"use strict";/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ie=["require","exports","vs/editor/common/core/range","vs/base/common/errors","vs/editor/common/core/offsetRange","vs/editor/common/core/position","vs/base/common/arrays","vs/base/common/strings","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/diffAlgorithm","vs/base/common/arraysFind","vs/base/common/lifecycle","vs/base/common/event","vs/editor/common/core/lineRange","vs/base/common/assert","vs/base/common/platform","vs/base/common/objects","vs/base/common/uri","vs/editor/common/diff/defaultLinesDiffComputer/utils","vs/editor/common/diff/rangeMapping","vs/base/common/functional","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/map","vs/base/common/stopwatch","vs/base/common/cancellation","vs/base/common/diff/diff","vs/base/common/types","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/myersDiffAlgorithm","vs/editor/common/diff/defaultLinesDiffComputer/linesSliceCharSequence","vs/editor/common/diff/linesDiffComputer","vs/editor/common/diff/legacyLinesDiffComputer","vs/base/common/collections","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/keyCodes","vs/base/common/lazy","vs/base/common/process","vs/base/common/path","vs/base/common/cache","vs/base/common/hash","vs/base/common/codicons","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/diff/defaultLinesDiffComputer/heuristicSequenceOptimizations","vs/editor/common/diff/defaultLinesDiffComputer/lineSequence","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/dynamicProgrammingDiffing","vs/editor/common/diff/defaultLinesDiffComputer/computeMovedLines","vs/editor/common/diff/defaultLinesDiffComputer/defaultLinesDiffComputer","vs/editor/common/diff/linesDiffComputers","vs/editor/common/languages/defaultDocumentColorsComputer","vs/editor/common/languages/linkComputer","vs/editor/common/languages/supports/inplaceReplaceSupport","vs/editor/common/model","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/services/unicodeTextModelHighlighter","vs/editor/common/standalone/standaloneEnums","vs/editor/common/tokenizationRegistry","vs/nls!vs/editor/common/languages","vs/editor/common/languages","vs/editor/common/services/editorBaseApi","vs/css","vs/base/common/worker/simpleWorker","vs/nls","vs/nls!vs/editor/common/services/editorSimpleWorker","vs/editor/common/services/editorSimpleWorker"],se=function(O){for(var t=[],k=0,_=O.length;k<_;k++)t[k]=ie[O[k]];return t};const We=this,Ce=typeof global=="object"?global:{};var he;(function(O){O.global=We;class t{get isWindows(){return this._detect(),this._isWindows}get isNode(){return this._detect(),this._isNode}get isElectronRenderer(){return this._detect(),this._isElectronRenderer}get isWebWorker(){return this._detect(),this._isWebWorker}get isElectronNodeIntegrationWebWorker(){return this._detect(),this._isElectronNodeIntegrationWebWorker}constructor(){this._detected=!1,this._isWindows=!1,this._isNode=!1,this._isElectronRenderer=!1,this._isWebWorker=!1,this._isElectronNodeIntegrationWebWorker=!1}_detect(){this._detected||(this._detected=!0,this._isWindows=t._isWindows(),this._isNode=typeof module<"u"&&!!module.exports,this._isElectronRenderer=typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="renderer",this._isWebWorker=typeof O.global.importScripts=="function",this._isElectronNodeIntegrationWebWorker=this._isWebWorker&&typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="worker")}static _isWindows(){return typeof navigator<"u"&&navigator.userAgent&&navigator.userAgent.indexOf("Windows")>=0?!0:typeof process<"u"?process.platform==="win32":!1}}O.Environment=t})(he||(he={}));var he;(function(O){class t{constructor(c,L,d){this.type=c,this.detail=L,this.timestamp=d}}O.LoaderEvent=t;class k{constructor(c){this._events=[new t(1,"",c)]}record(c,L){this._events.push(new t(c,L,O.Utilities.getHighPerformanceTimestamp()))}getEvents(){return this._events}}O.LoaderEventRecorder=k;class _{record(c,L){}getEvents(){return[]}}_.INSTANCE=new _,O.NullLoaderEventRecorder=_})(he||(he={}));var he;(function(O){class t{static fileUriToFilePath(_,r){if(r=decodeURI(r).replace(/%23/g,"#"),_){if(/^file:\/\/\//.test(r))return r.substr(8);if(/^file:\/\//.test(r))return r.substr(5)}else if(/^file:\/\//.test(r))return r.substr(7);return r}static startsWith(_,r){return _.length>=r.length&&_.substr(0,r.length)===r}static endsWith(_,r){return _.length>=r.length&&_.substr(_.length-r.length)===r}static containsQueryString(_){return/^[^\#]*\?/gi.test(_)}static isAbsolutePath(_){return/^((http:\/\/)|(https:\/\/)|(file:\/\/)|(\/))/.test(_)}static forEachProperty(_,r){if(_){let c;for(c in _)_.hasOwnProperty(c)&&r(c,_[c])}}static isEmpty(_){let r=!0;return t.forEachProperty(_,()=>{r=!1}),r}static recursiveClone(_){if(!_||typeof _!="object"||_ instanceof RegExp||!Array.isArray(_)&&Object.getPrototypeOf(_)!==Object.prototype)return _;let r=Array.isArray(_)?[]:{};return t.forEachProperty(_,(c,L)=>{L&&typeof L=="object"?r[c]=t.recursiveClone(L):r[c]=L}),r}static generateAnonymousModule(){return"===anonymous"+t.NEXT_ANONYMOUS_ID+++"==="}static isAnonymousModule(_){return t.startsWith(_,"===anonymous")}static getHighPerformanceTimestamp(){return this.PERFORMANCE_NOW_PROBED||(this.PERFORMANCE_NOW_PROBED=!0,this.HAS_PERFORMANCE_NOW=O.global.performance&&typeof O.global.performance.now=="function"),this.HAS_PERFORMANCE_NOW?O.global.performance.now():Date.now()}}t.NEXT_ANONYMOUS_ID=1,t.PERFORMANCE_NOW_PROBED=!1,t.HAS_PERFORMANCE_NOW=!1,O.Utilities=t})(he||(he={}));var he;(function(O){function t(r){if(r instanceof Error)return r;const c=new Error(r.message||String(r)||"Unknown Error");return r.stack&&(c.stack=r.stack),c}O.ensureError=t;class k{static validateConfigurationOptions(c){function L(d){if(d.phase==="loading"){console.error('Loading "'+d.moduleId+'" failed'),console.error(d),console.error("Here are the modules that depend on it:"),console.error(d.neededBy);return}if(d.phase==="factory"){console.error('The factory function of "'+d.moduleId+'" has thrown an exception'),console.error(d),console.error("Here are the modules that depend on it:"),console.error(d.neededBy);return}}if(c=c||{},typeof c.baseUrl!="string"&&(c.baseUrl=""),typeof c.isBuild!="boolean"&&(c.isBuild=!1),typeof c.paths!="object"&&(c.paths={}),typeof c.config!="object"&&(c.config={}),typeof c.catchError>"u"&&(c.catchError=!1),typeof c.recordStats>"u"&&(c.recordStats=!1),typeof c.urlArgs!="string"&&(c.urlArgs=""),typeof c.onError!="function"&&(c.onError=L),Array.isArray(c.ignoreDuplicateModules)||(c.ignoreDuplicateModules=[]),c.baseUrl.length>0&&(O.Utilities.endsWith(c.baseUrl,"/")||(c.baseUrl+="/")),typeof c.cspNonce!="string"&&(c.cspNonce=""),typeof c.preferScriptTags>"u"&&(c.preferScriptTags=!1),c.nodeCachedData&&typeof c.nodeCachedData=="object"&&(typeof c.nodeCachedData.seed!="string"&&(c.nodeCachedData.seed="seed"),(typeof c.nodeCachedData.writeDelay!="number"||c.nodeCachedData.writeDelay<0)&&(c.nodeCachedData.writeDelay=1e3*7),!c.nodeCachedData.path||typeof c.nodeCachedData.path!="string")){const d=t(new Error("INVALID cached data configuration, 'path' MUST be set"));d.phase="configuration",c.onError(d),c.nodeCachedData=void 0}return c}static mergeConfigurationOptions(c=null,L=null){let d=O.Utilities.recursiveClone(L||{});return O.Utilities.forEachProperty(c,(l,s)=>{l==="ignoreDuplicateModules"&&typeof d.ignoreDuplicateModules<"u"?d.ignoreDuplicateModules=d.ignoreDuplicateModules.concat(s):l==="paths"&&typeof d.paths<"u"?O.Utilities.forEachProperty(s,(g,A)=>d.paths[g]=A):l==="config"&&typeof d.config<"u"?O.Utilities.forEachProperty(s,(g,A)=>d.config[g]=A):d[l]=O.Utilities.recursiveClone(s)}),k.validateConfigurationOptions(d)}}O.ConfigurationOptionsUtil=k;class _{constructor(c,L){if(this._env=c,this.options=k.mergeConfigurationOptions(L),this._createIgnoreDuplicateModulesMap(),this._createSortedPathsRules(),this.options.baseUrl===""&&this.options.nodeRequire&&this.options.nodeRequire.main&&this.options.nodeRequire.main.filename&&this._env.isNode){let d=this.options.nodeRequire.main.filename,l=Math.max(d.lastIndexOf("/"),d.lastIndexOf("\\"));this.options.baseUrl=d.substring(0,l+1)}}_createIgnoreDuplicateModulesMap(){this.ignoreDuplicateModulesMap={};for(let c=0;c<this.options.ignoreDuplicateModules.length;c++)this.ignoreDuplicateModulesMap[this.options.ignoreDuplicateModules[c]]=!0}_createSortedPathsRules(){this.sortedPathsRules=[],O.Utilities.forEachProperty(this.options.paths,(c,L)=>{Array.isArray(L)?this.sortedPathsRules.push({from:c,to:L}):this.sortedPathsRules.push({from:c,to:[L]})}),this.sortedPathsRules.sort((c,L)=>L.from.length-c.from.length)}cloneAndMerge(c){return new _(this._env,k.mergeConfigurationOptions(c,this.options))}getOptionsLiteral(){return this.options}_applyPaths(c){let L;for(let d=0,l=this.sortedPathsRules.length;d<l;d++)if(L=this.sortedPathsRules[d],O.Utilities.startsWith(c,L.from)){let s=[];for(let g=0,A=L.to.length;g<A;g++)s.push(L.to[g]+c.substr(L.from.length));return s}return[c]}_addUrlArgsToUrl(c){return O.Utilities.containsQueryString(c)?c+"&"+this.options.urlArgs:c+"?"+this.options.urlArgs}_addUrlArgsIfNecessaryToUrl(c){return this.options.urlArgs?this._addUrlArgsToUrl(c):c}_addUrlArgsIfNecessaryToUrls(c){if(this.options.urlArgs)for(let L=0,d=c.length;L<d;L++)c[L]=this._addUrlArgsToUrl(c[L]);return c}moduleIdToPaths(c){if(this._env.isNode&&this.options.amdModulesPattern instanceof RegExp&&!this.options.amdModulesPattern.test(c))return this.isBuild()?["empty:"]:["node|"+c];let L=c,d;if(!O.Utilities.endsWith(L,".js")&&!O.Utilities.isAbsolutePath(L)){d=this._applyPaths(L);for(let l=0,s=d.length;l<s;l++)this.isBuild()&&d[l]==="empty:"||(O.Utilities.isAbsolutePath(d[l])||(d[l]=this.options.baseUrl+d[l]),!O.Utilities.endsWith(d[l],".js")&&!O.Utilities.containsQueryString(d[l])&&(d[l]=d[l]+".js"))}else!O.Utilities.endsWith(L,".js")&&!O.Utilities.containsQueryString(L)&&(L=L+".js"),d=[L];return this._addUrlArgsIfNecessaryToUrls(d)}requireToUrl(c){let L=c;return O.Utilities.isAbsolutePath(L)||(L=this._applyPaths(L)[0],O.Utilities.isAbsolutePath(L)||(L=this.options.baseUrl+L)),this._addUrlArgsIfNecessaryToUrl(L)}isBuild(){return this.options.isBuild}shouldInvokeFactory(c){return!!(!this.options.isBuild||O.Utilities.isAnonymousModule(c)||this.options.buildForceInvokeFactory&&this.options.buildForceInvokeFactory[c])}isDuplicateMessageIgnoredFor(c){return this.ignoreDuplicateModulesMap.hasOwnProperty(c)}getConfigForModule(c){if(this.options.config)return this.options.config[c]}shouldCatchError(){return this.options.catchError}shouldRecordStats(){return this.options.recordStats}onError(c){this.options.onError(c)}}O.Configuration=_})(he||(he={}));var he;(function(O){class t{constructor(s){this._env=s,this._scriptLoader=null,this._callbackMap={}}load(s,g,A,m){if(!this._scriptLoader)if(this._env.isWebWorker)this._scriptLoader=new r;else if(this._env.isElectronRenderer){const{preferScriptTags:e}=s.getConfig().getOptionsLiteral();e?this._scriptLoader=new k:this._scriptLoader=new c(this._env)}else this._env.isNode?this._scriptLoader=new c(this._env):this._scriptLoader=new k;let b={callback:A,errorback:m};if(this._callbackMap.hasOwnProperty(g)){this._callbackMap[g].push(b);return}this._callbackMap[g]=[b],this._scriptLoader.load(s,g,()=>this.triggerCallback(g),e=>this.triggerErrorback(g,e))}triggerCallback(s){let g=this._callbackMap[s];delete this._callbackMap[s];for(let A=0;A<g.length;A++)g[A].callback()}triggerErrorback(s,g){let A=this._callbackMap[s];delete this._callbackMap[s];for(let m=0;m<A.length;m++)A[m].errorback(g)}}class k{attachListeners(s,g,A){let m=()=>{s.removeEventListener("load",b),s.removeEventListener("error",e)},b=w=>{m(),g()},e=w=>{m(),A(w)};s.addEventListener("load",b),s.addEventListener("error",e)}load(s,g,A,m){if(/^node\|/.test(g)){let b=s.getConfig().getOptionsLiteral(),e=L(s.getRecorder(),b.nodeRequire||O.global.nodeRequire),w=g.split("|"),R=null;try{R=e(w[1])}catch(E){m(E);return}s.enqueueDefineAnonymousModule([],()=>R),A()}else{let b=document.createElement("script");b.setAttribute("async","async"),b.setAttribute("type","text/javascript"),this.attachListeners(b,A,m);const{trustedTypesPolicy:e}=s.getConfig().getOptionsLiteral();e&&(g=e.createScriptURL(g)),b.setAttribute("src",g);const{cspNonce:w}=s.getConfig().getOptionsLiteral();w&&b.setAttribute("nonce",w),document.getElementsByTagName("head")[0].appendChild(b)}}}function _(l){const{trustedTypesPolicy:s}=l.getConfig().getOptionsLiteral();try{return(s?self.eval(s.createScript("","true")):new Function("true")).call(self),!0}catch{return!1}}class r{constructor(){this._cachedCanUseEval=null}_canUseEval(s){return this._cachedCanUseEval===null&&(this._cachedCanUseEval=_(s)),this._cachedCanUseEval}load(s,g,A,m){if(/^node\|/.test(g)){const b=s.getConfig().getOptionsLiteral(),e=L(s.getRecorder(),b.nodeRequire||O.global.nodeRequire),w=g.split("|");let R=null;try{R=e(w[1])}catch(E){m(E);return}s.enqueueDefineAnonymousModule([],function(){return R}),A()}else{const{trustedTypesPolicy:b}=s.getConfig().getOptionsLiteral();if(!(/^((http:)|(https:)|(file:))/.test(g)&&g.substring(0,self.origin.length)!==self.origin)&&this._canUseEval(s)){fetch(g).then(w=>{if(w.status!==200)throw new Error(w.statusText);return w.text()}).then(w=>{w=`${w}
//# sourceURL=${g}`,(b?self.eval(b.createScript("",w)):new Function(w)).call(self),A()}).then(void 0,m);return}try{b&&(g=b.createScriptURL(g)),importScripts(g),A()}catch(w){m(w)}}}}class c{constructor(s){this._env=s,this._didInitialize=!1,this._didPatchNodeRequire=!1}_init(s){this._didInitialize||(this._didInitialize=!0,this._fs=s("fs"),this._vm=s("vm"),this._path=s("path"),this._crypto=s("crypto"))}_initNodeRequire(s,g){const{nodeCachedData:A}=g.getConfig().getOptionsLiteral();if(!A||this._didPatchNodeRequire)return;this._didPatchNodeRequire=!0;const m=this,b=s("module");function e(w){const R=w.constructor;let E=function(o){try{return w.require(o)}finally{}};return E.resolve=function(o,f){return R._resolveFilename(o,w,!1,f)},E.resolve.paths=function(o){return R._resolveLookupPaths(o,w)},E.main=process.mainModule,E.extensions=R._extensions,E.cache=R._cache,E}b.prototype._compile=function(w,R){const E=b.wrap(w.replace(/^#!.*/,"")),h=g.getRecorder(),o=m._getCachedDataPath(A,R),f={filename:R};let u;try{const M=m._fs.readFileSync(o);u=M.slice(0,16),f.cachedData=M.slice(16),h.record(60,o)}catch{h.record(61,o)}const i=new m._vm.Script(E,f),a=i.runInThisContext(f),N=m._path.dirname(R),$=e(this),v=[this.exports,$,this,R,N,process,Ce,Buffer],p=a.apply(this.exports,v);return m._handleCachedData(i,E,o,!f.cachedData,g),m._verifyCachedData(i,E,o,u,g),p}}load(s,g,A,m){const b=s.getConfig().getOptionsLiteral(),e=L(s.getRecorder(),b.nodeRequire||O.global.nodeRequire),w=b.nodeInstrumenter||function(E){return E};this._init(e),this._initNodeRequire(e,s);let R=s.getRecorder();if(/^node\|/.test(g)){let E=g.split("|"),h=null;try{h=e(E[1])}catch(o){m(o);return}s.enqueueDefineAnonymousModule([],()=>h),A()}else{g=O.Utilities.fileUriToFilePath(this._env.isWindows,g);const E=this._path.normalize(g),h=this._getElectronRendererScriptPathOrUri(E),o=!!b.nodeCachedData,f=o?this._getCachedDataPath(b.nodeCachedData,g):void 0;this._readSourceAndCachedData(E,f,R,(u,i,a,N)=>{if(u){m(u);return}let $;i.charCodeAt(0)===c._BOM?$=c._PREFIX+i.substring(1)+c._SUFFIX:$=c._PREFIX+i+c._SUFFIX,$=w($,E);const v={filename:h,cachedData:a},p=this._createAndEvalScript(s,$,v,A,m);this._handleCachedData(p,$,f,o&&!a,s),this._verifyCachedData(p,$,f,N,s)})}}_createAndEvalScript(s,g,A,m,b){const e=s.getRecorder();e.record(31,A.filename);const w=new this._vm.Script(g,A),R=w.runInThisContext(A),E=s.getGlobalAMDDefineFunc();let h=!1;const o=function(){return h=!0,E.apply(null,arguments)};return o.amd=E.amd,R.call(O.global,s.getGlobalAMDRequireFunc(),o,A.filename,this._path.dirname(A.filename)),e.record(32,A.filename),h?m():b(new Error(`Didn't receive define call in ${A.filename}!`)),w}_getElectronRendererScriptPathOrUri(s){if(!this._env.isElectronRenderer)return s;let g=s.match(/^([a-z])\:(.*)/i);return g?`file:///${(g[1].toUpperCase()+":"+g[2]).replace(/\\/g,"/")}`:`file://${s}`}_getCachedDataPath(s,g){const A=this._crypto.createHash("md5").update(g,"utf8").update(s.seed,"utf8").update(process.arch,"").digest("hex"),m=this._path.basename(g).replace(/\.js$/,"");return this._path.join(s.path,`${m}-${A}.code`)}_handleCachedData(s,g,A,m,b){s.cachedDataRejected?this._fs.unlink(A,e=>{b.getRecorder().record(62,A),this._createAndWriteCachedData(s,g,A,b),e&&b.getConfig().onError(e)}):m&&this._createAndWriteCachedData(s,g,A,b)}_createAndWriteCachedData(s,g,A,m){let b=Math.ceil(m.getConfig().getOptionsLiteral().nodeCachedData.writeDelay*(1+Math.random())),e=-1,w=0,R;const E=()=>{setTimeout(()=>{R||(R=this._crypto.createHash("md5").update(g,"utf8").digest());const h=s.createCachedData();if(!(h.length===0||h.length===e||w>=5)){if(h.length<e){E();return}e=h.length,this._fs.writeFile(A,Buffer.concat([R,h]),o=>{o&&m.getConfig().onError(o),m.getRecorder().record(63,A),E()})}},b*Math.pow(4,w++))};E()}_readSourceAndCachedData(s,g,A,m){if(!g)this._fs.readFile(s,{encoding:"utf8"},m);else{let b,e,w,R=2;const E=h=>{h?m(h):--R===0&&m(void 0,b,e,w)};this._fs.readFile(s,{encoding:"utf8"},(h,o)=>{b=o,E(h)}),this._fs.readFile(g,(h,o)=>{!h&&o&&o.length>0?(w=o.slice(0,16),e=o.slice(16),A.record(60,g)):A.record(61,g),E()})}}_verifyCachedData(s,g,A,m,b){m&&(s.cachedDataRejected||setTimeout(()=>{const e=this._crypto.createHash("md5").update(g,"utf8").digest();m.equals(e)||(b.getConfig().onError(new Error(`FAILED TO VERIFY CACHED DATA, deleting stale '${A}' now, but a RESTART IS REQUIRED`)),this._fs.unlink(A,w=>{w&&b.getConfig().onError(w)}))},Math.ceil(5e3*(1+Math.random()))))}}c._BOM=65279,c._PREFIX="(function (require, define, __filename, __dirname) { ",c._SUFFIX=`
});`;function L(l,s){if(s.__$__isRecorded)return s;const g=function(m){l.record(33,m);try{return s(m)}finally{l.record(34,m)}};return g.__$__isRecorded=!0,g}O.ensureRecordedNodeRequire=L;function d(l){return new t(l)}O.createScriptLoader=d})(he||(he={}));var he;(function(O){class t{constructor(l){let s=l.lastIndexOf("/");s!==-1?this.fromModulePath=l.substr(0,s+1):this.fromModulePath=""}static _normalizeModuleId(l){let s=l,g;for(g=/\/\.\//;g.test(s);)s=s.replace(g,"/");for(s=s.replace(/^\.\//g,""),g=/\/(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//;g.test(s);)s=s.replace(g,"/");return s=s.replace(/^(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//,""),s}resolveModule(l){let s=l;return O.Utilities.isAbsolutePath(s)||(O.Utilities.startsWith(s,"./")||O.Utilities.startsWith(s,"../"))&&(s=t._normalizeModuleId(this.fromModulePath+s)),s}}t.ROOT=new t(""),O.ModuleIdResolver=t;class k{constructor(l,s,g,A,m,b){this.id=l,this.strId=s,this.dependencies=g,this._callback=A,this._errorback=m,this.moduleIdResolver=b,this.exports={},this.error=null,this.exportsPassedIn=!1,this.unresolvedDependenciesCount=this.dependencies.length,this._isComplete=!1}static _safeInvokeFunction(l,s){try{return{returnedValue:l.apply(O.global,s),producedError:null}}catch(g){return{returnedValue:null,producedError:g}}}static _invokeFactory(l,s,g,A){return l.shouldInvokeFactory(s)?l.shouldCatchError()?this._safeInvokeFunction(g,A):{returnedValue:g.apply(O.global,A),producedError:null}:{returnedValue:null,producedError:null}}complete(l,s,g,A){this._isComplete=!0;let m=null;if(this._callback)if(typeof this._callback=="function"){l.record(21,this.strId);let b=k._invokeFactory(s,this.strId,this._callback,g);m=b.producedError,l.record(22,this.strId),!m&&typeof b.returnedValue<"u"&&(!this.exportsPassedIn||O.Utilities.isEmpty(this.exports))&&(this.exports=b.returnedValue)}else this.exports=this._callback;if(m){let b=O.ensureError(m);b.phase="factory",b.moduleId=this.strId,b.neededBy=A(this.id),this.error=b,s.onError(b)}this.dependencies=null,this._callback=null,this._errorback=null,this.moduleIdResolver=null}onDependencyError(l){return this._isComplete=!0,this.error=l,this._errorback?(this._errorback(l),!0):!1}isComplete(){return this._isComplete}}O.Module=k;class _{constructor(){this._nextId=0,this._strModuleIdToIntModuleId=new Map,this._intModuleIdToStrModuleId=[],this.getModuleId("exports"),this.getModuleId("module"),this.getModuleId("require")}getMaxModuleId(){return this._nextId}getModuleId(l){let s=this._strModuleIdToIntModuleId.get(l);return typeof s>"u"&&(s=this._nextId++,this._strModuleIdToIntModuleId.set(l,s),this._intModuleIdToStrModuleId[s]=l),s}getStrModuleId(l){return this._intModuleIdToStrModuleId[l]}}class r{constructor(l){this.id=l}}r.EXPORTS=new r(0),r.MODULE=new r(1),r.REQUIRE=new r(2),O.RegularDependency=r;class c{constructor(l,s,g){this.id=l,this.pluginId=s,this.pluginParam=g}}O.PluginDependency=c;class L{constructor(l,s,g,A,m=0){this._env=l,this._scriptLoader=s,this._loaderAvailableTimestamp=m,this._defineFunc=g,this._requireFunc=A,this._moduleIdProvider=new _,this._config=new O.Configuration(this._env),this._hasDependencyCycle=!1,this._modules2=[],this._knownModules2=[],this._inverseDependencies2=[],this._inversePluginDependencies2=new Map,this._currentAnonymousDefineCall=null,this._recorder=null,this._buildInfoPath=[],this._buildInfoDefineStack=[],this._buildInfoDependencies=[],this._requireFunc.moduleManager=this}reset(){return new L(this._env,this._scriptLoader,this._defineFunc,this._requireFunc,this._loaderAvailableTimestamp)}getGlobalAMDDefineFunc(){return this._defineFunc}getGlobalAMDRequireFunc(){return this._requireFunc}static _findRelevantLocationInStack(l,s){let g=b=>b.replace(/\\/g,"/"),A=g(l),m=s.split(/\n/);for(let b=0;b<m.length;b++){let e=m[b].match(/(.*):(\d+):(\d+)\)?$/);if(e){let w=e[1],R=e[2],E=e[3],h=Math.max(w.lastIndexOf(" ")+1,w.lastIndexOf("(")+1);if(w=w.substr(h),w=g(w),w===A){let o={line:parseInt(R,10),col:parseInt(E,10)};return o.line===1&&(o.col-=53),o}}}throw new Error("Could not correlate define call site for needle "+l)}getBuildInfo(){if(!this._config.isBuild())return null;let l=[],s=0;for(let g=0,A=this._modules2.length;g<A;g++){let m=this._modules2[g];if(!m)continue;let b=this._buildInfoPath[m.id]||null,e=this._buildInfoDefineStack[m.id]||null,w=this._buildInfoDependencies[m.id];l[s++]={id:m.strId,path:b,defineLocation:b&&e?L._findRelevantLocationInStack(b,e):null,dependencies:w,shim:null,exports:m.exports}}return l}getRecorder(){return this._recorder||(this._config.shouldRecordStats()?this._recorder=new O.LoaderEventRecorder(this._loaderAvailableTimestamp):this._recorder=O.NullLoaderEventRecorder.INSTANCE),this._recorder}getLoaderEvents(){return this.getRecorder().getEvents()}enqueueDefineAnonymousModule(l,s){if(this._currentAnonymousDefineCall!==null)throw new Error("Can only have one anonymous define call per script file");let g=null;this._config.isBuild()&&(g=new Error("StackLocation").stack||null),this._currentAnonymousDefineCall={stack:g,dependencies:l,callback:s}}defineModule(l,s,g,A,m,b=new t(l)){let e=this._moduleIdProvider.getModuleId(l);if(this._modules2[e]){this._config.isDuplicateMessageIgnoredFor(l)||console.warn("Duplicate definition of module '"+l+"'");return}let w=new k(e,l,this._normalizeDependencies(s,b),g,A,b);this._modules2[e]=w,this._config.isBuild()&&(this._buildInfoDefineStack[e]=m,this._buildInfoDependencies[e]=(w.dependencies||[]).map(R=>this._moduleIdProvider.getStrModuleId(R.id))),this._resolve(w)}_normalizeDependency(l,s){if(l==="exports")return r.EXPORTS;if(l==="module")return r.MODULE;if(l==="require")return r.REQUIRE;let g=l.indexOf("!");if(g>=0){let A=s.resolveModule(l.substr(0,g)),m=s.resolveModule(l.substr(g+1)),b=this._moduleIdProvider.getModuleId(A+"!"+m),e=this._moduleIdProvider.getModuleId(A);return new c(b,e,m)}return new r(this._moduleIdProvider.getModuleId(s.resolveModule(l)))}_normalizeDependencies(l,s){let g=[],A=0;for(let m=0,b=l.length;m<b;m++)g[A++]=this._normalizeDependency(l[m],s);return g}_relativeRequire(l,s,g,A){if(typeof s=="string")return this.synchronousRequire(s,l);this.defineModule(O.Utilities.generateAnonymousModule(),s,g,A,null,l)}synchronousRequire(l,s=new t(l)){let g=this._normalizeDependency(l,s),A=this._modules2[g.id];if(!A)throw new Error("Check dependency list! Synchronous require cannot resolve module '"+l+"'. This is the first mention of this module!");if(!A.isComplete())throw new Error("Check dependency list! Synchronous require cannot resolve module '"+l+"'. This module has not been resolved completely yet.");if(A.error)throw A.error;return A.exports}configure(l,s){let g=this._config.shouldRecordStats();s?this._config=new O.Configuration(this._env,l):this._config=this._config.cloneAndMerge(l),this._config.shouldRecordStats()&&!g&&(this._recorder=null)}getConfig(){return this._config}_onLoad(l){if(this._currentAnonymousDefineCall!==null){let s=this._currentAnonymousDefineCall;this._currentAnonymousDefineCall=null,this.defineModule(this._moduleIdProvider.getStrModuleId(l),s.dependencies,s.callback,null,s.stack)}}_createLoadError(l,s){let g=this._moduleIdProvider.getStrModuleId(l),A=(this._inverseDependencies2[l]||[]).map(b=>this._moduleIdProvider.getStrModuleId(b));const m=O.ensureError(s);return m.phase="loading",m.moduleId=g,m.neededBy=A,m}_onLoadError(l,s){const g=this._createLoadError(l,s);this._modules2[l]||(this._modules2[l]=new k(l,this._moduleIdProvider.getStrModuleId(l),[],()=>{},null,null));let A=[];for(let e=0,w=this._moduleIdProvider.getMaxModuleId();e<w;e++)A[e]=!1;let m=!1,b=[];for(b.push(l),A[l]=!0;b.length>0;){let e=b.shift(),w=this._modules2[e];w&&(m=w.onDependencyError(g)||m);let R=this._inverseDependencies2[e];if(R)for(let E=0,h=R.length;E<h;E++){let o=R[E];A[o]||(b.push(o),A[o]=!0)}}m||this._config.onError(g)}_hasDependencyPath(l,s){let g=this._modules2[l];if(!g)return!1;let A=[];for(let b=0,e=this._moduleIdProvider.getMaxModuleId();b<e;b++)A[b]=!1;let m=[];for(m.push(g),A[l]=!0;m.length>0;){let e=m.shift().dependencies;if(e)for(let w=0,R=e.length;w<R;w++){let E=e[w];if(E.id===s)return!0;let h=this._modules2[E.id];h&&!A[E.id]&&(A[E.id]=!0,m.push(h))}}return!1}_findCyclePath(l,s,g){if(l===s||g===50)return[l];let A=this._modules2[l];if(!A)return null;let m=A.dependencies;if(m)for(let b=0,e=m.length;b<e;b++){let w=this._findCyclePath(m[b].id,s,g+1);if(w!==null)return w.push(l),w}return null}_createRequire(l){let s=(g,A,m)=>this._relativeRequire(l,g,A,m);return s.toUrl=g=>this._config.requireToUrl(l.resolveModule(g)),s.getStats=()=>this.getLoaderEvents(),s.hasDependencyCycle=()=>this._hasDependencyCycle,s.config=(g,A=!1)=>{this.configure(g,A)},s.__$__nodeRequire=O.global.nodeRequire,s}_loadModule(l){if(this._modules2[l]||this._knownModules2[l])return;this._knownModules2[l]=!0;let s=this._moduleIdProvider.getStrModuleId(l),g=this._config.moduleIdToPaths(s),A=/^@[^\/]+\/[^\/]+$/;this._env.isNode&&(s.indexOf("/")===-1||A.test(s))&&g.push("node|"+s);let m=-1,b=e=>{if(m++,m>=g.length)this._onLoadError(l,e);else{let w=g[m],R=this.getRecorder();if(this._config.isBuild()&&w==="empty:"){this._buildInfoPath[l]=w,this.defineModule(this._moduleIdProvider.getStrModuleId(l),[],null,null,null),this._onLoad(l);return}R.record(10,w),this._scriptLoader.load(this,w,()=>{this._config.isBuild()&&(this._buildInfoPath[l]=w),R.record(11,w),this._onLoad(l)},E=>{R.record(12,w),b(E)})}};b(null)}_loadPluginDependency(l,s){if(this._modules2[s.id]||this._knownModules2[s.id])return;this._knownModules2[s.id]=!0;let g=A=>{this.defineModule(this._moduleIdProvider.getStrModuleId(s.id),[],A,null,null)};g.error=A=>{this._config.onError(this._createLoadError(s.id,A))},l.load(s.pluginParam,this._createRequire(t.ROOT),g,this._config.getOptionsLiteral())}_resolve(l){let s=l.dependencies;if(s)for(let g=0,A=s.length;g<A;g++){let m=s[g];if(m===r.EXPORTS){l.exportsPassedIn=!0,l.unresolvedDependenciesCount--;continue}if(m===r.MODULE){l.unresolvedDependenciesCount--;continue}if(m===r.REQUIRE){l.unresolvedDependenciesCount--;continue}let b=this._modules2[m.id];if(b&&b.isComplete()){if(b.error){l.onDependencyError(b.error);return}l.unresolvedDependenciesCount--;continue}if(this._hasDependencyPath(m.id,l.id)){this._hasDependencyCycle=!0,console.warn("There is a dependency cycle between '"+this._moduleIdProvider.getStrModuleId(m.id)+"' and '"+this._moduleIdProvider.getStrModuleId(l.id)+"'. The cyclic path follows:");let e=this._findCyclePath(m.id,l.id,0)||[];e.reverse(),e.push(m.id),console.warn(e.map(w=>this._moduleIdProvider.getStrModuleId(w)).join(` => 
`)),l.unresolvedDependenciesCount--;continue}if(this._inverseDependencies2[m.id]=this._inverseDependencies2[m.id]||[],this._inverseDependencies2[m.id].push(l.id),m instanceof c){let e=this._modules2[m.pluginId];if(e&&e.isComplete()){this._loadPluginDependency(e.exports,m);continue}let w=this._inversePluginDependencies2.get(m.pluginId);w||(w=[],this._inversePluginDependencies2.set(m.pluginId,w)),w.push(m),this._loadModule(m.pluginId);continue}this._loadModule(m.id)}l.unresolvedDependenciesCount===0&&this._onModuleComplete(l)}_onModuleComplete(l){let s=this.getRecorder();if(l.isComplete())return;let g=l.dependencies,A=[];if(g)for(let w=0,R=g.length;w<R;w++){let E=g[w];if(E===r.EXPORTS){A[w]=l.exports;continue}if(E===r.MODULE){A[w]={id:l.strId,config:()=>this._config.getConfigForModule(l.strId)};continue}if(E===r.REQUIRE){A[w]=this._createRequire(l.moduleIdResolver);continue}let h=this._modules2[E.id];if(h){A[w]=h.exports;continue}A[w]=null}const m=w=>(this._inverseDependencies2[w]||[]).map(R=>this._moduleIdProvider.getStrModuleId(R));l.complete(s,this._config,A,m);let b=this._inverseDependencies2[l.id];if(this._inverseDependencies2[l.id]=null,b)for(let w=0,R=b.length;w<R;w++){let E=b[w],h=this._modules2[E];h.unresolvedDependenciesCount--,h.unresolvedDependenciesCount===0&&this._onModuleComplete(h)}let e=this._inversePluginDependencies2.get(l.id);if(e){this._inversePluginDependencies2.delete(l.id);for(let w=0,R=e.length;w<R;w++)this._loadPluginDependency(l.exports,e[w])}}}O.ModuleManager=L})(he||(he={}));var te,he;(function(O){const t=new O.Environment;let k=null;const _=function(d,l,s){typeof d!="string"&&(s=l,l=d,d=null),(typeof l!="object"||!Array.isArray(l))&&(s=l,l=null),l||(l=["require","exports","module"]),d?k.defineModule(d,l,s,null,null):k.enqueueDefineAnonymousModule(l,s)};_.amd={jQuery:!0};const r=function(d,l=!1){k.configure(d,l)},c=function(){if(arguments.length===1){if(arguments[0]instanceof Object&&!Array.isArray(arguments[0])){r(arguments[0]);return}if(typeof arguments[0]=="string")return k.synchronousRequire(arguments[0])}if((arguments.length===2||arguments.length===3)&&Array.isArray(arguments[0])){k.defineModule(O.Utilities.generateAnonymousModule(),arguments[0],arguments[1],arguments[2],null);return}throw new Error("Unrecognized require call")};c.config=r,c.getConfig=function(){return k.getConfig().getOptionsLiteral()},c.reset=function(){k=k.reset()},c.getBuildInfo=function(){return k.getBuildInfo()},c.getStats=function(){return k.getLoaderEvents()},c.define=_;function L(){if(typeof O.global.require<"u"||typeof require<"u"){const d=O.global.require||require;if(typeof d=="function"&&typeof d.resolve=="function"){const l=O.ensureRecordedNodeRequire(k.getRecorder(),d);O.global.nodeRequire=l,c.nodeRequire=l,c.__$__nodeRequire=l}}t.isNode&&!t.isElectronRenderer&&!t.isElectronNodeIntegrationWebWorker?module.exports=c:(t.isElectronRenderer||(O.global.define=_),O.global.require=c)}O.init=L,(typeof O.global.define!="function"||!O.global.define.amd)&&(k=new O.ModuleManager(t,O.createScriptLoader(t),_,c,O.Utilities.getHighPerformanceTimestamp()),typeof O.global.require<"u"&&typeof O.global.require!="function"&&c.config(O.global.require),te=function(){return _.apply(null,arguments)},te.amd=_.amd,typeof doNotInitLoader>"u"&&L())})(he||(he={})),te(ie[66],se([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.load=void 0;function k(d,l,s,g){if(g=g||{},(g["vs/css"]||{}).disabled){s({});return}const m=l.toUrl(d+".css");_(d,m,()=>{s({})},b=>{typeof s.error=="function"&&s.error("Could not find "+m+".")})}t.load=k;function _(d,l,s,g){if(r(d,l)){s();return}c(d,l,s,g)}function r(d,l){const s=document.getElementsByTagName("link");for(let g=0,A=s.length;g<A;g++){const m=s[g].getAttribute("data-name"),b=s[g].getAttribute("href");if(m===d||b===l)return!0}return!1}function c(d,l,s,g){const A=document.createElement("link");A.setAttribute("rel","stylesheet"),A.setAttribute("type","text/css"),A.setAttribute("data-name",d),L(d,A,s,g),A.setAttribute("href",l),(document.head||document.getElementsByTagName("head")[0]).appendChild(A)}function L(d,l,s,g){const A=()=>{l.removeEventListener("load",m),l.removeEventListener("error",b)},m=e=>{A(),s()},b=e=>{A(),g(e)};l.addEventListener("load",m),l.addEventListener("error",b)}}),te("vs/nls",["require","exports"],function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.load=t.create=t.setPseudoTranslation=t.getConfiguredDefaultLocale=t.localize=void 0;let k=typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;const _="i-default";function r(e,w){let R;return w.length===0?R=e:R=e.replace(/\{(\d+)\}/g,(E,h)=>{const o=h[0],f=w[o];let u=E;return typeof f=="string"?u=f:(typeof f=="number"||typeof f=="boolean"||f===void 0||f===null)&&(u=String(f)),u}),k&&(R="\uFF3B"+R.replace(/[aouei]/g,"$&$&")+"\uFF3D"),R}function c(e,w){let R=e[w];return R||(R=e["*"],R)?R:null}function L(e){return e.charAt(e.length-1)==="/"?e:e+"/"}async function d(e,w,R){const E=L(e)+L(w)+"vscode/"+L(R),h=await fetch(E);if(h.ok)return await h.json();throw new Error(`${h.status} - ${h.statusText}`)}function l(e){return function(w,R){const E=Array.prototype.slice.call(arguments,2);return r(e[w],E)}}function s(e,w,...R){return r(w,R)}t.localize=s;function g(e){}t.getConfiguredDefaultLocale=g;function A(e){k=e}t.setPseudoTranslation=A;function m(e,w){return{localize:l(w[e]),getConfiguredDefaultLocale:w.getConfiguredDefaultLocale??(R=>{})}}t.create=m;function b(e,w,R,E){const h=E["vs/nls"]??{};if(!e||e.length===0)return R({localize:s,getConfiguredDefaultLocale:()=>h.availableLanguages?.["*"]});const o=h.availableLanguages?c(h.availableLanguages,e):null,f=o===null||o===_;let u=".nls";f||(u=u+"."+o);const i=a=>{Array.isArray(a)?a.localize=l(a):a.localize=l(a[e]),a.getConfiguredDefaultLocale=()=>h.availableLanguages?.["*"],R(a)};typeof h.loadBundle=="function"?h.loadBundle(e,o,(a,N)=>{a?w([e+".nls"],i):i(N)}):h.translationServiceUrl&&!f?(async()=>{try{const a=await d(h.translationServiceUrl,o,e);return i(a)}catch(a){if(!o.includes("-"))return console.error(a),w([e+".nls"],i);try{const N=o.split("-")[0],$=await d(h.translationServiceUrl,N,e);return h.availableLanguages??(h.availableLanguages={}),h.availableLanguages["*"]=N,i($)}catch(N){return console.error(N),w([e+".nls"],i)}}})():w([e+u],i,a=>{if(u===".nls"){console.error("Failed trying to load default language strings",a);return}console.error(`Failed to load message bundle for language ${o}. Falling back to the default language:`,a),w([e+".nls"],i)})}t.load=b}),function(){const O=globalThis.MonacoEnvironment,t=O&&O.baseUrl?O.baseUrl:"../../../";function k(g,A){if(O?.createTrustedTypesPolicy)try{return O.createTrustedTypesPolicy(g,A)}catch(m){console.warn(m);return}try{return self.trustedTypes?.createPolicy(g,A)}catch(m){console.warn(m);return}}const _=k("amdLoader",{createScriptURL:g=>g,createScript:(g,...A)=>{const m=A.slice(0,-1).join(","),b=A.pop().toString();return`(function anonymous(${m}) { ${b}
})`}});function r(){try{return(_?globalThis.eval(_.createScript("","true")):new Function("true")).call(globalThis),!0}catch{return!1}}function c(){return new Promise((g,A)=>{if(typeof globalThis.define=="function"&&globalThis.define.amd)return g();const m=t+"vs/loader.js";if(!(/^((http:)|(https:)|(file:))/.test(m)&&m.substring(0,globalThis.origin.length)!==globalThis.origin)&&r()){fetch(m).then(e=>{if(e.status!==200)throw new Error(e.statusText);return e.text()}).then(e=>{e=`${e}
//# sourceURL=${m}`,(_?globalThis.eval(_.createScript("",e)):new Function(e)).call(globalThis),g()}).then(void 0,A);return}_?importScripts(_.createScriptURL(m)):importScripts(m),g()})}function L(){require.config({baseUrl:t,catchError:!0,trustedTypesPolicy:_,amdModulesPattern:/^vs\//})}function d(g){c().then(()=>{L(),require([g],function(A){setTimeout(function(){const m=A.create((b,e)=>{globalThis.postMessage(b,e)},null);for(globalThis.onmessage=b=>m.onmessage(b.data,b.ports);s.length>0;){const b=s.shift();m.onmessage(b.data,b.ports)}},0)})})}typeof globalThis.define=="function"&&globalThis.define.amd&&L();let l=!0;const s=[];globalThis.onmessage=g=>{if(!l){s.push(g);return}l=!1,d(g.data)}}(),te(ie[9],se([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$pb=t.$ob=t.$nb=t.$mb=t.$lb=t.$kb=t.$jb=t.$ib=t.$hb=t.$gb=t.$fb=t.$eb=t.$db=void 0;function k(w,R,E){const h=_(w,R);if(h!==-1)return w[h]}t.$db=k;function _(w,R,E=w.length-1){for(let h=E;h>=0;h--){const o=w[h];if(R(o))return h}return-1}t.$eb=_;function r(w,R){const E=c(w,R);return E===-1?void 0:w[E]}t.$fb=r;function c(w,R,E=0,h=w.length){let o=E,f=h;for(;o<f;){const u=Math.floor((o+f)/2);R(w[u])?o=u+1:f=u}return o-1}t.$gb=c;function L(w,R){const E=d(w,R);return E===w.length?void 0:w[E]}t.$hb=L;function d(w,R,E=0,h=w.length){let o=E,f=h;for(;o<f;){const u=Math.floor((o+f)/2);R(w[u])?f=u:o=u+1}return o}t.$ib=d;function l(w,R,E=0,h=w.length){const o=d(w,R,E,h);return o===w.length?-1:o}t.$jb=l;class s{constructor(R){this.e=R,this.c=0}findLastMonotonous(R){if(s.assertInvariants){if(this.d){for(const h of this.e)if(this.d(h)&&!R(h))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=R}const E=c(this.e,R,this.c);return this.c=E+1,E===-1?void 0:this.e[E]}}t.$kb=s,s.assertInvariants=!1;function g(w,R){if(w.length===0)return;let E=w[0];for(let h=1;h<w.length;h++){const o=w[h];R(o,E)>0&&(E=o)}return E}t.$lb=g;function A(w,R){if(w.length===0)return;let E=w[0];for(let h=1;h<w.length;h++){const o=w[h];R(o,E)>=0&&(E=o)}return E}t.$mb=A;function m(w,R){return g(w,(E,h)=>-R(E,h))}t.$nb=m;function b(w,R){if(w.length===0)return-1;let E=0;for(let h=1;h<w.length;h++){const o=w[h];R(o,w[E])>0&&(E=h)}return E}t.$ob=b;function e(w,R){for(const E of w){const h=R(E);if(h!==void 0)return h}}t.$pb=e}),te(ie[34],se([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$G=t.$F=t.$E=t.$D=void 0;function k(L,d){const l=Object.create(null);for(const s of L){const g=d(s);let A=l[g];A||(A=l[g]=[]),A.push(s)}return l}t.$D=k;function _(L,d){const l=[],s=[];for(const g of L)d.has(g)||l.push(g);for(const g of d)L.has(g)||s.push(g);return{removed:l,added:s}}t.$E=_;function r(L,d){const l=[],s=[];for(const[g,A]of L)d.has(g)||l.push(A);for(const[g,A]of d)L.has(g)||s.push(A);return{removed:l,added:s}}t.$F=r;function c(L,d){const l=new Set;for(const s of d)L.has(s)&&l.add(s);return l}t.$G=c}),te(ie[35],se([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Qs=t.$Ps=t.$Os=t.$Ns=void 0;function k(d,l){const s=Math.pow(10,l);return Math.round(d*s)/s}class _{constructor(l,s,g,A=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,l))|0,this.g=Math.min(255,Math.max(0,s))|0,this.b=Math.min(255,Math.max(0,g))|0,this.a=k(Math.max(Math.min(1,A),0),3)}static equals(l,s){return l.r===s.r&&l.g===s.g&&l.b===s.b&&l.a===s.a}}t.$Ns=_;class r{constructor(l,s,g,A){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,l),0)|0,this.s=k(Math.max(Math.min(1,s),0),3),this.l=k(Math.max(Math.min(1,g),0),3),this.a=k(Math.max(Math.min(1,A),0),3)}static equals(l,s){return l.h===s.h&&l.s===s.s&&l.l===s.l&&l.a===s.a}static fromRGBA(l){const s=l.r/255,g=l.g/255,A=l.b/255,m=l.a,b=Math.max(s,g,A),e=Math.min(s,g,A);let w=0,R=0;const E=(e+b)/2,h=b-e;if(h>0){switch(R=Math.min(E<=.5?h/(2*E):h/(2-2*E),1),b){case s:w=(g-A)/h+(g<A?6:0);break;case g:w=(A-s)/h+2;break;case A:w=(s-g)/h+4;break}w*=60,w=Math.round(w)}return new r(w,R,E,m)}static i(l,s,g){return g<0&&(g+=1),g>1&&(g-=1),g<1/6?l+(s-l)*6*g:g<1/2?s:g<2/3?l+(s-l)*(2/3-g)*6:l}static toRGBA(l){const s=l.h/360,{s:g,l:A,a:m}=l;let b,e,w;if(g===0)b=e=w=A;else{const R=A<.5?A*(1+g):A+g-A*g,E=2*A-R;b=r.i(E,R,s+1/3),e=r.i(E,R,s),w=r.i(E,R,s-1/3)}return new _(Math.round(b*255),Math.round(e*255),Math.round(w*255),m)}}t.$Os=r;class c{constructor(l,s,g,A){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,l),0)|0,this.s=k(Math.max(Math.min(1,s),0),3),this.v=k(Math.max(Math.min(1,g),0),3),this.a=k(Math.max(Math.min(1,A),0),3)}static equals(l,s){return l.h===s.h&&l.s===s.s&&l.v===s.v&&l.a===s.a}static fromRGBA(l){const s=l.r/255,g=l.g/255,A=l.b/255,m=Math.max(s,g,A),b=Math.min(s,g,A),e=m-b,w=m===0?0:e/m;let R;return e===0?R=0:m===s?R=((g-A)/e%6+6)%6:m===g?R=(A-s)/e+2:R=(s-g)/e+4,new c(Math.round(R*60),w,m,l.a)}static toRGBA(l){const{h:s,s:g,v:A,a:m}=l,b=A*g,e=b*(1-Math.abs(s/60%2-1)),w=A-b;let[R,E,h]=[0,0,0];return s<60?(R=b,E=e):s<120?(R=e,E=b):s<180?(E=b,h=e):s<240?(E=e,h=b):s<300?(R=e,h=b):s<=360&&(R=b,h=e),R=Math.round((R+w)*255),E=Math.round((E+w)*255),h=Math.round((h+w)*255),new _(R,E,h,m)}}t.$Ps=c;class L{static fromHex(l){return L.Format.CSS.parseHex(l)||L.red}static equals(l,s){return!l&&!s?!0:!l||!s?!1:l.equals(s)}get hsla(){return this.i?this.i:r.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:c.fromRGBA(this.rgba)}constructor(l){if(l)if(l instanceof _)this.rgba=l;else if(l instanceof r)this.i=l,this.rgba=r.toRGBA(l);else if(l instanceof c)this.j=l,this.rgba=c.toRGBA(l);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(l){return!!l&&_.equals(this.rgba,l.rgba)&&r.equals(this.hsla,l.hsla)&&c.equals(this.hsva,l.hsva)}getRelativeLuminance(){const l=L.k(this.rgba.r),s=L.k(this.rgba.g),g=L.k(this.rgba.b),A=.2126*l+.7152*s+.0722*g;return k(A,4)}static k(l){const s=l/255;return s<=.03928?s/12.92:Math.pow((s+.055)/1.055,2.4)}getContrastRatio(l){const s=this.getRelativeLuminance(),g=l.getRelativeLuminance();return s>g?(s+.05)/(g+.05):(g+.05)/(s+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(l){const s=this.getRelativeLuminance(),g=l.getRelativeLuminance();return s>g}isDarkerThan(l){const s=this.getRelativeLuminance(),g=l.getRelativeLuminance();return s<g}lighten(l){return new L(new r(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*l,this.hsla.a))}darken(l){return new L(new r(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*l,this.hsla.a))}transparent(l){const{r:s,g,b:A,a:m}=this.rgba;return new L(new _(s,g,A,m*l))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new L(new _(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(l){const s=l.rgba,g=this.rgba.a,A=s.a,m=g+A*(1-g);if(m<1e-6)return L.transparent;const b=this.rgba.r*g/m+s.r*A*(1-g)/m,e=this.rgba.g*g/m+s.g*A*(1-g)/m,w=this.rgba.b*g/m+s.b*A*(1-g)/m;return new L(new _(b,e,w,m))}makeOpaque(l){if(this.isOpaque()||l.rgba.a!==1)return this;const{r:s,g,b:A,a:m}=this.rgba;return new L(new _(l.rgba.r-m*(l.rgba.r-s),l.rgba.g-m*(l.rgba.g-g),l.rgba.b-m*(l.rgba.b-A),1))}flatten(...l){const s=l.reduceRight((g,A)=>L.o(A,g));return L.o(this,s)}static o(l,s){const g=1-l.rgba.a;return new L(new _(g*s.rgba.r+l.rgba.a*l.rgba.r,g*s.rgba.g+l.rgba.a*l.rgba.g,g*s.rgba.b+l.rgba.a*l.rgba.b))}toString(){return this.u||(this.u=L.Format.CSS.format(this)),this.u}static getLighterColor(l,s,g){if(l.isLighterThan(s))return l;g=g||.5;const A=l.getRelativeLuminance(),m=s.getRelativeLuminance();return g=g*(m-A)/m,l.lighten(g)}static getDarkerColor(l,s,g){if(l.isDarkerThan(s))return l;g=g||.5;const A=l.getRelativeLuminance(),m=s.getRelativeLuminance();return g=g*(A-m)/A,l.darken(g)}}t.$Qs=L,L.white=new L(new _(255,255,255,1)),L.black=new L(new _(0,0,0,1)),L.red=new L(new _(255,0,0,1)),L.blue=new L(new _(0,0,255,1)),L.green=new L(new _(0,255,0,1)),L.cyan=new L(new _(0,255,255,1)),L.lightgrey=new L(new _(211,211,211,1)),L.transparent=new L(new _(0,0,0,0)),function(d){let l;(function(s){let g;(function(A){function m(i){return i.rgba.a===1?`rgb(${i.rgba.r}, ${i.rgba.g}, ${i.rgba.b})`:d.Format.CSS.formatRGBA(i)}A.formatRGB=m;function b(i){return`rgba(${i.rgba.r}, ${i.rgba.g}, ${i.rgba.b}, ${+i.rgba.a.toFixed(2)})`}A.formatRGBA=b;function e(i){return i.hsla.a===1?`hsl(${i.hsla.h}, ${(i.hsla.s*100).toFixed(2)}%, ${(i.hsla.l*100).toFixed(2)}%)`:d.Format.CSS.formatHSLA(i)}A.formatHSL=e;function w(i){return`hsla(${i.hsla.h}, ${(i.hsla.s*100).toFixed(2)}%, ${(i.hsla.l*100).toFixed(2)}%, ${i.hsla.a.toFixed(2)})`}A.formatHSLA=w;function R(i){const a=i.toString(16);return a.length!==2?"0"+a:a}function E(i){return`#${R(i.rgba.r)}${R(i.rgba.g)}${R(i.rgba.b)}`}A.formatHex=E;function h(i,a=!1){return a&&i.rgba.a===1?d.Format.CSS.formatHex(i):`#${R(i.rgba.r)}${R(i.rgba.g)}${R(i.rgba.b)}${R(Math.round(i.rgba.a*255))}`}A.formatHexA=h;function o(i){return i.isOpaque()?d.Format.CSS.formatHex(i):d.Format.CSS.formatRGBA(i)}A.format=o;function f(i){const a=i.length;if(a===0||i.charCodeAt(0)!==35)return null;if(a===7){const N=16*u(i.charCodeAt(1))+u(i.charCodeAt(2)),$=16*u(i.charCodeAt(3))+u(i.charCodeAt(4)),v=16*u(i.charCodeAt(5))+u(i.charCodeAt(6));return new d(new _(N,$,v,1))}if(a===9){const N=16*u(i.charCodeAt(1))+u(i.charCodeAt(2)),$=16*u(i.charCodeAt(3))+u(i.charCodeAt(4)),v=16*u(i.charCodeAt(5))+u(i.charCodeAt(6)),p=16*u(i.charCodeAt(7))+u(i.charCodeAt(8));return new d(new _(N,$,v,p/255))}if(a===4){const N=u(i.charCodeAt(1)),$=u(i.charCodeAt(2)),v=u(i.charCodeAt(3));return new d(new _(16*N+N,16*$+$,16*v+v))}if(a===5){const N=u(i.charCodeAt(1)),$=u(i.charCodeAt(2)),v=u(i.charCodeAt(3)),p=u(i.charCodeAt(4));return new d(new _(16*N+N,16*$+$,16*v+v,(16*p+p)/255))}return null}A.parseHex=f;function u(i){switch(i){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(g=s.CSS||(s.CSS={}))})(l=d.Format||(d.Format={}))}(L||(t.$Qs=L={}))}),te(ie[36],se([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ps=void 0;class k{constructor(r,c,L,d){this.originalStart=r,this.originalLength=c,this.modifiedStart=L,this.modifiedLength=d}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.$ps=k}),te(ie[3],se([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ab=t.$_=t.$$=t.$0=t.$9=t.$8=t.$7=t.$6=t.$5=t.$4=t.$3=t.$2=t.$1=t.$Z=t.$Y=t.$X=t.setUnexpectedErrorHandler=t.$V=t.$U=void 0;class k{constructor(){this.b=[],this.a=function(i){setTimeout(()=>{throw i.stack?o.isErrorNoTelemetry(i)?new o(i.message+`

`+i.stack):new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.b.push(i),()=>{this.d(i)}}c(i){this.b.forEach(a=>{a(i)})}d(i){this.b.splice(this.b.indexOf(i),1)}setUnexpectedErrorHandler(i){this.a=i}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(i){this.a(i),this.c(i)}onUnexpectedExternalError(i){this.a(i)}}t.$U=k,t.$V=new k;function _(u){t.$V.setUnexpectedErrorHandler(u)}t.setUnexpectedErrorHandler=_;function r(u){if(!u||typeof u!="object")return!1;const i=u;return i.code==="EPIPE"&&i.syscall?.toUpperCase()==="WRITE"}t.$X=r;function c(u){s(u)||t.$V.onUnexpectedError(u)}t.$Y=c;function L(u){s(u)||t.$V.onUnexpectedExternalError(u)}t.$Z=L;function d(u){if(u instanceof Error){const{name:i,message:a}=u,N=u.stacktrace||u.stack;return{$isError:!0,name:i,message:a,stack:N,noTelemetry:o.isErrorNoTelemetry(u)}}return u}t.$1=d;const l="Canceled";function s(u){return u instanceof g?!0:u instanceof Error&&u.name===l&&u.message===l}t.$2=s;class g extends Error{constructor(){super(l),this.name=this.message}}t.$3=g;function A(){const u=new Error(l);return u.name=u.message,u}t.$4=A;function m(u){return u?new Error(`Illegal argument: ${u}`):new Error("Illegal argument")}t.$5=m;function b(u){return u?new Error(`Illegal state: ${u}`):new Error("Illegal state")}t.$6=b;class e extends TypeError{constructor(i){super(i?`${i} is read-only and cannot be changed`:"Cannot change read-only property")}}t.$7=e;function w(u){return u?u.message?u.message:u.stack?u.stack.split(`
`)[0]:String(u):"Error"}t.$8=w;class R extends Error{constructor(i){super("NotImplemented"),i&&(this.message=i)}}t.$9=R;class E extends Error{constructor(i){super("NotSupported"),i&&(this.message=i)}}t.$0=E;class h extends Error{constructor(){super(...arguments),this.isExpected=!0}}t.$$=h;class o extends Error{constructor(i){super(i),this.name="CodeExpectedError"}static fromError(i){if(i instanceof o)return i;const a=new o;return a.message=i.message,a.stack=i.stack,a}static isErrorNoTelemetry(i){return i.name==="CodeExpectedError"}}t.$_=o;class f extends Error{constructor(i){super(i||"An unexpected bug occurred."),Object.setPrototypeOf(this,f.prototype)}}t.$ab=f}),te(ie[6],se([0,1,3,9]),function(O,t,k,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$$b=t.$0b=t.$9b=t.$8b=t.$7b=t.$6b=t.$5b=t.CompareResult=t.$4b=t.$3b=t.$2b=t.$1b=t.$Zb=t.$Yb=t.$Xb=t.$Wb=t.$Vb=t.$Ub=t.$Tb=t.$Sb=t.$Rb=t.$Qb=t.$Pb=t.$Ob=t.$Nb=t.$Mb=t.$Lb=t.$Kb=t.$Jb=t.$Ib=t.$Hb=t.$Gb=t.$Fb=t.$Eb=t.top=t.$Cb=t.$Bb=t.$Ab=t.$zb=t.$yb=t.$xb=t.$wb=t.$vb=t.$ub=t.$tb=t.$sb=t.$rb=t.$qb=void 0;function r(U,W=0){return U[U.length-(1+W)]}t.$qb=r;function c(U){if(U.length===0)throw new Error("Invalid tail call");return[U.slice(0,U.length-1),U[U.length-1]]}t.$rb=c;function L(U,W,V=(Q,ee)=>Q===ee){if(U===W)return!0;if(!U||!W||U.length!==W.length)return!1;for(let Q=0,ee=U.length;Q<ee;Q++)if(!V(U[Q],W[Q]))return!1;return!0}t.$sb=L;function d(U,W){const V=U.length-1;W<V&&(U[W]=U[V]),U.pop()}t.$tb=d;function l(U,W,V){return s(U.length,Q=>V(U[Q],W))}t.$ub=l;function s(U,W){let V=0,Q=U-1;for(;V<=Q;){const ee=(V+Q)/2|0,G=W(ee);if(G<0)V=ee+1;else if(G>0)Q=ee-1;else return ee}return-(V+1)}t.$vb=s;function g(U,W,V){if(U=U|0,U>=W.length)throw new TypeError("invalid index");const Q=W[Math.floor(W.length*Math.random())],ee=[],G=[],Y=[];for(const J of W){const K=V(J,Q);K<0?ee.push(J):K>0?G.push(J):Y.push(J)}return U<ee.length?g(U,ee,V):U<ee.length+Y.length?Y[0]:g(U-(ee.length+Y.length),G,V)}t.$wb=g;function A(U,W){const V=[];let Q;for(const ee of U.slice(0).sort(W))!Q||W(Q[0],ee)!==0?(Q=[ee],V.push(Q)):Q.push(ee);return V}t.$xb=A;function*m(U,W){let V,Q;for(const ee of U)Q!==void 0&&W(Q,ee)?V.push(ee):(V&&(yield V),V=[ee]),Q=ee;V&&(yield V)}t.$yb=m;function b(U,W){for(let V=0;V<=U.length;V++)W(V===0?void 0:U[V-1],V===U.length?void 0:U[V])}t.$zb=b;function e(U,W){for(let V=0;V<U.length;V++)W(V===0?void 0:U[V-1],U[V],V+1===U.length?void 0:U[V+1])}t.$Ab=e;function w(U,W,V){const Q=[];function ee(J,K,re){if(K===0&&re.length===0)return;const le=Q[Q.length-1];le&&le.start+le.deleteCount===J?(le.deleteCount+=K,le.toInsert.push(...re)):Q.push({start:J,deleteCount:K,toInsert:re})}let G=0,Y=0;for(;;){if(G===U.length){ee(G,0,W.slice(Y));break}if(Y===W.length){ee(G,U.length-G,[]);break}const J=U[G],K=W[Y],re=V(J,K);re===0?(G+=1,Y+=1):re<0?(ee(G,1,[]),G+=1):re>0&&(ee(G,0,[K]),Y+=1)}return Q}t.$Bb=w;function R(U,W,V){const Q=w(U,W,V),ee=[],G=[];for(const Y of Q)ee.push(...U.slice(Y.start,Y.start+Y.deleteCount)),G.push(...Y.toInsert);return{removed:ee,added:G}}t.$Cb=R;function E(U,W,V){if(V===0)return[];const Q=U.slice(0,V).sort(W);return o(U,W,Q,V,U.length),Q}t.top=E;function h(U,W,V,Q,ee){return V===0?Promise.resolve([]):new Promise((G,Y)=>{(async()=>{const J=U.length,K=U.slice(0,V).sort(W);for(let re=V,le=Math.min(V+Q,J);re<J;re=le,le=Math.min(le+Q,J)){if(re>V&&await new Promise(ce=>setTimeout(ce)),ee&&ee.isCancellationRequested)throw new k.$3;o(U,W,K,re,le)}return K})().then(G,Y)})}t.$Eb=h;function o(U,W,V,Q,ee){for(const G=V.length;Q<ee;Q++){const Y=U[Q];if(W(Y,V[G-1])<0){V.pop();const J=(0,_.$ib)(V,K=>W(Y,K)<0);V.splice(J,0,Y)}}}function f(U){return U.filter(W=>!!W)}t.$Fb=f;function u(U){let W=0;for(let V=0;V<U.length;V++)U[V]&&(U[W]=U[V],W+=1);U.length=W}t.$Gb=u;function i(U,W,V){U.splice(V,0,U.splice(W,1)[0])}t.$Hb=i;function a(U){return!Array.isArray(U)||U.length===0}t.$Ib=a;function N(U){return Array.isArray(U)&&U.length>0}t.$Jb=N;function $(U,W=V=>V){const V=new Set;return U.filter(Q=>{const ee=W(Q);return V.has(ee)?!1:(V.add(ee),!0)})}t.$Kb=$;function v(U){const W=new Set;return V=>{const Q=U(V);return W.has(Q)?!1:(W.add(Q),!0)}}t.$Lb=v;function p(U,W){return U.length>0?U[0]:W}t.$Mb=p;function M(U,W){return U.length>0?U[U.length-1]:W}t.$Nb=M;function P(U,W,V=(Q,ee)=>Q===ee){let Q=0;for(let ee=0,G=Math.min(U.length,W.length);ee<G&&V(U[ee],W[ee]);ee++)Q++;return Q}t.$Ob=P;function F(U){return[].concat(...U)}t.$Pb=F;function y(U,W){let V=typeof W=="number"?U:0;typeof W=="number"?V=U:(V=0,W=U);const Q=[];if(V<=W)for(let ee=V;ee<W;ee++)Q.push(ee);else for(let ee=V;ee>W;ee--)Q.push(ee);return Q}t.$Qb=y;function D(U,W,V){return U.reduce((Q,ee)=>(Q[W(ee)]=V?V(ee):ee,Q),Object.create(null))}t.$Rb=D;function q(U,W){return U.push(W),()=>I(U,W)}t.$Sb=q;function I(U,W){const V=U.indexOf(W);if(V>-1)return U.splice(V,1),W}t.$Tb=I;function x(U,W,V){const Q=U.slice(0,W),ee=U.slice(W);return Q.concat(V,ee)}t.$Ub=x;function T(U,W){let V;if(typeof W=="number"){let Q=W;V=()=>{const ee=Math.sin(Q++)*179426549;return ee-Math.floor(ee)}}else V=Math.random;for(let Q=U.length-1;Q>0;Q-=1){const ee=Math.floor(V()*(Q+1)),G=U[Q];U[Q]=U[ee],U[ee]=G}}t.$Vb=T;function j(U,W){const V=U.indexOf(W);V>-1&&(U.splice(V,1),U.unshift(W))}t.$Wb=j;function z(U,W){const V=U.indexOf(W);V>-1&&(U.splice(V,1),U.push(W))}t.$Xb=z;function C(U,W){for(const V of W)U.push(V)}t.$Yb=C;function X(U,W){return Array.isArray(U)?U.map(W):W(U)}t.$Zb=X;function n(U){return Array.isArray(U)?U:[U]}t.$1b=n;function ne(U){return U[Math.floor(Math.random()*U.length)]}t.$2b=ne;function oe(U,W,V){const Q=Ne(U,W),ee=U.length,G=V.length;U.length=ee+G;for(let Y=ee-1;Y>=Q;Y--)U[Y+G]=U[Y];for(let Y=0;Y<G;Y++)U[Y+Q]=V[Y]}t.$3b=oe;function me(U,W,V,Q){const ee=Ne(U,W);let G=U.splice(ee,V);return G===void 0&&(G=[]),oe(U,ee,Q),G}t.$4b=me;function Ne(U,W){return W<0?Math.max(W+U.length,0):Math.min(W,U.length)}var we;(function(U){function W(G){return G<0}U.isLessThan=W;function V(G){return G<=0}U.isLessThanOrEqual=V;function Q(G){return G>0}U.isGreaterThan=Q;function ee(G){return G===0}U.isNeitherLessOrGreaterThan=ee,U.greaterThan=1,U.lessThan=-1,U.neitherLessOrGreaterThan=0})(we||(t.CompareResult=we={}));function Ee(U,W){return(V,Q)=>W(U(V),U(Q))}t.$5b=Ee;function ve(...U){return(W,V)=>{for(const Q of U){const ee=Q(W,V);if(!we.isNeitherLessOrGreaterThan(ee))return ee}return we.neitherLessOrGreaterThan}}t.$6b=ve;const De=(U,W)=>U-W;t.$7b=De;const _e=(U,W)=>(0,t.$7b)(U?1:0,W?1:0);t.$8b=_e;function Te(U){return(W,V)=>-U(W,V)}t.$9b=Te;class Se{constructor(W){this.g=W,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(W){let V=this.c;for(;V<this.g.length&&W(this.g[V]);)V++;const Q=V===this.c?null:this.g.slice(this.c,V);return this.c=V,Q}takeFromEndWhile(W){let V=this.d;for(;V>=0&&W(this.g[V]);)V--;const Q=V===this.d?null:this.g.slice(V+1,this.d+1);return this.d=V,Q}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const W=this.g[this.c];return this.c++,W}removeLast(){const W=this.g[this.d];return this.d--,W}takeCount(W){const V=this.g.slice(this.c,this.c+W);return this.c+=W,V}}t.$0b=Se;class Ae{constructor(W){this.iterate=W}forEach(W){this.iterate(V=>(W(V),!0))}toArray(){const W=[];return this.iterate(V=>(W.push(V),!0)),W}filter(W){return new Ae(V=>this.iterate(Q=>W(Q)?V(Q):!0))}map(W){return new Ae(V=>this.iterate(Q=>V(W(Q))))}some(W){let V=!1;return this.iterate(Q=>(V=W(Q),!V)),V}findFirst(W){let V;return this.iterate(Q=>W(Q)?(V=Q,!1):!0),V}findLast(W){let V;return this.iterate(Q=>(W(Q)&&(V=Q),!0)),V}findLastMaxBy(W){let V,Q=!0;return this.iterate(ee=>((Q||we.isGreaterThan(W(ee,V)))&&(Q=!1,V=ee),!0)),V}}t.$$b=Ae,Ae.empty=new Ae(U=>{})}),te(ie[13],se([0,1,3]),function(O,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$5c=t.$4c=t.$3c=t.$2c=t.ok=void 0;function _(l,s){if(!l)throw new Error(s?`Assertion failed (${s})`:"Assertion Failed")}t.ok=_;function r(l,s="Unreachable"){throw new Error(s)}t.$2c=r;function c(l){if(!l)throw new k.$ab("Assertion Failed")}t.$3c=c;function L(l){if(!l()){debugger;l(),(0,k.$Y)(new k.$ab("Assertion Failed"))}}t.$4c=L;function d(l,s){let g=0;for(;g<l.length-1;){const A=l[g],m=l[g+1];if(!s(A,m))return!1;g++}return!0}t.$5c=d}),te(ie[19],se([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bb=void 0;function k(_){const r=this;let c=!1,L;return function(){return c||(c=!0,L=_.apply(r,arguments)),L}}t.$bb=k}),te(ie[20],se([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var k;(function(_){function r(u){return u&&typeof u=="object"&&typeof u[Symbol.iterator]=="function"}_.is=r;const c=Object.freeze([]);function L(){return c}_.empty=L;function*d(u){yield u}_.single=d;function l(u){return r(u)?u:d(u)}_.wrap=l;function s(u){return u||c}_.from=s;function*g(u){for(let i=u.length-1;i>=0;i--)yield u[i]}_.reverse=g;function A(u){return!u||u[Symbol.iterator]().next().done===!0}_.isEmpty=A;function m(u){return u[Symbol.iterator]().next().value}_.first=m;function b(u,i){for(const a of u)if(i(a))return!0;return!1}_.some=b;function e(u,i){for(const a of u)if(i(a))return a}_.find=e;function*w(u,i){for(const a of u)i(a)&&(yield a)}_.filter=w;function*R(u,i){let a=0;for(const N of u)yield i(N,a++)}_.map=R;function*E(...u){for(const i of u)for(const a of i)yield a}_.concat=E;function h(u,i,a){let N=a;for(const $ of u)N=i(N,$);return N}_.reduce=h;function*o(u,i,a=u.length){for(i<0&&(i+=u.length),a<0?a+=u.length:a>u.length&&(a=u.length);i<a;i++)yield u[i]}_.slice=o;function f(u,i=Number.POSITIVE_INFINITY){const a=[];if(i===0)return[a,u];const N=u[Symbol.iterator]();for(let $=0;$<i;$++){const v=N.next();if(v.done)return[a,_.empty()];a.push(v.value)}return[a,{[Symbol.iterator](){return N}}]}_.consume=f})(k||(t.Iterable=k={}))}),te(ie[37],se([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$xq=t.KeyMod=t.KeyCodeUtils=t.$wq=t.$vq=t.$uq=t.$tq=t.$sq=t.ScanCode=t.KeyCode=void 0;var k;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.F20=78]="F20",e[e.F21=79]="F21",e[e.F22=80]="F22",e[e.F23=81]="F23",e[e.F24=82]="F24",e[e.NumLock=83]="NumLock",e[e.ScrollLock=84]="ScrollLock",e[e.Semicolon=85]="Semicolon",e[e.Equal=86]="Equal",e[e.Comma=87]="Comma",e[e.Minus=88]="Minus",e[e.Period=89]="Period",e[e.Slash=90]="Slash",e[e.Backquote=91]="Backquote",e[e.BracketLeft=92]="BracketLeft",e[e.Backslash=93]="Backslash",e[e.BracketRight=94]="BracketRight",e[e.Quote=95]="Quote",e[e.OEM_8=96]="OEM_8",e[e.IntlBackslash=97]="IntlBackslash",e[e.Numpad0=98]="Numpad0",e[e.Numpad1=99]="Numpad1",e[e.Numpad2=100]="Numpad2",e[e.Numpad3=101]="Numpad3",e[e.Numpad4=102]="Numpad4",e[e.Numpad5=103]="Numpad5",e[e.Numpad6=104]="Numpad6",e[e.Numpad7=105]="Numpad7",e[e.Numpad8=106]="Numpad8",e[e.Numpad9=107]="Numpad9",e[e.NumpadMultiply=108]="NumpadMultiply",e[e.NumpadAdd=109]="NumpadAdd",e[e.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=111]="NumpadSubtract",e[e.NumpadDecimal=112]="NumpadDecimal",e[e.NumpadDivide=113]="NumpadDivide",e[e.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",e[e.ABNT_C1=115]="ABNT_C1",e[e.ABNT_C2=116]="ABNT_C2",e[e.AudioVolumeMute=117]="AudioVolumeMute",e[e.AudioVolumeUp=118]="AudioVolumeUp",e[e.AudioVolumeDown=119]="AudioVolumeDown",e[e.BrowserSearch=120]="BrowserSearch",e[e.BrowserHome=121]="BrowserHome",e[e.BrowserBack=122]="BrowserBack",e[e.BrowserForward=123]="BrowserForward",e[e.MediaTrackNext=124]="MediaTrackNext",e[e.MediaTrackPrevious=125]="MediaTrackPrevious",e[e.MediaStop=126]="MediaStop",e[e.MediaPlayPause=127]="MediaPlayPause",e[e.LaunchMediaPlayer=128]="LaunchMediaPlayer",e[e.LaunchMail=129]="LaunchMail",e[e.LaunchApp2=130]="LaunchApp2",e[e.Clear=131]="Clear",e[e.MAX_VALUE=132]="MAX_VALUE"})(k||(t.KeyCode=k={}));var _;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(_||(t.ScanCode=_={}));class r{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(w,R){this._keyCodeToStr[w]=R,this._strToKeyCode[R.toLowerCase()]=w}keyCodeToStr(w){return this._keyCodeToStr[w]}strToKeyCode(w){return this._strToKeyCode[w.toLowerCase()]||0}}const c=new r,L=new r,d=new r;t.$sq=new Array(230),t.$tq={};const l=[],s=Object.create(null),g=Object.create(null);t.$uq={lowerCaseToEnum:e=>g[e]||0,toEnum:e=>s[e]||0,toString:e=>l[e]||"None"},t.$vq=[],t.$wq=[];for(let e=0;e<=193;e++)t.$vq[e]=-1;for(let e=0;e<=132;e++)t.$wq[e]=-1;(function(){const e="",w=[[1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[1,1,"Hyper",0,e,0,e,e,e],[1,2,"Super",0,e,0,e,e,e],[1,3,"Fn",0,e,0,e,e,e],[1,4,"FnLock",0,e,0,e,e,e],[1,5,"Suspend",0,e,0,e,e,e],[1,6,"Resume",0,e,0,e,e,e],[1,7,"Turbo",0,e,0,e,e,e],[1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[1,9,"WakeUp",0,e,0,e,e,e],[0,10,"KeyA",31,"A",65,"VK_A",e,e],[0,11,"KeyB",32,"B",66,"VK_B",e,e],[0,12,"KeyC",33,"C",67,"VK_C",e,e],[0,13,"KeyD",34,"D",68,"VK_D",e,e],[0,14,"KeyE",35,"E",69,"VK_E",e,e],[0,15,"KeyF",36,"F",70,"VK_F",e,e],[0,16,"KeyG",37,"G",71,"VK_G",e,e],[0,17,"KeyH",38,"H",72,"VK_H",e,e],[0,18,"KeyI",39,"I",73,"VK_I",e,e],[0,19,"KeyJ",40,"J",74,"VK_J",e,e],[0,20,"KeyK",41,"K",75,"VK_K",e,e],[0,21,"KeyL",42,"L",76,"VK_L",e,e],[0,22,"KeyM",43,"M",77,"VK_M",e,e],[0,23,"KeyN",44,"N",78,"VK_N",e,e],[0,24,"KeyO",45,"O",79,"VK_O",e,e],[0,25,"KeyP",46,"P",80,"VK_P",e,e],[0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[0,27,"KeyR",48,"R",82,"VK_R",e,e],[0,28,"KeyS",49,"S",83,"VK_S",e,e],[0,29,"KeyT",50,"T",84,"VK_T",e,e],[0,30,"KeyU",51,"U",85,"VK_U",e,e],[0,31,"KeyV",52,"V",86,"VK_V",e,e],[0,32,"KeyW",53,"W",87,"VK_W",e,e],[0,33,"KeyX",54,"X",88,"VK_X",e,e],[0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[0,36,"Digit1",22,"1",49,"VK_1",e,e],[0,37,"Digit2",23,"2",50,"VK_2",e,e],[0,38,"Digit3",24,"3",51,"VK_3",e,e],[0,39,"Digit4",25,"4",52,"VK_4",e,e],[0,40,"Digit5",26,"5",53,"VK_5",e,e],[0,41,"Digit6",27,"6",54,"VK_6",e,e],[0,42,"Digit7",28,"7",55,"VK_7",e,e],[0,43,"Digit8",29,"8",56,"VK_8",e,e],[0,44,"Digit9",30,"9",57,"VK_9",e,e],[0,45,"Digit0",21,"0",48,"VK_0",e,e],[1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[0,51,"Minus",88,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[0,52,"Equal",86,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[0,53,"BracketLeft",92,"[",219,"VK_OEM_4","[","OEM_4"],[0,54,"BracketRight",94,"]",221,"VK_OEM_6","]","OEM_6"],[0,55,"Backslash",93,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,56,"IntlHash",0,e,0,e,e,e],[0,57,"Semicolon",85,";",186,"VK_OEM_1",";","OEM_1"],[0,58,"Quote",95,"'",222,"VK_OEM_7","'","OEM_7"],[0,59,"Backquote",91,"`",192,"VK_OEM_3","`","OEM_3"],[0,60,"Comma",87,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[0,61,"Period",89,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[0,62,"Slash",90,"/",191,"VK_OEM_2","/","OEM_2"],[1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[1,64,"F1",59,"F1",112,"VK_F1",e,e],[1,65,"F2",60,"F2",113,"VK_F2",e,e],[1,66,"F3",61,"F3",114,"VK_F3",e,e],[1,67,"F4",62,"F4",115,"VK_F4",e,e],[1,68,"F5",63,"F5",116,"VK_F5",e,e],[1,69,"F6",64,"F6",117,"VK_F6",e,e],[1,70,"F7",65,"F7",118,"VK_F7",e,e],[1,71,"F8",66,"F8",119,"VK_F8",e,e],[1,72,"F9",67,"F9",120,"VK_F9",e,e],[1,73,"F10",68,"F10",121,"VK_F10",e,e],[1,74,"F11",69,"F11",122,"VK_F11",e,e],[1,75,"F12",70,"F12",123,"VK_F12",e,e],[1,76,"PrintScreen",0,e,0,e,e,e],[1,77,"ScrollLock",84,"ScrollLock",145,"VK_SCROLL",e,e],[1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[1,80,"Home",14,"Home",36,"VK_HOME",e,e],[1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[1,83,"End",13,"End",35,"VK_END",e,e],[1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[1,89,"NumLock",83,"NumLock",144,"VK_NUMLOCK",e,e],[1,90,"NumpadDivide",113,"NumPad_Divide",111,"VK_DIVIDE",e,e],[1,91,"NumpadMultiply",108,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[1,92,"NumpadSubtract",111,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[1,93,"NumpadAdd",109,"NumPad_Add",107,"VK_ADD",e,e],[1,94,"NumpadEnter",3,e,0,e,e,e],[1,95,"Numpad1",99,"NumPad1",97,"VK_NUMPAD1",e,e],[1,96,"Numpad2",100,"NumPad2",98,"VK_NUMPAD2",e,e],[1,97,"Numpad3",101,"NumPad3",99,"VK_NUMPAD3",e,e],[1,98,"Numpad4",102,"NumPad4",100,"VK_NUMPAD4",e,e],[1,99,"Numpad5",103,"NumPad5",101,"VK_NUMPAD5",e,e],[1,100,"Numpad6",104,"NumPad6",102,"VK_NUMPAD6",e,e],[1,101,"Numpad7",105,"NumPad7",103,"VK_NUMPAD7",e,e],[1,102,"Numpad8",106,"NumPad8",104,"VK_NUMPAD8",e,e],[1,103,"Numpad9",107,"NumPad9",105,"VK_NUMPAD9",e,e],[1,104,"Numpad0",98,"NumPad0",96,"VK_NUMPAD0",e,e],[1,105,"NumpadDecimal",112,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[0,106,"IntlBackslash",97,"OEM_102",226,"VK_OEM_102",e,e],[1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[1,108,"Power",0,e,0,e,e,e],[1,109,"NumpadEqual",0,e,0,e,e,e],[1,110,"F13",71,"F13",124,"VK_F13",e,e],[1,111,"F14",72,"F14",125,"VK_F14",e,e],[1,112,"F15",73,"F15",126,"VK_F15",e,e],[1,113,"F16",74,"F16",127,"VK_F16",e,e],[1,114,"F17",75,"F17",128,"VK_F17",e,e],[1,115,"F18",76,"F18",129,"VK_F18",e,e],[1,116,"F19",77,"F19",130,"VK_F19",e,e],[1,117,"F20",78,"F20",131,"VK_F20",e,e],[1,118,"F21",79,"F21",132,"VK_F21",e,e],[1,119,"F22",80,"F22",133,"VK_F22",e,e],[1,120,"F23",81,"F23",134,"VK_F23",e,e],[1,121,"F24",82,"F24",135,"VK_F24",e,e],[1,122,"Open",0,e,0,e,e,e],[1,123,"Help",0,e,0,e,e,e],[1,124,"Select",0,e,0,e,e,e],[1,125,"Again",0,e,0,e,e,e],[1,126,"Undo",0,e,0,e,e,e],[1,127,"Cut",0,e,0,e,e,e],[1,128,"Copy",0,e,0,e,e,e],[1,129,"Paste",0,e,0,e,e,e],[1,130,"Find",0,e,0,e,e,e],[1,131,"AudioVolumeMute",117,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[1,132,"AudioVolumeUp",118,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[1,133,"AudioVolumeDown",119,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[1,134,"NumpadComma",110,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[0,135,"IntlRo",115,"ABNT_C1",193,"VK_ABNT_C1",e,e],[1,136,"KanaMode",0,e,0,e,e,e],[0,137,"IntlYen",0,e,0,e,e,e],[1,138,"Convert",0,e,0,e,e,e],[1,139,"NonConvert",0,e,0,e,e,e],[1,140,"Lang1",0,e,0,e,e,e],[1,141,"Lang2",0,e,0,e,e,e],[1,142,"Lang3",0,e,0,e,e,e],[1,143,"Lang4",0,e,0,e,e,e],[1,144,"Lang5",0,e,0,e,e,e],[1,145,"Abort",0,e,0,e,e,e],[1,146,"Props",0,e,0,e,e,e],[1,147,"NumpadParenLeft",0,e,0,e,e,e],[1,148,"NumpadParenRight",0,e,0,e,e,e],[1,149,"NumpadBackspace",0,e,0,e,e,e],[1,150,"NumpadMemoryStore",0,e,0,e,e,e],[1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[1,152,"NumpadMemoryClear",0,e,0,e,e,e],[1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[1,155,"NumpadClear",131,"Clear",12,"VK_CLEAR",e,e],[1,156,"NumpadClearEntry",0,e,0,e,e,e],[1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[1,0,e,6,"Alt",18,"VK_MENU",e,e],[1,0,e,57,"Meta",91,"VK_COMMAND",e,e],[1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[1,165,"BrightnessUp",0,e,0,e,e,e],[1,166,"BrightnessDown",0,e,0,e,e,e],[1,167,"MediaPlay",0,e,0,e,e,e],[1,168,"MediaRecord",0,e,0,e,e,e],[1,169,"MediaFastForward",0,e,0,e,e,e],[1,170,"MediaRewind",0,e,0,e,e,e],[1,171,"MediaTrackNext",124,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[1,172,"MediaTrackPrevious",125,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[1,173,"MediaStop",126,"MediaStop",178,"VK_MEDIA_STOP",e,e],[1,174,"Eject",0,e,0,e,e,e],[1,175,"MediaPlayPause",127,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[1,176,"MediaSelect",128,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[1,177,"LaunchMail",129,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[1,178,"LaunchApp2",130,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[1,180,"SelectTask",0,e,0,e,e,e],[1,181,"LaunchScreenSaver",0,e,0,e,e,e],[1,182,"BrowserSearch",120,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[1,183,"BrowserHome",121,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[1,184,"BrowserBack",122,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[1,185,"BrowserForward",123,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[1,189,"ZoomToggle",0,e,0,e,e,e],[1,190,"MailReply",0,e,0,e,e,e],[1,191,"MailForward",0,e,0,e,e,e],[1,192,"MailSend",0,e,0,e,e,e],[1,0,e,114,"KeyInComposition",229,e,e,e],[1,0,e,116,"ABNT_C2",194,"VK_ABNT_C2",e,e],[1,0,e,96,"OEM_8",223,"VK_OEM_8",e,e],[1,0,e,0,e,0,"VK_KANA",e,e],[1,0,e,0,e,0,"VK_HANGUL",e,e],[1,0,e,0,e,0,"VK_JUNJA",e,e],[1,0,e,0,e,0,"VK_FINAL",e,e],[1,0,e,0,e,0,"VK_HANJA",e,e],[1,0,e,0,e,0,"VK_KANJI",e,e],[1,0,e,0,e,0,"VK_CONVERT",e,e],[1,0,e,0,e,0,"VK_NONCONVERT",e,e],[1,0,e,0,e,0,"VK_ACCEPT",e,e],[1,0,e,0,e,0,"VK_MODECHANGE",e,e],[1,0,e,0,e,0,"VK_SELECT",e,e],[1,0,e,0,e,0,"VK_PRINT",e,e],[1,0,e,0,e,0,"VK_EXECUTE",e,e],[1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[1,0,e,0,e,0,"VK_HELP",e,e],[1,0,e,0,e,0,"VK_APPS",e,e],[1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[1,0,e,0,e,0,"VK_PACKET",e,e],[1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[1,0,e,0,e,0,"VK_ATTN",e,e],[1,0,e,0,e,0,"VK_CRSEL",e,e],[1,0,e,0,e,0,"VK_EXSEL",e,e],[1,0,e,0,e,0,"VK_EREOF",e,e],[1,0,e,0,e,0,"VK_PLAY",e,e],[1,0,e,0,e,0,"VK_ZOOM",e,e],[1,0,e,0,e,0,"VK_NONAME",e,e],[1,0,e,0,e,0,"VK_PA1",e,e],[1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],R=[],E=[];for(const h of w){const[o,f,u,i,a,N,$,v,p]=h;if(E[f]||(E[f]=!0,l[f]=u,s[u]=f,g[u.toLowerCase()]=f,o&&(t.$vq[f]=i,i!==0&&i!==3&&i!==5&&i!==4&&i!==6&&i!==57&&(t.$wq[i]=f))),!R[i]){if(R[i]=!0,!a)throw new Error(`String representation missing for key code ${i} around scan code ${u}`);c.define(i,a),L.define(i,v||a),d.define(i,p||v||a)}N&&(t.$sq[N]=i),$&&(t.$tq[$]=i)}t.$wq[3]=46})();var A;(function(e){function w(u){return c.keyCodeToStr(u)}e.toString=w;function R(u){return c.strToKeyCode(u)}e.fromString=R;function E(u){return L.keyCodeToStr(u)}e.toUserSettingsUS=E;function h(u){return d.keyCodeToStr(u)}e.toUserSettingsGeneral=h;function o(u){return L.strToKeyCode(u)||d.strToKeyCode(u)}e.fromUserSettings=o;function f(u){if(u>=98&&u<=113)return null;switch(u){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return c.keyCodeToStr(u)}e.toElectronAccelerator=f})(A||(t.KeyCodeUtils=A={}));var m;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(m||(t.KeyMod=m={}));function b(e,w){const R=(w&65535)<<16>>>0;return(e|R)>>>0}t.$xq=b}),te(ie[38],se([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$T=void 0;class k{constructor(r){this.d=r,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(r){this.c=r}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}t.$T=k}),te(ie[21],se([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Zc=void 0;class k{constructor(c){this.element=c,this.next=k.Undefined,this.prev=k.Undefined}}k.Undefined=new k(void 0);class _{constructor(){this.a=k.Undefined,this.b=k.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===k.Undefined}clear(){let c=this.a;for(;c!==k.Undefined;){const L=c.next;c.prev=k.Undefined,c.next=k.Undefined,c=L}this.a=k.Undefined,this.b=k.Undefined,this.c=0}unshift(c){return this.d(c,!1)}push(c){return this.d(c,!0)}d(c,L){const d=new k(c);if(this.a===k.Undefined)this.a=d,this.b=d;else if(L){const s=this.b;this.b=d,d.prev=s,s.next=d}else{const s=this.a;this.a=d,d.next=s,s.prev=d}this.c+=1;let l=!1;return()=>{l||(l=!0,this.e(d))}}shift(){if(this.a!==k.Undefined){const c=this.a.element;return this.e(this.a),c}}pop(){if(this.b!==k.Undefined){const c=this.b.element;return this.e(this.b),c}}e(c){if(c.prev!==k.Undefined&&c.next!==k.Undefined){const L=c.prev;L.next=c.next,c.next.prev=L}else c.prev===k.Undefined&&c.next===k.Undefined?(this.a=k.Undefined,this.b=k.Undefined):c.next===k.Undefined?(this.b=this.b.prev,this.b.next=k.Undefined):c.prev===k.Undefined&&(this.a=this.a.next,this.a.prev=k.Undefined);this.c-=1}*[Symbol.iterator](){let c=this.a;for(;c!==k.Undefined;)yield c.element,c=c.next}}t.$Zc=_}),te(ie[22],se([0,1]),function(O,t){"use strict";var k,_,r;Object.defineProperty(t,"__esModule",{value:!0}),t.$Ec=t.$Dc=t.$Cc=t.$Bc=t.$Ac=t.Touch=t.$zc=t.$yc=t.$xc=t.$wc=t.$vc=void 0;function c(h,o,f){let u=h.get(o);return u===void 0&&(u=f,h.set(o,u)),u}t.$vc=c;function L(h){const o=[];return h.forEach((f,u)=>{o.push(`${u} => ${f}`)}),`Map(${h.size}) {${o.join(", ")}}`}t.$wc=L;function d(h){const o=[];return h.forEach(f=>{o.push(f)}),`Set(${h.size}) {${o.join(", ")}}`}t.$xc=d;class l{constructor(o,f){this.uri=o,this.value=f}}function s(h){return Array.isArray(h)}class g{constructor(o,f){if(this[k]="ResourceMap",o instanceof g)this.b=new Map(o.b),this.c=f??g.a;else if(s(o)){this.b=new Map,this.c=f??g.a;for(const[u,i]of o)this.set(u,i)}else this.b=new Map,this.c=o??g.a}set(o,f){return this.b.set(this.c(o),new l(o,f)),this}get(o){return this.b.get(this.c(o))?.value}has(o){return this.b.has(this.c(o))}get size(){return this.b.size}clear(){this.b.clear()}delete(o){return this.b.delete(this.c(o))}forEach(o,f){typeof f<"u"&&(o=o.bind(f));for(const[u,i]of this.b)o(i.value,i.uri,this)}*values(){for(const o of this.b.values())yield o.value}*keys(){for(const o of this.b.values())yield o.uri}*entries(){for(const o of this.b.values())yield[o.uri,o.value]}*[(k=Symbol.toStringTag,Symbol.iterator)](){for(const[,o]of this.b)yield[o.uri,o.value]}}t.$yc=g,g.a=h=>h.toString();class A{constructor(o,f){this[_]="ResourceSet",!o||typeof o=="function"?this.a=new g(o):(this.a=new g(f),o.forEach(this.add,this))}get size(){return this.a.size}add(o){return this.a.set(o,o),this}clear(){this.a.clear()}delete(o){return this.a.delete(o)}forEach(o,f){this.a.forEach((u,i)=>o.call(f,i,i,this))}has(o){return this.a.has(o)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(_=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}t.$zc=A;var m;(function(h){h[h.None=0]="None",h[h.AsOld=1]="AsOld",h[h.AsNew=2]="AsNew"})(m||(t.Touch=m={}));class b{constructor(){this[r]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(o){return this.a.has(o)}get(o,f=0){const u=this.a.get(o);if(u)return f!==0&&this.j(u,f),u.value}set(o,f,u=0){let i=this.a.get(o);if(i)i.value=f,u!==0&&this.j(i,u);else{switch(i={key:o,value:f,next:void 0,previous:void 0},u){case 0:this.h(i);break;case 1:this.g(i);break;case 2:this.h(i);break;default:this.h(i);break}this.a.set(o,i),this.d++}return this}delete(o){return!!this.remove(o)}remove(o){const f=this.a.get(o);if(f)return this.a.delete(o),this.i(f),this.d--,f.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const o=this.b;return this.a.delete(o.key),this.i(o),this.d--,o.value}forEach(o,f){const u=this.e;let i=this.b;for(;i;){if(f?o.bind(f)(i.value,i.key,this):o(i.value,i.key,this),this.e!==u)throw new Error("LinkedMap got modified during iteration.");i=i.next}}keys(){const o=this,f=this.e;let u=this.b;const i={[Symbol.iterator](){return i},next(){if(o.e!==f)throw new Error("LinkedMap got modified during iteration.");if(u){const a={value:u.key,done:!1};return u=u.next,a}else return{value:void 0,done:!0}}};return i}values(){const o=this,f=this.e;let u=this.b;const i={[Symbol.iterator](){return i},next(){if(o.e!==f)throw new Error("LinkedMap got modified during iteration.");if(u){const a={value:u.value,done:!1};return u=u.next,a}else return{value:void 0,done:!0}}};return i}entries(){const o=this,f=this.e;let u=this.b;const i={[Symbol.iterator](){return i},next(){if(o.e!==f)throw new Error("LinkedMap got modified during iteration.");if(u){const a={value:[u.key,u.value],done:!1};return u=u.next,a}else return{value:void 0,done:!0}}};return i}[(r=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(o){if(o>=this.size)return;if(o===0){this.clear();return}let f=this.b,u=this.size;for(;f&&u>o;)this.a.delete(f.key),f=f.next,u--;this.b=f,this.d=u,f&&(f.previous=void 0),this.e++}g(o){if(!this.b&&!this.c)this.c=o;else if(this.b)o.next=this.b,this.b.previous=o;else throw new Error("Invalid list");this.b=o,this.e++}h(o){if(!this.b&&!this.c)this.b=o;else if(this.c)o.previous=this.c,this.c.next=o;else throw new Error("Invalid list");this.c=o,this.e++}i(o){if(o===this.b&&o===this.c)this.b=void 0,this.c=void 0;else if(o===this.b){if(!o.next)throw new Error("Invalid list");o.next.previous=void 0,this.b=o.next}else if(o===this.c){if(!o.previous)throw new Error("Invalid list");o.previous.next=void 0,this.c=o.previous}else{const f=o.next,u=o.previous;if(!f||!u)throw new Error("Invalid list");f.previous=u,u.next=f}o.next=void 0,o.previous=void 0,this.e++}j(o,f){if(!this.b||!this.c)throw new Error("Invalid list");if(!(f!==1&&f!==2)){if(f===1){if(o===this.b)return;const u=o.next,i=o.previous;o===this.c?(i.next=void 0,this.c=i):(u.previous=i,i.next=u),o.previous=void 0,o.next=this.b,this.b.previous=o,this.b=o,this.e++}else if(f===2){if(o===this.c)return;const u=o.next,i=o.previous;o===this.b?(u.previous=void 0,this.b=u):(u.previous=i,i.next=u),o.next=void 0,o.previous=this.c,this.c.next=o,this.c=o,this.e++}}}toJSON(){const o=[];return this.forEach((f,u)=>{o.push([u,f])}),o}fromJSON(o){this.clear();for(const[f,u]of o)this.set(f,u)}}t.$Ac=b;class e extends b{constructor(o,f=1){super(),this.k=o,this.l=Math.min(Math.max(0,f),1)}get limit(){return this.k}set limit(o){this.k=o,this.m()}get ratio(){return this.l}set ratio(o){this.l=Math.min(Math.max(0,o),1),this.m()}get(o,f=2){return super.get(o,f)}peek(o){return super.get(o,0)}set(o,f){return super.set(o,f,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}t.$Bc=e;class w{constructor(){this.a=new Map}add(o){return this.a.set(o,(this.a.get(o)||0)+1),this}delete(o){let f=this.a.get(o)||0;return f===0?!1:(f--,f===0?this.a.delete(o):this.a.set(o,f),!0)}has(o){return this.a.has(o)}}t.$Cc=w;class R{constructor(o){if(this.a=new Map,this.b=new Map,o)for(const[f,u]of o)this.set(f,u)}clear(){this.a.clear(),this.b.clear()}set(o,f){this.a.set(o,f),this.b.set(f,o)}get(o){return this.a.get(o)}getKey(o){return this.b.get(o)}delete(o){const f=this.a.get(o);return f===void 0?!1:(this.a.delete(o),this.b.delete(f),!0)}forEach(o,f){this.a.forEach((u,i)=>{o.call(f,u,i,this)})}keys(){return this.a.keys()}values(){return this.a.values()}}t.$Dc=R;class E{constructor(){this.a=new Map}add(o,f){let u=this.a.get(o);u||(u=new Set,this.a.set(o,u)),u.add(f)}delete(o,f){const u=this.a.get(o);u&&(u.delete(f),u.size===0&&this.a.delete(o))}forEach(o,f){const u=this.a.get(o);u&&u.forEach(f)}get(o){const f=this.a.get(o);return f||new Set}}t.$Ec=E}),te(ie[10],se([0,1,6,34,22,19,20]),function(O,t,k,_,r,c,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Yc=t.$Xc=t.$Wc=t.$Vc=t.$Uc=t.$Tc=t.$Sc=t.$Rc=t.$Qc=t.$Pc=t.$Oc=t.$Nc=t.$Mc=t.$Lc=t.$Kc=t.$Jc=t.$Ic=t.$Hc=t.$Gc=t.$Fc=void 0;const d=!1;let l=null;class s{constructor(){this.b=new Map}c(D){let q=this.b.get(D);return q||(q={parent:null,source:null,isSingleton:!1,value:D,idx:s.a++},this.b.set(D,q)),q}trackDisposable(D){const q=this.c(D);q.source||(q.source=new Error().stack)}setParent(D,q){const I=this.c(D);I.parent=q}markAsDisposed(D){this.b.delete(D)}markAsSingleton(D){this.c(D).isSingleton=!0}f(D,q){const I=q.get(D);if(I)return I;const x=D.parent?this.f(this.c(D.parent),q):D;return q.set(D,x),x}getTrackedDisposables(){const D=new Map;return[...this.b.entries()].filter(([,I])=>I.source!==null&&!this.f(I,D).isSingleton).map(([I])=>I).flat()}computeLeakingDisposables(D=10,q){let I;if(q)I=q;else{const C=new Map,X=[...this.b.values()].filter(ne=>ne.source!==null&&!this.f(ne,C).isSingleton);if(X.length===0)return;const n=new Set(X.map(ne=>ne.value));if(I=X.filter(ne=>!(ne.parent&&n.has(ne.parent))),I.length===0)throw new Error("There are cyclic diposable chains!")}if(!I)return;function x(C){function X(ne,oe){for(;ne.length>0&&oe.some(me=>typeof me=="string"?me===ne[0]:ne[0].match(me));)ne.shift()}const n=C.source.split(`
`).map(ne=>ne.trim().replace("at ","")).filter(ne=>ne!=="");return X(n,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),n.reverse()}const T=new r.$Ec;for(const C of I){const X=x(C);for(let n=0;n<=X.length;n++)T.add(X.slice(0,n).join(`
`),C)}I.sort((0,k.$5b)(C=>C.idx,k.$7b));let j="",z=0;for(const C of I.slice(0,D)){z++;const X=x(C),n=[];for(let ne=0;ne<X.length;ne++){let oe=X[ne];oe=`(shared with ${T.get(X.slice(0,ne+1).join(`
`)).size}/${I.length} leaks) at ${oe}`;const Ne=T.get(X.slice(0,ne).join(`
`)),we=(0,_.$D)([...Ne].map(Ee=>x(Ee)[ne]),Ee=>Ee);delete we[X[ne]];for(const[Ee,ve]of Object.entries(we))n.unshift(`    - stacktraces of ${ve.length} other leaks continue with ${Ee}`);n.unshift(oe)}j+=`


==================== Leaking disposable ${z}/${I.length}: ${C.value.constructor.name} ====================
${n.join(`
`)}
============================================================

`}return I.length>D&&(j+=`


... and ${I.length-D} more leaking disposables

`),{leaks:I,details:j}}}t.$Fc=s,s.a=0;function g(y){l=y}if(t.$Gc=g,d){const y="__is_disposable_tracked__";g(new class{trackDisposable(D){const q=new Error("Potentially leaked disposable").stack;setTimeout(()=>{D[y]||console.log(q)},3e3)}setParent(D,q){if(D&&D!==i.None)try{D[y]=!0}catch{}}markAsDisposed(D){if(D&&D!==i.None)try{D[y]=!0}catch{}}markAsSingleton(D){}})}function A(y){return l?.trackDisposable(y),y}t.$Hc=A;function m(y){l?.markAsDisposed(y)}t.$Ic=m;function b(y,D){l?.setParent(y,D)}function e(y,D){if(l)for(const q of y)l.setParent(q,D)}function w(y){return l?.markAsSingleton(y),y}t.$Jc=w;function R(y){return typeof y.dispose=="function"&&y.dispose.length===0}t.$Kc=R;function E(y){if(L.Iterable.is(y)){const D=[];for(const q of y)if(q)try{q.dispose()}catch(I){D.push(I)}if(D.length===1)throw D[0];if(D.length>1)throw new AggregateError(D,"Encountered errors while disposing of store");return Array.isArray(y)?[]:y}else if(y)return y.dispose(),y}t.$Lc=E;function h(y){for(const D of y)R(D)&&D.dispose();return[]}t.$Mc=h;function o(...y){const D=f(()=>E(y));return e(y,D),D}t.$Nc=o;function f(y){const D=A({dispose:(0,c.$bb)(()=>{m(D),y()})});return D}t.$Oc=f;class u{constructor(){this.f=new Set,this.g=!1,A(this)}dispose(){this.g||(m(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{E(this.f)}finally{this.f.clear()}}add(D){if(!D)return D;if(D===this)throw new Error("Cannot register a disposable on itself!");return b(D,this),this.g?u.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(D),D}delete(D){if(D){if(D===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(D),D.dispose()}}deleteAndLeak(D){D&&this.f.has(D)&&(this.f.delete(D),b(D,null))}}t.$Pc=u,u.DISABLE_DISPOSED_WARNING=!1;class i{constructor(){this.q=new u,A(this),b(this.q,this)}dispose(){m(this),this.q.dispose()}B(D){if(D===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(D)}}t.$Qc=i,i.None=Object.freeze({dispose(){}});class a{constructor(){this.b=!1,A(this)}get value(){return this.b?void 0:this.a}set value(D){this.b||D===this.a||(this.a?.dispose(),D&&b(D,this),this.a=D)}clear(){this.value=void 0}dispose(){this.b=!0,m(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const D=this.a;return this.a=void 0,D&&b(D,null),D}}t.$Rc=a;class N{constructor(D){this.b=D,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}t.$Sc=N;class ${constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,A(this)}set(D){let q=D;return this.unset=()=>q=void 0,this.isset=()=>q!==void 0,this.dispose=()=>{q&&(q(),q=void 0,m(this))},this}}t.$Tc=$;class v{constructor(){this.a=new Map}acquire(D,...q){let I=this.a.get(D);I||(I={counter:0,object:this.b(D,...q)},this.a.set(D,I));const{object:x}=I,T=(0,c.$bb)(()=>{--I.counter===0&&(this.c(D,I.object),this.a.delete(D))});return I.counter++,{object:x,dispose:T}}}t.$Uc=v;class p{constructor(D){this.a=D}async acquire(D,...q){const I=this.a.acquire(D,...q);try{return{object:await I.object,dispose:()=>I.dispose()}}catch(x){throw I.dispose(),x}}}t.$Vc=p;class M{constructor(D){this.object=D}dispose(){}}t.$Wc=M;function P(y){const D=new u;try{y(D)}finally{D.dispose()}}t.$Xc=P;class F{constructor(){this.a=new Map,this.b=!1,A(this)}dispose(){m(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{E(this.a.values())}finally{this.a.clear()}}has(D){return this.a.has(D)}get size(){return this.a.size}get(D){return this.a.get(D)}set(D,q,I=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),I||this.a.get(D)?.dispose(),this.a.set(D,q)}deleteAndDispose(D){this.a.get(D)?.dispose(),this.a.delete(D)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}t.$Yc=F}),te(ie[14],se([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$C=t.$B=t.$A=t.$z=t.$y=t.$x=t.OS=t.OperatingSystem=t.$v=t.$u=t.$t=t.$s=t.$r=t.Language=t.$q=t.$p=t.$o=t.$n=t.$m=t.$l=t.$k=t.$j=t.$i=t.$h=t.$g=t.$f=t.$e=t.$d=t.$c=t.Platform=t.$b=t.$a=void 0,t.$a="en";let k=!1,_=!1,r=!1,c=!1,L=!1,d=!1,l=!1,s=!1,g=!1,A=!1,m,b=t.$a,e=t.$a,w,R;t.$b=typeof self=="object"?self:typeof global=="object"?global:{};let E;typeof t.$b.vscode<"u"&&typeof t.$b.vscode.process<"u"?E=t.$b.vscode.process:typeof process<"u"&&(E=process);const h=typeof E?.versions?.electron=="string",o=h&&E?.type==="renderer";if(typeof navigator=="object"&&!o){R=navigator.userAgent,k=R.indexOf("Windows")>=0,_=R.indexOf("Macintosh")>=0,s=(R.indexOf("Macintosh")>=0||R.indexOf("iPad")>=0||R.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,r=R.indexOf("Linux")>=0,A=R?.indexOf("Mobi")>=0,d=!0,m=t.$a,b=m,e=navigator.language;const M=typeof document<"u"&&document.getElementById("vscode-remote-nls-configuration"),P=M&&M.getAttribute("data-settings");if(P)try{const F=JSON.parse(P),y=F.availableLanguages["*"];m=F.locale,e=F.osLocale,b=y||t.$a,w=F._translationsConfigFile}catch{}}else if(typeof E=="object"){k=E.platform==="win32",_=E.platform==="darwin",r=E.platform==="linux",c=r&&!!E.env.SNAP&&!!E.env.SNAP_REVISION,l=h,g=!!E.env.CI||!!E.env.BUILD_ARTIFACTSTAGINGDIRECTORY,m=t.$a,b=t.$a;const M=E.env.VSCODE_NLS_CONFIG;if(M)try{const P=JSON.parse(M),F=P.availableLanguages["*"];m=P.locale,e=P.osLocale,b=F||t.$a,w=P._translationsConfigFile}catch{}L=!0}else console.error("Unable to resolve platform.");var f;(function(M){M[M.Web=0]="Web",M[M.Mac=1]="Mac",M[M.Linux=2]="Linux",M[M.Windows=3]="Windows"})(f||(t.Platform=f={}));function u(M){switch(M){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}t.$c=u;let i=0;_?i=1:k?i=3:r&&(i=2),t.$d=k,t.$e=_,t.$f=r,t.$g=c,t.$h=L,t.$i=l,t.$j=d,t.$k=d&&typeof t.$b.importScripts=="function",t.$l=s,t.$m=A,t.$n=g,t.$o=i,t.$p=R,t.$q=b;var a;(function(M){function P(){return t.$q}M.value=P;function F(){return t.$q.length===2?t.$q==="en":t.$q.length>=3?t.$q[0]==="e"&&t.$q[1]==="n"&&t.$q[2]==="-":!1}M.isDefaultVariant=F;function y(){return t.$q==="en"}M.isDefault=y})(a||(t.Language=a={})),t.$r=m,t.$s=e,t.$t=w,t.$u=typeof t.$b.postMessage=="function"&&!t.$b.importScripts,t.$v=(()=>{if(t.$u){const M=[];t.$b.addEventListener("message",F=>{if(F.data&&F.data.vscodeScheduleAsyncWork)for(let y=0,D=M.length;y<D;y++){const q=M[y];if(q.id===F.data.vscodeScheduleAsyncWork){M.splice(y,1),q.callback();return}}});let P=0;return F=>{const y=++P;M.push({id:y,callback:F}),t.$b.postMessage({vscodeScheduleAsyncWork:y},"*")}}return M=>setTimeout(M)})();var N;(function(M){M[M.Windows=1]="Windows",M[M.Macintosh=2]="Macintosh",M[M.Linux=3]="Linux"})(N||(t.OperatingSystem=N={})),t.OS=_||s?2:k?1:3;let $=!0,v=!1;function p(){if(!v){v=!0;const M=new Uint8Array(2);M[0]=1,M[1]=2,$=new Uint16Array(M.buffer)[0]===(2<<8)+1}return $}t.$x=p,t.$y=!!(t.$p&&t.$p.indexOf("Chrome")>=0),t.$z=!!(t.$p&&t.$p.indexOf("Firefox")>=0),t.$A=!!(!t.$y&&t.$p&&t.$p.indexOf("Safari")>=0),t.$B=!!(t.$p&&t.$p.indexOf("Edg/")>=0),t.$C=!!(t.$p&&t.$p.indexOf("Android")>=0)}),te(ie[39],se([0,1,14]),function(O,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cc=t.$bc=t.env=t.cwd=void 0;let _;if(typeof k.$b.vscode<"u"&&typeof k.$b.vscode.process<"u"){const r=k.$b.vscode.process;_={get platform(){return r.platform},get arch(){return r.arch},get env(){return r.env},cwd(){return r.cwd()}}}else typeof process<"u"?_={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:_={get platform(){return k.$d?"win32":k.$e?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};t.cwd=_.cwd,t.env=_.env,t.$bc=_.platform,t.$cc=_.arch}),te(ie[40],se([0,1,39]),function(O,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$rc=t.sep=t.$pc=t.$oc=t.$nc=t.$mc=t.$lc=t.$kc=t.$jc=t.$ic=t.$hc=t.$gc=t.$fc=t.$ec=t.$dc=void 0;const _=65,r=97,c=90,L=122,d=46,l=47,s=92,g=58,A=63;class m extends Error{constructor(a,N,$){let v;typeof N=="string"&&N.indexOf("not ")===0?(v="must not be",N=N.replace(/^not /,"")):v="must be";const p=a.indexOf(".")!==-1?"property":"argument";let M=`The "${a}" ${p} ${v} of type ${N}`;M+=`. Received type ${typeof $}`,super(M),this.code="ERR_INVALID_ARG_TYPE"}}function b(i,a){if(i===null||typeof i!="object")throw new m(a,"Object",i)}function e(i,a){if(typeof i!="string")throw new m(a,"string",i)}const w=k.$bc==="win32";function R(i){return i===l||i===s}function E(i){return i===l}function h(i){return i>=_&&i<=c||i>=r&&i<=L}function o(i,a,N,$){let v="",p=0,M=-1,P=0,F=0;for(let y=0;y<=i.length;++y){if(y<i.length)F=i.charCodeAt(y);else{if($(F))break;F=l}if($(F)){if(!(M===y-1||P===1))if(P===2){if(v.length<2||p!==2||v.charCodeAt(v.length-1)!==d||v.charCodeAt(v.length-2)!==d){if(v.length>2){const D=v.lastIndexOf(N);D===-1?(v="",p=0):(v=v.slice(0,D),p=v.length-1-v.lastIndexOf(N)),M=y,P=0;continue}else if(v.length!==0){v="",p=0,M=y,P=0;continue}}a&&(v+=v.length>0?`${N}..`:"..",p=2)}else v.length>0?v+=`${N}${i.slice(M+1,y)}`:v=i.slice(M+1,y),p=y-M-1;M=y,P=0}else F===d&&P!==-1?++P:P=-1}return v}function f(i,a){b(a,"pathObject");const N=a.dir||a.root,$=a.base||`${a.name||""}${a.ext||""}`;return N?N===a.root?`${N}${$}`:`${N}${i}${$}`:$}t.$dc={resolve(...i){let a="",N="",$=!1;for(let v=i.length-1;v>=-1;v--){let p;if(v>=0){if(p=i[v],e(p,"path"),p.length===0)continue}else a.length===0?p=k.cwd():(p=k.env[`=${a}`]||k.cwd(),(p===void 0||p.slice(0,2).toLowerCase()!==a.toLowerCase()&&p.charCodeAt(2)===s)&&(p=`${a}\\`));const M=p.length;let P=0,F="",y=!1;const D=p.charCodeAt(0);if(M===1)R(D)&&(P=1,y=!0);else if(R(D))if(y=!0,R(p.charCodeAt(1))){let q=2,I=q;for(;q<M&&!R(p.charCodeAt(q));)q++;if(q<M&&q!==I){const x=p.slice(I,q);for(I=q;q<M&&R(p.charCodeAt(q));)q++;if(q<M&&q!==I){for(I=q;q<M&&!R(p.charCodeAt(q));)q++;(q===M||q!==I)&&(F=`\\\\${x}\\${p.slice(I,q)}`,P=q)}}}else P=1;else h(D)&&p.charCodeAt(1)===g&&(F=p.slice(0,2),P=2,M>2&&R(p.charCodeAt(2))&&(y=!0,P=3));if(F.length>0)if(a.length>0){if(F.toLowerCase()!==a.toLowerCase())continue}else a=F;if($){if(a.length>0)break}else if(N=`${p.slice(P)}\\${N}`,$=y,y&&a.length>0)break}return N=o(N,!$,"\\",R),$?`${a}\\${N}`:`${a}${N}`||"."},normalize(i){e(i,"path");const a=i.length;if(a===0)return".";let N=0,$,v=!1;const p=i.charCodeAt(0);if(a===1)return E(p)?"\\":i;if(R(p))if(v=!0,R(i.charCodeAt(1))){let P=2,F=P;for(;P<a&&!R(i.charCodeAt(P));)P++;if(P<a&&P!==F){const y=i.slice(F,P);for(F=P;P<a&&R(i.charCodeAt(P));)P++;if(P<a&&P!==F){for(F=P;P<a&&!R(i.charCodeAt(P));)P++;if(P===a)return`\\\\${y}\\${i.slice(F)}\\`;P!==F&&($=`\\\\${y}\\${i.slice(F,P)}`,N=P)}}}else N=1;else h(p)&&i.charCodeAt(1)===g&&($=i.slice(0,2),N=2,a>2&&R(i.charCodeAt(2))&&(v=!0,N=3));let M=N<a?o(i.slice(N),!v,"\\",R):"";return M.length===0&&!v&&(M="."),M.length>0&&R(i.charCodeAt(a-1))&&(M+="\\"),$===void 0?v?`\\${M}`:M:v?`${$}\\${M}`:`${$}${M}`},isAbsolute(i){e(i,"path");const a=i.length;if(a===0)return!1;const N=i.charCodeAt(0);return R(N)||a>2&&h(N)&&i.charCodeAt(1)===g&&R(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let a,N;for(let p=0;p<i.length;++p){const M=i[p];e(M,"path"),M.length>0&&(a===void 0?a=N=M:a+=`\\${M}`)}if(a===void 0)return".";let $=!0,v=0;if(typeof N=="string"&&R(N.charCodeAt(0))){++v;const p=N.length;p>1&&R(N.charCodeAt(1))&&(++v,p>2&&(R(N.charCodeAt(2))?++v:$=!1))}if($){for(;v<a.length&&R(a.charCodeAt(v));)v++;v>=2&&(a=`\\${a.slice(v)}`)}return t.$dc.normalize(a)},relative(i,a){if(e(i,"from"),e(a,"to"),i===a)return"";const N=t.$dc.resolve(i),$=t.$dc.resolve(a);if(N===$||(i=N.toLowerCase(),a=$.toLowerCase(),i===a))return"";let v=0;for(;v<i.length&&i.charCodeAt(v)===s;)v++;let p=i.length;for(;p-1>v&&i.charCodeAt(p-1)===s;)p--;const M=p-v;let P=0;for(;P<a.length&&a.charCodeAt(P)===s;)P++;let F=a.length;for(;F-1>P&&a.charCodeAt(F-1)===s;)F--;const y=F-P,D=M<y?M:y;let q=-1,I=0;for(;I<D;I++){const T=i.charCodeAt(v+I);if(T!==a.charCodeAt(P+I))break;T===s&&(q=I)}if(I!==D){if(q===-1)return $}else{if(y>D){if(a.charCodeAt(P+I)===s)return $.slice(P+I+1);if(I===2)return $.slice(P+I)}M>D&&(i.charCodeAt(v+I)===s?q=I:I===2&&(q=3)),q===-1&&(q=0)}let x="";for(I=v+q+1;I<=p;++I)(I===p||i.charCodeAt(I)===s)&&(x+=x.length===0?"..":"\\..");return P+=q,x.length>0?`${x}${$.slice(P,F)}`:($.charCodeAt(P)===s&&++P,$.slice(P,F))},toNamespacedPath(i){if(typeof i!="string"||i.length===0)return i;const a=t.$dc.resolve(i);if(a.length<=2)return i;if(a.charCodeAt(0)===s){if(a.charCodeAt(1)===s){const N=a.charCodeAt(2);if(N!==A&&N!==d)return`\\\\?\\UNC\\${a.slice(2)}`}}else if(h(a.charCodeAt(0))&&a.charCodeAt(1)===g&&a.charCodeAt(2)===s)return`\\\\?\\${a}`;return i},dirname(i){e(i,"path");const a=i.length;if(a===0)return".";let N=-1,$=0;const v=i.charCodeAt(0);if(a===1)return R(v)?i:".";if(R(v)){if(N=$=1,R(i.charCodeAt(1))){let P=2,F=P;for(;P<a&&!R(i.charCodeAt(P));)P++;if(P<a&&P!==F){for(F=P;P<a&&R(i.charCodeAt(P));)P++;if(P<a&&P!==F){for(F=P;P<a&&!R(i.charCodeAt(P));)P++;if(P===a)return i;P!==F&&(N=$=P+1)}}}}else h(v)&&i.charCodeAt(1)===g&&(N=a>2&&R(i.charCodeAt(2))?3:2,$=N);let p=-1,M=!0;for(let P=a-1;P>=$;--P)if(R(i.charCodeAt(P))){if(!M){p=P;break}}else M=!1;if(p===-1){if(N===-1)return".";p=N}return i.slice(0,p)},basename(i,a){a!==void 0&&e(a,"ext"),e(i,"path");let N=0,$=-1,v=!0,p;if(i.length>=2&&h(i.charCodeAt(0))&&i.charCodeAt(1)===g&&(N=2),a!==void 0&&a.length>0&&a.length<=i.length){if(a===i)return"";let M=a.length-1,P=-1;for(p=i.length-1;p>=N;--p){const F=i.charCodeAt(p);if(R(F)){if(!v){N=p+1;break}}else P===-1&&(v=!1,P=p+1),M>=0&&(F===a.charCodeAt(M)?--M===-1&&($=p):(M=-1,$=P))}return N===$?$=P:$===-1&&($=i.length),i.slice(N,$)}for(p=i.length-1;p>=N;--p)if(R(i.charCodeAt(p))){if(!v){N=p+1;break}}else $===-1&&(v=!1,$=p+1);return $===-1?"":i.slice(N,$)},extname(i){e(i,"path");let a=0,N=-1,$=0,v=-1,p=!0,M=0;i.length>=2&&i.charCodeAt(1)===g&&h(i.charCodeAt(0))&&(a=$=2);for(let P=i.length-1;P>=a;--P){const F=i.charCodeAt(P);if(R(F)){if(!p){$=P+1;break}continue}v===-1&&(p=!1,v=P+1),F===d?N===-1?N=P:M!==1&&(M=1):N!==-1&&(M=-1)}return N===-1||v===-1||M===0||M===1&&N===v-1&&N===$+1?"":i.slice(N,v)},format:f.bind(null,"\\"),parse(i){e(i,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return a;const N=i.length;let $=0,v=i.charCodeAt(0);if(N===1)return R(v)?(a.root=a.dir=i,a):(a.base=a.name=i,a);if(R(v)){if($=1,R(i.charCodeAt(1))){let q=2,I=q;for(;q<N&&!R(i.charCodeAt(q));)q++;if(q<N&&q!==I){for(I=q;q<N&&R(i.charCodeAt(q));)q++;if(q<N&&q!==I){for(I=q;q<N&&!R(i.charCodeAt(q));)q++;q===N?$=q:q!==I&&($=q+1)}}}}else if(h(v)&&i.charCodeAt(1)===g){if(N<=2)return a.root=a.dir=i,a;if($=2,R(i.charCodeAt(2))){if(N===3)return a.root=a.dir=i,a;$=3}}$>0&&(a.root=i.slice(0,$));let p=-1,M=$,P=-1,F=!0,y=i.length-1,D=0;for(;y>=$;--y){if(v=i.charCodeAt(y),R(v)){if(!F){M=y+1;break}continue}P===-1&&(F=!1,P=y+1),v===d?p===-1?p=y:D!==1&&(D=1):p!==-1&&(D=-1)}return P!==-1&&(p===-1||D===0||D===1&&p===P-1&&p===M+1?a.base=a.name=i.slice(M,P):(a.name=i.slice(M,p),a.base=i.slice(M,P),a.ext=i.slice(p,P))),M>0&&M!==$?a.dir=i.slice(0,M-1):a.dir=a.root,a},sep:"\\",delimiter:";",win32:null,posix:null};const u=(()=>{if(w){const i=/\\/g;return()=>{const a=k.cwd().replace(i,"/");return a.slice(a.indexOf("/"))}}return()=>k.cwd()})();t.$ec={resolve(...i){let a="",N=!1;for(let $=i.length-1;$>=-1&&!N;$--){const v=$>=0?i[$]:u();e(v,"path"),v.length!==0&&(a=`${v}/${a}`,N=v.charCodeAt(0)===l)}return a=o(a,!N,"/",E),N?`/${a}`:a.length>0?a:"."},normalize(i){if(e(i,"path"),i.length===0)return".";const a=i.charCodeAt(0)===l,N=i.charCodeAt(i.length-1)===l;return i=o(i,!a,"/",E),i.length===0?a?"/":N?"./":".":(N&&(i+="/"),a?`/${i}`:i)},isAbsolute(i){return e(i,"path"),i.length>0&&i.charCodeAt(0)===l},join(...i){if(i.length===0)return".";let a;for(let N=0;N<i.length;++N){const $=i[N];e($,"path"),$.length>0&&(a===void 0?a=$:a+=`/${$}`)}return a===void 0?".":t.$ec.normalize(a)},relative(i,a){if(e(i,"from"),e(a,"to"),i===a||(i=t.$ec.resolve(i),a=t.$ec.resolve(a),i===a))return"";const N=1,$=i.length,v=$-N,p=1,M=a.length-p,P=v<M?v:M;let F=-1,y=0;for(;y<P;y++){const q=i.charCodeAt(N+y);if(q!==a.charCodeAt(p+y))break;q===l&&(F=y)}if(y===P)if(M>P){if(a.charCodeAt(p+y)===l)return a.slice(p+y+1);if(y===0)return a.slice(p+y)}else v>P&&(i.charCodeAt(N+y)===l?F=y:y===0&&(F=0));let D="";for(y=N+F+1;y<=$;++y)(y===$||i.charCodeAt(y)===l)&&(D+=D.length===0?"..":"/..");return`${D}${a.slice(p+F)}`},toNamespacedPath(i){return i},dirname(i){if(e(i,"path"),i.length===0)return".";const a=i.charCodeAt(0)===l;let N=-1,$=!0;for(let v=i.length-1;v>=1;--v)if(i.charCodeAt(v)===l){if(!$){N=v;break}}else $=!1;return N===-1?a?"/":".":a&&N===1?"//":i.slice(0,N)},basename(i,a){a!==void 0&&e(a,"ext"),e(i,"path");let N=0,$=-1,v=!0,p;if(a!==void 0&&a.length>0&&a.length<=i.length){if(a===i)return"";let M=a.length-1,P=-1;for(p=i.length-1;p>=0;--p){const F=i.charCodeAt(p);if(F===l){if(!v){N=p+1;break}}else P===-1&&(v=!1,P=p+1),M>=0&&(F===a.charCodeAt(M)?--M===-1&&($=p):(M=-1,$=P))}return N===$?$=P:$===-1&&($=i.length),i.slice(N,$)}for(p=i.length-1;p>=0;--p)if(i.charCodeAt(p)===l){if(!v){N=p+1;break}}else $===-1&&(v=!1,$=p+1);return $===-1?"":i.slice(N,$)},extname(i){e(i,"path");let a=-1,N=0,$=-1,v=!0,p=0;for(let M=i.length-1;M>=0;--M){const P=i.charCodeAt(M);if(P===l){if(!v){N=M+1;break}continue}$===-1&&(v=!1,$=M+1),P===d?a===-1?a=M:p!==1&&(p=1):a!==-1&&(p=-1)}return a===-1||$===-1||p===0||p===1&&a===$-1&&a===N+1?"":i.slice(a,$)},format:f.bind(null,"/"),parse(i){e(i,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return a;const N=i.charCodeAt(0)===l;let $;N?(a.root="/",$=1):$=0;let v=-1,p=0,M=-1,P=!0,F=i.length-1,y=0;for(;F>=$;--F){const D=i.charCodeAt(F);if(D===l){if(!P){p=F+1;break}continue}M===-1&&(P=!1,M=F+1),D===d?v===-1?v=F:y!==1&&(y=1):v!==-1&&(y=-1)}if(M!==-1){const D=p===0&&N?1:p;v===-1||y===0||y===1&&v===M-1&&v===p+1?a.base=a.name=i.slice(D,M):(a.name=i.slice(D,v),a.base=i.slice(D,M),a.ext=i.slice(v,M))}return p>0?a.dir=i.slice(0,p-1):N&&(a.dir="/"),a},sep:"/",delimiter:":",win32:null,posix:null},t.$ec.win32=t.$dc.win32=t.$dc,t.$ec.posix=t.$dc.posix=t.$ec,t.$fc=w?t.$dc.normalize:t.$ec.normalize,t.$gc=w?t.$dc.isAbsolute:t.$ec.isAbsolute,t.$hc=w?t.$dc.join:t.$ec.join,t.$ic=w?t.$dc.resolve:t.$ec.resolve,t.$jc=w?t.$dc.relative:t.$ec.relative,t.$kc=w?t.$dc.dirname:t.$ec.dirname,t.$lc=w?t.$dc.basename:t.$ec.basename,t.$mc=w?t.$dc.extname:t.$ec.extname,t.$nc=w?t.$dc.format:t.$ec.format,t.$oc=w?t.$dc.parse:t.$ec.parse,t.$pc=w?t.$dc.toNamespacedPath:t.$ec.toNamespacedPath,t.sep=w?t.$dc.sep:t.$ec.sep,t.$rc=w?t.$dc.delimiter:t.$ec.delimiter}),te(ie[23],se([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Hd=void 0;const k=globalThis.performance&&typeof globalThis.performance.now=="function";class _{static create(c){return new _(c)}constructor(c){this.c=k&&c===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}t.$Hd=_}),te(ie[11],se([0,1,3,19,10,21,23]),function(O,t,k,_,r,c,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ud=t.$Td=t.$Sd=t.$Rd=t.$Qd=t.$Pd=t.$Od=t.$Nd=t.$Md=t.$Ld=t.$Kd=t.$Jd=t.Event=void 0;const d=!1,l=!1;var s;(function(F){F.None=()=>r.$Qc.None;function y(G){if(l){const{onDidAddListener:Y}=G,J=e.create();let K=0;G.onDidAddListener=()=>{++K===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),J.print()),Y?.()}}}function D(G,Y){return ne(G,()=>{},0,void 0,!0,void 0,Y)}F.defer=D;function q(G){return(Y,J=null,K)=>{let re=!1,le;return le=G(ce=>{if(!re)return le?le.dispose():re=!0,Y.call(J,ce)},null,K),re&&le.dispose(),le}}F.once=q;function I(G,Y,J){return X((K,re=null,le)=>G(ce=>K.call(re,Y(ce)),null,le),J)}F.map=I;function x(G,Y,J){return X((K,re=null,le)=>G(ce=>{Y(ce),K.call(re,ce)},null,le),J)}F.forEach=x;function T(G,Y,J){return X((K,re=null,le)=>G(ce=>Y(ce)&&K.call(re,ce),null,le),J)}F.filter=T;function j(G){return G}F.signal=j;function z(...G){return(Y,J=null,K)=>{const re=(0,r.$Nc)(...G.map(le=>le(ce=>Y.call(J,ce))));return n(re,K)}}F.any=z;function C(G,Y,J,K){let re=J;return I(G,le=>(re=Y(re,le),re),K)}F.reduce=C;function X(G,Y){let J;const K={onWillAddFirstListener(){J=G(re.fire,re)},onDidRemoveLastListener(){J?.dispose()}};Y||y(K);const re=new o(K);return Y?.add(re),re.event}function n(G,Y){return Y instanceof Array?Y.push(G):Y&&Y.add(G),G}function ne(G,Y,J=100,K=!1,re=!1,le,ce){let be,de,pe,ye=0,$e;const Ie={leakWarningThreshold:le,onWillAddFirstListener(){be=G(Be=>{ye++,de=Y(de,Be),K&&!pe&&(Fe.fire(de),de=void 0),$e=()=>{const Oe=de;de=void 0,pe=void 0,(!K||ye>1)&&Fe.fire(Oe),ye=0},typeof J=="number"?(clearTimeout(pe),pe=setTimeout($e,J)):pe===void 0&&(pe=0,queueMicrotask($e))})},onWillRemoveListener(){re&&ye>0&&$e?.()},onDidRemoveLastListener(){$e=void 0,be.dispose()}};ce||y(Ie);const Fe=new o(Ie);return ce?.add(Fe),Fe.event}F.debounce=ne;function oe(G,Y=0,J){return F.debounce(G,(K,re)=>K?(K.push(re),K):[re],Y,void 0,!0,void 0,J)}F.accumulate=oe;function me(G,Y=(K,re)=>K===re,J){let K=!0,re;return T(G,le=>{const ce=K||!Y(le,re);return K=!1,re=le,ce},J)}F.latch=me;function Ne(G,Y,J){return[F.filter(G,Y,J),F.filter(G,K=>!Y(K),J)]}F.split=Ne;function we(G,Y=!1,J=[],K){let re=J.slice(),le=G(de=>{re?re.push(de):be.fire(de)});K&&K.add(le);const ce=()=>{re?.forEach(de=>be.fire(de)),re=null},be=new o({onWillAddFirstListener(){le||(le=G(de=>be.fire(de)),K&&K.add(le))},onDidAddFirstListener(){re&&(Y?setTimeout(ce):ce())},onDidRemoveLastListener(){le&&le.dispose(),le=null}});return K&&K.add(be),be.event}F.buffer=we;function Ee(G,Y){return(K,re,le)=>{const ce=Y(new De);return G(function(be){const de=ce.evaluate(be);de!==ve&&K.call(re,de)},void 0,le)}}F.chain=Ee;const ve=Symbol("HaltChainable");class De{constructor(){this.f=[]}map(Y){return this.f.push(Y),this}forEach(Y){return this.f.push(J=>(Y(J),J)),this}filter(Y){return this.f.push(J=>Y(J)?J:ve),this}reduce(Y,J){let K=J;return this.f.push(re=>(K=Y(K,re),K)),this}latch(Y=(J,K)=>J===K){let J=!0,K;return this.f.push(re=>{const le=J||!Y(re,K);return J=!1,K=re,le?re:ve}),this}evaluate(Y){for(const J of this.f)if(Y=J(Y),Y===ve)break;return Y}}function _e(G,Y,J=K=>K){const K=(...be)=>ce.fire(J(...be)),re=()=>G.on(Y,K),le=()=>G.removeListener(Y,K),ce=new o({onWillAddFirstListener:re,onDidRemoveLastListener:le});return ce.event}F.fromNodeEventEmitter=_e;function Te(G,Y,J=K=>K){const K=(...be)=>ce.fire(J(...be)),re=()=>G.addEventListener(Y,K),le=()=>G.removeEventListener(Y,K),ce=new o({onWillAddFirstListener:re,onDidRemoveLastListener:le});return ce.event}F.fromDOMEventEmitter=Te;function Se(G){return new Promise(Y=>q(G)(Y))}F.toPromise=Se;function Ae(G){const Y=new o;return G.then(J=>{Y.fire(J)},()=>{Y.fire(void 0)}).finally(()=>{Y.dispose()}),Y.event}F.fromPromise=Ae;function U(G,Y){return Y(void 0),G(J=>Y(J))}F.runAndSubscribe=U;function W(G,Y){let J=null;function K(le){J?.dispose(),J=new r.$Pc,Y(le,J)}K(void 0);const re=G(le=>K(le));return(0,r.$Oc)(()=>{re.dispose(),J?.dispose()})}F.runAndSubscribeWithStore=W;class V{constructor(Y,J){this._observable=Y,this.f=0,this.g=!1;const K={onWillAddFirstListener:()=>{Y.addObserver(this)},onDidRemoveLastListener:()=>{Y.removeObserver(this)}};J||y(K),this.emitter=new o(K),J&&J.add(this.emitter)}beginUpdate(Y){this.f++}handlePossibleChange(Y){}handleChange(Y,J){this.g=!0}endUpdate(Y){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function Q(G,Y){return new V(G,Y).emitter.event}F.fromObservable=Q;function ee(G){return Y=>{let J=0,K=!1;const re={beginUpdate(){J++},endUpdate(){J--,J===0&&(G.reportChanges(),K&&(K=!1,Y()))},handlePossibleChange(){},handleChange(){K=!0}};return G.addObserver(re),G.reportChanges(),{dispose(){G.removeObserver(re)}}}}F.fromObservableLight=ee})(s||(t.Event=s={}));class g{constructor(y){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${y}_${g.f++}`,g.all.add(this)}start(y){this.g=new L.$Hd,this.listenerCount=y}stop(){if(this.g){const y=this.g.elapsed();this.durations.push(y),this.elapsedOverall+=y,this.invocationCount+=1,this.g=void 0}}}t.$Jd=g,g.all=new Set,g.f=0;let A=-1;function m(F){const y=A;return A=F,{dispose(){A=y}}}t.$Kd=m;class b{constructor(y,D=Math.random().toString(18).slice(2,5)){this.threshold=y,this.name=D,this.g=0}dispose(){this.f?.clear()}check(y,D){const q=this.threshold;if(q<=0||D<q)return;this.f||(this.f=new Map);const I=this.f.get(y.value)||0;if(this.f.set(y.value,I+1),this.g-=1,this.g<=0){this.g=q*.5;let x,T=0;for(const[j,z]of this.f)(!x||T<z)&&(x=j,T=z);console.warn(`[${this.name}] potential listener LEAK detected, having ${D} listeners already. MOST frequent listener (${T}):`),console.warn(x)}return()=>{const x=this.f.get(y.value)||0;this.f.set(y.value,x-1)}}}class e{static create(){return new e(new Error().stack??"")}constructor(y){this.value=y}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let w=0;class R{constructor(y){this.value=y,this.id=w++}}const E=2,h=(F,y)=>{if(F instanceof R)y(F);else for(let D=0;D<F.length;D++){const q=F[D];q&&y(q)}};class o{constructor(y){this.x=0,this.f=y,this.g=A>0||this.f?.leakWarningThreshold?new b(this.f?.leakWarningThreshold??A):void 0,this.j=this.f?._profName?new g(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(d){const y=this.t;queueMicrotask(()=>{h(y,D=>D.stack?.print())})}this.t=void 0,this.x=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??(this.q=(y,D,q)=>{if(this.g&&this.x>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),r.$Qc.None;if(this.m)return r.$Qc.None;D&&(y=y.bind(D));const I=new R(y);let x,T;this.g&&this.x>=Math.ceil(this.g.threshold*.2)&&(I.stack=e.create(),x=this.g.check(I.stack,this.x+1)),d&&(I.stack=T??e.create()),this.t?this.t instanceof R?(this.u??(this.u=new u),this.t=[this.t,I]):this.t.push(I):(this.f?.onWillAddFirstListener?.(this),this.t=I,this.f?.onDidAddFirstListener?.(this)),this.x++;const j=(0,r.$Oc)(()=>{x?.(),this.y(I)});return q instanceof r.$Pc?q.add(j):Array.isArray(q)&&q.push(j),j}),this.q}y(y){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.x===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.x=0;return}const D=this.t,q=D.indexOf(y);if(q===-1)throw console.log("disposed?",this.m),console.log("size?",this.x),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.x--,D[q]=void 0;const I=this.u.current===this;if(this.x*E<=D.length){let x=0;for(let T=0;T<D.length;T++)D[T]?D[x++]=D[T]:I&&(this.u.end--,x<this.u.i&&this.u.i--);D.length=x}}z(y,D){if(!y)return;const q=this.f?.onListenerError||k.$Y;if(!q){y.value(D);return}try{y.value(D)}catch(I){q(I)}}A(y){const D=y.current.t;for(;y.i<y.end;)this.z(D[y.i++],y.value);y.reset()}fire(y){if(this.u?.current&&(this.A(this.u),this.j?.stop()),this.j?.start(this.x),this.t)if(this.t instanceof R)this.z(this.t,y);else{const D=this.u;D.enqueue(this,y,this.t.length),this.A(D)}this.j?.stop()}hasListeners(){return this.x>0}}t.$Ld=o;const f=()=>new u;t.$Md=f;class u{constructor(){this.i=-1,this.end=0}enqueue(y,D,q){this.i=0,this.end=q,this.current=y,this.value=D}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class i extends o{async fireAsync(y,D,q){if(this.t)for(this.h||(this.h=new c.$Zc),h(this.t,I=>this.h.push([I.value,y]));this.h.size>0&&!D.isCancellationRequested;){const[I,x]=this.h.shift(),T=[],j={...x,token:D,waitUntil:z=>{if(Object.isFrozen(T))throw new Error("waitUntil can NOT be called asynchronous");q&&(z=q(z,I)),T.push(z)}};try{I(j)}catch(z){(0,k.$Y)(z);continue}Object.freeze(T),await Promise.allSettled(T).then(z=>{for(const C of z)C.status==="rejected"&&(0,k.$Y)(C.reason)})}}}t.$Nd=i;class a extends o{get isPaused(){return this.h!==0}constructor(y){super(y),this.h=0,this.s=new c.$Zc,this.w=y?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.w){if(this.s.size>0){const y=Array.from(this.s);this.s.clear(),super.fire(this.w(y))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(y){this.x&&(this.h!==0?this.s.push(y):super.fire(y))}}t.$Od=a;class N extends a{constructor(y){super(y),this.k=y.delay??100}fire(y){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(y)}}t.$Pd=N;class $ extends o{constructor(y){super(y),this.h=[],this.k=y?.merge}fire(y){this.hasListeners()&&(this.h.push(y),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(D=>super.fire(D)),this.h=[]}))}}t.$Qd=$;class v{constructor(){this.g=!1,this.h=[],this.f=new o({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(y){const D={event:y,listener:null};this.h.push(D),this.g&&this.m(D);const q=()=>{this.g&&this.o(D);const I=this.h.indexOf(D);this.h.splice(I,1)};return(0,r.$Oc)((0,_.$bb)(q))}j(){this.g=!0,this.h.forEach(y=>this.m(y))}k(){this.g=!1,this.h.forEach(y=>this.o(y))}m(y){y.listener=y.event(D=>this.f.fire(D))}o(y){y.listener&&y.listener.dispose(),y.listener=null}dispose(){this.f.dispose()}}t.$Rd=v;class p{constructor(y,D,q,I){this.f=new r.$Pc;const x=this.f.add(new v),T=this.f.add(new r.$Yc);function j(z){T.set(z,x.add(I(z)))}for(const z of y)j(z);this.f.add(D(z=>{j(z)})),this.f.add(q(z=>{T.deleteAndDispose(z)})),this.event=x.event}dispose(){this.f.dispose()}}t.$Sd=p;class M{constructor(){this.f=[]}wrapEvent(y){return(D,q,I)=>y(x=>{const T=this.f[this.f.length-1];T?T.push(()=>D.call(q,x)):D.call(q,x)},void 0,I)}bufferEvents(y){const D=[];this.f.push(D);const q=y();return this.f.pop(),D.forEach(I=>I()),q}}t.$Td=M;class P{constructor(){this.f=!1,this.g=s.None,this.h=r.$Qc.None,this.j=new o({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(y){this.g=y,this.f&&(this.h.dispose(),this.h=y(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}t.$Ud=P}),te(ie[24],se([0,1,11]),function(O,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Vd=t.CancellationToken=void 0;const _=Object.freeze(function(d,l){const s=setTimeout(d.bind(l),0);return{dispose(){clearTimeout(s)}}});var r;(function(d){function l(s){return s===d.None||s===d.Cancelled||s instanceof c?!0:!s||typeof s!="object"?!1:typeof s.isCancellationRequested=="boolean"&&typeof s.onCancellationRequested=="function"}d.isCancellationToken=l,d.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:k.Event.None}),d.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:_})})(r||(t.CancellationToken=r={}));class c{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?_:(this.b||(this.b=new k.$Ld),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class L{constructor(l){this.f=void 0,this.g=void 0,this.g=l&&l.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new c),this.f}cancel(){this.f?this.f instanceof c&&this.f.cancel():this.f=r.Cancelled}dispose(l=!1){l&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof c&&this.f.dispose():this.f=r.None}}t.$Vd=L}),te(ie[41],se([0,1,24]),function(O,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$we=t.$ve=t.$ue=void 0;class _{constructor(d){this.b=d,this.a=null}get(){if(this.a)return this.a;const d=new k.$Vd,l=this.b(d.token);return this.a={promise:l,dispose:()=>{this.a=null,d.cancel(),d.dispose()}},this.a}}t.$ue=_;class r{constructor(d){this.c=d,this.a=void 0,this.b=void 0}get(d){const l=JSON.stringify(d);return this.b!==l&&(this.b=l,this.a=this.c(d)),this.a}}t.$ve=r;class c{get cachedValues(){return this.a}constructor(d){this.b=d,this.a=new Map}get(d){if(this.a.has(d))return this.a.get(d);const l=this.b(d);return this.a.set(d,l),l}}t.$we=c}),te(ie[7],se([0,1,41,38]),function(O,t,k,_){"use strict";var r;Object.defineProperty(t,"__esModule",{value:!0}),t.$vf=t.$uf=t.$tf=t.$sf=t.GraphemeBreakType=t.$rf=t.$qf=t.$pf=t.$of=t.$nf=t.$mf=t.$lf=t.$kf=t.$jf=t.$if=t.$hf=t.$gf=t.$ff=t.$ef=t.$df=t.$cf=t.$bf=t.$af=t.$_e=t.$$e=t.$0e=t.$9e=t.$8e=t.$7e=t.$6e=t.$5e=t.$4e=t.$3e=t.$2e=t.$1e=t.$Ze=t.$Ye=t.$Xe=t.$We=t.$Ve=t.$Ue=t.$Te=t.$Se=t.$Re=t.$Qe=t.$Pe=t.$Oe=t.$Ne=t.$Me=t.$Le=t.$Ke=t.$Je=t.$Ie=t.$He=t.$Ge=t.$Fe=t.$Ee=t.$De=t.$Ce=t.$Be=t.$Ae=t.$ze=void 0;function c(S){return!S||typeof S!="string"?!0:S.trim().length===0}t.$ze=c;const L=/{(\d+)}/g;function d(S,...B){return B.length===0?S:S.replace(L,function(H,Z){const ue=parseInt(Z,10);return isNaN(ue)||ue<0||ue>=B.length?H:B[ue]})}t.$Ae=d;const l=/{([^}]+)}/g;function s(S,B){return S.replace(l,(H,Z)=>B[Z]??H)}t.$Be=s;function g(S){return S.replace(/[<>&]/g,function(B){switch(B){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return B}})}t.$Ce=g;function A(S){return S.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}t.$De=A;function m(S,B){let H=0;const Z=B.charCodeAt(0);for(let ue=S.length-1;ue>=0;ue--)S.charCodeAt(ue)===Z&&H++;return H}t.$Ee=m;function b(S,B,H="\u2026"){return S.length<=B?S:`${S.substr(0,B)}${H}`}t.$Fe=b;function e(S,B=" "){const H=w(S,B);return R(H,B)}t.$Ge=e;function w(S,B){if(!S||!B)return S;const H=B.length;if(H===0||S.length===0)return S;let Z=0;for(;S.indexOf(B,Z)===Z;)Z=Z+H;return S.substring(Z)}t.$He=w;function R(S,B){if(!S||!B)return S;const H=B.length,Z=S.length;if(H===0||Z===0)return S;let ue=Z,ae=-1;for(;ae=S.lastIndexOf(B,ue-1),!(ae===-1||ae+H!==ue);){if(ae===0)return"";ue=ae}return S.substring(0,ue)}t.$Ie=R;function E(S){return S.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}t.$Je=E;function h(S){return S.replace(/\*/g,"")}t.$Ke=h;function o(S,B,H={}){if(!S)throw new Error("Cannot create regex from empty string");B||(S=A(S)),H.wholeWord&&(/\B/.test(S.charAt(0))||(S="\\b"+S),/\B/.test(S.charAt(S.length-1))||(S=S+"\\b"));let Z="";return H.global&&(Z+="g"),H.matchCase||(Z+="i"),H.multiline&&(Z+="m"),H.unicode&&(Z+="u"),new RegExp(S,Z)}t.$Le=o;function f(S){return S.source==="^"||S.source==="^$"||S.source==="$"||S.source==="^\\s*$"?!1:!!(S.exec("")&&S.lastIndex===0)}t.$Me=f;function u(S){return S.split(/\r\n|\r|\n/)}t.$Ne=u;function i(S){for(let B=0,H=S.length;B<H;B++){const Z=S.charCodeAt(B);if(Z!==32&&Z!==9)return B}return-1}t.$Oe=i;function a(S,B=0,H=S.length){for(let Z=B;Z<H;Z++){const ue=S.charCodeAt(Z);if(ue!==32&&ue!==9)return S.substring(B,Z)}return S.substring(B,H)}t.$Pe=a;function N(S,B=S.length-1){for(let H=B;H>=0;H--){const Z=S.charCodeAt(H);if(Z!==32&&Z!==9)return H}return-1}t.$Qe=N;function $(S,B,H){const Z=[];let ue=0;for(const ae of S.matchAll(B)){if(Z.push(S.slice(ue,ae.index)),ae.index===void 0)throw new Error("match.index should be defined");ue=ae.index+ae[0].length,Z.push(H(ae[0],...ae.slice(1),ae.index,S,ae.groups))}return Z.push(S.slice(ue)),Promise.all(Z).then(ae=>ae.join(""))}t.$Re=$;function v(S,B){return S<B?-1:S>B?1:0}t.$Se=v;function p(S,B,H=0,Z=S.length,ue=0,ae=B.length){for(;H<Z&&ue<ae;H++,ue++){const Re=S.charCodeAt(H),fe=B.charCodeAt(ue);if(Re<fe)return-1;if(Re>fe)return 1}const ge=Z-H,Pe=ae-ue;return ge<Pe?-1:ge>Pe?1:0}t.$Te=p;function M(S,B){return P(S,B,0,S.length,0,B.length)}t.$Ue=M;function P(S,B,H=0,Z=S.length,ue=0,ae=B.length){for(;H<Z&&ue<ae;H++,ue++){let Re=S.charCodeAt(H),fe=B.charCodeAt(ue);if(Re===fe)continue;if(Re>=128||fe>=128)return p(S.toLowerCase(),B.toLowerCase(),H,Z,ue,ae);y(Re)&&(Re-=32),y(fe)&&(fe-=32);const Le=Re-fe;if(Le!==0)return Le}const ge=Z-H,Pe=ae-ue;return ge<Pe?-1:ge>Pe?1:0}t.$Ve=P;function F(S){return S>=48&&S<=57}t.$We=F;function y(S){return S>=97&&S<=122}t.$Xe=y;function D(S){return S>=65&&S<=90}t.$Ye=D;function q(S,B){return S.length===B.length&&P(S,B)===0}t.$Ze=q;function I(S,B){const H=B.length;return B.length>S.length?!1:P(S,B,0,H)===0}t.$1e=I;function x(S,B){const H=Math.min(S.length,B.length);let Z;for(Z=0;Z<H;Z++)if(S.charCodeAt(Z)!==B.charCodeAt(Z))return Z;return H}t.$2e=x;function T(S,B){const H=Math.min(S.length,B.length);let Z;const ue=S.length-1,ae=B.length-1;for(Z=0;Z<H;Z++)if(S.charCodeAt(ue-Z)!==B.charCodeAt(ae-Z))return Z;return H}t.$3e=T;function j(S){return 55296<=S&&S<=56319}t.$4e=j;function z(S){return 56320<=S&&S<=57343}t.$5e=z;function C(S,B){return(S-55296<<10)+(B-56320)+65536}t.$6e=C;function X(S,B,H){const Z=S.charCodeAt(H);if(j(Z)&&H+1<B){const ue=S.charCodeAt(H+1);if(z(ue))return C(Z,ue)}return Z}t.$7e=X;function n(S,B){const H=S.charCodeAt(B-1);if(z(H)&&B>1){const Z=S.charCodeAt(B-2);if(j(Z))return C(Z,H)}return H}class ne{get offset(){return this.e}constructor(B,H=0){this.c=B,this.d=B.length,this.e=H}setOffset(B){this.e=B}prevCodePoint(){const B=n(this.c,this.e);return this.e-=B>=65536?2:1,B}nextCodePoint(){const B=X(this.c,this.d,this.e);return this.e+=B>=65536?2:1,B}eol(){return this.e>=this.d}}t.$8e=ne;class oe{get offset(){return this.c.offset}constructor(B,H=0){this.c=new ne(B,H)}nextGraphemeLength(){const B=$e.getInstance(),H=this.c,Z=H.offset;let ue=B.getGraphemeBreakType(H.nextCodePoint());for(;!H.eol();){const ae=H.offset,ge=B.getGraphemeBreakType(H.nextCodePoint());if(pe(ue,ge)){H.setOffset(ae);break}ue=ge}return H.offset-Z}prevGraphemeLength(){const B=$e.getInstance(),H=this.c,Z=H.offset;let ue=B.getGraphemeBreakType(H.prevCodePoint());for(;H.offset>0;){const ae=H.offset,ge=B.getGraphemeBreakType(H.prevCodePoint());if(pe(ge,ue)){H.setOffset(ae);break}ue=ge}return Z-H.offset}eol(){return this.c.eol()}}t.$9e=oe;function me(S,B){return new oe(S,B).nextGraphemeLength()}t.$0e=me;function Ne(S,B){return new oe(S,B).prevGraphemeLength()}t.$$e=Ne;function we(S,B){B>0&&z(S.charCodeAt(B))&&B--;const H=B+me(S,B);return[H-Ne(S,H),H]}t.$_e=we;function Ee(S){const B=new oe(S);let H=0;for(;!B.eol();)H++,B.nextGraphemeLength();return H}t.$af=Ee;let ve;function De(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function _e(S){return ve||(ve=De()),ve.test(S)}t.$bf=_e;const Te=/^[\t\n\r\x20-\x7E]*$/;function Se(S){return Te.test(S)}t.$cf=Se,t.$df=/[\u2028\u2029]/;function Ae(S){return t.$df.test(S)}t.$ef=Ae;function U(S){return S>=11904&&S<=55215||S>=63744&&S<=64255||S>=65281&&S<=65374}t.$ff=U;function W(S){return S>=127462&&S<=127487||S===8986||S===8987||S===9200||S===9203||S>=9728&&S<=10175||S===11088||S===11093||S>=127744&&S<=128591||S>=128640&&S<=128764||S>=128992&&S<=129008||S>=129280&&S<=129535||S>=129648&&S<=129782}t.$gf=W;function V(S,B){if(S.length<B)return S;const H=/\b/g;let Z=0;for(;H.test(S)&&!(S.length-H.lastIndex<B);)Z=H.lastIndex,H.lastIndex+=1;return S.substring(Z).replace(/^\s/,"")}t.$hf=V;const Q=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,ee=/\x1b\].*?\x07/g;function G(S){return S&&(S=S.replace(Q,"").replace(ee,"")),S}t.$if=G,t.$jf=String.fromCharCode(65279);function Y(S){return!!(S&&S.length>0&&S.charCodeAt(0)===65279)}t.$kf=Y;function J(S){return Y(S)?S.substr(1):S}t.$lf=J;function K(S,B){if(!S||!B||S.length<B.length)return!1;const H=B.length,Z=S.toLowerCase();let ue=0,ae=-1;for(;ue<H;){const ge=Z.indexOf(B[ue],ae+1);if(ge<0)return!1;ae=ge,ue++}return!0}t.$mf=K;function re(S,B=!1){return S?(B&&(S=S.replace(/\\./g,"")),S.toLowerCase()!==S):!1}t.$nf=re;function le(S){return S.charAt(0).toUpperCase()+S.slice(1)}t.$of=le;function ce(S,B=1){if(B===0)return"";let H=-1;do H=S.indexOf(`
`,H+1),B--;while(B>0&&H>=0);return H===-1?S:(S[H-1]==="\r"&&H--,S.substr(0,H))}t.$pf=ce;function be(S){return S=S%(2*26),S<26?String.fromCharCode(97+S):String.fromCharCode(65+S-26)}t.$qf=be;function de(S){return $e.getInstance().getGraphemeBreakType(S)}t.$rf=de;function pe(S,B){return S===0?B!==5&&B!==7:S===2&&B===3?!1:S===4||S===2||S===3||B===4||B===2||B===3?!0:!(S===8&&(B===8||B===9||B===11||B===12)||(S===11||S===9)&&(B===9||B===10)||(S===12||S===10)&&B===10||B===5||B===13||B===7||S===1||S===13&&B===14||S===6&&B===6)}var ye;(function(S){S[S.Other=0]="Other",S[S.Prepend=1]="Prepend",S[S.CR=2]="CR",S[S.LF=3]="LF",S[S.Control=4]="Control",S[S.Extend=5]="Extend",S[S.Regional_Indicator=6]="Regional_Indicator",S[S.SpacingMark=7]="SpacingMark",S[S.L=8]="L",S[S.V=9]="V",S[S.T=10]="T",S[S.LV=11]="LV",S[S.LVT=12]="LVT",S[S.ZWJ=13]="ZWJ",S[S.Extended_Pictographic=14]="Extended_Pictographic"})(ye||(t.GraphemeBreakType=ye={}));class $e{static getInstance(){return $e.c||($e.c=new $e),$e.c}constructor(){this.d=Ie()}getGraphemeBreakType(B){if(B<32)return B===10?3:B===13?2:4;if(B<127)return 0;const H=this.d,Z=H.length/3;let ue=1;for(;ue<=Z;)if(B<H[3*ue])ue=2*ue;else if(B>H[3*ue+1])ue=2*ue+1;else return H[3*ue+2];return 0}}$e.c=null;function Ie(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Fe(S,B){if(S===0)return 0;const H=Be(S,B);if(H!==void 0)return H;const Z=new ne(B,S);return Z.prevCodePoint(),Z.offset}t.$sf=Fe;function Be(S,B){const H=new ne(B,S);let Z=H.prevCodePoint();for(;Oe(Z)||Z===65039||Z===8419;){if(H.offset===0)return;Z=H.prevCodePoint()}if(!W(Z))return;let ue=H.offset;return ue>0&&H.prevCodePoint()===8205&&(ue=H.offset),ue}function Oe(S){return 127995<=S&&S<=127999}var Ve;(function(S){S[S.zwj=8205]="zwj",S[S.emojiVariantSelector=65039]="emojiVariantSelector",S[S.enclosingKeyCap=8419]="enclosingKeyCap"})(Ve||(Ve={})),t.$tf="\xA0";class qe{static getInstance(B){return r.d.get(Array.from(B))}static getLocales(){return r.e.value}constructor(B){this.f=B}isAmbiguous(B){return this.f.has(B)}getPrimaryConfusable(B){return this.f.get(B)}getConfusableCodePoints(){return new Set(this.f.keys())}}t.$uf=qe,r=qe,qe.c=new _.$T(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),qe.d=new k.$ve(S=>{function B(fe){const Le=new Map;for(let Me=0;Me<fe.length;Me+=2)Le.set(fe[Me],fe[Me+1]);return Le}function H(fe,Le){const Me=new Map(fe);for(const[Ue,je]of Le)Me.set(Ue,je);return Me}function Z(fe,Le){if(!fe)return Le;const Me=new Map;for(const[Ue,je]of fe)Le.has(Ue)&&Me.set(Ue,je);return Me}const ue=r.c.value;let ae=S.filter(fe=>!fe.startsWith("_")&&fe in ue);ae.length===0&&(ae=["_default"]);let ge;for(const fe of ae){const Le=B(ue[fe]);ge=Z(ge,Le)}const Pe=B(ue._common),Re=H(Pe,ge);return new r(Re)}),qe.e=new _.$T(()=>Object.keys(r.c.value).filter(S=>!S.startsWith("_")));class ke{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(ke.c())),this.d}static isInvisibleCharacter(B){return ke.e().has(B)}static get codePoints(){return ke.e()}}t.$vf=ke,ke.d=void 0}),te(ie[42],se([0,1,7]),function(O,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Fi=t.$Ei=t.$Di=t.$Ci=t.$Bi=t.$Ai=t.$zi=void 0;function _(E){return r(E,0)}t.$zi=_;function r(E,h){switch(typeof E){case"object":return E===null?c(349,h):Array.isArray(E)?l(E,h):s(E,h);case"string":return d(E,h);case"boolean":return L(E,h);case"number":return c(E,h);case"undefined":return c(937,h);default:return c(617,h)}}t.$Ai=r;function c(E,h){return(h<<5)-h+E|0}t.$Bi=c;function L(E,h){return c(E?433:863,h)}function d(E,h){h=c(149417,h);for(let o=0,f=E.length;o<f;o++)h=c(E.charCodeAt(o),h);return h}t.$Ci=d;function l(E,h){return h=c(104579,h),E.reduce((o,f)=>r(f,o),h)}function s(E,h){return h=c(181387,h),Object.keys(E).sort().reduce((o,f)=>(o=d(f,o),r(E[f],o)),h)}class g{constructor(){this.g=0}get value(){return this.g}hash(h){return this.g=r(h,this.g),this.g}}t.$Di=g;var A;(function(E){E[E.BLOCK_SIZE=64]="BLOCK_SIZE",E[E.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(A||(A={}));function m(E,h,o=32){const f=o-h,u=~((1<<f)-1);return(E<<h|(u&E)>>>f)>>>0}function b(E,h=0,o=E.byteLength,f=0){for(let u=0;u<o;u++)E[h+u]=f}function e(E,h,o="0"){for(;E.length<h;)E=o+E;return E}function w(E,h=32){return E instanceof ArrayBuffer?Array.from(new Uint8Array(E)).map(o=>o.toString(16).padStart(2,"0")).join(""):e((E>>>0).toString(16),h/4)}t.$Ei=w;class R{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(h){const o=h.length;if(o===0)return;const f=this.p;let u=this.r,i=this.u,a,N;for(i!==0?(a=i,N=-1,i=0):(a=h.charCodeAt(0),N=0);;){let $=a;if(k.$4e(a))if(N+1<o){const v=h.charCodeAt(N+1);k.$5e(v)?(N++,$=k.$6e(a,v)):$=65533}else{i=a;break}else k.$5e(a)&&($=65533);if(u=this.w(f,u,$),N++,N<o)a=h.charCodeAt(N);else break}this.r=u,this.u=i}w(h,o,f){return f<128?h[o++]=f:f<2048?(h[o++]=192|(f&1984)>>>6,h[o++]=128|(f&63)>>>0):f<65536?(h[o++]=224|(f&61440)>>>12,h[o++]=128|(f&4032)>>>6,h[o++]=128|(f&63)>>>0):(h[o++]=240|(f&1835008)>>>18,h[o++]=128|(f&258048)>>>12,h[o++]=128|(f&4032)>>>6,h[o++]=128|(f&63)>>>0),o>=64&&(this.y(),o-=64,this.t+=64,h[0]=h[64+0],h[1]=h[64+1],h[2]=h[64+2]),o}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),w(this.h)+w(this.l)+w(this.m)+w(this.n)+w(this.o)}x(){this.p[this.r++]=128,b(this.p,this.r),this.r>56&&(this.y(),b(this.p));const h=8*this.t;this.q.setUint32(56,Math.floor(h/4294967296),!1),this.q.setUint32(60,h%4294967296,!1),this.y()}y(){const h=R.g,o=this.q;for(let M=0;M<64;M+=4)h.setUint32(M,o.getUint32(M,!1),!1);for(let M=64;M<320;M+=4)h.setUint32(M,m(h.getUint32(M-12,!1)^h.getUint32(M-32,!1)^h.getUint32(M-56,!1)^h.getUint32(M-64,!1),1),!1);let f=this.h,u=this.l,i=this.m,a=this.n,N=this.o,$,v,p;for(let M=0;M<80;M++)M<20?($=u&i|~u&a,v=1518500249):M<40?($=u^i^a,v=1859775393):M<60?($=u&i|u&a|i&a,v=2400959708):($=u^i^a,v=3395469782),p=m(f,5)+$+N+v+h.getUint32(M*4,!1)&4294967295,N=a,a=i,i=m(u,30),u=f,f=p;this.h=this.h+f&4294967295,this.l=this.l+u&4294967295,this.m=this.m+i&4294967295,this.n=this.n+a&4294967295,this.o=this.o+N&4294967295}}t.$Fi=R,R.g=new DataView(new ArrayBuffer(320))}),te(ie[25],se([0,1,36,42]),function(O,t,k,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ss=t.$rs=t.$qs=void 0;class r{constructor(m){this.a=m}getElements(){const m=this.a,b=new Int32Array(m.length);for(let e=0,w=m.length;e<w;e++)b[e]=m.charCodeAt(e);return b}}t.$qs=r;function c(A,m,b){return new g(new r(A),new r(m)).ComputeDiff(b).changes}t.$rs=c;class L{static Assert(m,b){if(!m)throw new Error(b)}}class d{static Copy(m,b,e,w,R){for(let E=0;E<R;E++)e[w+E]=m[b+E]}static Copy2(m,b,e,w,R){for(let E=0;E<R;E++)e[w+E]=m[b+E]}}var l;(function(A){A[A.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(l||(l={}));class s{constructor(){this.a=[],this.b=1073741824,this.c=1073741824,this.d=0,this.e=0}MarkNextChange(){(this.d>0||this.e>0)&&this.a.push(new k.$ps(this.b,this.d,this.c,this.e)),this.d=0,this.e=0,this.b=1073741824,this.c=1073741824}AddOriginalElement(m,b){this.b=Math.min(this.b,m),this.c=Math.min(this.c,b),this.d++}AddModifiedElement(m,b){this.b=Math.min(this.b,m),this.c=Math.min(this.c,b),this.e++}getChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a}getReverseChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a.reverse(),this.a}}class g{constructor(m,b,e=null){this.a=e,this.b=m,this.c=b;const[w,R,E]=g.o(m),[h,o,f]=g.o(b);this.d=E&&f,this.e=w,this.f=R,this.g=h,this.h=o,this.k=[],this.m=[]}static n(m){return m.length>0&&typeof m[0]=="string"}static o(m){const b=m.getElements();if(g.n(b)){const e=new Int32Array(b.length);for(let w=0,R=b.length;w<R;w++)e[w]=(0,_.$Ci)(b[w],0);return[b,e,!0]}return b instanceof Int32Array?[[],b,!1]:[[],new Int32Array(b),!1]}p(m,b){return this.f[m]!==this.h[b]?!1:this.d?this.e[m]===this.g[b]:!0}q(m,b){if(!this.p(m,b))return!1;const e=g.r(this.b,m),w=g.r(this.c,b);return e===w}static r(m,b){return typeof m.getStrictElement=="function"?m.getStrictElement(b):null}s(m,b){return this.f[m]!==this.f[b]?!1:this.d?this.e[m]===this.e[b]:!0}u(m,b){return this.h[m]!==this.h[b]?!1:this.d?this.g[m]===this.g[b]:!0}ComputeDiff(m){return this.v(0,this.f.length-1,0,this.h.length-1,m)}v(m,b,e,w,R){const E=[!1];let h=this.w(m,b,e,w,E);return R&&(h=this.z(h)),{quitEarly:E[0],changes:h}}w(m,b,e,w,R){for(R[0]=!1;m<=b&&e<=w&&this.p(m,e);)m++,e++;for(;b>=m&&w>=e&&this.p(b,w);)b--,w--;if(m>b||e>w){let i;return e<=w?(L.Assert(m===b+1,"originalStart should only be one more than originalEnd"),i=[new k.$ps(m,0,e,w-e+1)]):m<=b?(L.Assert(e===w+1,"modifiedStart should only be one more than modifiedEnd"),i=[new k.$ps(m,b-m+1,e,0)]):(L.Assert(m===b+1,"originalStart should only be one more than originalEnd"),L.Assert(e===w+1,"modifiedStart should only be one more than modifiedEnd"),i=[]),i}const E=[0],h=[0],o=this.y(m,b,e,w,E,h,R),f=E[0],u=h[0];if(o!==null)return o;if(!R[0]){const i=this.w(m,f,e,u,R);let a=[];return R[0]?a=[new k.$ps(f+1,b-(f+1)+1,u+1,w-(u+1)+1)]:a=this.w(f+1,b,u+1,w,R),this.H(i,a)}return[new k.$ps(m,b-m+1,e,w-e+1)]}x(m,b,e,w,R,E,h,o,f,u,i,a,N,$,v,p,M,P){let F=null,y=null,D=new s,q=b,I=e,x=N[0]-p[0]-w,T=-1073741824,j=this.k.length-1;do{const z=x+m;z===q||z<I&&f[z-1]<f[z+1]?(i=f[z+1],$=i-x-w,i<T&&D.MarkNextChange(),T=i,D.AddModifiedElement(i+1,$),x=z+1-m):(i=f[z-1]+1,$=i-x-w,i<T&&D.MarkNextChange(),T=i-1,D.AddOriginalElement(i,$+1),x=z-1-m),j>=0&&(f=this.k[j],m=f[0],q=1,I=f.length-1)}while(--j>=-1);if(F=D.getReverseChanges(),P[0]){let z=N[0]+1,C=p[0]+1;if(F!==null&&F.length>0){const X=F[F.length-1];z=Math.max(z,X.getOriginalEnd()),C=Math.max(C,X.getModifiedEnd())}y=[new k.$ps(z,a-z+1,C,v-C+1)]}else{D=new s,q=E,I=h,x=N[0]-p[0]-o,T=1073741824,j=M?this.m.length-1:this.m.length-2;do{const z=x+R;z===q||z<I&&u[z-1]>=u[z+1]?(i=u[z+1]-1,$=i-x-o,i>T&&D.MarkNextChange(),T=i+1,D.AddOriginalElement(i+1,$+1),x=z+1-R):(i=u[z-1],$=i-x-o,i>T&&D.MarkNextChange(),T=i,D.AddModifiedElement(i+1,$+1),x=z-1-R),j>=0&&(u=this.m[j],R=u[0],q=1,I=u.length-1)}while(--j>=-1);y=D.getChanges()}return this.H(F,y)}y(m,b,e,w,R,E,h){let o=0,f=0,u=0,i=0,a=0,N=0;m--,e--,R[0]=0,E[0]=0,this.k=[],this.m=[];const $=b-m+(w-e),v=$+1,p=new Int32Array(v),M=new Int32Array(v),P=w-e,F=b-m,y=m-e,D=b-w,I=(F-P)%2===0;p[P]=m,M[F]=b,h[0]=!1;for(let x=1;x<=$/2+1;x++){let T=0,j=0;u=this.J(P-x,x,P,v),i=this.J(P+x,x,P,v);for(let C=u;C<=i;C+=2){C===u||C<i&&p[C-1]<p[C+1]?o=p[C+1]:o=p[C-1]+1,f=o-(C-P)-y;const X=o;for(;o<b&&f<w&&this.p(o+1,f+1);)o++,f++;if(p[C]=o,o+f>T+j&&(T=o,j=f),!I&&Math.abs(C-F)<=x-1&&o>=M[C])return R[0]=o,E[0]=f,X<=M[C]&&1447>0&&x<=1447+1?this.x(P,u,i,y,F,a,N,D,p,M,o,b,R,f,w,E,I,h):null}const z=(T-m+(j-e)-x)/2;if(this.a!==null&&!this.a(T,z))return h[0]=!0,R[0]=T,E[0]=j,z>0&&1447>0&&x<=1447+1?this.x(P,u,i,y,F,a,N,D,p,M,o,b,R,f,w,E,I,h):(m++,e++,[new k.$ps(m,b-m+1,e,w-e+1)]);a=this.J(F-x,x,F,v),N=this.J(F+x,x,F,v);for(let C=a;C<=N;C+=2){C===a||C<N&&M[C-1]>=M[C+1]?o=M[C+1]-1:o=M[C-1],f=o-(C-F)-D;const X=o;for(;o>m&&f>e&&this.p(o,f);)o--,f--;if(M[C]=o,I&&Math.abs(C-P)<=x&&o<=p[C])return R[0]=o,E[0]=f,X>=p[C]&&1447>0&&x<=1447+1?this.x(P,u,i,y,F,a,N,D,p,M,o,b,R,f,w,E,I,h):null}if(x<=1447){let C=new Int32Array(i-u+2);C[0]=P-u+1,d.Copy2(p,u,C,1,i-u+1),this.k.push(C),C=new Int32Array(N-a+2),C[0]=F-a+1,d.Copy2(M,a,C,1,N-a+1),this.m.push(C)}}return this.x(P,u,i,y,F,a,N,D,p,M,o,b,R,f,w,E,I,h)}z(m){for(let b=0;b<m.length;b++){const e=m[b],w=b<m.length-1?m[b+1].originalStart:this.f.length,R=b<m.length-1?m[b+1].modifiedStart:this.h.length,E=e.originalLength>0,h=e.modifiedLength>0;for(;e.originalStart+e.originalLength<w&&e.modifiedStart+e.modifiedLength<R&&(!E||this.s(e.originalStart,e.originalStart+e.originalLength))&&(!h||this.u(e.modifiedStart,e.modifiedStart+e.modifiedLength));){const f=this.q(e.originalStart,e.modifiedStart);if(this.q(e.originalStart+e.originalLength,e.modifiedStart+e.modifiedLength)&&!f)break;e.originalStart++,e.modifiedStart++}const o=[null];if(b<m.length-1&&this.I(m[b],m[b+1],o)){m[b]=o[0],m.splice(b+1,1),b--;continue}}for(let b=m.length-1;b>=0;b--){const e=m[b];let w=0,R=0;if(b>0){const i=m[b-1];w=i.originalStart+i.originalLength,R=i.modifiedStart+i.modifiedLength}const E=e.originalLength>0,h=e.modifiedLength>0;let o=0,f=this.G(e.originalStart,e.originalLength,e.modifiedStart,e.modifiedLength);for(let i=1;;i++){const a=e.originalStart-i,N=e.modifiedStart-i;if(a<w||N<R||E&&!this.s(a,a+e.originalLength)||h&&!this.u(N,N+e.modifiedLength))break;const v=(a===w&&N===R?5:0)+this.G(a,e.originalLength,N,e.modifiedLength);v>f&&(f=v,o=i)}e.originalStart-=o,e.modifiedStart-=o;const u=[null];if(b>0&&this.I(m[b-1],m[b],u)){m[b-1]=u[0],m.splice(b,1),b++;continue}}if(this.d)for(let b=1,e=m.length;b<e;b++){const w=m[b-1],R=m[b],E=R.originalStart-w.originalStart-w.originalLength,h=w.originalStart,o=R.originalStart+R.originalLength,f=o-h,u=w.modifiedStart,i=R.modifiedStart+R.modifiedLength,a=i-u;if(E<5&&f<20&&a<20){const N=this.A(h,f,u,a,E);if(N){const[$,v]=N;($!==w.originalStart+w.originalLength||v!==w.modifiedStart+w.modifiedLength)&&(w.originalLength=$-w.originalStart,w.modifiedLength=v-w.modifiedStart,R.originalStart=$+E,R.modifiedStart=v+E,R.originalLength=o-R.originalStart,R.modifiedLength=i-R.modifiedStart)}}}return m}A(m,b,e,w,R){if(b<R||w<R)return null;const E=m+b-R+1,h=e+w-R+1;let o=0,f=0,u=0;for(let i=m;i<E;i++)for(let a=e;a<h;a++){const N=this.B(i,a,R);N>0&&N>o&&(o=N,f=i,u=a)}return o>0?[f,u]:null}B(m,b,e){let w=0;for(let R=0;R<e;R++){if(!this.p(m+R,b+R))return 0;w+=this.e[m+R].length}return w}C(m){return m<=0||m>=this.f.length-1?!0:this.d&&/^\s*$/.test(this.e[m])}D(m,b){if(this.C(m)||this.C(m-1))return!0;if(b>0){const e=m+b;if(this.C(e-1)||this.C(e))return!0}return!1}E(m){return m<=0||m>=this.h.length-1?!0:this.d&&/^\s*$/.test(this.g[m])}F(m,b){if(this.E(m)||this.E(m-1))return!0;if(b>0){const e=m+b;if(this.E(e-1)||this.E(e))return!0}return!1}G(m,b,e,w){const R=this.D(m,b)?1:0,E=this.F(e,w)?1:0;return R+E}H(m,b){const e=[];if(m.length===0||b.length===0)return b.length>0?b:m;if(this.I(m[m.length-1],b[0],e)){const w=new Array(m.length+b.length-1);return d.Copy(m,0,w,0,m.length-1),w[m.length-1]=e[0],d.Copy(b,1,w,m.length,b.length-1),w}else{const w=new Array(m.length+b.length);return d.Copy(m,0,w,0,m.length),d.Copy(b,0,w,m.length,b.length),w}}I(m,b,e){if(L.Assert(m.originalStart<=b.originalStart,"Left change is not less than or equal to right change"),L.Assert(m.modifiedStart<=b.modifiedStart,"Left change is not less than or equal to right change"),m.originalStart+m.originalLength>=b.originalStart||m.modifiedStart+m.modifiedLength>=b.modifiedStart){const w=m.originalStart;let R=m.originalLength;const E=m.modifiedStart;let h=m.modifiedLength;return m.originalStart+m.originalLength>=b.originalStart&&(R=b.originalStart+b.originalLength-m.originalStart),m.modifiedStart+m.modifiedLength>=b.modifiedStart&&(h=b.modifiedStart+b.modifiedLength-m.modifiedStart),e[0]=new k.$ps(w,R,E,h),!0}else return e[0]=null,!1}J(m,b,e,w){if(m>=0&&m<w)return m;const R=e,E=w-e-1,h=b%2===0;if(m<0){const o=R%2===0;return h===o?0:1}else{const o=E%2===0;return h===o?w-1:w-2}}}t.$ss=g}),te(ie[26],se([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Nf=t.$Mf=t.$Lf=t.$Kf=t.$Jf=t.$If=t.$Hf=t.$Gf=t.$Ff=t.$Ef=t.$Df=t.$Cf=t.$Bf=t.$Af=t.$zf=t.$yf=t.$xf=t.$wf=void 0;function k(u){return typeof u=="string"}t.$wf=k;function _(u){return Array.isArray(u)&&u.every(i=>k(i))}t.$xf=_;function r(u){return typeof u=="object"&&u!==null&&!Array.isArray(u)&&!(u instanceof RegExp)&&!(u instanceof Date)}t.$yf=r;function c(u){const i=Object.getPrototypeOf(Uint8Array);return typeof u=="object"&&u instanceof i}t.$zf=c;function L(u){return typeof u=="number"&&!isNaN(u)}t.$Af=L;function d(u){return!!u&&typeof u[Symbol.iterator]=="function"}t.$Bf=d;function l(u){return u===!0||u===!1}t.$Cf=l;function s(u){return typeof u>"u"}t.$Df=s;function g(u){return!A(u)}t.$Ef=g;function A(u){return s(u)||u===null}t.$Ff=A;function m(u,i){if(!u)throw new Error(i?`Unexpected type, expected '${i}'`:"Unexpected type")}t.$Gf=m;function b(u){if(A(u))throw new Error("Assertion Failed: argument is undefined or null");return u}t.$Hf=b;function e(...u){const i=[];for(let a=0;a<u.length;a++){const N=u[a];if(A(N))throw new Error(`Assertion Failed: argument at index ${a} is undefined or null`);i.push(N)}return i}t.$If=e;const w=Object.prototype.hasOwnProperty;function R(u){if(!r(u))return!1;for(const i in u)if(w.call(u,i))return!1;return!0}t.$Jf=R;function E(u){return typeof u=="function"}t.$Kf=E;function h(...u){return u.length>0&&u.every(E)}t.$Lf=h;function o(u,i){const a=Math.min(u.length,i.length);for(let N=0;N<a;N++)f(u[N],i[N])}t.$Mf=o;function f(u,i){if(k(i)){if(typeof u!==i)throw new Error(`argument does not match constraint: typeof ${i}`)}else if(E(i)){try{if(u instanceof i)return}catch{}if(!A(u)&&u.constructor===i||i.length===1&&i.call(void 0,u)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}t.$Nf=f}),te(ie[43],se([0,1,26]),function(O,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Qj=t.$Pj=t.$Oj=void 0;const _=Object.create(null);function r(d,l){if((0,k.$wf)(l)){const s=_[l];if(s===void 0)throw new Error(`${d} references an unknown codicon: ${l}`);l=s}return _[d]=l,{id:d}}function c(){return _}t.$Oj=c;function L(){return Object.values(t.$Qj)}t.$Pj=L,t.$Qj={add:r("add",6e4),plus:r("plus",6e4),gistNew:r("gist-new",6e4),repoCreate:r("repo-create",6e4),lightbulb:r("lightbulb",60001),lightBulb:r("light-bulb",60001),repo:r("repo",60002),repoDelete:r("repo-delete",60002),gistFork:r("gist-fork",60003),repoForked:r("repo-forked",60003),gitPullRequest:r("git-pull-request",60004),gitPullRequestAbandoned:r("git-pull-request-abandoned",60004),recordKeys:r("record-keys",60005),keyboard:r("keyboard",60005),tag:r("tag",60006),tagAdd:r("tag-add",60006),tagRemove:r("tag-remove",60006),gitPullRequestLabel:r("git-pull-request-label",60006),person:r("person",60007),personFollow:r("person-follow",60007),personOutline:r("person-outline",60007),personFilled:r("person-filled",60007),gitBranch:r("git-branch",60008),gitBranchCreate:r("git-branch-create",60008),gitBranchDelete:r("git-branch-delete",60008),sourceControl:r("source-control",60008),mirror:r("mirror",60009),mirrorPublic:r("mirror-public",60009),star:r("star",60010),starAdd:r("star-add",60010),starDelete:r("star-delete",60010),starEmpty:r("star-empty",60010),comment:r("comment",60011),commentAdd:r("comment-add",60011),alert:r("alert",60012),warning:r("warning",60012),search:r("search",60013),searchSave:r("search-save",60013),logOut:r("log-out",60014),signOut:r("sign-out",60014),logIn:r("log-in",60015),signIn:r("sign-in",60015),eye:r("eye",60016),eyeUnwatch:r("eye-unwatch",60016),eyeWatch:r("eye-watch",60016),circleFilled:r("circle-filled",60017),primitiveDot:r("primitive-dot",60017),closeDirty:r("close-dirty",60017),debugBreakpoint:r("debug-breakpoint",60017),debugBreakpointDisabled:r("debug-breakpoint-disabled",60017),debugHint:r("debug-hint",60017),primitiveSquare:r("primitive-square",60018),edit:r("edit",60019),pencil:r("pencil",60019),info:r("info",60020),issueOpened:r("issue-opened",60020),gistPrivate:r("gist-private",60021),gitForkPrivate:r("git-fork-private",60021),lock:r("lock",60021),mirrorPrivate:r("mirror-private",60021),close:r("close",60022),removeClose:r("remove-close",60022),x:r("x",60022),repoSync:r("repo-sync",60023),sync:r("sync",60023),clone:r("clone",60024),desktopDownload:r("desktop-download",60024),beaker:r("beaker",60025),microscope:r("microscope",60025),vm:r("vm",60026),deviceDesktop:r("device-desktop",60026),file:r("file",60027),fileText:r("file-text",60027),more:r("more",60028),ellipsis:r("ellipsis",60028),kebabHorizontal:r("kebab-horizontal",60028),mailReply:r("mail-reply",60029),reply:r("reply",60029),organization:r("organization",60030),organizationFilled:r("organization-filled",60030),organizationOutline:r("organization-outline",60030),newFile:r("new-file",60031),fileAdd:r("file-add",60031),newFolder:r("new-folder",60032),fileDirectoryCreate:r("file-directory-create",60032),trash:r("trash",60033),trashcan:r("trashcan",60033),history:r("history",60034),clock:r("clock",60034),folder:r("folder",60035),fileDirectory:r("file-directory",60035),symbolFolder:r("symbol-folder",60035),logoGithub:r("logo-github",60036),markGithub:r("mark-github",60036),github:r("github",60036),terminal:r("terminal",60037),console:r("console",60037),repl:r("repl",60037),zap:r("zap",60038),symbolEvent:r("symbol-event",60038),error:r("error",60039),stop:r("stop",60039),variable:r("variable",60040),symbolVariable:r("symbol-variable",60040),array:r("array",60042),symbolArray:r("symbol-array",60042),symbolModule:r("symbol-module",60043),symbolPackage:r("symbol-package",60043),symbolNamespace:r("symbol-namespace",60043),symbolObject:r("symbol-object",60043),symbolMethod:r("symbol-method",60044),symbolFunction:r("symbol-function",60044),symbolConstructor:r("symbol-constructor",60044),symbolBoolean:r("symbol-boolean",60047),symbolNull:r("symbol-null",60047),symbolNumeric:r("symbol-numeric",60048),symbolNumber:r("symbol-number",60048),symbolStructure:r("symbol-structure",60049),symbolStruct:r("symbol-struct",60049),symbolParameter:r("symbol-parameter",60050),symbolTypeParameter:r("symbol-type-parameter",60050),symbolKey:r("symbol-key",60051),symbolText:r("symbol-text",60051),symbolReference:r("symbol-reference",60052),goToFile:r("go-to-file",60052),symbolEnum:r("symbol-enum",60053),symbolValue:r("symbol-value",60053),symbolRuler:r("symbol-ruler",60054),symbolUnit:r("symbol-unit",60054),activateBreakpoints:r("activate-breakpoints",60055),archive:r("archive",60056),arrowBoth:r("arrow-both",60057),arrowDown:r("arrow-down",60058),arrowLeft:r("arrow-left",60059),arrowRight:r("arrow-right",60060),arrowSmallDown:r("arrow-small-down",60061),arrowSmallLeft:r("arrow-small-left",60062),arrowSmallRight:r("arrow-small-right",60063),arrowSmallUp:r("arrow-small-up",60064),arrowUp:r("arrow-up",60065),bell:r("bell",60066),bold:r("bold",60067),book:r("book",60068),bookmark:r("bookmark",60069),debugBreakpointConditionalUnverified:r("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:r("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:r("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:r("debug-breakpoint-data-unverified",60072),debugBreakpointData:r("debug-breakpoint-data",60073),debugBreakpointDataDisabled:r("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:r("debug-breakpoint-log-unverified",60074),debugBreakpointLog:r("debug-breakpoint-log",60075),debugBreakpointLogDisabled:r("debug-breakpoint-log-disabled",60075),briefcase:r("briefcase",60076),broadcast:r("broadcast",60077),browser:r("browser",60078),bug:r("bug",60079),calendar:r("calendar",60080),caseSensitive:r("case-sensitive",60081),check:r("check",60082),checklist:r("checklist",60083),chevronDown:r("chevron-down",60084),dropDownButton:r("drop-down-button",60084),chevronLeft:r("chevron-left",60085),chevronRight:r("chevron-right",60086),chevronUp:r("chevron-up",60087),chromeClose:r("chrome-close",60088),chromeMaximize:r("chrome-maximize",60089),chromeMinimize:r("chrome-minimize",60090),chromeRestore:r("chrome-restore",60091),circle:r("circle",60092),circleOutline:r("circle-outline",60092),debugBreakpointUnverified:r("debug-breakpoint-unverified",60092),circleSlash:r("circle-slash",60093),circuitBoard:r("circuit-board",60094),clearAll:r("clear-all",60095),clippy:r("clippy",60096),closeAll:r("close-all",60097),cloudDownload:r("cloud-download",60098),cloudUpload:r("cloud-upload",60099),code:r("code",60100),collapseAll:r("collapse-all",60101),colorMode:r("color-mode",60102),commentDiscussion:r("comment-discussion",60103),compareChanges:r("compare-changes",60157),creditCard:r("credit-card",60105),dash:r("dash",60108),dashboard:r("dashboard",60109),database:r("database",60110),debugContinue:r("debug-continue",60111),debugDisconnect:r("debug-disconnect",60112),debugPause:r("debug-pause",60113),debugRestart:r("debug-restart",60114),debugStart:r("debug-start",60115),debugStepInto:r("debug-step-into",60116),debugStepOut:r("debug-step-out",60117),debugStepOver:r("debug-step-over",60118),debugStop:r("debug-stop",60119),debug:r("debug",60120),deviceCameraVideo:r("device-camera-video",60121),deviceCamera:r("device-camera",60122),deviceMobile:r("device-mobile",60123),diffAdded:r("diff-added",60124),diffIgnored:r("diff-ignored",60125),diffModified:r("diff-modified",60126),diffRemoved:r("diff-removed",60127),diffRenamed:r("diff-renamed",60128),diff:r("diff",60129),discard:r("discard",60130),editorLayout:r("editor-layout",60131),emptyWindow:r("empty-window",60132),exclude:r("exclude",60133),extensions:r("extensions",60134),eyeClosed:r("eye-closed",60135),fileBinary:r("file-binary",60136),fileCode:r("file-code",60137),fileMedia:r("file-media",60138),filePdf:r("file-pdf",60139),fileSubmodule:r("file-submodule",60140),fileSymlinkDirectory:r("file-symlink-directory",60141),fileSymlinkFile:r("file-symlink-file",60142),fileZip:r("file-zip",60143),files:r("files",60144),filter:r("filter",60145),flame:r("flame",60146),foldDown:r("fold-down",60147),foldUp:r("fold-up",60148),fold:r("fold",60149),folderActive:r("folder-active",60150),folderOpened:r("folder-opened",60151),gear:r("gear",60152),gift:r("gift",60153),gistSecret:r("gist-secret",60154),gist:r("gist",60155),gitCommit:r("git-commit",60156),gitCompare:r("git-compare",60157),gitMerge:r("git-merge",60158),githubAction:r("github-action",60159),githubAlt:r("github-alt",60160),globe:r("globe",60161),grabber:r("grabber",60162),graph:r("graph",60163),gripper:r("gripper",60164),heart:r("heart",60165),home:r("home",60166),horizontalRule:r("horizontal-rule",60167),hubot:r("hubot",60168),inbox:r("inbox",60169),issueClosed:r("issue-closed",60324),issueReopened:r("issue-reopened",60171),issues:r("issues",60172),italic:r("italic",60173),jersey:r("jersey",60174),json:r("json",60175),bracket:r("bracket",60175),kebabVertical:r("kebab-vertical",60176),key:r("key",60177),law:r("law",60178),lightbulbAutofix:r("lightbulb-autofix",60179),linkExternal:r("link-external",60180),link:r("link",60181),listOrdered:r("list-ordered",60182),listUnordered:r("list-unordered",60183),liveShare:r("live-share",60184),loading:r("loading",60185),location:r("location",60186),mailRead:r("mail-read",60187),mail:r("mail",60188),markdown:r("markdown",60189),megaphone:r("megaphone",60190),mention:r("mention",60191),milestone:r("milestone",60192),gitPullRequestMilestone:r("git-pull-request-milestone",60192),mortarBoard:r("mortar-board",60193),move:r("move",60194),multipleWindows:r("multiple-windows",60195),mute:r("mute",60196),noNewline:r("no-newline",60197),note:r("note",60198),octoface:r("octoface",60199),openPreview:r("open-preview",60200),package:r("package",60201),paintcan:r("paintcan",60202),pin:r("pin",60203),play:r("play",60204),run:r("run",60204),plug:r("plug",60205),preserveCase:r("preserve-case",60206),preview:r("preview",60207),project:r("project",60208),pulse:r("pulse",60209),question:r("question",60210),quote:r("quote",60211),radioTower:r("radio-tower",60212),reactions:r("reactions",60213),references:r("references",60214),refresh:r("refresh",60215),regex:r("regex",60216),remoteExplorer:r("remote-explorer",60217),remote:r("remote",60218),remove:r("remove",60219),replaceAll:r("replace-all",60220),replace:r("replace",60221),repoClone:r("repo-clone",60222),repoForcePush:r("repo-force-push",60223),repoPull:r("repo-pull",60224),repoPush:r("repo-push",60225),report:r("report",60226),requestChanges:r("request-changes",60227),rocket:r("rocket",60228),rootFolderOpened:r("root-folder-opened",60229),rootFolder:r("root-folder",60230),rss:r("rss",60231),ruby:r("ruby",60232),saveAll:r("save-all",60233),saveAs:r("save-as",60234),save:r("save",60235),screenFull:r("screen-full",60236),screenNormal:r("screen-normal",60237),searchStop:r("search-stop",60238),server:r("server",60240),settingsGear:r("settings-gear",60241),settings:r("settings",60242),shield:r("shield",60243),smiley:r("smiley",60244),sortPrecedence:r("sort-precedence",60245),splitHorizontal:r("split-horizontal",60246),splitVertical:r("split-vertical",60247),squirrel:r("squirrel",60248),starFull:r("star-full",60249),starHalf:r("star-half",60250),symbolClass:r("symbol-class",60251),symbolColor:r("symbol-color",60252),symbolCustomColor:r("symbol-customcolor",60252),symbolConstant:r("symbol-constant",60253),symbolEnumMember:r("symbol-enum-member",60254),symbolField:r("symbol-field",60255),symbolFile:r("symbol-file",60256),symbolInterface:r("symbol-interface",60257),symbolKeyword:r("symbol-keyword",60258),symbolMisc:r("symbol-misc",60259),symbolOperator:r("symbol-operator",60260),symbolProperty:r("symbol-property",60261),wrench:r("wrench",60261),wrenchSubaction:r("wrench-subaction",60261),symbolSnippet:r("symbol-snippet",60262),tasklist:r("tasklist",60263),telescope:r("telescope",60264),textSize:r("text-size",60265),threeBars:r("three-bars",60266),thumbsdown:r("thumbsdown",60267),thumbsup:r("thumbsup",60268),tools:r("tools",60269),triangleDown:r("triangle-down",60270),triangleLeft:r("triangle-left",60271),triangleRight:r("triangle-right",60272),triangleUp:r("triangle-up",60273),twitter:r("twitter",60274),unfold:r("unfold",60275),unlock:r("unlock",60276),unmute:r("unmute",60277),unverified:r("unverified",60278),verified:r("verified",60279),versions:r("versions",60280),vmActive:r("vm-active",60281),vmOutline:r("vm-outline",60282),vmRunning:r("vm-running",60283),watch:r("watch",60284),whitespace:r("whitespace",60285),wholeWord:r("whole-word",60286),window:r("window",60287),wordWrap:r("word-wrap",60288),zoomIn:r("zoom-in",60289),zoomOut:r("zoom-out",60290),listFilter:r("list-filter",60291),listFlat:r("list-flat",60292),listSelection:r("list-selection",60293),selection:r("selection",60293),listTree:r("list-tree",60294),debugBreakpointFunctionUnverified:r("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:r("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:r("debug-breakpoint-function-disabled",60296),debugStackframeActive:r("debug-stackframe-active",60297),circleSmallFilled:r("circle-small-filled",60298),debugStackframeDot:r("debug-stackframe-dot",60298),debugStackframe:r("debug-stackframe",60299),debugStackframeFocused:r("debug-stackframe-focused",60299),debugBreakpointUnsupported:r("debug-breakpoint-unsupported",60300),symbolString:r("symbol-string",60301),debugReverseContinue:r("debug-reverse-continue",60302),debugStepBack:r("debug-step-back",60303),debugRestartFrame:r("debug-restart-frame",60304),callIncoming:r("call-incoming",60306),callOutgoing:r("call-outgoing",60307),menu:r("menu",60308),expandAll:r("expand-all",60309),feedback:r("feedback",60310),gitPullRequestReviewer:r("git-pull-request-reviewer",60310),groupByRefType:r("group-by-ref-type",60311),ungroupByRefType:r("ungroup-by-ref-type",60312),account:r("account",60313),gitPullRequestAssignee:r("git-pull-request-assignee",60313),bellDot:r("bell-dot",60314),debugConsole:r("debug-console",60315),library:r("library",60316),output:r("output",60317),runAll:r("run-all",60318),syncIgnored:r("sync-ignored",60319),pinned:r("pinned",60320),githubInverted:r("github-inverted",60321),debugAlt:r("debug-alt",60305),serverProcess:r("server-process",60322),serverEnvironment:r("server-environment",60323),pass:r("pass",60324),stopCircle:r("stop-circle",60325),playCircle:r("play-circle",60326),record:r("record",60327),debugAltSmall:r("debug-alt-small",60328),vmConnect:r("vm-connect",60329),cloud:r("cloud",60330),merge:r("merge",60331),exportIcon:r("export",60332),graphLeft:r("graph-left",60333),magnet:r("magnet",60334),notebook:r("notebook",60335),redo:r("redo",60336),checkAll:r("check-all",60337),pinnedDirty:r("pinned-dirty",60338),passFilled:r("pass-filled",60339),circleLargeFilled:r("circle-large-filled",60340),circleLarge:r("circle-large",60341),circleLargeOutline:r("circle-large-outline",60341),combine:r("combine",60342),gather:r("gather",60342),table:r("table",60343),variableGroup:r("variable-group",60344),typeHierarchy:r("type-hierarchy",60345),typeHierarchySub:r("type-hierarchy-sub",60346),typeHierarchySuper:r("type-hierarchy-super",60347),gitPullRequestCreate:r("git-pull-request-create",60348),runAbove:r("run-above",60349),runBelow:r("run-below",60350),notebookTemplate:r("notebook-template",60351),debugRerun:r("debug-rerun",60352),workspaceTrusted:r("workspace-trusted",60353),workspaceUntrusted:r("workspace-untrusted",60354),workspaceUnspecified:r("workspace-unspecified",60355),terminalCmd:r("terminal-cmd",60356),terminalDebian:r("terminal-debian",60357),terminalLinux:r("terminal-linux",60358),terminalPowershell:r("terminal-powershell",60359),terminalTmux:r("terminal-tmux",60360),terminalUbuntu:r("terminal-ubuntu",60361),terminalBash:r("terminal-bash",60362),arrowSwap:r("arrow-swap",60363),copy:r("copy",60364),personAdd:r("person-add",60365),filterFilled:r("filter-filled",60366),wand:r("wand",60367),debugLineByLine:r("debug-line-by-line",60368),inspect:r("inspect",60369),layers:r("layers",60370),layersDot:r("layers-dot",60371),layersActive:r("layers-active",60372),compass:r("compass",60373),compassDot:r("compass-dot",60374),compassActive:r("compass-active",60375),azure:r("azure",60376),issueDraft:r("issue-draft",60377),gitPullRequestClosed:r("git-pull-request-closed",60378),gitPullRequestDraft:r("git-pull-request-draft",60379),debugAll:r("debug-all",60380),debugCoverage:r("debug-coverage",60381),runErrors:r("run-errors",60382),folderLibrary:r("folder-library",60383),debugContinueSmall:r("debug-continue-small",60384),beakerStop:r("beaker-stop",60385),graphLine:r("graph-line",60386),graphScatter:r("graph-scatter",60387),pieChart:r("pie-chart",60388),bracketDot:r("bracket-dot",60389),bracketError:r("bracket-error",60390),lockSmall:r("lock-small",60391),azureDevops:r("azure-devops",60392),verifiedFilled:r("verified-filled",60393),newLine:r("newline",60394),layout:r("layout",60395),layoutActivitybarLeft:r("layout-activitybar-left",60396),layoutActivitybarRight:r("layout-activitybar-right",60397),layoutPanelLeft:r("layout-panel-left",60398),layoutPanelCenter:r("layout-panel-center",60399),layoutPanelJustify:r("layout-panel-justify",60400),layoutPanelRight:r("layout-panel-right",60401),layoutPanel:r("layout-panel",60402),layoutSidebarLeft:r("layout-sidebar-left",60403),layoutSidebarRight:r("layout-sidebar-right",60404),layoutStatusbar:r("layout-statusbar",60405),layoutMenubar:r("layout-menubar",60406),layoutCentered:r("layout-centered",60407),layoutSidebarRightOff:r("layout-sidebar-right-off",60416),layoutPanelOff:r("layout-panel-off",60417),layoutSidebarLeftOff:r("layout-sidebar-left-off",60418),target:r("target",60408),indent:r("indent",60409),recordSmall:r("record-small",60410),errorSmall:r("error-small",60411),arrowCircleDown:r("arrow-circle-down",60412),arrowCircleLeft:r("arrow-circle-left",60413),arrowCircleRight:r("arrow-circle-right",60414),arrowCircleUp:r("arrow-circle-up",60415),heartFilled:r("heart-filled",60420),map:r("map",60421),mapFilled:r("map-filled",60422),circleSmall:r("circle-small",60423),bellSlash:r("bell-slash",60424),bellSlashDot:r("bell-slash-dot",60425),commentUnresolved:r("comment-unresolved",60426),gitPullRequestGoToChanges:r("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:r("git-pull-request-new-changes",60428),searchFuzzy:r("search-fuzzy",60429),commentDraft:r("comment-draft",60430),send:r("send",60431),sparkle:r("sparkle",60432),insert:r("insert",60433),mic:r("mic",60434),dialogError:r("dialog-error","error"),dialogWarning:r("dialog-warning","warning"),dialogInfo:r("dialog-info","info"),dialogClose:r("dialog-close","close"),treeItemExpanded:r("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:r("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:r("tree-filter-on-type-off","list-selection"),treeFilterClear:r("tree-filter-clear","close"),treeItemLoading:r("tree-item-loading","loading"),menuSelection:r("menu-selection","check"),menuSubmenu:r("menu-submenu","chevron-right"),menuBarMore:r("menubar-more","more"),scrollbarButtonLeft:r("scrollbar-button-left","triangle-left"),scrollbarButtonRight:r("scrollbar-button-right","triangle-right"),scrollbarButtonUp:r("scrollbar-button-up","triangle-up"),scrollbarButtonDown:r("scrollbar-button-down","triangle-down"),toolBarMore:r("toolbar-more","more"),quickInputBack:r("quick-input-back","arrow-left")}}),te(ie[15],se([0,1,26]),function(O,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$9m=t.$8m=t.$7m=t.$6m=t.$5m=t.$4m=t.$3m=t.$2m=t.$1m=t.$Zm=t.$Ym=t.$Xm=void 0;function _(E){if(!E||typeof E!="object"||E instanceof RegExp)return E;const h=Array.isArray(E)?[]:{};return Object.entries(E).forEach(([o,f])=>{h[o]=f&&typeof f=="object"?_(f):f}),h}t.$Xm=_;function r(E){if(!E||typeof E!="object")return E;const h=[E];for(;h.length>0;){const o=h.shift();Object.freeze(o);for(const f in o)if(c.call(o,f)){const u=o[f];typeof u=="object"&&!Object.isFrozen(u)&&!(0,k.$zf)(u)&&h.push(u)}}return E}t.$Ym=r;const c=Object.prototype.hasOwnProperty;function L(E,h){return d(E,h,new Set)}t.$Zm=L;function d(E,h,o){if((0,k.$Ff)(E))return E;const f=h(E);if(typeof f<"u")return f;if(Array.isArray(E)){const u=[];for(const i of E)u.push(d(i,h,o));return u}if((0,k.$yf)(E)){if(o.has(E))throw new Error("Cannot clone recursive data-structure");o.add(E);const u={};for(const i in E)c.call(E,i)&&(u[i]=d(E[i],h,o));return o.delete(E),u}return E}function l(E,h,o=!0){return(0,k.$yf)(E)?((0,k.$yf)(h)&&Object.keys(h).forEach(f=>{f in E?o&&((0,k.$yf)(E[f])&&(0,k.$yf)(h[f])?l(E[f],h[f],o):E[f]=h[f]):E[f]=h[f]}),E):h}t.$1m=l;function s(E,h){if(E===h)return!0;if(E==null||h===null||h===void 0||typeof E!=typeof h||typeof E!="object"||Array.isArray(E)!==Array.isArray(h))return!1;let o,f;if(Array.isArray(E)){if(E.length!==h.length)return!1;for(o=0;o<E.length;o++)if(!s(E[o],h[o]))return!1}else{const u=[];for(f in E)u.push(f);u.sort();const i=[];for(f in h)i.push(f);if(i.sort(),!s(u,i))return!1;for(o=0;o<u.length;o++)if(!s(E[u[o]],h[u[o]]))return!1}return!0}t.$2m=s;function g(E){const h=new Set;return JSON.stringify(E,(o,f)=>{if((0,k.$yf)(f)||Array.isArray(f)){if(h.has(f))return"[Circular]";h.add(f)}return f})}t.$3m=g;function A(E,h){const o=Object.create(null);return!E||!h||Object.keys(h).forEach(u=>{const i=E[u],a=h[u];s(i,a)||(o[u]=a)}),o}t.$4m=A;function m(E,h){const o=h.toLowerCase(),f=Object.keys(E).find(u=>u.toLowerCase()===o);return f?E[f]:E[h]}t.$5m=m;function b(E,h){const o=Object.create(null);for(const[f,u]of Object.entries(E))h(f,u)&&(o[f]=u);return o}t.$6m=b;function e(E){let h=[];for(;Object.prototype!==E;)h=h.concat(Object.getOwnPropertyNames(E)),E=Object.getPrototypeOf(E);return h}t.$7m=e;function w(E){const h=[];for(const o of e(E))typeof E[o]=="function"&&h.push(o);return h}t.$8m=w;function R(E,h){const o=u=>function(){const i=Array.prototype.slice.call(arguments,0);return h(u,i)},f={};for(const u of E)f[u]=o(u);return f}t.$9m=R}),te(ie[27],se([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ye=t.$xe=t.Constants=void 0;var k;(function(c){c[c.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",c[c.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",c[c.MAX_UINT_8=255]="MAX_UINT_8",c[c.MAX_UINT_16=65535]="MAX_UINT_16",c[c.MAX_UINT_32=4294967295]="MAX_UINT_32",c[c.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(k||(t.Constants=k={}));function _(c){return c<0?0:c>255?255:c|0}t.$xe=_;function r(c){return c<0?0:c>4294967295?4294967295:c|0}t.$ye=r}),te(ie[16],se([0,1,40,14]),function(O,t,k,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$uc=t.$tc=t.URI=void 0;const r=/^\w[\w\d+.-]*$/,c=/^\//,L=/^\/\//;function d($,v){if(!$.scheme&&v)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${$.authority}", path: "${$.path}", query: "${$.query}", fragment: "${$.fragment}"}`);if($.scheme&&!r.test($.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if($.path){if($.authority){if(!c.test($.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(L.test($.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function l($,v){return!$&&!v?"file":$}function s($,v){switch($){case"https":case"http":case"file":v?v[0]!==A&&(v=A+v):v=A;break}return v}const g="",A="/",m=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class b{static isUri(v){return v instanceof b?!0:v?typeof v.authority=="string"&&typeof v.fragment=="string"&&typeof v.path=="string"&&typeof v.query=="string"&&typeof v.scheme=="string"&&typeof v.fsPath=="string"&&typeof v.with=="function"&&typeof v.toString=="function":!1}constructor(v,p,M,P,F,y=!1){typeof v=="object"?(this.scheme=v.scheme||g,this.authority=v.authority||g,this.path=v.path||g,this.query=v.query||g,this.fragment=v.fragment||g):(this.scheme=l(v,y),this.authority=p||g,this.path=s(this.scheme,M||g),this.query=P||g,this.fragment=F||g,d(this,y))}get fsPath(){return f(this,!1)}with(v){if(!v)return this;let{scheme:p,authority:M,path:P,query:F,fragment:y}=v;return p===void 0?p=this.scheme:p===null&&(p=g),M===void 0?M=this.authority:M===null&&(M=g),P===void 0?P=this.path:P===null&&(P=g),F===void 0?F=this.query:F===null&&(F=g),y===void 0?y=this.fragment:y===null&&(y=g),p===this.scheme&&M===this.authority&&P===this.path&&F===this.query&&y===this.fragment?this:new R(p,M,P,F,y)}static parse(v,p=!1){const M=m.exec(v);return M?new R(M[2]||g,N(M[4]||g),N(M[5]||g),N(M[7]||g),N(M[9]||g),p):new R(g,g,g,g,g)}static file(v){let p=g;if(_.$d&&(v=v.replace(/\\/g,A)),v[0]===A&&v[1]===A){const M=v.indexOf(A,2);M===-1?(p=v.substring(2),v=A):(p=v.substring(2,M),v=v.substring(M)||A)}return new R("file",p,v,g,g)}static from(v,p){return new R(v.scheme,v.authority,v.path,v.query,v.fragment,p)}static joinPath(v,...p){if(!v.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let M;return _.$d&&v.scheme==="file"?M=b.file(k.$dc.join(f(v,!0),...p)).path:M=k.$ec.join(v.path,...p),v.with({path:M})}toString(v=!1){return u(this,v)}toJSON(){return this}static revive(v){if(v){if(v instanceof b)return v;{const p=new R(v);return p._formatted=v.external??null,p._fsPath=v._sep===w?v.fsPath??null:null,p}}else return v}}t.URI=b;function e($){return!$||typeof $!="object"?!1:typeof $.scheme=="string"&&(typeof $.authority=="string"||typeof $.authority>"u")&&(typeof $.path=="string"||typeof $.path>"u")&&(typeof $.query=="string"||typeof $.query>"u")&&(typeof $.fragment=="string"||typeof $.fragment>"u")}t.$tc=e;const w=_.$d?1:void 0;class R extends b{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=f(this,!1)),this._fsPath}toString(v=!1){return v?u(this,!0):(this._formatted||(this._formatted=u(this,!1)),this._formatted)}toJSON(){const v={$mid:1};return this._fsPath&&(v.fsPath=this._fsPath,v._sep=w),this._formatted&&(v.external=this._formatted),this.path&&(v.path=this.path),this.scheme&&(v.scheme=this.scheme),this.authority&&(v.authority=this.authority),this.query&&(v.query=this.query),this.fragment&&(v.fragment=this.fragment),v}}const E={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function h($,v,p){let M,P=-1;for(let F=0;F<$.length;F++){const y=$.charCodeAt(F);if(y>=97&&y<=122||y>=65&&y<=90||y>=48&&y<=57||y===45||y===46||y===95||y===126||v&&y===47||p&&y===91||p&&y===93||p&&y===58)P!==-1&&(M+=encodeURIComponent($.substring(P,F)),P=-1),M!==void 0&&(M+=$.charAt(F));else{M===void 0&&(M=$.substr(0,F));const D=E[y];D!==void 0?(P!==-1&&(M+=encodeURIComponent($.substring(P,F)),P=-1),M+=D):P===-1&&(P=F)}}return P!==-1&&(M+=encodeURIComponent($.substring(P))),M!==void 0?M:$}function o($){let v;for(let p=0;p<$.length;p++){const M=$.charCodeAt(p);M===35||M===63?(v===void 0&&(v=$.substr(0,p)),v+=E[M]):v!==void 0&&(v+=$[p])}return v!==void 0?v:$}function f($,v){let p;return $.authority&&$.path.length>1&&$.scheme==="file"?p=`//${$.authority}${$.path}`:$.path.charCodeAt(0)===47&&($.path.charCodeAt(1)>=65&&$.path.charCodeAt(1)<=90||$.path.charCodeAt(1)>=97&&$.path.charCodeAt(1)<=122)&&$.path.charCodeAt(2)===58?v?p=$.path.substr(1):p=$.path[1].toLowerCase()+$.path.substr(2):p=$.path,_.$d&&(p=p.replace(/\//g,"\\")),p}t.$uc=f;function u($,v){const p=v?o:h;let M="",{scheme:P,authority:F,path:y,query:D,fragment:q}=$;if(P&&(M+=P,M+=":"),(F||P==="file")&&(M+=A,M+=A),F){let I=F.indexOf("@");if(I!==-1){const x=F.substr(0,I);F=F.substr(I+1),I=x.lastIndexOf(":"),I===-1?M+=p(x,!1,!1):(M+=p(x.substr(0,I),!1,!1),M+=":",M+=p(x.substr(I+1),!1,!0)),M+="@"}F=F.toLowerCase(),I=F.lastIndexOf(":"),I===-1?M+=p(F,!1,!0):(M+=p(F.substr(0,I),!1,!0),M+=F.substr(I))}if(y){if(y.length>=3&&y.charCodeAt(0)===47&&y.charCodeAt(2)===58){const I=y.charCodeAt(1);I>=65&&I<=90&&(y=`/${String.fromCharCode(I+32)}:${y.substr(3)}`)}else if(y.length>=2&&y.charCodeAt(1)===58){const I=y.charCodeAt(0);I>=65&&I<=90&&(y=`${String.fromCharCode(I+32)}:${y.substr(2)}`)}M+=p(y,!0,!1)}return D&&(M+="?",M+=p(D,!1,!1)),q&&(M+="#",M+=v?q:h(q,!1,!1)),M}function i($){try{return decodeURIComponent($)}catch{return $.length>3?$.substr(0,3)+i($.substr(3)):$}}const a=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function N($){return $.match(a)?$.replace(a,v=>i(v)):$}}),te(ie[67],se([0,1,3,11,10,15,14,7]),function(O,t,k,_,r,c,L,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.create=t.SimpleWorkerServer=t.SimpleWorkerClient=t.logOnceWebWorkerWarning=void 0;const l="$initialize";let s=!1;function g(N){L.$j&&(s||(s=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(N.message))}t.logOnceWebWorkerWarning=g;var A;(function(N){N[N.Request=0]="Request",N[N.Reply=1]="Reply",N[N.SubscribeEvent=2]="SubscribeEvent",N[N.Event=3]="Event",N[N.UnsubscribeEvent=4]="UnsubscribeEvent"})(A||(A={}));class m{constructor($,v,p,M){this.vsWorker=$,this.req=v,this.method=p,this.args=M,this.type=0}}class b{constructor($,v,p,M){this.vsWorker=$,this.seq=v,this.res=p,this.err=M,this.type=1}}class e{constructor($,v,p,M){this.vsWorker=$,this.req=v,this.eventName=p,this.arg=M,this.type=2}}class w{constructor($,v,p){this.vsWorker=$,this.req=v,this.event=p,this.type=3}}class R{constructor($,v){this.vsWorker=$,this.req=v,this.type=4}}class E{constructor($){this.a=-1,this.g=$,this.b=0,this.c=Object.create(null),this.d=new Map,this.f=new Map}setWorkerId($){this.a=$}sendMessage($,v){const p=String(++this.b);return new Promise((M,P)=>{this.c[p]={resolve:M,reject:P},this.o(new m(this.a,p,$,v))})}listen($,v){let p=null;const M=new _.$Ld({onWillAddFirstListener:()=>{p=String(++this.b),this.d.set(p,M),this.o(new e(this.a,p,$,v))},onDidRemoveLastListener:()=>{this.d.delete(p),this.o(new R(this.a,p)),p=null}});return M.event}handleMessage($){!$||!$.vsWorker||this.a!==-1&&$.vsWorker!==this.a||this.h($)}h($){switch($.type){case 1:return this.j($);case 0:return this.k($);case 2:return this.l($);case 3:return this.m($);case 4:return this.n($)}}j($){if(!this.c[$.seq]){console.warn("Got reply to unknown seq");return}const v=this.c[$.seq];if(delete this.c[$.seq],$.err){let p=$.err;$.err.$isError&&(p=new Error,p.name=$.err.name,p.message=$.err.message,p.stack=$.err.stack),v.reject(p);return}v.resolve($.res)}k($){const v=$.req;this.g.handleMessage($.method,$.args).then(M=>{this.o(new b(this.a,v,M,void 0))},M=>{M.detail instanceof Error&&(M.detail=(0,k.$1)(M.detail)),this.o(new b(this.a,v,void 0,(0,k.$1)(M)))})}l($){const v=$.req,p=this.g.handleEvent($.eventName,$.arg)(M=>{this.o(new w(this.a,v,M))});this.f.set(v,p)}m($){if(!this.d.has($.req)){console.warn("Got event for unknown req");return}this.d.get($.req).fire($.event)}n($){if(!this.f.has($.req)){console.warn("Got unsubscribe for unknown req");return}this.f.get($.req).dispose(),this.f.delete($.req)}o($){const v=[];if($.type===0)for(let p=0;p<$.args.length;p++)$.args[p]instanceof ArrayBuffer&&v.push($.args[p]);else $.type===1&&$.res instanceof ArrayBuffer&&v.push($.res);this.g.sendMessage($,v)}}class h extends r.$Qc{constructor($,v,p){super();let M=null;this.a=this.B($.create("vs/base/common/worker/simpleWorker",I=>{this.c.handleMessage(I)},I=>{M?.(I)})),this.c=new E({sendMessage:(I,x)=>{this.a.postMessage(I,x)},handleMessage:(I,x)=>{if(typeof p[I]!="function")return Promise.reject(new Error("Missing method "+I+" on main thread host."));try{return Promise.resolve(p[I].apply(p,x))}catch(T){return Promise.reject(T)}},handleEvent:(I,x)=>{if(f(I)){const T=p[I].call(p,x);if(typeof T!="function")throw new Error(`Missing dynamic event ${I} on main thread host.`);return T}if(o(I)){const T=p[I];if(typeof T!="function")throw new Error(`Missing event ${I} on main thread host.`);return T}throw new Error(`Malformed event name ${I}`)}}),this.c.setWorkerId(this.a.getId());let P=null;const F=globalThis.require;typeof F<"u"&&typeof F.getConfig=="function"?P=F.getConfig():typeof globalThis.requirejs<"u"&&(P=globalThis.requirejs.s.contexts._.config);const y=(0,c.$8m)(p);this.b=this.c.sendMessage(l,[this.a.getId(),JSON.parse(JSON.stringify(P)),v,y]);const D=(I,x)=>this.g(I,x),q=(I,x)=>this.c.listen(I,x);this.f=new Promise((I,x)=>{M=x,this.b.then(T=>{I(u(T,D,q))},T=>{x(T),this.h("Worker failed to load "+v,T)})})}getProxyObject(){return this.f}g($,v){return new Promise((p,M)=>{this.b.then(()=>{this.c.sendMessage($,v).then(p,M)},M)})}h($,v){console.error($),console.info(v)}}t.SimpleWorkerClient=h;function o(N){return N[0]==="o"&&N[1]==="n"&&d.$Ye(N.charCodeAt(2))}function f(N){return/^onDynamic/.test(N)&&d.$Ye(N.charCodeAt(9))}function u(N,$,v){const p=F=>function(){const y=Array.prototype.slice.call(arguments,0);return $(F,y)},M=F=>function(y){return v(F,y)},P={};for(const F of N){if(f(F)){P[F]=M(F);continue}if(o(F)){P[F]=v(F,void 0);continue}P[F]=p(F)}return P}class i{constructor($,v){this.a=v,this.b=null,this.c=new E({sendMessage:(p,M)=>{$(p,M)},handleMessage:(p,M)=>this.d(p,M),handleEvent:(p,M)=>this.f(p,M)})}onmessage($){this.c.handleMessage($)}d($,v){if($===l)return this.g(v[0],v[1],v[2],v[3]);if(!this.b||typeof this.b[$]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+$));try{return Promise.resolve(this.b[$].apply(this.b,v))}catch(p){return Promise.reject(p)}}f($,v){if(!this.b)throw new Error("Missing requestHandler");if(f($)){const p=this.b[$].call(this.b,v);if(typeof p!="function")throw new Error(`Missing dynamic event ${$} on request handler.`);return p}if(o($)){const p=this.b[$];if(typeof p!="function")throw new Error(`Missing event ${$} on request handler.`);return p}throw new Error(`Malformed event name ${$}`)}g($,v,p,M){this.c.setWorkerId($);const y=u(M,(D,q)=>this.c.sendMessage(D,q),(D,q)=>this.c.listen(D,q));return this.a?(this.b=this.a(y),Promise.resolve((0,c.$8m)(this.b))):(v&&(typeof v.baseUrl<"u"&&delete v.baseUrl,typeof v.paths<"u"&&typeof v.paths.vs<"u"&&delete v.paths.vs,typeof v.trustedTypesPolicy!==void 0&&delete v.trustedTypesPolicy,v.catchError=!0,globalThis.require.config(v)),new Promise((D,q)=>{(globalThis.require||O)([p],x=>{if(this.b=x.create(y),!this.b){q(new Error("No RequestHandler!"));return}D((0,c.$8m)(this.b))},q)}))}}t.SimpleWorkerServer=i;function a(N){return new i(N,null)}t.create=a}),te(ie[28],se([0,1,27]),function(O,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ks=t.$Js=void 0;class _{constructor(d){const l=(0,k.$xe)(d);this.c=l,this.a=_.d(l),this.b=new Map}static d(d){const l=new Uint8Array(256);return l.fill(d),l}set(d,l){const s=(0,k.$xe)(l);d>=0&&d<256?this.a[d]=s:this.b.set(d,s)}get(d){return d>=0&&d<256?this.a[d]:this.b.get(d)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}t.$Js=_;var r;(function(L){L[L.False=0]="False",L[L.True=1]="True"})(r||(r={}));class c{constructor(){this.a=new _(0)}add(d){this.a.set(d,1)}has(d){return this.a.get(d)===1}clear(){return this.a.clear()}}t.$Ks=c}),te(ie[4],se([0,1,3]),function(O,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$us=t.$ts=void 0;class _{static addRange(L,d){let l=0;for(;l<d.length&&d[l].endExclusive<L.start;)l++;let s=l;for(;s<d.length&&d[s].start<=L.endExclusive;)s++;if(l===s)d.splice(l,0,L);else{const g=Math.min(L.start,d[l].start),A=Math.max(L.endExclusive,d[s-1].endExclusive);d.splice(l,s-l,new _(g,A))}}static tryCreate(L,d){if(!(L>d))return new _(L,d)}static ofLength(L){return new _(0,L)}constructor(L,d){if(this.start=L,this.endExclusive=d,L>d)throw new k.$ab(`Invalid range: ${this.toString()}`)}get isEmpty(){return this.start===this.endExclusive}delta(L){return new _(this.start+L,this.endExclusive+L)}deltaStart(L){return new _(this.start+L,this.endExclusive)}deltaEnd(L){return new _(this.start,this.endExclusive+L)}get length(){return this.endExclusive-this.start}toString(){return`[${this.start}, ${this.endExclusive})`}equals(L){return this.start===L.start&&this.endExclusive===L.endExclusive}containsRange(L){return this.start<=L.start&&L.endExclusive<=this.endExclusive}contains(L){return this.start<=L&&L<this.endExclusive}join(L){return new _(Math.min(this.start,L.start),Math.max(this.endExclusive,L.endExclusive))}intersect(L){const d=Math.max(this.start,L.start),l=Math.min(this.endExclusive,L.endExclusive);if(d<=l)return new _(d,l)}intersectsOrTouches(L){const d=Math.max(this.start,L.start),l=Math.min(this.endExclusive,L.endExclusive);return d<=l}slice(L){return L.slice(this.start,this.endExclusive)}clip(L){if(this.isEmpty)throw new k.$ab(`Invalid clipping range: ${this.toString()}`);return Math.max(this.start,Math.min(this.endExclusive-1,L))}clipCyclic(L){if(this.isEmpty)throw new k.$ab(`Invalid clipping range: ${this.toString()}`);return L<this.start?this.endExclusive-(this.start-L)%this.length:L>=this.endExclusive?this.start+(L-this.start)%this.length:L}map(L){const d=[];for(let l=this.start;l<this.endExclusive;l++)d.push(L(l));return d}forEach(L){for(let d=this.start;d<this.endExclusive;d++)L(d)}}t.$ts=_;class r{constructor(){this.a=[]}addRange(L){let d=0;for(;d<this.a.length&&this.a[d].endExclusive<L.start;)d++;let l=d;for(;l<this.a.length&&this.a[l].start<=L.endExclusive;)l++;if(d===l)this.a.splice(d,0,L);else{const s=Math.min(L.start,this.a[d].start),g=Math.max(L.endExclusive,this.a[l-1].endExclusive);this.a.splice(d,l-d,new _(s,g))}}toString(){return this.a.map(L=>L.toString()).join(", ")}intersectsStrict(L){let d=0;for(;d<this.a.length&&this.a[d].endExclusive<=L.start;)d++;return d<this.a.length&&this.a[d].start<L.endExclusive}intersectWithRange(L){const d=new r;for(const l of this.a){const s=l.intersect(L);s&&d.addRange(s)}return d}intersectWithRangeLength(L){return this.intersectWithRange(L).length}get length(){return this.a.reduce((L,d)=>L+d.length,0)}}t.$us=r}),te(ie[5],se([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ls=void 0;class k{constructor(r,c){this.lineNumber=r,this.column=c}with(r=this.lineNumber,c=this.column){return r===this.lineNumber&&c===this.column?this:new k(r,c)}delta(r=0,c=0){return this.with(this.lineNumber+r,this.column+c)}equals(r){return k.equals(this,r)}static equals(r,c){return!r&&!c?!0:!!r&&!!c&&r.lineNumber===c.lineNumber&&r.column===c.column}isBefore(r){return k.isBefore(this,r)}static isBefore(r,c){return r.lineNumber<c.lineNumber?!0:c.lineNumber<r.lineNumber?!1:r.column<c.column}isBeforeOrEqual(r){return k.isBeforeOrEqual(this,r)}static isBeforeOrEqual(r,c){return r.lineNumber<c.lineNumber?!0:c.lineNumber<r.lineNumber?!1:r.column<=c.column}static compare(r,c){const L=r.lineNumber|0,d=c.lineNumber|0;if(L===d){const l=r.column|0,s=c.column|0;return l-s}return L-d}clone(){return new k(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(r){return new k(r.lineNumber,r.column)}static isIPosition(r){return r&&typeof r.lineNumber=="number"&&typeof r.column=="number"}}t.$ls=k}),te(ie[2],se([0,1,5]),function(O,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ms=void 0;class _{constructor(c,L,d,l){c>d||c===d&&L>l?(this.startLineNumber=d,this.startColumn=l,this.endLineNumber=c,this.endColumn=L):(this.startLineNumber=c,this.startColumn=L,this.endLineNumber=d,this.endColumn=l)}isEmpty(){return _.isEmpty(this)}static isEmpty(c){return c.startLineNumber===c.endLineNumber&&c.startColumn===c.endColumn}containsPosition(c){return _.containsPosition(this,c)}static containsPosition(c,L){return!(L.lineNumber<c.startLineNumber||L.lineNumber>c.endLineNumber||L.lineNumber===c.startLineNumber&&L.column<c.startColumn||L.lineNumber===c.endLineNumber&&L.column>c.endColumn)}static strictContainsPosition(c,L){return!(L.lineNumber<c.startLineNumber||L.lineNumber>c.endLineNumber||L.lineNumber===c.startLineNumber&&L.column<=c.startColumn||L.lineNumber===c.endLineNumber&&L.column>=c.endColumn)}containsRange(c){return _.containsRange(this,c)}static containsRange(c,L){return!(L.startLineNumber<c.startLineNumber||L.endLineNumber<c.startLineNumber||L.startLineNumber>c.endLineNumber||L.endLineNumber>c.endLineNumber||L.startLineNumber===c.startLineNumber&&L.startColumn<c.startColumn||L.endLineNumber===c.endLineNumber&&L.endColumn>c.endColumn)}strictContainsRange(c){return _.strictContainsRange(this,c)}static strictContainsRange(c,L){return!(L.startLineNumber<c.startLineNumber||L.endLineNumber<c.startLineNumber||L.startLineNumber>c.endLineNumber||L.endLineNumber>c.endLineNumber||L.startLineNumber===c.startLineNumber&&L.startColumn<=c.startColumn||L.endLineNumber===c.endLineNumber&&L.endColumn>=c.endColumn)}plusRange(c){return _.plusRange(this,c)}static plusRange(c,L){let d,l,s,g;return L.startLineNumber<c.startLineNumber?(d=L.startLineNumber,l=L.startColumn):L.startLineNumber===c.startLineNumber?(d=L.startLineNumber,l=Math.min(L.startColumn,c.startColumn)):(d=c.startLineNumber,l=c.startColumn),L.endLineNumber>c.endLineNumber?(s=L.endLineNumber,g=L.endColumn):L.endLineNumber===c.endLineNumber?(s=L.endLineNumber,g=Math.max(L.endColumn,c.endColumn)):(s=c.endLineNumber,g=c.endColumn),new _(d,l,s,g)}intersectRanges(c){return _.intersectRanges(this,c)}static intersectRanges(c,L){let d=c.startLineNumber,l=c.startColumn,s=c.endLineNumber,g=c.endColumn;const A=L.startLineNumber,m=L.startColumn,b=L.endLineNumber,e=L.endColumn;return d<A?(d=A,l=m):d===A&&(l=Math.max(l,m)),s>b?(s=b,g=e):s===b&&(g=Math.min(g,e)),d>s||d===s&&l>g?null:new _(d,l,s,g)}equalsRange(c){return _.equalsRange(this,c)}static equalsRange(c,L){return!c&&!L?!0:!!c&&!!L&&c.startLineNumber===L.startLineNumber&&c.startColumn===L.startColumn&&c.endLineNumber===L.endLineNumber&&c.endColumn===L.endColumn}getEndPosition(){return _.getEndPosition(this)}static getEndPosition(c){return new k.$ls(c.endLineNumber,c.endColumn)}getStartPosition(){return _.getStartPosition(this)}static getStartPosition(c){return new k.$ls(c.startLineNumber,c.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(c,L){return new _(this.startLineNumber,this.startColumn,c,L)}setStartPosition(c,L){return new _(c,L,this.endLineNumber,this.endColumn)}collapseToStart(){return _.collapseToStart(this)}static collapseToStart(c){return new _(c.startLineNumber,c.startColumn,c.startLineNumber,c.startColumn)}collapseToEnd(){return _.collapseToEnd(this)}static collapseToEnd(c){return new _(c.endLineNumber,c.endColumn,c.endLineNumber,c.endColumn)}delta(c){return new _(this.startLineNumber+c,this.startColumn,this.endLineNumber+c,this.endColumn)}static fromPositions(c,L=c){return new _(c.lineNumber,c.column,L.lineNumber,L.column)}static lift(c){return c?new _(c.startLineNumber,c.startColumn,c.endLineNumber,c.endColumn):null}static isIRange(c){return c&&typeof c.startLineNumber=="number"&&typeof c.startColumn=="number"&&typeof c.endLineNumber=="number"&&typeof c.endColumn=="number"}static areIntersectingOrTouching(c,L){return!(c.endLineNumber<L.startLineNumber||c.endLineNumber===L.startLineNumber&&c.endColumn<L.startColumn||L.endLineNumber<c.startLineNumber||L.endLineNumber===c.startLineNumber&&L.endColumn<c.startColumn)}static areIntersecting(c,L){return!(c.endLineNumber<L.startLineNumber||c.endLineNumber===L.startLineNumber&&c.endColumn<=L.startColumn||L.endLineNumber<c.startLineNumber||L.endLineNumber===c.startLineNumber&&L.endColumn<=c.startColumn)}static compareRangesUsingStarts(c,L){if(c&&L){const s=c.startLineNumber|0,g=L.startLineNumber|0;if(s===g){const A=c.startColumn|0,m=L.startColumn|0;if(A===m){const b=c.endLineNumber|0,e=L.endLineNumber|0;if(b===e){const w=c.endColumn|0,R=L.endColumn|0;return w-R}return b-e}return A-m}return s-g}return(c?1:0)-(L?1:0)}static compareRangesUsingEnds(c,L){return c.endLineNumber===L.endLineNumber?c.endColumn===L.endColumn?c.startLineNumber===L.startLineNumber?c.startColumn-L.startColumn:c.startLineNumber-L.startLineNumber:c.endColumn-L.endColumn:c.endLineNumber-L.endLineNumber}static spansMultipleLines(c){return c.endLineNumber>c.startLineNumber}toJSON(){return this}}t.$ms=_}),te(ie[44],se([0,1,2]),function(O,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ns=void 0;class _{static insert(c,L){return{range:new k.$ms(c.lineNumber,c.column,c.lineNumber,c.column),text:L,forceMoveMarkers:!0}}static delete(c){return{range:c,text:null}}static replace(c,L){return{range:c,text:L}}static replaceMove(c,L){return{range:c,text:L,forceMoveMarkers:!0}}}t.$ns=_}),te(ie[12],se([0,1,3,4,2,9]),function(O,t,k,_,r,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ws=t.$vs=void 0;class L{static fromRange(s){return new L(s.startLineNumber,s.endLineNumber)}static subtract(s,g){return g?s.startLineNumber<g.startLineNumber&&g.endLineNumberExclusive<s.endLineNumberExclusive?[new L(s.startLineNumber,g.startLineNumber),new L(g.endLineNumberExclusive,s.endLineNumberExclusive)]:g.startLineNumber<=s.startLineNumber&&s.endLineNumberExclusive<=g.endLineNumberExclusive?[]:g.endLineNumberExclusive<s.endLineNumberExclusive?[new L(Math.max(g.endLineNumberExclusive,s.startLineNumber),s.endLineNumberExclusive)]:[new L(s.startLineNumber,Math.min(g.startLineNumber,s.endLineNumberExclusive))]:[s]}static joinMany(s){if(s.length===0)return[];let g=new d(s[0].slice());for(let A=1;A<s.length;A++)g=g.getUnion(new d(s[A].slice()));return g.ranges}static ofLength(s,g){return new L(s,s+g)}static deserialize(s){return new L(s[0],s[1])}constructor(s,g){if(s>g)throw new k.$ab(`startLineNumber ${s} cannot be after endLineNumberExclusive ${g}`);this.startLineNumber=s,this.endLineNumberExclusive=g}contains(s){return this.startLineNumber<=s&&s<this.endLineNumberExclusive}get isEmpty(){return this.startLineNumber===this.endLineNumberExclusive}delta(s){return new L(this.startLineNumber+s,this.endLineNumberExclusive+s)}deltaLength(s){return new L(this.startLineNumber,this.endLineNumberExclusive+s)}get length(){return this.endLineNumberExclusive-this.startLineNumber}join(s){return new L(Math.min(this.startLineNumber,s.startLineNumber),Math.max(this.endLineNumberExclusive,s.endLineNumberExclusive))}toString(){return`[${this.startLineNumber},${this.endLineNumberExclusive})`}intersect(s){const g=Math.max(this.startLineNumber,s.startLineNumber),A=Math.min(this.endLineNumberExclusive,s.endLineNumberExclusive);if(g<=A)return new L(g,A)}intersectsStrict(s){return this.startLineNumber<s.endLineNumberExclusive&&s.startLineNumber<this.endLineNumberExclusive}overlapOrTouch(s){return this.startLineNumber<=s.endLineNumberExclusive&&s.startLineNumber<=this.endLineNumberExclusive}equals(s){return this.startLineNumber===s.startLineNumber&&this.endLineNumberExclusive===s.endLineNumberExclusive}toInclusiveRange(){return this.isEmpty?null:new r.$ms(this.startLineNumber,1,this.endLineNumberExclusive-1,Number.MAX_SAFE_INTEGER)}toExclusiveRange(){return new r.$ms(this.startLineNumber,1,this.endLineNumberExclusive,1)}mapToLineArray(s){const g=[];for(let A=this.startLineNumber;A<this.endLineNumberExclusive;A++)g.push(s(A));return g}forEach(s){for(let g=this.startLineNumber;g<this.endLineNumberExclusive;g++)s(g)}serialize(){return[this.startLineNumber,this.endLineNumberExclusive]}includes(s){return this.startLineNumber<=s&&s<this.endLineNumberExclusive}toOffsetRange(){return new _.$ts(this.startLineNumber-1,this.endLineNumberExclusive-1)}}t.$vs=L;class d{constructor(s=[]){this.c=s}get ranges(){return this.c}addRange(s){if(s.length===0)return;const g=(0,c.$ib)(this.c,m=>m.endLineNumberExclusive>=s.startLineNumber),A=(0,c.$gb)(this.c,m=>m.startLineNumber<=s.endLineNumberExclusive)+1;if(g===A)this.c.splice(g,0,s);else if(g===A-1){const m=this.c[g];this.c[g]=m.join(s)}else{const m=this.c[g].join(this.c[A-1]).join(s);this.c.splice(g,A-g,m)}}contains(s){const g=(0,c.$fb)(this.c,A=>A.startLineNumber<=s);return!!g&&g.endLineNumberExclusive>s}intersects(s){const g=(0,c.$fb)(this.c,A=>A.startLineNumber<s.endLineNumberExclusive);return!!g&&g.endLineNumberExclusive>s.startLineNumber}getUnion(s){if(this.c.length===0)return s;if(s.c.length===0)return this;const g=[];let A=0,m=0,b=null;for(;A<this.c.length||m<s.c.length;){let e=null;if(A<this.c.length&&m<s.c.length){const w=this.c[A],R=s.c[m];w.startLineNumber<R.startLineNumber?(e=w,A++):(e=R,m++)}else A<this.c.length?(e=this.c[A],A++):(e=s.c[m],m++);b===null?b=e:b.endLineNumberExclusive>=e.startLineNumber?b=new L(b.startLineNumber,Math.max(b.endLineNumberExclusive,e.endLineNumberExclusive)):(g.push(b),b=e)}return b!==null&&g.push(b),new d(g)}subtractFrom(s){const g=(0,c.$ib)(this.c,e=>e.endLineNumberExclusive>=s.startLineNumber),A=(0,c.$gb)(this.c,e=>e.startLineNumber<=s.endLineNumberExclusive)+1;if(g===A)return new d([s]);const m=[];let b=s.startLineNumber;for(let e=g;e<A;e++){const w=this.c[e];w.startLineNumber>b&&m.push(new L(b,w.startLineNumber)),b=w.endLineNumberExclusive}return b<s.endLineNumberExclusive&&m.push(new L(b,s.endLineNumberExclusive)),new d(m)}toString(){return this.c.map(s=>s.toString()).join(", ")}getIntersection(s){const g=[];let A=0,m=0;for(;A<this.c.length&&m<s.c.length;){const b=this.c[A],e=s.c[m],w=b.intersect(e);w&&!w.isEmpty&&g.push(w),b.endLineNumberExclusive<e.endLineNumberExclusive?A++:m++}return new d(g)}getWithDelta(s){return new d(this.c.map(g=>g.delta(s)))}}t.$ws=d}),te(ie[45],se([0,1,5,2]),function(O,t,k,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$os=t.SelectionDirection=void 0;var r;(function(L){L[L.LTR=0]="LTR",L[L.RTL=1]="RTL"})(r||(t.SelectionDirection=r={}));class c extends _.$ms{constructor(d,l,s,g){super(d,l,s,g),this.selectionStartLineNumber=d,this.selectionStartColumn=l,this.positionLineNumber=s,this.positionColumn=g}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(d){return c.selectionsEqual(this,d)}static selectionsEqual(d,l){return d.selectionStartLineNumber===l.selectionStartLineNumber&&d.selectionStartColumn===l.selectionStartColumn&&d.positionLineNumber===l.positionLineNumber&&d.positionColumn===l.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(d,l){return this.getDirection()===0?new c(this.startLineNumber,this.startColumn,d,l):new c(d,l,this.startLineNumber,this.startColumn)}getPosition(){return new k.$ls(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new k.$ls(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(d,l){return this.getDirection()===0?new c(d,l,this.endLineNumber,this.endColumn):new c(this.endLineNumber,this.endColumn,d,l)}static fromPositions(d,l=d){return new c(d.lineNumber,d.column,l.lineNumber,l.column)}static fromRange(d,l){return l===0?new c(d.startLineNumber,d.startColumn,d.endLineNumber,d.endColumn):new c(d.endLineNumber,d.endColumn,d.startLineNumber,d.startColumn)}static liftSelection(d){return new c(d.selectionStartLineNumber,d.selectionStartColumn,d.positionLineNumber,d.positionColumn)}static selectionsArrEqual(d,l){if(d&&!l||!d&&l)return!1;if(!d&&!l)return!0;if(d.length!==l.length)return!1;for(let s=0,g=d.length;s<g;s++)if(!this.selectionsEqual(d[s],l[s]))return!1;return!0}static isISelection(d){return d&&typeof d.selectionStartLineNumber=="number"&&typeof d.selectionStartColumn=="number"&&typeof d.positionLineNumber=="number"&&typeof d.positionColumn=="number"}static createWithDirection(d,l,s,g,A){return A===0?new c(d,l,s,g):new c(s,g,d,l)}}t.$os=c}),te(ie[46],se([0,1,28]),function(O,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ms=t.$Ls=t.WordCharacterClass=void 0;var _;(function(L){L[L.Regular=0]="Regular",L[L.Whitespace=1]="Whitespace",L[L.WordSeparator=2]="WordSeparator"})(_||(t.WordCharacterClass=_={}));class r extends k.$Js{constructor(d){super(0);for(let l=0,s=d.length;l<s;l++)this.set(d.charCodeAt(l),2);this.set(32,1),this.set(9,1)}}t.$Ls=r;function c(L){const d={};return l=>(d.hasOwnProperty(l)||(d[l]=L(l)),d[l])}t.$Ms=c(L=>new r(L))}),te(ie[29],se([0,1,20,10,21]),function(O,t,k,_,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$2r=t.$1r=t.$Zr=t.$Yr=t.$Xr=void 0,t.$Xr="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function c(A=""){let m="(-?\\d*\\.\\d\\w*)|([^";for(const b of t.$Xr)A.indexOf(b)>=0||(m+="\\"+b);return m+="\\s]+)",new RegExp(m,"g")}t.$Yr=c();function L(A){let m=t.$Yr;if(A&&A instanceof RegExp)if(A.global)m=A;else{let b="g";A.ignoreCase&&(b+="i"),A.multiline&&(b+="m"),A.unicode&&(b+="u"),m=new RegExp(A.source,b)}return m.lastIndex=0,m}t.$Zr=L;const d=new r.$Zc;d.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function l(A){const m=d.unshift(A);return(0,_.$Oc)(m)}t.$1r=l;function s(A,m,b,e,w){if(w||(w=k.Iterable.first(d)),b.length>w.maxLen){let f=A-w.maxLen/2;return f<0?f=0:e+=f,b=b.substring(f,A+w.maxLen/2),s(A,m,b,e,w)}const R=Date.now(),E=A-1-e;let h=-1,o=null;for(let f=1;!(Date.now()-R>=w.timeBudget);f++){const u=E-w.windowSize*f;m.lastIndex=Math.max(0,u);const i=g(m,b,E,h);if(!i&&o||(o=i,u<=0))break;h=u}if(o){const f={word:o[0],startColumn:e+1+o.index,endColumn:e+1+o.index+o[0].length};return m.lastIndex=0,f}return null}t.$2r=s;function g(A,m,b,e){let w;for(;w=A.exec(m);){const R=w.index||0;if(R<=b&&A.lastIndex>=b)return w;if(e>0&&R>e)return null}return null}}),te(ie[8],se([0,1,6,3,4]),function(O,t,k,_,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$VY=t.$UY=t.$TY=t.$SY=t.$RY=void 0;class c{static trivial(A,m){return new c([new L(r.$ts.ofLength(A.length),r.$ts.ofLength(m.length))],!1)}static trivialTimedOut(A,m){return new c([new L(r.$ts.ofLength(A.length),r.$ts.ofLength(m.length))],!0)}constructor(A,m){this.diffs=A,this.hitTimeout=m}}t.$RY=c;class L{static invert(A,m){const b=[];return(0,k.$zb)(A,(e,w)=>{b.push(L.fromOffsetPairs(e?e.getEndExclusives():d.zero,w?w.getStarts():new d(m,(e?e.seq2Range.endExclusive-e.seq1Range.endExclusive:0)+m)))}),b}static fromOffsetPairs(A,m){return new L(new r.$ts(A.offset1,m.offset1),new r.$ts(A.offset2,m.offset2))}constructor(A,m){this.seq1Range=A,this.seq2Range=m}swap(){return new L(this.seq2Range,this.seq1Range)}toString(){return`${this.seq1Range} <-> ${this.seq2Range}`}join(A){return new L(this.seq1Range.join(A.seq1Range),this.seq2Range.join(A.seq2Range))}delta(A){return A===0?this:new L(this.seq1Range.delta(A),this.seq2Range.delta(A))}deltaStart(A){return A===0?this:new L(this.seq1Range.deltaStart(A),this.seq2Range.deltaStart(A))}deltaEnd(A){return A===0?this:new L(this.seq1Range.deltaEnd(A),this.seq2Range.deltaEnd(A))}intersectsOrTouches(A){return this.seq1Range.intersectsOrTouches(A.seq1Range)||this.seq2Range.intersectsOrTouches(A.seq2Range)}intersect(A){const m=this.seq1Range.intersect(A.seq1Range),b=this.seq2Range.intersect(A.seq2Range);if(!(!m||!b))return new L(m,b)}getStarts(){return new d(this.seq1Range.start,this.seq2Range.start)}getEndExclusives(){return new d(this.seq1Range.endExclusive,this.seq2Range.endExclusive)}}t.$SY=L;class d{constructor(A,m){this.offset1=A,this.offset2=m}toString(){return`${this.offset1} <-> ${this.offset2}`}}t.$TY=d,d.zero=new d(0,0),d.max=new d(Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER);class l{isValid(){return!0}}t.$UY=l,l.instance=new l;class s{constructor(A){if(this.e=A,this.c=Date.now(),this.d=!0,A<=0)throw new _.$ab("timeout must be positive")}isValid(){if(!(Date.now()-this.c<this.e)&&this.d){this.d=!1;debugger}return this.d}disable(){this.e=Number.MAX_SAFE_INTEGER,this.isValid=()=>!0,this.d=!0}}t.$VY=s}),te(ie[30],se([0,1,4,8]),function(O,t,k,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$1Y=void 0;class r{compute(s,g,A=_.$UY.instance){if(s.length===0||g.length===0)return _.$RY.trivial(s,g);const m=s,b=g;function e(a,N){for(;a<m.length&&N<b.length&&m.getElement(a)===b.getElement(N);)a++,N++;return a}let w=0;const R=new L;R.set(0,e(0,0));const E=new d;E.set(0,R.get(0)===0?null:new c(null,0,0,R.get(0)));let h=0;e:for(;;){if(w++,!A.isValid())return _.$RY.trivialTimedOut(m,b);const a=-Math.min(w,b.length+w%2),N=Math.min(w,m.length+w%2);for(h=a;h<=N;h+=2){let $=0;const v=h===N?-1:R.get(h+1),p=h===a?-1:R.get(h-1)+1;$++;const M=Math.min(Math.max(v,p),m.length),P=M-h;if($++,M>m.length||P>b.length)continue;const F=e(M,P);R.set(h,F);const y=M===v?E.get(h+1):E.get(h-1);if(E.set(h,F!==M?new c(y,M,P,F-M):y),R.get(h)===m.length&&R.get(h)-h===b.length)break e}}let o=E.get(h);const f=[];let u=m.length,i=b.length;for(;;){const a=o?o.x+o.length:0,N=o?o.y+o.length:0;if((a!==u||N!==i)&&f.push(new _.$SY(new k.$ts(a,u),new k.$ts(N,i))),!o)break;u=o.x,i=o.y,o=o.prev}return f.reverse(),new _.$RY(f,!1)}}t.$1Y=r;class c{constructor(s,g,A,m){this.prev=s,this.x=g,this.y=A,this.length=m}}class L{constructor(){this.a=new Int32Array(10),this.b=new Int32Array(10)}get(s){return s<0?(s=-s-1,this.b[s]):this.a[s]}set(s,g){if(s<0){if(s=-s-1,s>=this.b.length){const A=this.b;this.b=new Int32Array(A.length*2),this.b.set(A)}this.b[s]=g}else{if(s>=this.a.length){const A=this.a;this.a=new Int32Array(A.length*2),this.a.set(A)}this.a[s]=g}}}class d{constructor(){this.a=[],this.b=[]}get(s){return s<0?(s=-s-1,this.b[s]):this.a[s]}set(s,g){s<0?(s=-s-1,this.b[s]=g):this.a[s]=g}}}),te(ie[47],se([0,1,6,4,8]),function(O,t,k,_,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$9Y=t.$8Y=t.$7Y=t.$6Y=t.$5Y=void 0;function c(e,w,R){let E=R;return E=L(e,w,E),E=d(e,w,E),E}t.$5Y=c;function L(e,w,R){if(R.length===0)return R;const E=[];E.push(R[0]);for(let o=1;o<R.length;o++){const f=E[E.length-1];let u=R[o];if(u.seq1Range.isEmpty||u.seq2Range.isEmpty){const i=u.seq1Range.start-f.seq1Range.endExclusive;let a;for(a=1;a<=i&&!(e.getElement(u.seq1Range.start-a)!==e.getElement(u.seq1Range.endExclusive-a)||w.getElement(u.seq2Range.start-a)!==w.getElement(u.seq2Range.endExclusive-a));a++);if(a--,a===i){E[E.length-1]=new r.$SY(new _.$ts(f.seq1Range.start,u.seq1Range.endExclusive-i),new _.$ts(f.seq2Range.start,u.seq2Range.endExclusive-i));continue}u=u.delta(-a)}E.push(u)}const h=[];for(let o=0;o<E.length-1;o++){const f=E[o+1];let u=E[o];if(u.seq1Range.isEmpty||u.seq2Range.isEmpty){const i=f.seq1Range.start-u.seq1Range.endExclusive;let a;for(a=0;a<i&&!(!e.isStronglyEqual(u.seq1Range.start+a,u.seq1Range.endExclusive+a)||!w.isStronglyEqual(u.seq2Range.start+a,u.seq2Range.endExclusive+a));a++);if(a===i){E[o+1]=new r.$SY(new _.$ts(u.seq1Range.start+i,f.seq1Range.endExclusive),new _.$ts(u.seq2Range.start+i,f.seq2Range.endExclusive));continue}a>0&&(u=u.delta(a))}h.push(u)}return E.length>0&&h.push(E[E.length-1]),h}function d(e,w,R){if(!e.getBoundaryScore||!w.getBoundaryScore)return R;for(let E=0;E<R.length;E++){const h=E>0?R[E-1]:void 0,o=R[E],f=E+1<R.length?R[E+1]:void 0,u=new _.$ts(h?h.seq1Range.start+1:0,f?f.seq1Range.endExclusive-1:e.length),i=new _.$ts(h?h.seq2Range.start+1:0,f?f.seq2Range.endExclusive-1:w.length);o.seq1Range.isEmpty?R[E]=l(o,e,w,u,i):o.seq2Range.isEmpty&&(R[E]=l(o.swap(),w,e,i,u).swap())}return R}function l(e,w,R,E,h){let f=1;for(;e.seq1Range.start-f>=E.start&&e.seq2Range.start-f>=h.start&&R.isStronglyEqual(e.seq2Range.start-f,e.seq2Range.endExclusive-f)&&f<100;)f++;f--;let u=0;for(;e.seq1Range.start+u<E.endExclusive&&e.seq2Range.endExclusive+u<h.endExclusive&&R.isStronglyEqual(e.seq2Range.start+u,e.seq2Range.endExclusive+u)&&u<100;)u++;if(f===0&&u===0)return e;let i=0,a=-1;for(let N=-f;N<=u;N++){const $=e.seq2Range.start+N,v=e.seq2Range.endExclusive+N,p=e.seq1Range.start+N,M=w.getBoundaryScore(p)+R.getBoundaryScore($)+R.getBoundaryScore(v);M>a&&(a=M,i=N)}return e.delta(i)}function s(e,w,R){const E=[];for(const h of R){const o=E[E.length-1];if(!o){E.push(h);continue}h.seq1Range.start-o.seq1Range.endExclusive<=2||h.seq2Range.start-o.seq2Range.endExclusive<=2?E[E.length-1]=new r.$SY(o.seq1Range.join(h.seq1Range),o.seq2Range.join(h.seq2Range)):E.push(h)}return E}t.$6Y=s;function g(e,w,R){const E=[];let h;function o(){if(!h)return;const u=h.s1Range.length-h.deleted,i=h.s2Range.length-h.added;Math.max(h.deleted,h.added)+(h.count-1)>u&&E.push(new r.$SY(h.s1Range,h.s2Range)),h=void 0}for(const u of R){let i=function(p,M){if(!h||!h.s1Range.containsRange(p)||!h.s2Range.containsRange(M))if(h&&!(h.s1Range.endExclusive<p.start&&h.s2Range.endExclusive<M.start)){const y=_.$ts.tryCreate(h.s1Range.endExclusive,p.start),D=_.$ts.tryCreate(h.s2Range.endExclusive,M.start);h.deleted+=y?.length??0,h.added+=D?.length??0,h.s1Range=h.s1Range.join(p),h.s2Range=h.s2Range.join(M)}else o(),h={added:0,deleted:0,count:0,s1Range:p,s2Range:M};const P=p.intersect(u.seq1Range),F=M.intersect(u.seq2Range);h.count++,h.deleted+=P?.length??0,h.added+=F?.length??0};const a=e.findWordContaining(u.seq1Range.start-1),N=w.findWordContaining(u.seq2Range.start-1),$=e.findWordContaining(u.seq1Range.endExclusive),v=w.findWordContaining(u.seq2Range.endExclusive);a&&$&&N&&v&&a.equals($)&&N.equals(v)?i(a,N):(a&&N&&i(a,N),$&&v&&i($,v))}return o(),A(R,E)}t.$7Y=g;function A(e,w){const R=[];for(;e.length>0||w.length>0;){const E=e[0],h=w[0];let o;E&&(!h||E.seq1Range.start<h.seq1Range.start)?o=e.shift():o=w.shift(),R.length>0&&R[R.length-1].seq1Range.endExclusive>=o.seq1Range.start?R[R.length-1]=R[R.length-1].join(o):R.push(o)}return R}function m(e,w,R){let E=R;if(E.length===0)return E;let h=0,o;do{o=!1;const f=[E[0]];for(let u=1;u<E.length;u++){let N=function(v,p){const M=new _.$ts(a.seq1Range.endExclusive,i.seq1Range.start);return e.getText(M).replace(/\s/g,"").length<=4&&(v.seq1Range.length+v.seq2Range.length>5||p.seq1Range.length+p.seq2Range.length>5)};const i=E[u],a=f[f.length-1];N(a,i)?(o=!0,f[f.length-1]=f[f.length-1].join(i)):f.push(i)}E=f}while(h++<10&&o);return E}t.$8Y=m;function b(e,w,R){let E=R;if(E.length===0)return E;let h=0,o;do{o=!1;const u=[E[0]];for(let i=1;i<E.length;i++){let $=function(p,M){const P=new _.$ts(N.seq1Range.endExclusive,a.seq1Range.start);if(e.countLinesIn(P)>5||P.length>500)return!1;const y=e.getText(P).trim();if(y.length>20||y.split(/\r\n|\r|\n/).length>1)return!1;const D=e.countLinesIn(p.seq1Range),q=p.seq1Range.length,I=w.countLinesIn(p.seq2Range),x=p.seq2Range.length,T=e.countLinesIn(M.seq1Range),j=M.seq1Range.length,z=w.countLinesIn(M.seq2Range),C=M.seq2Range.length,X=2*40+50;function n(ne){return Math.min(ne,X)}return Math.pow(Math.pow(n(D*40+q),1.5)+Math.pow(n(I*40+x),1.5),1.5)+Math.pow(Math.pow(n(T*40+j),1.5)+Math.pow(n(z*40+C),1.5),1.5)>(X**1.5)**1.5*1.3};const a=E[i],N=u[u.length-1];$(N,a)?(o=!0,u[u.length-1]=u[u.length-1].join(a)):u.push(a)}E=u}while(h++<10&&o);const f=[];return(0,k.$Ab)(E,(u,i,a)=>{let N=i;function $(y){return y.length>0&&y.trim().length<=3&&i.seq1Range.length+i.seq2Range.length>100}const v=e.extendToFullLines(i.seq1Range),p=e.getText(new _.$ts(v.start,i.seq1Range.start));$(p)&&(N=N.deltaStart(-p.length));const M=e.getText(new _.$ts(i.seq1Range.endExclusive,v.endExclusive));$(M)&&(N=N.deltaEnd(M.length));const P=r.$SY.fromOffsetPairs(u?u.getEndExclusives():r.$TY.zero,a?a.getStarts():r.$TY.max),F=N.intersect(P);f.push(F)}),f}t.$9Y=b}),te(ie[48],se([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$4Y=void 0;class k{constructor(c,L){this.a=c,this.b=L}getElement(c){return this.a[c]}get length(){return this.a.length}getBoundaryScore(c){const L=c===0?0:_(this.b[c-1]),d=c===this.b.length?0:_(this.b[c]);return 1e3-(L+d)}getText(c){return this.b.slice(c.start,c.endExclusive).join(`
`)}isStronglyEqual(c,L){return this.b[c]===this.b[L]}}t.$4Y=k;function _(r){let c=0;for(;c<r.length&&(r.charCodeAt(c)===32||r.charCodeAt(c)===9);)c++;return c}}),te(ie[17],se([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$YY=t.$XY=t.$WY=void 0;class k{constructor(L,d){this.width=L,this.height=d,this.a=[],this.a=new Array(L*d)}get(L,d){return this.a[L+d*this.width]}set(L,d,l){this.a[L+d*this.width]=l}}t.$WY=k;function _(c){return c===32||c===9}t.$XY=_;class r{static b(L){let d=this.a.get(L);return d===void 0&&(d=this.a.size,this.a.set(L,d)),d}constructor(L,d,l){this.range=L,this.lines=d,this.source=l,this.d=[];let s=0;for(let g=L.startLineNumber-1;g<L.endLineNumberExclusive-1;g++){const A=d[g];for(let b=0;b<A.length;b++){s++;const e=A[b],w=r.b(e);this.d[w]=(this.d[w]||0)+1}s++;const m=r.b(`
`);this.d[m]=(this.d[m]||0)+1}this.c=s}computeSimilarity(L){let d=0;const l=Math.max(this.d.length,L.d.length);for(let s=0;s<l;s++)d+=Math.abs((this.d[s]??0)-(L.d[s]??0));return 1-d/(this.c+L.c)}}t.$YY=r,r.a=new Map}),te(ie[49],se([0,1,4,8,17]),function(O,t,k,_,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ZY=void 0;class c{compute(d,l,s=_.$UY.instance,g){if(d.length===0||l.length===0)return _.$RY.trivial(d,l);const A=new r.$WY(d.length,l.length),m=new r.$WY(d.length,l.length),b=new r.$WY(d.length,l.length);for(let f=0;f<d.length;f++)for(let u=0;u<l.length;u++){if(!s.isValid())return _.$RY.trivialTimedOut(d,l);const i=f===0?0:A.get(f-1,u),a=u===0?0:A.get(f,u-1);let N;d.getElement(f)===l.getElement(u)?(f===0||u===0?N=0:N=A.get(f-1,u-1),f>0&&u>0&&m.get(f-1,u-1)===3&&(N+=b.get(f-1,u-1)),N+=g?g(f,u):1):N=-1;const $=Math.max(i,a,N);if($===N){const v=f>0&&u>0?b.get(f-1,u-1):0;b.set(f,u,v+1),m.set(f,u,3)}else $===i?(b.set(f,u,0),m.set(f,u,1)):$===a&&(b.set(f,u,0),m.set(f,u,2));A.set(f,u,$)}const e=[];let w=d.length,R=l.length;function E(f,u){(f+1!==w||u+1!==R)&&e.push(new _.$SY(new k.$ts(f+1,w),new k.$ts(u+1,R))),w=f,R=u}let h=d.length-1,o=l.length-1;for(;h>=0&&o>=0;)m.get(h,o)===3?(E(h,o),h--,o--):m.get(h,o)===1?h--:o--;return E(-1,-1),e.reverse(),new _.$RY(e,!1)}}t.$ZY=c}),te(ie[31],se([0,1,9,4,5,2,17]),function(O,t,k,_,r,c,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$2Y=void 0;class d{constructor(e,w,R){this.lines=e,this.considerWhitespaceChanges=R,this.b=[],this.c=[],this.d=[];let E=!1;w.start>0&&w.endExclusive>=e.length&&(w=new _.$ts(w.start-1,w.endExclusive),E=!0),this.lineRange=w,this.c[0]=0;for(let h=this.lineRange.start;h<this.lineRange.endExclusive;h++){let o=e[h],f=0;if(E)f=o.length,o="",E=!1;else if(!R){const u=o.trimStart();f=o.length-u.length,o=u.trimEnd()}this.d.push(f);for(let u=0;u<o.length;u++)this.b.push(o.charCodeAt(u));h<e.length-1&&(this.b.push(`
`.charCodeAt(0)),this.c[h-this.lineRange.start+1]=this.b.length)}this.d.push(0)}toString(){return`Slice: "${this.text}"`}get text(){return this.getText(new _.$ts(0,this.length))}getText(e){return this.b.slice(e.start,e.endExclusive).map(w=>String.fromCharCode(w)).join("")}getElement(e){return this.b[e]}get length(){return this.b.length}getBoundaryScore(e){const w=m(e>0?this.b[e-1]:-1),R=m(e<this.b.length?this.b[e]:-1);if(w===6&&R===7)return 0;let E=0;return w!==R&&(E+=10,w===0&&R===1&&(E+=1)),E+=A(w),E+=A(R),E}translateOffset(e){if(this.lineRange.isEmpty)return new r.$ls(this.lineRange.start+1,1);const w=(0,k.$gb)(this.c,R=>R<=e);return new r.$ls(this.lineRange.start+w+1,e-this.c[w]+this.d[w]+1)}translateRange(e){return c.$ms.fromPositions(this.translateOffset(e.start),this.translateOffset(e.endExclusive))}findWordContaining(e){if(e<0||e>=this.b.length||!l(this.b[e]))return;let w=e;for(;w>0&&l(this.b[w-1]);)w--;let R=e;for(;R<this.b.length&&l(this.b[R]);)R++;return new _.$ts(w,R)}countLinesIn(e){return this.translateOffset(e.endExclusive).lineNumber-this.translateOffset(e.start).lineNumber}isStronglyEqual(e,w){return this.b[e]===this.b[w]}extendToFullLines(e){const w=(0,k.$fb)(this.c,E=>E<=e.start)??0,R=(0,k.$hb)(this.c,E=>e.endExclusive<=E)??this.b.length;return new _.$ts(w,R)}}t.$2Y=d;function l(b){return b>=97&&b<=122||b>=65&&b<=90||b>=48&&b<=57}var s;(function(b){b[b.WordLower=0]="WordLower",b[b.WordUpper=1]="WordUpper",b[b.WordNumber=2]="WordNumber",b[b.End=3]="End",b[b.Other=4]="Other",b[b.Space=5]="Space",b[b.LineBreakCR=6]="LineBreakCR",b[b.LineBreakLF=7]="LineBreakLF"})(s||(s={}));const g={[0]:0,[1]:0,[2]:0,[3]:10,[4]:2,[5]:3,[6]:10,[7]:10};function A(b){return g[b]}function m(b){return b===10?7:b===13?6:(0,L.$XY)(b)?5:b>=97&&b<=122?0:b>=65&&b<=90?1:b>=48&&b<=57?2:b===-1?3:4}}),te(ie[32],se([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Bs=t.$As=void 0;class k{constructor(c,L,d){this.changes=c,this.moves=L,this.hitTimeout=d}}t.$As=k;class _{constructor(c,L){this.lineRangeMapping=c,this.changes=L}flip(){return new _(this.lineRangeMapping.flip(),this.changes.map(c=>c.flip()))}}t.$Bs=_}),te(ie[18],se([0,1,12]),function(O,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$zs=t.$ys=t.$xs=void 0;class _{static inverse(d,l,s){const g=[];let A=1,m=1;for(const e of d){const w=new r(new k.$vs(A,e.original.startLineNumber),new k.$vs(m,e.modified.startLineNumber),void 0);w.modified.isEmpty||g.push(w),A=e.original.endLineNumberExclusive,m=e.modified.endLineNumberExclusive}const b=new r(new k.$vs(A,l+1),new k.$vs(m,s+1),void 0);return b.modified.isEmpty||g.push(b),g}constructor(d,l){this.original=d,this.modified=l}toString(){return`{${this.original.toString()}->${this.modified.toString()}}`}flip(){return new _(this.modified,this.original)}join(d){return new _(this.original.join(d.original),this.modified.join(d.modified))}get changedLineCount(){return Math.max(this.original.length,this.modified.length)}}t.$xs=_;class r extends _{constructor(d,l,s){super(d,l),this.innerChanges=s}flip(){return new r(this.modified,this.original,this.innerChanges?.map(d=>d.flip()))}}t.$ys=r;class c{constructor(d,l){this.originalRange=d,this.modifiedRange=l}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}flip(){return new c(this.modifiedRange,this.originalRange)}}t.$zs=c}),te(ie[50],se([0,1,8,18,6,9,22,12,4,31,17,30]),function(O,t,k,_,r,c,L,d,l,s,g,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$3Y=void 0;function m(h,o,f,u,i,a){let{moves:N,excludedChanges:$}=b(h,o,f,a);if(!a.isValid())return[];const v=h.filter(M=>!$.has(M)),p=e(v,u,i,o,f,a);return(0,r.$Yb)(N,p),N=R(N),N=N.filter(M=>M.original.toOffsetRange().slice(o).map(F=>F.trim()).join(`
`).length>=10),N=E(h,N),N}t.$3Y=m;function b(h,o,f,u){const i=[],a=h.filter(v=>v.modified.isEmpty&&v.original.length>=3).map(v=>new g.$YY(v.original,o,v)),N=new Set(h.filter(v=>v.original.isEmpty&&v.modified.length>=3).map(v=>new g.$YY(v.modified,f,v))),$=new Set;for(const v of a){let p=-1,M;for(const P of N){const F=v.computeSimilarity(P);F>p&&(p=F,M=P)}if(p>.9&&M&&(N.delete(M),i.push(new _.$xs(v.range,M.range)),$.add(v.source),$.add(M.source)),!u.isValid())return{moves:i,excludedChanges:$}}return{moves:i,excludedChanges:$}}function e(h,o,f,u,i,a){const N=[],$=new L.$Ec;for(const F of h)for(let y=F.original.startLineNumber;y<F.original.endLineNumberExclusive-2;y++){const D=`${o[y-1]}:${o[y+1-1]}:${o[y+2-1]}`;$.add(D,{range:new d.$vs(y,y+3)})}const v=[];h.sort((0,r.$5b)(F=>F.modified.startLineNumber,r.$7b));for(const F of h){let y=[];for(let D=F.modified.startLineNumber;D<F.modified.endLineNumberExclusive-2;D++){const q=`${f[D-1]}:${f[D+1-1]}:${f[D+2-1]}`,I=new d.$vs(D,D+3),x=[];$.forEach(q,({range:T})=>{for(const z of y)if(z.originalLineRange.endLineNumberExclusive+1===T.endLineNumberExclusive&&z.modifiedLineRange.endLineNumberExclusive+1===I.endLineNumberExclusive){z.originalLineRange=new d.$vs(z.originalLineRange.startLineNumber,T.endLineNumberExclusive),z.modifiedLineRange=new d.$vs(z.modifiedLineRange.startLineNumber,I.endLineNumberExclusive),x.push(z);return}const j={modifiedLineRange:I,originalLineRange:T};v.push(j),x.push(j)}),y=x}if(!a.isValid())return[]}v.sort((0,r.$9b)((0,r.$5b)(F=>F.modifiedLineRange.length,r.$7b)));const p=new d.$ws,M=new d.$ws;for(const F of v){const y=F.modifiedLineRange.startLineNumber-F.originalLineRange.startLineNumber,D=p.subtractFrom(F.modifiedLineRange),q=M.subtractFrom(F.originalLineRange).getWithDelta(y),I=D.getIntersection(q);for(const x of I.ranges){if(x.length<3)continue;const T=x,j=x.delta(-y);N.push(new _.$xs(j,T)),p.addRange(T),M.addRange(j)}}N.sort((0,r.$5b)(F=>F.original.startLineNumber,r.$7b));const P=new c.$kb(h);for(let F=0;F<N.length;F++){const y=N[F],D=P.findLastMonotonous(X=>X.original.startLineNumber<=y.original.startLineNumber),q=(0,c.$fb)(h,X=>X.modified.startLineNumber<=y.modified.startLineNumber),I=Math.max(y.original.startLineNumber-D.original.startLineNumber,y.modified.startLineNumber-q.modified.startLineNumber),x=P.findLastMonotonous(X=>X.original.startLineNumber<y.original.endLineNumberExclusive),T=(0,c.$fb)(h,X=>X.modified.startLineNumber<y.modified.endLineNumberExclusive),j=Math.max(x.original.endLineNumberExclusive-y.original.endLineNumberExclusive,T.modified.endLineNumberExclusive-y.modified.endLineNumberExclusive);let z;for(z=0;z<I;z++){const X=y.original.startLineNumber-z-1,n=y.modified.startLineNumber-z-1;if(X>u.length||n>i.length||p.contains(n)||M.contains(X)||!w(u[X-1],i[n-1],a))break}z>0&&(M.addRange(new d.$vs(y.original.startLineNumber-z,y.original.startLineNumber)),p.addRange(new d.$vs(y.modified.startLineNumber-z,y.modified.startLineNumber)));let C;for(C=0;C<j;C++){const X=y.original.endLineNumberExclusive+C,n=y.modified.endLineNumberExclusive+C;if(X>u.length||n>i.length||p.contains(n)||M.contains(X)||!w(u[X-1],i[n-1],a))break}C>0&&(M.addRange(new d.$vs(y.original.endLineNumberExclusive,y.original.endLineNumberExclusive+C)),p.addRange(new d.$vs(y.modified.endLineNumberExclusive,y.modified.endLineNumberExclusive+C))),(z>0||C>0)&&(N[F]=new _.$xs(new d.$vs(y.original.startLineNumber-z,y.original.endLineNumberExclusive+C),new d.$vs(y.modified.startLineNumber-z,y.modified.endLineNumberExclusive+C)))}return N}function w(h,o,f){if(h.trim()===o.trim())return!0;if(h.length>300&&o.length>300)return!1;const i=new A.$1Y().compute(new s.$2Y([h],new l.$ts(0,1),!1),new s.$2Y([o],new l.$ts(0,1),!1),f);let a=0;const N=k.$SY.invert(i.diffs,h.length);for(const M of N)M.seq1Range.forEach(P=>{(0,g.$XY)(h.charCodeAt(P))||a++});function $(M){let P=0;for(let F=0;F<h.length;F++)(0,g.$XY)(M.charCodeAt(F))||P++;return P}const v=$(h.length>o.length?h:o);return a/v>.6&&v>10}function R(h){if(h.length===0)return h;h.sort((0,r.$5b)(f=>f.original.startLineNumber,r.$7b));const o=[h[0]];for(let f=1;f<h.length;f++){const u=o[o.length-1],i=h[f],a=i.original.startLineNumber-u.original.endLineNumberExclusive,N=i.modified.startLineNumber-u.modified.endLineNumberExclusive;if(a>=0&&N>=0&&a+N<=2){o[o.length-1]=u.join(i);continue}o.push(i)}return o}function E(h,o){const f=new c.$kb(h);return o=o.filter(u=>{const i=f.findLastMonotonous($=>$.original.endLineNumberExclusive<u.original.endLineNumberExclusive)||new _.$xs(new d.$vs(1,1),new d.$vs(1,1)),a=(0,c.$fb)(h,$=>$.modified.endLineNumberExclusive<u.modified.endLineNumberExclusive);return i!==a}),o}}),te(ie[51],se([0,1,6,13,12,4,2,8,49,30,50,47,32,18,31,48]),function(O,t,k,_,r,c,L,d,l,s,g,A,m,b,e,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$_Y=t.$$Y=t.$0Y=void 0;class R{constructor(){this.e=new l.$ZY,this.f=new s.$1Y}computeDiff(f,u,i){if(f.length<=1&&(0,k.$sb)(f,u,(X,n)=>X===n))return new m.$As([],[],!1);if(f.length===1&&f[0].length===0||u.length===1&&u[0].length===0)return new m.$As([new b.$ys(new r.$vs(1,f.length+1),new r.$vs(1,u.length+1),[new b.$zs(new L.$ms(1,1,f.length,f[0].length+1),new L.$ms(1,1,u.length,u[0].length+1))])],[],!1);const a=i.maxComputationTimeMs===0?d.$UY.instance:new d.$VY(i.maxComputationTimeMs),N=!i.ignoreTrimWhitespace,$=new Map;function v(X){let n=$.get(X);return n===void 0&&(n=$.size,$.set(X,n)),n}const p=f.map(X=>v(X.trim())),M=u.map(X=>v(X.trim())),P=new w.$4Y(p,f),F=new w.$4Y(M,u),y=(()=>P.length+F.length<1700?this.e.compute(P,F,a,(X,n)=>f[X]===u[n]?u[n].length===0?.1:1+Math.log(1+u[n].length):.99):this.f.compute(P,F))();let D=y.diffs,q=y.hitTimeout;D=(0,A.$5Y)(P,F,D),D=(0,A.$8Y)(P,F,D);const I=[],x=X=>{if(N)for(let n=0;n<X;n++){const ne=T+n,oe=j+n;if(f[ne]!==u[oe]){const me=this.j(f,u,new d.$SY(new c.$ts(ne,ne+1),new c.$ts(oe,oe+1)),a,N);for(const Ne of me.mappings)I.push(Ne);me.hitTimeout&&(q=!0)}}};let T=0,j=0;for(const X of D){(0,_.$4c)(()=>X.seq1Range.start-T===X.seq2Range.start-j);const n=X.seq1Range.start-T;x(n),T=X.seq1Range.endExclusive,j=X.seq2Range.endExclusive;const ne=this.j(f,u,X,a,N);ne.hitTimeout&&(q=!0);for(const oe of ne.mappings)I.push(oe)}x(f.length-T);const z=E(I,f,u);let C=[];return i.computeMoves&&(C=this.h(z,f,u,p,M,a,N)),(0,_.$4c)(()=>{function X(ne,oe){if(ne.lineNumber<1||ne.lineNumber>oe.length)return!1;const me=oe[ne.lineNumber-1];return!(ne.column<1||ne.column>me.length+1)}function n(ne,oe){return!(ne.startLineNumber<1||ne.startLineNumber>oe.length+1||ne.endLineNumberExclusive<1||ne.endLineNumberExclusive>oe.length+1)}for(const ne of z){if(!ne.innerChanges)return!1;for(const oe of ne.innerChanges)if(!(X(oe.modifiedRange.getStartPosition(),u)&&X(oe.modifiedRange.getEndPosition(),u)&&X(oe.originalRange.getStartPosition(),f)&&X(oe.originalRange.getEndPosition(),f)))return!1;if(!n(ne.modified,u)||!n(ne.original,f))return!1}return!0}),new m.$As(z,C,q)}h(f,u,i,a,N,$,v){return(0,g.$3Y)(f,u,i,a,N,$).map(P=>{const F=this.j(u,i,new d.$SY(P.original.toOffsetRange(),P.modified.toOffsetRange()),$,v),y=E(F.mappings,u,i,!0);return new m.$Bs(P,y)})}j(f,u,i,a,N){const $=new e.$2Y(f,i.seq1Range,N),v=new e.$2Y(u,i.seq2Range,N),p=$.length+v.length<500?this.e.compute($,v,a):this.f.compute($,v,a);let M=p.diffs;return M=(0,A.$5Y)($,v,M),M=(0,A.$7Y)($,v,M),M=(0,A.$6Y)($,v,M),M=(0,A.$9Y)($,v,M),{mappings:M.map(F=>new b.$zs($.translateRange(F.seq1Range),v.translateRange(F.seq2Range))),hitTimeout:p.hitTimeout}}}t.$0Y=R;function E(o,f,u,i=!1){const a=[];for(const N of(0,k.$yb)(o.map($=>h($,f,u)),($,v)=>$.original.overlapOrTouch(v.original)||$.modified.overlapOrTouch(v.modified))){const $=N[0],v=N[N.length-1];a.push(new b.$ys($.original.join(v.original),$.modified.join(v.modified),N.map(p=>p.innerChanges[0])))}return(0,_.$4c)(()=>!i&&a.length>0&&a[0].original.startLineNumber!==a[0].modified.startLineNumber?!1:(0,_.$5c)(a,(N,$)=>$.original.startLineNumber-N.original.endLineNumberExclusive===$.modified.startLineNumber-N.modified.endLineNumberExclusive&&N.original.endLineNumberExclusive<$.original.startLineNumber&&N.modified.endLineNumberExclusive<$.modified.startLineNumber)),a}t.$$Y=E;function h(o,f,u){let i=0,a=0;o.modifiedRange.endColumn===1&&o.originalRange.endColumn===1&&o.originalRange.startLineNumber+i<=o.originalRange.endLineNumber&&o.modifiedRange.startLineNumber+i<=o.modifiedRange.endLineNumber&&(a=-1),o.modifiedRange.startColumn-1>=u[o.modifiedRange.startLineNumber-1].length&&o.originalRange.startColumn-1>=f[o.originalRange.startLineNumber-1].length&&o.originalRange.startLineNumber<=o.originalRange.endLineNumber+a&&o.modifiedRange.startLineNumber<=o.modifiedRange.endLineNumber+a&&(i=1);const N=new r.$vs(o.originalRange.startLineNumber+i,o.originalRange.endLineNumber+1+a),$=new r.$vs(o.modifiedRange.startLineNumber+i,o.modifiedRange.endLineNumber+1+a);return new b.$ys(N,$,[o])}t.$_Y=h}),te(ie[33],se([0,1,25,32,18,7,2,13,12]),function(O,t,k,_,r,c,L,d,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ds=t.$Cs=void 0;const s=3;class g{computeDiff(i,a,N){const v=new E(i,a,{maxComputationTime:N.maxComputationTimeMs,shouldIgnoreTrimWhitespace:N.ignoreTrimWhitespace,shouldComputeCharChanges:!0,shouldMakePrettyDiff:!0,shouldPostProcessCharChanges:!0}).computeDiff(),p=[];let M=null;for(const P of v.changes){let F;P.originalEndLineNumber===0?F=new l.$vs(P.originalStartLineNumber+1,P.originalStartLineNumber+1):F=new l.$vs(P.originalStartLineNumber,P.originalEndLineNumber+1);let y;P.modifiedEndLineNumber===0?y=new l.$vs(P.modifiedStartLineNumber+1,P.modifiedStartLineNumber+1):y=new l.$vs(P.modifiedStartLineNumber,P.modifiedEndLineNumber+1);let D=new r.$ys(F,y,P.charChanges?.map(q=>new r.$zs(new L.$ms(q.originalStartLineNumber,q.originalStartColumn,q.originalEndLineNumber,q.originalEndColumn),new L.$ms(q.modifiedStartLineNumber,q.modifiedStartColumn,q.modifiedEndLineNumber,q.modifiedEndColumn))));M&&(M.modified.endLineNumberExclusive===D.modified.startLineNumber||M.original.endLineNumberExclusive===D.original.startLineNumber)&&(D=new r.$ys(M.original.join(D.original),M.modified.join(D.modified),M.innerChanges&&D.innerChanges?M.innerChanges.concat(D.innerChanges):void 0),p.pop()),p.push(D),M=D}return(0,d.$4c)(()=>(0,d.$5c)(p,(P,F)=>F.original.startLineNumber-P.original.endLineNumberExclusive===F.modified.startLineNumber-P.modified.endLineNumberExclusive&&P.original.endLineNumberExclusive<F.original.startLineNumber&&P.modified.endLineNumberExclusive<F.modified.startLineNumber)),new _.$As(p,[],v.quitEarly)}}t.$Cs=g;function A(u,i,a,N){return new k.$ss(u,i,a).ComputeDiff(N)}class m{constructor(i){const a=[],N=[];for(let $=0,v=i.length;$<v;$++)a[$]=h(i[$],1),N[$]=o(i[$],1);this.lines=i,this.a=a,this.b=N}getElements(){const i=[];for(let a=0,N=this.lines.length;a<N;a++)i[a]=this.lines[a].substring(this.a[a]-1,this.b[a]-1);return i}getStrictElement(i){return this.lines[i]}getStartLineNumber(i){return i+1}getEndLineNumber(i){return i+1}createCharSequence(i,a,N){const $=[],v=[],p=[];let M=0;for(let P=a;P<=N;P++){const F=this.lines[P],y=i?this.a[P]:1,D=i?this.b[P]:F.length+1;for(let q=y;q<D;q++)$[M]=F.charCodeAt(q-1),v[M]=P+1,p[M]=q,M++;!i&&P<N&&($[M]=10,v[M]=P+1,p[M]=F.length+1,M++)}return new b($,v,p)}}class b{constructor(i,a,N){this.a=i,this.b=a,this.d=N}toString(){return"["+this.a.map((i,a)=>(i===10?"\\n":String.fromCharCode(i))+`-(${this.b[a]},${this.d[a]})`).join(", ")+"]"}e(i,a){if(i<0||i>=a.length)throw new Error("Illegal index")}getElements(){return this.a}getStartLineNumber(i){return i>0&&i===this.b.length?this.getEndLineNumber(i-1):(this.e(i,this.b),this.b[i])}getEndLineNumber(i){return i===-1?this.getStartLineNumber(i+1):(this.e(i,this.b),this.a[i]===10?this.b[i]+1:this.b[i])}getStartColumn(i){return i>0&&i===this.d.length?this.getEndColumn(i-1):(this.e(i,this.d),this.d[i])}getEndColumn(i){return i===-1?this.getStartColumn(i+1):(this.e(i,this.d),this.a[i]===10?1:this.d[i]+1)}}class e{constructor(i,a,N,$,v,p,M,P){this.originalStartLineNumber=i,this.originalStartColumn=a,this.originalEndLineNumber=N,this.originalEndColumn=$,this.modifiedStartLineNumber=v,this.modifiedStartColumn=p,this.modifiedEndLineNumber=M,this.modifiedEndColumn=P}static createFromDiffChange(i,a,N){const $=a.getStartLineNumber(i.originalStart),v=a.getStartColumn(i.originalStart),p=a.getEndLineNumber(i.originalStart+i.originalLength-1),M=a.getEndColumn(i.originalStart+i.originalLength-1),P=N.getStartLineNumber(i.modifiedStart),F=N.getStartColumn(i.modifiedStart),y=N.getEndLineNumber(i.modifiedStart+i.modifiedLength-1),D=N.getEndColumn(i.modifiedStart+i.modifiedLength-1);return new e($,v,p,M,P,F,y,D)}}function w(u){if(u.length<=1)return u;const i=[u[0]];let a=i[0];for(let N=1,$=u.length;N<$;N++){const v=u[N],p=v.originalStart-(a.originalStart+a.originalLength),M=v.modifiedStart-(a.modifiedStart+a.modifiedLength);Math.min(p,M)<s?(a.originalLength=v.originalStart+v.originalLength-a.originalStart,a.modifiedLength=v.modifiedStart+v.modifiedLength-a.modifiedStart):(i.push(v),a=v)}return i}class R{constructor(i,a,N,$,v){this.originalStartLineNumber=i,this.originalEndLineNumber=a,this.modifiedStartLineNumber=N,this.modifiedEndLineNumber=$,this.charChanges=v}static createFromDiffResult(i,a,N,$,v,p,M){let P,F,y,D,q;if(a.originalLength===0?(P=N.getStartLineNumber(a.originalStart)-1,F=0):(P=N.getStartLineNumber(a.originalStart),F=N.getEndLineNumber(a.originalStart+a.originalLength-1)),a.modifiedLength===0?(y=$.getStartLineNumber(a.modifiedStart)-1,D=0):(y=$.getStartLineNumber(a.modifiedStart),D=$.getEndLineNumber(a.modifiedStart+a.modifiedLength-1)),p&&a.originalLength>0&&a.originalLength<20&&a.modifiedLength>0&&a.modifiedLength<20&&v()){const I=N.createCharSequence(i,a.originalStart,a.originalStart+a.originalLength-1),x=$.createCharSequence(i,a.modifiedStart,a.modifiedStart+a.modifiedLength-1);if(I.getElements().length>0&&x.getElements().length>0){let T=A(I,x,v,!0).changes;M&&(T=w(T)),q=[];for(let j=0,z=T.length;j<z;j++)q.push(e.createFromDiffChange(T[j],I,x))}}return new R(P,F,y,D,q)}}class E{constructor(i,a,N){this.a=N.shouldComputeCharChanges,this.b=N.shouldPostProcessCharChanges,this.d=N.shouldIgnoreTrimWhitespace,this.e=N.shouldMakePrettyDiff,this.f=i,this.g=a,this.h=new m(i),this.j=new m(a),this.k=f(N.maxComputationTime),this.l=f(N.maxComputationTime===0?0:Math.min(N.maxComputationTime,5e3))}computeDiff(){if(this.h.lines.length===1&&this.h.lines[0].length===0)return this.j.lines.length===1&&this.j.lines[0].length===0?{quitEarly:!1,changes:[]}:{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:1,modifiedStartLineNumber:1,modifiedEndLineNumber:this.j.lines.length,charChanges:void 0}]};if(this.j.lines.length===1&&this.j.lines[0].length===0)return{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:this.h.lines.length,modifiedStartLineNumber:1,modifiedEndLineNumber:1,charChanges:void 0}]};const i=A(this.h,this.j,this.k,this.e),a=i.changes,N=i.quitEarly;if(this.d){const M=[];for(let P=0,F=a.length;P<F;P++)M.push(R.createFromDiffResult(this.d,a[P],this.h,this.j,this.l,this.a,this.b));return{quitEarly:N,changes:M}}const $=[];let v=0,p=0;for(let M=-1,P=a.length;M<P;M++){const F=M+1<P?a[M+1]:null,y=F?F.originalStart:this.f.length,D=F?F.modifiedStart:this.g.length;for(;v<y&&p<D;){const q=this.f[v],I=this.g[p];if(q!==I){{let x=h(q,1),T=h(I,1);for(;x>1&&T>1;){const j=q.charCodeAt(x-2),z=I.charCodeAt(T-2);if(j!==z)break;x--,T--}(x>1||T>1)&&this.m($,v+1,1,x,p+1,1,T)}{let x=o(q,1),T=o(I,1);const j=q.length+1,z=I.length+1;for(;x<j&&T<z;){const C=q.charCodeAt(x-1),X=q.charCodeAt(T-1);if(C!==X)break;x++,T++}(x<j||T<z)&&this.m($,v+1,x,j,p+1,T,z)}}v++,p++}F&&($.push(R.createFromDiffResult(this.d,F,this.h,this.j,this.l,this.a,this.b)),v+=F.originalLength,p+=F.modifiedLength)}return{quitEarly:N,changes:$}}m(i,a,N,$,v,p,M){if(this.n(i,a,N,$,v,p,M))return;let P;this.a&&(P=[new e(a,N,a,$,v,p,v,M)]),i.push(new R(a,a,v,v,P))}n(i,a,N,$,v,p,M){const P=i.length;if(P===0)return!1;const F=i[P-1];return F.originalEndLineNumber===0||F.modifiedEndLineNumber===0?!1:F.originalEndLineNumber===a&&F.modifiedEndLineNumber===v?(this.a&&F.charChanges&&F.charChanges.push(new e(a,N,a,$,v,p,v,M)),!0):F.originalEndLineNumber+1===a&&F.modifiedEndLineNumber+1===v?(F.originalEndLineNumber=a,F.modifiedEndLineNumber=v,this.a&&F.charChanges&&F.charChanges.push(new e(a,N,a,$,v,p,v,M)),!0):!1}}t.$Ds=E;function h(u,i){const a=c.$Oe(u);return a===-1?i:a+1}function o(u,i){const a=c.$Qe(u);return a===-1?i:a+2}function f(u){if(u===0)return()=>!0;const i=Date.now();return()=>Date.now()-i<u}}),te(ie[52],se([0,1,33,51]),function(O,t,k,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$aZ=void 0,t.$aZ={getLegacy:()=>new k.$Cs,getDefault:()=>new _.$0Y}}),te(ie[53],se([0,1,35]),function(O,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bZ=void 0;function _(m){const b=[];for(const e of m){const w=Number(e);(w||w===0&&e.replace(/\s/g,"")!=="")&&b.push(w)}return b}function r(m,b,e,w){return{red:m/255,blue:e/255,green:b/255,alpha:w}}function c(m,b){const e=b.index,w=b[0].length;if(!e)return;const R=m.positionAt(e);return{startLineNumber:R.lineNumber,startColumn:R.column,endLineNumber:R.lineNumber,endColumn:R.column+w}}function L(m,b){if(!m)return;const e=k.$Qs.Format.CSS.parseHex(b);if(e)return{range:m,color:r(e.rgba.r,e.rgba.g,e.rgba.b,e.rgba.a)}}function d(m,b,e){if(!m||b.length!==1)return;const R=b[0].values(),E=_(R);return{range:m,color:r(E[0],E[1],E[2],e?E[3]:1)}}function l(m,b,e){if(!m||b.length!==1)return;const R=b[0].values(),E=_(R),h=new k.$Qs(new k.$Os(E[0],E[1]/100,E[2]/100,e?E[3]:1));return{range:m,color:r(h.rgba.r,h.rgba.g,h.rgba.b,h.rgba.a)}}function s(m,b){return typeof m=="string"?[...m.matchAll(b)]:m.findMatches(b)}function g(m){const b=[],w=s(m,/\b(rgb|rgba|hsl|hsla)(\([0-9\s,.\%]*\))|(#)([A-Fa-f0-9]{3})\b|(#)([A-Fa-f0-9]{4})\b|(#)([A-Fa-f0-9]{6})\b|(#)([A-Fa-f0-9]{8})\b/gm);if(w.length>0)for(const R of w){const E=R.filter(u=>u!==void 0),h=E[1],o=E[2];if(!o)continue;let f;if(h==="rgb"){const u=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*\)$/gm;f=d(c(m,R),s(o,u),!1)}else if(h==="rgba"){const u=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;f=d(c(m,R),s(o,u),!0)}else if(h==="hsl"){const u=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*\)$/gm;f=l(c(m,R),s(o,u),!1)}else if(h==="hsla"){const u=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;f=l(c(m,R),s(o,u),!0)}else h==="#"&&(f=L(c(m,R),h+o));f&&b.push(f)}return b}function A(m){return!m||typeof m.getValue!="function"||typeof m.positionAt!="function"?[]:g(m)}t.$bZ=A}),te(ie[54],se([0,1,28]),function(O,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$NY=t.$MY=t.$LY=t.State=void 0;var _;(function(b){b[b.Invalid=0]="Invalid",b[b.Start=1]="Start",b[b.H=2]="H",b[b.HT=3]="HT",b[b.HTT=4]="HTT",b[b.HTTP=5]="HTTP",b[b.F=6]="F",b[b.FI=7]="FI",b[b.FIL=8]="FIL",b[b.BeforeColon=9]="BeforeColon",b[b.AfterColon=10]="AfterColon",b[b.AlmostThere=11]="AlmostThere",b[b.End=12]="End",b[b.Accept=13]="Accept",b[b.LastKnownState=14]="LastKnownState"})(_||(t.State=_={}));class r{constructor(e,w,R){const E=new Uint8Array(e*w);for(let h=0,o=e*w;h<o;h++)E[h]=R;this.a=E,this.rows=e,this.cols=w}get(e,w){return this.a[e*this.cols+w]}set(e,w,R){this.a[e*this.cols+w]=R}}class c{constructor(e){let w=0,R=0;for(let h=0,o=e.length;h<o;h++){const[f,u,i]=e[h];u>w&&(w=u),f>R&&(R=f),i>R&&(R=i)}w++,R++;const E=new r(R,w,0);for(let h=0,o=e.length;h<o;h++){const[f,u,i]=e[h];E.set(f,u,i)}this.a=E,this.b=w}nextState(e,w){return w<0||w>=this.b?0:this.a.get(e,w)}}t.$LY=c;let L=null;function d(){return L===null&&(L=new c([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),L}var l;(function(b){b[b.None=0]="None",b[b.ForceTermination=1]="ForceTermination",b[b.CannotEndIn=2]="CannotEndIn"})(l||(l={}));let s=null;function g(){if(s===null){s=new k.$Js(0);const b=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let w=0;w<b.length;w++)s.set(b.charCodeAt(w),1);const e=".,;:";for(let w=0;w<e.length;w++)s.set(e.charCodeAt(w),2)}return s}class A{static a(e,w,R,E,h){let o=h-1;do{const f=w.charCodeAt(o);if(e.get(f)!==2)break;o--}while(o>E);if(E>0){const f=w.charCodeAt(E-1),u=w.charCodeAt(o);(f===40&&u===41||f===91&&u===93||f===123&&u===125)&&o--}return{range:{startLineNumber:R,startColumn:E+1,endLineNumber:R,endColumn:o+2},url:w.substring(E,o+1)}}static computeLinks(e,w=d()){const R=g(),E=[];for(let h=1,o=e.getLineCount();h<=o;h++){const f=e.getLineContent(h),u=f.length;let i=0,a=0,N=0,$=1,v=!1,p=!1,M=!1,P=!1;for(;i<u;){let F=!1;const y=f.charCodeAt(i);if($===13){let D;switch(y){case 40:v=!0,D=0;break;case 41:D=v?0:1;break;case 91:M=!0,p=!0,D=0;break;case 93:M=!1,D=p?0:1;break;case 123:P=!0,D=0;break;case 125:D=P?0:1;break;case 39:case 34:case 96:N===y?D=1:N===39||N===34||N===96?D=0:D=1;break;case 42:D=N===42?1:0;break;case 124:D=N===124?1:0;break;case 32:D=M?0:1;break;default:D=R.get(y)}D===1&&(E.push(A.a(R,f,h,a,i)),F=!0)}else if($===12){let D;y===91?(p=!0,D=0):D=R.get(y),D===1?F=!0:$=13}else $=w.nextState($,y),$===0&&(F=!0);F&&($=1,v=!1,p=!1,P=!1,a=i+1,N=y),i++}$===13&&E.push(A.a(R,f,h,a,u))}return E}}t.$MY=A;function m(b){return!b||typeof b.getLineCount!="function"||typeof b.getLineContent!="function"?[]:A.computeLinks(b)}t.$NY=m}),te(ie[55],se([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$OY=void 0;class k{constructor(){this.c=[["true","false"],["True","False"],["Private","Public","Friend","ReadOnly","Partial","Protected","WriteOnly"],["public","protected","private"]]}navigateValueSet(r,c,L,d,l){if(r&&c){const s=this.a(c,l);if(s)return{range:r,value:s}}if(L&&d){const s=this.a(d,l);if(s)return{range:L,value:s}}return null}a(r,c){const L=this.b(r,c);return L!==null?L:this.d(r,c)}b(r,c){const L=Math.pow(10,r.length-(r.lastIndexOf(".")+1));let d=Number(r);const l=parseFloat(r);return!isNaN(d)&&!isNaN(l)&&d===l?d===0&&!c?null:(d=Math.floor(d*L),d+=c?L:-L,String(d/L)):null}d(r,c){return this.e(this.c,r,c)}e(r,c,L){let d=null;for(let l=0,s=r.length;d===null&&l<s;l++)d=this.f(r[l],c,L);return d}f(r,c,L){let d=r.indexOf(c);return d>=0?(d+=L?1:-1,d<0?d=r.length-1:d%=r.length,r[d]):null}}t.$OY=k,k.INSTANCE=new k}),te(ie[56],se([0,1,15]),function(O,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Iu=t.$Hu=t.$Gu=t.$Fu=t.ModelConstants=t.PositionAffinity=t.$Eu=t.TrackedRangeStickiness=t.$Du=t.$Cu=t.EndOfLineSequence=t.DefaultEndOfLine=t.EndOfLinePreference=t.InjectedTextCursorStops=t.MinimapPosition=t.GlyphMarginLane=t.OverviewRulerLane=void 0;var _;(function(f){f[f.Left=1]="Left",f[f.Center=2]="Center",f[f.Right=4]="Right",f[f.Full=7]="Full"})(_||(t.OverviewRulerLane=_={}));var r;(function(f){f[f.Left=1]="Left",f[f.Right=2]="Right"})(r||(t.GlyphMarginLane=r={}));var c;(function(f){f[f.Inline=1]="Inline",f[f.Gutter=2]="Gutter"})(c||(t.MinimapPosition=c={}));var L;(function(f){f[f.Both=0]="Both",f[f.Right=1]="Right",f[f.Left=2]="Left",f[f.None=3]="None"})(L||(t.InjectedTextCursorStops=L={}));var d;(function(f){f[f.TextDefined=0]="TextDefined",f[f.LF=1]="LF",f[f.CRLF=2]="CRLF"})(d||(t.EndOfLinePreference=d={}));var l;(function(f){f[f.LF=1]="LF",f[f.CRLF=2]="CRLF"})(l||(t.DefaultEndOfLine=l={}));var s;(function(f){f[f.LF=0]="LF",f[f.CRLF=1]="CRLF"})(s||(t.EndOfLineSequence=s={}));class g{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(u){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,u.tabSize|0),u.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,u.indentSize|0),this.a=!1),this.insertSpaces=!!u.insertSpaces,this.defaultEOL=u.defaultEOL|0,this.trimAutoWhitespace=!!u.trimAutoWhitespace,this.bracketPairColorizationOptions=u.bracketPairColorizationOptions}equals(u){return this.tabSize===u.tabSize&&this.a===u.a&&this.indentSize===u.indentSize&&this.insertSpaces===u.insertSpaces&&this.defaultEOL===u.defaultEOL&&this.trimAutoWhitespace===u.trimAutoWhitespace&&(0,k.$2m)(this.bracketPairColorizationOptions,u.bracketPairColorizationOptions)}createChangeEvent(u){return{tabSize:this.tabSize!==u.tabSize,indentSize:this.indentSize!==u.indentSize,insertSpaces:this.insertSpaces!==u.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==u.trimAutoWhitespace}}}t.$Cu=g;class A{constructor(u,i){this._findMatchBrand=void 0,this.range=u,this.matches=i}}t.$Du=A;var m;(function(f){f[f.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",f[f.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",f[f.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",f[f.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(m||(t.TrackedRangeStickiness=m={}));function b(f){return f&&typeof f.read=="function"}t.$Eu=b;var e;(function(f){f[f.Left=0]="Left",f[f.Right=1]="Right",f[f.None=2]="None",f[f.LeftOfInjectedText=3]="LeftOfInjectedText",f[f.RightOfInjectedText=4]="RightOfInjectedText"})(e||(t.PositionAffinity=e={}));var w;(function(f){f[f.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(w||(t.ModelConstants=w={}));class R{constructor(u,i,a,N,$,v){this.identifier=u,this.range=i,this.text=a,this.forceMoveMarkers=N,this.isAutoWhitespaceEdit=$,this._isTracked=v}}t.$Fu=R;class E{constructor(u,i,a){this.regex=u,this.wordSeparators=i,this.simpleSearch=a}}t.$Gu=E;class h{constructor(u,i,a){this.reverseEdits=u,this.changes=i,this.trimAutoWhitespaceLineNumbers=a}}t.$Hu=h;function o(f){return!f.isTooLargeForSyncing()&&!f.isForSimpleWidget}t.$Iu=o}),te(ie[57],se([0,1,6,27]),function(O,t,k,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Nu=t.$Mu=t.$Lu=void 0;class r{constructor(l){this.a=l,this.b=new Uint32Array(l.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(l,s){l=(0,_.$ye)(l);const g=this.a,A=this.b,m=s.length;return m===0?!1:(this.a=new Uint32Array(g.length+m),this.a.set(g.subarray(0,l),0),this.a.set(g.subarray(l),l+m),this.a.set(s,l),l-1<this.c[0]&&(this.c[0]=l-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(A.subarray(0,this.c[0]+1)),!0)}setValue(l,s){return l=(0,_.$ye)(l),s=(0,_.$ye)(s),this.a[l]===s?!1:(this.a[l]=s,l-1<this.c[0]&&(this.c[0]=l-1),!0)}removeValues(l,s){l=(0,_.$ye)(l),s=(0,_.$ye)(s);const g=this.a,A=this.b;if(l>=g.length)return!1;const m=g.length-l;return s>=m&&(s=m),s===0?!1:(this.a=new Uint32Array(g.length-s),this.a.set(g.subarray(0,l),0),this.a.set(g.subarray(l+s),l),this.b=new Uint32Array(this.a.length),l-1<this.c[0]&&(this.c[0]=l-1),this.c[0]>=0&&this.b.set(A.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(l){return l<0?0:(l=(0,_.$ye)(l),this.d(l))}d(l){if(l<=this.c[0])return this.b[l];let s=this.c[0]+1;s===0&&(this.b[0]=this.a[0],s++),l>=this.a.length&&(l=this.a.length-1);for(let g=s;g<=l;g++)this.b[g]=this.b[g-1]+this.a[g];return this.c[0]=Math.max(this.c[0],l),this.b[l]}getIndexOf(l){l=Math.floor(l),this.getTotalSum();let s=0,g=this.a.length-1,A=0,m=0,b=0;for(;s<=g;)if(A=s+(g-s)/2|0,m=this.b[A],b=m-this.a[A],l<b)g=A-1;else if(l>=m)s=A+1;else break;return new L(A,l-b)}}t.$Lu=r;class c{constructor(l){this.a=l,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(l){return this.g(),l===0?0:this.d[l-1]}getIndexOf(l){this.g();const s=this.e[l],g=s>0?this.d[s-1]:0;return new L(s,l-g)}removeValues(l,s){this.a.splice(l,s),this.f(l)}insertValues(l,s){this.a=(0,k.$Ub)(this.a,l,s),this.f(l)}f(l){this.b=!1,this.c=Math.min(this.c,l-1)}g(){if(!this.b){for(let l=this.c+1,s=this.a.length;l<s;l++){const g=this.a[l],A=l>0?this.d[l-1]:0;this.d[l]=A+g;for(let m=0;m<g;m++)this.e[A+m]=l}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(l,s){this.a[l]!==s&&(this.a[l]=s,this.f(l))}}t.$Mu=c;class L{constructor(l,s){this.index=l,this.remainder=s,this._prefixSumIndexOfResultBrand=void 0,this.index=l,this.remainder=s}}t.$Nu=L}),te(ie[58],se([0,1,7,5,57]),function(O,t,k,_,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ou=void 0;class c{constructor(d,l,s,g){this.d=d,this.f=l,this.g=s,this.h=g,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents(d){d.eol&&d.eol!==this.g&&(this.g=d.eol,this.j=null);const l=d.changes;for(const s of l)this.o(s.range),this.p(new _.$ls(s.range.startLineNumber,s.range.startColumn),s.text);this.h=d.versionId,this.k=null}l(){if(!this.j){const d=this.g.length,l=this.f.length,s=new Uint32Array(l);for(let g=0;g<l;g++)s[g]=this.f[g].length+d;this.j=new r.$Lu(s)}}n(d,l){this.f[d]=l,this.j&&this.j.setValue(d,this.f[d].length+this.g.length)}o(d){if(d.startLineNumber===d.endLineNumber){if(d.startColumn===d.endColumn)return;this.n(d.startLineNumber-1,this.f[d.startLineNumber-1].substring(0,d.startColumn-1)+this.f[d.startLineNumber-1].substring(d.endColumn-1));return}this.n(d.startLineNumber-1,this.f[d.startLineNumber-1].substring(0,d.startColumn-1)+this.f[d.endLineNumber-1].substring(d.endColumn-1)),this.f.splice(d.startLineNumber,d.endLineNumber-d.startLineNumber),this.j&&this.j.removeValues(d.startLineNumber,d.endLineNumber-d.startLineNumber)}p(d,l){if(l.length===0)return;const s=(0,k.$Ne)(l);if(s.length===1){this.n(d.lineNumber-1,this.f[d.lineNumber-1].substring(0,d.column-1)+s[0]+this.f[d.lineNumber-1].substring(d.column-1));return}s[s.length-1]+=this.f[d.lineNumber-1].substring(d.column-1),this.n(d.lineNumber-1,this.f[d.lineNumber-1].substring(0,d.column-1)+s[0]);const g=new Uint32Array(s.length-1);for(let A=1;A<s.length;A++)this.f.splice(d.lineNumber+A-1,0,s[A]),g[A-1]=s[A].length+this.g.length;this.j&&this.j.insertValues(d.lineNumber,g)}}t.$Ou=c}),te(ie[59],se([0,1,7,46,5,2,56]),function(O,t,k,_,r,c,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$qB=t.$pB=t.$oB=t.$nB=t.$mB=t.$lB=void 0;const d=999;class l{constructor(h,o,f,u){this.searchString=h,this.isRegex=o,this.matchCase=f,this.wordSeparators=u}parseSearchRequest(){if(this.searchString==="")return null;let h;this.isRegex?h=s(this.searchString):h=this.searchString.indexOf(`
`)>=0;let o=null;try{o=k.$Le(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:h,global:!0,unicode:!0})}catch{return null}if(!o)return null;let f=!this.isRegex&&!h;return f&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(f=this.matchCase),new L.$Gu(o,this.wordSeparators?(0,_.$Ms)(this.wordSeparators):null,f?this.searchString:null)}}t.$lB=l;function s(E){if(!E||E.length===0)return!1;for(let h=0,o=E.length;h<o;h++){const f=E.charCodeAt(h);if(f===10)return!0;if(f===92){if(h++,h>=o)break;const u=E.charCodeAt(h);if(u===110||u===114||u===87)return!0}}return!1}t.$mB=s;function g(E,h,o){if(!o)return new L.$Du(E,null);const f=[];for(let u=0,i=h.length;u<i;u++)f[u]=h[u];return new L.$Du(E,f)}t.$nB=g;class A{constructor(h){const o=[];let f=0;for(let u=0,i=h.length;u<i;u++)h.charCodeAt(u)===10&&(o[f++]=u);this.a=o}findLineFeedCountBeforeOffset(h){const o=this.a;let f=0,u=o.length-1;if(u===-1||h<=o[0])return 0;for(;f<u;){const i=f+((u-f)/2>>0);o[i]>=h?u=i-1:o[i+1]>=h?(f=i,u=i):f=i+1}return f+1}}class m{static findMatches(h,o,f,u,i){const a=o.parseSearchRequest();return a?a.regex.multiline?this.b(h,f,new R(a.wordSeparators,a.regex),u,i):this.c(h,f,a,u,i):[]}static a(h,o,f,u,i,a){let N,$=0;u?($=u.findLineFeedCountBeforeOffset(i),N=o+i+$):N=o+i;let v;if(u){const F=u.findLineFeedCountBeforeOffset(i+a.length)-$;v=N+a.length+F}else v=N+a.length;const p=h.getPositionAt(N),M=h.getPositionAt(v);return new c.$ms(p.lineNumber,p.column,M.lineNumber,M.column)}static b(h,o,f,u,i){const a=h.getOffsetAt(o.getStartPosition()),N=h.getValueInRange(o,1),$=h.getEOL()===`\r
`?new A(N):null,v=[];let p=0,M;for(f.reset(0);M=f.next(N);)if(v[p++]=g(this.a(h,a,N,$,M.index,M[0]),M,u),p>=i)return v;return v}static c(h,o,f,u,i){const a=[];let N=0;if(o.startLineNumber===o.endLineNumber){const v=h.getLineContent(o.startLineNumber).substring(o.startColumn-1,o.endColumn-1);return N=this.d(f,v,o.startLineNumber,o.startColumn-1,N,a,u,i),a}const $=h.getLineContent(o.startLineNumber).substring(o.startColumn-1);N=this.d(f,$,o.startLineNumber,o.startColumn-1,N,a,u,i);for(let v=o.startLineNumber+1;v<o.endLineNumber&&N<i;v++)N=this.d(f,h.getLineContent(v),v,0,N,a,u,i);if(N<i){const v=h.getLineContent(o.endLineNumber).substring(0,o.endColumn-1);N=this.d(f,v,o.endLineNumber,0,N,a,u,i)}return a}static d(h,o,f,u,i,a,N,$){const v=h.wordSeparators;if(!N&&h.simpleSearch){const P=h.simpleSearch,F=P.length,y=o.length;let D=-F;for(;(D=o.indexOf(P,D+F))!==-1;)if((!v||w(v,o,y,D,F))&&(a[i++]=new L.$Du(new c.$ms(f,D+1+u,f,D+1+F+u),null),i>=$))return i;return i}const p=new R(h.wordSeparators,h.regex);let M;p.reset(0);do if(M=p.next(o),M&&(a[i++]=g(new c.$ms(f,M.index+1+u,f,M.index+1+M[0].length+u),M,N),i>=$))return i;while(M);return i}static findNextMatch(h,o,f,u){const i=o.parseSearchRequest();if(!i)return null;const a=new R(i.wordSeparators,i.regex);return i.regex.multiline?this.e(h,f,a,u):this.f(h,f,a,u)}static e(h,o,f,u){const i=new r.$ls(o.lineNumber,1),a=h.getOffsetAt(i),N=h.getLineCount(),$=h.getValueInRange(new c.$ms(i.lineNumber,i.column,N,h.getLineMaxColumn(N)),1),v=h.getEOL()===`\r
`?new A($):null;f.reset(o.column-1);const p=f.next($);return p?g(this.a(h,a,$,v,p.index,p[0]),p,u):o.lineNumber!==1||o.column!==1?this.e(h,new r.$ls(1,1),f,u):null}static f(h,o,f,u){const i=h.getLineCount(),a=o.lineNumber,N=h.getLineContent(a),$=this.g(f,N,a,o.column,u);if($)return $;for(let v=1;v<=i;v++){const p=(a+v-1)%i,M=h.getLineContent(p+1),P=this.g(f,M,p+1,1,u);if(P)return P}return null}static g(h,o,f,u,i){h.reset(u-1);const a=h.next(o);return a?g(new c.$ms(f,a.index+1,f,a.index+1+a[0].length),a,i):null}static findPreviousMatch(h,o,f,u){const i=o.parseSearchRequest();if(!i)return null;const a=new R(i.wordSeparators,i.regex);return i.regex.multiline?this.h(h,f,a,u):this.j(h,f,a,u)}static h(h,o,f,u){const i=this.b(h,new c.$ms(1,1,o.lineNumber,o.column),f,u,10*d);if(i.length>0)return i[i.length-1];const a=h.getLineCount();return o.lineNumber!==a||o.column!==h.getLineMaxColumn(a)?this.h(h,new r.$ls(a,h.getLineMaxColumn(a)),f,u):null}static j(h,o,f,u){const i=h.getLineCount(),a=o.lineNumber,N=h.getLineContent(a).substring(0,o.column-1),$=this.k(f,N,a,u);if($)return $;for(let v=1;v<=i;v++){const p=(i+a-v-1)%i,M=h.getLineContent(p+1),P=this.k(f,M,p+1,u);if(P)return P}return null}static k(h,o,f,u){let i=null,a;for(h.reset(0);a=h.next(o);)i=g(new c.$ms(f,a.index+1,f,a.index+1+a[0].length),a,u);return i}}t.$oB=m;function b(E,h,o,f,u){if(f===0)return!0;const i=h.charCodeAt(f-1);if(E.get(i)!==0||i===13||i===10)return!0;if(u>0){const a=h.charCodeAt(f);if(E.get(a)!==0)return!0}return!1}function e(E,h,o,f,u){if(f+u===o)return!0;const i=h.charCodeAt(f+u);if(E.get(i)!==0||i===13||i===10)return!0;if(u>0){const a=h.charCodeAt(f+u-1);if(E.get(a)!==0)return!0}return!1}function w(E,h,o,f,u){return b(E,h,o,f,u)&&e(E,h,o,f,u)}t.$pB=w;class R{constructor(h,o){this._wordSeparators=h,this.a=o,this.b=-1,this.c=0}reset(h){this.a.lastIndex=h,this.b=-1,this.c=0}next(h){const o=h.length;let f;do{if(this.b+this.c===o||(f=this.a.exec(h),!f))return null;const u=f.index,i=f[0].length;if(u===this.b&&i===this.c){if(i===0){k.$7e(h,o,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=u,this.c=i,!this._wordSeparators||w(this._wordSeparators,h,o,u,i))return f}while(f);return null}}t.$qB=R}),te(ie[60],se([0,1,2,59,7,13,29]),function(O,t,k,_,r,c,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UnicodeHighlighterReasonKind=t.$KY=void 0;class d{static computeUnicodeHighlights(e,w,R){const E=R?R.startLineNumber:1,h=R?R.endLineNumber:e.getLineCount(),o=new g(w),f=o.getCandidateCodePoints();let u;f==="allNonBasicAscii"?u=new RegExp("[^\\t\\n\\r\\x20-\\x7E]","g"):u=new RegExp(`${l(Array.from(f))}`,"g");const i=new _.$qB(null,u),a=[];let N=!1,$,v=0,p=0,M=0;e:for(let P=E,F=h;P<=F;P++){const y=e.getLineContent(P),D=y.length;i.reset(0);do if($=i.next(y),$){let q=$.index,I=$.index+$[0].length;if(q>0){const z=y.charCodeAt(q-1);r.$4e(z)&&q--}if(I+1<D){const z=y.charCodeAt(I-1);r.$4e(z)&&I++}const x=y.substring(q,I);let T=(0,L.$2r)(q+1,L.$Yr,y,0);T&&T.endColumn<=q+1&&(T=null);const j=o.shouldHighlightNonBasicASCII(x,T?T.word:null);if(j!==0){j===3?v++:j===2?p++:j===1?M++:(0,c.$2c)(j);const z=1e3;if(a.length>=z){N=!0;break e}a.push(new k.$ms(P,q+1,P,I+1))}}while($)}return{ranges:a,hasMore:N,ambiguousCharacterCount:v,invisibleCharacterCount:p,nonBasicAsciiCharacterCount:M}}static computeUnicodeHighlightReason(e,w){const R=new g(w);switch(R.shouldHighlightNonBasicASCII(e,null)){case 0:return null;case 2:return{kind:1};case 3:{const h=e.codePointAt(0),o=R.ambiguousCharacters.getPrimaryConfusable(h),f=r.$uf.getLocales().filter(u=>!r.$uf.getInstance(new Set([...w.allowedLocales,u])).isAmbiguous(h));return{kind:0,confusableWith:String.fromCodePoint(o),notAmbiguousInLocales:f}}case 1:return{kind:2}}}}t.$KY=d;function l(b,e){return`[${r.$De(b.map(R=>String.fromCodePoint(R)).join(""))}]`}var s;(function(b){b[b.Ambiguous=0]="Ambiguous",b[b.Invisible=1]="Invisible",b[b.NonBasicAscii=2]="NonBasicAscii"})(s||(t.UnicodeHighlighterReasonKind=s={}));class g{constructor(e){this.b=e,this.a=new Set(e.allowedCodePoints),this.ambiguousCharacters=r.$uf.getInstance(new Set(e.allowedLocales))}getCandidateCodePoints(){if(this.b.nonBasicASCII)return"allNonBasicAscii";const e=new Set;if(this.b.invisibleCharacters)for(const w of r.$vf.codePoints)A(String.fromCodePoint(w))||e.add(w);if(this.b.ambiguousCharacters)for(const w of this.ambiguousCharacters.getConfusableCodePoints())e.add(w);for(const w of this.a)e.delete(w);return e}shouldHighlightNonBasicASCII(e,w){const R=e.codePointAt(0);if(this.a.has(R))return 0;if(this.b.nonBasicASCII)return 1;let E=!1,h=!1;if(w)for(const o of w){const f=o.codePointAt(0),u=r.$cf(o);E=E||u,!u&&!this.ambiguousCharacters.isAmbiguous(f)&&!r.$vf.isInvisibleCharacter(f)&&(h=!0)}return!E&&h?0:this.b.invisibleCharacters&&!A(e)&&r.$vf.isInvisibleCharacter(R)?2:this.b.ambiguousCharacters&&this.ambiguousCharacters.isAmbiguous(R)?3:0}}function A(b){return b===" "||b===`
`||b==="	"}var m;(function(b){b[b.None=0]="None",b[b.NonBasicASCII=1]="NonBasicASCII",b[b.Invisible=2]="Invisible",b[b.Ambiguous=3]="Ambiguous"})(m||(m={}))}),te(ie[61],se([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.WrappingIndent=t.TrackedRangeStickiness=t.TextEditorCursorStyle=t.TextEditorCursorBlinkingStyle=t.SymbolTag=t.SymbolKind=t.SignatureHelpTriggerKind=t.SelectionDirection=t.ScrollbarVisibility=t.ScrollType=t.RenderMinimap=t.RenderLineNumbersType=t.PositionAffinity=t.OverviewRulerLane=t.OverlayWidgetPositionPreference=t.MouseTargetType=t.MinimapPosition=t.MarkerTag=t.MarkerSeverity=t.KeyCode=t.InlineCompletionTriggerKind=t.InlayHintKind=t.InjectedTextCursorStops=t.IndentAction=t.GlyphMarginLane=t.EndOfLineSequence=t.EndOfLinePreference=t.EditorOption=t.EditorAutoIndentStrategy=t.DocumentHighlightKind=t.DefaultEndOfLine=t.CursorChangeReason=t.ContentWidgetPositionPreference=t.CompletionTriggerKind=t.CompletionItemTag=t.CompletionItemKind=t.CompletionItemInsertTextRule=t.CodeActionTriggerType=t.AccessibilitySupport=void 0;var k;(function(n){n[n.Unknown=0]="Unknown",n[n.Disabled=1]="Disabled",n[n.Enabled=2]="Enabled"})(k||(t.AccessibilitySupport=k={}));var _;(function(n){n[n.Invoke=1]="Invoke",n[n.Auto=2]="Auto"})(_||(t.CodeActionTriggerType=_={}));var r;(function(n){n[n.None=0]="None",n[n.KeepWhitespace=1]="KeepWhitespace",n[n.InsertAsSnippet=4]="InsertAsSnippet"})(r||(t.CompletionItemInsertTextRule=r={}));var c;(function(n){n[n.Method=0]="Method",n[n.Function=1]="Function",n[n.Constructor=2]="Constructor",n[n.Field=3]="Field",n[n.Variable=4]="Variable",n[n.Class=5]="Class",n[n.Struct=6]="Struct",n[n.Interface=7]="Interface",n[n.Module=8]="Module",n[n.Property=9]="Property",n[n.Event=10]="Event",n[n.Operator=11]="Operator",n[n.Unit=12]="Unit",n[n.Value=13]="Value",n[n.Constant=14]="Constant",n[n.Enum=15]="Enum",n[n.EnumMember=16]="EnumMember",n[n.Keyword=17]="Keyword",n[n.Text=18]="Text",n[n.Color=19]="Color",n[n.File=20]="File",n[n.Reference=21]="Reference",n[n.Customcolor=22]="Customcolor",n[n.Folder=23]="Folder",n[n.TypeParameter=24]="TypeParameter",n[n.User=25]="User",n[n.Issue=26]="Issue",n[n.Snippet=27]="Snippet"})(c||(t.CompletionItemKind=c={}));var L;(function(n){n[n.Deprecated=1]="Deprecated"})(L||(t.CompletionItemTag=L={}));var d;(function(n){n[n.Invoke=0]="Invoke",n[n.TriggerCharacter=1]="TriggerCharacter",n[n.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(d||(t.CompletionTriggerKind=d={}));var l;(function(n){n[n.EXACT=0]="EXACT",n[n.ABOVE=1]="ABOVE",n[n.BELOW=2]="BELOW"})(l||(t.ContentWidgetPositionPreference=l={}));var s;(function(n){n[n.NotSet=0]="NotSet",n[n.ContentFlush=1]="ContentFlush",n[n.RecoverFromMarkers=2]="RecoverFromMarkers",n[n.Explicit=3]="Explicit",n[n.Paste=4]="Paste",n[n.Undo=5]="Undo",n[n.Redo=6]="Redo"})(s||(t.CursorChangeReason=s={}));var g;(function(n){n[n.LF=1]="LF",n[n.CRLF=2]="CRLF"})(g||(t.DefaultEndOfLine=g={}));var A;(function(n){n[n.Text=0]="Text",n[n.Read=1]="Read",n[n.Write=2]="Write"})(A||(t.DocumentHighlightKind=A={}));var m;(function(n){n[n.None=0]="None",n[n.Keep=1]="Keep",n[n.Brackets=2]="Brackets",n[n.Advanced=3]="Advanced",n[n.Full=4]="Full"})(m||(t.EditorAutoIndentStrategy=m={}));var b;(function(n){n[n.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",n[n.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",n[n.accessibilitySupport=2]="accessibilitySupport",n[n.accessibilityPageSize=3]="accessibilityPageSize",n[n.ariaLabel=4]="ariaLabel",n[n.ariaRequired=5]="ariaRequired",n[n.autoClosingBrackets=6]="autoClosingBrackets",n[n.autoClosingComments=7]="autoClosingComments",n[n.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",n[n.autoClosingDelete=9]="autoClosingDelete",n[n.autoClosingOvertype=10]="autoClosingOvertype",n[n.autoClosingQuotes=11]="autoClosingQuotes",n[n.autoIndent=12]="autoIndent",n[n.automaticLayout=13]="automaticLayout",n[n.autoSurround=14]="autoSurround",n[n.bracketPairColorization=15]="bracketPairColorization",n[n.guides=16]="guides",n[n.codeLens=17]="codeLens",n[n.codeLensFontFamily=18]="codeLensFontFamily",n[n.codeLensFontSize=19]="codeLensFontSize",n[n.colorDecorators=20]="colorDecorators",n[n.colorDecoratorsLimit=21]="colorDecoratorsLimit",n[n.columnSelection=22]="columnSelection",n[n.comments=23]="comments",n[n.contextmenu=24]="contextmenu",n[n.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",n[n.cursorBlinking=26]="cursorBlinking",n[n.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",n[n.cursorStyle=28]="cursorStyle",n[n.cursorSurroundingLines=29]="cursorSurroundingLines",n[n.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",n[n.cursorWidth=31]="cursorWidth",n[n.disableLayerHinting=32]="disableLayerHinting",n[n.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",n[n.domReadOnly=34]="domReadOnly",n[n.dragAndDrop=35]="dragAndDrop",n[n.dropIntoEditor=36]="dropIntoEditor",n[n.emptySelectionClipboard=37]="emptySelectionClipboard",n[n.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",n[n.extraEditorClassName=39]="extraEditorClassName",n[n.fastScrollSensitivity=40]="fastScrollSensitivity",n[n.find=41]="find",n[n.fixedOverflowWidgets=42]="fixedOverflowWidgets",n[n.folding=43]="folding",n[n.foldingStrategy=44]="foldingStrategy",n[n.foldingHighlight=45]="foldingHighlight",n[n.foldingImportsByDefault=46]="foldingImportsByDefault",n[n.foldingMaximumRegions=47]="foldingMaximumRegions",n[n.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",n[n.fontFamily=49]="fontFamily",n[n.fontInfo=50]="fontInfo",n[n.fontLigatures=51]="fontLigatures",n[n.fontSize=52]="fontSize",n[n.fontWeight=53]="fontWeight",n[n.fontVariations=54]="fontVariations",n[n.formatOnPaste=55]="formatOnPaste",n[n.formatOnType=56]="formatOnType",n[n.glyphMargin=57]="glyphMargin",n[n.gotoLocation=58]="gotoLocation",n[n.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",n[n.hover=60]="hover",n[n.inDiffEditor=61]="inDiffEditor",n[n.inlineSuggest=62]="inlineSuggest",n[n.letterSpacing=63]="letterSpacing",n[n.lightbulb=64]="lightbulb",n[n.lineDecorationsWidth=65]="lineDecorationsWidth",n[n.lineHeight=66]="lineHeight",n[n.lineNumbers=67]="lineNumbers",n[n.lineNumbersMinChars=68]="lineNumbersMinChars",n[n.linkedEditing=69]="linkedEditing",n[n.links=70]="links",n[n.matchBrackets=71]="matchBrackets",n[n.minimap=72]="minimap",n[n.mouseStyle=73]="mouseStyle",n[n.mouseWheelScrollSensitivity=74]="mouseWheelScrollSensitivity",n[n.mouseWheelZoom=75]="mouseWheelZoom",n[n.multiCursorMergeOverlapping=76]="multiCursorMergeOverlapping",n[n.multiCursorModifier=77]="multiCursorModifier",n[n.multiCursorPaste=78]="multiCursorPaste",n[n.multiCursorLimit=79]="multiCursorLimit",n[n.occurrencesHighlight=80]="occurrencesHighlight",n[n.overviewRulerBorder=81]="overviewRulerBorder",n[n.overviewRulerLanes=82]="overviewRulerLanes",n[n.padding=83]="padding",n[n.pasteAs=84]="pasteAs",n[n.parameterHints=85]="parameterHints",n[n.peekWidgetDefaultFocus=86]="peekWidgetDefaultFocus",n[n.definitionLinkOpensInPeek=87]="definitionLinkOpensInPeek",n[n.quickSuggestions=88]="quickSuggestions",n[n.quickSuggestionsDelay=89]="quickSuggestionsDelay",n[n.readOnly=90]="readOnly",n[n.readOnlyMessage=91]="readOnlyMessage",n[n.renameOnType=92]="renameOnType",n[n.renderControlCharacters=93]="renderControlCharacters",n[n.renderFinalNewline=94]="renderFinalNewline",n[n.renderLineHighlight=95]="renderLineHighlight",n[n.renderLineHighlightOnlyWhenFocus=96]="renderLineHighlightOnlyWhenFocus",n[n.renderValidationDecorations=97]="renderValidationDecorations",n[n.renderWhitespace=98]="renderWhitespace",n[n.revealHorizontalRightPadding=99]="revealHorizontalRightPadding",n[n.roundedSelection=100]="roundedSelection",n[n.rulers=101]="rulers",n[n.scrollbar=102]="scrollbar",n[n.scrollBeyondLastColumn=103]="scrollBeyondLastColumn",n[n.scrollBeyondLastLine=104]="scrollBeyondLastLine",n[n.scrollPredominantAxis=105]="scrollPredominantAxis",n[n.selectionClipboard=106]="selectionClipboard",n[n.selectionHighlight=107]="selectionHighlight",n[n.selectOnLineNumbers=108]="selectOnLineNumbers",n[n.showFoldingControls=109]="showFoldingControls",n[n.showUnused=110]="showUnused",n[n.snippetSuggestions=111]="snippetSuggestions",n[n.smartSelect=112]="smartSelect",n[n.smoothScrolling=113]="smoothScrolling",n[n.stickyScroll=114]="stickyScroll",n[n.stickyTabStops=115]="stickyTabStops",n[n.stopRenderingLineAfter=116]="stopRenderingLineAfter",n[n.suggest=117]="suggest",n[n.suggestFontSize=118]="suggestFontSize",n[n.suggestLineHeight=119]="suggestLineHeight",n[n.suggestOnTriggerCharacters=120]="suggestOnTriggerCharacters",n[n.suggestSelection=121]="suggestSelection",n[n.tabCompletion=122]="tabCompletion",n[n.tabIndex=123]="tabIndex",n[n.unicodeHighlighting=124]="unicodeHighlighting",n[n.unusualLineTerminators=125]="unusualLineTerminators",n[n.useShadowDOM=126]="useShadowDOM",n[n.useTabStops=127]="useTabStops",n[n.wordBreak=128]="wordBreak",n[n.wordSeparators=129]="wordSeparators",n[n.wordWrap=130]="wordWrap",n[n.wordWrapBreakAfterCharacters=131]="wordWrapBreakAfterCharacters",n[n.wordWrapBreakBeforeCharacters=132]="wordWrapBreakBeforeCharacters",n[n.wordWrapColumn=133]="wordWrapColumn",n[n.wordWrapOverride1=134]="wordWrapOverride1",n[n.wordWrapOverride2=135]="wordWrapOverride2",n[n.wrappingIndent=136]="wrappingIndent",n[n.wrappingStrategy=137]="wrappingStrategy",n[n.showDeprecated=138]="showDeprecated",n[n.inlayHints=139]="inlayHints",n[n.editorClassName=140]="editorClassName",n[n.pixelRatio=141]="pixelRatio",n[n.tabFocusMode=142]="tabFocusMode",n[n.layoutInfo=143]="layoutInfo",n[n.wrappingInfo=144]="wrappingInfo",n[n.defaultColorDecorators=145]="defaultColorDecorators",n[n.colorDecoratorsActivatedOn=146]="colorDecoratorsActivatedOn",n[n.inlineCompletionsAccessibilityVerbose=147]="inlineCompletionsAccessibilityVerbose"})(b||(t.EditorOption=b={}));var e;(function(n){n[n.TextDefined=0]="TextDefined",n[n.LF=1]="LF",n[n.CRLF=2]="CRLF"})(e||(t.EndOfLinePreference=e={}));var w;(function(n){n[n.LF=0]="LF",n[n.CRLF=1]="CRLF"})(w||(t.EndOfLineSequence=w={}));var R;(function(n){n[n.Left=1]="Left",n[n.Right=2]="Right"})(R||(t.GlyphMarginLane=R={}));var E;(function(n){n[n.None=0]="None",n[n.Indent=1]="Indent",n[n.IndentOutdent=2]="IndentOutdent",n[n.Outdent=3]="Outdent"})(E||(t.IndentAction=E={}));var h;(function(n){n[n.Both=0]="Both",n[n.Right=1]="Right",n[n.Left=2]="Left",n[n.None=3]="None"})(h||(t.InjectedTextCursorStops=h={}));var o;(function(n){n[n.Type=1]="Type",n[n.Parameter=2]="Parameter"})(o||(t.InlayHintKind=o={}));var f;(function(n){n[n.Automatic=0]="Automatic",n[n.Explicit=1]="Explicit"})(f||(t.InlineCompletionTriggerKind=f={}));var u;(function(n){n[n.DependsOnKbLayout=-1]="DependsOnKbLayout",n[n.Unknown=0]="Unknown",n[n.Backspace=1]="Backspace",n[n.Tab=2]="Tab",n[n.Enter=3]="Enter",n[n.Shift=4]="Shift",n[n.Ctrl=5]="Ctrl",n[n.Alt=6]="Alt",n[n.PauseBreak=7]="PauseBreak",n[n.CapsLock=8]="CapsLock",n[n.Escape=9]="Escape",n[n.Space=10]="Space",n[n.PageUp=11]="PageUp",n[n.PageDown=12]="PageDown",n[n.End=13]="End",n[n.Home=14]="Home",n[n.LeftArrow=15]="LeftArrow",n[n.UpArrow=16]="UpArrow",n[n.RightArrow=17]="RightArrow",n[n.DownArrow=18]="DownArrow",n[n.Insert=19]="Insert",n[n.Delete=20]="Delete",n[n.Digit0=21]="Digit0",n[n.Digit1=22]="Digit1",n[n.Digit2=23]="Digit2",n[n.Digit3=24]="Digit3",n[n.Digit4=25]="Digit4",n[n.Digit5=26]="Digit5",n[n.Digit6=27]="Digit6",n[n.Digit7=28]="Digit7",n[n.Digit8=29]="Digit8",n[n.Digit9=30]="Digit9",n[n.KeyA=31]="KeyA",n[n.KeyB=32]="KeyB",n[n.KeyC=33]="KeyC",n[n.KeyD=34]="KeyD",n[n.KeyE=35]="KeyE",n[n.KeyF=36]="KeyF",n[n.KeyG=37]="KeyG",n[n.KeyH=38]="KeyH",n[n.KeyI=39]="KeyI",n[n.KeyJ=40]="KeyJ",n[n.KeyK=41]="KeyK",n[n.KeyL=42]="KeyL",n[n.KeyM=43]="KeyM",n[n.KeyN=44]="KeyN",n[n.KeyO=45]="KeyO",n[n.KeyP=46]="KeyP",n[n.KeyQ=47]="KeyQ",n[n.KeyR=48]="KeyR",n[n.KeyS=49]="KeyS",n[n.KeyT=50]="KeyT",n[n.KeyU=51]="KeyU",n[n.KeyV=52]="KeyV",n[n.KeyW=53]="KeyW",n[n.KeyX=54]="KeyX",n[n.KeyY=55]="KeyY",n[n.KeyZ=56]="KeyZ",n[n.Meta=57]="Meta",n[n.ContextMenu=58]="ContextMenu",n[n.F1=59]="F1",n[n.F2=60]="F2",n[n.F3=61]="F3",n[n.F4=62]="F4",n[n.F5=63]="F5",n[n.F6=64]="F6",n[n.F7=65]="F7",n[n.F8=66]="F8",n[n.F9=67]="F9",n[n.F10=68]="F10",n[n.F11=69]="F11",n[n.F12=70]="F12",n[n.F13=71]="F13",n[n.F14=72]="F14",n[n.F15=73]="F15",n[n.F16=74]="F16",n[n.F17=75]="F17",n[n.F18=76]="F18",n[n.F19=77]="F19",n[n.F20=78]="F20",n[n.F21=79]="F21",n[n.F22=80]="F22",n[n.F23=81]="F23",n[n.F24=82]="F24",n[n.NumLock=83]="NumLock",n[n.ScrollLock=84]="ScrollLock",n[n.Semicolon=85]="Semicolon",n[n.Equal=86]="Equal",n[n.Comma=87]="Comma",n[n.Minus=88]="Minus",n[n.Period=89]="Period",n[n.Slash=90]="Slash",n[n.Backquote=91]="Backquote",n[n.BracketLeft=92]="BracketLeft",n[n.Backslash=93]="Backslash",n[n.BracketRight=94]="BracketRight",n[n.Quote=95]="Quote",n[n.OEM_8=96]="OEM_8",n[n.IntlBackslash=97]="IntlBackslash",n[n.Numpad0=98]="Numpad0",n[n.Numpad1=99]="Numpad1",n[n.Numpad2=100]="Numpad2",n[n.Numpad3=101]="Numpad3",n[n.Numpad4=102]="Numpad4",n[n.Numpad5=103]="Numpad5",n[n.Numpad6=104]="Numpad6",n[n.Numpad7=105]="Numpad7",n[n.Numpad8=106]="Numpad8",n[n.Numpad9=107]="Numpad9",n[n.NumpadMultiply=108]="NumpadMultiply",n[n.NumpadAdd=109]="NumpadAdd",n[n.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",n[n.NumpadSubtract=111]="NumpadSubtract",n[n.NumpadDecimal=112]="NumpadDecimal",n[n.NumpadDivide=113]="NumpadDivide",n[n.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",n[n.ABNT_C1=115]="ABNT_C1",n[n.ABNT_C2=116]="ABNT_C2",n[n.AudioVolumeMute=117]="AudioVolumeMute",n[n.AudioVolumeUp=118]="AudioVolumeUp",n[n.AudioVolumeDown=119]="AudioVolumeDown",n[n.BrowserSearch=120]="BrowserSearch",n[n.BrowserHome=121]="BrowserHome",n[n.BrowserBack=122]="BrowserBack",n[n.BrowserForward=123]="BrowserForward",n[n.MediaTrackNext=124]="MediaTrackNext",n[n.MediaTrackPrevious=125]="MediaTrackPrevious",n[n.MediaStop=126]="MediaStop",n[n.MediaPlayPause=127]="MediaPlayPause",n[n.LaunchMediaPlayer=128]="LaunchMediaPlayer",n[n.LaunchMail=129]="LaunchMail",n[n.LaunchApp2=130]="LaunchApp2",n[n.Clear=131]="Clear",n[n.MAX_VALUE=132]="MAX_VALUE"})(u||(t.KeyCode=u={}));var i;(function(n){n[n.Hint=1]="Hint",n[n.Info=2]="Info",n[n.Warning=4]="Warning",n[n.Error=8]="Error"})(i||(t.MarkerSeverity=i={}));var a;(function(n){n[n.Unnecessary=1]="Unnecessary",n[n.Deprecated=2]="Deprecated"})(a||(t.MarkerTag=a={}));var N;(function(n){n[n.Inline=1]="Inline",n[n.Gutter=2]="Gutter"})(N||(t.MinimapPosition=N={}));var $;(function(n){n[n.UNKNOWN=0]="UNKNOWN",n[n.TEXTAREA=1]="TEXTAREA",n[n.GUTTER_GLYPH_MARGIN=2]="GUTTER_GLYPH_MARGIN",n[n.GUTTER_LINE_NUMBERS=3]="GUTTER_LINE_NUMBERS",n[n.GUTTER_LINE_DECORATIONS=4]="GUTTER_LINE_DECORATIONS",n[n.GUTTER_VIEW_ZONE=5]="GUTTER_VIEW_ZONE",n[n.CONTENT_TEXT=6]="CONTENT_TEXT",n[n.CONTENT_EMPTY=7]="CONTENT_EMPTY",n[n.CONTENT_VIEW_ZONE=8]="CONTENT_VIEW_ZONE",n[n.CONTENT_WIDGET=9]="CONTENT_WIDGET",n[n.OVERVIEW_RULER=10]="OVERVIEW_RULER",n[n.SCROLLBAR=11]="SCROLLBAR",n[n.OVERLAY_WIDGET=12]="OVERLAY_WIDGET",n[n.OUTSIDE_EDITOR=13]="OUTSIDE_EDITOR"})($||(t.MouseTargetType=$={}));var v;(function(n){n[n.TOP_RIGHT_CORNER=0]="TOP_RIGHT_CORNER",n[n.BOTTOM_RIGHT_CORNER=1]="BOTTOM_RIGHT_CORNER",n[n.TOP_CENTER=2]="TOP_CENTER"})(v||(t.OverlayWidgetPositionPreference=v={}));var p;(function(n){n[n.Left=1]="Left",n[n.Center=2]="Center",n[n.Right=4]="Right",n[n.Full=7]="Full"})(p||(t.OverviewRulerLane=p={}));var M;(function(n){n[n.Left=0]="Left",n[n.Right=1]="Right",n[n.None=2]="None",n[n.LeftOfInjectedText=3]="LeftOfInjectedText",n[n.RightOfInjectedText=4]="RightOfInjectedText"})(M||(t.PositionAffinity=M={}));var P;(function(n){n[n.Off=0]="Off",n[n.On=1]="On",n[n.Relative=2]="Relative",n[n.Interval=3]="Interval",n[n.Custom=4]="Custom"})(P||(t.RenderLineNumbersType=P={}));var F;(function(n){n[n.None=0]="None",n[n.Text=1]="Text",n[n.Blocks=2]="Blocks"})(F||(t.RenderMinimap=F={}));var y;(function(n){n[n.Smooth=0]="Smooth",n[n.Immediate=1]="Immediate"})(y||(t.ScrollType=y={}));var D;(function(n){n[n.Auto=1]="Auto",n[n.Hidden=2]="Hidden",n[n.Visible=3]="Visible"})(D||(t.ScrollbarVisibility=D={}));var q;(function(n){n[n.LTR=0]="LTR",n[n.RTL=1]="RTL"})(q||(t.SelectionDirection=q={}));var I;(function(n){n[n.Invoke=1]="Invoke",n[n.TriggerCharacter=2]="TriggerCharacter",n[n.ContentChange=3]="ContentChange"})(I||(t.SignatureHelpTriggerKind=I={}));var x;(function(n){n[n.File=0]="File",n[n.Module=1]="Module",n[n.Namespace=2]="Namespace",n[n.Package=3]="Package",n[n.Class=4]="Class",n[n.Method=5]="Method",n[n.Property=6]="Property",n[n.Field=7]="Field",n[n.Constructor=8]="Constructor",n[n.Enum=9]="Enum",n[n.Interface=10]="Interface",n[n.Function=11]="Function",n[n.Variable=12]="Variable",n[n.Constant=13]="Constant",n[n.String=14]="String",n[n.Number=15]="Number",n[n.Boolean=16]="Boolean",n[n.Array=17]="Array",n[n.Object=18]="Object",n[n.Key=19]="Key",n[n.Null=20]="Null",n[n.EnumMember=21]="EnumMember",n[n.Struct=22]="Struct",n[n.Event=23]="Event",n[n.Operator=24]="Operator",n[n.TypeParameter=25]="TypeParameter"})(x||(t.SymbolKind=x={}));var T;(function(n){n[n.Deprecated=1]="Deprecated"})(T||(t.SymbolTag=T={}));var j;(function(n){n[n.Hidden=0]="Hidden",n[n.Blink=1]="Blink",n[n.Smooth=2]="Smooth",n[n.Phase=3]="Phase",n[n.Expand=4]="Expand",n[n.Solid=5]="Solid"})(j||(t.TextEditorCursorBlinkingStyle=j={}));var z;(function(n){n[n.Line=1]="Line",n[n.Block=2]="Block",n[n.Underline=3]="Underline",n[n.LineThin=4]="LineThin",n[n.BlockOutline=5]="BlockOutline",n[n.UnderlineThin=6]="UnderlineThin"})(z||(t.TextEditorCursorStyle=z={}));var C;(function(n){n[n.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",n[n.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",n[n.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",n[n.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(C||(t.TrackedRangeStickiness=C={}));var X;(function(n){n[n.None=0]="None",n[n.Same=1]="Same",n[n.Indent=2]="Indent",n[n.DeepIndent=3]="DeepIndent"})(X||(t.WrappingIndent=X={}))}),te(ie[62],se([0,1,11,10]),function(O,t,k,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Xs=void 0;class r{constructor(){this.a=new Map,this.b=new Map,this.c=new k.$Ld,this.onDidChange=this.c.event,this.d=null}handleChange(d){this.c.fire({changedLanguages:d,changedColorMap:!1})}register(d,l){return this.a.set(d,l),this.handleChange([d]),(0,_.$Oc)(()=>{this.a.get(d)===l&&(this.a.delete(d),this.handleChange([d]))})}get(d){return this.a.get(d)||null}registerFactory(d,l){this.b.get(d)?.dispose();const s=new c(this,d,l);return this.b.set(d,s),(0,_.$Oc)(()=>{const g=this.b.get(d);!g||g!==s||(this.b.delete(d),g.dispose())})}async getOrCreate(d){const l=this.get(d);if(l)return l;const s=this.b.get(d);return!s||s.isResolved?null:(await s.resolve(),this.get(d))}isResolved(d){if(this.get(d))return!0;const s=this.b.get(d);return!!(!s||s.isResolved)}setColorMap(d){this.d=d,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}t.$Xs=r;class c extends _.$Qc{get isResolved(){return this.c}constructor(d,l,s){super(),this.f=d,this.g=l,this.h=s,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const d=await this.h.tokenizationSupport;this.c=!0,d&&!this.a&&this.B(this.f.register(this.g,d))}}}),te(ie[63],se([68,69]),function(O,t){return O.create("vs/editor/common/languages",t)}),te(ie[64],se([0,1,43,16,44,2,62,63]),function(O,t,k,_,r,c,L,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExternalUriOpenerPriority=t.$dt=t.$ct=t.InlayHintKind=t.CommentState=t.CommentMode=t.CommentThreadState=t.CommentThreadCollapsibleState=t.Command=t.$bt=t.$at=t.SymbolKinds=t.SymbolTag=t.$_s=t.$$s=t.SymbolKind=t.$0s=t.DocumentHighlightKind=t.SignatureHelpTriggerKind=t.CodeActionTriggerType=t.$9s=t.InlineCompletionTriggerKind=t.CompletionTriggerKind=t.CompletionItemInsertTextRule=t.CompletionItemTag=t.CompletionItemKinds=t.CompletionItemKind=t.$8s=t.$7s=t.$6s=void 0;class l{constructor(j,z,C){this.offset=j,this.type=z,this.language=C,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}t.$6s=l;class s{constructor(j,z){this.tokens=j,this.endState=z,this._tokenizationResultBrand=void 0}}t.$7s=s;class g{constructor(j,z){this.tokens=j,this.endState=z,this._encodedTokenizationResultBrand=void 0}}t.$8s=g;var A;(function(T){T[T.Method=0]="Method",T[T.Function=1]="Function",T[T.Constructor=2]="Constructor",T[T.Field=3]="Field",T[T.Variable=4]="Variable",T[T.Class=5]="Class",T[T.Struct=6]="Struct",T[T.Interface=7]="Interface",T[T.Module=8]="Module",T[T.Property=9]="Property",T[T.Event=10]="Event",T[T.Operator=11]="Operator",T[T.Unit=12]="Unit",T[T.Value=13]="Value",T[T.Constant=14]="Constant",T[T.Enum=15]="Enum",T[T.EnumMember=16]="EnumMember",T[T.Keyword=17]="Keyword",T[T.Text=18]="Text",T[T.Color=19]="Color",T[T.File=20]="File",T[T.Reference=21]="Reference",T[T.Customcolor=22]="Customcolor",T[T.Folder=23]="Folder",T[T.TypeParameter=24]="TypeParameter",T[T.User=25]="User",T[T.Issue=26]="Issue",T[T.Snippet=27]="Snippet"})(A||(t.CompletionItemKind=A={}));var m;(function(T){const j=new Map;j.set(0,k.$Qj.symbolMethod),j.set(1,k.$Qj.symbolFunction),j.set(2,k.$Qj.symbolConstructor),j.set(3,k.$Qj.symbolField),j.set(4,k.$Qj.symbolVariable),j.set(5,k.$Qj.symbolClass),j.set(6,k.$Qj.symbolStruct),j.set(7,k.$Qj.symbolInterface),j.set(8,k.$Qj.symbolModule),j.set(9,k.$Qj.symbolProperty),j.set(10,k.$Qj.symbolEvent),j.set(11,k.$Qj.symbolOperator),j.set(12,k.$Qj.symbolUnit),j.set(13,k.$Qj.symbolValue),j.set(15,k.$Qj.symbolEnum),j.set(14,k.$Qj.symbolConstant),j.set(15,k.$Qj.symbolEnum),j.set(16,k.$Qj.symbolEnumMember),j.set(17,k.$Qj.symbolKeyword),j.set(27,k.$Qj.symbolSnippet),j.set(18,k.$Qj.symbolText),j.set(19,k.$Qj.symbolColor),j.set(20,k.$Qj.symbolFile),j.set(21,k.$Qj.symbolReference),j.set(22,k.$Qj.symbolCustomColor),j.set(23,k.$Qj.symbolFolder),j.set(24,k.$Qj.symbolTypeParameter),j.set(25,k.$Qj.account),j.set(26,k.$Qj.issues);function z(n){let ne=j.get(n);return ne||(console.info("No codicon found for CompletionItemKind "+n),ne=k.$Qj.symbolProperty),ne}T.toIcon=z;const C=new Map;C.set("method",0),C.set("function",1),C.set("constructor",2),C.set("field",3),C.set("variable",4),C.set("class",5),C.set("struct",6),C.set("interface",7),C.set("module",8),C.set("property",9),C.set("event",10),C.set("operator",11),C.set("unit",12),C.set("value",13),C.set("constant",14),C.set("enum",15),C.set("enum-member",16),C.set("enumMember",16),C.set("keyword",17),C.set("snippet",27),C.set("text",18),C.set("color",19),C.set("file",20),C.set("reference",21),C.set("customcolor",22),C.set("folder",23),C.set("type-parameter",24),C.set("typeParameter",24),C.set("account",25),C.set("issue",26);function X(n,ne){let oe=C.get(n);return typeof oe>"u"&&!ne&&(oe=9),oe}T.fromString=X})(m||(t.CompletionItemKinds=m={}));var b;(function(T){T[T.Deprecated=1]="Deprecated"})(b||(t.CompletionItemTag=b={}));var e;(function(T){T[T.None=0]="None",T[T.KeepWhitespace=1]="KeepWhitespace",T[T.InsertAsSnippet=4]="InsertAsSnippet"})(e||(t.CompletionItemInsertTextRule=e={}));var w;(function(T){T[T.Invoke=0]="Invoke",T[T.TriggerCharacter=1]="TriggerCharacter",T[T.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(w||(t.CompletionTriggerKind=w={}));var R;(function(T){T[T.Automatic=0]="Automatic",T[T.Explicit=1]="Explicit"})(R||(t.InlineCompletionTriggerKind=R={}));class E{constructor(j,z,C,X){this.range=j,this.text=z,this.completionKind=C,this.isSnippetText=X}equals(j){return c.$ms.lift(this.range).equalsRange(j.range)&&this.text===j.text&&this.completionKind===j.completionKind&&this.isSnippetText===j.isSnippetText}}t.$9s=E;var h;(function(T){T[T.Invoke=1]="Invoke",T[T.Auto=2]="Auto"})(h||(t.CodeActionTriggerType=h={}));var o;(function(T){T[T.Invoke=1]="Invoke",T[T.TriggerCharacter=2]="TriggerCharacter",T[T.ContentChange=3]="ContentChange"})(o||(t.SignatureHelpTriggerKind=o={}));var f;(function(T){T[T.Text=0]="Text",T[T.Read=1]="Read",T[T.Write=2]="Write"})(f||(t.DocumentHighlightKind=f={}));function u(T){return T&&_.URI.isUri(T.uri)&&c.$ms.isIRange(T.range)&&(c.$ms.isIRange(T.originSelectionRange)||c.$ms.isIRange(T.targetSelectionRange))}t.$0s=u;var i;(function(T){T[T.File=0]="File",T[T.Module=1]="Module",T[T.Namespace=2]="Namespace",T[T.Package=3]="Package",T[T.Class=4]="Class",T[T.Method=5]="Method",T[T.Property=6]="Property",T[T.Field=7]="Field",T[T.Constructor=8]="Constructor",T[T.Enum=9]="Enum",T[T.Interface=10]="Interface",T[T.Function=11]="Function",T[T.Variable=12]="Variable",T[T.Constant=13]="Constant",T[T.String=14]="String",T[T.Number=15]="Number",T[T.Boolean=16]="Boolean",T[T.Array=17]="Array",T[T.Object=18]="Object",T[T.Key=19]="Key",T[T.Null=20]="Null",T[T.EnumMember=21]="EnumMember",T[T.Struct=22]="Struct",T[T.Event=23]="Event",T[T.Operator=24]="Operator",T[T.TypeParameter=25]="TypeParameter"})(i||(t.SymbolKind=i={})),t.$$s={[17]:(0,d.localize)(0,null),[16]:(0,d.localize)(1,null),[4]:(0,d.localize)(2,null),[13]:(0,d.localize)(3,null),[8]:(0,d.localize)(4,null),[9]:(0,d.localize)(5,null),[21]:(0,d.localize)(6,null),[23]:(0,d.localize)(7,null),[7]:(0,d.localize)(8,null),[0]:(0,d.localize)(9,null),[11]:(0,d.localize)(10,null),[10]:(0,d.localize)(11,null),[19]:(0,d.localize)(12,null),[5]:(0,d.localize)(13,null),[1]:(0,d.localize)(14,null),[2]:(0,d.localize)(15,null),[20]:(0,d.localize)(16,null),[15]:(0,d.localize)(17,null),[18]:(0,d.localize)(18,null),[24]:(0,d.localize)(19,null),[3]:(0,d.localize)(20,null),[6]:(0,d.localize)(21,null),[14]:(0,d.localize)(22,null),[22]:(0,d.localize)(23,null),[25]:(0,d.localize)(24,null),[12]:(0,d.localize)(25,null)};function a(T,j){return(0,d.localize)(26,null,T,t.$$s[j])}t.$_s=a;var N;(function(T){T[T.Deprecated=1]="Deprecated"})(N||(t.SymbolTag=N={}));var $;(function(T){const j=new Map;j.set(0,k.$Qj.symbolFile),j.set(1,k.$Qj.symbolModule),j.set(2,k.$Qj.symbolNamespace),j.set(3,k.$Qj.symbolPackage),j.set(4,k.$Qj.symbolClass),j.set(5,k.$Qj.symbolMethod),j.set(6,k.$Qj.symbolProperty),j.set(7,k.$Qj.symbolField),j.set(8,k.$Qj.symbolConstructor),j.set(9,k.$Qj.symbolEnum),j.set(10,k.$Qj.symbolInterface),j.set(11,k.$Qj.symbolFunction),j.set(12,k.$Qj.symbolVariable),j.set(13,k.$Qj.symbolConstant),j.set(14,k.$Qj.symbolString),j.set(15,k.$Qj.symbolNumber),j.set(16,k.$Qj.symbolBoolean),j.set(17,k.$Qj.symbolArray),j.set(18,k.$Qj.symbolObject),j.set(19,k.$Qj.symbolKey),j.set(20,k.$Qj.symbolNull),j.set(21,k.$Qj.symbolEnumMember),j.set(22,k.$Qj.symbolStruct),j.set(23,k.$Qj.symbolEvent),j.set(24,k.$Qj.symbolOperator),j.set(25,k.$Qj.symbolTypeParameter);function z(C){let X=j.get(C);return X||(console.info("No codicon found for SymbolKind "+C),X=k.$Qj.symbolProperty),X}T.toIcon=z})($||(t.SymbolKinds=$={}));class v{static asEditOperation(j){return r.$ns.replace(c.$ms.lift(j.range),j.text)}}t.$at=v;class p{static fromValue(j){switch(j){case"comment":return p.Comment;case"imports":return p.Imports;case"region":return p.Region}return new p(j)}constructor(j){this.value=j}}t.$bt=p,p.Comment=new p("comment"),p.Imports=new p("imports"),p.Region=new p("region");var M;(function(T){function j(z){return!z||typeof z!="object"?!1:typeof z.id=="string"&&typeof z.title=="string"}T.is=j})(M||(t.Command=M={}));var P;(function(T){T[T.Collapsed=0]="Collapsed",T[T.Expanded=1]="Expanded"})(P||(t.CommentThreadCollapsibleState=P={}));var F;(function(T){T[T.Unresolved=0]="Unresolved",T[T.Resolved=1]="Resolved"})(F||(t.CommentThreadState=F={}));var y;(function(T){T[T.Editing=0]="Editing",T[T.Preview=1]="Preview"})(y||(t.CommentMode=y={}));var D;(function(T){T[T.Published=0]="Published",T[T.Draft=1]="Draft"})(D||(t.CommentState=D={}));var q;(function(T){T[T.Type=1]="Type",T[T.Parameter=2]="Parameter"})(q||(t.InlayHintKind=q={}));class I{constructor(j){this.b=j,this.a=null}dispose(){this.a&&this.a.then(j=>{j&&j.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}t.$ct=I,t.$dt=new L.$Xs;var x;(function(T){T[T.None=0]="None",T[T.Option=1]="Option",T[T.Default=2]="Default",T[T.Preferred=3]="Preferred"})(x||(t.ExternalUriOpenerPriority=x={}))}),te(ie[65],se([0,1,24,11,37,16,5,2,45,64,61]),function(O,t,k,_,r,c,L,d,l,s,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$QY=t.$PY=void 0;class A{static chord(e,w){return(0,r.$xq)(e,w)}}t.$PY=A,A.CtrlCmd=2048,A.Shift=1024,A.Alt=512,A.WinCtrl=256;function m(){return{editor:void 0,languages:void 0,CancellationTokenSource:k.$Vd,Emitter:_.$Ld,KeyCode:g.KeyCode,KeyMod:A,Position:L.$ls,Range:d.$ms,Selection:l.$os,SelectionDirection:g.SelectionDirection,MarkerSeverity:g.MarkerSeverity,MarkerTag:g.MarkerTag,Uri:c.URI,Token:s.$6s}}t.$QY=m}),te(ie[70],se([0,1,25,16,5,2,58,29,54,55,65,23,60,33,52,15,3,53]),function(O,t,k,_,r,c,L,d,l,s,g,A,m,b,e,w,R,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.create=t.EditorSimpleWorker=void 0;class h extends L.$Ou{get uri(){return this.d}get eol(){return this.g}getValue(){return this.getText()}findMatches(i){const a=[];for(let N=0;N<this.f.length;N++){const $=this.f[N],v=this.offsetAt(new r.$ls(N+1,1)),p=$.matchAll(i);for(const M of p)(M.index||M.index===0)&&(M.index=M.index+v),a.push(M)}return a}getLinesContent(){return this.f.slice(0)}getLineCount(){return this.f.length}getLineContent(i){return this.f[i-1]}getWordAtPosition(i,a){const N=(0,d.$2r)(i.column,(0,d.$Zr)(a),this.f[i.lineNumber-1],0);return N?new c.$ms(i.lineNumber,N.startColumn,i.lineNumber,N.endColumn):null}getWordUntilPosition(i,a){const N=this.getWordAtPosition(i,a);return N?{word:this.f[i.lineNumber-1].substring(N.startColumn-1,i.column-1),startColumn:N.startColumn,endColumn:i.column}:{word:"",startColumn:i.column,endColumn:i.column}}words(i){const a=this.f,N=this.q.bind(this);let $=0,v="",p=0,M=[];return{*[Symbol.iterator](){for(;;)if(p<M.length){const P=v.substring(M[p].start,M[p].end);p+=1,yield P}else if($<a.length)v=a[$],M=N(v,i),p=0,$+=1;else break}}}getLineWords(i,a){const N=this.f[i-1],$=this.q(N,a),v=[];for(const p of $)v.push({word:N.substring(p.start,p.end),startColumn:p.start+1,endColumn:p.end+1});return v}q(i,a){const N=[];let $;for(a.lastIndex=0;($=a.exec(i))&&$[0].length!==0;)N.push({start:$.index,end:$.index+$[0].length});return N}getValueInRange(i){if(i=this.r(i),i.startLineNumber===i.endLineNumber)return this.f[i.startLineNumber-1].substring(i.startColumn-1,i.endColumn-1);const a=this.g,N=i.startLineNumber-1,$=i.endLineNumber-1,v=[];v.push(this.f[N].substring(i.startColumn-1));for(let p=N+1;p<$;p++)v.push(this.f[p]);return v.push(this.f[$].substring(0,i.endColumn-1)),v.join(a)}offsetAt(i){return i=this.s(i),this.l(),this.j.getPrefixSum(i.lineNumber-2)+(i.column-1)}positionAt(i){i=Math.floor(i),i=Math.max(0,i),this.l();const a=this.j.getIndexOf(i),N=this.f[a.index].length;return{lineNumber:1+a.index,column:1+Math.min(a.remainder,N)}}r(i){const a=this.s({lineNumber:i.startLineNumber,column:i.startColumn}),N=this.s({lineNumber:i.endLineNumber,column:i.endColumn});return a.lineNumber!==i.startLineNumber||a.column!==i.startColumn||N.lineNumber!==i.endLineNumber||N.column!==i.endColumn?{startLineNumber:a.lineNumber,startColumn:a.column,endLineNumber:N.lineNumber,endColumn:N.column}:i}s(i){if(!r.$ls.isIPosition(i))throw new Error("bad position");let{lineNumber:a,column:N}=i,$=!1;if(a<1)a=1,N=1,$=!0;else if(a>this.f.length)a=this.f.length,N=this.f[a-1].length+1,$=!0;else{const v=this.f[a-1].length+1;N<1?(N=1,$=!0):N>v&&(N=v,$=!0)}return $?{lineNumber:a,column:N}:i}}class o{constructor(i,a){this.d=i,this.f=Object.create(null),this.g=a,this.h=null}dispose(){this.f=Object.create(null)}j(i){return this.f[i]}k(){const i=[];return Object.keys(this.f).forEach(a=>i.push(this.f[a])),i}acceptNewModel(i){this.f[i.url]=new h(_.URI.parse(i.url),i.lines,i.EOL,i.versionId)}acceptModelChanged(i,a){if(!this.f[i])return;this.f[i].onEvents(a)}acceptRemovedModel(i){this.f[i]&&delete this.f[i]}async computeUnicodeHighlights(i,a,N){const $=this.j(i);return $?m.$KY.computeUnicodeHighlights($,a,N):{ranges:[],hasMore:!1,ambiguousCharacterCount:0,invisibleCharacterCount:0,nonBasicAsciiCharacterCount:0}}async computeDiff(i,a,N,$){const v=this.j(i),p=this.j(a);return!v||!p?null:o.l(v,p,N,$)}static l(i,a,N,$){const v=$==="advanced"?e.$aZ.getDefault():e.$aZ.getLegacy(),p=i.getLinesContent(),M=a.getLinesContent(),P=v.computeDiff(p,M,N),F=P.changes.length>0?!1:this.n(i,a);function y(D){return D.map(q=>[q.original.startLineNumber,q.original.endLineNumberExclusive,q.modified.startLineNumber,q.modified.endLineNumberExclusive,q.innerChanges?.map(I=>[I.originalRange.startLineNumber,I.originalRange.startColumn,I.originalRange.endLineNumber,I.originalRange.endColumn,I.modifiedRange.startLineNumber,I.modifiedRange.startColumn,I.modifiedRange.endLineNumber,I.modifiedRange.endColumn])])}return{identical:F,quitEarly:P.hitTimeout,changes:y(P.changes),moves:P.moves.map(D=>[D.lineRangeMapping.original.startLineNumber,D.lineRangeMapping.original.endLineNumberExclusive,D.lineRangeMapping.modified.startLineNumber,D.lineRangeMapping.modified.endLineNumberExclusive,y(D.changes)])}}static n(i,a){const N=i.getLineCount(),$=a.getLineCount();if(N!==$)return!1;for(let v=1;v<=N;v++){const p=i.getLineContent(v),M=a.getLineContent(v);if(p!==M)return!1}return!0}async computeDirtyDiff(i,a,N){const $=this.j(i),v=this.j(a);if(!$||!v)return null;const p=$.getLinesContent(),M=v.getLinesContent();return new b.$Ds(p,M,{shouldComputeCharChanges:!1,shouldPostProcessCharChanges:!1,shouldIgnoreTrimWhitespace:N,shouldMakePrettyDiff:!0,maxComputationTime:1e3}).computeDiff().changes}async computeMoreMinimalEdits(i,a,N){const $=this.j(i);if(!$)return a;const v=[];let p;a=a.slice(0).sort((P,F)=>{if(P.range&&F.range)return c.$ms.compareRangesUsingStarts(P.range,F.range);const y=P.range?0:1,D=F.range?0:1;return y-D});let M=0;for(let P=1;P<a.length;P++)c.$ms.getEndPosition(a[M].range).equals(c.$ms.getStartPosition(a[P].range))?(a[M].range=c.$ms.fromPositions(c.$ms.getStartPosition(a[M].range),c.$ms.getEndPosition(a[P].range)),a[M].text+=a[P].text):(M++,a[M]=a[P]);a.length=M+1;for(let{range:P,text:F,eol:y}of a){if(typeof y=="number"&&(p=y),c.$ms.isEmpty(P)&&!F)continue;const D=$.getValueInRange(P);if(F=F.replace(/\r\n|\n|\r/g,$.eol),D===F)continue;if(Math.max(F.length,D.length)>o.o){v.push({range:P,text:F});continue}const q=(0,k.$rs)(D,F,N),I=$.offsetAt(c.$ms.lift(P).getStartPosition());for(const x of q){const T=$.positionAt(I+x.originalStart),j=$.positionAt(I+x.originalStart+x.originalLength),z={text:F.substr(x.modifiedStart,x.modifiedLength),range:{startLineNumber:T.lineNumber,startColumn:T.column,endLineNumber:j.lineNumber,endColumn:j.column}};$.getValueInRange(z.range)!==z.text&&v.push(z)}}return typeof p=="number"&&v.push({eol:p,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),v}computeHumanReadableDiff(i,a,N){const $=this.j(i);if(!$)return a;const v=[];let p;a=a.slice(0).sort((M,P)=>{if(M.range&&P.range)return c.$ms.compareRangesUsingStarts(M.range,P.range);const F=M.range?0:1,y=P.range?0:1;return F-y});for(let{range:M,text:P,eol:F}of a){let T=function(z,C){return new r.$ls(z.lineNumber+C.lineNumber-1,C.lineNumber===1?z.column+C.column-1:C.column)},j=function(z,C){const X=[];for(let n=C.startLineNumber;n<=C.endLineNumber;n++){const ne=z[n-1];n===C.startLineNumber&&n===C.endLineNumber?X.push(ne.substring(C.startColumn-1,C.endColumn-1)):n===C.startLineNumber?X.push(ne.substring(C.startColumn-1)):n===C.endLineNumber?X.push(ne.substring(0,C.endColumn-1)):X.push(ne)}return X};if(typeof F=="number"&&(p=F),c.$ms.isEmpty(M)&&!P)continue;const y=$.getValueInRange(M);if(P=P.replace(/\r\n|\n|\r/g,$.eol),y===P)continue;if(Math.max(P.length,y.length)>o.o){v.push({range:M,text:P});continue}const D=y.split(/\r\n|\n|\r/),q=P.split(/\r\n|\n|\r/),I=e.$aZ.getDefault().computeDiff(D,q,N),x=c.$ms.lift(M).getStartPosition();for(const z of I.changes)if(z.innerChanges)for(const C of z.innerChanges)v.push({range:c.$ms.fromPositions(T(x,C.originalRange.getStartPosition()),T(x,C.originalRange.getEndPosition())),text:j(q,C.modifiedRange).join($.eol)});else throw new R.$ab("The experimental diff algorithm always produces inner changes")}return typeof p=="number"&&v.push({eol:p,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),v}async computeLinks(i){const a=this.j(i);return a?(0,l.$NY)(a):null}async computeDefaultDocumentColors(i){const a=this.j(i);return a?(0,E.$bZ)(a):null}async textualSuggest(i,a,N,$){const v=new A.$Hd,p=new RegExp(N,$),M=new Set;e:for(const P of i){const F=this.j(P);if(F){for(const y of F.words(p))if(!(y===a||!isNaN(Number(y)))&&(M.add(y),M.size>o.p))break e}}return{words:Array.from(M),duration:v.elapsed()}}async computeWordRanges(i,a,N,$){const v=this.j(i);if(!v)return Object.create(null);const p=new RegExp(N,$),M=Object.create(null);for(let P=a.startLineNumber;P<a.endLineNumber;P++){const F=v.getLineWords(P,p);for(const y of F){if(!isNaN(Number(y.word)))continue;let D=M[y.word];D||(D=[],M[y.word]=D),D.push({startLineNumber:P,startColumn:y.startColumn,endLineNumber:P,endColumn:y.endColumn})}}return M}async navigateValueSet(i,a,N,$,v){const p=this.j(i);if(!p)return null;const M=new RegExp($,v);a.startColumn===a.endColumn&&(a={startLineNumber:a.startLineNumber,startColumn:a.startColumn,endLineNumber:a.endLineNumber,endColumn:a.endColumn+1});const P=p.getValueInRange(a),F=p.getWordAtPosition({lineNumber:a.startLineNumber,column:a.startColumn},M);if(!F)return null;const y=p.getValueInRange(F);return s.$OY.INSTANCE.navigateValueSet(a,P,F,y,N)}loadForeignModule(i,a,N){const $=(M,P)=>this.d.fhr(M,P),p={host:(0,w.$9m)(N,$),getMirrorModels:()=>this.k()};return this.g?(this.h=this.g(p,a),Promise.resolve((0,w.$8m)(this.h))):new Promise((M,P)=>{O([i],F=>{this.h=F.create(p,a),M((0,w.$8m)(this.h))},P)})}fmr(i,a){if(!this.h||typeof this.h[i]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+i));try{return Promise.resolve(this.h[i].apply(this.h,a))}catch(N){return Promise.reject(N)}}}t.EditorSimpleWorker=o,o.o=1e5,o.p=1e4;function f(u){return new o(u,null)}t.create=f,typeof importScripts=="function"&&(globalThis.monaco=(0,g.$QY)())})}).call(this);

//# sourceMappingURL=workerMain.js.map
