"use strict";/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var we=["exports","require","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/path","vs/base/common/types","vs/nls","vs/nls!vs/server/node/server.main","vs/base/common/errors","vs/base/common/network","vs/platform/log/common/log","vs/base/common/async","vs/base/common/buffer","vs/platform/files/common/files","vs/base/common/strings","vs/base/common/arrays","vs/base/common/resources","vs/base/common/cancellation","vs/base/node/pfs","vs/base/common/objects","vs/base/common/uuid","vs/platform/configuration/common/configuration","vs/platform/environment/common/environment","vs/base/common/map","os","vs/base/common/process","fs","vs/platform/extensionManagement/common/extensionManagement","vs/platform/product/common/productService","vs/platform/telemetry/common/telemetry","vs/platform/userDataProfile/common/userDataProfile","vs/platform/uriIdentity/common/uriIdentity","vs/platform/registry/common/platform","vs/platform/telemetry/common/telemetryUtils","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/extpath","vs/base/common/errorMessage","vs/platform/extensions/common/extensions","vs/base/common/performance","vs/base/parts/ipc/common/ipc","vs/editor/common/core/range","vs/platform/request/common/request","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/server/node/serverEnvironmentService","vs/base/common/iterator","vs/base/common/stream","vs/base/common/codicons","vs/base/common/marshalling","vs/base/common/uriIpc","child_process","vs/base/common/semver/semver","vs/platform/product/common/product","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/common/mime","vs/base/common/processes","vs/base/common/stopwatch","vs/base/common/hash","vs/base/common/severity","vs/base/common/ternarySearchTree","vs/platform/environment/node/argv","vs/platform/instantiation/common/descriptors","vs/platform/contextkey/common/contextkey","vs/platform/files/common/watcher","vs/platform/files/node/diskFileSystemProvider","vs/platform/policy/common/policy","vs/workbench/api/node/uriTransformer","vs/workbench/contrib/testing/common/testId","vs/base/parts/ipc/node/ipc.net","vs/base/common/decorators","vs/base/common/functional","vs/base/common/json","vs/base/common/glob","path","net","vs/platform/extensions/common/extensionValidator","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","url","vs/platform/shell/node/shellEnv","crypto","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminal","vs/platform/workspace/common/workspace","vs/server/node/remoteLanguagePacks","vs/workbench/common/editor","vs/workbench/contrib/testing/common/testTypes","vs/base/node/zip","vs/base/common/amd","vs/base/common/assert","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/themables","vs/base/common/htmlContent","vs/base/node/id","vs/base/node/powershell","vs/base/node/processes","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/node/ipc.cp","vs/editor/common/core/position","vs/platform/environment/node/environmentService","vs/platform/files/common/io","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/fileService","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/node/loggerService","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/languagePacks/node/languagePacks","vs/platform/terminal/common/environmentVariable","vs/platform/terminal/common/environmentVariableCollection","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/server/node/extensionHostStatusService","vs/server/node/extensionsScannerService","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostTypes","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostTypeConverters","vs/workbench/services/extensions/common/proxyIdentifier","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","vs/server/node/extensionHostConnection","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/marked/marked","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/cache","vs/base/common/filters","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/console","vs/amdX","vs/base/common/labels","vs/base/common/dataTransfer","vs/base/node/languagePacks","vs/base/node/macAddress","vs/base/node/osReleaseInfo","vs/base/node/extpath","vs/base/node/ports","vs/base/parts/storage/common/storage","vs/editor/common/core/editOperation","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/node/zip","vs/nls!vs/editor/common/languages","vs/editor/common/languages","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/server/node/remoteExtensionHostAgentCli","vs/nls!vs/server/node/serverEnvironmentService","vs/nls!vs/server/node/serverServices","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsUtil","vs/platform/contextkey/common/scanner","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/download/common/downloadIpc","vs/platform/environment/common/environmentService","vs/platform/environment/node/argvHelper","vs/platform/environment/node/userDataPath","vs/platform/extensionManagement/common/extensionNls","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/diagnostics/common/diagnostics","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/label/common/label","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/log/node/spdlogLog","vs/platform/markers/common/markers","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/remote/common/remoteExtensionsScanner","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","vs/platform/state/node/state","vs/platform/state/node/stateService","vs/platform/telemetry/common/errorTelemetry","vs/platform/telemetry/common/remoteTelemetryChannel","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/common/serverTelemetryService","vs/platform/telemetry/node/1dsAppender","https","vs/platform/telemetry/node/errorTelemetry","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalEnvironment","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/nodePtyHostStarter","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/storage/common/storage","vs/platform/userDataProfile/common/userDataProfileIpc","vs/server/node/remoteExtensionManagement","vs/server/node/serverConnectionToken","cookie","vs/server/node/telemetryClient","http","vs/server/node/webClientServer","vs/workbench/api/common/extHostInitDataService","vs/workbench/api/common/extHostRpcService","vs/server/node/remoteAgentEnvironmentImpl","vs/server/node/remoteFileSystemProviderServer","vs/workbench/contrib/terminal/common/environmentVariable","vs/workbench/contrib/terminal/common/terminalEnvironment","vs/workbench/services/configuration/common/configuration","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostTestItem","vs/workbench/contrib/terminal/common/remote/remoteTerminalChannel","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostTelemetry","vs/workbench/services/extensions/common/extensionsUtil","vs/server/node/remoteExtensionsScanner","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostCommands","vs/workbench/services/remote/common/remoteFileSystemProviderClient","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionManagementUtil","zlib","vs/server/node/remoteExtensionHostAgentCli","vs/base/node/unc","vs/workbench/api/node/extHostCLIServer","vs/server/node/remoteTerminalChannel","vs/server/node/serverServices","vs/server/node/remoteExtensionHostAgentServer","perf_hooks","fs/promises","readline","util","minimist","assert","graceful-fs","@microsoft/1ds-core-js","yauzl","yazl","vs/server/node/server.main"],pe=function(le){for(var e=[],y=0,R=le.length;y<R;y++)e[y]=we[le[y]];return e};define(we[94],pe([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S=e.$R=void 0,e.$R=!1;class y{static get(){const r=new Map,P=new Map,L=new Map,I=new Map;function w(d,g){d.has(g.detail)||d.set(g.detail,-g.timestamp)}function b(d,g){const m=d.get(g.detail);m&&(m>=0||d.set(g.detail,m+g.timestamp))}let C=[];typeof le=="function"&&typeof le.getStats=="function"&&(C=le.getStats().slice(0).sort((d,g)=>d.timestamp-g.timestamp));for(const d of C)switch(d.type){case 10:w(r,d);break;case 11:case 12:b(r,d);break;case 21:w(P,d);break;case 22:b(P,d);break;case 33:w(L,d);break;case 34:b(L,d);break;case 31:w(I,d);break;case 32:b(I,d);break}let E=0;L.forEach(d=>E+=d);function v(d){const g=[];return d.forEach((m,l)=>g.push([l,m])),g}return{amdLoad:v(r),amdInvoke:v(P),nodeRequire:v(L),nodeEval:v(I),nodeRequireTotal:E}}static toMarkdownTable(r,P){let L="";const I=[];return r.forEach((w,b)=>{I[b]=w.length}),P.forEach(w=>{w.forEach((b,C)=>{typeof b>"u"&&(b=w[C]="-");const E=b.toString().length;I[C]=Math.max(E,I[C])})}),r.forEach((w,b)=>{L+=`| ${w+" ".repeat(I[b]-w.toString().length)} `}),L+=`|
`,r.forEach((w,b)=>{L+=`| ${"-".repeat(I[b])} `}),L+=`|
`,P.forEach(w=>{w.forEach((b,C)=>{typeof b<"u"&&(L+=`| ${b+" ".repeat(I[C]-b.toString().length)} `)}),L+=`|
`}),L}}e.$S=y}),define(we[141],pe([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=e.$eb=e.$db=void 0;function y(m,l,f){const u=R(m,l);if(u!==-1)return m[u]}e.$db=y;function R(m,l,f=m.length-1){for(let u=f;u>=0;u--){const c=m[u];if(l(c))return u}return-1}e.$eb=R;function r(m,l){const f=P(m,l);return f===-1?void 0:m[f]}e.$fb=r;function P(m,l,f=0,u=m.length){let c=f,p=u;for(;c<p;){const h=Math.floor((c+p)/2);l(m[h])?c=h+1:p=h}return c-1}e.$gb=P;function L(m,l){const f=I(m,l);return f===m.length?void 0:m[f]}e.$hb=L;function I(m,l,f=0,u=m.length){let c=f,p=u;for(;c<p;){const h=Math.floor((c+p)/2);l(m[h])?p=h:c=h+1}return c}e.$ib=I;function w(m,l,f=0,u=m.length){const c=I(m,l,f,u);return c===m.length?-1:c}e.$jb=w;class b{constructor(l){this.e=l,this.c=0}findLastMonotonous(l){if(b.assertInvariants){if(this.d){for(const u of this.e)if(this.d(u)&&!l(u))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=l}const f=P(this.e,l,this.c);return this.c=f+1,f===-1?void 0:this.e[f]}}e.$kb=b,b.assertInvariants=!1;function C(m,l){if(m.length===0)return;let f=m[0];for(let u=1;u<m.length;u++){const c=m[u];l(c,f)>0&&(f=c)}return f}e.$lb=C;function E(m,l){if(m.length===0)return;let f=m[0];for(let u=1;u<m.length;u++){const c=m[u];l(c,f)>=0&&(f=c)}return f}e.$mb=E;function v(m,l){return C(m,(f,u)=>-l(f,u))}e.$nb=v;function d(m,l){if(m.length===0)return-1;let f=0;for(let u=1;u<m.length;u++){const c=m[u];l(c,m[f])>0&&(f=u)}return f}e.$ob=d;function g(m,l){for(const f of m){const u=l(f);if(u!==void 0)return u}}e.$pb=g}),define(we[142],pe([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$G=e.$F=e.$E=e.$D=void 0;function y(L,I){const w=Object.create(null);for(const b of L){const C=I(b);let E=w[C];E||(E=w[C]=[]),E.push(b)}return w}e.$D=y;function R(L,I){const w=[],b=[];for(const C of L)I.has(C)||w.push(C);for(const C of I)L.has(C)||b.push(C);return{removed:w,added:b}}e.$E=R;function r(L,I){const w=[],b=[];for(const[C,E]of L)I.has(C)||w.push(E);for(const[C,E]of I)L.has(C)||b.push(E);return{removed:w,added:b}}e.$F=r;function P(L,I){const w=new Set;for(const b of I)L.has(b)&&w.add(b);return w}e.$G=P}),define(we[73],pe([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fh=e.$eh=e.$dh=void 0;function y(L){return(I,w,b)=>{let C=null,E=null;if(typeof b.value=="function"?(C="value",E=b.value):typeof b.get=="function"&&(C="get",E=b.get),!E)throw new Error("not supported");b[C]=L(E,w)}}function R(L,I,w){let b=null,C=null;if(typeof w.value=="function"?(b="value",C=w.value,C.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof w.get=="function"&&(b="get",C=w.get),!C)throw new Error("not supported");const E=`$memoize$${I}`;w[b]=function(...v){return this.hasOwnProperty(E)||Object.defineProperty(this,E,{configurable:!1,enumerable:!1,writable:!1,value:C.apply(this,v)}),this[E]}}e.$dh=R;function r(L,I,w){return y((b,C)=>{const E=`$debounce$${C}`,v=`$debounce$result$${C}`;return function(...d){this[v]||(this[v]=w?w():void 0),clearTimeout(this[E]),I&&(this[v]=I(this[v],...d),d=[this[v]]),this[E]=setTimeout(()=>{b.apply(this,d),this[v]=w?w():void 0},L)}})}e.$eh=r;function P(L,I,w){return y((b,C)=>{const E=`$throttle$timer$${C}`,v=`$throttle$result$${C}`,d=`$throttle$lastRun$${C}`,g=`$throttle$pending$${C}`;return function(...m){if(this[v]||(this[v]=w?w():void 0),(this[d]===null||this[d]===void 0)&&(this[d]=-Number.MAX_VALUE),I&&(this[v]=I(this[v],...m)),this[g])return;const l=this[d]+L;l<=Date.now()?(this[d]=Date.now(),b.apply(this,[this[v]]),this[v]=w?w():void 0):(this[g]=!0,this[E]=setTimeout(()=>{this[g]=!1,this[d]=Date.now(),b.apply(this,[this[v]]),this[v]=w?w():void 0},l-Date.now()))}})}e.$fh=P}),define(we[11],pe([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.$Y=e.$X=e.setUnexpectedErrorHandler=e.$V=e.$U=void 0;class y{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?c.isErrorNoTelemetry(t)?new c(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(s=>{s(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$U=y,e.$V=new y;function R(h){e.$V.setUnexpectedErrorHandler(h)}e.setUnexpectedErrorHandler=R;function r(h){if(!h||typeof h!="object")return!1;const t=h;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}e.$X=r;function P(h){b(h)||e.$V.onUnexpectedError(h)}e.$Y=P;function L(h){b(h)||e.$V.onUnexpectedExternalError(h)}e.$Z=L;function I(h){if(h instanceof Error){const{name:t,message:s}=h,o=h.stacktrace||h.stack;return{$isError:!0,name:t,message:s,stack:o,noTelemetry:c.isErrorNoTelemetry(h)}}return h}e.$1=I;const w="Canceled";function b(h){return h instanceof C?!0:h instanceof Error&&h.name===w&&h.message===w}e.$2=b;class C extends Error{constructor(){super(w),this.name=this.message}}e.$3=C;function E(){const h=new Error(w);return h.name=h.message,h}e.$4=E;function v(h){return h?new Error(`Illegal argument: ${h}`):new Error("Illegal argument")}e.$5=v;function d(h){return h?new Error(`Illegal state: ${h}`):new Error("Illegal state")}e.$6=d;class g extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$7=g;function m(h){return h?h.message?h.message:h.stack?h.stack.split(`
`)[0]:String(h):"Error"}e.$8=m;class l extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$9=l;class f extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$0=f;class u extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$$=u;class c extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof c)return t;const s=new c;return s.message=t.message,s.stack=t.stack,s}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$_=c;class p extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,p.prototype)}}e.$ab=p}),define(we[18],pe([1,0,11,141]),function(le,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$b=e.$0b=e.$9b=e.$8b=e.$7b=e.$6b=e.$5b=e.CompareResult=e.$4b=e.$3b=e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=e.$Ib=e.$Hb=e.$Gb=e.$Fb=e.$Eb=e.top=e.$Cb=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=e.$tb=e.$sb=e.$rb=e.$qb=void 0;function r(T,H=0){return T[T.length-(1+H)]}e.$qb=r;function P(T){if(T.length===0)throw new Error("Invalid tail call");return[T.slice(0,T.length-1),T[T.length-1]]}e.$rb=P;function L(T,H,U=(ie,z)=>ie===z){if(T===H)return!0;if(!T||!H||T.length!==H.length)return!1;for(let ie=0,z=T.length;ie<z;ie++)if(!U(T[ie],H[ie]))return!1;return!0}e.$sb=L;function I(T,H){const U=T.length-1;H<U&&(T[H]=T[U]),T.pop()}e.$tb=I;function w(T,H,U){return b(T.length,ie=>U(T[ie],H))}e.$ub=w;function b(T,H){let U=0,ie=T-1;for(;U<=ie;){const z=(U+ie)/2|0,_=H(z);if(_<0)U=z+1;else if(_>0)ie=z-1;else return z}return-(U+1)}e.$vb=b;function C(T,H,U){if(T=T|0,T>=H.length)throw new TypeError("invalid index");const ie=H[Math.floor(H.length*Math.random())],z=[],_=[],W=[];for(const X of H){const oe=U(X,ie);oe<0?z.push(X):oe>0?_.push(X):W.push(X)}return T<z.length?C(T,z,U):T<z.length+W.length?W[0]:C(T-(z.length+W.length),_,U)}e.$wb=C;function E(T,H){const U=[];let ie;for(const z of T.slice(0).sort(H))!ie||H(ie[0],z)!==0?(ie=[z],U.push(ie)):ie.push(z);return U}e.$xb=E;function*v(T,H){let U,ie;for(const z of T)ie!==void 0&&H(ie,z)?U.push(z):(U&&(yield U),U=[z]),ie=z;U&&(yield U)}e.$yb=v;function d(T,H){for(let U=0;U<=T.length;U++)H(U===0?void 0:T[U-1],U===T.length?void 0:T[U])}e.$zb=d;function g(T,H){for(let U=0;U<T.length;U++)H(U===0?void 0:T[U-1],T[U],U+1===T.length?void 0:T[U+1])}e.$Ab=g;function m(T,H,U){const ie=[];function z(X,oe,ge){if(oe===0&&ge.length===0)return;const Ee=ie[ie.length-1];Ee&&Ee.start+Ee.deleteCount===X?(Ee.deleteCount+=oe,Ee.toInsert.push(...ge)):ie.push({start:X,deleteCount:oe,toInsert:ge})}let _=0,W=0;for(;;){if(_===T.length){z(_,0,H.slice(W));break}if(W===H.length){z(_,T.length-_,[]);break}const X=T[_],oe=H[W],ge=U(X,oe);ge===0?(_+=1,W+=1):ge<0?(z(_,1,[]),_+=1):ge>0&&(z(_,0,[oe]),W+=1)}return ie}e.$Bb=m;function l(T,H,U){const ie=m(T,H,U),z=[],_=[];for(const W of ie)z.push(...T.slice(W.start,W.start+W.deleteCount)),_.push(...W.toInsert);return{removed:z,added:_}}e.$Cb=l;function f(T,H,U){if(U===0)return[];const ie=T.slice(0,U).sort(H);return c(T,H,ie,U,T.length),ie}e.top=f;function u(T,H,U,ie,z){return U===0?Promise.resolve([]):new Promise((_,W)=>{(async()=>{const X=T.length,oe=T.slice(0,U).sort(H);for(let ge=U,Ee=Math.min(U+ie,X);ge<X;ge=Ee,Ee=Math.min(Ee+ie,X)){if(ge>U&&await new Promise(Pe=>setTimeout(Pe)),z&&z.isCancellationRequested)throw new y.$3;c(T,H,oe,ge,Ee)}return oe})().then(_,W)})}e.$Eb=u;function c(T,H,U,ie,z){for(const _=U.length;ie<z;ie++){const W=T[ie];if(H(W,U[_-1])<0){U.pop();const X=(0,R.$ib)(U,oe=>H(W,oe)<0);U.splice(X,0,W)}}}function p(T){return T.filter(H=>!!H)}e.$Fb=p;function h(T){let H=0;for(let U=0;U<T.length;U++)T[U]&&(T[H]=T[U],H+=1);T.length=H}e.$Gb=h;function t(T,H,U){T.splice(U,0,T.splice(H,1)[0])}e.$Hb=t;function s(T){return!Array.isArray(T)||T.length===0}e.$Ib=s;function o(T){return Array.isArray(T)&&T.length>0}e.$Jb=o;function i(T,H=U=>U){const U=new Set;return T.filter(ie=>{const z=H(ie);return U.has(z)?!1:(U.add(z),!0)})}e.$Kb=i;function n(T){const H=new Set;return U=>{const ie=T(U);return H.has(ie)?!1:(H.add(ie),!0)}}e.$Lb=n;function a(T,H){return T.length>0?T[0]:H}e.$Mb=a;function $(T,H){return T.length>0?T[T.length-1]:H}e.$Nb=$;function S(T,H,U=(ie,z)=>ie===z){let ie=0;for(let z=0,_=Math.min(T.length,H.length);z<_&&U(T[z],H[z]);z++)ie++;return ie}e.$Ob=S;function D(T){return[].concat(...T)}e.$Pb=D;function k(T,H){let U=typeof H=="number"?T:0;typeof H=="number"?U=T:(U=0,H=T);const ie=[];if(U<=H)for(let z=U;z<H;z++)ie.push(z);else for(let z=U;z>H;z--)ie.push(z);return ie}e.$Qb=k;function A(T,H,U){return T.reduce((ie,z)=>(ie[H(z)]=U?U(z):z,ie),Object.create(null))}e.$Rb=A;function j(T,H){return T.push(H),()=>Z(T,H)}e.$Sb=j;function Z(T,H){const U=T.indexOf(H);if(U>-1)return T.splice(U,1),H}e.$Tb=Z;function ae(T,H,U){const ie=T.slice(0,H),z=T.slice(H);return ie.concat(U,z)}e.$Ub=ae;function K(T,H){let U;if(typeof H=="number"){let ie=H;U=()=>{const z=Math.sin(ie++)*179426549;return z-Math.floor(z)}}else U=Math.random;for(let ie=T.length-1;ie>0;ie-=1){const z=Math.floor(U()*(ie+1)),_=T[ie];T[ie]=T[z],T[z]=_}}e.$Vb=K;function se(T,H){const U=T.indexOf(H);U>-1&&(T.splice(U,1),T.unshift(H))}e.$Wb=se;function ue(T,H){const U=T.indexOf(H);U>-1&&(T.splice(U,1),T.push(H))}e.$Xb=ue;function x(T,H){for(const U of H)T.push(U)}e.$Yb=x;function he(T,H){return Array.isArray(T)?T.map(H):H(T)}e.$Zb=he;function V(T){return Array.isArray(T)?T:[T]}e.$1b=V;function te(T){return T[Math.floor(Math.random()*T.length)]}e.$2b=te;function G(T,H,U){const ie=q(T,H),z=T.length,_=U.length;T.length=z+_;for(let W=z-1;W>=ie;W--)T[W+_]=T[W];for(let W=0;W<_;W++)T[W+ie]=U[W]}e.$3b=G;function J(T,H,U,ie){const z=q(T,H);let _=T.splice(z,U);return _===void 0&&(_=[]),G(T,z,ie),_}e.$4b=J;function q(T,H){return H<0?Math.max(H+T.length,0):Math.min(H,T.length)}var ne;(function(T){function H(_){return _<0}T.isLessThan=H;function U(_){return _<=0}T.isLessThanOrEqual=U;function ie(_){return _>0}T.isGreaterThan=ie;function z(_){return _===0}T.isNeitherLessOrGreaterThan=z,T.greaterThan=1,T.lessThan=-1,T.neitherLessOrGreaterThan=0})(ne||(e.CompareResult=ne={}));function me(T,H){return(U,ie)=>H(T(U),T(ie))}e.$5b=me;function re(...T){return(H,U)=>{for(const ie of T){const z=ie(H,U);if(!ne.isNeitherLessOrGreaterThan(z))return z}return ne.neitherLessOrGreaterThan}}e.$6b=re;const B=(T,H)=>T-H;e.$7b=B;const ee=(T,H)=>(0,e.$7b)(T?1:0,H?1:0);e.$8b=ee;function O(T){return(H,U)=>-T(H,U)}e.$9b=O;class N{constructor(H){this.g=H,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(H){let U=this.c;for(;U<this.g.length&&H(this.g[U]);)U++;const ie=U===this.c?null:this.g.slice(this.c,U);return this.c=U,ie}takeFromEndWhile(H){let U=this.d;for(;U>=0&&H(this.g[U]);)U--;const ie=U===this.d?null:this.g.slice(U+1,this.d+1);return this.d=U,ie}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const H=this.g[this.c];return this.c++,H}removeLast(){const H=this.g[this.d];return this.d--,H}takeCount(H){const U=this.g.slice(this.c,this.c+H);return this.c+=H,U}}e.$0b=N;class Q{constructor(H){this.iterate=H}forEach(H){this.iterate(U=>(H(U),!0))}toArray(){const H=[];return this.iterate(U=>(H.push(U),!0)),H}filter(H){return new Q(U=>this.iterate(ie=>H(ie)?U(ie):!0))}map(H){return new Q(U=>this.iterate(ie=>U(H(ie))))}some(H){let U=!1;return this.iterate(ie=>(U=H(ie),!U)),U}findFirst(H){let U;return this.iterate(ie=>H(ie)?(U=ie,!1):!0),U}findLast(H){let U;return this.iterate(ie=>(H(ie)&&(U=ie),!0)),U}findLastMaxBy(H){let U,ie=!0;return this.iterate(z=>((ie||ne.isGreaterThan(H(z,U)))&&(ie=!1,U=z),!0)),U}}e.$$b=Q,Q.empty=new Q(T=>{})}),define(we[95],pe([1,0,11]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5c=e.$4c=e.$3c=e.$2c=e.ok=void 0;function R(w,b){if(!w)throw new Error(b?`Assertion failed (${b})`:"Assertion Failed")}e.ok=R;function r(w,b="Unreachable"){throw new Error(b)}e.$2c=r;function P(w){if(!w)throw new y.$ab("Assertion Failed")}e.$3c=P;function L(w){if(!w()){debugger;w(),(0,y.$Y)(new y.$ab("Assertion Failed"))}}e.$4c=L;function I(w,b){let C=0;for(;C<w.length-1;){const E=w[C],v=w[C+1];if(!b(E,v))return!1;C++}return!0}e.$5c=I}),define(we[74],pe([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bb=void 0;function y(R){const r=this;let P=!1,L;return function(){return P||(P=!0,L=R.apply(r,arguments)),L}}e.$bb=y}),define(we[47],pe([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var y;(function(R){function r(h){return h&&typeof h=="object"&&typeof h[Symbol.iterator]=="function"}R.is=r;const P=Object.freeze([]);function L(){return P}R.empty=L;function*I(h){yield h}R.single=I;function w(h){return r(h)?h:I(h)}R.wrap=w;function b(h){return h||P}R.from=b;function*C(h){for(let t=h.length-1;t>=0;t--)yield h[t]}R.reverse=C;function E(h){return!h||h[Symbol.iterator]().next().done===!0}R.isEmpty=E;function v(h){return h[Symbol.iterator]().next().value}R.first=v;function d(h,t){for(const s of h)if(t(s))return!0;return!1}R.some=d;function g(h,t){for(const s of h)if(t(s))return s}R.find=g;function*m(h,t){for(const s of h)t(s)&&(yield s)}R.filter=m;function*l(h,t){let s=0;for(const o of h)yield t(o,s++)}R.map=l;function*f(...h){for(const t of h)for(const s of t)yield s}R.concat=f;function u(h,t,s){let o=s;for(const i of h)o=t(o,i);return o}R.reduce=u;function*c(h,t,s=h.length){for(t<0&&(t+=h.length),s<0?s+=h.length:s>h.length&&(s=h.length);t<s;t++)yield h[t]}R.slice=c;function p(h,t=Number.POSITIVE_INFINITY){const s=[];if(t===0)return[s,h];const o=h[Symbol.iterator]();for(let i=0;i<t;i++){const n=o.next();if(n.done)return[s,R.empty()];s.push(n.value)}return[s,{[Symbol.iterator](){return o}}]}R.consume=p})(y||(e.Iterable=y={}))}),define(we[75],pe([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wm=e.$Vm=e.$Um=e.$Tm=e.$Sm=e.$Rm=e.$Qm=e.$Pm=e.$Om=e.$Nm=e.$Mm=e.$Lm=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var y;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(y||(e.ScanError=y={}));var R;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(R||(e.SyntaxKind=R={}));var r;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(r||(e.ParseErrorCode=r={}));var P;(function(t){t.DEFAULT={allowTrailingComma:!0}})(P||(e.ParseOptions=P={}));function L(t,s=!1){let o=0;const i=t.length;let n="",a=0,$=16,S=0;function D(se){let ue=0,x=0;for(;ue<se;){const he=t.charCodeAt(o);if(he>=48&&he<=57)x=x*16+he-48;else if(he>=65&&he<=70)x=x*16+he-65+10;else if(he>=97&&he<=102)x=x*16+he-97+10;else break;o++,ue++}return ue<se&&(x=-1),x}function k(se){o=se,n="",a=0,$=16,S=0}function A(){const se=o;if(t.charCodeAt(o)===48)o++;else for(o++;o<t.length&&b(t.charCodeAt(o));)o++;if(o<t.length&&t.charCodeAt(o)===46)if(o++,o<t.length&&b(t.charCodeAt(o)))for(o++;o<t.length&&b(t.charCodeAt(o));)o++;else return S=3,t.substring(se,o);let ue=o;if(o<t.length&&(t.charCodeAt(o)===69||t.charCodeAt(o)===101))if(o++,(o<t.length&&t.charCodeAt(o)===43||t.charCodeAt(o)===45)&&o++,o<t.length&&b(t.charCodeAt(o))){for(o++;o<t.length&&b(t.charCodeAt(o));)o++;ue=o}else S=3;return t.substring(se,ue)}function j(){let se="",ue=o;for(;;){if(o>=i){se+=t.substring(ue,o),S=2;break}const x=t.charCodeAt(o);if(x===34){se+=t.substring(ue,o),o++;break}if(x===92){if(se+=t.substring(ue,o),o++,o>=i){S=2;break}switch(t.charCodeAt(o++)){case 34:se+='"';break;case 92:se+="\\";break;case 47:se+="/";break;case 98:se+="\b";break;case 102:se+="\f";break;case 110:se+=`
`;break;case 114:se+="\r";break;case 116:se+="	";break;case 117:{const V=D(4);V>=0?se+=String.fromCharCode(V):S=4;break}default:S=5}ue=o;continue}if(x>=0&&x<=31)if(w(x)){se+=t.substring(ue,o),S=2;break}else S=6;o++}return se}function Z(){if(n="",S=0,a=o,o>=i)return a=i,$=17;let se=t.charCodeAt(o);if(I(se)){do o++,n+=String.fromCharCode(se),se=t.charCodeAt(o);while(I(se));return $=15}if(w(se))return o++,n+=String.fromCharCode(se),se===13&&t.charCodeAt(o)===10&&(o++,n+=`
`),$=14;switch(se){case 123:return o++,$=1;case 125:return o++,$=2;case 91:return o++,$=3;case 93:return o++,$=4;case 58:return o++,$=6;case 44:return o++,$=5;case 34:return o++,n=j(),$=10;case 47:{const ue=o-1;if(t.charCodeAt(o+1)===47){for(o+=2;o<i&&!w(t.charCodeAt(o));)o++;return n=t.substring(ue,o),$=12}if(t.charCodeAt(o+1)===42){o+=2;const x=i-1;let he=!1;for(;o<x;){if(t.charCodeAt(o)===42&&t.charCodeAt(o+1)===47){o+=2,he=!0;break}o++}return he||(o++,S=1),n=t.substring(ue,o),$=13}return n+=String.fromCharCode(se),o++,$=16}case 45:if(n+=String.fromCharCode(se),o++,o===i||!b(t.charCodeAt(o)))return $=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return n+=A(),$=11;default:for(;o<i&&ae(se);)o++,se=t.charCodeAt(o);if(a!==o){switch(n=t.substring(a,o),n){case"true":return $=8;case"false":return $=9;case"null":return $=7}return $=16}return n+=String.fromCharCode(se),o++,$=16}}function ae(se){if(I(se)||w(se))return!1;switch(se){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function K(){let se;do se=Z();while(se>=12&&se<=15);return se}return{setPosition:k,getPosition:()=>o,scan:s?K:Z,getToken:()=>$,getTokenValue:()=>n,getTokenOffset:()=>a,getTokenLength:()=>o-a,getTokenError:()=>S}}e.$Lm=L;function I(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function w(t){return t===10||t===13||t===8232||t===8233}function b(t){return t>=48&&t<=57}var C;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(C||(C={}));function E(t,s){const o=[],i=new Object;let n;const a={value:{},offset:0,length:0,type:"object",parent:void 0};let $=!1;function S(D,k,A,j){a.value=D,a.offset=k,a.length=A,a.type=j,a.colonOffset=void 0,n=a}try{c(t,{onObjectBegin:(D,k)=>{if(s<=D)throw i;n=void 0,$=s>D,o.push("")},onObjectProperty:(D,k,A)=>{if(s<k||(S(D,k,A,"property"),o[o.length-1]=D,s<=k+A))throw i},onObjectEnd:(D,k)=>{if(s<=D)throw i;n=void 0,o.pop()},onArrayBegin:(D,k)=>{if(s<=D)throw i;n=void 0,o.push(0)},onArrayEnd:(D,k)=>{if(s<=D)throw i;n=void 0,o.pop()},onLiteralValue:(D,k,A)=>{if(s<k||(S(D,k,A,h(D)),s<=k+A))throw i},onSeparator:(D,k,A)=>{if(s<=k)throw i;if(D===":"&&n&&n.type==="property")n.colonOffset=k,$=!1,n=void 0;else if(D===","){const j=o[o.length-1];typeof j=="number"?o[o.length-1]=j+1:($=!0,o[o.length-1]=""),n=void 0}}})}catch(D){if(D!==i)throw D}return{path:o,previousNode:n,isAtPropertyKey:$,matches:D=>{let k=0;for(let A=0;k<D.length&&A<o.length;A++)if(D[k]===o[A]||D[k]==="*")k++;else if(D[k]!=="**")return!1;return k===D.length}}}e.$Mm=E;function v(t,s=[],o=P.DEFAULT){let i=null,n=[];const a=[];function $(D){Array.isArray(n)?n.push(D):i!==null&&(n[i]=D)}return c(t,{onObjectBegin:()=>{const D={};$(D),a.push(n),n=D,i=null},onObjectProperty:D=>{i=D},onObjectEnd:()=>{n=a.pop()},onArrayBegin:()=>{const D=[];$(D),a.push(n),n=D,i=null},onArrayEnd:()=>{n=a.pop()},onLiteralValue:$,onError:(D,k,A)=>{s.push({error:D,offset:k,length:A})}},o),n[0]}e.$Nm=v;function d(t,s=[],o=P.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function n(D){i.type==="property"&&(i.length=D-i.offset,i=i.parent)}function a(D){return i.children.push(D),D}c(t,{onObjectBegin:D=>{i=a({type:"object",offset:D,length:-1,parent:i,children:[]})},onObjectProperty:(D,k,A)=>{i=a({type:"property",offset:k,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:D,offset:k,length:A,parent:i})},onObjectEnd:(D,k)=>{i.length=D+k-i.offset,i=i.parent,n(D+k)},onArrayBegin:(D,k)=>{i=a({type:"array",offset:D,length:-1,parent:i,children:[]})},onArrayEnd:(D,k)=>{i.length=D+k-i.offset,i=i.parent,n(D+k)},onLiteralValue:(D,k,A)=>{a({type:h(D),offset:k,length:A,parent:i,value:D}),n(k+A)},onSeparator:(D,k,A)=>{i.type==="property"&&(D===":"?i.colonOffset=k:D===","&&n(k))},onError:(D,k,A)=>{s.push({error:D,offset:k,length:A})}},o);const S=i.children[0];return S&&delete S.parent,S}e.$Om=d;function g(t,s){if(!t)return;let o=t;for(const i of s)if(typeof i=="string"){if(o.type!=="object"||!Array.isArray(o.children))return;let n=!1;for(const a of o.children)if(Array.isArray(a.children)&&a.children[0].value===i){o=a.children[1],n=!0;break}if(!n)return}else{const n=i;if(o.type!=="array"||n<0||!Array.isArray(o.children)||n>=o.children.length)return;o=o.children[n]}return o}e.$Pm=g;function m(t){if(!t.parent||!t.parent.children)return[];const s=m(t.parent);if(t.parent.type==="property"){const o=t.parent.children[0].value;s.push(o)}else if(t.parent.type==="array"){const o=t.parent.children.indexOf(t);o!==-1&&s.push(o)}return s}e.$Qm=m;function l(t){switch(t.type){case"array":return t.children.map(l);case"object":{const s=Object.create(null);for(const o of t.children){const i=o.children[1];i&&(s[o.children[0].value]=l(i))}return s}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.$Rm=l;function f(t,s,o=!1){return s>=t.offset&&s<t.offset+t.length||o&&s===t.offset+t.length}e.$Sm=f;function u(t,s,o=!1){if(f(t,s,o)){const i=t.children;if(Array.isArray(i))for(let n=0;n<i.length&&i[n].offset<=s;n++){const a=u(i[n],s,o);if(a)return a}return t}}e.$Tm=u;function c(t,s,o=P.DEFAULT){const i=L(t,!1);function n(me){return me?()=>me(i.getTokenOffset(),i.getTokenLength()):()=>!0}function a(me){return me?re=>me(re,i.getTokenOffset(),i.getTokenLength()):()=>!0}const $=n(s.onObjectBegin),S=a(s.onObjectProperty),D=n(s.onObjectEnd),k=n(s.onArrayBegin),A=n(s.onArrayEnd),j=a(s.onLiteralValue),Z=a(s.onSeparator),ae=n(s.onComment),K=a(s.onError),se=o&&o.disallowComments,ue=o&&o.allowTrailingComma;function x(){for(;;){const me=i.scan();switch(i.getTokenError()){case 4:he(14);break;case 5:he(15);break;case 3:he(13);break;case 1:se||he(11);break;case 2:he(12);break;case 6:he(16);break}switch(me){case 12:case 13:se?he(10):ae();break;case 16:he(1);break;case 15:case 14:break;default:return me}}}function he(me,re=[],B=[]){if(K(me),re.length+B.length>0){let ee=i.getToken();for(;ee!==17;){if(re.indexOf(ee)!==-1){x();break}else if(B.indexOf(ee)!==-1)break;ee=x()}}}function V(me){const re=i.getTokenValue();return me?j(re):S(re),x(),!0}function te(){switch(i.getToken()){case 11:{let me=0;try{me=JSON.parse(i.getTokenValue()),typeof me!="number"&&(he(2),me=0)}catch{he(2)}j(me);break}case 7:j(null);break;case 8:j(!0);break;case 9:j(!1);break;default:return!1}return x(),!0}function G(){return i.getToken()!==10?(he(3,[],[2,5]),!1):(V(!1),i.getToken()===6?(Z(":"),x(),ne()||he(4,[],[2,5])):he(5,[],[2,5]),!0)}function J(){$(),x();let me=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(me||he(4,[],[]),Z(","),x(),i.getToken()===2&&ue)break}else me&&he(6,[],[]);G()||he(4,[],[2,5]),me=!0}return D(),i.getToken()!==2?he(7,[2],[]):x(),!0}function q(){k(),x();let me=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(me||he(4,[],[]),Z(","),x(),i.getToken()===4&&ue)break}else me&&he(6,[],[]);ne()||he(4,[],[4,5]),me=!0}return A(),i.getToken()!==4?he(8,[4],[]):x(),!0}function ne(){switch(i.getToken()){case 3:return q();case 1:return J();case 10:return V(!0);default:return te()}}return x(),i.getToken()===17?o.allowEmptyContent?!0:(he(4,[],[]),!1):ne()?(i.getToken()!==17&&he(9,[],[]),!0):(he(4,[],[]),!1)}e.$Um=c;function p(t,s){const o=L(t),i=[];let n,a=0,$;do switch($=o.getPosition(),n=o.scan(),n){case 12:case 13:case 17:a!==$&&i.push(t.substring(a,$)),s!==void 0&&i.push(o.getTokenValue().replace(/[^\r\n]/g,s)),a=o.getPosition();break}while(n!==17);return i.join("")}e.$Vm=p;function h(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.$Wm=h}),define(we[96],pe([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T=void 0;class y{constructor(r){this.d=r,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(r){this.c=r}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$T=y}),define(we[97],pe([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zc=void 0;class y{constructor(P){this.element=P,this.next=y.Undefined,this.prev=y.Undefined}}y.Undefined=new y(void 0);class R{constructor(){this.a=y.Undefined,this.b=y.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===y.Undefined}clear(){let P=this.a;for(;P!==y.Undefined;){const L=P.next;P.prev=y.Undefined,P.next=y.Undefined,P=L}this.a=y.Undefined,this.b=y.Undefined,this.c=0}unshift(P){return this.d(P,!1)}push(P){return this.d(P,!0)}d(P,L){const I=new y(P);if(this.a===y.Undefined)this.a=I,this.b=I;else if(L){const b=this.b;this.b=I,I.prev=b,b.next=I}else{const b=this.a;this.a=I,I.next=b,b.prev=I}this.c+=1;let w=!1;return()=>{w||(w=!0,this.e(I))}}shift(){if(this.a!==y.Undefined){const P=this.a.element;return this.e(this.a),P}}pop(){if(this.b!==y.Undefined){const P=this.b.element;return this.e(this.b),P}}e(P){if(P.prev!==y.Undefined&&P.next!==y.Undefined){const L=P.prev;L.next=P.next,P.next.prev=L}else P.prev===y.Undefined&&P.next===y.Undefined?(this.a=y.Undefined,this.b=y.Undefined):P.next===y.Undefined?(this.b=this.b.prev,this.b.next=y.Undefined):P.prev===y.Undefined&&(this.a=this.a.next,this.a.prev=y.Undefined);this.c-=1}*[Symbol.iterator](){let P=this.a;for(;P!==y.Undefined;)yield P.element,P=P.next}}e.$Zc=R}),define(we[26],pe([1,0]),function(le,e){"use strict";var y,R,r;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ec=e.$Dc=e.$Cc=e.$Bc=e.$Ac=e.Touch=e.$zc=e.$yc=e.$xc=e.$wc=e.$vc=void 0;function P(u,c,p){let h=u.get(c);return h===void 0&&(h=p,u.set(c,h)),h}e.$vc=P;function L(u){const c=[];return u.forEach((p,h)=>{c.push(`${h} => ${p}`)}),`Map(${u.size}) {${c.join(", ")}}`}e.$wc=L;function I(u){const c=[];return u.forEach(p=>{c.push(p)}),`Set(${u.size}) {${c.join(", ")}}`}e.$xc=I;class w{constructor(c,p){this.uri=c,this.value=p}}function b(u){return Array.isArray(u)}class C{constructor(c,p){if(this[y]="ResourceMap",c instanceof C)this.b=new Map(c.b),this.c=p??C.a;else if(b(c)){this.b=new Map,this.c=p??C.a;for(const[h,t]of c)this.set(h,t)}else this.b=new Map,this.c=c??C.a}set(c,p){return this.b.set(this.c(c),new w(c,p)),this}get(c){return this.b.get(this.c(c))?.value}has(c){return this.b.has(this.c(c))}get size(){return this.b.size}clear(){this.b.clear()}delete(c){return this.b.delete(this.c(c))}forEach(c,p){typeof p<"u"&&(c=c.bind(p));for(const[h,t]of this.b)c(t.value,t.uri,this)}*values(){for(const c of this.b.values())yield c.value}*keys(){for(const c of this.b.values())yield c.uri}*entries(){for(const c of this.b.values())yield[c.uri,c.value]}*[(y=Symbol.toStringTag,Symbol.iterator)](){for(const[,c]of this.b)yield[c.uri,c.value]}}e.$yc=C,C.a=u=>u.toString();class E{constructor(c,p){this[R]="ResourceSet",!c||typeof c=="function"?this.a=new C(c):(this.a=new C(p),c.forEach(this.add,this))}get size(){return this.a.size}add(c){return this.a.set(c,c),this}clear(){this.a.clear()}delete(c){return this.a.delete(c)}forEach(c,p){this.a.forEach((h,t)=>c.call(p,t,t,this))}has(c){return this.a.has(c)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(R=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$zc=E;var v;(function(u){u[u.None=0]="None",u[u.AsOld=1]="AsOld",u[u.AsNew=2]="AsNew"})(v||(e.Touch=v={}));class d{constructor(){this[r]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(c){return this.a.has(c)}get(c,p=0){const h=this.a.get(c);if(h)return p!==0&&this.j(h,p),h.value}set(c,p,h=0){let t=this.a.get(c);if(t)t.value=p,h!==0&&this.j(t,h);else{switch(t={key:c,value:p,next:void 0,previous:void 0},h){case 0:this.h(t);break;case 1:this.g(t);break;case 2:this.h(t);break;default:this.h(t);break}this.a.set(c,t),this.d++}return this}delete(c){return!!this.remove(c)}remove(c){const p=this.a.get(c);if(p)return this.a.delete(c),this.i(p),this.d--,p.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const c=this.b;return this.a.delete(c.key),this.i(c),this.d--,c.value}forEach(c,p){const h=this.e;let t=this.b;for(;t;){if(p?c.bind(p)(t.value,t.key,this):c(t.value,t.key,this),this.e!==h)throw new Error("LinkedMap got modified during iteration.");t=t.next}}keys(){const c=this,p=this.e;let h=this.b;const t={[Symbol.iterator](){return t},next(){if(c.e!==p)throw new Error("LinkedMap got modified during iteration.");if(h){const s={value:h.key,done:!1};return h=h.next,s}else return{value:void 0,done:!0}}};return t}values(){const c=this,p=this.e;let h=this.b;const t={[Symbol.iterator](){return t},next(){if(c.e!==p)throw new Error("LinkedMap got modified during iteration.");if(h){const s={value:h.value,done:!1};return h=h.next,s}else return{value:void 0,done:!0}}};return t}entries(){const c=this,p=this.e;let h=this.b;const t={[Symbol.iterator](){return t},next(){if(c.e!==p)throw new Error("LinkedMap got modified during iteration.");if(h){const s={value:[h.key,h.value],done:!1};return h=h.next,s}else return{value:void 0,done:!0}}};return t}[(r=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(c){if(c>=this.size)return;if(c===0){this.clear();return}let p=this.b,h=this.size;for(;p&&h>c;)this.a.delete(p.key),p=p.next,h--;this.b=p,this.d=h,p&&(p.previous=void 0),this.e++}g(c){if(!this.b&&!this.c)this.c=c;else if(this.b)c.next=this.b,this.b.previous=c;else throw new Error("Invalid list");this.b=c,this.e++}h(c){if(!this.b&&!this.c)this.b=c;else if(this.c)c.previous=this.c,this.c.next=c;else throw new Error("Invalid list");this.c=c,this.e++}i(c){if(c===this.b&&c===this.c)this.b=void 0,this.c=void 0;else if(c===this.b){if(!c.next)throw new Error("Invalid list");c.next.previous=void 0,this.b=c.next}else if(c===this.c){if(!c.previous)throw new Error("Invalid list");c.previous.next=void 0,this.c=c.previous}else{const p=c.next,h=c.previous;if(!p||!h)throw new Error("Invalid list");p.previous=h,h.next=p}c.next=void 0,c.previous=void 0,this.e++}j(c,p){if(!this.b||!this.c)throw new Error("Invalid list");if(!(p!==1&&p!==2)){if(p===1){if(c===this.b)return;const h=c.next,t=c.previous;c===this.c?(t.next=void 0,this.c=t):(h.previous=t,t.next=h),c.previous=void 0,c.next=this.b,this.b.previous=c,this.b=c,this.e++}else if(p===2){if(c===this.c)return;const h=c.next,t=c.previous;c===this.b?(h.previous=void 0,this.b=h):(h.previous=t,t.next=h),c.next=void 0,c.previous=this.c,this.c.next=c,this.c=c,this.e++}}}toJSON(){const c=[];return this.forEach((p,h)=>{c.push([h,p])}),c}fromJSON(c){this.clear();for(const[p,h]of c)this.set(p,h)}}e.$Ac=d;class g extends d{constructor(c,p=1){super(),this.k=c,this.l=Math.min(Math.max(0,p),1)}get limit(){return this.k}set limit(c){this.k=c,this.m()}get ratio(){return this.l}set ratio(c){this.l=Math.min(Math.max(0,c),1),this.m()}get(c,p=2){return super.get(c,p)}peek(c){return super.get(c,0)}set(c,p){return super.set(c,p,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.$Bc=g;class m{constructor(){this.a=new Map}add(c){return this.a.set(c,(this.a.get(c)||0)+1),this}delete(c){let p=this.a.get(c)||0;return p===0?!1:(p--,p===0?this.a.delete(c):this.a.set(c,p),!0)}has(c){return this.a.has(c)}}e.$Cc=m;class l{constructor(c){if(this.a=new Map,this.b=new Map,c)for(const[p,h]of c)this.set(p,h)}clear(){this.a.clear(),this.b.clear()}set(c,p){this.a.set(c,p),this.b.set(p,c)}get(c){return this.a.get(c)}getKey(c){return this.b.get(c)}delete(c){const p=this.a.get(c);return p===void 0?!1:(this.a.delete(c),this.b.delete(p),!0)}forEach(c,p){this.a.forEach((h,t)=>{c.call(p,h,t,this)})}keys(){return this.a.keys()}values(){return this.a.values()}}e.$Dc=l;class f{constructor(){this.a=new Map}add(c,p){let h=this.a.get(c);h||(h=new Set,this.a.set(c,h)),h.add(p)}delete(c,p){const h=this.a.get(c);h&&(h.delete(p),h.size===0&&this.a.delete(c))}forEach(c,p){const h=this.a.get(c);h&&h.forEach(p)}get(c){const p=this.a.get(c);return p||new Set}}e.$Ec=f}),define(we[2],pe([1,0,18,142,26,74,47]),function(le,e,y,R,r,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Rc=e.$Qc=e.$Pc=e.$Oc=e.$Nc=e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=e.$Hc=e.$Gc=e.$Fc=void 0;const I=!1;let w=null;class b{constructor(){this.b=new Map}c(A){let j=this.b.get(A);return j||(j={parent:null,source:null,isSingleton:!1,value:A,idx:b.a++},this.b.set(A,j)),j}trackDisposable(A){const j=this.c(A);j.source||(j.source=new Error().stack)}setParent(A,j){const Z=this.c(A);Z.parent=j}markAsDisposed(A){this.b.delete(A)}markAsSingleton(A){this.c(A).isSingleton=!0}f(A,j){const Z=j.get(A);if(Z)return Z;const ae=A.parent?this.f(this.c(A.parent),j):A;return j.set(A,ae),ae}getTrackedDisposables(){const A=new Map;return[...this.b.entries()].filter(([,Z])=>Z.source!==null&&!this.f(Z,A).isSingleton).map(([Z])=>Z).flat()}computeLeakingDisposables(A=10,j){let Z;if(j)Z=j;else{const x=new Map,he=[...this.b.values()].filter(te=>te.source!==null&&!this.f(te,x).isSingleton);if(he.length===0)return;const V=new Set(he.map(te=>te.value));if(Z=he.filter(te=>!(te.parent&&V.has(te.parent))),Z.length===0)throw new Error("There are cyclic diposable chains!")}if(!Z)return;function ae(x){function he(te,G){for(;te.length>0&&G.some(J=>typeof J=="string"?J===te[0]:te[0].match(J));)te.shift()}const V=x.source.split(`
`).map(te=>te.trim().replace("at ","")).filter(te=>te!=="");return he(V,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),V.reverse()}const K=new r.$Ec;for(const x of Z){const he=ae(x);for(let V=0;V<=he.length;V++)K.add(he.slice(0,V).join(`
`),x)}Z.sort((0,y.$5b)(x=>x.idx,y.$7b));let se="",ue=0;for(const x of Z.slice(0,A)){ue++;const he=ae(x),V=[];for(let te=0;te<he.length;te++){let G=he[te];G=`(shared with ${K.get(he.slice(0,te+1).join(`
`)).size}/${Z.length} leaks) at ${G}`;const q=K.get(he.slice(0,te).join(`
`)),ne=(0,R.$D)([...q].map(me=>ae(me)[te]),me=>me);delete ne[he[te]];for(const[me,re]of Object.entries(ne))V.unshift(`    - stacktraces of ${re.length} other leaks continue with ${me}`);V.unshift(G)}se+=`


==================== Leaking disposable ${ue}/${Z.length}: ${x.value.constructor.name} ====================
${V.join(`
`)}
============================================================

`}return Z.length>A&&(se+=`


... and ${Z.length-A} more leaking disposables

`),{leaks:Z,details:se}}}e.$Fc=b,b.a=0;function C(k){w=k}if(e.$Gc=C,I){const k="__is_disposable_tracked__";C(new class{trackDisposable(A){const j=new Error("Potentially leaked disposable").stack;setTimeout(()=>{A[k]||console.log(j)},3e3)}setParent(A,j){if(A&&A!==t.None)try{A[k]=!0}catch{}}markAsDisposed(A){if(A&&A!==t.None)try{A[k]=!0}catch{}}markAsSingleton(A){}})}function E(k){return w?.trackDisposable(k),k}e.$Hc=E;function v(k){w?.markAsDisposed(k)}e.$Ic=v;function d(k,A){w?.setParent(k,A)}function g(k,A){if(w)for(const j of k)w.setParent(j,A)}function m(k){return w?.markAsSingleton(k),k}e.$Jc=m;function l(k){return typeof k.dispose=="function"&&k.dispose.length===0}e.$Kc=l;function f(k){if(L.Iterable.is(k)){const A=[];for(const j of k)if(j)try{j.dispose()}catch(Z){A.push(Z)}if(A.length===1)throw A[0];if(A.length>1)throw new AggregateError(A,"Encountered errors while disposing of store");return Array.isArray(k)?[]:k}else if(k)return k.dispose(),k}e.$Lc=f;function u(k){for(const A of k)l(A)&&A.dispose();return[]}e.$Mc=u;function c(...k){const A=p(()=>f(k));return g(k,A),A}e.$Nc=c;function p(k){const A=E({dispose:(0,P.$bb)(()=>{v(A),k()})});return A}e.$Oc=p;class h{constructor(){this.f=new Set,this.g=!1,E(this)}dispose(){this.g||(v(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{f(this.f)}finally{this.f.clear()}}add(A){if(!A)return A;if(A===this)throw new Error("Cannot register a disposable on itself!");return d(A,this),this.g?h.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(A),A}delete(A){if(A){if(A===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(A),A.dispose()}}deleteAndLeak(A){A&&this.f.has(A)&&(this.f.delete(A),d(A,null))}}e.$Pc=h,h.DISABLE_DISPOSED_WARNING=!1;class t{constructor(){this.q=new h,E(this),d(this.q,this)}dispose(){v(this),this.q.dispose()}B(A){if(A===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(A)}}e.$Qc=t,t.None=Object.freeze({dispose(){}});class s{constructor(){this.b=!1,E(this)}get value(){return this.b?void 0:this.a}set value(A){this.b||A===this.a||(this.a?.dispose(),A&&d(A,this),this.a=A)}clear(){this.value=void 0}dispose(){this.b=!0,v(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const A=this.a;return this.a=void 0,A&&d(A,null),A}}e.$Rc=s;class o{constructor(A){this.b=A,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Sc=o;class i{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,E(this)}set(A){let j=A;return this.unset=()=>j=void 0,this.isset=()=>j!==void 0,this.dispose=()=>{j&&(j(),j=void 0,v(this))},this}}e.$Tc=i;class n{constructor(){this.a=new Map}acquire(A,...j){let Z=this.a.get(A);Z||(Z={counter:0,object:this.b(A,...j)},this.a.set(A,Z));const{object:ae}=Z,K=(0,P.$bb)(()=>{--Z.counter===0&&(this.c(A,Z.object),this.a.delete(A))});return Z.counter++,{object:ae,dispose:K}}}e.$Uc=n;class a{constructor(A){this.a=A}async acquire(A,...j){const Z=this.a.acquire(A,...j);try{return{object:await Z.object,dispose:()=>Z.dispose()}}catch(ae){throw Z.dispose(),ae}}}e.$Vc=a;class ${constructor(A){this.object=A}dispose(){}}e.$Wc=$;function S(k){const A=new h;try{k(A)}finally{A.dispose()}}e.$Xc=S;class D{constructor(){this.a=new Map,this.b=!1,E(this)}dispose(){v(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{f(this.a.values())}finally{this.a.clear()}}has(A){return this.a.has(A)}get size(){return this.a.size}get(A){return this.a.get(A)}set(A,j,Z=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),Z||this.a.get(A)?.dispose(),this.a.set(A,j)}deleteAndDispose(A){this.a.get(A)?.dispose(),this.a.delete(A)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$Yc=D}),function(le,e){typeof define=="function"&&define.amd?define(we[143],pe([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(le=typeof globalThis<"u"?globalThis:le||self,e(le.marked={}))}(this,function(le){"use strict";function e(H,U){for(var ie=0;ie<U.length;ie++){var z=U[ie];z.enumerable=z.enumerable||!1,z.configurable=!0,"value"in z&&(z.writable=!0),Object.defineProperty(H,z.key,z)}}function y(H,U,ie){return U&&e(H.prototype,U),ie&&e(H,ie),Object.defineProperty(H,"prototype",{writable:!1}),H}function R(H,U){if(H){if(typeof H=="string")return r(H,U);var ie=Object.prototype.toString.call(H).slice(8,-1);if(ie==="Object"&&H.constructor&&(ie=H.constructor.name),ie==="Map"||ie==="Set")return Array.from(H);if(ie==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ie))return r(H,U)}}function r(H,U){(U==null||U>H.length)&&(U=H.length);for(var ie=0,z=new Array(U);ie<U;ie++)z[ie]=H[ie];return z}function P(H,U){var ie=typeof Symbol<"u"&&H[Symbol.iterator]||H["@@iterator"];if(ie)return(ie=ie.call(H)).next.bind(ie);if(Array.isArray(H)||(ie=R(H))||U&&H&&typeof H.length=="number"){ie&&(H=ie);var z=0;return function(){return z>=H.length?{done:!0}:{done:!1,value:H[z++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function L(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}le.defaults=L();function I(H){le.defaults=H}var w=/[&<>"']/,b=/[&<>"']/g,C=/[<>"']|&(?!#?\w+;)/,E=/[<>"']|&(?!#?\w+;)/g,v={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},d=function(U){return v[U]};function g(H,U){if(U){if(w.test(H))return H.replace(b,d)}else if(C.test(H))return H.replace(E,d);return H}var m=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function l(H){return H.replace(m,function(U,ie){return ie=ie.toLowerCase(),ie==="colon"?":":ie.charAt(0)==="#"?ie.charAt(1)==="x"?String.fromCharCode(parseInt(ie.substring(2),16)):String.fromCharCode(+ie.substring(1)):""})}var f=/(^|[^\[])\^/g;function u(H,U){H=typeof H=="string"?H:H.source,U=U||"";var ie={replace:function(_,W){return W=W.source||W,W=W.replace(f,"$1"),H=H.replace(_,W),ie},getRegex:function(){return new RegExp(H,U)}};return ie}var c=/[^\w:]/g,p=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function h(H,U,ie){if(H){var z;try{z=decodeURIComponent(l(ie)).replace(c,"").toLowerCase()}catch{return null}if(z.indexOf("javascript:")===0||z.indexOf("vbscript:")===0||z.indexOf("data:")===0)return null}U&&!p.test(ie)&&(ie=n(U,ie));try{ie=encodeURI(ie).replace(/%25/g,"%")}catch{return null}return ie}var t={},s=/^[^:]+:\/*[^/]*$/,o=/^([^:]+:)[\s\S]*$/,i=/^([^:]+:\/*[^/]*)[\s\S]*$/;function n(H,U){t[" "+H]||(s.test(H)?t[" "+H]=H+"/":t[" "+H]=D(H,"/",!0)),H=t[" "+H];var ie=H.indexOf(":")===-1;return U.substring(0,2)==="//"?ie?U:H.replace(o,"$1")+U:U.charAt(0)==="/"?ie?U:H.replace(i,"$1")+U:H+U}var a={exec:function(){}};function $(H){for(var U=1,ie,z;U<arguments.length;U++){ie=arguments[U];for(z in ie)Object.prototype.hasOwnProperty.call(ie,z)&&(H[z]=ie[z])}return H}function S(H,U){var ie=H.replace(/\|/g,function(W,X,oe){for(var ge=!1,Ee=X;--Ee>=0&&oe[Ee]==="\\";)ge=!ge;return ge?"|":" |"}),z=ie.split(/ \|/),_=0;if(z[0].trim()||z.shift(),z.length>0&&!z[z.length-1].trim()&&z.pop(),z.length>U)z.splice(U);else for(;z.length<U;)z.push("");for(;_<z.length;_++)z[_]=z[_].trim().replace(/\\\|/g,"|");return z}function D(H,U,ie){var z=H.length;if(z===0)return"";for(var _=0;_<z;){var W=H.charAt(z-_-1);if(W===U&&!ie)_++;else if(W!==U&&ie)_++;else break}return H.slice(0,z-_)}function k(H,U){if(H.indexOf(U[1])===-1)return-1;for(var ie=H.length,z=0,_=0;_<ie;_++)if(H[_]==="\\")_++;else if(H[_]===U[0])z++;else if(H[_]===U[1]&&(z--,z<0))return _;return-1}function A(H){H&&H.sanitize&&!H.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function j(H,U){if(U<1)return"";for(var ie="";U>1;)U&1&&(ie+=H),U>>=1,H+=H;return ie+H}function Z(H,U,ie,z){var _=U.href,W=U.title?g(U.title):null,X=H[1].replace(/\\([\[\]])/g,"$1");if(H[0].charAt(0)!=="!"){z.state.inLink=!0;var oe={type:"link",raw:ie,href:_,title:W,text:X,tokens:z.inlineTokens(X)};return z.state.inLink=!1,oe}return{type:"image",raw:ie,href:_,title:W,text:g(X)}}function ae(H,U){var ie=H.match(/^(\s+)(?:```)/);if(ie===null)return U;var z=ie[1];return U.split(`
`).map(function(_){var W=_.match(/^\s+/);if(W===null)return _;var X=W[0];return X.length>=z.length?_.slice(z.length):_}).join(`
`)}var K=function(){function H(ie){this.options=ie||le.defaults}var U=H.prototype;return U.space=function(z){var _=this.rules.block.newline.exec(z);if(_&&_[0].length>0)return{type:"space",raw:_[0]}},U.code=function(z){var _=this.rules.block.code.exec(z);if(_){var W=_[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:_[0],codeBlockStyle:"indented",text:this.options.pedantic?W:D(W,`
`)}}},U.fences=function(z){var _=this.rules.block.fences.exec(z);if(_){var W=_[0],X=ae(W,_[3]||"");return{type:"code",raw:W,lang:_[2]?_[2].trim():_[2],text:X}}},U.heading=function(z){var _=this.rules.block.heading.exec(z);if(_){var W=_[2].trim();if(/#$/.test(W)){var X=D(W,"#");(this.options.pedantic||!X||/ $/.test(X))&&(W=X.trim())}return{type:"heading",raw:_[0],depth:_[1].length,text:W,tokens:this.lexer.inline(W)}}},U.hr=function(z){var _=this.rules.block.hr.exec(z);if(_)return{type:"hr",raw:_[0]}},U.blockquote=function(z){var _=this.rules.block.blockquote.exec(z);if(_){var W=_[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:_[0],tokens:this.lexer.blockTokens(W,[]),text:W}}},U.list=function(z){var _=this.rules.block.list.exec(z);if(_){var W,X,oe,ge,Ee,Pe,Ne,Fe,$e,ke,ve,Me,Ue=_[1].trim(),Ye=Ue.length>1,qe={type:"list",raw:"",ordered:Ye,start:Ye?+Ue.slice(0,-1):"",loose:!1,items:[]};Ue=Ye?"\\d{1,9}\\"+Ue.slice(-1):"\\"+Ue,this.options.pedantic&&(Ue=Ye?Ue:"[*+-]");for(var Je=new RegExp("^( {0,3}"+Ue+")((?:[	 ][^\\n]*)?(?:\\n|$))");z&&(Me=!1,!(!(_=Je.exec(z))||this.rules.block.hr.test(z)));){if(W=_[0],z=z.substring(W.length),Fe=_[2].split(`
`,1)[0],$e=z.split(`
`,1)[0],this.options.pedantic?(ge=2,ve=Fe.trimLeft()):(ge=_[2].search(/[^ ]/),ge=ge>4?1:ge,ve=Fe.slice(ge),ge+=_[1].length),Pe=!1,!Fe&&/^ *$/.test($e)&&(W+=$e+`
`,z=z.substring($e.length+1),Me=!0),!Me)for(var Ze=new RegExp("^ {0,"+Math.min(3,ge-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),xe=new RegExp("^ {0,"+Math.min(3,ge-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),de=new RegExp("^ {0,"+Math.min(3,ge-1)+"}(?:```|~~~)"),Se=new RegExp("^ {0,"+Math.min(3,ge-1)+"}#");z&&(ke=z.split(`
`,1)[0],Fe=ke,this.options.pedantic&&(Fe=Fe.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(de.test(Fe)||Se.test(Fe)||Ze.test(Fe)||xe.test(z)));){if(Fe.search(/[^ ]/)>=ge||!Fe.trim())ve+=`
`+Fe.slice(ge);else if(!Pe)ve+=`
`+Fe;else break;!Pe&&!Fe.trim()&&(Pe=!0),W+=ke+`
`,z=z.substring(ke.length+1)}qe.loose||(Ne?qe.loose=!0:/\n *\n *$/.test(W)&&(Ne=!0)),this.options.gfm&&(X=/^\[[ xX]\] /.exec(ve),X&&(oe=X[0]!=="[ ] ",ve=ve.replace(/^\[[ xX]\] +/,""))),qe.items.push({type:"list_item",raw:W,task:!!X,checked:oe,loose:!1,text:ve}),qe.raw+=W}qe.items[qe.items.length-1].raw=W.trimRight(),qe.items[qe.items.length-1].text=ve.trimRight(),qe.raw=qe.raw.trimRight();var Ie=qe.items.length;for(Ee=0;Ee<Ie;Ee++){this.lexer.state.top=!1,qe.items[Ee].tokens=this.lexer.blockTokens(qe.items[Ee].text,[]);var Le=qe.items[Ee].tokens.filter(function(ze){return ze.type==="space"}),Be=Le.every(function(ze){for(var He=ze.raw.split(""),Ge=0,Qe=P(He),We;!(We=Qe()).done;){var st=We.value;if(st===`
`&&(Ge+=1),Ge>1)return!0}return!1});!qe.loose&&Le.length&&Be&&(qe.loose=!0,qe.items[Ee].loose=!0)}return qe}},U.html=function(z){var _=this.rules.block.html.exec(z);if(_){var W={type:"html",raw:_[0],pre:!this.options.sanitizer&&(_[1]==="pre"||_[1]==="script"||_[1]==="style"),text:_[0]};if(this.options.sanitize){var X=this.options.sanitizer?this.options.sanitizer(_[0]):g(_[0]);W.type="paragraph",W.text=X,W.tokens=this.lexer.inline(X)}return W}},U.def=function(z){var _=this.rules.block.def.exec(z);if(_){_[3]&&(_[3]=_[3].substring(1,_[3].length-1));var W=_[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:W,raw:_[0],href:_[2],title:_[3]}}},U.table=function(z){var _=this.rules.block.table.exec(z);if(_){var W={type:"table",header:S(_[1]).map(function(Ne){return{text:Ne}}),align:_[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:_[3]&&_[3].trim()?_[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(W.header.length===W.align.length){W.raw=_[0];var X=W.align.length,oe,ge,Ee,Pe;for(oe=0;oe<X;oe++)/^ *-+: *$/.test(W.align[oe])?W.align[oe]="right":/^ *:-+: *$/.test(W.align[oe])?W.align[oe]="center":/^ *:-+ *$/.test(W.align[oe])?W.align[oe]="left":W.align[oe]=null;for(X=W.rows.length,oe=0;oe<X;oe++)W.rows[oe]=S(W.rows[oe],W.header.length).map(function(Ne){return{text:Ne}});for(X=W.header.length,ge=0;ge<X;ge++)W.header[ge].tokens=this.lexer.inline(W.header[ge].text);for(X=W.rows.length,ge=0;ge<X;ge++)for(Pe=W.rows[ge],Ee=0;Ee<Pe.length;Ee++)Pe[Ee].tokens=this.lexer.inline(Pe[Ee].text);return W}}},U.lheading=function(z){var _=this.rules.block.lheading.exec(z);if(_)return{type:"heading",raw:_[0],depth:_[2].charAt(0)==="="?1:2,text:_[1],tokens:this.lexer.inline(_[1])}},U.paragraph=function(z){var _=this.rules.block.paragraph.exec(z);if(_){var W=_[1].charAt(_[1].length-1)===`
`?_[1].slice(0,-1):_[1];return{type:"paragraph",raw:_[0],text:W,tokens:this.lexer.inline(W)}}},U.text=function(z){var _=this.rules.block.text.exec(z);if(_)return{type:"text",raw:_[0],text:_[0],tokens:this.lexer.inline(_[0])}},U.escape=function(z){var _=this.rules.inline.escape.exec(z);if(_)return{type:"escape",raw:_[0],text:g(_[1])}},U.tag=function(z){var _=this.rules.inline.tag.exec(z);if(_)return!this.lexer.state.inLink&&/^<a /i.test(_[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(_[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(_[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(_[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:_[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(_[0]):g(_[0]):_[0]}},U.link=function(z){var _=this.rules.inline.link.exec(z);if(_){var W=_[2].trim();if(!this.options.pedantic&&/^</.test(W)){if(!/>$/.test(W))return;var X=D(W.slice(0,-1),"\\");if((W.length-X.length)%2===0)return}else{var oe=k(_[2],"()");if(oe>-1){var ge=_[0].indexOf("!")===0?5:4,Ee=ge+_[1].length+oe;_[2]=_[2].substring(0,oe),_[0]=_[0].substring(0,Ee).trim(),_[3]=""}}var Pe=_[2],Ne="";if(this.options.pedantic){var Fe=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Pe);Fe&&(Pe=Fe[1],Ne=Fe[3])}else Ne=_[3]?_[3].slice(1,-1):"";return Pe=Pe.trim(),/^</.test(Pe)&&(this.options.pedantic&&!/>$/.test(W)?Pe=Pe.slice(1):Pe=Pe.slice(1,-1)),Z(_,{href:Pe&&Pe.replace(this.rules.inline._escapes,"$1"),title:Ne&&Ne.replace(this.rules.inline._escapes,"$1")},_[0],this.lexer)}},U.reflink=function(z,_){var W;if((W=this.rules.inline.reflink.exec(z))||(W=this.rules.inline.nolink.exec(z))){var X=(W[2]||W[1]).replace(/\s+/g," ");if(X=_[X.toLowerCase()],!X||!X.href){var oe=W[0].charAt(0);return{type:"text",raw:oe,text:oe}}return Z(W,X,W[0],this.lexer)}},U.emStrong=function(z,_,W){W===void 0&&(W="");var X=this.rules.inline.emStrong.lDelim.exec(z);if(X&&!(X[3]&&W.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var oe=X[1]||X[2]||"";if(!oe||oe&&(W===""||this.rules.inline.punctuation.exec(W))){var ge=X[0].length-1,Ee,Pe,Ne=ge,Fe=0,$e=X[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for($e.lastIndex=0,_=_.slice(-1*z.length+ge);(X=$e.exec(_))!=null;)if(Ee=X[1]||X[2]||X[3]||X[4]||X[5]||X[6],!!Ee){if(Pe=Ee.length,X[3]||X[4]){Ne+=Pe;continue}else if((X[5]||X[6])&&ge%3&&!((ge+Pe)%3)){Fe+=Pe;continue}if(Ne-=Pe,!(Ne>0)){if(Pe=Math.min(Pe,Pe+Ne+Fe),Math.min(ge,Pe)%2){var ke=z.slice(1,ge+X.index+Pe);return{type:"em",raw:z.slice(0,ge+X.index+Pe+1),text:ke,tokens:this.lexer.inlineTokens(ke)}}var ve=z.slice(2,ge+X.index+Pe-1);return{type:"strong",raw:z.slice(0,ge+X.index+Pe+1),text:ve,tokens:this.lexer.inlineTokens(ve)}}}}}},U.codespan=function(z){var _=this.rules.inline.code.exec(z);if(_){var W=_[2].replace(/\n/g," "),X=/[^ ]/.test(W),oe=/^ /.test(W)&&/ $/.test(W);return X&&oe&&(W=W.substring(1,W.length-1)),W=g(W,!0),{type:"codespan",raw:_[0],text:W}}},U.br=function(z){var _=this.rules.inline.br.exec(z);if(_)return{type:"br",raw:_[0]}},U.del=function(z){var _=this.rules.inline.del.exec(z);if(_)return{type:"del",raw:_[0],text:_[2],tokens:this.lexer.inlineTokens(_[2])}},U.autolink=function(z,_){var W=this.rules.inline.autolink.exec(z);if(W){var X,oe;return W[2]==="@"?(X=g(this.options.mangle?_(W[1]):W[1]),oe="mailto:"+X):(X=g(W[1]),oe=X),{type:"link",raw:W[0],text:X,href:oe,tokens:[{type:"text",raw:X,text:X}]}}},U.url=function(z,_){var W;if(W=this.rules.inline.url.exec(z)){var X,oe;if(W[2]==="@")X=g(this.options.mangle?_(W[0]):W[0]),oe="mailto:"+X;else{var ge;do ge=W[0],W[0]=this.rules.inline._backpedal.exec(W[0])[0];while(ge!==W[0]);X=g(W[0]),W[1]==="www."?oe="http://"+X:oe=X}return{type:"link",raw:W[0],text:X,href:oe,tokens:[{type:"text",raw:X,text:X}]}}},U.inlineText=function(z,_){var W=this.rules.inline.text.exec(z);if(W){var X;return this.lexer.state.inRawBlock?X=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(W[0]):g(W[0]):W[0]:X=g(this.options.smartypants?_(W[0]):W[0]),{type:"text",raw:W[0],text:X}}},H}(),se={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:a,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};se._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,se._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,se.def=u(se.def).replace("label",se._label).replace("title",se._title).getRegex(),se.bullet=/(?:[*+-]|\d{1,9}[.)])/,se.listItemStart=u(/^( *)(bull) */).replace("bull",se.bullet).getRegex(),se.list=u(se.list).replace(/bull/g,se.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+se.def.source+")").getRegex(),se._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",se._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,se.html=u(se.html,"i").replace("comment",se._comment).replace("tag",se._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),se.paragraph=u(se._paragraph).replace("hr",se.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",se._tag).getRegex(),se.blockquote=u(se.blockquote).replace("paragraph",se.paragraph).getRegex(),se.normal=$({},se),se.gfm=$({},se.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),se.gfm.table=u(se.gfm.table).replace("hr",se.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",se._tag).getRegex(),se.gfm.paragraph=u(se._paragraph).replace("hr",se.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",se.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",se._tag).getRegex(),se.pedantic=$({},se.normal,{html:u(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",se._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:a,paragraph:u(se.normal._paragraph).replace("hr",se.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",se.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var ue={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:a,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:a,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};ue._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",ue.punctuation=u(ue.punctuation).replace(/punctuation/g,ue._punctuation).getRegex(),ue.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,ue.escapedEmSt=/\\\*|\\_/g,ue._comment=u(se._comment).replace("(?:-->|$)","-->").getRegex(),ue.emStrong.lDelim=u(ue.emStrong.lDelim).replace(/punct/g,ue._punctuation).getRegex(),ue.emStrong.rDelimAst=u(ue.emStrong.rDelimAst,"g").replace(/punct/g,ue._punctuation).getRegex(),ue.emStrong.rDelimUnd=u(ue.emStrong.rDelimUnd,"g").replace(/punct/g,ue._punctuation).getRegex(),ue._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,ue._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,ue._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,ue.autolink=u(ue.autolink).replace("scheme",ue._scheme).replace("email",ue._email).getRegex(),ue._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,ue.tag=u(ue.tag).replace("comment",ue._comment).replace("attribute",ue._attribute).getRegex(),ue._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,ue._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,ue._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,ue.link=u(ue.link).replace("label",ue._label).replace("href",ue._href).replace("title",ue._title).getRegex(),ue.reflink=u(ue.reflink).replace("label",ue._label).replace("ref",se._label).getRegex(),ue.nolink=u(ue.nolink).replace("ref",se._label).getRegex(),ue.reflinkSearch=u(ue.reflinkSearch,"g").replace("reflink",ue.reflink).replace("nolink",ue.nolink).getRegex(),ue.normal=$({},ue),ue.pedantic=$({},ue.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:u(/^!?\[(label)\]\((.*?)\)/).replace("label",ue._label).getRegex(),reflink:u(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",ue._label).getRegex()}),ue.gfm=$({},ue.normal,{escape:u(ue.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),ue.gfm.url=u(ue.gfm.url,"i").replace("email",ue.gfm._extended_email).getRegex(),ue.breaks=$({},ue.gfm,{br:u(ue.br).replace("{2,}","*").getRegex(),text:u(ue.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function x(H){return H.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function he(H){var U="",ie,z,_=H.length;for(ie=0;ie<_;ie++)z=H.charCodeAt(ie),Math.random()>.5&&(z="x"+z.toString(16)),U+="&#"+z+";";return U}var V=function(){function H(ie){this.tokens=[],this.tokens.links=Object.create(null),this.options=ie||le.defaults,this.options.tokenizer=this.options.tokenizer||new K,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var z={block:se.normal,inline:ue.normal};this.options.pedantic?(z.block=se.pedantic,z.inline=ue.pedantic):this.options.gfm&&(z.block=se.gfm,this.options.breaks?z.inline=ue.breaks:z.inline=ue.gfm),this.tokenizer.rules=z}H.lex=function(z,_){var W=new H(_);return W.lex(z)},H.lexInline=function(z,_){var W=new H(_);return W.inlineTokens(z)};var U=H.prototype;return U.lex=function(z){z=z.replace(/\r\n|\r/g,`
`),this.blockTokens(z,this.tokens);for(var _;_=this.inlineQueue.shift();)this.inlineTokens(_.src,_.tokens);return this.tokens},U.blockTokens=function(z,_){var W=this;_===void 0&&(_=[]),this.options.pedantic?z=z.replace(/\t/g,"    ").replace(/^ +$/gm,""):z=z.replace(/^( *)(\t+)/gm,function(Ne,Fe,$e){return Fe+"    ".repeat($e.length)});for(var X,oe,ge,Ee;z;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Ne){return(X=Ne.call({lexer:W},z,_))?(z=z.substring(X.raw.length),_.push(X),!0):!1}))){if(X=this.tokenizer.space(z)){z=z.substring(X.raw.length),X.raw.length===1&&_.length>0?_[_.length-1].raw+=`
`:_.push(X);continue}if(X=this.tokenizer.code(z)){z=z.substring(X.raw.length),oe=_[_.length-1],oe&&(oe.type==="paragraph"||oe.type==="text")?(oe.raw+=`
`+X.raw,oe.text+=`
`+X.text,this.inlineQueue[this.inlineQueue.length-1].src=oe.text):_.push(X);continue}if(X=this.tokenizer.fences(z)){z=z.substring(X.raw.length),_.push(X);continue}if(X=this.tokenizer.heading(z)){z=z.substring(X.raw.length),_.push(X);continue}if(X=this.tokenizer.hr(z)){z=z.substring(X.raw.length),_.push(X);continue}if(X=this.tokenizer.blockquote(z)){z=z.substring(X.raw.length),_.push(X);continue}if(X=this.tokenizer.list(z)){z=z.substring(X.raw.length),_.push(X);continue}if(X=this.tokenizer.html(z)){z=z.substring(X.raw.length),_.push(X);continue}if(X=this.tokenizer.def(z)){z=z.substring(X.raw.length),oe=_[_.length-1],oe&&(oe.type==="paragraph"||oe.type==="text")?(oe.raw+=`
`+X.raw,oe.text+=`
`+X.raw,this.inlineQueue[this.inlineQueue.length-1].src=oe.text):this.tokens.links[X.tag]||(this.tokens.links[X.tag]={href:X.href,title:X.title});continue}if(X=this.tokenizer.table(z)){z=z.substring(X.raw.length),_.push(X);continue}if(X=this.tokenizer.lheading(z)){z=z.substring(X.raw.length),_.push(X);continue}if(ge=z,this.options.extensions&&this.options.extensions.startBlock&&function(){var Ne=1/0,Fe=z.slice(1),$e=void 0;W.options.extensions.startBlock.forEach(function(ke){$e=ke.call({lexer:this},Fe),typeof $e=="number"&&$e>=0&&(Ne=Math.min(Ne,$e))}),Ne<1/0&&Ne>=0&&(ge=z.substring(0,Ne+1))}(),this.state.top&&(X=this.tokenizer.paragraph(ge))){oe=_[_.length-1],Ee&&oe.type==="paragraph"?(oe.raw+=`
`+X.raw,oe.text+=`
`+X.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=oe.text):_.push(X),Ee=ge.length!==z.length,z=z.substring(X.raw.length);continue}if(X=this.tokenizer.text(z)){z=z.substring(X.raw.length),oe=_[_.length-1],oe&&oe.type==="text"?(oe.raw+=`
`+X.raw,oe.text+=`
`+X.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=oe.text):_.push(X);continue}if(z){var Pe="Infinite loop on byte: "+z.charCodeAt(0);if(this.options.silent){console.error(Pe);break}else throw new Error(Pe)}}return this.state.top=!0,_},U.inline=function(z,_){return _===void 0&&(_=[]),this.inlineQueue.push({src:z,tokens:_}),_},U.inlineTokens=function(z,_){var W=this;_===void 0&&(_=[]);var X,oe,ge,Ee=z,Pe,Ne,Fe;if(this.tokens.links){var $e=Object.keys(this.tokens.links);if($e.length>0)for(;(Pe=this.tokenizer.rules.inline.reflinkSearch.exec(Ee))!=null;)$e.includes(Pe[0].slice(Pe[0].lastIndexOf("[")+1,-1))&&(Ee=Ee.slice(0,Pe.index)+"["+j("a",Pe[0].length-2)+"]"+Ee.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Pe=this.tokenizer.rules.inline.blockSkip.exec(Ee))!=null;)Ee=Ee.slice(0,Pe.index)+"["+j("a",Pe[0].length-2)+"]"+Ee.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Pe=this.tokenizer.rules.inline.escapedEmSt.exec(Ee))!=null;)Ee=Ee.slice(0,Pe.index)+"++"+Ee.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;z;)if(Ne||(Fe=""),Ne=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ve){return(X=ve.call({lexer:W},z,_))?(z=z.substring(X.raw.length),_.push(X),!0):!1}))){if(X=this.tokenizer.escape(z)){z=z.substring(X.raw.length),_.push(X);continue}if(X=this.tokenizer.tag(z)){z=z.substring(X.raw.length),oe=_[_.length-1],oe&&X.type==="text"&&oe.type==="text"?(oe.raw+=X.raw,oe.text+=X.text):_.push(X);continue}if(X=this.tokenizer.link(z)){z=z.substring(X.raw.length),_.push(X);continue}if(X=this.tokenizer.reflink(z,this.tokens.links)){z=z.substring(X.raw.length),oe=_[_.length-1],oe&&X.type==="text"&&oe.type==="text"?(oe.raw+=X.raw,oe.text+=X.text):_.push(X);continue}if(X=this.tokenizer.emStrong(z,Ee,Fe)){z=z.substring(X.raw.length),_.push(X);continue}if(X=this.tokenizer.codespan(z)){z=z.substring(X.raw.length),_.push(X);continue}if(X=this.tokenizer.br(z)){z=z.substring(X.raw.length),_.push(X);continue}if(X=this.tokenizer.del(z)){z=z.substring(X.raw.length),_.push(X);continue}if(X=this.tokenizer.autolink(z,he)){z=z.substring(X.raw.length),_.push(X);continue}if(!this.state.inLink&&(X=this.tokenizer.url(z,he))){z=z.substring(X.raw.length),_.push(X);continue}if(ge=z,this.options.extensions&&this.options.extensions.startInline&&function(){var ve=1/0,Me=z.slice(1),Ue=void 0;W.options.extensions.startInline.forEach(function(Ye){Ue=Ye.call({lexer:this},Me),typeof Ue=="number"&&Ue>=0&&(ve=Math.min(ve,Ue))}),ve<1/0&&ve>=0&&(ge=z.substring(0,ve+1))}(),X=this.tokenizer.inlineText(ge,x)){z=z.substring(X.raw.length),X.raw.slice(-1)!=="_"&&(Fe=X.raw.slice(-1)),Ne=!0,oe=_[_.length-1],oe&&oe.type==="text"?(oe.raw+=X.raw,oe.text+=X.text):_.push(X);continue}if(z){var ke="Infinite loop on byte: "+z.charCodeAt(0);if(this.options.silent){console.error(ke);break}else throw new Error(ke)}}return _},y(H,null,[{key:"rules",get:function(){return{block:se,inline:ue}}}]),H}(),te=function(){function H(ie){this.options=ie||le.defaults}var U=H.prototype;return U.code=function(z,_,W){var X=(_||"").match(/\S*/)[0];if(this.options.highlight){var oe=this.options.highlight(z,X);oe!=null&&oe!==z&&(W=!0,z=oe)}return z=z.replace(/\n$/,"")+`
`,X?'<pre><code class="'+this.options.langPrefix+g(X,!0)+'">'+(W?z:g(z,!0))+`</code></pre>
`:"<pre><code>"+(W?z:g(z,!0))+`</code></pre>
`},U.blockquote=function(z){return`<blockquote>
`+z+`</blockquote>
`},U.html=function(z){return z},U.heading=function(z,_,W,X){if(this.options.headerIds){var oe=this.options.headerPrefix+X.slug(W);return"<h"+_+' id="'+oe+'">'+z+"</h"+_+`>
`}return"<h"+_+">"+z+"</h"+_+`>
`},U.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},U.list=function(z,_,W){var X=_?"ol":"ul",oe=_&&W!==1?' start="'+W+'"':"";return"<"+X+oe+`>
`+z+"</"+X+`>
`},U.listitem=function(z){return"<li>"+z+`</li>
`},U.checkbox=function(z){return"<input "+(z?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},U.paragraph=function(z){return"<p>"+z+`</p>
`},U.table=function(z,_){return _&&(_="<tbody>"+_+"</tbody>"),`<table>
<thead>
`+z+`</thead>
`+_+`</table>
`},U.tablerow=function(z){return`<tr>
`+z+`</tr>
`},U.tablecell=function(z,_){var W=_.header?"th":"td",X=_.align?"<"+W+' align="'+_.align+'">':"<"+W+">";return X+z+("</"+W+`>
`)},U.strong=function(z){return"<strong>"+z+"</strong>"},U.em=function(z){return"<em>"+z+"</em>"},U.codespan=function(z){return"<code>"+z+"</code>"},U.br=function(){return this.options.xhtml?"<br/>":"<br>"},U.del=function(z){return"<del>"+z+"</del>"},U.link=function(z,_,W){if(z=h(this.options.sanitize,this.options.baseUrl,z),z===null)return W;var X='<a href="'+g(z)+'"';return _&&(X+=' title="'+_+'"'),X+=">"+W+"</a>",X},U.image=function(z,_,W){if(z=h(this.options.sanitize,this.options.baseUrl,z),z===null)return W;var X='<img src="'+z+'" alt="'+W+'"';return _&&(X+=' title="'+_+'"'),X+=this.options.xhtml?"/>":">",X},U.text=function(z){return z},H}(),G=function(){function H(){}var U=H.prototype;return U.strong=function(z){return z},U.em=function(z){return z},U.codespan=function(z){return z},U.del=function(z){return z},U.html=function(z){return z},U.text=function(z){return z},U.link=function(z,_,W){return""+W},U.image=function(z,_,W){return""+W},U.br=function(){return""},H}(),J=function(){function H(){this.seen={}}var U=H.prototype;return U.serialize=function(z){return z.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},U.getNextSafeSlug=function(z,_){var W=z,X=0;if(this.seen.hasOwnProperty(W)){X=this.seen[z];do X++,W=z+"-"+X;while(this.seen.hasOwnProperty(W))}return _||(this.seen[z]=X,this.seen[W]=0),W},U.slug=function(z,_){_===void 0&&(_={});var W=this.serialize(z);return this.getNextSafeSlug(W,_.dryrun)},H}(),q=function(){function H(ie){this.options=ie||le.defaults,this.options.renderer=this.options.renderer||new te,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new G,this.slugger=new J}H.parse=function(z,_){var W=new H(_);return W.parse(z)},H.parseInline=function(z,_){var W=new H(_);return W.parseInline(z)};var U=H.prototype;return U.parse=function(z,_){_===void 0&&(_=!0);var W="",X,oe,ge,Ee,Pe,Ne,Fe,$e,ke,ve,Me,Ue,Ye,qe,Je,Ze,xe,de,Se,Ie=z.length;for(X=0;X<Ie;X++){if(ve=z[X],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ve.type]&&(Se=this.options.extensions.renderers[ve.type].call({parser:this},ve),Se!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ve.type))){W+=Se||"";continue}switch(ve.type){case"space":continue;case"hr":{W+=this.renderer.hr();continue}case"heading":{W+=this.renderer.heading(this.parseInline(ve.tokens),ve.depth,l(this.parseInline(ve.tokens,this.textRenderer)),this.slugger);continue}case"code":{W+=this.renderer.code(ve.text,ve.lang,ve.escaped);continue}case"table":{for($e="",Fe="",Ee=ve.header.length,oe=0;oe<Ee;oe++)Fe+=this.renderer.tablecell(this.parseInline(ve.header[oe].tokens),{header:!0,align:ve.align[oe]});for($e+=this.renderer.tablerow(Fe),ke="",Ee=ve.rows.length,oe=0;oe<Ee;oe++){for(Ne=ve.rows[oe],Fe="",Pe=Ne.length,ge=0;ge<Pe;ge++)Fe+=this.renderer.tablecell(this.parseInline(Ne[ge].tokens),{header:!1,align:ve.align[ge]});ke+=this.renderer.tablerow(Fe)}W+=this.renderer.table($e,ke);continue}case"blockquote":{ke=this.parse(ve.tokens),W+=this.renderer.blockquote(ke);continue}case"list":{for(Me=ve.ordered,Ue=ve.start,Ye=ve.loose,Ee=ve.items.length,ke="",oe=0;oe<Ee;oe++)Je=ve.items[oe],Ze=Je.checked,xe=Je.task,qe="",Je.task&&(de=this.renderer.checkbox(Ze),Ye?Je.tokens.length>0&&Je.tokens[0].type==="paragraph"?(Je.tokens[0].text=de+" "+Je.tokens[0].text,Je.tokens[0].tokens&&Je.tokens[0].tokens.length>0&&Je.tokens[0].tokens[0].type==="text"&&(Je.tokens[0].tokens[0].text=de+" "+Je.tokens[0].tokens[0].text)):Je.tokens.unshift({type:"text",text:de}):qe+=de),qe+=this.parse(Je.tokens,Ye),ke+=this.renderer.listitem(qe,xe,Ze);W+=this.renderer.list(ke,Me,Ue);continue}case"html":{W+=this.renderer.html(ve.text);continue}case"paragraph":{W+=this.renderer.paragraph(this.parseInline(ve.tokens));continue}case"text":{for(ke=ve.tokens?this.parseInline(ve.tokens):ve.text;X+1<Ie&&z[X+1].type==="text";)ve=z[++X],ke+=`
`+(ve.tokens?this.parseInline(ve.tokens):ve.text);W+=_?this.renderer.paragraph(ke):ke;continue}default:{var Le='Token with "'+ve.type+'" type was not found.';if(this.options.silent){console.error(Le);return}else throw new Error(Le)}}}return W},U.parseInline=function(z,_){_=_||this.renderer;var W="",X,oe,ge,Ee=z.length;for(X=0;X<Ee;X++){if(oe=z[X],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[oe.type]&&(ge=this.options.extensions.renderers[oe.type].call({parser:this},oe),ge!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(oe.type))){W+=ge||"";continue}switch(oe.type){case"escape":{W+=_.text(oe.text);break}case"html":{W+=_.html(oe.text);break}case"link":{W+=_.link(oe.href,oe.title,this.parseInline(oe.tokens,_));break}case"image":{W+=_.image(oe.href,oe.title,oe.text);break}case"strong":{W+=_.strong(this.parseInline(oe.tokens,_));break}case"em":{W+=_.em(this.parseInline(oe.tokens,_));break}case"codespan":{W+=_.codespan(oe.text);break}case"br":{W+=_.br();break}case"del":{W+=_.del(this.parseInline(oe.tokens,_));break}case"text":{W+=_.text(oe.text);break}default:{var Pe='Token with "'+oe.type+'" type was not found.';if(this.options.silent){console.error(Pe);return}else throw new Error(Pe)}}}return W},H}();function ne(H,U,ie){if(typeof H>"u"||H===null)throw new Error("marked(): input parameter is undefined or null");if(typeof H!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(H)+", string expected");if(typeof U=="function"&&(ie=U,U=null),U=$({},ne.defaults,U||{}),A(U),ie){var z=U.highlight,_;try{_=V.lex(H,U)}catch(Ee){return ie(Ee)}var W=function(Pe){var Ne;if(!Pe)try{U.walkTokens&&ne.walkTokens(_,U.walkTokens),Ne=q.parse(_,U)}catch(Fe){Pe=Fe}return U.highlight=z,Pe?ie(Pe):ie(null,Ne)};if(!z||z.length<3||(delete U.highlight,!_.length))return W();var X=0;ne.walkTokens(_,function(Ee){Ee.type==="code"&&(X++,setTimeout(function(){z(Ee.text,Ee.lang,function(Pe,Ne){if(Pe)return W(Pe);Ne!=null&&Ne!==Ee.text&&(Ee.text=Ne,Ee.escaped=!0),X--,X===0&&W()})},0))}),X===0&&W();return}function oe(Ee){if(Ee.message+=`
Please report this to https://github.com/markedjs/marked.`,U.silent)return"<p>An error occurred:</p><pre>"+g(Ee.message+"",!0)+"</pre>";throw Ee}try{var ge=V.lex(H,U);if(U.walkTokens){if(U.async)return Promise.all(ne.walkTokens(ge,U.walkTokens)).then(function(){return q.parse(ge,U)}).catch(oe);ne.walkTokens(ge,U.walkTokens)}return q.parse(ge,U)}catch(Ee){oe(Ee)}}ne.options=ne.setOptions=function(H){return $(ne.defaults,H),I(ne.defaults),ne},ne.getDefaults=L,ne.defaults=le.defaults,ne.use=function(){for(var H=arguments.length,U=new Array(H),ie=0;ie<H;ie++)U[ie]=arguments[ie];var z=$.apply(void 0,[{}].concat(U)),_=ne.defaults.extensions||{renderers:{},childTokens:{}},W;U.forEach(function(X){if(X.extensions&&(W=!0,X.extensions.forEach(function(ge){if(!ge.name)throw new Error("extension name required");if(ge.renderer){var Ee=_.renderers?_.renderers[ge.name]:null;Ee?_.renderers[ge.name]=function(){for(var Pe=arguments.length,Ne=new Array(Pe),Fe=0;Fe<Pe;Fe++)Ne[Fe]=arguments[Fe];var $e=ge.renderer.apply(this,Ne);return $e===!1&&($e=Ee.apply(this,Ne)),$e}:_.renderers[ge.name]=ge.renderer}if(ge.tokenizer){if(!ge.level||ge.level!=="block"&&ge.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");_[ge.level]?_[ge.level].unshift(ge.tokenizer):_[ge.level]=[ge.tokenizer],ge.start&&(ge.level==="block"?_.startBlock?_.startBlock.push(ge.start):_.startBlock=[ge.start]:ge.level==="inline"&&(_.startInline?_.startInline.push(ge.start):_.startInline=[ge.start]))}ge.childTokens&&(_.childTokens[ge.name]=ge.childTokens)})),X.renderer&&function(){var ge=ne.defaults.renderer||new te,Ee=function(Fe){var $e=ge[Fe];ge[Fe]=function(){for(var ke=arguments.length,ve=new Array(ke),Me=0;Me<ke;Me++)ve[Me]=arguments[Me];var Ue=X.renderer[Fe].apply(ge,ve);return Ue===!1&&(Ue=$e.apply(ge,ve)),Ue}};for(var Pe in X.renderer)Ee(Pe);z.renderer=ge}(),X.tokenizer&&function(){var ge=ne.defaults.tokenizer||new K,Ee=function(Fe){var $e=ge[Fe];ge[Fe]=function(){for(var ke=arguments.length,ve=new Array(ke),Me=0;Me<ke;Me++)ve[Me]=arguments[Me];var Ue=X.tokenizer[Fe].apply(ge,ve);return Ue===!1&&(Ue=$e.apply(ge,ve)),Ue}};for(var Pe in X.tokenizer)Ee(Pe);z.tokenizer=ge}(),X.walkTokens){var oe=ne.defaults.walkTokens;z.walkTokens=function(ge){var Ee=[];return Ee.push(X.walkTokens.call(this,ge)),oe&&(Ee=Ee.concat(oe.call(this,ge))),Ee}}W&&(z.extensions=_),ne.setOptions(z)})},ne.walkTokens=function(H,U){for(var ie=[],z=function(){var oe=W.value;switch(ie=ie.concat(U.call(ne,oe)),oe.type){case"table":{for(var ge=P(oe.header),Ee;!(Ee=ge()).done;){var Pe=Ee.value;ie=ie.concat(ne.walkTokens(Pe.tokens,U))}for(var Ne=P(oe.rows),Fe;!(Fe=Ne()).done;)for(var $e=Fe.value,ke=P($e),ve;!(ve=ke()).done;){var Me=ve.value;ie=ie.concat(ne.walkTokens(Me.tokens,U))}break}case"list":{ie=ie.concat(ne.walkTokens(oe.items,U));break}default:ne.defaults.extensions&&ne.defaults.extensions.childTokens&&ne.defaults.extensions.childTokens[oe.type]?ne.defaults.extensions.childTokens[oe.type].forEach(function(Ue){ie=ie.concat(ne.walkTokens(oe[Ue],U))}):oe.tokens&&(ie=ie.concat(ne.walkTokens(oe.tokens,U)))}},_=P(H),W;!(W=_()).done;)z();return ie},ne.parseInline=function(H,U){if(typeof H>"u"||H===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof H!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(H)+", string expected");U=$({},ne.defaults,U||{}),A(U);try{var ie=V.lexInline(H,U);return U.walkTokens&&ne.walkTokens(ie,U.walkTokens),q.parseInline(ie,U)}catch(z){if(z.message+=`
Please report this to https://github.com/markedjs/marked.`,U.silent)return"<p>An error occurred:</p><pre>"+g(z.message+"",!0)+"</pre>";throw z}},ne.Parser=q,ne.parser=q.parse,ne.Renderer=te,ne.TextRenderer=G,ne.Lexer=V,ne.lexer=V.lex,ne.Tokenizer=K,ne.Slugger=J,ne.parse=ne;var me=ne.options,re=ne.setOptions,B=ne.use,ee=ne.walkTokens,O=ne.parseInline,N=ne,Q=q.parse,T=V.lex;le.Lexer=V,le.Parser=q,le.Renderer=te,le.Slugger=J,le.TextRenderer=G,le.Tokenizer=K,le.getDefaults=L,le.lexer=T,le.marked=ne,le.options=me,le.parse=N,le.parseInline=O,le.parser=Q,le.setOptions=re,le.use=B,le.walkTokens=ee,Object.defineProperty(le,"__esModule",{value:!0})}),define(we[98],pe([1,0,26]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ll=e.$kl=e.$jl=void 0;const R=new y.$Bc(1e4);function r(b){return w(b,"NFC",R)}e.$jl=r;const P=new y.$Bc(1e4);function L(b){return w(b,"NFD",P)}e.$kl=L;const I=/[^\u0000-\u0080]/;function w(b,C,E){if(!b)return b;const v=E.get(b);if(v)return v;let d;return I.test(b)?d=b.normalize(C):d=b,E.set(b,d),d}e.$ll=function(){const b=/[\u0300-\u036f]/g;return function(C){return L(C).replace(b,"")}}()}),define(we[144],pe([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nl=e.$Ml=e.$Ll=e.rot=e.$Jl=void 0;function y(I,w,b){return Math.min(Math.max(I,w),b)}e.$Jl=y;function R(I,w){return(w+I%w)%w}e.rot=R;class r{constructor(){this.a=0}getNext(){return this.a++}}e.$Ll=r;class P{constructor(){this.a=1,this.b=0}update(w){return this.b=this.b+(w-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Ml=P;class L{constructor(w){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(w),this.c.fill(0,0,w)}update(w){const b=this.c[this.d];return this.c[this.d]=w,this.d=(this.d+1)%this.c.length,this.e-=b,this.e+=w,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Nl=L}),function(){function le(r){const P=[];typeof r=="number"&&P.push("code/timeOrigin",r);function L(w){P.push(w,Date.now())}function I(){const w=[];for(let b=0;b<P.length;b+=2)w.push({name:P[b],startTime:P[b+1]});return w}return{mark:L,getMarks:I}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?le():{mark(r){performance.mark(r)},getMarks(){let r=performance.timeOrigin;typeof r!="number"&&(r=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const P=[{name:"code/timeOrigin",startTime:Math.round(r)}];for(const L of performance.getEntriesByType("mark"))P.push({name:L.name,startTime:Math.round(r+L.startTime)});return P}};if(typeof process=="object"){const r=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return le(r)}else return console.trace("perf-util loaded in UNKNOWN environment"),le()}function y(r){return r.MonacoPerformanceMarks||(r.MonacoPerformanceMarks=e()),r.MonacoPerformanceMarks}var R;typeof global=="object"?R=global:typeof self=="object"?R=self:R={},typeof define=="function"?define("vs/base/common/performance",[],function(){return y(R)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=y(R):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),R.perf=y(R))}(),define(we[3],pe([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$C=e.$B=e.$A=e.$z=e.$y=e.$x=e.OS=e.OperatingSystem=e.$v=e.$u=e.$t=e.$s=e.$r=e.Language=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.$h=e.$g=e.$f=e.$e=e.$d=e.$c=e.Platform=e.$b=e.$a=void 0,e.$a="en";let y=!1,R=!1,r=!1,P=!1,L=!1,I=!1,w=!1,b=!1,C=!1,E=!1,v,d=e.$a,g=e.$a,m,l;e.$b=typeof self=="object"?self:typeof global=="object"?global:{};let f;typeof e.$b.vscode<"u"&&typeof e.$b.vscode.process<"u"?f=e.$b.vscode.process:typeof process<"u"&&(f=process);const u=typeof f?.versions?.electron=="string",c=u&&f?.type==="renderer";if(typeof navigator=="object"&&!c){l=navigator.userAgent,y=l.indexOf("Windows")>=0,R=l.indexOf("Macintosh")>=0,b=(l.indexOf("Macintosh")>=0||l.indexOf("iPad")>=0||l.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,r=l.indexOf("Linux")>=0,E=l?.indexOf("Mobi")>=0,I=!0,v=e.$a,d=v,g=navigator.language;const $=typeof document<"u"&&document.getElementById("vscode-remote-nls-configuration"),S=$&&$.getAttribute("data-settings");if(S)try{const D=JSON.parse(S),k=D.availableLanguages["*"];v=D.locale,g=D.osLocale,d=k||e.$a,m=D._translationsConfigFile}catch{}}else if(typeof f=="object"){y=f.platform==="win32",R=f.platform==="darwin",r=f.platform==="linux",P=r&&!!f.env.SNAP&&!!f.env.SNAP_REVISION,w=u,C=!!f.env.CI||!!f.env.BUILD_ARTIFACTSTAGINGDIRECTORY,v=e.$a,d=e.$a;const $=f.env.VSCODE_NLS_CONFIG;if($)try{const S=JSON.parse($),D=S.availableLanguages["*"];v=S.locale,g=S.osLocale,d=D||e.$a,m=S._translationsConfigFile}catch{}L=!0}else console.error("Unable to resolve platform.");var p;(function($){$[$.Web=0]="Web",$[$.Mac=1]="Mac",$[$.Linux=2]="Linux",$[$.Windows=3]="Windows"})(p||(e.Platform=p={}));function h($){switch($){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$c=h;let t=0;R?t=1:y?t=3:r&&(t=2),e.$d=y,e.$e=R,e.$f=r,e.$g=P,e.$h=L,e.$i=w,e.$j=I,e.$k=I&&typeof e.$b.importScripts=="function",e.$l=b,e.$m=E,e.$n=C,e.$o=t,e.$p=l,e.$q=d;var s;(function($){function S(){return e.$q}$.value=S;function D(){return e.$q.length===2?e.$q==="en":e.$q.length>=3?e.$q[0]==="e"&&e.$q[1]==="n"&&e.$q[2]==="-":!1}$.isDefaultVariant=D;function k(){return e.$q==="en"}$.isDefault=k})(s||(e.Language=s={})),e.$r=v,e.$s=g,e.$t=m,e.$u=typeof e.$b.postMessage=="function"&&!e.$b.importScripts,e.$v=(()=>{if(e.$u){const $=[];e.$b.addEventListener("message",D=>{if(D.data&&D.data.vscodeScheduleAsyncWork)for(let k=0,A=$.length;k<A;k++){const j=$[k];if(j.id===D.data.vscodeScheduleAsyncWork){$.splice(k,1),j.callback();return}}});let S=0;return D=>{const k=++S;$.push({id:k,callback:D}),e.$b.postMessage({vscodeScheduleAsyncWork:k},"*")}}return $=>setTimeout($)})();var o;(function($){$[$.Windows=1]="Windows",$[$.Macintosh=2]="Macintosh",$[$.Linux=3]="Linux"})(o||(e.OperatingSystem=o={})),e.OS=R||b?2:y?1:3;let i=!0,n=!1;function a(){if(!n){n=!0;const $=new Uint8Array(2);$[0]=1,$[1]=2,i=new Uint16Array($.buffer)[0]===(2<<8)+1}return i}e.$x=a,e.$y=!!(e.$p&&e.$p.indexOf("Chrome")>=0),e.$z=!!(e.$p&&e.$p.indexOf("Firefox")>=0),e.$A=!!(!e.$y&&e.$p&&e.$p.indexOf("Safari")>=0),e.$B=!!(e.$p&&e.$p.indexOf("Edg/")>=0),e.$C=!!(e.$p&&e.$p.indexOf("Android")>=0)}),define(we[28],pe([1,0,3]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cc=e.$bc=e.env=e.cwd=void 0;let R;if(typeof y.$b.vscode<"u"&&typeof y.$b.vscode.process<"u"){const r=y.$b.vscode.process;R={get platform(){return r.platform},get arch(){return r.arch},get env(){return r.env},cwd(){return r.cwd()}}}else typeof process<"u"?R={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:R={get platform(){return y.$d?"win32":y.$e?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=R.cwd,e.env=R.env,e.$bc=R.platform,e.$cc=R.arch}),define(we[7],pe([1,0,28]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rc=e.sep=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=e.$ec=e.$dc=void 0;const R=65,r=97,P=90,L=122,I=46,w=47,b=92,C=58,E=63;class v extends Error{constructor(s,o,i){let n;typeof o=="string"&&o.indexOf("not ")===0?(n="must not be",o=o.replace(/^not /,"")):n="must be";const a=s.indexOf(".")!==-1?"property":"argument";let $=`The "${s}" ${a} ${n} of type ${o}`;$+=`. Received type ${typeof i}`,super($),this.code="ERR_INVALID_ARG_TYPE"}}function d(t,s){if(t===null||typeof t!="object")throw new v(s,"Object",t)}function g(t,s){if(typeof t!="string")throw new v(s,"string",t)}const m=y.$bc==="win32";function l(t){return t===w||t===b}function f(t){return t===w}function u(t){return t>=R&&t<=P||t>=r&&t<=L}function c(t,s,o,i){let n="",a=0,$=-1,S=0,D=0;for(let k=0;k<=t.length;++k){if(k<t.length)D=t.charCodeAt(k);else{if(i(D))break;D=w}if(i(D)){if(!($===k-1||S===1))if(S===2){if(n.length<2||a!==2||n.charCodeAt(n.length-1)!==I||n.charCodeAt(n.length-2)!==I){if(n.length>2){const A=n.lastIndexOf(o);A===-1?(n="",a=0):(n=n.slice(0,A),a=n.length-1-n.lastIndexOf(o)),$=k,S=0;continue}else if(n.length!==0){n="",a=0,$=k,S=0;continue}}s&&(n+=n.length>0?`${o}..`:"..",a=2)}else n.length>0?n+=`${o}${t.slice($+1,k)}`:n=t.slice($+1,k),a=k-$-1;$=k,S=0}else D===I&&S!==-1?++S:S=-1}return n}function p(t,s){d(s,"pathObject");const o=s.dir||s.root,i=s.base||`${s.name||""}${s.ext||""}`;return o?o===s.root?`${o}${i}`:`${o}${t}${i}`:i}e.$dc={resolve(...t){let s="",o="",i=!1;for(let n=t.length-1;n>=-1;n--){let a;if(n>=0){if(a=t[n],g(a,"path"),a.length===0)continue}else s.length===0?a=y.cwd():(a=y.env[`=${s}`]||y.cwd(),(a===void 0||a.slice(0,2).toLowerCase()!==s.toLowerCase()&&a.charCodeAt(2)===b)&&(a=`${s}\\`));const $=a.length;let S=0,D="",k=!1;const A=a.charCodeAt(0);if($===1)l(A)&&(S=1,k=!0);else if(l(A))if(k=!0,l(a.charCodeAt(1))){let j=2,Z=j;for(;j<$&&!l(a.charCodeAt(j));)j++;if(j<$&&j!==Z){const ae=a.slice(Z,j);for(Z=j;j<$&&l(a.charCodeAt(j));)j++;if(j<$&&j!==Z){for(Z=j;j<$&&!l(a.charCodeAt(j));)j++;(j===$||j!==Z)&&(D=`\\\\${ae}\\${a.slice(Z,j)}`,S=j)}}}else S=1;else u(A)&&a.charCodeAt(1)===C&&(D=a.slice(0,2),S=2,$>2&&l(a.charCodeAt(2))&&(k=!0,S=3));if(D.length>0)if(s.length>0){if(D.toLowerCase()!==s.toLowerCase())continue}else s=D;if(i){if(s.length>0)break}else if(o=`${a.slice(S)}\\${o}`,i=k,k&&s.length>0)break}return o=c(o,!i,"\\",l),i?`${s}\\${o}`:`${s}${o}`||"."},normalize(t){g(t,"path");const s=t.length;if(s===0)return".";let o=0,i,n=!1;const a=t.charCodeAt(0);if(s===1)return f(a)?"\\":t;if(l(a))if(n=!0,l(t.charCodeAt(1))){let S=2,D=S;for(;S<s&&!l(t.charCodeAt(S));)S++;if(S<s&&S!==D){const k=t.slice(D,S);for(D=S;S<s&&l(t.charCodeAt(S));)S++;if(S<s&&S!==D){for(D=S;S<s&&!l(t.charCodeAt(S));)S++;if(S===s)return`\\\\${k}\\${t.slice(D)}\\`;S!==D&&(i=`\\\\${k}\\${t.slice(D,S)}`,o=S)}}}else o=1;else u(a)&&t.charCodeAt(1)===C&&(i=t.slice(0,2),o=2,s>2&&l(t.charCodeAt(2))&&(n=!0,o=3));let $=o<s?c(t.slice(o),!n,"\\",l):"";return $.length===0&&!n&&($="."),$.length>0&&l(t.charCodeAt(s-1))&&($+="\\"),i===void 0?n?`\\${$}`:$:n?`${i}\\${$}`:`${i}${$}`},isAbsolute(t){g(t,"path");const s=t.length;if(s===0)return!1;const o=t.charCodeAt(0);return l(o)||s>2&&u(o)&&t.charCodeAt(1)===C&&l(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let s,o;for(let a=0;a<t.length;++a){const $=t[a];g($,"path"),$.length>0&&(s===void 0?s=o=$:s+=`\\${$}`)}if(s===void 0)return".";let i=!0,n=0;if(typeof o=="string"&&l(o.charCodeAt(0))){++n;const a=o.length;a>1&&l(o.charCodeAt(1))&&(++n,a>2&&(l(o.charCodeAt(2))?++n:i=!1))}if(i){for(;n<s.length&&l(s.charCodeAt(n));)n++;n>=2&&(s=`\\${s.slice(n)}`)}return e.$dc.normalize(s)},relative(t,s){if(g(t,"from"),g(s,"to"),t===s)return"";const o=e.$dc.resolve(t),i=e.$dc.resolve(s);if(o===i||(t=o.toLowerCase(),s=i.toLowerCase(),t===s))return"";let n=0;for(;n<t.length&&t.charCodeAt(n)===b;)n++;let a=t.length;for(;a-1>n&&t.charCodeAt(a-1)===b;)a--;const $=a-n;let S=0;for(;S<s.length&&s.charCodeAt(S)===b;)S++;let D=s.length;for(;D-1>S&&s.charCodeAt(D-1)===b;)D--;const k=D-S,A=$<k?$:k;let j=-1,Z=0;for(;Z<A;Z++){const K=t.charCodeAt(n+Z);if(K!==s.charCodeAt(S+Z))break;K===b&&(j=Z)}if(Z!==A){if(j===-1)return i}else{if(k>A){if(s.charCodeAt(S+Z)===b)return i.slice(S+Z+1);if(Z===2)return i.slice(S+Z)}$>A&&(t.charCodeAt(n+Z)===b?j=Z:Z===2&&(j=3)),j===-1&&(j=0)}let ae="";for(Z=n+j+1;Z<=a;++Z)(Z===a||t.charCodeAt(Z)===b)&&(ae+=ae.length===0?"..":"\\..");return S+=j,ae.length>0?`${ae}${i.slice(S,D)}`:(i.charCodeAt(S)===b&&++S,i.slice(S,D))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const s=e.$dc.resolve(t);if(s.length<=2)return t;if(s.charCodeAt(0)===b){if(s.charCodeAt(1)===b){const o=s.charCodeAt(2);if(o!==E&&o!==I)return`\\\\?\\UNC\\${s.slice(2)}`}}else if(u(s.charCodeAt(0))&&s.charCodeAt(1)===C&&s.charCodeAt(2)===b)return`\\\\?\\${s}`;return t},dirname(t){g(t,"path");const s=t.length;if(s===0)return".";let o=-1,i=0;const n=t.charCodeAt(0);if(s===1)return l(n)?t:".";if(l(n)){if(o=i=1,l(t.charCodeAt(1))){let S=2,D=S;for(;S<s&&!l(t.charCodeAt(S));)S++;if(S<s&&S!==D){for(D=S;S<s&&l(t.charCodeAt(S));)S++;if(S<s&&S!==D){for(D=S;S<s&&!l(t.charCodeAt(S));)S++;if(S===s)return t;S!==D&&(o=i=S+1)}}}}else u(n)&&t.charCodeAt(1)===C&&(o=s>2&&l(t.charCodeAt(2))?3:2,i=o);let a=-1,$=!0;for(let S=s-1;S>=i;--S)if(l(t.charCodeAt(S))){if(!$){a=S;break}}else $=!1;if(a===-1){if(o===-1)return".";a=o}return t.slice(0,a)},basename(t,s){s!==void 0&&g(s,"ext"),g(t,"path");let o=0,i=-1,n=!0,a;if(t.length>=2&&u(t.charCodeAt(0))&&t.charCodeAt(1)===C&&(o=2),s!==void 0&&s.length>0&&s.length<=t.length){if(s===t)return"";let $=s.length-1,S=-1;for(a=t.length-1;a>=o;--a){const D=t.charCodeAt(a);if(l(D)){if(!n){o=a+1;break}}else S===-1&&(n=!1,S=a+1),$>=0&&(D===s.charCodeAt($)?--$===-1&&(i=a):($=-1,i=S))}return o===i?i=S:i===-1&&(i=t.length),t.slice(o,i)}for(a=t.length-1;a>=o;--a)if(l(t.charCodeAt(a))){if(!n){o=a+1;break}}else i===-1&&(n=!1,i=a+1);return i===-1?"":t.slice(o,i)},extname(t){g(t,"path");let s=0,o=-1,i=0,n=-1,a=!0,$=0;t.length>=2&&t.charCodeAt(1)===C&&u(t.charCodeAt(0))&&(s=i=2);for(let S=t.length-1;S>=s;--S){const D=t.charCodeAt(S);if(l(D)){if(!a){i=S+1;break}continue}n===-1&&(a=!1,n=S+1),D===I?o===-1?o=S:$!==1&&($=1):o!==-1&&($=-1)}return o===-1||n===-1||$===0||$===1&&o===n-1&&o===i+1?"":t.slice(o,n)},format:p.bind(null,"\\"),parse(t){g(t,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return s;const o=t.length;let i=0,n=t.charCodeAt(0);if(o===1)return l(n)?(s.root=s.dir=t,s):(s.base=s.name=t,s);if(l(n)){if(i=1,l(t.charCodeAt(1))){let j=2,Z=j;for(;j<o&&!l(t.charCodeAt(j));)j++;if(j<o&&j!==Z){for(Z=j;j<o&&l(t.charCodeAt(j));)j++;if(j<o&&j!==Z){for(Z=j;j<o&&!l(t.charCodeAt(j));)j++;j===o?i=j:j!==Z&&(i=j+1)}}}}else if(u(n)&&t.charCodeAt(1)===C){if(o<=2)return s.root=s.dir=t,s;if(i=2,l(t.charCodeAt(2))){if(o===3)return s.root=s.dir=t,s;i=3}}i>0&&(s.root=t.slice(0,i));let a=-1,$=i,S=-1,D=!0,k=t.length-1,A=0;for(;k>=i;--k){if(n=t.charCodeAt(k),l(n)){if(!D){$=k+1;break}continue}S===-1&&(D=!1,S=k+1),n===I?a===-1?a=k:A!==1&&(A=1):a!==-1&&(A=-1)}return S!==-1&&(a===-1||A===0||A===1&&a===S-1&&a===$+1?s.base=s.name=t.slice($,S):(s.name=t.slice($,a),s.base=t.slice($,S),s.ext=t.slice(a,S))),$>0&&$!==i?s.dir=t.slice(0,$-1):s.dir=s.root,s},sep:"\\",delimiter:";",win32:null,posix:null};const h=(()=>{if(m){const t=/\\/g;return()=>{const s=y.cwd().replace(t,"/");return s.slice(s.indexOf("/"))}}return()=>y.cwd()})();e.$ec={resolve(...t){let s="",o=!1;for(let i=t.length-1;i>=-1&&!o;i--){const n=i>=0?t[i]:h();g(n,"path"),n.length!==0&&(s=`${n}/${s}`,o=n.charCodeAt(0)===w)}return s=c(s,!o,"/",f),o?`/${s}`:s.length>0?s:"."},normalize(t){if(g(t,"path"),t.length===0)return".";const s=t.charCodeAt(0)===w,o=t.charCodeAt(t.length-1)===w;return t=c(t,!s,"/",f),t.length===0?s?"/":o?"./":".":(o&&(t+="/"),s?`/${t}`:t)},isAbsolute(t){return g(t,"path"),t.length>0&&t.charCodeAt(0)===w},join(...t){if(t.length===0)return".";let s;for(let o=0;o<t.length;++o){const i=t[o];g(i,"path"),i.length>0&&(s===void 0?s=i:s+=`/${i}`)}return s===void 0?".":e.$ec.normalize(s)},relative(t,s){if(g(t,"from"),g(s,"to"),t===s||(t=e.$ec.resolve(t),s=e.$ec.resolve(s),t===s))return"";const o=1,i=t.length,n=i-o,a=1,$=s.length-a,S=n<$?n:$;let D=-1,k=0;for(;k<S;k++){const j=t.charCodeAt(o+k);if(j!==s.charCodeAt(a+k))break;j===w&&(D=k)}if(k===S)if($>S){if(s.charCodeAt(a+k)===w)return s.slice(a+k+1);if(k===0)return s.slice(a+k)}else n>S&&(t.charCodeAt(o+k)===w?D=k:k===0&&(D=0));let A="";for(k=o+D+1;k<=i;++k)(k===i||t.charCodeAt(k)===w)&&(A+=A.length===0?"..":"/..");return`${A}${s.slice(a+D)}`},toNamespacedPath(t){return t},dirname(t){if(g(t,"path"),t.length===0)return".";const s=t.charCodeAt(0)===w;let o=-1,i=!0;for(let n=t.length-1;n>=1;--n)if(t.charCodeAt(n)===w){if(!i){o=n;break}}else i=!1;return o===-1?s?"/":".":s&&o===1?"//":t.slice(0,o)},basename(t,s){s!==void 0&&g(s,"ext"),g(t,"path");let o=0,i=-1,n=!0,a;if(s!==void 0&&s.length>0&&s.length<=t.length){if(s===t)return"";let $=s.length-1,S=-1;for(a=t.length-1;a>=0;--a){const D=t.charCodeAt(a);if(D===w){if(!n){o=a+1;break}}else S===-1&&(n=!1,S=a+1),$>=0&&(D===s.charCodeAt($)?--$===-1&&(i=a):($=-1,i=S))}return o===i?i=S:i===-1&&(i=t.length),t.slice(o,i)}for(a=t.length-1;a>=0;--a)if(t.charCodeAt(a)===w){if(!n){o=a+1;break}}else i===-1&&(n=!1,i=a+1);return i===-1?"":t.slice(o,i)},extname(t){g(t,"path");let s=-1,o=0,i=-1,n=!0,a=0;for(let $=t.length-1;$>=0;--$){const S=t.charCodeAt($);if(S===w){if(!n){o=$+1;break}continue}i===-1&&(n=!1,i=$+1),S===I?s===-1?s=$:a!==1&&(a=1):s!==-1&&(a=-1)}return s===-1||i===-1||a===0||a===1&&s===i-1&&s===o+1?"":t.slice(s,i)},format:p.bind(null,"/"),parse(t){g(t,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return s;const o=t.charCodeAt(0)===w;let i;o?(s.root="/",i=1):i=0;let n=-1,a=0,$=-1,S=!0,D=t.length-1,k=0;for(;D>=i;--D){const A=t.charCodeAt(D);if(A===w){if(!S){a=D+1;break}continue}$===-1&&(S=!1,$=D+1),A===I?n===-1?n=D:k!==1&&(k=1):n!==-1&&(k=-1)}if($!==-1){const A=a===0&&o?1:a;n===-1||k===0||k===1&&n===$-1&&n===a+1?s.base=s.name=t.slice(A,$):(s.name=t.slice(A,n),s.base=t.slice(A,$),s.ext=t.slice(n,$))}return a>0?s.dir=t.slice(0,a-1):o&&(s.dir="/"),s},sep:"/",delimiter:":",win32:null,posix:null},e.$ec.win32=e.$dc.win32=e.$dc,e.$ec.posix=e.$dc.posix=e.$ec,e.$fc=m?e.$dc.normalize:e.$ec.normalize,e.$gc=m?e.$dc.isAbsolute:e.$ec.isAbsolute,e.$hc=m?e.$dc.join:e.$ec.join,e.$ic=m?e.$dc.resolve:e.$ec.resolve,e.$jc=m?e.$dc.relative:e.$ec.relative,e.$kc=m?e.$dc.dirname:e.$ec.dirname,e.$lc=m?e.$dc.basename:e.$ec.basename,e.$mc=m?e.$dc.extname:e.$ec.extname,e.$nc=m?e.$dc.format:e.$ec.format,e.$oc=m?e.$dc.parse:e.$ec.parse,e.$pc=m?e.$dc.toNamespacedPath:e.$ec.toNamespacedPath,e.sep=m?e.$dc.sep:e.$ec.sep,e.$rc=m?e.$dc.delimiter:e.$ec.delimiter}),define(we[58],pe([1,0,7]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nr=e.$Mr=e.$Lr=e.$Kr=e.$Jr=void 0,e.$Jr=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const R={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},r={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function P(C){const E=(0,y.$mc)(C),v=R[E.toLowerCase()];return v!==void 0?v:L(C)}e.$Kr=P;function L(C){const E=(0,y.$mc)(C);return r[E.toLowerCase()]}e.$Lr=L;function I(C){for(const E in r)if(r[E]===C)return E}e.$Mr=I;const w=/^(.+)\/(.+?)(;.+)?$/;function b(C,E){const v=w.exec(C);return v?`${v[1].toLowerCase()}/${v[2].toLowerCase()}${v[3]??""}`:E?void 0:C}e.$Nr=b}),define(we[59],pe([1,0,3]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vl=e.$ul=e.TerminateResponseCode=e.Source=void 0;var R;(function(I){I[I.stdout=0]="stdout",I[I.stderr=1]="stderr"})(R||(e.Source=R={}));var r;(function(I){I[I.Success=0]="Success",I[I.Unknown=1]="Unknown",I[I.AccessDenied=2]="AccessDenied",I[I.ProcessNotFound=3]="ProcessNotFound"})(r||(e.TerminateResponseCode=r={}));function P(I,...w){const b=w.reduce((v,d)=>(v[d]=!0,v),{}),C=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/,/^CODE_SERVER_.+$/,/^CS_.+$/];Object.keys(I).filter(v=>!b[v]).forEach(v=>{for(let d=0;d<C.length;d++)if(v.search(C[d])!==-1){delete I[v];break}})}e.$ul=P;function L(I){I&&(delete I.DEBUG,y.$e&&delete I.DYLD_LIBRARY_PATH,y.$f&&delete I.LD_PRELOAD)}e.$vl=L}),function(le,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var y=e();for(var R in y)(typeof exports=="object"?exports:le)[R]=y[R]}}(typeof self<"u"?self:this,function(){return function(le){var e={};function y(R){if(e[R])return e[R].exports;var r=e[R]={i:R,l:!1,exports:{}};return le[R].call(r.exports,r,r.exports,y),r.l=!0,r.exports}return y.m=le,y.c=e,y.d=function(R,r,P){y.o(R,r)||Object.defineProperty(R,r,{enumerable:!0,get:P})},y.r=function(R){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(R,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(R,"__esModule",{value:!0})},y.t=function(R,r){if(1&r&&(R=y(R)),8&r||4&r&&typeof R=="object"&&R&&R.__esModule)return R;var P=Object.create(null);if(y.r(P),Object.defineProperty(P,"default",{enumerable:!0,value:R}),2&r&&typeof R!="string")for(var L in R)y.d(P,L,function(I){return R[I]}.bind(null,L));return P},y.n=function(R){var r=R&&R.__esModule?function(){return R.default}:function(){return R};return y.d(r,"a",r),r},y.o=function(R,r){return Object.prototype.hasOwnProperty.call(R,r)},y.p="",y(y.s=0)}([function(le,e,y){(function(R){var r;e=le.exports=B,r=typeof R=="object"&&R.env&&R.env.NODE_DEBUG&&/\bsemver\b/i.test(R.env.NODE_DEBUG)?function(){var $e=Array.prototype.slice.call(arguments,0);$e.unshift("SEMVER"),console.log.apply(console,$e)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var P=256,L=Number.MAX_SAFE_INTEGER||9007199254740991,I=e.re=[],w=e.src=[],b=0,C=b++;w[C]="0|[1-9]\\d*";var E=b++;w[E]="[0-9]+";var v=b++;w[v]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var d=b++;w[d]="("+w[C]+")\\.("+w[C]+")\\.("+w[C]+")";var g=b++;w[g]="("+w[E]+")\\.("+w[E]+")\\.("+w[E]+")";var m=b++;w[m]="(?:"+w[C]+"|"+w[v]+")";var l=b++;w[l]="(?:"+w[E]+"|"+w[v]+")";var f=b++;w[f]="(?:-("+w[m]+"(?:\\."+w[m]+")*))";var u=b++;w[u]="(?:-?("+w[l]+"(?:\\."+w[l]+")*))";var c=b++;w[c]="[0-9A-Za-z-]+";var p=b++;w[p]="(?:\\+("+w[c]+"(?:\\."+w[c]+")*))";var h=b++,t="v?"+w[d]+w[f]+"?"+w[p]+"?";w[h]="^"+t+"$";var s="[v=\\s]*"+w[g]+w[u]+"?"+w[p]+"?",o=b++;w[o]="^"+s+"$";var i=b++;w[i]="((?:<|>)?=?)";var n=b++;w[n]=w[E]+"|x|X|\\*";var a=b++;w[a]=w[C]+"|x|X|\\*";var $=b++;w[$]="[v=\\s]*("+w[a]+")(?:\\.("+w[a]+")(?:\\.("+w[a]+")(?:"+w[f]+")?"+w[p]+"?)?)?";var S=b++;w[S]="[v=\\s]*("+w[n]+")(?:\\.("+w[n]+")(?:\\.("+w[n]+")(?:"+w[u]+")?"+w[p]+"?)?)?";var D=b++;w[D]="^"+w[i]+"\\s*"+w[$]+"$";var k=b++;w[k]="^"+w[i]+"\\s*"+w[S]+"$";var A=b++;w[A]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var j=b++;w[j]="(?:~>?)";var Z=b++;w[Z]="(\\s*)"+w[j]+"\\s+",I[Z]=new RegExp(w[Z],"g");var ae=b++;w[ae]="^"+w[j]+w[$]+"$";var K=b++;w[K]="^"+w[j]+w[S]+"$";var se=b++;w[se]="(?:\\^)";var ue=b++;w[ue]="(\\s*)"+w[se]+"\\s+",I[ue]=new RegExp(w[ue],"g");var x=b++;w[x]="^"+w[se]+w[$]+"$";var he=b++;w[he]="^"+w[se]+w[S]+"$";var V=b++;w[V]="^"+w[i]+"\\s*("+s+")$|^$";var te=b++;w[te]="^"+w[i]+"\\s*("+t+")$|^$";var G=b++;w[G]="(\\s*)"+w[i]+"\\s*("+s+"|"+w[$]+")",I[G]=new RegExp(w[G],"g");var J=b++;w[J]="^\\s*("+w[$]+")\\s+-\\s+("+w[$]+")\\s*$";var q=b++;w[q]="^\\s*("+w[S]+")\\s+-\\s+("+w[S]+")\\s*$";var ne=b++;w[ne]="(<|>)?=?\\s*\\*";for(var me=0;me<35;me++)r(me,w[me]),I[me]||(I[me]=new RegExp(w[me]));function re($e,ke){if($e instanceof B)return $e;if(typeof $e!="string"||$e.length>P||!(ke?I[o]:I[h]).test($e))return null;try{return new B($e,ke)}catch{return null}}function B($e,ke){if($e instanceof B){if($e.loose===ke)return $e;$e=$e.version}else if(typeof $e!="string")throw new TypeError("Invalid Version: "+$e);if($e.length>P)throw new TypeError("version is longer than "+P+" characters");if(!(this instanceof B))return new B($e,ke);r("SemVer",$e,ke),this.loose=ke;var ve=$e.trim().match(ke?I[o]:I[h]);if(!ve)throw new TypeError("Invalid Version: "+$e);if(this.raw=$e,this.major=+ve[1],this.minor=+ve[2],this.patch=+ve[3],this.major>L||this.major<0)throw new TypeError("Invalid major version");if(this.minor>L||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>L||this.patch<0)throw new TypeError("Invalid patch version");ve[4]?this.prerelease=ve[4].split(".").map(function(Me){if(/^[0-9]+$/.test(Me)){var Ue=+Me;if(Ue>=0&&Ue<L)return Ue}return Me}):this.prerelease=[],this.build=ve[5]?ve[5].split("."):[],this.format()}e.parse=re,e.valid=function($e,ke){var ve=re($e,ke);return ve?ve.version:null},e.clean=function($e,ke){var ve=re($e.trim().replace(/^[=v]+/,""),ke);return ve?ve.version:null},e.SemVer=B,B.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},B.prototype.toString=function(){return this.version},B.prototype.compare=function($e){return r("SemVer.compare",this.version,this.loose,$e),$e instanceof B||($e=new B($e,this.loose)),this.compareMain($e)||this.comparePre($e)},B.prototype.compareMain=function($e){return $e instanceof B||($e=new B($e,this.loose)),O(this.major,$e.major)||O(this.minor,$e.minor)||O(this.patch,$e.patch)},B.prototype.comparePre=function($e){if($e instanceof B||($e=new B($e,this.loose)),this.prerelease.length&&!$e.prerelease.length)return-1;if(!this.prerelease.length&&$e.prerelease.length)return 1;if(!this.prerelease.length&&!$e.prerelease.length)return 0;var ke=0;do{var ve=this.prerelease[ke],Me=$e.prerelease[ke];if(r("prerelease compare",ke,ve,Me),ve===void 0&&Me===void 0)return 0;if(Me===void 0)return 1;if(ve===void 0)return-1;if(ve!==Me)return O(ve,Me)}while(++ke)},B.prototype.inc=function($e,ke){switch($e){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ke);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ke);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ke),this.inc("pre",ke);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ke),this.inc("pre",ke);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ve=this.prerelease.length;--ve>=0;)typeof this.prerelease[ve]=="number"&&(this.prerelease[ve]++,ve=-2);ve===-1&&this.prerelease.push(0)}ke&&(this.prerelease[0]===ke?isNaN(this.prerelease[1])&&(this.prerelease=[ke,0]):this.prerelease=[ke,0]);break;default:throw new Error("invalid increment argument: "+$e)}return this.format(),this.raw=this.version,this},e.inc=function($e,ke,ve,Me){typeof ve=="string"&&(Me=ve,ve=void 0);try{return new B($e,ve).inc(ke,Me).version}catch{return null}},e.diff=function($e,ke){if(H($e,ke))return null;var ve=re($e),Me=re(ke);if(ve.prerelease.length||Me.prerelease.length){for(var Ue in ve)if((Ue==="major"||Ue==="minor"||Ue==="patch")&&ve[Ue]!==Me[Ue])return"pre"+Ue;return"prerelease"}for(var Ue in ve)if((Ue==="major"||Ue==="minor"||Ue==="patch")&&ve[Ue]!==Me[Ue])return Ue},e.compareIdentifiers=O;var ee=/^[0-9]+$/;function O($e,ke){var ve=ee.test($e),Me=ee.test(ke);return ve&&Me&&($e=+$e,ke=+ke),ve&&!Me?-1:Me&&!ve?1:$e<ke?-1:$e>ke?1:0}function N($e,ke,ve){return new B($e,ve).compare(new B(ke,ve))}function Q($e,ke,ve){return N($e,ke,ve)>0}function T($e,ke,ve){return N($e,ke,ve)<0}function H($e,ke,ve){return N($e,ke,ve)===0}function U($e,ke,ve){return N($e,ke,ve)!==0}function ie($e,ke,ve){return N($e,ke,ve)>=0}function z($e,ke,ve){return N($e,ke,ve)<=0}function _($e,ke,ve,Me){var Ue;switch(ke){case"===":typeof $e=="object"&&($e=$e.version),typeof ve=="object"&&(ve=ve.version),Ue=$e===ve;break;case"!==":typeof $e=="object"&&($e=$e.version),typeof ve=="object"&&(ve=ve.version),Ue=$e!==ve;break;case"":case"=":case"==":Ue=H($e,ve,Me);break;case"!=":Ue=U($e,ve,Me);break;case">":Ue=Q($e,ve,Me);break;case">=":Ue=ie($e,ve,Me);break;case"<":Ue=T($e,ve,Me);break;case"<=":Ue=z($e,ve,Me);break;default:throw new TypeError("Invalid operator: "+ke)}return Ue}function W($e,ke){if($e instanceof W){if($e.loose===ke)return $e;$e=$e.value}if(!(this instanceof W))return new W($e,ke);r("comparator",$e,ke),this.loose=ke,this.parse($e),this.semver===X?this.value="":this.value=this.operator+this.semver.version,r("comp",this)}e.rcompareIdentifiers=function($e,ke){return O(ke,$e)},e.major=function($e,ke){return new B($e,ke).major},e.minor=function($e,ke){return new B($e,ke).minor},e.patch=function($e,ke){return new B($e,ke).patch},e.compare=N,e.compareLoose=function($e,ke){return N($e,ke,!0)},e.rcompare=function($e,ke,ve){return N(ke,$e,ve)},e.sort=function($e,ke){return $e.sort(function(ve,Me){return e.compare(ve,Me,ke)})},e.rsort=function($e,ke){return $e.sort(function(ve,Me){return e.rcompare(ve,Me,ke)})},e.gt=Q,e.lt=T,e.eq=H,e.neq=U,e.gte=ie,e.lte=z,e.cmp=_,e.Comparator=W;var X={};function oe($e,ke){if($e instanceof oe)return $e.loose===ke?$e:new oe($e.raw,ke);if($e instanceof W)return new oe($e.value,ke);if(!(this instanceof oe))return new oe($e,ke);if(this.loose=ke,this.raw=$e,this.set=$e.split(/\s*\|\|\s*/).map(function(ve){return this.parseRange(ve.trim())},this).filter(function(ve){return ve.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+$e);this.format()}function ge($e){return!$e||$e.toLowerCase()==="x"||$e==="*"}function Ee($e,ke,ve,Me,Ue,Ye,qe,Je,Ze,xe,de,Se,Ie){return((ke=ge(ve)?"":ge(Me)?">="+ve+".0.0":ge(Ue)?">="+ve+"."+Me+".0":">="+ke)+" "+(Je=ge(Ze)?"":ge(xe)?"<"+(+Ze+1)+".0.0":ge(de)?"<"+Ze+"."+(+xe+1)+".0":Se?"<="+Ze+"."+xe+"."+de+"-"+Se:"<="+Je)).trim()}function Pe($e,ke){for(var ve=0;ve<$e.length;ve++)if(!$e[ve].test(ke))return!1;if(ke.prerelease.length){for(ve=0;ve<$e.length;ve++)if(r($e[ve].semver),$e[ve].semver!==X&&$e[ve].semver.prerelease.length>0){var Me=$e[ve].semver;if(Me.major===ke.major&&Me.minor===ke.minor&&Me.patch===ke.patch)return!0}return!1}return!0}function Ne($e,ke,ve){try{ke=new oe(ke,ve)}catch{return!1}return ke.test($e)}function Fe($e,ke,ve,Me){var Ue,Ye,qe,Je,Ze;switch($e=new B($e,Me),ke=new oe(ke,Me),ve){case">":Ue=Q,Ye=z,qe=T,Je=">",Ze=">=";break;case"<":Ue=T,Ye=ie,qe=Q,Je="<",Ze="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ne($e,ke,Me))return!1;for(var xe=0;xe<ke.set.length;++xe){var de=ke.set[xe],Se=null,Ie=null;if(de.forEach(function(Le){Le.semver===X&&(Le=new W(">=0.0.0")),Se=Se||Le,Ie=Ie||Le,Ue(Le.semver,Se.semver,Me)?Se=Le:qe(Le.semver,Ie.semver,Me)&&(Ie=Le)}),Se.operator===Je||Se.operator===Ze||(!Ie.operator||Ie.operator===Je)&&Ye($e,Ie.semver)||Ie.operator===Ze&&qe($e,Ie.semver))return!1}return!0}W.prototype.parse=function($e){var ke=this.loose?I[V]:I[te],ve=$e.match(ke);if(!ve)throw new TypeError("Invalid comparator: "+$e);this.operator=ve[1],this.operator==="="&&(this.operator=""),ve[2]?this.semver=new B(ve[2],this.loose):this.semver=X},W.prototype.toString=function(){return this.value},W.prototype.test=function($e){return r("Comparator.test",$e,this.loose),this.semver===X||(typeof $e=="string"&&($e=new B($e,this.loose)),_($e,this.operator,this.semver,this.loose))},W.prototype.intersects=function($e,ke){if(!($e instanceof W))throw new TypeError("a Comparator is required");var ve;if(this.operator==="")return ve=new oe($e.value,ke),Ne(this.value,ve,ke);if($e.operator==="")return ve=new oe(this.value,ke),Ne($e.semver,ve,ke);var Me=!(this.operator!==">="&&this.operator!==">"||$e.operator!==">="&&$e.operator!==">"),Ue=!(this.operator!=="<="&&this.operator!=="<"||$e.operator!=="<="&&$e.operator!=="<"),Ye=this.semver.version===$e.semver.version,qe=!(this.operator!==">="&&this.operator!=="<="||$e.operator!==">="&&$e.operator!=="<="),Je=_(this.semver,"<",$e.semver,ke)&&(this.operator===">="||this.operator===">")&&($e.operator==="<="||$e.operator==="<"),Ze=_(this.semver,">",$e.semver,ke)&&(this.operator==="<="||this.operator==="<")&&($e.operator===">="||$e.operator===">");return Me||Ue||Ye&&qe||Je||Ze},e.Range=oe,oe.prototype.format=function(){return this.range=this.set.map(function($e){return $e.join(" ").trim()}).join("||").trim(),this.range},oe.prototype.toString=function(){return this.range},oe.prototype.parseRange=function($e){var ke=this.loose;$e=$e.trim(),r("range",$e,ke);var ve=ke?I[q]:I[J];$e=$e.replace(ve,Ee),r("hyphen replace",$e),$e=$e.replace(I[G],"$1$2$3"),r("comparator trim",$e,I[G]),$e=($e=($e=$e.replace(I[Z],"$1~")).replace(I[ue],"$1^")).split(/\s+/).join(" ");var Me=ke?I[V]:I[te],Ue=$e.split(" ").map(function(Ye){return function(qe,Je){return r("comp",qe),qe=function(Ze,xe){return Ze.trim().split(/\s+/).map(function(de){return function(Se,Ie){r("caret",Se,Ie);var Le=Ie?I[he]:I[x];return Se.replace(Le,function(Be,ze,He,Ge,Qe){var We;return r("caret",Se,Be,ze,He,Ge,Qe),ge(ze)?We="":ge(He)?We=">="+ze+".0.0 <"+(+ze+1)+".0.0":ge(Ge)?We=ze==="0"?">="+ze+"."+He+".0 <"+ze+"."+(+He+1)+".0":">="+ze+"."+He+".0 <"+(+ze+1)+".0.0":Qe?(r("replaceCaret pr",Qe),Qe.charAt(0)!=="-"&&(Qe="-"+Qe),We=ze==="0"?He==="0"?">="+ze+"."+He+"."+Ge+Qe+" <"+ze+"."+He+"."+(+Ge+1):">="+ze+"."+He+"."+Ge+Qe+" <"+ze+"."+(+He+1)+".0":">="+ze+"."+He+"."+Ge+Qe+" <"+(+ze+1)+".0.0"):(r("no pr"),We=ze==="0"?He==="0"?">="+ze+"."+He+"."+Ge+" <"+ze+"."+He+"."+(+Ge+1):">="+ze+"."+He+"."+Ge+" <"+ze+"."+(+He+1)+".0":">="+ze+"."+He+"."+Ge+" <"+(+ze+1)+".0.0"),r("caret return",We),We})}(de,xe)}).join(" ")}(qe,Je),r("caret",qe),qe=function(Ze,xe){return Ze.trim().split(/\s+/).map(function(de){return function(Se,Ie){var Le=Ie?I[K]:I[ae];return Se.replace(Le,function(Be,ze,He,Ge,Qe){var We;return r("tilde",Se,Be,ze,He,Ge,Qe),ge(ze)?We="":ge(He)?We=">="+ze+".0.0 <"+(+ze+1)+".0.0":ge(Ge)?We=">="+ze+"."+He+".0 <"+ze+"."+(+He+1)+".0":Qe?(r("replaceTilde pr",Qe),Qe.charAt(0)!=="-"&&(Qe="-"+Qe),We=">="+ze+"."+He+"."+Ge+Qe+" <"+ze+"."+(+He+1)+".0"):We=">="+ze+"."+He+"."+Ge+" <"+ze+"."+(+He+1)+".0",r("tilde return",We),We})}(de,xe)}).join(" ")}(qe,Je),r("tildes",qe),qe=function(Ze,xe){return r("replaceXRanges",Ze,xe),Ze.split(/\s+/).map(function(de){return function(Se,Ie){Se=Se.trim();var Le=Ie?I[k]:I[D];return Se.replace(Le,function(Be,ze,He,Ge,Qe,We){r("xRange",Se,Be,ze,He,Ge,Qe,We);var st=ge(He),rt=st||ge(Ge),et=rt||ge(Qe);return ze==="="&&et&&(ze=""),st?Be=ze===">"||ze==="<"?"<0.0.0":"*":ze&&et?(rt&&(Ge=0),et&&(Qe=0),ze===">"?(ze=">=",rt?(He=+He+1,Ge=0,Qe=0):et&&(Ge=+Ge+1,Qe=0)):ze==="<="&&(ze="<",rt?He=+He+1:Ge=+Ge+1),Be=ze+He+"."+Ge+"."+Qe):rt?Be=">="+He+".0.0 <"+(+He+1)+".0.0":et&&(Be=">="+He+"."+Ge+".0 <"+He+"."+(+Ge+1)+".0"),r("xRange return",Be),Be})}(de,xe)}).join(" ")}(qe,Je),r("xrange",qe),qe=function(Ze,xe){return r("replaceStars",Ze,xe),Ze.trim().replace(I[ne],"")}(qe,Je),r("stars",qe),qe}(Ye,ke)}).join(" ").split(/\s+/);return this.loose&&(Ue=Ue.filter(function(Ye){return!!Ye.match(Me)})),Ue=Ue.map(function(Ye){return new W(Ye,ke)})},oe.prototype.intersects=function($e,ke){if(!($e instanceof oe))throw new TypeError("a Range is required");return this.set.some(function(ve){return ve.every(function(Me){return $e.set.some(function(Ue){return Ue.every(function(Ye){return Me.intersects(Ye,ke)})})})})},e.toComparators=function($e,ke){return new oe($e,ke).set.map(function(ve){return ve.map(function(Me){return Me.value}).join(" ").trim().split(" ")})},oe.prototype.test=function($e){if(!$e)return!1;typeof $e=="string"&&($e=new B($e,this.loose));for(var ke=0;ke<this.set.length;ke++)if(Pe(this.set[ke],$e))return!0;return!1},e.satisfies=Ne,e.maxSatisfying=function($e,ke,ve){var Me=null,Ue=null;try{var Ye=new oe(ke,ve)}catch{return null}return $e.forEach(function(qe){Ye.test(qe)&&(Me&&Ue.compare(qe)!==-1||(Ue=new B(Me=qe,ve)))}),Me},e.minSatisfying=function($e,ke,ve){var Me=null,Ue=null;try{var Ye=new oe(ke,ve)}catch{return null}return $e.forEach(function(qe){Ye.test(qe)&&(Me&&Ue.compare(qe)!==1||(Ue=new B(Me=qe,ve)))}),Me},e.validRange=function($e,ke){try{return new oe($e,ke).range||"*"}catch{return null}},e.ltr=function($e,ke,ve){return Fe($e,ke,"<",ve)},e.gtr=function($e,ke,ve){return Fe($e,ke,">",ve)},e.outside=Fe,e.prerelease=function($e,ke){var ve=re($e,ke);return ve&&ve.prerelease.length?ve.prerelease:null},e.intersects=function($e,ke,ve){return $e=new oe($e,ve),ke=new oe(ke,ve),$e.intersects(ke)},e.coerce=function($e){if($e instanceof B)return $e;if(typeof $e!="string")return null;var ke=$e.match(I[A]);return ke==null?null:re((ke[1]||"0")+"."+(ke[2]||"0")+"."+(ke[3]||"0"))}}).call(this,y(1))},function(le,e){var y,R,r=le.exports={};function P(){throw new Error("setTimeout has not been defined")}function L(){throw new Error("clearTimeout has not been defined")}function I(l){if(y===setTimeout)return setTimeout(l,0);if((y===P||!y)&&setTimeout)return y=setTimeout,setTimeout(l,0);try{return y(l,0)}catch{try{return y.call(null,l,0)}catch{return y.call(this,l,0)}}}(function(){try{y=typeof setTimeout=="function"?setTimeout:P}catch{y=P}try{R=typeof clearTimeout=="function"?clearTimeout:L}catch{R=L}})();var w,b=[],C=!1,E=-1;function v(){C&&w&&(C=!1,w.length?b=w.concat(b):E=-1,b.length&&d())}function d(){if(!C){var l=I(v);C=!0;for(var f=b.length;f;){for(w=b,b=[];++E<f;)w&&w[E].run();E=-1,f=b.length}w=null,C=!1,function(u){if(R===clearTimeout)return clearTimeout(u);if((R===L||!R)&&clearTimeout)return R=clearTimeout,clearTimeout(u);try{R(u)}catch{try{return R.call(null,u)}catch{return R.call(this,u)}}}(l)}}function g(l,f){this.fun=l,this.array=f}function m(){}r.nextTick=function(l){var f=new Array(arguments.length-1);if(arguments.length>1)for(var u=1;u<arguments.length;u++)f[u-1]=arguments[u];b.push(new g(l,f)),b.length!==1||C||I(d)},g.prototype.run=function(){this.fun.apply(null,this.array)},r.title="browser",r.browser=!0,r.env={},r.argv=[],r.version="",r.versions={},r.on=m,r.addListener=m,r.once=m,r.off=m,r.removeListener=m,r.removeAllListeners=m,r.emit=m,r.prependListener=m,r.prependOnceListener=m,r.listeners=function(l){return[]},r.binding=function(l){throw new Error("process.binding is not supported")},r.cwd=function(){return"/"},r.chdir=function(l){throw new Error("process.chdir is not supported")},r.umask=function(){return 0}}])}),define(we[145],pe([1,0]),function(le,e){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.$qr=void 0;class R{constructor(I,w,b){this.level=I,this.key=w,this.value=b,this.forward=[]}}const r=void 0;class P{constructor(I,w=2**16){this.comparator=I,this[y]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(w)|0),this.e=new R(this.c,r,r)}get size(){return this.f}clear(){this.e=new R(this.c,r,r)}has(I){return!!P.g(this,I,this.comparator)}get(I){return P.g(this,I,this.comparator)?.value}set(I,w){return P.h(this,I,w,this.comparator)&&(this.f+=1),this}delete(I){const w=P.k(this,I,this.comparator);return w&&(this.f-=1),w}forEach(I,w){let b=this.e.forward[0];for(;b;)I.call(w,b.value,b.key,this),b=b.forward[0]}[(y=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let I=this.e.forward[0];for(;I;)yield[I.key,I.value],I=I.forward[0]}*keys(){let I=this.e.forward[0];for(;I;)yield I.key,I=I.forward[0]}*values(){let I=this.e.forward[0];for(;I;)yield I.value,I=I.forward[0]}toString(){let I="[SkipList]:",w=this.e.forward[0];for(;w;)I+=`node(${w.key}, ${w.value}, lvl:${w.level})`,w=w.forward[0];return I}static g(I,w,b){let C=I.e;for(let E=I.d-1;E>=0;E--)for(;C.forward[E]&&b(C.forward[E].key,w)<0;)C=C.forward[E];if(C=C.forward[0],C&&b(C.key,w)===0)return C}static h(I,w,b,C){const E=[];let v=I.e;for(let d=I.d-1;d>=0;d--){for(;v.forward[d]&&C(v.forward[d].key,w)<0;)v=v.forward[d];E[d]=v}if(v=v.forward[0],v&&C(v.key,w)===0)return v.value=b,!1;{const d=P.j(I);if(d>I.d){for(let g=I.d;g<d;g++)E[g]=I.e;I.d=d}v=new R(d,w,b);for(let g=0;g<d;g++)v.forward[g]=E[g].forward[g],E[g].forward[g]=v;return!0}}static j(I,w=.5){let b=1;for(;Math.random()<w&&b<I.c;)b+=1;return b}static k(I,w,b){const C=[];let E=I.e;for(let v=I.d-1;v>=0;v--){for(;E.forward[v]&&b(E.forward[v].key,w)<0;)E=E.forward[v];C[v]=E}if(E=E.forward[0],!E||b(E.key,w)!==0)return!1;for(let v=0;v<I.d&&C[v].forward[v]===E;v++)C[v].forward[v]=E.forward[v];for(;I.d>0&&I.e.forward[I.d-1]===r;)I.d-=1;return!0}}e.$qr=P}),define(we[60],pe([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hd=void 0;const y=globalThis.performance&&typeof globalThis.performance.now=="function";class R{static create(P){return new R(P)}constructor(P){this.c=y&&P===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$Hd=R}),define(we[5],pe([1,0,11,74,2,97,60]),function(le,e,y,R,r,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ud=e.$Td=e.$Sd=e.$Rd=e.$Qd=e.$Pd=e.$Od=e.$Nd=e.$Md=e.$Ld=e.$Kd=e.$Jd=e.Event=void 0;const I=!1,w=!1;var b;(function(D){D.None=()=>r.$Qc.None;function k(_){if(w){const{onDidAddListener:W}=_,X=g.create();let oe=0;_.onDidAddListener=()=>{++oe===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),X.print()),W?.()}}}function A(_,W){return te(_,()=>{},0,void 0,!0,void 0,W)}D.defer=A;function j(_){return(W,X=null,oe)=>{let ge=!1,Ee;return Ee=_(Pe=>{if(!ge)return Ee?Ee.dispose():ge=!0,W.call(X,Pe)},null,oe),ge&&Ee.dispose(),Ee}}D.once=j;function Z(_,W,X){return he((oe,ge=null,Ee)=>_(Pe=>oe.call(ge,W(Pe)),null,Ee),X)}D.map=Z;function ae(_,W,X){return he((oe,ge=null,Ee)=>_(Pe=>{W(Pe),oe.call(ge,Pe)},null,Ee),X)}D.forEach=ae;function K(_,W,X){return he((oe,ge=null,Ee)=>_(Pe=>W(Pe)&&oe.call(ge,Pe),null,Ee),X)}D.filter=K;function se(_){return _}D.signal=se;function ue(..._){return(W,X=null,oe)=>{const ge=(0,r.$Nc)(..._.map(Ee=>Ee(Pe=>W.call(X,Pe))));return V(ge,oe)}}D.any=ue;function x(_,W,X,oe){let ge=X;return Z(_,Ee=>(ge=W(ge,Ee),ge),oe)}D.reduce=x;function he(_,W){let X;const oe={onWillAddFirstListener(){X=_(ge.fire,ge)},onDidRemoveLastListener(){X?.dispose()}};W||k(oe);const ge=new c(oe);return W?.add(ge),ge.event}function V(_,W){return W instanceof Array?W.push(_):W&&W.add(_),_}function te(_,W,X=100,oe=!1,ge=!1,Ee,Pe){let Ne,Fe,$e,ke=0,ve;const Me={leakWarningThreshold:Ee,onWillAddFirstListener(){Ne=_(Ye=>{ke++,Fe=W(Fe,Ye),oe&&!$e&&(Ue.fire(Fe),Fe=void 0),ve=()=>{const qe=Fe;Fe=void 0,$e=void 0,(!oe||ke>1)&&Ue.fire(qe),ke=0},typeof X=="number"?(clearTimeout($e),$e=setTimeout(ve,X)):$e===void 0&&($e=0,queueMicrotask(ve))})},onWillRemoveListener(){ge&&ke>0&&ve?.()},onDidRemoveLastListener(){ve=void 0,Ne.dispose()}};Pe||k(Me);const Ue=new c(Me);return Pe?.add(Ue),Ue.event}D.debounce=te;function G(_,W=0,X){return D.debounce(_,(oe,ge)=>oe?(oe.push(ge),oe):[ge],W,void 0,!0,void 0,X)}D.accumulate=G;function J(_,W=(oe,ge)=>oe===ge,X){let oe=!0,ge;return K(_,Ee=>{const Pe=oe||!W(Ee,ge);return oe=!1,ge=Ee,Pe},X)}D.latch=J;function q(_,W,X){return[D.filter(_,W,X),D.filter(_,oe=>!W(oe),X)]}D.split=q;function ne(_,W=!1,X=[],oe){let ge=X.slice(),Ee=_(Fe=>{ge?ge.push(Fe):Ne.fire(Fe)});oe&&oe.add(Ee);const Pe=()=>{ge?.forEach(Fe=>Ne.fire(Fe)),ge=null},Ne=new c({onWillAddFirstListener(){Ee||(Ee=_(Fe=>Ne.fire(Fe)),oe&&oe.add(Ee))},onDidAddFirstListener(){ge&&(W?setTimeout(Pe):Pe())},onDidRemoveLastListener(){Ee&&Ee.dispose(),Ee=null}});return oe&&oe.add(Ne),Ne.event}D.buffer=ne;function me(_,W){return(oe,ge,Ee)=>{const Pe=W(new B);return _(function(Ne){const Fe=Pe.evaluate(Ne);Fe!==re&&oe.call(ge,Fe)},void 0,Ee)}}D.chain=me;const re=Symbol("HaltChainable");class B{constructor(){this.f=[]}map(W){return this.f.push(W),this}forEach(W){return this.f.push(X=>(W(X),X)),this}filter(W){return this.f.push(X=>W(X)?X:re),this}reduce(W,X){let oe=X;return this.f.push(ge=>(oe=W(oe,ge),oe)),this}latch(W=(X,oe)=>X===oe){let X=!0,oe;return this.f.push(ge=>{const Ee=X||!W(ge,oe);return X=!1,oe=ge,Ee?ge:re}),this}evaluate(W){for(const X of this.f)if(W=X(W),W===re)break;return W}}function ee(_,W,X=oe=>oe){const oe=(...Ne)=>Pe.fire(X(...Ne)),ge=()=>_.on(W,oe),Ee=()=>_.removeListener(W,oe),Pe=new c({onWillAddFirstListener:ge,onDidRemoveLastListener:Ee});return Pe.event}D.fromNodeEventEmitter=ee;function O(_,W,X=oe=>oe){const oe=(...Ne)=>Pe.fire(X(...Ne)),ge=()=>_.addEventListener(W,oe),Ee=()=>_.removeEventListener(W,oe),Pe=new c({onWillAddFirstListener:ge,onDidRemoveLastListener:Ee});return Pe.event}D.fromDOMEventEmitter=O;function N(_){return new Promise(W=>j(_)(W))}D.toPromise=N;function Q(_){const W=new c;return _.then(X=>{W.fire(X)},()=>{W.fire(void 0)}).finally(()=>{W.dispose()}),W.event}D.fromPromise=Q;function T(_,W){return W(void 0),_(X=>W(X))}D.runAndSubscribe=T;function H(_,W){let X=null;function oe(Ee){X?.dispose(),X=new r.$Pc,W(Ee,X)}oe(void 0);const ge=_(Ee=>oe(Ee));return(0,r.$Oc)(()=>{ge.dispose(),X?.dispose()})}D.runAndSubscribeWithStore=H;class U{constructor(W,X){this._observable=W,this.f=0,this.g=!1;const oe={onWillAddFirstListener:()=>{W.addObserver(this)},onDidRemoveLastListener:()=>{W.removeObserver(this)}};X||k(oe),this.emitter=new c(oe),X&&X.add(this.emitter)}beginUpdate(W){this.f++}handlePossibleChange(W){}handleChange(W,X){this.g=!0}endUpdate(W){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function ie(_,W){return new U(_,W).emitter.event}D.fromObservable=ie;function z(_){return W=>{let X=0,oe=!1;const ge={beginUpdate(){X++},endUpdate(){X--,X===0&&(_.reportChanges(),oe&&(oe=!1,W()))},handlePossibleChange(){},handleChange(){oe=!0}};return _.addObserver(ge),_.reportChanges(),{dispose(){_.removeObserver(ge)}}}}D.fromObservableLight=z})(b||(e.Event=b={}));class C{constructor(k){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${k}_${C.f++}`,C.all.add(this)}start(k){this.g=new L.$Hd,this.listenerCount=k}stop(){if(this.g){const k=this.g.elapsed();this.durations.push(k),this.elapsedOverall+=k,this.invocationCount+=1,this.g=void 0}}}e.$Jd=C,C.all=new Set,C.f=0;let E=-1;function v(D){const k=E;return E=D,{dispose(){E=k}}}e.$Kd=v;class d{constructor(k,A=Math.random().toString(18).slice(2,5)){this.threshold=k,this.name=A,this.g=0}dispose(){this.f?.clear()}check(k,A){const j=this.threshold;if(j<=0||A<j)return;this.f||(this.f=new Map);const Z=this.f.get(k.value)||0;if(this.f.set(k.value,Z+1),this.g-=1,this.g<=0){this.g=j*.5;let ae,K=0;for(const[se,ue]of this.f)(!ae||K<ue)&&(ae=se,K=ue);console.warn(`[${this.name}] potential listener LEAK detected, having ${A} listeners already. MOST frequent listener (${K}):`),console.warn(ae)}return()=>{const ae=this.f.get(k.value)||0;this.f.set(k.value,ae-1)}}}class g{static create(){return new g(new Error().stack??"")}constructor(k){this.value=k}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let m=0;class l{constructor(k){this.value=k,this.id=m++}}const f=2,u=(D,k)=>{if(D instanceof l)k(D);else for(let A=0;A<D.length;A++){const j=D[A];j&&k(j)}};class c{constructor(k){this.x=0,this.f=k,this.g=E>0||this.f?.leakWarningThreshold?new d(this.f?.leakWarningThreshold??E):void 0,this.j=this.f?._profName?new C(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(I){const k=this.t;queueMicrotask(()=>{u(k,A=>A.stack?.print())})}this.t=void 0,this.x=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??(this.q=(k,A,j)=>{if(this.g&&this.x>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),r.$Qc.None;if(this.m)return r.$Qc.None;A&&(k=k.bind(A));const Z=new l(k);let ae,K;this.g&&this.x>=Math.ceil(this.g.threshold*.2)&&(Z.stack=g.create(),ae=this.g.check(Z.stack,this.x+1)),I&&(Z.stack=K??g.create()),this.t?this.t instanceof l?(this.u??(this.u=new h),this.t=[this.t,Z]):this.t.push(Z):(this.f?.onWillAddFirstListener?.(this),this.t=Z,this.f?.onDidAddFirstListener?.(this)),this.x++;const se=(0,r.$Oc)(()=>{ae?.(),this.y(Z)});return j instanceof r.$Pc?j.add(se):Array.isArray(j)&&j.push(se),se}),this.q}y(k){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.x===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.x=0;return}const A=this.t,j=A.indexOf(k);if(j===-1)throw console.log("disposed?",this.m),console.log("size?",this.x),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.x--,A[j]=void 0;const Z=this.u.current===this;if(this.x*f<=A.length){let ae=0;for(let K=0;K<A.length;K++)A[K]?A[ae++]=A[K]:Z&&(this.u.end--,ae<this.u.i&&this.u.i--);A.length=ae}}z(k,A){if(!k)return;const j=this.f?.onListenerError||y.$Y;if(!j){k.value(A);return}try{k.value(A)}catch(Z){j(Z)}}A(k){const A=k.current.t;for(;k.i<k.end;)this.z(A[k.i++],k.value);k.reset()}fire(k){if(this.u?.current&&(this.A(this.u),this.j?.stop()),this.j?.start(this.x),this.t)if(this.t instanceof l)this.z(this.t,k);else{const A=this.u;A.enqueue(this,k,this.t.length),this.A(A)}this.j?.stop()}hasListeners(){return this.x>0}}e.$Ld=c;const p=()=>new h;e.$Md=p;class h{constructor(){this.i=-1,this.end=0}enqueue(k,A,j){this.i=0,this.end=j,this.current=k,this.value=A}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class t extends c{async fireAsync(k,A,j){if(this.t)for(this.h||(this.h=new P.$Zc),u(this.t,Z=>this.h.push([Z.value,k]));this.h.size>0&&!A.isCancellationRequested;){const[Z,ae]=this.h.shift(),K=[],se={...ae,token:A,waitUntil:ue=>{if(Object.isFrozen(K))throw new Error("waitUntil can NOT be called asynchronous");j&&(ue=j(ue,Z)),K.push(ue)}};try{Z(se)}catch(ue){(0,y.$Y)(ue);continue}Object.freeze(K),await Promise.allSettled(K).then(ue=>{for(const x of ue)x.status==="rejected"&&(0,y.$Y)(x.reason)})}}}e.$Nd=t;class s extends c{get isPaused(){return this.h!==0}constructor(k){super(k),this.h=0,this.s=new P.$Zc,this.w=k?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.w){if(this.s.size>0){const k=Array.from(this.s);this.s.clear(),super.fire(this.w(k))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(k){this.x&&(this.h!==0?this.s.push(k):super.fire(k))}}e.$Od=s;class o extends s{constructor(k){super(k),this.k=k.delay??100}fire(k){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(k)}}e.$Pd=o;class i extends c{constructor(k){super(k),this.h=[],this.k=k?.merge}fire(k){this.hasListeners()&&(this.h.push(k),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(A=>super.fire(A)),this.h=[]}))}}e.$Qd=i;class n{constructor(){this.g=!1,this.h=[],this.f=new c({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(k){const A={event:k,listener:null};this.h.push(A),this.g&&this.m(A);const j=()=>{this.g&&this.o(A);const Z=this.h.indexOf(A);this.h.splice(Z,1)};return(0,r.$Oc)((0,R.$bb)(j))}j(){this.g=!0,this.h.forEach(k=>this.m(k))}k(){this.g=!1,this.h.forEach(k=>this.o(k))}m(k){k.listener=k.event(A=>this.f.fire(A))}o(k){k.listener&&k.listener.dispose(),k.listener=null}dispose(){this.f.dispose()}}e.$Rd=n;class a{constructor(k,A,j,Z){this.f=new r.$Pc;const ae=this.f.add(new n),K=this.f.add(new r.$Yc);function se(ue){K.set(ue,ae.add(Z(ue)))}for(const ue of k)se(ue);this.f.add(A(ue=>{se(ue)})),this.f.add(j(ue=>{K.deleteAndDispose(ue)})),this.event=ae.event}dispose(){this.f.dispose()}}e.$Sd=a;class ${constructor(){this.f=[]}wrapEvent(k){return(A,j,Z)=>k(ae=>{const K=this.f[this.f.length-1];K?K.push(()=>A.call(j,ae)):A.call(j,ae)},void 0,Z)}bufferEvents(k){const A=[];this.f.push(A);const j=k();return this.f.pop(),A.forEach(Z=>Z()),j}}e.$Td=$;class S{constructor(){this.f=!1,this.g=b.None,this.h=r.$Qc.None,this.j=new c({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(k){this.g=k,this.f&&(this.h.dispose(),this.h=k(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$Ud=S}),define(we[20],pe([1,0,5]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vd=e.CancellationToken=void 0;const R=Object.freeze(function(I,w){const b=setTimeout(I.bind(w),0);return{dispose(){clearTimeout(b)}}});var r;(function(I){function w(b){return b===I.None||b===I.Cancelled||b instanceof P?!0:!b||typeof b!="object"?!1:typeof b.isCancellationRequested=="boolean"&&typeof b.onCancellationRequested=="function"}I.isCancellationToken=w,I.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:y.Event.None}),I.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:R})})(r||(e.CancellationToken=r={}));class P{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?R:(this.b||(this.b=new y.$Ld),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class L{constructor(w){this.f=void 0,this.g=void 0,this.g=w&&w.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new P),this.f}cancel(){this.f?this.f instanceof P&&this.f.cancel():this.f=r.Cancelled}dispose(w=!1){w&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof P&&this.f.dispose():this.f=r.None}}e.$Vd=L}),define(we[146],pe([1,0,20]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$we=e.$ve=e.$ue=void 0;class R{constructor(I){this.b=I,this.a=null}get(){if(this.a)return this.a;const I=new y.$Vd,w=this.b(I.token);return this.a={promise:w,dispose:()=>{this.a=null,I.cancel(),I.dispose()}},this.a}}e.$ue=R;class r{constructor(I){this.c=I,this.a=void 0,this.b=void 0}get(I){const w=JSON.stringify(I);return this.b!==w&&(this.b=w,this.a=this.c(I)),this.a}}e.$ve=r;class P{get cachedValues(){return this.a}constructor(I){this.b=I,this.a=new Map}get(I){if(this.a.has(I))return this.a.get(I);const w=this.b(I);return this.a.set(I,w),w}}e.$we=P}),define(we[48],pe([1,0,11,2]),function(le,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.$3d=e.$2d=e.$1d=e.$Zd=e.$Yd=e.$Xd=e.$Wd=void 0;function r(p){const h=p;return h?typeof h.read=="function":!1}e.$Wd=r;function P(p){const h=p;return h?[h.on,h.pause,h.resume,h.destroy].every(t=>typeof t=="function"):!1}e.$Xd=P;function L(p){const h=p;return h?P(h.stream)&&Array.isArray(h.buffer)&&typeof h.ended=="boolean":!1}e.$Yd=L;function I(p,h){return new w(p,h)}e.$Zd=I;class w{constructor(h,t){this.e=h,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(h){if(!this.a.destroyed){if(this.a.flowing)this.g(h);else if(this.b.data.push(h),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(h){this.a.destroyed||(this.a.flowing?this.h(h):this.b.error.push(h))}end(h){this.a.destroyed||(typeof h<"u"&&this.write(h),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(h){this.c.data.slice(0).forEach(t=>t(h))}h(h){this.c.error.length===0?(0,y.$Y)(h):this.c.error.slice(0).forEach(t=>t(h))}i(){this.c.end.slice(0).forEach(h=>h())}on(h,t){if(!this.a.destroyed)switch(h){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(h,t){if(this.a.destroyed)return;let s;switch(h){case"data":s=this.c.data;break;case"end":s=this.c.end;break;case"error":s=this.c.error;break}if(s){const o=s.indexOf(t);o>=0&&s.splice(o,1)}}j(){if(this.b.data.length>0){const h=this.e(this.b.data);this.g(h),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(s=>s())}}k(){if(this.c.error.length>0){for(const h of this.b.error)this.h(h);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function b(p,h){const t=[];let s;for(;(s=p.read())!==null;)t.push(s);return h(t)}e.$1d=b;function C(p,h,t){const s=[];let o;for(;(o=p.read())!==null&&s.length<t;)s.push(o);return o===null&&s.length>0?h(s):{read:()=>{if(s.length>0)return s.shift();if(typeof o<"u"){const i=o;return o=void 0,i}return p.read()}}}e.$2d=C;function E(p,h){return new Promise((t,s)=>{const o=[];v(p,{onData:i=>{h&&o.push(i)},onError:i=>{h?s(i):t(void 0)},onEnd:()=>{t(h?h(o):void 0)}})})}e.$3d=E;function v(p,h,t){p.on("error",s=>{t?.isCancellationRequested||h.onError(s)}),p.on("end",()=>{t?.isCancellationRequested||h.onEnd()}),p.on("data",s=>{t?.isCancellationRequested||h.onData(s)})}e.$4d=v;function d(p,h){return new Promise((t,s)=>{const o=new R.$Pc,i=[],n=S=>{if(i.push(S),i.length>h)return o.dispose(),p.pause(),t({stream:p,buffer:i,ended:!1})},a=S=>(o.dispose(),s(S)),$=()=>(o.dispose(),t({stream:p,buffer:i,ended:!0}));o.add((0,R.$Oc)(()=>p.removeListener("error",a))),p.on("error",a),o.add((0,R.$Oc)(()=>p.removeListener("end",$))),p.on("end",$),o.add((0,R.$Oc)(()=>p.removeListener("data",n))),p.on("data",n)})}e.$5d=d;function g(p,h){const t=I(h);return t.end(p),t}e.$6d=g;function m(){const p=I(()=>{throw new Error("not supported")});return p.end(),p}e.$7d=m;function l(p){let h=!1;return{read:()=>h?null:(h=!0,p)}}e.$8d=l;function f(p,h,t){const s=I(t);return v(p,{onData:o=>s.write(h.data(o)),onError:o=>s.error(h.error?h.error(o):o),onEnd:()=>s.end()}),s}e.$9d=f;function u(p,h,t){let s=!1;return{read:()=>{const o=h.read();return s?o:(s=!0,o!==null?t([p,o]):p)}}}e.$0d=u;function c(p,h,t){let s=!1;const o=I(t);return v(h,{onData:i=>s?o.write(i):(s=!0,o.write(t([p,i]))),onError:i=>o.error(i),onEnd:()=>{s||(s=!0,o.write(p)),o.end()}}),o}e.$$d=c}),define(we[15],pe([1,0,96,48]),function(le,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=e.$be=e.$ae=e.$_d=void 0;const r=typeof Buffer<"u",P=new y.$T(()=>new Uint8Array(256));let L,I;class w{static alloc(A){return r?new w(Buffer.allocUnsafe(A)):new w(new Uint8Array(A))}static wrap(A){return r&&!Buffer.isBuffer(A)&&(A=Buffer.from(A.buffer,A.byteOffset,A.byteLength)),new w(A)}static fromString(A,j){return!(j?.dontUseNodeBuffer||!1)&&r?new w(Buffer.from(A)):(L||(L=new TextEncoder),new w(L.encode(A)))}static fromByteArray(A){const j=w.alloc(A.length);for(let Z=0,ae=A.length;Z<ae;Z++)j.buffer[Z]=A[Z];return j}static concat(A,j){if(typeof j>"u"){j=0;for(let K=0,se=A.length;K<se;K++)j+=A[K].byteLength}const Z=w.alloc(j);let ae=0;for(let K=0,se=A.length;K<se;K++){const ue=A[K];Z.set(ue,ae),ae+=ue.byteLength}return Z}constructor(A){this.buffer=A,this.byteLength=this.buffer.byteLength}clone(){const A=w.alloc(this.byteLength);return A.set(this),A}toString(){return r?this.buffer.toString():(I||(I=new TextDecoder),I.decode(this.buffer))}slice(A,j){return new w(this.buffer.subarray(A,j))}set(A,j){if(A instanceof w)this.buffer.set(A.buffer,j);else if(A instanceof Uint8Array)this.buffer.set(A,j);else if(A instanceof ArrayBuffer)this.buffer.set(new Uint8Array(A),j);else if(ArrayBuffer.isView(A))this.buffer.set(new Uint8Array(A.buffer,A.byteOffset,A.byteLength),j);else throw new Error("Unknown argument 'array'")}readUInt32BE(A){return v(this.buffer,A)}writeUInt32BE(A,j){d(this.buffer,A,j)}readUInt32LE(A){return g(this.buffer,A)}writeUInt32LE(A,j){m(this.buffer,A,j)}readUInt8(A){return l(this.buffer,A)}writeUInt8(A,j){f(this.buffer,A,j)}indexOf(A,j=0){return b(this.buffer,A instanceof w?A.buffer:A,j)}}e.$_d=w;function b(k,A,j=0){const Z=A.byteLength,ae=k.byteLength;if(Z===0)return 0;if(Z===1)return k.indexOf(A[0]);if(Z>ae-j)return-1;const K=P.value;K.fill(A.length);for(let he=0;he<A.length;he++)K[A[he]]=A.length-he-1;let se=j+A.length-1,ue=se,x=-1;for(;se<ae;)if(k[se]===A[ue]){if(ue===0){x=se;break}se--,ue--}else se+=Math.max(A.length-ue,K[k[se]]),ue=A.length-1;return x}e.$ae=b;function C(k,A){return k[A+0]<<0>>>0|k[A+1]<<8>>>0}e.$be=C;function E(k,A,j){k[j+0]=A&255,A=A>>>8,k[j+1]=A&255}e.$ce=E;function v(k,A){return k[A]*2**24+k[A+1]*2**16+k[A+2]*2**8+k[A+3]}e.$de=v;function d(k,A,j){k[j+3]=A,A=A>>>8,k[j+2]=A,A=A>>>8,k[j+1]=A,A=A>>>8,k[j]=A}e.$ee=d;function g(k,A){return k[A+0]<<0>>>0|k[A+1]<<8>>>0|k[A+2]<<16>>>0|k[A+3]<<24>>>0}e.$fe=g;function m(k,A,j){k[j+0]=A&255,A=A>>>8,k[j+1]=A&255,A=A>>>8,k[j+2]=A&255,A=A>>>8,k[j+3]=A&255}e.$ge=m;function l(k,A){return k[A]}e.$he=l;function f(k,A,j){k[j]=A}e.$ie=f;function u(k){return R.$1d(k,A=>w.concat(A))}e.$je=u;function c(k){return R.$8d(k)}e.$ke=c;function p(k){return R.$3d(k,A=>w.concat(A))}e.$le=p;async function h(k){return k.ended?w.concat(k.buffer):w.concat([...k.buffer,await p(k.stream)])}e.$me=h;function t(k){return R.$6d(k,A=>w.concat(A))}e.$ne=t;function s(k){return R.$9d(k,{data:A=>typeof A=="string"?w.fromString(A):w.wrap(A)},A=>w.concat(A))}e.$oe=s;function o(k){return R.$Zd(A=>w.concat(A),k)}e.$pe=o;function i(k,A){return R.$0d(k,A,j=>w.concat(j))}e.$qe=i;function n(k,A){return R.$$d(k,A,j=>w.concat(j))}e.$re=n;function a(k){let A=0,j=0,Z=0;const ae=new Uint8Array(Math.floor(k.length/4*3)),K=ue=>{switch(j){case 3:ae[Z++]=A|ue,j=0;break;case 2:ae[Z++]=A|ue>>>2,A=ue<<6,j=3;break;case 1:ae[Z++]=A|ue>>>4,A=ue<<4,j=2;break;default:A=ue<<2,j=1}};for(let ue=0;ue<k.length;ue++){const x=k.charCodeAt(ue);if(x>=65&&x<=90)K(x-65);else if(x>=97&&x<=122)K(x-97+26);else if(x>=48&&x<=57)K(x-48+52);else if(x===43||x===45)K(62);else if(x===47||x===95)K(63);else{if(x===61)break;throw new SyntaxError(`Unexpected base64 character ${k[ue]}`)}}const se=Z;for(;j>0;)K(0);return w.wrap(ae).slice(0,se)}e.$se=a;const $="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",S="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function D({buffer:k},A=!0,j=!1){const Z=j?S:$;let ae="";const K=k.byteLength%3;let se=0;for(;se<k.byteLength-K;se+=3){const ue=k[se+0],x=k[se+1],he=k[se+2];ae+=Z[ue>>>2],ae+=Z[(ue<<4|x>>>4)&63],ae+=Z[(x<<2|he>>>6)&63],ae+=Z[he&63]}if(K===1){const ue=k[se+0];ae+=Z[ue>>>2],ae+=Z[ue<<4&63],A&&(ae+="==")}else if(K===2){const ue=k[se+0],x=k[se+1];ae+=Z[ue>>>2],ae+=Z[(ue<<4|x>>>4)&63],ae+=Z[x<<2&63],A&&(ae+="=")}return ae}e.$te=D}),define(we[17],pe([1,0,146,96]),function(le,e,y,R){"use strict";var r;Object.defineProperty(e,"__esModule",{value:!0}),e.$vf=e.$uf=e.$tf=e.$sf=e.GraphemeBreakType=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=e.$lf=e.$kf=e.$jf=e.$if=e.$hf=e.$gf=e.$ff=e.$ef=e.$df=e.$cf=e.$bf=e.$af=e.$_e=e.$$e=e.$0e=e.$9e=e.$8e=e.$7e=e.$6e=e.$5e=e.$4e=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.$Ue=e.$Te=e.$Se=e.$Re=e.$Qe=e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=e.$Fe=e.$Ee=e.$De=e.$Ce=e.$Be=e.$Ae=e.$ze=void 0;function P(de){return!de||typeof de!="string"?!0:de.trim().length===0}e.$ze=P;const L=/{(\d+)}/g;function I(de,...Se){return Se.length===0?de:de.replace(L,function(Ie,Le){const Be=parseInt(Le,10);return isNaN(Be)||Be<0||Be>=Se.length?Ie:Se[Be]})}e.$Ae=I;const w=/{([^}]+)}/g;function b(de,Se){return de.replace(w,(Ie,Le)=>Se[Le]??Ie)}e.$Be=b;function C(de){return de.replace(/[<>&]/g,function(Se){switch(Se){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Se}})}e.$Ce=C;function E(de){return de.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$De=E;function v(de,Se){let Ie=0;const Le=Se.charCodeAt(0);for(let Be=de.length-1;Be>=0;Be--)de.charCodeAt(Be)===Le&&Ie++;return Ie}e.$Ee=v;function d(de,Se,Ie="\u2026"){return de.length<=Se?de:`${de.substr(0,Se)}${Ie}`}e.$Fe=d;function g(de,Se=" "){const Ie=m(de,Se);return l(Ie,Se)}e.$Ge=g;function m(de,Se){if(!de||!Se)return de;const Ie=Se.length;if(Ie===0||de.length===0)return de;let Le=0;for(;de.indexOf(Se,Le)===Le;)Le=Le+Ie;return de.substring(Le)}e.$He=m;function l(de,Se){if(!de||!Se)return de;const Ie=Se.length,Le=de.length;if(Ie===0||Le===0)return de;let Be=Le,ze=-1;for(;ze=de.lastIndexOf(Se,Be-1),!(ze===-1||ze+Ie!==Be);){if(ze===0)return"";Be=ze}return de.substring(0,Be)}e.$Ie=l;function f(de){return de.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$Je=f;function u(de){return de.replace(/\*/g,"")}e.$Ke=u;function c(de,Se,Ie={}){if(!de)throw new Error("Cannot create regex from empty string");Se||(de=E(de)),Ie.wholeWord&&(/\B/.test(de.charAt(0))||(de="\\b"+de),/\B/.test(de.charAt(de.length-1))||(de=de+"\\b"));let Le="";return Ie.global&&(Le+="g"),Ie.matchCase||(Le+="i"),Ie.multiline&&(Le+="m"),Ie.unicode&&(Le+="u"),new RegExp(de,Le)}e.$Le=c;function p(de){return de.source==="^"||de.source==="^$"||de.source==="$"||de.source==="^\\s*$"?!1:!!(de.exec("")&&de.lastIndex===0)}e.$Me=p;function h(de){return de.split(/\r\n|\r|\n/)}e.$Ne=h;function t(de){for(let Se=0,Ie=de.length;Se<Ie;Se++){const Le=de.charCodeAt(Se);if(Le!==32&&Le!==9)return Se}return-1}e.$Oe=t;function s(de,Se=0,Ie=de.length){for(let Le=Se;Le<Ie;Le++){const Be=de.charCodeAt(Le);if(Be!==32&&Be!==9)return de.substring(Se,Le)}return de.substring(Se,Ie)}e.$Pe=s;function o(de,Se=de.length-1){for(let Ie=Se;Ie>=0;Ie--){const Le=de.charCodeAt(Ie);if(Le!==32&&Le!==9)return Ie}return-1}e.$Qe=o;function i(de,Se,Ie){const Le=[];let Be=0;for(const ze of de.matchAll(Se)){if(Le.push(de.slice(Be,ze.index)),ze.index===void 0)throw new Error("match.index should be defined");Be=ze.index+ze[0].length,Le.push(Ie(ze[0],...ze.slice(1),ze.index,de,ze.groups))}return Le.push(de.slice(Be)),Promise.all(Le).then(ze=>ze.join(""))}e.$Re=i;function n(de,Se){return de<Se?-1:de>Se?1:0}e.$Se=n;function a(de,Se,Ie=0,Le=de.length,Be=0,ze=Se.length){for(;Ie<Le&&Be<ze;Ie++,Be++){const Qe=de.charCodeAt(Ie),We=Se.charCodeAt(Be);if(Qe<We)return-1;if(Qe>We)return 1}const He=Le-Ie,Ge=ze-Be;return He<Ge?-1:He>Ge?1:0}e.$Te=a;function $(de,Se){return S(de,Se,0,de.length,0,Se.length)}e.$Ue=$;function S(de,Se,Ie=0,Le=de.length,Be=0,ze=Se.length){for(;Ie<Le&&Be<ze;Ie++,Be++){let Qe=de.charCodeAt(Ie),We=Se.charCodeAt(Be);if(Qe===We)continue;if(Qe>=128||We>=128)return a(de.toLowerCase(),Se.toLowerCase(),Ie,Le,Be,ze);k(Qe)&&(Qe-=32),k(We)&&(We-=32);const st=Qe-We;if(st!==0)return st}const He=Le-Ie,Ge=ze-Be;return He<Ge?-1:He>Ge?1:0}e.$Ve=S;function D(de){return de>=48&&de<=57}e.$We=D;function k(de){return de>=97&&de<=122}e.$Xe=k;function A(de){return de>=65&&de<=90}e.$Ye=A;function j(de,Se){return de.length===Se.length&&S(de,Se)===0}e.$Ze=j;function Z(de,Se){const Ie=Se.length;return Se.length>de.length?!1:S(de,Se,0,Ie)===0}e.$1e=Z;function ae(de,Se){const Ie=Math.min(de.length,Se.length);let Le;for(Le=0;Le<Ie;Le++)if(de.charCodeAt(Le)!==Se.charCodeAt(Le))return Le;return Ie}e.$2e=ae;function K(de,Se){const Ie=Math.min(de.length,Se.length);let Le;const Be=de.length-1,ze=Se.length-1;for(Le=0;Le<Ie;Le++)if(de.charCodeAt(Be-Le)!==Se.charCodeAt(ze-Le))return Le;return Ie}e.$3e=K;function se(de){return 55296<=de&&de<=56319}e.$4e=se;function ue(de){return 56320<=de&&de<=57343}e.$5e=ue;function x(de,Se){return(de-55296<<10)+(Se-56320)+65536}e.$6e=x;function he(de,Se,Ie){const Le=de.charCodeAt(Ie);if(se(Le)&&Ie+1<Se){const Be=de.charCodeAt(Ie+1);if(ue(Be))return x(Le,Be)}return Le}e.$7e=he;function V(de,Se){const Ie=de.charCodeAt(Se-1);if(ue(Ie)&&Se>1){const Le=de.charCodeAt(Se-2);if(se(Le))return x(Le,Ie)}return Ie}class te{get offset(){return this.e}constructor(Se,Ie=0){this.c=Se,this.d=Se.length,this.e=Ie}setOffset(Se){this.e=Se}prevCodePoint(){const Se=V(this.c,this.e);return this.e-=Se>=65536?2:1,Se}nextCodePoint(){const Se=he(this.c,this.d,this.e);return this.e+=Se>=65536?2:1,Se}eol(){return this.e>=this.d}}e.$8e=te;class G{get offset(){return this.c.offset}constructor(Se,Ie=0){this.c=new te(Se,Ie)}nextGraphemeLength(){const Se=ve.getInstance(),Ie=this.c,Le=Ie.offset;let Be=Se.getGraphemeBreakType(Ie.nextCodePoint());for(;!Ie.eol();){const ze=Ie.offset,He=Se.getGraphemeBreakType(Ie.nextCodePoint());if($e(Be,He)){Ie.setOffset(ze);break}Be=He}return Ie.offset-Le}prevGraphemeLength(){const Se=ve.getInstance(),Ie=this.c,Le=Ie.offset;let Be=Se.getGraphemeBreakType(Ie.prevCodePoint());for(;Ie.offset>0;){const ze=Ie.offset,He=Se.getGraphemeBreakType(Ie.prevCodePoint());if($e(He,Be)){Ie.setOffset(ze);break}Be=He}return Le-Ie.offset}eol(){return this.c.eol()}}e.$9e=G;function J(de,Se){return new G(de,Se).nextGraphemeLength()}e.$0e=J;function q(de,Se){return new G(de,Se).prevGraphemeLength()}e.$$e=q;function ne(de,Se){Se>0&&ue(de.charCodeAt(Se))&&Se--;const Ie=Se+J(de,Se);return[Ie-q(de,Ie),Ie]}e.$_e=ne;function me(de){const Se=new G(de);let Ie=0;for(;!Se.eol();)Ie++,Se.nextGraphemeLength();return Ie}e.$af=me;let re;function B(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function ee(de){return re||(re=B()),re.test(de)}e.$bf=ee;const O=/^[\t\n\r\x20-\x7E]*$/;function N(de){return O.test(de)}e.$cf=N,e.$df=/[\u2028\u2029]/;function Q(de){return e.$df.test(de)}e.$ef=Q;function T(de){return de>=11904&&de<=55215||de>=63744&&de<=64255||de>=65281&&de<=65374}e.$ff=T;function H(de){return de>=127462&&de<=127487||de===8986||de===8987||de===9200||de===9203||de>=9728&&de<=10175||de===11088||de===11093||de>=127744&&de<=128591||de>=128640&&de<=128764||de>=128992&&de<=129008||de>=129280&&de<=129535||de>=129648&&de<=129782}e.$gf=H;function U(de,Se){if(de.length<Se)return de;const Ie=/\b/g;let Le=0;for(;Ie.test(de)&&!(de.length-Ie.lastIndex<Se);)Le=Ie.lastIndex,Ie.lastIndex+=1;return de.substring(Le).replace(/^\s/,"")}e.$hf=U;const ie=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,z=/\x1b\].*?\x07/g;function _(de){return de&&(de=de.replace(ie,"").replace(z,"")),de}e.$if=_,e.$jf=String.fromCharCode(65279);function W(de){return!!(de&&de.length>0&&de.charCodeAt(0)===65279)}e.$kf=W;function X(de){return W(de)?de.substr(1):de}e.$lf=X;function oe(de,Se){if(!de||!Se||de.length<Se.length)return!1;const Ie=Se.length,Le=de.toLowerCase();let Be=0,ze=-1;for(;Be<Ie;){const He=Le.indexOf(Se[Be],ze+1);if(He<0)return!1;ze=He,Be++}return!0}e.$mf=oe;function ge(de,Se=!1){return de?(Se&&(de=de.replace(/\\./g,"")),de.toLowerCase()!==de):!1}e.$nf=ge;function Ee(de){return de.charAt(0).toUpperCase()+de.slice(1)}e.$of=Ee;function Pe(de,Se=1){if(Se===0)return"";let Ie=-1;do Ie=de.indexOf(`
`,Ie+1),Se--;while(Se>0&&Ie>=0);return Ie===-1?de:(de[Ie-1]==="\r"&&Ie--,de.substr(0,Ie))}e.$pf=Pe;function Ne(de){return de=de%(2*26),de<26?String.fromCharCode(97+de):String.fromCharCode(65+de-26)}e.$qf=Ne;function Fe(de){return ve.getInstance().getGraphemeBreakType(de)}e.$rf=Fe;function $e(de,Se){return de===0?Se!==5&&Se!==7:de===2&&Se===3?!1:de===4||de===2||de===3||Se===4||Se===2||Se===3?!0:!(de===8&&(Se===8||Se===9||Se===11||Se===12)||(de===11||de===9)&&(Se===9||Se===10)||(de===12||de===10)&&Se===10||Se===5||Se===13||Se===7||de===1||de===13&&Se===14||de===6&&Se===6)}var ke;(function(de){de[de.Other=0]="Other",de[de.Prepend=1]="Prepend",de[de.CR=2]="CR",de[de.LF=3]="LF",de[de.Control=4]="Control",de[de.Extend=5]="Extend",de[de.Regional_Indicator=6]="Regional_Indicator",de[de.SpacingMark=7]="SpacingMark",de[de.L=8]="L",de[de.V=9]="V",de[de.T=10]="T",de[de.LV=11]="LV",de[de.LVT=12]="LVT",de[de.ZWJ=13]="ZWJ",de[de.Extended_Pictographic=14]="Extended_Pictographic"})(ke||(e.GraphemeBreakType=ke={}));class ve{static getInstance(){return ve.c||(ve.c=new ve),ve.c}constructor(){this.d=Me()}getGraphemeBreakType(Se){if(Se<32)return Se===10?3:Se===13?2:4;if(Se<127)return 0;const Ie=this.d,Le=Ie.length/3;let Be=1;for(;Be<=Le;)if(Se<Ie[3*Be])Be=2*Be;else if(Se>Ie[3*Be+1])Be=2*Be+1;else return Ie[3*Be+2];return 0}}ve.c=null;function Me(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ue(de,Se){if(de===0)return 0;const Ie=Ye(de,Se);if(Ie!==void 0)return Ie;const Le=new te(Se,de);return Le.prevCodePoint(),Le.offset}e.$sf=Ue;function Ye(de,Se){const Ie=new te(Se,de);let Le=Ie.prevCodePoint();for(;qe(Le)||Le===65039||Le===8419;){if(Ie.offset===0)return;Le=Ie.prevCodePoint()}if(!H(Le))return;let Be=Ie.offset;return Be>0&&Ie.prevCodePoint()===8205&&(Be=Ie.offset),Be}function qe(de){return 127995<=de&&de<=127999}var Je;(function(de){de[de.zwj=8205]="zwj",de[de.emojiVariantSelector=65039]="emojiVariantSelector",de[de.enclosingKeyCap=8419]="enclosingKeyCap"})(Je||(Je={})),e.$tf="\xA0";class Ze{static getInstance(Se){return r.d.get(Array.from(Se))}static getLocales(){return r.e.value}constructor(Se){this.f=Se}isAmbiguous(Se){return this.f.has(Se)}getPrimaryConfusable(Se){return this.f.get(Se)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$uf=Ze,r=Ze,Ze.c=new R.$T(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Ze.d=new y.$ve(de=>{function Se(We){const st=new Map;for(let rt=0;rt<We.length;rt+=2)st.set(We[rt],We[rt+1]);return st}function Ie(We,st){const rt=new Map(We);for(const[et,ft]of st)rt.set(et,ft);return rt}function Le(We,st){if(!We)return st;const rt=new Map;for(const[et,ft]of We)st.has(et)&&rt.set(et,ft);return rt}const Be=r.c.value;let ze=de.filter(We=>!We.startsWith("_")&&We in Be);ze.length===0&&(ze=["_default"]);let He;for(const We of ze){const st=Se(Be[We]);He=Le(He,st)}const Ge=Se(Be._common),Qe=Ie(Ge,He);return new r(Qe)}),Ze.e=new R.$T(()=>Object.keys(r.c.value).filter(de=>!de.startsWith("_")));class xe{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(xe.c())),this.d}static isInvisibleCharacter(Se){return xe.e().has(Se)}static get codePoints(){return xe.e()}}e.$vf=xe,xe.d=void 0}),define(we[147],pe([1,0,26,17]),function(le,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.FuzzyScore=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.or=void 0;function r(...W){return function(X,oe){for(let ge=0,Ee=W.length;ge<Ee;ge++){const Pe=W[ge](X,oe);if(Pe)return Pe}return null}}e.or=r,e.$yj=P.bind(void 0,!1),e.$zj=P.bind(void 0,!0);function P(W,X,oe){if(!oe||oe.length<X.length)return null;let ge;return W?ge=R.$1e(oe,X):ge=oe.indexOf(X)===0,ge?X.length>0?[{start:0,end:X.length}]:[]:null}function L(W,X){const oe=X.toLowerCase().indexOf(W.toLowerCase());return oe===-1?null:[{start:oe,end:oe+W.length}]}e.$Aj=L;function I(W,X){return w(W.toLowerCase(),X.toLowerCase(),0,0)}e.$Bj=I;function w(W,X,oe,ge){if(oe===W.length)return[];if(ge===X.length)return null;if(W[oe]===X[ge]){let Ee=null;return(Ee=w(W,X,oe+1,ge+1))?f({start:ge,end:ge+1},Ee):null}return w(W,X,oe,ge+1)}function b(W){return 97<=W&&W<=122}function C(W){return 65<=W&&W<=90}e.$Cj=C;function E(W){return 48<=W&&W<=57}function v(W){return W===32||W===9||W===10||W===13}const d=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(W=>d.add(W.charCodeAt(0)));function g(W){return v(W)||d.has(W)}function m(W,X){return W===X||g(W)&&g(X)}function l(W){return b(W)||C(W)||E(W)}function f(W,X){return X.length===0?X=[W]:W.end===X[0].start?X[0].start=W.start:X.unshift(W),X}function u(W,X){for(let oe=X;oe<W.length;oe++){const ge=W.charCodeAt(oe);if(C(ge)||E(ge)||oe>0&&!l(W.charCodeAt(oe-1)))return oe}return W.length}function c(W,X,oe,ge){if(oe===W.length)return[];if(ge===X.length)return null;if(W[oe]!==X[ge].toLowerCase())return null;{let Ee=null,Pe=ge+1;for(Ee=c(W,X,oe+1,ge+1);!Ee&&(Pe=u(X,Pe))<X.length;)Ee=c(W,X,oe+1,Pe),Pe++;return Ee===null?null:f({start:ge,end:ge+1},Ee)}}function p(W){let X=0,oe=0,ge=0,Ee=0,Pe=0;for(let ve=0;ve<W.length;ve++)Pe=W.charCodeAt(ve),C(Pe)&&X++,b(Pe)&&oe++,l(Pe)&&ge++,E(Pe)&&Ee++;const Ne=X/W.length,Fe=oe/W.length,$e=ge/W.length,ke=Ee/W.length;return{upperPercent:Ne,lowerPercent:Fe,alphaPercent:$e,numericPercent:ke}}function h(W){const{upperPercent:X,lowerPercent:oe}=W;return oe===0&&X>.6}function t(W){const{upperPercent:X,lowerPercent:oe,alphaPercent:ge,numericPercent:Ee}=W;return oe>.2&&X<.8&&ge>.6&&Ee<.2}function s(W){let X=0,oe=0,ge=0,Ee=0;for(let Pe=0;Pe<W.length;Pe++)ge=W.charCodeAt(Pe),C(ge)&&X++,b(ge)&&oe++,v(ge)&&Ee++;return(X===0||oe===0)&&Ee===0?W.length<=30:X<=5}function o(W,X){if(!X||(X=X.trim(),X.length===0)||!s(W)||X.length>60)return null;const oe=p(X);if(!t(oe)){if(!h(oe))return null;X=X.toLowerCase()}let ge=null,Ee=0;for(W=W.toLowerCase();Ee<X.length&&(ge=c(W,X,0,Ee))===null;)Ee=u(X,Ee+1);return ge}e.$Dj=o;function i(W,X,oe=!1){if(!X||X.length===0)return null;let ge=null,Ee=0;for(W=W.toLowerCase(),X=X.toLowerCase();Ee<X.length&&(ge=n(W,X,0,Ee,oe))===null;)Ee=a(X,Ee+1);return ge}e.$Ej=i;function n(W,X,oe,ge,Ee){if(oe===W.length)return[];if(ge===X.length)return null;if(m(W.charCodeAt(oe),X.charCodeAt(ge))){let Pe=null,Ne=ge+1;if(Pe=n(W,X,oe+1,ge+1,Ee),!Ee)for(;!Pe&&(Ne=a(X,Ne))<X.length;)Pe=n(W,X,oe+1,Ne,Ee),Ne++;return Pe?W.charCodeAt(oe)!==X.charCodeAt(ge)?Pe:f({start:ge,end:ge+1},Pe):null}else return null}function a(W,X){for(let oe=X;oe<W.length;oe++)if(g(W.charCodeAt(oe))||oe>0&&g(W.charCodeAt(oe-1)))return oe;return W.length}const $=r(e.$zj,o,L),S=r(e.$zj,o,I),D=new y.$Bc(1e4);function k(W,X,oe=!1){if(typeof W!="string"||typeof X!="string")return null;let ge=D.get(W);ge||(ge=new RegExp(R.$Je(W),"i"),D.set(W,ge));const Ee=ge.exec(X);return Ee?[{start:Ee.index,end:Ee.index+Ee[0].length}]:oe?S(W,X):$(W,X)}e.$Fj=k;function A(W,X){const oe=Q(W,W.toLowerCase(),0,X,X.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return oe?Z(oe):null}e.$Gj=A;function j(W,X,oe,ge,Ee,Pe){const Ne=Math.min(13,W.length);for(;oe<Ne;oe++){const Fe=Q(W,X,oe,ge,Ee,Pe,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(Fe)return Fe}return[0,Pe]}e.$Hj=j;function Z(W){if(typeof W>"u")return[];const X=[],oe=W[1];for(let ge=W.length-1;ge>1;ge--){const Ee=W[ge]+oe,Pe=X[X.length-1];Pe&&Pe.end===Ee?Pe.end=Ee+1:X.push({start:Ee,end:Ee+1})}return X}e.$Ij=Z;const ae=128;function K(){const W=[],X=[];for(let oe=0;oe<=ae;oe++)X[oe]=0;for(let oe=0;oe<=ae;oe++)W.push(X.slice(0));return W}function se(W){const X=[];for(let oe=0;oe<=W;oe++)X[oe]=0;return X}const ue=se(2*ae),x=se(2*ae),he=K(),V=K(),te=K(),G=!1;function J(W,X,oe,ge,Ee){function Pe(Fe,$e,ke=" "){for(;Fe.length<$e;)Fe=ke+Fe;return Fe}let Ne=` |   |${ge.split("").map(Fe=>Pe(Fe,3)).join("|")}
`;for(let Fe=0;Fe<=oe;Fe++)Fe===0?Ne+=" |":Ne+=`${X[Fe-1]}|`,Ne+=W[Fe].slice(0,Ee+1).map($e=>Pe($e.toString(),3)).join("|")+`
`;return Ne}function q(W,X,oe,ge){W=W.substr(X),oe=oe.substr(ge),console.log(J(V,W,W.length,oe,oe.length)),console.log(J(te,W,W.length,oe,oe.length)),console.log(J(he,W,W.length,oe,oe.length))}function ne(W,X){if(X<0||X>=W.length)return!1;const oe=W.codePointAt(X);switch(oe){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!R.$gf(oe)}}function me(W,X){if(X<0||X>=W.length)return!1;switch(W.charCodeAt(X)){case 32:case 9:return!0;default:return!1}}function re(W,X,oe){return X[W]!==oe[W]}function B(W,X,oe,ge,Ee,Pe,Ne=!1){for(;X<oe&&Ee<Pe;)W[X]===ge[Ee]&&(Ne&&(ue[X]=Ee),X+=1),Ee+=1;return X===oe}e.$Jj=B;var ee;(function(W){W[W.Diag=1]="Diag",W[W.Left=2]="Left",W[W.LeftLeft=3]="LeftLeft"})(ee||(ee={}));var O;(function(W){W.Default=[-100,0];function X(oe){return!oe||oe.length===2&&oe[0]===-100&&oe[1]===0}W.isDefault=X})(O||(e.FuzzyScore=O={}));class N{constructor(X,oe){this.firstMatchCanBeWeak=X,this.boostFullMatch=oe}}e.$Kj=N,N.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function Q(W,X,oe,ge,Ee,Pe,Ne=N.default){const Fe=W.length>ae?ae:W.length,$e=ge.length>ae?ae:ge.length;if(oe>=Fe||Pe>=$e||Fe-oe>$e-Pe||!B(X,oe,Fe,Ee,Pe,$e,!0))return;T(Fe,$e,oe,Pe,X,Ee);let ke=1,ve=1,Me=oe,Ue=Pe;const Ye=[!1];for(ke=1,Me=oe;Me<Fe;ke++,Me++){const de=ue[Me],Se=x[Me],Ie=Me+1<Fe?x[Me+1]:$e;for(ve=de-Pe+1,Ue=de;Ue<Ie;ve++,Ue++){let Le=Number.MIN_SAFE_INTEGER,Be=!1;Ue<=Se&&(Le=H(W,X,Me,oe,ge,Ee,Ue,$e,Pe,he[ke-1][ve-1]===0,Ye));let ze=0;Le!==Number.MAX_SAFE_INTEGER&&(Be=!0,ze=Le+V[ke-1][ve-1]);const He=Ue>de,Ge=He?V[ke][ve-1]+(he[ke][ve-1]>0?-5:0):0,Qe=Ue>de+1&&he[ke][ve-1]>0,We=Qe?V[ke][ve-2]+(he[ke][ve-2]>0?-5:0):0;if(Qe&&(!He||We>=Ge)&&(!Be||We>=ze))V[ke][ve]=We,te[ke][ve]=3,he[ke][ve]=0;else if(He&&(!Be||Ge>=ze))V[ke][ve]=Ge,te[ke][ve]=2,he[ke][ve]=0;else if(Be)V[ke][ve]=ze,te[ke][ve]=1,he[ke][ve]=he[ke-1][ve-1]+1;else throw new Error("not possible")}}if(G&&q(W,oe,ge,Pe),!Ye[0]&&!Ne.firstMatchCanBeWeak)return;ke--,ve--;const qe=[V[ke][ve],Pe];let Je=0,Ze=0;for(;ke>=1;){let de=ve;do{const Se=te[ke][de];if(Se===3)de=de-2;else if(Se===2)de=de-1;else break}while(de>=1);Je>1&&X[oe+ke-1]===Ee[Pe+ve-1]&&!re(de+Pe-1,ge,Ee)&&Je+1>he[ke][de]&&(de=ve),de===ve?Je++:Je=1,Ze||(Ze=de),ke--,ve=de-1,qe.push(ve)}$e===Fe&&Ne.boostFullMatch&&(qe[0]+=2);const xe=Ze-Fe;return qe[0]-=xe,qe}e.$Lj=Q;function T(W,X,oe,ge,Ee,Pe){let Ne=W-1,Fe=X-1;for(;Ne>=oe&&Fe>=ge;)Ee[Ne]===Pe[Fe]&&(x[Ne]=Fe,Ne--),Fe--}function H(W,X,oe,ge,Ee,Pe,Ne,Fe,$e,ke,ve){if(X[oe]!==Pe[Ne])return Number.MIN_SAFE_INTEGER;let Me=1,Ue=!1;return Ne===oe-ge?Me=W[oe]===Ee[Ne]?7:5:re(Ne,Ee,Pe)&&(Ne===0||!re(Ne-1,Ee,Pe))?(Me=W[oe]===Ee[Ne]?7:5,Ue=!0):ne(Pe,Ne)&&(Ne===0||!ne(Pe,Ne-1))?Me=5:(ne(Pe,Ne-1)||me(Pe,Ne-1))&&(Me=5,Ue=!0),Me>1&&oe===ge&&(ve[0]=!0),Ue||(Ue=re(Ne,Ee,Pe)||ne(Pe,Ne-1)||me(Pe,Ne-1)),oe===ge?Ne>$e&&(Me-=Ue?3:5):ke?Me+=Ue?2:0:Me+=Ue?0:1,Ne+1===Fe&&(Me-=Ue?3:5),Me}function U(W,X,oe,ge,Ee,Pe,Ne){return z(W,X,oe,ge,Ee,Pe,!0,Ne)}e.$Mj=U;function ie(W,X,oe,ge,Ee,Pe,Ne){return z(W,X,oe,ge,Ee,Pe,!1,Ne)}e.$Nj=ie;function z(W,X,oe,ge,Ee,Pe,Ne,Fe){let $e=Q(W,X,oe,ge,Ee,Pe,Fe);if($e&&!Ne)return $e;if(W.length>=3){const ke=Math.min(7,W.length-1);for(let ve=oe+1;ve<ke;ve++){const Me=_(W,ve);if(Me){const Ue=Q(Me,Me.toLowerCase(),oe,ge,Ee,Pe,Fe);Ue&&(Ue[0]-=3,(!$e||Ue[0]>$e[0])&&($e=Ue))}}}return $e}function _(W,X){if(X+1>=W.length)return;const oe=W[X],ge=W[X+1];if(oe!==ge)return W.slice(0,X)+ge+oe+W.slice(X+2)}}),define(we[61],pe([1,0,17]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fi=e.$Ei=e.$Di=e.$Ci=e.$Bi=e.$Ai=e.$zi=void 0;function R(f){return r(f,0)}e.$zi=R;function r(f,u){switch(typeof f){case"object":return f===null?P(349,u):Array.isArray(f)?w(f,u):b(f,u);case"string":return I(f,u);case"boolean":return L(f,u);case"number":return P(f,u);case"undefined":return P(937,u);default:return P(617,u)}}e.$Ai=r;function P(f,u){return(u<<5)-u+f|0}e.$Bi=P;function L(f,u){return P(f?433:863,u)}function I(f,u){u=P(149417,u);for(let c=0,p=f.length;c<p;c++)u=P(f.charCodeAt(c),u);return u}e.$Ci=I;function w(f,u){return u=P(104579,u),f.reduce((c,p)=>r(p,c),u)}function b(f,u){return u=P(181387,u),Object.keys(f).sort().reduce((c,p)=>(c=I(p,c),r(f[p],c)),u)}class C{constructor(){this.g=0}get value(){return this.g}hash(u){return this.g=r(u,this.g),this.g}}e.$Di=C;var E;(function(f){f[f.BLOCK_SIZE=64]="BLOCK_SIZE",f[f.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(E||(E={}));function v(f,u,c=32){const p=c-u,h=~((1<<p)-1);return(f<<u|(h&f)>>>p)>>>0}function d(f,u=0,c=f.byteLength,p=0){for(let h=0;h<c;h++)f[u+h]=p}function g(f,u,c="0"){for(;f.length<u;)f=c+f;return f}function m(f,u=32){return f instanceof ArrayBuffer?Array.from(new Uint8Array(f)).map(c=>c.toString(16).padStart(2,"0")).join(""):g((f>>>0).toString(16),u/4)}e.$Ei=m;class l{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(u){const c=u.length;if(c===0)return;const p=this.p;let h=this.r,t=this.u,s,o;for(t!==0?(s=t,o=-1,t=0):(s=u.charCodeAt(0),o=0);;){let i=s;if(y.$4e(s))if(o+1<c){const n=u.charCodeAt(o+1);y.$5e(n)?(o++,i=y.$6e(s,n)):i=65533}else{t=s;break}else y.$5e(s)&&(i=65533);if(h=this.w(p,h,i),o++,o<c)s=u.charCodeAt(o);else break}this.r=h,this.u=t}w(u,c,p){return p<128?u[c++]=p:p<2048?(u[c++]=192|(p&1984)>>>6,u[c++]=128|(p&63)>>>0):p<65536?(u[c++]=224|(p&61440)>>>12,u[c++]=128|(p&4032)>>>6,u[c++]=128|(p&63)>>>0):(u[c++]=240|(p&1835008)>>>18,u[c++]=128|(p&258048)>>>12,u[c++]=128|(p&4032)>>>6,u[c++]=128|(p&63)>>>0),c>=64&&(this.y(),c-=64,this.t+=64,u[0]=u[64+0],u[1]=u[64+1],u[2]=u[64+2]),c}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),m(this.h)+m(this.l)+m(this.m)+m(this.n)+m(this.o)}x(){this.p[this.r++]=128,d(this.p,this.r),this.r>56&&(this.y(),d(this.p));const u=8*this.t;this.q.setUint32(56,Math.floor(u/4294967296),!1),this.q.setUint32(60,u%4294967296,!1),this.y()}y(){const u=l.g,c=this.q;for(let $=0;$<64;$+=4)u.setUint32($,c.getUint32($,!1),!1);for(let $=64;$<320;$+=4)u.setUint32($,v(u.getUint32($-12,!1)^u.getUint32($-32,!1)^u.getUint32($-56,!1)^u.getUint32($-64,!1),1),!1);let p=this.h,h=this.l,t=this.m,s=this.n,o=this.o,i,n,a;for(let $=0;$<80;$++)$<20?(i=h&t|~h&s,n=1518500249):$<40?(i=h^t^s,n=1859775393):$<60?(i=h&t|h&s|t&s,n=2400959708):(i=h^t^s,n=3395469782),a=v(p,5)+i+o+n+u.getUint32($*4,!1)&4294967295,o=s,s=t,t=v(h,30),h=p,p=a;this.h=this.h+p&4294967295,this.l=this.l+h&4294967295,this.m=this.m+t&4294967295,this.n=this.n+s&4294967295,this.o=this.o+o&4294967295}}e.$Fi=l,l.g=new DataView(new ArrayBuffer(320))}),define(we[62],pe([1,0,17]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var R;(function(r){r[r.Ignore=0]="Ignore",r[r.Info=1]="Info",r[r.Warning=2]="Warning",r[r.Error=3]="Error"})(R||(R={})),function(r){const P="error",L="warning",I="warn",w="info",b="ignore";function C(v){return v?y.$Ze(P,v)?r.Error:y.$Ze(L,v)||y.$Ze(I,v)?r.Warning:y.$Ze(w,v)?r.Info:r.Ignore:r.Ignore}r.fromValue=C;function E(v){switch(v){case r.Error:return P;case r.Warning:return L;case r.Info:return w;default:return b}}r.toString=E}(R||(R={})),e.default=R}),define(we[148],pe([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Id=void 0,e.$Id=Symbol("MicrotaskDelay")}),define(we[63],pe([1,0,18,17]),function(le,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=void 0;class r{constructor(){this.b="",this.c=0}reset(d){return this.b=d,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(d){const g=d.charCodeAt(0),m=this.b.charCodeAt(this.c);return g-m}value(){return this.b[this.c]}}e.$Nh=r;class P{constructor(d=!0){this.e=d}reset(d){return this.b=d,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let d=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(d)this.c++;else break;else d=!1;return this}cmp(d){return this.e?(0,R.$Te)(d,this.b,0,d.length,this.c,this.d):(0,R.$Ve)(d,this.b,0,d.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Oh=P;class L{constructor(d=!0,g=!0){this.f=d,this.g=g}reset(d){this.d=0,this.e=0,this.b=d,this.c=d.length;for(let g=d.length-1;g>=0;g--,this.c--){const m=this.b.charCodeAt(g);if(!(m===47||this.f&&m===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let d=!0;for(;this.e<this.c;this.e++){const g=this.b.charCodeAt(this.e);if(g===47||this.f&&g===92)if(d)this.d++;else break;else d=!1}return this}cmp(d){return this.g?(0,R.$Te)(d,this.b,0,d.length,this.d,this.e):(0,R.$Ve)(d,this.b,0,d.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Ph=L;var I;(function(v){v[v.Scheme=1]="Scheme",v[v.Authority=2]="Authority",v[v.Path=3]="Path",v[v.Query=4]="Query",v[v.Fragment=5]="Fragment"})(I||(I={}));class w{constructor(d,g){this.f=d,this.g=g,this.d=[],this.e=0}reset(d){return this.c=d,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new L(!1,!this.f(d)),this.b.reset(d.path),this.b.value()&&this.d.push(3)),this.g(d)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(d){if(this.d[this.e]===1)return(0,R.$Ue)(d,this.c.scheme);if(this.d[this.e]===2)return(0,R.$Ue)(d,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(d);if(this.d[this.e]===4)return(0,R.$Se)(d,this.c.query);if(this.d[this.e]===5)return(0,R.$Se)(d,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$Qh=w;class b{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const d=this.right;return this.right=d.left,d.left=this,this.updateHeight(),d.updateHeight(),d}rotateRight(){const d=this.left;return this.left=d.right,d.right=this,this.updateHeight(),d.updateHeight(),d}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var C;(function(v){v[v.Left=-1]="Left",v[v.Mid=0]="Mid",v[v.Right=1]="Right"})(C||(C={}));class E{static forUris(d=()=>!1,g=()=>!1){return new E(new w(d,g))}static forPaths(d=!1){return new E(new L(void 0,!d))}static forStrings(){return new E(new r)}static forConfigKeys(){return new E(new P)}constructor(d){this.b=d}clear(){this.c=void 0}fill(d,g){if(g){const m=g.slice(0);(0,y.$Vb)(m);for(const l of m)this.set(l,d)}else{const m=d.slice(0);(0,y.$Vb)(m);for(const l of m)this.set(l[0],l[1])}}set(d,g){const m=this.b.reset(d);let l;this.c||(this.c=new b,this.c.segment=m.value());const f=[];for(l=this.c;;){const c=m.cmp(l.segment);if(c>0)l.left||(l.left=new b,l.left.segment=m.value()),f.push([-1,l]),l=l.left;else if(c<0)l.right||(l.right=new b,l.right.segment=m.value()),f.push([1,l]),l=l.right;else if(m.hasNext())m.next(),l.mid||(l.mid=new b,l.mid.segment=m.value()),f.push([0,l]),l=l.mid;else break}const u=l.value;l.value=g,l.key=d;for(let c=f.length-1;c>=0;c--){const p=f[c][1];p.updateHeight();const h=p.balanceFactor();if(h<-1||h>1){const t=f[c][0],s=f[c+1][0];if(t===1&&s===1)f[c][1]=p.rotateLeft();else if(t===-1&&s===-1)f[c][1]=p.rotateRight();else if(t===1&&s===-1)p.right=f[c+1][1]=f[c+1][1].rotateRight(),f[c][1]=p.rotateLeft();else if(t===-1&&s===1)p.left=f[c+1][1]=f[c+1][1].rotateLeft(),f[c][1]=p.rotateRight();else throw new Error;if(c>0)switch(f[c-1][0]){case-1:f[c-1][1].left=f[c][1];break;case 1:f[c-1][1].right=f[c][1];break;case 0:f[c-1][1].mid=f[c][1];break}else this.c=f[0][1]}}return u}get(d){return this.d(d)?.value}d(d){const g=this.b.reset(d);let m=this.c;for(;m;){const l=g.cmp(m.segment);if(l>0)m=m.left;else if(l<0)m=m.right;else if(g.hasNext())g.next(),m=m.mid;else break}return m}has(d){const g=this.d(d);return!(g?.value===void 0&&g?.mid===void 0)}delete(d){return this.e(d,!1)}deleteSuperstr(d){return this.e(d,!0)}e(d,g){const m=this.b.reset(d),l=[];let f=this.c;for(;f;){const u=m.cmp(f.segment);if(u>0)l.push([-1,f]),f=f.left;else if(u<0)l.push([1,f]),f=f.right;else if(m.hasNext())m.next(),l.push([0,f]),f=f.mid;else break}if(f){if(g?(f.left=void 0,f.mid=void 0,f.right=void 0,f.height=1):(f.key=void 0,f.value=void 0),!f.mid&&!f.value)if(f.left&&f.right){const u=this.f(f.right);if(u.key){const{key:c,value:p,segment:h}=u;this.e(u.key,!1),f.key=c,f.value=p,f.segment=h}}else{const u=f.left??f.right;if(l.length>0){const[c,p]=l[l.length-1];switch(c){case-1:p.left=u;break;case 0:p.mid=u;break;case 1:p.right=u;break}}else this.c=u}for(let u=l.length-1;u>=0;u--){const c=l[u][1];c.updateHeight();const p=c.balanceFactor();if(p>1?(c.right.balanceFactor()>=0||(c.right=c.right.rotateRight()),l[u][1]=c.rotateLeft()):p<-1&&(c.left.balanceFactor()<=0||(c.left=c.left.rotateLeft()),l[u][1]=c.rotateRight()),u>0)switch(l[u-1][0]){case-1:l[u-1][1].left=l[u][1];break;case 1:l[u-1][1].right=l[u][1];break;case 0:l[u-1][1].mid=l[u][1];break}else this.c=l[0][1]}}}f(d){for(;d.left;)d=d.left;return d}findSubstr(d){const g=this.b.reset(d);let m=this.c,l;for(;m;){const f=g.cmp(m.segment);if(f>0)m=m.left;else if(f<0)m=m.right;else if(g.hasNext())g.next(),l=m.value||l,m=m.mid;else break}return m&&m.value||l}findSuperstr(d){return this.g(d,!1)}g(d,g){const m=this.b.reset(d);let l=this.c;for(;l;){const f=m.cmp(l.segment);if(f>0)l=l.left;else if(f<0)l=l.right;else if(m.hasNext())m.next(),l=l.mid;else return l.mid?this.h(l.mid):g?l.value:void 0}}hasElementOrSubtree(d){return this.g(d,!0)!==void 0}forEach(d){for(const[g,m]of this)d(m,g)}*[Symbol.iterator](){yield*this.h(this.c)}h(d){const g=[];return this.j(d,g),g[Symbol.iterator]()}j(d,g){d&&(d.left&&this.j(d.left,g),d.value&&g.push([d.key,d.value]),d.mid&&this.j(d.mid,g),d.right&&this.j(d.right,g))}_isBalanced(){const d=g=>{if(!g)return!0;const m=g.balanceFactor();return m<-1||m>1?!1:d(g.left)&&d(g.right)};return d(this.c)}}e.$Rh=E}),define(we[8],pe([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nf=e.$Mf=e.$Lf=e.$Kf=e.$Jf=e.$If=e.$Hf=e.$Gf=e.$Ff=e.$Ef=e.$Df=e.$Cf=e.$Bf=e.$Af=e.$zf=e.$yf=e.$xf=e.$wf=void 0;function y(h){return typeof h=="string"}e.$wf=y;function R(h){return Array.isArray(h)&&h.every(t=>y(t))}e.$xf=R;function r(h){return typeof h=="object"&&h!==null&&!Array.isArray(h)&&!(h instanceof RegExp)&&!(h instanceof Date)}e.$yf=r;function P(h){const t=Object.getPrototypeOf(Uint8Array);return typeof h=="object"&&h instanceof t}e.$zf=P;function L(h){return typeof h=="number"&&!isNaN(h)}e.$Af=L;function I(h){return!!h&&typeof h[Symbol.iterator]=="function"}e.$Bf=I;function w(h){return h===!0||h===!1}e.$Cf=w;function b(h){return typeof h>"u"}e.$Df=b;function C(h){return!E(h)}e.$Ef=C;function E(h){return b(h)||h===null}e.$Ff=E;function v(h,t){if(!h)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.$Gf=v;function d(h){if(E(h))throw new Error("Assertion Failed: argument is undefined or null");return h}e.$Hf=d;function g(...h){const t=[];for(let s=0;s<h.length;s++){const o=h[s];if(E(o))throw new Error(`Assertion Failed: argument at index ${s} is undefined or null`);t.push(o)}return t}e.$If=g;const m=Object.prototype.hasOwnProperty;function l(h){if(!r(h))return!1;for(const t in h)if(m.call(h,t))return!1;return!0}e.$Jf=l;function f(h){return typeof h=="function"}e.$Kf=f;function u(...h){return h.length>0&&h.every(f)}e.$Lf=u;function c(h,t){const s=Math.min(h.length,t.length);for(let o=0;o<s;o++)p(h[o],t[o])}e.$Mf=c;function p(h,t){if(y(t)){if(typeof h!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(f(t)){try{if(h instanceof t)return}catch{}if(!E(h)&&h.constructor===t||t.length===1&&t.call(void 0,h)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$Nf=p}),define(we[49],pe([1,0,8]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qj=e.$Pj=e.$Oj=void 0;const R=Object.create(null);function r(I,w){if((0,y.$wf)(w)){const b=R[w];if(b===void 0)throw new Error(`${I} references an unknown codicon: ${w}`);w=b}return R[I]=w,{id:I}}function P(){return R}e.$Oj=P;function L(){return Object.values(e.$Qj)}e.$Pj=L,e.$Qj={add:r("add",6e4),plus:r("plus",6e4),gistNew:r("gist-new",6e4),repoCreate:r("repo-create",6e4),lightbulb:r("lightbulb",60001),lightBulb:r("light-bulb",60001),repo:r("repo",60002),repoDelete:r("repo-delete",60002),gistFork:r("gist-fork",60003),repoForked:r("repo-forked",60003),gitPullRequest:r("git-pull-request",60004),gitPullRequestAbandoned:r("git-pull-request-abandoned",60004),recordKeys:r("record-keys",60005),keyboard:r("keyboard",60005),tag:r("tag",60006),tagAdd:r("tag-add",60006),tagRemove:r("tag-remove",60006),gitPullRequestLabel:r("git-pull-request-label",60006),person:r("person",60007),personFollow:r("person-follow",60007),personOutline:r("person-outline",60007),personFilled:r("person-filled",60007),gitBranch:r("git-branch",60008),gitBranchCreate:r("git-branch-create",60008),gitBranchDelete:r("git-branch-delete",60008),sourceControl:r("source-control",60008),mirror:r("mirror",60009),mirrorPublic:r("mirror-public",60009),star:r("star",60010),starAdd:r("star-add",60010),starDelete:r("star-delete",60010),starEmpty:r("star-empty",60010),comment:r("comment",60011),commentAdd:r("comment-add",60011),alert:r("alert",60012),warning:r("warning",60012),search:r("search",60013),searchSave:r("search-save",60013),logOut:r("log-out",60014),signOut:r("sign-out",60014),logIn:r("log-in",60015),signIn:r("sign-in",60015),eye:r("eye",60016),eyeUnwatch:r("eye-unwatch",60016),eyeWatch:r("eye-watch",60016),circleFilled:r("circle-filled",60017),primitiveDot:r("primitive-dot",60017),closeDirty:r("close-dirty",60017),debugBreakpoint:r("debug-breakpoint",60017),debugBreakpointDisabled:r("debug-breakpoint-disabled",60017),debugHint:r("debug-hint",60017),primitiveSquare:r("primitive-square",60018),edit:r("edit",60019),pencil:r("pencil",60019),info:r("info",60020),issueOpened:r("issue-opened",60020),gistPrivate:r("gist-private",60021),gitForkPrivate:r("git-fork-private",60021),lock:r("lock",60021),mirrorPrivate:r("mirror-private",60021),close:r("close",60022),removeClose:r("remove-close",60022),x:r("x",60022),repoSync:r("repo-sync",60023),sync:r("sync",60023),clone:r("clone",60024),desktopDownload:r("desktop-download",60024),beaker:r("beaker",60025),microscope:r("microscope",60025),vm:r("vm",60026),deviceDesktop:r("device-desktop",60026),file:r("file",60027),fileText:r("file-text",60027),more:r("more",60028),ellipsis:r("ellipsis",60028),kebabHorizontal:r("kebab-horizontal",60028),mailReply:r("mail-reply",60029),reply:r("reply",60029),organization:r("organization",60030),organizationFilled:r("organization-filled",60030),organizationOutline:r("organization-outline",60030),newFile:r("new-file",60031),fileAdd:r("file-add",60031),newFolder:r("new-folder",60032),fileDirectoryCreate:r("file-directory-create",60032),trash:r("trash",60033),trashcan:r("trashcan",60033),history:r("history",60034),clock:r("clock",60034),folder:r("folder",60035),fileDirectory:r("file-directory",60035),symbolFolder:r("symbol-folder",60035),logoGithub:r("logo-github",60036),markGithub:r("mark-github",60036),github:r("github",60036),terminal:r("terminal",60037),console:r("console",60037),repl:r("repl",60037),zap:r("zap",60038),symbolEvent:r("symbol-event",60038),error:r("error",60039),stop:r("stop",60039),variable:r("variable",60040),symbolVariable:r("symbol-variable",60040),array:r("array",60042),symbolArray:r("symbol-array",60042),symbolModule:r("symbol-module",60043),symbolPackage:r("symbol-package",60043),symbolNamespace:r("symbol-namespace",60043),symbolObject:r("symbol-object",60043),symbolMethod:r("symbol-method",60044),symbolFunction:r("symbol-function",60044),symbolConstructor:r("symbol-constructor",60044),symbolBoolean:r("symbol-boolean",60047),symbolNull:r("symbol-null",60047),symbolNumeric:r("symbol-numeric",60048),symbolNumber:r("symbol-number",60048),symbolStructure:r("symbol-structure",60049),symbolStruct:r("symbol-struct",60049),symbolParameter:r("symbol-parameter",60050),symbolTypeParameter:r("symbol-type-parameter",60050),symbolKey:r("symbol-key",60051),symbolText:r("symbol-text",60051),symbolReference:r("symbol-reference",60052),goToFile:r("go-to-file",60052),symbolEnum:r("symbol-enum",60053),symbolValue:r("symbol-value",60053),symbolRuler:r("symbol-ruler",60054),symbolUnit:r("symbol-unit",60054),activateBreakpoints:r("activate-breakpoints",60055),archive:r("archive",60056),arrowBoth:r("arrow-both",60057),arrowDown:r("arrow-down",60058),arrowLeft:r("arrow-left",60059),arrowRight:r("arrow-right",60060),arrowSmallDown:r("arrow-small-down",60061),arrowSmallLeft:r("arrow-small-left",60062),arrowSmallRight:r("arrow-small-right",60063),arrowSmallUp:r("arrow-small-up",60064),arrowUp:r("arrow-up",60065),bell:r("bell",60066),bold:r("bold",60067),book:r("book",60068),bookmark:r("bookmark",60069),debugBreakpointConditionalUnverified:r("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:r("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:r("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:r("debug-breakpoint-data-unverified",60072),debugBreakpointData:r("debug-breakpoint-data",60073),debugBreakpointDataDisabled:r("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:r("debug-breakpoint-log-unverified",60074),debugBreakpointLog:r("debug-breakpoint-log",60075),debugBreakpointLogDisabled:r("debug-breakpoint-log-disabled",60075),briefcase:r("briefcase",60076),broadcast:r("broadcast",60077),browser:r("browser",60078),bug:r("bug",60079),calendar:r("calendar",60080),caseSensitive:r("case-sensitive",60081),check:r("check",60082),checklist:r("checklist",60083),chevronDown:r("chevron-down",60084),dropDownButton:r("drop-down-button",60084),chevronLeft:r("chevron-left",60085),chevronRight:r("chevron-right",60086),chevronUp:r("chevron-up",60087),chromeClose:r("chrome-close",60088),chromeMaximize:r("chrome-maximize",60089),chromeMinimize:r("chrome-minimize",60090),chromeRestore:r("chrome-restore",60091),circle:r("circle",60092),circleOutline:r("circle-outline",60092),debugBreakpointUnverified:r("debug-breakpoint-unverified",60092),circleSlash:r("circle-slash",60093),circuitBoard:r("circuit-board",60094),clearAll:r("clear-all",60095),clippy:r("clippy",60096),closeAll:r("close-all",60097),cloudDownload:r("cloud-download",60098),cloudUpload:r("cloud-upload",60099),code:r("code",60100),collapseAll:r("collapse-all",60101),colorMode:r("color-mode",60102),commentDiscussion:r("comment-discussion",60103),compareChanges:r("compare-changes",60157),creditCard:r("credit-card",60105),dash:r("dash",60108),dashboard:r("dashboard",60109),database:r("database",60110),debugContinue:r("debug-continue",60111),debugDisconnect:r("debug-disconnect",60112),debugPause:r("debug-pause",60113),debugRestart:r("debug-restart",60114),debugStart:r("debug-start",60115),debugStepInto:r("debug-step-into",60116),debugStepOut:r("debug-step-out",60117),debugStepOver:r("debug-step-over",60118),debugStop:r("debug-stop",60119),debug:r("debug",60120),deviceCameraVideo:r("device-camera-video",60121),deviceCamera:r("device-camera",60122),deviceMobile:r("device-mobile",60123),diffAdded:r("diff-added",60124),diffIgnored:r("diff-ignored",60125),diffModified:r("diff-modified",60126),diffRemoved:r("diff-removed",60127),diffRenamed:r("diff-renamed",60128),diff:r("diff",60129),discard:r("discard",60130),editorLayout:r("editor-layout",60131),emptyWindow:r("empty-window",60132),exclude:r("exclude",60133),extensions:r("extensions",60134),eyeClosed:r("eye-closed",60135),fileBinary:r("file-binary",60136),fileCode:r("file-code",60137),fileMedia:r("file-media",60138),filePdf:r("file-pdf",60139),fileSubmodule:r("file-submodule",60140),fileSymlinkDirectory:r("file-symlink-directory",60141),fileSymlinkFile:r("file-symlink-file",60142),fileZip:r("file-zip",60143),files:r("files",60144),filter:r("filter",60145),flame:r("flame",60146),foldDown:r("fold-down",60147),foldUp:r("fold-up",60148),fold:r("fold",60149),folderActive:r("folder-active",60150),folderOpened:r("folder-opened",60151),gear:r("gear",60152),gift:r("gift",60153),gistSecret:r("gist-secret",60154),gist:r("gist",60155),gitCommit:r("git-commit",60156),gitCompare:r("git-compare",60157),gitMerge:r("git-merge",60158),githubAction:r("github-action",60159),githubAlt:r("github-alt",60160),globe:r("globe",60161),grabber:r("grabber",60162),graph:r("graph",60163),gripper:r("gripper",60164),heart:r("heart",60165),home:r("home",60166),horizontalRule:r("horizontal-rule",60167),hubot:r("hubot",60168),inbox:r("inbox",60169),issueClosed:r("issue-closed",60324),issueReopened:r("issue-reopened",60171),issues:r("issues",60172),italic:r("italic",60173),jersey:r("jersey",60174),json:r("json",60175),bracket:r("bracket",60175),kebabVertical:r("kebab-vertical",60176),key:r("key",60177),law:r("law",60178),lightbulbAutofix:r("lightbulb-autofix",60179),linkExternal:r("link-external",60180),link:r("link",60181),listOrdered:r("list-ordered",60182),listUnordered:r("list-unordered",60183),liveShare:r("live-share",60184),loading:r("loading",60185),location:r("location",60186),mailRead:r("mail-read",60187),mail:r("mail",60188),markdown:r("markdown",60189),megaphone:r("megaphone",60190),mention:r("mention",60191),milestone:r("milestone",60192),gitPullRequestMilestone:r("git-pull-request-milestone",60192),mortarBoard:r("mortar-board",60193),move:r("move",60194),multipleWindows:r("multiple-windows",60195),mute:r("mute",60196),noNewline:r("no-newline",60197),note:r("note",60198),octoface:r("octoface",60199),openPreview:r("open-preview",60200),package:r("package",60201),paintcan:r("paintcan",60202),pin:r("pin",60203),play:r("play",60204),run:r("run",60204),plug:r("plug",60205),preserveCase:r("preserve-case",60206),preview:r("preview",60207),project:r("project",60208),pulse:r("pulse",60209),question:r("question",60210),quote:r("quote",60211),radioTower:r("radio-tower",60212),reactions:r("reactions",60213),references:r("references",60214),refresh:r("refresh",60215),regex:r("regex",60216),remoteExplorer:r("remote-explorer",60217),remote:r("remote",60218),remove:r("remove",60219),replaceAll:r("replace-all",60220),replace:r("replace",60221),repoClone:r("repo-clone",60222),repoForcePush:r("repo-force-push",60223),repoPull:r("repo-pull",60224),repoPush:r("repo-push",60225),report:r("report",60226),requestChanges:r("request-changes",60227),rocket:r("rocket",60228),rootFolderOpened:r("root-folder-opened",60229),rootFolder:r("root-folder",60230),rss:r("rss",60231),ruby:r("ruby",60232),saveAll:r("save-all",60233),saveAs:r("save-as",60234),save:r("save",60235),screenFull:r("screen-full",60236),screenNormal:r("screen-normal",60237),searchStop:r("search-stop",60238),server:r("server",60240),settingsGear:r("settings-gear",60241),settings:r("settings",60242),shield:r("shield",60243),smiley:r("smiley",60244),sortPrecedence:r("sort-precedence",60245),splitHorizontal:r("split-horizontal",60246),splitVertical:r("split-vertical",60247),squirrel:r("squirrel",60248),starFull:r("star-full",60249),starHalf:r("star-half",60250),symbolClass:r("symbol-class",60251),symbolColor:r("symbol-color",60252),symbolCustomColor:r("symbol-customcolor",60252),symbolConstant:r("symbol-constant",60253),symbolEnumMember:r("symbol-enum-member",60254),symbolField:r("symbol-field",60255),symbolFile:r("symbol-file",60256),symbolInterface:r("symbol-interface",60257),symbolKeyword:r("symbol-keyword",60258),symbolMisc:r("symbol-misc",60259),symbolOperator:r("symbol-operator",60260),symbolProperty:r("symbol-property",60261),wrench:r("wrench",60261),wrenchSubaction:r("wrench-subaction",60261),symbolSnippet:r("symbol-snippet",60262),tasklist:r("tasklist",60263),telescope:r("telescope",60264),textSize:r("text-size",60265),threeBars:r("three-bars",60266),thumbsdown:r("thumbsdown",60267),thumbsup:r("thumbsup",60268),tools:r("tools",60269),triangleDown:r("triangle-down",60270),triangleLeft:r("triangle-left",60271),triangleRight:r("triangle-right",60272),triangleUp:r("triangle-up",60273),twitter:r("twitter",60274),unfold:r("unfold",60275),unlock:r("unlock",60276),unmute:r("unmute",60277),unverified:r("unverified",60278),verified:r("verified",60279),versions:r("versions",60280),vmActive:r("vm-active",60281),vmOutline:r("vm-outline",60282),vmRunning:r("vm-running",60283),watch:r("watch",60284),whitespace:r("whitespace",60285),wholeWord:r("whole-word",60286),window:r("window",60287),wordWrap:r("word-wrap",60288),zoomIn:r("zoom-in",60289),zoomOut:r("zoom-out",60290),listFilter:r("list-filter",60291),listFlat:r("list-flat",60292),listSelection:r("list-selection",60293),selection:r("selection",60293),listTree:r("list-tree",60294),debugBreakpointFunctionUnverified:r("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:r("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:r("debug-breakpoint-function-disabled",60296),debugStackframeActive:r("debug-stackframe-active",60297),circleSmallFilled:r("circle-small-filled",60298),debugStackframeDot:r("debug-stackframe-dot",60298),debugStackframe:r("debug-stackframe",60299),debugStackframeFocused:r("debug-stackframe-focused",60299),debugBreakpointUnsupported:r("debug-breakpoint-unsupported",60300),symbolString:r("symbol-string",60301),debugReverseContinue:r("debug-reverse-continue",60302),debugStepBack:r("debug-step-back",60303),debugRestartFrame:r("debug-restart-frame",60304),callIncoming:r("call-incoming",60306),callOutgoing:r("call-outgoing",60307),menu:r("menu",60308),expandAll:r("expand-all",60309),feedback:r("feedback",60310),gitPullRequestReviewer:r("git-pull-request-reviewer",60310),groupByRefType:r("group-by-ref-type",60311),ungroupByRefType:r("ungroup-by-ref-type",60312),account:r("account",60313),gitPullRequestAssignee:r("git-pull-request-assignee",60313),bellDot:r("bell-dot",60314),debugConsole:r("debug-console",60315),library:r("library",60316),output:r("output",60317),runAll:r("run-all",60318),syncIgnored:r("sync-ignored",60319),pinned:r("pinned",60320),githubInverted:r("github-inverted",60321),debugAlt:r("debug-alt",60305),serverProcess:r("server-process",60322),serverEnvironment:r("server-environment",60323),pass:r("pass",60324),stopCircle:r("stop-circle",60325),playCircle:r("play-circle",60326),record:r("record",60327),debugAltSmall:r("debug-alt-small",60328),vmConnect:r("vm-connect",60329),cloud:r("cloud",60330),merge:r("merge",60331),exportIcon:r("export",60332),graphLeft:r("graph-left",60333),magnet:r("magnet",60334),notebook:r("notebook",60335),redo:r("redo",60336),checkAll:r("check-all",60337),pinnedDirty:r("pinned-dirty",60338),passFilled:r("pass-filled",60339),circleLargeFilled:r("circle-large-filled",60340),circleLarge:r("circle-large",60341),circleLargeOutline:r("circle-large-outline",60341),combine:r("combine",60342),gather:r("gather",60342),table:r("table",60343),variableGroup:r("variable-group",60344),typeHierarchy:r("type-hierarchy",60345),typeHierarchySub:r("type-hierarchy-sub",60346),typeHierarchySuper:r("type-hierarchy-super",60347),gitPullRequestCreate:r("git-pull-request-create",60348),runAbove:r("run-above",60349),runBelow:r("run-below",60350),notebookTemplate:r("notebook-template",60351),debugRerun:r("debug-rerun",60352),workspaceTrusted:r("workspace-trusted",60353),workspaceUntrusted:r("workspace-untrusted",60354),workspaceUnspecified:r("workspace-unspecified",60355),terminalCmd:r("terminal-cmd",60356),terminalDebian:r("terminal-debian",60357),terminalLinux:r("terminal-linux",60358),terminalPowershell:r("terminal-powershell",60359),terminalTmux:r("terminal-tmux",60360),terminalUbuntu:r("terminal-ubuntu",60361),terminalBash:r("terminal-bash",60362),arrowSwap:r("arrow-swap",60363),copy:r("copy",60364),personAdd:r("person-add",60365),filterFilled:r("filter-filled",60366),wand:r("wand",60367),debugLineByLine:r("debug-line-by-line",60368),inspect:r("inspect",60369),layers:r("layers",60370),layersDot:r("layers-dot",60371),layersActive:r("layers-active",60372),compass:r("compass",60373),compassDot:r("compass-dot",60374),compassActive:r("compass-active",60375),azure:r("azure",60376),issueDraft:r("issue-draft",60377),gitPullRequestClosed:r("git-pull-request-closed",60378),gitPullRequestDraft:r("git-pull-request-draft",60379),debugAll:r("debug-all",60380),debugCoverage:r("debug-coverage",60381),runErrors:r("run-errors",60382),folderLibrary:r("folder-library",60383),debugContinueSmall:r("debug-continue-small",60384),beakerStop:r("beaker-stop",60385),graphLine:r("graph-line",60386),graphScatter:r("graph-scatter",60387),pieChart:r("pie-chart",60388),bracketDot:r("bracket-dot",60389),bracketError:r("bracket-error",60390),lockSmall:r("lock-small",60391),azureDevops:r("azure-devops",60392),verifiedFilled:r("verified-filled",60393),newLine:r("newline",60394),layout:r("layout",60395),layoutActivitybarLeft:r("layout-activitybar-left",60396),layoutActivitybarRight:r("layout-activitybar-right",60397),layoutPanelLeft:r("layout-panel-left",60398),layoutPanelCenter:r("layout-panel-center",60399),layoutPanelJustify:r("layout-panel-justify",60400),layoutPanelRight:r("layout-panel-right",60401),layoutPanel:r("layout-panel",60402),layoutSidebarLeft:r("layout-sidebar-left",60403),layoutSidebarRight:r("layout-sidebar-right",60404),layoutStatusbar:r("layout-statusbar",60405),layoutMenubar:r("layout-menubar",60406),layoutCentered:r("layout-centered",60407),layoutSidebarRightOff:r("layout-sidebar-right-off",60416),layoutPanelOff:r("layout-panel-off",60417),layoutSidebarLeftOff:r("layout-sidebar-left-off",60418),target:r("target",60408),indent:r("indent",60409),recordSmall:r("record-small",60410),errorSmall:r("error-small",60411),arrowCircleDown:r("arrow-circle-down",60412),arrowCircleLeft:r("arrow-circle-left",60413),arrowCircleRight:r("arrow-circle-right",60414),arrowCircleUp:r("arrow-circle-up",60415),heartFilled:r("heart-filled",60420),map:r("map",60421),mapFilled:r("map-filled",60422),circleSmall:r("circle-small",60423),bellSlash:r("bell-slash",60424),bellSlashDot:r("bell-slash-dot",60425),commentUnresolved:r("comment-unresolved",60426),gitPullRequestGoToChanges:r("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:r("git-pull-request-new-changes",60428),searchFuzzy:r("search-fuzzy",60429),commentDraft:r("comment-draft",60430),send:r("send",60431),sparkle:r("sparkle",60432),insert:r("insert",60433),mic:r("mic",60434),dialogError:r("dialog-error","error"),dialogWarning:r("dialog-warning","warning"),dialogInfo:r("dialog-info","info"),dialogClose:r("dialog-close","close"),treeItemExpanded:r("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:r("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:r("tree-filter-on-type-off","list-selection"),treeFilterClear:r("tree-filter-clear","close"),treeItemLoading:r("tree-item-loading","loading"),menuSelection:r("menu-selection","check"),menuSubmenu:r("menu-submenu","chevron-right"),menuBarMore:r("menubar-more","more"),scrollbarButtonLeft:r("scrollbar-button-left","triangle-left"),scrollbarButtonRight:r("scrollbar-button-right","triangle-right"),scrollbarButtonUp:r("scrollbar-button-up","triangle-up"),scrollbarButtonDown:r("scrollbar-button-down","triangle-down"),toolBarMore:r("toolbar-more","more"),quickInputBack:r("quick-input-back","arrow-left")}}),define(we[38],pe([1,0,7,3,17,8]),function(le,e,y,R,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.$Tf=e.$Sf=e.$Rf=e.$Qf=e.$Pf=e.$Of=void 0;function L(a){return a===47||a===92}e.$Of=L;function I(a){return a.replace(/[\\/]/g,y.$ec.sep)}e.$Pf=I;function w(a){return a.indexOf("/")===-1&&(a=I(a)),/^[a-zA-Z]:(\/|$)/.test(a)&&(a="/"+a),a}e.$Qf=w;function b(a,$=y.$ec.sep){if(!a)return"";const S=a.length,D=a.charCodeAt(0);if(L(D)){if(L(a.charCodeAt(1))&&!L(a.charCodeAt(2))){let A=3;const j=A;for(;A<S&&!L(a.charCodeAt(A));A++);if(j!==A&&!L(a.charCodeAt(A+1))){for(A+=1;A<S;A++)if(L(a.charCodeAt(A)))return a.slice(0,A+1).replace(/[\\/]/g,$)}}return $}else if(f(D)&&a.charCodeAt(1)===58)return L(a.charCodeAt(2))?a.slice(0,2)+$:a.slice(0,2);let k=a.indexOf("://");if(k!==-1){for(k+=3;k<S;k++)if(L(a.charCodeAt(k)))return a.slice(0,k+1)}return""}e.$Rf=b;function C(a){if(!R.$d||!a||a.length<5)return!1;let $=a.charCodeAt(0);if($!==92||($=a.charCodeAt(1),$!==92))return!1;let S=2;const D=S;for(;S<a.length&&($=a.charCodeAt(S),$!==92);S++);return!(D===S||($=a.charCodeAt(S+1),isNaN($)||$===92))}e.$Sf=C;const E=/[\\/:\*\?"<>\|]/g,v=/[\\/]/g,d=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function g(a,$=R.$d){const S=$?E:v;return!(!a||a.length===0||/^\s+$/.test(a)||(S.lastIndex=0,S.test(a))||$&&d.test(a)||a==="."||a===".."||$&&a[a.length-1]==="."||$&&a.length!==a.trim().length||a.length>255)}e.$Tf=g;function m(a,$,S){const D=a===$;return!S||D?D:!a||!$?!1:(0,r.$Ze)(a,$)}e.$Uf=m;function l(a,$,S,D=y.sep){if(a===$)return!0;if(!a||!$||$.length>a.length)return!1;if(S){if(!(0,r.$1e)(a,$))return!1;if($.length===a.length)return!0;let A=$.length;return $.charAt($.length-1)===D&&A--,a.charAt(A)===D}return $.charAt($.length-1)!==D&&($+=D),a.indexOf($)===0}e.$Vf=l;function f(a){return a>=65&&a<=90||a>=97&&a<=122}e.$Wf=f;function u(a,$){return R.$d&&a.endsWith(":")&&(a+=y.sep),(0,y.$gc)(a)||(a=(0,y.$hc)($,a)),a=(0,y.$fc)(a),R.$d?(a=(0,r.$Ie)(a,y.sep),a.endsWith(":")&&(a+=y.sep)):(a=(0,r.$Ie)(a,y.sep),a||(a=y.sep)),a}e.$Xf=u;function c(a){const $=(0,y.$fc)(a);return R.$d?a.length>3?!1:p($)&&(a.length===2||$.charCodeAt(2)===92):$===y.$ec.sep}e.$Yf=c;function p(a,$=R.$d){return $?f(a.charCodeAt(0))&&a.charCodeAt(1)===58:!1}e.$Zf=p;function h(a,$=R.$d){return p(a,$)?a[0]:void 0}e.$1f=h;function t(a,$,S){return $.length>a.length?-1:a===$?0:(S&&(a=a.toLowerCase(),$=$.toLowerCase()),a.indexOf($))}e.$2f=t;function s(a){const $=a.split(":");let S,D,k;for(const A of $){const j=Number(A);(0,P.$Af)(j)?D===void 0?D=j:k===void 0&&(k=j):S=S?[S,A].join(":"):A}if(!S)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:S,line:D!==void 0?D:void 0,column:k!==void 0?k:D!==void 0?1:void 0}}e.$3f=s;const o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",i="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function n(a,$,S=8){let D="";for(let A=0;A<S;A++){let j;A===0&&R.$d&&!$&&(S===3||S===4)?j=i:j=o,D+=j.charAt(Math.floor(Math.random()*j.length))}let k;return $?k=`${$}-${D}`:k=D,a?(0,y.$hc)(a,k):k}e.$4f=n}),define(we[22],pe([1,0,8]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9m=e.$8m=e.$7m=e.$6m=e.$5m=e.$4m=e.$3m=e.$2m=e.$1m=e.$Zm=e.$Ym=e.$Xm=void 0;function R(f){if(!f||typeof f!="object"||f instanceof RegExp)return f;const u=Array.isArray(f)?[]:{};return Object.entries(f).forEach(([c,p])=>{u[c]=p&&typeof p=="object"?R(p):p}),u}e.$Xm=R;function r(f){if(!f||typeof f!="object")return f;const u=[f];for(;u.length>0;){const c=u.shift();Object.freeze(c);for(const p in c)if(P.call(c,p)){const h=c[p];typeof h=="object"&&!Object.isFrozen(h)&&!(0,y.$zf)(h)&&u.push(h)}}return f}e.$Ym=r;const P=Object.prototype.hasOwnProperty;function L(f,u){return I(f,u,new Set)}e.$Zm=L;function I(f,u,c){if((0,y.$Ff)(f))return f;const p=u(f);if(typeof p<"u")return p;if(Array.isArray(f)){const h=[];for(const t of f)h.push(I(t,u,c));return h}if((0,y.$yf)(f)){if(c.has(f))throw new Error("Cannot clone recursive data-structure");c.add(f);const h={};for(const t in f)P.call(f,t)&&(h[t]=I(f[t],u,c));return c.delete(f),h}return f}function w(f,u,c=!0){return(0,y.$yf)(f)?((0,y.$yf)(u)&&Object.keys(u).forEach(p=>{p in f?c&&((0,y.$yf)(f[p])&&(0,y.$yf)(u[p])?w(f[p],u[p],c):f[p]=u[p]):f[p]=u[p]}),f):u}e.$1m=w;function b(f,u){if(f===u)return!0;if(f==null||u===null||u===void 0||typeof f!=typeof u||typeof f!="object"||Array.isArray(f)!==Array.isArray(u))return!1;let c,p;if(Array.isArray(f)){if(f.length!==u.length)return!1;for(c=0;c<f.length;c++)if(!b(f[c],u[c]))return!1}else{const h=[];for(p in f)h.push(p);h.sort();const t=[];for(p in u)t.push(p);if(t.sort(),!b(h,t))return!1;for(c=0;c<h.length;c++)if(!b(f[h[c]],u[h[c]]))return!1}return!0}e.$2m=b;function C(f){const u=new Set;return JSON.stringify(f,(c,p)=>{if((0,y.$yf)(p)||Array.isArray(p)){if(u.has(p))return"[Circular]";u.add(p)}return p})}e.$3m=C;function E(f,u){const c=Object.create(null);return!f||!u||Object.keys(u).forEach(h=>{const t=f[h],s=u[h];b(t,s)||(c[h]=s)}),c}e.$4m=E;function v(f,u){const c=u.toLowerCase(),p=Object.keys(f).find(h=>h.toLowerCase()===c);return p?f[p]:f[u]}e.$5m=v;function d(f,u){const c=Object.create(null);for(const[p,h]of Object.entries(f))u(p,h)&&(c[p]=h);return c}e.$6m=d;function g(f){let u=[];for(;Object.prototype!==f;)u=u.concat(Object.getOwnPropertyNames(f)),f=Object.getPrototypeOf(f);return u}e.$7m=g;function m(f){const u=[];for(const c of g(f))typeof f[c]=="function"&&u.push(c);return u}e.$8m=m;function l(f,u){const c=h=>function(){const t=Array.prototype.slice.call(arguments,0);return u(h,t)},p={};for(const h of f)p[h]=c(h);return p}e.$9m=l}),define(we[99],pe([1,0,49]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$Rj=e.ThemeColor=void 0;var R;(function(L){function I(w){return w&&typeof w=="object"&&typeof w.id=="string"}L.isThemeColor=I})(R||(e.ThemeColor=R={}));function r(L){return{id:L}}e.$Rj=r;var P;(function(L){L.iconNameSegment="[A-Za-z0-9]+",L.iconNameExpression="[A-Za-z0-9-]+",L.iconModifierExpression="~[A-Za-z]+",L.iconNameCharacter="[A-Za-z0-9~-]";const I=new RegExp(`^(${L.iconNameExpression})(${L.iconModifierExpression})?$`);function w(u){const c=I.exec(u.id);if(!c)return w(y.$Qj.error);const[,p,h]=c,t=["codicon","codicon-"+p];return h&&t.push("codicon-modifier-"+h.substring(1)),t}L.asClassNameArray=w;function b(u){return w(u).join(" ")}L.asClassName=b;function C(u){return"."+w(u).join(".")}L.asCSSSelector=C;function E(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(typeof u.color>"u"||R.isThemeColor(u.color))}L.isThemeIcon=E;const v=new RegExp(`^\\$\\((${L.iconNameExpression}(?:${L.iconModifierExpression})?)\\)$`);function d(u){const c=v.exec(u);if(!c)return;const[,p]=c;return{id:p}}L.fromString=d;function g(u){return{id:u}}L.fromId=g;function m(u,c){let p=u.id;const h=p.lastIndexOf("~");return h!==-1&&(p=p.substring(0,h)),c&&(p=`${p}~${c}`),{id:p}}L.modify=m;function l(u){const c=u.id.lastIndexOf("~");if(c!==-1)return u.id.substring(c+1)}L.getModifier=l;function f(u,c){return u.id===c.id&&u.color?.id===c.color?.id}L.isEqual=f})(P||(e.ThemeIcon=P={}))}),define(we[149],pe([1,0,147,17,99]),function(le,e,y,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=void 0;const P="$(",L=new RegExp(`\\$\\(${r.ThemeIcon.iconNameExpression}(?:${r.ThemeIcon.iconModifierExpression})?\\)`,"g"),I=new RegExp(`(\\\\)?${L.source}`,"g");function w(f){return f.replace(I,(u,c)=>c?u:`\\${u}`)}e.$Sj=w;const b=new RegExp(`\\\\${L.source}`,"g");function C(f){return f.replace(b,u=>`\\${u}`)}e.$Tj=C;const E=new RegExp(`(\\s)?(\\\\)?${L.source}(\\s)?`,"g");function v(f){return f.indexOf(P)===-1?f:f.replace(E,(u,c,p,h)=>p?u:c||h||"")}e.$Uj=v;function d(f){return f?f.replace(/\$\((.*?)\)/g,(u,c)=>` ${c} `).trim():""}e.$Vj=d;const g=new RegExp(`\\$\\(${r.ThemeIcon.iconNameCharacter}+\\)`,"g");function m(f){g.lastIndex=0;let u="";const c=[];let p=0;for(;;){const h=g.lastIndex,t=g.exec(f),s=f.substring(h,t?.index);if(s.length>0){u+=s;for(let o=0;o<s.length;o++)c.push(p)}if(!t)break;p+=t[0].length}return{text:u,iconOffsets:c}}e.$Wj=m;function l(f,u,c=!1){const{text:p,iconOffsets:h}=u;if(!h||h.length===0)return(0,y.$Fj)(f,p,c);const t=(0,R.$He)(p," "),s=p.length-t.length,o=(0,y.$Fj)(f,t,c);if(o)for(const i of o){const n=h[i.start+s]+s;i.start+=n,i.end+=n}return o}e.$Xj=l}),define(we[4],pe([1,0,7,3]),function(le,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uc=e.$tc=e.URI=void 0;const r=/^\w[\w\d+.-]*$/,P=/^\//,L=/^\/\//;function I(i,n){if(!i.scheme&&n)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!r.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!P.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(L.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function w(i,n){return!i&&!n?"file":i}function b(i,n){switch(i){case"https":case"http":case"file":n?n[0]!==E&&(n=E+n):n=E;break}return n}const C="",E="/",v=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class d{static isUri(n){return n instanceof d?!0:n?typeof n.authority=="string"&&typeof n.fragment=="string"&&typeof n.path=="string"&&typeof n.query=="string"&&typeof n.scheme=="string"&&typeof n.fsPath=="string"&&typeof n.with=="function"&&typeof n.toString=="function":!1}constructor(n,a,$,S,D,k=!1){typeof n=="object"?(this.scheme=n.scheme||C,this.authority=n.authority||C,this.path=n.path||C,this.query=n.query||C,this.fragment=n.fragment||C):(this.scheme=w(n,k),this.authority=a||C,this.path=b(this.scheme,$||C),this.query=S||C,this.fragment=D||C,I(this,k))}get fsPath(){return p(this,!1)}with(n){if(!n)return this;let{scheme:a,authority:$,path:S,query:D,fragment:k}=n;return a===void 0?a=this.scheme:a===null&&(a=C),$===void 0?$=this.authority:$===null&&($=C),S===void 0?S=this.path:S===null&&(S=C),D===void 0?D=this.query:D===null&&(D=C),k===void 0?k=this.fragment:k===null&&(k=C),a===this.scheme&&$===this.authority&&S===this.path&&D===this.query&&k===this.fragment?this:new l(a,$,S,D,k)}static parse(n,a=!1){const $=v.exec(n);return $?new l($[2]||C,o($[4]||C),o($[5]||C),o($[7]||C),o($[9]||C),a):new l(C,C,C,C,C)}static file(n){let a=C;if(R.$d&&(n=n.replace(/\\/g,E)),n[0]===E&&n[1]===E){const $=n.indexOf(E,2);$===-1?(a=n.substring(2),n=E):(a=n.substring(2,$),n=n.substring($)||E)}return new l("file",a,n,C,C)}static from(n,a){return new l(n.scheme,n.authority,n.path,n.query,n.fragment,a)}static joinPath(n,...a){if(!n.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let $;return R.$d&&n.scheme==="file"?$=d.file(y.$dc.join(p(n,!0),...a)).path:$=y.$ec.join(n.path,...a),n.with({path:$})}toString(n=!1){return h(this,n)}toJSON(){return this}static revive(n){if(n){if(n instanceof d)return n;{const a=new l(n);return a._formatted=n.external??null,a._fsPath=n._sep===m?n.fsPath??null:null,a}}else return n}}e.URI=d;function g(i){return!i||typeof i!="object"?!1:typeof i.scheme=="string"&&(typeof i.authority=="string"||typeof i.authority>"u")&&(typeof i.path=="string"||typeof i.path>"u")&&(typeof i.query=="string"||typeof i.query>"u")&&(typeof i.fragment=="string"||typeof i.fragment>"u")}e.$tc=g;const m=R.$d?1:void 0;class l extends d{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=p(this,!1)),this._fsPath}toString(n=!1){return n?h(this,!0):(this._formatted||(this._formatted=h(this,!1)),this._formatted)}toJSON(){const n={$mid:1};return this._fsPath&&(n.fsPath=this._fsPath,n._sep=m),this._formatted&&(n.external=this._formatted),this.path&&(n.path=this.path),this.scheme&&(n.scheme=this.scheme),this.authority&&(n.authority=this.authority),this.query&&(n.query=this.query),this.fragment&&(n.fragment=this.fragment),n}}const f={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function u(i,n,a){let $,S=-1;for(let D=0;D<i.length;D++){const k=i.charCodeAt(D);if(k>=97&&k<=122||k>=65&&k<=90||k>=48&&k<=57||k===45||k===46||k===95||k===126||n&&k===47||a&&k===91||a&&k===93||a&&k===58)S!==-1&&($+=encodeURIComponent(i.substring(S,D)),S=-1),$!==void 0&&($+=i.charAt(D));else{$===void 0&&($=i.substr(0,D));const A=f[k];A!==void 0?(S!==-1&&($+=encodeURIComponent(i.substring(S,D)),S=-1),$+=A):S===-1&&(S=D)}}return S!==-1&&($+=encodeURIComponent(i.substring(S))),$!==void 0?$:i}function c(i){let n;for(let a=0;a<i.length;a++){const $=i.charCodeAt(a);$===35||$===63?(n===void 0&&(n=i.substr(0,a)),n+=f[$]):n!==void 0&&(n+=i[a])}return n!==void 0?n:i}function p(i,n){let a;return i.authority&&i.path.length>1&&i.scheme==="file"?a=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?n?a=i.path.substr(1):a=i.path[1].toLowerCase()+i.path.substr(2):a=i.path,R.$d&&(a=a.replace(/\//g,"\\")),a}e.$uc=p;function h(i,n){const a=n?c:u;let $="",{scheme:S,authority:D,path:k,query:A,fragment:j}=i;if(S&&($+=S,$+=":"),(D||S==="file")&&($+=E,$+=E),D){let Z=D.indexOf("@");if(Z!==-1){const ae=D.substr(0,Z);D=D.substr(Z+1),Z=ae.lastIndexOf(":"),Z===-1?$+=a(ae,!1,!1):($+=a(ae.substr(0,Z),!1,!1),$+=":",$+=a(ae.substr(Z+1),!1,!0)),$+="@"}D=D.toLowerCase(),Z=D.lastIndexOf(":"),Z===-1?$+=a(D,!1,!0):($+=a(D.substr(0,Z),!1,!0),$+=D.substr(Z))}if(k){if(k.length>=3&&k.charCodeAt(0)===47&&k.charCodeAt(2)===58){const Z=k.charCodeAt(1);Z>=65&&Z<=90&&(k=`/${String.fromCharCode(Z+32)}:${k.substr(3)}`)}else if(k.length>=2&&k.charCodeAt(1)===58){const Z=k.charCodeAt(0);Z>=65&&Z<=90&&(k=`${String.fromCharCode(Z+32)}:${k.substr(2)}`)}$+=a(k,!0,!1)}return A&&($+="?",$+=a(A,!1,!1)),j&&($+="#",$+=n?j:u(j,!1,!1)),$}function t(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+t(i.substr(3)):i}}const s=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function o(i){return i.match(s)?i.replace(s,n=>t(n)):i}}),define(we[150],pe([1,0,4]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$Rp=e.$Qp=e.$Pp=void 0;function R(b){const C=b;return C&&typeof C.type=="string"&&typeof C.severity=="string"}e.$Pp=R;function r(b){const C=[];let E;try{const v=JSON.parse(b.arguments),d=v[v.length-1];d&&d.__$stack&&(v.pop(),E=d.__$stack),C.push(...v)}catch{C.push("Unable to log remote console arguments",b.arguments)}return{args:C,stack:E}}e.$Qp=r;function P(b){if(typeof b!="string")return P(r(b).stack);const C=b;if(C){const E=L(C),v=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(E||"");if(v&&v.length===4)return{uri:y.URI.file(v[1]),line:Number(v[2]),column:Number(v[3])}}}e.$Rp=P;function L(b){if(!b)return b;const C=b.indexOf(`
`);return C===-1?b:b.substring(0,C)}function I(b,C){const{args:E,stack:v}=r(b),d=typeof E[0]=="string"&&E.length===1;let g=L(v);g&&(g=`(${g.trim()})`);let m=[];if(typeof E[0]=="string"?g&&d?m=[`%c[${C}] %c${E[0]} %c${g}`,w("blue"),w(""),w("grey")]:m=[`%c[${C}] %c${E[0]}`,w("blue"),w(""),...E.slice(1)]:m=[`%c[${C}]%`,w("blue"),...E],g&&!d&&m.push(g),typeof console[b.severity]!="function")throw new Error("Unknown console method");console[b.severity].apply(console,m)}e.log=I;function w(b){return`color: ${b}`}}),define(we[50],pe([1,0,15,4]),function(le,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ih=e.$hh=e.$gh=void 0;function r(w){return JSON.stringify(w,L)}e.$gh=r;function P(w){let b=JSON.parse(w);return b=I(b),b}e.$hh=P;function L(w,b){return b instanceof RegExp?{$mid:2,source:b.source,flags:b.flags}:b}function I(w,b=0){if(!w||b>200)return w;if(typeof w=="object"){switch(w.$mid){case 1:return R.URI.revive(w);case 2:return new RegExp(w.source,w.flags);case 17:return new Date(w.source)}if(w instanceof y.$_d||w instanceof Uint8Array)return w;if(Array.isArray(w))for(let C=0;C<w.length;++C)w[C]=I(w[C],b+1);else for(const C in w)Object.hasOwnProperty.call(w,C)&&(w[C]=I(w[C],b+1))}return w}e.$ih=I}),define(we[12],pe([1,0,11,3,4]),function(le,e,y,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.Schemas=void 0;var P;(function(b){b.inMemory="inmemory",b.vscode="vscode",b.internal="private",b.walkThrough="walkThrough",b.walkThroughSnippet="walkThroughSnippet",b.http="http",b.https="https",b.file="file",b.mailto="mailto",b.untitled="untitled",b.data="data",b.command="command",b.vscodeRemote="vscode-remote",b.vscodeRemoteResource="vscode-remote-resource",b.vscodeManagedRemoteResource="vscode-managed-remote-resource",b.vscodeUserData="vscode-userdata",b.vscodeCustomEditor="vscode-custom-editor",b.vscodeNotebookCell="vscode-notebook-cell",b.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",b.vscodeNotebookCellOutput="vscode-notebook-cell-output",b.vscodeInteractiveInput="vscode-interactive-input",b.vscodeSettings="vscode-settings",b.vscodeWorkspaceTrust="vscode-workspace-trust",b.vscodeTerminal="vscode-terminal",b.vscodeChatSesssion="vscode-chat-editor",b.webviewPanel="webview-panel",b.vscodeWebview="vscode-webview",b.extension="extension",b.vscodeFileResource="vscode-file",b.tmp="tmp",b.vsls="vsls",b.vscodeSourceControl="vscode-scm"})(P||(e.Schemas=P={})),e.$5f="vscode-tkn",e.$6f="tkn";class L{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${P.vscodeRemoteResource}`}setPreferredWebSchema(C){this.d=C}setDelegate(C){this.e=C}setServerRootPath(C){this.f=`${C}/${P.vscodeRemoteResource}`}set(C,E,v){this.a[C]=E,this.b[C]=v}setConnectionToken(C,E){this.c[C]=E}getPreferredWebSchema(){return this.d}rewrite(C){if(this.e)try{return this.e(C)}catch(l){return y.$Y(l),C}const E=C.authority;let v=this.a[E];v&&v.indexOf(":")!==-1&&v.indexOf("[")===-1&&(v=`[${v}]`);const d=this.b[E],g=this.c[E];let m=`path=${encodeURIComponent(C.path)}`;return typeof g=="string"&&(m+=`&${e.$6f}=${encodeURIComponent(g)}`),r.URI.from({scheme:R.$j?this.d:P.vscodeRemoteResource,authority:`${v}:${d}`,path:R.$j?(window.location.pathname+"/"+this.f).replace(/\/\/+/g,"/"):this.f,query:m})}}e.$7f=new L,e.$8f="vs/../../extensions",e.$9f="vs/../../node_modules",e.$0f="vs/../../node_modules.asar",e.$$f="vs/../../node_modules.asar.unpacked";class I{asBrowserUri(C){const E=this.b(C,le);return this.uriToBrowserUri(E)}uriToBrowserUri(C){return C.scheme===P.vscodeRemote?e.$7f.rewrite(C):C.scheme===P.file&&(R.$h||R.$k&&R.$b.origin===`${P.vscodeFileResource}://${I.a}`)?C.with({scheme:P.vscodeFileResource,authority:C.authority||I.a,query:null,fragment:null}):C}asFileUri(C){const E=this.b(C,le);return this.uriToFileUri(E)}uriToFileUri(C){return C.scheme===P.vscodeFileResource?C.with({scheme:P.file,authority:C.authority!==I.a?C.authority:null,query:null,fragment:null}):C}b(C,E){return r.URI.isUri(C)?C:r.URI.parse(E.toUrl(C))}}I.a="vscode-app",e.$_f=new I;var w;(function(b){const C=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);b.CoopAndCoep=Object.freeze(C.get("3"));const E="vscode-coi";function v(g){let m;typeof g=="string"?m=new URL(g).searchParams:g instanceof URL?m=g.searchParams:r.URI.isUri(g)&&(m=new URL(g.toString(!0)).searchParams);const l=m?.get(E);if(l)return C.get(l)}b.getHeadersFromQuery=v;function d(g,m,l){if(!globalThis.crossOriginIsolated)return;const f=m&&l?"3":l?"2":"1";g instanceof URLSearchParams?g.set(E,f):g[E]=f}b.addSearchParam=d})(w||(e.COI=w={}))}),define(we[151],pe([1,0,94,12,3,4]),function(le,e,y,R,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eC=void 0;class L{constructor(v,d,g){this.id=v,this.dependencies=d,this.callback=g}}class I{constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(v,d,g)=>{typeof v!="string"&&(g=d,d=v,v=null),(typeof d!="object"||!Array.isArray(d))&&(g=d,d=null),this.c.push(new L(v,d,g))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(v){if(v.startsWith(window.location.origin)||v.startsWith("vscode-file://vscode-app"))return v;throw new Error(`[trusted_script_src] Invalid script url: ${v}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(v){return v}})))}async load(v){this.g();const d=await(this.a?this.i(v):this.b?this.h(v):this.j(v));if(!d)throw new Error(`Did not receive a define call from script ${v}`);if(Array.isArray(d.dependencies)&&d.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${v}. The dependencies are: ${d.dependencies.join(", ")}`);return typeof d.callback=="function"?d.callback([]):d.callback}h(v){return new Promise((d,g)=>{const m=document.createElement("script");m.setAttribute("async","async"),m.setAttribute("type","text/javascript");const l=()=>{m.removeEventListener("load",f),m.removeEventListener("error",u)},f=c=>{l(),d(this.c.pop())},u=c=>{l(),g(c)};m.addEventListener("load",f),m.addEventListener("error",u),this.f&&(v=this.f.createScriptURL(v)),m.setAttribute("src",v),document.getElementsByTagName("head")[0].appendChild(m)})}i(v){return new Promise((d,g)=>{try{this.f&&(v=this.f.createScriptURL(v)),importScripts(v),d(this.c.pop())}catch(m){g(m)}})}async j(v){try{const d=globalThis._VSCODE_NODE_MODULES.fs,g=globalThis._VSCODE_NODE_MODULES.vm,m=globalThis._VSCODE_NODE_MODULES.module,l=P.URI.parse(v).fsPath,f=d.readFileSync(l).toString(),u=m.wrap(f.replace(/^#!.*/,""));return new g.Script(u).runInThisContext().apply(),this.c.pop()}catch(d){throw d}}}I.INSTANCE=new I;const w=new Map;let b={};typeof globalThis.require=="object"&&(b=globalThis.require.paths??{});async function C(E,v,d){if(y.$R){d===void 0&&(d=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),b[E]&&(E=b[E]);const g=`${E}/${v}`;if(w.has(g))return w.get(g);let m;if(/^\w[\w\d+.-]*:\/\//.test(g))m=g;else{const c=`${d&&!r.$j?R.$0f:R.$9f}/${g}`;m=R.$_f.asBrowserUri(c).toString(!0)}const l=I.INSTANCE.load(m);return w.set(g,l),l}else return await new Promise((g,m)=>{le([E],g,m)})}e.$eC=C}),define(we[19],pe([1,0,38,12,7,3,17,4]),function(le,e,y,R,r,P,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cg=e.DataUri=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=e.$hg=e.$gg=void 0;function w(d){return(0,I.$uc)(d,!0)}e.$gg=w;class b{constructor(g){this.a=g}compare(g,m,l=!1){return g===m?0:(0,L.$Se)(this.getComparisonKey(g,l),this.getComparisonKey(m,l))}isEqual(g,m,l=!1){return g===m?!0:!g||!m?!1:this.getComparisonKey(g,l)===this.getComparisonKey(m,l)}getComparisonKey(g,m=!1){return g.with({path:this.a(g)?g.path.toLowerCase():void 0,fragment:m?null:void 0}).toString()}ignorePathCasing(g){return this.a(g)}isEqualOrParent(g,m,l=!1){if(g.scheme===m.scheme){if(g.scheme===R.Schemas.file)return y.$Vf(w(g),w(m),this.a(g))&&g.query===m.query&&(l||g.fragment===m.fragment);if((0,e.$xg)(g.authority,m.authority))return y.$Vf(g.path,m.path,this.a(g),"/")&&g.query===m.query&&(l||g.fragment===m.fragment)}return!1}joinPath(g,...m){return I.URI.joinPath(g,...m)}basenameOrAuthority(g){return(0,e.$pg)(g)||g.authority}basename(g){return r.$ec.basename(g.path)}extname(g){return r.$ec.extname(g.path)}dirname(g){if(g.path.length===0)return g;let m;return g.scheme===R.Schemas.file?m=I.URI.file(r.$kc(w(g))).path:(m=r.$ec.dirname(g.path),g.authority&&m.length&&m.charCodeAt(0)!==47&&(console.error(`dirname("${g.toString})) resulted in a relative path`),m="/")),g.with({path:m})}normalizePath(g){if(!g.path.length)return g;let m;return g.scheme===R.Schemas.file?m=I.URI.file(r.$fc(w(g))).path:m=r.$ec.normalize(g.path),g.with({path:m})}relativePath(g,m){if(g.scheme!==m.scheme||!(0,e.$xg)(g.authority,m.authority))return;if(g.scheme===R.Schemas.file){const u=r.$jc(w(g),w(m));return P.$d?y.$Pf(u):u}let l=g.path||"/";const f=m.path||"/";if(this.a(g)){let u=0;for(const c=Math.min(l.length,f.length);u<c&&!(l.charCodeAt(u)!==f.charCodeAt(u)&&l.charAt(u).toLowerCase()!==f.charAt(u).toLowerCase());u++);l=f.substr(0,u)+l.substr(u)}return r.$ec.relative(l,f)}resolvePath(g,m){if(g.scheme===R.Schemas.file){const l=I.URI.file(r.$ic(w(g),m));return g.with({authority:l.authority,path:l.path})}return m=y.$Qf(m),g.with({path:r.$ec.resolve(g.path,m)})}isAbsolutePath(g){return!!g.path&&g.path[0]==="/"}isEqualAuthority(g,m){return g===m||g!==void 0&&m!==void 0&&(0,L.$Ze)(g,m)}hasTrailingPathSeparator(g,m=r.sep){if(g.scheme===R.Schemas.file){const l=w(g);return l.length>y.$Rf(l).length&&l[l.length-1]===m}else{const l=g.path;return l.length>1&&l.charCodeAt(l.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(g.fsPath)}}removeTrailingPathSeparator(g,m=r.sep){return(0,e.$yg)(g,m)?g.with({path:g.path.substr(0,g.path.length-1)}):g}addTrailingPathSeparator(g,m=r.sep){let l=!1;if(g.scheme===R.Schemas.file){const f=w(g);l=f!==void 0&&f.length===y.$Rf(f).length&&f[f.length-1]===m}else{m="/";const f=g.path;l=f.length===1&&f.charCodeAt(f.length-1)===47}return!l&&!(0,e.$yg)(g,m)?g.with({path:g.path+"/"}):g}}e.$hg=b,e.$ig=new b(()=>!1),e.$jg=new b(d=>d.scheme===R.Schemas.file?!P.$f:!0),e.$kg=new b(d=>!0),e.$lg=e.$ig.isEqual.bind(e.$ig),e.$mg=e.$ig.isEqualOrParent.bind(e.$ig),e.$ng=e.$ig.getComparisonKey.bind(e.$ig),e.$og=e.$ig.basenameOrAuthority.bind(e.$ig),e.$pg=e.$ig.basename.bind(e.$ig),e.$qg=e.$ig.extname.bind(e.$ig),e.$rg=e.$ig.dirname.bind(e.$ig),e.$sg=e.$ig.joinPath.bind(e.$ig),e.$tg=e.$ig.normalizePath.bind(e.$ig),e.$ug=e.$ig.relativePath.bind(e.$ig),e.$vg=e.$ig.resolvePath.bind(e.$ig),e.$wg=e.$ig.isAbsolutePath.bind(e.$ig),e.$xg=e.$ig.isEqualAuthority.bind(e.$ig),e.$yg=e.$ig.hasTrailingPathSeparator.bind(e.$ig),e.$zg=e.$ig.removeTrailingPathSeparator.bind(e.$ig),e.$Ag=e.$ig.addTrailingPathSeparator.bind(e.$ig);function C(d,g){const m=[];for(let l=0;l<d.length;l++){const f=g(d[l]);d.some((u,c)=>c===l?!1:(0,e.$mg)(f,g(u)))||m.push(d[l])}return m}e.$Bg=C;var E;(function(d){d.META_DATA_LABEL="label",d.META_DATA_DESCRIPTION="description",d.META_DATA_SIZE="size",d.META_DATA_MIME="mime";function g(m){const l=new Map;m.path.substring(m.path.indexOf(";")+1,m.path.lastIndexOf(";")).split(";").forEach(c=>{const[p,h]=c.split(":");p&&h&&l.set(p,h)});const u=m.path.substring(0,m.path.indexOf(";"));return u&&l.set(d.META_DATA_MIME,u),l}d.parseMetaData=g})(E||(e.DataUri=E={}));function v(d,g,m){if(g){let l=d.path;return l&&l[0]!==r.$ec.sep&&(l=r.$ec.sep+l),d.with({scheme:m,authority:g,path:l})}return d.with({scheme:m})}e.$Cg=v}),define(we[14],pe([1,0,20,11,5,2,19,3,148]),function(le,e,y,R,r,P,L,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ch=e.$bh=e.$ah=e.Promises=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=void 0;function b(O){return!!O&&typeof O.then=="function"}e.$Dg=b;function C(O){const N=new y.$Vd,Q=O(N.token),T=new Promise((H,U)=>{const ie=N.token.onCancellationRequested(()=>{ie.dispose(),N.dispose(),U(new R.$3)});Promise.resolve(Q).then(z=>{ie.dispose(),N.dispose(),H(z)},z=>{ie.dispose(),N.dispose(),U(z)})});return new class{cancel(){N.cancel()}then(H,U){return T.then(H,U)}catch(H){return this.then(void 0,H)}finally(H){return T.finally(H)}}}e.$Eg=C;function E(O,N,Q){return new Promise((T,H)=>{const U=N.onCancellationRequested(()=>{U.dispose(),T(Q)});O.then(T,H).finally(()=>U.dispose())})}e.$Fg=E;function v(O,N){return new Promise((Q,T)=>{const H=N.onCancellationRequested(()=>{H.dispose(),T(new R.$3)});O.then(Q,T).finally(()=>H.dispose())})}e.$Gg=v;async function d(O){let N=-1;const Q=O.map((T,H)=>T.then(U=>(N=H,U)));try{return await Promise.race(Q)}finally{O.forEach((T,H)=>{H!==N&&T.cancel()})}}e.$Hg=d;function g(O,N,Q){let T;const H=setTimeout(()=>{T?.(void 0),Q?.()},N);return Promise.race([O.finally(()=>clearTimeout(H)),new Promise(U=>T=U)])}e.$Ig=g;function m(O){return new Promise((N,Q)=>{const T=O();b(T)?T.then(N,Q):N(T)})}e.$Jg=m;class l{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(N){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=N,!this.b){const Q=()=>{if(this.b=null,this.f)return;const T=this.queue(this.d);return this.d=null,T};this.b=new Promise(T=>{this.a.then(Q,Q).then(T)})}return new Promise((Q,T)=>{this.b.then(Q,T)})}return this.a=N(),new Promise((Q,T)=>{this.a.then(H=>{this.a=null,Q(H)},H=>{this.a=null,T(H)})})}dispose(){this.f=!0}}e.$Kg=l;class f{constructor(){this.a=Promise.resolve(null)}queue(N){return this.a=this.a.then(()=>N(),()=>N())}}e.$Lg=f;class u{constructor(){this.a=new Map}queue(N,Q){const H=(this.a.get(N)??Promise.resolve()).catch(()=>{}).then(Q).finally(()=>{this.a.get(N)===H&&this.a.delete(N)});return this.a.set(N,H),H}}e.$Mg=u;const c=(O,N)=>{let Q=!0;const T=setTimeout(()=>{Q=!1,N()},O);return{isTriggered:()=>Q,dispose:()=>{clearTimeout(T),Q=!1}}},p=O=>{let N=!0;return queueMicrotask(()=>{N&&(N=!1,O())}),{isTriggered:()=>N,dispose:()=>{N=!1}}};class h{constructor(N){this.defaultDelay=N,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(N,Q=this.defaultDelay){this.g=N,this.h(),this.b||(this.b=new Promise((H,U)=>{this.d=H,this.f=U}).then(()=>{if(this.b=null,this.d=null,this.g){const H=this.g;return this.g=null,H()}}));const T=()=>{this.a=null,this.d?.(null)};return this.a=Q===w.$Id?p(T):c(Q,T),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new R.$3),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Ng=h;class t{constructor(N){this.a=new h(N),this.b=new l}trigger(N,Q){return this.a.trigger(()=>this.b.queue(N),Q)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Og=t;class s{constructor(){this.a=!1,this.b=new Promise((N,Q)=>{this.d=N})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Pg=s;class o extends s{constructor(N){super(),this.f=setTimeout(()=>this.open(),N)}open(){clearTimeout(this.f),super.open()}}e.$Qg=o;function i(O,N){return N?new Promise((Q,T)=>{const H=setTimeout(()=>{U.dispose(),Q()},O),U=N.onCancellationRequested(()=>{clearTimeout(H),U.dispose(),T(new R.$3)})}):C(Q=>i(O,Q))}e.$Rg=i;function n(O,N=0,Q){const T=setTimeout(()=>{O(),Q&&H.dispose()},N),H=(0,P.$Oc)(()=>{clearTimeout(T),Q?.deleteAndLeak(H)});return Q?.add(H),H}e.$Sg=n;function a(O){const N=[];let Q=0;const T=O.length;function H(){return Q<T?O[Q++]():null}function U(ie){ie!=null&&N.push(ie);const z=H();return z?z.then(U):Promise.resolve(N)}return Promise.resolve(null).then(U)}e.$Tg=a;function $(O,N=T=>!!T,Q=null){let T=0;const H=O.length,U=()=>{if(T>=H)return Promise.resolve(Q);const ie=O[T++];return Promise.resolve(ie()).then(_=>N(_)?Promise.resolve(_):U())};return U()}e.$Ug=$;function S(O,N=T=>!!T,Q=null){if(O.length===0)return Promise.resolve(Q);let T=O.length;const H=()=>{T=-1;for(const U of O)U.cancel?.()};return new Promise((U,ie)=>{for(const z of O)z.then(_=>{--T>=0&&N(_)?(H(),U(_)):T===0&&U(Q)}).catch(_=>{--T>=0&&(H(),ie(_))})})}e.$Vg=S;class D{constructor(N){this.a=0,this.d=N,this.f=[],this.b=0,this.g=new r.$Ld}get onDrained(){return this.g.event}get size(){return this.a}queue(N){return this.a++,new Promise((Q,T)=>{this.f.push({factory:N,c:Q,e:T}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const N=this.f.shift();this.b++;const Q=N.factory();Q.then(N.c,N.e),Q.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$Wg=D;class k extends D{constructor(){super(1)}}e.$Xg=k;class A{constructor(){this.a=new te,this.b=0}queue(N){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,N())):this.a.run(this.b++,N())}}e.$Yg=A;class j{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const N=new q;return this.b.add(N),N.p}g(){for(const[,N]of this.a)if(N.size>0)return!1;return!0}queueFor(N,Q=L.$ig){const T=Q.getComparisonKey(N);let H=this.a.get(T);if(!H){H=new k;const U=this.f++,ie=r.Event.once(H.onDrained)(()=>{H?.dispose(),this.a.delete(T),this.h(),this.d?.deleteAndDispose(U),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new P.$Yc),this.d.set(U,ie),this.a.set(T,H)}return H}h(){this.g()&&this.j()}j(){for(const N of this.b)N.complete();this.b.clear()}dispose(){for(const[,N]of this.a)N.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Zg=j;class Z{constructor(N,Q){this.a=-1,typeof N=="function"&&typeof Q=="number"&&this.setIfNotSet(N,Q)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(N,Q){this.cancel(),this.a=setTimeout(()=>{this.a=-1,N()},Q)}setIfNotSet(N,Q){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,N()},Q))}}e.$1g=Z;class ae{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(N,Q){this.cancel(),this.a=setInterval(()=>{N()},Q)}}e.$2g=ae;class K{constructor(N,Q){this.b=-1,this.a=N,this.d=Q,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(N=this.d){this.cancel(),this.b=setTimeout(this.f,N)}get delay(){return this.d}set delay(N){this.d=N}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$3g=K;class se{constructor(N,Q){Q%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Q}ms is not a multiple of 1000ms.`),this.a=N,this.b=Q,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(N=this.b){N%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${N}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(N/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$4g=se;class ue extends K{constructor(N,Q){super(N,Q),this.j=[]}work(N){this.j.push(N),this.isScheduled()||this.schedule()}h(){const N=this.j;this.j=[],this.a?.(N)}dispose(){this.j=[],super.dispose()}}e.$5g=ue;class x extends P.$Qc{constructor(N,Q){super(),this.g=N,this.h=Q,this.a=[],this.b=this.B(new P.$Rc),this.f=!1}get pending(){return this.a.length}work(N){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+N.length>this.g.maxBufferedWork)return!1}else if(this.pending+N.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const Q of N)this.a.push(Q);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new K(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$6g=x,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.$7g=O=>{(0,I.$v)(()=>{if(N)return;const Q=Date.now()+15;O(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,Q-Date.now())}}))});let N=!1;return{dispose(){N||(N=!0)}}}:e.$7g=(O,N)=>{const Q=requestIdleCallback(O,typeof N=="number"?{timeout:N}:void 0);let T=!1;return{dispose(){T||(T=!0,cancelIdleCallback(Q))}}}}();class he{constructor(N){this.d=!1,this.a=()=>{try{this.f=N()}catch(Q){this.g=Q}finally{this.d=!0}},this.b=(0,e.$7g)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.$8g=he;async function V(O,N,Q){let T;for(let H=0;H<Q;H++)try{return await O()}catch(U){T=U,await i(N)}throw T}e.$9g=V;class te{isRunning(N){return typeof N=="number"?this.a?.taskId===N:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(N,Q,T){return this.a={taskId:N,cancel:()=>T?.(),promise:Q},Q.then(()=>this.d(N),()=>this.d(N)),Q}d(N){this.a&&N===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const N=this.b;this.b=void 0,N.run().then(N.promiseResolve,N.promiseReject)}}queue(N){if(this.b)this.b.run=N;else{let Q,T;const H=new Promise((U,ie)=>{Q=U,T=ie});this.b={run:N,promise:H,promiseResolve:Q,promiseReject:T}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$0g=te;class G{constructor(N,Q=()=>Date.now()){this.d=N,this.f=Q,this.a=0,this.b=0}increment(){const N=this.f();return N-this.a>this.d&&(this.a=N,this.b=0),this.b++,this.b}}e.$$g=G;var J;(function(O){O[O.Resolved=0]="Resolved",O[O.Rejected=1]="Rejected"})(J||(J={}));class q{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((N,Q)=>{this.a=N,this.b=Q})}complete(N){return new Promise(Q=>{this.a(N),this.d={outcome:0,value:N},Q()})}error(N){return new Promise(Q=>{this.b(N),this.d={outcome:1,value:N},Q()})}cancel(){return this.error(new R.$3)}}e.$_g=q;var ne;(function(O){async function N(T){let H;const U=await Promise.all(T.map(ie=>ie.then(z=>z,z=>{H||(H=z)})));if(typeof H<"u")throw H;return U}O.settled=N;function Q(T){return new Promise(async(H,U)=>{try{await T(H,U)}catch(ie){U(ie)}})}O.withAsyncBody=Q})(ne||(e.Promises=ne={}));var me;(function(O){O[O.Initial=0]="Initial",O[O.DoneOK=1]="DoneOK",O[O.DoneError=2]="DoneError"})(me||(me={}));class re{static fromArray(N){return new re(Q=>{Q.emitMany(N)})}static fromPromise(N){return new re(async Q=>{Q.emitMany(await N)})}static fromPromises(N){return new re(async Q=>{await Promise.all(N.map(async T=>Q.emitOne(await T)))})}static merge(N){return new re(async Q=>{await Promise.all(N.map(async T=>{for await(const H of T)Q.emitOne(H)}))})}constructor(N){this.a=0,this.b=[],this.d=null,this.f=new r.$Ld,queueMicrotask(async()=>{const Q={emitOne:T=>this.g(T),emitMany:T=>this.h(T),reject:T=>this.k(T)};try{await Promise.resolve(N(Q)),this.j()}catch(T){this.k(T)}finally{Q.emitOne=void 0,Q.emitMany=void 0,Q.reject=void 0}})}[Symbol.asyncIterator](){let N=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(N<this.b.length)return{done:!1,value:this.b[N++]};if(this.a===1)return{done:!0,value:void 0};await r.Event.toPromise(this.f.event)}while(!0)}}}static map(N,Q){return new re(async T=>{for await(const H of N)T.emitOne(Q(H))})}map(N){return re.map(this,N)}static filter(N,Q){return new re(async T=>{for await(const H of N)Q(H)&&T.emitOne(H)})}filter(N){return re.filter(this,N)}static coalesce(N){return re.filter(N,Q=>!!Q)}coalesce(){return re.coalesce(this)}static async toPromise(N){const Q=[];for await(const T of N)Q.push(T);return Q}toPromise(){return re.toPromise(this)}g(N){this.a===0&&(this.b.push(N),this.f.fire())}h(N){this.a===0&&(this.b=this.b.concat(N),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(N){this.a===0&&(this.a=2,this.d=N,this.f.fire())}}e.$ah=re,re.EMPTY=re.fromArray([]);class B extends re{constructor(N,Q){super(Q),this.l=N}cancel(){this.l.cancel()}}e.$bh=B;function ee(O){const N=new y.$Vd,Q=O(N.token);return new B(N,async T=>{const H=N.token.onCancellationRequested(()=>{H.dispose(),N.dispose(),T.reject(new R.$3)});try{for await(const U of Q){if(N.token.isCancellationRequested)return;T.emitOne(U)}H.dispose(),N.dispose()}catch(U){H.dispose(),N.dispose(),T.reject(U)}})}e.$ch=ee}),define(we[76],pe([1,0,18,14,38,26,7,3,17]),function(le,e,y,R,r,P,L,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=void 0;function b(){return Object.create(null)}e.$nj=b,e.$oj="**",e.$pj="/";const C="[/\\\\]",E="[^/\\\\]",v=/\//g;function d(te,G){switch(te){case 0:return"";case 1:return`${E}*?`;default:return`(?:${C}|${E}+${C}${G?`|${C}${E}+`:""})*?`}}function g(te,G){if(!te)return[];const J=[];let q=!1,ne=!1,me="";for(const re of te){switch(re){case G:if(!q&&!ne){J.push(me),me="";continue}break;case"{":q=!0;break;case"}":q=!1;break;case"[":ne=!0;break;case"]":ne=!1;break}me+=re}return me&&J.push(me),J}e.$qj=g;function m(te){if(!te)return"";let G="";const J=g(te,e.$pj);if(J.every(q=>q===e.$oj))G=".*";else{let q=!1;J.forEach((ne,me)=>{if(ne===e.$oj){if(q)return;G+=d(2,me===J.length-1)}else{let re=!1,B="",ee=!1,O="";for(const N of ne){if(N!=="}"&&re){B+=N;continue}if(ee&&(N!=="]"||!O)){let Q;N==="-"?Q=N:(N==="^"||N==="!")&&!O?Q="^":N===e.$pj?Q="":Q=(0,w.$De)(N),O+=Q;continue}switch(N){case"{":re=!0;continue;case"[":ee=!0;continue;case"}":{const T=`(?:${g(B,",").map(H=>m(H)).join("|")})`;G+=T,re=!1,B="";break}case"]":{G+="["+O+"]",ee=!1,O="";break}case"?":G+=E;continue;case"*":G+=d(1);continue;default:G+=(0,w.$De)(N)}}me<J.length-1&&(J[me+1]!==e.$oj||me+2<J.length)&&(G+=C)}q=ne===e.$oj})}return G}const l=/^\*\*\/\*\.[\w\.-]+$/,f=/^\*\*\/([\w\.-]+)\/?$/,u=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,c=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,p=/^\*\*((\/[\w\.-]+)+)\/?$/,h=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new P.$Bc(1e4),s=function(){return!1},o=function(){return null};function i(te,G){if(!te)return o;let J;typeof te!="string"?J=te.pattern:J=te,J=J.trim();const q=`${J}_${!!G.trimForExclusions}`;let ne=t.get(q);if(ne)return n(ne,te);let me;return l.test(J)?ne=$(J.substr(4),J):(me=f.exec(a(J,G)))?ne=S(me[1],J):(G.trimForExclusions?c:u).test(J)?ne=D(J,G):(me=p.exec(a(J,G)))?ne=k(me[1].substr(1),J,!0):(me=h.exec(a(J,G)))?ne=k(me[1],J,!1):ne=A(J),t.set(q,ne),n(ne,te)}function n(te,G){if(typeof G=="string")return te;const J=function(q,ne){return(0,r.$Vf)(q,G.base,!I.$f)?te((0,w.$He)(q.substr(G.base.length),L.sep),ne):null};return J.allBasenames=te.allBasenames,J.allPaths=te.allPaths,J.basenames=te.basenames,J.patterns=te.patterns,J}function a(te,G){return G.trimForExclusions&&te.endsWith("/**")?te.substr(0,te.length-2):te}function $(te,G){return function(J,q){return typeof J=="string"&&J.endsWith(te)?G:null}}function S(te,G){const J=`/${te}`,q=`\\${te}`,ne=function(re,B){return typeof re!="string"?null:B?B===te?G:null:re===te||re.endsWith(J)||re.endsWith(q)?G:null},me=[te];return ne.basenames=me,ne.patterns=[G],ne.allBasenames=me,ne}function D(te,G){const J=he(te.slice(1,-1).split(",").map(B=>i(B,G)).filter(B=>B!==o),te),q=J.length;if(!q)return o;if(q===1)return J[0];const ne=function(B,ee){for(let O=0,N=J.length;O<N;O++)if(J[O](B,ee))return te;return null},me=J.find(B=>!!B.allBasenames);me&&(ne.allBasenames=me.allBasenames);const re=J.reduce((B,ee)=>ee.allPaths?B.concat(ee.allPaths):B,[]);return re.length&&(ne.allPaths=re),ne}function k(te,G,J){const q=L.sep===L.$ec.sep,ne=q?te:te.replace(v,L.sep),me=L.sep+ne,re=L.$ec.sep+te;let B;return J?B=function(ee,O){return typeof ee=="string"&&(ee===ne||ee.endsWith(me)||!q&&(ee===te||ee.endsWith(re)))?G:null}:B=function(ee,O){return typeof ee=="string"&&(ee===ne||!q&&ee===te)?G:null},B.allPaths=[(J?"*/":"./")+te],B}function A(te){try{const G=new RegExp(`^${m(te)}$`);return function(J){return G.lastIndex=0,typeof J=="string"&&G.test(J)?te:null}}catch{return o}}function j(te,G,J){return!te||typeof G!="string"?!1:Z(te)(G,void 0,J)}e.$rj=j;function Z(te,G={}){if(!te)return s;if(typeof te=="string"||ae(te)){const J=i(te,G);if(J===o)return s;const q=function(ne,me){return!!J(ne,me)};return J.allBasenames&&(q.allBasenames=J.allBasenames),J.allPaths&&(q.allPaths=J.allPaths),q}return ue(te,G)}e.$sj=Z;function ae(te){const G=te;return G?typeof G.base=="string"&&typeof G.pattern=="string":!1}e.$tj=ae;function K(te){return te.allBasenames||[]}e.$uj=K;function se(te){return te.allPaths||[]}e.$vj=se;function ue(te,G){const J=he(Object.getOwnPropertyNames(te).map(B=>x(B,te[B],G)).filter(B=>B!==o)),q=J.length;if(!q)return o;if(!J.some(B=>!!B.requiresSiblings)){if(q===1)return J[0];const B=function(N,Q){let T;for(let H=0,U=J.length;H<U;H++){const ie=J[H](N,Q);if(typeof ie=="string")return ie;(0,R.$Dg)(ie)&&(T||(T=[]),T.push(ie))}return T?(async()=>{for(const H of T){const U=await H;if(typeof U=="string")return U}return null})():null},ee=J.find(N=>!!N.allBasenames);ee&&(B.allBasenames=ee.allBasenames);const O=J.reduce((N,Q)=>Q.allPaths?N.concat(Q.allPaths):N,[]);return O.length&&(B.allPaths=O),B}const ne=function(B,ee,O){let N,Q;for(let T=0,H=J.length;T<H;T++){const U=J[T];U.requiresSiblings&&O&&(ee||(ee=(0,L.$lc)(B)),N||(N=ee.substr(0,ee.length-(0,L.$mc)(B).length)));const ie=U(B,ee,N,O);if(typeof ie=="string")return ie;(0,R.$Dg)(ie)&&(Q||(Q=[]),Q.push(ie))}return Q?(async()=>{for(const T of Q){const H=await T;if(typeof H=="string")return H}return null})():null},me=J.find(B=>!!B.allBasenames);me&&(ne.allBasenames=me.allBasenames);const re=J.reduce((B,ee)=>ee.allPaths?B.concat(ee.allPaths):B,[]);return re.length&&(ne.allPaths=re),ne}function x(te,G,J){if(G===!1)return o;const q=i(te,J);if(q===o)return o;if(typeof G=="boolean")return q;if(G){const ne=G.when;if(typeof ne=="string"){const me=(re,B,ee,O)=>{if(!O||!q(re,B))return null;const N=ne.replace("$(basename)",()=>ee),Q=O(N);return(0,R.$Dg)(Q)?Q.then(T=>T?te:null):Q?te:null};return me.requiresSiblings=!0,me}}return q}function he(te,G){const J=te.filter(B=>!!B.basenames);if(J.length<2)return te;const q=J.reduce((B,ee)=>{const O=ee.basenames;return O?B.concat(O):B},[]);let ne;if(G){ne=[];for(let B=0,ee=q.length;B<ee;B++)ne.push(G)}else ne=J.reduce((B,ee)=>{const O=ee.patterns;return O?B.concat(O):B},[]);const me=function(B,ee){if(typeof B!="string")return null;if(!ee){let N;for(N=B.length;N>0;N--){const Q=B.charCodeAt(N-1);if(Q===47||Q===92)break}ee=B.substr(N)}const O=q.indexOf(ee);return O!==-1?ne[O]:null};me.basenames=q,me.patterns=ne,me.allBasenames=q;const re=te.filter(B=>!B.basenames);return re.push(me),re}function V(te,G){return(0,y.$sb)(te,G,(J,q)=>typeof J=="string"&&typeof q=="string"?J===q:typeof J!="string"&&typeof q!="string"?J.base===q.base&&J.pattern===q.pattern:!1)}e.$wj=V}),define(we[100],pe([1,0,11,149,19,17,4]),function(le,e,y,R,r,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6j=e.$5j=e.$4j=e.$3j=e.$2j=e.$1j=e.$Zj=e.$Yj=e.MarkdownStringTextNewlineStyle=void 0;var I;(function(l){l[l.Paragraph=0]="Paragraph",l[l.Break=1]="Break"})(I||(e.MarkdownStringTextNewlineStyle=I={}));class w{constructor(f="",u=!1){if(this.value=f,typeof this.value!="string")throw(0,y.$5)("value");typeof u=="boolean"?(this.isTrusted=u,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=u.isTrusted??void 0,this.supportThemeIcons=u.supportThemeIcons??!1,this.supportHtml=u.supportHtml??!1)}appendText(f,u=0){return this.value+=v(this.supportThemeIcons?(0,R.$Sj)(f):f).replace(/([ \t]+)/g,(c,p)=>"&nbsp;".repeat(p.length)).replace(/\>/gm,"\\>").replace(/\n/g,u===1?`\\
`:`

`),this}appendMarkdown(f){return this.value+=f,this}appendCodeblock(f,u){return this.value+="\n```",this.value+=f,this.value+=`
`,this.value+=u,this.value+="\n```\n",this}appendLink(f,u,c){return this.value+="[",this.value+=this.c(u,"]"),this.value+="](",this.value+=this.c(String(f),")"),c&&(this.value+=` "${this.c(this.c(c,'"'),")")}"`),this.value+=")",this}c(f,u){const c=new RegExp((0,P.$De)(u),"g");return f.replace(c,(p,h)=>f.charAt(h-1)!=="\\"?`\\${p}`:p)}}e.$Yj=w;function b(l){return C(l)?!l.value:Array.isArray(l)?l.every(b):!0}e.$Zj=b;function C(l){return l instanceof w?!0:l&&typeof l=="object"?typeof l.value=="string"&&(typeof l.isTrusted=="boolean"||typeof l.isTrusted=="object"||l.isTrusted===void 0)&&(typeof l.supportThemeIcons=="boolean"||l.supportThemeIcons===void 0):!1}e.$1j=C;function E(l,f){return l===f?!0:!l||!f?!1:l.value===f.value&&l.isTrusted===f.isTrusted&&l.supportThemeIcons===f.supportThemeIcons&&l.supportHtml===f.supportHtml&&(l.baseUri===f.baseUri||!!l.baseUri&&!!f.baseUri&&(0,r.$lg)(L.URI.from(l.baseUri),L.URI.from(f.baseUri)))}e.$2j=E;function v(l){return l.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$3j=v;function d(l){return l.replace(/"/g,"&quot;")}e.$4j=d;function g(l){return l&&l.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$5j=g;function m(l){const f=[],u=l.split("|").map(p=>p.trim());l=u[0];const c=u[1];if(c){const p=/height=(\d+)/.exec(c),h=/width=(\d+)/.exec(c),t=p?p[1]:"",s=h?h[1]:"",o=isFinite(parseInt(s)),i=isFinite(parseInt(t));o&&f.push(`width="${s}"`),i&&f.push(`height="${t}"`)}return{href:l,dimensions:f}}e.$6j=m}),define(we[152],pe([1,0,18,38,7,3,19,17]),function(le,e,y,R,r,P,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sv=e.$rv=e.$qv=e.$pv=e.$ov=e.$nv=e.$mv=e.$lv=e.$kv=e.$jv=void 0;function w(i,n){const{os:a,tildify:$,relative:S}=n;if(S){const A=b(i,S,a);if(typeof A=="string")return A}let D=i.fsPath;if(a===1&&!P.$d?D=D.replace(/\//g,"\\"):a!==1&&P.$d&&(D=D.replace(/\\/g,"/")),a!==1&&$?.userHome){const A=$.userHome.fsPath;let j;i.scheme!==$.userHome.scheme&&i.path.startsWith(r.$ec.sep)?j=$.userHome.with({path:i.path}).fsPath:j=i.fsPath,D=v(j,A,a)}return(a===1?r.$dc:r.$ec).normalize(C(D,a===1))}e.$jv=w;function b(i,n,a){const $=a===1?r.$dc:r.$ec,S=a===3?L.$ig:L.$kg,D=n.getWorkspace(),k=(0,y.$Mb)(D.folders);if(!k)return;i.scheme!==k.uri.scheme&&i.path.startsWith(r.$ec.sep)&&(i=k.uri.with({path:i.path}));const A=n.getWorkspaceFolder(i);if(!A)return;let j;if(S.isEqual(A.uri,i)?j="":j=S.relativePath(A.uri,i)??"",j&&(j=$.normalize(j)),D.folders.length>1&&!n.noPrefix){const Z=A.name?A.name:S.basenameOrAuthority(A.uri);j=j?`${Z} \u2022 ${j}`:Z}return j}function C(i,n=P.$d){return(0,R.$Zf)(i,n)?i.charAt(0).toUpperCase()+i.slice(1):i}e.$kv=C;let E=Object.create(null);function v(i,n,a=P.OS){if(a===1||!i||!n)return i;let $=E.original===n?E.normalized:void 0;$||($=n,P.$d&&($=(0,R.$Pf)($)),$=`${(0,I.$Ie)($,r.$ec.sep)}${r.$ec.sep}`,E={original:n,normalized:$});let S=i;return P.$d&&(S=(0,R.$Pf)(S)),(a===3?S.startsWith($):(0,I.$1e)(S,$))?`~/${S.substr($.length)}`:i}e.$lv=v;function d(i,n){return i.replace(/^~($|\/|\\)/,`${n}$1`)}e.$mv=d;const g="\u2026",m="\\\\",l="~";function f(i,n=r.sep){const a=new Array(i.length);let $=!1;for(let S=0;S<i.length;S++){const D=i[S];if(D===""){a[S]=`.${n}`;continue}if(!D){a[S]=D;continue}$=!0;let k="",A=D;A.indexOf(m)===0?(k=A.substr(0,A.indexOf(m)+m.length),A=A.substr(A.indexOf(m)+m.length)):A.indexOf(n)===0?(k=A.substr(0,A.indexOf(n)+n.length),A=A.substr(A.indexOf(n)+n.length)):A.indexOf(l)===0&&(k=A.substr(0,A.indexOf(l)+l.length),A=A.substr(A.indexOf(l)+l.length));const j=A.split(n);for(let Z=1;$&&Z<=j.length;Z++)for(let ae=j.length-Z;$&&ae>=0;ae--){$=!1;let K=j.slice(ae,ae+Z).join(n);for(let se=0;!$&&se<i.length;se++)if(se!==S&&i[se]&&i[se].indexOf(K)>-1){const ue=ae+Z===j.length,x=ae>0&&i[se].indexOf(n)>-1?n+K:K,he=i[se].endsWith(x);$=!ue||he}if(!$){let se="";(j[0].endsWith(":")||k!=="")&&(ae===1&&(ae=0,Z++,K=j[0]+n+K),ae>0&&(se=j[0]+n),se=k+se),ae>0&&(se=se+g+n),se=se+K,ae+Z<j.length&&(se=se+n+g),a[S]=se}}$&&(a[S]=D)}return a}e.$nv=f;var u;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(u||(u={}));function c(i,n=Object.create(null)){const a=[];let $=!1,S="";for(const D of i)if(D==="$"||$&&D==="{")S&&a.push({value:S,type:u.TEXT}),S="",$=!0;else if(D==="}"&&$){const k=n[S];if(typeof k=="string")k.length&&a.push({value:k,type:u.VARIABLE});else if(k){const A=a[a.length-1];(!A||A.type!==u.SEPARATOR)&&a.push({value:k.label,type:u.SEPARATOR})}S="",$=!1}else S+=D;return S&&!$&&a.push({value:S,type:u.TEXT}),a.filter((D,k)=>{if(D.type===u.SEPARATOR){const A=a[k-1],j=a[k+1];return[A,j].every(Z=>Z&&(Z.type===u.VARIABLE||Z.type===u.TEXT)&&Z.value.length>0)}return!0}).map(D=>D.value).join("")}e.$ov=c;function p(i,n){return P.$e||n?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,P.$e?"&":"&&"):i.replace(/&&|&/g,a=>a==="&"?"&&":"&")}e.$pv=p;function h(i,n){return P.$e||n?i.replace(/\(&&\w\)|&&/g,""):P.$d?i.replace(/&&|&/g,a=>a==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.$qv=h;function t(i){return i.replace(/&/g,"&&")}e.$rv=t;function s(i){if(i.endsWith("]")){const n=i.lastIndexOf(" [",i.length-2);if(n!==-1){const a=o(i.substring(0,n));return{name:a.name,parentPath:a.parentPath+i.substring(n)}}}return o(i)}e.$sv=s;function o(i){const n=i.indexOf("/")!==-1?r.$ec:r.$dc,a=n.basename(i),$=n.dirname(i);return a.length?{name:a,parentPath:$}:{name:$,parentPath:""}}}),define(we[51],pe([1,0,15,4]),function(le,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hm=e.$Gm=e.$Fm=e.$Em=e.$Dm=void 0;function r(E){return E.toJSON()}class P{constructor(v){this.a=v}transformIncoming(v){const d=this.a.transformIncoming(v);return d===v?v:r(R.URI.from(d))}transformOutgoing(v){const d=this.a.transformOutgoing(v);return d===v?v:r(R.URI.from(d))}transformOutgoingURI(v){const d=this.a.transformOutgoing(v);return d===v?v:R.URI.from(d)}transformOutgoingScheme(v){return this.a.transformOutgoingScheme(v)}}e.$Dm=P,e.$Em=new class{transformIncoming(E){return E}transformOutgoing(E){return E}transformOutgoingURI(E){return E}transformOutgoingScheme(E){return E}};function L(E,v,d){if(!E||d>200)return null;if(typeof E=="object"){if(E instanceof R.URI)return v.transformOutgoing(E);for(const g in E)if(Object.hasOwnProperty.call(E,g)){const m=L(E[g],v,d+1);m!==null&&(E[g]=m)}}return null}function I(E,v){const d=L(E,v,0);return d===null?E:d}e.$Fm=I;function w(E,v,d,g){if(!E||g>200)return null;if(typeof E=="object"){if(E.$mid===1)return d?R.URI.revive(v.transformIncoming(E)):v.transformIncoming(E);if(E instanceof y.$_d)return null;for(const m in E)if(Object.hasOwnProperty.call(E,m)){const l=w(E[m],v,d,g+1);l!==null&&(E[m]=l)}}return null}function b(E,v){const d=w(E,v,!1,0);return d===null?E:d}e.$Gm=b;function C(E,v){const d=w(E,v,!0,0);return d===null?E:d}e.$Hm=C}),define(we[23],pe([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bg=e.$ag=void 0;const y=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function R(r){return y.test(r)}e.$ag=R,e.$bg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let r;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?r=crypto.getRandomValues.bind(crypto):r=function(I){for(let w=0;w<I.length;w++)I[w]=Math.floor(Math.random()*256);return I};const P=new Uint8Array(16),L=[];for(let I=0;I<256;I++)L.push(I.toString(16).padStart(2,"0"));return function(){r(P),P[6]=P[6]&15|64,P[8]=P[8]&63|128;let w=0,b="";return b+=L[P[w++]],b+=L[P[w++]],b+=L[P[w++]],b+=L[P[w++]],b+="-",b+=L[P[w++]],b+=L[P[w++]],b+="-",b+=L[P[w++]],b+=L[P[w++]],b+="-",b+=L[P[w++]],b+=L[P[w++]],b+="-",b+=L[P[w++]],b+=L[P[w++]],b+=L[P[w++]],b+=L[P[w++]],b+=L[P[w++]],b+=L[P[w++]],b}}()}),define(we[153],pe([1,0,18,47,23]),function(le,e,y,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vs=e.$Us=e.$Ts=e.$Ss=e.$Rs=void 0;function P(E){return{asString:async()=>E,asFile:()=>{},value:typeof E=="string"?E:void 0}}e.$Rs=P;function L(E,v,d){const g={id:(0,r.$bg)(),name:E,uri:v,data:d};return{asString:async()=>"",asFile:()=>g,value:void 0}}e.$Ss=L;class I{constructor(){this.a=new Map}get size(){let v=0;for(const d of this.a)v++;return v}has(v){return this.a.has(this.b(v))}matches(v){const d=[...this.a.keys()];return R.Iterable.some(this,([g,m])=>m.asFile())&&d.push("files"),C(w(v),d)}get(v){return this.a.get(this.b(v))?.[0]}append(v,d){const g=this.a.get(v);g?g.push(d):this.a.set(this.b(v),[d])}replace(v,d){this.a.set(this.b(v),[d])}delete(v){this.a.delete(this.b(v))}*[Symbol.iterator](){for(const[v,d]of this.a)for(const g of d)yield[v,g]}b(v){return w(v)}}e.$Ts=I;function w(E){return E.toLowerCase()}function b(E,v){return C(w(E),v.map(w))}e.$Us=b;function C(E,v){if(E==="*/*")return v.length>0;if(v.includes(E))return!0;const d=E.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!d)return!1;const[g,m,l]=d;return l==="*"?v.some(f=>f.startsWith(m+"/")):!1}e.$Vs=Object.freeze({create:E=>(0,y.$Kb)(E.map(v=>v.toString())).join(`\r
`),split:E=>E.split(`\r
`),parse:E=>e.$Vs.split(E).filter(v=>!v.startsWith("#"))})}),function(){"use strict";function le(e,y,R){function r(d){return new Promise(g=>y.exists(d,g))}function P(d){return new Promise((g,m)=>{const l=new Date;y.utimes(d,l,l,f=>f?m(f):g())})}function L(d){return new Promise((g,m)=>y.mkdir(d,{recursive:!0},l=>l&&l.code!=="EEXIST"?m(l):g(d)))}function I(d){return new Promise((g,m)=>y.rm(d,{recursive:!0,force:!0,maxRetries:3},l=>l?m(l):g()))}function w(d){return new Promise((g,m)=>y.readFile(d,"utf8",(l,f)=>l?m(l):g(f)))}function b(d,g){return new Promise((m,l)=>y.writeFile(d,g,"utf8",f=>f?l(f):m()))}async function C(d){const g=e.join(d,"languagepacks.json");try{return JSON.parse(await w(g))}catch{}}function E(d,g){try{for(;g;){if(d[g])return g;{const m=g.lastIndexOf("-");if(m>0)g=g.substring(0,m);else return}}}catch(m){console.error("Resolving language pack configuration failed.",m)}}function v(d,g,m,l,f){const u=function(p){return R.mark("code/didGenerateNls"),Promise.resolve({locale:p,osLocale:f,availableLanguages:{}})};if(R.mark("code/willGenerateNls"),l==="pseudo")return Promise.resolve({locale:l,osLocale:f,availableLanguages:{},pseudo:!0});if(process.env.VSCODE_DEV)return Promise.resolve({locale:l,osLocale:f,availableLanguages:{}});if(l&&(l==="en"||l==="en-us"))return Promise.resolve({locale:l,osLocale:f,availableLanguages:{}});const c=l;try{return d?C(g).then(p=>{if(!p)return u(c);const h=E(p,l);if(!h)return u(c);l=h;const t=p[l];let s;return!t||typeof t.hash!="string"||!t.translations||typeof(s=t.translations.vscode)!="string"?u(c):r(s).then(o=>{if(!o)return u(c);const i=t.hash+"."+l,n=e.join(g,"clp",i),a=e.join(n,d),$=e.join(n,"tcf.json"),S=e.join(n,"corrupted.info"),D={locale:c,osLocale:f,availableLanguages:{"*":l},_languagePackId:i,_translationsConfigFile:$,_cacheRoot:n,_resolvedLanguagePackCoreLocation:a,_corruptedFile:S};return r(S).then(k=>{let A;return k?A=I(n):A=Promise.resolve(void 0),A.then(()=>r(a).then(j=>j?(P(a).catch(()=>{}),R.mark("code/didGenerateNls"),D):L(a).then(()=>Promise.all([w(m),w(s)])).then(Z=>{const ae=JSON.parse(Z[0]),K=JSON.parse(Z[1]).contents,se=Object.keys(ae.bundles),ue=[];for(const x of se){const he=ae.bundles[x],V=Object.create(null);for(const te of he){const G=ae.keys[te],J=ae.messages[te],q=K[te];let ne;if(q){ne=[];for(let me=0;me<G.length;me++){const re=G[me],B=typeof re=="string"?re:re.key;let ee=q[B];ee===void 0&&(ee=J[me]),ne.push(ee)}}else ne=J;V[te]=ne}ue.push(b(e.join(a,x.replace(/\//g,"!")+".nls.json"),JSON.stringify(V)))}return ue.push(b($,JSON.stringify(t.translations))),Promise.all(ue)}).then(()=>(R.mark("code/didGenerateNls"),D)).catch(Z=>(console.error("Generating translation files failed.",Z),u(l)))))})})}):u(c)}catch(p){return console.error("Generating translation files failed.",p),u(l)}}return{getNLSConfiguration:v}}if(typeof define=="function")define(we[154],pe([77,29,41]),function(e,y,R){return le(e,y,R)});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),y=require("fs"),R=require("../common/performance");module.exports=le(e,y,R)}else throw new Error("Unknown context")}(),define(we[155],pe([1,0,27]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Im=void 0;const R=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function r(L){const I=L.replace(/\-/g,":").toLowerCase();return!R.has(I)}function P(){const L=(0,y.networkInterfaces)();for(const I in L){const w=L[I];if(w){for(const{mac:b}of w)if(r(b))return b}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.$Im=P}),define(we[101],pe([1,0,27,63,23,155]),function(le,e,y,R,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Km=e.$Jm=void 0,e.$Jm=new class{c(b){return this.a||(this.a=R.$Rh.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(b)}value(){if(this.b===void 0){let b=0,C=0;const E=(0,y.networkInterfaces)();for(const v in E){const d=E[v];if(d)for(const{mac:g,internal:m}of d)m||(C+=1,this.c(g.toUpperCase())&&(b+=1))}this.b=C>0?b/C:0}return this.b}};let L;async function I(b){return L||(L=(async()=>await w(b)||r.$bg())()),L}e.$Km=I;async function w(b){try{const C=await new Promise((v,d)=>{le(["crypto"],v,d)}),E=(0,P.$Im)();return C.createHash("sha256").update(E,"utf8").digest("hex")}catch(C){b(C);return}}}),define(we[156],pe([1,0,29,294,295,3]),function(le,e,y,R,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cg=void 0;async function L(I){if(P.$e||P.$d)return;let w;for(const b of["/etc/os-release","/usr/lib/os-release","/etc/lsb-release"])try{w=await(0,R.open)(b,y.constants.R_OK);break}catch{}if(!w){I("Unable to retrieve release information from known identifier paths.");return}try{const b=new Set(["ID","DISTRIB_ID","ID_LIKE","VERSION_ID","DISTRIB_RELEASE"]),C={id:"unknown"};for await(const E of(0,r.createInterface)({input:w.createReadStream(),crlfDelay:1/0})){if(!E.includes("="))continue;const v=E.split("=")[0].toUpperCase().trim();if(b.has(v)){const d=E.split("=")[1].replace(/"/g,"").toLowerCase().trim();v==="ID"||v==="DISTRIB_ID"?C.id=d:v==="ID_LIKE"?C.id_like=d:(v==="VERSION_ID"||v==="DISTRIB_RELEASE")&&(C.version_id=d)}}return C}catch(b){I(b)}}e.$cg=L}),define(we[21],pe([1,0,29,27,296,14,38,98,7,3,19,4]),function(le,e,y,R,r,P,L,I,w,b,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var v;(function(x){x[x.UNLINK=0]="UNLINK",x[x.MOVE=1]="MOVE"})(v||(e.RimRafMode=v={}));async function d(x,he=v.UNLINK,V){if((0,L.$Yf)(x))throw new Error("rimraf - will refuse to recursively delete root");return he===v.UNLINK?m(x):g(x,V)}async function g(x,he=(0,L.$4f)((0,R.tmpdir)())){try{try{await y.promises.rename(x,he)}catch(V){return V.code==="ENOENT"?void 0:m(x)}m(he).catch(V=>{})}catch(V){if(V.code!=="ENOENT")throw V}}async function m(x){return(0,r.promisify)(y.rm)(x,{recursive:!0,force:!0,maxRetries:3})}function l(x){if((0,L.$Yf)(x))throw new Error("rimraf - will refuse to recursively delete root");y.rmSync(x,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=l;async function f(x,he){return p(await(he?u(x):(0,r.promisify)(y.readdir)(x)))}async function u(x){try{return await(0,r.promisify)(y.readdir)(x,{withFileTypes:!0})}catch(te){console.warn("[node.js fs] readdir with filetypes failed with error: ",te)}const he=[],V=await f(x);for(const te of V){let G=!1,J=!1,q=!1;try{const ne=await e.Promises.lstat((0,w.$hc)(x,te));G=ne.isFile(),J=ne.isDirectory(),q=ne.isSymbolicLink()}catch(ne){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ne)}he.push({name:te,isFile:()=>G,isDirectory:()=>J,isSymbolicLink:()=>q})}return he}function c(x){return p(y.readdirSync(x))}e.readdirSync=c;function p(x){return x.map(he=>typeof he=="string"?b.$e?(0,I.$jl)(he):he:(he.name=b.$e?(0,I.$jl)(he.name):he.name,he))}async function h(x){const he=await f(x),V=[];for(const te of he)await s.existsDirectory((0,w.$hc)(x,te))&&V.push(te);return V}function t(x,he=1e3){return new Promise(V=>{let te=!1;const G=setInterval(()=>{te||(te=!0,y.access(x,J=>{te=!1,J&&(clearInterval(G),V(void 0))}))},he)})}e.whenDeleted=t;var s;(function(x){async function he(G){let J;try{if(J=await e.Promises.lstat(G),!J.isSymbolicLink())return{stat:J}}catch{}try{return{stat:await e.Promises.stat(G),symbolicLink:J?.isSymbolicLink()?{dangling:!1}:void 0}}catch(q){if(q.code==="ENOENT"&&J)return{stat:J,symbolicLink:{dangling:!0}};if(b.$d&&q.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(G)),symbolicLink:{dangling:!1}}}catch(ne){if(ne.code==="ENOENT"&&J)return{stat:J,symbolicLink:{dangling:!0}};throw ne}throw q}}x.stat=he;async function V(G){try{const{stat:J,symbolicLink:q}=await x.stat(G);return J.isFile()&&q?.dangling!==!0}catch{}return!1}x.existsFile=V;async function te(G){try{const{stat:J,symbolicLink:q}=await x.stat(G);return J.isDirectory()&&q?.dangling!==!0}catch{}return!1}x.existsDirectory=te})(s||(e.SymlinkSupport=s={}));const o=new P.$Zg;function i(x,he,V){return o.queueFor(E.URI.file(x),C.$jg).queue(()=>{const te=D(V);return new Promise((G,J)=>$(x,he,te,q=>q?J(q):G()))})}let n=!0;function a(x){n=x}e.configureFlushOnWrite=a;function $(x,he,V,te){if(!n)return y.writeFile(x,he,{mode:V.mode,flag:V.flag},te);y.open(x,V.flag,V.mode,(G,J)=>{if(G)return te(G);y.writeFile(J,he,q=>{if(q)return y.close(J,()=>te(q));y.fdatasync(J,ne=>(ne&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ne),a(!1)),y.close(J,me=>te(me))))})})}function S(x,he,V){const te=D(V);if(!n)return y.writeFileSync(x,he,{mode:te.mode,flag:te.flag});const G=y.openSync(x,te.flag,te.mode);try{y.writeFileSync(G,he);try{y.fdatasyncSync(G)}catch(J){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",J),a(!1)}}finally{y.closeSync(G)}}e.writeFileSync=S;function D(x){return x?{mode:typeof x.mode=="number"?x.mode:438,flag:typeof x.flag=="string"?x.flag:"w"}:{mode:438,flag:"w"}}async function k(x,he,V=6e4){if(x!==he)try{b.$d&&typeof V=="number"?await A(x,he,Date.now(),V):await(0,r.promisify)(y.rename)(x,he)}catch(te){if(x.toLowerCase()!==he.toLowerCase()&&te.code==="EXDEV"||x.endsWith("."))await j(x,he,{preserveSymlinks:!1}),await d(x,v.MOVE);else throw te}}async function A(x,he,V,te,G=0){try{return await(0,r.promisify)(y.rename)(x,he)}catch(J){if(J.code!=="EACCES"&&J.code!=="EPERM"&&J.code!=="EBUSY")throw J;if(Date.now()-V>=te)throw console.error(`[node.js fs] rename failed after ${G} retries with error: ${J}`),J;if(G===0){let q=!1;try{const{stat:ne}=await s.stat(he);ne.isFile()||(q=!0)}catch{}if(q)throw J}return await(0,P.$Rg)(Math.min(100,G*10)),A(x,he,V,te,G+1)}}async function j(x,he,V){return ae(x,he,{root:{source:x,target:he},options:V,handledSourcePaths:new Set})}const Z=511;async function ae(x,he,V){if(V.handledSourcePaths.has(x))return;V.handledSourcePaths.add(x);const{stat:te,symbolicLink:G}=await s.stat(x);if(G){if(V.options.preserveSymlinks)try{return await ue(x,he,V)}catch(J){console.warn("[node.js fs] copy of symlink failed: ",J)}if(G.dangling)return}return te.isDirectory()?K(x,he,te.mode&Z,V):se(x,he,te.mode&Z)}async function K(x,he,V,te){await e.Promises.mkdir(he,{recursive:!0,mode:V});const G=await f(x);for(const J of G)await ae((0,w.$hc)(x,J),(0,w.$hc)(he,J),te)}async function se(x,he,V){await e.Promises.copyFile(x,he),await e.Promises.chmod(he,V)}async function ue(x,he,V){let te=await e.Promises.readlink(x);(0,L.$Vf)(te,V.root.source,!b.$f)&&(te=(0,w.$hc)(V.root.target,te.substr(V.root.source.length+1))),await e.Promises.symlink(te,he)}e.Promises=new class{get access(){return(0,r.promisify)(y.access)}get stat(){return(0,r.promisify)(y.stat)}get lstat(){return(0,r.promisify)(y.lstat)}get utimes(){return(0,r.promisify)(y.utimes)}get read(){return(x,he,V,te,G)=>new Promise((J,q)=>{y.read(x,he,V,te,G,(ne,me,re)=>ne?q(ne):J({bytesRead:me,buffer:re}))})}get readFile(){return(0,r.promisify)(y.readFile)}get write(){return(x,he,V,te,G)=>new Promise((J,q)=>{y.write(x,he,V,te,G,(ne,me,re)=>ne?q(ne):J({bytesWritten:me,buffer:re}))})}get appendFile(){return(0,r.promisify)(y.appendFile)}get fdatasync(){return(0,r.promisify)(y.fdatasync)}get truncate(){return(0,r.promisify)(y.truncate)}get copyFile(){return(0,r.promisify)(y.copyFile)}get open(){return(0,r.promisify)(y.open)}get close(){return(0,r.promisify)(y.close)}get symlink(){return(0,r.promisify)(y.symlink)}get readlink(){return(0,r.promisify)(y.readlink)}get chmod(){return(0,r.promisify)(y.chmod)}get mkdir(){return(0,r.promisify)(y.mkdir)}get unlink(){return(0,r.promisify)(y.unlink)}get rmdir(){return(0,r.promisify)(y.rmdir)}get realpath(){return(0,r.promisify)(y.realpath)}async exists(x){try{return await e.Promises.access(x),!0}catch{return!1}}get readdir(){return f}get readDirsInDir(){return h}get writeFile(){return i}get rm(){return d}get rename(){return k}get copy(){return j}}}),define(we[157],pe([1,0,29,7,3,17,21]),function(le,e,y,R,r,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zp=e.$Yp=e.$Xp=e.$Wp=void 0;function I(v){if(r.$f)return v;const d=(0,R.$kc)(v);if(v===d)return v;const g=((0,R.$lc)(v)||v).toLowerCase();try{const l=(0,L.readdirSync)(d).filter(f=>f.toLowerCase()===g);if(l.length===1){const f=I(d);if(f)return(0,R.$hc)(f,l[0])}else if(l.length>1){const f=l.indexOf(g);if(f>=0){const u=I(d);if(u)return(0,R.$hc)(u,l[f])}}}catch{}return null}e.$Wp=I;async function w(v){if(r.$f)return v;const d=(0,R.$kc)(v);if(v===d)return v;const g=((0,R.$lc)(v)||v).toLowerCase();try{const l=(await L.Promises.readdir(d)).filter(f=>f.toLowerCase()===g);if(l.length===1){const f=await w(d);if(f)return(0,R.$hc)(f,l[0])}else if(l.length>1){const f=l.indexOf(g);if(f>=0){const u=await w(d);if(u)return(0,R.$hc)(u,l[f])}}}catch{}return null}e.$Xp=w;async function b(v){try{return await L.Promises.realpath(v)}catch{const g=E(v);return await L.Promises.access(g,y.constants.R_OK),g}}e.$Yp=b;function C(v){try{return y.realpathSync(v)}catch{const g=E(v);return y.accessSync(g,y.constants.R_OK),g}}e.$Zp=C;function E(v){return(0,P.$Ie)((0,R.$fc)(v),R.sep)}}),define(we[158],pe([1,0,78]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fg=e.$eg=e.$dg=void 0;function R(I,w,b,C=1){let E=!1;return new Promise(v=>{const d=setTimeout(()=>{if(!E)return E=!0,v(0)},b);r(I,w,C,g=>{if(!E)return E=!0,clearTimeout(d),v(g)})})}e.$dg=R;function r(I,w,b,C){if(w===0)return C(0);const E=new y.Socket;E.once("connect",()=>(L(E),r(I+b,w-1,b,C))),E.once("data",()=>{}),E.once("error",v=>(L(E),v.code!=="ECONNREFUSED"?r(I+b,w-1,b,C):C(I))),E.connect(I,"127.0.0.1")}e.$eg={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function P(I,w,b,C="127.0.0.1"){let E=!1,v,d=1;const g=y.createServer({pauseOnConnect:!0});function m(l,f){E||(E=!0,g.removeAllListeners(),g.close(),v&&clearTimeout(v),f(l))}return new Promise(l=>{v=setTimeout(()=>{m(0,l)},b),g.on("listening",()=>{m(I,l)}),g.on("error",f=>{f&&(f.code==="EADDRINUSE"||f.code==="EACCES")&&d<w?(I++,d++,g.listen(I,C)):m(0,l)}),g.on("close",()=>{m(0,l)}),g.listen(I,C)})}e.$fg=P;function L(I){try{I.removeAllListeners("connect"),I.removeAllListeners("error"),I.end(),I.destroy(),I.unref()}catch(w){console.error(w)}}}),define(we[102],pe([1,0,27,7,21]),function(le,e,y,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tl=e.$sl=void 0;const P=/^\d+$/,L=/^Microsoft.PowerShell_.*/,I=/^Microsoft.PowerShellPreview_.*/;var w;(function(p){p[p.x64=0]="x64",p[p.x86=1]="x86",p[p.ARM=2]="ARM"})(w||(w={}));let b;switch(process.arch){case"ia32":b=1;break;case"arm":case"arm64":b=2;break;default:b=0;break}let C;process.env.PROCESSOR_ARCHITEW6432?C=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?C=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?C=1:C=0;class E{constructor(h,t,s){this.exePath=h,this.displayName=t,this.a=s}async exists(){return this.a===void 0&&(this.a=await r.SymlinkSupport.existsFile(this.exePath)),this.a}}function v({useAlternateBitness:p=!1}={}){return p?b===0?process.env["ProgramFiles(x86)"]||null:C===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function d({useAlternateBitness:p=!1,findPreview:h=!1}={}){const t=v({useAlternateBitness:p});if(!t)return null;const s=R.$hc(t,"PowerShell");if(!await r.SymlinkSupport.existsDirectory(s))return null;let o=-1,i=null;for(const $ of await r.Promises.readdir(s)){let S=-1;if(h){const k=$.indexOf("-");if(k<0)continue;const A=$.substring(0,k);if(!P.test(A)||$.substring(k+1)!=="preview")continue;S=parseInt(A,10)}else{if(!P.test($))continue;S=parseInt($,10)}if(S<=o)continue;const D=R.$hc(s,$,"pwsh.exe");await r.SymlinkSupport.existsFile(D)&&(i=D,o=S)}if(!i)return null;const n=t.includes("x86")?" (x86)":"",a=h?" Preview":"";return new E(i,`PowerShell${a}${n}`,!0)}async function g({findPreview:p}={}){if(!process.env.LOCALAPPDATA)return null;const h=R.$hc(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await r.SymlinkSupport.existsDirectory(h))return null;const{pwshMsixDirRegex:t,pwshMsixName:s}=p?{pwshMsixDirRegex:I,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:L,pwshMsixName:"PowerShell (Store)"};for(const o of await r.Promises.readdir(h))if(t.test(o)){const i=R.$hc(h,o,"pwsh.exe");return new E(i,s)}return null}function m(){const p=R.$hc(y.homedir(),".dotnet","tools","pwsh.exe");return new E(p,".NET Core PowerShell Global Tool")}function l(){const p=R.$hc(process.env.windir,b===1&&C!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new E(p,"Windows PowerShell",!0)}async function*f(){let p=await d();p&&(yield p),p=await d({useAlternateBitness:!0}),p&&(yield p),p=await g(),p&&(yield p),p=m(),p&&(yield p),p=await d({findPreview:!0}),p&&(yield p),p=await g({findPreview:!0}),p&&(yield p),p=await d({useAlternateBitness:!0,findPreview:!0}),p&&(yield p),p=l(),p&&(yield p)}async function*u(){for await(const p of f())await p.exists()&&(yield p)}e.$sl=u;async function c(){for await(const p of u())return p;return null}e.$tl=c}),define(we[103],pe([1,0,7,3,28,59,8,21]),function(le,e,y,R,r,P,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$xl=e.$wl=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return P.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return P.TerminateResponseCode}});function w(E=r.env){return E.comspec||"cmd.exe"}e.$wl=w;function b(E){let v=[],d=!1;const g=function(m){if(d){v.push(m);return}(!E.send(m,f=>{if(f&&console.error(f),d=!1,v.length>0){const u=v.slice(0);v=[],u.forEach(c=>g(c))}})||R.$d)&&(d=!0)};return{send:g}}e.$xl=b;var C;(function(E){async function v(d,g,m){if(y.$gc(d))return d;if(g===void 0&&(g=r.cwd()),y.$kc(d)!=="."||(m===void 0&&L.$wf(r.env.PATH)&&(m=r.env.PATH.split(y.$rc)),m===void 0||m.length===0))return y.$hc(g,d);async function f(u){if(await I.Promises.exists(u)){let c;try{c=await I.Promises.stat(u)}catch(p){p.message.startsWith("EACCES")&&(c=await I.Promises.lstat(u))}return c?!c.isDirectory():!1}return!1}for(const u of m){let c;if(y.$gc(u)?c=y.$hc(u,d):c=y.$hc(g,u,d),await f(c))return c;let p=c+".com";if(await f(p)||(p=c+".exe",await f(p)))return p}return y.$hc(g,d)}E.findExecutable=v})(C||(e.win32=C={}))}),define(we[104],pe([1,0,52,12]),function(le,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ur=void 0;function r(L){return new Promise((I,w)=>{let b;const C=new Map;function E(d,g,m,l,f){const u=C.get(g);if(d===L||u){const c={name:v(m),cmd:m,pid:d,ppid:g,load:l,mem:f};C.set(d,c),d===L&&(b=c),u&&(u.children||(u.children=[]),u.children.push(c),u.children.length>1&&(u.children=u.children.sort((p,h)=>p.pid-h.pid)))}}function v(d){const g=/--utility-sub-type=network/i,m=/--ms-enable-electron-run-as-node/i,l=/--crashes-directory/i,f=/\\pipe\\winpty-control/i,u=/conhost\.exe.+--headless/i,c=/--type=([a-zA-Z-]+)/;if(l.exec(d))return"electron-crash-reporter";if(f.exec(d))return"winpty-agent";if(u.exec(d))return"conpty-agent";let p=c.exec(d);if(p&&p.length===2)return p[1]==="renderer"?"window":p[1]==="utility"?g.exec(d)?"utility-network-service":"utility-process":p[1]==="extensionHost"?"extension-host":p[1];const h=/[a-zA-Z-]+\.js/g;let t="";do p=h.exec(d),p&&(t+=p+" ");while(p);return t&&d.indexOf("node ")<0&&d.indexOf("node.exe")<0?`electron-nodejs (${t})`:m.exec(d)?`electron-nodejs (${d})`:d}if(process.platform==="win32"){const d=g=>g.indexOf("\\\\?\\")===0||g.indexOf("\\??\\")===0?g.substring(4):g.indexOf('"\\\\?\\')===0||g.indexOf('"\\??\\')===0?'"'+g.substring(5):g;new Promise((g,m)=>{le(["@vscode/windows-process-tree"],g,m)}).then(g=>{g.getProcessList(L,m=>{if(!m){w(new Error(`Root process ${L} not found`));return}g.getProcessCpuUsage(m,l=>{const f=new Map;l.forEach(u=>{const c=d(u.commandLine||"");f.set(u.pid,{name:v(c),cmd:c,pid:u.pid,ppid:u.ppid,load:u.cpu||0,mem:u.memory||0})}),b=f.get(L),b?(f.forEach(u=>{const c=f.get(u.ppid);c&&(c.children||(c.children=[]),c.children.push(u))}),f.forEach(u=>{u.children&&(u.children=u.children.sort((c,p)=>c.pid-p.pid))}),I(b)):w(new Error(`Root process ${L} not found`))})},g.ProcessDataFlag.CommandLine|g.ProcessDataFlag.Memory)})}else{let d=function(){let g=[b];const m=[];for(;g.length;){const f=g.shift();f&&(m.push(f.pid),f.children&&(g=g.concat(f.children)))}let l=JSON.stringify(R.$_f.asFileUri("vs/base/node/cpuUsage.sh").fsPath);l+=" "+m.join(" "),(0,y.exec)(l,{},(f,u,c)=>{if(f||c)w(f||new Error(c.toString()));else{const p=u.toString().split(`
`);for(let h=0;h<m.length;h++){const t=C.get(m[h]);t.load=parseFloat(p[h])}if(!b){w(new Error(`Root process ${L} not found`));return}I(b)}})};(0,y.exec)("which ps",{},(g,m,l)=>{if(g||l)if(process.platform!=="linux")w(g||new Error(l.toString()));else{const f=JSON.stringify(R.$_f.asFileUri("vs/base/node/ps.sh").fsPath);(0,y.exec)(f,{},(u,c,p)=>{u||p?w(u||new Error(p.toString())):(P(c,E),d())})}else{const f=m.toString().trim(),u="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,y.exec)(`${f} ${u}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(c,p,h)=>{c||h&&!h.includes("screen size is bogus")?w(c||new Error(h.toString())):(P(p,E),process.platform==="linux"?d():b?I(b):w(new Error(`Root process ${L} not found`)))})}})}})}e.$ur=r;function P(L,I){const w=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,b=L.toString().split(`
`);for(const C of b){const E=w.exec(C.trim());E&&E.length===6&&I(parseInt(E[1]),parseInt(E[2]),E[5],parseFloat(E[3]),parseFloat(E[4]))}}}),define(we[105],pe([1,0,27,3,102,103]),function(le,e,y,R,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yl=void 0;async function L(E,v){return E===1?R.$d?C():P.$wl(v):w(E,v)}e.$yl=L;let I=null;function w(E,v){if(R.$f&&E===2||R.$e&&E===3)return"/bin/bash";if(!I){let d;if(R.$d)d="/bin/bash";else{if(d=v.SHELL,!d)try{d=(0,y.userInfo)().shell}catch{}d||(d="sh"),d==="/bin/false"&&(d="/bin/bash")}I=d}return I}let b=null;async function C(){return b||(b=(await(0,r.$tl)()).exePath),b}}),function(){function le(){function e(){return process.uncHostAllowlist}function y(w){const b=new Set;if(Array.isArray(w))for(const C of w)typeof C=="string"&&b.add(C);return Array.from(b)}function R(){const w=e();return w?Array.from(w):[]}function r(w){if(process.platform!=="win32")return;const b=e();if(b)if(typeof w=="string")b.add(w.toLowerCase());else for(const C of y(w))r(C)}function P(w){if(typeof w!="string")return;const b=["\\\\.\\UNC\\","\\\\?\\UNC\\","\\\\"];let C;for(const E of b){if(w.indexOf(E)!==0)continue;const d=w.indexOf("\\",E.length);if(d===-1)continue;const g=w.substring(E.length,d);if(g){C=g;break}}return C}function L(){process.platform==="win32"&&(process.restrictUNCAccess=!1)}function I(){return process.platform!=="win32"?!0:process.restrictUNCAccess===!1}return{getUNCHostAllowlist:R,addUNCHostToAllowlist:r,getUNCHost:P,disableUNCAccessRestrictions:L,isUNCAccessRestrictionsDisabled:I}}typeof define=="function"?define("vs/base/node/unc",[],function(){return le()}):typeof module=="object"&&typeof module.exports=="object"?module.exports=le():console.trace("vs/base/node/unc defined in UNKNOWN context (neither requirejs or commonjs)")}();var Oe=this&&this.__decorate||function(le,e,y,R){var r=arguments.length,P=r<3?e:R===null?R=Object.getOwnPropertyDescriptor(e,y):R,L;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")P=Reflect.decorate(le,e,y,R);else for(var I=le.length-1;I>=0;I--)(L=le[I])&&(P=(r<3?L(P):r>3?L(e,y,P):L(e,y))||P);return r>3&&P&&Object.defineProperty(e,y,P),P};define(we[42],pe([1,0,18,14,15,20,73,11,5,2,50,17,8]),function(le,e,y,R,r,P,L,I,w,b,C,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uh=e.ProxyChannel=e.$th=e.$sh=e.$rh=e.$qh=e.$ph=e.$oh=e.RequestInitiator=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=void 0;var d;(function(G){G[G.Promise=100]="Promise",G[G.PromiseCancel=101]="PromiseCancel",G[G.EventListen=102]="EventListen",G[G.EventDispose=103]="EventDispose"})(d||(d={}));function g(G){switch(G){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var m;(function(G){G[G.Initialize=200]="Initialize",G[G.PromiseSuccess=201]="PromiseSuccess",G[G.PromiseError=202]="PromiseError",G[G.PromiseErrorObj=203]="PromiseErrorObj",G[G.EventFire=204]="EventFire"})(m||(m={}));function l(G){switch(G){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var f;(function(G){G[G.Uninitialized=0]="Uninitialized",G[G.Idle=1]="Idle"})(f||(f={}));function u(G){let J=0;for(let q=0;;q+=7){const ne=G.read(1);if(J|=(ne.buffer[0]&127)<<q,!(ne.buffer[0]&128))return J}}const c=o(0);function p(G,J){if(J===0){G.write(c);return}let q=0;for(let me=J;me!==0;me=me>>>7)q++;const ne=r.$_d.alloc(q);for(let me=0;J!==0;me++)ne.buffer[me]=J&127,J=J>>>7,J>0&&(ne.buffer[me]|=128);G.write(ne)}class h{constructor(J){this.b=J,this.a=0}read(J){const q=this.b.slice(this.a,this.a+J);return this.a+=q.byteLength,q}}e.$jh=h;class t{constructor(){this.a=[]}get buffer(){return r.$_d.concat(this.a)}write(J){this.a.push(J)}}e.$kh=t;var s;(function(G){G[G.Undefined=0]="Undefined",G[G.String=1]="String",G[G.Buffer=2]="Buffer",G[G.VSBuffer=3]="VSBuffer",G[G.Array=4]="Array",G[G.Object=5]="Object",G[G.Int=6]="Int"})(s||(s={}));function o(G){const J=r.$_d.alloc(1);return J.writeUInt8(G,0),J}const i={Undefined:o(s.Undefined),String:o(s.String),Buffer:o(s.Buffer),VSBuffer:o(s.VSBuffer),Array:o(s.Array),Object:o(s.Object),Uint:o(s.Int)},n=typeof Buffer<"u";function a(G,J){if(typeof J>"u")G.write(i.Undefined);else if(typeof J=="string"){const q=r.$_d.fromString(J);G.write(i.String),p(G,q.byteLength),G.write(q)}else if(n&&Buffer.isBuffer(J)){const q=r.$_d.wrap(J);G.write(i.Buffer),p(G,q.byteLength),G.write(q)}else if(J instanceof r.$_d)G.write(i.VSBuffer),p(G,J.byteLength),G.write(J);else if(Array.isArray(J)){G.write(i.Array),p(G,J.length);for(const q of J)a(G,q)}else if(typeof J=="number"&&(J|0)===J)G.write(i.Uint),p(G,J);else{const q=r.$_d.fromString(JSON.stringify(J));G.write(i.Object),p(G,q.byteLength),G.write(q)}}e.$lh=a;function $(G){switch(G.read(1).readUInt8(0)){case s.Undefined:return;case s.String:return G.read(u(G)).toString();case s.Buffer:return G.read(u(G)).buffer;case s.VSBuffer:return G.read(u(G));case s.Array:{const q=u(G),ne=[];for(let me=0;me<q;me++)ne.push($(G));return ne}case s.Object:return JSON.parse(G.read(u(G)).toString());case s.Int:return u(G)}}e.$mh=$;class S{constructor(J,q,ne=null,me=1e3){this.h=J,this.j=q,this.k=ne,this.l=me,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(re=>this.q(re)),this.m({type:200})}registerChannel(J,q){this.b.set(J,q),setTimeout(()=>this.w(J),0)}m(J){switch(J.type){case 200:{const q=this.o([J.type]);this.k?.logOutgoing(q,0,1,l(J.type));return}case 201:case 202:case 204:case 203:{const q=this.o([J.type,J.id],J.data);this.k?.logOutgoing(q,J.id,1,l(J.type),J.data);return}}}o(J,q=void 0){const ne=new t;return a(ne,J),a(ne,q),this.p(ne.buffer)}p(J){try{return this.h.send(J),J.byteLength}catch{return 0}}q(J){const q=new h(J),ne=$(q),me=$(q),re=ne[0];switch(re){case 100:return this.k?.logIncoming(J.byteLength,ne[1],1,`${g(re)}: ${ne[2]}.${ne[3]}`,me),this.s({type:re,id:ne[1],channelName:ne[2],name:ne[3],arg:me});case 102:return this.k?.logIncoming(J.byteLength,ne[1],1,`${g(re)}: ${ne[2]}.${ne[3]}`,me),this.t({type:re,id:ne[1],channelName:ne[2],name:ne[3],arg:me});case 101:return this.k?.logIncoming(J.byteLength,ne[1],1,`${g(re)}`),this.u({type:re,id:ne[1]});case 103:return this.k?.logIncoming(J.byteLength,ne[1],1,`${g(re)}`),this.u({type:re,id:ne[1]})}}s(J){const q=this.b.get(J.channelName);if(!q){this.v(J);return}const ne=new P.$Vd;let me;try{me=q.call(this.j,J.name,J.arg,ne.token)}catch(ee){me=Promise.reject(ee)}const re=J.id;me.then(ee=>{this.m({id:re,data:ee,type:201})},ee=>{ee instanceof Error?this.m({id:re,data:{message:ee.message,name:ee.name,stack:ee.stack?ee.stack.split?ee.stack.split(`
`):ee.stack:void 0},type:202}):this.m({id:re,data:ee,type:203})}).finally(()=>{B.dispose(),this.d.delete(J.id)});const B=(0,b.$Oc)(()=>ne.cancel());this.d.set(J.id,B)}t(J){const q=this.b.get(J.channelName);if(!q){this.v(J);return}const ne=J.id,re=q.listen(this.j,J.name,J.arg)(B=>this.m({id:ne,data:B,type:204}));this.d.set(J.id,re)}u(J){const q=this.d.get(J.id);q&&(q.dispose(),this.d.delete(J.id))}v(J){let q=this.g.get(J.channelName);q||(q=[],this.g.set(J.channelName,q));const ne=setTimeout(()=>{console.error(`Unknown channel: ${J.channelName}`),J.type===100&&this.m({id:J.id,data:{name:"Unknown channel",message:`Channel name '${J.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);q.push({request:J,timeoutTimer:ne})}w(J){const q=this.g.get(J);if(q){for(const ne of q)switch(clearTimeout(ne.timeoutTimer),ne.request.type){case 100:this.s(ne.request);break;case 102:this.t(ne.request);break}this.g.delete(J)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,b.$Lc)(this.d.values()),this.d.clear()}}e.$nh=S;var D;(function(G){G[G.LocalSide=0]="LocalSide",G[G.OtherSide=1]="OtherSide"})(D||(e.RequestInitiator=D={}));class k{constructor(J,q=null){this.l=J,this.a=!1,this.b=f.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new w.$Ld,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ne=>this.s(ne)),this.j=q}getChannel(J){const q=this;return{call(ne,me,re){return q.a?Promise.reject(new I.$3):q.m(J,ne,me,re)},listen(ne,me){return q.a?w.Event.None:q.o(J,ne,me)}}}m(J,q,ne,me=P.CancellationToken.None){const re=this.g++,ee={id:re,type:100,channelName:J,name:q,arg:ne};if(me.isCancellationRequested)return Promise.reject(new I.$3);let O;return new Promise((Q,T)=>{if(me.isCancellationRequested)return T(new I.$3);const H=()=>{const _=W=>{switch(W.type){case 201:this.f.delete(re),Q(W.data);break;case 202:{this.f.delete(re);const X=new Error(W.data.message);X.stack=Array.isArray(W.data.stack)?W.data.stack.join(`
`):W.data.stack,X.name=W.data.name,T(X);break}case 203:this.f.delete(re),T(W.data);break}};this.f.set(re,_),this.p(ee)};let U=null;this.b===f.Idle?H():(U=(0,R.$Eg)(_=>this.u()),U.then(()=>{U=null,H()}));const ie=()=>{U?(U.cancel(),U=null):this.p({id:re,type:101}),T(new I.$3)},z=me.onCancellationRequested(ie);O=(0,b.$Nc)((0,b.$Oc)(ie),z),this.d.add(O)}).finally(()=>{O.dispose(),this.d.delete(O)})}o(J,q,ne){const me=this.g++,B={id:me,type:102,channelName:J,name:q,arg:ne};let ee=null;const O=new w.$Ld({onWillAddFirstListener:()=>{ee=(0,R.$Eg)(Q=>this.u()),ee.then(()=>{ee=null,this.d.add(O),this.p(B)})},onDidRemoveLastListener:()=>{ee?(ee.cancel(),ee=null):(this.d.delete(O),this.p({id:me,type:103}))}}),N=Q=>O.fire(Q.data);return this.f.set(me,N),O.event}p(J){switch(J.type){case 100:case 102:{const q=this.q([J.type,J.id,J.channelName,J.name],J.arg);this.j?.logOutgoing(q,J.id,0,`${g(J.type)}: ${J.channelName}.${J.name}`,J.arg);return}case 101:case 103:{const q=this.q([J.type,J.id]);this.j?.logOutgoing(q,J.id,0,g(J.type));return}}}q(J,q=void 0){const ne=new t;return a(ne,J),a(ne,q),this.r(ne.buffer)}r(J){try{return this.l.send(J),J.byteLength}catch{return 0}}s(J){const q=new h(J),ne=$(q),me=$(q),re=ne[0];switch(re){case 200:return this.j?.logIncoming(J.byteLength,0,0,l(re)),this.t({type:ne[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(J.byteLength,ne[1],0,l(re),me),this.t({type:ne[0],id:ne[1],data:me})}}t(J){if(J.type===200){this.b=f.Idle,this.k.fire();return}this.f.get(J.id)?.(J)}get onDidInitializePromise(){return w.Event.toPromise(this.onDidInitialize)}u(){return this.b===f.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,b.$Lc)(this.d.values()),this.d.clear()}}e.$oh=k,Oe([L.$dh],k.prototype,"onDidInitializePromise",null);class A{get connections(){const J=[];return this.f.forEach(q=>J.push(q)),J}constructor(J){this.a=new Map,this.f=new Set,this.g=new w.$Ld,this.onDidAddConnection=this.g.event,this.h=new w.$Ld,this.onDidRemoveConnection=this.h.event,this.j=new b.$Pc,this.j.add(J(({protocol:q,onDidClientDisconnect:ne})=>{const me=w.Event.once(q.onMessage);this.j.add(me(re=>{const B=new h(re),ee=$(B),O=new S(q,ee),N=new k(q);this.a.forEach((T,H)=>O.registerChannel(H,T));const Q={channelServer:O,channelClient:N,ctx:ee};this.f.add(Q),this.g.fire(Q),this.j.add(ne(()=>{O.dispose(),N.dispose(),this.f.delete(Q),this.h.fire(Q)}))}))}))}getChannel(J,q){const ne=this;return{call(me,re,B){let ee;if((0,v.$Kf)(q)){const N=(0,y.$2b)(ne.connections.filter(q));ee=N?Promise.resolve(N):w.Event.toPromise(w.Event.filter(ne.onDidAddConnection,q))}else ee=q.routeCall(ne,me,re);const O=ee.then(N=>N.channelClient.getChannel(J));return Z(O).call(me,re,B)},listen(me,re){if((0,v.$Kf)(q))return ne.k(J,q,me,re);const B=q.routeEvent(ne,me,re).then(ee=>ee.channelClient.getChannel(J));return Z(B).listen(me,re)}}}k(J,q,ne,me){const re=this;let B;const ee=new w.$Ld({onWillAddFirstListener:()=>{B=new b.$Pc;const O=new w.$Rd,N=new Map,Q=H=>{const ie=H.channelClient.getChannel(J).listen(ne,me),z=O.add(ie);N.set(H,z)},T=H=>{const U=N.get(H);U&&(U.dispose(),N.delete(H))};re.connections.filter(q).forEach(Q),w.Event.filter(re.onDidAddConnection,q)(Q,void 0,B),re.onDidRemoveConnection(T,void 0,B),O.event(ee.fire,ee,B),B.add(O)},onDidRemoveLastListener:()=>{B?.dispose(),B=void 0}});return ee.event}registerChannel(J,q){this.a.set(J,q);for(const ne of this.f)ne.channelServer.registerChannel(J,q)}dispose(){this.j.dispose();for(const J of this.f)J.channelClient.dispose(),J.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$ph=A;class j{constructor(J,q,ne=null){const me=new t;a(me,q),J.send(me.buffer),this.a=new k(J,ne),this.d=new S(J,q,ne)}getChannel(J){return this.a.getChannel(J)}registerChannel(J,q){this.d.registerChannel(J,q)}dispose(){this.a.dispose(),this.d.dispose()}}e.$qh=j;function Z(G){return{call(J,q,ne){return G.then(me=>me.call(J,q,ne))},listen(J,q){const ne=new w.$Ud;return G.then(me=>ne.input=me.listen(J,q)),ne.event}}}e.$rh=Z;function ae(G){let J=!1;return{call(q,ne,me){return J?G.call(q,ne,me):(0,R.$Rg)(0).then(()=>J=!0).then(()=>G.call(q,ne,me))},listen(q,ne){if(J)return G.listen(q,ne);const me=new w.$Ud;return(0,R.$Rg)(0).then(()=>J=!0).then(()=>me.input=G.listen(q,ne)),me.event}}}e.$sh=ae;class K{constructor(J){this.a=J}routeCall(J){return this.b(J)}routeEvent(J){return this.b(J)}async b(J){for(const q of J.connections)if(await Promise.resolve(this.a(q.ctx)))return Promise.resolve(q);return await w.Event.toPromise(J.onDidAddConnection),await this.b(J)}}e.$th=K;var se;(function(G){function J(re,B,ee){const O=re,N=ee&&ee.disableMarshalling,Q=new Map;for(const T in O)ne(T)&&Q.set(T,w.Event.buffer(O[T],!0,void 0,B));return new class{listen(T,H,U){const ie=Q.get(H);if(ie)return ie;if(me(H)){const z=O[H];if(typeof z=="function")return z.call(O,U)}throw new I.$_(`Event not found: ${H}`)}call(T,H,U){const ie=O[H];if(typeof ie=="function"){if(!N&&Array.isArray(U))for(let _=0;_<U.length;_++)U[_]=(0,C.$ih)(U[_]);let z=ie.apply(O,U);return z instanceof Promise||(z=Promise.resolve(z)),z}throw new I.$_(`Method not found: ${H}`)}}}G.fromService=J;function q(re,B){const ee=B&&B.disableMarshalling;return new Proxy({},{get(O,N){if(typeof N=="string")return B?.properties?.has(N)?B.properties.get(N):me(N)?function(Q){return re.listen(N,Q)}:ne(N)?re.listen(N):async function(...Q){let T;B&&!(0,v.$Ff)(B.context)?T=[B.context,...Q]:T=Q;const H=await re.call(N,T);return ee?H:(0,C.$ih)(H)};throw new I.$_(`Property not found: ${String(N)}`)}})}G.toService=q;function ne(re){return re[0]==="o"&&re[1]==="n"&&E.$Ye(re.charCodeAt(2))}function me(re){return/^onDynamic/.test(re)&&E.$Ye(re.charCodeAt(9))}})(se||(e.ProxyChannel=se={}));const ue=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function x(G){if(Array.isArray(G))return G;if(G&&typeof G=="object"&&typeof G.toString=="function"){const J=G.toString();if(J!=="[object Object]")return J}return G}function he(G){return Array.isArray(G)?G.map(x):x(G)}function V(G,J,q,ne,me,re,B){B=he(B);const ee=ue[me],O=ee[ne%ee.length];let N=[`%c[${G}]%c[${String(J).padStart(7," ")}]%c[len: ${String(q).padStart(5," ")}]%c${String(ne).padStart(5," ")} - ${re}`,"color: darkgreen","color: grey","color: grey",`color: ${O}`];/\($/.test(re)?(N=N.concat(B),N.push(")")):N.push(B),console.log.apply(console,N)}class te{constructor(J,q){this.d=J,this.f=q,this.a=0,this.b=0}logOutgoing(J,q,ne,me,re){this.b+=J,V(this.d,this.b,J,q,ne,me,re)}logIncoming(J,q,ne,me,re){this.a+=J,V(this.f,this.a,J,q,ne,me,re)}}e.$uh=te}),define(we[106],pe([1,0,15,5,2,42]),function(le,e,y,R,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zh=e.$yh=e.$xh=e.$wh=e.ProtocolConstants=e.$vh=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var L;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(L||(e.SocketDiagnosticsEventType=L={}));var I;(function(i){i.enableDiagnostics=!1,i.records=[];const n=new WeakMap;let a=0;function $(D,k){if(!n.has(D)){const A=String(++a);n.set(D,A)}return n.get(D)}function S(D,k,A,j){if(!i.enableDiagnostics)return;const Z=$(D,k);if(j instanceof y.$_d||j instanceof Uint8Array||j instanceof ArrayBuffer||ArrayBuffer.isView(j)){const ae=y.$_d.alloc(j.byteLength);ae.set(j),i.records.push({timestamp:Date.now(),id:Z,label:k,type:A,buff:ae})}else i.records.push({timestamp:Date.now(),id:Z,label:k,type:A,data:j})}i.traceSocketEvent=S})(I||(e.SocketDiagnostics=I={}));var w;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(w||(e.SocketCloseEventType=w={}));let b=null;function C(){return b||(b=y.$_d.alloc(0)),b}class E{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(n){this.a.push(n),this.b+=n.byteLength}read(n){return this.c(n,!0)}peek(n){return this.c(n,!1)}c(n,a){if(n===0)return C();if(n>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===n){const k=this.a[0];return a&&(this.a.shift(),this.b-=n),k}if(this.a[0].byteLength>n){const k=this.a[0].slice(0,n);return a&&(this.a[0]=this.a[0].slice(n),this.b-=n),k}const $=y.$_d.alloc(n);let S=0,D=0;for(;n>0;){const k=this.a[D];if(k.byteLength>n){const A=k.slice(0,n);$.set(A,S),S+=n,a&&(this.a[D]=k.slice(n),this.b-=n),n-=n}else $.set(k,S),S+=k.byteLength,a?(this.a.shift(),this.b-=k.byteLength):D++,n-=k.byteLength}return $}}e.$vh=E;var v;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume",i[i.KeepAlive=9]="KeepAlive"})(v||(v={}));function d(i){switch(i){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var g;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",i[i.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(g||(e.ProtocolConstants=g={}));class m{constructor(n,a,$,S){this.type=n,this.id=a,this.ack=$,this.data=S,this.writtenTime=0}get size(){return this.data.byteLength}}class l extends r.$Qc{constructor(n){super(),this.f=this.B(new R.$Ld),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=n,this.b=!1,this.c=new E,this.B(this.a.onData(a=>this.acceptChunk(a))),this.lastReadTime=Date.now()}acceptChunk(n){if(!(!n||n.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(n);this.c.byteLength>=this.g.readLen;){const a=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=a.readUInt32BE(9),this.g.messageType=a.readUInt8(0),this.g.id=a.readUInt32BE(1),this.g.ack=a.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:d(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const $=this.g.messageType,S=this.g.id,D=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",a),this.f.fire(new m($,S,D,a)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class f{constructor(n){this.k=null,this.a=!1,this.b=!1,this.c=n,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(n){if(this.a)return;n.writtenTime=Date.now(),this.lastWriteTime=Date.now();const a=y.$_d.alloc(13);a.writeUInt8(n.type,0),a.writeUInt32BE(n.id,1),a.writeUInt32BE(n.ack,5),a.writeUInt32BE(n.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:d(n.type),id:n.id,ack:n.ack,messageSize:n.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",n.data),this.j(a,n.data)}g(n,a){const $=this.f===0;return this.d.push(n,a),this.f+=n.byteLength+a.byteLength,$}h(){const n=y.$_d.concat(this.d,this.f);return this.d.length=0,this.f=0,n}j(n,a){this.g(n,a)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const n=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:n.byteLength}),this.c.write(n)}}class u extends r.$Qc{constructor(n){super(),this.f=new R.$Ld,this.onMessage=this.f.event,this.g=new R.$Ld,this.onDidDispose=this.g.event,this.a=n,this.b=this.B(new f(this.a)),this.c=this.B(new l(this.a)),this.B(this.c.onMessage(a=>{a.type===1&&this.f.fire(a.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(n){this.b.write(new m(1,0,0,n))}}e.$wh=u;class c extends P.$qh{static fromSocket(n,a){return new c(new u(n),a)}get onDidDispose(){return this.b.onDidDispose}constructor(n,a,$=null){super(n,a,$),this.b=n}dispose(){super.dispose();const n=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),n.end()}}e.$xh=c;class p{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new R.$Ld({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(n){this.b?this.d.length>0?this.d.push(n):this.a.fire(n):this.d.push(n)}flushBuffer(){this.d=[]}}e.$yh=p;class h{constructor(n){this.data=n,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let n=0,a=this.a;for(;a;)a=a.next,n++;return n}peek(){return this.a?this.a.data:null}toArray(){const n=[];let a=0,$=this.a;for(;$;)n[a++]=$.data,$=$.next;return n}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(n){const a=new h(n);if(!this.a){this.a=a,this.b=a;return}this.b.next=a,this.b=a}}class s{static getInstance(){return s.b||(s.b=new s),s.b}constructor(){this.c=[];const n=Date.now();for(let a=0;a<s.a;a++)this.c[a]=n-1e3*a;setInterval(()=>{for(let a=s.a;a>=1;a--)this.c[a]=this.c[a-1];this.c[0]=Date.now()},1e3)}d(){const n=Date.now(),a=(1+s.a)*1e3;let $=0;for(let S=0;S<s.a;S++)n-this.c[S]<=a&&$++;return 1-$/s.a}hasHighLoad(){return this.d()>=.5}}s.a=10,s.b=null;class o{get unacknowledgedCount(){return this.c-this.d}constructor(n){this.u=new p,this.onControlMessage=this.u.event,this.v=new p,this.onMessage=this.v.event,this.w=new p,this.onDidDispose=this.w.event,this.x=new p,this.onSocketClose=this.x.event,this.y=new p,this.onSocketTimeout=this.y.event,this.s=n.loadEstimator??s.getInstance(),this.t=n.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new r.$Pc,this.o=n.socket,this.p=this.r.add(new f(this.o)),this.q=this.r.add(new l(this.o)),this.r.add(this.q.onMessage(a=>this.z(a))),this.r.add(this.o.onClose(a=>this.x.fire(a))),n.initialChunk&&this.q.acceptChunk(n.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const n=new m(5,0,0,C());this.p.write(n),this.p.flush()}sendPause(){const n=new m(7,0,0,C());this.p.write(n)}sendResume(){const n=new m(8,0,0,C());this.p.write(n)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(n,a){this.a=!0,this.r.dispose(),this.r=new r.$Pc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=n,this.p=this.r.add(new f(this.o)),this.q=this.r.add(new l(this.o)),this.r.add(this.q.onMessage($=>this.z($))),this.r.add(this.o.onClose($=>this.x.fire($))),this.q.acceptChunk(a)}endAcceptReconnection(){this.a=!1,this.h=this.g;const n=new m(3,0,this.h,C());this.p.write(n);const a=this.b.toArray();for(let $=0,S=a.length;$<S;$++)this.p.write(a[$]);this.B()}acceptDisconnect(){this.w.fire()}z(n){if(n.ack>this.d){this.d=n.ack;do{const a=this.b.peek();if(a&&a.id<=n.ack)this.b.pop();else break}while(!0)}switch(n.type){case 0:break;case 1:{if(n.id>this.g)if(n.id!==this.g+1){const a=Date.now();a-this.m>1e4&&(this.m=a,this.p.write(new m(6,0,0,C())))}else this.g=n.id,this.j=Date.now(),this.A(),this.v.fire(n.data);break}case 2:{this.u.fire(n.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const a=this.b.toArray();for(let $=0,S=a.length;$<S;$++)this.p.write(a[$]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(n){const a=++this.c;this.h=this.g;const $=new m(1,a,this.h,n);this.b.push($),this.a||(this.p.write($),this.B())}sendControl(n){const a=new m(2,0,0,n);this.p.write(a)}A(){if(this.g<=this.h||this.k)return;const n=Date.now()-this.j;if(n>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-n+5)}B(){if(this.c<=this.d||this.f||this.a)return;const n=this.b.peek(),a=Date.now()-n.writtenTime,$=Date.now()-this.q.lastReadTime,S=Date.now()-this.n;if(a>=2e4&&$>=2e4&&S>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:a,timeSinceLastReceivedSomeData:$});return}const D=Math.max(2e4-a,2e4-$,2e4-S,500);this.f=setTimeout(()=>{this.f=null,this.B()},D)}C(){if(this.g<=this.h)return;this.h=this.g;const n=new m(3,0,this.h,C());this.p.write(n)}D(){this.h=this.g;const n=new m(9,0,this.h,C());this.p.write(n)}}e.$zh=o}),define(we[107],pe([1,0,52,14,15,20,150,11,5,2,22,103,59,42]),function(le,e,y,R,r,P,L,I,w,b,C,E,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Up=e.$Tp=void 0;class g extends d.$nh{constructor(f){super({send:u=>{try{process.send?.(u.buffer.toString("base64"))}catch{}},onMessage:w.Event.fromNodeEventEmitter(process,"message",u=>r.$_d.wrap(Buffer.from(u,"base64")))},f),process.once("disconnect",()=>this.dispose())}}e.$Tp=g;class m{constructor(f,u){this.i=f,this.j=u,this.c=new Set,this.g=new Map,this.h=new w.$Ld,this.onDidProcessExit=this.h.event;const c=u&&u.timeout?u.timeout:6e4;this.b=new R.$Ng(c),this.d=null,this.f=null}getChannel(f){const u=this;return{call(c,p,h){return u.k(f,c,p,h)},listen(c,p){return u.l(f,c,p)}}}k(f,u,c,p=P.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(p.isCancellationRequested)return Promise.reject(I.$4());this.b.cancel();const h=this.n(f),t=(0,R.$Eg)(i=>h.call(u,c,i)),s=p.onCancellationRequested(()=>t.cancel()),o=(0,b.$Oc)(()=>t.cancel());return this.c.add(o),t.finally(()=>{s.dispose(),this.c.delete(o),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(f,u,c){if(!this.b)return w.Event.None;this.b.cancel();let p;const h=new w.$Ld({onWillAddFirstListener:()=>{p=this.n(f).listen(u,c)(h.fire,h),this.c.add(p)},onDidRemoveLastListener:()=>{this.c.delete(p),p.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return h.event}get m(){if(!this.f){const f=this.j&&this.j.args?this.j.args:[],u=Object.create(null);u.env={...(0,C.$Xm)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(u.env={...u.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(u.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(u.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(u.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),u.execArgv===void 0&&(u.execArgv=process.execArgv.filter(n=>!/^--inspect(-brk)?=/.test(n)).filter(n=>!n.startsWith("--vscode-"))),(0,v.$vl)(u.env),this.d=(0,y.fork)(this.i,f,u);const c=new w.$Ld;w.Event.fromNodeEventEmitter(this.d,"message",n=>n)(n=>{if((0,L.$Pp)(n)){(0,L.log)(n,`IPC Library: ${this.j.serverName}`);return}c.fire(r.$_d.wrap(Buffer.from(n,"base64")))});const h=this.j.useQueue?(0,E.$xl)(this.d):this.d,t=n=>this.d&&this.d.connected&&h.send(n.buffer.toString("base64")),s=c.event,o={send:t,onMessage:s};this.f=new d.$oh(o);const i=()=>this.o();process.once("exit",i),this.d.on("error",n=>console.warn('IPC "'+this.j.serverName+'" errored with '+n)),this.d.on("exit",(n,a)=>{process.removeListener("exit",i),this.c.forEach($=>(0,b.$Lc)($)),this.c.clear(),n!==0&&a!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+n+" and signal "+a),this.b?.cancel(),this.o(),this.h.fire({code:n,signal:a})})}return this.f}n(f){let u=this.g.get(f);return u||(u=this.m.getChannel(f),this.g.set(f,u)),u}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$Up=m}),define(we[159],pe([1,0,14,5,2,50,8]),function(le,e,y,R,r,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uo=e.$To=e.StorageState=e.$So=e.StorageHint=void 0;var I;(function(v){v[v.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",v[v.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(I||(e.StorageHint=I={}));function w(v){const d=v;return d?.changed instanceof Map||d?.deleted instanceof Set}e.$So=w;var b;(function(v){v[v.None=0]="None",v[v.Initialized=1]="Initialized",v[v.Closed=2]="Closed"})(b||(e.StorageState=b={}));class C extends r.$Qc{constructor(d,g=Object.create(null)){super(),this.r=d,this.s=g,this.b=this.B(new R.$Od),this.onDidChangeStorage=this.b.event,this.c=b.None,this.f=new Map,this.g=this.B(new y.$Og(C.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(d=>this.u(d)))}u(d){this.b.pause();try{d.changed?.forEach((g,m)=>this.w(m,g)),d.deleted?.forEach(g=>this.w(g,void 0))}finally{this.b.resume()}}w(d,g){if(this.c===b.Closed)return;let m=!1;(0,L.$Ff)(g)?m=this.f.delete(d):this.f.get(d)!==g&&(this.f.set(d,g),m=!0),m&&this.b.fire({key:d,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===b.None&&(this.c=b.Initialized,this.s.hint!==I.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(d,g){const m=this.f.get(d);return(0,L.$Ff)(m)?g:m}getBoolean(d,g){const m=this.get(d);return(0,L.$Ff)(m)?g:m==="true"}getNumber(d,g){const m=this.get(d);return(0,L.$Ff)(m)?g:parseInt(m,10)}getObject(d,g){const m=this.get(d);return(0,L.$Ff)(m)?g:(0,P.$hh)(m)}async set(d,g,m=!1){if(this.c===b.Closed)return;if((0,L.$Ff)(g))return this.delete(d,m);const l=(0,L.$yf)(g)||Array.isArray(g)?(0,P.$gh)(g):String(g);if(this.f.get(d)!==l)return this.f.set(d,l),this.j.set(d,l),this.h.delete(d),this.b.fire({key:d,external:m}),this.D()}async delete(d,g=!1){if(!(this.c===b.Closed||!this.f.delete(d)))return this.h.has(d)||this.h.add(d),this.j.delete(d),this.b.fire({key:d,external:g}),this.D()}async optimize(){if(this.c!==b.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=b.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const d={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(d).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(d){if(this.z)return this.D(d)}async D(d){return this.s.hint===I.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),d)}async whenFlushed(){if(this.z)return new Promise(d=>this.n.push(d))}isInMemory(){return this.s.hint===I.STORAGE_IN_MEMORY}}e.$To=C,C.a=100;class E{constructor(){this.onDidChangeItemsExternal=R.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(d){d.insert?.forEach((g,m)=>this.a.set(m,g)),d.delete?.forEach(g=>this.a.delete(g))}async optimize(){}async close(){}}e.$Uo=E}),define(we[108],pe([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ls=void 0;class y{constructor(r,P){this.lineNumber=r,this.column=P}with(r=this.lineNumber,P=this.column){return r===this.lineNumber&&P===this.column?this:new y(r,P)}delta(r=0,P=0){return this.with(this.lineNumber+r,this.column+P)}equals(r){return y.equals(this,r)}static equals(r,P){return!r&&!P?!0:!!r&&!!P&&r.lineNumber===P.lineNumber&&r.column===P.column}isBefore(r){return y.isBefore(this,r)}static isBefore(r,P){return r.lineNumber<P.lineNumber?!0:P.lineNumber<r.lineNumber?!1:r.column<P.column}isBeforeOrEqual(r){return y.isBeforeOrEqual(this,r)}static isBeforeOrEqual(r,P){return r.lineNumber<P.lineNumber?!0:P.lineNumber<r.lineNumber?!1:r.column<=P.column}static compare(r,P){const L=r.lineNumber|0,I=P.lineNumber|0;if(L===I){const w=r.column|0,b=P.column|0;return w-b}return L-I}clone(){return new y(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(r){return new y(r.lineNumber,r.column)}static isIPosition(r){return r&&typeof r.lineNumber=="number"&&typeof r.column=="number"}}e.$ls=y}),define(we[43],pe([1,0,108]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ms=void 0;class R{constructor(P,L,I,w){P>I||P===I&&L>w?(this.startLineNumber=I,this.startColumn=w,this.endLineNumber=P,this.endColumn=L):(this.startLineNumber=P,this.startColumn=L,this.endLineNumber=I,this.endColumn=w)}isEmpty(){return R.isEmpty(this)}static isEmpty(P){return P.startLineNumber===P.endLineNumber&&P.startColumn===P.endColumn}containsPosition(P){return R.containsPosition(this,P)}static containsPosition(P,L){return!(L.lineNumber<P.startLineNumber||L.lineNumber>P.endLineNumber||L.lineNumber===P.startLineNumber&&L.column<P.startColumn||L.lineNumber===P.endLineNumber&&L.column>P.endColumn)}static strictContainsPosition(P,L){return!(L.lineNumber<P.startLineNumber||L.lineNumber>P.endLineNumber||L.lineNumber===P.startLineNumber&&L.column<=P.startColumn||L.lineNumber===P.endLineNumber&&L.column>=P.endColumn)}containsRange(P){return R.containsRange(this,P)}static containsRange(P,L){return!(L.startLineNumber<P.startLineNumber||L.endLineNumber<P.startLineNumber||L.startLineNumber>P.endLineNumber||L.endLineNumber>P.endLineNumber||L.startLineNumber===P.startLineNumber&&L.startColumn<P.startColumn||L.endLineNumber===P.endLineNumber&&L.endColumn>P.endColumn)}strictContainsRange(P){return R.strictContainsRange(this,P)}static strictContainsRange(P,L){return!(L.startLineNumber<P.startLineNumber||L.endLineNumber<P.startLineNumber||L.startLineNumber>P.endLineNumber||L.endLineNumber>P.endLineNumber||L.startLineNumber===P.startLineNumber&&L.startColumn<=P.startColumn||L.endLineNumber===P.endLineNumber&&L.endColumn>=P.endColumn)}plusRange(P){return R.plusRange(this,P)}static plusRange(P,L){let I,w,b,C;return L.startLineNumber<P.startLineNumber?(I=L.startLineNumber,w=L.startColumn):L.startLineNumber===P.startLineNumber?(I=L.startLineNumber,w=Math.min(L.startColumn,P.startColumn)):(I=P.startLineNumber,w=P.startColumn),L.endLineNumber>P.endLineNumber?(b=L.endLineNumber,C=L.endColumn):L.endLineNumber===P.endLineNumber?(b=L.endLineNumber,C=Math.max(L.endColumn,P.endColumn)):(b=P.endLineNumber,C=P.endColumn),new R(I,w,b,C)}intersectRanges(P){return R.intersectRanges(this,P)}static intersectRanges(P,L){let I=P.startLineNumber,w=P.startColumn,b=P.endLineNumber,C=P.endColumn;const E=L.startLineNumber,v=L.startColumn,d=L.endLineNumber,g=L.endColumn;return I<E?(I=E,w=v):I===E&&(w=Math.max(w,v)),b>d?(b=d,C=g):b===d&&(C=Math.min(C,g)),I>b||I===b&&w>C?null:new R(I,w,b,C)}equalsRange(P){return R.equalsRange(this,P)}static equalsRange(P,L){return!P&&!L?!0:!!P&&!!L&&P.startLineNumber===L.startLineNumber&&P.startColumn===L.startColumn&&P.endLineNumber===L.endLineNumber&&P.endColumn===L.endColumn}getEndPosition(){return R.getEndPosition(this)}static getEndPosition(P){return new y.$ls(P.endLineNumber,P.endColumn)}getStartPosition(){return R.getStartPosition(this)}static getStartPosition(P){return new y.$ls(P.startLineNumber,P.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(P,L){return new R(this.startLineNumber,this.startColumn,P,L)}setStartPosition(P,L){return new R(P,L,this.endLineNumber,this.endColumn)}collapseToStart(){return R.collapseToStart(this)}static collapseToStart(P){return new R(P.startLineNumber,P.startColumn,P.startLineNumber,P.startColumn)}collapseToEnd(){return R.collapseToEnd(this)}static collapseToEnd(P){return new R(P.endLineNumber,P.endColumn,P.endLineNumber,P.endColumn)}delta(P){return new R(this.startLineNumber+P,this.startColumn,this.endLineNumber+P,this.endColumn)}static fromPositions(P,L=P){return new R(P.lineNumber,P.column,L.lineNumber,L.column)}static lift(P){return P?new R(P.startLineNumber,P.startColumn,P.endLineNumber,P.endColumn):null}static isIRange(P){return P&&typeof P.startLineNumber=="number"&&typeof P.startColumn=="number"&&typeof P.endLineNumber=="number"&&typeof P.endColumn=="number"}static areIntersectingOrTouching(P,L){return!(P.endLineNumber<L.startLineNumber||P.endLineNumber===L.startLineNumber&&P.endColumn<L.startColumn||L.endLineNumber<P.startLineNumber||L.endLineNumber===P.startLineNumber&&L.endColumn<P.startColumn)}static areIntersecting(P,L){return!(P.endLineNumber<L.startLineNumber||P.endLineNumber===L.startLineNumber&&P.endColumn<=L.startColumn||L.endLineNumber<P.startLineNumber||L.endLineNumber===P.startLineNumber&&L.endColumn<=P.startColumn)}static compareRangesUsingStarts(P,L){if(P&&L){const b=P.startLineNumber|0,C=L.startLineNumber|0;if(b===C){const E=P.startColumn|0,v=L.startColumn|0;if(E===v){const d=P.endLineNumber|0,g=L.endLineNumber|0;if(d===g){const m=P.endColumn|0,l=L.endColumn|0;return m-l}return d-g}return E-v}return b-C}return(P?1:0)-(L?1:0)}static compareRangesUsingEnds(P,L){return P.endLineNumber===L.endLineNumber?P.endColumn===L.endColumn?P.startLineNumber===L.startLineNumber?P.startColumn-L.startColumn:P.startLineNumber-L.startLineNumber:P.endColumn-L.endColumn:P.endLineNumber-L.endLineNumber}static spansMultipleLines(P){return P.endLineNumber>P.startLineNumber}toJSON(){return this}}e.$ms=R}),define(we[160],pe([1,0,43]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ns=void 0;class R{static insert(P,L){return{range:new y.$ms(P.lineNumber,P.column,P.lineNumber,P.column),text:L,forceMoveMarkers:!0}}static delete(P){return{range:P,text:null}}static replace(P,L){return{range:P,text:L}}static replaceMove(P,L){return{range:P,text:L,forceMoveMarkers:!0}}}e.$ns=R}),define(we[161],pe([1,0,5,2]),function(le,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xs=void 0;class r{constructor(){this.a=new Map,this.b=new Map,this.c=new y.$Ld,this.onDidChange=this.c.event,this.d=null}handleChange(I){this.c.fire({changedLanguages:I,changedColorMap:!1})}register(I,w){return this.a.set(I,w),this.handleChange([I]),(0,R.$Oc)(()=>{this.a.get(I)===w&&(this.a.delete(I),this.handleChange([I]))})}get(I){return this.a.get(I)||null}registerFactory(I,w){this.b.get(I)?.dispose();const b=new P(this,I,w);return this.b.set(I,b),(0,R.$Oc)(()=>{const C=this.b.get(I);!C||C!==b||(this.b.delete(I),C.dispose())})}async getOrCreate(I){const w=this.get(I);if(w)return w;const b=this.b.get(I);return!b||b.isResolved?null:(await b.resolve(),this.get(I))}isResolved(I){if(this.get(I))return!0;const b=this.b.get(I);return!!(!b||b.isResolved)}setColorMap(I){this.d=I,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.$Xs=r;class P extends R.$Qc{get isResolved(){return this.c}constructor(I,w,b){super(),this.f=I,this.g=w,this.h=b,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const I=await this.h.tokenizationSupport;this.c=!0,I&&!this.a&&this.B(this.f.register(this.g,I))}}}),define(we[162],pe([9,10]),function(le,e){return le.create("vs/base/common/actions",e)}),define(we[163],pe([1,0,5,2,162]),function(le,e,y,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vi=e.$ui=e.$ti=e.$si=e.$ri=e.$qi=void 0;class P extends R.$Qc{constructor(v,d="",g="",m=!0,l){super(),this.h=this.B(new y.$Ld),this.onDidChange=this.h.event,this.w=!0,this.j=v,this.m=d,this.u=g,this.w=m,this.C=l}get id(){return this.j}get label(){return this.m}set label(v){this.D(v)}D(v){this.m!==v&&(this.m=v,this.h.fire({label:v}))}get tooltip(){return this.n||""}set tooltip(v){this.F(v)}F(v){this.n!==v&&(this.n=v,this.h.fire({tooltip:v}))}get class(){return this.u}set class(v){this.G(v)}G(v){this.u!==v&&(this.u=v,this.h.fire({class:v}))}get enabled(){return this.w}set enabled(v){this.H(v)}H(v){this.w!==v&&(this.w=v,this.h.fire({enabled:v}))}get checked(){return this.z}set checked(v){this.I(v)}I(v){this.z!==v&&(this.z=v,this.h.fire({checked:v}))}async run(v,d){this.C&&await this.C(v)}}e.$qi=P;class L extends R.$Qc{constructor(){super(...arguments),this.f=this.B(new y.$Ld),this.onWillRun=this.f.event,this.m=this.B(new y.$Ld),this.onDidRun=this.m.event}async run(v,d){if(!v.enabled)return;this.f.fire({action:v});let g;try{await this.u(v,d)}catch(m){g=m}this.m.fire({action:v,error:g})}async u(v,d){await v.run(d)}}e.$ri=L;class I{constructor(){this.id=I.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...v){let d=[];for(const g of v)g.length&&(d.length?d=[...d,new I,...g]:d=g);return d}async run(){}}e.$si=I,I.ID="vs.actions.separator";class w{get actions(){return this.a}constructor(v,d,g,m){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=v,this.label=d,this.class=m,this.a=g}async run(){}}e.$ti=w;class b extends P{constructor(){super(b.ID,r.localize(0,null),void 0,!1)}}e.$ui=b,b.ID="vs.actions.empty";function C(E){return{id:E.id,label:E.label,class:void 0,enabled:E.enabled??!0,checked:E.checked??!1,run:async(...v)=>E.run(...v),tooltip:E.label}}e.$vi=C}),define(we[164],pe([9,10]),function(le,e){return le.create("vs/base/common/date",e)}),define(we[165],pe([1,0,164]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9l=e.$8l=void 0;const R=60,r=R*60,P=r*24,L=P*7,I=P*30,w=P*365;function b(E,v,d,g){typeof E!="number"&&(E=E.getTime());const m=Math.round((new Date().getTime()-E)/1e3);if(m<-30)return(0,y.localize)(0,null,b(new Date().getTime()+m*1e3,!1));if(!g&&m<30)return(0,y.localize)(1,null);let l;return m<R?(l=m,v?l===1?d?(0,y.localize)(2,null,l):(0,y.localize)(3,null,l):d?(0,y.localize)(4,null,l):(0,y.localize)(5,null,l):l===1?d?(0,y.localize)(6,null,l):(0,y.localize)(7,null,l):d?(0,y.localize)(8,null,l):(0,y.localize)(9,null,l)):m<r?(l=Math.floor(m/R),v?l===1?d?(0,y.localize)(10,null,l):(0,y.localize)(11,null,l):d?(0,y.localize)(12,null,l):(0,y.localize)(13,null,l):l===1?d?(0,y.localize)(14,null,l):(0,y.localize)(15,null,l):d?(0,y.localize)(16,null,l):(0,y.localize)(17,null,l)):m<P?(l=Math.floor(m/r),v?l===1?d?(0,y.localize)(18,null,l):(0,y.localize)(19,null,l):d?(0,y.localize)(20,null,l):(0,y.localize)(21,null,l):l===1?d?(0,y.localize)(22,null,l):(0,y.localize)(23,null,l):d?(0,y.localize)(24,null,l):(0,y.localize)(25,null,l)):m<L?(l=Math.floor(m/P),v?l===1?(0,y.localize)(26,null,l):(0,y.localize)(27,null,l):l===1?(0,y.localize)(28,null,l):(0,y.localize)(29,null,l)):m<I?(l=Math.floor(m/L),v?l===1?d?(0,y.localize)(30,null,l):(0,y.localize)(31,null,l):d?(0,y.localize)(32,null,l):(0,y.localize)(33,null,l):l===1?d?(0,y.localize)(34,null,l):(0,y.localize)(35,null,l):d?(0,y.localize)(36,null,l):(0,y.localize)(37,null,l)):m<w?(l=Math.floor(m/I),v?l===1?d?(0,y.localize)(38,null,l):(0,y.localize)(39,null,l):d?(0,y.localize)(40,null,l):(0,y.localize)(41,null,l):l===1?d?(0,y.localize)(42,null,l):(0,y.localize)(43,null,l):d?(0,y.localize)(44,null,l):(0,y.localize)(45,null,l)):(l=Math.floor(m/w),v?l===1?d?(0,y.localize)(46,null,l):(0,y.localize)(47,null,l):d?(0,y.localize)(48,null,l):(0,y.localize)(49,null,l):l===1?d?(0,y.localize)(50,null,l):(0,y.localize)(51,null,l):d?(0,y.localize)(52,null,l):(0,y.localize)(53,null,l))}e.$8l=b;function C(E){return E.getFullYear()+"-"+String(E.getMonth()+1).padStart(2,"0")+"-"+String(E.getDate()).padStart(2,"0")+"T"+String(E.getHours()).padStart(2,"0")+":"+String(E.getMinutes()).padStart(2,"0")+":"+String(E.getSeconds()).padStart(2,"0")+"."+(E.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$9l=C}),define(we[166],pe([9,10]),function(le,e){return le.create("vs/base/common/errorMessage",e)}),define(we[39],pe([1,0,18,8,166]),function(le,e,y,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yi=e.$xi=e.$wi=void 0;function P(E,v){return v&&(E.stack||E.stacktrace)?r.localize(0,null,I(E),L(E.stack)||L(E.stacktrace)):I(E)}function L(E){return Array.isArray(E)?E.join(`
`):E}function I(E){return E.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${E.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof E.code=="string"&&typeof E.errno=="number"&&typeof E.syscall=="string"?r.localize(1,null,E.message):E.message||r.localize(2,null)}function w(E=null,v=!1){if(!E)return r.localize(3,null);if(Array.isArray(E)){const d=y.$Fb(E),g=w(d[0],v);return d.length>1?r.localize(4,null,g,d.length):g}if(R.$wf(E))return E;if(E.detail){const d=E.detail;if(d.error)return P(d.error,v);if(d.exception)return P(d.exception,v)}return E.stack?P(E,v):E.message?E.message:r.localize(5,null)}e.$wi=w;function b(E){const v=E;return v instanceof Error&&Array.isArray(v.actions)}e.$xi=b;function C(E,v){let d;return typeof E=="string"?d=new Error(E):d=E,d.actions=v,d}e.$yi=C}),define(we[167],pe([9,10]),function(le,e){return le.create("vs/base/common/jsonErrorMessages",e)}),define(we[168],pe([1,0,167]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$op=void 0;function R(r){switch(r){case 1:return(0,y.localize)(0,null);case 2:return(0,y.localize)(1,null);case 3:return(0,y.localize)(2,null);case 4:return(0,y.localize)(3,null);case 5:return(0,y.localize)(4,null);case 6:return(0,y.localize)(5,null);case 7:return(0,y.localize)(6,null);case 8:return(0,y.localize)(7,null);case 9:return(0,y.localize)(8,null);default:return""}}e.$op=R}),define(we[169],pe([9,10]),function(le,e){return le.create("vs/base/node/zip",e)}),define(we[170],pe([9,10]),function(le,e){return le.create("vs/editor/common/languages",e)}),define(we[171],pe([1,0,49,4,160,43,161,170]),function(le,e,y,R,r,P,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.$dt=e.$ct=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.$bt=e.$at=e.SymbolKinds=e.SymbolTag=e.$_s=e.$$s=e.SymbolKind=e.$0s=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.$9s=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.$8s=e.$7s=e.$6s=void 0;class w{constructor(se,ue,x){this.offset=se,this.type=ue,this.language=x,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.$6s=w;class b{constructor(se,ue){this.tokens=se,this.endState=ue,this._tokenizationResultBrand=void 0}}e.$7s=b;class C{constructor(se,ue){this.tokens=se,this.endState=ue,this._encodedTokenizationResultBrand=void 0}}e.$8s=C;var E;(function(K){K[K.Method=0]="Method",K[K.Function=1]="Function",K[K.Constructor=2]="Constructor",K[K.Field=3]="Field",K[K.Variable=4]="Variable",K[K.Class=5]="Class",K[K.Struct=6]="Struct",K[K.Interface=7]="Interface",K[K.Module=8]="Module",K[K.Property=9]="Property",K[K.Event=10]="Event",K[K.Operator=11]="Operator",K[K.Unit=12]="Unit",K[K.Value=13]="Value",K[K.Constant=14]="Constant",K[K.Enum=15]="Enum",K[K.EnumMember=16]="EnumMember",K[K.Keyword=17]="Keyword",K[K.Text=18]="Text",K[K.Color=19]="Color",K[K.File=20]="File",K[K.Reference=21]="Reference",K[K.Customcolor=22]="Customcolor",K[K.Folder=23]="Folder",K[K.TypeParameter=24]="TypeParameter",K[K.User=25]="User",K[K.Issue=26]="Issue",K[K.Snippet=27]="Snippet"})(E||(e.CompletionItemKind=E={}));var v;(function(K){const se=new Map;se.set(0,y.$Qj.symbolMethod),se.set(1,y.$Qj.symbolFunction),se.set(2,y.$Qj.symbolConstructor),se.set(3,y.$Qj.symbolField),se.set(4,y.$Qj.symbolVariable),se.set(5,y.$Qj.symbolClass),se.set(6,y.$Qj.symbolStruct),se.set(7,y.$Qj.symbolInterface),se.set(8,y.$Qj.symbolModule),se.set(9,y.$Qj.symbolProperty),se.set(10,y.$Qj.symbolEvent),se.set(11,y.$Qj.symbolOperator),se.set(12,y.$Qj.symbolUnit),se.set(13,y.$Qj.symbolValue),se.set(15,y.$Qj.symbolEnum),se.set(14,y.$Qj.symbolConstant),se.set(15,y.$Qj.symbolEnum),se.set(16,y.$Qj.symbolEnumMember),se.set(17,y.$Qj.symbolKeyword),se.set(27,y.$Qj.symbolSnippet),se.set(18,y.$Qj.symbolText),se.set(19,y.$Qj.symbolColor),se.set(20,y.$Qj.symbolFile),se.set(21,y.$Qj.symbolReference),se.set(22,y.$Qj.symbolCustomColor),se.set(23,y.$Qj.symbolFolder),se.set(24,y.$Qj.symbolTypeParameter),se.set(25,y.$Qj.account),se.set(26,y.$Qj.issues);function ue(V){let te=se.get(V);return te||(console.info("No codicon found for CompletionItemKind "+V),te=y.$Qj.symbolProperty),te}K.toIcon=ue;const x=new Map;x.set("method",0),x.set("function",1),x.set("constructor",2),x.set("field",3),x.set("variable",4),x.set("class",5),x.set("struct",6),x.set("interface",7),x.set("module",8),x.set("property",9),x.set("event",10),x.set("operator",11),x.set("unit",12),x.set("value",13),x.set("constant",14),x.set("enum",15),x.set("enum-member",16),x.set("enumMember",16),x.set("keyword",17),x.set("snippet",27),x.set("text",18),x.set("color",19),x.set("file",20),x.set("reference",21),x.set("customcolor",22),x.set("folder",23),x.set("type-parameter",24),x.set("typeParameter",24),x.set("account",25),x.set("issue",26);function he(V,te){let G=x.get(V);return typeof G>"u"&&!te&&(G=9),G}K.fromString=he})(v||(e.CompletionItemKinds=v={}));var d;(function(K){K[K.Deprecated=1]="Deprecated"})(d||(e.CompletionItemTag=d={}));var g;(function(K){K[K.None=0]="None",K[K.KeepWhitespace=1]="KeepWhitespace",K[K.InsertAsSnippet=4]="InsertAsSnippet"})(g||(e.CompletionItemInsertTextRule=g={}));var m;(function(K){K[K.Invoke=0]="Invoke",K[K.TriggerCharacter=1]="TriggerCharacter",K[K.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(m||(e.CompletionTriggerKind=m={}));var l;(function(K){K[K.Automatic=0]="Automatic",K[K.Explicit=1]="Explicit"})(l||(e.InlineCompletionTriggerKind=l={}));class f{constructor(se,ue,x,he){this.range=se,this.text=ue,this.completionKind=x,this.isSnippetText=he}equals(se){return P.$ms.lift(this.range).equalsRange(se.range)&&this.text===se.text&&this.completionKind===se.completionKind&&this.isSnippetText===se.isSnippetText}}e.$9s=f;var u;(function(K){K[K.Invoke=1]="Invoke",K[K.Auto=2]="Auto"})(u||(e.CodeActionTriggerType=u={}));var c;(function(K){K[K.Invoke=1]="Invoke",K[K.TriggerCharacter=2]="TriggerCharacter",K[K.ContentChange=3]="ContentChange"})(c||(e.SignatureHelpTriggerKind=c={}));var p;(function(K){K[K.Text=0]="Text",K[K.Read=1]="Read",K[K.Write=2]="Write"})(p||(e.DocumentHighlightKind=p={}));function h(K){return K&&R.URI.isUri(K.uri)&&P.$ms.isIRange(K.range)&&(P.$ms.isIRange(K.originSelectionRange)||P.$ms.isIRange(K.targetSelectionRange))}e.$0s=h;var t;(function(K){K[K.File=0]="File",K[K.Module=1]="Module",K[K.Namespace=2]="Namespace",K[K.Package=3]="Package",K[K.Class=4]="Class",K[K.Method=5]="Method",K[K.Property=6]="Property",K[K.Field=7]="Field",K[K.Constructor=8]="Constructor",K[K.Enum=9]="Enum",K[K.Interface=10]="Interface",K[K.Function=11]="Function",K[K.Variable=12]="Variable",K[K.Constant=13]="Constant",K[K.String=14]="String",K[K.Number=15]="Number",K[K.Boolean=16]="Boolean",K[K.Array=17]="Array",K[K.Object=18]="Object",K[K.Key=19]="Key",K[K.Null=20]="Null",K[K.EnumMember=21]="EnumMember",K[K.Struct=22]="Struct",K[K.Event=23]="Event",K[K.Operator=24]="Operator",K[K.TypeParameter=25]="TypeParameter"})(t||(e.SymbolKind=t={})),e.$$s={[17]:(0,I.localize)(0,null),[16]:(0,I.localize)(1,null),[4]:(0,I.localize)(2,null),[13]:(0,I.localize)(3,null),[8]:(0,I.localize)(4,null),[9]:(0,I.localize)(5,null),[21]:(0,I.localize)(6,null),[23]:(0,I.localize)(7,null),[7]:(0,I.localize)(8,null),[0]:(0,I.localize)(9,null),[11]:(0,I.localize)(10,null),[10]:(0,I.localize)(11,null),[19]:(0,I.localize)(12,null),[5]:(0,I.localize)(13,null),[1]:(0,I.localize)(14,null),[2]:(0,I.localize)(15,null),[20]:(0,I.localize)(16,null),[15]:(0,I.localize)(17,null),[18]:(0,I.localize)(18,null),[24]:(0,I.localize)(19,null),[3]:(0,I.localize)(20,null),[6]:(0,I.localize)(21,null),[14]:(0,I.localize)(22,null),[22]:(0,I.localize)(23,null),[25]:(0,I.localize)(24,null),[12]:(0,I.localize)(25,null)};function s(K,se){return(0,I.localize)(26,null,K,e.$$s[se])}e.$_s=s;var o;(function(K){K[K.Deprecated=1]="Deprecated"})(o||(e.SymbolTag=o={}));var i;(function(K){const se=new Map;se.set(0,y.$Qj.symbolFile),se.set(1,y.$Qj.symbolModule),se.set(2,y.$Qj.symbolNamespace),se.set(3,y.$Qj.symbolPackage),se.set(4,y.$Qj.symbolClass),se.set(5,y.$Qj.symbolMethod),se.set(6,y.$Qj.symbolProperty),se.set(7,y.$Qj.symbolField),se.set(8,y.$Qj.symbolConstructor),se.set(9,y.$Qj.symbolEnum),se.set(10,y.$Qj.symbolInterface),se.set(11,y.$Qj.symbolFunction),se.set(12,y.$Qj.symbolVariable),se.set(13,y.$Qj.symbolConstant),se.set(14,y.$Qj.symbolString),se.set(15,y.$Qj.symbolNumber),se.set(16,y.$Qj.symbolBoolean),se.set(17,y.$Qj.symbolArray),se.set(18,y.$Qj.symbolObject),se.set(19,y.$Qj.symbolKey),se.set(20,y.$Qj.symbolNull),se.set(21,y.$Qj.symbolEnumMember),se.set(22,y.$Qj.symbolStruct),se.set(23,y.$Qj.symbolEvent),se.set(24,y.$Qj.symbolOperator),se.set(25,y.$Qj.symbolTypeParameter);function ue(x){let he=se.get(x);return he||(console.info("No codicon found for SymbolKind "+x),he=y.$Qj.symbolProperty),he}K.toIcon=ue})(i||(e.SymbolKinds=i={}));class n{static asEditOperation(se){return r.$ns.replace(P.$ms.lift(se.range),se.text)}}e.$at=n;class a{static fromValue(se){switch(se){case"comment":return a.Comment;case"imports":return a.Imports;case"region":return a.Region}return new a(se)}constructor(se){this.value=se}}e.$bt=a,a.Comment=new a("comment"),a.Imports=new a("imports"),a.Region=new a("region");var $;(function(K){function se(ue){return!ue||typeof ue!="object"?!1:typeof ue.id=="string"&&typeof ue.title=="string"}K.is=se})($||(e.Command=$={}));var S;(function(K){K[K.Collapsed=0]="Collapsed",K[K.Expanded=1]="Expanded"})(S||(e.CommentThreadCollapsibleState=S={}));var D;(function(K){K[K.Unresolved=0]="Unresolved",K[K.Resolved=1]="Resolved"})(D||(e.CommentThreadState=D={}));var k;(function(K){K[K.Editing=0]="Editing",K[K.Preview=1]="Preview"})(k||(e.CommentMode=k={}));var A;(function(K){K[K.Published=0]="Published",K[K.Draft=1]="Draft"})(A||(e.CommentState=A={}));var j;(function(K){K[K.Type=1]="Type",K[K.Parameter=2]="Parameter"})(j||(e.InlayHintKind=j={}));class Z{constructor(se){this.b=se,this.a=null}dispose(){this.a&&this.a.then(se=>{se&&se.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}e.$ct=Z,e.$dt=new L.$Xs;var ae;(function(K){K[K.None=0]="None",K[K.Option=1]="Option",K[K.Default=2]="Default",K[K.Preferred=3]="Preferred"})(ae||(e.ExternalUriOpenerPriority=ae={}))}),define(we[172],pe([9,10]),function(le,e){return le.create("vs/platform/configuration/common/configurationRegistry",e)}),define(we[173],pe([9,10]),function(le,e){return le.create("vs/platform/contextkey/common/contextkey",e)}),define(we[174],pe([9,10]),function(le,e){return le.create("vs/platform/contextkey/common/scanner",e)}),define(we[175],pe([9,10]),function(le,e){return le.create("vs/platform/environment/node/argv",e)}),define(we[176],pe([9,10]),function(le,e){return le.create("vs/platform/environment/node/argvHelper",e)}),define(we[177],pe([9,10]),function(le,e){return le.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(we[178],pe([9,10]),function(le,e){return le.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(we[179],pe([9,10]),function(le,e){return le.create("vs/platform/extensionManagement/common/extensionManagementCLI",e)}),define(we[180],pe([9,10]),function(le,e){return le.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(we[181],pe([9,10]),function(le,e){return le.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(we[182],pe([9,10]),function(le,e){return le.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(we[183],pe([9,10]),function(le,e){return le.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(we[184],pe([9,10]),function(le,e){return le.create("vs/platform/extensions/common/extensionValidator",e)}),define(we[185],pe([9,10]),function(le,e){return le.create("vs/platform/files/common/fileService",e)}),define(we[186],pe([9,10]),function(le,e){return le.create("vs/platform/files/common/files",e)}),define(we[187],pe([9,10]),function(le,e){return le.create("vs/platform/files/common/io",e)}),define(we[188],pe([9,10]),function(le,e){return le.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(we[189],pe([9,10]),function(le,e){return le.create("vs/platform/languagePacks/common/languagePacks",e)}),define(we[190],pe([9,10]),function(le,e){return le.create("vs/platform/markers/common/markers",e)}),define(we[191],pe([9,10]),function(le,e){return le.create("vs/platform/request/common/request",e)}),define(we[192],pe([9,10]),function(le,e){return le.create("vs/platform/shell/node/shellEnv",e)}),define(we[193],pe([9,10]),function(le,e){return le.create("vs/platform/telemetry/common/telemetryService",e)}),define(we[194],pe([9,10]),function(le,e){return le.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(we[195],pe([9,10]),function(le,e){return le.create("vs/platform/terminal/common/terminalProfiles",e)}),define(we[196],pe([9,10]),function(le,e){return le.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(we[197],pe([9,10]),function(le,e){return le.create("vs/platform/workspace/common/workspace",e)}),define(we[198],pe([9,10]),function(le,e){return le.create("vs/server/node/remoteExtensionHostAgentCli",e)}),define(we[199],pe([9,10]),function(le,e){return le.create("vs/server/node/serverEnvironmentService",e)}),define(we[200],pe([9,10]),function(le,e){return le.create("vs/server/node/serverServices",e)}),define(we[201],pe([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostTelemetry",e)}),define(we[202],pe([9,10]),function(le,e){return le.create("vs/workbench/common/editor",e)}),define(we[203],pe([9,10]),function(le,e){return le.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(we[204],pe([9,10]),function(le,e){return le.create("vs/workbench/services/extensions/common/extensionsUtil",e)}),define(we[205],pe([1,0,11,174]),function(le,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gi=e.TokenType=void 0;var r;(function(b){b[b.LParen=0]="LParen",b[b.RParen=1]="RParen",b[b.Neg=2]="Neg",b[b.Eq=3]="Eq",b[b.NotEq=4]="NotEq",b[b.Lt=5]="Lt",b[b.LtEq=6]="LtEq",b[b.Gt=7]="Gt",b[b.GtEq=8]="GtEq",b[b.RegexOp=9]="RegexOp",b[b.RegexStr=10]="RegexStr",b[b.True=11]="True",b[b.False=12]="False",b[b.In=13]="In",b[b.Not=14]="Not",b[b.And=15]="And",b[b.Or=16]="Or",b[b.Str=17]="Str",b[b.QuotedStr=18]="QuotedStr",b[b.Error=19]="Error",b[b.EOF=20]="EOF"})(r||(e.TokenType=r={}));function P(...b){switch(b.length){case 1:return(0,R.localize)(0,null,b[0]);case 2:return(0,R.localize)(1,null,b[0],b[1]);case 3:return(0,R.localize)(2,null,b[0],b[1],b[2]);default:return}}const L=(0,R.localize)(3,null),I=(0,R.localize)(4,null);class w{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(C){switch(C.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return C.isTripleEq?"===":"==";case 4:return C.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return C.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return C.lexeme;case 18:return C.lexeme;case 19:return C.lexeme;case 20:return"EOF";default:throw(0,y.$6)(`unhandled token type: ${JSON.stringify(C)}; have you forgotten to add a case?`)}}get errors(){return this.g}reset(C){return this.c=C,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const E=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:E})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const E=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:E})}else this.h(126)?this.k(9):this.l(P("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(P("&&"));break;case 124:this.h(124)?this.k(16):this.l(P("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(C){return this.r()||this.c.charCodeAt(this.e)!==C?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(C){this.f.push({type:C,offset:this.d})}l(C){const E=this.d,v=this.c.substring(this.d,this.e),d={type:19,offset:this.d,lexeme:v};this.g.push({offset:E,lexeme:v,additionalInfo:C}),this.f.push(d)}n(){this.m.lastIndex=this.d;const C=this.m.exec(this.c);if(C){this.e=this.d+C[0].length;const E=this.c.substring(this.d,this.e),v=w.b.get(E);v?this.k(v):this.f.push({type:17,lexeme:E,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(L);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let C=this.e,E=!1,v=!1;for(;;){if(C>=this.c.length){this.e=C,this.l(I);return}const g=this.c.charCodeAt(C);if(E)E=!1;else if(g===47&&!v){C++;break}else g===91?v=!0:g===92?E=!0:g===93&&(v=!1);C++}for(;C<this.c.length&&w.a.has(this.c.charCodeAt(C));)C++;this.e=C;const d=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:d,offset:this.d})}r(){return this.e>=this.c.length}}e.$Gi=w,w.a=new Set(["i","g","s","m","y","u"].map(b=>b.charCodeAt(0))),w.b=new Map([["not",14],["in",13],["false",12],["true",11]])}),define(we[206],pe([1,0,5,2]),function(le,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$En=e.$Dn=void 0;class r{constructor(){this.a=new y.$Ld,this.b=new y.$Ld,this.c=new y.$Ld,this.d=new y.$Ld}call(I,w,b){switch(w){case"close":return Promise.resolve(this.a.fire({sessionId:b[0]}));case"reload":return Promise.resolve(this.b.fire({sessionId:b[0]}));case"terminate":return Promise.resolve(this.c.fire({sessionId:b[0]}));case"attach":return Promise.resolve(this.d.fire({sessionId:b[0],port:b[1],subId:b[2]}))}throw new Error("Method not implemented.")}listen(I,w,b){switch(w){case"close":return this.a.event;case"reload":return this.b.event;case"terminate":return this.c.event;case"attach":return this.d.event}throw new Error("Method not implemented.")}}e.$Dn=r,r.ChannelName="extensionhostdebugservice";class P extends R.$Qc{constructor(I){super(),this.b=I}reload(I){this.b.call("reload",[I])}get onReload(){return this.b.listen("reload")}close(I){this.b.call("close",[I])}get onClose(){return this.b.listen("close")}attachSession(I,w,b){this.b.call("attach",[I,w,b])}get onAttachSession(){return this.b.listen("attach")}terminateSession(I,w){this.b.call("terminate",[I,w])}get onTerminateSession(){return this.b.listen("terminate")}openExtensionDevelopmentHostWindow(I,w){return this.b.call("openExtensionDevelopmentHostWindow",[I,w])}}e.$En=P}),define(we[207],pe([1,0,4]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hn=e.$Gn=void 0;class R{constructor(L){this.a=L}listen(L,I,w){throw new Error("Invalid listen")}call(L,I,w){switch(I){case"download":return this.a.download(y.URI.revive(w[0]),y.URI.revive(w[1]))}throw new Error("Invalid call")}}e.$Gn=R;class r{constructor(L,I){this.a=L,this.b=I}async download(L,I){const w=this.b();w&&(L=w.transformOutgoingURI(L),I=w.transformOutgoingURI(I)),await this.a.call("download",[L,I])}}e.$Hn=r}),define(we[208],pe([1,0,165,73,12,7,28,19,4]),function(le,e,y,R,r,P,L,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$am=e.$_l=e.$$l=e.$0l=void 0,e.$0l=/^([^.]+\..+):(.+)$/;class b{get appRoot(){return(0,P.$kc)(r.$_f.asFileUri("").fsPath)}get userHome(){return w.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return w.URI.file((0,P.$hc)(this.userDataPath,"User"))}get tmpDir(){return w.URI.file(this.b.tmpDir)}get cacheHome(){return w.URI.file(this.userDataPath)}get stateResource(){return(0,I.$sg)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:r.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,I.$sg)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const d=(0,y.$9l)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,P.$hc)(this.userDataPath,"logs",d)}return w.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,I.$sg)(w.URI.file((0,P.$hc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,I.$sg)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,I.$sg)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,I.$sg)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const d=L.env.VSCODE_PORTABLE;return d?w.URI.file((0,P.$hc)(d,"argv.json")):(0,I.$sg)(this.appSettingsHome,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return w.URI.file((0,P.$hc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const d=this.args["builtin-extensions-dir"];return d?(0,P.$ic)(d):(0,P.$fc)((0,P.$hc)(r.$_f.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const d=this.args["extensions-download-dir"];return d?w.URI.file((0,P.$ic)(d)):w.URI.file((0,P.$hc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const d=this.args["extensions-dir"];if(d)return(0,P.$ic)(d);const g=L.env.VSCODE_EXTENSIONS;if(g)return g;const m=L.env.VSCODE_PORTABLE;return m?(0,P.$hc)(m,"extensions"):(0,I.$sg)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const d=this.args.extensionDevelopmentPath;if(Array.isArray(d))return d.map(g=>/^[^:/?#]+?:\/\//.test(g)?w.URI.parse(g):w.URI.file((0,P.$fc)(g)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(d=>d==="ui"||d==="workspace"||d==="web"?d:"workspace")}get extensionTestsLocationURI(){const d=this.args.extensionTestsPath;if(d)return/^[^:/?#]+?:\/\//.test(d)?w.URI.parse(d):w.URI.file((0,P.$fc)(d))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const d=this.args["disable-extension"];if(d){if(typeof d=="string")return[d];if(Array.isArray(d)&&d.length>0)return d}return!1}get debugExtensionHost(){return C(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!L.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(d=>!e.$0l.test(d))}get extensionLogLevel(){const d=[];for(const g of this.args.log||[]){const m=e.$0l.exec(g);m&&m[1]&&m[2]&&d.push([m[1],m[2]])}return d.length?d:void 0}get serviceMachineIdResource(){return(0,I.$sg)(w.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const d=L.env.VSCODE_PORTABLE;return d?w.URI.file((0,P.$hc)(d,"policy.json")):(0,I.$sg)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(d){this.args.continueOn=d}get args(){return this.a}constructor(d,g,m){this.a=d,this.b=g,this.c=m,this.editSessionId=this.args.editSessionId}}e.$$l=b,Oe([R.$dh],b.prototype,"appRoot",null),Oe([R.$dh],b.prototype,"userHome",null),Oe([R.$dh],b.prototype,"userDataPath",null),Oe([R.$dh],b.prototype,"appSettingsHome",null),Oe([R.$dh],b.prototype,"tmpDir",null),Oe([R.$dh],b.prototype,"cacheHome",null),Oe([R.$dh],b.prototype,"stateResource",null),Oe([R.$dh],b.prototype,"userRoamingDataHome",null),Oe([R.$dh],b.prototype,"userDataSyncHome",null),Oe([R.$dh],b.prototype,"sync",null),Oe([R.$dh],b.prototype,"machineSettingsResource",null),Oe([R.$dh],b.prototype,"workspaceStorageHome",null),Oe([R.$dh],b.prototype,"localHistoryHome",null),Oe([R.$dh],b.prototype,"keyboardLayoutResource",null),Oe([R.$dh],b.prototype,"argvResource",null),Oe([R.$dh],b.prototype,"isExtensionDevelopment",null),Oe([R.$dh],b.prototype,"untitledWorkspacesHome",null),Oe([R.$dh],b.prototype,"builtinExtensionsPath",null),Oe([R.$dh],b.prototype,"extensionsPath",null),Oe([R.$dh],b.prototype,"extensionDevelopmentLocationURI",null),Oe([R.$dh],b.prototype,"extensionDevelopmentKind",null),Oe([R.$dh],b.prototype,"extensionTestsLocationURI",null),Oe([R.$dh],b.prototype,"debugExtensionHost",null),Oe([R.$dh],b.prototype,"logLevel",null),Oe([R.$dh],b.prototype,"extensionLogLevel",null),Oe([R.$dh],b.prototype,"serviceMachineIdResource",null),Oe([R.$dh],b.prototype,"disableTelemetry",null),Oe([R.$dh],b.prototype,"disableWorkspaceTrust",null),Oe([R.$dh],b.prototype,"useInMemorySecretStorage",null),Oe([R.$dh],b.prototype,"policyFile",null);function C(v,d){return E(v["inspect-extensions"],v["inspect-brk-extensions"],5870,d,v.debugId,v.extensionEnvironment)}e.$_l=C;function E(v,d,g,m,l,f){const c=Number(d||v)||(m?null:g),p=c?!!d:!1;let h;if(f)try{h=JSON.parse(f)}catch{}return{port:c,break:p,debugId:l,env:h}}e.$am=E}),define(we[64],pe([1,0,297,3,175]),function(le,e,y,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$El=e.$Dl=e.$Cl=e.$Bl=e.$Al=e.$zl=void 0;const P={o:(0,r.localize)(0,null),e:(0,r.localize)(1,null),t:(0,r.localize)(2,null)};e.$zl=["tunnel","serve-web"],e.$Al={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,r.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},"serve-web":{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,r.localize)(4,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,r.localize)(5,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,r.localize)(6,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,r.localize)(7,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,r.localize)(8,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,r.localize)(9,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,r.localize)(10,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,r.localize)(11,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,r.localize)(12,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,r.localize)(13,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,r.localize)(14,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,r.localize)(15,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,r.localize)(16,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,r.localize)(17,null)},"show-versions":{type:"boolean",cat:"e",description:(0,r.localize)(18,null)},category:{type:"string",allowEmptyValue:!0,cat:"e",description:(0,r.localize)(19,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,r.localize)(20,null)},"pre-release":{type:"boolean",cat:"e",description:(0,r.localize)(21,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,r.localize)(22,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,r.localize)(23,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,r.localize)(24,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,r.localize)(25,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,r.localize)(26,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,r.localize)(27,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,r.localize)(28,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,r.localize)(29,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,r.localize)(30,null)},sync:{type:"string",cat:"t",description:(0,r.localize)(31,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,r.localize)(32,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,r.localize)(33,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,r.localize)(34,null)},"disable-chromium-sandbox":{type:"boolean",cat:"t",description:(0,r.localize)(35,null)},"ms-enable-electron-run-as-node":{type:"boolean",global:!0},telemetry:{type:"boolean",cat:"t",description:(0,r.localize)(36,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"use-inmemory-secretstorage":{type:"boolean",deprecates:["disable-keytar"]},"password-store":{type:"string"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const L={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function I(m,l,f=L){const u=m.find(a=>a.length>0&&a[0]!=="-"),c={},p=["_"],h=[],t={};let s;for(const a in l){const $=l[a];$.type==="subcommand"?a===u&&(s=$):($.alias&&(c[a]=$.alias),$.type==="string"||$.type==="string[]"?(p.push(a),$.deprecates&&p.push(...$.deprecates)):$.type==="boolean"&&(h.push(a),$.deprecates&&h.push(...$.deprecates)),$.global&&(t[a]=$))}if(s&&u){const a=t;for(const k in s.options)a[k]=s.options[k];const $=m.filter(k=>k!==u),S=f.getSubcommandReporter?f.getSubcommandReporter(u):void 0,D=I($,a,S);return{[u]:D,_:[]}}const o=y(m,{string:p,boolean:h,alias:c}),i={},n=o;i._=o._.map(a=>String(a)).filter(a=>a.length>0),delete n._;for(const a in l){const $=l[a];if($.type==="subcommand")continue;$.alias&&delete n[$.alias];let S=n[a];if($.deprecates)for(const D of $.deprecates)n.hasOwnProperty(D)&&(S||(S=n[D],S&&f.onDeprecatedOption(D,$.deprecationMessage||(0,r.localize)(37,null,a))),delete n[D]);if(typeof S<"u"){if($.type==="string[]"){if(Array.isArray(S)||(S=[S]),!$.allowEmptyValue){const D=S.filter(k=>k.length>0);D.length!==S.length&&(f.onEmptyValue(a),S=D.length>0?D:void 0)}}else $.type==="string"&&(Array.isArray(S)?(S=S.pop(),f.onMultipleValues(a,S)):!S&&!$.allowEmptyValue&&(f.onEmptyValue(a),S=void 0));i[a]=S,$.deprecationMessage&&f.onDeprecatedOption(a,$.deprecationMessage)}delete n[a]}for(const a in n)f.onUnknownOption(a);return i}e.$Bl=I;function w(m,l){let f="";return l.args&&(Array.isArray(l.args)?f=` <${l.args.join("> <")}>`:f=` <${l.args}>`),l.alias?`-${l.alias} --${m}${f}`:`--${m}${f}`}function b(m,l){const f=[];for(const u in m){const c=m[u],p=w(u,c);f.push([p,c.description])}return C(f,l)}e.$Cl=b;function C(m,l){const u=m.reduce((h,t)=>Math.max(h,t[0].length),12)+2+1;if(l-u<25)return m.reduce((h,t)=>h.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);const c=l-u-1,p=[];for(const h of m){const t=h[0],s=v(h[1],c),o=E(u-t.length-2);p.push("  "+t+o+s[0]);for(let i=1;i<s.length;i++)p.push(E(u)+s[i])}return p}function E(m){return" ".repeat(m)}function v(m,l){const f=[];for(;m.length;){const u=m.length<l?m.length:m.lastIndexOf(" ",l),c=m.slice(0,u).trim();m=m.slice(u),f.push(c)}return f}function d(m,l,f,u,c){const p=process.stdout.isTTY&&process.stdout.columns||80,h=c?.noInputFiles!==!0?`[${(0,r.localize)(38,null)}...]`:"",t=[`${m} ${f}`];t.push(""),t.push(`${(0,r.localize)(39,null)}: ${l} [${(0,r.localize)(40,null)}]${h}`),t.push(""),c?.noPipe!==!0&&(R.$d?t.push((0,r.localize)(41,null,l)):t.push((0,r.localize)(42,null,l)),t.push(""));const s={},o=[];for(const i in u){const n=u[i];if(n.type==="subcommand")n.description&&o.push({command:i,description:n.description});else if(n.description&&n.cat){let a=s[n.cat];a||(s[n.cat]=a={}),a[i]=n}}for(const i in s){const n=i,a=s[n];a&&(t.push(P[n]),t.push(...b(a,p)),t.push(""))}return o.length&&(t.push((0,r.localize)(43,null)),t.push(...C(o.map(i=>[i.command,i.description]),p)),t.push("")),t.join(`
`)}e.$Dl=d;function g(m,l){return`${m||(0,r.localize)(44,null)}
${l||(0,r.localize)(45,null)}
${process.arch}`}e.$El=g}),define(we[209],pe([1,0,298,176,64]),function(le,e,y,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Il=e.$Hl=e.$Gl=e.$Fl=void 0;function P(E,v){const d=(c,p)=>{console.warn((0,R.localize)(0,null,c,p))},g=c=>{console.warn((0,R.localize)(1,null,c))},m=(c,p)=>{console.warn((0,R.localize)(2,null,c,p))},l=c=>({onUnknownOption:p=>{r.$zl.includes(c)||console.warn((0,R.localize)(3,null,p,c))},onMultipleValues:d,onEmptyValue:g,onDeprecatedOption:m,getSubcommandReporter:r.$zl.includes(c)?l:void 0}),f={onUnknownOption:c=>{console.warn((0,R.localize)(4,null,c))},onMultipleValues:d,onEmptyValue:g,onDeprecatedOption:m,getSubcommandReporter:l},u=(0,r.$Bl)(E,r.$Al,v?f:void 0);return u.goto&&u._.forEach(c=>y(/^(\w:)?[^:]+(:\d*){0,2}:?$/.test(c),(0,R.localize)(5,null))),u}function L(E){const v=E.findIndex(d=>!/^-/.test(d));if(v>-1)return[...E.slice(0,v),...E.slice(v+1)]}function I(E){let[,...v]=E;process.env.VSCODE_DEV&&(v=L(v)||[]);const d=!C(process.env);return P(v,d)}e.$Fl=I;function w(E){let[,,...v]=E;return process.env.VSCODE_DEV&&(v=L(v)||[]),P(v,!0)}e.$Gl=w;function b(E,...v){const d=E.indexOf("--");return d===-1?E.push(...v):E.splice(d,0,...v),E}e.$Hl=b;function C(E){return E.VSCODE_CLI==="1"}e.$Il=C}),function(){"use strict";function le(e,y,R){function r(L,I){const w=P(L,I),b=[w];return e.isAbsolute(w)||b.unshift(R),e.resolve(...b)}function P(L,I){process.env.VSCODE_DEV&&(I="code-oss-dev");const w=process.env.VSCODE_PORTABLE;if(w)return e.join(w,"user-data");let b=process.env.VSCODE_APPDATA;if(b)return e.join(b,I);const C=L["user-data-dir"];if(C)return C;switch(process.platform){case"win32":if(b=process.env.APPDATA,!b){const E=process.env.USERPROFILE;if(typeof E!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");b=e.join(E,"AppData","Roaming")}break;case"darwin":b=e.join(y.homedir(),"Library","Application Support");break;case"linux":b=process.env.XDG_CONFIG_HOME||e.join(y.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(b,I)}return{getUserDataPath:r}}if(typeof define=="function")define(we[210],pe([77,27,28]),function(e,y,R){return le(e,y,R.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),y=require("os");module.exports=le(e,y,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(we[109],pe([1,0,27,208,210]),function(le,e,y,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dm=e.$cm=e.$bm=void 0;class P extends R.$$l{constructor(b,C){super(b,{homeDir:(0,y.homedir)(),tmpDir:(0,y.tmpdir)(),userDataDir:(0,r.getUserDataPath)(b,C.nameShort)},C)}}e.$bm=P;function L(w,b){return(0,R.$am)(w["inspect-ptyhost"],w["inspect-brk-ptyhost"],5877,b,w.extensionEnvironment)}e.$cm=L;function I(w,b){return(0,R.$am)(w["inspect-sharedprocess"],w["inspect-brk-sharedprocess"],5879,b,w.extensionEnvironment)}e.$dm=I}),define(we[211],pe([1,0,8,180]),function(le,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pp=void 0;function r(L,I,w,b){try{P(L,I,w,b)}catch(C){L.error(C?.message??C)}return I}e.$pp=r;function P(L,I,w,b){const C=(E,v,d)=>{const g=E[v];if((0,y.$wf)(g)){const m=g,l=m.length;if(l>1&&m[0]==="%"&&m[l-1]==="%"){const f=m.substr(1,l-2);let u=w[f];u===void 0&&b&&(u=b[f]);const c=typeof u=="string"?u:u?.message,p=b?.[f],h=typeof p=="string"?p:p?.message;if(!c){h||L.warn(`[${I.name}]: ${(0,R.localize)(0,null,f)}`);return}if(d&&(v==="title"||v==="category")&&h&&h!==c){const t={value:c,original:h};E[v]=t}else E[v]=c}}else if((0,y.$yf)(g))for(const m in g)g.hasOwnProperty(m)&&(m==="commands"?C(g,m,!0):C(g,m,d));else if(Array.isArray(g))for(let m=0;m<g.length;m++)C(g,m,d)};for(const E in I)I.hasOwnProperty(E)&&C(I,E)}}),define(we[79],pe([1,0,19,62,184,53]),function(le,e,y,R,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=void 0;const L=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,I=/^-(\d{4})(\d{2})(\d{2})$/;function w(f){return f=f.trim(),f==="*"||L.test(f)}e.$Do=w;function b(f){if(!w(f))return null;if(f=f.trim(),f==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const u=f.match(L);return u?{hasCaret:u[1]==="^",hasGreaterEquals:u[1]===">=",majorBase:u[2]==="x"?0:parseInt(u[2],10),majorMustEqual:u[2]!=="x",minorBase:u[4]==="x"?0:parseInt(u[4],10),minorMustEqual:u[4]!=="x",patchBase:u[6]==="x"?0:parseInt(u[6],10),patchMustEqual:u[6]!=="x",preRelease:u[8]||null}:null}e.$Eo=b;function C(f){if(!f)return null;const u=f.majorBase,c=f.majorMustEqual,p=f.minorBase;let h=f.minorMustEqual;const t=f.patchBase;let s=f.patchMustEqual;f.hasCaret&&(u===0||(h=!1),s=!1);let o=0;if(f.preRelease){const i=I.exec(f.preRelease);if(i){const[,n,a,$]=i;o=Date.UTC(Number(n),Number(a)-1,Number($))}}return{majorBase:u,majorMustEqual:c,minorBase:p,minorMustEqual:h,patchBase:t,patchMustEqual:s,isMinimum:f.hasGreaterEquals,notBefore:o}}e.$Fo=C;function E(f,u,c){let p;typeof f=="string"?p=C(b(f)):p=f;let h;u instanceof Date?h=u.getTime():typeof u=="string"&&(h=new Date(u).getTime());let t;if(typeof c=="string"?t=C(b(c)):t=c,!p||!t)return!1;const s=p.majorBase,o=p.minorBase,i=p.patchBase;let n=t.majorBase,a=t.minorBase,$=t.patchBase;const S=t.notBefore;let D=t.majorMustEqual,k=t.minorMustEqual,A=t.patchMustEqual;return t.isMinimum?s>n?!0:s<n?!1:o>a?!0:o<a||h&&h<S?!1:i>=$:(s===1&&n===0&&(!D||!k||!A)&&(n=1,a=0,$=0,D=!0,k=!1,A=!1),s<n?!1:s>n?!D:o<a?!1:o>a?!k:i<$?!1:i>$?!A:!(h&&h<S))}e.$Go=E;function v(f,u,c,p,h){const t=[];if(typeof p.publisher<"u"&&typeof p.publisher!="string")return t.push([R.default.Error,r.localize(0,null)]),t;if(typeof p.name!="string")return t.push([R.default.Error,r.localize(1,null,"name")]),t;if(typeof p.version!="string")return t.push([R.default.Error,r.localize(2,null,"version")]),t;if(!p.engines)return t.push([R.default.Error,r.localize(3,null,"engines")]),t;if(typeof p.engines.vscode!="string")return t.push([R.default.Error,r.localize(4,null,"engines.vscode")]),t;if(typeof p.extensionDependencies<"u"&&!l(p.extensionDependencies))return t.push([R.default.Error,r.localize(5,null,"extensionDependencies")]),t;if(typeof p.activationEvents<"u"){if(!l(p.activationEvents))return t.push([R.default.Error,r.localize(6,null,"activationEvents")]),t;if(typeof p.main>"u"&&typeof p.browser>"u")return t.push([R.default.Error,r.localize(7,null,"activationEvents","main","browser")]),t}if(typeof p.extensionKind<"u"&&typeof p.main>"u"&&t.push([R.default.Warning,r.localize(8,null,"extensionKind")]),typeof p.main<"u"){if(typeof p.main!="string")return t.push([R.default.Error,r.localize(9,null,"main")]),t;{const i=(0,y.$sg)(c,p.main);(0,y.$mg)(i,c)||t.push([R.default.Warning,r.localize(10,null,i.path,c.path)])}}if(typeof p.browser<"u"){if(typeof p.browser!="string")return t.push([R.default.Error,r.localize(11,null,"browser")]),t;{const i=(0,y.$sg)(c,p.browser);(0,y.$mg)(i,c)||t.push([R.default.Warning,r.localize(12,null,i.path,c.path)])}}if(!P.valid(p.version))return t.push([R.default.Error,r.localize(13,null)]),t;const s=[];if(!d(f,u,p,h,s))for(const i of s)t.push([R.default.Error,i]);return t}e.$Ho=v;function d(f,u,c,p,h){return p||typeof c.main>"u"&&typeof c.browser>"u"?!0:m(f,u,c.engines.vscode,h)}e.$Io=d;function g(f,u,c){return f==="*"||m(u,c,f)}e.$Jo=g;function m(f,u,c,p=[]){const h=C(b(c));if(!h)return p.push(r.localize(14,null,c)),!1;if(h.majorBase===0){if(!h.majorMustEqual||!h.minorMustEqual)return p.push(r.localize(15,null,c)),!1}else if(!h.majorMustEqual)return p.push(r.localize(16,null,c)),!1;return E(f,u,h)?!0:(p.push(r.localize(17,null,f,c)),!1)}function l(f){if(!Array.isArray(f))return!1;for(let u=0,c=f.length;u<c;u++)if(typeof f[u]!="string")return!1;return!0}}),define(we[212],pe([1,0,15,23]),function(le,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4o=void 0;async function r(P,L,I){let w=I&&I.get("storage.serviceMachineId",-1)||null;if(w)return w;try{const C=(await L.readFile(P.serviceMachineIdResource)).value.toString();w=(0,R.$ag)(C)?C:null}catch{w=null}if(!w){w=(0,R.$bg)();try{await L.writeFile(P.serviceMachineIdResource,y.$_d.fromString(w))}catch{}}return I?.store("storage.serviceMachineId",w,-1,1),w}e.$4o=r}),define(we[65],pe([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ih=void 0;class y{constructor(r,P=[],L=!1){this.ctor=r,this.staticArguments=P,this.supportsDelayedInstantiation=L}}e.$Ih=y}),define(we[213],pe([1,0,65]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pr=e.$or=e.InstantiationType=void 0;const R=[];var r;(function(I){I[I.Eager=0]="Eager",I[I.Delayed=1]="Delayed"})(r||(e.InstantiationType=r={}));function P(I,w,b){w instanceof y.$Ih||(w=new y.$Ih(w,[],!!b)),R.push([I,w])}e.$or=P;function L(){return R}e.$pr=L}),define(we[214],pe([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7p=e.$6p=void 0;class y{constructor(P,L){this.key=P,this.data=L,this.incoming=new Map,this.outgoing=new Map}}e.$6p=y;class R{constructor(P){this.b=P,this.a=new Map}roots(){const P=[];for(const L of this.a.values())L.outgoing.size===0&&P.push(L);return P}insertEdge(P,L){const I=this.lookupOrInsertNode(P),w=this.lookupOrInsertNode(L);I.outgoing.set(w.key,w),w.incoming.set(I.key,I)}removeNode(P){const L=this.b(P);this.a.delete(L);for(const I of this.a.values())I.outgoing.delete(L),I.incoming.delete(L)}lookupOrInsertNode(P){const L=this.b(P);let I=this.a.get(L);return I||(I=new y(L,P),this.a.set(L,I)),I}lookup(P){return this.a.get(this.b(P))}isEmpty(){return this.a.size===0}toString(){const P=[];for(const[L,I]of this.a)P.push(`${L}
	(-> incoming)[${[...I.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...I.outgoing.keys()].join(",")}]
`);return P.join(`
`)}findCycleSlow(){for(const[P,L]of this.a){const I=new Set([P]),w=this.c(L,I);if(w)return w}}c(P,L){for(const[I,w]of P.outgoing){if(L.has(I))return[...L,I].join(" -> ");L.add(I);const b=this.c(w,L);if(b)return b;L.delete(I)}}}e.$7p=R}),define(we[6],pe([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mh=e.$Lh=e.$Kh=e._util=void 0;var y;(function(L){L.serviceIds=new Map,L.DI_TARGET="$di$target",L.DI_DEPENDENCIES="$di$dependencies";function I(w){return w[L.DI_DEPENDENCIES]||[]}L.getServiceDependencies=I})(y||(e._util=y={})),e.$Kh=r("instantiationService");function R(L,I,w){I[y.DI_TARGET]===I?I[y.DI_DEPENDENCIES].push({id:L,index:w}):(I[y.DI_DEPENDENCIES]=[{id:L,index:w}],I[y.DI_TARGET]=I)}function r(L){if(y.serviceIds.has(L))return y.serviceIds.get(L);const I=function(w,b,C){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");R(I,w,C)};return I.toString=()=>L,y.serviceIds.set(L,I),I}e.$Lh=r;function P(L){return L}e.$Mh=P}),define(we[24],pe([1,0,8,4,6]),function(le,e,y,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pi=e.$oi=e.$ni=e.$mi=e.$li=e.$ki=e.$ji=e.$ii=e.ConfigurationTarget=e.$hi=e.$gi=e.$fi=void 0,e.$fi=(0,r.$Lh)("configurationService");function P(f){return f&&typeof f=="object"&&(!f.overrideIdentifier||typeof f.overrideIdentifier=="string")&&(!f.resource||f.resource instanceof R.URI)}e.$gi=P;function L(f){return f&&typeof f=="object"&&(!f.overrideIdentifiers||Array.isArray(f.overrideIdentifiers))&&!f.overrideIdentifier&&(!f.resource||f.resource instanceof R.URI)}e.$hi=L;var I;(function(f){f[f.APPLICATION=1]="APPLICATION",f[f.USER=2]="USER",f[f.USER_LOCAL=3]="USER_LOCAL",f[f.USER_REMOTE=4]="USER_REMOTE",f[f.WORKSPACE=5]="WORKSPACE",f[f.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",f[f.DEFAULT=7]="DEFAULT",f[f.MEMORY=8]="MEMORY"})(I||(e.ConfigurationTarget=I={}));function w(f){switch(f){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$ii=w;function b(f){return f.applicationValue!==void 0||f.userValue!==void 0||f.userLocalValue!==void 0||f.userRemoteValue!==void 0||f.workspaceValue!==void 0||f.workspaceFolderValue!==void 0}e.$ji=b;function C(f,u){const c=Object.create(null);for(const p in f)E(c,p,f[p],u);return c}e.$ki=C;function E(f,u,c,p){const h=u.split("."),t=h.pop();let s=f;for(let o=0;o<h.length;o++){const i=h[o];let n=s[i];switch(typeof n){case"undefined":n=s[i]=Object.create(null);break;case"object":break;default:p(`Ignoring ${u} as ${h.slice(0,o+1).join(".")} is ${JSON.stringify(n)}`);return}s=n}if(typeof s=="object"&&s!==null)try{s[t]=c}catch{p(`Ignoring ${u} as ${h.join(".")} is ${JSON.stringify(s)}`)}else p(`Ignoring ${u} as ${h.join(".")} is ${JSON.stringify(s)}`)}e.$li=E;function v(f,u){const c=u.split(".");d(f,c)}e.$mi=v;function d(f,u){const c=u.shift();if(u.length===0){delete f[c];return}if(Object.keys(f).indexOf(c)!==-1){const p=f[c];typeof p=="object"&&!Array.isArray(p)&&(d(p,u),Object.keys(p).length===0&&delete f[c])}}function g(f,u,c){function p(s,o){let i=s;for(const n of o){if(typeof i!="object"||i===null)return;i=i[n]}return i}const h=u.split("."),t=p(f,h);return typeof t>"u"?c:t}e.$ni=g;function m(f,u,c){Object.keys(u).forEach(p=>{p!=="__proto__"&&(p in f?y.$yf(f[p])&&y.$yf(u[p])?m(f[p],u[p],c):c&&(f[p]=u[p]):f[p]=u[p])})}e.$oi=m;function l(f){return f.replace(/[\[\]]/g,"")}e.$pi=l}),define(we[66],pe([1,0,3,17,205,6,173,11]),function(le,e,y,R,r,P,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.$Mi=e.$Li=e.$Ki=e.$Ji=e.$Ii=e.ContextKeyExprType=e.$Hi=void 0;const w=new Map;w.set("false",!1),w.set("true",!0),w.set("isMac",y.$e),w.set("isLinux",y.$f),w.set("isWindows",y.$d),w.set("isWeb",y.$j),w.set("isMacNative",y.$e&&!y.$j),w.set("isEdge",y.$B),w.set("isFirefox",y.$z),w.set("isChrome",y.$y),w.set("isSafari",y.$A);function b(ee,O){if(w.get(ee)!==void 0)throw(0,I.$5)("contextkey.setConstant(k, v) invoked with already set constant `k`");w.set(ee,O)}e.$Hi=b;const C=Object.prototype.hasOwnProperty;var E;(function(ee){ee[ee.False=0]="False",ee[ee.True=1]="True",ee[ee.Defined=2]="Defined",ee[ee.Not=3]="Not",ee[ee.Equals=4]="Equals",ee[ee.NotEquals=5]="NotEquals",ee[ee.And=6]="And",ee[ee.Regex=7]="Regex",ee[ee.NotRegex=8]="NotRegex",ee[ee.Or=9]="Or",ee[ee.In=10]="In",ee[ee.NotIn=11]="NotIn",ee[ee.Greater=12]="Greater",ee[ee.GreaterEquals=13]="GreaterEquals",ee[ee.Smaller=14]="Smaller",ee[ee.SmallerEquals=15]="SmallerEquals"})(E||(e.ContextKeyExprType=E={}));const v={regexParsingWithErrorRecovery:!0},d=(0,L.localize)(0,null),g=(0,L.localize)(1,null),m=(0,L.localize)(2,null),l=(0,L.localize)(3,null),f=(0,L.localize)(4,null),u=(0,L.localize)(5,null),c=(0,L.localize)(6,null),p=(0,L.localize)(7,null);class h{get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(O=v){this.k=O,this.d=new r.$Gi,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(O){if(O===""){this.h.push({message:d,offset:0,lexeme:"",additionalInfo:g});return}this.f=this.d.reset(O).scan(),this.g=0,this.h=[];try{const N=this.l();if(!this.E()){const Q=this.D(),T=Q.type===17?u:void 0;throw this.h.push({message:f,offset:Q.offset,lexeme:r.$Gi.getLexeme(Q),additionalInfo:T}),h.c}return N}catch(N){if(N!==h.c)throw N;return}}l(){return this.m()}m(){const O=[this.o()];for(;this.y(16);){const N=this.o();O.push(N)}return O.length===1?O[0]:t.or(...O)}o(){const O=[this.s()];for(;this.y(15);){const N=this.s();O.push(N)}return O.length===1?O[0]:t.and(...O)}s(){if(this.y(2)){const O=this.D();switch(O.type){case 11:return this.z(),n.INSTANCE;case 12:return this.z(),a.INSTANCE;case 0:{this.z();const N=this.l();return this.A(1,l),N?.negate()}case 17:return this.z(),j.create(O.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",O)}}return this.t()}t(){const O=this.D();switch(O.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const N=this.l();return this.A(1,l),N}case 17:{const N=O.lexeme;if(this.z(),this.y(9)){const T=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),T.type!==10)throw this.B("REGEX",T);const H=T.lexeme,U=H.lastIndexOf("/"),ie=U===H.length-1?void 0:this.w(H.substring(U+1));let z;try{z=new RegExp(H.substring(1,U),ie)}catch{throw this.B("REGEX",T)}return x.create(N,z)}switch(T.type){case 10:case 19:{const H=[T.lexeme];this.z();let U=this.D(),ie=0;for(let oe=0;oe<T.lexeme.length;oe++)T.lexeme.charCodeAt(oe)===40?ie++:T.lexeme.charCodeAt(oe)===41&&ie--;for(;!this.E()&&U.type!==15&&U.type!==16;){switch(U.type){case 0:ie++;break;case 1:ie--;break;case 10:case 18:for(let oe=0;oe<U.lexeme.length;oe++)U.lexeme.charCodeAt(oe)===40?ie++:T.lexeme.charCodeAt(oe)===41&&ie--}if(ie<0)break;H.push(r.$Gi.getLexeme(U)),this.z(),U=this.D()}const z=H.join(""),_=z.lastIndexOf("/"),W=_===z.length-1?void 0:this.w(z.substring(_+1));let X;try{X=new RegExp(z.substring(1,_),W)}catch{throw this.B("REGEX",T)}return t.regex(N,X)}case 18:{const H=T.lexeme;this.z();let U=null;if(!(0,R.$ze)(H)){const ie=H.indexOf("/"),z=H.lastIndexOf("/");if(ie!==z&&ie>=0){const _=H.slice(ie+1,z),W=H[z+1]==="i"?"i":"";try{U=new RegExp(_,W)}catch{throw this.B("REGEX",T)}}}if(U===null)throw this.B("REGEX",T);return x.create(N,U)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,m);const T=this.u();return t.notIn(N,T)}switch(this.D().type){case 3:{this.z();const T=this.u();if(this.x().type===18)return t.equals(N,T);switch(T){case"true":return t.has(N);case"false":return t.not(N);default:return t.equals(N,T)}}case 4:{this.z();const T=this.u();if(this.x().type===18)return t.notEquals(N,T);switch(T){case"true":return t.not(N);case"false":return t.has(N);default:return t.notEquals(N,T)}}case 5:return this.z(),se.create(N,this.u());case 6:return this.z(),ue.create(N,this.u());case 7:return this.z(),ae.create(N,this.u());case 8:return this.z(),K.create(N,this.u());case 13:return this.z(),t.in(N,this.u());default:return t.has(N)}}case 20:throw this.h.push({message:c,offset:O.offset,lexeme:"",additionalInfo:p}),h.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const O=this.D();switch(O.type){case 17:case 18:return this.z(),O.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(O){return O.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(O){return this.C(O)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(O,N){if(this.C(O))return this.z();throw this.B(N,this.D())}B(O,N,Q){const T=(0,L.localize)(8,null,O,r.$Gi.getLexeme(N)),H=N.offset,U=r.$Gi.getLexeme(N);return this.h.push({message:T,offset:H,lexeme:U,additionalInfo:Q}),h.c}C(O){return this.D().type===O}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Ii=h,h.c=new Error;class t{static false(){return n.INSTANCE}static true(){return a.INSTANCE}static has(O){return $.create(O)}static equals(O,N){return S.create(O,N)}static notEquals(O,N){return A.create(O,N)}static regex(O,N){return x.create(O,N)}static in(O,N){return D.create(O,N)}static notIn(O,N){return k.create(O,N)}static not(O){return j.create(O)}static and(...O){return te.create(O,null,!0)}static or(...O){return G.create(O,null,!0)}static greater(O,N){return ae.create(O,N)}static greaterEquals(O,N){return K.create(O,N)}static smaller(O,N){return se.create(O,N)}static smallerEquals(O,N){return ue.create(O,N)}static deserialize(O){return O==null?void 0:this.c.parse(O)}}e.$Ji=t,t.c=new h({regexParsingWithErrorRecovery:!1});function s(ee){const O=new h({regexParsingWithErrorRecovery:!1});return ee.map(N=>(O.parse(N),O.lexingErrors.length>0?O.lexingErrors.map(Q=>({errorMessage:Q.additionalInfo?(0,L.localize)(9,null,Q.additionalInfo):(0,L.localize)(10,null),offset:Q.offset,length:Q.lexeme.length})):O.parsingErrors.length>0?O.parsingErrors.map(Q=>({errorMessage:Q.additionalInfo?`${Q.message}. ${Q.additionalInfo}`:Q.message,offset:Q.offset,length:Q.lexeme.length})):[]))}e.$Ki=s;function o(ee,O){const N=ee?ee.substituteConstants():void 0,Q=O?O.substituteConstants():void 0;return!N&&!Q?!0:!N||!Q?!1:N.equals(Q)}e.$Li=o;function i(ee,O){return ee.cmp(O)}class n{constructor(){this.type=0}cmp(O){return this.type-O.type}equals(O){return O.type===this.type}substituteConstants(){return this}evaluate(O){return!1}serialize(){return"false"}keys(){return[]}map(O){return this}negate(){return a.INSTANCE}}e.$Mi=n,n.INSTANCE=new n;class a{constructor(){this.type=1}cmp(O){return this.type-O.type}equals(O){return O.type===this.type}substituteConstants(){return this}evaluate(O){return!0}serialize(){return"true"}keys(){return[]}map(O){return this}negate(){return n.INSTANCE}}e.$Ni=a,a.INSTANCE=new a;class ${static create(O,N=null){const Q=w.get(O);return typeof Q=="boolean"?Q?a.INSTANCE:n.INSTANCE:new $(O,N)}constructor(O,N){this.key=O,this.c=N,this.type=2}cmp(O){return O.type!==this.type?this.type-O.type:q(this.key,O.key)}equals(O){return O.type===this.type?this.key===O.key:!1}substituteConstants(){const O=w.get(this.key);return typeof O=="boolean"?O?a.INSTANCE:n.INSTANCE:this}evaluate(O){return!!O.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(O){return O.mapDefined(this.key)}negate(){return this.c||(this.c=j.create(this.key,this)),this.c}}e.$Oi=$;class S{static create(O,N,Q=null){if(typeof N=="boolean")return N?$.create(O,Q):j.create(O,Q);const T=w.get(O);return typeof T=="boolean"?N===(T?"true":"false")?a.INSTANCE:n.INSTANCE:new S(O,N,Q)}constructor(O,N,Q){this.c=O,this.d=N,this.f=Q,this.type=4}cmp(O){return O.type!==this.type?this.type-O.type:ne(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){const O=w.get(this.c);if(typeof O=="boolean"){const N=O?"true":"false";return this.d===N?a.INSTANCE:n.INSTANCE}return this}evaluate(O){return O.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(O){return O.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=A.create(this.c,this.d,this)),this.f}}e.$Pi=S;class D{static create(O,N){return new D(O,N)}constructor(O,N){this.d=O,this.f=N,this.type=10,this.c=null}cmp(O){return O.type!==this.type?this.type-O.type:ne(this.d,this.f,O.d,O.f)}equals(O){return O.type===this.type?this.d===O.d&&this.f===O.f:!1}substituteConstants(){return this}evaluate(O){const N=O.getValue(this.f),Q=O.getValue(this.d);return Array.isArray(N)?N.includes(Q):typeof Q=="string"&&typeof N=="object"&&N!==null?C.call(N,Q):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(O){return O.mapIn(this.d,this.f)}negate(){return this.c||(this.c=k.create(this.d,this.f)),this.c}}e.$Qi=D;class k{static create(O,N){return new k(O,N)}constructor(O,N){this.d=O,this.f=N,this.type=11,this.c=D.create(O,N)}cmp(O){return O.type!==this.type?this.type-O.type:this.c.cmp(O.c)}equals(O){return O.type===this.type?this.c.equals(O.c):!1}substituteConstants(){return this}evaluate(O){return!this.c.evaluate(O)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(O){return O.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Ri=k;class A{static create(O,N,Q=null){if(typeof N=="boolean")return N?j.create(O,Q):$.create(O,Q);const T=w.get(O);return typeof T=="boolean"?N===(T?"true":"false")?n.INSTANCE:a.INSTANCE:new A(O,N,Q)}constructor(O,N,Q){this.c=O,this.d=N,this.f=Q,this.type=5}cmp(O){return O.type!==this.type?this.type-O.type:ne(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){const O=w.get(this.c);if(typeof O=="boolean"){const N=O?"true":"false";return this.d===N?n.INSTANCE:a.INSTANCE}return this}evaluate(O){return O.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(O){return O.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=S.create(this.c,this.d,this)),this.f}}e.$Si=A;class j{static create(O,N=null){const Q=w.get(O);return typeof Q=="boolean"?Q?n.INSTANCE:a.INSTANCE:new j(O,N)}constructor(O,N){this.c=O,this.d=N,this.type=3}cmp(O){return O.type!==this.type?this.type-O.type:q(this.c,O.c)}equals(O){return O.type===this.type?this.c===O.c:!1}substituteConstants(){const O=w.get(this.c);return typeof O=="boolean"?O?n.INSTANCE:a.INSTANCE:this}evaluate(O){return!O.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(O){return O.mapNot(this.c)}negate(){return this.d||(this.d=$.create(this.c,this)),this.d}}e.$Ti=j;function Z(ee,O){if(typeof ee=="string"){const N=parseFloat(ee);isNaN(N)||(ee=N)}return typeof ee=="string"||typeof ee=="number"?O(ee):n.INSTANCE}class ae{static create(O,N,Q=null){return Z(N,T=>new ae(O,T,Q))}constructor(O,N,Q){this.c=O,this.d=N,this.f=Q,this.type=12}cmp(O){return O.type!==this.type?this.type-O.type:ne(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(O){return O.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=ue.create(this.c,this.d,this)),this.f}}e.$Ui=ae;class K{static create(O,N,Q=null){return Z(N,T=>new K(O,T,Q))}constructor(O,N,Q){this.c=O,this.d=N,this.f=Q,this.type=13}cmp(O){return O.type!==this.type?this.type-O.type:ne(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(O){return O.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=se.create(this.c,this.d,this)),this.f}}e.$Vi=K;class se{static create(O,N,Q=null){return Z(N,T=>new se(O,T,Q))}constructor(O,N,Q){this.c=O,this.d=N,this.f=Q,this.type=14}cmp(O){return O.type!==this.type?this.type-O.type:ne(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(O){return O.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=K.create(this.c,this.d,this)),this.f}}e.$Wi=se;class ue{static create(O,N,Q=null){return Z(N,T=>new ue(O,T,Q))}constructor(O,N,Q){this.c=O,this.d=N,this.f=Q,this.type=15}cmp(O){return O.type!==this.type?this.type-O.type:ne(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(O){return O.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=ae.create(this.c,this.d,this)),this.f}}e.$Xi=ue;class x{static create(O,N){return new x(O,N)}constructor(O,N){this.d=O,this.f=N,this.type=7,this.c=null}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.d<O.d)return-1;if(this.d>O.d)return 1;const N=this.f?this.f.source:"",Q=O.f?O.f.source:"";return N<Q?-1:N>Q?1:0}equals(O){if(O.type===this.type){const N=this.f?this.f.source:"",Q=O.f?O.f.source:"";return this.d===O.d&&N===Q}return!1}substituteConstants(){return this}evaluate(O){const N=O.getValue(this.d);return this.f?this.f.test(N):!1}serialize(){const O=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${O}`}keys(){return[this.d]}map(O){return O.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=he.create(this)),this.c}}e.$Yi=x;class he{static create(O){return new he(O)}constructor(O){this.c=O,this.type=8}cmp(O){return O.type!==this.type?this.type-O.type:this.c.cmp(O.c)}equals(O){return O.type===this.type?this.c.equals(O.c):!1}substituteConstants(){return this}evaluate(O){return!this.c.evaluate(O)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(O){return new he(this.c.map(O))}negate(){return this.c}}e.$Zi=he;function V(ee){let O=null;for(let N=0,Q=ee.length;N<Q;N++){const T=ee[N].substituteConstants();if(ee[N]!==T&&O===null){O=[];for(let H=0;H<N;H++)O[H]=ee[H]}O!==null&&(O[N]=T)}return O===null?ee:O}class te{static create(O,N,Q){return te.d(O,N,Q)}constructor(O,N){this.expr=O,this.c=N,this.type=6}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.expr.length<O.expr.length)return-1;if(this.expr.length>O.expr.length)return 1;for(let N=0,Q=this.expr.length;N<Q;N++){const T=i(this.expr[N],O.expr[N]);if(T!==0)return T}return 0}equals(O){if(O.type===this.type){if(this.expr.length!==O.expr.length)return!1;for(let N=0,Q=this.expr.length;N<Q;N++)if(!this.expr[N].equals(O.expr[N]))return!1;return!0}return!1}substituteConstants(){const O=V(this.expr);return O===this.expr?this:te.create(O,this.c,!1)}evaluate(O){for(let N=0,Q=this.expr.length;N<Q;N++)if(!this.expr[N].evaluate(O))return!1;return!0}static d(O,N,Q){const T=[];let H=!1;for(const U of O)if(U){if(U.type===1){H=!0;continue}if(U.type===0)return n.INSTANCE;if(U.type===6){T.push(...U.expr);continue}T.push(U)}if(T.length===0&&H)return a.INSTANCE;if(T.length!==0){if(T.length===1)return T[0];T.sort(i);for(let U=1;U<T.length;U++)T[U-1].equals(T[U])&&(T.splice(U,1),U--);if(T.length===1)return T[0];for(;T.length>1;){const U=T[T.length-1];if(U.type!==9)break;T.pop();const ie=T.pop(),z=T.length===0,_=G.create(U.expr.map(W=>te.create([W,ie],null,Q)),null,z);_&&(T.push(_),T.sort(i))}if(T.length===1)return T[0];if(Q){for(let U=0;U<T.length;U++)for(let ie=U+1;ie<T.length;ie++)if(T[U].negate().equals(T[ie]))return n.INSTANCE;if(T.length===1)return T[0]}return new te(T,N)}}serialize(){return this.expr.map(O=>O.serialize()).join(" && ")}keys(){const O=[];for(const N of this.expr)O.push(...N.keys());return O}map(O){return new te(this.expr.map(N=>N.map(O)),null)}negate(){if(!this.c){const O=[];for(const N of this.expr)O.push(N.negate());this.c=G.create(O,this,!0)}return this.c}}e.$1i=te;class G{static create(O,N,Q){return G.d(O,N,Q)}constructor(O,N){this.expr=O,this.c=N,this.type=9}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.expr.length<O.expr.length)return-1;if(this.expr.length>O.expr.length)return 1;for(let N=0,Q=this.expr.length;N<Q;N++){const T=i(this.expr[N],O.expr[N]);if(T!==0)return T}return 0}equals(O){if(O.type===this.type){if(this.expr.length!==O.expr.length)return!1;for(let N=0,Q=this.expr.length;N<Q;N++)if(!this.expr[N].equals(O.expr[N]))return!1;return!0}return!1}substituteConstants(){const O=V(this.expr);return O===this.expr?this:G.create(O,this.c,!1)}evaluate(O){for(let N=0,Q=this.expr.length;N<Q;N++)if(this.expr[N].evaluate(O))return!0;return!1}static d(O,N,Q){let T=[],H=!1;if(O){for(let U=0,ie=O.length;U<ie;U++){const z=O[U];if(z){if(z.type===0){H=!0;continue}if(z.type===1)return a.INSTANCE;if(z.type===9){T=T.concat(z.expr);continue}T.push(z)}}if(T.length===0&&H)return n.INSTANCE;T.sort(i)}if(T.length!==0){if(T.length===1)return T[0];for(let U=1;U<T.length;U++)T[U-1].equals(T[U])&&(T.splice(U,1),U--);if(T.length===1)return T[0];if(Q){for(let U=0;U<T.length;U++)for(let ie=U+1;ie<T.length;ie++)if(T[U].negate().equals(T[ie]))return a.INSTANCE;if(T.length===1)return T[0]}return new G(T,N)}}serialize(){return this.expr.map(O=>O.serialize()).join(" || ")}keys(){const O=[];for(const N of this.expr)O.push(...N.keys());return O}map(O){return new G(this.expr.map(N=>N.map(O)),null)}negate(){if(!this.c){const O=[];for(const N of this.expr)O.push(N.negate());for(;O.length>1;){const N=O.shift(),Q=O.shift(),T=[];for(const H of B(N))for(const U of B(Q))T.push(te.create([H,U],null,!1));O.unshift(G.create(T,null,!1))}this.c=G.create(O,this,!0)}return this.c}}e.$2i=G;class J extends ${static all(){return J.d.values()}constructor(O,N,Q){super(O,null),this.f=N,typeof Q=="object"?J.d.push({...Q,key:O}):Q!==!0&&J.d.push({key:O,description:Q,type:N!=null?typeof N:void 0})}bindTo(O){return O.createKey(this.key,this.f)}getValue(O){return O.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(O){return S.create(this.key,O)}notEqualsTo(O){return A.create(this.key,O)}}e.$3i=J,J.d=[],e.$4i=(0,P.$Lh)("contextKeyService");function q(ee,O){return ee<O?-1:ee>O?1:0}function ne(ee,O,N,Q){return ee<N?-1:ee>N?1:O<Q?-1:O>Q?1:0}function me(ee,O){if(ee.type===0||O.type===1)return!0;if(ee.type===9)return O.type===9?re(ee.expr,O.expr):!1;if(O.type===9){for(const N of O.expr)if(me(ee,N))return!0;return!1}if(ee.type===6){if(O.type===6)return re(O.expr,ee.expr);for(const N of ee.expr)if(me(N,O))return!0;return!1}return ee.equals(O)}e.$5i=me;function re(ee,O){let N=0,Q=0;for(;N<ee.length&&Q<O.length;){const T=ee[N].cmp(O[Q]);if(T<0)return!1;T===0&&N++,Q++}return N===ee.length}function B(ee){return ee.type===9?ee.expr:[ee]}}),define(we[215],pe([1,0,6]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$km=e.$jm=e.$im=e.ID=void 0,e.ID="diagnosticsService",e.$im=(0,y.$Lh)(e.ID);function R(P){return!!P.hostName&&!!P.errorMessage}e.$jm=R;class r{async getPerformanceInfo(L,I){return{}}async getSystemInfo(L,I){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(L,I){return""}async getWorkspaceFileExtensions(L){return{extensions:[]}}async reportWorkspaceStats(L){}}e.$km=r}),define(we[80],pe([1,0,6]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fn=void 0,e.$Fn=(0,y.$Lh)("downloadService")}),define(we[25],pe([1,0,6]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Th=e.$Sh=void 0,e.$Sh=(0,y.$Lh)("environmentService"),e.$Th=(0,y.$Mh)(e.$Sh)}),define(we[30],pe([1,0,178,6]),function(le,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$2n=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$1n=e.$Zn=e.$Yn=e.$Xn=e.$Wn=e.$Vn=e.$Un=e.$Tn=e.$Sn=e.$Rn=e.$Qn=e.$Pn=e.$On=void 0,e.$On="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Pn=new RegExp(e.$On),e.$Qn="__web_extension",e.$Rn="skipWalkthrough",e.$Sn="extensionsSync",e.$Tn="dependecyOrPackExtensionInstall";function r(u){switch(u){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$Un=r;function P(u){switch(u){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$Vn=P;function L(u,c){switch(u){case 3:return c==="x64"?"win32-x64":c==="ia32"?"win32-ia32":c==="arm64"?"win32-arm64":"unknown";case 2:return c==="x64"?"linux-x64":c==="arm64"?"linux-arm64":c==="arm"?"linux-armhf":"unknown";case"alpine":return c==="x64"?"alpine-x64":c==="arm64"?"alpine-arm64":"unknown";case 1:return c==="x64"?"darwin-x64":c==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$Wn=L;function I(u,c){return c==="web"&&!u.includes("web")}e.$Xn=I;function w(u,c,p){return I(c,p)?!1:u==="undefined"||u==="universal"?!0:u==="unknown"?!1:u===p?!0:b(p).includes(u)}e.$Yn=w;function b(u){switch(u){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.$Zn=b;function C(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(!u.uuid||typeof u.uuid=="string")}e.$1n=C;var E;(function(u){u[u.NoneOrRelevance=0]="NoneOrRelevance",u[u.LastUpdatedDate=1]="LastUpdatedDate",u[u.Title=2]="Title",u[u.PublisherName=3]="PublisherName",u[u.InstallCount=4]="InstallCount",u[u.PublishedDate=10]="PublishedDate",u[u.AverageRating=6]="AverageRating",u[u.WeightedRating=12]="WeightedRating"})(E||(e.SortBy=E={}));var v;(function(u){u[u.Default=0]="Default",u[u.Ascending=1]="Ascending",u[u.Descending=2]="Descending"})(v||(e.SortOrder=v={}));var d;(function(u){u.Install="install",u.Uninstall="uninstall"})(d||(e.StatisticType=d={}));var g;(function(u){u[u.None=1]="None",u[u.Install=2]="Install",u[u.Update=3]="Update",u[u.Migrate=4]="Migrate"})(g||(e.InstallOperation=g={})),e.$2n=(0,R.$Lh)("extensionGalleryService");var m;(function(u){u.Unsupported="Unsupported",u.Deprecated="Deprecated",u.Malicious="Malicious",u.Incompatible="Incompatible",u.IncompatibleTargetPlatform="IncompatibleTargetPlatform",u.ReleaseVersionNotFound="ReleaseVersionNotFound",u.Invalid="Invalid",u.Download="Download",u.Extract="Extract",u.Delete="Delete",u.Rename="Rename",u.CorruptZip="CorruptZip",u.IncompleteZip="IncompleteZip",u.Signature="Signature",u.Internal="Internal"})(m||(e.ExtensionManagementErrorCode=m={}));var l;(function(u){u.UnknownError="UnknownError",u.PackageIsInvalidZip="PackageIsInvalidZip",u.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(l||(e.ExtensionSignaturetErrorCode=l={}));class f extends Error{constructor(c,p){super(c),this.code=p,this.name=p}}e.$3n=f,e.$4n=(0,R.$Lh)("extensionManagementService"),e.$5n="extensionsIdentifiers/disabled",e.$6n="extensionsIdentifiers/enabled",e.$7n=(0,R.$Lh)("IGlobalExtensionEnablementService"),e.$8n=(0,R.$Lh)("IExtensionTipsService"),e.$9n=(0,y.localize)(0,null),e.$0n={value:e.$9n,original:"Extensions"},e.$$n={value:(0,y.localize)(1,null),original:"Preferences"}}),define(we[216],pe([1,0,5,2,22,4,51,30]),function(le,e,y,R,r,P,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bp=e.$ap=e.$_o=void 0;function w(l,f){return l?P.URI.revive(f?f.transformIncoming(l):l):void 0}function b(l,f){return f?f.transformOutgoingURI(l):l}function C(l,f){f=f||L.$Em;const u=l.manifest;return{...(0,L.$Hm)({...l,manifest:void 0},f),manifest:u}}function E(l,f){return l?.profileLocation?(0,L.$Hm)(l,f??L.$Em):l}function v(l,f){return f?(0,r.$Zm)(l,u=>u instanceof P.URI?f.transformOutgoingURI(u):void 0):l}class d{constructor(f,u){this.a=f,this.b=u,this.onInstallExtension=y.Event.buffer(f.onInstallExtension,!0),this.onDidInstallExtensions=y.Event.buffer(f.onDidInstallExtensions,!0),this.onUninstallExtension=y.Event.buffer(f.onUninstallExtension,!0),this.onDidUninstallExtension=y.Event.buffer(f.onDidUninstallExtension,!0),this.onDidUpdateExtensionMetadata=y.Event.buffer(f.onDidUpdateExtensionMetadata,!0)}listen(f,u){const c=this.b(f);switch(u){case"onInstallExtension":return y.Event.map(this.onInstallExtension,p=>({...p,profileLocation:p.profileLocation?b(p.profileLocation,c):p.profileLocation}));case"onDidInstallExtensions":return y.Event.map(this.onDidInstallExtensions,p=>p.map(h=>({...h,local:h.local?v(h.local,c):h.local,profileLocation:h.profileLocation?b(h.profileLocation,c):h.profileLocation})));case"onUninstallExtension":return y.Event.map(this.onUninstallExtension,p=>({...p,profileLocation:p.profileLocation?b(p.profileLocation,c):p.profileLocation}));case"onDidUninstallExtension":return y.Event.map(this.onDidUninstallExtension,p=>({...p,profileLocation:p.profileLocation?b(p.profileLocation,c):p.profileLocation}));case"onDidUpdateExtensionMetadata":return y.Event.map(this.onDidUpdateExtensionMetadata,p=>v(p,c))}throw new Error("Invalid listen")}async call(f,u,c){const p=this.b(f);switch(u){case"zip":{const h=C(c[0],p),t=await this.a.zip(h);return b(t,p)}case"unzip":return this.a.unzip(w(c[0],p));case"install":return this.a.install(w(c[0],p),E(c[1],p));case"installFromLocation":return this.a.installFromLocation(w(c[0],p),w(c[1],p));case"installExtensionsFromProfile":return this.a.installExtensionsFromProfile(c[0],w(c[1],p),w(c[2],p));case"getManifest":return this.a.getManifest(w(c[0],p));case"getTargetPlatform":return this.a.getTargetPlatform();case"canInstall":return this.a.canInstall(c[0]);case"installFromGallery":return this.a.installFromGallery(c[0],E(c[1],p));case"installGalleryExtensions":{const h=c[0];return this.a.installGalleryExtensions(h.map(({extension:t,options:s})=>({extension:t,options:E(s,p)??{}})))}case"uninstall":return this.a.uninstall(C(c[0],p),E(c[1],p));case"reinstallFromGallery":return this.a.reinstallFromGallery(C(c[0],p));case"getInstalled":return(await this.a.getInstalled(c[0],w(c[1],p))).map(t=>v(t,p));case"toggleAppliationScope":{const h=await this.a.toggleAppliationScope(C(c[0],p),w(c[1],p));return v(h,p)}case"copyExtensions":return this.a.copyExtensions(w(c[0],p),w(c[1],p));case"updateMetadata":{const h=await this.a.updateMetadata(C(c[0],p),c[1],w(c[2],p));return v(h,p)}case"getExtensionsControlManifest":return this.a.getExtensionsControlManifest();case"download":return this.a.download(c[0],c[1],c[2]);case"cleanUp":return this.a.cleanUp()}throw new Error("Invalid call")}}e.$_o=d;class g extends R.$Qc{get onInstallExtension(){return this.c.event}get onDidInstallExtensions(){return this.f.event}get onUninstallExtension(){return this.g.event}get onDidUninstallExtension(){return this.h.event}get onDidUpdateExtensionMetadata(){return this.j.event}constructor(f){super(),this.m=f,this.c=this.B(new y.$Ld),this.f=this.B(new y.$Ld),this.g=this.B(new y.$Ld),this.h=this.B(new y.$Ld),this.j=this.B(new y.$Ld),this.B(this.m.listen("onInstallExtension")(u=>this.n(this.c,{...u,source:this.r(u.source)?P.URI.revive(u.source):u.source,profileLocation:P.URI.revive(u.profileLocation)}))),this.B(this.m.listen("onDidInstallExtensions")(u=>this.n(this.f,u.map(c=>({...c,local:c.local?C(c.local,null):c.local,source:this.r(c.source)?P.URI.revive(c.source):c.source,profileLocation:P.URI.revive(c.profileLocation)}))))),this.B(this.m.listen("onUninstallExtension")(u=>this.n(this.g,{...u,profileLocation:P.URI.revive(u.profileLocation)}))),this.B(this.m.listen("onDidUninstallExtension")(u=>this.n(this.h,{...u,profileLocation:P.URI.revive(u.profileLocation)}))),this.B(this.m.listen("onDidUpdateExtensionMetadata")(u=>this.j.fire(C(u,null))))}n(f,u){f.fire(u)}r(f){return f?typeof f.path=="string"&&typeof f.scheme=="string":!1}getTargetPlatform(){return this.s||(this.s=this.m.call("getTargetPlatform")),this.s}async canInstall(f){const u=await this.getTargetPlatform();return f.allTargetPlatforms.some(c=>(0,I.$Yn)(c,f.allTargetPlatforms,u))}zip(f){return Promise.resolve(this.m.call("zip",[f]).then(u=>P.URI.revive(u)))}unzip(f){return Promise.resolve(this.m.call("unzip",[f]))}install(f,u){return Promise.resolve(this.m.call("install",[f,u])).then(c=>C(c,null))}installFromLocation(f,u){return Promise.resolve(this.m.call("installFromLocation",[f,u])).then(c=>C(c,null))}async installExtensionsFromProfile(f,u,c){return(await this.m.call("installExtensionsFromProfile",[f,u,c])).map(h=>C(h,null))}getManifest(f){return Promise.resolve(this.m.call("getManifest",[f]))}installFromGallery(f,u){return Promise.resolve(this.m.call("installFromGallery",[f,u])).then(c=>C(c,null))}async installGalleryExtensions(f){return(await this.m.call("installGalleryExtensions",[f])).map(c=>({...c,local:c.local?C(c.local,null):c.local,source:this.r(c.source)?P.URI.revive(c.source):c.source,profileLocation:P.URI.revive(c.profileLocation)}))}uninstall(f,u){return Promise.resolve(this.m.call("uninstall",[f,u]))}reinstallFromGallery(f){return Promise.resolve(this.m.call("reinstallFromGallery",[f])).then(u=>C(u,null))}getInstalled(f=null,u){return Promise.resolve(this.m.call("getInstalled",[f,u])).then(c=>c.map(p=>C(p,null)))}updateMetadata(f,u,c){return Promise.resolve(this.m.call("updateMetadata",[f,u,c])).then(p=>C(p,null))}toggleAppliationScope(f,u){return this.m.call("toggleAppliationScope",[f,u]).then(c=>C(c,null))}copyExtensions(f,u){return this.m.call("copyExtensions",[f,u])}getExtensionsControlManifest(){return Promise.resolve(this.m.call("getExtensionsControlManifest"))}async download(f,u,c){const p=await this.m.call("download",[f,u,c]);return P.URI.revive(p)}async cleanUp(){return this.m.call("cleanUp")}registerParticipant(){throw new Error("Not Supported")}}e.$ap=g;class m{constructor(f){this.a=f}listen(f,u){throw new Error("Invalid listen")}call(f,u,c){switch(u){case"getConfigBasedTips":return this.a.getConfigBasedTips(P.URI.revive(c[0]));case"getImportantExecutableBasedTips":return this.a.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.a.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.$bp=m}),define(we[81],pe([1,0,6]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0o=e.$9o=void 0,e.$9o=(0,y.$Lh)("IExtensionSignatureVerificationService");class R{b(){return this.a||(this.a=new Promise((P,L)=>le(["node-vsce-sign"],async I=>P(I),L))),this.a}async verify(P,L,I){let w;try{w=await this.b()}catch{return!1}return w.verify(P,L,I)}}e.$0o=R}),define(we[16],pe([1,0,63,7,17,8,4,186,6,3,12]),function(le,e,y,R,r,P,L,I,w,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ck=e.$Bk=e.$Ak=e.$zk=e.$yk=e.FileKind=e.$xk=e.$wk=e.$vk=e.$uk=e.$tk=e.$sk=e.$rk=e.FileOperationResult=e.$qk=e.$pk=e.$ok=e.$nk=e.$mk=e.FileChangeType=e.$lk=e.FileOperation=e.$kk=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.FileSystemProviderErrorCode=e.$ek=e.$dk=e.$ck=e.$bk=e.$ak=e.$_j=e.$$j=e.$0j=e.$9j=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.$8j=e.$7j=void 0,e.$7j=(0,w.$Lh)("fileService");function E(q){return q.create===!0}e.$8j=E;var v;(function(q){q[q.Unknown=0]="Unknown",q[q.File=1]="File",q[q.Directory=2]="Directory",q[q.SymbolicLink=64]="SymbolicLink"})(v||(e.FileType=v={}));var d;(function(q){q[q.Readonly=1]="Readonly",q[q.Locked=2]="Locked"})(d||(e.FilePermission=d={}));var g;(function(q){q[q.None=0]="None",q[q.FileReadWrite=2]="FileReadWrite",q[q.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",q[q.FileReadStream=16]="FileReadStream",q[q.FileFolderCopy=8]="FileFolderCopy",q[q.PathCaseSensitive=1024]="PathCaseSensitive",q[q.Readonly=2048]="Readonly",q[q.Trash=4096]="Trash",q[q.FileWriteUnlock=8192]="FileWriteUnlock",q[q.FileAtomicRead=16384]="FileAtomicRead",q[q.FileAtomicWrite=32768]="FileAtomicWrite",q[q.FileAtomicDelete=65536]="FileAtomicDelete",q[q.FileClone=131072]="FileClone"})(g||(e.FileSystemProviderCapabilities=g={}));function m(q){return!!(q.capabilities&2)}e.$9j=m;function l(q){return!!(q.capabilities&8)}e.$0j=l;function f(q){return!!(q.capabilities&131072)}e.$$j=f;function u(q){return!!(q.capabilities&4)}e.$_j=u;function c(q){return!!(q.capabilities&16)}e.$ak=c;function p(q){return m(q)?!!(q.capabilities&16384):!1}e.$bk=p;function h(q){return m(q)?!!(q.capabilities&32768):!1}e.$ck=h;function t(q){return!!(q.capabilities&65536)}e.$dk=t;function s(q){return!!(q.capabilities&2048)}e.$ek=s;var o;(function(q){q.FileExists="EntryExists",q.FileNotFound="EntryNotFound",q.FileNotADirectory="EntryNotADirectory",q.FileIsADirectory="EntryIsADirectory",q.FileExceedsStorageQuota="EntryExceedsStorageQuota",q.FileTooLarge="EntryTooLarge",q.FileWriteLocked="EntryWriteLocked",q.NoPermissions="NoPermissions",q.Unavailable="Unavailable",q.Unknown="Unknown"})(o||(e.FileSystemProviderErrorCode=o={}));class i extends Error{static create(ne,me){const re=new i(ne.toString(),me);return $(re,me),re}constructor(ne,me){super(ne),this.code=me}}e.$fk=i;function n(q,ne){return i.create(q,ne)}e.$gk=n;function a(q){return q||n((0,I.localize)(0,null),o.Unknown)}e.$hk=a;function $(q,ne){return q.name=ne?`${ne} (FileSystemError)`:"FileSystemError",q}e.$ik=$;function S(q){if(!q)return o.Unknown;if(q instanceof i)return q.code;const ne=/^(.+) \(FileSystemError\)$/.exec(q.name);if(!ne)return o.Unknown;switch(ne[1]){case o.FileExists:return o.FileExists;case o.FileIsADirectory:return o.FileIsADirectory;case o.FileNotADirectory:return o.FileNotADirectory;case o.FileNotFound:return o.FileNotFound;case o.FileTooLarge:return o.FileTooLarge;case o.FileWriteLocked:return o.FileWriteLocked;case o.NoPermissions:return o.NoPermissions;case o.Unavailable:return o.Unavailable}return o.Unknown}e.$jk=S;function D(q){if(q instanceof K)return q.fileOperationResult;switch(S(q)){case o.FileNotFound:return 1;case o.FileIsADirectory:return 0;case o.FileNotADirectory:return 9;case o.FileWriteLocked:return 5;case o.NoPermissions:return 6;case o.FileExists:return 4;case o.FileTooLarge:return 7;default:return 10}}e.$kk=D;var k;(function(q){q[q.CREATE=0]="CREATE",q[q.DELETE=1]="DELETE",q[q.MOVE=2]="MOVE",q[q.COPY=3]="COPY",q[q.WRITE=4]="WRITE"})(k||(e.FileOperation=k={}));class A{constructor(ne,me,re){this.resource=ne,this.operation=me,this.target=re}isOperation(ne){return this.operation===ne}}e.$lk=A;var j;(function(q){q[q.UPDATED=0]="UPDATED",q[q.ADDED=1]="ADDED",q[q.DELETED=2]="DELETED"})(j||(e.FileChangeType=j={}));class Z{constructor(ne,me){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const re=new Map;for(const B of ne){const ee=re.get(B.type);switch(ee?ee.push([B.resource,B]):re.set(B.type,[[B.resource,B]]),B.type){case 1:this.rawAdded.push(B.resource);break;case 0:this.rawUpdated.push(B.resource);break;case 2:this.rawDeleted.push(B.resource);break}}for(const[B,ee]of re)switch(B){case 1:this.a=y.$Rh.forUris(()=>me),this.a.fill(ee);break;case 0:this.b=y.$Rh.forUris(()=>me),this.b.fill(ee);break;case 2:this.c=y.$Rh.forUris(()=>me),this.c.fill(ee);break}}contains(ne,...me){return this.d(ne,{includeChildren:!1},...me)}affects(ne,...me){return this.d(ne,{includeChildren:!0},...me)}d(ne,me,...re){if(!ne)return!1;const B=re.length>0;return!!((!B||re.includes(1))&&(this.a?.get(ne)||me.includeChildren&&this.a?.findSuperstr(ne))||(!B||re.includes(0))&&(this.b?.get(ne)||me.includeChildren&&this.b?.findSuperstr(ne))||(!B||re.includes(2))&&(this.c?.findSubstr(ne)||me.includeChildren&&this.c?.findSuperstr(ne)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.$mk=Z;function ae(q,ne,me){return!q||!ne||q===ne||ne.length>q.length?!1:(ne.charAt(ne.length-1)!==R.sep&&(ne+=R.sep),me?(0,r.$1e)(q,ne):q.indexOf(ne)===0)}e.$nk=ae;class K extends Error{constructor(ne,me,re){super(ne),this.fileOperationResult=me,this.options=re}}e.$ok=K;class se extends K{constructor(ne,me,re,B){super(ne,me,B),this.fileOperationResult=me,this.size=re}}e.$pk=se;class ue extends K{constructor(ne,me,re){super(ne,2,re),this.stat=me}}e.$qk=ue;var x;(function(q){q[q.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",q[q.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",q[q.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",q[q.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",q[q.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",q[q.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",q[q.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",q[q.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",q[q.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",q[q.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",q[q.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(x||(e.FileOperationResult=x={})),e.$rk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$sk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$tk="files.associations",e.$uk="files.exclude",e.$vk="files.readonlyInclude",e.$wk="files.readonlyExclude",e.$xk="files.readonlyFromPermissions";var he;(function(q){q[q.FILE=0]="FILE",q[q.FOLDER=1]="FOLDER",q[q.ROOT_FOLDER=2]="ROOT_FOLDER"})(he||(e.FileKind=he={})),e.$yk="";function V(q){if(!(typeof q.size!="number"||typeof q.mtime!="number"))return q.mtime.toString(29)+q.size.toString(31)}e.$zk=V;async function te(q,ne){if(!ne.hasProvider(L.URI.from({scheme:q.scheme})))return new Promise(me=>{const re=ne.onDidChangeFileSystemProviderRegistrations(B=>{B.scheme===q.scheme&&B.added&&(re.dispose(),me())})})}e.$Ak=te;class G{static formatSize(ne){return(0,P.$Af)(ne)||(ne=0),ne<G.KB?(0,I.localize)(1,null,ne.toFixed(0)):ne<G.MB?(0,I.localize)(2,null,(ne/G.KB).toFixed(2)):ne<G.GB?(0,I.localize)(3,null,(ne/G.MB).toFixed(2)):ne<G.TB?(0,I.localize)(4,null,(ne/G.GB).toFixed(2)):(0,I.localize)(5,null,(ne/G.TB).toFixed(2))}}e.$Bk=G,G.KB=1024,G.MB=G.KB*G.KB,G.GB=G.MB*G.KB,G.TB=G.GB*G.KB;function J(q){const ne=typeof q=="string"||q?.scheme===C.Schemas.vscodeRemote;return typeof q!="string"&&q?.scheme===C.Schemas.file?1024*G.MB:ne?10*G.MB:b.$j?50*G.MB:1024*G.MB}e.$Ck=J}),define(we[217],pe([1,0,15,39,11,5,2,48,4,23,16]),function(le,e,y,R,r,P,L,I,w,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dN=e.$cN=void 0,e.$cN="localFilesystem";class E extends L.$Qc{constructor(d,g){super(),this.a=d,this.b=g,this.onDidChangeCapabilities=P.Event.None,this.f=this.B(new P.$Ld),this.onDidChangeFile=this.f.event,this.g=this.B(new P.$Ld),this.onDidWatchError=this.g.event,this.h=(0,b.$bg)(),this.j()}get capabilities(){return this.c||(this.c=253982,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(d){return this.a.call("stat",[d])}readdir(d){return this.a.call("readdir",[d])}async readFile(d,g){const{buffer:m}=await this.a.call("readFile",[d,g]);return m}readFileStream(d,g,m){const l=(0,I.$Zd)(u=>y.$_d.concat(u.map(c=>y.$_d.wrap(c))).buffer),f=new L.$Pc;return f.add(this.a.listen("readFileStream",[d,g])(u=>{if(u instanceof y.$_d)l.write(u.buffer);else{if(u==="end")l.end();else{let c;if(u instanceof Error)c=u;else{const p=u;c=(0,C.$gk)(p.message??(0,R.$wi)(p),p.code??C.FileSystemProviderErrorCode.Unknown)}l.error(c),l.end()}f.dispose()}})),f.add(m.onCancellationRequested(()=>{l.error((0,r.$4)()),l.end(),f.dispose()})),l}writeFile(d,g,m){return this.a.call("writeFile",[d,y.$_d.wrap(g),m])}open(d,g){return this.a.call("open",[d,g])}close(d){return this.a.call("close",[d])}async read(d,g,m,l,f){const[u,c]=await this.a.call("read",[d,g,f]);return m.set(u.buffer.slice(0,c),l),c}write(d,g,m,l,f){return this.a.call("write",[d,g,y.$_d.wrap(m),l,f])}mkdir(d){return this.a.call("mkdir",[d])}delete(d,g){return this.a.call("delete",[d,g])}rename(d,g,m){return this.a.call("rename",[d,g,m])}copy(d,g,m){return this.a.call("copy",[d,g,m])}cloneFile(d,g){return this.a.call("cloneFile",[d,g])}j(){this.B(this.a.listen("fileChange",[this.h])(d=>{if(Array.isArray(d)){const g=d;this.f.fire(g.map(m=>({resource:w.URI.revive(m.resource),type:m.type})))}else{const g=d;this.g.fire(g)}}))}watch(d,g){const m=(0,b.$bg)();return this.a.call("watch",[this.h,m,d,g]),(0,L.$Oc)(()=>this.a.call("unwatch",[this.h,m]))}}e.$dN=E}),define(we[110],pe([1,0,15,11,187,16]),function(le,e,y,R,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ep=void 0;async function L(C,E,v,d,g,m){let l;try{await I(C,E,v,d,g,m)}catch(f){l=f}finally{l&&g.errorTransformer&&(l=g.errorTransformer(l)),typeof l<"u"&&v.error(l),v.end()}}e.$Ep=L;async function I(C,E,v,d,g,m){w(m);const l=await C.open(E,{create:!1});try{w(m);let f=0,u=0,c=g&&typeof g.length=="number"?g.length:void 0,p=y.$_d.alloc(Math.min(g.bufferSize,typeof c=="number"?c:g.bufferSize)),h=g&&typeof g.position=="number"?g.position:0,t=0;do u=await C.read(l,h,p.buffer,t,p.byteLength-t),h+=u,t+=u,f+=u,typeof c=="number"&&(c-=u),t===p.byteLength&&(await v.write(d(p)),p=y.$_d.alloc(Math.min(g.bufferSize,typeof c=="number"?c:g.bufferSize)),t=0);while(u>0&&(typeof c!="number"||c>0)&&w(m)&&b(f,g));if(t>0){let s=t;typeof c=="number"&&(s=Math.min(t,c)),v.write(d(p.slice(0,s)))}}catch(f){throw(0,P.$hk)(f)}finally{await C.close(l)}}function w(C){if(C.isCancellationRequested)throw(0,R.$4)();return!0}function b(C,E){if(typeof E?.limits?.size=="number"&&C>E.limits.size)throw(0,P.$gk)((0,r.localize)(0,null),P.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(we[67],pe([1,0,76,2,7,3,4,16]),function(le,e,y,R,r,P,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Np=e.$Mp=e.$Lp=e.$Kp=e.$Jp=e.$Ip=e.$Hp=e.$Gp=void 0;function w(f){return f.recursive===!0}e.$Gp=w;class b extends R.$Qc{constructor(u,c,p,h){super(),this.h=u,this.j=c,this.m=p,this.n=h,this.c=this.B(new R.$Rc),this.f=void 0,this.g=0}s(){const u=new R.$Pc;this.c.value=u,this.b=this.r(u),this.b.setVerboseLogging(this.m),u.add(this.b.onDidChangeFile(c=>this.h(c))),u.add(this.b.onDidLogMessage(c=>this.j(c))),u.add(this.b.onDidError(c=>this.t(c)))}t(u){this.n.restartOnError?this.g<b.a&&this.f?(this.w(`restarting watcher after error: ${u}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${u}`):this.w(u)}u(u){this.g++,this.s(),this.watch(u)}async watch(u){this.f=u,await this.b?.watch(u)}async setVerboseLogging(u){this.m=u,await this.b?.setVerboseLogging(u)}w(u){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${u}`})}y(u){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${u}`})}dispose(){return this.b=void 0,super.dispose()}}e.$Hp=b,b.a=5;class C extends b{constructor(u,c,p){super(u,c,p,{type:"node.js",restartOnError:!1})}}e.$Ip=C;class E extends b{constructor(u,c,p){super(u,c,p,{type:"universal",restartOnError:!0})}}e.$Jp=E;function v(f){return f.map(u=>({type:u.type,resource:L.URI.file(u.path)}))}e.$Kp=v;function d(f){const u=new l;for(const c of f)u.processEvent(c);return u.coalesce()}e.$Lp=d;function g(f,u){return typeof u=="string"&&!u.startsWith(y.$oj)&&!(0,r.$gc)(u)?{base:f,pattern:u}:u}e.$Mp=g;function m(f,u){const c=[];for(const p of u)c.push((0,y.$sj)(g(f,p)));return c}e.$Np=m;class l{constructor(){this.a=new Set,this.b=new Map}c(u){return P.$f?u.path:u.path.toLowerCase()}processEvent(u){const c=this.b.get(this.c(u));let p=!1;if(c){const h=c.type,t=u.type;c.path!==u.path&&(u.type===2||u.type===1)?p=!0:h===1&&t===2?(this.b.delete(this.c(u)),this.a.delete(c)):h===2&&t===1?c.type=0:h===1&&t===0||(c.type=t)}else p=!0;p&&(this.a.add(u),this.b.set(this.c(u),u))}coalesce(){const u=[],c=[];return Array.from(this.a).filter(p=>p.type!==2?(u.push(p),!1):!0).sort((p,h)=>p.path.length-h.path.length).filter(p=>c.some(h=>(0,I.$nk)(p.path,h,!P.$f))?!1:(c.push(p.path),!0)).concat(u)}}}),define(we[218],pe([1,0,29,14,20,38,2,98,7,3,157,21,67]),function(le,e,y,R,r,P,L,I,w,b,C,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2p=e.$1p=void 0;class d extends L.$Qc{constructor(l,f,u,c){super(),this.m=l,this.n=f,this.r=u,this.s=c,this.c=this.B(new R.$6g({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},p=>this.n(p))),this.f=this.B(new R.$5g(p=>this.z(p),d.b)),this.g=(0,v.$Np)(this.m.path,this.m.excludes),this.h=this.m.includes?(0,v.$Np)(this.m.path,this.m.includes):void 0,this.j=new r.$Vd,this.ready=this.t()}async t(){try{const l=await this.u(this.m);if(this.j.token.isCancellationRequested)return;const f=await E.Promises.stat(l);this.B(await this.w(l,f.isDirectory()))}catch(l){l.code!=="ENOENT"?this.D(l):this.G(l)}}async u(l){let f=l.path;try{f=await E.Promises.realpath(l.path),l.path===f&&(f=await(0,C.$Xp)(l.path)??l.path),l.path!==f&&this.G(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${l.path}, real: ${f})`)}catch{}return f}async w(l,f){if(b.$e&&(0,P.$Vf)(l,"/Volumes/",!0))return this.D(`Refusing to watch ${l} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),L.$Qc.None;const u=new r.$Vd(this.j.token),c=new L.$Pc;try{const p=(0,w.$lc)(l),h=(0,y.watch)(l);c.add((0,L.$Oc)(()=>{h.removeAllListeners(),h.close()})),this.G(`Started watching: '${l}'`);const t=new Set;if(f)try{for(const o of await E.Promises.readdir(l))t.add(o)}catch(o){this.D(o)}const s=new Map;c.add((0,L.$Oc)(()=>{for(const[,o]of s)o.dispose();s.clear()})),h.on("error",(o,i)=>{this.D(`Failed to watch ${l} for changes using fs.watch() (${o}, ${i})`),this.dispose()}),h.on("change",(o,i)=>{if(u.token.isCancellationRequested)return;this.G(`[raw] ["${o}"] ${i}`);let n="";if(i&&(n=i.toString(),b.$e&&(n=(0,I.$jl)(n))),!(!n||o!=="change"&&o!=="rename"))if(f)if(o==="rename"){s.get(n)?.dispose();const a=setTimeout(async()=>{if(s.delete(n),n===p&&!await E.Promises.exists(l)){this.F("Watcher shutdown because watched path got deleted"),this.dispose();return}const $=await this.C((0,w.$hc)(l,n));if(u.token.isCancellationRequested)return;let S;$?t.has(n)?S=0:(S=1,t.add(n)):(t.delete(n),S=2),this.y({path:(0,w.$hc)(this.m.path,n),type:S})},d.a);s.set(n,(0,L.$Oc)(()=>clearTimeout(a)))}else{let a;t.has(n)?a=0:(a=1,t.add(n)),this.y({path:(0,w.$hc)(this.m.path,n),type:a})}else if(o==="rename"||n!==p){const a=setTimeout(async()=>{const $=await E.Promises.exists(l);u.token.isCancellationRequested||($?(this.y({path:this.m.path,type:0},!0),c.add(await this.w(l,!1))):(this.y({path:this.m.path,type:2},!0),this.f.flush(),this.dispose()))},d.a);c.clear(),c.add((0,L.$Oc)(()=>clearTimeout(a)))}else this.y({path:this.m.path,type:0},!0)})}catch(p){await E.Promises.exists(l)&&!u.token.isCancellationRequested&&this.D(`Failed to watch ${l} for changes using fs.watch() (${p.toString()})`)}return(0,L.$Oc)(()=>{u.dispose(!0),c.dispose()})}y(l,f=!1){this.j.token.isCancellationRequested||(this.s&&this.G(`${l.type===1?"[ADDED]":l.type===2?"[DELETED]":"[CHANGED]"} ${l.path}`),!f&&this.g.some(u=>u(l.path))?this.s&&this.G(` >> ignored (excluded) ${l.path}`):!f&&this.h&&this.h.length>0&&!this.h.some(u=>u(l.path))?this.s&&this.G(` >> ignored (not included) ${l.path}`):this.f.work(l))}z(l){const f=(0,v.$Lp)(l);if(f.length>0){if(this.s)for(const c of f)this.G(`>> normalized ${c.type===1?"[ADDED]":c.type===2?"[DELETED]":"[CHANGED]"} ${c.path}`);this.c.work(f)?this.c.pending>0&&this.G(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${f[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.F(`started ignoring events due to too many file change events at once (incoming: ${f.length}, most recent change: ${f[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async C(l){if(b.$f)return E.Promises.exists(l);try{const f=(0,w.$lc)(l);return(await E.Promises.readdir((0,w.$kc)(l))).some(c=>c===f)}catch(f){return this.G(f),!1}}setVerboseLogging(l){this.s=l}D(l){this.j.token.isCancellationRequested||this.r?.({type:"error",message:`[File Watcher (node.js)] ${l}`})}F(l){this.j.token.isCancellationRequested||this.r?.({type:"warn",message:`[File Watcher (node.js)] ${l}`})}G(l){!this.j.token.isCancellationRequested&&this.s&&this.r?.({type:"trace",message:`[File Watcher (node.js)] ${l}`})}dispose(){this.G(`stopping file watcher on ${this.m.path}`),this.j.dispose(!0),super.dispose()}}e.$1p=d,d.a=100,d.b=75;async function g(m,l,f,u,c=512){const p=await E.Promises.open(m,"r"),h=Buffer.allocUnsafe(c),t=new r.$Vd(u);let s,o=!1;const i={path:m,excludes:[],recursive:!1},n=new d(i,a=>{(async()=>{for(const{type:$}of a)if($===0){if(o)return;o=!0;try{for(;!t.token.isCancellationRequested;){const{bytesRead:S}=await E.Promises.read(p,h,0,c,null);if(!S||t.token.isCancellationRequested)break;l(h.slice(0,S))}}catch(S){s=new Error(S),t.dispose(!0)}finally{o=!1}}})()});return await n.ready,f(),new Promise((a,$)=>{t.token.onCancellationRequested(async()=>{n.dispose();try{await E.Promises.close(p)}catch(S){s=new Error(S)}s?$(s):a()})})}e.$2p=g}),define(we[219],pe([1,0,5,76,2,3,218]),function(le,e,y,R,r,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3p=void 0;class I extends r.$Qc{constructor(){super(...arguments),this.a=this.B(new y.$Ld),this.onDidChangeFile=this.a.event,this.b=this.B(new y.$Ld),this.onDidLogMessage=this.b.event,this.onDidError=y.Event.None,this.c=new Map,this.f=!1}async watch(b){const C=this.j(b),E=C.filter(d=>{const g=this.c.get(d.path);return g?!(0,R.$wj)(g.request.excludes,d.excludes)||!(0,R.$wj)(g.request.includes,d.includes):!0}),v=Array.from(this.c.values()).filter(({request:d})=>!C.find(g=>g.path===d.path&&(0,R.$wj)(g.excludes,d.excludes)&&(0,R.$wj)(g.includes,d.includes))).map(({request:d})=>d.path);E.length&&this.m(`Request to start watching: ${E.map(d=>`${d.path} (excludes: ${d.excludes.length>0?d.excludes:"<none>"}, includes: ${d.includes&&d.includes.length>0?JSON.stringify(d.includes):"<all>"})`).join(",")}`),v.length&&this.m(`Request to stop watching: ${v.join(",")}`);for(const d of v)this.h(d);for(const d of E)this.g(d)}g(b){const C=new L.$1p(b,v=>this.a.fire(v),v=>this.b.fire(v),this.f),E={request:b,instance:C};this.c.set(b.path,E)}async stop(){for(const[b]of this.c)this.h(b);this.c.clear()}h(b){const C=this.c.get(b);C&&(this.c.delete(b),C.instance.dispose())}j(b){const C=new Map;for(const E of b){const v=P.$f?E.path:E.path.toLowerCase();C.set(v,E)}return Array.from(C.values())}async setVerboseLogging(b){this.f=b;for(const[,C]of this.c)C.instance.setVerboseLogging(b)}m(b){this.f&&this.b.fire({type:"trace",message:this.n(b)})}n(b,C){return C?`[File Watcher (node.js)] ${b} (path: ${C.request.path})`:`[File Watcher (node.js)] ${b}`}}e.$3p=I}),define(we[220],pe([1,0,67,219]),function(le,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4p=void 0;class r extends y.$Ip{constructor(L,I,w){super(L,I,w),this.s()}r(L){return L.add(new R.$3p)}}e.$4p=r}),define(we[221],pe([1,0,12,42,107,67]),function(le,e,y,R,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vp=void 0;class L extends P.$Jp{constructor(w,b,C){super(w,b,C),this.s()}r(w){const b=w.add(new r.$Up(y.$_f.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return w.add(b.onDidProcessExit(({code:C,signal:E})=>this.t(`terminated by itself with code ${C}, signal: ${E}`))),R.ProxyChannel.toService((0,R.$sh)(b.getChannel("watcher")))}}e.$Vp=L}),define(we[82],pe([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jh=void 0;class y{constructor(...r){this.a=new Map;for(const[P,L]of r)this.set(P,L)}set(r,P){const L=this.a.get(r);return this.a.set(r,P),L}has(r){return this.a.has(r)}get(r){return this.a.get(r)}}e.$Jh=y}),define(we[111],pe([1,0,14,11,2,65,214,6,82,97]),function(le,e,y,R,r,P,L,I,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9p=e.$8p=void 0;const C=!1;class E extends Error{constructor(l){super("cyclic dependency between services"),this.message=l.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${l.toString()}`}}class v{constructor(l=new w.$Jh,f=!1,u,c=C){this.f=l,this.g=f,this.h=u,this.i=c,this.o=new Set,this.f.set(I.$Kh,this),this._globalGraph=c?u?._globalGraph??new L.$7p(p=>p):void 0}createChild(l){return new v(l,this.g,this,this.i)}invokeFunction(l,...f){const u=g.traceInvocation(this.i,l);let c=!1;try{return l({get:h=>{if(c)throw(0,R.$6)("service accessor is only valid during the invocation of its target method");const t=this.m(h,u);if(!t)throw new Error(`[invokeFunction] unknown service '${h}'`);return t}},...f)}finally{c=!0,u.stop()}}createInstance(l,...f){let u,c;return l instanceof P.$Ih?(u=g.traceCreation(this.i,l.ctor),c=this.j(l.ctor,l.staticArguments.concat(f),u)):(u=g.traceCreation(this.i,l),c=this.j(l,f,u)),u.stop(),c}j(l,f=[],u){const c=I._util.getServiceDependencies(l).sort((t,s)=>t.index-s.index),p=[];for(const t of c){const s=this.m(t.id,u);s||this.u(`[createInstance] ${l.name} depends on UNKNOWN service ${t.id}.`,!1),p.push(s)}const h=c.length>0?c[0].index:f.length;if(f.length!==h){console.trace(`[createInstance] First service dependency of ${l.name} at position ${h+1} conflicts with ${f.length} static arguments`);const t=h-f.length;t>0?f=f.concat(new Array(t)):f=f.slice(0,h)}return Reflect.construct(l,f.concat(p))}k(l,f){if(this.f.get(l)instanceof P.$Ih)this.f.set(l,f);else if(this.h)this.h.k(l,f);else throw new Error("illegalState - setting UNKNOWN service instance")}l(l){const f=this.f.get(l);return!f&&this.h?this.h.l(l):f}m(l,f){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(l));const u=this.l(l);return u instanceof P.$Ih?this.q(l,u,f.branch(l,!0)):(f.branch(l,!1),u)}q(l,f,u){if(this.o.has(l))throw new Error(`illegal state - RECURSIVELY instantiating service '${l}'`);this.o.add(l);try{return this.r(l,f,u)}finally{this.o.delete(l)}}r(l,f,u){const c=new L.$7p(t=>t.id.toString());let p=0;const h=[{id:l,desc:f,_trace:u}];for(;h.length;){const t=h.pop();if(c.lookupOrInsertNode(t),p++>1e3)throw new E(c);for(const s of I._util.getServiceDependencies(t.desc.ctor)){const o=this.l(s.id);if(o||this.u(`[createInstance] ${l} depends on ${s.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(s.id)),o instanceof P.$Ih){const i={id:s.id,desc:o,_trace:t._trace.branch(s.id,!0)};c.insertEdge(t,i),h.push(i)}}}for(;;){const t=c.roots();if(t.length===0){if(!c.isEmpty())throw new E(c);break}for(const{data:s}of t){if(this.l(s.id)instanceof P.$Ih){const i=this.s(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this.k(s.id,i)}c.removeNode(s)}}return this.l(l)}s(l,f,u=[],c,p){if(this.f.get(l)instanceof P.$Ih)return this.t(l,f,u,c,p);if(this.h)return this.h.s(l,f,u,c,p);throw new Error(`illegalState - creating UNKNOWN service instance ${f.name}`)}t(l,f,u=[],c,p){if(c){const h=new v(void 0,this.g,this,this.i);h.c=String(l);const t=new Map,s=new y.$8g(()=>{const o=h.j(f,u,p);for(const[i,n]of t){const a=o[i];if(typeof a=="function")for(const $ of n)a.apply(o,$)}return t.clear(),o});return new Proxy(Object.create(null),{get(o,i){if(!s.isInitialized&&typeof i=="string"&&(i.startsWith("onDid")||i.startsWith("onWill"))){let $=t.get(i);return $||($=new b.$Zc,t.set(i,$)),(D,k,A)=>{const j=$.push([D,k,A]);return(0,r.$Oc)(j)}}if(i in o)return o[i];const n=s.value;let a=n[i];return typeof a!="function"||(a=a.bind(n),o[i]=a),a},set(o,i,n){return s.value[i]=n,!0},getPrototypeOf(o){return f.prototype}})}else return this.j(f,u,p)}u(l,f){if(f&&console.warn(l),this.g)throw new Error(l)}}e.$8p=v;var d;(function(m){m[m.None=0]="None",m[m.Creation=1]="Creation",m[m.Invocation=2]="Invocation",m[m.Branch=3]="Branch"})(d||(d={}));class g{static traceInvocation(l,f){return l?new g(2,f.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):g.c}static traceCreation(l,f){return l?new g(1,f.name):g.c}constructor(l,f){this.type=l,this.name=f,this.g=Date.now(),this.h=[]}branch(l,f){const u=new g(3,l.toString());return this.h.push([l,f,u]),u}stop(){const l=Date.now()-this.g;g.f+=l;let f=!1;function u(p,h){const t=[],s=new Array(p+1).join("	");for(const[o,i,n]of h.h)if(i&&n){f=!0,t.push(`${s}CREATES -> ${o}`);const a=u(p+1,n);a&&t.push(a)}else t.push(`${s}uses -> ${o}`);return t.join(`
`)}const c=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${u(1,this)}`,`DONE, took ${l.toFixed(2)}ms (grand total ${g.f.toFixed(2)}ms)`];(l>2||f)&&g.all.add(c.join(`
`))}}e.$9p=g,g.all=new Set,g.c=new class extends g{constructor(){super(0,null)}stop(){}branch(){return this}},g.f=0}),define(we[222],pe([1,0,6]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Verbosity=e.$Ru=void 0,e.$Ru=(0,y.$Lh)("labelService");var R;(function(r){r[r.SHORT=0]="SHORT",r[r.MEDIUM=1]="MEDIUM",r[r.LONG=2]="LONG"})(R||(e.Verbosity=R={}))});var Ae=this&&this.__param||function(le,e){return function(y,R){e(y,R,le)}};define(we[83],pe([1,0,20,2,3,189,30,6]),function(le,e,y,R,r,P,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lq=e.$Kq=e.$Jq=void 0;function w(C){return C.tags.find(E=>E.startsWith("lp-"))?.split("lp-")[1]}e.$Jq=w,e.$Kq=(0,I.$Lh)("languagePackService");let b=class extends R.$Qc{constructor(E){super(),this.c=E}async getAvailableLanguages(){const E=new y.$Vd;setTimeout(()=>E.cancel(),1e3);let v;try{v=await this.c.query({text:'category:"language packs"',pageSize:20},E.token)}catch{return[]}const g=v.firstPage.filter(m=>m.properties.localizedLanguages?.length&&m.tags.some(l=>l.startsWith("lp-"))).map(m=>{const l=m.properties.localizedLanguages?.[0],f=w(m);return{...this.f(f,l,m),extensionId:m.identifier.id,galleryExtension:m}});return g.push(this.f("en","English")),g}f(E,v,d){const g=v??E;let m;if(g!==E&&(m=`(${E})`),E.toLowerCase()===r.$q.toLowerCase()&&(m??(m=""),m+=(0,P.localize)(0,null)),d?.installCount){m??(m="");const l=d.installCount;let f;l>1e6?f=`${Math.floor(l/1e5)/10}M`:l>1e3?f=`${Math.floor(l/1e3)}K`:f=String(l),m+=` $(cloud-download) ${f}`}return{id:E,label:g,description:m}}};e.$Lq=b,e.$Lq=b=Oe([Ae(0,L.$2n)],b)}),define(we[13],pe([1,0,39,5,61,2,26,3,19,8,4,66,6]),function(le,e,y,R,r,P,L,I,w,b,C,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=e.$$i=e.log=e.$9i=e.LogLevel=e.$8i=e.$7i=e.$6i=void 0,e.$6i=(0,v.$Lh)("logService"),e.$7i=(0,v.$Lh)("loggerService");function d(){return new Date().toISOString()}function g(D){return(0,b.$Af)(D)}e.$8i=g;var m;(function(D){D[D.Off=0]="Off",D[D.Trace=1]="Trace",D[D.Debug=2]="Debug",D[D.Info=3]="Info",D[D.Warning=4]="Warning",D[D.Error=5]="Error"})(m||(e.LogLevel=m={})),e.$9i=m.Info;function l(D,k,A){switch(k){case m.Trace:D.trace(A);break;case m.Debug:D.debug(A);break;case m.Info:D.info(A);break;case m.Warning:D.warn(A);break;case m.Error:D.error(A);break;case m.Off:break;default:throw new Error(`Invalid log level ${k}`)}}e.log=l;function f(D,k=!1){let A="";for(let j=0;j<D.length;j++){let Z=D[j];if(Z instanceof Error&&(Z=(0,y.$wi)(Z,k)),typeof Z=="object")try{Z=JSON.stringify(Z)}catch{}A+=(j>0?" ":"")+Z}return A}class u extends P.$Qc{constructor(){super(...arguments),this.b=e.$9i,this.c=this.B(new R.$Ld),this.onDidChangeLogLevel=this.c.event}setLevel(k){this.b!==k&&(this.b=k,this.c.fire(this.b))}getLevel(){return this.b}f(k){return this.b!==m.Off&&this.b<=k}}e.$$i=u;class c extends u{constructor(k){super(),this.h=k}f(k){return this.h||super.f(k)}trace(k,...A){this.f(m.Trace)&&this.g(m.Trace,f([k,...A],!0))}debug(k,...A){this.f(m.Debug)&&this.g(m.Debug,f([k,...A]))}info(k,...A){this.f(m.Info)&&this.g(m.Info,f([k,...A]))}warn(k,...A){this.f(m.Warning)&&this.g(m.Warning,f([k,...A]))}error(k,...A){if(this.f(m.Error))if(k instanceof Error){const j=Array.prototype.slice.call(arguments);j[0]=k.stack,this.g(m.Error,f(j))}else this.g(m.Error,f([k,...A]))}flush(){}}e.$_i=c;class p extends u{constructor(k=e.$9i){super(),this.setLevel(k),this.g=!I.$d}trace(k,...A){this.f(m.Trace)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,k,...A):console.log(`[main ${d()}]`,k,...A))}debug(k,...A){this.f(m.Debug)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,k,...A):console.log(`[main ${d()}]`,k,...A))}info(k,...A){this.f(m.Info)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,k,...A):console.log(`[main ${d()}]`,k,...A))}warn(k,...A){this.f(m.Warning)&&(this.g?console.warn(`\x1B[93m[main ${d()}]\x1B[0m`,k,...A):console.warn(`[main ${d()}]`,k,...A))}error(k,...A){this.f(m.Error)&&(this.g?console.error(`\x1B[91m[main ${d()}]\x1B[0m`,k,...A):console.error(`[main ${d()}]`,k,...A))}dispose(){}flush(){}}e.$aj=p;class h extends u{constructor(k=e.$9i,A=!0){super(),this.g=A,this.setLevel(k)}trace(k,...A){this.f(m.Trace)&&(this.g?console.log("%cTRACE","color: #888",k,...A):console.log(k,...A))}debug(k,...A){this.f(m.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",k,...A):console.log(k,...A))}info(k,...A){this.f(m.Info)&&(this.g?console.log("%c INFO","color: #33f",k,...A):console.log(k,...A))}warn(k,...A){this.f(m.Warning)&&(this.g?console.log("%c WARN","color: #993",k,...A):console.log(k,...A))}error(k,...A){this.f(m.Error)&&(this.g?console.log("%c  ERR","color: #f33",k,...A):console.error(k,...A))}dispose(){}flush(){}}e.$bj=h;class t extends u{constructor(k,A=e.$9i){super(),this.g=k,this.setLevel(A)}trace(k,...A){this.f(m.Trace)&&this.g.log(m.Trace,[this.h(k),...A])}debug(k,...A){this.f(m.Debug)&&this.g.log(m.Debug,[this.h(k),...A])}info(k,...A){this.f(m.Info)&&this.g.log(m.Info,[this.h(k),...A])}warn(k,...A){this.f(m.Warning)&&this.g.log(m.Warning,[this.h(k),...A])}error(k,...A){this.f(m.Error)&&this.g.log(m.Error,[this.h(k),...A])}h(k){return typeof k=="string"?k:(0,y.$wi)(k,this.f(m.Trace))}dispose(){}flush(){}}e.$cj=t;class s extends u{constructor(k){super(),this.g=k,k.length&&this.setLevel(k[0].getLevel())}setLevel(k){for(const A of this.g)A.setLevel(k);super.setLevel(k)}trace(k,...A){for(const j of this.g)j.trace(k,...A)}debug(k,...A){for(const j of this.g)j.debug(k,...A)}info(k,...A){for(const j of this.g)j.info(k,...A)}warn(k,...A){for(const j of this.g)j.warn(k,...A)}error(k,...A){for(const j of this.g)j.error(k,...A)}flush(){for(const k of this.g)k.flush()}dispose(){for(const k of this.g)k.dispose()}}e.$dj=s;class o extends P.$Qc{constructor(k,A,j){if(super(),this.h=k,this.j=A,this.b=new L.$yc,this.c=this.B(new R.$Ld),this.onDidChangeLoggers=this.c.event,this.f=this.B(new R.$Ld),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new R.$Ld),this.onDidChangeVisibility=this.g.event,j)for(const Z of j)this.b.set(Z.resource,{logger:void 0,info:Z})}m(k){return(0,b.$wf)(k)?[...this.b.values()].find(A=>A.info.id===k):this.b.get(k)}getLogger(k){return this.m(k)?.logger}createLogger(k,A){const j=this.n(k),Z=(0,b.$wf)(k)?k:A?.id??(0,r.$zi)(j.toString()).toString(16);let ae=this.b.get(j)?.logger;const K=A?.logLevel==="always"?m.Trace:A?.logLevel;ae||(ae=this.s(j,K??this.getLogLevel(j)??this.h,{...A,id:Z}));const se={logger:ae,info:{resource:j,id:Z,logLevel:K,name:A?.name,hidden:A?.hidden,extensionId:A?.extensionId,when:A?.when}};return this.registerLogger(se.info),this.b.set(j,se),ae}n(k){return(0,b.$wf)(k)?(0,w.$sg)(this.j,`${k}.log`):k}setLogLevel(k,A){if(C.URI.isUri(k)){const j=k,Z=A,ae=this.b.get(j);ae&&Z!==ae.info.logLevel&&(ae.info.logLevel=Z===this.h?void 0:Z,ae.logger?.setLevel(Z),this.b.set(ae.info.resource,ae),this.f.fire([j,Z]))}else{this.h=k;for(const[j,Z]of this.b.entries())this.b.get(j)?.info.logLevel===void 0&&Z.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(k,A){const j=this.m(k);j&&A!==!j.info.hidden&&(j.info.hidden=!A,this.b.set(j.info.resource,j),this.g.fire([j.info.resource,A]))}getLogLevel(k){let A;return k&&(A=this.b.get(k)?.info.logLevel),A??this.h}registerLogger(k){const A=this.b.get(k.resource);A?A.info.hidden!==k.hidden&&this.setVisibility(k.resource,!k.hidden):(this.b.set(k.resource,{info:k,logger:void 0}),this.c.fire({added:[k],removed:[]}))}deregisterLogger(k){const A=this.b.get(k);A&&(A.logger&&A.logger.dispose(),this.b.delete(k),this.c.fire({added:[],removed:[A.info]}))}*getRegisteredLoggers(){for(const k of this.b.values())yield k.info}getRegisteredLogger(k){return this.b.get(k)?.info}dispose(){this.b.forEach(k=>k.logger?.dispose()),this.b.clear(),super.dispose()}}e.$ej=o;class i{constructor(){this.onDidChangeLogLevel=new R.$Ld().event}setLevel(k){}getLevel(){return m.Info}trace(k,...A){}debug(k,...A){}info(k,...A){}warn(k,...A){}error(k,...A){}critical(k,...A){}dispose(){}flush(){}}e.$fj=i;class n extends i{}e.$gj=n;function a(D){if(D.verbose)return m.Trace;if(typeof D.logLevel=="string"){const k=S(D.logLevel.toLowerCase());if(k!==void 0)return k}return e.$9i}e.$hj=a;function $(D){switch(D){case m.Trace:return"trace";case m.Debug:return"debug";case m.Info:return"info";case m.Warning:return"warn";case m.Error:return"error";case m.Off:return"off"}}e.$ij=$;function S(D){switch(D){case"trace":return m.Trace;case"debug":return m.Debug;case"info":return m.Info;case"warn":return m.Warning;case"error":return m.Error;case"critical":return m.Error;case"off":return m.Off}}e.$jj=S,e.$kj=new E.$3i("logLevel",$(m.Info))}),define(we[223],pe([1,0,18,14,11,5,2,7,67,13]),function(le,e,y,R,r,P,L,I,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Op=void 0;class C extends L.$Qc{constructor(v,d){super(),this.a=v,this.b=d,this.c=this.B(new P.$Ld),this.onDidChangeFile=this.c.event,this.g=this.B(new P.$Ld),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new R.$Og(0)),this.w=[],this.y=this.B(new R.$Og(0))}watch(v,d){return d.recursive||this.b?.watcher?.forceUniversal?this.n(v,d):this.z(v,d)}n(v,d){const g={path:this.H(v),excludes:d.excludes,includes:d.includes,recursive:d.recursive},m=(0,y.$Sb)(this.j,g);return this.r(),(0,L.$Oc)(()=>{m(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(v=>(0,r.$Y)(v))}s(){this.h||(this.h=this.B(this.t(d=>this.c.fire((0,w.$Kp)(d)),d=>this.G(d),this.a.getLevel()===b.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===b.LogLevel.Trace)})));const v=this.b?.watcher?.recursive?.usePolling;if(v===!0)for(const d of this.j)(0,w.$Gp)(d)&&(d.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(v))for(const d of this.j)(0,w.$Gp)(d)&&v.includes(d.path)&&(d.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(v,d){const g={path:this.H(v),excludes:d.excludes,includes:d.includes,recursive:!1},m=(0,y.$Sb)(this.w,g);return this.C(),(0,L.$Oc)(()=>{m(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(v=>(0,r.$Y)(v))}D(){return this.u||(this.u=this.B(this.F(v=>this.c.fire((0,w.$Kp)(v)),v=>this.G(v),this.a.getLevel()===b.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===b.LogLevel.Trace)}))),this.u.watch(this.w)}G(v){v.type==="error"&&this.g.fire(v.message),this.a[v.type](v.message)}H(v){return(0,I.$fc)(v.fsPath)}}e.$Op=C}),define(we[112],pe([1,0,18,14,15,20,5,61,47,2,63,12,41,19,48,185,16,110,13,11]),function(le,e,y,R,r,P,L,I,w,b,C,E,v,d,g,m,l,f,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fp=void 0;let p=class extends b.$Qc{constructor(t){super(),this.b=t,this.a=256*1024,this.c=this.B(new L.$Ld),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new L.$Ld),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new L.$Ld),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new L.$Ld),this.onDidRunOperation=this.r.event,this.X=this.B(new L.$Ld),this.onDidFilesChange=this.X.event,this.Y=this.B(new L.$Ld),this.onDidWatchError=this.Y.event,this.Z=new Map,this.ab=this.B(new R.$Zg)}registerProvider(t,s){if(this.h.has(t))throw new Error(`A filesystem provider for the scheme '${t}' is already registered.`);(0,v.mark)(`code/registerFilesystem/${t}`);const o=new b.$Pc;return this.h.set(t,s),this.c.fire({added:!0,scheme:t,provider:s}),o.add(s.onDidChangeFile(i=>this.X.fire(new l.$mk(i,!this.S(s))))),typeof s.onDidWatchError=="function"&&o.add(s.onDidWatchError(i=>this.Y.fire(new Error(i)))),o.add(s.onDidChangeCapabilities(()=>this.g.fire({provider:s,scheme:t}))),(0,b.$Oc)(()=>{this.c.fire({added:!1,scheme:t,provider:s}),this.h.delete(t),(0,b.$Lc)(o)})}getProvider(t){return this.h.get(t)}async activateProvider(t){const s=[];this.f.fire({scheme:t,join(o){s.push(o)}}),!this.h.has(t)&&await R.Promises.settled(s)}async canHandleResource(t){return await this.activateProvider(t.scheme),this.hasProvider(t)}hasProvider(t){return this.h.has(t.scheme)}hasCapability(t,s){const o=this.h.get(t.scheme);return!!(o&&o.capabilities&s)}listCapabilities(){return w.Iterable.map(this.h,([t,s])=>({scheme:t,capabilities:s.capabilities}))}async j(t){if(!(0,d.$wg)(t))throw new l.$ok((0,m.localize)(0,null,this.qb(t)),8);await this.activateProvider(t.scheme);const s=this.h.get(t.scheme);if(!s){const o=new c.$_;throw o.message=(0,m.localize)(1,null,t.toString()),o}return s}async m(t){const s=await this.j(t);if((0,l.$_j)(s)||(0,l.$9j)(s)||(0,l.$ak)(s))return s;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(t){const s=await this.j(t);if((0,l.$_j)(s)||(0,l.$9j)(s))return s;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(t,s){try{return await this.s(t,s)}catch(o){throw(0,l.$jk)(o)===l.FileSystemProviderErrorCode.FileNotFound?new l.$ok((0,m.localize)(2,null,this.qb(t)),1):(0,l.$hk)(o)}}async s(t,s){const o=await this.j(t),i=this.S(o),n=s?.resolveTo,a=s?.resolveSingleChildDescendants,$=s?.resolveMetadata,S=await o.stat(t);let D;return this.t(o,t,S,void 0,!!$,(k,A)=>(D||(D=C.$Rh.forUris(()=>!i),D.set(t,!0),n&&D.fill(!0,n)),D.get(k.resource)||D.findSuperstr(k.resource.with({query:null,fragment:null}))?!0:k.isDirectory&&a?A===1:!1))}async t(t,s,o,i,n,a){const{providerExtUri:$}=this.R(t),S={resource:s,name:$.basename(s),isFile:(o.type&l.FileType.File)!==0,isDirectory:(o.type&l.FileType.Directory)!==0,isSymbolicLink:(o.type&l.FileType.SymbolicLink)!==0,mtime:o.mtime,ctime:o.ctime,size:o.size,readonly:!!((o.permissions??0)&l.FilePermission.Readonly)||!!(t.capabilities&2048),locked:!!((o.permissions??0)&l.FilePermission.Locked),etag:(0,l.$zk)({mtime:o.mtime,size:o.size}),children:void 0};if(S.isDirectory&&a(S,i)){try{const D=await t.readdir(s),k=await R.Promises.settled(D.map(async([A,j])=>{try{const Z=$.joinPath(s,A),ae=n?await t.stat(Z):{type:j};return await this.t(t,Z,ae,D.length,n,a)}catch(Z){return this.b.trace(Z),null}}));S.children=(0,y.$Fb)(k)}catch(D){this.b.trace(D),S.children=[]}return S}return S}async resolveAll(t){return R.Promises.settled(t.map(async s=>{try{return{stat:await this.s(s.resource,s.options),success:!0}}catch(o){return this.b.trace(o),{stat:void 0,success:!1}}}))}async stat(t){const s=await this.j(t),o=await s.stat(t);return this.t(s,t,o,void 0,!0,()=>!1)}async exists(t){const s=await this.j(t);try{return!!await s.stat(t)}catch{return!1}}async canCreateFile(t,s){try{await this.u(t,s)}catch(o){return o}return!0}async u(t,s){if(!s?.overwrite&&await this.exists(t))throw new l.$ok((0,m.localize)(3,null,this.qb(t)),3,s)}async createFile(t,s=r.$_d.fromString(""),o){await this.u(t,o);const i=await this.writeFile(t,s);return this.r.fire(new l.$lk(t,0,i)),i}async writeFile(t,s,o){const i=this.ob(await this.n(t),t),{providerExtUri:n}=this.R(i);let a=o;if((0,l.$ck)(i)&&!a?.atomic){const $=i.enforceAtomicWriteFile?.(t);$&&(a={...o,atomic:$})}try{await this.w(i,t,a)||await this.U(i,n.dirname(t));let S;if((0,l.$9j)(i)&&!(s instanceof r.$_d))if((0,g.$Xd)(s)){const D=await(0,g.$5d)(s,3);D.ended?S=r.$_d.concat(D.buffer):S=D}else S=(0,g.$2d)(s,D=>r.$_d.concat(D),3);else S=s;!(0,l.$_j)(i)||(0,l.$9j)(i)&&S instanceof r.$_d||(0,l.$9j)(i)&&(0,l.$ck)(i)&&a?.atomic?await this.fb(i,t,a,S):await this.bb(i,t,a,S instanceof r.$_d?(0,r.$ke)(S):S),this.r.fire(new l.$lk(t,4))}catch($){throw new l.$ok((0,m.localize)(4,null,this.qb(t),(0,l.$hk)($).toString()),(0,l.$kk)($),a)}return this.resolve(t,{resolveMetadata:!0})}async w(t,s,o){const i=!!o?.unlock;if(i&&!(t.capabilities&8192))throw new Error((0,m.localize)(5,null,this.qb(s)));if(!!o?.atomic){if(!(t.capabilities&32768))throw new Error((0,m.localize)(6,null,this.qb(s)));if(!(t.capabilities&2))throw new Error((0,m.localize)(7,null,this.qb(s)));if(i)throw new Error((0,m.localize)(8,null,this.qb(s)))}let a;try{a=await t.stat(s)}catch{return}if(a.type&l.FileType.Directory)throw new l.$ok((0,m.localize)(9,null,this.qb(s)),0,o);if(this.pb(s,a),typeof o?.mtime=="number"&&typeof o.etag=="string"&&o.etag!==l.$yk&&typeof a.mtime=="number"&&typeof a.size=="number"&&o.mtime<a.mtime&&o.etag!==(0,l.$zk)({mtime:o.mtime,size:a.size}))throw new l.$ok((0,m.localize)(10,null),3,o);return a}async readFile(t,s,o){const i=await this.m(t);return s?.atomic?this.z(i,t,s,o):this.C(i,t,s,o)}async z(t,s,o,i){return new Promise((n,a)=>{this.ab.queueFor(s,this.R(t).providerExtUri).queue(async()=>{try{const $=await this.C(t,s,o,i);n($)}catch($){a($)}})})}async C(t,s,o,i){const n=await this.D(t,s,{...o,preferUnbuffered:!0},i);return{...n,value:await(0,r.$le)(n.value)}}async readFileStream(t,s,o){const i=await this.m(t);return this.D(i,t,s,o)}async D(t,s,o,i){const n=new P.$Vd(i);let a=o;(0,l.$bk)(t)&&t.enforceAtomicReadFile?.(s)&&(a={...o,atomic:!0});const $=this.J(s,a).then(D=>D,D=>{throw n.dispose(!0),D});let S;try{return typeof a?.etag=="string"&&a.etag!==l.$yk&&await $,a?.atomic&&(0,l.$bk)(t)||!((0,l.$_j)(t)||(0,l.$ak)(t))||(0,l.$9j)(t)&&a?.preferUnbuffered?S=this.I(t,s,a):(0,l.$ak)(t)?S=this.G(t,s,n.token,a):S=this.H(t,s,n.token,a),S.on("end",()=>n.dispose()),S.on("error",()=>n.dispose()),{...await $,value:S}}catch(D){throw S&&await(0,g.$3d)(S),this.F(D,s,a)}}F(t,s,o){const i=(0,m.localize)(11,null,this.qb(s),(0,l.$hk)(t).toString());return t instanceof l.$qk?new l.$qk(i,t.stat,o):t instanceof l.$pk?new l.$pk(i,t.fileOperationResult,t.size,t.options):new l.$ok(i,(0,l.$kk)(t),o)}G(t,s,o,i=Object.create(null)){const n=t.readFileStream(s,i,o);return(0,g.$9d)(n,{data:a=>a instanceof r.$_d?a:r.$_d.wrap(a),error:a=>this.F(a,s,i)},a=>r.$_d.concat(a))}H(t,s,o,i=Object.create(null)){const n=(0,r.$pe)();return(0,f.$Ep)(t,s,n,a=>a,{...i,bufferSize:this.a,errorTransformer:a=>this.F(a,s,i)},o),n}I(t,s,o){const i=(0,g.$Zd)(n=>r.$_d.concat(n));return(async()=>{try{let n;o?.atomic&&(0,l.$bk)(t)?n=await t.readFile(s,{atomic:!0}):n=await t.readFile(s),typeof o?.position=="number"&&(n=n.slice(o.position)),typeof o?.length=="number"&&(n=n.slice(0,o.length)),this.L(s,n.byteLength,o),i.end(r.$_d.wrap(n))}catch(n){i.error(n),i.end()}})(),i}async J(t,s){const o=await this.resolve(t,{resolveMetadata:!0});if(o.isDirectory)throw new l.$ok((0,m.localize)(12,null,this.qb(t)),0,s);if(typeof s?.etag=="string"&&s.etag!==l.$yk&&s.etag===o.etag)throw new l.$qk((0,m.localize)(13,null),o,s);return this.L(t,o.size,s),o}L(t,s,o){if(typeof o?.limits?.size=="number"&&s>o.limits.size)throw new l.$pk((0,m.localize)(14,null,this.qb(t)),7,s,o)}async canMove(t,s,o){return this.M(t,s,"move",o)}async canCopy(t,s,o){return this.M(t,s,"copy",o)}async M(t,s,o,i){if(t.toString()!==s.toString())try{const n=o==="move"?this.ob(await this.n(t),t):await this.m(t),a=this.ob(await this.n(s),s);await this.Q(n,t,a,s,o,i)}catch(n){return n}return!0}async move(t,s,o){const i=this.ob(await this.n(t),t),n=this.ob(await this.n(s),s),a=await this.N(i,t,n,s,"move",!!o),$=await this.resolve(s,{resolveMetadata:!0});return this.r.fire(new l.$lk(t,a==="move"?2:3,$)),$}async copy(t,s,o){const i=await this.m(t),n=this.ob(await this.n(s),s),a=await this.N(i,t,n,s,"copy",!!o),$=await this.resolve(s,{resolveMetadata:!0});return this.r.fire(new l.$lk(t,a==="copy"?3:2,$)),$}async N(t,s,o,i,n,a){if(s.toString()===i.toString())return n;const{exists:$,isSameResourceWithDifferentPathCase:S}=await this.Q(t,s,o,i,n,a);if($&&!S&&a&&await this.del(i,{recursive:!0}),await this.U(o,this.R(o).providerExtUri.dirname(i)),n==="copy"){if(t===o&&(0,l.$0j)(t))await t.copy(s,i,{overwrite:a});else{const D=await this.resolve(s);D.isDirectory?await this.P(t,D,o,i):await this.O(t,s,o,i)}return n}else return t===o?(await t.rename(s,i,{overwrite:a}),n):(await this.N(t,s,o,i,"copy",a),await this.del(s,{recursive:!0}),"copy")}async O(t,s,o,i){if((0,l.$_j)(t)&&(0,l.$_j)(o))return this.hb(t,s,o,i);if((0,l.$_j)(t)&&(0,l.$9j)(o))return this.nb(t,s,o,i);if((0,l.$9j)(t)&&(0,l.$_j)(o))return this.lb(t,s,o,i);if((0,l.$9j)(t)&&(0,l.$9j)(o))return this.jb(t,s,o,i)}async P(t,s,o,i){await o.mkdir(i),Array.isArray(s.children)&&await R.Promises.settled(s.children.map(async n=>{const a=this.R(o).providerExtUri.joinPath(i,n.name);return n.isDirectory?this.P(t,await this.resolve(n.resource),o,a):this.O(t,n.resource,o,a)}))}async Q(t,s,o,i,n,a){let $=!1;if(t===o){const{providerExtUri:D,isPathCaseSensitive:k}=this.R(t);if(k||($=D.isEqual(s,i)),$&&n==="copy")throw new Error((0,m.localize)(15,null,this.qb(s),this.qb(i)));if(!$&&D.isEqualOrParent(i,s))throw new Error((0,m.localize)(16,null,this.qb(s),this.qb(i)))}const S=await this.exists(i);if(S&&!$){if(!a)throw new l.$ok((0,m.localize)(17,null,this.qb(s),this.qb(i)),4);if(t===o){const{providerExtUri:D}=this.R(t);if(D.isEqualOrParent(s,i))throw new Error((0,m.localize)(18,null,this.qb(s),this.qb(i)))}}return{exists:S,isSameResourceWithDifferentPathCase:$}}R(t){const s=this.S(t);return{providerExtUri:s?d.$ig:d.$kg,isPathCaseSensitive:s}}S(t){return!!(t.capabilities&1024)}async createFolder(t){const s=this.ob(await this.j(t),t);await this.U(s,t);const o=await this.resolve(t,{resolveMetadata:!0});return this.r.fire(new l.$lk(t,0,o)),o}async U(t,s){const o=[],{providerExtUri:i}=this.R(t);for(;!i.isEqual(s,i.dirname(s));)try{if(!((await t.stat(s)).type&l.FileType.Directory))throw new Error((0,m.localize)(19,null,this.qb(s)));break}catch(n){if((0,l.$jk)(n)!==l.FileSystemProviderErrorCode.FileNotFound)throw n;o.push(i.basename(s)),s=i.dirname(s)}for(let n=o.length-1;n>=0;n--){s=i.joinPath(s,o[n]);try{await t.mkdir(s)}catch(a){if((0,l.$jk)(a)!==l.FileSystemProviderErrorCode.FileExists)throw a}}}async canDelete(t,s){try{await this.W(t,s)}catch(o){return o}return!0}async W(t,s){const o=this.ob(await this.j(t),t),i=!!s?.useTrash;if(i&&!(o.capabilities&4096))throw new Error((0,m.localize)(20,null,this.qb(t)));const n=s?.atomic;if(n&&!(o.capabilities&65536))throw new Error((0,m.localize)(21,null,this.qb(t)));if(i&&n)throw new Error((0,m.localize)(22,null,this.qb(t)));let a;try{a=await o.stat(t)}catch{}if(a)this.pb(t,a);else throw new l.$ok((0,m.localize)(23,null,this.qb(t)),1);if(!!!s?.recursive){const S=await this.resolve(t);if(S.isDirectory&&Array.isArray(S.children)&&S.children.length>0)throw new Error((0,m.localize)(24,null,this.qb(t)))}return o}async del(t,s){const o=await this.W(t,s);let i=s;if((0,l.$dk)(o)&&!i?.atomic){const S=o.enforceAtomicDelete?.(t);S&&(i={...s,atomic:S})}const n=!!i?.useTrash,a=!!i?.recursive,$=i?.atomic??!1;await o.delete(t,{recursive:a,useTrash:n,atomic:$}),this.r.fire(new l.$lk(t,1))}async cloneFile(t,s){const o=await this.j(t),i=this.ob(await this.n(s),s);if(o===i&&this.R(o).providerExtUri.isEqual(t,s))return;if(o===i&&(0,l.$$j)(o))return o.cloneFile(t,s);await this.U(i,this.R(i).providerExtUri.dirname(s));const n=this.ab.queueFor(t,this.R(o).providerExtUri);return o===i&&(0,l.$0j)(o)?n.queue(()=>o.copy(t,s,{overwrite:!0})):n.queue(()=>this.O(o,t,i,s))}watch(t,s={recursive:!1,excludes:[]}){const o=new b.$Pc;let i=!1,n=()=>{i=!0};return o.add((0,b.$Oc)(()=>n())),(async()=>{try{const a=await this.$(t,s);i?(0,b.$Lc)(a):n=()=>(0,b.$Lc)(a)}catch(a){this.b.error(a)}})(),o}async $(t,s){const o=await this.j(t),i=(0,I.$zi)([this.R(o).providerExtUri.getComparisonKey(t),s]);let n=this.Z.get(i);return n||(n={count:0,disposable:o.watch(t,s)},this.Z.set(i,n)),n.count+=1,(0,b.$Oc)(()=>{n&&(n.count--,n.count===0&&((0,b.$Lc)(n.disposable),this.Z.delete(i)))})}dispose(){super.dispose();for(const[,t]of this.Z)(0,b.$Lc)(t.disposable);this.Z.clear()}async bb(t,s,o,i){return this.ab.queueFor(s,this.R(t).providerExtUri).queue(async()=>{const n=await t.open(s,{create:!0,unlock:o?.unlock??!1});try{(0,g.$Xd)(i)||(0,g.$Yd)(i)?await this.cb(t,n,i):await this.db(t,n,i)}catch(a){throw(0,l.$hk)(a)}finally{await t.close(n)}})}async cb(t,s,o){let i=0,n;if((0,g.$Yd)(o)){if(o.buffer.length>0){const a=r.$_d.concat(o.buffer);await this.eb(t,s,a,a.byteLength,i,0),i+=a.byteLength}if(o.ended)return;n=o.stream}else n=o;return new Promise((a,$)=>{(0,g.$4d)(n,{onData:async S=>{n.pause();try{await this.eb(t,s,S,S.byteLength,i,0)}catch(D){return $(D)}i+=S.byteLength,setTimeout(()=>n.resume())},onError:S=>$(S),onEnd:()=>a()})})}async db(t,s,o){let i=0,n;for(;(n=o.read())!==null;)await this.eb(t,s,n,n.byteLength,i,0),i+=n.byteLength}async eb(t,s,o,i,n,a){let $=0;for(;$<i;){const S=await t.write(s,n+$,o.buffer,a+$,i-$);$+=S}}async fb(t,s,o,i){return this.ab.queueFor(s,this.R(t).providerExtUri).queue(()=>this.gb(t,s,o,i))}async gb(t,s,o,i){let n;i instanceof r.$_d?n=i:(0,g.$Xd)(i)?n=await(0,r.$le)(i):(0,g.$Yd)(i)?n=await(0,r.$me)(i):n=(0,r.$je)(i),await t.writeFile(s,n.buffer,{create:!0,overwrite:!0,unlock:o?.unlock??!1,atomic:o?.atomic??!1})}async hb(t,s,o,i){return this.ab.queueFor(i,this.R(o).providerExtUri).queue(()=>this.ib(t,s,o,i))}async ib(t,s,o,i){let n,a;try{n=await t.open(s,{create:!1}),a=await o.open(i,{create:!0,unlock:!1});const $=r.$_d.alloc(this.a);let S=0,D=0,k=0;do k=await t.read(n,S,$.buffer,D,$.byteLength-D),await this.eb(o,a,$,k,S,D),S+=k,D+=k,D===$.byteLength&&(D=0);while(k>0)}catch($){throw(0,l.$hk)($)}finally{await R.Promises.settled([typeof n=="number"?t.close(n):Promise.resolve(),typeof a=="number"?o.close(a):Promise.resolve()])}}async jb(t,s,o,i){return this.ab.queueFor(i,this.R(o).providerExtUri).queue(()=>this.kb(t,s,o,i))}async kb(t,s,o,i){return o.writeFile(i,await t.readFile(s),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async lb(t,s,o,i){return this.ab.queueFor(i,this.R(o).providerExtUri).queue(()=>this.mb(t,s,o,i))}async mb(t,s,o,i){const n=await o.open(i,{create:!0,unlock:!1});try{const a=await t.readFile(s);await this.eb(o,n,r.$_d.wrap(a),a.byteLength,0,0)}catch(a){throw(0,l.$hk)(a)}finally{await o.close(n)}}async nb(t,s,o,i){const n=await(0,r.$le)(this.H(t,s,P.CancellationToken.None));await this.fb(o,i,void 0,n)}ob(t,s){if(t.capabilities&2048)throw new l.$ok((0,m.localize)(25,null,this.qb(s)),6);return t}pb(t,s){if((s.permissions??0)&l.FilePermission.Readonly)throw new l.$ok((0,m.localize)(26,null,this.qb(t)),6)}qb(t){return t.scheme===E.Schemas.file?t.fsPath:t.toString(!0)}};e.$Fp=p,e.$Fp=p=Oe([Ae(0,u.$6i)],p)}),define(we[68],pe([1,0,29,299,14,26,15,5,38,2,7,3,19,48,21,188,16,110,223,39,221,220]),function(le,e,y,R,r,P,L,I,w,b,C,E,v,d,g,m,l,f,u,c,p,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5p=void 0,(()=>{try{(0,R.gracefulify)(y)}catch(s){console.error(`Error enabling graceful-fs: ${(0,c.$wi)(s)}`)}})();class t extends u.$Op{constructor(o,i){super(o,i),this.onDidChangeCapabilities=I.Event.None,this.N=new P.$yc(n=>v.$jg.getComparisonKey(n)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,E.$f&&(this.J|=1024)),this.J}async stat(o){try{const{stat:i,symbolicLink:n}=await g.SymlinkSupport.stat(this.H(o));return{type:this.M(i,n),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:l.FilePermission.Locked}}catch(i){throw this.fb(i)}}async L(o){try{return await this.stat(o)}catch{return}}async readdir(o){try{const i=await g.Promises.readdir(this.H(o),{withFileTypes:!0}),n=[];return await Promise.all(i.map(async a=>{try{let $;a.isSymbolicLink()?$=(await this.stat((0,v.$sg)(o,a.name))).type:$=this.M(a),n.push([a.name,$])}catch($){this.a.trace($)}})),n}catch(i){throw this.fb(i)}}M(o,i){let n;return i?.dangling?n=l.FileType.Unknown:o.isFile()?n=l.FileType.File:o.isDirectory()?n=l.FileType.Directory:n=l.FileType.Unknown,i&&(n|=l.FileType.SymbolicLink),n}async O(o){const i=this.H(o);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let n;for(;n=this.N.get(o);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await n.wait();const a=new r.$Pg;return this.N.set(o,a),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,b.$Oc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.N.get(o)===a&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.N.delete(o)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),a.open()})}async readFile(o,i){let n;try{i?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(o)})`),n=await this.O(o));const a=this.H(o);return await g.Promises.readFile(a)}catch(a){throw this.fb(a)}finally{n?.dispose()}}P(o){t.I&&this.a.trace(o)}readFileStream(o,i,n){const a=(0,d.$Zd)($=>L.$_d.concat($.map(S=>L.$_d.wrap(S))).buffer);return(0,f.$Ep)(this,o,a,$=>$.buffer,{...i,bufferSize:256*1024},n),a}async writeFile(o,i,n){return n?.atomic!==!1&&n?.atomic?.postfix&&await this.Q(o)?this.R(o,(0,v.$sg)((0,v.$rg)(o),`${(0,v.$pg)(o)}${n.atomic.postfix}`),i,n):this.S(o,i,n)}async Q(o){try{const i=this.H(o),{symbolicLink:n}=await g.SymlinkSupport.stat(i);if(n)return!1}catch{}return!0}async R(o,i,n,a){const $=new b.$Pc;try{$.add(await this.O(o)),$.add(await this.O(i)),await this.S(i,n,a,!0);try{await this.rename(i,o,{overwrite:!0})}catch(S){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw S}}finally{$.dispose()}}async S(o,i,n,a){let $;try{const S=this.H(o);if(!n.create||!n.overwrite){if(await g.Promises.exists(S)){if(!n.overwrite)throw(0,l.$gk)((0,m.localize)(0,null),l.FileSystemProviderErrorCode.FileExists)}else if(!n.create)throw(0,l.$gk)((0,m.localize)(1,null),l.FileSystemProviderErrorCode.FileNotFound)}$=await this.open(o,{create:!0,unlock:n.unlock},a),await this.write($,0,i,0,i.byteLength)}catch(S){throw await this.gb(o,S)}finally{typeof $=="number"&&await this.close($)}}static configureFlushOnWrite(o){t.Y=o}async open(o,i,n){const a=this.H(o);let $;(0,l.$8j)(i)&&!n&&($=await this.O(o));let S;try{if((0,l.$8j)(i)&&i.unlock)try{const{stat:k}=await g.SymlinkSupport.stat(a);k.mode&128||await g.Promises.chmod(a,k.mode|128)}catch(k){k.code!=="ENOENT"&&this.a.trace(k)}let D;if((0,l.$8j)(i)){if(E.$d)try{await g.Promises.truncate(a,0),D="r+"}catch(k){k.code!=="ENOENT"&&this.a.trace(k)}D||(D="w")}else D="r";S=await g.Promises.open(a,D)}catch(D){throw $?.dispose(),(0,l.$8j)(i)?await this.gb(o,D):this.fb(D)}if(this.U.set(S,0),(0,l.$8j)(i)&&this.X.set(S,o),$){const D=this.W.get(S);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${S} (${a})`),this.W.set(S,$),D&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${S} (${a})`),D.dispose())}return S}async close(o){const i=this.W.get(o);try{if(this.U.delete(o),this.X.delete(o)&&t.Y)try{await g.Promises.fdatasync(o)}catch(n){t.configureFlushOnWrite(!1),this.a.error(n)}return await g.Promises.close(o)}catch(n){throw this.fb(n)}finally{i&&(this.W.get(o)===i&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${o}`),this.W.delete(o)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${o}`),i.dispose())}}async read(o,i,n,a,$){const S=this.Z(o,i);let D=null;try{D=(await g.Promises.read(o,n,a,$,S)).bytesRead}catch(k){throw this.fb(k)}finally{this.$(o,S,D)}return D}Z(o,i){return i===this.U.get(o)?null:i}$(o,i,n){const a=this.U.get(o);typeof a=="number"&&(typeof i=="number"||(typeof n=="number"?this.U.set(o,a+n):this.U.delete(o)))}async write(o,i,n,a,$){return(0,r.$9g)(()=>this.ab(o,i,n,a,$),100,3)}async ab(o,i,n,a,$){const S=this.Z(o,i);let D=null;try{D=(await g.Promises.write(o,n,a,$,S)).bytesWritten}catch(k){throw await this.gb(this.X.get(o),k)}finally{this.$(o,S,D)}return D}async mkdir(o){try{await g.Promises.mkdir(this.H(o))}catch(i){throw this.fb(i)}}async delete(o,i){try{const n=this.H(o);if(i.recursive){let a;i?.atomic!==!1&&i.atomic.postfix&&(a=(0,C.$hc)((0,C.$kc)(n),`${(0,C.$lc)(n)}${i.atomic.postfix}`)),await g.Promises.rm(n,g.RimRafMode.MOVE,a)}else try{await g.Promises.unlink(n)}catch(a){if(a.code==="EPERM"||a.code==="EISDIR"){let $=!1;try{const{stat:S,symbolicLink:D}=await g.SymlinkSupport.stat(n);$=S.isDirectory()&&!D}catch{}if($)await g.Promises.rmdir(n);else throw a}else throw a}}catch(n){throw this.fb(n)}}async rename(o,i,n){const a=this.H(o),$=this.H(i);if(a!==$)try{await this.bb(o,i,"move",n.overwrite),await g.Promises.rename(a,$)}catch(S){throw(S.code==="EINVAL"||S.code==="EBUSY"||S.code==="ENAMETOOLONG")&&(S=new Error((0,m.localize)(2,null,(0,C.$lc)(a),(0,C.$lc)((0,C.$kc)($)),S.toString()))),this.fb(S)}}async copy(o,i,n){const a=this.H(o),$=this.H(i);if(a!==$)try{await this.bb(o,i,"copy",n.overwrite),await g.Promises.copy(a,$,{preserveSymlinks:!0})}catch(S){throw(S.code==="EINVAL"||S.code==="EBUSY"||S.code==="ENAMETOOLONG")&&(S=new Error((0,m.localize)(3,null,(0,C.$lc)(a),(0,C.$lc)((0,C.$kc)($)),S.toString()))),this.fb(S)}}async bb(o,i,n,a){const $=this.H(o),S=this.H(i);let D=!1;if(!!(this.capabilities&1024)||(D=(0,w.$Uf)($,S,!0)),D){if(n==="copy")throw(0,l.$gk)((0,m.localize)(4,null),l.FileSystemProviderErrorCode.FileExists);if(n==="move")return}const A=await this.L(o);if(!A)throw(0,l.$gk)((0,m.localize)(5,null),l.FileSystemProviderErrorCode.FileNotFound);const j=await this.L(i);if(j){if(!a)throw(0,l.$gk)((0,m.localize)(6,null),l.FileSystemProviderErrorCode.FileExists);A.type&l.FileType.File&&j.type&l.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(o,i){return this.cb(o,i,!1)}async cb(o,i,n){const a=this.H(o),$=this.H(i),S=!!(this.capabilities&1024);if((0,w.$Uf)(a,$,!S))return;const D=new b.$Pc;try{D.add(await this.O(o)),D.add(await this.O(i)),n&&await g.Promises.mkdir((0,C.$kc)($),{recursive:!0}),await g.Promises.copyFile(a,$)}catch(k){if(k.code==="ENOENT"&&!n)return this.cb(o,i,!0);throw this.fb(k)}finally{D.dispose()}}t(o,i,n){return new p.$Vp(a=>o(a),a=>i(a),n)}F(o,i,n){return new h.$4p(a=>o(a),a=>i(a),n)}fb(o){if(o instanceof l.$fk)return o;let i=o,n;switch(o.code){case"ENOENT":n=l.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=l.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=l.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=l.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=l.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${o.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,n=l.FileSystemProviderErrorCode.Unknown;break;default:n=l.FileSystemProviderErrorCode.Unknown}return(0,l.$gk)(i,n)}async gb(o,i){let n=this.fb(i);if(o&&n.code===l.FileSystemProviderErrorCode.NoPermissions)try{const{stat:a}=await g.SymlinkSupport.stat(this.H(o));a.mode&128||(n=(0,l.$gk)(i,l.FileSystemProviderErrorCode.FileWriteLocked))}catch(a){this.a.trace(a)}return n}}e.$5p=t,t.I=!1,t.Y=!0}),define(we[224],pe([1,0,5,68,2,15,48,20]),function(le,e,y,R,r,P,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Br=e.$Ar=void 0;class w extends r.$Qc{constructor(E,v){super(),this.a=E,this.b=v,this.F=new Map,this.G=new Map}call(E,v,d){const g=this.c(E);switch(v){case"stat":return this.g(g,d[0]);case"readdir":return this.h(g,d[0]);case"open":return this.r(g,d[0],d[1]);case"close":return this.s(d[0]);case"read":return this.t(d[0],d[1],d[2]);case"readFile":return this.j(g,d[0],d[1]);case"write":return this.u(d[0],d[1],d[2],d[3],d[4]);case"writeFile":return this.n(g,d[0],d[1],d[2]);case"rename":return this.z(g,d[0],d[1],d[2]);case"copy":return this.C(g,d[0],d[1],d[2]);case"cloneFile":return this.D(g,d[0],d[1]);case"mkdir":return this.w(g,d[0]);case"delete":return this.y(g,d[0],d[1]);case"watch":return this.I(g,d[0],d[1],d[2],d[3]);case"unwatch":return this.J(d[0],d[1])}throw new Error(`IPC Command ${v} not found`)}listen(E,v,d){const g=this.c(E);switch(v){case"fileChange":return this.H(g,d[0]);case"readFileStream":return this.m(g,d[0],d[1])}throw new Error(`Unknown event ${v}`)}g(E,v){const d=this.f(E,v,!0);return this.a.stat(d)}h(E,v){const d=this.f(E,v);return this.a.readdir(d)}async j(E,v,d){const g=this.f(E,v,!0),m=await this.a.readFile(g,d);return P.$_d.wrap(m)}m(E,v,d){const g=this.f(E,v,!0),m=new I.$Vd,l=new y.$Ld({onDidRemoveLastListener:()=>{m.cancel()}}),f=this.a.readFileStream(g,d,m.token);return(0,L.$4d)(f,{onData:u=>l.fire(P.$_d.wrap(u)),onError:u=>l.fire(u),onEnd:()=>{l.fire("end"),l.dispose(),m.dispose()}}),l.event}n(E,v,d,g){const m=this.f(E,v);return this.a.writeFile(m,d.buffer,g)}r(E,v,d){const g=this.f(E,v,!0);return this.a.open(g,d)}s(E){return this.a.close(E)}async t(E,v,d){const g=P.$_d.alloc(d),m=0,l=await this.a.read(E,v,g.buffer,m,d);return[g,l]}u(E,v,d,g,m){return this.a.write(E,v,d.buffer,g,m)}w(E,v){const d=this.f(E,v);return this.a.mkdir(d)}y(E,v,d){const g=this.f(E,v);return this.a.delete(g,d)}z(E,v,d,g){const m=this.f(E,v),l=this.f(E,d);return this.a.rename(m,l,g)}C(E,v,d,g){const m=this.f(E,v),l=this.f(E,d);return this.a.copy(m,l,g)}D(E,v,d){const g=this.f(E,v),m=this.f(E,d);return this.a.cloneFile(g,m)}H(E,v){const d=new y.$Ld({onWillAddFirstListener:()=>{this.F.set(v,this.L(E,d))},onDidRemoveLastListener:()=>{(0,r.$Lc)(this.F.get(v)),this.F.delete(v)}});return d.event}async I(E,v,d,g,m){const l=this.F.get(v);if(l){const f=this.f(E,g),u=l.watch(d,f,m);this.G.set(v+d,u)}}async J(E,v){const d=E+v,g=this.G.get(d);g&&((0,r.$Lc)(g),this.G.delete(d))}dispose(){super.dispose();for(const[,E]of this.G)E.dispose();this.G.clear();for(const[,E]of this.F)E.dispose();this.F.clear()}}e.$Ar=w;class b extends r.$Qc{constructor(E,v,d,g){super(),this.c=E,this.f=d,this.g=g,this.a=new Map,this.b=this.B(new R.$5p(this.f,{watcher:{recursive:this.j(this.g)}})),this.h(v)}h(E){const v=this.B(new y.$Ld);this.B(v.event(d=>{E.fire(d.map(g=>({resource:this.c.transformOutgoingURI(g.resource),type:g.type})))})),this.B(this.b.onDidChangeFile(d=>v.fire(d))),this.B(this.b.onDidWatchError(d=>E.fire(d)))}j(E){}m(E){}watch(E,v,d){const g=this.m(this.g);return Array.isArray(g)&&(d.excludes=[...d.excludes,...g]),this.a.set(E,this.b.watch(v,d)),(0,r.$Oc)(()=>{(0,r.$Lc)(this.a.get(E)),this.a.delete(E)})}dispose(){for(const[,E]of this.a)E.dispose();this.a.clear(),super.dispose()}}e.$Br=b}),define(we[113],pe([1,0,4,5,13,2]),function(le,e,y,R,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5q=e.$4q=e.$3q=void 0;class L extends r.$ej{constructor(E,v,d,g,m){super(v,d,g),this.r=E,this.t=m,this.B(m.listen("onDidChangeLogLevel",E)(l=>{(0,r.$8i)(l)?super.setLogLevel(l):super.setLogLevel(y.URI.revive(l[0]),l[1])})),this.B(m.listen("onDidChangeVisibility",E)(([l,f])=>super.setVisibility(y.URI.revive(l),f))),this.B(m.listen("onDidChangeLoggers",E)(({added:l,removed:f})=>{for(const u of l)super.registerLogger({...u,resource:y.URI.revive(u.resource)});for(const u of f)super.deregisterLogger(u.resource)}))}createConsoleMainLogger(){return new r.$cj({log:(E,v)=>{this.t.call("consoleLog",[E,v])}})}registerLogger(E){super.registerLogger(E),this.t.call("registerLogger",[E,this.r])}deregisterLogger(E){super.deregisterLogger(E),this.t.call("deregisterLogger",[E,this.r])}setLogLevel(E,v){super.setLogLevel(E,v),this.t.call("setLogLevel",[E,v])}setVisibility(E,v){super.setVisibility(E,v),this.t.call("setVisibility",[this.n(E),v])}s(E,v,d){return new I(this.t,E,v,d,this.r)}static setLogLevel(E,v,d){return E.call("setLogLevel",[v,d])}}e.$3q=L;class I extends r.$_i{constructor(E,v,d,g,m){super(g?.logLevel==="always"),this.r=E,this.s=v,this.m=!1,this.n=[],this.setLevel(d),this.r.call("createLogger",[v,g,m]).then(()=>{this.u(this.n),this.m=!0})}g(E,v){const d=[[E,v]];this.m?this.u(d):this.n.push(...d)}u(E){this.r.call("log",[this.s,E])}}class w{constructor(E,v){this.a=E,this.b=v}listen(E,v){const d=this.b(E);switch(v){case"onDidChangeLoggers":return R.Event.map(this.a.onDidChangeLoggers,g=>({added:[...g.added].map(m=>this.c(m,d)),removed:[...g.removed].map(m=>this.c(m,d))}));case"onDidChangeVisibility":return R.Event.map(this.a.onDidChangeVisibility,g=>[d.transformOutgoingURI(g[0]),g[1]]);case"onDidChangeLogLevel":return R.Event.map(this.a.onDidChangeLogLevel,g=>(0,r.$8i)(g)?g:[d.transformOutgoingURI(g[0]),g[1]])}throw new Error(`Event not found: ${v}`)}async call(E,v,d){const g=this.b(E);switch(v){case"setLogLevel":return(0,r.$8i)(d[0])?this.a.setLogLevel(d[0]):this.a.setLogLevel(y.URI.revive(g.transformIncoming(d[0][0])),d[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(m=>this.c(m,g)))}throw new Error(`Call not found: ${v}`)}c(E,v){return{...E,resource:v.transformOutgoingURI(E.resource)}}}e.$4q=w;class b extends P.$Qc{constructor(E,v){super(),v.call("setLogLevel",[E.getLogLevel()]),this.B(E.onDidChangeLogLevel(d=>v.call("setLogLevel",[d]))),v.call("getRegisteredLoggers").then(d=>{for(const g of d)E.registerLogger({...g,resource:y.URI.revive(g.resource)})}),this.B(v.listen("onDidChangeVisibility")(([d,g])=>E.setVisibility(y.URI.revive(d),g))),this.B(v.listen("onDidChangeLoggers")(({added:d,removed:g})=>{for(const m of d)E.registerLogger({...m,resource:y.URI.revive(m.resource)});for(const m of g)E.deregisterLogger(m.resource)}))}}e.$5q=b}),define(we[114],pe([1,0,2,13]),function(le,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vN=void 0;class r extends y.$Qc{constructor(L,I=[]){super(),this.a=new R.$dj([L,...I]),this.B(L.onDidChangeLogLevel(w=>this.setLevel(w)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(L){this.a.setLevel(L)}getLevel(){return this.a.getLevel()}trace(L,...I){this.a.trace(L,...I)}debug(L,...I){this.a.debug(L,...I)}info(L,...I){this.a.info(L,...I)}warn(L,...I){this.a.warn(L,...I)}error(L,...I){this.a.error(L,...I)}flush(){this.a.flush()}}e.$vN=r}),define(we[225],pe([1,0,16,13]),function(le,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kN=void 0;var r;(function(b){b[b.Trace=0]="Trace",b[b.Debug=1]="Debug",b[b.Info=2]="Info",b[b.Warning=3]="Warning",b[b.Error=4]="Error",b[b.Critical=5]="Critical",b[b.Off=6]="Off"})(r||(r={}));async function P(b,C,E,v,d){try{const g=await new Promise((l,f)=>{le(["@vscode/spdlog"],l,f)});g.setFlushOn(r.Trace);const m=await g.createAsyncRotatingLogger(b,C,E,v);return d?m.clearFormatters():m.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),m}catch(g){console.error(g)}return null}function L(b,C,E){switch(C){case R.LogLevel.Trace:b.trace(E);break;case R.LogLevel.Debug:b.debug(E);break;case R.LogLevel.Info:b.info(E);break;case R.LogLevel.Warning:b.warn(E);break;case R.LogLevel.Error:b.error(E);break;case R.LogLevel.Off:break;default:throw new Error(`Invalid log level ${C}`)}}function I(b,C){switch(C){case R.LogLevel.Trace:b.setLevel(r.Trace);break;case R.LogLevel.Debug:b.setLevel(r.Debug);break;case R.LogLevel.Info:b.setLevel(r.Info);break;case R.LogLevel.Warning:b.setLevel(r.Warning);break;case R.LogLevel.Error:b.setLevel(r.Error);break;case R.LogLevel.Off:b.setLevel(r.Off);break;default:throw new Error(`Invalid log level ${C}`)}}class w extends R.$_i{constructor(C,E,v,d,g){super(),this.m=[],this.setLevel(g),this.n=this.s(C,E,v,d),this.B(this.onDidChangeLogLevel(m=>{this.r&&I(this.r,m)}))}async s(C,E,v,d){const g=v?6:1,m=30/g*y.$Bk.MB,l=await P(C,E,m,g,d);if(l){this.r=l,I(this.r,this.getLevel());for(const{level:f,message:u}of this.m)L(this.r,f,u);this.m=[]}}g(C,E){this.r?L(this.r,C,E):this.getLevel()<=C&&this.m.push({level:C,message:E})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u())}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$kN=w}),define(we[115],pe([1,0,23,13,225]),function(le,e,y,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lN=void 0;class P extends R.$ej{s(I,w,b){return new r.$kN((0,y.$bg)(),I.fsPath,!b?.donotRotate,!!b?.donotUseFormatters,w)}}e.$lN=P}),define(we[226],pe([1,0,62,190,6]),function(le,e,y,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5s=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var P;(function(w){w[w.Unnecessary=1]="Unnecessary",w[w.Deprecated=2]="Deprecated"})(P||(e.MarkerTag=P={}));var L;(function(w){w[w.Hint=1]="Hint",w[w.Info=2]="Info",w[w.Warning=4]="Warning",w[w.Error=8]="Error"})(L||(e.MarkerSeverity=L={})),function(w){function b(g,m){return m-g}w.compare=b;const C=Object.create(null);C[w.Error]=(0,R.localize)(0,null),C[w.Warning]=(0,R.localize)(1,null),C[w.Info]=(0,R.localize)(2,null);function E(g){return C[g]||""}w.toString=E;function v(g){switch(g){case y.default.Error:return w.Error;case y.default.Warning:return w.Warning;case y.default.Info:return w.Info;case y.default.Ignore:return w.Hint}}w.fromSeverity=v;function d(g){switch(g){case w.Error:return y.default.Error;case w.Warning:return y.default.Warning;case w.Info:return y.default.Info;case w.Hint:return y.default.Ignore}}w.toSeverity=d}(L||(e.MarkerSeverity=L={}));var I;(function(w){const b="";function C(v){return E(v,!0)}w.makeKey=C;function E(v,d){const g=[b];return v.source?g.push(v.source.replace("\xA6","\\\xA6")):g.push(b),v.code?typeof v.code=="string"?g.push(v.code.replace("\xA6","\\\xA6")):g.push(v.code.value.replace("\xA6","\\\xA6")):g.push(b),v.severity!==void 0&&v.severity!==null?g.push(L.toString(v.severity)):g.push(b),v.message&&d?g.push(v.message.replace("\xA6","\\\xA6")):g.push(b),v.startLineNumber!==void 0&&v.startLineNumber!==null?g.push(v.startLineNumber.toString()):g.push(b),v.startColumn!==void 0&&v.startColumn!==null?g.push(v.startColumn.toString()):g.push(b),v.endLineNumber!==void 0&&v.endLineNumber!==null?g.push(v.endLineNumber.toString()):g.push(b),v.endColumn!==void 0&&v.endColumn!==null?g.push(v.endColumn.toString()):g.push(b),g.push(b),g.join("\xA6")}w.makeKeyOptionalMessage=E})(I||(e.IMarkerData=I={})),e.$5s=(0,r.$Lh)("markerService")}),define(we[69],pe([1,0,5,47,2,6]),function(le,e,y,R,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bn=e.$an=e.$_m=void 0,e.$_m=(0,P.$Lh)("policy");class L extends r.$Qc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new y.$Ld),this.onDidChange=this.h.event}async updatePolicyDefinitions(b){const C=Object.keys(this.f).length;return this.f={...b,...this.f},C!==Object.keys(this.f).length&&await this.j(b),R.Iterable.reduce(this.g.entries(),(E,[v,d])=>({...E,[v]:d}),{})}getPolicyValue(b){return this.g.get(b)}serialize(){return R.Iterable.reduce(Object.entries(this.f),(b,[C,E])=>({...b,[C]:{definition:E,value:this.g.get(C)}}),{})}}e.$an=L;class I{constructor(){this.onDidChange=y.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$bn=I}),define(we[54],pe([1,0,3,28]),function(le,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let r;if(typeof y.$b.vscode<"u"&&typeof y.$b.vscode.context<"u"){const P=y.$b.vscode.context.configuration();if(P)r=P.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(r=globalThis._VSCODE_PRODUCT_JSON,R.env.VSCODE_DEV&&Object.assign(r,{nameShort:`${r.nameShort} Dev`,nameLong:`${r.nameLong} Dev`,dataFolderName:`${r.dataFolderName}-dev`,serverDataFolderName:r.serverDataFolderName?`${r.serverDataFolderName}-dev`:void 0}),!r.version){const P=globalThis._VSCODE_PACKAGE_JSON;Object.assign(r,{version:P.version})}Object.assign(r,{extensionsGallery:R.env.EXTENSIONS_GALLERY?JSON.parse(R.env.EXTENSIONS_GALLERY):r.extensionsGallery||{serviceUrl:"https://open-vsx.org/vscode/gallery",itemUrl:"https://open-vsx.org/vscode/item",resourceUrlTemplate:"https://open-vsx.org/vscode/asset/{publisher}/{name}/{version}/Microsoft.VisualStudio.Code.WebResources/{path}",controlUrl:"",recommendationsUrl:""}})}else r={nameShort:"code-server",nameLong:"code-server",applicationName:"code-server",dataFolderName:".code-server",win32MutexName:"codeserver",licenseName:"MIT",licenseUrl:"https://github.com/coder/code-server/blob/main/LICENSE",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverGreeting:[],serverLicense:[],serverLicensePrompt:"",serverApplicationName:"code-server-oss",serverDataFolderName:".vscode-server-oss",tunnelApplicationName:"code-tunnel-oss",win32DirName:"code-server",win32NameVersion:"code-server",win32RegValueName:"CodeOSS",win32AppId:"{{E34003BB-9E10-4501-8C11-BE3FAA83F23F}",win32x64AppId:"{{D77B7E06-80BA-4137-BCF4-654B95CCEBC5}",win32arm64AppId:"{{D1ACE434-89C5-48D1-88D3-E2991DF85475}",win32UserAppId:"{{C6065F05-9603-4FC4-8101-B9781A25D88E}",win32x64UserAppId:"{{CC6B787D-37A0-49E8-AE24-8559A032BE0C}",win32arm64UserAppId:"{{3AEBF0C8-F733-4AD4-BADE-FDB816D53D7B}",win32AppUserModelId:"coder.code-server",win32ShellNameShort:"c&ode-server",win32TunnelServiceMutex:"vscodeoss-tunnelservice",win32TunnelMutex:"vscodeoss-tunnel",darwinBundleIdentifier:"com.coder.code.server",linuxIconName:"com.coder.code.server",licenseFileName:"LICENSE.txt",reportIssueUrl:"https://github.com/coder/code-server/issues/new",nodejsRepository:"https://nodejs.org",urlProtocol:"code-oss",webviewContentExternalBaseUrlTemplate:"https://{{uuid}}.vscode-cdn.net/insider/ef65ac1ba57f57f2a3961bfe94aa20481caca4c6/out/vs/workbench/contrib/webview/browser/pre/",builtInExtensions:[{name:"ms-vscode.js-debug-companion",version:"1.1.2",sha256:"e034b8b41beb4e97e02c70f7175bd88abe66048374c2bd629f54bb33354bc2aa",repo:"https://github.com/microsoft/vscode-js-debug-companion",metadata:{id:"99cb0b7f-7354-4278-b8da-6cc79972169d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.js-debug",version:"1.83.1",sha256:"1452fdbab8d0d83ca5765bb66170d50b005c97ca4dcd13e154c3401d842a92d4",repo:"https://github.com/microsoft/vscode-js-debug",metadata:{id:"25629058-ddac-4e17-abba-74678e126c5d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.vscode-js-profile-table",version:"1.0.3",sha256:"b9dab017506d9e6a469a0f82b392e4cb1d7a25a4843f1db8ba396cbee209cfc5",repo:"https://github.com/microsoft/vscode-js-profile-visualizer",metadata:{id:"7e52b41b-71ad-457b-ab7e-0620f1fc4feb",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}}],enableTelemetry:!0,quality:"stable",codeServerVersion:"0.0.0",documentationUrl:"https://go.microsoft.com/fwlink/?LinkID=533484#vscode",keyboardShortcutsUrlMac:"https://go.microsoft.com/fwlink/?linkid=832143",keyboardShortcutsUrlLinux:"https://go.microsoft.com/fwlink/?linkid=832144",keyboardShortcutsUrlWin:"https://go.microsoft.com/fwlink/?linkid=832145",introductoryVideosUrl:"https://go.microsoft.com/fwlink/?linkid=832146",tipsAndTricksUrl:"https://go.microsoft.com/fwlink/?linkid=852118",newsletterSignupUrl:"https://www.research.net/r/vsc-newsletter",linkProtectionTrustedDomains:["https://open-vsx.org"],trustedExtensionAuthAccess:["vscode.git","vscode.github","github.vscode-pull-request-github","github.copilot","github.copilot-chat"],aiConfig:{ariaKey:"code-server"},version:"1.83.1",commit:"d7a2b4936af1bfd80cb96f2567af68badc2325e3",date:"2023-10-19T00:53:43.414Z"},Object.keys(r).length===0&&Object.assign(r,{version:"1.82.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=r}),define(we[31],pe([1,0,6]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mj=e.$lj=void 0,e.$lj=(0,y.$Lh)("productService"),e.$mj="vscode://schemas/vscode-product"}),define(we[35],pe([1,0,95,8]),function(le,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0m=void 0;class r{constructor(){this.a=new Map}add(L,I){y.ok(R.$wf(L)),y.ok(R.$yf(I)),y.ok(!this.a.has(L),"There is already an extension with this id"),this.a.set(L,I)}knows(L){return this.a.has(L)}as(L){return this.a.get(L)||null}}e.$0m=new r}),define(we[227],pe([1,0,5,35]),function(le,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$m=void 0,e.$$m={JSONContribution:"base.contributions.json"};function r(I){return I.length>0&&I.charAt(I.length-1)==="#"?I.substring(0,I.length-1):I}class P{constructor(){this.b=new y.$Ld,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(w,b){this.a[r(w)]=b,this.b.fire(w)}notifySchemaChanged(w){this.b.fire(w)}getSchemaContributions(){return{schemas:this.a}}}const L=new P;R.$0m.add(e.$$m.JSONContribution,L)}),define(we[55],pe([1,0,18,5,8,172,24,227,35]),function(le,e,y,R,r,P,L,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rn=e.$qn=e.$pn=e.$on=e.$nn=e.$mn=e.$ln=e.$kn=e.$jn=e.$in=e.$hn=e.$gn=e.$fn=e.$en=e.$dn=e.ConfigurationScope=e.$cn=e.EditPresentationTypes=void 0;var b;(function(h){h.Multiline="multilineText",h.Singleline="singlelineText"})(b||(e.EditPresentationTypes=b={})),e.$cn={Configuration:"base.contributions.configuration"};var C;(function(h){h[h.APPLICATION=1]="APPLICATION",h[h.MACHINE=2]="MACHINE",h[h.WINDOW=3]="WINDOW",h[h.RESOURCE=4]="RESOURCE",h[h.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",h[h.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(C||(e.ConfigurationScope=C={})),e.$dn={properties:{},patternProperties:{}},e.$en={properties:{},patternProperties:{}},e.$fn={properties:{},patternProperties:{}},e.$gn={properties:{},patternProperties:{}},e.$hn={properties:{},patternProperties:{}},e.$in={properties:{},patternProperties:{}},e.$jn="vscode://schemas/settings/resourceLanguage",e.$kn="vscode://schemas/settings/configurationDefaults";const E=w.$0m.as(I.$$m.JSONContribution);class v{constructor(){this.h=new Set,this.i=new R.$Ld,this.onDidSchemaChange=this.i.event,this.j=new R.$Ld,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:P.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},E.registerSchema(e.$jn,this.g),this.v()}registerConfiguration(t,s=!0){this.registerConfigurations([t],s)}registerConfigurations(t,s=!0){const o=new Set;this.n(t,s,o),E.registerSchema(e.$jn,this.g),this.i.fire(),this.j.fire({properties:o})}deregisterConfigurations(t){const s=new Set;this.o(t,s),E.registerSchema(e.$jn,this.g),this.i.fire(),this.j.fire({properties:s})}updateConfigurations({add:t,remove:s}){const o=new Set;this.o(s,o),this.n(t,!1,o),E.registerSchema(e.$jn,this.g),this.i.fire(),this.j.fire({properties:o})}registerDefaultConfigurations(t){const s=new Set;this.k(t,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}k(t,s){const o=[];for(const{overrides:i,source:n}of t)for(const a in i)if(s.add(a),e.$mn.test(a)){const $=this.a.get(a),S=$?.valuesSources??new Map;if(n)for(const j of Object.keys(i[a]))S.set(j,n);const D={...$?.value||{},...i[a]};this.a.set(a,{source:n,value:D,valuesSources:S});const k=(0,L.$pi)(a),A={type:"object",default:D,description:P.localize(1,null,k),$ref:e.$jn,defaultDefaultValue:D,source:r.$wf(n)?void 0:n,defaultValueSource:n};o.push(...m(a)),this.d[a]=A,this.b.properties[a]=A}else{this.a.set(a,{value:i[a],source:n});const $=this.d[a];$&&(this.w(a,$),this.r(a,$))}this.m(o)}deregisterDefaultConfigurations(t){const s=new Set;this.l(t,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}l(t,s){for(const{overrides:o,source:i}of t)for(const n in o){const a=this.a.get(n),$=r.$wf(i)?i:i?.id,S=r.$wf(a?.source)?a?.source:a?.source?.id;if($===S)if(s.add(n),this.a.delete(n),e.$mn.test(n))delete this.d[n],delete this.b.properties[n];else{const D=this.d[n];D&&(this.w(n,D),this.r(n,D))}}this.u()}deltaConfiguration(t){let s=!1;const o=new Set;t.removedDefaults&&(this.l(t.removedDefaults,o),s=!0),t.addedDefaults&&(this.k(t.addedDefaults,o),s=!0),t.removedConfigurations&&this.o(t.removedConfigurations,o),t.addedConfigurations&&this.n(t.addedConfigurations,!1,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:s})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const s of t)this.h.add(s);this.u()}n(t,s,o){t.forEach(i=>{this.p(i,s,i.extensionInfo,i.restrictedProperties,void 0,o),this.c.push(i),this.q(i)})}o(t,s){const o=i=>{if(i.properties)for(const n in i.properties){s.add(n);const a=this.d[n];a?.policy?.name&&this.e.delete(a.policy.name),delete this.d[n],this.s(n,i.properties[n])}i.allOf?.forEach(n=>o(n))};for(const i of t){o(i);const n=this.c.indexOf(i);n!==-1&&this.c.splice(n,1)}}p(t,s=!0,o,i,n=3,a){n=r.$Ff(t.scope)?n:t.scope;const $=t.properties;if($)for(const D in $){const k=$[D];if(s&&c(D,k)){delete $[D];continue}if(k.source=o,k.defaultDefaultValue=$[D].default,this.w(D,k),e.$mn.test(D)?k.scope=void 0:(k.scope=r.$Ff(k.scope)?n:k.scope,k.restricted=r.$Ff(k.restricted)?!!i?.includes(D):k.restricted),$[D].hasOwnProperty("included")&&!$[D].included){this.f[D]=$[D],delete $[D];continue}else this.d[D]=$[D],$[D].policy?.name&&this.e.set($[D].policy.name,D);!$[D].deprecationMessage&&$[D].markdownDeprecationMessage&&($[D].deprecationMessage=$[D].markdownDeprecationMessage),a.add(D)}const S=t.allOf;if(S)for(const D of S)this.p(D,s,o,i,n,a)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const s=o=>{const i=o.properties;if(i)for(const a in i)this.r(a,i[a]);o.allOf?.forEach(s)};s(t)}r(t,s){switch(e.$dn.properties[t]=s,s.scope){case 1:e.$en.properties[t]=s;break;case 2:e.$fn.properties[t]=s;break;case 6:e.$gn.properties[t]=s;break;case 3:e.$hn.properties[t]=s;break;case 4:e.$in.properties[t]=s;break;case 5:e.$in.properties[t]=s,this.g.properties[t]=s;break}}s(t,s){switch(delete e.$dn.properties[t],s.scope){case 1:delete e.$en.properties[t];break;case 2:delete e.$fn.properties[t];break;case 6:delete e.$gn.properties[t];break;case 3:delete e.$hn.properties[t];break;case 4:case 5:delete e.$in.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const s=`[${t}]`,o={type:"object",description:P.localize(2,null),errorMessage:P.localize(3,null),$ref:e.$jn};this.w(s,o),e.$dn.properties[s]=o,e.$en.properties[s]=o,e.$fn.properties[s]=o,e.$gn.properties[s]=o,e.$hn.properties[s]=o,e.$in.properties[s]=o}}v(){const t={type:"object",description:P.localize(4,null),errorMessage:P.localize(5,null),$ref:e.$jn};e.$dn.patternProperties[e.$ln]=t,e.$en.patternProperties[e.$ln]=t,e.$fn.patternProperties[e.$ln]=t,e.$gn.patternProperties[e.$ln]=t,e.$hn.patternProperties[e.$ln]=t,e.$in.patternProperties[e.$ln]=t,this.i.fire()}w(t,s){const o=this.a.get(t);let i=o?.value,n=o?.source;r.$Df(i)&&(i=s.defaultDefaultValue,n=void 0),r.$Df(i)&&(i=f(s.type)),s.default=i,s.defaultValueSource=n}}const d="\\[([^\\]]+)\\]",g=new RegExp(d,"g");e.$ln=`^(${d})+$`,e.$mn=new RegExp(e.$ln);function m(h){const t=[];if(e.$mn.test(h)){let s=g.exec(h);for(;s?.length;){const o=s[1].trim();o&&t.push(o),s=g.exec(h)}}return(0,y.$Kb)(t)}e.$nn=m;function l(h){return h.reduce((t,s)=>`${t}[${s}]`,"")}e.$on=l;function f(h){switch(Array.isArray(h)?h[0]:h){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$pn=f;const u=new v;w.$0m.add(e.$cn.Configuration,u);function c(h,t){return h.trim()?e.$mn.test(h)?P.localize(7,null,h):u.getConfigurationProperties()[h]!==void 0?P.localize(8,null,h):t.policy?.name&&u.getPolicyConfigurations().get(t.policy?.name)!==void 0?P.localize(9,null,h,t.policy?.name,u.getPolicyConfigurations().get(t.policy?.name)):null:P.localize(6,null)}e.$qn=c;function p(){const h=[],t=u.getConfigurationProperties();for(const s of Object.keys(t))h.push([s,t[s].scope]);return h.push(["launch",4]),h.push(["task",4]),h}e.$rn=p}),define(we[116],pe([1,0,18,5,75,2,26,22,8,4,24,55,35]),function(le,e,y,R,r,P,L,I,w,b,C,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xn=e.$wn=e.$vn=e.$un=e.$tn=e.$sn=void 0;function d(s){return Object.isFrozen(s)?s:I.$Ym(s)}class g{constructor(o={},i=[],n=[],a){this.b=o,this.c=i,this.d=n,this.raw=a,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const o=this.raw.map(i=>{if(i instanceof g)return i;const n=new m("");return n.parseRaw(i),n.configurationModel});this.f=o.reduce((i,n)=>n===i?n:i.merge(n),o[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(o){return o?(0,C.$ni)(this.contents,o):this.contents}inspect(o,i){const n=this.rawConfiguration.getValue(o),a=i?this.rawConfiguration.getOverrideValue(o,i):void 0,$=i?this.rawConfiguration.override(i).getValue(o):n;return{value:n,override:a,merged:$}}getOverrideValue(o,i){const n=this.i(i);return n?o?(0,C.$ni)(n,o):n:void 0}getKeysForOverrideIdentifier(o){const i=[];for(const n of this.overrides)n.identifiers.includes(o)&&i.push(...n.keys);return y.$Kb(i)}getAllOverrideIdentifiers(){const o=[];for(const i of this.overrides)o.push(...i.identifiers);return y.$Kb(o)}override(o){let i=this.a.get(o);return i||(i=this.g(o),this.a.set(o,i)),i}merge(...o){const i=I.$Xm(this.contents),n=I.$Xm(this.overrides),a=[...this.keys],$=this.raw?.length?[...this.raw]:[this];for(const S of o)if($.push(...S.raw?.length?S.raw:[S]),!S.isEmpty()){this.h(i,S.contents);for(const D of S.overrides){const[k]=n.filter(A=>y.$sb(A.identifiers,D.identifiers));k?(this.h(k.contents,D.contents),k.keys.push(...D.keys),k.keys=y.$Kb(k.keys)):n.push(I.$Xm(D))}for(const D of S.keys)a.indexOf(D)===-1&&a.push(D)}return new g(i,a,n,$.every(S=>S instanceof g)?void 0:$)}g(o){const i=this.i(o);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const n={};for(const a of y.$Kb([...Object.keys(this.contents),...Object.keys(i)])){let $=this.contents[a];const S=i[a];S&&(typeof $=="object"&&typeof S=="object"?($=I.$Xm($),this.h($,S)):$=S),n[a]=$}return new g(n,this.keys,this.overrides)}h(o,i){for(const n of Object.keys(i)){if(n in o&&w.$yf(o[n])&&w.$yf(i[n])){this.h(o[n],i[n]);continue}o[n]=I.$Xm(i[n])}}i(o){let i=null,n=null;const a=$=>{$&&(n?this.h(n,$):n=I.$Xm($))};for(const $ of this.overrides)$.identifiers.length===1&&$.identifiers[0]===o?i=$.contents:$.identifiers.includes(o)&&a($.contents);return a(i),n}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(o,i){this.j(o,i,!0)}setValue(o,i){this.j(o,i,!1)}removeValue(o){const i=this.keys.indexOf(o);i!==-1&&(this.keys.splice(i,1),(0,C.$mi)(this.contents,o),E.$mn.test(o)&&this.overrides.splice(this.overrides.findIndex(n=>y.$sb(n.identifiers,(0,E.$nn)(o))),1))}j(o,i,n){(0,C.$li)(this.contents,o,i,a=>console.error(a)),n=n||this.keys.indexOf(o)===-1,n&&this.keys.push(o),E.$mn.test(o)&&this.overrides.push({identifiers:(0,E.$nn)(o),keys:Object.keys(this.contents[o]),contents:(0,C.$ki)(this.contents[o],a=>console.error(a))})}}e.$sn=g;class m{constructor(o){this.f=o,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new g}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(o,i){if(!w.$Ff(o)){const n=this.g(o);this.parseRaw(n,i)}}reparse(o){this.a&&this.parseRaw(this.a,o)}parseRaw(o,i){this.a=o;const{contents:n,keys:a,overrides:$,restricted:S,hasExcludedProperties:D}=this.h(o,i);this.b=new g(n,a,$,D?[o]:void 0),this.c=S||[]}g(o){let i={},n=null,a=[];const $=[],S=[];function D(A){Array.isArray(a)?a.push(A):n!==null&&(a[n]=A)}const k={onObjectBegin:()=>{const A={};D(A),$.push(a),a=A,n=null},onObjectProperty:A=>{n=A},onObjectEnd:()=>{a=$.pop()},onArrayBegin:()=>{const A=[];D(A),$.push(a),a=A,n=null},onArrayEnd:()=>{a=$.pop()},onLiteralValue:D,onError:(A,j,Z)=>{S.push({error:A,offset:j,length:Z})}};if(o)try{r.$Um(o,k),i=a[0]||{}}catch(A){console.error(`Error while parsing settings file ${this.f}: ${A}`),this.d=[A]}return i}h(o,i){const n=v.$0m.as(E.$cn.Configuration).getConfigurationProperties(),a=this.i(o,n,!0,i);o=a.raw;const $=(0,C.$ki)(o,k=>console.error(`Conflict in settings file ${this.f}: ${k}`)),S=Object.keys(o),D=this.j(o,k=>console.error(`Conflict in settings file ${this.f}: ${k}`));return{contents:$,keys:S,overrides:D,restricted:a.restricted,hasExcludedProperties:a.hasExcludedProperties}}i(o,i,n,a){let $=!1;if(!a?.scopes&&!a?.skipRestricted&&!a?.exclude?.length)return{raw:o,restricted:[],hasExcludedProperties:$};const S={},D=[];for(const k in o)if(E.$mn.test(k)&&n){const A=this.i(o[k],i,!1,a);S[k]=A.raw,$=$||A.hasExcludedProperties,D.push(...A.restricted)}else{const A=i[k],j=A?typeof A.scope<"u"?A.scope:3:void 0;A?.restricted&&D.push(k),!a.exclude?.includes(k)&&(a.include?.includes(k)||(j===void 0||a.scopes===void 0||a.scopes.includes(j))&&!(a.skipRestricted&&A?.restricted))?S[k]=o[k]:$=!0}return{raw:S,restricted:D,hasExcludedProperties:$}}j(o,i){const n=[];for(const a of Object.keys(o))if(E.$mn.test(a)){const $={};for(const S in o[a])$[S]=o[a][S];n.push({identifiers:(0,E.$nn)(a),keys:Object.keys($),contents:(0,C.$ki)($,i)})}return n}}e.$tn=m;class l extends P.$Qc{constructor(o,i,n,a){super(),this.c=o,this.f=i,this.g=a,this.b=this.B(new R.$Ld),this.onDidChange=this.b.event,this.a=new m(this.c.toString()),this.B(this.g.watch(n.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(R.Event.any(R.Event.filter(this.g.onDidFilesChange,$=>$.contains(this.c)),R.Event.filter(this.g.onDidRunOperation,$=>($.isOperation(0)||$.isOperation(3)||$.isOperation(1)||$.isOperation(4))&&n.isEqual($.resource,o)))(()=>this.b.fire()))}async loadConfiguration(){try{const o=await this.g.readFile(this.c);return this.a.parse(o.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new g}}reparse(o){return o&&(this.f=o),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$un=l;class f{constructor(o,i,n,a,$,S,D,k,A,j,Z,ae,K){this.a=o,this.b=i,this.c=n,this.overrideIdentifiers=a,this.d=$,this.f=S,this.g=D,this.h=k,this.i=A,this.j=j,this.k=Z,this.l=ae,this.m=K}get value(){return d(this.c)}n(o,i,n){const a=o.inspect(i,n);return{get value(){return d(a.value)},get override(){return d(a.override)},get merged(){return d(a.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class u{constructor(o,i,n,a,$=new g,S=new g,D=new L.$yc,k=new g,A=new L.$yc){this.c=o,this.d=i,this.f=n,this.g=a,this.h=$,this.i=S,this.j=D,this.l=k,this.m=A,this.a=null,this.b=new L.$yc,this.n=null}getValue(o,i,n){return this.q(o,i,n).getValue(o)}updateValue(o,i,n={}){let a;n.resource?(a=this.m.get(n.resource),a||(a=new g,this.m.set(n.resource,a))):a=this.l,i===void 0?a.removeValue(o):a.setValue(o,i),n.resource||(this.a=null)}inspect(o,i,n){const a=this.q(o,i,n),$=this.u(i.resource,n),S=i.resource?this.m.get(i.resource)||this.l:this.l,D=new Set;for(const k of a.overrides)for(const A of k.identifiers)a.getOverrideValue(o,A)!==void 0&&D.add(A);return new f(o,i,a.getValue(o),D.size?[...D]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,n?this.i:void 0,$||void 0,S)}keys(o){const i=this.u(void 0,o);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:i?i.keys.slice(0):[]}}updateDefaultConfiguration(o){this.c=o,this.a=null,this.b.clear()}updatePolicyConfiguration(o){this.d=o}updateApplicationConfiguration(o){this.f=o,this.a=null,this.b.clear()}updateLocalUserConfiguration(o){this.g=o,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(o){this.h=o,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(o){this.i=o,this.a=null,this.b.clear()}updateFolderConfiguration(o,i){this.j.set(o,i),this.b.delete(o)}deleteFolderConfiguration(o){this.p.delete(o),this.b.delete(o)}compareAndUpdateDefaultConfiguration(o,i){const n=[];if(!i){const{added:a,updated:$,removed:S}=h(this.c,o);i=[...a,...$,...S]}for(const a of i)for(const $ of(0,E.$nn)(a)){const S=this.c.getKeysForOverrideIdentifier($),D=o.getKeysForOverrideIdentifier($),k=[...D.filter(A=>S.indexOf(A)===-1),...S.filter(A=>D.indexOf(A)===-1),...S.filter(A=>!I.$2m(this.c.override($).getValue(A),o.override($).getValue(A)))];n.push([$,k])}return this.updateDefaultConfiguration(o),{keys:i,overrides:n}}compareAndUpdatePolicyConfiguration(o){const{added:i,updated:n,removed:a}=h(this.d,o),$=[...i,...n,...a];return $.length&&this.updatePolicyConfiguration(o),{keys:$,overrides:[]}}compareAndUpdateApplicationConfiguration(o){const{added:i,updated:n,removed:a,overrides:$}=h(this.applicationConfiguration,o),S=[...i,...n,...a];return S.length&&this.updateApplicationConfiguration(o),{keys:S,overrides:$}}compareAndUpdateLocalUserConfiguration(o){const{added:i,updated:n,removed:a,overrides:$}=h(this.localUserConfiguration,o),S=[...i,...n,...a];return S.length&&this.updateLocalUserConfiguration(o),{keys:S,overrides:$}}compareAndUpdateRemoteUserConfiguration(o){const{added:i,updated:n,removed:a,overrides:$}=h(this.remoteUserConfiguration,o),S=[...i,...n,...a];return S.length&&this.updateRemoteUserConfiguration(o),{keys:S,overrides:$}}compareAndUpdateWorkspaceConfiguration(o){const{added:i,updated:n,removed:a,overrides:$}=h(this.workspaceConfiguration,o),S=[...i,...n,...a];return S.length&&this.updateWorkspaceConfiguration(o),{keys:S,overrides:$}}compareAndUpdateFolderConfiguration(o,i){const n=this.p.get(o),{added:a,updated:$,removed:S,overrides:D}=h(n,i),k=[...a,...$,...S];return(k.length||!n)&&this.updateFolderConfiguration(o,i),{keys:k,overrides:D}}compareAndDeleteFolderConfiguration(o){const i=this.p.get(o);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(o);const{added:n,updated:a,removed:$,overrides:S}=h(i,void 0);return{keys:[...n,...a,...$],overrides:S}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(o,i,n){let a=this.r(i,n);return i.overrideIdentifier&&(a=a.override(i.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(o)!==void 0&&(a=a.merge(this.d)),a}r({resource:o},i){let n=this.s();if(i&&o){const a=i.getFolder(o);a&&(n=this.t(a.uri)||n);const $=this.m.get(o);$&&(n=n.merge($))}return n}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(o){let i=this.b.get(o);if(!i){const n=this.s(),a=this.j.get(o);a?(i=n.merge(a),this.b.set(o,i)):i=n}return i}u(o,i){if(i&&o){const n=i.getFolder(o);if(n)return this.j.get(n.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((o,i)=>{const{contents:n,overrides:a,keys:$}=this.j.get(i);return o.push([i,{contents:n,overrides:a,keys:$}]),o},[])}}allKeys(){const o=new Set;return this.c.keys.forEach(i=>o.add(i)),this.userConfiguration.keys.forEach(i=>o.add(i)),this.i.keys.forEach(i=>o.add(i)),this.j.forEach(i=>i.keys.forEach(n=>o.add(n))),[...o.values()]}v(){const o=new Set;return this.c.getAllOverrideIdentifiers().forEach(i=>o.add(i)),this.userConfiguration.getAllOverrideIdentifiers().forEach(i=>o.add(i)),this.i.getAllOverrideIdentifiers().forEach(i=>o.add(i)),this.j.forEach(i=>i.getAllOverrideIdentifiers().forEach(n=>o.add(n))),[...o.values()]}w(o){const i=new Set;return this.c.getKeysForOverrideIdentifier(o).forEach(n=>i.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(o).forEach(n=>i.add(n)),this.i.getKeysForOverrideIdentifier(o).forEach(n=>i.add(n)),this.j.forEach(n=>n.getKeysForOverrideIdentifier(o).forEach(a=>i.add(a))),[...i.values()]}static parse(o){const i=this.x(o.defaults),n=this.x(o.policy),a=this.x(o.application),$=this.x(o.user),S=this.x(o.workspace),D=o.folders.reduce((k,A)=>(k.set(b.URI.revive(A[0]),this.x(A[1])),k),new L.$yc);return new u(i,n,a,$,new g,S,D,new g,new L.$yc)}static x(o){return new g(o.contents,o.keys,o.overrides)}}e.$vn=u;function c(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const o=new Set,i=new Map;for(const a of s)a.keys.forEach($=>o.add($)),a.overrides.forEach(([$,S])=>{const D=(0,L.$vc)(i,$,new Set);S.forEach(k=>D.add(k))});const n=[];return i.forEach((a,$)=>n.push([$,[...a.values()]])),{keys:[...o.values()],overrides:n}}e.$wn=c;class p{constructor(o,i,n,a){this.change=o,this.f=i,this.g=n,this.h=a,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const $ of o.keys)this.affectedKeys.add($);for(const[,$]of o.overrides)for(const S of $)this.affectedKeys.add(S);this.d=this.a;for(const $ of this.affectedKeys)this.d+=$+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=u.parse(this.f.data)),this.i}affectsConfiguration(o,i){const n=this.a+o,a=this.d.indexOf(n);if(a<0)return!1;const $=a+n.length;if($>=this.d.length)return!1;const S=this.d.charCodeAt($);if(S!==this.b&&S!==this.c)return!1;if(i){const D=this.previousConfiguration?this.previousConfiguration.getValue(o,i,this.f?.workspace):void 0,k=this.g.getValue(o,i,this.h);return!I.$2m(D,k)}return!0}}e.$xn=p;function h(s,o){const{added:i,removed:n,updated:a}=t(o?.rawConfiguration,s?.rawConfiguration),$=[],S=s?.getAllOverrideIdentifiers()||[],D=o?.getAllOverrideIdentifiers()||[];if(o){const k=D.filter(A=>!S.includes(A));for(const A of k)$.push([A,o.getKeysForOverrideIdentifier(A)])}if(s){const k=S.filter(A=>!D.includes(A));for(const A of k)$.push([A,s.getKeysForOverrideIdentifier(A)])}if(o&&s){for(const k of S)if(D.includes(k)){const A=t({contents:s.getOverrideValue(void 0,k)||{},keys:s.getKeysForOverrideIdentifier(k)},{contents:o.getOverrideValue(void 0,k)||{},keys:o.getKeysForOverrideIdentifier(k)});$.push([k,[...A.added,...A.removed,...A.updated]])}}return{added:i,removed:n,updated:a,overrides:$}}function t(s,o){const i=s?o?s.keys.filter($=>o.keys.indexOf($)===-1):[...s.keys]:[],n=o?s?o.keys.filter($=>s.keys.indexOf($)===-1):[...o.keys]:[],a=[];if(s&&o){for(const $ of o.keys)if(s.keys.indexOf($)!==-1){const S=(0,C.$ni)(o.contents,$),D=(0,C.$ni)(s.contents,$);I.$2m(S,D)||a.push($)}}return{added:i,removed:n,updated:a}}}),define(we[228],pe([1,0,18,5,2,22,8,116,55,13,69,35]),function(le,e,y,R,r,P,L,I,w,b,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$An=e.$zn=e.$yn=void 0;class v extends r.$Qc{constructor(){super(...arguments),this.a=this.B(new R.$Ld),this.onDidChangeConfiguration=this.a.event,this.b=new I.$sn}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(E.$0m.as(w.$cn.Configuration).onDidUpdateConfiguration(({properties:l,defaultsOverrides:f})=>this.c(Array.from(l),f))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(l,f){this.h(l,E.$0m.as(w.$cn.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:l})}f(){return{}}g(){this.b=new I.$sn;const l=E.$0m.as(w.$cn.Configuration).getConfigurationProperties();this.h(Object.keys(l),l)}h(l,f){const u=this.f();for(const c of l){const p=u[c],h=f[c];p!==void 0?this.b.addValue(c,p):h?this.b.addValue(c,h.default):this.b.removeValue(c)}}}e.$yn=v;class d{constructor(){this.onDidChangeConfiguration=R.Event.None,this.configurationModel=new I.$sn}async initialize(){return this.configurationModel}}e.$zn=d;let g=class extends r.$Qc{get configurationModel(){return this.b}constructor(l,f,u){super(),this.c=l,this.f=f,this.g=u,this.a=this.B(new R.$Ld),this.onDidChangeConfiguration=this.a.event,this.b=new I.$sn}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(l=>this.j(l))),this.B(this.c.onDidChangeConfiguration(async({properties:l})=>this.m(await this.h(l),!0))),this.b}async h(l){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",l);const f={},u=[],c=E.$0m.as(w.$cn.Configuration).getConfigurationProperties();for(const p of l){const h=c[p];if(!h){u.push(p);continue}if(h.policy){if(h.type!=="string"&&h.type!=="number"){this.g.warn(`Policy ${h.policy.name} has unsupported type ${h.type}`);continue}u.push(p),f[h.policy.name]={type:h.type}}}return(0,L.$Jf)(f)||await this.f.updatePolicyDefinitions(f),u}j(l){this.g.trace("PolicyConfiguration#onDidChangePolicies",l);const f=E.$0m.as(w.$cn.Configuration).getPolicyConfigurations(),u=(0,y.$Fb)(l.map(c=>f.get(c)));this.m(u,!0)}m(l,f){this.g.trace("PolicyConfiguration#update",l);const u=E.$0m.as(w.$cn.Configuration).getConfigurationProperties(),c=[],p=this.b.isEmpty();for(const h of l){const t=u[h]?.policy?.name;if(t){const s=this.f.getPolicyValue(t);(p?s!==void 0:!(0,P.$2m)(this.b.getValue(h),s))&&c.push([h,s])}else this.b.getValue(h)!==void 0&&c.push([h,void 0])}if(c.length){this.g.trace("PolicyConfiguration#changed",c);const h=this.b;this.b=new I.$sn;for(const t of h.keys)this.b.setValue(t,h.getValue(t));for(const[t,s]of c)s===void 0?this.b.removeValue(t):this.b.setValue(t,s);f&&this.a.fire(this.b)}}};e.$An=g,e.$An=g=Oe([Ae(1,C.$_m),Ae(2,b.$6i)],g)}),define(we[117],pe([1,0,14,5,2,19,24,116,228,69]),function(le,e,y,R,r,P,L,I,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bn=void 0;class C extends r.$Qc{constructor(v,d,g,m){super(),this.j=v,this.h=this.B(new R.$Ld),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new w.$yn),this.c=g instanceof b.$bn?new w.$zn:this.B(new w.$An(this.b,g,m)),this.f=this.B(new I.$un(this.j,{},P.$jg,d)),this.a=new I.$vn(this.b.configurationModel,this.c.configurationModel,new I.$sn,new I.$sn),this.g=this.B(new y.$3g(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:l,properties:f})=>this.n(l,f))),this.B(this.c.onDidChangeConfiguration(l=>this.r(l))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[v,d,g]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new I.$vn(v,d,new I.$sn,g)}getConfigurationData(){return this.a.toData()}getValue(v,d){const g=typeof v=="string"?v:void 0,m=(0,L.$gi)(v)?v:(0,L.$gi)(d)?d:{};return this.a.getValue(g,m,void 0)}updateValue(v,d,g,m){return Promise.reject(new Error("not supported"))}inspect(v){return this.a.inspect(v,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const v=await this.f.loadConfiguration();this.m(v)}m(v){const d=this.a.toData(),g=this.a.compareAndUpdateLocalUserConfiguration(v);this.s(g,d,2)}n(v,d){const g=this.a.toData(),m=this.a.compareAndUpdateDefaultConfiguration(v,d);this.s(m,g,7)}r(v){const d=this.a.toData(),g=this.a.compareAndUpdatePolicyConfiguration(v);this.s(g,d,7)}s(v,d,g){const m=new I.$xn(v,{data:d},this.a);m.source=g,m.sourceConfig=this.t(g),this.h.fire(m)}t(v){switch(v){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.$Bn=C}),define(we[118],pe([1,0,11,6]),function(le,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ok=e.$Nk=e.RemoteAuthorityResolverErrorCode=e.$Mk=e.$Lk=e.RemoteConnectionType=e.$Kk=void 0,e.$Kk=(0,R.$Lh)("remoteAuthorityResolverService");var r;(function(C){C[C.WebSocket=0]="WebSocket",C[C.Managed=1]="Managed"})(r||(e.RemoteConnectionType=r={}));class P{constructor(E){this.id=E,this.type=1}toString(){return`Managed(${this.id})`}}e.$Lk=P;class L{constructor(E,v){this.host=E,this.port=v,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Mk=L;var I;(function(C){C.Unknown="Unknown",C.NotAvailable="NotAvailable",C.TemporarilyNotAvailable="TemporarilyNotAvailable",C.NoResolverFound="NoResolverFound",C.InvalidAuthority="InvalidAuthority"})(I||(e.RemoteAuthorityResolverErrorCode=I={}));class w extends y.$_{static isNotAvailable(E){return E instanceof w&&E._code===I.NotAvailable}static isTemporarilyNotAvailable(E){return E instanceof w&&E._code===I.TemporarilyNotAvailable}static isNoResolverFound(E){return E instanceof w&&E._code===I.NoResolverFound}static isInvalidAuthority(E){return E instanceof w&&E._code===I.InvalidAuthority}static isHandled(E){return E instanceof w&&E.isHandled}constructor(E,v=I.Unknown,d){super(E),this._message=E,this._code=v,this._detail=d,this.isHandled=v===I.NotAvailable&&d===!0,Object.setPrototypeOf(this,w.prototype)}}e.$Nk=w;function b(C){const E=C.indexOf("+");return E===-1?C:C.substring(0,E)}e.$Ok=b}),define(we[229],pe([1,0,6]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yN=e.$xN=void 0,e.$xN=(0,y.$Lh)("IRemoteExtensionsScannerService"),e.$yN="remoteExtensionsScanner"}),define(we[56],pe([1,0,12]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tk=e.$Sk=e.$Rk=e.$Qk=e.$Pk=void 0;function R(b){return b.scheme===y.Schemas.vscodeRemote?b.authority:void 0}e.$Pk=R;function r(b){if(!b)return;const C=b.indexOf("+");return C<0?b:b.substr(0,C)}e.$Qk=r;function P(b){return`/${b.quality??"oss"}-${b.commit??"dev"}`}e.$Rk=P;function L(b){const{host:C,port:E}=w(b);if(typeof E>"u")throw new Error("Remote authority doesn't contain a port!");return{host:C,port:E}}e.$Sk=L;function I(b,C){let{host:E,port:v}=w(b);return typeof v>"u"&&(v=C),{host:E,port:v}}e.$Tk=I;function w(b){const C=b.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(C)return{host:C[1],port:parseInt(C[2],10)};const E=b.match(/^(\[[0-9a-z:]+\])$/);if(E)return{host:E[1],port:void 0};const v=b.match(/(.*):(\d+)$/);return v?{host:v[1],port:parseInt(v[2],10)}:{host:b,port:void 0}}}),define(we[40],pe([1,0,17,6,56]),function(le,e,y,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5l=e.$4l=e.$3l=e.$2l=e.$1l=e.$Zl=e.$Yl=e.$Xl=e.TargetPlatform=e.ExtensionType=e.$Wl=e.$Vl=e.$Ul=e.$Tl=e.$Sl=e.$Rl=void 0,e.$Rl="extensions.user.cache",e.$Sl="extensions.builtin.cache",e.$Tl="undefined_publisher",e.$Ul=["ui","workspace","web"];function P(m){if(typeof m=="object"&&m!==null&&m.supported!==!0)return m.description}e.$Vl=P,e.$Wl=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var L;(function(m){m[m.System=0]="System",m[m.User=1]="User"})(L||(e.ExtensionType=L={}));var I;(function(m){m.WIN32_X64="win32-x64",m.WIN32_IA32="win32-ia32",m.WIN32_ARM64="win32-arm64",m.LINUX_X64="linux-x64",m.LINUX_ARM64="linux-arm64",m.LINUX_ARMHF="linux-armhf",m.ALPINE_X64="alpine-x64",m.ALPINE_ARM64="alpine-arm64",m.DARWIN_X64="darwin-x64",m.DARWIN_ARM64="darwin-arm64",m.WEB="web",m.UNIVERSAL="universal",m.UNKNOWN="unknown",m.UNDEFINED="undefined"})(I||(e.TargetPlatform=I={}));class w{constructor(l){this.value=l,this._lower=l.toLowerCase()}static equals(l,f){if(typeof l>"u"||l===null)return typeof f>"u"||f===null;if(typeof f>"u"||f===null)return!1;if(typeof l=="string"||typeof f=="string"){const u=typeof l=="string"?l:l.value,c=typeof f=="string"?f:f.value;return y.$Ze(u,c)}return l._lower===f._lower}static toKey(l){return typeof l=="string"?l.toLowerCase():l._lower}}e.$Xl=w;class b{get size(){return this.c.size}constructor(l){if(this.c=new Set,l)for(const f of l)this.add(f)}add(l){this.c.add(w.toKey(l))}delete(l){return this.c.delete(w.toKey(l))}has(l){return this.c.has(w.toKey(l))}}e.$Yl=b;class C{constructor(){this.c=new Map}clear(){this.c.clear()}delete(l){this.c.delete(w.toKey(l))}get(l){return this.c.get(w.toKey(l))}has(l){return this.c.has(w.toKey(l))}set(l,f){this.c.set(w.toKey(l),f)}values(){return this.c.values()}forEach(l){this.c.forEach(l)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Zl=C;function E(m){return v(m)}e.$1l=E;function v(m){return m.contributes&&m.contributes.localizations?m.contributes.localizations.length>0:!1}e.$2l=v;function d(m){return m.contributes&&m.contributes.authentication?m.contributes.authentication.length>0:!1}e.$3l=d;function g(m,l){if(l){const f=`onResolveRemoteAuthority:${(0,r.$Qk)(l)}`;return!!m.activationEvents?.includes(f)}return!1}e.$4l=g,e.$5l=(0,R.$Lh)("IBuiltinExtensionsScannerService")}),define(we[230],pe([1,0,2,40,16]),function(le,e,y,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yp=void 0;class P extends y.$Qc{constructor(I,w,b,C,E){super(),this.a=I,this.b=w,this.c=b,this.f=E,this.B(C.onDidInstallExtensions(v=>this.g(v))),this.B(C.onDidUninstallExtension(v=>this.h(v)))}g(I){for(const w of I)w.local&&this.invalidate(w.profileLocation)}h(I){I.error||this.invalidate(I.profileLocation)}async invalidate(I){if(I)for(const w of this.a.profiles)this.c.extUri.isEqual(w.extensionsResource,I)&&await this.j(w);else await this.j(this.a.defaultProfile)}async j(I){try{await this.b.del(this.c.extUri.joinPath(I.cacheHome,R.$Rl))}catch(w){(0,r.$kk)(w)!==1&&this.f.error(w)}}}e.$yp=P}),define(we[44],pe([1,0,15,11,2,191,55,6,13,35]),function(le,e,y,R,r,P,L,I,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ro=e.$Qo=e.$Po=e.$Oo=e.$No=e.$Mo=e.$Lo=e.$Ko=void 0,e.$Ko=(0,I.$Lh)("requestService");class C{constructor(h){this.b=h}toJSON(){if(!this.a){const h=Object.create(null);for(const t in this.b)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?h[t]="*****":h[t]=this.b[t];this.a=h}return this.a}}class E extends r.$Qc{constructor(h){super(),this.b=0,this.a=h.createLogger("network",{name:(0,P.localize)(0,null),when:w.$kj.isEqualTo((0,w.$ij)(w.LogLevel.Trace)).serialize()})}async c(h,t,s){const o=`${h} #${++this.b}: ${t.url}`;this.a.trace(`${o} - begin`,t.type,new C(t.headers??{}));try{const i=await s();return this.a.trace(`${o} - end`,t.type,i.res.statusCode,i.res.headers),i}catch(i){throw this.a.error(`${o} - error`,t.type,(0,R.$8)(i)),i}}}e.$Lo=E;function v(p){return p.res.statusCode&&p.res.statusCode>=200&&p.res.statusCode<300||p.res.statusCode===1223}e.$Mo=v;function d(p){return p.res.statusCode===204}e.$No=d;async function g(p){return d(p)?null:(await(0,y.$le)(p.stream)).toString()}e.$Oo=g;async function m(p){if(!v(p))throw new Error("Server returned "+p.res.statusCode);return g(p)}e.$Po=m;async function l(p){if(!v(p))throw new Error("Server returned "+p.res.statusCode);if(d(p))return null;const t=(await(0,y.$le)(p.stream)).toString();try{return JSON.parse(t)}catch(s){throw s.message+=`:
`+t,s}}e.$Qo=l;function f(p){c(p)}e.$Ro=f;let u;function c(p){const h=b.$0m.as(L.$cn.Configuration),t=u;u={id:"http",order:15,title:(0,P.localize)(1,null),type:"object",scope:p,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,P.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,P.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,P.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,P.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,P.localize)(6,null),(0,P.localize)(7,null),(0,P.localize)(8,null),(0,P.localize)(9,null)],default:"override",description:(0,P.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,P.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,P.localize)(12,null),restricted:!0}}},h.updateConfigurations({add:[u],remove:t?[t]:[]})}c(1)}),define(we[231],pe([1,0,20,12,16,44]),function(le,e,y,R,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ON=void 0;let L=class{constructor(w,b){this.a=w,this.b=b}async download(w,b,C=y.CancellationToken.None){if(w.scheme===R.Schemas.file||w.scheme===R.Schemas.vscodeRemote){await this.b.copy(w,b);return}const E={type:"GET",url:w.toString(!0)},v=await this.a.request(E,C);if(v.res.statusCode===200)await this.b.writeFile(b,v.stream);else{const d=await(0,P.$Po)(v);throw new Error(`Expected 200, got back ${v.res.statusCode} instead.

${d}`)}}};e.$ON=L,e.$ON=L=Oe([Ae(0,P.$Ko),Ae(1,r.$7j)],L)}),define(we[232],pe([1,0,15,20]),function(le,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oq=e.$Nq=void 0;class r{constructor(I){this.a=I}listen(I,w){throw new Error("Invalid listen")}call(I,w,b,C=R.CancellationToken.None){switch(w){case"request":return this.a.request(b[0],C).then(async({res:E,stream:v})=>{const d=await(0,y.$le)(v);return[{statusCode:E.statusCode,headers:E.headers},d]});case"resolveProxy":return this.a.resolveProxy(b[0])}throw new Error("Invalid call")}}e.$Nq=r;class P{constructor(I){this.a=I}async request(I,w){const[b,C]=await this.a.call("request",[I],w);return{res:b,stream:(0,y.$ne)(C)}}async resolveProxy(I){return this.a.call("resolveProxy",[I])}}e.$Oq=P}),define(we[233],pe([1,0,84,8]),function(le,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pq=void 0;function r(L,I){return L.protocol==="http:"?I.HTTP_PROXY||I.http_proxy||null:L.protocol==="https:"&&(I.HTTPS_PROXY||I.https_proxy||I.HTTP_PROXY||I.http_proxy)||null}async function P(L,I,w={}){const b=(0,y.parse)(L),C=w.proxyUrl||r(b,I);if(!C)return null;const E=(0,y.parse)(C);if(!/^https?:$/.test(E.protocol||""))return null;const v={host:E.hostname||"",port:E.port||(E.protocol==="https"?"443":"80"),auth:E.auth,rejectUnauthorized:(0,R.$Cf)(w.strictSSL)?w.strictSSL:!0};return b.protocol==="http:"?new(await new Promise((d,g)=>{le(["http-proxy-agent"],d,g)}))(v):new(await new Promise((d,g)=>{le(["https-proxy-agent"],d,g)}))(v)}e.$Pq=P}),define(we[85],pe([1,0,52,7,192,20,39,11,3,23,105,209,14,144]),function(le,e,y,R,r,P,L,I,w,b,C,E,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ol=void 0;let g;async function m(f,u,c,p){return c["force-disable-user-env"]?(u.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):w.$d?(u.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,E.$Il)(p)&&!c["force-user-env"]?(u.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,E.$Il)(p)?u.trace("resolveShellEnv(): running (--force-user-env)"):u.trace("resolveShellEnv(): running (macOS/Linux)"),g||(g=v.Promises.withAsyncBody(async(h,t)=>{const s=new P.$Vd;let o=1e4;const i=f.getValue("application.shellEnvironmentResolutionTimeout");typeof i=="number"&&(o=(0,d.$Jl)(i,1,120)*1e3);const n=setTimeout(()=>{s.dispose(!0),t(new Error((0,r.localize)(0,null)))},o);try{h(await l(u,s.token))}catch(a){!(0,I.$2)(a)&&!s.token.isCancellationRequested?t(new Error((0,r.localize)(1,null,(0,L.$wi)(a)))):h({})}finally{clearTimeout(n),s.dispose()}})),g)}e.$Ol=m;async function l(f,u){const c=process.env.ELECTRON_RUN_AS_NODE;f.trace("getUnixShellEnvironment#runAsNode",c);const p=process.env.ELECTRON_NO_ATTACH_CONSOLE;f.trace("getUnixShellEnvironment#noAttach",p);const h=(0,b.$bg)().replace(/-/g,"").substr(0,12),t=new RegExp(h+"({.*})"+h),s={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};f.trace("getUnixShellEnvironment#env",s);const o=await(0,C.$yl)(w.OS,s);return f.trace("getUnixShellEnvironment#shell",o),new Promise((i,n)=>{if(u.isCancellationRequested)return n(new I.$3);const a=(0,R.$lc)(o);let $,S;const D=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(a)?($=`& '${process.execPath}' ${D} -p '''${h}'' + JSON.stringify(process.env) + ''${h}'''`,S=["-Login","-Command"]):a==="nu"?($=`^'${process.execPath}' ${D} -p '"${h}" + JSON.stringify(process.env) + "${h}"'`,S=["-i","-l","-c"]):($=`'${process.execPath}' ${D} -p '"${h}" + JSON.stringify(process.env) + "${h}"'`,a==="tcsh"||a==="csh"?S=["-ic"]:S=["-i","-l","-c"]),f.trace("getUnixShellEnvironment#spawn",JSON.stringify(S),$);const k=(0,y.spawn)(o,[...S,$],{detached:!0,stdio:["ignore","pipe","pipe"],env:s});u.onCancellationRequested(()=>(k.kill(),n(new I.$3))),k.on("error",Z=>{f.error("getUnixShellEnvironment#errorChildProcess",(0,L.$wi)(Z)),n(Z)});const A=[];k.stdout.on("data",Z=>A.push(Z));const j=[];k.stderr.on("data",Z=>j.push(Z)),k.on("close",(Z,ae)=>{const K=Buffer.concat(A).toString("utf8");f.trace("getUnixShellEnvironment#raw",K);const se=Buffer.concat(j).toString("utf8");if(se.trim()&&f.trace("getUnixShellEnvironment#stderr",se),Z||ae)return n(new Error((0,r.localize)(2,null,Z,ae)));const ue=t.exec(K),x=ue?ue[1]:"{}";try{const he=JSON.parse(x);c?he.ELECTRON_RUN_AS_NODE=c:delete he.ELECTRON_RUN_AS_NODE,p?he.ELECTRON_NO_ATTACH_CONSOLE=p:delete he.ELECTRON_NO_ATTACH_CONSOLE,delete he.VSCODE_RESOLVING_ENVIRONMENT,delete he.XDG_RUNTIME_DIR,f.trace("getUnixShellEnvironment#result",he),i(he)}catch(he){f.error("getUnixShellEnvironment#errorCaught",(0,L.$wi)(he)),n(he)}})})}}),define(we[234],pe([1,0,6]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nN=e.$mN=void 0,e.$mN=(0,y.$Lh)("stateReadService"),e.$nN=(0,y.$Lh)("stateService")}),define(we[235],pe([1,0,14,15,2,8,25,16,13]),function(le,e,y,R,r,P,L,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qN=e.$pN=e.$oN=e.SaveStrategy=void 0;var b;(function(d){d[d.IMMEDIATE=0]="IMMEDIATE",d[d.DELAYED=1]="DELAYED"})(b||(e.SaveStrategy=b={}));class C extends r.$Qc{constructor(g,m,l,f){super(),this.h=g,this.j=l,this.m=f,this.a=Object.create(null),this.b="",this.f=void 0,this.g=void 0,this.c=m===0?void 0:this.B(new y.$Og(100))}init(){return this.f||(this.f=this.n()),this.f}async n(){try{this.b=(await this.m.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch(g){g.fileOperationResult!==1&&this.j.error(g)}}getItem(g,m){const l=this.a[g];return(0,P.$Ff)(l)?m:l}setItem(g,m){this.setItems([{key:g,data:m}])}setItems(g){let m=!1;for(const{key:l,data:f}of g)this.a[l]!==f&&((0,P.$Ff)(f)?(0,P.$Df)(this.a[l])||(this.a[l]=void 0,m=!0):(this.a[l]=f,m=!0));m&&this.r()}removeItem(g){(0,P.$Df)(this.a[g])||(this.a[g]=void 0,this.r())}async r(){if(!this.g)return this.c?this.c.trigger(()=>this.s()):this.s()}async s(){if(!this.f)return;await this.f;const g=JSON.stringify(this.a,null,4);if(g!==this.b)try{await this.m.writeFile(this.h,R.$_d.fromString(g),{atomic:{postfix:".vsctmp"}}),this.b=g}catch(m){this.j.error(m)}}async close(){return this.g||(this.g=this.c?this.c.trigger(()=>this.s(),0):this.s()),this.g}}e.$oN=C;let E=class extends r.$Qc{constructor(g,m,l,f){super(),this.a=this.B(new C(m.stateResource,g,l,f))}async init(){await this.a.init()}getItem(g,m){return this.a.getItem(g,m)}};e.$pN=E,e.$pN=E=Oe([Ae(1,L.$Sh),Ae(2,w.$6i),Ae(3,I.$7j)],E);class v extends E{setItem(g,m){this.a.setItem(g,m)}setItems(g){this.a.setItems(g)}removeItem(g){this.a.removeItem(g)}close(){return this.a.close()}}e.$qN=v}),define(we[119],pe([1,0,3,28,23]),function(le,e,y,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ao=e.$_n=void 0;function P(w){if(y.$o===2&&/^penguin(\.|$)/i.test(w))return"chromebook"}function L(w,b,C,E,v,d,g,m){const l=Object.create(null);l["common.machineId"]=d,l.sessionID=(0,r.$bg)()+Date.now(),l.commitHash=E,l.version=v,l["common.platformVersion"]=(w||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),l["common.platform"]=(0,y.$c)(y.$o),l["common.nodePlatform"]=R.$bc,l["common.nodeArch"]=C,l["common.product"]=m||"desktop",g&&(l["common.msftInternal"]=g);let f=0;const u=Date.now();Object.defineProperties(l,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-u,enumerable:!0},"common.sequence":{get:()=>f++,enumerable:!0}}),y.$g&&(l["common.snap"]="true");const c=P(b);return c&&(l["common.platformDetail"]=c),l}e.$_n=L;function I(w){const b=R.env.USERDNSDOMAIN;if(!b)return!1;const C=b.toLowerCase();return w.some(E=>C===E)}e.$ao=I}),define(we[236],pe([1,0,18,11,2,22,16]),function(le,e,y,R,r,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ErrorEvent=void 0;var I;(function(b){function C(E,v){return E.callstack<v.callstack?-1:E.callstack>v.callstack?1:0}b.compare=C})(I||(e.ErrorEvent=I={}));class w{constructor(C,E=w.ERROR_FLUSH_TIMEOUT){this.f=-1,this.g=[],this.h=new r.$Pc,this.c=C,this.d=E;const v=R.$V.addListener(d=>this.j(d));this.h.add((0,r.$Oc)(v)),this.i()}dispose(){clearTimeout(this.f),this.l(),this.h.dispose()}i(){}j(C){if(!C||C.code||(C.detail&&C.detail.stack&&(C=C.detail),R.$_.isErrorNoTelemetry(C)||C instanceof L.$ok||typeof C?.message=="string"&&C.message.includes("Unable to read file")))return;const E=Array.isArray(C.stack)?C.stack.join(`
`):C.stack,v=C.message?C.message:(0,P.$3m)(C);E&&this.k({msg:v,callstack:E})}k(C){const E=(0,y.$ub)(this.g,C,I.compare);E<0?(C.count=1,this.g.splice(~E,0,C)):(this.g[E].count||(this.g[E].count=0),this.g[E].count+=1),this.f===-1&&(this.f=setTimeout(()=>{this.l(),this.f=-1},this.d))}l(){for(const C of this.g)this.c.publicLogError2("UnhandledError",C);this.g.length=0}}w.ERROR_FLUSH_TIMEOUT=5*1e3,e.default=w}),define(we[237],pe([1,0,2]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gr=void 0;class R extends y.$Qc{constructor(P,L){super(),this.a=P,this.b=L}async call(P,L,I){switch(L){case"updateTelemetryLevel":{const{telemetryLevel:w}=I;return this.a.updateInjectedTelemetryLevel(w)}case"logTelemetry":{const{eventName:w,data:b}=I;return this.b?this.b.log(w,b):Promise.resolve()}case"flushTelemetry":return this.b?this.b.flush():Promise.resolve();case"ping":return}throw new Error(`IPC Command ${L} not found`)}listen(P,L,I){throw new Error("Not supported")}dispose(){this.a.updateInjectedTelemetryLevel(0),super.dispose()}}e.$Gr=R}),define(we[32],pe([1,0,6]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$gl=e.$fl=e.$el=e.$dl=e.$cl=e.$bl=e.$al=e.$_k=e.$$k=e.$0k=void 0,e.$0k=(0,y.$Lh)("telemetryService"),e.$$k=(0,y.$Lh)("customEndpointTelemetryService"),e.$_k="telemetry.currentSessionDate",e.$al="telemetry.firstSessionDate",e.$bl="telemetry.lastSessionDate",e.$cl="telemetry.machineId",e.$dl="telemetry",e.$el="telemetry.telemetryLevel",e.$fl="telemetry.enableCrashReporter",e.$gl="telemetry.enableTelemetry";var R;(function(P){P[P.NONE=0]="NONE",P[P.CRASH=1]="CRASH",P[P.ERROR=2]="ERROR",P[P.USAGE=3]="USAGE"})(R||(e.TelemetryLevel=R={}));var r;(function(P){P.OFF="off",P.CRASH="crash",P.ERROR="error",P.ON="all"})(r||(e.TelemetryConfiguration=r={}))}),define(we[238],pe([1,0,27,14,75,12,7,3,4,101,21,104,215,16,31,32]),function(le,e,y,R,r,P,L,I,w,b,C,E,v,d,g,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yr=e.$xr=e.$wr=e.$vr=void 0;const l=new Map;async function f(t,s){const o=`${t}::${s.join(":")}`,i=l.get(o);if(i)return i;const n=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],a=new Map,$=new Map,S=2e4;function D(A,j,Z,ae){const K=j.substring(A.length+1);return R.Promises.withAsyncBody(async se=>{let ue;try{ue=await C.Promises.readdir(j,{withFileTypes:!0})}catch{se();return}if(ae.count>=S){ae.count+=ue.length,ae.maxReached=!0,se();return}let x=ue.length;if(x===0){se();return}let he=ue;ae.count+ue.length>S&&(ae.maxReached=!0,x=S-ae.count,he=ue.slice(0,x)),ae.count+=ue.length;for(const V of he)if(V.isDirectory()){if(Z.includes(V.name)||await D(A,(0,L.$hc)(j,V.name),Z,ae),--x===0){se();return}}else{const te=V.name.lastIndexOf(".");if(te>=0){const G=V.name.substring(te+1);G&&a.set(G,(a.get(G)??0)+1)}for(const G of n)G.relativePathPattern?.test(K)!==!1&&G.filePattern.test(V.name)&&$.set(G.tag,($.get(G.tag)??0)+1);if(--x===0){se();return}}})}const k=R.Promises.withAsyncBody(async A=>{const j={count:0,maxReached:!1};await D(t,t,s,j);const Z=await p(t);A({configFiles:u($),fileTypes:u(a),fileCount:j.count,maxFilesReached:j.maxReached,launchConfigFiles:Z})});return l.set(o,k),k}e.$vr=f;function u(t){return Array.from(t.entries(),([s,o])=>({name:s,count:o})).sort((s,o)=>o.count-s.count)}function c(){const t={os:`${y.type()} ${y.arch()} ${y.release()}`,memory:`${(y.totalmem()/d.$Bk.GB).toFixed(2)}GB (${(y.freemem()/d.$Bk.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(b.$Jm.value()*100)}%`},s=y.cpus();return s&&s.length>0&&(t.cpus=`${s[0].model} (${s.length} x ${s[0].speed})`),t}e.$wr=c;async function p(t){try{const s=new Map,o=(0,L.$hc)(t,".vscode","launch.json"),i=await C.Promises.readFile(o),n=[],a=(0,r.$Nm)(i.toString(),n);if(n.length)return console.log(`Unable to parse ${o}`),[];if((0,r.$Wm)(a)==="object"&&a.configurations)for(const $ of a.configurations){const S=$.type;S&&(s.has(S)?s.set(S,s.get(S)+1):s.set(S,1))}return u(s)}catch{return[]}}e.$xr=p;let h=class{constructor(s,o){this.c=s,this.d=o}f(s){const o=[];return o.push(`OS Version:       ${s.os}`),o.push(`CPUs:             ${s.cpus}`),o.push(`Memory (System):  ${s.memory}`),o.push(`VM:               ${s.vmHint}`),o.join(`
`)}g(s){const o=[];o.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),o.push(`OS Version:       ${y.type()} ${y.arch()} ${y.release()}`);const i=y.cpus();return i&&i.length>0&&o.push(`CPUs:             ${i[0].model} (${i.length} x ${i[0].speed})`),o.push(`Memory (System):  ${(y.totalmem()/d.$Bk.GB).toFixed(2)}GB (${(y.freemem()/d.$Bk.GB).toFixed(2)}GB free)`),I.$d||o.push(`Load (avg):       ${y.loadavg().map(n=>Math.round(n)).join(", ")}`),o.push(`VM:               ${Math.round(b.$Jm.value()*100)}%`),o.push(`Screen Reader:    ${s.screenReader?"yes":"no"}`),o.push(`Process Argv:     ${s.mainArguments.join(" ")}`),o.push(`GPU Status:       ${this.j(s.gpuFeatureStatus)}`),o.join(`
`)}async getPerformanceInfo(s,o){return Promise.all([(0,E.$ur)(s.mainPID),this.k(s)]).then(async i=>{let[n,a]=i,$=this.m(s,n);return o.forEach(S=>{if((0,v.$jm)(S))$+=`
${S.errorMessage}`,a+=`
${S.errorMessage}`;else if($+=`

Remote: ${S.hostName}`,S.processes&&($+=`
${this.m(s,S.processes)}`),S.workspaceMetadata){a+=`
|  Remote: ${S.hostName}`;for(const D of Object.keys(S.workspaceMetadata)){const k=S.workspaceMetadata[D];let A=`${k.fileCount} files`;k.maxFilesReached&&(A=`more than ${A}`),a+=`|    Folder (${D}): ${A}`,a+=this.h(k)}}}),{processInfo:$,workspaceInfo:a}})}async getSystemInfo(s,o){const{memory:i,vmHint:n,os:a,cpus:$}=c(),S={os:a,memory:i,cpus:$,vmHint:n,processArgs:`${s.mainArguments.join(" ")}`,gpuStatus:s.gpuFeatureStatus,screenReader:`${s.screenReader?"yes":"no"}`,remoteData:o};return I.$d||(S.load=`${y.loadavg().map(D=>Math.round(D)).join(", ")}`),I.$f&&(S.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(S)}async getDiagnostics(s,o){const i=[];return(0,E.$ur)(s.mainPID).then(async n=>(i.push(""),i.push(this.g(s)),i.push(""),i.push(this.m(s,n)),s.windows.some(a=>a.folderURIs&&a.folderURIs.length>0&&!a.remoteAuthority)&&(i.push(""),i.push("Workspace Stats: "),i.push(await this.k(s))),o.forEach(a=>{if((0,v.$jm)(a))i.push(`
${a.errorMessage}`);else if(i.push(`

`),i.push(`Remote:           ${a.hostName}`),i.push(this.f(a.machineInfo)),a.processes&&i.push(this.m(s,a.processes)),a.workspaceMetadata)for(const $ of Object.keys(a.workspaceMetadata)){const S=a.workspaceMetadata[$];let D=`${S.fileCount} files`;S.maxFilesReached&&(D=`more than ${D}`),i.push(`Folder (${$}): ${D}`),i.push(this.h(S))}}),i.push(""),i.push(""),i.join(`
`)))}h(s){const o=[];let n=0;const a=(k,A)=>{const j=` ${k}(${A})`;n+j.length>60?(o.push($),$="|                 ",n=$.length):n+=j.length,$+=j};let $="|      File types:";const S=10,D=s.fileTypes.length>S?S:s.fileTypes.length;for(let k=0;k<D;k++){const A=s.fileTypes[k];a(A.name,A.count)}if(o.push($),s.configFiles.length>=0&&($="|      Conf files:",n=0,s.configFiles.forEach(k=>{a(k.name,k.count)}),o.push($)),s.launchConfigFiles.length>0){let k="|      Launch Configs:";s.launchConfigFiles.forEach(A=>{const j=A.count>1?` ${A.name}(${A.count})`:` ${A.name}`;k+=j}),o.push(k)}return o.join(`
`)}j(s){const o=Math.max(...Object.keys(s).map(i=>i.length));return Object.keys(s).map(i=>`${i}:  ${" ".repeat(o-i.length)}  ${s[i]}`).join(`
                  `)}k(s){const o=[],i=[];return s.windows.forEach(n=>{n.folderURIs.length===0||n.remoteAuthority||(o.push(`|  Window (${n.title})`),n.folderURIs.forEach(a=>{const $=w.URI.revive(a);if($.scheme===P.Schemas.file){const S=$.fsPath;i.push(f(S,["node_modules",".git"]).then(D=>{let k=`${D.fileCount} files`;D.maxFilesReached&&(k=`more than ${k}`),o.push(`|    Folder (${(0,L.$lc)(S)}): ${k}`),o.push(this.h(D))}).catch(D=>{o.push(`|      Error: Unable to collect workspace stats for folder ${S} (${D.toString()})`)}))}else o.push(`|    Folder (${$.toString()}): Workspace stats not available.`)}))}),Promise.all(i).then(n=>o.join(`
`)).catch(n=>`Unable to collect workspace stats: ${n}`)}m(s,o){const i=new Map;s.windows.forEach(a=>i.set(a.pid,`window [${a.id}] (${a.title})`)),s.pidToNames.forEach(({pid:a,name:$})=>i.set(a,$));const n=[];return n.push("CPU %	Mem MB	   PID	Process"),o&&this.n(s.mainPID,i,n,o,0),n.join(`
`)}n(s,o,i,n,a){const $=a===0;let S;$?S=n.pid===s?`${this.d.applicationName} main`:"remote agent":o.has(n.pid)?S=o.get(n.pid):S=`${"  ".repeat(a)} ${n.name}`;const D=process.platform==="win32"?n.mem:y.totalmem()*(n.mem/100);i.push(`${n.load.toFixed(0).padStart(5," ")}	${(D/d.$Bk.MB).toFixed(0).padStart(6," ")}	${n.pid.toFixed(0).padStart(6," ")}	${S}`),Array.isArray(n.children)&&n.children.forEach(k=>this.n(s,o,i,k,a+1))}async getWorkspaceFileExtensions(s){const o=new Set;for(const{uri:i}of s.folders){const n=w.URI.revive(i);if(n.scheme!==P.Schemas.file)continue;const a=n.fsPath;try{(await f(a,["node_modules",".git"])).fileTypes.forEach(S=>o.add(S.name))}catch{}}return{extensions:[...o]}}async reportWorkspaceStats(s){for(const{uri:o}of s.folders){const i=w.URI.revive(o);if(i.scheme!==P.Schemas.file)continue;const n=i.fsPath;try{const a=await f(n,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":s.telemetryId,rendererSessionId:s.rendererSessionId}),a.fileTypes.forEach($=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:s.rendererSessionId,type:$.name,count:$.count})}),a.launchConfigFiles.forEach($=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:s.rendererSessionId,type:$.name,count:$.count})}),a.configFiles.forEach($=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:s.rendererSessionId,type:$.name,count:$.count})})}catch{}}}};e.$yr=h,e.$yr=h=Oe([Ae(0,m.$0k),Ae(1,g.$lj)],h)}),define(we[36],pe([1,0,22,8,5,24,56,119,32]),function(le,e,y,R,r,P,L,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qo=e.$po=e.$oo=e.$no=e.$mo=e.$lo=e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.$co=e.$bo=void 0;class b{constructor(n){this.value=n,this.isTrustedTelemetryValue=!0}}e.$bo=b;class C{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$co=C,e.$do=new C;class E{async publicLog(n,a,$){}async publicLogError(n,a,$){}}e.$eo=E,e.$fo="telemetry",e.$go="extensionTelemetryLog",e.$ho={log:()=>null,flush:()=>Promise.resolve(null)};function v(i,n){return r.Event.debounce(n.onDidChangeConfiguration,($,S)=>{const D=$?new Set([...$.affectedKeys,...S.affectedKeys]):S.affectedKeys;return{...S,affectedKeys:D}},1e3,!0)($=>{$.source!==7&&i.publicLog2("updateConfiguration",{configurationSource:(0,P.$ii)($.source),configurationKeys:Array.from($.affectedKeys)})})}e.$io=v;function d(i,n){return!n.isBuilt&&!n.disableTelemetry?!0:!(n.disableTelemetry||!i.enableTelemetry)}e.$jo=d;function g(i,n){return n.extensionTestsLocationURI?!0:!(n.isBuilt||n.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}e.$ko=g;function m(i){const n=i.getValue(w.$el),a=i.getValue(w.$fl);if(i.getValue(w.$gl)===!1||a===!1)return 0;switch(n??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$lo=m;function l(i){const n={},a={},$={};c(i,$);for(let S in $){S=S.length>150?S.substr(S.length-149):S;const D=$[S];typeof D=="number"?a[S]=D:typeof D=="boolean"?a[S]=D?1:0:typeof D=="string"?(D.length>8192&&console.warn(`Telemetry property: ${S} has been trimmed to 8192, the original length is ${D.length}`),n[S]=D.substring(0,8191)):typeof D<"u"&&D!==null&&(n[S]=D)}return{properties:n,measurements:a}}e.$mo=l;const f=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function u(i){if(!i)return"none";const n=(0,L.$Qk)(i);return f.has(n)?n:"other"}e.$no=u;function c(i,n,a=0,$){if(i)for(const S of Object.getOwnPropertyNames(i)){const D=i[S],k=$?$+S:S;Array.isArray(D)?n[k]=(0,y.$3m)(D):D instanceof Date?n[k]=D.toISOString():(0,R.$yf)(D)?a<2?c(D,n,a+1,k+"."):n[k]=(0,y.$3m)(D):n[k]=D}}function p(i,n){const a=i.msftInternalDomains||[],$=n.getValue("telemetry.internalTesting");return(0,I.$ao)(a)||$}e.$oo=p;function h(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}e.$po=h;function t(i,n){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let a=i;const $=[];for(const A of n)for(;;){const j=A.exec(i);if(!j)break;$.push([j.index,A.lastIndex])}const S=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,D=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let k=0;for(a="";;){const A=D.exec(i);if(!A)break;const j=$.some(([Z,ae])=>A.index<ae&&Z<D.lastIndex);!S.test(A[0])&&!j&&(a+=i.substring(k,A.index)+"<REDACTED: user-file-path>",k=D.lastIndex)}return k<i.length&&(a+=i.substr(k)),a}function s(i){if(!i)return i;const n=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const a of n)if(a.regex.test(i))return`<REDACTED: ${a.label}>`;return i}function o(i,n){return(0,y.$Zm)(i,a=>{if(a instanceof b||Object.hasOwnProperty.call(a,"isTrustedTelemetryValue"))return a.value;if(typeof a=="string"){let $=a.replaceAll("%20"," ");$=t($,n);for(const S of n)$=$.replace(S,"");return $=s($),$}})}e.$qo=o}),define(we[37],pe([1,0,17,30,40,3,4,11,28,36]),function(le,e,y,R,r,P,L,I,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=void 0;function C(o,i){return o.uuid&&i.uuid?o.uuid===i.uuid:o.id===i.id?!0:(0,y.$Ue)(o.id,i.id)===0}e.$ro=C;const E=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class v{static create(i){const n=i.manifest?i.manifest.version:i.version,a=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new v(i.identifier,n,a)}static parse(i){const n=E.exec(i);return n&&n[1]&&n[2]?new v({id:n[1]},n[2],n[4]||void 0):null}constructor(i,n,a="undefined"){this.version=n,this.targetPlatform=a,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof v?C(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.$so=v;const d=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function g(o){const i=d.exec(o);return i&&i[1]?[l(i[1]),i[2]]:[l(o),void 0]}e.$to=g;function m(o,i){return`${o}.${i}`}e.$uo=m;function l(o){return o.toLowerCase()}e.$vo=l;function f(o,i){return l(m(o??r.$Tl,i))}e.$wo=f;function u(o,i){const n=[],a=$=>{for(const S of n)if(S.some(D=>C(i(D),i($))))return S;return null};for(const $ of o){const S=a($);S?S.push($):n.push([$])}return n}e.$xo=u;function c(o){return{id:o.identifier.id,name:o.manifest.name,galleryId:null,publisherId:o.publisherId,publisherName:o.manifest.publisher,publisherDisplayName:o.publisherDisplayName,dependencies:o.manifest.extensionDependencies&&o.manifest.extensionDependencies.length>0}}e.$yo=c;function p(o){return{id:new b.$bo(o.identifier.id),name:new b.$bo(o.name),galleryId:o.identifier.uuid,publisherId:o.publisherId,publisherName:o.publisher,publisherDisplayName:o.publisherDisplayName,isPreReleaseVersion:o.properties.isPreReleaseVersion,dependencies:!!(o.properties.dependencies&&o.properties.dependencies.length>0),isSigned:o.isSigned,...o.telemetryData}}e.$zo=p,e.$Ao=new r.$Xl("pprice.better-merge");function h(o,i){const n=[],a=i.manifest.extensionDependencies?.slice(0)??[];for(;a.length;){const $=a.shift();if($&&n.every(S=>!C(S.identifier,{id:$}))){const S=o.filter(D=>C(D.identifier,{id:$}));S.length===1&&(n.push(S[0]),a.push(...S[0].manifest.extensionDependencies?.slice(0)??[]))}}return n}e.$Bo=h;async function t(o,i){if(!P.$f)return!1;let n;try{n=(await o.readFile(L.URI.file("/etc/os-release"))).value.toString()}catch{try{n=(await o.readFile(L.URI.file("/usr/lib/os-release"))).value.toString()}catch($){i.debug("Error while getting the os-release file.",(0,I.$8)($))}}return!!n&&(n.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function s(o,i){const n=await t(o,i),a=(0,R.$Wn)(n?"alpine":P.$o,w.$cc);return i.debug("ComputeTargetPlatform:",a),a}e.$Co=s}),define(we[120],pe([1,0,20,11,12,19,53,4,179,30,37,40]),function(le,e,y,R,r,P,L,I,w,b,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$o=void 0;const v=l=>(0,w.localize)(0,null,l),d=(0,w.localize)(1,null,"ms-dotnettools.csharp");function g(l,f){return f?`${l.publisher}.${l.name}@${l.version}`:`${l.publisher}.${l.name}`}let m=class{constructor(f,u,c){this.a=f,this.b=u,this.d=c}get f(){}async listExtensions(f,u,c){let p=await this.b.getInstalled(1,c);const h=E.$Wl.map(s=>s.toLowerCase());if(u&&u!==""){if(h.indexOf(u.toLowerCase())<0){this.a.info("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}p=p.filter(s=>s.manifest.categories?s.manifest.categories.map(i=>i.toLowerCase()).indexOf(u.toLowerCase())>-1:!1)}else if(u===""){this.a.info("Possible Categories: "),h.forEach(s=>{this.a.info(s)});return}this.f&&this.a.info((0,w.localize)(2,null,this.f)),p=p.sort((s,o)=>s.identifier.id.localeCompare(o.identifier.id));let t;for(const s of p)t!==s.identifier.id&&(t=s.identifier.id,this.a.info(g(s.manifest,f)))}async installExtensions(f,u,c,p){const h=[];try{const t=[];f.length&&this.a.info(this.f?(0,w.localize)(3,null,this.f):(0,w.localize)(4,null));const s=[];let o=[];const i=(a,$,S)=>{o.push({id:a,version:$!=="prerelease"?$:void 0,installOptions:{...c,isBuiltin:S,installPreReleaseVersion:$==="prerelease"||c.installPreReleaseVersion}})};for(const a of f)if(a instanceof I.URI)s.push({vsix:a,installOptions:c});else{const[$,S]=(0,C.$to)(a);i($,S,!1)}for(const a of u)if(a instanceof I.URI)s.push({vsix:a,installOptions:{...c,isBuiltin:!0,donotIncludePackAndDependencies:!0}});else{const[$,S]=(0,C.$to)(a);i($,S,!0)}const n=await this.b.getInstalled(1,c.profileLocation);if(s.length&&await Promise.all(s.map(async({vsix:a,installOptions:$})=>{try{const S=await this.g(a,$,p,n);S&&t.push(S)}catch(S){this.a.error(S),h.push(a.toString())}})),o.length&&(o=o.filter(({id:a,version:$})=>{const S=n.find(D=>(0,C.$ro)(D.identifier,{id:a}));if(S){if(!p&&(!$||$==="prerelease"&&S.preRelease))return this.a.info((0,w.localize)(5,null,a,S.manifest.version,a)),!1;if($&&S.manifest.version===$)return this.a.info((0,w.localize)(6,null,`${a}@${$}`)),!1}return!0}),o.length)){const a=await this.h(o);await Promise.all(o.map(async $=>{const S=a.get($.id.toLowerCase());if(S)try{const D=await this.j($,S,n);D&&t.push(D)}catch(D){this.a.error(D.message||D.stack||D),h.push($.id)}else this.a.error(`${v($.version?`${$.id}@${$.version}`:$.id)}
${d}`),h.push($.id)}))}}catch(t){throw this.a.error((0,w.localize)(7,null,(0,R.$8)(t))),t}if(h.length)throw new Error((0,w.localize)(8,null,h.join(", ")))}async g(f,u,c,p){const h=await this.b.getManifest(f);if(!h)throw new Error("Invalid vsix");if(await this.l(h,c,u.profileLocation,p))try{return await this.b.install(f,u),this.a.info((0,w.localize)(9,null,(0,P.$pg)(f))),h}catch(s){if((0,R.$2)(s))return this.a.info((0,w.localize)(10,null,(0,P.$pg)(f))),null;throw s}return null}async h(f){const u=new Map,c=f.some(t=>t.installOptions.installPreReleaseVersion),p=await this.b.getTargetPlatform(),h=[];for(const t of f)b.$Pn.test(t.id)&&h.push({...t,preRelease:c});if(h.length){const t=await this.d.getExtensions(h,{targetPlatform:p},y.CancellationToken.None);for(const s of t)u.set(s.identifier.id.toLowerCase(),s)}return u}async j({id:f,version:u,installOptions:c},p,h){const t=await this.d.getManifest(p,y.CancellationToken.None);if(t&&!this.k(t))return null;const s=h.find(o=>(0,C.$ro)(o.identifier,p.identifier));if(s){if(p.version===s.manifest.version)return this.a.info((0,w.localize)(11,null,u?`${f}@${u}`:f)),null;this.a.info((0,w.localize)(12,null,f,p.version))}try{c.isBuiltin?this.a.info(u?(0,w.localize)(13,null,f,u):(0,w.localize)(14,null,f)):this.a.info(u?(0,w.localize)(15,null,f,u):(0,w.localize)(16,null,f));const o=await this.b.installFromGallery(p,{...c,installGivenVersion:!!u});return this.a.info((0,w.localize)(17,null,f,o.manifest.version)),t}catch(o){if((0,R.$2)(o))return this.a.info((0,w.localize)(18,null,f)),null;throw o}}k(f){return!0}async l(f,u,c,p){if(!u){const h={id:(0,C.$wo)(f.publisher,f.name)},t=p.find(s=>(0,C.$ro)(h,s.identifier)&&(0,L.gt)(s.manifest.version,f.version));if(t)return this.a.info((0,w.localize)(19,null,t.identifier.id,t.manifest.version,f.version)),!1}return this.k(f)}async uninstallExtensions(f,u,c){const p=async t=>{if(t instanceof I.URI){const s=await this.b.getManifest(t);return g(s)}return t},h=[];for(const t of f){const s=await p(t),i=(await this.b.getInstalled(void 0,c)).filter(n=>(0,C.$ro)(n.identifier,{id:s}));if(!i.length)throw new Error(`${this.m(s)}
${d}`);if(i.some(n=>n.type===0)){this.a.info((0,w.localize)(20,null,s));return}if(!u&&i.some(n=>n.isBuiltin)){this.a.info((0,w.localize)(21,null,s));return}this.a.info((0,w.localize)(22,null,s));for(const n of i)await this.b.uninstall(n,{profileLocation:c}),h.push(n);this.f?this.a.info((0,w.localize)(23,null,s,this.f)):this.a.info((0,w.localize)(24,null,s))}}async locateExtension(f){const u=await this.b.getInstalled();f.forEach(c=>{u.forEach(p=>{if(p.identifier.id===c&&p.location.scheme===r.Schemas.file){this.a.info(p.location.fsPath);return}})})}m(f){return this.f?(0,w.localize)(25,null,f,this.f):(0,w.localize)(26,null,f)}};e.$$o=m,e.$$o=m=Oe([Ae(1,b.$4n),Ae(2,b.$2n)],m)}),define(we[239],pe([1,0,5,2,26,37,40]),function(le,e,y,R,r,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zp=void 0;class I extends R.$Qc{constructor(b,C,E,v,d,g,m){super(),this.f=b,this.g=C,this.h=E,this.j=v,this.m=d,this.n=g,this.r=m,this.a=this.B(new y.$Ld),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new R.$Yc),this.s().then(null,l=>m.error(l))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles(b=>this.u(b.added))),this.B(this.j.onAddExtensions(b=>this.w(b))),this.B(this.j.onDidAddExtensions(b=>this.y(b))),this.B(this.j.onRemoveExtensions(b=>this.z(b))),this.B(this.j.onDidRemoveExtensions(b=>this.C(b))),this.B(this.n.onDidFilesChange(b=>this.D(b)))}async u(b){try{b.length&&await Promise.all(b.map(C=>(this.c.set(C.id,(0,R.$Nc)(this.n.watch(this.m.extUri.dirname(C.extensionsResource)),this.n.watch(C.extensionsResource))),this.G(C.extensionsResource))))}catch(C){throw this.r.error(C),C}}async w(b){for(const C of b.extensions)this.I(this.L(C.identifier,C.version),b.profileLocation)}async y(b){for(const C of b.extensions){const E=this.L(C.identifier,C.version);b.error?this.J(E,b.profileLocation):this.I(E,b.profileLocation)}}async z(b){for(const C of b.extensions)this.J(this.L(C.identifier,C.version),b.profileLocation)}async C(b){const C=[],E=[];for(const v of b.extensions){const d=this.L(v.identifier,v.version);b.error?this.I(d,b.profileLocation):(this.J(d,b.profileLocation),this.b.has(d)||(this.r.debug("Extension is removed from all profiles",v.identifier.id,v.version),E.push(this.f.scanInstalledExtensionAtLocation(v.location).then(g=>{g?C.push(g):this.r.info("Extension not found at the location",v.location.toString())},g=>this.r.error(g)))))}try{await Promise.all(E),C.length&&await this.H(C)}catch(v){this.r.error(v)}}D(b){for(const C of this.h.profiles)b.contains(C.extensionsResource,0,1)&&this.F(C.extensionsResource)}async F(b){const C=[],E=[],v=await this.j.scanProfileExtensions(b),d=new Set,g=new Set;for(const[m,l]of this.b)l.has(b)&&g.add(m);for(const m of v){const l=this.L(m.identifier,m.version);d.add(l),g.has(l)||(C.push(m.identifier),this.I(l,b))}for(const m of g)if(!d.has(m)){const l=this.M(m);l&&(E.push(l.identifier),this.J(m,b))}(C.length||E.length)&&this.a.fire({added:C.length?{extensions:C,profileLocation:b}:void 0,removed:E.length?{extensions:E,profileLocation:b}:void 0})}async G(b){const C=await this.j.scanProfileExtensions(b);for(const E of C)this.I(this.L(E.identifier,E.version),b)}async H(b){b||(b=(await this.f.scanAllUserInstalledExtensions()).filter(E=>!this.b.has(this.L(E.identifier,E.manifest.version)))),b.length&&await this.f.markAsUninstalled(...b)}I(b,C){let E=this.b.get(b);E||this.b.set(b,E=new r.$zc(v=>this.m.extUri.getComparisonKey(v))),E.add(C)}J(b,C){const E=this.b.get(b);E&&E.delete(C),E?.size||this.b.delete(b)}L(b,C){return`${L.$Xl.toKey(b.id)}@${C}`}M(b){const[C,E]=(0,P.$to)(b);return E?{identifier:{id:C},version:E}:void 0}}e.$zp=I}),define(we[240],pe([1,0,212,36]),function(le,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5o=void 0;async function r(P,L,I,w,b,C,E){const v={"X-Market-Client-Id":`VSCode ${P}`,"User-Agent":`VSCode ${P} (${L.nameShort})`};if((0,R.$jo)(L,I)&&(0,R.$lo)(w)===3){const d=await(0,y.$4o)(I,b,C);v["X-Market-User-Id"]=d,v["VSCode-SessionId"]=E.machineId||d}return v}e.$5o=r}),define(we[121],pe([1,0,86,18,14,2,12,7,21,25,30,37,13,83,4]),function(le,e,y,R,r,P,L,I,w,b,C,E,v,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mq=void 0;let m=class extends d.$Lq{constructor(c,p,h,t){super(h),this.h=c,this.j=t,this.g=this.B(new l(p,t)),this.h.registerParticipant({postInstall:async s=>this.m(s),postUninstall:async s=>this.n(s)})}async getBuiltInExtensionTranslationsUri(c,p){const t=(await this.g.getLanguagePacks())[p];if(!t){this.j.warn(`No language pack found for ${p}`);return}const s=t.translations[c];return s?g.URI.file(s):void 0}async getInstalledLanguages(){const c=await this.g.getLanguagePacks(),p=Object.keys(c).map(h=>{const t=c[h];return{...this.f(h,t.label),extensionId:t.extensions[0].extensionIdentifier.id}});return p.push(this.f("en","English")),p.sort((h,t)=>h.label.localeCompare(t.label)),p}async m(c){c&&c.manifest&&c.manifest.contributes&&c.manifest.contributes.localizations&&c.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",c.identifier.id),await this.update())}async n(c){const p=await this.g.getLanguagePacks();Object.keys(p).some(h=>p[h]&&p[h].extensions.some(t=>(0,E.$ro)(t.extensionIdentifier,c.identifier)))&&(this.j.info("Removing language packs from the extension",c.identifier.id),await this.update())}async update(){const[c,p]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),h=await this.g.update(p);return!(0,R.$sb)(Object.keys(c),Object.keys(h))}};e.$Mq=m,e.$Mq=m=Oe([Ae(0,C.$4n),Ae(1,b.$Th),Ae(2,C.$2n),Ae(3,v.$6i)],m);let l=class extends P.$Qc{constructor(c,p){super(),this.j=p,this.c={},this.f=(0,I.$hc)(c.userDataPath,"languagepacks.json"),this.g=new r.$Xg}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update(c){return this.s(p=>{Object.keys(p).forEach(h=>delete p[h]),this.m(p,...c)}).then(()=>this.c)}m(c,...p){for(const h of p)h&&h.manifest&&h.manifest.contributes&&h.manifest.contributes.localizations&&h.manifest.contributes.localizations.length&&this.n(c,h);Object.keys(c).forEach(h=>this.r(c[h]))}n(c,p){const h=p.identifier,t=p.manifest.contributes&&p.manifest.contributes.localizations?p.manifest.contributes.localizations:[];for(const s of t)if(p.location.scheme===L.Schemas.file&&f(s)){let o=c[s.languageId];o||(o={hash:"",extensions:[],translations:{},label:s.localizedLanguageName??s.languageName},c[s.languageId]=o);const i=o.extensions.filter(n=>(0,E.$ro)(n.extensionIdentifier,h))[0];i?i.version=p.manifest.version:o.extensions.push({extensionIdentifier:h,version:p.manifest.version});for(const n of s.translations)o.translations[n.id]=(0,I.$hc)(p.location.fsPath,n.path)}}r(c){if(c){const p=(0,y.createHash)("md5");for(const h of c.extensions)p.update(h.extensionIdentifier.uuid||h.extensionIdentifier.id).update(h.version);c.hash=p.digest("hex")}}s(c=()=>null){return this.g.queue(()=>{let p=null;return w.Promises.readFile(this.f,"utf8").then(void 0,h=>h.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(h)).then(h=>{try{return JSON.parse(h)}catch{return{}}}).then(h=>(p=c(h),h)).then(h=>{for(const s of Object.keys(h))h[s]||delete h[s];this.c=h,this.h=!0;const t=JSON.stringify(this.c);return this.j.debug("Writing language packs",t),w.Promises.writeFile(this.f,t)}).then(()=>p,h=>this.j.error(h))})}};l=Oe([Ae(0,b.$Th),Ae(1,v.$6i)],l);function f(u){if(typeof u.languageId!="string"||!Array.isArray(u.translations)||u.translations.length===0)return!1;for(const c of u.translations)if(typeof c.id!="string"||typeof c.path!="string")return!1;return!(u.languageName&&typeof u.languageName!="string"||u.localizedLanguageName&&typeof u.localizedLanguageName!="string")}}),define(we[241],pe([1,0,151,11,22,36]),function(le,e,y,R,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iN=void 0;const L="https://mobile.events.data.microsoft.com/OneCollector/1.0",I="https://mobile.events.data.microsoft.com/ping";async function w(C,E,v){const d=await(0,y.$eC)("@microsoft/1ds-core-js","dist/ms.core.js"),g=await(0,y.$eC)("@microsoft/1ds-post-js","dist/ms.post.js"),m=new d.AppInsightsCore,l=new g.PostChannel,f={instrumentationKey:C,endpointUrl:L,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[l]]};if(v){f.extensionConfig={};const u={alwaysUseXhrOverride:!0,httpXHROverride:v};f.extensionConfig[l.identifier]=u}return m.initialize(f,[]),m.addTelemetryInitializer(u=>{E&&(u.ext=u.ext??{},u.ext.utc=u.ext.utc??{},u.ext.utc.flags=8462029)}),m}class b{constructor(E,v,d,g,m){this.e=E,this.f=v,this.g=d,this.h=m,this.c=L,this.d=I,this.g||(this.g={}),typeof g=="function"?this.a=g():this.a=g,this.b=null}i(E){if(this.a){if(typeof this.a!="string"){E(this.a);return}this.b||(this.b=w(this.a,this.e,this.h)),this.b.then(v=>{E(v)},v=>{(0,R.$Y)(v),console.error(v)})}}log(E,v){if(!this.a)return;v=(0,r.$1m)(v,this.g),v=(0,P.$mo)(v);const d=this.f+"/"+E;try{this.i(g=>{g.pluginVersionString=v?.properties.version??"Unknown",g.track({name:d,baseData:{name:d,properties:v?.properties,measurements:v?.measurements}})})}catch{}}flush(){return this.a?new Promise(E=>{this.i(v=>{v.unload(!0,()=>{this.a=void 0,E(void 0)})})}):Promise.resolve(void 0)}}e.$iN=b}),define(we[242],pe([1,0,2,22,3,17,193,24,55,54,31,35,32,36]),function(le,e,y,R,r,P,L,I,w,b,C,E,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sq=void 0;let g=class{constructor(f,u,c){this.k=u,this.l=c,this.d={},this.i=new y.$Pc,this.j=[],this.b=f.appenders,this.c=f.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=f.piiPaths||[],this.g=3,this.h=!!f.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const p of this.f)this.j.push(new RegExp((0,P.$De)(p),"gi")),p.indexOf("\\")>=0&&this.j.push(new RegExp((0,P.$De)(p.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(p=>{(p.affectsConfiguration(v.$el)||p.affectsConfiguration(v.$gl)||p.affectsConfiguration(v.$fl))&&this.m()}))}setExperimentProperty(f,u){this.d[f]=u}m(){let f=(0,d.$lo)(this.k);const u=this.l.enabledTelemetryLevels;if(u){this.h=this.sendErrorTelemetry?u.error:!1;const c=u.usage?3:u.error?2:0;f=Math.min(f,c)}this.g=f}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(f,u,c){this.g<u||(c=(0,R.$1m)(c,this.d),c=(0,d.$qo)(c,this.j),c=(0,R.$1m)(c,this.c),this.b.forEach(p=>p.log(f,c)))}publicLog(f,u){this.n(f,3,u)}publicLog2(f,u){this.publicLog(f,u)}publicLogError(f,u){this.h&&this.n(f,2,u)}publicLogError2(f,u){this.publicLogError(f,u)}};e.$Sq=g,g.IDLE_START_EVENT_NAME="UserIdleStart",g.IDLE_STOP_EVENT_NAME="UserIdleStop",e.$Sq=g=Oe([Ae(1,I.$fi),Ae(2,C.$lj)],g);function m(){const l=(0,L.localize)(0,null,b.default.nameLong),f=b.default.privacyStatementUrl?(0,L.localize)(2,null,"https://aka.ms/vscode-telemetry",b.default.privacyStatementUrl):(0,L.localize)(1,null,"https://aka.ms/vscode-telemetry"),u=r.$j?"":(0,L.localize)(3,null),c=(0,L.localize)(4,null),p=(0,L.localize)(5,null),h=(0,L.localize)(6,null),t=(0,L.localize)(7,null),s=`
|       | ${c} | ${p} | ${h} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,o=(0,L.localize)(8,null);return`
${l} ${f} ${u}

&nbsp;

${t}
${s}

&nbsp;

${o}
`}E.$0m.as(w.$cn.Configuration).registerConfiguration({id:v.$dl,order:1,type:"object",title:(0,L.localize)(9,null),properties:{[v.$el]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,L.localize)(10,null),(0,L.localize)(11,null),(0,L.localize)(12,null),(0,L.localize)(13,null)],markdownDescription:m(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),E.$0m.as(w.$cn.Configuration).registerConfiguration({id:v.$dl,order:110,type:"object",title:(0,L.localize)(14,null),properties:{[v.$gl]:{type:"boolean",markdownDescription:b.default.privacyStatementUrl?(0,L.localize)(16,null,b.default.nameLong,b.default.privacyStatementUrl):(0,L.localize)(15,null,b.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,L.localize)(17,null,`\`#${v.$el}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(we[243],pe([1,0,24,6,31,32,242,36]),function(le,e,y,R,r,P,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fr=e.$Er=e.$Dr=void 0;let w=class extends L.$Sq{constructor(C,E,v,d){super(C,v,d),this.o=E}publicLog(C,E){if(!(this.o<3))return super.publicLog(C,E)}publicLog2(C,E){return this.publicLog(C,E)}publicLogError(C,E){return this.o<2?Promise.resolve(void 0):super.publicLogError(C,E)}publicLogError2(C,E){return this.publicLogError(C,E)}async updateInjectedTelemetryLevel(C){if(C===void 0)throw this.o=0,new Error("Telemetry level cannot be undefined. This will cause infinite looping!");this.o=this.o?Math.min(this.o,C):C,this.o===0&&this.dispose()}};e.$Dr=w,e.$Dr=w=Oe([Ae(2,y.$fi),Ae(3,r.$lj)],w),e.$Er=new class extends I.$co{async updateInjectedTelemetryLevel(){}},e.$Fr=(0,R.$Mh)(P.$0k)}),define(we[244],pe([1,0,15,20,245,241]),function(le,e,y,R,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jN=void 0;async function L(C,E){const v=await E.request(C,R.CancellationToken.None),d=(await(0,y.$le)(v.stream)).toString(),g=v.res.statusCode??200;return{headers:v.res.headers,statusCode:g,responseData:d}}async function I(C){const E={method:C.type,headers:C.headers};return new Promise((d,g)=>{const m=r.request(C.url??"",E,l=>{l.on("data",function(f){d({headers:l.headers,statusCode:l.statusCode??200,responseData:f.toString()})}),l.on("error",function(f){g(f)})});m.write(C.data,l=>{l&&g(l)}),m.end()})}async function w(C,E,v){const d=typeof E.data=="string"?E.data:new TextDecoder().decode(E.data),g={type:"POST",headers:{...E.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(E.data).toString()},url:E.urlString,data:d};try{const m=C?await L(g,C):await I(g);v(m.statusCode,m.headers,m.responseData)}catch{v(0,{})}}class b extends P.$iN{constructor(E,v,d,g,m){const l={sendPOST:(f,u)=>{w(E,f,u)}};super(v,d,g,m,l)}}e.$jN=b}),define(we[246],pe([1,0,11,236]),function(le,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class r extends R.default{i(){(0,y.setUnexpectedErrorHandler)(I=>console.error(I));const L=[];process.on("unhandledRejection",(I,w)=>{L.push(w),setTimeout(()=>{const b=L.indexOf(w);b>=0&&w.catch(C=>{L.splice(b,1),(0,y.$2)(C)||(console.warn(`rejected promise not handled within 1 second: ${C}`),C.stack&&console.warn(`stack trace: ${C.stack}`),I&&(0,y.$Y)(I))})},1e3)}),process.on("rejectionHandled",I=>{const w=L.indexOf(I);w>=0&&L.splice(w,1)}),process.on("uncaughtException",I=>{(0,y.$X)(I)||(0,y.$Y)(I)})}}e.default=r}),define(we[122],pe([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var y;(function(R){R[R.Replace=1]="Replace",R[R.Append=2]="Append",R[R.Prepend=3]="Prepend"})(y||(e.EnvironmentVariableMutatorType=y={}))}),define(we[123],pe([1,0,3,122]),function(le,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ir=void 0;const r=new Map([[R.EnvironmentVariableMutatorType.Append,"APPEND"],[R.EnvironmentVariableMutatorType.Prepend,"PREPEND"],[R.EnvironmentVariableMutatorType.Replace,"REPLACE"]]);class P{constructor(C){this.collections=C,this.a=new Map,this.b=new Map,C.forEach((E,v)=>{this.d(E,v);const d=E.map.entries();let g=d.next();for(;!g.done;){const m=g.value[1],l=g.value[0];let f=this.a.get(l);if(f||(f=[],this.a.set(l,f)),f.length>0&&f[0].type===R.EnvironmentVariableMutatorType.Replace){g=d.next();continue}const u={extensionIdentifier:v,value:m.value,type:m.type,scope:m.scope,variable:m.variable,options:m.options};u.scope||delete u.scope,f.unshift(u),g=d.next()}})}async applyToProcessEnvironment(C,E,v){let d;y.$d&&(d={},Object.keys(C).forEach(g=>d[g.toLowerCase()]=g));for(const[g,m]of this.getVariableMap(E)){const l=y.$d&&d[g.toLowerCase()]||g;for(const f of m){const u=v?await v(f.value):f.value;if(f.options?.applyAtProcessCreation??!0)switch(f.type){case R.EnvironmentVariableMutatorType.Append:C[l]=(C[l]||"")+u;break;case R.EnvironmentVariableMutatorType.Prepend:C[l]=u+(C[l]||"");break;case R.EnvironmentVariableMutatorType.Replace:C[l]=u;break}if(f.options?.applyAtShellIntegration??!1){const c=`VSCODE_ENV_${r.get(f.type)}`;C[c]=(C[c]?C[c]+":":"")+g+"="+this.c(u)}}}}c(C){return C.replaceAll(":","\\x3a")}diff(C,E){const v=new Map,d=new Map,g=new Map;if(C.getVariableMap(E).forEach((m,l)=>{const f=this.getVariableMap(E).get(l),u=I(m,f);u&&v.set(l,u)}),this.getVariableMap(E).forEach((m,l)=>{const f=C.getVariableMap(E).get(l),u=I(m,f);u&&g.set(l,u)}),this.getVariableMap(E).forEach((m,l)=>{const f=C.getVariableMap(E).get(l),u=w(m,f);u&&d.set(l,u)}),!(v.size===0&&d.size===0&&g.size===0))return{added:v,changed:d,removed:g}}getVariableMap(C){const E=new Map;for(const v of this.a.values()){const d=v.filter(g=>L(g,C));d.length>0&&E.set(d[0].variable,d)}return E}getDescriptionMap(C){const E=new Map;for(const v of this.b.values()){const d=v.filter(g=>L(g,C,!0));for(const g of d)E.set(g.extensionIdentifier,g.description)}return E}d(C,E){if(!C.descriptionMap)return;const v=C.descriptionMap.entries();let d=v.next();for(;!d.done;){const g=d.value[1],m=d.value[0];let l=this.b.get(m);l||(l=[],this.b.set(m,l));const f={extensionIdentifier:E,scope:g.scope,description:g.description};f.scope||delete f.scope,l.push(f),d=v.next()}}}e.$ir=P;function L(b,C,E=!1){return b.scope?!!(b.scope.workspaceFolder&&C?.workspaceFolder&&b.scope.workspaceFolder.index===C.workspaceFolder.index):E?C===b.scope:!0}function I(b,C){if(!C)return b;const E=new Set;C.forEach(d=>E.add(d.extensionIdentifier));const v=[];return b.forEach(d=>{E.has(d.extensionIdentifier)||v.push(d)}),v.length===0?void 0:v}function w(b,C){if(!C)return;const E=new Map;C.forEach(d=>E.set(d.extensionIdentifier,d));const v=[];return b.forEach(d=>{const g=E.get(d.extensionIdentifier);g&&(d.type!==g.type||d.value!==g.value||d.scope?.workspaceFolder?.index!==g.scope?.workspaceFolder?.index)&&v.push(g)}),v.length===0?void 0:v}}),define(we[87],pe([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hr=e.$gr=e.$fr=e.$er=e.$dr=e.$cr=void 0;function y(w){return[...w.entries()]}e.$cr=y;function R(w){return w?[...w.entries()]:[]}e.$dr=R;function r(w){return new Map(w)}e.$er=r;function P(w){return new Map(w??[])}e.$fr=P;function L(w){return Array.from(w.entries()).map(b=>[b[0],y(b[1].map),R(b[1].descriptionMap)])}e.$gr=L;function I(w){return new Map(w.map(b=>[b[0],{map:r(b[1]),descriptionMap:P(b[2])}]))}e.$hr=I}),define(we[247],pe([1,0,14,20,5,2,13]),function(le,e,y,R,r,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6q=void 0;let I=class extends P.$Qc{constructor(b,C){super(),this.h=C,this.a=0,this.c=new Map,this.f=new Map,this.g=this.B(new r.$Ld),this.onCreateRequest=this.g.event,this.b=b===void 0?15e3:b,this.B((0,P.$Oc)(()=>{for(const E of this.f.values())(0,P.$Lc)(E)}))}createRequest(b){return new Promise((C,E)=>{const v=++this.a;this.c.set(v,C),this.g.fire({requestId:v,...b});const d=new R.$Vd;(0,y.$Rg)(this.b,d.token).then(()=>E(`Request ${v} timed out (${this.b}ms)`)),this.f.set(v,[(0,P.$Oc)(()=>d.cancel())])})}acceptReply(b,C){const E=this.c.get(b);E?(this.c.delete(b),(0,P.$Lc)(this.f.get(b)||[]),this.f.delete(b),E(C)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${b}`)}};e.$6q=I,e.$6q=I=Oe([Ae(1,L.$6i)],I)}),define(we[88],pe([1,0,6,66,35]),function(le,e,y,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2q=e.$1q=e.$Zq=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$Yq=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$Xq=void 0,e.$Xq=new R.$3i("terminalTabFocusMode",!1,!0);var P;(function(h){h.DefaultProfile="terminal.integrated.defaultProfile.",h.Profiles="terminal.integrated.profiles."})(P||(e.TerminalSettingPrefix=P={}));var L;(function(h){h.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",h.AutomationProfileLinux="terminal.integrated.automationProfile.linux",h.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",h.AutomationProfileWindows="terminal.integrated.automationProfile.windows",h.ProfilesWindows="terminal.integrated.profiles.windows",h.ProfilesMacOs="terminal.integrated.profiles.osx",h.ProfilesLinux="terminal.integrated.profiles.linux",h.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",h.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",h.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",h.UseWslProfiles="terminal.integrated.useWslProfiles",h.TabsDefaultColor="terminal.integrated.tabs.defaultColor",h.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",h.TabsEnabled="terminal.integrated.tabs.enabled",h.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",h.TabsHideCondition="terminal.integrated.tabs.hideCondition",h.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",h.TabsShowActions="terminal.integrated.tabs.showActions",h.TabsLocation="terminal.integrated.tabs.location",h.TabsFocusMode="terminal.integrated.tabs.focusMode",h.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",h.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",h.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",h.CopyOnSelection="terminal.integrated.copyOnSelection",h.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",h.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",h.FontFamily="terminal.integrated.fontFamily",h.FontSize="terminal.integrated.fontSize",h.LetterSpacing="terminal.integrated.letterSpacing",h.LineHeight="terminal.integrated.lineHeight",h.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",h.TabStopWidth="terminal.integrated.tabStopWidth",h.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",h.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",h.BellDuration="terminal.integrated.bellDuration",h.FontWeight="terminal.integrated.fontWeight",h.FontWeightBold="terminal.integrated.fontWeightBold",h.CursorBlinking="terminal.integrated.cursorBlinking",h.CursorStyle="terminal.integrated.cursorStyle",h.CursorStyleInactive="terminal.integrated.cursorStyleInactive",h.CursorWidth="terminal.integrated.cursorWidth",h.Scrollback="terminal.integrated.scrollback",h.DetectLocale="terminal.integrated.detectLocale",h.DefaultLocation="terminal.integrated.defaultLocation",h.GpuAcceleration="terminal.integrated.gpuAcceleration",h.TerminalTitleSeparator="terminal.integrated.tabs.separator",h.TerminalTitle="terminal.integrated.tabs.title",h.TerminalDescription="terminal.integrated.tabs.description",h.RightClickBehavior="terminal.integrated.rightClickBehavior",h.Cwd="terminal.integrated.cwd",h.ConfirmOnExit="terminal.integrated.confirmOnExit",h.ConfirmOnKill="terminal.integrated.confirmOnKill",h.EnableBell="terminal.integrated.enableBell",h.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",h.AllowChords="terminal.integrated.allowChords",h.AllowMnemonics="terminal.integrated.allowMnemonics",h.TabFocusMode="terminal.integrated.tabFocusMode",h.EnvMacOs="terminal.integrated.env.osx",h.EnvLinux="terminal.integrated.env.linux",h.EnvWindows="terminal.integrated.env.windows",h.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",h.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",h.ShowExitAlert="terminal.integrated.showExitAlert",h.SplitCwd="terminal.integrated.splitCwd",h.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",h.WordSeparators="terminal.integrated.wordSeparators",h.EnableFileLinks="terminal.integrated.enableFileLinks",h.UnicodeVersion="terminal.integrated.unicodeVersion",h.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",h.LocalEchoEnabled="terminal.integrated.localEchoEnabled",h.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",h.LocalEchoStyle="terminal.integrated.localEchoStyle",h.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",h.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",h.HideOnStartup="terminal.integrated.hideOnStartup",h.CustomGlyphs="terminal.integrated.customGlyphs",h.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",h.InheritEnv="terminal.integrated.inheritEnv",h.ShowLinkHover="terminal.integrated.showLinkHover",h.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",h.AutoReplies="terminal.integrated.autoReplies",h.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",h.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",h.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",h.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",h.ShellIntegrationSuggestEnabled="terminal.integrated.shellIntegration.suggestEnabled",h.EnableImages="terminal.integrated.enableImages",h.SmoothScrolling="terminal.integrated.smoothScrolling",h.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",h.FocusAfterRun="terminal.integrated.focusAfterRun",h.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",h.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",h.DevMode="terminal.integrated.developer.devMode"})(L||(e.TerminalSettingId=L={}));var I;(function(h){h.PowerShell="pwsh",h.Bash="bash",h.Fish="fish",h.Sh="sh",h.Csh="csh",h.Ksh="ksh",h.Zsh="zsh"})(I||(e.PosixShellType=I={}));var w;(function(h){h.CommandPrompt="cmd",h.PowerShell="pwsh",h.Wsl="wsl",h.GitBash="gitbash"})(w||(e.WindowsShellType=w={}));var b;(function(h){h[h.Api=0]="Api",h[h.Process=1]="Process",h[h.Sequence=2]="Sequence",h[h.Config=3]="Config"})(b||(e.TitleEventSource=b={}));var C;(function(h){h.LocalPty="localPty",h.PtyHost="ptyHost",h.PtyHostWindow="ptyHostWindow",h.Logger="logger",h.Heartbeat="heartbeat"})(C||(e.TerminalIpcChannels=C={}));var E;(function(h){h.Cwd="cwd",h.InitialCwd="initialCwd",h.FixedDimensions="fixedDimensions",h.Title="title",h.ShellType="shellType",h.HasChildProcesses="hasChildProcesses",h.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",h.OverrideDimensions="overrideDimensions",h.FailedShellIntegrationActivation="failedShellIntegrationActivation",h.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(E||(e.ProcessPropertyType=E={})),e.$Yq=(0,y.$Lh)("ptyService");var v;(function(h){h[h.BeatInterval=5e3]="BeatInterval",h[h.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",h[h.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",h[h.SecondWaitMultiplier=1]="SecondWaitMultiplier",h[h.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(v||(e.HeartbeatConstants=v={}));var d;(function(h){h[h.Panel=1]="Panel",h[h.Editor=2]="Editor"})(d||(e.TerminalLocation=d={}));var g;(function(h){h.TerminalView="view",h.Editor="editor"})(g||(e.TerminalLocationString=g={}));var m;(function(h){h[h.GraceTime=6e4]="GraceTime",h[h.ShortGraceTime=6e3]="ShortGraceTime"})(m||(e.LocalReconnectConstants=m={}));var l;(function(h){h[h.HighWatermarkChars=1e5]="HighWatermarkChars",h[h.LowWatermarkChars=5e3]="LowWatermarkChars",h[h.CharCountAckSize=5e3]="CharCountAckSize"})(l||(e.FlowControlConstants=l={}));var f;(function(h){h.GitBash="Git Bash",h.Pwsh="PowerShell"})(f||(e.ProfileSource=f={}));var u;(function(h){h[h.Off=0]="Off",h[h.FinalTerm=1]="FinalTerm",h[h.VSCode=2]="VSCode"})(u||(e.ShellIntegrationStatus=u={}));var c;(function(h){h[h.Unknown=0]="Unknown",h[h.Shutdown=1]="Shutdown",h[h.Process=2]="Process",h[h.User=3]="User",h[h.Extension=4]="Extension"})(c||(e.TerminalExitReason=c={})),e.$Zq={Backend:"workbench.contributions.terminal.processBackend"};class p{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(t){const s=this.b(t.remoteAuthority);if(this.a.has(s))throw new Error(`A terminal backend with remote authority '${s}' was already registered.`);this.a.set(s,t)}getTerminalBackend(t){return this.a.get(this.b(t))}b(t){return t?.toLowerCase()??""}}r.$0m.add(e.$Zq.Backend,new p),e.$1q=(0,y.$Lh)("localPtyService"),e.$2q=(0,y.$Lh)("terminalLogService")}),define(we[248],pe([1,0,3]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZM=e.$YM=e.$XM=void 0;function R(L){let I=L;I.includes("\\")&&(I=I.replace(/\\/g,"\\\\"));const w=/[\`\$\|\&\>\~\#\!\^\*\;\<\"\']/g;return I=I.replace(w,""),`'${I}'`}e.$XM=R;function r(L,I,w){if(!L)return"";if(!I)return L;I.match(/[\/\\]$/)&&(I=I.slice(0,I.length-1));const b=L.replace(/\\/g,"/").toLowerCase(),C=I.replace(/\\/g,"/").toLowerCase();return b.includes(C)?`~${w}${L.slice(I.length+1)}`:L}e.$YM=r;function P(L){return L.match(/^['"].*['"]$/)&&(L=L.substring(1,L.length-1)),y.OS===1&&L&&L[1]===":"?L[0].toUpperCase()+L.substring(1):L}e.$ZM=P}),define(we[249],pe([1,0,49,4,195,99]),function(le,e,y,R,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0q=e.$9q=e.$8q=e.$7q=void 0;function L(v,d){const g=[{name:null,description:(0,r.localize)(0,null)}];return g.push(...v.map(m=>({name:m.profileName,description:I(m)}))),d&&g.push(...d.map(m=>({name:m.title,description:w(m)}))),{values:g.map(m=>m.name),markdownDescriptions:g.map(m=>m.description)}}e.$7q=L;function I(v){let d=`$(${P.ThemeIcon.isThemeIcon(v.icon)?v.icon.id:v.icon?v.icon:y.$Qj.terminal.id}) ${v.profileName}
- path: ${v.path}`;return v.args&&(typeof v.args=="string"?d+=`
- args: "${v.args}"`:d+=`
- args: [${v.args.length===0?"":`'${v.args.join("','")}'`}]`),v.overrideName!==void 0&&(d+=`
- overrideName: ${v.overrideName}`),v.color&&(d+=`
- color: ${v.color}`),v.env&&(d+=`
- env: ${JSON.stringify(v.env)}`),d}function w(v){return`$(${P.ThemeIcon.isThemeIcon(v.icon)?v.icon.id:v.icon?v.icon:y.$Qj.terminal.id}) ${v.title}
- extensionIdentifier: ${v.extensionIdentifier}`}function b(v,d){if(!v&&!d)return!0;if(typeof v=="string"&&typeof d=="string")return v===d;if(Array.isArray(v)&&Array.isArray(d)){if(v.length!==d.length)return!1;for(let g=0;g<v.length;g++)if(v[g]!==d[g])return!1;return!0}return!1}e.$8q=b;function C(v,d){if(!v&&!d)return!0;if(!v||!d)return!1;if(P.ThemeIcon.isThemeIcon(v)&&P.ThemeIcon.isThemeIcon(d))return v.id===d.id&&v.color===d.color;if(typeof v=="object"&&"light"in v&&"dark"in v&&typeof d=="object"&&"light"in d&&"dark"in d){const g=v,m=d;if((R.URI.isUri(g.light)||E(g.light))&&(R.URI.isUri(g.dark)||E(g.dark))&&(R.URI.isUri(m.light)||E(m.light))&&(R.URI.isUri(m.dark)||E(m.dark)))return g.light.path===m.light.path&&g.dark.path===m.dark.path}if(R.URI.isUri(v)&&R.URI.isUri(d)||E(v)||E(d)){const g=v,m=d;return g.path===m.path&&g.scheme===m.scheme}return!1}e.$9q=C;function E(v){return v?typeof v.path=="string"&&typeof v.scheme=="string":!1}e.$0q=E}),define(we[250],pe([1,0,49,3,194,55,35,249]),function(le,e,y,R,r,P,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$br=e.$ar=e.$_q=e.$$q=void 0,e.$$q={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.$_q={type:"string",enum:Array.from((0,y.$Pj)(),l=>l.id),markdownEnumDescriptions:Array.from((0,y.$Pj)(),l=>`$(${l.id})`)};const w={args:{description:(0,r.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,r.localize)(1,null),type:"boolean"},icon:{description:(0,r.localize)(2,null),...e.$_q},color:{description:(0,r.localize)(3,null),...e.$$q},env:{markdownDescription:(0,r.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},b={type:"object",required:["path"],properties:{path:{description:(0,r.localize)(5,null),type:["string","array"],items:{type:"string"}},...w}},C={type:"object",required:["path"],properties:{path:{description:(0,r.localize)(6,null),type:["string"],items:{type:"string"}},...w}};function E(l){const f=l===2?"linux":l===1?"osx":"windows";return(0,r.localize)(7,null,(0,R.$c)(l),'```json\n"terminal.integrated.profile.'+f+'": {\n  "bash": null\n}\n```',"[","](https://code.visualstudio.com/docs/terminal/profiles)")}const v={id:"terminal",order:100,title:(0,r.localize)(8,null),type:"object",properties:{["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,r.localize)(9,null),type:["object","null"],default:null,anyOf:[{type:"null"},C],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,markdownDescription:(0,r.localize)(10,null),type:["object","null"],default:null,anyOf:[{type:"null"},C],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,markdownDescription:(0,r.localize)(11,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},C],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:E(3),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,r.localize)(12,null),enum:["PowerShell","Git Bash"]},...w}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,r.localize)(13,null),type:"string"},id:{description:(0,r.localize)(14,null),type:"string"},title:{description:(0,r.localize)(15,null),type:"string"},...w}},{type:"null"},b]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:E(1),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,r.localize)(16,null),type:"string"},id:{description:(0,r.localize)(17,null),type:"string"},title:{description:(0,r.localize)(18,null),type:"string"},...w}},{type:"null"},b]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:E(2),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,r.localize)(19,null),type:"string"},id:{description:(0,r.localize)(20,null),type:"string"},title:{description:(0,r.localize)(21,null),type:"string"},...w}},{type:"null"},b]}},["terminal.integrated.useWslProfiles"]:{description:(0,r.localize)(22,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,r.localize)(23,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,r.localize)(24,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,r.localize)(25,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{markdownDescription:(0,r.localize)(26,null,"`#terminal.integrated.confirmOnKill#`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function d(){L.$0m.as(P.$cn.Configuration).registerConfiguration(v),m()}e.$ar=d;let g;function m(l,f){const u=L.$0m.as(P.$cn.Configuration);let c;l&&(c=(0,I.$7q)(l?.profiles,f));const p=g;g={id:"terminal",order:100,title:(0,r.localize)(27,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,r.localize)(28,null),type:["string","null"],default:null,enum:l?.os===3?c?.values:void 0,markdownEnumDescriptions:l?.os===3?c?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,r.localize)(29,null),type:["string","null"],default:null,enum:l?.os===2?c?.values:void 0,markdownEnumDescriptions:l?.os===2?c?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,r.localize)(30,null),type:["string","null"],default:null,enum:l?.os===1?c?.values:void 0,markdownEnumDescriptions:l?.os===1?c?.markdownDescriptions:void 0}}},u.updateConfigurations({add:[g],remove:p?[p]:[]})}e.$br=m}),define(we[251],pe([1,0,2,12,107,25,109]),function(le,e,y,R,r,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DN=void 0;let I=class extends y.$Qc{constructor(b,C){super(),this.a=b,this.b=C}start(){const b={serverName:"Pty Host",args:["--type=ptyHost","--logsPath",this.b.logsHome.with({scheme:R.Schemas.file}).fsPath],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this.a.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this.a.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this.a.scrollback}},C=(0,L.$cm)(this.b.args,this.b.isBuilt);C&&(C.break&&C.port?b.debugBrk=C.port:!C.break&&C.port&&(b.debug=C.port));const E=new r.$Up(R.$_f.asFileUri("bootstrap-fork").fsPath,b),v=new y.$Pc;return v.add(E),{client:E,store:v,onDidProcessExit:E.onDidProcessExit}}};e.$DN=I,e.$DN=I=Oe([Ae(1,P.$Sh)],I)}),define(we[252],pe([1,0,27,12,22,7,3,28,17,8,21,122,87,123]),function(le,e,y,R,r,P,L,I,w,b,C,E,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lr=e.$kr=e.$jr=void 0;function g(){const i=/(\d+)\.(\d+)\.(\d+)/g.exec(y.release());let n=0;return i&&i.length===4&&(n=parseInt(i[3])),n}e.$jr=g;async function m(i,n,a,$=I.env,S=C.Promises.exists){if(P.$gc(i))return await S(i)?i:void 0;if(n===void 0&&(n=I.cwd()),P.$kc(i)!=="."){const j=P.$hc(n,i);return await S(j)?j:void 0}const k=(0,r.$5m)($,"PATH");if(a===void 0&&(0,b.$wf)(k)&&(a=k.split(P.$rc)),a===void 0||a.length===0){const j=P.$hc(n,i);return await S(j)?j:void 0}for(const j of a){let Z;if(P.$gc(j)?Z=P.$hc(j,i):Z=P.$hc(n,j,i),await S(Z))return Z;if(L.$d){let ae=Z+".com";if(await S(ae)||(ae=Z+".exe",await S(ae)))return ae}}const A=P.$hc(n,i);return await S(A)?A:void 0}e.$kr=m;function l(i,n,a,$,S){const D=L.$d&&(!n.windowsEnableConpty||g()<18309);if(!n.shellIntegration.enabled||!i.executable||i.isFeatureTerminal||i.hideFromUser||i.ignoreShellIntegration||D)return;const k=i.args,A=I.$bc==="win32"?P.$lc(i.executable).toLowerCase():P.$lc(i.executable),j=P.$kc(R.$_f.asFileUri("").fsPath);let Z;const ae={VSCODE_INJECTION:"1"};if(n.shellIntegration.nonce&&(ae.VSCODE_NONCE=n.shellIntegration.nonce),L.$d){if(A==="pwsh.exe"||A==="powershell.exe")return!k||s(k)?Z=c.get(u.WindowsPwsh):t(k)&&(Z=c.get(u.WindowsPwshLogin)),Z?(Z=[...Z],Z[Z.length-1]=(0,w.$Ae)(Z[Z.length-1],j,""),{newArgs:Z,envMixin:ae}):void 0;$.warn(`Shell integration cannot be enabled for executable "${i.executable}" and args`,i.args);return}switch(A){case"bash":return!k||k.length===0?Z=c.get(u.Bash):o(k)&&(ae.VSCODE_SHELL_LOGIN="1",f(n,ae),Z=c.get(u.Bash)),Z?(Z=[...Z],Z[Z.length-1]=(0,w.$Ae)(Z[Z.length-1],j),{newArgs:Z,envMixin:ae}):void 0;case"fish":{const K=a?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",se=P.$hc(j,"out/vs/workbench/contrib/terminal/browser/media/fish_xdg_data");return ae.XDG_DATA_DIRS=`${K}:${se}`,f(n,ae),{newArgs:void 0,envMixin:ae}}case"pwsh":return!k||s(k)?Z=c.get(u.Pwsh):t(k)&&(Z=c.get(u.PwshLogin)),Z?(Z=[...Z],Z[Z.length-1]=(0,w.$Ae)(Z[Z.length-1],j,""),{newArgs:Z,envMixin:ae}):void 0;case"zsh":{if(!k||k.length===0?Z=c.get(u.Zsh):o(k)?(Z=c.get(u.ZshLogin),f(n,ae)):(k===c.get(u.Zsh)||k===c.get(u.ZshLogin))&&(Z=k),!Z)return;Z=[...Z],Z[Z.length-1]=(0,w.$Ae)(Z[Z.length-1],j);let K;try{K=y.userInfo().username}catch{K="unknown"}const se=P.$hc(y.tmpdir(),`${K}-${S.applicationName}-zsh`);ae.ZDOTDIR=se;const ue=a?.ZDOTDIR??y.homedir()??"~";ae.USER_ZDOTDIR=ue;const x=[];return x.push({source:P.$hc(j,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:P.$hc(se,".zshrc")}),x.push({source:P.$hc(j,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:P.$hc(se,".zprofile")}),x.push({source:P.$hc(j,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:P.$hc(se,".zshenv")}),x.push({source:P.$hc(j,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:P.$hc(se,".zlogin")}),{newArgs:Z,envMixin:ae,filesToCopy:x}}}$.warn(`Shell integration cannot be enabled for executable "${i.executable}" and args`,i.args)}e.$lr=l;function f(i,n){if(L.$e&&i.environmentVariableCollections){const a=(0,v.$hr)(i.environmentVariableCollections),S=new d.$ir(a).getVariableMap({workspaceFolder:i.workspaceFolder}).get("PATH"),D=[];if(S)for(const k of S)k.type===E.EnvironmentVariableMutatorType.Prepend&&D.push(k.value);D.length>0&&(n.VSCODE_PATH_PREFIX=D.join(""))}}var u;(function(i){i.WindowsPwsh="windows-pwsh",i.WindowsPwshLogin="windows-pwsh-login",i.Pwsh="pwsh",i.PwshLogin="pwsh-login",i.Zsh="zsh",i.ZshLogin="zsh-login",i.Bash="bash"})(u||(u={}));const c=new Map;c.set(u.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),c.set(u.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),c.set(u.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),c.set(u.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),c.set(u.Zsh,["-i"]),c.set(u.ZshLogin,["-il"]),c.set(u.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const p=["-login","-l"],h=["-nol","-nologo"];function t(i){return typeof i=="string"?p.includes(i.toLowerCase()):i.length===1&&p.includes(i[0].toLowerCase())||i.length===2&&(p.includes(i[0].toLowerCase())||p.includes(i[1].toLowerCase()))&&(h.includes(i[0].toLowerCase())||h.includes(i[1].toLowerCase()))}function s(i){return typeof i=="string"?h.includes(i.toLowerCase()):i.length===0||i?.length===1&&h.includes(i[0].toLowerCase())}function o(i){return i==="string"&&p.includes(i.toLowerCase())||typeof i!="string"&&i.length===1&&p.includes(i[0].toLowerCase())}}),define(we[253],pe([1,0,52,49,7,3,8,21,102,252,77]),function(le,e,y,R,r,P,L,I,w,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mr=void 0;let E,v=!0;function d(n,a,$,S,D=process.env,k,A,j,Z){return k=k||{existsFile:I.SymlinkSupport.existsFile,readFile:I.Promises.readFile},P.$d?g($,k,D,A,S.getValue("terminal.integrated.useWslProfiles")!==!1,n&&typeof n=="object"?{...n}:S.getValue("terminal.integrated.profiles.windows"),typeof a=="string"?a:S.getValue("terminal.integrated.defaultProfile.windows"),Z,j):s(k,A,$,n&&typeof n=="object"?{...n}:S.getValue(P.$f?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof a=="string"?a:S.getValue(P.$f?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),Z,j,D)}e.$mr=d;async function g(n,a,$,S,D,k,A,j,Z){const ae=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),K=`${process.env.windir}\\${ae?"Sysnative":"System32"}`;let se=!1;(0,b.$jr)()>=16299&&(se=!0),await u(j);const ue=new Map;if(n){ue.set("PowerShell",{source:"PowerShell",icon:R.$Qj.terminalPowershell,isAutoDetected:!0}),ue.set("Windows PowerShell",{path:`${K}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:R.$Qj.terminalPowershell,isAutoDetected:!0}),ue.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),ue.set("Command Prompt",{path:`${K}\\cmd.exe`,icon:R.$Qj.terminalCmd,isAutoDetected:!0}),ue.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),ue.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],icon:R.$Qj.terminalBash,isAutoDetected:!0});const he=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;ue.set("Cmder",{path:`${K}\\cmd.exe`,args:["/K",he],requiresPath:process.env.CMDER_ROOT?he:{path:he,isUnsafe:!0},isAutoDetected:!0})}o(k,ue);const x=await m(ue.entries(),A,a,$,S,Z);if(n&&D)try{const he=await h(`${K}\\${se?"wsl":"bash"}.exe`,A);for(const V of he)(!k||!(V.profileName in k))&&x.push(V)}catch{v&&(S?.info("WSL is not installed, so could not detect WSL profiles"),v=!1)}return x}async function m(n,a,$,S=process.env,D,k){const A=[];for(const[j,Z]of n)A.push(l(j,Z,a,$,S,D,k));return(await Promise.all(A)).filter(j=>!!j)}async function l(n,a,$,S,D=process.env,k,A){if(a===null)return;let j,Z,ae;if("source"in a&&!("path"in a)){const x=E?.get(a.source);if(!x)return;j=x.paths,Z=a.args||x.args,a.icon?ae=f(a.icon):x.icon&&(ae=x.icon)}else j=Array.isArray(a.path)?a.path:[a.path],Z=P.$d||Array.isArray(a.args)?a.args:void 0,ae=f(a.icon);let K;if(A){const x=j.map(V=>typeof V=="string"?V:V.path),he=await A(x);K=new Array(j.length);for(let V=0;V<j.length;V++)typeof j[V]=="string"?K[V]=he[V]:K[V]={path:he[V],isUnsafe:!0}}else K=j.slice();let se;if(a.requiresPath){let x;if((0,L.$wf)(a.requiresPath)?x=a.requiresPath:(x=a.requiresPath.path,a.requiresPath.isUnsafe&&(se=x)),!await S.existsFile(x))return}const ue=await i(n,$,K,S,D,Z,a.env,a.overrideName,a.isAutoDetected,se);if(!ue){k?.debug("Terminal profile not validated",n,j);return}return ue.isAutoDetected=a.isAutoDetected,ue.icon=ae,ue.color=a.color,ue}function f(n){return typeof n=="string"?{id:n}:n}async function u(n){if(E&&!n)return;const[a,$]=await Promise.all([c(),n||p()]);E=new Map,E.set("Git Bash",{profileName:"Git Bash",paths:a,args:["--login","-i"]}),E.set("PowerShell",{profileName:"PowerShell",paths:$,icon:R.$Qj.terminalPowershell})}async function c(){const n=new Set,a=await(0,b.$kr)("git.exe");if(a){const D=(0,C.dirname)(a);n.add((0,C.resolve)(D,"../.."))}function $(D,k){k&&D.add(k)}$(n,process.env.ProgramW6432),$(n,process.env.ProgramFiles),$(n,process.env["ProgramFiles(X86)"]),$(n,`${process.env.LocalAppData}\\Program`);const S=[];for(const D of n)S.push(`${D}\\Git\\bin\\bash.exe`,`${D}\\Git\\usr\\bin\\bash.exe`,`${D}\\usr\\bin\\bash.exe`);return S.push(`${process.env.UserProfile}\\scoop\\apps\\git\\current\\bin\\bash.exe`),S.push(`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`),S}async function p(){const n=[];for await(const a of(0,w.$sl)())n.push(a.exePath);return n}async function h(n,a){const $=[],S=await new Promise((A,j)=>{y.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(Z,ae)=>{if(Z)return j("Problem occurred when getting wsl distros");A(ae)})});if(!S)return[];const D=new RegExp(/[\r?\n]/),k=S.split(D).filter(A=>A.trim().length>0&&A!=="");for(const A of k){if(A===""||A.startsWith("docker-desktop"))continue;const j=`${A} (WSL)`,Z={profileName:j,path:n,args:["-d",`${A}`],isDefault:j===a,icon:t(A),isAutoDetected:!1};$.push(Z)}return $}function t(n){return n.includes("Ubuntu")?R.$Qj.terminalUbuntu:n.includes("Debian")?R.$Qj.terminalDebian:R.$Qj.terminalLinux}async function s(n,a,$,S,D,k,A,j){const Z=new Map;if($){const ae=(await n.readFile("/etc/shells")).toString(),K=(k||ae.split(`
`)).map(ue=>{const x=ue.indexOf("#");return x===-1?ue:ue.substring(0,x)}).filter(ue=>ue.trim().length>0),se=new Map;for(const ue of K){let x=(0,r.$lc)(ue),he=se.get(x)||0;he++,he>1&&(x=`${x} (${he})`),se.set(x,he),Z.set(x,{path:ue,isAutoDetected:!0})}}return o(S,Z),await m(Z.entries(),D,n,j,a,A)}function o(n,a){if(n)for(const[$,S]of Object.entries(n))S===null||typeof S!="object"||!("path"in S)&&!("source"in S)?a.delete($):(S.icon=S.icon||a.get($)?.icon,a.set($,S))}async function i(n,a,$,S,D,k,A,j,Z,ae){if($.length===0)return Promise.resolve(void 0);const K=$.shift();if(K==="")return i(n,a,$,S,D,k,A,j,Z);const se=typeof K!="string"&&K.isUnsafe,ue=typeof K=="string"?K:K.path,x={profileName:n,path:ue,args:k,env:A,overrideName:j,isAutoDetected:Z,isDefault:n===a,isUnsafePath:se,requiresUnsafePath:ae};if((0,r.$lc)(ue)===ue){const V=D.PATH?D.PATH.split(r.$rc):void 0,te=await(0,b.$kr)(ue,void 0,V,void 0,S.existsFile);return te?(x.path=te,x.isFromPath=!0,x):i(n,a,$,S,D,k)}return await S.existsFile((0,r.$fc)(ue))?x:i(n,a,$,S,D,k,A,j,Z)}}),define(we[254],pe([1,0,5,2,3,42,24,13,113,85,247,88,250,253,105,60]),function(le,e,y,R,r,P,L,I,w,b,C,E,v,d,g,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nr=void 0;var l;(function(u){u[u.MaxRestarts=5]="MaxRestarts"})(l||(l={}));let f=class extends R.$Qc{get c(){return this.h(),this.a}get f(){return this.h(),this.b}get g(){return this.b}h(){this.a||this.U()}constructor(c,p,h,t){super(),this.M=c,this.N=p,this.O=h,this.P=t,this.m=!1,this.n=0,this.r=!0,this.u=this.B(new y.$Ld),this.onPtyHostExit=this.u.event,this.w=this.B(new y.$Ld),this.onPtyHostStart=this.w.event,this.y=this.B(new y.$Ld),this.onPtyHostUnresponsive=this.y.event,this.z=this.B(new y.$Ld),this.onPtyHostResponsive=this.z.event,this.C=this.B(new y.$Ld),this.onPtyHostRequestResolveVariables=this.C.event,this.D=this.B(new y.$Ld),this.onProcessData=this.D.event,this.F=this.B(new y.$Ld),this.onProcessReady=this.F.event,this.G=this.B(new y.$Ld),this.onProcessReplay=this.G.event,this.H=this.B(new y.$Ld),this.onProcessOrphanQuestion=this.H.event,this.I=this.B(new y.$Ld),this.onDidRequestDetach=this.I.event,this.J=this.B(new y.$Ld),this.onDidChangeProperty=this.J.event,this.L=this.B(new y.$Ld),this.onProcessExit=this.L.event,(0,v.$ar)(),this.B(this.M),this.B((0,R.$Oc)(()=>this.W())),this.j=this.B(new C.$6q(void 0,this.O)),this.j.onCreateRequest(this.C.fire,this.C),this.M.onRequestConnection&&y.Event.once(this.M.onRequestConnection)(()=>this.h()),this.M.onWillShutdown?.(()=>this.m=!0)}get Q(){return this.N.getValue("terminal.integrated.ignoreProcessNames")}async R(){return this.g?.refreshIgnoreProcessNames?.(this.Q)}async S(){if(r.$d)return process.env;try{return await(0,b.$Ol)(this.N,this.O,{_:[]},process.env)}catch(c){return this.O.error("ptyHost was unable to resolve shell environment",c),{}}}U(){const c=this.M.start(),p=c.client;this.O.getLevel()===I.LogLevel.Trace&&this.O.trace("PtyHostService#_startPtyHost",new Error().stack?.replace(/^Error/,"")),P.ProxyChannel.toService(p.getChannel(E.TerminalIpcChannels.Heartbeat)).onBeat(()=>this.X()),this.X(!0),this.B(c.onDidProcessExit(s=>{this.u.fire(s.code),!this.m&&!this.q.isDisposed&&(this.n<=l.MaxRestarts?(this.O.error(`ptyHost terminated unexpectedly with code ${s.code}`),this.n++,this.restartPtyHost()):this.O.error(`ptyHost terminated unexpectedly with code ${s.code}, giving up`))}));const t=P.ProxyChannel.toService(p.getChannel(E.TerminalIpcChannels.PtyHost));return this.B(t.onProcessData(s=>this.D.fire(s))),this.B(t.onProcessReady(s=>this.F.fire(s))),this.B(t.onProcessExit(s=>this.L.fire(s))),this.B(t.onDidChangeProperty(s=>this.J.fire(s))),this.B(t.onProcessReplay(s=>this.G.fire(s))),this.B(t.onProcessOrphanQuestion(s=>this.H.fire(s))),this.B(t.onDidRequestDetach(s=>this.I.fire(s))),this.B(new w.$5q(this.P,p.getChannel(E.TerminalIpcChannels.Logger))),this.a=c,this.b=t,this.w.fire(),this.B(this.N.onDidChangeConfiguration(async s=>{s.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this.R()})),this.R(),[c,t]}async createProcess(c,p,h,t,s,o,i,n,a,$,S){const D=setTimeout(()=>this.$(),E.HeartbeatConstants.CreateProcessTimeout),k=await this.f.createProcess(c,p,h,t,s,o,i,n,a,$,S);return clearTimeout(D),k}updateTitle(c,p,h){return this.f.updateTitle(c,p,h)}updateIcon(c,p,h,t){return this.f.updateIcon(c,p,h,t)}attachToProcess(c){return this.f.attachToProcess(c)}detachFromProcess(c,p){return this.f.detachFromProcess(c,p)}shutdownAll(){return this.f.shutdownAll()}listProcesses(){return this.f.listProcesses()}async getPerformanceMarks(){return this.g?.getPerformanceMarks()??[]}async reduceConnectionGraceTime(){return this.g?.reduceConnectionGraceTime()}start(c){return this.f.start(c)}shutdown(c,p){return this.f.shutdown(c,p)}input(c,p){return this.f.input(c,p)}processBinary(c,p){return this.f.processBinary(c,p)}resize(c,p,h){return this.f.resize(c,p,h)}clearBuffer(c){return this.f.clearBuffer(c)}acknowledgeDataEvent(c,p){return this.f.acknowledgeDataEvent(c,p)}setUnicodeVersion(c,p){return this.f.setUnicodeVersion(c,p)}getInitialCwd(c){return this.f.getInitialCwd(c)}getCwd(c){return this.f.getCwd(c)}async getLatency(){const c=new m.$Hd,p=await this.f.getLatency();return c.stop(),[{label:"ptyhostservice<->ptyhost",latency:c.elapsed()},...p]}orphanQuestionReply(c){return this.f.orphanQuestionReply(c)}installAutoReply(c,p){return this.f.installAutoReply(c,p)}uninstallAllAutoReplies(){return this.f.uninstallAllAutoReplies()}uninstallAutoReply(c){return this.f.uninstallAutoReply(c)}getDefaultSystemShell(c){return this.g?.getDefaultSystemShell(c)??(0,g.$yl)(c??r.OS,process.env)}async getProfiles(c,p,h,t=!1){const s=await this.S();return(0,d.$mr)(p,h,t,this.N,s,void 0,this.O,this.bb.bind(this,c))}async getEnvironment(){return this.b?this.f.getEnvironment():{...process.env}}getWslPath(c,p){return this.f.getWslPath(c,p)}getRevivedPtyNewId(c,p){return this.f.getRevivedPtyNewId(c,p)}setTerminalLayoutInfo(c){return this.f.setTerminalLayoutInfo(c)}async getTerminalLayoutInfo(c){return this.g?.getTerminalLayoutInfo(c)}async requestDetachInstance(c,p){return this.f.requestDetachInstance(c,p)}async acceptDetachInstanceReply(c,p){return this.f.acceptDetachInstanceReply(c,p)}async freePortKillProcess(c){if(!this.f.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this.f.freePortKillProcess(c)}async serializeTerminalState(c){return this.f.serializeTerminalState(c)}async reviveTerminalProcesses(c,p,h){return this.f.reviveTerminalProcesses(c,p,h)}async refreshProperty(c,p){return this.f.refreshProperty(c,p)}async updateProperty(c,p,h){return this.f.updateProperty(c,p,h)}async restartPtyHost(){this.W(),this.r=!0,this.U()}W(){this.f.shutdownAll(),this.c.store.dispose()}X(c){this.ab(),this.s=setTimeout(()=>this.Y(),c?E.HeartbeatConstants.ConnectingBeatInterval:E.HeartbeatConstants.BeatInterval*E.HeartbeatConstants.FirstWaitMultiplier),this.r||(this.r=!0,this.z.fire())}Y(){this.O.warn(`No ptyHost heartbeat after ${E.HeartbeatConstants.BeatInterval*E.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this.s=void 0,this.t=setTimeout(()=>this.Z(),E.HeartbeatConstants.BeatInterval*E.HeartbeatConstants.SecondWaitMultiplier)}Z(){this.O.error(`No ptyHost heartbeat after ${(E.HeartbeatConstants.BeatInterval*E.HeartbeatConstants.FirstWaitMultiplier+E.HeartbeatConstants.BeatInterval*E.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this.t=void 0,this.r&&(this.r=!1,this.y.fire())}$(){this.ab(),this.O.error(`No ptyHost response to createProcess after ${E.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this.r&&(this.r=!1,this.y.fire())}ab(){this.s&&(clearTimeout(this.s),this.s=void 0),this.t&&(clearTimeout(this.t),this.t=void 0)}bb(c,p){return this.j.createRequest({workspaceId:c,originalText:p})}async acceptPtyHostResolvedVariables(c,p){this.j.acceptReply(c,p)}};e.$nr=f,e.$nr=f=Oe([Ae(1,L.$fi),Ae(2,I.$6i),Ae(3,I.$7i)],f)}),define(we[34],pe([1,0,6]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dk=void 0,e.$Dk=(0,y.$Lh)("IUriIdentityService")}),define(we[124],pe([1,0,34,213,16,19,145,5,2]),function(le,e,y,R,r,P,L,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rr=void 0;class b{constructor(v){this.uri=v,this.time=b._clock++}touch(){return this.time=b._clock++,this}}b._clock=0;let C=class{constructor(v){this.g=v,this.c=new w.$Pc,this.f=2**16;const d=new Map,g=m=>{let l=d.get(m.scheme);return l===void 0&&(l=v.hasProvider(m)&&!this.g.hasCapability(m,1024),d.set(m.scheme,l)),l};this.c.add(I.Event.any(v.onDidChangeFileSystemProviderRegistrations,v.onDidChangeFileSystemProviderCapabilities)(m=>{d.delete(m.scheme)})),this.extUri=new P.$hg(g),this.d=new L.$qr((m,l)=>this.extUri.compare(m,l,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(v){this.g.hasProvider(v)&&(v=(0,P.$tg)(v));const d=this.d.get(v);return d?d.touch().uri.with({fragment:v.fragment}):(this.d.set(v,new b(v)),this.h(),v)}h(){if(this.d.size<this.f)return;const v=[...this.d.entries()].sort((g,m)=>g[1].time<m[1].time?1:g[1].time>m[1].time?-1:0);b._clock=0,this.d.clear();const d=this.f*.5;for(let g=0;g<d;g++)this.d.set(v[g][0],v[g][1].touch())}};e.$rr=C,e.$rr=C=Oe([Ae(0,r.$7j)],C),(0,R.$or)(y.$Dk,C,1)}),define(we[89],pe([1,0,197,7,63,19,4,6,12]),function(le,e,y,R,r,P,L,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ei=e.$di=e.$ci=e.$bi=e.$ai=e.$_h=e.$$h=e.$0h=e.$9h=e.$8h=e.$7h=e.$6h=e.$5h=e.$4h=e.$3h=e.WorkbenchState=e.$2h=e.$1h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=void 0,e.$Uh=(0,I.$Lh)("contextService");function b(i){const n=i;return typeof n?.id=="string"&&L.URI.isUri(n.uri)}e.$Vh=b;function C(i){return typeof i?.id=="string"&&!b(i)&&!v(i)}e.$Wh=C,e.$Xh={id:"ext-dev"},e.$Yh={id:"empty-window"};function E(i,n){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,R.$lc)(i)}:n?e.$Xh:e.$Yh;const a=i;return a.configuration?{id:a.id,configPath:a.configuration}:a.folders.length===1?{id:a.id,uri:a.folders[0].uri}:{id:a.id}}e.$Zh=E;function v(i){const n=i;return typeof n?.id=="string"&&L.URI.isUri(n.configPath)}e.$1h=v;function d(i){const n=i;if(n?.uri)return{id:n.id,uri:L.URI.revive(n.uri)};const a=i;if(a?.configPath)return{id:a.id,configPath:L.URI.revive(a.configPath)};if(i?.id)return{id:i.id}}e.$2h=d;var g;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(g||(e.WorkbenchState=g={}));function m(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}e.$3h=m;function l(i){const n=i;return!!(n&&typeof n=="object"&&L.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}e.$4h=l;class f{constructor(n,a,$,S,D){this.h=n,this.j=$,this.k=S,this.l=D,this.c=r.$Rh.forUris(this.l,()=>!0),this.folders=a}update(n){this.h=n.id,this.k=n.configuration,this.j=n.transient,this.l=n.l,this.folders=n.folders}get folders(){return this.g}set folders(n){this.g=n,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(n){this.k=n}getFolder(n){return n&&this.c.findSubstr(n)||null}n(){this.c=r.$Rh.forUris(this.l,()=>!0);for(const n of this.folders)this.c.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$5h=f;class u{constructor(n,a){this.raw=a,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,P.$sg)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$6h=u;function c(i){return new u({uri:i,index:0,name:(0,P.$og)(i)},{uri:i.toString()})}e.$7h=c,e.$8h="code-workspace",e.$9h=`.${e.$8h}`,e.$0h=[{name:(0,y.localize)(0,null),extensions:[e.$8h]}],e.$$h="workspace.json";function p(i,n){return P.$jg.isEqualOrParent(i,n.untitledWorkspacesHome)}e.$_h=p;function h(i){let n;return L.URI.isUri(i)?n=i:n=i.configuration,n?.scheme===w.Schemas.tmp}e.$ai=h,e.$bi="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(i){return i.id===e.$bi}e.$ci=t;function s(i,n){return!p(i,n)&&!h(i)}e.$di=s;function o(i){return(typeof i=="string"?(0,R.$mc)(i):(0,P.$qg)(i))===e.$9h}e.$ei=o}),define(we[33],pe([1,0,61,5,2,19,4,196,25,16,6,13,89,26,34,14,23,17,8]),function(le,e,y,R,r,P,L,I,w,b,C,E,v,d,g,m,l,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jk=e.$Ik=e.$Hk=e.$Gk=e.$Fk=e.$Ek=e.ProfileResourceType=void 0;var c;(function(i){i.Settings="settings",i.Keybindings="keybindings",i.Snippets="snippets",i.Tasks="tasks",i.Extensions="extensions",i.GlobalState="globalState"})(c||(e.ProfileResourceType=c={}));function p(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&L.URI.isUri(n.location)&&L.URI.isUri(n.globalStorageHome)&&L.URI.isUri(n.settingsResource)&&L.URI.isUri(n.keybindingsResource)&&L.URI.isUri(n.tasksResource)&&L.URI.isUri(n.snippetsHome)&&L.URI.isUri(n.extensionsResource))}e.$Ek=p,e.$Fk=(0,C.$Lh)("IUserDataProfilesService");function h(i,n){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,icon:i.icon,location:L.URI.revive(i.location).with({scheme:n}),globalStorageHome:L.URI.revive(i.globalStorageHome).with({scheme:n}),settingsResource:L.URI.revive(i.settingsResource).with({scheme:n}),keybindingsResource:L.URI.revive(i.keybindingsResource).with({scheme:n}),tasksResource:L.URI.revive(i.tasksResource).with({scheme:n}),snippetsHome:L.URI.revive(i.snippetsHome).with({scheme:n}),extensionsResource:L.URI.revive(i.extensionsResource).with({scheme:n}),cacheHome:L.URI.revive(i.cacheHome).with({scheme:n}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}e.$Gk=h;function t(i,n,a,$,S,D){return{id:i,name:n,location:a,isDefault:!1,shortName:S?.shortName,icon:S?.icon,globalStorageHome:D&&S?.useDefaultFlags?.globalState?D.globalStorageHome:(0,P.$sg)(a,"globalStorage"),settingsResource:D&&S?.useDefaultFlags?.settings?D.settingsResource:(0,P.$sg)(a,"settings.json"),keybindingsResource:D&&S?.useDefaultFlags?.keybindings?D.keybindingsResource:(0,P.$sg)(a,"keybindings.json"),tasksResource:D&&S?.useDefaultFlags?.tasks?D.tasksResource:(0,P.$sg)(a,"tasks.json"),snippetsHome:D&&S?.useDefaultFlags?.snippets?D.snippetsHome:(0,P.$sg)(a,"snippets"),extensionsResource:D&&S?.useDefaultFlags?.extensions?D.extensionsResource:(0,P.$sg)(a,"extensions.json"),cacheHome:(0,P.$sg)($,i),useDefaultFlags:S?.useDefaultFlags,isTransient:S?.transient}}e.$Hk=t;let s=class extends r.$Qc{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(n,a,$,S){super(),this.t=n,this.u=a,this.w=$,this.y=S,this.f=!0,this.h=this.B(new R.$Ld),this.onDidChangeProfiles=this.h.event,this.j=this.B(new R.$Ld),this.onWillCreateProfile=this.j.event,this.m=this.B(new R.$Ld),this.onWillRemoveProfile=this.m.event,this.n=this.B(new R.$Ld),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new d.$yc,emptyWindows:new Map},this.profilesHome=(0,P.$sg)(this.t.userRoamingDataHome,"profiles"),this.g=(0,P.$sg)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(n){this.f!==n&&(this.z=void 0,this.f=n)}isEnabled(){return this.f}get C(){if(!this.z){const n=this.D(),a=[n];if(this.f)try{for(const D of this.O()){if(!D.name||!(0,u.$wf)(D.name)||!D.location){this.y.warn("Skipping the invalid stored profile",D.location||D.name);continue}a.push(t((0,P.$pg)(D.location),D.name,D.location,this.g,{shortName:D.shortName,icon:D.icon,useDefaultFlags:D.useDefaultFlags},n))}}catch(D){this.y.error(D)}const $=new d.$yc,S=new Map;if(a.length)try{const D=this.Q();if(D.workspaces)for(const[k,A]of Object.entries(D.workspaces)){const j=L.URI.parse(k),Z=a.find(ae=>ae.id===A);Z&&$.set(j,Z)}if(D.emptyWindows)for(const[k,A]of Object.entries(D.emptyWindows)){const j=a.find(Z=>Z.id===A);j&&S.set(k,j)}}catch(D){this.y.error(D)}this.z={profiles:a,workspaces:$,emptyWindows:S}}return this.z}D(){const n=t("__default__profile__",(0,I.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...n,extensionsResource:this.S()??n.extensionsResource,isDefault:!0}}async createTransientProfile(n){const a="Temp",$=new RegExp(`${(0,f.$De)(a)}\\s(\\d+)`);let S=0;for(const k of this.profiles){const A=$.exec(k.name),j=A?parseInt(A[1]):0;S=j>S?j:S}const D=`${a} ${S+1}`;return this.createProfile((0,y.$zi)((0,l.$bg)()).toString(16),D,{transient:!0},n)}async createNamedProfile(n,a,$){return this.createProfile((0,y.$zi)((0,l.$bg)()).toString(16),n,a,$)}async createProfile(n,a,$,S){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const D=await this.F(n,a,$);return S&&await this.setProfileForWorkspace(S,D),D}async F(n,a,$){if(!(0,u.$wf)(a)||!a)throw new Error("Name of the profile is mandatory and must be of type `string`");let S=this.r.get(a);return S||(S=(async()=>{try{const D=this.profiles.find(j=>j.name===a||j.id===n);if(D)return D;const k=t(n,a,(0,P.$sg)(this.profilesHome,n),this.g,$,this.defaultProfile);await this.u.createFolder(k.location);const A=[];return this.j.fire({profile:k,join(j){A.push(j)}}),await m.Promises.settled(A),this.I([k],[],[]),k}finally{this.r.delete(a)}})(),this.r.set(a,S)),S}async updateProfile(n,a){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let $=this.profiles.find(S=>S.id===n.id);if(!$)throw new Error(`Profile '${n.name}' does not exist`);return $=t($.id,a.name??$.name,$.location,this.g,{shortName:a.shortName??$.shortName,icon:a.icon===null?void 0:a.icon??$.icon,transient:a.transient??$.isTransient,useDefaultFlags:a.useDefaultFlags??$.useDefaultFlags},this.defaultProfile),this.I([],[],[$]),$}async removeProfile(n){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(n.isDefault)throw new Error("Cannot remove default profile");const a=this.profiles.find(S=>S.id===n.id);if(!a)throw new Error(`Profile '${n.name}' does not exist`);const $=[];this.m.fire({profile:a,join(S){$.push(S)}});try{await Promise.allSettled($)}catch(S){this.y.error(S)}for(const S of[...this.C.emptyWindows.keys()])a.id===this.C.emptyWindows.get(S)?.id&&this.C.emptyWindows.delete(S);for(const S of[...this.C.workspaces.keys()])a.id===this.C.workspaces.get(S)?.id&&this.C.workspaces.delete(S);this.M(),this.I([],[a],[]);try{await this.u.del(a.cacheHome,{recursive:!0})}catch(S){(0,b.$kk)(S)!==1&&this.y.error(S)}}async setProfileForWorkspace(n,a){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const $=this.profiles.find(S=>S.id===a.id);if(!$)throw new Error(`Profile '${a.name}' does not exist`);this.L(n,$)}unsetWorkspace(n,a){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(n,void 0,a)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const n=await this.u.resolve(this.profilesHome);await Promise.all((n.children||[]).filter(a=>a.isDirectory&&this.profiles.every($=>!this.w.extUri.isEqual($.location,a.resource))).map(a=>this.u.del(a.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const n=this.s.profiles.filter(a=>!this.H(a));await Promise.allSettled(n.map(a=>this.removeProfile(a)))}getProfileForWorkspace(n){const a=this.G(n);return L.URI.isUri(a)?this.s.workspaces.get(a)??this.C.workspaces.get(a):this.s.emptyWindows.get(a)??this.C.emptyWindows.get(a)}G(n){return(0,v.$Vh)(n)?n.uri:(0,v.$1h)(n)?n.configPath:n.id}H(n){return!!([...this.s.emptyWindows.values()].some(a=>this.w.extUri.isEqual(a.location,n.location))||[...this.s.workspaces.values()].some(a=>this.w.extUri.isEqual(a.location,n.location))||[...this.C.emptyWindows.values()].some(a=>this.w.extUri.isEqual(a.location,n.location))||[...this.C.workspaces.values()].some(a=>this.w.extUri.isEqual(a.location,n.location)))}I(n,a,$){const S=[...this.profiles,...n],D=[];this.s.profiles=[];for(let k of S)k.isDefault||a.some(A=>k.id===A.id)||(k=$.find(A=>k.id===A.id)??k,k.isTransient?this.s.profiles.push(k):D.push({location:k.location,name:k.name,shortName:k.shortName,icon:k.icon,useDefaultFlags:k.useDefaultFlags}));this.P(D),this.z=void 0,this.J(n,a,$)}J(n,a,$){this.h.fire({added:n,removed:a,updated:$,all:this.profiles})}L(n,a,$){$=a?.isTransient?!0:$,$||this.L(n,void 0,!0);const S=this.G(n),D=$?this.s:this.C;L.URI.isUri(S)?(D.workspaces.delete(S),a&&D.workspaces.set(S,a)):(D.emptyWindows.delete(S),a&&D.emptyWindows.set(S,a)),$||this.M()}M(){const n={};for(const[$,S]of this.C.workspaces.entries())n[$.toString()]=S.id;const a={};for(const[$,S]of this.C.emptyWindows.entries())a[$.toString()]=S.id;this.R({workspaces:n,emptyWindows:a}),this.z=void 0}N(n){const a={},$=this.D();if(n.workspaces)for(const[D,k]of Object.entries(n.workspaces)){const A=L.URI.parse(k);a[D]=this.w.extUri.isEqual(A,$.location)?$.id:this.w.extUri.basename(A)}const S={};if(n.emptyWindows)for(const[D,k]of Object.entries(n.emptyWindows)){const A=L.URI.parse(k);S[D]=this.w.extUri.isEqual(A,$.location)?$.id:this.w.extUri.basename(A)}return{workspaces:a,emptyWindows:S}}O(){return[]}P(n){throw new Error("not implemented")}Q(){return{}}R(n){throw new Error("not implemented")}S(){}};e.$Ik=s,s.b="userDataProfiles",s.c="profileAssociations",e.$Ik=s=Oe([Ae(0,w.$Sh),Ae(1,b.$7j),Ae(2,g.$Dk),Ae(3,E.$6i)],s);class o extends s{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(n){this.a=n}Q(){return this.X}R(n){this.X=n}}e.$Jk=o}),define(we[255],pe([1,0,18,14,20,11,5,2,3,8,4,177,30,37,40,13,31,32,34,33]),function(le,e,y,R,r,P,L,I,w,b,C,E,v,d,g,m,l,f,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kp=e.$jp=e.$ip=e.$hp=void 0;let p=class extends I.$Qc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(n,a,$,S,D,k){super(),this.z=n,this.C=a,this.D=$,this.F=S,this.G=D,this.H=k,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new L.$Ld),this.s=this.B(new L.$Ld),this.t=this.B(new L.$Ld),this.u=this.B(new L.$Ld),this.w=this.B(new L.$Ld),this.y=[],this.B((0,I.$Oc)(()=>{this.j.forEach(({task:A})=>A.cancel()),this.m.forEach(A=>A.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(n){const a=await this.getTargetPlatform();return n.allTargetPlatforms.some($=>(0,v.$Yn)($,n.allTargetPlatforms,a))}async installFromGallery(n,a={}){try{const S=(await this.installGalleryExtensions([{extension:n,options:a}])).find(({identifier:D})=>(0,d.$ro)(D,n.identifier));if(S?.local)return S?.local;throw S?.error?S.error:t(new Error(`Unknown error while installing extension ${n.identifier.id}`))}catch($){throw t($)}}async installGalleryExtensions(n){if(!this.z.isEnabled())throw new v.$3n(E.localize(0,null),v.ExtensionManagementErrorCode.Internal);const a=[],$=[];await Promise.allSettled(n.map(async({extension:S,options:D})=>{try{const k=await this.O(S,!!D?.installGivenVersion,!!D?.installPreReleaseVersion);$.push({...k,options:D})}catch(k){a.push({identifier:S.identifier,operation:2,source:S,error:k})}})),$.length&&a.push(...await this.I($));for(const S of a)S.error&&(this.F.error("Failed to install extension.",S.identifier.id),this.F.error(S.error),S.source&&!C.URI.isUri(S.source)&&s(this.C,"extensionGallery:install",{extensionData:(0,d.$zo)(S.source),error:S.error}));return a}async uninstall(n,a={}){return this.F.trace("ExtensionManagementService#uninstall",n.identifier.id),this.Q(n,a)}async toggleAppliationScope(n,a){if((0,g.$1l)(n.manifest)||n.isBuiltin)return n;if(n.isApplicationScoped){let $=await this.updateMetadata(n,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(a,this.H.defaultProfile.extensionsResource)||($=await this.ab(n,this.H.defaultProfile.extensionsResource,a));for(const S of this.H.profiles){const D=(await this.getInstalled(1,S.extensionsResource)).find(k=>(0,d.$ro)(k.identifier,n.identifier));D?this.w.fire(D):this.u.fire({identifier:n.identifier,profileLocation:S.extensionsResource})}return $}else{const $=this.D.extUri.isEqual(a,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(n,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.ab(n,a,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:$.identifier,operation:2,local:$,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),$}}getExtensionsControlManifest(){const n=new Date().getTime();return(!this.g||n-this.h>1e3*60*5)&&(this.g=this.X(),this.h=n),this.g}registerParticipant(n){this.y.push(n)}async I(n){const a=[];return await Promise.allSettled(n.map(async $=>{try{const S=await this.J($);a.push(...S)}catch(S){a.push({identifier:{id:(0,d.$wo)($.manifest.publisher,$.manifest.name)},operation:2,source:$.extension,error:S})}})),this.s.fire(a),a}async J({manifest:n,extension:a,options:$}){const S=$.isApplicationScoped||$.isBuiltin||(0,g.$1l)(n),D={...$,installOnlyNewlyAddedFromExtensionPack:C.URI.isUri(a)?$.installOnlyNewlyAddedFromExtensionPack:!0,isApplicationScoped:S,profileLocation:S?this.H.defaultProfile.extensionsResource:$.profileLocation??this.Y()},k=se=>`${d.$so.create(se).toString()}${D.profileLocation?`-${D.profileLocation.toString()}`:""}`;if(!C.URI.isUri(a)){const se=this.j.get(k(a));if(se)return this.F.info("Extensions is already requested to install",a.identifier.id),await se.task.waitUntilTaskIsFinished(),[]}const A=[],j=[],Z=[],ae=this.Z(n,a,D);C.URI.isUri(a)||this.j.set(k(a),{task:ae,waitingTasks:[]}),this.n.fire({identifier:ae.identifier,source:a,profileLocation:D.profileLocation}),this.F.info("Installing extension:",ae.identifier.id),A.push({task:ae,manifest:n});let K=!1;try{if(D.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",ae.identifier.id);else try{const ue=await this.N(ae.identifier,n,!!D.installOnlyNewlyAddedFromExtensionPack,!!D.installPreReleaseVersion,D.profileLocation),x=await this.getInstalled(void 0,D.profileLocation),he={...D,donotIncludePackAndDependencies:!0,context:{...D.context,[v.$Tn]:!0}};for(const{gallery:V,manifest:te}of(0,y.$Kb)(ue,({gallery:G})=>G.identifier.id)){K=K||!!te.extensionDependencies?.some(q=>(0,d.$ro)({id:q},ae.identifier));const G=k(V),J=this.j.get(G);if(J){if(this.L(ae,J.task)){const q=J.task.identifier;this.F.info("Waiting for already requested installing extension",q.id,ae.identifier.id),J.waitingTasks.push(ae),j.push(L.Event.toPromise(L.Event.filter(this.onDidInstallExtensions,ne=>ne.some(me=>(0,d.$ro)(me.identifier,q)))).then(ne=>{if(this.F.info("Finished waiting for already requested installing extension",q.id,ae.identifier.id),!ne.find(re=>(0,d.$ro)(re.identifier,q))?.local)throw new Error(`Extension ${q.id} is not installed`)}))}}else if(!x.some(({identifier:q})=>(0,d.$ro)(q,V.identifier))){const q=this.Z(te,V,he);this.j.set(G,{task:q,waitingTasks:[ae]}),this.n.fire({identifier:q.identifier,source:V,profileLocation:D.profileLocation}),this.F.info("Installing extension:",q.identifier.id,ae.identifier.id),A.push({task:q,manifest:te})}}}catch(ue){if(C.URI.isUri(ae.source))(0,y.$Jb)(n.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",ae.identifier.id,ue.message),(0,y.$Jb)(n.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",ae.identifier.id,ue.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",ae.identifier.id),ue}const se=A.reduce((ue,{task:x,manifest:he})=>(ue.set(x.identifier.id.toLowerCase(),{task:x,manifest:he}),ue),new Map);for(;se.size;){let ue;const x=[...se.values()].filter(({manifest:he})=>!he.extensionDependencies?.some(V=>se.has(V.toLowerCase())));x.length?ue=se.size===1?x:x.filter(({task:he})=>!(he===ae&&!K)):(this.F.info("Found extensions with circular dependencies",x.map(({task:he})=>he.identifier.id)),ue=[...se.values()]),await this.M(ue.map(async({task:he})=>{const V=new Date().getTime();try{const te=await he.run();if(await this.M(this.y.map(G=>G.postInstall(te,he.source,D,r.CancellationToken.None))),!C.URI.isUri(he.source)){const G=he.operation===3,J=G?void 0:(new Date().getTime()-he.source.lastUpdated)/1e3;if(s(this.C,G?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,d.$zo)(he.source),verificationStatus:he.verificationStatus,duration:new Date().getTime()-V,durationSinceUpdate:J}),w.$j&&he.operation!==3)try{await this.z.reportStatistic(te.manifest.publisher,te.manifest.name,te.manifest.version,"install")}catch{}}Z.push({local:te,identifier:he.identifier,operation:he.operation,source:he.source,context:he.options.context,profileLocation:he.profileLocation,applicationScoped:te.isApplicationScoped})}catch(te){throw C.URI.isUri(he.source)||s(this.C,he.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,d.$zo)(he.source),verificationStatus:he.verificationStatus,duration:new Date().getTime()-V,error:te}),this.F.error("Error while installing the extension:",he.identifier.id),te}finally{se.delete(he.identifier.id.toLowerCase())}}))}return j.length&&await this.M(j),Z.forEach(({identifier:ue})=>this.F.info("Extension installed successfully:",ue.id)),Z}catch(se){if(A.forEach(({task:ue})=>ue.cancel()),Z.length)try{const ue=await Promise.allSettled(Z.map(({local:x})=>this.$(x,{versionOnly:!0,profileLocation:D.profileLocation}).run()));for(let x=0;x<ue.length;x++){const he=ue[x],{identifier:V}=Z[x];he.status==="fulfilled"?this.F.info("Rollback: Uninstalled extension",V.id):this.F.warn("Rollback: Error while uninstalling extension",V.id,(0,P.$8)(he.reason))}}catch(ue){this.F.warn("Error while rolling back extensions",(0,P.$8)(ue),Z.map(({identifier:x})=>x.id))}return A.map(({task:ue})=>({identifier:ue.identifier,operation:2,source:ue.source,context:D.context,profileLocation:D.profileLocation,error:se}))}finally{for(const{task:se}of A)se.source&&!C.URI.isUri(se.source)&&this.j.delete(k(se.source))}}L(n,a){for(const[,{task:$,waitingTasks:S}]of this.j.entries())if($===n&&(S.includes(a)||S.some(D=>this.L(D,a)))||$===a&&S[0]&&!this.L(n,S[0]))return!1;return!0}async M(n){const a=[],$=[],S=await Promise.allSettled(n);for(const D of S)D.status==="fulfilled"?a.push(D.value):$.push(D.reason);if($.length)throw h($);return a}async N(n,a,$,S,D){if(!this.z.isEnabled())return[];const k=await this.getInstalled(void 0,D),A=[],j=[],Z=async(ae,K)=>{A.push(ae);const se=K.extensionDependencies||[],ue=[...se];if(K.extensionPack){const x=$?k.find(he=>(0,d.$ro)(he.identifier,ae)):void 0;for(const he of K.extensionPack)x&&x.manifest.extensionPack&&x.manifest.extensionPack.some(V=>(0,d.$ro)({id:V},{id:he}))||ue.every(V=>!(0,d.$ro)({id:V},{id:he}))&&ue.push(he)}if(ue.length){const x=ue.filter(he=>A.every(V=>!(0,d.$ro)(V,{id:he})));if(x.length){const he=await this.z.getExtensions(x.map(V=>({id:V,preRelease:S})),r.CancellationToken.None);for(const V of he){if(A.find(J=>(0,d.$ro)(J,V.identifier)))continue;const te=se.some(J=>(0,d.$ro)({id:J},V.identifier));let G;try{G=await this.O(V,!1,S)}catch(J){if(te)throw J;this.F.info("Skipping the packed extension as it cannot be installed",V.identifier.id,(0,P.$8)(J));continue}j.push({gallery:G.extension,manifest:G.manifest}),await Z(G.extension.identifier,G.manifest)}}}};return await Z(n,a),j}async O(n,a,$){let S;const D=await this.getExtensionsControlManifest();if(D.malicious.some(j=>(0,d.$ro)(n.identifier,j)))throw new v.$3n(E.localize(1,null,n.identifier.id),v.ExtensionManagementErrorCode.Malicious);const k=D.deprecated[n.identifier.id.toLowerCase()];if(k?.extension?.autoMigrate){if(this.F.info(`The '${n.identifier.id}' extension is deprecated, fetching the compatible '${k.extension.id}' extension instead.`),S=(await this.z.getExtensions([{id:k.extension.id,preRelease:k.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0},r.CancellationToken.None))[0],!S)throw new v.$3n(E.localize(2,null,n.identifier.id,k.extension.id),v.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(n)){const j=await this.getTargetPlatform();throw new v.$3n(E.localize(3,null,n.identifier.id,this.G.nameLong,(0,v.$Un)(j)),v.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(S=await this.P(n,a,$),!S)throw!$&&n.properties.isPreReleaseVersion&&(await this.z.getExtensions([n.identifier],r.CancellationToken.None))[0]?new v.$3n(E.localize(4,null,n.identifier.id),v.ExtensionManagementErrorCode.ReleaseVersionNotFound):new v.$3n(E.localize(5,null,n.identifier.id,this.G.nameLong,this.G.version),v.ExtensionManagementErrorCode.Incompatible)}this.F.info("Getting Manifest...",S.identifier.id);const A=await this.z.getManifest(S,r.CancellationToken.None);if(A===null)throw new v.$3n(`Missing manifest for extension ${S.identifier.id}`,v.ExtensionManagementErrorCode.Invalid);if(A.version!==S.version)throw new v.$3n(`Cannot install '${S.identifier.id}' extension because of version mismatch in Marketplace`,v.ExtensionManagementErrorCode.Invalid);return{extension:S,manifest:A}}async P(n,a,$){const S=await this.getTargetPlatform();let D=null;return!a&&n.hasPreReleaseVersion&&n.properties.isPreReleaseVersion!==$&&(D=(await this.z.getExtensions([{...n.identifier,preRelease:$}],{targetPlatform:S,compatible:!0},r.CancellationToken.None))[0]||null),!D&&await this.z.isExtensionCompatible(n,$,S)&&(D=n),D||(a?D=(await this.z.getExtensions([{...n.identifier,version:n.version}],{targetPlatform:S,compatible:!0},r.CancellationToken.None))[0]||null:D=await this.z.getCompatibleExtension(n,$,S)),D}async Q(n,a){const $={...a,profileLocation:n.isApplicationScoped?this.H.defaultProfile.extensionsResource:a.profileLocation??this.Y()},S=ae=>`${ae.id.toLowerCase()}${$.versionOnly?`-${n.manifest.version}`:""}${$.profileLocation?`@${$.profileLocation.toString()}`:""}`,D=this.m.get(S(n.identifier));if(D)return this.F.info("Extensions is already requested to uninstall",n.identifier.id),D.waitUntilTaskIsFinished();const k=ae=>{const K=this.$(ae,$);return this.m.set(S(K.extension.identifier),K),$.profileLocation?this.F.info("Uninstalling extension from the profile:",`${ae.identifier.id}@${ae.manifest.version}`,$.profileLocation.toString()):this.F.info("Uninstalling extension:",`${ae.identifier.id}@${ae.manifest.version}`),this.t.fire({identifier:ae.identifier,profileLocation:$.profileLocation,applicationScoped:ae.isApplicationScoped}),K},A=(ae,K)=>{K?$.profileLocation?this.F.error("Failed to uninstall extension from the profile:",`${ae.identifier.id}@${ae.manifest.version}`,$.profileLocation.toString(),K.message):this.F.error("Failed to uninstall extension:",`${ae.identifier.id}@${ae.manifest.version}`,K.message):$.profileLocation?this.F.info("Successfully uninstalled extension from the profile",`${ae.identifier.id}@${ae.manifest.version}`,$.profileLocation.toString()):this.F.info("Successfully uninstalled extension:",`${ae.identifier.id}@${ae.manifest.version}`),s(this.C,"extensionGallery:uninstall",{extensionData:(0,d.$yo)(ae),error:K}),this.u.fire({identifier:ae.identifier,error:K?.code,profileLocation:$.profileLocation,applicationScoped:ae.isApplicationScoped})},j=[],Z=[];try{j.push(k(n));const ae=await this.getInstalled(1,$.profileLocation);if($.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${n.identifier.id}@${n.manifest.version}`);else{const K=this.U(n,ae);for(const se of K)this.m.has(S(se.identifier))?this.F.info("Extensions is already requested to uninstall",se.identifier.id):j.push(k(se))}$.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${n.identifier.id}@${n.manifest.version}`):this.R(j.map(K=>K.extension),ae,n),await this.M(j.map(async K=>{try{if(await K.run(),await this.M(this.y.map(se=>se.postUninstall(K.extension,$,r.CancellationToken.None))),K.extension.identifier.uuid)try{await this.z.reportStatistic(K.extension.manifest.publisher,K.extension.manifest.name,K.extension.manifest.version,"uninstall")}catch{}A(K.extension)}catch(se){const ue=se instanceof v.$3n?se:new v.$3n((0,P.$8)(se),v.ExtensionManagementErrorCode.Internal);throw A(K.extension,ue),ue}finally{Z.push(K)}}))}catch(ae){const K=ae instanceof v.$3n?ae:new v.$3n((0,P.$8)(ae),v.ExtensionManagementErrorCode.Internal);for(const se of j){try{se.cancel()}catch{}Z.includes(se)||A(se.extension,K)}throw K}finally{for(const ae of j)this.m.delete(S(ae.extension.identifier))||this.F.warn("Uninstallation task is not found in the cache",ae.extension.identifier.id)}}R(n,a,$){for(const S of n){const D=this.W(S,a);if(D.length){const k=D.filter(A=>!n.some(j=>(0,d.$ro)(j.identifier,A.identifier)));if(k.length)throw new Error(this.S(S,k,$))}}}S(n,a,$){return $===n?a.length===1?E.localize(6,null,$.manifest.displayName||$.manifest.name,a[0].manifest.displayName||a[0].manifest.name):a.length===2?E.localize(7,null,$.manifest.displayName||$.manifest.name,a[0].manifest.displayName||a[0].manifest.name,a[1].manifest.displayName||a[1].manifest.name):E.localize(8,null,$.manifest.displayName||$.manifest.name,a[0].manifest.displayName||a[0].manifest.name,a[1].manifest.displayName||a[1].manifest.name):a.length===1?E.localize(9,null,$.manifest.displayName||$.manifest.name,n.manifest.displayName||n.manifest.name,a[0].manifest.displayName||a[0].manifest.name):a.length===2?E.localize(10,null,$.manifest.displayName||$.manifest.name,n.manifest.displayName||n.manifest.name,a[0].manifest.displayName||a[0].manifest.name,a[1].manifest.displayName||a[1].manifest.name):E.localize(11,null,$.manifest.displayName||$.manifest.name,n.manifest.displayName||n.manifest.name,a[0].manifest.displayName||a[0].manifest.name,a[1].manifest.displayName||a[1].manifest.name)}U(n,a,$=[]){if($.indexOf(n)!==-1)return[];$.push(n);const S=n.manifest.extensionPack?n.manifest.extensionPack:[];if(S.length){const D=a.filter(A=>!A.isBuiltin&&S.some(j=>(0,d.$ro)({id:j},A.identifier))),k=[];for(const A of D)k.push(...this.U(A,a,$));return[...D,...k]}return[]}W(n,a){return a.filter($=>$.manifest.extensionDependencies&&$.manifest.extensionDependencies.some(S=>(0,d.$ro)({id:S},n.identifier)))}async X(){try{this.F.trace("ExtensionManagementService.refreshReportedCache");const n=await this.z.getExtensionsControlManifest();return this.F.trace("ExtensionManagementService.refreshControlCache",n),n}catch{return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{},search:[]}}}};e.$hp=p,e.$hp=p=Oe([Ae(0,v.$2n),Ae(1,f.$0k),Ae(2,u.$Dk),Ae(3,m.$6i),Ae(4,l.$lj),Ae(5,c.$Fk)],p);function h(i){const n=Array.isArray(i)?i:[i];return n.length===1?n[0]instanceof Error?n[0]:new Error(n[0]):n.reduce((a,$)=>new Error(`${a.message}${a.message?",":""}${$ instanceof Error?$.message:$}`),new Error(""))}e.$ip=h;function t(i){if(i instanceof v.$3n)return i;const n=new v.$3n(i.message,v.ExtensionManagementErrorCode.Internal);return n.stack=i.stack,n}e.$jp=t;function s(i,n,{extensionData:a,verificationStatus:$,duration:S,error:D,durationSinceUpdate:k}){let A,j;(0,b.$Ef)($)&&($===!0?$="Verified":($===!1||(A=v.ExtensionManagementErrorCode.Signature,j=$),$="Unverified")),D&&(D instanceof v.$3n?(A=D.code,D.code===v.ExtensionManagementErrorCode.Signature&&(j=D.message)):A=v.ExtensionManagementErrorCode.Internal),i.publicLog(n,{...a,verificationStatus:$,success:!D,duration:S,errorcode:A,errorcodeDetail:j,durationSinceUpdate:k})}class o{constructor(){this.d=new R.$Pg}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,R.$Eg)(n=>this.h(n))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,R.$Eg)(n=>new Promise((a,$)=>{const S=n.onCancellationRequested(()=>{S.dispose(),$(new P.$3)})})),this.d.open()),this.g.cancel()}}e.$kp=o}),define(we[45],pe([1,0,14,15,2,5,26,4,30,37,16,6,13,33,34,8,11,32]),function(le,e,y,R,r,P,L,I,w,b,C,E,v,d,g,m,l,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$np=e.$mp=e.$lp=e.ExtensionsProfileScanningErrorCode=void 0;var u;(function(s){s.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",s.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(u||(e.ExtensionsProfileScanningErrorCode=u={}));class c extends Error{constructor(o,i){super(o),this.code=i}}e.$lp=c,e.$mp=(0,E.$Lh)("IExtensionsProfileScannerService");let p=class extends r.$Qc{constructor(o,i,n,a,$,S){super(),this.j=o,this.m=i,this.n=n,this.r=a,this.s=$,this.t=S,this.b=this.B(new P.$Ld),this.onAddExtensions=this.b.event,this.c=this.B(new P.$Ld),this.onDidAddExtensions=this.c.event,this.f=this.B(new P.$Ld),this.onRemoveExtensions=this.f.event,this.g=this.B(new P.$Ld),this.onDidRemoveExtensions=this.g.event,this.h=new L.$yc}scanProfileExtensions(o,i){return this.u(o,void 0,i)}async addExtensionsToProfile(o,i){const n=[],a=[];try{return await this.u(i,$=>{const S=[];for(const D of $)o.some(([k])=>(0,b.$ro)(k.identifier,D.identifier)&&k.manifest.version!==D.version)?n.push(D):S.push(D);for(const[D,k]of o){const A=S.findIndex(Z=>(0,b.$ro)(Z.identifier,D.identifier)&&Z.version===D.manifest.version),j={identifier:D.identifier,version:D.manifest.version,location:D.location,metadata:k};A===-1?(a.push(j),S.push(j)):S.splice(A,1,j)}return a.length&&this.b.fire({extensions:a,profileLocation:i}),n.length&&this.f.fire({extensions:n,profileLocation:i}),S}),a.length&&this.c.fire({extensions:a,profileLocation:i}),n.length&&this.g.fire({extensions:n,profileLocation:i}),a}catch($){throw a.length&&this.c.fire({extensions:a,error:$,profileLocation:i}),n.length&&this.g.fire({extensions:n,error:$,profileLocation:i}),$}}async updateMetadata(o,i){const n=[];return await this.u(i,a=>{const $=[];for(const S of a){const D=o.find(([k])=>(0,b.$ro)(k.identifier,S.identifier)&&k.manifest.version===S.version);D&&(S.metadata={...S.metadata,...D[1]},n.push(S)),$.push(S)}return $}),n}async removeExtensionFromProfile(o,i){const n=[];try{await this.u(i,a=>{const $=[];for(const S of a)(0,b.$ro)(S.identifier,o.identifier)?n.push(S):$.push(S);return n.length&&this.f.fire({extensions:n,profileLocation:i}),$}),n.length&&this.g.fire({extensions:n,profileLocation:i})}catch(a){throw n.length&&this.g.fire({extensions:n,error:a,profileLocation:i}),a}}async u(o,i,n){return this.F(o).queue(async()=>{let a=[],$;try{const S=await this.m.readFile(o);$=JSON.parse(S.value.toString().trim()||"[]")}catch(S){if((0,C.$kk)(S)!==1)throw S;if(this.r.extUri.isEqual(o,this.n.defaultProfile.extensionsResource)&&($=await this.D()),!$&&n?.bailOutWhenFileNotFound)throw new c((0,l.$8)(S),"ERROR_PROFILE_NOT_FOUND")}if($){Array.isArray($)||this.w(o);let S=!1;for(const D of $){h(D)||this.w(o);let k;if((0,m.$wf)(D.relativeLocation)&&D.relativeLocation)k=this.z(D.relativeLocation);else if((0,m.$wf)(D.location))k=this.z(D.location),S=!0,D.relativeLocation=D.location,D.location=k.toJSON();else{k=I.URI.revive(D.location);const A=this.y(k);A&&(S=!0,D.relativeLocation=A)}a.push({identifier:D.identifier,location:k,version:D.version,metadata:D.metadata})}S&&await this.m.writeFile(o,R.$_d.fromString(JSON.stringify($)))}if(i){a=i(a);const S=a.map(D=>({identifier:D.identifier,version:D.version,location:D.location.toJSON(),relativeLocation:this.y(D.location),metadata:D.metadata}));await this.m.writeFile(o,R.$_d.fromString(JSON.stringify(S)))}return a})}w(o){const i=new c(`Invalid extensions content in ${o.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:i.code}),i}y(o){return this.r.extUri.isEqual(this.r.extUri.dirname(o),this.j)?this.r.extUri.basename(o):void 0}z(o){return this.r.extUri.joinPath(this.j,o)}async D(){return this.C||(this.C=(async()=>{const o=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),i=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let n;try{n=(await this.m.readFile(o)).value.toString()}catch($){if((0,C.$kk)($)===1)return;throw $}this.t.info("Migrating extensions from old default profile location",o.toString());let a;try{const $=JSON.parse(n);Array.isArray($)&&$.every(S=>h(S))?a=$:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",$)}catch($){this.t.error($)}if(a)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,R.$_d.fromString(JSON.stringify(a)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",o.toString(),this.n.defaultProfile.extensionsResource.toString())}catch($){if((0,C.$kk)($)===3)this.t.info("Migration from old default profile location to new location is done by another window",o.toString(),this.n.defaultProfile.extensionsResource.toString());else throw $}try{await this.m.del(o)}catch($){(0,C.$kk)($)!==1&&this.t.error($)}try{await this.m.del(i)}catch($){(0,C.$kk)($)!==1&&this.t.error($)}return a})()),this.C}F(o){let i=this.h.get(o);return i||(i=new y.$Xg,this.h.set(o,i)),i}};e.$np=p,e.$np=p=Oe([Ae(1,C.$7j),Ae(2,d.$Fk),Ae(3,g.$Dk),Ae(4,f.$0k),Ae(5,v.$6i)],p);function h(s){return(0,m.$yf)(s)&&(0,w.$1n)(s.identifier)&&(t(s.location)||(0,m.$wf)(s.location)&&s.location)&&((0,m.$Df)(s.relativeLocation)||(0,m.$wf)(s.relativeLocation))&&s.version&&(0,m.$wf)(s.version)}function t(s){return s?(0,m.$wf)(s.path)&&(0,m.$wf)(s.scheme):!1}}),define(we[57],pe([1,0,18,14,22,15,11,75,168,2,12,7,3,19,53,62,8,4,181,25,37,40,79,16,6,13,31,5,50,45,33,34,211]),function(le,e,y,R,r,P,L,I,w,b,C,E,v,d,g,m,l,f,u,c,p,h,t,s,o,i,n,a,$,S,D,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$up=e.$tp=e.$sp=e.$rp=e.$qp=e.Translations=void 0;var j;(function(he){function V(te,G){if(te===G)return!0;const J=Object.keys(te),q=new Set;for(const ne of Object.keys(G))q.add(ne);if(J.length!==q.size)return!1;for(const ne of J){if(te[ne]!==G[ne])return!1;q.delete(ne)}return q.size===0}he.equals=V})(j||(e.Translations=j={})),e.$qp=(0,o.$Lh)("IExtensionsScannerService");let Z=class extends b.$Qc{constructor(V,te,G,J,q,ne,me,re,B,ee,O,N){super(),this.systemExtensionsLocation=V,this.userExtensionsLocation=te,this.r=G,this.s=J,this.t=q,this.u=ne,this.w=me,this.y=re,this.z=B,this.C=ee,this.D=O,this.F=N,this.g=this.B(new a.$Ld),this.onDidChangeCache=this.g.event,this.h=(0,d.$sg)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(se,this.s,this.h)),this.m=this.B(this.F.createInstance(se,this.s,this.h)),this.n=this.B(this.F.createInstance(K,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,p.$Co)(this.w,this.y)),this.G}async scanAllExtensions(V,te,G){const[J,q]=await Promise.all([this.scanSystemExtensions(V),this.scanUserExtensions(te)]),ne=G?await this.scanExtensionsUnderDevelopment(V,[...J,...q]):[];return this.L(J,q,ne,await this.getTargetPlatform(),!0)}async scanSystemExtensions(V){const te=[];te.push(this.M(!!V.useCache,V.language)),te.push(this.N(V.language,!!V.checkControlFile));const[G,J]=await Promise.all(te);return this.J([...G,...J],0,V,!1)}async scanUserExtensions(V){const te=V.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",te);const G=this.D.extUri.isEqual(V.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,J=await this.P(te,!!V.profileLocation,1,!V.includeUninstalled,V.language,!0,G),q=V.useCache&&!J.devMode&&J.excludeObsolete?this.m:this.n;let ne;try{ne=await q.scanExtensions(J)}catch(me){if(me instanceof S.$lp&&me.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),ne=await q.scanExtensions(J);else throw me}return ne=await this.J(ne,1,V,!0),this.y.trace("Scanned user extensions:",ne.length),ne}async scanExtensionsUnderDevelopment(V,te){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const G=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(J=>J.scheme===C.Schemas.file).map(async J=>{const q=await this.P(J,!1,1,!0,V.language,!1,void 0);return(await this.n.scanOneOrMultipleExtensions(q)).map(me=>(me.type=te.find(re=>(0,p.$ro)(re.identifier,me.identifier))?.type??me.type,this.n.validate(me,q)))}))).flat();return this.J(G,"development",V,!0)}return[]}async scanExistingExtension(V,te,G){const J=await this.P(V,!1,te,!0,G.language,!0,void 0),q=await this.n.scanExtension(J);return!q||!G.includeInvalid&&!q.isValid?null:q}async scanOneOrMultipleExtensions(V,te,G){const J=await this.P(V,!1,te,!0,G.language,!0,void 0),q=await this.n.scanOneOrMultipleExtensions(J);return this.J(q,te,G,!0)}async scanMetadata(V){const te=(0,d.$sg)(V,"package.json"),G=(await this.w.readFile(te)).value.toString();return JSON.parse(G).__metadata}async updateMetadata(V,te){const G=(0,d.$sg)(V,"package.json"),J=(await this.w.readFile(G)).value.toString(),q=JSON.parse(J);te.isMachineScoped=te.isMachineScoped||void 0,te.isBuiltin=te.isBuiltin||void 0,q.__metadata={...q.__metadata,...te},await this.w.writeFile((0,d.$sg)(V,"package.json"),P.$_d.fromString(JSON.stringify(q,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(V){if(V instanceof S.$lp&&V.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw V}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const V=await this.scanUserExtensions({includeInvalid:!0});if(V.length)await this.u.addExtensionsToProfile(V.map(te=>[te,te.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,P.$_d.fromString(JSON.stringify([])))}catch(te){(0,s.$kk)(te)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,L.$8)(te))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(V){this.y.error(V)}finally{this.H=void 0}})()),this.H}async J(V,te,G,J){return G.includeAllVersions||(V=this.L(te===0?V:void 0,te===1?V:void 0,te==="development"?V:void 0,await this.getTargetPlatform(),J)),G.includeInvalid||(V=V.filter(q=>q.isValid)),V.sort((q,ne)=>{const me=E.$lc(q.location.fsPath),re=E.$lc(ne.location.fsPath);return me<re?-1:me>re?1:0})}L(V,te,G,J,q){const ne=(re,B,ee)=>{if(re.isValid&&!B.isValid)return!1;if(re.isValid===B.isValid){if(q&&g.gt(re.manifest.version,B.manifest.version))return this.y.debug(`Skipping extension ${B.location.path} with lower version ${B.manifest.version} in favour of ${re.location.path} with version ${re.manifest.version}`),!1;if(g.eq(re.manifest.version,B.manifest.version)){if(re.type===0)return this.y.debug(`Skipping extension ${B.location.path} in favour of system extension ${re.location.path} with same version`),!1;if(re.targetPlatform===J)return this.y.debug(`Skipping extension ${B.location.path} from different target platform ${B.targetPlatform}`),!1}}return ee?this.y.warn(`Overwriting user extension ${re.location.path} with ${B.location.path}.`):this.y.debug(`Overwriting user extension ${re.location.path} with ${B.location.path}.`),!0},me=new h.$Zl;return V?.forEach(re=>{const B=me.get(re.identifier.id);(!B||ne(B,re,!1))&&me.set(re.identifier.id,re)}),te?.forEach(re=>{const B=me.get(re.identifier.id);if(!B&&V&&re.type===0){this.y.debug(`Skipping obsolete system extension ${re.location.path}.`);return}(!B||ne(B,re,!1))&&me.set(re.identifier.id,re)}),G?.forEach(re=>{const B=me.get(re.identifier.id);(!B||ne(B,re,!0))&&me.set(re.identifier.id,re),me.set(re.identifier.id,re)}),[...me.values()]}async M(V,te){this.y.trace("Started scanning system extensions");const G=await this.P(this.systemExtensionsLocation,!1,0,!0,te,!0,void 0),q=await(V&&!G.devMode?this.j:this.n).scanExtensions(G);return this.y.trace("Scanned system extensions:",q.length),q}async N(V,te){const G=this.z.isBuilt?[]:this.C.builtInExtensions;if(!G?.length)return[];this.y.trace("Started scanning dev system extensions");const J=te?await this.O():{},q=[],ne=f.URI.file(E.$fc(E.$hc(C.$_f.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const re of G){const B=J[re.name]||"marketplace";switch(B){case"disabled":break;case"marketplace":q.push((0,d.$sg)(ne,re.name));break;default:q.push(f.URI.file(B));break}}const me=await Promise.all(q.map(async re=>this.n.scanExtension(await this.P(re,!1,0,!0,V,!0,void 0))));return this.y.trace("Scanned dev system extensions:",me.length),(0,y.$Fb)(me)}async O(){try{const V=await this.w.readFile(this.r);return JSON.parse(V.value.toString())}catch{return{}}}async P(V,te,G,J,q,ne,me){const re=await this.f(q??v.$q),B=await this.Q(V),ee=te&&!this.D.extUri.isEqual(V,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,O=ee?await this.Q(ee):void 0;return new ae(V,B,ee,O,te,me,G,J,ne,this.C.version,this.C.date,this.C.commit,!this.z.isBuilt,q,re)}async Q(V){try{const te=await this.w.stat(V);if(typeof te.mtime=="number")return te.mtime}catch{}}};e.$rp=Z,e.$rp=Z=Oe([Ae(4,D.$Fk),Ae(5,S.$mp),Ae(6,s.$7j),Ae(7,i.$6i),Ae(8,c.$Sh),Ae(9,n.$lj),Ae(10,k.$Dk),Ae(11,o.$Kh)],Z);class ae{constructor(V,te,G,J,q,ne,me,re,B,ee,O,N,Q,T,H){this.location=V,this.mtime=te,this.applicationExtensionslocation=G,this.applicationExtensionslocationMtime=J,this.profile=q,this.profileScanOptions=ne,this.type=me,this.excludeObsolete=re,this.validate=B,this.productVersion=ee,this.productDate=O,this.productCommit=N,this.devMode=Q,this.language=T,this.translations=H}static createNlsConfiguration(V){return{language:V.language,pseudo:V.language==="pseudo",devMode:V.devMode,translations:V.translations}}static equals(V,te){return(0,d.$lg)(V.location,te.location)&&V.mtime===te.mtime&&(0,d.$lg)(V.applicationExtensionslocation,te.applicationExtensionslocation)&&V.applicationExtensionslocationMtime===te.applicationExtensionslocationMtime&&V.profile===te.profile&&r.$2m(V.profileScanOptions,te.profileScanOptions)&&V.type===te.type&&V.excludeObsolete===te.excludeObsolete&&V.validate===te.validate&&V.productVersion===te.productVersion&&V.productDate===te.productDate&&V.productCommit===te.productCommit&&V.devMode===te.devMode&&V.language===te.language&&j.equals(V.translations,te.translations)}}e.$sp=ae;let K=class extends b.$Qc{constructor(V,te,G,J,q){super(),this.f=V,this.g=te,this.h=G,this.j=J,this.m=q}async scanExtensions(V){const te=V.profile?await this.r(V):await this.n(V);let G={};if(V.excludeObsolete&&V.type===1)try{const J=(await this.j.readFile(this.f)).value.toString();G=JSON.parse(J)}catch{}return(0,l.$Jf)(G)?te:te.filter(J=>!G[p.$so.create(J).toString()])}async n(V){const te=await this.j.resolve(V.location);if(!te.children?.length)return[];const G=await Promise.all(te.children.map(async J=>{if(!J.isDirectory||V.type===1&&(0,d.$pg)(J.resource).indexOf(".")===0)return null;const q=new ae(J.resource,V.mtime,V.applicationExtensionslocation,V.applicationExtensionslocationMtime,V.profile,V.profileScanOptions,V.type,V.excludeObsolete,V.validate,V.productVersion,V.productDate,V.productCommit,V.devMode,V.language,V.translations);return this.scanExtension(q)}));return(0,y.$Fb)(G).sort((J,q)=>J.location.path<q.location.path?-1:1)}async r(V){let te=await this.s(V.location,()=>!0,V);if(V.applicationExtensionslocation&&!this.h.extUri.isEqual(V.location,V.applicationExtensionslocation)){te=te.filter(J=>!J.metadata?.isApplicationScoped);const G=await this.s(V.applicationExtensionslocation,J=>!!J.metadata?.isBuiltin||!!J.metadata?.isApplicationScoped,V);te.push(...G)}return te}async s(V,te,G){const J=await this.g.scanProfileExtensions(V,G.profileScanOptions);if(!J.length)return[];const q=await Promise.all(J.map(async ne=>{if(te(ne)){const me=new ae(ne.location,G.mtime,G.applicationExtensionslocation,G.applicationExtensionslocationMtime,G.profile,G.profileScanOptions,G.type,G.excludeObsolete,G.validate,G.productVersion,G.productDate,G.productCommit,G.devMode,G.language,G.translations);return this.scanExtension(me,ne.metadata)}return null}));return(0,y.$Fb)(q)}async scanOneOrMultipleExtensions(V){try{if(await this.j.exists((0,d.$sg)(V.location,"package.json"))){const te=await this.scanExtension(V);return te?[te]:[]}else return await this.scanExtensions(V)}catch(te){return this.m.error(`Error scanning extensions at ${V.location.path}:`,(0,L.$8)(te)),[]}}async scanExtension(V,te){try{let G=await this.scanExtensionManifest(V.location);if(G){G.publisher||(G.publisher=h.$Tl),te=te??G.__metadata,delete G.__metadata;const J=(0,p.$wo)(G.publisher,G.name),q=te?.id?{id:J,uuid:te.id}:{id:J},ne=te?.isSystem?0:V.type,me=ne===0||!!te?.isBuiltin;G=await this.t(V.location,G,ae.createNlsConfiguration(V));const re={type:ne,identifier:q,manifest:G,location:V.location,isBuiltin:me,targetPlatform:te?.targetPlatform??"undefined",metadata:te,isValid:!0,validations:[]};return V.validate?this.validate(re,V):re}}catch(G){V.type!==0&&this.m.error(G)}return null}validate(V,te){let G=!0;const J=(0,t.$Ho)(te.productVersion,te.productDate,te.location,V.manifest,V.isBuiltin);for(const[q,ne]of J)q===m.default.Error&&(G=!1,this.m.error(this.z(te.location,ne)));return V.isValid=G,V.validations=J,V}async scanExtensionManifest(V){const te=(0,d.$sg)(V,"package.json");let G;try{G=(await this.j.readFile(te)).value.toString()}catch(q){return(0,s.$kk)(q)!==1&&this.m.error(this.z(V,(0,u.localize)(0,null,te.path,q.message))),null}let J;try{J=JSON.parse(G)}catch{const ne=[];(0,I.$Nm)(G,ne);for(const me of ne)this.m.error(this.z(V,(0,u.localize)(1,null,te.path,me.offset,me.length,(0,w.$op)(me.error))));return null}return(0,I.$Wm)(J)!=="object"?(this.m.error(this.z(V,(0,u.localize)(2,null,te.path))),null):J}async t(V,te,G){const J=await this.u(V,te,G);if(J)try{const q=[],ne=await this.w(J.default,q);if(q.length>0)return q.forEach(re=>{this.m.error(this.z(V,(0,u.localize)(3,null,J.default?.path,(0,w.$op)(re.error))))}),te;if((0,I.$Wm)(J)!=="object")return this.m.error(this.z(V,(0,u.localize)(4,null,J.default?.path))),te;const me=J.values||Object.create(null);return(0,A.$pp)(this.m,te,me,ne)}catch{}return te}async u(V,te,G){const J=(0,d.$sg)(V,"package.nls.json"),q=(B,ee)=>{ee.forEach(O=>{this.m.error(this.z(V,(0,u.localize)(5,null,B?.path,(0,w.$op)(O.error))))})},ne=B=>{this.m.error(this.z(V,(0,u.localize)(6,null,B?.path)))},me=`${te.publisher}.${te.name}`,re=G.translations[me];if(re)try{const B=f.URI.file(re),ee=(await this.j.readFile(B)).value.toString(),O=[],N=(0,I.$Nm)(ee,O);return O.length>0?(q(B,O),{values:void 0,default:J}):(0,I.$Wm)(N)!=="object"?(ne(B),{values:void 0,default:J}):{values:N.contents?N.contents.package:void 0,default:J}}catch{return{values:void 0,default:J}}else{if(!await this.j.exists(J))return;let ee;try{ee=await this.y(V,G)}catch{return}if(!ee.localized)return{values:void 0,default:ee.original};try{const O=(await this.j.readFile(ee.localized)).value.toString(),N=[],Q=(0,I.$Nm)(O,N);return N.length>0?(q(ee.localized,N),{values:void 0,default:ee.original}):(0,I.$Wm)(Q)!=="object"?(ne(ee.localized),{values:void 0,default:ee.original}):{values:Q,default:ee.original}}catch{return{values:void 0,default:ee.original}}}}async w(V,te){if(V)try{const G=(await this.j.readFile(V)).value.toString();return(0,I.$Nm)(G,te)}catch{}}y(V,te){return new Promise((G,J)=>{const q=ne=>{const me=(0,d.$sg)(V,`package.nls.${ne}.json`);this.j.exists(me).then(re=>{re&&G({localized:me,original:(0,d.$sg)(V,"package.nls.json")});const B=ne.lastIndexOf("-");B===-1?G({localized:(0,d.$sg)(V,"package.nls.json"),original:null}):(ne=ne.substring(0,B),q(ne))})};if(te.devMode||te.pseudo||!te.language)return G({localized:(0,d.$sg)(V,"package.nls.json"),original:null});q(te.language)})}z(V,te){return`[${V.path}]: ${te}`}};K=Oe([Ae(1,S.$mp),Ae(2,k.$Dk),Ae(3,s.$7j),Ae(4,i.$6i)],K);let se=class extends K{constructor(V,te,G,J,q,ne,me){super(te,J,q,ne,me),this.G=V,this.H=G,this.D=this.B(new R.$Og(3e3)),this.F=this.B(new a.$Ld),this.onDidChangeCache=this.F.event}async scanExtensions(V){const te=this.M(V),G=await this.I(te);if(this.C=V,G&&G.input&&ae.equals(G.input,this.C))return this.m.debug("Using cached extensions scan result",V.location.toString()),this.D.trigger(()=>this.L()),G.result.map(q=>(q.location=f.URI.revive(q.location),q));const J=await super.scanExtensions(V);return await this.J(te,{input:V,result:J}),J}async I(V){try{const te=await this.j.readFile(V),G=JSON.parse(te.value.toString());return{result:G.result,input:(0,$.$ih)(G.input)}}catch(te){this.m.debug("Error while reading the extension cache file:",V.path,(0,L.$8)(te))}return null}async J(V,te){try{await this.j.writeFile(V,P.$_d.fromString(JSON.stringify(te)))}catch(G){this.m.debug("Error while writing the extension cache file:",V.path,(0,L.$8)(G))}}async L(){if(!this.C)return;const V=this.M(this.C),te=await this.I(V);if(!te)return;const G=te.result,J=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!r.$2m(J,G))try{this.m.info("Invalidating Cache",G,J),await this.j.del(V),this.F.fire()}catch(q){this.m.error(q)}}M(V){const te=this.N(V);return this.h.extUri.joinPath(te.cacheHome,V.type===0?h.$Sl:h.$Rl)}N(V){return V.type===0?this.H.defaultProfile:V.profile?this.h.extUri.isEqual(V.location,this.G.extensionsResource)?this.G:this.H.profiles.find(te=>this.h.extUri.isEqual(V.location,te.extensionsResource))??this.G:this.H.defaultProfile}};se=Oe([Ae(2,D.$Fk),Ae(3,S.$mp),Ae(4,k.$Dk),Ae(5,s.$7j),Ae(6,i.$6i)],se);function ue(he,V){const te=(0,p.$uo)(he.manifest.publisher,he.manifest.name);return{id:te,identifier:new h.$Xl(te),isBuiltin:he.type===0,isUserBuiltin:he.type===1&&he.isBuiltin,isUnderDevelopment:V,extensionLocation:he.location,uuid:he.identifier.uuid,targetPlatform:he.targetPlatform,...he.manifest}}e.$tp=ue;class x extends Z{constructor(V,te,G,J,q,ne,me,re,B,ee,O,N){super(V,te,(0,d.$sg)(G,".vscode-oss-dev","extensions","control.json"),J,q,ne,me,re,B,ee,O,N),this.R=(async()=>{if(v.$t)try{const Q=await this.w.readFile(f.URI.file(v.$t));return JSON.parse(Q.value.toString())}catch{}return Object.create(null)})()}f(V){return this.R}}e.$up=x}),define(we[256],pe([1,0,52,14,39,5,2,12,7,21,13,33]),function(le,e,y,R,r,P,L,I,w,b,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wp=void 0;let v=class extends L.$Qc{constructor(g,m){super(),this.b=g,this.f=m,this.a=new R.$Wg(5)}async postUninstall(g){const m=this.g(g,"uninstall");m&&(this.f.info(g.identifier.id,g.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(m.script,"uninstall",m.args,!0,g),this.f.info("Finished running post uninstall script",g.identifier.id,g.manifest.version)}catch(l){this.f.error("Failed to run post uninstall script",g.identifier.id,g.manifest.version),this.f.error(l)}}));try{await b.Promises.rm(this.m(g))}catch(l){this.f.error("Error while removing extension storage path",g.identifier.id),this.f.error(l)}}g(g,m){const l=`vscode:${m}`;if(g.location.scheme===I.Schemas.file&&g.manifest&&g.manifest.scripts&&typeof g.manifest.scripts[l]=="string"){const f=g.manifest.scripts[l].split(" ");return f.length<2||f[0]!=="node"||!f[1]?(this.f.warn(g.identifier.id,g.manifest.version,`${l} should be a node script`),null):{script:(0,w.$hc)(g.location.fsPath,f[1]),args:f.slice(2)||[]}}return null}h(g,m,l,f,u){return new Promise((c,p)=>{const h=this.j(g,m,l,u);let t;const s=o=>{t&&(clearTimeout(t),t=null),o?p(o):c(void 0)};h.on("error",o=>{s((0,r.$wi)(o)||"Unknown")}),h.on("exit",(o,i)=>{s(o?`post-${m} process exited with code ${o}`:void 0)}),f&&(t=setTimeout(()=>{t=null,h.kill(),p("timed out")},5e3))})}j(g,m,l,f){const u={silent:!0,execArgv:void 0},c=(0,y.fork)(g,[`--type=extension-post-${m}`,...l],u);c.stdout.setEncoding("utf8"),c.stderr.setEncoding("utf8");const p=P.Event.fromNodeEventEmitter(c.stdout,"data"),h=P.Event.fromNodeEventEmitter(c.stderr,"data");p(o=>this.f.info(f.identifier.id,f.manifest.version,`post-${m}`,o)),h(o=>this.f.error(f.identifier.id,f.manifest.version,`post-${m}`,o));const t=P.Event.any(P.Event.map(p,o=>({data:`%c${o}`,format:[""]})),P.Event.map(h,o=>({data:`%c${o}`,format:["color: red"]})));return P.Event.debounce(t,(o,i)=>o?{data:o.data+i.data,format:[...o.format,...i.format]}:{data:i.data,format:i.format},100)(o=>{console.group(f.identifier.id),console.log(o.data,...o.format),console.groupEnd()}),c}m(g){return(0,w.$hc)(this.b.defaultProfile.globalStorageHome.fsPath,g.identifier.id.toLowerCase())}};e.$wp=v,e.$wp=v=Oe([Ae(0,E.$Fk),Ae(1,C.$6i)],v)}),define(we[125],pe([1,0,13,33,34,32,45,16,25,4]),function(le,e,y,R,r,P,L,I,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uN=void 0;let C=class extends L.$np{constructor(v,d,g,m,l,f){super(b.URI.file(v.extensionsPath),d,g,m,l,f)}};e.$uN=C,e.$uN=C=Oe([Ae(0,w.$Th),Ae(1,I.$7j),Ae(2,R.$Fk),Ae(3,r.$Dk),Ae(4,P.$0k),Ae(5,y.$6i)],C)}),define(we[257],pe([1,0,14,5,2,41,8,159,6,33]),function(le,e,y,R,r,P,L,I,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3o=e.$2o=e.$1o=e.$Zo=e.$Yo=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$Xo=e.$Wo=e.$Vo=void 0,e.$Vo="__$__isNewStorageMarker",e.$Wo="__$__targetStorageMarker",e.$Xo=(0,w.$Lh)("storageService");var C;(function(u){u[u.NONE=0]="NONE",u[u.SHUTDOWN=1]="SHUTDOWN"})(C||(e.WillSaveStateReason=C={}));var E;(function(u){u[u.APPLICATION=-1]="APPLICATION",u[u.PROFILE=0]="PROFILE",u[u.WORKSPACE=1]="WORKSPACE"})(E||(e.StorageScope=E={}));var v;(function(u){u[u.USER=0]="USER",u[u.MACHINE=1]="MACHINE"})(v||(e.StorageTarget=v={}));function d(u){const c=u.get(e.$Wo);if(c)try{return JSON.parse(c)}catch{}return Object.create(null)}e.$Yo=d;class g extends r.$Qc{constructor(c={flushInterval:g.a}){super(),this.m=c,this.b=this.B(new R.$Od),this.c=this.B(new R.$Od),this.onDidChangeTarget=this.c.event,this.f=this.B(new R.$Ld),this.onWillSaveState=this.f.event,this.h=this.B(new y.$3g(()=>this.n(),this.m.flushInterval)),this.j=this.B(new r.$Rc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(c,p,h){return R.Event.filter(this.b.event,t=>t.scope===c&&(p===void 0||t.key===p),h)}n(){this.j.value=(0,y.$7g)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,r.$Lc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,P.mark)("code/willInitStorage");try{await this.O()}finally{(0,P.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(c,p){const{key:h,external:t}=p;if(h===e.$Wo){switch(c){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:c})}else this.b.fire({scope:c,key:h,target:this.J(c)[h],external:t})}w(c){this.f.fire({reason:c})}get(c,p,h){return this.P(p)?.get(c,h)}getBoolean(c,p,h){return this.P(p)?.getBoolean(c,h)}getNumber(c,p,h){return this.P(p)?.getNumber(c,h)}getObject(c,p,h){return this.P(p)?.getObject(c,h)}storeAll(c,p){this.y(()=>{for(const h of c)this.store(h.key,h.value,h.scope,h.target,p)})}store(c,p,h,t,s=!1){if((0,L.$Ff)(p)){this.remove(c,h,s);return}this.y(()=>{this.z(c,h,t),this.P(h)?.set(c,p,s)})}remove(c,p,h=!1){this.y(()=>{this.z(c,p,void 0),this.P(p)?.delete(c,h)})}y(c){this.b.pause(),this.c.pause();try{c()}finally{this.b.resume(),this.c.resume()}}keys(c,p){const h=[],t=this.J(c);for(const s of Object.keys(t))t[s]===p&&h.push(s);return h}z(c,p,h,t=!1){const s=this.J(p);typeof h=="number"?s[c]!==h&&(s[c]=h,this.P(p)?.set(e.$Wo,JSON.stringify(s),t)):typeof s[c]=="number"&&(delete s[c],this.P(p)?.set(e.$Wo,JSON.stringify(s),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(c){switch(c){case-1:return this.I;case 0:return this.G;default:return this.D}}L(c){const p=this.P(c);return p?d(p):Object.create(null)}isNew(c){return this.getBoolean(e.$Vo,c)===!0}async flush(c=C.NONE){this.f.fire({reason:c});const p=this.P(-1),h=this.P(0),t=this.P(1);switch(c){case C.NONE:await y.Promises.settled([p?.whenFlushed()??Promise.resolve(),h?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case C.SHUTDOWN:await y.Promises.settled([p?.flush(0)??Promise.resolve(),h?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const c=this.P(-1)?.items??new Map,p=this.P(0)?.items??new Map,h=this.P(1)?.items??new Map;return f(c,p,h,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(c){return await this.flush(),this.P(c)?.optimize()}async switch(c,p){return this.w(C.NONE),(0,b.$Ek)(c)?this.R(c,p):this.S(c,p)}M(c,p){return!(c.id===p.id||m(p)&&m(c))}N(c,p,h){this.y(()=>{const t=new Set;for(const[s,o]of c)t.add(s),p.get(s)!==o&&this.u(h,{key:s,external:!0});for(const[s]of p.items)t.has(s)||this.u(h,{key:s,external:!0})})}}e.$Zo=g,g.a=60*1e3;function m(u){return u.isDefault||!!u.useDefaultFlags?.globalState}e.$1o=m;class l extends g{constructor(){super(),this.U=this.B(new I.$To(new I.$Uo,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new I.$To(new I.$Uo,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new I.$To(new I.$Uo,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(c=>this.u(1,c))),this.B(this.W.onDidChangeStorage(c=>this.u(0,c))),this.B(this.U.onDidChangeStorage(c=>this.u(-1,c)))}P(c){switch(c){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(c){switch(c){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(c){return!1}}e.$2o=l;async function f(u,c,p,h,t,s){const o=j=>{try{return JSON.parse(j)}catch{return j}},i=new Map,n=new Map;u.forEach((j,Z)=>{i.set(Z,j),n.set(Z,o(j))});const a=new Map,$=new Map;c.forEach((j,Z)=>{a.set(Z,j),$.set(Z,o(j))});const S=new Map,D=new Map;p.forEach((j,Z)=>{S.set(Z,j),D.set(Z,o(j))}),console.group(h!==t?`Storage: Application (path: ${h})`:`Storage: Application & Profile (path: ${h}, default profile)`);const k=[];if(i.forEach((j,Z)=>{k.push({key:Z,value:j})}),console.table(k),console.groupEnd(),console.log(n),h!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const j=[];a.forEach((Z,ae)=>{j.push({key:ae,value:Z})}),console.table(j),console.groupEnd(),console.log($)}console.group(`Storage: Workspace (path: ${s})`);const A=[];S.forEach((j,Z)=>{A.push({key:Z,value:j})}),console.table(A),console.groupEnd(),console.log(D)}e.$3o=f}),define(we[126],pe([1,0,18,20,11,3,28,8,4,24,25,30,37,79,16,13,31,44,240,257,32,60]),function(le,e,y,R,r,P,L,I,w,b,C,E,v,d,g,m,l,f,u,c,p,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8o=e.$7o=e.$6o=void 0;const t=P.$j?"web":(0,E.$Wn)(P.$o,L.$cc),s="X-Market-Search-Activity-Id";var o;(function(O){O[O.None=0]="None",O[O.IncludeVersions=1]="IncludeVersions",O[O.IncludeFiles=2]="IncludeFiles",O[O.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",O[O.IncludeSharedAccounts=8]="IncludeSharedAccounts",O[O.IncludeVersionProperties=16]="IncludeVersionProperties",O[O.ExcludeNonValidated=32]="ExcludeNonValidated",O[O.IncludeInstallationTargets=64]="IncludeInstallationTargets",O[O.IncludeAssetUri=128]="IncludeAssetUri",O[O.IncludeStatistics=256]="IncludeStatistics",O[O.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",O[O.Unpublished=4096]="Unpublished",O[O.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(o||(o={}));function i(...O){return String(O.reduce((N,Q)=>N|Q,0))}var n;(function(O){O[O.Tag=1]="Tag",O[O.ExtensionId=4]="ExtensionId",O[O.Category=5]="Category",O[O.ExtensionName=7]="ExtensionName",O[O.Target=8]="Target",O[O.Featured=9]="Featured",O[O.SearchText=10]="SearchText",O[O.ExcludeWithFlags=12]="ExcludeWithFlags"})(n||(n={}));const a={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},$={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},D={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:o.None,criteria:[],assetTypes:[]};class k{constructor(N=D){this.d=N}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(N,Q=this.d.pageSize){return new k({...this.d,pageNumber:N,pageSize:Q})}withFilter(N,...Q){const T=[...this.d.criteria,...Q.length?Q.map(H=>({filterType:N,value:H})):[{filterType:N}]];return new k({...this.d,criteria:T})}withSortBy(N){return new k({...this.d,sortBy:N})}withSortOrder(N){return new k({...this.d,sortOrder:N})}withFlags(...N){return new k({...this.d,flags:N.reduce((Q,T)=>Q|T,0)})}withAssetTypes(...N){return new k({...this.d,assetTypes:N})}withSource(N){return new k({...this.d,source:N})}get raw(){const{criteria:N,pageNumber:Q,pageSize:T,sortBy:H,sortOrder:U,flags:ie,assetTypes:z}=this.d;return{filters:[{criteria:N,pageNumber:Q,pageSize:T,sortBy:H,sortOrder:U}],assetTypes:z,flags:ie}}get searchText(){const N=this.d.criteria.filter(Q=>Q.filterType===n.SearchText)[0];return N&&N.value?N.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(N=>String(N.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function A(O,N){const Q=(O||[]).filter(T=>T.statisticName===N)[0];return Q?Q.value:0}function j(O){const N="Microsoft.VisualStudio.Code.Translation.";return O.files.filter(T=>T.assetType.indexOf(N)===0).reduce((T,H)=>{const U=K(O,H.assetType);return U&&T.push([H.assetType.substring(N.length),U]),T},[])}function Z(O){if(O.properties){const N=O.properties.filter(H=>H.key===a.Repository),Q=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),T=N.filter(H=>Q.test(H.value))[0];return T?{uri:T.value,fallbackUri:T.value}:null}return K(O,a.Repository)}function ae(O){return{uri:`${O.fallbackAssetUri}/${a.VSIX}?redirect=true${O.targetPlatform?`&targetPlatform=${O.targetPlatform}`:""}`,fallbackUri:`${O.fallbackAssetUri}/${a.VSIX}${O.targetPlatform?`?targetPlatform=${O.targetPlatform}`:""}`}}function K(O,N){return O.files.filter(T=>T.assetType===N)[0]?{uri:`${O.assetUri}/${N}${O.targetPlatform?`?targetPlatform=${O.targetPlatform}`:""}`,fallbackUri:`${O.fallbackAssetUri}/${N}${O.targetPlatform?`?targetPlatform=${O.targetPlatform}`:""}`}:null}function se(O,N){const Q=O.properties?O.properties.filter(H=>H.key===N):[],T=Q.length>0&&Q[0].value;return T?T.split(",").map(H=>(0,v.$vo)(H)):[]}function ue(O){const N=O.properties?O.properties.filter(Q=>Q.key===$.Engine):[];return N.length>0&&N[0].value||""}function x(O){const N=O.properties?O.properties.filter(Q=>Q.key===$.PreRelease):[];return N.length>0&&N[0].value==="true"}function he(O){const N=O.properties?O.properties.filter(T=>T.key===$.LocalizedLanguages):[],Q=N.length>0&&N[0].value||"";return Q?Q.split(","):[]}function V(O){return O.properties?.find(N=>N.key===$.SponsorLink)?.value}function te(O){return O.indexOf("preview")!==-1}function G(O){return O.targetPlatform?(0,E.$Vn)(O.targetPlatform):"undefined"}function J(O){const N=(0,y.$Kb)(O.versions.map(G)),Q=!!O.tags?.includes(E.$Qn),T=N.indexOf("web");return Q?T===-1&&N.push("web"):T!==-1&&N.splice(T,1),N}function q(O,N){const Q=(0,E.$Zn)(N);for(let T=0;T<O.length;T++){const H=O[T];if(H.version===O[T-1]?.version){let U=T;const ie=G(H);if(ie===N)for(;U>0&&O[U-1].version===H.version;)U--;else if(Q.includes(ie))for(;U>0&&O[U-1].version===H.version&&G(O[U-1])!==N;)U--;U!==T&&(O.splice(T,1),O.splice(U,0,H))}}return O}e.$6o=q;function ne(O,N,Q){O.telemetryData={index:N,querySource:Q,queryActivityId:O.queryContext?.[s]}}function me(O,N,Q,T){const H=O.versions[0],U={manifest:K(N,a.Manifest),readme:K(N,a.Details),changelog:K(N,a.Changelog),license:K(N,a.License),repository:Z(N),download:ae(N),icon:K(N,a.Icon),signature:K(N,a.Signature),coreTranslations:j(N)};return{identifier:{id:(0,v.$wo)(O.publisher.publisherName,O.extensionName),uuid:O.extensionId},name:O.extensionName,version:N.version,displayName:O.displayName,publisherId:O.publisher.publisherId,publisher:O.publisher.publisherName,publisherDisplayName:O.publisher.displayName,publisherDomain:O.publisher.domain?{link:O.publisher.domain,verified:!!O.publisher.isDomainVerified}:void 0,publisherSponsorLink:V(H),description:O.shortDescription||"",installCount:A(O.statistics,"install"),rating:A(O.statistics,"averagerating"),ratingCount:A(O.statistics,"ratingcount"),categories:O.categories||[],tags:O.tags||[],releaseDate:Date.parse(O.releaseDate),lastUpdated:Date.parse(O.lastUpdated),allTargetPlatforms:Q,assets:U,properties:{dependencies:se(N,$.Dependency),extensionPack:se(N,$.ExtensionPack),engine:ue(N),localizedLanguages:he(N),targetPlatform:G(N),isPreReleaseVersion:x(N)},hasPreReleaseVersion:x(H),hasReleaseVersion:!0,preview:te(O.flags),isSigned:!!U.signature,queryContext:T}}let re=class{constructor(N,Q,T,H,U,ie,z,_){this.k=Q,this.l=T,this.n=H,this.o=U,this.q=ie,this.u=z,this.w=_;const W=z.extensionsGallery,X=W?.servicePPEUrl&&_.getValue("_extensionsGallery.enablePPE");this.d=X?W.servicePPEUrl:W?.serviceUrl,this.g=X?void 0:W?.searchUrl,this.h=W?.controlUrl,this.j=(0,u.$5o)(z.version,z,this.n,this.w,this.q,N,this.o)}x(N=""){return`${this.d}${N}`}isEnabled(){return!!this.d}async getExtensions(N,Q,T){const H=R.CancellationToken.isCancellationToken(Q)?{}:Q,U=R.CancellationToken.isCancellationToken(Q)?Q:T,ie=[],z=[],_=[],W=[];let X=!0;for(const Ee of N){Ee.uuid?z.push(Ee.uuid):ie.push(Ee.id);const Pe=!!(Ee.version||Ee.preRelease);_.push({id:Ee.id,uuid:Ee.uuid,includePreRelease:Pe}),Ee.version&&W.push({id:Ee.id,uuid:Ee.uuid,version:Ee.version}),X=X&&!!Ee.hasPreRelease&&!Pe}if(!z.length&&!ie.length)return[];let oe=new k().withPage(1,N.length);z.length&&(oe=oe.withFilter(n.ExtensionId,...z)),ie.length&&(oe=oe.withFilter(n.ExtensionName,...ie)),(H.queryAllVersions||X)&&(oe=oe.withFlags(oe.flags,o.IncludeVersions)),H.source&&(oe=oe.withSource(H.source));const{extensions:ge}=await this.z(oe,{targetPlatform:H.targetPlatform??t,includePreRelease:_,versions:W,compatible:!!H.compatible},U);return H.source&&ge.forEach((Ee,Pe)=>ne(Ee,Pe,H.source)),ge}async getCompatibleExtension(N,Q,T){if((0,E.$Xn)(N.allTargetPlatforms,T))return null;if(await this.isExtensionCompatible(N,Q,T))return N;const H=new k().withFlags(o.IncludeVersions).withPage(1,1).withFilter(n.ExtensionId,N.identifier.uuid),{extensions:U}=await this.z(H,{targetPlatform:T,compatible:!0,includePreRelease:Q},R.CancellationToken.None);return U[0]||null}async isExtensionCompatible(N,Q,T){if(!(0,E.$Yn)(N.properties.targetPlatform,N.allTargetPlatforms,T)||!Q&&N.properties.isPreReleaseVersion)return!1;let H=N.properties.engine;if(!H){const U=await this.getManifest(N,R.CancellationToken.None);if(!U)throw new Error("Manifest was not found");H=U.engines.vscode}return(0,d.$Jo)(H,this.u.version,this.u.date)}async y(N,Q,T,H,U){if(!(0,E.$Yn)(G(N),H,U)||Q!=="any"&&x(N)!==(Q==="prerelease"))return!1;if(T)try{const ie=await this.E(N);if(!(0,d.$Jo)(ie,this.u.version,this.u.date))return!1}catch(ie){return this.l.error(`Error while getting the engine for the version ${N.version}.`,(0,r.$8)(ie)),!1}return!0}async query(N,Q){let T=N.text||"";const H=N.pageSize??50;let U=new k().withPage(1,H);T?(T=T.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(X,oe,ge)=>(U=U.withFilter(n.Category,ge||oe),"")),T=T.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(X,oe,ge)=>(U=U.withFilter(n.Tag,ge||oe),"")),T=T.replace(/\bfeatured(\s+|\b|$)/g,()=>(U=U.withFilter(n.Featured),"")),T=T.trim(),T&&(T=T.length<200?T:T.substring(0,200),U=U.withFilter(n.SearchText,T)),U=U.withSortBy(0)):N.ids?U=U.withFilter(n.ExtensionId,...N.ids):N.names?U=U.withFilter(n.ExtensionName,...N.names):U=U.withSortBy(4),typeof N.sortBy=="number"&&(U=U.withSortBy(N.sortBy)),typeof N.sortOrder=="number"&&(U=U.withSortOrder(N.sortOrder)),N.source&&(U=U.withSource(N.source));const ie=async(X,oe)=>{const{extensions:ge,total:Ee}=await this.z(X,{targetPlatform:t,compatible:!1,includePreRelease:!!N.includePreRelease},oe);return ge.forEach((Pe,Ne)=>ne(Pe,(X.pageNumber-1)*X.pageSize+Ne,N.source)),{extensions:ge,total:Ee}},{extensions:z,total:_}=await ie(U,Q),W=async(X,oe)=>{if(oe.isCancellationRequested)throw new r.$3;const{extensions:ge}=await ie(U.withPage(X+1),oe);return ge};return{firstPage:z,total:_,pageSize:U.pageSize,getPage:W}}async z(N,Q,T){const H=N.flags;N.flags&o.IncludeLatestVersionOnly&&N.flags&o.IncludeVersions&&(N=N.withFlags(N.flags&~o.IncludeVersions,o.IncludeLatestVersionOnly)),!(N.flags&o.IncludeLatestVersionOnly)&&!(N.flags&o.IncludeVersions)&&(N=N.withFlags(N.flags,o.IncludeLatestVersionOnly)),Q.versions?.length&&(N=N.withFlags(N.flags&~o.IncludeLatestVersionOnly,o.IncludeVersions)),N=N.withFlags(N.flags,o.IncludeAssetUri,o.IncludeCategoryAndTags,o.IncludeFiles,o.IncludeStatistics,o.IncludeVersionProperties);const{galleryExtensions:U,total:ie,context:z}=await this.B(N,T);if(!(N.flags&o.IncludeLatestVersionOnly)){const oe=[];for(const ge of U){const Ee=await this.A(ge,Q,z);Ee&&oe.push(Ee)}return{extensions:oe,total:ie}}const W=[],X=new Map;for(let oe=0;oe<U.length;oe++){const ge=U[oe],Ee={id:(0,v.$wo)(ge.publisher.publisherName,ge.extensionName),uuid:ge.extensionId},Pe=(0,I.$Cf)(Q.includePreRelease)?Q.includePreRelease:!!Q.includePreRelease.find(Fe=>(0,v.$ro)(Fe,Ee))?.includePreRelease;if(Q.compatible&&(0,E.$Xn)(J(ge),Q.targetPlatform))continue;const Ne=await this.A(ge,Q,z);!Ne||Ne.properties.isPreReleaseVersion&&(!Pe||!Ne.hasReleaseVersion)||!Ne.properties.isPreReleaseVersion&&Ne.properties.targetPlatform!==Q.targetPlatform&&Ne.hasPreReleaseVersion?X.set(ge.extensionId,oe):W.push([oe,Ne])}if(X.size){const oe=new h.$Hd,ge=new k().withFlags(H&~o.IncludeLatestVersionOnly,o.IncludeVersions).withPage(1,X.size).withFilter(n.ExtensionId,...X.keys()),{extensions:Ee}=await this.z(ge,Q,T);this.o.publicLog2("galleryService:additionalQuery",{duration:oe.elapsed(),count:X.size});for(const Pe of Ee){const Ne=X.get(Pe.identifier.uuid);W.push([Ne,Pe])}}return{extensions:W.sort((oe,ge)=>oe[0]-ge[0]).map(([,oe])=>oe),total:ie}}async A(N,Q,T){const H={id:(0,v.$wo)(N.publisher.publisherName,N.extensionName),uuid:N.extensionId},U=Q.versions?.find(W=>(0,v.$ro)(W,H))?.version,ie=(0,I.$Cf)(Q.includePreRelease)?Q.includePreRelease:!!Q.includePreRelease.find(W=>(0,v.$ro)(W,H))?.includePreRelease,z=J(N),_=q(N.versions,Q.targetPlatform);if(Q.compatible&&(0,E.$Xn)(z,Q.targetPlatform))return null;for(let W=0;W<_.length;W++){const X=_[W];if(!(U&&X.version!==U)){if(await this.y(X,ie?"any":"release",Q.compatible,z,Q.targetPlatform))return me(N,X,z,T);if(U&&X.version===U)return null}}return U||Q.compatible?null:me(N,N.versions[0],z)}async B(N,Q){if(!this.isEnabled())throw new Error("No extension gallery service configured.");N=N.withFlags(N.flags,o.ExcludeNonValidated).withFilter(n.Target,"Microsoft.VisualStudio.Code").withFilter(n.ExcludeWithFlags,i(o.Unpublished));const T=await this.j,H=JSON.stringify(N.raw),U={...T,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(H.length)},ie=new h.$Hd;let z,_,W=0;try{if(z=await this.k.request({type:"POST",url:this.g&&N.criteria.some(oe=>oe.filterType===n.SearchText)?this.g:this.x("/extensionquery"),data:H,headers:U},Q),z.res.statusCode&&z.res.statusCode>=400&&z.res.statusCode<500)return{galleryExtensions:[],total:W};const X=await(0,f.$Qo)(z);if(X){const oe=X.results[0],ge=oe.extensions,Ee=oe.resultMetadata&&oe.resultMetadata.filter(Pe=>Pe.metadataType==="ResultCount")[0];return W=Ee&&Ee.metadataItems.filter(Pe=>Pe.name==="TotalCount")[0].count||0,{galleryExtensions:ge,total:W,context:{[s]:z.res.headers.activityid}}}return{galleryExtensions:[],total:W}}catch(X){throw _=X,X}finally{this.o.publicLog2("galleryService:query",{...N.telemetryData,requestBodySize:String(H.length),duration:ie.elapsed(),success:!!z&&(0,f.$Mo)(z),responseBodySize:z?.res.headers["Content-Length"],statusCode:z?String(z.res.statusCode):void 0,errorCode:_?(0,r.$2)(_)?"canceled":(0,r.$8)(_).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(W)})}}async reportStatistic(N,Q,T,H){if(!this.isEnabled())return;const U=P.$j?this.x(`/itemName/${N}.${Q}/version/${T}/statType/${H==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${N}/extensions/${Q}/${T}/stats?statType=${H}`),ie=P.$j?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",_={...await this.j,Accept:ie};try{await this.k.request({type:"POST",url:U,headers:_},R.CancellationToken.None)}catch{}}async download(N,Q,T){this.l.trace("ExtensionGalleryService#download",N.identifier.id);const H=(0,v.$zo)(N),U=new Date().getTime(),ie=oe=>this.o.publicLog("galleryService:downloadVSIX",{...H,duration:oe}),z=T===2?"install":T===3?"update":"",_=z?{uri:`${N.assets.download.uri}${w.URI.parse(N.assets.download.uri).query?"&":"?"}${z}=true`,fallbackUri:`${N.assets.download.fallbackUri}${w.URI.parse(N.assets.download.fallbackUri).query?"&":"?"}${z}=true`}:N.assets.download,W=N.queryContext?.[s]?{[s]:N.queryContext[s]}:void 0,X=await this.D(_,W?{headers:W}:void 0);await this.q.writeFile(Q,X.stream),ie(new Date().getTime()-U)}async downloadSignatureArchive(N,Q){if(!N.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",N.identifier.id);const T=await this.D(N.assets.signature);await this.q.writeFile(Q,T.stream)}async getReadme(N,Q){if(N.assets.readme){const T=await this.D(N.assets.readme,{},Q);return await(0,f.$Po)(T)||""}return""}async getManifest(N,Q){if(N.assets.manifest){const T=await this.D(N.assets.manifest,{},Q),H=await(0,f.$Po)(T);return H?JSON.parse(H):null}return null}async C(N,Q){const T=K(N,a.Manifest);if(!T)throw new Error("Manifest was not found");const H={"Accept-Encoding":"gzip"},U=await this.D(T,{headers:H});return await(0,f.$Qo)(U)}async getCoreTranslation(N,Q){const T=N.assets.coreTranslations.filter(H=>H[0]===Q.toUpperCase())[0];if(T){const H=await this.D(T[1]),U=await(0,f.$Po)(H);return U?JSON.parse(U):null}return null}async getChangelog(N,Q){if(N.assets.changelog){const T=await this.D(N.assets.changelog,{},Q);return await(0,f.$Po)(T)||""}return""}async getAllCompatibleVersions(N,Q,T){let H=new k().withFlags(o.IncludeVersions,o.IncludeCategoryAndTags,o.IncludeFiles,o.IncludeVersionProperties).withPage(1,1);N.identifier.uuid?H=H.withFilter(n.ExtensionId,N.identifier.uuid):H=H.withFilter(n.ExtensionName,N.identifier.id);const{galleryExtensions:U}=await this.B(H,R.CancellationToken.None);if(!U.length)return[];const ie=J(U[0]);if((0,E.$Xn)(ie,T))return[];const z=[];await Promise.all(U[0].versions.map(async X=>{try{await this.y(X,Q?"any":"release",!0,ie,T)&&z.push(X)}catch{}}));const _=[],W=new Set;for(const X of q(z,T))W.has(X.version)||(W.add(X.version),_.push({version:X.version,date:X.lastUpdated,isPreReleaseVersion:x(X)}));return _}async D(N,Q={},T=R.CancellationToken.None){const H=await this.j,U={type:"GET"},ie={...H,...Q.headers||{}};Q={...Q,...U,headers:ie};const z=N.uri,_=N.fallbackUri,W={...Q,url:z};try{const X=await this.k.request(W,T);if(X.res.statusCode===200)return X;const oe=await(0,f.$Po)(X);throw new Error(`Expected 200, got back ${X.res.statusCode} instead.

${oe}`)}catch(X){if((0,r.$2)(X))throw X;const oe=(0,r.$8)(X);this.o.publicLog2("galleryService:cdnFallback",{url:z,message:oe});const ge={...Q,url:_};return this.k.request(ge,T)}}async E(N){let Q=ue(N);if(!Q){const T=await this.C(N,R.CancellationToken.None);if(!T)throw new Error("Manifest was not found");Q=T.engines.vscode}return Q}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const N=await this.k.request({type:"GET",url:this.h},R.CancellationToken.None);if(N.res.statusCode!==200)throw new Error("Could not get extensions report.");const Q=await(0,f.$Qo)(N),T=[],H={},U=[];if(Q){for(const ie of Q.malicious)T.push({id:ie});if(Q.migrateToPreRelease)for(const[ie,z]of Object.entries(Q.migrateToPreRelease))(!z.engine||(0,d.$Jo)(z.engine,this.u.version,this.u.date))&&(H[ie.toLowerCase()]={disallowInstall:!0,extension:{id:z.id,displayName:z.displayName,autoMigrate:{storage:!!z.migrateStorage},preRelease:!0}});if(Q.deprecated)for(const[ie,z]of Object.entries(Q.deprecated))z&&(H[ie.toLowerCase()]=(0,I.$Cf)(z)?{}:z);if(Q.search)for(const ie of Q.search)U.push(ie)}return{malicious:T,deprecated:H,search:U}}};re=Oe([Ae(1,f.$Ko),Ae(2,m.$6i),Ae(3,C.$Sh),Ae(4,p.$0k),Ae(5,g.$7j),Ae(6,l.$lj),Ae(7,b.$fi)],re);let B=class extends re{constructor(N,Q,T,H,U,ie,z,_){super(N,Q,T,H,U,ie,z,_)}};e.$7o=B,e.$7o=B=Oe([Ae(0,c.$Xo),Ae(1,f.$Ko),Ae(2,m.$6i),Ae(3,C.$Sh),Ae(4,p.$0k),Ae(5,g.$7j),Ae(6,l.$lj),Ae(7,b.$fi)],B);let ee=class extends re{constructor(N,Q,T,H,U,ie,z){super(void 0,N,Q,T,H,U,ie,z)}};e.$8o=ee,e.$8o=ee=Oe([Ae(0,f.$Ko),Ae(1,m.$6i),Ae(2,C.$Sh),Ae(3,p.$0k),Ae(4,g.$7j),Ae(5,l.$lj),Ae(6,b.$fi)],ee)}),define(we[258],pe([1,0,5,2,33,51]),function(le,e,y,R,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CN=e.$BN=void 0;class L{constructor(b,C){this.a=b,this.b=C}listen(b,C){const E=this.b(b);switch(C){case"onDidChangeProfiles":return y.Event.map(this.a.onDidChangeProfiles,v=>({all:v.all.map(d=>(0,P.$Fm)({...d},E)),added:v.added.map(d=>(0,P.$Fm)({...d},E)),removed:v.removed.map(d=>(0,P.$Fm)({...d},E)),updated:v.updated.map(d=>(0,P.$Fm)({...d},E))}))}throw new Error(`Invalid listen ${C}`)}async call(b,C,E){const v=this.b(b);switch(C){case"createProfile":{const d=await this.a.createProfile(E[0],E[1],E[2]);return(0,P.$Fm)({...d},v)}case"updateProfile":{let d=(0,r.$Gk)((0,P.$Gm)(E[0],v),this.a.profilesHome.scheme);return d=await this.a.updateProfile(d,E[1]),(0,P.$Fm)({...d},v)}case"removeProfile":{const d=(0,r.$Gk)((0,P.$Gm)(E[0],v),this.a.profilesHome.scheme);return this.a.removeProfile(d)}}throw new Error(`Invalid call ${C}`)}}e.$BN=L;class I extends R.$Qc{get defaultProfile(){return this.profiles[0]}get profiles(){return this.a}constructor(b,C,E){super(),this.profilesHome=C,this.f=E,this.a=[],this.b=this.B(new y.$Ld),this.onDidChangeProfiles=this.b.event,this.c=!0,this.a=b.map(v=>(0,r.$Gk)(v,this.profilesHome.scheme)),this.B(this.f.listen("onDidChangeProfiles")(v=>{const d=v.added.map(l=>(0,r.$Gk)(l,this.profilesHome.scheme)),g=v.removed.map(l=>(0,r.$Gk)(l,this.profilesHome.scheme)),m=v.updated.map(l=>(0,r.$Gk)(l,this.profilesHome.scheme));this.a=v.all.map(l=>(0,r.$Gk)(l,this.profilesHome.scheme)),this.b.fire({added:d,removed:g,updated:m,all:this.profiles})})),this.onDidResetWorkspaces=this.f.listen("onDidResetWorkspaces")}setEnablement(b){this.c=b}isEnabled(){return this.c}async createNamedProfile(b,C,E){const v=await this.f.call("createNamedProfile",[b,C,E]);return(0,r.$Gk)(v,this.profilesHome.scheme)}async createProfile(b,C,E,v){const d=await this.f.call("createProfile",[b,C,E,v]);return(0,r.$Gk)(d,this.profilesHome.scheme)}async createTransientProfile(b){const C=await this.f.call("createTransientProfile",[b]);return(0,r.$Gk)(C,this.profilesHome.scheme)}async setProfileForWorkspace(b,C){await this.f.call("setProfileForWorkspace",[b,C])}removeProfile(b){return this.f.call("removeProfile",[b])}async updateProfile(b,C){const E=await this.f.call("updateProfile",[b,C]);return(0,r.$Gk)(E,this.profilesHome.scheme)}resetWorkspaces(){return this.f.call("resetWorkspaces")}cleanUp(){return this.f.call("cleanUp")}cleanUpTransientProfiles(){return this.f.call("cleanUpTransientProfiles")}}e.$CN=I}),define(we[127],pe([1,0,4,25,16,13,234,34,33,8,235]),function(le,e,y,R,r,P,L,I,w,b,C){"use strict";var E,v;Object.defineProperty(e,"__esModule",{value:!0}),e.$tN=e.$sN=e.$rN=void 0;let d=E=class extends w.$Ik{constructor(f,u,c,p,h){super(c,p,u,h),this.U=f,this.W=c}O(){return this.U.getItem(E.b,[]).map(u=>({...u,location:(0,b.$wf)(u.location)?this.w.extUri.joinPath(this.profilesHome,u.location):y.URI.revive(u.location)}))}Q(){const f=this.U.getItem(E.c,{});return this.U.getItem(E.a,!1)?f:this.N(f)}S(){return this.w.extUri.joinPath(y.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$rN=d,d.a="profileAssociationsMigration",e.$rN=d=E=Oe([Ae(0,L.$mN),Ae(1,I.$Dk),Ae(2,R.$Th),Ae(3,r.$7j),Ae(4,P.$6i)],d);let g=v=class extends d{constructor(f,u,c,p,h){super(f,u,c,p,h),this.$=f}P(f){f.length?this.$.setItem(v.b,f.map(u=>({...u,location:this.w.extUri.basename(u.location)}))):this.$.removeItem(v.b)}O(){const f=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P(f),this.$.setItem("userDataProfilesMigration",!0)),f}R(f){f.emptyWindows||f.workspaces?this.$.setItem(v.c,f):this.$.removeItem(v.c)}Q(){const f="workspaceAndProfileInfo",u=this.$.getItem(f,void 0);if(u){this.$.removeItem(f);const p=u.reduce((h,{workspace:t,profile:s})=>(h[y.URI.revive(t).toString()]=y.URI.revive(s).toString(),h),{});this.$.setItem(v.c,{workspaces:p})}const c=super.Q();return this.$.getItem(v.a,!1)||(this.R(c),this.$.setItem(v.a,!0)),c}};e.$sN=g,e.$sN=g=v=Oe([Ae(0,L.$nN),Ae(1,I.$Dk),Ae(2,R.$Th),Ae(3,r.$7j),Ae(4,P.$6i)],g);let m=class extends g{constructor(f,u,c,p){super(new C.$qN(0,u,p,c),f,u,c,p)}async init(){return await this.$.init(),super.init()}};e.$tN=m,e.$tN=m=Oe([Ae(0,I.$Dk),Ae(1,R.$Th),Ae(2,r.$7j),Ae(3,P.$6i)],m)}),define(we[128],pe([1,0,6]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$om=e.$nm=void 0,e.$nm=(0,y.$Lh)("extensionHostStatusService");class R{constructor(){this.a=new Map}setExitInfo(P,L){this.a.set(P,L)}getExitInfo(P){return this.a.get(P)||null}}e.$om=R}),define(we[259],pe([1,0,5,14]),function(le,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wm=void 0;function r(L){let I=0,w=0,b=0;L>=1e3&&(b=Math.floor(L/1e3),L-=b*1e3),b>=60&&(w=Math.floor(b/60),b-=w*60),w>=60&&(I=Math.floor(w/60),w-=I*60);const C=I?`${I}h`:"",E=w?`${w}m`:"",v=b?`${b}s`:"",d=L?`${L}ms`:"";return`${C}${E}${v}${d}`}class P{constructor(I,w,b,C){this.i=I,this.j=w,this.a=new y.$Ld,this.onClose=this.a.event,this.b=108e5,this.c=3e5,this.d=b,this.protocol=C,this.e=!1,this.f=new R.$4g(()=>{this.k(`The reconnection grace time of ${r(this.b)} has expired, so the connection will be disposed.`),this.l()},this.b),this.g=new R.$4g(()=>{this.k(`The reconnection short grace time of ${r(this.c)} has expired, so the connection will be disposed.`),this.l()},this.c),this.protocol.onDidDispose(()=>{this.k("The client has disconnected gracefully, so the connection will be disposed."),this.l()}),this.protocol.onSocketClose(()=>{this.k(`The client has disconnected, will wait for reconnection ${r(this.b)} before disposing...`),this.f.schedule()}),this.k("New connection established.")}k(I){this.i.info(`[${this.d}][${this.j.substr(0,8)}][ManagementConnection] ${I}`)}shortenReconnectionGraceTimeIfNecessary(){this.g.isScheduled()||this.f.isScheduled()&&(this.k(`Another client has connected, will shorten the wait for reconnection ${r(this.c)} before disposing...`),this.g.schedule())}l(){if(this.e)return;this.e=!0,this.f.dispose(),this.g.dispose();const I=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),I.end(),this.a.fire(void 0)}acceptReconnection(I,w,b){this.d=I,this.k("The client has reconnected."),this.f.cancel(),this.g.cancel(),this.protocol.beginAcceptReconnection(w,b),this.protocol.endAcceptReconnection()}}e.$wm=P}),define(we[90],pe([1,0,29,12,7,154,54]),function(le,e,y,R,r,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$il=e.InternalNLSConfiguration=e.$hl=void 0;const I=r.$hc(R.$_f.asFileUri("").fsPath,"nls.metadata.json"),w=new Map;function b(g){return new Promise(m=>y.exists(g,m))}function C(g,m){return b(I).then(l=>{if(!l||!L.default.commit)return Promise.resolve({locale:"en",osLocale:"en",availableLanguages:{}});const f=`${g}||${m}`;let u=w.get(f);return u||(u=P.getNLSConfiguration(L.default.commit,m,I,g,g).then(c=>(E.is(c)&&(c._languagePackSupport=!0),c.locale!=="en"&&c.locale!=="en-us"&&Object.keys(c.availableLanguages).length===0&&w.delete(f),c)),w.set(f,u)),u})}e.$hl=C;var E;(function(g){function m(l){const f=l;return f&&typeof f._languagePackId=="string"}g.is=m})(E||(e.InternalNLSConfiguration=E={}));const v=async g=>{try{const m=d(await y.promises.readFile(g,"utf8"));return JSON.parse(m).locale}catch(m){return m.code!=="ENOENT"&&console.warn(m),"en"}};e.$il=v;const d=g=>{const m=/('(?:[^\\']*(?:\\.)?)*')|('(?:[^\\']*(?:\\.)?)*')|(\/\*(?:\r?\n|.)*?\*\/)|(\/{2,}.*?(?:(?:\r?\n)|$))/g;return g.replace(m,(l,f,u,c,p)=>{if(c)return"";if(p){const h=p.length;return h>2&&p[h-1]===`
`?p[h-2]==="\r"?`\r
`:`
`:""}else return l})}}),define(we[129],pe([1,0,19,4,25,45,57,16,6,13,31,34,33,90]),function(le,e,y,R,r,P,L,I,w,b,C,E,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gN=void 0;let g=class extends L.$rp{constructor(l,f,u,c,p,h,t,s){super(R.URI.file(p.builtinExtensionsPath),R.URI.file(p.extensionsPath),(0,y.$sg)(p.userHome,".vscode-oss-dev","extensions","control.json"),l.defaultProfile,l,f,u,c,p,h,t,s),this.R=p}async f(l){const f=await(0,d.$hl)(l,this.R.userDataPath);if(d.InternalNLSConfiguration.is(f))try{const u=await this.w.readFile(R.URI.file(f._translationsConfigFile));return JSON.parse(u.value.toString())}catch{}return Object.create(null)}};e.$gN=g,e.$gN=g=Oe([Ae(0,v.$Fk),Ae(1,P.$mp),Ae(2,I.$7j),Ae(3,b.$6i),Ae(4,r.$Th),Ae(5,C.$lj),Ae(6,E.$Dk),Ae(7,w.$Kh)],g)}),define(we[260],pe([1,0,261,29,7,23,12,21]),function(le,e,y,R,r,P,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cm=e.$Bm=e.$Am=e.$zm=e.$ym=e.$xm=e.ServerConnectionTokenType=void 0;const w=/^[0-9A-Za-z_-]+$/;var b;(function(l){l[l.None=0]="None",l[l.Optional=1]="Optional",l[l.Mandatory=2]="Mandatory"})(b||(e.ServerConnectionTokenType=b={}));class C{constructor(){this.type=0}validate(f){return!0}}e.$xm=C;class E{constructor(f){this.value=f,this.type=2}validate(f){return f===this.value}}e.$ym=E;class v{constructor(f){this.message=f}}e.$zm=v;async function d(l,f){const u=l["without-connection-token"],c=l["connection-token"],p=l["connection-token-file"];if(u)return typeof c<"u"||typeof p<"u"?new v("Please do not use the argument '--connection-token' or '--connection-token-file' at the same time as '--without-connection-token'."):new C;if(typeof p<"u"){if(typeof c<"u")return new v("Please do not use the argument '--connection-token' at the same time as '--connection-token-file'.");let h;try{h=R.readFileSync(p).toString().replace(/\r?\n$/,"")}catch{return new v(`Unable to read the connection token file at '${p}'.`)}return w.test(h)?new E(h):new v(`The connection token defined in '${p} does not adhere to the characters 0-9, a-z, A-Z, _, or -.`)}return typeof c<"u"?w.test(c)?new E(c):new v(`The connection token '${c} does not adhere to the characters 0-9, a-z, A-Z or -.`):new E(await f())}e.$Am=d;async function g(l){return d(l,async()=>{if(!l["user-data-dir"])return(0,P.$bg)();const u=r.$hc(l["user-data-dir"],"token");try{const h=(await I.Promises.readFile(u)).toString().replace(/\r?\n$/,"");if(w.test(h))return h}catch{}const c=(0,P.$bg)();try{await I.Promises.writeFile(u,c,{mode:384})}catch{}return c})}e.$Bm=g;function m(l,f,u){if(l.validate(u.query[L.$6f]))return!0;const c=y.parse(f.headers.cookie||"");return l.validate(c[L.$5f])}e.$Cm=m}),define(we[46],pe([1,0,199,109,64,6,25,73]),function(le,e,y,R,r,P,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gm=e.$fm=e.$em=void 0,e.$em={"disable-update-check":{type:"boolean"},auth:{type:"string"},"disable-file-downloads":{type:"boolean"},locale:{type:"string"},"disable-getting-started-override":{type:"boolean"},host:{type:"string",cat:"o",args:"ip-address",description:y.localize(0,null)},port:{type:"string",cat:"o",args:"port | port range",description:y.localize(1,null)},"socket-path":{type:"string",cat:"o",args:"path",description:y.localize(2,null)},"connection-token":{type:"string",cat:"o",args:"token",deprecates:["connectionToken"],description:y.localize(3,null)},"connection-token-file":{type:"string",cat:"o",args:"path",deprecates:["connection-secret","connectionTokenFile"],description:y.localize(4,null)},"without-connection-token":{type:"boolean",cat:"o",description:y.localize(5,null)},"disable-websocket-compression":{type:"boolean"},"print-startup-performance":{type:"boolean"},"print-ip-address":{type:"boolean"},"accept-server-license-terms":{type:"boolean",cat:"o",description:y.localize(6,null)},"server-data-dir":{type:"string",cat:"o",description:y.localize(7,null)},"telemetry-level":{type:"string",cat:"o",args:"level",description:y.localize(8,null)},"user-data-dir":r.$Al["user-data-dir"],"enable-smoke-test-driver":r.$Al["enable-smoke-test-driver"],"disable-telemetry":r.$Al["disable-telemetry"],"disable-workspace-trust":r.$Al["disable-workspace-trust"],"file-watcher-polling":{type:"string",deprecates:["fileWatcherPolling"]},log:r.$Al.log,logsPath:r.$Al.logsPath,"force-disable-user-env":r.$Al["force-disable-user-env"],folder:{type:"string",deprecationMessage:"No longer supported. Folder needs to be provided in the browser URL or with `default-folder`."},workspace:{type:"string",deprecationMessage:"No longer supported. Workspace needs to be provided in the browser URL or with `default-workspace`."},"default-folder":{type:"string",description:y.localize(9,null)},"default-workspace":{type:"string",description:y.localize(10,null)},"enable-sync":{type:"boolean"},"github-auth":{type:"string"},"use-test-resolver":{type:"boolean"},"extensions-dir":r.$Al["extensions-dir"],"extensions-download-dir":r.$Al["extensions-download-dir"],"builtin-extensions-dir":r.$Al["builtin-extensions-dir"],"install-extension":r.$Al["install-extension"],"install-builtin-extension":r.$Al["install-builtin-extension"],"uninstall-extension":r.$Al["uninstall-extension"],"list-extensions":r.$Al["list-extensions"],"locate-extension":r.$Al["locate-extension"],"show-versions":r.$Al["show-versions"],category:r.$Al.category,force:r.$Al.force,"do-not-sync":r.$Al["do-not-sync"],"pre-release":r.$Al["pre-release"],"start-server":{type:"boolean",cat:"e",description:y.localize(11,null)},"enable-remote-auto-shutdown":{type:"boolean"},"remote-auto-shutdown-without-delay":{type:"boolean"},"use-host-proxy":{type:"boolean"},"without-browser-env-var":{type:"boolean"},help:r.$Al.help,version:r.$Al.version,"locate-shell-integration-path":r.$Al["locate-shell-integration-path"],compatibility:{type:"string"},_:r.$Al._},e.$fm=(0,P.$Mh)(L.$Sh);class w extends R.$bm{get userRoamingDataHome(){return this.appSettingsHome}get args(){return super.args}}e.$gm=w,Oe([I.$dh],w.prototype,"userRoamingDataHome",null)}),define(we[262],pe([1,0,300,245,263,27]),function(le,e,y,R,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hN=void 0;class L extends y.AppInsightsCore{constructor(w){super(),this.a=w}track(w){const b=w.baseData||{};b.properties||(b.properties={}),b.measurements||(b.measurements={});try{const C=P.cpus();b.measurements.cores=C.length,b.properties["common.cpuModel"]=C[0].model}catch{}try{b.measurements.memoryFree=P.freemem(),b.measurements.memoryTotal=P.totalmem()}catch{}try{b.properties["common.shell"]=P.userInfo().shell,b.properties["common.release"]=P.release(),b.properties["common.arch"]=P.arch()}catch{}try{const C=(/^http:/.test(this.a)?r:R).request(this.a,{method:"POST",headers:{"Content-Type":"application/json"}});C.on("error",()=>{}),C.write(JSON.stringify(b)),C.end()}catch{}}}e.$hN=L}),define(we[264],pe([1,0,29,21,77,84,261,86,38,58,3,13,46,7,12,23,31,44,20,4,15,8,90,56]),function(le,e,y,R,r,P,L,I,w,b,C,E,v,d,g,m,l,f,u,c,p,h,t,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MN=e.$LN=e.$KN=e.$JN=e.$IN=e.$HN=e.CacheControl=e.$GN=void 0;const o={".html":"text/html",".js":"text/javascript",".json":"application/json",".css":"text/css",".svg":"image/svg+xml"};async function i(Z,ae,K,se){ae.writeHead(K,{"Content-Type":"text/plain"}),ae.end(se)}e.$GN=i;var n;(function(Z){Z[Z.NO_CACHING=0]="NO_CACHING",Z[Z.ETAG=1]="ETAG",Z[Z.NO_EXPIRY=2]="NO_EXPIRY"})(n||(e.CacheControl=n={}));async function a(Z,ae,K,se,ue,x){try{const he=await R.Promises.stat(Z);if(ae===1){const V=`W/"${[he.ino,he.size,he.mtime.getTime()].join("-")}"`;if(se.headers["if-none-match"]===V)return ue.writeHead(304),void ue.end();x.Etag=V}else ae===2?x["Cache-Control"]="public, max-age=31536000":ae===0&&(x["Cache-Control"]="no-store");x["Content-Type"]=o[(0,d.$mc)(Z)]||(0,b.$Lr)(Z)||"text/plain",ue.writeHead(200,x),(0,y.createReadStream)(Z).pipe(ue)}catch(he){return he.code!=="ENOENT"?(K.error(he),console.error(he.toString())):console.error(`File not found: ${Z}`),ue.writeHead(404,{"Content-Type":"text/plain"}),void ue.end("Not found")}}e.$HN=a;const $=(0,d.$kc)(g.$_f.asFileUri("").fsPath);let S=class{constructor(ae,K,se,ue,x){this.f=ae,this.g=K,this.h=se,this.i=ue,this.j=x,this.a=this.j.extensionsGallery?.resourceUrlTemplate?c.URI.parse(this.j.extensionsGallery.resourceUrlTemplate):void 0;const he=(0,s.$Rk)(x);this.b=`${he}/static`,this.c=`${he}/callback`,this.d="/web-extension-resource"}async handle(ae,K,se){try{const ue=se.pathname;return ue.startsWith(this.b)&&ue.charCodeAt(this.b.length)===47?this.k(ae,K,se):ue==="/"?this.n(ae,K,se):ue===this.c?this.p(K):ue.startsWith(this.d)&&ue.charCodeAt(this.d.length)===47?this.m(ae,K,se):i(ae,K,404,"Not found.")}catch(ue){return this.h.error(ue),console.error(ue.toString()),i(ae,K,500,"Internal Server Error.")}}async k(ae,K,se){const ue=Object.create(null),he=decodeURIComponent(se.pathname).substring(this.b.length+1),V=(0,d.$hc)($,he);return(0,w.$Vf)(V,$,!C.$f)?a(V,this.g.isBuilt?2:1,this.h,ae,K,ue):i(ae,K,400,"Bad request.")}l(ae){const K=ae.authority.indexOf(".");return K!==-1?ae.authority.substring(K+1):void 0}async m(ae,K,se){if(!this.a)return i(ae,K,500,"No extension gallery service configured.");const ue=decodeURIComponent(se.pathname),x=(0,d.$fc)(ue.substring(this.d.length+1)),he=c.URI.parse(x).with({scheme:this.a.scheme,authority:x.substring(0,x.indexOf("/")),path:x.substring(x.indexOf("/")+1)});if(this.l(this.a)!==this.l(he))return i(ae,K,403,"Request Forbidden");const V={},te=re=>{const B=ae.headers[re];B&&((0,h.$wf)(B)||B[0])?V[re]=(0,h.$wf)(B)?B:B[0]:re!==re.toLowerCase()&&te(re.toLowerCase())};te("X-Client-Name"),te("X-Client-Version"),te("X-Machine-Id"),te("X-Client-Commit");const G=await this.i.request({type:"GET",url:he.toString(!0),headers:V},u.CancellationToken.None),J=G.res.statusCode||500;if(J!==200){let re=null;try{re=await(0,f.$Po)(G)}catch{}return i(ae,K,J,re||`Request failed with status ${J}`)}const q=Object.create(null),ne=re=>{const B=G.res.headers[re];B?q[re]=B:re!==re.toLowerCase()&&ne(re.toLowerCase())};ne("Cache-Control"),ne("Content-Type"),K.writeHead(200,q);const me=await(0,p.$le)(G.stream);return void K.end(me.buffer)}async n(ae,K,se){const ue=se.query[g.$6f];if(typeof ue=="string"){const ie=Object.create(null);ie["Set-Cookie"]=L.serialize(g.$5f,ue,{sameSite:"lax",maxAge:60*60*24*7});const z=Object.create(null);for(const W in se.query)W!==g.$6f&&(z[W]=se.query[W]);const _=P.format({pathname:"/",query:z});return ie.Location=_,K.writeHead(302,ie),void K.end()}const x=!this.g.isBuilt&&this.g.args["use-test-resolver"],he=x?"test+test":"remote";if(!he)return i(ae,K,400,"Bad request.");function V(ie){return JSON.stringify(ie).replace(/"/g,"&quot;")}let te;this.g.args["enable-smoke-test-driver"]&&(te=!1);const G=ie=>ie&&c.URI.file(r.resolve(ie)).with({scheme:g.Schemas.vscodeRemote,authority:he}),J=g.$_f.asFileUri(this.g.isBuilt?"vs/code/browser/workbench/workbench.html":"vs/code/browser/workbench/workbench-dev.html").fsPath,q=!this.g.isBuilt&&this.g.args["github-auth"]?{id:(0,m.$bg)(),providerId:"github",accessToken:this.g.args["github-auth"],scopes:[["user:email"],["repo"]]}:void 0,ne=(0,e.$KN)((0,e.$MN)(ae)),me=(0,e.$LN)((0,e.$MN)(ae)),re={codeServerVersion:this.j.codeServerVersion,rootEndpoint:ne,updateEndpoint:this.g.args["disable-update-check"]?void 0:ne+"/update/check",logoutEndpoint:this.g.args.auth&&this.g.args.auth!=="none"?ne+"/logout":void 0,proxyEndpointTemplate:process.env.VSCODE_PROXY_URI??ne+"/proxy/{{port}}/",serviceWorker:{scope:me+"/",path:ne+"/_static/out/browser/serviceWorker.js"},enableTelemetry:this.j.enableTelemetry,embedderIdentifier:"server-distro",extensionsGallery:this.j.extensionsGallery};if(!this.g.isBuilt)try{const ie=JSON.parse((await R.Promises.readFile((0,d.$hc)($,"product.overrides.json"))).toString());Object.assign(re,ie)}catch{}const B={remoteAuthority:he,webviewEndpoint:me+this.b+"/out/vs/workbench/contrib/webview/browser/pre",userDataPath:this.g.userDataPath,isEnabledFileDownloads:!this.g.args["disable-file-downloads"],isEnabledCoderGettingStarted:!this.g.args["disable-getting-started-override"],_wrapWebWorkerExtHostInIframe:te,developmentOptions:{enableSmokeTestDriver:this.g.args["enable-smoke-test-driver"]?!0:void 0,logLevel:this.h.getLevel()},settingsSyncOptions:!this.g.isBuilt&&this.g.args["enable-sync"]?{enabled:!0}:void 0,enableWorkspaceTrust:!this.g.args["disable-workspace-trust"],folderUri:G(this.g.args["default-folder"]),workspaceUri:G(this.g.args["default-workspace"]),productConfiguration:re,callbackRoute:this.c},ee=this.g.args.locale||await(0,t.$il)(this.g.argvResource.fsPath),O=await(0,t.$hl)(ee,this.g.userDataPath),N=this.j.extensionsGallery?.nlsBaseUrl,Q={WORKBENCH_WEB_CONFIGURATION:V(B),WORKBENCH_AUTH_SESSION:q?V(q):"",WORKBENCH_WEB_BASE_URL:me+this.b,WORKBENCH_NLS_BASE_URL:me+(N?`${N}${N.endsWith("/")?"":"/"}${this.j.commit}/${this.j.version}/`:""),BASE:ne,VS_BASE:me,NLS_CONFIGURATION:V(O)};if(x){const ie=[];for(const z of["vscode-test-resolver","github-authentication"]){const _=JSON.parse((await R.Promises.readFile(g.$_f.asFileUri(`${g.$8f}/${z}/package.json`).fsPath)).toString());ie.push({extensionPath:z,packageJSON:_})}Q.WORKBENCH_BUILTIN_EXTENSIONS=V(ie)}let T;try{T=(await R.Promises.readFile(J)).toString().replace(/\{\{([^}]+)\}\}/g,(z,_)=>Q[_]??"undefined")}catch{return K.writeHead(404,{"Content-Type":"text/plain"}),void K.end("Not found")}const U={"Content-Type":"text/html","Content-Security-Policy":["default-src 'self';","img-src 'self' https: data: blob:;","media-src 'self';",`script-src 'self' 'unsafe-eval' ${this.o(T).join(" ")} 'sha256-fh3TwPMflhsEIpR8g1OYTIMVWhXTLcjQ9kh2tIpmv54=' ;`,"child-src 'self';","frame-src 'self' https://*.vscode-cdn.net data:;","worker-src 'self' data: blob:;","style-src 'self' 'unsafe-inline';","connect-src 'self' ws: wss: https:;","font-src 'self' blob:;","manifest-src 'self';"].join(" ")};return this.f.type!==0&&(U["Set-Cookie"]=L.serialize(g.$5f,this.f.value,{sameSite:"lax",maxAge:60*60*24*7})),K.writeHead(200,U),void K.end(T)}o(ae){const K=/<script>([\s\S]+?)<\/script>/img,se=[];let ue;for(;ue=K.exec(ae);){const x=I.createHash("sha256"),he=ue[1].replace(/\r\n/g,`
`),V=x.update(Buffer.from(he)).digest().toString("base64");se.push(`'sha256-${V}'`)}return se}async p(ae){const K=g.$_f.asFileUri("vs/code/browser/workbench/callback.html").fsPath,se=(await R.Promises.readFile(K)).toString(),ue=["default-src 'self';","img-src 'self' https: data: blob:;","media-src 'none';",`script-src 'self' ${this.o(se).join(" ")};`,"style-src 'self' 'unsafe-inline';","font-src 'self' blob:;"].join(" ");return ae.writeHead(200,{"Content-Type":"text/html","Content-Security-Policy":ue}),void ae.end(se)}};e.$IN=S,e.$IN=S=Oe([Ae(1,v.$fm),Ae(2,E.$6i),Ae(3,f.$Ko),Ae(4,l.$lj)],S);const D=(Z,ae=!1)=>Z.replace(/\/\/+/g,"/").replace(/\/+$/,ae?"/":"");e.$JN=D;const k=Z=>{const ae=(Z.split("?",1)[0].match(/\//g)||[]).length;return(0,e.$JN)("./"+(ae>1?"../".repeat(ae-1):""))};e.$KN=k;const A=Z=>{const ae=Z.split("?",1)[0].split("/");return(0,e.$JN)("./"+ae[ae.length-1])};e.$LN=A;const j=Z=>Z.originalUrl||Z.url;e.$MN=j}),define(we[265],pe([1,0,6]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nM=void 0,e.$nM=(0,y.$Lh)("IExtHostInitDataService")}),define(we[266],pe([1,0,6]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$L=e.$0L=void 0,e.$0L=(0,y.$Lh)("IExtHostRpcService");class R{constructor(P){this.getProxy=P.getProxy.bind(P),this.set=P.set.bind(P),this.dispose=P.dispose.bind(P),this.assertRegistered=P.assertRegistered.bind(P),this.drain=P.drain.bind(P)}}e.$$L=R}),define(we[70],pe([1,0,51]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sr=void 0;function R(P){return{transformIncoming:L=>L.scheme==="vscode-remote"?{scheme:"file",path:L.path,query:L.query,fragment:L.fragment}:L.scheme==="file"?{scheme:"vscode-local",path:L.path,query:L.query,fragment:L.fragment}:L,transformOutgoing:L=>L.scheme==="file"?{scheme:"vscode-remote",authority:P,path:L.path,query:L.query,fragment:L.fragment}:L.scheme==="vscode-local"?{scheme:"file",path:L.path,query:L.query,fragment:L.fragment}:L,transformOutgoingScheme:L=>L==="file"?"vscode-remote":L==="vscode-local"?"file":L}}function r(P){return new y.$Dm(R(P))}e.$sr=r}),define(we[267],pe([1,0,3,41,4,70,51,104,238,7,19]),function(le,e,y,R,r,P,L,I,w,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zr=void 0;class E{constructor(d,g,m,l){this.b=d,this.c=g,this.d=m,this.e=l}async call(d,g,m){switch(g){case"getEnvironmentData":{const l=m,f=(0,P.$sr)(l.remoteAuthority);let u=await this.f(l.profile);return u=(0,L.$Fm)(u,f),u}case"getExtensionHostExitInfo":{const l=m;return this.e.getExitInfo(l.reconnectionToken)}case"getDiagnosticInfo":{const l=m,f={machineInfo:(0,w.$wr)()},u=l.includeProcesses?(0,I.$ur)(process.pid):Promise.resolve();let c=[];const p={};if(l.folders){const h=(0,P.$sr)("");c=l.folders.map(s=>r.URI.revive(h.transformIncoming(s))).filter(s=>s.scheme==="file").map(s=>(0,w.$vr)(s.fsPath,["node_modules",".git"]).then(o=>{p[(0,b.$lc)(s.fsPath)]=o}))}return Promise.all([u,...c]).then(([h,t])=>(f.processes=h||void 0,f.workspaceMetadata=l.folders?p:void 0,f))}}throw new Error(`IPC Command ${g} not found`)}listen(d,g,m){throw new Error("Not supported")}async f(d){return d&&!this.d.profiles.some(g=>g.id===d)&&await this.d.createProfile(d,d),{pid:process.pid,connectionToken:this.b.type!==0?this.b.value:"",appRoot:r.URI.file(this.c.appRoot),settingsPath:this.c.machineSettingsResource,logsPath:this.c.logsHome,extensionHostLogsPath:(0,C.$sg)(this.c.logsHome,`exthost${E.a++}`),globalStorageHome:this.d.defaultProfile.globalStorageHome,workspaceStorageHome:this.c.workspaceStorageHome,localHistoryHome:this.c.localHistoryHome,userHome:this.c.userHome,os:y.OS,arch:process.arch,marks:R.getMarks(),useHostProxy:!!this.c.args["use-host-proxy"],profiles:{home:this.d.profilesHome,all:[...this.d.profiles].map(g=>({...g}))}}}}e.$zr=E,E.a=1}),define(we[268],pe([1,0,4,70,68,7,224]),function(le,e,y,R,r,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cr=void 0;class I extends L.$Ar{constructor(C,E){super(new r.$5p(C),C),this.N=E,this.M=new Map,this.B(this.a)}c(C){let E=this.M.get(C.remoteAuthority);return E||(E=(0,R.$sr)(C.remoteAuthority),this.M.set(C.remoteAuthority,E)),E}f(C,E,v=!1){if(v&&E.path==="/vscode-resource"&&E.query){const d=JSON.parse(E.query).requestResourcePath;return y.URI.from({scheme:"file",path:d})}return y.URI.revive(C.transformIncoming(E))}L(C,E){return new w(C,E,this.b,this.N)}}e.$Cr=I;class w extends L.$Br{constructor(C,E,v,d){super(C,E,v,d)}j(C){const E=C.args["file-watcher-polling"];if(E){const v=E.split(P.$rc),d=Number(v[0]);if(d>0)return{usePolling:v.length>1?v.slice(1):!0,pollingInterval:d}}}m(C){if(C.extensionsPath)return[P.$ec.join(C.extensionsPath,"**")]}}}),define(we[91],pe([1,0,202,8,4,2,6,35,16,12,39,163,62]),function(le,e,y,R,r,P,L,I,w,b,C,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$D=e.$0D=e.$9D=e.EditorsOrder=e.$8D=e.CloseDirection=e.$7D=e.$6D=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$5D=e.$4D=e.$3D=e.$2D=e.$1D=e.$ZD=e.$YD=e.$XD=e.EditorInputCapabilities=e.$WD=e.SaveReason=e.Verbosity=e.$VD=e.$UD=e.$TD=e.$SD=e.$RD=e.$QD=e.$PD=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$OD=e.$ND=e.$MD=e.$LD=e.$KD=void 0,e.$KD={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$LD={id:"default",displayName:(0,y.localize)(0,null),providerDisplayName:(0,y.localize)(1,null)},e.$MD="workbench.editor.sidebysideEditor",e.$ND="workbench.editors.textDiffEditor",e.$OD="workbench.editors.binaryResourceDiffEditor";var d;(function(re){re[re.PROGRAMMATIC=1]="PROGRAMMATIC",re[re.USER=2]="USER",re[re.EDIT=3]="EDIT",re[re.NAVIGATION=4]="NAVIGATION",re[re.JUMP=5]="JUMP"})(d||(e.EditorPaneSelectionChangeReason=d={}));var g;(function(re){re[re.IDENTICAL=1]="IDENTICAL",re[re.SIMILAR=2]="SIMILAR",re[re.DIFFERENT=3]="DIFFERENT"})(g||(e.EditorPaneSelectionCompareResult=g={}));function m(re){const B=re;return!!B&&typeof B.getSelection=="function"&&!!B.onDidChangeSelection}e.$PD=m;function l(re,B,ee){for(const O of ee.visibleEditorPanes)if(O.group.id===B&&re.matches(O.input))return O.getViewState()}e.$QD=l;function f(re){if(a(re))return!1;const B=re;return r.URI.isUri(B?.resource)}e.$RD=f;function u(re){if(a(re))return!1;const B=re;return B?.original!==void 0&&B.modified!==void 0}e.$SD=u;function c(re){if(a(re)||u(re))return!1;const B=re;return B?.primary!==void 0&&B.secondary!==void 0}e.$TD=c;function p(re){if(a(re))return!1;const B=re;return B?B.resource===void 0||B.resource.scheme===b.Schemas.untitled||B.forceUntitled===!0:!1}e.$UD=p;function h(re){if(a(re))return!1;const B=re;return r.URI.isUri(B?.base?.resource)&&r.URI.isUri(B?.input1?.resource)&&r.URI.isUri(B?.input2?.resource)&&r.URI.isUri(B?.result?.resource)}e.$VD=h;var t;(function(re){re[re.SHORT=0]="SHORT",re[re.MEDIUM=1]="MEDIUM",re[re.LONG=2]="LONG"})(t||(e.Verbosity=t={}));var s;(function(re){re[re.EXPLICIT=1]="EXPLICIT",re[re.AUTO=2]="AUTO",re[re.FOCUS_CHANGE=3]="FOCUS_CHANGE",re[re.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(s||(e.SaveReason=s={}));class o{constructor(){this.a=new Map}registerSource(B,ee){let O=this.a.get(B);return O||(O={source:B,label:ee},this.a.set(B,O)),O.source}getSourceLabel(B){return this.a.get(B)?.label??B}}e.$WD=new o;var i;(function(re){re[re.None=0]="None",re[re.Readonly=2]="Readonly",re[re.Untitled=4]="Untitled",re[re.Singleton=8]="Singleton",re[re.RequiresTrust=16]="RequiresTrust",re[re.CanSplitInGroup=32]="CanSplitInGroup",re[re.ForceDescription=64]="ForceDescription",re[re.CanDropIntoEditor=128]="CanDropIntoEditor",re[re.MultipleEditors=256]="MultipleEditors",re[re.Scratchpad=512]="Scratchpad"})(i||(e.EditorInputCapabilities=i={}));class n extends P.$Qc{}e.$XD=n;function a(re){return re instanceof n}e.$YD=a;function $(re){const B=re;return r.URI.isUri(B?.preferredResource)}function S(re){const B=re;return a(B?.primary)&&a(B?.secondary)}e.$ZD=S;function D(re){const B=re;return a(B?.modified)&&a(B?.original)}e.$1D=D;function k(re,B,ee,O,N){return me(O,[(0,E.$vi)({id:"workbench.action.openLargeFile",label:(0,y.localize)(2,null),run:()=>{const Q={...ee,limits:{size:Number.MAX_VALUE}};re.openEditor(B,Q)}}),(0,E.$vi)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,y.localize)(3,null),run:()=>N.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:v.default.Warning})}e.$2D=k;function A(re){return a(re?.editor)}e.$3D=A;function j(re){const B=re;return A(re)&&B?.group!==void 0}e.$4D=j;function Z(re){const B=re;return typeof B?.groupId=="number"&&a(B.editor)}e.$5D=Z;var ae;(function(re){re[re.UNKNOWN=0]="UNKNOWN",re[re.REPLACE=1]="REPLACE",re[re.MOVE=2]="MOVE",re[re.UNPIN=3]="UNPIN"})(ae||(e.EditorCloseContext=ae={}));var K;(function(re){re[re.GROUP_ACTIVE=0]="GROUP_ACTIVE",re[re.GROUP_INDEX=1]="GROUP_INDEX",re[re.GROUP_LOCKED=2]="GROUP_LOCKED",re[re.EDITOR_OPEN=3]="EDITOR_OPEN",re[re.EDITOR_CLOSE=4]="EDITOR_CLOSE",re[re.EDITOR_MOVE=5]="EDITOR_MOVE",re[re.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",re[re.EDITOR_LABEL=7]="EDITOR_LABEL",re[re.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",re[re.EDITOR_PIN=9]="EDITOR_PIN",re[re.EDITOR_STICKY=10]="EDITOR_STICKY",re[re.EDITOR_DIRTY=11]="EDITOR_DIRTY",re[re.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(K||(e.GroupModelChangeKind=K={}));var se;(function(re){re[re.PRIMARY=1]="PRIMARY",re[re.SECONDARY=2]="SECONDARY",re[re.BOTH=3]="BOTH",re[re.ANY=4]="ANY"})(se||(e.SideBySideEditor=se={}));class ue{getOriginalUri(B,ee){if(!B)return;if(h(B))return e.$7D.getOriginalUri(B.result,ee);if(ee?.supportSideBySide){const{primary:N,secondary:Q}=this.a(B);if(N&&Q){if(ee?.supportSideBySide===se.BOTH)return{primary:this.getOriginalUri(N,{filterByScheme:ee.filterByScheme}),secondary:this.getOriginalUri(Q,{filterByScheme:ee.filterByScheme})};if(ee?.supportSideBySide===se.ANY)return this.getOriginalUri(N,{filterByScheme:ee.filterByScheme})??this.getOriginalUri(Q,{filterByScheme:ee.filterByScheme});B=ee.supportSideBySide===se.PRIMARY?N:Q}}if(u(B)||c(B)||h(B))return;const O=$(B)?B.preferredResource:B.resource;return!O||!ee||!ee.filterByScheme?O:this.b(O,ee.filterByScheme)}a(B){return S(B)||c(B)?{primary:B.primary,secondary:B.secondary}:D(B)||u(B)?{primary:B.modified,secondary:B.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(B,ee){if(!B)return;if(h(B))return e.$7D.getCanonicalUri(B.result,ee);if(ee?.supportSideBySide){const{primary:N,secondary:Q}=this.a(B);if(N&&Q){if(ee?.supportSideBySide===se.BOTH)return{primary:this.getCanonicalUri(N,{filterByScheme:ee.filterByScheme}),secondary:this.getCanonicalUri(Q,{filterByScheme:ee.filterByScheme})};if(ee?.supportSideBySide===se.ANY)return this.getCanonicalUri(N,{filterByScheme:ee.filterByScheme})??this.getCanonicalUri(Q,{filterByScheme:ee.filterByScheme});B=ee.supportSideBySide===se.PRIMARY?N:Q}}if(u(B)||c(B)||h(B))return;const O=B.resource;return!O||!ee||!ee.filterByScheme?O:this.b(O,ee.filterByScheme)}b(B,ee){if(Array.isArray(ee)){if(ee.some(O=>B.scheme===O))return B}else if(ee===B.scheme)return B}}var x;(function(re){re[re.UNKNOWN=0]="UNKNOWN",re[re.KEYBOARD=1]="KEYBOARD",re[re.MOUSE=2]="MOUSE"})(x||(e.EditorCloseMethod=x={}));function he(re,B,ee,O){if(!re.isSticky(B))return!1;switch(O.preventPinnedEditorClose){case"keyboardAndMouse":return ee===x.MOUSE||ee===x.KEYBOARD;case"mouse":return ee===x.MOUSE;case"keyboard":return ee===x.KEYBOARD}return!1}e.$6D=he,e.$7D=new ue;var V;(function(re){re[re.LEFT=0]="LEFT",re[re.RIGHT=1]="RIGHT"})(V||(e.CloseDirection=V={}));class te{constructor(){this.c=new Map,this.d=new Map}start(B){const ee=this.a=B.get(L.$Kh);for(const[O,N]of this.c)this.e(O,N,ee);this.c.clear()}e(B,ee,O){const N=O.createInstance(ee);this.d.set(B,N)}registerFileEditorFactory(B){if(this.b)throw new Error("Can only register one file editor factory.");this.b=B}getFileEditorFactory(){return(0,R.$Hf)(this.b)}registerEditorSerializer(B,ee){if(this.c.has(B)||this.d.has(B))throw new Error(`A editor serializer with type ID '${B}' was already registered.`);return this.a?this.e(B,ee,this.a):this.c.set(B,ee),(0,P.$Oc)(()=>{this.c.delete(B),this.d.delete(B)})}getEditorSerializer(B){return this.d.get(typeof B=="string"?B:B.typeId)}}I.$0m.add(e.$KD.EditorFactory,new te);async function G(re,B,ee){return!re||!re.length?[]:await Promise.all(re.map(async O=>{const N=r.URI.revive(O.fileUri);if(!N){ee.info("Cannot resolve the path because it is not valid.",O);return}if(!await B.canHandleResource(N)){ee.info("Cannot resolve the path because it cannot be handled",O);return}let T=O.exists,H=O.type;if(typeof T!="boolean"||typeof H!="number")try{H=(await B.stat(N)).isDirectory?w.FileType.Directory:w.FileType.Unknown,T=!0}catch(ie){ee.error(ie),T=!1}if(!T&&O.openOnlyIfExists){ee.info("Cannot resolve the path because it does not exist",O);return}if(H===w.FileType.Directory){ee.info("Cannot resolve the path because it is a directory",O);return}const U={...O.options,pinned:!0};return T?{resource:N,options:U}:{resource:N,options:U,forceUntitled:!0}}))}e.$8D=G;var J;(function(re){re[re.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",re[re.SEQUENTIAL=1]="SEQUENTIAL"})(J||(e.EditorsOrder=J={}));function q(re){const B=re;if(!B)return!1;const ee=B;if(ee.modified)return q(ee.modified);const O=B;return!!(O.contributionsState&&O.viewState&&Array.isArray(O.cursorState))}e.$9D=q;function ne(re){return(0,C.$xi)(re)}e.$0D=ne;function me(re,B,ee){const O=(0,C.$yi)(re,B);return O.forceMessage=ee?.forceMessage,O.forceSeverity=ee?.forceSeverity,O.allowDialog=ee?.allowDialog,O}e.$$D=me}),define(we[130],pe([1,0,15,76,47,58,12,7,3,66]),function(le,e,y,R,r,P,L,I,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kI=e.$jI=e.$iI=e.$hI=e.CellStatusbarAlignment=e.$gI=e.$fI=e.$eI=e.NotebookEditorPriority=e.$dI=e.$cI=e.$bI=e.$aI=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$_H=e.$$H=e.$0H=e.$9H=e.CellKind=e.$8H=e.$7H=e.$6H=void 0,e.$6H="workbench.editor.notebook",e.$7H="workbench.editor.notebookTextDiffEditor",e.$8H="workbench.editor.interactive";var C;(function(x){x[x.Markup=1]="Markup",x[x.Code=2]="Code"})(C||(e.CellKind=C={})),e.$9H=["application/json","application/javascript","text/html","image/svg+xml",P.$Jr.latex,P.$Jr.markdown,"image/png","image/jpeg",P.$Jr.text],e.$0H=[P.$Jr.latex,P.$Jr.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",P.$Jr.text],e.$$H=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$_H="_notAvailable";var E;(function(x){x[x.Running=1]="Running",x[x.Idle=2]="Idle"})(E||(e.NotebookRunState=E={}));var v;(function(x){x[x.Unconfirmed=1]="Unconfirmed",x[x.Pending=2]="Pending",x[x.Executing=3]="Executing"})(v||(e.NotebookCellExecutionState=v={}));var d;(function(x){x[x.Unconfirmed=1]="Unconfirmed",x[x.Pending=2]="Pending",x[x.Executing=3]="Executing"})(d||(e.NotebookExecutionState=d={}));var g;(function(x){x[x.WithHardKernelDependency=0]="WithHardKernelDependency",x[x.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",x[x.Pure=2]="Pure",x[x.Never=3]="Never"})(g||(e.NotebookRendererMatch=g={}));var m;(function(x){x.Always="always",x.Never="never",x.Optional="optional"})(m||(e.RendererMessagingSpec=m={}));var l;(function(x){x[x.ModelChange=1]="ModelChange",x[x.Move=2]="Move",x[x.ChangeCellLanguage=5]="ChangeCellLanguage",x[x.Initialize=6]="Initialize",x[x.ChangeCellMetadata=7]="ChangeCellMetadata",x[x.Output=8]="Output",x[x.OutputItem=9]="OutputItem",x[x.ChangeCellContent=10]="ChangeCellContent",x[x.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",x[x.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",x[x.ChangeCellMime=13]="ChangeCellMime",x[x.Unknown=100]="Unknown"})(l||(e.NotebookCellsChangeType=l={}));var f;(function(x){x[x.Handle=0]="Handle",x[x.Index=1]="Index"})(f||(e.SelectionStateType=f={}));var u;(function(x){x[x.Replace=1]="Replace",x[x.Output=2]="Output",x[x.Metadata=3]="Metadata",x[x.CellLanguage=4]="CellLanguage",x[x.DocumentMetadata=5]="DocumentMetadata",x[x.Move=6]="Move",x[x.OutputItems=7]="OutputItems",x[x.PartialMetadata=8]="PartialMetadata",x[x.PartialInternalMetadata=9]="PartialInternalMetadata"})(u||(e.CellEditType=u={}));var c;(function(x){x.scheme=L.Schemas.vscodeNotebookCell;const he=["W","X","Y","Z","a","b","c","d","e","f"],V=new RegExp(`^[${he.join("")}]+`),te=7;function G(B,ee){const O=ee.toString(te),Q=`${O.length<he.length?he[O.length-1]:"z"}${O}s${(0,y.$te)(y.$_d.fromString(B.scheme),!0,!0)}`;return B.with({scheme:x.scheme,fragment:Q})}x.generate=G;function J(B){if(B.scheme!==x.scheme)return;const ee=B.fragment.indexOf("s");if(ee<0)return;const O=parseInt(B.fragment.substring(0,ee).replace(V,""),te),N=(0,y.$se)(B.fragment.substring(ee+1)).toString();if(!isNaN(O))return{handle:O,notebook:B.with({scheme:N,fragment:null})}}x.parse=J;function q(B,ee){return B.with({scheme:L.Schemas.vscodeNotebookCellOutput,fragment:`op${ee??""},${B.scheme!==L.Schemas.file?B.scheme:""}`})}x.generateCellOutputUri=q;function ne(B){if(B.scheme!==L.Schemas.vscodeNotebookCellOutput)return;const ee=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(B.fragment);if(!ee)return;const O=ee[1]&&ee[1]!==""?ee[1]:void 0,N=ee[2];return{outputId:O,notebook:B.with({scheme:N||L.Schemas.file,fragment:null})}}x.parseCellOutputUri=ne;function me(B,ee,O){return x.generate(B,ee).with({scheme:O})}x.generateCellPropertyUri=me;function re(B,ee){if(B.scheme===ee)return x.parse(B.with({scheme:x.scheme}))}x.parseCellPropertyUri=re})(c||(e.CellUri=c={}));const p=x=>w.$d?x.replace(/\//g,"\\"):x;class h{constructor(he=[],V=e.$9H){this.e=V,this.d=[...new Set(he)].map(te=>({pattern:te,matches:R.$sj(p(te))}))}sort(he){const V=new Map(r.Iterable.map(he,G=>[G,p(G)]));let te=[];for(const{matches:G}of this.d)for(const[J,q]of V)if(G(q)){te.push(J),V.delete(J);break}return V.size&&(te=te.concat([...V.keys()].sort((G,J)=>this.e.indexOf(G)-this.e.indexOf(J)))),te}prioritize(he,V){const te=this.f(he);if(te===-1){this.d.unshift({pattern:he,matches:R.$sj(p(he))});return}const G=new Set(V.map(q=>this.f(q,te)));G.delete(-1);const J=Array.from(G).sort();this.d.splice(te+1,0,...J.map(q=>this.d[q]));for(let q=J.length-1;q>=0;q--)this.d.splice(J[q],1)}toArray(){return this.d.map(he=>he.pattern)}f(he,V=this.d.length){const te=p(he);for(let G=0;G<V;G++)if(this.d[G].matches(te))return G;return-1}}e.$aI=h;function t(x,he,V,te=(G,J)=>G===J){const G=[];function J(me,re,B){if(re===0&&B.length===0)return;const ee=G[G.length-1];ee&&ee.start+ee.deleteCount===me?(ee.deleteCount+=re,ee.toInsert.push(...B)):G.push({start:me,deleteCount:re,toInsert:B})}let q=0,ne=0;for(;;){if(q===x.length){J(q,0,he.slice(ne));break}if(ne===he.length){J(q,x.length-q,[]);break}const me=x[q],re=he[ne];if(te(me,re)){q+=1,ne+=1;continue}V(re)?(J(q,1,[]),q+=1):(J(q,0,[re]),ne+=1)}return G}e.$bI=t,e.$cI=new b.$3i("notebookEditorCursorAtBoundary","none"),e.$dI=new b.$3i("notebookEditorCursorAtLineBoundary","none");var s;(function(x){x.default="default",x.option="option"})(s||(e.NotebookEditorPriority=s={}));function o(x){const he=x;return!!((typeof he.include=="string"||R.$tj(he.include))&&(typeof he.exclude=="string"||R.$tj(he.exclude)))}e.$eI=o;function i(x,he,V){if(Array.isArray(x.viewType)&&x.viewType.indexOf(he)>=0||x.viewType===he)return!0;if(x.filenamePattern){const te=o(x.filenamePattern)?x.filenamePattern.include:x.filenamePattern,G=o(x.filenamePattern)?x.filenamePattern.exclude:void 0;if(R.$rj(te,(0,I.$lc)(V.fsPath).toLowerCase()))return!(G&&R.$rj(G,(0,I.$lc)(V.fsPath).toLowerCase()))}return!1}e.$fI=i,e.$gI={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScroll:"notebook.stickyScroll.enabled",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",formatOnSave:"notebook.formatOnSave.enabled",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell"};var n;(function(x){x[x.Left=1]="Left",x[x.Right=2]="Right"})(n||(e.CellStatusbarAlignment=n={}));class a{static create(he){return`${a.d}${he}`}static parse(he){if(he.startsWith(a.d))return he.substring(a.d.length)}}e.$hI=a,a.d="notebook/";function $(x){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(x)}e.$iI=$;const S=new TextDecoder;function D(x){const he=[];let V=!1;for(const q of x)(he.length===0||V)&&(he.push(q),V=!0);let te=j(he);const G=y.$_d.concat(he.map(q=>y.$_d.wrap(q))),J=ue(G);return te=te||J.byteLength!==G.byteLength,{data:J,didCompression:te}}e.$jI=D,e.$kI=`${String.fromCharCode(27)}[A`;const k=e.$kI.split("").map(x=>x.charCodeAt(0)),A=10;function j(x){let he=!1;return x.forEach((V,te)=>{if(te===0||V.length<e.$kI.length)return;const G=x[te-1],J=V.subarray(0,e.$kI.length);if(J[0]===k[0]&&J[1]===k[1]&&J[2]===k[2]){const q=G.lastIndexOf(A);if(q===-1)return;he=!0,x[te-1]=G.subarray(0,q),x[te]=V.subarray(e.$kI.length)}}),he}function Z(x){let he=x;do x=he,he=x.replace(/[^\n]\x08/gm,"");while(he.length<x.length);return x}function ae(x){for(x=x.replace(/\r+\n/gm,`
`);x.search(/\r[^$]/g)>-1;){const he=x.match(/^(.*)\r+/m)[1];let V=x.match(/\r+(.*)$/m)[1];V=V+he.slice(V.length,he.length),x=x.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,V)}return x}const K="\b".charCodeAt(0),se="\r".charCodeAt(0);function ue(x){return!x.buffer.includes(K)&&!x.buffer.includes(se)?x:y.$_d.fromString(ae(Z(S.decode(x.buffer))))}});var Rt=this&&this.__classPrivateFieldSet||function(le,e,y,R,r){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!r)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?le!==e||!r:!e.has(le))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?r.call(le,y):r?r.value=y:e.set(le,y),y},nt=this&&this.__classPrivateFieldGet||function(le,e,y,R){if(y==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?le!==e||!R:!e.has(le))throw new TypeError("Cannot read private member from an object whose class did not declare it");return y==="m"?R:y==="a"?R.call(le):R?R.value:e.get(le)};define(we[131],pe([1,0,18,11,100,26,58,17,8,4,23,40,16,118,130]),function(le,e,y,R,r,P,L,I,w,b,C,E,v,d,g){"use strict";var m,l,f,u,c,p,h,t,s,o,i,n,a,$,S,D,k,A,j,Z,ae,K,se,ue,x,he;Object.defineProperty(e,"__esModule",{value:!0}),e.RelatedInformationType=e.$YL=e.ChatVariableLevel=e.ChatMessageRole=e.InteractiveEditorResponseFeedbackKind=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.$XL=e.$WL=e.$VL=e.$UL=e.$TL=e.$SL=e.$RL=e.$QL=e.$PL=e.$OL=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$NL=e.$ML=e.$LL=e.$KL=e.$JL=e.$IL=e.$HL=e.$GL=e.TestRunProfileKind=e.TestResultState=e.$FL=e.$EL=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$DL=e.$CL=e.$BL=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$AL=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$zL=e.$yL=e.$xL=e.$wL=e.$vL=e.ColorThemeKind=e.$uL=e.$tL=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$sL=e.DebugConsoleMode=e.$rL=e.$qL=e.$pL=e.$oL=e.$nL=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$mL=e.$lL=e.FileChangeType=e.$kL=e.$jL=e.$iL=e.$hL=e.InlineCompletionTriggerKind=e.$gL=e.$fL=e.$eL=e.$dL=e.$cL=e.$bL=e.$aL=e.$_K=e.$$K=e.$0K=e.$9K=e.$8K=e.$7K=e.ConfigurationTarget=e.$6K=e.$5K=e.$4K=e.$3K=e.$2K=e.$1K=e.$ZK=e.$YK=e.$XK=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$WK=e.ViewBadge=e.ProgressLocation=e.$VK=e.$UK=e.TaskScope=e.ShellQuoting=e.$TK=e.$SK=e.$RK=e.TaskPanelKind=e.TaskRevealKind=e.$QK=e.TerminalLocation=e.$PK=e.$OK=e.$NK=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$MK=e.$LK=e.$KK=e.$JK=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.$IK=e.StatusBarAlignment=e.ViewColumn=e.$HK=e.$GK=e.$FK=e.$EK=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$DK=e.$CK=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$BK=e.$AK=e.$zK=e.$yK=e.$xK=e.LanguageStatusSeverity=e.$wK=e.$vK=e.$uK=e.$tK=e.$sK=e.$rK=e.CodeActionTriggerKind=e.$qK=e.$pK=e.SymbolTag=e.SymbolKind=e.$oK=e.DocumentHighlightKind=e.$nK=e.$mK=e.$lK=e.$kK=e.DiagnosticSeverity=e.DiagnosticTag=e.$jK=e.$iK=e.FileEditType=e.$hK=e.$gK=e.$fK=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$eK=e.$dK=e.$cK=e.$bK=e.$aK=e.$_J=e.$$J=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function V(M){return Object.assign(M,{apply:function(...ce){if(ce.length===0)return Reflect.construct(M,[]);{const be=ce.length===1?[]:ce[1];return Reflect.construct(M,be,ce[0].constructor)}},call:function(...ce){if(ce.length===0)return Reflect.construct(M,[]);{const[be,...je]=ce;return Reflect.construct(M,je,be.constructor)}}})}var te;(function(M){M[M.Top=0]="Top",M[M.Bottom=1]="Bottom"})(te||(e.TerminalOutputAnchor=te={}));var G;(function(M){M[M.TerminalCommand=0]="TerminalCommand",M[M.Opener=1]="Opener",M[M.Command=3]="Command"})(G||(e.TerminalQuickFixType=G={}));let J=s=class{static from(...F){let ce=F;return new s(function(){if(ce){for(const be of ce)be&&typeof be.dispose=="function"&&be.dispose();ce=void 0}})}constructor(F){m.set(this,void 0),Rt(this,m,F,"f")}dispose(){typeof nt(this,m,"f")=="function"&&(nt(this,m,"f").call(this),Rt(this,m,void 0,"f"))}};e.$$J=J,m=new WeakMap,e.$$J=J=s=Oe([V],J);let q=o=class{static Min(...F){if(F.length===0)throw new TypeError;let ce=F[0];for(let be=1;be<F.length;be++){const je=F[be];je.isBefore(ce)&&(ce=je)}return ce}static Max(...F){if(F.length===0)throw new TypeError;let ce=F[0];for(let be=1;be<F.length;be++){const je=F[be];je.isAfter(ce)&&(ce=je)}return ce}static isPosition(F){if(!F)return!1;if(F instanceof o)return!0;const{line:ce,character:be}=F;return typeof ce=="number"&&typeof be=="number"}static of(F){if(F instanceof o)return F;if(this.isPosition(F))return new o(F.line,F.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(F,ce){if(F<0)throw(0,R.$5)("line must be non-negative");if(ce<0)throw(0,R.$5)("character must be non-negative");this.c=F,this.e=ce}isBefore(F){return this.c<F.c?!0:F.c<this.c?!1:this.e<F.e}isBeforeOrEqual(F){return this.c<F.c?!0:F.c<this.c?!1:this.e<=F.e}isAfter(F){return!this.isBeforeOrEqual(F)}isAfterOrEqual(F){return!this.isBefore(F)}isEqual(F){return this.c===F.c&&this.e===F.e}compareTo(F){return this.c<F.c?-1:this.c>F.line?1:this.e<F.e?-1:this.e>F.e?1:0}translate(F,ce=0){if(F===null||ce===null)throw(0,R.$5)();let be;return typeof F>"u"?be=0:typeof F=="number"?be=F:(be=typeof F.lineDelta=="number"?F.lineDelta:0,ce=typeof F.characterDelta=="number"?F.characterDelta:0),be===0&&ce===0?this:new o(this.line+be,this.character+ce)}with(F,ce=this.character){if(F===null||ce===null)throw(0,R.$5)();let be;return typeof F>"u"?be=this.line:typeof F=="number"?be=F:(be=typeof F.line=="number"?F.line:this.line,ce=typeof F.character=="number"?F.character:this.character),be===this.line&&ce===this.character?this:new o(be,ce)}toJSON(){return{line:this.line,character:this.character}}};e.$_J=q,e.$_J=q=o=Oe([V],q);let ne=i=class{static isRange(F){return F instanceof i?!0:F?q.isPosition(F.start)&&q.isPosition(F.end):!1}static of(F){if(F instanceof i)return F;if(this.isRange(F))return new i(F.start,F.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(F,ce,be,je){let Ke,_e;if(typeof F=="number"&&typeof ce=="number"&&typeof be=="number"&&typeof je=="number"?(Ke=new q(F,ce),_e=new q(be,je)):q.isPosition(F)&&q.isPosition(ce)&&(Ke=q.of(F),_e=q.of(ce)),!Ke||!_e)throw new Error("Invalid arguments");Ke.isBefore(_e)?(this.c=Ke,this.e=_e):(this.c=_e,this.e=Ke)}contains(F){return i.isRange(F)?this.contains(F.start)&&this.contains(F.end):q.isPosition(F)?!(q.of(F).isBefore(this.c)||this.e.isBefore(F)):!1}isEqual(F){return this.c.isEqual(F.c)&&this.e.isEqual(F.e)}intersection(F){const ce=q.Max(F.start,this.c),be=q.Min(F.end,this.e);if(!ce.isAfter(be))return new i(ce,be)}union(F){if(this.contains(F))return this;if(F.contains(this))return F;const ce=q.Min(F.start,this.c),be=q.Max(F.end,this.end);return new i(ce,be)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(F,ce=this.end){if(F===null||ce===null)throw(0,R.$5)();let be;return F?q.isPosition(F)?be=F:(be=F.start||this.start,ce=F.end||this.end):be=this.start,be.isEqual(this.c)&&ce.isEqual(this.end)?this:new i(be,ce)}toJSON(){return[this.start,this.end]}};e.$aK=ne,e.$aK=ne=i=Oe([V],ne);let me=n=class extends ne{static isSelection(F){return F instanceof n?!0:F?ne.isRange(F)&&q.isPosition(F.anchor)&&q.isPosition(F.active)&&typeof F.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(F,ce,be,je){let Ke,_e;if(typeof F=="number"&&typeof ce=="number"&&typeof be=="number"&&typeof je=="number"?(Ke=new q(F,ce),_e=new q(be,je)):q.isPosition(F)&&q.isPosition(ce)&&(Ke=q.of(F),_e=q.of(ce)),!Ke||!_e)throw new Error("Invalid arguments");super(Ke,_e),this.f=Ke,this.g=_e}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$bK=me,e.$bK=me=n=Oe([V],me);const re=M=>{if(typeof M!="string"||M.length===0||!/^[0-9A-Za-z_\-]+$/.test(M))throw(0,R.$5)("connectionToken")};class B{static isResolvedAuthority(F){return F&&typeof F=="object"&&typeof F.host=="string"&&typeof F.port=="number"&&(F.connectionToken===void 0||typeof F.connectionToken=="string")}constructor(F,ce,be){if(typeof F!="string"||F.length===0)throw(0,R.$5)("host");if(typeof ce!="number"||ce===0||Math.round(ce)!==ce)throw(0,R.$5)("port");typeof be<"u"&&re(be),this.host=F,this.port=Math.round(ce),this.connectionToken=be}}e.$cK=B;class ee{static isManagedResolvedAuthority(F){return F&&typeof F=="object"&&typeof F.makeConnection=="function"&&(F.connectionToken===void 0||typeof F.connectionToken=="string")}constructor(F,ce){this.makeConnection=F,this.connectionToken=ce,typeof ce<"u"&&re(ce)}}e.$dK=ee;class O extends Error{static NotAvailable(F,ce){return new O(F,d.RemoteAuthorityResolverErrorCode.NotAvailable,ce)}static TemporarilyNotAvailable(F){return new O(F,d.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(F,ce=d.RemoteAuthorityResolverErrorCode.Unknown,be){super(F),this._message=F,this._code=ce,this._detail=be,Object.setPrototypeOf(this,O.prototype)}}e.$eK=O;var N;(function(M){M[M.LF=1]="LF",M[M.CRLF=2]="CRLF"})(N||(e.EndOfLine=N={}));var Q;(function(M){M[M.Replace=1]="Replace",M[M.Append=2]="Append",M[M.Prepend=3]="Prepend"})(Q||(e.EnvironmentVariableMutatorType=Q={}));let T=a=class{static isTextEdit(F){return F instanceof a?!0:F?ne.isRange(F)&&typeof F.newText=="string":!1}static replace(F,ce){return new a(F,ce)}static insert(F,ce){return a.replace(new ne(F,F),ce)}static delete(F){return a.replace(F,"")}static setEndOfLine(F){const ce=new a(new ne(new q(0,0),new q(0,0)),"");return ce.newEol=F,ce}get range(){return this.c}set range(F){if(F&&!ne.isRange(F))throw(0,R.$5)("range");this.c=F}get newText(){return this.e||""}set newText(F){if(F&&typeof F!="string")throw(0,R.$5)("newText");this.e=F}get newEol(){return this.f}set newEol(F){if(F&&typeof F!="number")throw(0,R.$5)("newEol");this.f=F}constructor(F,ce){this.c=F,this.e=ce}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$fK=T,e.$fK=T=a=Oe([V],T);let H=$=class{static isNotebookCellEdit(F){return F instanceof $?!0:F?Mt.isNotebookRange(F)&&Array.isArray(F.newCells):!1}static replaceCells(F,ce){return new $(F,ce)}static insertCells(F,ce){return new $(new Mt(F,F),ce)}static deleteCells(F){return new $(F,[])}static updateCellMetadata(F,ce){const be=new $(new Mt(F,F),[]);return be.newCellMetadata=ce,be}static updateNotebookMetadata(F){const ce=new $(new Mt(0,0),[]);return ce.newNotebookMetadata=F,ce}constructor(F,ce){this.range=F,this.newCells=ce}};e.$gK=H,e.$gK=H=$=Oe([V],H);class U{static isSnippetTextEdit(F){return F instanceof U?!0:F?ne.isRange(F.range)&&_.isSnippetString(F.snippet):!1}static replace(F,ce){return new U(F,ce)}static insert(F,ce){return U.replace(new ne(F,F),ce)}constructor(F,ce){this.range=F,this.snippet=ce}}e.$hK=U;var ie;(function(M){M[M.File=1]="File",M[M.Text=2]="Text",M[M.Cell=3]="Cell",M[M.CellReplace=5]="CellReplace",M[M.Snippet=6]="Snippet"})(ie||(e.FileEditType=ie={}));let z=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(F,ce,be,je){this.c.push({_type:1,from:F,to:ce,options:be,metadata:je})}createFile(F,ce,be){this.c.push({_type:1,from:void 0,to:F,options:ce,metadata:be})}deleteFile(F,ce,be){this.c.push({_type:1,from:F,to:void 0,options:ce,metadata:be})}e(F,ce,be){this.c.push({_type:3,metadata:be,uri:F,edit:{editType:5,metadata:ce},notebookMetadata:ce})}f(F,ce,be,je){const Ke=ce.start,_e=ce.end;(Ke!==_e||be.length>0)&&this.c.push({_type:5,uri:F,index:Ke,count:_e-Ke,cells:be,metadata:je})}g(F,ce,be,je){this.c.push({_type:3,metadata:je,uri:F,edit:{editType:3,index:ce,metadata:be}})}replace(F,ce,be,je){this.c.push({_type:2,uri:F,edit:new T(ce,be),metadata:je})}insert(F,ce,be,je){this.replace(F,new ne(ce,ce),be,je)}delete(F,ce,be){this.replace(F,ce,"",be)}has(F){return this.c.some(ce=>ce._type===2&&ce.uri.toString()===F.toString())}set(F,ce){if(ce)for(const be of ce){if(!be)continue;let je,Ke;Array.isArray(be)?(je=be[0],Ke=be[1]):je=be,H.isNotebookCellEdit(je)?je.newCellMetadata?this.g(F,je.range.start,je.newCellMetadata,Ke):je.newNotebookMetadata?this.e(F,je.newNotebookMetadata,Ke):this.f(F,je.range,je.newCells,Ke):U.isSnippetTextEdit(je)?this.c.push({_type:6,uri:F,range:je.range,edit:je.snippet,metadata:Ke}):this.c.push({_type:2,uri:F,edit:je,metadata:Ke})}else{for(let be=0;be<this.c.length;be++){const je=this.c[be];switch(je._type){case 2:case 6:case 3:case 5:je.uri.toString()===F.toString()&&(this.c[be]=void 0);break}}(0,y.$Gb)(this.c)}}get(F){const ce=[];for(const be of this.c)be._type===2&&be.uri.toString()===F.toString()&&ce.push(be.edit);return ce}entries(){const F=new P.$yc;for(const ce of this.c)if(ce._type===2){let be=F.get(ce.uri);be||(be=[ce.uri,[]],F.set(ce.uri,be)),be[1].push(ce.edit)}return[...F.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$iK=z,e.$iK=z=Oe([V],z);let _=S=class{static isSnippetString(F){return F instanceof S?!0:F?typeof F.value=="string":!1}static c(F){return F.replace(/\$|}|\\/g,"\\$&")}constructor(F){this.e=1,this.value=F||""}appendText(F){return this.value+=S.c(F),this}appendTabstop(F=this.e++){return this.value+="$",this.value+=F,this}appendPlaceholder(F,ce=this.e++){if(typeof F=="function"){const be=new S;be.e=this.e,F(be),this.e=be.e,F=be.value}else F=S.c(F);return this.value+="${",this.value+=ce,this.value+=":",this.value+=F,this.value+="}",this}appendChoice(F,ce=this.e++){const be=F.map(je=>je.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ce,this.value+="|",this.value+=be,this.value+="|}",this}appendVariable(F,ce){if(typeof ce=="function"){const be=new S;be.e=this.e,ce(be),this.e=be.e,ce=be.value}else typeof ce=="string"&&(ce=ce.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=F,ce&&(this.value+=":",this.value+=ce),this.value+="}",this}};e.$jK=_,e.$jK=_=S=Oe([V],_);var W;(function(M){M[M.Unnecessary=1]="Unnecessary",M[M.Deprecated=2]="Deprecated"})(W||(e.DiagnosticTag=W={}));var X;(function(M){M[M.Hint=3]="Hint",M[M.Information=2]="Information",M[M.Warning=1]="Warning",M[M.Error=0]="Error"})(X||(e.DiagnosticSeverity=X={}));let oe=D=class{static isLocation(F){return F instanceof D?!0:F?ne.isRange(F.range)&&b.URI.isUri(F.uri):!1}constructor(F,ce){if(this.uri=F,ce)if(ne.isRange(ce))this.range=ne.of(ce);else if(q.isPosition(ce))this.range=new ne(ce,ce);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$kK=oe,e.$kK=oe=D=Oe([V],oe);let ge=class{static is(F){return F?typeof F.message=="string"&&F.location&&ne.isRange(F.location.range)&&b.URI.isUri(F.location.uri):!1}constructor(F,ce){this.location=F,this.message=ce}static isEqual(F,ce){return F===ce?!0:!F||!ce?!1:F.message===ce.message&&F.location.range.isEqual(ce.location.range)&&F.location.uri.toString()===ce.location.uri.toString()}};e.$lK=ge,e.$lK=ge=Oe([V],ge);let Ee=class{constructor(F,ce,be=X.Error){if(!ne.isRange(F))throw new TypeError("range must be set");if(!ce)throw new TypeError("message must be set");this.range=F,this.message=ce,this.severity=be}toJSON(){return{severity:X[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(F,ce){return F===ce?!0:!F||!ce?!1:F.message===ce.message&&F.severity===ce.severity&&F.code===ce.code&&F.severity===ce.severity&&F.source===ce.source&&F.range.isEqual(ce.range)&&(0,y.$sb)(F.tags,ce.tags)&&(0,y.$sb)(F.relatedInformation,ce.relatedInformation,ge.isEqual)}};e.$mK=Ee,e.$mK=Ee=Oe([V],Ee);let Pe=class{constructor(F,ce){if(!F)throw new Error("Illegal argument, contents must be defined");Array.isArray(F)?this.contents=F:this.contents=[F],this.range=ce}};e.$nK=Pe,e.$nK=Pe=Oe([V],Pe);var Ne;(function(M){M[M.Text=0]="Text",M[M.Read=1]="Read",M[M.Write=2]="Write"})(Ne||(e.DocumentHighlightKind=Ne={}));let Fe=class{constructor(F,ce=Ne.Text){this.range=F,this.kind=ce}toJSON(){return{range:this.range,kind:Ne[this.kind]}}};e.$oK=Fe,e.$oK=Fe=Oe([V],Fe);var $e;(function(M){M[M.File=0]="File",M[M.Module=1]="Module",M[M.Namespace=2]="Namespace",M[M.Package=3]="Package",M[M.Class=4]="Class",M[M.Method=5]="Method",M[M.Property=6]="Property",M[M.Field=7]="Field",M[M.Constructor=8]="Constructor",M[M.Enum=9]="Enum",M[M.Interface=10]="Interface",M[M.Function=11]="Function",M[M.Variable=12]="Variable",M[M.Constant=13]="Constant",M[M.String=14]="String",M[M.Number=15]="Number",M[M.Boolean=16]="Boolean",M[M.Array=17]="Array",M[M.Object=18]="Object",M[M.Key=19]="Key",M[M.Null=20]="Null",M[M.EnumMember=21]="EnumMember",M[M.Struct=22]="Struct",M[M.Event=23]="Event",M[M.Operator=24]="Operator",M[M.TypeParameter=25]="TypeParameter"})($e||(e.SymbolKind=$e={}));var ke;(function(M){M[M.Deprecated=1]="Deprecated"})(ke||(e.SymbolTag=ke={}));let ve=k=class{static validate(F){if(!F.name)throw new Error("name must not be falsy")}constructor(F,ce,be,je,Ke){this.name=F,this.kind=ce,this.containerName=Ke,typeof be=="string"&&(this.containerName=be),je instanceof oe?this.location=je:be instanceof ne&&(this.location=new oe(je,be)),k.validate(this)}toJSON(){return{name:this.name,kind:$e[this.kind],location:this.location,containerName:this.containerName}}};e.$pK=ve,e.$pK=ve=k=Oe([V],ve);let Me=A=class{static validate(F){if(!F.name)throw new Error("name must not be falsy");if(!F.range.contains(F.selectionRange))throw new Error("selectionRange must be contained in fullRange");F.children?.forEach(A.validate)}constructor(F,ce,be,je,Ke){this.name=F,this.detail=ce,this.kind=be,this.range=je,this.selectionRange=Ke,this.children=[],A.validate(this)}};e.$qK=Me,e.$qK=Me=A=Oe([V],Me);var Ue;(function(M){M[M.Invoke=1]="Invoke",M[M.Automatic=2]="Automatic"})(Ue||(e.CodeActionTriggerKind=Ue={}));let Ye=class{constructor(F,ce){this.title=F,this.kind=ce}};e.$rK=Ye,e.$rK=Ye=Oe([V],Ye);let qe=j=class{constructor(F){this.value=F}append(F){return new j(this.value?this.value+j.c+F:F)}intersects(F){return this.contains(F)||F.contains(this)}contains(F){return this.value===F.value||F.value.startsWith(this.value+j.c)}};e.$sK=qe,qe.c=".",e.$sK=qe=j=Oe([V],qe),qe.Empty=new qe(""),qe.QuickFix=qe.Empty.append("quickfix"),qe.Refactor=qe.Empty.append("refactor"),qe.RefactorExtract=qe.Refactor.append("extract"),qe.RefactorInline=qe.Refactor.append("inline"),qe.RefactorMove=qe.Refactor.append("move"),qe.RefactorRewrite=qe.Refactor.append("rewrite"),qe.Source=qe.Empty.append("source"),qe.SourceOrganizeImports=qe.Source.append("organizeImports"),qe.SourceFixAll=qe.Source.append("fixAll"),qe.Notebook=qe.Empty.append("notebook");let Je=class{constructor(F,ce){if(this.range=F,this.parent=ce,ce&&!ce.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$tK=Je,e.$tK=Je=Oe([V],Je);class Ze{constructor(F,ce,be,je,Ke,_e){this.kind=F,this.name=ce,this.detail=be,this.uri=je,this.range=Ke,this.selectionRange=_e}}e.$uK=Ze;class xe{constructor(F,ce){this.fromRanges=ce,this.from=F}}e.$vK=xe;class de{constructor(F,ce){this.fromRanges=ce,this.to=F}}e.$wK=de;var Se;(function(M){M[M.Information=0]="Information",M[M.Warning=1]="Warning",M[M.Error=2]="Error"})(Se||(e.LanguageStatusSeverity=Se={}));let Ie=class{constructor(F,ce){this.range=F,this.command=ce}get isResolved(){return!!this.command}};e.$xK=Ie,e.$xK=Ie=Oe([V],Ie);let Le=Z=class{static isMarkdownString(F){return F instanceof Z?!0:F&&F.appendCodeblock&&F.appendMarkdown&&F.appendText&&F.value!==void 0}constructor(F,ce=!1){l.set(this,void 0),Rt(this,l,new r.$Yj(F,{supportThemeIcons:ce}),"f")}get value(){return nt(this,l,"f").value}set value(F){nt(this,l,"f").value=F}get isTrusted(){return nt(this,l,"f").isTrusted}set isTrusted(F){nt(this,l,"f").isTrusted=F}get supportThemeIcons(){return nt(this,l,"f").supportThemeIcons}set supportThemeIcons(F){nt(this,l,"f").supportThemeIcons=F}get supportHtml(){return nt(this,l,"f").supportHtml}set supportHtml(F){nt(this,l,"f").supportHtml=F}get baseUri(){return nt(this,l,"f").baseUri}set baseUri(F){nt(this,l,"f").baseUri=F}appendText(F){return nt(this,l,"f").appendText(F),this}appendMarkdown(F){return nt(this,l,"f").appendMarkdown(F),this}appendCodeblock(F,ce){return nt(this,l,"f").appendCodeblock(ce??"",F),this}};e.$yK=Le,l=new WeakMap,e.$yK=Le=Z=Oe([V],Le);let Be=class{constructor(F,ce){this.label=F,this.documentation=ce}};e.$zK=Be,e.$zK=Be=Oe([V],Be);let ze=class{constructor(F,ce){this.label=F,this.documentation=ce,this.parameters=[]}};e.$AK=ze,e.$AK=ze=Oe([V],ze);let He=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$BK=He,e.$BK=He=Oe([V],He);var Ge;(function(M){M[M.Invoke=1]="Invoke",M[M.TriggerCharacter=2]="TriggerCharacter",M[M.ContentChange=3]="ContentChange"})(Ge||(e.SignatureHelpTriggerKind=Ge={}));var Qe;(function(M){M[M.Type=1]="Type",M[M.Parameter=2]="Parameter"})(Qe||(e.InlayHintKind=Qe={}));let We=class{constructor(F){this.value=F}};e.$CK=We,e.$CK=We=Oe([V],We);let st=class{constructor(F,ce,be){this.position=F,this.label=ce,this.kind=be}};e.$DK=st,e.$DK=st=Oe([V],st);var rt;(function(M){M[M.Invoke=0]="Invoke",M[M.TriggerCharacter=1]="TriggerCharacter",M[M.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(rt||(e.CompletionTriggerKind=rt={}));var et;(function(M){M[M.Text=0]="Text",M[M.Method=1]="Method",M[M.Function=2]="Function",M[M.Constructor=3]="Constructor",M[M.Field=4]="Field",M[M.Variable=5]="Variable",M[M.Class=6]="Class",M[M.Interface=7]="Interface",M[M.Module=8]="Module",M[M.Property=9]="Property",M[M.Unit=10]="Unit",M[M.Value=11]="Value",M[M.Enum=12]="Enum",M[M.Keyword=13]="Keyword",M[M.Snippet=14]="Snippet",M[M.Color=15]="Color",M[M.File=16]="File",M[M.Reference=17]="Reference",M[M.Folder=18]="Folder",M[M.EnumMember=19]="EnumMember",M[M.Constant=20]="Constant",M[M.Struct=21]="Struct",M[M.Event=22]="Event",M[M.Operator=23]="Operator",M[M.TypeParameter=24]="TypeParameter",M[M.User=25]="User",M[M.Issue=26]="Issue"})(et||(e.CompletionItemKind=et={}));var ft;(function(M){M[M.Deprecated=1]="Deprecated"})(ft||(e.CompletionItemTag=ft={}));let $t=class{constructor(F,ce){this.label=F,this.kind=ce}toJSON(){return{label:this.label,kind:this.kind&&et[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$EK=$t,e.$EK=$t=Oe([V],$t);let Ct=class{constructor(F=[],ce=!1){this.items=F,this.isIncomplete=ce}};e.$FK=Ct,e.$FK=Ct=Oe([V],Ct);let dt=class{constructor(F,ce,be){this.insertText=F,this.range=ce,this.command=be}};e.$GK=dt,e.$GK=dt=Oe([V],dt);let bt=class{constructor(F){this.commands=void 0,this.suppressSuggestions=void 0,this.items=F}};e.$HK=bt,e.$HK=bt=Oe([V],bt);var jt;(function(M){M[M.Active=-1]="Active",M[M.Beside=-2]="Beside",M[M.One=1]="One",M[M.Two=2]="Two",M[M.Three=3]="Three",M[M.Four=4]="Four",M[M.Five=5]="Five",M[M.Six=6]="Six",M[M.Seven=7]="Seven",M[M.Eight=8]="Eight",M[M.Nine=9]="Nine"})(jt||(e.ViewColumn=jt={}));var Pt;(function(M){M[M.Left=1]="Left",M[M.Right=2]="Right"})(Pt||(e.StatusBarAlignment=Pt={}));function wt(M,F){return`${E.$Xl.toKey(M)}.${F}`}e.$IK=wt;var pt;(function(M){M[M.Off=0]="Off",M[M.On=1]="On",M[M.Relative=2]="Relative"})(pt||(e.TextEditorLineNumbersStyle=pt={}));var Ot;(function(M){M[M.Manual=1]="Manual",M[M.AfterDelay=2]="AfterDelay",M[M.FocusOut=3]="FocusOut"})(Ot||(e.TextDocumentSaveReason=Ot={}));var Tt;(function(M){M[M.Default=0]="Default",M[M.InCenter=1]="InCenter",M[M.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",M[M.AtTop=3]="AtTop"})(Tt||(e.TextEditorRevealType=Tt={}));var ut;(function(M){M[M.Keyboard=1]="Keyboard",M[M.Mouse=2]="Mouse",M[M.Command=3]="Command"})(ut||(e.TextEditorSelectionChangeKind=ut={}));var Ut;(function(M){M[M.Undo=1]="Undo",M[M.Redo=2]="Redo"})(Ut||(e.TextDocumentChangeReason=Ut={}));var Nt;(function(M){M[M.OpenOpen=0]="OpenOpen",M[M.ClosedClosed=1]="ClosedClosed",M[M.OpenClosed=2]="OpenClosed",M[M.ClosedOpen=3]="ClosedOpen"})(Nt||(e.DecorationRangeBehavior=Nt={})),function(M){function F(ce){switch(ce){case"keyboard":return M.Keyboard;case"mouse":return M.Mouse;case"api":return M.Command}}M.fromValue=F}(ut||(e.TextEditorSelectionChangeKind=ut={}));var it;(function(M){M[M.Other=0]="Other",M[M.Comment=1]="Comment",M[M.String=2]="String",M[M.RegEx=3]="RegEx"})(it||(e.SyntaxTokenType=it={})),function(M){function F(ce){switch(ce){case M.Other:return"other";case M.Comment:return"comment";case M.String:return"string";case M.RegEx:return"regex"}return"other"}M.toString=F}(it||(e.SyntaxTokenType=it={}));let vt=class{constructor(F,ce){if(ce&&!b.URI.isUri(ce))throw(0,R.$5)("target");if(!ne.isRange(F)||F.isEmpty)throw(0,R.$5)("range");this.range=F,this.target=ce}};e.$JK=vt,e.$JK=vt=Oe([V],vt);let ct=class{constructor(F,ce,be,je){this.red=F,this.green=ce,this.blue=be,this.alpha=je}};e.$KK=ct,e.$KK=ct=Oe([V],ct);let ht=class{constructor(F,ce){if(ce&&!(ce instanceof ct))throw(0,R.$5)("color");if(!ne.isRange(F)||F.isEmpty)throw(0,R.$5)("range");this.range=F,this.color=ce}};e.$LK=ht,e.$LK=ht=Oe([V],ht);let Ft=class{constructor(F){if(!F||typeof F!="string")throw(0,R.$5)("label");this.label=F}};e.$MK=Ft,e.$MK=Ft=Oe([V],Ft);var It;(function(M){M[M.RGB=0]="RGB",M[M.HEX=1]="HEX",M[M.HSL=2]="HSL"})(It||(e.ColorFormat=It={}));var Bt;(function(M){M[M.Error=0]="Error",M[M.Warning=1]="Warning",M[M.Information=2]="Information"})(Bt||(e.SourceControlInputBoxValidationType=Bt={}));var Dt;(function(M){M[M.Unknown=0]="Unknown",M[M.Shutdown=1]="Shutdown",M[M.Process=2]="Process",M[M.User=3]="User",M[M.Extension=4]="Extension"})(Dt||(e.TerminalExitReason=Dt={}));class zt{constructor(F,ce,be){if(this.startIndex=F,this.length=ce,this.tooltip=be,typeof F!="number"||F<0)throw(0,R.$5)("startIndex");if(typeof ce!="number"||ce<1)throw(0,R.$5)("length");if(be!==void 0&&typeof be!="string")throw(0,R.$5)("tooltip")}}e.$NK=zt;class qt{constructor(F){this.uri=F}}e.$OK=qt;class ye{constructor(F){this.terminalCommand=F}}e.$PK=ye;var De;(function(M){M[M.Panel=1]="Panel",M[M.Editor=2]="Editor"})(De||(e.TerminalLocation=De={}));class fe{constructor(F){if(this.options=F,typeof F!="object")throw(0,R.$5)("options")}}e.$QK=fe;var Y;(function(M){M[M.Always=1]="Always",M[M.Silent=2]="Silent",M[M.Never=3]="Never"})(Y||(e.TaskRevealKind=Y={}));var Ce;(function(M){M[M.Shared=1]="Shared",M[M.Dedicated=2]="Dedicated",M[M.New=3]="New"})(Ce||(e.TaskPanelKind=Ce={}));let Re=ae=class{static from(F){switch(F){case"clean":return ae.Clean;case"build":return ae.Build;case"rebuild":return ae.Rebuild;case"test":return ae.Test;default:return}}constructor(F,ce){if(this.label=ce,typeof F!="string"||typeof ce!="string")throw(0,R.$5)("name");this.c=F}get id(){return this.c}};e.$RK=Re,Re.Clean=new ae("clean","Clean"),Re.Build=new ae("build","Build"),Re.Rebuild=new ae("rebuild","Rebuild"),Re.Test=new ae("test","Test"),e.$RK=Re=ae=Oe([V],Re);function Ve(M){let F="";for(let ce=0;ce<M.length;ce++)F+=M[ce].replace(/,/g,",,")+",";return F}let Te=class{constructor(F,ce,be){if(typeof F!="string")throw(0,R.$5)("process");this.e=[],this.c=F,ce!==void 0&&(Array.isArray(ce)?(this.e=ce,this.f=be):this.f=ce)}get process(){return this.c}set process(F){if(typeof F!="string")throw(0,R.$5)("process");this.c=F}get args(){return this.e}set args(F){Array.isArray(F)||(F=[]),this.e=F}get options(){return this.f}set options(F){this.f=F}computeId(){const F=[];if(F.push("process"),this.c!==void 0&&F.push(this.c),this.e&&this.e.length>0)for(const ce of this.e)F.push(ce);return Ve(F)}};e.$SK=Te,e.$SK=Te=Oe([V],Te);let Xe=class{constructor(F,ce,be){if(this.f=[],Array.isArray(ce)){if(!F)throw(0,R.$5)("command can't be undefined or null");if(typeof F!="string"&&typeof F.value!="string")throw(0,R.$5)("command");this.e=F,this.f=ce,this.g=be}else{if(typeof F!="string")throw(0,R.$5)("commandLine");this.c=F,this.g=ce}}get commandLine(){return this.c}set commandLine(F){if(typeof F!="string")throw(0,R.$5)("commandLine");this.c=F}get command(){return this.e?this.e:""}set command(F){if(typeof F!="string"&&typeof F.value!="string")throw(0,R.$5)("command");this.e=F}get args(){return this.f}set args(F){this.f=F||[]}get options(){return this.g}set options(F){this.g=F}computeId(){const F=[];if(F.push("shell"),this.c!==void 0&&F.push(this.c),this.e!==void 0&&F.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const ce of this.f)F.push(typeof ce=="string"?ce:ce.value);return Ve(F)}};e.$TK=Xe,e.$TK=Xe=Oe([V],Xe);var at;(function(M){M[M.Escape=1]="Escape",M[M.Strong=2]="Strong",M[M.Weak=3]="Weak"})(at||(e.ShellQuoting=at={}));var mt;(function(M){M[M.Global=1]="Global",M[M.Workspace=2]="Workspace"})(mt||(e.TaskScope=mt={}));class yt{constructor(F){this.c=F}computeId(){return"customExecution"+(0,C.$bg)()}set callback(F){this.c=F}get callback(){return this.c}}e.$UK=yt;let ot=K=class{constructor(F,ce,be,je,Ke,_e){this.j=!1,this.k=this.definition=F;let tt;typeof ce=="string"?(this.m=this.name=ce,this.t=this.source=be,this.execution=je,tt=Ke,this.j=!0):ce===mt.Global||ce===mt.Workspace?(this.target=ce,this.m=this.name=be,this.t=this.source=je,this.execution=Ke,tt=_e):(this.target=ce,this.m=this.name=be,this.t=this.source=je,this.execution=Ke,tt=_e),typeof tt=="string"?(this.o=[tt],this.q=!0):Array.isArray(tt)?(this.o=tt,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.w=Object.create(null),this.x=Object.create(null)}get _id(){return this.h}set _id(F){this.h=F}get _deprecated(){return this.j}z(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.A())}A(){this.n instanceof Te?this.k={type:K.e,id:this.n.computeId()}:this.n instanceof Xe?this.k={type:K.f,id:this.n.computeId()}:this.n instanceof yt?this.k={type:K.c,id:this.n.computeId()}:this.k={type:K.g,id:(0,C.$bg)()}}get definition(){return this.k}set definition(F){if(F==null)throw(0,R.$5)("Kind can't be undefined or null");this.z(),this.k=F}get scope(){return this.l}set target(F){this.z(),this.l=F}get name(){return this.m}set name(F){if(typeof F!="string")throw(0,R.$5)("name");this.z(),this.m=F}get execution(){return this.n}set execution(F){F===null&&(F=void 0),this.z(),this.n=F;const ce=this.k.type;(K.g===ce||K.e===ce||K.f===ce||K.c===ce)&&this.A()}get problemMatchers(){return this.o}set problemMatchers(F){if(Array.isArray(F))this.z(),this.o=F,this.q=!0;else{this.z(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(F){F!==!0&&F!==!1&&(F=!1),this.z(),this.r=F}get source(){return this.t}set source(F){if(typeof F!="string"||F.length===0)throw(0,R.$5)("source must be a string of length > 0");this.z(),this.t=F}get group(){return this.u}set group(F){F===null&&(F=void 0),this.z(),this.u=F}get detail(){return this.y}set detail(F){F===null&&(F=void 0),this.y=F}get presentationOptions(){return this.w}set presentationOptions(F){F==null&&(F=Object.create(null)),this.z(),this.w=F}get runOptions(){return this.x}set runOptions(F){F==null&&(F=Object.create(null)),this.z(),this.x=F}};e.$VK=ot,ot.c="customExecution",ot.e="process",ot.f="shell",ot.g="$empty",e.$VK=ot=K=Oe([V],ot);var gt;(function(M){M[M.SourceControl=1]="SourceControl",M[M.Window=10]="Window",M[M.Notification=15]="Notification"})(gt||(e.ProgressLocation=gt={}));var On;(function(M){function F(ce){const be=ce;return(0,w.$Af)(be.value)?be.tooltip&&!(0,w.$wf)(be.tooltip)?(console.log("INVALID view badge, invalid tooltip",be.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",be.value),!1)}M.isViewBadge=F})(On||(e.ViewBadge=On={}));let xt=se=class{static isTreeItem(F,ce){const be=F;if(be.checkboxState!==void 0){const je=(0,w.$Af)(be.checkboxState)?be.checkboxState:(0,w.$yf)(be.checkboxState)&&(0,w.$Af)(be.checkboxState.state)?be.checkboxState.state:void 0,Ke=!(0,w.$Af)(be.checkboxState)&&(0,w.$yf)(be.checkboxState)?be.checkboxState.tooltip:void 0;if(je===void 0||je!==Qt.Checked&&je!==Qt.Unchecked||Ke!==void 0&&!(0,w.$wf)(Ke))return console.log("INVALID tree item, invalid checkboxState",be.checkboxState),!1}if(F instanceof se)return!0;if(be.label!==void 0&&!(0,w.$wf)(be.label)&&!be.label?.label)return console.log("INVALID tree item, invalid label",be.label),!1;if(be.id!==void 0&&!(0,w.$wf)(be.id))return console.log("INVALID tree item, invalid id",be.id),!1;if(be.iconPath!==void 0&&!(0,w.$wf)(be.iconPath)&&!b.URI.isUri(be.iconPath)&&(!be.iconPath||!(0,w.$wf)(be.iconPath.id))){const je=be.iconPath;if(!je||!(0,w.$wf)(je.light)&&!b.URI.isUri(je.light)&&!(0,w.$wf)(je.dark)&&!b.URI.isUri(je.dark))return console.log("INVALID tree item, invalid iconPath",be.iconPath),!1}return be.description!==void 0&&!(0,w.$wf)(be.description)&&typeof be.description!="boolean"?(console.log("INVALID tree item, invalid description",be.description),!1):be.resourceUri!==void 0&&!b.URI.isUri(be.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",be.resourceUri),!1):be.tooltip!==void 0&&!(0,w.$wf)(be.tooltip)&&!(be.tooltip instanceof Le)?(console.log("INVALID tree item, invalid tooltip",be.tooltip),!1):be.command!==void 0&&!be.command.command?(console.log("INVALID tree item, invalid command",be.command),!1):be.collapsibleState!==void 0&&be.collapsibleState<Vt.None&&be.collapsibleState>Vt.Expanded?(console.log("INVALID tree item, invalid collapsibleState",be.collapsibleState),!1):be.contextValue!==void 0&&!(0,w.$wf)(be.contextValue)?(console.log("INVALID tree item, invalid contextValue",be.contextValue),!1):be.accessibilityInformation!==void 0&&!be.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",be.accessibilityInformation),!1):!0}constructor(F,ce=Vt.None){this.collapsibleState=ce,b.URI.isUri(F)?this.resourceUri=F:this.label=F}};e.$WK=xt,e.$WK=xt=se=Oe([V],xt);var Vt;(function(M){M[M.None=0]="None",M[M.Collapsed=1]="Collapsed",M[M.Expanded=2]="Expanded"})(Vt||(e.TreeItemCollapsibleState=Vt={}));var Qt;(function(M){M[M.Unchecked=0]="Unchecked",M[M.Checked=1]="Checked"})(Qt||(e.TreeItemCheckboxState=Qt={}));let Jt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(F){this.value=F}};e.$XK=Jt,e.$XK=Jt=Oe([V],Jt);class Nn extends Jt{}e.$YK=Nn;class $i extends Nn{constructor(F){super(""),f.set(this,void 0),Rt(this,f,F,"f")}asFile(){return nt(this,f,"f")}}e.$ZK=$i,f=new WeakMap;class bi{constructor(F,ce,be,je){this.name=F,this.uri=ce,this._itemId=be,this.c=je}data(){return this.c()}}e.$1K=bi;let _t=class{constructor(F){u.add(this),c.set(this,new Map);for(const[ce,be]of F??[]){const je=nt(this,c,"f").get(nt(this,u,"m",p).call(this,ce));je?je.push(be):nt(this,c,"f").set(nt(this,u,"m",p).call(this,ce),[be])}}get(F){return nt(this,c,"f").get(nt(this,u,"m",p).call(this,F))?.[0]}set(F,ce){nt(this,c,"f").set(nt(this,u,"m",p).call(this,F),[ce])}forEach(F,ce){for(const[be,je]of nt(this,c,"f"))for(const Ke of je)F.call(ce,Ke,be,this)}*[(c=new WeakMap,u=new WeakSet,Symbol.iterator)](){for(const[F,ce]of nt(this,c,"f"))for(const be of ce)yield[F,be]}};e.$2K=_t,p=function(F){return F.toLowerCase()},e.$2K=_t=Oe([V],_t);let en=class{constructor(F){this.insertText=F}};e.$3K=en,e.$3K=en=Oe([V],en);let tn=class{constructor(F,ce){this.label=ce,this.insertText=F}};e.$4K=tn,e.$4K=tn=Oe([V],tn);let At=class{constructor(F,ce){this.id=F,this.color=ce}static isThemeIcon(F){return typeof F.id!="string"?(console.log("INVALID ThemeIcon, invalid id",F.id),!1):!0}};e.$5K=At,e.$5K=At=Oe([V],At),At.File=new At("file"),At.Folder=new At("folder");let nn=class{constructor(F){this.id=F}};e.$6K=nn,e.$6K=nn=Oe([V],nn);var Fn;(function(M){M[M.Global=1]="Global",M[M.Workspace=2]="Workspace",M[M.WorkspaceFolder=3]="WorkspaceFolder"})(Fn||(e.ConfigurationTarget=Fn={}));let sn=class{get base(){return this.c}set base(F){this.c=F,this.e=b.URI.file(F)}get baseUri(){return this.e}set baseUri(F){this.e=F,this.c=F.fsPath}constructor(F,ce){if(typeof F!="string"&&(!F||!b.URI.isUri(F)&&!b.URI.isUri(F.uri)))throw(0,R.$5)("base");if(typeof ce!="string")throw(0,R.$5)("pattern");typeof F=="string"?this.baseUri=b.URI.file(F):b.URI.isUri(F)?this.baseUri=F:this.baseUri=F.uri,this.pattern=ce}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$7K=sn,e.$7K=sn=Oe([V],sn);const Mn=new WeakMap;function wi(M,F){Mn.set(M,F)}e.$8K=wi;let Ht=class{constructor(F,ce,be,je){this.enabled=typeof F=="boolean"?F:!0,typeof ce=="string"&&(this.condition=ce),typeof be=="string"&&(this.hitCondition=be),typeof je=="string"&&(this.logMessage=je)}get id(){return this.c||(this.c=Mn.get(this)??(0,C.$bg)()),this.c}};e.$9K=Ht,e.$9K=Ht=Oe([V],Ht);let rn=class extends Ht{constructor(F,ce,be,je,Ke){if(super(ce,be,je,Ke),F===null)throw(0,R.$5)("location");this.location=F}};e.$0K=rn,e.$0K=rn=Oe([V],rn);let on=class extends Ht{constructor(F,ce,be,je,Ke){super(ce,be,je,Ke),this.functionName=F}};e.$$K=on,e.$$K=on=Oe([V],on);let an=class extends Ht{constructor(F,ce,be,je,Ke,_e,tt){if(super(je,Ke,_e,tt),!ce)throw(0,R.$5)("dataId");this.label=F,this.dataId=ce,this.canPersist=be}};e.$_K=an,e.$_K=an=Oe([V],an);let cn=class{constructor(F,ce,be){this.command=F,this.args=ce||[],this.options=be}};e.$aL=cn,e.$aL=cn=Oe([V],cn);let ln=class{constructor(F,ce){this.port=F,this.host=ce}};e.$bL=ln,e.$bL=ln=Oe([V],ln);let un=class{constructor(F){this.path=F}};e.$cL=un,e.$cL=un=Oe([V],un);let hn=class{constructor(F){this.implementation=F}};e.$dL=hn,e.$dL=hn=Oe([V],hn);let fn=class{constructor(F,ce,be){this.session=F,this.threadId=ce,this.frameId=be}};e.$eL=fn,e.$eL=fn=Oe([V],fn);let dn=class{constructor(F,ce){this.session=F,this.threadId=ce}};e.$fL=dn,e.$fL=dn=Oe([V],dn);let mn=class{constructor(F,ce){this.range=F,this.expression=ce}};e.$gL=mn,e.$gL=mn=Oe([V],mn);var jn;(function(M){M[M.Invoke=0]="Invoke",M[M.Automatic=1]="Automatic"})(jn||(e.InlineCompletionTriggerKind=jn={}));let gn=class{constructor(F,ce){this.range=F,this.text=ce}};e.$hL=gn,e.$hL=gn=Oe([V],gn);let $n=class{constructor(F,ce,be=!0){this.range=F,this.variableName=ce,this.caseSensitiveLookup=be}};e.$iL=$n,e.$iL=$n=Oe([V],$n);let bn=class{constructor(F,ce){this.range=F,this.expression=ce}};e.$jL=bn,e.$jL=bn=Oe([V],bn);let wn=class{constructor(F,ce){this.frameId=F,this.stoppedLocation=ce}};e.$kL=wn,e.$kL=wn=Oe([V],wn);var Tn;(function(M){M[M.Changed=1]="Changed",M[M.Created=2]="Created",M[M.Deleted=3]="Deleted"})(Tn||(e.FileChangeType=Tn={}));let pn=ue=class extends Error{static FileExists(F){return new ue(F,v.FileSystemProviderErrorCode.FileExists,ue.FileExists)}static FileNotFound(F){return new ue(F,v.FileSystemProviderErrorCode.FileNotFound,ue.FileNotFound)}static FileNotADirectory(F){return new ue(F,v.FileSystemProviderErrorCode.FileNotADirectory,ue.FileNotADirectory)}static FileIsADirectory(F){return new ue(F,v.FileSystemProviderErrorCode.FileIsADirectory,ue.FileIsADirectory)}static NoPermissions(F){return new ue(F,v.FileSystemProviderErrorCode.NoPermissions,ue.NoPermissions)}static Unavailable(F){return new ue(F,v.FileSystemProviderErrorCode.Unavailable,ue.Unavailable)}constructor(F,ce=v.FileSystemProviderErrorCode.Unknown,be){super(b.URI.isUri(F)?F.toString(!0):F),this.code=be?.name??"Unknown",(0,v.$ik)(this,ce),Object.setPrototypeOf(this,ue.prototype),typeof Error.captureStackTrace=="function"&&typeof be=="function"&&Error.captureStackTrace(this,be)}};e.$lL=pn,e.$lL=pn=ue=Oe([V],pn);let vn=class{constructor(F,ce,be){this.start=F,this.end=ce,this.kind=be}};e.$mL=vn,e.$mL=vn=Oe([V],vn);var Un;(function(M){M[M.Comment=1]="Comment",M[M.Imports=2]="Imports",M[M.Region=3]="Region"})(Un||(e.FoldingRangeKind=Un={}));var Bn;(function(M){M[M.Collapsed=0]="Collapsed",M[M.Expanded=1]="Expanded"})(Bn||(e.CommentThreadCollapsibleState=Bn={}));var zn;(function(M){M[M.Editing=0]="Editing",M[M.Preview=1]="Preview"})(zn||(e.CommentMode=zn={}));var qn;(function(M){M[M.Published=0]="Published",M[M.Draft=1]="Draft"})(qn||(e.CommentState=qn={}));var Hn;(function(M){M[M.Unresolved=0]="Unresolved",M[M.Resolved=1]="Resolved"})(Hn||(e.CommentThreadState=Hn={}));class pi{constructor(F,ce=[]){this.tokenTypes=F,this.tokenModifiers=ce}}e.$nL=pi;function vi(M){return typeof M>"u"||(0,w.$xf)(M)}class yn{constructor(F){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,F){this.l=!0;for(let ce=0,be=F.tokenTypes.length;ce<be;ce++)this.j.set(F.tokenTypes[ce],ce);for(let ce=0,be=F.tokenModifiers.length;ce<be;ce++)this.k.set(F.tokenModifiers[ce],ce)}}push(F,ce,be,je,Ke){if(typeof F=="number"&&typeof ce=="number"&&typeof be=="number"&&typeof je=="number"&&(typeof Ke=="number"||typeof Ke>"u"))return typeof Ke>"u"&&(Ke=0),this.n(F,ce,be,je,Ke);if(ne.isRange(F)&&typeof ce=="string"&&vi(be))return this.m(F,ce,be);throw(0,R.$5)()}m(F,ce,be){if(!this.l)throw new Error("Legend must be provided in constructor");if(F.start.line!==F.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(ce))throw new Error("`tokenType` is not in the provided legend");const je=F.start.line,Ke=F.start.character,_e=F.end.character-F.start.character,tt=this.j.get(ce);let lt=0;if(be)for(const Et of be){if(!this.k.has(Et))throw new Error("`tokenModifier` is not in the provided legend");const kt=this.k.get(Et);lt|=1<<kt>>>0}this.n(je,Ke,_e,tt,lt)}n(F,ce,be,je,Ke){if(this.f&&(F<this.c||F===this.c&&ce<this.e)){this.f=!1;const lt=this.g.length/5|0;let Et=0,kt=0;for(let St=0;St<lt;St++){let Lt=this.g[5*St],Kt=this.g[5*St+1];Lt===0?(Lt=Et,Kt+=kt):Lt+=Et,this.g[5*St]=Lt,this.g[5*St+1]=Kt,Et=Lt,kt=Kt}}let _e=F,tt=ce;this.f&&this.h>0&&(_e-=this.c,_e===0&&(tt-=this.e)),this.g[this.h++]=_e,this.g[this.h++]=tt,this.g[this.h++]=be,this.g[this.h++]=je,this.g[this.h++]=Ke,this.c=F,this.e=ce}static o(F){const ce=[],be=F.length/5|0;for(let tt=0;tt<be;tt++)ce[tt]=tt;ce.sort((tt,lt)=>{const Et=F[5*tt],kt=F[5*lt];if(Et===kt){const St=F[5*tt+1],Lt=F[5*lt+1];return St-Lt}return Et-kt});const je=new Uint32Array(F.length);let Ke=0,_e=0;for(let tt=0;tt<be;tt++){const lt=5*ce[tt],Et=F[lt+0],kt=F[lt+1],St=F[lt+2],Lt=F[lt+3],Kt=F[lt+4],gi=Et-Ke,qi=gi===0?kt-_e:kt,Gt=5*tt;je[Gt+0]=gi,je[Gt+1]=qi,je[Gt+2]=St,je[Gt+3]=Lt,je[Gt+4]=Kt,Ke=Et,_e=kt}return je}build(F){return this.f?new En(new Uint32Array(this.g),F):new En(yn.o(this.g),F)}}e.$oL=yn;class En{constructor(F,ce){this.resultId=ce,this.data=F}}e.$pL=En;class yi{constructor(F,ce,be){this.start=F,this.deleteCount=ce,this.data=be}}e.$qL=yi;class Ei{constructor(F,ce){this.resultId=ce,this.edits=F}}e.$rL=Ei;var Wn;(function(M){M[M.Separate=0]="Separate",M[M.MergeWithParent=1]="MergeWithParent"})(Wn||(e.DebugConsoleMode=Wn={}));let Xt=class{constructor(){}};e.$sL=Xt,Xt.Back={iconPath:new At("arrow-left")},e.$sL=Xt=Oe([V],Xt);var Vn;(function(M){M[M.Separator=-1]="Separator",M[M.Default=0]="Default"})(Vn||(e.QuickPickItemKind=Vn={}));var Kn;(function(M){M[M.Info=1]="Info",M[M.Warning=2]="Warning",M[M.Error=3]="Error"})(Kn||(e.InputBoxValidationSeverity=Kn={}));var Gn;(function(M){M[M.UI=1]="UI",M[M.Workspace=2]="Workspace"})(Gn||(e.ExtensionKind=Gn={}));class ki{static validate(F){if(typeof F.badge=="string"){let ce=(0,I.$0e)(F.badge,0);if(ce<F.badge.length&&(ce+=(0,I.$0e)(F.badge,ce)),F.badge.length>ce)throw new Error("The 'badge'-property must be undefined or a short character")}else if(F.badge&&!At.isThemeIcon(F.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!F.color&&!F.badge&&!F.tooltip)throw new Error("The decoration is empty");return!0}constructor(F,ce,be){this.badge=F,this.tooltip=ce,this.color=be}}e.$tL=ki;let kn=class{constructor(F){this.kind=F}};e.$uL=kn,e.$uL=kn=Oe([V],kn);var Qn;(function(M){M[M.Light=1]="Light",M[M.Dark=2]="Dark",M[M.HighContrast=3]="HighContrast",M[M.HighContrastLight=4]="HighContrastLight"})(Qn||(e.ColorThemeKind=Qn={}));class Mt{static isNotebookRange(F){return F instanceof Mt?!0:F?typeof F.start=="number"&&typeof F.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(F,ce){if(F<0)throw(0,R.$5)("start must be positive");if(ce<0)throw(0,R.$5)("end must be positive");F<=ce?(this.c=F,this.e=ce):(this.c=ce,this.e=F)}with(F){let ce=this.c,be=this.e;return F.start!==void 0&&(ce=F.start),F.end!==void 0&&(be=F.end),ce===this.c&&be===this.e?this:new Mt(ce,be)}}e.$vL=Mt;class Yt{static validate(F){if(typeof F.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof F.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof F.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(F){return Array.isArray(F)&&F.every(ce=>Yt.isNotebookCellData(ce))}static isNotebookCellData(F){return!0}constructor(F,ce,be,je,Ke,_e,tt){this.kind=F,this.value=ce,this.languageId=be,this.mime=je,this.outputs=Ke??[],this.metadata=_e,this.executionSummary=tt,Yt.validate(this)}}e.$wL=Yt;class Di{constructor(F){this.cells=F}}e.$xL=Di;class Jn{static isNotebookCellOutputItem(F){return F instanceof h?!0:F?typeof F.mime=="string"&&F.data instanceof Uint8Array:!1}static error(F){const ce={name:F.name,message:F.message,stack:F.stack};return h.json(ce,"application/vnd.code.notebook.error")}static stdout(F){return h.text(F,"application/vnd.code.notebook.stdout")}static stderr(F){return h.text(F,"application/vnd.code.notebook.stderr")}static bytes(F,ce="application/octet-stream"){return new h(F,ce)}static text(F,ce=L.$Jr.text){const be=nt(h,h,"f",t).encode(String(F));return new h(be,ce)}static json(F,ce="text/x-json"){const be=JSON.stringify(F,void 0,"	");return h.text(be,ce)}constructor(F,ce){this.data=F,this.mime=ce;const be=(0,L.$Nr)(ce,!0);if(!be)throw new Error(`INVALID mime type: ${ce}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=be}}e.$yL=Jn,h=Jn,t={value:new TextEncoder};class Zt{static isNotebookCellOutput(F){return F instanceof Zt?!0:!F||typeof F!="object"?!1:typeof F.id=="string"&&Array.isArray(F.items)}static ensureUniqueMimeTypes(F,ce=!1){const be=new Set,je=new Set;for(let Ke=0;Ke<F.length;Ke++){const _e=F[Ke],tt=(0,L.$Nr)(_e.mime);if(!be.has(tt)||(0,g.$iI)(tt)){be.add(tt);continue}je.add(Ke),ce&&console.warn(`DUPLICATED mime type '${_e.mime}' will be dropped`)}return je.size===0?F:F.filter((Ke,_e)=>!je.has(_e))}constructor(F,ce,be){this.items=Zt.ensureUniqueMimeTypes(F,!0),typeof ce=="string"?(this.id=ce,this.metadata=be):(this.id=(0,C.$bg)(),this.metadata=ce??be)}}e.$zL=Zt;var Xn;(function(M){M[M.Markup=1]="Markup",M[M.Code=2]="Code"})(Xn||(e.NotebookCellKind=Xn={}));var Yn;(function(M){M[M.Idle=1]="Idle",M[M.Pending=2]="Pending",M[M.Executing=3]="Executing"})(Yn||(e.NotebookCellExecutionState=Yn={}));var Zn;(function(M){M[M.Left=1]="Left",M[M.Right=2]="Right"})(Zn||(e.NotebookCellStatusBarAlignment=Zn={}));var xn;(function(M){M[M.Default=0]="Default",M[M.InCenter=1]="InCenter",M[M.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",M[M.AtTop=3]="AtTop"})(xn||(e.NotebookEditorRevealType=xn={}));class Si{constructor(F,ce){this.text=F,this.alignment=ce}}e.$AL=Si;var _n;(function(M){M[M.Default=1]="Default",M[M.Preferred=2]="Preferred"})(_n||(e.NotebookControllerAffinity=_n={}));var ei;(function(M){M[M.Default=1]="Default",M[M.Preferred=2]="Preferred",M[M.Hidden=-1]="Hidden"})(ei||(e.NotebookControllerAffinity2=ei={}));class Ci{constructor(F,ce=[]){this.uri=F,this.provides=(0,y.$1b)(ce)}}e.$BL=Ci;class Pi{constructor(F){this.label=F}}e.$CL=Pi;let Dn=class{constructor(F,ce){this.label=F,this.timestamp=ce}};e.$DL=Dn,e.$DL=Dn=Oe([V],Dn);var ti;(function(M){M[M.Production=1]="Production",M[M.Development=2]="Development",M[M.Test=3]="Test"})(ti||(e.ExtensionMode=ti={}));var ni;(function(M){M[M.Node=1]="Node",M[M.Webworker=2]="Webworker"})(ni||(e.ExtensionRuntime=ni={}));var ii;(function(M){M[M.Other=0]="Other",M[M.Comment=1]="Comment",M[M.String=2]="String",M[M.RegEx=3]="RegEx"})(ii||(e.StandardTokenType=ii={}));class Ii{constructor(F,ce){this.ranges=F,this.wordPattern=ce}}e.$EL=Ii;class Ai{constructor(F){this.c=F}get autoForwardAction(){return this.c}}e.$FL=Ai;var si;(function(M){M[M.Queued=1]="Queued",M[M.Running=2]="Running",M[M.Passed=3]="Passed",M[M.Failed=4]="Failed",M[M.Skipped=5]="Skipped",M[M.Errored=6]="Errored"})(si||(e.TestResultState=si={}));var ri;(function(M){M[M.Run=1]="Run",M[M.Debug=2]="Debug",M[M.Coverage=3]="Coverage"})(ri||(e.TestRunProfileKind=ri={}));let Sn=class{constructor(F=void 0,ce=void 0,be=void 0,je=!1){this.include=F,this.exclude=ce,this.profile=be,this.continuous=je}};e.$GL=Sn,e.$GL=Sn=Oe([V],Sn);let Cn=x=class{static diff(F,ce,be){const je=new x(F);return je.expectedOutput=ce,je.actualOutput=be,je}constructor(F){this.message=F}};e.$HL=Cn,e.$HL=Cn=x=Oe([V],Cn);let Pn=class{constructor(F){this.id=F}};e.$IL=Pn,e.$IL=Pn=Oe([V],Pn);let Wt=class{constructor(F,ce){this.covered=F,this.total=ce}};e.$JL=Wt,e.$JL=Wt=Oe([V],Wt);let In=he=class{static fromDetails(F,ce){const be=new Wt(0,0),je=new Wt(0,0),Ke=new Wt(0,0);for(const tt of ce)if("branches"in tt){be.total+=1,be.covered+=tt.executionCount>0?1:0;for(const lt of tt.branches)je.total+=1,je.covered+=lt.executionCount>0?1:0}else Ke.total+=1,Ke.covered+=tt.executionCount>0?1:0;const _e=new he(F,be,je.total>0?je:void 0,Ke.total>0?Ke:void 0);return _e.detailedCoverage=ce,_e}constructor(F,ce,be,je){this.uri=F,this.statementCoverage=ce,this.branchCoverage=be,this.functionCoverage=je}};e.$KL=In,e.$KL=In=he=Oe([V],In);let An=class{constructor(F,ce,be=[]){this.executionCount=F,this.location=ce,this.branches=be}};e.$LL=An,e.$LL=An=Oe([V],An);let Ln=class{constructor(F,ce){this.executionCount=F,this.location=ce}};e.$ML=Ln,e.$ML=Ln=Oe([V],Ln);let Rn=class{constructor(F,ce){this.executionCount=F,this.location=ce}};e.$NL=Rn,e.$NL=Rn=Oe([V],Rn);var oi;(function(M){M[M.None=0]="None",M[M.Option=1]="Option",M[M.Default=2]="Default",M[M.Preferred=3]="Preferred"})(oi||(e.ExternalUriOpenerPriority=oi={}));var ai;(function(M){M[M.Untrusted=0]="Untrusted",M[M.Trusted=1]="Trusted",M[M.Unspecified=2]="Unspecified"})(ai||(e.WorkspaceTrustState=ai={}));var ci;(function(M){M[M.Notify=1]="Notify",M[M.OpenBrowser=2]="OpenBrowser",M[M.OpenPreview=3]="OpenPreview",M[M.Silent=4]="Silent",M[M.Ignore=5]="Ignore",M[M.OpenBrowserOnce=6]="OpenBrowserOnce"})(ci||(e.PortAutoForwardAction=ci={}));class Li{constructor(F,ce,be,je,Ke,_e){this.kind=F,this.name=ce,this.detail=be,this.uri=je,this.range=Ke,this.selectionRange=_e}}e.$OL=Li;class Ri{constructor(F){this.uri=F}}e.$PL=Ri;class Oi{constructor(F,ce){this.original=F,this.modified=ce}}e.$QL=Oi;class Ni{constructor(F,ce,be,je){this.base=F,this.input1=ce,this.input2=be,this.result=je}}e.$RL=Ni;class Fi{constructor(F,ce){this.uri=F,this.viewType=ce}}e.$SL=Fi;class Mi{constructor(F){this.viewType=F}}e.$TL=Mi;class ji{constructor(F,ce){this.uri=F,this.notebookType=ce}}e.$UL=ji;class Ti{constructor(F,ce,be){this.original=F,this.modified=ce,this.notebookType=be}}e.$VL=Ti;class Ui{constructor(){}}e.$WL=Ui;class Bi{constructor(F,ce){this.uri=F,this.inputBoxUri=ce}}e.$XL=Bi;var li;(function(M){M[M.Up=1]="Up",M[M.Down=2]="Down"})(li||(e.InteractiveSessionVoteDirection=li={}));var ui;(function(M){M[M.Action=1]="Action",M[M.Toolbar=2]="Toolbar"})(ui||(e.InteractiveSessionCopyKind=ui={}));var hi;(function(M){M[M.Unhelpful=0]="Unhelpful",M[M.Helpful=1]="Helpful",M[M.Undone=2]="Undone",M[M.Accepted=3]="Accepted"})(hi||(e.InteractiveEditorResponseFeedbackKind=hi={}));var fi;(function(M){M[M.System=0]="System",M[M.User=1]="User",M[M.Assistant=2]="Assistant",M[M.Function=3]="Function"})(fi||(e.ChatMessageRole=fi={}));var di;(function(M){M[M.Short=1]="Short",M[M.Medium=2]="Medium",M[M.Full=3]="Full"})(di||(e.ChatVariableLevel=di={}));class zi{constructor(F,ce){this.role=F,this.content=ce}}e.$YL=zi;var mi;(function(M){M[M.SymbolInformation=1]="SymbolInformation",M[M.CommandInformation=2]="CommandInformation",M[M.SearchInformation=3]="SearchInformation",M[M.SettingInformation=4]="SettingInformation"})(mi||(e.RelatedInformationType=mi={}))}),define(we[269],pe([1,0,6]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AM=void 0,e.$AM=(0,y.$Lh)("environmentVariableService")}),define(we[270],pe([1,0,7,4,59,3,248,8]),function(le,e,y,R,r,P,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0M=e.$9M=e.$8M=e.$7M=e.$6M=e.$5M=e.$4M=e.$3M=e.$2M=void 0;function w(h,t){if(t)if(P.$d)for(const s in t){let o=s;for(const n in h)if(s.toLowerCase()===n.toLowerCase()){o=n;break}const i=t[s];i!==void 0&&b(h,o,i)}else Object.keys(t).forEach(s=>{const o=t[s];o!==void 0&&b(h,s,o)})}e.$2M=w;function b(h,t,s){typeof s=="string"?h[t]=s:delete h[t]}function C(h,t,s,o){h.TERM_PROGRAM="vscode",t&&(h.TERM_PROGRAM_VERSION=t),d(h,o)&&(h.LANG=g(s)),h.COLORTERM="truecolor"}e.$3M=C;function E(h,t){if(t)for(const s of Object.keys(t)){const o=t[s];o!=null&&(h[s]=o)}}async function v(h,t){return await Promise.all(Object.entries(t).map(async([s,o])=>{if(typeof o=="string")try{t[s]=await h(o)}catch{t[s]=o}})),t}function d(h,t){if(t==="on")return!0;if(t==="auto"){const s=h.LANG;return!s||s.search(/\.UTF\-8$/)===-1&&s.search(/\.utf8$/)===-1&&s.search(/\.euc.+/)===-1}return!1}e.$4M=d;function g(h){const t=h?h.split("-"):[],s=t.length;if(s===0)return"en_US.UTF-8";if(s===1){const o={af:"ZA",am:"ET",be:"BY",bg:"BG",ca:"ES",cs:"CZ",da:"DK",de:"DE",el:"GR",en:"US",es:"ES",et:"EE",eu:"ES",fi:"FI",fr:"FR",he:"IL",hr:"HR",hu:"HU",hy:"AM",is:"IS",it:"IT",ja:"JP",kk:"KZ",ko:"KR",lt:"LT",nl:"NL",no:"NO",pl:"PL",pt:"BR",ro:"RO",ru:"RU",sk:"SK",sl:"SI",sr:"YU",sv:"SE",tr:"TR",uk:"UA",zh:"CN"};t[0]in o&&t.push(o[t[0]])}else t[1]=t[1].toUpperCase();return t.join("_")+".UTF-8"}e.$5M=g;async function m(h,t,s,o,i,n){if(h.cwd){const $=typeof h.cwd=="object"?h.cwd.fsPath:h.cwd,S=await l($,s);return(0,L.$ZM)(S||$)}let a;return!h.ignoreConfigurationCwd&&i&&(s&&(i=await l(i,s,n)),i&&(y.$gc(i)?a=i:o&&(a=y.$hc(o.fsPath,i)))),a||(a=o?o.fsPath:t||""),(0,L.$ZM)(a)}e.$6M=m;async function l(h,t,s){if(t)try{return await t(h)}catch(o){s?.error("Could not resolve terminal cwd",o);return}return h}function f(h,t,s){if(s)return o=>s.resolveWithEnvironment(t,h,o)}e.$7M=f;async function u(h,t,s,o,i,n){const a={};if(h.strictEnv)E(a,h.env);else{E(a,n);const $={...t};s&&($&&await v(s,$),h.env&&await v(s,h.env)),(0,r.$ul)(a,"VSCODE_IPC_HOOK_CLI","VSCODE_PROXY_URI"),w(a,$),w(a,h.env),C(a,o,P.$q,i)}return a}e.$8M=u;async function c(h,t,s,o,i,n,a=P.$d){let $;if((0,I.$wf)(h)?$=h:($=h.fsPath,a&&n!==1?$=$.replace(/\\/g,"/"):!a&&n===1&&($=$.replace(/\//g,"\\"))),!t)return $;const S=$.includes(" "),D=$.includes("(")||$.includes(")"),k=y.$lc(t,".exe"),A=k==="pwsh"||s==="pwsh"||k==="powershell"||s==="powershell";if(A&&(S||$.includes("'")))return`& '${$.replace(/'/g,"''")}'`;if(D&&A)return`& '${$}'`;if(n===1){if(o!==void 0)return o==="gitbash"?(0,L.$XM)($.replace(/\\/g,"/")):o==="wsl"?i?.getWslPath($,"win-to-unix")||$:S?`"${$}"`:$;const j=t.toLowerCase();return j.includes("wsl")||j.includes("bash.exe")&&!j.toLowerCase().includes("git")?i?.getWslPath($,"win-to-unix")||$:S?`"${$}"`:$}return(0,L.$XM)($)}e.$9M=c;function p(h,t,s){const o=typeof h=="string"?R.URI.parse(h):h;let i=o?t.getWorkspaceFolder(o)??void 0:void 0;if(!i){const n=s.getLastActiveWorkspaceRoot();i=n?t.getWorkspaceFolder(n)??void 0:void 0}return i}e.$0M=p}),define(we[71],pe([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2I=e.TestPosition=e.TestIdPathParts=void 0;var y;(function(P){P.Delimiter="\0"})(y||(e.TestIdPathParts=y={}));var R;(function(P){P[P.IsSame=0]="IsSame",P[P.Disconnected=1]="Disconnected",P[P.IsChild=2]="IsChild",P[P.IsParent=3]="IsParent"})(R||(e.TestPosition=R={}));class r{static fromExtHostTestItem(L,I,w=L.parent){if(L._isRoot)return new r([I]);const b=[L.id];for(let C=w;C&&C.id!==I;C=C.parent)b.push(C.id);return b.push(I),new r(b.reverse())}static isRoot(L){return!L.includes("\0")}static root(L){const I=L.indexOf("\0");return I===-1?L:L.slice(0,I)}static fromString(L){return new r(L.split("\0"))}static join(L,I){return new r([...L.path,I])}static joinToString(L,I){return L.toString()+"\0"+I}static parentId(L){const I=L.lastIndexOf("\0");return I===-1?void 0:L.slice(0,I)}static localId(L){const I=L.lastIndexOf("\0");return I===-1?L:L.slice(I+1)}static isChild(L,I){return I.startsWith(L)&&I[L.length]==="\0"}static compare(L,I){return L===I?0:r.isChild(L,I)?2:r.isChild(I,L)?3:1}constructor(L,I=L.length){if(this.path=L,this.d=I,L.length===0||I<1)throw new Error("cannot create test with empty path")}get rootId(){return new r(this.path,1)}get parentId(){return this.d>1?new r(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let L=1;L<=this.d;L++)yield new r(this.path,L)}*idsToRoot(){for(let L=this.d;L>0;L--)yield new r(this.path,L)}compare(L){if(typeof L=="string")return r.compare(this.toString(),L);for(let I=0;I<L.d&&I<this.d;I++)if(L.path[I]!==this.path[I])return 1;return L.d>this.d?2:L.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let L=1;L<this.d;L++)this.c+="\0",this.c+=this.path[L]}return this.c}}e.$2I=r}),define(we[92],pe([1,0,4,43,71]),function(le,e,y,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9I=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.$8I=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$7I=e.$6I=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$5I=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$4I=e.$3I=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var P;(function(S){S[S.Unset=0]="Unset",S[S.Queued=1]="Queued",S[S.Running=2]="Running",S[S.Passed=3]="Passed",S[S.Failed=4]="Failed",S[S.Skipped=5]="Skipped",S[S.Errored=6]="Errored"})(P||(e.TestResultState=P={}));var L;(function(S){S[S.Run=1]="Run",S[S.Debug=2]="Debug",S[S.Coverage=3]="Coverage"})(L||(e.ExtTestRunProfileKind=L={}));var I;(function(S){S[S.Run=2]="Run",S[S.Debug=4]="Debug",S[S.Coverage=8]="Coverage",S[S.HasNonDefaultProfile=16]="HasNonDefaultProfile",S[S.HasConfigurable=32]="HasConfigurable",S[S.SupportsContinuousRun=64]="SupportsContinuousRun"})(I||(e.TestRunProfileBitset=I={})),e.$3I=[2,4,8,16,32,64];const w=S=>"runId"in S;e.$4I=w;var b;(function(S){S.serialize=D=>({range:D.range.toJSON(),uri:D.uri.toJSON()}),S.deserialize=D=>({range:R.$ms.lift(D.range),uri:y.URI.revive(D.uri)})})(b||(e.IRichLocation=b={}));var C;(function(S){S[S.Error=0]="Error",S[S.Output=1]="Output"})(C||(e.TestMessageType=C={}));var E;(function(S){S.serialize=D=>({message:D.message,type:0,expected:D.expected,actual:D.actual,contextValue:D.contextValue,location:D.location&&b.serialize(D.location)}),S.deserialize=D=>({message:D.message,type:0,expected:D.expected,actual:D.actual,contextValue:D.contextValue,location:D.location&&b.deserialize(D.location)})})(E||(e.ITestErrorMessage=E={}));const v=(S,D)=>`${D?"s":"e"}${S}`;e.$5I=v;var d;(function(S){S.serialize=D=>({message:D.message,type:1,offset:D.offset,length:D.length,location:D.location&&b.serialize(D.location)}),S.deserialize=D=>({message:D.message,type:1,offset:D.offset,length:D.length,location:D.location&&b.deserialize(D.location)})})(d||(e.ITestOutputMessage=d={}));var g;(function(S){S.serialize=D=>D.type===0?E.serialize(D):d.serialize(D),S.deserialize=D=>D.type===0?E.deserialize(D):d.deserialize(D)})(g||(e.ITestMessage=g={}));var m;(function(S){S.serializeWithoutMessages=D=>({state:D.state,duration:D.duration,messages:[]}),S.serialize=D=>({state:D.state,duration:D.duration,messages:D.messages.map(g.serialize)}),S.deserialize=D=>({state:D.state,duration:D.duration,messages:D.messages.map(g.deserialize)})})(m||(e.ITestTaskState=m={}));const l="\0",f=(S,D)=>S+l+D;e.$6I=f;const u=S=>{const D=S.indexOf(l);return{ctrlId:S.slice(0,D),tagId:S.slice(D+1)}};e.$7I=u;var c;(function(S){S.serialize=D=>({extId:D.extId,label:D.label,tags:D.tags,busy:D.busy,children:void 0,uri:D.uri?.toJSON(),range:D.range?.toJSON()||null,description:D.description,error:D.error,sortText:D.sortText}),S.deserialize=D=>({extId:D.extId,label:D.label,tags:D.tags,busy:D.busy,children:void 0,uri:D.uri?y.URI.revive(D.uri):void 0,range:D.range?R.$ms.lift(D.range):null,description:D.description,error:D.error,sortText:D.sortText})})(c||(e.ITestItem=c={}));var p;(function(S){S[S.NotExpandable=0]="NotExpandable",S[S.Expandable=1]="Expandable",S[S.BusyExpanding=2]="BusyExpanding",S[S.Expanded=3]="Expanded"})(p||(e.TestItemExpandState=p={}));var h;(function(S){S.serialize=D=>({expand:D.expand,item:c.serialize(D.item)}),S.deserialize=D=>({controllerId:r.$2I.root(D.item.extId),expand:D.expand,item:c.deserialize(D.item)})})(h||(e.InternalTestItem=h={}));var t;(function(S){S.serialize=D=>{let k;return D.item&&(k={},D.item.label!==void 0&&(k.label=D.item.label),D.item.tags!==void 0&&(k.tags=D.item.tags),D.item.busy!==void 0&&(k.busy=D.item.busy),D.item.uri!==void 0&&(k.uri=D.item.uri?.toJSON()),D.item.range!==void 0&&(k.range=D.item.range?.toJSON()),D.item.description!==void 0&&(k.description=D.item.description),D.item.error!==void 0&&(k.error=D.item.error),D.item.sortText!==void 0&&(k.sortText=D.item.sortText)),{extId:D.extId,expand:D.expand,item:k}},S.deserialize=D=>{let k;return D.item&&(k={},D.item.label!==void 0&&(k.label=D.item.label),D.item.tags!==void 0&&(k.tags=D.item.tags),D.item.busy!==void 0&&(k.busy=D.item.busy),D.item.range!==void 0&&(k.range=D.item.range?R.$ms.lift(D.item.range):null),D.item.description!==void 0&&(k.description=D.item.description),D.item.error!==void 0&&(k.error=D.item.error),D.item.sortText!==void 0&&(k.sortText=D.item.sortText)),{extId:D.extId,expand:D.expand,item:k}}})(t||(e.ITestItemUpdate=t={}));const s=(S,D)=>{D.expand!==void 0&&(S.expand=D.expand),D.item!==void 0&&(S.item=S.item?Object.assign(S.item,D.item):D.item)};e.$8I=s;var o;(function(S){S.serializeWithoutMessages=D=>({...h.serialize(D),ownComputedState:D.ownComputedState,computedState:D.computedState,tasks:D.tasks.map(m.serializeWithoutMessages)}),S.serialize=D=>({...h.serialize(D),ownComputedState:D.ownComputedState,computedState:D.computedState,tasks:D.tasks.map(m.serialize)}),S.deserialize=D=>({...h.deserialize(D),ownComputedState:D.ownComputedState,computedState:D.computedState,tasks:D.tasks.map(m.deserialize),retired:!0})})(o||(e.TestResultItem=o={}));var i;(function(S){S[S.Function=0]="Function",S[S.Statement=1]="Statement"})(i||(e.DetailType=i={}));var n;(function(S){S[S.Add=0]="Add",S[S.Update=1]="Update",S[S.DocumentSynced=2]="DocumentSynced",S[S.Remove=3]="Remove",S[S.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",S[S.Retire=5]="Retire",S[S.AddTag=6]="AddTag",S[S.RemoveTag=7]="RemoveTag"})(n||(e.TestDiffOpType=n={}));var a;(function(S){S.deserialize=D=>D.op===0?{op:D.op,item:h.deserialize(D.item)}:D.op===1?{op:D.op,item:t.deserialize(D.item)}:D.op===2?{op:D.op,uri:y.URI.revive(D.uri),docv:D.docv}:D,S.serialize=D=>D.op===0?{op:D.op,item:h.serialize(D.item)}:D.op===1?{op:D.op,item:t.serialize(D.item)}:D})(a||(e.TestsDiffOp=a={}));class ${constructor(){this.d=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.d}apply(D){const k=this.p();for(const A of D)switch(A.op){case 0:this.k(h.deserialize(A.item),k);break;case 1:this.l(t.deserialize(A.item),k);break;case 3:this.m(A.itemId,k);break;case 5:this.o(A.itemId);break;case 4:this.updatePendingRoots(A.amount);break;case 6:this.d.set(A.tag.id,A.tag);break;case 7:this.d.delete(A.id);break}k.complete?.()}k(D,k){const A=r.$2I.parentId(D.item.extId)?.toString();let j;if(!A)j=this.q(D),this.g.add(j),this.f.set(D.item.extId,j);else if(this.f.has(A)){const Z=this.f.get(A);Z.children.add(D.item.extId),j=this.q(D,Z),this.f.set(D.item.extId,j)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(D)}`);return}return k.add?.(j),D.expand===2&&this.h++,j}l(D,k){const A=this.f.get(D.extId);if(A)return D.expand!==void 0&&(A.expand===2&&this.h--,D.expand===2&&this.h++),(0,e.$8I)(A,D),k.update?.(A),A}m(D,k){const A=this.f.get(D);if(!A)return;const j=r.$2I.parentId(A.item.extId)?.toString();j?this.f.get(j).children.delete(A.item.extId):this.g.delete(A);const Z=[[D]];for(;Z.length;)for(const ae of Z.pop()){const K=this.f.get(ae);K&&(Z.push(K.children),this.f.delete(ae),k.remove?.(K,K!==A),K.expand===2&&this.h--)}}o(D){}updatePendingRoots(D){this.j+=D}p(){return{}}}e.$9I=$}),define(we[132],pe([1,0,14,5,2,95,92,71]),function(le,e,y,R,r,P,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4L=e.$3L=e.$2L=e.$1L=e.$ZL=e.TestItemEventOp=void 0;var w;(function(u){u[u.Upsert=0]="Upsert",u[u.SetTags=1]="SetTags",u[u.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",u[u.RemoveChild=3]="RemoveChild",u[u.SetProp=4]="SetProp",u[u.Bulk=5]="Bulk",u[u.DocumentSynced=6]="DocumentSynced"})(w||(e.TestItemEventOp=w={}));const b=(u,c)=>u===c,E=Object.entries({range:(u,c)=>u===c?!0:!u||!c?!1:u.equalsRange(c),busy:b,label:b,description:b,error:b,sortText:b,tags:(u,c)=>!(u.length!==c.length||u.some(p=>!c.includes(p)))}),v=(u,c)=>{let p;for(const[h,t]of E)t(u[h],c[h])||(p?p[h]=c[h]:p={[h]:c[h]});return p};class d extends r.$Qc{get root(){return this.s.root}constructor(c){super(),this.s=c,this.f=this.B(new y.$3g(()=>this.flushDiff(),200)),this.g=this.B(new R.$Ld),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.y(this.root,void 0)}set resolveHandler(c){this.h=c;for(const p of this.tree.values())this.I(p)}get resolveHandler(){return this.h}collectDiff(){const c=this.m;return this.m=[],c}pushDiff(c){switch(c.op){case 2:{for(const p of this.m)if(p.op===2&&p.uri===c.uri){p.docv=c.docv;return}break}case 1:{const p=this.m[this.m.length-1];if(p){if(p.op===1&&p.item.extId===c.item.extId){(0,L.$8I)(p.item,c.item);return}if(p.op===0&&p.item.item.extId===c.item.extId){(0,L.$8I)(p.item,c.item);return}}break}}this.m.push(c),this.f.isScheduled()||this.f.schedule()}expand(c,p){const h=this.tree.get(c);if(h){if((h.expandLevels===void 0||p>h.expandLevels)&&(h.expandLevels=p),h.expand===1){const t=this.L(h);return t.isOpen()?this.J(h,p-1):t.wait().then(()=>this.J(h,p-1))}else if(h.expand===3)return h.resolveBarrier?.isOpen()===!1?h.resolveBarrier.wait().then(()=>this.J(h,p-1)):this.J(h,p-1)}}dispose(){for(const c of this.tree.values())this.s.getApiFor(c.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}u(c,p){switch(p.op){case 3:this.N(I.$2I.joinToString(c.fullId,p.id));break;case 0:this.y(p.item,c);break;case 5:for(const h of p.ops)this.u(c,h);break;case 1:this.z(p.new,p.old,c.fullId.toString());break;case 2:this.I(c);break;case 4:this.pushDiff({op:1,item:{extId:c.fullId.toString(),item:p.update}});break;case 6:this.w(c.actual.uri);break;default:(0,P.$2c)(p)}}w(c){c&&this.pushDiff({op:2,uri:c,docv:this.s.getDocumentVersion(c)})}y(c,p){const h=I.$2I.fromExtHostTestItem(c,this.root.id,p?.actual),t=this.s.getApiFor(c);t.parent&&t.parent!==p?.actual&&this.s.getChildren(t.parent).delete(c.id);let s=this.tree.get(h.toString());if(!s){s={fullId:h,actual:c,expandLevels:p?.expandLevels?p.expandLevels-1:void 0,expand:0},c.tags.forEach(this.C,this),this.tree.set(s.fullId.toString(),s),this.F(c,p),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:s.expand,item:this.s.toITestItem(c)}}),this.H(c,s,p);return}if(s.actual===c){this.G(c,s,p);return}if(s.actual.uri?.toString()!==c.uri?.toString())return this.N(h.toString()),this.y(c,p);const o=this.s.getChildren(s.actual),i=s.actual,n=v(this.s.toITestItem(i),this.s.toITestItem(c));this.s.getApiFor(i).listener=void 0,s.actual=c,s.expand=0,n&&(n.hasOwnProperty("tags")&&(this.z(c.tags,i.tags,h.toString()),delete n.tags),this.u(s,{op:4,update:n})),this.H(c,s,p);for(const[a,$]of o)this.s.getChildren(c).get($.id)||this.N(I.$2I.joinToString(h,$.id));this.w(s.actual.uri)}z(c,p,h){const t=new Set(p.map(s=>s.id));for(const s of c)t.delete(s.id)||this.C(s);this.pushDiff({op:1,item:{extId:h,item:{tags:c.map(s=>(0,L.$6I)(this.s.controllerId,s.id))}}}),t.forEach(this.D,this)}C(c){const p=this.j.get(c.id);p?p.refCount++:(this.j.set(c.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,L.$6I)(this.s.controllerId,c.id)}}))}D(c){const p=this.j.get(c);p&&!--p.refCount&&(this.j.delete(c),this.pushDiff({op:7,id:(0,L.$6I)(this.s.controllerId,c)}))}F(c,p){this.s.getApiFor(c).parent=p&&p.actual!==this.root?p.actual:void 0}G(c,p,h){this.F(c,h);const t=this.s.getApiFor(c);t.parent=h?.actual,t.listener=s=>this.u(p,s),this.I(p)}H(c,p,h){this.G(c,p,h);for(const[t,s]of this.s.getChildren(c))this.y(s,p)}I(c){let p;this.h?c.resolveBarrier?p=c.resolveBarrier.isOpen()?3:2:p=c.actual.canResolveChildren?1:0:p=0,p!==c.expand&&(c.expand=p,this.pushDiff({op:1,item:{extId:c.fullId.toString(),expand:p}}),p===1&&c.expandLevels!==void 0&&this.L(c))}J(c,p){if(p<0)return;const h=[];for(const[t,s]of this.s.getChildren(c.actual)){const o=this.expand(I.$2I.joinToString(c.fullId,s.id),p);(0,y.$Dg)(o)&&h.push(o)}if(h.length)return Promise.all(h).then(()=>{})}L(c){if(c.resolveBarrier)return c.resolveBarrier;if(!this.h){const s=new y.$Pg;return s.open(),s}c.expand=2,this.M(c);const p=c.resolveBarrier=new y.$Pg,h=s=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,s)};let t;try{t=this.h(c.actual===this.root?void 0:c.actual)}catch(s){h(s)}return(0,y.$Dg)(t)?t.catch(h).then(()=>{p.open(),this.I(c)}):(p.open(),this.I(c)),c.resolveBarrier}M(c){this.pushDiff({op:1,item:{extId:c.fullId.toString(),expand:c.expand}})}N(c){const p=this.tree.get(c);if(!p)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:c});const h=[p];for(;h.length;){const t=h.pop();if(t){this.s.getApiFor(t.actual).listener=void 0;for(const s of t.actual.tags)this.D(s.id);this.tree.delete(t.fullId.toString());for(const[s,o]of this.s.getChildren(t.actual))h.push(this.tree.get(I.$2I.joinToString(t.fullId,o.id)))}}}flushDiff(){const c=this.collectDiff();c.length&&this.g.fire(c)}}e.$ZL=d;class g extends Error{constructor(c){super(`Attempted to insert a duplicate test item ID ${c}`)}}e.$1L=g;class m extends Error{constructor(c){super(`TestItem with ID "${c}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$2L=m;class l extends Error{constructor(c,p,h){super(`TestItem with ID "${c}" is from controller "${p}" and cannot be added as a child of an item from controller "${h}".`)}}e.$3L=l;const f=(u,c,p)=>{let h=new Map;return{get size(){return h.size},forEach(t,s){for(const o of h.values())t.call(s,o,this)},[Symbol.iterator](){return h.entries()},replace(t){const s=new Map,o=new Set(h.keys()),i={op:5,ops:[]};for(const n of t){if(!(n instanceof p))throw new m(n.id);const a=c(n).controllerId;if(a!==u.controllerId)throw new l(n.id,a,u.controllerId);if(s.has(n.id))throw new g(n.id);s.set(n.id,n),o.delete(n.id),i.ops.push({op:0,item:n})}for(const n of o.keys())i.ops.push({op:3,id:n});u.listener?.(i),h=s},add(t){if(!(t instanceof p))throw new m(t.id);h.set(t.id,t),u.listener?.({op:0,item:t})},delete(t){h.delete(t)&&u.listener?.({op:3,id:t})},get(t){return h.get(t)},toJSON(){return Array.from(h.values())}}};e.$4L=f}),define(we[133],pe([1,0,132]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6L=e.$5L=void 0;const R=new WeakMap,r=(L,I)=>{const w={controllerId:I};return R.set(L,w),w};e.$5L=r;const P=L=>{const I=R.get(L);if(!I)throw new y.$2L(L?.id||"<unknown>");return I};e.$6L=P}),define(we[271],pe([1,0,24,6]),function(le,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sD=e.$rD=e.$qD=e.$pD=e.$oD=e.$nD=e.$mD=e.$lD=e.$kD=e.$jD=e.$iD=e.$hD=e.$gD=e.$fD=e.$eD=e.$dD=e.$cD=e.$bD=e.$aD=e.$_C=e.$$C=e.$0C=e.$9C=e.$8C=e.$7C=void 0,e.$7C=".vscode",e.$8C="settings",e.$9C=`${e.$7C}/${e.$8C}.json`,e.$0C="vscode://schemas/settings/default",e.$$C="vscode://schemas/settings/user",e.$_C="vscode://schemas/settings/profile",e.$aD="vscode://schemas/settings/machine",e.$bD="vscode://schemas/settings/workspace",e.$cD="vscode://schemas/settings/folder",e.$dD="vscode://schemas/launch",e.$eD="vscode://schemas/tasks",e.$fD=[1],e.$gD=[2,3,4,5,6],e.$hD=[3,4,5],e.$iD=[1,...e.$hD],e.$jD=[2,3,4,5,6],e.$kD=[3,4,5,6],e.$lD=[4,5,6],e.$mD="tasks",e.$nD="launch",e.$oD=Object.create(null),e.$oD[e.$mD]=`${e.$7C}/${e.$mD}.json`,e.$oD[e.$nD]=`${e.$7C}/${e.$nD}.json`,e.$pD=Object.create(null),e.$pD[e.$mD]=`${e.$mD}.json`,e.$qD=(0,R.$Mh)(y.$fi),e.$rD=`{
	"version": "2.0.0",
	"tasks": []
}`,e.$sD="workbench.settings.applyToAllProfiles"}),define(we[134],pe([1,0,6]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WM=e.VariableKind=e.$VM=void 0,e.$VM=(0,y.$Lh)("configurationResolverService");var R;(function(P){P.Unknown="unknown",P.Env="env",P.Config="config",P.Command="command",P.Input="input",P.ExtensionInstallFolder="extensionInstallFolder",P.WorkspaceFolder="workspaceFolder",P.Cwd="cwd",P.WorkspaceFolderBasename="workspaceFolderBasename",P.UserHome="userHome",P.LineNumber="lineNumber",P.SelectedText="selectedText",P.File="file",P.FileWorkspaceFolder="fileWorkspaceFolder",P.RelativeFile="relativeFile",P.RelativeFileDirname="relativeFileDirname",P.FileDirname="fileDirname",P.FileExtname="fileExtname",P.FileBasename="fileBasename",P.FileBasenameNoExtension="fileBasenameNoExtension",P.FileDirnameBasename="fileDirnameBasename",P.ExecPath="execPath",P.ExecInstallFolder="execInstallFolder",P.PathSeparator="pathSeparator"})(R||(e.VariableKind=R={}));class r extends Error{constructor(L,I){super(I),this.variable=L}}e.$WM=r}),define(we[272],pe([1,0,7,28,8,22,3,152,203,134,17]),function(le,e,y,R,r,P,L,I,w,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$M=void 0;class E{constructor(d,g,m,l){this.h=new Map,this.a=d,this.b=g,this.g=m,l&&(this.c=l.then(f=>this.i(f)))}i(d){if(L.$d){const g=Object.create(null);return Object.keys(d).forEach(m=>{g[m.toLowerCase()]=d[m]}),g}return d}resolveWithEnvironment(d,g,m){return this.l({env:this.i(d),userHome:void 0},g?g.uri:void 0,m)}async resolveAsync(d,g){const m={env:await this.c,userHome:await this.g};return this.l(m,d?d.uri:void 0,g)}async j(d,g,m,l){const f=P.$Xm(g);L.$d&&f.windows?Object.keys(f.windows).forEach(c=>f[c]=f.windows[c]):L.$e&&f.osx?Object.keys(f.osx).forEach(c=>f[c]=f.osx[c]):L.$f&&f.linux&&Object.keys(f.linux).forEach(c=>f[c]=f.linux[c]),delete f.windows,delete f.osx,delete f.linux;const u={env:await this.c,userHome:await this.g};return this.l(u,d?d.uri:void 0,f,m,l)}async resolveAnyAsync(d,g,m){return this.j(d,g,m)}async resolveAnyMap(d,g,m){const l=new Map;return{newConfig:await this.j(d,g,m,l),resolvedVariables:l}}resolveWithInteractionReplace(d,g,m,l){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(d,g,m,l){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(d,g){if(this.h.has(d))throw new Error("Variable "+d+" is contributed twice.");this.h.set(d,g)}async l(d,g,m,l,f){if(r.$wf(m))return this.m(d,g,m,l,f);if(Array.isArray(m))return Promise.all(m.map(u=>this.l(d,g,u,l,f)));if(r.$yf(m)){const u=Object.create(null),c=await Promise.all(Object.keys(m).map(async p=>[await this.m(d,g,p,l,f),await this.l(d,g,m[p],l,f)]));for(const[p,h]of c)u[p]=h;return u}return m}m(d,g,m,l,f){return(0,C.$Re)(m,E.VARIABLE_REGEXP,async(u,c)=>{if(c.includes(E.VARIABLE_LHS))return u;let p=await this.o(d,u,c,g,l);return f?.set(c,p),p!==u&&r.$wf(p)&&p.match(E.VARIABLE_REGEXP)&&(p=await this.m(d,g,p,l,f)),p})}n(d){return this.b?this.b.getUriLabel(d,{noPrefix:!0}):d.fsPath}async o(d,g,m,l,f){let u;const c=m.split(":");c.length>1&&(m=c[0],u=c[1]);const p=s=>{const o=this.a.getFilePath();if(o)return(0,I.$kv)(o);throw new b.$WM(s,(0,w.localize)(0,null,g))},h=s=>{const o=p(s);if(this.a.getWorkspaceFolderPathForFile){const i=this.a.getWorkspaceFolderPathForFile();if(i)return(0,I.$kv)(i)}throw new b.$WM(s,(0,w.localize)(1,null,g,y.$lc(o)))},t=s=>{if(u){const o=this.a.getFolderUri(u);if(o)return o;throw new b.$WM(s,(0,w.localize)(2,null,g,u))}if(l)return l;throw this.a.getWorkspaceFolderCount()>1?new b.$WM(s,(0,w.localize)(3,null,g)):new b.$WM(s,(0,w.localize)(4,null,g))};switch(m){case"env":if(u){if(d.env){const s=d.env[L.$d?u.toLowerCase():u];if(r.$wf(s))return s}return""}throw new b.$WM(b.VariableKind.Env,(0,w.localize)(5,null,g));case"config":if(u){const s=this.a.getConfigurationValue(l,u);if(r.$Ff(s))throw new b.$WM(b.VariableKind.Config,(0,w.localize)(6,null,g,u));if(r.$yf(s))throw new b.$WM(b.VariableKind.Config,(0,w.localize)(7,null,g,u));return s}throw new b.$WM(b.VariableKind.Config,(0,w.localize)(8,null,g));case"command":return this.p(b.VariableKind.Command,g,u,f,"command");case"input":return this.p(b.VariableKind.Input,g,u,f,"input");case"extensionInstallFolder":if(u){const s=await this.a.getExtension(u);if(!s)throw new b.$WM(b.VariableKind.ExtensionInstallFolder,(0,w.localize)(9,null,g,u));return this.n(s.extensionLocation)}throw new b.$WM(b.VariableKind.ExtensionInstallFolder,(0,w.localize)(10,null,g));default:switch(m){case"workspaceRoot":case"workspaceFolder":return(0,I.$kv)(this.n(t(b.VariableKind.WorkspaceFolder)));case"cwd":return l||u?(0,I.$kv)(this.n(t(b.VariableKind.Cwd))):R.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,I.$kv)(y.$lc(this.n(t(b.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(d.userHome)return d.userHome;throw new b.$WM(b.VariableKind.UserHome,(0,w.localize)(11,null,g))}case"lineNumber":{const s=this.a.getLineNumber();if(s)return s;throw new b.$WM(b.VariableKind.LineNumber,(0,w.localize)(12,null,g))}case"selectedText":{const s=this.a.getSelectedText();if(s)return s;throw new b.$WM(b.VariableKind.SelectedText,(0,w.localize)(13,null,g))}case"file":return p(b.VariableKind.File);case"fileWorkspaceFolder":return h(b.VariableKind.FileWorkspaceFolder);case"relativeFile":return l||u?y.$jc(this.n(t(b.VariableKind.RelativeFile)),p(b.VariableKind.RelativeFile)):p(b.VariableKind.RelativeFile);case"relativeFileDirname":{const s=y.$kc(p(b.VariableKind.RelativeFileDirname));if(l||u){const o=y.$jc(this.n(t(b.VariableKind.RelativeFileDirname)),s);return o.length===0?".":o}return s}case"fileDirname":return y.$kc(p(b.VariableKind.FileDirname));case"fileExtname":return y.$mc(p(b.VariableKind.FileExtname));case"fileBasename":return y.$lc(p(b.VariableKind.FileBasename));case"fileBasenameNoExtension":{const s=y.$lc(p(b.VariableKind.FileBasenameNoExtension));return s.slice(0,s.length-y.$mc(s).length)}case"fileDirnameBasename":return y.$lc(y.$kc(p(b.VariableKind.FileDirnameBasename)));case"execPath":{const s=this.a.getExecPath();return s||g}case"execInstallFolder":{const s=this.a.getAppRoot();return s||g}case"pathSeparator":return y.sep;default:try{const s=u?`${m}:${u}`:m;return this.p(b.VariableKind.Unknown,g,s,f,void 0)}catch{return g}}}}p(d,g,m,l,f){if(m&&l){const u=f===void 0?l[m]:l[f+":"+m];if(typeof u=="string")return u;throw new b.$WM(d,(0,w.localize)(14,null,g))}return g}}e.$$M=E,E.VARIABLE_LHS="${",E.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(we[273],pe([1,0,6,91]),function(le,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_B=e.$$B=e.OpenEditorContext=e.GroupsOrder=e.$0B=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$9B=void 0,e.$9B=(0,y.$Lh)("editorGroupsService");var r;(function(g){g[g.UP=0]="UP",g[g.DOWN=1]="DOWN",g[g.LEFT=2]="LEFT",g[g.RIGHT=3]="RIGHT"})(r||(e.GroupDirection=r={}));var P;(function(g){g[g.HORIZONTAL=0]="HORIZONTAL",g[g.VERTICAL=1]="VERTICAL"})(P||(e.GroupOrientation=P={}));var L;(function(g){g[g.FIRST=0]="FIRST",g[g.LAST=1]="LAST",g[g.NEXT=2]="NEXT",g[g.PREVIOUS=3]="PREVIOUS"})(L||(e.GroupLocation=L={}));var I;(function(g){g[g.MAXIMIZE=0]="MAXIMIZE",g[g.EVEN=1]="EVEN",g[g.TOGGLE=2]="TOGGLE"})(I||(e.GroupsArrangement=I={}));var w;(function(g){g[g.COPY_EDITORS=0]="COPY_EDITORS",g[g.MOVE_EDITORS=1]="MOVE_EDITORS"})(w||(e.MergeGroupMode=w={}));function b(g){const m=g;return(0,R.$YD)(m?.editor)&&(0,R.$YD)(m?.replacement)}e.$0B=b;var C;(function(g){g[g.CREATION_TIME=0]="CREATION_TIME",g[g.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",g[g.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(C||(e.GroupsOrder=C={}));var E;(function(g){g[g.NEW_EDITOR=1]="NEW_EDITOR",g[g.MOVE_EDITOR=2]="MOVE_EDITOR",g[g.COPY_EDITOR=3]="COPY_EDITOR"})(E||(e.OpenEditorContext=E={}));function v(g){const m=g;return!!m&&typeof m.id=="number"&&Array.isArray(m.editors)}e.$$B=v;function d(g){return g.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.$_B=d}),define(we[135],pe([1,0,6,273]),function(le,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dC=e.$cC=e.$bC=e.$aC=void 0,e.$aC=(0,y.$Lh)("editorService"),e.$bC=-1,e.$cC=-2;function r(P){const L=P;return typeof P=="number"||(0,R.$$B)(L)}e.$dC=r}),define(we[136],pe([1,0,18,15,153,74,100,26,143,50,58,22,8,4,43,171,226,133,91,130,71,92,135,131]),function(le,e,y,R,r,P,L,I,w,b,C,E,v,d,g,m,l,f,u,c,p,h,t,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalQuickFix=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.ChatMessageRole=e.ChatMessage=e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.$9L=e.$8L=e.MarkdownString=e.$7L=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var o;(function(ye){function De(Y){const{selectionStartLineNumber:Ce,selectionStartColumn:Re,positionLineNumber:Ve,positionColumn:Te}=Y,Xe=new s.$_J(Ce-1,Re-1),at=new s.$_J(Ve-1,Te-1);return new s.$bK(Xe,at)}ye.to=De;function fe(Y){const{anchor:Ce,active:Re}=Y;return{selectionStartLineNumber:Ce.line+1,selectionStartColumn:Ce.character+1,positionLineNumber:Re.line+1,positionColumn:Re.character+1}}ye.from=fe})(o||(e.Selection=o={}));var i;(function(ye){function De(Y){if(!Y)return;const{start:Ce,end:Re}=Y;return{startLineNumber:Ce.line+1,startColumn:Ce.character+1,endLineNumber:Re.line+1,endColumn:Re.character+1}}ye.from=De;function fe(Y){if(!Y)return;const{startLineNumber:Ce,startColumn:Re,endLineNumber:Ve,endColumn:Te}=Y;return new s.$aK(Ce-1,Re-1,Ve-1,Te-1)}ye.to=fe})(i||(e.Range=i={}));var n;(function(ye){function De(fe){switch(fe){case 1:return s.StandardTokenType.Comment;case 0:return s.StandardTokenType.Other;case 3:return s.StandardTokenType.RegEx;case 2:return s.StandardTokenType.String}}ye.to=De})(n||(e.TokenType=n={}));var a;(function(ye){function De(Y){return new s.$_J(Y.lineNumber-1,Y.column-1)}ye.to=De;function fe(Y){return{lineNumber:Y.line+1,column:Y.character+1}}ye.from=fe})(a||(e.Position=a={}));var $;(function(ye){function De(Ce,Re,Ve){return(0,y.$Fb)((0,y.$1b)(Ce).map(Te=>fe(Te,Re,Ve)))}ye.from=De;function fe(Ce,Re,Ve){if(typeof Ce=="string")return{$serialized:!0,language:Ce,isBuiltin:Ve?.isBuiltin};if(Ce)return{$serialized:!0,language:Ce.language,scheme:Y(Ce.scheme,Re),pattern:Le.from(Ce.pattern)??void 0,exclusive:Ce.exclusive,notebookType:Ce.notebookType,isBuiltin:Ve?.isBuiltin}}function Y(Ce,Re){return Re&&typeof Ce=="string"?Re.transformOutgoingScheme(Ce):Ce}})($||(e.DocumentSelector=$={}));var S;(function(ye){function De(Y){switch(Y){case s.DiagnosticTag.Unnecessary:return 1;case s.DiagnosticTag.Deprecated:return 2}}ye.from=De;function fe(Y){switch(Y){case 1:return s.DiagnosticTag.Unnecessary;case 2:return s.DiagnosticTag.Deprecated;default:return}}ye.to=fe})(S||(e.DiagnosticTag=S={}));var D;(function(ye){function De(Y){let Ce;return Y.code&&((0,v.$wf)(Y.code)||(0,v.$Af)(Y.code)?Ce=String(Y.code):Ce={value:String(Y.code.value),target:Y.code.target}),{...i.from(Y.range),message:Y.message,source:Y.source,code:Ce,severity:A.from(Y.severity),relatedInformation:Y.relatedInformation&&Y.relatedInformation.map(k.from),tags:Array.isArray(Y.tags)?(0,y.$Fb)(Y.tags.map(S.from)):void 0}}ye.from=De;function fe(Y){const Ce=new s.$mK(i.to(Y),Y.message,A.to(Y.severity));return Ce.source=Y.source,Ce.code=(0,v.$wf)(Y.code)?Y.code:Y.code?.value,Ce.relatedInformation=Y.relatedInformation&&Y.relatedInformation.map(k.to),Ce.tags=Y.tags&&(0,y.$Fb)(Y.tags.map(S.to)),Ce}ye.to=fe})(D||(e.Diagnostic=D={}));var k;(function(ye){function De(Y){return{...i.from(Y.location.range),message:Y.message,resource:Y.location.uri}}ye.from=De;function fe(Y){return new s.$lK(new s.$kK(Y.resource,i.to(Y)),Y.message)}ye.to=fe})(k||(e.DiagnosticRelatedInformation=k={}));var A;(function(ye){function De(Y){switch(Y){case s.DiagnosticSeverity.Error:return l.MarkerSeverity.Error;case s.DiagnosticSeverity.Warning:return l.MarkerSeverity.Warning;case s.DiagnosticSeverity.Information:return l.MarkerSeverity.Info;case s.DiagnosticSeverity.Hint:return l.MarkerSeverity.Hint}return l.MarkerSeverity.Error}ye.from=De;function fe(Y){switch(Y){case l.MarkerSeverity.Info:return s.DiagnosticSeverity.Information;case l.MarkerSeverity.Warning:return s.DiagnosticSeverity.Warning;case l.MarkerSeverity.Error:return s.DiagnosticSeverity.Error;case l.MarkerSeverity.Hint:return s.DiagnosticSeverity.Hint;default:return s.DiagnosticSeverity.Error}}ye.to=fe})(A||(e.DiagnosticSeverity=A={}));var j;(function(ye){function De(Y){return typeof Y=="number"&&Y>=s.ViewColumn.One?Y-1:Y===s.ViewColumn.Beside?t.$cC:t.$bC}ye.from=De;function fe(Y){if(typeof Y=="number"&&Y>=0)return Y+1;throw new Error("invalid 'EditorGroupColumn'")}ye.to=fe})(j||(e.ViewColumn=j={}));function Z(ye){return typeof ye.range<"u"}function ae(ye){return ye.length===0?!0:!!Z(ye[0])}e.$7L=ae;var K;(function(ye){function De(Te){return Te.map(ye.from)}ye.fromMany=De;function fe(Te){return Te&&typeof Te=="object"&&typeof Te.language=="string"&&typeof Te.value=="string"}function Y(Te){let Xe;if(fe(Te)){const{language:ot,value:gt}=Te;Xe={value:"```"+ot+`
`+gt+"\n```\n"}}else s.$yK.isMarkdownString(Te)?Xe={value:Te.value,isTrusted:Te.isTrusted,supportThemeIcons:Te.supportThemeIcons,supportHtml:Te.supportHtml,baseUri:Te.baseUri}:typeof Te=="string"?Xe={value:Te}:Xe={value:""};const at=Object.create(null);Xe.uris=at;const mt=ot=>{try{let gt=d.URI.parse(ot,!0);gt=gt.with({query:Ce(gt.query,at)}),at[ot]=gt}catch{}return""},yt=new w.marked.Renderer;return yt.link=mt,yt.image=ot=>typeof ot=="string"?mt(L.$6j(ot).href):"",(0,w.marked)(Xe.value,{renderer:yt}),Xe}ye.from=Y;function Ce(Te,Xe){if(!Te)return Te;let at;try{at=(0,b.$hh)(Te)}catch{}if(!at)return Te;let mt=!1;return at=(0,E.$Zm)(at,yt=>{if(d.URI.isUri(yt)){const ot=`__uri_${Math.random().toString(16).slice(2,8)}`;return Xe[ot]=yt,mt=!0,ot}else return}),mt?JSON.stringify(at):Te}function Re(Te){const Xe=new s.$yK(Te.value,Te.supportThemeIcons);return Xe.isTrusted=Te.isTrusted,Xe.supportHtml=Te.supportHtml,Xe.baseUri=Te.baseUri?d.URI.from(Te.baseUri):void 0,Xe}ye.to=Re;function Ve(Te){if(Te)return typeof Te=="string"?Te:ye.from(Te)}ye.fromStrict=Ve})(K||(e.MarkdownString=K={}));function se(ye){return ae(ye)?ye.map(De=>({range:i.from(De.range),hoverMessage:Array.isArray(De.hoverMessage)?K.fromMany(De.hoverMessage):De.hoverMessage?K.from(De.hoverMessage):void 0,renderOptions:De.renderOptions})):ye.map(De=>({range:i.from(De)}))}e.$8L=se;function ue(ye){return typeof ye>"u"?ye:typeof ye=="string"?d.URI.file(ye):ye}e.$9L=ue;var x;(function(ye){function De(fe){return typeof fe>"u"?fe:{contentText:fe.contentText,contentIconPath:fe.contentIconPath?ue(fe.contentIconPath):void 0,border:fe.border,borderColor:fe.borderColor,fontStyle:fe.fontStyle,fontWeight:fe.fontWeight,textDecoration:fe.textDecoration,color:fe.color,backgroundColor:fe.backgroundColor,margin:fe.margin,width:fe.width,height:fe.height}}ye.from=De})(x||(e.ThemableDecorationAttachmentRenderOptions=x={}));var he;(function(ye){function De(fe){return typeof fe>"u"?fe:{backgroundColor:fe.backgroundColor,outline:fe.outline,outlineColor:fe.outlineColor,outlineStyle:fe.outlineStyle,outlineWidth:fe.outlineWidth,border:fe.border,borderColor:fe.borderColor,borderRadius:fe.borderRadius,borderSpacing:fe.borderSpacing,borderStyle:fe.borderStyle,borderWidth:fe.borderWidth,fontStyle:fe.fontStyle,fontWeight:fe.fontWeight,textDecoration:fe.textDecoration,cursor:fe.cursor,color:fe.color,opacity:fe.opacity,letterSpacing:fe.letterSpacing,gutterIconPath:fe.gutterIconPath?ue(fe.gutterIconPath):void 0,gutterIconSize:fe.gutterIconSize,overviewRulerColor:fe.overviewRulerColor,before:fe.before?x.from(fe.before):void 0,after:fe.after?x.from(fe.after):void 0}}ye.from=De})(he||(e.ThemableDecorationRenderOptions=he={}));var V;(function(ye){function De(fe){if(typeof fe>"u")return fe;switch(fe){case s.DecorationRangeBehavior.OpenOpen:return 0;case s.DecorationRangeBehavior.ClosedClosed:return 1;case s.DecorationRangeBehavior.OpenClosed:return 2;case s.DecorationRangeBehavior.ClosedOpen:return 3}}ye.from=De})(V||(e.DecorationRangeBehavior=V={}));var te;(function(ye){function De(fe){return{isWholeLine:fe.isWholeLine,rangeBehavior:fe.rangeBehavior?V.from(fe.rangeBehavior):void 0,overviewRulerLane:fe.overviewRulerLane,light:fe.light?he.from(fe.light):void 0,dark:fe.dark?he.from(fe.dark):void 0,backgroundColor:fe.backgroundColor,outline:fe.outline,outlineColor:fe.outlineColor,outlineStyle:fe.outlineStyle,outlineWidth:fe.outlineWidth,border:fe.border,borderColor:fe.borderColor,borderRadius:fe.borderRadius,borderSpacing:fe.borderSpacing,borderStyle:fe.borderStyle,borderWidth:fe.borderWidth,fontStyle:fe.fontStyle,fontWeight:fe.fontWeight,textDecoration:fe.textDecoration,cursor:fe.cursor,color:fe.color,opacity:fe.opacity,letterSpacing:fe.letterSpacing,gutterIconPath:fe.gutterIconPath?ue(fe.gutterIconPath):void 0,gutterIconSize:fe.gutterIconSize,overviewRulerColor:fe.overviewRulerColor,before:fe.before?x.from(fe.before):void 0,after:fe.after?x.from(fe.after):void 0}}ye.from=De})(te||(e.DecorationRenderOptions=te={}));var G;(function(ye){function De(Y){return{text:Y.newText,eol:Y.newEol&&Ze.from(Y.newEol),range:i.from(Y.range)}}ye.from=De;function fe(Y){const Ce=new s.$fK(i.to(Y.range),Y.text);return Ce.newEol=typeof Y.eol>"u"?void 0:Ze.to(Y.eol),Ce}ye.to=fe})(G||(e.TextEdit=G={}));var J;(function(ye){function De(Y,Ce){const Re={edits:[]};if(Y instanceof s.$iK){const Ve=new I.$zc;for(const Te of Y._allEntries())Te._type===1&&d.URI.isUri(Te.to)&&Te.from===void 0&&Ve.add(Te.to);for(const Te of Y._allEntries())if(Te._type===1){let Xe;Te.options?.contents&&(ArrayBuffer.isView(Te.options.contents)?Xe={type:"base64",value:(0,R.$te)(R.$_d.wrap(Te.options.contents))}:Xe={type:"dataTransferItem",id:Te.options.contents._itemId}),Re.edits.push({oldResource:Te.from,newResource:Te.to,options:{...Te.options,contents:Xe},metadata:Te.metadata})}else Te._type===2?Re.edits.push({resource:Te.uri,textEdit:G.from(Te.edit),versionId:Ve.has(Te.uri)?void 0:Ce?.getTextDocumentVersion(Te.uri),metadata:Te.metadata}):Te._type===6?Re.edits.push({resource:Te.uri,textEdit:{range:i.from(Te.range),text:Te.edit.value,insertAsSnippet:!0},versionId:Ve.has(Te.uri)?void 0:Ce?.getTextDocumentVersion(Te.uri),metadata:Te.metadata}):Te._type===3?Re.edits.push({metadata:Te.metadata,resource:Te.uri,cellEdit:Te.edit,notebookMetadata:Te.notebookMetadata,notebookVersionId:Ce?.getNotebookDocumentVersion(Te.uri)}):Te._type===5&&Re.edits.push({metadata:Te.metadata,resource:Te.uri,notebookVersionId:Ce?.getNotebookDocumentVersion(Te.uri),cellEdit:{editType:1,index:Te.index,count:Te.count,cells:Te.cells.map(rt.from)}})}return Re}ye.from=De;function fe(Y){const Ce=new s.$iK,Re=new I.$yc;for(const Ve of Y.edits)if(Ve.textEdit){const Te=Ve,Xe=d.URI.revive(Te.resource),at=i.to(Te.textEdit.range),mt=Te.textEdit.text,yt=Te.textEdit.insertAsSnippet;let ot;yt?ot=s.$hK.replace(at,new s.$jK(mt)):ot=s.$fK.replace(at,mt);const gt=Re.get(Xe);gt?gt.push(ot):Re.set(Xe,[ot])}else Ce.renameFile(d.URI.revive(Ve.oldResource),d.URI.revive(Ve.newResource),Ve.options);for(const[Ve,Te]of Re)Ce.set(Ve,Te);return Ce}ye.to=fe})(J||(e.WorkspaceEdit=J={}));var q;(function(ye){const De=Object.create(null);De[s.SymbolKind.File]=0,De[s.SymbolKind.Module]=1,De[s.SymbolKind.Namespace]=2,De[s.SymbolKind.Package]=3,De[s.SymbolKind.Class]=4,De[s.SymbolKind.Method]=5,De[s.SymbolKind.Property]=6,De[s.SymbolKind.Field]=7,De[s.SymbolKind.Constructor]=8,De[s.SymbolKind.Enum]=9,De[s.SymbolKind.Interface]=10,De[s.SymbolKind.Function]=11,De[s.SymbolKind.Variable]=12,De[s.SymbolKind.Constant]=13,De[s.SymbolKind.String]=14,De[s.SymbolKind.Number]=15,De[s.SymbolKind.Boolean]=16,De[s.SymbolKind.Array]=17,De[s.SymbolKind.Object]=18,De[s.SymbolKind.Key]=19,De[s.SymbolKind.Null]=20,De[s.SymbolKind.EnumMember]=21,De[s.SymbolKind.Struct]=22,De[s.SymbolKind.Event]=23,De[s.SymbolKind.Operator]=24,De[s.SymbolKind.TypeParameter]=25;function fe(Ce){return typeof De[Ce]=="number"?De[Ce]:6}ye.from=fe;function Y(Ce){for(const Re in De)if(De[Re]===Ce)return Number(Re);return s.SymbolKind.Property}ye.to=Y})(q||(e.SymbolKind=q={}));var ne;(function(ye){function De(Y){switch(Y){case s.SymbolTag.Deprecated:return 1}}ye.from=De;function fe(Y){switch(Y){case 1:return s.SymbolTag.Deprecated}}ye.to=fe})(ne||(e.SymbolTag=ne={}));var me;(function(ye){function De(Y){return{name:Y.name,kind:q.from(Y.kind),tags:Y.tags&&Y.tags.map(ne.from),containerName:Y.containerName,location:N.from(Y.location)}}ye.from=De;function fe(Y){const Ce=new s.$pK(Y.name,q.to(Y.kind),Y.containerName,N.to(Y.location));return Ce.tags=Y.tags&&Y.tags.map(ne.to),Ce}ye.to=fe})(me||(e.WorkspaceSymbol=me={}));var re;(function(ye){function De(Y){const Ce={name:Y.name||"!!MISSING: name!!",detail:Y.detail,range:i.from(Y.range),selectionRange:i.from(Y.selectionRange),kind:q.from(Y.kind),tags:Y.tags?.map(ne.from)??[]};return Y.children&&(Ce.children=Y.children.map(De)),Ce}ye.from=De;function fe(Y){const Ce=new s.$qK(Y.name,Y.detail,q.to(Y.kind),i.to(Y.range),i.to(Y.selectionRange));return(0,y.$Jb)(Y.tags)&&(Ce.tags=Y.tags.map(ne.to)),Y.children&&(Ce.children=Y.children.map(fe)),Ce}ye.to=fe})(re||(e.DocumentSymbol=re={}));var B;(function(ye){function De(Y){const Ce=new s.$uK(q.to(Y.kind),Y.name,Y.detail||"",d.URI.revive(Y.uri),i.to(Y.range),i.to(Y.selectionRange));return Ce._sessionId=Y._sessionId,Ce._itemId=Y._itemId,Ce}ye.to=De;function fe(Y,Ce,Re){if(Ce=Ce??Y._sessionId,Re=Re??Y._itemId,Ce===void 0||Re===void 0)throw new Error("invalid item");return{_sessionId:Ce,_itemId:Re,name:Y.name,detail:Y.detail,kind:q.from(Y.kind),uri:Y.uri,range:i.from(Y.range),selectionRange:i.from(Y.selectionRange),tags:Y.tags?.map(ne.from)}}ye.from=fe})(B||(e.CallHierarchyItem=B={}));var ee;(function(ye){function De(fe){return new s.$vK(B.to(fe.from),fe.fromRanges.map(Y=>i.to(Y)))}ye.to=De})(ee||(e.CallHierarchyIncomingCall=ee={}));var O;(function(ye){function De(fe){return new s.$wK(B.to(fe.to),fe.fromRanges.map(Y=>i.to(Y)))}ye.to=De})(O||(e.CallHierarchyOutgoingCall=O={}));var N;(function(ye){function De(Y){return{range:Y.range&&i.from(Y.range),uri:Y.uri}}ye.from=De;function fe(Y){return new s.$kK(d.URI.revive(Y.uri),i.to(Y.range))}ye.to=fe})(N||(e.location=N={}));var Q;(function(ye){function De(Y){const Ce=Y,Re=Y;return{originSelectionRange:Ce.originSelectionRange?i.from(Ce.originSelectionRange):void 0,uri:Ce.targetUri?Ce.targetUri:Re.uri,range:i.from(Ce.targetRange?Ce.targetRange:Re.range),targetSelectionRange:Ce.targetSelectionRange?i.from(Ce.targetSelectionRange):void 0}}ye.from=De;function fe(Y){return{targetUri:d.URI.revive(Y.uri),targetRange:i.to(Y.range),targetSelectionRange:Y.targetSelectionRange?i.to(Y.targetSelectionRange):void 0,originSelectionRange:Y.originSelectionRange?i.to(Y.originSelectionRange):void 0}}ye.to=fe})(Q||(e.DefinitionLink=Q={}));var T;(function(ye){function De(Y){return{range:i.from(Y.range),contents:K.fromMany(Y.contents)}}ye.from=De;function fe(Y){return new s.$nK(Y.contents.map(K.to),i.to(Y.range))}ye.to=fe})(T||(e.Hover=T={}));var H;(function(ye){function De(Y){return{range:i.from(Y.range),expression:Y.expression}}ye.from=De;function fe(Y){return new s.$gL(i.to(Y.range),Y.expression)}ye.to=fe})(H||(e.EvaluatableExpression=H={}));var U;(function(ye){function De(Y){if(Y instanceof s.$hL)return{type:"text",range:i.from(Y.range),text:Y.text};if(Y instanceof s.$iL)return{type:"variable",range:i.from(Y.range),variableName:Y.variableName,caseSensitiveLookup:Y.caseSensitiveLookup};if(Y instanceof s.$jL)return{type:"expression",range:i.from(Y.range),expression:Y.expression};throw new Error("Unknown 'InlineValue' type")}ye.from=De;function fe(Y){switch(Y.type){case"text":return{range:i.to(Y.range),text:Y.text};case"variable":return{range:i.to(Y.range),variableName:Y.variableName,caseSensitiveLookup:Y.caseSensitiveLookup};case"expression":return{range:i.to(Y.range),expression:Y.expression}}}ye.to=fe})(U||(e.InlineValue=U={}));var ie;(function(ye){function De(Y){return{frameId:Y.frameId,stoppedLocation:i.from(Y.stoppedLocation)}}ye.from=De;function fe(Y){return new s.$kL(Y.frameId,i.to(Y.stoppedLocation))}ye.to=fe})(ie||(e.InlineValueContext=ie={}));var z;(function(ye){function De(Y){return{range:i.from(Y.range),kind:Y.kind}}ye.from=De;function fe(Y){return new s.$oK(i.to(Y.range),Y.kind)}ye.to=fe})(z||(e.DocumentHighlight=z={}));var _;(function(ye){function De(fe){switch(fe){case 1:return s.CompletionTriggerKind.TriggerCharacter;case 2:return s.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return s.CompletionTriggerKind.Invoke}}ye.to=De})(_||(e.CompletionTriggerKind=_={}));var W;(function(ye){function De(fe){return{triggerKind:_.to(fe.triggerKind),triggerCharacter:fe.triggerCharacter}}ye.to=De})(W||(e.CompletionContext=W={}));var X;(function(ye){function De(Y){switch(Y){case s.CompletionItemTag.Deprecated:return 1}}ye.from=De;function fe(Y){switch(Y){case 1:return s.CompletionItemTag.Deprecated}}ye.to=fe})(X||(e.CompletionItemTag=X={}));var oe;(function(ye){const De=new Map([[s.CompletionItemKind.Method,0],[s.CompletionItemKind.Function,1],[s.CompletionItemKind.Constructor,2],[s.CompletionItemKind.Field,3],[s.CompletionItemKind.Variable,4],[s.CompletionItemKind.Class,5],[s.CompletionItemKind.Interface,7],[s.CompletionItemKind.Struct,6],[s.CompletionItemKind.Module,8],[s.CompletionItemKind.Property,9],[s.CompletionItemKind.Unit,12],[s.CompletionItemKind.Value,13],[s.CompletionItemKind.Constant,14],[s.CompletionItemKind.Enum,15],[s.CompletionItemKind.EnumMember,16],[s.CompletionItemKind.Keyword,17],[s.CompletionItemKind.Snippet,27],[s.CompletionItemKind.Text,18],[s.CompletionItemKind.Color,19],[s.CompletionItemKind.File,20],[s.CompletionItemKind.Reference,21],[s.CompletionItemKind.Folder,23],[s.CompletionItemKind.Event,10],[s.CompletionItemKind.Operator,11],[s.CompletionItemKind.TypeParameter,24],[s.CompletionItemKind.Issue,26],[s.CompletionItemKind.User,25]]);function fe(Re){return De.get(Re)??9}ye.from=fe;const Y=new Map([[0,s.CompletionItemKind.Method],[1,s.CompletionItemKind.Function],[2,s.CompletionItemKind.Constructor],[3,s.CompletionItemKind.Field],[4,s.CompletionItemKind.Variable],[5,s.CompletionItemKind.Class],[7,s.CompletionItemKind.Interface],[6,s.CompletionItemKind.Struct],[8,s.CompletionItemKind.Module],[9,s.CompletionItemKind.Property],[12,s.CompletionItemKind.Unit],[13,s.CompletionItemKind.Value],[14,s.CompletionItemKind.Constant],[15,s.CompletionItemKind.Enum],[16,s.CompletionItemKind.EnumMember],[17,s.CompletionItemKind.Keyword],[27,s.CompletionItemKind.Snippet],[18,s.CompletionItemKind.Text],[19,s.CompletionItemKind.Color],[20,s.CompletionItemKind.File],[21,s.CompletionItemKind.Reference],[23,s.CompletionItemKind.Folder],[10,s.CompletionItemKind.Event],[11,s.CompletionItemKind.Operator],[24,s.CompletionItemKind.TypeParameter],[25,s.CompletionItemKind.User],[26,s.CompletionItemKind.Issue]]);function Ce(Re){return Y.get(Re)??s.CompletionItemKind.Property}ye.to=Ce})(oe||(e.CompletionItemKind=oe={}));var ge;(function(ye){function De(fe,Y){const Ce=new s.$EK(fe.label);return Ce.insertText=fe.insertText,Ce.kind=oe.to(fe.kind),Ce.tags=fe.tags?.map(X.to),Ce.detail=fe.detail,Ce.documentation=L.$1j(fe.documentation)?K.to(fe.documentation):fe.documentation,Ce.sortText=fe.sortText,Ce.filterText=fe.filterText,Ce.preselect=fe.preselect,Ce.commitCharacters=fe.commitCharacters,g.$ms.isIRange(fe.range)?Ce.range=i.to(fe.range):typeof fe.range=="object"&&(Ce.range={inserting:i.to(fe.range.insert),replacing:i.to(fe.range.replace)}),Ce.keepWhitespace=typeof fe.insertTextRules>"u"?!1:!!(fe.insertTextRules&1),typeof fe.insertTextRules<"u"&&fe.insertTextRules&4?Ce.insertText=new s.$jK(fe.insertText):(Ce.insertText=fe.insertText,Ce.textEdit=Ce.range instanceof s.$aK?new s.$fK(Ce.range,Ce.insertText):void 0),fe.additionalTextEdits&&fe.additionalTextEdits.length>0&&(Ce.additionalTextEdits=fe.additionalTextEdits.map(Re=>G.to(Re))),Ce.command=Y&&fe.command?Y.fromInternal(fe.command):void 0,Ce}ye.to=De})(ge||(e.CompletionItem=ge={}));var Ee;(function(ye){function De(Y){if(typeof Y.label!="string"&&!Array.isArray(Y.label))throw new TypeError("Invalid label");return{label:Y.label,documentation:K.fromStrict(Y.documentation)}}ye.from=De;function fe(Y){return{label:Y.label,documentation:L.$1j(Y.documentation)?K.to(Y.documentation):Y.documentation}}ye.to=fe})(Ee||(e.ParameterInformation=Ee={}));var Pe;(function(ye){function De(Y){return{label:Y.label,documentation:K.fromStrict(Y.documentation),parameters:Array.isArray(Y.parameters)?Y.parameters.map(Ee.from):[],activeParameter:Y.activeParameter}}ye.from=De;function fe(Y){return{label:Y.label,documentation:L.$1j(Y.documentation)?K.to(Y.documentation):Y.documentation,parameters:Array.isArray(Y.parameters)?Y.parameters.map(Ee.to):[],activeParameter:Y.activeParameter}}ye.to=fe})(Pe||(e.SignatureInformation=Pe={}));var Ne;(function(ye){function De(Y){return{activeSignature:Y.activeSignature,activeParameter:Y.activeParameter,signatures:Array.isArray(Y.signatures)?Y.signatures.map(Pe.from):[]}}ye.from=De;function fe(Y){return{activeSignature:Y.activeSignature,activeParameter:Y.activeParameter,signatures:Array.isArray(Y.signatures)?Y.signatures.map(Pe.to):[]}}ye.to=fe})(Ne||(e.SignatureHelp=Ne={}));var Fe;(function(ye){function De(fe,Y){const Ce=new s.$DK(a.to(Y.position),typeof Y.label=="string"?Y.label:Y.label.map($e.to.bind(void 0,fe)),Y.kind&&ke.to(Y.kind));return Ce.textEdits=Y.textEdits&&Y.textEdits.map(G.to),Ce.tooltip=L.$1j(Y.tooltip)?K.to(Y.tooltip):Y.tooltip,Ce.paddingLeft=Y.paddingLeft,Ce.paddingRight=Y.paddingRight,Ce}ye.to=De})(Fe||(e.InlayHint=Fe={}));var $e;(function(ye){function De(fe,Y){const Ce=new s.$CK(Y.label);return Ce.tooltip=L.$1j(Y.tooltip)?K.to(Y.tooltip):Y.tooltip,m.Command.is(Y.command)&&(Ce.command=fe.fromInternal(Y.command)),Y.location&&(Ce.location=N.to(Y.location)),Ce}ye.to=De})($e||(e.InlayHintLabelPart=$e={}));var ke;(function(ye){function De(Y){return Y}ye.from=De;function fe(Y){return Y}ye.to=fe})(ke||(e.InlayHintKind=ke={}));var ve;(function(ye){function De(Y){return{range:i.from(Y.range),url:Y.target,tooltip:Y.tooltip}}ye.from=De;function fe(Y){let Ce;if(Y.url)try{Ce=typeof Y.url=="string"?d.URI.parse(Y.url,!0):d.URI.revive(Y.url)}catch{}return new s.$JK(i.to(Y.range),Ce)}ye.to=fe})(ve||(e.DocumentLink=ve={}));var Me;(function(ye){function De(Y){const Ce=new s.$MK(Y.label);return Y.textEdit&&(Ce.textEdit=G.to(Y.textEdit)),Y.additionalTextEdits&&(Ce.additionalTextEdits=Y.additionalTextEdits.map(Re=>G.to(Re))),Ce}ye.to=De;function fe(Y){return{label:Y.label,textEdit:Y.textEdit?G.from(Y.textEdit):void 0,additionalTextEdits:Y.additionalTextEdits?Y.additionalTextEdits.map(Ce=>G.from(Ce)):void 0}}ye.from=fe})(Me||(e.ColorPresentation=Me={}));var Ue;(function(ye){function De(Y){return new s.$KK(Y[0],Y[1],Y[2],Y[3])}ye.to=De;function fe(Y){return[Y.red,Y.green,Y.blue,Y.alpha]}ye.from=fe})(Ue||(e.Color=Ue={}));var Ye;(function(ye){function De(Y){return{range:i.from(Y.range)}}ye.from=De;function fe(Y){return new s.$tK(i.to(Y.range))}ye.to=fe})(Ye||(e.SelectionRange=Ye={}));var qe;(function(ye){function De(fe){switch(fe){case 2:return s.TextDocumentSaveReason.AfterDelay;case 1:return s.TextDocumentSaveReason.Manual;case 3:case 4:return s.TextDocumentSaveReason.FocusOut}}ye.to=De})(qe||(e.TextDocumentSaveReason=qe={}));var Je;(function(ye){function De(Y){switch(Y){case s.TextEditorLineNumbersStyle.Off:return 0;case s.TextEditorLineNumbersStyle.Relative:return 2;case s.TextEditorLineNumbersStyle.On:default:return 1}}ye.from=De;function fe(Y){switch(Y){case 0:return s.TextEditorLineNumbersStyle.Off;case 2:return s.TextEditorLineNumbersStyle.Relative;case 1:default:return s.TextEditorLineNumbersStyle.On}}ye.to=fe})(Je||(e.TextEditorLineNumbersStyle=Je={}));var Ze;(function(ye){function De(Y){if(Y===s.EndOfLine.CRLF)return 1;if(Y===s.EndOfLine.LF)return 0}ye.from=De;function fe(Y){if(Y===1)return s.EndOfLine.CRLF;if(Y===0)return s.EndOfLine.LF}ye.to=fe})(Ze||(e.EndOfLine=Ze={}));var xe;(function(ye){function De(fe){if(typeof fe=="object")return fe.viewId;switch(fe){case s.ProgressLocation.SourceControl:return 3;case s.ProgressLocation.Window:return 10;case s.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}ye.from=De})(xe||(e.ProgressLocation=xe={}));var de;(function(ye){function De(Y){const Ce={start:Y.start+1,end:Y.end+1};return Y.kind&&(Ce.kind=Se.from(Y.kind)),Ce}ye.from=De;function fe(Y){const Ce={start:Y.start-1,end:Y.end-1};return Y.kind&&(Ce.kind=Se.to(Y.kind)),Ce}ye.to=fe})(de||(e.FoldingRange=de={}));var Se;(function(ye){function De(Y){if(Y)switch(Y){case s.FoldingRangeKind.Comment:return m.$bt.Comment;case s.FoldingRangeKind.Imports:return m.$bt.Imports;case s.FoldingRangeKind.Region:return m.$bt.Region}}ye.from=De;function fe(Y){if(Y)switch(Y.value){case m.$bt.Comment.value:return s.FoldingRangeKind.Comment;case m.$bt.Imports.value:return s.FoldingRangeKind.Imports;case m.$bt.Region.value:return s.FoldingRangeKind.Region}}ye.to=fe})(Se||(e.FoldingRangeKind=Se={}));var Ie;(function(ye){function De(fe){if(fe)return{pinned:typeof fe.preview=="boolean"?!fe.preview:void 0,inactive:fe.background,preserveFocus:fe.preserveFocus,selection:typeof fe.selection=="object"?i.from(fe.selection):void 0,override:typeof fe.override=="boolean"?u.$LD.id:void 0}}ye.from=De})(Ie||(e.TextEditorOpenOptions=Ie={}));var Le;(function(ye){function De(Re){return Re instanceof s.$7K?Re.toJSON():typeof Re=="string"?Re:fe(Re)||Y(Re)?new s.$7K(Re.baseUri??Re.base,Re.pattern).toJSON():Re}ye.from=De;function fe(Re){const Ve=Re;return Ve?d.URI.isUri(Ve.baseUri)&&typeof Ve.pattern=="string":!1}function Y(Re){const Ve=Re;return Ve?typeof Ve.base=="string"&&typeof Ve.pattern=="string":!1}function Ce(Re){return typeof Re=="string"?Re:new s.$7K(d.URI.revive(Re.baseUri),Re.pattern)}ye.to=Ce})(Le||(e.GlobPattern=Le={}));var Be;(function(ye){function De(fe){if(fe){if(Array.isArray(fe))return fe.map(De);if(typeof fe=="string")return fe;{const Y=fe;return{language:Y.language,scheme:Y.scheme,pattern:Le.from(Y.pattern),exclusive:Y.exclusive,notebookType:Y.notebookType}}}else return}ye.from=De})(Be||(e.LanguageSelector=Be={}));var ze;(function(ye){function De(Y){return!!Y&&typeof Y=="object"&&"documents"in Y&&Array.isArray(Y.documents)&&Y.documents.every(Ce=>Array.isArray(Ce)&&Ce.every(Re=>Re&&typeof Re=="object"&&"uri"in Re&&d.URI.isUri(Re.uri)&&"version"in Re&&typeof Re.version=="number"&&"ranges"in Re&&Array.isArray(Re.ranges)&&Re.ranges.every(Ve=>Ve instanceof s.$aK)))}ye.is=De;function fe(Y){return{documents:Y.documents.map(Ce=>Ce.map(Re=>({uri:d.URI.from(Re.uri),version:Re.version,ranges:Re.ranges.map(Ve=>i.from(Ve))})))}}ye.from=fe})(ze||(e.MappedEditsContext=ze={}));var He;(function(ye){function De(Y){return{start:Y.start,end:Y.end}}ye.from=De;function fe(Y){return new s.$vL(Y.start,Y.end)}ye.to=fe})(He||(e.NotebookRange=He={}));var Ge;(function(ye){function De(Y){return{timing:typeof Y.runStartTime=="number"&&typeof Y.runEndTime=="number"?{startTime:Y.runStartTime,endTime:Y.runEndTime}:void 0,executionOrder:Y.executionOrder,success:Y.lastRunSuccess}}ye.to=De;function fe(Y){return{lastRunSuccess:Y.success,runStartTime:Y.timing?.startTime,runEndTime:Y.timing?.endTime,executionOrder:Y.executionOrder}}ye.from=fe})(Ge||(e.NotebookCellExecutionSummary=Ge={}));var Qe;(function(ye){function De(fe){if(fe===c.NotebookCellExecutionState.Unconfirmed)return s.NotebookCellExecutionState.Pending;if(fe===c.NotebookCellExecutionState.Pending)return;if(fe===c.NotebookCellExecutionState.Executing)return s.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${fe}`)}ye.to=De})(Qe||(e.NotebookCellExecutionState=Qe={}));var We;(function(ye){function De(Y){switch(Y){case s.NotebookCellKind.Markup:return c.CellKind.Markup;case s.NotebookCellKind.Code:default:return c.CellKind.Code}}ye.from=De;function fe(Y){switch(Y){case c.CellKind.Markup:return s.NotebookCellKind.Markup;case c.CellKind.Code:default:return s.NotebookCellKind.Code}}ye.to=fe})(We||(e.NotebookCellKind=We={}));var st;(function(ye){function De(Y){const Ce={metadata:Y.metadata??Object.create(null),cells:[]};for(const Re of Y.cells)s.$wL.validate(Re),Ce.cells.push(rt.from(Re));return Ce}ye.from=De;function fe(Y){const Ce=new s.$xL(Y.cells.map(rt.to));return(0,v.$Jf)(Y.metadata)||(Ce.metadata=Y.metadata),Ce}ye.to=fe})(st||(e.NotebookData=st={}));var rt;(function(ye){function De(Y){return{cellKind:We.from(Y.kind),language:Y.languageId,mime:Y.mime,source:Y.value,metadata:Y.metadata,internalMetadata:Ge.from(Y.executionSummary??{}),outputs:Y.outputs?Y.outputs.map(ft.from):[]}}ye.from=De;function fe(Y){return new s.$wL(We.to(Y.cellKind),Y.source,Y.language,Y.mime,Y.outputs?Y.outputs.map(ft.to):void 0,Y.metadata,Y.internalMetadata?Ge.to(Y.internalMetadata):void 0)}ye.to=fe})(rt||(e.NotebookCellData=rt={}));var et;(function(ye){function De(Y){return{mime:Y.mime,valueBytes:R.$_d.wrap(Y.data)}}ye.from=De;function fe(Y){return new s.$yL(Y.valueBytes.buffer,Y.mime)}ye.to=fe})(et||(e.NotebookCellOutputItem=et={}));var ft;(function(ye){function De(Y){return{outputId:Y.id,items:Y.items.map(et.from),metadata:Y.metadata}}ye.from=De;function fe(Y){const Ce=Y.items.map(et.to);return new s.$zL(Ce,Y.outputId,Y.metadata)}ye.to=fe})(ft||(e.NotebookCellOutput=ft={}));var $t;(function(ye){function De(Ce){return Y(Ce)?{include:Le.from(Ce.include)??void 0,exclude:Le.from(Ce.exclude)??void 0}:Le.from(Ce)??void 0}ye.from=De;function fe(Ce){return Y(Ce)?{include:Le.to(Ce.include),exclude:Le.to(Ce.exclude)}:Le.to(Ce)}ye.to=fe;function Y(Ce){const Re=Ce;return Re?!(0,v.$Ff)(Re.include)&&!(0,v.$Ff)(Re.exclude):!1}})($t||(e.NotebookExclusiveDocumentPattern=$t={}));var Ct;(function(ye){function De(fe,Y,Ce){const Re=typeof fe.command=="string"?{title:"",command:fe.command}:fe.command;return{alignment:fe.alignment===s.NotebookCellStatusBarAlignment.Left?1:2,command:Y.toInternal(Re,Ce),text:fe.text,tooltip:fe.tooltip,accessibilityInformation:fe.accessibilityInformation,priority:fe.priority}}ye.from=De})(Ct||(e.NotebookStatusBarItem=Ct={}));var dt;(function(ye){function De(fe,Y,Ce){const Re=typeof fe.command=="string"?{title:"",command:fe.command}:fe.command;return{command:Y.toInternal(Re,Ce),label:fe.label,description:fe.description,detail:fe.detail,documentation:fe.documentation}}ye.from=De})(dt||(e.NotebookKernelSourceAction=dt={}));var bt;(function(ye){function De(fe){return{transientOutputs:fe?.transientOutputs??!1,transientCellMetadata:fe?.transientCellMetadata??{},transientDocumentMetadata:fe?.transientDocumentMetadata??{},cellContentMetadata:fe?.cellContentMetadata??{}}}ye.from=De})(bt||(e.NotebookDocumentContentOptions=bt={}));var jt;(function(ye){function De(Y){return{uri:Y.uri,provides:Y.provides}}ye.from=De;function fe(Y){return new s.$BL(d.URI.revive(Y.uri),Y.provides)}ye.to=fe})(jt||(e.NotebookRendererScript=jt={}));var Pt;(function(ye){function De(Y){return{message:K.fromStrict(Y.message)||"",type:0,expected:Y.expectedOutput,actual:Y.actualOutput,contextValue:Y.contextValue,location:Y.location&&{range:i.from(Y.location.range),uri:Y.location.uri}}}ye.from=De;function fe(Y){const Ce=new s.$HL(typeof Y.message=="string"?Y.message:K.to(Y.message));return Ce.actualOutput=Y.actual,Ce.expectedOutput=Y.expected,Ce.contextValue=Y.contextValue,Ce.location=Y.location?N.to(Y.location):void 0,Ce}ye.to=fe})(Pt||(e.TestMessage=Pt={}));var wt;(function(ye){ye.namespace=h.$6I,ye.denamespace=h.$7I})(wt||(e.TestTag=wt={}));var pt;(function(ye){function De(Y){const Ce=(0,f.$6L)(Y).controllerId;return{extId:p.$2I.fromExtHostTestItem(Y,Ce).toString(),label:Y.label,uri:d.URI.revive(Y.uri),busy:Y.busy,tags:Y.tags.map(Re=>wt.namespace(Ce,Re.id)),range:g.$ms.lift(i.from(Y.range)),description:Y.description||null,sortText:Y.sortText||null,error:Y.error&&K.fromStrict(Y.error)||null}}ye.from=De;function fe(Y){return{parent:void 0,error:void 0,id:p.$2I.fromString(Y.extId).localId,label:Y.label,uri:d.URI.revive(Y.uri),tags:(Y.tags||[]).map(Ce=>{const{tagId:Re}=wt.denamespace(Ce);return new s.$IL(Re)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:i.to(Y.range||void 0),canResolveChildren:!1,busy:Y.busy,description:Y.description||void 0,sortText:Y.sortText||void 0}}ye.toPlain=fe})(pt||(e.TestItem=pt={})),function(ye){function De(Y){return{id:Y.id}}ye.from=De;function fe(Y){return new s.$IL(Y.id)}ye.to=fe}(wt||(e.TestTag=wt={}));var Ot;(function(ye){const De=(Y,Ce)=>{const Re=[];for(const[Te,Xe]of Ce)p.$2I.compare(Xe.item.extId,Te)===2&&(Ce.delete(Te),Re.push(Xe));const Ve={...pt.toPlain(Y.item),parent:void 0,taskStates:Y.tasks.map(Te=>({state:Te.state,duration:Te.duration,messages:Te.messages.filter(Xe=>Xe.type===0).map(Pt.to)})),children:Re.map(Te=>De(Te,Ce))};for(const Te of Ve.children)Te.parent=Ve;return Ve};function fe(Y){const Ce=[],Re=new Map;for(const Ve of Y.items){Re.set(Ve.item.extId,Ve);const Te=p.$2I.root(Ve.item.extId);Y.request.targets.some(Xe=>Xe.controllerId===Te&&Xe.testIds.includes(Ve.item.extId))&&Ce.push(Ve)}return{completedAt:Y.completedAt,results:Ce.map(Ve=>De(Ve,Re))}}ye.to=fe})(Ot||(e.TestResults=Ot={}));var Tt;(function(ye){function De(Re){return{covered:Re.covered,total:Re.covered}}function fe(Re){return"line"in Re?a.from(Re):i.from(Re)}function Y(Re){return"branches"in Re?{count:Re.executionCount,location:fe(Re.location),type:1,branches:Re.branches.length?Re.branches.map(Ve=>({count:Ve.executionCount,location:Ve.location&&fe(Ve.location)})):void 0}:{type:0,count:Re.executionCount,location:fe(Re.location)}}ye.fromDetailed=Y;function Ce(Re){return{uri:Re.uri,statement:De(Re.statementCoverage),branch:Re.branchCoverage&&De(Re.branchCoverage),function:Re.functionCoverage&&De(Re.functionCoverage),details:Re.detailedCoverage?.map(Y)}}ye.fromFile=Ce})(Tt||(e.TestCoverage=Tt={}));var ut;(function(ye){function De(fe){switch(fe){case 1:return s.CodeActionTriggerKind.Invoke;case 2:return s.CodeActionTriggerKind.Automatic}}ye.to=De})(ut||(e.CodeActionTriggerKind=ut={}));var Ut;(function(ye){function De(Y){const Ce=new s.$OL(q.to(Y.kind),Y.name,Y.detail||"",d.URI.revive(Y.uri),i.to(Y.range),i.to(Y.selectionRange));return Ce._sessionId=Y._sessionId,Ce._itemId=Y._itemId,Ce}ye.to=De;function fe(Y,Ce,Re){if(Ce=Ce??Y._sessionId,Re=Re??Y._itemId,Ce===void 0||Re===void 0)throw new Error("invalid item");return{_sessionId:Ce,_itemId:Re,kind:q.from(Y.kind),name:Y.name,detail:Y.detail??"",uri:Y.uri,range:i.from(Y.range),selectionRange:i.from(Y.selectionRange),tags:Y.tags?.map(ne.from)}}ye.from=fe})(Ut||(e.TypeHierarchyItem=Ut={}));var Nt;(function(ye){function De(fe){if(fe)return{value:fe.value,tooltip:fe.tooltip}}ye.from=De})(Nt||(e.ViewBadge=Nt={}));var it;(function(ye){function De(Re,Ve,Te){const Xe=Ve.fileData;return Xe?new s.$ZK(new s.$1K(Xe.name,d.URI.revive(Xe.uri),Xe.id,(0,P.$bb)(()=>Te(Xe.id)))):Re===C.$Jr.uriList&&Ve.uriListData?new s.$YK(Ce(Ve.uriListData)):new s.$YK(Ve.asString)}ye.to=De;async function fe(Re,Ve){const Te=await Ve.asString();if(Re===C.$Jr.uriList)return{asString:Te,fileData:void 0,uriListData:Y(Te)};const Xe=Ve.asFile();return{asString:Te,fileData:Xe?{name:Xe.name,uri:Xe.uri,id:Xe._itemId??Xe.id}:void 0}}ye.from=fe;function Y(Re){return r.$Vs.split(Re).map(Ve=>{if(Ve.startsWith("#"))return Ve;try{return d.URI.parse(Ve)}catch{}return Ve})}function Ce(Re){return r.$Vs.create(Re.map(Ve=>typeof Ve=="string"?Ve:d.URI.revive(Ve)))}})(it||(e.DataTransferItem=it={}));var vt;(function(ye){function De(Y,Ce){const Re=Y.items.map(([Ve,Te])=>[Ve,it.to(Ve,Te,Ce)]);return new s.$2K(Re)}ye.toDataTransfer=De;async function fe(Y){const Ce={items:[]},Re=[];for(const[Ve,Te]of Y)Re.push((async()=>{Ce.items.push([Ve,await it.from(Ve,Te)])})());return await Promise.all(Re),Ce}ye.from=fe})(vt||(e.DataTransfer=vt={}));var ct;(function(ye){function De(Y){return{message:Y.message,metadata:Y.metadata,title:Y.title,tooltip:Y.tooltip}}ye.to=De;function fe(Y){return{kind:"reply",message:Y.message,metadata:Y.metadata,title:Y.title,tooltip:Y.tooltip}}ye.from=fe})(ct||(e.ChatReplyFollowup=ct={}));var ht;(function(ye){function De(fe){return typeof fe=="string"?{title:fe,message:fe,kind:"reply"}:"commandId"in fe?{kind:"command",title:fe.title??"",commandId:fe.commandId??"",when:fe.when??"",args:fe.args}:ct.from(fe)}ye.from=De})(ht||(e.ChatFollowup=ht={}));var Ft;(function(ye){function De(Y){const Ce=new s.$YL(It.to(Y.role),Y.content);return Ce.name=Y.name,Ce}ye.to=De;function fe(Y){return{role:It.from(Y.role),content:Y.content,name:Y.name}}ye.from=fe})(Ft||(e.ChatMessage=Ft={}));var It;(function(ye){function De(Y){switch(Y){case 0:return s.ChatMessageRole.System;case 1:return s.ChatMessageRole.User;case 2:return s.ChatMessageRole.Assistant;case 3:return s.ChatMessageRole.Function}}ye.to=De;function fe(Y){switch(Y){case s.ChatMessageRole.System:return 0;case s.ChatMessageRole.Assistant:return 2;case s.ChatMessageRole.Function:return 3;case s.ChatMessageRole.User:default:return 1}}ye.from=fe})(It||(e.ChatMessageRole=It={}));var Bt;(function(ye){function De(Y){return{level:Dt.to(Y.level),value:Y.value,description:Y.description}}ye.to=De;function fe(Y){return{level:Dt.from(Y.level),value:Y.value,description:Y.description}}ye.from=fe})(Bt||(e.ChatVariable=Bt={}));var Dt;(function(ye){function De(Y){switch(Y){case"short":return s.ChatVariableLevel.Short;case"medium":return s.ChatVariableLevel.Medium;case"full":default:return s.ChatVariableLevel.Full}}ye.to=De;function fe(Y){switch(Y){case s.ChatVariableLevel.Short:return"short";case s.ChatVariableLevel.Medium:return"medium";case s.ChatVariableLevel.Full:default:return"full"}}ye.from=fe})(Dt||(e.ChatVariableLevel=Dt={}));var zt;(function(ye){function De(fe){switch(fe){case 1:return s.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return s.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return s.InteractiveEditorResponseFeedbackKind.Undone;case 3:return s.InteractiveEditorResponseFeedbackKind.Accepted}}ye.to=De})(zt||(e.InteractiveEditorResponseFeedbackKind=zt={}));var qt;(function(ye){function De(fe,Y,Ce){return"terminalCommand"in fe?{terminalCommand:fe.terminalCommand}:"uri"in fe?{uri:fe.uri}:Y.toInternal(fe,Ce)}ye.from=De})(qt||(e.TerminalQuickFix=qt={}))}),define(we[274],pe([1,0,43,133,71,132,92,136,4]),function(le,e,y,R,r,P,L,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mM=e.$lM=e.$kM=e.$jM=void 0;const b=(c,p,h,t)=>{let s=p;return{enumerable:!0,configurable:!1,get(){return s},set(o){if(!h(s,o)){const i=s;s=o,c.listener?.(t(o,i))}}}},C=(c,p)=>c===p,E={range:(c,p)=>c===p?!0:!c||!p?!1:c.isEqual(p),label:C,description:C,sortText:C,busy:C,error:C,canResolveChildren:C,tags:(c,p)=>!(c.length!==p.length||c.some(h=>!p.find(t=>h.id===t.id)))},v=c=>p=>({op:4,update:c(p)}),d=(c,p)=>({range:(()=>{let h;const t=v(s=>({range:y.$ms.lift(I.Range.from(s))}));return{enumerable:!0,configurable:!1,get(){return h},set(s){c.listener?.({op:6}),E.range(h,s)||(h=s,c.listener?.(t(s)))}}})(),label:b(c,p,E.label,v(h=>({label:h}))),description:b(c,void 0,E.description,v(h=>({description:h}))),sortText:b(c,void 0,E.sortText,v(h=>({sortText:h}))),canResolveChildren:b(c,!1,E.canResolveChildren,h=>({op:2,state:h})),busy:b(c,!1,E.busy,v(h=>({busy:h}))),error:b(c,void 0,E.error,v(h=>({error:I.MarkdownString.fromStrict(h)||null}))),tags:b(c,[],E.tags,(h,t)=>({op:1,new:h.map(I.TestTag.from),old:t.map(I.TestTag.from)}))}),g=c=>{const p=r.$2I.fromString(c.extId),h=new l(p.controllerId,p.localId,c.label,w.URI.revive(c.uri)||void 0);return h.range=I.Range.to(c.range||void 0),h.description=c.description||void 0,h.sortText=c.sortText||void 0,h.tags=c.tags.map(t=>I.TestTag.to({id:(0,L.$7I)(t).tagId})),h},m=c=>{let p;for(const h of c.tests){const t=g(h.item);(0,R.$6L)(t).parent=p,p=t}return p};e.$jM=m;class l{constructor(p,h,t,s){if(h.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(h)} symbol`);const o=(0,R.$5L)(this,p);Object.defineProperties(this,{id:{value:h,enumerable:!0,writable:!1},uri:{value:s,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return o.parent instanceof f?void 0:o.parent}},children:{value:(0,P.$4L)(o,R.$6L,l),enumerable:!0,writable:!1},...d(o,t)})}}e.$kM=l;class f extends l{constructor(p,h){super(p,p,h,void 0),this._isRoot=!0}}e.$lM=f;class u extends P.$ZL{constructor(p,h,t){super({controllerId:p,getDocumentVersion:s=>s&&t.getDocument(s)?.version,getApiFor:R.$6L,getChildren:s=>s.children,root:new f(p,h),toITestItem:I.TestItem.from})}}e.$mM=u}),define(we[275],pe([1,0,271,118,89,87,134,91,135,12,222,269,88]),function(le,e,y,R,r,P,L,I,w,b,C,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bN=e.$aN=void 0,e.$aN="remoteterminal";let d=class{get onPtyHostExit(){return this.b.listen("$onPtyHostExitEvent")}get onPtyHostStart(){return this.b.listen("$onPtyHostStartEvent")}get onPtyHostUnresponsive(){return this.b.listen("$onPtyHostUnresponsiveEvent")}get onPtyHostResponsive(){return this.b.listen("$onPtyHostResponsiveEvent")}get onPtyHostRequestResolveVariables(){return this.b.listen("$onPtyHostRequestResolveVariablesEvent")}get onProcessData(){return this.b.listen("$onProcessDataEvent")}get onProcessExit(){return this.b.listen("$onProcessExitEvent")}get onProcessReady(){return this.b.listen("$onProcessReadyEvent")}get onProcessReplay(){return this.b.listen("$onProcessReplayEvent")}get onProcessOrphanQuestion(){return this.b.listen("$onProcessOrphanQuestion")}get onExecuteCommand(){return this.b.listen("$onExecuteCommand")}get onDidRequestDetach(){return this.b.listen("$onDidRequestDetach")}get onDidChangeProperty(){return this.b.listen("$onDidChangeProperty")}constructor(m,l,f,u,c,p,h,t,s,o){this.a=m,this.b=l,this.c=f,this.d=u,this.e=c,this.f=p,this.g=h,this.h=t,this.i=s,this.j=o}restartPtyHost(){return this.b.call("$restartPtyHost",[])}async createProcess(m,l,f,u,c,p,h,t){await this.c.whenRemoteConfigurationLoaded();const s=Object.create(null),o=f?this.d.getWorkspaceFolder(f)??void 0:void 0;let i;try{i=(await this.e.resolveAnyMap(o,{shellLaunchConfig:m,configuration:l})).resolvedVariables}catch(Z){this.h.error(Z)}if(i)for(const[Z,ae]of i.entries())(/^config:/.test(Z)||Z==="selectedText"||Z==="lineNumber")&&(s[Z]=ae);const n=[];for(const[Z,ae]of this.f.collections.entries())n.push([Z,(0,P.$cr)(ae.map),(0,P.$dr)(ae.descriptionMap)]);const a=await this.g.resolveAuthority(this.a),$=a.options&&a.options.extensionHostEnv,S=this.d.getWorkspace(),D=S.folders,k=f?this.d.getWorkspaceFolder(f):null,A=I.$7D.getOriginalUri(this.i.activeEditor,{supportSideBySide:I.SideBySideEditor.PRIMARY,filterByScheme:[b.Schemas.file,b.Schemas.vscodeUserData,b.Schemas.vscodeRemote]}),j={configuration:l,resolvedVariables:s,envVariableCollections:n,shellLaunchConfig:m,workspaceId:S.id,workspaceName:this.j.getWorkspaceLabel(S),workspaceFolders:D,activeWorkspaceFolder:k,activeFileResource:A,shouldPersistTerminal:c,options:u,cols:p,rows:h,unicodeVersion:t,resolverEnv:$};return await this.b.call("$createProcess",j)}requestDetachInstance(m,l){return this.b.call("$requestDetachInstance",[m,l])}acceptDetachInstanceReply(m,l){return this.b.call("$acceptDetachInstanceReply",[m,l])}attachToProcess(m){return this.b.call("$attachToProcess",[m])}detachFromProcess(m,l){return this.b.call("$detachFromProcess",[m,l])}listProcesses(){return this.b.call("$listProcesses")}getLatency(){return this.b.call("$getLatency")}getPerformanceMarks(){return this.b.call("$getPerformanceMarks")}reduceConnectionGraceTime(){return this.b.call("$reduceConnectionGraceTime")}processBinary(m,l){return this.b.call("$processBinary",[m,l])}start(m){return this.b.call("$start",[m])}input(m,l){return this.b.call("$input",[m,l])}acknowledgeDataEvent(m,l){return this.b.call("$acknowledgeDataEvent",[m,l])}setUnicodeVersion(m,l){return this.b.call("$setUnicodeVersion",[m,l])}shutdown(m,l){return this.b.call("$shutdown",[m,l])}resize(m,l,f){return this.b.call("$resize",[m,l,f])}clearBuffer(m){return this.b.call("$clearBuffer",[m])}getInitialCwd(m){return this.b.call("$getInitialCwd",[m])}getCwd(m){return this.b.call("$getCwd",[m])}orphanQuestionReply(m){return this.b.call("$orphanQuestionReply",[m])}sendCommandResult(m,l,f){return this.b.call("$sendCommandResult",[m,l,f])}freePortKillProcess(m){return this.b.call("$freePortKillProcess",[m])}installAutoReply(m,l){return this.b.call("$installAutoReply",[m,l])}uninstallAllAutoReplies(){return this.b.call("$uninstallAllAutoReplies",[])}getDefaultSystemShell(m){return this.b.call("$getDefaultSystemShell",[m])}getProfiles(m,l,f){return this.b.call("$getProfiles",[this.d.getWorkspace().id,m,l,f])}acceptPtyHostResolvedVariables(m,l){return this.b.call("$acceptPtyHostResolvedVariables",[m,l])}getEnvironment(){return this.b.call("$getEnvironment")}getWslPath(m,l){return this.b.call("$getWslPath",[m,l])}setTerminalLayoutInfo(m){const f={workspaceId:this.d.getWorkspace().id,tabs:m?m.tabs:[]};return this.b.call("$setTerminalLayoutInfo",f)}updateTitle(m,l,f){return this.b.call("$updateTitle",[m,l,f])}updateIcon(m,l,f,u){return this.b.call("$updateIcon",[m,l,f,u])}refreshProperty(m,l){return this.b.call("$refreshProperty",[m,l])}updateProperty(m,l,f){return this.b.call("$updateProperty",[m,l,f])}getTerminalLayoutInfo(){const l={workspaceId:this.d.getWorkspace().id};return this.b.call("$getTerminalLayoutInfo",l)}reviveTerminalProcesses(m,l,f){return this.b.call("$reviveTerminalProcesses",[m,l,f])}getRevivedPtyNewId(m){return this.b.call("$getRevivedPtyNewId",[m])}serializeTerminalState(m){return this.b.call("$serializeTerminalState",[m])}};e.$bN=d,e.$bN=d=Oe([Ae(2,y.$qD),Ae(3,r.$Uh),Ae(4,L.$VM),Ae(5,E.$AM),Ae(6,R.$Kk),Ae(7,v.$2q),Ae(8,w.$aC),Ae(9,C.$Ru)],d)}),define(we[276],pe([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tm=e.$sm=e.$rm=e.$qm=e.$pm=e.ExtHostConnectionType=void 0;var y;(function(C){C[C.IPC=1]="IPC",C[C.Socket=2]="Socket",C[C.MessagePort=3]="MessagePort"})(y||(e.ExtHostConnectionType=y={}));class R{constructor(E){this.pipeName=E,this.type=1}serialize(E){E[R.ENV_KEY]=this.pipeName}}e.$pm=R,R.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK";class r{constructor(){this.type=2}serialize(E){E[r.ENV_KEY]="1"}}e.$qm=r,r.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET";class P{constructor(){this.type=3}serialize(E){E[P.ENV_KEY]="1"}}e.$rm=P,P.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT";function L(C){delete C[R.ENV_KEY],delete C[r.ENV_KEY],delete C[P.ENV_KEY]}function I(C,E){L(E),C.serialize(E)}e.$sm=I;function w(C){if(C[R.ENV_KEY])return b(C,new R(C[R.ENV_KEY]));if(C[r.ENV_KEY])return b(C,new r);if(C[P.ENV_KEY])return b(C,new P);throw new Error("No connection information defined in environment!")}e.$tm=w;function b(C,E){return L(C),E}}),define(we[277],pe([1,0,15]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.$7l=e.$6l=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var R;(function(b){b[b.Desktop=1]="Desktop",b[b.Web=2]="Web"})(R||(e.UIKind=R={}));var r;(function(b){b[b.VersionMismatch=55]="VersionMismatch",b[b.UnexpectedError=81]="UnexpectedError"})(r||(e.ExtensionHostExitCode=r={}));var P;(function(b){b[b.Initialized=0]="Initialized",b[b.Ready=1]="Ready",b[b.Terminate=2]="Terminate"})(P||(e.MessageType=P={}));function L(b){const C=y.$_d.alloc(1);switch(b){case 0:C.writeUInt8(1,0);break;case 1:C.writeUInt8(2,0);break;case 2:C.writeUInt8(3,0);break}return C}e.$6l=L;function I(b,C){if(b.byteLength!==1)return!1;switch(b.readUInt8(0)){case 1:return C===0;case 2:return C===1;case 3:return C===2;default:return!1}}e.$7l=I;var w;(function(b){b.Start="START_NATIVE_LOG",b.End="END_NATIVE_LOG"})(w||(e.NativeLogMarkers=w={}))}),define(we[278],pe([1,0,6,5,13,265,277,56,36,22,4,2,201]),function(le,e,y,R,r,P,L,I,w,b,C,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rM=e.$qM=e.$pM=e.$oM=void 0;let d=class extends E.$Qc{constructor(f,u){super(),this.s=f,this.t=u,this.a=this.B(new R.$Ld),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new R.$Ld),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=C.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=u.createLogger(this.m,{id:w.$go,name:(0,v.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(u.onDidChangeLogLevel(c=>{(0,r.$8i)(c)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===r.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(f,u,c){const p=this.getTelemetryDetails(),h=new g(u,c,f,this.n,this.j,this.getBuiltInCommonProperties(f),{isUsageEnabled:p.isUsageEnabled,isErrorsEnabled:p.isErrorsEnabled}),t=this.r.get(f.identifier.value)??[];return this.r.set(f.identifier.value,[...t,h]),h.apiTelemetryLogger}$initializeTelemetryLevel(f,u,c){this.f=f,this.g=u,this.c=c??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(f){const u=Object.create(null);switch(u["common.extname"]=`${f.publisher}.${f.name}`,u["common.extversion"]=f.version,u["common.vscodemachineid"]=this.s.telemetryInfo.machineId,u["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,u["common.vscodeversion"]=this.s.version,u["common.isnewappinstall"]=m(this.s.telemetryInfo.firstSessionDate),u["common.product"]=this.s.environment.appHost,this.s.uiKind){case L.UIKind.Web:u["common.uikind"]="web";break;case L.UIKind.Desktop:u["common.uikind"]="desktop";break;default:u["common.uikind"]="unknown"}return u["common.remotename"]=(0,I.$Qk)((0,w.$no)(this.s.remote.authority)),u}$onDidChangeTelemetryLevel(f){this.h=this.getTelemetryConfiguration(),this.f=f;const u=this.getTelemetryDetails();this.r.forEach((c,p)=>{const h=c.filter(t=>!t.isDisposed);h.length===0?this.r.delete(p):this.r.set(p,h)}),this.r.forEach(c=>{for(const p of c)p.updateTelemetryEnablements(u.isUsageEnabled,u.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(f,u){const p=this.r.get(f.value)?.filter(t=>!t.isDisposed);if(!p)return this.r.delete(f.value),!1;let h=!1;for(const t of p)t.ignoreUnhandledExtHostErrors||(t.logError(u),h=!0);return h}};e.$oM=d,e.$oM=d=Oe([Ae(0,P.$nM),Ae(1,r.$7i)],d);class g{static validateSender(f){if(typeof f!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof f.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof f.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof f.flush<"u"&&typeof f.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(f,u,c,p,h,t,s){this.g=c,this.h=p,this.i=h,this.j=t,this.a=new R.$Ld,this.ignoreUnhandledExtHostErrors=u?.ignoreUnhandledErrors??!1,this.b=u?.ignoreBuiltInCommonProperties??!1,this.c=u?.additionalCommonProperties,this.f=f,this.d={isUsageEnabled:s.isUsageEnabled,isErrorsEnabled:s.isErrorsEnabled}}updateTelemetryEnablements(f,u){this.e&&(this.d={isUsageEnabled:f,isErrorsEnabled:u},this.a.fire(this.e))}mixInCommonPropsAndCleanData(f){let u="properties"in f?f.properties??{}:f;return u=(0,w.$qo)(u,[]),this.c&&(u=(0,b.$1m)(u,this.c)),this.b||(u=(0,b.$1m)(u,this.j)),"properties"in f?f.properties=u:f=u,f}k(f,u){this.f&&(this.g.publisher==="vscode"?f=this.g.name+"/"+f:f=this.g.identifier.value+"/"+f,u=this.mixInCommonPropsAndCleanData(u||{}),this.i||this.f?.sendEventData(f,u),this.h.trace(f,u))}logUsage(f,u){this.d.isUsageEnabled&&this.k(f,u)}logError(f,u){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof f=="string")this.k(f,u);else{const c={name:f.name,message:f.message,stack:f.stack,cause:f.cause},p=(0,w.$qo)(c,[]),h=new Error(p.message,{cause:p.cause});h.stack=p.stack,h.name=p.name,u=this.mixInCommonPropsAndCleanData(u||{}),this.i||this.f.sendErrorData(h,u),this.h.trace("exception",u)}}get apiTelemetryLogger(){if(!this.e){const f=this,u={logUsage:f.logUsage.bind(f),get isUsageEnabled(){return f.d.isUsageEnabled},get isErrorsEnabled(){return f.d.isErrorsEnabled},logError:f.logError.bind(f),dispose:f.dispose.bind(f),onDidChangeEnableStates:f.a.event.bind(f)};this.e=Object.freeze(u)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let f=this.f;this.f=void 0,Promise.resolve(f.flush()).then(f=void 0),this.e=void 0}else this.f=void 0}}e.$pM=g;function m(l){const f=Date.now()-new Date(l).getTime();return isNaN(f)?!1:f<1e3*60*60*24}e.$qM=m,e.$rM=(0,y.$Lh)("IExtHostTelemetry")}),define(we[279],pe([1,0,40,204,53]),function(le,e,y,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wN=void 0;function P(L,I,w,b){const C=new y.$Zl;return L.forEach(E=>{const v=C.get(E.identifier);v&&b.warn((0,R.localize)(0,null,v.extensionLocation.fsPath,E.extensionLocation.fsPath)),C.set(E.identifier,E)}),I.forEach(E=>{const v=C.get(E.identifier);if(v)if(v.isBuiltin){if(r.gte(v.version,E.version)){b.warn(`Skipping extension ${E.extensionLocation.path} in favour of the builtin extension ${v.extensionLocation.path}.`);return}E.isBuiltin=!0}else b.warn((0,R.localize)(1,null,v.extensionLocation.fsPath,E.extensionLocation.fsPath));else if(E.isBuiltin){b.warn(`Skipping obsolete builtin extension ${E.extensionLocation.path}`);return}C.set(E.identifier,E)}),w.forEach(E=>{b.info((0,R.localize)(2,null,E.extensionLocation.fsPath));const v=C.get(E.identifier);v&&v.isBuiltin&&(E.isBuiltin=!0),C.set(E.identifier,E)}),Array.from(C.values())}e.$wN=P}),define(we[280],pe([1,0,7,3,28,4,41,51,66,57,279,12]),function(le,e,y,R,r,P,L,I,w,b,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AN=e.$zN=void 0;class v{constructor(m,l,f,u,c,p,h){this.c=m,this.d=f,this.f=u,this.g=c,this.h=p,this.i=h,this.a=Promise.resolve(),this.b=Promise.resolve();const t=l.args["install-builtin-extension"];if(t){c.trace("Installing builtin extensions passed via args...");const o={isMachineScoped:!!l.args["do-not-sync"],installPreReleaseVersion:!!l.args["pre-release"]};L.mark("code/server/willInstallBuiltinExtensions"),this.b=this.a=m.installExtensions([],this.j(t),o,!!l.args.force).then(()=>{L.mark("code/server/didInstallBuiltinExtensions"),c.trace("Finished installing builtin extensions")},i=>{c.error(i)})}const s=l.args["install-extension"];s&&(c.trace("Installing extensions passed via args..."),this.b=this.a.then(()=>m.installExtensions(this.j(s),[],{isMachineScoped:!!l.args["do-not-sync"],installPreReleaseVersion:!!l.args["pre-release"],isApplicationScoped:!0},!!l.args.force)).then(()=>{c.trace("Finished installing extensions")},o=>{c.error(o)}))}j(m){return m.map(l=>/\.vsix$/i.test(l)?P.URI.file((0,y.$gc)(l)?l:(0,y.$hc)((0,r.cwd)(),l)):l)}whenExtensionsReady(){return this.b}async scanExtensions(m,l,f,u){L.mark("code/server/willScanExtensions"),this.g.trace(`Scanning extensions using UI language: ${m}`),await this.a;const c=f?f.filter(h=>h.scheme===E.Schemas.file).map(h=>h.fsPath):void 0;l=l??this.d.defaultProfile.extensionsResource;const p=await this.k(l,m??R.$q,c,u);return this.g.trace("Scanned Extensions",p),this.r(p),L.mark("code/server/didScanExtensions"),p}async scanSingleExtension(m,l,f){await this.a;const u=m.scheme===E.Schemas.file?m.fsPath:null;if(!u)return null;const c=await this.o(u,l,f??R.$q);return c?(this.r([c]),c):null}async k(m,l,f,u){await this.q(l,u);const[c,p,h]=await Promise.all([this.m(l),this.n(m,l),this.l(l,f)]);return(0,C.$wN)(c,p,h,this.g)}async l(m,l){return l?(await Promise.all(l.map(f=>this.f.scanOneOrMultipleExtensions(P.URI.file((0,y.$ic)(f)),1,{language:m})))).flat().map(f=>(0,b.$tp)(f,!0)):[]}async m(m){return(await this.f.scanSystemExtensions({language:m,useCache:!0})).map(f=>(0,b.$tp)(f,!1))}async n(m,l){return(await this.f.scanUserExtensions({profileLocation:m,language:l,useCache:!0})).map(u=>(0,b.$tp)(u,!1))}async o(m,l,f){const u=P.URI.file((0,y.$ic)(m)),c=l?0:1,p=await this.f.scanExistingExtension(u,c,{language:f});return p?(0,b.$tp)(p,!1):null}async q(m,l){if(!(m===R.$a||!this.h.isEnabled())){try{if((await this.i.getInstalledLanguages()).find(u=>u.id===m)){this.g.trace(`Language Pack ${m} is already installed. Skipping language pack installation.`);return}}catch(f){this.g.error(f)}if(!l){this.g.trace(`No language pack id provided for language ${m}. Skipping language pack installation.`);return}this.g.trace(`Language Pack ${l} for language ${m} is not installed. It will be installed now.`);try{await this.c.installExtensions([l],[],{isMachineScoped:!0},!0)}catch(f){this.g.error(f)}}}r(m){const l=(t,s)=>t.replace(/file/g,"vscode-remote"),f=t=>{let s="";return s+=t.global?"g":"",s+=t.ignoreCase?"i":"",s+=t.multiline?"m":"",new RegExp(l(t.source,!0),s)},u=new class{mapDefined(t){return w.$Oi.create(t)}mapNot(t){return w.$Ti.create(t)}mapEquals(t,s){return t==="resourceScheme"&&typeof s=="string"?w.$Pi.create(t,l(s,!1)):w.$Pi.create(t,s)}mapNotEquals(t,s){return t==="resourceScheme"&&typeof s=="string"?w.$Si.create(t,l(s,!1)):w.$Si.create(t,s)}mapGreater(t,s){return w.$Ui.create(t,s)}mapGreaterEquals(t,s){return w.$Vi.create(t,s)}mapSmaller(t,s){return w.$Wi.create(t,s)}mapSmallerEquals(t,s){return w.$Xi.create(t,s)}mapRegex(t,s){return t==="resourceScheme"&&s?w.$Yi.create(t,f(s)):w.$Yi.create(t,s)}mapIn(t,s){return w.$Qi.create(t,s)}mapNotIn(t,s){return w.$Ri.create(t,s)}},c=t=>{if(!t||!t.when||!/resourceScheme/.test(t.when))return;const s=w.$Ji.deserialize(t.when);if(!s)return;const o=s.map(u);t.when=o.serialize()},p=t=>{if(Array.isArray(t))for(const s of t)c(s);else c(t)},h=t=>{for(const s in t)p(t[s])};m.forEach(t=>{t.contributes&&(t.contributes.menus&&h(t.contributes.menus),t.contributes.keybindings&&p(t.contributes.keybindings),t.contributes.views&&h(t.contributes.views))})}}e.$zN=v;class d{constructor(m,l){this.a=m,this.b=l}listen(m,l){throw new Error("Invalid listen")}async call(m,l,f){const u=this.b(m);switch(l){case"whenExtensionsReady":return this.a.whenExtensionsReady();case"scanExtensions":{const c=f[0],p=f[1]?P.URI.revive(u.transformIncoming(f[1])):void 0,h=Array.isArray(f[2])?f[2].map(o=>P.URI.revive(u.transformIncoming(o))):void 0,t=f[3];return(await this.a.scanExtensions(c,p,h,t)).map(o=>(0,I.$Fm)(o,u))}case"scanSingleExtension":{const c=await this.a.scanSingleExtension(P.URI.revive(u.transformIncoming(f[0])),f[1],f[2]);return c?(0,I.$Fm)(c,u):null}}throw new Error("Invalid call")}}e.$AN=d}),define(we[137],pe([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iv=e.$hv=e.$gv=e.$fv=void 0;class y{constructor(w){this._proxyIdentifierBrand=void 0,this.sid=w,this.nid=++y.count}}e.$fv=y,y.count=0;const R=[];function r(I){const w=new y(I);return R[w.nid]=w,w}e.$gv=r;function P(I){return R[I].sid}e.$hv=P;class L{constructor(w){this.value=w}}e.$iv=L}),define(we[281],pe([1,0,137]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0J=e.$9J=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$8J=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var R;(function(m){m[m.Default=0]="Default",m[m.InCenter=1]="InCenter",m[m.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",m[m.AtTop=3]="AtTop"})(R||(e.TextEditorRevealType=R={}));var r;(function(m){m[m.UnknownInput=0]="UnknownInput",m[m.TextInput=1]="TextInput",m[m.TextDiffInput=2]="TextDiffInput",m[m.TextMergeInput=3]="TextMergeInput",m[m.NotebookInput=4]="NotebookInput",m[m.NotebookDiffInput=5]="NotebookDiffInput",m[m.CustomEditorInput=6]="CustomEditorInput",m[m.WebviewEditorInput=7]="WebviewEditorInput",m[m.TerminalEditorInput=8]="TerminalEditorInput",m[m.InteractiveEditorInput=9]="InteractiveEditorInput"})(r||(e.TabInputKind=r={}));var P;(function(m){m[m.TAB_OPEN=0]="TAB_OPEN",m[m.TAB_CLOSE=1]="TAB_CLOSE",m[m.TAB_UPDATE=2]="TAB_UPDATE",m[m.TAB_MOVE=3]="TAB_MOVE"})(P||(e.TabModelOperationKind=P={}));var L;(function(m){m[m.Editable=0]="Editable",m[m.SupportsHotExit=1]="SupportsHotExit"})(L||(e.WebviewEditorCapabilities=L={}));var I;(function(m){m[m.Int8Array=1]="Int8Array",m[m.Uint8Array=2]="Uint8Array",m[m.Uint8ClampedArray=3]="Uint8ClampedArray",m[m.Int16Array=4]="Int16Array",m[m.Uint16Array=5]="Uint16Array",m[m.Int32Array=6]="Int32Array",m[m.Uint32Array=7]="Uint32Array",m[m.Float32Array=8]="Float32Array",m[m.Float64Array=9]="Float64Array",m[m.BigInt64Array=10]="BigInt64Array",m[m.BigUint64Array=11]="BigUint64Array"})(I||(e.WebviewMessageArrayBufferViewType=I={}));var w;(function(m){m[m.Text=1]="Text",m[m.Error=2]="Error",m[m.Rich=3]="Rich"})(w||(e.CellOutputKind=w={}));var b;(function(m){m[m.Default=0]="Default",m[m.InCenter=1]="InCenter",m[m.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",m[m.AtTop=3]="AtTop"})(b||(e.NotebookEditorRevealType=b={}));var C;(function(m){m[m.None=0]="None",m[m.Process=1]="Process",m[m.Output=2]="Output"})(C||(e.CandidatePortSource=C={}));class E{static mixin(l){return l._id=E.a++,l}}e.$8J=E,E.a=0;var v;(function(m){m.label="a",m.kind="b",m.detail="c",m.documentation="d",m.sortText="e",m.filterText="f",m.preselect="g",m.insertText="h",m.insertTextRules="i",m.range="j",m.commitCharacters="k",m.additionalTextEdits="l",m.kindModifier="m",m.commandIdent="n",m.commandId="o",m.commandArguments="p"})(v||(e.ISuggestDataDtoField=v={}));var d;(function(m){m.defaultRanges="a",m.completions="b",m.isIncomplete="c",m.duration="d"})(d||(e.ISuggestResultDtoField=d={}));var g;(function(m){m[m.Workspace=0]="Workspace",m[m.TextDocument=1]="TextDocument"})(g||(e.ExtHostTestingResource=g={})),e.$9J={MainThreadAuthentication:(0,y.$gv)("MainThreadAuthentication"),MainThreadBulkEdits:(0,y.$gv)("MainThreadBulkEdits"),MainThreadChatProvider:(0,y.$gv)("MainThreadChatProvider"),MainThreadChatSlashCommands:(0,y.$gv)("MainThreadChatSlashCommands"),MainThreadChatAgents:(0,y.$gv)("MainThreadChatAgents"),MainThreadChatVariables:(0,y.$gv)("MainThreadChatVariables"),MainThreadClipboard:(0,y.$gv)("MainThreadClipboard"),MainThreadCommands:(0,y.$gv)("MainThreadCommands"),MainThreadComments:(0,y.$gv)("MainThreadComments"),MainThreadConfiguration:(0,y.$gv)("MainThreadConfiguration"),MainThreadConsole:(0,y.$gv)("MainThreadConsole"),MainThreadDebugService:(0,y.$gv)("MainThreadDebugService"),MainThreadDecorations:(0,y.$gv)("MainThreadDecorations"),MainThreadDiagnostics:(0,y.$gv)("MainThreadDiagnostics"),MainThreadDialogs:(0,y.$gv)("MainThreadDiaglogs"),MainThreadDocuments:(0,y.$gv)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,y.$gv)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,y.$gv)("MainThreadTextEditors"),MainThreadEditorInsets:(0,y.$gv)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,y.$gv)("MainThreadEditorTabs"),MainThreadErrors:(0,y.$gv)("MainThreadErrors"),MainThreadTreeViews:(0,y.$gv)("MainThreadTreeViews"),MainThreadDownloadService:(0,y.$gv)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,y.$gv)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,y.$gv)("MainThreadLanguages"),MainThreadLogger:(0,y.$gv)("MainThreadLogger"),MainThreadMessageService:(0,y.$gv)("MainThreadMessageService"),MainThreadOutputService:(0,y.$gv)("MainThreadOutputService"),MainThreadProgress:(0,y.$gv)("MainThreadProgress"),MainThreadQuickDiff:(0,y.$gv)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,y.$gv)("MainThreadQuickOpen"),MainThreadStatusBar:(0,y.$gv)("MainThreadStatusBar"),MainThreadSecretState:(0,y.$gv)("MainThreadSecretState"),MainThreadStorage:(0,y.$gv)("MainThreadStorage"),MainThreadTelemetry:(0,y.$gv)("MainThreadTelemetry"),MainThreadTerminalService:(0,y.$gv)("MainThreadTerminalService"),MainThreadWebviews:(0,y.$gv)("MainThreadWebviews"),MainThreadWebviewPanels:(0,y.$gv)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,y.$gv)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,y.$gv)("MainThreadCustomEditors"),MainThreadUrls:(0,y.$gv)("MainThreadUrls"),MainThreadUriOpeners:(0,y.$gv)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,y.$gv)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,y.$gv)("MainThreadWorkspace"),MainThreadFileSystem:(0,y.$gv)("MainThreadFileSystem"),MainThreadExtensionService:(0,y.$gv)("MainThreadExtensionService"),MainThreadSCM:(0,y.$gv)("MainThreadSCM"),MainThreadSearch:(0,y.$gv)("MainThreadSearch"),MainThreadShare:(0,y.$gv)("MainThreadShare"),MainThreadTask:(0,y.$gv)("MainThreadTask"),MainThreadWindow:(0,y.$gv)("MainThreadWindow"),MainThreadLabelService:(0,y.$gv)("MainThreadLabelService"),MainThreadNotebook:(0,y.$gv)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,y.$gv)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,y.$gv)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,y.$gv)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,y.$gv)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,y.$gv)("MainThreadInteractive"),MainThreadChat:(0,y.$gv)("MainThreadChat"),MainThreadInlineChat:(0,y.$gv)("MainThreadInlineChatShape"),MainThreadTheming:(0,y.$gv)("MainThreadTheming"),MainThreadTunnelService:(0,y.$gv)("MainThreadTunnelService"),MainThreadManagedSockets:(0,y.$gv)("MainThreadManagedSockets"),MainThreadTimeline:(0,y.$gv)("MainThreadTimeline"),MainThreadTesting:(0,y.$gv)("MainThreadTesting"),MainThreadLocalization:(0,y.$gv)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,y.$gv)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,y.$gv)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,y.$gv)("MainThreadIssueReporter")},e.$0J={ExtHostCommands:(0,y.$gv)("ExtHostCommands"),ExtHostConfiguration:(0,y.$gv)("ExtHostConfiguration"),ExtHostDiagnostics:(0,y.$gv)("ExtHostDiagnostics"),ExtHostDebugService:(0,y.$gv)("ExtHostDebugService"),ExtHostDecorations:(0,y.$gv)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,y.$gv)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,y.$gv)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,y.$gv)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,y.$gv)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,y.$gv)("ExtHostEditors"),ExtHostTreeViews:(0,y.$gv)("ExtHostTreeViews"),ExtHostFileSystem:(0,y.$gv)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,y.$gv)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,y.$gv)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,y.$gv)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,y.$gv)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,y.$gv)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,y.$gv)("ExtHostQuickDiff"),ExtHostStatusBar:(0,y.$gv)("ExtHostStatusBar"),ExtHostShare:(0,y.$gv)("ExtHostShare"),ExtHostExtensionService:(0,y.$gv)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,y.$gv)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,y.$gv)("ExtHostTerminalService"),ExtHostSCM:(0,y.$gv)("ExtHostSCM"),ExtHostSearch:(0,y.$gv)("ExtHostSearch"),ExtHostTask:(0,y.$gv)("ExtHostTask"),ExtHostWorkspace:(0,y.$gv)("ExtHostWorkspace"),ExtHostWindow:(0,y.$gv)("ExtHostWindow"),ExtHostWebviews:(0,y.$gv)("ExtHostWebviews"),ExtHostWebviewPanels:(0,y.$gv)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,y.$gv)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,y.$gv)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,y.$gv)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,y.$gv)("ExtHostEditorTabs"),ExtHostProgress:(0,y.$gv)("ExtHostProgress"),ExtHostComments:(0,y.$gv)("ExtHostComments"),ExtHostSecretState:(0,y.$gv)("ExtHostSecretState"),ExtHostStorage:(0,y.$gv)("ExtHostStorage"),ExtHostUrls:(0,y.$gv)("ExtHostUrls"),ExtHostUriOpeners:(0,y.$gv)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,y.$gv)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,y.$gv)("ExtHostOutputService"),ExtHosLabelService:(0,y.$gv)("ExtHostLabelService"),ExtHostNotebook:(0,y.$gv)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,y.$gv)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,y.$gv)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,y.$gv)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,y.$gv)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,y.$gv)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,y.$gv)("ExtHostInteractive"),ExtHostInlineChat:(0,y.$gv)("ExtHostInlineChatShape"),ExtHostChat:(0,y.$gv)("ExtHostChat"),ExtHostChatSlashCommands:(0,y.$gv)("ExtHostChatSlashCommands"),ExtHostChatAgents:(0,y.$gv)("ExtHostChatAgents"),ExtHostChatVariables:(0,y.$gv)("ExtHostChatVariables"),ExtHostChatProvider:(0,y.$gv)("ExtHostChatProvider"),ExtHostAiRelatedInformation:(0,y.$gv)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,y.$gv)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,y.$gv)("ExtHostTheming"),ExtHostTunnelService:(0,y.$gv)("ExtHostTunnelService"),ExtHostManagedSockets:(0,y.$gv)("ExtHostManagedSockets"),ExtHostAuthentication:(0,y.$gv)("ExtHostAuthentication"),ExtHostTimeline:(0,y.$gv)("ExtHostTimeline"),ExtHostTesting:(0,y.$gv)("ExtHostTesting"),ExtHostTelemetry:(0,y.$gv)("ExtHostTelemetry"),ExtHostLocalization:(0,y.$gv)("ExtHostLocalization"),ExtHostIssueReporter:(0,y.$gv)("ExtHostIssueReporter")}});var Rt=this&&this.__classPrivateFieldSet||function(le,e,y,R,r){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!r)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?le!==e||!r:!e.has(le))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?r.call(le,y):r?r.value=y:e.set(le,y),y},nt=this&&this.__classPrivateFieldGet||function(le,e,y,R){if(y==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?le!==e||!R:!e.has(le))throw new TypeError("Cannot read private member from an object whose class did not declare it");return y==="m"?R:y==="a"?R.call(le):R?R.value:e.get(le)};define(we[282],pe([1,0,8,131,136,22,281,18,13,50,43,108,4,2,6,266,274,15,137,39,60,36,278]),function(le,e,y,R,r,P,L,I,w,b,C,E,v,d,g,m,l,f,u,c,p,h,t){"use strict";var s,o,i;Object.defineProperty(e,"__esModule",{value:!0}),e.$xM=e.$wM=e.$vM=e.$uM=e.$tM=e.$sM=void 0;let n=class{constructor(A,j,Z){s.set(this,void 0),this.b=new Map,this.c=new Map,o.set(this,void 0),i.set(this,void 0),Rt(this,s,A.getProxy(L.$9J.MainThreadCommands),"f"),this.d=j,Rt(this,i,Z,"f"),Rt(this,o,A.getProxy(L.$9J.MainThreadTelemetry),"f"),this.converter=new a(this,ae=>{const K=this.c.get(ae);return K?.result===S.Void?K:void 0},j),this.f=[{processArgument(ae){return(0,b.$ih)(ae)}},{processArgument(ae){return(0,P.$Zm)(ae,function(K){if(C.$ms.isIRange(K))return r.Range.to(K);if(E.$ls.isIPosition(K))return r.Position.to(K);if(C.$ms.isIRange(K.range)&&v.URI.isUri(K.uri))return r.location.to(K);if(K instanceof f.$_d)return K.buffer.buffer;if(!Array.isArray(K))return K})}}]}registerArgumentProcessor(A){this.f.push(A)}registerApiCommand(A){const j=this.registerCommand(!1,A.id,async(...Z)=>{const ae=A.args.map((se,ue)=>{if(!se.validate(Z[ue]))throw new Error(`Invalid argument '${se.name}' when running '${A.id}', received: ${typeof Z[ue]=="object"?JSON.stringify(Z[ue],null,"	"):Z[ue]} `);return se.convert(Z[ue])}),K=await this.executeCommand(A.internalId,...ae);return A.result.convert(K,Z,this.converter)},void 0,{description:A.description,args:A.args,returns:A.result.description});return this.c.set(A.id,A),new R.$$J(()=>{j.dispose(),this.c.delete(A.id)})}registerCommand(A,j,Z,ae,K,se){if(this.d.trace("ExtHostCommands#registerCommand",j),!j.trim().length)throw new Error("invalid id");if(this.b.has(j))throw new Error(`command '${j}' already exists`);return this.b.set(j,{callback:Z,thisArg:ae,description:K,extension:se}),A&&nt(this,s,"f").$registerCommand(j),new R.$$J(()=>{this.b.delete(j)&&A&&nt(this,s,"f").$unregisterCommand(j)})}executeCommand(A,...j){return this.d.trace("ExtHostCommands#executeCommand",A),this.g(A,j,!0)}async g(A,j,Z){if(this.b.has(A))return nt(this,s,"f").$fireCommandActivationEvent(A),this.h(A,j,!1);{let ae=!1;const K=(0,P.$Zm)(j,function(se){if(se instanceof R.$_J)return r.Position.from(se);if(se instanceof R.$aK)return r.Range.from(se);if(se instanceof R.$kK)return r.location.from(se);if(R.$vL.isNotebookRange(se))return r.NotebookRange.from(se);if(se instanceof ArrayBuffer)return ae=!0,f.$_d.wrap(new Uint8Array(se));if(se instanceof Uint8Array)return ae=!0,f.$_d.wrap(se);if(se instanceof f.$_d)return ae=!0,se;if(!Array.isArray(se))return se});try{const se=await nt(this,s,"f").$executeCommand(A,ae?new u.$iv(K):K,Z);return(0,b.$ih)(se)}catch(se){if(se instanceof Error&&se.message==="$executeCommand:retry")return this.g(A,j,!1);throw se}}}async h(A,j,Z){const ae=this.b.get(A);if(!ae)throw new Error("Unknown command");const{callback:K,thisArg:se,description:ue}=ae;if(ue)for(let he=0;he<ue.args.length;he++)try{(0,y.$Nf)(j[he],ue.args[he].constraint)}catch{throw new Error(`Running the contributed command: '${A}' failed.Illegal argument '${ue.args[he].name}' - ${ue.args[he].description} `)}const x=p.$Hd.create();try{return await K.apply(se,j)}catch(he){if(A===this.converter.delegatingCommandId){const V=this.converter.getActualCommand(...j);V&&(A=V.command)}if(this.d.error(he,A,ae.extension?.identifier),!Z)throw he;if(ae.extension?.identifier){const V=nt(this,i,"f").onExtensionError(ae.extension.identifier,he);this.d.trace("forwarded error to extension?",V,ae.extension?.identifier)}throw new class extends Error{constructor(){super((0,c.$wi)(he)),this.id=A,this.source=ae.extension?.displayName??ae.extension?.name}}}finally{this.j(ae,A,x.elapsed())}}j(A,j,Z){A.extension&&nt(this,o,"f").$publicLog2("Extension:ActionExecuted",{extensionId:A.extension.identifier.value,id:new h.$bo(j),duration:Z})}$executeContributedCommand(A,...j){this.d.trace("ExtHostCommands#$executeContributedCommand",A);const Z=this.b.get(A);return Z?(j=j.map(ae=>this.f.reduce((K,se)=>se.processArgument(K,Z.extension?.identifier),ae)),this.h(A,j,!0)):Promise.reject(new Error(`Contributed command '${A}' does not exist.`))}getCommands(A=!1){return this.d.trace("ExtHostCommands#getCommands",A),nt(this,s,"f").$getCommands().then(j=>(A&&(j=j.filter(Z=>Z[0]!=="_")),j))}$getContributedCommandHandlerDescriptions(){const A=Object.create(null);for(const[j,Z]of this.b){const{description:ae}=Z;ae&&(A[j]=ae)}return Promise.resolve(A)}};e.$sM=n,s=new WeakMap,o=new WeakMap,i=new WeakMap,e.$sM=n=Oe([Ae(0,m.$0L),Ae(1,w.$6i),Ae(2,t.$rM)],n),e.$tM=(0,g.$Lh)("IExtHostCommands");class a{constructor(A,j,Z){this.d=A,this.f=j,this.g=Z,this.delegatingCommandId=`__vsc${Date.now().toString(36)} `,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(A,j){if(!A)return;const Z={$ident:void 0,id:A.command,title:A.title,tooltip:A.tooltip};if(!A.command)return Z;const ae=this.f(A.command);if(ae)Z.id=ae.internalId,Z.arguments=ae.args.map((K,se)=>K.convert(A.arguments&&A.arguments[se]));else if((0,I.$Jb)(A.arguments)){const K=`${A.command} /${++this.c}`;this.b.set(K,A),j.add((0,d.$Oc)(()=>{this.b.delete(K),this.g.trace("CommandsConverter#DISPOSE",K)})),Z.$ident=K,Z.id=this.delegatingCommandId,Z.arguments=[K],this.g.trace("CommandsConverter#CREATE",A.command,K)}return Z}fromInternal(A){return typeof A.$ident=="string"?this.b.get(A.$ident):{command:A.id,title:A.title,arguments:A.arguments}}getActualCommand(...A){return this.b.get(A[0])}h(...A){const j=this.getActualCommand(...A);return this.g.trace("CommandsConverter#EXECUTE",A[0],j?j.command:"MISSING"),j?this.d.executeCommand(j.command,...j.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${A[0]}`)}}e.$uM=a;class ${static Arr(A){return new $(`${A.name}_array`,`Array of ${A.name}, ${A.description}`,j=>Array.isArray(j)&&j.every(Z=>A.validate(Z)),j=>j.map(Z=>A.convert(Z)))}constructor(A,j,Z,ae){this.name=A,this.description=j,this.validate=Z,this.convert=ae}optional(){return new $(this.name,`(optional) ${this.description}`,A=>A==null||this.validate(A),A=>A===void 0?void 0:A===null?null:this.convert(A))}with(A,j){return new $(A??this.name,j??this.description,this.validate,this.convert)}}e.$vM=$,$.Uri=new $("uri","Uri of a text document",k=>v.URI.isUri(k),k=>k),$.Position=new $("position","A position in a text document",k=>R.$_J.isPosition(k),r.Position.from),$.Range=new $("range","A range in a text document",k=>R.$aK.isRange(k),r.Range.from),$.Selection=new $("selection","A selection in a text document",k=>R.$bK.isSelection(k),r.Selection.from),$.Number=new $("number","",k=>typeof k=="number",k=>k),$.String=new $("string","",k=>typeof k=="string",k=>k),$.StringArray=$.Arr($.String),$.CallHierarchyItem=new $("item","A call hierarchy item",k=>k instanceof R.$uK,r.CallHierarchyItem.from),$.TypeHierarchyItem=new $("item","A type hierarchy item",k=>k instanceof R.$OL,r.TypeHierarchyItem.from),$.TestItem=new $("testItem","A VS Code TestItem",k=>k instanceof l.$kM,r.TestItem.from);class S{constructor(A,j){this.description=A,this.convert=j}}e.$wM=S,S.Void=new S("no result",k=>k);class D{constructor(A,j,Z,ae,K){this.id=A,this.internalId=j,this.description=Z,this.args=ae,this.result=K}}e.$xM=D}),define(we[283],pe([1,0,11,2,12,217]),function(le,e,y,R,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fN=e.$eN=void 0,e.$eN="remoteFilesystem";class L extends P.$dN{static register(w,b,C){const E=w.getConnection();if(!E)return R.$Qc.None;const v=new R.$Pc,d=(async()=>{try{const g=await w.getRawEnvironment();g?b.registerProvider(r.Schemas.vscodeRemote,v.add(new L(g,E))):C.error("Cannot register remote filesystem provider. Remote environment doesnot exist.")}catch(g){C.error("Cannot register remote filesystem provider. Error while fetching remote environment.",(0,y.$8)(g))}})();return v.add(b.onWillActivateFileSystemProvider(g=>{g.scheme===r.Schemas.vscodeRemote&&g.join(d)})),v}constructor(w,b){super(b.getChannel(e.$eN),{pathCaseSensitive:w.os===3})}}e.$fN=L}),define(we[93],pe([1,0,29,14,7,8,21,169,301,302]),function(le,e,y,R,r,P,L,I,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gp=e.$fp=e.zip=e.$dp=e.$cp=void 0,e.$cp="end of central directory record signature not found";const C=new RegExp(e.$cp);class E extends Error{constructor(s,o){let i=o.message;switch(s){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i),this.type=s,this.cause=o}}e.$dp=E;function v(t){const s=t.externalFileAttributes>>16||33188;return[448,56,7].map(o=>s&o).reduce((o,i)=>o+i,s&61440)}function d(t){if(t instanceof E)return t;let s;return C.test(t.message)&&(s="CorruptZip"),new E(s,t)}function g(t,s,o,i,n,a){const $=r.$kc(s),S=r.$hc(i,$);if(!S.startsWith(i))return Promise.reject(new Error(I.localize(0,null,s)));const D=r.$hc(i,s);let k;return a.onCancellationRequested(()=>{k?.destroy()}),Promise.resolve(L.Promises.mkdir(S,{recursive:!0})).then(()=>new Promise((A,j)=>{if(!a.isCancellationRequested)try{k=(0,y.createWriteStream)(D,{mode:o}),k.once("close",()=>A()),k.once("error",j),t.once("error",j),t.pipe(k)}catch(Z){j(Z)}}))}function m(t,s,o,i){let n=(0,R.$Eg)(()=>Promise.resolve()),a=0;const $=i.onCancellationRequested(()=>{n.cancel(),t.close()});return new Promise((S,D)=>{const k=new R.$Lg,A=j=>{j.isCancellationRequested||(a++,t.readEntry())};t.once("error",D),t.once("close",()=>n.then(()=>{i.isCancellationRequested||t.entryCount===a?S():D(new E("Incomplete",new Error(I.localize(1,null,a,t.entryCount))))},D)),t.readEntry(),t.on("entry",j=>{if(i.isCancellationRequested)return;if(!o.sourcePathRegex.test(j.fileName)){A(i);return}const Z=j.fileName.replace(o.sourcePathRegex,"");if(/\/$/.test(Z)){const se=r.$hc(s,Z);n=(0,R.$Eg)(ue=>L.Promises.mkdir(se,{recursive:!0}).then(()=>A(ue)).then(void 0,D));return}const ae=f(t,j),K=v(j);n=(0,R.$Eg)(se=>k.queue(()=>ae.then(ue=>g(ue,Z,K,s,o,se).then(()=>A(se)))).then(null,D))})}).finally(()=>$.dispose())}function l(t,s=!1){return new Promise((o,i)=>{(0,w.open)(t,s?{lazyEntries:!0}:void 0,(n,a)=>{n?i(d(n)):o((0,P.$Hf)(a))})})}function f(t,s){return new Promise((o,i)=>{t.openReadStream(s,(n,a)=>{n?i(d(n)):o((0,P.$Hf)(a))})})}function u(t,s){return new Promise((o,i)=>{const n=new b.ZipFile;s.forEach($=>{$.contents?n.addBuffer(typeof $.contents=="string"?Buffer.from($.contents,"utf8"):$.contents,$.path):$.localPath&&n.addFile($.localPath,$.path)}),n.end();const a=(0,y.createWriteStream)(t);n.outputStream.pipe(a),n.outputStream.once("error",i),a.once("error",i),a.once("finish",()=>o(t))})}e.zip=u;function c(t,s,o={},i){const n=new RegExp(o.sourcePath?`^${o.sourcePath}`:"");let a=l(t,!0);return o.overwrite&&(a=a.then($=>L.Promises.rm(s).then(()=>$))),a.then($=>m($,s,{sourcePathRegex:n},i))}e.$fp=c;function p(t,s){return l(t).then(o=>new Promise((i,n)=>{o.on("entry",a=>{a.fileName===s&&f(o,a).then($=>i($),$=>n($))}),o.once("close",()=>n(new Error(I.localize(2,null,s))))}))}function h(t,s){return p(t,s).then(o=>new Promise((i,n)=>{const a=[];o.once("error",n),o.on("data",$=>a.push($)),o.on("end",()=>i(Buffer.concat(a)))}))}e.$gp=h}),define(we[284],pe([1,0,14,11,2,12,19,53,8,23,21,93,24,25,30,37,81,16,13]),function(le,e,y,R,r,P,L,I,w,b,C,E,v,d,g,m,l,f,u){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.$vp=void 0;let p=c=class extends r.$Qc{constructor(t,s,o,i,n,a){super(),this.h=s,this.j=o,this.m=i,this.n=n,this.r=a,this.extensionsDownloadDir=t.extensionsDownloadLocation,this.f=20,this.g=this.y()}async download(t,s,o){await this.g;const i=(0,L.$sg)(this.extensionsDownloadDir,this.z(t));try{await this.w(t,i,a=>this.j.download(t,a,s))}catch(a){throw new g.$3n(a.message,g.ExtensionManagementErrorCode.Download)}let n=!1;if(o&&this.t(t)){const a=await this.u(t);try{n=await this.n.verify(i.fsPath,a.fsPath,this.r.getLevel()===u.LogLevel.Trace)}catch($){const S=$;if(n=S.code,S.output&&this.r.trace(`Extension signature verification details for ${t.identifier.id} ${t.version}:
${S.output}`),n===g.ExtensionSignaturetErrorCode.PackageIsInvalidZip||n===g.ExtensionSignaturetErrorCode.SignatureArchiveIsInvalidZip)throw new g.$3n(E.$cp,g.ExtensionManagementErrorCode.CorruptZip)}finally{try{await this.delete(a)}catch($){this.r.error($)}}}return n===!0?this.r.info(`Extension signature is verified: ${t.identifier.id}`):n===!1?this.r.info(`Extension signature verification is not done: ${t.identifier.id}`):this.r.warn(`Extension signature verification failed with error '${n}': ${t.identifier.id}`),{location:i,verificationStatus:n}}t(t){if(!t.isSigned)return!1;const s=this.m.getValue("extensions.verifySignature");return(0,w.$Cf)(s)?s:!0}async u(t){await this.g;const s=(0,L.$sg)(this.extensionsDownloadDir,`${this.z(t)}${c.c}`);return await this.w(t,s,o=>this.j.downloadSignatureArchive(t,o)),s}async w(t,s,o){if(await this.h.exists(s))return;if(s.scheme!==P.Schemas.file){await o(s);return}const i=(0,L.$sg)(this.extensionsDownloadDir,`.${(0,b.$bg)()}`);await this.h.exists(i)||await o(i);try{await C.Promises.rename(i.fsPath,s.fsPath,2*60*1e3)}catch(n){try{await this.h.del(i)}catch{}if(n.code==="ENOTEMPTY")this.r.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",t.identifier.id,s.path);else throw this.r.info(`Rename failed because of ${(0,R.$8)(n)}. Deleted the file from downloaded location`,i.path),n}}async delete(t){await this.g,await this.h.del(t)}async y(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.r.trace("Extension VSIX downloads cache dir does not exist");return}const t=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(t.children){const s=[],o=[],i=[];for(const $ of t.children)if($.name.endsWith(c.c))i.push($.resource);else{const S=m.$so.parse($.name);S&&o.push([S,$])}const n=(0,m.$xo)(o,([$])=>$),a=[];for(const $ of n)$.sort((S,D)=>I.rcompare(S[0].version,D[0].version)),s.push(...$.slice(1).map(S=>S[1].resource)),a.push($[0][1]);a.sort(($,S)=>$.mtime-S.mtime),s.push(...a.slice(0,Math.max(0,a.length-this.f)).map($=>$.resource)),s.push(...i),await y.Promises.settled(s.map($=>(this.r.trace("Deleting from cache",$.path),this.h.del($))))}}catch(t){this.r.error(t)}}z(t){return this.f?m.$so.create(t).toString().toLowerCase():(0,b.$bg)()}};e.$vp=p,p.c=".sigzip",e.$vp=p=c=Oe([Ae(0,d.$Th),Ae(1,f.$7j),Ae(2,g.$2n),Ae(3,v.$fi),Ae(4,l.$9o),Ae(5,u.$6i)],p)}),define(we[285],pe([1,0,93,183]),function(le,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xp=void 0;function r(P){return(0,y.$gp)(P,"extension/package.json").then(L=>{try{return JSON.parse(L.toString("utf8"))}catch{throw new Error((0,R.localize)(0,null))}})}e.$xp=r}),define(we[138],pe([1,0,14,15,20,39,11,5,61,2,26,12,7,19,53,8,4,23,21,93,182,80,25,255,30,37,45,57,284,256,285,230,239,79,16,6,13,31,32,34,33]),function(le,e,y,R,r,P,L,I,w,b,C,E,v,d,g,m,l,f,u,c,p,h,t,s,o,i,n,a,$,S,D,k,A,j,Z,ae,K,se,ue,x,he){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dp=e.$Cp=e.$Bp=e.$Ap=void 0,e.$Ap=(0,ae.$Mh)(o.$4n);const V=".vsctmp";let te=class extends s.$hp{constructor(B,ee,O,N,Q,T,H,U,ie,z,_,W){super(B,ee,_,O,z,W),this.fb=Q,this.gb=T,this.hb=H,this.ib=ie,this.eb=new Map,this.rb=new C.$zc;const X=this.B(U.createInstance(S.$wp));this.bb=this.B(U.createInstance(G,ge=>X.postUninstall(ge))),this.cb=this.B(new k.$yp(W,ie,_,this,this.F)),this.db=this.B(U.createInstance($.$vp));const oe=this.B(new A.$zp(this,this.fb,W,T,_,ie,O));this.B(oe.onDidChangeExtensionsByAnotherSource(ge=>this.qb(ge))),this.sb()}getTargetPlatform(){return this.jb||(this.jb=(0,i.$Co)(this.ib,this.F)),this.jb}async zip(B){this.F.trace("ExtensionManagementService#zip",B.identifier.id);const ee=await this.pb(B),O=await(0,c.zip)((0,d.$sg)(this.db.extensionsDownloadDir,(0,f.$bg)()).fsPath,ee);return l.URI.file(O)}async unzip(B){return this.F.trace("ExtensionManagementService#unzip",B.toString()),(await this.install(B)).identifier}async getManifest(B){const{location:ee,cleanup:O}=await this.lb(B),N=v.$ic(ee.fsPath);try{return await(0,D.$xp)(N)}finally{await O()}}getInstalled(B,ee=this.H.defaultProfile.extensionsResource){return this.bb.scanExtensions(B??null,ee)}scanAllUserInstalledExtensions(){return this.bb.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(B){return this.bb.scanUserExtensionAtLocation(B)}async install(B,ee={}){this.F.trace("ExtensionManagementService#install",B.toString());const{location:O,cleanup:N}=await this.lb(B);try{const Q=await(0,D.$xp)(v.$ic(O.fsPath)),T=(0,i.$wo)(Q.publisher,Q.name);if(Q.engines&&Q.engines.vscode&&!(0,j.$Jo)(Q.engines.vscode,this.G.version,this.G.date))throw new Error(p.localize(0,null,T,this.G.version));const U=(await this.I([{manifest:Q,extension:O,options:ee}])).find(({identifier:ie})=>(0,i.$ro)(ie,{id:T}));if(U?.local)return U.local;throw U?.error?U.error:(0,s.$jp)(new Error(`Unknown error while installing extension ${T}`))}finally{await N()}}async installFromLocation(B,ee){this.F.trace("ExtensionManagementService#installFromLocation",B.toString());const O=await this.bb.scanUserExtensionAtLocation(B);if(!O)throw new Error(`Cannot find a valid extension from the location ${B.toString()}`);return await this.ub([[O,void 0]],ee),this.F.info("Successfully installed extension",O.identifier.id,ee.toString()),O}async installExtensionsFromProfile(B,ee,O){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",B,ee.toString(),O.toString());const N=(await this.bb.scanExtensions(1,ee)).filter(Q=>B.some(T=>(0,i.$ro)(T,Q.identifier)));if(N.length){const Q=await Promise.all(N.map(T=>this.bb.scanMetadata(T,ee)));await this.ub(N.map((T,H)=>[T,Q[H]]),O),this.F.info("Successfully installed extensions",N.map(T=>T.identifier.id),O.toString())}return N}async updateMetadata(B,ee,O=this.H.defaultProfile.extensionsResource){return this.F.trace("ExtensionManagementService#updateMetadata",B.identifier.id),ee.isPreReleaseVersion&&(ee.preRelease=!0),ee.isMachineScoped=ee.isMachineScoped||void 0,ee.isBuiltin=ee.isBuiltin||void 0,ee.pinned=ee.pinned||void 0,B=await this.bb.updateMetadata(B,ee,O),this.cb.invalidate(O),this.w.fire(B),B}async reinstallFromGallery(B){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",B.identifier.id),!this.z.isEnabled())throw new Error(p.localize(1,null));const ee=await this.getTargetPlatform(),[O]=await this.z.getExtensions([{...B.identifier,preRelease:B.preRelease}],{targetPlatform:ee,compatible:!0},r.CancellationToken.None);if(!O)throw new Error(p.localize(2,null));await this.bb.setUninstalled(B);try{await this.bb.removeUninstalledExtension(B)}catch(N){throw new Error(p.localize(3,null,(0,P.$wi)(N)))}return this.installFromGallery(O)}ab(B,ee,O,N){return this.bb.copyExtension(B,ee,O,N)}copyExtensions(B,ee){return this.bb.copyExtensions(B,ee)}markAsUninstalled(...B){return this.bb.setUninstalled(...B)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.bb.cleanUp()}catch(B){this.F.error(B)}}async download(B,ee,O){const{location:N}=await this.db.download(B,ee,!O);return N}async lb(B){if(B.scheme===E.Schemas.file)return{location:B,async cleanup(){}};this.F.trace("Downloading extension from",B.toString());const ee=(0,d.$sg)(this.db.extensionsDownloadDir,(0,f.$bg)());return await this.hb.download(B,ee),this.F.info("Downloaded extension to",ee.toString()),{location:ee,cleanup:async()=>{try{await this.ib.del(ee)}catch(N){this.F.error(N)}}}}Y(){return this.H.defaultProfile.extensionsResource}Z(B,ee,O){if(l.URI.isUri(ee))return new ne(B,ee,O,this.z,this.bb,this.D,this.H,this.fb,this.gb,this.F);const N=i.$so.create(ee).toString();let Q=this.eb.get(N);return Q||(this.eb.set(N,Q=new q(B,ee,O,this.db,this.bb,this.D,this.H,this.fb,this.gb,this.F)),Q.waitUntilTaskIsFinished().finally(()=>this.eb.delete(N))),Q}$(B,ee){return new me(B,ee.profileLocation,this.gb)}async pb(B){const ee=async N=>{let Q=await u.Promises.readdir(N);Q=Q.map(U=>v.$hc(N,U));const T=await Promise.all(Q.map(U=>u.Promises.stat(U)));let H=Promise.resolve([]);return T.forEach((U,ie)=>{const z=Q[ie];U.isFile()&&(H=H.then(_=>[..._,z])),U.isDirectory()&&(H=H.then(_=>ee(z).then(W=>[..._,...W])))}),H};return(await ee(B.location.fsPath)).map(N=>({path:`extension/${v.$jc(B.location.fsPath,N)}`,localPath:N}))}async qb({added:B,removed:ee}){if(ee){const O=B&&this.D.extUri.isEqual(ee.profileLocation,B.profileLocation)?ee.extensions.filter(N=>B.extensions.every(Q=>!(0,i.$ro)(Q,N))):ee.extensions;for(const N of O)this.F.info("Extensions removed from another source",N.id,ee.profileLocation.toString()),this.u.fire({identifier:N,profileLocation:ee.profileLocation})}if(B){const N=(await this.bb.scanExtensions(1,B.profileLocation)).filter(Q=>B.extensions.some(T=>(0,i.$ro)(T,Q.identifier)));this.s.fire(N.map(Q=>(this.F.info("Extensions added from another source",Q.identifier.id,B.profileLocation.toString()),{identifier:Q.identifier,local:Q,profileLocation:B.profileLocation,operation:1})))}}async sb(){this.B(this.bb.onExtract(ee=>this.rb.add(ee)));const B=await this.ib.resolve(this.fb.userExtensionsLocation);for(const ee of B.children??[])ee.isDirectory&&this.rb.add(ee.resource);this.B(this.ib.watch(this.fb.userExtensionsLocation)),this.B(this.ib.onDidFilesChange(ee=>this.tb(ee)))}async tb(B){if(!B.affects(this.fb.userExtensionsLocation,1))return;const ee=[];for(const O of B.rawAdded){if(this.rb.has(O)||!this.D.extUri.isEqual(this.D.extUri.dirname(O),this.fb.userExtensionsLocation)||this.D.extUri.isEqual(O,this.D.extUri.joinPath(this.fb.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(O).startsWith(".")||!(await this.ib.stat(O)).isDirectory)continue;const N=await this.bb.scanUserExtensionAtLocation(O);N&&N.installedTimestamp===void 0&&(this.rb.add(O),ee.push(N))}ee.length&&(await this.ub(ee.map(O=>[O,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",ee.map(O=>O.identifier.id)))}async ub(B,ee){const O=B.map(N=>N[0]);await this.vb(O),await this.gb.addExtensionsToProfile(B,ee),this.s.fire(O.map(N=>({local:N,identifier:N.identifier,operation:1,profileLocation:ee})))}async vb(B){const ee=await this.bb.getUninstalledExtensions();for(const O of B){const N=i.$so.create(O);ee[N.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",N.id),await this.bb.setInstalled(N),this.F.info("Removed the extension from uninstalled list:",N.id))}}};e.$Bp=te,e.$Bp=te=Oe([Ae(0,o.$2n),Ae(1,ue.$0k),Ae(2,K.$6i),Ae(3,t.$Th),Ae(4,a.$qp),Ae(5,n.$mp),Ae(6,h.$Fn),Ae(7,ae.$Kh),Ae(8,Z.$7j),Ae(9,se.$lj),Ae(10,x.$Dk),Ae(11,he.$Fk)],te);let G=class extends b.$Qc{constructor(B,ee,O,N,Q,T){super(),this.j=B,this.m=ee,this.n=O,this.s=N,this.t=Q,this.u=T,this.h=this.B(new I.$Ld),this.onExtract=this.h.event,this.c=(0,d.$sg)(this.n.userExtensionsLocation,".obsolete"),this.g=new y.$Xg}async cleanUp(){await this.H(),await this.G()}async scanExtensions(B,ee){const O={includeInvalid:!0,profileLocation:ee};let N=[];return B===null||B===0?N.push(...await this.n.scanAllExtensions({includeInvalid:!0},O,!1)):B===1&&N.push(...await this.n.scanUserExtensions(O)),N=B!==null?N.filter(Q=>Q.type===B):N,Promise.all(N.map(Q=>this.F(Q)))}async scanAllUserExtensions(B){const ee=await this.n.scanUserExtensions({includeAllVersions:!B,includeInvalid:!0});return Promise.all(ee.map(O=>this.F(O)))}async scanUserExtensionAtLocation(B){try{const ee=await this.n.scanExistingExtension(B,1,{includeInvalid:!0});if(ee)return await this.F(ee)}catch(ee){this.u.error(ee)}return null}async extractUserExtension(B,ee,O,N,Q){const T=B.toString(),H=l.URI.file(v.$hc(this.n.userExtensionsLocation.fsPath,`.${(0,f.$bg)()}`)),U=l.URI.file(v.$hc(this.n.userExtensionsLocation.fsPath,T));let ie=await this.m.exists(U);if(ie&&N){try{await this.y(B.id,U,"removeExisting")}catch{throw new o.$3n(p.localize(4,null,U.fsPath,B.id),o.ExtensionManagementErrorCode.Delete)}ie=!1}if(!ie)try{try{this.u.trace(`Started extracting the extension from ${ee} to ${U.fsPath}`),await(0,c.$fp)(ee,H.fsPath,{sourcePath:"extension",overwrite:!0},Q),this.u.info(`Extracted extension to ${U}:`,B.id)}catch(z){let _=o.ExtensionManagementErrorCode.Extract;throw z instanceof c.$dp&&(z.type==="CorruptZip"?_=o.ExtensionManagementErrorCode.CorruptZip:z.type==="Incomplete"&&(_=o.ExtensionManagementErrorCode.IncompleteZip)),new o.$3n(z.message,_)}await this.n.updateMetadata(H,O);try{this.u.trace(`Started renaming the extension from ${H.fsPath} to ${U.fsPath}`),await this.C(H.fsPath,U.fsPath),this.u.info("Renamed to",U.fsPath)}catch(z){if(z.code==="ENOTEMPTY")this.u.info("Rename failed because extension was installed by another source. So ignoring renaming.",B.id);else throw this.u.info(`Rename failed because of ${(0,L.$8)(z)}. Deleted from extracted location`,H),z}this.h.fire(U)}catch(z){try{await this.m.del(H,{recursive:!0})}catch{}throw z}return this.D(U,1)}async scanMetadata(B,ee){return ee?(await this.w(B,ee))?.metadata:this.n.scanMetadata(B.location)}async w(B,ee){return(await this.s.scanProfileExtensions(ee)).find(N=>(0,i.$ro)(N.identifier,B.identifier))}async updateMetadata(B,ee,O){return O?await this.s.updateMetadata([[B,ee]],O):await this.n.updateMetadata(B.location,ee),this.D(B.location,B.type,O)}getUninstalledExtensions(){return this.z()}async setUninstalled(...B){const ee=B.map(O=>i.$so.create(O));await this.z(O=>ee.forEach(N=>{O[N.toString()]=!0,this.u.info("Marked extension as uninstalled",N.toString())}))}async setInstalled(B){await this.z(ee=>delete ee[B.toString()])}async removeExtension(B,ee){if(this.t.extUri.isEqualOrParent(B.location,this.n.userExtensionsLocation))return this.y(B.identifier.id,B.location,ee)}async removeUninstalledExtension(B){await this.removeExtension(B,"uninstalled"),await this.z(ee=>delete ee[i.$so.create(B).toString()])}async copyExtension(B,ee,O,N){const Q=await this.w(B,ee),T=await this.w(B,O);return N={...Q?.metadata,...N},T?await this.s.updateMetadata([[B,{...T.metadata,...N}]],O):await this.s.addExtensionsToProfile([[B,N]],O),this.D(B.location,B.type,O)}async copyExtensions(B,ee){const O=await this.scanExtensions(1,B),N=await Promise.all(O.filter(Q=>!Q.isApplicationScoped).map(async Q=>[Q,await this.scanMetadata(Q,B)]));await this.s.addExtensionsToProfile(N,ee)}async y(B,ee,O){this.u.trace(`Deleting ${O} extension from disk`,B,ee.fsPath);const N=this.t.extUri.joinPath(this.t.extUri.dirname(ee),`${this.t.extUri.basename(ee)}.${(0,w.$zi)((0,f.$bg)()).toString(16)}${V}`);await this.C(ee.fsPath,N.fsPath),await this.m.del(N,{recursive:!0}),this.u.info(`Deleted ${O} extension from disk`,B,ee.fsPath)}async z(B){return this.g.queue(async()=>{let ee;try{ee=(await this.m.readFile(this.c,"utf8")).value.toString()}catch(N){if((0,Z.$kk)(N)!==1)throw N}let O={};if(ee)try{O=JSON.parse(ee)}catch{}return B&&(B(O),Object.keys(O).length?await this.m.writeFile(this.c,R.$_d.fromString(JSON.stringify(O))):await this.m.del(this.c)),O})}async C(B,ee){try{await u.Promises.rename(B,ee,2*60*1e3)}catch(O){throw new o.$3n(O.message||p.localize(5,null,B,ee),O.code||o.ExtensionManagementErrorCode.Rename)}}async D(B,ee,O){if(O){const Q=(await this.n.scanUserExtensions({profileLocation:O})).find(T=>this.t.extUri.isEqual(T.location,B));if(Q)return this.F(Q)}else{const N=await this.n.scanExistingExtension(B,ee,{includeInvalid:!0});if(N)return this.F(N)}throw new Error(p.localize(6,null,B.path))}async F(B){const ee=await this.m.resolve(B.location);let O,N;return ee.children&&(O=ee.children.find(({name:Q})=>/^readme(\.txt|\.md|)$/i.test(Q))?.resource,N=ee.children.find(({name:Q})=>/^changelog(\.txt|\.md|)$/i.test(Q))?.resource),{identifier:B.identifier,type:B.type,isBuiltin:B.isBuiltin||!!B.metadata?.isBuiltin,location:B.location,manifest:B.manifest,targetPlatform:B.targetPlatform,validations:B.validations,isValid:B.isValid,readmeUrl:O,changelogUrl:N,publisherDisplayName:B.metadata?.publisherDisplayName||null,publisherId:B.metadata?.publisherId||null,isApplicationScoped:!!B.metadata?.isApplicationScoped,isMachineScoped:!!B.metadata?.isMachineScoped,isPreReleaseVersion:!!B.metadata?.isPreReleaseVersion,preRelease:!!B.metadata?.preRelease,installedTimestamp:B.metadata?.installedTimestamp,updated:!!B.metadata?.updated,pinned:!!B.metadata?.pinned}}async G(){const B=await this.getUninstalledExtensions();if(Object.keys(B).length===0){this.u.debug("No uninstalled extensions found.");return}this.u.debug("Removing uninstalled extensions:",Object.keys(B));const ee=await this.n.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),O=new Set;for(const Q of ee)B[i.$so.create(Q).toString()]||O.add(Q.identifier.id.toLowerCase());try{const Q=(0,i.$xo)(ee,T=>T.identifier);await y.Promises.settled(Q.map(async T=>{const H=T.sort((U,ie)=>g.rcompare(U.manifest.version,ie.manifest.version))[0];O.has(H.identifier.id.toLowerCase())||await this.j(await this.F(H))}))}catch(Q){this.u.error(Q)}const N=ee.filter(Q=>Q.metadata&&B[i.$so.create(Q).toString()]);await Promise.allSettled(N.map(Q=>this.removeUninstalledExtension(Q)))}async H(){this.u.trace("ExtensionManagementService#removeTempDeleteFolders");let B;try{B=await this.m.resolve(this.n.userExtensionsLocation)}catch(ee){(0,Z.$kk)(ee)!==1&&this.u.error(ee);return}if(B?.children)try{await Promise.allSettled(B.children.map(async ee=>{if(!(!ee.isDirectory||!ee.name.endsWith(V))){this.u.trace("Deleting the temporarily deleted folder",ee.resource.toString());try{await this.m.del(ee.resource,{recursive:!0}),this.u.trace("Deleted the temporarily deleted folder",ee.resource.toString())}catch(O){(0,Z.$kk)(O)!==1&&this.u.error(O)}}}))}catch{}}};e.$Cp=G,e.$Cp=G=Oe([Ae(1,Z.$7j),Ae(2,a.$qp),Ae(3,n.$mp),Ae(4,x.$Dk),Ae(5,K.$6i)],G);class J extends s.$kp{get profileLocation(){return this.j}get verificationStatus(){return this.k}get operation(){return(0,m.$Df)(this.options.operation)?this.l:this.options.operation}constructor(B,ee,O,N,Q,T,H,U,ie){super(),this.identifier=B,this.source=ee,this.options=O,this.m=N,this.n=Q,this.o=T,this.p=H,this.q=U,this.s=ie,this.j=this.options.profileLocation,this.k=!1,this.l=2}async h(B){const[ee,O]=await this.x(B);return this.j=ee.isBuiltin||ee.isApplicationScoped?this.o.defaultProfile.extensionsResource:this.options.profileLocation,this.n.extUri.isEqual(this.o.defaultProfile.extensionsResource,this.j)&&await this.p.initializeDefaultProfileExtensions(),await this.q.addExtensionsToProfile([[ee,O]],this.j),ee}async u({zipPath:B,key:ee,metadata:O},N,Q){let T=await this.v(ee);return T||(this.s.trace("Extracting extension...",ee.id),T=await this.m.extractUserExtension(ee,B,O,N,Q),this.s.info("Extracting extension completed.",ee.id)),T}async v(B){return await this.w(B)?(this.s.trace("Removing the extension from uninstalled list:",B.id),await this.m.setInstalled(B),this.s.info("Removed the extension from uninstalled list:",B.id),(await this.m.scanAllUserExtensions(!0)).find(N=>i.$so.create(N).equals(B))):void 0}async w(B){return!!(await this.m.getUninstalledExtensions())[B.toString()]}}class q extends J{constructor(B,ee,O,N,Q,T,H,U,ie,z){super(ee.identifier,ee,O,Q,T,H,U,ie,z),this.y=ee,this.z=N}async x(B){const O=(await this.m.scanExtensions(null,this.options.profileLocation)).find(H=>(0,i.$ro)(H.identifier,this.y.identifier));O&&(this.l=3);const N={id:this.y.identifier.uuid,publisherId:this.y.publisherId,publisherDisplayName:this.y.publisherDisplayName,targetPlatform:this.y.properties.targetPlatform,isApplicationScoped:this.options.isApplicationScoped||O?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||O?.isMachineScoped,isBuiltin:this.options.isBuiltin||O?.isBuiltin,isSystem:O?.type===0?!0:void 0,updated:!!O,isPreReleaseVersion:this.y.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:void 0,preRelease:this.y.properties.isPreReleaseVersion||((0,m.$Cf)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:O?.preRelease)};if(O?.manifest.version===this.y.version)return[await this.m.updateMetadata(O,N),N];const{location:Q,verificationStatus:T}=await this.z.download(this.y,this.l,!this.options.donotVerifySignature);try{return this.k=T,this.B(Q.fsPath),[await this.u({zipPath:Q.fsPath,key:i.$so.create(this.y),metadata:N},!1,B),N]}catch(H){try{await this.z.delete(Q)}catch(U){this.s.warn("Error while deleting the downloaded file",Q.toString(),(0,L.$8)(U))}throw H}}async B(B){try{await(0,D.$xp)(B)}catch(ee){throw new o.$3n((0,s.$ip)(ee).message,o.ExtensionManagementErrorCode.Invalid)}}}e.$Dp=q;class ne extends J{constructor(B,ee,O,N,Q,T,H,U,ie,z){super({id:(0,i.$wo)(B.publisher,B.name)},ee,O,Q,T,H,U,ie,z),this.y=B,this.z=ee,this.A=N}async h(B){const ee=await super.h(B);return this.D(ee,B),ee}async x(B){const ee=new i.$so(this.identifier,this.y.version),N=(await this.m.scanExtensions(1,this.options.profileLocation)).find(H=>(0,i.$ro)(this.identifier,H.identifier)),Q={isApplicationScoped:this.options.isApplicationScoped||N?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||N?.isMachineScoped,isBuiltin:this.options.isBuiltin||N?.isBuiltin,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:void 0};if(N)if(this.l=3,ee.equals(new i.$so(N.identifier,N.manifest.version)))try{await this.m.removeExtension(N,"existing")}catch{throw new Error(p.localize(7,null,this.y.displayName||this.y.name))}else!this.options.profileLocation&&g.gt(N.manifest.version,this.y.version)&&await this.m.setUninstalled(N);else{const H=await this.v(ee);if(H)try{await this.m.removeExtension(H,"existing")}catch{throw new Error(p.localize(8,null,this.y.displayName||this.y.name))}}return[await this.u({zipPath:v.$ic(this.z.fsPath),key:ee,metadata:Q},!0,B),Q]}async D(B,ee){try{let[O]=await this.A.getExtensions([{id:B.identifier.id,version:B.manifest.version}],ee);if(O||([O]=await this.A.getExtensions([{id:B.identifier.id}],ee)),O){const N={id:O.identifier.uuid,publisherDisplayName:O.publisherDisplayName,publisherId:O.publisherId,isPreReleaseVersion:O.properties.isPreReleaseVersion,preRelease:O.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.m.updateMetadata(B,N,this.options.profileLocation)}}catch{}}}class me extends s.$kp{constructor(B,ee,O){super(),this.extension=B,this.j=ee,this.k=O}async h(B){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(we[72],pe([1,0,86,78,27,286,15,11,5,2,7,3,23,42,106]),function(le,e,y,R,r,P,L,I,w,b,C,E,v,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.$Bh=e.$Ah=void 0;class m{traceSocketEvent(k,A){g.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,k,A)}constructor(k,A=""){this.f=!0,this.debugLabel=A,this.socket=k,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=j=>{if(this.traceSocketEvent("error",{code:j?.code,message:j?.message}),j){if(j.code==="EPIPE")return;(0,I.$Y)(j)}},this.socket.on("error",this.a),this.b=j=>{this.traceSocketEvent("close",{hadError:j}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(k){const A=j=>{this.traceSocketEvent("read",j),k(L.$_d.wrap(j))};return this.socket.on("data",A),{dispose:()=>this.socket.off("data",A)}}onClose(k){const A=j=>{k({type:0,hadError:j,error:void 0})};return this.socket.on("close",A),{dispose:()=>this.socket.off("close",A)}}onEnd(k){const A=()=>{k()};return this.socket.on("end",A),{dispose:()=>this.socket.off("end",A)}}write(k){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",k),this.socket.write(k.buffer,A=>{if(A){if(A.code==="EPIPE")return;(0,I.$Y)(A)}})}catch(A){if(A.code==="EPIPE")return;(0,I.$Y)(A)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((k,A)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),k();return}const j=()=>{this.socket.off("close",j),this.socket.off("end",j),this.socket.off("error",j),this.socket.off("timeout",j),this.socket.off("drain",j),this.traceSocketEvent("nodeDrainEnd"),k()};this.socket.on("close",j),this.socket.on("end",j),this.socket.on("error",j),this.socket.on("timeout",j),this.socket.on("drain",j)})}}e.$Ah=m;var l;(function(D){D[D.MinHeaderByteSize=2]="MinHeaderByteSize",D[D.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(l||(l={}));var f;(function(D){D[D.PeekHeader=1]="PeekHeader",D[D.ReadHeader=2]="ReadHeader",D[D.ReadBody=3]="ReadBody",D[D.Fin=4]="Fin"})(f||(f={}));class u extends b.$Qc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(k,A){this.socket.traceSocketEvent(k,A)}constructor(k,A,j,Z){super(),this.f=this.B(new w.$Ld),this.g=this.B(new w.$Ld),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=k,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:A,inflateBytesLength:j?.byteLength||0,recordInflateBytes:Z}),this.a=this.B(new c(this,A,j,Z,this.f,(ae,K)=>this.m(ae,K))),this.B(this.a.onError(ae=>{console.error(ae),(0,I.$Y)(ae),this.g.fire({type:0,hadError:!0,error:ae})})),this.b=new g.$vh,this.B(this.socket.onData(ae=>this.n(ae))),this.B(this.socket.onClose(async ae=>{this.a.isProcessingReadQueue()&&await w.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(ae)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(k){return this.f.event(k)}onClose(k){return this.g.event(k)}onEnd(k){return this.socket.onEnd(k)}write(k){let A=0;for(;A<k.byteLength;)this.a.writeMessage(k.slice(A,Math.min(A+262144,k.byteLength))),A+=262144}m(k,A){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",k);let j=2;k.byteLength<126?j+=0:k.byteLength<2**16?j+=2:j+=8;const Z=L.$_d.alloc(j);if(A?Z.writeUInt8(194,0):Z.writeUInt8(130,0),k.byteLength<126)Z.writeUInt8(k.byteLength,1);else if(k.byteLength<2**16){Z.writeUInt8(126,1);let ae=1;Z.writeUInt8(k.byteLength>>>8&255,++ae),Z.writeUInt8(k.byteLength>>>0&255,++ae)}else{Z.writeUInt8(127,1);let ae=1;Z.writeUInt8(0,++ae),Z.writeUInt8(0,++ae),Z.writeUInt8(0,++ae),Z.writeUInt8(0,++ae),Z.writeUInt8(k.byteLength>>>24&255,++ae),Z.writeUInt8(k.byteLength>>>16&255,++ae),Z.writeUInt8(k.byteLength>>>8&255,++ae),Z.writeUInt8(k.byteLength>>>0&255,++ae)}this.socket.write(L.$_d.concat([Z,k]))}end(){this.h=!0,this.socket.end()}n(k){if(k.byteLength!==0){for(this.b.acceptChunk(k);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const A=this.b.peek(this.j.readLen),j=A.readUInt8(0),Z=(j&128)>>>7,ae=(j&64)>>>6,K=A.readUInt8(1),se=(K&128)>>>7,ue=K&127;this.j.state=2,this.j.readLen=2+(se?4:0)+(ue===126?2:0)+(ue===127?8:0),this.j.fin=Z,this.j.firstFrameOfMessage&&(this.j.compressed=!!ae),this.j.firstFrameOfMessage=!!Z,this.j.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin})}else if(this.j.state===2){const A=this.b.read(this.j.readLen),j=A.readUInt8(1),Z=(j&128)>>>7;let ae=j&127,K=1;ae===126?ae=A.readUInt8(++K)*2**8+A.readUInt8(++K):ae===127&&(ae=A.readUInt8(++K)*0+A.readUInt8(++K)*0+A.readUInt8(++K)*0+A.readUInt8(++K)*0+A.readUInt8(++K)*2**24+A.readUInt8(++K)*2**16+A.readUInt8(++K)*2**8+A.readUInt8(++K));let se=0;Z&&(se=A.readUInt8(++K)*2**24+A.readUInt8(++K)*2**16+A.readUInt8(++K)*2**8+A.readUInt8(++K)),this.j.state=3,this.j.readLen=ae,this.j.mask=se,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask})}else if(this.j.state===3){const A=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",A),t(A,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",A),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.a.acceptFrame(A,this.j.compressed,!!this.j.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await w.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$Bh=u;class c extends b.$Qc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:L.$_d.alloc(0)}constructor(k,A,j,Z,ae,K){super(),this.n=k,this.r=ae,this.s=K,this.a=this.B(new w.$Ld),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new w.$Ld),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new w.$Ld),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,A?(this.b=this.B(new p(this.n,Z,j,{windowBits:15})),this.f=this.B(new h(this.n,{windowBits:15})),this.B(this.b.onError(se=>this.a.fire(se))),this.B(this.f.onError(se=>this.a.fire(se)))):(this.b=null,this.f=null)}writeMessage(k){this.g.push(k),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const k=this.g.shift();if(this.f){const A=await this.w(this.f,k);this.s(A,!0)}else this.s(k,!1)}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(k,A){return new Promise((j,Z)=>{k.write(A),k.flush(ae=>j(ae))})}acceptFrame(k,A,j){this.h.push({data:k,isCompressed:A,isLastFrameOfMessage:j}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const k=this.h.shift();if(this.b&&k.isCompressed){const A=await this.C(this.b,k.data,k.isLastFrameOfMessage);this.r.fire(A)}else this.r.fire(k.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(k,A,j){return new Promise((Z,ae)=>{k.write(A),j&&k.write(L.$_d.fromByteArray([0,0,255,255])),k.flush(K=>Z(K))})}}class p extends b.$Qc{get recordedInflateBytes(){return this.j?L.$_d.concat(this.f):L.$_d.alloc(0)}constructor(k,A,j,Z){super(),this.h=k,this.j=A,this.a=this.B(new w.$Ld),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,P.createInflateRaw)(Z),this.b.on("error",ae=>{this.h.traceSocketEvent("zlibInflateError",{message:ae?.message,code:ae?.code}),this.a.fire(ae)}),this.b.on("data",ae=>{this.h.traceSocketEvent("zlibInflateData",ae),this.g.push(L.$_d.wrap(ae))}),j&&(this.h.traceSocketEvent("zlibInflateInitialWrite",j.buffer),this.b.write(j.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(k){this.j&&this.f.push(k.clone()),this.h.traceSocketEvent("zlibInflateWrite",k),this.b.write(k.buffer)}flush(k){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const A=L.$_d.concat(this.g);this.g.length=0,k(A)})}}class h extends b.$Qc{constructor(k,A){super(),this.g=k,this.a=this.B(new w.$Ld),this.onError=this.a.event,this.f=[],this.b=(0,P.createDeflateRaw)({windowBits:15}),this.b.on("error",j=>{this.g.traceSocketEvent("zlibDeflateError",{message:j?.message,code:j?.code}),this.a.fire(j)}),this.b.on("data",j=>{this.g.traceSocketEvent("zlibDeflateData",j),this.f.push(L.$_d.wrap(j))})}write(k){this.g.traceSocketEvent("zlibDeflateWrite",k.buffer),this.b.write(k.buffer)}flush(k){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let A=L.$_d.concat(this.f);this.f.length=0,A=A.slice(0,A.byteLength-4),k(A)})}}function t(D,k){if(k===0)return;const A=D.byteLength>>>2;for(let ue=0;ue<A;ue++){const x=D.readUInt32BE(ue*4);D.writeUInt32BE(x^k,ue*4)}const j=A*4,Z=D.byteLength-j,ae=k>>>24&255,K=k>>>16&255,se=k>>>8&255;Z>=1&&D.writeUInt8(D.readUInt8(j)^ae,j),Z>=2&&D.writeUInt8(D.readUInt8(j+1)^K,j+1),Z>=3&&D.writeUInt8(D.readUInt8(j+2)^se,j+2)}e.$Ch=process.env.XDG_RUNTIME_DIR;const s={[2]:107,[1]:103};function o(){const D=(0,v.$bg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${D}-sock`;const k=process.platform!=="darwin"&&e.$Ch?e.$Ch:(0,r.tmpdir)(),A=(0,C.$hc)(k,`vscode-ipc-${D}.sock`);return n(A),A}e.$Dh=o;function i(D,k,A){const j=(0,y.createHash)("md5").update(D).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${j}-${A}-${k}-sock`;const Z=A.substr(0,4),ae=k.substr(0,6),K=j.substr(0,8);let se;return process.platform!=="darwin"&&e.$Ch&&!process.env.VSCODE_PORTABLE?se=(0,C.$hc)(e.$Ch,`vscode-${K}-${Z}-${ae}.sock`):se=(0,C.$hc)(D,`${Z}-${ae}.sock`),n(se),se}e.$Eh=i;function n(D){const k=s[E.$o];typeof k=="number"&&D.length>=k&&console.warn(`WARNING: IPC handle "${D}" is longer than ${k} chars, try a shorter --user-data-dir`)}class a extends d.$ph{static b(k){const A=w.Event.fromNodeEventEmitter(k,"connection");return w.Event.map(A,j=>({protocol:new g.$wh(new m(j,"ipc-server-connection")),onDidClientDisconnect:w.Event.once(w.Event.fromNodeEventEmitter(j,"close"))}))}constructor(k){super(a.b(k)),this.d=k}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$Fh=a;function $(D){return new Promise((k,A)=>{const j=(0,R.createServer)();j.on("error",A),j.listen(D,()=>{j.removeListener("error",A),k(new a(j))})})}e.$Gh=$;function S(D,k){return new Promise((A,j)=>{const Z=(0,R.createConnection)(D,()=>{Z.removeListener("error",j),A(g.$xh.fromSocket(new m(Z,`ipc-client${k}`),k))});Z.once("error",j)})}e.$Hh=S}),define(we[139],pe([1,0,84,14,15,11,8,24,25,85,13,44,233,286]),function(le,e,y,R,r,P,L,I,w,b,C,E,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rq=e.$Qq=void 0;let g=class extends E.$Lo{constructor(u,c,p,h){super(h),this.m=u,this.n=c,this.r=p,this.s(),this.B(u.onDidChangeConfiguration(t=>{t.affectsConfiguration("http")&&this.s()}))}s(){const u=this.m.getValue("http");this.f=u?.proxy,this.g=!!u?.proxyStrictSSL,this.h=u?.proxyAuthorization}async request(u,c){const{f:p,g:h}=this;let t;try{t=await(0,b.$Ol)(this.m,this.r,this.n.args,process.env)}catch(i){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,P.$8)(i)))}const s={...process.env,...t},o=u.agent?u.agent:await(0,v.$Pq)(u.url||"",s,{proxyUrl:p,strictSSL:h});return u.agent=o,u.strictSSL=h,this.h&&(u.headers={...u.headers||{},"Proxy-Authorization":this.h}),this.c(u.isChromiumNetwork?"electron":"node",u,()=>l(u,c))}async resolveProxy(u){}};e.$Qq=g,e.$Qq=g=Oe([Ae(0,I.$fi),Ae(1,w.$Th),Ae(2,C.$6i),Ae(3,C.$7i)],g);async function m(f){return((0,y.parse)(f.url).protocol==="https:"?await new Promise((p,h)=>{le(["https"],p,h)}):await new Promise((p,h)=>{le(["http"],p,h)})).request}async function l(f,u){return R.Promises.withAsyncBody(async(c,p)=>{const h=(0,y.parse)(f.url),t=f.getRawRequest?f.getRawRequest(f):await m(f),s={hostname:h.hostname,port:h.port?parseInt(h.port):h.protocol==="https:"?443:80,protocol:h.protocol,path:h.path,method:f.type||"GET",headers:f.headers,agent:f.agent,rejectUnauthorized:(0,L.$Cf)(f.strictSSL)?f.strictSSL:!0};f.user&&f.password&&(s.auth=f.user+":"+f.password);const o=t(s,i=>{const n=(0,L.$Af)(f.followRedirects)?f.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&n>0&&i.headers.location)l({...f,url:i.headers.location,followRedirects:n-1},u).then(c,p);else{let a=i;!f.isChromiumNetwork&&i.headers["content-encoding"]==="gzip"&&(a=i.pipe((0,d.createGunzip)())),c({res:i,stream:(0,r.$oe)(a)})}});o.on("error",p),f.timeout&&o.setTimeout(f.timeout),f.isChromiumNetwork&&o.removeHeader("Content-Length"),f.data&&typeof f.data=="string"&&o.write(f.data),o.end(),u.onCancellationRequested(()=>{o.abort(),p(new P.$3)})})}e.$Rq=l}),define(we[140],pe([1,0,52,78,90,12,7,15,5,72,85,13,46,3,59,128,2,276,24]),function(le,e,y,R,r,P,L,I,w,b,C,E,v,d,g,m,l,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vm=e.$um=void 0;async function c(i={},n,a,$,S,D){const k=await(0,r.$hl)(a,$.userDataPath);let A={};if(n)try{A=await(0,C.$Ol)(D,S,$.args,process.env)}catch(ue){S.error("ExtensionHostConnection#buildUserEnvironment resolving shell environment failed",ue)}const Z={...process.env,...A,VSCODE_AMD_ENTRYPOINT:"vs/workbench/api/node/extensionHostProcess",VSCODE_HANDLES_UNCAUGHT_ERRORS:"true",VSCODE_NLS_CONFIG:JSON.stringify(k,void 0,0),...i},ae=$.isBuilt?(0,L.$hc)($.appRoot,"bin"):(0,L.$hc)($.appRoot,"resources","server","bin-dev"),K=(0,L.$hc)(ae,"remote-cli");let se=t(Z,"PATH");return se?se=K+L.$rc+se:se=K,s(Z,"PATH",se),$.args["without-browser-env-var"]||(Z.BROWSER=(0,L.$hc)(ae,"helpers",d.$d?"browser.cmd":"browser.sh")),o(Z),Z}e.$um=c;class p{constructor(n,a){this.socket=n,this.initialDataChunk=a}socketDrain(){return this.socket.drain()}toIExtHostSocketMessage(){let n,a,$;return this.socket instanceof b.$Ah?(n=!0,a=!1,$=I.$_d.alloc(0)):(n=!1,a=this.socket.permessageDeflate,$=this.socket.recordedInflateBytes),{type:"VSCODE_EXTHOST_IPC_SOCKET",initialDataChunk:this.initialDataChunk.buffer.toString("base64"),skipWebSocketFrames:n,permessageDeflate:a,inflateBytes:$.buffer.toString("base64")}}}let h=class{constructor(n,a,$,S,D,k,A,j){this.i=n,this.j=D,this.l=k,this.m=A,this.n=j,this.b=new w.$Ld,this.onClose=this.b.event,this.c=!d.$d||!this.j.args["socket-path"],this.d=!1,this.f=a,this.g=null,this.h=new p($,S),this.p("New connection established.")}get o(){return`[${this.f}][${this.i.substr(0,8)}][ExtensionHostConnection] `}p(n){this.l.info(`${this.o}${n}`)}q(n){this.l.error(`${this.o}${n}`)}async r(n,a){const $=new l.$Pc;$.add(a.socket),$.add((0,l.$Oc)(()=>{n.destroy()}));const S=()=>{$.dispose()};$.add(a.socket.onEnd(S)),$.add(a.socket.onClose(S)),$.add(w.Event.fromNodeEventEmitter(n,"end")(S)),$.add(w.Event.fromNodeEventEmitter(n,"close")(S)),$.add(w.Event.fromNodeEventEmitter(n,"error")(S)),$.add(a.socket.onData(D=>n.write(D.buffer))),$.add(w.Event.fromNodeEventEmitter(n,"data")(D=>{a.socket.write(I.$_d.wrap(D))})),a.initialDataChunk.byteLength>0&&n.write(a.initialDataChunk.buffer)}async s(n,a){await a.socketDrain();const $=a.toIExtHostSocketMessage();let S;a.socket instanceof b.$Ah?S=a.socket.socket:S=a.socket.socket.socket,n.send($,S)}shortenReconnectionGraceTimeIfNecessary(){if(!this.g)return;const n={type:"VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"};this.g.send(n)}acceptReconnection(n,a,$){this.f=n,this.p("The client has reconnected.");const S=new p(a,$);if(!this.g){this.h=S;return}this.s(this.g,S)}t(){this.d||(this.d=!0,this.h&&(this.h.socket.end(),this.h=null),this.g&&(this.g.kill(),this.g=null),this.b.fire(void 0))}async start(n){try{let a=process.execArgv?process.execArgv.filter(K=>!/^--inspect(-brk)?=/.test(K)):[];n.port&&!process.pkg&&(a=[`--inspect${n.break?"-brk":""}=${n.port}`]);const $=await c(n.env,!0,n.language,this.j,this.l,this.n);(0,g.$vl)($);let S;if(this.c)(0,f.$sm)(new f.$qm,$),S=null;else{const{namedPipeServer:K,pipeName:se}=await this.u();(0,f.$sm)(new f.$pm(se),$),S=K}const D={env:$,execArgv:a,silent:!0};D.execArgv.unshift("--dns-result-order=ipv4first");const k=["--type=extensionHost","--transformURIs"],A=this.j.args["use-host-proxy"];k.push(`--useHostProxy=${A?"true":"false"}`),this.g=y.fork(P.$_f.asFileUri("bootstrap-fork").fsPath,k,D);const j=this.g.pid;this.p(`<${j}> Launched Extension Host Process.`),this.g.stdout.setEncoding("utf8"),this.g.stderr.setEncoding("utf8");const Z=w.Event.fromNodeEventEmitter(this.g.stdout,"data"),ae=w.Event.fromNodeEventEmitter(this.g.stderr,"data");if(Z(K=>this.p(`<${j}> ${K}`)),ae(K=>this.p(`<${j}><stderr> ${K}`)),this.g.on("error",K=>{this.q(`<${j}> Extension Host Process had an error`),this.l.error(K),this.t()}),this.g.on("exit",(K,se)=>{this.m.setExitInfo(this.i,{code:K,signal:se}),this.p(`<${j}> Extension Host Process exited with code: ${K}, signal: ${se}.`),this.t()}),S)S.on("connection",K=>{S.close(),this.r(K,this.h)});else{const K=se=>{se.type==="VSCODE_EXTHOST_IPC_READY"&&(this.g.removeListener("message",K),this.s(this.g,this.h),this.h=null)};this.g.on("message",K)}}catch(a){console.error("ExtensionHostConnection errored"),a&&console.error(a)}}u(){return new Promise((n,a)=>{const $=(0,b.$Dh)(),S=R.createServer();S.on("error",a),S.listen($,()=>{S?.removeListener("error",a),n({pipeName:$,namedPipeServer:S})})})}};e.$vm=h,e.$vm=h=Oe([Ae(4,v.$fm),Ae(5,E.$6i),Ae(6,m.$nm),Ae(7,u.$fi)],h);function t(i,n){const a=Object.keys(i).filter(S=>S.toLowerCase()===n.toLowerCase()),$=a.length>0?a[0]:n;return i[$]}function s(i,n,a){const $=Object.keys(i).filter(D=>D.toLowerCase()===n.toLowerCase()),S=$.length>0?$[0]:n;i[S]=a}function o(i){for(const n of Object.keys(i))i[n]===null&&delete i[n]}}),define(we[287],pe([1,0,82,13,65,117,24,44,139,36,32,30,126,138,81,111,54,2,112,68,12,16,31,46,120,83,121,11,4,7,28,231,80,34,124,64,3,57,129,33,45,69,127,125,114,115,198,288]),function(le,e,y,R,r,P,L,I,w,b,C,E,v,d,g,m,l,f,u,c,p,h,t,s,o,i,n,a,$,S,D,k,A,j,Z,ae,K,se,ue,x,he,V,te,G,J,q,ne,me){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.run=void 0;class re extends f.$Qc{constructor(N,Q){super(),this.a=N,this.b=Q,this.c()}c(){process.once("exit",()=>this.dispose())}async run(){const N=await this.f();await N.invokeFunction(async Q=>{const T=Q.get(L.$fi),H=Q.get(R.$6i);K.$d&&(T.getValue("security.restrictUNCAccess")===!1?(0,me.disableUNCAccessRestrictions)():(0,me.addUNCHostToAllowlist)(T.getValue("security.allowedUNCHosts")));try{await this.g(N.createInstance(o.$$o,new R.$bj(H.getLevel(),!1)))}catch(U){throw H.error(U),console.error((0,a.$8)(U)),U}})}async f(){const N=new y.$Jh,Q={_serviceBrand:void 0,...l.default};N.set(t.$lj,Q);const T=new s.$gm(this.a,Q);N.set(s.$fm,T);const H=new q.$lN((0,R.$hj)(T),T.logsHome);N.set(R.$7i,H);const U=new J.$vN(this.B(H.createLogger("remoteCLI",{name:(0,ne.localize)(0,null)})));N.set(R.$6i,U),U.trace(`Remote configuration data at ${this.b}`),U.trace("process arguments:",this.a);const ie=this.B(new u.$Fp(U));N.set(h.$7j,ie),ie.registerProvider(p.Schemas.file,this.B(new c.$5p(U)));const z=new Z.$rr(ie);N.set(j.$Dk,z);const _=this.B(new te.$tN(z,T,ie,U));N.set(x.$Fk,_);const W=this.B(new P.$Bn(_.defaultProfile.settingsResource,ie,new V.$bn,U));return N.set(L.$fi,W),await Promise.all([W.initialize(),_.init()]),N.set(I.$Ko,new r.$Ih(w.$Qq)),N.set(A.$Fn,new r.$Ih(k.$ON)),N.set(C.$0k,b.$do),N.set(E.$2n,new r.$Ih(v.$8o)),N.set(he.$mp,new r.$Ih(G.$uN)),N.set(se.$qp,new r.$Ih(ue.$gN)),N.set(g.$9o,new r.$Ih(g.$0o)),N.set(d.$Ap,new r.$Ih(d.$Bp)),N.set(i.$Kq,new r.$Ih(n.$Mq)),new m.$8p(N)}async g(N){if(this.a["list-extensions"])return N.listExtensions(!!this.a["show-versions"],this.a.category);if(this.a["install-extension"]||this.a["install-builtin-extension"]){const Q={isMachineScoped:!!this.a["do-not-sync"],installPreReleaseVersion:!!this.a["pre-release"]};return N.installExtensions(this.h(this.a["install-extension"]||[]),this.h(this.a["install-builtin-extension"]||[]),Q,!!this.a.force)}else{if(this.a["uninstall-extension"])return N.uninstallExtensions(this.h(this.a["uninstall-extension"]),!!this.a.force);if(this.a["locate-extension"])return N.locateExtension(this.a["locate-extension"])}}h(N){return N.map(Q=>/\.vsix$/i.test(Q)?$.URI.file((0,S.$gc)(Q)?Q:(0,S.$hc)((0,D.cwd)(),Q)):Q)}}function B(O){setTimeout(()=>process.exit(O),0)}async function ee(O,N,Q){if(O.help){const H=l.default.serverApplicationName+(K.$d?".cmd":"");console.log((0,ae.$Dl)(l.default.nameLong,H,l.default.version,Q,{noInputFiles:!0,noPipe:!0}));return}if(O.version){console.log((0,ae.$El)(l.default.version,l.default.commit));return}const T=new re(O,N);try{await T.run(),B(0)}catch{B(1)}finally{T.dispose()}}e.run=ee}),define(we[289],pe([1,0,72,263,29,282,4,13,89]),function(le,e,y,R,r,P,L,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zM=e.$yM=void 0;class b{constructor(v,d,g){this.b=v,this.c=d,this.f=g,this.a=R.createServer((m,l)=>this.h(m,l)),this.g().catch(m=>(d.error(m),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",v=>this.c.error(v))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(v,d){const g=(l,f)=>{d.writeHead(l,{"content-type":"application/json"}),d.end(JSON.stringify(f||null),u=>u&&this.c.error(u))},m=[];v.setEncoding("utf8"),v.on("data",l=>m.push(l)),v.on("end",async()=>{try{const l=JSON.parse(m.join(""));let f;switch(l.type){case"open":f=await this.i(l);break;case"openExternal":f=await this.j(l);break;case"status":f=await this.l(l);break;case"extensionManagement":f=await this.k(l);break;default:g(404,`Unknown message type: ${l.type}`);break}g(200,f)}catch(l){const f=l instanceof Error?l.message:JSON.stringify(l);g(500,f),this.c.error("Error while processing pipe request",l)}})}async i(v){const{fileURIs:d,folderURIs:g,forceNewWindow:m,diffMode:l,mergeMode:f,addMode:u,forceReuseWindow:c,gotoLineMode:p,waitMarkerFilePath:h,remoteAuthority:t}=v,s=[];if(Array.isArray(g))for(const a of g)try{s.push({folderUri:L.URI.parse(a)})}catch{}if(Array.isArray(d))for(const a of d)try{(0,w.$ei)(a)?s.push({workspaceUri:L.URI.parse(a)}):s.push({fileUri:L.URI.parse(a)})}catch{}const o=h?L.URI.file(h):void 0,n={forceNewWindow:m,diffMode:l,mergeMode:f,addMode:u,gotoLineMode:p,forceReuseWindow:c,preferNewWindow:!c&&!o&&!u,waitMarkerFileURI:o,remoteAuthority:t};this.b.executeCommand("_remoteCLI.windowOpen",s,n)}async j(v){for(const d of v.uris){const g=L.URI.parse(d),m=g.scheme==="file"?g:d;await this.b.executeCommand("_remoteCLI.openExternal",m)}}async k(v){const d=m=>m?.map(l=>/\.vsix$/i.test(l)?L.URI.parse(l):l),g={list:v.list,install:d(v.install),uninstall:d(v.uninstall),force:v.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",g)}async l(v){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&r.existsSync(this.f)&&r.unlinkSync(this.f)}}e.$yM=b;let C=class extends b{constructor(v,d){super(v,d,(0,y.$Dh)())}};e.$zM=C,e.$zM=C=Oe([Ae(0,P.$tM),Ae(1,I.$6i)],C)}),define(we[290],pe([1,0,27,5,22,2,7,3,4,72,70,289,123,87,270,272,140]),function(le,e,y,R,r,P,L,I,w,b,C,E,v,d,g,m,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_M=void 0;class f extends m.$$M{constructor(p,h,t,s,o){super({getFolderUri:i=>{const n=h.filter(a=>a.name===i);if(n&&n.length>0)return n[0].uri},getWorkspaceFolderCount:()=>h.length,getConfigurationValue:(i,n)=>s[`config:${n}`],getExecPath:()=>p.VSCODE_EXEC_PATH,getAppRoot:()=>p.VSCODE_CWD,getFilePath:()=>{if(t)return L.$fc(t.fsPath)},getSelectedText:()=>s.selectedText,getLineNumber:()=>s.lineNumber,getExtension:async i=>{const a=(await o.getInstalled()).find($=>$.identifier.id===i);return a&&{extensionLocation:a.location}}},void 0,Promise.resolve(y.homedir()),Promise.resolve(p))}}class u extends P.$Qc{constructor(p,h,t,s,o,i){super(),this.g=p,this.h=h,this.j=t,this.m=s,this.n=o,this.r=i,this.a=0,this.b=new Map,this.c=this.B(new R.$Ld),this.onExecuteCommand=this.c.event}async call(p,h,t){switch(h){case"$restartPtyHost":return this.j.restartPtyHost.apply(this.j,t);case"$createProcess":{const s=(0,C.$sr)(p.remoteAuthority);return this.s(s,t)}case"$attachToProcess":return this.j.attachToProcess.apply(this.j,t);case"$detachFromProcess":return this.j.detachFromProcess.apply(this.j,t);case"$listProcesses":return this.j.listProcesses.apply(this.j,t);case"$getLatency":return this.j.getLatency.apply(this.j,t);case"$getPerformanceMarks":return this.j.getPerformanceMarks.apply(this.j,t);case"$orphanQuestionReply":return this.j.orphanQuestionReply.apply(this.j,t);case"$acceptPtyHostResolvedVariables":return this.j.acceptPtyHostResolvedVariables.apply(this.j,t);case"$start":return this.j.start.apply(this.j,t);case"$input":return this.j.input.apply(this.j,t);case"$acknowledgeDataEvent":return this.j.acknowledgeDataEvent.apply(this.j,t);case"$shutdown":return this.j.shutdown.apply(this.j,t);case"$resize":return this.j.resize.apply(this.j,t);case"$clearBuffer":return this.j.clearBuffer.apply(this.j,t);case"$getInitialCwd":return this.j.getInitialCwd.apply(this.j,t);case"$getCwd":return this.j.getCwd.apply(this.j,t);case"$processBinary":return this.j.processBinary.apply(this.j,t);case"$sendCommandResult":return this.u(t[0],t[1],t[2]);case"$installAutoReply":return this.j.installAutoReply.apply(this.j,t);case"$uninstallAllAutoReplies":return this.j.uninstallAllAutoReplies.apply(this.j,t);case"$getDefaultSystemShell":return this.w.apply(this,t);case"$getProfiles":return this.y.apply(this,t);case"$getEnvironment":return this.z();case"$getWslPath":return this.C(t[0],t[1]);case"$getTerminalLayoutInfo":return this.j.getTerminalLayoutInfo(t);case"$setTerminalLayoutInfo":return this.j.setTerminalLayoutInfo(t);case"$serializeTerminalState":return this.j.serializeTerminalState.apply(this.j,t);case"$reviveTerminalProcesses":return this.j.reviveTerminalProcesses.apply(this.j,t);case"$getRevivedPtyNewId":return this.j.getRevivedPtyNewId.apply(this.j,t);case"$setUnicodeVersion":return this.j.setUnicodeVersion.apply(this.j,t);case"$reduceConnectionGraceTime":return this.D();case"$updateIcon":return this.j.updateIcon.apply(this.j,t);case"$updateTitle":return this.j.updateTitle.apply(this.j,t);case"$updateProperty":return this.j.updateProperty.apply(this.j,t);case"$refreshProperty":return this.j.refreshProperty.apply(this.j,t);case"$requestDetachInstance":return this.j.requestDetachInstance(t[0],t[1]);case"$acceptDetachedInstance":return this.j.acceptDetachInstanceReply(t[0],t[1]);case"$freePortKillProcess":return this.j.freePortKillProcess.apply(this.j,t);case"$acceptDetachInstanceReply":return this.j.acceptDetachInstanceReply.apply(this.j,t)}throw new Error(`IPC Command ${h} not found`)}listen(p,h,t){switch(h){case"$onPtyHostExitEvent":return this.j.onPtyHostExit||R.Event.None;case"$onPtyHostStartEvent":return this.j.onPtyHostStart||R.Event.None;case"$onPtyHostUnresponsiveEvent":return this.j.onPtyHostUnresponsive||R.Event.None;case"$onPtyHostResponsiveEvent":return this.j.onPtyHostResponsive||R.Event.None;case"$onPtyHostRequestResolveVariablesEvent":return this.j.onPtyHostRequestResolveVariables||R.Event.None;case"$onProcessDataEvent":return this.j.onProcessData;case"$onProcessReadyEvent":return this.j.onProcessReady;case"$onProcessExitEvent":return this.j.onProcessExit;case"$onProcessReplayEvent":return this.j.onProcessReplay;case"$onProcessOrphanQuestion":return this.j.onProcessOrphanQuestion;case"$onExecuteCommand":return this.onExecuteCommand;case"$onDidRequestDetach":return this.j.onDidRequestDetach||R.Event.None;case"$onDidChangeProperty":return this.j.onDidChangeProperty}throw new Error(`IPC Command ${h} not found`)}async s(p,h){const t={name:h.shellLaunchConfig.name,executable:h.shellLaunchConfig.executable,args:h.shellLaunchConfig.args,cwd:typeof h.shellLaunchConfig.cwd=="string"||typeof h.shellLaunchConfig.cwd>"u"?h.shellLaunchConfig.cwd:w.URI.revive(p.transformIncoming(h.shellLaunchConfig.cwd)),env:h.shellLaunchConfig.env,useShellEnvironment:h.shellLaunchConfig.useShellEnvironment,reconnectionProperties:h.shellLaunchConfig.reconnectionProperties,type:h.shellLaunchConfig.type,isFeatureTerminal:h.shellLaunchConfig.isFeatureTerminal},s=await(0,l.$um)(h.resolverEnv,!!h.shellLaunchConfig.useShellEnvironment,I.$q,this.g,this.h,this.r);this.h.trace("baseEnv",s);const o=ue=>({uri:w.URI.revive(p.transformIncoming(ue.uri)),name:ue.name,index:ue.index,toResource:()=>{throw new Error("Not implemented")}}),i=h.workspaceFolders.map(o),n=h.activeWorkspaceFolder?o(h.activeWorkspaceFolder):void 0,a=h.activeFileResource?w.URI.revive(p.transformIncoming(h.activeFileResource)):void 0,$=new f(s,i,a,h.resolvedVariables,this.n),S=g.$7M(n,process.env,$),D=await g.$6M(t,y.homedir(),S,n?.uri,h.configuration["terminal.integrated.cwd"],this.h);t.cwd=D;const k=I.$d?"terminal.integrated.env.windows":I.$e?"terminal.integrated.env.osx":"terminal.integrated.env.linux",A=h.configuration[k],j=await g.$8M(t,A,S,this.m.version,h.configuration["terminal.integrated.detectLocale"],s);if(!t.strictEnv){const ue=[];for(const[te,G,J]of h.envVariableCollections)ue.push([te,{map:(0,d.$er)(G),descriptionMap:(0,d.$fr)(J)}]);const x=new Map(ue),he=new v.$ir(x),V=n?n??void 0:void 0;await he.applyToProcessEnvironment(j,{workspaceFolder:V},S)}this.h.debug("Terminal process launching on remote agent",{shellLaunchConfig:t,initialCwd:D,cols:h.cols,rows:h.rows,env:j});const Z=(0,b.$Dh)();j.VSCODE_IPC_HOOK_CLI=Z;const ae=await this.j.createProcess(t,D,h.cols,h.rows,h.unicodeVersion,j,s,h.options,h.shouldPersistTerminal,h.workspaceId,h.workspaceName),K={executeCommand:(ue,...x)=>this.t(ae,ue,x,p)},se=new E.$yM(K,this.h,Z);return this.j.onProcessExit(ue=>ue.id===ae&&se.dispose()),{persistentTerminalId:ae,resolvedShellLaunchConfig:t}}t(p,h,t,s){let o,i;const n=new Promise((S,D)=>{o=S,i=D}),a=++this.a;this.b.set(a,{resolve:o,reject:i,uriTransformer:s});const $=(0,r.$Zm)(t,S=>{if(S&&S.$mid===1)return s.transformOutgoing(S);if(S&&S instanceof w.URI)return s.transformOutgoingURI(S)});return this.c.fire({reqId:a,persistentProcessId:p,commandId:h,commandArgs:$}),n}u(p,h,t){const s=this.b.get(p);if(!s)return;this.b.delete(p);const o=(0,r.$Zm)(t,i=>{if(i&&i.$mid===1)return s.uriTransformer.transformIncoming(i)});h?s.reject(o):s.resolve(o)}w(p){return this.j.getDefaultSystemShell(p)}async y(p,h,t,s){return this.j.getProfiles(p,h,t,s)||[]}z(){return{...process.env}}C(p,h){return this.j.getWslPath(p,h)}D(){return this.j.reduceConnectionGraceTime()}}e.$_M=u}),define(we[291],pe([1,0,27,5,2,12,7,101,21,42,24,117,206,80,207,25,126,30,81,120,216,138,16,112,68,65,111,82,83,121,13,54,31,44,232,139,119,32,36,246,88,254,34,124,267,268,237,243,290,70,46,275,283,128,57,129,45,33,262,69,244,115,127,125,114,113,200,280,229,258,251]),function(le,e,y,R,r,P,L,I,w,b,C,E,v,d,g,m,l,f,u,c,p,h,t,s,o,i,n,a,$,S,D,k,A,j,Z,ae,K,se,ue,x,he,V,te,G,J,q,ne,me,re,B,ee,O,N,Q,T,H,U,ie,z,_,W,X,oe,ge,Ee,Pe,Ne,Fe,$e,ke,ve){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FN=e.$EN=void 0;const Me="monacoworkbench";async function Ue(Ie,Le,Be,ze){const He=new a.$Jh,Ge=new Je,Qe={_serviceBrand:void 0,...k.default};He.set(A.$lj,Qe);const We=new ee.$gm(Le,Qe);He.set(m.$Sh,We),He.set(m.$Th,We);const st=new X.$lN((0,D.$hj)(We),We.logsHome);He.set(D.$7i,st),Ge.registerChannel("logger",new Pe.$4q(st,it=>qe(it.remoteAuthority)));const rt=st.createLogger("remoteagent",{name:(0,Ne.localize)(0,null)}),et=new Ee.$vN(rt,[new Ze((0,D.$hj)(We))]);He.set(D.$6i,et),setTimeout(()=>Se(We.logsHome.with({scheme:P.Schemas.file}).fsPath).then(null,it=>et.error(it)),1e4),et.onDidChangeLogLevel(it=>(0,D.log)(et,it,`Log level changed to ${(0,D.$ij)(et.getLevel())}`)),et.trace(`Remote configuration data at ${Be}`),et.trace("process arguments:",We.args),Array.isArray(Qe.serverGreeting)&&et.info(`

${Qe.serverGreeting.join(`
`)}

`),Ge.registerChannel(v.$Dn.ChannelName,new v.$Dn);const ft=new b.$th(it=>it.clientId==="renderer"),$t=ze.add(new s.$Fp(et));He.set(t.$7j,$t),$t.registerProvider(P.Schemas.file,ze.add(new o.$5p(et)));const Ct=new G.$rr($t);He.set(te.$Dk,Ct);const dt=new E.$Bn(We.machineSettingsResource,$t,new _.$bn,et);He.set(C.$fi,dt);const bt=new oe.$tN(Ct,We,$t,et);He.set(ie.$Fk,bt),Ge.registerChannel("userDataProfiles",new ke.$BN(bt,it=>qe(it.remoteAuthority)));const[,,jt]=await Promise.all([dt.initialize(),bt.init(),(0,I.$Km)(et.error.bind(et))]),Pt=new Q.$om;He.set(Q.$nm,Pt);const wt=new ae.$Qq(dt,We,et,st);He.set(j.$Ko,wt);let pt=ue.$ho;const Ot=(0,ue.$oo)(Qe,dt);if((0,ue.$jo)(Qe,We)){const it=process.env.CS_TELEMETRY_URL||"https://v1.telemetry.coder.com/track";it?pt=new W.$jN(wt,!1,Me,null,()=>new z.$hN(it)):!(0,ue.$ko)(Qe,We)&&Qe.aiConfig?.ariaKey&&(pt=new W.$jN(wt,Ot,Me,null,Qe.aiConfig.ariaKey),ze.add((0,r.$Oc)(()=>pt?.flush())));const vt={appenders:[pt],commonProperties:(0,K.$_n)((0,y.release)(),(0,y.hostname)(),process.arch,Qe.commit,Qe.version+"-remote",jt,Ot,"remoteAgent"),piiPaths:(0,ue.$po)(We)},ct=We.args["telemetry-level"];let ht=3;ct==="all"?ht=3:ct==="error"?ht=2:ct==="crash"?ht=1:ct!==void 0&&(ht=0),He.set(me.$Fr,new i.$Ih(me.$Dr,[vt,ht]))}else He.set(me.$Fr,me.$Er);He.set(f.$2n,new i.$Ih(l.$8o));const Tt=Ge.getChannel("download",ft);He.set(d.$Fn,new g.$Hn(Tt,()=>qe("renderer"))),He.set(U.$mp,new i.$Ih(ge.$uN)),He.set(T.$qp,new i.$Ih(H.$gN)),He.set(u.$9o,new i.$Ih(u.$0o)),He.set(h.$Ap,new i.$Ih(h.$Bp));const ut=new n.$8p(He);He.set($.$Kq,ut.createInstance(S.$Mq));const Ut=ut.createInstance(ve.$DN,{graceTime:108e5,shortGraceTime:3e5,scrollback:dt.getValue("terminal.integrated.persistentSessionScrollback")??100}),Nt=ut.createInstance(V.$nr,Ut);return He.set(he.$Yq,Nt),ut.invokeFunction(it=>{const vt=it.get(h.$Ap),ct=it.get(T.$qp),ht=it.get(f.$2n),Ft=it.get($.$Kq),It=new J.$zr(Ie,We,bt,Pt);Ge.registerChannel("remoteextensionsenvironment",It);const Bt=new ne.$Gr(it.get(me.$Fr),pt);Ge.registerChannel("telemetry",Bt),Ge.registerChannel(O.$aN,new re.$_M(We,et,Nt,Qe,vt,dt));const Dt=new Fe.$zN(ut.createInstance(c.$$o,et),We,bt,ct,et,ht,Ft);Ge.registerChannel($e.$yN,new Fe.$AN(Dt,De=>qe(De.remoteAuthority)));const zt=new q.$Cr(et,We);Ge.registerChannel(N.$eN,zt),Ge.registerChannel("request",new Z.$Nq(it.get(j.$Ko)));const qt=new p.$_o(vt,De=>qe(De.remoteAuthority));Ge.registerChannel("extensions",qt);const ye=b.ProxyChannel.fromService(it.get($.$Kq),ze);return Ge.registerChannel("languagePacks",ye),Dt.whenExtensionsReady().then(()=>vt.cleanUp()),ze.add(new x.default(it.get(se.$0k))),{telemetryService:it.get(se.$0k)}}),{socketServer:Ge,instantiationService:ut}}e.$EN=Ue;const Ye=Object.create(null);function qe(Ie){return Ye[Ie]||(Ye[Ie]=(0,B.$sr)(Ie)),Ye[Ie]}class Je extends b.$ph{constructor(){const Le=new R.$Ld;super(Le.event),this.b=Le}acceptConnection(Le,Be){this.b.fire({protocol:Le,onDidClientDisconnect:Be})}}e.$FN=Je;class Ze extends D.$$i{constructor(Le=D.$9i){super(),this.setLevel(Le),this.g=!!process.stdout.isTTY}trace(Le,...Be){this.f(D.LogLevel.Trace)&&(this.g?console.log(`\x1B[90m[${xe()}]\x1B[0m`,Le,...Be):console.log(`[${xe()}]`,Le,...Be))}debug(Le,...Be){this.f(D.LogLevel.Debug)&&(this.g?console.log(`\x1B[90m[${xe()}]\x1B[0m`,Le,...Be):console.log(`[${xe()}]`,Le,...Be))}info(Le,...Be){this.f(D.LogLevel.Info)&&(this.g?console.log(`\x1B[90m[${xe()}]\x1B[0m`,Le,...Be):console.log(`[${xe()}]`,Le,...Be))}warn(Le,...Be){this.f(D.LogLevel.Warning)&&(this.g?console.warn(`\x1B[93m[${xe()}]\x1B[0m`,Le,...Be):console.warn(`[${xe()}]`,Le,...Be))}error(Le,...Be){this.f(D.LogLevel.Error)&&(this.g?console.error(`\x1B[91m[${xe()}]\x1B[0m`,Le,...Be):console.error(`[${xe()}]`,Le,...Be))}dispose(){}flush(){}}function xe(){const Ie=new Date;return`${de(Ie.getHours())}:${de(Ie.getMinutes())}:${de(Ie.getSeconds())}`}function de(Ie){return Ie<10?`0${Ie}`:String(Ie)}async function Se(Ie){const Le=L.$lc(Ie),Be=L.$kc(Ie),Ge=(await w.Promises.readdir(Be)).filter(We=>/^\d{8}T\d{6}$/.test(We)).sort().filter(We=>We!==Le),Qe=Ge.slice(0,Math.max(0,Ge.length-9));await Promise.all(Qe.map(We=>w.Promises.rm(L.$hc(Be,We))))}}),define(we[292],pe([1,0,86,29,78,293,84,94,15,11,38,2,12,7,41,3,17,4,23,156,158,288,106,72,24,6,13,31,56,32,140,259,260,46,291,264]),function(le,e,y,R,r,P,L,I,w,b,C,E,v,d,g,m,l,f,u,c,p,h,t,s,o,i,n,a,$,S,D,k,A,j,Z,ae){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NN=void 0;const K=5*60*1e3;let se=class extends E.$Qc{constructor(V,te,G,J,q,ne,me,re){super(),this.n=V,this.r=te,this.s=G,this.t=q,this.u=ne,this.w=me,this.y=re,this.h=x.create(this.u),this.j=(0,$.$Rk)(ne),this.a=Object.create(null),this.b=Object.create(null),this.f=new Set,this.g=J?this.y.createInstance(ae.$IN,this.r):null,this.w.info("Extension host agent started."),this.L(!0)}async handleRequest(V,te){if(V.method!=="GET")return(0,ae.$GN)(V,te,405,`Unsupported method ${V.method}`);if(!V.url)return(0,ae.$GN)(V,te,400,"Bad request.");const G=L.parse(V.url,!0);let J=G.pathname;if(!J)return(0,ae.$GN)(V,te,400,"Bad request.");if(J.startsWith(this.j)&&J.charCodeAt(this.j.length)===47&&(J=J.substring(this.j.length)),J==="/version")return te.writeHead(200,{"Content-Type":"text/plain"}),void te.end(this.u.commit||"");if(J==="/delay-shutdown")return this.N(),te.writeHead(200),void te.end("OK");if(!(0,A.$Cm)(this.r,V,G))return(0,ae.$GN)(V,te,403,"Forbidden.");if(J==="/vscode-remote-resource"){const q=G.query.path;if(typeof q!="string")return(0,ae.$GN)(V,te,400,"Bad request.");let ne;try{ne=f.URI.from({scheme:v.Schemas.file,path:q}).fsPath}catch{return(0,ae.$GN)(V,te,400,"Bad request.")}const me=Object.create(null);this.t.isBuilt&&((0,C.$Vf)(ne,this.t.builtinExtensionsPath,!m.$f)||(0,C.$Vf)(ne,this.t.extensionsPath,!m.$f))&&(me["Cache-Control"]="public, max-age=31536000"),me.Vary="Origin";const re=V.headers.origin;return re&&this.h.matches(re)&&(me["Access-Control-Allow-Origin"]=re),(0,ae.$HN)(ne,1,this.w,V,te,me)}if(this.g){this.g.handle(V,te,G);return}return te.writeHead(404,{"Content-Type":"text/plain"}),void te.end("Not found")}handleUpgrade(V,te){let G=(0,u.$bg)(),J=!1,q=!1;if(V.url){const O=L.parse(V.url,!0).query;typeof O.reconnectionToken=="string"&&(G=O.reconnectionToken),O.reconnection==="true"&&(J=!0),O.skipWebSocketFrames==="true"&&(q=!0)}if(V.headers.upgrade===void 0||V.headers.upgrade.toLowerCase()!=="websocket"){te.end("HTTP/1.1 400 Bad Request");return}const ne=V.headers["sec-websocket-key"],me=y.createHash("sha1");me.update(ne+"258EAFA5-E914-47DA-95CA-C5AB0DC85B11");const B=["HTTP/1.1 101 Switching Protocols","Upgrade: websocket","Connection: Upgrade",`Sec-WebSocket-Accept: ${me.digest("base64")}`];let ee=!1;if(!q&&!this.t.args["disable-websocket-compression"]&&V.headers["sec-websocket-extensions"]){const O=Array.isArray(V.headers["sec-websocket-extensions"])?V.headers["sec-websocket-extensions"]:[V.headers["sec-websocket-extensions"]];for(const N of O)if(!/\b((server_max_window_bits)|(server_no_context_takeover)|(client_no_context_takeover))\b/.test(N)){if(/\b(permessage-deflate)\b/.test(N)){ee=!0,B.push("Sec-WebSocket-Extensions: permessage-deflate");break}if(/\b(x-webkit-deflate-frame)\b/.test(N)){ee=!0,B.push("Sec-WebSocket-Extensions: x-webkit-deflate-frame");break}}}te.write(B.join(`\r
`)+`\r
\r
`),te.setTimeout(0),te.setNoDelay(!0),q?this.D(new s.$Ah(te,`server-connection-${G}`),J,G):this.D(new s.$Bh(new s.$Ah(te,`server-connection-${G}`),ee,null,!0),J,G)}handleServerError(V){this.w.error("Error occurred in server"),this.w.error(V)}z(V){let te;return V instanceof s.$Ah?te=V.socket:te=V.socket.socket,te.remoteAddress||"<unknown>"}async C(V,te,G){const J=te.getSocket();this.w.error(`${V} ${G}.`);const q={type:"error",reason:G};te.sendControl(w.$_d.fromString(JSON.stringify(q))),te.dispose(),await J.drain(),J.dispose()}D(V,te,G){const J=this.z(V),q=`[${J}][${G.substr(0,8)}]`,ne=new t.$zh({socket:V}),me=this.s?new this.s.validator:null,re=this.s?new this.s.signer:null;let B;(function(Q){Q[Q.WaitingForAuth=0]="WaitingForAuth",Q[Q.WaitingForConnectionType=1]="WaitingForConnectionType",Q[Q.Done=2]="Done",Q[Q.Error=3]="Error"})(B||(B={}));let ee=0;const O=Q=>{ee=3,N.dispose(),this.C(q,ne,Q)},N=ne.onControlMessage(Q=>{if(ee===0){let T;try{T=JSON.parse(Q.toString())}catch{return O("Malformed first message")}if(T.type!=="auth")return O("Invalid first message");if(this.r.type===2&&!this.r.validate(T.auth))return O("Unauthorized client refused: auth mismatch");let H=(0,u.$bg)();if(re)try{H=re.sign(T.data)}catch{}let U=(0,u.$bg)();if(me)try{U=me.createNewMessage(U)}catch{}const ie={type:"sign",data:U,signedData:H};ne.sendControl(w.$_d.fromString(JSON.stringify(ie))),ee=1}else if(ee===1){let T;try{T=JSON.parse(Q.toString())}catch{return O("Malformed second message")}if(T.type!=="connectionType")return O("Invalid second message");if(typeof T.signedData!="string")return O("Invalid second message field type");const H=T.commit,U=this.u.commit;if(H&&U&&H!==U)return O("Client refused: version mismatch");let ie=!1;if(!me)ie=!0;else if(this.r.validate(T.signedData))ie=!0;else try{ie=me.validate(T.signedData)==="ok"}catch{}if(!ie){if(this.t.isBuilt)return O("Unauthorized client refused");this.w.error(`${q} Unauthorized client handshake failed but we proceed because of dev mode.`)}for(const z in this.b)this.b[z].shortenReconnectionGraceTimeIfNecessary();for(const z in this.a)this.a[z].shortenReconnectionGraceTimeIfNecessary();ee=2,N.dispose(),this.F(J,q,ne,V,te,G,T)}})}async F(V,te,G,J,q,ne,me){const re=me.desiredConnectionType===1?`${te}[ManagementConnection]`:me.desiredConnectionType===2?`${te}[ExtensionHostConnection]`:te;if(me.desiredConnectionType===1)if(q){if(!this.b[ne])return this.f.has(ne)?this.C(re,G,"Unknown reconnection token (seen before)"):this.C(re,G,"Unknown reconnection token (never seen)");G.sendControl(w.$_d.fromString(JSON.stringify({type:"ok"})));const B=G.readEntireBuffer();G.dispose(),this.b[ne].acceptReconnection(V,J,B)}else{if(this.b[ne])return this.C(re,G,"Duplicate reconnection token");G.sendControl(w.$_d.fromString(JSON.stringify({type:"ok"})));const B=new k.$wm(this.w,ne,V,G);this.n.acceptConnection(B.protocol,B.onClose),this.b[ne]=B,this.f.add(ne),B.onClose(()=>{delete this.b[ne]})}else if(me.desiredConnectionType===2){const B=me.args||{language:"en"},ee=await this.I(B);if(ee.port&&this.w.trace(`${re} - startParams debug port ${ee.port}`),this.w.trace(`${re} - startParams language: ${ee.language}`),this.w.trace(`${re} - startParams env: ${JSON.stringify(ee.env)}`),q){if(!this.a[ne])return this.f.has(ne)?this.C(re,G,"Unknown reconnection token (seen before)"):this.C(re,G,"Unknown reconnection token (never seen)");G.sendPause(),G.sendControl(w.$_d.fromString(JSON.stringify(ee.port?{debugPort:ee.port}:{})));const O=G.readEntireBuffer();G.dispose(),this.a[ne].acceptReconnection(V,J,O)}else{if(this.a[ne])return this.C(re,G,"Duplicate reconnection token");G.sendPause(),G.sendControl(w.$_d.fromString(JSON.stringify(ee.port?{debugPort:ee.port}:{})));const O=G.readEntireBuffer();G.dispose();const N=this.y.createInstance(D.$vm,ne,V,J,O);this.a[ne]=N,this.f.add(ne),N.onClose(()=>{delete this.a[ne],this.J()}),N.start(ee)}}else if(me.desiredConnectionType===3){const B=me.args;this.G(G,B)}else return this.C(re,G,"Unknown initial data received")}async G(V,te){const G=V.getSocket().socket,J=V.readEntireBuffer();V.dispose(),G.pause();const q=await this.H(te.host,te.port);J.byteLength>0&&q.write(J.buffer),q.on("end",()=>G.end()),q.on("close",()=>G.end()),q.on("error",()=>G.destroy()),G.on("end",()=>q.end()),G.on("close",()=>q.end()),G.on("error",()=>q.destroy()),q.pipe(G),G.pipe(q)}H(V,te){return new Promise((G,J)=>{const q=r.createConnection({host:V,port:te,autoSelectFamily:!0},()=>{q.removeListener("error",J),q.pause(),G(q)});q.once("error",J)})}I(V){return typeof V.port=="number"?(0,p.$dg)(V.port,10,5e3).then(te=>(V.port=te,V)):(V.debugId=void 0,V.port=void 0,V.break=void 0,Promise.resolve(V))}async J(){if(!this.t.args["enable-remote-auto-shutdown"])return;this.O(),!!Object.keys(this.a).length||(console.log("Last EH closed, waiting before shutting down"),this.w.info("Last EH closed, waiting before shutting down"),this.L())}L(V=!1){this.t.args["enable-remote-auto-shutdown"]&&(this.t.args["remote-auto-shutdown-without-delay"]&&!V?this.M():this.m=setTimeout(()=>{this.m=void 0,this.M()},K))}M(){if(!!Object.keys(this.a).length){console.log("New EH opened, aborting shutdown"),this.w.info("New EH opened, aborting shutdown");return}else console.log("Last EH closed, shutting down"),this.w.info("Last EH closed, shutting down"),this.dispose(),process.exit(0)}N(){this.m&&(console.log("Got delay-shutdown request while in shutdown timeout, delaying"),this.w.info("Got delay-shutdown request while in shutdown timeout, delaying"),this.O(),this.L())}O(){this.m&&(console.log("Cancelling previous shutdown timeout"),this.w.info("Cancelling previous shutdown timeout"),clearTimeout(this.m),this.m=void 0)}};se=Oe([Ae(4,j.$fm),Ae(5,a.$lj),Ae(6,n.$6i),Ae(7,i.$Kh)],se);async function ue(he,V,te){const G=await(0,A.$Bm)(V);G instanceof A.$zm&&(console.warn(G.message),process.exit(1));function J(ie){(0,b.setUnexpectedErrorHandler)(z=>{(0,b.$X)(z)&&z.stack&&/unexpectedErrorHandler/.test(z.stack)||ie(z)})}const q=[];J(ie=>{q.push(ie),console.error(ie)});let ne=!1;process.on("SIGPIPE",()=>{ne||(ne=!0,(0,b.$Y)(new Error("Unexpected SIGPIPE")))});const me=new E.$Pc,{socketServer:re,instantiationService:B}=await(0,Z.$EN)(G,V,te,me);B.invokeFunction(ie=>{const z=ie.get(n.$6i);q.forEach(_=>z.error(_)),q.length=0,J(_=>z.error(_))}),B.invokeFunction(ie=>{const z=ie.get(o.$fi);m.$d&&(z.getValue("security.restrictUNCAccess")===!1?(0,h.disableUNCAccessRestrictions)():(0,h.addUNCHostToAllowlist)(z.getValue("security.allowedUNCHosts")))}),B.invokeFunction(ie=>{const z=ie.get(n.$6i);if(m.$d&&process.env.HOMEDRIVE&&process.env.HOMEPATH){const _=(0,d.$hc)(process.env.HOMEDRIVE,"node_modules"),W=(0,d.$kc)((0,d.$hc)(process.env.HOMEDRIVE,process.env.HOMEPATH)),X=(0,d.$hc)(W,"node_modules");if(R.existsSync(_)||R.existsSync(X)){const oe=`

*
* !!!! Server terminated due to presence of CVE-2020-1416 !!!!
*
* Please remove the following directories and re-try
* ${_}
* ${X}
*
* For more information on the vulnerability https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2020-1416
*

`;z.warn(oe),console.warn(oe),process.exit(0)}}});const ee=B.invokeFunction(ie=>{const z=ie.get(n.$6i);if(R.existsSync((0,d.$hc)(v.$_f.asFileUri("").fsPath,"../node_modules/vsda")))try{return globalThis._VSCODE_NODE_MODULES.vsda}catch(W){z.error(W)}return null}),O=R.existsSync(v.$_f.asFileUri("vs/code/browser/workbench/workbench.html").fsPath);if(O&&he&&typeof he!="string"){const ie=G.type!==0?`?${v.$6f}=${G.value}`:"";console.log(`Web UI available at http://localhost${he.port===80?"":`:${he.port}`}/${ie}`)}const N=B.createInstance(se,re,G,ee,O);g.mark("code/server/ready");const Q=P.performance.now(),T=global.vscodeServerStartTime,H=global.vscodeServerListenTime,U=global.vscodeServerCodeLoadedTime;if(B.invokeFunction(async ie=>{const z=ie.get(S.$0k);if(z.publicLog2("serverStart",{startTime:T,startedTime:H,codeLoadedTime:U,readyTime:Q}),m.$f){const _=ie.get(n.$6i),W=await(0,c.$cg)(_.error.bind(_));W&&z.publicLog2("serverPlatformInfo",{platformId:W.id,platformVersionId:W.version_id,platformIdLike:W.id_like})}}),V["print-startup-performance"]){const ie=I.$S.get();let z="";z+=`

### Load AMD-module
`,z+=I.$S.toMarkdownTable(["Module","Duration"],ie.amdLoad),z+=`

### Load commonjs-module
`,z+=I.$S.toMarkdownTable(["Module","Duration"],ie.nodeRequire),z+=`

### Invoke AMD-module factory
`,z+=I.$S.toMarkdownTable(["Module","Duration"],ie.amdInvoke),z+=`

### Invoke commonjs-module
`,z+=I.$S.toMarkdownTable(["Module","Duration"],ie.nodeEval),z+=`Start-up time: ${H-T}
`,z+=`Code loading time: ${U-T}
`,z+=`Initialized time: ${Q-T}
`,z+=`
`,console.log(z)}return N}e.$NN=ue;class x{static create(V){const te=V.webEndpointUrlTemplate,G=V.commit,J=V.quality;if(!te||!G||!J)return new x(null);const q=(0,u.$bg)(),me=new URL(te.replace("{{uuid}}",q).replace("{{commit}}",G).replace("{{quality}}",J)).origin,re=(0,l.$De)(me).replace(q,"[a-zA-Z0-9\\-]+");try{const B=(0,l.$Le)(`^${re}$`,!0,{matchCase:!1});return new x(B)}catch{return new x(null)}}constructor(V){this.a=V}matches(V){return this.a?this.a.test(V):!1}}}),define(we[303],pe([1,0,27,29,12,287,292,64,7,293,46,54,41]),function(le,e,y,R,r,P,L,I,w,b,C,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createServer=e.spawnCli=void 0,v.mark("code/server/codeLoaded"),global.vscodeServerCodeLoadedTime=b.performance.now();const d={onMultipleValues:(u,c)=>{console.error(`Option '${u}' can only be defined once. Using value ${c}.`)},onEmptyValue:u=>{console.error(`Ignoring option '${u}': Value must not be empty.`)},onUnknownOption:u=>{console.error(`Ignoring option '${u}': not supported for server.`)},onDeprecatedOption:(u,c)=>{console.warn(`Option '${u}' is deprecated: ${c}`)}};function g(){return(0,I.$Bl)(process.argv.slice(2),C.$em,d)}function m(u){const c=u["server-data-dir"]||u["user-data-dir"]||process.env.VSCODE_AGENT_FOLDER||(0,w.$hc)(y.homedir(),E.default.serverDataFolderName||".vscode-remote"),p=u["user-data-dir"]||(0,w.$hc)(c,"data"),h=(0,w.$hc)(p,"User"),t=(0,w.$hc)(h,"globalStorage"),s=(0,w.$hc)(h,"History"),o=(0,w.$hc)(p,"Machine");u["user-data-dir"]=p;const i=(0,w.$kc)(r.$_f.asFileUri("").fsPath),n=u["builtin-extensions-dir"]||(0,w.$hc)(i,"extensions");return u["builtin-extensions-dir"]=n,u["extensions-dir"]=u["extensions-dir"]||(0,w.$hc)(c,"extensions"),[c,u["extensions-dir"],p,h,o,t,s].forEach(a=>{try{R.existsSync(a)||R.mkdirSync(a,{mode:448})}catch($){console.error($)}}),c}function l(u=g()){return(0,P.run)(u,m(u),C.$em)}e.spawnCli=l;function f(u,c=g()){return(0,L.$NN)(u,c,m(c))}e.createServer=f})}).call(this);

//# sourceMappingURL=server.main.js.map
