"use strict";/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Se=["exports","require","vs/base/common/uri","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostTypes","vs/base/common/errors","vs/base/common/async","vs/base/common/platform","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/workbench/api/common/extHostTypeConverters","vs/platform/log/common/log","vs/base/common/path","vs/base/common/strings","vs/base/common/network","vs/base/common/types","vs/base/common/arrays","vs/workbench/api/common/extHostRpcService","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/objects","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/workbench/services/extensions/common/extensions","vs/base/common/map","vs/base/node/pfs","vs/platform/files/common/files","vs/base/common/uuid","vs/base/common/extpath","vs/workbench/api/common/extHostCommands","vs/base/common/glob","vs/editor/common/core/range","vs/workbench/services/search/common/search","vs/workbench/api/common/extHostWorkspace","vs/base/common/stopwatch","vs/base/common/severity","vs/workbench/api/common/extHostConfiguration","vs/platform/contextkey/common/contextkey","vs/platform/registry/common/platform","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostExtensionService","vs/base/common/process","child_process","vs/base/common/errorMessage","vs/platform/configuration/common/configuration","vs/base/common/iterator","vs/base/common/hash","fs","vs/base/common/performance","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/decorators","vs/base/common/assert","vs/base/common/lazy","vs/base/common/themables","vs/base/common/marshalling","os","net","vs/editor/common/core/position","vs/platform/progress/common/progress","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTunnelService","vs/base/common/collections","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/ternarySearchTree","vs/base/common/codicons","vs/base/common/htmlContent","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/languages","vs/platform/files/common/watcher","vs/platform/telemetry/common/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/mime","vs/base/common/processes","vs/base/common/stream","vs/base/common/labels","vs/base/node/extpath","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/sign/common/sign","http","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/parts/ipc/node/ipc.net","vs/base/common/arraysFind","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/comparers","vs/base/common/filters","vs/base/common/fuzzyScorer","vs/base/common/uint","vs/base/common/uriIpc","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/product/common/productService","vs/platform/configuration/common/configurationRegistry","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/sign/node/signService","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/amd","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/cache","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/console","vs/amdX","vs/base/common/dataTransfer","vs/base/node/ports","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languageSelector","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/services/treeViewsDnd","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/editor/common/languages","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChat","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/remote/common/tunnelModel","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/dialogs/common/dialogs","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/io","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/sign/common/abstractSignService","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/proxyResolver","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/api/common/extHostTheming","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostTreeViews","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostChatAgents","vs/workbench/api/common/extHostChatProvider","vs/workbench/api/common/extHostChatSlashCommand","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostDiskFileSystemProvider","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/remote/common/tunnelModel","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/platform/tunnel/node/tunnelService","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHostTunnelService","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","graceful-fs","https","tls","@vscode/proxy-agent","events","vscode-regexpp","crypto","zlib","vs/workbench/api/node/extensionHostProcess","minimist"],De=function(ne){for(var e=[],y=0,M=ne.length;y<M;y++)e[y]=Se[ne[y]];return e};define(Se[157],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S=e.$R=void 0,e.$R=!1;class y{static get(){const l=new Map,R=new Map,A=new Map,m=new Map;function k(S,D){S.has(D.detail)||S.set(D.detail,-D.timestamp)}function $(S,D){const E=S.get(D.detail);E&&(E>=0||S.set(D.detail,E+D.timestamp))}let P=[];typeof ne=="function"&&typeof ne.getStats=="function"&&(P=ne.getStats().slice(0).sort((S,D)=>S.timestamp-D.timestamp));for(const S of P)switch(S.type){case 10:k(l,S);break;case 11:case 12:$(l,S);break;case 21:k(R,S);break;case 22:$(R,S);break;case 33:k(A,S);break;case 34:$(A,S);break;case 31:k(m,S);break;case 32:$(m,S);break}let C=0;A.forEach(S=>C+=S);function v(S){const D=[];return S.forEach((E,s)=>D.push([s,E])),D}return{amdLoad:v(l),amdInvoke:v(R),nodeRequire:v(A),nodeEval:v(m),nodeRequireTotal:C}}static toMarkdownTable(l,R){let A="";const m=[];return l.forEach((k,$)=>{m[$]=k.length}),R.forEach(k=>{k.forEach(($,P)=>{typeof $>"u"&&($=k[P]="-");const C=$.toString().length;m[P]=Math.max(C,m[P])})}),l.forEach((k,$)=>{A+=`| ${k+" ".repeat(m[$]-k.toString().length)} `}),A+=`|
`,l.forEach((k,$)=>{A+=`| ${"-".repeat(m[$])} `}),A+=`|
`,R.forEach(k=>{k.forEach(($,P)=>{typeof $<"u"&&(A+=`| ${$+" ".repeat(m[P]-$.toString().length)} `)}),A+=`|
`}),A}}e.$S=y}),define(Se[119],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=e.$eb=e.$db=void 0;function y(E,s,c){const u=M(E,s);if(u!==-1)return E[u]}e.$db=y;function M(E,s,c=E.length-1){for(let u=c;u>=0;u--){const o=E[u];if(s(o))return u}return-1}e.$eb=M;function l(E,s){const c=R(E,s);return c===-1?void 0:E[c]}e.$fb=l;function R(E,s,c=0,u=E.length){let o=c,g=u;for(;o<g;){const d=Math.floor((o+g)/2);s(E[d])?o=d+1:g=d}return o-1}e.$gb=R;function A(E,s){const c=m(E,s);return c===E.length?void 0:E[c]}e.$hb=A;function m(E,s,c=0,u=E.length){let o=c,g=u;for(;o<g;){const d=Math.floor((o+g)/2);s(E[d])?g=d:o=d+1}return o}e.$ib=m;function k(E,s,c=0,u=E.length){const o=m(E,s,c,u);return o===E.length?-1:o}e.$jb=k;class ${constructor(s){this.e=s,this.c=0}findLastMonotonous(s){if($.assertInvariants){if(this.d){for(const u of this.e)if(this.d(u)&&!s(u))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=s}const c=R(this.e,s,this.c);return this.c=c+1,c===-1?void 0:this.e[c]}}e.$kb=$,$.assertInvariants=!1;function P(E,s){if(E.length===0)return;let c=E[0];for(let u=1;u<E.length;u++){const o=E[u];s(o,c)>0&&(c=o)}return c}e.$lb=P;function C(E,s){if(E.length===0)return;let c=E[0];for(let u=1;u<E.length;u++){const o=E[u];s(o,c)>=0&&(c=o)}return c}e.$mb=C;function v(E,s){return P(E,(c,u)=>-s(c,u))}e.$nb=v;function S(E,s){if(E.length===0)return-1;let c=0;for(let u=1;u<E.length;u++){const o=E[u];s(o,E[c])>0&&(c=u)}return c}e.$ob=S;function D(E,s){for(const c of E){const u=s(c);if(u!==void 0)return u}}e.$pb=D}),define(Se[74],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$G=e.$F=e.$E=e.$D=void 0;function y(A,m){const k=Object.create(null);for(const $ of A){const P=m($);let C=k[P];C||(C=k[P]=[]),C.push($)}return k}e.$D=y;function M(A,m){const k=[],$=[];for(const P of A)m.has(P)||k.push(P);for(const P of m)A.has(P)||$.push(P);return{removed:k,added:$}}e.$E=M;function l(A,m){const k=[],$=[];for(const[P,C]of A)m.has(P)||k.push(C);for(const[P,C]of m)A.has(P)||$.push(C);return{removed:k,added:$}}e.$F=l;function R(A,m){const k=new Set;for(const $ of m)A.has($)&&k.add($);return k}e.$G=R}),define(Se[56],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fh=e.$eh=e.$dh=void 0;function y(A){return(m,k,$)=>{let P=null,C=null;if(typeof $.value=="function"?(P="value",C=$.value):typeof $.get=="function"&&(P="get",C=$.get),!C)throw new Error("not supported");$[P]=A(C,k)}}function M(A,m,k){let $=null,P=null;if(typeof k.value=="function"?($="value",P=k.value,P.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof k.get=="function"&&($="get",P=k.get),!P)throw new Error("not supported");const C=`$memoize$${m}`;k[$]=function(...v){return this.hasOwnProperty(C)||Object.defineProperty(this,C,{configurable:!1,enumerable:!1,writable:!1,value:P.apply(this,v)}),this[C]}}e.$dh=M;function l(A,m,k){return y(($,P)=>{const C=`$debounce$${P}`,v=`$debounce$result$${P}`;return function(...S){this[v]||(this[v]=k?k():void 0),clearTimeout(this[C]),m&&(this[v]=m(this[v],...S),S=[this[v]]),this[C]=setTimeout(()=>{$.apply(this,S),this[v]=k?k():void 0},A)}})}e.$eh=l;function R(A,m,k){return y(($,P)=>{const C=`$throttle$timer$${P}`,v=`$throttle$result$${P}`,S=`$throttle$lastRun$${P}`,D=`$throttle$pending$${P}`;return function(...E){if(this[v]||(this[v]=k?k():void 0),(this[S]===null||this[S]===void 0)&&(this[S]=-Number.MAX_VALUE),m&&(this[v]=m(this[v],...E)),this[D])return;const s=this[S]+A;s<=Date.now()?(this[S]=Date.now(),$.apply(this,[this[v]]),this[v]=k?k():void 0):(this[D]=!0,this[C]=setTimeout(()=>{this[D]=!1,this[S]=Date.now(),$.apply(this,[this[v]]),this[v]=k?k():void 0},s-Date.now()))}})}e.$fh=R}),define(Se[8],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.$Y=e.$X=e.setUnexpectedErrorHandler=e.$V=e.$U=void 0;class y{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?o.isErrorNoTelemetry(t)?new o(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(n=>{n(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$U=y,e.$V=new y;function M(d){e.$V.setUnexpectedErrorHandler(d)}e.setUnexpectedErrorHandler=M;function l(d){if(!d||typeof d!="object")return!1;const t=d;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}e.$X=l;function R(d){$(d)||e.$V.onUnexpectedError(d)}e.$Y=R;function A(d){$(d)||e.$V.onUnexpectedExternalError(d)}e.$Z=A;function m(d){if(d instanceof Error){const{name:t,message:n}=d,r=d.stacktrace||d.stack;return{$isError:!0,name:t,message:n,stack:r,noTelemetry:o.isErrorNoTelemetry(d)}}return d}e.$1=m;const k="Canceled";function $(d){return d instanceof P?!0:d instanceof Error&&d.name===k&&d.message===k}e.$2=$;class P extends Error{constructor(){super(k),this.name=this.message}}e.$3=P;function C(){const d=new Error(k);return d.name=d.message,d}e.$4=C;function v(d){return d?new Error(`Illegal argument: ${d}`):new Error("Illegal argument")}e.$5=v;function S(d){return d?new Error(`Illegal state: ${d}`):new Error("Illegal state")}e.$6=S;class D extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$7=D;function E(d){return d?d.message?d.message:d.stack?d.stack.split(`
`)[0]:String(d):"Error"}e.$8=E;class s extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$9=s;class c extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$0=c;class u extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$$=u;class o extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof o)return t;const n=new o;return n.message=t.message,n.stack=t.stack,n}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$_=o;class g extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,g.prototype)}}e.$ab=g}),define(Se[19],De([1,0,8,119]),function(ne,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$b=e.$0b=e.$9b=e.$8b=e.$7b=e.$6b=e.$5b=e.CompareResult=e.$4b=e.$3b=e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=e.$Ib=e.$Hb=e.$Gb=e.$Fb=e.$Eb=e.top=e.$Cb=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=e.$tb=e.$sb=e.$rb=e.$qb=void 0;function l(Y,Z=0){return Y[Y.length-(1+Z)]}e.$qb=l;function R(Y){if(Y.length===0)throw new Error("Invalid tail call");return[Y.slice(0,Y.length-1),Y[Y.length-1]]}e.$rb=R;function A(Y,Z,_=(pe,se)=>pe===se){if(Y===Z)return!0;if(!Y||!Z||Y.length!==Z.length)return!1;for(let pe=0,se=Y.length;pe<se;pe++)if(!_(Y[pe],Z[pe]))return!1;return!0}e.$sb=A;function m(Y,Z){const _=Y.length-1;Z<_&&(Y[Z]=Y[_]),Y.pop()}e.$tb=m;function k(Y,Z,_){return $(Y.length,pe=>_(Y[pe],Z))}e.$ub=k;function $(Y,Z){let _=0,pe=Y-1;for(;_<=pe;){const se=(_+pe)/2|0,ge=Z(se);if(ge<0)_=se+1;else if(ge>0)pe=se-1;else return se}return-(_+1)}e.$vb=$;function P(Y,Z,_){if(Y=Y|0,Y>=Z.length)throw new TypeError("invalid index");const pe=Z[Math.floor(Z.length*Math.random())],se=[],ge=[],ie=[];for(const fe of Z){const be=_(fe,pe);be<0?se.push(fe):be>0?ge.push(fe):ie.push(fe)}return Y<se.length?P(Y,se,_):Y<se.length+ie.length?ie[0]:P(Y-(se.length+ie.length),ge,_)}e.$wb=P;function C(Y,Z){const _=[];let pe;for(const se of Y.slice(0).sort(Z))!pe||Z(pe[0],se)!==0?(pe=[se],_.push(pe)):pe.push(se);return _}e.$xb=C;function*v(Y,Z){let _,pe;for(const se of Y)pe!==void 0&&Z(pe,se)?_.push(se):(_&&(yield _),_=[se]),pe=se;_&&(yield _)}e.$yb=v;function S(Y,Z){for(let _=0;_<=Y.length;_++)Z(_===0?void 0:Y[_-1],_===Y.length?void 0:Y[_])}e.$zb=S;function D(Y,Z){for(let _=0;_<Y.length;_++)Z(_===0?void 0:Y[_-1],Y[_],_+1===Y.length?void 0:Y[_+1])}e.$Ab=D;function E(Y,Z,_){const pe=[];function se(fe,be,Ie){if(be===0&&Ie.length===0)return;const W=pe[pe.length-1];W&&W.start+W.deleteCount===fe?(W.deleteCount+=be,W.toInsert.push(...Ie)):pe.push({start:fe,deleteCount:be,toInsert:Ie})}let ge=0,ie=0;for(;;){if(ge===Y.length){se(ge,0,Z.slice(ie));break}if(ie===Z.length){se(ge,Y.length-ge,[]);break}const fe=Y[ge],be=Z[ie],Ie=_(fe,be);Ie===0?(ge+=1,ie+=1):Ie<0?(se(ge,1,[]),ge+=1):Ie>0&&(se(ge,0,[be]),ie+=1)}return pe}e.$Bb=E;function s(Y,Z,_){const pe=E(Y,Z,_),se=[],ge=[];for(const ie of pe)se.push(...Y.slice(ie.start,ie.start+ie.deleteCount)),ge.push(...ie.toInsert);return{removed:se,added:ge}}e.$Cb=s;function c(Y,Z,_){if(_===0)return[];const pe=Y.slice(0,_).sort(Z);return o(Y,Z,pe,_,Y.length),pe}e.top=c;function u(Y,Z,_,pe,se){return _===0?Promise.resolve([]):new Promise((ge,ie)=>{(async()=>{const fe=Y.length,be=Y.slice(0,_).sort(Z);for(let Ie=_,W=Math.min(_+pe,fe);Ie<fe;Ie=W,W=Math.min(W+pe,fe)){if(Ie>_&&await new Promise(G=>setTimeout(G)),se&&se.isCancellationRequested)throw new y.$3;o(Y,Z,be,Ie,W)}return be})().then(ge,ie)})}e.$Eb=u;function o(Y,Z,_,pe,se){for(const ge=_.length;pe<se;pe++){const ie=Y[pe];if(Z(ie,_[ge-1])<0){_.pop();const fe=(0,M.$ib)(_,be=>Z(ie,be)<0);_.splice(fe,0,ie)}}}function g(Y){return Y.filter(Z=>!!Z)}e.$Fb=g;function d(Y){let Z=0;for(let _=0;_<Y.length;_++)Y[_]&&(Y[Z]=Y[_],Z+=1);Y.length=Z}e.$Gb=d;function t(Y,Z,_){Y.splice(_,0,Y.splice(Z,1)[0])}e.$Hb=t;function n(Y){return!Array.isArray(Y)||Y.length===0}e.$Ib=n;function r(Y){return Array.isArray(Y)&&Y.length>0}e.$Jb=r;function i(Y,Z=_=>_){const _=new Set;return Y.filter(pe=>{const se=Z(pe);return _.has(se)?!1:(_.add(se),!0)})}e.$Kb=i;function a(Y){const Z=new Set;return _=>{const pe=Y(_);return Z.has(pe)?!1:(Z.add(pe),!0)}}e.$Lb=a;function h(Y,Z){return Y.length>0?Y[0]:Z}e.$Mb=h;function p(Y,Z){return Y.length>0?Y[Y.length-1]:Z}e.$Nb=p;function I(Y,Z,_=(pe,se)=>pe===se){let pe=0;for(let se=0,ge=Math.min(Y.length,Z.length);se<ge&&_(Y[se],Z[se]);se++)pe++;return pe}e.$Ob=I;function w(Y){return[].concat(...Y)}e.$Pb=w;function f(Y,Z){let _=typeof Z=="number"?Y:0;typeof Z=="number"?_=Y:(_=0,Z=Y);const pe=[];if(_<=Z)for(let se=_;se<Z;se++)pe.push(se);else for(let se=_;se>Z;se--)pe.push(se);return pe}e.$Qb=f;function b(Y,Z,_){return Y.reduce((pe,se)=>(pe[Z(se)]=_?_(se):se,pe),Object.create(null))}e.$Rb=b;function L(Y,Z){return Y.push(Z),()=>O(Y,Z)}e.$Sb=L;function O(Y,Z){const _=Y.indexOf(Z);if(_>-1)return Y.splice(_,1),Z}e.$Tb=O;function T(Y,Z,_){const pe=Y.slice(0,Z),se=Y.slice(Z);return pe.concat(_,se)}e.$Ub=T;function F(Y,Z){let _;if(typeof Z=="number"){let pe=Z;_=()=>{const se=Math.sin(pe++)*179426549;return se-Math.floor(se)}}else _=Math.random;for(let pe=Y.length-1;pe>0;pe-=1){const se=Math.floor(_()*(pe+1)),ge=Y[pe];Y[pe]=Y[se],Y[se]=ge}}e.$Vb=F;function U(Y,Z){const _=Y.indexOf(Z);_>-1&&(Y.splice(_,1),Y.unshift(Z))}e.$Wb=U;function N(Y,Z){const _=Y.indexOf(Z);_>-1&&(Y.splice(_,1),Y.push(Z))}e.$Xb=N;function j(Y,Z){for(const _ of Z)Y.push(_)}e.$Yb=j;function z(Y,Z){return Array.isArray(Y)?Y.map(Z):Z(Y)}e.$Zb=z;function B(Y){return Array.isArray(Y)?Y:[Y]}e.$1b=B;function ae(Y){return Y[Math.floor(Math.random()*Y.length)]}e.$2b=ae;function X(Y,Z,_){const pe=H(Y,Z),se=Y.length,ge=_.length;Y.length=se+ge;for(let ie=se-1;ie>=pe;ie--)Y[ie+ge]=Y[ie];for(let ie=0;ie<ge;ie++)Y[ie+pe]=_[ie]}e.$3b=X;function Q(Y,Z,_,pe){const se=H(Y,Z);let ge=Y.splice(se,_);return ge===void 0&&(ge=[]),X(Y,se,pe),ge}e.$4b=Q;function H(Y,Z){return Z<0?Math.max(Z+Y.length,0):Math.min(Z,Y.length)}var te;(function(Y){function Z(ge){return ge<0}Y.isLessThan=Z;function _(ge){return ge<=0}Y.isLessThanOrEqual=_;function pe(ge){return ge>0}Y.isGreaterThan=pe;function se(ge){return ge===0}Y.isNeitherLessOrGreaterThan=se,Y.greaterThan=1,Y.lessThan=-1,Y.neitherLessOrGreaterThan=0})(te||(e.CompareResult=te={}));function me(Y,Z){return(_,pe)=>Z(Y(_),Y(pe))}e.$5b=me;function le(...Y){return(Z,_)=>{for(const pe of Y){const se=pe(Z,_);if(!te.isNeitherLessOrGreaterThan(se))return se}return te.neitherLessOrGreaterThan}}e.$6b=le;const ye=(Y,Z)=>Y-Z;e.$7b=ye;const de=(Y,Z)=>(0,e.$7b)(Y?1:0,Z?1:0);e.$8b=de;function V(Y){return(Z,_)=>-Y(Z,_)}e.$9b=V;class J{constructor(Z){this.g=Z,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(Z){let _=this.c;for(;_<this.g.length&&Z(this.g[_]);)_++;const pe=_===this.c?null:this.g.slice(this.c,_);return this.c=_,pe}takeFromEndWhile(Z){let _=this.d;for(;_>=0&&Z(this.g[_]);)_--;const pe=_===this.d?null:this.g.slice(_+1,this.d+1);return this.d=_,pe}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const Z=this.g[this.c];return this.c++,Z}removeLast(){const Z=this.g[this.d];return this.d--,Z}takeCount(Z){const _=this.g.slice(this.c,this.c+Z);return this.c+=Z,_}}e.$0b=J;class ee{constructor(Z){this.iterate=Z}forEach(Z){this.iterate(_=>(Z(_),!0))}toArray(){const Z=[];return this.iterate(_=>(Z.push(_),!0)),Z}filter(Z){return new ee(_=>this.iterate(pe=>Z(pe)?_(pe):!0))}map(Z){return new ee(_=>this.iterate(pe=>_(Z(pe))))}some(Z){let _=!1;return this.iterate(pe=>(_=Z(pe),!_)),_}findFirst(Z){let _;return this.iterate(pe=>Z(pe)?(_=pe,!1):!0),_}findLast(Z){let _;return this.iterate(pe=>(Z(pe)&&(_=pe),!0)),_}findLastMaxBy(Z){let _,pe=!0;return this.iterate(se=>((pe||te.isGreaterThan(Z(se,_)))&&(pe=!1,_=se),!0)),_}}e.$$b=ee,ee.empty=new ee(Y=>{})}),define(Se[57],De([1,0,8]),function(ne,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5c=e.$4c=e.$3c=e.$2c=e.ok=void 0;function M(k,$){if(!k)throw new Error($?`Assertion failed (${$})`:"Assertion Failed")}e.ok=M;function l(k,$="Unreachable"){throw new Error($)}e.$2c=l;function R(k){if(!k)throw new y.$ab("Assertion Failed")}e.$3c=R;function A(k){if(!k()){debugger;k(),(0,y.$Y)(new y.$ab("Assertion Failed"))}}e.$4c=A;function m(k,$){let P=0;for(;P<k.length-1;){const C=k[P],v=k[P+1];if(!$(C,v))return!1;P++}return!0}e.$5c=m}),define(Se[75],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bb=void 0;function y(M){const l=this;let R=!1,A;return function(){return R||(R=!0,A=M.apply(l,arguments)),A}}e.$bb=y}),define(Se[120],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dM=e.$cM=void 0;class y{constructor(l){this.a=l,this.b=0}nextId(){return this.a+ ++this.b}}e.$cM=y,e.$dM=new y("id#")}),define(Se[50],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var y;(function(M){function l(d){return d&&typeof d=="object"&&typeof d[Symbol.iterator]=="function"}M.is=l;const R=Object.freeze([]);function A(){return R}M.empty=A;function*m(d){yield d}M.single=m;function k(d){return l(d)?d:m(d)}M.wrap=k;function $(d){return d||R}M.from=$;function*P(d){for(let t=d.length-1;t>=0;t--)yield d[t]}M.reverse=P;function C(d){return!d||d[Symbol.iterator]().next().done===!0}M.isEmpty=C;function v(d){return d[Symbol.iterator]().next().value}M.first=v;function S(d,t){for(const n of d)if(t(n))return!0;return!1}M.some=S;function D(d,t){for(const n of d)if(t(n))return n}M.find=D;function*E(d,t){for(const n of d)t(n)&&(yield n)}M.filter=E;function*s(d,t){let n=0;for(const r of d)yield t(r,n++)}M.map=s;function*c(...d){for(const t of d)for(const n of t)yield n}M.concat=c;function u(d,t,n){let r=n;for(const i of d)r=t(r,i);return r}M.reduce=u;function*o(d,t,n=d.length){for(t<0&&(t+=d.length),n<0?n+=d.length:n>d.length&&(n=d.length);t<n;t++)yield d[t]}M.slice=o;function g(d,t=Number.POSITIVE_INFINITY){const n=[];if(t===0)return[n,d];const r=d[Symbol.iterator]();for(let i=0;i<t;i++){const a=r.next();if(a.done)return[n,M.empty()];n.push(a.value)}return[n,{[Symbol.iterator](){return r}}]}M.consume=g})(y||(e.Iterable=y={}))}),define(Se[158],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wm=e.$Vm=e.$Um=e.$Tm=e.$Sm=e.$Rm=e.$Qm=e.$Pm=e.$Om=e.$Nm=e.$Mm=e.$Lm=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var y;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(y||(e.ScanError=y={}));var M;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(M||(e.SyntaxKind=M={}));var l;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(l||(e.ParseErrorCode=l={}));var R;(function(t){t.DEFAULT={allowTrailingComma:!0}})(R||(e.ParseOptions=R={}));function A(t,n=!1){let r=0;const i=t.length;let a="",h=0,p=16,I=0;function w(U){let N=0,j=0;for(;N<U;){const z=t.charCodeAt(r);if(z>=48&&z<=57)j=j*16+z-48;else if(z>=65&&z<=70)j=j*16+z-65+10;else if(z>=97&&z<=102)j=j*16+z-97+10;else break;r++,N++}return N<U&&(j=-1),j}function f(U){r=U,a="",h=0,p=16,I=0}function b(){const U=r;if(t.charCodeAt(r)===48)r++;else for(r++;r<t.length&&$(t.charCodeAt(r));)r++;if(r<t.length&&t.charCodeAt(r)===46)if(r++,r<t.length&&$(t.charCodeAt(r)))for(r++;r<t.length&&$(t.charCodeAt(r));)r++;else return I=3,t.substring(U,r);let N=r;if(r<t.length&&(t.charCodeAt(r)===69||t.charCodeAt(r)===101))if(r++,(r<t.length&&t.charCodeAt(r)===43||t.charCodeAt(r)===45)&&r++,r<t.length&&$(t.charCodeAt(r))){for(r++;r<t.length&&$(t.charCodeAt(r));)r++;N=r}else I=3;return t.substring(U,N)}function L(){let U="",N=r;for(;;){if(r>=i){U+=t.substring(N,r),I=2;break}const j=t.charCodeAt(r);if(j===34){U+=t.substring(N,r),r++;break}if(j===92){if(U+=t.substring(N,r),r++,r>=i){I=2;break}switch(t.charCodeAt(r++)){case 34:U+='"';break;case 92:U+="\\";break;case 47:U+="/";break;case 98:U+="\b";break;case 102:U+="\f";break;case 110:U+=`
`;break;case 114:U+="\r";break;case 116:U+="	";break;case 117:{const B=w(4);B>=0?U+=String.fromCharCode(B):I=4;break}default:I=5}N=r;continue}if(j>=0&&j<=31)if(k(j)){U+=t.substring(N,r),I=2;break}else I=6;r++}return U}function O(){if(a="",I=0,h=r,r>=i)return h=i,p=17;let U=t.charCodeAt(r);if(m(U)){do r++,a+=String.fromCharCode(U),U=t.charCodeAt(r);while(m(U));return p=15}if(k(U))return r++,a+=String.fromCharCode(U),U===13&&t.charCodeAt(r)===10&&(r++,a+=`
`),p=14;switch(U){case 123:return r++,p=1;case 125:return r++,p=2;case 91:return r++,p=3;case 93:return r++,p=4;case 58:return r++,p=6;case 44:return r++,p=5;case 34:return r++,a=L(),p=10;case 47:{const N=r-1;if(t.charCodeAt(r+1)===47){for(r+=2;r<i&&!k(t.charCodeAt(r));)r++;return a=t.substring(N,r),p=12}if(t.charCodeAt(r+1)===42){r+=2;const j=i-1;let z=!1;for(;r<j;){if(t.charCodeAt(r)===42&&t.charCodeAt(r+1)===47){r+=2,z=!0;break}r++}return z||(r++,I=1),a=t.substring(N,r),p=13}return a+=String.fromCharCode(U),r++,p=16}case 45:if(a+=String.fromCharCode(U),r++,r===i||!$(t.charCodeAt(r)))return p=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return a+=b(),p=11;default:for(;r<i&&T(U);)r++,U=t.charCodeAt(r);if(h!==r){switch(a=t.substring(h,r),a){case"true":return p=8;case"false":return p=9;case"null":return p=7}return p=16}return a+=String.fromCharCode(U),r++,p=16}}function T(U){if(m(U)||k(U))return!1;switch(U){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function F(){let U;do U=O();while(U>=12&&U<=15);return U}return{setPosition:f,getPosition:()=>r,scan:n?F:O,getToken:()=>p,getTokenValue:()=>a,getTokenOffset:()=>h,getTokenLength:()=>r-h,getTokenError:()=>I}}e.$Lm=A;function m(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function k(t){return t===10||t===13||t===8232||t===8233}function $(t){return t>=48&&t<=57}var P;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(P||(P={}));function C(t,n){const r=[],i=new Object;let a;const h={value:{},offset:0,length:0,type:"object",parent:void 0};let p=!1;function I(w,f,b,L){h.value=w,h.offset=f,h.length=b,h.type=L,h.colonOffset=void 0,a=h}try{o(t,{onObjectBegin:(w,f)=>{if(n<=w)throw i;a=void 0,p=n>w,r.push("")},onObjectProperty:(w,f,b)=>{if(n<f||(I(w,f,b,"property"),r[r.length-1]=w,n<=f+b))throw i},onObjectEnd:(w,f)=>{if(n<=w)throw i;a=void 0,r.pop()},onArrayBegin:(w,f)=>{if(n<=w)throw i;a=void 0,r.push(0)},onArrayEnd:(w,f)=>{if(n<=w)throw i;a=void 0,r.pop()},onLiteralValue:(w,f,b)=>{if(n<f||(I(w,f,b,d(w)),n<=f+b))throw i},onSeparator:(w,f,b)=>{if(n<=f)throw i;if(w===":"&&a&&a.type==="property")a.colonOffset=f,p=!1,a=void 0;else if(w===","){const L=r[r.length-1];typeof L=="number"?r[r.length-1]=L+1:(p=!0,r[r.length-1]=""),a=void 0}}})}catch(w){if(w!==i)throw w}return{path:r,previousNode:a,isAtPropertyKey:p,matches:w=>{let f=0;for(let b=0;f<w.length&&b<r.length;b++)if(w[f]===r[b]||w[f]==="*")f++;else if(w[f]!=="**")return!1;return f===w.length}}}e.$Mm=C;function v(t,n=[],r=R.DEFAULT){let i=null,a=[];const h=[];function p(w){Array.isArray(a)?a.push(w):i!==null&&(a[i]=w)}return o(t,{onObjectBegin:()=>{const w={};p(w),h.push(a),a=w,i=null},onObjectProperty:w=>{i=w},onObjectEnd:()=>{a=h.pop()},onArrayBegin:()=>{const w=[];p(w),h.push(a),a=w,i=null},onArrayEnd:()=>{a=h.pop()},onLiteralValue:p,onError:(w,f,b)=>{n.push({error:w,offset:f,length:b})}},r),a[0]}e.$Nm=v;function S(t,n=[],r=R.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function a(w){i.type==="property"&&(i.length=w-i.offset,i=i.parent)}function h(w){return i.children.push(w),w}o(t,{onObjectBegin:w=>{i=h({type:"object",offset:w,length:-1,parent:i,children:[]})},onObjectProperty:(w,f,b)=>{i=h({type:"property",offset:f,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:w,offset:f,length:b,parent:i})},onObjectEnd:(w,f)=>{i.length=w+f-i.offset,i=i.parent,a(w+f)},onArrayBegin:(w,f)=>{i=h({type:"array",offset:w,length:-1,parent:i,children:[]})},onArrayEnd:(w,f)=>{i.length=w+f-i.offset,i=i.parent,a(w+f)},onLiteralValue:(w,f,b)=>{h({type:d(w),offset:f,length:b,parent:i,value:w}),a(f+b)},onSeparator:(w,f,b)=>{i.type==="property"&&(w===":"?i.colonOffset=f:w===","&&a(f))},onError:(w,f,b)=>{n.push({error:w,offset:f,length:b})}},r);const I=i.children[0];return I&&delete I.parent,I}e.$Om=S;function D(t,n){if(!t)return;let r=t;for(const i of n)if(typeof i=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let a=!1;for(const h of r.children)if(Array.isArray(h.children)&&h.children[0].value===i){r=h.children[1],a=!0;break}if(!a)return}else{const a=i;if(r.type!=="array"||a<0||!Array.isArray(r.children)||a>=r.children.length)return;r=r.children[a]}return r}e.$Pm=D;function E(t){if(!t.parent||!t.parent.children)return[];const n=E(t.parent);if(t.parent.type==="property"){const r=t.parent.children[0].value;n.push(r)}else if(t.parent.type==="array"){const r=t.parent.children.indexOf(t);r!==-1&&n.push(r)}return n}e.$Qm=E;function s(t){switch(t.type){case"array":return t.children.map(s);case"object":{const n=Object.create(null);for(const r of t.children){const i=r.children[1];i&&(n[r.children[0].value]=s(i))}return n}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.$Rm=s;function c(t,n,r=!1){return n>=t.offset&&n<t.offset+t.length||r&&n===t.offset+t.length}e.$Sm=c;function u(t,n,r=!1){if(c(t,n,r)){const i=t.children;if(Array.isArray(i))for(let a=0;a<i.length&&i[a].offset<=n;a++){const h=u(i[a],n,r);if(h)return h}return t}}e.$Tm=u;function o(t,n,r=R.DEFAULT){const i=A(t,!1);function a(me){return me?()=>me(i.getTokenOffset(),i.getTokenLength()):()=>!0}function h(me){return me?le=>me(le,i.getTokenOffset(),i.getTokenLength()):()=>!0}const p=a(n.onObjectBegin),I=h(n.onObjectProperty),w=a(n.onObjectEnd),f=a(n.onArrayBegin),b=a(n.onArrayEnd),L=h(n.onLiteralValue),O=h(n.onSeparator),T=a(n.onComment),F=h(n.onError),U=r&&r.disallowComments,N=r&&r.allowTrailingComma;function j(){for(;;){const me=i.scan();switch(i.getTokenError()){case 4:z(14);break;case 5:z(15);break;case 3:z(13);break;case 1:U||z(11);break;case 2:z(12);break;case 6:z(16);break}switch(me){case 12:case 13:U?z(10):T();break;case 16:z(1);break;case 15:case 14:break;default:return me}}}function z(me,le=[],ye=[]){if(F(me),le.length+ye.length>0){let de=i.getToken();for(;de!==17;){if(le.indexOf(de)!==-1){j();break}else if(ye.indexOf(de)!==-1)break;de=j()}}}function B(me){const le=i.getTokenValue();return me?L(le):I(le),j(),!0}function ae(){switch(i.getToken()){case 11:{let me=0;try{me=JSON.parse(i.getTokenValue()),typeof me!="number"&&(z(2),me=0)}catch{z(2)}L(me);break}case 7:L(null);break;case 8:L(!0);break;case 9:L(!1);break;default:return!1}return j(),!0}function X(){return i.getToken()!==10?(z(3,[],[2,5]),!1):(B(!1),i.getToken()===6?(O(":"),j(),te()||z(4,[],[2,5])):z(5,[],[2,5]),!0)}function Q(){p(),j();let me=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(me||z(4,[],[]),O(","),j(),i.getToken()===2&&N)break}else me&&z(6,[],[]);X()||z(4,[],[2,5]),me=!0}return w(),i.getToken()!==2?z(7,[2],[]):j(),!0}function H(){f(),j();let me=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(me||z(4,[],[]),O(","),j(),i.getToken()===4&&N)break}else me&&z(6,[],[]);te()||z(4,[],[4,5]),me=!0}return b(),i.getToken()!==4?z(8,[4],[]):j(),!0}function te(){switch(i.getToken()){case 3:return H();case 1:return Q();case 10:return B(!0);default:return ae()}}return j(),i.getToken()===17?r.allowEmptyContent?!0:(z(4,[],[]),!1):te()?(i.getToken()!==17&&z(9,[],[]),!0):(z(4,[],[]),!1)}e.$Um=o;function g(t,n){const r=A(t),i=[];let a,h=0,p;do switch(p=r.getPosition(),a=r.scan(),a){case 12:case 13:case 17:h!==p&&i.push(t.substring(h,p)),n!==void 0&&i.push(r.getTokenValue().replace(/[^\r\n]/g,n)),h=r.getPosition();break}while(a!==17);return i.join("")}e.$Vm=g;function d(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.$Wm=d}),define(Se[58],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T=void 0;class y{constructor(l){this.d=l,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(l){this.c=l}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$T=y}),define(Se[76],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zc=void 0;class y{constructor(R){this.element=R,this.next=y.Undefined,this.prev=y.Undefined}}y.Undefined=new y(void 0);class M{constructor(){this.a=y.Undefined,this.b=y.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===y.Undefined}clear(){let R=this.a;for(;R!==y.Undefined;){const A=R.next;R.prev=y.Undefined,R.next=y.Undefined,R=A}this.a=y.Undefined,this.b=y.Undefined,this.c=0}unshift(R){return this.d(R,!1)}push(R){return this.d(R,!0)}d(R,A){const m=new y(R);if(this.a===y.Undefined)this.a=m,this.b=m;else if(A){const $=this.b;this.b=m,m.prev=$,$.next=m}else{const $=this.a;this.a=m,m.next=$,$.prev=m}this.c+=1;let k=!1;return()=>{k||(k=!0,this.e(m))}}shift(){if(this.a!==y.Undefined){const R=this.a.element;return this.e(this.a),R}}pop(){if(this.b!==y.Undefined){const R=this.b.element;return this.e(this.b),R}}e(R){if(R.prev!==y.Undefined&&R.next!==y.Undefined){const A=R.prev;A.next=R.next,R.next.prev=A}else R.prev===y.Undefined&&R.next===y.Undefined?(this.a=y.Undefined,this.b=y.Undefined):R.next===y.Undefined?(this.b=this.b.prev,this.b.next=y.Undefined):R.prev===y.Undefined&&(this.a=this.a.next,this.a.prev=y.Undefined);this.c-=1}*[Symbol.iterator](){let R=this.a;for(;R!==y.Undefined;)yield R.element,R=R.next}}e.$Zc=M}),define(Se[28],De([1,0]),function(ne,e){"use strict";var y,M,l;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ec=e.$Dc=e.$Cc=e.$Bc=e.$Ac=e.Touch=e.$zc=e.$yc=e.$xc=e.$wc=e.$vc=void 0;function R(u,o,g){let d=u.get(o);return d===void 0&&(d=g,u.set(o,d)),d}e.$vc=R;function A(u){const o=[];return u.forEach((g,d)=>{o.push(`${d} => ${g}`)}),`Map(${u.size}) {${o.join(", ")}}`}e.$wc=A;function m(u){const o=[];return u.forEach(g=>{o.push(g)}),`Set(${u.size}) {${o.join(", ")}}`}e.$xc=m;class k{constructor(o,g){this.uri=o,this.value=g}}function $(u){return Array.isArray(u)}class P{constructor(o,g){if(this[y]="ResourceMap",o instanceof P)this.b=new Map(o.b),this.c=g??P.a;else if($(o)){this.b=new Map,this.c=g??P.a;for(const[d,t]of o)this.set(d,t)}else this.b=new Map,this.c=o??P.a}set(o,g){return this.b.set(this.c(o),new k(o,g)),this}get(o){return this.b.get(this.c(o))?.value}has(o){return this.b.has(this.c(o))}get size(){return this.b.size}clear(){this.b.clear()}delete(o){return this.b.delete(this.c(o))}forEach(o,g){typeof g<"u"&&(o=o.bind(g));for(const[d,t]of this.b)o(t.value,t.uri,this)}*values(){for(const o of this.b.values())yield o.value}*keys(){for(const o of this.b.values())yield o.uri}*entries(){for(const o of this.b.values())yield[o.uri,o.value]}*[(y=Symbol.toStringTag,Symbol.iterator)](){for(const[,o]of this.b)yield[o.uri,o.value]}}e.$yc=P,P.a=u=>u.toString();class C{constructor(o,g){this[M]="ResourceSet",!o||typeof o=="function"?this.a=new P(o):(this.a=new P(g),o.forEach(this.add,this))}get size(){return this.a.size}add(o){return this.a.set(o,o),this}clear(){this.a.clear()}delete(o){return this.a.delete(o)}forEach(o,g){this.a.forEach((d,t)=>o.call(g,t,t,this))}has(o){return this.a.has(o)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(M=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$zc=C;var v;(function(u){u[u.None=0]="None",u[u.AsOld=1]="AsOld",u[u.AsNew=2]="AsNew"})(v||(e.Touch=v={}));class S{constructor(){this[l]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(o){return this.a.has(o)}get(o,g=0){const d=this.a.get(o);if(d)return g!==0&&this.j(d,g),d.value}set(o,g,d=0){let t=this.a.get(o);if(t)t.value=g,d!==0&&this.j(t,d);else{switch(t={key:o,value:g,next:void 0,previous:void 0},d){case 0:this.h(t);break;case 1:this.g(t);break;case 2:this.h(t);break;default:this.h(t);break}this.a.set(o,t),this.d++}return this}delete(o){return!!this.remove(o)}remove(o){const g=this.a.get(o);if(g)return this.a.delete(o),this.i(g),this.d--,g.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const o=this.b;return this.a.delete(o.key),this.i(o),this.d--,o.value}forEach(o,g){const d=this.e;let t=this.b;for(;t;){if(g?o.bind(g)(t.value,t.key,this):o(t.value,t.key,this),this.e!==d)throw new Error("LinkedMap got modified during iteration.");t=t.next}}keys(){const o=this,g=this.e;let d=this.b;const t={[Symbol.iterator](){return t},next(){if(o.e!==g)throw new Error("LinkedMap got modified during iteration.");if(d){const n={value:d.key,done:!1};return d=d.next,n}else return{value:void 0,done:!0}}};return t}values(){const o=this,g=this.e;let d=this.b;const t={[Symbol.iterator](){return t},next(){if(o.e!==g)throw new Error("LinkedMap got modified during iteration.");if(d){const n={value:d.value,done:!1};return d=d.next,n}else return{value:void 0,done:!0}}};return t}entries(){const o=this,g=this.e;let d=this.b;const t={[Symbol.iterator](){return t},next(){if(o.e!==g)throw new Error("LinkedMap got modified during iteration.");if(d){const n={value:[d.key,d.value],done:!1};return d=d.next,n}else return{value:void 0,done:!0}}};return t}[(l=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(o){if(o>=this.size)return;if(o===0){this.clear();return}let g=this.b,d=this.size;for(;g&&d>o;)this.a.delete(g.key),g=g.next,d--;this.b=g,this.d=d,g&&(g.previous=void 0),this.e++}g(o){if(!this.b&&!this.c)this.c=o;else if(this.b)o.next=this.b,this.b.previous=o;else throw new Error("Invalid list");this.b=o,this.e++}h(o){if(!this.b&&!this.c)this.b=o;else if(this.c)o.previous=this.c,this.c.next=o;else throw new Error("Invalid list");this.c=o,this.e++}i(o){if(o===this.b&&o===this.c)this.b=void 0,this.c=void 0;else if(o===this.b){if(!o.next)throw new Error("Invalid list");o.next.previous=void 0,this.b=o.next}else if(o===this.c){if(!o.previous)throw new Error("Invalid list");o.previous.next=void 0,this.c=o.previous}else{const g=o.next,d=o.previous;if(!g||!d)throw new Error("Invalid list");g.previous=d,d.next=g}o.next=void 0,o.previous=void 0,this.e++}j(o,g){if(!this.b||!this.c)throw new Error("Invalid list");if(!(g!==1&&g!==2)){if(g===1){if(o===this.b)return;const d=o.next,t=o.previous;o===this.c?(t.next=void 0,this.c=t):(d.previous=t,t.next=d),o.previous=void 0,o.next=this.b,this.b.previous=o,this.b=o,this.e++}else if(g===2){if(o===this.c)return;const d=o.next,t=o.previous;o===this.b?(d.previous=void 0,this.b=d):(d.previous=t,t.next=d),o.next=void 0,o.previous=this.c,this.c.next=o,this.c=o,this.e++}}}toJSON(){const o=[];return this.forEach((g,d)=>{o.push([d,g])}),o}fromJSON(o){this.clear();for(const[g,d]of o)this.set(g,d)}}e.$Ac=S;class D extends S{constructor(o,g=1){super(),this.k=o,this.l=Math.min(Math.max(0,g),1)}get limit(){return this.k}set limit(o){this.k=o,this.m()}get ratio(){return this.l}set ratio(o){this.l=Math.min(Math.max(0,o),1),this.m()}get(o,g=2){return super.get(o,g)}peek(o){return super.get(o,0)}set(o,g){return super.set(o,g,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.$Bc=D;class E{constructor(){this.a=new Map}add(o){return this.a.set(o,(this.a.get(o)||0)+1),this}delete(o){let g=this.a.get(o)||0;return g===0?!1:(g--,g===0?this.a.delete(o):this.a.set(o,g),!0)}has(o){return this.a.has(o)}}e.$Cc=E;class s{constructor(o){if(this.a=new Map,this.b=new Map,o)for(const[g,d]of o)this.set(g,d)}clear(){this.a.clear(),this.b.clear()}set(o,g){this.a.set(o,g),this.b.set(g,o)}get(o){return this.a.get(o)}getKey(o){return this.b.get(o)}delete(o){const g=this.a.get(o);return g===void 0?!1:(this.a.delete(o),this.b.delete(g),!0)}forEach(o,g){this.a.forEach((d,t)=>{o.call(g,d,t,this)})}keys(){return this.a.keys()}values(){return this.a.values()}}e.$Dc=s;class c{constructor(){this.a=new Map}add(o,g){let d=this.a.get(o);d||(d=new Set,this.a.set(o,d)),d.add(g)}delete(o,g){const d=this.a.get(o);d&&(d.delete(g),d.size===0&&this.a.delete(o))}forEach(o,g){const d=this.a.get(o);d&&d.forEach(g)}get(o){const g=this.a.get(o);return g||new Set}}e.$Ec=c}),define(Se[3],De([1,0,19,74,28,75,50]),function(ne,e,y,M,l,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Rc=e.$Qc=e.$Pc=e.$Oc=e.$Nc=e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=e.$Hc=e.$Gc=e.$Fc=void 0;const m=!1;let k=null;class ${constructor(){this.b=new Map}c(b){let L=this.b.get(b);return L||(L={parent:null,source:null,isSingleton:!1,value:b,idx:$.a++},this.b.set(b,L)),L}trackDisposable(b){const L=this.c(b);L.source||(L.source=new Error().stack)}setParent(b,L){const O=this.c(b);O.parent=L}markAsDisposed(b){this.b.delete(b)}markAsSingleton(b){this.c(b).isSingleton=!0}f(b,L){const O=L.get(b);if(O)return O;const T=b.parent?this.f(this.c(b.parent),L):b;return L.set(b,T),T}getTrackedDisposables(){const b=new Map;return[...this.b.entries()].filter(([,O])=>O.source!==null&&!this.f(O,b).isSingleton).map(([O])=>O).flat()}computeLeakingDisposables(b=10,L){let O;if(L)O=L;else{const j=new Map,z=[...this.b.values()].filter(ae=>ae.source!==null&&!this.f(ae,j).isSingleton);if(z.length===0)return;const B=new Set(z.map(ae=>ae.value));if(O=z.filter(ae=>!(ae.parent&&B.has(ae.parent))),O.length===0)throw new Error("There are cyclic diposable chains!")}if(!O)return;function T(j){function z(ae,X){for(;ae.length>0&&X.some(Q=>typeof Q=="string"?Q===ae[0]:ae[0].match(Q));)ae.shift()}const B=j.source.split(`
`).map(ae=>ae.trim().replace("at ","")).filter(ae=>ae!=="");return z(B,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),B.reverse()}const F=new l.$Ec;for(const j of O){const z=T(j);for(let B=0;B<=z.length;B++)F.add(z.slice(0,B).join(`
`),j)}O.sort((0,y.$5b)(j=>j.idx,y.$7b));let U="",N=0;for(const j of O.slice(0,b)){N++;const z=T(j),B=[];for(let ae=0;ae<z.length;ae++){let X=z[ae];X=`(shared with ${F.get(z.slice(0,ae+1).join(`
`)).size}/${O.length} leaks) at ${X}`;const H=F.get(z.slice(0,ae).join(`
`)),te=(0,M.$D)([...H].map(me=>T(me)[ae]),me=>me);delete te[z[ae]];for(const[me,le]of Object.entries(te))B.unshift(`    - stacktraces of ${le.length} other leaks continue with ${me}`);B.unshift(X)}U+=`


==================== Leaking disposable ${N}/${O.length}: ${j.value.constructor.name} ====================
${B.join(`
`)}
============================================================

`}return O.length>b&&(U+=`


... and ${O.length-b} more leaking disposables

`),{leaks:O,details:U}}}e.$Fc=$,$.a=0;function P(f){k=f}if(e.$Gc=P,m){const f="__is_disposable_tracked__";P(new class{trackDisposable(b){const L=new Error("Potentially leaked disposable").stack;setTimeout(()=>{b[f]||console.log(L)},3e3)}setParent(b,L){if(b&&b!==t.None)try{b[f]=!0}catch{}}markAsDisposed(b){if(b&&b!==t.None)try{b[f]=!0}catch{}}markAsSingleton(b){}})}function C(f){return k?.trackDisposable(f),f}e.$Hc=C;function v(f){k?.markAsDisposed(f)}e.$Ic=v;function S(f,b){k?.setParent(f,b)}function D(f,b){if(k)for(const L of f)k.setParent(L,b)}function E(f){return k?.markAsSingleton(f),f}e.$Jc=E;function s(f){return typeof f.dispose=="function"&&f.dispose.length===0}e.$Kc=s;function c(f){if(A.Iterable.is(f)){const b=[];for(const L of f)if(L)try{L.dispose()}catch(O){b.push(O)}if(b.length===1)throw b[0];if(b.length>1)throw new AggregateError(b,"Encountered errors while disposing of store");return Array.isArray(f)?[]:f}else if(f)return f.dispose(),f}e.$Lc=c;function u(f){for(const b of f)s(b)&&b.dispose();return[]}e.$Mc=u;function o(...f){const b=g(()=>c(f));return D(f,b),b}e.$Nc=o;function g(f){const b=C({dispose:(0,R.$bb)(()=>{v(b),f()})});return b}e.$Oc=g;class d{constructor(){this.f=new Set,this.g=!1,C(this)}dispose(){this.g||(v(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{c(this.f)}finally{this.f.clear()}}add(b){if(!b)return b;if(b===this)throw new Error("Cannot register a disposable on itself!");return S(b,this),this.g?d.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(b),b}delete(b){if(b){if(b===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(b),b.dispose()}}deleteAndLeak(b){b&&this.f.has(b)&&(this.f.delete(b),S(b,null))}}e.$Pc=d,d.DISABLE_DISPOSED_WARNING=!1;class t{constructor(){this.q=new d,C(this),S(this.q,this)}dispose(){v(this),this.q.dispose()}B(b){if(b===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(b)}}e.$Qc=t,t.None=Object.freeze({dispose(){}});class n{constructor(){this.b=!1,C(this)}get value(){return this.b?void 0:this.a}set value(b){this.b||b===this.a||(this.a?.dispose(),b&&S(b,this),this.a=b)}clear(){this.value=void 0}dispose(){this.b=!0,v(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const b=this.a;return this.a=void 0,b&&S(b,null),b}}e.$Rc=n;class r{constructor(b){this.b=b,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Sc=r;class i{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,C(this)}set(b){let L=b;return this.unset=()=>L=void 0,this.isset=()=>L!==void 0,this.dispose=()=>{L&&(L(),L=void 0,v(this))},this}}e.$Tc=i;class a{constructor(){this.a=new Map}acquire(b,...L){let O=this.a.get(b);O||(O={counter:0,object:this.b(b,...L)},this.a.set(b,O));const{object:T}=O,F=(0,R.$bb)(()=>{--O.counter===0&&(this.c(b,O.object),this.a.delete(b))});return O.counter++,{object:T,dispose:F}}}e.$Uc=a;class h{constructor(b){this.a=b}async acquire(b,...L){const O=this.a.acquire(b,...L);try{return{object:await O.object,dispose:()=>O.dispose()}}catch(T){throw O.dispose(),T}}}e.$Vc=h;class p{constructor(b){this.object=b}dispose(){}}e.$Wc=p;function I(f){const b=new d;try{f(b)}finally{b.dispose()}}e.$Xc=I;class w{constructor(){this.a=new Map,this.b=!1,C(this)}dispose(){v(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{c(this.a.values())}finally{this.a.clear()}}has(b){return this.a.has(b)}get size(){return this.a.size}get(b){return this.a.get(b)}set(b,L,O=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),O||this.a.get(b)?.dispose(),this.a.set(b,L)}deleteAndDispose(b){this.a.get(b)?.dispose(),this.a.delete(b)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$Yc=w}),function(ne,e){typeof define=="function"&&define.amd?define(Se[159],De([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(ne=typeof globalThis<"u"?globalThis:ne||self,e(ne.marked={}))}(this,function(ne){"use strict";function e(Z,_){for(var pe=0;pe<_.length;pe++){var se=_[pe];se.enumerable=se.enumerable||!1,se.configurable=!0,"value"in se&&(se.writable=!0),Object.defineProperty(Z,se.key,se)}}function y(Z,_,pe){return _&&e(Z.prototype,_),pe&&e(Z,pe),Object.defineProperty(Z,"prototype",{writable:!1}),Z}function M(Z,_){if(Z){if(typeof Z=="string")return l(Z,_);var pe=Object.prototype.toString.call(Z).slice(8,-1);if(pe==="Object"&&Z.constructor&&(pe=Z.constructor.name),pe==="Map"||pe==="Set")return Array.from(Z);if(pe==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(pe))return l(Z,_)}}function l(Z,_){(_==null||_>Z.length)&&(_=Z.length);for(var pe=0,se=new Array(_);pe<_;pe++)se[pe]=Z[pe];return se}function R(Z,_){var pe=typeof Symbol<"u"&&Z[Symbol.iterator]||Z["@@iterator"];if(pe)return(pe=pe.call(Z)).next.bind(pe);if(Array.isArray(Z)||(pe=M(Z))||_&&Z&&typeof Z.length=="number"){pe&&(Z=pe);var se=0;return function(){return se>=Z.length?{done:!0}:{done:!1,value:Z[se++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function A(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ne.defaults=A();function m(Z){ne.defaults=Z}var k=/[&<>"']/,$=/[&<>"']/g,P=/[<>"']|&(?!#?\w+;)/,C=/[<>"']|&(?!#?\w+;)/g,v={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},S=function(_){return v[_]};function D(Z,_){if(_){if(k.test(Z))return Z.replace($,S)}else if(P.test(Z))return Z.replace(C,S);return Z}var E=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function s(Z){return Z.replace(E,function(_,pe){return pe=pe.toLowerCase(),pe==="colon"?":":pe.charAt(0)==="#"?pe.charAt(1)==="x"?String.fromCharCode(parseInt(pe.substring(2),16)):String.fromCharCode(+pe.substring(1)):""})}var c=/(^|[^\[])\^/g;function u(Z,_){Z=typeof Z=="string"?Z:Z.source,_=_||"";var pe={replace:function(ge,ie){return ie=ie.source||ie,ie=ie.replace(c,"$1"),Z=Z.replace(ge,ie),pe},getRegex:function(){return new RegExp(Z,_)}};return pe}var o=/[^\w:]/g,g=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function d(Z,_,pe){if(Z){var se;try{se=decodeURIComponent(s(pe)).replace(o,"").toLowerCase()}catch{return null}if(se.indexOf("javascript:")===0||se.indexOf("vbscript:")===0||se.indexOf("data:")===0)return null}_&&!g.test(pe)&&(pe=a(_,pe));try{pe=encodeURI(pe).replace(/%25/g,"%")}catch{return null}return pe}var t={},n=/^[^:]+:\/*[^/]*$/,r=/^([^:]+:)[\s\S]*$/,i=/^([^:]+:\/*[^/]*)[\s\S]*$/;function a(Z,_){t[" "+Z]||(n.test(Z)?t[" "+Z]=Z+"/":t[" "+Z]=w(Z,"/",!0)),Z=t[" "+Z];var pe=Z.indexOf(":")===-1;return _.substring(0,2)==="//"?pe?_:Z.replace(r,"$1")+_:_.charAt(0)==="/"?pe?_:Z.replace(i,"$1")+_:Z+_}var h={exec:function(){}};function p(Z){for(var _=1,pe,se;_<arguments.length;_++){pe=arguments[_];for(se in pe)Object.prototype.hasOwnProperty.call(pe,se)&&(Z[se]=pe[se])}return Z}function I(Z,_){var pe=Z.replace(/\|/g,function(ie,fe,be){for(var Ie=!1,W=fe;--W>=0&&be[W]==="\\";)Ie=!Ie;return Ie?"|":" |"}),se=pe.split(/ \|/),ge=0;if(se[0].trim()||se.shift(),se.length>0&&!se[se.length-1].trim()&&se.pop(),se.length>_)se.splice(_);else for(;se.length<_;)se.push("");for(;ge<se.length;ge++)se[ge]=se[ge].trim().replace(/\\\|/g,"|");return se}function w(Z,_,pe){var se=Z.length;if(se===0)return"";for(var ge=0;ge<se;){var ie=Z.charAt(se-ge-1);if(ie===_&&!pe)ge++;else if(ie!==_&&pe)ge++;else break}return Z.slice(0,se-ge)}function f(Z,_){if(Z.indexOf(_[1])===-1)return-1;for(var pe=Z.length,se=0,ge=0;ge<pe;ge++)if(Z[ge]==="\\")ge++;else if(Z[ge]===_[0])se++;else if(Z[ge]===_[1]&&(se--,se<0))return ge;return-1}function b(Z){Z&&Z.sanitize&&!Z.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function L(Z,_){if(_<1)return"";for(var pe="";_>1;)_&1&&(pe+=Z),_>>=1,Z+=Z;return pe+Z}function O(Z,_,pe,se){var ge=_.href,ie=_.title?D(_.title):null,fe=Z[1].replace(/\\([\[\]])/g,"$1");if(Z[0].charAt(0)!=="!"){se.state.inLink=!0;var be={type:"link",raw:pe,href:ge,title:ie,text:fe,tokens:se.inlineTokens(fe)};return se.state.inLink=!1,be}return{type:"image",raw:pe,href:ge,title:ie,text:D(fe)}}function T(Z,_){var pe=Z.match(/^(\s+)(?:```)/);if(pe===null)return _;var se=pe[1];return _.split(`
`).map(function(ge){var ie=ge.match(/^\s+/);if(ie===null)return ge;var fe=ie[0];return fe.length>=se.length?ge.slice(se.length):ge}).join(`
`)}var F=function(){function Z(pe){this.options=pe||ne.defaults}var _=Z.prototype;return _.space=function(se){var ge=this.rules.block.newline.exec(se);if(ge&&ge[0].length>0)return{type:"space",raw:ge[0]}},_.code=function(se){var ge=this.rules.block.code.exec(se);if(ge){var ie=ge[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ge[0],codeBlockStyle:"indented",text:this.options.pedantic?ie:w(ie,`
`)}}},_.fences=function(se){var ge=this.rules.block.fences.exec(se);if(ge){var ie=ge[0],fe=T(ie,ge[3]||"");return{type:"code",raw:ie,lang:ge[2]?ge[2].trim():ge[2],text:fe}}},_.heading=function(se){var ge=this.rules.block.heading.exec(se);if(ge){var ie=ge[2].trim();if(/#$/.test(ie)){var fe=w(ie,"#");(this.options.pedantic||!fe||/ $/.test(fe))&&(ie=fe.trim())}return{type:"heading",raw:ge[0],depth:ge[1].length,text:ie,tokens:this.lexer.inline(ie)}}},_.hr=function(se){var ge=this.rules.block.hr.exec(se);if(ge)return{type:"hr",raw:ge[0]}},_.blockquote=function(se){var ge=this.rules.block.blockquote.exec(se);if(ge){var ie=ge[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:ge[0],tokens:this.lexer.blockTokens(ie,[]),text:ie}}},_.list=function(se){var ge=this.rules.block.list.exec(se);if(ge){var ie,fe,be,Ie,W,G,ce,he,x,$e,ve,Ne,Ve=ge[1].trim(),xe=Ve.length>1,Qe={type:"list",raw:"",ordered:xe,start:xe?+Ve.slice(0,-1):"",loose:!1,items:[]};Ve=xe?"\\d{1,9}\\"+Ve.slice(-1):"\\"+Ve,this.options.pedantic&&(Ve=xe?Ve:"[*+-]");for(var rt=new RegExp("^( {0,3}"+Ve+")((?:[	 ][^\\n]*)?(?:\\n|$))");se&&(Ne=!1,!(!(ge=rt.exec(se))||this.rules.block.hr.test(se)));){if(ie=ge[0],se=se.substring(ie.length),he=ge[2].split(`
`,1)[0],x=se.split(`
`,1)[0],this.options.pedantic?(Ie=2,ve=he.trimLeft()):(Ie=ge[2].search(/[^ ]/),Ie=Ie>4?1:Ie,ve=he.slice(Ie),Ie+=ge[1].length),G=!1,!he&&/^ *$/.test(x)&&(ie+=x+`
`,se=se.substring(x.length+1),Ne=!0),!Ne)for(var it=new RegExp("^ {0,"+Math.min(3,Ie-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),nt=new RegExp("^ {0,"+Math.min(3,Ie-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Ae=new RegExp("^ {0,"+Math.min(3,Ie-1)+"}(?:```|~~~)"),Fe=new RegExp("^ {0,"+Math.min(3,Ie-1)+"}#");se&&($e=se.split(`
`,1)[0],he=$e,this.options.pedantic&&(he=he.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Ae.test(he)||Fe.test(he)||it.test(he)||nt.test(se)));){if(he.search(/[^ ]/)>=Ie||!he.trim())ve+=`
`+he.slice(Ie);else if(!G)ve+=`
`+he;else break;!G&&!he.trim()&&(G=!0),ie+=$e+`
`,se=se.substring($e.length+1)}Qe.loose||(ce?Qe.loose=!0:/\n *\n *$/.test(ie)&&(ce=!0)),this.options.gfm&&(fe=/^\[[ xX]\] /.exec(ve),fe&&(be=fe[0]!=="[ ] ",ve=ve.replace(/^\[[ xX]\] +/,""))),Qe.items.push({type:"list_item",raw:ie,task:!!fe,checked:be,loose:!1,text:ve}),Qe.raw+=ie}Qe.items[Qe.items.length-1].raw=ie.trimRight(),Qe.items[Qe.items.length-1].text=ve.trimRight(),Qe.raw=Qe.raw.trimRight();var Le=Qe.items.length;for(W=0;W<Le;W++){this.lexer.state.top=!1,Qe.items[W].tokens=this.lexer.blockTokens(Qe.items[W].text,[]);var Je=Qe.items[W].tokens.filter(function(oe){return oe.type==="space"}),ue=Je.every(function(oe){for(var Ce=oe.raw.split(""),He=0,ze=R(Ce),Ze;!(Ze=ze()).done;){var st=Ze.value;if(st===`
`&&(He+=1),He>1)return!0}return!1});!Qe.loose&&Je.length&&ue&&(Qe.loose=!0,Qe.items[W].loose=!0)}return Qe}},_.html=function(se){var ge=this.rules.block.html.exec(se);if(ge){var ie={type:"html",raw:ge[0],pre:!this.options.sanitizer&&(ge[1]==="pre"||ge[1]==="script"||ge[1]==="style"),text:ge[0]};if(this.options.sanitize){var fe=this.options.sanitizer?this.options.sanitizer(ge[0]):D(ge[0]);ie.type="paragraph",ie.text=fe,ie.tokens=this.lexer.inline(fe)}return ie}},_.def=function(se){var ge=this.rules.block.def.exec(se);if(ge){ge[3]&&(ge[3]=ge[3].substring(1,ge[3].length-1));var ie=ge[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:ie,raw:ge[0],href:ge[2],title:ge[3]}}},_.table=function(se){var ge=this.rules.block.table.exec(se);if(ge){var ie={type:"table",header:I(ge[1]).map(function(ce){return{text:ce}}),align:ge[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ge[3]&&ge[3].trim()?ge[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(ie.header.length===ie.align.length){ie.raw=ge[0];var fe=ie.align.length,be,Ie,W,G;for(be=0;be<fe;be++)/^ *-+: *$/.test(ie.align[be])?ie.align[be]="right":/^ *:-+: *$/.test(ie.align[be])?ie.align[be]="center":/^ *:-+ *$/.test(ie.align[be])?ie.align[be]="left":ie.align[be]=null;for(fe=ie.rows.length,be=0;be<fe;be++)ie.rows[be]=I(ie.rows[be],ie.header.length).map(function(ce){return{text:ce}});for(fe=ie.header.length,Ie=0;Ie<fe;Ie++)ie.header[Ie].tokens=this.lexer.inline(ie.header[Ie].text);for(fe=ie.rows.length,Ie=0;Ie<fe;Ie++)for(G=ie.rows[Ie],W=0;W<G.length;W++)G[W].tokens=this.lexer.inline(G[W].text);return ie}}},_.lheading=function(se){var ge=this.rules.block.lheading.exec(se);if(ge)return{type:"heading",raw:ge[0],depth:ge[2].charAt(0)==="="?1:2,text:ge[1],tokens:this.lexer.inline(ge[1])}},_.paragraph=function(se){var ge=this.rules.block.paragraph.exec(se);if(ge){var ie=ge[1].charAt(ge[1].length-1)===`
`?ge[1].slice(0,-1):ge[1];return{type:"paragraph",raw:ge[0],text:ie,tokens:this.lexer.inline(ie)}}},_.text=function(se){var ge=this.rules.block.text.exec(se);if(ge)return{type:"text",raw:ge[0],text:ge[0],tokens:this.lexer.inline(ge[0])}},_.escape=function(se){var ge=this.rules.inline.escape.exec(se);if(ge)return{type:"escape",raw:ge[0],text:D(ge[1])}},_.tag=function(se){var ge=this.rules.inline.tag.exec(se);if(ge)return!this.lexer.state.inLink&&/^<a /i.test(ge[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ge[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ge[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ge[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ge[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ge[0]):D(ge[0]):ge[0]}},_.link=function(se){var ge=this.rules.inline.link.exec(se);if(ge){var ie=ge[2].trim();if(!this.options.pedantic&&/^</.test(ie)){if(!/>$/.test(ie))return;var fe=w(ie.slice(0,-1),"\\");if((ie.length-fe.length)%2===0)return}else{var be=f(ge[2],"()");if(be>-1){var Ie=ge[0].indexOf("!")===0?5:4,W=Ie+ge[1].length+be;ge[2]=ge[2].substring(0,be),ge[0]=ge[0].substring(0,W).trim(),ge[3]=""}}var G=ge[2],ce="";if(this.options.pedantic){var he=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(G);he&&(G=he[1],ce=he[3])}else ce=ge[3]?ge[3].slice(1,-1):"";return G=G.trim(),/^</.test(G)&&(this.options.pedantic&&!/>$/.test(ie)?G=G.slice(1):G=G.slice(1,-1)),O(ge,{href:G&&G.replace(this.rules.inline._escapes,"$1"),title:ce&&ce.replace(this.rules.inline._escapes,"$1")},ge[0],this.lexer)}},_.reflink=function(se,ge){var ie;if((ie=this.rules.inline.reflink.exec(se))||(ie=this.rules.inline.nolink.exec(se))){var fe=(ie[2]||ie[1]).replace(/\s+/g," ");if(fe=ge[fe.toLowerCase()],!fe||!fe.href){var be=ie[0].charAt(0);return{type:"text",raw:be,text:be}}return O(ie,fe,ie[0],this.lexer)}},_.emStrong=function(se,ge,ie){ie===void 0&&(ie="");var fe=this.rules.inline.emStrong.lDelim.exec(se);if(fe&&!(fe[3]&&ie.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var be=fe[1]||fe[2]||"";if(!be||be&&(ie===""||this.rules.inline.punctuation.exec(ie))){var Ie=fe[0].length-1,W,G,ce=Ie,he=0,x=fe[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(x.lastIndex=0,ge=ge.slice(-1*se.length+Ie);(fe=x.exec(ge))!=null;)if(W=fe[1]||fe[2]||fe[3]||fe[4]||fe[5]||fe[6],!!W){if(G=W.length,fe[3]||fe[4]){ce+=G;continue}else if((fe[5]||fe[6])&&Ie%3&&!((Ie+G)%3)){he+=G;continue}if(ce-=G,!(ce>0)){if(G=Math.min(G,G+ce+he),Math.min(Ie,G)%2){var $e=se.slice(1,Ie+fe.index+G);return{type:"em",raw:se.slice(0,Ie+fe.index+G+1),text:$e,tokens:this.lexer.inlineTokens($e)}}var ve=se.slice(2,Ie+fe.index+G-1);return{type:"strong",raw:se.slice(0,Ie+fe.index+G+1),text:ve,tokens:this.lexer.inlineTokens(ve)}}}}}},_.codespan=function(se){var ge=this.rules.inline.code.exec(se);if(ge){var ie=ge[2].replace(/\n/g," "),fe=/[^ ]/.test(ie),be=/^ /.test(ie)&&/ $/.test(ie);return fe&&be&&(ie=ie.substring(1,ie.length-1)),ie=D(ie,!0),{type:"codespan",raw:ge[0],text:ie}}},_.br=function(se){var ge=this.rules.inline.br.exec(se);if(ge)return{type:"br",raw:ge[0]}},_.del=function(se){var ge=this.rules.inline.del.exec(se);if(ge)return{type:"del",raw:ge[0],text:ge[2],tokens:this.lexer.inlineTokens(ge[2])}},_.autolink=function(se,ge){var ie=this.rules.inline.autolink.exec(se);if(ie){var fe,be;return ie[2]==="@"?(fe=D(this.options.mangle?ge(ie[1]):ie[1]),be="mailto:"+fe):(fe=D(ie[1]),be=fe),{type:"link",raw:ie[0],text:fe,href:be,tokens:[{type:"text",raw:fe,text:fe}]}}},_.url=function(se,ge){var ie;if(ie=this.rules.inline.url.exec(se)){var fe,be;if(ie[2]==="@")fe=D(this.options.mangle?ge(ie[0]):ie[0]),be="mailto:"+fe;else{var Ie;do Ie=ie[0],ie[0]=this.rules.inline._backpedal.exec(ie[0])[0];while(Ie!==ie[0]);fe=D(ie[0]),ie[1]==="www."?be="http://"+fe:be=fe}return{type:"link",raw:ie[0],text:fe,href:be,tokens:[{type:"text",raw:fe,text:fe}]}}},_.inlineText=function(se,ge){var ie=this.rules.inline.text.exec(se);if(ie){var fe;return this.lexer.state.inRawBlock?fe=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ie[0]):D(ie[0]):ie[0]:fe=D(this.options.smartypants?ge(ie[0]):ie[0]),{type:"text",raw:ie[0],text:fe}}},Z}(),U={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:h,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};U._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,U._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,U.def=u(U.def).replace("label",U._label).replace("title",U._title).getRegex(),U.bullet=/(?:[*+-]|\d{1,9}[.)])/,U.listItemStart=u(/^( *)(bull) */).replace("bull",U.bullet).getRegex(),U.list=u(U.list).replace(/bull/g,U.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+U.def.source+")").getRegex(),U._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",U._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,U.html=u(U.html,"i").replace("comment",U._comment).replace("tag",U._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),U.paragraph=u(U._paragraph).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",U._tag).getRegex(),U.blockquote=u(U.blockquote).replace("paragraph",U.paragraph).getRegex(),U.normal=p({},U),U.gfm=p({},U.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),U.gfm.table=u(U.gfm.table).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",U._tag).getRegex(),U.gfm.paragraph=u(U._paragraph).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",U.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",U._tag).getRegex(),U.pedantic=p({},U.normal,{html:u(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",U._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:h,paragraph:u(U.normal._paragraph).replace("hr",U.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",U.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var N={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:h,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:h,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};N._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",N.punctuation=u(N.punctuation).replace(/punctuation/g,N._punctuation).getRegex(),N.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,N.escapedEmSt=/\\\*|\\_/g,N._comment=u(U._comment).replace("(?:-->|$)","-->").getRegex(),N.emStrong.lDelim=u(N.emStrong.lDelim).replace(/punct/g,N._punctuation).getRegex(),N.emStrong.rDelimAst=u(N.emStrong.rDelimAst,"g").replace(/punct/g,N._punctuation).getRegex(),N.emStrong.rDelimUnd=u(N.emStrong.rDelimUnd,"g").replace(/punct/g,N._punctuation).getRegex(),N._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,N._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,N._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,N.autolink=u(N.autolink).replace("scheme",N._scheme).replace("email",N._email).getRegex(),N._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,N.tag=u(N.tag).replace("comment",N._comment).replace("attribute",N._attribute).getRegex(),N._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,N._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,N._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,N.link=u(N.link).replace("label",N._label).replace("href",N._href).replace("title",N._title).getRegex(),N.reflink=u(N.reflink).replace("label",N._label).replace("ref",U._label).getRegex(),N.nolink=u(N.nolink).replace("ref",U._label).getRegex(),N.reflinkSearch=u(N.reflinkSearch,"g").replace("reflink",N.reflink).replace("nolink",N.nolink).getRegex(),N.normal=p({},N),N.pedantic=p({},N.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:u(/^!?\[(label)\]\((.*?)\)/).replace("label",N._label).getRegex(),reflink:u(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",N._label).getRegex()}),N.gfm=p({},N.normal,{escape:u(N.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),N.gfm.url=u(N.gfm.url,"i").replace("email",N.gfm._extended_email).getRegex(),N.breaks=p({},N.gfm,{br:u(N.br).replace("{2,}","*").getRegex(),text:u(N.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function j(Z){return Z.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function z(Z){var _="",pe,se,ge=Z.length;for(pe=0;pe<ge;pe++)se=Z.charCodeAt(pe),Math.random()>.5&&(se="x"+se.toString(16)),_+="&#"+se+";";return _}var B=function(){function Z(pe){this.tokens=[],this.tokens.links=Object.create(null),this.options=pe||ne.defaults,this.options.tokenizer=this.options.tokenizer||new F,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var se={block:U.normal,inline:N.normal};this.options.pedantic?(se.block=U.pedantic,se.inline=N.pedantic):this.options.gfm&&(se.block=U.gfm,this.options.breaks?se.inline=N.breaks:se.inline=N.gfm),this.tokenizer.rules=se}Z.lex=function(se,ge){var ie=new Z(ge);return ie.lex(se)},Z.lexInline=function(se,ge){var ie=new Z(ge);return ie.inlineTokens(se)};var _=Z.prototype;return _.lex=function(se){se=se.replace(/\r\n|\r/g,`
`),this.blockTokens(se,this.tokens);for(var ge;ge=this.inlineQueue.shift();)this.inlineTokens(ge.src,ge.tokens);return this.tokens},_.blockTokens=function(se,ge){var ie=this;ge===void 0&&(ge=[]),this.options.pedantic?se=se.replace(/\t/g,"    ").replace(/^ +$/gm,""):se=se.replace(/^( *)(\t+)/gm,function(ce,he,x){return he+"    ".repeat(x.length)});for(var fe,be,Ie,W;se;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(ce){return(fe=ce.call({lexer:ie},se,ge))?(se=se.substring(fe.raw.length),ge.push(fe),!0):!1}))){if(fe=this.tokenizer.space(se)){se=se.substring(fe.raw.length),fe.raw.length===1&&ge.length>0?ge[ge.length-1].raw+=`
`:ge.push(fe);continue}if(fe=this.tokenizer.code(se)){se=se.substring(fe.raw.length),be=ge[ge.length-1],be&&(be.type==="paragraph"||be.type==="text")?(be.raw+=`
`+fe.raw,be.text+=`
`+fe.text,this.inlineQueue[this.inlineQueue.length-1].src=be.text):ge.push(fe);continue}if(fe=this.tokenizer.fences(se)){se=se.substring(fe.raw.length),ge.push(fe);continue}if(fe=this.tokenizer.heading(se)){se=se.substring(fe.raw.length),ge.push(fe);continue}if(fe=this.tokenizer.hr(se)){se=se.substring(fe.raw.length),ge.push(fe);continue}if(fe=this.tokenizer.blockquote(se)){se=se.substring(fe.raw.length),ge.push(fe);continue}if(fe=this.tokenizer.list(se)){se=se.substring(fe.raw.length),ge.push(fe);continue}if(fe=this.tokenizer.html(se)){se=se.substring(fe.raw.length),ge.push(fe);continue}if(fe=this.tokenizer.def(se)){se=se.substring(fe.raw.length),be=ge[ge.length-1],be&&(be.type==="paragraph"||be.type==="text")?(be.raw+=`
`+fe.raw,be.text+=`
`+fe.raw,this.inlineQueue[this.inlineQueue.length-1].src=be.text):this.tokens.links[fe.tag]||(this.tokens.links[fe.tag]={href:fe.href,title:fe.title});continue}if(fe=this.tokenizer.table(se)){se=se.substring(fe.raw.length),ge.push(fe);continue}if(fe=this.tokenizer.lheading(se)){se=se.substring(fe.raw.length),ge.push(fe);continue}if(Ie=se,this.options.extensions&&this.options.extensions.startBlock&&function(){var ce=1/0,he=se.slice(1),x=void 0;ie.options.extensions.startBlock.forEach(function($e){x=$e.call({lexer:this},he),typeof x=="number"&&x>=0&&(ce=Math.min(ce,x))}),ce<1/0&&ce>=0&&(Ie=se.substring(0,ce+1))}(),this.state.top&&(fe=this.tokenizer.paragraph(Ie))){be=ge[ge.length-1],W&&be.type==="paragraph"?(be.raw+=`
`+fe.raw,be.text+=`
`+fe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=be.text):ge.push(fe),W=Ie.length!==se.length,se=se.substring(fe.raw.length);continue}if(fe=this.tokenizer.text(se)){se=se.substring(fe.raw.length),be=ge[ge.length-1],be&&be.type==="text"?(be.raw+=`
`+fe.raw,be.text+=`
`+fe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=be.text):ge.push(fe);continue}if(se){var G="Infinite loop on byte: "+se.charCodeAt(0);if(this.options.silent){console.error(G);break}else throw new Error(G)}}return this.state.top=!0,ge},_.inline=function(se,ge){return ge===void 0&&(ge=[]),this.inlineQueue.push({src:se,tokens:ge}),ge},_.inlineTokens=function(se,ge){var ie=this;ge===void 0&&(ge=[]);var fe,be,Ie,W=se,G,ce,he;if(this.tokens.links){var x=Object.keys(this.tokens.links);if(x.length>0)for(;(G=this.tokenizer.rules.inline.reflinkSearch.exec(W))!=null;)x.includes(G[0].slice(G[0].lastIndexOf("[")+1,-1))&&(W=W.slice(0,G.index)+"["+L("a",G[0].length-2)+"]"+W.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(G=this.tokenizer.rules.inline.blockSkip.exec(W))!=null;)W=W.slice(0,G.index)+"["+L("a",G[0].length-2)+"]"+W.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(G=this.tokenizer.rules.inline.escapedEmSt.exec(W))!=null;)W=W.slice(0,G.index)+"++"+W.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;se;)if(ce||(he=""),ce=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ve){return(fe=ve.call({lexer:ie},se,ge))?(se=se.substring(fe.raw.length),ge.push(fe),!0):!1}))){if(fe=this.tokenizer.escape(se)){se=se.substring(fe.raw.length),ge.push(fe);continue}if(fe=this.tokenizer.tag(se)){se=se.substring(fe.raw.length),be=ge[ge.length-1],be&&fe.type==="text"&&be.type==="text"?(be.raw+=fe.raw,be.text+=fe.text):ge.push(fe);continue}if(fe=this.tokenizer.link(se)){se=se.substring(fe.raw.length),ge.push(fe);continue}if(fe=this.tokenizer.reflink(se,this.tokens.links)){se=se.substring(fe.raw.length),be=ge[ge.length-1],be&&fe.type==="text"&&be.type==="text"?(be.raw+=fe.raw,be.text+=fe.text):ge.push(fe);continue}if(fe=this.tokenizer.emStrong(se,W,he)){se=se.substring(fe.raw.length),ge.push(fe);continue}if(fe=this.tokenizer.codespan(se)){se=se.substring(fe.raw.length),ge.push(fe);continue}if(fe=this.tokenizer.br(se)){se=se.substring(fe.raw.length),ge.push(fe);continue}if(fe=this.tokenizer.del(se)){se=se.substring(fe.raw.length),ge.push(fe);continue}if(fe=this.tokenizer.autolink(se,z)){se=se.substring(fe.raw.length),ge.push(fe);continue}if(!this.state.inLink&&(fe=this.tokenizer.url(se,z))){se=se.substring(fe.raw.length),ge.push(fe);continue}if(Ie=se,this.options.extensions&&this.options.extensions.startInline&&function(){var ve=1/0,Ne=se.slice(1),Ve=void 0;ie.options.extensions.startInline.forEach(function(xe){Ve=xe.call({lexer:this},Ne),typeof Ve=="number"&&Ve>=0&&(ve=Math.min(ve,Ve))}),ve<1/0&&ve>=0&&(Ie=se.substring(0,ve+1))}(),fe=this.tokenizer.inlineText(Ie,j)){se=se.substring(fe.raw.length),fe.raw.slice(-1)!=="_"&&(he=fe.raw.slice(-1)),ce=!0,be=ge[ge.length-1],be&&be.type==="text"?(be.raw+=fe.raw,be.text+=fe.text):ge.push(fe);continue}if(se){var $e="Infinite loop on byte: "+se.charCodeAt(0);if(this.options.silent){console.error($e);break}else throw new Error($e)}}return ge},y(Z,null,[{key:"rules",get:function(){return{block:U,inline:N}}}]),Z}(),ae=function(){function Z(pe){this.options=pe||ne.defaults}var _=Z.prototype;return _.code=function(se,ge,ie){var fe=(ge||"").match(/\S*/)[0];if(this.options.highlight){var be=this.options.highlight(se,fe);be!=null&&be!==se&&(ie=!0,se=be)}return se=se.replace(/\n$/,"")+`
`,fe?'<pre><code class="'+this.options.langPrefix+D(fe,!0)+'">'+(ie?se:D(se,!0))+`</code></pre>
`:"<pre><code>"+(ie?se:D(se,!0))+`</code></pre>
`},_.blockquote=function(se){return`<blockquote>
`+se+`</blockquote>
`},_.html=function(se){return se},_.heading=function(se,ge,ie,fe){if(this.options.headerIds){var be=this.options.headerPrefix+fe.slug(ie);return"<h"+ge+' id="'+be+'">'+se+"</h"+ge+`>
`}return"<h"+ge+">"+se+"</h"+ge+`>
`},_.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},_.list=function(se,ge,ie){var fe=ge?"ol":"ul",be=ge&&ie!==1?' start="'+ie+'"':"";return"<"+fe+be+`>
`+se+"</"+fe+`>
`},_.listitem=function(se){return"<li>"+se+`</li>
`},_.checkbox=function(se){return"<input "+(se?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},_.paragraph=function(se){return"<p>"+se+`</p>
`},_.table=function(se,ge){return ge&&(ge="<tbody>"+ge+"</tbody>"),`<table>
<thead>
`+se+`</thead>
`+ge+`</table>
`},_.tablerow=function(se){return`<tr>
`+se+`</tr>
`},_.tablecell=function(se,ge){var ie=ge.header?"th":"td",fe=ge.align?"<"+ie+' align="'+ge.align+'">':"<"+ie+">";return fe+se+("</"+ie+`>
`)},_.strong=function(se){return"<strong>"+se+"</strong>"},_.em=function(se){return"<em>"+se+"</em>"},_.codespan=function(se){return"<code>"+se+"</code>"},_.br=function(){return this.options.xhtml?"<br/>":"<br>"},_.del=function(se){return"<del>"+se+"</del>"},_.link=function(se,ge,ie){if(se=d(this.options.sanitize,this.options.baseUrl,se),se===null)return ie;var fe='<a href="'+D(se)+'"';return ge&&(fe+=' title="'+ge+'"'),fe+=">"+ie+"</a>",fe},_.image=function(se,ge,ie){if(se=d(this.options.sanitize,this.options.baseUrl,se),se===null)return ie;var fe='<img src="'+se+'" alt="'+ie+'"';return ge&&(fe+=' title="'+ge+'"'),fe+=this.options.xhtml?"/>":">",fe},_.text=function(se){return se},Z}(),X=function(){function Z(){}var _=Z.prototype;return _.strong=function(se){return se},_.em=function(se){return se},_.codespan=function(se){return se},_.del=function(se){return se},_.html=function(se){return se},_.text=function(se){return se},_.link=function(se,ge,ie){return""+ie},_.image=function(se,ge,ie){return""+ie},_.br=function(){return""},Z}(),Q=function(){function Z(){this.seen={}}var _=Z.prototype;return _.serialize=function(se){return se.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},_.getNextSafeSlug=function(se,ge){var ie=se,fe=0;if(this.seen.hasOwnProperty(ie)){fe=this.seen[se];do fe++,ie=se+"-"+fe;while(this.seen.hasOwnProperty(ie))}return ge||(this.seen[se]=fe,this.seen[ie]=0),ie},_.slug=function(se,ge){ge===void 0&&(ge={});var ie=this.serialize(se);return this.getNextSafeSlug(ie,ge.dryrun)},Z}(),H=function(){function Z(pe){this.options=pe||ne.defaults,this.options.renderer=this.options.renderer||new ae,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new X,this.slugger=new Q}Z.parse=function(se,ge){var ie=new Z(ge);return ie.parse(se)},Z.parseInline=function(se,ge){var ie=new Z(ge);return ie.parseInline(se)};var _=Z.prototype;return _.parse=function(se,ge){ge===void 0&&(ge=!0);var ie="",fe,be,Ie,W,G,ce,he,x,$e,ve,Ne,Ve,xe,Qe,rt,it,nt,Ae,Fe,Le=se.length;for(fe=0;fe<Le;fe++){if(ve=se[fe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ve.type]&&(Fe=this.options.extensions.renderers[ve.type].call({parser:this},ve),Fe!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ve.type))){ie+=Fe||"";continue}switch(ve.type){case"space":continue;case"hr":{ie+=this.renderer.hr();continue}case"heading":{ie+=this.renderer.heading(this.parseInline(ve.tokens),ve.depth,s(this.parseInline(ve.tokens,this.textRenderer)),this.slugger);continue}case"code":{ie+=this.renderer.code(ve.text,ve.lang,ve.escaped);continue}case"table":{for(x="",he="",W=ve.header.length,be=0;be<W;be++)he+=this.renderer.tablecell(this.parseInline(ve.header[be].tokens),{header:!0,align:ve.align[be]});for(x+=this.renderer.tablerow(he),$e="",W=ve.rows.length,be=0;be<W;be++){for(ce=ve.rows[be],he="",G=ce.length,Ie=0;Ie<G;Ie++)he+=this.renderer.tablecell(this.parseInline(ce[Ie].tokens),{header:!1,align:ve.align[Ie]});$e+=this.renderer.tablerow(he)}ie+=this.renderer.table(x,$e);continue}case"blockquote":{$e=this.parse(ve.tokens),ie+=this.renderer.blockquote($e);continue}case"list":{for(Ne=ve.ordered,Ve=ve.start,xe=ve.loose,W=ve.items.length,$e="",be=0;be<W;be++)rt=ve.items[be],it=rt.checked,nt=rt.task,Qe="",rt.task&&(Ae=this.renderer.checkbox(it),xe?rt.tokens.length>0&&rt.tokens[0].type==="paragraph"?(rt.tokens[0].text=Ae+" "+rt.tokens[0].text,rt.tokens[0].tokens&&rt.tokens[0].tokens.length>0&&rt.tokens[0].tokens[0].type==="text"&&(rt.tokens[0].tokens[0].text=Ae+" "+rt.tokens[0].tokens[0].text)):rt.tokens.unshift({type:"text",text:Ae}):Qe+=Ae),Qe+=this.parse(rt.tokens,xe),$e+=this.renderer.listitem(Qe,nt,it);ie+=this.renderer.list($e,Ne,Ve);continue}case"html":{ie+=this.renderer.html(ve.text);continue}case"paragraph":{ie+=this.renderer.paragraph(this.parseInline(ve.tokens));continue}case"text":{for($e=ve.tokens?this.parseInline(ve.tokens):ve.text;fe+1<Le&&se[fe+1].type==="text";)ve=se[++fe],$e+=`
`+(ve.tokens?this.parseInline(ve.tokens):ve.text);ie+=ge?this.renderer.paragraph($e):$e;continue}default:{var Je='Token with "'+ve.type+'" type was not found.';if(this.options.silent){console.error(Je);return}else throw new Error(Je)}}}return ie},_.parseInline=function(se,ge){ge=ge||this.renderer;var ie="",fe,be,Ie,W=se.length;for(fe=0;fe<W;fe++){if(be=se[fe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[be.type]&&(Ie=this.options.extensions.renderers[be.type].call({parser:this},be),Ie!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(be.type))){ie+=Ie||"";continue}switch(be.type){case"escape":{ie+=ge.text(be.text);break}case"html":{ie+=ge.html(be.text);break}case"link":{ie+=ge.link(be.href,be.title,this.parseInline(be.tokens,ge));break}case"image":{ie+=ge.image(be.href,be.title,be.text);break}case"strong":{ie+=ge.strong(this.parseInline(be.tokens,ge));break}case"em":{ie+=ge.em(this.parseInline(be.tokens,ge));break}case"codespan":{ie+=ge.codespan(be.text);break}case"br":{ie+=ge.br();break}case"del":{ie+=ge.del(this.parseInline(be.tokens,ge));break}case"text":{ie+=ge.text(be.text);break}default:{var G='Token with "'+be.type+'" type was not found.';if(this.options.silent){console.error(G);return}else throw new Error(G)}}}return ie},Z}();function te(Z,_,pe){if(typeof Z>"u"||Z===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Z!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Z)+", string expected");if(typeof _=="function"&&(pe=_,_=null),_=p({},te.defaults,_||{}),b(_),pe){var se=_.highlight,ge;try{ge=B.lex(Z,_)}catch(W){return pe(W)}var ie=function(G){var ce;if(!G)try{_.walkTokens&&te.walkTokens(ge,_.walkTokens),ce=H.parse(ge,_)}catch(he){G=he}return _.highlight=se,G?pe(G):pe(null,ce)};if(!se||se.length<3||(delete _.highlight,!ge.length))return ie();var fe=0;te.walkTokens(ge,function(W){W.type==="code"&&(fe++,setTimeout(function(){se(W.text,W.lang,function(G,ce){if(G)return ie(G);ce!=null&&ce!==W.text&&(W.text=ce,W.escaped=!0),fe--,fe===0&&ie()})},0))}),fe===0&&ie();return}function be(W){if(W.message+=`
Please report this to https://github.com/markedjs/marked.`,_.silent)return"<p>An error occurred:</p><pre>"+D(W.message+"",!0)+"</pre>";throw W}try{var Ie=B.lex(Z,_);if(_.walkTokens){if(_.async)return Promise.all(te.walkTokens(Ie,_.walkTokens)).then(function(){return H.parse(Ie,_)}).catch(be);te.walkTokens(Ie,_.walkTokens)}return H.parse(Ie,_)}catch(W){be(W)}}te.options=te.setOptions=function(Z){return p(te.defaults,Z),m(te.defaults),te},te.getDefaults=A,te.defaults=ne.defaults,te.use=function(){for(var Z=arguments.length,_=new Array(Z),pe=0;pe<Z;pe++)_[pe]=arguments[pe];var se=p.apply(void 0,[{}].concat(_)),ge=te.defaults.extensions||{renderers:{},childTokens:{}},ie;_.forEach(function(fe){if(fe.extensions&&(ie=!0,fe.extensions.forEach(function(Ie){if(!Ie.name)throw new Error("extension name required");if(Ie.renderer){var W=ge.renderers?ge.renderers[Ie.name]:null;W?ge.renderers[Ie.name]=function(){for(var G=arguments.length,ce=new Array(G),he=0;he<G;he++)ce[he]=arguments[he];var x=Ie.renderer.apply(this,ce);return x===!1&&(x=W.apply(this,ce)),x}:ge.renderers[Ie.name]=Ie.renderer}if(Ie.tokenizer){if(!Ie.level||Ie.level!=="block"&&Ie.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ge[Ie.level]?ge[Ie.level].unshift(Ie.tokenizer):ge[Ie.level]=[Ie.tokenizer],Ie.start&&(Ie.level==="block"?ge.startBlock?ge.startBlock.push(Ie.start):ge.startBlock=[Ie.start]:Ie.level==="inline"&&(ge.startInline?ge.startInline.push(Ie.start):ge.startInline=[Ie.start]))}Ie.childTokens&&(ge.childTokens[Ie.name]=Ie.childTokens)})),fe.renderer&&function(){var Ie=te.defaults.renderer||new ae,W=function(he){var x=Ie[he];Ie[he]=function(){for(var $e=arguments.length,ve=new Array($e),Ne=0;Ne<$e;Ne++)ve[Ne]=arguments[Ne];var Ve=fe.renderer[he].apply(Ie,ve);return Ve===!1&&(Ve=x.apply(Ie,ve)),Ve}};for(var G in fe.renderer)W(G);se.renderer=Ie}(),fe.tokenizer&&function(){var Ie=te.defaults.tokenizer||new F,W=function(he){var x=Ie[he];Ie[he]=function(){for(var $e=arguments.length,ve=new Array($e),Ne=0;Ne<$e;Ne++)ve[Ne]=arguments[Ne];var Ve=fe.tokenizer[he].apply(Ie,ve);return Ve===!1&&(Ve=x.apply(Ie,ve)),Ve}};for(var G in fe.tokenizer)W(G);se.tokenizer=Ie}(),fe.walkTokens){var be=te.defaults.walkTokens;se.walkTokens=function(Ie){var W=[];return W.push(fe.walkTokens.call(this,Ie)),be&&(W=W.concat(be.call(this,Ie))),W}}ie&&(se.extensions=ge),te.setOptions(se)})},te.walkTokens=function(Z,_){for(var pe=[],se=function(){var be=ie.value;switch(pe=pe.concat(_.call(te,be)),be.type){case"table":{for(var Ie=R(be.header),W;!(W=Ie()).done;){var G=W.value;pe=pe.concat(te.walkTokens(G.tokens,_))}for(var ce=R(be.rows),he;!(he=ce()).done;)for(var x=he.value,$e=R(x),ve;!(ve=$e()).done;){var Ne=ve.value;pe=pe.concat(te.walkTokens(Ne.tokens,_))}break}case"list":{pe=pe.concat(te.walkTokens(be.items,_));break}default:te.defaults.extensions&&te.defaults.extensions.childTokens&&te.defaults.extensions.childTokens[be.type]?te.defaults.extensions.childTokens[be.type].forEach(function(Ve){pe=pe.concat(te.walkTokens(be[Ve],_))}):be.tokens&&(pe=pe.concat(te.walkTokens(be.tokens,_)))}},ge=R(Z),ie;!(ie=ge()).done;)se();return pe},te.parseInline=function(Z,_){if(typeof Z>"u"||Z===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Z!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Z)+", string expected");_=p({},te.defaults,_||{}),b(_);try{var pe=B.lexInline(Z,_);return _.walkTokens&&te.walkTokens(pe,_.walkTokens),H.parseInline(pe,_)}catch(se){if(se.message+=`
Please report this to https://github.com/markedjs/marked.`,_.silent)return"<p>An error occurred:</p><pre>"+D(se.message+"",!0)+"</pre>";throw se}},te.Parser=H,te.parser=H.parse,te.Renderer=ae,te.TextRenderer=X,te.Lexer=B,te.lexer=B.lex,te.Tokenizer=F,te.Slugger=Q,te.parse=te;var me=te.options,le=te.setOptions,ye=te.use,de=te.walkTokens,V=te.parseInline,J=te,ee=H.parse,Y=B.lex;ne.Lexer=B,ne.Parser=H,ne.Renderer=ae,ne.Slugger=Q,ne.TextRenderer=X,ne.Tokenizer=F,ne.getDefaults=A,ne.lexer=Y,ne.marked=te,ne.options=me,ne.parse=J,ne.parseInline=V,ne.parser=ee,ne.setOptions=le,ne.use=ye,ne.walkTokens=de,Object.defineProperty(ne,"__esModule",{value:!0})}),define(Se[77],De([1,0,28]),function(ne,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ll=e.$kl=e.$jl=void 0;const M=new y.$Bc(1e4);function l($){return k($,"NFC",M)}e.$jl=l;const R=new y.$Bc(1e4);function A($){return k($,"NFD",R)}e.$kl=A;const m=/[^\u0000-\u0080]/;function k($,P,C){if(!$)return $;const v=C.get($);if(v)return v;let S;return m.test($)?S=$.normalize(P):S=$,C.set($,S),S}e.$ll=function(){const $=/[\u0300-\u036f]/g;return function(P){return A(P).replace($,"")}}()}),define(Se[121],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nl=e.$Ml=e.$Ll=e.rot=e.$Jl=void 0;function y(m,k,$){return Math.min(Math.max(m,k),$)}e.$Jl=y;function M(m,k){return(k+m%k)%k}e.rot=M;class l{constructor(){this.a=0}getNext(){return this.a++}}e.$Ll=l;class R{constructor(){this.a=1,this.b=0}update(k){return this.b=this.b+(k-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Ml=R;class A{constructor(k){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(k),this.c.fill(0,0,k)}update(k){const $=this.c[this.d];return this.c[this.d]=k,this.d=(this.d+1)%this.c.length,this.e-=$,this.e+=k,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Nl=A}),function(){function ne(l){const R=[];typeof l=="number"&&R.push("code/timeOrigin",l);function A(k){R.push(k,Date.now())}function m(){const k=[];for(let $=0;$<R.length;$+=2)k.push({name:R[$],startTime:R[$+1]});return k}return{mark:A,getMarks:m}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ne():{mark(l){performance.mark(l)},getMarks(){let l=performance.timeOrigin;typeof l!="number"&&(l=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(l)}];for(const A of performance.getEntriesByType("mark"))R.push({name:A.name,startTime:Math.round(l+A.startTime)});return R}};if(typeof process=="object"){const l=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ne(l)}else return console.trace("perf-util loaded in UNKNOWN environment"),ne()}function y(l){return l.MonacoPerformanceMarks||(l.MonacoPerformanceMarks=e()),l.MonacoPerformanceMarks}var M;typeof global=="object"?M=global:typeof self=="object"?M=self:M={},typeof define=="function"?define("vs/base/common/performance",[],function(){return y(M)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=y(M):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),M.perf=y(M))}(),define(Se[10],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$C=e.$B=e.$A=e.$z=e.$y=e.$x=e.OS=e.OperatingSystem=e.$v=e.$u=e.$t=e.$s=e.$r=e.Language=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.$h=e.$g=e.$f=e.$e=e.$d=e.$c=e.Platform=e.$b=e.$a=void 0,e.$a="en";let y=!1,M=!1,l=!1,R=!1,A=!1,m=!1,k=!1,$=!1,P=!1,C=!1,v,S=e.$a,D=e.$a,E,s;e.$b=typeof self=="object"?self:typeof global=="object"?global:{};let c;typeof e.$b.vscode<"u"&&typeof e.$b.vscode.process<"u"?c=e.$b.vscode.process:typeof process<"u"&&(c=process);const u=typeof c?.versions?.electron=="string",o=u&&c?.type==="renderer";if(typeof navigator=="object"&&!o){s=navigator.userAgent,y=s.indexOf("Windows")>=0,M=s.indexOf("Macintosh")>=0,$=(s.indexOf("Macintosh")>=0||s.indexOf("iPad")>=0||s.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,l=s.indexOf("Linux")>=0,C=s?.indexOf("Mobi")>=0,m=!0,v=e.$a,S=v,D=navigator.language;const p=typeof document<"u"&&document.getElementById("vscode-remote-nls-configuration"),I=p&&p.getAttribute("data-settings");if(I)try{const w=JSON.parse(I),f=w.availableLanguages["*"];v=w.locale,D=w.osLocale,S=f||e.$a,E=w._translationsConfigFile}catch{}}else if(typeof c=="object"){y=c.platform==="win32",M=c.platform==="darwin",l=c.platform==="linux",R=l&&!!c.env.SNAP&&!!c.env.SNAP_REVISION,k=u,P=!!c.env.CI||!!c.env.BUILD_ARTIFACTSTAGINGDIRECTORY,v=e.$a,S=e.$a;const p=c.env.VSCODE_NLS_CONFIG;if(p)try{const I=JSON.parse(p),w=I.availableLanguages["*"];v=I.locale,D=I.osLocale,S=w||e.$a,E=I._translationsConfigFile}catch{}A=!0}else console.error("Unable to resolve platform.");var g;(function(p){p[p.Web=0]="Web",p[p.Mac=1]="Mac",p[p.Linux=2]="Linux",p[p.Windows=3]="Windows"})(g||(e.Platform=g={}));function d(p){switch(p){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$c=d;let t=0;M?t=1:y?t=3:l&&(t=2),e.$d=y,e.$e=M,e.$f=l,e.$g=R,e.$h=A,e.$i=k,e.$j=m,e.$k=m&&typeof e.$b.importScripts=="function",e.$l=$,e.$m=C,e.$n=P,e.$o=t,e.$p=s,e.$q=S;var n;(function(p){function I(){return e.$q}p.value=I;function w(){return e.$q.length===2?e.$q==="en":e.$q.length>=3?e.$q[0]==="e"&&e.$q[1]==="n"&&e.$q[2]==="-":!1}p.isDefaultVariant=w;function f(){return e.$q==="en"}p.isDefault=f})(n||(e.Language=n={})),e.$r=v,e.$s=D,e.$t=E,e.$u=typeof e.$b.postMessage=="function"&&!e.$b.importScripts,e.$v=(()=>{if(e.$u){const p=[];e.$b.addEventListener("message",w=>{if(w.data&&w.data.vscodeScheduleAsyncWork)for(let f=0,b=p.length;f<b;f++){const L=p[f];if(L.id===w.data.vscodeScheduleAsyncWork){p.splice(f,1),L.callback();return}}});let I=0;return w=>{const f=++I;p.push({id:f,callback:w}),e.$b.postMessage({vscodeScheduleAsyncWork:f},"*")}}return p=>setTimeout(p)})();var r;(function(p){p[p.Windows=1]="Windows",p[p.Macintosh=2]="Macintosh",p[p.Linux=3]="Linux"})(r||(e.OperatingSystem=r={})),e.OS=M||$?2:y?1:3;let i=!0,a=!1;function h(){if(!a){a=!0;const p=new Uint8Array(2);p[0]=1,p[1]=2,i=new Uint16Array(p.buffer)[0]===(2<<8)+1}return i}e.$x=h,e.$y=!!(e.$p&&e.$p.indexOf("Chrome")>=0),e.$z=!!(e.$p&&e.$p.indexOf("Firefox")>=0),e.$A=!!(!e.$y&&e.$p&&e.$p.indexOf("Safari")>=0),e.$B=!!(e.$p&&e.$p.indexOf("Edg/")>=0),e.$C=!!(e.$p&&e.$p.indexOf("Android")>=0)}),define(Se[46],De([1,0,10]),function(ne,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cc=e.$bc=e.env=e.cwd=void 0;let M;if(typeof y.$b.vscode<"u"&&typeof y.$b.vscode.process<"u"){const l=y.$b.vscode.process;M={get platform(){return l.platform},get arch(){return l.arch},get env(){return l.env},cwd(){return l.cwd()}}}else typeof process<"u"?M={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:M={get platform(){return y.$d?"win32":y.$e?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=M.cwd,e.env=M.env,e.$bc=M.platform,e.$cc=M.arch}),define(Se[15],De([1,0,46]),function(ne,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rc=e.sep=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=e.$ec=e.$dc=void 0;const M=65,l=97,R=90,A=122,m=46,k=47,$=92,P=58,C=63;class v extends Error{constructor(n,r,i){let a;typeof r=="string"&&r.indexOf("not ")===0?(a="must not be",r=r.replace(/^not /,"")):a="must be";const h=n.indexOf(".")!==-1?"property":"argument";let p=`The "${n}" ${h} ${a} of type ${r}`;p+=`. Received type ${typeof i}`,super(p),this.code="ERR_INVALID_ARG_TYPE"}}function S(t,n){if(t===null||typeof t!="object")throw new v(n,"Object",t)}function D(t,n){if(typeof t!="string")throw new v(n,"string",t)}const E=y.$bc==="win32";function s(t){return t===k||t===$}function c(t){return t===k}function u(t){return t>=M&&t<=R||t>=l&&t<=A}function o(t,n,r,i){let a="",h=0,p=-1,I=0,w=0;for(let f=0;f<=t.length;++f){if(f<t.length)w=t.charCodeAt(f);else{if(i(w))break;w=k}if(i(w)){if(!(p===f-1||I===1))if(I===2){if(a.length<2||h!==2||a.charCodeAt(a.length-1)!==m||a.charCodeAt(a.length-2)!==m){if(a.length>2){const b=a.lastIndexOf(r);b===-1?(a="",h=0):(a=a.slice(0,b),h=a.length-1-a.lastIndexOf(r)),p=f,I=0;continue}else if(a.length!==0){a="",h=0,p=f,I=0;continue}}n&&(a+=a.length>0?`${r}..`:"..",h=2)}else a.length>0?a+=`${r}${t.slice(p+1,f)}`:a=t.slice(p+1,f),h=f-p-1;p=f,I=0}else w===m&&I!==-1?++I:I=-1}return a}function g(t,n){S(n,"pathObject");const r=n.dir||n.root,i=n.base||`${n.name||""}${n.ext||""}`;return r?r===n.root?`${r}${i}`:`${r}${t}${i}`:i}e.$dc={resolve(...t){let n="",r="",i=!1;for(let a=t.length-1;a>=-1;a--){let h;if(a>=0){if(h=t[a],D(h,"path"),h.length===0)continue}else n.length===0?h=y.cwd():(h=y.env[`=${n}`]||y.cwd(),(h===void 0||h.slice(0,2).toLowerCase()!==n.toLowerCase()&&h.charCodeAt(2)===$)&&(h=`${n}\\`));const p=h.length;let I=0,w="",f=!1;const b=h.charCodeAt(0);if(p===1)s(b)&&(I=1,f=!0);else if(s(b))if(f=!0,s(h.charCodeAt(1))){let L=2,O=L;for(;L<p&&!s(h.charCodeAt(L));)L++;if(L<p&&L!==O){const T=h.slice(O,L);for(O=L;L<p&&s(h.charCodeAt(L));)L++;if(L<p&&L!==O){for(O=L;L<p&&!s(h.charCodeAt(L));)L++;(L===p||L!==O)&&(w=`\\\\${T}\\${h.slice(O,L)}`,I=L)}}}else I=1;else u(b)&&h.charCodeAt(1)===P&&(w=h.slice(0,2),I=2,p>2&&s(h.charCodeAt(2))&&(f=!0,I=3));if(w.length>0)if(n.length>0){if(w.toLowerCase()!==n.toLowerCase())continue}else n=w;if(i){if(n.length>0)break}else if(r=`${h.slice(I)}\\${r}`,i=f,f&&n.length>0)break}return r=o(r,!i,"\\",s),i?`${n}\\${r}`:`${n}${r}`||"."},normalize(t){D(t,"path");const n=t.length;if(n===0)return".";let r=0,i,a=!1;const h=t.charCodeAt(0);if(n===1)return c(h)?"\\":t;if(s(h))if(a=!0,s(t.charCodeAt(1))){let I=2,w=I;for(;I<n&&!s(t.charCodeAt(I));)I++;if(I<n&&I!==w){const f=t.slice(w,I);for(w=I;I<n&&s(t.charCodeAt(I));)I++;if(I<n&&I!==w){for(w=I;I<n&&!s(t.charCodeAt(I));)I++;if(I===n)return`\\\\${f}\\${t.slice(w)}\\`;I!==w&&(i=`\\\\${f}\\${t.slice(w,I)}`,r=I)}}}else r=1;else u(h)&&t.charCodeAt(1)===P&&(i=t.slice(0,2),r=2,n>2&&s(t.charCodeAt(2))&&(a=!0,r=3));let p=r<n?o(t.slice(r),!a,"\\",s):"";return p.length===0&&!a&&(p="."),p.length>0&&s(t.charCodeAt(n-1))&&(p+="\\"),i===void 0?a?`\\${p}`:p:a?`${i}\\${p}`:`${i}${p}`},isAbsolute(t){D(t,"path");const n=t.length;if(n===0)return!1;const r=t.charCodeAt(0);return s(r)||n>2&&u(r)&&t.charCodeAt(1)===P&&s(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let n,r;for(let h=0;h<t.length;++h){const p=t[h];D(p,"path"),p.length>0&&(n===void 0?n=r=p:n+=`\\${p}`)}if(n===void 0)return".";let i=!0,a=0;if(typeof r=="string"&&s(r.charCodeAt(0))){++a;const h=r.length;h>1&&s(r.charCodeAt(1))&&(++a,h>2&&(s(r.charCodeAt(2))?++a:i=!1))}if(i){for(;a<n.length&&s(n.charCodeAt(a));)a++;a>=2&&(n=`\\${n.slice(a)}`)}return e.$dc.normalize(n)},relative(t,n){if(D(t,"from"),D(n,"to"),t===n)return"";const r=e.$dc.resolve(t),i=e.$dc.resolve(n);if(r===i||(t=r.toLowerCase(),n=i.toLowerCase(),t===n))return"";let a=0;for(;a<t.length&&t.charCodeAt(a)===$;)a++;let h=t.length;for(;h-1>a&&t.charCodeAt(h-1)===$;)h--;const p=h-a;let I=0;for(;I<n.length&&n.charCodeAt(I)===$;)I++;let w=n.length;for(;w-1>I&&n.charCodeAt(w-1)===$;)w--;const f=w-I,b=p<f?p:f;let L=-1,O=0;for(;O<b;O++){const F=t.charCodeAt(a+O);if(F!==n.charCodeAt(I+O))break;F===$&&(L=O)}if(O!==b){if(L===-1)return i}else{if(f>b){if(n.charCodeAt(I+O)===$)return i.slice(I+O+1);if(O===2)return i.slice(I+O)}p>b&&(t.charCodeAt(a+O)===$?L=O:O===2&&(L=3)),L===-1&&(L=0)}let T="";for(O=a+L+1;O<=h;++O)(O===h||t.charCodeAt(O)===$)&&(T+=T.length===0?"..":"\\..");return I+=L,T.length>0?`${T}${i.slice(I,w)}`:(i.charCodeAt(I)===$&&++I,i.slice(I,w))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const n=e.$dc.resolve(t);if(n.length<=2)return t;if(n.charCodeAt(0)===$){if(n.charCodeAt(1)===$){const r=n.charCodeAt(2);if(r!==C&&r!==m)return`\\\\?\\UNC\\${n.slice(2)}`}}else if(u(n.charCodeAt(0))&&n.charCodeAt(1)===P&&n.charCodeAt(2)===$)return`\\\\?\\${n}`;return t},dirname(t){D(t,"path");const n=t.length;if(n===0)return".";let r=-1,i=0;const a=t.charCodeAt(0);if(n===1)return s(a)?t:".";if(s(a)){if(r=i=1,s(t.charCodeAt(1))){let I=2,w=I;for(;I<n&&!s(t.charCodeAt(I));)I++;if(I<n&&I!==w){for(w=I;I<n&&s(t.charCodeAt(I));)I++;if(I<n&&I!==w){for(w=I;I<n&&!s(t.charCodeAt(I));)I++;if(I===n)return t;I!==w&&(r=i=I+1)}}}}else u(a)&&t.charCodeAt(1)===P&&(r=n>2&&s(t.charCodeAt(2))?3:2,i=r);let h=-1,p=!0;for(let I=n-1;I>=i;--I)if(s(t.charCodeAt(I))){if(!p){h=I;break}}else p=!1;if(h===-1){if(r===-1)return".";h=r}return t.slice(0,h)},basename(t,n){n!==void 0&&D(n,"ext"),D(t,"path");let r=0,i=-1,a=!0,h;if(t.length>=2&&u(t.charCodeAt(0))&&t.charCodeAt(1)===P&&(r=2),n!==void 0&&n.length>0&&n.length<=t.length){if(n===t)return"";let p=n.length-1,I=-1;for(h=t.length-1;h>=r;--h){const w=t.charCodeAt(h);if(s(w)){if(!a){r=h+1;break}}else I===-1&&(a=!1,I=h+1),p>=0&&(w===n.charCodeAt(p)?--p===-1&&(i=h):(p=-1,i=I))}return r===i?i=I:i===-1&&(i=t.length),t.slice(r,i)}for(h=t.length-1;h>=r;--h)if(s(t.charCodeAt(h))){if(!a){r=h+1;break}}else i===-1&&(a=!1,i=h+1);return i===-1?"":t.slice(r,i)},extname(t){D(t,"path");let n=0,r=-1,i=0,a=-1,h=!0,p=0;t.length>=2&&t.charCodeAt(1)===P&&u(t.charCodeAt(0))&&(n=i=2);for(let I=t.length-1;I>=n;--I){const w=t.charCodeAt(I);if(s(w)){if(!h){i=I+1;break}continue}a===-1&&(h=!1,a=I+1),w===m?r===-1?r=I:p!==1&&(p=1):r!==-1&&(p=-1)}return r===-1||a===-1||p===0||p===1&&r===a-1&&r===i+1?"":t.slice(r,a)},format:g.bind(null,"\\"),parse(t){D(t,"path");const n={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return n;const r=t.length;let i=0,a=t.charCodeAt(0);if(r===1)return s(a)?(n.root=n.dir=t,n):(n.base=n.name=t,n);if(s(a)){if(i=1,s(t.charCodeAt(1))){let L=2,O=L;for(;L<r&&!s(t.charCodeAt(L));)L++;if(L<r&&L!==O){for(O=L;L<r&&s(t.charCodeAt(L));)L++;if(L<r&&L!==O){for(O=L;L<r&&!s(t.charCodeAt(L));)L++;L===r?i=L:L!==O&&(i=L+1)}}}}else if(u(a)&&t.charCodeAt(1)===P){if(r<=2)return n.root=n.dir=t,n;if(i=2,s(t.charCodeAt(2))){if(r===3)return n.root=n.dir=t,n;i=3}}i>0&&(n.root=t.slice(0,i));let h=-1,p=i,I=-1,w=!0,f=t.length-1,b=0;for(;f>=i;--f){if(a=t.charCodeAt(f),s(a)){if(!w){p=f+1;break}continue}I===-1&&(w=!1,I=f+1),a===m?h===-1?h=f:b!==1&&(b=1):h!==-1&&(b=-1)}return I!==-1&&(h===-1||b===0||b===1&&h===I-1&&h===p+1?n.base=n.name=t.slice(p,I):(n.name=t.slice(p,h),n.base=t.slice(p,I),n.ext=t.slice(h,I))),p>0&&p!==i?n.dir=t.slice(0,p-1):n.dir=n.root,n},sep:"\\",delimiter:";",win32:null,posix:null};const d=(()=>{if(E){const t=/\\/g;return()=>{const n=y.cwd().replace(t,"/");return n.slice(n.indexOf("/"))}}return()=>y.cwd()})();e.$ec={resolve(...t){let n="",r=!1;for(let i=t.length-1;i>=-1&&!r;i--){const a=i>=0?t[i]:d();D(a,"path"),a.length!==0&&(n=`${a}/${n}`,r=a.charCodeAt(0)===k)}return n=o(n,!r,"/",c),r?`/${n}`:n.length>0?n:"."},normalize(t){if(D(t,"path"),t.length===0)return".";const n=t.charCodeAt(0)===k,r=t.charCodeAt(t.length-1)===k;return t=o(t,!n,"/",c),t.length===0?n?"/":r?"./":".":(r&&(t+="/"),n?`/${t}`:t)},isAbsolute(t){return D(t,"path"),t.length>0&&t.charCodeAt(0)===k},join(...t){if(t.length===0)return".";let n;for(let r=0;r<t.length;++r){const i=t[r];D(i,"path"),i.length>0&&(n===void 0?n=i:n+=`/${i}`)}return n===void 0?".":e.$ec.normalize(n)},relative(t,n){if(D(t,"from"),D(n,"to"),t===n||(t=e.$ec.resolve(t),n=e.$ec.resolve(n),t===n))return"";const r=1,i=t.length,a=i-r,h=1,p=n.length-h,I=a<p?a:p;let w=-1,f=0;for(;f<I;f++){const L=t.charCodeAt(r+f);if(L!==n.charCodeAt(h+f))break;L===k&&(w=f)}if(f===I)if(p>I){if(n.charCodeAt(h+f)===k)return n.slice(h+f+1);if(f===0)return n.slice(h+f)}else a>I&&(t.charCodeAt(r+f)===k?w=f:f===0&&(w=0));let b="";for(f=r+w+1;f<=i;++f)(f===i||t.charCodeAt(f)===k)&&(b+=b.length===0?"..":"/..");return`${b}${n.slice(h+w)}`},toNamespacedPath(t){return t},dirname(t){if(D(t,"path"),t.length===0)return".";const n=t.charCodeAt(0)===k;let r=-1,i=!0;for(let a=t.length-1;a>=1;--a)if(t.charCodeAt(a)===k){if(!i){r=a;break}}else i=!1;return r===-1?n?"/":".":n&&r===1?"//":t.slice(0,r)},basename(t,n){n!==void 0&&D(n,"ext"),D(t,"path");let r=0,i=-1,a=!0,h;if(n!==void 0&&n.length>0&&n.length<=t.length){if(n===t)return"";let p=n.length-1,I=-1;for(h=t.length-1;h>=0;--h){const w=t.charCodeAt(h);if(w===k){if(!a){r=h+1;break}}else I===-1&&(a=!1,I=h+1),p>=0&&(w===n.charCodeAt(p)?--p===-1&&(i=h):(p=-1,i=I))}return r===i?i=I:i===-1&&(i=t.length),t.slice(r,i)}for(h=t.length-1;h>=0;--h)if(t.charCodeAt(h)===k){if(!a){r=h+1;break}}else i===-1&&(a=!1,i=h+1);return i===-1?"":t.slice(r,i)},extname(t){D(t,"path");let n=-1,r=0,i=-1,a=!0,h=0;for(let p=t.length-1;p>=0;--p){const I=t.charCodeAt(p);if(I===k){if(!a){r=p+1;break}continue}i===-1&&(a=!1,i=p+1),I===m?n===-1?n=p:h!==1&&(h=1):n!==-1&&(h=-1)}return n===-1||i===-1||h===0||h===1&&n===i-1&&n===r+1?"":t.slice(n,i)},format:g.bind(null,"/"),parse(t){D(t,"path");const n={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return n;const r=t.charCodeAt(0)===k;let i;r?(n.root="/",i=1):i=0;let a=-1,h=0,p=-1,I=!0,w=t.length-1,f=0;for(;w>=i;--w){const b=t.charCodeAt(w);if(b===k){if(!I){h=w+1;break}continue}p===-1&&(I=!1,p=w+1),b===m?a===-1?a=w:f!==1&&(f=1):a!==-1&&(f=-1)}if(p!==-1){const b=h===0&&r?1:h;a===-1||f===0||f===1&&a===p-1&&a===h+1?n.base=n.name=t.slice(b,p):(n.name=t.slice(b,a),n.base=t.slice(b,p),n.ext=t.slice(a,p))}return h>0?n.dir=t.slice(0,h-1):r&&(n.dir="/"),n},sep:"/",delimiter:":",win32:null,posix:null},e.$ec.win32=e.$dc.win32=e.$dc,e.$ec.posix=e.$dc.posix=e.$ec,e.$fc=E?e.$dc.normalize:e.$ec.normalize,e.$gc=E?e.$dc.isAbsolute:e.$ec.isAbsolute,e.$hc=E?e.$dc.join:e.$ec.join,e.$ic=E?e.$dc.resolve:e.$ec.resolve,e.$jc=E?e.$dc.relative:e.$ec.relative,e.$kc=E?e.$dc.dirname:e.$ec.dirname,e.$lc=E?e.$dc.basename:e.$ec.basename,e.$mc=E?e.$dc.extname:e.$ec.extname,e.$nc=E?e.$dc.format:e.$ec.format,e.$oc=E?e.$dc.parse:e.$ec.parse,e.$pc=E?e.$dc.toNamespacedPath:e.$ec.toNamespacedPath,e.sep=E?e.$dc.sep:e.$ec.sep,e.$rc=E?e.$dc.delimiter:e.$ec.delimiter}),define(Se[122],De([1,0,58,15]),function(ne,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lq=e.$kq=e.$jq=e.$iq=e.$hq=e.$gq=e.$fq=e.$eq=e.$dq=e.$cq=e.$bq=e.$aq=e.$_p=void 0;const l=new y.$T(()=>{const I=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:I,collatorIsNumeric:I.resolvedOptions().numeric}}),R=new y.$T(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),A=new y.$T(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function m(I,w,f=!1){const b=I||"",L=w||"",O=l.value.collator.compare(b,L);return l.value.collatorIsNumeric&&O===0&&b!==L?b<L?-1:1:O}e.$_p=m;function k(I,w){const f=R.value.collator;return I=I||"",w=w||"",g(f,I,w)}e.$aq=k;function $(I,w){const f=R.value.collator;return I=I||"",w=w||"",r(I,w)||g(f,I,w)}e.$bq=$;function P(I,w){const f=R.value.collator;return I=I||"",w=w||"",n(I,w)||g(f,I,w)}e.$cq=P;function C(I,w){return I=I||"",w=w||"",I===w?0:I<w?-1:1}e.$dq=C;function v(I,w){const[f,b]=u(I),[L,O]=u(w);let T=l.value.collator.compare(b,O);if(T===0){if(l.value.collatorIsNumeric&&b!==O)return b<O?-1:1;if(T=l.value.collator.compare(f,L),l.value.collatorIsNumeric&&T===0&&f!==L)return f<L?-1:1}return T}e.$eq=v;function S(I,w){I=I||"",w=w||"";const f=o(I),b=o(w),L=R.value.collator,O=A.value.collator;return g(O,f,b)||g(L,I,w)}e.$fq=S;function D(I,w){I=I||"",w=w||"";const f=o(I),b=o(w),L=R.value.collator,O=A.value.collator;return g(O,f,b)||r(I,w)||g(L,I,w)}e.$gq=D;function E(I,w){I=I||"",w=w||"";const f=o(I),b=o(w),L=R.value.collator,O=A.value.collator;return g(O,f,b)||n(I,w)||g(L,I,w)}e.$hq=E;function s(I,w){I=I||"",w=w||"";const f=o(I).toLowerCase(),b=o(w).toLowerCase();return f!==b?f<b?-1:1:I!==w?I<w?-1:1:0}e.$iq=s;const c=/^(.*?)(\.([^.]*))?$/;function u(I,w=!1){const f=I?c.exec(I):[];let b=[f&&f[1]||"",f&&f[3]||""];return w&&(!b[0]&&b[1]||b[0]&&b[0].charAt(0)===".")&&(b=[b[0]+"."+b[1],""]),b}function o(I){const w=I?c.exec(I):[];return w&&w[1]&&w[1].charAt(0)!=="."&&w[3]||""}function g(I,w,f){const b=I.compare(w,f);return b!==0?b:w.length!==f.length?w.length<f.length?-1:1:0}function d(I){const w=I.charAt(0);return w.toLocaleUpperCase()!==w}function t(I){const w=I.charAt(0);return w.toLocaleLowerCase()!==w}function n(I,w){return d(I)&&t(w)?-1:t(I)&&d(w)?1:0}function r(I,w){return t(I)&&d(w)?-1:d(I)&&t(w)?1:0}function i(I,w,f=!1){return f||(I=I&&I.toLowerCase(),w=w&&w.toLowerCase()),I===w?0:I<w?-1:1}function a(I,w,f=!1){const b=I.split(M.sep),L=w.split(M.sep),O=b.length-1,T=L.length-1;let F,U;for(let N=0;;N++){if(F=O===N,U=T===N,F&&U)return m(b[N],L[N],f);if(F)return-1;if(U)return 1;const j=i(b[N],L[N],f);if(j!==0)return j}}e.$jq=a;function h(I,w,f){const b=I.toLowerCase(),L=w.toLowerCase(),O=p(I,w,f);if(O)return O;const T=b.endsWith(f),F=L.endsWith(f);if(T!==F)return T?-1:1;const U=m(b,L);return U!==0?U:b.localeCompare(L)}e.$kq=h;function p(I,w,f){const b=I.toLowerCase(),L=w.toLowerCase(),O=b.startsWith(f),T=L.startsWith(f);if(O!==T)return O?-1:1;if(O&&T){if(b.length<L.length)return-1;if(b.length>L.length)return 1}return 0}e.$lq=p}),define(Se[97],De([1,0,15]),function(ne,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nr=e.$Mr=e.$Lr=e.$Kr=e.$Jr=void 0,e.$Jr=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const M={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},l={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function R(P){const C=(0,y.$mc)(P),v=M[C.toLowerCase()];return v!==void 0?v:A(P)}e.$Kr=R;function A(P){const C=(0,y.$mc)(P);return l[C.toLowerCase()]}e.$Lr=A;function m(P){for(const C in l)if(l[C]===P)return C}e.$Mr=m;const k=/^(.+)\/(.+?)(;.+)?$/;function $(P,C){const v=k.exec(P);return v?`${v[1].toLowerCase()}/${v[2].toLowerCase()}${v[3]??""}`:C?void 0:P}e.$Nr=$}),define(Se[98],De([1,0,10]),function(ne,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vl=e.$ul=e.TerminateResponseCode=e.Source=void 0;var M;(function(m){m[m.stdout=0]="stdout",m[m.stderr=1]="stderr"})(M||(e.Source=M={}));var l;(function(m){m[m.Success=0]="Success",m[m.Unknown=1]="Unknown",m[m.AccessDenied=2]="AccessDenied",m[m.ProcessNotFound=3]="ProcessNotFound"})(l||(e.TerminateResponseCode=l={}));function R(m,...k){const $=k.reduce((v,S)=>(v[S]=!0,v),{}),P=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/,/^CODE_SERVER_.+$/,/^CS_.+$/];Object.keys(m).filter(v=>!$[v]).forEach(v=>{for(let S=0;S<P.length;S++)if(v.search(P[S])!==-1){delete m[v];break}})}e.$ul=R;function A(m){m&&(delete m.DEBUG,y.$e&&delete m.DYLD_LIBRARY_PATH,y.$f&&delete m.LD_PRELOAD)}e.$vl=A}),function(ne,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var y=e();for(var M in y)(typeof exports=="object"?exports:ne)[M]=y[M]}}(typeof self<"u"?self:this,function(){return function(ne){var e={};function y(M){if(e[M])return e[M].exports;var l=e[M]={i:M,l:!1,exports:{}};return ne[M].call(l.exports,l,l.exports,y),l.l=!0,l.exports}return y.m=ne,y.c=e,y.d=function(M,l,R){y.o(M,l)||Object.defineProperty(M,l,{enumerable:!0,get:R})},y.r=function(M){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(M,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(M,"__esModule",{value:!0})},y.t=function(M,l){if(1&l&&(M=y(M)),8&l||4&l&&typeof M=="object"&&M&&M.__esModule)return M;var R=Object.create(null);if(y.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:M}),2&l&&typeof M!="string")for(var A in M)y.d(R,A,function(m){return M[m]}.bind(null,A));return R},y.n=function(M){var l=M&&M.__esModule?function(){return M.default}:function(){return M};return y.d(l,"a",l),l},y.o=function(M,l){return Object.prototype.hasOwnProperty.call(M,l)},y.p="",y(y.s=0)}([function(ne,e,y){(function(M){var l;e=ne.exports=ye,l=typeof M=="object"&&M.env&&M.env.NODE_DEBUG&&/\bsemver\b/i.test(M.env.NODE_DEBUG)?function(){var x=Array.prototype.slice.call(arguments,0);x.unshift("SEMVER"),console.log.apply(console,x)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var R=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,m=e.re=[],k=e.src=[],$=0,P=$++;k[P]="0|[1-9]\\d*";var C=$++;k[C]="[0-9]+";var v=$++;k[v]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var S=$++;k[S]="("+k[P]+")\\.("+k[P]+")\\.("+k[P]+")";var D=$++;k[D]="("+k[C]+")\\.("+k[C]+")\\.("+k[C]+")";var E=$++;k[E]="(?:"+k[P]+"|"+k[v]+")";var s=$++;k[s]="(?:"+k[C]+"|"+k[v]+")";var c=$++;k[c]="(?:-("+k[E]+"(?:\\."+k[E]+")*))";var u=$++;k[u]="(?:-?("+k[s]+"(?:\\."+k[s]+")*))";var o=$++;k[o]="[0-9A-Za-z-]+";var g=$++;k[g]="(?:\\+("+k[o]+"(?:\\."+k[o]+")*))";var d=$++,t="v?"+k[S]+k[c]+"?"+k[g]+"?";k[d]="^"+t+"$";var n="[v=\\s]*"+k[D]+k[u]+"?"+k[g]+"?",r=$++;k[r]="^"+n+"$";var i=$++;k[i]="((?:<|>)?=?)";var a=$++;k[a]=k[C]+"|x|X|\\*";var h=$++;k[h]=k[P]+"|x|X|\\*";var p=$++;k[p]="[v=\\s]*("+k[h]+")(?:\\.("+k[h]+")(?:\\.("+k[h]+")(?:"+k[c]+")?"+k[g]+"?)?)?";var I=$++;k[I]="[v=\\s]*("+k[a]+")(?:\\.("+k[a]+")(?:\\.("+k[a]+")(?:"+k[u]+")?"+k[g]+"?)?)?";var w=$++;k[w]="^"+k[i]+"\\s*"+k[p]+"$";var f=$++;k[f]="^"+k[i]+"\\s*"+k[I]+"$";var b=$++;k[b]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var L=$++;k[L]="(?:~>?)";var O=$++;k[O]="(\\s*)"+k[L]+"\\s+",m[O]=new RegExp(k[O],"g");var T=$++;k[T]="^"+k[L]+k[p]+"$";var F=$++;k[F]="^"+k[L]+k[I]+"$";var U=$++;k[U]="(?:\\^)";var N=$++;k[N]="(\\s*)"+k[U]+"\\s+",m[N]=new RegExp(k[N],"g");var j=$++;k[j]="^"+k[U]+k[p]+"$";var z=$++;k[z]="^"+k[U]+k[I]+"$";var B=$++;k[B]="^"+k[i]+"\\s*("+n+")$|^$";var ae=$++;k[ae]="^"+k[i]+"\\s*("+t+")$|^$";var X=$++;k[X]="(\\s*)"+k[i]+"\\s*("+n+"|"+k[p]+")",m[X]=new RegExp(k[X],"g");var Q=$++;k[Q]="^\\s*("+k[p]+")\\s+-\\s+("+k[p]+")\\s*$";var H=$++;k[H]="^\\s*("+k[I]+")\\s+-\\s+("+k[I]+")\\s*$";var te=$++;k[te]="(<|>)?=?\\s*\\*";for(var me=0;me<35;me++)l(me,k[me]),m[me]||(m[me]=new RegExp(k[me]));function le(x,$e){if(x instanceof ye)return x;if(typeof x!="string"||x.length>R||!($e?m[r]:m[d]).test(x))return null;try{return new ye(x,$e)}catch{return null}}function ye(x,$e){if(x instanceof ye){if(x.loose===$e)return x;x=x.version}else if(typeof x!="string")throw new TypeError("Invalid Version: "+x);if(x.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof ye))return new ye(x,$e);l("SemVer",x,$e),this.loose=$e;var ve=x.trim().match($e?m[r]:m[d]);if(!ve)throw new TypeError("Invalid Version: "+x);if(this.raw=x,this.major=+ve[1],this.minor=+ve[2],this.patch=+ve[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");ve[4]?this.prerelease=ve[4].split(".").map(function(Ne){if(/^[0-9]+$/.test(Ne)){var Ve=+Ne;if(Ve>=0&&Ve<A)return Ve}return Ne}):this.prerelease=[],this.build=ve[5]?ve[5].split("."):[],this.format()}e.parse=le,e.valid=function(x,$e){var ve=le(x,$e);return ve?ve.version:null},e.clean=function(x,$e){var ve=le(x.trim().replace(/^[=v]+/,""),$e);return ve?ve.version:null},e.SemVer=ye,ye.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ye.prototype.toString=function(){return this.version},ye.prototype.compare=function(x){return l("SemVer.compare",this.version,this.loose,x),x instanceof ye||(x=new ye(x,this.loose)),this.compareMain(x)||this.comparePre(x)},ye.prototype.compareMain=function(x){return x instanceof ye||(x=new ye(x,this.loose)),V(this.major,x.major)||V(this.minor,x.minor)||V(this.patch,x.patch)},ye.prototype.comparePre=function(x){if(x instanceof ye||(x=new ye(x,this.loose)),this.prerelease.length&&!x.prerelease.length)return-1;if(!this.prerelease.length&&x.prerelease.length)return 1;if(!this.prerelease.length&&!x.prerelease.length)return 0;var $e=0;do{var ve=this.prerelease[$e],Ne=x.prerelease[$e];if(l("prerelease compare",$e,ve,Ne),ve===void 0&&Ne===void 0)return 0;if(Ne===void 0)return 1;if(ve===void 0)return-1;if(ve!==Ne)return V(ve,Ne)}while(++$e)},ye.prototype.inc=function(x,$e){switch(x){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",$e);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",$e);break;case"prepatch":this.prerelease.length=0,this.inc("patch",$e),this.inc("pre",$e);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",$e),this.inc("pre",$e);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ve=this.prerelease.length;--ve>=0;)typeof this.prerelease[ve]=="number"&&(this.prerelease[ve]++,ve=-2);ve===-1&&this.prerelease.push(0)}$e&&(this.prerelease[0]===$e?isNaN(this.prerelease[1])&&(this.prerelease=[$e,0]):this.prerelease=[$e,0]);break;default:throw new Error("invalid increment argument: "+x)}return this.format(),this.raw=this.version,this},e.inc=function(x,$e,ve,Ne){typeof ve=="string"&&(Ne=ve,ve=void 0);try{return new ye(x,ve).inc($e,Ne).version}catch{return null}},e.diff=function(x,$e){if(Z(x,$e))return null;var ve=le(x),Ne=le($e);if(ve.prerelease.length||Ne.prerelease.length){for(var Ve in ve)if((Ve==="major"||Ve==="minor"||Ve==="patch")&&ve[Ve]!==Ne[Ve])return"pre"+Ve;return"prerelease"}for(var Ve in ve)if((Ve==="major"||Ve==="minor"||Ve==="patch")&&ve[Ve]!==Ne[Ve])return Ve},e.compareIdentifiers=V;var de=/^[0-9]+$/;function V(x,$e){var ve=de.test(x),Ne=de.test($e);return ve&&Ne&&(x=+x,$e=+$e),ve&&!Ne?-1:Ne&&!ve?1:x<$e?-1:x>$e?1:0}function J(x,$e,ve){return new ye(x,ve).compare(new ye($e,ve))}function ee(x,$e,ve){return J(x,$e,ve)>0}function Y(x,$e,ve){return J(x,$e,ve)<0}function Z(x,$e,ve){return J(x,$e,ve)===0}function _(x,$e,ve){return J(x,$e,ve)!==0}function pe(x,$e,ve){return J(x,$e,ve)>=0}function se(x,$e,ve){return J(x,$e,ve)<=0}function ge(x,$e,ve,Ne){var Ve;switch($e){case"===":typeof x=="object"&&(x=x.version),typeof ve=="object"&&(ve=ve.version),Ve=x===ve;break;case"!==":typeof x=="object"&&(x=x.version),typeof ve=="object"&&(ve=ve.version),Ve=x!==ve;break;case"":case"=":case"==":Ve=Z(x,ve,Ne);break;case"!=":Ve=_(x,ve,Ne);break;case">":Ve=ee(x,ve,Ne);break;case">=":Ve=pe(x,ve,Ne);break;case"<":Ve=Y(x,ve,Ne);break;case"<=":Ve=se(x,ve,Ne);break;default:throw new TypeError("Invalid operator: "+$e)}return Ve}function ie(x,$e){if(x instanceof ie){if(x.loose===$e)return x;x=x.value}if(!(this instanceof ie))return new ie(x,$e);l("comparator",x,$e),this.loose=$e,this.parse(x),this.semver===fe?this.value="":this.value=this.operator+this.semver.version,l("comp",this)}e.rcompareIdentifiers=function(x,$e){return V($e,x)},e.major=function(x,$e){return new ye(x,$e).major},e.minor=function(x,$e){return new ye(x,$e).minor},e.patch=function(x,$e){return new ye(x,$e).patch},e.compare=J,e.compareLoose=function(x,$e){return J(x,$e,!0)},e.rcompare=function(x,$e,ve){return J($e,x,ve)},e.sort=function(x,$e){return x.sort(function(ve,Ne){return e.compare(ve,Ne,$e)})},e.rsort=function(x,$e){return x.sort(function(ve,Ne){return e.rcompare(ve,Ne,$e)})},e.gt=ee,e.lt=Y,e.eq=Z,e.neq=_,e.gte=pe,e.lte=se,e.cmp=ge,e.Comparator=ie;var fe={};function be(x,$e){if(x instanceof be)return x.loose===$e?x:new be(x.raw,$e);if(x instanceof ie)return new be(x.value,$e);if(!(this instanceof be))return new be(x,$e);if(this.loose=$e,this.raw=x,this.set=x.split(/\s*\|\|\s*/).map(function(ve){return this.parseRange(ve.trim())},this).filter(function(ve){return ve.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+x);this.format()}function Ie(x){return!x||x.toLowerCase()==="x"||x==="*"}function W(x,$e,ve,Ne,Ve,xe,Qe,rt,it,nt,Ae,Fe,Le){return(($e=Ie(ve)?"":Ie(Ne)?">="+ve+".0.0":Ie(Ve)?">="+ve+"."+Ne+".0":">="+$e)+" "+(rt=Ie(it)?"":Ie(nt)?"<"+(+it+1)+".0.0":Ie(Ae)?"<"+it+"."+(+nt+1)+".0":Fe?"<="+it+"."+nt+"."+Ae+"-"+Fe:"<="+rt)).trim()}function G(x,$e){for(var ve=0;ve<x.length;ve++)if(!x[ve].test($e))return!1;if($e.prerelease.length){for(ve=0;ve<x.length;ve++)if(l(x[ve].semver),x[ve].semver!==fe&&x[ve].semver.prerelease.length>0){var Ne=x[ve].semver;if(Ne.major===$e.major&&Ne.minor===$e.minor&&Ne.patch===$e.patch)return!0}return!1}return!0}function ce(x,$e,ve){try{$e=new be($e,ve)}catch{return!1}return $e.test(x)}function he(x,$e,ve,Ne){var Ve,xe,Qe,rt,it;switch(x=new ye(x,Ne),$e=new be($e,Ne),ve){case">":Ve=ee,xe=se,Qe=Y,rt=">",it=">=";break;case"<":Ve=Y,xe=pe,Qe=ee,rt="<",it="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ce(x,$e,Ne))return!1;for(var nt=0;nt<$e.set.length;++nt){var Ae=$e.set[nt],Fe=null,Le=null;if(Ae.forEach(function(Je){Je.semver===fe&&(Je=new ie(">=0.0.0")),Fe=Fe||Je,Le=Le||Je,Ve(Je.semver,Fe.semver,Ne)?Fe=Je:Qe(Je.semver,Le.semver,Ne)&&(Le=Je)}),Fe.operator===rt||Fe.operator===it||(!Le.operator||Le.operator===rt)&&xe(x,Le.semver)||Le.operator===it&&Qe(x,Le.semver))return!1}return!0}ie.prototype.parse=function(x){var $e=this.loose?m[B]:m[ae],ve=x.match($e);if(!ve)throw new TypeError("Invalid comparator: "+x);this.operator=ve[1],this.operator==="="&&(this.operator=""),ve[2]?this.semver=new ye(ve[2],this.loose):this.semver=fe},ie.prototype.toString=function(){return this.value},ie.prototype.test=function(x){return l("Comparator.test",x,this.loose),this.semver===fe||(typeof x=="string"&&(x=new ye(x,this.loose)),ge(x,this.operator,this.semver,this.loose))},ie.prototype.intersects=function(x,$e){if(!(x instanceof ie))throw new TypeError("a Comparator is required");var ve;if(this.operator==="")return ve=new be(x.value,$e),ce(this.value,ve,$e);if(x.operator==="")return ve=new be(this.value,$e),ce(x.semver,ve,$e);var Ne=!(this.operator!==">="&&this.operator!==">"||x.operator!==">="&&x.operator!==">"),Ve=!(this.operator!=="<="&&this.operator!=="<"||x.operator!=="<="&&x.operator!=="<"),xe=this.semver.version===x.semver.version,Qe=!(this.operator!==">="&&this.operator!=="<="||x.operator!==">="&&x.operator!=="<="),rt=ge(this.semver,"<",x.semver,$e)&&(this.operator===">="||this.operator===">")&&(x.operator==="<="||x.operator==="<"),it=ge(this.semver,">",x.semver,$e)&&(this.operator==="<="||this.operator==="<")&&(x.operator===">="||x.operator===">");return Ne||Ve||xe&&Qe||rt||it},e.Range=be,be.prototype.format=function(){return this.range=this.set.map(function(x){return x.join(" ").trim()}).join("||").trim(),this.range},be.prototype.toString=function(){return this.range},be.prototype.parseRange=function(x){var $e=this.loose;x=x.trim(),l("range",x,$e);var ve=$e?m[H]:m[Q];x=x.replace(ve,W),l("hyphen replace",x),x=x.replace(m[X],"$1$2$3"),l("comparator trim",x,m[X]),x=(x=(x=x.replace(m[O],"$1~")).replace(m[N],"$1^")).split(/\s+/).join(" ");var Ne=$e?m[B]:m[ae],Ve=x.split(" ").map(function(xe){return function(Qe,rt){return l("comp",Qe),Qe=function(it,nt){return it.trim().split(/\s+/).map(function(Ae){return function(Fe,Le){l("caret",Fe,Le);var Je=Le?m[z]:m[j];return Fe.replace(Je,function(ue,oe,Ce,He,ze){var Ze;return l("caret",Fe,ue,oe,Ce,He,ze),Ie(oe)?Ze="":Ie(Ce)?Ze=">="+oe+".0.0 <"+(+oe+1)+".0.0":Ie(He)?Ze=oe==="0"?">="+oe+"."+Ce+".0 <"+oe+"."+(+Ce+1)+".0":">="+oe+"."+Ce+".0 <"+(+oe+1)+".0.0":ze?(l("replaceCaret pr",ze),ze.charAt(0)!=="-"&&(ze="-"+ze),Ze=oe==="0"?Ce==="0"?">="+oe+"."+Ce+"."+He+ze+" <"+oe+"."+Ce+"."+(+He+1):">="+oe+"."+Ce+"."+He+ze+" <"+oe+"."+(+Ce+1)+".0":">="+oe+"."+Ce+"."+He+ze+" <"+(+oe+1)+".0.0"):(l("no pr"),Ze=oe==="0"?Ce==="0"?">="+oe+"."+Ce+"."+He+" <"+oe+"."+Ce+"."+(+He+1):">="+oe+"."+Ce+"."+He+" <"+oe+"."+(+Ce+1)+".0":">="+oe+"."+Ce+"."+He+" <"+(+oe+1)+".0.0"),l("caret return",Ze),Ze})}(Ae,nt)}).join(" ")}(Qe,rt),l("caret",Qe),Qe=function(it,nt){return it.trim().split(/\s+/).map(function(Ae){return function(Fe,Le){var Je=Le?m[F]:m[T];return Fe.replace(Je,function(ue,oe,Ce,He,ze){var Ze;return l("tilde",Fe,ue,oe,Ce,He,ze),Ie(oe)?Ze="":Ie(Ce)?Ze=">="+oe+".0.0 <"+(+oe+1)+".0.0":Ie(He)?Ze=">="+oe+"."+Ce+".0 <"+oe+"."+(+Ce+1)+".0":ze?(l("replaceTilde pr",ze),ze.charAt(0)!=="-"&&(ze="-"+ze),Ze=">="+oe+"."+Ce+"."+He+ze+" <"+oe+"."+(+Ce+1)+".0"):Ze=">="+oe+"."+Ce+"."+He+" <"+oe+"."+(+Ce+1)+".0",l("tilde return",Ze),Ze})}(Ae,nt)}).join(" ")}(Qe,rt),l("tildes",Qe),Qe=function(it,nt){return l("replaceXRanges",it,nt),it.split(/\s+/).map(function(Ae){return function(Fe,Le){Fe=Fe.trim();var Je=Le?m[f]:m[w];return Fe.replace(Je,function(ue,oe,Ce,He,ze,Ze){l("xRange",Fe,ue,oe,Ce,He,ze,Ze);var st=Ie(Ce),lt=st||Ie(He),wt=lt||Ie(ze);return oe==="="&&wt&&(oe=""),st?ue=oe===">"||oe==="<"?"<0.0.0":"*":oe&&wt?(lt&&(He=0),wt&&(ze=0),oe===">"?(oe=">=",lt?(Ce=+Ce+1,He=0,ze=0):wt&&(He=+He+1,ze=0)):oe==="<="&&(oe="<",lt?Ce=+Ce+1:He=+He+1),ue=oe+Ce+"."+He+"."+ze):lt?ue=">="+Ce+".0.0 <"+(+Ce+1)+".0.0":wt&&(ue=">="+Ce+"."+He+".0 <"+Ce+"."+(+He+1)+".0"),l("xRange return",ue),ue})}(Ae,nt)}).join(" ")}(Qe,rt),l("xrange",Qe),Qe=function(it,nt){return l("replaceStars",it,nt),it.trim().replace(m[te],"")}(Qe,rt),l("stars",Qe),Qe}(xe,$e)}).join(" ").split(/\s+/);return this.loose&&(Ve=Ve.filter(function(xe){return!!xe.match(Ne)})),Ve=Ve.map(function(xe){return new ie(xe,$e)})},be.prototype.intersects=function(x,$e){if(!(x instanceof be))throw new TypeError("a Range is required");return this.set.some(function(ve){return ve.every(function(Ne){return x.set.some(function(Ve){return Ve.every(function(xe){return Ne.intersects(xe,$e)})})})})},e.toComparators=function(x,$e){return new be(x,$e).set.map(function(ve){return ve.map(function(Ne){return Ne.value}).join(" ").trim().split(" ")})},be.prototype.test=function(x){if(!x)return!1;typeof x=="string"&&(x=new ye(x,this.loose));for(var $e=0;$e<this.set.length;$e++)if(G(this.set[$e],x))return!0;return!1},e.satisfies=ce,e.maxSatisfying=function(x,$e,ve){var Ne=null,Ve=null;try{var xe=new be($e,ve)}catch{return null}return x.forEach(function(Qe){xe.test(Qe)&&(Ne&&Ve.compare(Qe)!==-1||(Ve=new ye(Ne=Qe,ve)))}),Ne},e.minSatisfying=function(x,$e,ve){var Ne=null,Ve=null;try{var xe=new be($e,ve)}catch{return null}return x.forEach(function(Qe){xe.test(Qe)&&(Ne&&Ve.compare(Qe)!==1||(Ve=new ye(Ne=Qe,ve)))}),Ne},e.validRange=function(x,$e){try{return new be(x,$e).range||"*"}catch{return null}},e.ltr=function(x,$e,ve){return he(x,$e,"<",ve)},e.gtr=function(x,$e,ve){return he(x,$e,">",ve)},e.outside=he,e.prerelease=function(x,$e){var ve=le(x,$e);return ve&&ve.prerelease.length?ve.prerelease:null},e.intersects=function(x,$e,ve){return x=new be(x,ve),$e=new be($e,ve),x.intersects($e)},e.coerce=function(x){if(x instanceof ye)return x;if(typeof x!="string")return null;var $e=x.match(m[b]);return $e==null?null:le(($e[1]||"0")+"."+($e[2]||"0")+"."+($e[3]||"0"))}}).call(this,y(1))},function(ne,e){var y,M,l=ne.exports={};function R(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function m(s){if(y===setTimeout)return setTimeout(s,0);if((y===R||!y)&&setTimeout)return y=setTimeout,setTimeout(s,0);try{return y(s,0)}catch{try{return y.call(null,s,0)}catch{return y.call(this,s,0)}}}(function(){try{y=typeof setTimeout=="function"?setTimeout:R}catch{y=R}try{M=typeof clearTimeout=="function"?clearTimeout:A}catch{M=A}})();var k,$=[],P=!1,C=-1;function v(){P&&k&&(P=!1,k.length?$=k.concat($):C=-1,$.length&&S())}function S(){if(!P){var s=m(v);P=!0;for(var c=$.length;c;){for(k=$,$=[];++C<c;)k&&k[C].run();C=-1,c=$.length}k=null,P=!1,function(u){if(M===clearTimeout)return clearTimeout(u);if((M===A||!M)&&clearTimeout)return M=clearTimeout,clearTimeout(u);try{M(u)}catch{try{return M.call(null,u)}catch{return M.call(this,u)}}}(s)}}function D(s,c){this.fun=s,this.array=c}function E(){}l.nextTick=function(s){var c=new Array(arguments.length-1);if(arguments.length>1)for(var u=1;u<arguments.length;u++)c[u-1]=arguments[u];$.push(new D(s,c)),$.length!==1||P||m(S)},D.prototype.run=function(){this.fun.apply(null,this.array)},l.title="browser",l.browser=!0,l.env={},l.argv=[],l.version="",l.versions={},l.on=E,l.addListener=E,l.once=E,l.off=E,l.removeListener=E,l.removeAllListeners=E,l.emit=E,l.prependListener=E,l.prependOnceListener=E,l.listeners=function(s){return[]},l.binding=function(s){throw new Error("process.binding is not supported")},l.cwd=function(){return"/"},l.chdir=function(s){throw new Error("process.chdir is not supported")},l.umask=function(){return 0}}])}),define(Se[38],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hd=void 0;const y=globalThis.performance&&typeof globalThis.performance.now=="function";class M{static create(R){return new M(R)}constructor(R){this.c=y&&R===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$Hd=M}),define(Se[4],De([1,0,8,75,3,76,38]),function(ne,e,y,M,l,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ud=e.$Td=e.$Sd=e.$Rd=e.$Qd=e.$Pd=e.$Od=e.$Nd=e.$Md=e.$Ld=e.$Kd=e.$Jd=e.Event=void 0;const m=!1,k=!1;var $;(function(w){w.None=()=>l.$Qc.None;function f(ge){if(k){const{onDidAddListener:ie}=ge,fe=D.create();let be=0;ge.onDidAddListener=()=>{++be===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),fe.print()),ie?.()}}}function b(ge,ie){return ae(ge,()=>{},0,void 0,!0,void 0,ie)}w.defer=b;function L(ge){return(ie,fe=null,be)=>{let Ie=!1,W;return W=ge(G=>{if(!Ie)return W?W.dispose():Ie=!0,ie.call(fe,G)},null,be),Ie&&W.dispose(),W}}w.once=L;function O(ge,ie,fe){return z((be,Ie=null,W)=>ge(G=>be.call(Ie,ie(G)),null,W),fe)}w.map=O;function T(ge,ie,fe){return z((be,Ie=null,W)=>ge(G=>{ie(G),be.call(Ie,G)},null,W),fe)}w.forEach=T;function F(ge,ie,fe){return z((be,Ie=null,W)=>ge(G=>ie(G)&&be.call(Ie,G),null,W),fe)}w.filter=F;function U(ge){return ge}w.signal=U;function N(...ge){return(ie,fe=null,be)=>{const Ie=(0,l.$Nc)(...ge.map(W=>W(G=>ie.call(fe,G))));return B(Ie,be)}}w.any=N;function j(ge,ie,fe,be){let Ie=fe;return O(ge,W=>(Ie=ie(Ie,W),Ie),be)}w.reduce=j;function z(ge,ie){let fe;const be={onWillAddFirstListener(){fe=ge(Ie.fire,Ie)},onDidRemoveLastListener(){fe?.dispose()}};ie||f(be);const Ie=new o(be);return ie?.add(Ie),Ie.event}function B(ge,ie){return ie instanceof Array?ie.push(ge):ie&&ie.add(ge),ge}function ae(ge,ie,fe=100,be=!1,Ie=!1,W,G){let ce,he,x,$e=0,ve;const Ne={leakWarningThreshold:W,onWillAddFirstListener(){ce=ge(xe=>{$e++,he=ie(he,xe),be&&!x&&(Ve.fire(he),he=void 0),ve=()=>{const Qe=he;he=void 0,x=void 0,(!be||$e>1)&&Ve.fire(Qe),$e=0},typeof fe=="number"?(clearTimeout(x),x=setTimeout(ve,fe)):x===void 0&&(x=0,queueMicrotask(ve))})},onWillRemoveListener(){Ie&&$e>0&&ve?.()},onDidRemoveLastListener(){ve=void 0,ce.dispose()}};G||f(Ne);const Ve=new o(Ne);return G?.add(Ve),Ve.event}w.debounce=ae;function X(ge,ie=0,fe){return w.debounce(ge,(be,Ie)=>be?(be.push(Ie),be):[Ie],ie,void 0,!0,void 0,fe)}w.accumulate=X;function Q(ge,ie=(be,Ie)=>be===Ie,fe){let be=!0,Ie;return F(ge,W=>{const G=be||!ie(W,Ie);return be=!1,Ie=W,G},fe)}w.latch=Q;function H(ge,ie,fe){return[w.filter(ge,ie,fe),w.filter(ge,be=>!ie(be),fe)]}w.split=H;function te(ge,ie=!1,fe=[],be){let Ie=fe.slice(),W=ge(he=>{Ie?Ie.push(he):ce.fire(he)});be&&be.add(W);const G=()=>{Ie?.forEach(he=>ce.fire(he)),Ie=null},ce=new o({onWillAddFirstListener(){W||(W=ge(he=>ce.fire(he)),be&&be.add(W))},onDidAddFirstListener(){Ie&&(ie?setTimeout(G):G())},onDidRemoveLastListener(){W&&W.dispose(),W=null}});return be&&be.add(ce),ce.event}w.buffer=te;function me(ge,ie){return(be,Ie,W)=>{const G=ie(new ye);return ge(function(ce){const he=G.evaluate(ce);he!==le&&be.call(Ie,he)},void 0,W)}}w.chain=me;const le=Symbol("HaltChainable");class ye{constructor(){this.f=[]}map(ie){return this.f.push(ie),this}forEach(ie){return this.f.push(fe=>(ie(fe),fe)),this}filter(ie){return this.f.push(fe=>ie(fe)?fe:le),this}reduce(ie,fe){let be=fe;return this.f.push(Ie=>(be=ie(be,Ie),be)),this}latch(ie=(fe,be)=>fe===be){let fe=!0,be;return this.f.push(Ie=>{const W=fe||!ie(Ie,be);return fe=!1,be=Ie,W?Ie:le}),this}evaluate(ie){for(const fe of this.f)if(ie=fe(ie),ie===le)break;return ie}}function de(ge,ie,fe=be=>be){const be=(...ce)=>G.fire(fe(...ce)),Ie=()=>ge.on(ie,be),W=()=>ge.removeListener(ie,be),G=new o({onWillAddFirstListener:Ie,onDidRemoveLastListener:W});return G.event}w.fromNodeEventEmitter=de;function V(ge,ie,fe=be=>be){const be=(...ce)=>G.fire(fe(...ce)),Ie=()=>ge.addEventListener(ie,be),W=()=>ge.removeEventListener(ie,be),G=new o({onWillAddFirstListener:Ie,onDidRemoveLastListener:W});return G.event}w.fromDOMEventEmitter=V;function J(ge){return new Promise(ie=>L(ge)(ie))}w.toPromise=J;function ee(ge){const ie=new o;return ge.then(fe=>{ie.fire(fe)},()=>{ie.fire(void 0)}).finally(()=>{ie.dispose()}),ie.event}w.fromPromise=ee;function Y(ge,ie){return ie(void 0),ge(fe=>ie(fe))}w.runAndSubscribe=Y;function Z(ge,ie){let fe=null;function be(W){fe?.dispose(),fe=new l.$Pc,ie(W,fe)}be(void 0);const Ie=ge(W=>be(W));return(0,l.$Oc)(()=>{Ie.dispose(),fe?.dispose()})}w.runAndSubscribeWithStore=Z;class _{constructor(ie,fe){this._observable=ie,this.f=0,this.g=!1;const be={onWillAddFirstListener:()=>{ie.addObserver(this)},onDidRemoveLastListener:()=>{ie.removeObserver(this)}};fe||f(be),this.emitter=new o(be),fe&&fe.add(this.emitter)}beginUpdate(ie){this.f++}handlePossibleChange(ie){}handleChange(ie,fe){this.g=!0}endUpdate(ie){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function pe(ge,ie){return new _(ge,ie).emitter.event}w.fromObservable=pe;function se(ge){return ie=>{let fe=0,be=!1;const Ie={beginUpdate(){fe++},endUpdate(){fe--,fe===0&&(ge.reportChanges(),be&&(be=!1,ie()))},handlePossibleChange(){},handleChange(){be=!0}};return ge.addObserver(Ie),ge.reportChanges(),{dispose(){ge.removeObserver(Ie)}}}}w.fromObservableLight=se})($||(e.Event=$={}));class P{constructor(f){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${f}_${P.f++}`,P.all.add(this)}start(f){this.g=new A.$Hd,this.listenerCount=f}stop(){if(this.g){const f=this.g.elapsed();this.durations.push(f),this.elapsedOverall+=f,this.invocationCount+=1,this.g=void 0}}}e.$Jd=P,P.all=new Set,P.f=0;let C=-1;function v(w){const f=C;return C=w,{dispose(){C=f}}}e.$Kd=v;class S{constructor(f,b=Math.random().toString(18).slice(2,5)){this.threshold=f,this.name=b,this.g=0}dispose(){this.f?.clear()}check(f,b){const L=this.threshold;if(L<=0||b<L)return;this.f||(this.f=new Map);const O=this.f.get(f.value)||0;if(this.f.set(f.value,O+1),this.g-=1,this.g<=0){this.g=L*.5;let T,F=0;for(const[U,N]of this.f)(!T||F<N)&&(T=U,F=N);console.warn(`[${this.name}] potential listener LEAK detected, having ${b} listeners already. MOST frequent listener (${F}):`),console.warn(T)}return()=>{const T=this.f.get(f.value)||0;this.f.set(f.value,T-1)}}}class D{static create(){return new D(new Error().stack??"")}constructor(f){this.value=f}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let E=0;class s{constructor(f){this.value=f,this.id=E++}}const c=2,u=(w,f)=>{if(w instanceof s)f(w);else for(let b=0;b<w.length;b++){const L=w[b];L&&f(L)}};class o{constructor(f){this.x=0,this.f=f,this.g=C>0||this.f?.leakWarningThreshold?new S(this.f?.leakWarningThreshold??C):void 0,this.j=this.f?._profName?new P(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(m){const f=this.t;queueMicrotask(()=>{u(f,b=>b.stack?.print())})}this.t=void 0,this.x=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??(this.q=(f,b,L)=>{if(this.g&&this.x>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),l.$Qc.None;if(this.m)return l.$Qc.None;b&&(f=f.bind(b));const O=new s(f);let T,F;this.g&&this.x>=Math.ceil(this.g.threshold*.2)&&(O.stack=D.create(),T=this.g.check(O.stack,this.x+1)),m&&(O.stack=F??D.create()),this.t?this.t instanceof s?(this.u??(this.u=new d),this.t=[this.t,O]):this.t.push(O):(this.f?.onWillAddFirstListener?.(this),this.t=O,this.f?.onDidAddFirstListener?.(this)),this.x++;const U=(0,l.$Oc)(()=>{T?.(),this.y(O)});return L instanceof l.$Pc?L.add(U):Array.isArray(L)&&L.push(U),U}),this.q}y(f){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.x===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.x=0;return}const b=this.t,L=b.indexOf(f);if(L===-1)throw console.log("disposed?",this.m),console.log("size?",this.x),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.x--,b[L]=void 0;const O=this.u.current===this;if(this.x*c<=b.length){let T=0;for(let F=0;F<b.length;F++)b[F]?b[T++]=b[F]:O&&(this.u.end--,T<this.u.i&&this.u.i--);b.length=T}}z(f,b){if(!f)return;const L=this.f?.onListenerError||y.$Y;if(!L){f.value(b);return}try{f.value(b)}catch(O){L(O)}}A(f){const b=f.current.t;for(;f.i<f.end;)this.z(b[f.i++],f.value);f.reset()}fire(f){if(this.u?.current&&(this.A(this.u),this.j?.stop()),this.j?.start(this.x),this.t)if(this.t instanceof s)this.z(this.t,f);else{const b=this.u;b.enqueue(this,f,this.t.length),this.A(b)}this.j?.stop()}hasListeners(){return this.x>0}}e.$Ld=o;const g=()=>new d;e.$Md=g;class d{constructor(){this.i=-1,this.end=0}enqueue(f,b,L){this.i=0,this.end=L,this.current=f,this.value=b}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class t extends o{async fireAsync(f,b,L){if(this.t)for(this.h||(this.h=new R.$Zc),u(this.t,O=>this.h.push([O.value,f]));this.h.size>0&&!b.isCancellationRequested;){const[O,T]=this.h.shift(),F=[],U={...T,token:b,waitUntil:N=>{if(Object.isFrozen(F))throw new Error("waitUntil can NOT be called asynchronous");L&&(N=L(N,O)),F.push(N)}};try{O(U)}catch(N){(0,y.$Y)(N);continue}Object.freeze(F),await Promise.allSettled(F).then(N=>{for(const j of N)j.status==="rejected"&&(0,y.$Y)(j.reason)})}}}e.$Nd=t;class n extends o{get isPaused(){return this.h!==0}constructor(f){super(f),this.h=0,this.s=new R.$Zc,this.w=f?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.w){if(this.s.size>0){const f=Array.from(this.s);this.s.clear(),super.fire(this.w(f))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(f){this.x&&(this.h!==0?this.s.push(f):super.fire(f))}}e.$Od=n;class r extends n{constructor(f){super(f),this.k=f.delay??100}fire(f){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(f)}}e.$Pd=r;class i extends o{constructor(f){super(f),this.h=[],this.k=f?.merge}fire(f){this.hasListeners()&&(this.h.push(f),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(b=>super.fire(b)),this.h=[]}))}}e.$Qd=i;class a{constructor(){this.g=!1,this.h=[],this.f=new o({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(f){const b={event:f,listener:null};this.h.push(b),this.g&&this.m(b);const L=()=>{this.g&&this.o(b);const O=this.h.indexOf(b);this.h.splice(O,1)};return(0,l.$Oc)((0,M.$bb)(L))}j(){this.g=!0,this.h.forEach(f=>this.m(f))}k(){this.g=!1,this.h.forEach(f=>this.o(f))}m(f){f.listener=f.event(b=>this.f.fire(b))}o(f){f.listener&&f.listener.dispose(),f.listener=null}dispose(){this.f.dispose()}}e.$Rd=a;class h{constructor(f,b,L,O){this.f=new l.$Pc;const T=this.f.add(new a),F=this.f.add(new l.$Yc);function U(N){F.set(N,T.add(O(N)))}for(const N of f)U(N);this.f.add(b(N=>{U(N)})),this.f.add(L(N=>{F.deleteAndDispose(N)})),this.event=T.event}dispose(){this.f.dispose()}}e.$Sd=h;class p{constructor(){this.f=[]}wrapEvent(f){return(b,L,O)=>f(T=>{const F=this.f[this.f.length-1];F?F.push(()=>b.call(L,T)):b.call(L,T)},void 0,O)}bufferEvents(f){const b=[];this.f.push(b);const L=f();return this.f.pop(),b.forEach(O=>O()),L}}e.$Td=p;class I{constructor(){this.f=!1,this.g=$.None,this.h=l.$Qc.None,this.j=new o({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(f){this.g=f,this.f&&(this.h.dispose(),this.h=f(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$Ud=I}),define(Se[21],De([1,0,4]),function(ne,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vd=e.CancellationToken=void 0;const M=Object.freeze(function(m,k){const $=setTimeout(m.bind(k),0);return{dispose(){clearTimeout($)}}});var l;(function(m){function k($){return $===m.None||$===m.Cancelled||$ instanceof R?!0:!$||typeof $!="object"?!1:typeof $.isCancellationRequested=="boolean"&&typeof $.onCancellationRequested=="function"}m.isCancellationToken=k,m.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:y.Event.None}),m.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:M})})(l||(e.CancellationToken=l={}));class R{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?M:(this.b||(this.b=new y.$Ld),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class A{constructor(k){this.f=void 0,this.g=void 0,this.g=k&&k.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new R),this.f}cancel(){this.f?this.f instanceof R&&this.f.cancel():this.f=l.Cancelled}dispose(k=!1){k&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof R&&this.f.dispose():this.f=l.None}}e.$Vd=A}),define(Se[160],De([1,0,21]),function(ne,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$we=e.$ve=e.$ue=void 0;class M{constructor(m){this.b=m,this.a=null}get(){if(this.a)return this.a;const m=new y.$Vd,k=this.b(m.token);return this.a={promise:k,dispose:()=>{this.a=null,m.cancel(),m.dispose()}},this.a}}e.$ue=M;class l{constructor(m){this.c=m,this.a=void 0,this.b=void 0}get(m){const k=JSON.stringify(m);return this.b!==k&&(this.b=k,this.a=this.c(m)),this.a}}e.$ve=l;class R{get cachedValues(){return this.a}constructor(m){this.b=m,this.a=new Map}get(m){if(this.a.has(m))return this.a.get(m);const k=this.b(m);return this.a.set(m,k),k}}e.$we=R}),define(Se[99],De([1,0,8,3]),function(ne,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.$3d=e.$2d=e.$1d=e.$Zd=e.$Yd=e.$Xd=e.$Wd=void 0;function l(g){const d=g;return d?typeof d.read=="function":!1}e.$Wd=l;function R(g){const d=g;return d?[d.on,d.pause,d.resume,d.destroy].every(t=>typeof t=="function"):!1}e.$Xd=R;function A(g){const d=g;return d?R(d.stream)&&Array.isArray(d.buffer)&&typeof d.ended=="boolean":!1}e.$Yd=A;function m(g,d){return new k(g,d)}e.$Zd=m;class k{constructor(d,t){this.e=d,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(d){if(!this.a.destroyed){if(this.a.flowing)this.g(d);else if(this.b.data.push(d),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(d){this.a.destroyed||(this.a.flowing?this.h(d):this.b.error.push(d))}end(d){this.a.destroyed||(typeof d<"u"&&this.write(d),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(d){this.c.data.slice(0).forEach(t=>t(d))}h(d){this.c.error.length===0?(0,y.$Y)(d):this.c.error.slice(0).forEach(t=>t(d))}i(){this.c.end.slice(0).forEach(d=>d())}on(d,t){if(!this.a.destroyed)switch(d){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(d,t){if(this.a.destroyed)return;let n;switch(d){case"data":n=this.c.data;break;case"end":n=this.c.end;break;case"error":n=this.c.error;break}if(n){const r=n.indexOf(t);r>=0&&n.splice(r,1)}}j(){if(this.b.data.length>0){const d=this.e(this.b.data);this.g(d),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(n=>n())}}k(){if(this.c.error.length>0){for(const d of this.b.error)this.h(d);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function $(g,d){const t=[];let n;for(;(n=g.read())!==null;)t.push(n);return d(t)}e.$1d=$;function P(g,d,t){const n=[];let r;for(;(r=g.read())!==null&&n.length<t;)n.push(r);return r===null&&n.length>0?d(n):{read:()=>{if(n.length>0)return n.shift();if(typeof r<"u"){const i=r;return r=void 0,i}return g.read()}}}e.$2d=P;function C(g,d){return new Promise((t,n)=>{const r=[];v(g,{onData:i=>{d&&r.push(i)},onError:i=>{d?n(i):t(void 0)},onEnd:()=>{t(d?d(r):void 0)}})})}e.$3d=C;function v(g,d,t){g.on("error",n=>{t?.isCancellationRequested||d.onError(n)}),g.on("end",()=>{t?.isCancellationRequested||d.onEnd()}),g.on("data",n=>{t?.isCancellationRequested||d.onData(n)})}e.$4d=v;function S(g,d){return new Promise((t,n)=>{const r=new M.$Pc,i=[],a=I=>{if(i.push(I),i.length>d)return r.dispose(),g.pause(),t({stream:g,buffer:i,ended:!1})},h=I=>(r.dispose(),n(I)),p=()=>(r.dispose(),t({stream:g,buffer:i,ended:!0}));r.add((0,M.$Oc)(()=>g.removeListener("error",h))),g.on("error",h),r.add((0,M.$Oc)(()=>g.removeListener("end",p))),g.on("end",p),r.add((0,M.$Oc)(()=>g.removeListener("data",a))),g.on("data",a)})}e.$5d=S;function D(g,d){const t=m(d);return t.end(g),t}e.$6d=D;function E(){const g=m(()=>{throw new Error("not supported")});return g.end(),g}e.$7d=E;function s(g){let d=!1;return{read:()=>d?null:(d=!0,g)}}e.$8d=s;function c(g,d,t){const n=m(t);return v(g,{onData:r=>n.write(d.data(r)),onError:r=>n.error(d.error?d.error(r):r),onEnd:()=>n.end()}),n}e.$9d=c;function u(g,d,t){let n=!1;return{read:()=>{const r=d.read();return n?r:(n=!0,r!==null?t([g,r]):g)}}}e.$0d=u;function o(g,d,t){let n=!1;const r=m(t);return v(d,{onData:i=>n?r.write(i):(n=!0,r.write(t([g,i]))),onError:i=>r.error(i),onEnd:()=>{n||(n=!0,r.write(g)),r.end()}}),r}e.$$d=o}),define(Se[22],De([1,0,58,99]),function(ne,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=e.$be=e.$ae=e.$_d=void 0;const l=typeof Buffer<"u",R=new y.$T(()=>new Uint8Array(256));let A,m;class k{static alloc(b){return l?new k(Buffer.allocUnsafe(b)):new k(new Uint8Array(b))}static wrap(b){return l&&!Buffer.isBuffer(b)&&(b=Buffer.from(b.buffer,b.byteOffset,b.byteLength)),new k(b)}static fromString(b,L){return!(L?.dontUseNodeBuffer||!1)&&l?new k(Buffer.from(b)):(A||(A=new TextEncoder),new k(A.encode(b)))}static fromByteArray(b){const L=k.alloc(b.length);for(let O=0,T=b.length;O<T;O++)L.buffer[O]=b[O];return L}static concat(b,L){if(typeof L>"u"){L=0;for(let F=0,U=b.length;F<U;F++)L+=b[F].byteLength}const O=k.alloc(L);let T=0;for(let F=0,U=b.length;F<U;F++){const N=b[F];O.set(N,T),T+=N.byteLength}return O}constructor(b){this.buffer=b,this.byteLength=this.buffer.byteLength}clone(){const b=k.alloc(this.byteLength);return b.set(this),b}toString(){return l?this.buffer.toString():(m||(m=new TextDecoder),m.decode(this.buffer))}slice(b,L){return new k(this.buffer.subarray(b,L))}set(b,L){if(b instanceof k)this.buffer.set(b.buffer,L);else if(b instanceof Uint8Array)this.buffer.set(b,L);else if(b instanceof ArrayBuffer)this.buffer.set(new Uint8Array(b),L);else if(ArrayBuffer.isView(b))this.buffer.set(new Uint8Array(b.buffer,b.byteOffset,b.byteLength),L);else throw new Error("Unknown argument 'array'")}readUInt32BE(b){return v(this.buffer,b)}writeUInt32BE(b,L){S(this.buffer,b,L)}readUInt32LE(b){return D(this.buffer,b)}writeUInt32LE(b,L){E(this.buffer,b,L)}readUInt8(b){return s(this.buffer,b)}writeUInt8(b,L){c(this.buffer,b,L)}indexOf(b,L=0){return $(this.buffer,b instanceof k?b.buffer:b,L)}}e.$_d=k;function $(f,b,L=0){const O=b.byteLength,T=f.byteLength;if(O===0)return 0;if(O===1)return f.indexOf(b[0]);if(O>T-L)return-1;const F=R.value;F.fill(b.length);for(let z=0;z<b.length;z++)F[b[z]]=b.length-z-1;let U=L+b.length-1,N=U,j=-1;for(;U<T;)if(f[U]===b[N]){if(N===0){j=U;break}U--,N--}else U+=Math.max(b.length-N,F[f[U]]),N=b.length-1;return j}e.$ae=$;function P(f,b){return f[b+0]<<0>>>0|f[b+1]<<8>>>0}e.$be=P;function C(f,b,L){f[L+0]=b&255,b=b>>>8,f[L+1]=b&255}e.$ce=C;function v(f,b){return f[b]*2**24+f[b+1]*2**16+f[b+2]*2**8+f[b+3]}e.$de=v;function S(f,b,L){f[L+3]=b,b=b>>>8,f[L+2]=b,b=b>>>8,f[L+1]=b,b=b>>>8,f[L]=b}e.$ee=S;function D(f,b){return f[b+0]<<0>>>0|f[b+1]<<8>>>0|f[b+2]<<16>>>0|f[b+3]<<24>>>0}e.$fe=D;function E(f,b,L){f[L+0]=b&255,b=b>>>8,f[L+1]=b&255,b=b>>>8,f[L+2]=b&255,b=b>>>8,f[L+3]=b&255}e.$ge=E;function s(f,b){return f[b]}e.$he=s;function c(f,b,L){f[L]=b}e.$ie=c;function u(f){return M.$1d(f,b=>k.concat(b))}e.$je=u;function o(f){return M.$8d(f)}e.$ke=o;function g(f){return M.$3d(f,b=>k.concat(b))}e.$le=g;async function d(f){return f.ended?k.concat(f.buffer):k.concat([...f.buffer,await g(f.stream)])}e.$me=d;function t(f){return M.$6d(f,b=>k.concat(b))}e.$ne=t;function n(f){return M.$9d(f,{data:b=>typeof b=="string"?k.fromString(b):k.wrap(b)},b=>k.concat(b))}e.$oe=n;function r(f){return M.$Zd(b=>k.concat(b),f)}e.$pe=r;function i(f,b){return M.$0d(f,b,L=>k.concat(L))}e.$qe=i;function a(f,b){return M.$$d(f,b,L=>k.concat(L))}e.$re=a;function h(f){let b=0,L=0,O=0;const T=new Uint8Array(Math.floor(f.length/4*3)),F=N=>{switch(L){case 3:T[O++]=b|N,L=0;break;case 2:T[O++]=b|N>>>2,b=N<<6,L=3;break;case 1:T[O++]=b|N>>>4,b=N<<4,L=2;break;default:b=N<<2,L=1}};for(let N=0;N<f.length;N++){const j=f.charCodeAt(N);if(j>=65&&j<=90)F(j-65);else if(j>=97&&j<=122)F(j-97+26);else if(j>=48&&j<=57)F(j-48+52);else if(j===43||j===45)F(62);else if(j===47||j===95)F(63);else{if(j===61)break;throw new SyntaxError(`Unexpected base64 character ${f[N]}`)}}const U=O;for(;L>0;)F(0);return k.wrap(T).slice(0,U)}e.$se=h;const p="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",I="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function w({buffer:f},b=!0,L=!1){const O=L?I:p;let T="";const F=f.byteLength%3;let U=0;for(;U<f.byteLength-F;U+=3){const N=f[U+0],j=f[U+1],z=f[U+2];T+=O[N>>>2],T+=O[(N<<4|j>>>4)&63],T+=O[(j<<2|z>>>6)&63],T+=O[z&63]}if(F===1){const N=f[U+0];T+=O[N>>>2],T+=O[N<<4&63],b&&(T+="==")}else if(F===2){const N=f[U+0],j=f[U+1];T+=O[N>>>2],T+=O[(N<<4|j>>>4)&63],T+=O[j<<2&63],b&&(T+="=")}return T}e.$te=w}),define(Se[16],De([1,0,160,58]),function(ne,e,y,M){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$vf=e.$uf=e.$tf=e.$sf=e.GraphemeBreakType=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=e.$lf=e.$kf=e.$jf=e.$if=e.$hf=e.$gf=e.$ff=e.$ef=e.$df=e.$cf=e.$bf=e.$af=e.$_e=e.$$e=e.$0e=e.$9e=e.$8e=e.$7e=e.$6e=e.$5e=e.$4e=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.$Ue=e.$Te=e.$Se=e.$Re=e.$Qe=e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=e.$Fe=e.$Ee=e.$De=e.$Ce=e.$Be=e.$Ae=e.$ze=void 0;function R(Ae){return!Ae||typeof Ae!="string"?!0:Ae.trim().length===0}e.$ze=R;const A=/{(\d+)}/g;function m(Ae,...Fe){return Fe.length===0?Ae:Ae.replace(A,function(Le,Je){const ue=parseInt(Je,10);return isNaN(ue)||ue<0||ue>=Fe.length?Le:Fe[ue]})}e.$Ae=m;const k=/{([^}]+)}/g;function $(Ae,Fe){return Ae.replace(k,(Le,Je)=>Fe[Je]??Le)}e.$Be=$;function P(Ae){return Ae.replace(/[<>&]/g,function(Fe){switch(Fe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Fe}})}e.$Ce=P;function C(Ae){return Ae.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$De=C;function v(Ae,Fe){let Le=0;const Je=Fe.charCodeAt(0);for(let ue=Ae.length-1;ue>=0;ue--)Ae.charCodeAt(ue)===Je&&Le++;return Le}e.$Ee=v;function S(Ae,Fe,Le="\u2026"){return Ae.length<=Fe?Ae:`${Ae.substr(0,Fe)}${Le}`}e.$Fe=S;function D(Ae,Fe=" "){const Le=E(Ae,Fe);return s(Le,Fe)}e.$Ge=D;function E(Ae,Fe){if(!Ae||!Fe)return Ae;const Le=Fe.length;if(Le===0||Ae.length===0)return Ae;let Je=0;for(;Ae.indexOf(Fe,Je)===Je;)Je=Je+Le;return Ae.substring(Je)}e.$He=E;function s(Ae,Fe){if(!Ae||!Fe)return Ae;const Le=Fe.length,Je=Ae.length;if(Le===0||Je===0)return Ae;let ue=Je,oe=-1;for(;oe=Ae.lastIndexOf(Fe,ue-1),!(oe===-1||oe+Le!==ue);){if(oe===0)return"";ue=oe}return Ae.substring(0,ue)}e.$Ie=s;function c(Ae){return Ae.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$Je=c;function u(Ae){return Ae.replace(/\*/g,"")}e.$Ke=u;function o(Ae,Fe,Le={}){if(!Ae)throw new Error("Cannot create regex from empty string");Fe||(Ae=C(Ae)),Le.wholeWord&&(/\B/.test(Ae.charAt(0))||(Ae="\\b"+Ae),/\B/.test(Ae.charAt(Ae.length-1))||(Ae=Ae+"\\b"));let Je="";return Le.global&&(Je+="g"),Le.matchCase||(Je+="i"),Le.multiline&&(Je+="m"),Le.unicode&&(Je+="u"),new RegExp(Ae,Je)}e.$Le=o;function g(Ae){return Ae.source==="^"||Ae.source==="^$"||Ae.source==="$"||Ae.source==="^\\s*$"?!1:!!(Ae.exec("")&&Ae.lastIndex===0)}e.$Me=g;function d(Ae){return Ae.split(/\r\n|\r|\n/)}e.$Ne=d;function t(Ae){for(let Fe=0,Le=Ae.length;Fe<Le;Fe++){const Je=Ae.charCodeAt(Fe);if(Je!==32&&Je!==9)return Fe}return-1}e.$Oe=t;function n(Ae,Fe=0,Le=Ae.length){for(let Je=Fe;Je<Le;Je++){const ue=Ae.charCodeAt(Je);if(ue!==32&&ue!==9)return Ae.substring(Fe,Je)}return Ae.substring(Fe,Le)}e.$Pe=n;function r(Ae,Fe=Ae.length-1){for(let Le=Fe;Le>=0;Le--){const Je=Ae.charCodeAt(Le);if(Je!==32&&Je!==9)return Le}return-1}e.$Qe=r;function i(Ae,Fe,Le){const Je=[];let ue=0;for(const oe of Ae.matchAll(Fe)){if(Je.push(Ae.slice(ue,oe.index)),oe.index===void 0)throw new Error("match.index should be defined");ue=oe.index+oe[0].length,Je.push(Le(oe[0],...oe.slice(1),oe.index,Ae,oe.groups))}return Je.push(Ae.slice(ue)),Promise.all(Je).then(oe=>oe.join(""))}e.$Re=i;function a(Ae,Fe){return Ae<Fe?-1:Ae>Fe?1:0}e.$Se=a;function h(Ae,Fe,Le=0,Je=Ae.length,ue=0,oe=Fe.length){for(;Le<Je&&ue<oe;Le++,ue++){const ze=Ae.charCodeAt(Le),Ze=Fe.charCodeAt(ue);if(ze<Ze)return-1;if(ze>Ze)return 1}const Ce=Je-Le,He=oe-ue;return Ce<He?-1:Ce>He?1:0}e.$Te=h;function p(Ae,Fe){return I(Ae,Fe,0,Ae.length,0,Fe.length)}e.$Ue=p;function I(Ae,Fe,Le=0,Je=Ae.length,ue=0,oe=Fe.length){for(;Le<Je&&ue<oe;Le++,ue++){let ze=Ae.charCodeAt(Le),Ze=Fe.charCodeAt(ue);if(ze===Ze)continue;if(ze>=128||Ze>=128)return h(Ae.toLowerCase(),Fe.toLowerCase(),Le,Je,ue,oe);f(ze)&&(ze-=32),f(Ze)&&(Ze-=32);const st=ze-Ze;if(st!==0)return st}const Ce=Je-Le,He=oe-ue;return Ce<He?-1:Ce>He?1:0}e.$Ve=I;function w(Ae){return Ae>=48&&Ae<=57}e.$We=w;function f(Ae){return Ae>=97&&Ae<=122}e.$Xe=f;function b(Ae){return Ae>=65&&Ae<=90}e.$Ye=b;function L(Ae,Fe){return Ae.length===Fe.length&&I(Ae,Fe)===0}e.$Ze=L;function O(Ae,Fe){const Le=Fe.length;return Fe.length>Ae.length?!1:I(Ae,Fe,0,Le)===0}e.$1e=O;function T(Ae,Fe){const Le=Math.min(Ae.length,Fe.length);let Je;for(Je=0;Je<Le;Je++)if(Ae.charCodeAt(Je)!==Fe.charCodeAt(Je))return Je;return Le}e.$2e=T;function F(Ae,Fe){const Le=Math.min(Ae.length,Fe.length);let Je;const ue=Ae.length-1,oe=Fe.length-1;for(Je=0;Je<Le;Je++)if(Ae.charCodeAt(ue-Je)!==Fe.charCodeAt(oe-Je))return Je;return Le}e.$3e=F;function U(Ae){return 55296<=Ae&&Ae<=56319}e.$4e=U;function N(Ae){return 56320<=Ae&&Ae<=57343}e.$5e=N;function j(Ae,Fe){return(Ae-55296<<10)+(Fe-56320)+65536}e.$6e=j;function z(Ae,Fe,Le){const Je=Ae.charCodeAt(Le);if(U(Je)&&Le+1<Fe){const ue=Ae.charCodeAt(Le+1);if(N(ue))return j(Je,ue)}return Je}e.$7e=z;function B(Ae,Fe){const Le=Ae.charCodeAt(Fe-1);if(N(Le)&&Fe>1){const Je=Ae.charCodeAt(Fe-2);if(U(Je))return j(Je,Le)}return Le}class ae{get offset(){return this.e}constructor(Fe,Le=0){this.c=Fe,this.d=Fe.length,this.e=Le}setOffset(Fe){this.e=Fe}prevCodePoint(){const Fe=B(this.c,this.e);return this.e-=Fe>=65536?2:1,Fe}nextCodePoint(){const Fe=z(this.c,this.d,this.e);return this.e+=Fe>=65536?2:1,Fe}eol(){return this.e>=this.d}}e.$8e=ae;class X{get offset(){return this.c.offset}constructor(Fe,Le=0){this.c=new ae(Fe,Le)}nextGraphemeLength(){const Fe=ve.getInstance(),Le=this.c,Je=Le.offset;let ue=Fe.getGraphemeBreakType(Le.nextCodePoint());for(;!Le.eol();){const oe=Le.offset,Ce=Fe.getGraphemeBreakType(Le.nextCodePoint());if(x(ue,Ce)){Le.setOffset(oe);break}ue=Ce}return Le.offset-Je}prevGraphemeLength(){const Fe=ve.getInstance(),Le=this.c,Je=Le.offset;let ue=Fe.getGraphemeBreakType(Le.prevCodePoint());for(;Le.offset>0;){const oe=Le.offset,Ce=Fe.getGraphemeBreakType(Le.prevCodePoint());if(x(Ce,ue)){Le.setOffset(oe);break}ue=Ce}return Je-Le.offset}eol(){return this.c.eol()}}e.$9e=X;function Q(Ae,Fe){return new X(Ae,Fe).nextGraphemeLength()}e.$0e=Q;function H(Ae,Fe){return new X(Ae,Fe).prevGraphemeLength()}e.$$e=H;function te(Ae,Fe){Fe>0&&N(Ae.charCodeAt(Fe))&&Fe--;const Le=Fe+Q(Ae,Fe);return[Le-H(Ae,Le),Le]}e.$_e=te;function me(Ae){const Fe=new X(Ae);let Le=0;for(;!Fe.eol();)Le++,Fe.nextGraphemeLength();return Le}e.$af=me;let le;function ye(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function de(Ae){return le||(le=ye()),le.test(Ae)}e.$bf=de;const V=/^[\t\n\r\x20-\x7E]*$/;function J(Ae){return V.test(Ae)}e.$cf=J,e.$df=/[\u2028\u2029]/;function ee(Ae){return e.$df.test(Ae)}e.$ef=ee;function Y(Ae){return Ae>=11904&&Ae<=55215||Ae>=63744&&Ae<=64255||Ae>=65281&&Ae<=65374}e.$ff=Y;function Z(Ae){return Ae>=127462&&Ae<=127487||Ae===8986||Ae===8987||Ae===9200||Ae===9203||Ae>=9728&&Ae<=10175||Ae===11088||Ae===11093||Ae>=127744&&Ae<=128591||Ae>=128640&&Ae<=128764||Ae>=128992&&Ae<=129008||Ae>=129280&&Ae<=129535||Ae>=129648&&Ae<=129782}e.$gf=Z;function _(Ae,Fe){if(Ae.length<Fe)return Ae;const Le=/\b/g;let Je=0;for(;Le.test(Ae)&&!(Ae.length-Le.lastIndex<Fe);)Je=Le.lastIndex,Le.lastIndex+=1;return Ae.substring(Je).replace(/^\s/,"")}e.$hf=_;const pe=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,se=/\x1b\].*?\x07/g;function ge(Ae){return Ae&&(Ae=Ae.replace(pe,"").replace(se,"")),Ae}e.$if=ge,e.$jf=String.fromCharCode(65279);function ie(Ae){return!!(Ae&&Ae.length>0&&Ae.charCodeAt(0)===65279)}e.$kf=ie;function fe(Ae){return ie(Ae)?Ae.substr(1):Ae}e.$lf=fe;function be(Ae,Fe){if(!Ae||!Fe||Ae.length<Fe.length)return!1;const Le=Fe.length,Je=Ae.toLowerCase();let ue=0,oe=-1;for(;ue<Le;){const Ce=Je.indexOf(Fe[ue],oe+1);if(Ce<0)return!1;oe=Ce,ue++}return!0}e.$mf=be;function Ie(Ae,Fe=!1){return Ae?(Fe&&(Ae=Ae.replace(/\\./g,"")),Ae.toLowerCase()!==Ae):!1}e.$nf=Ie;function W(Ae){return Ae.charAt(0).toUpperCase()+Ae.slice(1)}e.$of=W;function G(Ae,Fe=1){if(Fe===0)return"";let Le=-1;do Le=Ae.indexOf(`
`,Le+1),Fe--;while(Fe>0&&Le>=0);return Le===-1?Ae:(Ae[Le-1]==="\r"&&Le--,Ae.substr(0,Le))}e.$pf=G;function ce(Ae){return Ae=Ae%(2*26),Ae<26?String.fromCharCode(97+Ae):String.fromCharCode(65+Ae-26)}e.$qf=ce;function he(Ae){return ve.getInstance().getGraphemeBreakType(Ae)}e.$rf=he;function x(Ae,Fe){return Ae===0?Fe!==5&&Fe!==7:Ae===2&&Fe===3?!1:Ae===4||Ae===2||Ae===3||Fe===4||Fe===2||Fe===3?!0:!(Ae===8&&(Fe===8||Fe===9||Fe===11||Fe===12)||(Ae===11||Ae===9)&&(Fe===9||Fe===10)||(Ae===12||Ae===10)&&Fe===10||Fe===5||Fe===13||Fe===7||Ae===1||Ae===13&&Fe===14||Ae===6&&Fe===6)}var $e;(function(Ae){Ae[Ae.Other=0]="Other",Ae[Ae.Prepend=1]="Prepend",Ae[Ae.CR=2]="CR",Ae[Ae.LF=3]="LF",Ae[Ae.Control=4]="Control",Ae[Ae.Extend=5]="Extend",Ae[Ae.Regional_Indicator=6]="Regional_Indicator",Ae[Ae.SpacingMark=7]="SpacingMark",Ae[Ae.L=8]="L",Ae[Ae.V=9]="V",Ae[Ae.T=10]="T",Ae[Ae.LV=11]="LV",Ae[Ae.LVT=12]="LVT",Ae[Ae.ZWJ=13]="ZWJ",Ae[Ae.Extended_Pictographic=14]="Extended_Pictographic"})($e||(e.GraphemeBreakType=$e={}));class ve{static getInstance(){return ve.c||(ve.c=new ve),ve.c}constructor(){this.d=Ne()}getGraphemeBreakType(Fe){if(Fe<32)return Fe===10?3:Fe===13?2:4;if(Fe<127)return 0;const Le=this.d,Je=Le.length/3;let ue=1;for(;ue<=Je;)if(Fe<Le[3*ue])ue=2*ue;else if(Fe>Le[3*ue+1])ue=2*ue+1;else return Le[3*ue+2];return 0}}ve.c=null;function Ne(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ve(Ae,Fe){if(Ae===0)return 0;const Le=xe(Ae,Fe);if(Le!==void 0)return Le;const Je=new ae(Fe,Ae);return Je.prevCodePoint(),Je.offset}e.$sf=Ve;function xe(Ae,Fe){const Le=new ae(Fe,Ae);let Je=Le.prevCodePoint();for(;Qe(Je)||Je===65039||Je===8419;){if(Le.offset===0)return;Je=Le.prevCodePoint()}if(!Z(Je))return;let ue=Le.offset;return ue>0&&Le.prevCodePoint()===8205&&(ue=Le.offset),ue}function Qe(Ae){return 127995<=Ae&&Ae<=127999}var rt;(function(Ae){Ae[Ae.zwj=8205]="zwj",Ae[Ae.emojiVariantSelector=65039]="emojiVariantSelector",Ae[Ae.enclosingKeyCap=8419]="enclosingKeyCap"})(rt||(rt={})),e.$tf="\xA0";class it{static getInstance(Fe){return l.d.get(Array.from(Fe))}static getLocales(){return l.e.value}constructor(Fe){this.f=Fe}isAmbiguous(Fe){return this.f.has(Fe)}getPrimaryConfusable(Fe){return this.f.get(Fe)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$uf=it,l=it,it.c=new M.$T(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),it.d=new y.$ve(Ae=>{function Fe(Ze){const st=new Map;for(let lt=0;lt<Ze.length;lt+=2)st.set(Ze[lt],Ze[lt+1]);return st}function Le(Ze,st){const lt=new Map(Ze);for(const[wt,Ct]of st)lt.set(wt,Ct);return lt}function Je(Ze,st){if(!Ze)return st;const lt=new Map;for(const[wt,Ct]of Ze)st.has(wt)&&lt.set(wt,Ct);return lt}const ue=l.c.value;let oe=Ae.filter(Ze=>!Ze.startsWith("_")&&Ze in ue);oe.length===0&&(oe=["_default"]);let Ce;for(const Ze of oe){const st=Fe(ue[Ze]);Ce=Je(Ce,st)}const He=Fe(ue._common),ze=Le(He,Ce);return new l(ze)}),it.e=new M.$T(()=>Object.keys(l.c.value).filter(Ae=>!Ae.startsWith("_")));class nt{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(nt.c())),this.d}static isInvisibleCharacter(Fe){return nt.e().has(Fe)}static get codePoints(){return nt.e()}}e.$vf=nt,nt.d=void 0}),define(Se[123],De([1,0,28,16]),function(ne,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.FuzzyScore=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.or=void 0;function l(...ie){return function(fe,be){for(let Ie=0,W=ie.length;Ie<W;Ie++){const G=ie[Ie](fe,be);if(G)return G}return null}}e.or=l,e.$yj=R.bind(void 0,!1),e.$zj=R.bind(void 0,!0);function R(ie,fe,be){if(!be||be.length<fe.length)return null;let Ie;return ie?Ie=M.$1e(be,fe):Ie=be.indexOf(fe)===0,Ie?fe.length>0?[{start:0,end:fe.length}]:[]:null}function A(ie,fe){const be=fe.toLowerCase().indexOf(ie.toLowerCase());return be===-1?null:[{start:be,end:be+ie.length}]}e.$Aj=A;function m(ie,fe){return k(ie.toLowerCase(),fe.toLowerCase(),0,0)}e.$Bj=m;function k(ie,fe,be,Ie){if(be===ie.length)return[];if(Ie===fe.length)return null;if(ie[be]===fe[Ie]){let W=null;return(W=k(ie,fe,be+1,Ie+1))?c({start:Ie,end:Ie+1},W):null}return k(ie,fe,be,Ie+1)}function $(ie){return 97<=ie&&ie<=122}function P(ie){return 65<=ie&&ie<=90}e.$Cj=P;function C(ie){return 48<=ie&&ie<=57}function v(ie){return ie===32||ie===9||ie===10||ie===13}const S=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(ie=>S.add(ie.charCodeAt(0)));function D(ie){return v(ie)||S.has(ie)}function E(ie,fe){return ie===fe||D(ie)&&D(fe)}function s(ie){return $(ie)||P(ie)||C(ie)}function c(ie,fe){return fe.length===0?fe=[ie]:ie.end===fe[0].start?fe[0].start=ie.start:fe.unshift(ie),fe}function u(ie,fe){for(let be=fe;be<ie.length;be++){const Ie=ie.charCodeAt(be);if(P(Ie)||C(Ie)||be>0&&!s(ie.charCodeAt(be-1)))return be}return ie.length}function o(ie,fe,be,Ie){if(be===ie.length)return[];if(Ie===fe.length)return null;if(ie[be]!==fe[Ie].toLowerCase())return null;{let W=null,G=Ie+1;for(W=o(ie,fe,be+1,Ie+1);!W&&(G=u(fe,G))<fe.length;)W=o(ie,fe,be+1,G),G++;return W===null?null:c({start:Ie,end:Ie+1},W)}}function g(ie){let fe=0,be=0,Ie=0,W=0,G=0;for(let ve=0;ve<ie.length;ve++)G=ie.charCodeAt(ve),P(G)&&fe++,$(G)&&be++,s(G)&&Ie++,C(G)&&W++;const ce=fe/ie.length,he=be/ie.length,x=Ie/ie.length,$e=W/ie.length;return{upperPercent:ce,lowerPercent:he,alphaPercent:x,numericPercent:$e}}function d(ie){const{upperPercent:fe,lowerPercent:be}=ie;return be===0&&fe>.6}function t(ie){const{upperPercent:fe,lowerPercent:be,alphaPercent:Ie,numericPercent:W}=ie;return be>.2&&fe<.8&&Ie>.6&&W<.2}function n(ie){let fe=0,be=0,Ie=0,W=0;for(let G=0;G<ie.length;G++)Ie=ie.charCodeAt(G),P(Ie)&&fe++,$(Ie)&&be++,v(Ie)&&W++;return(fe===0||be===0)&&W===0?ie.length<=30:fe<=5}function r(ie,fe){if(!fe||(fe=fe.trim(),fe.length===0)||!n(ie)||fe.length>60)return null;const be=g(fe);if(!t(be)){if(!d(be))return null;fe=fe.toLowerCase()}let Ie=null,W=0;for(ie=ie.toLowerCase();W<fe.length&&(Ie=o(ie,fe,0,W))===null;)W=u(fe,W+1);return Ie}e.$Dj=r;function i(ie,fe,be=!1){if(!fe||fe.length===0)return null;let Ie=null,W=0;for(ie=ie.toLowerCase(),fe=fe.toLowerCase();W<fe.length&&(Ie=a(ie,fe,0,W,be))===null;)W=h(fe,W+1);return Ie}e.$Ej=i;function a(ie,fe,be,Ie,W){if(be===ie.length)return[];if(Ie===fe.length)return null;if(E(ie.charCodeAt(be),fe.charCodeAt(Ie))){let G=null,ce=Ie+1;if(G=a(ie,fe,be+1,Ie+1,W),!W)for(;!G&&(ce=h(fe,ce))<fe.length;)G=a(ie,fe,be+1,ce,W),ce++;return G?ie.charCodeAt(be)!==fe.charCodeAt(Ie)?G:c({start:Ie,end:Ie+1},G):null}else return null}function h(ie,fe){for(let be=fe;be<ie.length;be++)if(D(ie.charCodeAt(be))||be>0&&D(ie.charCodeAt(be-1)))return be;return ie.length}const p=l(e.$zj,r,A),I=l(e.$zj,r,m),w=new y.$Bc(1e4);function f(ie,fe,be=!1){if(typeof ie!="string"||typeof fe!="string")return null;let Ie=w.get(ie);Ie||(Ie=new RegExp(M.$Je(ie),"i"),w.set(ie,Ie));const W=Ie.exec(fe);return W?[{start:W.index,end:W.index+W[0].length}]:be?I(ie,fe):p(ie,fe)}e.$Fj=f;function b(ie,fe){const be=ee(ie,ie.toLowerCase(),0,fe,fe.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return be?O(be):null}e.$Gj=b;function L(ie,fe,be,Ie,W,G){const ce=Math.min(13,ie.length);for(;be<ce;be++){const he=ee(ie,fe,be,Ie,W,G,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(he)return he}return[0,G]}e.$Hj=L;function O(ie){if(typeof ie>"u")return[];const fe=[],be=ie[1];for(let Ie=ie.length-1;Ie>1;Ie--){const W=ie[Ie]+be,G=fe[fe.length-1];G&&G.end===W?G.end=W+1:fe.push({start:W,end:W+1})}return fe}e.$Ij=O;const T=128;function F(){const ie=[],fe=[];for(let be=0;be<=T;be++)fe[be]=0;for(let be=0;be<=T;be++)ie.push(fe.slice(0));return ie}function U(ie){const fe=[];for(let be=0;be<=ie;be++)fe[be]=0;return fe}const N=U(2*T),j=U(2*T),z=F(),B=F(),ae=F(),X=!1;function Q(ie,fe,be,Ie,W){function G(he,x,$e=" "){for(;he.length<x;)he=$e+he;return he}let ce=` |   |${Ie.split("").map(he=>G(he,3)).join("|")}
`;for(let he=0;he<=be;he++)he===0?ce+=" |":ce+=`${fe[he-1]}|`,ce+=ie[he].slice(0,W+1).map(x=>G(x.toString(),3)).join("|")+`
`;return ce}function H(ie,fe,be,Ie){ie=ie.substr(fe),be=be.substr(Ie),console.log(Q(B,ie,ie.length,be,be.length)),console.log(Q(ae,ie,ie.length,be,be.length)),console.log(Q(z,ie,ie.length,be,be.length))}function te(ie,fe){if(fe<0||fe>=ie.length)return!1;const be=ie.codePointAt(fe);switch(be){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!M.$gf(be)}}function me(ie,fe){if(fe<0||fe>=ie.length)return!1;switch(ie.charCodeAt(fe)){case 32:case 9:return!0;default:return!1}}function le(ie,fe,be){return fe[ie]!==be[ie]}function ye(ie,fe,be,Ie,W,G,ce=!1){for(;fe<be&&W<G;)ie[fe]===Ie[W]&&(ce&&(N[fe]=W),fe+=1),W+=1;return fe===be}e.$Jj=ye;var de;(function(ie){ie[ie.Diag=1]="Diag",ie[ie.Left=2]="Left",ie[ie.LeftLeft=3]="LeftLeft"})(de||(de={}));var V;(function(ie){ie.Default=[-100,0];function fe(be){return!be||be.length===2&&be[0]===-100&&be[1]===0}ie.isDefault=fe})(V||(e.FuzzyScore=V={}));class J{constructor(fe,be){this.firstMatchCanBeWeak=fe,this.boostFullMatch=be}}e.$Kj=J,J.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function ee(ie,fe,be,Ie,W,G,ce=J.default){const he=ie.length>T?T:ie.length,x=Ie.length>T?T:Ie.length;if(be>=he||G>=x||he-be>x-G||!ye(fe,be,he,W,G,x,!0))return;Y(he,x,be,G,fe,W);let $e=1,ve=1,Ne=be,Ve=G;const xe=[!1];for($e=1,Ne=be;Ne<he;$e++,Ne++){const Ae=N[Ne],Fe=j[Ne],Le=Ne+1<he?j[Ne+1]:x;for(ve=Ae-G+1,Ve=Ae;Ve<Le;ve++,Ve++){let Je=Number.MIN_SAFE_INTEGER,ue=!1;Ve<=Fe&&(Je=Z(ie,fe,Ne,be,Ie,W,Ve,x,G,z[$e-1][ve-1]===0,xe));let oe=0;Je!==Number.MAX_SAFE_INTEGER&&(ue=!0,oe=Je+B[$e-1][ve-1]);const Ce=Ve>Ae,He=Ce?B[$e][ve-1]+(z[$e][ve-1]>0?-5:0):0,ze=Ve>Ae+1&&z[$e][ve-1]>0,Ze=ze?B[$e][ve-2]+(z[$e][ve-2]>0?-5:0):0;if(ze&&(!Ce||Ze>=He)&&(!ue||Ze>=oe))B[$e][ve]=Ze,ae[$e][ve]=3,z[$e][ve]=0;else if(Ce&&(!ue||He>=oe))B[$e][ve]=He,ae[$e][ve]=2,z[$e][ve]=0;else if(ue)B[$e][ve]=oe,ae[$e][ve]=1,z[$e][ve]=z[$e-1][ve-1]+1;else throw new Error("not possible")}}if(X&&H(ie,be,Ie,G),!xe[0]&&!ce.firstMatchCanBeWeak)return;$e--,ve--;const Qe=[B[$e][ve],G];let rt=0,it=0;for(;$e>=1;){let Ae=ve;do{const Fe=ae[$e][Ae];if(Fe===3)Ae=Ae-2;else if(Fe===2)Ae=Ae-1;else break}while(Ae>=1);rt>1&&fe[be+$e-1]===W[G+ve-1]&&!le(Ae+G-1,Ie,W)&&rt+1>z[$e][Ae]&&(Ae=ve),Ae===ve?rt++:rt=1,it||(it=Ae),$e--,ve=Ae-1,Qe.push(ve)}x===he&&ce.boostFullMatch&&(Qe[0]+=2);const nt=it-he;return Qe[0]-=nt,Qe}e.$Lj=ee;function Y(ie,fe,be,Ie,W,G){let ce=ie-1,he=fe-1;for(;ce>=be&&he>=Ie;)W[ce]===G[he]&&(j[ce]=he,ce--),he--}function Z(ie,fe,be,Ie,W,G,ce,he,x,$e,ve){if(fe[be]!==G[ce])return Number.MIN_SAFE_INTEGER;let Ne=1,Ve=!1;return ce===be-Ie?Ne=ie[be]===W[ce]?7:5:le(ce,W,G)&&(ce===0||!le(ce-1,W,G))?(Ne=ie[be]===W[ce]?7:5,Ve=!0):te(G,ce)&&(ce===0||!te(G,ce-1))?Ne=5:(te(G,ce-1)||me(G,ce-1))&&(Ne=5,Ve=!0),Ne>1&&be===Ie&&(ve[0]=!0),Ve||(Ve=le(ce,W,G)||te(G,ce-1)||me(G,ce-1)),be===Ie?ce>x&&(Ne-=Ve?3:5):$e?Ne+=Ve?2:0:Ne+=Ve?0:1,ce+1===he&&(Ne-=Ve?3:5),Ne}function _(ie,fe,be,Ie,W,G,ce){return se(ie,fe,be,Ie,W,G,!0,ce)}e.$Mj=_;function pe(ie,fe,be,Ie,W,G,ce){return se(ie,fe,be,Ie,W,G,!1,ce)}e.$Nj=pe;function se(ie,fe,be,Ie,W,G,ce,he){let x=ee(ie,fe,be,Ie,W,G,he);if(x&&!ce)return x;if(ie.length>=3){const $e=Math.min(7,ie.length-1);for(let ve=be+1;ve<$e;ve++){const Ne=ge(ie,ve);if(Ne){const Ve=ee(Ne,Ne.toLowerCase(),be,Ie,W,G,he);Ve&&(Ve[0]-=3,(!x||Ve[0]>x[0])&&(x=Ve))}}}return x}function ge(ie,fe){if(fe+1>=ie.length)return;const be=ie[fe],Ie=ie[fe+1];if(be!==Ie)return ie.slice(0,fe)+Ie+be+ie.slice(fe+2)}}),define(Se[51],De([1,0,16]),function(ne,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fi=e.$Ei=e.$Di=e.$Ci=e.$Bi=e.$Ai=e.$zi=void 0;function M(c){return l(c,0)}e.$zi=M;function l(c,u){switch(typeof c){case"object":return c===null?R(349,u):Array.isArray(c)?k(c,u):$(c,u);case"string":return m(c,u);case"boolean":return A(c,u);case"number":return R(c,u);case"undefined":return R(937,u);default:return R(617,u)}}e.$Ai=l;function R(c,u){return(u<<5)-u+c|0}e.$Bi=R;function A(c,u){return R(c?433:863,u)}function m(c,u){u=R(149417,u);for(let o=0,g=c.length;o<g;o++)u=R(c.charCodeAt(o),u);return u}e.$Ci=m;function k(c,u){return u=R(104579,u),c.reduce((o,g)=>l(g,o),u)}function $(c,u){return u=R(181387,u),Object.keys(c).sort().reduce((o,g)=>(o=m(g,o),l(c[g],o)),u)}class P{constructor(){this.g=0}get value(){return this.g}hash(u){return this.g=l(u,this.g),this.g}}e.$Di=P;var C;(function(c){c[c.BLOCK_SIZE=64]="BLOCK_SIZE",c[c.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(C||(C={}));function v(c,u,o=32){const g=o-u,d=~((1<<g)-1);return(c<<u|(d&c)>>>g)>>>0}function S(c,u=0,o=c.byteLength,g=0){for(let d=0;d<o;d++)c[u+d]=g}function D(c,u,o="0"){for(;c.length<u;)c=o+c;return c}function E(c,u=32){return c instanceof ArrayBuffer?Array.from(new Uint8Array(c)).map(o=>o.toString(16).padStart(2,"0")).join(""):D((c>>>0).toString(16),u/4)}e.$Ei=E;class s{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(u){const o=u.length;if(o===0)return;const g=this.p;let d=this.r,t=this.u,n,r;for(t!==0?(n=t,r=-1,t=0):(n=u.charCodeAt(0),r=0);;){let i=n;if(y.$4e(n))if(r+1<o){const a=u.charCodeAt(r+1);y.$5e(a)?(r++,i=y.$6e(n,a)):i=65533}else{t=n;break}else y.$5e(n)&&(i=65533);if(d=this.w(g,d,i),r++,r<o)n=u.charCodeAt(r);else break}this.r=d,this.u=t}w(u,o,g){return g<128?u[o++]=g:g<2048?(u[o++]=192|(g&1984)>>>6,u[o++]=128|(g&63)>>>0):g<65536?(u[o++]=224|(g&61440)>>>12,u[o++]=128|(g&4032)>>>6,u[o++]=128|(g&63)>>>0):(u[o++]=240|(g&1835008)>>>18,u[o++]=128|(g&258048)>>>12,u[o++]=128|(g&4032)>>>6,u[o++]=128|(g&63)>>>0),o>=64&&(this.y(),o-=64,this.t+=64,u[0]=u[64+0],u[1]=u[64+1],u[2]=u[64+2]),o}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),E(this.h)+E(this.l)+E(this.m)+E(this.n)+E(this.o)}x(){this.p[this.r++]=128,S(this.p,this.r),this.r>56&&(this.y(),S(this.p));const u=8*this.t;this.q.setUint32(56,Math.floor(u/4294967296),!1),this.q.setUint32(60,u%4294967296,!1),this.y()}y(){const u=s.g,o=this.q;for(let p=0;p<64;p+=4)u.setUint32(p,o.getUint32(p,!1),!1);for(let p=64;p<320;p+=4)u.setUint32(p,v(u.getUint32(p-12,!1)^u.getUint32(p-32,!1)^u.getUint32(p-56,!1)^u.getUint32(p-64,!1),1),!1);let g=this.h,d=this.l,t=this.m,n=this.n,r=this.o,i,a,h;for(let p=0;p<80;p++)p<20?(i=d&t|~d&n,a=1518500249):p<40?(i=d^t^n,a=1859775393):p<60?(i=d&t|d&n|t&n,a=2400959708):(i=d^t^n,a=3395469782),h=v(g,5)+i+r+a+u.getUint32(p*4,!1)&4294967295,r=n,n=t,t=v(d,30),d=g,g=h;this.h=this.h+g&4294967295,this.l=this.l+d&4294967295,this.m=this.m+t&4294967295,this.n=this.n+n&4294967295,this.o=this.o+r&4294967295}}e.$Fi=s,s.g=new DataView(new ArrayBuffer(320))}),define(Se[124],De([1,0,122,123,51,15,10,16]),function(ne,e,y,M,l,R,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rq=e.$qq=e.$pq=e.$oq=e.$nq=e.$mq=void 0;const k=0,$=[k,[]];function P(z,B,ae,X){if(!z||!B)return $;const Q=z.length,H=B.length;if(Q<H)return $;const te=z.toLowerCase();return C(B,ae,H,z,te,Q,X)}e.$mq=P;function C(z,B,ae,X,Q,H,te){const me=[],le=[];for(let J=0;J<ae;J++){const ee=J*H,Y=ee-H,Z=J>0,_=z[J],pe=B[J];for(let se=0;se<H;se++){const ge=se>0,ie=ee+se,fe=ie-1,be=Y+se-1,Ie=ge?me[fe]:0,W=Z&&ge?me[be]:0,G=Z&&ge?le[be]:0;let ce;!W&&Z?ce=0:ce=v(_,pe,X,Q,se,G),ce&&W+ce>=Ie&&(te||Z||Q.startsWith(B,se))?(le[ie]=G+1,me[ie]=W+ce):(le[ie]=k,me[ie]=Ie)}}const ye=[];let de=ae-1,V=H-1;for(;de>=0&&V>=0;){const J=de*H+V;le[J]===k||(ye.push(V),de--),V--}return[me[ae*H-1],ye.reverse()]}function v(z,B,ae,X,Q,H){let te=0;if(!S(B,X[Q]))return te;if(te+=1,H>0&&(te+=H*5),z===ae[Q]&&(te+=1),Q===0)te+=8;else{const me=D(ae.charCodeAt(Q-1));me?te+=me:(0,M.$Cj)(ae.charCodeAt(Q))&&H===0&&(te+=2)}return te}function S(z,B){return z===B?!0:z==="/"||z==="\\"?B==="/"||B==="\\":!1}function D(z){switch(z){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const E=[void 0,[]];function s(z,B,ae=0,X=0){const Q=B;return Q.values&&Q.values.length>1?c(z,Q.values,ae,X):u(z,B,ae,X)}e.$nq=s;function c(z,B,ae,X){let Q=0;const H=[];for(const te of B){const[me,le]=u(z,te,ae,X);if(typeof me!="number")return E;Q+=me,H.push(...le)}return[Q,I(H)]}function u(z,B,ae,X){const Q=(0,M.$Lj)(B.original,B.originalLowercase,ae,z,z.toLowerCase(),X,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Q?[Q[0],(0,M.$Ij)(Q)]:E}const o=Object.freeze({score:0}),g=1<<18,d=1<<17,t=1<<16;function n(z,B,ae,X){const Q=X.values?X.values:[X];return(0,l.$zi)({[X.normalized]:{values:Q.map(te=>({value:te.normalized,expectContiguousMatch:te.expectContiguousMatch})),label:z,description:B,allowNonContiguousMatches:ae}})}function r(z,B,ae,X,Q){if(!z||!B.normalized)return o;const H=X.getItemLabel(z);if(!H)return o;const te=X.getItemDescription(z),me=n(H,te,ae,B),le=Q[me];if(le)return le;const ye=i(H,te,X.getItemPath(z),B,ae);return Q[me]=ye,ye}e.$oq=r;function i(z,B,ae,X,Q){const H=!ae||!X.containsPathSeparator;return ae&&(A.$f?X.pathNormalized===ae:(0,m.$Ze)(X.pathNormalized,ae))?{score:g,labelMatch:[{start:0,end:z.length}],descriptionMatch:B?[{start:0,end:B.length}]:void 0}:X.values&&X.values.length>1?a(z,B,ae,X.values,H,Q):h(z,B,ae,X,H,Q)}function a(z,B,ae,X,Q,H){let te=0;const me=[],le=[];for(const ye of X){const{score:de,labelMatch:V,descriptionMatch:J}=h(z,B,ae,ye,Q,H);if(de===k)return o;te+=de,V&&me.push(...V),J&&le.push(...J)}return{score:te,labelMatch:I(me),descriptionMatch:I(le)}}function h(z,B,ae,X,Q,H){if(Q||!B){const[te,me]=P(z,X.normalized,X.normalizedLowercase,H&&!X.expectContiguousMatch);if(te){const le=(0,M.$zj)(X.normalized,z);let ye;if(le){ye=d;const de=Math.round(X.normalized.length/z.length*100);ye+=de}else ye=t;return{score:ye+te,labelMatch:le||p(me)}}}if(B){let te=B;ae&&(te=`${B}${R.sep}`);const me=te.length,le=`${te}${z}`,[ye,de]=P(le,X.normalized,X.normalizedLowercase,H&&!X.expectContiguousMatch);if(ye){const V=p(de),J=[],ee=[];return V.forEach(Y=>{Y.start<me&&Y.end>me?(J.push({start:0,end:Y.end-me}),ee.push({start:Y.start,end:me})):Y.start>=me?J.push({start:Y.start-me,end:Y.end-me}):ee.push(Y)}),{score:ye,labelMatch:J,descriptionMatch:ee}}}return o}function p(z){const B=[];if(!z)return B;let ae;for(const X of z)ae&&ae.end===X?ae.end+=1:(ae={start:X,end:X+1},B.push(ae));return B}function I(z){const B=z.sort((Q,H)=>Q.start-H.start),ae=[];let X;for(const Q of B)!X||!w(X,Q)?(X=Q,ae.push(Q)):(X.start=Math.min(X.start,Q.start),X.end=Math.max(X.end,Q.end));return ae}function w(z,B){return!(z.end<B.start||B.end<z.start)}function f(z,B,ae,X,Q,H){const te=r(z,ae,X,Q,H),me=r(B,ae,X,Q,H),le=te.score,ye=me.score;if((le===g||ye===g)&&le!==ye)return le===g?-1:1;if(le>t||ye>t){if(le!==ye)return le>ye?-1:1;if(le<d&&ye<d){const _=L(te.labelMatch,me.labelMatch);if(_!==0)return _}const Y=Q.getItemLabel(z)||"",Z=Q.getItemLabel(B)||"";if(Y.length!==Z.length)return Y.length-Z.length}if(le!==ye)return le>ye?-1:1;const de=Array.isArray(te.labelMatch)&&te.labelMatch.length>0,V=Array.isArray(me.labelMatch)&&me.labelMatch.length>0;if(de&&!V)return-1;if(V&&!de)return 1;const J=b(z,te,Q),ee=b(B,me,Q);return J&&ee&&J!==ee?ee>J?-1:1:O(z,B,ae,Q)}e.$pq=f;function b(z,B,ae){let X=-1,Q=-1;if(B.descriptionMatch&&B.descriptionMatch.length?X=B.descriptionMatch[0].start:B.labelMatch&&B.labelMatch.length&&(X=B.labelMatch[0].start),B.labelMatch&&B.labelMatch.length){if(Q=B.labelMatch[B.labelMatch.length-1].end,B.descriptionMatch&&B.descriptionMatch.length){const H=ae.getItemDescription(z);H&&(Q+=H.length)}}else B.descriptionMatch&&B.descriptionMatch.length&&(Q=B.descriptionMatch[B.descriptionMatch.length-1].end);return Q-X}function L(z,B){if(!z&&!B||(!z||!z.length)&&(!B||!B.length))return 0;if(!B||!B.length)return-1;if(!z||!z.length)return 1;const ae=z[0].start,Q=z[z.length-1].end-ae,H=B[0].start,me=B[B.length-1].end-H;return Q===me?0:me<Q?1:-1}function O(z,B,ae,X){const Q=X.getItemLabel(z)||"",H=X.getItemLabel(B)||"",te=X.getItemDescription(z),me=X.getItemDescription(B),le=Q.length+(te?te.length:0),ye=H.length+(me?me.length:0);if(le!==ye)return le-ye;const de=X.getItemPath(z),V=X.getItemPath(B);return de&&V&&de.length!==V.length?de.length-V.length:Q!==H?(0,y.$kq)(Q,H,ae.normalized):te&&me&&te!==me?(0,y.$kq)(te,me,ae.normalized):de&&V&&de!==V?(0,y.$kq)(de,V,ae.normalized):0}function T(z){return z.startsWith('"')&&z.endsWith('"')}const F=" ";function U(z){typeof z!="string"&&(z="");const B=z.toLowerCase(),{pathNormalized:ae,normalized:X,normalizedLowercase:Q}=N(z),H=ae.indexOf(R.sep)>=0,te=T(z);let me;const le=z.split(F);if(le.length>1)for(const ye of le){const de=T(ye),{pathNormalized:V,normalized:J,normalizedLowercase:ee}=N(ye);J&&(me||(me=[]),me.push({original:ye,originalLowercase:ye.toLowerCase(),pathNormalized:V,normalized:J,normalizedLowercase:ee,expectContiguousMatch:de}))}return{original:z,originalLowercase:B,pathNormalized:ae,normalized:X,normalizedLowercase:Q,values:me,containsPathSeparator:H,expectContiguousMatch:te}}e.$qq=U;function N(z){let B;A.$d?B=z.replace(/\//g,R.sep):B=z.replace(/\\/g,R.sep);const ae=(0,m.$Ke)(B).replace(/\s|"/g,"");return{pathNormalized:B,normalized:ae,normalizedLowercase:ae.toLowerCase()}}function j(z){return Array.isArray(z)?U(z.map(B=>B.original).join(F)):U(z.original)}e.$rq=j}),define(Se[39],De([1,0,16]),function(ne,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var M;(function(l){l[l.Ignore=0]="Ignore",l[l.Info=1]="Info",l[l.Warning=2]="Warning",l[l.Error=3]="Error"})(M||(M={})),function(l){const R="error",A="warning",m="warn",k="info",$="ignore";function P(v){return v?y.$Ze(R,v)?l.Error:y.$Ze(A,v)||y.$Ze(m,v)?l.Warning:y.$Ze(k,v)?l.Info:l.Ignore:l.Ignore}l.fromValue=P;function C(v){switch(v){case l.Error:return R;case l.Warning:return A;case l.Info:return k;default:return $}}l.toString=C}(M||(M={})),e.default=M}),define(Se[161],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Id=void 0,e.$Id=Symbol("MicrotaskDelay")}),define(Se[78],De([1,0,19,16]),function(ne,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=void 0;class l{constructor(){this.b="",this.c=0}reset(S){return this.b=S,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(S){const D=S.charCodeAt(0),E=this.b.charCodeAt(this.c);return D-E}value(){return this.b[this.c]}}e.$Nh=l;class R{constructor(S=!0){this.e=S}reset(S){return this.b=S,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let S=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(S)this.c++;else break;else S=!1;return this}cmp(S){return this.e?(0,M.$Te)(S,this.b,0,S.length,this.c,this.d):(0,M.$Ve)(S,this.b,0,S.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Oh=R;class A{constructor(S=!0,D=!0){this.f=S,this.g=D}reset(S){this.d=0,this.e=0,this.b=S,this.c=S.length;for(let D=S.length-1;D>=0;D--,this.c--){const E=this.b.charCodeAt(D);if(!(E===47||this.f&&E===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let S=!0;for(;this.e<this.c;this.e++){const D=this.b.charCodeAt(this.e);if(D===47||this.f&&D===92)if(S)this.d++;else break;else S=!1}return this}cmp(S){return this.g?(0,M.$Te)(S,this.b,0,S.length,this.d,this.e):(0,M.$Ve)(S,this.b,0,S.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Ph=A;var m;(function(v){v[v.Scheme=1]="Scheme",v[v.Authority=2]="Authority",v[v.Path=3]="Path",v[v.Query=4]="Query",v[v.Fragment=5]="Fragment"})(m||(m={}));class k{constructor(S,D){this.f=S,this.g=D,this.d=[],this.e=0}reset(S){return this.c=S,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new A(!1,!this.f(S)),this.b.reset(S.path),this.b.value()&&this.d.push(3)),this.g(S)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(S){if(this.d[this.e]===1)return(0,M.$Ue)(S,this.c.scheme);if(this.d[this.e]===2)return(0,M.$Ue)(S,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(S);if(this.d[this.e]===4)return(0,M.$Se)(S,this.c.query);if(this.d[this.e]===5)return(0,M.$Se)(S,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$Qh=k;class ${constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const S=this.right;return this.right=S.left,S.left=this,this.updateHeight(),S.updateHeight(),S}rotateRight(){const S=this.left;return this.left=S.right,S.right=this,this.updateHeight(),S.updateHeight(),S}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var P;(function(v){v[v.Left=-1]="Left",v[v.Mid=0]="Mid",v[v.Right=1]="Right"})(P||(P={}));class C{static forUris(S=()=>!1,D=()=>!1){return new C(new k(S,D))}static forPaths(S=!1){return new C(new A(void 0,!S))}static forStrings(){return new C(new l)}static forConfigKeys(){return new C(new R)}constructor(S){this.b=S}clear(){this.c=void 0}fill(S,D){if(D){const E=D.slice(0);(0,y.$Vb)(E);for(const s of E)this.set(s,S)}else{const E=S.slice(0);(0,y.$Vb)(E);for(const s of E)this.set(s[0],s[1])}}set(S,D){const E=this.b.reset(S);let s;this.c||(this.c=new $,this.c.segment=E.value());const c=[];for(s=this.c;;){const o=E.cmp(s.segment);if(o>0)s.left||(s.left=new $,s.left.segment=E.value()),c.push([-1,s]),s=s.left;else if(o<0)s.right||(s.right=new $,s.right.segment=E.value()),c.push([1,s]),s=s.right;else if(E.hasNext())E.next(),s.mid||(s.mid=new $,s.mid.segment=E.value()),c.push([0,s]),s=s.mid;else break}const u=s.value;s.value=D,s.key=S;for(let o=c.length-1;o>=0;o--){const g=c[o][1];g.updateHeight();const d=g.balanceFactor();if(d<-1||d>1){const t=c[o][0],n=c[o+1][0];if(t===1&&n===1)c[o][1]=g.rotateLeft();else if(t===-1&&n===-1)c[o][1]=g.rotateRight();else if(t===1&&n===-1)g.right=c[o+1][1]=c[o+1][1].rotateRight(),c[o][1]=g.rotateLeft();else if(t===-1&&n===1)g.left=c[o+1][1]=c[o+1][1].rotateLeft(),c[o][1]=g.rotateRight();else throw new Error;if(o>0)switch(c[o-1][0]){case-1:c[o-1][1].left=c[o][1];break;case 1:c[o-1][1].right=c[o][1];break;case 0:c[o-1][1].mid=c[o][1];break}else this.c=c[0][1]}}return u}get(S){return this.d(S)?.value}d(S){const D=this.b.reset(S);let E=this.c;for(;E;){const s=D.cmp(E.segment);if(s>0)E=E.left;else if(s<0)E=E.right;else if(D.hasNext())D.next(),E=E.mid;else break}return E}has(S){const D=this.d(S);return!(D?.value===void 0&&D?.mid===void 0)}delete(S){return this.e(S,!1)}deleteSuperstr(S){return this.e(S,!0)}e(S,D){const E=this.b.reset(S),s=[];let c=this.c;for(;c;){const u=E.cmp(c.segment);if(u>0)s.push([-1,c]),c=c.left;else if(u<0)s.push([1,c]),c=c.right;else if(E.hasNext())E.next(),s.push([0,c]),c=c.mid;else break}if(c){if(D?(c.left=void 0,c.mid=void 0,c.right=void 0,c.height=1):(c.key=void 0,c.value=void 0),!c.mid&&!c.value)if(c.left&&c.right){const u=this.f(c.right);if(u.key){const{key:o,value:g,segment:d}=u;this.e(u.key,!1),c.key=o,c.value=g,c.segment=d}}else{const u=c.left??c.right;if(s.length>0){const[o,g]=s[s.length-1];switch(o){case-1:g.left=u;break;case 0:g.mid=u;break;case 1:g.right=u;break}}else this.c=u}for(let u=s.length-1;u>=0;u--){const o=s[u][1];o.updateHeight();const g=o.balanceFactor();if(g>1?(o.right.balanceFactor()>=0||(o.right=o.right.rotateRight()),s[u][1]=o.rotateLeft()):g<-1&&(o.left.balanceFactor()<=0||(o.left=o.left.rotateLeft()),s[u][1]=o.rotateRight()),u>0)switch(s[u-1][0]){case-1:s[u-1][1].left=s[u][1];break;case 1:s[u-1][1].right=s[u][1];break;case 0:s[u-1][1].mid=s[u][1];break}else this.c=s[0][1]}}}f(S){for(;S.left;)S=S.left;return S}findSubstr(S){const D=this.b.reset(S);let E=this.c,s;for(;E;){const c=D.cmp(E.segment);if(c>0)E=E.left;else if(c<0)E=E.right;else if(D.hasNext())D.next(),s=E.value||s,E=E.mid;else break}return E&&E.value||s}findSuperstr(S){return this.g(S,!1)}g(S,D){const E=this.b.reset(S);let s=this.c;for(;s;){const c=E.cmp(s.segment);if(c>0)s=s.left;else if(c<0)s=s.right;else if(E.hasNext())E.next(),s=s.mid;else return s.mid?this.h(s.mid):D?s.value:void 0}}hasElementOrSubtree(S){return this.g(S,!0)!==void 0}forEach(S){for(const[D,E]of this)S(E,D)}*[Symbol.iterator](){yield*this.h(this.c)}h(S){const D=[];return this.j(S,D),D[Symbol.iterator]()}j(S,D){S&&(S.left&&this.j(S.left,D),S.value&&D.push([S.key,S.value]),S.mid&&this.j(S.mid,D),S.right&&this.j(S.right,D))}_isBalanced(){const S=D=>{if(!D)return!0;const E=D.balanceFactor();return E<-1||E>1?!1:S(D.left)&&S(D.right)};return S(this.c)}}e.$Rh=C}),define(Se[18],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nf=e.$Mf=e.$Lf=e.$Kf=e.$Jf=e.$If=e.$Hf=e.$Gf=e.$Ff=e.$Ef=e.$Df=e.$Cf=e.$Bf=e.$Af=e.$zf=e.$yf=e.$xf=e.$wf=void 0;function y(d){return typeof d=="string"}e.$wf=y;function M(d){return Array.isArray(d)&&d.every(t=>y(t))}e.$xf=M;function l(d){return typeof d=="object"&&d!==null&&!Array.isArray(d)&&!(d instanceof RegExp)&&!(d instanceof Date)}e.$yf=l;function R(d){const t=Object.getPrototypeOf(Uint8Array);return typeof d=="object"&&d instanceof t}e.$zf=R;function A(d){return typeof d=="number"&&!isNaN(d)}e.$Af=A;function m(d){return!!d&&typeof d[Symbol.iterator]=="function"}e.$Bf=m;function k(d){return d===!0||d===!1}e.$Cf=k;function $(d){return typeof d>"u"}e.$Df=$;function P(d){return!C(d)}e.$Ef=P;function C(d){return $(d)||d===null}e.$Ff=C;function v(d,t){if(!d)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.$Gf=v;function S(d){if(C(d))throw new Error("Assertion Failed: argument is undefined or null");return d}e.$Hf=S;function D(...d){const t=[];for(let n=0;n<d.length;n++){const r=d[n];if(C(r))throw new Error(`Assertion Failed: argument at index ${n} is undefined or null`);t.push(r)}return t}e.$If=D;const E=Object.prototype.hasOwnProperty;function s(d){if(!l(d))return!1;for(const t in d)if(E.call(d,t))return!1;return!0}e.$Jf=s;function c(d){return typeof d=="function"}e.$Kf=c;function u(...d){return d.length>0&&d.every(c)}e.$Lf=u;function o(d,t){const n=Math.min(d.length,t.length);for(let r=0;r<n;r++)g(d[r],t[r])}e.$Mf=o;function g(d,t){if(y(t)){if(typeof d!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(c(t)){try{if(d instanceof t)return}catch{}if(!C(d)&&d.constructor===t||t.length===1&&t.call(void 0,d)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$Nf=g}),define(Se[79],De([1,0,18]),function(ne,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qj=e.$Pj=e.$Oj=void 0;const M=Object.create(null);function l(m,k){if((0,y.$wf)(k)){const $=M[k];if($===void 0)throw new Error(`${m} references an unknown codicon: ${k}`);k=$}return M[m]=k,{id:m}}function R(){return M}e.$Oj=R;function A(){return Object.values(e.$Qj)}e.$Pj=A,e.$Qj={add:l("add",6e4),plus:l("plus",6e4),gistNew:l("gist-new",6e4),repoCreate:l("repo-create",6e4),lightbulb:l("lightbulb",60001),lightBulb:l("light-bulb",60001),repo:l("repo",60002),repoDelete:l("repo-delete",60002),gistFork:l("gist-fork",60003),repoForked:l("repo-forked",60003),gitPullRequest:l("git-pull-request",60004),gitPullRequestAbandoned:l("git-pull-request-abandoned",60004),recordKeys:l("record-keys",60005),keyboard:l("keyboard",60005),tag:l("tag",60006),tagAdd:l("tag-add",60006),tagRemove:l("tag-remove",60006),gitPullRequestLabel:l("git-pull-request-label",60006),person:l("person",60007),personFollow:l("person-follow",60007),personOutline:l("person-outline",60007),personFilled:l("person-filled",60007),gitBranch:l("git-branch",60008),gitBranchCreate:l("git-branch-create",60008),gitBranchDelete:l("git-branch-delete",60008),sourceControl:l("source-control",60008),mirror:l("mirror",60009),mirrorPublic:l("mirror-public",60009),star:l("star",60010),starAdd:l("star-add",60010),starDelete:l("star-delete",60010),starEmpty:l("star-empty",60010),comment:l("comment",60011),commentAdd:l("comment-add",60011),alert:l("alert",60012),warning:l("warning",60012),search:l("search",60013),searchSave:l("search-save",60013),logOut:l("log-out",60014),signOut:l("sign-out",60014),logIn:l("log-in",60015),signIn:l("sign-in",60015),eye:l("eye",60016),eyeUnwatch:l("eye-unwatch",60016),eyeWatch:l("eye-watch",60016),circleFilled:l("circle-filled",60017),primitiveDot:l("primitive-dot",60017),closeDirty:l("close-dirty",60017),debugBreakpoint:l("debug-breakpoint",60017),debugBreakpointDisabled:l("debug-breakpoint-disabled",60017),debugHint:l("debug-hint",60017),primitiveSquare:l("primitive-square",60018),edit:l("edit",60019),pencil:l("pencil",60019),info:l("info",60020),issueOpened:l("issue-opened",60020),gistPrivate:l("gist-private",60021),gitForkPrivate:l("git-fork-private",60021),lock:l("lock",60021),mirrorPrivate:l("mirror-private",60021),close:l("close",60022),removeClose:l("remove-close",60022),x:l("x",60022),repoSync:l("repo-sync",60023),sync:l("sync",60023),clone:l("clone",60024),desktopDownload:l("desktop-download",60024),beaker:l("beaker",60025),microscope:l("microscope",60025),vm:l("vm",60026),deviceDesktop:l("device-desktop",60026),file:l("file",60027),fileText:l("file-text",60027),more:l("more",60028),ellipsis:l("ellipsis",60028),kebabHorizontal:l("kebab-horizontal",60028),mailReply:l("mail-reply",60029),reply:l("reply",60029),organization:l("organization",60030),organizationFilled:l("organization-filled",60030),organizationOutline:l("organization-outline",60030),newFile:l("new-file",60031),fileAdd:l("file-add",60031),newFolder:l("new-folder",60032),fileDirectoryCreate:l("file-directory-create",60032),trash:l("trash",60033),trashcan:l("trashcan",60033),history:l("history",60034),clock:l("clock",60034),folder:l("folder",60035),fileDirectory:l("file-directory",60035),symbolFolder:l("symbol-folder",60035),logoGithub:l("logo-github",60036),markGithub:l("mark-github",60036),github:l("github",60036),terminal:l("terminal",60037),console:l("console",60037),repl:l("repl",60037),zap:l("zap",60038),symbolEvent:l("symbol-event",60038),error:l("error",60039),stop:l("stop",60039),variable:l("variable",60040),symbolVariable:l("symbol-variable",60040),array:l("array",60042),symbolArray:l("symbol-array",60042),symbolModule:l("symbol-module",60043),symbolPackage:l("symbol-package",60043),symbolNamespace:l("symbol-namespace",60043),symbolObject:l("symbol-object",60043),symbolMethod:l("symbol-method",60044),symbolFunction:l("symbol-function",60044),symbolConstructor:l("symbol-constructor",60044),symbolBoolean:l("symbol-boolean",60047),symbolNull:l("symbol-null",60047),symbolNumeric:l("symbol-numeric",60048),symbolNumber:l("symbol-number",60048),symbolStructure:l("symbol-structure",60049),symbolStruct:l("symbol-struct",60049),symbolParameter:l("symbol-parameter",60050),symbolTypeParameter:l("symbol-type-parameter",60050),symbolKey:l("symbol-key",60051),symbolText:l("symbol-text",60051),symbolReference:l("symbol-reference",60052),goToFile:l("go-to-file",60052),symbolEnum:l("symbol-enum",60053),symbolValue:l("symbol-value",60053),symbolRuler:l("symbol-ruler",60054),symbolUnit:l("symbol-unit",60054),activateBreakpoints:l("activate-breakpoints",60055),archive:l("archive",60056),arrowBoth:l("arrow-both",60057),arrowDown:l("arrow-down",60058),arrowLeft:l("arrow-left",60059),arrowRight:l("arrow-right",60060),arrowSmallDown:l("arrow-small-down",60061),arrowSmallLeft:l("arrow-small-left",60062),arrowSmallRight:l("arrow-small-right",60063),arrowSmallUp:l("arrow-small-up",60064),arrowUp:l("arrow-up",60065),bell:l("bell",60066),bold:l("bold",60067),book:l("book",60068),bookmark:l("bookmark",60069),debugBreakpointConditionalUnverified:l("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:l("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:l("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:l("debug-breakpoint-data-unverified",60072),debugBreakpointData:l("debug-breakpoint-data",60073),debugBreakpointDataDisabled:l("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:l("debug-breakpoint-log-unverified",60074),debugBreakpointLog:l("debug-breakpoint-log",60075),debugBreakpointLogDisabled:l("debug-breakpoint-log-disabled",60075),briefcase:l("briefcase",60076),broadcast:l("broadcast",60077),browser:l("browser",60078),bug:l("bug",60079),calendar:l("calendar",60080),caseSensitive:l("case-sensitive",60081),check:l("check",60082),checklist:l("checklist",60083),chevronDown:l("chevron-down",60084),dropDownButton:l("drop-down-button",60084),chevronLeft:l("chevron-left",60085),chevronRight:l("chevron-right",60086),chevronUp:l("chevron-up",60087),chromeClose:l("chrome-close",60088),chromeMaximize:l("chrome-maximize",60089),chromeMinimize:l("chrome-minimize",60090),chromeRestore:l("chrome-restore",60091),circle:l("circle",60092),circleOutline:l("circle-outline",60092),debugBreakpointUnverified:l("debug-breakpoint-unverified",60092),circleSlash:l("circle-slash",60093),circuitBoard:l("circuit-board",60094),clearAll:l("clear-all",60095),clippy:l("clippy",60096),closeAll:l("close-all",60097),cloudDownload:l("cloud-download",60098),cloudUpload:l("cloud-upload",60099),code:l("code",60100),collapseAll:l("collapse-all",60101),colorMode:l("color-mode",60102),commentDiscussion:l("comment-discussion",60103),compareChanges:l("compare-changes",60157),creditCard:l("credit-card",60105),dash:l("dash",60108),dashboard:l("dashboard",60109),database:l("database",60110),debugContinue:l("debug-continue",60111),debugDisconnect:l("debug-disconnect",60112),debugPause:l("debug-pause",60113),debugRestart:l("debug-restart",60114),debugStart:l("debug-start",60115),debugStepInto:l("debug-step-into",60116),debugStepOut:l("debug-step-out",60117),debugStepOver:l("debug-step-over",60118),debugStop:l("debug-stop",60119),debug:l("debug",60120),deviceCameraVideo:l("device-camera-video",60121),deviceCamera:l("device-camera",60122),deviceMobile:l("device-mobile",60123),diffAdded:l("diff-added",60124),diffIgnored:l("diff-ignored",60125),diffModified:l("diff-modified",60126),diffRemoved:l("diff-removed",60127),diffRenamed:l("diff-renamed",60128),diff:l("diff",60129),discard:l("discard",60130),editorLayout:l("editor-layout",60131),emptyWindow:l("empty-window",60132),exclude:l("exclude",60133),extensions:l("extensions",60134),eyeClosed:l("eye-closed",60135),fileBinary:l("file-binary",60136),fileCode:l("file-code",60137),fileMedia:l("file-media",60138),filePdf:l("file-pdf",60139),fileSubmodule:l("file-submodule",60140),fileSymlinkDirectory:l("file-symlink-directory",60141),fileSymlinkFile:l("file-symlink-file",60142),fileZip:l("file-zip",60143),files:l("files",60144),filter:l("filter",60145),flame:l("flame",60146),foldDown:l("fold-down",60147),foldUp:l("fold-up",60148),fold:l("fold",60149),folderActive:l("folder-active",60150),folderOpened:l("folder-opened",60151),gear:l("gear",60152),gift:l("gift",60153),gistSecret:l("gist-secret",60154),gist:l("gist",60155),gitCommit:l("git-commit",60156),gitCompare:l("git-compare",60157),gitMerge:l("git-merge",60158),githubAction:l("github-action",60159),githubAlt:l("github-alt",60160),globe:l("globe",60161),grabber:l("grabber",60162),graph:l("graph",60163),gripper:l("gripper",60164),heart:l("heart",60165),home:l("home",60166),horizontalRule:l("horizontal-rule",60167),hubot:l("hubot",60168),inbox:l("inbox",60169),issueClosed:l("issue-closed",60324),issueReopened:l("issue-reopened",60171),issues:l("issues",60172),italic:l("italic",60173),jersey:l("jersey",60174),json:l("json",60175),bracket:l("bracket",60175),kebabVertical:l("kebab-vertical",60176),key:l("key",60177),law:l("law",60178),lightbulbAutofix:l("lightbulb-autofix",60179),linkExternal:l("link-external",60180),link:l("link",60181),listOrdered:l("list-ordered",60182),listUnordered:l("list-unordered",60183),liveShare:l("live-share",60184),loading:l("loading",60185),location:l("location",60186),mailRead:l("mail-read",60187),mail:l("mail",60188),markdown:l("markdown",60189),megaphone:l("megaphone",60190),mention:l("mention",60191),milestone:l("milestone",60192),gitPullRequestMilestone:l("git-pull-request-milestone",60192),mortarBoard:l("mortar-board",60193),move:l("move",60194),multipleWindows:l("multiple-windows",60195),mute:l("mute",60196),noNewline:l("no-newline",60197),note:l("note",60198),octoface:l("octoface",60199),openPreview:l("open-preview",60200),package:l("package",60201),paintcan:l("paintcan",60202),pin:l("pin",60203),play:l("play",60204),run:l("run",60204),plug:l("plug",60205),preserveCase:l("preserve-case",60206),preview:l("preview",60207),project:l("project",60208),pulse:l("pulse",60209),question:l("question",60210),quote:l("quote",60211),radioTower:l("radio-tower",60212),reactions:l("reactions",60213),references:l("references",60214),refresh:l("refresh",60215),regex:l("regex",60216),remoteExplorer:l("remote-explorer",60217),remote:l("remote",60218),remove:l("remove",60219),replaceAll:l("replace-all",60220),replace:l("replace",60221),repoClone:l("repo-clone",60222),repoForcePush:l("repo-force-push",60223),repoPull:l("repo-pull",60224),repoPush:l("repo-push",60225),report:l("report",60226),requestChanges:l("request-changes",60227),rocket:l("rocket",60228),rootFolderOpened:l("root-folder-opened",60229),rootFolder:l("root-folder",60230),rss:l("rss",60231),ruby:l("ruby",60232),saveAll:l("save-all",60233),saveAs:l("save-as",60234),save:l("save",60235),screenFull:l("screen-full",60236),screenNormal:l("screen-normal",60237),searchStop:l("search-stop",60238),server:l("server",60240),settingsGear:l("settings-gear",60241),settings:l("settings",60242),shield:l("shield",60243),smiley:l("smiley",60244),sortPrecedence:l("sort-precedence",60245),splitHorizontal:l("split-horizontal",60246),splitVertical:l("split-vertical",60247),squirrel:l("squirrel",60248),starFull:l("star-full",60249),starHalf:l("star-half",60250),symbolClass:l("symbol-class",60251),symbolColor:l("symbol-color",60252),symbolCustomColor:l("symbol-customcolor",60252),symbolConstant:l("symbol-constant",60253),symbolEnumMember:l("symbol-enum-member",60254),symbolField:l("symbol-field",60255),symbolFile:l("symbol-file",60256),symbolInterface:l("symbol-interface",60257),symbolKeyword:l("symbol-keyword",60258),symbolMisc:l("symbol-misc",60259),symbolOperator:l("symbol-operator",60260),symbolProperty:l("symbol-property",60261),wrench:l("wrench",60261),wrenchSubaction:l("wrench-subaction",60261),symbolSnippet:l("symbol-snippet",60262),tasklist:l("tasklist",60263),telescope:l("telescope",60264),textSize:l("text-size",60265),threeBars:l("three-bars",60266),thumbsdown:l("thumbsdown",60267),thumbsup:l("thumbsup",60268),tools:l("tools",60269),triangleDown:l("triangle-down",60270),triangleLeft:l("triangle-left",60271),triangleRight:l("triangle-right",60272),triangleUp:l("triangle-up",60273),twitter:l("twitter",60274),unfold:l("unfold",60275),unlock:l("unlock",60276),unmute:l("unmute",60277),unverified:l("unverified",60278),verified:l("verified",60279),versions:l("versions",60280),vmActive:l("vm-active",60281),vmOutline:l("vm-outline",60282),vmRunning:l("vm-running",60283),watch:l("watch",60284),whitespace:l("whitespace",60285),wholeWord:l("whole-word",60286),window:l("window",60287),wordWrap:l("word-wrap",60288),zoomIn:l("zoom-in",60289),zoomOut:l("zoom-out",60290),listFilter:l("list-filter",60291),listFlat:l("list-flat",60292),listSelection:l("list-selection",60293),selection:l("selection",60293),listTree:l("list-tree",60294),debugBreakpointFunctionUnverified:l("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:l("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:l("debug-breakpoint-function-disabled",60296),debugStackframeActive:l("debug-stackframe-active",60297),circleSmallFilled:l("circle-small-filled",60298),debugStackframeDot:l("debug-stackframe-dot",60298),debugStackframe:l("debug-stackframe",60299),debugStackframeFocused:l("debug-stackframe-focused",60299),debugBreakpointUnsupported:l("debug-breakpoint-unsupported",60300),symbolString:l("symbol-string",60301),debugReverseContinue:l("debug-reverse-continue",60302),debugStepBack:l("debug-step-back",60303),debugRestartFrame:l("debug-restart-frame",60304),callIncoming:l("call-incoming",60306),callOutgoing:l("call-outgoing",60307),menu:l("menu",60308),expandAll:l("expand-all",60309),feedback:l("feedback",60310),gitPullRequestReviewer:l("git-pull-request-reviewer",60310),groupByRefType:l("group-by-ref-type",60311),ungroupByRefType:l("ungroup-by-ref-type",60312),account:l("account",60313),gitPullRequestAssignee:l("git-pull-request-assignee",60313),bellDot:l("bell-dot",60314),debugConsole:l("debug-console",60315),library:l("library",60316),output:l("output",60317),runAll:l("run-all",60318),syncIgnored:l("sync-ignored",60319),pinned:l("pinned",60320),githubInverted:l("github-inverted",60321),debugAlt:l("debug-alt",60305),serverProcess:l("server-process",60322),serverEnvironment:l("server-environment",60323),pass:l("pass",60324),stopCircle:l("stop-circle",60325),playCircle:l("play-circle",60326),record:l("record",60327),debugAltSmall:l("debug-alt-small",60328),vmConnect:l("vm-connect",60329),cloud:l("cloud",60330),merge:l("merge",60331),exportIcon:l("export",60332),graphLeft:l("graph-left",60333),magnet:l("magnet",60334),notebook:l("notebook",60335),redo:l("redo",60336),checkAll:l("check-all",60337),pinnedDirty:l("pinned-dirty",60338),passFilled:l("pass-filled",60339),circleLargeFilled:l("circle-large-filled",60340),circleLarge:l("circle-large",60341),circleLargeOutline:l("circle-large-outline",60341),combine:l("combine",60342),gather:l("gather",60342),table:l("table",60343),variableGroup:l("variable-group",60344),typeHierarchy:l("type-hierarchy",60345),typeHierarchySub:l("type-hierarchy-sub",60346),typeHierarchySuper:l("type-hierarchy-super",60347),gitPullRequestCreate:l("git-pull-request-create",60348),runAbove:l("run-above",60349),runBelow:l("run-below",60350),notebookTemplate:l("notebook-template",60351),debugRerun:l("debug-rerun",60352),workspaceTrusted:l("workspace-trusted",60353),workspaceUntrusted:l("workspace-untrusted",60354),workspaceUnspecified:l("workspace-unspecified",60355),terminalCmd:l("terminal-cmd",60356),terminalDebian:l("terminal-debian",60357),terminalLinux:l("terminal-linux",60358),terminalPowershell:l("terminal-powershell",60359),terminalTmux:l("terminal-tmux",60360),terminalUbuntu:l("terminal-ubuntu",60361),terminalBash:l("terminal-bash",60362),arrowSwap:l("arrow-swap",60363),copy:l("copy",60364),personAdd:l("person-add",60365),filterFilled:l("filter-filled",60366),wand:l("wand",60367),debugLineByLine:l("debug-line-by-line",60368),inspect:l("inspect",60369),layers:l("layers",60370),layersDot:l("layers-dot",60371),layersActive:l("layers-active",60372),compass:l("compass",60373),compassDot:l("compass-dot",60374),compassActive:l("compass-active",60375),azure:l("azure",60376),issueDraft:l("issue-draft",60377),gitPullRequestClosed:l("git-pull-request-closed",60378),gitPullRequestDraft:l("git-pull-request-draft",60379),debugAll:l("debug-all",60380),debugCoverage:l("debug-coverage",60381),runErrors:l("run-errors",60382),folderLibrary:l("folder-library",60383),debugContinueSmall:l("debug-continue-small",60384),beakerStop:l("beaker-stop",60385),graphLine:l("graph-line",60386),graphScatter:l("graph-scatter",60387),pieChart:l("pie-chart",60388),bracketDot:l("bracket-dot",60389),bracketError:l("bracket-error",60390),lockSmall:l("lock-small",60391),azureDevops:l("azure-devops",60392),verifiedFilled:l("verified-filled",60393),newLine:l("newline",60394),layout:l("layout",60395),layoutActivitybarLeft:l("layout-activitybar-left",60396),layoutActivitybarRight:l("layout-activitybar-right",60397),layoutPanelLeft:l("layout-panel-left",60398),layoutPanelCenter:l("layout-panel-center",60399),layoutPanelJustify:l("layout-panel-justify",60400),layoutPanelRight:l("layout-panel-right",60401),layoutPanel:l("layout-panel",60402),layoutSidebarLeft:l("layout-sidebar-left",60403),layoutSidebarRight:l("layout-sidebar-right",60404),layoutStatusbar:l("layout-statusbar",60405),layoutMenubar:l("layout-menubar",60406),layoutCentered:l("layout-centered",60407),layoutSidebarRightOff:l("layout-sidebar-right-off",60416),layoutPanelOff:l("layout-panel-off",60417),layoutSidebarLeftOff:l("layout-sidebar-left-off",60418),target:l("target",60408),indent:l("indent",60409),recordSmall:l("record-small",60410),errorSmall:l("error-small",60411),arrowCircleDown:l("arrow-circle-down",60412),arrowCircleLeft:l("arrow-circle-left",60413),arrowCircleRight:l("arrow-circle-right",60414),arrowCircleUp:l("arrow-circle-up",60415),heartFilled:l("heart-filled",60420),map:l("map",60421),mapFilled:l("map-filled",60422),circleSmall:l("circle-small",60423),bellSlash:l("bell-slash",60424),bellSlashDot:l("bell-slash-dot",60425),commentUnresolved:l("comment-unresolved",60426),gitPullRequestGoToChanges:l("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:l("git-pull-request-new-changes",60428),searchFuzzy:l("search-fuzzy",60429),commentDraft:l("comment-draft",60430),send:l("send",60431),sparkle:l("sparkle",60432),insert:l("insert",60433),mic:l("mic",60434),dialogError:l("dialog-error","error"),dialogWarning:l("dialog-warning","warning"),dialogInfo:l("dialog-info","info"),dialogClose:l("dialog-close","close"),treeItemExpanded:l("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:l("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:l("tree-filter-on-type-off","list-selection"),treeFilterClear:l("tree-filter-clear","close"),treeItemLoading:l("tree-item-loading","loading"),menuSelection:l("menu-selection","check"),menuSubmenu:l("menu-submenu","chevron-right"),menuBarMore:l("menubar-more","more"),scrollbarButtonLeft:l("scrollbar-button-left","triangle-left"),scrollbarButtonRight:l("scrollbar-button-right","triangle-right"),scrollbarButtonUp:l("scrollbar-button-up","triangle-up"),scrollbarButtonDown:l("scrollbar-button-down","triangle-down"),toolBarMore:l("toolbar-more","more"),quickInputBack:l("quick-input-back","arrow-left")}}),define(Se[32],De([1,0,15,10,16,18]),function(ne,e,y,M,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.$Tf=e.$Sf=e.$Rf=e.$Qf=e.$Pf=e.$Of=void 0;function A(h){return h===47||h===92}e.$Of=A;function m(h){return h.replace(/[\\/]/g,y.$ec.sep)}e.$Pf=m;function k(h){return h.indexOf("/")===-1&&(h=m(h)),/^[a-zA-Z]:(\/|$)/.test(h)&&(h="/"+h),h}e.$Qf=k;function $(h,p=y.$ec.sep){if(!h)return"";const I=h.length,w=h.charCodeAt(0);if(A(w)){if(A(h.charCodeAt(1))&&!A(h.charCodeAt(2))){let b=3;const L=b;for(;b<I&&!A(h.charCodeAt(b));b++);if(L!==b&&!A(h.charCodeAt(b+1))){for(b+=1;b<I;b++)if(A(h.charCodeAt(b)))return h.slice(0,b+1).replace(/[\\/]/g,p)}}return p}else if(c(w)&&h.charCodeAt(1)===58)return A(h.charCodeAt(2))?h.slice(0,2)+p:h.slice(0,2);let f=h.indexOf("://");if(f!==-1){for(f+=3;f<I;f++)if(A(h.charCodeAt(f)))return h.slice(0,f+1)}return""}e.$Rf=$;function P(h){if(!M.$d||!h||h.length<5)return!1;let p=h.charCodeAt(0);if(p!==92||(p=h.charCodeAt(1),p!==92))return!1;let I=2;const w=I;for(;I<h.length&&(p=h.charCodeAt(I),p!==92);I++);return!(w===I||(p=h.charCodeAt(I+1),isNaN(p)||p===92))}e.$Sf=P;const C=/[\\/:\*\?"<>\|]/g,v=/[\\/]/g,S=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function D(h,p=M.$d){const I=p?C:v;return!(!h||h.length===0||/^\s+$/.test(h)||(I.lastIndex=0,I.test(h))||p&&S.test(h)||h==="."||h===".."||p&&h[h.length-1]==="."||p&&h.length!==h.trim().length||h.length>255)}e.$Tf=D;function E(h,p,I){const w=h===p;return!I||w?w:!h||!p?!1:(0,l.$Ze)(h,p)}e.$Uf=E;function s(h,p,I,w=y.sep){if(h===p)return!0;if(!h||!p||p.length>h.length)return!1;if(I){if(!(0,l.$1e)(h,p))return!1;if(p.length===h.length)return!0;let b=p.length;return p.charAt(p.length-1)===w&&b--,h.charAt(b)===w}return p.charAt(p.length-1)!==w&&(p+=w),h.indexOf(p)===0}e.$Vf=s;function c(h){return h>=65&&h<=90||h>=97&&h<=122}e.$Wf=c;function u(h,p){return M.$d&&h.endsWith(":")&&(h+=y.sep),(0,y.$gc)(h)||(h=(0,y.$hc)(p,h)),h=(0,y.$fc)(h),M.$d?(h=(0,l.$Ie)(h,y.sep),h.endsWith(":")&&(h+=y.sep)):(h=(0,l.$Ie)(h,y.sep),h||(h=y.sep)),h}e.$Xf=u;function o(h){const p=(0,y.$fc)(h);return M.$d?h.length>3?!1:g(p)&&(h.length===2||p.charCodeAt(2)===92):p===y.$ec.sep}e.$Yf=o;function g(h,p=M.$d){return p?c(h.charCodeAt(0))&&h.charCodeAt(1)===58:!1}e.$Zf=g;function d(h,p=M.$d){return g(h,p)?h[0]:void 0}e.$1f=d;function t(h,p,I){return p.length>h.length?-1:h===p?0:(I&&(h=h.toLowerCase(),p=p.toLowerCase()),h.indexOf(p))}e.$2f=t;function n(h){const p=h.split(":");let I,w,f;for(const b of p){const L=Number(b);(0,R.$Af)(L)?w===void 0?w=L:f===void 0&&(f=L):I=I?[I,b].join(":"):b}if(!I)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:I,line:w!==void 0?w:void 0,column:f!==void 0?f:w!==void 0?1:void 0}}e.$3f=n;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",i="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function a(h,p,I=8){let w="";for(let b=0;b<I;b++){let L;b===0&&M.$d&&!p&&(I===3||I===4)?L=i:L=r,w+=L.charAt(Math.floor(Math.random()*L.length))}let f;return p?f=`${p}-${w}`:f=w,h?(0,y.$hc)(h,f):f}e.$4f=a}),define(Se[23],De([1,0,18]),function(ne,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9m=e.$8m=e.$7m=e.$6m=e.$5m=e.$4m=e.$3m=e.$2m=e.$1m=e.$Zm=e.$Ym=e.$Xm=void 0;function M(c){if(!c||typeof c!="object"||c instanceof RegExp)return c;const u=Array.isArray(c)?[]:{};return Object.entries(c).forEach(([o,g])=>{u[o]=g&&typeof g=="object"?M(g):g}),u}e.$Xm=M;function l(c){if(!c||typeof c!="object")return c;const u=[c];for(;u.length>0;){const o=u.shift();Object.freeze(o);for(const g in o)if(R.call(o,g)){const d=o[g];typeof d=="object"&&!Object.isFrozen(d)&&!(0,y.$zf)(d)&&u.push(d)}}return c}e.$Ym=l;const R=Object.prototype.hasOwnProperty;function A(c,u){return m(c,u,new Set)}e.$Zm=A;function m(c,u,o){if((0,y.$Ff)(c))return c;const g=u(c);if(typeof g<"u")return g;if(Array.isArray(c)){const d=[];for(const t of c)d.push(m(t,u,o));return d}if((0,y.$yf)(c)){if(o.has(c))throw new Error("Cannot clone recursive data-structure");o.add(c);const d={};for(const t in c)R.call(c,t)&&(d[t]=m(c[t],u,o));return o.delete(c),d}return c}function k(c,u,o=!0){return(0,y.$yf)(c)?((0,y.$yf)(u)&&Object.keys(u).forEach(g=>{g in c?o&&((0,y.$yf)(c[g])&&(0,y.$yf)(u[g])?k(c[g],u[g],o):c[g]=u[g]):c[g]=u[g]}),c):u}e.$1m=k;function $(c,u){if(c===u)return!0;if(c==null||u===null||u===void 0||typeof c!=typeof u||typeof c!="object"||Array.isArray(c)!==Array.isArray(u))return!1;let o,g;if(Array.isArray(c)){if(c.length!==u.length)return!1;for(o=0;o<c.length;o++)if(!$(c[o],u[o]))return!1}else{const d=[];for(g in c)d.push(g);d.sort();const t=[];for(g in u)t.push(g);if(t.sort(),!$(d,t))return!1;for(o=0;o<d.length;o++)if(!$(c[d[o]],u[d[o]]))return!1}return!0}e.$2m=$;function P(c){const u=new Set;return JSON.stringify(c,(o,g)=>{if((0,y.$yf)(g)||Array.isArray(g)){if(u.has(g))return"[Circular]";u.add(g)}return g})}e.$3m=P;function C(c,u){const o=Object.create(null);return!c||!u||Object.keys(u).forEach(d=>{const t=c[d],n=u[d];$(t,n)||(o[d]=n)}),o}e.$4m=C;function v(c,u){const o=u.toLowerCase(),g=Object.keys(c).find(d=>d.toLowerCase()===o);return g?c[g]:c[u]}e.$5m=v;function S(c,u){const o=Object.create(null);for(const[g,d]of Object.entries(c))u(g,d)&&(o[g]=d);return o}e.$6m=S;function D(c){let u=[];for(;Object.prototype!==c;)u=u.concat(Object.getOwnPropertyNames(c)),c=Object.getPrototypeOf(c);return u}e.$7m=D;function E(c){const u=[];for(const o of D(c))typeof c[o]=="function"&&u.push(o);return u}e.$8m=E;function s(c,u){const o=d=>function(){const t=Array.prototype.slice.call(arguments,0);return u(d,t)},g={};for(const d of c)g[d]=o(d);return g}e.$9m=s}),define(Se[59],De([1,0,79]),function(ne,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$Rj=e.ThemeColor=void 0;var M;(function(A){function m(k){return k&&typeof k=="object"&&typeof k.id=="string"}A.isThemeColor=m})(M||(e.ThemeColor=M={}));function l(A){return{id:A}}e.$Rj=l;var R;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const m=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function k(u){const o=m.exec(u.id);if(!o)return k(y.$Qj.error);const[,g,d]=o,t=["codicon","codicon-"+g];return d&&t.push("codicon-modifier-"+d.substring(1)),t}A.asClassNameArray=k;function $(u){return k(u).join(" ")}A.asClassName=$;function P(u){return"."+k(u).join(".")}A.asCSSSelector=P;function C(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(typeof u.color>"u"||M.isThemeColor(u.color))}A.isThemeIcon=C;const v=new RegExp(`^\\$\\((${A.iconNameExpression}(?:${A.iconModifierExpression})?)\\)$`);function S(u){const o=v.exec(u);if(!o)return;const[,g]=o;return{id:g}}A.fromString=S;function D(u){return{id:u}}A.fromId=D;function E(u,o){let g=u.id;const d=g.lastIndexOf("~");return d!==-1&&(g=g.substring(0,d)),o&&(g=`${g}~${o}`),{id:g}}A.modify=E;function s(u){const o=u.id.lastIndexOf("~");if(o!==-1)return u.id.substring(o+1)}A.getModifier=s;function c(u,o){return u.id===o.id&&u.color?.id===o.color?.id}A.isEqual=c})(R||(e.ThemeIcon=R={}))}),define(Se[162],De([1,0,123,16,59]),function(ne,e,y,M,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=void 0;const R="$(",A=new RegExp(`\\$\\(${l.ThemeIcon.iconNameExpression}(?:${l.ThemeIcon.iconModifierExpression})?\\)`,"g"),m=new RegExp(`(\\\\)?${A.source}`,"g");function k(c){return c.replace(m,(u,o)=>o?u:`\\${u}`)}e.$Sj=k;const $=new RegExp(`\\\\${A.source}`,"g");function P(c){return c.replace($,u=>`\\${u}`)}e.$Tj=P;const C=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function v(c){return c.indexOf(R)===-1?c:c.replace(C,(u,o,g,d)=>g?u:o||d||"")}e.$Uj=v;function S(c){return c?c.replace(/\$\((.*?)\)/g,(u,o)=>` ${o} `).trim():""}e.$Vj=S;const D=new RegExp(`\\$\\(${l.ThemeIcon.iconNameCharacter}+\\)`,"g");function E(c){D.lastIndex=0;let u="";const o=[];let g=0;for(;;){const d=D.lastIndex,t=D.exec(c),n=c.substring(d,t?.index);if(n.length>0){u+=n;for(let r=0;r<n.length;r++)o.push(g)}if(!t)break;g+=t[0].length}return{text:u,iconOffsets:o}}e.$Wj=E;function s(c,u,o=!1){const{text:g,iconOffsets:d}=u;if(!d||d.length===0)return(0,y.$Fj)(c,g,o);const t=(0,M.$He)(g," "),n=g.length-t.length,r=(0,y.$Fj)(c,t,o);if(r)for(const i of r){const a=d[i.start+n]+n;i.start+=a,i.end+=a}return r}e.$Xj=s}),define(Se[125],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ye=e.$xe=e.Constants=void 0;var y;(function(R){R[R.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",R[R.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",R[R.MAX_UINT_8=255]="MAX_UINT_8",R[R.MAX_UINT_16=65535]="MAX_UINT_16",R[R.MAX_UINT_32=4294967295]="MAX_UINT_32",R[R.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(y||(e.Constants=y={}));function M(R){return R<0?0:R>255?255:R|0}e.$xe=M;function l(R){return R<0?0:R>4294967295?4294967295:R|0}e.$ye=l}),define(Se[2],De([1,0,15,10]),function(ne,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uc=e.$tc=e.URI=void 0;const l=/^\w[\w\d+.-]*$/,R=/^\//,A=/^\/\//;function m(i,a){if(!i.scheme&&a)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!l.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!R.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(A.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function k(i,a){return!i&&!a?"file":i}function $(i,a){switch(i){case"https":case"http":case"file":a?a[0]!==C&&(a=C+a):a=C;break}return a}const P="",C="/",v=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class S{static isUri(a){return a instanceof S?!0:a?typeof a.authority=="string"&&typeof a.fragment=="string"&&typeof a.path=="string"&&typeof a.query=="string"&&typeof a.scheme=="string"&&typeof a.fsPath=="string"&&typeof a.with=="function"&&typeof a.toString=="function":!1}constructor(a,h,p,I,w,f=!1){typeof a=="object"?(this.scheme=a.scheme||P,this.authority=a.authority||P,this.path=a.path||P,this.query=a.query||P,this.fragment=a.fragment||P):(this.scheme=k(a,f),this.authority=h||P,this.path=$(this.scheme,p||P),this.query=I||P,this.fragment=w||P,m(this,f))}get fsPath(){return g(this,!1)}with(a){if(!a)return this;let{scheme:h,authority:p,path:I,query:w,fragment:f}=a;return h===void 0?h=this.scheme:h===null&&(h=P),p===void 0?p=this.authority:p===null&&(p=P),I===void 0?I=this.path:I===null&&(I=P),w===void 0?w=this.query:w===null&&(w=P),f===void 0?f=this.fragment:f===null&&(f=P),h===this.scheme&&p===this.authority&&I===this.path&&w===this.query&&f===this.fragment?this:new s(h,p,I,w,f)}static parse(a,h=!1){const p=v.exec(a);return p?new s(p[2]||P,r(p[4]||P),r(p[5]||P),r(p[7]||P),r(p[9]||P),h):new s(P,P,P,P,P)}static file(a){let h=P;if(M.$d&&(a=a.replace(/\\/g,C)),a[0]===C&&a[1]===C){const p=a.indexOf(C,2);p===-1?(h=a.substring(2),a=C):(h=a.substring(2,p),a=a.substring(p)||C)}return new s("file",h,a,P,P)}static from(a,h){return new s(a.scheme,a.authority,a.path,a.query,a.fragment,h)}static joinPath(a,...h){if(!a.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let p;return M.$d&&a.scheme==="file"?p=S.file(y.$dc.join(g(a,!0),...h)).path:p=y.$ec.join(a.path,...h),a.with({path:p})}toString(a=!1){return d(this,a)}toJSON(){return this}static revive(a){if(a){if(a instanceof S)return a;{const h=new s(a);return h._formatted=a.external??null,h._fsPath=a._sep===E?a.fsPath??null:null,h}}else return a}}e.URI=S;function D(i){return!i||typeof i!="object"?!1:typeof i.scheme=="string"&&(typeof i.authority=="string"||typeof i.authority>"u")&&(typeof i.path=="string"||typeof i.path>"u")&&(typeof i.query=="string"||typeof i.query>"u")&&(typeof i.fragment=="string"||typeof i.fragment>"u")}e.$tc=D;const E=M.$d?1:void 0;class s extends S{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=g(this,!1)),this._fsPath}toString(a=!1){return a?d(this,!0):(this._formatted||(this._formatted=d(this,!1)),this._formatted)}toJSON(){const a={$mid:1};return this._fsPath&&(a.fsPath=this._fsPath,a._sep=E),this._formatted&&(a.external=this._formatted),this.path&&(a.path=this.path),this.scheme&&(a.scheme=this.scheme),this.authority&&(a.authority=this.authority),this.query&&(a.query=this.query),this.fragment&&(a.fragment=this.fragment),a}}const c={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function u(i,a,h){let p,I=-1;for(let w=0;w<i.length;w++){const f=i.charCodeAt(w);if(f>=97&&f<=122||f>=65&&f<=90||f>=48&&f<=57||f===45||f===46||f===95||f===126||a&&f===47||h&&f===91||h&&f===93||h&&f===58)I!==-1&&(p+=encodeURIComponent(i.substring(I,w)),I=-1),p!==void 0&&(p+=i.charAt(w));else{p===void 0&&(p=i.substr(0,w));const b=c[f];b!==void 0?(I!==-1&&(p+=encodeURIComponent(i.substring(I,w)),I=-1),p+=b):I===-1&&(I=w)}}return I!==-1&&(p+=encodeURIComponent(i.substring(I))),p!==void 0?p:i}function o(i){let a;for(let h=0;h<i.length;h++){const p=i.charCodeAt(h);p===35||p===63?(a===void 0&&(a=i.substr(0,h)),a+=c[p]):a!==void 0&&(a+=i[h])}return a!==void 0?a:i}function g(i,a){let h;return i.authority&&i.path.length>1&&i.scheme==="file"?h=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?a?h=i.path.substr(1):h=i.path[1].toLowerCase()+i.path.substr(2):h=i.path,M.$d&&(h=h.replace(/\//g,"\\")),h}e.$uc=g;function d(i,a){const h=a?o:u;let p="",{scheme:I,authority:w,path:f,query:b,fragment:L}=i;if(I&&(p+=I,p+=":"),(w||I==="file")&&(p+=C,p+=C),w){let O=w.indexOf("@");if(O!==-1){const T=w.substr(0,O);w=w.substr(O+1),O=T.lastIndexOf(":"),O===-1?p+=h(T,!1,!1):(p+=h(T.substr(0,O),!1,!1),p+=":",p+=h(T.substr(O+1),!1,!0)),p+="@"}w=w.toLowerCase(),O=w.lastIndexOf(":"),O===-1?p+=h(w,!1,!0):(p+=h(w.substr(0,O),!1,!0),p+=w.substr(O))}if(f){if(f.length>=3&&f.charCodeAt(0)===47&&f.charCodeAt(2)===58){const O=f.charCodeAt(1);O>=65&&O<=90&&(f=`/${String.fromCharCode(O+32)}:${f.substr(3)}`)}else if(f.length>=2&&f.charCodeAt(1)===58){const O=f.charCodeAt(0);O>=65&&O<=90&&(f=`${String.fromCharCode(O+32)}:${f.substr(2)}`)}p+=h(f,!0,!1)}return b&&(p+="?",p+=h(b,!1,!1)),L&&(p+="#",p+=a?L:u(L,!1,!1)),p}function t(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+t(i.substr(3)):i}}const n=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(i){return i.match(n)?i.replace(n,a=>t(a)):i}}),define(Se[163],De([1,0,2]),function(ne,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$Rp=e.$Qp=e.$Pp=void 0;function M($){const P=$;return P&&typeof P.type=="string"&&typeof P.severity=="string"}e.$Pp=M;function l($){const P=[];let C;try{const v=JSON.parse($.arguments),S=v[v.length-1];S&&S.__$stack&&(v.pop(),C=S.__$stack),P.push(...v)}catch{P.push("Unable to log remote console arguments",$.arguments)}return{args:P,stack:C}}e.$Qp=l;function R($){if(typeof $!="string")return R(l($).stack);const P=$;if(P){const C=A(P),v=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(C||"");if(v&&v.length===4)return{uri:y.URI.file(v[1]),line:Number(v[2]),column:Number(v[3])}}}e.$Rp=R;function A($){if(!$)return $;const P=$.indexOf(`
`);return P===-1?$:$.substring(0,P)}function m($,P){const{args:C,stack:v}=l($),S=typeof C[0]=="string"&&C.length===1;let D=A(v);D&&(D=`(${D.trim()})`);let E=[];if(typeof C[0]=="string"?D&&S?E=[`%c[${P}] %c${C[0]} %c${D}`,k("blue"),k(""),k("grey")]:E=[`%c[${P}] %c${C[0]}`,k("blue"),k(""),...C.slice(1)]:E=[`%c[${P}]%`,k("blue"),...C],D&&!S&&E.push(D),typeof console[$.severity]!="function")throw new Error("Unknown console method");console[$.severity].apply(console,E)}e.log=m;function k($){return`color: ${$}`}}),define(Se[60],De([1,0,22,2]),function(ne,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ih=e.$hh=e.$gh=void 0;function l(k){return JSON.stringify(k,A)}e.$gh=l;function R(k){let $=JSON.parse(k);return $=m($),$}e.$hh=R;function A(k,$){return $ instanceof RegExp?{$mid:2,source:$.source,flags:$.flags}:$}function m(k,$=0){if(!k||$>200)return k;if(typeof k=="object"){switch(k.$mid){case 1:return M.URI.revive(k);case 2:return new RegExp(k.source,k.flags);case 17:return new Date(k.source)}if(k instanceof y.$_d||k instanceof Uint8Array)return k;if(Array.isArray(k))for(let P=0;P<k.length;++P)k[P]=m(k[P],$+1);else for(const P in k)Object.hasOwnProperty.call(k,P)&&(k[P]=m(k[P],$+1))}return k}e.$ih=m}),define(Se[17],De([1,0,8,10,2]),function(ne,e,y,M,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.Schemas=void 0;var R;(function($){$.inMemory="inmemory",$.vscode="vscode",$.internal="private",$.walkThrough="walkThrough",$.walkThroughSnippet="walkThroughSnippet",$.http="http",$.https="https",$.file="file",$.mailto="mailto",$.untitled="untitled",$.data="data",$.command="command",$.vscodeRemote="vscode-remote",$.vscodeRemoteResource="vscode-remote-resource",$.vscodeManagedRemoteResource="vscode-managed-remote-resource",$.vscodeUserData="vscode-userdata",$.vscodeCustomEditor="vscode-custom-editor",$.vscodeNotebookCell="vscode-notebook-cell",$.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",$.vscodeNotebookCellOutput="vscode-notebook-cell-output",$.vscodeInteractiveInput="vscode-interactive-input",$.vscodeSettings="vscode-settings",$.vscodeWorkspaceTrust="vscode-workspace-trust",$.vscodeTerminal="vscode-terminal",$.vscodeChatSesssion="vscode-chat-editor",$.webviewPanel="webview-panel",$.vscodeWebview="vscode-webview",$.extension="extension",$.vscodeFileResource="vscode-file",$.tmp="tmp",$.vsls="vsls",$.vscodeSourceControl="vscode-scm"})(R||(e.Schemas=R={})),e.$5f="vscode-tkn",e.$6f="tkn";class A{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${R.vscodeRemoteResource}`}setPreferredWebSchema(P){this.d=P}setDelegate(P){this.e=P}setServerRootPath(P){this.f=`${P}/${R.vscodeRemoteResource}`}set(P,C,v){this.a[P]=C,this.b[P]=v}setConnectionToken(P,C){this.c[P]=C}getPreferredWebSchema(){return this.d}rewrite(P){if(this.e)try{return this.e(P)}catch(s){return y.$Y(s),P}const C=P.authority;let v=this.a[C];v&&v.indexOf(":")!==-1&&v.indexOf("[")===-1&&(v=`[${v}]`);const S=this.b[C],D=this.c[C];let E=`path=${encodeURIComponent(P.path)}`;return typeof D=="string"&&(E+=`&${e.$6f}=${encodeURIComponent(D)}`),l.URI.from({scheme:M.$j?this.d:R.vscodeRemoteResource,authority:`${v}:${S}`,path:M.$j?(window.location.pathname+"/"+this.f).replace(/\/\/+/g,"/"):this.f,query:E})}}e.$7f=new A,e.$8f="vs/../../extensions",e.$9f="vs/../../node_modules",e.$0f="vs/../../node_modules.asar",e.$$f="vs/../../node_modules.asar.unpacked";class m{asBrowserUri(P){const C=this.b(P,ne);return this.uriToBrowserUri(C)}uriToBrowserUri(P){return P.scheme===R.vscodeRemote?e.$7f.rewrite(P):P.scheme===R.file&&(M.$h||M.$k&&M.$b.origin===`${R.vscodeFileResource}://${m.a}`)?P.with({scheme:R.vscodeFileResource,authority:P.authority||m.a,query:null,fragment:null}):P}asFileUri(P){const C=this.b(P,ne);return this.uriToFileUri(C)}uriToFileUri(P){return P.scheme===R.vscodeFileResource?P.with({scheme:R.file,authority:P.authority!==m.a?P.authority:null,query:null,fragment:null}):P}b(P,C){return l.URI.isUri(P)?P:l.URI.parse(C.toUrl(P))}}m.a="vscode-app",e.$_f=new m;var k;(function($){const P=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);$.CoopAndCoep=Object.freeze(P.get("3"));const C="vscode-coi";function v(D){let E;typeof D=="string"?E=new URL(D).searchParams:D instanceof URL?E=D.searchParams:l.URI.isUri(D)&&(E=new URL(D.toString(!0)).searchParams);const s=E?.get(C);if(s)return P.get(s)}$.getHeadersFromQuery=v;function S(D,E,s){if(!globalThis.crossOriginIsolated)return;const c=E&&s?"3":s?"2":"1";D instanceof URLSearchParams?D.set(C,c):D[C]=c}$.addSearchParam=S})(k||(e.COI=k={}))}),define(Se[164],De([1,0,157,17,10,2]),function(ne,e,y,M,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eC=void 0;class A{constructor(v,S,D){this.id=v,this.dependencies=S,this.callback=D}}class m{constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(v,S,D)=>{typeof v!="string"&&(D=S,S=v,v=null),(typeof S!="object"||!Array.isArray(S))&&(D=S,S=null),this.c.push(new A(v,S,D))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(v){if(v.startsWith(window.location.origin)||v.startsWith("vscode-file://vscode-app"))return v;throw new Error(`[trusted_script_src] Invalid script url: ${v}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(v){return v}})))}async load(v){this.g();const S=await(this.a?this.i(v):this.b?this.h(v):this.j(v));if(!S)throw new Error(`Did not receive a define call from script ${v}`);if(Array.isArray(S.dependencies)&&S.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${v}. The dependencies are: ${S.dependencies.join(", ")}`);return typeof S.callback=="function"?S.callback([]):S.callback}h(v){return new Promise((S,D)=>{const E=document.createElement("script");E.setAttribute("async","async"),E.setAttribute("type","text/javascript");const s=()=>{E.removeEventListener("load",c),E.removeEventListener("error",u)},c=o=>{s(),S(this.c.pop())},u=o=>{s(),D(o)};E.addEventListener("load",c),E.addEventListener("error",u),this.f&&(v=this.f.createScriptURL(v)),E.setAttribute("src",v),document.getElementsByTagName("head")[0].appendChild(E)})}i(v){return new Promise((S,D)=>{try{this.f&&(v=this.f.createScriptURL(v)),importScripts(v),S(this.c.pop())}catch(E){D(E)}})}async j(v){try{const S=globalThis._VSCODE_NODE_MODULES.fs,D=globalThis._VSCODE_NODE_MODULES.vm,E=globalThis._VSCODE_NODE_MODULES.module,s=R.URI.parse(v).fsPath,c=S.readFileSync(s).toString(),u=E.wrap(c.replace(/^#!.*/,""));return new D.Script(u).runInThisContext().apply(),this.c.pop()}catch(S){throw S}}}m.INSTANCE=new m;const k=new Map;let $={};typeof globalThis.require=="object"&&($=globalThis.require.paths??{});async function P(C,v,S){if(y.$R){S===void 0&&(S=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),$[C]&&(C=$[C]);const D=`${C}/${v}`;if(k.has(D))return k.get(D);let E;if(/^\w[\w\d+.-]*:\/\//.test(D))E=D;else{const o=`${S&&!l.$j?M.$0f:M.$9f}/${D}`;E=M.$_f.asBrowserUri(o).toString(!0)}const s=m.INSTANCE.load(E);return k.set(D,s),s}else return await new Promise((D,E)=>{ne([C],D,E)})}e.$eC=P}),define(Se[24],De([1,0,32,17,15,10,16,2]),function(ne,e,y,M,l,R,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cg=e.DataUri=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=e.$hg=e.$gg=void 0;function k(S){return(0,m.$uc)(S,!0)}e.$gg=k;class ${constructor(D){this.a=D}compare(D,E,s=!1){return D===E?0:(0,A.$Se)(this.getComparisonKey(D,s),this.getComparisonKey(E,s))}isEqual(D,E,s=!1){return D===E?!0:!D||!E?!1:this.getComparisonKey(D,s)===this.getComparisonKey(E,s)}getComparisonKey(D,E=!1){return D.with({path:this.a(D)?D.path.toLowerCase():void 0,fragment:E?null:void 0}).toString()}ignorePathCasing(D){return this.a(D)}isEqualOrParent(D,E,s=!1){if(D.scheme===E.scheme){if(D.scheme===M.Schemas.file)return y.$Vf(k(D),k(E),this.a(D))&&D.query===E.query&&(s||D.fragment===E.fragment);if((0,e.$xg)(D.authority,E.authority))return y.$Vf(D.path,E.path,this.a(D),"/")&&D.query===E.query&&(s||D.fragment===E.fragment)}return!1}joinPath(D,...E){return m.URI.joinPath(D,...E)}basenameOrAuthority(D){return(0,e.$pg)(D)||D.authority}basename(D){return l.$ec.basename(D.path)}extname(D){return l.$ec.extname(D.path)}dirname(D){if(D.path.length===0)return D;let E;return D.scheme===M.Schemas.file?E=m.URI.file(l.$kc(k(D))).path:(E=l.$ec.dirname(D.path),D.authority&&E.length&&E.charCodeAt(0)!==47&&(console.error(`dirname("${D.toString})) resulted in a relative path`),E="/")),D.with({path:E})}normalizePath(D){if(!D.path.length)return D;let E;return D.scheme===M.Schemas.file?E=m.URI.file(l.$fc(k(D))).path:E=l.$ec.normalize(D.path),D.with({path:E})}relativePath(D,E){if(D.scheme!==E.scheme||!(0,e.$xg)(D.authority,E.authority))return;if(D.scheme===M.Schemas.file){const u=l.$jc(k(D),k(E));return R.$d?y.$Pf(u):u}let s=D.path||"/";const c=E.path||"/";if(this.a(D)){let u=0;for(const o=Math.min(s.length,c.length);u<o&&!(s.charCodeAt(u)!==c.charCodeAt(u)&&s.charAt(u).toLowerCase()!==c.charAt(u).toLowerCase());u++);s=c.substr(0,u)+s.substr(u)}return l.$ec.relative(s,c)}resolvePath(D,E){if(D.scheme===M.Schemas.file){const s=m.URI.file(l.$ic(k(D),E));return D.with({authority:s.authority,path:s.path})}return E=y.$Qf(E),D.with({path:l.$ec.resolve(D.path,E)})}isAbsolutePath(D){return!!D.path&&D.path[0]==="/"}isEqualAuthority(D,E){return D===E||D!==void 0&&E!==void 0&&(0,A.$Ze)(D,E)}hasTrailingPathSeparator(D,E=l.sep){if(D.scheme===M.Schemas.file){const s=k(D);return s.length>y.$Rf(s).length&&s[s.length-1]===E}else{const s=D.path;return s.length>1&&s.charCodeAt(s.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(D.fsPath)}}removeTrailingPathSeparator(D,E=l.sep){return(0,e.$yg)(D,E)?D.with({path:D.path.substr(0,D.path.length-1)}):D}addTrailingPathSeparator(D,E=l.sep){let s=!1;if(D.scheme===M.Schemas.file){const c=k(D);s=c!==void 0&&c.length===y.$Rf(c).length&&c[c.length-1]===E}else{E="/";const c=D.path;s=c.length===1&&c.charCodeAt(c.length-1)===47}return!s&&!(0,e.$yg)(D,E)?D.with({path:D.path+"/"}):D}}e.$hg=$,e.$ig=new $(()=>!1),e.$jg=new $(S=>S.scheme===M.Schemas.file?!R.$f:!0),e.$kg=new $(S=>!0),e.$lg=e.$ig.isEqual.bind(e.$ig),e.$mg=e.$ig.isEqualOrParent.bind(e.$ig),e.$ng=e.$ig.getComparisonKey.bind(e.$ig),e.$og=e.$ig.basenameOrAuthority.bind(e.$ig),e.$pg=e.$ig.basename.bind(e.$ig),e.$qg=e.$ig.extname.bind(e.$ig),e.$rg=e.$ig.dirname.bind(e.$ig),e.$sg=e.$ig.joinPath.bind(e.$ig),e.$tg=e.$ig.normalizePath.bind(e.$ig),e.$ug=e.$ig.relativePath.bind(e.$ig),e.$vg=e.$ig.resolvePath.bind(e.$ig),e.$wg=e.$ig.isAbsolutePath.bind(e.$ig),e.$xg=e.$ig.isEqualAuthority.bind(e.$ig),e.$yg=e.$ig.hasTrailingPathSeparator.bind(e.$ig),e.$zg=e.$ig.removeTrailingPathSeparator.bind(e.$ig),e.$Ag=e.$ig.addTrailingPathSeparator.bind(e.$ig);function P(S,D){const E=[];for(let s=0;s<S.length;s++){const c=D(S[s]);S.some((u,o)=>o===s?!1:(0,e.$mg)(c,D(u)))||E.push(S[s])}return E}e.$Bg=P;var C;(function(S){S.META_DATA_LABEL="label",S.META_DATA_DESCRIPTION="description",S.META_DATA_SIZE="size",S.META_DATA_MIME="mime";function D(E){const s=new Map;E.path.substring(E.path.indexOf(";")+1,E.path.lastIndexOf(";")).split(";").forEach(o=>{const[g,d]=o.split(":");g&&d&&s.set(g,d)});const u=E.path.substring(0,E.path.indexOf(";"));return u&&s.set(S.META_DATA_MIME,u),s}S.parseMetaData=D})(C||(e.DataUri=C={}));function v(S,D,E){if(D){let s=S.path;return s&&s[0]!==l.$ec.sep&&(s=l.$ec.sep+s),S.with({scheme:E,authority:D,path:s})}return S.with({scheme:E})}e.$Cg=v}),define(Se[9],De([1,0,21,8,4,3,24,10,161]),function(ne,e,y,M,l,R,A,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ch=e.$bh=e.$ah=e.Promises=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=void 0;function $(V){return!!V&&typeof V.then=="function"}e.$Dg=$;function P(V){const J=new y.$Vd,ee=V(J.token),Y=new Promise((Z,_)=>{const pe=J.token.onCancellationRequested(()=>{pe.dispose(),J.dispose(),_(new M.$3)});Promise.resolve(ee).then(se=>{pe.dispose(),J.dispose(),Z(se)},se=>{pe.dispose(),J.dispose(),_(se)})});return new class{cancel(){J.cancel()}then(Z,_){return Y.then(Z,_)}catch(Z){return this.then(void 0,Z)}finally(Z){return Y.finally(Z)}}}e.$Eg=P;function C(V,J,ee){return new Promise((Y,Z)=>{const _=J.onCancellationRequested(()=>{_.dispose(),Y(ee)});V.then(Y,Z).finally(()=>_.dispose())})}e.$Fg=C;function v(V,J){return new Promise((ee,Y)=>{const Z=J.onCancellationRequested(()=>{Z.dispose(),Y(new M.$3)});V.then(ee,Y).finally(()=>Z.dispose())})}e.$Gg=v;async function S(V){let J=-1;const ee=V.map((Y,Z)=>Y.then(_=>(J=Z,_)));try{return await Promise.race(ee)}finally{V.forEach((Y,Z)=>{Z!==J&&Y.cancel()})}}e.$Hg=S;function D(V,J,ee){let Y;const Z=setTimeout(()=>{Y?.(void 0),ee?.()},J);return Promise.race([V.finally(()=>clearTimeout(Z)),new Promise(_=>Y=_)])}e.$Ig=D;function E(V){return new Promise((J,ee)=>{const Y=V();$(Y)?Y.then(J,ee):J(Y)})}e.$Jg=E;class s{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(J){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=J,!this.b){const ee=()=>{if(this.b=null,this.f)return;const Y=this.queue(this.d);return this.d=null,Y};this.b=new Promise(Y=>{this.a.then(ee,ee).then(Y)})}return new Promise((ee,Y)=>{this.b.then(ee,Y)})}return this.a=J(),new Promise((ee,Y)=>{this.a.then(Z=>{this.a=null,ee(Z)},Z=>{this.a=null,Y(Z)})})}dispose(){this.f=!0}}e.$Kg=s;class c{constructor(){this.a=Promise.resolve(null)}queue(J){return this.a=this.a.then(()=>J(),()=>J())}}e.$Lg=c;class u{constructor(){this.a=new Map}queue(J,ee){const Z=(this.a.get(J)??Promise.resolve()).catch(()=>{}).then(ee).finally(()=>{this.a.get(J)===Z&&this.a.delete(J)});return this.a.set(J,Z),Z}}e.$Mg=u;const o=(V,J)=>{let ee=!0;const Y=setTimeout(()=>{ee=!1,J()},V);return{isTriggered:()=>ee,dispose:()=>{clearTimeout(Y),ee=!1}}},g=V=>{let J=!0;return queueMicrotask(()=>{J&&(J=!1,V())}),{isTriggered:()=>J,dispose:()=>{J=!1}}};class d{constructor(J){this.defaultDelay=J,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(J,ee=this.defaultDelay){this.g=J,this.h(),this.b||(this.b=new Promise((Z,_)=>{this.d=Z,this.f=_}).then(()=>{if(this.b=null,this.d=null,this.g){const Z=this.g;return this.g=null,Z()}}));const Y=()=>{this.a=null,this.d?.(null)};return this.a=ee===k.$Id?g(Y):o(ee,Y),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new M.$3),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Ng=d;class t{constructor(J){this.a=new d(J),this.b=new s}trigger(J,ee){return this.a.trigger(()=>this.b.queue(J),ee)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Og=t;class n{constructor(){this.a=!1,this.b=new Promise((J,ee)=>{this.d=J})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Pg=n;class r extends n{constructor(J){super(),this.f=setTimeout(()=>this.open(),J)}open(){clearTimeout(this.f),super.open()}}e.$Qg=r;function i(V,J){return J?new Promise((ee,Y)=>{const Z=setTimeout(()=>{_.dispose(),ee()},V),_=J.onCancellationRequested(()=>{clearTimeout(Z),_.dispose(),Y(new M.$3)})}):P(ee=>i(V,ee))}e.$Rg=i;function a(V,J=0,ee){const Y=setTimeout(()=>{V(),ee&&Z.dispose()},J),Z=(0,R.$Oc)(()=>{clearTimeout(Y),ee?.deleteAndLeak(Z)});return ee?.add(Z),Z}e.$Sg=a;function h(V){const J=[];let ee=0;const Y=V.length;function Z(){return ee<Y?V[ee++]():null}function _(pe){pe!=null&&J.push(pe);const se=Z();return se?se.then(_):Promise.resolve(J)}return Promise.resolve(null).then(_)}e.$Tg=h;function p(V,J=Y=>!!Y,ee=null){let Y=0;const Z=V.length,_=()=>{if(Y>=Z)return Promise.resolve(ee);const pe=V[Y++];return Promise.resolve(pe()).then(ge=>J(ge)?Promise.resolve(ge):_())};return _()}e.$Ug=p;function I(V,J=Y=>!!Y,ee=null){if(V.length===0)return Promise.resolve(ee);let Y=V.length;const Z=()=>{Y=-1;for(const _ of V)_.cancel?.()};return new Promise((_,pe)=>{for(const se of V)se.then(ge=>{--Y>=0&&J(ge)?(Z(),_(ge)):Y===0&&_(ee)}).catch(ge=>{--Y>=0&&(Z(),pe(ge))})})}e.$Vg=I;class w{constructor(J){this.a=0,this.d=J,this.f=[],this.b=0,this.g=new l.$Ld}get onDrained(){return this.g.event}get size(){return this.a}queue(J){return this.a++,new Promise((ee,Y)=>{this.f.push({factory:J,c:ee,e:Y}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const J=this.f.shift();this.b++;const ee=J.factory();ee.then(J.c,J.e),ee.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$Wg=w;class f extends w{constructor(){super(1)}}e.$Xg=f;class b{constructor(){this.a=new ae,this.b=0}queue(J){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,J())):this.a.run(this.b++,J())}}e.$Yg=b;class L{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const J=new H;return this.b.add(J),J.p}g(){for(const[,J]of this.a)if(J.size>0)return!1;return!0}queueFor(J,ee=A.$ig){const Y=ee.getComparisonKey(J);let Z=this.a.get(Y);if(!Z){Z=new f;const _=this.f++,pe=l.Event.once(Z.onDrained)(()=>{Z?.dispose(),this.a.delete(Y),this.h(),this.d?.deleteAndDispose(_),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new R.$Yc),this.d.set(_,pe),this.a.set(Y,Z)}return Z}h(){this.g()&&this.j()}j(){for(const J of this.b)J.complete();this.b.clear()}dispose(){for(const[,J]of this.a)J.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Zg=L;class O{constructor(J,ee){this.a=-1,typeof J=="function"&&typeof ee=="number"&&this.setIfNotSet(J,ee)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(J,ee){this.cancel(),this.a=setTimeout(()=>{this.a=-1,J()},ee)}setIfNotSet(J,ee){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,J()},ee))}}e.$1g=O;class T{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(J,ee){this.cancel(),this.a=setInterval(()=>{J()},ee)}}e.$2g=T;class F{constructor(J,ee){this.b=-1,this.a=J,this.d=ee,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(J=this.d){this.cancel(),this.b=setTimeout(this.f,J)}get delay(){return this.d}set delay(J){this.d=J}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$3g=F;class U{constructor(J,ee){ee%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ee}ms is not a multiple of 1000ms.`),this.a=J,this.b=ee,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(J=this.b){J%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${J}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(J/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$4g=U;class N extends F{constructor(J,ee){super(J,ee),this.j=[]}work(J){this.j.push(J),this.isScheduled()||this.schedule()}h(){const J=this.j;this.j=[],this.a?.(J)}dispose(){this.j=[],super.dispose()}}e.$5g=N;class j extends R.$Qc{constructor(J,ee){super(),this.g=J,this.h=ee,this.a=[],this.b=this.B(new R.$Rc),this.f=!1}get pending(){return this.a.length}work(J){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+J.length>this.g.maxBufferedWork)return!1}else if(this.pending+J.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const ee of J)this.a.push(ee);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new F(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$6g=j,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.$7g=V=>{(0,m.$v)(()=>{if(J)return;const ee=Date.now()+15;V(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ee-Date.now())}}))});let J=!1;return{dispose(){J||(J=!0)}}}:e.$7g=(V,J)=>{const ee=requestIdleCallback(V,typeof J=="number"?{timeout:J}:void 0);let Y=!1;return{dispose(){Y||(Y=!0,cancelIdleCallback(ee))}}}}();class z{constructor(J){this.d=!1,this.a=()=>{try{this.f=J()}catch(ee){this.g=ee}finally{this.d=!0}},this.b=(0,e.$7g)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.$8g=z;async function B(V,J,ee){let Y;for(let Z=0;Z<ee;Z++)try{return await V()}catch(_){Y=_,await i(J)}throw Y}e.$9g=B;class ae{isRunning(J){return typeof J=="number"?this.a?.taskId===J:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(J,ee,Y){return this.a={taskId:J,cancel:()=>Y?.(),promise:ee},ee.then(()=>this.d(J),()=>this.d(J)),ee}d(J){this.a&&J===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const J=this.b;this.b=void 0,J.run().then(J.promiseResolve,J.promiseReject)}}queue(J){if(this.b)this.b.run=J;else{let ee,Y;const Z=new Promise((_,pe)=>{ee=_,Y=pe});this.b={run:J,promise:Z,promiseResolve:ee,promiseReject:Y}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$0g=ae;class X{constructor(J,ee=()=>Date.now()){this.d=J,this.f=ee,this.a=0,this.b=0}increment(){const J=this.f();return J-this.a>this.d&&(this.a=J,this.b=0),this.b++,this.b}}e.$$g=X;var Q;(function(V){V[V.Resolved=0]="Resolved",V[V.Rejected=1]="Rejected"})(Q||(Q={}));class H{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((J,ee)=>{this.a=J,this.b=ee})}complete(J){return new Promise(ee=>{this.a(J),this.d={outcome:0,value:J},ee()})}error(J){return new Promise(ee=>{this.b(J),this.d={outcome:1,value:J},ee()})}cancel(){return this.error(new M.$3)}}e.$_g=H;var te;(function(V){async function J(Y){let Z;const _=await Promise.all(Y.map(pe=>pe.then(se=>se,se=>{Z||(Z=se)})));if(typeof Z<"u")throw Z;return _}V.settled=J;function ee(Y){return new Promise(async(Z,_)=>{try{await Y(Z,_)}catch(pe){_(pe)}})}V.withAsyncBody=ee})(te||(e.Promises=te={}));var me;(function(V){V[V.Initial=0]="Initial",V[V.DoneOK=1]="DoneOK",V[V.DoneError=2]="DoneError"})(me||(me={}));class le{static fromArray(J){return new le(ee=>{ee.emitMany(J)})}static fromPromise(J){return new le(async ee=>{ee.emitMany(await J)})}static fromPromises(J){return new le(async ee=>{await Promise.all(J.map(async Y=>ee.emitOne(await Y)))})}static merge(J){return new le(async ee=>{await Promise.all(J.map(async Y=>{for await(const Z of Y)ee.emitOne(Z)}))})}constructor(J){this.a=0,this.b=[],this.d=null,this.f=new l.$Ld,queueMicrotask(async()=>{const ee={emitOne:Y=>this.g(Y),emitMany:Y=>this.h(Y),reject:Y=>this.k(Y)};try{await Promise.resolve(J(ee)),this.j()}catch(Y){this.k(Y)}finally{ee.emitOne=void 0,ee.emitMany=void 0,ee.reject=void 0}})}[Symbol.asyncIterator](){let J=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(J<this.b.length)return{done:!1,value:this.b[J++]};if(this.a===1)return{done:!0,value:void 0};await l.Event.toPromise(this.f.event)}while(!0)}}}static map(J,ee){return new le(async Y=>{for await(const Z of J)Y.emitOne(ee(Z))})}map(J){return le.map(this,J)}static filter(J,ee){return new le(async Y=>{for await(const Z of J)ee(Z)&&Y.emitOne(Z)})}filter(J){return le.filter(this,J)}static coalesce(J){return le.filter(J,ee=>!!ee)}coalesce(){return le.coalesce(this)}static async toPromise(J){const ee=[];for await(const Y of J)ee.push(Y);return ee}toPromise(){return le.toPromise(this)}g(J){this.a===0&&(this.b.push(J),this.f.fire())}h(J){this.a===0&&(this.b=this.b.concat(J),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(J){this.a===0&&(this.a=2,this.d=J,this.f.fire())}}e.$ah=le,le.EMPTY=le.fromArray([]);class ye extends le{constructor(J,ee){super(ee),this.l=J}cancel(){this.l.cancel()}}e.$bh=ye;function de(V){const J=new y.$Vd,ee=V(J.token);return new ye(J,async Y=>{const Z=J.token.onCancellationRequested(()=>{Z.dispose(),J.dispose(),Y.reject(new M.$3)});try{for await(const _ of ee){if(J.token.isCancellationRequested)return;Y.emitOne(_)}Z.dispose(),J.dispose()}catch(_){Z.dispose(),J.dispose(),Y.reject(_)}})}e.$ch=de}),define(Se[34],De([1,0,19,9,32,28,15,10,16]),function(ne,e,y,M,l,R,A,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=void 0;function $(){return Object.create(null)}e.$nj=$,e.$oj="**",e.$pj="/";const P="[/\\\\]",C="[^/\\\\]",v=/\//g;function S(ae,X){switch(ae){case 0:return"";case 1:return`${C}*?`;default:return`(?:${P}|${C}+${P}${X?`|${P}${C}+`:""})*?`}}function D(ae,X){if(!ae)return[];const Q=[];let H=!1,te=!1,me="";for(const le of ae){switch(le){case X:if(!H&&!te){Q.push(me),me="";continue}break;case"{":H=!0;break;case"}":H=!1;break;case"[":te=!0;break;case"]":te=!1;break}me+=le}return me&&Q.push(me),Q}e.$qj=D;function E(ae){if(!ae)return"";let X="";const Q=D(ae,e.$pj);if(Q.every(H=>H===e.$oj))X=".*";else{let H=!1;Q.forEach((te,me)=>{if(te===e.$oj){if(H)return;X+=S(2,me===Q.length-1)}else{let le=!1,ye="",de=!1,V="";for(const J of te){if(J!=="}"&&le){ye+=J;continue}if(de&&(J!=="]"||!V)){let ee;J==="-"?ee=J:(J==="^"||J==="!")&&!V?ee="^":J===e.$pj?ee="":ee=(0,k.$De)(J),V+=ee;continue}switch(J){case"{":le=!0;continue;case"[":de=!0;continue;case"}":{const Y=`(?:${D(ye,",").map(Z=>E(Z)).join("|")})`;X+=Y,le=!1,ye="";break}case"]":{X+="["+V+"]",de=!1,V="";break}case"?":X+=C;continue;case"*":X+=S(1);continue;default:X+=(0,k.$De)(J)}}me<Q.length-1&&(Q[me+1]!==e.$oj||me+2<Q.length)&&(X+=P)}H=te===e.$oj})}return X}const s=/^\*\*\/\*\.[\w\.-]+$/,c=/^\*\*\/([\w\.-]+)\/?$/,u=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,o=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,g=/^\*\*((\/[\w\.-]+)+)\/?$/,d=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new R.$Bc(1e4),n=function(){return!1},r=function(){return null};function i(ae,X){if(!ae)return r;let Q;typeof ae!="string"?Q=ae.pattern:Q=ae,Q=Q.trim();const H=`${Q}_${!!X.trimForExclusions}`;let te=t.get(H);if(te)return a(te,ae);let me;return s.test(Q)?te=p(Q.substr(4),Q):(me=c.exec(h(Q,X)))?te=I(me[1],Q):(X.trimForExclusions?o:u).test(Q)?te=w(Q,X):(me=g.exec(h(Q,X)))?te=f(me[1].substr(1),Q,!0):(me=d.exec(h(Q,X)))?te=f(me[1],Q,!1):te=b(Q),t.set(H,te),a(te,ae)}function a(ae,X){if(typeof X=="string")return ae;const Q=function(H,te){return(0,l.$Vf)(H,X.base,!m.$f)?ae((0,k.$He)(H.substr(X.base.length),A.sep),te):null};return Q.allBasenames=ae.allBasenames,Q.allPaths=ae.allPaths,Q.basenames=ae.basenames,Q.patterns=ae.patterns,Q}function h(ae,X){return X.trimForExclusions&&ae.endsWith("/**")?ae.substr(0,ae.length-2):ae}function p(ae,X){return function(Q,H){return typeof Q=="string"&&Q.endsWith(ae)?X:null}}function I(ae,X){const Q=`/${ae}`,H=`\\${ae}`,te=function(le,ye){return typeof le!="string"?null:ye?ye===ae?X:null:le===ae||le.endsWith(Q)||le.endsWith(H)?X:null},me=[ae];return te.basenames=me,te.patterns=[X],te.allBasenames=me,te}function w(ae,X){const Q=z(ae.slice(1,-1).split(",").map(ye=>i(ye,X)).filter(ye=>ye!==r),ae),H=Q.length;if(!H)return r;if(H===1)return Q[0];const te=function(ye,de){for(let V=0,J=Q.length;V<J;V++)if(Q[V](ye,de))return ae;return null},me=Q.find(ye=>!!ye.allBasenames);me&&(te.allBasenames=me.allBasenames);const le=Q.reduce((ye,de)=>de.allPaths?ye.concat(de.allPaths):ye,[]);return le.length&&(te.allPaths=le),te}function f(ae,X,Q){const H=A.sep===A.$ec.sep,te=H?ae:ae.replace(v,A.sep),me=A.sep+te,le=A.$ec.sep+ae;let ye;return Q?ye=function(de,V){return typeof de=="string"&&(de===te||de.endsWith(me)||!H&&(de===ae||de.endsWith(le)))?X:null}:ye=function(de,V){return typeof de=="string"&&(de===te||!H&&de===ae)?X:null},ye.allPaths=[(Q?"*/":"./")+ae],ye}function b(ae){try{const X=new RegExp(`^${E(ae)}$`);return function(Q){return X.lastIndex=0,typeof Q=="string"&&X.test(Q)?ae:null}}catch{return r}}function L(ae,X,Q){return!ae||typeof X!="string"?!1:O(ae)(X,void 0,Q)}e.$rj=L;function O(ae,X={}){if(!ae)return n;if(typeof ae=="string"||T(ae)){const Q=i(ae,X);if(Q===r)return n;const H=function(te,me){return!!Q(te,me)};return Q.allBasenames&&(H.allBasenames=Q.allBasenames),Q.allPaths&&(H.allPaths=Q.allPaths),H}return N(ae,X)}e.$sj=O;function T(ae){const X=ae;return X?typeof X.base=="string"&&typeof X.pattern=="string":!1}e.$tj=T;function F(ae){return ae.allBasenames||[]}e.$uj=F;function U(ae){return ae.allPaths||[]}e.$vj=U;function N(ae,X){const Q=z(Object.getOwnPropertyNames(ae).map(ye=>j(ye,ae[ye],X)).filter(ye=>ye!==r)),H=Q.length;if(!H)return r;if(!Q.some(ye=>!!ye.requiresSiblings)){if(H===1)return Q[0];const ye=function(J,ee){let Y;for(let Z=0,_=Q.length;Z<_;Z++){const pe=Q[Z](J,ee);if(typeof pe=="string")return pe;(0,M.$Dg)(pe)&&(Y||(Y=[]),Y.push(pe))}return Y?(async()=>{for(const Z of Y){const _=await Z;if(typeof _=="string")return _}return null})():null},de=Q.find(J=>!!J.allBasenames);de&&(ye.allBasenames=de.allBasenames);const V=Q.reduce((J,ee)=>ee.allPaths?J.concat(ee.allPaths):J,[]);return V.length&&(ye.allPaths=V),ye}const te=function(ye,de,V){let J,ee;for(let Y=0,Z=Q.length;Y<Z;Y++){const _=Q[Y];_.requiresSiblings&&V&&(de||(de=(0,A.$lc)(ye)),J||(J=de.substr(0,de.length-(0,A.$mc)(ye).length)));const pe=_(ye,de,J,V);if(typeof pe=="string")return pe;(0,M.$Dg)(pe)&&(ee||(ee=[]),ee.push(pe))}return ee?(async()=>{for(const Y of ee){const Z=await Y;if(typeof Z=="string")return Z}return null})():null},me=Q.find(ye=>!!ye.allBasenames);me&&(te.allBasenames=me.allBasenames);const le=Q.reduce((ye,de)=>de.allPaths?ye.concat(de.allPaths):ye,[]);return le.length&&(te.allPaths=le),te}function j(ae,X,Q){if(X===!1)return r;const H=i(ae,Q);if(H===r)return r;if(typeof X=="boolean")return H;if(X){const te=X.when;if(typeof te=="string"){const me=(le,ye,de,V)=>{if(!V||!H(le,ye))return null;const J=te.replace("$(basename)",()=>de),ee=V(J);return(0,M.$Dg)(ee)?ee.then(Y=>Y?ae:null):ee?ae:null};return me.requiresSiblings=!0,me}}return H}function z(ae,X){const Q=ae.filter(ye=>!!ye.basenames);if(Q.length<2)return ae;const H=Q.reduce((ye,de)=>{const V=de.basenames;return V?ye.concat(V):ye},[]);let te;if(X){te=[];for(let ye=0,de=H.length;ye<de;ye++)te.push(X)}else te=Q.reduce((ye,de)=>{const V=de.patterns;return V?ye.concat(V):ye},[]);const me=function(ye,de){if(typeof ye!="string")return null;if(!de){let J;for(J=ye.length;J>0;J--){const ee=ye.charCodeAt(J-1);if(ee===47||ee===92)break}de=ye.substr(J)}const V=H.indexOf(de);return V!==-1?te[V]:null};me.basenames=H,me.patterns=te,me.allBasenames=H;const le=ae.filter(ye=>!ye.basenames);return le.push(me),le}function B(ae,X){return(0,y.$sb)(ae,X,(Q,H)=>typeof Q=="string"&&typeof H=="string"?Q===H:typeof Q!="string"&&typeof H!="string"?Q.base===H.base&&Q.pattern===H.pattern:!1)}e.$wj=B}),define(Se[80],De([1,0,8,162,24,16,2]),function(ne,e,y,M,l,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6j=e.$5j=e.$4j=e.$3j=e.$2j=e.$1j=e.$Zj=e.$Yj=e.MarkdownStringTextNewlineStyle=void 0;var m;(function(s){s[s.Paragraph=0]="Paragraph",s[s.Break=1]="Break"})(m||(e.MarkdownStringTextNewlineStyle=m={}));class k{constructor(c="",u=!1){if(this.value=c,typeof this.value!="string")throw(0,y.$5)("value");typeof u=="boolean"?(this.isTrusted=u,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=u.isTrusted??void 0,this.supportThemeIcons=u.supportThemeIcons??!1,this.supportHtml=u.supportHtml??!1)}appendText(c,u=0){return this.value+=v(this.supportThemeIcons?(0,M.$Sj)(c):c).replace(/([ \t]+)/g,(o,g)=>"&nbsp;".repeat(g.length)).replace(/\>/gm,"\\>").replace(/\n/g,u===1?`\\
`:`

`),this}appendMarkdown(c){return this.value+=c,this}appendCodeblock(c,u){return this.value+="\n```",this.value+=c,this.value+=`
`,this.value+=u,this.value+="\n```\n",this}appendLink(c,u,o){return this.value+="[",this.value+=this.c(u,"]"),this.value+="](",this.value+=this.c(String(c),")"),o&&(this.value+=` "${this.c(this.c(o,'"'),")")}"`),this.value+=")",this}c(c,u){const o=new RegExp((0,R.$De)(u),"g");return c.replace(o,(g,d)=>c.charAt(d-1)!=="\\"?`\\${g}`:g)}}e.$Yj=k;function $(s){return P(s)?!s.value:Array.isArray(s)?s.every($):!0}e.$Zj=$;function P(s){return s instanceof k?!0:s&&typeof s=="object"?typeof s.value=="string"&&(typeof s.isTrusted=="boolean"||typeof s.isTrusted=="object"||s.isTrusted===void 0)&&(typeof s.supportThemeIcons=="boolean"||s.supportThemeIcons===void 0):!1}e.$1j=P;function C(s,c){return s===c?!0:!s||!c?!1:s.value===c.value&&s.isTrusted===c.isTrusted&&s.supportThemeIcons===c.supportThemeIcons&&s.supportHtml===c.supportHtml&&(s.baseUri===c.baseUri||!!s.baseUri&&!!c.baseUri&&(0,l.$lg)(A.URI.from(s.baseUri),A.URI.from(c.baseUri)))}e.$2j=C;function v(s){return s.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$3j=v;function S(s){return s.replace(/"/g,"&quot;")}e.$4j=S;function D(s){return s&&s.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$5j=D;function E(s){const c=[],u=s.split("|").map(g=>g.trim());s=u[0];const o=u[1];if(o){const g=/height=(\d+)/.exec(o),d=/width=(\d+)/.exec(o),t=g?g[1]:"",n=d?d[1]:"",r=isFinite(parseInt(n)),i=isFinite(parseInt(t));r&&c.push(`width="${n}"`),i&&c.push(`height="${t}"`)}return{href:s,dimensions:c}}e.$6j=E}),define(Se[100],De([1,0,19,32,15,10,24,16]),function(ne,e,y,M,l,R,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sv=e.$rv=e.$qv=e.$pv=e.$ov=e.$nv=e.$mv=e.$lv=e.$kv=e.$jv=void 0;function k(i,a){const{os:h,tildify:p,relative:I}=a;if(I){const b=$(i,I,h);if(typeof b=="string")return b}let w=i.fsPath;if(h===1&&!R.$d?w=w.replace(/\//g,"\\"):h!==1&&R.$d&&(w=w.replace(/\\/g,"/")),h!==1&&p?.userHome){const b=p.userHome.fsPath;let L;i.scheme!==p.userHome.scheme&&i.path.startsWith(l.$ec.sep)?L=p.userHome.with({path:i.path}).fsPath:L=i.fsPath,w=v(L,b,h)}return(h===1?l.$dc:l.$ec).normalize(P(w,h===1))}e.$jv=k;function $(i,a,h){const p=h===1?l.$dc:l.$ec,I=h===3?A.$ig:A.$kg,w=a.getWorkspace(),f=(0,y.$Mb)(w.folders);if(!f)return;i.scheme!==f.uri.scheme&&i.path.startsWith(l.$ec.sep)&&(i=f.uri.with({path:i.path}));const b=a.getWorkspaceFolder(i);if(!b)return;let L;if(I.isEqual(b.uri,i)?L="":L=I.relativePath(b.uri,i)??"",L&&(L=p.normalize(L)),w.folders.length>1&&!a.noPrefix){const O=b.name?b.name:I.basenameOrAuthority(b.uri);L=L?`${O} \u2022 ${L}`:O}return L}function P(i,a=R.$d){return(0,M.$Zf)(i,a)?i.charAt(0).toUpperCase()+i.slice(1):i}e.$kv=P;let C=Object.create(null);function v(i,a,h=R.OS){if(h===1||!i||!a)return i;let p=C.original===a?C.normalized:void 0;p||(p=a,R.$d&&(p=(0,M.$Pf)(p)),p=`${(0,m.$Ie)(p,l.$ec.sep)}${l.$ec.sep}`,C={original:a,normalized:p});let I=i;return R.$d&&(I=(0,M.$Pf)(I)),(h===3?I.startsWith(p):(0,m.$1e)(I,p))?`~/${I.substr(p.length)}`:i}e.$lv=v;function S(i,a){return i.replace(/^~($|\/|\\)/,`${a}$1`)}e.$mv=S;const D="\u2026",E="\\\\",s="~";function c(i,a=l.sep){const h=new Array(i.length);let p=!1;for(let I=0;I<i.length;I++){const w=i[I];if(w===""){h[I]=`.${a}`;continue}if(!w){h[I]=w;continue}p=!0;let f="",b=w;b.indexOf(E)===0?(f=b.substr(0,b.indexOf(E)+E.length),b=b.substr(b.indexOf(E)+E.length)):b.indexOf(a)===0?(f=b.substr(0,b.indexOf(a)+a.length),b=b.substr(b.indexOf(a)+a.length)):b.indexOf(s)===0&&(f=b.substr(0,b.indexOf(s)+s.length),b=b.substr(b.indexOf(s)+s.length));const L=b.split(a);for(let O=1;p&&O<=L.length;O++)for(let T=L.length-O;p&&T>=0;T--){p=!1;let F=L.slice(T,T+O).join(a);for(let U=0;!p&&U<i.length;U++)if(U!==I&&i[U]&&i[U].indexOf(F)>-1){const N=T+O===L.length,j=T>0&&i[U].indexOf(a)>-1?a+F:F,z=i[U].endsWith(j);p=!N||z}if(!p){let U="";(L[0].endsWith(":")||f!=="")&&(T===1&&(T=0,O++,F=L[0]+a+F),T>0&&(U=L[0]+a),U=f+U),T>0&&(U=U+D+a),U=U+F,T+O<L.length&&(U=U+a+D),h[I]=U}}p&&(h[I]=w)}return h}e.$nv=c;var u;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(u||(u={}));function o(i,a=Object.create(null)){const h=[];let p=!1,I="";for(const w of i)if(w==="$"||p&&w==="{")I&&h.push({value:I,type:u.TEXT}),I="",p=!0;else if(w==="}"&&p){const f=a[I];if(typeof f=="string")f.length&&h.push({value:f,type:u.VARIABLE});else if(f){const b=h[h.length-1];(!b||b.type!==u.SEPARATOR)&&h.push({value:f.label,type:u.SEPARATOR})}I="",p=!1}else I+=w;return I&&!p&&h.push({value:I,type:u.TEXT}),h.filter((w,f)=>{if(w.type===u.SEPARATOR){const b=h[f-1],L=h[f+1];return[b,L].every(O=>O&&(O.type===u.VARIABLE||O.type===u.TEXT)&&O.value.length>0)}return!0}).map(w=>w.value).join("")}e.$ov=o;function g(i,a){return R.$e||a?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,R.$e?"&":"&&"):i.replace(/&&|&/g,h=>h==="&"?"&&":"&")}e.$pv=g;function d(i,a){return R.$e||a?i.replace(/\(&&\w\)|&&/g,""):R.$d?i.replace(/&&|&/g,h=>h==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.$qv=d;function t(i){return i.replace(/&/g,"&&")}e.$rv=t;function n(i){if(i.endsWith("]")){const a=i.lastIndexOf(" [",i.length-2);if(a!==-1){const h=r(i.substring(0,a));return{name:h.name,parentPath:h.parentPath+i.substring(a)}}}return r(i)}e.$sv=n;function r(i){const a=i.indexOf("/")!==-1?l.$ec:l.$dc,h=a.basename(i),p=a.dirname(i);return h.length?{name:h,parentPath:p}:{name:p,parentPath:""}}}),define(Se[126],De([1,0,22,2]),function(ne,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hm=e.$Gm=e.$Fm=e.$Em=e.$Dm=void 0;function l(C){return C.toJSON()}class R{constructor(v){this.a=v}transformIncoming(v){const S=this.a.transformIncoming(v);return S===v?v:l(M.URI.from(S))}transformOutgoing(v){const S=this.a.transformOutgoing(v);return S===v?v:l(M.URI.from(S))}transformOutgoingURI(v){const S=this.a.transformOutgoing(v);return S===v?v:M.URI.from(S)}transformOutgoingScheme(v){return this.a.transformOutgoingScheme(v)}}e.$Dm=R,e.$Em=new class{transformIncoming(C){return C}transformOutgoing(C){return C}transformOutgoingURI(C){return C}transformOutgoingScheme(C){return C}};function A(C,v,S){if(!C||S>200)return null;if(typeof C=="object"){if(C instanceof M.URI)return v.transformOutgoing(C);for(const D in C)if(Object.hasOwnProperty.call(C,D)){const E=A(C[D],v,S+1);E!==null&&(C[D]=E)}}return null}function m(C,v){const S=A(C,v,0);return S===null?C:S}e.$Fm=m;function k(C,v,S,D){if(!C||D>200)return null;if(typeof C=="object"){if(C.$mid===1)return S?M.URI.revive(v.transformIncoming(C)):v.transformIncoming(C);if(C instanceof y.$_d)return null;for(const E in C)if(Object.hasOwnProperty.call(C,E)){const s=k(C[E],v,S,D+1);s!==null&&(C[E]=s)}}return null}function $(C,v){const S=k(C,v,!1,0);return S===null?C:S}e.$Gm=$;function P(C,v){const S=k(C,v,!0,0);return S===null?C:S}e.$Hm=P}),define(Se[31],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bg=e.$ag=void 0;const y=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function M(l){return y.test(l)}e.$ag=M,e.$bg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let l;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?l=crypto.getRandomValues.bind(crypto):l=function(m){for(let k=0;k<m.length;k++)m[k]=Math.floor(Math.random()*256);return m};const R=new Uint8Array(16),A=[];for(let m=0;m<256;m++)A.push(m.toString(16).padStart(2,"0"));return function(){l(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let k=0,$="";return $+=A[R[k++]],$+=A[R[k++]],$+=A[R[k++]],$+=A[R[k++]],$+="-",$+=A[R[k++]],$+=A[R[k++]],$+="-",$+=A[R[k++]],$+=A[R[k++]],$+="-",$+=A[R[k++]],$+=A[R[k++]],$+="-",$+=A[R[k++]],$+=A[R[k++]],$+=A[R[k++]],$+=A[R[k++]],$+=A[R[k++]],$+=A[R[k++]],$}}()}),define(Se[165],De([1,0,19,50,31]),function(ne,e,y,M,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vs=e.$Us=e.$Ts=e.$Ss=e.$Rs=void 0;function R(C){return{asString:async()=>C,asFile:()=>{},value:typeof C=="string"?C:void 0}}e.$Rs=R;function A(C,v,S){const D={id:(0,l.$bg)(),name:C,uri:v,data:S};return{asString:async()=>"",asFile:()=>D,value:void 0}}e.$Ss=A;class m{constructor(){this.a=new Map}get size(){let v=0;for(const S of this.a)v++;return v}has(v){return this.a.has(this.b(v))}matches(v){const S=[...this.a.keys()];return M.Iterable.some(this,([D,E])=>E.asFile())&&S.push("files"),P(k(v),S)}get(v){return this.a.get(this.b(v))?.[0]}append(v,S){const D=this.a.get(v);D?D.push(S):this.a.set(this.b(v),[S])}replace(v,S){this.a.set(this.b(v),[S])}delete(v){this.a.delete(this.b(v))}*[Symbol.iterator](){for(const[v,S]of this.a)for(const D of S)yield[v,D]}b(v){return k(v)}}e.$Ts=m;function k(C){return C.toLowerCase()}function $(C,v){return P(k(C),v.map(k))}e.$Us=$;function P(C,v){if(C==="*/*")return v.length>0;if(v.includes(C))return!0;const S=C.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!S)return!1;const[D,E,s]=S;return s==="*"?v.some(c=>c.startsWith(E+"/")):!1}e.$Vs=Object.freeze({create:C=>(0,y.$Kb)(C.map(v=>v.toString())).join(`\r
`),split:C=>C.split(`\r
`),parse:C=>e.$Vs.split(C).filter(v=>!v.startsWith("#"))})}),define(Se[29],De([1,0,52,61,370,9,32,77,15,10,24,2]),function(ne,e,y,M,l,R,A,m,k,$,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var v;(function(j){j[j.UNLINK=0]="UNLINK",j[j.MOVE=1]="MOVE"})(v||(e.RimRafMode=v={}));async function S(j,z=v.UNLINK,B){if((0,A.$Yf)(j))throw new Error("rimraf - will refuse to recursively delete root");return z===v.UNLINK?E(j):D(j,B)}async function D(j,z=(0,A.$4f)((0,M.tmpdir)())){try{try{await y.promises.rename(j,z)}catch(B){return B.code==="ENOENT"?void 0:E(j)}E(z).catch(B=>{})}catch(B){if(B.code!=="ENOENT")throw B}}async function E(j){return(0,l.promisify)(y.rm)(j,{recursive:!0,force:!0,maxRetries:3})}function s(j){if((0,A.$Yf)(j))throw new Error("rimraf - will refuse to recursively delete root");y.rmSync(j,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=s;async function c(j,z){return g(await(z?u(j):(0,l.promisify)(y.readdir)(j)))}async function u(j){try{return await(0,l.promisify)(y.readdir)(j,{withFileTypes:!0})}catch(ae){console.warn("[node.js fs] readdir with filetypes failed with error: ",ae)}const z=[],B=await c(j);for(const ae of B){let X=!1,Q=!1,H=!1;try{const te=await e.Promises.lstat((0,k.$hc)(j,ae));X=te.isFile(),Q=te.isDirectory(),H=te.isSymbolicLink()}catch(te){console.warn("[node.js fs] unexpected error from lstat after readdir: ",te)}z.push({name:ae,isFile:()=>X,isDirectory:()=>Q,isSymbolicLink:()=>H})}return z}function o(j){return g(y.readdirSync(j))}e.readdirSync=o;function g(j){return j.map(z=>typeof z=="string"?$.$e?(0,m.$jl)(z):z:(z.name=$.$e?(0,m.$jl)(z.name):z.name,z))}async function d(j){const z=await c(j),B=[];for(const ae of z)await n.existsDirectory((0,k.$hc)(j,ae))&&B.push(ae);return B}function t(j,z=1e3){return new Promise(B=>{let ae=!1;const X=setInterval(()=>{ae||(ae=!0,y.access(j,Q=>{ae=!1,Q&&(clearInterval(X),B(void 0))}))},z)})}e.whenDeleted=t;var n;(function(j){async function z(X){let Q;try{if(Q=await e.Promises.lstat(X),!Q.isSymbolicLink())return{stat:Q}}catch{}try{return{stat:await e.Promises.stat(X),symbolicLink:Q?.isSymbolicLink()?{dangling:!1}:void 0}}catch(H){if(H.code==="ENOENT"&&Q)return{stat:Q,symbolicLink:{dangling:!0}};if($.$d&&H.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(X)),symbolicLink:{dangling:!1}}}catch(te){if(te.code==="ENOENT"&&Q)return{stat:Q,symbolicLink:{dangling:!0}};throw te}throw H}}j.stat=z;async function B(X){try{const{stat:Q,symbolicLink:H}=await j.stat(X);return Q.isFile()&&H?.dangling!==!0}catch{}return!1}j.existsFile=B;async function ae(X){try{const{stat:Q,symbolicLink:H}=await j.stat(X);return Q.isDirectory()&&H?.dangling!==!0}catch{}return!1}j.existsDirectory=ae})(n||(e.SymlinkSupport=n={}));const r=new R.$Zg;function i(j,z,B){return r.queueFor(C.URI.file(j),P.$jg).queue(()=>{const ae=w(B);return new Promise((X,Q)=>p(j,z,ae,H=>H?Q(H):X()))})}let a=!0;function h(j){a=j}e.configureFlushOnWrite=h;function p(j,z,B,ae){if(!a)return y.writeFile(j,z,{mode:B.mode,flag:B.flag},ae);y.open(j,B.flag,B.mode,(X,Q)=>{if(X)return ae(X);y.writeFile(Q,z,H=>{if(H)return y.close(Q,()=>ae(H));y.fdatasync(Q,te=>(te&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",te),h(!1)),y.close(Q,me=>ae(me))))})})}function I(j,z,B){const ae=w(B);if(!a)return y.writeFileSync(j,z,{mode:ae.mode,flag:ae.flag});const X=y.openSync(j,ae.flag,ae.mode);try{y.writeFileSync(X,z);try{y.fdatasyncSync(X)}catch(Q){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",Q),h(!1)}}finally{y.closeSync(X)}}e.writeFileSync=I;function w(j){return j?{mode:typeof j.mode=="number"?j.mode:438,flag:typeof j.flag=="string"?j.flag:"w"}:{mode:438,flag:"w"}}async function f(j,z,B=6e4){if(j!==z)try{$.$d&&typeof B=="number"?await b(j,z,Date.now(),B):await(0,l.promisify)(y.rename)(j,z)}catch(ae){if(j.toLowerCase()!==z.toLowerCase()&&ae.code==="EXDEV"||j.endsWith("."))await L(j,z,{preserveSymlinks:!1}),await S(j,v.MOVE);else throw ae}}async function b(j,z,B,ae,X=0){try{return await(0,l.promisify)(y.rename)(j,z)}catch(Q){if(Q.code!=="EACCES"&&Q.code!=="EPERM"&&Q.code!=="EBUSY")throw Q;if(Date.now()-B>=ae)throw console.error(`[node.js fs] rename failed after ${X} retries with error: ${Q}`),Q;if(X===0){let H=!1;try{const{stat:te}=await n.stat(z);te.isFile()||(H=!0)}catch{}if(H)throw Q}return await(0,R.$Rg)(Math.min(100,X*10)),b(j,z,B,ae,X+1)}}async function L(j,z,B){return T(j,z,{root:{source:j,target:z},options:B,handledSourcePaths:new Set})}const O=511;async function T(j,z,B){if(B.handledSourcePaths.has(j))return;B.handledSourcePaths.add(j);const{stat:ae,symbolicLink:X}=await n.stat(j);if(X){if(B.options.preserveSymlinks)try{return await N(j,z,B)}catch(Q){console.warn("[node.js fs] copy of symlink failed: ",Q)}if(X.dangling)return}return ae.isDirectory()?F(j,z,ae.mode&O,B):U(j,z,ae.mode&O)}async function F(j,z,B,ae){await e.Promises.mkdir(z,{recursive:!0,mode:B});const X=await c(j);for(const Q of X)await T((0,k.$hc)(j,Q),(0,k.$hc)(z,Q),ae)}async function U(j,z,B){await e.Promises.copyFile(j,z),await e.Promises.chmod(z,B)}async function N(j,z,B){let ae=await e.Promises.readlink(j);(0,A.$Vf)(ae,B.root.source,!$.$f)&&(ae=(0,k.$hc)(B.root.target,ae.substr(B.root.source.length+1))),await e.Promises.symlink(ae,z)}e.Promises=new class{get access(){return(0,l.promisify)(y.access)}get stat(){return(0,l.promisify)(y.stat)}get lstat(){return(0,l.promisify)(y.lstat)}get utimes(){return(0,l.promisify)(y.utimes)}get read(){return(j,z,B,ae,X)=>new Promise((Q,H)=>{y.read(j,z,B,ae,X,(te,me,le)=>te?H(te):Q({bytesRead:me,buffer:le}))})}get readFile(){return(0,l.promisify)(y.readFile)}get write(){return(j,z,B,ae,X)=>new Promise((Q,H)=>{y.write(j,z,B,ae,X,(te,me,le)=>te?H(te):Q({bytesWritten:me,buffer:le}))})}get appendFile(){return(0,l.promisify)(y.appendFile)}get fdatasync(){return(0,l.promisify)(y.fdatasync)}get truncate(){return(0,l.promisify)(y.truncate)}get copyFile(){return(0,l.promisify)(y.copyFile)}get open(){return(0,l.promisify)(y.open)}get close(){return(0,l.promisify)(y.close)}get symlink(){return(0,l.promisify)(y.symlink)}get readlink(){return(0,l.promisify)(y.readlink)}get chmod(){return(0,l.promisify)(y.chmod)}get mkdir(){return(0,l.promisify)(y.mkdir)}get unlink(){return(0,l.promisify)(y.unlink)}get rmdir(){return(0,l.promisify)(y.rmdir)}get realpath(){return(0,l.promisify)(y.realpath)}async exists(j){try{return await e.Promises.access(j),!0}catch{return!1}}get readdir(){return c}get readDirsInDir(){return d}get writeFile(){return i}get rm(){return S}get rename(){return f}get copy(){return L}}}),define(Se[101],De([1,0,52,15,10,16,29]),function(ne,e,y,M,l,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zp=e.$Yp=e.$Xp=e.$Wp=void 0;function m(v){if(l.$f)return v;const S=(0,M.$kc)(v);if(v===S)return v;const D=((0,M.$lc)(v)||v).toLowerCase();try{const s=(0,A.readdirSync)(S).filter(c=>c.toLowerCase()===D);if(s.length===1){const c=m(S);if(c)return(0,M.$hc)(c,s[0])}else if(s.length>1){const c=s.indexOf(D);if(c>=0){const u=m(S);if(u)return(0,M.$hc)(u,s[c])}}}catch{}return null}e.$Wp=m;async function k(v){if(l.$f)return v;const S=(0,M.$kc)(v);if(v===S)return v;const D=((0,M.$lc)(v)||v).toLowerCase();try{const s=(await A.Promises.readdir(S)).filter(c=>c.toLowerCase()===D);if(s.length===1){const c=await k(S);if(c)return(0,M.$hc)(c,s[0])}else if(s.length>1){const c=s.indexOf(D);if(c>=0){const u=await k(S);if(u)return(0,M.$hc)(u,s[c])}}}catch{}return null}e.$Xp=k;async function $(v){try{return await A.Promises.realpath(v)}catch{const D=C(v);return await A.Promises.access(D,y.constants.R_OK),D}}e.$Yp=$;function P(v){try{return y.realpathSync(v)}catch{const D=C(v);return y.accessSync(D,y.constants.R_OK),D}}e.$Zp=P;function C(v){return(0,R.$Ie)((0,M.$fc)(v),M.sep)}}),define(Se[166],De([1,0,62]),function(ne,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fg=e.$eg=e.$dg=void 0;function M(m,k,$,P=1){let C=!1;return new Promise(v=>{const S=setTimeout(()=>{if(!C)return C=!0,v(0)},$);l(m,k,P,D=>{if(!C)return C=!0,clearTimeout(S),v(D)})})}e.$dg=M;function l(m,k,$,P){if(k===0)return P(0);const C=new y.Socket;C.once("connect",()=>(A(C),l(m+$,k-1,$,P))),C.once("data",()=>{}),C.once("error",v=>(A(C),v.code!=="ECONNREFUSED"?l(m+$,k-1,$,P):P(m))),C.connect(m,"127.0.0.1")}e.$eg={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function R(m,k,$,P="127.0.0.1"){let C=!1,v,S=1;const D=y.createServer({pauseOnConnect:!0});function E(s,c){C||(C=!0,D.removeAllListeners(),D.close(),v&&clearTimeout(v),c(s))}return new Promise(s=>{v=setTimeout(()=>{E(0,s)},$),D.on("listening",()=>{E(m,s)}),D.on("error",c=>{c&&(c.code==="EADDRINUSE"||c.code==="EACCES")&&S<k?(m++,S++,D.listen(m,P)):E(0,s)}),D.on("close",()=>{E(0,s)}),D.listen(m,P)})}e.$fg=R;function A(m){try{m.removeAllListeners("connect"),m.removeAllListeners("error"),m.end(),m.destroy(),m.unref()}catch(k){console.error(k)}}}),define(Se[102],De([1,0,15,10,46,98,18,29]),function(ne,e,y,M,l,R,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$xl=e.$wl=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return R.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return R.TerminateResponseCode}});function k(C=l.env){return C.comspec||"cmd.exe"}e.$wl=k;function $(C){let v=[],S=!1;const D=function(E){if(S){v.push(E);return}(!C.send(E,c=>{if(c&&console.error(c),S=!1,v.length>0){const u=v.slice(0);v=[],u.forEach(o=>D(o))}})||M.$d)&&(S=!0)};return{send:D}}e.$xl=$;var P;(function(C){async function v(S,D,E){if(y.$gc(S))return S;if(D===void 0&&(D=l.cwd()),y.$kc(S)!=="."||(E===void 0&&A.$wf(l.env.PATH)&&(E=l.env.PATH.split(y.$rc)),E===void 0||E.length===0))return y.$hc(D,S);async function c(u){if(await m.Promises.exists(u)){let o;try{o=await m.Promises.stat(u)}catch(g){g.message.startsWith("EACCES")&&(o=await m.Promises.lstat(u))}return o?!o.isDirectory():!1}return!1}for(const u of E){let o;if(y.$gc(u)?o=y.$hc(u,S):o=y.$hc(D,u,S),await c(o))return o;let g=o+".com";if(await c(g)||(g=o+".exe",await c(g)))return g}return y.$hc(D,S)}C.findExecutable=v})(P||(e.win32=P={}))});var Ke=this&&this.__decorate||function(ne,e,y,M){var l=arguments.length,R=l<3?e:M===null?M=Object.getOwnPropertyDescriptor(e,y):M,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate(ne,e,y,M);else for(var m=ne.length-1;m>=0;m--)(A=ne[m])&&(R=(l<3?A(R):l>3?A(e,y,R):A(e,y))||R);return l>3&&R&&Object.defineProperty(e,y,R),R};define(Se[81],De([1,0,19,9,22,21,56,8,4,3,60,16,18]),function(ne,e,y,M,l,R,A,m,k,$,P,C,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uh=e.ProxyChannel=e.$th=e.$sh=e.$rh=e.$qh=e.$ph=e.$oh=e.RequestInitiator=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=void 0;var S;(function(X){X[X.Promise=100]="Promise",X[X.PromiseCancel=101]="PromiseCancel",X[X.EventListen=102]="EventListen",X[X.EventDispose=103]="EventDispose"})(S||(S={}));function D(X){switch(X){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var E;(function(X){X[X.Initialize=200]="Initialize",X[X.PromiseSuccess=201]="PromiseSuccess",X[X.PromiseError=202]="PromiseError",X[X.PromiseErrorObj=203]="PromiseErrorObj",X[X.EventFire=204]="EventFire"})(E||(E={}));function s(X){switch(X){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var c;(function(X){X[X.Uninitialized=0]="Uninitialized",X[X.Idle=1]="Idle"})(c||(c={}));function u(X){let Q=0;for(let H=0;;H+=7){const te=X.read(1);if(Q|=(te.buffer[0]&127)<<H,!(te.buffer[0]&128))return Q}}const o=r(0);function g(X,Q){if(Q===0){X.write(o);return}let H=0;for(let me=Q;me!==0;me=me>>>7)H++;const te=l.$_d.alloc(H);for(let me=0;Q!==0;me++)te.buffer[me]=Q&127,Q=Q>>>7,Q>0&&(te.buffer[me]|=128);X.write(te)}class d{constructor(Q){this.b=Q,this.a=0}read(Q){const H=this.b.slice(this.a,this.a+Q);return this.a+=H.byteLength,H}}e.$jh=d;class t{constructor(){this.a=[]}get buffer(){return l.$_d.concat(this.a)}write(Q){this.a.push(Q)}}e.$kh=t;var n;(function(X){X[X.Undefined=0]="Undefined",X[X.String=1]="String",X[X.Buffer=2]="Buffer",X[X.VSBuffer=3]="VSBuffer",X[X.Array=4]="Array",X[X.Object=5]="Object",X[X.Int=6]="Int"})(n||(n={}));function r(X){const Q=l.$_d.alloc(1);return Q.writeUInt8(X,0),Q}const i={Undefined:r(n.Undefined),String:r(n.String),Buffer:r(n.Buffer),VSBuffer:r(n.VSBuffer),Array:r(n.Array),Object:r(n.Object),Uint:r(n.Int)},a=typeof Buffer<"u";function h(X,Q){if(typeof Q>"u")X.write(i.Undefined);else if(typeof Q=="string"){const H=l.$_d.fromString(Q);X.write(i.String),g(X,H.byteLength),X.write(H)}else if(a&&Buffer.isBuffer(Q)){const H=l.$_d.wrap(Q);X.write(i.Buffer),g(X,H.byteLength),X.write(H)}else if(Q instanceof l.$_d)X.write(i.VSBuffer),g(X,Q.byteLength),X.write(Q);else if(Array.isArray(Q)){X.write(i.Array),g(X,Q.length);for(const H of Q)h(X,H)}else if(typeof Q=="number"&&(Q|0)===Q)X.write(i.Uint),g(X,Q);else{const H=l.$_d.fromString(JSON.stringify(Q));X.write(i.Object),g(X,H.byteLength),X.write(H)}}e.$lh=h;function p(X){switch(X.read(1).readUInt8(0)){case n.Undefined:return;case n.String:return X.read(u(X)).toString();case n.Buffer:return X.read(u(X)).buffer;case n.VSBuffer:return X.read(u(X));case n.Array:{const H=u(X),te=[];for(let me=0;me<H;me++)te.push(p(X));return te}case n.Object:return JSON.parse(X.read(u(X)).toString());case n.Int:return u(X)}}e.$mh=p;class I{constructor(Q,H,te=null,me=1e3){this.h=Q,this.j=H,this.k=te,this.l=me,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(le=>this.q(le)),this.m({type:200})}registerChannel(Q,H){this.b.set(Q,H),setTimeout(()=>this.w(Q),0)}m(Q){switch(Q.type){case 200:{const H=this.o([Q.type]);this.k?.logOutgoing(H,0,1,s(Q.type));return}case 201:case 202:case 204:case 203:{const H=this.o([Q.type,Q.id],Q.data);this.k?.logOutgoing(H,Q.id,1,s(Q.type),Q.data);return}}}o(Q,H=void 0){const te=new t;return h(te,Q),h(te,H),this.p(te.buffer)}p(Q){try{return this.h.send(Q),Q.byteLength}catch{return 0}}q(Q){const H=new d(Q),te=p(H),me=p(H),le=te[0];switch(le){case 100:return this.k?.logIncoming(Q.byteLength,te[1],1,`${D(le)}: ${te[2]}.${te[3]}`,me),this.s({type:le,id:te[1],channelName:te[2],name:te[3],arg:me});case 102:return this.k?.logIncoming(Q.byteLength,te[1],1,`${D(le)}: ${te[2]}.${te[3]}`,me),this.t({type:le,id:te[1],channelName:te[2],name:te[3],arg:me});case 101:return this.k?.logIncoming(Q.byteLength,te[1],1,`${D(le)}`),this.u({type:le,id:te[1]});case 103:return this.k?.logIncoming(Q.byteLength,te[1],1,`${D(le)}`),this.u({type:le,id:te[1]})}}s(Q){const H=this.b.get(Q.channelName);if(!H){this.v(Q);return}const te=new R.$Vd;let me;try{me=H.call(this.j,Q.name,Q.arg,te.token)}catch(de){me=Promise.reject(de)}const le=Q.id;me.then(de=>{this.m({id:le,data:de,type:201})},de=>{de instanceof Error?this.m({id:le,data:{message:de.message,name:de.name,stack:de.stack?de.stack.split?de.stack.split(`
`):de.stack:void 0},type:202}):this.m({id:le,data:de,type:203})}).finally(()=>{ye.dispose(),this.d.delete(Q.id)});const ye=(0,$.$Oc)(()=>te.cancel());this.d.set(Q.id,ye)}t(Q){const H=this.b.get(Q.channelName);if(!H){this.v(Q);return}const te=Q.id,le=H.listen(this.j,Q.name,Q.arg)(ye=>this.m({id:te,data:ye,type:204}));this.d.set(Q.id,le)}u(Q){const H=this.d.get(Q.id);H&&(H.dispose(),this.d.delete(Q.id))}v(Q){let H=this.g.get(Q.channelName);H||(H=[],this.g.set(Q.channelName,H));const te=setTimeout(()=>{console.error(`Unknown channel: ${Q.channelName}`),Q.type===100&&this.m({id:Q.id,data:{name:"Unknown channel",message:`Channel name '${Q.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);H.push({request:Q,timeoutTimer:te})}w(Q){const H=this.g.get(Q);if(H){for(const te of H)switch(clearTimeout(te.timeoutTimer),te.request.type){case 100:this.s(te.request);break;case 102:this.t(te.request);break}this.g.delete(Q)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,$.$Lc)(this.d.values()),this.d.clear()}}e.$nh=I;var w;(function(X){X[X.LocalSide=0]="LocalSide",X[X.OtherSide=1]="OtherSide"})(w||(e.RequestInitiator=w={}));class f{constructor(Q,H=null){this.l=Q,this.a=!1,this.b=c.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new k.$Ld,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(te=>this.s(te)),this.j=H}getChannel(Q){const H=this;return{call(te,me,le){return H.a?Promise.reject(new m.$3):H.m(Q,te,me,le)},listen(te,me){return H.a?k.Event.None:H.o(Q,te,me)}}}m(Q,H,te,me=R.CancellationToken.None){const le=this.g++,de={id:le,type:100,channelName:Q,name:H,arg:te};if(me.isCancellationRequested)return Promise.reject(new m.$3);let V;return new Promise((ee,Y)=>{if(me.isCancellationRequested)return Y(new m.$3);const Z=()=>{const ge=ie=>{switch(ie.type){case 201:this.f.delete(le),ee(ie.data);break;case 202:{this.f.delete(le);const fe=new Error(ie.data.message);fe.stack=Array.isArray(ie.data.stack)?ie.data.stack.join(`
`):ie.data.stack,fe.name=ie.data.name,Y(fe);break}case 203:this.f.delete(le),Y(ie.data);break}};this.f.set(le,ge),this.p(de)};let _=null;this.b===c.Idle?Z():(_=(0,M.$Eg)(ge=>this.u()),_.then(()=>{_=null,Z()}));const pe=()=>{_?(_.cancel(),_=null):this.p({id:le,type:101}),Y(new m.$3)},se=me.onCancellationRequested(pe);V=(0,$.$Nc)((0,$.$Oc)(pe),se),this.d.add(V)}).finally(()=>{V.dispose(),this.d.delete(V)})}o(Q,H,te){const me=this.g++,ye={id:me,type:102,channelName:Q,name:H,arg:te};let de=null;const V=new k.$Ld({onWillAddFirstListener:()=>{de=(0,M.$Eg)(ee=>this.u()),de.then(()=>{de=null,this.d.add(V),this.p(ye)})},onDidRemoveLastListener:()=>{de?(de.cancel(),de=null):(this.d.delete(V),this.p({id:me,type:103}))}}),J=ee=>V.fire(ee.data);return this.f.set(me,J),V.event}p(Q){switch(Q.type){case 100:case 102:{const H=this.q([Q.type,Q.id,Q.channelName,Q.name],Q.arg);this.j?.logOutgoing(H,Q.id,0,`${D(Q.type)}: ${Q.channelName}.${Q.name}`,Q.arg);return}case 101:case 103:{const H=this.q([Q.type,Q.id]);this.j?.logOutgoing(H,Q.id,0,D(Q.type));return}}}q(Q,H=void 0){const te=new t;return h(te,Q),h(te,H),this.r(te.buffer)}r(Q){try{return this.l.send(Q),Q.byteLength}catch{return 0}}s(Q){const H=new d(Q),te=p(H),me=p(H),le=te[0];switch(le){case 200:return this.j?.logIncoming(Q.byteLength,0,0,s(le)),this.t({type:te[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(Q.byteLength,te[1],0,s(le),me),this.t({type:te[0],id:te[1],data:me})}}t(Q){if(Q.type===200){this.b=c.Idle,this.k.fire();return}this.f.get(Q.id)?.(Q)}get onDidInitializePromise(){return k.Event.toPromise(this.onDidInitialize)}u(){return this.b===c.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,$.$Lc)(this.d.values()),this.d.clear()}}e.$oh=f,Ke([A.$dh],f.prototype,"onDidInitializePromise",null);class b{get connections(){const Q=[];return this.f.forEach(H=>Q.push(H)),Q}constructor(Q){this.a=new Map,this.f=new Set,this.g=new k.$Ld,this.onDidAddConnection=this.g.event,this.h=new k.$Ld,this.onDidRemoveConnection=this.h.event,this.j=new $.$Pc,this.j.add(Q(({protocol:H,onDidClientDisconnect:te})=>{const me=k.Event.once(H.onMessage);this.j.add(me(le=>{const ye=new d(le),de=p(ye),V=new I(H,de),J=new f(H);this.a.forEach((Y,Z)=>V.registerChannel(Z,Y));const ee={channelServer:V,channelClient:J,ctx:de};this.f.add(ee),this.g.fire(ee),this.j.add(te(()=>{V.dispose(),J.dispose(),this.f.delete(ee),this.h.fire(ee)}))}))}))}getChannel(Q,H){const te=this;return{call(me,le,ye){let de;if((0,v.$Kf)(H)){const J=(0,y.$2b)(te.connections.filter(H));de=J?Promise.resolve(J):k.Event.toPromise(k.Event.filter(te.onDidAddConnection,H))}else de=H.routeCall(te,me,le);const V=de.then(J=>J.channelClient.getChannel(Q));return O(V).call(me,le,ye)},listen(me,le){if((0,v.$Kf)(H))return te.k(Q,H,me,le);const ye=H.routeEvent(te,me,le).then(de=>de.channelClient.getChannel(Q));return O(ye).listen(me,le)}}}k(Q,H,te,me){const le=this;let ye;const de=new k.$Ld({onWillAddFirstListener:()=>{ye=new $.$Pc;const V=new k.$Rd,J=new Map,ee=Z=>{const pe=Z.channelClient.getChannel(Q).listen(te,me),se=V.add(pe);J.set(Z,se)},Y=Z=>{const _=J.get(Z);_&&(_.dispose(),J.delete(Z))};le.connections.filter(H).forEach(ee),k.Event.filter(le.onDidAddConnection,H)(ee,void 0,ye),le.onDidRemoveConnection(Y,void 0,ye),V.event(de.fire,de,ye),ye.add(V)},onDidRemoveLastListener:()=>{ye?.dispose(),ye=void 0}});return de.event}registerChannel(Q,H){this.a.set(Q,H);for(const te of this.f)te.channelServer.registerChannel(Q,H)}dispose(){this.j.dispose();for(const Q of this.f)Q.channelClient.dispose(),Q.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$ph=b;class L{constructor(Q,H,te=null){const me=new t;h(me,H),Q.send(me.buffer),this.a=new f(Q,te),this.d=new I(Q,H,te)}getChannel(Q){return this.a.getChannel(Q)}registerChannel(Q,H){this.d.registerChannel(Q,H)}dispose(){this.a.dispose(),this.d.dispose()}}e.$qh=L;function O(X){return{call(Q,H,te){return X.then(me=>me.call(Q,H,te))},listen(Q,H){const te=new k.$Ud;return X.then(me=>te.input=me.listen(Q,H)),te.event}}}e.$rh=O;function T(X){let Q=!1;return{call(H,te,me){return Q?X.call(H,te,me):(0,M.$Rg)(0).then(()=>Q=!0).then(()=>X.call(H,te,me))},listen(H,te){if(Q)return X.listen(H,te);const me=new k.$Ud;return(0,M.$Rg)(0).then(()=>Q=!0).then(()=>me.input=X.listen(H,te)),me.event}}}e.$sh=T;class F{constructor(Q){this.a=Q}routeCall(Q){return this.b(Q)}routeEvent(Q){return this.b(Q)}async b(Q){for(const H of Q.connections)if(await Promise.resolve(this.a(H.ctx)))return Promise.resolve(H);return await k.Event.toPromise(Q.onDidAddConnection),await this.b(Q)}}e.$th=F;var U;(function(X){function Q(le,ye,de){const V=le,J=de&&de.disableMarshalling,ee=new Map;for(const Y in V)te(Y)&&ee.set(Y,k.Event.buffer(V[Y],!0,void 0,ye));return new class{listen(Y,Z,_){const pe=ee.get(Z);if(pe)return pe;if(me(Z)){const se=V[Z];if(typeof se=="function")return se.call(V,_)}throw new m.$_(`Event not found: ${Z}`)}call(Y,Z,_){const pe=V[Z];if(typeof pe=="function"){if(!J&&Array.isArray(_))for(let ge=0;ge<_.length;ge++)_[ge]=(0,P.$ih)(_[ge]);let se=pe.apply(V,_);return se instanceof Promise||(se=Promise.resolve(se)),se}throw new m.$_(`Method not found: ${Z}`)}}}X.fromService=Q;function H(le,ye){const de=ye&&ye.disableMarshalling;return new Proxy({},{get(V,J){if(typeof J=="string")return ye?.properties?.has(J)?ye.properties.get(J):me(J)?function(ee){return le.listen(J,ee)}:te(J)?le.listen(J):async function(...ee){let Y;ye&&!(0,v.$Ff)(ye.context)?Y=[ye.context,...ee]:Y=ee;const Z=await le.call(J,Y);return de?Z:(0,P.$ih)(Z)};throw new m.$_(`Property not found: ${String(J)}`)}})}X.toService=H;function te(le){return le[0]==="o"&&le[1]==="n"&&C.$Ye(le.charCodeAt(2))}function me(le){return/^onDynamic/.test(le)&&C.$Ye(le.charCodeAt(9))}})(U||(e.ProxyChannel=U={}));const N=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function j(X){if(Array.isArray(X))return X;if(X&&typeof X=="object"&&typeof X.toString=="function"){const Q=X.toString();if(Q!=="[object Object]")return Q}return X}function z(X){return Array.isArray(X)?X.map(j):j(X)}function B(X,Q,H,te,me,le,ye){ye=z(ye);const de=N[me],V=de[te%de.length];let J=[`%c[${X}]%c[${String(Q).padStart(7," ")}]%c[len: ${String(H).padStart(5," ")}]%c${String(te).padStart(5," ")} - ${le}`,"color: darkgreen","color: grey","color: grey",`color: ${V}`];/\($/.test(le)?(J=J.concat(ye),J.push(")")):J.push(ye),console.log.apply(console,J)}class ae{constructor(Q,H){this.d=Q,this.f=H,this.a=0,this.b=0}logOutgoing(Q,H,te,me,le){this.b+=Q,B(this.d,this.b,Q,H,te,me,le)}logIncoming(Q,H,te,me,le){this.a+=Q,B(this.f,this.a,Q,H,te,me,le)}}e.$uh=ae}),define(Se[82],De([1,0,22,4,3,81]),function(ne,e,y,M,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zh=e.$yh=e.$xh=e.$wh=e.ProtocolConstants=e.$vh=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var A;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(A||(e.SocketDiagnosticsEventType=A={}));var m;(function(i){i.enableDiagnostics=!1,i.records=[];const a=new WeakMap;let h=0;function p(w,f){if(!a.has(w)){const b=String(++h);a.set(w,b)}return a.get(w)}function I(w,f,b,L){if(!i.enableDiagnostics)return;const O=p(w,f);if(L instanceof y.$_d||L instanceof Uint8Array||L instanceof ArrayBuffer||ArrayBuffer.isView(L)){const T=y.$_d.alloc(L.byteLength);T.set(L),i.records.push({timestamp:Date.now(),id:O,label:f,type:b,buff:T})}else i.records.push({timestamp:Date.now(),id:O,label:f,type:b,data:L})}i.traceSocketEvent=I})(m||(e.SocketDiagnostics=m={}));var k;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(k||(e.SocketCloseEventType=k={}));let $=null;function P(){return $||($=y.$_d.alloc(0)),$}class C{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(a){this.a.push(a),this.b+=a.byteLength}read(a){return this.c(a,!0)}peek(a){return this.c(a,!1)}c(a,h){if(a===0)return P();if(a>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===a){const f=this.a[0];return h&&(this.a.shift(),this.b-=a),f}if(this.a[0].byteLength>a){const f=this.a[0].slice(0,a);return h&&(this.a[0]=this.a[0].slice(a),this.b-=a),f}const p=y.$_d.alloc(a);let I=0,w=0;for(;a>0;){const f=this.a[w];if(f.byteLength>a){const b=f.slice(0,a);p.set(b,I),I+=a,h&&(this.a[w]=f.slice(a),this.b-=a),a-=a}else p.set(f,I),I+=f.byteLength,h?(this.a.shift(),this.b-=f.byteLength):w++,a-=f.byteLength}return p}}e.$vh=C;var v;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume",i[i.KeepAlive=9]="KeepAlive"})(v||(v={}));function S(i){switch(i){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var D;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",i[i.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(D||(e.ProtocolConstants=D={}));class E{constructor(a,h,p,I){this.type=a,this.id=h,this.ack=p,this.data=I,this.writtenTime=0}get size(){return this.data.byteLength}}class s extends l.$Qc{constructor(a){super(),this.f=this.B(new M.$Ld),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=a,this.b=!1,this.c=new C,this.B(this.a.onData(h=>this.acceptChunk(h))),this.lastReadTime=Date.now()}acceptChunk(a){if(!(!a||a.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(a);this.c.byteLength>=this.g.readLen;){const h=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=h.readUInt32BE(9),this.g.messageType=h.readUInt8(0),this.g.id=h.readUInt32BE(1),this.g.ack=h.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:S(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const p=this.g.messageType,I=this.g.id,w=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",h),this.f.fire(new E(p,I,w,h)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class c{constructor(a){this.k=null,this.a=!1,this.b=!1,this.c=a,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(a){if(this.a)return;a.writtenTime=Date.now(),this.lastWriteTime=Date.now();const h=y.$_d.alloc(13);h.writeUInt8(a.type,0),h.writeUInt32BE(a.id,1),h.writeUInt32BE(a.ack,5),h.writeUInt32BE(a.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:S(a.type),id:a.id,ack:a.ack,messageSize:a.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",a.data),this.j(h,a.data)}g(a,h){const p=this.f===0;return this.d.push(a,h),this.f+=a.byteLength+h.byteLength,p}h(){const a=y.$_d.concat(this.d,this.f);return this.d.length=0,this.f=0,a}j(a,h){this.g(a,h)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const a=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:a.byteLength}),this.c.write(a)}}class u extends l.$Qc{constructor(a){super(),this.f=new M.$Ld,this.onMessage=this.f.event,this.g=new M.$Ld,this.onDidDispose=this.g.event,this.a=a,this.b=this.B(new c(this.a)),this.c=this.B(new s(this.a)),this.B(this.c.onMessage(h=>{h.type===1&&this.f.fire(h.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(a){this.b.write(new E(1,0,0,a))}}e.$wh=u;class o extends R.$qh{static fromSocket(a,h){return new o(new u(a),h)}get onDidDispose(){return this.b.onDidDispose}constructor(a,h,p=null){super(a,h,p),this.b=a}dispose(){super.dispose();const a=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),a.end()}}e.$xh=o;class g{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new M.$Ld({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(a){this.b?this.d.length>0?this.d.push(a):this.a.fire(a):this.d.push(a)}flushBuffer(){this.d=[]}}e.$yh=g;class d{constructor(a){this.data=a,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let a=0,h=this.a;for(;h;)h=h.next,a++;return a}peek(){return this.a?this.a.data:null}toArray(){const a=[];let h=0,p=this.a;for(;p;)a[h++]=p.data,p=p.next;return a}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(a){const h=new d(a);if(!this.a){this.a=h,this.b=h;return}this.b.next=h,this.b=h}}class n{static getInstance(){return n.b||(n.b=new n),n.b}constructor(){this.c=[];const a=Date.now();for(let h=0;h<n.a;h++)this.c[h]=a-1e3*h;setInterval(()=>{for(let h=n.a;h>=1;h--)this.c[h]=this.c[h-1];this.c[0]=Date.now()},1e3)}d(){const a=Date.now(),h=(1+n.a)*1e3;let p=0;for(let I=0;I<n.a;I++)a-this.c[I]<=h&&p++;return 1-p/n.a}hasHighLoad(){return this.d()>=.5}}n.a=10,n.b=null;class r{get unacknowledgedCount(){return this.c-this.d}constructor(a){this.u=new g,this.onControlMessage=this.u.event,this.v=new g,this.onMessage=this.v.event,this.w=new g,this.onDidDispose=this.w.event,this.x=new g,this.onSocketClose=this.x.event,this.y=new g,this.onSocketTimeout=this.y.event,this.s=a.loadEstimator??n.getInstance(),this.t=a.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new l.$Pc,this.o=a.socket,this.p=this.r.add(new c(this.o)),this.q=this.r.add(new s(this.o)),this.r.add(this.q.onMessage(h=>this.z(h))),this.r.add(this.o.onClose(h=>this.x.fire(h))),a.initialChunk&&this.q.acceptChunk(a.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const a=new E(5,0,0,P());this.p.write(a),this.p.flush()}sendPause(){const a=new E(7,0,0,P());this.p.write(a)}sendResume(){const a=new E(8,0,0,P());this.p.write(a)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(a,h){this.a=!0,this.r.dispose(),this.r=new l.$Pc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=a,this.p=this.r.add(new c(this.o)),this.q=this.r.add(new s(this.o)),this.r.add(this.q.onMessage(p=>this.z(p))),this.r.add(this.o.onClose(p=>this.x.fire(p))),this.q.acceptChunk(h)}endAcceptReconnection(){this.a=!1,this.h=this.g;const a=new E(3,0,this.h,P());this.p.write(a);const h=this.b.toArray();for(let p=0,I=h.length;p<I;p++)this.p.write(h[p]);this.B()}acceptDisconnect(){this.w.fire()}z(a){if(a.ack>this.d){this.d=a.ack;do{const h=this.b.peek();if(h&&h.id<=a.ack)this.b.pop();else break}while(!0)}switch(a.type){case 0:break;case 1:{if(a.id>this.g)if(a.id!==this.g+1){const h=Date.now();h-this.m>1e4&&(this.m=h,this.p.write(new E(6,0,0,P())))}else this.g=a.id,this.j=Date.now(),this.A(),this.v.fire(a.data);break}case 2:{this.u.fire(a.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const h=this.b.toArray();for(let p=0,I=h.length;p<I;p++)this.p.write(h[p]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(a){const h=++this.c;this.h=this.g;const p=new E(1,h,this.h,a);this.b.push(p),this.a||(this.p.write(p),this.B())}sendControl(a){const h=new E(2,0,0,a);this.p.write(h)}A(){if(this.g<=this.h||this.k)return;const a=Date.now()-this.j;if(a>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-a+5)}B(){if(this.c<=this.d||this.f||this.a)return;const a=this.b.peek(),h=Date.now()-a.writtenTime,p=Date.now()-this.q.lastReadTime,I=Date.now()-this.n;if(h>=2e4&&p>=2e4&&I>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:h,timeSinceLastReceivedSomeData:p});return}const w=Math.max(2e4-h,2e4-p,2e4-I,500);this.f=setTimeout(()=>{this.f=null,this.B()},w)}C(){if(this.g<=this.h)return;this.h=this.g;const a=new E(3,0,this.h,P());this.p.write(a)}D(){this.h=this.g;const a=new E(9,0,this.h,P());this.p.write(a)}}e.$zh=r}),define(Se[167],De([1,0,47,9,22,21,163,8,4,3,23,102,98,81]),function(ne,e,y,M,l,R,A,m,k,$,P,C,v,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Up=e.$Tp=void 0;class D extends S.$nh{constructor(c){super({send:u=>{try{process.send?.(u.buffer.toString("base64"))}catch{}},onMessage:k.Event.fromNodeEventEmitter(process,"message",u=>l.$_d.wrap(Buffer.from(u,"base64")))},c),process.once("disconnect",()=>this.dispose())}}e.$Tp=D;class E{constructor(c,u){this.i=c,this.j=u,this.c=new Set,this.g=new Map,this.h=new k.$Ld,this.onDidProcessExit=this.h.event;const o=u&&u.timeout?u.timeout:6e4;this.b=new M.$Ng(o),this.d=null,this.f=null}getChannel(c){const u=this;return{call(o,g,d){return u.k(c,o,g,d)},listen(o,g){return u.l(c,o,g)}}}k(c,u,o,g=R.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(g.isCancellationRequested)return Promise.reject(m.$4());this.b.cancel();const d=this.n(c),t=(0,M.$Eg)(i=>d.call(u,o,i)),n=g.onCancellationRequested(()=>t.cancel()),r=(0,$.$Oc)(()=>t.cancel());return this.c.add(r),t.finally(()=>{n.dispose(),this.c.delete(r),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(c,u,o){if(!this.b)return k.Event.None;this.b.cancel();let g;const d=new k.$Ld({onWillAddFirstListener:()=>{g=this.n(c).listen(u,o)(d.fire,d),this.c.add(g)},onDidRemoveLastListener:()=>{this.c.delete(g),g.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return d.event}get m(){if(!this.f){const c=this.j&&this.j.args?this.j.args:[],u=Object.create(null);u.env={...(0,P.$Xm)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(u.env={...u.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(u.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(u.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(u.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),u.execArgv===void 0&&(u.execArgv=process.execArgv.filter(a=>!/^--inspect(-brk)?=/.test(a)).filter(a=>!a.startsWith("--vscode-"))),(0,v.$vl)(u.env),this.d=(0,y.fork)(this.i,c,u);const o=new k.$Ld;k.Event.fromNodeEventEmitter(this.d,"message",a=>a)(a=>{if((0,A.$Pp)(a)){(0,A.log)(a,`IPC Library: ${this.j.serverName}`);return}o.fire(l.$_d.wrap(Buffer.from(a,"base64")))});const d=this.j.useQueue?(0,C.$xl)(this.d):this.d,t=a=>this.d&&this.d.connected&&d.send(a.buffer.toString("base64")),n=o.event,r={send:t,onMessage:n};this.f=new S.$oh(r);const i=()=>this.o();process.once("exit",i),this.d.on("error",a=>console.warn('IPC "'+this.j.serverName+'" errored with '+a)),this.d.on("exit",(a,h)=>{process.removeListener("exit",i),this.c.forEach(p=>(0,$.$Lc)(p)),this.c.clear(),a!==0&&h!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+a+" and signal "+h),this.b?.cancel(),this.o(),this.h.fire({code:a,signal:h})})}return this.f}n(c){let u=this.g.get(c);return u||(u=this.m.getChannel(c),this.g.set(c,u)),u}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$Up=E}),define(Se[168],De([1,0,9,4,3,60,18]),function(ne,e,y,M,l,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uo=e.$To=e.StorageState=e.$So=e.StorageHint=void 0;var m;(function(v){v[v.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",v[v.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(m||(e.StorageHint=m={}));function k(v){const S=v;return S?.changed instanceof Map||S?.deleted instanceof Set}e.$So=k;var $;(function(v){v[v.None=0]="None",v[v.Initialized=1]="Initialized",v[v.Closed=2]="Closed"})($||(e.StorageState=$={}));class P extends l.$Qc{constructor(S,D=Object.create(null)){super(),this.r=S,this.s=D,this.b=this.B(new M.$Od),this.onDidChangeStorage=this.b.event,this.c=$.None,this.f=new Map,this.g=this.B(new y.$Og(P.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(S=>this.u(S)))}u(S){this.b.pause();try{S.changed?.forEach((D,E)=>this.w(E,D)),S.deleted?.forEach(D=>this.w(D,void 0))}finally{this.b.resume()}}w(S,D){if(this.c===$.Closed)return;let E=!1;(0,A.$Ff)(D)?E=this.f.delete(S):this.f.get(S)!==D&&(this.f.set(S,D),E=!0),E&&this.b.fire({key:S,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===$.None&&(this.c=$.Initialized,this.s.hint!==m.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(S,D){const E=this.f.get(S);return(0,A.$Ff)(E)?D:E}getBoolean(S,D){const E=this.get(S);return(0,A.$Ff)(E)?D:E==="true"}getNumber(S,D){const E=this.get(S);return(0,A.$Ff)(E)?D:parseInt(E,10)}getObject(S,D){const E=this.get(S);return(0,A.$Ff)(E)?D:(0,R.$hh)(E)}async set(S,D,E=!1){if(this.c===$.Closed)return;if((0,A.$Ff)(D))return this.delete(S,E);const s=(0,A.$yf)(D)||Array.isArray(D)?(0,R.$gh)(D):String(D);if(this.f.get(S)!==s)return this.f.set(S,s),this.j.set(S,s),this.h.delete(S),this.b.fire({key:S,external:E}),this.D()}async delete(S,D=!1){if(!(this.c===$.Closed||!this.f.delete(S)))return this.h.has(S)||this.h.add(S),this.j.delete(S),this.b.fire({key:S,external:D}),this.D()}async optimize(){if(this.c!==$.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=$.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const S={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(S).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(S){if(this.z)return this.D(S)}async D(S){return this.s.hint===m.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),S)}async whenFlushed(){if(this.z)return new Promise(S=>this.n.push(S))}isInMemory(){return this.s.hint===m.STORAGE_IN_MEMORY}}e.$To=P,P.a=100;class C{constructor(){this.onDidChangeItemsExternal=M.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(S){S.insert?.forEach((D,E)=>this.a.set(E,D)),S.delete?.forEach(D=>this.a.delete(D))}async optimize(){}async close(){}}e.$Uo=C}),define(Se[127],De([1,0,125]),function(ne,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ks=e.$Js=void 0;class M{constructor(m){const k=(0,y.$xe)(m);this.c=k,this.a=M.d(k),this.b=new Map}static d(m){const k=new Uint8Array(256);return k.fill(m),k}set(m,k){const $=(0,y.$xe)(k);m>=0&&m<256?this.a[m]=$:this.b.set(m,$)}get(m){return m>=0&&m<256?this.a[m]:this.b.get(m)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}e.$Js=M;var l;(function(A){A[A.False=0]="False",A[A.True=1]="True"})(l||(l={}));class R{constructor(){this.a=new M(0)}add(m){this.a.set(m,1)}has(m){return this.a.get(m)===1}clear(){return this.a.clear()}}e.$Ks=R}),define(Se[63],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ls=void 0;class y{constructor(l,R){this.lineNumber=l,this.column=R}with(l=this.lineNumber,R=this.column){return l===this.lineNumber&&R===this.column?this:new y(l,R)}delta(l=0,R=0){return this.with(this.lineNumber+l,this.column+R)}equals(l){return y.equals(this,l)}static equals(l,R){return!l&&!R?!0:!!l&&!!R&&l.lineNumber===R.lineNumber&&l.column===R.column}isBefore(l){return y.isBefore(this,l)}static isBefore(l,R){return l.lineNumber<R.lineNumber?!0:R.lineNumber<l.lineNumber?!1:l.column<R.column}isBeforeOrEqual(l){return y.isBeforeOrEqual(this,l)}static isBeforeOrEqual(l,R){return l.lineNumber<R.lineNumber?!0:R.lineNumber<l.lineNumber?!1:l.column<=R.column}static compare(l,R){const A=l.lineNumber|0,m=R.lineNumber|0;if(A===m){const k=l.column|0,$=R.column|0;return k-$}return A-m}clone(){return new y(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(l){return new y(l.lineNumber,l.column)}static isIPosition(l){return l&&typeof l.lineNumber=="number"&&typeof l.column=="number"}}e.$ls=y}),define(Se[35],De([1,0,63]),function(ne,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ms=void 0;class M{constructor(R,A,m,k){R>m||R===m&&A>k?(this.startLineNumber=m,this.startColumn=k,this.endLineNumber=R,this.endColumn=A):(this.startLineNumber=R,this.startColumn=A,this.endLineNumber=m,this.endColumn=k)}isEmpty(){return M.isEmpty(this)}static isEmpty(R){return R.startLineNumber===R.endLineNumber&&R.startColumn===R.endColumn}containsPosition(R){return M.containsPosition(this,R)}static containsPosition(R,A){return!(A.lineNumber<R.startLineNumber||A.lineNumber>R.endLineNumber||A.lineNumber===R.startLineNumber&&A.column<R.startColumn||A.lineNumber===R.endLineNumber&&A.column>R.endColumn)}static strictContainsPosition(R,A){return!(A.lineNumber<R.startLineNumber||A.lineNumber>R.endLineNumber||A.lineNumber===R.startLineNumber&&A.column<=R.startColumn||A.lineNumber===R.endLineNumber&&A.column>=R.endColumn)}containsRange(R){return M.containsRange(this,R)}static containsRange(R,A){return!(A.startLineNumber<R.startLineNumber||A.endLineNumber<R.startLineNumber||A.startLineNumber>R.endLineNumber||A.endLineNumber>R.endLineNumber||A.startLineNumber===R.startLineNumber&&A.startColumn<R.startColumn||A.endLineNumber===R.endLineNumber&&A.endColumn>R.endColumn)}strictContainsRange(R){return M.strictContainsRange(this,R)}static strictContainsRange(R,A){return!(A.startLineNumber<R.startLineNumber||A.endLineNumber<R.startLineNumber||A.startLineNumber>R.endLineNumber||A.endLineNumber>R.endLineNumber||A.startLineNumber===R.startLineNumber&&A.startColumn<=R.startColumn||A.endLineNumber===R.endLineNumber&&A.endColumn>=R.endColumn)}plusRange(R){return M.plusRange(this,R)}static plusRange(R,A){let m,k,$,P;return A.startLineNumber<R.startLineNumber?(m=A.startLineNumber,k=A.startColumn):A.startLineNumber===R.startLineNumber?(m=A.startLineNumber,k=Math.min(A.startColumn,R.startColumn)):(m=R.startLineNumber,k=R.startColumn),A.endLineNumber>R.endLineNumber?($=A.endLineNumber,P=A.endColumn):A.endLineNumber===R.endLineNumber?($=A.endLineNumber,P=Math.max(A.endColumn,R.endColumn)):($=R.endLineNumber,P=R.endColumn),new M(m,k,$,P)}intersectRanges(R){return M.intersectRanges(this,R)}static intersectRanges(R,A){let m=R.startLineNumber,k=R.startColumn,$=R.endLineNumber,P=R.endColumn;const C=A.startLineNumber,v=A.startColumn,S=A.endLineNumber,D=A.endColumn;return m<C?(m=C,k=v):m===C&&(k=Math.max(k,v)),$>S?($=S,P=D):$===S&&(P=Math.min(P,D)),m>$||m===$&&k>P?null:new M(m,k,$,P)}equalsRange(R){return M.equalsRange(this,R)}static equalsRange(R,A){return!R&&!A?!0:!!R&&!!A&&R.startLineNumber===A.startLineNumber&&R.startColumn===A.startColumn&&R.endLineNumber===A.endLineNumber&&R.endColumn===A.endColumn}getEndPosition(){return M.getEndPosition(this)}static getEndPosition(R){return new y.$ls(R.endLineNumber,R.endColumn)}getStartPosition(){return M.getStartPosition(this)}static getStartPosition(R){return new y.$ls(R.startLineNumber,R.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(R,A){return new M(this.startLineNumber,this.startColumn,R,A)}setStartPosition(R,A){return new M(R,A,this.endLineNumber,this.endColumn)}collapseToStart(){return M.collapseToStart(this)}static collapseToStart(R){return new M(R.startLineNumber,R.startColumn,R.startLineNumber,R.startColumn)}collapseToEnd(){return M.collapseToEnd(this)}static collapseToEnd(R){return new M(R.endLineNumber,R.endColumn,R.endLineNumber,R.endColumn)}delta(R){return new M(this.startLineNumber+R,this.startColumn,this.endLineNumber+R,this.endColumn)}static fromPositions(R,A=R){return new M(R.lineNumber,R.column,A.lineNumber,A.column)}static lift(R){return R?new M(R.startLineNumber,R.startColumn,R.endLineNumber,R.endColumn):null}static isIRange(R){return R&&typeof R.startLineNumber=="number"&&typeof R.startColumn=="number"&&typeof R.endLineNumber=="number"&&typeof R.endColumn=="number"}static areIntersectingOrTouching(R,A){return!(R.endLineNumber<A.startLineNumber||R.endLineNumber===A.startLineNumber&&R.endColumn<A.startColumn||A.endLineNumber<R.startLineNumber||A.endLineNumber===R.startLineNumber&&A.endColumn<R.startColumn)}static areIntersecting(R,A){return!(R.endLineNumber<A.startLineNumber||R.endLineNumber===A.startLineNumber&&R.endColumn<=A.startColumn||A.endLineNumber<R.startLineNumber||A.endLineNumber===R.startLineNumber&&A.endColumn<=R.startColumn)}static compareRangesUsingStarts(R,A){if(R&&A){const $=R.startLineNumber|0,P=A.startLineNumber|0;if($===P){const C=R.startColumn|0,v=A.startColumn|0;if(C===v){const S=R.endLineNumber|0,D=A.endLineNumber|0;if(S===D){const E=R.endColumn|0,s=A.endColumn|0;return E-s}return S-D}return C-v}return $-P}return(R?1:0)-(A?1:0)}static compareRangesUsingEnds(R,A){return R.endLineNumber===A.endLineNumber?R.endColumn===A.endColumn?R.startLineNumber===A.startLineNumber?R.startColumn-A.startColumn:R.startLineNumber-A.startLineNumber:R.endColumn-A.endColumn:R.endLineNumber-A.endLineNumber}static spansMultipleLines(R){return R.endLineNumber>R.startLineNumber}toJSON(){return this}}e.$ms=M}),define(Se[169],De([1,0,35]),function(ne,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ns=void 0;class M{static insert(R,A){return{range:new y.$ms(R.lineNumber,R.column,R.lineNumber,R.column),text:A,forceMoveMarkers:!0}}static delete(R){return{range:R,text:null}}static replace(R,A){return{range:R,text:A}}static replaceMove(R,A){return{range:R,text:A,forceMoveMarkers:!0}}}e.$ns=M}),define(Se[170],De([1,0,63,35]),function(ne,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$os=e.SelectionDirection=void 0;var l;(function(A){A[A.LTR=0]="LTR",A[A.RTL=1]="RTL"})(l||(e.SelectionDirection=l={}));class R extends M.$ms{constructor(m,k,$,P){super(m,k,$,P),this.selectionStartLineNumber=m,this.selectionStartColumn=k,this.positionLineNumber=$,this.positionColumn=P}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(m){return R.selectionsEqual(this,m)}static selectionsEqual(m,k){return m.selectionStartLineNumber===k.selectionStartLineNumber&&m.selectionStartColumn===k.selectionStartColumn&&m.positionLineNumber===k.positionLineNumber&&m.positionColumn===k.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(m,k){return this.getDirection()===0?new R(this.startLineNumber,this.startColumn,m,k):new R(m,k,this.startLineNumber,this.startColumn)}getPosition(){return new y.$ls(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new y.$ls(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(m,k){return this.getDirection()===0?new R(m,k,this.endLineNumber,this.endColumn):new R(this.endLineNumber,this.endColumn,m,k)}static fromPositions(m,k=m){return new R(m.lineNumber,m.column,k.lineNumber,k.column)}static fromRange(m,k){return k===0?new R(m.startLineNumber,m.startColumn,m.endLineNumber,m.endColumn):new R(m.endLineNumber,m.endColumn,m.startLineNumber,m.startColumn)}static liftSelection(m){return new R(m.selectionStartLineNumber,m.selectionStartColumn,m.positionLineNumber,m.positionColumn)}static selectionsArrEqual(m,k){if(m&&!k||!m&&k)return!1;if(!m&&!k)return!0;if(m.length!==k.length)return!1;for(let $=0,P=m.length;$<P;$++)if(!this.selectionsEqual(m[$],k[$]))return!1;return!0}static isISelection(m){return m&&typeof m.selectionStartLineNumber=="number"&&typeof m.selectionStartColumn=="number"&&typeof m.positionLineNumber=="number"&&typeof m.positionColumn=="number"}static createWithDirection(m,k,$,P,C){return C===0?new R(m,k,$,P):new R($,P,m,k)}}e.$os=R}),define(Se[171],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wr=void 0,e.$Wr={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Se[172],De([1,0,127]),function(ne,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ms=e.$Ls=e.WordCharacterClass=void 0;var M;(function(A){A[A.Regular=0]="Regular",A[A.Whitespace=1]="Whitespace",A[A.WordSeparator=2]="WordSeparator"})(M||(e.WordCharacterClass=M={}));class l extends y.$Js{constructor(m){super(0);for(let k=0,$=m.length;k<$;k++)this.set(m.charCodeAt(k),2);this.set(32,1),this.set(9,1)}}e.$Ls=l;function R(A){const m={};return k=>(m.hasOwnProperty(k)||(m[k]=A(k)),m[k])}e.$Ms=R(A=>new l(A))}),define(Se[128],De([1,0,50,3,76]),function(ne,e,y,M,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2r=e.$1r=e.$Zr=e.$Yr=e.$Xr=void 0,e.$Xr="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function R(C=""){let v="(-?\\d*\\.\\d\\w*)|([^";for(const S of e.$Xr)C.indexOf(S)>=0||(v+="\\"+S);return v+="\\s]+)",new RegExp(v,"g")}e.$Yr=R();function A(C){let v=e.$Yr;if(C&&C instanceof RegExp)if(C.global)v=C;else{let S="g";C.ignoreCase&&(S+="i"),C.multiline&&(S+="m"),C.unicode&&(S+="u"),v=new RegExp(C.source,S)}return v.lastIndex=0,v}e.$Zr=A;const m=new l.$Zc;m.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function k(C){const v=m.unshift(C);return(0,M.$Oc)(v)}e.$1r=k;function $(C,v,S,D,E){if(E||(E=y.Iterable.first(m)),S.length>E.maxLen){let g=C-E.maxLen/2;return g<0?g=0:D+=g,S=S.substring(g,C+E.maxLen/2),$(C,v,S,D,E)}const s=Date.now(),c=C-1-D;let u=-1,o=null;for(let g=1;!(Date.now()-s>=E.timeBudget);g++){const d=c-E.windowSize*g;v.lastIndex=Math.max(0,d);const t=P(v,S,c,u);if(!t&&o||(o=t,d<=0))break;u=d}if(o){const g={word:o[0],startColumn:D+1+o.index,endColumn:D+1+o.index+o[0].length};return v.lastIndex=0,g}return null}e.$2r=$;function P(C,v,S,D){let E;for(;E=C.exec(v);){const s=E.index||0;if(s<=S&&C.lastIndex>=S)return E;if(D>0&&s>D)return null}return null}}),define(Se[173],De([1,0,34,15]),function(ne,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iE=void 0;function l(R,A,m,k,$,P){if(Array.isArray(R)){let C=0;for(const v of R){const S=l(v,A,m,k,$,P);if(S===10)return S;S>C&&(C=S)}return C}else{if(typeof R=="string")return k?R==="*"?5:R===m?10:0:0;if(R){const{language:C,pattern:v,scheme:S,hasAccessToAllModels:D,notebookType:E}=R;if(!k&&!D)return 0;E&&$&&(A=$);let s=0;if(S)if(S===A.scheme)s=10;else if(S==="*")s=5;else return 0;if(C)if(C===m)s=10;else if(C==="*")s=Math.max(s,5);else return 0;if(E)if(E===P)s=10;else if(E==="*"&&P!==void 0)s=Math.max(s,5);else return 0;if(v){let c;if(typeof v=="string"?c=v:c={...v,base:(0,M.$fc)(v.base)},c===A.fsPath||(0,y.$rj)(c,A.fsPath))s=10;else return 0}return s}else return 0}}e.$iE=l}),define(Se[174],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jt=e.$it=e.IndentAction=void 0;var y;(function(A){A[A.None=0]="None",A[A.Indent=1]="Indent",A[A.IndentOutdent=2]="IndentOutdent",A[A.Outdent=3]="Outdent"})(y||(e.IndentAction=y={}));class M{constructor(m){if(this.e=null,this.f=!1,this.open=m.open,this.close=m.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(m.notIn))for(let k=0,$=m.notIn.length;k<$;k++)switch(m.notIn[k]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(m){switch(m){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(m,k){if(m.getTokenCount()===0)return!0;const $=m.findTokenIndexAtOffset(k-2),P=m.getStandardTokenType($);return this.isOK(P)}g(m,k){for(let $=m;$<=k;$++){const P=String.fromCharCode($);if(!this.open.includes(P)&&!this.close.includes(P))return P}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$it=M;class l{constructor(m){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const k of m)R(this.autoClosingPairsOpenByStart,k.open.charAt(0),k),R(this.autoClosingPairsOpenByEnd,k.open.charAt(k.open.length-1),k),R(this.autoClosingPairsCloseByStart,k.close.charAt(0),k),R(this.autoClosingPairsCloseByEnd,k.close.charAt(k.close.length-1),k),k.close.length===1&&k.open.length===1&&R(this.autoClosingPairsCloseSingleChar,k.close,k)}}e.$jt=l;function R(A,m,k){A.has(m)?A.get(m).push(k):A.set(m,[k])}}),define(Se[175],De([1,0,127]),function(ne,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NY=e.$MY=e.$LY=e.State=void 0;var M;(function(S){S[S.Invalid=0]="Invalid",S[S.Start=1]="Start",S[S.H=2]="H",S[S.HT=3]="HT",S[S.HTT=4]="HTT",S[S.HTTP=5]="HTTP",S[S.F=6]="F",S[S.FI=7]="FI",S[S.FIL=8]="FIL",S[S.BeforeColon=9]="BeforeColon",S[S.AfterColon=10]="AfterColon",S[S.AlmostThere=11]="AlmostThere",S[S.End=12]="End",S[S.Accept=13]="Accept",S[S.LastKnownState=14]="LastKnownState"})(M||(e.State=M={}));class l{constructor(D,E,s){const c=new Uint8Array(D*E);for(let u=0,o=D*E;u<o;u++)c[u]=s;this.a=c,this.rows=D,this.cols=E}get(D,E){return this.a[D*this.cols+E]}set(D,E,s){this.a[D*this.cols+E]=s}}class R{constructor(D){let E=0,s=0;for(let u=0,o=D.length;u<o;u++){const[g,d,t]=D[u];d>E&&(E=d),g>s&&(s=g),t>s&&(s=t)}E++,s++;const c=new l(s,E,0);for(let u=0,o=D.length;u<o;u++){const[g,d,t]=D[u];c.set(g,d,t)}this.a=c,this.b=E}nextState(D,E){return E<0||E>=this.b?0:this.a.get(D,E)}}e.$LY=R;let A=null;function m(){return A===null&&(A=new R([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),A}var k;(function(S){S[S.None=0]="None",S[S.ForceTermination=1]="ForceTermination",S[S.CannotEndIn=2]="CannotEndIn"})(k||(k={}));let $=null;function P(){if($===null){$=new y.$Js(0);const S=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let E=0;E<S.length;E++)$.set(S.charCodeAt(E),1);const D=".,;:";for(let E=0;E<D.length;E++)$.set(D.charCodeAt(E),2)}return $}class C{static a(D,E,s,c,u){let o=u-1;do{const g=E.charCodeAt(o);if(D.get(g)!==2)break;o--}while(o>c);if(c>0){const g=E.charCodeAt(c-1),d=E.charCodeAt(o);(g===40&&d===41||g===91&&d===93||g===123&&d===125)&&o--}return{range:{startLineNumber:s,startColumn:c+1,endLineNumber:s,endColumn:o+2},url:E.substring(c,o+1)}}static computeLinks(D,E=m()){const s=P(),c=[];for(let u=1,o=D.getLineCount();u<=o;u++){const g=D.getLineContent(u),d=g.length;let t=0,n=0,r=0,i=1,a=!1,h=!1,p=!1,I=!1;for(;t<d;){let w=!1;const f=g.charCodeAt(t);if(i===13){let b;switch(f){case 40:a=!0,b=0;break;case 41:b=a?0:1;break;case 91:p=!0,h=!0,b=0;break;case 93:p=!1,b=h?0:1;break;case 123:I=!0,b=0;break;case 125:b=I?0:1;break;case 39:case 34:case 96:r===f?b=1:r===39||r===34||r===96?b=0:b=1;break;case 42:b=r===42?1:0;break;case 124:b=r===124?1:0;break;case 32:b=p?0:1;break;default:b=s.get(f)}b===1&&(c.push(C.a(s,g,u,n,t)),w=!0)}else if(i===12){let b;f===91?(h=!0,b=0):b=s.get(f),b===1?w=!0:i=13}else i=E.nextState(i,f),i===0&&(w=!0);w&&(i=1,a=!1,h=!1,I=!1,n=t+1,r=f),t++}i===13&&c.push(C.a(s,g,u,n,d))}return c}}e.$MY=C;function v(S){return!S||typeof S.getLineCount!="function"||typeof S.getLineContent!="function"?[]:C.computeLinks(S)}e.$NY=v}),define(Se[129],De([1,0,23]),function(ne,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iu=e.$Hu=e.$Gu=e.$Fu=e.ModelConstants=e.PositionAffinity=e.$Eu=e.TrackedRangeStickiness=e.$Du=e.$Cu=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.GlyphMarginLane=e.OverviewRulerLane=void 0;var M;(function(g){g[g.Left=1]="Left",g[g.Center=2]="Center",g[g.Right=4]="Right",g[g.Full=7]="Full"})(M||(e.OverviewRulerLane=M={}));var l;(function(g){g[g.Left=1]="Left",g[g.Right=2]="Right"})(l||(e.GlyphMarginLane=l={}));var R;(function(g){g[g.Inline=1]="Inline",g[g.Gutter=2]="Gutter"})(R||(e.MinimapPosition=R={}));var A;(function(g){g[g.Both=0]="Both",g[g.Right=1]="Right",g[g.Left=2]="Left",g[g.None=3]="None"})(A||(e.InjectedTextCursorStops=A={}));var m;(function(g){g[g.TextDefined=0]="TextDefined",g[g.LF=1]="LF",g[g.CRLF=2]="CRLF"})(m||(e.EndOfLinePreference=m={}));var k;(function(g){g[g.LF=1]="LF",g[g.CRLF=2]="CRLF"})(k||(e.DefaultEndOfLine=k={}));var $;(function(g){g[g.LF=0]="LF",g[g.CRLF=1]="CRLF"})($||(e.EndOfLineSequence=$={}));class P{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(d){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,d.tabSize|0),d.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,d.indentSize|0),this.a=!1),this.insertSpaces=!!d.insertSpaces,this.defaultEOL=d.defaultEOL|0,this.trimAutoWhitespace=!!d.trimAutoWhitespace,this.bracketPairColorizationOptions=d.bracketPairColorizationOptions}equals(d){return this.tabSize===d.tabSize&&this.a===d.a&&this.indentSize===d.indentSize&&this.insertSpaces===d.insertSpaces&&this.defaultEOL===d.defaultEOL&&this.trimAutoWhitespace===d.trimAutoWhitespace&&(0,y.$2m)(this.bracketPairColorizationOptions,d.bracketPairColorizationOptions)}createChangeEvent(d){return{tabSize:this.tabSize!==d.tabSize,indentSize:this.indentSize!==d.indentSize,insertSpaces:this.insertSpaces!==d.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==d.trimAutoWhitespace}}}e.$Cu=P;class C{constructor(d,t){this._findMatchBrand=void 0,this.range=d,this.matches=t}}e.$Du=C;var v;(function(g){g[g.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",g[g.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",g[g.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",g[g.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(v||(e.TrackedRangeStickiness=v={}));function S(g){return g&&typeof g.read=="function"}e.$Eu=S;var D;(function(g){g[g.Left=0]="Left",g[g.Right=1]="Right",g[g.None=2]="None",g[g.LeftOfInjectedText=3]="LeftOfInjectedText",g[g.RightOfInjectedText=4]="RightOfInjectedText"})(D||(e.PositionAffinity=D={}));var E;(function(g){g[g.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(E||(e.ModelConstants=E={}));class s{constructor(d,t,n,r,i,a){this.identifier=d,this.range=t,this.text=n,this.forceMoveMarkers=r,this.isAutoWhitespaceEdit=i,this._isTracked=a}}e.$Fu=s;class c{constructor(d,t,n){this.regex=d,this.wordSeparators=t,this.simpleSearch=n}}e.$Gu=c;class u{constructor(d,t,n){this.reverseEdits=d,this.changes=t,this.trimAutoWhitespaceLineNumbers=n}}e.$Hu=u;function o(g){return!g.isTooLargeForSyncing()&&!g.isForSimpleWidget}e.$Iu=o}),define(Se[176],De([1,0,19,125]),function(ne,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nu=e.$Mu=e.$Lu=void 0;class l{constructor(k){this.a=k,this.b=new Uint32Array(k.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(k,$){k=(0,M.$ye)(k);const P=this.a,C=this.b,v=$.length;return v===0?!1:(this.a=new Uint32Array(P.length+v),this.a.set(P.subarray(0,k),0),this.a.set(P.subarray(k),k+v),this.a.set($,k),k-1<this.c[0]&&(this.c[0]=k-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(C.subarray(0,this.c[0]+1)),!0)}setValue(k,$){return k=(0,M.$ye)(k),$=(0,M.$ye)($),this.a[k]===$?!1:(this.a[k]=$,k-1<this.c[0]&&(this.c[0]=k-1),!0)}removeValues(k,$){k=(0,M.$ye)(k),$=(0,M.$ye)($);const P=this.a,C=this.b;if(k>=P.length)return!1;const v=P.length-k;return $>=v&&($=v),$===0?!1:(this.a=new Uint32Array(P.length-$),this.a.set(P.subarray(0,k),0),this.a.set(P.subarray(k+$),k),this.b=new Uint32Array(this.a.length),k-1<this.c[0]&&(this.c[0]=k-1),this.c[0]>=0&&this.b.set(C.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(k){return k<0?0:(k=(0,M.$ye)(k),this.d(k))}d(k){if(k<=this.c[0])return this.b[k];let $=this.c[0]+1;$===0&&(this.b[0]=this.a[0],$++),k>=this.a.length&&(k=this.a.length-1);for(let P=$;P<=k;P++)this.b[P]=this.b[P-1]+this.a[P];return this.c[0]=Math.max(this.c[0],k),this.b[k]}getIndexOf(k){k=Math.floor(k),this.getTotalSum();let $=0,P=this.a.length-1,C=0,v=0,S=0;for(;$<=P;)if(C=$+(P-$)/2|0,v=this.b[C],S=v-this.a[C],k<S)P=C-1;else if(k>=v)$=C+1;else break;return new A(C,k-S)}}e.$Lu=l;class R{constructor(k){this.a=k,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(k){return this.g(),k===0?0:this.d[k-1]}getIndexOf(k){this.g();const $=this.e[k],P=$>0?this.d[$-1]:0;return new A($,k-P)}removeValues(k,$){this.a.splice(k,$),this.f(k)}insertValues(k,$){this.a=(0,y.$Ub)(this.a,k,$),this.f(k)}f(k){this.b=!1,this.c=Math.min(this.c,k-1)}g(){if(!this.b){for(let k=this.c+1,$=this.a.length;k<$;k++){const P=this.a[k],C=k>0?this.d[k-1]:0;this.d[k]=C+P;for(let v=0;v<P;v++)this.e[C+v]=k}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(k,$){this.a[k]!==$&&(this.a[k]=$,this.f(k))}}e.$Mu=R;class A{constructor(k,$){this.index=k,this.remainder=$,this._prefixSumIndexOfResultBrand=void 0,this.index=k,this.remainder=$}}e.$Nu=A}),define(Se[177],De([1,0,16,63,176]),function(ne,e,y,M,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ou=void 0;class R{constructor(m,k,$,P){this.d=m,this.f=k,this.g=$,this.h=P,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents(m){m.eol&&m.eol!==this.g&&(this.g=m.eol,this.j=null);const k=m.changes;for(const $ of k)this.o($.range),this.p(new M.$ls($.range.startLineNumber,$.range.startColumn),$.text);this.h=m.versionId,this.k=null}l(){if(!this.j){const m=this.g.length,k=this.f.length,$=new Uint32Array(k);for(let P=0;P<k;P++)$[P]=this.f[P].length+m;this.j=new l.$Lu($)}}n(m,k){this.f[m]=k,this.j&&this.j.setValue(m,this.f[m].length+this.g.length)}o(m){if(m.startLineNumber===m.endLineNumber){if(m.startColumn===m.endColumn)return;this.n(m.startLineNumber-1,this.f[m.startLineNumber-1].substring(0,m.startColumn-1)+this.f[m.startLineNumber-1].substring(m.endColumn-1));return}this.n(m.startLineNumber-1,this.f[m.startLineNumber-1].substring(0,m.startColumn-1)+this.f[m.endLineNumber-1].substring(m.endColumn-1)),this.f.splice(m.startLineNumber,m.endLineNumber-m.startLineNumber),this.j&&this.j.removeValues(m.startLineNumber,m.endLineNumber-m.startLineNumber)}p(m,k){if(k.length===0)return;const $=(0,y.$Ne)(k);if($.length===1){this.n(m.lineNumber-1,this.f[m.lineNumber-1].substring(0,m.column-1)+$[0]+this.f[m.lineNumber-1].substring(m.column-1));return}$[$.length-1]+=this.f[m.lineNumber-1].substring(m.column-1),this.n(m.lineNumber-1,this.f[m.lineNumber-1].substring(0,m.column-1)+$[0]);const P=new Uint32Array($.length-1);for(let C=1;C<$.length;C++)this.f.splice(m.lineNumber+C-1,0,$[C]),P[C-1]=$[C].length+this.g.length;this.j&&this.j.insertValues(m.lineNumber,P)}}e.$Ou=R}),define(Se[178],De([1,0,16,172,63,35,129]),function(ne,e,y,M,l,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qB=e.$pB=e.$oB=e.$nB=e.$mB=e.$lB=void 0;const m=999;class k{constructor(u,o,g,d){this.searchString=u,this.isRegex=o,this.matchCase=g,this.wordSeparators=d}parseSearchRequest(){if(this.searchString==="")return null;let u;this.isRegex?u=$(this.searchString):u=this.searchString.indexOf(`
`)>=0;let o=null;try{o=y.$Le(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:u,global:!0,unicode:!0})}catch{return null}if(!o)return null;let g=!this.isRegex&&!u;return g&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(g=this.matchCase),new A.$Gu(o,this.wordSeparators?(0,M.$Ms)(this.wordSeparators):null,g?this.searchString:null)}}e.$lB=k;function $(c){if(!c||c.length===0)return!1;for(let u=0,o=c.length;u<o;u++){const g=c.charCodeAt(u);if(g===10)return!0;if(g===92){if(u++,u>=o)break;const d=c.charCodeAt(u);if(d===110||d===114||d===87)return!0}}return!1}e.$mB=$;function P(c,u,o){if(!o)return new A.$Du(c,null);const g=[];for(let d=0,t=u.length;d<t;d++)g[d]=u[d];return new A.$Du(c,g)}e.$nB=P;class C{constructor(u){const o=[];let g=0;for(let d=0,t=u.length;d<t;d++)u.charCodeAt(d)===10&&(o[g++]=d);this.a=o}findLineFeedCountBeforeOffset(u){const o=this.a;let g=0,d=o.length-1;if(d===-1||u<=o[0])return 0;for(;g<d;){const t=g+((d-g)/2>>0);o[t]>=u?d=t-1:o[t+1]>=u?(g=t,d=t):g=t+1}return g+1}}class v{static findMatches(u,o,g,d,t){const n=o.parseSearchRequest();return n?n.regex.multiline?this.b(u,g,new s(n.wordSeparators,n.regex),d,t):this.c(u,g,n,d,t):[]}static a(u,o,g,d,t,n){let r,i=0;d?(i=d.findLineFeedCountBeforeOffset(t),r=o+t+i):r=o+t;let a;if(d){const w=d.findLineFeedCountBeforeOffset(t+n.length)-i;a=r+n.length+w}else a=r+n.length;const h=u.getPositionAt(r),p=u.getPositionAt(a);return new R.$ms(h.lineNumber,h.column,p.lineNumber,p.column)}static b(u,o,g,d,t){const n=u.getOffsetAt(o.getStartPosition()),r=u.getValueInRange(o,1),i=u.getEOL()===`\r
`?new C(r):null,a=[];let h=0,p;for(g.reset(0);p=g.next(r);)if(a[h++]=P(this.a(u,n,r,i,p.index,p[0]),p,d),h>=t)return a;return a}static c(u,o,g,d,t){const n=[];let r=0;if(o.startLineNumber===o.endLineNumber){const a=u.getLineContent(o.startLineNumber).substring(o.startColumn-1,o.endColumn-1);return r=this.d(g,a,o.startLineNumber,o.startColumn-1,r,n,d,t),n}const i=u.getLineContent(o.startLineNumber).substring(o.startColumn-1);r=this.d(g,i,o.startLineNumber,o.startColumn-1,r,n,d,t);for(let a=o.startLineNumber+1;a<o.endLineNumber&&r<t;a++)r=this.d(g,u.getLineContent(a),a,0,r,n,d,t);if(r<t){const a=u.getLineContent(o.endLineNumber).substring(0,o.endColumn-1);r=this.d(g,a,o.endLineNumber,0,r,n,d,t)}return n}static d(u,o,g,d,t,n,r,i){const a=u.wordSeparators;if(!r&&u.simpleSearch){const I=u.simpleSearch,w=I.length,f=o.length;let b=-w;for(;(b=o.indexOf(I,b+w))!==-1;)if((!a||E(a,o,f,b,w))&&(n[t++]=new A.$Du(new R.$ms(g,b+1+d,g,b+1+w+d),null),t>=i))return t;return t}const h=new s(u.wordSeparators,u.regex);let p;h.reset(0);do if(p=h.next(o),p&&(n[t++]=P(new R.$ms(g,p.index+1+d,g,p.index+1+p[0].length+d),p,r),t>=i))return t;while(p);return t}static findNextMatch(u,o,g,d){const t=o.parseSearchRequest();if(!t)return null;const n=new s(t.wordSeparators,t.regex);return t.regex.multiline?this.e(u,g,n,d):this.f(u,g,n,d)}static e(u,o,g,d){const t=new l.$ls(o.lineNumber,1),n=u.getOffsetAt(t),r=u.getLineCount(),i=u.getValueInRange(new R.$ms(t.lineNumber,t.column,r,u.getLineMaxColumn(r)),1),a=u.getEOL()===`\r
`?new C(i):null;g.reset(o.column-1);const h=g.next(i);return h?P(this.a(u,n,i,a,h.index,h[0]),h,d):o.lineNumber!==1||o.column!==1?this.e(u,new l.$ls(1,1),g,d):null}static f(u,o,g,d){const t=u.getLineCount(),n=o.lineNumber,r=u.getLineContent(n),i=this.g(g,r,n,o.column,d);if(i)return i;for(let a=1;a<=t;a++){const h=(n+a-1)%t,p=u.getLineContent(h+1),I=this.g(g,p,h+1,1,d);if(I)return I}return null}static g(u,o,g,d,t){u.reset(d-1);const n=u.next(o);return n?P(new R.$ms(g,n.index+1,g,n.index+1+n[0].length),n,t):null}static findPreviousMatch(u,o,g,d){const t=o.parseSearchRequest();if(!t)return null;const n=new s(t.wordSeparators,t.regex);return t.regex.multiline?this.h(u,g,n,d):this.j(u,g,n,d)}static h(u,o,g,d){const t=this.b(u,new R.$ms(1,1,o.lineNumber,o.column),g,d,10*m);if(t.length>0)return t[t.length-1];const n=u.getLineCount();return o.lineNumber!==n||o.column!==u.getLineMaxColumn(n)?this.h(u,new l.$ls(n,u.getLineMaxColumn(n)),g,d):null}static j(u,o,g,d){const t=u.getLineCount(),n=o.lineNumber,r=u.getLineContent(n).substring(0,o.column-1),i=this.k(g,r,n,d);if(i)return i;for(let a=1;a<=t;a++){const h=(t+n-a-1)%t,p=u.getLineContent(h+1),I=this.k(g,p,h+1,d);if(I)return I}return null}static k(u,o,g,d){let t=null,n;for(u.reset(0);n=u.next(o);)t=P(new R.$ms(g,n.index+1,g,n.index+1+n[0].length),n,d);return t}}e.$oB=v;function S(c,u,o,g,d){if(g===0)return!0;const t=u.charCodeAt(g-1);if(c.get(t)!==0||t===13||t===10)return!0;if(d>0){const n=u.charCodeAt(g);if(c.get(n)!==0)return!0}return!1}function D(c,u,o,g,d){if(g+d===o)return!0;const t=u.charCodeAt(g+d);if(c.get(t)!==0||t===13||t===10)return!0;if(d>0){const n=u.charCodeAt(g+d-1);if(c.get(n)!==0)return!0}return!1}function E(c,u,o,g,d){return S(c,u,o,g,d)&&D(c,u,o,g,d)}e.$pB=E;class s{constructor(u,o){this._wordSeparators=u,this.a=o,this.b=-1,this.c=0}reset(u){this.a.lastIndex=u,this.b=-1,this.c=0}next(u){const o=u.length;let g;do{if(this.b+this.c===o||(g=this.a.exec(u),!g))return null;const d=g.index,t=g[0].length;if(d===this.b&&t===this.c){if(t===0){y.$7e(u,o,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=d,this.c=t,!this._wordSeparators||E(this._wordSeparators,u,o,d,t))return g}while(g);return null}}e.$qB=s}),define(Se[130],De([1,0,22,10]),function(ne,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J0=e.$I0=void 0;var l;(function(C){C[C.Full=1]="Full",C[C.Delta=2]="Delta"})(l||(l={}));function R(C){for(let v=0,S=C.length;v<S;v+=4){const D=C[v+0],E=C[v+1],s=C[v+2],c=C[v+3];C[v+0]=c,C[v+1]=s,C[v+2]=E,C[v+3]=D}}function A(C){const v=new Uint8Array(C.buffer,C.byteOffset,C.length*4);return M.$x()||R(v),y.$_d.wrap(v)}function m(C){const v=C.buffer;if(M.$x()||R(v),v.byteOffset%4===0)return new Uint32Array(v.buffer,v.byteOffset,v.length/4);{const S=new Uint8Array(v.byteLength);return S.set(v),new Uint32Array(S.buffer,S.byteOffset,S.length/4)}}function k(C){const v=new Uint32Array($(C));let S=0;if(v[S++]=C.id,C.type==="full")v[S++]=1,v[S++]=C.data.length,v.set(C.data,S),S+=C.data.length;else{v[S++]=2,v[S++]=C.deltas.length;for(const D of C.deltas)v[S++]=D.start,v[S++]=D.deleteCount,D.data?(v[S++]=D.data.length,v.set(D.data,S),S+=D.data.length):v[S++]=0}return A(v)}e.$I0=k;function $(C){let v=0;if(v+=1+1,C.type==="full")v+=1+C.data.length;else{v+=1,v+=(1+1+1)*C.deltas.length;for(const S of C.deltas)S.data&&(v+=S.data.length)}return v}function P(C){const v=m(C);let S=0;const D=v[S++];if(v[S++]===1){const u=v[S++],o=v.subarray(S,S+u);return S+=u,{id:D,type:"full",data:o}}const s=v[S++],c=[];for(let u=0;u<s;u++){const o=v[S++],g=v[S++],d=v[S++];let t;d>0&&(t=v.subarray(S,S+d),S+=d),c[u]={start:o,deleteCount:g,data:t}}return{id:D,type:"delta",deltas:c}}e.$J0=P}),define(Se[179],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$z7=e.$y7=void 0;class y{constructor(){this.a=new Map}removeDragOperationTransfer(R){if(R&&this.a.has(R)){const A=this.a.get(R);return this.a.delete(R),A}}addDragOperationTransfer(R,A){this.a.set(R,A)}}e.$y7=y;class M{constructor(R){this.identifier=R}}e.$z7=M}),define(Se[180],De([1,0,4,3]),function(ne,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xs=void 0;class l{constructor(){this.a=new Map,this.b=new Map,this.c=new y.$Ld,this.onDidChange=this.c.event,this.d=null}handleChange(m){this.c.fire({changedLanguages:m,changedColorMap:!1})}register(m,k){return this.a.set(m,k),this.handleChange([m]),(0,M.$Oc)(()=>{this.a.get(m)===k&&(this.a.delete(m),this.handleChange([m]))})}get(m){return this.a.get(m)||null}registerFactory(m,k){this.b.get(m)?.dispose();const $=new R(this,m,k);return this.b.set(m,$),(0,M.$Oc)(()=>{const P=this.b.get(m);!P||P!==$||(this.b.delete(m),P.dispose())})}async getOrCreate(m){const k=this.get(m);if(k)return k;const $=this.b.get(m);return!$||$.isResolved?null:(await $.resolve(),this.get(m))}isResolved(m){if(this.get(m))return!0;const $=this.b.get(m);return!!(!$||$.isResolved)}setColorMap(m){this.d=m,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.$Xs=l;class R extends M.$Qc{get isResolved(){return this.c}constructor(m,k,$){super(),this.f=m,this.g=k,this.h=$,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const m=await this.h.tokenizationSupport;this.c=!0,m&&!this.a&&this.B(this.f.register(this.g,m))}}}),define(Se[181],De([11,12]),function(ne,e){return ne.create("vs/base/common/actions",e)}),define(Se[182],De([1,0,4,3,181]),function(ne,e,y,M,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vi=e.$ui=e.$ti=e.$si=e.$ri=e.$qi=void 0;class R extends M.$Qc{constructor(v,S="",D="",E=!0,s){super(),this.h=this.B(new y.$Ld),this.onDidChange=this.h.event,this.w=!0,this.j=v,this.m=S,this.u=D,this.w=E,this.C=s}get id(){return this.j}get label(){return this.m}set label(v){this.D(v)}D(v){this.m!==v&&(this.m=v,this.h.fire({label:v}))}get tooltip(){return this.n||""}set tooltip(v){this.F(v)}F(v){this.n!==v&&(this.n=v,this.h.fire({tooltip:v}))}get class(){return this.u}set class(v){this.G(v)}G(v){this.u!==v&&(this.u=v,this.h.fire({class:v}))}get enabled(){return this.w}set enabled(v){this.H(v)}H(v){this.w!==v&&(this.w=v,this.h.fire({enabled:v}))}get checked(){return this.z}set checked(v){this.I(v)}I(v){this.z!==v&&(this.z=v,this.h.fire({checked:v}))}async run(v,S){this.C&&await this.C(v)}}e.$qi=R;class A extends M.$Qc{constructor(){super(...arguments),this.f=this.B(new y.$Ld),this.onWillRun=this.f.event,this.m=this.B(new y.$Ld),this.onDidRun=this.m.event}async run(v,S){if(!v.enabled)return;this.f.fire({action:v});let D;try{await this.u(v,S)}catch(E){D=E}this.m.fire({action:v,error:D})}async u(v,S){await v.run(S)}}e.$ri=A;class m{constructor(){this.id=m.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...v){let S=[];for(const D of v)D.length&&(S.length?S=[...S,new m,...D]:S=D);return S}async run(){}}e.$si=m,m.ID="vs.actions.separator";class k{get actions(){return this.a}constructor(v,S,D,E){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=v,this.label=S,this.class=E,this.a=D}async run(){}}e.$ti=k;class $ extends R{constructor(){super($.ID,l.localize(0,null),void 0,!1)}}e.$ui=$,$.ID="vs.actions.empty";function P(C){return{id:C.id,label:C.label,class:void 0,enabled:C.enabled??!0,checked:C.checked??!1,run:async(...v)=>C.run(...v),tooltip:C.label}}e.$vi=P}),define(Se[183],De([11,12]),function(ne,e){return ne.create("vs/base/common/date",e)}),define(Se[184],De([1,0,183]),function(ne,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9l=e.$8l=void 0;const M=60,l=M*60,R=l*24,A=R*7,m=R*30,k=R*365;function $(C,v,S,D){typeof C!="number"&&(C=C.getTime());const E=Math.round((new Date().getTime()-C)/1e3);if(E<-30)return(0,y.localize)(0,null,$(new Date().getTime()+E*1e3,!1));if(!D&&E<30)return(0,y.localize)(1,null);let s;return E<M?(s=E,v?s===1?S?(0,y.localize)(2,null,s):(0,y.localize)(3,null,s):S?(0,y.localize)(4,null,s):(0,y.localize)(5,null,s):s===1?S?(0,y.localize)(6,null,s):(0,y.localize)(7,null,s):S?(0,y.localize)(8,null,s):(0,y.localize)(9,null,s)):E<l?(s=Math.floor(E/M),v?s===1?S?(0,y.localize)(10,null,s):(0,y.localize)(11,null,s):S?(0,y.localize)(12,null,s):(0,y.localize)(13,null,s):s===1?S?(0,y.localize)(14,null,s):(0,y.localize)(15,null,s):S?(0,y.localize)(16,null,s):(0,y.localize)(17,null,s)):E<R?(s=Math.floor(E/l),v?s===1?S?(0,y.localize)(18,null,s):(0,y.localize)(19,null,s):S?(0,y.localize)(20,null,s):(0,y.localize)(21,null,s):s===1?S?(0,y.localize)(22,null,s):(0,y.localize)(23,null,s):S?(0,y.localize)(24,null,s):(0,y.localize)(25,null,s)):E<A?(s=Math.floor(E/R),v?s===1?(0,y.localize)(26,null,s):(0,y.localize)(27,null,s):s===1?(0,y.localize)(28,null,s):(0,y.localize)(29,null,s)):E<m?(s=Math.floor(E/A),v?s===1?S?(0,y.localize)(30,null,s):(0,y.localize)(31,null,s):S?(0,y.localize)(32,null,s):(0,y.localize)(33,null,s):s===1?S?(0,y.localize)(34,null,s):(0,y.localize)(35,null,s):S?(0,y.localize)(36,null,s):(0,y.localize)(37,null,s)):E<k?(s=Math.floor(E/m),v?s===1?S?(0,y.localize)(38,null,s):(0,y.localize)(39,null,s):S?(0,y.localize)(40,null,s):(0,y.localize)(41,null,s):s===1?S?(0,y.localize)(42,null,s):(0,y.localize)(43,null,s):S?(0,y.localize)(44,null,s):(0,y.localize)(45,null,s)):(s=Math.floor(E/k),v?s===1?S?(0,y.localize)(46,null,s):(0,y.localize)(47,null,s):S?(0,y.localize)(48,null,s):(0,y.localize)(49,null,s):s===1?S?(0,y.localize)(50,null,s):(0,y.localize)(51,null,s):S?(0,y.localize)(52,null,s):(0,y.localize)(53,null,s))}e.$8l=$;function P(C){return C.getFullYear()+"-"+String(C.getMonth()+1).padStart(2,"0")+"-"+String(C.getDate()).padStart(2,"0")+"T"+String(C.getHours()).padStart(2,"0")+":"+String(C.getMinutes()).padStart(2,"0")+":"+String(C.getSeconds()).padStart(2,"0")+"."+(C.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$9l=P}),define(Se[185],De([11,12]),function(ne,e){return ne.create("vs/base/common/errorMessage",e)}),define(Se[48],De([1,0,19,18,185]),function(ne,e,y,M,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yi=e.$xi=e.$wi=void 0;function R(C,v){return v&&(C.stack||C.stacktrace)?l.localize(0,null,m(C),A(C.stack)||A(C.stacktrace)):m(C)}function A(C){return Array.isArray(C)?C.join(`
`):C}function m(C){return C.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${C.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof C.code=="string"&&typeof C.errno=="number"&&typeof C.syscall=="string"?l.localize(1,null,C.message):C.message||l.localize(2,null)}function k(C=null,v=!1){if(!C)return l.localize(3,null);if(Array.isArray(C)){const S=y.$Fb(C),D=k(S[0],v);return S.length>1?l.localize(4,null,D,S.length):D}if(M.$wf(C))return C;if(C.detail){const S=C.detail;if(S.error)return R(S.error,v);if(S.exception)return R(S.exception,v)}return C.stack?R(C,v):C.message?C.message:l.localize(5,null)}e.$wi=k;function $(C){const v=C;return v instanceof Error&&Array.isArray(v.actions)}e.$xi=$;function P(C,v){let S;return typeof C=="string"?S=new Error(C):S=C,S.actions=v,S}e.$yi=P}),define(Se[186],De([11,12]),function(ne,e){return ne.create("vs/editor/common/config/editorOptions",e)}),define(Se[131],De([1,0,19,23,10,171,128,186]),function(ne,e,y,M,l,R,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var k;(function(ue){ue[ue.None=0]="None",ue[ue.Keep=1]="Keep",ue[ue.Brackets=2]="Brackets",ue[ue.Advanced=3]="Advanced",ue[ue.Full=4]="Full"})(k||(e.EditorAutoIndentStrategy=k={})),e.MINIMAP_GUTTER_WIDTH=8;class ${constructor(oe){this.c=oe}hasChanged(oe){return this.c[oe]}}e.ConfigurationChangedEvent=$;class P{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=P;class C{constructor(oe,Ce,He,ze){this.id=oe,this.name=Ce,this.defaultValue=He,this.schema=ze}applyUpdate(oe,Ce){return S(oe,Ce)}compute(oe,Ce,He){return He}}class v{constructor(oe,Ce){this.newValue=oe,this.didChange=Ce}}e.ApplyUpdateResult=v;function S(ue,oe){if(typeof ue!="object"||typeof oe!="object"||!ue||!oe)return new v(oe,ue!==oe);if(Array.isArray(ue)||Array.isArray(oe)){const He=Array.isArray(ue)&&Array.isArray(oe)&&y.$sb(ue,oe);return new v(oe,!He)}let Ce=!1;for(const He in oe)if(oe.hasOwnProperty(He)){const ze=S(ue[He],oe[He]);ze.didChange&&(ue[He]=ze.newValue,Ce=!0)}return new v(ue,Ce)}class D{constructor(oe){this.schema=void 0,this.id=oe,this.name="_never_",this.defaultValue=void 0}applyUpdate(oe,Ce){return S(oe,Ce)}validate(oe){return this.defaultValue}}class E{constructor(oe,Ce,He,ze){this.id=oe,this.name=Ce,this.defaultValue=He,this.schema=ze}applyUpdate(oe,Ce){return S(oe,Ce)}validate(oe){return typeof oe>"u"?this.defaultValue:oe}compute(oe,Ce,He){return He}}function s(ue,oe){return typeof ue>"u"?oe:ue==="false"?!1:!!ue}e.boolean=s;class c extends E{constructor(oe,Ce,He,ze=void 0){typeof ze<"u"&&(ze.type="boolean",ze.default=He),super(oe,Ce,He,ze)}validate(oe){return s(oe,this.defaultValue)}}function u(ue,oe,Ce,He){if(typeof ue>"u")return oe;let ze=parseInt(ue,10);return isNaN(ze)?oe:(ze=Math.max(Ce,ze),ze=Math.min(He,ze),ze|0)}e.clampedInt=u;class o extends E{static clampedInt(oe,Ce,He,ze){return u(oe,Ce,He,ze)}constructor(oe,Ce,He,ze,Ze,st=void 0){typeof st<"u"&&(st.type="integer",st.default=He,st.minimum=ze,st.maximum=Ze),super(oe,Ce,He,st),this.minimum=ze,this.maximum=Ze}validate(oe){return o.clampedInt(oe,this.defaultValue,this.minimum,this.maximum)}}function g(ue,oe,Ce,He){if(typeof ue>"u")return oe;const ze=d.float(ue,oe);return d.clamp(ze,Ce,He)}e.clampedFloat=g;class d extends E{static clamp(oe,Ce,He){return oe<Ce?Ce:oe>He?He:oe}static float(oe,Ce){if(typeof oe=="number")return oe;if(typeof oe>"u")return Ce;const He=parseFloat(oe);return isNaN(He)?Ce:He}constructor(oe,Ce,He,ze,Ze){typeof Ze<"u"&&(Ze.type="number",Ze.default=He),super(oe,Ce,He,Ze),this.validationFn=ze}validate(oe){return this.validationFn(d.float(oe,this.defaultValue))}}class t extends E{static string(oe,Ce){return typeof oe!="string"?Ce:oe}constructor(oe,Ce,He,ze=void 0){typeof ze<"u"&&(ze.type="string",ze.default=He),super(oe,Ce,He,ze)}validate(oe){return t.string(oe,this.defaultValue)}}function n(ue,oe,Ce,He){return typeof ue!="string"?oe:He&&ue in He?He[ue]:Ce.indexOf(ue)===-1?oe:ue}e.stringSet=n;class r extends E{constructor(oe,Ce,He,ze,Ze=void 0){typeof Ze<"u"&&(Ze.type="string",Ze.enum=ze,Ze.default=He),super(oe,Ce,He,Ze),this.c=ze}validate(oe){return n(oe,this.defaultValue,this.c)}}class i extends C{constructor(oe,Ce,He,ze,Ze,st,lt=void 0){typeof lt<"u"&&(lt.type="string",lt.enum=Ze,lt.default=ze),super(oe,Ce,He,lt),this.c=Ze,this.d=st}validate(oe){return typeof oe!="string"?this.defaultValue:this.c.indexOf(oe)===-1?this.defaultValue:this.d(oe)}}function a(ue){switch(ue){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class h extends C{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[m.localize(0,null),m.localize(1,null),m.localize(2,null)],default:"auto",tags:["accessibility"],description:m.localize(3,null)})}validate(oe){switch(oe){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(oe,Ce,He){return He===0?oe.accessibilitySupport:He}}class p extends C{constructor(){const oe={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",oe,{"editor.comments.insertSpace":{type:"boolean",default:oe.insertSpace,description:m.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:oe.ignoreEmptyLines,description:m.localize(5,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ce=oe;return{insertSpace:s(Ce.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:s(Ce.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var I;(function(ue){ue[ue.Hidden=0]="Hidden",ue[ue.Blink=1]="Blink",ue[ue.Smooth=2]="Smooth",ue[ue.Phase=3]="Phase",ue[ue.Expand=4]="Expand",ue[ue.Solid=5]="Solid"})(I||(e.TextEditorCursorBlinkingStyle=I={}));function w(ue){switch(ue){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var f;(function(ue){ue[ue.Line=1]="Line",ue[ue.Block=2]="Block",ue[ue.Underline=3]="Underline",ue[ue.LineThin=4]="LineThin",ue[ue.BlockOutline=5]="BlockOutline",ue[ue.UnderlineThin=6]="UnderlineThin"})(f||(e.TextEditorCursorStyle=f={}));function b(ue){switch(ue){case f.Line:return"line";case f.Block:return"block";case f.Underline:return"underline";case f.LineThin:return"line-thin";case f.BlockOutline:return"block-outline";case f.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=b;function L(ue){switch(ue){case"line":return f.Line;case"block":return f.Block;case"underline":return f.Underline;case"line-thin":return f.LineThin;case"block-outline":return f.BlockOutline;case"underline-thin":return f.UnderlineThin}}class O extends D{constructor(){super(140)}compute(oe,Ce,He){const ze=["monaco-editor"];return Ce.get(39)&&ze.push(Ce.get(39)),oe.extraEditorClassName&&ze.push(oe.extraEditorClassName),Ce.get(73)==="default"?ze.push("mouse-default"):Ce.get(73)==="copy"&&ze.push("mouse-copy"),Ce.get(110)&&ze.push("showUnused"),Ce.get(138)&&ze.push("showDeprecated"),ze.join(" ")}}class T extends c{constructor(){super(37,"emptySelectionClipboard",!0,{description:m.localize(6,null)})}compute(oe,Ce,He){return He&&oe.emptySelectionClipboard}}class F extends C{constructor(){const oe={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",oe,{"editor.find.cursorMoveOnType":{type:"boolean",default:oe.cursorMoveOnType,description:m.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:oe.seedSearchStringFromSelection,enumDescriptions:[m.localize(8,null),m.localize(9,null),m.localize(10,null)],description:m.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:oe.autoFindInSelection,enumDescriptions:[m.localize(12,null),m.localize(13,null),m.localize(14,null)],description:m.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:oe.globalFindClipboard,description:m.localize(16,null),included:l.$e},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:oe.addExtraSpaceOnTop,description:m.localize(17,null)},"editor.find.loop":{type:"boolean",default:oe.loop,description:m.localize(18,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ce=oe;return{cursorMoveOnType:s(Ce.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof oe.seedSearchStringFromSelection=="boolean"?oe.seedSearchStringFromSelection?"always":"never":n(Ce.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof oe.autoFindInSelection=="boolean"?oe.autoFindInSelection?"always":"never":n(Ce.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:s(Ce.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:s(Ce.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:s(Ce.loop,this.defaultValue.loop)}}}class U extends C{constructor(){super(51,"fontLigatures",U.OFF,{anyOf:[{type:"boolean",description:m.localize(19,null)},{type:"string",description:m.localize(20,null)}],description:m.localize(21,null),default:!1})}validate(oe){return typeof oe>"u"?this.defaultValue:typeof oe=="string"?oe==="false"?U.OFF:oe==="true"?U.ON:oe:oe?U.ON:U.OFF}}e.EditorFontLigatures=U,U.OFF='"liga" off, "calt" off',U.ON='"liga" on, "calt" on';class N extends C{constructor(){super(54,"fontVariations",N.OFF,{anyOf:[{type:"boolean",description:m.localize(22,null)},{type:"string",description:m.localize(23,null)}],description:m.localize(24,null),default:!1})}validate(oe){return typeof oe>"u"?this.defaultValue:typeof oe=="string"?oe==="false"?N.OFF:oe==="true"?N.TRANSLATE:oe:oe?N.TRANSLATE:N.OFF}compute(oe,Ce,He){return oe.fontInfo.fontVariationSettings}}e.EditorFontVariations=N,N.OFF="normal",N.TRANSLATE="translate";class j extends D{constructor(){super(50)}compute(oe,Ce,He){return oe.fontInfo}}class z extends E{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:m.localize(25,null)})}validate(oe){const Ce=d.float(oe,this.defaultValue);return Ce===0?e.EDITOR_FONT_DEFAULTS.fontSize:d.clamp(Ce,6,100)}compute(oe,Ce,He){return oe.fontInfo.fontSize}}class B extends C{constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:B.d,maximum:B.e,errorMessage:m.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:B.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:m.localize(27,null)})}validate(oe){return oe==="normal"||oe==="bold"?oe:String(o.clampedInt(oe,e.EDITOR_FONT_DEFAULTS.fontWeight,B.d,B.e))}}B.c=["normal","bold","100","200","300","400","500","600","700","800","900"],B.d=1,B.e=1e3;class ae extends C{constructor(){const oe={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Ce={type:"string",enum:["peek","gotoAndPeek","goto"],default:oe.multiple,enumDescriptions:[m.localize(28,null),m.localize(29,null),m.localize(30,null)]},He=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",oe,{"editor.gotoLocation.multiple":{deprecationMessage:m.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:m.localize(32,null),...Ce},"editor.gotoLocation.multipleTypeDefinitions":{description:m.localize(33,null),...Ce},"editor.gotoLocation.multipleDeclarations":{description:m.localize(34,null),...Ce},"editor.gotoLocation.multipleImplementations":{description:m.localize(35,null),...Ce},"editor.gotoLocation.multipleReferences":{description:m.localize(36,null),...Ce},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:oe.alternativeDefinitionCommand,enum:He,description:m.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:oe.alternativeTypeDefinitionCommand,enum:He,description:m.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:oe.alternativeDeclarationCommand,enum:He,description:m.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:oe.alternativeImplementationCommand,enum:He,description:m.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:oe.alternativeReferenceCommand,enum:He,description:m.localize(41,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ce=oe;return{multiple:n(Ce.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Ce.multipleDefinitions??n(Ce.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Ce.multipleTypeDefinitions??n(Ce.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Ce.multipleDeclarations??n(Ce.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Ce.multipleImplementations??n(Ce.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Ce.multipleReferences??n(Ce.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:t.string(Ce.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:t.string(Ce.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:t.string(Ce.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:t.string(Ce.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:t.string(Ce.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class X extends C{constructor(){const oe={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",oe,{"editor.hover.enabled":{type:"boolean",default:oe.enabled,description:m.localize(42,null)},"editor.hover.delay":{type:"number",default:oe.delay,minimum:0,maximum:1e4,description:m.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:oe.sticky,description:m.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:oe.hidingDelay,description:m.localize(45,null)},"editor.hover.above":{type:"boolean",default:oe.above,description:m.localize(46,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ce=oe;return{enabled:s(Ce.enabled,this.defaultValue.enabled),delay:o.clampedInt(Ce.delay,this.defaultValue.delay,0,1e4),sticky:s(Ce.sticky,this.defaultValue.sticky),hidingDelay:o.clampedInt(Ce.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:s(Ce.above,this.defaultValue.above)}}}var Q;(function(ue){ue[ue.None=0]="None",ue[ue.Text=1]="Text",ue[ue.Blocks=2]="Blocks"})(Q||(e.RenderMinimap=Q={}));class H extends D{constructor(){super(143)}compute(oe,Ce,He){return H.computeLayout(Ce,{memory:oe.memory,outerWidth:oe.outerWidth,outerHeight:oe.outerHeight,isDominatedByLongLines:oe.isDominatedByLongLines,lineHeight:oe.fontInfo.lineHeight,viewLineCount:oe.viewLineCount,lineNumbersDigitCount:oe.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:oe.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:oe.fontInfo.maxDigitWidth,pixelRatio:oe.pixelRatio,glyphMarginDecorationLaneCount:oe.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(oe){const Ce=oe.height/oe.lineHeight,He=Math.floor(oe.paddingTop/oe.lineHeight);let ze=Math.floor(oe.paddingBottom/oe.lineHeight);oe.scrollBeyondLastLine&&(ze=Math.max(ze,Ce-1));const Ze=(He+oe.viewLineCount+ze)/(oe.pixelRatio*oe.height),st=Math.floor(oe.viewLineCount/Ze);return{typicalViewportLineCount:Ce,extraLinesBeforeFirstLine:He,extraLinesBeyondLastLine:ze,desiredRatio:Ze,minimapLineCount:st}}static c(oe,Ce){const He=oe.outerWidth,ze=oe.outerHeight,Ze=oe.pixelRatio;if(!oe.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Ze*ze),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:ze};const st=Ce.stableMinimapLayoutInput,lt=st&&oe.outerHeight===st.outerHeight&&oe.lineHeight===st.lineHeight&&oe.typicalHalfwidthCharacterWidth===st.typicalHalfwidthCharacterWidth&&oe.pixelRatio===st.pixelRatio&&oe.scrollBeyondLastLine===st.scrollBeyondLastLine&&oe.paddingTop===st.paddingTop&&oe.paddingBottom===st.paddingBottom&&oe.minimap.enabled===st.minimap.enabled&&oe.minimap.side===st.minimap.side&&oe.minimap.size===st.minimap.size&&oe.minimap.showSlider===st.minimap.showSlider&&oe.minimap.renderCharacters===st.minimap.renderCharacters&&oe.minimap.maxColumn===st.minimap.maxColumn&&oe.minimap.scale===st.minimap.scale&&oe.verticalScrollbarWidth===st.verticalScrollbarWidth&&oe.isViewportWrapping===st.isViewportWrapping,wt=oe.lineHeight,Ct=oe.typicalHalfwidthCharacterWidth,Xt=oe.scrollBeyondLastLine,qt=oe.minimap.renderCharacters;let vt=Ze>=2?Math.round(oe.minimap.scale*2):oe.minimap.scale;const Nt=oe.minimap.maxColumn,jt=oe.minimap.size,Yt=oe.minimap.side,Ut=oe.verticalScrollbarWidth,zt=oe.viewLineCount,Ht=oe.remainingWidth,Gt=oe.isViewportWrapping,Bt=qt?2:3;let Kt=Math.floor(Ze*ze);const Jt=Kt/Ze;let ct=!1,mt=!1,It=Bt*vt,Rt=vt/Ze,Pt=1;if(jt==="fill"||jt==="fit"){const{typicalViewportLineCount:Te,extraLinesBeforeFirstLine:Pe,extraLinesBeyondLastLine:re,desiredRatio:Oe,minimapLineCount:qe}=H.computeContainedMinimapLineCount({viewLineCount:zt,scrollBeyondLastLine:Xt,paddingTop:oe.paddingTop,paddingBottom:oe.paddingBottom,height:ze,lineHeight:wt,pixelRatio:Ze});if(zt/qe>1)ct=!0,mt=!0,vt=1,It=1,Rt=vt/Ze;else{let Ge=!1,ot=vt+1;if(jt==="fit"){const pt=Math.ceil((Pe+zt+re)*It);Gt&&lt&&Ht<=Ce.stableFitRemainingWidth?(Ge=!0,ot=Ce.stableFitMaxMinimapScale):Ge=pt>Kt}if(jt==="fill"||Ge){ct=!0;const pt=vt;It=Math.min(wt*Ze,Math.max(1,Math.floor(1/Oe))),Gt&&lt&&Ht<=Ce.stableFitRemainingWidth&&(ot=Ce.stableFitMaxMinimapScale),vt=Math.min(ot,Math.max(1,Math.floor(It/Bt))),vt>pt&&(Pt=Math.min(2,vt/pt)),Rt=vt/Ze/Pt,Kt=Math.ceil(Math.max(Te,Pe+zt+re)*It),Gt?(Ce.stableMinimapLayoutInput=oe,Ce.stableFitRemainingWidth=Ht,Ce.stableFitMaxMinimapScale=vt):(Ce.stableMinimapLayoutInput=null,Ce.stableFitRemainingWidth=0)}}}const gt=Math.floor(Nt*Rt),St=Math.min(gt,Math.max(0,Math.floor((Ht-Ut-2)*Rt/(Ct+Rt)))+e.MINIMAP_GUTTER_WIDTH);let At=Math.floor(Ze*St);const Ft=At/Ze;At=Math.floor(At*Pt);const Xe=qt?1:2,Me=Yt==="left"?0:He-St-Ut;return{renderMinimap:Xe,minimapLeft:Me,minimapWidth:St,minimapHeightIsEditorHeight:ct,minimapIsSampling:mt,minimapScale:vt,minimapLineHeight:It,minimapCanvasInnerWidth:At,minimapCanvasInnerHeight:Kt,minimapCanvasOuterWidth:Ft,minimapCanvasOuterHeight:Jt}}static computeLayout(oe,Ce){const He=Ce.outerWidth|0,ze=Ce.outerHeight|0,Ze=Ce.lineHeight|0,st=Ce.lineNumbersDigitCount|0,lt=Ce.typicalHalfwidthCharacterWidth,wt=Ce.maxDigitWidth,Ct=Ce.pixelRatio,Xt=Ce.viewLineCount,qt=oe.get(135),vt=qt==="inherit"?oe.get(134):qt,Nt=vt==="inherit"?oe.get(130):vt,jt=oe.get(133),Yt=Ce.isDominatedByLongLines,Ut=oe.get(57),zt=oe.get(67).renderType!==0,Ht=oe.get(68),Gt=oe.get(104),Bt=oe.get(83),Kt=oe.get(72),Jt=oe.get(102),ct=Jt.verticalScrollbarSize,mt=Jt.verticalHasArrows,It=Jt.arrowSize,Rt=Jt.horizontalScrollbarSize,Pt=oe.get(43),gt=oe.get(109)!=="never";let St=oe.get(65);Pt&&gt&&(St+=16);let At=0;if(zt){const yt=Math.max(st,Ht);At=Math.round(yt*wt)}let Ft=0;Ut&&(Ft=Ze*Ce.glyphMarginDecorationLaneCount);let Xe=0,Me=Xe+Ft,Te=Me+At,Pe=Te+St;const re=He-Ft-At-St;let Oe=!1,qe=!1,_e=-1;vt==="inherit"&&Yt?(Oe=!0,qe=!0):Nt==="on"||Nt==="bounded"?qe=!0:Nt==="wordWrapColumn"&&(_e=jt);const Ge=H.c({outerWidth:He,outerHeight:ze,lineHeight:Ze,typicalHalfwidthCharacterWidth:lt,pixelRatio:Ct,scrollBeyondLastLine:Gt,paddingTop:Bt.top,paddingBottom:Bt.bottom,minimap:Kt,verticalScrollbarWidth:ct,viewLineCount:Xt,remainingWidth:re,isViewportWrapping:qe},Ce.memory||new P);Ge.renderMinimap!==0&&Ge.minimapLeft===0&&(Xe+=Ge.minimapWidth,Me+=Ge.minimapWidth,Te+=Ge.minimapWidth,Pe+=Ge.minimapWidth);const ot=re-Ge.minimapWidth,pt=Math.max(1,Math.floor((ot-ct-2)/lt)),Mt=mt?It:0;return qe&&(_e=Math.max(1,pt),Nt==="bounded"&&(_e=Math.min(_e,jt))),{width:He,height:ze,glyphMarginLeft:Xe,glyphMarginWidth:Ft,glyphMarginDecorationLaneCount:Ce.glyphMarginDecorationLaneCount,lineNumbersLeft:Me,lineNumbersWidth:At,decorationsLeft:Te,decorationsWidth:St,contentLeft:Pe,contentWidth:ot,minimap:Ge,viewportColumn:pt,isWordWrapMinified:Oe,isViewportWrapping:qe,wrappingColumn:_e,verticalScrollbarWidth:ct,horizontalScrollbarHeight:Rt,overviewRuler:{top:Mt,width:ct,height:ze-2*Mt,right:0}}}}e.EditorLayoutInfoComputer=H;class te extends C{constructor(){super(137,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[m.localize(47,null),m.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:m.localize(49,null)}})}validate(oe){return n(oe,"simple",["simple","advanced"])}compute(oe,Ce,He){return Ce.get(2)===2?"advanced":He}}class me extends C{constructor(){const oe={enabled:!0};super(64,"lightbulb",oe,{"editor.lightbulb.enabled":{type:"boolean",default:oe.enabled,description:m.localize(50,null)}})}validate(oe){return!oe||typeof oe!="object"?this.defaultValue:{enabled:s(oe.enabled,this.defaultValue.enabled)}}}class le extends C{constructor(){const oe={enabled:!1,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(114,"stickyScroll",oe,{"editor.stickyScroll.enabled":{type:"boolean",default:oe.enabled,description:m.localize(51,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:oe.maxLineCount,minimum:1,maximum:10,description:m.localize(52,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:oe.defaultModel,description:m.localize(53,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:oe.scrollWithEditor,description:m.localize(54,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ce=oe;return{enabled:s(Ce.enabled,this.defaultValue.enabled),maxLineCount:o.clampedInt(Ce.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:n(Ce.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:s(Ce.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class ye extends C{constructor(){const oe={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(139,"inlayHints",oe,{"editor.inlayHints.enabled":{type:"string",default:oe.enabled,description:m.localize(55,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[m.localize(56,null),m.localize(57,null,l.$e?"Ctrl+Option":"Ctrl+Alt"),m.localize(58,null,l.$e?"Ctrl+Option":"Ctrl+Alt"),m.localize(59,null)]},"editor.inlayHints.fontSize":{type:"number",default:oe.fontSize,markdownDescription:m.localize(60,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:oe.fontFamily,markdownDescription:m.localize(61,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:oe.padding,description:m.localize(62,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ce=oe;return typeof Ce.enabled=="boolean"&&(Ce.enabled=Ce.enabled?"on":"off"),{enabled:n(Ce.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:o.clampedInt(Ce.fontSize,this.defaultValue.fontSize,0,100),fontFamily:t.string(Ce.fontFamily,this.defaultValue.fontFamily),padding:s(Ce.padding,this.defaultValue.padding)}}}class de extends C{constructor(){super(65,"lineDecorationsWidth",10)}validate(oe){return typeof oe=="string"&&/^\d+(\.\d+)?ch$/.test(oe)?-parseFloat(oe.substring(0,oe.length-2)):o.clampedInt(oe,this.defaultValue,0,1e3)}compute(oe,Ce,He){return He<0?o.clampedInt(-He*oe.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):He}}class V extends d{constructor(){super(66,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,oe=>d.clamp(oe,0,150),{markdownDescription:m.localize(63,null)})}compute(oe,Ce,He){return oe.fontInfo.lineHeight}}class J extends C{constructor(){const oe={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(72,"minimap",oe,{"editor.minimap.enabled":{type:"boolean",default:oe.enabled,description:m.localize(64,null)},"editor.minimap.autohide":{type:"boolean",default:oe.autohide,description:m.localize(65,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[m.localize(66,null),m.localize(67,null),m.localize(68,null)],default:oe.size,description:m.localize(69,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:oe.side,description:m.localize(70,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:oe.showSlider,description:m.localize(71,null)},"editor.minimap.scale":{type:"number",default:oe.scale,minimum:1,maximum:3,enum:[1,2,3],description:m.localize(72,null)},"editor.minimap.renderCharacters":{type:"boolean",default:oe.renderCharacters,description:m.localize(73,null)},"editor.minimap.maxColumn":{type:"number",default:oe.maxColumn,description:m.localize(74,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ce=oe;return{enabled:s(Ce.enabled,this.defaultValue.enabled),autohide:s(Ce.autohide,this.defaultValue.autohide),size:n(Ce.size,this.defaultValue.size,["proportional","fill","fit"]),side:n(Ce.side,this.defaultValue.side,["right","left"]),showSlider:n(Ce.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:s(Ce.renderCharacters,this.defaultValue.renderCharacters),scale:o.clampedInt(Ce.scale,1,1,3),maxColumn:o.clampedInt(Ce.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function ee(ue){return ue==="ctrlCmd"?l.$e?"metaKey":"ctrlKey":"altKey"}class Y extends C{constructor(){super(83,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:m.localize(75,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:m.localize(76,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ce=oe;return{top:o.clampedInt(Ce.top,0,0,1e3),bottom:o.clampedInt(Ce.bottom,0,0,1e3)}}}class Z extends C{constructor(){const oe={enabled:!0,cycle:!0};super(85,"parameterHints",oe,{"editor.parameterHints.enabled":{type:"boolean",default:oe.enabled,description:m.localize(77,null)},"editor.parameterHints.cycle":{type:"boolean",default:oe.cycle,description:m.localize(78,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ce=oe;return{enabled:s(Ce.enabled,this.defaultValue.enabled),cycle:s(Ce.cycle,this.defaultValue.cycle)}}}class _ extends D{constructor(){super(141)}compute(oe,Ce,He){return oe.pixelRatio}}class pe extends C{constructor(){const oe={other:"on",comments:"off",strings:"off"},Ce=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[m.localize(79,null),m.localize(80,null),m.localize(81,null)]}];super(88,"quickSuggestions",oe,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Ce,default:oe.strings,description:m.localize(82,null)},comments:{anyOf:Ce,default:oe.comments,description:m.localize(83,null)},other:{anyOf:Ce,default:oe.other,description:m.localize(84,null)}},default:oe,markdownDescription:m.localize(85,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=oe}validate(oe){if(typeof oe=="boolean"){const Ct=oe?"on":"off";return{comments:Ct,strings:Ct,other:Ct}}if(!oe||typeof oe!="object")return this.defaultValue;const{other:Ce,comments:He,strings:ze}=oe,Ze=["on","inline","off"];let st,lt,wt;return typeof Ce=="boolean"?st=Ce?"on":"off":st=n(Ce,this.defaultValue.other,Ze),typeof He=="boolean"?lt=He?"on":"off":lt=n(He,this.defaultValue.comments,Ze),typeof ze=="boolean"?wt=ze?"on":"off":wt=n(ze,this.defaultValue.strings,Ze),{other:st,comments:lt,strings:wt}}}var se;(function(ue){ue[ue.Off=0]="Off",ue[ue.On=1]="On",ue[ue.Relative=2]="Relative",ue[ue.Interval=3]="Interval",ue[ue.Custom=4]="Custom"})(se||(e.RenderLineNumbersType=se={}));class ge extends C{constructor(){super(67,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[m.localize(86,null),m.localize(87,null),m.localize(88,null),m.localize(89,null)],default:"on",description:m.localize(90,null)})}validate(oe){let Ce=this.defaultValue.renderType,He=this.defaultValue.renderFn;return typeof oe<"u"&&(typeof oe=="function"?(Ce=4,He=oe):oe==="interval"?Ce=3:oe==="relative"?Ce=2:oe==="on"?Ce=1:Ce=0),{renderType:Ce,renderFn:He}}}function ie(ue){const oe=ue.get(97);return oe==="editable"?ue.get(90):oe!=="on"}e.filterValidationDecorations=ie;class fe extends C{constructor(){const oe=[],Ce={type:"number",description:m.localize(91,null)};super(101,"rulers",oe,{type:"array",items:{anyOf:[Ce,{type:["object"],properties:{column:Ce,color:{type:"string",description:m.localize(92,null),format:"color-hex"}}}]},default:oe,description:m.localize(93,null)})}validate(oe){if(Array.isArray(oe)){const Ce=[];for(const He of oe)if(typeof He=="number")Ce.push({column:o.clampedInt(He,0,0,1e4),color:null});else if(He&&typeof He=="object"){const ze=He;Ce.push({column:o.clampedInt(ze.column,0,0,1e4),color:ze.color})}return Ce.sort((He,ze)=>He.column-ze.column),Ce}return this.defaultValue}}class be extends C{constructor(){super(91,"readOnlyMessage",void 0)}validate(oe){return!oe||typeof oe!="object"?this.defaultValue:oe}}function Ie(ue,oe){if(typeof ue!="string")return oe;switch(ue){case"hidden":return 2;case"visible":return 3;default:return 1}}class W extends C{constructor(){const oe={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(102,"scrollbar",oe,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[m.localize(94,null),m.localize(95,null),m.localize(96,null)],default:"auto",description:m.localize(97,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[m.localize(98,null),m.localize(99,null),m.localize(100,null)],default:"auto",description:m.localize(101,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:oe.verticalScrollbarSize,description:m.localize(102,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:oe.horizontalScrollbarSize,description:m.localize(103,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:oe.scrollByPage,description:m.localize(104,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ce=oe,He=o.clampedInt(Ce.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),ze=o.clampedInt(Ce.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:o.clampedInt(Ce.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Ie(Ce.vertical,this.defaultValue.vertical),horizontal:Ie(Ce.horizontal,this.defaultValue.horizontal),useShadows:s(Ce.useShadows,this.defaultValue.useShadows),verticalHasArrows:s(Ce.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:s(Ce.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:s(Ce.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:s(Ce.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:He,horizontalSliderSize:o.clampedInt(Ce.horizontalSliderSize,He,0,1e3),verticalScrollbarSize:ze,verticalSliderSize:o.clampedInt(Ce.verticalSliderSize,ze,0,1e3),scrollByPage:s(Ce.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class G extends C{constructor(){const oe={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(124,"unicodeHighlight",oe,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:oe.nonBasicASCII,description:m.localize(105,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:oe.invisibleCharacters,description:m.localize(106,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:oe.ambiguousCharacters,description:m.localize(107,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:oe.includeComments,description:m.localize(108,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:oe.includeStrings,description:m.localize(109,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:oe.allowedCharacters,description:m.localize(110,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:oe.allowedLocales,description:m.localize(111,null)}})}applyUpdate(oe,Ce){let He=!1;Ce.allowedCharacters&&oe&&(M.$2m(oe.allowedCharacters,Ce.allowedCharacters)||(oe={...oe,allowedCharacters:Ce.allowedCharacters},He=!0)),Ce.allowedLocales&&oe&&(M.$2m(oe.allowedLocales,Ce.allowedLocales)||(oe={...oe,allowedLocales:Ce.allowedLocales},He=!0));const ze=super.applyUpdate(oe,Ce);return He?new v(ze.newValue,!0):ze}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ce=oe;return{nonBasicASCII:$e(Ce.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:s(Ce.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:s(Ce.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:$e(Ce.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:$e(Ce.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(oe.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(oe.allowedLocales,this.defaultValue.allowedLocales)}}c(oe,Ce){if(typeof oe!="object"||!oe)return Ce;const He={};for(const[ze,Ze]of Object.entries(oe))Ze===!0&&(He[ze]=!0);return He}}class ce extends C{constructor(){const oe={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1};super(62,"inlineSuggest",oe,{"editor.inlineSuggest.enabled":{type:"boolean",default:oe.enabled,description:m.localize(112,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:oe.showToolbar,enum:["always","onHover"],enumDescriptions:[m.localize(113,null),m.localize(114,null)],description:m.localize(115,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:oe.suppressSuggestions,description:m.localize(116,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ce=oe;return{enabled:s(Ce.enabled,this.defaultValue.enabled),mode:n(Ce.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:n(Ce.showToolbar,this.defaultValue.showToolbar,["always","onHover"]),suppressSuggestions:s(Ce.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:s(Ce.keepOnBlur,this.defaultValue.keepOnBlur)}}}class he extends C{constructor(){const oe={enabled:R.$Wr.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:R.$Wr.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",oe,{"editor.bracketPairColorization.enabled":{type:"boolean",default:oe.enabled,markdownDescription:m.localize(117,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:oe.independentColorPoolPerBracketType,description:m.localize(118,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ce=oe;return{enabled:s(Ce.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:s(Ce.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class x extends C{constructor(){const oe={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",oe,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[m.localize(119,null),m.localize(120,null),m.localize(121,null)],default:oe.bracketPairs,description:m.localize(122,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[m.localize(123,null),m.localize(124,null),m.localize(125,null)],default:oe.bracketPairsHorizontal,description:m.localize(126,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:oe.highlightActiveBracketPair,description:m.localize(127,null)},"editor.guides.indentation":{type:"boolean",default:oe.indentation,description:m.localize(128,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[m.localize(129,null),m.localize(130,null),m.localize(131,null)],default:oe.highlightActiveIndentation,description:m.localize(132,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ce=oe;return{bracketPairs:$e(Ce.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:$e(Ce.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:s(Ce.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:s(Ce.indentation,this.defaultValue.indentation),highlightActiveIndentation:$e(Ce.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function $e(ue,oe,Ce){const He=Ce.indexOf(ue);return He===-1?oe:Ce[He]}class ve extends C{constructor(){const oe={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(117,"suggest",oe,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[m.localize(133,null),m.localize(134,null)],default:oe.insertMode,description:m.localize(135,null)},"editor.suggest.filterGraceful":{type:"boolean",default:oe.filterGraceful,description:m.localize(136,null)},"editor.suggest.localityBonus":{type:"boolean",default:oe.localityBonus,description:m.localize(137,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:oe.shareSuggestSelections,markdownDescription:m.localize(138,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[m.localize(139,null),m.localize(140,null),m.localize(141,null),m.localize(142,null)],default:oe.selectionMode,markdownDescription:m.localize(143,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:oe.snippetsPreventQuickSuggestions,description:m.localize(144,null)},"editor.suggest.showIcons":{type:"boolean",default:oe.showIcons,description:m.localize(145,null)},"editor.suggest.showStatusBar":{type:"boolean",default:oe.showStatusBar,description:m.localize(146,null)},"editor.suggest.preview":{type:"boolean",default:oe.preview,description:m.localize(147,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:oe.showInlineDetails,description:m.localize(148,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:m.localize(149,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:m.localize(150,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:m.localize(151,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:m.localize(152,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:m.localize(153,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:m.localize(154,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:m.localize(155,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:m.localize(156,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:m.localize(157,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:m.localize(158,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:m.localize(159,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:m.localize(160,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:m.localize(161,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:m.localize(162,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:m.localize(163,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:m.localize(164,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:m.localize(165,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:m.localize(166,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:m.localize(167,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:m.localize(168,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:m.localize(169,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:m.localize(170,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:m.localize(171,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:m.localize(172,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:m.localize(173,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:m.localize(174,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:m.localize(175,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:m.localize(176,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:m.localize(177,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:m.localize(178,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:m.localize(179,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:m.localize(180,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ce=oe;return{insertMode:n(Ce.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:s(Ce.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:s(Ce.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:s(Ce.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:s(Ce.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:n(Ce.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:s(Ce.showIcons,this.defaultValue.showIcons),showStatusBar:s(Ce.showStatusBar,this.defaultValue.showStatusBar),preview:s(Ce.preview,this.defaultValue.preview),previewMode:n(Ce.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:s(Ce.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:s(Ce.showMethods,this.defaultValue.showMethods),showFunctions:s(Ce.showFunctions,this.defaultValue.showFunctions),showConstructors:s(Ce.showConstructors,this.defaultValue.showConstructors),showDeprecated:s(Ce.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:s(Ce.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:s(Ce.showFields,this.defaultValue.showFields),showVariables:s(Ce.showVariables,this.defaultValue.showVariables),showClasses:s(Ce.showClasses,this.defaultValue.showClasses),showStructs:s(Ce.showStructs,this.defaultValue.showStructs),showInterfaces:s(Ce.showInterfaces,this.defaultValue.showInterfaces),showModules:s(Ce.showModules,this.defaultValue.showModules),showProperties:s(Ce.showProperties,this.defaultValue.showProperties),showEvents:s(Ce.showEvents,this.defaultValue.showEvents),showOperators:s(Ce.showOperators,this.defaultValue.showOperators),showUnits:s(Ce.showUnits,this.defaultValue.showUnits),showValues:s(Ce.showValues,this.defaultValue.showValues),showConstants:s(Ce.showConstants,this.defaultValue.showConstants),showEnums:s(Ce.showEnums,this.defaultValue.showEnums),showEnumMembers:s(Ce.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:s(Ce.showKeywords,this.defaultValue.showKeywords),showWords:s(Ce.showWords,this.defaultValue.showWords),showColors:s(Ce.showColors,this.defaultValue.showColors),showFiles:s(Ce.showFiles,this.defaultValue.showFiles),showReferences:s(Ce.showReferences,this.defaultValue.showReferences),showFolders:s(Ce.showFolders,this.defaultValue.showFolders),showTypeParameters:s(Ce.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:s(Ce.showSnippets,this.defaultValue.showSnippets),showUsers:s(Ce.showUsers,this.defaultValue.showUsers),showIssues:s(Ce.showIssues,this.defaultValue.showIssues)}}}class Ne extends C{constructor(){super(112,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:m.localize(181,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:m.localize(182,null),default:!0,type:"boolean"}})}validate(oe){return!oe||typeof oe!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:s(oe.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:s(oe.selectSubwords,this.defaultValue.selectSubwords)}}}var Ve;(function(ue){ue[ue.None=0]="None",ue[ue.Same=1]="Same",ue[ue.Indent=2]="Indent",ue[ue.DeepIndent=3]="DeepIndent"})(Ve||(e.WrappingIndent=Ve={}));class xe extends C{constructor(){super(136,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[m.localize(183,null),m.localize(184,null),m.localize(185,null),m.localize(186,null)],description:m.localize(187,null),default:"same"}})}validate(oe){switch(oe){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(oe,Ce,He){return Ce.get(2)===2?0:He}}class Qe extends D{constructor(){super(144)}compute(oe,Ce,He){const ze=Ce.get(143);return{isDominatedByLongLines:oe.isDominatedByLongLines,isWordWrapMinified:ze.isWordWrapMinified,isViewportWrapping:ze.isViewportWrapping,wrappingColumn:ze.wrappingColumn}}}class rt extends C{constructor(){const oe={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",oe,{"editor.dropIntoEditor.enabled":{type:"boolean",default:oe.enabled,markdownDescription:m.localize(188,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:m.localize(189,null),enum:["afterDrop","never"],enumDescriptions:[m.localize(190,null),m.localize(191,null)],default:"afterDrop"}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ce=oe;return{enabled:s(Ce.enabled,this.defaultValue.enabled),showDropSelector:n(Ce.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class it extends C{constructor(){const oe={enabled:!0,showPasteSelector:"afterPaste"};super(84,"pasteAs",oe,{"editor.pasteAs.enabled":{type:"boolean",default:oe.enabled,markdownDescription:m.localize(192,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:m.localize(193,null),enum:["afterPaste","never"],enumDescriptions:[m.localize(194,null),m.localize(195,null)],default:"afterPaste"}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ce=oe;return{enabled:s(Ce.enabled,this.defaultValue.enabled),showPasteSelector:n(Ce.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const nt="Consolas, 'Courier New', monospace",Ae="Menlo, Monaco, 'Courier New', monospace",Fe="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:l.$e?Ae:l.$f?Fe:nt,fontWeight:"normal",fontSize:l.$e?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Le(ue){return e.editorOptionsRegistry[ue.id]=ue,ue}var Je;(function(ue){ue[ue.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",ue[ue.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",ue[ue.accessibilitySupport=2]="accessibilitySupport",ue[ue.accessibilityPageSize=3]="accessibilityPageSize",ue[ue.ariaLabel=4]="ariaLabel",ue[ue.ariaRequired=5]="ariaRequired",ue[ue.autoClosingBrackets=6]="autoClosingBrackets",ue[ue.autoClosingComments=7]="autoClosingComments",ue[ue.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",ue[ue.autoClosingDelete=9]="autoClosingDelete",ue[ue.autoClosingOvertype=10]="autoClosingOvertype",ue[ue.autoClosingQuotes=11]="autoClosingQuotes",ue[ue.autoIndent=12]="autoIndent",ue[ue.automaticLayout=13]="automaticLayout",ue[ue.autoSurround=14]="autoSurround",ue[ue.bracketPairColorization=15]="bracketPairColorization",ue[ue.guides=16]="guides",ue[ue.codeLens=17]="codeLens",ue[ue.codeLensFontFamily=18]="codeLensFontFamily",ue[ue.codeLensFontSize=19]="codeLensFontSize",ue[ue.colorDecorators=20]="colorDecorators",ue[ue.colorDecoratorsLimit=21]="colorDecoratorsLimit",ue[ue.columnSelection=22]="columnSelection",ue[ue.comments=23]="comments",ue[ue.contextmenu=24]="contextmenu",ue[ue.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",ue[ue.cursorBlinking=26]="cursorBlinking",ue[ue.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",ue[ue.cursorStyle=28]="cursorStyle",ue[ue.cursorSurroundingLines=29]="cursorSurroundingLines",ue[ue.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",ue[ue.cursorWidth=31]="cursorWidth",ue[ue.disableLayerHinting=32]="disableLayerHinting",ue[ue.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",ue[ue.domReadOnly=34]="domReadOnly",ue[ue.dragAndDrop=35]="dragAndDrop",ue[ue.dropIntoEditor=36]="dropIntoEditor",ue[ue.emptySelectionClipboard=37]="emptySelectionClipboard",ue[ue.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",ue[ue.extraEditorClassName=39]="extraEditorClassName",ue[ue.fastScrollSensitivity=40]="fastScrollSensitivity",ue[ue.find=41]="find",ue[ue.fixedOverflowWidgets=42]="fixedOverflowWidgets",ue[ue.folding=43]="folding",ue[ue.foldingStrategy=44]="foldingStrategy",ue[ue.foldingHighlight=45]="foldingHighlight",ue[ue.foldingImportsByDefault=46]="foldingImportsByDefault",ue[ue.foldingMaximumRegions=47]="foldingMaximumRegions",ue[ue.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",ue[ue.fontFamily=49]="fontFamily",ue[ue.fontInfo=50]="fontInfo",ue[ue.fontLigatures=51]="fontLigatures",ue[ue.fontSize=52]="fontSize",ue[ue.fontWeight=53]="fontWeight",ue[ue.fontVariations=54]="fontVariations",ue[ue.formatOnPaste=55]="formatOnPaste",ue[ue.formatOnType=56]="formatOnType",ue[ue.glyphMargin=57]="glyphMargin",ue[ue.gotoLocation=58]="gotoLocation",ue[ue.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",ue[ue.hover=60]="hover",ue[ue.inDiffEditor=61]="inDiffEditor",ue[ue.inlineSuggest=62]="inlineSuggest",ue[ue.letterSpacing=63]="letterSpacing",ue[ue.lightbulb=64]="lightbulb",ue[ue.lineDecorationsWidth=65]="lineDecorationsWidth",ue[ue.lineHeight=66]="lineHeight",ue[ue.lineNumbers=67]="lineNumbers",ue[ue.lineNumbersMinChars=68]="lineNumbersMinChars",ue[ue.linkedEditing=69]="linkedEditing",ue[ue.links=70]="links",ue[ue.matchBrackets=71]="matchBrackets",ue[ue.minimap=72]="minimap",ue[ue.mouseStyle=73]="mouseStyle",ue[ue.mouseWheelScrollSensitivity=74]="mouseWheelScrollSensitivity",ue[ue.mouseWheelZoom=75]="mouseWheelZoom",ue[ue.multiCursorMergeOverlapping=76]="multiCursorMergeOverlapping",ue[ue.multiCursorModifier=77]="multiCursorModifier",ue[ue.multiCursorPaste=78]="multiCursorPaste",ue[ue.multiCursorLimit=79]="multiCursorLimit",ue[ue.occurrencesHighlight=80]="occurrencesHighlight",ue[ue.overviewRulerBorder=81]="overviewRulerBorder",ue[ue.overviewRulerLanes=82]="overviewRulerLanes",ue[ue.padding=83]="padding",ue[ue.pasteAs=84]="pasteAs",ue[ue.parameterHints=85]="parameterHints",ue[ue.peekWidgetDefaultFocus=86]="peekWidgetDefaultFocus",ue[ue.definitionLinkOpensInPeek=87]="definitionLinkOpensInPeek",ue[ue.quickSuggestions=88]="quickSuggestions",ue[ue.quickSuggestionsDelay=89]="quickSuggestionsDelay",ue[ue.readOnly=90]="readOnly",ue[ue.readOnlyMessage=91]="readOnlyMessage",ue[ue.renameOnType=92]="renameOnType",ue[ue.renderControlCharacters=93]="renderControlCharacters",ue[ue.renderFinalNewline=94]="renderFinalNewline",ue[ue.renderLineHighlight=95]="renderLineHighlight",ue[ue.renderLineHighlightOnlyWhenFocus=96]="renderLineHighlightOnlyWhenFocus",ue[ue.renderValidationDecorations=97]="renderValidationDecorations",ue[ue.renderWhitespace=98]="renderWhitespace",ue[ue.revealHorizontalRightPadding=99]="revealHorizontalRightPadding",ue[ue.roundedSelection=100]="roundedSelection",ue[ue.rulers=101]="rulers",ue[ue.scrollbar=102]="scrollbar",ue[ue.scrollBeyondLastColumn=103]="scrollBeyondLastColumn",ue[ue.scrollBeyondLastLine=104]="scrollBeyondLastLine",ue[ue.scrollPredominantAxis=105]="scrollPredominantAxis",ue[ue.selectionClipboard=106]="selectionClipboard",ue[ue.selectionHighlight=107]="selectionHighlight",ue[ue.selectOnLineNumbers=108]="selectOnLineNumbers",ue[ue.showFoldingControls=109]="showFoldingControls",ue[ue.showUnused=110]="showUnused",ue[ue.snippetSuggestions=111]="snippetSuggestions",ue[ue.smartSelect=112]="smartSelect",ue[ue.smoothScrolling=113]="smoothScrolling",ue[ue.stickyScroll=114]="stickyScroll",ue[ue.stickyTabStops=115]="stickyTabStops",ue[ue.stopRenderingLineAfter=116]="stopRenderingLineAfter",ue[ue.suggest=117]="suggest",ue[ue.suggestFontSize=118]="suggestFontSize",ue[ue.suggestLineHeight=119]="suggestLineHeight",ue[ue.suggestOnTriggerCharacters=120]="suggestOnTriggerCharacters",ue[ue.suggestSelection=121]="suggestSelection",ue[ue.tabCompletion=122]="tabCompletion",ue[ue.tabIndex=123]="tabIndex",ue[ue.unicodeHighlighting=124]="unicodeHighlighting",ue[ue.unusualLineTerminators=125]="unusualLineTerminators",ue[ue.useShadowDOM=126]="useShadowDOM",ue[ue.useTabStops=127]="useTabStops",ue[ue.wordBreak=128]="wordBreak",ue[ue.wordSeparators=129]="wordSeparators",ue[ue.wordWrap=130]="wordWrap",ue[ue.wordWrapBreakAfterCharacters=131]="wordWrapBreakAfterCharacters",ue[ue.wordWrapBreakBeforeCharacters=132]="wordWrapBreakBeforeCharacters",ue[ue.wordWrapColumn=133]="wordWrapColumn",ue[ue.wordWrapOverride1=134]="wordWrapOverride1",ue[ue.wordWrapOverride2=135]="wordWrapOverride2",ue[ue.wrappingIndent=136]="wrappingIndent",ue[ue.wrappingStrategy=137]="wrappingStrategy",ue[ue.showDeprecated=138]="showDeprecated",ue[ue.inlayHints=139]="inlayHints",ue[ue.editorClassName=140]="editorClassName",ue[ue.pixelRatio=141]="pixelRatio",ue[ue.tabFocusMode=142]="tabFocusMode",ue[ue.layoutInfo=143]="layoutInfo",ue[ue.wrappingInfo=144]="wrappingInfo",ue[ue.defaultColorDecorators=145]="defaultColorDecorators",ue[ue.colorDecoratorsActivatedOn=146]="colorDecoratorsActivatedOn",ue[ue.inlineCompletionsAccessibilityVerbose=147]="inlineCompletionsAccessibilityVerbose"})(Je||(e.EditorOption=Je={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Le(new c(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:m.localize(196,null)})),acceptSuggestionOnEnter:Le(new r(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",m.localize(197,null),""],markdownDescription:m.localize(198,null)})),accessibilitySupport:Le(new h),accessibilityPageSize:Le(new o(3,"accessibilityPageSize",10,1,1073741824,{description:m.localize(199,null),tags:["accessibility"]})),ariaLabel:Le(new t(4,"ariaLabel",m.localize(200,null))),ariaRequired:Le(new c(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Le(new c(8,"screenReaderAnnounceInlineSuggestion",!0,{description:m.localize(201,null),tags:["accessibility"]})),autoClosingBrackets:Le(new r(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(202,null),m.localize(203,null),""],description:m.localize(204,null)})),autoClosingComments:Le(new r(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(205,null),m.localize(206,null),""],description:m.localize(207,null)})),autoClosingDelete:Le(new r(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",m.localize(208,null),""],description:m.localize(209,null)})),autoClosingOvertype:Le(new r(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",m.localize(210,null),""],description:m.localize(211,null)})),autoClosingQuotes:Le(new r(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(212,null),m.localize(213,null),""],description:m.localize(214,null)})),autoIndent:Le(new i(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],a,{enumDescriptions:[m.localize(215,null),m.localize(216,null),m.localize(217,null),m.localize(218,null),m.localize(219,null)],description:m.localize(220,null)})),automaticLayout:Le(new c(13,"automaticLayout",!1)),autoSurround:Le(new r(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[m.localize(221,null),m.localize(222,null),m.localize(223,null),""],description:m.localize(224,null)})),bracketPairColorization:Le(new he),bracketPairGuides:Le(new x),stickyTabStops:Le(new c(115,"stickyTabStops",!1,{description:m.localize(225,null)})),codeLens:Le(new c(17,"codeLens",!0,{description:m.localize(226,null)})),codeLensFontFamily:Le(new t(18,"codeLensFontFamily","",{description:m.localize(227,null)})),codeLensFontSize:Le(new o(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:m.localize(228,null)})),colorDecorators:Le(new c(20,"colorDecorators",!0,{description:m.localize(229,null)})),colorDecoratorActivatedOn:Le(new r(146,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[m.localize(230,null),m.localize(231,null),m.localize(232,null)],description:m.localize(233,null)})),colorDecoratorsLimit:Le(new o(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:m.localize(234,null)})),columnSelection:Le(new c(22,"columnSelection",!1,{description:m.localize(235,null)})),comments:Le(new p),contextmenu:Le(new c(24,"contextmenu",!0)),copyWithSyntaxHighlighting:Le(new c(25,"copyWithSyntaxHighlighting",!0,{description:m.localize(236,null)})),cursorBlinking:Le(new i(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],w,{description:m.localize(237,null)})),cursorSmoothCaretAnimation:Le(new r(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[m.localize(238,null),m.localize(239,null),m.localize(240,null)],description:m.localize(241,null)})),cursorStyle:Le(new i(28,"cursorStyle",f.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],L,{description:m.localize(242,null)})),cursorSurroundingLines:Le(new o(29,"cursorSurroundingLines",0,0,1073741824,{description:m.localize(243,null)})),cursorSurroundingLinesStyle:Le(new r(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[m.localize(244,null),m.localize(245,null)],markdownDescription:m.localize(246,null)})),cursorWidth:Le(new o(31,"cursorWidth",0,0,1073741824,{markdownDescription:m.localize(247,null)})),disableLayerHinting:Le(new c(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:Le(new c(33,"disableMonospaceOptimizations",!1)),domReadOnly:Le(new c(34,"domReadOnly",!1)),dragAndDrop:Le(new c(35,"dragAndDrop",!0,{description:m.localize(248,null)})),emptySelectionClipboard:Le(new T),dropIntoEditor:Le(new rt),stickyScroll:Le(new le),experimentalWhitespaceRendering:Le(new r(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[m.localize(249,null),m.localize(250,null),m.localize(251,null)],description:m.localize(252,null)})),extraEditorClassName:Le(new t(39,"extraEditorClassName","")),fastScrollSensitivity:Le(new d(40,"fastScrollSensitivity",5,ue=>ue<=0?5:ue,{markdownDescription:m.localize(253,null)})),find:Le(new F),fixedOverflowWidgets:Le(new c(42,"fixedOverflowWidgets",!1)),folding:Le(new c(43,"folding",!0,{description:m.localize(254,null)})),foldingStrategy:Le(new r(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[m.localize(255,null),m.localize(256,null)],description:m.localize(257,null)})),foldingHighlight:Le(new c(45,"foldingHighlight",!0,{description:m.localize(258,null)})),foldingImportsByDefault:Le(new c(46,"foldingImportsByDefault",!1,{description:m.localize(259,null)})),foldingMaximumRegions:Le(new o(47,"foldingMaximumRegions",5e3,10,65e3,{description:m.localize(260,null)})),unfoldOnClickAfterEndOfLine:Le(new c(48,"unfoldOnClickAfterEndOfLine",!1,{description:m.localize(261,null)})),fontFamily:Le(new t(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:m.localize(262,null)})),fontInfo:Le(new j),fontLigatures2:Le(new U),fontSize:Le(new z),fontWeight:Le(new B),fontVariations:Le(new N),formatOnPaste:Le(new c(55,"formatOnPaste",!1,{description:m.localize(263,null)})),formatOnType:Le(new c(56,"formatOnType",!1,{description:m.localize(264,null)})),glyphMargin:Le(new c(57,"glyphMargin",!0,{description:m.localize(265,null)})),gotoLocation:Le(new ae),hideCursorInOverviewRuler:Le(new c(59,"hideCursorInOverviewRuler",!1,{description:m.localize(266,null)})),hover:Le(new X),inDiffEditor:Le(new c(61,"inDiffEditor",!1)),letterSpacing:Le(new d(63,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,ue=>d.clamp(ue,-5,20),{description:m.localize(267,null)})),lightbulb:Le(new me),lineDecorationsWidth:Le(new de),lineHeight:Le(new V),lineNumbers:Le(new ge),lineNumbersMinChars:Le(new o(68,"lineNumbersMinChars",5,1,300)),linkedEditing:Le(new c(69,"linkedEditing",!1,{description:m.localize(268,null)})),links:Le(new c(70,"links",!0,{description:m.localize(269,null)})),matchBrackets:Le(new r(71,"matchBrackets","always",["always","near","never"],{description:m.localize(270,null)})),minimap:Le(new J),mouseStyle:Le(new r(73,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Le(new d(74,"mouseWheelScrollSensitivity",1,ue=>ue===0?1:ue,{markdownDescription:m.localize(271,null)})),mouseWheelZoom:Le(new c(75,"mouseWheelZoom",!1,{markdownDescription:m.localize(272,null)})),multiCursorMergeOverlapping:Le(new c(76,"multiCursorMergeOverlapping",!0,{description:m.localize(273,null)})),multiCursorModifier:Le(new i(77,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],ee,{markdownEnumDescriptions:[m.localize(274,null),m.localize(275,null)],markdownDescription:m.localize(276,null)})),multiCursorPaste:Le(new r(78,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[m.localize(277,null),m.localize(278,null)],markdownDescription:m.localize(279,null)})),multiCursorLimit:Le(new o(79,"multiCursorLimit",1e4,1,1e5,{markdownDescription:m.localize(280,null)})),occurrencesHighlight:Le(new c(80,"occurrencesHighlight",!0,{description:m.localize(281,null)})),overviewRulerBorder:Le(new c(81,"overviewRulerBorder",!0,{description:m.localize(282,null)})),overviewRulerLanes:Le(new o(82,"overviewRulerLanes",3,0,3)),padding:Le(new Y),pasteAs:Le(new it),parameterHints:Le(new Z),peekWidgetDefaultFocus:Le(new r(86,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[m.localize(283,null),m.localize(284,null)],description:m.localize(285,null)})),definitionLinkOpensInPeek:Le(new c(87,"definitionLinkOpensInPeek",!1,{description:m.localize(286,null)})),quickSuggestions:Le(new pe),quickSuggestionsDelay:Le(new o(89,"quickSuggestionsDelay",10,0,1073741824,{description:m.localize(287,null)})),readOnly:Le(new c(90,"readOnly",!1)),readOnlyMessage:Le(new be),renameOnType:Le(new c(92,"renameOnType",!1,{description:m.localize(288,null),markdownDeprecationMessage:m.localize(289,null)})),renderControlCharacters:Le(new c(93,"renderControlCharacters",!0,{description:m.localize(290,null),restricted:!0})),renderFinalNewline:Le(new r(94,"renderFinalNewline",l.$f?"dimmed":"on",["off","on","dimmed"],{description:m.localize(291,null)})),renderLineHighlight:Le(new r(95,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",m.localize(292,null)],description:m.localize(293,null)})),renderLineHighlightOnlyWhenFocus:Le(new c(96,"renderLineHighlightOnlyWhenFocus",!1,{description:m.localize(294,null)})),renderValidationDecorations:Le(new r(97,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Le(new r(98,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",m.localize(295,null),m.localize(296,null),m.localize(297,null),""],description:m.localize(298,null)})),revealHorizontalRightPadding:Le(new o(99,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Le(new c(100,"roundedSelection",!0,{description:m.localize(299,null)})),rulers:Le(new fe),scrollbar:Le(new W),scrollBeyondLastColumn:Le(new o(103,"scrollBeyondLastColumn",4,0,1073741824,{description:m.localize(300,null)})),scrollBeyondLastLine:Le(new c(104,"scrollBeyondLastLine",!0,{description:m.localize(301,null)})),scrollPredominantAxis:Le(new c(105,"scrollPredominantAxis",!0,{description:m.localize(302,null)})),selectionClipboard:Le(new c(106,"selectionClipboard",!0,{description:m.localize(303,null),included:l.$f})),selectionHighlight:Le(new c(107,"selectionHighlight",!0,{description:m.localize(304,null)})),selectOnLineNumbers:Le(new c(108,"selectOnLineNumbers",!0)),showFoldingControls:Le(new r(109,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[m.localize(305,null),m.localize(306,null),m.localize(307,null)],description:m.localize(308,null)})),showUnused:Le(new c(110,"showUnused",!0,{description:m.localize(309,null)})),showDeprecated:Le(new c(138,"showDeprecated",!0,{description:m.localize(310,null)})),inlayHints:Le(new ye),snippetSuggestions:Le(new r(111,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[m.localize(311,null),m.localize(312,null),m.localize(313,null),m.localize(314,null)],description:m.localize(315,null)})),smartSelect:Le(new Ne),smoothScrolling:Le(new c(113,"smoothScrolling",!1,{description:m.localize(316,null)})),stopRenderingLineAfter:Le(new o(116,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Le(new ve),inlineSuggest:Le(new ce),inlineCompletionsAccessibilityVerbose:Le(new c(147,"inlineCompletionsAccessibilityVerbose",!1,{description:m.localize(317,null)})),suggestFontSize:Le(new o(118,"suggestFontSize",0,0,1e3,{markdownDescription:m.localize(318,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Le(new o(119,"suggestLineHeight",0,0,1e3,{markdownDescription:m.localize(319,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Le(new c(120,"suggestOnTriggerCharacters",!0,{description:m.localize(320,null)})),suggestSelection:Le(new r(121,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[m.localize(321,null),m.localize(322,null),m.localize(323,null)],description:m.localize(324,null)})),tabCompletion:Le(new r(122,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[m.localize(325,null),m.localize(326,null),m.localize(327,null)],description:m.localize(328,null)})),tabIndex:Le(new o(123,"tabIndex",0,-1,1073741824)),unicodeHighlight:Le(new G),unusualLineTerminators:Le(new r(125,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[m.localize(329,null),m.localize(330,null),m.localize(331,null)],description:m.localize(332,null)})),useShadowDOM:Le(new c(126,"useShadowDOM",!0)),useTabStops:Le(new c(127,"useTabStops",!0,{description:m.localize(333,null)})),wordBreak:Le(new r(128,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[m.localize(334,null),m.localize(335,null)],description:m.localize(336,null)})),wordSeparators:Le(new t(129,"wordSeparators",A.$Xr,{description:m.localize(337,null)})),wordWrap:Le(new r(130,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[m.localize(338,null),m.localize(339,null),m.localize(340,null),m.localize(341,null)],description:m.localize(342,null)})),wordWrapBreakAfterCharacters:Le(new t(131,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Le(new t(132,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Le(new o(133,"wordWrapColumn",80,1,1073741824,{markdownDescription:m.localize(343,null)})),wordWrapOverride1:Le(new r(134,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Le(new r(135,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Le(new O),defaultColorDecorators:Le(new c(145,"defaultColorDecorators",!1,{markdownDescription:m.localize(344,null)})),pixelRatio:Le(new _),tabFocusMode:Le(new c(142,"tabFocusMode",!1,{markdownDescription:m.localize(345,null)})),layoutInfo:Le(new H),wrappingInfo:Le(new Qe),wrappingIndent:Le(new xe),wrappingStrategy:Le(new te)}}),define(Se[187],De([11,12]),function(ne,e){return ne.create("vs/editor/common/languages",e)}),define(Se[83],De([1,0,79,2,169,35,180,187]),function(ne,e,y,M,l,R,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.$dt=e.$ct=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.$bt=e.$at=e.SymbolKinds=e.SymbolTag=e.$_s=e.$$s=e.SymbolKind=e.$0s=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.$9s=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.$8s=e.$7s=e.$6s=void 0;class k{constructor(U,N,j){this.offset=U,this.type=N,this.language=j,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.$6s=k;class ${constructor(U,N){this.tokens=U,this.endState=N,this._tokenizationResultBrand=void 0}}e.$7s=$;class P{constructor(U,N){this.tokens=U,this.endState=N,this._encodedTokenizationResultBrand=void 0}}e.$8s=P;var C;(function(F){F[F.Method=0]="Method",F[F.Function=1]="Function",F[F.Constructor=2]="Constructor",F[F.Field=3]="Field",F[F.Variable=4]="Variable",F[F.Class=5]="Class",F[F.Struct=6]="Struct",F[F.Interface=7]="Interface",F[F.Module=8]="Module",F[F.Property=9]="Property",F[F.Event=10]="Event",F[F.Operator=11]="Operator",F[F.Unit=12]="Unit",F[F.Value=13]="Value",F[F.Constant=14]="Constant",F[F.Enum=15]="Enum",F[F.EnumMember=16]="EnumMember",F[F.Keyword=17]="Keyword",F[F.Text=18]="Text",F[F.Color=19]="Color",F[F.File=20]="File",F[F.Reference=21]="Reference",F[F.Customcolor=22]="Customcolor",F[F.Folder=23]="Folder",F[F.TypeParameter=24]="TypeParameter",F[F.User=25]="User",F[F.Issue=26]="Issue",F[F.Snippet=27]="Snippet"})(C||(e.CompletionItemKind=C={}));var v;(function(F){const U=new Map;U.set(0,y.$Qj.symbolMethod),U.set(1,y.$Qj.symbolFunction),U.set(2,y.$Qj.symbolConstructor),U.set(3,y.$Qj.symbolField),U.set(4,y.$Qj.symbolVariable),U.set(5,y.$Qj.symbolClass),U.set(6,y.$Qj.symbolStruct),U.set(7,y.$Qj.symbolInterface),U.set(8,y.$Qj.symbolModule),U.set(9,y.$Qj.symbolProperty),U.set(10,y.$Qj.symbolEvent),U.set(11,y.$Qj.symbolOperator),U.set(12,y.$Qj.symbolUnit),U.set(13,y.$Qj.symbolValue),U.set(15,y.$Qj.symbolEnum),U.set(14,y.$Qj.symbolConstant),U.set(15,y.$Qj.symbolEnum),U.set(16,y.$Qj.symbolEnumMember),U.set(17,y.$Qj.symbolKeyword),U.set(27,y.$Qj.symbolSnippet),U.set(18,y.$Qj.symbolText),U.set(19,y.$Qj.symbolColor),U.set(20,y.$Qj.symbolFile),U.set(21,y.$Qj.symbolReference),U.set(22,y.$Qj.symbolCustomColor),U.set(23,y.$Qj.symbolFolder),U.set(24,y.$Qj.symbolTypeParameter),U.set(25,y.$Qj.account),U.set(26,y.$Qj.issues);function N(B){let ae=U.get(B);return ae||(console.info("No codicon found for CompletionItemKind "+B),ae=y.$Qj.symbolProperty),ae}F.toIcon=N;const j=new Map;j.set("method",0),j.set("function",1),j.set("constructor",2),j.set("field",3),j.set("variable",4),j.set("class",5),j.set("struct",6),j.set("interface",7),j.set("module",8),j.set("property",9),j.set("event",10),j.set("operator",11),j.set("unit",12),j.set("value",13),j.set("constant",14),j.set("enum",15),j.set("enum-member",16),j.set("enumMember",16),j.set("keyword",17),j.set("snippet",27),j.set("text",18),j.set("color",19),j.set("file",20),j.set("reference",21),j.set("customcolor",22),j.set("folder",23),j.set("type-parameter",24),j.set("typeParameter",24),j.set("account",25),j.set("issue",26);function z(B,ae){let X=j.get(B);return typeof X>"u"&&!ae&&(X=9),X}F.fromString=z})(v||(e.CompletionItemKinds=v={}));var S;(function(F){F[F.Deprecated=1]="Deprecated"})(S||(e.CompletionItemTag=S={}));var D;(function(F){F[F.None=0]="None",F[F.KeepWhitespace=1]="KeepWhitespace",F[F.InsertAsSnippet=4]="InsertAsSnippet"})(D||(e.CompletionItemInsertTextRule=D={}));var E;(function(F){F[F.Invoke=0]="Invoke",F[F.TriggerCharacter=1]="TriggerCharacter",F[F.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(E||(e.CompletionTriggerKind=E={}));var s;(function(F){F[F.Automatic=0]="Automatic",F[F.Explicit=1]="Explicit"})(s||(e.InlineCompletionTriggerKind=s={}));class c{constructor(U,N,j,z){this.range=U,this.text=N,this.completionKind=j,this.isSnippetText=z}equals(U){return R.$ms.lift(this.range).equalsRange(U.range)&&this.text===U.text&&this.completionKind===U.completionKind&&this.isSnippetText===U.isSnippetText}}e.$9s=c;var u;(function(F){F[F.Invoke=1]="Invoke",F[F.Auto=2]="Auto"})(u||(e.CodeActionTriggerType=u={}));var o;(function(F){F[F.Invoke=1]="Invoke",F[F.TriggerCharacter=2]="TriggerCharacter",F[F.ContentChange=3]="ContentChange"})(o||(e.SignatureHelpTriggerKind=o={}));var g;(function(F){F[F.Text=0]="Text",F[F.Read=1]="Read",F[F.Write=2]="Write"})(g||(e.DocumentHighlightKind=g={}));function d(F){return F&&M.URI.isUri(F.uri)&&R.$ms.isIRange(F.range)&&(R.$ms.isIRange(F.originSelectionRange)||R.$ms.isIRange(F.targetSelectionRange))}e.$0s=d;var t;(function(F){F[F.File=0]="File",F[F.Module=1]="Module",F[F.Namespace=2]="Namespace",F[F.Package=3]="Package",F[F.Class=4]="Class",F[F.Method=5]="Method",F[F.Property=6]="Property",F[F.Field=7]="Field",F[F.Constructor=8]="Constructor",F[F.Enum=9]="Enum",F[F.Interface=10]="Interface",F[F.Function=11]="Function",F[F.Variable=12]="Variable",F[F.Constant=13]="Constant",F[F.String=14]="String",F[F.Number=15]="Number",F[F.Boolean=16]="Boolean",F[F.Array=17]="Array",F[F.Object=18]="Object",F[F.Key=19]="Key",F[F.Null=20]="Null",F[F.EnumMember=21]="EnumMember",F[F.Struct=22]="Struct",F[F.Event=23]="Event",F[F.Operator=24]="Operator",F[F.TypeParameter=25]="TypeParameter"})(t||(e.SymbolKind=t={})),e.$$s={[17]:(0,m.localize)(0,null),[16]:(0,m.localize)(1,null),[4]:(0,m.localize)(2,null),[13]:(0,m.localize)(3,null),[8]:(0,m.localize)(4,null),[9]:(0,m.localize)(5,null),[21]:(0,m.localize)(6,null),[23]:(0,m.localize)(7,null),[7]:(0,m.localize)(8,null),[0]:(0,m.localize)(9,null),[11]:(0,m.localize)(10,null),[10]:(0,m.localize)(11,null),[19]:(0,m.localize)(12,null),[5]:(0,m.localize)(13,null),[1]:(0,m.localize)(14,null),[2]:(0,m.localize)(15,null),[20]:(0,m.localize)(16,null),[15]:(0,m.localize)(17,null),[18]:(0,m.localize)(18,null),[24]:(0,m.localize)(19,null),[3]:(0,m.localize)(20,null),[6]:(0,m.localize)(21,null),[14]:(0,m.localize)(22,null),[22]:(0,m.localize)(23,null),[25]:(0,m.localize)(24,null),[12]:(0,m.localize)(25,null)};function n(F,U){return(0,m.localize)(26,null,F,e.$$s[U])}e.$_s=n;var r;(function(F){F[F.Deprecated=1]="Deprecated"})(r||(e.SymbolTag=r={}));var i;(function(F){const U=new Map;U.set(0,y.$Qj.symbolFile),U.set(1,y.$Qj.symbolModule),U.set(2,y.$Qj.symbolNamespace),U.set(3,y.$Qj.symbolPackage),U.set(4,y.$Qj.symbolClass),U.set(5,y.$Qj.symbolMethod),U.set(6,y.$Qj.symbolProperty),U.set(7,y.$Qj.symbolField),U.set(8,y.$Qj.symbolConstructor),U.set(9,y.$Qj.symbolEnum),U.set(10,y.$Qj.symbolInterface),U.set(11,y.$Qj.symbolFunction),U.set(12,y.$Qj.symbolVariable),U.set(13,y.$Qj.symbolConstant),U.set(14,y.$Qj.symbolString),U.set(15,y.$Qj.symbolNumber),U.set(16,y.$Qj.symbolBoolean),U.set(17,y.$Qj.symbolArray),U.set(18,y.$Qj.symbolObject),U.set(19,y.$Qj.symbolKey),U.set(20,y.$Qj.symbolNull),U.set(21,y.$Qj.symbolEnumMember),U.set(22,y.$Qj.symbolStruct),U.set(23,y.$Qj.symbolEvent),U.set(24,y.$Qj.symbolOperator),U.set(25,y.$Qj.symbolTypeParameter);function N(j){let z=U.get(j);return z||(console.info("No codicon found for SymbolKind "+j),z=y.$Qj.symbolProperty),z}F.toIcon=N})(i||(e.SymbolKinds=i={}));class a{static asEditOperation(U){return l.$ns.replace(R.$ms.lift(U.range),U.text)}}e.$at=a;class h{static fromValue(U){switch(U){case"comment":return h.Comment;case"imports":return h.Imports;case"region":return h.Region}return new h(U)}constructor(U){this.value=U}}e.$bt=h,h.Comment=new h("comment"),h.Imports=new h("imports"),h.Region=new h("region");var p;(function(F){function U(N){return!N||typeof N!="object"?!1:typeof N.id=="string"&&typeof N.title=="string"}F.is=U})(p||(e.Command=p={}));var I;(function(F){F[F.Collapsed=0]="Collapsed",F[F.Expanded=1]="Expanded"})(I||(e.CommentThreadCollapsibleState=I={}));var w;(function(F){F[F.Unresolved=0]="Unresolved",F[F.Resolved=1]="Resolved"})(w||(e.CommentThreadState=w={}));var f;(function(F){F[F.Editing=0]="Editing",F[F.Preview=1]="Preview"})(f||(e.CommentMode=f={}));var b;(function(F){F[F.Published=0]="Published",F[F.Draft=1]="Draft"})(b||(e.CommentState=b={}));var L;(function(F){F[F.Type=1]="Type",F[F.Parameter=2]="Parameter"})(L||(e.InlayHintKind=L={}));class O{constructor(U){this.b=U,this.a=null}dispose(){this.a&&this.a.then(U=>{U&&U.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}e.$ct=O,e.$dt=new A.$Xs;var T;(function(F){F[F.None=0]="None",F[F.Option=1]="Option",F[F.Default=2]="Default",F[F.Preferred=3]="Preferred"})(T||(e.ExternalUriOpenerPriority=T={}))}),define(Se[188],De([11,12]),function(ne,e){return ne.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Se[189],De([11,12]),function(ne,e){return ne.create("vs/platform/contextkey/common/contextkey",e)}),define(Se[190],De([11,12]),function(ne,e){return ne.create("vs/platform/contextkey/common/scanner",e)}),define(Se[191],De([11,12]),function(ne,e){return ne.create("vs/platform/dialogs/common/dialogs",e)}),define(Se[192],De([11,12]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Se[193],De([11,12]),function(ne,e){return ne.create("vs/platform/extensions/common/extensionValidator",e)}),define(Se[194],De([11,12]),function(ne,e){return ne.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(Se[195],De([11,12]),function(ne,e){return ne.create("vs/platform/files/common/files",e)}),define(Se[196],De([11,12]),function(ne,e){return ne.create("vs/platform/files/common/io",e)}),define(Se[197],De([11,12]),function(ne,e){return ne.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Se[198],De([11,12]),function(ne,e){return ne.create("vs/platform/markers/common/markers",e)}),define(Se[199],De([11,12]),function(ne,e){return ne.create("vs/platform/theme/common/iconRegistry",e)}),define(Se[200],De([11,12]),function(ne,e){return ne.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(Se[201],De([11,12]),function(ne,e){return ne.create("vs/platform/workspace/common/workspace",e)}),define(Se[202],De([11,12]),function(ne,e){return ne.create("vs/workbench/api/common/extHostChat",e)}),define(Se[203],De([11,12]),function(ne,e){return ne.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Se[204],De([11,12]),function(ne,e){return ne.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Se[205],De([11,12]),function(ne,e){return ne.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Se[206],De([11,12]),function(ne,e){return ne.create("vs/workbench/api/common/extHostLogService",e)}),define(Se[207],De([11,12]),function(ne,e){return ne.create("vs/workbench/api/common/extHostNotebook",e)}),define(Se[208],De([11,12]),function(ne,e){return ne.create("vs/workbench/api/common/extHostProgress",e)}),define(Se[209],De([11,12]),function(ne,e){return ne.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Se[210],De([11,12]),function(ne,e){return ne.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Se[211],De([11,12]),function(ne,e){return ne.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Se[212],De([11,12]),function(ne,e){return ne.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Se[213],De([11,12]),function(ne,e){return ne.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Se[214],De([11,12]),function(ne,e){return ne.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Se[215],De([11,12]),function(ne,e){return ne.create("vs/workbench/api/node/extHostDebugService",e)}),define(Se[216],De([11,12]),function(ne,e){return ne.create("vs/workbench/common/editor",e)}),define(Se[217],De([11,12]),function(ne,e){return ne.create("vs/workbench/common/views",e)}),define(Se[218],De([11,12]),function(ne,e){return ne.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Se[219],De([11,12]),function(ne,e){return ne.create("vs/workbench/contrib/debug/common/debug",e)}),define(Se[220],De([11,12]),function(ne,e){return ne.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(Se[221],De([11,12]),function(ne,e){return ne.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Se[222],De([11,12]),function(ne,e){return ne.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Se[223],De([11,12]),function(ne,e){return ne.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Se[224],De([11,12]),function(ne,e){return ne.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Se[225],De([11,12]),function(ne,e){return ne.create("vs/workbench/services/remote/common/tunnelModel",e)}),define(Se[226],De([11,12]),function(ne,e){return ne.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Se[227],De([1,0,8,190]),function(ne,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gi=e.TokenType=void 0;var l;(function($){$[$.LParen=0]="LParen",$[$.RParen=1]="RParen",$[$.Neg=2]="Neg",$[$.Eq=3]="Eq",$[$.NotEq=4]="NotEq",$[$.Lt=5]="Lt",$[$.LtEq=6]="LtEq",$[$.Gt=7]="Gt",$[$.GtEq=8]="GtEq",$[$.RegexOp=9]="RegexOp",$[$.RegexStr=10]="RegexStr",$[$.True=11]="True",$[$.False=12]="False",$[$.In=13]="In",$[$.Not=14]="Not",$[$.And=15]="And",$[$.Or=16]="Or",$[$.Str=17]="Str",$[$.QuotedStr=18]="QuotedStr",$[$.Error=19]="Error",$[$.EOF=20]="EOF"})(l||(e.TokenType=l={}));function R(...$){switch($.length){case 1:return(0,M.localize)(0,null,$[0]);case 2:return(0,M.localize)(1,null,$[0],$[1]);case 3:return(0,M.localize)(2,null,$[0],$[1],$[2]);default:return}}const A=(0,M.localize)(3,null),m=(0,M.localize)(4,null);class k{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(P){switch(P.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return P.isTripleEq?"===":"==";case 4:return P.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return P.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return P.lexeme;case 18:return P.lexeme;case 19:return P.lexeme;case 20:return"EOF";default:throw(0,y.$6)(`unhandled token type: ${JSON.stringify(P)}; have you forgotten to add a case?`)}}get errors(){return this.g}reset(P){return this.c=P,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const C=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:C})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const C=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:C})}else this.h(126)?this.k(9):this.l(R("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(R("&&"));break;case 124:this.h(124)?this.k(16):this.l(R("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(P){return this.r()||this.c.charCodeAt(this.e)!==P?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(P){this.f.push({type:P,offset:this.d})}l(P){const C=this.d,v=this.c.substring(this.d,this.e),S={type:19,offset:this.d,lexeme:v};this.g.push({offset:C,lexeme:v,additionalInfo:P}),this.f.push(S)}n(){this.m.lastIndex=this.d;const P=this.m.exec(this.c);if(P){this.e=this.d+P[0].length;const C=this.c.substring(this.d,this.e),v=k.b.get(C);v?this.k(v):this.f.push({type:17,lexeme:C,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(A);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let P=this.e,C=!1,v=!1;for(;;){if(P>=this.c.length){this.e=P,this.l(m);return}const D=this.c.charCodeAt(P);if(C)C=!1;else if(D===47&&!v){P++;break}else D===91?v=!0:D===92?C=!0:D===93&&(v=!1);P++}for(;P<this.c.length&&k.a.has(this.c.charCodeAt(P));)P++;this.e=P;const S=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:S,offset:this.d})}r(){return this.e>=this.c.length}}e.$Gi=k,k.a=new Set(["i","g","s","m","y","u"].map($=>$.charCodeAt(0))),k.b=new Map([["not",14],["in",13],["false",12],["true",11]])}),define(Se[228],De([1,0,24,39,193,371]),function(ne,e,y,M,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=void 0;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,m=/^-(\d{4})(\d{2})(\d{2})$/;function k(c){return c=c.trim(),c==="*"||A.test(c)}e.$Do=k;function $(c){if(!k(c))return null;if(c=c.trim(),c==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const u=c.match(A);return u?{hasCaret:u[1]==="^",hasGreaterEquals:u[1]===">=",majorBase:u[2]==="x"?0:parseInt(u[2],10),majorMustEqual:u[2]!=="x",minorBase:u[4]==="x"?0:parseInt(u[4],10),minorMustEqual:u[4]!=="x",patchBase:u[6]==="x"?0:parseInt(u[6],10),patchMustEqual:u[6]!=="x",preRelease:u[8]||null}:null}e.$Eo=$;function P(c){if(!c)return null;const u=c.majorBase,o=c.majorMustEqual,g=c.minorBase;let d=c.minorMustEqual;const t=c.patchBase;let n=c.patchMustEqual;c.hasCaret&&(u===0||(d=!1),n=!1);let r=0;if(c.preRelease){const i=m.exec(c.preRelease);if(i){const[,a,h,p]=i;r=Date.UTC(Number(a),Number(h)-1,Number(p))}}return{majorBase:u,majorMustEqual:o,minorBase:g,minorMustEqual:d,patchBase:t,patchMustEqual:n,isMinimum:c.hasGreaterEquals,notBefore:r}}e.$Fo=P;function C(c,u,o){let g;typeof c=="string"?g=P($(c)):g=c;let d;u instanceof Date?d=u.getTime():typeof u=="string"&&(d=new Date(u).getTime());let t;if(typeof o=="string"?t=P($(o)):t=o,!g||!t)return!1;const n=g.majorBase,r=g.minorBase,i=g.patchBase;let a=t.majorBase,h=t.minorBase,p=t.patchBase;const I=t.notBefore;let w=t.majorMustEqual,f=t.minorMustEqual,b=t.patchMustEqual;return t.isMinimum?n>a?!0:n<a?!1:r>h?!0:r<h||d&&d<I?!1:i>=p:(n===1&&a===0&&(!w||!f||!b)&&(a=1,h=0,p=0,w=!0,f=!1,b=!1),n<a?!1:n>a?!w:r<h?!1:r>h?!f:i<p?!1:i>p?!b:!(d&&d<I))}e.$Go=C;function v(c,u,o,g,d){const t=[];if(typeof g.publisher<"u"&&typeof g.publisher!="string")return t.push([M.default.Error,l.localize(0,null)]),t;if(typeof g.name!="string")return t.push([M.default.Error,l.localize(1,null,"name")]),t;if(typeof g.version!="string")return t.push([M.default.Error,l.localize(2,null,"version")]),t;if(!g.engines)return t.push([M.default.Error,l.localize(3,null,"engines")]),t;if(typeof g.engines.vscode!="string")return t.push([M.default.Error,l.localize(4,null,"engines.vscode")]),t;if(typeof g.extensionDependencies<"u"&&!s(g.extensionDependencies))return t.push([M.default.Error,l.localize(5,null,"extensionDependencies")]),t;if(typeof g.activationEvents<"u"){if(!s(g.activationEvents))return t.push([M.default.Error,l.localize(6,null,"activationEvents")]),t;if(typeof g.main>"u"&&typeof g.browser>"u")return t.push([M.default.Error,l.localize(7,null,"activationEvents","main","browser")]),t}if(typeof g.extensionKind<"u"&&typeof g.main>"u"&&t.push([M.default.Warning,l.localize(8,null,"extensionKind")]),typeof g.main<"u"){if(typeof g.main!="string")return t.push([M.default.Error,l.localize(9,null,"main")]),t;{const i=(0,y.$sg)(o,g.main);(0,y.$mg)(i,o)||t.push([M.default.Warning,l.localize(10,null,i.path,o.path)])}}if(typeof g.browser<"u"){if(typeof g.browser!="string")return t.push([M.default.Error,l.localize(11,null,"browser")]),t;{const i=(0,y.$sg)(o,g.browser);(0,y.$mg)(i,o)||t.push([M.default.Warning,l.localize(12,null,i.path,o.path)])}}if(!R.valid(g.version))return t.push([M.default.Error,l.localize(13,null)]),t;const n=[];if(!S(c,u,g,d,n))for(const i of n)t.push([M.default.Error,i]);return t}e.$Ho=v;function S(c,u,o,g,d){return g||typeof o.main>"u"&&typeof o.browser>"u"?!0:E(c,u,o.engines.vscode,d)}e.$Io=S;function D(c,u,o){return c==="*"||E(u,o,c)}e.$Jo=D;function E(c,u,o,g=[]){const d=P($(o));if(!d)return g.push(l.localize(14,null,o)),!1;if(d.majorBase===0){if(!d.majorMustEqual||!d.minorMustEqual)return g.push(l.localize(15,null,o)),!1}else if(!d.majorMustEqual)return g.push(l.localize(16,null,o)),!1;return C(c,u,d)?!0:(g.push(l.localize(17,null,c,o)),!1)}function s(c){if(!Array.isArray(c))return!1;for(let u=0,o=c.length;u<o;u++)if(typeof c[u]!="string")return!1;return!0}}),define(Se[103],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ih=void 0;class y{constructor(l,R=[],A=!1){this.ctor=l,this.staticArguments=R,this.supportsDelayedInstantiation=A}}e.$Ih=y}),define(Se[104],De([1,0,103]),function(ne,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pr=e.$or=e.InstantiationType=void 0;const M=[];var l;(function(m){m[m.Eager=0]="Eager",m[m.Delayed=1]="Delayed"})(l||(e.InstantiationType=l={}));function R(m,k,$){k instanceof y.$Ih||(k=new y.$Ih(k,[],!!$)),M.push([m,k])}e.$or=R;function A(){return M}e.$pr=A}),define(Se[229],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7p=e.$6p=void 0;class y{constructor(R,A){this.key=R,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.$6p=y;class M{constructor(R){this.b=R,this.a=new Map}roots(){const R=[];for(const A of this.a.values())A.outgoing.size===0&&R.push(A);return R}insertEdge(R,A){const m=this.lookupOrInsertNode(R),k=this.lookupOrInsertNode(A);m.outgoing.set(k.key,k),k.incoming.set(m.key,m)}removeNode(R){const A=this.b(R);this.a.delete(A);for(const m of this.a.values())m.outgoing.delete(A),m.incoming.delete(A)}lookupOrInsertNode(R){const A=this.b(R);let m=this.a.get(A);return m||(m=new y(A,R),this.a.set(A,m)),m}lookup(R){return this.a.get(this.b(R))}isEmpty(){return this.a.size===0}toString(){const R=[];for(const[A,m]of this.a)R.push(`${A}
	(-> incoming)[${[...m.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...m.outgoing.keys()].join(",")}]
`);return R.join(`
`)}findCycleSlow(){for(const[R,A]of this.a){const m=new Set([R]),k=this.c(A,m);if(k)return k}}c(R,A){for(const[m,k]of R.outgoing){if(A.has(m))return[...A,m].join(" -> ");A.add(m);const $=this.c(k,A);if($)return $;A.delete(m)}}}e.$7p=M}),define(Se[5],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mh=e.$Lh=e.$Kh=e._util=void 0;var y;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function m(k){return k[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=m})(y||(e._util=y={})),e.$Kh=l("instantiationService");function M(A,m,k){m[y.DI_TARGET]===m?m[y.DI_DEPENDENCIES].push({id:A,index:k}):(m[y.DI_DEPENDENCIES]=[{id:A,index:k}],m[y.DI_TARGET]=m)}function l(A){if(y.serviceIds.has(A))return y.serviceIds.get(A);const m=function(k,$,P){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");M(m,k,P)};return m.toString=()=>A,y.serviceIds.set(A,m),m}e.$Lh=l;function R(A){return A}e.$Mh=R}),define(Se[49],De([1,0,18,2,5]),function(ne,e,y,M,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pi=e.$oi=e.$ni=e.$mi=e.$li=e.$ki=e.$ji=e.$ii=e.ConfigurationTarget=e.$hi=e.$gi=e.$fi=void 0,e.$fi=(0,l.$Lh)("configurationService");function R(c){return c&&typeof c=="object"&&(!c.overrideIdentifier||typeof c.overrideIdentifier=="string")&&(!c.resource||c.resource instanceof M.URI)}e.$gi=R;function A(c){return c&&typeof c=="object"&&(!c.overrideIdentifiers||Array.isArray(c.overrideIdentifiers))&&!c.overrideIdentifier&&(!c.resource||c.resource instanceof M.URI)}e.$hi=A;var m;(function(c){c[c.APPLICATION=1]="APPLICATION",c[c.USER=2]="USER",c[c.USER_LOCAL=3]="USER_LOCAL",c[c.USER_REMOTE=4]="USER_REMOTE",c[c.WORKSPACE=5]="WORKSPACE",c[c.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",c[c.DEFAULT=7]="DEFAULT",c[c.MEMORY=8]="MEMORY"})(m||(e.ConfigurationTarget=m={}));function k(c){switch(c){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$ii=k;function $(c){return c.applicationValue!==void 0||c.userValue!==void 0||c.userLocalValue!==void 0||c.userRemoteValue!==void 0||c.workspaceValue!==void 0||c.workspaceFolderValue!==void 0}e.$ji=$;function P(c,u){const o=Object.create(null);for(const g in c)C(o,g,c[g],u);return o}e.$ki=P;function C(c,u,o,g){const d=u.split("."),t=d.pop();let n=c;for(let r=0;r<d.length;r++){const i=d[r];let a=n[i];switch(typeof a){case"undefined":a=n[i]=Object.create(null);break;case"object":break;default:g(`Ignoring ${u} as ${d.slice(0,r+1).join(".")} is ${JSON.stringify(a)}`);return}n=a}if(typeof n=="object"&&n!==null)try{n[t]=o}catch{g(`Ignoring ${u} as ${d.join(".")} is ${JSON.stringify(n)}`)}else g(`Ignoring ${u} as ${d.join(".")} is ${JSON.stringify(n)}`)}e.$li=C;function v(c,u){const o=u.split(".");S(c,o)}e.$mi=v;function S(c,u){const o=u.shift();if(u.length===0){delete c[o];return}if(Object.keys(c).indexOf(o)!==-1){const g=c[o];typeof g=="object"&&!Array.isArray(g)&&(S(g,u),Object.keys(g).length===0&&delete c[o])}}function D(c,u,o){function g(n,r){let i=n;for(const a of r){if(typeof i!="object"||i===null)return;i=i[a]}return i}const d=u.split("."),t=g(c,d);return typeof t>"u"?o:t}e.$ni=D;function E(c,u,o){Object.keys(u).forEach(g=>{g!=="__proto__"&&(g in c?y.$yf(c[g])&&y.$yf(u[g])?E(c[g],u[g],o):o&&(c[g]=u[g]):c[g]=u[g])})}e.$oi=E;function s(c){return c.replace(/[\[\]]/g,"")}e.$pi=s}),define(Se[41],De([1,0,10,16,227,5,189,8]),function(ne,e,y,M,l,R,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.$Mi=e.$Li=e.$Ki=e.$Ji=e.$Ii=e.ContextKeyExprType=e.$Hi=void 0;const k=new Map;k.set("false",!1),k.set("true",!0),k.set("isMac",y.$e),k.set("isLinux",y.$f),k.set("isWindows",y.$d),k.set("isWeb",y.$j),k.set("isMacNative",y.$e&&!y.$j),k.set("isEdge",y.$B),k.set("isFirefox",y.$z),k.set("isChrome",y.$y),k.set("isSafari",y.$A);function $(de,V){if(k.get(de)!==void 0)throw(0,m.$5)("contextkey.setConstant(k, v) invoked with already set constant `k`");k.set(de,V)}e.$Hi=$;const P=Object.prototype.hasOwnProperty;var C;(function(de){de[de.False=0]="False",de[de.True=1]="True",de[de.Defined=2]="Defined",de[de.Not=3]="Not",de[de.Equals=4]="Equals",de[de.NotEquals=5]="NotEquals",de[de.And=6]="And",de[de.Regex=7]="Regex",de[de.NotRegex=8]="NotRegex",de[de.Or=9]="Or",de[de.In=10]="In",de[de.NotIn=11]="NotIn",de[de.Greater=12]="Greater",de[de.GreaterEquals=13]="GreaterEquals",de[de.Smaller=14]="Smaller",de[de.SmallerEquals=15]="SmallerEquals"})(C||(e.ContextKeyExprType=C={}));const v={regexParsingWithErrorRecovery:!0},S=(0,A.localize)(0,null),D=(0,A.localize)(1,null),E=(0,A.localize)(2,null),s=(0,A.localize)(3,null),c=(0,A.localize)(4,null),u=(0,A.localize)(5,null),o=(0,A.localize)(6,null),g=(0,A.localize)(7,null);class d{get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(V=v){this.k=V,this.d=new l.$Gi,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(V){if(V===""){this.h.push({message:S,offset:0,lexeme:"",additionalInfo:D});return}this.f=this.d.reset(V).scan(),this.g=0,this.h=[];try{const J=this.l();if(!this.E()){const ee=this.D(),Y=ee.type===17?u:void 0;throw this.h.push({message:c,offset:ee.offset,lexeme:l.$Gi.getLexeme(ee),additionalInfo:Y}),d.c}return J}catch(J){if(J!==d.c)throw J;return}}l(){return this.m()}m(){const V=[this.o()];for(;this.y(16);){const J=this.o();V.push(J)}return V.length===1?V[0]:t.or(...V)}o(){const V=[this.s()];for(;this.y(15);){const J=this.s();V.push(J)}return V.length===1?V[0]:t.and(...V)}s(){if(this.y(2)){const V=this.D();switch(V.type){case 11:return this.z(),a.INSTANCE;case 12:return this.z(),h.INSTANCE;case 0:{this.z();const J=this.l();return this.A(1,s),J?.negate()}case 17:return this.z(),L.create(V.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",V)}}return this.t()}t(){const V=this.D();switch(V.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const J=this.l();return this.A(1,s),J}case 17:{const J=V.lexeme;if(this.z(),this.y(9)){const Y=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),Y.type!==10)throw this.B("REGEX",Y);const Z=Y.lexeme,_=Z.lastIndexOf("/"),pe=_===Z.length-1?void 0:this.w(Z.substring(_+1));let se;try{se=new RegExp(Z.substring(1,_),pe)}catch{throw this.B("REGEX",Y)}return j.create(J,se)}switch(Y.type){case 10:case 19:{const Z=[Y.lexeme];this.z();let _=this.D(),pe=0;for(let be=0;be<Y.lexeme.length;be++)Y.lexeme.charCodeAt(be)===40?pe++:Y.lexeme.charCodeAt(be)===41&&pe--;for(;!this.E()&&_.type!==15&&_.type!==16;){switch(_.type){case 0:pe++;break;case 1:pe--;break;case 10:case 18:for(let be=0;be<_.lexeme.length;be++)_.lexeme.charCodeAt(be)===40?pe++:Y.lexeme.charCodeAt(be)===41&&pe--}if(pe<0)break;Z.push(l.$Gi.getLexeme(_)),this.z(),_=this.D()}const se=Z.join(""),ge=se.lastIndexOf("/"),ie=ge===se.length-1?void 0:this.w(se.substring(ge+1));let fe;try{fe=new RegExp(se.substring(1,ge),ie)}catch{throw this.B("REGEX",Y)}return t.regex(J,fe)}case 18:{const Z=Y.lexeme;this.z();let _=null;if(!(0,M.$ze)(Z)){const pe=Z.indexOf("/"),se=Z.lastIndexOf("/");if(pe!==se&&pe>=0){const ge=Z.slice(pe+1,se),ie=Z[se+1]==="i"?"i":"";try{_=new RegExp(ge,ie)}catch{throw this.B("REGEX",Y)}}}if(_===null)throw this.B("REGEX",Y);return j.create(J,_)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,E);const Y=this.u();return t.notIn(J,Y)}switch(this.D().type){case 3:{this.z();const Y=this.u();if(this.x().type===18)return t.equals(J,Y);switch(Y){case"true":return t.has(J);case"false":return t.not(J);default:return t.equals(J,Y)}}case 4:{this.z();const Y=this.u();if(this.x().type===18)return t.notEquals(J,Y);switch(Y){case"true":return t.not(J);case"false":return t.has(J);default:return t.notEquals(J,Y)}}case 5:return this.z(),U.create(J,this.u());case 6:return this.z(),N.create(J,this.u());case 7:return this.z(),T.create(J,this.u());case 8:return this.z(),F.create(J,this.u());case 13:return this.z(),t.in(J,this.u());default:return t.has(J)}}case 20:throw this.h.push({message:o,offset:V.offset,lexeme:"",additionalInfo:g}),d.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const V=this.D();switch(V.type){case 17:case 18:return this.z(),V.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(V){return V.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(V){return this.C(V)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(V,J){if(this.C(V))return this.z();throw this.B(J,this.D())}B(V,J,ee){const Y=(0,A.localize)(8,null,V,l.$Gi.getLexeme(J)),Z=J.offset,_=l.$Gi.getLexeme(J);return this.h.push({message:Y,offset:Z,lexeme:_,additionalInfo:ee}),d.c}C(V){return this.D().type===V}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Ii=d,d.c=new Error;class t{static false(){return a.INSTANCE}static true(){return h.INSTANCE}static has(V){return p.create(V)}static equals(V,J){return I.create(V,J)}static notEquals(V,J){return b.create(V,J)}static regex(V,J){return j.create(V,J)}static in(V,J){return w.create(V,J)}static notIn(V,J){return f.create(V,J)}static not(V){return L.create(V)}static and(...V){return ae.create(V,null,!0)}static or(...V){return X.create(V,null,!0)}static greater(V,J){return T.create(V,J)}static greaterEquals(V,J){return F.create(V,J)}static smaller(V,J){return U.create(V,J)}static smallerEquals(V,J){return N.create(V,J)}static deserialize(V){return V==null?void 0:this.c.parse(V)}}e.$Ji=t,t.c=new d({regexParsingWithErrorRecovery:!1});function n(de){const V=new d({regexParsingWithErrorRecovery:!1});return de.map(J=>(V.parse(J),V.lexingErrors.length>0?V.lexingErrors.map(ee=>({errorMessage:ee.additionalInfo?(0,A.localize)(9,null,ee.additionalInfo):(0,A.localize)(10,null),offset:ee.offset,length:ee.lexeme.length})):V.parsingErrors.length>0?V.parsingErrors.map(ee=>({errorMessage:ee.additionalInfo?`${ee.message}. ${ee.additionalInfo}`:ee.message,offset:ee.offset,length:ee.lexeme.length})):[]))}e.$Ki=n;function r(de,V){const J=de?de.substituteConstants():void 0,ee=V?V.substituteConstants():void 0;return!J&&!ee?!0:!J||!ee?!1:J.equals(ee)}e.$Li=r;function i(de,V){return de.cmp(V)}class a{constructor(){this.type=0}cmp(V){return this.type-V.type}equals(V){return V.type===this.type}substituteConstants(){return this}evaluate(V){return!1}serialize(){return"false"}keys(){return[]}map(V){return this}negate(){return h.INSTANCE}}e.$Mi=a,a.INSTANCE=new a;class h{constructor(){this.type=1}cmp(V){return this.type-V.type}equals(V){return V.type===this.type}substituteConstants(){return this}evaluate(V){return!0}serialize(){return"true"}keys(){return[]}map(V){return this}negate(){return a.INSTANCE}}e.$Ni=h,h.INSTANCE=new h;class p{static create(V,J=null){const ee=k.get(V);return typeof ee=="boolean"?ee?h.INSTANCE:a.INSTANCE:new p(V,J)}constructor(V,J){this.key=V,this.c=J,this.type=2}cmp(V){return V.type!==this.type?this.type-V.type:H(this.key,V.key)}equals(V){return V.type===this.type?this.key===V.key:!1}substituteConstants(){const V=k.get(this.key);return typeof V=="boolean"?V?h.INSTANCE:a.INSTANCE:this}evaluate(V){return!!V.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(V){return V.mapDefined(this.key)}negate(){return this.c||(this.c=L.create(this.key,this)),this.c}}e.$Oi=p;class I{static create(V,J,ee=null){if(typeof J=="boolean")return J?p.create(V,ee):L.create(V,ee);const Y=k.get(V);return typeof Y=="boolean"?J===(Y?"true":"false")?h.INSTANCE:a.INSTANCE:new I(V,J,ee)}constructor(V,J,ee){this.c=V,this.d=J,this.f=ee,this.type=4}cmp(V){return V.type!==this.type?this.type-V.type:te(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){const V=k.get(this.c);if(typeof V=="boolean"){const J=V?"true":"false";return this.d===J?h.INSTANCE:a.INSTANCE}return this}evaluate(V){return V.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(V){return V.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=b.create(this.c,this.d,this)),this.f}}e.$Pi=I;class w{static create(V,J){return new w(V,J)}constructor(V,J){this.d=V,this.f=J,this.type=10,this.c=null}cmp(V){return V.type!==this.type?this.type-V.type:te(this.d,this.f,V.d,V.f)}equals(V){return V.type===this.type?this.d===V.d&&this.f===V.f:!1}substituteConstants(){return this}evaluate(V){const J=V.getValue(this.f),ee=V.getValue(this.d);return Array.isArray(J)?J.includes(ee):typeof ee=="string"&&typeof J=="object"&&J!==null?P.call(J,ee):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(V){return V.mapIn(this.d,this.f)}negate(){return this.c||(this.c=f.create(this.d,this.f)),this.c}}e.$Qi=w;class f{static create(V,J){return new f(V,J)}constructor(V,J){this.d=V,this.f=J,this.type=11,this.c=w.create(V,J)}cmp(V){return V.type!==this.type?this.type-V.type:this.c.cmp(V.c)}equals(V){return V.type===this.type?this.c.equals(V.c):!1}substituteConstants(){return this}evaluate(V){return!this.c.evaluate(V)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(V){return V.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Ri=f;class b{static create(V,J,ee=null){if(typeof J=="boolean")return J?L.create(V,ee):p.create(V,ee);const Y=k.get(V);return typeof Y=="boolean"?J===(Y?"true":"false")?a.INSTANCE:h.INSTANCE:new b(V,J,ee)}constructor(V,J,ee){this.c=V,this.d=J,this.f=ee,this.type=5}cmp(V){return V.type!==this.type?this.type-V.type:te(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){const V=k.get(this.c);if(typeof V=="boolean"){const J=V?"true":"false";return this.d===J?a.INSTANCE:h.INSTANCE}return this}evaluate(V){return V.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(V){return V.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=I.create(this.c,this.d,this)),this.f}}e.$Si=b;class L{static create(V,J=null){const ee=k.get(V);return typeof ee=="boolean"?ee?a.INSTANCE:h.INSTANCE:new L(V,J)}constructor(V,J){this.c=V,this.d=J,this.type=3}cmp(V){return V.type!==this.type?this.type-V.type:H(this.c,V.c)}equals(V){return V.type===this.type?this.c===V.c:!1}substituteConstants(){const V=k.get(this.c);return typeof V=="boolean"?V?a.INSTANCE:h.INSTANCE:this}evaluate(V){return!V.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(V){return V.mapNot(this.c)}negate(){return this.d||(this.d=p.create(this.c,this)),this.d}}e.$Ti=L;function O(de,V){if(typeof de=="string"){const J=parseFloat(de);isNaN(J)||(de=J)}return typeof de=="string"||typeof de=="number"?V(de):a.INSTANCE}class T{static create(V,J,ee=null){return O(J,Y=>new T(V,Y,ee))}constructor(V,J,ee){this.c=V,this.d=J,this.f=ee,this.type=12}cmp(V){return V.type!==this.type?this.type-V.type:te(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){return this}evaluate(V){return typeof this.d=="string"?!1:parseFloat(V.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(V){return V.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=N.create(this.c,this.d,this)),this.f}}e.$Ui=T;class F{static create(V,J,ee=null){return O(J,Y=>new F(V,Y,ee))}constructor(V,J,ee){this.c=V,this.d=J,this.f=ee,this.type=13}cmp(V){return V.type!==this.type?this.type-V.type:te(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){return this}evaluate(V){return typeof this.d=="string"?!1:parseFloat(V.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(V){return V.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=U.create(this.c,this.d,this)),this.f}}e.$Vi=F;class U{static create(V,J,ee=null){return O(J,Y=>new U(V,Y,ee))}constructor(V,J,ee){this.c=V,this.d=J,this.f=ee,this.type=14}cmp(V){return V.type!==this.type?this.type-V.type:te(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){return this}evaluate(V){return typeof this.d=="string"?!1:parseFloat(V.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(V){return V.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=F.create(this.c,this.d,this)),this.f}}e.$Wi=U;class N{static create(V,J,ee=null){return O(J,Y=>new N(V,Y,ee))}constructor(V,J,ee){this.c=V,this.d=J,this.f=ee,this.type=15}cmp(V){return V.type!==this.type?this.type-V.type:te(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){return this}evaluate(V){return typeof this.d=="string"?!1:parseFloat(V.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(V){return V.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=T.create(this.c,this.d,this)),this.f}}e.$Xi=N;class j{static create(V,J){return new j(V,J)}constructor(V,J){this.d=V,this.f=J,this.type=7,this.c=null}cmp(V){if(V.type!==this.type)return this.type-V.type;if(this.d<V.d)return-1;if(this.d>V.d)return 1;const J=this.f?this.f.source:"",ee=V.f?V.f.source:"";return J<ee?-1:J>ee?1:0}equals(V){if(V.type===this.type){const J=this.f?this.f.source:"",ee=V.f?V.f.source:"";return this.d===V.d&&J===ee}return!1}substituteConstants(){return this}evaluate(V){const J=V.getValue(this.d);return this.f?this.f.test(J):!1}serialize(){const V=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${V}`}keys(){return[this.d]}map(V){return V.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=z.create(this)),this.c}}e.$Yi=j;class z{static create(V){return new z(V)}constructor(V){this.c=V,this.type=8}cmp(V){return V.type!==this.type?this.type-V.type:this.c.cmp(V.c)}equals(V){return V.type===this.type?this.c.equals(V.c):!1}substituteConstants(){return this}evaluate(V){return!this.c.evaluate(V)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(V){return new z(this.c.map(V))}negate(){return this.c}}e.$Zi=z;function B(de){let V=null;for(let J=0,ee=de.length;J<ee;J++){const Y=de[J].substituteConstants();if(de[J]!==Y&&V===null){V=[];for(let Z=0;Z<J;Z++)V[Z]=de[Z]}V!==null&&(V[J]=Y)}return V===null?de:V}class ae{static create(V,J,ee){return ae.d(V,J,ee)}constructor(V,J){this.expr=V,this.c=J,this.type=6}cmp(V){if(V.type!==this.type)return this.type-V.type;if(this.expr.length<V.expr.length)return-1;if(this.expr.length>V.expr.length)return 1;for(let J=0,ee=this.expr.length;J<ee;J++){const Y=i(this.expr[J],V.expr[J]);if(Y!==0)return Y}return 0}equals(V){if(V.type===this.type){if(this.expr.length!==V.expr.length)return!1;for(let J=0,ee=this.expr.length;J<ee;J++)if(!this.expr[J].equals(V.expr[J]))return!1;return!0}return!1}substituteConstants(){const V=B(this.expr);return V===this.expr?this:ae.create(V,this.c,!1)}evaluate(V){for(let J=0,ee=this.expr.length;J<ee;J++)if(!this.expr[J].evaluate(V))return!1;return!0}static d(V,J,ee){const Y=[];let Z=!1;for(const _ of V)if(_){if(_.type===1){Z=!0;continue}if(_.type===0)return a.INSTANCE;if(_.type===6){Y.push(..._.expr);continue}Y.push(_)}if(Y.length===0&&Z)return h.INSTANCE;if(Y.length!==0){if(Y.length===1)return Y[0];Y.sort(i);for(let _=1;_<Y.length;_++)Y[_-1].equals(Y[_])&&(Y.splice(_,1),_--);if(Y.length===1)return Y[0];for(;Y.length>1;){const _=Y[Y.length-1];if(_.type!==9)break;Y.pop();const pe=Y.pop(),se=Y.length===0,ge=X.create(_.expr.map(ie=>ae.create([ie,pe],null,ee)),null,se);ge&&(Y.push(ge),Y.sort(i))}if(Y.length===1)return Y[0];if(ee){for(let _=0;_<Y.length;_++)for(let pe=_+1;pe<Y.length;pe++)if(Y[_].negate().equals(Y[pe]))return a.INSTANCE;if(Y.length===1)return Y[0]}return new ae(Y,J)}}serialize(){return this.expr.map(V=>V.serialize()).join(" && ")}keys(){const V=[];for(const J of this.expr)V.push(...J.keys());return V}map(V){return new ae(this.expr.map(J=>J.map(V)),null)}negate(){if(!this.c){const V=[];for(const J of this.expr)V.push(J.negate());this.c=X.create(V,this,!0)}return this.c}}e.$1i=ae;class X{static create(V,J,ee){return X.d(V,J,ee)}constructor(V,J){this.expr=V,this.c=J,this.type=9}cmp(V){if(V.type!==this.type)return this.type-V.type;if(this.expr.length<V.expr.length)return-1;if(this.expr.length>V.expr.length)return 1;for(let J=0,ee=this.expr.length;J<ee;J++){const Y=i(this.expr[J],V.expr[J]);if(Y!==0)return Y}return 0}equals(V){if(V.type===this.type){if(this.expr.length!==V.expr.length)return!1;for(let J=0,ee=this.expr.length;J<ee;J++)if(!this.expr[J].equals(V.expr[J]))return!1;return!0}return!1}substituteConstants(){const V=B(this.expr);return V===this.expr?this:X.create(V,this.c,!1)}evaluate(V){for(let J=0,ee=this.expr.length;J<ee;J++)if(this.expr[J].evaluate(V))return!0;return!1}static d(V,J,ee){let Y=[],Z=!1;if(V){for(let _=0,pe=V.length;_<pe;_++){const se=V[_];if(se){if(se.type===0){Z=!0;continue}if(se.type===1)return h.INSTANCE;if(se.type===9){Y=Y.concat(se.expr);continue}Y.push(se)}}if(Y.length===0&&Z)return a.INSTANCE;Y.sort(i)}if(Y.length!==0){if(Y.length===1)return Y[0];for(let _=1;_<Y.length;_++)Y[_-1].equals(Y[_])&&(Y.splice(_,1),_--);if(Y.length===1)return Y[0];if(ee){for(let _=0;_<Y.length;_++)for(let pe=_+1;pe<Y.length;pe++)if(Y[_].negate().equals(Y[pe]))return h.INSTANCE;if(Y.length===1)return Y[0]}return new X(Y,J)}}serialize(){return this.expr.map(V=>V.serialize()).join(" || ")}keys(){const V=[];for(const J of this.expr)V.push(...J.keys());return V}map(V){return new X(this.expr.map(J=>J.map(V)),null)}negate(){if(!this.c){const V=[];for(const J of this.expr)V.push(J.negate());for(;V.length>1;){const J=V.shift(),ee=V.shift(),Y=[];for(const Z of ye(J))for(const _ of ye(ee))Y.push(ae.create([Z,_],null,!1));V.unshift(X.create(Y,null,!1))}this.c=X.create(V,this,!0)}return this.c}}e.$2i=X;class Q extends p{static all(){return Q.d.values()}constructor(V,J,ee){super(V,null),this.f=J,typeof ee=="object"?Q.d.push({...ee,key:V}):ee!==!0&&Q.d.push({key:V,description:ee,type:J!=null?typeof J:void 0})}bindTo(V){return V.createKey(this.key,this.f)}getValue(V){return V.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(V){return I.create(this.key,V)}notEqualsTo(V){return b.create(this.key,V)}}e.$3i=Q,Q.d=[],e.$4i=(0,R.$Lh)("contextKeyService");function H(de,V){return de<V?-1:de>V?1:0}function te(de,V,J,ee){return de<J?-1:de>J?1:V<ee?-1:V>ee?1:0}function me(de,V){if(de.type===0||V.type===1)return!0;if(de.type===9)return V.type===9?le(de.expr,V.expr):!1;if(V.type===9){for(const J of V.expr)if(me(de,J))return!0;return!1}if(de.type===6){if(V.type===6)return le(V.expr,de.expr);for(const J of de.expr)if(me(J,V))return!0;return!1}return de.equals(V)}e.$5i=me;function le(de,V){let J=0,ee=0;for(;J<de.length&&ee<V.length;){const Y=de[J].cmp(V[ee]);if(Y<0)return!1;Y===0&&J++,ee++}return J===de.length}function ye(de){return de.type===9?de.expr:[de]}}),define(Se[230],De([1,0,24,39,191,5,100,10,23]),function(ne,e,y,M,l,R,A,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xv=e.$wv=e.ConfirmResult=e.$vv=e.$uv=e.$tv=void 0,e.$tv=(0,R.$Lh)("dialogService");var $;(function(E){E[E.Confirmation=1]="Confirmation",E[E.Prompt=2]="Prompt",E[E.Input=3]="Input"})($||($={}));class P{a(s){return this.d(s,$.Confirmation)}b(s){return this.d(s,$.Prompt)}c(s){return this.d(s,$.Input)}d(s,c){const u=[];switch(c){case $.Confirmation:{const o=s;o.primaryButton?u.push(o.primaryButton):u.push((0,l.localize)(0,null)),o.cancelButton?u.push(o.cancelButton):u.push((0,l.localize)(1,null));break}case $.Prompt:{const o=s;Array.isArray(o.buttons)&&o.buttons.length>0&&u.push(...o.buttons.map(g=>g.label)),o.cancelButton&&(o.cancelButton===!0?u.push((0,l.localize)(2,null)):typeof o.cancelButton=="string"?u.push(o.cancelButton):o.cancelButton.label?u.push(o.cancelButton.label):u.push((0,l.localize)(3,null))),u.length===0&&u.push((0,l.localize)(4,null));break}case $.Input:{const o=s;o.primaryButton?u.push(o.primaryButton):u.push((0,l.localize)(5,null)),o.cancelButton?u.push(o.cancelButton):u.push((0,l.localize)(6,null));break}}return u}e(s){if(typeof s=="string")return s;if(typeof s=="number")return s===M.default.Info?"info":s===M.default.Error?"error":s===M.default.Warning?"warning":"none"}async f(s,c,u){const o=[...s.buttons??[]];return s.cancelButton&&typeof s.cancelButton!="string"&&typeof s.cancelButton!="boolean"&&o.push(s.cancelButton),{result:await o[c]?.run({checkboxChecked:u}),checkboxChecked:u}}}e.$uv=P,e.$vv=(0,R.$Lh)("fileDialogService");var C;(function(E){E[E.SAVE=0]="SAVE",E[E.DONT_SAVE=1]="DONT_SAVE",E[E.CANCEL=2]="CANCEL"})(C||(e.ConfirmResult=C={}));const v=10;function S(E){const s=[];return s.push(...E.slice(0,v).map(c=>typeof c=="string"?c:(0,y.$pg)(c))),E.length>v&&(E.length-v===1?s.push((0,l.localize)(7,null)):s.push((0,l.localize)(8,null,E.length-v))),s.push(""),s.join(`
`)}e.$wv=S;function D(E,s){const c=(0,k.$Xm)(E);let u=(c.buttons??[]).map(t=>(0,A.$qv)(t)),o=(E.buttons||[]).map((t,n)=>n),g=0,d=c.cancelId??u.length-1;if(u.length>1){const t=typeof d=="number"?u[d]:void 0;if(m.$f||m.$e){if(typeof t=="string"&&u.length>1&&d!==1){u.splice(d,1),u.splice(1,0,t);const n=o[d];o.splice(d,1),o.splice(1,0,n),d=1}m.$f&&u.length>1&&(u=u.reverse(),o=o.reverse(),g=u.length-1,typeof t=="string"&&(d=g-1))}else if(m.$d&&typeof t=="string"&&u.length>1&&d!==u.length-1){u.splice(d,1),u.push(t);const n=o[d];o.splice(d,1),o.push(n),d=u.length-1}}return c.buttons=u,c.defaultId=g,c.cancelId=d,c.noLink=!0,c.title=c.title||s.nameLong,{options:c,buttonIndeces:o}}e.$xv=D}),define(Se[132],De([1,0,5]),function(ne,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Th=e.$Sh=void 0,e.$Sh=(0,y.$Lh)("environmentService"),e.$Th=(0,y.$Mh)(e.$Sh)}),define(Se[133],De([1,0,192,5]),function(ne,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$2n=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$1n=e.$Zn=e.$Yn=e.$Xn=e.$Wn=e.$Vn=e.$Un=e.$Tn=e.$Sn=e.$Rn=e.$Qn=e.$Pn=e.$On=void 0,e.$On="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Pn=new RegExp(e.$On),e.$Qn="__web_extension",e.$Rn="skipWalkthrough",e.$Sn="extensionsSync",e.$Tn="dependecyOrPackExtensionInstall";function l(u){switch(u){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$Un=l;function R(u){switch(u){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$Vn=R;function A(u,o){switch(u){case 3:return o==="x64"?"win32-x64":o==="ia32"?"win32-ia32":o==="arm64"?"win32-arm64":"unknown";case 2:return o==="x64"?"linux-x64":o==="arm64"?"linux-arm64":o==="arm"?"linux-armhf":"unknown";case"alpine":return o==="x64"?"alpine-x64":o==="arm64"?"alpine-arm64":"unknown";case 1:return o==="x64"?"darwin-x64":o==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$Wn=A;function m(u,o){return o==="web"&&!u.includes("web")}e.$Xn=m;function k(u,o,g){return m(o,g)?!1:u==="undefined"||u==="universal"?!0:u==="unknown"?!1:u===g?!0:$(g).includes(u)}e.$Yn=k;function $(u){switch(u){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.$Zn=$;function P(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(!u.uuid||typeof u.uuid=="string")}e.$1n=P;var C;(function(u){u[u.NoneOrRelevance=0]="NoneOrRelevance",u[u.LastUpdatedDate=1]="LastUpdatedDate",u[u.Title=2]="Title",u[u.PublisherName=3]="PublisherName",u[u.InstallCount=4]="InstallCount",u[u.PublishedDate=10]="PublishedDate",u[u.AverageRating=6]="AverageRating",u[u.WeightedRating=12]="WeightedRating"})(C||(e.SortBy=C={}));var v;(function(u){u[u.Default=0]="Default",u[u.Ascending=1]="Ascending",u[u.Descending=2]="Descending"})(v||(e.SortOrder=v={}));var S;(function(u){u.Install="install",u.Uninstall="uninstall"})(S||(e.StatisticType=S={}));var D;(function(u){u[u.None=1]="None",u[u.Install=2]="Install",u[u.Update=3]="Update",u[u.Migrate=4]="Migrate"})(D||(e.InstallOperation=D={})),e.$2n=(0,M.$Lh)("extensionGalleryService");var E;(function(u){u.Unsupported="Unsupported",u.Deprecated="Deprecated",u.Malicious="Malicious",u.Incompatible="Incompatible",u.IncompatibleTargetPlatform="IncompatibleTargetPlatform",u.ReleaseVersionNotFound="ReleaseVersionNotFound",u.Invalid="Invalid",u.Download="Download",u.Extract="Extract",u.Delete="Delete",u.Rename="Rename",u.CorruptZip="CorruptZip",u.IncompleteZip="IncompleteZip",u.Signature="Signature",u.Internal="Internal"})(E||(e.ExtensionManagementErrorCode=E={}));var s;(function(u){u.UnknownError="UnknownError",u.PackageIsInvalidZip="PackageIsInvalidZip",u.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(s||(e.ExtensionSignaturetErrorCode=s={}));class c extends Error{constructor(o,g){super(o),this.code=g,this.name=g}}e.$3n=c,e.$4n=(0,M.$Lh)("extensionManagementService"),e.$5n="extensionsIdentifiers/disabled",e.$6n="extensionsIdentifiers/enabled",e.$7n=(0,M.$Lh)("IGlobalExtensionEnablementService"),e.$8n=(0,M.$Lh)("IExtensionTipsService"),e.$9n=(0,y.localize)(0,null),e.$0n={value:e.$9n,original:"Extensions"},e.$$n={value:(0,y.localize)(1,null),original:"Preferences"}}),define(Se[231],De([1,0,5]),function(ne,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PXb=e.$OXb=void 0,e.$OXb=(0,y.$Lh)("externalTerminal"),e.$PXb="Terminal.app"}),define(Se[232],De([1,0,47,17,15,10,98,29,102,194,231]),function(ne,e,y,M,l,R,A,m,k,$,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$z6b=e.$y6b=e.$x6b=void 0;const C=$.localize(0,null);class v{async getDefaultTerminalForPlatforms(){return{windows:S.getDefaultTerminalWindows(),linux:await E.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class S extends v{openTerminal(g,d){return this.spawnTerminal(y,g,k.$wl(),d)}spawnTerminal(g,d,t,n){const r=d.windowsExec||S.getDefaultTerminalWindows();n&&n[1]===":"&&(n=n[0].toUpperCase()+n.substr(1));const i=l.$lc(r,".exe").toLowerCase();if(i==="cmder")return g.spawn(r,n?[n]:void 0),Promise.resolve(void 0);const a=["/c","start","/wait"];return r.indexOf(" ")>=0&&a.push('""'),a.push(r),i==="wt"&&a.push("-d ."),new Promise((h,p)=>{const I=s(process),w=g.spawn(t,a,{cwd:n,env:I});w.on("error",p),w.on("exit",()=>h())})}runInTerminal(g,d,t,n,r){const i="windowsExec"in r&&r.windowsExec?r.windowsExec:S.getDefaultTerminalWindows();return new Promise((a,h)=>{const p=`"${d} - ${C}"`,I=`""${t.join('" "')}" & pause"`,w=Object.assign({},s(process),n);Object.keys(w).filter(T=>w[T]===null).forEach(T=>delete w[T]);const f={cwd:d,env:w,windowsVerbatimArguments:!0};let b,L;l.$lc(i,".exe")==="wt"?(b=i,L=["-d",".",S.b,"/c",I]):(b=S.b,L=["/c","start",p,"/wait",i,"/c",I]),y.spawn(b,L,f).on("error",T=>{h(c(T))}),a(void 0)})}static getDefaultTerminalWindows(){if(!S.d){const g=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");S.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${g?"Sysnative":"System32"}\\cmd.exe`}return S.d}}e.$x6b=S,S.b="cmd.exe";class D extends v{openTerminal(g,d){return this.spawnTerminal(y,g,d)}runInTerminal(g,d,t,n,r){const i=r.osxExec||P.$PXb;return new Promise((a,h)=>{if(i===P.$PXb||i==="iTerm.app"){const p=i===P.$PXb?"TerminalHelper":"iTermHelper",w=[M.$_f.asFileUri(`vs/workbench/contrib/externalTerminal/node/${p}.scpt`).fsPath,"-t",g||C,"-w",d];for(const L of t)w.push("-a"),w.push(L);if(n){const L=Object.assign({},s(process),n);for(const O in L){const T=L[O];T===null?(w.push("-u"),w.push(O)):(w.push("-e"),w.push(`${O}=${T}`))}}let f="";const b=y.spawn(D.b,w);b.on("error",L=>{h(c(L))}),b.stderr.on("data",L=>{f+=L.toString()}),b.on("exit",L=>{if(L===0)a(void 0);else if(f){const O=f.split(`
`,1);h(new Error(O[0]))}else h(new Error($.localize(1,null,p,L)))})}else h(new Error($.localize(2,null,i)))})}spawnTerminal(g,d,t){const n=d.osxExec||P.$PXb;return new Promise((r,i)=>{const a=["-a",n];t&&a.push(t);const h=s(process),p=g.spawn("/usr/bin/open",a,{cwd:t,env:h});p.on("error",i),p.on("exit",()=>r())})}}e.$y6b=D,D.b="/usr/bin/osascript";class E extends v{openTerminal(g,d){return this.spawnTerminal(y,g,d)}runInTerminal(g,d,t,n,r){const i=r.linuxExec?Promise.resolve(r.linuxExec):E.getDefaultTerminalLinuxReady();return new Promise((a,h)=>{const p=[];i.then(I=>{I.indexOf("gnome-terminal")>=0?p.push("-x"):p.push("-e"),p.push("bash"),p.push("-c");const w=`${u(t)}; echo; read -p "${E.b}" -n1;`;p.push(`''${w}''`);const f=Object.assign({},s(process),n);Object.keys(f).filter(T=>f[T]===null).forEach(T=>delete f[T]);const b={cwd:d,env:f};let L="";const O=y.spawn(I,p,b);O.on("error",T=>{h(c(T))}),O.stderr.on("data",T=>{L+=T.toString()}),O.on("exit",T=>{if(T===0)a(void 0);else if(L){const F=L.split(`
`,1);h(new Error(F[0]))}else h(new Error($.localize(4,null,I,T)))})})})}static async getDefaultTerminalLinuxReady(){if(!E.d)if(!R.$f)E.d=Promise.resolve("xterm");else{const g=await m.Promises.exists("/etc/debian_version");E.d=new Promise(d=>{g?d("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?d("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?d("konsole"):process.env.COLORTERM?d(process.env.COLORTERM):process.env.TERM?d(process.env.TERM):d("xterm")})}return E.d}spawnTerminal(g,d,t){const n=d.linuxExec?Promise.resolve(d.linuxExec):E.getDefaultTerminalLinuxReady();return new Promise((r,i)=>{n.then(a=>{const h=s(process),p=g.spawn(a,[],{cwd:t,env:h});p.on("error",i),p.on("exit",()=>r())})})}}e.$z6b=E,E.b=$.localize(3,null);function s(o){const g={...o.env};return(0,A.$ul)(g),g}function c(o){return"errno"in o&&o.errno==="ENOENT"&&"path"in o&&typeof o.path=="string"?new Error($.localize(5,null,o.path)):o}function u(o){let g="";for(const d of o)d.indexOf(" ")>=0?g+='"'+d+'"':g+=d,g+=" ";return g}}),define(Se[30],De([1,0,78,15,16,18,2,195,5,10,17]),function(ne,e,y,M,l,R,A,m,k,$,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ck=e.$Bk=e.$Ak=e.$zk=e.$yk=e.FileKind=e.$xk=e.$wk=e.$vk=e.$uk=e.$tk=e.$sk=e.$rk=e.FileOperationResult=e.$qk=e.$pk=e.$ok=e.$nk=e.$mk=e.FileChangeType=e.$lk=e.FileOperation=e.$kk=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.FileSystemProviderErrorCode=e.$ek=e.$dk=e.$ck=e.$bk=e.$ak=e.$_j=e.$$j=e.$0j=e.$9j=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.$8j=e.$7j=void 0,e.$7j=(0,k.$Lh)("fileService");function C(H){return H.create===!0}e.$8j=C;var v;(function(H){H[H.Unknown=0]="Unknown",H[H.File=1]="File",H[H.Directory=2]="Directory",H[H.SymbolicLink=64]="SymbolicLink"})(v||(e.FileType=v={}));var S;(function(H){H[H.Readonly=1]="Readonly",H[H.Locked=2]="Locked"})(S||(e.FilePermission=S={}));var D;(function(H){H[H.None=0]="None",H[H.FileReadWrite=2]="FileReadWrite",H[H.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",H[H.FileReadStream=16]="FileReadStream",H[H.FileFolderCopy=8]="FileFolderCopy",H[H.PathCaseSensitive=1024]="PathCaseSensitive",H[H.Readonly=2048]="Readonly",H[H.Trash=4096]="Trash",H[H.FileWriteUnlock=8192]="FileWriteUnlock",H[H.FileAtomicRead=16384]="FileAtomicRead",H[H.FileAtomicWrite=32768]="FileAtomicWrite",H[H.FileAtomicDelete=65536]="FileAtomicDelete",H[H.FileClone=131072]="FileClone"})(D||(e.FileSystemProviderCapabilities=D={}));function E(H){return!!(H.capabilities&2)}e.$9j=E;function s(H){return!!(H.capabilities&8)}e.$0j=s;function c(H){return!!(H.capabilities&131072)}e.$$j=c;function u(H){return!!(H.capabilities&4)}e.$_j=u;function o(H){return!!(H.capabilities&16)}e.$ak=o;function g(H){return E(H)?!!(H.capabilities&16384):!1}e.$bk=g;function d(H){return E(H)?!!(H.capabilities&32768):!1}e.$ck=d;function t(H){return!!(H.capabilities&65536)}e.$dk=t;function n(H){return!!(H.capabilities&2048)}e.$ek=n;var r;(function(H){H.FileExists="EntryExists",H.FileNotFound="EntryNotFound",H.FileNotADirectory="EntryNotADirectory",H.FileIsADirectory="EntryIsADirectory",H.FileExceedsStorageQuota="EntryExceedsStorageQuota",H.FileTooLarge="EntryTooLarge",H.FileWriteLocked="EntryWriteLocked",H.NoPermissions="NoPermissions",H.Unavailable="Unavailable",H.Unknown="Unknown"})(r||(e.FileSystemProviderErrorCode=r={}));class i extends Error{static create(te,me){const le=new i(te.toString(),me);return p(le,me),le}constructor(te,me){super(te),this.code=me}}e.$fk=i;function a(H,te){return i.create(H,te)}e.$gk=a;function h(H){return H||a((0,m.localize)(0,null),r.Unknown)}e.$hk=h;function p(H,te){return H.name=te?`${te} (FileSystemError)`:"FileSystemError",H}e.$ik=p;function I(H){if(!H)return r.Unknown;if(H instanceof i)return H.code;const te=/^(.+) \(FileSystemError\)$/.exec(H.name);if(!te)return r.Unknown;switch(te[1]){case r.FileExists:return r.FileExists;case r.FileIsADirectory:return r.FileIsADirectory;case r.FileNotADirectory:return r.FileNotADirectory;case r.FileNotFound:return r.FileNotFound;case r.FileTooLarge:return r.FileTooLarge;case r.FileWriteLocked:return r.FileWriteLocked;case r.NoPermissions:return r.NoPermissions;case r.Unavailable:return r.Unavailable}return r.Unknown}e.$jk=I;function w(H){if(H instanceof F)return H.fileOperationResult;switch(I(H)){case r.FileNotFound:return 1;case r.FileIsADirectory:return 0;case r.FileNotADirectory:return 9;case r.FileWriteLocked:return 5;case r.NoPermissions:return 6;case r.FileExists:return 4;case r.FileTooLarge:return 7;default:return 10}}e.$kk=w;var f;(function(H){H[H.CREATE=0]="CREATE",H[H.DELETE=1]="DELETE",H[H.MOVE=2]="MOVE",H[H.COPY=3]="COPY",H[H.WRITE=4]="WRITE"})(f||(e.FileOperation=f={}));class b{constructor(te,me,le){this.resource=te,this.operation=me,this.target=le}isOperation(te){return this.operation===te}}e.$lk=b;var L;(function(H){H[H.UPDATED=0]="UPDATED",H[H.ADDED=1]="ADDED",H[H.DELETED=2]="DELETED"})(L||(e.FileChangeType=L={}));class O{constructor(te,me){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const le=new Map;for(const ye of te){const de=le.get(ye.type);switch(de?de.push([ye.resource,ye]):le.set(ye.type,[[ye.resource,ye]]),ye.type){case 1:this.rawAdded.push(ye.resource);break;case 0:this.rawUpdated.push(ye.resource);break;case 2:this.rawDeleted.push(ye.resource);break}}for(const[ye,de]of le)switch(ye){case 1:this.a=y.$Rh.forUris(()=>me),this.a.fill(de);break;case 0:this.b=y.$Rh.forUris(()=>me),this.b.fill(de);break;case 2:this.c=y.$Rh.forUris(()=>me),this.c.fill(de);break}}contains(te,...me){return this.d(te,{includeChildren:!1},...me)}affects(te,...me){return this.d(te,{includeChildren:!0},...me)}d(te,me,...le){if(!te)return!1;const ye=le.length>0;return!!((!ye||le.includes(1))&&(this.a?.get(te)||me.includeChildren&&this.a?.findSuperstr(te))||(!ye||le.includes(0))&&(this.b?.get(te)||me.includeChildren&&this.b?.findSuperstr(te))||(!ye||le.includes(2))&&(this.c?.findSubstr(te)||me.includeChildren&&this.c?.findSuperstr(te)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.$mk=O;function T(H,te,me){return!H||!te||H===te||te.length>H.length?!1:(te.charAt(te.length-1)!==M.sep&&(te+=M.sep),me?(0,l.$1e)(H,te):H.indexOf(te)===0)}e.$nk=T;class F extends Error{constructor(te,me,le){super(te),this.fileOperationResult=me,this.options=le}}e.$ok=F;class U extends F{constructor(te,me,le,ye){super(te,me,ye),this.fileOperationResult=me,this.size=le}}e.$pk=U;class N extends F{constructor(te,me,le){super(te,2,le),this.stat=me}}e.$qk=N;var j;(function(H){H[H.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",H[H.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",H[H.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",H[H.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",H[H.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",H[H.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",H[H.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",H[H.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",H[H.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",H[H.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",H[H.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(j||(e.FileOperationResult=j={})),e.$rk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$sk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$tk="files.associations",e.$uk="files.exclude",e.$vk="files.readonlyInclude",e.$wk="files.readonlyExclude",e.$xk="files.readonlyFromPermissions";var z;(function(H){H[H.FILE=0]="FILE",H[H.FOLDER=1]="FOLDER",H[H.ROOT_FOLDER=2]="ROOT_FOLDER"})(z||(e.FileKind=z={})),e.$yk="";function B(H){if(!(typeof H.size!="number"||typeof H.mtime!="number"))return H.mtime.toString(29)+H.size.toString(31)}e.$zk=B;async function ae(H,te){if(!te.hasProvider(A.URI.from({scheme:H.scheme})))return new Promise(me=>{const le=te.onDidChangeFileSystemProviderRegistrations(ye=>{ye.scheme===H.scheme&&ye.added&&(le.dispose(),me())})})}e.$Ak=ae;class X{static formatSize(te){return(0,R.$Af)(te)||(te=0),te<X.KB?(0,m.localize)(1,null,te.toFixed(0)):te<X.MB?(0,m.localize)(2,null,(te/X.KB).toFixed(2)):te<X.GB?(0,m.localize)(3,null,(te/X.MB).toFixed(2)):te<X.TB?(0,m.localize)(4,null,(te/X.GB).toFixed(2)):(0,m.localize)(5,null,(te/X.TB).toFixed(2))}}e.$Bk=X,X.KB=1024,X.MB=X.KB*X.KB,X.GB=X.MB*X.KB,X.TB=X.GB*X.KB;function Q(H){const te=typeof H=="string"||H?.scheme===P.Schemas.vscodeRemote;return typeof H!="string"&&H?.scheme===P.Schemas.file?1024*X.MB:te?10*X.MB:$.$j?50*X.MB:1024*X.MB}e.$Ck=Q}),define(Se[233],De([1,0,22,8,196,30]),function(ne,e,y,M,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ep=void 0;async function A(P,C,v,S,D,E){let s;try{await m(P,C,v,S,D,E)}catch(c){s=c}finally{s&&D.errorTransformer&&(s=D.errorTransformer(s)),typeof s<"u"&&v.error(s),v.end()}}e.$Ep=A;async function m(P,C,v,S,D,E){k(E);const s=await P.open(C,{create:!1});try{k(E);let c=0,u=0,o=D&&typeof D.length=="number"?D.length:void 0,g=y.$_d.alloc(Math.min(D.bufferSize,typeof o=="number"?o:D.bufferSize)),d=D&&typeof D.position=="number"?D.position:0,t=0;do u=await P.read(s,d,g.buffer,t,g.byteLength-t),d+=u,t+=u,c+=u,typeof o=="number"&&(o-=u),t===g.byteLength&&(await v.write(S(g)),g=y.$_d.alloc(Math.min(D.bufferSize,typeof o=="number"?o:D.bufferSize)),t=0);while(u>0&&(typeof o!="number"||o>0)&&k(E)&&$(c,D));if(t>0){let n=t;typeof o=="number"&&(n=Math.min(t,o)),v.write(S(g.slice(0,n)))}}catch(c){throw(0,R.$hk)(c)}finally{await P.close(s)}}function k(P){if(P.isCancellationRequested)throw(0,M.$4)();return!0}function $(P,C){if(typeof C?.limits?.size=="number"&&P>C.limits.size)throw(0,R.$gk)((0,l.localize)(0,null),R.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(Se[84],De([1,0,34,3,15,10,2,30]),function(ne,e,y,M,l,R,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Np=e.$Mp=e.$Lp=e.$Kp=e.$Jp=e.$Ip=e.$Hp=e.$Gp=void 0;function k(c){return c.recursive===!0}e.$Gp=k;class $ extends M.$Qc{constructor(u,o,g,d){super(),this.h=u,this.j=o,this.m=g,this.n=d,this.c=this.B(new M.$Rc),this.f=void 0,this.g=0}s(){const u=new M.$Pc;this.c.value=u,this.b=this.r(u),this.b.setVerboseLogging(this.m),u.add(this.b.onDidChangeFile(o=>this.h(o))),u.add(this.b.onDidLogMessage(o=>this.j(o))),u.add(this.b.onDidError(o=>this.t(o)))}t(u){this.n.restartOnError?this.g<$.a&&this.f?(this.w(`restarting watcher after error: ${u}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${u}`):this.w(u)}u(u){this.g++,this.s(),this.watch(u)}async watch(u){this.f=u,await this.b?.watch(u)}async setVerboseLogging(u){this.m=u,await this.b?.setVerboseLogging(u)}w(u){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${u}`})}y(u){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${u}`})}dispose(){return this.b=void 0,super.dispose()}}e.$Hp=$,$.a=5;class P extends ${constructor(u,o,g){super(u,o,g,{type:"node.js",restartOnError:!1})}}e.$Ip=P;class C extends ${constructor(u,o,g){super(u,o,g,{type:"universal",restartOnError:!0})}}e.$Jp=C;function v(c){return c.map(u=>({type:u.type,resource:A.URI.file(u.path)}))}e.$Kp=v;function S(c){const u=new s;for(const o of c)u.processEvent(o);return u.coalesce()}e.$Lp=S;function D(c,u){return typeof u=="string"&&!u.startsWith(y.$oj)&&!(0,l.$gc)(u)?{base:c,pattern:u}:u}e.$Mp=D;function E(c,u){const o=[];for(const g of u)o.push((0,y.$sj)(D(c,g)));return o}e.$Np=E;class s{constructor(){this.a=new Set,this.b=new Map}c(u){return R.$f?u.path:u.path.toLowerCase()}processEvent(u){const o=this.b.get(this.c(u));let g=!1;if(o){const d=o.type,t=u.type;o.path!==u.path&&(u.type===2||u.type===1)?g=!0:d===1&&t===2?(this.b.delete(this.c(u)),this.a.delete(o)):d===2&&t===1?o.type=0:d===1&&t===0||(o.type=t)}else g=!0;g&&(this.a.add(u),this.b.set(this.c(u),u))}coalesce(){const u=[],o=[];return Array.from(this.a).filter(g=>g.type!==2?(u.push(g),!1):!0).sort((g,d)=>g.path.length-d.path.length).filter(g=>o.some(d=>(0,m.$nk)(g.path,d,!R.$f))?!1:(o.push(g.path),!0)).concat(u)}}}),define(Se[234],De([1,0,52,9,21,32,3,77,15,10,101,29,84]),function(ne,e,y,M,l,R,A,m,k,$,P,C,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2p=e.$1p=void 0;class S extends A.$Qc{constructor(s,c,u,o){super(),this.m=s,this.n=c,this.r=u,this.s=o,this.c=this.B(new M.$6g({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},g=>this.n(g))),this.f=this.B(new M.$5g(g=>this.z(g),S.b)),this.g=(0,v.$Np)(this.m.path,this.m.excludes),this.h=this.m.includes?(0,v.$Np)(this.m.path,this.m.includes):void 0,this.j=new l.$Vd,this.ready=this.t()}async t(){try{const s=await this.u(this.m);if(this.j.token.isCancellationRequested)return;const c=await C.Promises.stat(s);this.B(await this.w(s,c.isDirectory()))}catch(s){s.code!=="ENOENT"?this.D(s):this.G(s)}}async u(s){let c=s.path;try{c=await C.Promises.realpath(s.path),s.path===c&&(c=await(0,P.$Xp)(s.path)??s.path),s.path!==c&&this.G(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${s.path}, real: ${c})`)}catch{}return c}async w(s,c){if($.$e&&(0,R.$Vf)(s,"/Volumes/",!0))return this.D(`Refusing to watch ${s} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),A.$Qc.None;const u=new l.$Vd(this.j.token),o=new A.$Pc;try{const g=(0,k.$lc)(s),d=(0,y.watch)(s);o.add((0,A.$Oc)(()=>{d.removeAllListeners(),d.close()})),this.G(`Started watching: '${s}'`);const t=new Set;if(c)try{for(const r of await C.Promises.readdir(s))t.add(r)}catch(r){this.D(r)}const n=new Map;o.add((0,A.$Oc)(()=>{for(const[,r]of n)r.dispose();n.clear()})),d.on("error",(r,i)=>{this.D(`Failed to watch ${s} for changes using fs.watch() (${r}, ${i})`),this.dispose()}),d.on("change",(r,i)=>{if(u.token.isCancellationRequested)return;this.G(`[raw] ["${r}"] ${i}`);let a="";if(i&&(a=i.toString(),$.$e&&(a=(0,m.$jl)(a))),!(!a||r!=="change"&&r!=="rename"))if(c)if(r==="rename"){n.get(a)?.dispose();const h=setTimeout(async()=>{if(n.delete(a),a===g&&!await C.Promises.exists(s)){this.F("Watcher shutdown because watched path got deleted"),this.dispose();return}const p=await this.C((0,k.$hc)(s,a));if(u.token.isCancellationRequested)return;let I;p?t.has(a)?I=0:(I=1,t.add(a)):(t.delete(a),I=2),this.y({path:(0,k.$hc)(this.m.path,a),type:I})},S.a);n.set(a,(0,A.$Oc)(()=>clearTimeout(h)))}else{let h;t.has(a)?h=0:(h=1,t.add(a)),this.y({path:(0,k.$hc)(this.m.path,a),type:h})}else if(r==="rename"||a!==g){const h=setTimeout(async()=>{const p=await C.Promises.exists(s);u.token.isCancellationRequested||(p?(this.y({path:this.m.path,type:0},!0),o.add(await this.w(s,!1))):(this.y({path:this.m.path,type:2},!0),this.f.flush(),this.dispose()))},S.a);o.clear(),o.add((0,A.$Oc)(()=>clearTimeout(h)))}else this.y({path:this.m.path,type:0},!0)})}catch(g){await C.Promises.exists(s)&&!u.token.isCancellationRequested&&this.D(`Failed to watch ${s} for changes using fs.watch() (${g.toString()})`)}return(0,A.$Oc)(()=>{u.dispose(!0),o.dispose()})}y(s,c=!1){this.j.token.isCancellationRequested||(this.s&&this.G(`${s.type===1?"[ADDED]":s.type===2?"[DELETED]":"[CHANGED]"} ${s.path}`),!c&&this.g.some(u=>u(s.path))?this.s&&this.G(` >> ignored (excluded) ${s.path}`):!c&&this.h&&this.h.length>0&&!this.h.some(u=>u(s.path))?this.s&&this.G(` >> ignored (not included) ${s.path}`):this.f.work(s))}z(s){const c=(0,v.$Lp)(s);if(c.length>0){if(this.s)for(const o of c)this.G(`>> normalized ${o.type===1?"[ADDED]":o.type===2?"[DELETED]":"[CHANGED]"} ${o.path}`);this.c.work(c)?this.c.pending>0&&this.G(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${c[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.F(`started ignoring events due to too many file change events at once (incoming: ${c.length}, most recent change: ${c[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async C(s){if($.$f)return C.Promises.exists(s);try{const c=(0,k.$lc)(s);return(await C.Promises.readdir((0,k.$kc)(s))).some(o=>o===c)}catch(c){return this.G(c),!1}}setVerboseLogging(s){this.s=s}D(s){this.j.token.isCancellationRequested||this.r?.({type:"error",message:`[File Watcher (node.js)] ${s}`})}F(s){this.j.token.isCancellationRequested||this.r?.({type:"warn",message:`[File Watcher (node.js)] ${s}`})}G(s){!this.j.token.isCancellationRequested&&this.s&&this.r?.({type:"trace",message:`[File Watcher (node.js)] ${s}`})}dispose(){this.G(`stopping file watcher on ${this.m.path}`),this.j.dispose(!0),super.dispose()}}e.$1p=S,S.a=100,S.b=75;async function D(E,s,c,u,o=512){const g=await C.Promises.open(E,"r"),d=Buffer.allocUnsafe(o),t=new l.$Vd(u);let n,r=!1;const i={path:E,excludes:[],recursive:!1},a=new S(i,h=>{(async()=>{for(const{type:p}of h)if(p===0){if(r)return;r=!0;try{for(;!t.token.isCancellationRequested;){const{bytesRead:I}=await C.Promises.read(g,d,0,o,null);if(!I||t.token.isCancellationRequested)break;s(d.slice(0,I))}}catch(I){n=new Error(I),t.dispose(!0)}finally{r=!1}}})()});return await a.ready,c(),new Promise((h,p)=>{t.token.onCancellationRequested(async()=>{a.dispose();try{await C.Promises.close(g)}catch(I){n=new Error(I)}n?p(n):h()})})}e.$2p=D}),define(Se[235],De([1,0,4,34,3,10,234]),function(ne,e,y,M,l,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3p=void 0;class m extends l.$Qc{constructor(){super(...arguments),this.a=this.B(new y.$Ld),this.onDidChangeFile=this.a.event,this.b=this.B(new y.$Ld),this.onDidLogMessage=this.b.event,this.onDidError=y.Event.None,this.c=new Map,this.f=!1}async watch($){const P=this.j($),C=P.filter(S=>{const D=this.c.get(S.path);return D?!(0,M.$wj)(D.request.excludes,S.excludes)||!(0,M.$wj)(D.request.includes,S.includes):!0}),v=Array.from(this.c.values()).filter(({request:S})=>!P.find(D=>D.path===S.path&&(0,M.$wj)(D.excludes,S.excludes)&&(0,M.$wj)(D.includes,S.includes))).map(({request:S})=>S.path);C.length&&this.m(`Request to start watching: ${C.map(S=>`${S.path} (excludes: ${S.excludes.length>0?S.excludes:"<none>"}, includes: ${S.includes&&S.includes.length>0?JSON.stringify(S.includes):"<all>"})`).join(",")}`),v.length&&this.m(`Request to stop watching: ${v.join(",")}`);for(const S of v)this.h(S);for(const S of C)this.g(S)}g($){const P=new A.$1p($,v=>this.a.fire(v),v=>this.b.fire(v),this.f),C={request:$,instance:P};this.c.set($.path,C)}async stop(){for(const[$]of this.c)this.h($);this.c.clear()}h($){const P=this.c.get($);P&&(this.c.delete($),P.instance.dispose())}j($){const P=new Map;for(const C of $){const v=R.$f?C.path:C.path.toLowerCase();P.set(v,C)}return Array.from(P.values())}async setVerboseLogging($){this.f=$;for(const[,P]of this.c)P.instance.setVerboseLogging($)}m($){this.f&&this.b.fire({type:"trace",message:this.n($)})}n($,P){return P?`[File Watcher (node.js)] ${$} (path: ${P.request.path})`:`[File Watcher (node.js)] ${$}`}}e.$3p=m}),define(Se[236],De([1,0,84,235]),function(ne,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4p=void 0;class l extends y.$Ip{constructor(A,m,k){super(A,m,k),this.s()}r(A){return A.add(new M.$3p)}}e.$4p=l}),define(Se[237],De([1,0,17,81,167,84]),function(ne,e,y,M,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vp=void 0;class A extends R.$Jp{constructor(k,$,P){super(k,$,P),this.s()}r(k){const $=k.add(new l.$Up(y.$_f.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return k.add($.onDidProcessExit(({code:P,signal:C})=>this.t(`terminated by itself with code ${P}, signal: ${C}`))),M.ProxyChannel.toService((0,M.$sh)($.getChannel("watcher")))}}e.$Vp=A}),define(Se[105],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jh=void 0;class y{constructor(...l){this.a=new Map;for(const[R,A]of l)this.set(R,A)}set(l,R){const A=this.a.get(l);return this.a.set(l,R),A}has(l){return this.a.has(l)}get(l){return this.a.get(l)}}e.$Jh=y}),define(Se[238],De([1,0,9,8,3,103,229,5,105,76]),function(ne,e,y,M,l,R,A,m,k,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9p=e.$8p=void 0;const P=!1;class C extends Error{constructor(s){super("cyclic dependency between services"),this.message=s.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${s.toString()}`}}class v{constructor(s=new k.$Jh,c=!1,u,o=P){this.f=s,this.g=c,this.h=u,this.i=o,this.o=new Set,this.f.set(m.$Kh,this),this._globalGraph=o?u?._globalGraph??new A.$7p(g=>g):void 0}createChild(s){return new v(s,this.g,this,this.i)}invokeFunction(s,...c){const u=D.traceInvocation(this.i,s);let o=!1;try{return s({get:d=>{if(o)throw(0,M.$6)("service accessor is only valid during the invocation of its target method");const t=this.m(d,u);if(!t)throw new Error(`[invokeFunction] unknown service '${d}'`);return t}},...c)}finally{o=!0,u.stop()}}createInstance(s,...c){let u,o;return s instanceof R.$Ih?(u=D.traceCreation(this.i,s.ctor),o=this.j(s.ctor,s.staticArguments.concat(c),u)):(u=D.traceCreation(this.i,s),o=this.j(s,c,u)),u.stop(),o}j(s,c=[],u){const o=m._util.getServiceDependencies(s).sort((t,n)=>t.index-n.index),g=[];for(const t of o){const n=this.m(t.id,u);n||this.u(`[createInstance] ${s.name} depends on UNKNOWN service ${t.id}.`,!1),g.push(n)}const d=o.length>0?o[0].index:c.length;if(c.length!==d){console.trace(`[createInstance] First service dependency of ${s.name} at position ${d+1} conflicts with ${c.length} static arguments`);const t=d-c.length;t>0?c=c.concat(new Array(t)):c=c.slice(0,d)}return Reflect.construct(s,c.concat(g))}k(s,c){if(this.f.get(s)instanceof R.$Ih)this.f.set(s,c);else if(this.h)this.h.k(s,c);else throw new Error("illegalState - setting UNKNOWN service instance")}l(s){const c=this.f.get(s);return!c&&this.h?this.h.l(s):c}m(s,c){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(s));const u=this.l(s);return u instanceof R.$Ih?this.q(s,u,c.branch(s,!0)):(c.branch(s,!1),u)}q(s,c,u){if(this.o.has(s))throw new Error(`illegal state - RECURSIVELY instantiating service '${s}'`);this.o.add(s);try{return this.r(s,c,u)}finally{this.o.delete(s)}}r(s,c,u){const o=new A.$7p(t=>t.id.toString());let g=0;const d=[{id:s,desc:c,_trace:u}];for(;d.length;){const t=d.pop();if(o.lookupOrInsertNode(t),g++>1e3)throw new C(o);for(const n of m._util.getServiceDependencies(t.desc.ctor)){const r=this.l(n.id);if(r||this.u(`[createInstance] ${s} depends on ${n.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(n.id)),r instanceof R.$Ih){const i={id:n.id,desc:r,_trace:t._trace.branch(n.id,!0)};o.insertEdge(t,i),d.push(i)}}}for(;;){const t=o.roots();if(t.length===0){if(!o.isEmpty())throw new C(o);break}for(const{data:n}of t){if(this.l(n.id)instanceof R.$Ih){const i=this.s(n.id,n.desc.ctor,n.desc.staticArguments,n.desc.supportsDelayedInstantiation,n._trace);this.k(n.id,i)}o.removeNode(n)}}return this.l(s)}s(s,c,u=[],o,g){if(this.f.get(s)instanceof R.$Ih)return this.t(s,c,u,o,g);if(this.h)return this.h.s(s,c,u,o,g);throw new Error(`illegalState - creating UNKNOWN service instance ${c.name}`)}t(s,c,u=[],o,g){if(o){const d=new v(void 0,this.g,this,this.i);d.c=String(s);const t=new Map,n=new y.$8g(()=>{const r=d.j(c,u,g);for(const[i,a]of t){const h=r[i];if(typeof h=="function")for(const p of a)h.apply(r,p)}return t.clear(),r});return new Proxy(Object.create(null),{get(r,i){if(!n.isInitialized&&typeof i=="string"&&(i.startsWith("onDid")||i.startsWith("onWill"))){let p=t.get(i);return p||(p=new $.$Zc,t.set(i,p)),(w,f,b)=>{const L=p.push([w,f,b]);return(0,l.$Oc)(L)}}if(i in r)return r[i];const a=n.value;let h=a[i];return typeof h!="function"||(h=h.bind(a),r[i]=h),h},set(r,i,a){return n.value[i]=a,!0},getPrototypeOf(r){return c.prototype}})}else return this.j(c,u,g)}u(s,c){if(c&&console.warn(s),this.g)throw new Error(s)}}e.$8p=v;var S;(function(E){E[E.None=0]="None",E[E.Creation=1]="Creation",E[E.Invocation=2]="Invocation",E[E.Branch=3]="Branch"})(S||(S={}));class D{static traceInvocation(s,c){return s?new D(2,c.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):D.c}static traceCreation(s,c){return s?new D(1,c.name):D.c}constructor(s,c){this.type=s,this.name=c,this.g=Date.now(),this.h=[]}branch(s,c){const u=new D(3,s.toString());return this.h.push([s,c,u]),u}stop(){const s=Date.now()-this.g;D.f+=s;let c=!1;function u(g,d){const t=[],n=new Array(g+1).join("	");for(const[r,i,a]of d.h)if(i&&a){c=!0,t.push(`${n}CREATES -> ${r}`);const h=u(g+1,a);h&&t.push(h)}else t.push(`${n}uses -> ${r}`);return t.join(`
`)}const o=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${u(1,this)}`,`DONE, took ${s.toFixed(2)}ms (grand total ${D.f.toFixed(2)}ms)`];(s>2||c)&&D.all.add(o.join(`
`))}}e.$9p=D,D.all=new Set,D.c=new class extends D{constructor(){super(0,null)}stop(){}branch(){return this}},D.f=0}),define(Se[14],De([1,0,48,4,51,3,28,10,24,18,2,41,5]),function(ne,e,y,M,l,R,A,m,k,$,P,C,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=e.$$i=e.log=e.$9i=e.LogLevel=e.$8i=e.$7i=e.$6i=void 0,e.$6i=(0,v.$Lh)("logService"),e.$7i=(0,v.$Lh)("loggerService");function S(){return new Date().toISOString()}function D(w){return(0,$.$Af)(w)}e.$8i=D;var E;(function(w){w[w.Off=0]="Off",w[w.Trace=1]="Trace",w[w.Debug=2]="Debug",w[w.Info=3]="Info",w[w.Warning=4]="Warning",w[w.Error=5]="Error"})(E||(e.LogLevel=E={})),e.$9i=E.Info;function s(w,f,b){switch(f){case E.Trace:w.trace(b);break;case E.Debug:w.debug(b);break;case E.Info:w.info(b);break;case E.Warning:w.warn(b);break;case E.Error:w.error(b);break;case E.Off:break;default:throw new Error(`Invalid log level ${f}`)}}e.log=s;function c(w,f=!1){let b="";for(let L=0;L<w.length;L++){let O=w[L];if(O instanceof Error&&(O=(0,y.$wi)(O,f)),typeof O=="object")try{O=JSON.stringify(O)}catch{}b+=(L>0?" ":"")+O}return b}class u extends R.$Qc{constructor(){super(...arguments),this.b=e.$9i,this.c=this.B(new M.$Ld),this.onDidChangeLogLevel=this.c.event}setLevel(f){this.b!==f&&(this.b=f,this.c.fire(this.b))}getLevel(){return this.b}f(f){return this.b!==E.Off&&this.b<=f}}e.$$i=u;class o extends u{constructor(f){super(),this.h=f}f(f){return this.h||super.f(f)}trace(f,...b){this.f(E.Trace)&&this.g(E.Trace,c([f,...b],!0))}debug(f,...b){this.f(E.Debug)&&this.g(E.Debug,c([f,...b]))}info(f,...b){this.f(E.Info)&&this.g(E.Info,c([f,...b]))}warn(f,...b){this.f(E.Warning)&&this.g(E.Warning,c([f,...b]))}error(f,...b){if(this.f(E.Error))if(f instanceof Error){const L=Array.prototype.slice.call(arguments);L[0]=f.stack,this.g(E.Error,c(L))}else this.g(E.Error,c([f,...b]))}flush(){}}e.$_i=o;class g extends u{constructor(f=e.$9i){super(),this.setLevel(f),this.g=!m.$d}trace(f,...b){this.f(E.Trace)&&(this.g?console.log(`\x1B[90m[main ${S()}]\x1B[0m`,f,...b):console.log(`[main ${S()}]`,f,...b))}debug(f,...b){this.f(E.Debug)&&(this.g?console.log(`\x1B[90m[main ${S()}]\x1B[0m`,f,...b):console.log(`[main ${S()}]`,f,...b))}info(f,...b){this.f(E.Info)&&(this.g?console.log(`\x1B[90m[main ${S()}]\x1B[0m`,f,...b):console.log(`[main ${S()}]`,f,...b))}warn(f,...b){this.f(E.Warning)&&(this.g?console.warn(`\x1B[93m[main ${S()}]\x1B[0m`,f,...b):console.warn(`[main ${S()}]`,f,...b))}error(f,...b){this.f(E.Error)&&(this.g?console.error(`\x1B[91m[main ${S()}]\x1B[0m`,f,...b):console.error(`[main ${S()}]`,f,...b))}dispose(){}flush(){}}e.$aj=g;class d extends u{constructor(f=e.$9i,b=!0){super(),this.g=b,this.setLevel(f)}trace(f,...b){this.f(E.Trace)&&(this.g?console.log("%cTRACE","color: #888",f,...b):console.log(f,...b))}debug(f,...b){this.f(E.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",f,...b):console.log(f,...b))}info(f,...b){this.f(E.Info)&&(this.g?console.log("%c INFO","color: #33f",f,...b):console.log(f,...b))}warn(f,...b){this.f(E.Warning)&&(this.g?console.log("%c WARN","color: #993",f,...b):console.log(f,...b))}error(f,...b){this.f(E.Error)&&(this.g?console.log("%c  ERR","color: #f33",f,...b):console.error(f,...b))}dispose(){}flush(){}}e.$bj=d;class t extends u{constructor(f,b=e.$9i){super(),this.g=f,this.setLevel(b)}trace(f,...b){this.f(E.Trace)&&this.g.log(E.Trace,[this.h(f),...b])}debug(f,...b){this.f(E.Debug)&&this.g.log(E.Debug,[this.h(f),...b])}info(f,...b){this.f(E.Info)&&this.g.log(E.Info,[this.h(f),...b])}warn(f,...b){this.f(E.Warning)&&this.g.log(E.Warning,[this.h(f),...b])}error(f,...b){this.f(E.Error)&&this.g.log(E.Error,[this.h(f),...b])}h(f){return typeof f=="string"?f:(0,y.$wi)(f,this.f(E.Trace))}dispose(){}flush(){}}e.$cj=t;class n extends u{constructor(f){super(),this.g=f,f.length&&this.setLevel(f[0].getLevel())}setLevel(f){for(const b of this.g)b.setLevel(f);super.setLevel(f)}trace(f,...b){for(const L of this.g)L.trace(f,...b)}debug(f,...b){for(const L of this.g)L.debug(f,...b)}info(f,...b){for(const L of this.g)L.info(f,...b)}warn(f,...b){for(const L of this.g)L.warn(f,...b)}error(f,...b){for(const L of this.g)L.error(f,...b)}flush(){for(const f of this.g)f.flush()}dispose(){for(const f of this.g)f.dispose()}}e.$dj=n;class r extends R.$Qc{constructor(f,b,L){if(super(),this.h=f,this.j=b,this.b=new A.$yc,this.c=this.B(new M.$Ld),this.onDidChangeLoggers=this.c.event,this.f=this.B(new M.$Ld),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new M.$Ld),this.onDidChangeVisibility=this.g.event,L)for(const O of L)this.b.set(O.resource,{logger:void 0,info:O})}m(f){return(0,$.$wf)(f)?[...this.b.values()].find(b=>b.info.id===f):this.b.get(f)}getLogger(f){return this.m(f)?.logger}createLogger(f,b){const L=this.n(f),O=(0,$.$wf)(f)?f:b?.id??(0,l.$zi)(L.toString()).toString(16);let T=this.b.get(L)?.logger;const F=b?.logLevel==="always"?E.Trace:b?.logLevel;T||(T=this.s(L,F??this.getLogLevel(L)??this.h,{...b,id:O}));const U={logger:T,info:{resource:L,id:O,logLevel:F,name:b?.name,hidden:b?.hidden,extensionId:b?.extensionId,when:b?.when}};return this.registerLogger(U.info),this.b.set(L,U),T}n(f){return(0,$.$wf)(f)?(0,k.$sg)(this.j,`${f}.log`):f}setLogLevel(f,b){if(P.URI.isUri(f)){const L=f,O=b,T=this.b.get(L);T&&O!==T.info.logLevel&&(T.info.logLevel=O===this.h?void 0:O,T.logger?.setLevel(O),this.b.set(T.info.resource,T),this.f.fire([L,O]))}else{this.h=f;for(const[L,O]of this.b.entries())this.b.get(L)?.info.logLevel===void 0&&O.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(f,b){const L=this.m(f);L&&b!==!L.info.hidden&&(L.info.hidden=!b,this.b.set(L.info.resource,L),this.g.fire([L.info.resource,b]))}getLogLevel(f){let b;return f&&(b=this.b.get(f)?.info.logLevel),b??this.h}registerLogger(f){const b=this.b.get(f.resource);b?b.info.hidden!==f.hidden&&this.setVisibility(f.resource,!f.hidden):(this.b.set(f.resource,{info:f,logger:void 0}),this.c.fire({added:[f],removed:[]}))}deregisterLogger(f){const b=this.b.get(f);b&&(b.logger&&b.logger.dispose(),this.b.delete(f),this.c.fire({added:[],removed:[b.info]}))}*getRegisteredLoggers(){for(const f of this.b.values())yield f.info}getRegisteredLogger(f){return this.b.get(f)?.info}dispose(){this.b.forEach(f=>f.logger?.dispose()),this.b.clear(),super.dispose()}}e.$ej=r;class i{constructor(){this.onDidChangeLogLevel=new M.$Ld().event}setLevel(f){}getLevel(){return E.Info}trace(f,...b){}debug(f,...b){}info(f,...b){}warn(f,...b){}error(f,...b){}critical(f,...b){}dispose(){}flush(){}}e.$fj=i;class a extends i{}e.$gj=a;function h(w){if(w.verbose)return E.Trace;if(typeof w.logLevel=="string"){const f=I(w.logLevel.toLowerCase());if(f!==void 0)return f}return e.$9i}e.$hj=h;function p(w){switch(w){case E.Trace:return"trace";case E.Debug:return"debug";case E.Info:return"info";case E.Warning:return"warn";case E.Error:return"error";case E.Off:return"off"}}e.$ij=p;function I(w){switch(w){case"trace":return E.Trace;case"debug":return E.Debug;case"info":return E.Info;case"warn":return E.Warning;case"error":return E.Error;case"critical":return E.Error;case"off":return E.Off}}e.$jj=I,e.$kj=new C.$3i("logLevel",p(E.Info))}),define(Se[239],De([1,0,19,9,8,4,3,15,84,14]),function(ne,e,y,M,l,R,A,m,k,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Op=void 0;class P extends A.$Qc{constructor(v,S){super(),this.a=v,this.b=S,this.c=this.B(new R.$Ld),this.onDidChangeFile=this.c.event,this.g=this.B(new R.$Ld),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new M.$Og(0)),this.w=[],this.y=this.B(new M.$Og(0))}watch(v,S){return S.recursive||this.b?.watcher?.forceUniversal?this.n(v,S):this.z(v,S)}n(v,S){const D={path:this.H(v),excludes:S.excludes,includes:S.includes,recursive:S.recursive},E=(0,y.$Sb)(this.j,D);return this.r(),(0,A.$Oc)(()=>{E(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(v=>(0,l.$Y)(v))}s(){this.h||(this.h=this.B(this.t(S=>this.c.fire((0,k.$Kp)(S)),S=>this.G(S),this.a.getLevel()===$.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===$.LogLevel.Trace)})));const v=this.b?.watcher?.recursive?.usePolling;if(v===!0)for(const S of this.j)(0,k.$Gp)(S)&&(S.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(v))for(const S of this.j)(0,k.$Gp)(S)&&v.includes(S.path)&&(S.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(v,S){const D={path:this.H(v),excludes:S.excludes,includes:S.includes,recursive:!1},E=(0,y.$Sb)(this.w,D);return this.C(),(0,A.$Oc)(()=>{E(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(v=>(0,l.$Y)(v))}D(){return this.u||(this.u=this.B(this.F(v=>this.c.fire((0,k.$Kp)(v)),v=>this.G(v),this.a.getLevel()===$.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===$.LogLevel.Trace)}))),this.u.watch(this.w)}G(v){v.type==="error"&&this.g.fire(v.message),this.a[v.type](v.message)}H(v){return(0,m.$fc)(v.fsPath)}}e.$Op=P}),define(Se[240],De([1,0,52,372,9,28,22,4,32,3,15,10,24,99,29,197,30,233,239,48,237,236]),function(ne,e,y,M,l,R,A,m,k,$,P,C,v,S,D,E,s,c,u,o,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5p=void 0,(()=>{try{(0,M.gracefulify)(y)}catch(n){console.error(`Error enabling graceful-fs: ${(0,o.$wi)(n)}`)}})();class t extends u.$Op{constructor(r,i){super(r,i),this.onDidChangeCapabilities=m.Event.None,this.N=new R.$yc(a=>v.$jg.getComparisonKey(a)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,C.$f&&(this.J|=1024)),this.J}async stat(r){try{const{stat:i,symbolicLink:a}=await D.SymlinkSupport.stat(this.H(r));return{type:this.M(i,a),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:s.FilePermission.Locked}}catch(i){throw this.fb(i)}}async L(r){try{return await this.stat(r)}catch{return}}async readdir(r){try{const i=await D.Promises.readdir(this.H(r),{withFileTypes:!0}),a=[];return await Promise.all(i.map(async h=>{try{let p;h.isSymbolicLink()?p=(await this.stat((0,v.$sg)(r,h.name))).type:p=this.M(h),a.push([h.name,p])}catch(p){this.a.trace(p)}})),a}catch(i){throw this.fb(i)}}M(r,i){let a;return i?.dangling?a=s.FileType.Unknown:r.isFile()?a=s.FileType.File:r.isDirectory()?a=s.FileType.Directory:a=s.FileType.Unknown,i&&(a|=s.FileType.SymbolicLink),a}async O(r){const i=this.H(r);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let a;for(;a=this.N.get(r);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await a.wait();const h=new l.$Pg;return this.N.set(r,h),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,$.$Oc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.N.get(r)===h&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.N.delete(r)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),h.open()})}async readFile(r,i){let a;try{i?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(r)})`),a=await this.O(r));const h=this.H(r);return await D.Promises.readFile(h)}catch(h){throw this.fb(h)}finally{a?.dispose()}}P(r){t.I&&this.a.trace(r)}readFileStream(r,i,a){const h=(0,S.$Zd)(p=>A.$_d.concat(p.map(I=>A.$_d.wrap(I))).buffer);return(0,c.$Ep)(this,r,h,p=>p.buffer,{...i,bufferSize:256*1024},a),h}async writeFile(r,i,a){return a?.atomic!==!1&&a?.atomic?.postfix&&await this.Q(r)?this.R(r,(0,v.$sg)((0,v.$rg)(r),`${(0,v.$pg)(r)}${a.atomic.postfix}`),i,a):this.S(r,i,a)}async Q(r){try{const i=this.H(r),{symbolicLink:a}=await D.SymlinkSupport.stat(i);if(a)return!1}catch{}return!0}async R(r,i,a,h){const p=new $.$Pc;try{p.add(await this.O(r)),p.add(await this.O(i)),await this.S(i,a,h,!0);try{await this.rename(i,r,{overwrite:!0})}catch(I){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw I}}finally{p.dispose()}}async S(r,i,a,h){let p;try{const I=this.H(r);if(!a.create||!a.overwrite){if(await D.Promises.exists(I)){if(!a.overwrite)throw(0,s.$gk)((0,E.localize)(0,null),s.FileSystemProviderErrorCode.FileExists)}else if(!a.create)throw(0,s.$gk)((0,E.localize)(1,null),s.FileSystemProviderErrorCode.FileNotFound)}p=await this.open(r,{create:!0,unlock:a.unlock},h),await this.write(p,0,i,0,i.byteLength)}catch(I){throw await this.gb(r,I)}finally{typeof p=="number"&&await this.close(p)}}static configureFlushOnWrite(r){t.Y=r}async open(r,i,a){const h=this.H(r);let p;(0,s.$8j)(i)&&!a&&(p=await this.O(r));let I;try{if((0,s.$8j)(i)&&i.unlock)try{const{stat:f}=await D.SymlinkSupport.stat(h);f.mode&128||await D.Promises.chmod(h,f.mode|128)}catch(f){f.code!=="ENOENT"&&this.a.trace(f)}let w;if((0,s.$8j)(i)){if(C.$d)try{await D.Promises.truncate(h,0),w="r+"}catch(f){f.code!=="ENOENT"&&this.a.trace(f)}w||(w="w")}else w="r";I=await D.Promises.open(h,w)}catch(w){throw p?.dispose(),(0,s.$8j)(i)?await this.gb(r,w):this.fb(w)}if(this.U.set(I,0),(0,s.$8j)(i)&&this.X.set(I,r),p){const w=this.W.get(I);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${I} (${h})`),this.W.set(I,p),w&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${I} (${h})`),w.dispose())}return I}async close(r){const i=this.W.get(r);try{if(this.U.delete(r),this.X.delete(r)&&t.Y)try{await D.Promises.fdatasync(r)}catch(a){t.configureFlushOnWrite(!1),this.a.error(a)}return await D.Promises.close(r)}catch(a){throw this.fb(a)}finally{i&&(this.W.get(r)===i&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${r}`),this.W.delete(r)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${r}`),i.dispose())}}async read(r,i,a,h,p){const I=this.Z(r,i);let w=null;try{w=(await D.Promises.read(r,a,h,p,I)).bytesRead}catch(f){throw this.fb(f)}finally{this.$(r,I,w)}return w}Z(r,i){return i===this.U.get(r)?null:i}$(r,i,a){const h=this.U.get(r);typeof h=="number"&&(typeof i=="number"||(typeof a=="number"?this.U.set(r,h+a):this.U.delete(r)))}async write(r,i,a,h,p){return(0,l.$9g)(()=>this.ab(r,i,a,h,p),100,3)}async ab(r,i,a,h,p){const I=this.Z(r,i);let w=null;try{w=(await D.Promises.write(r,a,h,p,I)).bytesWritten}catch(f){throw await this.gb(this.X.get(r),f)}finally{this.$(r,I,w)}return w}async mkdir(r){try{await D.Promises.mkdir(this.H(r))}catch(i){throw this.fb(i)}}async delete(r,i){try{const a=this.H(r);if(i.recursive){let h;i?.atomic!==!1&&i.atomic.postfix&&(h=(0,P.$hc)((0,P.$kc)(a),`${(0,P.$lc)(a)}${i.atomic.postfix}`)),await D.Promises.rm(a,D.RimRafMode.MOVE,h)}else try{await D.Promises.unlink(a)}catch(h){if(h.code==="EPERM"||h.code==="EISDIR"){let p=!1;try{const{stat:I,symbolicLink:w}=await D.SymlinkSupport.stat(a);p=I.isDirectory()&&!w}catch{}if(p)await D.Promises.rmdir(a);else throw h}else throw h}}catch(a){throw this.fb(a)}}async rename(r,i,a){const h=this.H(r),p=this.H(i);if(h!==p)try{await this.bb(r,i,"move",a.overwrite),await D.Promises.rename(h,p)}catch(I){throw(I.code==="EINVAL"||I.code==="EBUSY"||I.code==="ENAMETOOLONG")&&(I=new Error((0,E.localize)(2,null,(0,P.$lc)(h),(0,P.$lc)((0,P.$kc)(p)),I.toString()))),this.fb(I)}}async copy(r,i,a){const h=this.H(r),p=this.H(i);if(h!==p)try{await this.bb(r,i,"copy",a.overwrite),await D.Promises.copy(h,p,{preserveSymlinks:!0})}catch(I){throw(I.code==="EINVAL"||I.code==="EBUSY"||I.code==="ENAMETOOLONG")&&(I=new Error((0,E.localize)(3,null,(0,P.$lc)(h),(0,P.$lc)((0,P.$kc)(p)),I.toString()))),this.fb(I)}}async bb(r,i,a,h){const p=this.H(r),I=this.H(i);let w=!1;if(!!(this.capabilities&1024)||(w=(0,k.$Uf)(p,I,!0)),w){if(a==="copy")throw(0,s.$gk)((0,E.localize)(4,null),s.FileSystemProviderErrorCode.FileExists);if(a==="move")return}const b=await this.L(r);if(!b)throw(0,s.$gk)((0,E.localize)(5,null),s.FileSystemProviderErrorCode.FileNotFound);const L=await this.L(i);if(L){if(!h)throw(0,s.$gk)((0,E.localize)(6,null),s.FileSystemProviderErrorCode.FileExists);b.type&s.FileType.File&&L.type&s.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(r,i){return this.cb(r,i,!1)}async cb(r,i,a){const h=this.H(r),p=this.H(i),I=!!(this.capabilities&1024);if((0,k.$Uf)(h,p,!I))return;const w=new $.$Pc;try{w.add(await this.O(r)),w.add(await this.O(i)),a&&await D.Promises.mkdir((0,P.$kc)(p),{recursive:!0}),await D.Promises.copyFile(h,p)}catch(f){if(f.code==="ENOENT"&&!a)return this.cb(r,i,!0);throw this.fb(f)}finally{w.dispose()}}t(r,i,a){return new g.$Vp(h=>r(h),h=>i(h),a)}F(r,i,a){return new d.$4p(h=>r(h),h=>i(h),a)}fb(r){if(r instanceof s.$fk)return r;let i=r,a;switch(r.code){case"ENOENT":a=s.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":a=s.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":a=s.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":a=s.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":a=s.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${r.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,a=s.FileSystemProviderErrorCode.Unknown;break;default:a=s.FileSystemProviderErrorCode.Unknown}return(0,s.$gk)(i,a)}async gb(r,i){let a=this.fb(i);if(r&&a.code===s.FileSystemProviderErrorCode.NoPermissions)try{const{stat:h}=await D.SymlinkSupport.stat(this.H(r));h.mode&128||(a=(0,s.$gk)(i,s.FileSystemProviderErrorCode.FileWriteLocked))}catch(h){this.a.trace(h)}return a}}e.$5p=t,t.I=!1,t.Y=!0}),define(Se[241],De([1,0,3,14]),function(ne,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vN=void 0;class l extends y.$Qc{constructor(A,m=[]){super(),this.a=new M.$dj([A,...m]),this.B(A.onDidChangeLogLevel(k=>this.setLevel(k)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(A){this.a.setLevel(A)}getLevel(){return this.a.getLevel()}trace(A,...m){this.a.trace(A,...m)}debug(A,...m){this.a.debug(A,...m)}info(A,...m){this.a.info(A,...m)}warn(A,...m){this.a.warn(A,...m)}error(A,...m){this.a.error(A,...m)}flush(){this.a.flush()}}e.$vN=l}),define(Se[242],De([1,0,30,14]),function(ne,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kN=void 0;var l;(function($){$[$.Trace=0]="Trace",$[$.Debug=1]="Debug",$[$.Info=2]="Info",$[$.Warning=3]="Warning",$[$.Error=4]="Error",$[$.Critical=5]="Critical",$[$.Off=6]="Off"})(l||(l={}));async function R($,P,C,v,S){try{const D=await new Promise((s,c)=>{ne(["@vscode/spdlog"],s,c)});D.setFlushOn(l.Trace);const E=await D.createAsyncRotatingLogger($,P,C,v);return S?E.clearFormatters():E.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),E}catch(D){console.error(D)}return null}function A($,P,C){switch(P){case M.LogLevel.Trace:$.trace(C);break;case M.LogLevel.Debug:$.debug(C);break;case M.LogLevel.Info:$.info(C);break;case M.LogLevel.Warning:$.warn(C);break;case M.LogLevel.Error:$.error(C);break;case M.LogLevel.Off:break;default:throw new Error(`Invalid log level ${P}`)}}function m($,P){switch(P){case M.LogLevel.Trace:$.setLevel(l.Trace);break;case M.LogLevel.Debug:$.setLevel(l.Debug);break;case M.LogLevel.Info:$.setLevel(l.Info);break;case M.LogLevel.Warning:$.setLevel(l.Warning);break;case M.LogLevel.Error:$.setLevel(l.Error);break;case M.LogLevel.Off:$.setLevel(l.Off);break;default:throw new Error(`Invalid log level ${P}`)}}class k extends M.$_i{constructor(P,C,v,S,D){super(),this.m=[],this.setLevel(D),this.n=this.s(P,C,v,S),this.B(this.onDidChangeLogLevel(E=>{this.r&&m(this.r,E)}))}async s(P,C,v,S){const D=v?6:1,E=30/D*y.$Bk.MB,s=await R(P,C,E,D,S);if(s){this.r=s,m(this.r,this.getLevel());for(const{level:c,message:u}of this.m)A(this.r,c,u);this.m=[]}}g(P,C){this.r?A(this.r,P,C):this.getLevel()<=P&&this.m.push({level:P,message:C})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u())}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$kN=k}),define(Se[134],De([1,0,39,198,5]),function(ne,e,y,M,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5s=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var R;(function(k){k[k.Unnecessary=1]="Unnecessary",k[k.Deprecated=2]="Deprecated"})(R||(e.MarkerTag=R={}));var A;(function(k){k[k.Hint=1]="Hint",k[k.Info=2]="Info",k[k.Warning=4]="Warning",k[k.Error=8]="Error"})(A||(e.MarkerSeverity=A={})),function(k){function $(D,E){return E-D}k.compare=$;const P=Object.create(null);P[k.Error]=(0,M.localize)(0,null),P[k.Warning]=(0,M.localize)(1,null),P[k.Info]=(0,M.localize)(2,null);function C(D){return P[D]||""}k.toString=C;function v(D){switch(D){case y.default.Error:return k.Error;case y.default.Warning:return k.Warning;case y.default.Info:return k.Info;case y.default.Ignore:return k.Hint}}k.fromSeverity=v;function S(D){switch(D){case k.Error:return y.default.Error;case k.Warning:return y.default.Warning;case k.Info:return y.default.Info;case k.Hint:return y.default.Ignore}}k.toSeverity=S}(A||(e.MarkerSeverity=A={}));var m;(function(k){const $="";function P(v){return C(v,!0)}k.makeKey=P;function C(v,S){const D=[$];return v.source?D.push(v.source.replace("\xA6","\\\xA6")):D.push($),v.code?typeof v.code=="string"?D.push(v.code.replace("\xA6","\\\xA6")):D.push(v.code.value.replace("\xA6","\\\xA6")):D.push($),v.severity!==void 0&&v.severity!==null?D.push(A.toString(v.severity)):D.push($),v.message&&S?D.push(v.message.replace("\xA6","\\\xA6")):D.push($),v.startLineNumber!==void 0&&v.startLineNumber!==null?D.push(v.startLineNumber.toString()):D.push($),v.startColumn!==void 0&&v.startColumn!==null?D.push(v.startColumn.toString()):D.push($),v.endLineNumber!==void 0&&v.endLineNumber!==null?D.push(v.endLineNumber.toString()):D.push($),v.endColumn!==void 0&&v.endColumn!==null?D.push(v.endColumn.toString()):D.push($),D.push($),D.join("\xA6")}k.makeKeyOptionalMessage=C})(m||(e.IMarkerData=m={})),e.$5s=(0,l.$Lh)("markerService")}),define(Se[243],De([1,0,4,39,5]),function(ne,e,y,M,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uu=e.$Tu=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$Su=e.Severity=void 0,e.Severity=M.default,e.$Su=(0,l.$Lh)("notificationService");var R;(function(P){P[P.DEFAULT=0]="DEFAULT",P[P.SILENT=1]="SILENT",P[P.URGENT=2]="URGENT"})(R||(e.NotificationPriority=R={}));var A;(function(P){P[P.WORKSPACE=0]="WORKSPACE",P[P.PROFILE=1]="PROFILE",P[P.APPLICATION=2]="APPLICATION"})(A||(e.NeverShowAgainScope=A={}));var m;(function(P){P[P.OFF=0]="OFF",P[P.SILENT=1]="SILENT",P[P.ERROR=2]="ERROR"})(m||(e.NotificationsFilter=m={}));class k{constructor(){this.progress=new $,this.onDidClose=y.Event.None,this.onDidChangeVisibility=y.Event.None}updateSeverity(C){}updateMessage(C){}updateActions(C){}close(){}}e.$Tu=k;class ${infinite(){}done(){}total(C){}worked(C){}}e.$Uu=$}),define(Se[135],De([1,0,16,2,5]),function(ne,e,y,M,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5T=e.$4T=e.$3T=e.$2T=e.$1T=void 0,e.$1T=(0,l.$Lh)("openerService");function R($,P){return M.URI.isUri($)?(0,y.$Ze)($.scheme,P):(0,y.$1e)($,P+":")}e.$2T=R;function A($,...P){return P.some(C=>R($,C))}e.$3T=A;function m($,P){return $.with({fragment:`${P.startLineNumber},${P.startColumn}${P.endLineNumber?`-${P.endLineNumber}${P.endColumn?`,${P.endColumn}`:""}`:""}`})}e.$4T=m;function k($){let P;const C=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec($.fragment);return C&&(P={startLineNumber:parseInt(C[1]),startColumn:C[2]?parseInt(C[2]):1,endLineNumber:C[4]?parseInt(C[4]):void 0,endColumn:C[4]?C[5]?parseInt(C[5]):1:void 0},$=$.with({fragment:""})),{selection:P,uri:$}}e.$5T=k}),define(Se[244],De([1,0,10,46]),function(ne,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let l;if(typeof y.$b.vscode<"u"&&typeof y.$b.vscode.context<"u"){const R=y.$b.vscode.context.configuration();if(R)l=R.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(l=globalThis._VSCODE_PRODUCT_JSON,M.env.VSCODE_DEV&&Object.assign(l,{nameShort:`${l.nameShort} Dev`,nameLong:`${l.nameLong} Dev`,dataFolderName:`${l.dataFolderName}-dev`,serverDataFolderName:l.serverDataFolderName?`${l.serverDataFolderName}-dev`:void 0}),!l.version){const R=globalThis._VSCODE_PACKAGE_JSON;Object.assign(l,{version:R.version})}Object.assign(l,{extensionsGallery:M.env.EXTENSIONS_GALLERY?JSON.parse(M.env.EXTENSIONS_GALLERY):l.extensionsGallery||{serviceUrl:"https://open-vsx.org/vscode/gallery",itemUrl:"https://open-vsx.org/vscode/item",resourceUrlTemplate:"https://open-vsx.org/vscode/asset/{publisher}/{name}/{version}/Microsoft.VisualStudio.Code.WebResources/{path}",controlUrl:"",recommendationsUrl:""}})}else l={nameShort:"code-server",nameLong:"code-server",applicationName:"code-server",dataFolderName:".code-server",win32MutexName:"codeserver",licenseName:"MIT",licenseUrl:"https://github.com/coder/code-server/blob/main/LICENSE",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverGreeting:[],serverLicense:[],serverLicensePrompt:"",serverApplicationName:"code-server-oss",serverDataFolderName:".vscode-server-oss",tunnelApplicationName:"code-tunnel-oss",win32DirName:"code-server",win32NameVersion:"code-server",win32RegValueName:"CodeOSS",win32AppId:"{{E34003BB-9E10-4501-8C11-BE3FAA83F23F}",win32x64AppId:"{{D77B7E06-80BA-4137-BCF4-654B95CCEBC5}",win32arm64AppId:"{{D1ACE434-89C5-48D1-88D3-E2991DF85475}",win32UserAppId:"{{C6065F05-9603-4FC4-8101-B9781A25D88E}",win32x64UserAppId:"{{CC6B787D-37A0-49E8-AE24-8559A032BE0C}",win32arm64UserAppId:"{{3AEBF0C8-F733-4AD4-BADE-FDB816D53D7B}",win32AppUserModelId:"coder.code-server",win32ShellNameShort:"c&ode-server",win32TunnelServiceMutex:"vscodeoss-tunnelservice",win32TunnelMutex:"vscodeoss-tunnel",darwinBundleIdentifier:"com.coder.code.server",linuxIconName:"com.coder.code.server",licenseFileName:"LICENSE.txt",reportIssueUrl:"https://github.com/coder/code-server/issues/new",nodejsRepository:"https://nodejs.org",urlProtocol:"code-oss",webviewContentExternalBaseUrlTemplate:"https://{{uuid}}.vscode-cdn.net/insider/ef65ac1ba57f57f2a3961bfe94aa20481caca4c6/out/vs/workbench/contrib/webview/browser/pre/",builtInExtensions:[{name:"ms-vscode.js-debug-companion",version:"1.1.2",sha256:"e034b8b41beb4e97e02c70f7175bd88abe66048374c2bd629f54bb33354bc2aa",repo:"https://github.com/microsoft/vscode-js-debug-companion",metadata:{id:"99cb0b7f-7354-4278-b8da-6cc79972169d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.js-debug",version:"1.83.1",sha256:"1452fdbab8d0d83ca5765bb66170d50b005c97ca4dcd13e154c3401d842a92d4",repo:"https://github.com/microsoft/vscode-js-debug",metadata:{id:"25629058-ddac-4e17-abba-74678e126c5d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.vscode-js-profile-table",version:"1.0.3",sha256:"b9dab017506d9e6a469a0f82b392e4cb1d7a25a4843f1db8ba396cbee209cfc5",repo:"https://github.com/microsoft/vscode-js-profile-visualizer",metadata:{id:"7e52b41b-71ad-457b-ab7e-0620f1fc4feb",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}}],enableTelemetry:!0,quality:"stable",codeServerVersion:"0.0.0",documentationUrl:"https://go.microsoft.com/fwlink/?LinkID=533484#vscode",keyboardShortcutsUrlMac:"https://go.microsoft.com/fwlink/?linkid=832143",keyboardShortcutsUrlLinux:"https://go.microsoft.com/fwlink/?linkid=832144",keyboardShortcutsUrlWin:"https://go.microsoft.com/fwlink/?linkid=832145",introductoryVideosUrl:"https://go.microsoft.com/fwlink/?linkid=832146",tipsAndTricksUrl:"https://go.microsoft.com/fwlink/?linkid=852118",newsletterSignupUrl:"https://www.research.net/r/vsc-newsletter",linkProtectionTrustedDomains:["https://open-vsx.org"],trustedExtensionAuthAccess:["vscode.git","vscode.github","github.vscode-pull-request-github","github.copilot","github.copilot-chat"],aiConfig:{ariaKey:"code-server"},version:"1.83.1",commit:"d7a2b4936af1bfd80cb96f2567af68badc2325e3",date:"2023-10-19T00:53:43.414Z"},Object.keys(l).length===0&&Object.assign(l,{version:"1.82.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=l}),define(Se[136],De([1,0,5]),function(ne,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mj=e.$lj=void 0,e.$lj=(0,y.$Lh)("productService"),e.$mj="vscode://schemas/vscode-product"});var We=this&&this.__param||function(ne,e){return function(y,M){e(y,M,ne)}};define(Se[64],De([1,0,9,21,3,5]),function(ne,e,y,M,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1u=e.$Zu=e.$Yu=e.$Xu=e.$Wu=e.ProgressLocation=e.$Vu=void 0,e.$Vu=(0,R.$Lh)("progressService");var A;(function(P){P[P.Explorer=1]="Explorer",P[P.Scm=3]="Scm",P[P.Extensions=5]="Extensions",P[P.Window=10]="Window",P[P.Notification=15]="Notification",P[P.Dialog=20]="Dialog"})(A||(e.ProgressLocation=A={})),e.$Wu=Object.freeze({total(){},worked(){},done(){}});class m{get value(){return this.a}constructor(C,v){this.c=C,this.report=v?.async?this.e.bind(this):this.d.bind(this)}d(C){this.a=C,this.c(this.a)}e(C){Promise.resolve(this.b).finally(()=>{this.a=C;const v=this.c(this.a);this.b=Promise.resolve(v).finally(()=>this.b=void 0)})}}e.$Xu=m,m.None=Object.freeze({report(){}});let k=class extends l.$Qc{constructor(C,v){super(),this.a=new y.$_g,v.withProgress(C,S=>(this.b=S,this.c&&S.report(this.c),this.a.p)),this.B((0,l.$Oc)(()=>this.a.complete()))}report(C){this.b?this.b.report(C):this.c=C}};e.$Yu=k,e.$Yu=k=Ke([We(1,e.$Vu)],k);class $ extends l.$Qc{constructor(C){super(),this.g=C,this.a=0,this.b=this.B(new l.$Pc)}start(C){this.stop();const v=++this.a,S=new M.$Vd;return this.f=setTimeout(()=>{v===this.a&&(this.c=this.g.show(!0))},C),this.b.add((0,l.$Oc)(()=>clearTimeout(this.f))),this.b.add((0,l.$Oc)(()=>S.cancel())),this.b.add((0,l.$Oc)(()=>this.c?this.c.done():void 0)),{id:v,token:S.token,stop:()=>this.h(v),isCurrent:()=>this.a===v}}stop(){this.h(this.a)}h(C){this.a===C&&this.b.clear()}}e.$Zu=$,e.$1u=(0,R.$Lh)("editorProgressService")}),define(Se[42],De([1,0,57,18]),function(ne,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0m=void 0;class l{constructor(){this.a=new Map}add(A,m){y.ok(M.$wf(A)),y.ok(M.$yf(m)),y.ok(!this.a.has(A),"There is already an extension with this id"),this.a.set(A,m)}knows(A){return this.a.has(A)}as(A){return this.a.get(A)||null}}e.$0m=new l}),define(Se[106],De([1,0,4,42]),function(ne,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$m=void 0,e.$$m={JSONContribution:"base.contributions.json"};function l(m){return m.length>0&&m.charAt(m.length-1)==="#"?m.substring(0,m.length-1):m}class R{constructor(){this.b=new y.$Ld,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(k,$){this.a[l(k)]=$,this.b.fire(k)}notifySchemaChanged(k){this.b.fire(k)}getSchemaContributions(){return{schemas:this.a}}}const A=new R;M.$0m.add(e.$$m.JSONContribution,A)}),define(Se[137],De([1,0,19,4,18,188,49,106,42]),function(ne,e,y,M,l,R,A,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rn=e.$qn=e.$pn=e.$on=e.$nn=e.$mn=e.$ln=e.$kn=e.$jn=e.$in=e.$hn=e.$gn=e.$fn=e.$en=e.$dn=e.ConfigurationScope=e.$cn=e.EditPresentationTypes=void 0;var $;(function(d){d.Multiline="multilineText",d.Singleline="singlelineText"})($||(e.EditPresentationTypes=$={})),e.$cn={Configuration:"base.contributions.configuration"};var P;(function(d){d[d.APPLICATION=1]="APPLICATION",d[d.MACHINE=2]="MACHINE",d[d.WINDOW=3]="WINDOW",d[d.RESOURCE=4]="RESOURCE",d[d.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",d[d.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(P||(e.ConfigurationScope=P={})),e.$dn={properties:{},patternProperties:{}},e.$en={properties:{},patternProperties:{}},e.$fn={properties:{},patternProperties:{}},e.$gn={properties:{},patternProperties:{}},e.$hn={properties:{},patternProperties:{}},e.$in={properties:{},patternProperties:{}},e.$jn="vscode://schemas/settings/resourceLanguage",e.$kn="vscode://schemas/settings/configurationDefaults";const C=k.$0m.as(m.$$m.JSONContribution);class v{constructor(){this.h=new Set,this.i=new M.$Ld,this.onDidSchemaChange=this.i.event,this.j=new M.$Ld,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:R.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},C.registerSchema(e.$jn,this.g),this.v()}registerConfiguration(t,n=!0){this.registerConfigurations([t],n)}registerConfigurations(t,n=!0){const r=new Set;this.n(t,n,r),C.registerSchema(e.$jn,this.g),this.i.fire(),this.j.fire({properties:r})}deregisterConfigurations(t){const n=new Set;this.o(t,n),C.registerSchema(e.$jn,this.g),this.i.fire(),this.j.fire({properties:n})}updateConfigurations({add:t,remove:n}){const r=new Set;this.o(n,r),this.n(t,!1,r),C.registerSchema(e.$jn,this.g),this.i.fire(),this.j.fire({properties:r})}registerDefaultConfigurations(t){const n=new Set;this.k(t,n),this.i.fire(),this.j.fire({properties:n,defaultsOverrides:!0})}k(t,n){const r=[];for(const{overrides:i,source:a}of t)for(const h in i)if(n.add(h),e.$mn.test(h)){const p=this.a.get(h),I=p?.valuesSources??new Map;if(a)for(const L of Object.keys(i[h]))I.set(L,a);const w={...p?.value||{},...i[h]};this.a.set(h,{source:a,value:w,valuesSources:I});const f=(0,A.$pi)(h),b={type:"object",default:w,description:R.localize(1,null,f),$ref:e.$jn,defaultDefaultValue:w,source:l.$wf(a)?void 0:a,defaultValueSource:a};r.push(...E(h)),this.d[h]=b,this.b.properties[h]=b}else{this.a.set(h,{value:i[h],source:a});const p=this.d[h];p&&(this.w(h,p),this.r(h,p))}this.m(r)}deregisterDefaultConfigurations(t){const n=new Set;this.l(t,n),this.i.fire(),this.j.fire({properties:n,defaultsOverrides:!0})}l(t,n){for(const{overrides:r,source:i}of t)for(const a in r){const h=this.a.get(a),p=l.$wf(i)?i:i?.id,I=l.$wf(h?.source)?h?.source:h?.source?.id;if(p===I)if(n.add(a),this.a.delete(a),e.$mn.test(a))delete this.d[a],delete this.b.properties[a];else{const w=this.d[a];w&&(this.w(a,w),this.r(a,w))}}this.u()}deltaConfiguration(t){let n=!1;const r=new Set;t.removedDefaults&&(this.l(t.removedDefaults,r),n=!0),t.addedDefaults&&(this.k(t.addedDefaults,r),n=!0),t.removedConfigurations&&this.o(t.removedConfigurations,r),t.addedConfigurations&&this.n(t.addedConfigurations,!1,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:n})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const n of t)this.h.add(n);this.u()}n(t,n,r){t.forEach(i=>{this.p(i,n,i.extensionInfo,i.restrictedProperties,void 0,r),this.c.push(i),this.q(i)})}o(t,n){const r=i=>{if(i.properties)for(const a in i.properties){n.add(a);const h=this.d[a];h?.policy?.name&&this.e.delete(h.policy.name),delete this.d[a],this.s(a,i.properties[a])}i.allOf?.forEach(a=>r(a))};for(const i of t){r(i);const a=this.c.indexOf(i);a!==-1&&this.c.splice(a,1)}}p(t,n=!0,r,i,a=3,h){a=l.$Ff(t.scope)?a:t.scope;const p=t.properties;if(p)for(const w in p){const f=p[w];if(n&&o(w,f)){delete p[w];continue}if(f.source=r,f.defaultDefaultValue=p[w].default,this.w(w,f),e.$mn.test(w)?f.scope=void 0:(f.scope=l.$Ff(f.scope)?a:f.scope,f.restricted=l.$Ff(f.restricted)?!!i?.includes(w):f.restricted),p[w].hasOwnProperty("included")&&!p[w].included){this.f[w]=p[w],delete p[w];continue}else this.d[w]=p[w],p[w].policy?.name&&this.e.set(p[w].policy.name,w);!p[w].deprecationMessage&&p[w].markdownDeprecationMessage&&(p[w].deprecationMessage=p[w].markdownDeprecationMessage),h.add(w)}const I=t.allOf;if(I)for(const w of I)this.p(w,n,r,i,a,h)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const n=r=>{const i=r.properties;if(i)for(const h in i)this.r(h,i[h]);r.allOf?.forEach(n)};n(t)}r(t,n){switch(e.$dn.properties[t]=n,n.scope){case 1:e.$en.properties[t]=n;break;case 2:e.$fn.properties[t]=n;break;case 6:e.$gn.properties[t]=n;break;case 3:e.$hn.properties[t]=n;break;case 4:e.$in.properties[t]=n;break;case 5:e.$in.properties[t]=n,this.g.properties[t]=n;break}}s(t,n){switch(delete e.$dn.properties[t],n.scope){case 1:delete e.$en.properties[t];break;case 2:delete e.$fn.properties[t];break;case 6:delete e.$gn.properties[t];break;case 3:delete e.$hn.properties[t];break;case 4:case 5:delete e.$in.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const n=`[${t}]`,r={type:"object",description:R.localize(2,null),errorMessage:R.localize(3,null),$ref:e.$jn};this.w(n,r),e.$dn.properties[n]=r,e.$en.properties[n]=r,e.$fn.properties[n]=r,e.$gn.properties[n]=r,e.$hn.properties[n]=r,e.$in.properties[n]=r}}v(){const t={type:"object",description:R.localize(4,null),errorMessage:R.localize(5,null),$ref:e.$jn};e.$dn.patternProperties[e.$ln]=t,e.$en.patternProperties[e.$ln]=t,e.$fn.patternProperties[e.$ln]=t,e.$gn.patternProperties[e.$ln]=t,e.$hn.patternProperties[e.$ln]=t,e.$in.patternProperties[e.$ln]=t,this.i.fire()}w(t,n){const r=this.a.get(t);let i=r?.value,a=r?.source;l.$Df(i)&&(i=n.defaultDefaultValue,a=void 0),l.$Df(i)&&(i=c(n.type)),n.default=i,n.defaultValueSource=a}}const S="\\[([^\\]]+)\\]",D=new RegExp(S,"g");e.$ln=`^(${S})+$`,e.$mn=new RegExp(e.$ln);function E(d){const t=[];if(e.$mn.test(d)){let n=D.exec(d);for(;n?.length;){const r=n[1].trim();r&&t.push(r),n=D.exec(d)}}return(0,y.$Kb)(t)}e.$nn=E;function s(d){return d.reduce((t,n)=>`${t}[${n}]`,"")}e.$on=s;function c(d){switch(Array.isArray(d)?d[0]:d){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$pn=c;const u=new v;k.$0m.add(e.$cn.Configuration,u);function o(d,t){return d.trim()?e.$mn.test(d)?R.localize(7,null,d):u.getConfigurationProperties()[d]!==void 0?R.localize(8,null,d):t.policy?.name&&u.getPolicyConfigurations().get(t.policy?.name)!==void 0?R.localize(9,null,d,t.policy?.name,u.getPolicyConfigurations().get(t.policy?.name)):null:R.localize(6,null)}e.$qn=o;function g(){const d=[],t=u.getConfigurationProperties();for(const n of Object.keys(t))d.push([n,t[n].scope]);return d.push(["launch",4]),d.push(["task",4]),d}e.$rn=g}),define(Se[245],De([1,0,19,4,158,3,28,23,18,2,49,137,42]),function(ne,e,y,M,l,R,A,m,k,$,P,C,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xn=e.$wn=e.$vn=e.$un=e.$tn=e.$sn=void 0;function S(n){return Object.isFrozen(n)?n:m.$Ym(n)}class D{constructor(r={},i=[],a=[],h){this.b=r,this.c=i,this.d=a,this.raw=h,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const r=this.raw.map(i=>{if(i instanceof D)return i;const a=new E("");return a.parseRaw(i),a.configurationModel});this.f=r.reduce((i,a)=>a===i?a:i.merge(a),r[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(r){return r?(0,P.$ni)(this.contents,r):this.contents}inspect(r,i){const a=this.rawConfiguration.getValue(r),h=i?this.rawConfiguration.getOverrideValue(r,i):void 0,p=i?this.rawConfiguration.override(i).getValue(r):a;return{value:a,override:h,merged:p}}getOverrideValue(r,i){const a=this.i(i);return a?r?(0,P.$ni)(a,r):a:void 0}getKeysForOverrideIdentifier(r){const i=[];for(const a of this.overrides)a.identifiers.includes(r)&&i.push(...a.keys);return y.$Kb(i)}getAllOverrideIdentifiers(){const r=[];for(const i of this.overrides)r.push(...i.identifiers);return y.$Kb(r)}override(r){let i=this.a.get(r);return i||(i=this.g(r),this.a.set(r,i)),i}merge(...r){const i=m.$Xm(this.contents),a=m.$Xm(this.overrides),h=[...this.keys],p=this.raw?.length?[...this.raw]:[this];for(const I of r)if(p.push(...I.raw?.length?I.raw:[I]),!I.isEmpty()){this.h(i,I.contents);for(const w of I.overrides){const[f]=a.filter(b=>y.$sb(b.identifiers,w.identifiers));f?(this.h(f.contents,w.contents),f.keys.push(...w.keys),f.keys=y.$Kb(f.keys)):a.push(m.$Xm(w))}for(const w of I.keys)h.indexOf(w)===-1&&h.push(w)}return new D(i,h,a,p.every(I=>I instanceof D)?void 0:p)}g(r){const i=this.i(r);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const a={};for(const h of y.$Kb([...Object.keys(this.contents),...Object.keys(i)])){let p=this.contents[h];const I=i[h];I&&(typeof p=="object"&&typeof I=="object"?(p=m.$Xm(p),this.h(p,I)):p=I),a[h]=p}return new D(a,this.keys,this.overrides)}h(r,i){for(const a of Object.keys(i)){if(a in r&&k.$yf(r[a])&&k.$yf(i[a])){this.h(r[a],i[a]);continue}r[a]=m.$Xm(i[a])}}i(r){let i=null,a=null;const h=p=>{p&&(a?this.h(a,p):a=m.$Xm(p))};for(const p of this.overrides)p.identifiers.length===1&&p.identifiers[0]===r?i=p.contents:p.identifiers.includes(r)&&h(p.contents);return h(i),a}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(r,i){this.j(r,i,!0)}setValue(r,i){this.j(r,i,!1)}removeValue(r){const i=this.keys.indexOf(r);i!==-1&&(this.keys.splice(i,1),(0,P.$mi)(this.contents,r),C.$mn.test(r)&&this.overrides.splice(this.overrides.findIndex(a=>y.$sb(a.identifiers,(0,C.$nn)(r))),1))}j(r,i,a){(0,P.$li)(this.contents,r,i,h=>console.error(h)),a=a||this.keys.indexOf(r)===-1,a&&this.keys.push(r),C.$mn.test(r)&&this.overrides.push({identifiers:(0,C.$nn)(r),keys:Object.keys(this.contents[r]),contents:(0,P.$ki)(this.contents[r],h=>console.error(h))})}}e.$sn=D;class E{constructor(r){this.f=r,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new D}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(r,i){if(!k.$Ff(r)){const a=this.g(r);this.parseRaw(a,i)}}reparse(r){this.a&&this.parseRaw(this.a,r)}parseRaw(r,i){this.a=r;const{contents:a,keys:h,overrides:p,restricted:I,hasExcludedProperties:w}=this.h(r,i);this.b=new D(a,h,p,w?[r]:void 0),this.c=I||[]}g(r){let i={},a=null,h=[];const p=[],I=[];function w(b){Array.isArray(h)?h.push(b):a!==null&&(h[a]=b)}const f={onObjectBegin:()=>{const b={};w(b),p.push(h),h=b,a=null},onObjectProperty:b=>{a=b},onObjectEnd:()=>{h=p.pop()},onArrayBegin:()=>{const b=[];w(b),p.push(h),h=b,a=null},onArrayEnd:()=>{h=p.pop()},onLiteralValue:w,onError:(b,L,O)=>{I.push({error:b,offset:L,length:O})}};if(r)try{l.$Um(r,f),i=h[0]||{}}catch(b){console.error(`Error while parsing settings file ${this.f}: ${b}`),this.d=[b]}return i}h(r,i){const a=v.$0m.as(C.$cn.Configuration).getConfigurationProperties(),h=this.i(r,a,!0,i);r=h.raw;const p=(0,P.$ki)(r,f=>console.error(`Conflict in settings file ${this.f}: ${f}`)),I=Object.keys(r),w=this.j(r,f=>console.error(`Conflict in settings file ${this.f}: ${f}`));return{contents:p,keys:I,overrides:w,restricted:h.restricted,hasExcludedProperties:h.hasExcludedProperties}}i(r,i,a,h){let p=!1;if(!h?.scopes&&!h?.skipRestricted&&!h?.exclude?.length)return{raw:r,restricted:[],hasExcludedProperties:p};const I={},w=[];for(const f in r)if(C.$mn.test(f)&&a){const b=this.i(r[f],i,!1,h);I[f]=b.raw,p=p||b.hasExcludedProperties,w.push(...b.restricted)}else{const b=i[f],L=b?typeof b.scope<"u"?b.scope:3:void 0;b?.restricted&&w.push(f),!h.exclude?.includes(f)&&(h.include?.includes(f)||(L===void 0||h.scopes===void 0||h.scopes.includes(L))&&!(h.skipRestricted&&b?.restricted))?I[f]=r[f]:p=!0}return{raw:I,restricted:w,hasExcludedProperties:p}}j(r,i){const a=[];for(const h of Object.keys(r))if(C.$mn.test(h)){const p={};for(const I in r[h])p[I]=r[h][I];a.push({identifiers:(0,C.$nn)(h),keys:Object.keys(p),contents:(0,P.$ki)(p,i)})}return a}}e.$tn=E;class s extends R.$Qc{constructor(r,i,a,h){super(),this.c=r,this.f=i,this.g=h,this.b=this.B(new M.$Ld),this.onDidChange=this.b.event,this.a=new E(this.c.toString()),this.B(this.g.watch(a.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(M.Event.any(M.Event.filter(this.g.onDidFilesChange,p=>p.contains(this.c)),M.Event.filter(this.g.onDidRunOperation,p=>(p.isOperation(0)||p.isOperation(3)||p.isOperation(1)||p.isOperation(4))&&a.isEqual(p.resource,r)))(()=>this.b.fire()))}async loadConfiguration(){try{const r=await this.g.readFile(this.c);return this.a.parse(r.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new D}}reparse(r){return r&&(this.f=r),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$un=s;class c{constructor(r,i,a,h,p,I,w,f,b,L,O,T,F){this.a=r,this.b=i,this.c=a,this.overrideIdentifiers=h,this.d=p,this.f=I,this.g=w,this.h=f,this.i=b,this.j=L,this.k=O,this.l=T,this.m=F}get value(){return S(this.c)}n(r,i,a){const h=r.inspect(i,a);return{get value(){return S(h.value)},get override(){return S(h.override)},get merged(){return S(h.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class u{constructor(r,i,a,h,p=new D,I=new D,w=new A.$yc,f=new D,b=new A.$yc){this.c=r,this.d=i,this.f=a,this.g=h,this.h=p,this.i=I,this.j=w,this.l=f,this.m=b,this.a=null,this.b=new A.$yc,this.n=null}getValue(r,i,a){return this.q(r,i,a).getValue(r)}updateValue(r,i,a={}){let h;a.resource?(h=this.m.get(a.resource),h||(h=new D,this.m.set(a.resource,h))):h=this.l,i===void 0?h.removeValue(r):h.setValue(r,i),a.resource||(this.a=null)}inspect(r,i,a){const h=this.q(r,i,a),p=this.u(i.resource,a),I=i.resource?this.m.get(i.resource)||this.l:this.l,w=new Set;for(const f of h.overrides)for(const b of f.identifiers)h.getOverrideValue(r,b)!==void 0&&w.add(b);return new c(r,i,h.getValue(r),w.size?[...w]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,a?this.i:void 0,p||void 0,I)}keys(r){const i=this.u(void 0,r);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:i?i.keys.slice(0):[]}}updateDefaultConfiguration(r){this.c=r,this.a=null,this.b.clear()}updatePolicyConfiguration(r){this.d=r}updateApplicationConfiguration(r){this.f=r,this.a=null,this.b.clear()}updateLocalUserConfiguration(r){this.g=r,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(r){this.h=r,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(r){this.i=r,this.a=null,this.b.clear()}updateFolderConfiguration(r,i){this.j.set(r,i),this.b.delete(r)}deleteFolderConfiguration(r){this.p.delete(r),this.b.delete(r)}compareAndUpdateDefaultConfiguration(r,i){const a=[];if(!i){const{added:h,updated:p,removed:I}=d(this.c,r);i=[...h,...p,...I]}for(const h of i)for(const p of(0,C.$nn)(h)){const I=this.c.getKeysForOverrideIdentifier(p),w=r.getKeysForOverrideIdentifier(p),f=[...w.filter(b=>I.indexOf(b)===-1),...I.filter(b=>w.indexOf(b)===-1),...I.filter(b=>!m.$2m(this.c.override(p).getValue(b),r.override(p).getValue(b)))];a.push([p,f])}return this.updateDefaultConfiguration(r),{keys:i,overrides:a}}compareAndUpdatePolicyConfiguration(r){const{added:i,updated:a,removed:h}=d(this.d,r),p=[...i,...a,...h];return p.length&&this.updatePolicyConfiguration(r),{keys:p,overrides:[]}}compareAndUpdateApplicationConfiguration(r){const{added:i,updated:a,removed:h,overrides:p}=d(this.applicationConfiguration,r),I=[...i,...a,...h];return I.length&&this.updateApplicationConfiguration(r),{keys:I,overrides:p}}compareAndUpdateLocalUserConfiguration(r){const{added:i,updated:a,removed:h,overrides:p}=d(this.localUserConfiguration,r),I=[...i,...a,...h];return I.length&&this.updateLocalUserConfiguration(r),{keys:I,overrides:p}}compareAndUpdateRemoteUserConfiguration(r){const{added:i,updated:a,removed:h,overrides:p}=d(this.remoteUserConfiguration,r),I=[...i,...a,...h];return I.length&&this.updateRemoteUserConfiguration(r),{keys:I,overrides:p}}compareAndUpdateWorkspaceConfiguration(r){const{added:i,updated:a,removed:h,overrides:p}=d(this.workspaceConfiguration,r),I=[...i,...a,...h];return I.length&&this.updateWorkspaceConfiguration(r),{keys:I,overrides:p}}compareAndUpdateFolderConfiguration(r,i){const a=this.p.get(r),{added:h,updated:p,removed:I,overrides:w}=d(a,i),f=[...h,...p,...I];return(f.length||!a)&&this.updateFolderConfiguration(r,i),{keys:f,overrides:w}}compareAndDeleteFolderConfiguration(r){const i=this.p.get(r);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:a,updated:h,removed:p,overrides:I}=d(i,void 0);return{keys:[...a,...h,...p],overrides:I}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(r,i,a){let h=this.r(i,a);return i.overrideIdentifier&&(h=h.override(i.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(r)!==void 0&&(h=h.merge(this.d)),h}r({resource:r},i){let a=this.s();if(i&&r){const h=i.getFolder(r);h&&(a=this.t(h.uri)||a);const p=this.m.get(r);p&&(a=a.merge(p))}return a}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(r){let i=this.b.get(r);if(!i){const a=this.s(),h=this.j.get(r);h?(i=a.merge(h),this.b.set(r,i)):i=a}return i}u(r,i){if(i&&r){const a=i.getFolder(r);if(a)return this.j.get(a.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((r,i)=>{const{contents:a,overrides:h,keys:p}=this.j.get(i);return r.push([i,{contents:a,overrides:h,keys:p}]),r},[])}}allKeys(){const r=new Set;return this.c.keys.forEach(i=>r.add(i)),this.userConfiguration.keys.forEach(i=>r.add(i)),this.i.keys.forEach(i=>r.add(i)),this.j.forEach(i=>i.keys.forEach(a=>r.add(a))),[...r.values()]}v(){const r=new Set;return this.c.getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.userConfiguration.getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.i.getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.j.forEach(i=>i.getAllOverrideIdentifiers().forEach(a=>r.add(a))),[...r.values()]}w(r){const i=new Set;return this.c.getKeysForOverrideIdentifier(r).forEach(a=>i.add(a)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(a=>i.add(a)),this.i.getKeysForOverrideIdentifier(r).forEach(a=>i.add(a)),this.j.forEach(a=>a.getKeysForOverrideIdentifier(r).forEach(h=>i.add(h))),[...i.values()]}static parse(r){const i=this.x(r.defaults),a=this.x(r.policy),h=this.x(r.application),p=this.x(r.user),I=this.x(r.workspace),w=r.folders.reduce((f,b)=>(f.set($.URI.revive(b[0]),this.x(b[1])),f),new A.$yc);return new u(i,a,h,p,new D,I,w,new D,new A.$yc)}static x(r){return new D(r.contents,r.keys,r.overrides)}}e.$vn=u;function o(...n){if(n.length===0)return{keys:[],overrides:[]};if(n.length===1)return n[0];const r=new Set,i=new Map;for(const h of n)h.keys.forEach(p=>r.add(p)),h.overrides.forEach(([p,I])=>{const w=(0,A.$vc)(i,p,new Set);I.forEach(f=>w.add(f))});const a=[];return i.forEach((h,p)=>a.push([p,[...h.values()]])),{keys:[...r.values()],overrides:a}}e.$wn=o;class g{constructor(r,i,a,h){this.change=r,this.f=i,this.g=a,this.h=h,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const p of r.keys)this.affectedKeys.add(p);for(const[,p]of r.overrides)for(const I of p)this.affectedKeys.add(I);this.d=this.a;for(const p of this.affectedKeys)this.d+=p+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=u.parse(this.f.data)),this.i}affectsConfiguration(r,i){const a=this.a+r,h=this.d.indexOf(a);if(h<0)return!1;const p=h+a.length;if(p>=this.d.length)return!1;const I=this.d.charCodeAt(p);if(I!==this.b&&I!==this.c)return!1;if(i){const w=this.previousConfiguration?this.previousConfiguration.getValue(r,i,this.f?.workspace):void 0,f=this.g.getValue(r,i,this.h);return!m.$2m(w,f)}return!0}}e.$xn=g;function d(n,r){const{added:i,removed:a,updated:h}=t(r?.rawConfiguration,n?.rawConfiguration),p=[],I=n?.getAllOverrideIdentifiers()||[],w=r?.getAllOverrideIdentifiers()||[];if(r){const f=w.filter(b=>!I.includes(b));for(const b of f)p.push([b,r.getKeysForOverrideIdentifier(b)])}if(n){const f=I.filter(b=>!w.includes(b));for(const b of f)p.push([b,n.getKeysForOverrideIdentifier(b)])}if(r&&n){for(const f of I)if(w.includes(f)){const b=t({contents:n.getOverrideValue(void 0,f)||{},keys:n.getKeysForOverrideIdentifier(f)},{contents:r.getOverrideValue(void 0,f)||{},keys:r.getKeysForOverrideIdentifier(f)});p.push([f,[...b.added,...b.removed,...b.updated]])}}return{added:i,removed:a,updated:h,overrides:p}}function t(n,r){const i=n?r?n.keys.filter(p=>r.keys.indexOf(p)===-1):[...n.keys]:[],a=r?n?r.keys.filter(p=>n.keys.indexOf(p)===-1):[...r.keys]:[],h=[];if(n&&r){for(const p of r.keys)if(n.keys.indexOf(p)!==-1){const I=(0,P.$ni)(r.contents,p),w=(0,P.$ni)(n.contents,p);m.$2m(I,w)||h.push(p)}}return{added:i,removed:a,updated:h}}}),define(Se[246],De([1,0,22,4,3,82]),function(ne,e,y,M,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$skb=e.$rkb=e.$qkb=e.$pkb=void 0;const A=($,P,C)=>{const v=new Uint8Array(16);for(let E=0;E<16;E++)v[E]=Math.round(Math.random()*256);const S=(0,y.$te)(y.$_d.wrap(v));return[`GET ws://localhost${$}?${P}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${S}`].join(`\r
`)+`\r
\r
`};e.$pkb=A,e.$qkb=y.$_d.fromString(`\r
\r
`);async function m($,P,C,v,S){$.write(y.$_d.fromString((0,e.$pkb)(P,C,v)));const D=new l.$Pc;try{return await new Promise((E,s)=>{let c;D.add($.onData(u=>{c?c=y.$_d.concat([c,u],c.byteLength+u.byteLength):c=u;const o=c.indexOf(e.$qkb);if(o===-1)return;E($),$.pauseData();const g=c.slice(o+e.$qkb.byteLength);g.byteLength&&S.onData.fire(g)})),D.add($.onClose(u=>s(u??new Error("socket closed")))),D.add($.onEnd(()=>s(new Error("socket ended"))))})}catch(E){throw $.dispose(),E}finally{D.dispose()}}e.$rkb=m;class k extends l.$Qc{constructor(P,C){super(),this.g=P,this.a=this.B(new M.$Od),this.onData=(...v)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...v)),this.b=this.B(new M.$Ld),this.onDidDispose=this.b.event,this.f=!1,this.B(C.onData),this.B(C.onData.event(v=>this.a.fire(v))),this.onClose=this.B(C.onClose).event,this.onEnd=this.B(C.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(P,C){R.SocketDiagnostics.traceSocketEvent(this,this.g,P,C)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$skb=k}),define(Se[65],De([1,0,8,5]),function(ne,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ok=e.$Nk=e.RemoteAuthorityResolverErrorCode=e.$Mk=e.$Lk=e.RemoteConnectionType=e.$Kk=void 0,e.$Kk=(0,M.$Lh)("remoteAuthorityResolverService");var l;(function(P){P[P.WebSocket=0]="WebSocket",P[P.Managed=1]="Managed"})(l||(e.RemoteConnectionType=l={}));class R{constructor(C){this.id=C,this.type=1}toString(){return`Managed(${this.id})`}}e.$Lk=R;class A{constructor(C,v){this.host=C,this.port=v,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Mk=A;var m;(function(P){P.Unknown="Unknown",P.NotAvailable="NotAvailable",P.TemporarilyNotAvailable="TemporarilyNotAvailable",P.NoResolverFound="NoResolverFound",P.InvalidAuthority="InvalidAuthority"})(m||(e.RemoteAuthorityResolverErrorCode=m={}));class k extends y.$_{static isNotAvailable(C){return C instanceof k&&C._code===m.NotAvailable}static isTemporarilyNotAvailable(C){return C instanceof k&&C._code===m.TemporarilyNotAvailable}static isNoResolverFound(C){return C instanceof k&&C._code===m.NoResolverFound}static isInvalidAuthority(C){return C instanceof k&&C._code===m.InvalidAuthority}static isHandled(C){return C instanceof k&&C.isHandled}constructor(C,v=m.Unknown,S){super(C),this._message=C,this._code=v,this._detail=S,this.isHandled=v===m.NotAvailable&&S===!0,Object.setPrototypeOf(this,k.prototype)}}e.$Nk=k;function $(P){const C=P.indexOf("+");return C===-1?P:P.substring(0,C)}e.$Ok=$}),define(Se[66],De([1,0,17]),function(ne,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tk=e.$Sk=e.$Rk=e.$Qk=e.$Pk=void 0;function M($){return $.scheme===y.Schemas.vscodeRemote?$.authority:void 0}e.$Pk=M;function l($){if(!$)return;const P=$.indexOf("+");return P<0?$:$.substr(0,P)}e.$Qk=l;function R($){return`/${$.quality??"oss"}-${$.commit??"dev"}`}e.$Rk=R;function A($){const{host:P,port:C}=k($);if(typeof C>"u")throw new Error("Remote authority doesn't contain a port!");return{host:P,port:C}}e.$Sk=A;function m($,P){let{host:C,port:v}=k($);return typeof v>"u"&&(v=P),{host:C,port:v}}e.$Tk=m;function k($){const P=$.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(P)return{host:P[1],port:parseInt(P[2],10)};const C=$.match(/^(\[[0-9a-z:]+\])$/);if(C)return{host:C[1],port:void 0};const v=$.match(/(.*):(\d+)$/);return v?{host:v[1],port:parseInt(v[2],10)}:{host:$,port:void 0}}}),define(Se[25],De([1,0,16,5,66]),function(ne,e,y,M,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5l=e.$4l=e.$3l=e.$2l=e.$1l=e.$Zl=e.$Yl=e.$Xl=e.TargetPlatform=e.ExtensionType=e.$Wl=e.$Vl=e.$Ul=e.$Tl=e.$Sl=e.$Rl=void 0,e.$Rl="extensions.user.cache",e.$Sl="extensions.builtin.cache",e.$Tl="undefined_publisher",e.$Ul=["ui","workspace","web"];function R(E){if(typeof E=="object"&&E!==null&&E.supported!==!0)return E.description}e.$Vl=R,e.$Wl=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(E){E[E.System=0]="System",E[E.User=1]="User"})(A||(e.ExtensionType=A={}));var m;(function(E){E.WIN32_X64="win32-x64",E.WIN32_IA32="win32-ia32",E.WIN32_ARM64="win32-arm64",E.LINUX_X64="linux-x64",E.LINUX_ARM64="linux-arm64",E.LINUX_ARMHF="linux-armhf",E.ALPINE_X64="alpine-x64",E.ALPINE_ARM64="alpine-arm64",E.DARWIN_X64="darwin-x64",E.DARWIN_ARM64="darwin-arm64",E.WEB="web",E.UNIVERSAL="universal",E.UNKNOWN="unknown",E.UNDEFINED="undefined"})(m||(e.TargetPlatform=m={}));class k{constructor(s){this.value=s,this._lower=s.toLowerCase()}static equals(s,c){if(typeof s>"u"||s===null)return typeof c>"u"||c===null;if(typeof c>"u"||c===null)return!1;if(typeof s=="string"||typeof c=="string"){const u=typeof s=="string"?s:s.value,o=typeof c=="string"?c:c.value;return y.$Ze(u,o)}return s._lower===c._lower}static toKey(s){return typeof s=="string"?s.toLowerCase():s._lower}}e.$Xl=k;class ${get size(){return this.c.size}constructor(s){if(this.c=new Set,s)for(const c of s)this.add(c)}add(s){this.c.add(k.toKey(s))}delete(s){return this.c.delete(k.toKey(s))}has(s){return this.c.has(k.toKey(s))}}e.$Yl=$;class P{constructor(){this.c=new Map}clear(){this.c.clear()}delete(s){this.c.delete(k.toKey(s))}get(s){return this.c.get(k.toKey(s))}has(s){return this.c.has(k.toKey(s))}set(s,c){this.c.set(k.toKey(s),c)}values(){return this.c.values()}forEach(s){this.c.forEach(s)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Zl=P;function C(E){return v(E)}e.$1l=C;function v(E){return E.contributes&&E.contributes.localizations?E.contributes.localizations.length>0:!1}e.$2l=v;function S(E){return E.contributes&&E.contributes.authentication?E.contributes.authentication.length>0:!1}e.$3l=S;function D(E,s){if(s){const c=`onResolveRemoteAuthority:${(0,l.$Qk)(s)}`;return!!E.activationEvents?.includes(c)}return!1}e.$4l=D,e.$5l=(0,M.$Lh)("IBuiltinExtensionsScannerService")}),define(Se[138],De([1,0,8,25]),function(ne,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ME=e.$LE=void 0;class l{constructor(){this.a=new Map,this.b=new WeakMap}register(A,m){this.a.set(A,m)}readActivationEvents(A){return this.b.has(A)||this.b.set(A,this.c(A)),this.b.get(A)}createActivationEventsMap(A){const m=Object.create(null);for(const k of A){const $=this.readActivationEvents(k);$.length>0&&(m[M.$Xl.toKey(k.identifier)]=$)}return m}c(A){if(typeof A.main>"u"&&typeof A.browser>"u")return[];const m=Array.isArray(A.activationEvents)?A.activationEvents.slice(0):[];if(!A.contributes)return m;for(const k in A.contributes){const $=this.a.get(k);if(!$)continue;const P=A.contributes[k],C=Array.isArray(P)?P:[P];try{$(C,m)}catch(v){(0,y.$Y)(v)}}return m}}e.$LE=l,e.$ME=new l}),define(Se[247],De([1,0,9,22,21,8,4,3,53,38,31,82,65,66]),function(ne,e,y,M,l,R,A,m,k,$,P,C,v,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9k=e.$8k=e.$7k=e.$6k=e.$5k=e.$4k=e.$3k=e.$2k=e.PersistentConnectionEventType=e.$1k=e.$Zk=e.$Yk=e.ConnectionType=void 0;const D=30*1e3;var E;(function(de){de[de.Management=1]="Management",de[de.ExtensionHost=2]="ExtensionHost",de[de.Tunnel=3]="Tunnel"})(E||(e.ConnectionType=E={}));function s(de){switch(de){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function c(de){const V=new l.$Vd;return setTimeout(()=>V.cancel(),de),V.token}function u(de,V){if(de.isCancellationRequested||V.isCancellationRequested)return l.CancellationToken.Cancelled;const J=new l.$Vd;return de.onCancellationRequested(()=>J.cancel()),V.onCancellationRequested(()=>J.cancel()),J.token}class o{get didTimeout(){return this.c==="timedout"}constructor(V){this.c="pending",this.d=new m.$Pc,this.promise=new Promise((J,ee)=>{this.f=J,this.g=ee}),V.isCancellationRequested?this.h():this.d.add(V.onCancellationRequested(()=>this.h()))}registerDisposable(V){this.c==="pending"?this.d.add(V):V.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const V=new Error("Time limit reached");return V.code="ETIMEDOUT",V.syscall="connect",V}resolve(V){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(V))}reject(V){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(V))}}function g(de,V){const J=new o(V);return J.registerDisposable(de.onControlMessage(ee=>{const Y=JSON.parse(ee.toString()),Z=Q(Y);Z?J.reject(Z):J.resolve(Y)})),J.promise}function d(de,V,J,ee,Y,Z,_,pe){const se=new o(pe),ge=$.$Hd.create(!1);return de.info(`Creating a socket (${_})...`),k.mark(`code/willCreateSocket/${Z}`),V.connect(J,ee,Y,_).then(ie=>{se.didTimeout?(k.mark(`code/didCreateSocketError/${Z}`),de.info(`Creating a socket (${_}) finished after ${ge.elapsed()} ms, but this is too late and has timed out already.`),ie?.dispose()):(k.mark(`code/didCreateSocketOK/${Z}`),de.info(`Creating a socket (${_}) was successful after ${ge.elapsed()} ms.`),se.resolve(ie))},ie=>{k.mark(`code/didCreateSocketError/${Z}`),de.info(`Creating a socket (${_}) returned an error after ${ge.elapsed()} ms.`),de.error(ie),se.reject(ie)}),se.promise}function t(de,V){const J=new o(V);return de.then(ee=>{J.didTimeout||J.resolve(ee)},ee=>{J.didTimeout||J.reject(ee)}),J.promise}async function n(de,V,J,ee){const Y=le(de,V);de.logService.trace(`${Y} 1/6. invoking socketFactory.connect().`);let Z;try{Z=await d(de.logService,de.remoteSocketFactoryService,de.connectTo,(0,S.$Rk)(de),`reconnectionToken=${de.reconnectionToken}&reconnection=${de.reconnectionProtocol?"true":"false"}`,s(V),`renderer-${s(V)}-${de.reconnectionToken}`,ee)}catch(ie){throw de.logService.error(`${Y} socketFactory.connect() failed or timed out. Error:`),de.logService.error(ie),ie}de.logService.trace(`${Y} 2/6. socketFactory.connect() was successful.`);let _,pe;de.reconnectionProtocol?(de.reconnectionProtocol.beginAcceptReconnection(Z,null),_=de.reconnectionProtocol,pe=!1):(_=new C.$zh({socket:Z}),pe=!0),de.logService.trace(`${Y} 3/6. sending AuthRequest control message.`);const se=await t(de.signService.createNewMessage((0,P.$bg)()),ee),ge={type:"auth",auth:de.connectionToken||"00000000000000000000",data:se.data};_.sendControl(M.$_d.fromString(JSON.stringify(ge)));try{const ie=await g(_,u(ee,c(1e4)));if(ie.type!=="sign"||typeof ie.data!="string"){const W=new Error("Unexpected handshake message");throw W.code="VSCODE_CONNECTION_ERROR",W}if(de.logService.trace(`${Y} 4/6. received SignRequest control message.`),!await t(de.signService.validate(se,ie.signedData),ee)){const W=new Error("Refused to connect to unsupported server");throw W.code="VSCODE_CONNECTION_ERROR",W}const be=await t(de.signService.sign(ie.data),ee),Ie={type:"connectionType",commit:de.commit,signedData:be,desiredConnectionType:V};return J&&(Ie.args=J),de.logService.trace(`${Y} 5/6. sending ConnectionTypeRequest control message.`),_.sendControl(M.$_d.fromString(JSON.stringify(Ie))),{protocol:_,ownsProtocol:pe}}catch(ie){throw ie&&ie.code==="ETIMEDOUT"&&(de.logService.error(`${Y} the handshake timed out. Error:`),de.logService.error(ie)),ie&&ie.code==="VSCODE_CONNECTION_ERROR"&&(de.logService.error(`${Y} received error control message when negotiating connection. Error:`),de.logService.error(ie)),pe&&X(_),ie}}async function r(de,V,J,ee){const Y=Date.now(),Z=le(de,V),{protocol:_,ownsProtocol:pe}=await n(de,V,J,ee),se=new o(ee);return se.registerDisposable(_.onControlMessage(ge=>{const ie=JSON.parse(ge.toString()),fe=Q(ie);fe?(de.logService.error(`${Z} received error control message when negotiating connection. Error:`),de.logService.error(fe),pe&&X(_),se.reject(fe)):(de.reconnectionProtocol?.endAcceptReconnection(),de.logService.trace(`${Z} 6/6. handshake finished, connection is up and running after ${ye(Y)}!`),se.resolve({protocol:_,firstMessage:ie}))})),se.promise}async function i(de,V){const{protocol:J}=await r(de,1,void 0,V);return{protocol:J}}async function a(de,V,J){const{protocol:ee,firstMessage:Y}=await r(de,2,V,J),Z=Y&&Y.debugPort;return{protocol:ee,debugPort:Z}}async function h(de,V,J){const ee=Date.now(),Y=le(de,3),{protocol:Z}=await n(de,3,V,J);return de.logService.trace(`${Y} 6/6. handshake finished, connection is up and running after ${ye(ee)}!`),Z}async function p(de,V,J){const{connectTo:ee,connectionToken:Y}=await de.addressProvider.getAddress();return{commit:de.commit,quality:de.quality,connectTo:ee,connectionToken:Y,reconnectionToken:V,reconnectionProtocol:J,remoteSocketFactoryService:de.remoteSocketFactoryService,signService:de.signService,logService:de.logService}}async function I(de,V,J){return f(de,async ee=>{const{protocol:Y}=await i(ee,l.CancellationToken.None);return new B(de,V,J,ee.reconnectionToken,Y)})}e.$Yk=I;async function w(de,V){return f(de,async J=>{const{protocol:ee,debugPort:Y}=await a(J,V,l.CancellationToken.None);return new ae(de,V,J.reconnectionToken,ee,Y)})}e.$Zk=w;async function f(de,V){for(let ee=1;;ee++)try{const Y=(0,P.$bg)(),Z=await p(de,Y,null);return await V(Z)}catch(Y){if(ee<5)de.logService.error(`[remote-connection][attempt ${ee}] An error occurred in initial connection! Will retry... Error:`),de.logService.error(Y);else throw de.logService.error(`[remote-connection][attempt ${ee}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),de.logService.error(Y),z.triggerPermanentFailure(0,0,v.$Nk.isHandled(Y)),Y}}async function b(de,V,J){const ee=await p(de,(0,P.$bg)(),null);return await h(ee,{host:V,port:J},l.CancellationToken.None)}e.$1k=b;function L(de){return(0,y.$Eg)(V=>new Promise((J,ee)=>{const Y=setTimeout(J,de*1e3);V.onCancellationRequested(()=>{clearTimeout(Y),J()})}))}var O;(function(de){de[de.ConnectionLost=0]="ConnectionLost",de[de.ReconnectionWait=1]="ReconnectionWait",de[de.ReconnectionRunning=2]="ReconnectionRunning",de[de.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",de[de.ConnectionGain=4]="ConnectionGain"})(O||(e.PersistentConnectionEventType=O={}));class T{constructor(V,J){this.reconnectionToken=V,this.millisSinceLastIncomingData=J,this.type=0}}e.$2k=T;class F{constructor(V,J,ee,Y){this.reconnectionToken=V,this.millisSinceLastIncomingData=J,this.durationSeconds=ee,this.c=Y,this.type=1}skipWait(){this.c.cancel()}}e.$3k=F;class U{constructor(V,J,ee){this.reconnectionToken=V,this.millisSinceLastIncomingData=J,this.attempt=ee,this.type=2}}e.$4k=U;class N{constructor(V,J,ee){this.reconnectionToken=V,this.millisSinceLastIncomingData=J,this.attempt=ee,this.type=4}}e.$5k=N;class j{constructor(V,J,ee,Y){this.reconnectionToken=V,this.millisSinceLastIncomingData=J,this.attempt=ee,this.handled=Y,this.type=3}}e.$6k=j;class z extends m.$Qc{static triggerPermanentFailure(V,J,ee){this._permanentFailure=!0,this.f=V,this.g=J,this.h=ee,this.j.forEach(Y=>Y.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(V=>V.y())}static debugPauseSocketWriting(){this.j.forEach(V=>V.F())}get n(){return this.c||z._permanentFailure}constructor(V,J,ee,Y,Z){super(),this.t=V,this.u=J,this.reconnectionToken=ee,this.protocol=Y,this.w=Z,this.m=this.B(new A.$Ld),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new N(this.reconnectionToken,0,0)),this.B(Y.onSocketClose(_=>{const pe=me(this.t,this.reconnectionToken,!0);_?_.type===0?(this.u.logService.info(`${pe} received socket close event (hadError: ${_.hadError}).`),_.error&&this.u.logService.error(_.error)):(this.u.logService.info(`${pe} received socket close event (wasClean: ${_.wasClean}, code: ${_.code}, reason: ${_.reason}).`),_.event&&this.u.logService.error(_.event)):this.u.logService.info(`${pe} received socket close event.`),this.y()})),this.B(Y.onSocketTimeout(_=>{const pe=me(this.t,this.reconnectionToken,!0);this.u.logService.info(`${pe} received socket timeout event (unacknowledgedMsgCount: ${_.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${_.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${_.timeSinceLastReceivedSomeData}).`),this.y()})),z.j.push(this),this.B((0,m.$Oc)(()=>{const _=z.j.indexOf(this);_>=0&&z.j.splice(_,1)})),this.n&&this.D(z.f,z.g,z.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const V=me(this.t,this.reconnectionToken,!0);this.u.logService.info(`${V} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new T(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const J=[0,5,5,10,10,10,10,10,30];let ee=-1;do{ee++;const Y=ee<J.length?J[ee]:J[J.length-1];try{if(Y>0){const _=L(Y);this.m.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Y,_)),this.u.logService.info(`${V} waiting for ${Y} seconds before reconnecting...`);try{await _}catch{}}if(this.n){this.u.logService.error(`${V} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new U(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),ee+1)),this.u.logService.info(`${V} resolving connection...`);const Z=await p(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${V} connecting to ${Z.connectTo}...`),await this.G(Z,c(D)),this.u.logService.info(`${V} reconnected!`),this.m.fire(new N(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),ee+1));break}catch(Z){if(Z.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${V} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(Z),this.C(this.protocol.getMillisSinceLastIncomingData(),ee+1,!1);break}if(ee>360){this.u.logService.error(`${V} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(Z),this.C(this.protocol.getMillisSinceLastIncomingData(),ee+1,!1);break}if(v.$Nk.isTemporarilyNotAvailable(Z)){this.u.logService.info(`${V} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(Z);continue}if((Z.code==="ETIMEDOUT"||Z.code==="ENETUNREACH"||Z.code==="ECONNREFUSED"||Z.code==="ECONNRESET")&&Z.syscall==="connect"){this.u.logService.info(`${V} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(Z);continue}if((0,R.$2)(Z)){this.u.logService.info(`${V} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(Z);continue}if(Z instanceof v.$Nk){this.u.logService.error(`${V} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(Z),this.C(this.protocol.getMillisSinceLastIncomingData(),ee+1,v.$Nk.isHandled(Z));break}this.u.logService.error(`${V} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(Z),this.C(this.protocol.getMillisSinceLastIncomingData(),ee+1,!1);break}}while(!this.n&&!this.s)}C(V,J,ee){this.w?z.triggerPermanentFailure(V,J,ee):this.D(V,J,ee)}D(V,J,ee){this.m.fire(new j(this.reconnectionToken,V,J,ee)),X(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$7k=z,z._permanentFailure=!1,z.f=0,z.g=0,z.h=!1,z.j=[];class B extends z{constructor(V,J,ee,Y,Z){super(1,V,Y,Z,!0),this.client=this.B(new C.$xh(Z,{remoteAuthority:J,clientId:ee},V.ipcLogger))}async G(V,J){await i(V,J)}}e.$8k=B;class ae extends z{constructor(V,J,ee,Y,Z){super(2,V,ee,Y,!1),this.H=J,this.debugPort=Z}async G(V,J){await a(V,this.H,J)}}e.$9k=ae;function X(de){try{de.acceptDisconnect();const V=de.getSocket();de.dispose(),V.dispose()}catch(V){(0,R.$Y)(V)}}function Q(de){if(de&&de.type==="error"){const V=new Error(`Connection error: ${de.reason}`);return V.code="VSCODE_CONNECTION_ERROR",V}return null}function H(de,V){for(;de.length<V;)de+=" ";return de}function te(de,V){return`[remote-connection][${H(s(de),13)}][${V.substr(0,5)}\u2026]`}function me(de,V,J){return`${te(de,V)}[${J?"reconnect":"initial"}]`}function le(de,V){return`${me(V,de.reconnectionToken,!!de.reconnectionProtocol)}[${de.connectTo}]`}function ye(de){return`${Date.now()-de} ms`}}),define(Se[248],De([1,0,3,5]),function(ne,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vk=e.$Uk=void 0,e.$Uk=(0,M.$Lh)("remoteSocketFactoryService");class l{constructor(){this.a={}}register(A,m){var k;return(k=this.a)[A]??(k[A]=[]),this.a[A].push(m),(0,y.$Oc)(()=>{const $=this.a[A]?.indexOf(m);typeof $=="number"&&$>=0&&this.a[A]?.splice($,1)})}b(A){return(this.a[A.type]||[]).find(k=>k.supports(A))}connect(A,m,k,$){const P=this.b(A);if(!P)throw new Error(`No socket factory found for ${A}`);return P.connect(A,m,k,$)}}e.$Vk=l}),define(Se[249],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$32b=void 0;class y{constructor(){this.b=new Map}async createNewMessage(l){try{const R=await this.c();if(R){const A=String(y.a++);return this.b.set(A,R),{id:A,data:R.createNewMessage(l)}}}catch{}return{id:"",data:l}}async validate(l,R){if(!l.id)return!0;const A=this.b.get(l.id);if(!A)return!1;this.b.delete(l.id);try{return A.validate(R)==="ok"}catch{return!1}finally{A.dispose?.()}}async sign(l){try{return await this.d(l)}catch{}return l}}e.$32b=y,y.a=1}),define(Se[107],De([1,0,5]),function(ne,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xk=e.$Wk=void 0,e.$Wk="signService",e.$Xk=(0,y.$Lh)(e.$Wk)}),define(Se[139],De([1,0,249]),function(ne,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$O7b=void 0;class M extends y.$32b{c(){return this.h().then(R=>new R.validator)}d(R){return this.h().then(A=>new A.signer().sign(R))}h(){return new Promise((R,A)=>ne(["vsda"],R,A))}}e.$O7b=M}),define(Se[250],De([1,0,10,46,31]),function(ne,e,y,M,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ao=e.$_n=void 0;function R(k){if(y.$o===2&&/^penguin(\.|$)/i.test(k))return"chromebook"}function A(k,$,P,C,v,S,D,E){const s=Object.create(null);s["common.machineId"]=S,s.sessionID=(0,l.$bg)()+Date.now(),s.commitHash=C,s.version=v,s["common.platformVersion"]=(k||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),s["common.platform"]=(0,y.$c)(y.$o),s["common.nodePlatform"]=M.$bc,s["common.nodeArch"]=P,s["common.product"]=E||"desktop",D&&(s["common.msftInternal"]=D);let c=0;const u=Date.now();Object.defineProperties(s,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-u,enumerable:!0},"common.sequence":{get:()=>c++,enumerable:!0}}),y.$g&&(s["common.snap"]="true");const o=R($);return o&&(s["common.platformDetail"]=o),s}e.$_n=A;function m(k){const $=M.env.USERDNSDOMAIN;if(!$)return!1;const P=$.toLowerCase();return k.some(C=>P===C)}e.$ao=m}),define(Se[251],De([1,0,5]),function(ne,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$gl=e.$fl=e.$el=e.$dl=e.$cl=e.$bl=e.$al=e.$_k=e.$$k=e.$0k=void 0,e.$0k=(0,y.$Lh)("telemetryService"),e.$$k=(0,y.$Lh)("customEndpointTelemetryService"),e.$_k="telemetry.currentSessionDate",e.$al="telemetry.firstSessionDate",e.$bl="telemetry.lastSessionDate",e.$cl="telemetry.machineId",e.$dl="telemetry",e.$el="telemetry.telemetryLevel",e.$fl="telemetry.enableCrashReporter",e.$gl="telemetry.enableTelemetry";var M;(function(R){R[R.NONE=0]="NONE",R[R.CRASH=1]="CRASH",R[R.ERROR=2]="ERROR",R[R.USAGE=3]="USAGE"})(M||(e.TelemetryLevel=M={}));var l;(function(R){R.OFF="off",R.CRASH="crash",R.ERROR="error",R.ON="all"})(l||(e.TelemetryConfiguration=l={}))}),define(Se[85],De([1,0,23,18,4,49,66,250,251]),function(ne,e,y,M,l,R,A,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qo=e.$po=e.$oo=e.$no=e.$mo=e.$lo=e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.$co=e.$bo=void 0;class ${constructor(a){this.value=a,this.isTrustedTelemetryValue=!0}}e.$bo=$;class P{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$co=P,e.$do=new P;class C{async publicLog(a,h,p){}async publicLogError(a,h,p){}}e.$eo=C,e.$fo="telemetry",e.$go="extensionTelemetryLog",e.$ho={log:()=>null,flush:()=>Promise.resolve(null)};function v(i,a){return l.Event.debounce(a.onDidChangeConfiguration,(p,I)=>{const w=p?new Set([...p.affectedKeys,...I.affectedKeys]):I.affectedKeys;return{...I,affectedKeys:w}},1e3,!0)(p=>{p.source!==7&&i.publicLog2("updateConfiguration",{configurationSource:(0,R.$ii)(p.source),configurationKeys:Array.from(p.affectedKeys)})})}e.$io=v;function S(i,a){return!a.isBuilt&&!a.disableTelemetry?!0:!(a.disableTelemetry||!i.enableTelemetry)}e.$jo=S;function D(i,a){return a.extensionTestsLocationURI?!0:!(a.isBuilt||a.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}e.$ko=D;function E(i){const a=i.getValue(k.$el),h=i.getValue(k.$fl);if(i.getValue(k.$gl)===!1||h===!1)return 0;switch(a??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$lo=E;function s(i){const a={},h={},p={};o(i,p);for(let I in p){I=I.length>150?I.substr(I.length-149):I;const w=p[I];typeof w=="number"?h[I]=w:typeof w=="boolean"?h[I]=w?1:0:typeof w=="string"?(w.length>8192&&console.warn(`Telemetry property: ${I} has been trimmed to 8192, the original length is ${w.length}`),a[I]=w.substring(0,8191)):typeof w<"u"&&w!==null&&(a[I]=w)}return{properties:a,measurements:h}}e.$mo=s;const c=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function u(i){if(!i)return"none";const a=(0,A.$Qk)(i);return c.has(a)?a:"other"}e.$no=u;function o(i,a,h=0,p){if(i)for(const I of Object.getOwnPropertyNames(i)){const w=i[I],f=p?p+I:I;Array.isArray(w)?a[f]=(0,y.$3m)(w):w instanceof Date?a[f]=w.toISOString():(0,M.$yf)(w)?h<2?o(w,a,h+1,f+"."):a[f]=(0,y.$3m)(w):a[f]=w}}function g(i,a){const h=i.msftInternalDomains||[],p=a.getValue("telemetry.internalTesting");return(0,m.$ao)(h)||p}e.$oo=g;function d(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}e.$po=d;function t(i,a){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let h=i;const p=[];for(const b of a)for(;;){const L=b.exec(i);if(!L)break;p.push([L.index,b.lastIndex])}const I=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,w=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let f=0;for(h="";;){const b=w.exec(i);if(!b)break;const L=p.some(([O,T])=>b.index<T&&O<w.lastIndex);!I.test(b[0])&&!L&&(h+=i.substring(f,b.index)+"<REDACTED: user-file-path>",f=w.lastIndex)}return f<i.length&&(h+=i.substr(f)),h}function n(i){if(!i)return i;const a=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const h of a)if(h.regex.test(i))return`<REDACTED: ${h.label}>`;return i}function r(i,a){return(0,y.$Zm)(i,h=>{if(h instanceof $||Object.hasOwnProperty.call(h,"isTrustedTelemetryValue"))return h.value;if(typeof h=="string"){let p=h.replaceAll("%20"," ");p=t(p,a);for(const I of a)p=p.replace(I,"");return p=n(p),p}})}e.$qo=r}),define(Se[252],De([1,0,16,133,25,10,2,8,46,85]),function(ne,e,y,M,l,R,A,m,k,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=void 0;function P(r,i){return r.uuid&&i.uuid?r.uuid===i.uuid:r.id===i.id?!0:(0,y.$Ue)(r.id,i.id)===0}e.$ro=P;const C=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class v{static create(i){const a=i.manifest?i.manifest.version:i.version,h=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new v(i.identifier,a,h)}static parse(i){const a=C.exec(i);return a&&a[1]&&a[2]?new v({id:a[1]},a[2],a[4]||void 0):null}constructor(i,a,h="undefined"){this.version=a,this.targetPlatform=h,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof v?P(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.$so=v;const S=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function D(r){const i=S.exec(r);return i&&i[1]?[s(i[1]),i[2]]:[s(r),void 0]}e.$to=D;function E(r,i){return`${r}.${i}`}e.$uo=E;function s(r){return r.toLowerCase()}e.$vo=s;function c(r,i){return s(E(r??l.$Tl,i))}e.$wo=c;function u(r,i){const a=[],h=p=>{for(const I of a)if(I.some(w=>P(i(w),i(p))))return I;return null};for(const p of r){const I=h(p);I?I.push(p):a.push([p])}return a}e.$xo=u;function o(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}e.$yo=o;function g(r){return{id:new $.$bo(r.identifier.id),name:new $.$bo(r.name),galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),isSigned:r.isSigned,...r.telemetryData}}e.$zo=g,e.$Ao=new l.$Xl("pprice.better-merge");function d(r,i){const a=[],h=i.manifest.extensionDependencies?.slice(0)??[];for(;h.length;){const p=h.shift();if(p&&a.every(I=>!P(I.identifier,{id:p}))){const I=r.filter(w=>P(w.identifier,{id:p}));I.length===1&&(a.push(I[0]),h.push(...I[0].manifest.extensionDependencies?.slice(0)??[]))}}return a}e.$Bo=d;async function t(r,i){if(!R.$f)return!1;let a;try{a=(await r.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{a=(await r.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(p){i.debug("Error while getting the os-release file.",(0,m.$8)(p))}}return!!a&&(a.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function n(r,i){const a=await t(r,i),h=(0,M.$Wn)(a?"alpine":R.$o,k.$cc);return i.debug("ComputeTargetPlatform:",h),h}e.$Co=n}),define(Se[253],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hr=e.$gr=e.$fr=e.$er=e.$dr=e.$cr=void 0;function y(k){return[...k.entries()]}e.$cr=y;function M(k){return k?[...k.entries()]:[]}e.$dr=M;function l(k){return new Map(k)}e.$er=l;function R(k){return new Map(k??[])}e.$fr=R;function A(k){return Array.from(k.entries()).map($=>[$[0],y($[1].map),M($[1].descriptionMap)])}e.$gr=A;function m(k){return new Map(k.map($=>[$[0],{map:l($[1]),descriptionMap:R($[2])}]))}e.$hr=m}),define(Se[254],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ikb=void 0;class y{constructor(l){this.b=l,this.a=new Map}dispose(){for(const l of this.a.values())l.dispose()}startBuffering(l,R,A=5){const m=R(k=>{const $=typeof k=="string"?k:k.data;let P=this.a.get(l);if(P){P.data.push($);return}const C=setTimeout(()=>this.flushBuffer(l),A);P={data:[$],timeoutId:C,dispose:()=>{clearTimeout(C),this.flushBuffer(l),m.dispose()}},this.a.set(l,P)});return m}stopBuffering(l){this.a.get(l)?.dispose()}flushBuffer(l){const R=this.a.get(l);R&&(this.a.delete(l),this.b(l,R.data.join("")))}}e.$Ikb=y}),define(Se[255],De([1,0,9,79,59,4,18,2,199,106,42]),function(ne,e,y,M,l,R,A,m,k,$,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5v=e.$4v=e.$3v=e.$2v=e.$1v=e.$Zv=e.$Yv=e.$Xv=e.IconFontDefinition=e.IconContribution=e.$Wv=void 0,e.$Wv={IconContribution:"base.contributions.icons"};var C;(function(g){function d(t,n){let r=t.defaults;for(;l.ThemeIcon.isThemeIcon(r);){const i=D.getIcon(r.id);if(!i)return;r=i.defaults}return r}g.getDefinition=d})(C||(e.IconContribution=C={}));var v;(function(g){function d(n){return{weight:n.weight,style:n.style,src:n.src.map(r=>({format:r.format,location:r.location.toString()}))}}g.toJSONObject=d;function t(n){const r=i=>(0,A.$wf)(i)?i:void 0;if(n&&Array.isArray(n.src)&&n.src.every(i=>(0,A.$wf)(i.format)&&(0,A.$wf)(i.location)))return{weight:r(n.weight),style:r(n.style),src:n.src.map(i=>({format:i.format,location:m.URI.parse(i.location)}))}}g.fromJSONObject=t})(v||(e.IconFontDefinition=v={}));class S{constructor(){this.a=new R.$Ld,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,k.localize)(0,null)},fontCharacter:{type:"string",description:(0,k.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${l.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(d,t,n,r){const i=this.b[d];if(i){if(n&&!i.description){i.description=n,this.d.properties[d].markdownDescription=`${n} $(${d})`;const p=this.e.enum.indexOf(d);p!==-1&&(this.e.enumDescriptions[p]=n),this.a.fire()}return i}const a={id:d,description:n,defaults:t,deprecationMessage:r};this.b[d]=a;const h={$ref:"#/definitions/icons"};return r&&(h.deprecationMessage=r),n&&(h.markdownDescription=`${n}: $(${d})`),this.d.properties[d]=h,this.e.enum.push(d),this.e.enumDescriptions.push(n||""),this.a.fire(),{id:d}}deregisterIcon(d){delete this.b[d],delete this.d.properties[d];const t=this.e.enum.indexOf(d);t!==-1&&(this.e.enum.splice(t,1),this.e.enumDescriptions.splice(t,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(d=>this.b[d])}getIcon(d){return this.b[d]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(d,t){const n=this.f[d];return n||(this.f[d]=t,this.a.fire(),t)}deregisterIconFont(d){delete this.f[d]}getIconFont(d){return this.f[d]}toString(){const d=(i,a)=>i.id.localeCompare(a.id),t=i=>{for(;l.ThemeIcon.isThemeIcon(i.defaults);)i=this.b[i.defaults.id];return`codicon codicon-${i?i.id:""}`},n=[];n.push("| preview     | identifier                        | default codicon ID                | description"),n.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const r=Object.keys(this.b).map(i=>this.b[i]);for(const i of r.filter(a=>!!a.description).sort(d))n.push(`|<i class="${t(i)}"></i>|${i.id}|${l.ThemeIcon.isThemeIcon(i.defaults)?i.defaults.id:i.id}|${i.description||""}|`);n.push("| preview     | identifier                        "),n.push("| ----------- | --------------------------------- |");for(const i of r.filter(a=>!l.ThemeIcon.isThemeIcon(a.defaults)).sort(d))n.push(`|<i class="${t(i)}"></i>|${i.id}|`);return n.join(`
`)}}const D=new S;P.$0m.add(e.$Wv.IconContribution,D);function E(g,d,t,n){return D.registerIcon(g,d,t,n)}e.$Xv=E;function s(){return D}e.$Yv=s;function c(){const g=(0,M.$Oj)();for(const d in g){const t="\\"+g[d].toString(16);D.registerIcon(d,{fontCharacter:t})}}c(),e.$Zv="vscode://schemas/icons";const u=P.$0m.as($.$$m.JSONContribution);u.registerSchema(e.$Zv,D.getIconSchema());const o=new y.$3g(()=>u.notifySchemaChanged(e.$Zv),200);D.onDidChange(()=>{o.isScheduled()||o.schedule()}),e.$1v=E("widget-close",M.$Qj.close,(0,k.localize)(2,null)),e.$2v=E("goto-previous-location",M.$Qj.arrowUp,(0,k.localize)(3,null)),e.$3v=E("goto-next-location",M.$Qj.arrowDown,(0,k.localize)(4,null)),e.$4v=l.ThemeIcon.modify(M.$Qj.sync,"spin"),e.$5v=l.ThemeIcon.modify(M.$Qj.loading,"spin")}),define(Se[86],De([1,0,4,49,5,14]),function(ne,e,y,M,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_u=e.$$u=e.$0u=e.$9u=e.$8u=e.$7u=e.$6u=e.$5u=e.ProvidedOnAutoForward=e.$4u=e.TunnelPrivacyId=e.TunnelProtocol=e.$3u=e.$2u=void 0,e.$2u=(0,l.$Lh)("tunnelService"),e.$3u=(0,l.$Lh)("sharedTunnelsService");var A;(function(s){s.Http="http",s.Https="https"})(A||(e.TunnelProtocol=A={}));var m;(function(s){s.ConstantPrivate="constantPrivate",s.Private="private",s.Public="public"})(m||(e.TunnelPrivacyId=m={}));function k(s){return!!s.forwardPort}e.$4u=k;var $;(function(s){s[s.Notify=1]="Notify",s[s.OpenBrowser=2]="OpenBrowser",s[s.OpenPreview=3]="OpenPreview",s[s.Silent=4]="Silent",s[s.Ignore=5]="Ignore",s[s.OpenBrowserOnce=6]="OpenBrowserOnce"})($||(e.ProvidedOnAutoForward=$={}));function P(s){if(s.scheme!=="http"&&s.scheme!=="https")return;const c=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(s.authority);if(c)return{address:c[1],port:+c[2]}}e.$5u=P,e.$6u=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function C(s){return e.$6u.indexOf(s)>=0}e.$7u=C,e.$8u=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function v(s){return e.$8u.indexOf(s)>=0}e.$9u=v;function S(s,c,u,o){if(u===1)return!1;if(u===2&&v(c)){const g=/(\d+)\.(\d+)\.(\d+)/g.exec(o);if(g?.length===4&&parseInt(g[1])>=18)return!1}return s<1024}e.$0u=S;class D{constructor(c,u,o){this.remoteAddress=c,this.localAddress=u,this.b=o,this.a=new y.$Ld,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$$u=D;let E=class{constructor(c,u){this.j=c,this.k=u,this.a=new y.$Ld,this.onTunnelOpened=this.a.event,this.b=new y.$Ld,this.onTunnelClosed=this.b.event,this.c=new y.$Ld,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=[],this.i=new Set}get hasTunnelProvider(){return!!this.f}get l(){const c=this.k.getValue("remote.localPortHost");return!c||c==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(c){return this.f=c,c?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.h=[]}}):(this.g=!1,this.h=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(c){this.g=c.elevation,this.h=c.privacyOptions}get canElevate(){return this.g}get canChangePrivacy(){return this.h.length>0}get privacyOptions(){return this.h}get tunnels(){return this.m()}async m(){const c=[],u=Array.from(this.e.values());for(const o of u){const g=Array.from(o.values());for(const d of g){const t=await d.value;t&&typeof t!="string"&&c.push(t)}}return c}async dispose(){for(const c of this.e.values()){for(const{value:u}of c.values())await u.then(o=>typeof o!="string"?o?.dispose():void 0);c.clear()}this.e.clear()}setEnvironmentTunnel(c,u,o,g,d){this.p(c,u,Promise.resolve({tunnelRemoteHost:c,tunnelRemotePort:u,localAddress:o,privacy:g,protocol:d,dispose:()=>Promise.resolve()}))}async getExistingTunnel(c,u){(v(c)||C(c))&&(c=e.$6u[0]);const o=this.r(c,u);if(o)return++o.refcount,o.value}openTunnel(c,u,o,g,d,t=!1,n,r){this.j.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${u}:${o} on local port ${d}.`);const i=this.f??c;if(!i)return;if(u||(u="localhost"),g||(g=this.l),this.f&&this.i.has(o)){this.j.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const a=this.s(i,u,o,g,d,t,n,r);return a?a.then(h=>{if(h){if(typeof h=="string")return this.j.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.q(u,o),h}else{this.j.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.q(u,o);return}this.j.trace("ForwardedPorts: (TunnelService) New tunnel established.");const p=this.n(h);return(h.tunnelRemoteHost!==u||h.tunnelRemotePort!==o)&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),n&&h.privacy!==n&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(p),p}):(this.j.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),a)}n(c){return{tunnelRemotePort:c.tunnelRemotePort,tunnelRemoteHost:c.tunnelRemoteHost,tunnelLocalPort:c.tunnelLocalPort,localAddress:c.localAddress,privacy:c.privacy,protocol:c.protocol,dispose:async()=>{this.j.trace(`ForwardedPorts: (TunnelService) dispose request for ${c.tunnelRemoteHost}:${c.tunnelRemotePort} `);const u=this.e.get(c.tunnelRemoteHost);if(u){const o=u.get(c.tunnelRemotePort);o&&(o.refcount--,await this.o(c.tunnelRemoteHost,c.tunnelRemotePort,o))}}}}async o(c,u,o){if(o.refcount<=0){this.j.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${c}:${u}.`);const g=o.value.then(async d=>{d&&typeof d!="string"&&(await d.dispose(!0),this.b.fire({host:d.tunnelRemoteHost,port:d.tunnelRemotePort}))});return this.e.has(c)&&this.e.get(c).delete(u),g}}async closeTunnel(c,u){this.j.trace(`ForwardedPorts: (TunnelService) close request for ${c}:${u} `);const o=this.e.get(c);if(o&&o.has(u)){const g=o.get(u);g.refcount=0,await this.o(c,u,g)}}p(c,u,o){this.e.has(c)||this.e.set(c,new Map),this.e.get(c).set(u,{refcount:1,value:o})}async q(c,u){const o=this.e.get(c);if(o){const g=o.get(u),d=g?await g.value:void 0;(!d||typeof d=="string")&&o.delete(u),o.size===0&&this.e.delete(c)}}r(c,u){const o=[c];C(c)?(o.push(...e.$6u),o.push(...e.$8u)):v(c)&&o.push(...e.$8u);const g=o.map(d=>this.e.get(d));for(const d of g){const t=d?.get(u);if(t)return t}}canTunnel(c){return!!P(c)}t(c,u,o,g,d,t,n){this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${u}:${o} on local port ${g}.`);const r=o;this.i.add(r);const i=g===void 0?o:g,a={elevationRequired:d?this.isPortPrivileged(i):!1},h={remoteAddress:{host:u,port:o},localAddressPort:g,privacy:t,public:t?t!==m.Private:void 0,protocol:n},p=c.forwardPort(h,a);return p?(this.p(u,o,p),p.finally(()=>{this.j.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.i.delete(r)})):this.i.delete(r),p}};e.$_u=E,e.$_u=E=Ke([We(0,R.$6i),We(1,M.$fi)],E)}),define(Se[256],De([1,0,5]),function(ne,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dk=void 0,e.$Dk=(0,y.$Lh)("IUriIdentityService")}),define(Se[257],De([1,0,5]),function(ne,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$av=void 0,e.$av=(0,y.$Lh)("editSessionIdentityService");var M;(function(l){l[l.Complete=100]="Complete",l[l.Partial=50]="Partial",l[l.None=0]="None"})(M||(e.EditSessionIdentityMatch=M={}))}),define(Se[258],De([1,0,17]),function(ne,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JJ=e.$IJ=e.$HJ=e.$GJ=e.$FJ=void 0;function M(k){return k.scheme!==y.Schemas.file&&k.scheme!==y.Schemas.vscodeRemote}e.$FJ=M;function l(k){if(k.folders.length)return k.folders.every($=>M($.uri))?k.folders[0].uri:void 0;if(k.configuration&&M(k.configuration))return k.configuration}e.$GJ=l;function R(k){return l(k)?.scheme}e.$HJ=R;function A(k){return l(k)?.authority}e.$IJ=A;function m(k){return l(k)!==void 0}e.$JJ=m}),define(Se[43],De([1,0,201,15,78,24,2,5,17]),function(ne,e,y,M,l,R,A,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ei=e.$di=e.$ci=e.$bi=e.$ai=e.$_h=e.$$h=e.$0h=e.$9h=e.$8h=e.$7h=e.$6h=e.$5h=e.$4h=e.$3h=e.WorkbenchState=e.$2h=e.$1h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=void 0,e.$Uh=(0,m.$Lh)("contextService");function $(i){const a=i;return typeof a?.id=="string"&&A.URI.isUri(a.uri)}e.$Vh=$;function P(i){return typeof i?.id=="string"&&!$(i)&&!v(i)}e.$Wh=P,e.$Xh={id:"ext-dev"},e.$Yh={id:"empty-window"};function C(i,a){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,M.$lc)(i)}:a?e.$Xh:e.$Yh;const h=i;return h.configuration?{id:h.id,configPath:h.configuration}:h.folders.length===1?{id:h.id,uri:h.folders[0].uri}:{id:h.id}}e.$Zh=C;function v(i){const a=i;return typeof a?.id=="string"&&A.URI.isUri(a.configPath)}e.$1h=v;function S(i){const a=i;if(a?.uri)return{id:a.id,uri:A.URI.revive(a.uri)};const h=i;if(h?.configPath)return{id:h.id,configPath:A.URI.revive(h.configPath)};if(i?.id)return{id:i.id}}e.$2h=S;var D;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(D||(e.WorkbenchState=D={}));function E(i){const a=i;return!!(a&&typeof a=="object"&&typeof a.id=="string"&&Array.isArray(a.folders))}e.$3h=E;function s(i){const a=i;return!!(a&&typeof a=="object"&&A.URI.isUri(a.uri)&&typeof a.name=="string"&&typeof a.toResource=="function")}e.$4h=s;class c{constructor(a,h,p,I,w){this.h=a,this.j=p,this.k=I,this.l=w,this.c=l.$Rh.forUris(this.l,()=>!0),this.folders=h}update(a){this.h=a.id,this.k=a.configuration,this.j=a.transient,this.l=a.l,this.folders=a.folders}get folders(){return this.g}set folders(a){this.g=a,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(a){this.k=a}getFolder(a){return a&&this.c.findSubstr(a)||null}n(){this.c=l.$Rh.forUris(this.l,()=>!0);for(const a of this.folders)this.c.set(a.uri,a)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$5h=c;class u{constructor(a,h){this.raw=h,this.uri=a.uri,this.index=a.index,this.name=a.name}toResource(a){return(0,R.$sg)(this.uri,a)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$6h=u;function o(i){return new u({uri:i,index:0,name:(0,R.$og)(i)},{uri:i.toString()})}e.$7h=o,e.$8h="code-workspace",e.$9h=`.${e.$8h}`,e.$0h=[{name:(0,y.localize)(0,null),extensions:[e.$8h]}],e.$$h="workspace.json";function g(i,a){return R.$jg.isEqualOrParent(i,a.untitledWorkspacesHome)}e.$_h=g;function d(i){let a;return A.URI.isUri(i)?a=i:a=i.configuration,a?.scheme===k.Schemas.tmp}e.$ai=d,e.$bi="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(i){return i.id===e.$bi}e.$ci=t;function n(i,a){return!g(i,a)&&!d(i)}e.$di=n;function r(i){return(typeof i=="string"?(0,M.$mc)(i):(0,R.$qg)(i))===e.$9h}e.$ei=r}),define(Se[259],De([1,0,51,4,3,24,2,200,132,30,5,14,43,28,256,9,31,16,18]),function(ne,e,y,M,l,R,A,m,k,$,P,C,v,S,D,E,s,c,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jk=e.$Ik=e.$Hk=e.$Gk=e.$Fk=e.$Ek=e.ProfileResourceType=void 0;var o;(function(i){i.Settings="settings",i.Keybindings="keybindings",i.Snippets="snippets",i.Tasks="tasks",i.Extensions="extensions",i.GlobalState="globalState"})(o||(e.ProfileResourceType=o={}));function g(i){const a=i;return!!(a&&typeof a=="object"&&typeof a.id=="string"&&typeof a.isDefault=="boolean"&&typeof a.name=="string"&&A.URI.isUri(a.location)&&A.URI.isUri(a.globalStorageHome)&&A.URI.isUri(a.settingsResource)&&A.URI.isUri(a.keybindingsResource)&&A.URI.isUri(a.tasksResource)&&A.URI.isUri(a.snippetsHome)&&A.URI.isUri(a.extensionsResource))}e.$Ek=g,e.$Fk=(0,P.$Lh)("IUserDataProfilesService");function d(i,a){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,icon:i.icon,location:A.URI.revive(i.location).with({scheme:a}),globalStorageHome:A.URI.revive(i.globalStorageHome).with({scheme:a}),settingsResource:A.URI.revive(i.settingsResource).with({scheme:a}),keybindingsResource:A.URI.revive(i.keybindingsResource).with({scheme:a}),tasksResource:A.URI.revive(i.tasksResource).with({scheme:a}),snippetsHome:A.URI.revive(i.snippetsHome).with({scheme:a}),extensionsResource:A.URI.revive(i.extensionsResource).with({scheme:a}),cacheHome:A.URI.revive(i.cacheHome).with({scheme:a}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}e.$Gk=d;function t(i,a,h,p,I,w){return{id:i,name:a,location:h,isDefault:!1,shortName:I?.shortName,icon:I?.icon,globalStorageHome:w&&I?.useDefaultFlags?.globalState?w.globalStorageHome:(0,R.$sg)(h,"globalStorage"),settingsResource:w&&I?.useDefaultFlags?.settings?w.settingsResource:(0,R.$sg)(h,"settings.json"),keybindingsResource:w&&I?.useDefaultFlags?.keybindings?w.keybindingsResource:(0,R.$sg)(h,"keybindings.json"),tasksResource:w&&I?.useDefaultFlags?.tasks?w.tasksResource:(0,R.$sg)(h,"tasks.json"),snippetsHome:w&&I?.useDefaultFlags?.snippets?w.snippetsHome:(0,R.$sg)(h,"snippets"),extensionsResource:w&&I?.useDefaultFlags?.extensions?w.extensionsResource:(0,R.$sg)(h,"extensions.json"),cacheHome:(0,R.$sg)(p,i),useDefaultFlags:I?.useDefaultFlags,isTransient:I?.transient}}e.$Hk=t;let n=class extends l.$Qc{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(a,h,p,I){super(),this.t=a,this.u=h,this.w=p,this.y=I,this.f=!0,this.h=this.B(new M.$Ld),this.onDidChangeProfiles=this.h.event,this.j=this.B(new M.$Ld),this.onWillCreateProfile=this.j.event,this.m=this.B(new M.$Ld),this.onWillRemoveProfile=this.m.event,this.n=this.B(new M.$Ld),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new S.$yc,emptyWindows:new Map},this.profilesHome=(0,R.$sg)(this.t.userRoamingDataHome,"profiles"),this.g=(0,R.$sg)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(a){this.f!==a&&(this.z=void 0,this.f=a)}isEnabled(){return this.f}get C(){if(!this.z){const a=this.D(),h=[a];if(this.f)try{for(const w of this.O()){if(!w.name||!(0,u.$wf)(w.name)||!w.location){this.y.warn("Skipping the invalid stored profile",w.location||w.name);continue}h.push(t((0,R.$pg)(w.location),w.name,w.location,this.g,{shortName:w.shortName,icon:w.icon,useDefaultFlags:w.useDefaultFlags},a))}}catch(w){this.y.error(w)}const p=new S.$yc,I=new Map;if(h.length)try{const w=this.Q();if(w.workspaces)for(const[f,b]of Object.entries(w.workspaces)){const L=A.URI.parse(f),O=h.find(T=>T.id===b);O&&p.set(L,O)}if(w.emptyWindows)for(const[f,b]of Object.entries(w.emptyWindows)){const L=h.find(O=>O.id===b);L&&I.set(f,L)}}catch(w){this.y.error(w)}this.z={profiles:h,workspaces:p,emptyWindows:I}}return this.z}D(){const a=t("__default__profile__",(0,m.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...a,extensionsResource:this.S()??a.extensionsResource,isDefault:!0}}async createTransientProfile(a){const h="Temp",p=new RegExp(`${(0,c.$De)(h)}\\s(\\d+)`);let I=0;for(const f of this.profiles){const b=p.exec(f.name),L=b?parseInt(b[1]):0;I=L>I?L:I}const w=`${h} ${I+1}`;return this.createProfile((0,y.$zi)((0,s.$bg)()).toString(16),w,{transient:!0},a)}async createNamedProfile(a,h,p){return this.createProfile((0,y.$zi)((0,s.$bg)()).toString(16),a,h,p)}async createProfile(a,h,p,I){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const w=await this.F(a,h,p);return I&&await this.setProfileForWorkspace(I,w),w}async F(a,h,p){if(!(0,u.$wf)(h)||!h)throw new Error("Name of the profile is mandatory and must be of type `string`");let I=this.r.get(h);return I||(I=(async()=>{try{const w=this.profiles.find(L=>L.name===h||L.id===a);if(w)return w;const f=t(a,h,(0,R.$sg)(this.profilesHome,a),this.g,p,this.defaultProfile);await this.u.createFolder(f.location);const b=[];return this.j.fire({profile:f,join(L){b.push(L)}}),await E.Promises.settled(b),this.I([f],[],[]),f}finally{this.r.delete(h)}})(),this.r.set(h,I)),I}async updateProfile(a,h){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let p=this.profiles.find(I=>I.id===a.id);if(!p)throw new Error(`Profile '${a.name}' does not exist`);return p=t(p.id,h.name??p.name,p.location,this.g,{shortName:h.shortName??p.shortName,icon:h.icon===null?void 0:h.icon??p.icon,transient:h.transient??p.isTransient,useDefaultFlags:h.useDefaultFlags??p.useDefaultFlags},this.defaultProfile),this.I([],[],[p]),p}async removeProfile(a){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(a.isDefault)throw new Error("Cannot remove default profile");const h=this.profiles.find(I=>I.id===a.id);if(!h)throw new Error(`Profile '${a.name}' does not exist`);const p=[];this.m.fire({profile:h,join(I){p.push(I)}});try{await Promise.allSettled(p)}catch(I){this.y.error(I)}for(const I of[...this.C.emptyWindows.keys()])h.id===this.C.emptyWindows.get(I)?.id&&this.C.emptyWindows.delete(I);for(const I of[...this.C.workspaces.keys()])h.id===this.C.workspaces.get(I)?.id&&this.C.workspaces.delete(I);this.M(),this.I([],[h],[]);try{await this.u.del(h.cacheHome,{recursive:!0})}catch(I){(0,$.$kk)(I)!==1&&this.y.error(I)}}async setProfileForWorkspace(a,h){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const p=this.profiles.find(I=>I.id===h.id);if(!p)throw new Error(`Profile '${h.name}' does not exist`);this.L(a,p)}unsetWorkspace(a,h){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(a,void 0,h)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const a=await this.u.resolve(this.profilesHome);await Promise.all((a.children||[]).filter(h=>h.isDirectory&&this.profiles.every(p=>!this.w.extUri.isEqual(p.location,h.resource))).map(h=>this.u.del(h.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const a=this.s.profiles.filter(h=>!this.H(h));await Promise.allSettled(a.map(h=>this.removeProfile(h)))}getProfileForWorkspace(a){const h=this.G(a);return A.URI.isUri(h)?this.s.workspaces.get(h)??this.C.workspaces.get(h):this.s.emptyWindows.get(h)??this.C.emptyWindows.get(h)}G(a){return(0,v.$Vh)(a)?a.uri:(0,v.$1h)(a)?a.configPath:a.id}H(a){return!!([...this.s.emptyWindows.values()].some(h=>this.w.extUri.isEqual(h.location,a.location))||[...this.s.workspaces.values()].some(h=>this.w.extUri.isEqual(h.location,a.location))||[...this.C.emptyWindows.values()].some(h=>this.w.extUri.isEqual(h.location,a.location))||[...this.C.workspaces.values()].some(h=>this.w.extUri.isEqual(h.location,a.location)))}I(a,h,p){const I=[...this.profiles,...a],w=[];this.s.profiles=[];for(let f of I)f.isDefault||h.some(b=>f.id===b.id)||(f=p.find(b=>f.id===b.id)??f,f.isTransient?this.s.profiles.push(f):w.push({location:f.location,name:f.name,shortName:f.shortName,icon:f.icon,useDefaultFlags:f.useDefaultFlags}));this.P(w),this.z=void 0,this.J(a,h,p)}J(a,h,p){this.h.fire({added:a,removed:h,updated:p,all:this.profiles})}L(a,h,p){p=h?.isTransient?!0:p,p||this.L(a,void 0,!0);const I=this.G(a),w=p?this.s:this.C;A.URI.isUri(I)?(w.workspaces.delete(I),h&&w.workspaces.set(I,h)):(w.emptyWindows.delete(I),h&&w.emptyWindows.set(I,h)),p||this.M()}M(){const a={};for(const[p,I]of this.C.workspaces.entries())a[p.toString()]=I.id;const h={};for(const[p,I]of this.C.emptyWindows.entries())h[p.toString()]=I.id;this.R({workspaces:a,emptyWindows:h}),this.z=void 0}N(a){const h={},p=this.D();if(a.workspaces)for(const[w,f]of Object.entries(a.workspaces)){const b=A.URI.parse(f);h[w]=this.w.extUri.isEqual(b,p.location)?p.id:this.w.extUri.basename(b)}const I={};if(a.emptyWindows)for(const[w,f]of Object.entries(a.emptyWindows)){const b=A.URI.parse(f);I[w]=this.w.extUri.isEqual(b,p.location)?p.id:this.w.extUri.basename(b)}return{workspaces:h,emptyWindows:I}}O(){return[]}P(a){throw new Error("not implemented")}Q(){return{}}R(a){throw new Error("not implemented")}S(){}};e.$Ik=n,n.b="userDataProfiles",n.c="profileAssociations",e.$Ik=n=Ke([We(0,k.$Sh),We(1,$.$7j),We(2,D.$Dk),We(3,C.$6i)],n);class r extends n{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(a){this.a=a}Q(){return this.X}R(a){this.X=a}}e.$Jk=r}),define(Se[260],De([1,0,9,4,3,53,18,168,5,259]),function(ne,e,y,M,l,R,A,m,k,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3o=e.$2o=e.$1o=e.$Zo=e.$Yo=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$Xo=e.$Wo=e.$Vo=void 0,e.$Vo="__$__isNewStorageMarker",e.$Wo="__$__targetStorageMarker",e.$Xo=(0,k.$Lh)("storageService");var P;(function(u){u[u.NONE=0]="NONE",u[u.SHUTDOWN=1]="SHUTDOWN"})(P||(e.WillSaveStateReason=P={}));var C;(function(u){u[u.APPLICATION=-1]="APPLICATION",u[u.PROFILE=0]="PROFILE",u[u.WORKSPACE=1]="WORKSPACE"})(C||(e.StorageScope=C={}));var v;(function(u){u[u.USER=0]="USER",u[u.MACHINE=1]="MACHINE"})(v||(e.StorageTarget=v={}));function S(u){const o=u.get(e.$Wo);if(o)try{return JSON.parse(o)}catch{}return Object.create(null)}e.$Yo=S;class D extends l.$Qc{constructor(o={flushInterval:D.a}){super(),this.m=o,this.b=this.B(new M.$Od),this.c=this.B(new M.$Od),this.onDidChangeTarget=this.c.event,this.f=this.B(new M.$Ld),this.onWillSaveState=this.f.event,this.h=this.B(new y.$3g(()=>this.n(),this.m.flushInterval)),this.j=this.B(new l.$Rc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(o,g,d){return M.Event.filter(this.b.event,t=>t.scope===o&&(g===void 0||t.key===g),d)}n(){this.j.value=(0,y.$7g)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,l.$Lc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,R.mark)("code/willInitStorage");try{await this.O()}finally{(0,R.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(o,g){const{key:d,external:t}=g;if(d===e.$Wo){switch(o){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:o})}else this.b.fire({scope:o,key:d,target:this.J(o)[d],external:t})}w(o){this.f.fire({reason:o})}get(o,g,d){return this.P(g)?.get(o,d)}getBoolean(o,g,d){return this.P(g)?.getBoolean(o,d)}getNumber(o,g,d){return this.P(g)?.getNumber(o,d)}getObject(o,g,d){return this.P(g)?.getObject(o,d)}storeAll(o,g){this.y(()=>{for(const d of o)this.store(d.key,d.value,d.scope,d.target,g)})}store(o,g,d,t,n=!1){if((0,A.$Ff)(g)){this.remove(o,d,n);return}this.y(()=>{this.z(o,d,t),this.P(d)?.set(o,g,n)})}remove(o,g,d=!1){this.y(()=>{this.z(o,g,void 0),this.P(g)?.delete(o,d)})}y(o){this.b.pause(),this.c.pause();try{o()}finally{this.b.resume(),this.c.resume()}}keys(o,g){const d=[],t=this.J(o);for(const n of Object.keys(t))t[n]===g&&d.push(n);return d}z(o,g,d,t=!1){const n=this.J(g);typeof d=="number"?n[o]!==d&&(n[o]=d,this.P(g)?.set(e.$Wo,JSON.stringify(n),t)):typeof n[o]=="number"&&(delete n[o],this.P(g)?.set(e.$Wo,JSON.stringify(n),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(o){switch(o){case-1:return this.I;case 0:return this.G;default:return this.D}}L(o){const g=this.P(o);return g?S(g):Object.create(null)}isNew(o){return this.getBoolean(e.$Vo,o)===!0}async flush(o=P.NONE){this.f.fire({reason:o});const g=this.P(-1),d=this.P(0),t=this.P(1);switch(o){case P.NONE:await y.Promises.settled([g?.whenFlushed()??Promise.resolve(),d?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case P.SHUTDOWN:await y.Promises.settled([g?.flush(0)??Promise.resolve(),d?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const o=this.P(-1)?.items??new Map,g=this.P(0)?.items??new Map,d=this.P(1)?.items??new Map;return c(o,g,d,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(o){return await this.flush(),this.P(o)?.optimize()}async switch(o,g){return this.w(P.NONE),(0,$.$Ek)(o)?this.R(o,g):this.S(o,g)}M(o,g){return!(o.id===g.id||E(g)&&E(o))}N(o,g,d){this.y(()=>{const t=new Set;for(const[n,r]of o)t.add(n),g.get(n)!==r&&this.u(d,{key:n,external:!0});for(const[n]of g.items)t.has(n)||this.u(d,{key:n,external:!0})})}}e.$Zo=D,D.a=60*1e3;function E(u){return u.isDefault||!!u.useDefaultFlags?.globalState}e.$1o=E;class s extends D{constructor(){super(),this.U=this.B(new m.$To(new m.$Uo,{hint:m.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new m.$To(new m.$Uo,{hint:m.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new m.$To(new m.$Uo,{hint:m.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(o=>this.u(1,o))),this.B(this.W.onDidChangeStorage(o=>this.u(0,o))),this.B(this.U.onDidChangeStorage(o=>this.u(-1,o)))}P(o){switch(o){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(o){switch(o){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(o){return!1}}e.$2o=s;async function c(u,o,g,d,t,n){const r=L=>{try{return JSON.parse(L)}catch{return L}},i=new Map,a=new Map;u.forEach((L,O)=>{i.set(O,L),a.set(O,r(L))});const h=new Map,p=new Map;o.forEach((L,O)=>{h.set(O,L),p.set(O,r(L))});const I=new Map,w=new Map;g.forEach((L,O)=>{I.set(O,L),w.set(O,r(L))}),console.group(d!==t?`Storage: Application (path: ${d})`:`Storage: Application & Profile (path: ${d}, default profile)`);const f=[];if(i.forEach((L,O)=>{f.push({key:O,value:L})}),console.table(f),console.groupEnd(),console.log(a),d!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const L=[];h.forEach((O,T)=>{L.push({key:T,value:O})}),console.table(L),console.groupEnd(),console.log(p)}console.group(`Storage: Workspace (path: ${n})`);const b=[];I.forEach((L,O)=>{b.push({key:O,value:L})}),console.table(b),console.groupEnd(),console.log(w)}e.$3o=c}),define(Se[87],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wbc=void 0;class y{constructor(l){this.d=l,this.b=new Map,this.c=1}add(l){const R=this.c++;return this.b.set(R,l),this.e(),R}get(l,R){return this.b.has(l)?this.b.get(l)[R]:void 0}delete(l){this.b.delete(l),this.e()}e(){y.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$wbc=y,y.a=!1}),define(Se[54],De([1,0,17,24,5]),function(ne,e,y,M,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zbc=e.$ybc=void 0;class R{constructor(){this.a=new Set(Object.keys(y.Schemas)),this.b=new Map,this.extUri=new M.$hg(m=>{const k=this.b.get(m.scheme);return!(k===void 0||k&1024)})}$acceptProviderInfos(m,k){k===null?this.b.delete(m.scheme):this.b.set(m.scheme,k)}isFreeScheme(m){return!this.b.has(m)&&!this.a.has(m)}getCapabilities(m){return this.b.get(m)}}e.$ybc=R,e.$zbc=(0,l.$Lh)("IExtHostFileSystemInfo")}),define(Se[26],De([1,0,5]),function(ne,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nM=void 0,e.$nM=(0,y.$Lh)("IExtHostInitDataService")}),define(Se[261],De([1,0,206,14,241,26]),function(ne,e,y,M,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gdc=void 0;let A=class extends l.$vN{constructor(k,$,P){const C=P.remote.isRemote?"remoteexthost":k?"workerexthost":"exthost",v=P.remote.isRemote?(0,y.localize)(0,null):k?(0,y.localize)(1,null):(0,y.localize)(2,null);super($.createLogger(C,{name:v}))}};e.$Gdc=A,e.$Gdc=A=Ke([We(1,M.$7i),We(2,R.$nM)],A)}),define(Se[262],De([1,0,9]),function(ne,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3bc=e.$2bc=void 0;class M{constructor(A,m,k){this.h=new Map,this.a=A,this.b=m,this.c=k,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then($=>(this.f=$,this)),this.g=this.c.onDidChangeStorage($=>{$.shared===this.b&&$.key===this.a&&(this.f=$.value)}),this.i=new y.$3g(()=>{const $=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const P of $.values())P.complete()}catch(P){for(const C of $.values())C.error(P)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,A])=>A!==void 0).map(([A])=>A)}get whenReady(){return this.d}get(A,m){let k=this.f[A];return typeof k>"u"&&(k=m),k}update(A,m){this.f[A]=m;const k=this.h.get(A);if(k!==void 0)return k.p;const $=new y.$_g;return this.h.set(A,$),this.i.isScheduled()||this.i.schedule(),$.p}dispose(){this.g.dispose()}}e.$2bc=M;class l extends M{setKeysForSync(A){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},A)}constructor(A,m){super(A.identifier.value,!0,m),this.j=A}}e.$3bc=l}),define(Se[263],De([1,0,4,2]),function(ne,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$odc=void 0;class l{constructor(A){this.c=A,this.a=new y.$Ld,this.onDidSaveNotebookDocument=this.a.event,this.b=new y.$Ld,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(A,m,k,$){const C=this.c.getNotebookDocument(M.URI.revive(A)).acceptModelChanged(m.value,k,$);this.b.fire(C)}$acceptDirtyStateChanged(A,m){this.c.getNotebookDocument(M.URI.revive(A)).acceptDirty(m)}$acceptModelSaved(A){const m=this.c.getNotebookDocument(M.URI.revive(A));this.a.fire(m.apiNotebook)}}e.$odc=l}),define(Se[20],De([1,0,5]),function(ne,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$L=e.$0L=void 0,e.$0L=(0,y.$Lh)("IExtHostRpcService");class M{constructor(R){this.getProxy=R.getProxy.bind(R),this.set=R.set.bind(R),this.dispose=R.dispose.bind(R),this.assertRegistered=R.assertRegistered.bind(R),this.drain=R.drain.bind(R)}}e.$$L=M});var et=this&&this.__classPrivateFieldSet||function(ne,e,y,M,l){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!l:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?l.call(ne,y):l?l.value=y:e.set(ne,y),y},Be=this&&this.__classPrivateFieldGet||function(ne,e,y,M){if(y==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!M:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return y==="m"?M:y==="a"?M.call(ne):M?M.value:e.get(ne)};define(Se[264],De([1,0,25,4]),function(ne,e,y,M){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$bcc=void 0;class R{constructor(m,k){l.set(this,void 0),this.b=new M.$Ld,this.onDidChange=this.b.event,this.a=y.$Xl.toKey(m.identifier),et(this,l,k,"f"),Be(this,l,"f").onDidChangePassword($=>{$.extensionId===this.a&&this.b.fire({key:$.key})})}get(m){return Be(this,l,"f").get(this.a,m)}store(m,k){return Be(this,l,"f").store(this.a,m,k)}delete(m){return Be(this,l,"f").delete(this.a,m)}}e.$bcc=R,l=new WeakMap}),define(Se[67],De([1,0,5]),function(ne,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kbc=e.$Jbc=void 0,e.$Jbc=(0,y.$Lh)("IURITransformerService");class M{constructor(R){R?(this.transformIncoming=R.transformIncoming.bind(R),this.transformOutgoing=R.transformOutgoing.bind(R),this.transformOutgoingURI=R.transformOutgoingURI.bind(R),this.transformOutgoingScheme=R.transformOutgoingScheme.bind(R)):(this.transformIncoming=A=>A,this.transformOutgoing=A=>A,this.transformOutgoingURI=A=>A,this.transformOutgoingScheme=A=>A)}}e.$Kbc=M}),define(Se[265],De([1,0,22]),function(ne,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mcb=e.$lcb=void 0;class M{constructor(){this.buffers=[]}add(k){let $=this.buffers.indexOf(k);return $<0&&($=this.buffers.length,this.buffers.push(k)),$}}function l(m,k){if(k.serializeBuffersForPostMessage){const $=new M,C=JSON.stringify(m,(S,D)=>{if(D instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:$.add(D)};if(ArrayBuffer.isView(D)){const E=R(D);if(E)return{$$vscode_array_buffer_reference$$:!0,index:$.add(D.buffer),view:{type:E,byteLength:D.byteLength,byteOffset:D.byteOffset}}}return D}),v=$.buffers.map(S=>{const D=new Uint8Array(S);return y.$_d.wrap(D)});return{message:C,buffers:v}}else return{message:JSON.stringify(m),buffers:[]}}e.$lcb=l;function R(m){switch(m.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function A(m,k){const $=k.map(v=>{const S=new ArrayBuffer(v.byteLength);return new Uint8Array(S).set(v.buffer),S}),P=k.length?(v,S)=>{if(S&&typeof S=="object"&&S.$$vscode_array_buffer_reference$$){const D=S,{index:E}=D,s=$[E];if(D.view)switch(D.view.type){case 1:return new Int8Array(s,D.view.byteOffset,D.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(s,D.view.byteOffset,D.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(s,D.view.byteOffset,D.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(s,D.view.byteOffset,D.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(s,D.view.byteOffset,D.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(s,D.view.byteOffset,D.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(s,D.view.byteOffset,D.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(s,D.view.byteOffset,D.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(s,D.view.byteOffset,D.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(s,D.view.byteOffset,D.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(s,D.view.byteOffset,D.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return s}return S}:void 0;return{message:JSON.parse(m,P),arrayBuffers:$}}e.$mcb=A}),define(Se[266],De([1,0,108,373,374,62,2,14,375]),function(ne,e,y,M,l,R,A,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cec=void 0;const $=!1;function P(o,g,d,t,n,r){const i=r.environment.useHostProxy,a=typeof i=="boolean"?i:!r.remote.isRemote,h={resolveProxy:w=>o.resolveProxy(w),lookupProxyAuthorization:s.bind(void 0,t,n,g,{},r.remote.isRemote),getProxyURL:()=>g.getConfiguration("http").get("proxy"),getProxySupport:()=>g.getConfiguration("http").get("proxySupport")||"off",getSystemCertificatesV1:()=>v(g),getSystemCertificatesV2:()=>S(g),log:(w,f,...b)=>{switch(w){case k.LogLevel.Trace:t.trace(f,...b);break;case k.LogLevel.Debug:t.debug(f,...b);break;case k.LogLevel.Info:t.info(f,...b);break;case k.LogLevel.Warning:t.warn(f,...b);break;case k.LogLevel.Error:t.error(f,...b);break;case k.LogLevel.Critical:t.error(f,...b);break;case k.LogLevel.Off:break;default:L(w,f,b);break}function L(O,T,...F){t.error("Unknown log level",O),t.error(T,...F)}},getLogLevel:()=>{const w=t.getLevel();switch(w){case m.LogLevel.Trace:return k.LogLevel.Trace;case m.LogLevel.Debug:return k.LogLevel.Debug;case m.LogLevel.Info:return k.LogLevel.Info;case m.LogLevel.Warning:return k.LogLevel.Warning;case m.LogLevel.Error:return k.LogLevel.Error;case m.LogLevel.Off:return k.LogLevel.Off;default:return f(w)}function f(b){return t.error("Unknown log level",b),k.LogLevel.Debug}},proxyResolveTelemetry:()=>{},useHostProxy:a,addCertificates:[],env:process.env},p=(0,k.createProxyResolver)(h),I=C(h,p);return E(d,I)}e.$cec=P;function C(o,g){return{http:Object.assign(y,(0,k.createHttpPatch)(o,y,g)),https:Object.assign(M,(0,k.createHttpPatch)(o,M,g)),net:Object.assign(R,(0,k.createNetPatch)(o,R)),tls:Object.assign(l,(0,k.createTlsPatch)(o,l))}}function v(o){const g=o.getConfiguration("http");return!g.get("experimental.systemCertificatesV2",$)&&!!g.get("systemCertificates")}function S(o){const g=o.getConfiguration("http");return!!g.get("experimental.systemCertificatesV2",$)&&!!g.get("systemCertificates")}const D=new Map;function E(o,g){return o.getExtensionPathIndex().then(d=>{const t=globalThis._VSCODE_NODE_MODULES.module,n=t._load;t._load=function(i,a,h){if(i==="net")return g.net;if(i==="tls")return g.tls;if(i!=="http"&&i!=="https")return n.apply(this,arguments);const p=d.findSubstr(A.URI.file(a.filename));let I=D.get(p);if(I||D.set(p,I={}),!I[i]){const w=g[i];I[i]={...w}}return I[i]}})}async function s(o,g,d,t,n,r,i,a){const h=t[r];i&&(t[r]=i),o.trace("ProxyResolver#lookupProxyAuthorization callback",`proxyURL:${r}`,`proxyAuthenticate:${i}`,`proxyAuthenticateCache:${h}`);const p=i||h,I=Array.isArray(p)?p:typeof p=="string"?[p]:[];if(u(g,I,n),I.some(w=>/^(Negotiate|Kerberos)( |$)/i.test(w))&&!a.kerberosRequested)try{a.kerberosRequested=!0;const w=await new Promise((T,F)=>{ne(["kerberos"],T,F)}),f=new URL(r),b=d.getConfiguration("http").get("proxyKerberosServicePrincipal")||(process.platform==="win32"?`HTTP/${f.hostname}`:`HTTP@${f.hostname}`);return o.debug("ProxyResolver#lookupProxyAuthorization Kerberos authentication lookup",`proxyURL:${r}`,`spn:${b}`),"Negotiate "+await(await w.initializeClient(b)).step("")}catch(w){o.error("ProxyResolver#lookupProxyAuthorization Kerberos authentication failed",w)}}let c=!1;function u(o,g,d){c||!g.length||(c=!0,o.$publicLog2("proxyAuthenticationRequest",{authenticationType:g.map(t=>t.split(" ")[0]).join(","),extensionHostType:d?"remote":"local"}))}}),define(Se[267],De([1,0,126]),function(ne,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sr=void 0;function M(R){return{transformIncoming:A=>A.scheme==="vscode-remote"?{scheme:"file",path:A.path,query:A.query,fragment:A.fragment}:A.scheme==="file"?{scheme:"vscode-local",path:A.path,query:A.query,fragment:A.fragment}:A,transformOutgoing:A=>A.scheme==="file"?{scheme:"vscode-remote",authority:R,path:A.path,query:A.query,fragment:A.fragment}:A.scheme==="vscode-local"?{scheme:"file",path:A.path,query:A.query,fragment:A.fragment}:A,transformOutgoingScheme:A=>A==="file"?"vscode-remote":A==="vscode-local"?"file":A}}function l(R){return new y.$Dm(M(R))}e.$sr=l}),define(Se[140],De([1,0,216,18,2,3,5,42,30,17,48,182,39]),function(ne,e,y,M,l,R,A,m,k,$,P,C,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$D=e.$0D=e.$9D=e.EditorsOrder=e.$8D=e.CloseDirection=e.$7D=e.$6D=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$5D=e.$4D=e.$3D=e.$2D=e.$1D=e.$ZD=e.$YD=e.$XD=e.EditorInputCapabilities=e.$WD=e.SaveReason=e.Verbosity=e.$VD=e.$UD=e.$TD=e.$SD=e.$RD=e.$QD=e.$PD=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$OD=e.$ND=e.$MD=e.$LD=e.$KD=void 0,e.$KD={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$LD={id:"default",displayName:(0,y.localize)(0,null),providerDisplayName:(0,y.localize)(1,null)},e.$MD="workbench.editor.sidebysideEditor",e.$ND="workbench.editors.textDiffEditor",e.$OD="workbench.editors.binaryResourceDiffEditor";var S;(function(le){le[le.PROGRAMMATIC=1]="PROGRAMMATIC",le[le.USER=2]="USER",le[le.EDIT=3]="EDIT",le[le.NAVIGATION=4]="NAVIGATION",le[le.JUMP=5]="JUMP"})(S||(e.EditorPaneSelectionChangeReason=S={}));var D;(function(le){le[le.IDENTICAL=1]="IDENTICAL",le[le.SIMILAR=2]="SIMILAR",le[le.DIFFERENT=3]="DIFFERENT"})(D||(e.EditorPaneSelectionCompareResult=D={}));function E(le){const ye=le;return!!ye&&typeof ye.getSelection=="function"&&!!ye.onDidChangeSelection}e.$PD=E;function s(le,ye,de){for(const V of de.visibleEditorPanes)if(V.group.id===ye&&le.matches(V.input))return V.getViewState()}e.$QD=s;function c(le){if(h(le))return!1;const ye=le;return l.URI.isUri(ye?.resource)}e.$RD=c;function u(le){if(h(le))return!1;const ye=le;return ye?.original!==void 0&&ye.modified!==void 0}e.$SD=u;function o(le){if(h(le)||u(le))return!1;const ye=le;return ye?.primary!==void 0&&ye.secondary!==void 0}e.$TD=o;function g(le){if(h(le))return!1;const ye=le;return ye?ye.resource===void 0||ye.resource.scheme===$.Schemas.untitled||ye.forceUntitled===!0:!1}e.$UD=g;function d(le){if(h(le))return!1;const ye=le;return l.URI.isUri(ye?.base?.resource)&&l.URI.isUri(ye?.input1?.resource)&&l.URI.isUri(ye?.input2?.resource)&&l.URI.isUri(ye?.result?.resource)}e.$VD=d;var t;(function(le){le[le.SHORT=0]="SHORT",le[le.MEDIUM=1]="MEDIUM",le[le.LONG=2]="LONG"})(t||(e.Verbosity=t={}));var n;(function(le){le[le.EXPLICIT=1]="EXPLICIT",le[le.AUTO=2]="AUTO",le[le.FOCUS_CHANGE=3]="FOCUS_CHANGE",le[le.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(n||(e.SaveReason=n={}));class r{constructor(){this.a=new Map}registerSource(ye,de){let V=this.a.get(ye);return V||(V={source:ye,label:de},this.a.set(ye,V)),V.source}getSourceLabel(ye){return this.a.get(ye)?.label??ye}}e.$WD=new r;var i;(function(le){le[le.None=0]="None",le[le.Readonly=2]="Readonly",le[le.Untitled=4]="Untitled",le[le.Singleton=8]="Singleton",le[le.RequiresTrust=16]="RequiresTrust",le[le.CanSplitInGroup=32]="CanSplitInGroup",le[le.ForceDescription=64]="ForceDescription",le[le.CanDropIntoEditor=128]="CanDropIntoEditor",le[le.MultipleEditors=256]="MultipleEditors",le[le.Scratchpad=512]="Scratchpad"})(i||(e.EditorInputCapabilities=i={}));class a extends R.$Qc{}e.$XD=a;function h(le){return le instanceof a}e.$YD=h;function p(le){const ye=le;return l.URI.isUri(ye?.preferredResource)}function I(le){const ye=le;return h(ye?.primary)&&h(ye?.secondary)}e.$ZD=I;function w(le){const ye=le;return h(ye?.modified)&&h(ye?.original)}e.$1D=w;function f(le,ye,de,V,J){return me(V,[(0,C.$vi)({id:"workbench.action.openLargeFile",label:(0,y.localize)(2,null),run:()=>{const ee={...de,limits:{size:Number.MAX_VALUE}};le.openEditor(ye,ee)}}),(0,C.$vi)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,y.localize)(3,null),run:()=>J.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:v.default.Warning})}e.$2D=f;function b(le){return h(le?.editor)}e.$3D=b;function L(le){const ye=le;return b(le)&&ye?.group!==void 0}e.$4D=L;function O(le){const ye=le;return typeof ye?.groupId=="number"&&h(ye.editor)}e.$5D=O;var T;(function(le){le[le.UNKNOWN=0]="UNKNOWN",le[le.REPLACE=1]="REPLACE",le[le.MOVE=2]="MOVE",le[le.UNPIN=3]="UNPIN"})(T||(e.EditorCloseContext=T={}));var F;(function(le){le[le.GROUP_ACTIVE=0]="GROUP_ACTIVE",le[le.GROUP_INDEX=1]="GROUP_INDEX",le[le.GROUP_LOCKED=2]="GROUP_LOCKED",le[le.EDITOR_OPEN=3]="EDITOR_OPEN",le[le.EDITOR_CLOSE=4]="EDITOR_CLOSE",le[le.EDITOR_MOVE=5]="EDITOR_MOVE",le[le.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",le[le.EDITOR_LABEL=7]="EDITOR_LABEL",le[le.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",le[le.EDITOR_PIN=9]="EDITOR_PIN",le[le.EDITOR_STICKY=10]="EDITOR_STICKY",le[le.EDITOR_DIRTY=11]="EDITOR_DIRTY",le[le.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(F||(e.GroupModelChangeKind=F={}));var U;(function(le){le[le.PRIMARY=1]="PRIMARY",le[le.SECONDARY=2]="SECONDARY",le[le.BOTH=3]="BOTH",le[le.ANY=4]="ANY"})(U||(e.SideBySideEditor=U={}));class N{getOriginalUri(ye,de){if(!ye)return;if(d(ye))return e.$7D.getOriginalUri(ye.result,de);if(de?.supportSideBySide){const{primary:J,secondary:ee}=this.a(ye);if(J&&ee){if(de?.supportSideBySide===U.BOTH)return{primary:this.getOriginalUri(J,{filterByScheme:de.filterByScheme}),secondary:this.getOriginalUri(ee,{filterByScheme:de.filterByScheme})};if(de?.supportSideBySide===U.ANY)return this.getOriginalUri(J,{filterByScheme:de.filterByScheme})??this.getOriginalUri(ee,{filterByScheme:de.filterByScheme});ye=de.supportSideBySide===U.PRIMARY?J:ee}}if(u(ye)||o(ye)||d(ye))return;const V=p(ye)?ye.preferredResource:ye.resource;return!V||!de||!de.filterByScheme?V:this.b(V,de.filterByScheme)}a(ye){return I(ye)||o(ye)?{primary:ye.primary,secondary:ye.secondary}:w(ye)||u(ye)?{primary:ye.modified,secondary:ye.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(ye,de){if(!ye)return;if(d(ye))return e.$7D.getCanonicalUri(ye.result,de);if(de?.supportSideBySide){const{primary:J,secondary:ee}=this.a(ye);if(J&&ee){if(de?.supportSideBySide===U.BOTH)return{primary:this.getCanonicalUri(J,{filterByScheme:de.filterByScheme}),secondary:this.getCanonicalUri(ee,{filterByScheme:de.filterByScheme})};if(de?.supportSideBySide===U.ANY)return this.getCanonicalUri(J,{filterByScheme:de.filterByScheme})??this.getCanonicalUri(ee,{filterByScheme:de.filterByScheme});ye=de.supportSideBySide===U.PRIMARY?J:ee}}if(u(ye)||o(ye)||d(ye))return;const V=ye.resource;return!V||!de||!de.filterByScheme?V:this.b(V,de.filterByScheme)}b(ye,de){if(Array.isArray(de)){if(de.some(V=>ye.scheme===V))return ye}else if(de===ye.scheme)return ye}}var j;(function(le){le[le.UNKNOWN=0]="UNKNOWN",le[le.KEYBOARD=1]="KEYBOARD",le[le.MOUSE=2]="MOUSE"})(j||(e.EditorCloseMethod=j={}));function z(le,ye,de,V){if(!le.isSticky(ye))return!1;switch(V.preventPinnedEditorClose){case"keyboardAndMouse":return de===j.MOUSE||de===j.KEYBOARD;case"mouse":return de===j.MOUSE;case"keyboard":return de===j.KEYBOARD}return!1}e.$6D=z,e.$7D=new N;var B;(function(le){le[le.LEFT=0]="LEFT",le[le.RIGHT=1]="RIGHT"})(B||(e.CloseDirection=B={}));class ae{constructor(){this.c=new Map,this.d=new Map}start(ye){const de=this.a=ye.get(A.$Kh);for(const[V,J]of this.c)this.e(V,J,de);this.c.clear()}e(ye,de,V){const J=V.createInstance(de);this.d.set(ye,J)}registerFileEditorFactory(ye){if(this.b)throw new Error("Can only register one file editor factory.");this.b=ye}getFileEditorFactory(){return(0,M.$Hf)(this.b)}registerEditorSerializer(ye,de){if(this.c.has(ye)||this.d.has(ye))throw new Error(`A editor serializer with type ID '${ye}' was already registered.`);return this.a?this.e(ye,de,this.a):this.c.set(ye,de),(0,R.$Oc)(()=>{this.c.delete(ye),this.d.delete(ye)})}getEditorSerializer(ye){return this.d.get(typeof ye=="string"?ye:ye.typeId)}}m.$0m.add(e.$KD.EditorFactory,new ae);async function X(le,ye,de){return!le||!le.length?[]:await Promise.all(le.map(async V=>{const J=l.URI.revive(V.fileUri);if(!J){de.info("Cannot resolve the path because it is not valid.",V);return}if(!await ye.canHandleResource(J)){de.info("Cannot resolve the path because it cannot be handled",V);return}let Y=V.exists,Z=V.type;if(typeof Y!="boolean"||typeof Z!="number")try{Z=(await ye.stat(J)).isDirectory?k.FileType.Directory:k.FileType.Unknown,Y=!0}catch(pe){de.error(pe),Y=!1}if(!Y&&V.openOnlyIfExists){de.info("Cannot resolve the path because it does not exist",V);return}if(Z===k.FileType.Directory){de.info("Cannot resolve the path because it is a directory",V);return}const _={...V.options,pinned:!0};return Y?{resource:J,options:_}:{resource:J,options:_,forceUntitled:!0}}))}e.$8D=X;var Q;(function(le){le[le.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",le[le.SEQUENTIAL=1]="SEQUENTIAL"})(Q||(e.EditorsOrder=Q={}));function H(le){const ye=le;if(!ye)return!1;const de=ye;if(de.modified)return H(de.modified);const V=ye;return!!(V.contributionsState&&V.viewState&&Array.isArray(V.cursorState))}e.$9D=H;function te(le){return(0,P.$xi)(le)}e.$0D=te;function me(le,ye,de){const V=(0,P.$yi)(le,ye);return V.forceMessage=de?.forceMessage,V.forceSeverity=de?.forceSeverity,V.allowDialog=de?.allowDialog,V}e.$$D=me}),define(Se[268],De([1,0,4,217,5,3,28,42,19,23,79,255]),function(ne,e,y,M,l,R,A,m,k,$,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hE=e.$gE=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$fE=e.$eE=e.ViewContentGroups=e.$dE=e.$cE=e.ViewContainerLocation=e.Extensions=e.$bE=void 0,e.$bE=(0,C.$Xv)("default-view-icon",P.$Qj.window,(0,M.localize)(0,null));var v;(function(n){n.ViewContainersRegistry="workbench.registry.view.containers",n.ViewsRegistry="workbench.registry.view"})(v||(e.Extensions=v={}));var S;(function(n){n[n.Sidebar=0]="Sidebar",n[n.Panel=1]="Panel",n[n.AuxiliaryBar=2]="AuxiliaryBar"})(S||(e.ViewContainerLocation=S={})),e.$cE=[0,1,2];function D(n){switch(n){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.$dE=D;class E extends R.$Qc{constructor(){super(...arguments),this.c=this.B(new y.$Ld),this.onDidRegister=this.c.event,this.f=this.B(new y.$Ld),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,k.$Pb)([...this.g.values()])}registerViewContainer(r,i,a){const h=this.get(r.id);if(h)return h;const p=r;return p.openCommandActionDescriptor=a?.doNotRegisterOpenCommand?void 0:p.openCommandActionDescriptor??{id:p.id},(0,A.$vc)(this.g,i,[]).push(p),a?.isDefault&&this.h.push(p),this.c.fire({viewContainer:p,viewContainerLocation:i}),p}deregisterViewContainer(r){for(const i of this.g.keys()){const a=this.g.get(i),h=a?.indexOf(r);if(h!==-1){a?.splice(h,1),a.length===0&&this.g.delete(i),this.f.fire({viewContainer:r,viewContainerLocation:i});return}}}get(r){return this.all.filter(i=>i.id===r)[0]}getViewContainers(r){return[...this.g.get(r)||[]]}getViewContainerLocation(r){return[...this.g.keys()].filter(i=>this.getViewContainers(i).filter(a=>a?.id===r.id).length>0)[0]}getDefaultViewContainer(r){return this.h.find(i=>this.getViewContainerLocation(i)===r)}}m.$0m.add(v.ViewContainersRegistry,new E);var s;(function(n){n.Open="2_open",n.Debug="4_debug",n.SCM="5_scm",n.More="9_more"})(s||(e.ViewContentGroups=s={}));function c(n,r){const i=n.group??s.More,a=r.group??s.More;return i!==a?i.localeCompare(a):(n.order??5)-(r.order??5)}class u extends R.$Qc{constructor(){super(...arguments),this.c=this.B(new y.$Ld),this.onViewsRegistered=this.c.event,this.f=this.B(new y.$Ld),this.onViewsDeregistered=this.f.event,this.g=this.B(new y.$Ld),this.onDidChangeContainer=this.g.event,this.h=this.B(new y.$Ld),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new A.$Ec}registerViews(r,i){this.registerViews2([{views:r,viewContainer:i}])}registerViews2(r){r.forEach(({views:i,viewContainer:a})=>this.r(i,a)),this.c.fire(r)}deregisterViews(r,i){const a=this.s(r,i);a.length&&this.f.fire({views:a,viewContainer:i})}moveViews(r,i){for(const a of this.m.keys())if(a!==i){const h=this.s(r,a);h.length&&(this.r(h,i),this.g.fire({views:h,from:a,to:i}))}}getViews(r){return this.m.get(r)||[]}getView(r){for(const i of this.j){const a=(this.m.get(i)||[]).filter(h=>h.id===r)[0];if(a)return a}return null}getViewContainer(r){for(const i of this.j)if((this.m.get(i)||[]).filter(h=>h.id===r)[0])return i;return null}registerViewWelcomeContent(r,i){return this.n.add(r,i),this.h.fire(r),(0,R.$Oc)(()=>{this.n.delete(r,i),this.h.fire(r)})}registerViewWelcomeContent2(r,i){const a=new Map;for(const[h,p]of i)this.n.add(r,p),a.set(h,(0,R.$Oc)(()=>{this.n.delete(r,p),this.h.fire(r)}));return this.h.fire(r),a}getViewWelcomeContent(r){const i=[];return this.n.forEach(r,a=>i.push(a)),i.sort(c)}r(r,i){let a=this.m.get(i);a||(a=[],this.m.set(i,a),this.j.push(i));for(const h of r){if(this.getView(h.id)!==null)throw new Error((0,M.localize)(1,null,h.id));a.push(h)}}s(r,i){const a=this.m.get(i);if(!a)return[];const h=[],p=[];for(const I of a)r.includes(I)?h.push(I):p.push(I);return h.length&&(p.length?this.m.set(i,p):(this.m.delete(i),this.j.splice(this.j.indexOf(i),1))),h}}m.$0m.add(v.ViewsRegistry,new u),e.$eE=(0,l.$Lh)("viewsService"),e.$fE=(0,l.$Lh)("viewDescriptorService");var o;(function(n){n[n.Default=0]="Default",n[n.Expand=1]="Expand"})(o||(e.ViewVisibilityState=o={}));var g;(function(n){n[n.None=0]="None",n[n.Collapsed=1]="Collapsed",n[n.Expanded=2]="Expanded"})(g||(e.TreeItemCollapsibleState=g={}));class d{constructor(r,i){this.c=!1,this.d=!1,(0,$.$1m)(this,r),this.d=!!i,this.resolve=async a=>{if(i&&!this.c){const h=await i(a);h&&(this.tooltip=this.tooltip??h.tooltip,this.command=this.command??h.command)}a.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$gE=d;class t extends Error{constructor(r){super((0,M.localize)(2,null,r)),this.name="NoTreeViewError"}static is(r){return r.name==="NoTreeViewError"}}e.$hE=t}),define(Se[141],De([1,0,4,9,218]),function(ne,e,y,M,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rcb=void 0;class R{constructor(){this.f=new Map,this.k=[],this.m=new y.$Ld,this.n=new y.$Ld,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(m){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=m}onEvent(m){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=m}onRequest(m){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=m}sendResponse(m){m.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${m.command}`)):this.s("response",m)}sendRequest(m,k,$,P){const C={command:m};if(k&&Object.keys(k).length>0&&(C.arguments=k),this.s("request",C),typeof P=="number"){const v=setTimeout(()=>{clearTimeout(v);const S=this.f.get(C.seq);if(S){this.f.delete(C.seq);const D={type:"response",seq:0,request_seq:C.seq,success:!1,command:m,message:(0,l.localize)(0,null,P,m)};S(D)}},P)}return $&&this.f.set(C.seq,$),C.seq}acceptMessage(m){this.j?this.j(m):(this.k.push(m),this.k.length===1&&this.q())}o(m,k){return m.type!=="event"||k.type!=="event"}async q(){let m;for(;this.k.length;){if((!m||this.o(this.k[0],m))&&await(0,M.$Rg)(0),m=this.k.shift(),!m)return;switch(m.type){case"event":this.i?.(m);break;case"request":this.g?.(m);break;case"response":{const k=m,$=this.f.get(k.request_seq);$&&(this.f.delete(k.request_seq),$(k));break}}}}s(m,k){k.type=m,k.seq=this.d++,this.sendMessage(k)}async u(){if(this.f.size===0)return Promise.resolve();const m=new Map;this.f.forEach((k,$)=>m.set($,k)),await(0,M.$Rg)(500),m.forEach((k,$)=>{k({type:"response",seq:0,request_seq:$,success:!1,command:"canceled",message:"canceled"}),this.f.delete($)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.$Rcb=R}),define(Se[269],De([1,0,219,41,5]),function(ne,e,y,M,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.$YG=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.$XG=e.MemoryRangeType=e.$WG=e.State=e.$VG=e.$UG=e.$TG=e.$SG=e.$RG=e.$QG=e.$PG=e.$OG=e.$NG=e.$MG=e.$LG=e.$KG=e.$JG=e.$IG=e.$HG=e.$GG=e.$FG=e.$EG=e.$DG=e.$CG=e.$BG=e.$AG=e.$zG=e.$yG=e.$xG=e.$wG=e.$vG=e.$uG=e.$tG=e.$sG=e.$rG=e.$qG=e.$pG=e.$oG=e.$nG=e.$mG=e.$lG=e.$kG=e.$jG=e.$iG=e.$hG=e.$gG=e.$fG=e.$eG=e.$dG=e.$cG=e.$bG=e.$aG=e.$_F=e.$$F=e.$0F=e.$9F=e.$8F=e.$7F=e.$6F=e.$5F=e.$4F=e.$3F=e.$2F=e.$1F=e.$ZF=e.$YF=e.$XF=e.$WF=e.$VF=e.$UF=void 0,e.$UF="workbench.view.debug",e.$VF="workbench.debug.variablesView",e.$WF="workbench.debug.watchExpressionsView",e.$XF="workbench.debug.callStackView",e.$YF="workbench.debug.loadedScriptsView",e.$ZF="workbench.debug.breakPointsView",e.$1F="workbench.debug.disassemblyView",e.$2F="workbench.panel.repl",e.$3F="workbench.panel.repl.view",e.$4F=new M.$3i("debugType",void 0,{type:"string",description:y.localize(0,null)}),e.$5F=new M.$3i("debugConfigurationType",void 0,{type:"string",description:y.localize(1,null)}),e.$6F=new M.$3i("debugState","inactive",{type:"string",description:y.localize(2,null)}),e.$7F="debugUx",e.$8F=new M.$3i(e.$7F,"default",{type:"string",description:y.localize(3,null)}),e.$9F=new M.$3i("hasDebugged",!1,{type:"boolean",description:y.localize(4,null)}),e.$0F=new M.$3i("inDebugMode",!1,{type:"boolean",description:y.localize(5,null)}),e.$$F=new M.$3i("inDebugRepl",!1,{type:"boolean",description:y.localize(6,null)}),e.$_F=new M.$3i("breakpointWidgetVisible",!1,{type:"boolean",description:y.localize(7,null)}),e.$aG=new M.$3i("inBreakpointWidget",!1,{type:"boolean",description:y.localize(8,null)}),e.$bG=new M.$3i("breakpointsFocused",!0,{type:"boolean",description:y.localize(9,null)}),e.$cG=new M.$3i("watchExpressionsFocused",!0,{type:"boolean",description:y.localize(10,null)}),e.$dG=new M.$3i("watchExpressionsExist",!1,{type:"boolean",description:y.localize(11,null)}),e.$eG=new M.$3i("variablesFocused",!0,{type:"boolean",description:y.localize(12,null)}),e.$fG=new M.$3i("expressionSelected",!1,{type:"boolean",description:y.localize(13,null)}),e.$gG=new M.$3i("breakpointInputFocused",!1,{type:"boolean",description:y.localize(14,null)}),e.$hG=new M.$3i("callStackItemType",void 0,{type:"string",description:y.localize(15,null)}),e.$iG=new M.$3i("callStackSessionIsAttach",!1,{type:"boolean",description:y.localize(16,null)}),e.$jG=new M.$3i("callStackItemStopped",!1,{type:"boolean",description:y.localize(17,null)}),e.$kG=new M.$3i("callStackSessionHasOneThread",!1,{type:"boolean",description:y.localize(18,null)}),e.$lG=new M.$3i("watchItemType",void 0,{type:"string",description:y.localize(19,null)}),e.$mG=new M.$3i("canViewMemory",void 0,{type:"boolean",description:y.localize(20,null)}),e.$nG=new M.$3i("breakpointItemType",void 0,{type:"string",description:y.localize(21,null)}),e.$oG=new M.$3i("breakpointSupportsCondition",!1,{type:"boolean",description:y.localize(22,null)}),e.$pG=new M.$3i("loadedScriptsSupported",!1,{type:"boolean",description:y.localize(23,null)}),e.$qG=new M.$3i("loadedScriptsItemType",void 0,{type:"string",description:y.localize(24,null)}),e.$rG=new M.$3i("focusedSessionIsAttach",!1,{type:"boolean",description:y.localize(25,null)}),e.$sG=new M.$3i("stepBackSupported",!1,{type:"boolean",description:y.localize(26,null)}),e.$tG=new M.$3i("restartFrameSupported",!1,{type:"boolean",description:y.localize(27,null)}),e.$uG=new M.$3i("stackFrameSupportsRestart",!1,{type:"boolean",description:y.localize(28,null)}),e.$vG=new M.$3i("jumpToCursorSupported",!1,{type:"boolean",description:y.localize(29,null)}),e.$wG=new M.$3i("stepIntoTargetsSupported",!1,{type:"boolean",description:y.localize(30,null)}),e.$xG=new M.$3i("breakpointsExist",!1,{type:"boolean",description:y.localize(31,null)}),e.$yG=new M.$3i("debuggersAvailable",!1,{type:"boolean",description:y.localize(32,null)}),e.$zG=new M.$3i("debugExtensionAvailable",!0,{type:"boolean",description:y.localize(33,null)}),e.$AG=new M.$3i("debugProtocolVariableMenuContext",void 0,{type:"string",description:y.localize(34,null)}),e.$BG=new M.$3i("debugSetVariableSupported",!1,{type:"boolean",description:y.localize(35,null)}),e.$CG=new M.$3i("debugSetExpressionSupported",!1,{type:"boolean",description:y.localize(36,null)}),e.$DG=new M.$3i("breakWhenValueChangesSupported",!1,{type:"boolean",description:y.localize(37,null)}),e.$EG=new M.$3i("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:y.localize(38,null)}),e.$FG=new M.$3i("breakWhenValueIsReadSupported",!1,{type:"boolean",description:y.localize(39,null)}),e.$GG=new M.$3i("terminateDebuggeeSupported",!1,{type:"boolean",description:y.localize(40,null)}),e.$HG=new M.$3i("suspendDebuggeeSupported",!1,{type:"boolean",description:y.localize(41,null)}),e.$IG=new M.$3i("variableEvaluateNamePresent",!1,{type:"boolean",description:y.localize(42,null)}),e.$JG=new M.$3i("variableIsReadonly",!1,{type:"boolean",description:y.localize(43,null)}),e.$KG=new M.$3i("exceptionWidgetVisible",!1,{type:"boolean",description:y.localize(44,null)}),e.$LG=new M.$3i("multiSessionRepl",!1,{type:"boolean",description:y.localize(45,null)}),e.$MG=new M.$3i("multiSessionDebug",!1,{type:"boolean",description:y.localize(46,null)}),e.$NG=new M.$3i("disassembleRequestSupported",!1,{type:"boolean",description:y.localize(47,null)}),e.$OG=new M.$3i("disassemblyViewFocus",!1,{type:"boolean",description:y.localize(48,null)}),e.$PG=new M.$3i("languageSupportsDisassembleRequest",!1,{type:"boolean",description:y.localize(49,null)}),e.$QG=new M.$3i("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:y.localize(50,null)});const R=v=>y.localize(51,null,v);e.$RG=R,e.$SG="editor.contrib.debug",e.$TG="editor.contrib.breakpoint",e.$UG="debug",e.$VG={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:y.localize(52,null)};var A;(function(v){v[v.Inactive=0]="Inactive",v[v.Initializing=1]="Initializing",v[v.Stopped=2]="Stopped",v[v.Running=3]="Running"})(A||(e.State=A={}));function m(v){switch(v){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.$WG=m;var k;(function(v){v[v.Valid=0]="Valid",v[v.Unreadable=1]="Unreadable",v[v.Error=2]="Error"})(k||(e.MemoryRangeType=k={})),e.$XG="vscode-debug-memory";var $;(function(v){v[v.Initial=1]="Initial",v[v.Dynamic=2]="Dynamic"})($||(e.DebugConfigurationProviderTriggerKind=$={}));var P;(function(v){v.UnverifiedBreakpoints="unverifiedBreakpoints"})(P||(e.DebuggerString=P={})),e.$YG=(0,l.$Lh)("debugService");var C;(function(v){v[v.CONDITION=0]="CONDITION",v[v.HIT_COUNT=1]="HIT_COUNT",v[v.LOG_MESSAGE=2]="LOG_MESSAGE"})(C||(e.BreakpointWidgetContext=C={}))}),define(Se[270],De([1,0,16,2,15,23,17,35,21,19]),function(ne,e,y,M,l,R,A,m,k,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vF=e.$uF=e.$tF=e.$sF=e.$rF=e.$qF=e.$pF=e.$oF=e.$nF=e.$mF=e.$lF=e.$kF=e.$jF=void 0;const P=/{([^}]+)}/g;function C(I,w,f){return I.replace(P,function(b,L){return w&&L.length>0&&L[0]!=="_"?b:f&&f.hasOwnProperty(L)?f[L]:b})}e.$jF=C;function v(I){const w={};for(const f of Object.keys(I))f.startsWith("!")||(w[f]=I[f]);return w}e.$kF=v;function S(I){return I.configuration.request==="attach"&&!D(I)&&(!I.parentSession||S(I.parentSession))}e.$lF=S;function D(I){let w=I.configuration.type;if(w)return w==="vslsShare"&&(w=I.configuration.adapterProxy.configuration.type),(0,y.$Ze)(w,"extensionhost")||(0,y.$Ze)(w,"pwa-extensionhost")?I:I.parentSession?D(I.parentSession):void 0}e.$mF=D;function E(I){return I.type&&(I.label||I.program||I.runtime)}e.$nF=E;function s(I,w,f){let b,L=0;const O=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let T=null;for(;T=O.exec(I);){const F=T.index+1,U=F+T[0].length;if(F<=w&&U>=f){b=T[0],L=F;break}}if(b){const F=/\w+/g;let U=null;for(;(U=F.exec(b))&&!(U.index+1+L+U[0].length>=f););U&&(b=b.substring(0,F.lastIndex))}return b?{start:L,end:L+b.length-1}:{start:0,end:0}}e.$oF=s;async function c(I,w,f,b){if(I.evaluatableExpressionProvider.has(w)){const L=I.evaluatableExpressionProvider.ordered(w),O=(0,$.$Fb)(await Promise.all(L.map(async T=>{try{return await T.provideEvaluatableExpression(w,f,b??k.CancellationToken.None)}catch{return}})));if(O.length>0){let T=O[0].expression;const F=O[0].range;return T||(T=w.getLineContent(f.lineNumber).substring(F.startColumn-1,F.endColumn-1)),{range:F,matchingExpression:T}}}else{const L=w.getLineContent(f.lineNumber),{start:O,end:T}=s(L,f.column,f.column),F=L.substring(O-1,T);return{matchingExpression:F,range:new m.$ms(f.lineNumber,O,f.lineNumber,O+F.length)}}return null}e.$pF=c;const u=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function o(I){return!!(I&&I.match(u))}e.$qF=o;function g(I){if(typeof I.path=="string"&&!(typeof I.sourceReference=="number"&&I.sourceReference>0)){if(o(I.path))return M.URI.parse(I.path);if((0,l.$gc)(I.path))return M.URI.file(I.path)}return I.path}function d(I){if(typeof I.path=="object"){const w=M.URI.revive(I.path);if(w)return w.scheme===A.Schemas.file?w.fsPath:w.toString()}return I.path}function t(I,w){const f=w?g:d,b=(0,R.$Xm)(I);return r(b,(L,O)=>{L&&O&&(O.path=f(O))}),b}e.$rF=t;function n(I,w){const f=w?g:d,b=(0,R.$Xm)(I);return r(b,(L,O)=>{!L&&O&&(O.path=f(O))}),b}e.$sF=n;function r(I,w){switch(I.type){case"event":{const f=I;switch(f.event){case"output":w(!1,f.body.source);break;case"loadedSource":w(!1,f.body.source);break;case"breakpoint":w(!1,f.body.breakpoint.source);break;default:break}break}case"request":{const f=I;switch(f.command){case"setBreakpoints":w(!0,f.arguments.source);break;case"breakpointLocations":w(!0,f.arguments.source);break;case"source":w(!0,f.arguments.source);break;case"gotoTargets":w(!0,f.arguments.source);break;case"launchVSCode":f.arguments.args.forEach(b=>w(!1,b));break;default:break}break}case"response":{const f=I;if(f.success&&f.body)switch(f.command){case"stackTrace":f.body.stackFrames.forEach(b=>w(!1,b.source));break;case"loadedSources":f.body.sources.forEach(b=>w(!1,b));break;case"scopes":f.body.scopes.forEach(b=>w(!1,b.source));break;case"setFunctionBreakpoints":f.body.breakpoints.forEach(b=>w(!1,b.source));break;case"setBreakpoints":f.body.breakpoints.forEach(b=>w(!1,b.source));break;case"disassemble":f.body?.instructions.forEach(L=>w(!1,L.location));break;default:break}break}}}function i(I){return I.filter(w=>!w.presentation?.hidden).sort((w,f)=>w.presentation?f.presentation?w.presentation.group?f.presentation.group?w.presentation.group!==f.presentation.group?w.presentation.group.localeCompare(f.presentation.group):a(w.presentation.order,f.presentation.order):-1:f.presentation.group?1:a(w.presentation.order,f.presentation.order):-1:f.presentation?1:0)}e.$tF=i;function a(I,w){return typeof I!="number"?typeof w!="number"?0:1:typeof w!="number"?-1:I-w}async function h(I,w){const f=I.getValue("debug.saveBeforeStart",{overrideIdentifier:w.activeTextEditorLanguageId});if(f!=="none"&&(await w.saveAll(),f==="allEditorsInActiveGroup")){const b=w.activeEditorPane;b&&b.input.resource?.scheme===A.Schemas.untitled&&await w.save({editor:b.input,groupId:b.group.id})}await I.reloadConfiguration()}e.$uF=h;const p=(I,w)=>!I||!w?I===w:I.name===w.name&&I.path===w.path&&I.sourceReference===w.sourceReference;e.$vF=p}),define(Se[271],De([1,0,47,62,23,15,10,16,29,220,141]),function(ne,e,y,M,l,R,A,m,k,$,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qdc=e.$Pdc=e.$Odc=e.$Ndc=e.$Mdc=void 0;class C extends P.$Rcb{constructor(){super(),this.r=Buffer.allocUnsafe(0),this.t=-1}v(c,u){this.p=u,this.r=Buffer.allocUnsafe(0),this.t=-1,c.on("data",o=>this.w(o))}sendMessage(c){if(this.p){const u=JSON.stringify(c);this.p.write(`Content-Length: ${Buffer.byteLength(u,"utf8")}${C.a}${u}`,"utf8")}}w(c){for(this.r=Buffer.concat([this.r,c]);;){if(this.t>=0){if(this.r.length>=this.t){const u=this.r.toString("utf8",0,this.t);if(this.r=this.r.slice(this.t),this.t=-1,u.length>0)try{this.acceptMessage(JSON.parse(u))}catch(o){this.m.fire(new Error((o.message||o)+`
`+u))}continue}}else{const u=this.r.indexOf(C.a);if(u!==-1){const g=this.r.toString("utf8",0,u).split(C.b);for(const d of g){const t=d.split(C.l);t[0]==="Content-Length"&&(this.t=Number(t[1]))}this.r=this.r.slice(u+C.a.length);continue}}break}}}e.$Mdc=C,C.a=`\r
\r
`,C.b=/\r?\n/,C.l=/: */;class v extends C{startSession(){return new Promise((c,u)=>{let o=!1;this.x=this.y(()=>{this.v(this.x,this.x),c(),o=!0}),this.x.on("close",()=>{o?this.m.fire(new Error("connection closed")):u(new Error("connection closed"))}),this.x.on("error",g=>{o?this.m.fire(g):u(g)})})}async stopSession(){await this.u(),this.x&&(this.x.end(),this.x=void 0)}}e.$Ndc=v;class S extends v{constructor(c){super(),this.z=c}y(c){return M.createConnection(this.z.port,this.z.host||"127.0.0.1",c)}}e.$Odc=S;class D extends v{constructor(c){super(),this.z=c}y(c){return M.createConnection(this.z.path,c)}}e.$Pdc=D;class E extends C{constructor(c,u){super(),this.y=c,this.z=u}async startSession(){const c=this.y.command,u=this.y.args,o=this.y.options||{};try{if(c)if(R.$gc(c)){if(!await k.Promises.exists(c))throw new Error($.localize(0,null,c))}else c.indexOf("/")<0&&c.indexOf("\\")<0;else throw new Error($.localize(1,null,this.z));let g=process.env;if(o.env&&Object.keys(o.env).length>0&&(g=l.$1m(l.$Xm(process.env),o.env)),c==="node")if(Array.isArray(u)&&u.length>0){const d=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,t={env:g,execArgv:d?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};o.cwd&&(t.cwd=o.cwd);const n=y.fork(u[0],u.slice(1),t);if(!n.pid)throw new Error($.localize(2,null,u[0]));this.x=n}else throw new Error($.localize(3,null));else{const d={env:g};o.cwd&&(d.cwd=o.cwd),this.x=y.spawn(c,u,d)}this.x.on("error",d=>{this.m.fire(d)}),this.x.on("exit",(d,t)=>{this.n.fire(d)}),this.x.stdout.on("close",()=>{this.m.fire(new Error("read error"))}),this.x.stdout.on("error",d=>{this.m.fire(d)}),this.x.stdin.on("error",d=>{this.m.fire(d)}),this.x.stderr.resume(),this.v(this.x.stdout,this.x.stdin)}catch(g){this.m.fire(g)}}async stopSession(){return this.x?(await this.u(),A.$d?new Promise((c,u)=>{const o=y.exec(`taskkill /F /T /PID ${this.x.pid}`,function(g,d,t){if(g)return u(g)});o.on("exit",c),o.on("error",u)}):(this.x.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static A(c,u){if(!c)return;const o=Object.create(null);c.runtime&&(c.runtime.indexOf("./")===0?o.runtime=R.$hc(u,c.runtime):o.runtime=c.runtime),c.runtimeArgs&&(o.runtimeArgs=c.runtimeArgs),c.program&&(R.$gc(c.program)?o.program=c.program:o.program=R.$hc(u,c.program)),c.args&&(o.args=c.args);const g=c;return g.win&&(o.win=E.A(g.win,u)),g.winx86&&(o.winx86=E.A(g.winx86,u)),g.windows&&(o.windows=E.A(g.windows,u)),g.osx&&(o.osx=E.A(g.osx,u)),g.linux&&(o.linux=E.A(g.linux,u)),o}static platformAdapterExecutable(c,u){let o=Object.create(null);u=u.toLowerCase();for(const i of c)if(i.contributes){const a=i.contributes.debuggers;a&&a.length>0&&a.filter(h=>typeof h.type=="string"&&m.$Ze(h.type,u)).forEach(h=>{const p=E.A(h,i.extensionLocation.fsPath);o=l.$1m(o,p,i.isBuiltin)})}let g;A.$d&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?g=o.winx86||o.win||o.windows:A.$d?g=o.win||o.windows:A.$e?g=o.osx:A.$f&&(g=o.linux),g=g||o;const d=g.program||o.program,t=g.args||o.args,n=g.runtime||o.runtime,r=g.runtimeArgs||o.runtimeArgs;if(n)return{type:"executable",command:n,args:(r||[]).concat(typeof d=="string"?[d]:[]).concat(t||[])};if(d)return{type:"executable",command:d,args:t||[]}}}e.$Qdc=E}),define(Se[272],De([1,0,47,32,10]),function(ne,e,y,M,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sdc=e.$Rdc=void 0;function R($,P){return new Promise((C,v)=>{let S="";const D=y.spawn($,P);D.pid&&D.stdout.on("data",E=>{S+=E.toString()}),D.on("error",E=>{v(E)}),D.on("close",E=>{C(S)})})}async function A($){if($)if(l.$d){const P=await new Promise((C,v)=>{ne(["@vscode/windows-process-tree"],C,v)});return new Promise(C=>{P.getProcessTree($,v=>{C(!!v&&v.children.length>0)})})}else return R("/usr/bin/pgrep",["-lP",String($)]).then(P=>{const C=P.trim();return!(C.length===0||C.indexOf(" tmux")>=0)},P=>!0);return Promise.resolve(!0)}e.$Rdc=A;var m;(function($){$[$.cmd=0]="cmd",$[$.powershell=1]="powershell",$[$.bash=2]="bash"})(m||(m={}));function k($,P,C,v,S){$=$.trim().toLowerCase();let D;$.indexOf("powershell")>=0||$.indexOf("pwsh")>=0?D=1:$.indexOf("cmd.exe")>=0?D=0:$.indexOf("bash")>=0?D=2:l.$d?D=0:D=2;let E,s=" ";switch(D){case 1:if(E=c=>(c=c.replace(/\'/g,"''"),c.length>0&&c.charAt(c.length-1)==="\\"?`'${c}\\'`:`'${c}'`),v){const c=(0,M.$1f)(v);c&&(s+=`${c}:; `),s+=`cd ${E(v)}; `}if(S)for(const c in S){const u=S[c];u===null?s+=`Remove-Item env:${c}; `:s+=`\${env:${c}}='${u}'; `}if(P.length>0){const c=P.shift(),u=C?c:E(c);s+=u[0]==="'"?`& ${u} `:`${u} `;for(const o of P)s+=o==="<"||o===">"||C?o:E(o),s+=" "}break;case 0:if(E=c=>(c=c.replace(/\"/g,'""'),c=c.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(u=>c.includes(u))||c.length===0?`"${c}"`:c),v){const c=(0,M.$1f)(v);c&&(s+=`${c}: && `),s+=`cd ${E(v)} && `}if(S){s+='cmd /C "';for(const c in S){let u=S[c];u===null?s+=`set "${c}=" && `:(u=u.replace(/[&^|<>]/g,o=>`^${o}`),s+=`set "${c}=${u}" && `)}}for(const c of P)s+=c==="<"||c===">"||C?c:E(c),s+=" ";S&&(s+='"');break;case 2:{E=u=>(u=u.replace(/(["'\\\$!><#()\[\]*&^| ;{}`])/g,"\\$1"),u.length===0?'""':u);const c=u=>/[^\w@%\/+=,.:^-]/.test(u)?`'${u.replace(/'/g,"'\\''")}'`:u;if(v&&(s+=`cd ${E(v)} ; `),S){s+="/usr/bin/env";for(const u in S){const o=S[u];o===null?s+=` -u ${c(u)}`:s+=` ${c(`${u}=${o}`)}`}s+=" "}for(const u of P)s+=u==="<"||u===">"||C?u:E(u),s+=" ";break}}return s}e.$Sdc=k}),define(Se[109],De([1,0,22,34,50,97,17,15,10,41]),function(ne,e,y,M,l,R,A,m,k,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kI=e.$jI=e.$iI=e.$hI=e.CellStatusbarAlignment=e.$gI=e.$fI=e.$eI=e.NotebookEditorPriority=e.$dI=e.$cI=e.$bI=e.$aI=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$_H=e.$$H=e.$0H=e.$9H=e.CellKind=e.$8H=e.$7H=e.$6H=void 0,e.$6H="workbench.editor.notebook",e.$7H="workbench.editor.notebookTextDiffEditor",e.$8H="workbench.editor.interactive";var P;(function(j){j[j.Markup=1]="Markup",j[j.Code=2]="Code"})(P||(e.CellKind=P={})),e.$9H=["application/json","application/javascript","text/html","image/svg+xml",R.$Jr.latex,R.$Jr.markdown,"image/png","image/jpeg",R.$Jr.text],e.$0H=[R.$Jr.latex,R.$Jr.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",R.$Jr.text],e.$$H=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$_H="_notAvailable";var C;(function(j){j[j.Running=1]="Running",j[j.Idle=2]="Idle"})(C||(e.NotebookRunState=C={}));var v;(function(j){j[j.Unconfirmed=1]="Unconfirmed",j[j.Pending=2]="Pending",j[j.Executing=3]="Executing"})(v||(e.NotebookCellExecutionState=v={}));var S;(function(j){j[j.Unconfirmed=1]="Unconfirmed",j[j.Pending=2]="Pending",j[j.Executing=3]="Executing"})(S||(e.NotebookExecutionState=S={}));var D;(function(j){j[j.WithHardKernelDependency=0]="WithHardKernelDependency",j[j.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",j[j.Pure=2]="Pure",j[j.Never=3]="Never"})(D||(e.NotebookRendererMatch=D={}));var E;(function(j){j.Always="always",j.Never="never",j.Optional="optional"})(E||(e.RendererMessagingSpec=E={}));var s;(function(j){j[j.ModelChange=1]="ModelChange",j[j.Move=2]="Move",j[j.ChangeCellLanguage=5]="ChangeCellLanguage",j[j.Initialize=6]="Initialize",j[j.ChangeCellMetadata=7]="ChangeCellMetadata",j[j.Output=8]="Output",j[j.OutputItem=9]="OutputItem",j[j.ChangeCellContent=10]="ChangeCellContent",j[j.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",j[j.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",j[j.ChangeCellMime=13]="ChangeCellMime",j[j.Unknown=100]="Unknown"})(s||(e.NotebookCellsChangeType=s={}));var c;(function(j){j[j.Handle=0]="Handle",j[j.Index=1]="Index"})(c||(e.SelectionStateType=c={}));var u;(function(j){j[j.Replace=1]="Replace",j[j.Output=2]="Output",j[j.Metadata=3]="Metadata",j[j.CellLanguage=4]="CellLanguage",j[j.DocumentMetadata=5]="DocumentMetadata",j[j.Move=6]="Move",j[j.OutputItems=7]="OutputItems",j[j.PartialMetadata=8]="PartialMetadata",j[j.PartialInternalMetadata=9]="PartialInternalMetadata"})(u||(e.CellEditType=u={}));var o;(function(j){j.scheme=A.Schemas.vscodeNotebookCell;const z=["W","X","Y","Z","a","b","c","d","e","f"],B=new RegExp(`^[${z.join("")}]+`),ae=7;function X(ye,de){const V=de.toString(ae),ee=`${V.length<z.length?z[V.length-1]:"z"}${V}s${(0,y.$te)(y.$_d.fromString(ye.scheme),!0,!0)}`;return ye.with({scheme:j.scheme,fragment:ee})}j.generate=X;function Q(ye){if(ye.scheme!==j.scheme)return;const de=ye.fragment.indexOf("s");if(de<0)return;const V=parseInt(ye.fragment.substring(0,de).replace(B,""),ae),J=(0,y.$se)(ye.fragment.substring(de+1)).toString();if(!isNaN(V))return{handle:V,notebook:ye.with({scheme:J,fragment:null})}}j.parse=Q;function H(ye,de){return ye.with({scheme:A.Schemas.vscodeNotebookCellOutput,fragment:`op${de??""},${ye.scheme!==A.Schemas.file?ye.scheme:""}`})}j.generateCellOutputUri=H;function te(ye){if(ye.scheme!==A.Schemas.vscodeNotebookCellOutput)return;const de=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(ye.fragment);if(!de)return;const V=de[1]&&de[1]!==""?de[1]:void 0,J=de[2];return{outputId:V,notebook:ye.with({scheme:J||A.Schemas.file,fragment:null})}}j.parseCellOutputUri=te;function me(ye,de,V){return j.generate(ye,de).with({scheme:V})}j.generateCellPropertyUri=me;function le(ye,de){if(ye.scheme===de)return j.parse(ye.with({scheme:j.scheme}))}j.parseCellPropertyUri=le})(o||(e.CellUri=o={}));const g=j=>k.$d?j.replace(/\//g,"\\"):j;class d{constructor(z=[],B=e.$9H){this.e=B,this.d=[...new Set(z)].map(ae=>({pattern:ae,matches:M.$sj(g(ae))}))}sort(z){const B=new Map(l.Iterable.map(z,X=>[X,g(X)]));let ae=[];for(const{matches:X}of this.d)for(const[Q,H]of B)if(X(H)){ae.push(Q),B.delete(Q);break}return B.size&&(ae=ae.concat([...B.keys()].sort((X,Q)=>this.e.indexOf(X)-this.e.indexOf(Q)))),ae}prioritize(z,B){const ae=this.f(z);if(ae===-1){this.d.unshift({pattern:z,matches:M.$sj(g(z))});return}const X=new Set(B.map(H=>this.f(H,ae)));X.delete(-1);const Q=Array.from(X).sort();this.d.splice(ae+1,0,...Q.map(H=>this.d[H]));for(let H=Q.length-1;H>=0;H--)this.d.splice(Q[H],1)}toArray(){return this.d.map(z=>z.pattern)}f(z,B=this.d.length){const ae=g(z);for(let X=0;X<B;X++)if(this.d[X].matches(ae))return X;return-1}}e.$aI=d;function t(j,z,B,ae=(X,Q)=>X===Q){const X=[];function Q(me,le,ye){if(le===0&&ye.length===0)return;const de=X[X.length-1];de&&de.start+de.deleteCount===me?(de.deleteCount+=le,de.toInsert.push(...ye)):X.push({start:me,deleteCount:le,toInsert:ye})}let H=0,te=0;for(;;){if(H===j.length){Q(H,0,z.slice(te));break}if(te===z.length){Q(H,j.length-H,[]);break}const me=j[H],le=z[te];if(ae(me,le)){H+=1,te+=1;continue}B(le)?(Q(H,1,[]),H+=1):(Q(H,0,[le]),te+=1)}return X}e.$bI=t,e.$cI=new $.$3i("notebookEditorCursorAtBoundary","none"),e.$dI=new $.$3i("notebookEditorCursorAtLineBoundary","none");var n;(function(j){j.default="default",j.option="option"})(n||(e.NotebookEditorPriority=n={}));function r(j){const z=j;return!!((typeof z.include=="string"||M.$tj(z.include))&&(typeof z.exclude=="string"||M.$tj(z.exclude)))}e.$eI=r;function i(j,z,B){if(Array.isArray(j.viewType)&&j.viewType.indexOf(z)>=0||j.viewType===z)return!0;if(j.filenamePattern){const ae=r(j.filenamePattern)?j.filenamePattern.include:j.filenamePattern,X=r(j.filenamePattern)?j.filenamePattern.exclude:void 0;if(M.$rj(ae,(0,m.$lc)(B.fsPath).toLowerCase()))return!(X&&M.$rj(X,(0,m.$lc)(B.fsPath).toLowerCase()))}return!1}e.$fI=i,e.$gI={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScroll:"notebook.stickyScroll.enabled",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",formatOnSave:"notebook.formatOnSave.enabled",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell"};var a;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(a||(e.CellStatusbarAlignment=a={}));class h{static create(z){return`${h.d}${z}`}static parse(z){if(z.startsWith(h.d))return z.substring(h.d.length)}}e.$hI=h,h.d="notebook/";function p(j){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(j)}e.$iI=p;const I=new TextDecoder;function w(j){const z=[];let B=!1;for(const H of j)(z.length===0||B)&&(z.push(H),B=!0);let ae=L(z);const X=y.$_d.concat(z.map(H=>y.$_d.wrap(H))),Q=N(X);return ae=ae||Q.byteLength!==X.byteLength,{data:Q,didCompression:ae}}e.$jI=w,e.$kI=`${String.fromCharCode(27)}[A`;const f=e.$kI.split("").map(j=>j.charCodeAt(0)),b=10;function L(j){let z=!1;return j.forEach((B,ae)=>{if(ae===0||B.length<e.$kI.length)return;const X=j[ae-1],Q=B.subarray(0,e.$kI.length);if(Q[0]===f[0]&&Q[1]===f[1]&&Q[2]===f[2]){const H=X.lastIndexOf(b);if(H===-1)return;z=!0,j[ae-1]=X.subarray(0,H),j[ae]=B.subarray(e.$kI.length)}}),z}function O(j){let z=j;do j=z,z=j.replace(/[^\n]\x08/gm,"");while(z.length<j.length);return j}function T(j){for(j=j.replace(/\r+\n/gm,`
`);j.search(/\r[^$]/g)>-1;){const z=j.match(/^(.*)\r+/m)[1];let B=j.match(/\r+(.*)$/m)[1];B=B+z.slice(B.length,z.length),j=j.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,B)}return j}const F="\b".charCodeAt(0),U="\r".charCodeAt(0);function N(j){return!j.buffer.includes(F)&&!j.buffer.includes(U)?j:y.$_d.fromString(T(O(I.decode(j.buffer))))}});var et=this&&this.__classPrivateFieldSet||function(ne,e,y,M,l){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!l:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?l.call(ne,y):l?l.value=y:e.set(ne,y),y},Be=this&&this.__classPrivateFieldGet||function(ne,e,y,M){if(y==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!M:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return y==="m"?M:y==="a"?M.call(ne):M?M.value:e.get(ne)};define(Se[7],De([1,0,19,8,80,28,97,16,18,2,31,25,30,65,109]),function(ne,e,y,M,l,R,A,m,k,$,P,C,v,S,D){"use strict";var E,s,c,u,o,g,d,t,n,r,i,a,h,p,I,w,f,b,L,O,T,F,U,N,j,z;Object.defineProperty(e,"__esModule",{value:!0}),e.RelatedInformationType=e.$YL=e.ChatVariableLevel=e.ChatMessageRole=e.InteractiveEditorResponseFeedbackKind=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.$XL=e.$WL=e.$VL=e.$UL=e.$TL=e.$SL=e.$RL=e.$QL=e.$PL=e.$OL=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$NL=e.$ML=e.$LL=e.$KL=e.$JL=e.$IL=e.$HL=e.$GL=e.TestRunProfileKind=e.TestResultState=e.$FL=e.$EL=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$DL=e.$CL=e.$BL=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$AL=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$zL=e.$yL=e.$xL=e.$wL=e.$vL=e.ColorThemeKind=e.$uL=e.$tL=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$sL=e.DebugConsoleMode=e.$rL=e.$qL=e.$pL=e.$oL=e.$nL=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$mL=e.$lL=e.FileChangeType=e.$kL=e.$jL=e.$iL=e.$hL=e.InlineCompletionTriggerKind=e.$gL=e.$fL=e.$eL=e.$dL=e.$cL=e.$bL=e.$aL=e.$_K=e.$$K=e.$0K=e.$9K=e.$8K=e.$7K=e.ConfigurationTarget=e.$6K=e.$5K=e.$4K=e.$3K=e.$2K=e.$1K=e.$ZK=e.$YK=e.$XK=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$WK=e.ViewBadge=e.ProgressLocation=e.$VK=e.$UK=e.TaskScope=e.ShellQuoting=e.$TK=e.$SK=e.$RK=e.TaskPanelKind=e.TaskRevealKind=e.$QK=e.TerminalLocation=e.$PK=e.$OK=e.$NK=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$MK=e.$LK=e.$KK=e.$JK=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.$IK=e.StatusBarAlignment=e.ViewColumn=e.$HK=e.$GK=e.$FK=e.$EK=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$DK=e.$CK=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$BK=e.$AK=e.$zK=e.$yK=e.$xK=e.LanguageStatusSeverity=e.$wK=e.$vK=e.$uK=e.$tK=e.$sK=e.$rK=e.CodeActionTriggerKind=e.$qK=e.$pK=e.SymbolTag=e.SymbolKind=e.$oK=e.DocumentHighlightKind=e.$nK=e.$mK=e.$lK=e.$kK=e.DiagnosticSeverity=e.DiagnosticTag=e.$jK=e.$iK=e.FileEditType=e.$hK=e.$gK=e.$fK=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$eK=e.$dK=e.$cK=e.$bK=e.$aK=e.$_J=e.$$J=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function B(K){return Object.assign(K,{apply:function(...Ee){if(Ee.length===0)return Reflect.construct(K,[]);{const Re=Ee.length===1?[]:Ee[1];return Reflect.construct(K,Re,Ee[0].constructor)}},call:function(...Ee){if(Ee.length===0)return Reflect.construct(K,[]);{const[Re,...Ye]=Ee;return Reflect.construct(K,Ye,Re.constructor)}}})}var ae;(function(K){K[K.Top=0]="Top",K[K.Bottom=1]="Bottom"})(ae||(e.TerminalOutputAnchor=ae={}));var X;(function(K){K[K.TerminalCommand=0]="TerminalCommand",K[K.Opener=1]="Opener",K[K.Command=3]="Command"})(X||(e.TerminalQuickFixType=X={}));let Q=n=class{static from(...q){let Ee=q;return new n(function(){if(Ee){for(const Re of Ee)Re&&typeof Re.dispose=="function"&&Re.dispose();Ee=void 0}})}constructor(q){E.set(this,void 0),et(this,E,q,"f")}dispose(){typeof Be(this,E,"f")=="function"&&(Be(this,E,"f").call(this),et(this,E,void 0,"f"))}};e.$$J=Q,E=new WeakMap,e.$$J=Q=n=Ke([B],Q);let H=r=class{static Min(...q){if(q.length===0)throw new TypeError;let Ee=q[0];for(let Re=1;Re<q.length;Re++){const Ye=q[Re];Ye.isBefore(Ee)&&(Ee=Ye)}return Ee}static Max(...q){if(q.length===0)throw new TypeError;let Ee=q[0];for(let Re=1;Re<q.length;Re++){const Ye=q[Re];Ye.isAfter(Ee)&&(Ee=Ye)}return Ee}static isPosition(q){if(!q)return!1;if(q instanceof r)return!0;const{line:Ee,character:Re}=q;return typeof Ee=="number"&&typeof Re=="number"}static of(q){if(q instanceof r)return q;if(this.isPosition(q))return new r(q.line,q.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(q,Ee){if(q<0)throw(0,M.$5)("line must be non-negative");if(Ee<0)throw(0,M.$5)("character must be non-negative");this.c=q,this.e=Ee}isBefore(q){return this.c<q.c?!0:q.c<this.c?!1:this.e<q.e}isBeforeOrEqual(q){return this.c<q.c?!0:q.c<this.c?!1:this.e<=q.e}isAfter(q){return!this.isBeforeOrEqual(q)}isAfterOrEqual(q){return!this.isBefore(q)}isEqual(q){return this.c===q.c&&this.e===q.e}compareTo(q){return this.c<q.c?-1:this.c>q.line?1:this.e<q.e?-1:this.e>q.e?1:0}translate(q,Ee=0){if(q===null||Ee===null)throw(0,M.$5)();let Re;return typeof q>"u"?Re=0:typeof q=="number"?Re=q:(Re=typeof q.lineDelta=="number"?q.lineDelta:0,Ee=typeof q.characterDelta=="number"?q.characterDelta:0),Re===0&&Ee===0?this:new r(this.line+Re,this.character+Ee)}with(q,Ee=this.character){if(q===null||Ee===null)throw(0,M.$5)();let Re;return typeof q>"u"?Re=this.line:typeof q=="number"?Re=q:(Re=typeof q.line=="number"?q.line:this.line,Ee=typeof q.character=="number"?q.character:this.character),Re===this.line&&Ee===this.character?this:new r(Re,Ee)}toJSON(){return{line:this.line,character:this.character}}};e.$_J=H,e.$_J=H=r=Ke([B],H);let te=i=class{static isRange(q){return q instanceof i?!0:q?H.isPosition(q.start)&&H.isPosition(q.end):!1}static of(q){if(q instanceof i)return q;if(this.isRange(q))return new i(q.start,q.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(q,Ee,Re,Ye){let tt,ht;if(typeof q=="number"&&typeof Ee=="number"&&typeof Re=="number"&&typeof Ye=="number"?(tt=new H(q,Ee),ht=new H(Re,Ye)):H.isPosition(q)&&H.isPosition(Ee)&&(tt=H.of(q),ht=H.of(Ee)),!tt||!ht)throw new Error("Invalid arguments");tt.isBefore(ht)?(this.c=tt,this.e=ht):(this.c=ht,this.e=tt)}contains(q){return i.isRange(q)?this.contains(q.start)&&this.contains(q.end):H.isPosition(q)?!(H.of(q).isBefore(this.c)||this.e.isBefore(q)):!1}isEqual(q){return this.c.isEqual(q.c)&&this.e.isEqual(q.e)}intersection(q){const Ee=H.Max(q.start,this.c),Re=H.Min(q.end,this.e);if(!Ee.isAfter(Re))return new i(Ee,Re)}union(q){if(this.contains(q))return this;if(q.contains(this))return q;const Ee=H.Min(q.start,this.c),Re=H.Max(q.end,this.end);return new i(Ee,Re)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(q,Ee=this.end){if(q===null||Ee===null)throw(0,M.$5)();let Re;return q?H.isPosition(q)?Re=q:(Re=q.start||this.start,Ee=q.end||this.end):Re=this.start,Re.isEqual(this.c)&&Ee.isEqual(this.end)?this:new i(Re,Ee)}toJSON(){return[this.start,this.end]}};e.$aK=te,e.$aK=te=i=Ke([B],te);let me=a=class extends te{static isSelection(q){return q instanceof a?!0:q?te.isRange(q)&&H.isPosition(q.anchor)&&H.isPosition(q.active)&&typeof q.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(q,Ee,Re,Ye){let tt,ht;if(typeof q=="number"&&typeof Ee=="number"&&typeof Re=="number"&&typeof Ye=="number"?(tt=new H(q,Ee),ht=new H(Re,Ye)):H.isPosition(q)&&H.isPosition(Ee)&&(tt=H.of(q),ht=H.of(Ee)),!tt||!ht)throw new Error("Invalid arguments");super(tt,ht),this.f=tt,this.g=ht}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$bK=me,e.$bK=me=a=Ke([B],me);const le=K=>{if(typeof K!="string"||K.length===0||!/^[0-9A-Za-z_\-]+$/.test(K))throw(0,M.$5)("connectionToken")};class ye{static isResolvedAuthority(q){return q&&typeof q=="object"&&typeof q.host=="string"&&typeof q.port=="number"&&(q.connectionToken===void 0||typeof q.connectionToken=="string")}constructor(q,Ee,Re){if(typeof q!="string"||q.length===0)throw(0,M.$5)("host");if(typeof Ee!="number"||Ee===0||Math.round(Ee)!==Ee)throw(0,M.$5)("port");typeof Re<"u"&&le(Re),this.host=q,this.port=Math.round(Ee),this.connectionToken=Re}}e.$cK=ye;class de{static isManagedResolvedAuthority(q){return q&&typeof q=="object"&&typeof q.makeConnection=="function"&&(q.connectionToken===void 0||typeof q.connectionToken=="string")}constructor(q,Ee){this.makeConnection=q,this.connectionToken=Ee,typeof Ee<"u"&&le(Ee)}}e.$dK=de;class V extends Error{static NotAvailable(q,Ee){return new V(q,S.RemoteAuthorityResolverErrorCode.NotAvailable,Ee)}static TemporarilyNotAvailable(q){return new V(q,S.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(q,Ee=S.RemoteAuthorityResolverErrorCode.Unknown,Re){super(q),this._message=q,this._code=Ee,this._detail=Re,Object.setPrototypeOf(this,V.prototype)}}e.$eK=V;var J;(function(K){K[K.LF=1]="LF",K[K.CRLF=2]="CRLF"})(J||(e.EndOfLine=J={}));var ee;(function(K){K[K.Replace=1]="Replace",K[K.Append=2]="Append",K[K.Prepend=3]="Prepend"})(ee||(e.EnvironmentVariableMutatorType=ee={}));let Y=h=class{static isTextEdit(q){return q instanceof h?!0:q?te.isRange(q)&&typeof q.newText=="string":!1}static replace(q,Ee){return new h(q,Ee)}static insert(q,Ee){return h.replace(new te(q,q),Ee)}static delete(q){return h.replace(q,"")}static setEndOfLine(q){const Ee=new h(new te(new H(0,0),new H(0,0)),"");return Ee.newEol=q,Ee}get range(){return this.c}set range(q){if(q&&!te.isRange(q))throw(0,M.$5)("range");this.c=q}get newText(){return this.e||""}set newText(q){if(q&&typeof q!="string")throw(0,M.$5)("newText");this.e=q}get newEol(){return this.f}set newEol(q){if(q&&typeof q!="number")throw(0,M.$5)("newEol");this.f=q}constructor(q,Ee){this.c=q,this.e=Ee}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$fK=Y,e.$fK=Y=h=Ke([B],Y);let Z=p=class{static isNotebookCellEdit(q){return q instanceof p?!0:q?Ue.isNotebookRange(q)&&Array.isArray(q.newCells):!1}static replaceCells(q,Ee){return new p(q,Ee)}static insertCells(q,Ee){return new p(new Ue(q,q),Ee)}static deleteCells(q){return new p(q,[])}static updateCellMetadata(q,Ee){const Re=new p(new Ue(q,q),[]);return Re.newCellMetadata=Ee,Re}static updateNotebookMetadata(q){const Ee=new p(new Ue(0,0),[]);return Ee.newNotebookMetadata=q,Ee}constructor(q,Ee){this.range=q,this.newCells=Ee}};e.$gK=Z,e.$gK=Z=p=Ke([B],Z);class _{static isSnippetTextEdit(q){return q instanceof _?!0:q?te.isRange(q.range)&&ge.isSnippetString(q.snippet):!1}static replace(q,Ee){return new _(q,Ee)}static insert(q,Ee){return _.replace(new te(q,q),Ee)}constructor(q,Ee){this.range=q,this.snippet=Ee}}e.$hK=_;var pe;(function(K){K[K.File=1]="File",K[K.Text=2]="Text",K[K.Cell=3]="Cell",K[K.CellReplace=5]="CellReplace",K[K.Snippet=6]="Snippet"})(pe||(e.FileEditType=pe={}));let se=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(q,Ee,Re,Ye){this.c.push({_type:1,from:q,to:Ee,options:Re,metadata:Ye})}createFile(q,Ee,Re){this.c.push({_type:1,from:void 0,to:q,options:Ee,metadata:Re})}deleteFile(q,Ee,Re){this.c.push({_type:1,from:q,to:void 0,options:Ee,metadata:Re})}e(q,Ee,Re){this.c.push({_type:3,metadata:Re,uri:q,edit:{editType:5,metadata:Ee},notebookMetadata:Ee})}f(q,Ee,Re,Ye){const tt=Ee.start,ht=Ee.end;(tt!==ht||Re.length>0)&&this.c.push({_type:5,uri:q,index:tt,count:ht-tt,cells:Re,metadata:Ye})}g(q,Ee,Re,Ye){this.c.push({_type:3,metadata:Ye,uri:q,edit:{editType:3,index:Ee,metadata:Re}})}replace(q,Ee,Re,Ye){this.c.push({_type:2,uri:q,edit:new Y(Ee,Re),metadata:Ye})}insert(q,Ee,Re,Ye){this.replace(q,new te(Ee,Ee),Re,Ye)}delete(q,Ee,Re){this.replace(q,Ee,"",Re)}has(q){return this.c.some(Ee=>Ee._type===2&&Ee.uri.toString()===q.toString())}set(q,Ee){if(Ee)for(const Re of Ee){if(!Re)continue;let Ye,tt;Array.isArray(Re)?(Ye=Re[0],tt=Re[1]):Ye=Re,Z.isNotebookCellEdit(Ye)?Ye.newCellMetadata?this.g(q,Ye.range.start,Ye.newCellMetadata,tt):Ye.newNotebookMetadata?this.e(q,Ye.newNotebookMetadata,tt):this.f(q,Ye.range,Ye.newCells,tt):_.isSnippetTextEdit(Ye)?this.c.push({_type:6,uri:q,range:Ye.range,edit:Ye.snippet,metadata:tt}):this.c.push({_type:2,uri:q,edit:Ye,metadata:tt})}else{for(let Re=0;Re<this.c.length;Re++){const Ye=this.c[Re];switch(Ye._type){case 2:case 6:case 3:case 5:Ye.uri.toString()===q.toString()&&(this.c[Re]=void 0);break}}(0,y.$Gb)(this.c)}}get(q){const Ee=[];for(const Re of this.c)Re._type===2&&Re.uri.toString()===q.toString()&&Ee.push(Re.edit);return Ee}entries(){const q=new R.$yc;for(const Ee of this.c)if(Ee._type===2){let Re=q.get(Ee.uri);Re||(Re=[Ee.uri,[]],q.set(Ee.uri,Re)),Re[1].push(Ee.edit)}return[...q.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$iK=se,e.$iK=se=Ke([B],se);let ge=I=class{static isSnippetString(q){return q instanceof I?!0:q?typeof q.value=="string":!1}static c(q){return q.replace(/\$|}|\\/g,"\\$&")}constructor(q){this.e=1,this.value=q||""}appendText(q){return this.value+=I.c(q),this}appendTabstop(q=this.e++){return this.value+="$",this.value+=q,this}appendPlaceholder(q,Ee=this.e++){if(typeof q=="function"){const Re=new I;Re.e=this.e,q(Re),this.e=Re.e,q=Re.value}else q=I.c(q);return this.value+="${",this.value+=Ee,this.value+=":",this.value+=q,this.value+="}",this}appendChoice(q,Ee=this.e++){const Re=q.map(Ye=>Ye.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=Ee,this.value+="|",this.value+=Re,this.value+="|}",this}appendVariable(q,Ee){if(typeof Ee=="function"){const Re=new I;Re.e=this.e,Ee(Re),this.e=Re.e,Ee=Re.value}else typeof Ee=="string"&&(Ee=Ee.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=q,Ee&&(this.value+=":",this.value+=Ee),this.value+="}",this}};e.$jK=ge,e.$jK=ge=I=Ke([B],ge);var ie;(function(K){K[K.Unnecessary=1]="Unnecessary",K[K.Deprecated=2]="Deprecated"})(ie||(e.DiagnosticTag=ie={}));var fe;(function(K){K[K.Hint=3]="Hint",K[K.Information=2]="Information",K[K.Warning=1]="Warning",K[K.Error=0]="Error"})(fe||(e.DiagnosticSeverity=fe={}));let be=w=class{static isLocation(q){return q instanceof w?!0:q?te.isRange(q.range)&&$.URI.isUri(q.uri):!1}constructor(q,Ee){if(this.uri=q,Ee)if(te.isRange(Ee))this.range=te.of(Ee);else if(H.isPosition(Ee))this.range=new te(Ee,Ee);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$kK=be,e.$kK=be=w=Ke([B],be);let Ie=class{static is(q){return q?typeof q.message=="string"&&q.location&&te.isRange(q.location.range)&&$.URI.isUri(q.location.uri):!1}constructor(q,Ee){this.location=q,this.message=Ee}static isEqual(q,Ee){return q===Ee?!0:!q||!Ee?!1:q.message===Ee.message&&q.location.range.isEqual(Ee.location.range)&&q.location.uri.toString()===Ee.location.uri.toString()}};e.$lK=Ie,e.$lK=Ie=Ke([B],Ie);let W=class{constructor(q,Ee,Re=fe.Error){if(!te.isRange(q))throw new TypeError("range must be set");if(!Ee)throw new TypeError("message must be set");this.range=q,this.message=Ee,this.severity=Re}toJSON(){return{severity:fe[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(q,Ee){return q===Ee?!0:!q||!Ee?!1:q.message===Ee.message&&q.severity===Ee.severity&&q.code===Ee.code&&q.severity===Ee.severity&&q.source===Ee.source&&q.range.isEqual(Ee.range)&&(0,y.$sb)(q.tags,Ee.tags)&&(0,y.$sb)(q.relatedInformation,Ee.relatedInformation,Ie.isEqual)}};e.$mK=W,e.$mK=W=Ke([B],W);let G=class{constructor(q,Ee){if(!q)throw new Error("Illegal argument, contents must be defined");Array.isArray(q)?this.contents=q:this.contents=[q],this.range=Ee}};e.$nK=G,e.$nK=G=Ke([B],G);var ce;(function(K){K[K.Text=0]="Text",K[K.Read=1]="Read",K[K.Write=2]="Write"})(ce||(e.DocumentHighlightKind=ce={}));let he=class{constructor(q,Ee=ce.Text){this.range=q,this.kind=Ee}toJSON(){return{range:this.range,kind:ce[this.kind]}}};e.$oK=he,e.$oK=he=Ke([B],he);var x;(function(K){K[K.File=0]="File",K[K.Module=1]="Module",K[K.Namespace=2]="Namespace",K[K.Package=3]="Package",K[K.Class=4]="Class",K[K.Method=5]="Method",K[K.Property=6]="Property",K[K.Field=7]="Field",K[K.Constructor=8]="Constructor",K[K.Enum=9]="Enum",K[K.Interface=10]="Interface",K[K.Function=11]="Function",K[K.Variable=12]="Variable",K[K.Constant=13]="Constant",K[K.String=14]="String",K[K.Number=15]="Number",K[K.Boolean=16]="Boolean",K[K.Array=17]="Array",K[K.Object=18]="Object",K[K.Key=19]="Key",K[K.Null=20]="Null",K[K.EnumMember=21]="EnumMember",K[K.Struct=22]="Struct",K[K.Event=23]="Event",K[K.Operator=24]="Operator",K[K.TypeParameter=25]="TypeParameter"})(x||(e.SymbolKind=x={}));var $e;(function(K){K[K.Deprecated=1]="Deprecated"})($e||(e.SymbolTag=$e={}));let ve=f=class{static validate(q){if(!q.name)throw new Error("name must not be falsy")}constructor(q,Ee,Re,Ye,tt){this.name=q,this.kind=Ee,this.containerName=tt,typeof Re=="string"&&(this.containerName=Re),Ye instanceof be?this.location=Ye:Re instanceof te&&(this.location=new be(Ye,Re)),f.validate(this)}toJSON(){return{name:this.name,kind:x[this.kind],location:this.location,containerName:this.containerName}}};e.$pK=ve,e.$pK=ve=f=Ke([B],ve);let Ne=b=class{static validate(q){if(!q.name)throw new Error("name must not be falsy");if(!q.range.contains(q.selectionRange))throw new Error("selectionRange must be contained in fullRange");q.children?.forEach(b.validate)}constructor(q,Ee,Re,Ye,tt){this.name=q,this.detail=Ee,this.kind=Re,this.range=Ye,this.selectionRange=tt,this.children=[],b.validate(this)}};e.$qK=Ne,e.$qK=Ne=b=Ke([B],Ne);var Ve;(function(K){K[K.Invoke=1]="Invoke",K[K.Automatic=2]="Automatic"})(Ve||(e.CodeActionTriggerKind=Ve={}));let xe=class{constructor(q,Ee){this.title=q,this.kind=Ee}};e.$rK=xe,e.$rK=xe=Ke([B],xe);let Qe=L=class{constructor(q){this.value=q}append(q){return new L(this.value?this.value+L.c+q:q)}intersects(q){return this.contains(q)||q.contains(this)}contains(q){return this.value===q.value||q.value.startsWith(this.value+L.c)}};e.$sK=Qe,Qe.c=".",e.$sK=Qe=L=Ke([B],Qe),Qe.Empty=new Qe(""),Qe.QuickFix=Qe.Empty.append("quickfix"),Qe.Refactor=Qe.Empty.append("refactor"),Qe.RefactorExtract=Qe.Refactor.append("extract"),Qe.RefactorInline=Qe.Refactor.append("inline"),Qe.RefactorMove=Qe.Refactor.append("move"),Qe.RefactorRewrite=Qe.Refactor.append("rewrite"),Qe.Source=Qe.Empty.append("source"),Qe.SourceOrganizeImports=Qe.Source.append("organizeImports"),Qe.SourceFixAll=Qe.Source.append("fixAll"),Qe.Notebook=Qe.Empty.append("notebook");let rt=class{constructor(q,Ee){if(this.range=q,this.parent=Ee,Ee&&!Ee.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$tK=rt,e.$tK=rt=Ke([B],rt);class it{constructor(q,Ee,Re,Ye,tt,ht){this.kind=q,this.name=Ee,this.detail=Re,this.uri=Ye,this.range=tt,this.selectionRange=ht}}e.$uK=it;class nt{constructor(q,Ee){this.fromRanges=Ee,this.from=q}}e.$vK=nt;class Ae{constructor(q,Ee){this.fromRanges=Ee,this.to=q}}e.$wK=Ae;var Fe;(function(K){K[K.Information=0]="Information",K[K.Warning=1]="Warning",K[K.Error=2]="Error"})(Fe||(e.LanguageStatusSeverity=Fe={}));let Le=class{constructor(q,Ee){this.range=q,this.command=Ee}get isResolved(){return!!this.command}};e.$xK=Le,e.$xK=Le=Ke([B],Le);let Je=O=class{static isMarkdownString(q){return q instanceof O?!0:q&&q.appendCodeblock&&q.appendMarkdown&&q.appendText&&q.value!==void 0}constructor(q,Ee=!1){s.set(this,void 0),et(this,s,new l.$Yj(q,{supportThemeIcons:Ee}),"f")}get value(){return Be(this,s,"f").value}set value(q){Be(this,s,"f").value=q}get isTrusted(){return Be(this,s,"f").isTrusted}set isTrusted(q){Be(this,s,"f").isTrusted=q}get supportThemeIcons(){return Be(this,s,"f").supportThemeIcons}set supportThemeIcons(q){Be(this,s,"f").supportThemeIcons=q}get supportHtml(){return Be(this,s,"f").supportHtml}set supportHtml(q){Be(this,s,"f").supportHtml=q}get baseUri(){return Be(this,s,"f").baseUri}set baseUri(q){Be(this,s,"f").baseUri=q}appendText(q){return Be(this,s,"f").appendText(q),this}appendMarkdown(q){return Be(this,s,"f").appendMarkdown(q),this}appendCodeblock(q,Ee){return Be(this,s,"f").appendCodeblock(Ee??"",q),this}};e.$yK=Je,s=new WeakMap,e.$yK=Je=O=Ke([B],Je);let ue=class{constructor(q,Ee){this.label=q,this.documentation=Ee}};e.$zK=ue,e.$zK=ue=Ke([B],ue);let oe=class{constructor(q,Ee){this.label=q,this.documentation=Ee,this.parameters=[]}};e.$AK=oe,e.$AK=oe=Ke([B],oe);let Ce=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$BK=Ce,e.$BK=Ce=Ke([B],Ce);var He;(function(K){K[K.Invoke=1]="Invoke",K[K.TriggerCharacter=2]="TriggerCharacter",K[K.ContentChange=3]="ContentChange"})(He||(e.SignatureHelpTriggerKind=He={}));var ze;(function(K){K[K.Type=1]="Type",K[K.Parameter=2]="Parameter"})(ze||(e.InlayHintKind=ze={}));let Ze=class{constructor(q){this.value=q}};e.$CK=Ze,e.$CK=Ze=Ke([B],Ze);let st=class{constructor(q,Ee,Re){this.position=q,this.label=Ee,this.kind=Re}};e.$DK=st,e.$DK=st=Ke([B],st);var lt;(function(K){K[K.Invoke=0]="Invoke",K[K.TriggerCharacter=1]="TriggerCharacter",K[K.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(lt||(e.CompletionTriggerKind=lt={}));var wt;(function(K){K[K.Text=0]="Text",K[K.Method=1]="Method",K[K.Function=2]="Function",K[K.Constructor=3]="Constructor",K[K.Field=4]="Field",K[K.Variable=5]="Variable",K[K.Class=6]="Class",K[K.Interface=7]="Interface",K[K.Module=8]="Module",K[K.Property=9]="Property",K[K.Unit=10]="Unit",K[K.Value=11]="Value",K[K.Enum=12]="Enum",K[K.Keyword=13]="Keyword",K[K.Snippet=14]="Snippet",K[K.Color=15]="Color",K[K.File=16]="File",K[K.Reference=17]="Reference",K[K.Folder=18]="Folder",K[K.EnumMember=19]="EnumMember",K[K.Constant=20]="Constant",K[K.Struct=21]="Struct",K[K.Event=22]="Event",K[K.Operator=23]="Operator",K[K.TypeParameter=24]="TypeParameter",K[K.User=25]="User",K[K.Issue=26]="Issue"})(wt||(e.CompletionItemKind=wt={}));var Ct;(function(K){K[K.Deprecated=1]="Deprecated"})(Ct||(e.CompletionItemTag=Ct={}));let Xt=class{constructor(q,Ee){this.label=q,this.kind=Ee}toJSON(){return{label:this.label,kind:this.kind&&wt[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$EK=Xt,e.$EK=Xt=Ke([B],Xt);let qt=class{constructor(q=[],Ee=!1){this.items=q,this.isIncomplete=Ee}};e.$FK=qt,e.$FK=qt=Ke([B],qt);let vt=class{constructor(q,Ee,Re){this.insertText=q,this.range=Ee,this.command=Re}};e.$GK=vt,e.$GK=vt=Ke([B],vt);let Nt=class{constructor(q){this.commands=void 0,this.suppressSuggestions=void 0,this.items=q}};e.$HK=Nt,e.$HK=Nt=Ke([B],Nt);var jt;(function(K){K[K.Active=-1]="Active",K[K.Beside=-2]="Beside",K[K.One=1]="One",K[K.Two=2]="Two",K[K.Three=3]="Three",K[K.Four=4]="Four",K[K.Five=5]="Five",K[K.Six=6]="Six",K[K.Seven=7]="Seven",K[K.Eight=8]="Eight",K[K.Nine=9]="Nine"})(jt||(e.ViewColumn=jt={}));var Yt;(function(K){K[K.Left=1]="Left",K[K.Right=2]="Right"})(Yt||(e.StatusBarAlignment=Yt={}));function Ut(K,q){return`${C.$Xl.toKey(K)}.${q}`}e.$IK=Ut;var zt;(function(K){K[K.Off=0]="Off",K[K.On=1]="On",K[K.Relative=2]="Relative"})(zt||(e.TextEditorLineNumbersStyle=zt={}));var Ht;(function(K){K[K.Manual=1]="Manual",K[K.AfterDelay=2]="AfterDelay",K[K.FocusOut=3]="FocusOut"})(Ht||(e.TextDocumentSaveReason=Ht={}));var Gt;(function(K){K[K.Default=0]="Default",K[K.InCenter=1]="InCenter",K[K.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",K[K.AtTop=3]="AtTop"})(Gt||(e.TextEditorRevealType=Gt={}));var Bt;(function(K){K[K.Keyboard=1]="Keyboard",K[K.Mouse=2]="Mouse",K[K.Command=3]="Command"})(Bt||(e.TextEditorSelectionChangeKind=Bt={}));var Kt;(function(K){K[K.Undo=1]="Undo",K[K.Redo=2]="Redo"})(Kt||(e.TextDocumentChangeReason=Kt={}));var Jt;(function(K){K[K.OpenOpen=0]="OpenOpen",K[K.ClosedClosed=1]="ClosedClosed",K[K.OpenClosed=2]="OpenClosed",K[K.ClosedOpen=3]="ClosedOpen"})(Jt||(e.DecorationRangeBehavior=Jt={})),function(K){function q(Ee){switch(Ee){case"keyboard":return K.Keyboard;case"mouse":return K.Mouse;case"api":return K.Command}}K.fromValue=q}(Bt||(e.TextEditorSelectionChangeKind=Bt={}));var ct;(function(K){K[K.Other=0]="Other",K[K.Comment=1]="Comment",K[K.String=2]="String",K[K.RegEx=3]="RegEx"})(ct||(e.SyntaxTokenType=ct={})),function(K){function q(Ee){switch(Ee){case K.Other:return"other";case K.Comment:return"comment";case K.String:return"string";case K.RegEx:return"regex"}return"other"}K.toString=q}(ct||(e.SyntaxTokenType=ct={}));let mt=class{constructor(q,Ee){if(Ee&&!$.URI.isUri(Ee))throw(0,M.$5)("target");if(!te.isRange(q)||q.isEmpty)throw(0,M.$5)("range");this.range=q,this.target=Ee}};e.$JK=mt,e.$JK=mt=Ke([B],mt);let It=class{constructor(q,Ee,Re,Ye){this.red=q,this.green=Ee,this.blue=Re,this.alpha=Ye}};e.$KK=It,e.$KK=It=Ke([B],It);let Rt=class{constructor(q,Ee){if(Ee&&!(Ee instanceof It))throw(0,M.$5)("color");if(!te.isRange(q)||q.isEmpty)throw(0,M.$5)("range");this.range=q,this.color=Ee}};e.$LK=Rt,e.$LK=Rt=Ke([B],Rt);let Pt=class{constructor(q){if(!q||typeof q!="string")throw(0,M.$5)("label");this.label=q}};e.$MK=Pt,e.$MK=Pt=Ke([B],Pt);var gt;(function(K){K[K.RGB=0]="RGB",K[K.HEX=1]="HEX",K[K.HSL=2]="HSL"})(gt||(e.ColorFormat=gt={}));var St;(function(K){K[K.Error=0]="Error",K[K.Warning=1]="Warning",K[K.Information=2]="Information"})(St||(e.SourceControlInputBoxValidationType=St={}));var At;(function(K){K[K.Unknown=0]="Unknown",K[K.Shutdown=1]="Shutdown",K[K.Process=2]="Process",K[K.User=3]="User",K[K.Extension=4]="Extension"})(At||(e.TerminalExitReason=At={}));class Ft{constructor(q,Ee,Re){if(this.startIndex=q,this.length=Ee,this.tooltip=Re,typeof q!="number"||q<0)throw(0,M.$5)("startIndex");if(typeof Ee!="number"||Ee<1)throw(0,M.$5)("length");if(Re!==void 0&&typeof Re!="string")throw(0,M.$5)("tooltip")}}e.$NK=Ft;class Xe{constructor(q){this.uri=q}}e.$OK=Xe;class Me{constructor(q){this.terminalCommand=q}}e.$PK=Me;var Te;(function(K){K[K.Panel=1]="Panel",K[K.Editor=2]="Editor"})(Te||(e.TerminalLocation=Te={}));class Pe{constructor(q){if(this.options=q,typeof q!="object")throw(0,M.$5)("options")}}e.$QK=Pe;var re;(function(K){K[K.Always=1]="Always",K[K.Silent=2]="Silent",K[K.Never=3]="Never"})(re||(e.TaskRevealKind=re={}));var Oe;(function(K){K[K.Shared=1]="Shared",K[K.Dedicated=2]="Dedicated",K[K.New=3]="New"})(Oe||(e.TaskPanelKind=Oe={}));let qe=T=class{static from(q){switch(q){case"clean":return T.Clean;case"build":return T.Build;case"rebuild":return T.Rebuild;case"test":return T.Test;default:return}}constructor(q,Ee){if(this.label=Ee,typeof q!="string"||typeof Ee!="string")throw(0,M.$5)("name");this.c=q}get id(){return this.c}};e.$RK=qe,qe.Clean=new T("clean","Clean"),qe.Build=new T("build","Build"),qe.Rebuild=new T("rebuild","Rebuild"),qe.Test=new T("test","Test"),e.$RK=qe=T=Ke([B],qe);function _e(K){let q="";for(let Ee=0;Ee<K.length;Ee++)q+=K[Ee].replace(/,/g,",,")+",";return q}let Ge=class{constructor(q,Ee,Re){if(typeof q!="string")throw(0,M.$5)("process");this.e=[],this.c=q,Ee!==void 0&&(Array.isArray(Ee)?(this.e=Ee,this.f=Re):this.f=Ee)}get process(){return this.c}set process(q){if(typeof q!="string")throw(0,M.$5)("process");this.c=q}get args(){return this.e}set args(q){Array.isArray(q)||(q=[]),this.e=q}get options(){return this.f}set options(q){this.f=q}computeId(){const q=[];if(q.push("process"),this.c!==void 0&&q.push(this.c),this.e&&this.e.length>0)for(const Ee of this.e)q.push(Ee);return _e(q)}};e.$SK=Ge,e.$SK=Ge=Ke([B],Ge);let ot=class{constructor(q,Ee,Re){if(this.f=[],Array.isArray(Ee)){if(!q)throw(0,M.$5)("command can't be undefined or null");if(typeof q!="string"&&typeof q.value!="string")throw(0,M.$5)("command");this.e=q,this.f=Ee,this.g=Re}else{if(typeof q!="string")throw(0,M.$5)("commandLine");this.c=q,this.g=Ee}}get commandLine(){return this.c}set commandLine(q){if(typeof q!="string")throw(0,M.$5)("commandLine");this.c=q}get command(){return this.e?this.e:""}set command(q){if(typeof q!="string"&&typeof q.value!="string")throw(0,M.$5)("command");this.e=q}get args(){return this.f}set args(q){this.f=q||[]}get options(){return this.g}set options(q){this.g=q}computeId(){const q=[];if(q.push("shell"),this.c!==void 0&&q.push(this.c),this.e!==void 0&&q.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const Ee of this.f)q.push(typeof Ee=="string"?Ee:Ee.value);return _e(q)}};e.$TK=ot,e.$TK=ot=Ke([B],ot);var pt;(function(K){K[K.Escape=1]="Escape",K[K.Strong=2]="Strong",K[K.Weak=3]="Weak"})(pt||(e.ShellQuoting=pt={}));var Mt;(function(K){K[K.Global=1]="Global",K[K.Workspace=2]="Workspace"})(Mt||(e.TaskScope=Mt={}));class yt{constructor(q){this.c=q}computeId(){return"customExecution"+(0,P.$bg)()}set callback(q){this.c=q}get callback(){return this.c}}e.$UK=yt;let ut=F=class{constructor(q,Ee,Re,Ye,tt,ht){this.j=!1,this.k=this.definition=q;let ft;typeof Ee=="string"?(this.m=this.name=Ee,this.t=this.source=Re,this.execution=Ye,ft=tt,this.j=!0):Ee===Mt.Global||Ee===Mt.Workspace?(this.target=Ee,this.m=this.name=Re,this.t=this.source=Ye,this.execution=tt,ft=ht):(this.target=Ee,this.m=this.name=Re,this.t=this.source=Ye,this.execution=tt,ft=ht),typeof ft=="string"?(this.o=[ft],this.q=!0):Array.isArray(ft)?(this.o=ft,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.w=Object.create(null),this.x=Object.create(null)}get _id(){return this.h}set _id(q){this.h=q}get _deprecated(){return this.j}z(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.A())}A(){this.n instanceof Ge?this.k={type:F.e,id:this.n.computeId()}:this.n instanceof ot?this.k={type:F.f,id:this.n.computeId()}:this.n instanceof yt?this.k={type:F.c,id:this.n.computeId()}:this.k={type:F.g,id:(0,P.$bg)()}}get definition(){return this.k}set definition(q){if(q==null)throw(0,M.$5)("Kind can't be undefined or null");this.z(),this.k=q}get scope(){return this.l}set target(q){this.z(),this.l=q}get name(){return this.m}set name(q){if(typeof q!="string")throw(0,M.$5)("name");this.z(),this.m=q}get execution(){return this.n}set execution(q){q===null&&(q=void 0),this.z(),this.n=q;const Ee=this.k.type;(F.g===Ee||F.e===Ee||F.f===Ee||F.c===Ee)&&this.A()}get problemMatchers(){return this.o}set problemMatchers(q){if(Array.isArray(q))this.z(),this.o=q,this.q=!0;else{this.z(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(q){q!==!0&&q!==!1&&(q=!1),this.z(),this.r=q}get source(){return this.t}set source(q){if(typeof q!="string"||q.length===0)throw(0,M.$5)("source must be a string of length > 0");this.z(),this.t=q}get group(){return this.u}set group(q){q===null&&(q=void 0),this.z(),this.u=q}get detail(){return this.y}set detail(q){q===null&&(q=void 0),this.y=q}get presentationOptions(){return this.w}set presentationOptions(q){q==null&&(q=Object.create(null)),this.z(),this.w=q}get runOptions(){return this.x}set runOptions(q){q==null&&(q=Object.create(null)),this.z(),this.x=q}};e.$VK=ut,ut.c="customExecution",ut.e="process",ut.f="shell",ut.g="$empty",e.$VK=ut=F=Ke([B],ut);var bt;(function(K){K[K.SourceControl=1]="SourceControl",K[K.Window=10]="Window",K[K.Notification=15]="Notification"})(bt||(e.ProgressLocation=bt={}));var Dt;(function(K){function q(Ee){const Re=Ee;return(0,k.$Af)(Re.value)?Re.tooltip&&!(0,k.$wf)(Re.tooltip)?(console.log("INVALID view badge, invalid tooltip",Re.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Re.value),!1)}K.isViewBadge=q})(Dt||(e.ViewBadge=Dt={}));let mi=U=class{static isTreeItem(q,Ee){const Re=q;if(Re.checkboxState!==void 0){const Ye=(0,k.$Af)(Re.checkboxState)?Re.checkboxState:(0,k.$yf)(Re.checkboxState)&&(0,k.$Af)(Re.checkboxState.state)?Re.checkboxState.state:void 0,tt=!(0,k.$Af)(Re.checkboxState)&&(0,k.$yf)(Re.checkboxState)?Re.checkboxState.tooltip:void 0;if(Ye===void 0||Ye!==$i.Checked&&Ye!==$i.Unchecked||tt!==void 0&&!(0,k.$wf)(tt))return console.log("INVALID tree item, invalid checkboxState",Re.checkboxState),!1}if(q instanceof U)return!0;if(Re.label!==void 0&&!(0,k.$wf)(Re.label)&&!Re.label?.label)return console.log("INVALID tree item, invalid label",Re.label),!1;if(Re.id!==void 0&&!(0,k.$wf)(Re.id))return console.log("INVALID tree item, invalid id",Re.id),!1;if(Re.iconPath!==void 0&&!(0,k.$wf)(Re.iconPath)&&!$.URI.isUri(Re.iconPath)&&(!Re.iconPath||!(0,k.$wf)(Re.iconPath.id))){const Ye=Re.iconPath;if(!Ye||!(0,k.$wf)(Ye.light)&&!$.URI.isUri(Ye.light)&&!(0,k.$wf)(Ye.dark)&&!$.URI.isUri(Ye.dark))return console.log("INVALID tree item, invalid iconPath",Re.iconPath),!1}return Re.description!==void 0&&!(0,k.$wf)(Re.description)&&typeof Re.description!="boolean"?(console.log("INVALID tree item, invalid description",Re.description),!1):Re.resourceUri!==void 0&&!$.URI.isUri(Re.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Re.resourceUri),!1):Re.tooltip!==void 0&&!(0,k.$wf)(Re.tooltip)&&!(Re.tooltip instanceof Je)?(console.log("INVALID tree item, invalid tooltip",Re.tooltip),!1):Re.command!==void 0&&!Re.command.command?(console.log("INVALID tree item, invalid command",Re.command),!1):Re.collapsibleState!==void 0&&Re.collapsibleState<Wt.None&&Re.collapsibleState>Wt.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Re.collapsibleState),!1):Re.contextValue!==void 0&&!(0,k.$wf)(Re.contextValue)?(console.log("INVALID tree item, invalid contextValue",Re.contextValue),!1):Re.accessibilityInformation!==void 0&&!Re.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Re.accessibilityInformation),!1):!0}constructor(q,Ee=Wt.None){this.collapsibleState=Ee,$.URI.isUri(q)?this.resourceUri=q:this.label=q}};e.$WK=mi,e.$WK=mi=U=Ke([B],mi);var Wt;(function(K){K[K.None=0]="None",K[K.Collapsed=1]="Collapsed",K[K.Expanded=2]="Expanded"})(Wt||(e.TreeItemCollapsibleState=Wt={}));var $i;(function(K){K[K.Unchecked=0]="Unchecked",K[K.Checked=1]="Checked"})($i||(e.TreeItemCheckboxState=$i={}));let ii=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(q){this.value=q}};e.$XK=ii,e.$XK=ii=Ke([B],ii);class Si extends ii{}e.$YK=Si;class Tt extends Si{constructor(q){super(""),c.set(this,void 0),et(this,c,q,"f")}asFile(){return Be(this,c,"f")}}e.$ZK=Tt,c=new WeakMap;class hn{constructor(q,Ee,Re,Ye){this.name=q,this.uri=Ee,this._itemId=Re,this.c=Ye}data(){return this.c()}}e.$1K=hn;let Di=class{constructor(q){u.add(this),o.set(this,new Map);for(const[Ee,Re]of q??[]){const Ye=Be(this,o,"f").get(Be(this,u,"m",g).call(this,Ee));Ye?Ye.push(Re):Be(this,o,"f").set(Be(this,u,"m",g).call(this,Ee),[Re])}}get(q){return Be(this,o,"f").get(Be(this,u,"m",g).call(this,q))?.[0]}set(q,Ee){Be(this,o,"f").set(Be(this,u,"m",g).call(this,q),[Ee])}forEach(q,Ee){for(const[Re,Ye]of Be(this,o,"f"))for(const tt of Ye)q.call(Ee,tt,Re,this)}*[(o=new WeakMap,u=new WeakSet,Symbol.iterator)](){for(const[q,Ee]of Be(this,o,"f"))for(const Re of Ee)yield[q,Re]}};e.$2K=Di,g=function(q){return q.toLowerCase()},e.$2K=Di=Ke([B],Di);let kt=class{constructor(q){this.insertText=q}};e.$3K=kt,e.$3K=kt=Ke([B],kt);let bi=class{constructor(q,Ee){this.label=Ee,this.insertText=q}};e.$4K=bi,e.$4K=bi=Ke([B],bi);let Zt=class{constructor(q,Ee){this.id=q,this.color=Ee}static isThemeIcon(q){return typeof q.id!="string"?(console.log("INVALID ThemeIcon, invalid id",q.id),!1):!0}};e.$5K=Zt,e.$5K=Zt=Ke([B],Zt),Zt.File=new Zt("file"),Zt.Folder=new Zt("folder");let oi=class{constructor(q){this.id=q}};e.$6K=oi,e.$6K=oi=Ke([B],oi);var qi;(function(K){K[K.Global=1]="Global",K[K.Workspace=2]="Workspace",K[K.WorkspaceFolder=3]="WorkspaceFolder"})(qi||(e.ConfigurationTarget=qi={}));let Ci=class{get base(){return this.c}set base(q){this.c=q,this.e=$.URI.file(q)}get baseUri(){return this.e}set baseUri(q){this.e=q,this.c=q.fsPath}constructor(q,Ee){if(typeof q!="string"&&(!q||!$.URI.isUri(q)&&!$.URI.isUri(q.uri)))throw(0,M.$5)("base");if(typeof Ee!="string")throw(0,M.$5)("pattern");typeof q=="string"?this.baseUri=$.URI.file(q):$.URI.isUri(q)?this.baseUri=q:this.baseUri=q.uri,this.pattern=Ee}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$7K=Ci,e.$7K=Ci=Ke([B],Ci);const Ot=new WeakMap;function Hi(K,q){Ot.set(K,q)}e.$8K=Hi;let ai=class{constructor(q,Ee,Re,Ye){this.enabled=typeof q=="boolean"?q:!0,typeof Ee=="string"&&(this.condition=Ee),typeof Re=="string"&&(this.hitCondition=Re),typeof Ye=="string"&&(this.logMessage=Ye)}get id(){return this.c||(this.c=Ot.get(this)??(0,P.$bg)()),this.c}};e.$9K=ai,e.$9K=ai=Ke([B],ai);let ci=class extends ai{constructor(q,Ee,Re,Ye,tt){if(super(Ee,Re,Ye,tt),q===null)throw(0,M.$5)("location");this.location=q}};e.$0K=ci,e.$0K=ci=Ke([B],ci);let ui=class extends ai{constructor(q,Ee,Re,Ye,tt){super(Ee,Re,Ye,tt),this.functionName=q}};e.$$K=ui,e.$$K=ui=Ke([B],ui);let dt=class extends ai{constructor(q,Ee,Re,Ye,tt,ht,ft){if(super(Ye,tt,ht,ft),!Ee)throw(0,M.$5)("dataId");this.label=q,this.dataId=Ee,this.canPersist=Re}};e.$_K=dt,e.$_K=dt=Ke([B],dt);let Ii=class{constructor(q,Ee,Re){this.command=q,this.args=Ee||[],this.options=Re}};e.$aL=Ii,e.$aL=Ii=Ke([B],Ii);let _t=class{constructor(q,Ee){this.port=q,this.host=Ee}};e.$bL=_t,e.$bL=_t=Ke([B],_t);let ni=class{constructor(q){this.path=q}};e.$cL=ni,e.$cL=ni=Ke([B],ni);let wi=class{constructor(q){this.implementation=q}};e.$dL=wi,e.$dL=wi=Ke([B],wi);let Pi=class{constructor(q,Ee,Re){this.session=q,this.threadId=Ee,this.frameId=Re}};e.$eL=Pi,e.$eL=Pi=Ke([B],Pi);let Ai=class{constructor(q,Ee){this.session=q,this.threadId=Ee}};e.$fL=Ai,e.$fL=Ai=Ke([B],Ai);let Li=class{constructor(q,Ee){this.range=q,this.expression=Ee}};e.$gL=Li,e.$gL=Li=Ke([B],Li);var Ri;(function(K){K[K.Invoke=0]="Invoke",K[K.Automatic=1]="Automatic"})(Ri||(e.InlineCompletionTriggerKind=Ri={}));let Mi=class{constructor(q,Ee){this.range=q,this.text=Ee}};e.$hL=Mi,e.$hL=Mi=Ke([B],Mi);let pi=class{constructor(q,Ee,Re=!0){this.range=q,this.variableName=Ee,this.caseSensitiveLookup=Re}};e.$iL=pi,e.$iL=pi=Ke([B],pi);let ri=class{constructor(q,Ee){this.range=q,this.expression=Ee}};e.$jL=ri,e.$jL=ri=Ke([B],ri);let Ti=class{constructor(q,Ee){this.frameId=q,this.stoppedLocation=Ee}};e.$kL=Ti,e.$kL=Ti=Ke([B],Ti);var vi;(function(K){K[K.Changed=1]="Changed",K[K.Created=2]="Created",K[K.Deleted=3]="Deleted"})(vi||(e.FileChangeType=vi={}));let hi=N=class extends Error{static FileExists(q){return new N(q,v.FileSystemProviderErrorCode.FileExists,N.FileExists)}static FileNotFound(q){return new N(q,v.FileSystemProviderErrorCode.FileNotFound,N.FileNotFound)}static FileNotADirectory(q){return new N(q,v.FileSystemProviderErrorCode.FileNotADirectory,N.FileNotADirectory)}static FileIsADirectory(q){return new N(q,v.FileSystemProviderErrorCode.FileIsADirectory,N.FileIsADirectory)}static NoPermissions(q){return new N(q,v.FileSystemProviderErrorCode.NoPermissions,N.NoPermissions)}static Unavailable(q){return new N(q,v.FileSystemProviderErrorCode.Unavailable,N.Unavailable)}constructor(q,Ee=v.FileSystemProviderErrorCode.Unknown,Re){super($.URI.isUri(q)?q.toString(!0):q),this.code=Re?.name??"Unknown",(0,v.$ik)(this,Ee),Object.setPrototypeOf(this,N.prototype),typeof Error.captureStackTrace=="function"&&typeof Re=="function"&&Error.captureStackTrace(this,Re)}};e.$lL=hi,e.$lL=hi=N=Ke([B],hi);let Fi=class{constructor(q,Ee,Re){this.start=q,this.end=Ee,this.kind=Re}};e.$mL=Fi,e.$mL=Fi=Ke([B],Fi);var Ki;(function(K){K[K.Comment=1]="Comment",K[K.Imports=2]="Imports",K[K.Region=3]="Region"})(Ki||(e.FoldingRangeKind=Ki={}));var li;(function(K){K[K.Collapsed=0]="Collapsed",K[K.Expanded=1]="Expanded"})(li||(e.CommentThreadCollapsibleState=li={}));var Ji;(function(K){K[K.Editing=0]="Editing",K[K.Preview=1]="Preview"})(Ji||(e.CommentMode=Ji={}));var Gi;(function(K){K[K.Published=0]="Published",K[K.Draft=1]="Draft"})(Gi||(e.CommentState=Gi={}));var Qi;(function(K){K[K.Unresolved=0]="Unresolved",K[K.Resolved=1]="Resolved"})(Qi||(e.CommentThreadState=Qi={}));class yi{constructor(q,Ee=[]){this.tokenTypes=q,this.tokenModifiers=Ee}}e.$nL=yi;function dn(K){return typeof K>"u"||(0,k.$xf)(K)}class Oi{constructor(q){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,q){this.l=!0;for(let Ee=0,Re=q.tokenTypes.length;Ee<Re;Ee++)this.j.set(q.tokenTypes[Ee],Ee);for(let Ee=0,Re=q.tokenModifiers.length;Ee<Re;Ee++)this.k.set(q.tokenModifiers[Ee],Ee)}}push(q,Ee,Re,Ye,tt){if(typeof q=="number"&&typeof Ee=="number"&&typeof Re=="number"&&typeof Ye=="number"&&(typeof tt=="number"||typeof tt>"u"))return typeof tt>"u"&&(tt=0),this.n(q,Ee,Re,Ye,tt);if(te.isRange(q)&&typeof Ee=="string"&&dn(Re))return this.m(q,Ee,Re);throw(0,M.$5)()}m(q,Ee,Re){if(!this.l)throw new Error("Legend must be provided in constructor");if(q.start.line!==q.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(Ee))throw new Error("`tokenType` is not in the provided legend");const Ye=q.start.line,tt=q.start.character,ht=q.end.character-q.start.character,ft=this.j.get(Ee);let Vt=0;if(Re)for(const xt of Re){if(!this.k.has(xt))throw new Error("`tokenModifier` is not in the provided legend");const ei=this.k.get(xt);Vt|=1<<ei>>>0}this.n(Ye,tt,ht,ft,Vt)}n(q,Ee,Re,Ye,tt){if(this.f&&(q<this.c||q===this.c&&Ee<this.e)){this.f=!1;const Vt=this.g.length/5|0;let xt=0,ei=0;for(let ti=0;ti<Vt;ti++){let si=this.g[5*ti],Wi=this.g[5*ti+1];si===0?(si=xt,Wi+=ei):si+=xt,this.g[5*ti]=si,this.g[5*ti+1]=Wi,xt=si,ei=Wi}}let ht=q,ft=Ee;this.f&&this.h>0&&(ht-=this.c,ht===0&&(ft-=this.e)),this.g[this.h++]=ht,this.g[this.h++]=ft,this.g[this.h++]=Re,this.g[this.h++]=Ye,this.g[this.h++]=tt,this.c=q,this.e=Ee}static o(q){const Ee=[],Re=q.length/5|0;for(let ft=0;ft<Re;ft++)Ee[ft]=ft;Ee.sort((ft,Vt)=>{const xt=q[5*ft],ei=q[5*Vt];if(xt===ei){const ti=q[5*ft+1],si=q[5*Vt+1];return ti-si}return xt-ei});const Ye=new Uint32Array(q.length);let tt=0,ht=0;for(let ft=0;ft<Re;ft++){const Vt=5*Ee[ft],xt=q[Vt+0],ei=q[Vt+1],ti=q[Vt+2],si=q[Vt+3],Wi=q[Vt+4],An=xt-tt,Wn=An===0?ei-ht:ei,Vi=5*ft;Ye[Vi+0]=An,Ye[Vi+1]=Wn,Ye[Vi+2]=ti,Ye[Vi+3]=si,Ye[Vi+4]=Wi,tt=xt,ht=ei}return Ye}build(q){return this.f?new Ni(new Uint32Array(this.g),q):new Ni(Oi.o(this.g),q)}}e.$oL=Oi;class Ni{constructor(q,Ee){this.resultId=Ee,this.data=q}}e.$pL=Ni;class di{constructor(q,Ee,Re){this.start=q,this.deleteCount=Ee,this.data=Re}}e.$qL=di;class Xi{constructor(q,Ee){this.resultId=Ee,this.edits=q}}e.$rL=Xi;var Yi;(function(K){K[K.Separate=0]="Separate",K[K.MergeWithParent=1]="MergeWithParent"})(Yi||(e.DebugConsoleMode=Yi={}));let Ei=class{constructor(){}};e.$sL=Ei,Ei.Back={iconPath:new Zt("arrow-left")},e.$sL=Ei=Ke([B],Ei);var ji;(function(K){K[K.Separator=-1]="Separator",K[K.Default=0]="Default"})(ji||(e.QuickPickItemKind=ji={}));var Zi;(function(K){K[K.Info=1]="Info",K[K.Warning=2]="Warning",K[K.Error=3]="Error"})(Zi||(e.InputBoxValidationSeverity=Zi={}));var xi;(function(K){K[K.UI=1]="UI",K[K.Workspace=2]="Workspace"})(xi||(e.ExtensionKind=xi={}));class fn{static validate(q){if(typeof q.badge=="string"){let Ee=(0,m.$0e)(q.badge,0);if(Ee<q.badge.length&&(Ee+=(0,m.$0e)(q.badge,Ee)),q.badge.length>Ee)throw new Error("The 'badge'-property must be undefined or a short character")}else if(q.badge&&!Zt.isThemeIcon(q.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!q.color&&!q.badge&&!q.tooltip)throw new Error("The decoration is empty");return!0}constructor(q,Ee,Re){this.badge=q,this.tooltip=Ee,this.color=Re}}e.$tL=fn;let fi=class{constructor(q){this.kind=q}};e.$uL=fi,e.$uL=fi=Ke([B],fi);var Ui;(function(K){K[K.Light=1]="Light",K[K.Dark=2]="Dark",K[K.HighContrast=3]="HighContrast",K[K.HighContrastLight=4]="HighContrastLight"})(Ui||(e.ColorThemeKind=Ui={}));class Ue{static isNotebookRange(q){return q instanceof Ue?!0:q?typeof q.start=="number"&&typeof q.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(q,Ee){if(q<0)throw(0,M.$5)("start must be positive");if(Ee<0)throw(0,M.$5)("end must be positive");q<=Ee?(this.c=q,this.e=Ee):(this.c=Ee,this.e=q)}with(q){let Ee=this.c,Re=this.e;return q.start!==void 0&&(Ee=q.start),q.end!==void 0&&(Re=q.end),Ee===this.c&&Re===this.e?this:new Ue(Ee,Re)}}e.$vL=Ue;class Qt{static validate(q){if(typeof q.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof q.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof q.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(q){return Array.isArray(q)&&q.every(Ee=>Qt.isNotebookCellData(Ee))}static isNotebookCellData(q){return!0}constructor(q,Ee,Re,Ye,tt,ht,ft){this.kind=q,this.value=Ee,this.languageId=Re,this.mime=Ye,this.outputs=tt??[],this.metadata=ht,this.executionSummary=ft,Qt.validate(this)}}e.$wL=Qt;class _i{constructor(q){this.cells=q}}e.$xL=_i;class $t{static isNotebookCellOutputItem(q){return q instanceof d?!0:q?typeof q.mime=="string"&&q.data instanceof Uint8Array:!1}static error(q){const Ee={name:q.name,message:q.message,stack:q.stack};return d.json(Ee,"application/vnd.code.notebook.error")}static stdout(q){return d.text(q,"application/vnd.code.notebook.stdout")}static stderr(q){return d.text(q,"application/vnd.code.notebook.stderr")}static bytes(q,Ee="application/octet-stream"){return new d(q,Ee)}static text(q,Ee=A.$Jr.text){const Re=Be(d,d,"f",t).encode(String(q));return new d(Re,Ee)}static json(q,Ee="text/x-json"){const Re=JSON.stringify(q,void 0,"	");return d.text(Re,Ee)}constructor(q,Ee){this.data=q,this.mime=Ee;const Re=(0,A.$Nr)(Ee,!0);if(!Re)throw new Error(`INVALID mime type: ${Ee}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Re}}e.$yL=$t,d=$t,t={value:new TextEncoder};class ki{static isNotebookCellOutput(q){return q instanceof ki?!0:!q||typeof q!="object"?!1:typeof q.id=="string"&&Array.isArray(q.items)}static ensureUniqueMimeTypes(q,Ee=!1){const Re=new Set,Ye=new Set;for(let tt=0;tt<q.length;tt++){const ht=q[tt],ft=(0,A.$Nr)(ht.mime);if(!Re.has(ft)||(0,D.$iI)(ft)){Re.add(ft);continue}Ye.add(tt),Ee&&console.warn(`DUPLICATED mime type '${ht.mime}' will be dropped`)}return Ye.size===0?q:q.filter((tt,ht)=>!Ye.has(ht))}constructor(q,Ee,Re){this.items=ki.ensureUniqueMimeTypes(q,!0),typeof Ee=="string"?(this.id=Ee,this.metadata=Re):(this.id=(0,P.$bg)(),this.metadata=Ee??Re)}}e.$zL=ki;var en;(function(K){K[K.Markup=1]="Markup",K[K.Code=2]="Code"})(en||(e.NotebookCellKind=en={}));var zi;(function(K){K[K.Idle=1]="Idle",K[K.Pending=2]="Pending",K[K.Executing=3]="Executing"})(zi||(e.NotebookCellExecutionState=zi={}));var tn;(function(K){K[K.Left=1]="Left",K[K.Right=2]="Right"})(tn||(e.NotebookCellStatusBarAlignment=tn={}));var gi;(function(K){K[K.Default=0]="Default",K[K.InCenter=1]="InCenter",K[K.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",K[K.AtTop=3]="AtTop"})(gi||(e.NotebookEditorRevealType=gi={}));class gn{constructor(q,Ee){this.text=q,this.alignment=Ee}}e.$AL=gn;var nn;(function(K){K[K.Default=1]="Default",K[K.Preferred=2]="Preferred"})(nn||(e.NotebookControllerAffinity=nn={}));var rn;(function(K){K[K.Default=1]="Default",K[K.Preferred=2]="Preferred",K[K.Hidden=-1]="Hidden"})(rn||(e.NotebookControllerAffinity2=rn={}));class sn{constructor(q,Ee=[]){this.uri=q,this.provides=(0,y.$1b)(Ee)}}e.$BL=sn;class mn{constructor(q){this.label=q}}e.$CL=mn;let Bi=class{constructor(q,Ee){this.label=q,this.timestamp=Ee}};e.$DL=Bi,e.$DL=Bi=Ke([B],Bi);var on;(function(K){K[K.Production=1]="Production",K[K.Development=2]="Development",K[K.Test=3]="Test"})(on||(e.ExtensionMode=on={}));var an;(function(K){K[K.Node=1]="Node",K[K.Webworker=2]="Webworker"})(an||(e.ExtensionRuntime=an={}));var cn;(function(K){K[K.Other=0]="Other",K[K.Comment=1]="Comment",K[K.String=2]="String",K[K.RegEx=3]="RegEx"})(cn||(e.StandardTokenType=cn={}));class $n{constructor(q,Ee){this.ranges=q,this.wordPattern=Ee}}e.$EL=$n;class bn{constructor(q){this.c=q}get autoForwardAction(){return this.c}}e.$FL=bn;var un;(function(K){K[K.Queued=1]="Queued",K[K.Running=2]="Running",K[K.Passed=3]="Passed",K[K.Failed=4]="Failed",K[K.Skipped=5]="Skipped",K[K.Errored=6]="Errored"})(un||(e.TestResultState=un={}));var ln;(function(K){K[K.Run=1]="Run",K[K.Debug=2]="Debug",K[K.Coverage=3]="Coverage"})(ln||(e.TestRunProfileKind=ln={}));let we=class{constructor(q=void 0,Ee=void 0,Re=void 0,Ye=!1){this.include=q,this.exclude=Ee,this.profile=Re,this.continuous=Ye}};e.$GL=we,e.$GL=we=Ke([B],we);let ke=j=class{static diff(q,Ee,Re){const Ye=new j(q);return Ye.expectedOutput=Ee,Ye.actualOutput=Re,Ye}constructor(q){this.message=q}};e.$HL=ke,e.$HL=ke=j=Ke([B],ke);let je=class{constructor(q){this.id=q}};e.$IL=je,e.$IL=je=Ke([B],je);let at=class{constructor(q,Ee){this.covered=q,this.total=Ee}};e.$JL=at,e.$JL=at=Ke([B],at);let Et=z=class{static fromDetails(q,Ee){const Re=new at(0,0),Ye=new at(0,0),tt=new at(0,0);for(const ft of Ee)if("branches"in ft){Re.total+=1,Re.covered+=ft.executionCount>0?1:0;for(const Vt of ft.branches)Ye.total+=1,Ye.covered+=Vt.executionCount>0?1:0}else tt.total+=1,tt.covered+=ft.executionCount>0?1:0;const ht=new z(q,Re,Ye.total>0?Ye:void 0,tt.total>0?tt:void 0);return ht.detailedCoverage=Ee,ht}constructor(q,Ee,Re,Ye){this.uri=q,this.statementCoverage=Ee,this.branchCoverage=Re,this.functionCoverage=Ye}};e.$KL=Et,e.$KL=Et=z=Ke([B],Et);let Lt=class{constructor(q,Ee,Re=[]){this.executionCount=q,this.location=Ee,this.branches=Re}};e.$LL=Lt,e.$LL=Lt=Ke([B],Lt);let wn=class{constructor(q,Ee){this.executionCount=q,this.location=Ee}};e.$ML=wn,e.$ML=wn=Ke([B],wn);let pn=class{constructor(q,Ee){this.executionCount=q,this.location=Ee}};e.$NL=pn,e.$NL=pn=Ke([B],pn);var vn;(function(K){K[K.None=0]="None",K[K.Option=1]="Option",K[K.Default=2]="Default",K[K.Preferred=3]="Preferred"})(vn||(e.ExternalUriOpenerPriority=vn={}));var yn;(function(K){K[K.Untrusted=0]="Untrusted",K[K.Trusted=1]="Trusted",K[K.Unspecified=2]="Unspecified"})(yn||(e.WorkspaceTrustState=yn={}));var En;(function(K){K[K.Notify=1]="Notify",K[K.OpenBrowser=2]="OpenBrowser",K[K.OpenPreview=3]="OpenPreview",K[K.Silent=4]="Silent",K[K.Ignore=5]="Ignore",K[K.OpenBrowserOnce=6]="OpenBrowserOnce"})(En||(e.PortAutoForwardAction=En={}));class Ln{constructor(q,Ee,Re,Ye,tt,ht){this.kind=q,this.name=Ee,this.detail=Re,this.uri=Ye,this.range=tt,this.selectionRange=ht}}e.$OL=Ln;class Rn{constructor(q){this.uri=q}}e.$PL=Rn;class Mn{constructor(q,Ee){this.original=q,this.modified=Ee}}e.$QL=Mn;class Tn{constructor(q,Ee,Re,Ye){this.base=q,this.input1=Ee,this.input2=Re,this.result=Ye}}e.$RL=Tn;class Fn{constructor(q,Ee){this.uri=q,this.viewType=Ee}}e.$SL=Fn;class On{constructor(q){this.viewType=q}}e.$TL=On;class Nn{constructor(q,Ee){this.uri=q,this.notebookType=Ee}}e.$UL=Nn;class jn{constructor(q,Ee,Re){this.original=q,this.modified=Ee,this.notebookType=Re}}e.$VL=jn;class Un{constructor(){}}e.$WL=Un;class zn{constructor(q,Ee){this.uri=q,this.inputBoxUri=Ee}}e.$XL=zn;var kn;(function(K){K[K.Up=1]="Up",K[K.Down=2]="Down"})(kn||(e.InteractiveSessionVoteDirection=kn={}));var Sn;(function(K){K[K.Action=1]="Action",K[K.Toolbar=2]="Toolbar"})(Sn||(e.InteractiveSessionCopyKind=Sn={}));var Dn;(function(K){K[K.Unhelpful=0]="Unhelpful",K[K.Helpful=1]="Helpful",K[K.Undone=2]="Undone",K[K.Accepted=3]="Accepted"})(Dn||(e.InteractiveEditorResponseFeedbackKind=Dn={}));var Cn;(function(K){K[K.System=0]="System",K[K.User=1]="User",K[K.Assistant=2]="Assistant",K[K.Function=3]="Function"})(Cn||(e.ChatMessageRole=Cn={}));var In;(function(K){K[K.Short=1]="Short",K[K.Medium=2]="Medium",K[K.Full=3]="Full"})(In||(e.ChatVariableLevel=In={}));class Bn{constructor(q,Ee){this.role=q,this.content=Ee}}e.$YL=Bn;var Pn;(function(K){K[K.SymbolInformation=1]="SymbolInformation",K[K.CommandInformation=2]="CommandInformation",K[K.SearchInformation=3]="SearchInformation",K[K.SettingInformation=4]="SettingInformation"})(Pn||(e.RelatedInformationType=Pn={}))}),define(Se[142],De([1,0,57,17,16,177,128,7,19]),function(ne,e,y,M,l,R,A,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bM=e.$aM=e.$_L=void 0;const $=new Map;function P(D,E){E?$.set(D,E):$.delete(D)}e.$_L=P;function C(D){return $.get(D)}class v extends R.$Ou{constructor(E,s,c,u,o,g,d,t){super(s,c,u,o),this.c=E,this.m=g,this.q=d,this.notebook=t,this.b=!1}dispose(){(0,y.ok)(!this.b),this.b=!0,this.q=!1}equalLines(E){return(0,k.$sb)(this.f,E)}get document(){if(!this.a){const E=this;this.a={get uri(){return E.d},get fileName(){return E.d.fsPath},get isUntitled(){return E.d.scheme===M.Schemas.untitled},get languageId(){return E.m},get version(){return E.h},get isClosed(){return E.b},get isDirty(){return E.q},save(){return E.r()},getText(s){return s?E.s(s):E.getText()},get eol(){return E.g===`
`?m.EndOfLine.LF:m.EndOfLine.CRLF},get lineCount(){return E.f.length},lineAt(s){return E.t(s)},offsetAt(s){return E.u(s)},positionAt(s){return E.v(s)},validateRange(s){return E.w(s)},validatePosition(s){return E.x(s)},getWordRangeAtPosition(s,c){return E.y(s,c)}}}return Object.freeze(this.a)}_acceptLanguageId(E){(0,y.ok)(!this.b),this.m=E}_acceptIsDirty(E){(0,y.ok)(!this.b),this.q=E}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(E){const s=this.w(E);if(s.isEmpty)return"";if(s.isSingleLine)return this.f[s.start.line].substring(s.start.character,s.end.character);const c=this.g,u=s.start.line,o=s.end.line,g=[];g.push(this.f[u].substring(s.start.character));for(let d=u+1;d<o;d++)g.push(this.f[d]);return g.push(this.f[o].substring(0,s.end.character)),g.join(c)}t(E){let s;if(E instanceof m.$_J?s=E.line:typeof E=="number"&&(s=E),typeof s!="number"||s<0||s>=this.f.length||Math.floor(s)!==s)throw new Error("Illegal value for `line`");return new S(s,this.f[s],s===this.f.length-1)}u(E){return E=this.x(E),this.l(),this.j.getPrefixSum(E.line-1)+E.character}v(E){E=Math.floor(E),E=Math.max(0,E),this.l();const s=this.j.getIndexOf(E),c=this.f[s.index].length;return new m.$_J(s.index,Math.min(s.remainder,c))}w(E){if(!(E instanceof m.$aK))throw new Error("Invalid argument");const s=this.x(E.start),c=this.x(E.end);return s===E.start&&c===E.end?E:new m.$aK(s.line,s.character,c.line,c.character)}x(E){if(!(E instanceof m.$_J))throw new Error("Invalid argument");if(this.f.length===0)return E.with(0,0);let{line:s,character:c}=E,u=!1;if(s<0)s=0,c=0,u=!0;else if(s>=this.f.length)s=this.f.length-1,c=this.f[s].length,u=!0;else{const o=this.f[s].length;c<0?(c=0,u=!0):c>o&&(c=o,u=!0)}return u?new m.$_J(s,c):E}y(E,s){const c=this.x(E);if(!s)s=C(this.m);else if((0,l.$Me)(s))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${s.source}' because it matches the empty string.`);const u=(0,A.$2r)(c.character+1,(0,A.$Zr)(s),this.f[c.line],0);if(u)return new m.$aK(c.line,u.startColumn-1,c.line,u.endColumn-1)}}e.$aM=v;class S{constructor(E,s,c){this.a=E,this.b=s,this.c=c}get lineNumber(){return this.a}get text(){return this.b}get range(){return new m.$aK(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new m.$aK(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$bM=S}),define(Se[273],De([1,0,7,20,4]),function(ne,e,y,M,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0cc=void 0;let R=class{constructor(m){this.a=new y.$uL(y.ColorThemeKind.Dark),this.b=new l.$Ld}get activeColorTheme(){return this.a}$onColorThemeChange(m){let k;switch(m){case"light":k=y.ColorThemeKind.Light;break;case"hcDark":k=y.ColorThemeKind.HighContrast;break;case"hcLight":k=y.ColorThemeKind.HighContrastLight;break;default:k=y.ColorThemeKind.Dark}this.a=new y.$uL(k),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$0cc=R,e.$0cc=R=Ke([We(0,M.$0L)],R)}),define(Se[274],De([1,0,5]),function(ne,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mI=e.CellExecutionUpdateType=void 0;var M;(function(l){l[l.Output=1]="Output",l[l.OutputItems=2]="OutputItems",l[l.ExecutionState=3]="ExecutionState"})(M||(e.CellExecutionUpdateType=M={})),e.$mI=(0,y.$Lh)("INotebookExecutionService")}),define(Se[68],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2I=e.TestPosition=e.TestIdPathParts=void 0;var y;(function(R){R.Delimiter="\0"})(y||(e.TestIdPathParts=y={}));var M;(function(R){R[R.IsSame=0]="IsSame",R[R.Disconnected=1]="Disconnected",R[R.IsChild=2]="IsChild",R[R.IsParent=3]="IsParent"})(M||(e.TestPosition=M={}));class l{static fromExtHostTestItem(A,m,k=A.parent){if(A._isRoot)return new l([m]);const $=[A.id];for(let P=k;P&&P.id!==m;P=P.parent)$.push(P.id);return $.push(m),new l($.reverse())}static isRoot(A){return!A.includes("\0")}static root(A){const m=A.indexOf("\0");return m===-1?A:A.slice(0,m)}static fromString(A){return new l(A.split("\0"))}static join(A,m){return new l([...A.path,m])}static joinToString(A,m){return A.toString()+"\0"+m}static parentId(A){const m=A.lastIndexOf("\0");return m===-1?void 0:A.slice(0,m)}static localId(A){const m=A.lastIndexOf("\0");return m===-1?A:A.slice(m+1)}static isChild(A,m){return m.startsWith(A)&&m[A.length]==="\0"}static compare(A,m){return A===m?0:l.isChild(A,m)?2:l.isChild(m,A)?3:1}constructor(A,m=A.length){if(this.path=A,this.d=m,A.length===0||m<1)throw new Error("cannot create test with empty path")}get rootId(){return new l(this.path,1)}get parentId(){return this.d>1?new l(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let A=1;A<=this.d;A++)yield new l(this.path,A)}*idsToRoot(){for(let A=this.d;A>0;A--)yield new l(this.path,A)}compare(A){if(typeof A=="string")return l.compare(this.toString(),A);for(let m=0;m<A.d&&m<this.d;m++)if(A.path[m]!==this.path[m])return 1;return A.d>this.d?2:A.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let A=1;A<this.d;A++)this.c+="\0",this.c+=this.path[A]}return this.c}}e.$2I=l}),define(Se[88],De([1,0,2,35,68]),function(ne,e,y,M,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9I=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.$8I=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$7I=e.$6I=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$5I=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$4I=e.$3I=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var R;(function(I){I[I.Unset=0]="Unset",I[I.Queued=1]="Queued",I[I.Running=2]="Running",I[I.Passed=3]="Passed",I[I.Failed=4]="Failed",I[I.Skipped=5]="Skipped",I[I.Errored=6]="Errored"})(R||(e.TestResultState=R={}));var A;(function(I){I[I.Run=1]="Run",I[I.Debug=2]="Debug",I[I.Coverage=3]="Coverage"})(A||(e.ExtTestRunProfileKind=A={}));var m;(function(I){I[I.Run=2]="Run",I[I.Debug=4]="Debug",I[I.Coverage=8]="Coverage",I[I.HasNonDefaultProfile=16]="HasNonDefaultProfile",I[I.HasConfigurable=32]="HasConfigurable",I[I.SupportsContinuousRun=64]="SupportsContinuousRun"})(m||(e.TestRunProfileBitset=m={})),e.$3I=[2,4,8,16,32,64];const k=I=>"runId"in I;e.$4I=k;var $;(function(I){I.serialize=w=>({range:w.range.toJSON(),uri:w.uri.toJSON()}),I.deserialize=w=>({range:M.$ms.lift(w.range),uri:y.URI.revive(w.uri)})})($||(e.IRichLocation=$={}));var P;(function(I){I[I.Error=0]="Error",I[I.Output=1]="Output"})(P||(e.TestMessageType=P={}));var C;(function(I){I.serialize=w=>({message:w.message,type:0,expected:w.expected,actual:w.actual,contextValue:w.contextValue,location:w.location&&$.serialize(w.location)}),I.deserialize=w=>({message:w.message,type:0,expected:w.expected,actual:w.actual,contextValue:w.contextValue,location:w.location&&$.deserialize(w.location)})})(C||(e.ITestErrorMessage=C={}));const v=(I,w)=>`${w?"s":"e"}${I}`;e.$5I=v;var S;(function(I){I.serialize=w=>({message:w.message,type:1,offset:w.offset,length:w.length,location:w.location&&$.serialize(w.location)}),I.deserialize=w=>({message:w.message,type:1,offset:w.offset,length:w.length,location:w.location&&$.deserialize(w.location)})})(S||(e.ITestOutputMessage=S={}));var D;(function(I){I.serialize=w=>w.type===0?C.serialize(w):S.serialize(w),I.deserialize=w=>w.type===0?C.deserialize(w):S.deserialize(w)})(D||(e.ITestMessage=D={}));var E;(function(I){I.serializeWithoutMessages=w=>({state:w.state,duration:w.duration,messages:[]}),I.serialize=w=>({state:w.state,duration:w.duration,messages:w.messages.map(D.serialize)}),I.deserialize=w=>({state:w.state,duration:w.duration,messages:w.messages.map(D.deserialize)})})(E||(e.ITestTaskState=E={}));const s="\0",c=(I,w)=>I+s+w;e.$6I=c;const u=I=>{const w=I.indexOf(s);return{ctrlId:I.slice(0,w),tagId:I.slice(w+1)}};e.$7I=u;var o;(function(I){I.serialize=w=>({extId:w.extId,label:w.label,tags:w.tags,busy:w.busy,children:void 0,uri:w.uri?.toJSON(),range:w.range?.toJSON()||null,description:w.description,error:w.error,sortText:w.sortText}),I.deserialize=w=>({extId:w.extId,label:w.label,tags:w.tags,busy:w.busy,children:void 0,uri:w.uri?y.URI.revive(w.uri):void 0,range:w.range?M.$ms.lift(w.range):null,description:w.description,error:w.error,sortText:w.sortText})})(o||(e.ITestItem=o={}));var g;(function(I){I[I.NotExpandable=0]="NotExpandable",I[I.Expandable=1]="Expandable",I[I.BusyExpanding=2]="BusyExpanding",I[I.Expanded=3]="Expanded"})(g||(e.TestItemExpandState=g={}));var d;(function(I){I.serialize=w=>({expand:w.expand,item:o.serialize(w.item)}),I.deserialize=w=>({controllerId:l.$2I.root(w.item.extId),expand:w.expand,item:o.deserialize(w.item)})})(d||(e.InternalTestItem=d={}));var t;(function(I){I.serialize=w=>{let f;return w.item&&(f={},w.item.label!==void 0&&(f.label=w.item.label),w.item.tags!==void 0&&(f.tags=w.item.tags),w.item.busy!==void 0&&(f.busy=w.item.busy),w.item.uri!==void 0&&(f.uri=w.item.uri?.toJSON()),w.item.range!==void 0&&(f.range=w.item.range?.toJSON()),w.item.description!==void 0&&(f.description=w.item.description),w.item.error!==void 0&&(f.error=w.item.error),w.item.sortText!==void 0&&(f.sortText=w.item.sortText)),{extId:w.extId,expand:w.expand,item:f}},I.deserialize=w=>{let f;return w.item&&(f={},w.item.label!==void 0&&(f.label=w.item.label),w.item.tags!==void 0&&(f.tags=w.item.tags),w.item.busy!==void 0&&(f.busy=w.item.busy),w.item.range!==void 0&&(f.range=w.item.range?M.$ms.lift(w.item.range):null),w.item.description!==void 0&&(f.description=w.item.description),w.item.error!==void 0&&(f.error=w.item.error),w.item.sortText!==void 0&&(f.sortText=w.item.sortText)),{extId:w.extId,expand:w.expand,item:f}}})(t||(e.ITestItemUpdate=t={}));const n=(I,w)=>{w.expand!==void 0&&(I.expand=w.expand),w.item!==void 0&&(I.item=I.item?Object.assign(I.item,w.item):w.item)};e.$8I=n;var r;(function(I){I.serializeWithoutMessages=w=>({...d.serialize(w),ownComputedState:w.ownComputedState,computedState:w.computedState,tasks:w.tasks.map(E.serializeWithoutMessages)}),I.serialize=w=>({...d.serialize(w),ownComputedState:w.ownComputedState,computedState:w.computedState,tasks:w.tasks.map(E.serialize)}),I.deserialize=w=>({...d.deserialize(w),ownComputedState:w.ownComputedState,computedState:w.computedState,tasks:w.tasks.map(E.deserialize),retired:!0})})(r||(e.TestResultItem=r={}));var i;(function(I){I[I.Function=0]="Function",I[I.Statement=1]="Statement"})(i||(e.DetailType=i={}));var a;(function(I){I[I.Add=0]="Add",I[I.Update=1]="Update",I[I.DocumentSynced=2]="DocumentSynced",I[I.Remove=3]="Remove",I[I.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",I[I.Retire=5]="Retire",I[I.AddTag=6]="AddTag",I[I.RemoveTag=7]="RemoveTag"})(a||(e.TestDiffOpType=a={}));var h;(function(I){I.deserialize=w=>w.op===0?{op:w.op,item:d.deserialize(w.item)}:w.op===1?{op:w.op,item:t.deserialize(w.item)}:w.op===2?{op:w.op,uri:y.URI.revive(w.uri),docv:w.docv}:w,I.serialize=w=>w.op===0?{op:w.op,item:d.serialize(w.item)}:w.op===1?{op:w.op,item:t.serialize(w.item)}:w})(h||(e.TestsDiffOp=h={}));class p{constructor(){this.d=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.d}apply(w){const f=this.p();for(const b of w)switch(b.op){case 0:this.k(d.deserialize(b.item),f);break;case 1:this.l(t.deserialize(b.item),f);break;case 3:this.m(b.itemId,f);break;case 5:this.o(b.itemId);break;case 4:this.updatePendingRoots(b.amount);break;case 6:this.d.set(b.tag.id,b.tag);break;case 7:this.d.delete(b.id);break}f.complete?.()}k(w,f){const b=l.$2I.parentId(w.item.extId)?.toString();let L;if(!b)L=this.q(w),this.g.add(L),this.f.set(w.item.extId,L);else if(this.f.has(b)){const O=this.f.get(b);O.children.add(w.item.extId),L=this.q(w,O),this.f.set(w.item.extId,L)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(w)}`);return}return f.add?.(L),w.expand===2&&this.h++,L}l(w,f){const b=this.f.get(w.extId);if(b)return w.expand!==void 0&&(b.expand===2&&this.h--,w.expand===2&&this.h++),(0,e.$8I)(b,w),f.update?.(b),b}m(w,f){const b=this.f.get(w);if(!b)return;const L=l.$2I.parentId(b.item.extId)?.toString();L?this.f.get(L).children.delete(b.item.extId):this.g.delete(b);const O=[[w]];for(;O.length;)for(const T of O.pop()){const F=this.f.get(T);F&&(O.push(F.children),this.f.delete(T),f.remove?.(F,F!==b),F.expand===2&&this.h--)}}o(w){}updatePendingRoots(w){this.j+=w}p(){return{}}}e.$9I=p}),define(Se[110],De([1,0,9,4,3,57,88,68]),function(ne,e,y,M,l,R,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4L=e.$3L=e.$2L=e.$1L=e.$ZL=e.TestItemEventOp=void 0;var k;(function(u){u[u.Upsert=0]="Upsert",u[u.SetTags=1]="SetTags",u[u.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",u[u.RemoveChild=3]="RemoveChild",u[u.SetProp=4]="SetProp",u[u.Bulk=5]="Bulk",u[u.DocumentSynced=6]="DocumentSynced"})(k||(e.TestItemEventOp=k={}));const $=(u,o)=>u===o,C=Object.entries({range:(u,o)=>u===o?!0:!u||!o?!1:u.equalsRange(o),busy:$,label:$,description:$,error:$,sortText:$,tags:(u,o)=>!(u.length!==o.length||u.some(g=>!o.includes(g)))}),v=(u,o)=>{let g;for(const[d,t]of C)t(u[d],o[d])||(g?g[d]=o[d]:g={[d]:o[d]});return g};class S extends l.$Qc{get root(){return this.s.root}constructor(o){super(),this.s=o,this.f=this.B(new y.$3g(()=>this.flushDiff(),200)),this.g=this.B(new M.$Ld),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.y(this.root,void 0)}set resolveHandler(o){this.h=o;for(const g of this.tree.values())this.I(g)}get resolveHandler(){return this.h}collectDiff(){const o=this.m;return this.m=[],o}pushDiff(o){switch(o.op){case 2:{for(const g of this.m)if(g.op===2&&g.uri===o.uri){g.docv=o.docv;return}break}case 1:{const g=this.m[this.m.length-1];if(g){if(g.op===1&&g.item.extId===o.item.extId){(0,A.$8I)(g.item,o.item);return}if(g.op===0&&g.item.item.extId===o.item.extId){(0,A.$8I)(g.item,o.item);return}}break}}this.m.push(o),this.f.isScheduled()||this.f.schedule()}expand(o,g){const d=this.tree.get(o);if(d){if((d.expandLevels===void 0||g>d.expandLevels)&&(d.expandLevels=g),d.expand===1){const t=this.L(d);return t.isOpen()?this.J(d,g-1):t.wait().then(()=>this.J(d,g-1))}else if(d.expand===3)return d.resolveBarrier?.isOpen()===!1?d.resolveBarrier.wait().then(()=>this.J(d,g-1)):this.J(d,g-1)}}dispose(){for(const o of this.tree.values())this.s.getApiFor(o.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}u(o,g){switch(g.op){case 3:this.N(m.$2I.joinToString(o.fullId,g.id));break;case 0:this.y(g.item,o);break;case 5:for(const d of g.ops)this.u(o,d);break;case 1:this.z(g.new,g.old,o.fullId.toString());break;case 2:this.I(o);break;case 4:this.pushDiff({op:1,item:{extId:o.fullId.toString(),item:g.update}});break;case 6:this.w(o.actual.uri);break;default:(0,R.$2c)(g)}}w(o){o&&this.pushDiff({op:2,uri:o,docv:this.s.getDocumentVersion(o)})}y(o,g){const d=m.$2I.fromExtHostTestItem(o,this.root.id,g?.actual),t=this.s.getApiFor(o);t.parent&&t.parent!==g?.actual&&this.s.getChildren(t.parent).delete(o.id);let n=this.tree.get(d.toString());if(!n){n={fullId:d,actual:o,expandLevels:g?.expandLevels?g.expandLevels-1:void 0,expand:0},o.tags.forEach(this.C,this),this.tree.set(n.fullId.toString(),n),this.F(o,g),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:n.expand,item:this.s.toITestItem(o)}}),this.H(o,n,g);return}if(n.actual===o){this.G(o,n,g);return}if(n.actual.uri?.toString()!==o.uri?.toString())return this.N(d.toString()),this.y(o,g);const r=this.s.getChildren(n.actual),i=n.actual,a=v(this.s.toITestItem(i),this.s.toITestItem(o));this.s.getApiFor(i).listener=void 0,n.actual=o,n.expand=0,a&&(a.hasOwnProperty("tags")&&(this.z(o.tags,i.tags,d.toString()),delete a.tags),this.u(n,{op:4,update:a})),this.H(o,n,g);for(const[h,p]of r)this.s.getChildren(o).get(p.id)||this.N(m.$2I.joinToString(d,p.id));this.w(n.actual.uri)}z(o,g,d){const t=new Set(g.map(n=>n.id));for(const n of o)t.delete(n.id)||this.C(n);this.pushDiff({op:1,item:{extId:d,item:{tags:o.map(n=>(0,A.$6I)(this.s.controllerId,n.id))}}}),t.forEach(this.D,this)}C(o){const g=this.j.get(o.id);g?g.refCount++:(this.j.set(o.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,A.$6I)(this.s.controllerId,o.id)}}))}D(o){const g=this.j.get(o);g&&!--g.refCount&&(this.j.delete(o),this.pushDiff({op:7,id:(0,A.$6I)(this.s.controllerId,o)}))}F(o,g){this.s.getApiFor(o).parent=g&&g.actual!==this.root?g.actual:void 0}G(o,g,d){this.F(o,d);const t=this.s.getApiFor(o);t.parent=d?.actual,t.listener=n=>this.u(g,n),this.I(g)}H(o,g,d){this.G(o,g,d);for(const[t,n]of this.s.getChildren(o))this.y(n,g)}I(o){let g;this.h?o.resolveBarrier?g=o.resolveBarrier.isOpen()?3:2:g=o.actual.canResolveChildren?1:0:g=0,g!==o.expand&&(o.expand=g,this.pushDiff({op:1,item:{extId:o.fullId.toString(),expand:g}}),g===1&&o.expandLevels!==void 0&&this.L(o))}J(o,g){if(g<0)return;const d=[];for(const[t,n]of this.s.getChildren(o.actual)){const r=this.expand(m.$2I.joinToString(o.fullId,n.id),g);(0,y.$Dg)(r)&&d.push(r)}if(d.length)return Promise.all(d).then(()=>{})}L(o){if(o.resolveBarrier)return o.resolveBarrier;if(!this.h){const n=new y.$Pg;return n.open(),n}o.expand=2,this.M(o);const g=o.resolveBarrier=new y.$Pg,d=n=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,n)};let t;try{t=this.h(o.actual===this.root?void 0:o.actual)}catch(n){d(n)}return(0,y.$Dg)(t)?t.catch(d).then(()=>{g.open(),this.I(o)}):(g.open(),this.I(o)),o.resolveBarrier}M(o){this.pushDiff({op:1,item:{extId:o.fullId.toString(),expand:o.expand}})}N(o){const g=this.tree.get(o);if(!g)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:o});const d=[g];for(;d.length;){const t=d.pop();if(t){this.s.getApiFor(t.actual).listener=void 0;for(const n of t.actual.tags)this.D(n.id);this.tree.delete(t.fullId.toString());for(const[n,r]of this.s.getChildren(t.actual))d.push(this.tree.get(m.$2I.joinToString(t.fullId,r.id)))}}}flushDiff(){const o=this.collectDiff();o.length&&this.g.fire(o)}}e.$ZL=S;class D extends Error{constructor(o){super(`Attempted to insert a duplicate test item ID ${o}`)}}e.$1L=D;class E extends Error{constructor(o){super(`TestItem with ID "${o}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$2L=E;class s extends Error{constructor(o,g,d){super(`TestItem with ID "${o}" is from controller "${g}" and cannot be added as a child of an item from controller "${d}".`)}}e.$3L=s;const c=(u,o,g)=>{let d=new Map;return{get size(){return d.size},forEach(t,n){for(const r of d.values())t.call(n,r,this)},[Symbol.iterator](){return d.entries()},replace(t){const n=new Map,r=new Set(d.keys()),i={op:5,ops:[]};for(const a of t){if(!(a instanceof g))throw new E(a.id);const h=o(a).controllerId;if(h!==u.controllerId)throw new s(a.id,h,u.controllerId);if(n.has(a.id))throw new D(a.id);n.set(a.id,a),r.delete(a.id),i.ops.push({op:0,item:a})}for(const a of r.keys())i.ops.push({op:3,id:a});u.listener?.(i),d=n},add(t){if(!(t instanceof g))throw new E(t.id);d.set(t.id,t),u.listener?.({op:0,item:t})},delete(t){d.delete(t)&&u.listener?.({op:3,id:t})},get(t){return d.get(t)},toJSON(){return Array.from(d.values())}}};e.$4L=c}),define(Se[143],De([1,0,110]),function(ne,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6L=e.$5L=void 0;const M=new WeakMap,l=(A,m)=>{const k={controllerId:m};return M.set(A,k),k};e.$5L=l;const R=A=>{const m=M.get(A);if(!m)throw new y.$2L(A?.id||"<unknown>");return m};e.$6L=R}),define(Se[111],De([1,0,17,2]),function(ne,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zob=e.$Yob=e.$Xob=e.$Wob=e.$Vob=void 0,e.$Vob="vscode-cdn.net",e.$Wob=`vscode-resource.${e.$Vob}`,e.$Xob=`'self' https://*.${e.$Vob}`;function l(m,k){return m.scheme===y.Schemas.http||m.scheme===y.Schemas.https?m:(k&&k.authority&&k.isRemote&&m.scheme===y.Schemas.file&&(m=M.URI.from({scheme:y.Schemas.vscodeRemote,authority:k.authority,path:m.path})),M.URI.from({scheme:y.Schemas.https,authority:`${m.scheme}+${R(m.authority)}.${e.$Wob}`,path:m.path,fragment:m.fragment,query:m.query}))}e.$Yob=l;function R(m){return m.replace(/./g,k=>{const $=k.charCodeAt(0);return $>=97&&$<=122||$>=65&&$<=90||$>=48&&$<=57?k:"-"+$.toString(16).padStart(4,"0")})}function A(m){return m.replace(/-([0-9a-f]{4})/g,(k,$)=>String.fromCharCode(parseInt($,16)))}e.$Zob=A}),define(Se[275],De([1,0,4,3,111]),function(ne,e,y,M,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hcc=void 0;class R{constructor(m,k,$){this.d=m,this.e=k,this.f=$,this.a=0,this.b=new M.$Pc,this.c=new Map,this.b.add(k.onDidChangeVisibleTextEditors(()=>{const P=k.getVisibleTextEditors();for(const C of this.c.values())P.indexOf(C.editor)<0&&C.inset.dispose()}))}dispose(){this.c.forEach(m=>m.inset.dispose()),this.b.dispose()}createWebviewEditorInset(m,k,$,P,C){let v;for(const o of this.e.getVisibleTextEditors(!0))if(o.value===m){v=o;break}if(!v)throw new Error("not a visible editor");const S=this,D=this.a++,E=new y.$Ld,s=new y.$Ld,c=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(o){return(0,l.$Yob)(o,S.f)}get cspSource(){return l.$Xob}set options(o){this.b=o,S.d.$setOptions(D,o)}get options(){return this.b}set html(o){this.a=o,S.d.$setHtml(D,o)}get html(){return this.a}get onDidReceiveMessage(){return E.event}postMessage(o){return S.d.$postMessage(D,o)}},u=new class{constructor(){this.editor=m,this.line=k,this.height=$,this.webview=c,this.onDidDispose=s.event}dispose(){S.c.has(D)&&(S.c.delete(D),S.d.$disposeEditorInset(D),s.fire(),s.dispose(),E.dispose())}};return this.d.$createEditorInset(D,v.id,v.value.document.uri,k+1,$,P||{},C.identifier,C.extensionLocation),this.c.set(D,{editor:m,inset:u,onDidReceiveMessage:E}),u}$onDidDispose(m){const k=this.c.get(m);k&&k.inset.dispose()}$onDidReceiveMessage(m,k){this.c.get(m)?.onDidReceiveMessage.fire(k)}}e.$Hcc=R}),define(Se[276],De([1,0,5]),function(ne,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WM=e.VariableKind=e.$VM=void 0,e.$VM=(0,y.$Lh)("configurationResolverService");var M;(function(R){R.Unknown="unknown",R.Env="env",R.Config="config",R.Command="command",R.Input="input",R.ExtensionInstallFolder="extensionInstallFolder",R.WorkspaceFolder="workspaceFolder",R.Cwd="cwd",R.WorkspaceFolderBasename="workspaceFolderBasename",R.UserHome="userHome",R.LineNumber="lineNumber",R.SelectedText="selectedText",R.File="file",R.FileWorkspaceFolder="fileWorkspaceFolder",R.RelativeFile="relativeFile",R.RelativeFileDirname="relativeFileDirname",R.FileDirname="fileDirname",R.FileExtname="fileExtname",R.FileBasename="fileBasename",R.FileBasenameNoExtension="fileBasenameNoExtension",R.FileDirnameBasename="fileDirnameBasename",R.ExecPath="execPath",R.ExecInstallFolder="execInstallFolder",R.PathSeparator="pathSeparator"})(M||(e.VariableKind=M={}));class l extends Error{constructor(A,m){super(m),this.variable=A}}e.$WM=l}),define(Se[277],De([1,0,15,46,18,23,10,100,223,276,16]),function(ne,e,y,M,l,R,A,m,k,$,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$M=void 0;class C{constructor(S,D,E,s){this.h=new Map,this.a=S,this.b=D,this.g=E,s&&(this.c=s.then(c=>this.i(c)))}i(S){if(A.$d){const D=Object.create(null);return Object.keys(S).forEach(E=>{D[E.toLowerCase()]=S[E]}),D}return S}resolveWithEnvironment(S,D,E){return this.l({env:this.i(S),userHome:void 0},D?D.uri:void 0,E)}async resolveAsync(S,D){const E={env:await this.c,userHome:await this.g};return this.l(E,S?S.uri:void 0,D)}async j(S,D,E,s){const c=R.$Xm(D);A.$d&&c.windows?Object.keys(c.windows).forEach(o=>c[o]=c.windows[o]):A.$e&&c.osx?Object.keys(c.osx).forEach(o=>c[o]=c.osx[o]):A.$f&&c.linux&&Object.keys(c.linux).forEach(o=>c[o]=c.linux[o]),delete c.windows,delete c.osx,delete c.linux;const u={env:await this.c,userHome:await this.g};return this.l(u,S?S.uri:void 0,c,E,s)}async resolveAnyAsync(S,D,E){return this.j(S,D,E)}async resolveAnyMap(S,D,E){const s=new Map;return{newConfig:await this.j(S,D,E,s),resolvedVariables:s}}resolveWithInteractionReplace(S,D,E,s){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(S,D,E,s){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(S,D){if(this.h.has(S))throw new Error("Variable "+S+" is contributed twice.");this.h.set(S,D)}async l(S,D,E,s,c){if(l.$wf(E))return this.m(S,D,E,s,c);if(Array.isArray(E))return Promise.all(E.map(u=>this.l(S,D,u,s,c)));if(l.$yf(E)){const u=Object.create(null),o=await Promise.all(Object.keys(E).map(async g=>[await this.m(S,D,g,s,c),await this.l(S,D,E[g],s,c)]));for(const[g,d]of o)u[g]=d;return u}return E}m(S,D,E,s,c){return(0,P.$Re)(E,C.VARIABLE_REGEXP,async(u,o)=>{if(o.includes(C.VARIABLE_LHS))return u;let g=await this.o(S,u,o,D,s);return c?.set(o,g),g!==u&&l.$wf(g)&&g.match(C.VARIABLE_REGEXP)&&(g=await this.m(S,D,g,s,c)),g})}n(S){return this.b?this.b.getUriLabel(S,{noPrefix:!0}):S.fsPath}async o(S,D,E,s,c){let u;const o=E.split(":");o.length>1&&(E=o[0],u=o[1]);const g=n=>{const r=this.a.getFilePath();if(r)return(0,m.$kv)(r);throw new $.$WM(n,(0,k.localize)(0,null,D))},d=n=>{const r=g(n);if(this.a.getWorkspaceFolderPathForFile){const i=this.a.getWorkspaceFolderPathForFile();if(i)return(0,m.$kv)(i)}throw new $.$WM(n,(0,k.localize)(1,null,D,y.$lc(r)))},t=n=>{if(u){const r=this.a.getFolderUri(u);if(r)return r;throw new $.$WM(n,(0,k.localize)(2,null,D,u))}if(s)return s;throw this.a.getWorkspaceFolderCount()>1?new $.$WM(n,(0,k.localize)(3,null,D)):new $.$WM(n,(0,k.localize)(4,null,D))};switch(E){case"env":if(u){if(S.env){const n=S.env[A.$d?u.toLowerCase():u];if(l.$wf(n))return n}return""}throw new $.$WM($.VariableKind.Env,(0,k.localize)(5,null,D));case"config":if(u){const n=this.a.getConfigurationValue(s,u);if(l.$Ff(n))throw new $.$WM($.VariableKind.Config,(0,k.localize)(6,null,D,u));if(l.$yf(n))throw new $.$WM($.VariableKind.Config,(0,k.localize)(7,null,D,u));return n}throw new $.$WM($.VariableKind.Config,(0,k.localize)(8,null,D));case"command":return this.p($.VariableKind.Command,D,u,c,"command");case"input":return this.p($.VariableKind.Input,D,u,c,"input");case"extensionInstallFolder":if(u){const n=await this.a.getExtension(u);if(!n)throw new $.$WM($.VariableKind.ExtensionInstallFolder,(0,k.localize)(9,null,D,u));return this.n(n.extensionLocation)}throw new $.$WM($.VariableKind.ExtensionInstallFolder,(0,k.localize)(10,null,D));default:switch(E){case"workspaceRoot":case"workspaceFolder":return(0,m.$kv)(this.n(t($.VariableKind.WorkspaceFolder)));case"cwd":return s||u?(0,m.$kv)(this.n(t($.VariableKind.Cwd))):M.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,m.$kv)(y.$lc(this.n(t($.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(S.userHome)return S.userHome;throw new $.$WM($.VariableKind.UserHome,(0,k.localize)(11,null,D))}case"lineNumber":{const n=this.a.getLineNumber();if(n)return n;throw new $.$WM($.VariableKind.LineNumber,(0,k.localize)(12,null,D))}case"selectedText":{const n=this.a.getSelectedText();if(n)return n;throw new $.$WM($.VariableKind.SelectedText,(0,k.localize)(13,null,D))}case"file":return g($.VariableKind.File);case"fileWorkspaceFolder":return d($.VariableKind.FileWorkspaceFolder);case"relativeFile":return s||u?y.$jc(this.n(t($.VariableKind.RelativeFile)),g($.VariableKind.RelativeFile)):g($.VariableKind.RelativeFile);case"relativeFileDirname":{const n=y.$kc(g($.VariableKind.RelativeFileDirname));if(s||u){const r=y.$jc(this.n(t($.VariableKind.RelativeFileDirname)),n);return r.length===0?".":r}return n}case"fileDirname":return y.$kc(g($.VariableKind.FileDirname));case"fileExtname":return y.$mc(g($.VariableKind.FileExtname));case"fileBasename":return y.$lc(g($.VariableKind.FileBasename));case"fileBasenameNoExtension":{const n=y.$lc(g($.VariableKind.FileBasenameNoExtension));return n.slice(0,n.length-y.$mc(n).length)}case"fileDirnameBasename":return y.$lc(y.$kc(g($.VariableKind.FileDirnameBasename)));case"execPath":{const n=this.a.getExecPath();return n||D}case"execInstallFolder":{const n=this.a.getAppRoot();return n||D}case"pathSeparator":return y.sep;default:try{const n=u?`${E}:${u}`:E;return this.p($.VariableKind.Unknown,D,n,c,void 0)}catch{return D}}}}p(S,D,E,s,c){if(E&&s){const u=c===void 0?s[E]:s[c+":"+E];if(typeof u=="string")return u;throw new $.$WM(S,(0,k.localize)(14,null,D))}return D}}e.$$M=C,C.VARIABLE_LHS="${",C.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(Se[144],De([1,0,5,140]),function(ne,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_B=e.$$B=e.OpenEditorContext=e.GroupsOrder=e.$0B=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$9B=void 0,e.$9B=(0,y.$Lh)("editorGroupsService");var l;(function(D){D[D.UP=0]="UP",D[D.DOWN=1]="DOWN",D[D.LEFT=2]="LEFT",D[D.RIGHT=3]="RIGHT"})(l||(e.GroupDirection=l={}));var R;(function(D){D[D.HORIZONTAL=0]="HORIZONTAL",D[D.VERTICAL=1]="VERTICAL"})(R||(e.GroupOrientation=R={}));var A;(function(D){D[D.FIRST=0]="FIRST",D[D.LAST=1]="LAST",D[D.NEXT=2]="NEXT",D[D.PREVIOUS=3]="PREVIOUS"})(A||(e.GroupLocation=A={}));var m;(function(D){D[D.MAXIMIZE=0]="MAXIMIZE",D[D.EVEN=1]="EVEN",D[D.TOGGLE=2]="TOGGLE"})(m||(e.GroupsArrangement=m={}));var k;(function(D){D[D.COPY_EDITORS=0]="COPY_EDITORS",D[D.MOVE_EDITORS=1]="MOVE_EDITORS"})(k||(e.MergeGroupMode=k={}));function $(D){const E=D;return(0,M.$YD)(E?.editor)&&(0,M.$YD)(E?.replacement)}e.$0B=$;var P;(function(D){D[D.CREATION_TIME=0]="CREATION_TIME",D[D.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",D[D.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(P||(e.GroupsOrder=P={}));var C;(function(D){D[D.NEW_EDITOR=1]="NEW_EDITOR",D[D.MOVE_EDITOR=2]="MOVE_EDITOR",D[D.COPY_EDITOR=3]="COPY_EDITOR"})(C||(e.OpenEditorContext=C={}));function v(D){const E=D;return!!E&&typeof E.id=="number"&&Array.isArray(E.editors)}e.$$B=v;function S(D){return D.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.$_B=S}),define(Se[278],De([1,0,5,144]),function(ne,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dC=e.$cC=e.$bC=e.$aC=void 0,e.$aC=(0,y.$Lh)("editorService"),e.$bC=-1,e.$cC=-2;function l(R){const A=R;return typeof R=="number"||(0,M.$$B)(A)}e.$dC=l}),define(Se[13],De([1,0,19,22,165,75,80,28,159,60,97,23,18,2,35,83,134,143,140,109,68,88,278,7]),function(ne,e,y,M,l,R,A,m,k,$,P,C,v,S,D,E,s,c,u,o,g,d,t,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalQuickFix=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.ChatMessageRole=e.ChatMessage=e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.$9L=e.$8L=e.MarkdownString=e.$7L=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var r;(function(Me){function Te(re){const{selectionStartLineNumber:Oe,selectionStartColumn:qe,positionLineNumber:_e,positionColumn:Ge}=re,ot=new n.$_J(Oe-1,qe-1),pt=new n.$_J(_e-1,Ge-1);return new n.$bK(ot,pt)}Me.to=Te;function Pe(re){const{anchor:Oe,active:qe}=re;return{selectionStartLineNumber:Oe.line+1,selectionStartColumn:Oe.character+1,positionLineNumber:qe.line+1,positionColumn:qe.character+1}}Me.from=Pe})(r||(e.Selection=r={}));var i;(function(Me){function Te(re){if(!re)return;const{start:Oe,end:qe}=re;return{startLineNumber:Oe.line+1,startColumn:Oe.character+1,endLineNumber:qe.line+1,endColumn:qe.character+1}}Me.from=Te;function Pe(re){if(!re)return;const{startLineNumber:Oe,startColumn:qe,endLineNumber:_e,endColumn:Ge}=re;return new n.$aK(Oe-1,qe-1,_e-1,Ge-1)}Me.to=Pe})(i||(e.Range=i={}));var a;(function(Me){function Te(Pe){switch(Pe){case 1:return n.StandardTokenType.Comment;case 0:return n.StandardTokenType.Other;case 3:return n.StandardTokenType.RegEx;case 2:return n.StandardTokenType.String}}Me.to=Te})(a||(e.TokenType=a={}));var h;(function(Me){function Te(re){return new n.$_J(re.lineNumber-1,re.column-1)}Me.to=Te;function Pe(re){return{lineNumber:re.line+1,column:re.character+1}}Me.from=Pe})(h||(e.Position=h={}));var p;(function(Me){function Te(Oe,qe,_e){return(0,y.$Fb)((0,y.$1b)(Oe).map(Ge=>Pe(Ge,qe,_e)))}Me.from=Te;function Pe(Oe,qe,_e){if(typeof Oe=="string")return{$serialized:!0,language:Oe,isBuiltin:_e?.isBuiltin};if(Oe)return{$serialized:!0,language:Oe.language,scheme:re(Oe.scheme,qe),pattern:Je.from(Oe.pattern)??void 0,exclusive:Oe.exclusive,notebookType:Oe.notebookType,isBuiltin:_e?.isBuiltin}}function re(Oe,qe){return qe&&typeof Oe=="string"?qe.transformOutgoingScheme(Oe):Oe}})(p||(e.DocumentSelector=p={}));var I;(function(Me){function Te(re){switch(re){case n.DiagnosticTag.Unnecessary:return 1;case n.DiagnosticTag.Deprecated:return 2}}Me.from=Te;function Pe(re){switch(re){case 1:return n.DiagnosticTag.Unnecessary;case 2:return n.DiagnosticTag.Deprecated;default:return}}Me.to=Pe})(I||(e.DiagnosticTag=I={}));var w;(function(Me){function Te(re){let Oe;return re.code&&((0,v.$wf)(re.code)||(0,v.$Af)(re.code)?Oe=String(re.code):Oe={value:String(re.code.value),target:re.code.target}),{...i.from(re.range),message:re.message,source:re.source,code:Oe,severity:b.from(re.severity),relatedInformation:re.relatedInformation&&re.relatedInformation.map(f.from),tags:Array.isArray(re.tags)?(0,y.$Fb)(re.tags.map(I.from)):void 0}}Me.from=Te;function Pe(re){const Oe=new n.$mK(i.to(re),re.message,b.to(re.severity));return Oe.source=re.source,Oe.code=(0,v.$wf)(re.code)?re.code:re.code?.value,Oe.relatedInformation=re.relatedInformation&&re.relatedInformation.map(f.to),Oe.tags=re.tags&&(0,y.$Fb)(re.tags.map(I.to)),Oe}Me.to=Pe})(w||(e.Diagnostic=w={}));var f;(function(Me){function Te(re){return{...i.from(re.location.range),message:re.message,resource:re.location.uri}}Me.from=Te;function Pe(re){return new n.$lK(new n.$kK(re.resource,i.to(re)),re.message)}Me.to=Pe})(f||(e.DiagnosticRelatedInformation=f={}));var b;(function(Me){function Te(re){switch(re){case n.DiagnosticSeverity.Error:return s.MarkerSeverity.Error;case n.DiagnosticSeverity.Warning:return s.MarkerSeverity.Warning;case n.DiagnosticSeverity.Information:return s.MarkerSeverity.Info;case n.DiagnosticSeverity.Hint:return s.MarkerSeverity.Hint}return s.MarkerSeverity.Error}Me.from=Te;function Pe(re){switch(re){case s.MarkerSeverity.Info:return n.DiagnosticSeverity.Information;case s.MarkerSeverity.Warning:return n.DiagnosticSeverity.Warning;case s.MarkerSeverity.Error:return n.DiagnosticSeverity.Error;case s.MarkerSeverity.Hint:return n.DiagnosticSeverity.Hint;default:return n.DiagnosticSeverity.Error}}Me.to=Pe})(b||(e.DiagnosticSeverity=b={}));var L;(function(Me){function Te(re){return typeof re=="number"&&re>=n.ViewColumn.One?re-1:re===n.ViewColumn.Beside?t.$cC:t.$bC}Me.from=Te;function Pe(re){if(typeof re=="number"&&re>=0)return re+1;throw new Error("invalid 'EditorGroupColumn'")}Me.to=Pe})(L||(e.ViewColumn=L={}));function O(Me){return typeof Me.range<"u"}function T(Me){return Me.length===0?!0:!!O(Me[0])}e.$7L=T;var F;(function(Me){function Te(Ge){return Ge.map(Me.from)}Me.fromMany=Te;function Pe(Ge){return Ge&&typeof Ge=="object"&&typeof Ge.language=="string"&&typeof Ge.value=="string"}function re(Ge){let ot;if(Pe(Ge)){const{language:ut,value:bt}=Ge;ot={value:"```"+ut+`
`+bt+"\n```\n"}}else n.$yK.isMarkdownString(Ge)?ot={value:Ge.value,isTrusted:Ge.isTrusted,supportThemeIcons:Ge.supportThemeIcons,supportHtml:Ge.supportHtml,baseUri:Ge.baseUri}:typeof Ge=="string"?ot={value:Ge}:ot={value:""};const pt=Object.create(null);ot.uris=pt;const Mt=ut=>{try{let bt=S.URI.parse(ut,!0);bt=bt.with({query:Oe(bt.query,pt)}),pt[ut]=bt}catch{}return""},yt=new k.marked.Renderer;return yt.link=Mt,yt.image=ut=>typeof ut=="string"?Mt(A.$6j(ut).href):"",(0,k.marked)(ot.value,{renderer:yt}),ot}Me.from=re;function Oe(Ge,ot){if(!Ge)return Ge;let pt;try{pt=(0,$.$hh)(Ge)}catch{}if(!pt)return Ge;let Mt=!1;return pt=(0,C.$Zm)(pt,yt=>{if(S.URI.isUri(yt)){const ut=`__uri_${Math.random().toString(16).slice(2,8)}`;return ot[ut]=yt,Mt=!0,ut}else return}),Mt?JSON.stringify(pt):Ge}function qe(Ge){const ot=new n.$yK(Ge.value,Ge.supportThemeIcons);return ot.isTrusted=Ge.isTrusted,ot.supportHtml=Ge.supportHtml,ot.baseUri=Ge.baseUri?S.URI.from(Ge.baseUri):void 0,ot}Me.to=qe;function _e(Ge){if(Ge)return typeof Ge=="string"?Ge:Me.from(Ge)}Me.fromStrict=_e})(F||(e.MarkdownString=F={}));function U(Me){return T(Me)?Me.map(Te=>({range:i.from(Te.range),hoverMessage:Array.isArray(Te.hoverMessage)?F.fromMany(Te.hoverMessage):Te.hoverMessage?F.from(Te.hoverMessage):void 0,renderOptions:Te.renderOptions})):Me.map(Te=>({range:i.from(Te)}))}e.$8L=U;function N(Me){return typeof Me>"u"?Me:typeof Me=="string"?S.URI.file(Me):Me}e.$9L=N;var j;(function(Me){function Te(Pe){return typeof Pe>"u"?Pe:{contentText:Pe.contentText,contentIconPath:Pe.contentIconPath?N(Pe.contentIconPath):void 0,border:Pe.border,borderColor:Pe.borderColor,fontStyle:Pe.fontStyle,fontWeight:Pe.fontWeight,textDecoration:Pe.textDecoration,color:Pe.color,backgroundColor:Pe.backgroundColor,margin:Pe.margin,width:Pe.width,height:Pe.height}}Me.from=Te})(j||(e.ThemableDecorationAttachmentRenderOptions=j={}));var z;(function(Me){function Te(Pe){return typeof Pe>"u"?Pe:{backgroundColor:Pe.backgroundColor,outline:Pe.outline,outlineColor:Pe.outlineColor,outlineStyle:Pe.outlineStyle,outlineWidth:Pe.outlineWidth,border:Pe.border,borderColor:Pe.borderColor,borderRadius:Pe.borderRadius,borderSpacing:Pe.borderSpacing,borderStyle:Pe.borderStyle,borderWidth:Pe.borderWidth,fontStyle:Pe.fontStyle,fontWeight:Pe.fontWeight,textDecoration:Pe.textDecoration,cursor:Pe.cursor,color:Pe.color,opacity:Pe.opacity,letterSpacing:Pe.letterSpacing,gutterIconPath:Pe.gutterIconPath?N(Pe.gutterIconPath):void 0,gutterIconSize:Pe.gutterIconSize,overviewRulerColor:Pe.overviewRulerColor,before:Pe.before?j.from(Pe.before):void 0,after:Pe.after?j.from(Pe.after):void 0}}Me.from=Te})(z||(e.ThemableDecorationRenderOptions=z={}));var B;(function(Me){function Te(Pe){if(typeof Pe>"u")return Pe;switch(Pe){case n.DecorationRangeBehavior.OpenOpen:return 0;case n.DecorationRangeBehavior.ClosedClosed:return 1;case n.DecorationRangeBehavior.OpenClosed:return 2;case n.DecorationRangeBehavior.ClosedOpen:return 3}}Me.from=Te})(B||(e.DecorationRangeBehavior=B={}));var ae;(function(Me){function Te(Pe){return{isWholeLine:Pe.isWholeLine,rangeBehavior:Pe.rangeBehavior?B.from(Pe.rangeBehavior):void 0,overviewRulerLane:Pe.overviewRulerLane,light:Pe.light?z.from(Pe.light):void 0,dark:Pe.dark?z.from(Pe.dark):void 0,backgroundColor:Pe.backgroundColor,outline:Pe.outline,outlineColor:Pe.outlineColor,outlineStyle:Pe.outlineStyle,outlineWidth:Pe.outlineWidth,border:Pe.border,borderColor:Pe.borderColor,borderRadius:Pe.borderRadius,borderSpacing:Pe.borderSpacing,borderStyle:Pe.borderStyle,borderWidth:Pe.borderWidth,fontStyle:Pe.fontStyle,fontWeight:Pe.fontWeight,textDecoration:Pe.textDecoration,cursor:Pe.cursor,color:Pe.color,opacity:Pe.opacity,letterSpacing:Pe.letterSpacing,gutterIconPath:Pe.gutterIconPath?N(Pe.gutterIconPath):void 0,gutterIconSize:Pe.gutterIconSize,overviewRulerColor:Pe.overviewRulerColor,before:Pe.before?j.from(Pe.before):void 0,after:Pe.after?j.from(Pe.after):void 0}}Me.from=Te})(ae||(e.DecorationRenderOptions=ae={}));var X;(function(Me){function Te(re){return{text:re.newText,eol:re.newEol&&it.from(re.newEol),range:i.from(re.range)}}Me.from=Te;function Pe(re){const Oe=new n.$fK(i.to(re.range),re.text);return Oe.newEol=typeof re.eol>"u"?void 0:it.to(re.eol),Oe}Me.to=Pe})(X||(e.TextEdit=X={}));var Q;(function(Me){function Te(re,Oe){const qe={edits:[]};if(re instanceof n.$iK){const _e=new m.$zc;for(const Ge of re._allEntries())Ge._type===1&&S.URI.isUri(Ge.to)&&Ge.from===void 0&&_e.add(Ge.to);for(const Ge of re._allEntries())if(Ge._type===1){let ot;Ge.options?.contents&&(ArrayBuffer.isView(Ge.options.contents)?ot={type:"base64",value:(0,M.$te)(M.$_d.wrap(Ge.options.contents))}:ot={type:"dataTransferItem",id:Ge.options.contents._itemId}),qe.edits.push({oldResource:Ge.from,newResource:Ge.to,options:{...Ge.options,contents:ot},metadata:Ge.metadata})}else Ge._type===2?qe.edits.push({resource:Ge.uri,textEdit:X.from(Ge.edit),versionId:_e.has(Ge.uri)?void 0:Oe?.getTextDocumentVersion(Ge.uri),metadata:Ge.metadata}):Ge._type===6?qe.edits.push({resource:Ge.uri,textEdit:{range:i.from(Ge.range),text:Ge.edit.value,insertAsSnippet:!0},versionId:_e.has(Ge.uri)?void 0:Oe?.getTextDocumentVersion(Ge.uri),metadata:Ge.metadata}):Ge._type===3?qe.edits.push({metadata:Ge.metadata,resource:Ge.uri,cellEdit:Ge.edit,notebookMetadata:Ge.notebookMetadata,notebookVersionId:Oe?.getNotebookDocumentVersion(Ge.uri)}):Ge._type===5&&qe.edits.push({metadata:Ge.metadata,resource:Ge.uri,notebookVersionId:Oe?.getNotebookDocumentVersion(Ge.uri),cellEdit:{editType:1,index:Ge.index,count:Ge.count,cells:Ge.cells.map(lt.from)}})}return qe}Me.from=Te;function Pe(re){const Oe=new n.$iK,qe=new m.$yc;for(const _e of re.edits)if(_e.textEdit){const Ge=_e,ot=S.URI.revive(Ge.resource),pt=i.to(Ge.textEdit.range),Mt=Ge.textEdit.text,yt=Ge.textEdit.insertAsSnippet;let ut;yt?ut=n.$hK.replace(pt,new n.$jK(Mt)):ut=n.$fK.replace(pt,Mt);const bt=qe.get(ot);bt?bt.push(ut):qe.set(ot,[ut])}else Oe.renameFile(S.URI.revive(_e.oldResource),S.URI.revive(_e.newResource),_e.options);for(const[_e,Ge]of qe)Oe.set(_e,Ge);return Oe}Me.to=Pe})(Q||(e.WorkspaceEdit=Q={}));var H;(function(Me){const Te=Object.create(null);Te[n.SymbolKind.File]=0,Te[n.SymbolKind.Module]=1,Te[n.SymbolKind.Namespace]=2,Te[n.SymbolKind.Package]=3,Te[n.SymbolKind.Class]=4,Te[n.SymbolKind.Method]=5,Te[n.SymbolKind.Property]=6,Te[n.SymbolKind.Field]=7,Te[n.SymbolKind.Constructor]=8,Te[n.SymbolKind.Enum]=9,Te[n.SymbolKind.Interface]=10,Te[n.SymbolKind.Function]=11,Te[n.SymbolKind.Variable]=12,Te[n.SymbolKind.Constant]=13,Te[n.SymbolKind.String]=14,Te[n.SymbolKind.Number]=15,Te[n.SymbolKind.Boolean]=16,Te[n.SymbolKind.Array]=17,Te[n.SymbolKind.Object]=18,Te[n.SymbolKind.Key]=19,Te[n.SymbolKind.Null]=20,Te[n.SymbolKind.EnumMember]=21,Te[n.SymbolKind.Struct]=22,Te[n.SymbolKind.Event]=23,Te[n.SymbolKind.Operator]=24,Te[n.SymbolKind.TypeParameter]=25;function Pe(Oe){return typeof Te[Oe]=="number"?Te[Oe]:6}Me.from=Pe;function re(Oe){for(const qe in Te)if(Te[qe]===Oe)return Number(qe);return n.SymbolKind.Property}Me.to=re})(H||(e.SymbolKind=H={}));var te;(function(Me){function Te(re){switch(re){case n.SymbolTag.Deprecated:return 1}}Me.from=Te;function Pe(re){switch(re){case 1:return n.SymbolTag.Deprecated}}Me.to=Pe})(te||(e.SymbolTag=te={}));var me;(function(Me){function Te(re){return{name:re.name,kind:H.from(re.kind),tags:re.tags&&re.tags.map(te.from),containerName:re.containerName,location:J.from(re.location)}}Me.from=Te;function Pe(re){const Oe=new n.$pK(re.name,H.to(re.kind),re.containerName,J.to(re.location));return Oe.tags=re.tags&&re.tags.map(te.to),Oe}Me.to=Pe})(me||(e.WorkspaceSymbol=me={}));var le;(function(Me){function Te(re){const Oe={name:re.name||"!!MISSING: name!!",detail:re.detail,range:i.from(re.range),selectionRange:i.from(re.selectionRange),kind:H.from(re.kind),tags:re.tags?.map(te.from)??[]};return re.children&&(Oe.children=re.children.map(Te)),Oe}Me.from=Te;function Pe(re){const Oe=new n.$qK(re.name,re.detail,H.to(re.kind),i.to(re.range),i.to(re.selectionRange));return(0,y.$Jb)(re.tags)&&(Oe.tags=re.tags.map(te.to)),re.children&&(Oe.children=re.children.map(Pe)),Oe}Me.to=Pe})(le||(e.DocumentSymbol=le={}));var ye;(function(Me){function Te(re){const Oe=new n.$uK(H.to(re.kind),re.name,re.detail||"",S.URI.revive(re.uri),i.to(re.range),i.to(re.selectionRange));return Oe._sessionId=re._sessionId,Oe._itemId=re._itemId,Oe}Me.to=Te;function Pe(re,Oe,qe){if(Oe=Oe??re._sessionId,qe=qe??re._itemId,Oe===void 0||qe===void 0)throw new Error("invalid item");return{_sessionId:Oe,_itemId:qe,name:re.name,detail:re.detail,kind:H.from(re.kind),uri:re.uri,range:i.from(re.range),selectionRange:i.from(re.selectionRange),tags:re.tags?.map(te.from)}}Me.from=Pe})(ye||(e.CallHierarchyItem=ye={}));var de;(function(Me){function Te(Pe){return new n.$vK(ye.to(Pe.from),Pe.fromRanges.map(re=>i.to(re)))}Me.to=Te})(de||(e.CallHierarchyIncomingCall=de={}));var V;(function(Me){function Te(Pe){return new n.$wK(ye.to(Pe.to),Pe.fromRanges.map(re=>i.to(re)))}Me.to=Te})(V||(e.CallHierarchyOutgoingCall=V={}));var J;(function(Me){function Te(re){return{range:re.range&&i.from(re.range),uri:re.uri}}Me.from=Te;function Pe(re){return new n.$kK(S.URI.revive(re.uri),i.to(re.range))}Me.to=Pe})(J||(e.location=J={}));var ee;(function(Me){function Te(re){const Oe=re,qe=re;return{originSelectionRange:Oe.originSelectionRange?i.from(Oe.originSelectionRange):void 0,uri:Oe.targetUri?Oe.targetUri:qe.uri,range:i.from(Oe.targetRange?Oe.targetRange:qe.range),targetSelectionRange:Oe.targetSelectionRange?i.from(Oe.targetSelectionRange):void 0}}Me.from=Te;function Pe(re){return{targetUri:S.URI.revive(re.uri),targetRange:i.to(re.range),targetSelectionRange:re.targetSelectionRange?i.to(re.targetSelectionRange):void 0,originSelectionRange:re.originSelectionRange?i.to(re.originSelectionRange):void 0}}Me.to=Pe})(ee||(e.DefinitionLink=ee={}));var Y;(function(Me){function Te(re){return{range:i.from(re.range),contents:F.fromMany(re.contents)}}Me.from=Te;function Pe(re){return new n.$nK(re.contents.map(F.to),i.to(re.range))}Me.to=Pe})(Y||(e.Hover=Y={}));var Z;(function(Me){function Te(re){return{range:i.from(re.range),expression:re.expression}}Me.from=Te;function Pe(re){return new n.$gL(i.to(re.range),re.expression)}Me.to=Pe})(Z||(e.EvaluatableExpression=Z={}));var _;(function(Me){function Te(re){if(re instanceof n.$hL)return{type:"text",range:i.from(re.range),text:re.text};if(re instanceof n.$iL)return{type:"variable",range:i.from(re.range),variableName:re.variableName,caseSensitiveLookup:re.caseSensitiveLookup};if(re instanceof n.$jL)return{type:"expression",range:i.from(re.range),expression:re.expression};throw new Error("Unknown 'InlineValue' type")}Me.from=Te;function Pe(re){switch(re.type){case"text":return{range:i.to(re.range),text:re.text};case"variable":return{range:i.to(re.range),variableName:re.variableName,caseSensitiveLookup:re.caseSensitiveLookup};case"expression":return{range:i.to(re.range),expression:re.expression}}}Me.to=Pe})(_||(e.InlineValue=_={}));var pe;(function(Me){function Te(re){return{frameId:re.frameId,stoppedLocation:i.from(re.stoppedLocation)}}Me.from=Te;function Pe(re){return new n.$kL(re.frameId,i.to(re.stoppedLocation))}Me.to=Pe})(pe||(e.InlineValueContext=pe={}));var se;(function(Me){function Te(re){return{range:i.from(re.range),kind:re.kind}}Me.from=Te;function Pe(re){return new n.$oK(i.to(re.range),re.kind)}Me.to=Pe})(se||(e.DocumentHighlight=se={}));var ge;(function(Me){function Te(Pe){switch(Pe){case 1:return n.CompletionTriggerKind.TriggerCharacter;case 2:return n.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return n.CompletionTriggerKind.Invoke}}Me.to=Te})(ge||(e.CompletionTriggerKind=ge={}));var ie;(function(Me){function Te(Pe){return{triggerKind:ge.to(Pe.triggerKind),triggerCharacter:Pe.triggerCharacter}}Me.to=Te})(ie||(e.CompletionContext=ie={}));var fe;(function(Me){function Te(re){switch(re){case n.CompletionItemTag.Deprecated:return 1}}Me.from=Te;function Pe(re){switch(re){case 1:return n.CompletionItemTag.Deprecated}}Me.to=Pe})(fe||(e.CompletionItemTag=fe={}));var be;(function(Me){const Te=new Map([[n.CompletionItemKind.Method,0],[n.CompletionItemKind.Function,1],[n.CompletionItemKind.Constructor,2],[n.CompletionItemKind.Field,3],[n.CompletionItemKind.Variable,4],[n.CompletionItemKind.Class,5],[n.CompletionItemKind.Interface,7],[n.CompletionItemKind.Struct,6],[n.CompletionItemKind.Module,8],[n.CompletionItemKind.Property,9],[n.CompletionItemKind.Unit,12],[n.CompletionItemKind.Value,13],[n.CompletionItemKind.Constant,14],[n.CompletionItemKind.Enum,15],[n.CompletionItemKind.EnumMember,16],[n.CompletionItemKind.Keyword,17],[n.CompletionItemKind.Snippet,27],[n.CompletionItemKind.Text,18],[n.CompletionItemKind.Color,19],[n.CompletionItemKind.File,20],[n.CompletionItemKind.Reference,21],[n.CompletionItemKind.Folder,23],[n.CompletionItemKind.Event,10],[n.CompletionItemKind.Operator,11],[n.CompletionItemKind.TypeParameter,24],[n.CompletionItemKind.Issue,26],[n.CompletionItemKind.User,25]]);function Pe(qe){return Te.get(qe)??9}Me.from=Pe;const re=new Map([[0,n.CompletionItemKind.Method],[1,n.CompletionItemKind.Function],[2,n.CompletionItemKind.Constructor],[3,n.CompletionItemKind.Field],[4,n.CompletionItemKind.Variable],[5,n.CompletionItemKind.Class],[7,n.CompletionItemKind.Interface],[6,n.CompletionItemKind.Struct],[8,n.CompletionItemKind.Module],[9,n.CompletionItemKind.Property],[12,n.CompletionItemKind.Unit],[13,n.CompletionItemKind.Value],[14,n.CompletionItemKind.Constant],[15,n.CompletionItemKind.Enum],[16,n.CompletionItemKind.EnumMember],[17,n.CompletionItemKind.Keyword],[27,n.CompletionItemKind.Snippet],[18,n.CompletionItemKind.Text],[19,n.CompletionItemKind.Color],[20,n.CompletionItemKind.File],[21,n.CompletionItemKind.Reference],[23,n.CompletionItemKind.Folder],[10,n.CompletionItemKind.Event],[11,n.CompletionItemKind.Operator],[24,n.CompletionItemKind.TypeParameter],[25,n.CompletionItemKind.User],[26,n.CompletionItemKind.Issue]]);function Oe(qe){return re.get(qe)??n.CompletionItemKind.Property}Me.to=Oe})(be||(e.CompletionItemKind=be={}));var Ie;(function(Me){function Te(Pe,re){const Oe=new n.$EK(Pe.label);return Oe.insertText=Pe.insertText,Oe.kind=be.to(Pe.kind),Oe.tags=Pe.tags?.map(fe.to),Oe.detail=Pe.detail,Oe.documentation=A.$1j(Pe.documentation)?F.to(Pe.documentation):Pe.documentation,Oe.sortText=Pe.sortText,Oe.filterText=Pe.filterText,Oe.preselect=Pe.preselect,Oe.commitCharacters=Pe.commitCharacters,D.$ms.isIRange(Pe.range)?Oe.range=i.to(Pe.range):typeof Pe.range=="object"&&(Oe.range={inserting:i.to(Pe.range.insert),replacing:i.to(Pe.range.replace)}),Oe.keepWhitespace=typeof Pe.insertTextRules>"u"?!1:!!(Pe.insertTextRules&1),typeof Pe.insertTextRules<"u"&&Pe.insertTextRules&4?Oe.insertText=new n.$jK(Pe.insertText):(Oe.insertText=Pe.insertText,Oe.textEdit=Oe.range instanceof n.$aK?new n.$fK(Oe.range,Oe.insertText):void 0),Pe.additionalTextEdits&&Pe.additionalTextEdits.length>0&&(Oe.additionalTextEdits=Pe.additionalTextEdits.map(qe=>X.to(qe))),Oe.command=re&&Pe.command?re.fromInternal(Pe.command):void 0,Oe}Me.to=Te})(Ie||(e.CompletionItem=Ie={}));var W;(function(Me){function Te(re){if(typeof re.label!="string"&&!Array.isArray(re.label))throw new TypeError("Invalid label");return{label:re.label,documentation:F.fromStrict(re.documentation)}}Me.from=Te;function Pe(re){return{label:re.label,documentation:A.$1j(re.documentation)?F.to(re.documentation):re.documentation}}Me.to=Pe})(W||(e.ParameterInformation=W={}));var G;(function(Me){function Te(re){return{label:re.label,documentation:F.fromStrict(re.documentation),parameters:Array.isArray(re.parameters)?re.parameters.map(W.from):[],activeParameter:re.activeParameter}}Me.from=Te;function Pe(re){return{label:re.label,documentation:A.$1j(re.documentation)?F.to(re.documentation):re.documentation,parameters:Array.isArray(re.parameters)?re.parameters.map(W.to):[],activeParameter:re.activeParameter}}Me.to=Pe})(G||(e.SignatureInformation=G={}));var ce;(function(Me){function Te(re){return{activeSignature:re.activeSignature,activeParameter:re.activeParameter,signatures:Array.isArray(re.signatures)?re.signatures.map(G.from):[]}}Me.from=Te;function Pe(re){return{activeSignature:re.activeSignature,activeParameter:re.activeParameter,signatures:Array.isArray(re.signatures)?re.signatures.map(G.to):[]}}Me.to=Pe})(ce||(e.SignatureHelp=ce={}));var he;(function(Me){function Te(Pe,re){const Oe=new n.$DK(h.to(re.position),typeof re.label=="string"?re.label:re.label.map(x.to.bind(void 0,Pe)),re.kind&&$e.to(re.kind));return Oe.textEdits=re.textEdits&&re.textEdits.map(X.to),Oe.tooltip=A.$1j(re.tooltip)?F.to(re.tooltip):re.tooltip,Oe.paddingLeft=re.paddingLeft,Oe.paddingRight=re.paddingRight,Oe}Me.to=Te})(he||(e.InlayHint=he={}));var x;(function(Me){function Te(Pe,re){const Oe=new n.$CK(re.label);return Oe.tooltip=A.$1j(re.tooltip)?F.to(re.tooltip):re.tooltip,E.Command.is(re.command)&&(Oe.command=Pe.fromInternal(re.command)),re.location&&(Oe.location=J.to(re.location)),Oe}Me.to=Te})(x||(e.InlayHintLabelPart=x={}));var $e;(function(Me){function Te(re){return re}Me.from=Te;function Pe(re){return re}Me.to=Pe})($e||(e.InlayHintKind=$e={}));var ve;(function(Me){function Te(re){return{range:i.from(re.range),url:re.target,tooltip:re.tooltip}}Me.from=Te;function Pe(re){let Oe;if(re.url)try{Oe=typeof re.url=="string"?S.URI.parse(re.url,!0):S.URI.revive(re.url)}catch{}return new n.$JK(i.to(re.range),Oe)}Me.to=Pe})(ve||(e.DocumentLink=ve={}));var Ne;(function(Me){function Te(re){const Oe=new n.$MK(re.label);return re.textEdit&&(Oe.textEdit=X.to(re.textEdit)),re.additionalTextEdits&&(Oe.additionalTextEdits=re.additionalTextEdits.map(qe=>X.to(qe))),Oe}Me.to=Te;function Pe(re){return{label:re.label,textEdit:re.textEdit?X.from(re.textEdit):void 0,additionalTextEdits:re.additionalTextEdits?re.additionalTextEdits.map(Oe=>X.from(Oe)):void 0}}Me.from=Pe})(Ne||(e.ColorPresentation=Ne={}));var Ve;(function(Me){function Te(re){return new n.$KK(re[0],re[1],re[2],re[3])}Me.to=Te;function Pe(re){return[re.red,re.green,re.blue,re.alpha]}Me.from=Pe})(Ve||(e.Color=Ve={}));var xe;(function(Me){function Te(re){return{range:i.from(re.range)}}Me.from=Te;function Pe(re){return new n.$tK(i.to(re.range))}Me.to=Pe})(xe||(e.SelectionRange=xe={}));var Qe;(function(Me){function Te(Pe){switch(Pe){case 2:return n.TextDocumentSaveReason.AfterDelay;case 1:return n.TextDocumentSaveReason.Manual;case 3:case 4:return n.TextDocumentSaveReason.FocusOut}}Me.to=Te})(Qe||(e.TextDocumentSaveReason=Qe={}));var rt;(function(Me){function Te(re){switch(re){case n.TextEditorLineNumbersStyle.Off:return 0;case n.TextEditorLineNumbersStyle.Relative:return 2;case n.TextEditorLineNumbersStyle.On:default:return 1}}Me.from=Te;function Pe(re){switch(re){case 0:return n.TextEditorLineNumbersStyle.Off;case 2:return n.TextEditorLineNumbersStyle.Relative;case 1:default:return n.TextEditorLineNumbersStyle.On}}Me.to=Pe})(rt||(e.TextEditorLineNumbersStyle=rt={}));var it;(function(Me){function Te(re){if(re===n.EndOfLine.CRLF)return 1;if(re===n.EndOfLine.LF)return 0}Me.from=Te;function Pe(re){if(re===1)return n.EndOfLine.CRLF;if(re===0)return n.EndOfLine.LF}Me.to=Pe})(it||(e.EndOfLine=it={}));var nt;(function(Me){function Te(Pe){if(typeof Pe=="object")return Pe.viewId;switch(Pe){case n.ProgressLocation.SourceControl:return 3;case n.ProgressLocation.Window:return 10;case n.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Me.from=Te})(nt||(e.ProgressLocation=nt={}));var Ae;(function(Me){function Te(re){const Oe={start:re.start+1,end:re.end+1};return re.kind&&(Oe.kind=Fe.from(re.kind)),Oe}Me.from=Te;function Pe(re){const Oe={start:re.start-1,end:re.end-1};return re.kind&&(Oe.kind=Fe.to(re.kind)),Oe}Me.to=Pe})(Ae||(e.FoldingRange=Ae={}));var Fe;(function(Me){function Te(re){if(re)switch(re){case n.FoldingRangeKind.Comment:return E.$bt.Comment;case n.FoldingRangeKind.Imports:return E.$bt.Imports;case n.FoldingRangeKind.Region:return E.$bt.Region}}Me.from=Te;function Pe(re){if(re)switch(re.value){case E.$bt.Comment.value:return n.FoldingRangeKind.Comment;case E.$bt.Imports.value:return n.FoldingRangeKind.Imports;case E.$bt.Region.value:return n.FoldingRangeKind.Region}}Me.to=Pe})(Fe||(e.FoldingRangeKind=Fe={}));var Le;(function(Me){function Te(Pe){if(Pe)return{pinned:typeof Pe.preview=="boolean"?!Pe.preview:void 0,inactive:Pe.background,preserveFocus:Pe.preserveFocus,selection:typeof Pe.selection=="object"?i.from(Pe.selection):void 0,override:typeof Pe.override=="boolean"?u.$LD.id:void 0}}Me.from=Te})(Le||(e.TextEditorOpenOptions=Le={}));var Je;(function(Me){function Te(qe){return qe instanceof n.$7K?qe.toJSON():typeof qe=="string"?qe:Pe(qe)||re(qe)?new n.$7K(qe.baseUri??qe.base,qe.pattern).toJSON():qe}Me.from=Te;function Pe(qe){const _e=qe;return _e?S.URI.isUri(_e.baseUri)&&typeof _e.pattern=="string":!1}function re(qe){const _e=qe;return _e?typeof _e.base=="string"&&typeof _e.pattern=="string":!1}function Oe(qe){return typeof qe=="string"?qe:new n.$7K(S.URI.revive(qe.baseUri),qe.pattern)}Me.to=Oe})(Je||(e.GlobPattern=Je={}));var ue;(function(Me){function Te(Pe){if(Pe){if(Array.isArray(Pe))return Pe.map(Te);if(typeof Pe=="string")return Pe;{const re=Pe;return{language:re.language,scheme:re.scheme,pattern:Je.from(re.pattern),exclusive:re.exclusive,notebookType:re.notebookType}}}else return}Me.from=Te})(ue||(e.LanguageSelector=ue={}));var oe;(function(Me){function Te(re){return!!re&&typeof re=="object"&&"documents"in re&&Array.isArray(re.documents)&&re.documents.every(Oe=>Array.isArray(Oe)&&Oe.every(qe=>qe&&typeof qe=="object"&&"uri"in qe&&S.URI.isUri(qe.uri)&&"version"in qe&&typeof qe.version=="number"&&"ranges"in qe&&Array.isArray(qe.ranges)&&qe.ranges.every(_e=>_e instanceof n.$aK)))}Me.is=Te;function Pe(re){return{documents:re.documents.map(Oe=>Oe.map(qe=>({uri:S.URI.from(qe.uri),version:qe.version,ranges:qe.ranges.map(_e=>i.from(_e))})))}}Me.from=Pe})(oe||(e.MappedEditsContext=oe={}));var Ce;(function(Me){function Te(re){return{start:re.start,end:re.end}}Me.from=Te;function Pe(re){return new n.$vL(re.start,re.end)}Me.to=Pe})(Ce||(e.NotebookRange=Ce={}));var He;(function(Me){function Te(re){return{timing:typeof re.runStartTime=="number"&&typeof re.runEndTime=="number"?{startTime:re.runStartTime,endTime:re.runEndTime}:void 0,executionOrder:re.executionOrder,success:re.lastRunSuccess}}Me.to=Te;function Pe(re){return{lastRunSuccess:re.success,runStartTime:re.timing?.startTime,runEndTime:re.timing?.endTime,executionOrder:re.executionOrder}}Me.from=Pe})(He||(e.NotebookCellExecutionSummary=He={}));var ze;(function(Me){function Te(Pe){if(Pe===o.NotebookCellExecutionState.Unconfirmed)return n.NotebookCellExecutionState.Pending;if(Pe===o.NotebookCellExecutionState.Pending)return;if(Pe===o.NotebookCellExecutionState.Executing)return n.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${Pe}`)}Me.to=Te})(ze||(e.NotebookCellExecutionState=ze={}));var Ze;(function(Me){function Te(re){switch(re){case n.NotebookCellKind.Markup:return o.CellKind.Markup;case n.NotebookCellKind.Code:default:return o.CellKind.Code}}Me.from=Te;function Pe(re){switch(re){case o.CellKind.Markup:return n.NotebookCellKind.Markup;case o.CellKind.Code:default:return n.NotebookCellKind.Code}}Me.to=Pe})(Ze||(e.NotebookCellKind=Ze={}));var st;(function(Me){function Te(re){const Oe={metadata:re.metadata??Object.create(null),cells:[]};for(const qe of re.cells)n.$wL.validate(qe),Oe.cells.push(lt.from(qe));return Oe}Me.from=Te;function Pe(re){const Oe=new n.$xL(re.cells.map(lt.to));return(0,v.$Jf)(re.metadata)||(Oe.metadata=re.metadata),Oe}Me.to=Pe})(st||(e.NotebookData=st={}));var lt;(function(Me){function Te(re){return{cellKind:Ze.from(re.kind),language:re.languageId,mime:re.mime,source:re.value,metadata:re.metadata,internalMetadata:He.from(re.executionSummary??{}),outputs:re.outputs?re.outputs.map(Ct.from):[]}}Me.from=Te;function Pe(re){return new n.$wL(Ze.to(re.cellKind),re.source,re.language,re.mime,re.outputs?re.outputs.map(Ct.to):void 0,re.metadata,re.internalMetadata?He.to(re.internalMetadata):void 0)}Me.to=Pe})(lt||(e.NotebookCellData=lt={}));var wt;(function(Me){function Te(re){return{mime:re.mime,valueBytes:M.$_d.wrap(re.data)}}Me.from=Te;function Pe(re){return new n.$yL(re.valueBytes.buffer,re.mime)}Me.to=Pe})(wt||(e.NotebookCellOutputItem=wt={}));var Ct;(function(Me){function Te(re){return{outputId:re.id,items:re.items.map(wt.from),metadata:re.metadata}}Me.from=Te;function Pe(re){const Oe=re.items.map(wt.to);return new n.$zL(Oe,re.outputId,re.metadata)}Me.to=Pe})(Ct||(e.NotebookCellOutput=Ct={}));var Xt;(function(Me){function Te(Oe){return re(Oe)?{include:Je.from(Oe.include)??void 0,exclude:Je.from(Oe.exclude)??void 0}:Je.from(Oe)??void 0}Me.from=Te;function Pe(Oe){return re(Oe)?{include:Je.to(Oe.include),exclude:Je.to(Oe.exclude)}:Je.to(Oe)}Me.to=Pe;function re(Oe){const qe=Oe;return qe?!(0,v.$Ff)(qe.include)&&!(0,v.$Ff)(qe.exclude):!1}})(Xt||(e.NotebookExclusiveDocumentPattern=Xt={}));var qt;(function(Me){function Te(Pe,re,Oe){const qe=typeof Pe.command=="string"?{title:"",command:Pe.command}:Pe.command;return{alignment:Pe.alignment===n.NotebookCellStatusBarAlignment.Left?1:2,command:re.toInternal(qe,Oe),text:Pe.text,tooltip:Pe.tooltip,accessibilityInformation:Pe.accessibilityInformation,priority:Pe.priority}}Me.from=Te})(qt||(e.NotebookStatusBarItem=qt={}));var vt;(function(Me){function Te(Pe,re,Oe){const qe=typeof Pe.command=="string"?{title:"",command:Pe.command}:Pe.command;return{command:re.toInternal(qe,Oe),label:Pe.label,description:Pe.description,detail:Pe.detail,documentation:Pe.documentation}}Me.from=Te})(vt||(e.NotebookKernelSourceAction=vt={}));var Nt;(function(Me){function Te(Pe){return{transientOutputs:Pe?.transientOutputs??!1,transientCellMetadata:Pe?.transientCellMetadata??{},transientDocumentMetadata:Pe?.transientDocumentMetadata??{},cellContentMetadata:Pe?.cellContentMetadata??{}}}Me.from=Te})(Nt||(e.NotebookDocumentContentOptions=Nt={}));var jt;(function(Me){function Te(re){return{uri:re.uri,provides:re.provides}}Me.from=Te;function Pe(re){return new n.$BL(S.URI.revive(re.uri),re.provides)}Me.to=Pe})(jt||(e.NotebookRendererScript=jt={}));var Yt;(function(Me){function Te(re){return{message:F.fromStrict(re.message)||"",type:0,expected:re.expectedOutput,actual:re.actualOutput,contextValue:re.contextValue,location:re.location&&{range:i.from(re.location.range),uri:re.location.uri}}}Me.from=Te;function Pe(re){const Oe=new n.$HL(typeof re.message=="string"?re.message:F.to(re.message));return Oe.actualOutput=re.actual,Oe.expectedOutput=re.expected,Oe.contextValue=re.contextValue,Oe.location=re.location?J.to(re.location):void 0,Oe}Me.to=Pe})(Yt||(e.TestMessage=Yt={}));var Ut;(function(Me){Me.namespace=d.$6I,Me.denamespace=d.$7I})(Ut||(e.TestTag=Ut={}));var zt;(function(Me){function Te(re){const Oe=(0,c.$6L)(re).controllerId;return{extId:g.$2I.fromExtHostTestItem(re,Oe).toString(),label:re.label,uri:S.URI.revive(re.uri),busy:re.busy,tags:re.tags.map(qe=>Ut.namespace(Oe,qe.id)),range:D.$ms.lift(i.from(re.range)),description:re.description||null,sortText:re.sortText||null,error:re.error&&F.fromStrict(re.error)||null}}Me.from=Te;function Pe(re){return{parent:void 0,error:void 0,id:g.$2I.fromString(re.extId).localId,label:re.label,uri:S.URI.revive(re.uri),tags:(re.tags||[]).map(Oe=>{const{tagId:qe}=Ut.denamespace(Oe);return new n.$IL(qe)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:i.to(re.range||void 0),canResolveChildren:!1,busy:re.busy,description:re.description||void 0,sortText:re.sortText||void 0}}Me.toPlain=Pe})(zt||(e.TestItem=zt={})),function(Me){function Te(re){return{id:re.id}}Me.from=Te;function Pe(re){return new n.$IL(re.id)}Me.to=Pe}(Ut||(e.TestTag=Ut={}));var Ht;(function(Me){const Te=(re,Oe)=>{const qe=[];for(const[Ge,ot]of Oe)g.$2I.compare(ot.item.extId,Ge)===2&&(Oe.delete(Ge),qe.push(ot));const _e={...zt.toPlain(re.item),parent:void 0,taskStates:re.tasks.map(Ge=>({state:Ge.state,duration:Ge.duration,messages:Ge.messages.filter(ot=>ot.type===0).map(Yt.to)})),children:qe.map(Ge=>Te(Ge,Oe))};for(const Ge of _e.children)Ge.parent=_e;return _e};function Pe(re){const Oe=[],qe=new Map;for(const _e of re.items){qe.set(_e.item.extId,_e);const Ge=g.$2I.root(_e.item.extId);re.request.targets.some(ot=>ot.controllerId===Ge&&ot.testIds.includes(_e.item.extId))&&Oe.push(_e)}return{completedAt:re.completedAt,results:Oe.map(_e=>Te(_e,qe))}}Me.to=Pe})(Ht||(e.TestResults=Ht={}));var Gt;(function(Me){function Te(qe){return{covered:qe.covered,total:qe.covered}}function Pe(qe){return"line"in qe?h.from(qe):i.from(qe)}function re(qe){return"branches"in qe?{count:qe.executionCount,location:Pe(qe.location),type:1,branches:qe.branches.length?qe.branches.map(_e=>({count:_e.executionCount,location:_e.location&&Pe(_e.location)})):void 0}:{type:0,count:qe.executionCount,location:Pe(qe.location)}}Me.fromDetailed=re;function Oe(qe){return{uri:qe.uri,statement:Te(qe.statementCoverage),branch:qe.branchCoverage&&Te(qe.branchCoverage),function:qe.functionCoverage&&Te(qe.functionCoverage),details:qe.detailedCoverage?.map(re)}}Me.fromFile=Oe})(Gt||(e.TestCoverage=Gt={}));var Bt;(function(Me){function Te(Pe){switch(Pe){case 1:return n.CodeActionTriggerKind.Invoke;case 2:return n.CodeActionTriggerKind.Automatic}}Me.to=Te})(Bt||(e.CodeActionTriggerKind=Bt={}));var Kt;(function(Me){function Te(re){const Oe=new n.$OL(H.to(re.kind),re.name,re.detail||"",S.URI.revive(re.uri),i.to(re.range),i.to(re.selectionRange));return Oe._sessionId=re._sessionId,Oe._itemId=re._itemId,Oe}Me.to=Te;function Pe(re,Oe,qe){if(Oe=Oe??re._sessionId,qe=qe??re._itemId,Oe===void 0||qe===void 0)throw new Error("invalid item");return{_sessionId:Oe,_itemId:qe,kind:H.from(re.kind),name:re.name,detail:re.detail??"",uri:re.uri,range:i.from(re.range),selectionRange:i.from(re.selectionRange),tags:re.tags?.map(te.from)}}Me.from=Pe})(Kt||(e.TypeHierarchyItem=Kt={}));var Jt;(function(Me){function Te(Pe){if(Pe)return{value:Pe.value,tooltip:Pe.tooltip}}Me.from=Te})(Jt||(e.ViewBadge=Jt={}));var ct;(function(Me){function Te(qe,_e,Ge){const ot=_e.fileData;return ot?new n.$ZK(new n.$1K(ot.name,S.URI.revive(ot.uri),ot.id,(0,R.$bb)(()=>Ge(ot.id)))):qe===P.$Jr.uriList&&_e.uriListData?new n.$YK(Oe(_e.uriListData)):new n.$YK(_e.asString)}Me.to=Te;async function Pe(qe,_e){const Ge=await _e.asString();if(qe===P.$Jr.uriList)return{asString:Ge,fileData:void 0,uriListData:re(Ge)};const ot=_e.asFile();return{asString:Ge,fileData:ot?{name:ot.name,uri:ot.uri,id:ot._itemId??ot.id}:void 0}}Me.from=Pe;function re(qe){return l.$Vs.split(qe).map(_e=>{if(_e.startsWith("#"))return _e;try{return S.URI.parse(_e)}catch{}return _e})}function Oe(qe){return l.$Vs.create(qe.map(_e=>typeof _e=="string"?_e:S.URI.revive(_e)))}})(ct||(e.DataTransferItem=ct={}));var mt;(function(Me){function Te(re,Oe){const qe=re.items.map(([_e,Ge])=>[_e,ct.to(_e,Ge,Oe)]);return new n.$2K(qe)}Me.toDataTransfer=Te;async function Pe(re){const Oe={items:[]},qe=[];for(const[_e,Ge]of re)qe.push((async()=>{Oe.items.push([_e,await ct.from(_e,Ge)])})());return await Promise.all(qe),Oe}Me.from=Pe})(mt||(e.DataTransfer=mt={}));var It;(function(Me){function Te(re){return{message:re.message,metadata:re.metadata,title:re.title,tooltip:re.tooltip}}Me.to=Te;function Pe(re){return{kind:"reply",message:re.message,metadata:re.metadata,title:re.title,tooltip:re.tooltip}}Me.from=Pe})(It||(e.ChatReplyFollowup=It={}));var Rt;(function(Me){function Te(Pe){return typeof Pe=="string"?{title:Pe,message:Pe,kind:"reply"}:"commandId"in Pe?{kind:"command",title:Pe.title??"",commandId:Pe.commandId??"",when:Pe.when??"",args:Pe.args}:It.from(Pe)}Me.from=Te})(Rt||(e.ChatFollowup=Rt={}));var Pt;(function(Me){function Te(re){const Oe=new n.$YL(gt.to(re.role),re.content);return Oe.name=re.name,Oe}Me.to=Te;function Pe(re){return{role:gt.from(re.role),content:re.content,name:re.name}}Me.from=Pe})(Pt||(e.ChatMessage=Pt={}));var gt;(function(Me){function Te(re){switch(re){case 0:return n.ChatMessageRole.System;case 1:return n.ChatMessageRole.User;case 2:return n.ChatMessageRole.Assistant;case 3:return n.ChatMessageRole.Function}}Me.to=Te;function Pe(re){switch(re){case n.ChatMessageRole.System:return 0;case n.ChatMessageRole.Assistant:return 2;case n.ChatMessageRole.Function:return 3;case n.ChatMessageRole.User:default:return 1}}Me.from=Pe})(gt||(e.ChatMessageRole=gt={}));var St;(function(Me){function Te(re){return{level:At.to(re.level),value:re.value,description:re.description}}Me.to=Te;function Pe(re){return{level:At.from(re.level),value:re.value,description:re.description}}Me.from=Pe})(St||(e.ChatVariable=St={}));var At;(function(Me){function Te(re){switch(re){case"short":return n.ChatVariableLevel.Short;case"medium":return n.ChatVariableLevel.Medium;case"full":default:return n.ChatVariableLevel.Full}}Me.to=Te;function Pe(re){switch(re){case n.ChatVariableLevel.Short:return"short";case n.ChatVariableLevel.Medium:return"medium";case n.ChatVariableLevel.Full:default:return"full"}}Me.from=Pe})(At||(e.ChatVariableLevel=At={}));var Ft;(function(Me){function Te(Pe){switch(Pe){case 1:return n.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return n.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return n.InteractiveEditorResponseFeedbackKind.Undone;case 3:return n.InteractiveEditorResponseFeedbackKind.Accepted}}Me.to=Te})(Ft||(e.InteractiveEditorResponseFeedbackKind=Ft={}));var Xe;(function(Me){function Te(Pe,re,Oe){return"terminalCommand"in Pe?{terminalCommand:Pe.terminalCommand}:"uri"in Pe?{uri:Pe.uri}:re.toInternal(Pe,Oe)}Me.from=Te})(Xe||(e.TerminalQuickFix=Xe={}))}),define(Se[279],De([1,0,2,8,7,13,76]),function(ne,e,y,M,l,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sbc=void 0;class m{constructor($,P,C,v={timeout:1500,errors:3}){this.c=$,this.d=P,this.f=C,this.g=v,this.a=new A.$Zc,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent($){return(P,C,v)=>{const D={dispose:this.a.push([P,C,$])};return Array.isArray(v)&&v.push(D),D}}async $participateInSave($,P){const C=y.URI.revive($);let v=!1;const S=setTimeout(()=>v=!0,this.g.timeout),D=[];try{for(const E of[...this.a]){if(v)break;const s=this.d.getDocument(C),c=await this.h(E,{document:s,reason:R.TextDocumentSaveReason.to(P)});D.push(c)}}finally{clearTimeout(S)}return D}h([$,P,C],v){const S=this.b.get($);return typeof S=="number"&&S>this.g.errors?Promise.resolve(!1):this.i(C,$,P,v).then(()=>!0,D=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' threw ERROR`),this.c.error(D),!(D instanceof Error)||D.message!=="concurrent_edits"){const E=this.b.get($);this.b.set($,E?E+1:1),typeof E=="number"&&E>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i($,P,C,v){const S=[],D=Date.now(),{document:E,reason:s}=v,{version:c}=E,u=Object.freeze({document:E,reason:s,waitUntil(o){if(Object.isFrozen(S))throw(0,M.$6)("waitUntil can not be called async");S.push(Promise.resolve(o))}});try{P.apply(C,[u])}catch(o){return Promise.reject(o)}return Object.freeze(S),new Promise((o,g)=>{const d=setTimeout(()=>g(new Error("timeout")),this.g.timeout);return Promise.all(S).then(t=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${$.identifier.value}' finished after ${Date.now()-D}ms`),clearTimeout(d),o(t)}).catch(t=>{clearTimeout(d),g(t)})}).then(o=>{const g={edits:[]};for(const d of o)if(Array.isArray(d)&&d.every(t=>t instanceof l.$fK))for(const{newText:t,newEol:n,range:r}of d)g.edits.push({resource:E.uri,versionId:void 0,textEdit:{range:r&&R.Range.from(r),text:t,eol:n&&R.EndOfLine.from(n)}});if(g.edits.length!==0)return c===E.version?this.f.$tryApplyWorkspaceEdit(g):Promise.reject(new Error("concurrent_edits"))})}}e.$Sbc=m}),define(Se[280],De([1,0,17,2,13,7,109]),function(ne,e,y,M,l,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7cc=e.$6cc=void 0;class m{constructor(C,v,S,D){this.start=C,this.deletedCount=v,this.deletedItems=S,this.items=D}asApiEvent(){return{range:new R.$vL(this.start,this.start+this.deletedCount),addedCells:this.items.map(C=>C.apiCell),removedCells:this.deletedItems}}}class k{static asModelAddData(C,v){return{EOL:v.eol,lines:v.source,languageId:v.language,uri:v.uri,isDirty:!1,versionId:1,notebook:C}}constructor(C,v,S){this.notebook=C,this.h=v,this.j=S,this.handle=S.handle,this.uri=M.URI.revive(S.uri),this.cellKind=S.cellKind,this.a=S.outputs.map(l.NotebookCellOutput.to),this.e=S.internalMetadata??{},this.b=Object.freeze(S.metadata??{}),this.d=Object.freeze(l.NotebookCellExecutionSummary.to(S.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const C=this,v=this.h.getDocument(this.uri);if(!v)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const S={get index(){return C.notebook.getCellIndex(C)},notebook:C.notebook.apiNotebook,kind:l.NotebookCellKind.to(this.j.cellKind),document:v.document,get mime(){return C.g},set mime(D){C.g=D},get outputs(){return C.a.slice(0)},get metadata(){return C.b},get executionSummary(){return C.d}};this.f=Object.freeze(S)}return this.f}setOutputs(C){this.a=C.map(l.NotebookCellOutput.to)}setOutputItems(C,v,S){const D=S.map(l.NotebookCellOutputItem.to),E=this.a.find(s=>s.id===C);if(E&&(v||(E.items.length=0),E.items.push(...D),E.items.length>1&&E.items.every(s=>A.$iI(s.mime)))){const s=new Map,c=[];E.items.forEach(u=>{let o;s.has(u.mime)?o=s.get(u.mime):(o=[],s.set(u.mime,o),c.push(u.mime)),o.push(u.data)}),E.items.length=0,c.forEach(u=>{const o=A.$jI(s.get(u));E.items.push({mime:u,data:o.data.buffer})})}}setMetadata(C){this.b=Object.freeze(C)}setInternalMetadata(C){this.e=C,this.d=Object.freeze(l.NotebookCellExecutionSummary.to(C))}setMime(C){}}e.$6cc=k;class ${constructor(C,v,S,D,E){this.k=C,this.l=v,this.m=S,this.uri=D,this.handle=$.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=E.viewType,this.f=Object.freeze(E.metadata??Object.create(null)),this.r([[0,0,E.cells]],!0,void 0),this.g=E.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const C=this,v={get uri(){return C.uri},get version(){return C.g},get notebookType(){return C.d},get isDirty(){return C.h},get isUntitled(){return C.uri.scheme===y.Schemas.untitled},get isClosed(){return C.j},get metadata(){return C.f},get cellCount(){return C.b.length},cellAt(S){return S=C.n(S),C.b[S].apiCell},getCells(S){return(S?C.p(S):C.b).map(E=>E.apiCell)},save(){return C.q()}};this.e=Object.freeze(v)}return this.e}acceptDocumentPropertiesChanged(C){C.metadata&&(this.f=Object.freeze({...this.f,...C.metadata}))}acceptDirty(C){this.h=C}acceptModelChanged(C,v,S){this.g=C.versionId,this.h=v,this.acceptDocumentPropertiesChanged({metadata:S});const D={notebook:this.apiNotebook,metadata:S,cellChanges:[],contentChanges:[]},E=[];for(const c of C.rawEvents)c.kind===A.NotebookCellsChangeType.ModelChange?this.r(c.changes,!1,D.contentChanges):c.kind===A.NotebookCellsChangeType.Move?this.s(c.index,c.length,c.newIdx,D.contentChanges):c.kind===A.NotebookCellsChangeType.Output?(this.t(c.index,c.outputs),E.push({cell:this.b[c.index].apiCell,outputs:this.b[c.index].apiCell.outputs})):c.kind===A.NotebookCellsChangeType.OutputItem?(this.u(c.index,c.outputId,c.append,c.outputItems),E.push({cell:this.b[c.index].apiCell,outputs:this.b[c.index].apiCell.outputs})):c.kind===A.NotebookCellsChangeType.ChangeCellLanguage?(this.v(c.index,c.language),E.push({cell:this.b[c.index].apiCell,document:this.b[c.index].apiCell.document})):c.kind===A.NotebookCellsChangeType.ChangeCellContent?E.push({cell:this.b[c.index].apiCell,document:this.b[c.index].apiCell.document}):c.kind===A.NotebookCellsChangeType.ChangeCellMime?this.w(c.index,c.mime):c.kind===A.NotebookCellsChangeType.ChangeCellMetadata?(this.x(c.index,c.metadata),E.push({cell:this.b[c.index].apiCell,metadata:this.b[c.index].apiCell.metadata})):c.kind===A.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(c.index,c.internalMetadata),E.push({cell:this.b[c.index].apiCell,executionSummary:this.b[c.index].apiCell.executionSummary}));const s=new Map;for(let c=0;c<E.length;c++){const u=E[c],o=s.get(u.cell);if(o===void 0){const g=D.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...u});s.set(u.cell,g-1)}else D.cellChanges[o]={...D.cellChanges[o],...u}}return Object.freeze(D),Object.freeze(D.cellChanges),Object.freeze(D.contentChanges),D}n(C){return C=C|0,C<0?0:C>=this.b.length?this.b.length-1:C}o(C){let v=C.start|0,S=C.end|0;return v<0&&(v=0),S>this.b.length&&(S=this.b.length),C.with({start:v,end:S})}p(C){C=this.o(C);const v=[];for(let S=C.start;S<C.end;S++)v.push(this.b[S]);return v}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(C,v,S){if(this.j)return;const D=[],E=[],s=[];if(C.reverse().forEach(c=>{const o=c[2].map(t=>{const n=new k(this,this.l,t);return v||E.push(k.asModelAddData(this.apiNotebook,t)),n}),g=new m(c[0],c[1],[],o),d=this.b.splice(c[0],c[1],...o);for(const t of d)s.push(t.uri),g.deletedItems.push(t.apiCell);D.push(g)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:E,removedDocuments:s}),S)for(const c of D)S.push(c.asApiEvent())}s(C,v,S,D){const E=this.b.splice(C,v);this.b.splice(S,0,...E);const s=[new m(C,v,E.map(c=>c.apiCell),[]),new m(S,0,[],E)];for(const c of s)D.push(c.asApiEvent())}t(C,v){this.b[C].setOutputs(v)}u(C,v,S,D){this.b[C].setOutputItems(v,S,D)}v(C,v){const S=this.b[C];S.apiCell.document.languageId!==v&&this.m.$acceptModelLanguageChanged(S.uri,v)}w(C,v){const S=this.b[C];S.apiCell.mime=v}x(C,v){this.b[C].setMetadata(v)}y(C,v){this.b[C].setInternalMetadata(v)}getCellFromApiCell(C){return this.b.find(v=>v.apiCell===C)}getCellFromIndex(C){return this.b[C]}getCell(C){return this.b.find(v=>v.handle===C)}getCellIndex(C){return this.b.indexOf(C)}}e.$7cc=$,$.a=0}),define(Se[281],De([1,0,4,2,13,7]),function(ne,e,y,M,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$udc=void 0;class A{constructor(k,$,P,C={timeout:1500,errors:3}){this.b=k,this.c=$,this.d=P,this.f=C,this.a=new y.$Nd}dispose(){}getOnWillSaveNotebookDocumentEvent(k){return($,P,C)=>{const v=function(D){$.call(P,D)};return v.extension=k,this.a.event(v,void 0,C)}}async $participateInSave(k,$,P){const C=M.URI.revive(k),v=this.c.getNotebookDocument(C);if(!v)throw new Error("Unable to resolve notebook document");const S=[];if(await this.a.fireAsync({notebook:v.apiNotebook,reason:l.TextDocumentSaveReason.to($)},P,async(E,s)=>{const c=Date.now(),u=await await Promise.resolve(E);Date.now()-c>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",s.extension.identifier),!P.isCancellationRequested&&u&&(u instanceof R.$iK?S.push(u):this.b.warn("onWillSaveNotebookDocument-listener from extension",s.extension.identifier,"ignored due to invalid data"))}),P.isCancellationRequested)return!1;if(S.length===0)return!0;const D={edits:[]};for(const E of S){const{edits:s}=l.WorkspaceEdit.from(E);D.edits=D.edits.concat(s)}return this.d.$tryApplyWorkspaceEdit(D)}}e.$udc=A}),define(Se[145],De([1,0,8,13,7]),function(ne,e,y,M,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8cc=void 0;class R{constructor(m,k,$,P,C,v){this.id=m,this.f=k,this.notebookData=$,this.a=[],this.b=[],this.d=!1,this.a=C,this.b=P,this.c=v}get apiEditor(){if(!this.e){const m=this;this.e={get notebook(){return m.notebookData.apiNotebook},get selection(){return m.a[0]},set selection(k){this.selections=[k]},get selections(){return m.a},set selections(k){if(!Array.isArray(k)||!k.every(l.$vL.isNotebookRange))throw(0,y.$5)("selections");m.a=k,m.g(k)},get visibleRanges(){return m.b},revealRange(k,$){m.f.$tryRevealRange(m.id,M.NotebookRange.from(k),$??l.NotebookEditorRevealType.Default)},get viewColumn(){return m.c}},R.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(m){this.d=m}_acceptVisibleRanges(m){this.b=m}_acceptSelections(m){this.a=m}g(m){this.f.$trySetSelections(this.id,m.map(M.NotebookRange.from))}_acceptViewColumn(m){this.c=m}}e.$8cc=R,R.apiEditorsToExtHost=new WeakMap}),define(Se[282],De([1,0,8,4,14,13]),function(ne,e,y,M,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ndc=void 0;let A=class{constructor(k,$){this.c=k,this.d=$,this.a=new M.$Ld({onListenerError:y.$Z}),this.b=new M.$Ld({onListenerError:y.$Z}),this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(k,$){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",k,$);const P=this.d.getEditorById(k);$.visibleRanges&&P._acceptVisibleRanges($.visibleRanges.ranges.map(R.NotebookRange.to)),$.selections&&P._acceptSelections($.selections.selections.map(R.NotebookRange.to)),$.visibleRanges&&this.b.fire({notebookEditor:P.apiEditor,visibleRanges:P.apiEditor.visibleRanges}),$.selections&&this.a.fire(Object.freeze({notebookEditor:P.apiEditor,selections:P.apiEditor.selections}))}$acceptEditorViewColumns(k){for(const $ in k)this.d.getEditorById($)._acceptViewColumn(R.ViewColumn.to(k[$]))}};e.$ndc=A,e.$ndc=A=Ke([We(0,l.$6i)],A)}),define(Se[283],De([1,0,13,64,208,21,56,8]),function(ne,e,y,M,l,R,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rcc=void 0;class k{constructor(v){this.b=0,this.c=new Map,this.a=v}async withProgress(v,S,D){const E=this.b++,{title:s,location:c,cancellable:u}=S,o={label:(0,l.localize)(0,null,v.displayName||v.name),id:v.identifier.value};return this.a.$startProgress(E,{location:y.ProgressLocation.from(c),title:s,source:o,cancellable:u},v.isUnderDevelopment?void 0:v.identifier.value).catch(m.$Z),this.d(E,D,!!u)}d(v,S,D){let E;D&&(E=new R.$Vd,this.c.set(v,E));const s=u=>{this.a.$progressEnd(u),this.c.delete(u),E?.dispose()};let c;try{c=S(new P(this.a,v),D&&E?E.token:R.CancellationToken.None)}catch(u){throw s(v),u}return c.then(u=>s(v),u=>s(v)),c}$acceptProgressCanceled(v){const S=this.c.get(v);S&&(S.cancel(),this.c.delete(v))}}e.$rcc=k;function $(C,v){return C.message=v.message,typeof v.increment=="number"&&(typeof C.increment=="number"?C.increment+=v.increment:C.increment=v.increment),C}class P extends M.$Xu{constructor(v,S){super(D=>this.throttledReport(D)),this.f=v,this.g=S}throttledReport(v){this.f.$progressReport(this.g,v)}}Ke([(0,A.$fh)(100,(C,v)=>$(C,v),()=>Object.create(null))],P.prototype,"throttledReport",null)}),define(Se[146],De([1,0,35,143,68,110,88,13,2]),function(ne,e,y,M,l,R,A,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mM=e.$lM=e.$kM=e.$jM=void 0;const $=(o,g,d,t)=>{let n=g;return{enumerable:!0,configurable:!1,get(){return n},set(r){if(!d(n,r)){const i=n;n=r,o.listener?.(t(r,i))}}}},P=(o,g)=>o===g,C={range:(o,g)=>o===g?!0:!o||!g?!1:o.isEqual(g),label:P,description:P,sortText:P,busy:P,error:P,canResolveChildren:P,tags:(o,g)=>!(o.length!==g.length||o.some(d=>!g.find(t=>d.id===t.id)))},v=o=>g=>({op:4,update:o(g)}),S=(o,g)=>({range:(()=>{let d;const t=v(n=>({range:y.$ms.lift(m.Range.from(n))}));return{enumerable:!0,configurable:!1,get(){return d},set(n){o.listener?.({op:6}),C.range(d,n)||(d=n,o.listener?.(t(n)))}}})(),label:$(o,g,C.label,v(d=>({label:d}))),description:$(o,void 0,C.description,v(d=>({description:d}))),sortText:$(o,void 0,C.sortText,v(d=>({sortText:d}))),canResolveChildren:$(o,!1,C.canResolveChildren,d=>({op:2,state:d})),busy:$(o,!1,C.busy,v(d=>({busy:d}))),error:$(o,void 0,C.error,v(d=>({error:m.MarkdownString.fromStrict(d)||null}))),tags:$(o,[],C.tags,(d,t)=>({op:1,new:d.map(m.TestTag.from),old:t.map(m.TestTag.from)}))}),D=o=>{const g=l.$2I.fromString(o.extId),d=new s(g.controllerId,g.localId,o.label,k.URI.revive(o.uri)||void 0);return d.range=m.Range.to(o.range||void 0),d.description=o.description||void 0,d.sortText=o.sortText||void 0,d.tags=o.tags.map(t=>m.TestTag.to({id:(0,A.$7I)(t).tagId})),d},E=o=>{let g;for(const d of o.tests){const t=D(d.item);(0,M.$6L)(t).parent=g,g=t}return g};e.$jM=E;class s{constructor(g,d,t,n){if(d.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(d)} symbol`);const r=(0,M.$5L)(this,g);Object.defineProperties(this,{id:{value:d,enumerable:!0,writable:!1},uri:{value:n,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return r.parent instanceof c?void 0:r.parent}},children:{value:(0,R.$4L)(r,M.$6L,s),enumerable:!0,writable:!1},...S(r,t)})}}e.$kM=s;class c extends s{constructor(g,d){super(g,g,d,void 0),this._isRoot=!0}}e.$lM=c;class u extends R.$ZL{constructor(g,d,t){super({controllerId:g,getDocumentVersion:n=>n&&t.getDocument(n)?.version,getApiFor:M.$6L,getChildren:n=>n.children,root:new c(g,d),toITestItem:m.TestItem.from})}}e.$mM=u}),define(Se[147],De([1,0,57,8,120,13,7]),function(ne,e,y,M,l,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gM=e.$fM=e.$eM=void 0;class m{constructor(v,S,D){const E=m.c.nextId();v.$registerTextEditorDecorationType(S.identifier,E,R.DecorationRenderOptions.from(D)),this.value=Object.freeze({key:E,dispose(){v.$removeTextEditorDecorationType(E)}})}}e.$eM=m,m.c=new l.$cM("TextEditorDecorationType");class k{constructor(v,S){this.g=[],this.h=void 0,this.j=!1,this.c=v,this.d=v.version,this.e=S.undoStopBefore,this.f=S.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(v,S){this.k();let D=null;if(v instanceof A.$_J)D=new A.$aK(v,v);else if(v instanceof A.$aK)D=v;else throw new Error("Unrecognized location");this.l(D,S,!1)}insert(v,S){this.k(),this.l(new A.$aK(v,v),S,!0)}delete(v){this.k();let S=null;if(v instanceof A.$aK)S=v;else throw new Error("Unrecognized location");this.l(S,null,!0)}l(v,S,D){const E=this.c.validateRange(v);this.g.push({range:E,text:S,forceMoveMarkers:D})}setEndOfLine(v){if(this.k(),v!==A.EndOfLine.LF&&v!==A.EndOfLine.CRLF)throw(0,M.$5)("endOfLine");this.h=v}}class ${constructor(v,S,D,E){this.c=v,this.d=S,this._accept(D),this.e=E;const s=this;this.value={get tabSize(){return s.f},set tabSize(c){s.m(c)},get indentSize(){return s.g},set indentSize(c){s.o(c)},get insertSpaces(){return s.h},set insertSpaces(c){s.q(c)},get cursorStyle(){return s.j},set cursorStyle(c){s.s(c)},get lineNumbers(){return s.k},set lineNumbers(c){s.t(c)}}}_accept(v){this.f=v.tabSize,this.g=v.indentSize,this.h=v.insertSpaces,this.j=v.cursorStyle,this.k=R.TextEditorLineNumbersStyle.to(v.lineNumbers)}l(v){if(v==="auto")return"auto";if(typeof v=="number"){const S=Math.floor(v);return S>0?S:null}if(typeof v=="string"){const S=parseInt(v,10);return isNaN(S)?null:S>0?S:null}return null}m(v){const S=this.l(v);if(S!==null){if(typeof S=="number"){if(this.f===S)return;this.f=S}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:S}))}}n(v){if(v==="tabSize")return"tabSize";if(typeof v=="number"){const S=Math.floor(v);return S>0?S:null}if(typeof v=="string"){const S=parseInt(v,10);return isNaN(S)?null:S>0?S:null}return null}o(v){const S=this.n(v);if(S!==null){if(typeof S=="number"){if(this.g===S)return;this.g=S}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:S}))}}p(v){return v==="auto"?"auto":v==="false"?!1:!!v}q(v){const S=this.p(v);if(typeof S=="boolean"){if(this.h===S)return;this.h=S}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:S}))}s(v){this.j!==v&&(this.j=v,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:v})))}t(v){this.k!==v&&(this.k=v,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:R.TextEditorLineNumbersStyle.from(v)})))}assign(v){const S={};let D=!1;if(typeof v.tabSize<"u"){const E=this.l(v.tabSize);E==="auto"?(D=!0,S.tabSize=E):typeof E=="number"&&this.f!==E&&(this.f=E,D=!0,S.tabSize=E)}if(typeof v.indentSize<"u"){const E=this.n(v.indentSize);E==="tabSize"?(D=!0,S.indentSize=E):typeof E=="number"&&this.g!==E&&(this.g=E,D=!0,S.indentSize=E)}if(typeof v.insertSpaces<"u"){const E=this.p(v.insertSpaces);E==="auto"?(D=!0,S.insertSpaces=E):this.h!==E&&(this.h=E,D=!0,S.insertSpaces=E)}typeof v.cursorStyle<"u"&&this.j!==v.cursorStyle&&(this.j=v.cursorStyle,D=!0,S.cursorStyle=v.cursorStyle),typeof v.lineNumbers<"u"&&this.k!==v.lineNumbers&&(this.k=v.lineNumbers,D=!0,S.lineNumbers=R.TextEditorLineNumbersStyle.from(v.lineNumbers)),D&&this.u("setOptions",this.c.$trySetOptions(this.d,S))}u(v,S){S.catch(D=>{this.e.warn(`ExtHostTextEditorOptions '${v}' failed:'`),this.e.warn(D)})}}e.$fM=$;class P{constructor(v,S,D,E,s,c,u,o){this.id=v,this.j=S,this.k=D,this.g=!1,this.h=new Set,this.c=s,this.d=new $(this.j,this.id,c,D),this.e=u,this.f=o;const g=this;this.value=Object.freeze({get document(){return E.value},set document(d){throw new M.$7("document")},get selection(){return g.c&&g.c[0]},set selection(d){if(!(d instanceof A.$bK))throw(0,M.$5)("selection");g.c=[d],g.l()},get selections(){return g.c},set selections(d){if(!Array.isArray(d)||d.some(t=>!(t instanceof A.$bK)))throw(0,M.$5)("selections");g.c=d,g.l()},get visibleRanges(){return g.e},set visibleRanges(d){throw new M.$7("visibleRanges")},get options(){return g.d.value},set options(d){g.g||g.d.assign(d)},get viewColumn(){return g.f},set viewColumn(d){throw new M.$7("viewColumn")},edit(d,t={undoStopBefore:!0,undoStopAfter:!0}){if(g.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const n=new k(E.value,t);return d(n),g.m(n)},insertSnippet(d,t,n={undoStopBefore:!0,undoStopAfter:!0}){if(g.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let r;if(!t||Array.isArray(t)&&t.length===0)r=g.c.map(i=>R.Range.from(i));else if(t instanceof A.$_J){const{lineNumber:i,column:a}=R.Position.from(t);r=[{startLineNumber:i,startColumn:a,endLineNumber:i,endColumn:a}]}else if(t instanceof A.$aK)r=[R.Range.from(t)];else{r=[];for(const i of t)if(i instanceof A.$aK)r.push(R.Range.from(i));else{const{lineNumber:a,column:h}=R.Position.from(i);r.push({startLineNumber:a,startColumn:h,endLineNumber:a,endColumn:h})}}return S.$tryInsertSnippet(v,E.value.version,d.value,r,n)},setDecorations(d,t){const n=t.length===0;n&&!g.h.has(d.key)||(n?g.h.delete(d.key):g.h.add(d.key),g.n(()=>{if(R.$7L(t))return S.$trySetDecorations(v,d.key,R.$8L(t));{const r=new Array(4*t.length);for(let i=0,a=t.length;i<a;i++){const h=t[i];r[4*i]=h.start.line+1,r[4*i+1]=h.start.character+1,r[4*i+2]=h.end.line+1,r[4*i+3]=h.end.character+1}return S.$trySetDecorationsFast(v,d.key,r)}}))},revealRange(d,t){g.n(()=>S.$tryRevealRange(v,R.Range.from(d),t||A.TextEditorRevealType.Default))},show(d){S.$tryShowEditor(v,R.ViewColumn.from(d))},hide(){S.$tryHideEditor(v)}})}dispose(){(0,y.ok)(!this.g),this.g=!0}_acceptOptions(v){(0,y.ok)(!this.g),this.d._accept(v)}_acceptVisibleRanges(v){(0,y.ok)(!this.g),this.e=v}_acceptViewColumn(v){(0,y.ok)(!this.g),this.f=v}_acceptSelections(v){(0,y.ok)(!this.g),this.c=v}async l(){const v=this.c.map(R.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,v)),this.value}m(v){const S=v.finalize();if(S.edits.length===0&&!S.setEndOfLine)return Promise.resolve(!0);const D=S.edits.map(s=>s.range);D.sort((s,c)=>s.end.line===c.end.line?s.end.character===c.end.character?s.start.line===c.start.line?s.start.character-c.start.character:s.start.line-c.start.line:s.end.character-c.end.character:s.end.line-c.end.line);for(let s=0,c=D.length-1;s<c;s++){const u=D[s].end;if(D[s+1].start.isBefore(u))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const E=S.edits.map(s=>({range:R.Range.from(s.range),text:s.text,forceMoveMarkers:s.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,S.documentVersionId,E,{setEndOfLine:typeof S.setEndOfLine=="number"?R.EndOfLine.from(S.setEndOfLine):void 0,undoStopBefore:S.undoStopBefore,undoStopAfter:S.undoStopAfter})}n(v){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):v().then(()=>this,S=>(S instanceof Error&&S.name==="DISPOSED"||this.k.warn(S),null))}}e.$gM=P}),define(Se[148],De([1,0,5,132]),function(ne,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tJ=void 0,e.$tJ=(0,y.$Mh)(M.$Sh)}),define(Se[149],De([1,0,25,4,15,3]),function(ne,e,y,M,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$93b=e.$83b=e.$73b=e.$63b=e.$53b=e.$43b=void 0;class A{constructor(c,u){this.versionId=c,this.removedDueToLooping=u}}e.$43b=A;class m{static isHostExtension(c,u,o){if(u.getExtensionDescription(c))return!1;const g=o.getExtensionDescription(c);return g?!!((g.main||g.browser)&&g.api==="none"):!1}constructor(c,u){this.j=c,this.c=new M.$Ld,this.onDidChange=this.c.event,this.d=0,this.e=u,this.k()}k(){this.e.sort(D),this.f=new y.$Zl,this.g=[],this.h=new Map;for(const c of this.e){if(this.f.has(c.identifier)){console.error("Extension `"+c.identifier.value+"` is already registered");continue}this.f.set(c.identifier,c),this.g.push(c);const u=this.j.readActivationEvents(c);if(Array.isArray(u))for(let o of u)o==="onUri"&&(o=`onUri:${y.$Xl.toKey(c.identifier)}`),this.h.has(o)||this.h.set(o,[]),this.h.get(o).push(c)}}set(c){return this.e=c,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(c,u){this.e=E(this.e,u),this.e=this.e.concat(c);const o=m.l(this.e);return this.e=E(this.e,o.map(g=>g.identifier)),this.k(),this.d++,this.c.fire(void 0),new A(this.d,o)}static l(c){const u=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(n){this.d.has(n)||(this.d.add(n),this.e.push(n))}addArc(n,r){this.addNode(n),this.addNode(r),this.c.has(n)?this.c.get(n).push(r):this.c.set(n,[r])}getArcs(n){return this.c.has(n)?this.c.get(n):[]}hasOnlyGoodArcs(n,r){const i=u.getArcs(n);for(let a=0;a<i.length;a++)if(!r.has(i[a]))return!1;return!0}getNodes(){return this.e}},o=new y.$Zl;for(const n of c)if(o.set(n.identifier,n),n.extensionDependencies)for(const r of n.extensionDependencies)u.addArc(y.$Xl.toKey(n.identifier),y.$Xl.toKey(r));const g=new Set;u.getNodes().filter(n=>u.getArcs(n).length===0).forEach(n=>g.add(n));const d=u.getNodes().filter(n=>!g.has(n));let t;do{t=!1;for(let n=0;n<d.length;n++){const r=d[n];u.hasOnlyGoodArcs(r,g)&&(d.splice(n,1),n--,g.add(r),t=!0)}}while(t);return d.map(n=>o.get(n))}containsActivationEvent(c){return this.h.has(c)}containsExtension(c){return this.f.has(c)}getExtensionDescriptionsForActivationEvent(c){const u=this.h.get(c);return u?u.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new k(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(c){const u=this.f.get(c);return u||void 0}getExtensionDescriptionByUUID(c){for(const u of this.g)if(u.uuid===c)return u}getExtensionDescriptionByIdOrUUID(c,u){return this.getExtensionDescription(c)??(u?this.getExtensionDescriptionByUUID(u):void 0)}}e.$53b=m;class k{constructor(c,u){this.versionId=c,this.extensions=u}}e.$63b=k,e.$73b={readActivationEvents:s=>s.activationEvents};class ${constructor(c){this.d=new v,this.c=new m(c,[])}async acquireLock(c){const u=await this.d.acquire(c);return new P(this,u)}deltaExtensions(c,u,o){if(!c.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(u,o)}containsActivationEvent(c){return this.c.containsActivationEvent(c)}containsExtension(c){return this.c.containsExtension(c)}getExtensionDescriptionsForActivationEvent(c){return this.c.getExtensionDescriptionsForActivationEvent(c)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(c){return this.c.getExtensionDescription(c)}getExtensionDescriptionByUUID(c){return this.c.getExtensionDescriptionByUUID(c)}getExtensionDescriptionByIdOrUUID(c,u){return this.c.getExtensionDescriptionByIdOrUUID(c,u)}}e.$83b=$;class P extends R.$Qc{constructor(c,u){super(),this.f=c,this.c=!1,this.B(u)}isAcquiredFor(c){return!this.c&&this.f===c}}e.$93b=P;class C{constructor(c){this.name=c,this.promise=new Promise((u,o)=>{this.c=u})}resolve(c){this.c(c)}}class v{constructor(){this.c=[],this.d=!1}async acquire(c){const u=new C(c);return this.c.push(u),this.e(),u.promise}e(){if(this.d||this.c.length===0)return;const c=this.c.shift();this.d=!0;let u=!0;const o=setTimeout(()=>{u&&console.warn(`The customer named ${c.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),g=()=>{u&&(clearTimeout(o),u=!1,this.d=!1,this.e())};c.resolve((0,R.$Oc)(g))}}var S;(function(s){s[s.Builtin=0]="Builtin",s[s.User=1]="User",s[s.Dev=2]="Dev"})(S||(S={}));function D(s,c){const u=s.isBuiltin?0:s.isUnderDevelopment?2:1,o=c.isBuiltin?0:c.isUnderDevelopment?2:1;if(u!==o)return u-o;const g=l.$ec.basename(s.extensionLocation.path),d=l.$ec.basename(c.extensionLocation.path);return g<d?-1:g>d?1:0}function E(s,c){const u=new y.$Yl(c);return s.filter(o=>!u.has(o.identifier))}}),define(Se[284],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tm=e.$sm=e.$rm=e.$qm=e.$pm=e.ExtHostConnectionType=void 0;var y;(function(P){P[P.IPC=1]="IPC",P[P.Socket=2]="Socket",P[P.MessagePort=3]="MessagePort"})(y||(e.ExtHostConnectionType=y={}));class M{constructor(C){this.pipeName=C,this.type=1}serialize(C){C[M.ENV_KEY]=this.pipeName}}e.$pm=M,M.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK";class l{constructor(){this.type=2}serialize(C){C[l.ENV_KEY]="1"}}e.$qm=l,l.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET";class R{constructor(){this.type=3}serialize(C){C[R.ENV_KEY]="1"}}e.$rm=R,R.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT";function A(P){delete P[M.ENV_KEY],delete P[l.ENV_KEY],delete P[R.ENV_KEY]}function m(P,C){A(C),P.serialize(C)}e.$sm=m;function k(P){if(P[M.ENV_KEY])return $(P,new M(P[M.ENV_KEY]));if(P[l.ENV_KEY])return $(P,new l);if(P[R.ENV_KEY])return $(P,new R);throw new Error("No connection information defined in environment!")}e.$tm=k;function $(P,C){return A(P),C}}),define(Se[112],De([1,0,22]),function(ne,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.$7l=e.$6l=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var M;(function($){$[$.Desktop=1]="Desktop",$[$.Web=2]="Web"})(M||(e.UIKind=M={}));var l;(function($){$[$.VersionMismatch=55]="VersionMismatch",$[$.UnexpectedError=81]="UnexpectedError"})(l||(e.ExtensionHostExitCode=l={}));var R;(function($){$[$.Initialized=0]="Initialized",$[$.Ready=1]="Ready",$[$.Terminate=2]="Terminate"})(R||(e.MessageType=R={}));function A($){const P=y.$_d.alloc(1);switch($){case 0:P.writeUInt8(1,0);break;case 1:P.writeUInt8(2,0);break;case 2:P.writeUInt8(3,0);break}return P}e.$6l=A;function m($,P){if($.byteLength!==1)return!1;switch($.readUInt8(0)){case 1:return P===0;case 2:return P===1;case 3:return P===2;default:return!1}}e.$7l=m;var k;(function($){$.Start="START_NATIVE_LOG",$.End="END_NATIVE_LOG"})(k||(e.NativeLogMarkers=k={}))}),define(Se[89],De([1,0,5,4,14,26,112,66,85,23,2,3,210]),function(ne,e,y,M,l,R,A,m,k,$,P,C,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rM=e.$qM=e.$pM=e.$oM=void 0;let S=class extends C.$Qc{constructor(c,u){super(),this.s=c,this.t=u,this.a=this.B(new M.$Ld),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new M.$Ld),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=P.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=u.createLogger(this.m,{id:k.$go,name:(0,v.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(u.onDidChangeLogLevel(o=>{(0,l.$8i)(o)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===l.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(c,u,o){const g=this.getTelemetryDetails(),d=new D(u,o,c,this.n,this.j,this.getBuiltInCommonProperties(c),{isUsageEnabled:g.isUsageEnabled,isErrorsEnabled:g.isErrorsEnabled}),t=this.r.get(c.identifier.value)??[];return this.r.set(c.identifier.value,[...t,d]),d.apiTelemetryLogger}$initializeTelemetryLevel(c,u,o){this.f=c,this.g=u,this.c=o??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(c){const u=Object.create(null);switch(u["common.extname"]=`${c.publisher}.${c.name}`,u["common.extversion"]=c.version,u["common.vscodemachineid"]=this.s.telemetryInfo.machineId,u["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,u["common.vscodeversion"]=this.s.version,u["common.isnewappinstall"]=E(this.s.telemetryInfo.firstSessionDate),u["common.product"]=this.s.environment.appHost,this.s.uiKind){case A.UIKind.Web:u["common.uikind"]="web";break;case A.UIKind.Desktop:u["common.uikind"]="desktop";break;default:u["common.uikind"]="unknown"}return u["common.remotename"]=(0,m.$Qk)((0,k.$no)(this.s.remote.authority)),u}$onDidChangeTelemetryLevel(c){this.h=this.getTelemetryConfiguration(),this.f=c;const u=this.getTelemetryDetails();this.r.forEach((o,g)=>{const d=o.filter(t=>!t.isDisposed);d.length===0?this.r.delete(g):this.r.set(g,d)}),this.r.forEach(o=>{for(const g of o)g.updateTelemetryEnablements(u.isUsageEnabled,u.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(c,u){const g=this.r.get(c.value)?.filter(t=>!t.isDisposed);if(!g)return this.r.delete(c.value),!1;let d=!1;for(const t of g)t.ignoreUnhandledExtHostErrors||(t.logError(u),d=!0);return d}};e.$oM=S,e.$oM=S=Ke([We(0,R.$nM),We(1,l.$7i)],S);class D{static validateSender(c){if(typeof c!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof c.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof c.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof c.flush<"u"&&typeof c.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(c,u,o,g,d,t,n){this.g=o,this.h=g,this.i=d,this.j=t,this.a=new M.$Ld,this.ignoreUnhandledExtHostErrors=u?.ignoreUnhandledErrors??!1,this.b=u?.ignoreBuiltInCommonProperties??!1,this.c=u?.additionalCommonProperties,this.f=c,this.d={isUsageEnabled:n.isUsageEnabled,isErrorsEnabled:n.isErrorsEnabled}}updateTelemetryEnablements(c,u){this.e&&(this.d={isUsageEnabled:c,isErrorsEnabled:u},this.a.fire(this.e))}mixInCommonPropsAndCleanData(c){let u="properties"in c?c.properties??{}:c;return u=(0,k.$qo)(u,[]),this.c&&(u=(0,$.$1m)(u,this.c)),this.b||(u=(0,$.$1m)(u,this.j)),"properties"in c?c.properties=u:c=u,c}k(c,u){this.f&&(this.g.publisher==="vscode"?c=this.g.name+"/"+c:c=this.g.identifier.value+"/"+c,u=this.mixInCommonPropsAndCleanData(u||{}),this.i||this.f?.sendEventData(c,u),this.h.trace(c,u))}logUsage(c,u){this.d.isUsageEnabled&&this.k(c,u)}logError(c,u){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof c=="string")this.k(c,u);else{const o={name:c.name,message:c.message,stack:c.stack,cause:c.cause},g=(0,k.$qo)(o,[]),d=new Error(g.message,{cause:g.cause});d.stack=g.stack,d.name=g.name,u=this.mixInCommonPropsAndCleanData(u||{}),this.i||this.f.sendErrorData(d,u),this.h.trace("exception",u)}}get apiTelemetryLogger(){if(!this.e){const c=this,u={logUsage:c.logUsage.bind(c),get isUsageEnabled(){return c.d.isUsageEnabled},get isErrorsEnabled(){return c.d.isErrorsEnabled},logError:c.logError.bind(c),dispose:c.dispose.bind(c),onDidChangeEnableStates:c.a.event.bind(c)};this.e=Object.freeze(u)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let c=this.f;this.f=void 0,Promise.resolve(c.flush()).then(c=void 0),this.e=void 0}else this.f=void 0}}e.$pM=D;function E(s){const c=Date.now()-new Date(s).getTime();return isNaN(c)?!1:c<1e3*60*60*24}e.$qM=E,e.$rM=(0,y.$Lh)("IExtHostTelemetry")}),define(Se[27],De([1,0,4,2,252,138,25,5]),function(ne,e,y,M,l,R,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aF=e.$_E=e.$$E=e.ActivationKind=e.$0E=e.$9E=e.$8E=e.$7E=e.$6E=e.ExtensionHostStartup=e.$5E=e.$4E=e.$3E=e.$2E=void 0,e.$2E=Object.freeze({identifier:new A.$Xl("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:M.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$3E="extensions.webWorker",e.$4E=(0,m.$Lh)("extensionService");class k{constructor(d){this.dependency=d}}e.$5E=k;var $;(function(g){g[g.EagerAutoStart=1]="EagerAutoStart",g[g.EagerManualStart=2]="EagerManualStart",g[g.Lazy=3]="Lazy"})($||(e.ExtensionHostStartup=$={}));class P{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(d,t,n){this.c=d,this.d=t.slice(0),this.e=n.slice(0)}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:R.$ME.createActivationEventsMap(this.d)}}set(d,t,n){if(this.c>d)throw new Error(`ExtensionHostExtensions: invalid versionId ${d} (current: ${this.c})`);const r=[],i=[],a=[],h=[],p=C(this.d),I=C(t),w=(T,F)=>T.extensionLocation.toString()===F.extensionLocation.toString()||T.isBuiltin===F.isBuiltin||T.isUserBuiltin===F.isUserBuiltin||T.isUnderDevelopment===F.isUnderDevelopment;for(const T of this.d){const F=I.get(T.identifier);if(!F){r.push(T.identifier),p.delete(T.identifier);continue}if(!w(T,F)){r.push(T.identifier),p.delete(T.identifier);continue}}for(const T of t){const F=p.get(T.identifier);if(!F){i.push(T);continue}if(!w(F,T)){r.push(F.identifier),p.delete(F.identifier);continue}}const f=new A.$Yl(this.e),b=new A.$Yl(n);for(const T of this.e)b.has(T)||a.push(T);for(const T of n)f.has(T)||h.push(T);const L=R.$ME.createActivationEventsMap(i),O={versionId:d,toRemove:r,toAdd:i,addActivationEvents:L,myToRemove:a,myToAdd:h};return this.delta(O),O}delta(d){if(this.c>=d.versionId)return null;const{toRemove:t,toAdd:n,myToRemove:r,myToAdd:i}=d,a=new A.$Yl(t),h=new A.$Yl(r);for(let p=0;p<this.d.length;p++)a.has(this.d[p].identifier)&&(this.d.splice(p,1),p--);for(let p=0;p<this.e.length;p++)h.has(this.e[p])&&(this.e.splice(p,1),p--);for(const p of n)this.d.push(p);for(const p of i)this.e.push(p);return d}containsExtension(d){for(const t of this.e)if(A.$Xl.equals(t,d))return!0;return!1}}e.$6E=P;function C(g){const d=new A.$Zl;for(const t of g)d.set(t.identifier,t);return d}function v(g,d){return!0}e.$7E=v;function S(g,d){if(!v(g,d))throw new Error(`Extension '${g.identifier.value}' CANNOT use API proposal: ${d}.
Its package.json#enabledApiProposals-property declares: ${g.enabledApiProposals?.join(", ")??"[]"} but NOT ${d}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${g.identifier.value}`)}e.$8E=S;class D{constructor(d,t,n,r){this.codeLoadingTime=d,this.activateCallTime=t,this.activateResolvedTime=n,this.activationReason=r}}e.$9E=D;class E{constructor(d,t){this.description=d,this.value=t}}e.$0E=E;var s;(function(g){g[g.Normal=0]="Normal",g[g.Immediate=1]="Immediate"})(s||(e.ActivationKind=s={}));function c(g){return{type:g.isBuiltin?0:1,isBuiltin:g.isBuiltin||g.isUserBuiltin,identifier:{id:(0,l.$wo)(g.publisher,g.name),uuid:g.uuid},manifest:g,location:g.extensionLocation,targetPlatform:g.targetPlatform,validations:[],isValid:!0}}e.$$E=c;function u(g,d){return{identifier:new A.$Xl((0,l.$uo)(g.manifest.publisher,g.manifest.name)),isBuiltin:g.type===0,isUserBuiltin:g.type===1&&g.isBuiltin,isUnderDevelopment:!!d,extensionLocation:g.location,...g.manifest,uuid:g.identifier.uuid,targetPlatform:g.targetPlatform}}e.$_E=u;class o{constructor(){this.onDidRegisterExtensions=y.Event.None,this.onDidChangeExtensionsStatus=y.Event.None,this.onDidChangeExtensions=y.Event.None,this.onWillActivateByEvent=y.Event.None,this.onDidChangeResponsiveChange=y.Event.None,this.onWillStop=y.Event.None,this.extensions=[]}activateByEvent(d){return Promise.resolve(void 0)}activationEventIsDone(d){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(d){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(d,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(d){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$aF=o}),define(Se[285],De([1,0,8,149,25,27,14,9]),function(ne,e,y,M,l,R,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ybc=e.$Xbc=e.$Wbc=e.$Vbc=e.$Ubc=e.$Tbc=void 0;class k{constructor(c,u,o,g){this.startup=c,this.codeLoadingTime=u,this.activateCallTime=o,this.activateResolvedTime=g}}e.$Tbc=k,k.NONE=new k(!1,-1,-1,-1);class ${constructor(c){this.a=c,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(c,u){return c===-1||u===-1?-1:u-c}build(){return new k(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$Ubc=$;class P{constructor(c,u,o,g,d,t){this.activationFailed=c,this.activationFailedError=u,this.activationTimes=o,this.module=g,this.exports=d,this.subscriptions=t}}e.$Vbc=P;class C extends P{constructor(c){super(!1,null,c,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Wbc=C;class v extends P{constructor(){super(!1,null,k.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Xbc=v;class S extends P{constructor(c){super(!0,c,k.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let D=class{constructor(c,u,o,g){this.g=g,this.a=c,this.b=u,this.c=o,this.d=new l.$Zl,this.f=Object.create(null)}dispose(){for(const[c,u]of this.d)u.dispose()}async waitForActivatingExtensions(){const c=[];for(const[u,o]of this.d)c.push(o.wait());await Promise.all(c)}isActivated(c){const u=this.d.get(c);return!!(u&&u.value)}getActivatedExtension(c){const u=this.d.get(c);if(!u||!u.value)throw new Error(`Extension '${c.value}' is not known or not activated`);return u.value}async activateByEvent(c,u){if(this.f[c])return;const o=this.a.getExtensionDescriptionsForActivationEvent(c);await this.h(o.map(g=>({id:g.identifier,reason:{startup:u,extensionId:g.identifier,activationEvent:c}}))),this.f[c]=!0}activateById(c,u){const o=this.a.getExtensionDescription(c);if(!o)throw new Error(`Extension '${c}' is not known`);return this.h([{id:o.identifier,reason:u}])}async h(c){const u=c.filter(o=>!this.isActivated(o.id)).map(o=>this.j(o));await Promise.all(u.map(o=>o.wait()))}j(c){if(this.d.has(c.id))return this.d.get(c.id);if(this.l(c.id))return this.k(c,null,[],null);const u=this.a.getExtensionDescription(c.id);if(!u){const d=new Error(`Cannot activate unknown extension '${c.id.value}'`),t=this.k(c,null,[],new S(d));return this.c.onExtensionActivationError(c.id,d,new R.$5E(c.id.value)),t}const o=[],g=typeof u.extensionDependencies>"u"?[]:u.extensionDependencies;for(const d of g){if(this.m(d))continue;const t=this.d.get(d);if(t){o.push(t);continue}if(this.l(d)){o.push(this.j({id:this.b.getExtensionDescription(d).identifier,reason:c.reason}));continue}const n=this.a.getExtensionDescription(d);if(n){if(!n.main&&!n.browser)continue;o.push(this.j({id:n.identifier,reason:c.reason}));continue}const r=u.displayName||u.identifier.value,i=new Error(`Cannot activate the '${r}' extension because it depends on unknown extension '${d}'`),a=this.k(c,u.displayName,[],new S(i));return this.c.onExtensionActivationError(u.identifier,i,new R.$5E(d)),a}return this.k(c,u.displayName,o,null)}k(c,u,o,g){const d=new E(c.id,u,c.reason,o,g,this.c,this.g);return this.d.set(c.id,d),d}l(c){return M.$53b.isHostExtension(c,this.a,this.b)}m(c){const u=this.b.getExtensionDescription(c);return u?!u.main&&!u.browser:!1}};e.$Ybc=D,e.$Ybc=D=Ke([We(3,A.$6i)],D);let E=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(c,u,o,g,d,t,n){this.c=c,this.d=u,this.f=o,this.g=g,this.h=d,this.j=t,this.k=n,this.a=new m.$Pg,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let c=0;c<this.g.length;c++){const u=this.g[c];if(u.value&&!u.value.activationFailed){this.g.splice(c,1),c--;continue}if(u.value&&u.value.activationFailed){const o=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${u.friendlyName}' failed to activate`);o.detail=u.value.activationFailedError,this.h=new S(o),this.j.onExtensionActivationError(this.c,o,null);return}}this.g.length>0&&await Promise.race(this.g.map(c=>c.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(c){const u=new Error;if(c&&c.name&&(u.name=c.name),c&&c.message?u.message=`Activating extension '${this.c.value}' failed: ${c.message}.`:u.message=`Activating extension '${this.c.value}' failed: ${c}.`,c&&c.stack&&(u.stack=c.stack),this.h=new S(u),this.b&&y.$2(c))return;this.j.onExtensionActivationError(this.c,u,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(c)}}};E=Ke([We(6,A.$6i)],E)}),define(Se[286],De([1,0,212,24,2,4,3,268,9,7,18,19,13,80,21,179,27]),function(ne,e,y,M,l,R,A,m,k,$,P,C,v,S,D,E,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ycc=void 0;function c(g,d){if((0,P.$wf)(g))return{label:g};if(g&&typeof g=="object"&&typeof g.label=="string"){let t;return Array.isArray(g.highlights)&&(t=g.highlights.filter(n=>n.length===2&&typeof n[0]=="number"&&typeof n[1]=="number"),t=t.length?t:void 0),{label:g.label,highlights:t}}}class u extends A.$Qc{constructor(d,t,n){super(),this.f=d,this.g=t,this.h=n,this.a=new Map,this.b=new E.$y7;function r(i){return i&&i.$treeViewId&&(i.$treeItemHandle||i.$selectedTreeItems||i.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:i=>r(i)?this.r(i):Array.isArray(i)&&i.length>0?i.map(a=>r(a)?this.r(a):a):i})}registerTreeDataProvider(d,t,n){const r=this.createTreeView(d,{treeDataProvider:t},n);return{dispose:()=>r.dispose()}}createTreeView(d,t,n){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const r=t.dragAndDropController?.dropMimeTypes??[],i=t.dragAndDropController?.dragMimeTypes??[],a=!!t.dragAndDropController?.handleDrag,h=!!t.dragAndDropController?.handleDrop,p=this.m(d,t,n),I={showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:r,dragMimeTypes:i,hasHandleDrag:a,hasHandleDrop:h,manuallyManageCheckboxes:!!t.manageCheckboxStateManually},w=this.f.$registerTreeViewDataProvider(d,I),f={get onDidCollapseElement(){return p.onDidCollapseElement},get onDidExpandElement(){return p.onDidExpandElement},get selection(){return p.selectedElements},get onDidChangeSelection(){return p.onDidChangeSelection},get activeItem(){return(0,s.$8E)(n,"treeViewActiveItem"),p.focusedElement},get onDidChangeActiveItem(){return(0,s.$8E)(n,"treeViewActiveItem"),p.onDidChangeActiveItem},get visible(){return p.visible},get onDidChangeVisibility(){return p.onDidChangeVisibility},get onDidChangeCheckboxState(){return p.onDidChangeCheckboxState},get message(){return p.message},set message(b){(0,S.$1j)(b)&&(0,s.$8E)(n,"treeViewMarkdownMessage"),p.message=b},get title(){return p.title},set title(b){p.title=b},get description(){return p.description},set description(b){p.description=b},get badge(){return p.badge},set badge(b){b!==void 0&&$.ViewBadge.isViewBadge(b)?p.badge={value:Math.floor(Math.abs(b.value)),tooltip:b.tooltip}:b===void 0&&(p.badge=void 0)},reveal:(b,L)=>p.reveal(b,L),dispose:async()=>{await w,this.a.delete(d),p.dispose()}};return this.B(f),f}$getChildren(d,t){const n=this.a.get(d);return n?n.getChildren(t):Promise.reject(new m.$hE(d))}async $handleDrop(d,t,n,r,i,a,h,p){const I=this.a.get(d);if(!I)return Promise.reject(new m.$hE(d));const w=v.DataTransfer.toDataTransfer(n,async f=>(await this.f.$resolveDropFileData(d,t,f)).buffer);return h===d&&p&&await this.j(w,I,p,i,a),I.onDrop(w,r,i)}async j(d,t,n,r,i){const a=this.b.removeDragOperationTransfer(i);if(a)(await a)?.forEach((h,p)=>{h&&d.set(p,h)});else if(i&&t.handleDrag){const h=t.handleDrag(n,d,r);this.b.addDragOperationTransfer(i,h),await h}return d}async $handleDrag(d,t,n,r){const i=this.a.get(d);if(!i)return Promise.reject(new m.$hE(d));const a=await this.j(new $.$2K,i,t,r,n);if(!(!a||r.isCancellationRequested))return v.DataTransfer.from(a)}async $hasResolve(d){const t=this.a.get(d);if(!t)throw new m.$hE(d);return t.hasResolve}$resolve(d,t,n){const r=this.a.get(d);if(!r)throw new m.$hE(d);return r.resolveTreeItem(t,n)}$setExpanded(d,t,n){const r=this.a.get(d);if(!r)throw new m.$hE(d);r.setExpanded(t,n)}$setSelectionAndFocus(d,t,n){const r=this.a.get(d);if(!r)throw new m.$hE(d);r.setSelectionAndFocus(t,n)}$setVisible(d,t){const n=this.a.get(d);if(!n){if(!t)return;throw new m.$hE(d)}n.setVisible(t)}$changeCheckboxState(d,t){const n=this.a.get(d);if(!n)throw new m.$hE(d);n.setCheckboxState(t)}m(d,t,n){const r=this.B(new o(d,t,this.f,this.g.converter,this.h,n));return this.a.set(d,r),r}r(d){const t=this.a.get(d.$treeViewId);return t&&"$treeItemHandle"in d?t.getExtensionElement(d.$treeItemHandle):t&&"$focusedTreeItem"in d&&d.$focusedTreeItem?t.focusedElement:null}}e.$ycc=u;class o extends A.$Qc{get visible(){return this.r}get selectedElements(){return this.s.map(d=>this.getExtensionElement(d)).filter(d=>!(0,P.$Ff)(d))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(d,t,n,r,i,a){if(super(),this.I=d,this.J=n,this.L=r,this.M=i,this.N=a,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new R.$Ld),this.onDidExpandElement=this.u.event,this.w=this.B(new R.$Ld),this.onDidCollapseElement=this.w.event,this.y=this.B(new R.$Ld),this.onDidChangeSelection=this.y.event,this.z=this.B(new R.$Ld),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new R.$Ld),this.onDidChangeVisibility=this.C.event,this.D=this.B(new R.$Ld),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new R.$Ld),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new D.$Vd,a.contributes&&a.contributes.views)for(const w in a.contributes.views)for(const f of a.contributes.views[w])f.id===d&&(this.P=f.name);this.f=t.treeDataProvider,this.g=t.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(w=>this.F.fire({message:!1,element:w})));let h,p;const I=R.Event.debounce(this.F.event,(w,f)=>(w||(w={message:!1,elements:[]}),f.element!==!1&&(h||(h=new Promise(b=>p=b),this.G=this.G.then(()=>h)),Array.isArray(f.element)?w.elements.push(...f.element):w.elements.push(f.element)),f.message&&(w.message=!0),w),200,!0);this.B(I(({message:w,elements:f})=>{f.length&&(this.H=this.H.then(()=>{const b=p;return h=null,this.$(f).then(()=>b())})),w&&this.J.$setMessage(this.I,v.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(d){const t=d?this.getExtensionElement(d):void 0;if(d&&!t)return this.M.error(`No tree item with id '${d}' found.`),Promise.resolve([]);let n=this.X(d);return n||(n=await this.Y(t)),n?n.map(r=>r.item):void 0}getExtensionElement(d){return this.j.get(d)}reveal(d,t){t=t||{select:!0,focus:!1};const n=(0,P.$Ff)(t.select)?!0:t.select,r=(0,P.$Ff)(t.focus)?!1:t.focus,i=(0,P.$Ff)(t.expand)?!1:t.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):d?this.G.then(()=>this.S(d)).then(a=>this.W(d,a[a.length-1]).then(h=>this.J.$reveal(this.I,{item:h.item,parentChain:a.map(p=>p.item)},{select:n,focus:r,expand:i})),a=>this.M.error(a)):this.J.$reveal(this.I,void 0,{select:n,focus:r,expand:i})}get message(){return this.O}set message(d){this.O=d,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(d){this.P=d,this.J.$setTitle(this.I,d,this.Q)}get description(){return this.Q}set description(d){this.Q=d,this.J.$setTitle(this.I,this.P,d)}get badge(){return this.R}set badge(d){this.R?.value===d?.value&&this.R?.tooltip===d?.tooltip||(this.R=v.ViewBadge.from(d),this.J.$setBadge(this.I,d))}setExpanded(d,t){const n=this.getExtensionElement(d);n&&(t?this.u.fire(Object.freeze({element:n})):this.w.fire(Object.freeze({element:n})))}setSelectionAndFocus(d,t){const n=!(0,C.$sb)(this.s,d);this.s=d;const r=this.t!==t;this.t=t,n&&this.y.fire(Object.freeze({selection:this.selectedElements})),r&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(d){d!==this.r&&(this.r=d,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(d){const t=(await Promise.all(d.map(async n=>{const r=this.getExtensionElement(n.treeItemHandle);return r?{extensionItem:r,treeItem:await this.f.getTreeItem(r),newState:n.newState?$.TreeItemCheckboxState.Checked:$.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(n=>n!==void 0);t.forEach(n=>{n.treeItem.checkboxState=n.newState?$.TreeItemCheckboxState.Checked:$.TreeItemCheckboxState.Unchecked}),this.D.fire({items:t.map(n=>[n.extensionItem,n.newState])})}async handleDrag(d,t,n){const r=[];for(const i of d){const a=this.getExtensionElement(i);a&&r.push(a)}if(!(!this.g?.handleDrag||r.length===0))return await this.g.handleDrag(r,t,n),t}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(d,t,n){const r=t?this.getExtensionElement(t):void 0;if(!(!r&&t||!this.g?.handleDrop))return(0,k.$Jg)(()=>this.g?.handleDrop?this.g.handleDrop(r,d,n):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(d,t){if(!this.f.resolveTreeItem)return;const n=this.j.get(d);if(n){const r=this.m.get(n);if(r){const i=await this.f.resolveTreeItem(r.extensionItem,n,t)??r.extensionItem;return this.hb(i),r.item.tooltip=this.eb(i.tooltip),r.item.command=this.fb(r.disposableStore,i.command),r.item}}}S(d){return this.U(d).then(t=>t?this.S(t).then(n=>this.W(t,n[n.length-1]).then(r=>(n.push(r),n))):Promise.resolve([]))}U(d){const t=this.m.get(d);return t?Promise.resolve(t.parent?this.j.get(t.parent.item.handle):void 0):(0,k.$Jg)(()=>this.f.getParent(d))}W(d,t){const n=this.m.get(d);return n?Promise.resolve(n):(0,k.$Jg)(()=>this.f.getTreeItem(d)).then(r=>this.kb(d,r,t,!0)).then(r=>this.getChildren(t?t.item.handle:void 0).then(()=>{const i=this.getExtensionElement(r);if(i){const a=this.m.get(i);if(a)return Promise.resolve(a)}throw new Error(`Cannot resolve tree item for element ${r} from extension ${this.N.identifier.value}`)}))}X(d){if(d){let t;if(typeof d=="string"){const n=this.getExtensionElement(d);t=n?this.m.get(n):void 0}else t=d;return t&&t.children||void 0}return this.h}async Y(d){this.rb(d);const t=new D.$Vd(this.Z.token);try{const n=d?this.m.get(d):void 0,r=await this.f.getChildren(d);if(t.token.isCancellationRequested)return;const i=await Promise.all((0,C.$Fb)(r||[]).map(async a=>{const h=await this.f.getTreeItem(a);return h&&!t.token.isCancellationRequested?this.db(a,h,n):null}));return t.token.isCancellationRequested?void 0:(0,C.$Fb)(i)}finally{t.dispose()}}$(d){if(d.some(n=>!n))return this.Z.dispose(!0),this.Z=new D.$Vd,this.tb(),this.J.$refresh(this.I);{const n=this.ab(d);if(n.length)return this.bb(n)}return Promise.resolve(void 0)}ab(d){const t=new Set,n=d.map(i=>this.m.get(i));for(const i of n)if(i&&!t.has(i.item.handle)){let a=i;for(;a&&a.parent&&n.findIndex(h=>a&&a.parent&&h&&h.item.handle===a.parent.item.handle)===-1;){const h=this.j.get(a.parent.item.handle);a=h?this.m.get(h):void 0}a&&!a.parent&&t.add(i.item.handle)}const r=[];return t.forEach(i=>{const a=this.j.get(i);if(a){const h=this.m.get(a);h&&(!h.parent||!t.has(h.parent.item.handle))&&r.push(i)}}),r}bb(d){const t={};return Promise.all(d.map(n=>this.cb(n).then(r=>{r&&(t[n]=r.item)}))).then(()=>Object.keys(t).length?this.J.$refresh(this.I,t):void 0)}cb(d){const t=this.getExtensionElement(d);if(t){const n=this.m.get(t);if(n)return this.rb(t),(0,k.$Jg)(()=>this.f.getTreeItem(t)).then(r=>{if(r){const i=this.ib(t,r,n.parent);return this.pb(t,i,n,n.parent),n.dispose(),i}return null})}return Promise.resolve(null)}db(d,t,n){const r=this.ib(d,t,n);if(t.id&&this.j.has(r.item.handle))throw new Error((0,y.localize)(0,null,t.id));return this.ob(d,r),this.qb(r,n),r}eb(d){return $.$yK.isMarkdownString(d)?v.MarkdownString.from(d):d}fb(d,t){return t?{...this.L.toInternal(t,d),originalId:t.command}:void 0}gb(d){if(d.checkboxState===void 0)return;let t,n,r;return typeof d.checkboxState=="number"?t=d.checkboxState:(t=d.checkboxState.state,n=d.checkboxState.tooltip,r=d.checkboxState.accessibilityInformation),{isChecked:t===$.TreeItemCheckboxState.Checked,tooltip:n,accessibilityInformation:r}}hb(d){if(!$.$WK.isTreeItem(d,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(d,t,n){this.hb(t);const r=this.B(new A.$Pc),i=this.kb(d,t,n),a=this.lb(t);return{item:{handle:i,parentHandle:n?n.item.handle:void 0,label:c(t.label,this.N),description:t.description,resourceUri:t.resourceUri,tooltip:this.eb(t.tooltip),command:this.fb(r,t.command),contextValue:t.contextValue,icon:a,iconDark:this.mb(t)||a,themeIcon:this.jb(t),collapsibleState:(0,P.$Ff)(t.collapsibleState)?$.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.gb(t)},extensionItem:t,parent:n,children:void 0,disposableStore:r,dispose(){r.dispose()}}}jb(d){return d.iconPath instanceof $.$5K?d.iconPath:void 0}kb(d,{id:t,label:n,resourceUri:r},i,a){if(t)return`${o.b}/${t}`;const h=c(n,this.N),p=i?i.item.handle:o.a;let I=h?h.label:r?(0,M.$pg)(r):"";I=I.indexOf("/")!==-1?I.replace("/","//"):I;const w=this.m.has(d)?this.m.get(d).item.handle:void 0,f=this.X(i)||[];let b,L=0;do{if(b=`${p}/${L}:${I}`,a||!this.j.has(b)||w===b)break;L++}while(L<=f.length);return b}lb(d){if(d.iconPath&&!(d.iconPath instanceof $.$5K))return typeof d.iconPath=="string"||l.URI.isUri(d.iconPath)?this.nb(d.iconPath):this.nb(d.iconPath.light)}mb(d){if(d.iconPath&&!(d.iconPath instanceof $.$5K)&&d.iconPath.dark)return this.nb(d.iconPath.dark)}nb(d){return l.URI.isUri(d)?d:l.URI.file(d)}ob(d,t){this.j.set(t.item.handle,d),this.m.set(d,t)}pb(d,t,n,r){this.j.delete(t.item.handle),this.m.delete(d),t.item.handle!==n.item.handle&&this.j.delete(n.item.handle),this.ob(d,t);const i=this.X(r)||[],a=i.filter(h=>h.item.handle===n.item.handle)[0];a&&i.splice(i.indexOf(a),1,t)}qb(d,t){t?(t.children||(t.children=[]),t.children.push(d)):(this.h||(this.h=[]),this.h.push(d))}rb(d){if(d){const t=this.m.get(d);if(t){if(t.children)for(const n of t.children){const r=this.j.get(n.item.handle);r&&this.sb(r)}t.children=void 0}}else this.tb()}sb(d){const t=this.m.get(d);if(t){if(t.children)for(const n of t.children){const r=this.j.get(n.item.handle);r&&this.sb(r)}this.m.delete(d),this.j.delete(t.item.handle),t.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(d=>d.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}o.a="0",o.b="1"}),define(Se[287],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chat:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chat.d.ts",chatAgents:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatRequestAccess:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatRequestAccess.d.ts",chatSlashCommands:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatSlashCommands.d.ts",chatVariables:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariables.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveUserActions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveUserActions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",readonlyMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.readonlyMessage.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",saveEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.saveEditor.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testMessageContextValue:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testMessageContextValue.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Se[288],De([1,0,224,8,39,133,106,42,25,287,136,138]),function(ne,e,y,M,l,R,A,m,k,$,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1E=e.$ZE=e.$YE=e.$XE=e.$WE=e.$VE=void 0;const v=m.$0m.as(A.$$m.JSONContribution);class S{constructor(d,t,n){this.a=d,this.b=t,this.c=n}d(d,t){this.a({type:d,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(d){this.d(l.default.Error,d)}warn(d){this.d(l.default.Warning,d)}info(d){this.d(l.default.Info,d)}}e.$VE=S;class D{static a(d){const t=new k.$Yl;for(let n=0,r=d.length;n<r;n++)t.add(d[n].description.identifier);return t}static compute(d,t){if(!d||!d.length)return new D(t,[]);if(!t||!t.length)return new D([],d);const n=this.a(d),r=this.a(t),i=t.filter(h=>!n.has(h.description.identifier)),a=d.filter(h=>!r.has(h.description.identifier));return new D(i,a)}constructor(d,t){this.added=d,this.removed=t}}e.$WE=D;class E{constructor(d,t){this.name=d,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(d){if(this.a!==null)throw new Error("Handler already set!");this.a=d,this.d()}acceptUsers(d){this.c=D.compute(this.b,d),this.b=d,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(d){(0,M.$Y)(d)}}}e.$XE=E;const s={type:"string",enum:["ui","workspace"],enumDescriptions:[y.localize(0,null),y.localize(1,null)]},c="vscode://schemas/vscode-extensions";e.$YE={properties:{engines:{type:"object",description:y.localize(2,null),properties:{vscode:{type:"string",description:y.localize(3,null),default:"^1.22.0"}}},publisher:{description:y.localize(4,null),type:"string"},displayName:{description:y.localize(5,null),type:"string"},categories:{description:y.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:k.$Wl},{type:"string",const:"Languages",deprecationMessage:y.localize(7,null)}]}},galleryBanner:{type:"object",description:y.localize(8,null),properties:{color:{description:y.localize(9,null),type:"string"},theme:{description:y.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:y.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:y.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:y.localize(13,null)},enabledApiProposals:{markdownDescription:y.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys($.allApiProposals),markdownEnumDescriptions:Object.values($.allApiProposals)}},api:{markdownDescription:y.localize(15,null),type:"string",enum:["none"],enumDescriptions:[y.localize(16,null)]},activationEvents:{description:y.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:y.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:y.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:y.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:y.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:y.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:y.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:y.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:y.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:y.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:y.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:y.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:y.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:y.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:y.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:y.localize(32,null)},{label:"onUri",body:"onUri",description:y.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:y.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:y.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:y.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:y.localize(37,null)},{label:"onRenderer",description:y.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:y.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:y.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:y.localize(41,null)},{label:"*",description:y.localize(42,null),body:"*"}]}},badges:{type:"array",description:y.localize(43,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:y.localize(44,null)},href:{type:"string",description:y.localize(45,null)},description:{type:"string",description:y.localize(46,null)}}}},markdown:{type:"string",description:y.localize(47,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:y.localize(48,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:y.localize(49,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:R.$On}},extensionPack:{description:y.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:R.$On}},extensionKind:{description:y.localize(51,null),type:"array",items:s,default:["workspace"],defaultSnippets:[{body:["ui"],description:y.localize(52,null)},{body:["workspace"],description:y.localize(53,null)},{body:["ui","workspace"],description:y.localize(54,null)},{body:["workspace","ui"],description:y.localize(55,null)},{body:[],description:y.localize(56,null)}]},capabilities:{description:y.localize(57,null),type:"object",properties:{virtualWorkspaces:{description:y.localize(58,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:y.localize(59,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[y.localize(60,null),y.localize(61,null),y.localize(62,null)]},description:{type:"string",markdownDescription:y.localize(63,null)}}},untrustedWorkspaces:{description:y.localize(64,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:y.localize(65,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[y.localize(66,null),y.localize(67,null),y.localize(68,null)]},restrictedConfigurations:{description:y.localize(69,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:y.localize(70,null)}}}}},sponsor:{description:y.localize(71,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:y.localize(72,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:y.localize(73,null),type:"string"},"vscode:uninstall":{description:y.localize(74,null),type:"string"}}},icon:{type:"string",description:y.localize(75,null)},l10n:{type:"string",description:y.localize(76,null)},pricing:{type:"string",markdownDescription:y.localize(77,null),enum:["Free","Trial"],default:"Free"}}};class u{constructor(){this.a=new Map}registerExtensionPoint(d){if(this.a.has(d.extensionPoint))throw new Error("Duplicate extension point: "+d.extensionPoint);const t=new E(d.extensionPoint,d.defaultExtensionKind);return this.a.set(d.extensionPoint,t),d.activationEventsGenerator&&C.$ME.register(d.extensionPoint,d.activationEventsGenerator),e.$YE.properties.contributes.properties[d.extensionPoint]=d.jsonSchema,v.registerSchema(c,e.$YE),t}getExtensionPoints(){return Array.from(this.a.values())}}e.$ZE=u;const o={ExtensionsRegistry:"ExtensionsRegistry"};m.$0m.add(o.ExtensionsRegistry,new u),e.$1E=m.$0m.as(o.ExtensionsRegistry),v.registerSchema(c,e.$YE),v.registerSchema(P.$mj,{properties:{extensionEnabledApiProposals:{description:y.localize(78,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys($.allApiProposals),markdownEnumDescriptions:Object.values($.allApiProposals)}}]}}}})}),define(Se[289],De([1,0,221,18,23,288,41,4]),function(ne,e,y,M,l,R,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JF=void 0;const k={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:y.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:y.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:y.localize(2,null),default:""}}};var $;(function(v){function S(D,E,s){if(!D)return;const c=M.$wf(D.type)?D.type:void 0;if(!c||c.length===0){s.error(y.localize(3,null));return}const u=[];if(Array.isArray(D.required))for(const o of D.required)M.$wf(o)&&u.push(o);return{extensionId:E.value,taskType:c,required:u,properties:D.properties?l.$Xm(D.properties):{},when:D.when?A.$Ji.deserialize(D.when):void 0}}v.from=S})($||($={}));const P=R.$1E.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(v,S)=>{for(const D of v)D.type&&S.push(`onTaskType:${D.type}`)},jsonSchema:{description:y.localize(4,null),type:"array",items:k}});class C{constructor(){this.d=new m.$Ld,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((S,D)=>{P.setHandler((E,s)=>{this.c=void 0;try{for(const c of s.removed){const u=c.value;for(const o of u)this.a&&o.type&&this.a[o.type]&&delete this.a[o.type]}for(const c of s.added){const u=c.value;for(const o of u){const g=$.from(o,c.description.identifier,c.collector);g&&(this.a[g.taskType]=g)}}(s.removed.length>0||s.added.length>0)&&this.d.fire()}catch{}S(void 0)})})}onReady(){return this.b}get(S){return this.a[S]}all(){return Object.keys(this.a).map(S=>this.a[S])}getJsonSchema(){if(this.c===void 0){const S=[];for(const D of this.all()){const E={type:"object",additionalProperties:!1};D.required.length>0&&(E.required=D.required.slice(0)),D.properties!==void 0?E.properties=l.$Xm(D.properties):E.properties=Object.create(null),E.properties.type={type:"string",enum:[D.taskType]},S.push(E)}this.c={oneOf:S}}return this.c}}e.$JF=new C}),define(Se[290],De([1,0,222,18,24,23,41,289]),function(ne,e,y,M,l,R,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$TF=e.JsonSchemaVersion=e.ExecutionEngine=e.$SF=e.$RF=e.$QF=e.$PF=e.$OF=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$NF=e.ShellQuoting=e.$MF=e.$LF=e.$KF=void 0,e.$KF="settings",e.$LF=new A.$3i("taskRunning",!1,y.localize(0,null)),e.$MF={value:y.localize(1,null),original:"Tasks"};var k;(function(N){N[N.Escape=1]="Escape",N[N.Strong=2]="Strong",N[N.Weak=3]="Weak"})(k||(e.ShellQuoting=k={})),e.$NF="$customized",function(N){function j(z){if(!z)return N.Strong;switch(z.toLowerCase()){case"escape":return N.Escape;case"strong":return N.Strong;case"weak":return N.Weak;default:return N.Strong}}N.from=j}(k||(e.ShellQuoting=k={}));var $;(function(N){N.defaults={cwd:"${workspaceFolder}"}})($||(e.CommandOptions=$={}));var P;(function(N){N[N.Always=1]="Always",N[N.Silent=2]="Silent",N[N.Never=3]="Never"})(P||(e.RevealKind=P={})),function(N){function j(z){switch(z.toLowerCase()){case"always":return N.Always;case"silent":return N.Silent;case"never":return N.Never;default:return N.Always}}N.fromString=j}(P||(e.RevealKind=P={}));var C;(function(N){N[N.Never=1]="Never",N[N.OnProblem=2]="OnProblem",N[N.Always=3]="Always"})(C||(e.RevealProblemKind=C={})),function(N){function j(z){switch(z.toLowerCase()){case"always":return N.Always;case"never":return N.Never;case"onproblem":return N.OnProblem;default:return N.OnProblem}}N.fromString=j}(C||(e.RevealProblemKind=C={}));var v;(function(N){N[N.Shared=1]="Shared",N[N.Dedicated=2]="Dedicated",N[N.New=3]="New"})(v||(e.PanelKind=v={})),function(N){function j(z){switch(z.toLowerCase()){case"shared":return N.Shared;case"dedicated":return N.Dedicated;case"new":return N.New;default:return N.Shared}}N.fromString=j}(v||(e.PanelKind=v={}));var S;(function(N){N.defaults={echo:!0,reveal:P.Always,revealProblems:C.Never,focus:!1,panel:v.Shared,showReuseMessage:!0,clear:!1}})(S||(e.PresentationOptions=S={}));var D;(function(N){N[N.Shell=1]="Shell",N[N.Process=2]="Process",N[N.CustomExecution=3]="CustomExecution"})(D||(e.RuntimeType=D={})),function(N){function j(B){switch(B.toLowerCase()){case"shell":return N.Shell;case"process":return N.Process;case"customExecution":return N.CustomExecution;default:return N.Process}}N.fromString=j;function z(B){switch(B){case N.Shell:return"shell";case N.Process:return"process";case N.CustomExecution:return"customExecution";default:return"process"}}N.toString=z}(D||(e.RuntimeType=D={}));var E;(function(N){function j(z){return M.$wf(z)?z:z.value}N.value=j})(E||(e.CommandString=E={}));var s;(function(N){N.Clean={_id:"clean",isDefault:!1},N.Build={_id:"build",isDefault:!1},N.Rebuild={_id:"rebuild",isDefault:!1},N.Test={_id:"test",isDefault:!1};function j(B){return B===N.Clean._id||B===N.Build._id||B===N.Rebuild._id||B===N.Test._id}N.is=j;function z(B){if(B!==void 0)return M.$wf(B)?j(B)?{_id:B,isDefault:!1}:void 0:B}N.from=z})(s||(e.TaskGroup=s={}));var c;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace",N[N.Folder=3]="Folder"})(c||(e.TaskScope=c={}));var u;(function(N){N.Workspace="workspace",N.Extension="extension",N.InMemory="inMemory",N.WorkspaceFile="workspaceFile",N.User="user";function j(z){switch(z){case N.User:return 2;case N.WorkspaceFile:return 5;default:return 6}}N.toConfigurationTarget=j})(u||(e.TaskSourceKind=u={}));var o;(function(N){N.parallel="parallel",N.sequence="sequence"})(o||(e.DependsOrder=o={}));var g;(function(N){N[N.default=1]="default",N[N.folderOpen=2]="folderOpen"})(g||(e.RunOnOptions=g={}));var d;(function(N){N.defaults={reevaluateOnRerun:!0,runOn:g.default,instanceLimit:1}})(d||(e.RunOptions=d={}));class t{constructor(j,z,B,ae,X,Q){this._label="",this._id=j,z&&(this._label=z),B&&(this.type=B),this.runOptions=ae,this.configurationProperties=X,this._source=Q}getDefinition(j){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const j={folder:this.d(),id:this._id};return JSON.stringify(j)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(j,z=!1){if(j===void 0)return!1;if(M.$wf(j))return j===this._label||j===this.configurationProperties.identifier||z&&j===this._id;const B=this.getDefinition(!0);return B!==void 0&&B._key===j._key}getQualifiedLabel(){const j=this.getWorkspaceFolder();return j?`${this._label} (${j.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(j){this.c===void 0&&(this.c=[]),j&&(this.c=this.c.concat(j))}get taskLoadMessages(){return this.c}}e.$OF=t;class n extends t{constructor(j,z,B,ae,X,Q,H,te){super(j,B,void 0,H,te,z),this.command={},this._source=z,this.hasDefinedMatchers=Q,X&&(this.command=X)}clone(){return new n(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(j=!1){if(j&&this._source.customizes!==void 0)return this._source.customizes;{let z;switch(this.command?this.command.runtime:void 0){case D.Shell:z="shell";break;case D.Process:z="process";break;case D.CustomExecution:z="customExecution";break;case void 0:z="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:z,_key:this._id,id:this._id}}}static is(j){return j instanceof n}getMapKey(){const j=this._source.config.workspaceFolder;return j?`${j.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===u.User?e.$KF:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const j=this.d();if(!j)return;let z=this.configurationProperties.identifier;this._source.kind!==u.Workspace&&(z+=this._source.kind);const B={type:e.$NF,folder:j,id:z};return JSON.stringify(B)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?l.$pg(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(j){return new n(j._id,j._source,j._label,j.type,j.command,j.hasDefinedMatchers,j.runOptions,j.configurationProperties)}}e.$PF=n;class r extends t{constructor(j,z,B,ae,X,Q,H){super(j,B,ae,Q,H,z),this._source=z,this.configures=X}static is(j){return j instanceof r}f(j){return j}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?l.$pg(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===u.User?e.$KF:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const j=this.d();if(!j)return;let z=this.configurationProperties.identifier;this._source.kind!==u.Workspace&&(z+=this._source.kind);const B={type:e.$NF,folder:j,id:z};return JSON.stringify(B)}}e.$QF=r;class i extends t{constructor(j,z,B,ae,X,Q,H,te,me){super(j,B,ae,te,me,z),this.defines=X,this.hasDefinedMatchers=H,this.command=Q,this.icon=me.icon,this.hide=me.hide}clone(){return new i(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(j){return j instanceof i}getMapKey(){const j=this._source.workspaceFolder;return j?`${this._source.scope.toString()}|${j.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const j={type:"contributed",scope:this._source.scope,id:this._id};return j.folder=this.d(),JSON.stringify(j)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(j){return new i(j._id,j._source,j._label,j.type,j.defines,j.command,j.hasDefinedMatchers,j.runOptions,j.configurationProperties)}}e.$RF=i;class a extends t{constructor(j,z,B,ae,X,Q){super(j,B,ae,X,Q,z),this._source=z}clone(){return new a(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(j){return j instanceof a}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(j){return new a(j._id,j._source,j._label,j.type,j.runOptions,j.configurationProperties)}}e.$SF=a;var h;(function(N){N[N.Process=1]="Process",N[N.Terminal=2]="Terminal"})(h||(e.ExecutionEngine=h={})),function(N){N._default=N.Terminal}(h||(e.ExecutionEngine=h={}));var p;(function(N){N[N.V0_1_0=1]="V0_1_0",N[N.V2_0_0=2]="V2_0_0"})(p||(e.JsonSchemaVersion=p={}));class I{constructor(j){this.c=new Map;for(let z=0;z<j.length;z++)this.c.set(j[z].uri.toString(),z)}compare(j,z){const B=j.getWorkspaceFolder(),ae=z.getWorkspaceFolder();if(B&&ae){let X=this.c.get(B.uri.toString());X=X===void 0?0:X+1;let Q=this.c.get(ae.uri.toString());return Q=Q===void 0?0:Q+1,X===Q?j._label.localeCompare(z._label):X-Q}else return!B&&ae?-1:B&&!ae?1:0}}e.$TF=I;var w;(function(N){N.DependsOnStarted="dependsOnStarted",N.AcquiredInput="acquiredInput",N.Start="start",N.ProcessStarted="processStarted",N.Active="active",N.Inactive="inactive",N.Changed="changed",N.Terminated="terminated",N.ProcessEnded="processEnded",N.End="end"})(w||(e.TaskEventKind=w={}));var f;(function(N){N.SingleRun="singleRun",N.Background="background"})(f||(e.TaskRunType=f={}));var b;(function(N){N[N.System=0]="System",N[N.User=1]="User",N[N.FolderOpen=2]="FolderOpen",N[N.ConfigurationChange=3]="ConfigurationChange",N[N.Reconnect=4]="Reconnect"})(b||(e.TaskRunSource=b={}));var L;(function(N){function j(te){return{taskId:te._id,taskName:te.configurationProperties.name,runType:te.configurationProperties.isBackground?"background":"singleRun",group:te.configurationProperties.group,__task:te}}function z(te,me,le){return{...j(te),kind:"start",terminalId:me,resolvedVariables:le}}N.start=z;function B(te,me,le){return{...j(te),kind:"processStarted",terminalId:me,processId:le}}N.processStarted=B;function ae(te,me,le){return{...j(te),kind:"processEnded",terminalId:me,exitCode:le}}N.processEnded=ae;function X(te,me,le){return{...j(te),kind:"terminated",exitReason:le,terminalId:me}}N.terminated=X;function Q(te,me,le){return{...j(me),kind:te,terminalId:le}}N.general=Q;function H(){return{kind:"changed"}}N.changed=H})(L||(e.TaskEvent=L={}));var O;(function(N){function j(B){const ae=Object.keys(B).sort();let X="";for(const Q of ae){let H=B[Q];H instanceof Object?H=j(H):typeof H=="string"&&(H=H.replace(/,/g,",,")),X+=Q+","+H+","}return X}function z(B){const X={_key:j(B),type:B.taskType};return Object.assign(X,B),X}N.create=z})(O||(e.KeyedTaskIdentifier=O={}));var T;(function(N){N.AutoDetect="task.autoDetect",N.SaveBeforeRun="task.saveBeforeRun",N.ShowDecorations="task.showDecorations",N.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",N.SlowProviderWarning="task.slowProviderWarning",N.QuickOpenHistory="task.quickOpen.history",N.QuickOpenDetail="task.quickOpen.detail",N.QuickOpenSkip="task.quickOpen.skip",N.QuickOpenShowAll="task.quickOpen.showAll",N.AllowAutomaticTasks="task.allowAutomaticTasks",N.Reconnection="task.reconnection"})(T||(e.TaskSettingId=T={}));var F;(function(N){N.Tasks="tasks",N.SuppressTaskName="tasks.suppressTaskName",N.Windows="tasks.windows",N.Osx="tasks.osx",N.Linux="tasks.linux",N.ShowOutput="tasks.showOutput",N.IsShellCommand="tasks.isShellCommand",N.ServiceTestSetting="tasks.service.testSetting"})(F||(e.TasksSchemaProperties=F={}));var U;(function(N){function j(z,B){const ae=m.$JF.get(z.type);if(ae===void 0){const te=R.$Xm(z);return delete te._key,O.create(te)}const X=Object.create(null);X.type=ae.taskType;const Q=new Set;ae.required.forEach(te=>Q.add(te));const H=ae.properties;for(const te of Object.keys(H)){const me=z[te];if(me!=null)X[te]=me;else if(Q.has(te)){const le=H[te];if(le.default!==void 0)X[te]=R.$Xm(le.default);else switch(le.type){case"boolean":X[te]=!1;break;case"number":case"integer":X[te]=0;break;case"string":X[te]="";break;default:B.error(y.localize(2,null,JSON.stringify(z,void 0,0),te));return}}}return O.create(X)}N.createTaskIdentifier=j})(U||(e.TaskDefinition=U={}))}),define(Se[291],De([1,0,8]),function(ne,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$3b=e.$03b=void 0;class M{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((A,m)=>{this.b=A,this.d=m,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(A){this.f||this.h||(this.f=!0,this.g=A,this.a&&this.b(A))}resolveErr(A){this.f||this.h||(this.h=!0,this.i=A,this.a?this.d(A):(0,y.$Y)(A))}then(A,m){return this.j().then(A,m)}catch(A){return this.j().then(void 0,A)}finally(A){return this.j().finally(A)}}e.$03b=M;class l extends M{constructor(){super(),this.h=!0,this.i=new y.$3}}e.$$3b=l}),define(Se[69],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iv=e.$hv=e.$gv=e.$fv=void 0;class y{constructor(k){this._proxyIdentifierBrand=void 0,this.sid=k,this.nid=++y.count}}e.$fv=y,y.count=0;const M=[];function l(m){const k=new y(m);return M[k.nid]=k,k}e.$gv=l;function R(m){return M[m].sid}e.$hv=R;class A{constructor(k){this.value=k}}e.$iv=A}),define(Se[6],De([1,0,69]),function(ne,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0J=e.$9J=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$8J=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var M;(function(E){E[E.Default=0]="Default",E[E.InCenter=1]="InCenter",E[E.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",E[E.AtTop=3]="AtTop"})(M||(e.TextEditorRevealType=M={}));var l;(function(E){E[E.UnknownInput=0]="UnknownInput",E[E.TextInput=1]="TextInput",E[E.TextDiffInput=2]="TextDiffInput",E[E.TextMergeInput=3]="TextMergeInput",E[E.NotebookInput=4]="NotebookInput",E[E.NotebookDiffInput=5]="NotebookDiffInput",E[E.CustomEditorInput=6]="CustomEditorInput",E[E.WebviewEditorInput=7]="WebviewEditorInput",E[E.TerminalEditorInput=8]="TerminalEditorInput",E[E.InteractiveEditorInput=9]="InteractiveEditorInput"})(l||(e.TabInputKind=l={}));var R;(function(E){E[E.TAB_OPEN=0]="TAB_OPEN",E[E.TAB_CLOSE=1]="TAB_CLOSE",E[E.TAB_UPDATE=2]="TAB_UPDATE",E[E.TAB_MOVE=3]="TAB_MOVE"})(R||(e.TabModelOperationKind=R={}));var A;(function(E){E[E.Editable=0]="Editable",E[E.SupportsHotExit=1]="SupportsHotExit"})(A||(e.WebviewEditorCapabilities=A={}));var m;(function(E){E[E.Int8Array=1]="Int8Array",E[E.Uint8Array=2]="Uint8Array",E[E.Uint8ClampedArray=3]="Uint8ClampedArray",E[E.Int16Array=4]="Int16Array",E[E.Uint16Array=5]="Uint16Array",E[E.Int32Array=6]="Int32Array",E[E.Uint32Array=7]="Uint32Array",E[E.Float32Array=8]="Float32Array",E[E.Float64Array=9]="Float64Array",E[E.BigInt64Array=10]="BigInt64Array",E[E.BigUint64Array=11]="BigUint64Array"})(m||(e.WebviewMessageArrayBufferViewType=m={}));var k;(function(E){E[E.Text=1]="Text",E[E.Error=2]="Error",E[E.Rich=3]="Rich"})(k||(e.CellOutputKind=k={}));var $;(function(E){E[E.Default=0]="Default",E[E.InCenter=1]="InCenter",E[E.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",E[E.AtTop=3]="AtTop"})($||(e.NotebookEditorRevealType=$={}));var P;(function(E){E[E.None=0]="None",E[E.Process=1]="Process",E[E.Output=2]="Output"})(P||(e.CandidatePortSource=P={}));class C{static mixin(s){return s._id=C.a++,s}}e.$8J=C,C.a=0;var v;(function(E){E.label="a",E.kind="b",E.detail="c",E.documentation="d",E.sortText="e",E.filterText="f",E.preselect="g",E.insertText="h",E.insertTextRules="i",E.range="j",E.commitCharacters="k",E.additionalTextEdits="l",E.kindModifier="m",E.commandIdent="n",E.commandId="o",E.commandArguments="p"})(v||(e.ISuggestDataDtoField=v={}));var S;(function(E){E.defaultRanges="a",E.completions="b",E.isIncomplete="c",E.duration="d"})(S||(e.ISuggestResultDtoField=S={}));var D;(function(E){E[E.Workspace=0]="Workspace",E[E.TextDocument=1]="TextDocument"})(D||(e.ExtHostTestingResource=D={})),e.$9J={MainThreadAuthentication:(0,y.$gv)("MainThreadAuthentication"),MainThreadBulkEdits:(0,y.$gv)("MainThreadBulkEdits"),MainThreadChatProvider:(0,y.$gv)("MainThreadChatProvider"),MainThreadChatSlashCommands:(0,y.$gv)("MainThreadChatSlashCommands"),MainThreadChatAgents:(0,y.$gv)("MainThreadChatAgents"),MainThreadChatVariables:(0,y.$gv)("MainThreadChatVariables"),MainThreadClipboard:(0,y.$gv)("MainThreadClipboard"),MainThreadCommands:(0,y.$gv)("MainThreadCommands"),MainThreadComments:(0,y.$gv)("MainThreadComments"),MainThreadConfiguration:(0,y.$gv)("MainThreadConfiguration"),MainThreadConsole:(0,y.$gv)("MainThreadConsole"),MainThreadDebugService:(0,y.$gv)("MainThreadDebugService"),MainThreadDecorations:(0,y.$gv)("MainThreadDecorations"),MainThreadDiagnostics:(0,y.$gv)("MainThreadDiagnostics"),MainThreadDialogs:(0,y.$gv)("MainThreadDiaglogs"),MainThreadDocuments:(0,y.$gv)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,y.$gv)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,y.$gv)("MainThreadTextEditors"),MainThreadEditorInsets:(0,y.$gv)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,y.$gv)("MainThreadEditorTabs"),MainThreadErrors:(0,y.$gv)("MainThreadErrors"),MainThreadTreeViews:(0,y.$gv)("MainThreadTreeViews"),MainThreadDownloadService:(0,y.$gv)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,y.$gv)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,y.$gv)("MainThreadLanguages"),MainThreadLogger:(0,y.$gv)("MainThreadLogger"),MainThreadMessageService:(0,y.$gv)("MainThreadMessageService"),MainThreadOutputService:(0,y.$gv)("MainThreadOutputService"),MainThreadProgress:(0,y.$gv)("MainThreadProgress"),MainThreadQuickDiff:(0,y.$gv)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,y.$gv)("MainThreadQuickOpen"),MainThreadStatusBar:(0,y.$gv)("MainThreadStatusBar"),MainThreadSecretState:(0,y.$gv)("MainThreadSecretState"),MainThreadStorage:(0,y.$gv)("MainThreadStorage"),MainThreadTelemetry:(0,y.$gv)("MainThreadTelemetry"),MainThreadTerminalService:(0,y.$gv)("MainThreadTerminalService"),MainThreadWebviews:(0,y.$gv)("MainThreadWebviews"),MainThreadWebviewPanels:(0,y.$gv)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,y.$gv)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,y.$gv)("MainThreadCustomEditors"),MainThreadUrls:(0,y.$gv)("MainThreadUrls"),MainThreadUriOpeners:(0,y.$gv)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,y.$gv)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,y.$gv)("MainThreadWorkspace"),MainThreadFileSystem:(0,y.$gv)("MainThreadFileSystem"),MainThreadExtensionService:(0,y.$gv)("MainThreadExtensionService"),MainThreadSCM:(0,y.$gv)("MainThreadSCM"),MainThreadSearch:(0,y.$gv)("MainThreadSearch"),MainThreadShare:(0,y.$gv)("MainThreadShare"),MainThreadTask:(0,y.$gv)("MainThreadTask"),MainThreadWindow:(0,y.$gv)("MainThreadWindow"),MainThreadLabelService:(0,y.$gv)("MainThreadLabelService"),MainThreadNotebook:(0,y.$gv)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,y.$gv)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,y.$gv)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,y.$gv)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,y.$gv)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,y.$gv)("MainThreadInteractive"),MainThreadChat:(0,y.$gv)("MainThreadChat"),MainThreadInlineChat:(0,y.$gv)("MainThreadInlineChatShape"),MainThreadTheming:(0,y.$gv)("MainThreadTheming"),MainThreadTunnelService:(0,y.$gv)("MainThreadTunnelService"),MainThreadManagedSockets:(0,y.$gv)("MainThreadManagedSockets"),MainThreadTimeline:(0,y.$gv)("MainThreadTimeline"),MainThreadTesting:(0,y.$gv)("MainThreadTesting"),MainThreadLocalization:(0,y.$gv)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,y.$gv)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,y.$gv)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,y.$gv)("MainThreadIssueReporter")},e.$0J={ExtHostCommands:(0,y.$gv)("ExtHostCommands"),ExtHostConfiguration:(0,y.$gv)("ExtHostConfiguration"),ExtHostDiagnostics:(0,y.$gv)("ExtHostDiagnostics"),ExtHostDebugService:(0,y.$gv)("ExtHostDebugService"),ExtHostDecorations:(0,y.$gv)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,y.$gv)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,y.$gv)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,y.$gv)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,y.$gv)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,y.$gv)("ExtHostEditors"),ExtHostTreeViews:(0,y.$gv)("ExtHostTreeViews"),ExtHostFileSystem:(0,y.$gv)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,y.$gv)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,y.$gv)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,y.$gv)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,y.$gv)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,y.$gv)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,y.$gv)("ExtHostQuickDiff"),ExtHostStatusBar:(0,y.$gv)("ExtHostStatusBar"),ExtHostShare:(0,y.$gv)("ExtHostShare"),ExtHostExtensionService:(0,y.$gv)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,y.$gv)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,y.$gv)("ExtHostTerminalService"),ExtHostSCM:(0,y.$gv)("ExtHostSCM"),ExtHostSearch:(0,y.$gv)("ExtHostSearch"),ExtHostTask:(0,y.$gv)("ExtHostTask"),ExtHostWorkspace:(0,y.$gv)("ExtHostWorkspace"),ExtHostWindow:(0,y.$gv)("ExtHostWindow"),ExtHostWebviews:(0,y.$gv)("ExtHostWebviews"),ExtHostWebviewPanels:(0,y.$gv)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,y.$gv)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,y.$gv)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,y.$gv)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,y.$gv)("ExtHostEditorTabs"),ExtHostProgress:(0,y.$gv)("ExtHostProgress"),ExtHostComments:(0,y.$gv)("ExtHostComments"),ExtHostSecretState:(0,y.$gv)("ExtHostSecretState"),ExtHostStorage:(0,y.$gv)("ExtHostStorage"),ExtHostUrls:(0,y.$gv)("ExtHostUrls"),ExtHostUriOpeners:(0,y.$gv)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,y.$gv)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,y.$gv)("ExtHostOutputService"),ExtHosLabelService:(0,y.$gv)("ExtHostLabelService"),ExtHostNotebook:(0,y.$gv)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,y.$gv)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,y.$gv)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,y.$gv)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,y.$gv)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,y.$gv)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,y.$gv)("ExtHostInteractive"),ExtHostInlineChat:(0,y.$gv)("ExtHostInlineChatShape"),ExtHostChat:(0,y.$gv)("ExtHostChat"),ExtHostChatSlashCommands:(0,y.$gv)("ExtHostChatSlashCommands"),ExtHostChatAgents:(0,y.$gv)("ExtHostChatAgents"),ExtHostChatVariables:(0,y.$gv)("ExtHostChatVariables"),ExtHostChatProvider:(0,y.$gv)("ExtHostChatProvider"),ExtHostAiRelatedInformation:(0,y.$gv)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,y.$gv)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,y.$gv)("ExtHostTheming"),ExtHostTunnelService:(0,y.$gv)("ExtHostTunnelService"),ExtHostManagedSockets:(0,y.$gv)("ExtHostManagedSockets"),ExtHostAuthentication:(0,y.$gv)("ExtHostAuthentication"),ExtHostTimeline:(0,y.$gv)("ExtHostTimeline"),ExtHostTesting:(0,y.$gv)("ExtHostTesting"),ExtHostTelemetry:(0,y.$gv)("ExtHostTelemetry"),ExtHostLocalization:(0,y.$gv)("ExtHostLocalization"),ExtHostIssueReporter:(0,y.$gv)("ExtHostIssueReporter")}}),define(Se[292],De([1,0,6,7]),function(ne,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Adc=void 0;class l{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(y.$9J.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(A,m,k){if(this.a.size===0)throw new Error("No related information providers registered");const $=this.a.get(A);if(!$)throw new Error("related information provider not found");return await $.provideRelatedInformation(m,k)??[]}getRelatedInformation(A,m,k){return this.c.$getAiRelatedInformation(m,k)}registerRelatedInformationProvider(A,m,k){const $=this.b;return this.b++,this.a.set($,k),this.c.$registerAiRelatedInformationProvider($,m),new M.$$J(()=>{this.c.$unregisterAiRelatedInformationProvider($),this.a.delete($)})}}e.$Adc=l}),define(Se[90],De([1,0,5,14,6,20]),function(ne,e,y,M,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ebc=e.$Dbc=e.$Cbc=void 0,e.$Cbc=(0,y.$Lh)("IExtHostApiDeprecationService");let A=class{constructor(k,$){this.c=$,this.a=new Set,this.b=k.getProxy(l.$9J.MainThreadTelemetry)}report(k,$,P){const C=this.d(k,$);this.a.has(C)||(this.a.add(C),$.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${k}' is deprecated. ${P}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:$.identifier.value,apiId:k}))}d(k,$){return`${k}-${$.identifier.value}`}};e.$Dbc=A,e.$Dbc=A=Ke([We(0,R.$0L),We(1,M.$6i)],A),e.$Ebc=Object.freeze(new class{report(m,k,$){}})}),define(Se[293],De([1,0,4,6,7,25]),function(ne,e,y,M,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$cc=void 0;class A{constructor($){this.b=new Map,this.c=[],this.d=new y.$Ld,this.onDidChangeSessions=this.d.event,this.f=new m,this.g=new m,this.a=$.getProxy(M.$9J.MainThreadAuthentication)}$setProviders($){return this.c=$,Promise.resolve()}async getSession($,P,C,v={}){const S=R.$Xl.toKey($.identifier),D=[...C].sort().join(" ");return await this.f.getOrCreate(`${S} ${P} ${D}`,async()=>{await this.a.$ensureProvider(P);const E=$.displayName||$.name;return this.a.$getSession(P,C,S,E,v)})}async getSessions($,P,C){const v=R.$Xl.toKey($.identifier),S=[...C].sort().join(" ");return await this.g.getOrCreate(`${v} ${S}`,async()=>{await this.a.$ensureProvider(P);const D=$.displayName||$.name;return this.a.$getSessions(P,C,v,D)})}async removeSession($,P){const C=this.b.get($);return C?C.provider.removeSession(P):this.a.$removeSession($,P)}registerAuthenticationProvider($,P,C,v){if(this.b.get($))throw new Error(`An authentication provider with id '${$}' is already registered.`);this.b.set($,{label:P,provider:C,options:v??{supportsMultipleAccounts:!1}}),this.c.find(D=>D.id===$)||this.c.push({id:$,label:P});const S=C.onDidChangeSessions(D=>{this.a.$sendDidChangeSessions($,{added:D.added??[],changed:D.changed??[],removed:D.removed??[]})});return this.a.$registerAuthenticationProvider($,P,v?.supportsMultipleAccounts??!1),new l.$$J(()=>{S.dispose(),this.b.delete($);const D=this.c.findIndex(E=>E.id===$);D>-1&&this.c.splice(D),this.a.$unregisterAuthenticationProvider($)})}$createSession($,P,C){const v=this.b.get($);if(v)return Promise.resolve(v.provider.createSession(P,C));throw new Error(`Unable to find authentication provider with handle: ${$}`)}$removeSession($,P){const C=this.b.get($);if(C)return Promise.resolve(C.provider.removeSession(P));throw new Error(`Unable to find authentication provider with handle: ${$}`)}$getSessions($,P){const C=this.b.get($);if(C)return Promise.resolve(C.provider.getSessions(P));throw new Error(`Unable to find authentication provider with handle: ${$}`)}$onDidChangeAuthenticationSessions($,P){return this.d.fire({provider:{id:$,label:P}}),Promise.resolve()}}e.$$cc=A;class m{constructor(){this.a=new Map}getOrCreate($,P){const C=this.a.get($);if(C)return C;const v=P().finally(()=>this.a.delete($));return this.a.set($,v),v}}}),define(Se[294],De([1,0,6,20,13]),function(ne,e,y,M,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$edc=void 0;let R=class{constructor(m,k){this.a=m.getProxy(y.$9J.MainThreadBulkEdits),this.b={getTextDocumentVersion:$=>k.getDocument($)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(m,k,$){const P=l.WorkspaceEdit.from(m,this.b);return this.a.$tryApplyWorkspaceEdit(P,void 0,$?.isRefactoring??!1)}};e.$edc=R,e.$edc=R=Ke([We(0,M.$0L)],R)}),define(Se[295],De([1,0,9,4,50,3,38,202,6,13]),function(ne,e,y,M,l,R,A,m,k,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sdc=void 0;class P{constructor(S,D){this.extension=S,this.provider=D,this.handle=P.a++}}P.a=0;class C{constructor(S,D){this.i=D,this.b=new Map,this.e=new Map,this.g=new M.$Ld,this.onDidPerformUserAction=this.g.event,this.h=S.getProxy(k.$9J.MainThreadChat)}registerChatProvider(S,D,E){const s=new P(S,E);return this.b.set(s.handle,s),this.h.$registerChatProvider(s.handle,D),(0,R.$Oc)(()=>{this.h.$unregisterChatProvider(s.handle),this.b.delete(s.handle)})}transferChatSession(S,D){const E=l.Iterable.find(this.e.keys(),s=>this.e.get(s)===S)??0;typeof E=="number"&&this.h.$transferChatSession(E,D)}addChatRequest(S){this.h.$addRequest(S)}sendInteractiveRequestToProvider(S,D){this.h.$sendRequestToProvider(S,D)}async $prepareChat(S,D,E){const s=this.b.get(S);if(!s)return;const c=await s.provider.prepareSession(D,E);if(!c)return;const u=C.a++;return this.e.set(u,c),{id:u,requesterUsername:c.requester?.name,requesterAvatarIconUri:c.requester?.icon,responderUsername:c.responder?.name,responderAvatarIconUri:c.responder?.icon,inputPlaceholder:c.inputPlaceholder}}async $resolveRequest(S,D,E,s){const c=this.b.get(S);if(!c)return;const u=this.e.get(D);if(!u||!c.provider.resolveRequest)return;const o=await c.provider.resolveRequest(u,E,s);if(o)return{message:typeof o.message=="string"?o.message:$.ChatReplyFollowup.from(o.message)}}async $provideWelcomeMessage(S,D){const E=this.b.get(S);if(!E||!E.provider.provideWelcomeMessage)return;const s=await E.provider.provideWelcomeMessage(D);if(s)return s.map(c=>typeof c=="string"?c:c.map(u=>$.ChatReplyFollowup.from(u)))}async $provideFollowups(S,D,E){const s=this.b.get(S);if(!s)return;const c=this.e.get(D);return!c||!s.provider.provideFollowups?void 0:(await s.provider.provideFollowups(c,E))?.map(o=>$.ChatFollowup.from(o))}$removeRequest(S,D,E){const s=this.b.get(S);if(!s)return;const c=this.e.get(D);c&&s.provider.removeRequest&&s.provider.removeRequest(c,E)}async $provideReply(S,D,E,s){const c=this.b.get(S);if(!c)return;const u=this.e.get(D);if(!u)return;const o={session:u,message:typeof E.message=="string"?E.message:$.ChatReplyFollowup.to(E.message),variables:{}};if(E.variables)for(const i of Object.keys(E.variables))o.variables[i]=E.variables[i].map($.ChatVariable.to);const g=A.$Hd.create(!1);let d;const t={report:i=>{if(!s.isCancellationRequested)if(typeof d>"u"&&(d=g.elapsed()),"responseId"in i)this.h.$acceptResponseProgress(S,D,{requestId:i.responseId});else if("placeholder"in i&&"resolvedContent"in i){const a=Promise.all([this.h.$acceptResponseProgress(S,D,{placeholder:i.placeholder}),i.resolvedContent]);(0,y.$Fg)(a,s).then(h=>{if(!h)return;const[p,I]=h;this.h.$acceptResponseProgress(S,D,I,p??void 0)})}else"content"in i?this.h.$acceptResponseProgress(S,D,{content:typeof i.content=="string"?i.content:$.MarkdownString.from(i.content)}):"documents"in i?this.h.$acceptResponseProgress(S,D,{documents:i.documents.map(a=>({uri:a.uri,version:a.version,ranges:a.ranges.map(h=>$.Range.from(h))}))}):this.h.$acceptResponseProgress(S,D,i)}};let n;try{n=await c.provider.provideResponseWithProgress(o,t,s),n||(n={errorDetails:{message:(0,m.localize)(0,null)}})}catch(i){n={errorDetails:{message:(0,m.localize)(1,null,i.message),responseIsIncomplete:!0}},this.i.error(i)}try{if(u.saveState&&this.e.has(D)){const i=u.saveState();this.h.$acceptChatState(D,i)}}catch(i){this.i.warn(i)}const r={firstProgress:d??0,totalElapsed:g.elapsed()};return{errorDetails:n.errorDetails,timings:r}}async $provideSlashCommands(S,D,E){const s=this.b.get(S);if(!s)return;const c=this.e.get(D);return!c||!s.provider.provideSlashCommands?void 0:(await s.provider.provideSlashCommands(c,E))?.map(o=>({...o,kind:$.CompletionItemKind.from(o.kind)}))}$releaseSession(S){this.e.delete(S)}async $onDidPerformUserAction(S){this.g.fire(S)}}e.$sdc=C,C.a=0}),define(Se[296],De([1,0,9,3,64,6,13,7]),function(ne,e,y,M,l,R,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cdc=void 0;class k{constructor(C,v,S){this.d=v,this.e=S,this.b=new Map,this.c=C.getProxy(R.$9J.MainThreadChatAgents)}registerAgent(C,v,S,D){const E=k.a++;return this.b.set(E,{extension:C,agent:S}),this.c.$registerAgent(E,v,D),(0,M.$Oc)(()=>{this.c.$unregisterAgent(E),this.b.delete(E)})}async $invokeAgent(C,v,S,D,E){const s=this.b.get(C);if(!s){this.e.warn(`[CHAT](${C}) CANNOT invoke agent because the agent is not registered`);return}let c=!1;function u(){if(c)throw new Error("Only valid while executing the command")}const o=new y.$_g;E.onCancellationRequested(()=>o.complete()),setTimeout(()=>o.complete(),3*1e3),this.d.allowListExtensionWhile(s.extension,o.p);const g=s.agent({role:m.ChatMessageRole.User,content:S},{history:D.history.map(A.ChatMessage.to)},new l.$Xu(d=>{u(),this.c.$handleProgressChunk(v,{content:$(d.message)?d.message:d.message.value})}),E);try{return await(0,y.$Fg)(Promise.resolve(g).then(d=>{if(d&&"followUp"in d)return{followUp:d?.followUp?.map(n=>A.ChatFollowup.from(n))}}),E)}finally{c=!0,o.complete()}}}e.$Cdc=k,k.a=0;function $(P){return!!P&&typeof P=="object"&&"treeData"in P}}),define(Se[297],De([1,0,3,6,13,64,25]),function(ne,e,y,M,l,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xdc=void 0;class m{constructor($,P){this.d=P,this.c=new Map,this.e=new Map,this.f=new A.$Zl,this.b=$.getProxy(M.$9J.MainThreadChatProvider)}registerProvider($,P,C,v){const S=m.a++;return this.c.set(S,{extension:$,provider:C}),this.b.$registerProvider(S,P,{extension:$,displayName:v.name??$.value}),(0,y.$Oc)(()=>{this.b.$unregisterProvider(S),this.c.delete(S)})}async $provideChatResponse($,P,C,v,S){const D=this.c.get($);if(!D)return;const E=new R.$Xu(async s=>{if(S.isCancellationRequested){this.d.warn(`[CHAT](${D.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}await this.b.$handleProgressChunk(P,{index:s.index,part:s.part})},{async:!0});return D.provider.provideChatResponse(C.map(l.ChatMessage.to),v,E,S)}allowListExtensionWhile($,P){this.f.set($,P),P.finally(()=>this.f.delete($))}async requestChatResponseProvider($,P){if(!this.f.has($))throw new Error("Extension is NOT allowed to make chat requests");const C=this;return{get isRevoked(){return!C.f.has($)},async makeRequest(v,S,D,E){if(!C.f.has($))throw new Error("Access to chat has been revoked");const s=Math.random()*1e6|0;C.e.set(s,D);try{await C.b.$fetchResponse($,P,s,v.map(l.ChatMessage.from),S,E)}finally{C.e.delete(s)}}}}async $handleResponseFragment($,P){this.e.get($)?.report(P)}}e.$xdc=m,m.a=1}),define(Se[298],De([1,0,3,6,7,13,64,9]),function(ne,e,y,M,l,R,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ydc=void 0;class k{constructor(C,v,S){this.d=v,this.e=S,this.b=new Map,this.c=C.getProxy(M.$9J.MainThreadChatSlashCommands)}registerCommand(C,v,S,D){const E=k.a++;return this.b.set(E,{extension:C,command:S}),this.c.$registerCommand(E,v,D.description),(0,y.$Oc)(()=>{this.c.$unregisterCommand(E),this.b.delete(E)})}async $executeCommand(C,v,S,D,E){const s=this.b.get(C);if(!s){this.e.warn(`[CHAT](${C}) CANNOT execute command because the command is not registered`);return}let c=!1;function u(){if(c)throw new Error("Only valid while executing the command")}const o=new m.$_g;E.onCancellationRequested(()=>o.complete()),setTimeout(()=>o.complete(),10*1e3),this.d.allowListExtensionWhile(s.extension,o.p);const g=s.command({role:l.ChatMessageRole.User,content:S},{history:D.history.map(R.ChatMessage.to)},new A.$Xu(d=>{u(),this.c.$handleProgressChunk(v,{content:$(d.message)?d.message:d.message.value})}),E);try{return await(0,m.$Fg)(Promise.resolve(g).then(d=>{if(d&&"followUp"in d)return{followUp:d?.followUp?.map(n=>R.ChatFollowup.from(n))}}),E)}finally{c=!0,o.complete()}}}e.$ydc=k,k.a=0;function $(P){return!!P&&typeof P=="object"&&"treeData"in P}}),define(Se[299],De([1,0,3,6,8,13]),function(ne,e,y,M,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zdc=void 0;class A{constructor(k){this.b=new Map,this.c=k.getProxy(M.$9J.MainThreadChatVariables)}async $resolveVariable(k,$,P){const C=this.b.get(k);if(C)try{const v=await C.resolver.resolve(C.data.name,{message:$},P);if(v)return v.map(R.ChatVariable.from)}catch(v){(0,l.$Z)(v)}}registerVariableResolver(k,$,P,C){const v=A.a++;return this.b.set(v,{extension:k.identifier,data:{name:$,description:P},resolver:C}),this.c.$registerVariable(v,{name:$,description:P}),(0,y.$Oc)(()=>{this.b.delete(v),this.c.$unregisterVariable(v)})}}e.$zdc=A,A.a=0}),define(Se[300],De([1,0,6]),function(ne,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hbc=void 0;class M{constructor(R){const A=R.getProxy(y.$9J.MainThreadClipboard);this.value=Object.freeze({readText(){return A.$readText()},writeText(m){return A.$writeText(m)}})}}e.$Hbc=M});var et=this&&this.__classPrivateFieldSet||function(ne,e,y,M,l){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!l:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?l.call(ne,y):l?l.value=y:e.set(ne,y),y},Be=this&&this.__classPrivateFieldGet||function(ne,e,y,M){if(y==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!M:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return y==="m"?M:y==="a"?M.call(ne):M?M.value:e.get(ne)};define(Se[33],De([1,0,18,7,13,23,6,19,14,60,35,63,2,3,5,20,146,22,69,48,38,85,89]),function(ne,e,y,M,l,R,A,m,k,$,P,C,v,S,D,E,s,c,u,o,g,d,t){"use strict";var n,r,i;Object.defineProperty(e,"__esModule",{value:!0}),e.$xM=e.$wM=e.$vM=e.$uM=e.$tM=e.$sM=void 0;let a=class{constructor(b,L,O){n.set(this,void 0),this.b=new Map,this.c=new Map,r.set(this,void 0),i.set(this,void 0),et(this,n,b.getProxy(A.$9J.MainThreadCommands),"f"),this.d=L,et(this,i,O,"f"),et(this,r,b.getProxy(A.$9J.MainThreadTelemetry),"f"),this.converter=new h(this,T=>{const F=this.c.get(T);return F?.result===I.Void?F:void 0},L),this.f=[{processArgument(T){return(0,$.$ih)(T)}},{processArgument(T){return(0,R.$Zm)(T,function(F){if(P.$ms.isIRange(F))return l.Range.to(F);if(C.$ls.isIPosition(F))return l.Position.to(F);if(P.$ms.isIRange(F.range)&&v.URI.isUri(F.uri))return l.location.to(F);if(F instanceof c.$_d)return F.buffer.buffer;if(!Array.isArray(F))return F})}}]}registerArgumentProcessor(b){this.f.push(b)}registerApiCommand(b){const L=this.registerCommand(!1,b.id,async(...O)=>{const T=b.args.map((U,N)=>{if(!U.validate(O[N]))throw new Error(`Invalid argument '${U.name}' when running '${b.id}', received: ${typeof O[N]=="object"?JSON.stringify(O[N],null,"	"):O[N]} `);return U.convert(O[N])}),F=await this.executeCommand(b.internalId,...T);return b.result.convert(F,O,this.converter)},void 0,{description:b.description,args:b.args,returns:b.result.description});return this.c.set(b.id,b),new M.$$J(()=>{L.dispose(),this.c.delete(b.id)})}registerCommand(b,L,O,T,F,U){if(this.d.trace("ExtHostCommands#registerCommand",L),!L.trim().length)throw new Error("invalid id");if(this.b.has(L))throw new Error(`command '${L}' already exists`);return this.b.set(L,{callback:O,thisArg:T,description:F,extension:U}),b&&Be(this,n,"f").$registerCommand(L),new M.$$J(()=>{this.b.delete(L)&&b&&Be(this,n,"f").$unregisterCommand(L)})}executeCommand(b,...L){return this.d.trace("ExtHostCommands#executeCommand",b),this.g(b,L,!0)}async g(b,L,O){if(this.b.has(b))return Be(this,n,"f").$fireCommandActivationEvent(b),this.h(b,L,!1);{let T=!1;const F=(0,R.$Zm)(L,function(U){if(U instanceof M.$_J)return l.Position.from(U);if(U instanceof M.$aK)return l.Range.from(U);if(U instanceof M.$kK)return l.location.from(U);if(M.$vL.isNotebookRange(U))return l.NotebookRange.from(U);if(U instanceof ArrayBuffer)return T=!0,c.$_d.wrap(new Uint8Array(U));if(U instanceof Uint8Array)return T=!0,c.$_d.wrap(U);if(U instanceof c.$_d)return T=!0,U;if(!Array.isArray(U))return U});try{const U=await Be(this,n,"f").$executeCommand(b,T?new u.$iv(F):F,O);return(0,$.$ih)(U)}catch(U){if(U instanceof Error&&U.message==="$executeCommand:retry")return this.g(b,L,!1);throw U}}}async h(b,L,O){const T=this.b.get(b);if(!T)throw new Error("Unknown command");const{callback:F,thisArg:U,description:N}=T;if(N)for(let z=0;z<N.args.length;z++)try{(0,y.$Nf)(L[z],N.args[z].constraint)}catch{throw new Error(`Running the contributed command: '${b}' failed.Illegal argument '${N.args[z].name}' - ${N.args[z].description} `)}const j=g.$Hd.create();try{return await F.apply(U,L)}catch(z){if(b===this.converter.delegatingCommandId){const B=this.converter.getActualCommand(...L);B&&(b=B.command)}if(this.d.error(z,b,T.extension?.identifier),!O)throw z;if(T.extension?.identifier){const B=Be(this,i,"f").onExtensionError(T.extension.identifier,z);this.d.trace("forwarded error to extension?",B,T.extension?.identifier)}throw new class extends Error{constructor(){super((0,o.$wi)(z)),this.id=b,this.source=T.extension?.displayName??T.extension?.name}}}finally{this.j(T,b,j.elapsed())}}j(b,L,O){b.extension&&Be(this,r,"f").$publicLog2("Extension:ActionExecuted",{extensionId:b.extension.identifier.value,id:new d.$bo(L),duration:O})}$executeContributedCommand(b,...L){this.d.trace("ExtHostCommands#$executeContributedCommand",b);const O=this.b.get(b);return O?(L=L.map(T=>this.f.reduce((F,U)=>U.processArgument(F,O.extension?.identifier),T)),this.h(b,L,!0)):Promise.reject(new Error(`Contributed command '${b}' does not exist.`))}getCommands(b=!1){return this.d.trace("ExtHostCommands#getCommands",b),Be(this,n,"f").$getCommands().then(L=>(b&&(L=L.filter(O=>O[0]!=="_")),L))}$getContributedCommandHandlerDescriptions(){const b=Object.create(null);for(const[L,O]of this.b){const{description:T}=O;T&&(b[L]=T)}return Promise.resolve(b)}};e.$sM=a,n=new WeakMap,r=new WeakMap,i=new WeakMap,e.$sM=a=Ke([We(0,E.$0L),We(1,k.$6i),We(2,t.$rM)],a),e.$tM=(0,D.$Lh)("IExtHostCommands");class h{constructor(b,L,O){this.d=b,this.f=L,this.g=O,this.delegatingCommandId=`__vsc${Date.now().toString(36)} `,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(b,L){if(!b)return;const O={$ident:void 0,id:b.command,title:b.title,tooltip:b.tooltip};if(!b.command)return O;const T=this.f(b.command);if(T)O.id=T.internalId,O.arguments=T.args.map((F,U)=>F.convert(b.arguments&&b.arguments[U]));else if((0,m.$Jb)(b.arguments)){const F=`${b.command} /${++this.c}`;this.b.set(F,b),L.add((0,S.$Oc)(()=>{this.b.delete(F),this.g.trace("CommandsConverter#DISPOSE",F)})),O.$ident=F,O.id=this.delegatingCommandId,O.arguments=[F],this.g.trace("CommandsConverter#CREATE",b.command,F)}return O}fromInternal(b){return typeof b.$ident=="string"?this.b.get(b.$ident):{command:b.id,title:b.title,arguments:b.arguments}}getActualCommand(...b){return this.b.get(b[0])}h(...b){const L=this.getActualCommand(...b);return this.g.trace("CommandsConverter#EXECUTE",b[0],L?L.command:"MISSING"),L?this.d.executeCommand(L.command,...L.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${b[0]}`)}}e.$uM=h;class p{static Arr(b){return new p(`${b.name}_array`,`Array of ${b.name}, ${b.description}`,L=>Array.isArray(L)&&L.every(O=>b.validate(O)),L=>L.map(O=>b.convert(O)))}constructor(b,L,O,T){this.name=b,this.description=L,this.validate=O,this.convert=T}optional(){return new p(this.name,`(optional) ${this.description}`,b=>b==null||this.validate(b),b=>b===void 0?void 0:b===null?null:this.convert(b))}with(b,L){return new p(b??this.name,L??this.description,this.validate,this.convert)}}e.$vM=p,p.Uri=new p("uri","Uri of a text document",f=>v.URI.isUri(f),f=>f),p.Position=new p("position","A position in a text document",f=>M.$_J.isPosition(f),l.Position.from),p.Range=new p("range","A range in a text document",f=>M.$aK.isRange(f),l.Range.from),p.Selection=new p("selection","A selection in a text document",f=>M.$bK.isSelection(f),l.Selection.from),p.Number=new p("number","",f=>typeof f=="number",f=>f),p.String=new p("string","",f=>typeof f=="string",f=>f),p.StringArray=p.Arr(p.String),p.CallHierarchyItem=new p("item","A call hierarchy item",f=>f instanceof M.$uK,l.CallHierarchyItem.from),p.TypeHierarchyItem=new p("item","A type hierarchy item",f=>f instanceof M.$OL,l.TypeHierarchyItem.from),p.TestItem=new p("testItem","A VS Code TestItem",f=>f instanceof s.$kM,l.TestItem.from);class I{constructor(b,L){this.description=b,this.convert=L}}e.$wM=I,I.Void=new I("no result",f=>f);class w{constructor(b,L,O,T,F){this.id=b,this.internalId=L,this.description=O,this.args=T,this.result=F}}e.$xM=w}),define(Se[301],De([1,0,19,17,2,83,130,41,135,33,13,7]),function(ne,e,y,M,l,R,A,m,k,$,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gbc=void 0;const v=[new $.$xM("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[$.$vM.Uri,$.$vM.Position],new $.$wM("A promise that resolves to an array of DocumentHighlight-instances.",D(P.DocumentHighlight.to))),new $.$xM("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[$.$vM.Uri],new $.$wM("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(s,c)=>{if((0,y.$Ib)(s))return;class u extends C.$pK{static to(g){const d=new u(g.name,P.SymbolKind.to(g.kind),g.containerName||"",new C.$kK(c[0],P.Range.to(g.range)));return d.detail=g.detail,d.range=d.location.range,d.selectionRange=P.Range.to(g.selectionRange),d.children=g.children?g.children.map(u.to):[],d}}return s.map(u.to)})),new $.$xM("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[$.$vM.Uri,new $.$vM("options","Formatting options",s=>!0,s=>s)],new $.$wM("A promise that resolves to an array of TextEdits.",D(P.TextEdit.to))),new $.$xM("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[$.$vM.Uri,$.$vM.Range,new $.$vM("options","Formatting options",s=>!0,s=>s)],new $.$wM("A promise that resolves to an array of TextEdits.",D(P.TextEdit.to))),new $.$xM("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[$.$vM.Uri,$.$vM.Position,new $.$vM("ch","Trigger character",s=>typeof s=="string",s=>s),new $.$vM("options","Formatting options",s=>!0,s=>s)],new $.$wM("A promise that resolves to an array of TextEdits.",D(P.TextEdit.to))),new $.$xM("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[$.$vM.Uri,$.$vM.Position],new $.$wM("A promise that resolves to an array of Location or LocationLink instances.",E)),new $.$xM("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[$.$vM.Uri,$.$vM.Position],new $.$wM("A promise that resolves to an array of Location or LocationLink instances.",E)),new $.$xM("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[$.$vM.Uri,$.$vM.Position],new $.$wM("A promise that resolves to an array of Location or LocationLink instances.",E)),new $.$xM("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[$.$vM.Uri,$.$vM.Position],new $.$wM("A promise that resolves to an array of Location or LocationLink instances.",E)),new $.$xM("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[$.$vM.Uri,$.$vM.Position],new $.$wM("A promise that resolves to an array of Location-instances.",D(P.location.to))),new $.$xM("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[$.$vM.Uri,$.$vM.Position],new $.$wM("A promise that resolves to an array of Hover-instances.",D(P.Hover.to))),new $.$xM("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[$.$vM.Uri,new $.$vM("position","A position in a text document",s=>Array.isArray(s)&&s.every(c=>C.$_J.isPosition(c)),s=>s.map(P.Position.from))],new $.$wM("A promise that resolves to an array of ranges.",s=>s.map(c=>{let u;for(const o of c.reverse())u=new C.$tK(P.Range.to(o),u);return u}))),new $.$xM("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[$.$vM.String.with("query","Search string")],new $.$wM("A promise that resolves to an array of SymbolInformation-instances.",s=>s.map(P.WorkspaceSymbol.to))),new $.$xM("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[$.$vM.Uri,$.$vM.Position],new $.$wM("A promise that resolves to an array of CallHierarchyItem-instances",s=>s.map(P.CallHierarchyItem.to))),new $.$xM("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[$.$vM.CallHierarchyItem],new $.$wM("A promise that resolves to an array of CallHierarchyIncomingCall-instances",s=>s.map(P.CallHierarchyIncomingCall.to))),new $.$xM("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[$.$vM.CallHierarchyItem],new $.$wM("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",s=>s.map(P.CallHierarchyOutgoingCall.to))),new $.$xM("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[$.$vM.Uri,$.$vM.Position],new $.$wM("A promise that resolves to a range and placeholder text.",s=>{if(s)return{range:P.Range.to(s.range),placeholder:s.text}})),new $.$xM("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[$.$vM.Uri,$.$vM.Position,$.$vM.String.with("newName","The new symbol name")],new $.$wM("A promise that resolves to a WorkspaceEdit.",s=>{if(s){if(s.rejectReason)throw new Error(s.rejectReason);return P.WorkspaceEdit.to(s)}})),new $.$xM("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[$.$vM.Uri,$.$vM.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new $.$wM("A promise that resolves to an array of DocumentLink-instances.",s=>s.map(P.DocumentLink.to))),new $.$xM("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[$.$vM.Uri],new $.$wM("A promise that resolves to SemanticTokensLegend.",s=>{if(s)return new C.$nL(s.tokenTypes,s.tokenModifiers)})),new $.$xM("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[$.$vM.Uri],new $.$wM("A promise that resolves to SemanticTokens.",s=>{if(!s)return;const c=(0,A.$J0)(s);if(c.type==="full")return new C.$pL(c.data,void 0)})),new $.$xM("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[$.$vM.Uri,$.$vM.Range.optional()],new $.$wM("A promise that resolves to SemanticTokensLegend.",s=>{if(s)return new C.$nL(s.tokenTypes,s.tokenModifiers)})),new $.$xM("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[$.$vM.Uri,$.$vM.Range],new $.$wM("A promise that resolves to SemanticTokens.",s=>{if(!s)return;const c=(0,A.$J0)(s);if(c.type==="full")return new C.$pL(c.data,void 0)})),new $.$xM("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[$.$vM.Uri,$.$vM.Position,$.$vM.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),$.$vM.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new $.$wM("A promise that resolves to a CompletionList-instance.",(s,c,u)=>{if(!s)return new C.$FK([]);const o=s.suggestions.map(g=>P.CompletionItem.to(g,u));return new C.$FK(o,s.incomplete)})),new $.$xM("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[$.$vM.Uri,$.$vM.Position,$.$vM.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new $.$wM("A promise that resolves to SignatureHelp.",s=>{if(s)return P.SignatureHelp.to(s)})),new $.$xM("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[$.$vM.Uri,$.$vM.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new $.$wM("A promise that resolves to an array of CodeLens-instances.",(s,c,u)=>D(o=>new C.$xK(P.Range.to(o.range),o.command&&u.fromInternal(o.command)))(s))),new $.$xM("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[$.$vM.Uri,new $.$vM("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",s=>C.$aK.isRange(s),s=>C.$bK.isSelection(s)?P.Selection.from(s):P.Range.from(s)),$.$vM.String.with("kind","Code action kind to return code actions for").optional(),$.$vM.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new $.$wM("A promise that resolves to an array of Command-instances.",(s,c,u)=>D(o=>{if(o._isSynthetic){if(!o.command)throw new Error("Synthetic code actions must have a command");return u.fromInternal(o.command)}else{const g=new C.$rK(o.title,o.kind?new C.$sK(o.kind):void 0);return o.edit&&(g.edit=P.WorkspaceEdit.to(o.edit)),o.command&&(g.command=u.fromInternal(o.command)),g.isPreferred=o.isPreferred,g}})(s))),new $.$xM("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[$.$vM.Uri],new $.$wM("A promise that resolves to an array of ColorInformation objects.",s=>s?s.map(c=>new C.$LK(P.Range.to(c.range),P.Color.to(c.color))):[])),new $.$xM("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new $.$vM("color","The color to show and insert",s=>s instanceof C.$KK,P.Color.from),new $.$vM("context","Context object with uri and range",s=>!0,s=>({uri:s.uri,range:P.Range.from(s.range)}))],new $.$wM("A promise that resolves to an array of ColorPresentation objects.",s=>s?s.map(P.ColorPresentation.to):[])),new $.$xM("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[$.$vM.Uri,$.$vM.Range],new $.$wM("A promise that resolves to an array of Inlay objects",(s,c,u)=>s.map(P.InlayHint.to.bind(void 0,u)))),new $.$xM("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[$.$vM.Uri],new $.$wM("A promise that resolves to an array of FoldingRange objects",(s,c)=>{if(s)return s.map(P.FoldingRange.to)})),new $.$xM("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new $.$wM("A promise that resolves to an array of NotebookContentProvider static info objects.",D(s=>({viewType:s.viewType,displayName:s.displayName,options:{transientOutputs:s.options.transientOutputs,transientCellMetadata:s.options.transientCellMetadata,transientDocumentMetadata:s.options.transientDocumentMetadata},filenamePattern:s.filenamePattern.map(c=>P.NotebookExclusiveDocumentPattern.to(c))})))),new $.$xM("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[$.$vM.Uri,$.$vM.Range,new $.$vM("context","An InlineValueContext",s=>s&&typeof s.frameId=="number"&&s.stoppedLocation instanceof C.$aK,s=>P.InlineValueContext.from(s))],new $.$wM("A promise that resolves to an array of InlineValue objects",s=>s.map(P.InlineValue.to))),new $.$xM("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new $.$vM("uriOrString","Uri-instance or string (only http/https)",s=>l.URI.isUri(s)||typeof s=="string"&&(0,k.$3T)(s,M.Schemas.http,M.Schemas.https),s=>s),new $.$vM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",s=>s===void 0||typeof s=="number"||typeof s=="object",s=>s&&(typeof s=="number"?[P.ViewColumn.from(s),void 0]:[P.ViewColumn.from(s.viewColumn),P.TextEditorOpenOptions.from(s)])).optional(),$.$vM.String.with("label","").optional()],$.$wM.Void),new $.$xM("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[$.$vM.Uri.with("resource","Resource to open"),$.$vM.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new $.$vM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",s=>s===void 0||typeof s=="number"||typeof s=="object",s=>s&&(typeof s=="number"?[P.ViewColumn.from(s),void 0]:[P.ViewColumn.from(s.viewColumn),P.TextEditorOpenOptions.from(s)])).optional()],$.$wM.Void),new $.$xM("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[$.$vM.Uri.with("left","Left-hand side resource of the diff editor"),$.$vM.Uri.with("right","Right-hand side resource of the diff editor"),$.$vM.String.with("title","Human readable title for the diff editor").optional(),new $.$vM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",s=>s===void 0||typeof s=="object",s=>s&&[P.ViewColumn.from(s.viewColumn),P.TextEditorOpenOptions.from(s)]).optional()],$.$wM.Void),new $.$xM("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[$.$vM.Uri,$.$vM.Position],new $.$wM("A promise that resolves to an array of TypeHierarchyItem-instances",s=>s.map(P.TypeHierarchyItem.to))),new $.$xM("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[$.$vM.TypeHierarchyItem],new $.$wM("A promise that resolves to an array of TypeHierarchyItem-instances",s=>s.map(P.TypeHierarchyItem.to))),new $.$xM("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[$.$vM.TypeHierarchyItem],new $.$wM("A promise that resolves to an array of TypeHierarchyItem-instances",s=>s.map(P.TypeHierarchyItem.to))),new $.$xM("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[$.$vM.TestItem],$.$wM.Void),new $.$xM("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[$.$vM.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],$.$wM.Void),new $.$xM("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[$.$vM.String.with("name","The context key name"),new $.$vM("value","The context key value",()=>!0,s=>s)],$.$wM.Void),new $.$xM("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[$.$vM.Uri,$.$vM.StringArray,new $.$vM("MappedEditsContext","Mapped Edits Context",s=>P.MappedEditsContext.is(s),s=>P.MappedEditsContext.from(s))],new $.$wM("A promise that resolves to a workspace edit or null",s=>s?P.WorkspaceEdit.to(s):null))];class S{static register(c){v.forEach(c.registerApiCommand,c),this.a(c)}static a(c){c.registerCommand(!1,"_validateWhenClauses",m.$Ki)}}e.$Gbc=S;function D(s){return c=>{if(Array.isArray(c))return c.map(s)}}function E(s){if(!Array.isArray(s))return;const c=[];for(const u of s)R.$0s(u)?c.push(P.DefinitionLink.to(u)):c.push(P.location.to(u));return c}}),define(Se[302],De([1,0,9,56,4,3,2,83,25,13,7,6,27]),function(ne,e,y,M,l,R,A,m,k,$,P,C,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ibc=void 0;function S(D,E,s){const c=D.getProxy(C.$9J.MainThreadComments);class u{constructor(){this.b=new Map,this.c=new k.$Zl,E.registerArgumentProcessor({processArgument:h=>{if(h&&h.$mid===6){const p=this.b.get(h.handle);return p?p.value:h}else if(h&&h.$mid===7){const p=this.b.get(h.commentControlHandle);if(!p)return h;const I=p.getCommentThread(h.commentThreadHandle);return I?I.value:h}else if(h&&(h.$mid===9||h.$mid===8)){const p=this.b.get(h.thread.commentControlHandle);if(!p)return h;const I=p.getCommentThread(h.thread.commentThreadHandle);return I?h.$mid===8?I.value:{thread:I.value,text:h.text}:h}else if(h&&h.$mid===10){const p=this.b.get(h.thread.commentControlHandle);if(!p)return h;const I=p.getCommentThread(h.thread.commentThreadHandle);if(!I)return h;const w=h.commentUniqueId,f=I.getCommentByUniqueId(w);return f||h}else if(h&&h.$mid===11){const p=this.b.get(h.thread.commentControlHandle);if(!p)return h;const I=p.getCommentThread(h.thread.commentThreadHandle);if(!I)return h;const w=h.text,f=h.commentUniqueId,b=I.getCommentByUniqueId(f);return b?(typeof b.body=="string"?b.body=w:b.body=new P.$yK(w),b):h}return h}})}createCommentController(h,p,I){const w=u.a++,f=new g(h,w,p,I);this.b.set(f.handle,f);const b=this.c.get(h.identifier)||[];return b.push(f),this.c.set(h.identifier,b),f.value}$createCommentThreadTemplate(h,p,I){const w=this.b.get(h);w&&w.$createCommentThreadTemplate(p,I)}async $updateCommentThreadTemplate(h,p,I){const w=this.b.get(h);w&&w.$updateCommentThreadTemplate(p,I)}$deleteCommentThread(h,p){this.b.get(h)?.$deleteCommentThread(p)}$provideCommentingRanges(h,p,I){const w=this.b.get(h);if(!w||!w.commentingRangeProvider)return Promise.resolve(void 0);const f=s.getDocument(A.URI.revive(p));return(0,y.$Jg)(async()=>{const b=await w.commentingRangeProvider.provideCommentingRanges(f,I);let L;return Array.isArray(b)?L={ranges:b,fileComments:!1}:b?L={ranges:b.ranges||[],fileComments:b.fileComments||!1}:L=b??void 0,L}).then(b=>{let L;return b&&(L={ranges:b.ranges.map(O=>$.Range.from(O)),fileComments:b.fileComments}),L})}$toggleReaction(h,p,I,w,f){const b=this.b.get(h);return!b||!b.reactionHandler?Promise.resolve(void 0):(0,y.$Jg)(()=>{const L=b.getCommentThread(p);if(L){const O=L.getCommentByUniqueId(w.uniqueIdInThread);if(b!==void 0&&O&&b.reactionHandler)return b.reactionHandler(O,n(f))}return Promise.resolve(void 0)})}}u.a=0;class o{set threadId(h){this.n=h}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(h){(h===void 0!=(this.p===void 0)||!h||!this.p||!h.isEqual(this.p))&&(this.p=h,this.b.range=h,this.c.fire())}get range(){return this.p}set canReply(h){this.d!==h&&(this.d=h,this.b.canReply=h,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(h){this.e=h,this.b.label=h,this.c.fire()}get contextValue(){return this.f}set contextValue(h){this.f=h,this.b.contextValue=h,this.c.fire()}get comments(){return this.q}set comments(h){this.q=h,this.b.comments=h,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(h){this.g=h,this.b.collapsibleState=h,this.c.fire()}get state(){return this.h}set state(h){this.h=h,this.b.state=h,this.c.fire()}get isDisposed(){return this.j}constructor(h,p,I,w,f,b,L,O){this.m=p,this.n=I,this.o=w,this.p=f,this.q=b,this.extensionDescription=L,this.r=O,this.handle=o.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new l.$Ld,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new R.$Rc,this.l.value=new R.$Pc,this.n===void 0&&(this.n=`${h}.${this.handle}`),c.$createCommentThread(p,this.handle,this.n,this.o,$.Range.from(this.p),L.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=b,this.i.push({dispose:()=>{c.$deleteCommentThread(p,this.handle)}});const T=this;this.value={get uri(){return T.uri},get range(){return T.range},set range(F){T.range=F},get comments(){return T.comments},set comments(F){T.comments=F},get collapsibleState(){return T.collapsibleState},set collapsibleState(F){T.collapsibleState=F},get canReply(){return T.canReply},set canReply(F){T.canReply=F},get contextValue(){return T.contextValue},set contextValue(F){T.contextValue=F},get label(){return T.label},set label(F){T.label=F},get state(){return T.state},set state(F){T.state=F},dispose:()=>{T.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new R.$Pc);const h=I=>Object.prototype.hasOwnProperty.call(this.b,I),p={};h("range")&&(p.range=$.Range.from(this.p)),h("label")&&(p.label=this.label),h("contextValue")&&(p.contextValue=this.contextValue??null),h("comments")&&(p.comments=this.q.map(I=>d(this,I,this.k,this.extensionDescription))),h("collapsibleState")&&(p.collapseState=r(this.g)),h("canReply")&&(p.canReply=this.canReply),h("state")&&(p.state=i(this.h)),h("isTemplate")&&(p.isTemplate=this.r),this.b={},c.$updateCommentThread(this.m,this.handle,this.n,this.o,p)}getCommentByUniqueId(h){for(const p of this.k){const I=p[0],w=p[1];if(h===w)return I}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(h=>h.dispose())}}o.a=0,Ke([(0,M.$eh)(100)],o.prototype,"eventuallyUpdateCommentThread",null);class g{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(h){this.b=h,c.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(h){this.c=h,c.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!h})}get options(){return this.d}set options(h){this.d=h,c.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(h,p,I,w){this.f=h,this.g=p,this.h=I,this.i=w,this.a=new Map,c.$registerCommentController(this.handle,I,w,this.f.identifier.value);const f=this;this.value=Object.freeze({id:f.id,label:f.label,get options(){return f.options},set options(b){f.options=b},get commentingRangeProvider(){return f.commentingRangeProvider},set commentingRangeProvider(b){f.commentingRangeProvider=b},get reactionHandler(){return f.reactionHandler},set reactionHandler(b){f.reactionHandler=b},createCommentThread(b,L,O){return f.createCommentThread(b,L,O).value},dispose:()=>{f.dispose()}}),this.e=[],this.e.push({dispose:()=>{c.$unregisterCommentController(this.handle)}})}createCommentThread(h,p,I){p===void 0&&(0,v.$8E)(this.f,"fileComments");const w=new o(this.id,this.handle,void 0,h,p,I,this.f,!1);return this.a.set(w.handle,w),w}$createCommentThreadTemplate(h,p){const I=new o(this.id,this.handle,void 0,A.URI.revive(h),$.Range.to(p),[],this.f,!0);return I.collapsibleState=m.CommentThreadCollapsibleState.Expanded,this.a.set(I.handle,I),I}$updateCommentThreadTemplate(h,p){const I=this.a.get(h);I&&(I.range=$.Range.to(p))}$deleteCommentThread(h){this.a.get(h)?.dispose(),this.a.delete(h)}getCommentThread(h){return this.a.get(h)}dispose(){this.a.forEach(h=>{h.dispose()}),this.e.forEach(h=>h.dispose())}}function d(a,h,p,I){let w=p.get(h);return w||(w=++a.commentHandle,p.set(h,w)),h.state!==void 0&&(0,v.$8E)(I,"commentsDraftState"),{mode:h.mode,contextValue:h.contextValue,uniqueIdInThread:w,body:typeof h.body=="string"?h.body:$.MarkdownString.from(h.body),userName:h.author.name,userIconPath:h.author.iconPath,label:h.label,commentReactions:h.reactions?h.reactions.map(f=>t(f)):void 0,state:h.state,timestamp:h.timestamp?.toJSON()}}function t(a){return{label:a.label,iconPath:a.iconPath?$.$9L(a.iconPath):void 0,count:a.count,hasReacted:a.authorHasReacted}}function n(a){return{label:a.label||"",count:a.count||0,iconPath:a.iconPath?A.URI.revive(a.iconPath):"",authorHasReacted:a.hasReacted||!1}}function r(a){if(a!==void 0)switch(a){case P.CommentThreadCollapsibleState.Expanded:return m.CommentThreadCollapsibleState.Expanded;case P.CommentThreadCollapsibleState.Collapsed:return m.CommentThreadCollapsibleState.Collapsed}return m.CommentThreadCollapsibleState.Collapsed}function i(a){if(a!==void 0)switch(a){case P.CommentThreadState.Unresolved:return m.CommentThreadState.Unresolved;case P.CommentThreadState.Resolved:return m.CommentThreadState.Resolved}return m.CommentThreadState.Unresolved}return new u}e.$Ibc=S}),define(Se[303],De([1,0,23,6,26,20]),function(ne,e,y,M,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fdc=void 0;let A=class{constructor(P,C){this.a=P.getProxy(M.$9J.MainThreadConsole),this.b=C.consoleForward.includeStack,this.c=C.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(P,C){const v=this,S=console[P];Object.defineProperty(console,P,{set:()=>{},get:()=>function(){v.e(P,C,S,arguments)}})}e(P,C,v,S){this.a.$logExtensionHostMessage({type:"__$console",severity:C,arguments:k(S,this.b)}),this.c&&this.f(P,v,S)}};e.$Fdc=A,e.$Fdc=A=Ke([We(0,R.$0L),We(1,l.$nM)],A);const m=1e5;function k($,P){const C=[];if($.length)for(let v=0;v<$.length;v++){let S=$[v];if(typeof S>"u")S="undefined";else if(S instanceof Error){const D=S;D.stack?S=D.stack:S=D.toString()}C.push(S)}if(P){const v=new Error().stack;v&&C.push({__$stack:v.split(`
`).slice(3).join(`
`)})}try{const v=(0,y.$3m)(C);return v.length>m?"Output omitted for a large object that exceeds the limits":v}catch(v){return`Output omitted for an object that cannot be inspected ('${v.toString()}')`}}}),define(Se[150],De([1,0,2,6,7,5,20,14,19,16,15,27]),function(ne,e,y,M,l,R,A,m,k,$,P,C){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.$Kcc=e.$Jcc=void 0;let S=v=class{constructor(E,s){this.h=s,this.f=new Map,this.g=E.getProxy(M.$9J.MainThreadDecorations)}registerFileDecorationProvider(E,s){const c=v.c++;this.f.set(c,{provider:E,extensionDescription:s}),this.g.$registerDecorationProvider(c,s.identifier.value);const u=E.onDidChangeFileDecorations&&E.onDidChangeFileDecorations(o=>{if(!o){this.g.$onDidChange(c,null);return}const g=(0,k.$1b)(o);if(g.length<=v.d){this.g.$onDidChange(c,g);return}this.h.warn("[Decorations] CAPPING events from decorations provider",s.identifier.value,g.length);const d=g.map(r=>({uri:r,rank:(0,$.$Ee)(r.path,"/")})),t=(0,k.$xb)(d,(r,i)=>r.rank-i.rank||(0,$.$Se)(r.uri.path,i.uri.path)),n=[];e:for(const r of t){let i;for(const a of r){const h=(0,P.$kc)(a.uri.path);if(i!==h&&(i=h,n.push(a.uri)>=v.d))break e}}this.g.$onDidChange(c,n)});return new l.$$J(()=>{u?.dispose(),this.g.$unregisterDecorationProvider(c),this.f.delete(c)})}async $provideDecorations(E,s,c){if(!this.f.has(E))return Object.create(null);const u=Object.create(null),{provider:o,extensionDescription:g}=this.f.get(E);return await Promise.all(s.map(async d=>{try{const{uri:t,id:n}=d,r=await Promise.resolve(o.provideFileDecoration(y.URI.revive(t),c));if(!r)return;try{l.$tL.validate(r),r.badge&&typeof r.badge!="string"&&(0,C.$8E)(g,"codiconDecoration"),u[n]=[r.propagate,r.tooltip,r.badge,r.color]}catch(i){this.h.warn(`INVALID decoration from extension '${g.identifier.value}': ${i}`)}}catch(t){this.h.error(t)}})),u}};e.$Jcc=S,S.c=0,S.d=250,e.$Jcc=S=v=Ke([We(0,A.$0L),We(1,m.$6i)],S),e.$Kcc=(0,R.$Lh)("IExtHostDecorations")});var et=this&&this.__classPrivateFieldSet||function(ne,e,y,M,l){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!l:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?l.call(ne,y):l?l.value=y:e.set(ne,y),y},Be=this&&this.__classPrivateFieldGet||function(ne,e,y,M){if(y==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!M:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return y==="m"?M:y==="a"?M.call(ne):M?M.value:e.get(ne)};define(Se[304],De([1,0,203,134,2,6,7,13,4,14,28,54]),function(ne,e,y,M,l,R,A,m,k,$,P,C){"use strict";var v,S,D,E;Object.defineProperty(e,"__esModule",{value:!0}),e.$Bbc=e.$Abc=void 0;class s{constructor(o,g,d,t,n,r,i,a){this.d=o,this.e=g,this.f=d,this.g=t,this.h=n,v.set(this,void 0),S.set(this,void 0),D.set(this,void 0),this.c=!1,this.f=Math.max(t,d),et(this,D,new P.$yc(h=>r.getComparisonKey(h)),"f"),et(this,v,i,"f"),et(this,S,a,"f")}dispose(){this.c||(Be(this,S,"f").fire([...Be(this,D,"f").keys()]),Be(this,v,"f")?.$clear(this.e),Be(this,D,"f").clear(),this.c=!0)}get name(){return this.j(),this.d}set(o,g){if(!o){this.clear();return}this.j();let d=[];if(l.URI.isUri(o)){if(!g){this.delete(o);return}Be(this,D,"f").set(o,g.slice()),d=[o]}else if(Array.isArray(o)){d=[];let r;o=[...o].sort(s.k);for(const i of o){const[a,h]=i;if((!r||a.toString()!==r.toString())&&(r&&Be(this,D,"f").get(r).length===0&&Be(this,D,"f").delete(r),r=a,d.push(a),Be(this,D,"f").set(a,[])),h)Be(this,D,"f").get(a)?.push(...h);else{const p=Be(this,D,"f").get(a);p&&(p.length=0)}}}if(Be(this,S,"f").fire(d),!Be(this,v,"f"))return;const t=[];let n=0;for(const r of d){let i=[];const a=Be(this,D,"f").get(r);if(a)if(a.length>this.g){i=[];const h=[A.DiagnosticSeverity.Error,A.DiagnosticSeverity.Warning,A.DiagnosticSeverity.Information,A.DiagnosticSeverity.Hint];e:for(let p=0;p<4;p++)for(const I of a)if(I.severity===h[p]&&i.push({...m.Diagnostic.from(I),modelVersionId:this.h(r)})===this.g)break e;i.push({severity:M.MarkerSeverity.Info,message:(0,y.localize)(0,null,a.length-this.g),startLineNumber:i[i.length-1].startLineNumber,startColumn:i[i.length-1].startColumn,endLineNumber:i[i.length-1].endLineNumber,endColumn:i[i.length-1].endColumn})}else i=a.map(h=>({...m.Diagnostic.from(h),modelVersionId:this.h(r)}));if(t.push([r,i]),n+=i.length,n>this.f)break}Be(this,v,"f").$changeMany(this.e,t)}delete(o){this.j(),Be(this,S,"f").fire([o]),Be(this,D,"f").delete(o),Be(this,v,"f")?.$changeMany(this.e,[[o,void 0]])}clear(){this.j(),Be(this,S,"f").fire([...Be(this,D,"f").keys()]),Be(this,D,"f").clear(),Be(this,v,"f")?.$clear(this.e)}forEach(o,g){this.j();for(const[d,t]of this)o.call(g,d,t,this)}*[(v=new WeakMap,S=new WeakMap,D=new WeakMap,Symbol.iterator)](){this.j();for(const o of Be(this,D,"f").keys())yield[o,this.get(o)]}get(o){this.j();const g=Be(this,D,"f").get(o);return Array.isArray(g)?Object.freeze(g.slice(0)):[]}has(o){return this.j(),Array.isArray(Be(this,D,"f").get(o))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(o,g){return o[0].toString()<g[0].toString()?-1:o[0].toString()>g[0].toString()?1:0}}e.$Abc=s;let c=E=class{static _mapper(o){const g=new P.$yc;for(const d of o)g.set(d,d);return{uris:Object.freeze(Array.from(g.values()))}}constructor(o,g,d,t){this.j=g,this.k=d,this.l=t,this.g=new Map,this.h=new k.$Pd({merge:n=>n.flat(),delay:50}),this.onDidChangeDiagnostics=k.Event.map(this.h.event,E._mapper),this.f=o.getProxy(R.$9J.MainThreadDiagnostics)}createDiagnosticCollection(o,g){const{g:d,f:t,h:n,j:r,k:i,l:a}=this,h=new class{$changeMany(w,f){t.$changeMany(w,f),r.trace("[DiagnosticCollection] change many (extension, owner, uris)",o.value,w,f.length===0?"CLEARING":f)}$clear(w){t.$clear(w),r.trace("[DiagnosticCollection] remove all (extension, owner)",o.value,w)}dispose(){t.dispose()}};let p;if(!g)g="_generated_diagnostic_collection_name_#"+E.c++,p=g;else if(!d.has(g))p=g;else{this.j.warn(`DiagnosticCollection with name '${g}' does already exist.`);do p=g+E.c++;while(d.has(p))}return new class extends s{constructor(){super(g,p,E.e,E.d,w=>a.getDocument(w)?.version,i.extUri,h,n),d.set(p,this)}dispose(){super.dispose(),d.delete(p)}}}getDiagnostics(o){if(o)return this.m(o);{const g=new Map,d=[];for(const t of this.g.values())t.forEach((n,r)=>{let i=g.get(n.toString());typeof i>"u"&&(i=d.length,g.set(n.toString(),i),d.push([n,[]])),d[i][1]=d[i][1].concat(...r)});return d}}m(o){let g=[];for(const d of this.g.values())d.has(o)&&(g=g.concat(d.get(o)));return g}$acceptMarkersChange(o){if(!this.n){const g="_generated_mirror",d=new s(g,g,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,t=>{},this.k.extUri,void 0,this.h);this.g.set(g,d),this.n=d}for(const[g,d]of o)this.n.set(l.URI.revive(g),d.map(m.Diagnostic.to))}};e.$Bbc=c,c.c=0,c.d=1e3,c.e=1.1*E.d,e.$Bbc=c=E=Ke([We(1,$.$6i),We(2,C.$zbc)],c)}),define(Se[305],De([1,0,2,6,27]),function(ne,e,y,M,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qbc=void 0;class R{constructor(m){this.a=m.getProxy(M.$9J.MainThreadDialogs)}showOpenDialog(m,k){return k?.allowUIResources&&(0,l.$8E)(m,"showLocal"),this.a.$showOpenDialog(k).then($=>$?$.map(P=>y.URI.revive(P)):void 0)}showSaveDialog(m){return this.a.$showSaveDialog(m).then(k=>k?y.URI.revive(k):void 0)}}e.$Qbc=R}),define(Se[306],De([1,0,8,2,7,6,17,21,16]),function(ne,e,y,M,l,R,A,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rbc=void 0;class ${constructor(C,v,S){this.d=v,this.e=S,this.b=new Map,this.c=C.getProxy(R.$9J.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(C,v){if(Object.keys(A.Schemas).indexOf(C)>=0)throw new Error(`scheme '${C}' already registered`);const S=$.a++;this.b.set(S,v),this.c.$registerTextContentProvider(S,C);let D;return typeof v.onDidChange=="function"&&(D=v.onDidChange(E=>{if(E.scheme!==C){this.e.warn(`Provider for scheme '${C}' is firing event for schema '${E.scheme}' which will be IGNORED`);return}this.d.getDocument(E)&&this.$provideTextDocumentContent(S,E).then(s=>{if(!s&&typeof s!="string")return;const c=this.d.getDocument(E);if(!c)return;const u=(0,k.$Ne)(s);if(!c.equalLines(u))return this.c.$onVirtualDocumentChange(E,s)},y.$Y)})),new l.$$J(()=>{this.b.delete(S)&&this.c.$unregisterTextContentProvider(S),D&&(D.dispose(),D=void 0)})}$provideTextDocumentContent(C,v){const S=this.b.get(C);return S?Promise.resolve(S.provideTextDocumentContent(M.URI.revive(v),m.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${v.scheme}`))}}e.$Rbc=$,$.a=0}),define(Se[307],De([1,0,4,3,2,6,142,13,18,23,7,8]),function(ne,e,y,M,l,R,A,m,k,$,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xbc=void 0;class v{constructor(D,E){this.a=new y.$Ld({onListenerError:C.$Z}),this.b=new y.$Ld({onListenerError:C.$Z}),this.c=new y.$Ld({onListenerError:C.$Z}),this.d=new y.$Ld({onListenerError:C.$Z}),this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new M.$Pc,this.h=new Map,this.f=D.getProxy(R.$9J.MainThreadDocuments),this.g=E,this.g.onDidRemoveDocuments(s=>{for(const c of s)this.b.fire(c.document)},void 0,this.e),this.g.onDidAddDocuments(s=>{for(const c of s)this.a.fire(c.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(D){if(!D)return;const E=this.g.getDocument(D);if(E)return E}getDocument(D){const E=this.getDocumentData(D);if(!E?.document)throw new Error(`Unable to retrieve document from URI '${D}'`);return E.document}ensureDocumentData(D){const E=this.g.getDocument(D);if(E)return Promise.resolve(E);let s=this.h.get(D.toString());return s||(s=this.f.$tryOpenDocument(D).then(c=>{this.h.delete(D.toString());const u=l.URI.revive(c);return(0,k.$Hf)(this.g.getDocument(u))},c=>(this.h.delete(D.toString()),Promise.reject(c))),this.h.set(D.toString(),s)),s}createDocumentData(D){return this.f.$tryCreateDocument(D).then(E=>l.URI.revive(E))}$acceptModelLanguageChanged(D,E){const s=l.URI.revive(D),c=this.g.getDocument(s);if(!c)throw new Error("unknown document");this.b.fire(c.document),c._acceptLanguageId(E),this.a.fire(c.document)}$acceptModelSaved(D){const E=l.URI.revive(D),s=this.g.getDocument(E);if(!s)throw new Error("unknown document");this.$acceptDirtyStateChanged(D,!1),this.d.fire(s.document)}$acceptDirtyStateChanged(D,E){const s=l.URI.revive(D),c=this.g.getDocument(s);if(!c)throw new Error("unknown document");c._acceptIsDirty(E),this.c.fire({document:c.document,contentChanges:[],reason:void 0})}$acceptModelChanged(D,E,s){const c=l.URI.revive(D),u=this.g.getDocument(c);if(!u)throw new Error("unknown document");u._acceptIsDirty(s),u.onEvents(E);let o;E.isUndoing?o=P.TextDocumentChangeReason.Undo:E.isRedoing&&(o=P.TextDocumentChangeReason.Redo),this.c.fire((0,$.$Ym)({document:u.document,contentChanges:E.changes.map(g=>({range:m.Range.to(g.range),rangeOffset:g.rangeOffset,rangeLength:g.rangeLength,text:g.text})),reason:o}))}setWordDefinitionFor(D,E){(0,A.$_L)(D,E)}}e.$xbc=v}),define(Se[70],De([1,0,57,4,3,2,5,6,142,20,147,13,14,28,17,50,58]),function(ne,e,y,M,l,R,A,m,k,$,P,C,v,S,D,E,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iM=e.$hM=void 0;class c{constructor(g){this.value=g,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let u=class{constructor(g,d){this.h=g,this.i=d,this.a=null,this.b=new Map,this.c=new S.$yc,this.d=new M.$Ld,this.e=new M.$Ld,this.f=new M.$Ld,this.g=new M.$Ld,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(g){this.acceptDocumentsAndEditorsDelta(g)}acceptDocumentsAndEditorsDelta(g){const d=[],t=[],n=[];if(g.removedDocuments)for(const r of g.removedDocuments){const i=R.URI.revive(r),a=this.c.get(i);a?.unref()&&(this.c.delete(i),d.push(a.value))}if(g.addedDocuments)for(const r of g.addedDocuments){const i=R.URI.revive(r.uri);let a=this.c.get(i);if(a&&i.scheme!==D.Schemas.vscodeNotebookCell&&i.scheme!==D.Schemas.vscodeInteractiveInput)throw new Error(`document '${i} already exists!'`);a||(a=new c(new k.$aM(this.h.getProxy(m.$9J.MainThreadDocuments),i,r.lines,r.EOL,r.versionId,r.languageId,r.isDirty,r.notebook)),this.c.set(i,a),t.push(a.value)),a.ref()}if(g.removedEditors)for(const r of g.removedEditors){const i=this.b.get(r);this.b.delete(r),i&&n.push(i)}if(g.addedEditors)for(const r of g.addedEditors){const i=R.URI.revive(r.documentUri);y.ok(this.c.has(i),`document '${i}' does not exist`),y.ok(!this.b.has(r.id),`editor '${r.id}' already exists!`);const a=this.c.get(i).value,h=new P.$gM(r.id,this.h.getProxy(m.$9J.MainThreadTextEditors),this.i,new s.$T(()=>a.document),r.selections.map(C.Selection.to),r.options,r.visibleRanges.map(p=>C.Range.to(p)),typeof r.editorPosition=="number"?C.ViewColumn.to(r.editorPosition):void 0);this.b.set(r.id,h)}g.newActiveEditor!==void 0&&(y.ok(g.newActiveEditor===null||this.b.has(g.newActiveEditor),`active editor '${g.newActiveEditor}' does not exist`),this.a=g.newActiveEditor),(0,l.$Lc)(d),(0,l.$Lc)(n),g.removedDocuments&&this.e.fire(d),g.addedDocuments&&this.d.fire(t),(g.removedEditors||g.addedEditors)&&this.f.fire(this.allEditors().map(r=>r.value)),g.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(g){return this.c.get(g)?.value}allDocuments(){return E.Iterable.map(this.c.values(),g=>g.value)}getEditor(g){return this.b.get(g)}activeEditor(g){if(!this.a)return;const d=this.b.get(this.a);return g?d:d?.value}allEditors(){return[...this.b.values()]}};e.$hM=u,e.$hM=u=Ke([We(0,$.$0L),We(1,v.$6i)],u),e.$iM=(0,A.$Lh)("IExtHostDocumentsAndEditors")}),define(Se[71],De([1,0,13,6,2,4,5,7,20,18,74]),function(ne,e,y,M,l,R,A,m,k,$,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pcc=e.$Occ=void 0,e.$Occ=(0,A.$Lh)("IExtHostEditorTabs");class C{constructor(s,c,u){this.e=u,this.d=c,this.acceptDtoUpdate(s)}get apiObject(){if(!this.a){const s=this,c={get isActive(){return s.b.id===s.e()},get label(){return s.b.label},get input(){return s.c},get isDirty(){return s.b.isDirty},get isPinned(){return s.b.isPinned},get isPreview(){return s.b.isPreview},get group(){return s.d.apiObject}};this.a=Object.freeze(c)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(s){this.b=s,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new m.$PL(l.URI.revive(this.b.input.uri));case 2:return new m.$QL(l.URI.revive(this.b.input.original),l.URI.revive(this.b.input.modified));case 3:return new m.$RL(l.URI.revive(this.b.input.base),l.URI.revive(this.b.input.input1),l.URI.revive(this.b.input.input2),l.URI.revive(this.b.input.result));case 6:return new m.$SL(l.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new m.$TL(this.b.input.viewType);case 4:return new m.$UL(l.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new m.$VL(l.URI.revive(this.b.input.original),l.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new m.$WL;case 9:return new m.$XL(l.URI.revive(this.b.input.uri),l.URI.revive(this.b.input.inputBoxUri));default:return}}}class v{constructor(s,c){this.c=[],this.d="",this.b=s,this.e=c;for(const u of s.tabs)u.isActive&&(this.d=u.id),this.c.push(new C(u,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const s=this,c={get isActive(){return s.b.groupId===s.e()},get viewColumn(){return y.ViewColumn.to(s.b.viewColumn)},get activeTab(){return s.c.find(u=>u.tabId===s.d)?.apiObject},get tabs(){return Object.freeze(s.c.map(u=>u.apiObject))}};this.a=Object.freeze(c)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(s){this.b=s}acceptTabOperation(s){if(s.kind===0){const u=new C(s.tabDto,this,()=>this.activeTabId());return this.c.splice(s.index,0,u),s.tabDto.isActive&&(this.d=u.tabId),u}else if(s.kind===1){const u=this.c.splice(s.index,1)[0];if(!u)throw new Error(`Tab close updated received for index ${s.index} which does not exist`);return u.tabId===this.d&&(this.d=""),u}else if(s.kind===3){if(s.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const u=this.c.splice(s.oldIndex,1)[0];if(!u)throw new Error(`Tab move updated received for index ${s.oldIndex} which does not exist`);return this.c.splice(s.index,0,u),u}const c=this.c.find(u=>u.tabId===s.tabDto.id);if(!c)throw new Error("INVALID tab");return s.tabDto.isActive?this.d=s.tabDto.id:this.d===s.tabDto.id&&!s.tabDto.isActive&&(this.d=""),c.acceptDtoUpdate(s.tabDto),c}activeTabId(){return this.d}}let S=class{constructor(s){this.b=new R.$Ld,this.c=new R.$Ld,this.e=[],this.a=s.getProxy(M.$9J.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const s=this,c={onDidChangeTabGroups:s.c.event,onDidChangeTabs:s.b.event,get all(){return Object.freeze(s.e.map(u=>u.apiObject))},get activeTabGroup(){const u=s.d;return(0,$.$Hf)(s.e.find(g=>g.groupId===u)?.apiObject)},close:async(u,o)=>{const g=Array.isArray(u)?u:[u];return g.length?D(g[0])?this.j(g,o):this.i(g,o):!0}};this.f=Object.freeze(c)}return this.f}$acceptEditorTabModel(s){const c=new Set(this.e.map(r=>r.groupId)),u=new Set(s.map(r=>r.groupId)),o=(0,P.$E)(c,u),g=this.e.filter(r=>o.removed.includes(r.groupId)).map(r=>r.apiObject),d=[],t=[];this.e=s.map(r=>{const i=new v(r,()=>this.d);return o.added.includes(i.groupId)?d.push(i.apiObject):t.push(i.apiObject),i});const n=(0,$.$Hf)(s.find(r=>r.isActive===!0)?.groupId);n!==void 0&&this.d!==n&&(this.d=n),this.c.fire(Object.freeze({opened:d,closed:g,changed:t}))}$acceptTabGroupUpdate(s){const c=this.e.find(u=>u.groupId===s.groupId);if(!c)throw new Error("Update Group IPC call received before group creation.");c.acceptGroupDtoUpdate(s),s.isActive&&(this.d=s.groupId),this.c.fire(Object.freeze({changed:[c.apiObject],opened:[],closed:[]}))}$acceptTabOperation(s){const c=this.e.find(o=>o.groupId===s.groupId);if(!c)throw new Error("Update Tabs IPC call received before group creation.");const u=c.acceptTabOperation(s);switch(s.kind){case 0:this.b.fire(Object.freeze({opened:[u.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[u.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[u.apiObject]}));return}}g(s){for(const c of this.e)for(const u of c.tabs)if(u.apiObject===s)return u}h(s){return this.e.find(c=>c.apiObject===s)}async i(s,c){const u=[];for(const o of s){const g=this.g(o);if(!g)throw new Error("Tab close: Invalid tab not found!");u.push(g.tabId)}return this.a.$closeTab(u,c)}async j(s,c){const u=[];for(const o of s){const g=this.h(o);if(!g)throw new Error("Group close: Invalid group not found!");u.push(g.groupId)}return this.a.$closeGroup(u,c)}};e.$Pcc=S,e.$Pcc=S=Ke([We(0,k.$0L)],S);function D(E){return E.tabs!==void 0}}),define(Se[308],De([1,0,6,7]),function(ne,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bdc=void 0;class l{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(y.$9J.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(A,m,k){if(this.a.size===0)throw new Error("No embedding vector providers registered");const $=this.a.get(A);if(!$)throw new Error("Embedding vector provider not found");const P=await $.provideEmbeddingVector(m,k);if(!P)throw new Error("Embedding vector provider returned undefined");return P}registerEmbeddingVectorProvider(A,m,k){const $=this.b;return this.b++,this.a.set($,k),this.c.$registerAiEmbeddingVectorProvider(m,$),new M.$$J(()=>{this.c.$unregisterAiEmbeddingVectorProvider($),this.a.delete($)})}}e.$Bdc=l}),define(Se[309],De([1,0,2,6,3,7,13,175,16,22,27,80]),function(ne,e,y,M,l,R,A,m,k,$,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lcc=void 0;class v{constructor(){this.a=[]}add(E){this.b=void 0,this.a.push(E)}delete(E){const s=this.a.indexOf(E);s>=0&&(this.a.splice(s,1),this.b=void 0)}c(){if(!this.b){const E=this.a.sort(),s=[];let c,u,o=14,g=14;for(const d of E){let t=c?(0,k.$2e)(c,d):0;for(t===0?u=1:u=g;t<d.length;t++)t+1===d.length?(o=g,g=9):g+=1,s.push([u,d.toUpperCase().charCodeAt(t),g]),s.push([u,d.toLowerCase().charCodeAt(t),g]),u=g;c=d,g=o}s.push([9,58,10]),s.push([10,47,12]),this.b=new m.$LY(s)}}provideDocumentLinks(E){this.c();const s=[],c=m.$MY.computeLinks({getLineContent(u){return E.lineAt(u-1).text},getLineCount(){return E.lineCount}},this.b);for(const u of c){const o=A.DocumentLink.to(u);o.target&&s.push(o)}return s}}class S{constructor(E,s){this.i=s,this.b=new v,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=E.getProxy(M.$9J.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(E,s,c,u={}){if(S.j(c),this.d.has(s))throw new Error(`a provider for the scheme '${s}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(E,"*",this.b));const o=this.h++;this.b.add(s),this.d.add(s),this.c.set(o,c);let g=2;u.isCaseSensitive&&(g+=1024),u.isReadonly&&(g+=2048),typeof c.copy=="function"&&(g+=8),typeof c.open=="function"&&typeof c.close=="function"&&typeof c.read=="function"&&typeof c.write=="function"&&((0,P.$8E)(E,"fsChunks"),g+=4);let d;u.isReadonly&&(0,C.$1j)(u.isReadonly)&&((0,P.$8E)(E,"readonlyMessage"),d={value:u.isReadonly.value,isTrusted:u.isReadonly.isTrusted,supportThemeIcons:u.isReadonly.supportThemeIcons,supportHtml:u.isReadonly.supportHtml,baseUri:u.isReadonly.baseUri,uris:u.isReadonly.uris}),this.a.$registerFileSystemProvider(o,s,g,d).catch(n=>{console.error(`FAILED to register filesystem provider of ${E.identifier.value}-extension for the scheme ${s}`),console.error(n)});const t=c.onDidChangeFile(n=>{const r=[];for(const i of n){const{uri:a,type:h}=i;if(a.scheme!==s)continue;let p;switch(h){case R.FileChangeType.Changed:p=0;break;case R.FileChangeType.Created:p=1;break;case R.FileChangeType.Deleted:p=2;break;default:throw new Error("Unknown FileChangeType")}r.push({resource:a,type:p})}this.a.$onFileSystemChange(o,r)});return(0,l.$Oc)(()=>{t.dispose(),this.b.delete(s),this.d.delete(s),this.c.delete(o),this.a.$unregisterProvider(o)})}static j(E){if(!E)throw new Error("MISSING provider");if(typeof E.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof E.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof E.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof E.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof E.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof E.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof E.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof E.rename!="function")throw new Error("Provider does NOT implement rename")}static k(E){const{type:s,ctime:c,mtime:u,size:o,permissions:g}=E;return{type:s,ctime:c,mtime:u,size:o,permissions:g}}$stat(E,s){return Promise.resolve(this.l(E).stat(y.URI.revive(s))).then(c=>S.k(c))}$readdir(E,s){return Promise.resolve(this.l(E).readDirectory(y.URI.revive(s)))}$readFile(E,s){return Promise.resolve(this.l(E).readFile(y.URI.revive(s))).then(c=>$.$_d.wrap(c))}$writeFile(E,s,c,u){return Promise.resolve(this.l(E).writeFile(y.URI.revive(s),c.buffer,u))}$delete(E,s,c){return Promise.resolve(this.l(E).delete(y.URI.revive(s),c))}$rename(E,s,c,u){return Promise.resolve(this.l(E).rename(y.URI.revive(s),y.URI.revive(c),u))}$copy(E,s,c,u){const o=this.l(E);if(!o.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(o.copy(y.URI.revive(s),y.URI.revive(c),u))}$mkdir(E,s){return Promise.resolve(this.l(E).createDirectory(y.URI.revive(s)))}$watch(E,s,c,u){const o=this.l(E).watch(y.URI.revive(c),u);this.f.set(s,o)}$unwatch(E,s){const c=this.f.get(s);c&&(c.dispose(),this.f.delete(s))}$open(E,s,c){const u=this.l(E);if(!u.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(u.open(y.URI.revive(s),c))}$close(E,s){const c=this.l(E);if(!c.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(c.close(s))}$read(E,s,c,u){const o=this.l(E);if(!o.read)throw new Error('FileSystemProvider does not implement "read"');const g=$.$_d.alloc(u);return Promise.resolve(o.read(s,c,g.buffer,0,u)).then(d=>g.slice(0,d))}$write(E,s,c,u){const o=this.l(E);if(!o.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(o.write(s,c,u.buffer,0,u.byteLength))}l(E){const s=this.c.get(E);if(!s){const c=new Error;throw c.name="ENOPRO",c.message="no provider",c}return s}}e.$lcc=S}),define(Se[72],De([1,0,6,30,7,22,5,20,54,3,9,24,17]),function(ne,e,y,M,l,R,A,m,k,$,P,C,v){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$5bc=e.$4bc=void 0;let D=S=class{constructor(s,c){this.b=new Map,this.c=new P.$Zg,this.a=s.getProxy(y.$9J.MainThreadFileSystem);const u=this;this.value=Object.freeze({async stat(o){try{let g;const d=u.b.get(o.scheme);return d?(await u.a.$ensureActivation(o.scheme),g=await d.impl.stat(o)):g=await u.a.$stat(o),{type:g.type,ctime:g.ctime,mtime:g.mtime,size:g.size,permissions:g.permissions===M.FilePermission.Readonly?1:void 0}}catch(g){S.e(g)}},async readDirectory(o){try{const g=u.b.get(o.scheme);return g?(await u.a.$ensureActivation(o.scheme),(await g.impl.readDirectory(o)).slice()):await u.a.$readdir(o)}catch(g){return S.e(g)}},async createDirectory(o){try{const g=u.b.get(o.scheme);return g&&!g.isReadonly?(await u.a.$ensureActivation(o.scheme),await u.d(g.impl,g.extUri,o)):await u.a.$mkdir(o)}catch(g){return S.e(g)}},async readFile(o){try{const g=u.b.get(o.scheme);return g?(await u.a.$ensureActivation(o.scheme),(await g.impl.readFile(o)).slice()):(await u.a.$readFile(o)).buffer}catch(g){return S.e(g)}},async writeFile(o,g){try{const d=u.b.get(o.scheme);return d&&!d.isReadonly?(await u.a.$ensureActivation(o.scheme),await u.d(d.impl,d.extUri,d.extUri.dirname(o)),await u.c.queueFor(o).queue(()=>Promise.resolve(d.impl.writeFile(o,g,{create:!0,overwrite:!0})))):await u.a.$writeFile(o,R.$_d.wrap(g))}catch(d){return S.e(d)}},async delete(o,g){try{const d=u.b.get(o.scheme);return d&&!d.isReadonly?(await u.a.$ensureActivation(o.scheme),await d.impl.delete(o,{recursive:!1,...g})):await u.a.$delete(o,{recursive:!1,useTrash:!1,atomic:!1,...g})}catch(d){return S.e(d)}},async rename(o,g,d){try{return await u.a.$rename(o,g,{overwrite:!1,...d})}catch(t){return S.e(t)}},async copy(o,g,d){try{return await u.a.$copy(o,g,{overwrite:!1,...d})}catch(t){return S.e(t)}},isWritableFileSystem(o){const g=c.getCapabilities(o);if(typeof g=="number")return!(g&2048)}})}async d(s,c,u){const o=[];for(;!c.isEqual(u,c.dirname(u));)try{if(!((await s.stat(u)).type&M.FileType.Directory))throw l.$lL.FileExists(`Unable to create folder '${u.scheme===v.Schemas.file?u.fsPath:u.toString(!0)}' that already exists but is not a directory`);break}catch(g){if(M.$jk(g)!==M.FileSystemProviderErrorCode.FileNotFound)throw g;o.push(c.basename(u)),u=c.dirname(u)}for(let g=o.length-1;g>=0;g--){u=c.joinPath(u,o[g]);try{await s.createDirectory(u)}catch(d){if(M.$jk(d)!==M.FileSystemProviderErrorCode.FileExists)throw d}}}static e(s){if(s instanceof l.$lL)throw s;if(s instanceof M.$fk)switch(s.code){case M.FileSystemProviderErrorCode.FileExists:throw l.$lL.FileExists(s.message);case M.FileSystemProviderErrorCode.FileNotFound:throw l.$lL.FileNotFound(s.message);case M.FileSystemProviderErrorCode.FileNotADirectory:throw l.$lL.FileNotADirectory(s.message);case M.FileSystemProviderErrorCode.FileIsADirectory:throw l.$lL.FileIsADirectory(s.message);case M.FileSystemProviderErrorCode.NoPermissions:throw l.$lL.NoPermissions(s.message);case M.FileSystemProviderErrorCode.Unavailable:throw l.$lL.Unavailable(s.message);default:throw new l.$lL(s.message,s.name)}if(!(s instanceof Error))throw new l.$lL(String(s));if(s.name==="ENOPRO"||s.message.includes("ENOPRO"))throw l.$lL.Unavailable(s.message);switch(s.name){case M.FileSystemProviderErrorCode.FileExists:throw l.$lL.FileExists(s.message);case M.FileSystemProviderErrorCode.FileNotFound:throw l.$lL.FileNotFound(s.message);case M.FileSystemProviderErrorCode.FileNotADirectory:throw l.$lL.FileNotADirectory(s.message);case M.FileSystemProviderErrorCode.FileIsADirectory:throw l.$lL.FileIsADirectory(s.message);case M.FileSystemProviderErrorCode.NoPermissions:throw l.$lL.NoPermissions(s.message);case M.FileSystemProviderErrorCode.Unavailable:throw l.$lL.Unavailable(s.message);default:throw new l.$lL(s.message,s.name)}}addFileSystemProvider(s,c,u){return this.b.set(s,{impl:c,extUri:u?.isCaseSensitive?C.$ig:C.$kg,isReadonly:!!u?.isReadonly}),(0,$.$Oc)(()=>this.b.delete(s))}getFileSystemProviderExtUri(s){return this.b.get(s)?.extUri??C.$ig}};e.$4bc=D,e.$4bc=D=S=Ke([We(0,m.$0L),We(1,k.$zbc)],D),e.$5bc=(0,A.$Lh)("IExtHostConsumerFileSystem")}),define(Se[310],De([1,0,4,34,2,6,13,7]),function(ne,e,y,M,l,R,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mcc=void 0;class k{get ignoreCreateEvents(){return!!(this.g&1)}get ignoreChangeEvents(){return!!(this.g&2)}get ignoreDeleteEvents(){return!!(this.g&4)}constructor(C,v,S,D,E,s,c,u){this.a=new y.$Ld,this.b=new y.$Ld,this.c=new y.$Ld;const o=this.h(C,S,E);this.g=0,s&&(this.g+=1),c&&(this.g+=2),u&&(this.g+=4);const g=(0,M.$sj)(E),d=typeof E=="string",t=D(n=>{if(!s)for(const r of n.created){const i=l.URI.revive(r);g(i.fsPath)&&(!d||v.getWorkspaceFolder(i))&&this.a.fire(i)}if(!c)for(const r of n.changed){const i=l.URI.revive(r);g(i.fsPath)&&(!d||v.getWorkspaceFolder(i))&&this.b.fire(i)}if(!u)for(const r of n.deleted){const i=l.URI.revive(r);g(i.fsPath)&&(!d||v.getWorkspaceFolder(i))&&this.c.fire(i)}});this.d=m.$$J.from(o,this.a,this.b,this.c,t)}h(C,v,S){const D=m.$$J.from();if(typeof S=="string")return D;const E=C.getProxy(R.$9J.MainThreadFileSystem);let s=!1;(S.pattern.includes(M.$oj)||S.pattern.includes(M.$pj))&&(s=!0);const c=Math.random();return E.$watch(v.identifier.value,c,S.baseUri,{recursive:s,excludes:[]}),m.$$J.from({dispose:()=>E.$unwatch(c)})}dispose(){this.d.dispose()}get onDidCreate(){return this.a.event}get onDidChange(){return this.b.event}get onDidDelete(){return this.c.event}}class ${constructor(C,v,S){this.j=C,this.k=v,this.l=S,this.a=new y.$Ld,this.b=new y.$Ld,this.c=new y.$Ld,this.d=new y.$Ld,this.g=new y.$Nd,this.h=new y.$Nd,this.i=new y.$Nd,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(C,v,S,D,E,s){return new k(this.j,C,v,this.a.event,A.GlobPattern.from(S),D,E,s)}$onFileEvent(C){this.a.fire(C)}$onDidRunFileOperation(C,v){switch(C){case 2:this.b.fire(Object.freeze({files:v.map(S=>({oldUri:l.URI.revive(S.source),newUri:l.URI.revive(S.target)}))}));break;case 1:this.d.fire(Object.freeze({files:v.map(S=>l.URI.revive(S.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:v.map(S=>l.URI.revive(S.target))}));break;default:}}getOnWillRenameFileEvent(C){return this.m(C,this.g)}getOnWillCreateFileEvent(C){return this.m(C,this.h)}getOnWillDeleteFileEvent(C){return this.m(C,this.i)}m(C,v){return(S,D,E)=>{const s=function(u){S.call(D,u)};return s.extension=C,v.event(s,void 0,E)}}async $onWillRunFileOperation(C,v,S,D){switch(C){case 2:return await this.n(this.g,{files:v.map(E=>({oldUri:l.URI.revive(E.source),newUri:l.URI.revive(E.target)}))},S,D);case 1:return await this.n(this.i,{files:v.map(E=>l.URI.revive(E.target))},S,D);case 0:case 3:return await this.n(this.h,{files:v.map(E=>l.URI.revive(E.target))},S,D)}}async n(C,v,S,D){const E=new Set,s=[];if(await C.fireAsync(v,D,async(u,o)=>{const g=Date.now(),d=await Promise.resolve(u);d instanceof m.$iK&&(s.push([o.extension,d]),E.add(o.extension.displayName??o.extension.identifier.value)),Date.now()-g>S&&this.k.warn("SLOW file-participant",o.extension.identifier)}),D.isCancellationRequested||s.length===0)return;const c={edits:[]};for(const[,u]of s){const{edits:o}=A.WorkspaceEdit.from(u,{getTextDocumentVersion:g=>this.l.getDocument(g)?.version,getNotebookDocumentVersion:()=>{}});c.edits=c.edits.concat(o)}return{edit:c,extensionNames:Array.from(E)}}}e.$mcc=$}),define(Se[311],De([1,0,3,2,6,13,7,33]),function(ne,e,y,M,l,R,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tdc=void 0;class k{constructor(v,S){this.extension=v,this.provider=S,this.handle=k.a++}}k.a=0;class ${constructor(v){this.session=v,this.responses=[]}}class P{constructor(v,S,D,E){this.f=D,this.g=E,this.b=new Map,this.d=new Map,this.e=v.getProxy(l.$9J.MainThreadInlineChat),S.registerApiCommand(new m.$xM("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new m.$vM("Run arguments","",s=>!0,s=>{if(s)return{initialRange:s.initialRange?R.Range.from(s.initialRange):void 0,initialSelection:s.initialSelection?R.Selection.from(s.initialSelection):void 0,message:s.message,autoSend:s.autoSend,position:s.position?R.Position.from(s.position):void 0}})],m.$wM.Void))}registerProvider(v,S,D){const E=new k(v,S);return this.b.set(E.handle,E),this.e.$registerInteractiveEditorProvider(E.handle,D.label,v.identifier.value,typeof S.handleInteractiveEditorResponseFeedback=="function"),(0,y.$Oc)(()=>{this.e.$unregisterInteractiveEditorProvider(E.handle),this.b.delete(E.handle)})}async $prepareSession(v,S,D,E){const s=this.b.get(v);if(!s){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const c=this.f.getDocument(M.URI.revive(S)),u=R.Selection.to(D),o=await s.provider.prepareInteractiveEditorSession({document:c,selection:u},E);if(!o)return;if(o.wholeRange&&!o.wholeRange.contains(u))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const g=P.a++;return this.d.set(g,new $(o)),{id:g,placeholder:o.placeholder,slashCommands:o.slashCommands?.map(d=>({command:d.command,detail:d.detail,refer:d.refer,executeImmediately:d.executeImmediately})),wholeRange:R.Range.from(o.wholeRange),message:o.message}}async $provideResponse(v,S,D,E){const s=this.b.get(v);if(!s)return;const c=this.d.get(S.id);if(!c)return;const u={prompt:D.prompt,selection:R.Selection.to(D.selection),wholeRange:R.Range.to(D.wholeRange),attempt:D.attempt,live:D.live};let o=!1;const g={report:n=>{if(!D.live)throw new Error("Progress reporting is only supported for live sessions");o||E.isCancellationRequested||!n.message&&!n.edits||this.e.$handleProgressChunk(D.requestId,{message:n.message,edits:n.edits?.map(R.TextEdit.from)})}},d=s.provider.provideInteractiveEditorResponse(c.session,u,g,E);Promise.resolve(d).finally(()=>o=!0);const t=await d;if(t){const n=c.responses.push(t)-1,r={wholeRange:R.Range.from(t.wholeRange),placeholder:t.placeholder};if(P.h(t))return{...r,id:n,type:"message",message:R.MarkdownString.from(t.contents)};const{edits:i}=t;if(i instanceof A.$iK)return{...r,id:n,type:"bulkEdit",edits:R.WorkspaceEdit.from(i)};if(Array.isArray(i))return{...r,id:n,type:"editorEdit",edits:i.map(R.TextEdit.from)}}}$handleFeedback(v,S,D,E){const s=this.b.get(v),c=this.d.get(S),u=c?.responses[D];if(s&&u){const o=R.InteractiveEditorResponseFeedbackKind.to(E);s.provider.handleInteractiveEditorResponseFeedback?.(c.session,u,o)}}$releaseSession(v,S){}static h(v){return typeof v=="object"&&typeof v.contents=="object"}}e.$tdc=P,P.a=0}),define(Se[312],De([1,0,2,33]),function(ne,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pdc=void 0;class l{constructor(A,m,k,$,P){this.a=m,this.b=k,this.c=$;const C=new M.$xM("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new M.$vM("showOptions","Show Options",v=>!0,v=>v),new M.$vM("resource","Interactive resource Uri",v=>!0,v=>v),new M.$vM("controllerId","Notebook controller Id",v=>!0,v=>v),new M.$vM("title","Interactive editor title",v=>!0,v=>v)],new M.$wM("Notebook and input URI",v=>{if(P.debug("[ExtHostInteractive] open iw with notebook editor id",v.notebookEditorId),v.notebookEditorId!==void 0){const S=this.a.getEditorById(v.notebookEditorId);return P.debug("[ExtHostInteractive] notebook editor found",S.id),{notebookUri:y.URI.revive(v.notebookUri),inputUri:y.URI.revive(v.inputUri),notebookEditor:S.apiEditor}}return P.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",v.notebookUri,v.inputUri),{notebookUri:y.URI.revive(v.notebookUri),inputUri:y.URI.revive(v.inputUri)}}));this.c.registerApiCommand(C)}$willAddInteractiveDocument(A,m,k,$){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:m,lines:[""],languageId:k,uri:A,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(y.URI.revive($))?.apiNotebook}]})}$willRemoveInteractiveDocument(A,m){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[A]})}}e.$pdc=l}),define(Se[313],De([1,0,6,7]),function(ne,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vdc=void 0;class l{constructor(A){this.a=new Map,this.b=A.getProxy(y.$9J.MainThreadIssueReporter)}async $getIssueReporterUri(A,m){if(this.a.size===0)throw new Error("No issue request handlers registered");const k=this.a.get(A);if(!k)throw new Error("Issue request handler not found");const $=await k.handleIssueUrlRequest();if(!$)throw new Error("Issue request handler returned no result");return $}registerIssueUriRequestHandler(A,m){const k=A.identifier.value;return this.a.set(k,m),this.b.$registerIssueUriRequestHandler(k),new M.$$J(()=>{this.b.$unregisterIssueUriRequestHandler(k),this.a.delete(k)})}}e.$vdc=l}),define(Se[314],De([1,0,3,6]),function(ne,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Icc=void 0;class l{constructor(A){this.b=0,this.a=A.getProxy(M.$9J.MainThreadLabelService)}$registerResourceLabelFormatter(A){const m=this.b++;return this.a.$registerResourceLabelFormatter(m,A),(0,y.$Oc)(()=>{this.a.$unregisterResourceLabelFormatter(m)})}}e.$Icc=l}),define(Se[315],De([1,0,2,23,13,7,83,6,16,35,19,18,170,21,25,3,130,120,87,38,8,9,27,205]),function(ne,e,y,M,l,R,A,m,k,$,P,C,v,S,D,E,s,c,u,o,g,d,t,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fbc=void 0;class r{constructor(W,G){this.d=W,this.e=G}async provideDocumentSymbols(W,G){const ce=this.d.getDocument(W),he=await this.e.provideDocumentSymbols(ce,G);if(!(0,P.$Ib)(he))return he[0]instanceof R.$qK?he.map(l.DocumentSymbol.from):r.f(he)}static f(W){W=W.slice(0).sort((he,x)=>{let $e=he.location.range.start.compareTo(x.location.range.start);return $e===0&&($e=x.location.range.end.compareTo(he.location.range.end)),$e});const G=[],ce=[];for(const he of W){const x={name:he.name||"!!MISSING: name!!",kind:l.SymbolKind.from(he.kind),tags:he.tags?.map(l.SymbolTag.from)||[],detail:"",containerName:he.containerName,range:l.Range.from(he.location.range),selectionRange:l.Range.from(he.location.range),children:[]};for(;;){if(ce.length===0){ce.push(x),G.push(x);break}const $e=ce[ce.length-1];if($.$ms.containsRange($e.range,x.range)&&!$.$ms.equalsRange($e.range,x.range)){$e.children?.push(x),ce.push(x);break}ce.pop()}}return G}}class i{constructor(W,G,ce){this.g=W,this.h=G,this.j=ce,this.e=new u.$wbc("CodeLens"),this.f=new Map}async provideCodeLenses(W,G){const ce=this.g.getDocument(W),he=await this.j.provideCodeLenses(ce,G);if(!he||G.isCancellationRequested)return;const x=this.e.add(he),$e=new E.$Pc;this.f.set(x,$e);const ve={cacheId:x,lenses:[]};for(let Ne=0;Ne<he.length;Ne++)ve.lenses.push({cacheId:[x,Ne],range:l.Range.from(he[Ne].range),command:this.h.toInternal(he[Ne].command,$e)});return ve}async resolveCodeLens(W,G){const ce=W.cacheId&&this.e.get(...W.cacheId);if(!ce)return;let he;if(typeof this.j.resolveCodeLens!="function"||ce.isResolved?he=ce:he=await this.j.resolveCodeLens(ce,G),he||(he=ce),G.isCancellationRequested)return;const x=W.cacheId&&this.f.get(W.cacheId[0]);if(x)return W.command=this.h.toInternal(he.command??i.d,x),W}releaseCodeLenses(W){this.f.get(W)?.dispose(),this.f.delete(W),this.e.delete(W)}}i.d={command:"missing",title:"!!MISSING: command!!"};function a(Ie){return Array.isArray(Ie)?Ie.map(l.DefinitionLink.from):Ie?[l.DefinitionLink.from(Ie)]:[]}class h{constructor(W,G){this.d=W,this.e=G}async provideDefinition(W,G,ce){const he=this.d.getDocument(W),x=l.Position.to(G),$e=await this.e.provideDefinition(he,x,ce);return a($e)}}class p{constructor(W,G){this.d=W,this.e=G}async provideDeclaration(W,G,ce){const he=this.d.getDocument(W),x=l.Position.to(G),$e=await this.e.provideDeclaration(he,x,ce);return a($e)}}class I{constructor(W,G){this.d=W,this.e=G}async provideImplementation(W,G,ce){const he=this.d.getDocument(W),x=l.Position.to(G),$e=await this.e.provideImplementation(he,x,ce);return a($e)}}class w{constructor(W,G){this.d=W,this.e=G}async provideTypeDefinition(W,G,ce){const he=this.d.getDocument(W),x=l.Position.to(G),$e=await this.e.provideTypeDefinition(he,x,ce);return a($e)}}class f{constructor(W,G){this.d=W,this.e=G}async provideHover(W,G,ce){const he=this.d.getDocument(W),x=l.Position.to(G),$e=await this.e.provideHover(he,x,ce);if(!(!$e||(0,P.$Ib)($e.contents)))return $e.range||($e.range=he.getWordRangeAtPosition(x)),$e.range||($e.range=new R.$aK(x,x)),l.Hover.from($e)}}class b{constructor(W,G){this.d=W,this.e=G}async provideEvaluatableExpression(W,G,ce){const he=this.d.getDocument(W),x=l.Position.to(G),$e=await this.e.provideEvaluatableExpression(he,x,ce);if($e)return l.EvaluatableExpression.from($e)}}class L{constructor(W,G){this.d=W,this.e=G}async provideInlineValues(W,G,ce,he){const x=this.d.getDocument(W),$e=await this.e.provideInlineValues(x,l.Range.to(G),l.InlineValueContext.to(ce),he);if(Array.isArray($e))return $e.map(ve=>l.InlineValue.from(ve))}}class O{constructor(W,G){this.d=W,this.e=G}async provideDocumentHighlights(W,G,ce){const he=this.d.getDocument(W),x=l.Position.to(G),$e=await this.e.provideDocumentHighlights(he,x,ce);if(Array.isArray($e))return $e.map(l.DocumentHighlight.from)}}class T{constructor(W,G){this.d=W,this.e=G}async provideLinkedEditingRanges(W,G,ce){const he=this.d.getDocument(W),x=l.Position.to(G),$e=await this.e.provideLinkedEditingRanges(he,x,ce);if($e&&Array.isArray($e.ranges))return{ranges:(0,P.$Fb)($e.ranges.map(l.Range.from)),wordPattern:$e.wordPattern}}}class F{constructor(W,G){this.d=W,this.e=G}async provideReferences(W,G,ce,he){const x=this.d.getDocument(W),$e=l.Position.to(G),ve=await this.e.provideReferences(x,$e,ce,he);if(Array.isArray(ve))return ve.map(l.location.from)}}class U{constructor(W,G,ce,he,x,$e,ve){this.g=W,this.h=G,this.j=ce,this.k=he,this.l=x,this.m=$e,this.n=ve,this.e=new u.$wbc("CodeAction"),this.f=new Map}async provideCodeActions(W,G,ce,he){const x=this.g.getDocument(W),$e=v.$os.isISelection(G)?l.Selection.to(G):l.Range.to(G),ve=[];for(const it of this.j.getDiagnostics(W))if($e.intersection(it.range)&&ve.push(it)>U.d)break;const Ne={diagnostics:ve,only:ce.only?new R.$sK(ce.only):void 0,triggerKind:l.CodeActionTriggerKind.to(ce.trigger)},Ve=await this.k.provideCodeActions(x,$e,Ne,he);if(!(0,P.$Jb)(Ve)||he.isCancellationRequested)return;const xe=this.e.add(Ve),Qe=new E.$Pc;this.f.set(xe,Qe);const rt=[];for(let it=0;it<Ve.length;it++){const nt=Ve[it];nt&&(U.o(nt)?(this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),rt.push({_isSynthetic:!0,title:nt.title,command:this.h.toInternal(nt,Qe)})):(Ne.only&&(nt.kind?Ne.only.contains(nt.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Ne.only.value} 'requested but returned code action is of kind '${nt.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Ne.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),rt.push({cacheId:[xe,it],title:nt.title,command:nt.command&&this.h.toInternal(nt.command,Qe),diagnostics:nt.diagnostics&&nt.diagnostics.map(l.Diagnostic.from),edit:nt.edit&&l.WorkspaceEdit.from(nt.edit,void 0),kind:nt.kind&&nt.kind.value,isPreferred:nt.isPreferred,disabled:nt.disabled?.reason})))}return{cacheId:xe,actions:rt}}async resolveCodeAction(W,G){const[ce,he]=W,x=this.e.get(ce,he);if(!x||U.o(x))return{};if(!this.k.resolveCodeAction)return{};const $e=await this.k.resolveCodeAction(x,G)??x;let ve;$e.edit&&(ve=l.WorkspaceEdit.from($e.edit,void 0));let Ne;if($e.command){const Ve=this.f.get(ce);Ve&&(Ne=this.h.toInternal($e.command,Ve))}return{edit:ve,command:Ne}}releaseCodeActions(W){this.f.get(W)?.dispose(),this.f.delete(W),this.e.delete(W)}static o(W){return typeof W.command=="string"&&typeof W.title=="string"}}U.d=1e3;class N{static toInternalProviderId(W,G){return W+"."+G}constructor(W,G,ce,he,x){this.d=W,this.e=G,this.f=ce,this.g=he,this.h=x}async prepareDocumentPaste(W,G,ce,he){if(!this.f.prepareDocumentPaste)return;const x=this.e.getDocument(W),$e=G.map(Ve=>l.Range.to(Ve)),ve=l.DataTransfer.toDataTransfer(ce,()=>{throw new g.$9});if(await this.f.prepareDocumentPaste(x,$e,ve,he),he.isCancellationRequested)return;const Ne=Array.from(ve).filter(([,Ve])=>!(Ve instanceof R.$YK));return l.DataTransfer.from(Ne)}async providePasteEdits(W,G,ce,he,x){if(!this.f.provideDocumentPasteEdits)return;const $e=this.e.getDocument(G),ve=ce.map(xe=>l.Range.to(xe)),Ne=l.DataTransfer.toDataTransfer(he,async xe=>(await this.d.$resolvePasteFileData(this.g,W,xe)).buffer),Ve=await this.f.provideDocumentPasteEdits($e,ve,Ne,x);if(Ve)return{label:Ve.label??(0,n.localize)(0,null,this.h.displayName||this.h.name),detail:this.h.displayName||this.h.name,yieldTo:Ve.yieldTo?.map(xe=>"mimeType"in xe?xe:{providerId:N.toInternalProviderId(xe.extensionId,xe.providerId)}),insertText:typeof Ve.insertText=="string"?Ve.insertText:{snippet:Ve.insertText.value},additionalEdit:Ve.additionalEdit?l.WorkspaceEdit.from(Ve.additionalEdit,void 0):void 0}}}class j{constructor(W,G){this.d=W,this.e=G}async provideDocumentFormattingEdits(W,G,ce){const he=this.d.getDocument(W),x=await this.e.provideDocumentFormattingEdits(he,G,ce);if(Array.isArray(x))return x.map(l.TextEdit.from)}}class z{constructor(W,G){this.d=W,this.e=G}async provideDocumentRangeFormattingEdits(W,G,ce,he){const x=this.d.getDocument(W),$e=l.Range.to(G),ve=await this.e.provideDocumentRangeFormattingEdits(x,$e,ce,he);if(Array.isArray(ve))return ve.map(l.TextEdit.from)}async provideDocumentRangesFormattingEdits(W,G,ce,he){(0,C.$Gf)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const x=this.d.getDocument(W),$e=G.map(l.Range.to),ve=await this.e.provideDocumentRangesFormattingEdits(x,$e,ce,he);if(Array.isArray(ve))return ve.map(l.TextEdit.from)}}class B{constructor(W,G){this.d=W,this.e=G,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(W,G,ce,he,x){const $e=this.d.getDocument(W),ve=l.Position.to(G),Ne=await this.e.provideOnTypeFormattingEdits($e,ve,ce,he,x);if(Array.isArray(Ne))return Ne.map(l.TextEdit.from)}}class ae{constructor(W,G){this.e=W,this.f=G,this.d=new u.$wbc("WorkspaceSymbols")}async provideWorkspaceSymbols(W,G){const ce=await this.e.provideWorkspaceSymbols(W,G);if(!(0,P.$Jb)(ce))return{symbols:[]};const he=this.d.add(ce),x={cacheId:he,symbols:[]};for(let $e=0;$e<ce.length;$e++){const ve=ce[$e];if(!ve||!ve.name){this.f.warn("INVALID SymbolInformation",ve);continue}x.symbols.push({...l.WorkspaceSymbol.from(ve),cacheId:[he,$e]})}return x}async resolveWorkspaceSymbol(W,G){if(typeof this.e.resolveWorkspaceSymbol!="function"||!W.cacheId)return W;const ce=this.d.get(...W.cacheId);if(ce){const he=await this.e.resolveWorkspaceSymbol(ce,G);return he&&(0,M.$1m)(W,l.WorkspaceSymbol.from(he),!0)}}releaseWorkspaceSymbols(W){this.d.delete(W)}}class X{static supportsResolving(W){return typeof W.prepareRename=="function"}constructor(W,G,ce){this.d=W,this.e=G,this.f=ce}async provideRenameEdits(W,G,ce,he){const x=this.d.getDocument(W),$e=l.Position.to(G);try{const ve=await this.e.provideRenameEdits(x,$e,ce,he);return ve?l.WorkspaceEdit.from(ve):void 0}catch(ve){const Ne=X.g(ve);return Ne?{rejectReason:Ne,edits:void 0}:Promise.reject(ve)}}async resolveRenameLocation(W,G,ce){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const he=this.d.getDocument(W),x=l.Position.to(G);try{const $e=await this.e.prepareRename(he,x,ce);let ve,Ne;if(R.$aK.isRange($e)?(ve=$e,Ne=he.getText($e)):(0,C.$yf)($e)&&(ve=$e.range,Ne=$e.placeholder),!ve||!Ne)return;if(ve.start.line>x.line||ve.end.line<x.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:l.Range.from(ve),text:Ne}}catch($e){const ve=X.g($e);return ve?{rejectReason:ve,range:void 0,text:void 0}:Promise.reject($e)}}static g(W){return typeof W=="string"?W:W instanceof Error&&typeof W.message=="string"?W.message:void 0}}class Q{constructor(W,G){this.resultId=W,this.tokens=G}}class H{constructor(W,G){this.f=W,this.g=G,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(W,G,ce){const he=this.f.getDocument(W),x=G!==0?this.d.get(G):null;let $e=typeof x?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(he,x.resultId,ce):await this.g.provideDocumentSemanticTokens(he,ce);return x&&this.d.delete(G),$e?($e=H.h($e),this.o(H.n(x,$e),$e)):null}async releaseDocumentSemanticColoring(W){this.d.delete(W)}static h(W){return H.j(W)?H.k(W)?W:new R.$pL(new Uint32Array(W.data),W.resultId):H.l(W)?H.m(W)?W:new R.$rL(W.edits.map(G=>new R.$qL(G.start,G.deleteCount,G.data?new Uint32Array(G.data):G.data)),W.resultId):W}static j(W){return W&&!!W.data}static k(W){return W.data instanceof Uint32Array}static l(W){return W&&Array.isArray(W.edits)}static m(W){for(const G of W.edits)if(!(G.data instanceof Uint32Array))return!1;return!0}static n(W,G){if(!H.j(G)||!W||!W.tokens)return G;const ce=W.tokens,he=ce.length,x=G.data,$e=x.length;let ve=0;const Ne=Math.min(he,$e);for(;ve<Ne&&ce[ve]===x[ve];)ve++;if(ve===he&&ve===$e)return new R.$rL([],G.resultId);let Ve=0;const xe=Ne-ve;for(;Ve<xe&&ce[he-Ve-1]===x[$e-Ve-1];)Ve++;return new R.$rL([{start:ve,deleteCount:he-ve-Ve,data:x.subarray(ve,$e-Ve)}],G.resultId)}o(W,G){if(H.j(W)){const ce=this.e++;return this.d.set(ce,new Q(W.resultId,W.data)),(0,s.$I0)({id:ce,type:"full",data:W.data})}if(H.l(W)){const ce=this.e++;return H.j(G)?this.d.set(ce,new Q(G.resultId,G.data)):this.d.set(ce,new Q(W.resultId)),(0,s.$I0)({id:ce,type:"delta",deltas:(W.edits||[]).map(he=>({start:he.start,deleteCount:he.deleteCount,data:he.data}))})}return null}}class te{constructor(W,G){this.d=W,this.e=G}async provideDocumentRangeSemanticTokens(W,G,ce){const he=this.d.getDocument(W),x=await this.e.provideDocumentRangeSemanticTokens(he,l.Range.to(G),ce);return x?this.f(x):null}f(W){return(0,s.$I0)({id:0,type:"full",data:W.data})}}class me{static supportsResolving(W){return typeof W.resolveCompletionItem=="function"}constructor(W,G,ce,he,x){this.f=W,this.g=G,this.h=ce,this.j=he,this.k=x,this.d=new u.$wbc("CompletionItem"),this.e=new Map}async provideCompletionItems(W,G,ce,he){const x=this.f.getDocument(W),$e=l.Position.to(G),ve=x.getWordRangeAtPosition($e)||new R.$aK($e,$e),Ne=ve.with({end:$e}),Ve=new o.$Hd,xe=await this.h.provideCompletionItems(x,$e,he,l.CompletionContext.to(ce));if(!xe||he.isCancellationRequested)return;const Qe=Array.isArray(xe)?new R.$FK(xe):xe,rt=me.supportsResolving(this.h)?this.d.add(Qe.items):this.d.add([]),it=new E.$Pc;this.e.set(rt,it);const nt=[],Ae={x:rt,b:nt,a:{replace:l.Range.from(ve),insert:l.Range.from(Ne)},c:Qe.isIncomplete||void 0,d:Ve.elapsed()};for(let Fe=0;Fe<Qe.items.length;Fe++){const Le=Qe.items[Fe],Je=this.l(Le,[rt,Fe],Ne,ve);nt.push(Je)}return Ae}async resolveCompletionItem(W,G){if(typeof this.h.resolveCompletionItem!="function")return;const ce=this.d.get(...W);if(!ce)return;const he=this.l(ce,W),x=await this.h.resolveCompletionItem(ce,G);if(!x)return;const $e=this.l(x,W);return(he.h!==$e.h||he.i!==$e.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(he.n!==$e.n||he.o!==$e.o||!(0,M.$2m)(he.p,$e.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...he,d:$e.d,c:$e.c,l:$e.l,h:$e.h,i:$e.i,n:$e.n,o:$e.o,p:$e.p}}releaseCompletionItems(W){this.e.get(W)?.dispose(),this.e.delete(W),this.d.delete(W)}l(W,G,ce,he){const x=this.e.get(G[0]);if(!x)throw Error("DisposableStore is missing...");const $e=this.g.toInternal(W.command,x),ve={x:G,a:W.label,b:W.kind!==void 0?l.CompletionItemKind.from(W.kind):void 0,m:W.tags&&W.tags.map(l.CompletionItemTag.from),c:W.detail,d:typeof W.documentation>"u"?void 0:l.MarkdownString.fromStrict(W.documentation),e:W.sortText!==W.label?W.sortText:void 0,f:W.filterText!==W.label?W.filterText:void 0,g:W.preselect||void 0,i:W.keepWhitespace?1:0,k:W.commitCharacters?.join(""),l:W.additionalTextEdits&&W.additionalTextEdits.map(l.TextEdit.from),n:$e?.$ident,o:$e?.id,p:$e?.$ident?void 0:$e?.arguments};W.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ve.h=W.textEdit.newText):typeof W.insertText=="string"?ve.h=W.insertText:W.insertText instanceof R.$jK&&(ve.h=W.insertText.value,ve.i|=4);let Ne;return W.textEdit?Ne=W.textEdit.range:W.range&&(Ne=W.range),R.$aK.isRange(Ne)?ve.j=l.Range.from(Ne):Ne&&(!ce?.isEqual(Ne.inserting)||!he?.isEqual(Ne.replacing))&&(ve.j={insert:l.Range.from(Ne.inserting),replace:l.Range.from(Ne.replacing)}),ve}}class le{async provideInlineCompletions(W,G,ce,he){}disposeCompletions(W){}handleDidShowCompletionItem(W,G,ce){}handlePartialAccept(W,G,ce){}}class ye extends le{constructor(W,G,ce,he){super(),this.f=W,this.g=G,this.h=ce,this.j=he,this.d=new de,this.e=(0,t.$7E)(this.f,"inlineCompletionsAdditions"),this.k={[A.InlineCompletionTriggerKind.Automatic]:R.InlineCompletionTriggerKind.Automatic,[A.InlineCompletionTriggerKind.Explicit]:R.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,t.$7E)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(W,G,ce,he){const x=this.g.getDocument(W),$e=l.Position.to(G),ve=await this.h.provideInlineCompletionItems(x,$e,{selectedCompletionInfo:ce.selectedSuggestionInfo?{range:l.Range.to(ce.selectedSuggestionInfo.range),text:ce.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[ce.triggerKind]},he);if(!ve||he.isCancellationRequested)return;const Ne=Array.isArray(ve)?ve:ve.items,Ve=this.e?Array.isArray(ve)?[]:ve.commands||[]:[],xe=this.e&&!Array.isArray(ve)?ve.enableForwardStability:void 0;let Qe;return{pid:this.d.createReferenceId({dispose(){Qe?.dispose()},items:Ne}),items:Ne.map((it,nt)=>{let Ae;it.command&&(Qe||(Qe=new E.$Pc),Ae=this.j.toInternal(it.command,Qe));const Fe=it.insertText;return{insertText:typeof Fe=="string"?Fe:{snippet:Fe.value},filterText:it.filterText,range:it.range?l.Range.from(it.range):void 0,command:Ae,idx:nt,completeBracketPairs:this.e?it.completeBracketPairs:!1}}),commands:Ve.map(it=>(Qe||(Qe=new E.$Pc),this.j.toInternal(it,Qe))),suppressSuggestions:!1,enableForwardStability:xe}}disposeCompletions(W){this.d.disposeReferenceId(W)?.dispose()}handleDidShowCompletionItem(W,G,ce){const he=this.d.get(W)?.items[G];he&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(he,ce)}handlePartialAccept(W,G,ce){const he=this.d.get(W)?.items[G];he&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(he,ce)}}class de{constructor(){this.d=new Map,this.e=1}createReferenceId(W){const G=this.e++;return this.d.set(G,W),G}disposeReferenceId(W){const G=this.d.get(W);return this.d.delete(W),G}get(W){return this.d.get(W)}}class V{constructor(W,G){this.e=W,this.f=G,this.d=new u.$wbc("SignatureHelp")}async provideSignatureHelp(W,G,ce,he){const x=this.e.getDocument(W),$e=l.Position.to(G),ve=this.g(ce),Ne=await this.f.provideSignatureHelp(x,$e,he,ve);if(Ne){const Ve=this.d.add([Ne]);return{...l.SignatureHelp.from(Ne),id:Ve}}}g(W){let G;if(W.activeSignatureHelp){const ce=l.SignatureHelp.to(W.activeSignatureHelp),he=this.d.get(W.activeSignatureHelp.id,0);he?(G=he,G.activeSignature=ce.activeSignature,G.activeParameter=ce.activeParameter):G=ce}return{...W,activeSignatureHelp:G}}releaseSignatureHelp(W){this.d.delete(W)}}class J{constructor(W,G,ce,he,x){this.f=W,this.g=G,this.h=ce,this.j=he,this.k=x,this.d=new u.$wbc("InlayHints"),this.e=new Map}async provideInlayHints(W,G,ce){const he=this.f.getDocument(W),x=l.Range.to(G),$e=await this.h.provideInlayHints(he,x,ce);if(!Array.isArray($e)||$e.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for ${G}`);return}if(ce.isCancellationRequested)return;const ve=this.d.add($e);this.e.set(ve,new E.$Pc);const Ne={hints:[],cacheId:ve};for(let Ve=0;Ve<$e.length;Ve++)this.l($e[Ve],x)&&Ne.hints.push(this.m($e[Ve],[ve,Ve]));return this.j.trace(`[InlayHints] ${Ne.hints.length} inlay hints from '${this.k.identifier.value}' for ${G}`),Ne}async resolveInlayHint(W,G){if(typeof this.h.resolveInlayHint!="function")return;const ce=this.d.get(...W);if(!ce)return;const he=await this.h.resolveInlayHint(ce,G);if(he&&this.l(he))return this.m(he,W)}releaseHints(W){this.e.get(W)?.dispose(),this.e.delete(W),this.d.delete(W)}l(W,G){return W.label.length===0||Array.isArray(W.label)&&W.label.every(ce=>ce.value.length===0)?(console.log("INVALID inlay hint, empty label",W),!1):!(G&&!G.contains(W.position))}m(W,G){const ce=this.e.get(G[0]);if(!ce)throw Error("DisposableStore is missing...");const he={label:"",cacheId:G,tooltip:l.MarkdownString.fromStrict(W.tooltip),position:l.Position.from(W.position),textEdits:W.textEdits&&W.textEdits.map(l.TextEdit.from),kind:W.kind&&l.InlayHintKind.from(W.kind),paddingLeft:W.paddingLeft,paddingRight:W.paddingRight};return typeof W.label=="string"?he.label=W.label:he.label=W.label.map(x=>{const $e={label:x.value};return $e.tooltip=l.MarkdownString.fromStrict(x.tooltip),R.$kK.isLocation(x.location)&&($e.location=l.location.from(x.location)),x.command&&($e.command=this.g.toInternal(x.command,ce)),$e}),he}}class ee{constructor(W,G){this.e=W,this.f=G,this.d=new u.$wbc("DocumentLink")}async provideLinks(W,G){const ce=this.e.getDocument(W),he=await this.f.provideDocumentLinks(ce,G);if(!(!Array.isArray(he)||he.length===0)&&!G.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:he.filter(ee.g).map(l.DocumentLink.from)};{const x=this.d.add(he),$e={links:[],cacheId:x};for(let ve=0;ve<he.length;ve++){if(!ee.g(he[ve]))continue;const Ne=l.DocumentLink.from(he[ve]);Ne.cacheId=[x,ve],$e.links.push(Ne)}return $e}}}static g(W){return W.target&&W.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(W,G){if(typeof this.f.resolveDocumentLink!="function")return;const ce=this.d.get(...W);if(!ce)return;const he=await this.f.resolveDocumentLink(ce,G);if(!(!he||!ee.g(he)))return l.DocumentLink.from(he)}releaseLinks(W){this.d.delete(W)}}class Y{constructor(W,G){this.d=W,this.e=G}async provideColors(W,G){const ce=this.d.getDocument(W),he=await this.e.provideDocumentColors(ce,G);return Array.isArray(he)?he.map($e=>({color:l.Color.from($e.color),range:l.Range.from($e.range)})):[]}async provideColorPresentations(W,G,ce){const he=this.d.getDocument(W),x=l.Range.to(G.range),$e=l.Color.to(G.color),ve=await this.e.provideColorPresentations($e,{document:he,range:x},ce);if(Array.isArray(ve))return ve.map(l.ColorPresentation.from)}}class Z{constructor(W,G){this.d=W,this.e=G}async provideFoldingRanges(W,G,ce){const he=this.d.getDocument(W),x=await this.e.provideFoldingRanges(he,G,ce);if(Array.isArray(x))return x.map(l.FoldingRange.from)}}class _{constructor(W,G,ce){this.d=W,this.e=G,this.f=ce}async provideSelectionRanges(W,G,ce){const he=this.d.getDocument(W),x=G.map(l.Position.to),$e=await this.e.provideSelectionRanges(he,x,ce);if(!(0,P.$Jb)($e))return[];if($e.length!==x.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const ve=[];for(let Ne=0;Ne<x.length;Ne++){const Ve=[];ve.push(Ve);let xe=x[Ne],Qe=$e[Ne];for(;;){if(!Qe.range.contains(xe))throw new Error("INVALID selection range, must contain the previous range");if(Ve.push(l.SelectionRange.from(Qe)),!Qe.parent)break;xe=Qe.range,Qe=Qe.parent}}return ve}}class pe{constructor(W,G){this.f=W,this.g=G,this.d=new c.$cM(""),this.e=new Map}async prepareSession(W,G,ce){const he=this.f.getDocument(W),x=l.Position.to(G),$e=await this.g.prepareCallHierarchy(he,x,ce);if(!$e)return;const ve=this.d.nextId();return this.e.set(ve,new Map),Array.isArray($e)?$e.map(Ne=>this.h(ve,Ne)):[this.h(ve,$e)]}async provideCallsTo(W,G,ce){const he=this.j(W,G);if(!he)throw new Error("missing call hierarchy item");const x=await this.g.provideCallHierarchyIncomingCalls(he,ce);if(x)return x.map($e=>({from:this.h(W,$e.from),fromRanges:$e.fromRanges.map(ve=>l.Range.from(ve))}))}async provideCallsFrom(W,G,ce){const he=this.j(W,G);if(!he)throw new Error("missing call hierarchy item");const x=await this.g.provideCallHierarchyOutgoingCalls(he,ce);if(x)return x.map($e=>({to:this.h(W,$e.to),fromRanges:$e.fromRanges.map(ve=>l.Range.from(ve))}))}releaseSession(W){this.e.delete(W)}h(W,G){const ce=this.e.get(W),he=l.CallHierarchyItem.from(G,W,ce.size.toString(36));return ce.set(he._itemId,G),he}j(W,G){return this.e.get(W)?.get(G)}}class se{constructor(W,G){this.f=W,this.g=G,this.d=new c.$cM(""),this.e=new Map}async prepareSession(W,G,ce){const he=this.f.getDocument(W),x=l.Position.to(G),$e=await this.g.prepareTypeHierarchy(he,x,ce);if(!$e)return;const ve=this.d.nextId();return this.e.set(ve,new Map),Array.isArray($e)?$e.map(Ne=>this.h(ve,Ne)):[this.h(ve,$e)]}async provideSupertypes(W,G,ce){const he=this.j(W,G);if(!he)throw new Error("missing type hierarchy item");const x=await this.g.provideTypeHierarchySupertypes(he,ce);if(x)return x.map($e=>this.h(W,$e))}async provideSubtypes(W,G,ce){const he=this.j(W,G);if(!he)throw new Error("missing type hierarchy item");const x=await this.g.provideTypeHierarchySubtypes(he,ce);if(x)return x.map($e=>this.h(W,$e))}releaseSession(W){this.e.delete(W)}h(W,G){const ce=this.e.get(W),he=l.TypeHierarchyItem.from(G,W,ce.size.toString(36));return ce.set(he._itemId,G),he}j(W,G){return this.e.get(W)?.get(G)}}class ge{static toInternalProviderId(W,G){return W+"."+G}constructor(W,G,ce,he,x){this.d=W,this.e=G,this.f=ce,this.g=he,this.h=x}async provideDocumentOnDropEdits(W,G,ce,he,x){const $e=this.e.getDocument(G),ve=l.Position.to(ce),Ne=l.DataTransfer.toDataTransfer(he,async xe=>(await this.d.$resolveDocumentOnDropFileData(this.g,W,xe)).buffer),Ve=await this.f.provideDocumentDropEdits($e,ve,Ne,x);if(Ve)return{label:Ve.label??(0,n.localize)(1,null,this.h.displayName||this.h.name),yieldTo:Ve.yieldTo?.map(xe=>"mimeType"in xe?xe:{providerId:ge.toInternalProviderId(xe.extensionId,xe.providerId)}),insertText:typeof Ve.insertText=="string"?Ve.insertText:{snippet:Ve.insertText.value},additionalEdit:Ve.additionalEdit?l.WorkspaceEdit.from(Ve.additionalEdit,void 0):void 0}}}class ie{constructor(W,G){this.d=W,this.e=G}async provideMappedEdits(W,G,ce,he){const x=y.URI.revive(W),$e=this.d.getDocument(x),ve=ce.documents.map(xe=>xe.map(Qe=>({uri:y.URI.revive(Qe.uri),version:Qe.version,ranges:Qe.ranges.map(rt=>l.Range.to(rt))}))),Ne={documents:ve,selections:ve[0]?.[0]?.ranges??[]},Ve=await this.e.provideMappedEdits($e,G,Ne,he);return Ve?l.WorkspaceEdit.from(Ve):null}}class fe{constructor(W,G){this.adapter=W,this.extension=G}}class be{constructor(W,G,ce,he,x,$e,ve,Ne){this.g=G,this.h=ce,this.j=he,this.k=x,this.l=$e,this.m=ve,this.n=Ne,this.f=new Map,this.e=W.getProxy(m.$9J.MainThreadLanguageFeatures)}o(W,G){return l.DocumentSelector.from(W,this.g,G)}p(W){return new R.$$J(()=>{this.f.delete(W),this.e.$unregister(W)})}q(){return be.d++}async s(W,G,ce,he,x,$e=!1){const ve=this.f.get(W);if(!ve||!(ve.adapter instanceof G))return he;const Ne=Date.now();$e||this.l.trace(`[${ve.extension.identifier.value}] INVOKE provider '${ce.toString().replace(/[\r\n]/g,"")}'`);const Ve=ce(ve.adapter,ve.extension);return Promise.resolve(Ve).catch(xe=>{(0,g.$2)(xe)||(this.l.error(`[${ve.extension.identifier.value}] provider FAILED`),this.l.error(xe),this.n.onExtensionError(ve.extension.identifier,xe))}).finally(()=>{$e||this.l.trace(`[${ve.extension.identifier.value}] provider DONE after ${Date.now()-Ne}ms`)}),S.CancellationToken.isCancellationToken(x)?(0,d.$Gg)(Ve,x):Ve}t(W,G){const ce=this.q();return this.f.set(ce,new fe(W,G)),ce}static u(W){return W.displayName||W.name}registerDocumentSymbolProvider(W,G,ce,he){const x=this.t(new r(this.h,ce),W),$e=he&&he.label||be.u(W);return this.e.$registerDocumentSymbolProvider(x,this.o(G,W),$e),this.p(x)}$provideDocumentSymbols(W,G,ce){return this.s(W,r,he=>he.provideDocumentSymbols(y.URI.revive(G),ce),void 0,ce)}registerCodeLensProvider(W,G,ce){const he=this.q(),x=typeof ce.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(he,new fe(new i(this.h,this.j.converter,ce),W)),this.e.$registerCodeLensSupport(he,this.o(G,W),x);let $e=this.p(he);if(x!==void 0){const ve=ce.onDidChangeCodeLenses(Ne=>this.e.$emitCodeLensEvent(x));$e=R.$$J.from($e,ve)}return $e}$provideCodeLenses(W,G,ce){return this.s(W,i,he=>he.provideCodeLenses(y.URI.revive(G),ce),void 0,ce)}$resolveCodeLens(W,G,ce){return this.s(W,i,he=>he.resolveCodeLens(G,ce),void 0,void 0)}$releaseCodeLenses(W,G){this.s(W,i,ce=>Promise.resolve(ce.releaseCodeLenses(G)),void 0,void 0)}registerDefinitionProvider(W,G,ce){const he=this.t(new h(this.h,ce),W);return this.e.$registerDefinitionSupport(he,this.o(G,W)),this.p(he)}$provideDefinition(W,G,ce,he){return this.s(W,h,x=>x.provideDefinition(y.URI.revive(G),ce,he),[],he)}registerDeclarationProvider(W,G,ce){const he=this.t(new p(this.h,ce),W);return this.e.$registerDeclarationSupport(he,this.o(G,W)),this.p(he)}$provideDeclaration(W,G,ce,he){return this.s(W,p,x=>x.provideDeclaration(y.URI.revive(G),ce,he),[],he)}registerImplementationProvider(W,G,ce){const he=this.t(new I(this.h,ce),W);return this.e.$registerImplementationSupport(he,this.o(G,W)),this.p(he)}$provideImplementation(W,G,ce,he){return this.s(W,I,x=>x.provideImplementation(y.URI.revive(G),ce,he),[],he)}registerTypeDefinitionProvider(W,G,ce){const he=this.t(new w(this.h,ce),W);return this.e.$registerTypeDefinitionSupport(he,this.o(G,W)),this.p(he)}$provideTypeDefinition(W,G,ce,he){return this.s(W,w,x=>x.provideTypeDefinition(y.URI.revive(G),ce,he),[],he)}registerHoverProvider(W,G,ce,he){const x=this.t(new f(this.h,ce),W);return this.e.$registerHoverProvider(x,this.o(G,W)),this.p(x)}$provideHover(W,G,ce,he){return this.s(W,f,x=>x.provideHover(y.URI.revive(G),ce,he),void 0,he)}registerEvaluatableExpressionProvider(W,G,ce,he){const x=this.t(new b(this.h,ce),W);return this.e.$registerEvaluatableExpressionProvider(x,this.o(G,W)),this.p(x)}$provideEvaluatableExpression(W,G,ce,he){return this.s(W,b,x=>x.provideEvaluatableExpression(y.URI.revive(G),ce,he),void 0,he)}registerInlineValuesProvider(W,G,ce,he){const x=typeof ce.onDidChangeInlineValues=="function"?this.q():void 0,$e=this.t(new L(this.h,ce),W);this.e.$registerInlineValuesProvider($e,this.o(G,W),x);let ve=this.p($e);if(x!==void 0){const Ne=ce.onDidChangeInlineValues(Ve=>this.e.$emitInlineValuesEvent(x));ve=R.$$J.from(ve,Ne)}return ve}$provideInlineValues(W,G,ce,he,x){return this.s(W,L,$e=>$e.provideInlineValues(y.URI.revive(G),ce,he,x),void 0,x)}registerDocumentHighlightProvider(W,G,ce){const he=this.t(new O(this.h,ce),W);return this.e.$registerDocumentHighlightProvider(he,this.o(G,W)),this.p(he)}$provideDocumentHighlights(W,G,ce,he){return this.s(W,O,x=>x.provideDocumentHighlights(y.URI.revive(G),ce,he),void 0,he)}registerLinkedEditingRangeProvider(W,G,ce){const he=this.t(new T(this.h,ce),W);return this.e.$registerLinkedEditingRangeProvider(he,this.o(G,W)),this.p(he)}$provideLinkedEditingRanges(W,G,ce,he){return this.s(W,T,async x=>{const $e=await x.provideLinkedEditingRanges(y.URI.revive(G),ce,he);if($e)return{ranges:$e.ranges,wordPattern:$e.wordPattern?be.w($e.wordPattern):void 0}},void 0,he)}registerReferenceProvider(W,G,ce){const he=this.t(new F(this.h,ce),W);return this.e.$registerReferenceSupport(he,this.o(G,W)),this.p(he)}$provideReferences(W,G,ce,he,x){return this.s(W,F,$e=>$e.provideReferences(y.URI.revive(G),ce,he,x),void 0,x)}registerCodeActionProvider(W,G,ce,he){const x=new E.$Pc,$e=this.t(new U(this.h,this.j.converter,this.k,ce,this.l,W,this.m),W);return this.e.$registerQuickFixSupport($e,this.o(G,W),{providedKinds:he?.providedCodeActionKinds?.map(ve=>ve.value),documentation:he?.documentation?.map(ve=>({kind:ve.kind.value,command:this.j.converter.toInternal(ve.command,x)}))},be.u(W),!!ce.resolveCodeAction),x.add(this.p($e)),x}$provideCodeActions(W,G,ce,he,x){return this.s(W,U,$e=>$e.provideCodeActions(y.URI.revive(G),ce,he,x),void 0,x)}$resolveCodeAction(W,G,ce){return this.s(W,U,he=>he.resolveCodeAction(G,ce),{},void 0)}$releaseCodeActions(W,G){this.s(W,U,ce=>Promise.resolve(ce.releaseCodeActions(G)),void 0,void 0)}registerDocumentFormattingEditProvider(W,G,ce){const he=this.t(new j(this.h,ce),W);return this.e.$registerDocumentFormattingSupport(he,this.o(G,W),W.identifier,W.displayName||W.name),this.p(he)}$provideDocumentFormattingEdits(W,G,ce,he){return this.s(W,j,x=>x.provideDocumentFormattingEdits(y.URI.revive(G),ce,he),void 0,he)}registerDocumentRangeFormattingEditProvider(W,G,ce){const he=typeof ce.provideDocumentRangesFormattingEdits=="function",x=this.t(new z(this.h,ce),W);return this.e.$registerRangeFormattingSupport(x,this.o(G,W),W.identifier,W.displayName||W.name,he),this.p(x)}$provideDocumentRangeFormattingEdits(W,G,ce,he,x){return this.s(W,z,$e=>$e.provideDocumentRangeFormattingEdits(y.URI.revive(G),ce,he,x),void 0,x)}$provideDocumentRangesFormattingEdits(W,G,ce,he,x){return this.s(W,z,$e=>$e.provideDocumentRangesFormattingEdits(y.URI.revive(G),ce,he,x),void 0,x)}registerOnTypeFormattingEditProvider(W,G,ce,he){const x=this.t(new B(this.h,ce),W);return this.e.$registerOnTypeFormattingSupport(x,this.o(G,W),he,W.identifier),this.p(x)}$provideOnTypeFormattingEdits(W,G,ce,he,x,$e){return this.s(W,B,ve=>ve.provideOnTypeFormattingEdits(y.URI.revive(G),ce,he,x,$e),void 0,$e)}registerWorkspaceSymbolProvider(W,G){const ce=this.t(new ae(G,this.l),W);return this.e.$registerNavigateTypeSupport(ce,typeof G.resolveWorkspaceSymbol=="function"),this.p(ce)}$provideWorkspaceSymbols(W,G,ce){return this.s(W,ae,he=>he.provideWorkspaceSymbols(G,ce),{symbols:[]},ce)}$resolveWorkspaceSymbol(W,G,ce){return this.s(W,ae,he=>he.resolveWorkspaceSymbol(G,ce),void 0,void 0)}$releaseWorkspaceSymbols(W,G){this.s(W,ae,ce=>ce.releaseWorkspaceSymbols(G),void 0,void 0)}registerRenameProvider(W,G,ce){const he=this.t(new X(this.h,ce,this.l),W);return this.e.$registerRenameSupport(he,this.o(G,W),X.supportsResolving(ce)),this.p(he)}$provideRenameEdits(W,G,ce,he,x){return this.s(W,X,$e=>$e.provideRenameEdits(y.URI.revive(G),ce,he,x),void 0,x)}$resolveRenameLocation(W,G,ce,he){return this.s(W,X,x=>x.resolveRenameLocation(y.URI.revive(G),ce,he),void 0,he)}registerDocumentSemanticTokensProvider(W,G,ce,he){const x=this.t(new H(this.h,ce),W),$e=typeof ce.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(x,this.o(G,W),he,$e);let ve=this.p(x);if($e){const Ne=ce.onDidChangeSemanticTokens(Ve=>this.e.$emitDocumentSemanticTokensEvent($e));ve=R.$$J.from(ve,Ne)}return ve}$provideDocumentSemanticTokens(W,G,ce,he){return this.s(W,H,x=>x.provideDocumentSemanticTokens(y.URI.revive(G),ce,he),null,he)}$releaseDocumentSemanticTokens(W,G){this.s(W,H,ce=>ce.releaseDocumentSemanticColoring(G),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(W,G,ce,he){const x=this.t(new te(this.h,ce),W);return this.e.$registerDocumentRangeSemanticTokensProvider(x,this.o(G,W),he),this.p(x)}$provideDocumentRangeSemanticTokens(W,G,ce,he){return this.s(W,te,x=>x.provideDocumentRangeSemanticTokens(y.URI.revive(G),ce,he),null,he)}registerCompletionItemProvider(W,G,ce,he){const x=this.t(new me(this.h,this.j.converter,ce,this.m,W),W);return this.e.$registerCompletionsProvider(x,this.o(G,W),he,me.supportsResolving(ce),W.identifier),this.p(x)}$provideCompletionItems(W,G,ce,he,x){return this.s(W,me,$e=>$e.provideCompletionItems(y.URI.revive(G),ce,he,x),void 0,x)}$resolveCompletionItem(W,G,ce){return this.s(W,me,he=>he.resolveCompletionItem(G,ce),void 0,ce)}$releaseCompletionItems(W,G){this.s(W,me,ce=>ce.releaseCompletionItems(G),void 0,void 0)}registerInlineCompletionsProvider(W,G,ce,he){const x=new ye(W,this.h,ce,this.j.converter),$e=this.t(x,W);return this.e.$registerInlineCompletionsSupport($e,this.o(G,W),x.supportsHandleEvents,D.$Xl.toKey(W.identifier.value),he?.yieldTo?.map(ve=>D.$Xl.toKey(ve))||[]),this.p($e)}$provideInlineCompletions(W,G,ce,he,x){return this.s(W,le,$e=>$e.provideInlineCompletions(y.URI.revive(G),ce,he,x),void 0,x)}$handleInlineCompletionDidShow(W,G,ce,he){this.s(W,le,async x=>{x.handleDidShowCompletionItem(G,ce,he)},void 0,void 0)}$handleInlineCompletionPartialAccept(W,G,ce,he){this.s(W,le,async x=>{x.handlePartialAccept(G,ce,he)},void 0,void 0)}$freeInlineCompletionsList(W,G){this.s(W,le,async ce=>{ce.disposeCompletions(G)},void 0,void 0)}registerSignatureHelpProvider(W,G,ce,he){const x=Array.isArray(he)?{triggerCharacters:he,retriggerCharacters:[]}:he,$e=this.t(new V(this.h,ce),W);return this.e.$registerSignatureHelpProvider($e,this.o(G,W),x),this.p($e)}$provideSignatureHelp(W,G,ce,he,x){return this.s(W,V,$e=>$e.provideSignatureHelp(y.URI.revive(G),ce,he,x),void 0,x)}$releaseSignatureHelp(W,G){this.s(W,V,ce=>ce.releaseSignatureHelp(G),void 0,void 0)}registerInlayHintsProvider(W,G,ce){const he=typeof ce.onDidChangeInlayHints=="function"?this.q():void 0,x=this.t(new J(this.h,this.j.converter,ce,this.l,W),W);this.e.$registerInlayHintsProvider(x,this.o(G,W),typeof ce.resolveInlayHint=="function",he,be.u(W));let $e=this.p(x);if(he!==void 0){const ve=ce.onDidChangeInlayHints(Ne=>this.e.$emitInlayHintsEvent(he));$e=R.$$J.from($e,ve)}return $e}$provideInlayHints(W,G,ce,he){return this.s(W,J,x=>x.provideInlayHints(y.URI.revive(G),ce,he),void 0,he)}$resolveInlayHint(W,G,ce){return this.s(W,J,he=>he.resolveInlayHint(G,ce),void 0,ce)}$releaseInlayHints(W,G){this.s(W,J,ce=>ce.releaseHints(G),void 0,void 0)}registerDocumentLinkProvider(W,G,ce){const he=this.t(new ee(this.h,ce),W);return this.e.$registerDocumentLinkProvider(he,this.o(G,W),typeof ce.resolveDocumentLink=="function"),this.p(he)}$provideDocumentLinks(W,G,ce){return this.s(W,ee,he=>he.provideLinks(y.URI.revive(G),ce),void 0,ce,G.scheme==="output")}$resolveDocumentLink(W,G,ce){return this.s(W,ee,he=>he.resolveLink(G,ce),void 0,void 0,!0)}$releaseDocumentLinks(W,G){this.s(W,ee,ce=>ce.releaseLinks(G),void 0,void 0,!0)}registerColorProvider(W,G,ce){const he=this.t(new Y(this.h,ce),W);return this.e.$registerDocumentColorProvider(he,this.o(G,W)),this.p(he)}$provideDocumentColors(W,G,ce){return this.s(W,Y,he=>he.provideColors(y.URI.revive(G),ce),[],ce)}$provideColorPresentations(W,G,ce,he){return this.s(W,Y,x=>x.provideColorPresentations(y.URI.revive(G),ce,he),void 0,he)}registerFoldingRangeProvider(W,G,ce){const he=this.q(),x=typeof ce.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(he,new fe(new Z(this.h,ce),W)),this.e.$registerFoldingRangeProvider(he,this.o(G,W),W.identifier,x);let $e=this.p(he);if(x!==void 0){const ve=ce.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(x));$e=R.$$J.from($e,ve)}return $e}$provideFoldingRanges(W,G,ce,he){return this.s(W,Z,x=>x.provideFoldingRanges(y.URI.revive(G),ce,he),void 0,he)}registerSelectionRangeProvider(W,G,ce){const he=this.t(new _(this.h,ce,this.l),W);return this.e.$registerSelectionRangeProvider(he,this.o(G,W)),this.p(he)}$provideSelectionRanges(W,G,ce,he){return this.s(W,_,x=>x.provideSelectionRanges(y.URI.revive(G),ce,he),[],he)}registerCallHierarchyProvider(W,G,ce){const he=this.t(new pe(this.h,ce),W);return this.e.$registerCallHierarchyProvider(he,this.o(G,W)),this.p(he)}$prepareCallHierarchy(W,G,ce,he){return this.s(W,pe,x=>Promise.resolve(x.prepareSession(y.URI.revive(G),ce,he)),void 0,he)}$provideCallHierarchyIncomingCalls(W,G,ce,he){return this.s(W,pe,x=>x.provideCallsTo(G,ce,he),void 0,he)}$provideCallHierarchyOutgoingCalls(W,G,ce,he){return this.s(W,pe,x=>x.provideCallsFrom(G,ce,he),void 0,he)}$releaseCallHierarchy(W,G){this.s(W,pe,ce=>Promise.resolve(ce.releaseSession(G)),void 0,void 0)}registerTypeHierarchyProvider(W,G,ce){const he=this.t(new se(this.h,ce),W);return this.e.$registerTypeHierarchyProvider(he,this.o(G,W)),this.p(he)}$prepareTypeHierarchy(W,G,ce,he){return this.s(W,se,x=>Promise.resolve(x.prepareSession(y.URI.revive(G),ce,he)),void 0,he)}$provideTypeHierarchySupertypes(W,G,ce,he){return this.s(W,se,x=>x.provideSupertypes(G,ce,he),void 0,he)}$provideTypeHierarchySubtypes(W,G,ce,he){return this.s(W,se,x=>x.provideSubtypes(G,ce,he),void 0,he)}$releaseTypeHierarchy(W,G){this.s(W,se,ce=>Promise.resolve(ce.releaseSession(G)),void 0,void 0)}registerDocumentOnDropEditProvider(W,G,ce,he){const x=this.q();this.f.set(x,new fe(new ge(this.e,this.h,ce,x,W),W));const $e=(0,t.$7E)(W,"dropMetadata")&&he?ge.toInternalProviderId(W.identifier.value,he.id):void 0;return this.e.$registerDocumentOnDropEditProvider(x,this.o(G,W),$e,(0,t.$7E)(W,"dropMetadata")?he:void 0),this.p(x)}$provideDocumentOnDropEdits(W,G,ce,he,x,$e){return this.s(W,ge,ve=>Promise.resolve(ve.provideDocumentOnDropEdits(G,y.URI.revive(ce),he,x,$e)),void 0,void 0)}registerMappedEditsProvider(W,G,ce){const he=this.t(new ie(this.h,ce),W);return this.e.$registerMappedEditsProvider(he,this.o(G,W)),this.p(he)}$provideMappedEdits(W,G,ce,he,x){return this.s(W,ie,$e=>Promise.resolve($e.provideMappedEdits(G,ce,he,x)),null,x)}registerDocumentPasteEditProvider(W,G,ce,he){const x=this.q();this.f.set(x,new fe(new N(this.e,this.h,ce,x,W),W));const $e=N.toInternalProviderId(W.identifier.value,he.id);return this.e.$registerPasteEditProvider(x,this.o(G,W),$e,{supportsCopy:!!ce.prepareDocumentPaste,supportsPaste:!!ce.provideDocumentPasteEdits,copyMimeTypes:he.copyMimeTypes,pasteMimeTypes:he.pasteMimeTypes}),this.p(x)}$prepareDocumentPaste(W,G,ce,he,x){return this.s(W,N,$e=>$e.prepareDocumentPaste(y.URI.revive(G),ce,he,x),void 0,x)}$providePasteEdits(W,G,ce,he,x,$e){return this.s(W,N,ve=>ve.providePasteEdits(G,y.URI.revive(ce),he,x,$e),void 0,$e)}static w(W){return{pattern:W.source,flags:W.flags}}static y(W){return{decreaseIndentPattern:be.w(W.decreaseIndentPattern),increaseIndentPattern:be.w(W.increaseIndentPattern),indentNextLinePattern:W.indentNextLinePattern?be.w(W.indentNextLinePattern):void 0,unIndentedLinePattern:W.unIndentedLinePattern?be.w(W.unIndentedLinePattern):void 0}}static z(W){return{beforeText:be.w(W.beforeText),afterText:W.afterText?be.w(W.afterText):void 0,previousLineText:W.previousLineText?be.w(W.previousLineText):void 0,action:W.action}}static B(W){return W.map(be.z)}static C(W){return{open:W.open,close:W.close,notIn:W.notIn?W.notIn.map(G=>R.SyntaxTokenType.toString(G)):void 0}}static D(W){return W.map(be.C)}setLanguageConfiguration(W,G,ce){const{wordPattern:he}=ce;if(he&&(0,k.$Me)(he))throw new Error(`Invalid language configuration: wordPattern '${he}' is not allowed to match the empty string.`);he?this.h.setWordDefinitionFor(G,he):this.h.setWordDefinitionFor(G,void 0),ce.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",W,"Do not use."),ce.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",W,"Do not use.");const x=this.q(),$e={comments:ce.comments,brackets:ce.brackets,wordPattern:ce.wordPattern?be.w(ce.wordPattern):void 0,indentationRules:ce.indentationRules?be.y(ce.indentationRules):void 0,onEnterRules:ce.onEnterRules?be.B(ce.onEnterRules):void 0,__electricCharacterSupport:ce.__electricCharacterSupport,__characterPairSupport:ce.__characterPairSupport,autoClosingPairs:ce.autoClosingPairs?be.D(ce.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(x,G,$e),this.p(x)}$setWordDefinitions(W){for(const G of W)this.h.setWordDefinitionFor(G.languageId,new RegExp(G.regexSource,G.regexFlags))}}e.$Fbc=be,be.d=0}),define(Se[316],De([1,0,6,13,7,39,9,3]),function(ne,e,y,M,l,R,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ncc=void 0;class k{constructor(P,C,v,S){this.c=C,this.d=v,this.e=S,this.b=[],this.f=0,this.g=new Set,this.a=P.getProxy(y.$9J.MainThreadLanguages)}$acceptLanguageIds(P){this.b=P}async getLanguages(){return this.b.slice(0)}async changeLanguage(P,C){await this.a.$changeLanguage(P,C);const v=this.c.getDocumentData(P);if(!v)throw new Error(`document '${P.toString()}' NOT found`);return v.document}async tokenAtPosition(P,C){const v=P.version,S=M.Position.from(C),D=await this.a.$tokensAtPosition(P.uri,S),E={type:l.StandardTokenType.Other,range:P.getWordRangeAtPosition(C)??new l.$aK(C.line,C.character,C.line,C.character)};if(!D)return E;const s={range:M.Range.to(D.range),type:M.TokenType.to(D.type)};return!s.range.contains(C)||v!==P.version?E:s}createLanguageStatusItem(P,C,v){const S=this.f++,D=this.a,E=this.g,s=`${P.identifier.value}/${C}`;if(E.has(s))throw new Error(`LanguageStatusItem with id '${C}' ALREADY exists`);E.add(s);const c={selector:v,id:C,name:P.displayName??P.name,severity:l.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let u;const o=new m.$Pc,g=()=>{if(u?.dispose(),!E.has(s)){console.warn(`LanguageStatusItem (${C}) from ${P.identifier.value} has been disposed and CANNOT be updated anymore`);return}u=(0,A.$Sg)(()=>{o.clear(),this.a.$setLanguageStatus(S,{id:s,name:c.name??P.displayName??P.name,source:P.displayName??P.name,selector:M.DocumentSelector.from(c.selector,this.e),label:c.text,detail:c.detail??"",severity:c.severity===l.LanguageStatusSeverity.Error?R.default.Error:c.severity===l.LanguageStatusSeverity.Warning?R.default.Warning:R.default.Info,command:c.command&&this.d.toInternal(c.command,o),accessibilityInfo:c.accessibilityInformation,busy:c.busy})},0)},d={dispose(){o.dispose(),u?.dispose(),D.$removeLanguageStatus(S),E.delete(s)},get id(){return c.id},get name(){return c.name},set name(t){c.name=t,g()},get selector(){return c.selector},set selector(t){c.selector=t,g()},get text(){return c.text},set text(t){c.text=t,g()},get detail(){return c.detail},set detail(t){c.detail=t,g()},get severity(){return c.severity},set severity(t){c.severity=t,g()},get accessibilityInformation(){return c.accessibilityInformation},set accessibilityInformation(t){c.accessibilityInformation=t,g()},get command(){return c.command},set command(t){c.command=t,g()},get busy(){return c.busy},set busy(t){c.busy=t,g()}};return g(),d}}e.$ncc=k}),define(Se[113],De([1,0,10,16,2,5,14,6,26,20]),function(ne,e,y,M,l,R,A,m,k,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dcc=e.$ccc=void 0;let P=class{constructor(v,S,D){this.f=D,this.d=new Map,this.a=S.getProxy(m.$9J.MainThreadLocalization),this.b=v.environment.appLanguage,this.c=this.b===y.$a}getMessage(v,S){const{message:D,args:E,comment:s}=S;if(this.c)return(0,M.$Be)(D,E??{});let c=D;s&&s.length>0&&(c+=`/${Array.isArray(s)?s.join(""):s}`);const u=this.d.get(v)?.contents[c];return u||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${c}`),(0,M.$Be)(u??D,E??{})}getBundle(v){return this.d.get(v)?.contents}getBundleUri(v){return this.d.get(v)?.uri}async initializeLocalizedMessages(v){if(this.c||!v.l10n&&!v.isBuiltin||this.d.has(v.identifier.value))return;let S;const D=await this.g(v);if(!D){this.f.error(`No bundle location found for extension ${v.identifier.value}`);return}try{const E=await this.a.$fetchBundleContents(D),s=JSON.parse(E);S=v.isBuiltin?s.contents?.bundle:s}catch(E){this.f.error(`Failed to load translations for ${v.identifier.value} from ${D}: ${E.message}`);return}S&&this.d.set(v.identifier.value,{contents:S,uri:D})}async g(v){if(v.isBuiltin){const S=await this.a.$fetchBuiltInBundleUri(v.identifier.value,this.b);return l.URI.revive(S)}return v.l10n?l.URI.joinPath(v.extensionLocation,v.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$ccc=P,e.$ccc=P=Ke([We(0,k.$nM),We(1,$.$0L),We(2,A.$6i)],P),e.$dcc=(0,R.$Lh)("IExtHostLocalizationService")}),define(Se[151],De([1,0,14,6,26,20,2,60]),function(ne,e,y,M,l,R,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Edc=void 0;let k=class extends y.$ej{constructor(C,v){super(v.logLevel,v.logsLocation,v.loggers.map(S=>(0,m.$ih)(S))),this.r=C.getProxy(M.$9J.MainThreadLogger)}$setLogLevel(C,v){v?this.setLogLevel(A.URI.revive(v),C):this.setLogLevel(C)}setVisibility(C,v){super.setVisibility(C,v),this.r.$setVisibility(C,v)}s(C,v,S){return new $(this.r,C,v,S)}};e.$Edc=k,e.$Edc=k=Ke([We(0,R.$0L),We(1,l.$nM)],k);class $ extends y.$_i{constructor(C,v,S,D){super(D?.logLevel==="always"),this.r=C,this.s=v,this.m=!1,this.n=[],this.setLevel(S),this.r.$createLogger(v,D).then(()=>{this.u(this.n),this.m=!0})}g(C,v){const S=[[C,v]];this.m?this.u(S):this.n.push(...S)}u(C){this.r.$log(this.s,C)}flush(){this.r.$flush(this.s)}}}),define(Se[114],De([1,0,6,5,3,20,22]),function(ne,e,y,M,l,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fcc=e.$ecc=void 0,e.$ecc=(0,M.$Lh)("IExtHostManagedSockets");let m=class{constructor(C){this.b=0,this.c=null,this.d=new Map,this.a=C.getProxy(y.$9J.MainThreadManagedSockets)}setFactory(C,v){for(const S of this.d.values())S.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new k(C,v),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(C){if(!this.c||this.c.socketFactoryId!==C)throw new Error(`No socket factory with id ${C}`);const v=++this.b,S=await this.c.makeConnection(),D=new l.$Pc;return this.d.set(v,new $(v,S,D)),D.add((0,l.$Oc)(()=>this.d.delete(v))),D.add(S.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(v),D.dispose()})),D.add(S.onDidClose(E=>{this.a.$onDidManagedSocketClose(v,E?.stack??E?.message),D.dispose()})),D.add(S.onDidReceiveMessage(E=>this.a.$onDidManagedSocketHaveData(v,A.$_d.wrap(E)))),v}$remoteSocketWrite(C,v){this.d.get(C)?.actual.send(v.buffer)}$remoteSocketEnd(C){const v=this.d.get(C);v&&(v.actual.end(),v.dispose())}async $remoteSocketDrain(C){await this.d.get(C)?.actual.drain?.()}};e.$fcc=m,e.$fcc=m=Ke([We(0,R.$0L)],m);class k{constructor(C,v){this.socketFactoryId=C,this.makeConnection=v}}class $ extends l.$Qc{constructor(C,v,S){super(),this.socketId=C,this.actual=v,this.B(S)}}}),define(Se[317],De([1,0,6,14,27]),function(ne,e,y,M,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$occ=void 0;function R(m){return m&&m.title}let A=class{constructor(k,$){this.b=$,this.a=k.getProxy(y.$9J.MainThreadMessageService)}showMessage(k,$,P,C,v){const S={source:{identifier:k.identifier,label:k.displayName||k.name}};let D;typeof C=="string"||R(C)?D=[C,...v]:(S.modal=C?.modal,S.useCustom=C?.useCustom,S.detail=C?.detail,D=v),S.useCustom&&(0,l.$8E)(k,"resolvers");const E=[];for(let s=0;s<D.length;s++){const c=D[s];if(typeof c=="string")E.push({title:c,handle:s,isCloseAffordance:!1});else if(typeof c=="object"){const{title:u,isCloseAffordance:o}=c;E.push({title:u,isCloseAffordance:!!o,handle:s})}else this.b.warn("Invalid message item:",c)}return this.a.$showMessage($,P,S,E).then(s=>{if(typeof s=="number")return D[s]})}};e.$occ=A,e.$occ=A=Ke([We(1,M.$6i)],A)}),define(Se[318],De([1,0,207,22,4,3,28,16,18,2,30,87,6,33,13,7,69,280,145,8,23,17]),function(ne,e,y,M,l,R,A,m,k,$,P,C,v,S,D,E,s,c,u,o,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9cc=void 0;class t{get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(r=>r.apiEditor)}constructor(r,i,a,h,p){this.q=a,this.r=h,this.s=p,this.f=new Map,this.g=new A.$yc,this.h=new Map,this.j=new l.$Ld({onListenerError:o.$Z}),this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new l.$Ld({onListenerError:o.$Z}),this.onDidOpenNotebookDocument=this.m.event,this.n=new l.$Ld({onListenerError:o.$Z}),this.onDidCloseNotebookDocument=this.n.event,this.o=new l.$Ld({onListenerError:o.$Z}),this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new C.$wbc("NotebookCellStatusBarCache"),this.u=0,this.w=new Map,this.b=r.getProxy(v.$9J.MainThreadNotebook),this.c=r.getProxy(v.$9J.MainThreadNotebookDocuments),this.d=r.getProxy(v.$9J.MainThreadNotebookEditors),this.i=i.converter,i.registerArgumentProcessor({processArgument:I=>{if(I&&I.$mid===13){const w=I.notebookEditor?.notebookUri,f=I.cell.handle,L=this.g.get(w)?.getCell(f);if(L)return L.apiCell}if(I&&I.$mid===14){const w=I.uri,f=this.g.get(w);if(f)return f.apiNotebook}return I}}),t.A(i)}getEditorById(r){const i=this.h.get(r);if(!i)throw new Error(`unknown text editor: ${r}. known editors: ${[...this.h.keys()]} `);return i}getIdByEditor(r){for(const[i,a]of this.h)if(a.apiEditor===r)return i}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(r,i){const a=this.g.get(r);if(!a&&!i)throw new Error(`NO notebook document for '${r}'`);return a}static t(r,i){if(!i)return;const a=i.filenamePattern.map(h=>D.NotebookExclusiveDocumentPattern.from(h)).filter(h=>h!==void 0);if(i.filenamePattern&&!a){console.warn(`Notebook content provider view options file name pattern is invalid ${i.filenamePattern}`);return}return{extension:r.identifier,providerDisplayName:r.displayName||r.name,displayName:i.displayName,filenamePattern:a,exclusive:i.exclusive||!1}}registerNotebookCellStatusBarItemProvider(r,i,a){const h=t.a++,p=typeof a.onDidChangeCellStatusBarItems=="function"?t.a++:void 0;this.f.set(h,a),this.b.$registerNotebookCellStatusBarItemProvider(h,p,i);let I;return p!==void 0&&(I=a.onDidChangeCellStatusBarItems(w=>this.b.$emitCellStatusBarEvent(p))),new E.$$J(()=>{this.f.delete(h),this.b.$unregisterNotebookCellStatusBarItemProvider(h,p),I?.dispose()})}async createNotebookDocument(r){const i=await this.c.$tryCreateNotebook({viewType:r.viewType,content:r.content&&D.NotebookData.from(r.content)});return $.URI.revive(i)}async openNotebookDocument(r){const i=this.g.get(r);if(i)return i.apiNotebook;const a=await this.c.$tryOpenNotebook(r),h=this.g.get($.URI.revive(a));return(0,k.$Hf)(h?.apiNotebook)}async showNotebookDocument(r,i){$.URI.isUri(r)&&(r=await this.openNotebookDocument(r));let a;typeof i=="object"?a={position:D.ViewColumn.from(i.viewColumn),preserveFocus:i.preserveFocus,selections:i.selections&&i.selections.map(D.NotebookRange.from),pinned:typeof i.preview=="boolean"?!i.preview:void 0}:a={preserveFocus:!1};const h=await this.d.$tryShowNotebookDocument(r.uri,r.notebookType,a),p=h&&this.h.get(h)?.apiEditor;if(p)return p;throw h?new Error(`Could NOT open editor for "${r.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${r.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(r,i,a,h){const p=this.f.get(r),I=$.URI.revive(i),w=this.g.get(I);if(!w||!p)return;const f=w.getCellFromIndex(a);if(!f)return;const b=await p.provideCellStatusBarItems(f.apiCell,h);if(!b)return;const L=new R.$Pc,O=this.p.add([L]),F=(Array.isArray(b)?b:[b]).map(U=>D.NotebookStatusBarItem.from(U,this.i,L));return{cacheId:O,items:F}}$releaseNotebookCellStatusBarItems(r){this.p.delete(r)}registerNotebookSerializer(r,i,a,h,p){if((0,m.$ze)(i))throw new Error("viewType cannot be empty or just whitespace");const I=this.u++;return this.w.set(I,{viewType:i,serializer:a,options:h}),this.b.$registerNotebookSerializer(I,{id:r.identifier,location:r.extensionLocation},i,D.NotebookDocumentContentOptions.from(h),t.t(r,p)),(0,R.$Oc)(()=>{this.b.$unregisterNotebookSerializer(I)})}async $dataToNotebook(r,i,a){const h=this.w.get(r);if(!h)throw new Error("NO serializer found");const p=await h.serializer.deserializeNotebook(i.buffer,a);return new s.$iv(D.NotebookData.from(p))}async $notebookToData(r,i,a){const h=this.w.get(r);if(!h)throw new Error("NO serializer found");const p=await h.serializer.serializeNotebook(D.NotebookData.to(i.value),a);return M.$_d.wrap(p)}async $saveNotebook(r,i,a,h,p){const I=$.URI.revive(i),w=this.w.get(r);if(!w)throw new Error("NO serializer found");const f=this.g.get(I);if(!f)throw new Error("Document NOT found");if(f.versionId!==a)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(I.scheme))throw new P.$ok((0,y.localize)(0,null,this.y(I)),6);await this.x(I,h);const b={metadata:(0,g.$6m)(f.apiNotebook.metadata,U=>!(w.options?.transientDocumentMetadata??{})[U]),cells:[]};for(const U of f.apiNotebook.getCells()){const N=new E.$wL(U.kind,U.document.getText(),U.document.languageId,U.mime,w.options?.transientOutputs?[]:[...U.outputs],U.metadata,U.executionSummary);N.metadata=(0,g.$6m)(U.metadata,j=>!(w.options?.transientCellMetadata??{})[j]),b.cells.push(N)}const L=await w.serializer.serializeNotebook(b,p);await this.s.value.writeFile(I,L);const O=this.s.getFileSystemProviderExtUri(I.scheme),T=await this.s.value.stat(I);return{name:O.basename(I),isFile:(T.type&P.FileType.File)!==0,isDirectory:(T.type&P.FileType.Directory)!==0,isSymbolicLink:(T.type&P.FileType.SymbolicLink)!==0,mtime:T.mtime,ctime:T.ctime,size:T.size,readonly:!!((T.permissions??0)&P.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(I.scheme),locked:!!((T.permissions??0)&P.FilePermission.Locked),etag:P.$zk({mtime:T.mtime,size:T.size}),children:void 0}}async x(r,i){const a=await this.s.value.stat(r);if(typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==P.$yk&&typeof a.mtime=="number"&&typeof a.size=="number"&&i.mtime<a.mtime&&i.etag!==P.$zk({mtime:i.mtime,size:a.size}))throw new P.$ok((0,y.localize)(1,null),3,i)}y(r){return r.scheme===d.Schemas.file?r.fsPath:r.toString()}z(r,i,a){if(this.h.has(i))throw new Error(`editor with id ALREADY EXSIST: ${i}`);const h=new u.$8cc(i,this.d,r,a.visibleRanges.map(D.NotebookRange.to),a.selections.map(D.NotebookRange.to),typeof a.viewColumn=="number"?D.ViewColumn.to(a.viewColumn):void 0);this.h.set(i,h)}$acceptDocumentAndEditorsDelta(r){if(r.value.removedDocuments)for(const a of r.value.removedDocuments){const h=$.URI.revive(a),p=this.g.get(h);p&&(p.dispose(),this.g.delete(h),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:p.apiNotebook.getCells().map(I=>I.document.uri)}),this.n.fire(p.apiNotebook));for(const I of this.h.values())I.notebookData.uri.toString()===h.toString()&&this.h.delete(I.id)}if(r.value.addedDocuments){const a=[];for(const h of r.value.addedDocuments){const p=$.URI.revive(h.uri);if(this.g.has(p))throw new Error(`adding EXISTING notebook ${p} `);const I=new c.$7cc(this.c,this.q,this.r,p,h);a.push(...h.cells.map(w=>c.$6cc.asModelAddData(I.apiNotebook,w))),this.g.get(p)?.dispose(),this.g.set(p,I),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:a}),this.m.fire(I.apiNotebook)}}if(r.value.addedEditors)for(const a of r.value.addedEditors){if(this.h.has(a.id))return;const h=$.URI.revive(a.documentUri),p=this.g.get(h);p&&this.z(p,a.id,a)}const i=[];if(r.value.removedEditors)for(const a of r.value.removedEditors){const h=this.h.get(a);h&&(this.h.delete(a),this.k?.id===h.id&&(this.k=void 0),i.push(h))}if(r.value.visibleEditors){this.l=r.value.visibleEditors.map(h=>this.h.get(h)).filter(h=>!!h);const a=new Set;this.l.forEach(h=>a.add(h.id));for(const h of this.h.values()){const p=a.has(h.id);h._acceptVisibility(p)}this.l=[...this.h.values()].map(h=>h).filter(h=>h.visible),this.o.fire(this.visibleNotebookEditors)}r.value.newActiveEditor===null?this.k=void 0:r.value.newActiveEditor&&(this.h.get(r.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${r.value.newActiveEditor}`),this.k=this.h.get(r.value.newActiveEditor)),r.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static A(r){const i=S.$vM.String.with("notebookType","A notebook type"),a=new S.$xM("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[i,new S.$vM("data","Bytes to convert to data",p=>p instanceof Uint8Array,p=>M.$_d.wrap(p))],new S.$wM("Notebook Data",p=>D.NotebookData.to(p.value))),h=new S.$xM("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[i,new S.$vM("NotebookData","Notebook data to convert to bytes",p=>!0,p=>new s.$iv(D.NotebookData.from(p)))],new S.$wM("Bytes",p=>p.buffer));r.registerApiCommand(a),r.registerApiCommand(h)}}e.$9cc=t,t.a=0}),define(Se[319],De([1,0,19,9,21,4,3,28,2,25,14,87,6,33,13,7,111,274,27,69]),function(ne,e,y,M,l,R,A,m,k,$,P,C,v,S,D,E,s,c,u,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ldc=e.$kdc=void 0;let g=class{constructor(p,I,w,f,b){this.m=I,this.n=w,this.o=f,this.q=b,this.b=new m.$yc,this.c=new m.$yc,this.e=new Map,this.f=0,this.g=new Map,this.h=0,this.i=new C.$wbc("NotebookKernelSourceActionProviderCache"),this.j=new Map,this.k=0,this.l=new R.$Ld,this.onDidChangeNotebookCellExecutionState=this.l.event,this.a=p.getProxy(v.$9J.MainThreadNotebookKernels);const L=new S.$xM("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new S.$vM("options","Select kernel options",O=>!0,O=>{if(O&&"notebookEditor"in O&&"id"in O){const T=this.n.getIdByEditor(O.notebookEditor);return{id:O.id,extension:O.extension,notebookEditorId:T}}else if(O&&"notebookEditor"in O){const T=this.n.getIdByEditor(O.notebookEditor);if(T===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${O.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:T}}return O})],S.$wM.Void);this.o.registerApiCommand(L)}createNotebookController(p,I,w,f,b,L){for(const me of this.j.values())if(me.controller.id===I&&$.$Xl.equals(p.identifier,me.extensionId))throw new Error(`notebook controller with id '${I}' ALREADY exist`);const O=this.k++,T=this;this.q.trace(`NotebookController[${O}], CREATED by ${p.identifier.value}, ${I}`);const F=()=>console.warn(`NO execute handler from notebook controller '${z.id}' of extension: '${p.identifier}'`);let U=!1;const N=new R.$Ld,j=new R.$Ld,z={id:a(p.identifier,I),notebookType:w,extensionId:p.identifier,extensionLocation:p.extensionLocation,label:f||p.identifier.value,preloads:L?L.map(D.NotebookRendererScript.from):[]};let B=b??F,ae;this.a.$addKernel(O,z).catch(me=>{console.log(me),U=!0});let X=0;const Q=()=>{if(U)return;const me=++X;Promise.resolve().then(()=>{me===X&&this.a.$updateKernel(O,z)})},H=new m.$yc,te={get id(){return I},get notebookType(){return z.notebookType},onDidChangeSelectedNotebooks:N.event,get label(){return z.label},set label(me){z.label=me??p.displayName??p.name,Q()},get detail(){return z.detail??""},set detail(me){z.detail=me,Q()},get description(){return z.description??""},set description(me){z.description=me,Q()},get supportedLanguages(){return z.supportedLanguages},set supportedLanguages(me){z.supportedLanguages=me,Q()},get supportsExecutionOrder(){return z.supportsExecutionOrder??!1},set supportsExecutionOrder(me){z.supportsExecutionOrder=me,Q()},get rendererScripts(){return z.preloads?z.preloads.map(D.NotebookRendererScript.to):[]},get executeHandler(){return B},set executeHandler(me){B=me??F},get interruptHandler(){return ae},set interruptHandler(me){ae=me,z.supportsInterrupt=!!me,Q()},createNotebookCellExecution(me){if(U)throw new Error("notebook controller is DISPOSED");if(!H.has(me.notebook.uri))throw T.q.trace(`NotebookController[${O}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(H.keys()).map(le=>le.toString())),new Error(`notebook controller is NOT associated to notebook: ${me.notebook.uri.toString()}`);return T._createNotebookCellExecution(me,a(p.identifier,this.id))},createNotebookExecution(me){if((0,u.$8E)(p,"notebookExecution"),U)throw new Error("notebook controller is DISPOSED");if(!H.has(me.uri))throw T.q.trace(`NotebookController[${O}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(H.keys()).map(le=>le.toString())),new Error(`notebook controller is NOT associated to notebook: ${me.uri.toString()}`);return T._createNotebookExecution(me,a(p.identifier,this.id))},dispose:()=>{U||(this.q.trace(`NotebookController[${O}], DISPOSED`),U=!0,this.j.delete(O),N.dispose(),j.dispose(),this.a.$removeKernel(O))},updateNotebookAffinity(me,le){le===E.NotebookControllerAffinity2.Hidden&&(0,u.$8E)(p,"notebookControllerAffinityHidden"),T.a.$updateNotebookPriority(O,me.uri,le)},onDidReceiveMessage:j.event,postMessage(me,le){return(0,u.$8E)(p,"notebookMessaging"),T.a.$postMessage(O,le&&T.n.getIdByEditor(le),me)},asWebviewUri(me){return(0,u.$8E)(p,"notebookMessaging"),(0,s.$Yob)(me,T.m.remote)}};return this.j.set(O,{extensionId:p.identifier,controller:te,onDidReceiveMessage:j,onDidChangeSelection:N,associatedNotebooks:H}),te}getIdByController(p){for(const[I,w]of this.j)if(w.controller===p)return a(w.extensionId,p.id);return null}createNotebookControllerDetectionTask(p,I){const w=this.f++,f=this;this.q.trace(`NotebookControllerDetectionTask[${w}], CREATED by ${p.identifier.value}`),this.a.$addKernelDetectionTask(w,I);const b={dispose:()=>{this.e.delete(w),f.a.$removeKernelDetectionTask(w)}};return this.e.set(w,b),b}registerKernelSourceActionProvider(p,I,w){const f=this.h++,b=typeof w.onDidChangeNotebookKernelSourceActions=="function"?f:void 0,L=this;this.g.set(f,w),this.q.trace(`NotebookKernelSourceActionProvider[${f}], CREATED by ${p.identifier.value}`),this.a.$addKernelSourceActionProvider(f,f,I);let O;return b!==void 0&&(O=w.onDidChangeNotebookKernelSourceActions(T=>this.a.$emitNotebookKernelSourceActionsChangeEvent(b))),{dispose:()=>{this.g.delete(f),L.a.$removeKernelSourceActionProvider(f,f),O?.dispose()}}}async $provideKernelSourceActions(p,I){const w=this.g.get(p);if(w){const f=new A.$Pc;return this.i.add([f]),(await w.provideNotebookKernelSourceActions(I)??[]).map(L=>D.NotebookKernelSourceAction.from(L,this.o.converter,f))}return[]}$acceptNotebookAssociation(p,I,w){const f=this.j.get(p);if(f){const b=this.n.getNotebookDocument(k.URI.revive(I));w?f.associatedNotebooks.set(b.uri,!0):f.associatedNotebooks.delete(b.uri),this.q.trace(`NotebookController[${p}] ASSOCIATE notebook`,b.uri.toString(),w),f.onDidChangeSelection.fire({selected:w,notebook:b.apiNotebook})}}async $executeCells(p,I,w){const f=this.j.get(p);if(!f)return;const b=this.n.getNotebookDocument(k.URI.revive(I)),L=[];for(const O of w){const T=b.getCell(O);T&&L.push(T.apiCell)}try{this.q.trace(`NotebookController[${p}] EXECUTE cells`,b.uri.toString(),L.length),await f.controller.executeHandler.call(f.controller,L,b.apiNotebook,f.controller)}catch(O){this.q.error(`NotebookController[${p}] execute cells FAILED`,O),console.error(O)}}async $cancelCells(p,I,w){const f=this.j.get(p);if(!f)return;const b=this.n.getNotebookDocument(k.URI.revive(I));if(f.controller.interruptHandler)await f.controller.interruptHandler.call(f.controller,b.apiNotebook);else for(const L of w){const O=b.getCell(L);O&&this.b.get(O.uri)?.cancel()}if(f.controller.interruptHandler){const L=this.c.get(b.uri);w.length&&Array.isArray(L)&&L.length&&L.forEach(O=>O.dispose())}}$acceptKernelMessageFromRenderer(p,I,w){const f=this.j.get(p);if(!f)return;const b=this.n.getEditorById(I);f.onDidReceiveMessage.fire(Object.freeze({editor:b.apiEditor,message:w}))}$cellExecutionChanged(p,I,w){const b=this.n.getNotebookDocument(k.URI.revive(p)).getCell(I);if(b){const L=w?D.NotebookCellExecutionState.to(w):E.NotebookCellExecutionState.Idle;L!==void 0&&this.l.fire({cell:b.apiCell,state:L})}}_createNotebookCellExecution(p,I){if(p.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const f=this.n.getNotebookDocument(p.notebook.uri).getCellFromApiCell(p);if(!f)throw new Error("invalid cell");if(this.b.has(f.uri))throw new Error(`duplicate execution for ${f.uri}`);const b=new t(I,f,this.a);this.b.set(f.uri,b);const L=b.onDidChangeState(()=>{b.state===d.Resolved&&(b.dispose(),L.dispose(),this.b.delete(f.uri))});return b.asApiObject()}_createNotebookExecution(p,I){const w=this.n.getNotebookDocument(p.uri),f=p.getCells().find(O=>{const T=w.getCellFromApiCell(O);return T&&this.b.has(T.uri)});if(f)throw new Error(`duplicate cell execution for ${f.document.uri}`);if(this.c.has(w.uri))throw new Error(`duplicate notebook execution for ${w.uri}`);const b=new r(I,w,this.a),L=b.onDidChangeState(()=>{b.state===n.Resolved&&(b.dispose(),L.dispose(),this.c.delete(w.uri))});return this.c.set(w.uri,[b,L]),b.asApiObject()}};e.$kdc=g,e.$kdc=g=Ke([We(4,P.$6i)],g);var d;(function(h){h[h.Init=0]="Init",h[h.Started=1]="Started",h[h.Resolved=2]="Resolved"})(d||(d={}));class t extends A.$Qc{get state(){return this.f}constructor(p,I,w){super(),this.m=I,this.n=w,this.b=t.a++,this.c=new R.$Ld,this.onDidChangeState=this.c.event,this.f=d.Init,this.g=this.B(new l.$Vd),this.h=new i(10,f=>this.s(f)),this.j=I.internalMetadata.executionOrder,this.n.$createExecution(this.b,p,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(p){await this.h.addItem(p)}async s(p){const I=Array.isArray(p)?p:[p];return this.n.$updateExecution(this.b,new o.$iv(I))}t(){if(this.f===d.Init)throw new Error("Must call start before modifying cell output");if(this.f===d.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(p){let I=this.m;if(p&&(I=this.m.notebook.getCellFromApiCell(p)),!I)throw new Error("INVALID cell");return I.handle}y(p){return p.map(I=>{const w=E.$zL.ensureUniqueMimeTypes(I.items,!0);return w===I.items?D.NotebookCellOutput.from(I):D.NotebookCellOutput.from({items:w,id:I.id,metadata:I.metadata})})}async z(p,I,w){const f=this.w(I),b=this.y((0,y.$1b)(p));return this.r({editType:c.CellExecutionUpdateType.Output,cellHandle:f,append:w,outputs:b})}async C(p,I,w){return p=E.$zL.ensureUniqueMimeTypes((0,y.$1b)(p),!0),this.r({editType:c.CellExecutionUpdateType.OutputItems,items:p.map(D.NotebookCellOutputItem.from),outputId:I.id,append:w})}asApiObject(){const p=this;return Object.freeze({get token(){return p.g.token},get cell(){return p.m.apiCell},get executionOrder(){return p.j},set executionOrder(w){p.j=w,p.s([{editType:c.CellExecutionUpdateType.ExecutionState,executionOrder:p.j}])},start(w){if(p.f===d.Resolved||p.f===d.Started)throw new Error("Cannot call start again");p.f=d.Started,p.c.fire(),p.s({editType:c.CellExecutionUpdateType.ExecutionState,runStartTime:w})},end(w,f){if(p.f===d.Resolved)throw new Error("Cannot call resolve twice");p.f=d.Resolved,p.c.fire(),p.h.flush(),p.n.$completeExecution(p.b,new o.$iv({runEndTime:f,lastRunSuccess:w}))},clearOutput(w){return p.t(),p.z([],w,!1)},appendOutput(w,f){return p.t(),p.z(w,f,!0)},replaceOutput(w,f){return p.t(),p.z(w,f,!1)},appendOutputItems(w,f){return p.t(),p.C(w,f,!0)},replaceOutputItems(w,f){return p.t(),p.C(w,f,!1)}})}}t.a=0;var n;(function(h){h[h.Init=0]="Init",h[h.Started=1]="Started",h[h.Resolved=2]="Resolved"})(n||(n={}));class r extends A.$Qc{get state(){return this.f}constructor(p,I,w){super(),this.h=I,this.j=w,this.b=r.a++,this.c=new R.$Ld,this.onDidChangeState=this.c.event,this.f=n.Init,this.g=this.B(new l.$Vd),this.j.$createNotebookExecution(this.b,p,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===n.Resolved||this.f===n.Started)throw new Error("Cannot call start again");this.f=n.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===n.Resolved)throw new Error("Cannot call resolve twice");this.f=n.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}r.a=0;class i{constructor(p,I){this.e=p,this.f=I,this.a=[],this.b=Date.now()}addItem(p){return this.a.push(p),this.c||(this.c=new M.$_g,this.b=Date.now(),(0,M.$Rg)(this.e).then(()=>this.flush())),Date.now()-this.b>this.e?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const p=this.c;this.c=void 0;const I=this.a;return this.a=[],this.f(I).finally(()=>p.complete())}}function a(h,p){return`${h.value}/${p}`}e.$ldc=a}),define(Se[320],De([1,0,4,6,145]),function(ne,e,y,M,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mdc=void 0;class R{constructor(m,k){this.c=k,this.a=new Map,this.b=m.getProxy(M.$9J.MainThreadNotebookRenderers)}$postRendererMessage(m,k,$){const P=this.c.getEditorById(m);this.a.get(k)?.fire({editor:P.apiEditor,message:$})}createRendererMessaging(m,k){if(!m.contributes?.notebookRenderer?.some(P=>P.id===k))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${k})`);return{onDidReceiveMessage:(P,C,v)=>this.d(k).event(P,C,v),postMessage:(P,C)=>{l.$8cc.apiEditorsToExtHost.has(P)&&([P,C]=[C,P]);const v=C&&l.$8cc.apiEditorsToExtHost.get(C);return this.b.$postMessage(v?.id,k,P)}}}d(m){let k=this.a.get(m);return k||(k=new y.$Ld({onDidRemoveLastListener:()=>{k?.dispose(),this.a.delete(m)}}),this.a.set(m,k),k)}}e.$mdc=R}),define(Se[321],De([1,0,3,18,2,27,6]),function(ne,e,y,M,l,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qdc=void 0;class m{constructor($){this.b=new Map,this.a=$.getProxy(A.$9J.MainThreadProfileContentHandlers)}registrProfileContentHandler($,P,C){if((0,R.$8E)($,"profileContentHandlers"),this.b.has(P))throw new Error(`Handler with id '${P}' already registered`);return this.b.set(P,C),this.a.$registerProfileContentHandler(P,C.name,C.description,$.identifier.value),(0,y.$Oc)(()=>{this.b.delete(P),this.a.$unregisterProfileContentHandler(P)})}async $saveProfile($,P,C,v){const S=this.b.get($);if(!S)throw new Error(`Unknown handler with id: ${$}`);return S.saveProfile(P,C,v)}async $readProfile($,P,C){const v=this.b.get($);if(!v)throw new Error(`Unknown handler with id: ${$}`);return v.readProfile((0,M.$wf)(P)?P:l.URI.revive(P),C)}}e.$qdc=m}),define(Se[322],De([1,0,2,6,9,13]),function(ne,e,y,M,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rdc=void 0;class A{constructor(k,$){this.d=$,this.c=new Map,this.b=k.getProxy(M.$9J.MainThreadQuickDiff)}$provideOriginalResource(k,$,P){const C=y.URI.revive($),v=this.c.get(k);return v?(0,l.$Jg)(()=>v.provideOriginalResource(C,P)).then(S=>S||null):Promise.resolve(null)}registerQuickDiffProvider(k,$,P,C){const v=A.a++;return this.c.set(v,$),this.b.$registerQuickDiffProvider(v,R.DocumentSelector.from(k,this.d),P,C),{dispose:()=>{this.b.$unregisterQuickDiffProvider(v),this.c.delete(v)}}}}e.$rdc=A,A.a=0}),define(Se[323],De([1,0,21,4,3,6,2,7,8,19,39,59,27,13]),function(ne,e,y,M,l,R,A,m,k,$,P,C,v,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$scc=void 0;function D(E,s,c){const u=E.getProxy(R.$9J.MainThreadQuickOpen);class o{constructor(p,I){this.e=new Map,this.f=0,this.a=p,this.b=I}showQuickPick(p,I,w,f=y.CancellationToken.None){this.c=void 0;const b=Promise.resolve(I),L=++this.f,O=u.$show(L,{title:w?.title,placeHolder:w?.placeHolder,matchOnDescription:w?.matchOnDescription,matchOnDetail:w?.matchOnDetail,ignoreFocusLost:w?.ignoreFocusOut,canPickMany:w?.canPickMany},f),T={},F=O.then(()=>T);return Promise.race([F,b]).then(U=>{if(U===T)return;const N=(0,v.$7E)(p,"quickPickItemTooltip");return b.then(j=>{const z=[];for(let B=0;B<j.length;B++){const ae=j[B];if(typeof ae=="string")z.push({label:ae,handle:B});else if(ae.kind===m.QuickPickItemKind.Separator)z.push({type:"separator",label:ae.label});else{ae.tooltip&&!N&&console.warn(`Extension '${p.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${p.identifier.value}`);const X=ae.iconPath?r(ae.iconPath):void 0;z.push({label:ae.label,iconPath:X?.iconPath,iconClass:X?.iconClass,description:ae.description,detail:ae.detail,picked:ae.picked,alwaysShow:ae.alwaysShow,tooltip:N?S.MarkdownString.fromStrict(ae.tooltip):void 0,handle:B})}}return w&&typeof w.onDidSelectItem=="function"&&(this.c=B=>{w.onDidSelectItem(j[B])}),u.$setItems(L,z),O.then(B=>{if(typeof B=="number")return j[B];if(Array.isArray(B))return B.map(ae=>j[ae])})})}).then(void 0,U=>{if(!(0,k.$2)(U))return u.$setError(L,U),Promise.reject(U)})}$onItemSelected(p){this.c?.(p)}showInput(p,I=y.CancellationToken.None){return this.d=p?.validateInput,u.$input(p,typeof this.d=="function",I).then(void 0,w=>{if(!(0,k.$2)(w))return Promise.reject(w)})}async $validateInput(p){if(!this.d)return;const I=await this.d(p);if(!I||typeof I=="string")return I;let w;switch(I.severity){case m.InputBoxValidationSeverity.Info:w=P.default.Info;break;case m.InputBoxValidationSeverity.Warning:w=P.default.Warning;break;case m.InputBoxValidationSeverity.Error:w=P.default.Error;break;default:w=I.message?P.default.Error:P.default.Ignore;break}return{content:I.message,severity:w}}async showWorkspaceFolderPick(p,I=y.CancellationToken.None){const w=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[p]);if(!w)return;const f=await this.a.getWorkspaceFolders2();if(f)return f.find(b=>b.uri.toString()===w.uri.toString())}createQuickPick(p){const I=new i(p,()=>this.e.delete(I._id));return this.e.set(I._id,I),I}createInputBox(p){const I=new a(p,()=>this.e.delete(I._id));return this.e.set(I._id,I),I}$onDidChangeValue(p,I){this.e.get(p)?._fireDidChangeValue(I)}$onDidAccept(p){this.e.get(p)?._fireDidAccept()}$onDidChangeActive(p,I){const w=this.e.get(p);w instanceof i&&w._fireDidChangeActive(I)}$onDidChangeSelection(p,I){const w=this.e.get(p);w instanceof i&&w._fireDidChangeSelection(I)}$onDidTriggerButton(p,I){this.e.get(p)?._fireDidTriggerButton(I)}$onDidTriggerItemButton(p,I,w){const f=this.e.get(p);f instanceof i&&f._fireDidTriggerItemButton(I,w)}$onDidHide(p){this.e.get(p)?._fireDidHide()}}class g{constructor(p,I){this.x=p,this.y=I,this._id=i.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new M.$Ld,this.q=new M.$Ld,this.r=new M.$Ld,this.s=new M.$Ld,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(p){this.b=p,this.z({title:p})}get step(){return this.c}set step(p){this.c=p,this.z({step:p})}get totalSteps(){return this.d}set totalSteps(p){this.d=p,this.z({totalSteps:p})}get enabled(){return this.g}set enabled(p){this.g=p,this.z({enabled:p})}get busy(){return this.j}set busy(p){this.j=p,this.z({busy:p})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(p){this.k=p,this.z({ignoreFocusOut:p})}get value(){return this.l}set value(p){this.l=p,this.z({value:p})}get placeholder(){return this.m}set placeholder(p){this.m=p,this.z({placeholder:p})}get buttons(){return this.n}set buttons(p){this.n=p.slice(),this.o.clear(),p.forEach((I,w)=>{const f=I===m.$sL.Back?-1:w;this.o.set(f,I)}),this.z({buttons:p.map((I,w)=>({...r(I.iconPath),tooltip:I.tooltip,handle:I===m.$sL.Back?-1:w}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(p){this.l=p,this.q.fire(p)}_fireDidTriggerButton(p){const I=this.o.get(p);I&&this.r.fire(I)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,l.$Lc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),u.$dispose(this._id))}z(p){if(!this.v){for(const I of Object.keys(p)){const w=p[I];this.u[I]=w===void 0?null:w}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){u.$createOrUpdate(this.u),this.u={id:this._id}}}g.a=1;function d(h){if(h instanceof m.$5K)return{id:h.id};const p=n(h),I=t(h);return{dark:typeof p=="string"?A.URI.file(p):p,light:typeof I=="string"?A.URI.file(I):I}}function t(h){return typeof h=="object"&&"light"in h?h.light:h}function n(h){return typeof h=="object"&&"dark"in h?h.dark:h}function r(h){const p=d(h);let I,w;return"id"in p?w=C.ThemeIcon.asClassName(p):I=p,{iconPath:I,iconClass:w}}class i extends g{constructor(p,I){super(p.identifier,I),this.O=p,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new M.$Ld,this.L=[],this.M=new M.$Ld,this.N=new M.$Ld,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(p){this.B=p.slice(),this.C.clear(),this.D.clear(),p.forEach((f,b)=>{this.C.set(b,f),this.D.set(f,b)});const I=(0,v.$7E)(this.O,"quickPickItemTooltip"),w=[];for(let f=0;f<p.length;f++){const b=p[f];if(b.kind===m.QuickPickItemKind.Separator)w.push({type:"separator",label:b.label});else{b.tooltip&&!I&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const L=b.iconPath?r(b.iconPath):void 0;w.push({handle:f,label:b.label,iconPath:L?.iconPath,iconClass:L?.iconClass,description:b.description,detail:b.detail,picked:b.picked,alwaysShow:b.alwaysShow,tooltip:I?S.MarkdownString.fromStrict(b.tooltip):void 0,buttons:b.buttons?.map((O,T)=>({...r(O.iconPath),tooltip:O.tooltip,handle:T}))})}}this.z({items:w})}get canSelectMany(){return this.E}set canSelectMany(p){this.E=p,this.z({canSelectMany:p})}get matchOnDescription(){return this.F}set matchOnDescription(p){this.F=p,this.z({matchOnDescription:p})}get matchOnDetail(){return this.G}set matchOnDetail(p){this.G=p,this.z({matchOnDetail:p})}get sortByLabel(){return this.H}set sortByLabel(p){this.H=p,this.z({sortByLabel:p})}get keepScrollPosition(){return this.I}set keepScrollPosition(p){this.I=p,this.z({keepScrollPosition:p})}get activeItems(){return this.J}set activeItems(p){this.J=p.filter(I=>this.D.has(I)),this.z({activeItems:this.J.map(I=>this.D.get(I))})}get selectedItems(){return this.L}set selectedItems(p){this.L=p.filter(I=>this.D.has(I)),this.z({selectedItems:this.L.map(I=>this.D.get(I))})}_fireDidChangeActive(p){const I=(0,$.$Fb)(p.map(w=>this.C.get(w)));this.J=I,this.K.fire(I)}_fireDidChangeSelection(p){const I=(0,$.$Fb)(p.map(w=>this.C.get(w)));this.L=I,this.M.fire(I)}_fireDidTriggerItemButton(p,I){const w=this.C.get(p);if(!w||!w.buttons||!w.buttons.length)return;const f=w.buttons[I];f&&this.N.fire({button:f,item:w})}}class a extends g{constructor(p,I){super(p.identifier,I),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(p){this.B=p,this.z({password:p})}get prompt(){return this.C}set prompt(p){this.C=p,this.z({prompt:p})}get valueSelection(){return this.D}set valueSelection(p){this.D=p,this.z({valueSelection:p})}get validationMessage(){return this.E}set validationMessage(p){this.E=p,p?typeof p=="string"?this.z({validationMessage:p,severity:P.default.Error}):this.z({validationMessage:p.message,severity:p.severity??P.default.Error}):this.z({validationMessage:void 0,severity:P.default.Ignore})}}return new o(s,c)}e.$scc=D});var Be=this&&this.__classPrivateFieldGet||function(ne,e,y,M){if(y==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!M:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return y==="m"?M:y==="a"?M.call(ne):M?M.value:e.get(ne)},et=this&&this.__classPrivateFieldSet||function(ne,e,y,M,l){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!l:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?l.call(ne,y):l?l.value=y:e.set(ne,y),y};define(Se[324],De([1,0,2,4,56,3,9,6,19,122,14,25,59,13,27,17]),function(ne,e,y,M,l,R,A,m,k,$,P,C,v,S,D,E){"use strict";var s,c,u,o;Object.defineProperty(e,"__esModule",{value:!0}),e.$ucc=e.$tcc=void 0;function g(O){if(O)return typeof O.iconPath=="string"?y.URI.file(O.iconPath):y.URI.isUri(O.iconPath)||v.ThemeIcon.isThemeIcon(O.iconPath)?O.iconPath:void 0}function d(O){if(O.icon){if(y.URI.isUri(O.icon))return O.icon;if(v.ThemeIcon.isThemeIcon(O.icon))return O.icon;{const T=O.icon;return{light:T.light,dark:T.dark}}}else return}function t(O,T){if(!O.iconPath&&!T.iconPath)return 0;if(O.iconPath){if(!T.iconPath)return 1}else return-1;const F=typeof O.iconPath=="string"?O.iconPath:y.URI.isUri(O.iconPath)?O.iconPath.fsPath:O.iconPath.id,U=typeof T.iconPath=="string"?T.iconPath:y.URI.isUri(T.iconPath)?T.iconPath.fsPath:T.iconPath.id;return(0,$.$jq)(F,U)}function n(O,T){let F=0;if(O.strikeThrough!==T.strikeThrough)return O.strikeThrough?1:-1;if(O.faded!==T.faded)return O.faded?1:-1;if(O.tooltip!==T.tooltip)return(O.tooltip||"").localeCompare(T.tooltip||"");if(F=t(O,T),F!==0)return F;if(O.light&&T.light)F=t(O.light,T.light);else{if(O.light)return 1;if(T.light)return-1}if(F!==0)return F;if(O.dark&&T.dark)F=t(O.dark,T.dark);else{if(O.dark)return 1;if(T.dark)return-1}return F}function r(O,T){if(O.command!==T.command)return O.command<T.command?-1:1;if(O.title!==T.title)return O.title<T.title?-1:1;if(O.tooltip!==T.tooltip){if(O.tooltip!==void 0&&T.tooltip!==void 0)return O.tooltip<T.tooltip?-1:1;if(O.tooltip!==void 0)return 1;if(T.tooltip!==void 0)return-1}if(O.arguments===T.arguments)return 0;if(O.arguments)if(T.arguments){if(O.arguments.length!==T.arguments.length)return O.arguments.length-T.arguments.length}else return 1;else return-1;for(let F=0;F<O.arguments.length;F++){const U=O.arguments[F],N=T.arguments[F];if(U!==N)return U<N?-1:1}return 0}function i(O,T){let F=(0,$.$jq)(O.resourceUri.fsPath,T.resourceUri.fsPath,!0);if(F!==0)return F;if(O.command&&T.command)F=r(O.command,T.command);else{if(O.command)return 1;if(T.command)return-1}if(F!==0)return F;if(O.decorations&&T.decorations)F=n(O.decorations,T.decorations);else{if(O.decorations)return 1;if(T.decorations)return-1}return F}function a(O,T){for(let F=0;F<O.length;F++)if(O[F]!==T[F])return!1;return!0}function h(O,T){return O.command===T.command&&O.title===T.title&&O.tooltip===T.tooltip&&(O.arguments&&T.arguments?a(O.arguments,T.arguments):O.arguments===T.arguments)}function p(O,T){return(0,k.$sb)(O,T,h)}function I(O,T){return O===T?!0:!O||!T?!1:O.id===T.id&&O.label===T.label&&O.upstream?.id===T.upstream?.id&&O.upstream?.label===T.upstream?.label}class w{get value(){return this.d}set value(T){T=T??"",Be(this,s,"f").$setInputBoxValue(this.l,T),this.n(T)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(T){Be(this,s,"f").$setInputBoxPlaceholder(this.l,T),this.f=T}get validateInput(){return(0,D.$8E)(this.k,"scmValidation"),this.g}set validateInput(T){if((0,D.$8E)(this.k,"scmValidation"),T&&typeof T!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=T,Be(this,s,"f").$setValidationProviderIsEnabled(this.l,!!T)}get enabled(){return this.h}set enabled(T){T=!!T,this.h!==T&&(this.h=T,Be(this,s,"f").$setInputBoxEnablement(this.l,T))}get visible(){return this.j}set visible(T){T=!!T,this.j!==T&&(this.j=T,Be(this,s,"f").$setInputBoxVisibility(this.l,T))}get document(){return(0,D.$8E)(this.k,"scmTextDocument"),Be(this,c,"f").getDocument(this.m)}constructor(T,F,U,N,j){this.k=T,this.l=N,this.m=j,s.set(this,void 0),c.set(this,void 0),this.d="",this.e=new M.$Ld,this.f="",this.h=!0,this.j=!0,et(this,c,F,"f"),et(this,s,U,"f")}showValidationMessage(T,F){(0,D.$8E)(this.k,"scmValidation"),Be(this,s,"f").$showValidationMessage(this.l,T,F)}$onInputBoxValueChange(T){this.n(T)}n(T){this.d=T,this.e.fire(T)}}e.$tcc=w,s=new WeakMap,c=new WeakMap;class f{get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(T){this.v=T,this.q.$updateGroupLabel(this.t,this.handle,T)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(T){this.p=T,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(T){this.f=[...T],this.k.fire()}constructor(T,F,U,N,j){this.q=T,this.s=F,this.t=U,this.u=N,this.v=j,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new M.$Ld,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new M.$Ld,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=f.d++}getResourceState(T){return this.g.get(T)}$executeResourceCommand(T,F){const U=this.h.get(T);return U?(0,A.$Jg)(()=>this.s.executeCommand(U.command,...U.arguments||[],F)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const T=[...this.f].sort(i),U=(0,k.$Bb)(this.o,T,i).map(z=>{const B=z.toInsert.map(ae=>{const X=this.e++;this.g.set(X,ae);const Q=ae.resourceUri;let H;if(ae.command)if(ae.command.command==="vscode.open"||ae.command.command==="vscode.diff"){const Z=new R.$Pc;H=this.s.converter.toInternal(ae.command,Z),this.j.set(X,Z)}else this.h.set(X,ae.command);const te=g(ae.decorations),me=ae.decorations&&g(ae.decorations.light)||te,le=ae.decorations&&g(ae.decorations.dark)||te,ye=[me,le],de=ae.decorations&&ae.decorations.tooltip||"",V=ae.decorations&&!!ae.decorations.strikeThrough,J=ae.decorations&&!!ae.decorations.faded,ee=ae.contextValue||"";return{rawResource:[X,Q,ye,de,V,J,ee,H],handle:X}});return{start:z.start,deleteCount:z.deleteCount,toInsert:B}}),N=U.map(({start:z,deleteCount:B,toInsert:ae})=>[z,B,ae.map(X=>X.rawResource)]),j=U.reverse();for(const{start:z,deleteCount:B,toInsert:ae}of j){const X=ae.map(H=>H.handle),Q=this.n.splice(z,B,...X);for(const H of Q)this.g.delete(H),this.h.delete(H),this.j.get(H)?.dispose(),this.j.delete(H)}return this.o=T,N}dispose(){this.l=!0,this.m.fire()}}f.d=0;class b{get id(){return this.A}get label(){return this.B}get rootUri(){return this.C}get inputBox(){return this.f}get count(){return this.g}set count(T){this.g!==T&&(this.g=T,Be(this,u,"f").$updateSourceControl(this.x,{count:T}))}get quickDiffProvider(){return this.h}set quickDiffProvider(T){this.h=T;let F;(0,D.$7E)(this.y,"quickDiffProvider")&&(F=T?.label),Be(this,u,"f").$updateSourceControl(this.x,{hasQuickDiffProvider:!!T,quickDiffLabel:F})}get historyProvider(){return(0,D.$8E)(this.y,"scmHistoryProvider"),this.j}set historyProvider(T){(0,D.$8E)(this.y,"scmHistoryProvider"),this.j=T,this.k.value=new R.$Pc,Be(this,u,"f").$updateSourceControl(this.x,{hasHistoryProvider:!!T}),T&&(this.k.value.add(T.onDidChangeCurrentHistoryItemGroup(()=>{I(this.l,T?.currentHistoryItemGroup)||(this.l=T?.currentHistoryItemGroup,Be(this,u,"f").$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.x,this.l))})),this.k.value.add(T.onDidChangeActionButton(()=>{(0,D.$8E)(this.y,"scmActionButton"),this.m.value=new R.$Pc;const F=T.actionButton!==void 0?{command:this.z.converter.toInternal(T.actionButton.command,this.m.value),description:T.actionButton.description,enabled:T.actionButton.enabled}:void 0;Be(this,u,"f").$onDidChangeHistoryProviderActionButton(this.x,F??null)})))}get commitTemplate(){return this.n}set commitTemplate(T){T!==this.n&&(this.n=T,Be(this,u,"f").$updateSourceControl(this.x,{commitTemplate:T}))}get acceptInputCommand(){return this.p}set acceptInputCommand(T){this.o.value=new R.$Pc,this.p=T;const F=this.z.converter.toInternal(T,this.o.value);Be(this,u,"f").$updateSourceControl(this.x,{acceptInputCommand:F})}get actionButton(){return(0,D.$8E)(this.y,"scmActionButton"),this.s}set actionButton(T){(0,D.$8E)(this.y,"scmActionButton"),this.q.value=new R.$Pc,this.s=T;const F=T!==void 0?{command:this.z.converter.toInternal(T.command,this.q.value),secondaryCommands:T.secondaryCommands?.map(U=>U.map(N=>this.z.converter.toInternal(N,this.q.value))),description:T.description,enabled:T.enabled}:void 0;Be(this,u,"f").$updateSourceControl(this.x,{actionButton:F??null})}get statusBarCommands(){return this.u}set statusBarCommands(T){if(this.u&&T&&p(this.u,T))return;this.t.value=new R.$Pc,this.u=T;const F=(T||[]).map(U=>this.z.converter.toInternal(U,this.t.value));Be(this,u,"f").$updateSourceControl(this.x,{statusBarCommands:F})}get selected(){return this.v}constructor(T,F,U,N,j,z,B){this.y=T,this.z=N,this.A=j,this.B=z,this.C=B,u.set(this,void 0),this.e=new Map,this.g=void 0,this.h=void 0,this.k=new R.$Rc,this.m=new R.$Rc,this.n=void 0,this.o=new R.$Rc,this.p=void 0,this.q=new R.$Rc,this.t=new R.$Rc,this.u=void 0,this.v=!1,this.w=new M.$Ld,this.onDidChangeSelection=this.w.event,this.x=b.d++,this.D=new Map,this.E=new Set,et(this,u,U,"f");const ae=y.URI.from({scheme:E.Schemas.vscodeSourceControl,path:`${j}/scm${this.x}/input`,query:B?`rootUri=${encodeURIComponent(B.toString())}`:void 0});this.f=new w(T,F,Be(this,u,"f"),this.x,ae),Be(this,u,"f").$registerSourceControl(this.x,j,z,B,ae)}createResourceGroup(T,F){const U=new f(Be(this,u,"f"),this.z,this.x,T,F),N=M.Event.once(U.onDidDispose)(()=>this.D.delete(U));return this.D.set(U,N),this.eventuallyAddResourceGroups(),U}eventuallyAddResourceGroups(){const T=[],F=[];for(const[U,N]of this.D){N.dispose();const j=U.onDidUpdateResourceStates(()=>{this.E.add(U),this.eventuallyUpdateResourceStates()});M.Event.once(U.onDidDispose)(()=>{this.E.delete(U),j.dispose(),this.e.delete(U.handle),Be(this,u,"f").$unregisterGroup(this.x,U.handle)}),T.push([U.handle,U.id,U.label,U.features]);const z=U._takeResourceStateSnapshot();z.length>0&&F.push([U.handle,z]),this.e.set(U.handle,U)}Be(this,u,"f").$registerGroups(this.x,T,F),this.D.clear()}eventuallyUpdateResourceStates(){const T=[];this.E.forEach(F=>{const U=F._takeResourceStateSnapshot();U.length!==0&&T.push([F.handle,U])}),T.length>0&&Be(this,u,"f").$spliceResourceStates(this.x,T),this.E.clear()}getResourceGroup(T){return this.e.get(T)}setSelectionState(T){this.v=T,this.w.fire(T)}dispose(){this.o.dispose(),this.q.dispose(),this.t.dispose(),this.e.forEach(T=>T.dispose()),Be(this,u,"f").$unregisterSourceControl(this.x)}}u=new WeakMap,b.d=0,Ke([(0,l.$eh)(100)],b.prototype,"eventuallyAddResourceGroups",null),Ke([(0,l.$eh)(100)],b.prototype,"eventuallyUpdateResourceStates",null);let L=o=class{get onDidChangeActiveProvider(){return this.j.event}constructor(T,F,U,N){this.l=F,this.m=U,this.n=N,this.g=new Map,this.h=new C.$Zl,this.j=new M.$Ld,this.e=T.getProxy(m.$9J.MainThreadSCM),this.f=T.getProxy(m.$9J.MainThreadTelemetry),F.registerArgumentProcessor({processArgument:j=>{if(j&&j.$mid===3){const z=this.g.get(j.sourceControlHandle);if(!z)return j;const B=z.getResourceGroup(j.groupHandle);return B?B.getResourceState(j.handle):j}else if(j&&j.$mid===4){const z=this.g.get(j.sourceControlHandle);return z?z.getResourceGroup(j.groupHandle):j}else if(j&&j.$mid===5){const z=this.g.get(j.handle);return z||j}return j}})}createSourceControl(T,F,U,N){this.n.trace("ExtHostSCM#createSourceControl",T.identifier.value,F,U,N),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:T.identifier.value});const j=o.d++,z=new b(T,this.m,this.e,this.l,F,U,N);this.g.set(j,z);const B=this.h.get(T.identifier)||[];return B.push(z),this.h.set(T.identifier,B),z}getLastInputBox(T){this.n.trace("ExtHostSCM#getLastInputBox",T.identifier.value);const F=this.h.get(T.identifier),U=F&&F[F.length-1];return U&&U.inputBox}$provideOriginalResource(T,F,U){const N=y.URI.revive(F);this.n.trace("ExtHostSCM#$provideOriginalResource",T,N.toString());const j=this.g.get(T);return!j||!j.quickDiffProvider||!j.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,A.$Jg)(()=>j.quickDiffProvider.provideOriginalResource(N,U)).then(z=>z||null)}$onInputBoxValueChange(T,F){this.n.trace("ExtHostSCM#$onInputBoxValueChange",T);const U=this.g.get(T);return U&&U.inputBox.$onInputBoxValueChange(F),Promise.resolve(void 0)}$executeResourceCommand(T,F,U,N){this.n.trace("ExtHostSCM#$executeResourceCommand",T,F,U);const j=this.g.get(T);if(!j)return Promise.resolve(void 0);const z=j.getResourceGroup(F);return z?z.$executeResourceCommand(U,N):Promise.resolve(void 0)}$validateInput(T,F,U){this.n.trace("ExtHostSCM#$validateInput",T);const N=this.g.get(T);return!N||!N.inputBox.validateInput?Promise.resolve(void 0):(0,A.$Jg)(()=>N.inputBox.validateInput(F,U)).then(j=>{if(!j)return Promise.resolve(void 0);const z=S.MarkdownString.fromStrict(j.message);return z?Promise.resolve([z,j.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(T){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",T),T!==void 0&&this.g.get(T)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=T,Promise.resolve(void 0)}async $resolveHistoryItemGroupBase(T,F,U){return await this.g.get(T)?.historyProvider?.resolveHistoryItemGroupBase(F,U)??void 0}async $resolveHistoryItemGroupCommonAncestor(T,F,U,N){return await this.g.get(T)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(F,U,N)??void 0}async $provideHistoryItems(T,F,U,N){return(await this.g.get(T)?.historyProvider?.provideHistoryItems(F,U,N))?.map(B=>({id:B.id,parentIds:B.parentIds,label:B.label,description:B.description,icon:d(B),timestamp:B.timestamp}))??void 0}async $provideHistoryItemChanges(T,F,U){return await this.g.get(T)?.historyProvider?.provideHistoryItemChanges(F,U)??void 0}};e.$ucc=L,L.d=0,e.$ucc=L=o=Ke([We(3,P.$6i)],L)}),define(Se[115],De([1,0,6,4,5]),function(ne,e,y,M,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$acc=e.$_bc=void 0;class R{constructor(m){this.b=new M.$Ld,this.onDidChangePassword=this.b.event,this.a=m.getProxy(y.$9J.MainThreadSecretState)}async $onDidChangePassword(m){this.b.fire(m)}get(m,k){return this.a.$getPassword(m,k)}store(m,k,$){return this.a.$setPassword(m,k,$)}delete(m,k){return this.a.$deletePassword(m,k)}}e.$_bc=R,e.$acc=(0,l.$Lh)("IExtHostSecretState")}),define(Se[325],De([1,0,6,13,2]),function(ne,e,y,M,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wdc=void 0;class R{constructor(m,k){this.d=k,this.c=new Map,this.b=m.getProxy(y.$9J.MainThreadShare)}async $provideShare(m,k,$){return await this.c.get(m)?.provideShare({selection:M.Range.to(k.selection),resourceUri:l.URI.revive(k.resourceUri)},$)??void 0}registerShareProvider(m,k){const $=R.a++;return this.c.set($,k),this.b.$registerShareProvider($,M.DocumentSelector.from(m,this.d),k.id,k.label,k.priority),{dispose:()=>{this.b.$unregisterShareProvider($),this.c.delete($)}}}}e.$wdc=R,R.a=0});var et=this&&this.__classPrivateFieldSet||function(ne,e,y,M,l){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!l:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?l.call(ne,y):l?l.value=y:e.set(ne,y),y},Be=this&&this.__classPrivateFieldGet||function(ne,e,y,M){if(y==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!M:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return y==="m"?M:y==="a"?M.call(ne):M?M.value:e.get(ne)};define(Se[326],De([1,0,7,6,209,3,13,18]),function(ne,e,y,M,l,R,A,m){"use strict";var k,$;Object.defineProperty(e,"__esModule",{value:!0}),e.$wcc=e.$vcc=void 0;class P{constructor(D,E,s,c,u,o=y.StatusBarAlignment.Left,g){if(k.set(this,void 0),$.set(this,void 0),this.i=!1,this.k="",this.q=new R.$Pc,et(this,k,D,"f"),et(this,$,E,"f"),u&&c){this.c=(0,y.$IK)(c.identifier,u);const d=s.get(this.c);d&&(o=d.alignLeft?y.StatusBarAlignment.Left:y.StatusBarAlignment.Right,g=d.priority,this.j=!0,this.name=d.name,this.text=d.text,this.tooltip=d.tooltip,this.command=d.command,this.accessibilityInformation=d.accessibilityInformation)}else this.c=String(P.a++);this.e=c,this.f=u,this.g=o,this.h=this.u(g)}u(D){if((0,m.$Af)(D))return D===Number.POSITIVE_INFINITY?Number.MAX_VALUE:D===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:D}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(D){this.k=D,this.v()}set name(D){this.m=D,this.v()}set tooltip(D){this.l=D,this.v()}set color(D){this.n=D,this.v()}set backgroundColor(D){D&&!P.b.has(D.id)&&(D=void 0),this.o=D,this.v()}set command(D){this.r?.fromApi!==D&&(this.p&&this.q.add(this.p),this.p=new R.$Pc,typeof D=="string"?this.r={fromApi:D,internal:Be(this,$,"f").toInternal({title:"",command:D},this.p)}:D?this.r={fromApi:D,internal:Be(this,$,"f").toInternal(D,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(D){this.t=D,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,Be(this,k,"f").$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let D;this.e?this.f?D=`${this.e.identifier.value}.${this.f}`:D=this.e.identifier.value:D=this.f;let E;this.m?E=this.m:E=(0,l.localize)(0,null,this.e.displayName||this.e.name);let s=this.n;this.o&&(s=P.b.get(this.o.id));const c=A.MarkdownString.fromStrict(this.l);Be(this,k,"f").$setEntry(this.c,D,this.e?.identifier.value,E,this.k,c,this.r?.internal,s,this.o,this.g===y.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$vcc=P,k=new WeakMap,$=new WeakMap,P.a=0,P.b=new Map([["statusBarItem.errorBackground",new y.$6K("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new y.$6K("statusBarItem.warningForeground")]]);class C{constructor(D){this.b=[],this.a=D.createStatusBarEntry(void 0,"status.extensionMessage",y.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,l.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(D){const E={message:D};return this.b.unshift(E),this.c(),new y.$$J(()=>{const s=this.b.indexOf(E);s>=0&&(this.b.splice(s,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class v{constructor(D,E){this.e=new Map,this.a=D.getProxy(M.$9J.MainThreadStatusBar),this.b=E,this.c=new C(this)}$acceptStaticEntries(D){for(const E of D)this.e.set(E.entryId,E)}createStatusBarEntry(D,E,s,c){return new P(this.a,this.b,this.e,D,E,s,c)}setStatusBarMessage(D,E){const s=this.c.setMessage(D);let c;return typeof E=="number"?c=setTimeout(()=>s.dispose(),E):typeof E<"u"&&E.then(()=>s.dispose(),()=>s.dispose()),new y.$$J(()=>{s.dispose(),clearTimeout(c)})}}e.$wcc=v}),define(Se[116],De([1,0,6,4,5]),function(ne,e,y,M,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1bc=e.$Zbc=void 0;class R{constructor(m,k){this.c=k,this.b=new M.$Ld,this.onDidChangeStorage=this.b.event,this.a=m.getProxy(y.$9J.MainThreadStorage)}registerExtensionStorageKeysToSync(m,k){this.a.$registerExtensionStorageKeysToSync(m,k)}async initializeExtensionStorage(m,k,$){const P=await this.a.$initializeExtensionStorage(m,k);let C;return P&&(C=this.d(m,k,P)),C||$}setValue(m,k,$){return this.a.$setValue(m,k,$)}$acceptValue(m,k,$){const P=this.d(m,k,$);P&&this.b.fire({shared:m,key:k,value:P})}d(m,k,$){try{return JSON.parse($)}catch(P){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${k}, global: ${m}): ${P}`)}}}e.$Zbc=R,e.$1bc=(0,l.$Lh)("IExtHostStorage")}),define(Se[91],De([1,0,5,26,14,72,2]),function(ne,e,y,M,l,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7bc=e.$6bc=void 0,e.$6bc=(0,y.$Lh)("IExtensionStoragePaths");let m=class{constructor($,P,C){this.d=P,this.f=C,this.a=$.workspace??void 0,this.b=$.environment,this.whenReady=this.h().then(v=>this.c=v)}async g($){return A.URI.joinPath(this.b.workspaceStorageHome,$)}async h(){if(!this.a)return Promise.resolve(void 0);const $=this.a.id,P=await this.g($);try{return await this.f.value.stat(P),this.d.trace("[ExtHostStorage] storage dir already exists",P),P}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",P),await this.f.value.createDirectory(P),await this.f.value.writeFile(A.URI.joinPath(P,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:A.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),P}catch(C){this.d.error("[ExtHostStorage]",C);return}}workspaceValue($){if(this.c)return A.URI.joinPath(this.c,$.identifier.value)}globalValue($){return A.URI.joinPath(this.b.globalStorageHome,$.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$7bc=m,e.$7bc=m=Ke([We(0,M.$nM),We(1,l.$6i),We(2,R.$5bc)],m)}),define(Se[44],De([1,0,4,6,5,2,20,3,7,211,8,253,21,31,254,59,9,13,33]),function(ne,e,y,M,l,R,A,m,k,$,P,C,v,S,D,E,s,c,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$bc=e.$0bc=e.$9bc=e.$8bc=void 0,e.$8bc=(0,l.$Lh)("IExtHostTerminalService");class o{constructor(w,f,b,L){this.l=w,this._id=f,this.m=b,this.n=L,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.m=Object.freeze(this.m),this.b=new Promise(T=>this.f=T);const O=this;this.value={get name(){return O.n||""},get processId(){return O.b},get creationOptions(){return O.m},get exitStatus(){return O.h},get state(){return O.j},get selection(){return O.k},sendText(T,F=!0){O.q(),O.l.$sendText(O._id,T,F)},show(T){O.q(),O.l.$show(O._id,T)},hide(){O.q(),O.l.$hide(O._id)},dispose(){O.a||(O.a=!0,O.l.$dispose(O._id))},get dimensions(){if(!(O.d===void 0||O.g===void 0))return{columns:O.d,rows:O.g}}}}async create(w,f){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.l.$createTerminal(this._id,{name:w.name,shellPath:w.shellPath??void 0,shellArgs:w.shellArgs??void 0,cwd:w.cwd??void 0,env:w.env??void 0,icon:a(w.iconPath)??void 0,color:E.ThemeColor.isThemeColor(w.color)?w.color.id:void 0,initialText:w.message??void 0,strictEnv:w.strictEnv??void 0,hideFromUser:w.hideFromUser??void 0,isFeatureTerminal:f?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:f?.useShellEnvironment??void 0,location:f?.location||this.o(w.location,f?.resolvedExtHostIdentifier),isTransient:w.isTransient??void 0})}async createExtensionTerminal(w,f,b,L){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.l.$createTerminal(this._id,{name:this.n,isExtensionCustomPtyTerminal:!0,icon:b,color:E.ThemeColor.isThemeColor(L)?L.id:void 0,location:this.o(w,f),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}o(w,f){return typeof w=="object"?"parentTerminal"in w&&w.parentTerminal&&f?{parentTerminal:f}:"viewColumn"in w?{viewColumn:c.ViewColumn.from(w.viewColumn),preserveFocus:w.preserveFocus}:void 0:w}q(){if(this.a)throw new Error("Terminal has already been disposed")}set name(w){this.n=w}setExitStatus(w,f){this.h=Object.freeze({code:w,reason:f})}setDimensions(w,f){return w===this.d&&f===this.g||w===0||f===0?!1:(this.d=w,this.g=f,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}setSelection(w){this.k=w}_setProcessId(w){this.f?(this.f(w),this.f=void 0):this.b.then(f=>{f!==w&&(this.b=Promise.resolve(w))})}}e.$9bc=o;class g{get onProcessReady(){return this.b.event}constructor(w){this.g=w,this.id=0,this.shouldPersist=!1,this.a=new y.$Ld,this.onProcessData=this.a.event,this.b=new y.$Ld,this.d=new y.$Ld,this.onDidChangeProperty=this.d.event,this.f=new y.$Ld,this.onProcessExit=this.f.event}refreshProperty(w){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${w}`)}updateProperty(w,f){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${w}, value: ${f}`)}async start(){}shutdown(){this.g.close()}input(w){this.g.handleInput?.(w)}resize(w,f){this.g.setDimensions?.({columns:w,rows:f})}clearBuffer(){}async processBinary(w){}acknowledgeDataEvent(w){}async setUnicodeVersion(w){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(w){this.g.onDidWrite(f=>this.a.fire(f)),this.g.onDidClose?.((f=void 0)=>{this.f.fire(f===void 0?void 0:f)}),this.g.onDidOverrideDimensions?.(f=>{f&&this.d.fire({type:"overrideDimensions",value:{cols:f.columns,rows:f.rows}})}),this.g.onDidChangeName?.(f=>{this.d.fire({type:"title",value:f})}),this.g.open(w||void 0),w&&this.g.setDimensions?.(w),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let d=1,t=class extends m.$Qc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(w=>w.value)}constructor(w,f,b){super(),this.Q=f,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new m.$Rc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new y.$Ld,this.onDidCloseTerminal=this.H.event,this.I=new y.$Ld,this.onDidOpenTerminal=this.I.event,this.J=new y.$Ld,this.onDidChangeActiveTerminal=this.J.event,this.L=new y.$Ld,this.onDidChangeTerminalDimensions=this.L.event,this.M=new y.$Ld,this.onDidChangeTerminalState=this.M.event,this.N=new y.$Ld,this.onDidChangeShell=this.N.event,this.O=new y.$Ld({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new y.$Ld({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=b.getProxy(M.$9J.MainThreadTerminalService),this.y=new D.$Ikb(this.a.$sendProcessData),this.a.$registerProcessSupport(w),this.Q.registerArgumentProcessor({processArgument:L=>{const O=T=>{const F=T;return this.W(F.instanceId)?.value};switch(L?.$mid){case 15:return O(L);default:{if(Array.isArray(L))for(let T=0;T<L.length&&L[T].$mid===15;T++)L[T]=O(L[T]);return L}}}}),this.B({dispose:()=>{for(const[L,O]of this.g)O.shutdown(!0)}})}getDefaultShell(w){return(w?this.u:this.s)?.path||""}getDefaultShellArgs(w){return(w?this.u:this.s)?.args||[]}createExtensionTerminal(w,f){const b=new o(this.a,(0,S.$bg)(),w,w.name),L=new g(w.pty);return b.createExtensionTerminal(w.location,this.R(w,f).resolvedExtHostIdentifier,a(w.iconPath),h(w.color)).then(O=>{const T=this.S(O,L);this.h[O]=T}),this.f.push(b),b.value}R(w,f){if(f=f||{},w.location&&typeof w.location=="object"&&"parentTerminal"in w.location){const b=w.location.parentTerminal;if(b){const L=this.f.find(O=>O.value===b);L&&(f.resolvedExtHostIdentifier=L._id)}}else w.location&&typeof w.location!="object"?f.location=w.location:f.location&&typeof f.location=="object"&&"splitActiveTerminal"in f.location&&(f.location={splitActiveTerminal:!0});return f}attachPtyToTerminal(w,f){if(!this.W(w))throw new Error(`Cannot resolve terminal with id ${w} for virtual process`);const L=new g(f),O=this.S(w,L);this.h[w]=O}async $acceptActiveTerminalChanged(w){const f=this.b;if(w===null){this.b=void 0,f!==this.b&&this.J.fire(this.b);return}const b=this.W(w);b&&(this.b=b,f!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(w,f){const b=this.W(w);b&&this.O.fire({terminal:b.value,data:f})}async $acceptTerminalDimensions(w,f,b){const L=this.W(w);L&&L.setDimensions(f,b)&&this.L.fire({terminal:L.value,dimensions:L.value.dimensions})}async $acceptDidExecuteCommand(w,f){const b=this.W(w);b&&this.P.fire({terminal:b.value,...f})}async $acceptTerminalMaximumDimensions(w,f,b){this.g.get(w)?.resize(f,b)}async $acceptTerminalTitleChange(w,f){const b=this.W(w);b&&(b.name=f)}async $acceptTerminalClosed(w,f,b){const L=this.Y(this.f,w);if(L!==null){const O=this.f.splice(L,1)[0];O.setExitStatus(f,b),this.H.fire(O.value)}}$acceptTerminalOpened(w,f,b,L){if(f){const F=this.Y(this.f,f);if(F!==null){this.f[F]._id=w,this.I.fire(this.terminals[F]),this.f[F].isOpen=!0;return}}const O={name:L.name,shellPath:L.executable,shellArgs:L.args,cwd:typeof L.cwd=="string"?L.cwd:R.URI.revive(L.cwd),env:L.env,hideFromUser:L.hideFromUser},T=new o(this.a,w,O,b);this.f.push(T),this.I.fire(T.value),T.isOpen=!0}async $acceptTerminalProcessId(w,f){this.W(w)?._setProcessId(f)}async $startExtensionTerminal(w,f){const b=this.W(w);if(!b)return{message:(0,$.localize)(0,null,w)};b.isOpen||await new Promise(O=>{const T=this.onDidOpenTerminal(async F=>{F===b.value&&(T.dispose(),O())})});const L=this.g.get(w);L?L.startSendingEvents(f):this.j[w]={initialDimensions:f}}S(w,f){const b=new m.$Pc;b.add(f.onProcessReady(O=>this.a.$sendProcessReady(w,O.pid,O.cwd,O.windowsPty))),b.add(f.onDidChangeProperty(O=>this.a.$sendProcessProperty(w,O))),this.y.startBuffering(w,f.onProcessData),b.add(f.onProcessExit(O=>this.U(w,O))),this.g.set(w,f);const L=this.j[w];return L&&f instanceof g&&(f.startSendingEvents(L.initialDimensions),delete this.j[w]),b}$acceptProcessAckDataEvent(w,f){this.g.get(w)?.acknowledgeDataEvent(f)}$acceptProcessInput(w,f){this.g.get(w)?.input(f)}$acceptTerminalInteraction(w){const f=this.W(w);f?.setInteractedWith()&&this.M.fire(f.value)}$acceptTerminalSelection(w,f){this.W(w)?.setSelection(f)}$acceptProcessResize(w,f,b){try{this.g.get(w)?.resize(f,b)}catch(L){if(L.code!=="EPIPE"&&L.code!=="ERR_IPC_CHANNEL_CLOSED")throw L}}$acceptProcessShutdown(w,f){this.g.get(w)?.shutdown(f)}$acceptProcessRequestInitialCwd(w){this.g.get(w)?.getInitialCwd().then(f=>this.a.$sendProcessProperty(w,{type:"initialCwd",value:f}))}$acceptProcessRequestCwd(w){this.g.get(w)?.getCwd().then(f=>this.a.$sendProcessProperty(w,{type:"cwd",value:f}))}$acceptProcessRequestLatency(w){return Promise.resolve(w)}registerLinkProvider(w){return this.z.add(w),this.z.size===1&&this.a.$startLinkProvider(),new k.$$J(()=>{this.z.delete(w),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(w,f,b){if(this.C.has(f))throw new Error(`Terminal profile provider "${f}" already registered`);return this.C.set(f,b),this.a.$registerProfileProvider(f,w.identifier.value),new k.$$J(()=>{this.C.delete(f),this.a.$unregisterProfileProvider(f)})}registerTerminalQuickFixProvider(w,f,b){if(this.D.has(w))throw new Error(`Terminal quick fix provider "${w}" is already registered`);return this.D.set(w,b),this.a.$registerQuickFixProvider(w,f),new k.$$J(()=>{this.D.delete(w),this.a.$unregisterQuickFixProvider(w)})}async $provideTerminalQuickFixes(w,f){const b=new v.$Vd().token;if(b.isCancellationRequested)return;const L=this.D.get(w);if(!L)return;const O=await L.provideTerminalQuickFixes(f,b);if(O===null||Array.isArray(O)&&O.length===0)return;const T=new m.$Pc;if(this.w.value=T,!Array.isArray(O))return O?c.TerminalQuickFix.from(O,this.Q.converter,T):void 0;const F=[];for(const U of O){const N=c.TerminalQuickFix.from(U,this.Q.converter,T);N&&F.push(N)}return F}async $createContributedProfileTerminal(w,f){const b=new v.$Vd().token;let L=await this.C.get(w)?.provideTerminalProfile(b);if(!b.isCancellationRequested){if(L&&!("options"in L)&&(L={options:L}),!L||!("options"in L))throw new Error(`No terminal profile options provided for id "${w}"`);if("pty"in L.options){this.createExtensionTerminal(L.options,f);return}this.createTerminalFromOptions(L.options,f)}}async $provideLinks(w,f){const b=this.W(w);if(!b)return[];this.F.delete(w),this.G.get(w)?.dispose(!0);const O=new v.$Vd;this.G.set(w,O);const T=[],F={terminal:b.value,line:f},U=[];for(const z of this.z)U.push(s.Promises.withAsyncBody(async B=>{O.token.onCancellationRequested(()=>B({provider:z,links:[]}));const ae=await z.provideTerminalLinks(F,O.token)||[];O.token.isCancellationRequested||B({provider:z,links:ae})}));const N=await Promise.all(U);if(O.token.isCancellationRequested)return[];const j=new Map;for(const z of N)z&&z.links.length>0&&T.push(...z.links.map(B=>{const ae={id:d++,startIndex:B.startIndex,length:B.length,label:B.tooltip};return j.set(ae.id,{provider:z.provider,link:B}),ae}));return this.F.set(w,j),T}$activateLink(w,f){const b=this.F.get(w)?.get(f);b&&b.provider.handleTerminalLink(b.link)}U(w,f){this.y.stopBuffering(w),this.g.delete(w),delete this.j[w];const b=this.h[w];b&&(b.dispose(),delete this.h[w]),this.a.$sendProcessExit(w,f)}W(w){return this.X(this.f,w)}X(w,f){const b=this.Y(w,f);return b!==null?w[b]:null}Y(w,f){const b=w.findIndex(L=>L._id===f);return b===-1?null:b}getEnvironmentVariableCollection(w){let f=this.n.get(w.identifier.value);return f||(f=new n,this.$(w.identifier.value,f)),f.getScopedEnvironmentVariableCollection(void 0)}Z(w,f){const b=(0,C.$cr)(f.map),L=(0,C.$dr)(f.descriptionMap);this.a.$setEnvironmentVariableCollection(w,f.persistent,b.length===0?void 0:b,L)}$initEnvironmentVariableCollections(w){w.forEach(f=>{const b=f[0],L=new n(f[1]);this.$(b,L)})}$acceptDefaultProfile(w,f){const b=this.s;this.s=w,this.u=f,b?.path!==w.path&&this.N.fire(w.path)}$(w,f){this.n.set(w,f),f.onDidChangeCollection(()=>{this.Z(w,f)})}};e.$0bc=t,e.$0bc=t=Ke([We(1,u.$tM),We(2,A.$0L)],t);class n{get persistent(){return this.b}set persistent(w){this.b=w,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(w){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new y.$Ld,this.map=new Map(w)}getScopedEnvironmentVariableCollection(w){const f=this.h(w);let b=this.a.get(f);return b||(b=new r(this,w),this.a.set(f,b),b.onDidChangeCollection(()=>this.d.fire())),b}replace(w,f,b,L){this.f(w,{value:f,type:k.EnvironmentVariableMutatorType.Replace,options:b??{applyAtProcessCreation:!0},scope:L})}append(w,f,b,L){this.f(w,{value:f,type:k.EnvironmentVariableMutatorType.Append,options:b??{applyAtProcessCreation:!0},scope:L})}prepend(w,f,b,L){this.f(w,{value:f,type:k.EnvironmentVariableMutatorType.Prepend,options:b??{applyAtProcessCreation:!0},scope:L})}f(w,f){if(f.options&&f.options.applyAtProcessCreation===!1&&!f.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const b=this.g(w,f.scope),L=this.map.get(b),O=f.options?{applyAtProcessCreation:f.options.applyAtProcessCreation??!1,applyAtShellIntegration:f.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!L||L.value!==f.value||L.type!==f.type||L.options?.applyAtProcessCreation!==O.applyAtProcessCreation||L.options?.applyAtShellIntegration!==O.applyAtShellIntegration||L.scope?.workspaceFolder?.index!==f.scope?.workspaceFolder?.index){const T=this.g(w,f.scope),F={variable:w,...f,options:O};this.map.set(T,F),this.d.fire()}}get(w,f){const b=this.g(w,f),L=this.map.get(b);return L?p(L):void 0}g(w,f){const b=this.h(f);return b.length?`${w}:::${b}`:w}h(w){return this.j(w?.workspaceFolder)??""}j(w){return w?w.uri.toString():void 0}getVariableMap(w){const f=new Map;for(const[b,L]of this.map)this.h(L.scope)===this.h(w)&&f.set(L.variable,p(L));return f}delete(w,f){const b=this.g(w,f);this.map.delete(b),this.d.fire()}clear(w){if(w?.workspaceFolder){for(const[f,b]of this.map)b.scope?.workspaceFolder?.index===w.workspaceFolder.index&&this.map.delete(f);this.k(w)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(w,f){const b=this.h(f),L=this.descriptionMap.get(b);if(!L||L.description!==w){let O;typeof w=="string"?O=w:O=w?.value.split(`

`)[0];const T={description:O,scope:f};this.descriptionMap.set(b,T),this.d.fire()}}getDescription(w){const f=this.h(w);return this.descriptionMap.get(f)?.description}k(w){const f=this.h(w);this.descriptionMap.delete(f)}}class r{get persistent(){return this.b.persistent}set persistent(w){this.b.persistent=w}get onDidChangeCollection(){return this.a&&this.a.event}constructor(w,f){this.b=w,this.d=f,this.a=new y.$Ld}getScoped(w){return this.b.getScopedEnvironmentVariableCollection(w)}replace(w,f,b){this.b.replace(w,f,b,this.d)}append(w,f,b){this.b.append(w,f,b,this.d)}prepend(w,f,b){this.b.prepend(w,f,b,this.d)}get(w){return this.b.get(w,this.d)}forEach(w,f){this.b.getVariableMap(this.d).forEach((b,L)=>w.call(f,L,b,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(w){this.b.delete(w,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(w){this.b.setDescription(w,this.d)}get description(){return this.b.getDescription(this.d)}}let i=class extends t{constructor(w,f){super(!1,w,f)}createTerminal(w,f,b){throw new P.$0}createTerminalFromOptions(w,f){throw new P.$0}};e.$$bc=i,e.$$bc=i=Ke([We(0,u.$tM),We(1,A.$0L)],i);function a(I){if(!(!I||typeof I=="string"))return"id"in I?{id:I.id,color:I.color}:I}function h(I){return E.ThemeColor.isThemeColor(I)?I:void 0}function p(I){const w={...I};return delete w.scope,w.options=w.options??void 0,delete w.variable,w}});var Be=this&&this.__classPrivateFieldGet||function(ne,e,y,M){if(y==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!M:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return y==="m"?M:y==="a"?M.call(ne):M?M.value:e.get(ne)},et=this&&this.__classPrivateFieldSet||function(ne,e,y,M,l){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!l:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?l.call(ne,y):l?l.value=y:e.set(ne,y),y};define(Se[327],De([1,0,119,9,22,21,4,75,51,3,23,18,31,6,20,146,13,7,68,110,88,27]),function(ne,e,y,M,l,R,A,m,k,$,P,C,v,S,D,E,s,c,u,o,g,d){"use strict";var t,n;Object.defineProperty(e,"__esModule",{value:!0}),e.$idc=e.$hdc=e.$gdc=e.$fdc=void 0;let r=class{constructor(N,j,z){this.k=z,this.d=new A.$Ld,this.f=new Map,this.onResultsChanged=this.d.event,this.results=[],this.g=N.getProxy(S.$9J.MainThreadTesting),this.j=new O(this.g),this.h=new p(this.g),j.registerArgumentProcessor({processArgument:B=>{switch(B?.$mid){case 16:{const ae=B,X=ae.tests[ae.tests.length-1].item.extId;return this.f.get(u.$2I.root(X))?.collection.tree.get(X)?.actual??(0,E.$jM)(B)}case 18:{const{extId:ae,message:X}=B;return{test:this.f.get(u.$2I.root(ae))?.collection.tree.get(ae)?.actual,message:s.TestMessage.to(X)}}default:return B}}}),j.registerCommand(!1,"testing.getExplorerSelection",async()=>{const B=await j.executeCommand("_testing.getExplorerSelection"),ae=X=>{const Q=this.f.get(u.$2I.root(X));if(Q)return u.$2I.isRoot(X)?Q.controller:Q.collection.tree.get(X)?.actual};return{include:B?.include.map(ae).filter(C.$Ef)||[],exclude:B?.exclude.map(ae).filter(C.$Ef)||[]}})}createTestController(N,j,z,B){if(this.f.has(j))throw new Error(`Attempt to insert a duplicate controller with ID "${j}"`);const ae=new $.$Pc,X=ae.add(new E.$mM(j,z,this.k));X.root.label=z;const Q=new Map,H=this.g,te={items:X.root.children,get label(){return z},set label(le){z=le,X.root.label=le,H.$updateController(j,{label:z})},get refreshHandler(){return B},set refreshHandler(le){B=le,H.$updateController(j,{canRefresh:!!le})},get id(){return j},createRunProfile:(le,ye,de,V,J,ee)=>{let Y=(0,k.$zi)(le);for(;Q.has(Y);)Y++;return new T(this.g,Q,j,Y,le,ye,de,V,J,ee)},createTestItem(le,ye,de){return new E.$kM(j,le,ye,de)},createTestRun:(le,ye,de=!0)=>this.h.createTestRun(N,j,X,le,ye,de),invalidateTestResults:le=>{if(le===void 0)this.g.$markTestRetired(void 0);else{const ye=le instanceof Array?le:[le];this.g.$markTestRetired(ye.map(de=>u.$2I.fromExtHostTestItem(de,j).toString()))}},set resolveHandler(le){X.resolveHandler=le},get resolveHandler(){return X.resolveHandler},dispose:()=>{ae.dispose()}};H.$registerTestController(j,z,!!B),ae.add((0,$.$Oc)(()=>H.$unregisterTestController(j)));const me={controller:te,collection:X,profiles:Q,extension:N};return this.f.set(j,me),ae.add((0,$.$Oc)(()=>this.f.delete(j))),ae.add(X.onDidGenerateDiff(le=>H.$publishDiff(j,le.map(g.TestsDiffOp.serialize)))),te}createTestObserver(){return this.j.checkout()}async runTests(N,j=R.CancellationToken.None){const z=I(N);if(!z)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const B=this.f.get(z.controllerId);if(!B)throw new Error("Controller not found");await this.g.$runTests({isUiTriggered:!1,targets:[{testIds:N.include?.map(ae=>u.$2I.fromExtHostTestItem(ae,B.collection.root.id).toString())??[B.collection.root.id],profileGroup:F[z.kind],profileId:z.profileId,controllerId:z.controllerId}],exclude:N.exclude?.map(ae=>ae.id)},j)}$syncTests(){for(const{collection:N}of this.f.values())N.flushDiff();return Promise.resolve()}$provideFileCoverage(N,j,z){return(0,y.$pb)(this.h.trackers,ae=>ae.id===N?ae.getCoverage(j):void 0)?.provideFileCoverage(z)??Promise.resolve([])}$resolveFileCoverage(N,j,z,B){return(0,y.$pb)(this.h.trackers,X=>X.id===N?X.getCoverage(j):void 0)?.resolveFileCoverage(z,B)??Promise.resolve([])}$configureRunProfile(N,j){this.f.get(N)?.profiles.get(j)?.configureHandler?.()}async $refreshTests(N,j){await this.f.get(N)?.controller.refreshHandler?.(j)}$publishTestResults(N){this.results=Object.freeze(N.map(j=>(0,P.$Ym)(s.TestResults.to(j))).concat(this.results).sort((j,z)=>z.completedAt-j.completedAt).slice(0,32)),this.d.fire()}async $expandTest(N,j){const z=this.f.get(u.$2I.fromString(N).controllerId)?.collection;z&&(await z.expand(N,j<0?1/0:j),z.flushDiff())}$acceptDiff(N){this.j.applyDiff(N.map(g.TestsDiffOp.deserialize))}async $runControllerTests(N,j){return Promise.all(N.map(z=>this.l(z,!1,j)))}async $startContinuousRun(N,j){const z=new R.$Vd(j),B=await Promise.all(N.map(ae=>this.l(ae,!0,z.token)));return!j.isCancellationRequested&&!B.some(ae=>ae.error)&&await new Promise(ae=>j.onCancellationRequested(ae)),z.dispose(!0),B}async l(N,j,z){const B=this.f.get(N.controllerId);if(!B)return{};const{collection:ae,profiles:X,extension:Q}=B,H=X.get(N.profileId);if(!H)return{};const te=N.testIds.map(de=>ae.tree.get(de)).filter(C.$Ef),me=N.excludeExtIds.map(de=>B.collection.tree.get(de)).filter(C.$Ef).filter(de=>te.some(V=>V.fullId.compare(de.fullId)===2));if(!te.length)return{};const le=new c.$GL(te.some(de=>de.actual instanceof E.$lM)?void 0:te.map(de=>de.actual),me.map(de=>de.actual),H,j),ye=(0,g.$4I)(N)&&this.h.prepareForMainThreadTestRun(le,w.fromInternal(N,B.collection),Q,z);try{return await H.runHandler(le,z),{}}catch(de){return{error:String(de)}}finally{ye&&(ye.hasRunningTasks&&!z.isCancellationRequested&&await A.Event.toPromise(ye.onEnd),ye.dispose())}}$cancelExtensionTestRun(N){N===void 0?this.h.cancelAllRuns():this.h.cancelRunById(N)}};e.$fdc=r,e.$fdc=r=Ke([We(0,D.$0L)],r);const i=1e4;var a;(function(U){U[U.Running=0]="Running",U[U.Cancelling=1]="Cancelling",U[U.Ended=2]="Ended"})(a||(a={}));class h extends $.$Qc{get hasRunningTasks(){return this.g.size>0}get id(){return this.s.id}constructor(N,j,z,B){super(),this.s=N,this.u=j,this.w=z,this.f=0,this.g=new Map,this.h=new Set,this.m=this.B(new A.$Ld),this.onEnd=this.m.event,this.j=this.B(new R.$Vd(B));const ae=this.B(new M.$3g(()=>this.y(),i));this.B(this.j.token.onCancellationRequested(()=>ae.schedule()))}cancel(){this.f===0?(this.j.cancel(),this.f=1):this.f===1&&this.y()}getCoverage(N){return this.g.get(N)?.coverage}createRun(N){const j=this.s.id,z=this.s.controllerId,B=(0,v.$bg)(),ae=new f(this.u,j,B),X=me=>(le,...ye)=>{if(H){console.warn(`Setting the state of test "${le.id}" is a no-op after the run ends.`);return}this.s.isIncluded(le)&&(this.C(le),me(le,...ye))},Q=(me,le)=>{const ye=le instanceof Array?le.map(s.TestMessage.from):[s.TestMessage.from(le)];if(ye.some(de=>de.contextValue!==void 0)&&(0,d.$8E)(this.w,"testMessageContextValue"),me.uri&&me.range){const de={range:s.Range.from(me.range),uri:me.uri};for(const V of ye)V.location=V.location||de}this.u.$appendTestMessagesInRun(j,B,u.$2I.fromExtHostTestItem(me,z).toString(),ye)};let H=!1;const te={isPersisted:this.s.isPersisted,token:this.j.token,name:N,get coverageProvider(){return ae.coverageProvider},set coverageProvider(me){ae.coverageProvider=me},enqueued:X(me=>{this.u.$updateTestStateInRun(j,B,u.$2I.fromExtHostTestItem(me,z).toString(),1)}),skipped:X(me=>{this.u.$updateTestStateInRun(j,B,u.$2I.fromExtHostTestItem(me,z).toString(),5)}),started:X(me=>{this.u.$updateTestStateInRun(j,B,u.$2I.fromExtHostTestItem(me,z).toString(),2)}),errored:X((me,le,ye)=>{Q(me,le),this.u.$updateTestStateInRun(j,B,u.$2I.fromExtHostTestItem(me,z).toString(),6,ye)}),failed:X((me,le,ye)=>{Q(me,le),this.u.$updateTestStateInRun(j,B,u.$2I.fromExtHostTestItem(me,z).toString(),4,ye)}),passed:X((me,le)=>{this.u.$updateTestStateInRun(j,B,u.$2I.fromExtHostTestItem(me,this.s.controllerId).toString(),3,le)}),appendOutput:(me,le,ye)=>{H||(ye&&(this.s.isIncluded(ye)?this.C(ye):ye=void 0),this.u.$appendOutputToRun(j,B,l.$_d.fromString(me),le&&s.location.from(le),ye&&u.$2I.fromExtHostTestItem(ye,z).toString()))},end:()=>{H||(H=!0,this.u.$finishedTestRunTask(j,B),this.g.delete(B),this.g.size||this.z())}};return this.g.set(B,{run:te,coverage:ae}),this.u.$startedTestRunTask(j,{id:B,name:N,running:!0}),te}y(){for(const{run:N}of this.g.values())N.end()}z(){this.f!==2&&(this.f=2,this.m.fire())}C(N){if(!(N instanceof E.$kM))throw new o.$2L(N.id);if(this.h.has(u.$2I.fromExtHostTestItem(N,this.s.controllerId).toString()))return;const j=[],z=this.s.colllection.root;for(;;){const B=s.TestItem.from(N);if(j.unshift(B),this.h.has(B.extId)||(this.h.add(B.extId),N===z))break;N=N.parent||z}this.u.$addTestsToRun(this.s.controllerId,this.s.id,j)}dispose(){this.z(),super.dispose()}}class p{get trackers(){return this.d.values()}constructor(N){this.f=N,this.d=new Map}prepareForMainThreadTestRun(N,j,z,B){return this.g(N,j,z,B)}cancelRunById(N){for(const j of this.d.values())if(j.id===N){j.cancel();return}}cancelAllRuns(){for(const N of this.d.values())N.cancel()}createTestRun(N,j,z,B,ae,X){const Q=this.d.get(B);if(Q)return Q.createRun(ae);const H=w.fromPublic(j,z,B,X),te=I(B);this.f.$startedExtensionTestRun({controllerId:j,continuous:!!B.continuous,profile:te&&{group:F[te.kind],id:te.profileId},exclude:B.exclude?.map(le=>u.$2I.fromExtHostTestItem(le,z.root.id).toString())??[],id:H.id,include:B.include?.map(le=>u.$2I.fromExtHostTestItem(le,z.root.id).toString())??[z.root.id],persist:X});const me=this.g(B,H,N);return A.Event.once(me.onEnd)(()=>{this.f.$finishedExtensionTestRun(H.id),me.dispose()}),me.createRun(ae)}g(N,j,z,B){const ae=new h(j,this.f,z,B);return this.d.set(N,ae),A.Event.once(ae.onEnd)(()=>this.d.delete(N)),ae}}e.$gdc=p;const I=U=>{if(U.profile){if(!(U.profile instanceof T))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return U.profile}};class w{static fromPublic(N,j,z,B){return new w(N,(0,v.$bg)(),z.include?.map(ae=>u.$2I.fromExtHostTestItem(ae,N).toString())??[N],z.exclude?.map(ae=>u.$2I.fromExtHostTestItem(ae,N).toString())??[],B,j)}static fromInternal(N,j){return new w(N.controllerId,N.runId,N.testIds,N.excludeExtIds,!0,j)}constructor(N,j,z,B,ae,X){this.controllerId=N,this.id=j,this.isPersisted=ae,this.colllection=X,this.d=z.map(Q=>Q+"\0"),this.f=B.map(Q=>Q+"\0")}isIncluded(N){const j=u.$2I.fromExtHostTestItem(N,this.controllerId).toString()+"\0";for(const z of this.f)if(j===z||j.startsWith(z))return!1;for(const z of this.d)if(j===z||j.startsWith(z))return!0;return!1}}e.$hdc=w;class f{set coverageProvider(N){if(this.d)throw new Error("The TestCoverageProvider cannot be replaced after being provided");N&&(this.d=N,this.g.$signalCoverageAvailable(this.h,this.j))}get coverageProvider(){return this.d}constructor(N,j,z){this.g=N,this.h=j,this.j=z}async provideFileCoverage(N){if(!this.d)return[];this.f||(this.f=(async()=>this.d.provideFileCoverage(N))());try{return(await this.f)?.map(s.TestCoverage.fromFile)??[]}catch(j){throw this.f=void 0,j}}async resolveFileCoverage(N,j){const z=await this.f;let B=z?.[N];return!this.d||!z||!B?[]:(B.detailedCoverage||(B=z[N]=await this.d.resolveFileCoverage?.(B,j)??B),B.detailedCoverage?.map(s.TestCoverage.fromDetailed)??[])}}class b{get isEmpty(){return this.d.size===0&&this.g.size===0&&this.f.size===0}constructor(N){this.j=N,this.d=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(N){this.d.add(N)}update(N){Object.assign(N.revived,s.TestItem.toPlain(N.item)),this.d.has(N)||this.f.add(N)}remove(N){if(this.d.has(N)){this.d.delete(N);return}this.f.delete(N);const j=u.$2I.parentId(N.item.extId);if(j&&this.h.has(j.toString())){this.h.add(N.item.extId);return}this.g.add(N)}getChangeEvent(){const{d:N,f:j,g:z}=this;return{get added(){return[...N].map(B=>B.revived)},get updated(){return[...j].map(B=>B.revived)},get removed(){return[...z].map(B=>B.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class L extends g.$9I{constructor(){super(...arguments),this.s=new A.$Ld,this.onDidChangeTests=this.s.event}get rootTests(){return this.g}getMirroredTestDataById(N){return this.f.get(N)}getMirroredTestDataByReference(N){return this.f.get(N.id)}q(N,j){return{...N,revived:s.TestItem.toPlain(N.item),depth:j?j.depth+1:0,children:new Set}}p(){return new b(this.s)}}class O{constructor(N){this.f=N}checkout(){this.d||(this.d=this.g());const N=this.d;return N.observers++,{onDidChangeTest:N.tests.onDidChangeTests,get tests(){return[...N.tests.rootTests].map(j=>j.revived)},dispose:(0,m.$bb)(()=>{--N.observers===0&&(this.f.$unsubscribeFromDiffs(),this.d=void 0)})}}getMirroredTestDataByReference(N){return this.d?.tests.getMirroredTestDataByReference(N)}applyDiff(N){this.d?.tests.apply(N)}g(){const N=new L;return this.f.$subscribeToDiffs(),{observers:0,tests:N}}}class T{get label(){return this.f}set label(N){N!==this.f&&(this.f=N,Be(this,t,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:N}))}get supportsContinuousRun(){return this.h}set supportsContinuousRun(N){N!==this.h&&(this.h=N,Be(this,t,"f").$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:N}))}get isDefault(){return this.g}set isDefault(N){N!==this.g&&(this.g=N,Be(this,t,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:N}))}get tag(){return this._tag}set tag(N){N?.id!==this._tag?.id&&(this._tag=N,Be(this,t,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:N?s.TestTag.namespace(this.controllerId,N.id):null}))}get configureHandler(){return this.d}set configureHandler(N){N!==this.d&&(this.d=N,Be(this,t,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!N}))}constructor(N,j,z,B,ae,X,Q,H=!1,te=void 0,me=!1){this.controllerId=z,this.profileId=B,this.f=ae,this.kind=X,this.runHandler=Q,this.g=H,this._tag=te,this.h=me,t.set(this,void 0),n.set(this,void 0),et(this,t,N,"f"),et(this,n,j,"f"),j.set(B,this);const le=F[X];if(typeof le!="number")throw new Error(`Unknown TestRunProfile.group ${X}`);Be(this,t,"f").$publishTestRunProfile({profileId:B,controllerId:z,tag:te?s.TestTag.namespace(this.controllerId,te.id):null,label:ae,group:le,isDefault:H,hasConfigurationHandler:!1,supportsContinuousRun:me})}dispose(){Be(this,n,"f")?.delete(this.profileId)&&(et(this,n,void 0,"f"),Be(this,t,"f").$removeTestProfile(this.controllerId,this.profileId))}}e.$idc=T,t=new WeakMap,n=new WeakMap;const F={[c.TestRunProfileKind.Coverage]:8,[c.TestRunProfileKind.Debug]:4,[c.TestRunProfileKind.Run]:2}}),define(Se[328],De([1,0,19,8,4,6,147,13,7]),function(ne,e,y,M,l,R,A,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xcc=void 0;class ${constructor(C,v){this.i=v,this.a=new l.$Ld({onListenerError:M.$Z}),this.b=new l.$Ld({onListenerError:M.$Z}),this.c=new l.$Ld({onListenerError:M.$Z}),this.d=new l.$Ld({onListenerError:M.$Z}),this.f=new l.$Ld({onListenerError:M.$Z}),this.g=new l.$Ld({onListenerError:M.$Z}),this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=C.getProxy(R.$9J.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(S=>this.g.fire(S)),this.i.onDidChangeActiveTextEditor(S=>this.f.fire(S))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(C){const v=this.i.allEditors();return C?v:v.map(S=>S.value)}async showTextDocument(C,v,S){let D;typeof v=="number"?D={position:m.ViewColumn.from(v),preserveFocus:S}:typeof v=="object"?D={position:m.ViewColumn.from(v.viewColumn),preserveFocus:v.preserveFocus,selection:typeof v.selection=="object"?m.Range.from(v.selection):void 0,pinned:typeof v.preview=="boolean"?!v.preview:void 0}:D={preserveFocus:!1};const E=await this.h.$tryShowTextDocument(C.uri,D),s=E&&this.i.getEditor(E);if(s)return s.value;throw E?new Error(`Could NOT open editor for "${C.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${C.uri.toString()}".`)}createTextEditorDecorationType(C,v){return new A.$eM(this.h,C,v).value}$acceptEditorPropertiesChanged(C,v){const S=this.i.getEditor(C);if(!S)throw new Error("unknown text editor");if(v.options&&S._acceptOptions(v.options),v.selections){const D=v.selections.selections.map(m.Selection.to);S._acceptSelections(D)}if(v.visibleRanges){const D=y.$Fb(v.visibleRanges.map(m.Range.to));S._acceptVisibleRanges(D)}if(v.options&&this.b.fire({textEditor:S.value,options:{...v.options,lineNumbers:m.TextEditorLineNumbersStyle.to(v.options.lineNumbers)}}),v.selections){const D=k.TextEditorSelectionChangeKind.fromValue(v.selections.source),E=v.selections.selections.map(m.Selection.to);this.a.fire({textEditor:S.value,selections:E,kind:D})}if(v.visibleRanges){const D=y.$Fb(v.visibleRanges.map(m.Range.to));this.c.fire({textEditor:S.value,visibleRanges:D})}}$acceptEditorPositionData(C){for(const v in C){const S=this.i.getEditor(v);if(!S)throw new Error("Unknown text editor");const D=m.ViewColumn.to(C[v]);S.value.viewColumn!==D&&(S._acceptViewColumn(D),this.d.fire({textEditor:S.value,viewColumn:D}))}}getDiffInformation(C){return Promise.resolve(this.h.$getDiffInformation(C))}}e.$xcc=$}),define(Se[329],De([1,0,2,5,6,3,7,13,25,18]),function(ne,e,y,M,l,R,A,m,k,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$adc=e.$_cc=void 0,e.$_cc=(0,M.$Lh)("IExtHostTimeline");class P{constructor(S,D){this.b=new Map,this.c=new Map,this.a=S.getProxy(l.$9J.MainThreadTimeline),D.registerArgumentProcessor({processArgument:(E,s)=>{if(E&&E.$mid===12)if(this.b.get(E.source)&&k.$Xl.equals(s,this.b.get(E.source)?.extension)){const c=E.uri===void 0?void 0:y.URI.revive(E.uri);return this.c.get(E.source)?.get(C(c))?.get(E.handle)}else return;return E}})}async $getTimeline(S,D,E,s){return this.b.get(S)?.provider.provideTimeline(y.URI.revive(D),E,s)}registerTimelineProvider(S,D,E,s){const c=new R.$Pc,u=this.d(D.id,s,c).bind(this);let o;D.onDidChange&&(o=D.onDidChange(d=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...d,id:D.id}),this));const g=this.c;return this.f({...D,scheme:S,onDidChange:void 0,async provideTimeline(d,t,n){t?.resetCache&&(c.clear(),g.get(D.id)?.clear());const r=await D.provideTimeline(d,t,n);if(r==null)return;const i=u(d,t);return{...r,source:D.id,items:r.items.map(i)}},dispose(){for(const d of g.values())d.get(D.id)?.clear();o?.dispose(),c.dispose()}},E)}d(S,D,E){return(s,c)=>{let u;if(c?.cacheResults){let o=this.c.get(S);o===void 0&&(o=new Map,this.c.set(S,o));const g=C(s);u=o.get(g),u===void 0&&(u=new Map,o.set(g,u))}return o=>{const{iconPath:g,...d}=o,t=`${S}|${o.id??o.timestamp}`;u?.set(t,o);let n,r,i;o.iconPath&&(g instanceof A.$5K?i={id:g.id,color:g.color}:y.URI.isUri(g)?(n=g,r=g):{light:n,dark:r}=g);let a;return A.$yK.isMarkdownString(d.tooltip)?a=m.MarkdownString.from(d.tooltip):(0,$.$wf)(d.tooltip)?a=d.tooltip:A.$yK.isMarkdownString(d.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),a=m.MarkdownString.from(d.detail)):(0,$.$wf)(d.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),a=d.detail),{...d,id:d.id??void 0,handle:t,source:S,command:o.command?D.toInternal(o.command,E):void 0,icon:n,iconDark:r,themeIcon:i,tooltip:a,accessibilityInformation:o.accessibilityInformation}}}}f(S,D){if(this.b.get(S.id))throw new Error(`Timeline Provider ${S.id} already exists.`);return this.a.$registerTimelineProvider({id:S.id,label:S.label,scheme:S.scheme}),this.b.set(S.id,{provider:S,extension:D}),(0,R.$Oc)(()=>{for(const s of this.c.values())s.get(S.id)?.clear();this.b.delete(S.id),this.a.$unregisterTimelineProvider(S.id),S.dispose()})}}e.$adc=P;function C(v){return v?.toString()}}),define(Se[73],De([1,0,21,4,3,213,5,14,86,6,26,20,7]),function(ne,e,y,M,l,R,A,m,k,$,P,C,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lsb=e.$ksb=e.TunnelDtoConverter=void 0;class S extends k.$$u{}var D;(function(s){function c(o){return{remoteAddress:o.remoteAddress,localAddress:o.localAddress,public:!!o.public,privacy:o.privacy??(o.public?k.TunnelPrivacyId.Public:k.TunnelPrivacyId.Private),protocol:o.protocol}}s.fromApiTunnel=c;function u(o){return{remoteAddress:{host:o.tunnelRemoteHost,port:o.tunnelRemotePort},localAddress:o.localAddress,public:o.privacy!==k.TunnelPrivacyId.ConstantPrivate&&o.privacy!==k.TunnelPrivacyId.ConstantPrivate,privacy:o.privacy,protocol:o.protocol}}s.fromServiceTunnel=u})(D||(e.TunnelDtoConverter=D={})),e.$ksb=(0,A.$Lh)("IExtHostTunnelService");let E=class extends l.$Qc{constructor(c,u,o){super(),this.s=o,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new M.$Ld,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=c.getProxy($.$9J.MainThreadTunnelService)}async openTunnel(c,u){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${c.identifier.value} called openTunnel API for ${u.remoteAddress.host}:${u.remoteAddress.port}.`);const o=await this.a.$openTunnel(u,c.displayName);if(o){const g=new S(o.remoteAddress,o.localAddress,()=>this.a.$closeTunnel(o.remoteAddress));return this.B(g),g}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(c,u){const o=this.u();return this.r.set(o,{selector:c,provider:u}),this.a.$registerPortsAttributesProvider(c,o),new v.$$J(()=>{this.r.delete(o),this.a.$unregisterPortsAttributesProvider(o)})}async $providePortAttributes(c,u,o,g,d){const t=[];for(const r of c){const i=this.r.get(r);if(!i)return[];t.push(...await Promise.all(u.map(async a=>{let h;try{h=await i.provider.providePortAttributes({port:a,pid:o,commandLine:g},d)}catch{h=await i.provider.providePortAttributes(a,o,g,d)}return{providedAttributes:h,port:a}})))}const n=t.filter(r=>!!r.providedAttributes);return n.length>0?n.map(r=>({autoForwardAction:r.providedAttributes.autoForwardAction,port:r.port})):[]}async $registerCandidateFinder(c){}registerTunnelProvider(c,u){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(g,d)=>await c.provideTunnel(g,d,new y.$Vd().token)??void 0;const o=u.tunnelFeatures?{elevation:!!u.tunnelFeatures?.elevation,privacyOptions:u.tunnelFeatures?.privacyOptions}:void 0;return this.a.$setTunnelProvider(o),Promise.resolve((0,l.$Oc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(c,u){if(c){c.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(c.candidatePortSource),c.showCandidatePort&&(this.f=c.showCandidatePort,this.a.$setCandidateFilter());const o=c.tunnelFactory??(u?this.w(u):void 0);if(o){this.b=o;let g=c.tunnelFeatures?.privacyOptions??[];c.tunnelFeatures?.public&&g.length===0&&(g=[{id:"private",label:R.localize(0,null),themeIcon:"lock"},{id:"public",label:R.localize(1,null),themeIcon:"eye"}]);const d=c.tunnelFeatures?{elevation:!!c.tunnelFeatures?.elevation,public:!!c.tunnelFeatures?.public,privacyOptions:g}:void 0;this.a.$setTunnelProvider(d)}}else this.b=void 0;return(0,l.$Oc)(()=>{this.b=void 0})}w(c){}async $closeTunnel(c,u){if(this.g.has(c.host)){const o=this.g.get(c.host);o.has(c.port)&&(u&&o.get(c.port).disposeListener.dispose(),await o.get(c.port).tunnel.dispose(),o.delete(c.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(c,u){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const o=this.b(c,u);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),o!==void 0){const g=await o;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),g===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(c.remoteAddress.host)||this.g.set(c.remoteAddress.host,new Map);const d=this.B(g.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(g.remoteAddress))));return this.g.get(c.remoteAddress.host).set(c.remoteAddress.port,{tunnel:g,disposeListener:d}),D.fromApiTunnel(g)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(o){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),o instanceof Error)return o.message}}async $applyCandidateFilter(c){const u=await Promise.all(c.map(g=>this.f(g.host,g.port,g.detail??""))),o=c.filter((g,d)=>u[d]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${c.map(g=>g.port).join(", ")} to ${o.map(g=>g.port).join(", ")}`),o}};e.$lsb=E,e.$lsb=E=Ke([We(0,C.$0L),We(1,P.$nM),We(2,m.$6i)],E)}),define(Se[330],De([1,0,3,17,2,6]),function(ne,e,y,M,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jdc=void 0;class A{constructor(k){this.c=new Map,this.b=k.getProxy(R.$9J.MainThreadUriOpeners)}registerExternalUriOpener(k,$,P,C){if(this.c.has($))throw new Error(`Opener with id '${$}' already registered`);const v=C.schemes.find(S=>!A.a.has(S));if(v)throw new Error(`Scheme '${v}' is not supported. Only http and https are currently supported.`);return this.c.set($,P),this.b.$registerUriOpener($,C.schemes,k,C.label),(0,y.$Oc)(()=>{this.c.delete($),this.b.$unregisterUriOpener($)})}async $canOpenUri(k,$,P){const C=this.c.get(k);if(!C)throw new Error(`Unknown opener with id: ${k}`);const v=l.URI.revive($);return C.canOpenExternalUri(v,P)}async $openUri(k,$,P){const C=this.c.get(k);if(!C)throw new Error(`Unknown opener id: '${k}'`);return C.openExternalUri(l.URI.revive($.resolvedUri),{sourceUri:l.URI.revive($.sourceUri)},P)}}e.$jdc=A,A.a=new Set([M.Schemas.http,M.Schemas.https])}),define(Se[331],De([1,0,6,2,3,8,25]),function(ne,e,y,M,l,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zcc=void 0;class m{constructor($){this.c=new A.$Yl,this.d=new Map,this.b=$.getProxy(y.$9J.MainThreadUrls)}registerUriHandler($,P){const C=$.identifier;if(this.c.has(C))throw new Error(`Protocol handler already registered for extension ${C}`);const v=m.a++;return this.c.add(C),this.d.set(v,P),this.b.$registerUriHandler(v,C,$.displayName||$.name),(0,l.$Oc)(()=>{this.c.delete(C),this.d.delete(v),this.b.$unregisterUriHandler(v)})}$handleExternalUri($,P){const C=this.d.get($);if(!C)return Promise.resolve(void 0);try{C.handleUri(M.URI.revive(P))}catch(v){(0,R.$Y)(v)}return Promise.resolve(void 0)}async createAppUri($){return M.URI.revive(await this.b.$createAppUri($))}}e.$zcc=m,m.a=0});var et=this&&this.__classPrivateFieldSet||function(ne,e,y,M,l){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!l:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?l.call(ne,y):l?l.value=y:e.set(ne,y),y},Be=this&&this.__classPrivateFieldGet||function(ne,e,y,M){if(y==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!M:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return y==="m"?M:y==="a"?M.call(ne):M?M.value:e.get(ne)};define(Se[92],De([1,0,4,3,17,23,2,228,265,111,6]),function(ne,e,y,M,l,R,A,m,k,$,P){"use strict";var C,v,S,D,E,s,c,u,o,g,d,t,n;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ecc=e.$Dcc=e.$Ccc=e.$Bcc=e.$Acc=void 0;class r{constructor(L,O,T,F,U,N,j){C.set(this,void 0),v.set(this,void 0),S.set(this,void 0),D.set(this,void 0),E.set(this,void 0),s.set(this,void 0),c.set(this,""),u.set(this,void 0),o.set(this,!1),g.set(this,!1),d.set(this,void 0),t.set(this,void 0),this._onMessageEmitter=new y.$Ld,this.onDidReceiveMessage=this._onMessageEmitter.event,n.set(this,new y.$Ld),this._onDidDispose=Be(this,n,"f").event,et(this,C,L,"f"),et(this,v,O,"f"),et(this,u,T,"f"),et(this,D,F,"f"),et(this,E,U,"f"),et(this,s,N,"f"),et(this,d,i(N),"f"),et(this,t,a(N),"f"),et(this,S,j,"f")}dispose(){et(this,o,!0,"f"),Be(this,n,"f").fire(),Be(this,n,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(L){return et(this,g,!0,"f"),(0,$.$Yob)(L,Be(this,D,"f"))}get cspSource(){const L=Be(this,s,"f").extensionLocation;if(L.scheme===l.Schemas.https||L.scheme===l.Schemas.http){let O=L.toString();return O.endsWith("/")||(O+="/"),O+" "+$.$Xob}return $.$Xob}get html(){return this.a(),Be(this,c,"f")}set html(L){this.a(),Be(this,c,"f")!==L&&(et(this,c,L,"f"),Be(this,t,"f")&&!Be(this,g,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(L)&&(et(this,g,!0,"f"),Be(this,S,"f").report("Webview vscode-resource: uris",Be(this,s,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Be(this,v,"f").$setHtml(Be(this,C,"f"),this.b(L)))}get options(){return this.a(),Be(this,u,"f")}set options(L){this.a(),R.$2m(Be(this,u,"f"),L)||Be(this,v,"f").$setOptions(Be(this,C,"f"),I(Be(this,s,"f"),Be(this,E,"f"),L)),et(this,u,L,"f")}async postMessage(L){if(Be(this,o,"f"))return!1;const O=(0,k.$lcb)(L,{serializeBuffersForPostMessage:Be(this,d,"f")});return Be(this,v,"f").$postMessage(Be(this,C,"f"),O.message,...O.buffers)}a(){if(Be(this,o,"f"))throw new Error("Webview is disposed")}b(L){if(!Be(this,t,"f"))return L;const O=Be(this,s,"f").extensionLocation?.scheme===l.Schemas.vscodeRemote,T=Be(this,s,"f").extensionLocation.scheme===l.Schemas.vscodeRemote?Be(this,s,"f").extensionLocation.authority:void 0;return L.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(F,U,N,j,z,B)=>{const ae=A.URI.from({scheme:j||"file",path:decodeURIComponent(z)}),X=(0,$.$Yob)(ae,{isRemote:O,authority:T}).toString();return`${U}${X}${B}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(F,U,N,j,z,B)=>{const ae=A.URI.from({scheme:j||"file",path:decodeURIComponent(z)}),X=(0,$.$Yob)(ae,{isRemote:O,authority:T}).toString();return`${U}${X}${B}`})}}e.$Acc=r,C=new WeakMap,v=new WeakMap,S=new WeakMap,D=new WeakMap,E=new WeakMap,s=new WeakMap,c=new WeakMap,u=new WeakMap,o=new WeakMap,g=new WeakMap,d=new WeakMap,t=new WeakMap,n=new WeakMap;function i(b){try{const L=(0,m.$Fo)((0,m.$Eo)(b.engines.vscode));return!!L&&L.majorBase>=1&&L.minorBase>=57}catch{return!1}}e.$Bcc=i;function a(b){try{const L=(0,m.$Fo)((0,m.$Eo)(b.engines.vscode));return L?L.majorBase<1||L.majorBase===1&&L.minorBase<60:!1}catch{return!1}}class h extends M.$Qc{constructor(L,O,T,F,U){super(),this.c=O,this.f=T,this.g=F,this.h=U,this.b=new Map,this.a=L.getProxy(P.$9J.MainThreadWebviews)}dispose(){super.dispose();for(const L of this.b.values())L.dispose();this.b.clear()}$onMessage(L,O,T){const F=this.j(L);if(F){const{message:U}=(0,k.$mcb)(O,T.value);F._onMessageEmitter.fire(U)}}$onMissingCsp(L,O){this.g.warn(`${O} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(L,O,T){const F=new r(L,this.a,w(O),this.c,this.f,T,this.h);this.b.set(L,F);const U=F._onDidDispose(()=>{U.dispose(),this.deleteWebview(L)});return F}deleteWebview(L){this.b.delete(L)}j(L){return this.b.get(L)}}e.$Ccc=h;function p(b){return{id:b.identifier,location:b.extensionLocation}}e.$Dcc=p;function I(b,L,O){return{enableCommandUris:O.enableCommandUris,enableScripts:O.enableScripts,enableForms:O.enableForms,portMapping:O.portMapping,localResourceRoots:O.localResourceRoots||f(b,L)}}e.$Ecc=I;function w(b){return{enableCommandUris:b.enableCommandUris,enableScripts:b.enableScripts,enableForms:b.enableForms,portMapping:b.portMapping,localResourceRoots:b.localResourceRoots?.map(L=>A.URI.from(L))}}function f(b,L){return[...(L?.getWorkspaceFolders()||[]).map(O=>O.uri),b.extensionLocation]}}),define(Se[332],De([1,0,21,51,3,17,24,2,13,92,87,6,7]),function(ne,e,y,M,l,R,A,m,k,$,P,C,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ddc=void 0;class S{constructor(n,r){this.document=n,this.b=r,this.a=1,this.c=new P.$wbc("custom documents")}addEdit(n){return this.c.add([n])}async undo(n,r){await this.f(n).undo(),r||this.disposeBackup()}async redo(n,r){await this.f(n).redo(),r||this.disposeBackup()}disposeEdits(n){for(const r of n)this.c.delete(r)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const n=d(this.document.uri)+this.a++;return(0,A.$sg)(this.b,n)}updateBackup(n){this.d?.delete(),this.d=n}disposeBackup(){this.d?.delete(),this.d=void 0}f(n){const r=this.c.get(n,0);if(!r)throw new Error("No edit found");return r}}class D{constructor(){this.a=new Map}get(n,r){return this.a.get(this.b(n,r))}add(n,r,i){const a=this.b(n,r.uri);if(this.a.has(a))throw new Error(`Document already exists for viewType:${n} resource:${r.uri}`);const h=new S(r,i);return this.a.set(a,h),h}delete(n,r){const i=this.b(n,r.uri);this.a.delete(i)}b(n,r){return`${n}@@@${r}`}}var E;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(E||(E={}));class s{constructor(){this.a=new Map}addTextProvider(n,r,i){return this.b(0,n,r,i)}addCustomProvider(n,r,i){return this.b(1,n,r,i)}get(n){return this.a.get(n)}b(n,r,i,a){if(this.a.has(r))throw new Error(`Provider for viewType:${r} already registered`);return this.a.set(r,{type:n,extension:i,provider:a}),new v.$$J(()=>this.a.delete(r))}}class c{constructor(n,r,i,a,h){this.d=r,this.f=i,this.g=a,this.h=h,this.b=new s,this.c=new D,this.a=n.getProxy(C.$9J.MainThreadCustomEditors)}registerCustomEditorProvider(n,r,i,a){const h=new l.$Pc;return o(i)?(h.add(this.b.addTextProvider(r,n,i)),this.a.$registerTextEditorProvider((0,$.$Dcc)(n),r,a.webviewOptions||{},{supportsMove:!!i.moveCustomTextEditor},(0,$.$Bcc)(n))):(h.add(this.b.addCustomProvider(r,n,i)),u(i)&&h.add(i.onDidChangeCustomDocument(p=>{const I=this.i(r,p.document.uri);if(g(p)){const w=I.addEdit(p);this.a.$onDidEdit(p.document.uri,r,w,p.label)}else this.a.$onContentChange(p.document.uri,r)})),this.a.$registerCustomEditorProvider((0,$.$Dcc)(n),r,a.webviewOptions||{},!!a.supportsMultipleEditorsPerDocument,(0,$.$Bcc)(n))),v.$$J.from(h,new v.$$J(()=>{this.a.$unregisterEditorProvider(r)}))}async $createCustomDocument(n,r,i,a,h){const p=this.b.get(r);if(!p)throw new Error(`No provider found for '${r}'`);if(p.type!==1)throw new Error(`Invalid provide type for '${r}'`);const I=m.URI.revive(n),w=await p.provider.openCustomDocument(I,{backupId:i,untitledDocumentData:a?.buffer},h);let f;return u(p.provider)&&this.f&&(f=this.f.workspaceValue(p.extension)??this.f.globalValue(p.extension)),this.c.add(r,w,f),{editable:u(p.provider)}}async $disposeCustomDocument(n,r){const i=this.b.get(r);if(!i)throw new Error(`No provider found for '${r}'`);if(i.type!==1)throw new Error(`Invalid provider type for '${r}'`);const a=m.URI.revive(n),{document:h}=this.i(r,a);this.c.delete(r,h),h.dispose()}async $resolveCustomEditor(n,r,i,a,h,p){const I=this.b.get(i);if(!I)throw new Error(`No provider found for '${i}'`);const w=k.ViewColumn.to(h),f=this.g.createNewWebview(r,a.contentOptions,I.extension),b=this.h.createNewWebviewPanel(r,i,a.title,w,a.options,f,a.active),L=m.URI.revive(n);switch(I.type){case 1:{const{document:O}=this.i(i,L);return I.provider.resolveCustomEditor(O,b,p)}case 0:{const O=this.d.getDocument(L);return I.provider.resolveCustomTextEditor(O,b,p)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(n,r,i){this.i(r,n).disposeEdits(i)}async $onMoveCustomEditor(n,r,i){const a=this.b.get(i);if(!a)throw new Error(`No provider found for '${i}'`);if(!a.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${i}'`);const h=this.h.getWebviewPanel(n);if(!h)throw new Error("No webview found");const p=m.URI.revive(r),I=this.d.getDocument(p);await a.provider.moveCustomTextEditor(I,h,y.CancellationToken.None)}async $undo(n,r,i,a){return this.i(r,n).undo(i,a)}async $redo(n,r,i,a){return this.i(r,n).redo(i,a)}async $revert(n,r,i){const a=this.i(r,n);await this.j(r).revertCustomDocument(a.document,i),a.disposeBackup()}async $onSave(n,r,i){const a=this.i(r,n);await this.j(r).saveCustomDocument(a.document,i),a.disposeBackup()}async $onSaveAs(n,r,i,a){const h=this.i(r,n);return this.j(r).saveCustomDocumentAs(h.document,m.URI.revive(i),a)}async $backup(n,r,i){const a=this.i(r,n),p=await this.j(r).backupCustomDocument(a.document,{destination:a.getNewBackupUri()},i);return a.updateBackup(p),p.id}i(n,r){const i=this.c.get(n,m.URI.revive(r));if(!i)throw new Error("No custom document found");return i}j(n){const i=this.b.get(n)?.provider;if(!i||!u(i))throw new Error("Custom document is not editable");return i}}e.$ddc=c;function u(t){return!!t.onDidChangeCustomDocument}function o(t){return typeof t.resolveCustomTextEditor=="function"}function g(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function d(t){const n=t.scheme===R.Schemas.file||t.scheme===R.Schemas.untitled?t.fsPath:t.toString();return(0,M.$zi)(n)+""}});var et=this&&this.__classPrivateFieldSet||function(ne,e,y,M,l){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!l:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?l.call(ne,y):l?l.value=y:e.set(ne,y),y},Be=this&&this.__classPrivateFieldGet||function(ne,e,y,M){if(y==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!M:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return y==="m"?M:y==="a"?M.call(ne):M?M.value:e.get(ne)};define(Se[333],De([1,0,4,3,2,31,13,92,6,7]),function(ne,e,y,M,l,R,A,m,k,$){"use strict";var P,C,v,S,D,E,s,c,u,o,g,d,t;Object.defineProperty(e,"__esModule",{value:!0}),e.$cdc=void 0;class n extends M.$Qc{constructor(h,p,I,w){super(),P.set(this,void 0),C.set(this,void 0),v.set(this,void 0),S.set(this,void 0),D.set(this,void 0),E.set(this,void 0),s.set(this,void 0),c.set(this,void 0),u.set(this,!0),o.set(this,void 0),g.set(this,!1),d.set(this,this.B(new y.$Ld)),this.onDidDispose=Be(this,d,"f").event,t.set(this,this.B(new y.$Ld)),this.onDidChangeViewState=Be(this,t,"f").event,et(this,P,h,"f"),et(this,C,p,"f"),et(this,S,I,"f"),et(this,v,w.viewType,"f"),et(this,D,w.panelOptions,"f"),et(this,c,w.viewColumn,"f"),et(this,E,w.title,"f"),et(this,o,w.active,"f")}dispose(){Be(this,g,"f")||(et(this,g,!0,"f"),Be(this,d,"f").fire(),Be(this,C,"f").$disposeWebview(Be(this,P,"f")),Be(this,S,"f").dispose(),super.dispose())}get webview(){return this.c(),Be(this,S,"f")}get viewType(){return this.c(),Be(this,v,"f")}get title(){return this.c(),Be(this,E,"f")}set title(h){this.c(),Be(this,E,"f")!==h&&(et(this,E,h,"f"),Be(this,C,"f").$setTitle(Be(this,P,"f"),h))}get iconPath(){return this.c(),Be(this,s,"f")}set iconPath(h){this.c(),Be(this,s,"f")!==h&&(et(this,s,h,"f"),Be(this,C,"f").$setIconPath(Be(this,P,"f"),l.URI.isUri(h)?{light:h,dark:h}:h))}get options(){return Be(this,D,"f")}get viewColumn(){if(this.c(),!(typeof Be(this,c,"f")=="number"&&Be(this,c,"f")<0))return Be(this,c,"f")}get active(){return this.c(),Be(this,o,"f")}get visible(){return this.c(),Be(this,u,"f")}_updateViewState(h){Be(this,g,"f")||(this.active!==h.active||this.visible!==h.visible||this.viewColumn!==h.viewColumn)&&(et(this,o,h.active,"f"),et(this,u,h.visible,"f"),et(this,c,h.viewColumn,"f"),Be(this,t,"f").fire({webviewPanel:this}))}reveal(h,p){this.c(),Be(this,C,"f").$reveal(Be(this,P,"f"),{viewColumn:typeof h>"u"?void 0:A.ViewColumn.from(h),preserveFocus:!!p})}c(){if(Be(this,g,"f"))throw new Error("Webview is disposed")}}P=new WeakMap,C=new WeakMap,v=new WeakMap,S=new WeakMap,D=new WeakMap,E=new WeakMap,s=new WeakMap,c=new WeakMap,u=new WeakMap,o=new WeakMap,g=new WeakMap,d=new WeakMap,t=new WeakMap;class r extends M.$Qc{static c(){return(0,R.$bg)()}constructor(h,p,I){super(),this.j=p,this.m=I,this.g=new Map,this.h=new Map,this.f=h.getProxy(k.$9J.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(h=>h.dispose()),this.g.clear()}createWebviewPanel(h,p,I,w,f={}){const b=typeof w=="object"?w.viewColumn:w,L={viewColumn:A.ViewColumn.from(b),preserveFocus:typeof w=="object"&&!!w.preserveFocus},O=(0,m.$Bcc)(h),T=r.c();this.f.$createWebviewPanel((0,m.$Dcc)(h),T,p,{title:I,panelOptions:i(f),webviewOptions:(0,m.$Ecc)(h,this.m,f),serializeBuffersForPostMessage:O},L);const F=this.j.createNewWebview(T,f,h);return this.createNewWebviewPanel(T,p,I,b,f,F,!0)}$onDidChangeWebviewPanelViewStates(h){const p=Object.keys(h);p.sort((I,w)=>{const f=h[I],b=h[w];return f.active?1:b.active?-1:+f.visible-+b.visible});for(const I of p){const w=this.getWebviewPanel(I);if(!w)continue;const f=h[I];w._updateViewState({active:f.active,visible:f.visible,viewColumn:A.ViewColumn.to(f.position)})}}async $onDidDisposeWebviewPanel(h){this.getWebviewPanel(h)?.dispose(),this.g.delete(h),this.j.deleteWebview(h)}registerWebviewPanelSerializer(h,p,I){if(this.h.has(p))throw new Error(`Serializer for '${p}' already registered`);return this.h.set(p,{serializer:I,extension:h}),this.f.$registerSerializer(p,{serializeBuffersForPostMessage:(0,m.$Bcc)(h)}),new $.$$J(()=>{this.h.delete(p),this.f.$unregisterSerializer(p)})}async $deserializeWebviewPanel(h,p,I,w){const f=this.h.get(p);if(!f)throw new Error(`No serializer found for '${p}'`);const{serializer:b,extension:L}=f,O=this.j.createNewWebview(h,I.webviewOptions,L),T=this.createNewWebviewPanel(h,p,I.title,w,I.panelOptions,O,I.active);await b.deserializeWebviewPanel(T,I.state)}createNewWebviewPanel(h,p,I,w,f,b,L){const O=new n(h,this.f,b,{viewType:p,title:I,viewColumn:w,panelOptions:f,active:L});return this.g.set(h,O),O}getWebviewPanel(h){return this.g.get(h)}}e.$cdc=r;function i(a){return{enableFindWidget:a.enableFindWidget,retainContextWhenHidden:a.retainContextWhenHidden}}});var et=this&&this.__classPrivateFieldSet||function(ne,e,y,M,l){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!l:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?l.call(ne,y):l?l.value=y:e.set(ne,y),y},Be=this&&this.__classPrivateFieldGet||function(ne,e,y,M){if(y==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!M:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return y==="m"?M:y==="a"?M.call(ne):M?M.value:e.get(ne)};define(Se[334],De([1,0,4,3,92,13,6,7]),function(ne,e,y,M,l,R,A,m){"use strict";var k,$,P,C,v,S,D,E,s,c,u;Object.defineProperty(e,"__esModule",{value:!0}),e.$bdc=void 0;class o extends M.$Qc{constructor(t,n,r,i,a,h){super(),k.set(this,void 0),$.set(this,void 0),P.set(this,void 0),C.set(this,void 0),v.set(this,!1),S.set(this,void 0),D.set(this,void 0),E.set(this,void 0),s.set(this,void 0),c.set(this,this.B(new y.$Ld)),this.onDidChangeVisibility=Be(this,c,"f").event,u.set(this,this.B(new y.$Ld)),this.onDidDispose=Be(this,u,"f").event,et(this,P,r,"f"),et(this,D,i,"f"),et(this,k,t,"f"),et(this,$,n,"f"),et(this,C,a,"f"),et(this,S,h,"f")}dispose(){Be(this,v,"f")||(et(this,v,!0,"f"),Be(this,u,"f").fire(),Be(this,C,"f").dispose(),super.dispose())}get title(){return this.a(),Be(this,D,"f")}set title(t){this.a(),Be(this,D,"f")!==t&&(et(this,D,t,"f"),Be(this,$,"f").$setWebviewViewTitle(Be(this,k,"f"),t))}get description(){return this.a(),Be(this,E,"f")}set description(t){this.a(),Be(this,E,"f")!==t&&(et(this,E,t,"f"),Be(this,$,"f").$setWebviewViewDescription(Be(this,k,"f"),t))}get visible(){return Be(this,S,"f")}get webview(){return Be(this,C,"f")}get viewType(){return Be(this,P,"f")}_setVisible(t){t===Be(this,S,"f")||Be(this,v,"f")||(et(this,S,t,"f"),Be(this,c,"f").fire())}get badge(){return this.a(),Be(this,s,"f")}set badge(t){this.a(),!(t?.value===Be(this,s,"f")?.value&&t?.tooltip===Be(this,s,"f")?.tooltip)&&(et(this,s,R.ViewBadge.from(t),"f"),Be(this,$,"f").$setWebviewViewBadge(Be(this,k,"f"),t))}show(t){this.a(),Be(this,$,"f").$show(Be(this,k,"f"),!!t)}a(){if(Be(this,v,"f"))throw new Error("Webview is disposed")}}k=new WeakMap,$=new WeakMap,P=new WeakMap,C=new WeakMap,v=new WeakMap,S=new WeakMap,D=new WeakMap,E=new WeakMap,s=new WeakMap,c=new WeakMap,u=new WeakMap;class g{constructor(t,n){this.d=n,this.b=new Map,this.c=new Map,this.a=t.getProxy(A.$9J.MainThreadWebviewViews)}registerWebviewViewProvider(t,n,r,i){if(this.b.has(n))throw new Error(`View provider for '${n}' already registered`);return this.b.set(n,{provider:r,extension:t}),this.a.$registerWebviewViewProvider((0,l.$Dcc)(t),n,{retainContextWhenHidden:i?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,l.$Bcc)(t)}),new m.$$J(()=>{this.b.delete(n),this.a.$unregisterWebviewViewProvider(n)})}async $resolveWebviewView(t,n,r,i,a){const h=this.b.get(n);if(!h)throw new Error(`No view provider found for '${n}'`);const{provider:p,extension:I}=h,w=this.d.createNewWebview(t,{},I),f=new o(t,this.a,n,r,w,!0);this.c.set(t,f),await p.resolveWebviewView(f,{state:i},a)}async $onDidChangeWebviewViewVisibility(t,n){this.e(t)._setVisible(n)}async $disposeWebviewView(t){const n=this.e(t);this.c.delete(t),n.dispose(),this.d.deleteWebview(t)}e(t){const n=this.c.get(t);if(!n)throw new Error("No webview found");return n}}e.$bdc=g}),define(Se[152],De([1,0,4,6,2,17,16,5,20,27]),function(ne,e,y,M,l,R,A,m,k,$){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.$Gcc=e.$Fcc=void 0;let C=P=class{getState(S){const D=this.d;return{get focused(){return D.focused},get active(){return(0,$.$8E)(S,"windowActivity"),D.active}}}constructor(S){this.c=new y.$Ld,this.onDidChangeWindowState=this.c.event,this.d=P.a,this.b=S.getProxy(M.$9J.MainThreadWindow),this.b.$getInitialState().then(({isFocused:D,isActive:E})=>{this.onDidChangeWindowProperty("focused",D),this.onDidChangeWindowProperty("active",E)})}$onDidChangeWindowFocus(S){this.onDidChangeWindowProperty("focused",S)}$onDidChangeWindowActive(S){this.onDidChangeWindowProperty("active",S)}onDidChangeWindowProperty(S,D){D!==this.d[S]&&(this.d={...this.d,[S]:D},this.c.fire(this.d))}openUri(S,D){let E;if(typeof S=="string"){E=S;try{S=l.URI.parse(S)}catch{return Promise.reject(`Invalid uri - '${S}'`)}}return(0,A.$ze)(S.scheme)?Promise.reject("Invalid scheme - cannot be empty"):S.scheme===R.Schemas.command?Promise.reject(`Invalid scheme '${S.scheme}'`):this.b.$openUri(S,E,D)}async asExternalUri(S,D){if((0,A.$ze)(S.scheme))return Promise.reject("Invalid scheme - cannot be empty");const E=await this.b.$asExternalUri(S,D);return l.URI.from(E)}};e.$Fcc=C,C.a={focused:!0,active:!0},e.$Fcc=C=P=Ke([We(0,k.$0L)],C),e.$Gcc=(0,m.$Lh)("IExtHostWindow")}),define(Se[335],De([1,0,303,26,20]),function(ne,e,y,M,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eec=void 0;const R=1024*1024;let A=class extends y.$Fdc{constructor(k,$){super(k,$),this.g=!1,this.j("stderr","error"),this.j("stdout","log")}f(k,$,P){const C=k==="error"||k==="warn"?process.stderr:process.stdout;this.g=!0,C.write(`
START_NATIVE_LOG
`),$.apply(console,P),C.write(`
END_NATIVE_LOG
`),this.g=!1}j(k,$){const P=process[k],C=P.write;let v="";Object.defineProperty(P,"write",{set:()=>{},get:()=>(S,D,E)=>{if(!this.g){v+=S.toString(D);const s=v.length>R?v.length:v.lastIndexOf(`
`);s!==-1&&(console[$](v.slice(0,s)),v=v.slice(s+1))}C.call(P,S,D,E)}})}};e.$eec=A,e.$eec=A=Ke([We(0,l.$0L),We(1,M.$nM)],A)}),define(Se[336],De([1,0,72,17,14,240,30,10]),function(ne,e,y,M,l,R,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fec=void 0;let k=class{constructor(C,v){C.addFileSystemProvider(M.Schemas.file,new $(v),{isCaseSensitive:m.$f})}};e.$fec=k,e.$fec=k=Ke([We(0,y.$5bc),We(1,l.$6i)],k);class ${constructor(C){this.b=C,this.a=new R.$5p(this.b)}async stat(C){const v=await this.a.stat(C);return{type:v.type,ctime:v.ctime,mtime:v.mtime,size:v.size,permissions:v.permissions===A.FilePermission.Readonly?1:void 0}}readDirectory(C){return this.a.readdir(C)}createDirectory(C){return this.a.mkdir(C)}readFile(C){return this.a.readFile(C)}writeFile(C,v,S){return this.a.writeFile(C,v,{...S,unlock:!1,atomic:!1})}delete(C,v){return this.a.delete(C,{...v,useTrash:!1,atomic:!1})}rename(C,v,S){return this.a.rename(C,v,S)}copy(C,v,S){return this.a.copy(C,v,S)}get onDidChangeFile(){throw new Error("Method not implemented.")}watch(C,v){throw new Error("Method not implemented.")}}}),define(Se[337],De([1,0,15,61,31,33,3,6,2,20]),function(ne,e,y,M,l,R,A,m,k,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dec=void 0;let P=class extends A.$Qc{constructor(v,S){super();const D=v.getProxy(m.$9J.MainThreadDownloadService);S.registerCommand(!1,"_workbench.downloadResource",async E=>{const s=k.URI.file((0,y.$hc)((0,M.tmpdir)(),(0,l.$bg)()));return await D.$download(E,s),s})}};e.$dec=P,e.$dec=P=Ke([We(0,$.$0L),We(1,R.$tM)],P)}),define(Se[338],De([1,0,151,17,242,31]),function(ne,e,y,M,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qec=void 0;class A extends y.$Edc{s(k,$,P){return k.scheme===M.Schemas.file?new l.$kN(P?.name||(0,R.$bg)(),k.fsPath,!P?.donotRotate,!!P?.donotUseFormatters,$):super.s(k,$,P)}registerLogger(k){super.registerLogger(k),this.r.$registerLogger(k)}deregisterLogger(k){super.deregisterLogger(k),this.r.$deregisterLogger(k)}}e.$qec=A}),define(Se[339],De([1,0,52,15,2,91,3,17,9,29]),function(ne,e,y,M,l,R,A,m,k,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pec=void 0;class P extends R.$7bc{constructor(){super(...arguments),this.i=null}async g(t){const n=await super.g(t);if(n.scheme!==m.Schemas.file)return n;if(this.b.skipWorkspaceStorageLock)return this.d.info(`Skipping acquiring lock for ${n.fsPath}.`),n;const r=n.fsPath;let i=0;do{let a;i===0?a=r:a=/[/\\]$/.test(r)?`${r.substr(0,r.length-1)}-${i}`:`${r}-${i}`,await C(a);const h=M.$hc(a,"vscode.lock"),p=await E(this.d,h,!1);if(p)return this.i=p,process.on("exit",()=>{p.dispose()}),l.URI.file(a);i++}while(i<10);return n}onWillDeactivateAll(){this.i?.setWillRelease(6e3)}}e.$pec=P;async function C(d){try{await $.Promises.stat(d);return}catch{}try{await $.Promises.mkdir(d,{recursive:!0})}catch{}}const v=1e3,S=10*60*1e3;class D extends A.$Qc{constructor(t,n){super(),this.b=t,this.c=n,this.a=this.B(new k.$2g),this.a.cancelAndSet(async()=>{const r=await s(t,n);(!r||r.pid!==process.pid)&&(t.info(`Lock '${n}': The lock was lost unexpectedly.`),this.a.cancel());try{await $.Promises.utimes(n,new Date,new Date)}catch(i){t.error(i),t.info(`Lock '${n}': Could not update mtime.`)}},v)}dispose(){super.dispose();try{y.unlinkSync(this.c)}catch{}}async setWillRelease(t){this.b.info(`Lock '${this.c}': Marking the lockfile as scheduled to be released in ${t} ms.`);try{const n={pid:process.pid,willReleaseAt:Date.now()+t};await $.Promises.writeFile(this.c,JSON.stringify(n),{flag:"w"})}catch(n){this.b.error(n)}}}async function E(d,t,n){try{const i={pid:process.pid,willReleaseAt:0};await $.Promises.writeFile(t,JSON.stringify(i),{flag:"wx"})}catch(i){d.error(i)}const r=await s(d,t);return!r||r.pid!==process.pid?n?(d.info(`Lock '${t}': Could not acquire lock, giving up.`),null):(d.info(`Lock '${t}': Could not acquire lock, checking if the file is stale.`),o(d,t)):(d.info(`Lock '${t}': Lock acquired.`),new D(d,t))}async function s(d,t){let n;try{n=await $.Promises.readFile(t)}catch(r){return d.error(r),null}try{return JSON.parse(String(n))}catch(r){return d.error(r),null}}async function c(d,t){let n;try{n=await $.Promises.stat(t)}catch(r){return d.error(r),0}return n.mtime.getTime()}function u(d){try{return process.kill(d,0),!0}catch{return!1}}async function o(d,t){const n=await s(d,t);if(!n)return d.info(`Lock '${t}': Could not read pid of lock holder.`),g(d,t);if(n.willReleaseAt){let p=n.willReleaseAt-Date.now();if(p<5e3){for(p>0?d.info(`Lock '${t}': The lockfile is scheduled to be released in ${p} ms.`):d.info(`Lock '${t}': The lockfile is scheduled to have been released.`);p>0;){if(await(0,k.$Rg)(Math.min(100,p)),await c(d,t)===0)return g(d,t);p=n.willReleaseAt-Date.now()}return g(d,t)}}if(!u(n.pid))return d.info(`Lock '${t}': The pid ${n.pid} appears to be gone.`),g(d,t);const r=await c(d,t),i=Date.now()-r;if(i<=S)return d.info(`Lock '${t}': The lock does not look stale, elapsed: ${i} ms, giving up.`),null;d.info(`Lock '${t}': The lock looks stale, waiting for 2s.`),await(0,k.$Rg)(2e3);const a=await c(d,t),h=Date.now()-a;return h<=S?(d.info(`Lock '${t}': The lock does not look stale, elapsed: ${h} ms, giving up.`),null):(d.info(`Lock '${t}': The lock looks stale even after waiting for 2s.`),g(d,t))}async function g(d,t){d.info(`Lock '${t}': Deleting a stale lock.`);try{await $.Promises.unlink(t)}catch{}return E(d,t,!0)}}),define(Se[340],De([1,0,31,20,44,33]),function(ne,e,y,M,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kdc=void 0;let A=class extends l.$0bc{constructor(k,$){super(!0,k,$)}createTerminal(k,$,P){return this.createTerminalFromOptions({name:k,shellPath:$,shellArgs:P})}createTerminalFromOptions(k,$){const P=new l.$9bc(this.a,(0,y.$bg)(),k,k.name);return this.f.push(P),P.create(k,this.R(k,$)),P.value}};e.$Kdc=A,e.$Kdc=A=Ke([We(0,R.$tM),We(1,M.$0L)],A)}),define(Se[341],De([1,0,9,22,21,8,4,3,126,291,69]),function(ne,e,y,M,l,R,A,m,k,$,P){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.$b4b=e.ResponsiveState=e.RequestInitiator=e.$a4b=e.$_3b=void 0;function v(b,L){try{return JSON.stringify(b,L)}catch{return"null"}}const S="$$ref$$",D={[S]:-1};class E{constructor(L,O){this.jsonString=L,this.referencedBuffers=O}}function s(b,L=null,O=!1){const T=[];return{jsonString:(O?v:JSON.stringify)(b,(U,N)=>{if(typeof N>"u")return D;if(typeof N=="object"){if(N instanceof M.$_d){const j=T.push(N)-1;return{[S]:j}}if(L)return L(U,N)}return N}),referencedBuffers:T}}e.$_3b=s;function c(b,L,O){return JSON.parse(b,(T,F)=>{if(F){const U=F[S];if(typeof U=="number")return L[U];if(O&&F.$mid===1)return O.transformIncoming(F)}return F})}e.$a4b=c;function u(b,L){return JSON.stringify(b,L)}function o(b){return b?(L,O)=>O&&O.$mid===1?b.transformOutgoing(O):O:null}var g;(function(b){b[b.LocalSide=0]="LocalSide",b[b.OtherSide=1]="OtherSide"})(g||(e.RequestInitiator=g={}));var d;(function(b){b[b.Responsive=0]="Responsive",b[b.Unresponsive=1]="Unresponsive"})(d||(e.ResponsiveState=d={}));const t=()=>{},n=Symbol.for("rpcProtocol"),r=Symbol.for("rpcProxy");class i extends m.$Qc{constructor(L,O=null,T=null){super(),this[C]=!0,this.b=this.B(new A.$Ld),this.onDidChangeResponsiveState=this.b.event,this.c=L,this.f=O,this.g=T,this.h=o(this.g),this.j=!1,this.m=[],this.s=[];for(let F=0,U=P.$fv.count;F<U;F++)this.m[F]=null,this.s[F]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new y.$3g(()=>this.H(),1e3)),this.c.onMessage(F=>this.L(F))}dispose(){this.j=!0,Object.keys(this.w).forEach(L=>{const O=this.w[L];delete this.w[L],O.resolveErr(R.$4())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(L){this.z===0&&(this.C=Date.now()+i.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(L){this.C=Date.now()+i.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(L){this.y!==L&&(this.y=L,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(L){return this.g?(0,k.$Gm)(L,this.g):L}getProxy(L){const{nid:O,sid:T}=L;return this.s[O]||(this.s[O]=this.J(O,T)),this.s[O]}J(L,O){const T={get:(F,U)=>(typeof U=="string"&&!F[U]&&U.charCodeAt(0)===36&&(F[U]=(...N)=>this.U(L,U,N)),U===r?O:F[U])};return new Proxy(Object.create(null),T)}set(L,O){return this.m[L.nid]=O,O}assertRegistered(L){for(let O=0,T=L.length;O<T;O++){const F=L[O];if(!this.m[F.nid])throw new Error(`Missing proxy instance ${F.sid}`)}}L(L){if(this.j)return;const O=L.byteLength,T=h.read(L,0),F=T.readUInt8(),U=T.readUInt32();switch(F){case 1:case 2:{let{rpcId:N,method:j,args:z}=I.deserializeRequestJSONArgs(T);this.g&&(z=(0,k.$Gm)(z,this.g)),this.M(O,U,N,j,z,F===2);break}case 3:case 4:{let{rpcId:N,method:j,args:z}=I.deserializeRequestMixedArgs(T);this.g&&(z=(0,k.$Gm)(z,this.g)),this.M(O,U,N,j,z,F===4);break}case 5:{this.f?.logIncoming(O,U,0,"ack"),this.G(U);break}case 6:{this.N(O,U);break}case 7:{this.O(O,U,void 0);break}case 9:{let N=I.deserializeReplyOKJSON(T);this.g&&(N=(0,k.$Gm)(N,this.g)),this.O(O,U,N);break}case 10:{const N=I.deserializeReplyOKJSONWithBuffers(T,this.g);this.O(O,U,N);break}case 8:{const N=I.deserializeReplyOKVSBuffer(T);this.O(O,U,N);break}case 11:{let N=I.deserializeReplyErrError(T);this.g&&(N=(0,k.$Gm)(N,this.g)),this.P(O,U,N);break}case 12:{this.P(O,U,void 0);break}default:console.error("received unexpected message"),console.error(L)}}M(L,O,T,F,U,N){this.f?.logIncoming(L,O,1,`receiveRequest ${(0,P.$hv)(T)}.${F}(`,U);const j=String(O);let z,B;if(N){const X=new l.$Vd;U.push(X.token),z=this.Q(T,F,U),B=()=>X.cancel()}else z=this.Q(T,F,U),B=t;this.u[j]=B;const ae=I.serializeAcknowledged(O);this.f?.logOutgoing(ae.byteLength,O,1,"ack"),this.c.send(ae),z.then(X=>{delete this.u[j];const Q=I.serializeReplyOK(O,X,this.h);this.f?.logOutgoing(Q.byteLength,O,1,"reply:",X),this.c.send(Q)},X=>{delete this.u[j];const Q=I.serializeReplyErr(O,X);this.f?.logOutgoing(Q.byteLength,O,1,"replyErr:",X),this.c.send(Q)})}N(L,O){this.f?.logIncoming(L,O,1,"receiveCancel");const T=String(O);this.u[T]?.()}O(L,O,T){this.f?.logIncoming(L,O,0,"receiveReply:",T);const F=String(O);if(!this.w.hasOwnProperty(F))return;const U=this.w[F];delete this.w[F],U.resolveOk(T)}P(L,O,T){this.f?.logIncoming(L,O,0,"receiveReplyErr:",T);const F=String(O);if(!this.w.hasOwnProperty(F))return;const U=this.w[F];delete this.w[F];let N;T&&(T.$isError?(N=new Error,N.name=T.name,N.message=T.message,N.stack=T.stack):N=T),U.resolveErr(N)}Q(L,O,T){try{return Promise.resolve(this.S(L,O,T))}catch(F){return Promise.reject(F)}}S(L,O,T){const F=this.m[L];if(!F)throw new Error("Unknown actor "+(0,P.$hv)(L));const U=F[O];if(typeof U!="function")throw new Error("Unknown method "+O+" on actor "+(0,P.$hv)(L));return U.apply(F,T)}U(L,O,T){if(this.j)return new $.$$3b;let F=null;if(T.length>0&&l.CancellationToken.isCancellationToken(T[T.length-1])&&(F=T.pop()),F&&F.isCancellationRequested)return Promise.reject(R.$4());const U=I.serializeRequestArguments(T,this.h),N=++this.t,j=String(N),z=new $.$03b,B=new m.$Pc;F&&B.add(F.onCancellationRequested(()=>{const X=I.serializeCancel(N);this.f?.logOutgoing(X.byteLength,N,0,"cancel"),this.c.send(I.serializeCancel(N))})),this.w[j]=new a(z,B),this.F(N);const ae=I.serializeRequest(N,L,O,U,!!F);return this.f?.logOutgoing(ae.byteLength,N,0,`request: ${(0,P.$hv)(L)}.${O}(`,T),this.c.send(ae),z}}e.$b4b=i,C=n,i.a=3*1e3;class a{constructor(L,O){this.a=L,this.b=O}resolveOk(L){this.a.resolveOk(L),this.b.dispose()}resolveErr(L){this.a.resolveErr(L),this.b.dispose()}}class h{static alloc(L,O,T){const F=new h(M.$_d.alloc(T+1+4),0);return F.writeUInt8(L),F.writeUInt32(O),F}static read(L,O){return new h(L,O)}get buffer(){return this.a}constructor(L,O){this.a=L,this.b=O}static sizeUInt8(){return 1}writeUInt8(L){this.a.writeUInt8(L,this.b),this.b+=1}readUInt8(){const L=this.a.readUInt8(this.b);return this.b+=1,L}writeUInt32(L){this.a.writeUInt32BE(L,this.b),this.b+=4}readUInt32(){const L=this.a.readUInt32BE(this.b);return this.b+=4,L}static sizeShortString(L){return 1+L.byteLength}writeShortString(L){this.a.writeUInt8(L.byteLength,this.b),this.b+=1,this.a.set(L,this.b),this.b+=L.byteLength}readShortString(){const L=this.a.readUInt8(this.b);this.b+=1;const T=this.a.slice(this.b,this.b+L).toString();return this.b+=L,T}static sizeLongString(L){return 4+L.byteLength}writeLongString(L){this.a.writeUInt32BE(L.byteLength,this.b),this.b+=4,this.a.set(L,this.b),this.b+=L.byteLength}readLongString(){const L=this.a.readUInt32BE(this.b);this.b+=4;const T=this.a.slice(this.b,this.b+L).toString();return this.b+=L,T}writeBuffer(L){this.a.writeUInt32BE(L.byteLength,this.b),this.b+=4,this.a.set(L,this.b),this.b+=L.byteLength}static sizeVSBuffer(L){return 4+L.byteLength}writeVSBuffer(L){this.a.writeUInt32BE(L.byteLength,this.b),this.b+=4,this.a.set(L,this.b),this.b+=L.byteLength}readVSBuffer(){const L=this.a.readUInt32BE(this.b);this.b+=4;const O=this.a.slice(this.b,this.b+L);return this.b+=L,O}static sizeMixedArray(L){let O=0;O+=1;for(let T=0,F=L.length;T<F;T++){const U=L[T];switch(O+=1,U.type){case 1:O+=this.sizeLongString(U.value);break;case 2:O+=this.sizeVSBuffer(U.value);break;case 3:O+=this.sizeUInt32,O+=this.sizeLongString(U.value);for(let N=0;N<U.buffers.length;++N)O+=this.sizeVSBuffer(U.buffers[N]);break;case 4:break}}return O}writeMixedArray(L){this.a.writeUInt8(L.length,this.b),this.b+=1;for(let O=0,T=L.length;O<T;O++){const F=L[O];switch(F.type){case 1:this.writeUInt8(1),this.writeLongString(F.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(F.value);break;case 3:this.writeUInt8(3),this.writeUInt32(F.buffers.length),this.writeLongString(F.value);for(let U=0;U<F.buffers.length;++U)this.writeBuffer(F.buffers[U]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const L=this.a.readUInt8(this.b);this.b+=1;const O=new Array(L);for(let T=0;T<L;T++)switch(this.readUInt8()){case 1:O[T]=this.readLongString();break;case 2:O[T]=this.readVSBuffer();break;case 3:{const U=this.readUInt32(),N=this.readLongString(),j=[];for(let z=0;z<U;++z)j.push(this.readVSBuffer());O[T]=new P.$iv(c(N,j,null));break}case 4:O[T]=void 0;break}return O}}h.sizeUInt32=4;var p;(function(b){b[b.Simple=0]="Simple",b[b.Mixed=1]="Mixed"})(p||(p={}));class I{static a(L){for(let O=0,T=L.length;O<T;O++)if(L[O]instanceof M.$_d||L[O]instanceof P.$iv||typeof L[O]>"u")return!0;return!1}static serializeRequestArguments(L,O){if(this.a(L)){const T=[];for(let F=0,U=L.length;F<U;F++){const N=L[F];if(N instanceof M.$_d)T[F]={type:2,value:N};else if(typeof N>"u")T[F]={type:4};else if(N instanceof P.$iv){const{jsonString:j,referencedBuffers:z}=s(N.value,O);T[F]={type:3,value:M.$_d.fromString(j),buffers:z}}else T[F]={type:1,value:M.$_d.fromString(u(N,O))}}return{type:1,args:T}}return{type:0,args:u(L,O)}}static serializeRequest(L,O,T,F,U){switch(F.type){case 0:return this.b(L,O,T,F.args,U);case 1:return this.c(L,O,T,F.args,U)}}static b(L,O,T,F,U){const N=M.$_d.fromString(T),j=M.$_d.fromString(F);let z=0;z+=h.sizeUInt8(),z+=h.sizeShortString(N),z+=h.sizeLongString(j);const B=h.alloc(U?2:1,L,z);return B.writeUInt8(O),B.writeShortString(N),B.writeLongString(j),B.buffer}static deserializeRequestJSONArgs(L){const O=L.readUInt8(),T=L.readShortString(),F=L.readLongString();return{rpcId:O,method:T,args:JSON.parse(F)}}static c(L,O,T,F,U){const N=M.$_d.fromString(T);let j=0;j+=h.sizeUInt8(),j+=h.sizeShortString(N),j+=h.sizeMixedArray(F);const z=h.alloc(U?4:3,L,j);return z.writeUInt8(O),z.writeShortString(N),z.writeMixedArray(F),z.buffer}static deserializeRequestMixedArgs(L){const O=L.readUInt8(),T=L.readShortString(),F=L.readMixedArray(),U=new Array(F.length);for(let N=0,j=F.length;N<j;N++){const z=F[N];typeof z=="string"?U[N]=JSON.parse(z):U[N]=z}return{rpcId:O,method:T,args:U}}static serializeAcknowledged(L){return h.alloc(5,L,0).buffer}static serializeCancel(L){return h.alloc(6,L,0).buffer}static serializeReplyOK(L,O,T){if(typeof O>"u")return this.d(L);if(O instanceof M.$_d)return this.e(L,O);if(O instanceof P.$iv){const{jsonString:F,referencedBuffers:U}=s(O.value,T,!0);return this.g(L,F,U)}else return this.f(L,v(O,T))}static d(L){return h.alloc(7,L,0).buffer}static e(L,O){let T=0;T+=h.sizeVSBuffer(O);const F=h.alloc(8,L,T);return F.writeVSBuffer(O),F.buffer}static deserializeReplyOKVSBuffer(L){return L.readVSBuffer()}static f(L,O){const T=M.$_d.fromString(O);let F=0;F+=h.sizeLongString(T);const U=h.alloc(9,L,F);return U.writeLongString(T),U.buffer}static g(L,O,T){const F=M.$_d.fromString(O);let U=0;U+=h.sizeUInt32,U+=h.sizeLongString(F);for(const j of T)U+=h.sizeVSBuffer(j);const N=h.alloc(10,L,U);N.writeUInt32(T.length),N.writeLongString(F);for(const j of T)N.writeBuffer(j);return N.buffer}static deserializeReplyOKJSON(L){const O=L.readLongString();return JSON.parse(O)}static deserializeReplyOKJSONWithBuffers(L,O){const T=L.readUInt32(),F=L.readLongString(),U=[];for(let N=0;N<T;++N)U.push(L.readVSBuffer());return new P.$iv(c(F,U,O))}static serializeReplyErr(L,O){const T=O?v(R.$1(O),null):void 0;if(typeof T!="string")return this.h(L);const F=M.$_d.fromString(T);let U=0;U+=h.sizeLongString(F);const N=h.alloc(11,L,U);return N.writeLongString(F),N.buffer}static deserializeReplyErrError(L){const O=L.readLongString();return JSON.parse(O)}static h(L){return h.alloc(12,L,0).buffer}}var w;(function(b){b[b.RequestJSONArgs=1]="RequestJSONArgs",b[b.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",b[b.RequestMixedArgs=3]="RequestMixedArgs",b[b.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",b[b.Acknowledged=5]="Acknowledged",b[b.Cancel=6]="Cancel",b[b.ReplyOKEmpty=7]="ReplyOKEmpty",b[b.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",b[b.ReplyOKJSON=9]="ReplyOKJSON",b[b.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",b[b.ReplyErrError=11]="ReplyErrError",b[b.ReplyErrEmpty=12]="ReplyErrEmpty"})(w||(w={}));var f;(function(b){b[b.String=1]="String",b[b.VSBuffer=2]="VSBuffer",b[b.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",b[b.Undefined=4]="Undefined"})(f||(f={}))}),define(Se[342],De([1,0,4,42,41,5]),function(ne,e,y,M,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sJ=e.$rJ=e.OutputChannelUpdateMode=e.$qJ=e.$pJ=e.$oJ=e.$nJ=e.$mJ=e.$lJ=e.$kJ=e.$jJ=e.$iJ=e.$hJ=void 0,e.$hJ="text/x-code-output",e.$iJ="output",e.$jJ="Log",e.$kJ="text/x-code-log-output",e.$lJ="log",e.$mJ="workbench.panel.output",e.$nJ=new l.$3i("inOutput",!1),e.$oJ=new l.$3i("activeLogOutput",!1),e.$pJ=new l.$3i("outputView.scrollLock",!1),e.$qJ=(0,R.$Lh)("outputService");var A;(function(k){k[k.Append=1]="Append",k[k.Replace=2]="Replace",k[k.Clear=3]="Clear"})(A||(e.OutputChannelUpdateMode=A={})),e.$rJ={OutputChannels:"workbench.contributions.outputChannels"};class m{constructor(){this.a=new Map,this.b=new y.$Ld,this.onDidRegisterChannel=this.b.event,this.c=new y.$Ld,this.onDidRemoveChannel=this.c.event}registerChannel($){this.a.has($.id)||(this.a.set($.id,$),this.b.fire($.id))}getChannels(){const $=[];return this.a.forEach(P=>$.push(P)),$}getChannel($){return this.a.get($)}removeChannel($){this.a.delete($),this.c.fire($)}}M.$0m.add(e.$rJ.OutputChannels,new m),e.$sJ=new l.$3i("activeOutputChannel","")}),define(Se[153],De([1,0,6,5,20,25,14,342,72,26,54,184,22,18,30,4,3]),function(ne,e,y,M,l,R,A,m,k,$,P,C,v,S,D,E,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qcc=e.$pcc=void 0;class c extends A.$_i{get disposed(){return this.n}constructor(d,t,n,r,i){super(),this.id=d,this.name=t,this.r=n,this.s=r,this.extension=i,this.m=0,this.n=!1,this.visible=!1,this.setLevel(n.getLevel()),this.B(n.onDidChangeLogLevel(a=>this.setLevel(a)))}get logLevel(){return this.getLevel()}appendLine(d){this.append(d+`
`)}append(d){this.info(d)}clear(){const d=this.m;this.r.flush(),this.s.$update(this.id,m.OutputChannelUpdateMode.Clear,d)}replace(d){const t=this.m;this.info(d),this.s.$update(this.id,m.OutputChannelUpdateMode.Replace,t),this.visible&&this.r.flush()}show(d,t){this.r.flush(),this.s.$reveal(this.id,!!(typeof d=="boolean"?d:t))}hide(){this.s.$close(this.id)}g(d,t){this.m+=v.$_d.fromString(t).byteLength,(0,A.log)(this.r,d,t),this.visible&&(this.r.flush(),this.s.$update(this.id,m.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class u extends c{appendLine(d){this.append(d)}}let o=class{constructor(d,t,n,r,i,a){this.i=t,this.j=n,this.k=r,this.l=i,this.m=a,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=d.getProxy(y.$9J.MainThreadOutputService),this.b=this.k.extUri.joinPath(t.logsLocation,`output_logging_${(0,C.$9l)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(d){this.h=d;for(const[t,n]of this.g)n.visible=t===this.h}createOutputChannel(d,t,n){if(d=d.trim(),!d)throw new Error("illegal argument `name`. must not be falsy");const r=typeof t=="object"&&t.log,i=(0,S.$wf)(t)?t:void 0;if((0,S.$wf)(i)&&!i.trim())throw new Error("illegal argument `languageId`. must not be empty");let a;const h=this.i.environment.extensionLogLevel?.find(([I])=>R.$Xl.equals(n.identifier,I))?.[1];h&&(a=(0,A.$jj)(h));const p=r?this.o(d,a,n):this.n(d,i,n);return p.then(I=>{this.g.set(I.id,I),I.visible=I.id===this.h}),r?this.r(d,a??this.m.getLevel(),p):this.q(d,p)}async n(d,t,n){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const r=await this.c,i=this.k.extUri.joinPath(r,`${this.f++}-${d.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),a=this.l.createLogger(i,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),h=await this.a.$register(d,i,t,n.identifier.value);return new c(h,d,a,this.a,n)}async o(d,t,n){const r=await this.p(n),i=d.replace(/[\\/:\*\?"<>\|]/g,""),a=this.k.extUri.joinPath(r,`${i}.log`),h=`${n.identifier.value}.${i}`,p=this.l.createLogger(a,{id:h,name:d,logLevel:t,extensionId:n.identifier.value});return new u(h,d,p,this.a,n)}p(d){let t=this.d.get(d.identifier.value);if(!t){const n=this.k.extUri.joinPath(this.i.logsLocation,d.identifier.value);this.d.set(d.identifier.value,t=(async()=>{try{await this.j.value.createDirectory(n)}catch(r){if((0,D.$jk)(r)!==D.FileSystemProviderErrorCode.FileExists)throw r}return n})())}return t}q(d,t){let n=!1;const r=()=>{if(n)throw new Error("Channel has been closed")};return{get name(){return d},append(i){r(),t.then(a=>a.append(i))},appendLine(i){r(),t.then(a=>a.appendLine(i))},clear(){r(),t.then(i=>i.clear())},replace(i){r(),t.then(a=>a.replace(i))},show(i,a){r(),t.then(h=>h.show(i,a))},hide(){r(),t.then(i=>i.hide())},dispose(){n=!0,t.then(i=>i.dispose())}}}r(d,t,n){const r=new s.$Pc,i=()=>{if(r.isDisposed)throw new Error("Channel has been closed")},a=r.add(new E.$Ld);function h(p){t=p,a.fire(p)}return n.then(p=>{r.add(p),p.logLevel!==t&&h(p.logLevel),r.add(p.onDidChangeLogLevel(I=>h(I)))}),{...this.q(d,n),get logLevel(){return t},onDidChangeLogLevel:a.event,trace(p,...I){i(),n.then(w=>w.trace(p,...I))},debug(p,...I){i(),n.then(w=>w.debug(p,...I))},info(p,...I){i(),n.then(w=>w.info(p,...I))},warn(p,...I){i(),n.then(w=>w.warn(p,...I))},error(p,...I){i(),n.then(w=>w.error(p,...I))},dispose(){r.dispose()}}}};e.$pcc=o,e.$pcc=o=Ke([We(0,l.$0L),We(1,$.$nM),We(2,k.$5bc),We(3,P.$zbc),We(4,A.$7i),We(5,A.$6i)],o),e.$qcc=(0,M.$Lh)("IExtHostOutputService")}),define(Se[343],De([1,0,5,9]),function(ne,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mm=e.$lm=void 0,e.$lm=(0,y.$Lh)("remoteAgentService"),e.$mm=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(l){let R=1/0;for(let m=0;m<this.maxSampleCount;m++){const k=await l.getRoundTripTime();if(k===void 0)return;R=Math.min(R,k/2),await(0,M.$Rg)(this.sampleDelay)}this.average.push(R),this.average.length>this.maxAverageCount&&this.average.shift();let A;return this.initial.length<this.maxInitialCount?this.initial.push(R):A=this.initial.reduce((m,k)=>m+k,0)/this.initial.length,this.lastMeasurement={initial:A,current:R,average:this.average.reduce((m,k)=>m+k,0)/this.average.length,high:(()=>typeof A>"u"?!1:R>this.highLatencyMaxThreshold||R>this.highLatencyMinThreshold&&R>A*this.highLatencyMultiple)()},this.lastMeasurement}}}),define(Se[344],De([1,0,32,17,15,10,24,2,5,258,43,148,343]),function(ne,e,y,M,l,R,A,m,k,$,P,C,v){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$LJ=e.$KJ=void 0,e.$KJ=(0,k.$Lh)("pathService");let D=S=class{constructor(s,c,u,o){this.d=s,this.e=c,this.f=u,this.g=o,this.a=(async()=>(await this.e.getEnvironment())?.os||R.OS)(),this.b=(async()=>{const g=await this.e.getEnvironment();return this.c=g?.userHome??s})()}hasValidBasename(s,c,u){return typeof c=="string"||typeof c>"u"?this.a.then(o=>this.h(s,o,c)):this.h(s,c,u)}h(s,c,u){return s.scheme===M.Schemas.file||s.scheme===M.Schemas.vscodeRemote?(0,y.$Tf)(u??(0,A.$pg)(s),c===1):!0}get defaultUriScheme(){return S.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(s,c){if(s.remoteAuthority)return M.Schemas.vscodeRemote;const u=(0,$.$HJ)(c.getWorkspace());if(u)return u;const o=c.getWorkspace().folders[0];if(o)return o.uri.scheme;const g=c.getWorkspace().configuration;return g?g.scheme:M.Schemas.file}userHome(s){return s?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(s=>s===1?l.$dc:l.$ec)}async fileURI(s){let c="";if(await this.a===1&&(s=s.replace(/\\/g,"/")),s[0]==="/"&&s[1]==="/"){const o=s.indexOf("/",2);o===-1?(c=s.substring(2),s="/"):(c=s.substring(2,o),s=s.substring(o)||"/")}return m.URI.from({scheme:M.Schemas.file,authority:c,path:s,query:"",fragment:""})}};e.$LJ=D,e.$LJ=D=S=Ke([We(1,v.$lm),We(2,C.$tJ),We(3,P.$Uh)],D)}),define(Se[345],De([1,0,225,19,56,4,51,3,2,49,230,14,65,260,86,43,148,27,21,18,23,41]),function(ne,e,y,M,l,R,A,m,k,$,P,C,v,S,D,E,s,c,u,o,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EJ=e.$DJ=e.$CJ=e.OnPortForward=e.$BJ=e.$AJ=e.$zJ=e.$yJ=e.$xJ=e.TunnelSource=e.TunnelCloseReason=e.$wJ=e.$vJ=e.$uJ=void 0;const t=10*1e3,n="remote.tunnels.toRestore";e.$uJ="onTunnel",e.$vJ=new d.$3i("forwardedPortsViewEnabled",!1,y.localize(0,null));function r(O){const T=O.match(/^([a-zA-Z0-9_-]+(?:\.[a-zA-Z0-9_-]+)*:)?([0-9]+)$/);if(T)return{host:T[1]?.substring(0,T[1].length-1)||"localhost",port:Number(T[2])}}e.$wJ=r;var i;(function(O){O.Other="Other",O.User="User",O.AutoForwardEnd="AutoForwardEnd"})(i||(e.TunnelCloseReason=i={}));var a;(function(O){O[O.User=0]="User",O[O.Auto=1]="Auto",O[O.Extension=2]="Extension"})(a||(e.TunnelSource=a={})),e.$xJ={source:a.User,description:y.localize(1,null)},e.$yJ={source:a.Auto,description:y.localize(2,null)};function h(O,T,F){const U=O.get(I(T,F));if(U)return U;if((0,D.$7u)(T))for(const N of D.$6u){const j=I(N,F);if(O.has(j))return O.get(j)}else if((0,D.$9u)(T))for(const N of D.$8u){const j=I(N,F);if(O.has(j))return O.get(j)}}e.$zJ=h;function p(O,T,F){const U=h(O,T,F);if(U)return U;const N=(0,D.$9u)(T)?"localhost":(0,D.$7u)(T)?"0.0.0.0":void 0;if(N)return h(O,N,F)}e.$AJ=p;function I(O,T){return O+":"+T}e.$BJ=I;var w;(function(O){O.Notify="notify",O.OpenBrowser="openBrowser",O.OpenBrowserOnce="openBrowserOnce",O.OpenPreview="openPreview",O.Silent="silent",O.Ignore="ignore"})(w||(e.OnPortForward=w={}));function f(O){return O&&"host"in O&&typeof O.host=="string"&&"port"in O&&typeof O.port=="number"&&(!("detail"in O)||typeof O.detail=="string")&&(!("pid"in O)||typeof O.pid=="string")}e.$CJ=f;class b extends m.$Qc{constructor(T){super(),this.r=T,this.j=[],this.n=new R.$Ld,this.onDidChangeAttributes=this.n.event,this.B(T.onDidChangeConfiguration(F=>{(F.affectsConfiguration(b.c)||F.affectsConfiguration(b.f))&&this.s()})),this.s()}s(){this.j=this.y(),this.n.fire()}getAttributes(T,F,U){let N=this.w(T,F,U,this.j,0);const j={label:void 0,onAutoForward:void 0,elevateIfNeeded:void 0,requireLocalPort:void 0,protocol:void 0};for(;N>=0;){const z=this.j[N];z.key===T?(j.onAutoForward=z.onAutoForward??j.onAutoForward,j.elevateIfNeeded=z.elevateIfNeeded!==void 0?z.elevateIfNeeded:j.elevateIfNeeded,j.label=z.label??j.label,j.requireLocalPort=z.requireLocalPort,j.protocol=z.protocol):(j.onAutoForward=j.onAutoForward??z.onAutoForward,j.elevateIfNeeded=j.elevateIfNeeded!==void 0?j.elevateIfNeeded:z.elevateIfNeeded,j.label=j.label??z.label,j.requireLocalPort=j.requireLocalPort!==void 0?j.requireLocalPort:void 0,j.protocol=j.protocol??z.protocol),N=this.w(T,F,U,this.j,N+1)}return j.onAutoForward!==void 0||j.elevateIfNeeded!==void 0||j.label!==void 0||j.requireLocalPort!==void 0||j.protocol!==void 0?j:this.C()}t(T){return T.start!==void 0&&T.end!==void 0}u(T){return T.host!==void 0&&T.port!==void 0&&(0,o.$wf)(T.host)&&(0,o.$Af)(T.port)}w(T,F,U,N,j){if(j>=N.length)return-1;const z=!(0,D.$7u)(F)&&!(0,D.$9u)(F),ae=N.slice(j).findIndex(X=>(0,o.$Af)(X.key)?z?!1:X.key===T:this.t(X.key)?z?!1:T>=X.key.start&&T<=X.key.end:this.u(X.key)?T===X.key.port&&F===X.key.host:U?X.key.test(U):!1);return ae>=0?ae+j:-1}y(){const T=this.r.getValue(b.c);if(!T||!(0,o.$yf)(T))return[];const F=[];for(const N in T){if(N===void 0)continue;const j=T[N];let z;if(Number(N))z=Number(N);else if((0,o.$wf)(N))if(b.g.test(N)){const B=N.match(b.g);z={start:Number(B[1]),end:Number(B[2])}}else if(b.h.test(N)){const B=N.match(b.h);z={host:B[1],port:Number(B[2])}}else{let B;try{B=RegExp(N)}catch{}B&&(z=B)}z&&F.push({key:z,elevateIfNeeded:j.elevateIfNeeded,onAutoForward:j.onAutoForward,label:j.label,requireLocalPort:j.requireLocalPort,protocol:j.protocol})}const U=this.r.getValue(b.f);return U&&(this.m={elevateIfNeeded:U.elevateIfNeeded,label:U.label,onAutoForward:U.onAutoForward,requireLocalPort:U.requireLocalPort,protocol:U.protocol}),this.z(F)}z(T){function F(U,N){return(0,o.$Af)(U.key)?U.key:N.t(U.key)?U.key.start:N.u(U.key)?U.key.port:Number.MAX_VALUE}return T.sort((U,N)=>F(U,this)-F(N,this))}C(){return this.m}static providedActionToAction(T){switch(T){case D.ProvidedOnAutoForward.Notify:return w.Notify;case D.ProvidedOnAutoForward.OpenBrowser:return w.OpenBrowser;case D.ProvidedOnAutoForward.OpenBrowserOnce:return w.OpenBrowserOnce;case D.ProvidedOnAutoForward.OpenPreview:return w.OpenPreview;case D.ProvidedOnAutoForward.Silent:return w.Silent;case D.ProvidedOnAutoForward.Ignore:return w.Ignore;default:return}}async addAttributes(T,F,U){const j=this.r.inspect(b.c).userRemoteValue;let z;!j||!(0,o.$yf)(j)?z={}:z=(0,g.$Xm)(j),z[`${T}`]||(z[`${T}`]={});for(const B in F)z[`${T}`][B]=F[B];return this.r.updateValue(b.c,z,U)}}e.$DJ=b,b.c="remote.portsAttributes",b.f="remote.otherPortsAttributes",b.g=/^(\d+)\-(\d+)$/,b.h=/^([a-z0-9\-]+):(\d{1,5})$/;let L=class extends m.$Qc{constructor(T,F,U,N,j,z,B,ae,X,Q){super(),this.H=T,this.I=F,this.J=U,this.L=N,this.M=j,this.N=z,this.O=B,this.P=ae,this.Q=X,this.R=Q,this.c=new Map,this.g=new R.$Ld,this.onForwardPort=this.g.event,this.h=new R.$Ld,this.onClosePort=this.h.event,this.j=new R.$Ld,this.onPortName=this.j.event,this.n=new R.$Ld,this.onCandidatesChanged=this.n.event,this.t=new R.$Ld,this.onEnvironmentTunnelsSet=this.t.event,this.u=!1,this.w=void 0,this.z=!1,this.C=new R.$Ld,this.D=new Map,this.F=new Map,this.G=[],this.ab=new Date,this.configPortsAttributes=new b(U),this.s=this.Z(),this.B(this.configPortsAttributes.onDidChangeAttributes(this.gb,this)),this.forwarded=new Map,this.f=new Map,this.H.tunnels.then(async H=>{const te=await this.getAttributes(H.map(me=>({port:me.tunnelRemotePort,host:me.tunnelRemoteHost})));for(const me of H)if(me.localAddress){const le=I(me.tunnelRemoteHost,me.tunnelRemotePort),ye=p(this.m??new Map,me.tunnelRemoteHost,me.tunnelRemotePort);this.forwarded.set(le,{remotePort:me.tunnelRemotePort,remoteHost:me.tunnelRemoteHost,localAddress:me.localAddress,protocol:te?.get(me.tunnelRemotePort)?.protocol??D.TunnelProtocol.Http,localUri:await this.X(me.localAddress,te?.get(me.tunnelRemotePort)),localPort:me.tunnelLocalPort,runningProcess:ye?.detail,hasRunningProcess:!!ye,pid:ye?.pid,privacy:me.privacy,source:e.$xJ}),this.f.set(le,me)}}),this.detected=new Map,this.B(this.H.onTunnelOpened(async H=>{const te=I(H.tunnelRemoteHost,H.tunnelRemotePort);if(!p(this.forwarded,H.tunnelRemoteHost,H.tunnelRemotePort)&&!p(this.detected,H.tunnelRemoteHost,H.tunnelRemotePort)&&!p(this.c,H.tunnelRemoteHost,H.tunnelRemotePort)&&H.localAddress){const me=p(this.m??new Map,H.tunnelRemoteHost,H.tunnelRemotePort),le=(await this.getAttributes([{port:H.tunnelRemotePort,host:H.tunnelRemoteHost}]))?.get(H.tunnelRemotePort);this.forwarded.set(te,{remoteHost:H.tunnelRemoteHost,remotePort:H.tunnelRemotePort,localAddress:H.localAddress,protocol:le?.protocol??D.TunnelProtocol.Http,localUri:await this.X(H.localAddress,le),localPort:H.tunnelLocalPort,closeable:!0,runningProcess:me?.detail,hasRunningProcess:!!me,pid:me?.pid,privacy:H.privacy,source:e.$xJ})}await this.$(),this.f.set(te,H),this.g.fire(this.forwarded.get(te))})),this.B(this.H.onTunnelClosed(H=>this.W(H,i.Other))),this.U()}S(){return this.Q.extensions.find(T=>T.activationEvents?.includes(e.$uJ))?(this.R.createKey(e.$vJ.key,!0),!0):!1}U(){if(this.S())return;const T=this.B(this.Q.onDidRegisterExtensions(()=>{this.S()&&T.dispose()}))}async W(T,F){const U=I(T.host,T.port);this.forwarded.has(U)&&(this.forwarded.delete(U),await this.$(),this.h.fire(T))}X(T,F){if(T.startsWith("http"))return k.URI.parse(T);const U=F?.protocol??"http";return k.URI.parse(`${U}://${T}`)}async Y(){const T=this.N.getWorkspace(),F=T.configuration?(0,A.$zi)(T.configuration.path):T.folders.length>0?(0,A.$zi)(T.folders[0].uri.path):void 0;if(F===void 0){this.O.debug("Could not get workspace hash for forwarded ports storage key.");return}return`${n}.${this.L.remoteAuthority}.${F}`}async Z(){const T=this.I.get(n,1);if(T)return this.I.remove(n,1),await this.$(),T;const F=await this.Y();if(F)return this.I.get(F,0)}async restoreForwarded(){if(this.J.getValue("remote.restoreForwardedPorts")){const T=await this.s;if(T&&T!==this.y){const F=JSON.parse(T)??[];this.O.trace(`ForwardedPorts: (TunnelModel) restoring ports ${F.map(U=>U.remotePort).join(", ")}`);for(const U of F){const N=p(this.detected,U.remoteHost,U.remotePort);U.source.source!==a.Extension&&!N||U.source.source===a.Extension&&N?await this.cb({remote:{host:U.remoteHost,port:U.remotePort},local:U.localPort,name:U.name,privacy:U.privacy,elevateIfNeeded:!0,source:U.source}):U.source.source===a.Extension&&!N&&this.D.set(I(U.remoteHost,U.remotePort),U)}}}if(this.z=!0,this.C.fire(),!this.w){const T=await this.Y();this.w=this.B(new m.$Pc),this.w.add(this.I.onDidChangeValue(0,void 0,this.w)(async F=>{F.key===T&&(this.s=Promise.resolve(this.I.get(T,0)),await this.restoreForwarded())}))}}async $(){if(this.J.getValue("remote.restoreForwardedPorts")){const T=JSON.stringify(Array.from(this.forwarded.values()));if(T!==this.y){this.y=T;const F=await this.Y();F&&this.I.store(F,this.y,0,0)}}}async bb(T,F,U){if(!T.tunnelLocalPort||!U?.requireLocalPort||T.tunnelLocalPort===F)return;const N=new Date;if(this.ab.getTime()+t>N.getTime())return;this.ab=N;const j=y.localize(3,null,F,T.tunnelRemotePort,T.tunnelLocalPort);return this.P.info(j)}async forward(T,F){return!this.z&&this.L.remoteAuthority&&await R.Event.toPromise(this.C.event),this.cb(T,F)}async cb(T,F){await this.Q.activateByEvent(e.$uJ);const U=p(this.forwarded,T.remote.host,T.remote.port);F=F??(F!==null?(await this.getAttributes([T.remote]))?.get(T.remote.port):void 0);const N=T.local!==void 0?T.local:T.remote.port;let j;if(U)return this.eb(U,T,F);{const z=this.L.remoteAuthority,B=z?{getAddress:async()=>(await this.M.resolveAuthority(z)).authority}:void 0,ae=I(T.remote.host,T.remote.port);this.c.set(ae,!0),T=this.db(ae,T);const X=await this.H.openTunnel(B,T.remote.host,T.remote.port,void 0,N,T.elevateIfNeeded?T.elevateIfNeeded:F?.elevateIfNeeded,T.privacy,F?.protocol);if(typeof X=="string")j=X;else if(X&&X.localAddress){const Q=p(this.m??new Map,T.remote.host,T.remote.port),H=X.protocol?X.protocol===D.TunnelProtocol.Https?D.TunnelProtocol.Https:D.TunnelProtocol.Http:F?.protocol??D.TunnelProtocol.Http,te={remoteHost:X.tunnelRemoteHost,remotePort:X.tunnelRemotePort,localPort:X.tunnelLocalPort,name:F?.label??T.name,closeable:!0,localAddress:X.localAddress,protocol:H,localUri:await this.X(X.localAddress,F),runningProcess:Q?.detail,hasRunningProcess:!!Q,pid:Q?.pid,source:T.source??e.$xJ,privacy:X.privacy};return this.forwarded.set(ae,te),this.f.set(ae,X),this.c.delete(ae),await this.$(),await this.bb(X,N,F),this.g.fire(te),X}this.c.delete(ae)}return j}db(T,F){const U=this.D.has(T)?this.D:this.F.has(T)?this.F:void 0;if(U){const N=U.get(T);U.delete(T),N&&(F.name=N.name??F.name,F.local=("local"in N?N.local:"localPort"in N?N.localPort:void 0)??F.local,F.privacy=N.privacy??F.privacy)}return F}async eb(T,F,U){const N=U?.label??F.name;let j;(function(B){B[B.None=0]="None",B[B.Fire=1]="Fire",B[B.Reopen=2]="Reopen"})(j||(j={}));let z=j.None;switch(N!==T.name&&(T.name=N,z=j.Fire),(U?.protocol||T.protocol!==D.TunnelProtocol.Http)&&U?.protocol!==T.protocol&&(F.source=T.source,z=j.Reopen),F.privacy&&T.privacy!==F.privacy&&(z=j.Reopen),z){case j.Fire:{this.g.fire();break}case j.Reopen:await this.close(T.remoteHost,T.remotePort,i.User),await this.cb(F,U)}return p(this.f,F.remote.host,F.remote.port)}async name(T,F,U){const N=p(this.forwarded,T,F),j=I(T,F);if(N){N.name=U,await this.$(),this.j.fire({host:T,port:F});return}else this.detected.has(j)&&(this.detected.get(j).name=U,this.j.fire({host:T,port:F}))}async close(T,F,U){const N=I(T,F),j=this.forwarded.get(N);return U===i.AutoForwardEnd&&j&&j.source.source===a.Auto&&this.F.set(N,{local:j.localPort,name:j.name,privacy:j.privacy}),await this.H.closeTunnel(T,F),this.W({host:T,port:F},U)}address(T,F){const U=I(T,F);return(this.forwarded.get(U)||this.detected.get(U))?.localAddress}get environmentTunnelsSet(){return this.u}addEnvironmentTunnels(T){if(T)for(const F of T){const U=p(this.m??new Map,F.remoteAddress.host,F.remoteAddress.port),N=typeof F.localAddress=="string"?F.localAddress:I(F.localAddress.host,F.localAddress.port);this.detected.set(I(F.remoteAddress.host,F.remoteAddress.port),{remoteHost:F.remoteAddress.host,remotePort:F.remoteAddress.port,localAddress:N,protocol:D.TunnelProtocol.Http,localUri:this.X(N),closeable:!1,runningProcess:U?.detail,hasRunningProcess:!!U,pid:U?.pid,privacy:D.TunnelPrivacyId.ConstantPrivate,source:{source:a.Extension,description:y.localize(4,null)}}),this.H.setEnvironmentTunnel(F.remoteAddress.host,F.remoteAddress.port,N,D.TunnelPrivacyId.ConstantPrivate,D.TunnelProtocol.Http)}this.u=!0,this.t.fire(),this.g.fire()}setCandidateFilter(T){this.r=T}async setCandidates(T){let F=T;this.r&&(F=await this.r(T));const U=this.fb(F);this.O.trace(`ForwardedPorts: (TunnelModel) removed candidates ${Array.from(U.values()).map(N=>N.port).join(", ")}`),this.n.fire(U)}fb(T){const F=this.m??new Map,U=new Map;return this.m=U,T.forEach(N=>{const j=I(N.host,N.port);U.set(j,{host:N.host,port:N.port,detail:N.detail,pid:N.pid}),F.has(j)&&F.delete(j);const z=p(this.forwarded,N.host,N.port);z&&(z.runningProcess=N.detail,z.hasRunningProcess=!0,z.pid=N.pid)}),F.forEach((N,j)=>{const z=r(j);if(!z)return;const B=p(this.forwarded,z.host,z.port);B&&(B.runningProcess=void 0,B.hasRunningProcess=!1,B.pid=void 0);const ae=p(this.detected,z.host,z.port);ae&&(ae.runningProcess=void 0,ae.hasRunningProcess=!1,ae.pid=void 0)}),F}get candidates(){return this.m?Array.from(this.m.values()):[]}get candidatesOrUndefined(){return this.m?this.candidates:void 0}async gb(){const T=Array.from(this.forwarded.values()),F=await this.getAttributes(T.map(U=>({port:U.remotePort,host:U.remoteHost})),!1);if(F)for(const U of T){const N=F.get(U.remotePort);(N?.protocol||U.protocol!==D.TunnelProtocol.Http)&&N?.protocol!==U.protocol&&await this.cb({remote:{host:U.remoteHost,port:U.remotePort},local:U.localPort,name:U.name,source:U.source},N),N&&N.label&&N.label!==U.name&&await this.name(U.remoteHost,U.remotePort,N.label)}}async getAttributes(T,F=!0){const U=new Map,N=new Map;T.forEach(X=>{const Q=p(this.m??new Map,D.$6u[0],X.port)??X;if(Q){U.set(X.port,Q);const H=f(Q)?Q.pid:void 0;N.has(H)||N.set(H,[]),N.get(H)?.push(X.port)}});const j=new Map;if(T.forEach(X=>{const Q=this.configPortsAttributes.getAttributes(X.port,X.host,U.get(X.port)?.detail);Q&&j.set(X.port,Q)}),this.G.length===0||!F)return j.size>0?j:void 0;const z=await Promise.all((0,M.$Pb)(this.G.map(X=>Array.from(N.entries()).map(Q=>{const H=Q[1],te=U.get(H[0]);return X.providePortAttributes(H,te?.pid,te?.detail,new u.$Vd().token)})))),B=new Map;if(z.forEach(X=>X.forEach(Q=>{Q&&B.set(Q.port,Q)})),!j&&!B)return;const ae=new Map;return T.forEach(X=>{const Q=j.get(X.port),H=B.get(X.port);ae.set(X.port,{elevateIfNeeded:Q?.elevateIfNeeded,label:Q?.label,onAutoForward:Q?.onAutoForward??b.providedActionToAction(H?.autoForwardAction),requireLocalPort:Q?.requireLocalPort,protocol:Q?.protocol})}),ae}addAttributesProvider(T){this.G.push(T)}};e.$EJ=L,Ke([(0,l.$eh)(1e3)],L.prototype,"$",null),e.$EJ=L=Ke([We(0,D.$2u),We(1,S.$Xo),We(2,$.$fi),We(3,s.$tJ),We(4,v.$Kk),We(5,E.$Uh),We(6,C.$6i),We(7,P.$tv),We(8,c.$4E),We(9,d.$4i)],L)}),define(Se[93],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$uI=e.$tI=void 0;class y{constructor(A,m){this.line=A,this.character=m}isBefore(A){return!1}isBeforeOrEqual(A){return!1}isAfter(A){return!1}isAfterOrEqual(A){return!1}isEqual(A){return!1}compareTo(A){return 0}translate(A,m){return new y(0,0)}with(A){return new y(0,0)}}e.$tI=y;class M{constructor(A,m,k,$){this.isEmpty=!1,this.isSingleLine=!1,this.start=new y(A,m),this.end=new y(k,$)}contains(A){return!1}isEqual(A){return!1}intersection(A){}union(A){return new M(0,0,0,0)}with(A){return new M(0,0,0,0)}}e.$uI=M;var l;(function(R){R[R.Information=1]="Information",R[R.Warning=2]="Warning"})(l||(e.TextSearchCompleteMessageType=l={}))}),define(Se[36],De([1,0,19,34,23,32,16,5,15,8,93,9]),function(ne,e,y,M,l,R,A,m,k,$,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VI=e.$UI=e.$TI=e.$SI=e.$RI=e.$QI=e.$PI=e.$OI=e.$NI=e.$MI=e.$LI=e.$KI=e.SearchErrorCode=e.$JI=e.$II=e.SearchSortOrder=e.ViewMode=e.$HI=e.$GI=e.$FI=e.$EI=e.SearchCompletionExitCode=e.$DI=e.$CI=e.$BI=e.QueryType=e.SearchProviderType=e.$AI=e.$zI=e.$yI=e.$xI=e.$wI=e.$vI=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return P.TextSearchCompleteMessageType}}),e.$vI="workbench.view.search",e.$wI="workbench.panel.search",e.$xI="workbench.view.search",e.$yI="search-result",e.$zI="search.exclude";const v="\u27EA ",S=" characters skipped \u27EB",D=(v.length+S.length+5)*2;e.$AI=(0,m.$Lh)("searchService");var E;(function(H){H[H.file=0]="file",H[H.text=1]="text"})(E||(e.SearchProviderType=E={}));var s;(function(H){H[H.File=1]="File",H[H.Text=2]="Text"})(s||(e.QueryType=s={}));function c(H){return!!H.preview}e.$BI=c;function u(H){return!!H.resource}e.$CI=u;function o(H){return!!H.message}e.$DI=o;var g;(function(H){H[H.Normal=0]="Normal",H[H.NewSearchStarted=1]="NewSearchStarted"})(g||(e.SearchCompletionExitCode=g={}));class d{constructor(te){this.resource=te,this.results=[]}}e.$EI=d;class t{constructor(te,me,le,ye){this.ranges=me,this.webviewIndex=ye;const de=Array.isArray(me)?me:[me];if(le&&le.matchLines===1&&n(de)){te=(0,A.$pf)(te,le.matchLines);let V="",J=0,ee=0;const Y=Math.floor(le.charsPerLine/5),Z=[];for(const _ of de){const pe=Math.max(_.startColumn-Y,0),se=_.startColumn+le.charsPerLine;if(pe>ee+Y+D){const ge=v+(pe-ee)+S;V+=ge+te.slice(pe,se),J+=pe-(ee+ge.length)}else V+=te.slice(ee,se);Z.push(new i(0,_.startColumn-J,_.endColumn-J)),ee=se}this.preview={text:V,matches:Array.isArray(this.ranges)?Z:Z[0]}}else{const V=Array.isArray(me)?me[0].startLineNumber:me.startLineNumber;this.preview={text:te,matches:(0,y.$Zb)(me,J=>new r(J.startLineNumber-V,J.startColumn,J.endLineNumber-V,J.endColumn))}}}}e.$FI=t;function n(H){const te=H[0].startLineNumber;for(const me of H)if(me.startLineNumber!==te||me.endLineNumber!==te)return!1;return!0}class r{constructor(te,me,le,ye){this.startLineNumber=te,this.startColumn=me,this.endLineNumber=le,this.endColumn=ye}}e.$GI=r;class i extends r{constructor(te,me,le){super(te,me,te,le)}}e.$HI=i;var a;(function(H){H.List="list",H.Tree="tree"})(a||(e.ViewMode=a={}));var h;(function(H){H.Default="default",H.FileNames="fileNames",H.Type="type",H.Modified="modified",H.CountDescending="countDescending",H.CountAscending="countAscending"})(h||(e.SearchSortOrder=h={}));function p(H,te=!0){const me=H&&H.files&&H.files.exclude,le=te&&H&&H.search&&H.search.exclude;if(!me&&!le)return;if(!me||!le)return me||le;let ye=Object.create(null);return ye=l.$1m(ye,l.$Xm(me)),ye=l.$1m(ye,l.$Xm(le),!0),ye}e.$II=p;function I(H,te){return H.excludePattern&&M.$rj(H.excludePattern,te)?!1:H.includePattern||H.usingSearchPaths?H.includePattern&&M.$rj(H.includePattern,te)?!0:H.usingSearchPaths?!!H.folderQueries&&H.folderQueries.some(me=>{const le=me.folder.fsPath;if(R.$Vf(te,le)){const ye=k.$jc(le,te);return!me.includePattern||!!M.$rj(me.includePattern,ye)}else return!1}):!1:!0}e.$JI=I;var w;(function(H){H[H.unknownEncoding=1]="unknownEncoding",H[H.regexParseError=2]="regexParseError",H[H.globParseError=3]="globParseError",H[H.invalidLiteral=4]="invalidLiteral",H[H.rgProcessError=5]="rgProcessError",H[H.other=6]="other",H[H.canceled=7]="canceled"})(w||(e.SearchErrorCode=w={}));class f extends Error{constructor(te,me){super(te),this.code=me}}e.$KI=f;function b(H){const te=H.message;if((0,$.$2)(H))return new f(te,w.canceled);try{const me=JSON.parse(te);return new f(me.message,me.code)}catch{return new f(te,w.other)}}e.$LI=b;function L(H){const te={message:H.message,code:H.code};return new Error(JSON.stringify(te))}e.$MI=L;function O(H){return H.type==="error"?!0:H.type==="success"}e.$NI=O;function T(H){return H.type==="success"}e.$OI=T;function F(H){return!!H.path}e.$PI=F;function U(H,te){const me=H.searchPath?H.searchPath:H.relativePath;return(0,A.$mf)(me,te)}e.$QI=U;class N{constructor(te){this.path=te,this.results=[]}addMatch(te){this.results.push(te)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$RI=N;function j(H,te){const me={...H||{},...te||{}};return Object.keys(me).filter(le=>{const ye=me[le];return typeof ye=="boolean"&&ye})}e.$SI=j;class z{constructor(te,me){this.c=null,this.a={...te.excludePattern||{},...me.excludePattern||{}},this.b=M.$sj(this.a);let le=te.includePattern;me.includePattern&&(le?le={...le,...me.includePattern}:le=me.includePattern),le&&(this.c=M.$sj(le))}matchesExcludesSync(te,me,le){return!!(this.b&&this.b(te,me,le))}includedInQuerySync(te,me,le){return!(this.b&&this.b(te,me,le)||this.c&&!this.c(te,me,le))}includedInQuery(te,me,le){const ye=this.b(te,me,le),de=()=>this.c?!!this.c(te,me,le):!0;return(0,C.$Dg)(ye)?ye.then(V=>V?!1:de()):de()}hasSiblingExcludeClauses(){return B(this.a)}}e.$TI=z;function B(H){for(const te in H)if(typeof H[te]!="boolean")return!0;return!1}function ae(H){if(!H)return;let te;return me=>(te||(te=(H()||Promise.resolve([])).then(le=>le?Q(le):{})),te.then(le=>!!le[me]))}e.$UI=ae;function X(H){if(!H)return;let te;return me=>{if(!te){const le=H();te=le?Q(le):{}}return!!te[me]}}e.$VI=X;function Q(H){const te={};for(const me of H)te[me]=!0;return te}}),define(Se[37],De([1,0,19,9,21,4,3,78,17,121,24,16,2,214,5,14,243,43,54,26,20,13,7,67,36,6]),function(ne,e,y,M,l,R,A,m,k,$,P,C,v,S,D,E,s,c,u,o,g,d,t,n,r,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mbc=e.$Lbc=void 0;function a(O,T,F){return new P.$hg(U=>w(U,F)).isEqual(O,T)}function h(O,T,F){return a(O.uri,T.uri,F)?0:(0,C.$Se)(O.uri.toString(),T.uri.toString())}function p(O,T,F){return O.index!==T.index?O.index<T.index?-1:1:a(O.uri,T.uri,F)?(0,C.$Se)(O.name,T.name):(0,C.$Se)(O.uri.toString(),T.uri.toString())}function I(O,T,F,U){const N=O.slice(0).sort((z,B)=>F(z,B,U)),j=T.slice(0).sort((z,B)=>F(z,B,U));return(0,y.$Cb)(N,j,(z,B)=>F(z,B,U))}function w(O,T){const F=T.getCapabilities(O.scheme);return!(F&&F&1024)}class f extends c.$5h{static toExtHostWorkspace(T,F,U,N){if(!T)return{workspace:null,added:[],removed:[]};const{id:j,name:z,folders:B,configuration:ae,transient:X,isUntitled:Q}=T,H=[],te=F;F?B.forEach((de,V)=>{const J=v.URI.revive(de.uri),ee=f.o(U||F,J,N);ee?(ee.name=de.name,ee.index=de.index,H.push(ee)):H.push({uri:J,name:de.name,index:V})}):H.push(...B.map(({uri:de,name:V,index:J})=>({uri:v.URI.revive(de),name:V,index:J}))),H.sort((de,V)=>de.index<V.index?-1:1);const me=new f(j,z,H,!!X,ae?v.URI.revive(ae):null,!!Q,de=>w(de,N)),{added:le,removed:ye}=I(te?te.workspaceFolders:[],me.workspaceFolders,h,N);return{workspace:me,added:le,removed:ye}}static o(T,F,U){for(let N=0;N<T.folders.length;N++){const j=T.workspaceFolders[N];if(a(j.uri,F,U))return j}}constructor(T,F,U,N,j,z,B){super(T,U.map(ae=>new c.$6h(ae)),N,j,B),this.t=F,this.u=z,this.q=[],this.s=m.$Rh.forUris(B),U.forEach(ae=>{this.q.push(ae),this.s.set(ae.uri,ae)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(T,F){return F&&this.s.get(T)&&(T=(0,P.$rg)(T)),this.s.findSubstr(T)}resolveWorkspaceFolder(T){return this.s.get(T)}}let b=class{constructor(T,F,U,N,j){this.c=new R.$Ld,this.onDidChangeWorkspace=this.c.event,this.g=new R.$Ld,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.z=0,this.A=new R.$Nd,this.B=new Map,this.h=N,this.s=U,this.t=j,this.j=new $.$Ll,this.k=new M.$Pg,this.o=T.getProxy(i.$9J.MainThreadWorkspace),this.q=T.getProxy(i.$9J.MainThreadMessageService);const z=F.workspace;this.l=z?new f(z.id,z.name,[],!!z.transient,z.configuration?v.URI.revive(z.configuration):null,!!z.isUntitled,B=>w(B,U)):void 0}$initializeWorkspace(T,F){this.v=F,this.$acceptWorkspaceData(T),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?v.URI.from({scheme:k.Schemas.untitled,path:(0,P.$pg)((0,P.$rg)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(T,F,U,...N){const j=[];if(Array.isArray(N)&&N.forEach(Q=>{v.URI.isUri(Q.uri)&&!j.some(H=>a(H.uri,Q.uri,this.s))&&j.push({uri:Q.uri,name:Q.name||(0,P.$og)(Q.uri)})}),this.n||[F,U].some(Q=>typeof Q!="number"||Q<0)||U===0&&j.length===0)return!1;const z=this.x?this.x.workspaceFolders:[];if(F+U>z.length)return!1;const B=z.slice(0);B.splice(F,U,...j.map(Q=>({uri:Q.uri,name:Q.name||(0,P.$og)(Q.uri),index:void 0})));for(let Q=0;Q<B.length;Q++){const H=B[Q];if(B.some((te,me)=>me!==Q&&a(H.uri,te.uri,this.s)))return!1}B.forEach((Q,H)=>Q.index=H);const{added:ae,removed:X}=I(z,B,p,this.s);if(ae.length===0&&X.length===0)return!1;if(this.o){const Q=T.displayName||T.name;this.o.$updateWorkspaceFolders(Q,F,U,j).then(void 0,H=>{this.n=void 0;const te={source:{identifier:T.identifier,label:T.displayName||T.name}};this.q.$showMessage(s.Severity.Error,(0,S.localize)(0,null,Q,H.toString()),te,[])})}return this.y(B),!0}getWorkspaceFolder(T,F){if(this.x)return this.x.getWorkspaceFolder(T,F)}async getWorkspaceFolder2(T,F){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(T,F)}async resolveWorkspaceFolder(T){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(T)}getPath(){if(!this.x)return;const{folders:T}=this.x;if(T.length!==0)return T[0].uri.fsPath}getRelativePath(T,F){let U,N="";if(typeof T=="string"?(U=v.URI.file(T),N=T):typeof T<"u"&&(U=T,N=T.fsPath),!U)return N;const j=this.getWorkspaceFolder(U,!0);if(!j)return N;typeof F>"u"&&this.x&&(F=this.x.folders.length>1);let z=(0,P.$ug)(j.uri,U);return F&&j.name&&(z=`${j.name}/${z}`),z}y(T){this.x&&(this.n=f.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:T,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(T){const{workspace:F,added:U,removed:N}=f.toExtHostWorkspace(T,this.l,this.n,this.s);this.l=F||void 0,this.n=void 0,this.c.fire(Object.freeze({added:U,removed:N}))}findFiles(T,F,U,N,j=l.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${N.value}, entryPoint: findFiles`);let z;if(F===null?z=!1:F&&(typeof F=="string"?z=F:z=F.pattern),j&&j.isCancellationRequested)return Promise.resolve([]);const{includePattern:B,folder:ae}=L(d.GlobPattern.from(T));return this.o.$startFileSearch(B??null,ae??null,z??null,U??null,j).then(X=>Array.isArray(X)?X.map(Q=>v.URI.revive(Q)):[])}async findTextInFiles(T,F,U,N,j=l.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${N.value}, entryPoint: findTextInFiles`);const z=this.j.getNext(),B=typeof F.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:F.previewOptions,{includePattern:ae,folder:X}=L(d.GlobPattern.from(F.include)),Q=typeof F.exclude=="string"?F.exclude:F.exclude?F.exclude.pattern:void 0,H={ignoreSymlinks:typeof F.followSymlinks=="boolean"?!F.followSymlinks:void 0,disregardIgnoreFiles:typeof F.useIgnoreFiles=="boolean"?!F.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof F.useGlobalIgnoreFiles=="boolean"?!F.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof F.useParentIgnoreFiles=="boolean"?!F.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof F.useDefaultExcludes=="boolean"?!F.useDefaultExcludes:!0,fileEncoding:F.encoding,maxResults:F.maxResults,previewOptions:B,afterContext:F.afterContext,beforeContext:F.beforeContext,includePattern:ae,excludePattern:Q},te=!1;if(this.u[z]=me=>{if(te)return;const le=v.URI.revive(me.resource);me.results.forEach(ye=>{(0,r.$BI)(ye)?U({uri:le,preview:{text:ye.preview.text,matches:(0,y.$Zb)(ye.preview.matches,de=>new t.$aK(de.startLineNumber,de.startColumn,de.endLineNumber,de.endColumn))},ranges:(0,y.$Zb)(ye.ranges,de=>new t.$aK(de.startLineNumber,de.startColumn,de.endLineNumber,de.endColumn))}):U({uri:le,text:ye.text,lineNumber:ye.lineNumber})})},j.isCancellationRequested)return{};try{const me=await this.o.$startTextSearch(T,X??null,H,z,j);return delete this.u[z],me||{}}catch(me){throw delete this.u[z],me}}$handleTextSearchResult(T,F){this.u[F]?.(T)}async save(T){const F=await this.o.$save(T,{saveAs:!1});return v.URI.revive(F)}async saveAs(T){const F=await this.o.$save(T,{saveAs:!0});return v.URI.revive(F)}saveAll(T){return this.o.$saveAll(T)}resolveProxy(T){return this.o.$resolveProxy(T)}get trusted(){return this.v}requestWorkspaceTrust(T){return this.o.$requestWorkspaceTrust(T)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(T,F){if(this.w.has(T))throw new Error(`A provider has already been registered for scheme ${T}`);this.w.set(T,F);const U=this.t.transformOutgoingScheme(T),N=this.z++;return this.o.$registerEditSessionIdentityProvider(N,U),(0,A.$Oc)(()=>{this.w.delete(T),this.o.$unregisterEditSessionIdentityProvider(N)})}async $getEditSessionIdentifier(T,F){this.h.info("Getting edit session identifier for workspaceFolder",T);const U=await this.resolveWorkspaceFolder(v.URI.revive(T));if(!U){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",U);const N=this.w.get(U.uri.scheme);if(this.h.info(`Provider for scheme ${U.uri.scheme} is defined: `,!!N),!N)return;const j=await N.provideEditSessionIdentity(U,F);if(this.h.info("Provider returned edit session identifier: ",j),!!j)return j}async $provideEditSessionIdentityMatch(T,F,U,N){this.h.info("Getting edit session identifier for workspaceFolder",T);const j=await this.resolveWorkspaceFolder(v.URI.revive(T));if(!j){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",j);const z=this.w.get(j.uri.scheme);if(this.h.info(`Provider for scheme ${j.uri.scheme} is defined: `,!!z),!z)return;const B=await z.provideEditSessionIdentityMatch?.(F,U,N);if(this.h.info("Provider returned edit session identifier match result: ",B),!!B)return B}getOnWillCreateEditSessionIdentityEvent(T){return(F,U,N)=>{const j=function(B){F.call(U,B)};return j.extension=T,this.A.event(j,void 0,N)}}async $onWillCreateEditSessionIdentity(T,F,U){const N=await this.resolveWorkspaceFolder(v.URI.revive(T));if(N===void 0)throw new Error("Unable to resolve workspace folder");await this.A.fireAsync({workspaceFolder:N},F,async(j,z)=>{const B=Date.now();await Promise.resolve(j),Date.now()-B>U&&this.h.warn("SLOW edit session create-participant",z.extension.identifier)}),F.isCancellationRequested}registerCanonicalUriProvider(T,F){if(this.B.has(T))throw new Error(`A provider has already been registered for scheme ${T}`);this.B.set(T,F);const U=this.t.transformOutgoingScheme(T),N=this.z++;return this.o.$registerCanonicalUriProvider(N,U),(0,A.$Oc)(()=>{this.B.delete(T),this.o.$unregisterCanonicalUriProvider(N)})}async provideCanonicalUri(T,F,U){const N=this.B.get(T.scheme);if(!N)return;const j=await N.provideCanonicalUri?.(v.URI.revive(T),F,U);if(j)return j}async $provideCanonicalUri(T,F,U){return this.provideCanonicalUri(v.URI.revive(T),{targetScheme:F},U)}};e.$Lbc=b,e.$Lbc=b=Ke([We(0,g.$0L),We(1,o.$nM),We(2,u.$zbc),We(3,E.$6i),We(4,n.$Jbc)],b),e.$Mbc=(0,D.$Lh)("IExtHostWorkspace");function L(O){let T,F;return O&&(typeof O=="string"?T=O:(T=O.pattern,F=v.URI.revive(O.baseUri))),{includePattern:T,folder:F}}}),define(Se[40],De([1,0,23,4,37,6,7,245,137,18,9,5,20,14,2]),function(ne,e,y,M,l,R,A,m,k,$,P,C,v,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pbc=e.$Obc=e.$Nbc=void 0;function E(n,r){if(r){const i=r.split(".");let a=n;for(let h=0;a&&h<i.length;h++)a=a[i[h]];return a}}function s(n){return n instanceof D.URI}function c(n){return n&&n.uri instanceof D.URI&&n.languageId&&typeof n.languageId=="string"}function u(n){return n&&!n.uri&&n.languageId&&typeof n.languageId=="string"}function o(n){return n&&n.uri instanceof D.URI&&(!n.name||typeof n.name=="string")&&(!n.index||typeof n.index=="number")}function g(n){if(s(n))return{resource:n};if(c(n))return{resource:n.uri,overrideIdentifier:n.languageId};if(u(n))return{overrideIdentifier:n.languageId};if(o(n))return{resource:n.uri};if(n===null)return{resource:null}}let d=class{constructor(r,i,a){this.a=r.getProxy(R.$9J.MainThreadConfiguration),this.c=i,this.b=a,this.d=new P.$Pg,this.e=null}getConfigProvider(){return this.d.wait().then(r=>this.e)}$initializeConfiguration(r){this.e=new t(this.a,this.c,r,this.b),this.d.open()}$acceptConfigurationChanged(r,i){this.getConfigProvider().then(a=>a.$acceptConfigurationChanged(r,i))}};e.$Nbc=d,e.$Nbc=d=Ke([We(0,v.$0L),We(1,l.$Mbc),We(2,S.$6i)],d);class t{constructor(r,i,a,h){this.a=new M.$Ld,this.b=r,this.f=h,this.c=i,this.e=m.$vn.parse(a),this.d=this.k(a.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(r,i){const a={data:this.e.toData(),workspace:this.c.workspace};this.e=m.$vn.parse(r),this.d=this.k(r.configurationScopes),this.a.fire(this.j(i,a))}getConfiguration(r,i,a){const h=g(i)||{},p=this.g(r?E(this.e.getValue(void 0,h,this.c.workspace),r):this.e.getValue(void 0,h,this.c.workspace));r&&this.h(r,h,a?.identifier);function I(f){if(f==null)return null;if(typeof f=="boolean")return f?2:5;switch(f){case A.ConfigurationTarget.Global:return 2;case A.ConfigurationTarget.Workspace:return 5;case A.ConfigurationTarget.WorkspaceFolder:return 6}}const w={has(f){return typeof E(p,f)<"u"},get:(f,b)=>{this.h(r?`${r}.${f}`:f,h,a?.identifier);let L=E(p,f);if(typeof L>"u")L=b;else{let O;const T=(F,U)=>{if((0,$.$yf)(F)){let N;const j=()=>{O=O||(0,y.$Xm)(p),N=N||E(O,U)};return new Proxy(F,{get:(z,B)=>{if(typeof B=="string"&&B.toLowerCase()==="tojson")return j(),()=>N;if(O)return N=N||E(O,U),N[B];const ae=z[B];return typeof B=="string"?T(ae,`${U}.${B}`):ae},set:(z,B,ae)=>(j(),N&&(N[B]=ae),!0),deleteProperty:(z,B)=>(j(),N&&delete N[B],!0),defineProperty:(z,B,ae)=>(j(),N&&Object.defineProperty(N,B,ae),!0)})}return Array.isArray(F)?(0,y.$Xm)(F):F};L=T(L,f)}return L},update:(f,b,L,O)=>{f=r?`${r}.${f}`:f;const T=I(L);return b!==void 0?this.b.$updateConfigurationOption(T,f,b,h,O):this.b.$removeConfigurationOption(T,f,h,O)},inspect:f=>{f=r?`${r}.${f}`:f;const b=this.e.inspect(f,h,this.c.workspace);if(b)return{key:f,defaultValue:(0,y.$Xm)(b.policy?.value??b.default?.value),globalValue:(0,y.$Xm)(b.user?.value??b.application?.value),workspaceValue:(0,y.$Xm)(b.workspace?.value),workspaceFolderValue:(0,y.$Xm)(b.workspaceFolder?.value),defaultLanguageValue:(0,y.$Xm)(b.default?.override),globalLanguageValue:(0,y.$Xm)(b.user?.override??b.application?.override),workspaceLanguageValue:(0,y.$Xm)(b.workspace?.override),workspaceFolderLanguageValue:(0,y.$Xm)(b.workspaceFolder?.override),languageIds:(0,y.$Xm)(b.overrideIdentifiers)}}};return typeof p=="object"&&(0,y.$1m)(w,p,!1),Object.freeze(w)}g(r){const i=a=>(0,$.$yf)(a)?new Proxy(a,{get:(h,p)=>i(h[p]),set:(h,p,I)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(p)}' of object`)},deleteProperty:(h,p)=>{throw new Error(`TypeError: Cannot delete read only property '${String(p)}' of object`)},defineProperty:(h,p)=>{throw new Error(`TypeError: Cannot define property '${String(p)}' for a readonly object`)},setPrototypeOf:h=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):a;return i(r)}h(r,i,a){const h=k.$mn.test(r)?4:this.d.get(r),p=a?`[${a.value}] `:"";if(h===4){typeof i?.resource>"u"&&this.f.warn(`${p}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${r}', provide the URI of a resource or 'null' for any resource.`);return}if(h===3){i?.resource&&this.f.warn(`${p}Accessing a window scoped configuration for a resource is not expected. To associate '${r}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(r,i){const a=new m.$xn(r,i,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(h,p)=>a.affectsConfiguration(h,g(p))})}k(r){return r.reduce((i,a)=>(i.set(a[0],a[1]),i),new Map)}}e.$Obc=t,e.$Pbc=(0,C.$Lh)("IExtHostConfiguration")});var et=this&&this.__classPrivateFieldSet||function(ne,e,y,M,l){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!l:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?l.call(ne,y):l?l.value=y:e.set(ne,y),y},Be=this&&this.__classPrivateFieldGet||function(ne,e,y,M){if(y==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!M:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return y==="m"?M:y==="a"?M.call(ne):M?M.value:e.get(ne)};define(Se[94],De([1,0,2,9,4,6,7,37,70,40,21,44,20,26,5,17,10,14,90,290,8]),function(ne,e,y,M,l,R,A,m,k,$,P,C,v,S,D,E,s,c,u,o,g){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ncc=e.$Mcc=e.$Lcc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var t;(function(F){function U(j){if(j!=null)return j}F.from=U;function N(j){if(j!=null)return j}F.to=N})(t||(t={}));var n;(function(F){function U(j){if(j!=null)return j}F.from=U;function N(j){if(j!=null)return j}F.to=N})(n||(n={}));var r;(function(F){function U(j){if(j!=null)return j}F.from=U;function N(j){if(j!=null)return j}F.to=N})(r||(r={}));var i;(function(F){function U(z){if(z){const B=z;return B&&!!B.process}else return!1}F.is=U;function N(z){if(z==null)return;const B={process:z.process,args:z.args};return z.options&&(B.options=r.from(z.options)),B}F.from=N;function j(z){if(z!=null)return new A.$SK(z.process,z.args,z.options)}F.to=j})(i||(i={}));var a;(function(F){function U(j){if(j!=null)return j}F.from=U;function N(j){if(j!=null)return j}F.to=N})(a||(a={}));var h;(function(F){function U(z){if(z){const B=z;return B&&(!!B.commandLine||!!B.command)}else return!1}F.is=U;function N(z){if(z==null)return;const B={};return z.commandLine!==void 0?B.commandLine=z.commandLine:(B.command=z.command,B.args=z.args),z.options&&(B.options=a.from(z.options)),B}F.from=N;function j(z){if(!(z==null||z.command===void 0&&z.commandLine===void 0))return z.commandLine?new A.$TK(z.commandLine,z.options):new A.$TK(z.command,z.args?z.args:[],z.options)}F.to=j})(h||(h={}));var p;(function(F){function U(z){if(z){const B=z;return B&&B.customExecution==="customExecution"}else return!1}F.is=U;function N(z){return{customExecution:"customExecution"}}F.from=N;function j(z,B){return B.get(z)}F.to=j})(p||(e.CustomExecutionDTO=p={}));var I;(function(F){function U(N,j){let z;return N.scope!==void 0&&typeof N.scope!="number"?z=N.scope.uri:N.scope!==void 0&&typeof N.scope=="number"&&(N.scope===A.TaskScope.Workspace&&j&&j.workspaceFile?z=j.workspaceFile:z=o.$KF),{id:N._id,workspaceFolder:z}}F.from=U})(I||(e.TaskHandleDTO=I={}));var w;(function(F){function U(N){if(N!=null)return{_id:N.id,isDefault:N.isDefault}}F.from=U})(w||(w={}));var f;(function(F){function U(z,B){if(z==null)return[];const ae=[];for(const X of z){const Q=N(X,B);Q&&ae.push(Q)}return ae}F.fromMany=U;function N(z,B){if(z==null)return;let ae;z.execution instanceof A.$SK?ae=i.from(z.execution):z.execution instanceof A.$TK?ae=h.from(z.execution):z.execution&&z.execution instanceof A.$UK&&(ae=p.from(z.execution));const X=t.from(z.definition);let Q;return z.scope?typeof z.scope=="number"?Q=z.scope:Q=z.scope.uri:Q=A.TaskScope.Workspace,!X||!Q?void 0:{_id:z._id,definition:X,name:z.name,source:{extensionId:B.identifier.value,label:z.source,scope:Q},execution:ae,isBackground:z.isBackground,group:w.from(z.group),presentationOptions:n.from(z.presentationOptions),problemMatchers:z.problemMatchers,hasDefinedMatchers:z.hasDefinedMatchers,runOptions:z.runOptions?z.runOptions:{reevaluateOnRerun:!0},detail:z.detail}}F.from=N;async function j(z,B,ae){if(z==null)return;let X;i.is(z.execution)?X=i.to(z.execution):h.is(z.execution)?X=h.to(z.execution):p.is(z.execution)&&(X=p.to(z._id,ae));const Q=t.to(z.definition);let H;if(z.source&&(z.source.scope!==void 0?typeof z.source.scope=="number"?H=z.source.scope:H=await B.resolveWorkspaceFolder(y.URI.revive(z.source.scope)):H=A.TaskScope.Workspace),!Q||!H)return;const te=new A.$VK(Q,H,z.name,z.source.label,X,z.problemMatchers);return z.isBackground!==void 0&&(te.isBackground=z.isBackground),z.group!==void 0&&(te.group=A.$RK.from(z.group._id),te.group&&z.group.isDefault&&(te.group=new A.$RK(te.group.id,te.group.label),z.group.isDefault===!0&&(te.group.isDefault=z.group.isDefault))),z.presentationOptions&&(te.presentationOptions=n.to(z.presentationOptions)),z._id&&(te._id=z._id),z.detail&&(te.detail=z.detail),te}F.to=j})(f||(e.TaskDTO=f={}));var b;(function(F){function U(j){return j}F.from=U;function N(j){if(j)return Object.assign(Object.create(null),j)}F.to=N})(b||(b={}));class L{constructor(U,N,j){this._id=N,this.a=j,d.set(this,void 0),et(this,d,U,"f")}get task(){return this.a}terminate(){Be(this,d,"f").terminateTask(this)}fireDidStartProcess(U){}fireDidEndProcess(U){}}d=new WeakMap;let O=class{constructor(U,N,j,z,B,ae,X,Q){this.q=new l.$Ld,this.r=new l.$Ld,this.s=new l.$Ld,this.t=new l.$Ld,this.a=U.getProxy(R.$9J.MainThreadTask),this.b=j,this.c=z,this.d=B,this.e=ae,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=X,this.g=Q,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(U,N,j){if(!j)return new A.$$J(()=>{});const z=this.w();return this.j.set(z,{type:N,provider:j,extension:U}),this.a.$registerTaskProvider(z,N),new A.$$J(()=>{this.j.delete(z),this.a.$unregisterTaskProvider(z)})}registerTaskSystem(U,N){this.a.$registerTaskSystem(U,N)}fetchTasks(U){return this.a.$fetchTasks(b.from(U)).then(async N=>{const j=[];for(const z of N){const B=await f.to(z,this.b,this.m);B&&j.push(B)}return j})}get taskExecutions(){const U=[];return this.k.forEach(N=>U.push(N)),U}terminateTask(U){if(!(U instanceof L))throw new Error("No valid task execution provided");return this.a.$terminateTask(U._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(U,N,j){const z=this.m.get(U.id);z&&(this.o.set(U.id,z),this.e.attachPtyToTerminal(N,await z.callback(j))),this.p=U.id,this.q.fire({execution:await this.y(U)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(U){const N=await this.y(U);this.l.delete(U.id),this.k.delete(U.id),this.A(U),this.r.fire({execution:N})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(U){const N=await this.y(U.id);this.s.fire({execution:N,processId:U.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess(U){const N=await this.y(U.id);this.t.fire({execution:N,exitCode:U.exitCode})}$provideTasks(U,N){const j=this.j.get(U);if(!j)return Promise.reject(new Error("no handler found"));const z=[],B=(0,M.$Jg)(()=>j.provider.provideTasks(P.CancellationToken.None)).then(ae=>this.u(N,z,j,ae));return new Promise(ae=>{B.then(X=>{Promise.all(z).then(()=>{ae(X)})})})}async $resolveTask(U,N){const j=this.j.get(U);if(!j)return Promise.reject(new Error("no handler found"));if(N.definition.type!==j.type)throw new Error(`Unexpected: Task of type [${N.definition.type}] cannot be resolved by provider of type [${j.type}].`);const z=await f.to(N,this.b,this.m);if(!z)throw new Error("Unexpected: Task cannot be resolved.");const B=await j.provider.resolveTask(z,P.CancellationToken.None);if(!B)return;this.z(B,j);const ae=f.from(B,j.extension);if(!ae)throw new Error("Unexpected: Task cannot be resolved.");if(B.definition!==z.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return p.is(ae.execution)&&await this.x(ae,B,!0),await this.v(ae)}w(){return this.h++}async x(U,N,j){const z=await this.a.$createTaskId(U);!j&&!this.m.has(z)&&(this.n.add(z),this.o.set(z,N.execution)),this.m.set(z,N.execution)}async y(U,N){if(typeof U=="string"){const B=this.l.get(U);if(!B)throw new g.$_("Unexpected: The specified task is missing an execution");return B}const j=this.l.get(U.id);if(j)return j;const z=new Promise((B,ae)=>{function X(Q,H,te){te?B(new L(Q,H.id,te)):ae("Unexpected: Task does not exist.")}N?X(this,U,N):f.to(U.task,this.b,this.m).then(Q=>X(this,U,Q))});return this.l.set(U.id,z),z.then(B=>(this.k.set(U.id,B),B),B=>Promise.reject(B))}z(U,N){U._deprecated&&this.g.report("Task.constructor",N.extension,"Use the Task constructor that takes a `scope` instead.")}A(U){this.o.get(U.id)&&this.o.delete(U.id),this.n.has(U.id)&&this.p!==U.id&&(this.m.delete(U.id),this.n.delete(U.id));const j=this.n.values();let z=j.next();for(;!z.done;)!this.o.has(z.value)&&this.p!==z.value&&(this.m.delete(z.value),this.n.delete(z.value)),z=j.next()}};e.$Lcc=O,e.$Lcc=O=Ke([We(0,v.$0L),We(1,S.$nM),We(2,m.$Mbc),We(3,k.$iM),We(4,$.$Pbc),We(5,C.$8bc),We(6,c.$6i),We(7,u.$Cbc)],O);let T=class extends O{constructor(U,N,j,z,B,ae,X,Q){super(U,N,j,z,B,ae,X,Q),this.registerTaskSystem(E.Schemas.vscodeRemote,{scheme:E.Schemas.vscodeRemote,authority:"",platform:s.$c(0)})}async executeTask(U,N){if(!N.execution)throw new Error("Tasks to execute must include an execution");const j=f.from(N,U);if(j===void 0)throw new Error("Task is not valid");if(p.is(j.execution))await this.x(j,N,!1);else throw new g.$0;const z=await this.y(await this.a.$getTaskExecution(j),N);return this.a.$executeTask(j).catch(B=>{throw new Error(B)}),z}u(U,N,j,z){const B=[];if(z)for(const ae of z){this.z(ae,j),(!ae.definition||!U[ae.definition.type])&&this.f.warn(`The task [${ae.source}, ${ae.name}] uses an undefined task type. The task will be ignored in the future.`);const X=f.from(ae,j.extension);X&&p.is(X.execution)?(B.push(X),N.push(this.x(X,ae,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:B,extension:j.extension}}async v(U){if(p.is(U.execution))return U;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(U,N){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(U,N,j){}};e.$Mcc=T,e.$Mcc=T=Ke([We(0,v.$0L),We(1,S.$nM),We(2,m.$Mbc),We(3,k.$iM),We(4,$.$Pbc),We(5,C.$8bc),We(6,c.$6i),We(7,u.$Cbc)],T),e.$Ncc=(0,D.$Lh)("IExtHostTask")}),define(Se[346],De([1,0,15,21,48,34,24,38,36]),function(ne,e,y,M,l,R,A,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xcc=void 0;class ${constructor(v,S,D){this.k=v,this.l=S,this.o=D,this.e=!1,this.f=0,this.g=!1,this.a=v.filePattern,this.b=v.includePattern&&R.$sj(v.includePattern),this.c=v.maxResults||void 0,this.d=v.exists,this.h=new Set,this.j=v.excludePattern&&R.$sj(v.excludePattern)}cancel(){this.g=!0,this.h.forEach(v=>v.cancel()),this.h=new Set}search(v){const S=this.k.folderQueries||[];return new Promise((D,E)=>{const s=c=>{this.f++,v(c)};if(this.g)return D({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(c=>{const u=c.toString(),o=y.$lc(u);this.j&&this.j(u,o)||this.v(s,{base:c,basename:o})}),Promise.all(S.map(c=>this.p(c,s))).then(c=>{D({limitHit:this.e,stats:c[0]||void 0})},c=>{E(new Error((0,l.$wi)(c)))})})}async p(v,S){const D=new M.$Vd,E=this.q(v),s=this.r(),c=new k.$TI(this.k,v),u=!c.hasSiblingExcludeClauses();let o;try{this.h.add(D),o=m.$Hd.create();const g=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},E,D.token),d=o.elapsed(),t=m.$Hd.create();return this.g&&!this.e||(g&&g.forEach(n=>{const r=y.$ec.relative(v.folder.path,n.path);if(u){const i=y.$lc(n.path);this.v(S,{base:v.folder,relativePath:r,basename:i});return}this.s(s,v.folder,r,S)}),this.g&&!this.e)?null:(this.u(s,c,S),{providerTime:d,postProcessTime:t.elapsed()})}finally{D.dispose(),this.h.delete(D)}}q(v){const S=(0,k.$SI)(this.k.includePattern,v.includePattern),D=(0,k.$SI)(this.k.excludePattern,v.excludePattern);return{folder:v.folder,excludes:D,includes:S,useIgnoreFiles:!v.disregardIgnoreFiles,useGlobalIgnoreFiles:!v.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!v.disregardParentIgnoreFiles,followSymlinks:!v.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const v={rootEntries:[],pathToEntries:Object.create(null)};return v.pathToEntries["."]=v.rootEntries,v}s({pathToEntries:v},S,D,E){if(D===this.a){const c=y.$lc(this.a);this.v(E,{base:S,relativePath:this.a,basename:c})}function s(c){const u=y.$lc(c),o=y.$kc(c);let g=v[o];g||(g=v[o]=[],s(o)),g.push({base:S,relativePath:c,basename:u})}s(D)}u({rootEntries:v,pathToEntries:S},D,E){const s=this,c=this.a;function u(o){const g=(0,k.$VI)(()=>o.map(d=>d.basename));for(let d=0,t=o.length;d<t;d++){const n=o[d],{relativePath:r,basename:i}=n;if(D.matchesExcludesSync(r,i,c!==i?g:void 0))continue;const a=S[r];if(a)u(a);else{if(r===c)continue;s.v(E,n)}if(s.e)break}}u(v)}v(v,S){(!this.b||S.relativePath&&this.b(S.relativePath,S.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||v(S))}}class P{constructor(){this.b=new Map}fileSearch(v,S,D,E){const s=this.c(v.cacheKey),c=new $(v,S,s&&s.token);let u=0;const o=g=>{u+=g.length,D(g.map(d=>this.d(d)))};return this.e(c,P.a,o,E).then(g=>({limitHit:g.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:u,detailStats:g.stats}}))}clearCache(v){this.c(v)?.cancel()}c(v){if(v)return this.b.has(v)||this.b.set(v,new M.$Vd),this.b.get(v)}d(v){return v.relativePath?{resource:A.$sg(v.base,v.relativePath)}:{resource:v.base}}e(v,S,D,E){const s=E.onCancellationRequested(()=>{v.cancel()}),c=o=>{o&&(u.push(o),S>0&&u.length>=S&&(D(u),u=[]))};let u=[];return v.search(c).then(o=>(u.length&&D(u),s.dispose(),o),o=>(u.length&&D(u),s.dispose(),Promise.reject(o)))}}e.$Xcc=P,P.a=512}),define(Se[347],De([1,0,19,74,34,100,28,17,15,24,16,18,2,178,226,49,14,43,144,344,36]),function(ne,e,y,M,l,R,A,m,k,$,P,C,v,S,D,E,s,c,u,o,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NJ=e.$MJ=void 0;let d=class{constructor(f,b,L,O,T){this.a=f,this.b=b,this.c=L,this.d=O,this.e=T}text(f,b,L={}){f=this.f(f,L);const O=this.a.getValue(),T=b&&b.some(U=>!this.a.getValue({resource:U}).search.useRipgrep);return{...this.h(b?.map(c.$7h),L),type:2,contentPattern:f,previewOptions:L.previewOptions,maxFileSize:L.maxFileSize,usePCRE2:O.search.usePCRE2||T||!1,beforeContext:L.beforeContext,afterContext:L.afterContext,userDisabledExcludesAndIgnoreFiles:L.disregardExcludeSettings&&L.disregardIgnoreFiles}}f(f,b){const L=this.a.getValue();f.isRegExp&&(f.pattern=f.pattern.replace(/\r?\n/g,"\\n"));const O={...f,wordSeparators:L.editor.wordSeparators};return this.j(f,b)&&(O.isCaseSensitive=!0),this.k(f)&&(O.isMultiline=!0),b.notebookSearchConfig?.includeMarkupInput&&(O.notebookInfo||(O.notebookInfo={}),O.notebookInfo.isInNotebookMarkdownInput=b.notebookSearchConfig.includeMarkupInput),b.notebookSearchConfig?.includeMarkupPreview&&(O.notebookInfo||(O.notebookInfo={}),O.notebookInfo.isInNotebookMarkdownPreview=b.notebookSearchConfig.includeMarkupPreview),b.notebookSearchConfig?.includeCodeInput&&(O.notebookInfo||(O.notebookInfo={}),O.notebookInfo.isInNotebookCellInput=b.notebookSearchConfig.includeCodeInput),b.notebookSearchConfig?.includeOutput&&(O.notebookInfo||(O.notebookInfo={}),O.notebookInfo.isInNotebookCellOutput=b.notebookSearchConfig.includeOutput),O}file(f,b={}){return{...this.h(f,b),type:1,filePattern:b.filePattern?b.filePattern.trim():b.filePattern,exists:b.exists,sortByScore:b.sortByScore,cacheKey:b.cacheKey}}g(f,b){return f?(f=Array.isArray(f)?f.map(a):a(f),b?this.parseSearchPaths(f):{pattern:n(...Array.isArray(f)?f:[f])}):{}}h(f=[],b={}){const L=this.g(b.includePattern,b.expandPatterns),O=this.g(b.excludePattern,b.expandPatterns),T=f.length>1,F=(L.searchPaths&&L.searchPaths.length?L.searchPaths.map(j=>this.q(j,b,O)):f.map(j=>this.r(j,b,O,T))).filter(j=>!!j),U={_reason:b._reason,folderQueries:F,usingSearchPaths:!!(L.searchPaths&&L.searchPaths.length),extraFileResources:b.extraFileResources,excludePattern:O.pattern,includePattern:L.pattern,onlyOpenEditors:b.onlyOpenEditors,maxResults:b.maxResults};if(b.onlyOpenEditors){const j=y.$Fb(y.$Pb(this.c.groups.map(ae=>ae.editors.map(X=>X.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(j));const z=j.filter(ae=>(0,g.$JI)(U,ae.fsPath)),B=this.i(z);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(B)),{...U,...B}}const N=b.extraFileResources&&b.extraFileResources.filter(j=>(0,g.$JI)(U,j.fsPath));return U.extraFileResources=N&&N.length?N:void 0,U}i(f){const b=[],L=new A.$yc,O={};let T=!1;return f.forEach(F=>{if(F.scheme===m.Schemas.walkThrough)return;if((0,$.$wg)(F)){const N=this.b.getWorkspaceFolder(F)?.uri??F.with({path:k.$kc(F.fsPath)});let j=L.get(N);j||(T=!0,j={folder:N,includePattern:{}},b.push(j),L.set(N,j));const z=k.$jc(N.fsPath,F.fsPath);(0,C.$Hf)(j.includePattern)[z.replace(/\\/g,"/")]=!0}else F.fsPath&&(T=!0,O[F.fsPath]=!0)}),{folderQueries:b,includePattern:O,usingSearchPaths:!0,excludePattern:T?void 0:{"**/*":!0}}}j(f,b){if(b.isSmartCase){if(f.isRegExp){if(P.$nf(f.pattern,!0))return!0}else if(P.$nf(f.pattern))return!0}return!!f.isCaseSensitive}k(f){return f.isMultiline||f.isRegExp&&(0,S.$mB)(f.pattern)||f.pattern.indexOf(`
`)>=0?!0:!!f.isMultiline}parseSearchPaths(f){const b=B=>k.$gc(B)||/^\.\.?([\/\\]|$)/.test(B),O=(Array.isArray(f)?f:r(f)).map(B=>{const ae=this.e.resolvedUserHome;return ae?(0,R.$mv)(B,ae.scheme===m.Schemas.file?ae.fsPath:ae.path):B}),T=M.$D(O,B=>b(B)?"searchPaths":"exprSegments"),F=(T.exprSegments||[]).map(B=>P.$Ie(B,"/")).map(B=>P.$Ie(B,"\\")).map(B=>(B[0]==="."&&(B="*"+B),i(B))),U={},N=this.m(T.searchPaths||[]);N&&N.length&&(U.searchPaths=N);const j=y.$Pb(F),z=n(...j);return z&&(U.pattern=z),U}l(f,b){return b.disregardExcludeSettings?void 0:(0,g.$II)(f,!b.disregardSearchExcludeSettings)}m(f){if(!f||!f.length)return[];const b=f.flatMap(O=>{let{pathPortion:T,globPortion:F}=t(O);return F&&(F=h(F)),this.n(T).flatMap(N=>this.o(N,F))}),L=new Map;return b.forEach(O=>{const T=O.searchPath.toString(),F=L.get(T);F?O.pattern&&(F.pattern=F.pattern||{},F.pattern[O.pattern]=!0):L.set(T,{searchPath:O.searchPath,pattern:O.pattern?n(O.pattern):void 0})}),Array.from(L.values())}n(f){if(k.$gc(f)){const b=this.b.getWorkspace().folders;return b[0]&&b[0].uri.scheme!==m.Schemas.file?[{searchPath:b[0].uri.with({path:f})}]:[{searchPath:v.URI.file(k.$fc(f))}]}if(this.b.getWorkbenchState()===2){const b=this.b.getWorkspace().folders[0].uri;if(f=a(f),f.startsWith("../")||f===".."){const O=k.$ec.resolve(b.path,f);return[{searchPath:b.with({path:O})}]}const L=h(f);return[{searchPath:b,pattern:L}]}else{if(f==="./"||f===".\\")return[];{const b=f.replace(/^\.[\/\\]/,""),O=this.b.getWorkspace().folders.map(T=>{const F=b.match(new RegExp(`^${P.$De(T.name)}(?:/(.*)|$)`));return F?{match:F,folder:T}:null}).filter(C.$Ef);if(O.length)return O.map(T=>{const F=T.match[1];return{searchPath:T.folder.uri,pattern:F&&h(F)}});{const T=f.match(/\.[\/\\](.+)[\/\\]?/),F=T?T[1]:f,U=D.localize(0,null,F);throw new Error(U)}}}}o(f,b){const L=f.pattern&&b?`${f.pattern}/${b}`:f.pattern||b,O=[{searchPath:f.searchPath,pattern:L}];return L&&!L.endsWith("**")&&O.push({searchPath:f.searchPath,pattern:L+"/**"}),O}q(f,b,L){const O=this.r((0,c.$7h)(f.searchPath),b,L,!1);return O?{...O,includePattern:f.pattern}:null}r(f,b,L,O){let T;const F=v.URI.isUri(f)?f:f.uri;if(L.searchPaths){const B=L.searchPaths.filter(ae=>(0,$.$lg)(ae.searchPath,F))[0];if(B&&!B.pattern)return null;B&&(T=B.pattern)}const U=this.a.getValue({resource:F}),j={...this.l(U,b)||{},...T||{}},z=v.URI.isUri(f)?(0,$.$pg)(f):f.name;return{folder:F,folderName:O?z:void 0,excludePattern:Object.keys(j).length>0?j:void 0,fileEncoding:U.files&&U.files.encoding,disregardIgnoreFiles:typeof b.disregardIgnoreFiles=="boolean"?b.disregardIgnoreFiles:!U.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof b.disregardGlobalIgnoreFiles=="boolean"?b.disregardGlobalIgnoreFiles:!U.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof b.disregardParentIgnoreFiles=="boolean"?b.disregardParentIgnoreFiles:!U.search.useParentIgnoreFiles,ignoreSymlinks:typeof b.ignoreSymlinks=="boolean"?b.ignoreSymlinks:!U.search.followSymlinks}}};e.$MJ=d,e.$MJ=d=Ke([We(0,E.$fi),We(1,c.$Uh),We(2,u.$9B),We(3,s.$6i),We(4,o.$KJ)],d);function t(w){const f=w.match(/[\*\{\}\(\)\[\]\?]/);if(f){const b=f.index,L=w.substr(0,b).match(/[/|\\][^/\\]*$/);if(L){let O=w.substr(0,L.index);return O.match(/[/\\]/)||(O+="/"),{pathPortion:O,globPortion:w.substr((L.index||0)+1)}}}return{pathPortion:w}}function n(...w){return w.length?w.reduce((f,b)=>(f[b]=!0,f),Object.create(null)):void 0}function r(w){return l.$qj(w,",").map(f=>f.trim()).filter(f=>!!f.length)}function i(w){return[`**/${w}/**`,`**/${w}`].map(b=>b.replace(/\*\*\/\*\*/g,"**"))}function a(w){return w.replace(/\\/g,"/")}function h(w){return a(w).replace(/^\.\//,"").replace(/\/+$/g,"")}function p(w){return w.replace(/([?*[\]])/g,"[$1]")}function I(w,f){w=y.$Kb(w,O=>O.toString());const b=[],L=f.getWorkspace();return w&&w.forEach(O=>{let T;if(f.getWorkbenchState()===2)T=(0,$.$ug)(L.folders[0].uri,O),T&&T!=="."&&(T="./"+T);else{const F=f.getWorkspaceFolder(O);if(F){const U=F.name;if(L.folders.filter(j=>j.name===U).length===1){const j=(0,$.$ug)(F.uri,O);j===""?T=`./${F.name}`:T=`./${F.name}/${j}`}else T=O.fsPath}}T&&b.push(p(T))}),b}e.$NJ=I}),define(Se[348],De([1,0,24,2,21,8,5,347,36,43]),function(ne,e,y,M,l,R,A,m,k,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$plb=e.$olb=void 0;const P=7e3;function C(E,s){const c=s.activationEvents;if(!c)return Promise.resolve(void 0);const u=[],o=[];for(const i of c)if(/^workspaceContains:/.test(i)){const a=i.substr(18);a.indexOf("*")>=0||a.indexOf("?")>=0||E.forceUsingSearch?o.push(a):u.push(a)}if(u.length===0&&o.length===0)return Promise.resolve(void 0);let g;const d=new Promise((i,a)=>{g=i}),t=i=>g({activationEvent:i}),n=Promise.all(u.map(i=>v(E,i,t))).then(()=>{}),r=S(E,s.identifier,o,t);return Promise.all([n,r]).then(()=>{g(void 0)}),d}e.$olb=C;async function v(E,s,c){for(const u of E.folders)if(await E.exists(y.$sg(M.URI.revive(u),s))){c(`workspaceContains:${s}`);return}}async function S(E,s,c,u){if(c.length===0)return Promise.resolve(void 0);const o=new l.$Vd,g=E.checkExists(E.folders,c,o.token),d=setTimeout(async()=>{o.cancel(),E.logService.info(`Not activating extension '${s.value}': Timed out while searching for 'workspaceContains' pattern ${c.join(",")}`)},P);let t=!1;try{t=await g}catch(n){R.$2(n)||R.$Y(n)}o.dispose(),clearTimeout(d),t&&u(`workspaceContains:${c.join(",")}`)}function D(E,s,c,u){const o=E.get(A.$Kh),g=E.get(k.$AI),t=o.createInstance(m.$MJ).file(s.map(n=>(0,$.$7h)(M.URI.revive(n))),{_reason:"checkExists",includePattern:c,exists:!0});return g.fileSearch(t,u).then(n=>!!n.limitHit,n=>R.$2(n)?!1:Promise.reject(n))}e.$plb=D});var et=this&&this.__classPrivateFieldSet||function(ne,e,y,M,l){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!l:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?l.call(ne,y):l?l.value=y:e.set(ne,y),y},Be=this&&this.__classPrivateFieldGet||function(ne,e,y,M){if(y==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!M:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return y==="m"?M:y==="a"?M.call(ne):M?M.value:e.get(ne)};define(Se[45],De([1,0,204,15,53,24,9,3,78,2,14,6,40,285,116,37,27,149,8,25,22,262,7,65,5,26,91,20,105,73,44,4,348,115,264,17,113,38,10,114]),function(ne,e,y,M,l,R,A,m,k,$,P,C,v,S,D,E,s,c,u,o,g,d,t,n,r,i,a,h,p,I,w,f,b,L,O,T,F,U,N,j){"use strict";var z,B,ae,X;Object.defineProperty(e,"__esModule",{value:!0}),e.$kcc=e.$jcc=e.$icc=e.$hcc=e.$gcc=void 0,e.$gcc=(0,r.$Lh)("IHostUtils");let Q=X=class extends m.$Qc{constructor(ee,Y,Z,_,pe,se,ge,ie,fe,be,Ie,W){super(),this.X=W,this.a=this.B(new f.$Ld),this.onDidChangeRemoteConnectionData=this.a.event,this.U=!1,this.c=Y,this.g=Z,this.f=ge,this.j=_,this.m=pe,this.s=se,this.t=fe,this.u=be,this.w=Ie,this.y=this.g.getProxy(C.$9J.MainThreadWorkspace),this.z=this.g.getProxy(C.$9J.MainThreadTelemetry),this.C=this.g.getProxy(C.$9J.MainThreadExtensionService),this.D=new A.$Pg,this.F=new A.$Pg,this.G=new A.$Pg,this.H=new A.$Pg,this.I=new V(this.f.extensions.activationEvents),this.L=new c.$53b(this.I,this.f.extensions.allExtensions);const G=new o.$Yl(this.f.extensions.myExtensions);this.J=new c.$53b(this.I,ye(this.L,G)),N.$n&&(this.s.info(`Creating extension host with the following global extensions: ${me(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${me(this.J)}`)),this.M=new D.$Zbc(this.g,this.s),this.N=new L.$_bc(this.g),this.O=ie,this.h=ee.createChild(new p.$Jh([D.$1bc,this.M],[L.$acc,this.N])),this.P=this.B(new S.$Ybc(this.J,this.L,{onExtensionActivationError:(ce,he,x)=>{this.C.$onExtensionActivationError(ce,u.$1(he),x)},actualActivateExtension:async(ce,he)=>{if(c.$53b.isHostExtension(ce,this.J,this.L))return await this.C.$activateExtension(ce,he),new S.$Xbc;const x=this.J.getExtensionDescription(ce);return this.db(x,he)}},this.s)),this.Q=null,this.R=Object.create(null),this.S=!1,this.W=this.f.remote.connectionData}getRemoteConnectionData(){return this.W}async initialize(){try{await this.tb(),this.D.open(),await this.j.waitForInitializeCall(),l.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.rb()}catch(ee){u.$Y(ee)}}async Y(){this.O.onWillDeactivateAll();let ee=[];try{ee=this.J.getAllExtensionDescriptions().map(pe=>pe.identifier).filter(pe=>this.isActivated(pe)).map(pe=>this.cb(pe))}catch{}await Promise.all(ee)}terminate(ee,Y=0){if(this.U)return;this.U=!0,this.s.info(`Extension host terminating: ${ee}`),this.s.flush(),this.u.dispose(),this.P.dispose(),u.setUnexpectedErrorHandler(_=>{this.s.error(_)}),this.g.dispose();const Z=this.Y();Promise.race([(0,A.$Rg)(5e3),Z]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${Y}`):this.s.info(`Extension host exiting with code ${Y}`),this.s.flush(),this.s.dispose(),this.c.exit(Y)})}isActivated(ee){return this.G.isOpen()?this.P.isActivated(ee):!1}async getExtension(ee){const Y=await this.C.$getExtension(ee);return Y&&{...Y,identifier:new o.$Xl(Y.identifier.value),extensionLocation:$.URI.revive(Y.extensionLocation)}}Z(ee,Y){return this.P.activateByEvent(ee,Y)}$(ee,Y){return this.P.activateById(ee,Y)}activateByIdWithErrors(ee,Y){return this.$(ee,Y).then(()=>{const Z=this.P.getActivatedExtension(ee);if(Z.activationFailed)return Promise.reject(Z.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(ee=>this.J)}getExtensionExports(ee){if(this.G.isOpen())return this.P.getActivatedExtension(ee).exports;try{return this.P.getActivatedExtension(ee).exports}catch{return null}}async ab(ee){if(ee.scheme===T.Schemas.file&&this.c.fsRealpath){const Y=await this.c.fsRealpath(ee.fsPath);return $.URI.file(Y)}return ee}async getExtensionPathIndex(){return this.Q||(this.Q=this.bb(this.J.getAllExtensionDescriptions()).then(ee=>new de(ee))),this.Q}async bb(ee){const Y=k.$Rh.forUris(Z=>R.$jg.ignorePathCasing(Z));return await Promise.all(ee.map(async Z=>{if(this.ub(Z)){const _=await this.ab(Z.extensionLocation);Y.set(_,Z)}})),Y}cb(ee){let Y=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(ee))return Y;const Z=this.P.getActivatedExtension(ee);if(!Z)return Y;try{typeof Z.module.deactivate=="function"&&(Y=Promise.resolve(Z.module.deactivate()).then(void 0,_=>(this.s.error(_),Promise.resolve(void 0))))}catch(_){this.s.error(`An error occurred when deactivating the extension '${ee.value}':`),this.s.error(_)}try{(0,m.$Lc)(Z.subscriptions)}catch(_){this.s.error(`An error occurred when deactivating the subscriptions for extension '${ee.value}':`),this.s.error(_)}return Y}async db(ee,Y){return this.f.remote.isRemote?this.C.$onWillActivateExtension(ee.identifier):await this.C.$onWillActivateExtension(ee.identifier),this.fb(ee,Y).then(Z=>{const _=Z.activationTimes;return this.C.$onDidActivateExtension(ee.identifier,_.codeLoadingTime,_.activateCallTime,_.activateResolvedTime,Y),this.eb(ee,Y,"success",_),Z},Z=>{throw this.eb(ee,Y,"failure"),Z})}eb(ee,Y,Z,_){const pe=te(ee,Y);this.z.$publicLog2("extensionActivationTimes",{...pe,..._||{},outcome:Z})}fb(ee,Y){const Z=te(ee,Y);this.z.$publicLog2("activatePlugin",Z);const _=this.ub(ee);if(!_)return Promise.resolve(new S.$Wbc(S.$Tbc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${ee.identifier.value}, startup: ${Y.startup}, activationEvent: '${Y.activationEvent}'${ee.identifier.value!==Y.extensionId.value?`, root cause: ${Y.extensionId.value}`:""}`),this.s.flush();const pe=new S.$Ubc(Y.startup);return Promise.all([this.vb(ee,(0,R.$sg)(ee.extensionLocation,_),pe),this.gb(ee)]).then(se=>(l.mark(`code/extHost/willActivateExtension/${ee.identifier.value}`),X.hb(this.s,ee.identifier,se[0],se[1],pe))).then(se=>(l.mark(`code/extHost/didActivateExtension/${ee.identifier.value}`),se))}gb(ee){const Y=new d.$3bc(ee,this.M),Z=new d.$2bc(ee.identifier.value,!1,this.M),_=new O.$bcc(ee,this.N),pe=ee.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,se=this.f.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${ee.identifier.value}`),Promise.all([Y.whenReady,Z.whenReady,this.O.whenReady]).then(()=>{const ge=this;let ie,fe;const be=(0,s.$7E)(ee,"ipc")?this.f.messagePorts?.get(o.$Xl.toKey(ee.identifier)):void 0;return Object.freeze({globalState:Y,workspaceState:Z,secrets:_,subscriptions:[],get extensionUri(){return ee.extensionLocation},get extensionPath(){return ee.extensionLocation.fsPath},asAbsolutePath(Ie){return M.$hc(ee.extensionLocation.fsPath,Ie)},get storagePath(){return ge.O.workspaceValue(ee)?.fsPath},get globalStoragePath(){return ge.O.globalValue(ee).fsPath},get logPath(){return M.$hc(ge.f.logsLocation.fsPath,ee.identifier.value)},get logUri(){return $.URI.joinPath(ge.f.logsLocation,ee.identifier.value)},get storageUri(){return ge.O.workspaceValue(ee)},get globalStorageUri(){return ge.O.globalValue(ee)},get extensionMode(){return pe},get extension(){return ie===void 0&&(ie=new le(ge,ee.identifier,ee,se,!1)),ie},get extensionRuntime(){return(0,s.$8E)(ee,"extensionRuntime"),ge.extensionRuntime},get environmentVariableCollection(){return ge.u.getEnvironmentVariableCollection(ee)},get messagePassingProtocol(){if(!fe){if(!be)return;const Ie=f.Event.buffer(f.Event.fromDOMEventEmitter(be,"message",W=>W.data));be.start(),fe={onDidReceiveMessage:Ie,postMessage:be.postMessage.bind(be)}}return fe}})})}static hb(ee,Y,Z,_,pe){return Z=Z||{activate:void 0,deactivate:void 0},this.ib(ee,Y,Z,_,pe).then(se=>new S.$Vbc(!1,null,pe.build(),Z,se,_.subscriptions))}static ib(ee,Y,Z,_,pe){if(typeof Z.activate=="function")try{pe.activateCallStart(),ee.trace(`ExtensionService#_callActivateOptional ${Y.value}`);const se=typeof global=="object"?global:self,ge=Z.activate.apply(se,[_]);return pe.activateCallStop(),pe.activateResolveStart(),Promise.resolve(ge).then(ie=>(pe.activateResolveStop(),ie))}catch(se){return Promise.reject(se)}else return Promise.resolve(Z)}jb(ee,Y){this.$(ee.identifier,{startup:!1,extensionId:ee.identifier,activationEvent:Y}).then(void 0,Z=>{this.s.error(Z)})}kb(ee,Y=0){const _=Date.now();(0,N.$v)(()=>{for(let pe=Y;pe<ee.length;pe+=1){const se=ee[pe];for(const ge of se.activationEvents??[])if(ge==="onStartupFinished")if(Date.now()-_>50){this.kb(ee,pe);break}else this.jb(se,ge)}})}lb(){this.C.$setPerformanceMarks(l.getMarks()),this.m.getConfigProvider().then(ee=>{const Y=ee.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),Z=this.J.getAllExtensionDescriptions();if(Y)this.kb(Z);else for(const _ of Z)if(_.activationEvents)for(const pe of _.activationEvents)pe==="onStartupFinished"&&this.jb(_,pe)})}mb(){const ee=this.Z("*",!0).then(void 0,se=>{this.s.error(se)});this.B(this.j.onDidChangeWorkspace(se=>this.nb(se.added)));const Y=this.j.workspace?this.j.workspace.folders:[],Z=this.nb(Y),_=this.pb(),pe=Promise.all([_,ee,Z]).then(()=>{});return Promise.race([pe,(0,A.$Rg)(1e4)]).then(()=>{this.lb()}),pe}nb(ee){return ee.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(Y=>this.ob(ee,Y))).then(()=>{})}async ob(ee,Y){if(this.isActivated(Y.identifier))return;const Z=!this.f.remote.isRemote&&!!this.f.remote.authority,_={logService:this.s,folders:ee.map(se=>se.uri),forceUsingSearch:Z||!this.c.fsExists,exists:se=>this.c.fsExists(se.fsPath),checkExists:(se,ge,ie)=>this.y.$checkExists(se,ge,ie)},pe=await(0,b.$olb)(_,Y);if(pe)return this.$(Y.identifier,{startup:!0,extensionId:Y.identifier,activationEvent:pe.activationEvent}).then(void 0,se=>this.s.error(se))}async pb(){if(this.f.remote.authority)return this.Z(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.qb()}catch(ee){throw console.error(ee),ee}}async qb(){const{extensionDevelopmentLocationURI:ee,extensionTestsLocationURI:Y}=this.f.environment;if(!ee||!Y)throw new Error(y.localize(0,null));const Z=await this.vb(null,Y,new S.$Ubc(!1));if(!Z||typeof Z.run!="function")throw new Error(y.localize(1,null,Y.toString()));return new Promise((_,pe)=>{const se=(fe,be)=>{fe?(N.$n&&this.s.error("Test runner called back with error",fe),pe(fe)):(N.$n&&(be?this.s.info(`Test runner called back with ${be} failures.`):this.s.info("Test runner called back with successful outcome.")),_(typeof be=="number"&&be>0?1:0))},ge=(0,R.$gg)(Y),ie=Z.run(ge,se);ie&&ie.then&&ie.then(()=>{N.$n&&this.s.info("Test runner finished successfully."),_(0)}).catch(fe=>{N.$n&&this.s.error("Test runner finished with error",fe),pe(fe instanceof Error&&fe.stack?fe.stack:String(fe))})})}rb(){if(this.S)throw new Error("Extension host is already started!");return this.S=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,A.$Rg)(1e3)])).then(()=>this.mb()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(ee,Y){return this.R[ee]=Y,(0,m.$Oc)(()=>{delete this.R[ee]})}async getRemoteExecServer(ee){const{resolver:Y}=await this.sb(ee);return Y?.resolveExecServer?.(ee,{resolveAttempt:0})}async sb(ee){const Y=ee.indexOf("+");if(Y===-1)throw new t.$eK("Not an authority that can be resolved!",n.RemoteAuthorityResolverErrorCode.InvalidAuthority);const Z=ee.substr(0,Y);return await this.D.wait(),await this.Z(`onResolveRemoteAuthority:${Z}`,!1),{authorityPrefix:Z,resolver:this.R[Z]}}async $resolveAuthority(ee,Y){const Z=U.$Hd.create(!1),_=()=>`[resolveAuthority(${(0,n.$Ok)(ee)},${Y})][${Z.elapsed()}ms] `,pe=ve=>this.s.info(`${_()}${ve}`),se=ve=>this.s.warn(`${_()}${ve}`),ge=(ve,Ne=void 0)=>this.s.error(`${_()}${ve}`,Ne),ie=ve=>{if(ve instanceof t.$eK)return{type:"error",error:{code:ve._code,message:ve._message,detail:ve._detail}};throw ve},fe=async ve=>{pe(`activating resolver for ${ve}...`);const{resolver:Ne,authorityPrefix:Ve}=await this.sb(ve);if(!Ne)throw ge(`no resolver for ${Ve}`),new t.$eK(`No remote extension installed to resolve ${Ve}.`,n.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:Ne,authorityPrefix:Ve,remoteAuthority:ve}},be=ee.split(/@|%40/g).reverse();pe(`activating remote resolvers ${be.join(" -> ")}`);let Ie;try{Ie=await Promise.all(be.map(fe)).catch(async ve=>{if(!(ve instanceof t.$eK)||ve._code!==n.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw ve;return se(`resolving nested authorities failed: ${ve.message}`),[await fe(ee)]})}catch(ve){return ie(ve)}const W=new A.$2g;W.cancelAndSet(()=>pe("waiting..."),1e3);let G,ce;for(const[ve,{authorityPrefix:Ne,resolver:Ve,remoteAuthority:xe}]of Ie.entries())try{if(ve===Ie.length-1)pe("invoking final resolve()..."),l.mark(`code/extHost/willResolveAuthority/${Ne}`),G=await Ve.resolve(xe,{resolveAttempt:Y,execServer:ce}),l.mark(`code/extHost/didResolveAuthorityOK/${Ne}`),pe("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(Ve,t.$dK.isManagedResolvedAuthority(G)?G:void 0));else{if(pe(`invoking resolveExecServer() for ${xe}`),l.mark(`code/extHost/willResolveExecServer/${Ne}`),ce=await Ve.resolveExecServer?.(xe,{resolveAttempt:Y,execServer:ce}),!ce)throw new t.$eK(`Exec server was not available for ${xe}`,n.RemoteAuthorityResolverErrorCode.NoResolverFound);l.mark(`code/extHost/didResolveExecServerOK/${Ne}`)}}catch(Qe){return l.mark(`code/extHost/didResolveAuthorityError/${Ne}`),ge("returned an error",Qe),W.dispose(),ie(Qe)}W.dispose();const he={environmentTunnels:G.environmentTunnels,features:G.tunnelFeatures},x={extensionHostEnv:G.extensionHostEnv,isTrusted:G.isTrusted,authenticationSession:G.authenticationSessionForInitializingExtensions?{id:G.authenticationSessionForInitializingExtensions.id,providerId:G.authenticationSessionForInitializingExtensions.providerId}:void 0};pe(`returned ${t.$dK.isManagedResolvedAuthority(G)?"managed authority":`${G.host}:${G.port}`}`);let $e;if(t.$dK.isManagedResolvedAuthority(G)){const ve=Y;this.X.setFactory(ve,G.makeConnection),$e={authority:ee,connectTo:new n.$Lk(ve),connectionToken:G.connectionToken}}else $e={authority:ee,connectTo:new n.$Mk(G.host,G.port),connectionToken:G.connectionToken};return{type:"ok",value:{authority:$e,options:x,tunnelInformation:he}}}async $getCanonicalURI(ee,Y){this.s.info(`$getCanonicalURI invoked for authority (${(0,n.$Ok)(ee)})`);const{resolver:Z}=await this.sb(ee);if(!Z)return null;const _=$.URI.revive(Y);if(typeof Z.getCanonicalURI>"u")return _;const pe=await(0,A.$Jg)(()=>Z.getCanonicalURI(_));return pe||_}$startExtensionHost(ee){ee.toAdd.forEach(_=>_.extensionLocation=$.URI.revive(_.extensionLocation));const{globalRegistry:Y,myExtensions:Z}=H(this.I,this.L,this.J,ee);return this.L.set(Y.getAllExtensionDescriptions()),this.J.set(Z),N.$n&&(this.s.info(`$startExtensionHost: global extensions: ${me(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${me(this.J)}`)),this.rb()}$activateByEvent(ee,Y){return Y===1?this.D.wait().then(Z=>this.Z(ee,!1)):this.G.wait().then(Z=>this.Z(ee,!1))}async $activate(ee,Y){return await this.G.wait(),this.J.getExtensionDescription(ee)?(await this.$(ee,Y),!0):!1}async $deltaExtensions(ee){ee.toAdd.forEach(se=>se.extensionLocation=$.URI.revive(se.extensionLocation));const{globalRegistry:Y,myExtensions:Z}=H(this.I,this.L,this.J,ee),_=await this.bb(Z);return(await this.getExtensionPathIndex()).setSearchTree(_),this.L.set(Y.getAllExtensionDescriptions()),this.J.set(Z),N.$n&&(this.s.info(`$deltaExtensions: global extensions: ${me(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${me(this.J)}`)),Promise.resolve(void 0)}async $test_latency(ee){return ee}async $test_up(ee){return ee.byteLength}async $test_down(ee){const Y=g.$_d.alloc(ee),Z=Math.random()%256;for(let _=0;_<ee;_++)Y.writeUInt8(Z,_);return Y}async $updateRemoteConnectionData(ee){this.W=ee,this.a.fire()}};e.$hcc=Q,e.$hcc=Q=X=Ke([We(0,r.$Kh),We(1,e.$gcc),We(2,h.$0L),We(3,E.$Mbc),We(4,v.$Pbc),We(5,P.$6i),We(6,i.$nM),We(7,a.$6bc),We(8,I.$ksb),We(9,w.$8bc),We(10,F.$dcc),We(11,j.$ecc)],Q);function H(J,ee,Y,Z){J.addActivationEvents(Z.addActivationEvents);const _=new c.$53b(J,ee.getAllExtensionDescriptions());_.deltaExtensions(Z.toAdd,Z.toRemove);const pe=new o.$Yl(Y.getAllExtensionDescriptions().map(ge=>ge.identifier));for(const ge of Z.myToRemove)pe.delete(ge);for(const ge of Z.myToAdd)pe.add(ge);const se=ye(_,pe);return{globalRegistry:_,myExtensions:se}}function te(J,ee){return{id:J.identifier.value,name:J.name,extensionVersion:J.version,publisherDisplayName:J.publisher,activationEvents:J.activationEvents?J.activationEvents.join(","):null,isBuiltin:J.isBuiltin,reason:ee.activationEvent,reasonId:ee.extensionId.value}}function me(J){return J.getAllExtensionDescriptions().map(ee=>ee.identifier.value).join(",")}e.$icc=(0,r.$Lh)("IExtHostExtensionService");class le{constructor(ee,Y,Z,_,pe){z.set(this,void 0),B.set(this,void 0),ae.set(this,void 0),et(this,z,ee,"f"),et(this,B,Y,"f"),et(this,ae,Z.identifier,"f"),this.id=Z.identifier.value,this.extensionUri=Z.extensionLocation,this.extensionPath=M.$fc((0,R.$gg)(Z.extensionLocation)),this.packageJSON=Z,this.extensionKind=_,this.isFromDifferentExtensionHost=pe}get isActive(){return Be(this,z,"f").isActivated(Be(this,ae,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return Be(this,z,"f").getExtensionExports(Be(this,ae,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await Be(this,z,"f").activateByIdWithErrors(Be(this,ae,"f"),{startup:!1,extensionId:Be(this,B,"f"),activationEvent:"api"}),this.exports}}e.$jcc=le,z=new WeakMap,B=new WeakMap,ae=new WeakMap;function ye(J,ee){return J.getAllExtensionDescriptions().filter(Y=>ee.has(Y.identifier))}class de{constructor(ee){this.a=ee}setSearchTree(ee){this.a=ee}findSubstr(ee){return this.a.findSubstr(ee)}forEach(ee){return this.a.forEach(ee)}}e.$kcc=de;class V{constructor(ee){this.a=new o.$Zl,this.addActivationEvents(ee)}readActivationEvents(ee){return this.a.get(ee.identifier)}addActivationEvents(ee){for(const Y of Object.keys(ee))this.a.set(Y,ee[Y])}}}),define(Se[349],De([1,0,53,2,6,40,27,25,20,26,5,45,14,16]),function(ne,e,y,M,l,R,A,m,k,$,P,C,v,S){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hdc=void 0;let E=class{constructor(g,d,t,n,r,i,a){this.c=g,this.d=d,this.f=t,this.g=n,this.h=r,this.i=i,this.j=a,this.a=new Map,this.b=[]}async install(){this.k(),y.mark("code/extHost/willWaitForConfig");const g=await this.g.getConfigProvider();y.mark("code/extHost/didWaitForConfig");const d=await this.h.getExtensionPathIndex();this.register(new c(this.c,d,this.d,g,this.j)),this.register(this.f.createInstance(s)),this.i.remote.isRemote&&this.register(this.f.createInstance(u,d,this.i.environment.appUriScheme))}register(g){if("nodeModuleName"in g)if(Array.isArray(g.nodeModuleName))for(const d of g.nodeModuleName)this.a.set(d,g);else this.a.set(g.nodeModuleName,g);typeof g.alternativeModuleName=="function"&&this.b.push(d=>g.alternativeModuleName(d))}};e.$Hdc=E,e.$Hdc=E=Ke([We(2,P.$Kh),We(3,R.$Pbc),We(4,C.$icc),We(5,$.$nM),We(6,v.$6i)],E);let s=D=class{constructor(g){if(g.environment.appRoot&&D.a.size){const d=(0,S.$De)(this.c(g.environment.appRoot.fsPath)),t="[a-z0-9_.-]",n=`@${t}+\\/${t}+|${t}+`,r="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${d}/${r}\\/)(${n})(.*)$`,"i")}}alternativeModuleName(g){if(!this.b)return;const d=this.b.exec(this.c(g));if(!d)return;const[,t,n,r]=d,i=D.a.get(n);if(i!==void 0)return console.warn(`${n} as been renamed to ${i}, please update your imports`),t+i+r}c(g){return g.replace(/\\/g,"/")}};s.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),s=D=Ke([We(0,$.$nM)],s);class c{constructor(g,d,t,n,r){this.c=g,this.d=d,this.e=t,this.f=n,this.g=r,this.nodeModuleName="vscode",this.a=new m.$Zl}load(g,d){const t=this.d.findSubstr(d);if(t){let n=this.a.get(t.identifier);return n||(n=this.c(t,this.e,this.f),this.a.set(t.identifier,n)),n}if(!this.b){let n="";this.d.forEach((r,i)=>n+=`	${i} -> ${r.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${d}. These are the extension path mappings: 
${n}`),this.b=this.c(A.$2E,this.e,this.f)}return this.b}}let u=class{constructor(g,d,t){this.e=g,this.f=d,this.nodeModuleName=["open","opn"],this.d=t.getProxy(l.$9J.MainThreadTelemetry);const n=t.getProxy(l.$9J.MainThreadWindow);this.c=(r,i)=>{const a=M.URI.parse(r);return i?this.g(r,i):a.scheme==="http"||a.scheme==="https"?n.$openUri(a,r,{allowTunneling:!0}):a.scheme==="mailto"||a.scheme===this.f?n.$openUri(a,r,{}):this.g(r,i)}}load(g,d,t){const n=this.e.findSubstr(d);return n&&(this.a=n.identifier.value,this.h()),this.b=t(g),this.c}g(g,d){return this.i(),this.b(g,d)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};u=Ke([We(2,k.$0L)],u)}),define(Se[55],De([1,0,58,3,15,46,5,70,71,45,7,37,277,40]),function(ne,e,y,M,l,R,A,m,k,$,P,C,v,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rcc=e.$Qcc=void 0,e.$Qcc=(0,A.$Lh)("IExtHostVariableResolverProvider");class D extends v.$$M{constructor(c,u,o,g,d,t,n){function r(){if(o){const i=o.activeEditor();if(i)return i.document.uri;const a=g.tabGroups.all.find(h=>h.isActive)?.activeTab;if(a!==void 0){if(a.input instanceof P.$QL||a.input instanceof P.$VL)return a.input.modified;if(a.input instanceof P.$PL||a.input instanceof P.$UL||a.input instanceof P.$SL)return a.input.uri}}}super({getFolderUri:i=>{const a=t.folders.filter(h=>h.name===i);if(a&&a.length>0)return a[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(i,a)=>d.getConfiguration(void 0,i).get(a),getAppRoot:()=>R.cwd(),getExecPath:()=>R.env.VSCODE_EXEC_PATH,getFilePath:()=>{const i=r();if(i)return l.$fc(i.fsPath)},getWorkspaceFolderPathForFile:()=>{if(u){const i=r();if(i){const a=u.getWorkspaceFolder(i);if(a)return l.$fc(a.uri.fsPath)}}},getSelectedText:()=>{if(o){const i=o.activeEditor();if(i&&!i.selection.isEmpty)return i.document.getText(i.selection)}},getLineNumber:()=>{if(o){const i=o.activeEditor();if(i)return String(i.selection.end.line+1)}},getExtension:i=>c.getExtension(i)},void 0,n?Promise.resolve(n):void 0,Promise.resolve(R.env))}}let E=class extends M.$Qc{constructor(c,u,o,g,d){super(),this.b=c,this.c=u,this.g=o,this.h=g,this.j=d,this.a=new y.$T(async()=>{const t=await this.h.getConfigProvider(),r={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async i=>{r.folders=await this.c.getWorkspaceFolders2()||[]})),new D(this.b,this.c,this.g,this.j,t,r,this.m())})}getResolver(){return this.a.value}m(){}};e.$Rcc=E,e.$Rcc=E=Ke([We(0,$.$icc),We(1,C.$Mbc),We(2,m.$iM),We(3,S.$Pbc),We(4,k.$Occ)],E)}),define(Se[95],De([1,0,9,4,2,5,6,71,45,20,7,37,141,270,40,55]),function(ne,e,y,M,l,R,A,m,k,$,P,C,v,S,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wcc=e.$Vcc=e.$Ucc=e.$Tcc=e.$Scc=void 0,e.$Scc=(0,R.$Lh)("IExtHostDebugService");let s=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(n,r,i,a,h,p){this.E=r,this.F=i,this.G=a,this.H=h,this.I=p,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.B=new Map,this.C=new Map,this.m=new M.$Ld,this.n=new M.$Ld,this.o=new M.$Ld,this.u=new M.$Ld,this.k=n.getProxy(A.$9J.MainThreadDebugService),this.y=new M.$Ld,this.A=new M.$Ld,this.v=new u(this.k),this.w=new Map,this.F.getExtensionRegistry().then(I=>{I.onDidChange(w=>{this.J(I)}),this.J(I)})}asDebugSourceUri(n,r){const i=n;if(typeof i.sourceReference=="number"&&i.sourceReference>0){let a=`debug:${encodeURIComponent(i.path||"")}`,h="?";return r&&(a+=`${h}session=${encodeURIComponent(r.id)}`,h="&"),a+=`${h}ref=${i.sourceReference}`,l.URI.parse(a)}else{if(i.path)return l.URI.file(i.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}J(n){const r=[];for(const i of n.getAllExtensionDescriptions())if(i.contributes){const a=i.contributes.debuggers;if(a&&a.length>0)for(const h of a)(0,S.$nF)(h)&&r.push(h.type)}this.k.$registerDebugTypes(r)}get stackFrameFocus(){return this.z}get onDidChangeStackFrameFocus(){return this.A.event}get onDidChangeBreakpoints(){return this.y.event}get breakpoints(){const n=[];return this.w.forEach(r=>n.push(r)),n}addBreakpoints(n){const r=n.filter(h=>{const p=h.id;return this.w.has(p)?!1:(this.w.set(p,h),!0)});this.U(r,[],[]);const i=[],a=new Map;for(const h of r)if(h instanceof P.$0K){let p=a.get(h.location.uri.toString());p||(p={type:"sourceMulti",uri:h.location.uri,lines:[]},a.set(h.location.uri.toString(),p),i.push(p)),p.lines.push({id:h.id,enabled:h.enabled,condition:h.condition,hitCondition:h.hitCondition,logMessage:h.logMessage,line:h.location.range.start.line,character:h.location.range.start.character})}else h instanceof P.$$K&&i.push({type:"function",id:h.id,enabled:h.enabled,hitCondition:h.hitCondition,logMessage:h.logMessage,condition:h.condition,functionName:h.functionName});return this.k.$registerBreakpoints(i)}removeBreakpoints(n){const r=n.filter(p=>this.w.delete(p.id));this.U([],r,[]);const i=r.filter(p=>p instanceof P.$0K).map(p=>p.id),a=r.filter(p=>p instanceof P.$$K).map(p=>p.id),h=r.filter(p=>p instanceof P.$_K).map(p=>p.id);return this.k.$unregisterBreakpoints(i,a,h)}startDebugging(n,r,i){return this.k.$startDebugging(n?n.uri:void 0,r,{parentSessionID:i.parentSession?i.parentSession.id:void 0,lifecycleManagedByParent:i.lifecycleManagedByParent,repl:i.consoleMode===P.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:i.noDebug,compact:i.compact,suppressSaveBeforeStart:i.suppressSaveBeforeStart,suppressDebugStatusbar:i.suppressDebugStatusbar??i.debugUI?.simple,suppressDebugToolbar:i.suppressDebugToolbar??i.debugUI?.simple,suppressDebugView:i.suppressDebugView??i.debugUI?.simple})}stopDebugging(n){return this.k.$stopDebugging(n?n.id:void 0)}registerDebugConfigurationProvider(n,r,i){if(!r)return new P.$$J(()=>{});const a=this.d++;return this.f.push({type:n,handle:a,provider:r}),this.k.$registerDebugConfigurationProvider(n,i,!!r.provideDebugConfigurations,!!r.resolveDebugConfiguration,!!r.resolveDebugConfigurationWithSubstitutedVariables,a),new P.$$J(()=>{this.f=this.f.filter(h=>h.provider!==r),this.k.$unregisterDebugConfigurationProvider(a)})}registerDebugAdapterDescriptorFactory(n,r,i){if(!i)return new P.$$J(()=>{});if(!this.Q(n,r))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${r}' debugger.`);if(this.N(r))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const a=this.g++;return this.h.push({type:r,handle:a,factory:i}),this.k.$registerDebugAdapterDescriptorFactory(r,a),new P.$$J(()=>{this.h=this.h.filter(h=>h.factory!==i),this.k.$unregisterDebugAdapterDescriptorFactory(a)})}registerDebugAdapterTrackerFactory(n,r){if(!r)return new P.$$J(()=>{});const i=this.i++;return this.j.push({type:n,handle:i,factory:r}),new P.$$J(()=>{this.j=this.j.filter(a=>a.factory!==r)})}async $runInTerminal(n,r){return Promise.resolve(void 0)}async $substituteVariables(n,r){let i;const a=await this.W(n);return a&&(i={uri:a.uri,name:a.name,index:a.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.I.getResolver()).resolveAnyAsync(i,r)}K(n,r){if(n.type==="implementation")return new g(n.implementation)}L(){}async $startDASession(n,r){const i=this,a=await this.V(r);return this.S(this.N(a.type),a).then(h=>{if(!h)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${a.type}' (extension might have failed to activate)`);const p=this.M(h),I=this.K(p,a);if(!I)throw new Error(`Couldn't create a debug adapter for type '${a.type}'.`);const w=I;return this.B.set(n,w),this.R(a).then(f=>(f&&this.C.set(n,f),w.onMessage(async b=>{if(b.type==="request"&&b.command==="handshake"){const L=b,O={type:"response",seq:0,command:L.command,request_seq:L.seq,success:!0};this.D||(this.D=this.L());try{if(this.D){const T=await this.D.sign(L.arguments.value);O.body={signature:T},w.sendResponse(O)}else throw new Error("no signer")}catch(T){O.success=!1,O.message=T.message,w.sendResponse(O)}}else f&&f.onDidSendMessage&&f.onDidSendMessage(b),b=(0,S.$sF)(b,!0),i.k.$acceptDAMessage(n,b)}),w.onError(b=>{f&&f.onError&&f.onError(b),this.k.$acceptDAError(n,b.name,b.message,b.stack)}),w.onExit(b=>{f&&f.onExit&&f.onExit(b??void 0,void 0),this.k.$acceptDAExit(n,b??void 0,void 0)}),f&&f.onWillStartSession&&f.onWillStartSession(),w.startSession()))})}$sendDAMessage(n,r){r=(0,S.$rF)(r,!1);const i=this.C.get(n);i&&i.onWillReceiveMessage&&i.onWillReceiveMessage(r),this.B.get(n)?.sendMessage(r)}$stopDASession(n){const r=this.C.get(n);this.C.delete(n),r&&r.onWillStopSession&&r.onWillStopSession();const i=this.B.get(n);return this.B.delete(n),i?i.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(n){const r=[],i=[],a=[];if(n.added)for(const h of n.added){const p=h.id;if(p&&!this.w.has(p)){let I;if(h.type==="function")I=new P.$$K(h.functionName,h.enabled,h.condition,h.hitCondition,h.logMessage);else if(h.type==="data")I=new P.$_K(h.label,h.dataId,h.canPersist,h.enabled,h.hitCondition,h.condition,h.logMessage);else{const w=l.URI.revive(h.uri);I=new P.$0K(new P.$kK(w,new P.$_J(h.line,h.character)),h.enabled,h.condition,h.hitCondition,h.logMessage)}(0,P.$8K)(I,p),this.w.set(p,I),r.push(I)}}if(n.removed)for(const h of n.removed){const p=this.w.get(h);p&&(this.w.delete(h),i.push(p))}if(n.changed){for(const h of n.changed)if(h.id){const p=this.w.get(h.id);if(p){if(p instanceof P.$$K&&h.type==="function"){const I=p;I.enabled=h.enabled,I.condition=h.condition,I.hitCondition=h.hitCondition,I.logMessage=h.logMessage,I.functionName=h.functionName}else if(p instanceof P.$0K&&h.type==="source"){const I=p;I.enabled=h.enabled,I.condition=h.condition,I.hitCondition=h.hitCondition,I.logMessage=h.logMessage,I.location=new P.$kK(l.URI.revive(h.uri),new P.$_J(h.line,h.character))}a.push(p)}}}this.U(r,i,a)}async $acceptStackFrameFocus(n){let r;const i=n.sessionId?await this.V(n.sessionId):void 0;if(!i)throw new Error("no DebugSession found for debug focus context");n.kind==="thread"?r=new P.$fL(i,n.threadId):r=new P.$eL(i,n.threadId,n.frameId),this.z=r,this.A.fire(this.z)}$provideDebugConfigurations(n,r,i){return(0,y.$Jg)(async()=>{const a=this.P(n);if(!a)throw new Error("no DebugConfigurationProvider found");if(!a.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const h=await this.W(r);return a.provideDebugConfigurations(h,i)}).then(a=>{if(!a)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return a})}$resolveDebugConfiguration(n,r,i,a){return(0,y.$Jg)(async()=>{const h=this.P(n);if(!h)throw new Error("no DebugConfigurationProvider found");if(!h.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const p=await this.W(r);return h.resolveDebugConfiguration(p,i,a)})}$resolveDebugConfigurationWithSubstitutedVariables(n,r,i,a){return(0,y.$Jg)(async()=>{const h=this.P(n);if(!h)throw new Error("no DebugConfigurationProvider found");if(!h.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const p=await this.W(r);return h.resolveDebugConfigurationWithSubstitutedVariables(p,i,a)})}async $provideDebugAdapter(n,r){const i=this.O(n);if(!i)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const a=await this.V(r);return this.S(i,a).then(h=>{if(!h)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${a.type}'`);return this.M(h)})}async $acceptDebugSessionStarted(n){const r=await this.V(n);this.m.fire(r)}async $acceptDebugSessionTerminated(n){const r=await this.V(n);r&&(this.n.fire(r),this.l.delete(r.id))}async $acceptDebugSessionActiveChanged(n){this.q=n?await this.V(n):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(n,r){(await this.V(n))?._acceptNameChanged(r)}async $acceptDebugSessionCustomEvent(n,r){const a={session:await this.V(n),event:r.event,body:r.body};this.u.fire(a)}M(n){if(n instanceof P.$aL)return{type:"executable",command:n.command,args:n.args,options:n.options};if(n instanceof P.$bL)return{type:"server",port:n.port,host:n.host};if(n instanceof P.$cL)return{type:"pipeServer",path:n.path};if(n instanceof P.$dL)return{type:"implementation",implementation:n.implementation};throw new Error("convertToDto unexpected type")}N(n){const r=this.h.filter(i=>i.type===n);if(r.length>0)return r[0].factory}O(n){const r=this.h.filter(i=>i.handle===n);if(r.length>0)return r[0].factory}P(n){const r=this.f.filter(i=>i.handle===n);if(r.length>0)return r[0].provider}Q(n,r){if(n.contributes){const i=n.contributes.debuggers;if(i&&i.length>0){for(const a of i)if(a.label&&a.type&&a.type===r)return!0}}return!1}R(n){const i=n.configuration.type,a=this.j.filter(h=>h.type===i||h.type==="*").map(h=>(0,y.$Jg)(()=>h.factory.createDebugAdapterTracker(n)).then(p=>p,p=>null));return Promise.race([Promise.all(a).then(h=>{const p=h.filter(I=>!!I);if(p.length>0)return new o(p)}),new Promise(h=>setTimeout(()=>h(void 0),1e3))]).catch(h=>{})}async S(n,r){const i=r.configuration.debugServer;if(typeof i=="number")return Promise.resolve(new P.$bL(i));if(n){const h=await this.F.getExtensionRegistry();return(0,y.$Jg)(()=>n.createDebugAdapterDescriptor(r,this.T(r,h))).then(p=>{if(p)return p})}const a=await this.F.getExtensionRegistry();return Promise.resolve(this.T(r,a))}T(n,r){}U(n,r,i){(n.length>0||r.length>0||i.length>0)&&this.y.fire(Object.freeze({added:n,removed:r,changed:i}))}async V(n){if(n)if(typeof n=="string"){const r=this.l.get(n);if(r)return r}else{let r=this.l.get(n.id);if(!r){const i=await this.W(n.folderUri),a=n.parent?this.l.get(n.parent):void 0;r=new c(this.k,n.id,n.type,n.name,i,n.configuration,a),this.l.set(r.id,r),this.k.$sessionCached(r.id)}return r}throw new Error("cannot find session")}W(n){if(n){const r=l.URI.revive(n);return this.E.resolveWorkspaceFolder(r)}return Promise.resolve(void 0)}};e.$Tcc=s,e.$Tcc=s=Ke([We(0,$.$0L),We(1,C.$Mbc),We(2,k.$icc),We(3,D.$Pbc),We(4,m.$Occ),We(5,E.$Qcc)],s);class c{constructor(n,r,i,a,h,p,I){this.d=n,this.f=r,this.g=i,this.h=a,this.i=h,this.j=p,this.k=I}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(n){this.h=n,this.d.$setDebugSessionName(this.f,n)}get parentSession(){return this.k}_acceptNameChanged(n){this.h=n}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(n,r){return this.d.$customDebugAdapterRequest(this.f,n,r)}getDebugProtocolBreakpoint(n){return this.d.$getDebugProtocolBreakpoint(this.f,n.id)}}e.$Ucc=c;class u{constructor(n){this.value=Object.freeze({append(r){n.$appendDebugConsole(r)},appendLine(r){this.append(r+`
`)}})}}e.$Vcc=u;class o{constructor(n){this.d=n}onWillStartSession(){this.d.forEach(n=>n.onWillStartSession?n.onWillStartSession():void 0)}onWillReceiveMessage(n){this.d.forEach(r=>r.onWillReceiveMessage?r.onWillReceiveMessage(n):void 0)}onDidSendMessage(n){this.d.forEach(r=>r.onDidSendMessage?r.onDidSendMessage(n):void 0)}onWillStopSession(){this.d.forEach(n=>n.onWillStopSession?n.onWillStopSession():void 0)}onError(n){this.d.forEach(r=>r.onError?r.onError(n):void 0)}onExit(n,r){this.d.forEach(i=>i.onExit?i.onExit(n,r):void 0)}}class g extends v.$Rcb{constructor(n){super(),this.h=n,n.onDidSendMessage(r=>{this.acceptMessage(r)})}startSession(){return Promise.resolve(void 0)}sendMessage(n){this.h.handleMessage(n)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let d=class extends s{constructor(n,r,i,a,h,p){super(n,r,i,a,h,p)}};e.$Wcc=d,e.$Wcc=d=Ke([We(0,$.$0L),We(1,C.$Mbc),We(2,k.$icc),We(3,D.$Pbc),We(4,m.$Occ),We(5,E.$Qcc)],d)}),define(Se[350],De([1,0,8,53,2,6,341,14,104,105,26,238,20,67,45,89]),function(ne,e,y,M,l,R,A,m,k,$,P,C,v,S,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jdc=e.$Idc=void 0;class s{static async installEarlyHandler(o){Error.stackTraceLimit=100;const g=o.get(m.$6i),t=o.get(v.$0L).getProxy(R.$9J.MainThreadErrors);y.setUnexpectedErrorHandler(n=>{g.error(n);const r=y.$1(n);t.$onUnexpectedError(r)})}static async installFullHandler(o){const g=o.get(m.$6i),d=o.get(v.$0L),t=o.get(D.$icc),n=o.get(E.$rM),r=d.getProxy(R.$9J.MainThreadExtensionService),i=d.getProxy(R.$9J.MainThreadErrors),a=await t.getExtensionPathIndex(),h=new WeakMap;function p(f,b){if(h.has(f))return h.get(f).stack;let L="",O,T;for(const U of b)L+=`
	at ${U.toString()}`,T=U.getFileName(),!O&&T&&(O=a.findSubstr(l.URI.file(T)));const F=`${f.name||"Error"}: ${f.message||""}${L}`;return h.set(f,{extensionIdentifier:O?.identifier,stack:F}),F}const I=Symbol("prepareStackTrace wrapped");let w=p;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return w},set(f){if(f===p||!f||f[I]){w=f||p;return}w=function(b,L){return p(b,L),f.call(Error,b,L)},Object.assign(w,{[I]:!0})}}),y.setUnexpectedErrorHandler(f=>{g.error(f);const b=y.$1(f),L=h.get(f);if(!L?.extensionIdentifier){i.$onUnexpectedError(b);return}r.$onExtensionRuntimeError(L.extensionIdentifier,b);const O=n.onExtensionError(L.extensionIdentifier,f);g.trace("forwarded error to extension?",O,L)})}}e.$Idc=s;class c{constructor(o,g,d,t,n){this.a=d,this.b=new A.$b4b(o,null,t),g=c.e(g,this.b);const r=new $.$Jh(...(0,k.$pr)());r.set(P.$nM,{_serviceBrand:void 0,...g,messagePorts:n}),r.set(v.$0L,new v.$$L(this.b)),r.set(S.$Jbc,new S.$Kbc(t)),r.set(D.$gcc,d);const i=new C.$8p(r,!0);i.invokeFunction(s.installEarlyHandler),this.d=i.invokeFunction(a=>a.get(m.$6i)),M.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",g),this.c=i.invokeFunction(a=>a.get(D.$icc)),this.c.initialize(),i.invokeFunction(s.installFullHandler)}async asBrowserUri(o){const g=this.b.getProxy(R.$9J.MainThreadExtensionService);return l.URI.revive(await g.$asBrowserUri(o))}terminate(o){this.c.terminate(o)}static e(o,g){o.extensions.allExtensions.forEach(t=>{t.extensionLocation=l.URI.revive(g.transformIncomingURIs(t.extensionLocation))}),o.environment.appRoot=l.URI.revive(g.transformIncomingURIs(o.environment.appRoot));const d=o.environment.extensionDevelopmentLocationURI;return d&&(o.environment.extensionDevelopmentLocationURI=d.map(t=>l.URI.revive(g.transformIncomingURIs(t)))),o.environment.extensionTestsLocationURI=l.URI.revive(g.transformIncomingURIs(o.environment.extensionTestsLocationURI)),o.environment.globalStorageHome=l.URI.revive(g.transformIncomingURIs(o.environment.globalStorageHome)),o.environment.workspaceStorageHome=l.URI.revive(g.transformIncomingURIs(o.environment.workspaceStorageHome)),o.environment.extensionTelemetryLogResource=l.URI.revive(g.transformIncomingURIs(o.environment.extensionTelemetryLogResource)),o.nlsBaseUrl=l.URI.revive(g.transformIncomingURIs(o.nlsBaseUrl)),o.logsLocation=l.URI.revive(g.transformIncomingURIs(o.logsLocation)),o.workspace=g.transformIncomingURIs(o.workspace),o}}e.$Jdc=c}),define(Se[351],De([1,0,9,10,215,232,139,95,71,45,20,44,7,55,37,271,272,40]),function(ne,e,y,M,l,R,A,m,k,$,P,C,v,S,D,E,s,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tdc=void 0;let u=class extends m.$Tcc{constructor(n,r,i,a,h,p,I){super(n,r,i,a,p,I),this.Z=h,this.X=new d}K(n,r){switch(n.type){case"server":return new E.$Odc(n);case"pipeServer":return new E.$Pdc(n);case"executable":return new E.$Qdc(n,r.type)}return super.K(n,r)}T(n,r){const i=E.$Qdc.platformAdapterExecutable(r.getAllExtensionDescriptions(),n.type);if(i)return new v.$aL(i.command,i.args,i.options)}L(){return new A.$O7b}async $runInTerminal(n,r){if(n.kind==="integrated"){this.Y||(this.Y=this.Z.onDidCloseTerminal(F=>{this.X.onTerminalClosed(F)}));const i=await this.G.getConfigProvider(),a=this.Z.getDefaultShell(!0),h=this.Z.getDefaultShellArgs(!0),p=n.title||l.localize(0,null),I=JSON.stringify({shell:a,shellArgs:h});let w=await this.X.checkout(I,p),f,b=!1;if(w)f=n.cwd;else{const F={shellPath:a,shellArgs:h,cwd:n.cwd,name:p,iconPath:new v.$5K("debug")};b=!0,w=this.Z.createTerminalFromOptions(F,{isFeatureTerminal:!0,useShellEnvironment:!0}),this.X.insert(w,I)}w.show(!0);const L=await w.processId;b?await new Promise(F=>setTimeout(F,1e3)):i.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(a.indexOf("powershell")>=0||a.indexOf("pwsh")>=0||a.indexOf("cmd.exe")>=0?w.sendText("cls"):a.indexOf("bash")>=0?w.sendText("clear"):M.$d?w.sendText("cls"):w.sendText("clear"));const O=(0,s.$Sdc)(a,n.args,!!n.argsCanBeInterpretedByShell,f,n.env);w.sendText(O);const T=this.onDidTerminateDebugSession(F=>{F.id===r&&(this.X.free(w),T.dispose())});return L}else if(n.kind==="external")return g(n,await this.G.getConfigProvider());return super.$runInTerminal(n,r)}};e.$Tdc=u,e.$Tdc=u=Ke([We(0,P.$0L),We(1,D.$Mbc),We(2,$.$icc),We(3,c.$Pbc),We(4,C.$8bc),We(5,k.$Occ),We(6,S.$Qcc)],u);let o;function g(t,n){if(!o)if(M.$d)o=new R.$x6b;else if(M.$e)o=new R.$y6b;else if(M.$f)o=new R.$z6b;else throw new Error("external terminals not supported on this platform");const r=n.getConfiguration("terminal");return o.runInTerminal(t.title,t.cwd,t.args,t.env||{},r.external||{})}class d{constructor(){this.b=new Map}async checkout(n,r){const a=[...this.b.entries()].map(([h,p])=>(0,y.$Eg)(async I=>{if(h.name!==r||p.lastUsedAt!==-1&&await(0,s.$Rdc)(await h.processId))return null;const w=Date.now();return p.lastUsedAt+d.a>w||I.isCancellationRequested||p.config!==n?null:(p.lastUsedAt=w,h)}));return await(0,y.$Vg)(a,h=>!!h)}insert(n,r){this.b.set(n,{lastUsedAt:Date.now(),config:r})}free(n){const r=this.b.get(n);r&&(r.lastUsedAt=-1)}onTerminalClosed(n){this.b.delete(n)}}d.a=1e3}),define(Se[352],De([1,0,15,2,102,37,70,40,43,44,20,26,94,17,14,90,24,61,55]),function(ne,e,y,M,l,R,A,m,k,$,P,C,v,S,D,E,s,c,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ldc=void 0;let o=class extends v.$Lcc{constructor(d,t,n,r,i,a,h,p,I){super(d,t,n,r,i,a,h,p),this.B=n,this.C=I,t.remote.isRemote&&t.remote.authority?this.registerTaskSystem(S.Schemas.vscodeRemote,{scheme:S.Schemas.vscodeRemote,authority:t.remote.authority,platform:process.platform}):this.registerTaskSystem(S.Schemas.file,{scheme:S.Schemas.file,authority:"",platform:process.platform}),this.a.$registerSupportedExecutions(!0,!0,!0)}async executeTask(d,t){const n=t;if(!t.execution&&n._id===void 0)throw new Error("Tasks to execute must include an execution");if(n._id!==void 0){const r=v.TaskHandleDTO.from(n,this.B),i=await this.a.$getTaskExecution(r);if(i.task===void 0)throw new Error("Task from execution DTO is undefined");const a=await this.y(i,t);return this.a.$executeTask(r).catch(()=>{}),a}else{const r=v.TaskDTO.from(t,d);if(r===void 0)return Promise.reject(new Error("Task is not valid"));v.CustomExecutionDTO.is(r.execution)&&await this.x(r,t,!1);const i=await this.y(await this.a.$getTaskExecution(r),t);return this.a.$executeTask(r).catch(()=>{}),i}}u(d,t,n,r){const i=[];if(r)for(const a of r){this.z(a,n),(!a.definition||!d[a.definition.type])&&this.f.warn(`The task [${a.source}, ${a.name}] uses an undefined task type. The task will be ignored in the future.`);const h=v.TaskDTO.from(a,n.extension);h&&(i.push(h),v.CustomExecutionDTO.is(h.execution)&&t.push(this.x(h,a,!0)))}return{tasks:i,extension:n.extension}}async v(d){return d}async F(d){let t=d&&d.length>0?d[0]:void 0;if(!t){const n=M.URI.file((0,c.homedir)());t=new k.$6h({uri:n,name:s.$pg(n),index:0})}return{uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(d,t){const n=M.URI.revive(d),r={process:void 0,variables:Object.create(null)},i=await this.b.resolveWorkspaceFolder(n),a=await this.b.getWorkspaceFolders2()??[],h=await this.C.getResolver(),p=i?{uri:i.uri,name:i.name,index:i.index,toResource:()=>{throw new Error("Not implemented")}}:await this.F(a);for(const I of t.variables)r.variables[I]=await h.resolveAsync(p,I);if(t.process!==void 0){let I;if(t.process.path!==void 0){I=t.process.path.split(y.$rc);for(let w=0;w<I.length;w++)I[w]=await h.resolveAsync(p,I[w])}r.process=await l.win32.findExecutable(await h.resolveAsync(p,t.process.name),t.process.cwd!==void 0?await h.resolveAsync(p,t.process.cwd):void 0,I)}return r}async $jsonTasksSupported(){return!0}async $findExecutable(d,t,n){return l.win32.findExecutable(d,t,n)}};e.$Ldc=o,e.$Ldc=o=Ke([We(0,P.$0L),We(1,C.$nM),We(2,R.$Mbc),We(3,A.$iM),We(4,m.$Pbc),We(5,$.$8bc),We(6,D.$6i),We(7,E.$Cbc),We(8,u.$Qcc)],o)}),define(Se[353],De([1,0,61,55]),function(ne,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rec=void 0;class l extends M.$Rcc{m(){return(0,y.homedir)()}}e.$rec=l}),define(Se[154],De([1,0,19,9,21,48,17,15,24,2,36]),function(ne,e,y,M,l,R,A,m,k,$,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2cc=e.$1cc=e.$Zcc=e.$Ycc=void 0;class C{constructor(u,o,g,d){this.d=u,this.e=o,this.f=g,this.g=d,this.a=null,this.b=!1,this.c=0}search(u,o){const g=this.d.folderQueries||[],d=new l.$Vd(o);return new Promise((t,n)=>{this.a=new S(u);let r=!1;const i=(a,h)=>{if(!r&&!this.b){const p=this.h(a);E(a)&&typeof this.d.maxResults=="number"&&this.c+p>this.d.maxResults&&(this.b=!0,r=!0,d.cancel(),a=this.j(a,this.d.maxResults-this.c));const I=this.h(a);this.c+=I,(I>0||!E(a))&&this.a.add(a,h)}};Promise.all(g.map((a,h)=>this.k(a,p=>i(p,h),d.token))).then(a=>{d.dispose(),this.a.flush();const h=a.some(p=>!!p&&!!p.limitHit);t({limitHit:this.b||h,messages:(0,y.$Pb)(a.map(p=>p?.message?Array.isArray(p.message)?p.message:[p.message]:[])),stats:{type:this.g}})},a=>{d.dispose();const h=(0,R.$wi)(a);n(new Error(h))})})}h(u){return E(u)?Array.isArray(u.ranges)?u.ranges.length:1:0}j(u,o){const g=Array.isArray(u.ranges)?u.ranges:[u.ranges],d=Array.isArray(u.preview.matches)?u.preview.matches:[u.preview.matches];return{ranges:g.slice(0,o),preview:{matches:d.slice(0,o),text:u.preview.text},uri:u.uri}}async k(u,o,g){const d=new P.$TI(this.d,u),t=[],n={report:a=>{if(!this.l(a))return;const h=u.folder.scheme===A.Schemas.file?(0,P.$UI)(()=>this.f.readdir(k.$rg(a.uri))):void 0,p=k.$ug(u.folder,a.uri);if(p){const I=d.includedInQuery(p,m.$lc(p),h);(0,M.$Dg)(I)?t.push(I.then(w=>{w&&o(a)})):I&&o(a)}}},r=this.n(u),i=await this.e.provideTextSearchResults(v(this.d.contentPattern),r,n,g);return t.length&&await Promise.all(t),i}l(u){if(E(u)){if(Array.isArray(u.ranges)){if(!Array.isArray(u.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(u.preview.matches.length!==u.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(u.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(u){const o=(0,P.$SI)(this.d.includePattern,u.includePattern),g=(0,P.$SI)(this.d.excludePattern,u.excludePattern),d={folder:$.URI.from(u.folder),excludes:g,includes:o,useIgnoreFiles:!u.disregardIgnoreFiles,useGlobalIgnoreFiles:!u.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!u.disregardParentIgnoreFiles,followSymlinks:!u.ignoreSymlinks,encoding:u.fileEncoding&&this.f.toCanonicalName(u.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return d.usePCRE2=this.d.usePCRE2,d}}e.$Ycc=C;function v(c){return{isCaseSensitive:c.isCaseSensitive||!1,isRegExp:c.isRegExp||!1,isWordMatch:c.isWordMatch||!1,isMultiline:c.isMultiline||!1,pattern:c.pattern}}class S{constructor(u){this.e=u,this.b=-1,this.d=null,this.a=new s(512,o=>this.g(o))}add(u,o){this.d&&(this.b!==o||!k.$lg(this.c,u.uri))&&(this.f(),this.d=null),this.d||(this.b=o,this.d={resource:u.uri,results:[]}),this.d.results.push(D(u))}f(){const u=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,u)}flush(){this.f(),this.a.flush()}g(u){this.e(u)}}e.$Zcc=S;function D(c){return E(c)?{preview:{matches:(0,y.$Zb)(c.preview.matches,u=>({startLineNumber:u.start.line,startColumn:u.start.character,endLineNumber:u.end.line,endColumn:u.end.character})),text:c.preview.text},ranges:(0,y.$Zb)(c.ranges,u=>({startLineNumber:u.start.line,startColumn:u.start.character,endLineNumber:u.end.line,endColumn:u.end.character}))}:{text:c.text,lineNumber:c.lineNumber}}function E(c){return!!c.preview}e.$1cc=E;class s{constructor(u,o){this.g=u,this.h=o,this.c=0,this.d=[],this.e=0}addItem(u,o){u&&this.j(u,o)}addItems(u,o){u&&this.k(u,o)}j(u,o){this.d.push(u),this.e+=o,this.l()}k(u,o){this.d=this.d.concat(u),this.e+=o,this.l()}l(){this.c<s.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},s.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$2cc=s,s.a=4e3,s.b=50}),define(Se[96],De([1,0,3,6,5,346,20,67,14,2,154]),function(ne,e,y,M,l,R,A,m,k,$,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5cc=e.$4cc=e.$3cc=void 0,e.$3cc=(0,l.$Lh)("IExtHostSearch");let C=class{constructor(E,s,c){this.k=E,this.l=s,this.n=c,this.c=this.k.getProxy(M.$9J.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new R.$Xcc}o(E){return this.l.transformOutgoingScheme(E)}registerTextSearchProvider(E,s){if(this.g.has(E))throw new Error(`a text search provider for the scheme '${E}' is already registered`);this.g.add(E);const c=this.d++;return this.e.set(c,s),this.c.$registerTextSearchProvider(c,this.o(E)),(0,y.$Oc)(()=>{this.g.delete(E),this.e.delete(c),this.c.$unregisterProvider(c)})}registerFileSearchProvider(E,s){if(this.i.has(E))throw new Error(`a file search provider for the scheme '${E}' is already registered`);this.i.add(E);const c=this.d++;return this.h.set(c,s),this.c.$registerFileSearchProvider(c,this.o(E)),(0,y.$Oc)(()=>{this.i.delete(E),this.h.delete(c),this.c.$unregisterProvider(c)})}$provideFileSearchResults(E,s,c,u){const o=v(c),g=this.h.get(E);if(g)return this.j.fileSearch(o,g,d=>{this.c.$handleFileMatch(E,s,d.map(t=>t.resource))},u);throw new Error("unknown provider: "+E)}$clearCache(E){return this.j.clearCache(E),Promise.resolve(void 0)}$provideTextSearchResults(E,s,c,u){const o=this.e.get(E);if(!o||!o.provideTextSearchResults)throw new Error(`Unknown provider ${E}`);const g=v(c);return this.q(g,o).search(t=>this.c.$handleTextMatch(E,s,t),u)}$enableExtensionHostSearch(){}q(E,s){return new P.$Ycc(E,s,{readdir:c=>Promise.resolve([]),toCanonicalName:c=>c},"textSearchProvider")}};e.$4cc=C,e.$4cc=C=Ke([We(0,A.$0L),We(1,m.$Jbc),We(2,k.$6i)],C);function v(D){return{...D,folderQueries:D.folderQueries&&D.folderQueries.map(S),extraFileResources:D.extraFileResources&&D.extraFileResources.map(E=>$.URI.revive(E))}}e.$5cc=v;function S(D){return{...D,folder:$.URI.revive(D.folder)}}}),define(Se[354],De([1,0,21,8,4,39,2,131,129,174,173,30,6,112,301,300,33,302,40,304,305,306,279,307,70,45,309,310,315,316,317,153,283,323,324,326,116,44,328,286,13,7,85,331,92,152,37,25,275,314,66,150,94,95,96,14,67,20,26,318,273,73,90,293,329,91,72,334,332,333,294,54,327,330,115,71,89,319,93,320,17,135,282,263,312,3,27,269,113,257,321,322,295,311,281,313,114,325,297,298,299,292,308,296]),function(ne,e,y,M,l,R,A,m,k,$,P,C,v,S,D,E,s,c,u,o,g,d,t,n,r,i,a,h,p,I,w,f,b,L,O,T,F,U,N,j,z,B,ae,X,Q,H,te,me,le,ye,de,V,J,ee,Y,Z,_,pe,se,ge,ie,fe,be,Ie,W,G,ce,he,x,$e,ve,Ne,Ve,xe,Qe,rt,it,nt,Ae,Fe,Le,Je,ue,oe,Ce,He,ze,Ze,st,lt,wt,Ct,Xt,qt,vt,Nt,jt,Yt,Ut,zt,Ht,Gt,Bt,Kt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ddc=void 0;function Jt(ct){const mt=ct.get(se.$nM),It=ct.get(Ne.$zbc),Rt=ct.get(ce.$5bc),Pt=ct.get(i.$icc),gt=ct.get(te.$Mbc),St=ct.get(it.$rM),At=ct.get(u.$Pbc),Ft=ct.get(_.$Jbc),Xe=ct.get(pe.$0L),Me=ct.get(F.$1bc),Te=ct.get(G.$6bc),Pe=ct.get(Z.$7i),re=ct.get(Z.$6i),Oe=ct.get(fe.$ksb),qe=ct.get(be.$Cbc),_e=ct.get(H.$Gcc),Ge=ct.get(Qe.$acc),ot=ct.get(rt.$Occ),pt=ct.get(jt.$ecc);Xe.set(v.$0J.ExtHostFileSystemInfo,It),Xe.set(v.$0J.ExtHostLogLevelServiceShape,Pe),Xe.set(v.$0J.ExtHostWorkspace,gt),Xe.set(v.$0J.ExtHostConfiguration,At),Xe.set(v.$0J.ExtHostExtensionService,Pt),Xe.set(v.$0J.ExtHostStorage,Me),Xe.set(v.$0J.ExtHostTunnelService,Oe),Xe.set(v.$0J.ExtHostWindow,_e),Xe.set(v.$0J.ExtHostSecretState,Ge),Xe.set(v.$0J.ExtHostTelemetry,St),Xe.set(v.$0J.ExtHostEditorTabs,ot),Xe.set(v.$0J.ExtHostManagedSockets,pt);const Mt=Xe.set(v.$0J.ExtHostDecorations,ct.get(V.$Kcc)),yt=Xe.set(v.$0J.ExtHostDocumentsAndEditors,ct.get(r.$iM)),ut=Xe.set(v.$0J.ExtHostCommands,ct.get(s.$tM)),bt=Xe.set(v.$0J.ExtHostTerminalService,ct.get(U.$8bc)),Dt=Xe.set(v.$0J.ExtHostDebugService,ct.get(ee.$Scc)),mi=Xe.set(v.$0J.ExtHostSearch,ct.get(Y.$3cc)),Wt=Xe.set(v.$0J.ExtHostTask,ct.get(J.$Ncc)),$i=Xe.set(v.$0J.ExtHostOutputService,ct.get(f.$qcc)),ii=Xe.set(v.$0J.ExtHostLocalization,ct.get(st.$dcc)),Si=Xe.set(v.$0J.ExtHostUrls,new X.$zcc(Xe)),Tt=Xe.set(v.$0J.ExtHostDocuments,new n.$xbc(Xe,yt)),hn=Xe.set(v.$0J.ExtHostDocumentContentProviders,new d.$Rbc(Xe,yt,re)),Di=Xe.set(v.$0J.ExtHostDocumentSaveParticipant,new t.$Sbc(re,Tt,Xe.getProxy(v.$9J.MainThreadBulkEdits))),kt=Xe.set(v.$0J.ExtHostNotebook,new ge.$9cc(Xe,ut,yt,Tt,Rt)),bi=Xe.set(v.$0J.ExtHostNotebookDocuments,new oe.$odc(kt)),Zt=Xe.set(v.$0J.ExtHostNotebookEditors,new ue.$ndc(re,kt)),oi=Xe.set(v.$0J.ExtHostNotebookKernels,new nt.$kdc(Xe,mt,kt,ut,re)),qi=Xe.set(v.$0J.ExtHostNotebookRenderers,new Fe.$mdc(Xe,kt)),Ci=Xe.set(v.$0J.ExtHostNotebookDocumentSaveParticipant,new vt.$udc(re,kt,Xe.getProxy(v.$9J.MainThreadBulkEdits))),Ot=Xe.set(v.$0J.ExtHostEditors,new N.$xcc(Xe,yt)),Hi=Xe.set(v.$0J.ExtHostTreeViews,new j.$ycc(Xe.getProxy(v.$9J.MainThreadTreeViews),ut,re)),ai=Xe.set(v.$0J.ExtHostEditorInsets,new le.$Hcc(Xe.getProxy(v.$9J.MainThreadEditorInsets),Ot,mt.remote)),ci=Xe.set(v.$0J.ExtHostDiagnostics,new o.$Bbc(Xe,re,It,yt)),ui=Xe.set(v.$0J.ExtHostLanguages,new I.$ncc(Xe,Tt,ut.converter,Ft)),dt=Xe.set(v.$0J.ExtHostLanguageFeatures,new p.$Fbc(Xe,Ft,Tt,ut,ci,re,qe,St)),Ii=Xe.set(v.$0J.ExtHostFileSystem,new a.$lcc(Xe,dt)),_t=Xe.set(v.$0J.ExtHostFileSystemEventService,new h.$mcc(Xe,re,yt)),ni=Xe.set(v.$0J.ExtHostQuickOpen,(0,L.$scc)(Xe,gt,ut)),wi=Xe.set(v.$0J.ExtHostSCM,new O.$ucc(Xe,ut,Tt,re)),Pi=Xe.set(v.$0J.ExtHostQuickDiff,new Ct.$rdc(Xe,Ft)),Ai=Xe.set(v.$0J.ExtHostShare,new Yt.$wdc(Xe,Ft)),Li=Xe.set(v.$0J.ExtHostComments,(0,c.$Ibc)(Xe,ut,Tt)),Ri=Xe.set(v.$0J.ExtHostProgress,new b.$rcc(Xe.getProxy(v.$9J.MainThreadProgress))),Mi=Xe.set(v.$0J.ExtHosLabelService,new ye.$Icc(Xe)),pi=Xe.set(v.$0J.ExtHostTheming,new ie.$0cc(Xe)),ri=Xe.set(v.$0J.ExtHostAuthentication,new Ie.$$cc(Xe)),Ti=Xe.set(v.$0J.ExtHostTimeline,new W.$adc(Xe,ut)),vi=Xe.set(v.$0J.ExtHostWebviews,new Q.$Ccc(Xe,mt.remote,gt,re,qe)),hi=Xe.set(v.$0J.ExtHostWebviewPanels,new $e.$cdc(Xe,vi,gt)),Fi=Xe.set(v.$0J.ExtHostCustomEditors,new x.$ddc(Xe,Tt,Te,vi,hi)),Ki=Xe.set(v.$0J.ExtHostWebviewViews,new he.$bdc(Xe,vi)),li=Xe.set(v.$0J.ExtHostTesting,new Ve.$fdc(Xe,ut,yt)),Ji=Xe.set(v.$0J.ExtHostUriOpeners,new xe.$jdc(Xe)),Gi=Xe.set(v.$0J.ExtHostProfileContentHandlers,new wt.$qdc(Xe));Xe.set(v.$0J.ExtHostInteractive,new Ce.$pdc(Xe,kt,yt,ut,re));const Qi=Xe.set(v.$0J.ExtHostInlineChat,new qt.$tdc(Xe,ut,Tt,re)),yi=Xe.set(v.$0J.ExtHostChatProvider,new Ut.$xdc(Xe,re)),dn=Xe.set(v.$0J.ExtHostChatSlashCommands,new zt.$ydc(Xe,yi,re)),Oi=Xe.set(v.$0J.ExtHostChatAgents,new Kt.$Cdc(Xe,yi,re)),Ni=Xe.set(v.$0J.ExtHostChatVariables,new Ht.$zdc(Xe)),di=Xe.set(v.$0J.ExtHostChat,new Xt.$sdc(Xe,re)),Xi=Xe.set(v.$0J.ExtHostAiRelatedInformation,new Gt.$Adc(Xe)),Yi=Xe.set(v.$0J.ExtHostAiEmbeddingVector,new Bt.$Bdc(Xe)),Ei=Xe.set(v.$0J.ExtHostIssueReporter,new Nt.$vdc(Xe)),ji=Xe.set(v.$0J.ExtHostStatusBar,new T.$wcc(Xe,ut.converter)),Zi=Object.values(v.$0J);Xe.assertRegistered(Zi);const xi=new ve.$edc(Xe,yt),fn=new E.$Hbc(Xe),fi=new w.$occ(Xe,re),Ui=new g.$Qbc(Xe);return D.$Gbc.register(ut),function(Ue,Qt,_i){const $t=function(){let we=!Ue.isUnderDevelopment;function ke(){we||(re.info(`Extension '${Ue.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),we=!0)}return function je(at){if(Array.isArray(at))at.forEach(je);else if(typeof at=="string")ke();else{const Et=at;typeof Et.scheme>"u"&&ke(),typeof Et.exclusive=="boolean"&&(0,ze.$8E)(Ue,"documentFiltersExclusive")}return at}}(),ki={getSession(we,ke,je){return ri.getSession(Ue,we,ke,je)},getSessions(we,ke){return(0,ze.$8E)(Ue,"authGetSessions"),ri.getSessions(Ue,we,ke)},async hasSession(we,ke){return(0,ze.$8E)(Ue,"authSession"),!!await ri.getSession(Ue,we,ke,{silent:!0})},get onDidChangeSessions(){return ri.onDidChangeSessions},registerAuthenticationProvider(we,ke,je,at){return ri.registerAuthenticationProvider(we,ke,je,at)}},en={registerCommand(we,ke,je){return ut.registerCommand(!0,we,ke,je,void 0,Ue)},registerTextEditorCommand(we,ke,je){return ut.registerCommand(!0,we,(...at)=>{const Et=Ot.getActiveTextEditor();if(!Et){re.warn("Cannot execute "+we+" because there is no active text editor.");return}return Et.edit(Lt=>{ke.apply(je,[Et,Lt,...at])}).then(Lt=>{Lt||re.warn("Edits from command "+we+" were not applied.")},Lt=>{re.warn("An error occurred while running command "+we,Lt)})},void 0,void 0,Ue)},registerDiffInformationCommand:(we,ke,je)=>((0,ze.$8E)(Ue,"diffCommand"),ut.registerCommand(!0,we,async(...at)=>{const Et=yt.activeEditor(!0);if(!Et){re.warn("Cannot execute "+we+" because there is no active text editor.");return}const Lt=await Ot.getDiffInformation(Et.id);ke.apply(je,[Lt,...at])},void 0,void 0,Ue)),executeCommand(we,...ke){return ut.executeCommand(we,...ke)},getCommands(we=!1){return ut.getCommands(we)}},zi={get machineId(){return mt.telemetryInfo.machineId},get sessionId(){return mt.telemetryInfo.sessionId},get language(){return mt.environment.appLanguage},get appName(){return mt.environment.appName},get appRoot(){return mt.environment.appRoot?.fsPath??""},get appHost(){return mt.environment.appHost},get uriScheme(){return mt.environment.appUriScheme},get clipboard(){return fn.value},get shell(){return bt.getDefaultShell(!1)},get onDidChangeShell(){return bt.onDidChangeShell},get isTelemetryEnabled(){return St.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return St.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,ze.$8E)(Ue,"telemetry"),St.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,ze.$8E)(Ue,"telemetry"),St.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,it.$qM)(mt.telemetryInfo.firstSessionDate)},createTelemetryLogger(we,ke){return it.$pM.validateSender(we),St.instantiateLogger(Ue,we,ke)},openExternal(we,ke){return _e.openUri(we,{allowTunneling:!!mt.remote.authority,allowContributedOpeners:ke?.allowContributedOpeners})},async asExternalUri(we){if(we.scheme===mt.environment.appUriScheme)return Si.createAppUri(we);try{return await _e.asExternalUri(we,{allowTunneling:!!mt.remote.authority})}catch(ke){if((0,Je.$2T)(we,Le.Schemas.http)||(0,Je.$2T)(we,Le.Schemas.https))return we;throw ke}},get remoteName(){return(0,de.$Qk)(mt.remote.authority)},get remoteAuthority(){return(0,ze.$8E)(Ue,"resolvers"),mt.remote.authority},get uiKind(){return mt.uiKind},get logLevel(){return re.getLevel()},get onDidChangeLogLevel(){return re.onDidChangeLogLevel},registerIssueUriRequestHandler(we){return(0,ze.$8E)(Ue,"handleIssueUri"),Ei.registerIssueUriRequestHandler(Ue,we)},get appQuality(){return(0,ze.$8E)(Ue,"resolvers"),mt.quality},get appCommit(){return(0,ze.$8E)(Ue,"resolvers"),mt.commit}};mt.environment.extensionTestsLocationURI||Object.freeze(zi);const tn={createTestController(we,ke,je){return li.createTestController(Ue,we,ke,je)},createTestObserver(){return(0,ze.$8E)(Ue,"testObserver"),li.createTestObserver()},runTests(we){return(0,ze.$8E)(Ue,"testObserver"),li.runTests(we)},get onDidChangeTestResults(){return(0,ze.$8E)(Ue,"testObserver"),li.onResultsChanged},get testResults(){return(0,ze.$8E)(Ue,"testObserver"),li.results}},gi=mt.remote.isRemote?B.ExtensionKind.Workspace:B.ExtensionKind.UI,gn={getExtension(we,ke){(0,ze.$7E)(Ue,"extensionsAny")||(ke=!1);const je=Qt.mine.getExtensionDescription(we);if(je)return new i.$jcc(Pt,Ue.identifier,je,gi,!1);if(ke){const at=Qt.all.getExtensionDescription(we);if(at)return new i.$jcc(Pt,Ue.identifier,at,gi,!0)}},get all(){const we=[];for(const ke of Qt.mine.getAllExtensionDescriptions())we.push(new i.$jcc(Pt,Ue.identifier,ke,gi,!1));return we},get allAcrossExtensionHosts(){(0,ze.$8E)(Ue,"extensionsAny");const we=new me.$Yl(Qt.mine.getAllExtensionDescriptions().map(je=>je.identifier)),ke=[];for(const je of Qt.all.getAllExtensionDescriptions()){const at=!we.has(je.identifier);ke.push(new i.$jcc(Pt,Ue.identifier,je,gi,at))}return ke},get onDidChange(){return(0,ze.$7E)(Ue,"extensionsAny")?l.Event.any(Qt.mine.onDidChange,Qt.all.onDidChange):Qt.mine.onDidChange}},nn={createDiagnosticCollection(we){return ci.createDiagnosticCollection(Ue.identifier,we)},get onDidChangeDiagnostics(){return ci.onDidChangeDiagnostics},getDiagnostics:we=>ci.getDiagnostics(we),getLanguages(){return ui.getLanguages()},setTextDocumentLanguage(we,ke){return ui.changeLanguage(we.uri,ke)},match(we,ke){const je=Tt.getDocumentData(ke.uri)?.notebook;return(0,P.$iE)(z.LanguageSelector.from(we),ke.uri,ke.languageId,!0,je?.uri,je?.notebookType)},registerCodeActionsProvider(we,ke,je){return dt.registerCodeActionProvider(Ue,$t(we),ke,je)},registerDocumentPasteEditProvider(we,ke,je){return(0,ze.$8E)(Ue,"documentPaste"),dt.registerDocumentPasteEditProvider(Ue,$t(we),ke,je)},registerCodeLensProvider(we,ke){return dt.registerCodeLensProvider(Ue,$t(we),ke)},registerDefinitionProvider(we,ke){return dt.registerDefinitionProvider(Ue,$t(we),ke)},registerDeclarationProvider(we,ke){return dt.registerDeclarationProvider(Ue,$t(we),ke)},registerImplementationProvider(we,ke){return dt.registerImplementationProvider(Ue,$t(we),ke)},registerTypeDefinitionProvider(we,ke){return dt.registerTypeDefinitionProvider(Ue,$t(we),ke)},registerHoverProvider(we,ke){return dt.registerHoverProvider(Ue,$t(we),ke,Ue.identifier)},registerEvaluatableExpressionProvider(we,ke){return dt.registerEvaluatableExpressionProvider(Ue,$t(we),ke,Ue.identifier)},registerInlineValuesProvider(we,ke){return dt.registerInlineValuesProvider(Ue,$t(we),ke,Ue.identifier)},registerDocumentHighlightProvider(we,ke){return dt.registerDocumentHighlightProvider(Ue,$t(we),ke)},registerLinkedEditingRangeProvider(we,ke){return dt.registerLinkedEditingRangeProvider(Ue,$t(we),ke)},registerReferenceProvider(we,ke){return dt.registerReferenceProvider(Ue,$t(we),ke)},registerRenameProvider(we,ke){return dt.registerRenameProvider(Ue,$t(we),ke)},registerDocumentSymbolProvider(we,ke,je){return dt.registerDocumentSymbolProvider(Ue,$t(we),ke,je)},registerWorkspaceSymbolProvider(we){return dt.registerWorkspaceSymbolProvider(Ue,we)},registerDocumentFormattingEditProvider(we,ke){return dt.registerDocumentFormattingEditProvider(Ue,$t(we),ke)},registerDocumentRangeFormattingEditProvider(we,ke){return dt.registerDocumentRangeFormattingEditProvider(Ue,$t(we),ke)},registerOnTypeFormattingEditProvider(we,ke,je,...at){return dt.registerOnTypeFormattingEditProvider(Ue,$t(we),ke,[je].concat(at))},registerDocumentSemanticTokensProvider(we,ke,je){return dt.registerDocumentSemanticTokensProvider(Ue,$t(we),ke,je)},registerDocumentRangeSemanticTokensProvider(we,ke,je){return dt.registerDocumentRangeSemanticTokensProvider(Ue,$t(we),ke,je)},registerSignatureHelpProvider(we,ke,je,...at){return typeof je=="object"?dt.registerSignatureHelpProvider(Ue,$t(we),ke,je):dt.registerSignatureHelpProvider(Ue,$t(we),ke,typeof je>"u"?[]:[je,...at])},registerCompletionItemProvider(we,ke,...je){return dt.registerCompletionItemProvider(Ue,$t(we),ke,je)},registerInlineCompletionItemProvider(we,ke,je){return ke.handleDidShowCompletionItem&&(0,ze.$8E)(Ue,"inlineCompletionsAdditions"),ke.handleDidPartiallyAcceptCompletionItem&&(0,ze.$8E)(Ue,"inlineCompletionsAdditions"),je&&(0,ze.$8E)(Ue,"inlineCompletionsAdditions"),dt.registerInlineCompletionsProvider(Ue,$t(we),ke,je)},registerDocumentLinkProvider(we,ke){return dt.registerDocumentLinkProvider(Ue,$t(we),ke)},registerColorProvider(we,ke){return dt.registerColorProvider(Ue,$t(we),ke)},registerFoldingRangeProvider(we,ke){return dt.registerFoldingRangeProvider(Ue,$t(we),ke)},registerSelectionRangeProvider(we,ke){return dt.registerSelectionRangeProvider(Ue,we,ke)},registerCallHierarchyProvider(we,ke){return dt.registerCallHierarchyProvider(Ue,we,ke)},registerTypeHierarchyProvider(we,ke){return dt.registerTypeHierarchyProvider(Ue,we,ke)},setLanguageConfiguration:(we,ke)=>dt.setLanguageConfiguration(Ue,we,ke),getTokenInformationAtPosition(we,ke){return(0,ze.$8E)(Ue,"tokenInformation"),ui.tokenAtPosition(we,ke)},registerInlayHintsProvider(we,ke){return dt.registerInlayHintsProvider(Ue,we,ke)},createLanguageStatusItem(we,ke){return ui.createLanguageStatusItem(Ue,we,ke)},registerDocumentDropEditProvider(we,ke,je){return dt.registerDocumentOnDropEditProvider(Ue,we,ke,(0,ze.$7E)(Ue,"dropMetadata")?je:void 0)}},rn={get activeTextEditor(){return Ot.getActiveTextEditor()},get visibleTextEditors(){return Ot.getVisibleTextEditors()},get activeTerminal(){return bt.activeTerminal},get terminals(){return bt.terminals},async showTextDocument(we,ke,je){const at=await(A.URI.isUri(we)?Promise.resolve(sn.openTextDocument(we)):Promise.resolve(we));return Ot.showTextDocument(at,ke,je)},createTextEditorDecorationType(we){return Ot.createTextEditorDecorationType(Ue,we)},onDidChangeActiveTextEditor(we,ke,je){return Ot.onDidChangeActiveTextEditor(we,ke,je)},onDidChangeVisibleTextEditors(we,ke,je){return Ot.onDidChangeVisibleTextEditors(we,ke,je)},onDidChangeTextEditorSelection(we,ke,je){return Ot.onDidChangeTextEditorSelection(we,ke,je)},onDidChangeTextEditorOptions(we,ke,je){return Ot.onDidChangeTextEditorOptions(we,ke,je)},onDidChangeTextEditorVisibleRanges(we,ke,je){return Ot.onDidChangeTextEditorVisibleRanges(we,ke,je)},onDidChangeTextEditorViewColumn(we,ke,je){return Ot.onDidChangeTextEditorViewColumn(we,ke,je)},onDidCloseTerminal(we,ke,je){return bt.onDidCloseTerminal(we,ke,je)},onDidOpenTerminal(we,ke,je){return bt.onDidOpenTerminal(we,ke,je)},onDidChangeActiveTerminal(we,ke,je){return bt.onDidChangeActiveTerminal(we,ke,je)},onDidChangeTerminalDimensions(we,ke,je){return(0,ze.$8E)(Ue,"terminalDimensions"),bt.onDidChangeTerminalDimensions(we,ke,je)},onDidChangeTerminalState(we,ke,je){return bt.onDidChangeTerminalState(we,ke,je)},onDidWriteTerminalData(we,ke,je){return(0,ze.$8E)(Ue,"terminalDataWriteEvent"),bt.onDidWriteTerminalData(we,ke,je)},onDidExecuteTerminalCommand(we,ke,je){return(0,ze.$8E)(Ue,"terminalExecuteCommandEvent"),bt.onDidExecuteTerminalCommand(we,ke,je)},get state(){return _e.getState(Ue)},onDidChangeWindowState(we,ke,je){return _e.onDidChangeWindowState(we,ke,je)},showInformationMessage(we,...ke){return fi.showMessage(Ue,R.default.Info,we,ke[0],ke.slice(1))},showWarningMessage(we,...ke){return fi.showMessage(Ue,R.default.Warning,we,ke[0],ke.slice(1))},showErrorMessage(we,...ke){return fi.showMessage(Ue,R.default.Error,we,ke[0],ke.slice(1))},showQuickPick(we,ke,je){return ni.showQuickPick(Ue,we,ke,je)},showWorkspaceFolderPick(we){return ni.showWorkspaceFolderPick(we)},showInputBox(we,ke){return ni.showInput(we,ke)},showOpenDialog(we){return Ui.showOpenDialog(Ue,we)},showSaveDialog(we){return Ui.showSaveDialog(we)},createStatusBarItem(we,ke,je){let at,Et,Lt;return typeof we=="string"?(at=we,Et=ke,Lt=je):(Et=we,Lt=ke),ji.createStatusBarEntry(Ue,at,Et,Lt)},setStatusBarMessage(we,ke){return ji.setStatusBarMessage(we,ke)},withScmProgress(we){return qe.report("window.withScmProgress",Ue,"Use 'withProgress' instead."),Ri.withProgress(Ue,{location:B.ProgressLocation.SourceControl},(ke,je)=>we({report(at){}}))},withProgress(we,ke){return Ri.withProgress(Ue,we,ke)},createOutputChannel(we,ke){return $i.createOutputChannel(we,ke,Ue)},createWebviewPanel(we,ke,je,at){return hi.createWebviewPanel(Ue,we,ke,je,at)},createWebviewTextEditorInset(we,ke,je,at){return(0,ze.$8E)(Ue,"editorInsets"),ai.createWebviewEditorInset(we,ke,je,at,Ue)},createTerminal(we,ke,je){return typeof we=="object"?"pty"in we?bt.createExtensionTerminal(we):bt.createTerminalFromOptions(we):bt.createTerminal(we,ke,je)},registerTerminalLinkProvider(we){return bt.registerLinkProvider(we)},registerTerminalProfileProvider(we,ke){return bt.registerProfileProvider(Ue,we,ke)},registerTerminalQuickFixProvider(we,ke){return(0,ze.$8E)(Ue,"terminalQuickFixProvider"),bt.registerTerminalQuickFixProvider(we,Ue.identifier.value,ke)},registerTreeDataProvider(we,ke){return Hi.registerTreeDataProvider(we,ke,Ue)},createTreeView(we,ke){return Hi.createTreeView(we,ke,Ue)},registerWebviewPanelSerializer:(we,ke)=>hi.registerWebviewPanelSerializer(Ue,we,ke),registerCustomEditorProvider:(we,ke,je={})=>Fi.registerCustomEditorProvider(Ue,we,ke,je),registerFileDecorationProvider(we){return Mt.registerFileDecorationProvider(we,Ue)},registerUriHandler(we){return Si.registerUriHandler(Ue,we)},createQuickPick(){return ni.createQuickPick(Ue)},createInputBox(){return ni.createInputBox(Ue)},get activeColorTheme(){return pi.activeColorTheme},onDidChangeActiveColorTheme(we,ke,je){return pi.onDidChangeActiveColorTheme(we,ke,je)},registerWebviewViewProvider(we,ke,je){return Ki.registerWebviewViewProvider(Ue,we,ke,je?.webviewOptions)},get activeNotebookEditor(){return kt.activeNotebookEditor},onDidChangeActiveNotebookEditor(we,ke,je){return kt.onDidChangeActiveNotebookEditor(we,ke,je)},get visibleNotebookEditors(){return kt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return kt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(we,ke,je){return Zt.onDidChangeNotebookEditorSelection(we,ke,je)},onDidChangeNotebookEditorVisibleRanges(we,ke,je){return Zt.onDidChangeNotebookEditorVisibleRanges(we,ke,je)},showNotebookDocument(we,ke){return kt.showNotebookDocument(we,ke)},registerExternalUriOpener(we,ke,je){return(0,ze.$8E)(Ue,"externalUriOpener"),Ji.registerExternalUriOpener(Ue.identifier,we,ke,je)},registerProfileContentHandler(we,ke){return(0,ze.$8E)(Ue,"profileContentHandlers"),Gi.registrProfileContentHandler(Ue,we,ke)},registerQuickDiffProvider(we,ke,je,at){return(0,ze.$8E)(Ue,"quickDiffProvider"),Pi.registerQuickDiffProvider($t(we),ke,je,at)},get tabGroups(){return ot.tabGroups},registerShareProvider(we,ke){return(0,ze.$8E)(Ue,"shareProvider"),Ai.registerShareProvider($t(we),ke)}},sn={get rootPath(){return qe.report("workspace.rootPath",Ue,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),gt.getPath()},set rootPath(we){throw new M.$7("rootPath")},getWorkspaceFolder(we){return gt.getWorkspaceFolder(we)},get workspaceFolders(){return gt.getWorkspaceFolders()},get name(){return gt.name},set name(we){throw new M.$7("name")},get workspaceFile(){return gt.workspaceFile},set workspaceFile(we){throw new M.$7("workspaceFile")},updateWorkspaceFolders:(we,ke,...je)=>gt.updateWorkspaceFolders(Ue,we,ke||0,...je),onDidChangeWorkspaceFolders:function(we,ke,je){return gt.onDidChangeWorkspace(we,ke,je)},asRelativePath:(we,ke)=>gt.getRelativePath(we,ke),findFiles:(we,ke,je,at)=>gt.findFiles(we,ke,je,Ue.identifier,at),findTextInFiles:(we,ke,je,at)=>{(0,ze.$8E)(Ue,"findTextInFiles");let Et,Lt;return typeof ke=="object"?(Et=ke,Lt=je):(Et={},Lt=ke,at=je),gt.findTextInFiles(we,Et||{},Lt,Ue.identifier,at)},save:we=>((0,ze.$8E)(Ue,"saveEditor"),gt.save(we)),saveAs:we=>((0,ze.$8E)(Ue,"saveEditor"),gt.saveAs(we)),saveAll:we=>gt.saveAll(we),applyEdit(we,ke){return xi.applyWorkspaceEdit(we,Ue,ke)},createFileSystemWatcher:(we,ke,je,at)=>_t.createFileSystemWatcher(gt,Ue,we,ke,je,at),get textDocuments(){return Tt.getAllDocumentData().map(we=>we.document)},set textDocuments(we){throw new M.$7("textDocuments")},openTextDocument(we){let ke;const je=we;if(typeof we=="string")ke=Promise.resolve(A.URI.file(we));else if(A.URI.isUri(we))ke=Promise.resolve(we);else if(!je||typeof je=="object")ke=Tt.createDocumentData(je);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ke.then(at=>Tt.ensureDocumentData(at).then(Et=>Et.document))},onDidOpenTextDocument:(we,ke,je)=>Tt.onDidAddDocument(we,ke,je),onDidCloseTextDocument:(we,ke,je)=>Tt.onDidRemoveDocument(we,ke,je),onDidChangeTextDocument:(we,ke,je)=>Tt.onDidChangeDocument(we,ke,je),onDidSaveTextDocument:(we,ke,je)=>Tt.onDidSaveDocument(we,ke,je),onWillSaveTextDocument:(we,ke,je)=>Di.getOnWillSaveTextDocumentEvent(Ue)(we,ke,je),get notebookDocuments(){return kt.notebookDocuments.map(we=>we.apiNotebook)},async openNotebookDocument(we,ke){let je;if(A.URI.isUri(we))je=we,await kt.openNotebookDocument(we);else if(typeof we=="string")je=A.URI.revive(await kt.createNotebookDocument({viewType:we,content:ke}));else throw new Error("Invalid arguments");return kt.getNotebookDocument(je).apiNotebook},onDidSaveNotebookDocument(we,ke,je){return bi.onDidSaveNotebookDocument(we,ke,je)},onDidChangeNotebookDocument(we,ke,je){return bi.onDidChangeNotebookDocument(we,ke,je)},onWillSaveNotebookDocument(we,ke,je){return Ci.getOnWillSaveNotebookDocumentEvent(Ue)(we,ke,je)},get onDidOpenNotebookDocument(){return kt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return kt.onDidCloseNotebookDocument},registerNotebookSerializer(we,ke,je,at){return kt.registerNotebookSerializer(Ue,we,ke,je,(0,ze.$7E)(Ue,"notebookLiveShare")?at:void 0)},onDidChangeConfiguration:(we,ke,je)=>_i.onDidChangeConfiguration(we,ke,je),getConfiguration(we,ke){return ke=arguments.length===1?void 0:ke,_i.getConfiguration(we,ke,Ue)},registerTextDocumentContentProvider(we,ke){return hn.registerTextDocumentContentProvider(we,ke)},registerTaskProvider:(we,ke)=>(qe.report("window.registerTaskProvider",Ue,"Use the corresponding function on the 'tasks' namespace instead"),Wt.registerTaskProvider(Ue,we,ke)),registerFileSystemProvider(we,ke,je){return(0,He.$Nc)(Ii.registerFileSystemProvider(Ue,we,ke,je),Rt.addFileSystemProvider(we,ke,je))},get fs(){return Rt.value},registerFileSearchProvider:(we,ke)=>((0,ze.$8E)(Ue,"fileSearchProvider"),mi.registerFileSearchProvider(we,ke)),registerTextSearchProvider:(we,ke)=>((0,ze.$8E)(Ue,"textSearchProvider"),mi.registerTextSearchProvider(we,ke)),registerRemoteAuthorityResolver:(we,ke)=>((0,ze.$8E)(Ue,"resolvers"),Pt.registerRemoteAuthorityResolver(we,ke)),registerResourceLabelFormatter:we=>((0,ze.$8E)(Ue,"resolvers"),Mi.$registerResourceLabelFormatter(we)),getRemoteExecServer:we=>((0,ze.$8E)(Ue,"resolvers"),Pt.getRemoteExecServer(we)),onDidCreateFiles:(we,ke,je)=>_t.onDidCreateFile(we,ke,je),onDidDeleteFiles:(we,ke,je)=>_t.onDidDeleteFile(we,ke,je),onDidRenameFiles:(we,ke,je)=>_t.onDidRenameFile(we,ke,je),onWillCreateFiles:(we,ke,je)=>_t.getOnWillCreateFileEvent(Ue)(we,ke,je),onWillDeleteFiles:(we,ke,je)=>_t.getOnWillDeleteFileEvent(Ue)(we,ke,je),onWillRenameFiles:(we,ke,je)=>_t.getOnWillRenameFileEvent(Ue)(we,ke,je),openTunnel:we=>((0,ze.$8E)(Ue,"tunnels"),Oe.openTunnel(Ue,we).then(ke=>{if(!ke)throw new Error("cannot open tunnel");return ke})),get tunnels(){return(0,ze.$8E)(Ue,"tunnels"),Oe.getTunnels()},onDidChangeTunnels:(we,ke,je)=>((0,ze.$8E)(Ue,"tunnels"),Oe.onDidChangeTunnels(we,ke,je)),registerPortAttributesProvider:(we,ke)=>((0,ze.$8E)(Ue,"portsAttributes"),Oe.registerPortsAttributesProvider(we,ke)),registerTunnelProvider:(we,ke)=>((0,ze.$8E)(Ue,"tunnelFactory"),Oe.registerTunnelProvider(we,ke)),registerTimelineProvider:(we,ke)=>((0,ze.$8E)(Ue,"timeline"),Ti.registerTimelineProvider(we,ke,Ue.identifier,ut.converter)),get isTrusted(){return gt.trusted},requestWorkspaceTrust:we=>((0,ze.$8E)(Ue,"workspaceTrust"),gt.requestWorkspaceTrust(we)),onDidGrantWorkspaceTrust:(we,ke,je)=>gt.onDidGrantWorkspaceTrust(we,ke,je),registerEditSessionIdentityProvider:(we,ke)=>((0,ze.$8E)(Ue,"editSessionIdentityProvider"),gt.registerEditSessionIdentityProvider(we,ke)),onWillCreateEditSessionIdentity:(we,ke,je)=>((0,ze.$8E)(Ue,"editSessionIdentityProvider"),gt.getOnWillCreateEditSessionIdentityEvent(Ue)(we,ke,je)),registerCanonicalUriProvider:(we,ke)=>((0,ze.$8E)(Ue,"canonicalUriProvider"),gt.registerCanonicalUriProvider(we,ke)),getCanonicalUri:(we,ke,je)=>((0,ze.$8E)(Ue,"canonicalUriProvider"),gt.provideCanonicalUri(we,ke,je))},mn={get inputBox(){return qe.report("scm.inputBox",Ue,"Use 'SourceControl.inputBox' instead"),wi.getLastInputBox(Ue)},createSourceControl(we,ke,je){return wi.createSourceControl(Ue,we,ke,je)}},Bi={createCommentController(we,ke){return Li.createCommentController(Ue,we,ke)}},on={get activeDebugSession(){return Dt.activeDebugSession},get activeDebugConsole(){return Dt.activeDebugConsole},get breakpoints(){return Dt.breakpoints},get stackFrameFocus(){return Dt.stackFrameFocus},onDidStartDebugSession(we,ke,je){return Dt.onDidStartDebugSession(we,ke,je)},onDidTerminateDebugSession(we,ke,je){return Dt.onDidTerminateDebugSession(we,ke,je)},onDidChangeActiveDebugSession(we,ke,je){return Dt.onDidChangeActiveDebugSession(we,ke,je)},onDidReceiveDebugSessionCustomEvent(we,ke,je){return Dt.onDidReceiveDebugSessionCustomEvent(we,ke,je)},onDidChangeBreakpoints(we,ke,je){return Dt.onDidChangeBreakpoints(we,ke,je)},onDidChangeStackFrameFocus(we,ke,je){return(0,ze.$8E)(Ue,"debugFocus"),Dt.onDidChangeStackFrameFocus(we,ke,je)},registerDebugConfigurationProvider(we,ke,je){return Dt.registerDebugConfigurationProvider(we,ke,je||Ze.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(we,ke){return Dt.registerDebugAdapterDescriptorFactory(Ue,we,ke)},registerDebugAdapterTrackerFactory(we,ke){return Dt.registerDebugAdapterTrackerFactory(we,ke)},startDebugging(we,ke,je){return!je||typeof je=="object"&&"configuration"in je?Dt.startDebugging(we,ke,{parentSession:je}):Dt.startDebugging(we,ke,je||{})},stopDebugging(we){return Dt.stopDebugging(we)},addBreakpoints(we){return Dt.addBreakpoints(we)},removeBreakpoints(we){return Dt.removeBreakpoints(we)},asDebugSourceUri(we,ke){return Dt.asDebugSourceUri(we,ke)}},an={registerTaskProvider:(we,ke)=>Wt.registerTaskProvider(Ue,we,ke),fetchTasks:we=>Wt.fetchTasks(we),executeTask:we=>Wt.executeTask(Ue,we),get taskExecutions(){return Wt.taskExecutions},onDidStartTask:(we,ke,je)=>Wt.onDidStartTask(we,ke,je),onDidEndTask:(we,ke,je)=>Wt.onDidEndTask(we,ke,je),onDidStartTaskProcess:(we,ke,je)=>Wt.onDidStartTaskProcess(we,ke,je),onDidEndTaskProcess:(we,ke,je)=>Wt.onDidEndTaskProcess(we,ke,je)},cn={createNotebookController(we,ke,je,at,Et){return oi.createNotebookController(Ue,we,ke,je,at,(0,ze.$7E)(Ue,"notebookMessaging")?Et:void 0)},registerNotebookCellStatusBarItemProvider:(we,ke)=>kt.registerNotebookCellStatusBarItemProvider(Ue,we,ke),createRendererMessaging(we){return qi.createRendererMessaging(Ue,we)},createNotebookControllerDetectionTask(we){return(0,ze.$8E)(Ue,"notebookKernelSource"),oi.createNotebookControllerDetectionTask(Ue,we)},registerKernelSourceActionProvider(we,ke){return(0,ze.$8E)(Ue,"notebookKernelSource"),oi.registerKernelSourceActionProvider(Ue,we,ke)},onDidChangeNotebookCellExecutionState(we,ke,je){return(0,ze.$8E)(Ue,"notebookCellExecutionState"),oi.onDidChangeNotebookCellExecutionState(we,ke,je)}},$n={t(...we){if(typeof we[0]=="string"){const ke=we.shift(),je=!we||typeof we[0]!="object"?we:we[0];return ii.getMessage(Ue.identifier.value,{message:ke,args:je})}return ii.getMessage(Ue.identifier.value,we[0])},get bundle(){return ii.getBundle(Ue.identifier.value)},get uri(){return ii.getBundleUri(Ue.identifier.value)}},bn={_version:1,registerInteractiveEditorSessionProvider(we,ke){return(0,ze.$8E)(Ue,"interactive"),Qi.registerProvider(Ue,we,ke={label:ke?.label??Ue.displayName??Ue.name})},registerInteractiveSessionProvider(we,ke){return(0,ze.$8E)(Ue,"interactive"),di.registerChatProvider(Ue,we,ke)},addInteractiveRequest(we){return(0,ze.$8E)(Ue,"interactive"),di.addChatRequest(we)},sendInteractiveRequestToProvider(we,ke){return(0,ze.$8E)(Ue,"interactive"),di.sendInteractiveRequestToProvider(we,ke)},get onDidPerformUserAction(){return(0,ze.$8E)(Ue,"interactiveUserActions"),di.onDidPerformUserAction},transferChatSession(we,ke){return(0,ze.$8E)(Ue,"interactive"),di.transferChatSession(we,ke)}},un={getRelatedInformation(we,ke){return(0,ze.$8E)(Ue,"aiRelatedInformation"),Xi.getRelatedInformation(Ue,we,ke)},registerRelatedInformationProvider(we,ke){return(0,ze.$8E)(Ue,"aiRelatedInformation"),Xi.registerRelatedInformationProvider(Ue,we,ke)},registerEmbeddingVectorProvider(we,ke){return(0,ze.$8E)(Ue,"aiRelatedInformation"),Yi.registerEmbeddingVectorProvider(Ue,we,ke)}},ln={registerChatResponseProvider(we,ke,je){return(0,ze.$8E)(Ue,"chatProvider"),yi.registerProvider(Ue.identifier,we,ke,je)},registerSlashCommand(we,ke,je){return(0,ze.$8E)(Ue,"chatSlashCommands"),dn.registerCommand(Ue.identifier,we,ke,je??{description:""})},requestChatAccess(we){return(0,ze.$8E)(Ue,"chatRequestAccess"),yi.requestChatResponseProvider(Ue.identifier,we)},registerVariable(we,ke,je){return(0,ze.$8E)(Ue,"chatVariables"),Ni.registerVariableResolver(Ue,we,ke,je)},registerMappedEditsProvider(we,ke){return(0,ze.$8E)(Ue,"mappedEditsProvider"),dt.registerMappedEditsProvider(Ue,we,ke)},registerAgent(we,ke,je){return(0,ze.$8E)(Ue,"chatAgents"),Oi.registerAgent(Ue.identifier,we,ke,je)}};return{version:mt.version,ai:un,authentication:ki,commands:en,comments:Bi,chat:ln,debug:on,env:zi,extensions:gn,interactive:bn,l10n:$n,languages:nn,notebooks:cn,scm:mn,tasks:an,tests:tn,window:rn,workspace:sn,Breakpoint:B.$9K,TerminalOutputAnchor:B.TerminalOutputAnchor,ChatMessage:B.$YL,ChatMessageRole:B.ChatMessageRole,ChatVariableLevel:B.ChatVariableLevel,CallHierarchyIncomingCall:B.$vK,CallHierarchyItem:B.$uK,CallHierarchyOutgoingCall:B.$wK,CancellationError:M.$3,CancellationTokenSource:y.$Vd,CandidatePortSource:v.CandidatePortSource,CodeAction:B.$rK,CodeActionKind:B.$sK,CodeActionTriggerKind:B.CodeActionTriggerKind,CodeLens:B.$xK,Color:B.$KK,ColorInformation:B.$LK,ColorPresentation:B.$MK,ColorThemeKind:B.ColorThemeKind,CommentMode:B.CommentMode,CommentState:B.CommentState,CommentThreadCollapsibleState:B.CommentThreadCollapsibleState,CommentThreadState:B.CommentThreadState,CompletionItem:B.$EK,CompletionItemKind:B.CompletionItemKind,CompletionItemTag:B.CompletionItemTag,CompletionList:B.$FK,CompletionTriggerKind:B.CompletionTriggerKind,ConfigurationTarget:B.ConfigurationTarget,CustomExecution:B.$UK,DebugAdapterExecutable:B.$aL,DebugAdapterInlineImplementation:B.$dL,DebugAdapterNamedPipeServer:B.$cL,DebugAdapterServer:B.$bL,DebugConfigurationProviderTriggerKind:Ze.DebugConfigurationProviderTriggerKind,DebugConsoleMode:B.DebugConsoleMode,DecorationRangeBehavior:B.DecorationRangeBehavior,Diagnostic:B.$mK,DiagnosticRelatedInformation:B.$lK,DiagnosticSeverity:B.DiagnosticSeverity,DiagnosticTag:B.DiagnosticTag,Disposable:B.$$J,DocumentHighlight:B.$oK,DocumentHighlightKind:B.DocumentHighlightKind,DocumentLink:B.$JK,DocumentSymbol:B.$qK,EndOfLine:B.EndOfLine,EnvironmentVariableMutatorType:B.EnvironmentVariableMutatorType,EvaluatableExpression:B.$gL,InlineValueText:B.$hL,InlineValueVariableLookup:B.$iL,InlineValueEvaluatableExpression:B.$jL,InlineCompletionTriggerKind:B.InlineCompletionTriggerKind,EventEmitter:l.$Ld,ExtensionKind:B.ExtensionKind,ExtensionMode:B.ExtensionMode,ExternalUriOpenerPriority:B.ExternalUriOpenerPriority,FileChangeType:B.FileChangeType,FileDecoration:B.$tL,FileDecoration2:B.$tL,FileSystemError:B.$lL,FileType:C.FileType,FilePermission:C.FilePermission,FoldingRange:B.$mL,FoldingRangeKind:B.FoldingRangeKind,FunctionBreakpoint:B.$$K,InlineCompletionItem:B.$GK,InlineCompletionList:B.$HK,Hover:B.$nK,IndentAction:$.IndentAction,Location:B.$kK,MarkdownString:B.$yK,OverviewRulerLane:k.OverviewRulerLane,ParameterInformation:B.$zK,PortAutoForwardAction:B.PortAutoForwardAction,Position:B.$_J,ProcessExecution:B.$SK,ProgressLocation:B.ProgressLocation,QuickInputButtons:B.$sL,Range:B.$aK,RelativePattern:B.$7K,Selection:B.$bK,SelectionRange:B.$tK,SemanticTokens:B.$pL,SemanticTokensBuilder:B.$oL,SemanticTokensEdit:B.$qL,SemanticTokensEdits:B.$rL,SemanticTokensLegend:B.$nL,ShellExecution:B.$TK,ShellQuoting:B.ShellQuoting,SignatureHelp:B.$BK,SignatureHelpTriggerKind:B.SignatureHelpTriggerKind,SignatureInformation:B.$AK,SnippetString:B.$jK,SourceBreakpoint:B.$0K,StandardTokenType:B.StandardTokenType,StatusBarAlignment:B.StatusBarAlignment,SymbolInformation:B.$pK,SymbolKind:B.SymbolKind,SymbolTag:B.SymbolTag,Task:B.$VK,TaskGroup:B.$RK,TaskPanelKind:B.TaskPanelKind,TaskRevealKind:B.TaskRevealKind,TaskScope:B.TaskScope,TerminalLink:B.$NK,TerminalQuickFixExecuteTerminalCommand:B.$PK,TerminalQuickFixOpener:B.$OK,TerminalLocation:B.TerminalLocation,TerminalProfile:B.$QK,TerminalExitReason:B.TerminalExitReason,TextDocumentSaveReason:B.TextDocumentSaveReason,TextEdit:B.$fK,SnippetTextEdit:B.$hK,TextEditorCursorStyle:m.TextEditorCursorStyle,TextEditorLineNumbersStyle:B.TextEditorLineNumbersStyle,TextEditorRevealType:B.TextEditorRevealType,TextEditorSelectionChangeKind:B.TextEditorSelectionChangeKind,SyntaxTokenType:B.SyntaxTokenType,TextDocumentChangeReason:B.TextDocumentChangeReason,ThemeColor:B.$6K,ThemeIcon:B.$5K,TreeItem:B.$WK,TreeItemCheckboxState:B.TreeItemCheckboxState,TreeItemCollapsibleState:B.TreeItemCollapsibleState,TypeHierarchyItem:B.$OL,UIKind:S.UIKind,Uri:A.URI,ViewColumn:B.ViewColumn,WorkspaceEdit:B.$iK,DocumentDropEdit:B.$3K,DocumentPasteEdit:B.$4K,InlayHint:B.$DK,InlayHintLabelPart:B.$CK,InlayHintKind:B.InlayHintKind,RemoteAuthorityResolverError:B.$eK,ResolvedAuthority:B.$cK,ManagedResolvedAuthority:B.$dK,SourceControlInputBoxValidationType:B.SourceControlInputBoxValidationType,ExtensionRuntime:B.ExtensionRuntime,TimelineItem:B.$DL,NotebookRange:B.$vL,NotebookCellKind:B.NotebookCellKind,NotebookCellExecutionState:B.NotebookCellExecutionState,NotebookCellData:B.$wL,NotebookData:B.$xL,NotebookRendererScript:B.$BL,NotebookCellStatusBarAlignment:B.NotebookCellStatusBarAlignment,NotebookEditorRevealType:B.NotebookEditorRevealType,NotebookCellOutput:B.$zL,NotebookCellOutputItem:B.$yL,NotebookCellStatusBarItem:B.$AL,NotebookControllerAffinity:B.NotebookControllerAffinity,NotebookControllerAffinity2:B.NotebookControllerAffinity2,NotebookEdit:B.$gK,NotebookKernelSourceAction:B.$CL,PortAttributes:B.$FL,LinkedEditingRanges:B.$EL,TestResultState:B.TestResultState,TestRunRequest:B.$GL,TestMessage:B.$HL,TestMessage2:B.$HL,TestTag:B.$IL,TestRunProfileKind:B.TestRunProfileKind,TextSearchCompleteMessageType:Ae.TextSearchCompleteMessageType,DataTransfer:B.$2K,DataTransferItem:B.$XK,CoveredCount:B.$JL,FileCoverage:B.$KL,StatementCoverage:B.$LL,BranchCoverage:B.$ML,FunctionCoverage:B.$NL,WorkspaceTrustState:B.WorkspaceTrustState,LanguageStatusSeverity:B.LanguageStatusSeverity,QuickPickItemKind:B.QuickPickItemKind,InputBoxValidationSeverity:B.InputBoxValidationSeverity,TabInputText:B.$PL,TabInputTextDiff:B.$QL,TabInputTextMerge:B.$RL,TabInputCustom:B.$SL,TabInputNotebook:B.$UL,TabInputNotebookDiff:B.$VL,TabInputWebview:B.$TL,TabInputTerminal:B.$WL,TabInputInteractiveWindow:B.$XL,TelemetryTrustedValue:ae.$bo,LogLevel:Z.LogLevel,EditSessionIdentityMatch:lt.EditSessionIdentityMatch,InteractiveSessionVoteDirection:B.InteractiveSessionVoteDirection,InteractiveSessionCopyKind:B.InteractiveSessionCopyKind,InteractiveEditorResponseFeedbackKind:B.InteractiveEditorResponseFeedbackKind,StackFrameFocus:B.$eL,ThreadFocus:B.$fL,RelatedInformationType:B.RelatedInformationType}}}e.$Ddc=Jt}),define(Se[355],De([1,0,104,153,37,150,40,33,70,44,94,95,96,116,73,90,152,72,54,115,89,71,151,14,55,113,114]),function(ne,e,y,M,l,R,A,m,k,$,P,C,v,S,D,E,s,c,u,o,g,d,t,n,r,i,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,y.$or)(i.$dcc,i.$ccc,1),(0,y.$or)(n.$7i,t.$Edc,1),(0,y.$or)(E.$Cbc,E.$Dbc,1),(0,y.$or)(m.$tM,m.$sM,0),(0,y.$or)(A.$Pbc,A.$Nbc,0),(0,y.$or)(c.$5bc,c.$4bc,0),(0,y.$or)(C.$Scc,C.$Wcc,0),(0,y.$or)(R.$Kcc,R.$Jcc,0),(0,y.$or)(k.$iM,k.$hM,0),(0,y.$or)(a.$ecc,a.$fcc,0),(0,y.$or)(u.$zbc,u.$ybc,0),(0,y.$or)(M.$qcc,M.$pcc,1),(0,y.$or)(v.$3cc,v.$4cc,0),(0,y.$or)(S.$1bc,S.$Zbc,0),(0,y.$or)(P.$Ncc,P.$Mcc,0),(0,y.$or)($.$8bc,$.$$bc,0),(0,y.$or)(D.$ksb,D.$lsb,0),(0,y.$or)(s.$Gcc,s.$Fcc,0),(0,y.$or)(l.$Mbc,l.$Lbc,0),(0,y.$or)(o.$acc,o.$_bc,0),(0,y.$or)(g.$rM,g.$oM,0),(0,y.$or)(d.$Occ,d.$Pcc,0),(0,y.$or)(r.$Qcc,r.$Rcc,0)}),define(Se[117],De([1,0,19,14,36,93]),function(ne,e,y,M,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wdc=e.$Vdc=e.$Udc=void 0;function A(C){return C.startsWith("**")||C.startsWith("/")?C:`/${C}`}e.$Udc=A;function m(C,v,S,D){const E=(0,y.$Zb)(S,k),s=new l.$FI(v,E,D),c=s.preview.matches;return{ranges:(0,y.$Zb)(E,$),uri:C,preview:{text:s.preview.text,matches:(0,y.$Zb)(c,$)}}}e.$Vdc=m;function k(C){return new l.$GI(C.start.line,C.start.character,C.end.line,C.end.character)}function $(C){return new R.$uI(C.startLineNumber,C.startColumn,C.endLineNumber,C.endColumn)}let P=class{constructor(v,S){this.a=v,this.b=S}appendLine(v){this.b.debug(`${this.a}#search`,v)}};e.$Wdc=P,e.$Wdc=P=Ke([We(1,M.$6i)],P)}),define(Se[356],De([1,0,47,15,77,32,10,16,117,357]),function(ne,e,y,M,l,R,A,m,k,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zdc=e.$Ydc=e.$Xdc=void 0;const P=$.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function C(o,g,d,t){const n=v(o,g,d,t),r=g.folder.fsPath;return{cmd:y.spawn(P,n.args,{cwd:r}),rgDiskPath:P,siblingClauses:n.siblingClauses,rgArgs:n,cwd:r}}e.$Xdc=C;function v(o,g,d,t){const n=["--files","--hidden","--case-sensitive","--no-require-git"];D([g],d,!1).forEach(i=>{const a=(0,k.$Udc)(i);if(n.push("-g",a),A.$e){const h=(0,l.$kl)(a);h!==a&&n.push("-g",h)}});const r=S([g],t,void 0,!1);return r.globArgs.forEach(i=>{const a=`!${(0,k.$Udc)(i)}`;if(n.push("-g",a),A.$e){const h=(0,l.$kl)(a);h!==a&&n.push("-g",h)}}),g.disregardIgnoreFiles!==!1?n.push("--no-ignore"):g.disregardParentIgnoreFiles!==!1&&n.push("--no-ignore-parent"),g.ignoreSymlinks||n.push("--follow"),o.exists&&n.push("--quiet"),n.push("--no-config"),g.disregardGlobalIgnoreFiles&&n.push("--no-ignore-global"),{args:n,siblingClauses:r.siblingClauses}}function S(o,g,d,t=!0){const n=[];let r={};return o.forEach(i=>{const a=Object.assign({},i.excludePattern||{},g||{}),h=E(a,t?i.folder.fsPath:void 0,d);n.push(...h.globArgs),h.siblingClauses&&(r=Object.assign(r,h.siblingClauses))}),{globArgs:n,siblingClauses:r}}function D(o,g,d=!0){const t=[];return o.forEach(n=>{const r=Object.assign({},g||{},n.includePattern||{}),i=E(r,d?n.folder.fsPath:void 0);t.push(...i.globArgs)}),t}function E(o,g,d){const t=[],n={};return Object.keys(o).forEach(r=>{if(d&&d.has(r)||!r)return;const i=o[r];r=c(g?s(g,r):r),r.startsWith("\\\\")?r="\\\\"+r.substr(2).replace(/\\/g,"/"):r=r.replace(/\\/g,"/"),typeof i=="boolean"&&i?(r.startsWith("\\\\")&&(r+="**"),t.push(u(r))):i&&i.when&&(n[r]=i)}),{globArgs:t,siblingClauses:n}}function s(o,g){return M.$gc(g)?g:M.$hc(o,g)}e.$Ydc=s;function c(o){return o=m.$Ie(o,"\\"),m.$Ie(o,"/")}function u(o){return R.$Rf(o).toLowerCase()==="c:/"?o.replace(/^c:[/\\]/i,"/"):o}e.$Zdc=u}),define(Se[358],De([1,0,47,52,15,359,19,48,34,77,32,10,38,16,18,29,36,356,124]),function(ne,e,y,M,l,R,A,m,k,$,P,C,v,S,D,E,s,c,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2dc=e.$1dc=void 0;const o=new Set;process.on("exit",()=>{o.forEach(r=>r())});class g{constructor(i){this.c=null,this.h=null,this.l=!1,this.m=null,this.r=null,this.s=0,this.a=i,this.b=i.filePattern||"",this.d=i.includePattern&&k.$sj(i.includePattern),this.f=i.maxResults||null,this.g=!!i.exists,this.v=Object.create(null),this.k=0,this.j=!1,this.o=0,this.p=0,this.q=[],this.b&&(this.c=(0,u.$qq)(this.b).normalizedLowercase),this.u=i.excludePattern&&k.$sj(i.excludePattern),this.t=new Map,i.folderQueries.forEach(a=>{const h=Object.assign({},a.excludePattern||{},this.a.excludePattern||{}),p=a.folder.fsPath;i.folderQueries.map(I=>I.folder.fsPath).filter(I=>I!==p).forEach(I=>{(0,P.$Vf)(I,p)&&(h[l.$jc(p,I)]=!0)}),this.t.set(p,new t(h,p))})}cancel(){this.l=!0,o.forEach(i=>i())}walk(i,a,h,p,I){if(this.m=v.$Hd.create(!1),this.l)return I(null,this.j);a.forEach(w=>{const f=l.$lc(w.fsPath);this.u&&this.u(w.fsPath,f)||this.J(h,{relativePath:w.fsPath,searchPath:void 0})}),this.r=v.$Hd.create(!1),this.w(i,(w,f)=>{this.x(this.y,this,w,h,p,b=>{if(b){const L=(0,m.$wi)(b);console.error(L),this.q.push(L),f(b,void 0)}else f(null,void 0)})},(w,f)=>{this.m.stop();const b=w?A.$Fb(w)[0]:null;I(b,this.j)})}w(i,a,h){const p=new Array(i.length),I=new Array(i.length);let w=!1,f=0;if(i.length===0)return h(null,[]);i.forEach((b,L)=>{a(b,(O,T)=>{if(O?(w=!0,p[L]=null,I[L]=O):(p[L]=T,I[L]=null),++f===i.length)return h(w?I:null,p)})})}x(i,a,...h){try{i.apply(a,h)}catch(p){h[h.length-1](p)}}y(i,a,h,p){const I=i.folder.fsPath,w=C.$e,f=()=>F&&F.kill();o.add(f);let b=z=>{o.delete(f),b=()=>{},p(z)},L="";const O=this.D(),T=(0,c.$Xdc)(this.a,i,this.a.includePattern,this.t.get(i.folder.fsPath).expression),F=T.cmd,U=!Object.keys(T.siblingClauses).length,N=T.rgArgs.args.map(z=>z.match(/^-/)?z:`'${z}'`).join(" ");let j=`${T.rgDiskPath} ${N}
 - cwd: ${T.cwd}`;T.rgArgs.siblingClauses&&(j+=`
 - Sibling clauses: ${JSON.stringify(T.rgArgs.siblingClauses)}`),h({message:j}),this.s=0,this.z(F,"utf8",h,(z,B,ae)=>{if(z){b(z);return}if(this.j){b();return}const Q=(L+(w?$.$jl(B||""):B)).split(`
`);if(ae){const H=Q.length;Q[H-1]=Q[H-1].trim(),Q[H-1]||Q.pop()}else L=Q.pop()||"";if(Q.length&&Q[0].indexOf(`
`)!==-1){b(new Error("Splitting up files failed"));return}if(this.s+=Q.length,U){for(const H of Q)if(this.J(a,{base:I,relativePath:H,searchPath:this.N(i,H)}),this.j){f();break}(ae||this.j)&&b();return}this.G(i,O,I,Q,a),ae&&(this.H(O,I,a),b())})}spawnFindCmd(i){const a=this.t.get(i.folder.fsPath),h=a.getBasenameTerms(),p=a.getPathTerms(),I=["-L","."];if(h.length||p.length){I.push("-not","(","(");for(const w of h)I.push("-name",w),I.push("-o");for(const w of p)I.push("-path",w),I.push("-o");I.pop(),I.push(")","-prune",")")}return I.push("-type","f"),y.spawn("find",I,{cwd:i.folder.fsPath})}readStdout(i,a,h){let p="";this.z(i,a,()=>{},(I,w,f)=>{if(I){h(I);return}p+=w,f&&h(null,p)})}z(i,a,h,p){let I=(b,L,O)=>{(b||O)&&(I=()=>{},this.r?.stop()),p(b,L,O)},w=!1;i.stdout?(this.A(i.stdout,a,I),i.stdout.once("data",()=>w=!0)):h({message:"stdout is null"});let f;i.stderr?f=this.B(i.stderr):h({message:"stderr is null"}),i.on("error",b=>{I(b)}),i.on("close",b=>{let L;!w&&(L=this.C(f,a))&&n(L)?I(new Error(`command failed with error code ${b}: ${this.C(f,a)}`)):(this.g&&b===0&&(this.j=!0),I(null,"",!0))})}A(i,a,h){const p=new R.StringDecoder(a);return i.on("data",I=>{h(null,p.write(I))}),p}B(i){const a=[];return i.on("data",h=>{a.push(h)}),a}C(i,a){const h=new R.StringDecoder(a);return i.map(p=>h.write(p)).join("")}D(){const i={rootEntries:[],pathToEntries:Object.create(null)};return i.pathToEntries["."]=i.rootEntries,i}G(i,{pathToEntries:a},h,p,I){p.indexOf(this.b)!==-1&&this.J(I,{base:h,relativePath:this.b,searchPath:this.N(i,this.b)});const w=f=>{const b=l.$lc(f),L=l.$kc(f);let O=a[L];O||(O=a[L]=[],w(L)),O.push({base:h,relativePath:f,basename:b,searchPath:this.N(i,f)})};p.forEach(w)}H({rootEntries:i,pathToEntries:a},h,p){const I=this,w=this.t.get(h),f=this.b;function b(L){I.o++;const O=(0,s.$VI)(()=>L.map(T=>T.basename));for(let T=0,F=L.length;T<F;T++){const U=L[T],{relativePath:N,basename:j}=U;if(w.test(N,j,f!==j?O:void 0))continue;const z=a[N];if(z)b(z);else{if(I.p++,N===f)continue;I.J(p,U)}if(I.j)break}}b(i)}getStats(){return{cmdTime:this.r.elapsed(),fileWalkTime:this.m.elapsed(),directoriesWalked:this.o,filesWalked:this.p,cmdResultCount:this.s}}I(i,a,h,p,I){const w=i.folder,f=(0,s.$VI)(()=>h);this.w(h,(b,L)=>{if(this.l||this.j)return L(null);const O=a?[a,b].join(l.sep):b;if(this.t.get(i.folder.fsPath).test(O,b,this.a.filePattern!==b?f:void 0))return L(null);const T=[w.fsPath,O].join(l.sep);M.lstat(T,(F,U)=>{if(F||this.l||this.j)return L(null);this.L(T,U,(N,j)=>N||this.l||this.j?L(null):j.isDirectory()?(this.o++,this.M(T,U,(z,B)=>z||this.l||this.j||(B=B||"",this.v[B])?L(null):(this.v[B]=!0,E.Promises.readdir(T).then(ae=>{if(this.l||this.j)return L(null);this.I(i,O,ae,p,X=>L(X||null))},ae=>{L(null)})))):(this.p++,O===this.b||this.h&&D.$Af(j.size)&&j.size>this.h||this.J(p,{base:w.fsPath,relativePath:O,searchPath:this.N(i,O)}),L(null,void 0)))})},b=>{const L=b&&A.$Fb(b);return I(L&&L.length>0?L[0]:void 0)})}J(i,a){this.K(a)&&(!this.d||this.d(a.relativePath,l.$lc(a.relativePath)))&&(this.k++,(this.g||this.f&&this.k>this.f)&&(this.j=!0),this.j||i(a))}K(i){if(this.b){if(this.b==="*")return!0;if(this.c)return(0,s.$QI)(i,this.c)}return!0}L(i,a,h){return a.isSymbolicLink()?M.stat(i,h):h(null,a)}M(i,a,h){return a.isSymbolicLink()?M.realpath(i,(p,I)=>p?h(p):h(null,I)):h(null,i)}N(i,a){return i.folderName?l.$hc(i.folderName,a):a}}e.$1dc=g;class d{constructor(i){this.a=i.folderQueries,this.b=i.extraFileResources||[],this.c=new g(i)}search(i,a,h){this.c.walk(this.a,this.b,i,a,(p,I)=>{h(p,{limitHit:I,stats:this.c.getStats(),messages:[]})})}cancel(){this.c.cancel()}}e.$2dc=d;class t{constructor(i,a){this.expression=i,this.c=a,this.d(i)}d(i){let a,h;Object.keys(i).filter(p=>i[p]).forEach(p=>{l.$gc(p)?(a=a||k.$nj(),a[p]=i[p]):(h=h||k.$nj(),h[p]=i[p])}),this.a=a&&k.$sj(a,{trimForExclusions:!0}),this.b=h&&k.$sj(h,{trimForExclusions:!0})}test(i,a,h){return this.b&&this.b(i,a,h)||this.a&&this.a(l.$hc(this.c,i),a,h)}getBasenameTerms(){const i=[];return this.a&&i.push(...k.$uj(this.a)),this.b&&i.push(...k.$uj(this.b)),i}getPathTerms(){const i=[];return this.a&&i.push(...k.$vj(this.a)),this.b&&i.push(...k.$vj(this.b)),i}}function n(r){const i=r.trim().split(`
`),a=i[0].trim();if(a.startsWith("Error parsing regex"))return a;if(a.startsWith("regex parse error"))return S.$of(i[i.length-1].trim());if(a.startsWith("error parsing glob")||a.startsWith("unsupported encoding"))return a.charAt(0).toUpperCase()+a.substr(1);if(a==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(a.startsWith("Literal "))return a}}),define(Se[360],De([1,0,99,22,164,21]),function(ne,e,y,M,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vC=e.$uC=e.$tC=e.$sC=e.$rC=e.$qC=e.$pC=e.$oC=e.$nC=e.DecodeStreamErrorKind=e.$mC=e.$lC=e.$kC=e.$jC=e.$iC=e.$hC=e.$gC=e.$fC=void 0,e.$fC="utf8",e.$gC="utf8bom",e.$hC="utf16be",e.$iC="utf16le";function A(a){return[e.$fC,e.$gC,e.$hC,e.$iC].some(h=>h===a)}e.$jC=A,e.$kC=[254,255],e.$lC=[255,254],e.$mC=[239,187,191];const m=512,k=512,$=512*8,P=512*128;var C;(function(a){a[a.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(C||(e.DecodeStreamErrorKind=C={}));class v extends Error{constructor(h,p){super(h),this.decodeStreamErrorKind=p}}e.$nC=v;class S{static async create(h){let p;if(h!==e.$fC)p=(await(0,l.$eC)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getDecoder(c(h));else{const I=new TextDecoder;p={write(w){return I.decode(w,{stream:!0})},end(){return I.decode()}}}return new S(p)}constructor(h){this.a=h}write(h){return this.a.write(h)}end(){return this.a.end()}}function D(a,h){const p=h.minBytesRequiredForDetection??h.guessEncoding?$:k;return new Promise((I,w)=>{const f=(0,y.$Zd)(U=>U.join("")),b=[];let L=0,O;const T=new R.$Vd,F=async()=>{try{const U=await i({buffer:M.$_d.concat(b),bytesRead:L},h.guessEncoding);if(U.seemsBinary&&h.acceptTextOnly)throw new v("Stream is binary but only text is accepted for decoding",1);U.encoding=await h.overwriteEncoding(U.encoding),O=await S.create(U.encoding);const N=O.write(M.$_d.concat(b).buffer);f.write(N),b.length=0,L=0,I({stream:f,detected:U})}catch(U){T.cancel(),f.destroy(),w(U)}};(0,y.$4d)(a,{onData:async U=>{O?f.write(O.write(U.buffer)):(b.push(U),L+=U.byteLength,L>=p&&(a.pause(),await F(),setTimeout(()=>a.resume())))},onError:U=>f.error(U),onEnd:async()=>{O||await F(),f.end(O?.end())}},T.token)})}e.$oC=D;async function E(a,h,p){const w=(await(0,l.$eC)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getEncoder(c(h),p);let f=!1,b=!1;return{read(){if(b)return null;const L=a.read();if(typeof L!="string"){if(b=!0,!f&&p?.addBOM)switch(h){case e.$fC:case e.$gC:return M.$_d.wrap(Uint8Array.from(e.$mC));case e.$hC:return M.$_d.wrap(Uint8Array.from(e.$kC));case e.$iC:return M.$_d.wrap(Uint8Array.from(e.$lC))}const O=w.end();return O&&O.length>0?(f=!0,M.$_d.wrap(O)):null}return f=!0,M.$_d.wrap(w.write(L))}}}e.$pC=E;async function s(a){return(await(0,l.$eC)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).encodingExists(c(a))}e.$qC=s;function c(a){return a===e.$gC||a===null?e.$fC:a}e.$rC=c;function u(a,h){if(!a||h<e.$kC.length)return null;const p=a.readUInt8(0),I=a.readUInt8(1);if(p===e.$kC[0]&&I===e.$kC[1])return e.$hC;if(p===e.$lC[0]&&I===e.$lC[1])return e.$iC;if(h<e.$mC.length)return null;const w=a.readUInt8(2);return p===e.$mC[0]&&I===e.$mC[1]&&w===e.$mC[2]?e.$gC:null}e.$sC=u;const o=["ascii","utf-16","utf-32"];async function g(a){const h=await(0,l.$eC)("jschardet","dist/jschardet.min.js"),p=a.slice(0,P),I=n(p.buffer),w=h.detect(I);if(!w||!w.encoding)return null;const f=w.encoding.toLowerCase();return 0<=o.indexOf(f)?null:t(w.encoding)}const d={ibm866:"cp866",big5:"cp950"};function t(a){const h=a.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return d[h]||h}function n(a){let h="";for(let p=0;p<a.length;p++)h+=String.fromCharCode(a[p]);return h}function r(a){switch(a){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const h=a.match(/windows(\d+)/);return h?"windows-"+h[1]:a}}}e.$tC=r;function i({buffer:a,bytesRead:h},p){let I=u(a,h),w=!1;if(I!==e.$hC&&I!==e.$iC&&a){let f=!0,b=!0,L=!1;for(let O=0;O<h&&O<m;O++){const T=O%2===1,F=a.readUInt8(O)===0;if(F&&(L=!0),f&&(T&&!F||!T&&F)&&(f=!1),b&&(T&&F||!T&&!F)&&(b=!1),F&&!f&&!b)break}L&&(f?I=e.$iC:b?I=e.$hC:w=!0)}return p&&!w&&!I&&a?g(a.slice(0,h)).then(f=>({seemsBinary:!1,encoding:f})):{seemsBinary:w,encoding:I}}e.$uC=i,e.$vC={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(Se[155],De([1,0,360,29,154]),function(ne,e,y,M,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0dc=void 0;class R extends l.$Ycc{constructor(m,k,$=M,P="searchProcess"){super(m,k,{readdir:C=>$.Promises.readdir(C.fsPath),toCanonicalName:C=>(0,y.$tC)(C)},P)}}e.$0dc=R}),define(Se[156],De([1,0,47,376,359,19,74,34,15,16,2,36,93,377,357,117]),function(ne,e,y,M,l,R,A,m,k,$,P,C,v,S,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9dc=e.$8dc=e.$7dc=e.$6dc=e.$5dc=e.$4dc=e.$3dc=void 0;const s=D.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class c{constructor(b){this.a=b}provideTextSearchResults(b,L,O,T){return this.a.appendLine(`provideTextSearchResults ${b.pattern}, ${JSON.stringify({...L,folder:L.folder.toString()})}`),new Promise((F,U)=>{T.onCancellationRequested(()=>H());const N=n(b,L),j=L.folder.fsPath,z=N.map(de=>de.match(/^-/)?de:`'${de}'`).join(" ");this.a.appendLine(`${s} ${z}
 - cwd: ${j}`);let B=y.spawn(s,N,{cwd:j});B.on("error",de=>{console.error(de),this.a.appendLine("Error: "+(de&&de.message)),U((0,C.$MI)(new C.$KI(de&&de.message,C.SearchErrorCode.rgProcessError)))});let ae=!1;const X=new g(L.maxResults,j,L.previewOptions);X.on("result",de=>{ae=!0,me="",O.report(de)});let Q=!1;const H=()=>{Q=!0,B?.kill(),X?.cancel()};let te=!1;X.on("hitLimit",()=>{te=!0,H()});let me="";B.stdout.on("data",de=>{X.handleData(de),ae||(me+=de)});let le=!1;B.stdout.once("data",()=>le=!0);let ye="";B.stderr.on("data",de=>{const V=de.toString();this.a.appendLine(V),ye.length+V.length<1e6&&(ye+=V)}),B.on("close",()=>{if(this.a.appendLine(le?"Got data from stdout":"No data from stdout"),this.a.appendLine(ae?"Got result from parser":"No result from parser"),me&&this.a.appendLine(`Got data without result: ${me}`),this.a.appendLine(""),Q)F({limitHit:te});else{X.flush(),B=null;let de;ye&&!le&&(de=u(ye))?U((0,C.$MI)(new C.$KI(de.message,de.code))):F({limitHit:te})}})})}}e.$3dc=c;function u(f){const b=f.split(`
`),L=b[0].trim();if(b.some(T=>T.startsWith("regex parse error")))return new C.$KI(o(b),C.SearchErrorCode.regexParseError);const O=L.match(/grep config error: unknown encoding: (.*)/);if(O)return new C.$KI(`Unknown encoding: ${O[1]}`,C.SearchErrorCode.unknownEncoding);if(L.startsWith("error parsing glob"))return new C.$KI(L.charAt(0).toUpperCase()+L.substr(1),C.SearchErrorCode.globParseError);if(L.startsWith("the literal"))return new C.$KI(L.charAt(0).toUpperCase()+L.substr(1),C.SearchErrorCode.invalidLiteral);if(L.startsWith("PCRE2: error compiling pattern"))return new C.$KI(L,C.SearchErrorCode.regexParseError)}function o(f){const b=["Regex parse error"],L=f.filter(O=>O.startsWith("PCRE2:"));if(L.length>=1){const O=L[0].replace("PCRE2:","");if(O.indexOf(":")!==-1&&O.split(":").length>=2){const T=O.split(":")[1];b.push(":"+T)}}return b.join("")}class g extends M.EventEmitter{constructor(b,L,O){super(),this.g=b,this.h=L,this.j=O,this.a="",this.b=!1,this.c=!1,this.f=0,this.d=new l.StringDecoder}cancel(){this.b=!0}flush(){this.k(this.d.end())}on(b,L){return super.on(b,L),this}handleData(b){if(this.b)return;const L=typeof b=="string"?b:this.d.write(b);this.k(L)}k(b){let L=b.indexOf(`
`);const O=this.a+b;if(L>=0)L+=this.a.length;else{this.a=O;return}let T=0;for(;L>=0;)this.m(O.substring(T,L).trim()),T=L+1,L=O.indexOf(`
`,T);this.a=O.substring(T)}m(b){if(this.b||!b)return;let L;try{L=JSON.parse(b)}catch{throw new Error(`malformed line from rg: ${b}`)}if(L.type==="match"){const O=d(L.data.path),T=P.URI.file(k.$hc(this.h,O)),F=this.n(L.data,T);this.p(F),this.c&&(this.cancel(),this.emit("hitLimit"))}else if(L.type==="context"){const O=d(L.data.path),T=P.URI.file(k.$hc(this.h,O));this.o(L.data,T).forEach(U=>this.p(U))}}n(b,L){const O=b.line_number-1,T=d(b.lines),F=Buffer.from(T);let U=0,N=0,j=O;b.submatches.length===0&&b.submatches.push(T.length?{start:0,end:1,match:{text:T[0]}}:{start:0,end:0,match:{text:""}});const z=(0,R.$Fb)(b.submatches.map((B,ae)=>{if(this.c)return null;this.f++,this.f>=this.g&&(this.c=!0);const X=d(B.match),Q=F.slice(U,B.start).toString(),H=t(Q),te=H.numLines>0?H.lastLineLength:H.lastLineLength+N,me=t(X),le=H.numLines+j,ye=me.numLines+le,de=me.numLines>0?me.lastLineLength:me.lastLineLength+te;return U=B.end,N=de,j=ye,new v.$uI(le,te,ye,de)}));return(0,E.$Vdc)(L,T,z,this.j)}o(b,L){const O=d(b.lines),T=b.line_number;return O.replace(/\r?\n$/,"").split(`
`).map((F,U)=>({text:F,uri:L,lineNumber:T+U}))}p(b){this.emit("result",b)}}e.$4dc=g;function d(f){return f.bytes?Buffer.from(f.bytes,"base64").toString():f.text}function t(f){const b=/\n/g;let L=0,O=-1,T;for(;T=b.exec(f);)L++,O=T.index;const F=O>=0?f.length-O-1:f.length;return{numLines:L,lastLineLength:F}}function n(f,b){const L=["--hidden","--no-require-git"];L.push(f.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:O,otherIncludes:T}=(0,A.$D)(b.includes,U=>U.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(T&&T.length){const U=new Set;T.forEach(N=>{U.add(N)}),L.push("-g","!*"),U.forEach(N=>{r(N).map(E.$Udc).forEach(j=>{L.push("-g",j)})})}O&&O.length&&O.forEach(U=>{L.push("-g",U)}),b.excludes.map(E.$Udc).forEach(U=>L.push("-g",`!${U}`)),b.maxFileSize&&L.push("--max-filesize",b.maxFileSize+""),b.useIgnoreFiles?b.useParentIgnoreFiles||L.push("--no-ignore-parent"):L.push("--no-ignore"),b.followSymlinks&&L.push("--follow"),b.encoding&&b.encoding!=="utf8"&&L.push("--encoding",b.encoding),f.pattern==="--"&&(f.isRegExp=!0,f.pattern="\\-\\-"),f.isMultiline&&!f.isRegExp&&(f.pattern=(0,$.$De)(f.pattern),f.isRegExp=!0),b.usePCRE2&&L.push("--pcre2"),L.push("--crlf"),f.isRegExp&&(f.pattern=i(f.pattern),L.push("--engine","auto"));let F;if(f.isWordMatch){const N=(0,$.$Le)(f.pattern,!!f.isRegExp,{wholeWord:f.isWordMatch}).source.replace(/\\\//g,"/");L.push("--regexp",N)}else if(f.isRegExp){let U=h(f.pattern);U=p(U),L.push("--regexp",U)}else F=f.pattern,L.push("--fixed-strings");return L.push("--no-config"),b.useGlobalIgnoreFiles||L.push("--no-ignore-global"),L.push("--json"),f.isMultiline&&L.push("--multiline"),b.beforeContext&&L.push("--before-context",b.beforeContext+""),b.afterContext&&L.push("--after-context",b.afterContext+""),L.push("--"),F&&L.push(F),L.push("."),L}e.$5dc=n;function r(f){return w(f).flatMap(L=>{const O=(0,m.$qj)(L,"/");return O.map((T,F)=>O.slice(0,F+1).join("/"))})}function i(f){const b=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;f.match(b);)f=f.replace(b,"$1\\x{$2}");const L=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;f.match(L);)f=f.replace(L,"$1\\x{$2}");return f}e.$6dc=i;const a=f=>f.type==="Assertion"&&f.kind==="lookbehind";function h(f){let b;try{b=new S.RegExpParser().parsePattern(f)}catch{return f}let L="",O=0;const T=(N,j,z)=>{L+=f.slice(O,N)+z,O=j},F=[];return new S.RegExpVisitor({onCharacterEnter(N){if(N.raw!=="\\n")return;const j=F[0];if(!j)T(N.start,N.end,"\\r?\\n");else if(!F.some(a))if(j.type==="CharacterClass")if(j.negate){const z=f.slice(j.start+2,N.start)+f.slice(N.end,j.end-1);j.parent?.type==="Quantifier"?T(j.start,j.end,z?`[^${z}]`:"."):T(j.start,j.end,"(?!\\r?\\n"+(z?`|[${z}]`:"")+")")}else{const z=f.slice(j.start+1,N.start)+f.slice(N.end,j.end-1);T(j.start,j.end,z===""?"\\r?\\n":`(?:[${z}]|\\r?\\n)`)}else j.type==="Quantifier"&&T(N.start,N.end,"(?:\\r?\\n)")},onQuantifierEnter(N){F.unshift(N)},onQuantifierLeave(){F.shift()},onCharacterClassRangeEnter(N){F.unshift(N)},onCharacterClassRangeLeave(){F.shift()},onCharacterClassEnter(N){F.unshift(N)},onCharacterClassLeave(){F.shift()},onAssertionEnter(N){a(N)&&F.push(N)},onAssertionLeave(N){F[0]===N&&F.shift()}}).visit(b),L+=f.slice(O),L}e.$7dc=h;function p(f){return f.replace(/\n/g,"\\r?\\n")}e.$8dc=p;function I(f){let b=!1,L=!1,O="",T="";for(let F=0;F<f.length;F++){const U=f[F];switch(U){case"\\":L?(b?T+="\\"+U:O+="\\"+U,L=!1):L=!0;break;case"{":if(L)b?T+=U:O+=U,L=!1;else{if(b)return{strInBraces:O+"{"+T+"{"+f.substring(F+1)};b=!0}break;case"}":if(L)b?T+=U:O+=U,L=!1;else{if(b)return{fixedStart:O,strInBraces:T,fixedEnd:f.substring(F+1)};O+=U}break;default:b?T+=(L?"\\":"")+U:O+=(L?"\\":"")+U,L=!1;break}}return{strInBraces:O+(b?"{"+T:"")}}function w(f){const{fixedStart:b,strInBraces:L,fixedEnd:O}=I(f);if(b===void 0||O===void 0)return[L];let T=(0,m.$qj)(L,",");T.length||(T=[""]);const F=w(O);return T.flatMap(U=>{const N=b+U;return F.map(j=>N+j)})}e.$9dc=w}),define(Se[361],De([1,0,21,156,64,17]),function(ne,e,y,M,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aec=void 0;class A{constructor($){this.b=$,this.a=new Set,process.once("exit",()=>this.d())}provideTextSearchResults($,P,C,v){const S=new M.$3dc(this.b);if(P.folder.scheme===R.Schemas.vscodeUserData){const D={...P,folder:P.folder.with({scheme:R.Schemas.file})},E=new l.$Xu(s=>C.report({...s,uri:s.uri.with({scheme:P.folder.scheme})}));return this.c(v,s=>S.provideTextSearchResults($,D,E,s))}else return this.c(v,D=>S.provideTextSearchResults($,P,C,D))}async c($,P){const C=m($);this.a.add(C);const v=await P(C.token);return this.a.delete(C),v}d(){this.a.forEach($=>$.cancel())}}e.$aec=A;function m(k){const $=new y.$Vd;return k.onCancellationRequested(()=>$.cancel()),$}}),define(Se[362],De([1,0,29,156,155]),function(ne,e,y,M,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$dc=void 0;class R{constructor(k){this.a=k}search(k,$,P){if((!this.a.folderQueries||!this.a.folderQueries.length)&&(!this.a.extraFileResources||!this.a.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const C={appendLine(S){P({message:S})}},v=new l.$0dc(this.a,new M.$3dc(C),y);return new Promise((S,D)=>v.search(E=>{$(E.map(A))},k).then(E=>S({limitHit:E.limitHit,type:"success",stats:E.stats}),D))}}e.$$dc=R;function A(m){return{path:m.resource&&m.resource.fsPath,results:m.results,numMatches:(m.results||[]).reduce((k,$)=>{if($.ranges){const P=$;return k+(Array.isArray(P.ranges)?P.ranges.length:1)}else return k+1},0)}}}),define(Se[363],De([1,0,19,9,8,4,124,15,38,2,30,36,358,362]),function(ne,e,y,M,l,R,A,m,k,$,P,C,v,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_dc=void 0;class D{constructor(g="searchProcess"){this.d=g,this.b=Object.create(null)}fileSearch(g){let d;const t=c(g),n=new R.$Ld({onDidAddFirstListener:()=>{d=(0,M.$Eg)(r=>this.doFileSearchWithEngine(v.$2dc,t,i=>n.fire(i),r)),d.then(r=>n.fire(r),r=>n.fire({type:"error",error:{message:r.message,stack:r.stack}}))},onDidRemoveLastListener:()=>{d.cancel()}});return n.event}textSearch(g){let d;const t=c(g),n=new R.$Ld({onDidAddFirstListener:()=>{d=(0,M.$Eg)(r=>this.f(t,i=>n.fire(i),r)),d.then(r=>n.fire(r),r=>n.fire({type:"error",error:{message:r.message,stack:r.stack}}))},onDidRemoveLastListener:()=>{d.cancel()}});return n.event}f(g,d,t){return g.maxFileSize=this.g().maxFileSize,new S.$$dc(g).search(t,d,d)}g(){return{maxFileSize:process.arch==="ia32"?300*P.$Bk.MB:16*P.$Bk.GB}}doFileSearch(g,d,t){return this.doFileSearchWithEngine(v.$2dc,g,d,t)}doFileSearchWithEngine(g,d,t,n,r=D.a){let i=0;const a=p=>{Array.isArray(p)?(i+=p.length,t(p.map(I=>this.h(I)))):p.relativePath?(i++,t(this.h(p))):t(p)};if(d.sortByScore){let p=this.l(d,a,n);if(!p){const I=d.maxResults?Object.assign({},d,{maxResults:null}):d,w=new g(I);p=this.j(w,d,t,a,n)}return new Promise((I,w)=>{p.then(([f,b])=>{const L=b.map(O=>this.h(O));this.o(L,t,r),I(f)},w)})}const h=new g(d);return this.r(h,a,r,n).then(p=>({limitHit:p.limitHit,type:"success",stats:{detailStats:p.stats,type:this.d,fromCache:!1,resultCount:i,sortingTime:void 0}}))}h(g){return{path:g.base?(0,m.$hc)(g.base,g.relativePath):g.relativePath}}j(g,d,t,n,r){const i=new R.$Ld;let a=(0,M.$Eg)(p=>{let I=[];const w=f=>{Array.isArray(f)?I=f:(n(f),i.fire(f))};return this.r(g,w,-1,p).then(f=>[f,I])}),h;if(d.cacheKey){h=this.k(d.cacheKey);const p={promise:a,event:i.event,resolved:!1};h.resultsToSearchCache[d.filePattern||""]=p,a.then(()=>{p.resolved=!0},I=>{delete h.resultsToSearchCache[d.filePattern||""]}),a=this.s(a)}return a.then(([p,I])=>{const w=h?h.scorerCache:Object.create(null),f=(typeof d.maxResults!="number"||d.maxResults>0)&&k.$Hd.create(!1);return this.n(d,I,w,r).then(b=>{const L=f?f.elapsed():-1;return[{type:"success",stats:{detailStats:p.stats,sortingTime:L,fromCache:!1,type:this.d,workspaceFolderCount:d.folderQueries.length,resultCount:b.length},messages:p.messages,limitHit:p.limitHit||typeof d.maxResults=="number"&&I.length>d.maxResults},b]})})}k(g){const d=this.b[g];return d||(this.b[g]=new E)}l(g,d,t){const n=g.cacheKey&&this.b[g.cacheKey];if(!n)return;const r=this.q(n,g.filePattern||"",d,t);if(r)return r.then(([i,a,h])=>{const p=k.$Hd.create(!1);return this.n(g,a,n.scorerCache,t).then(I=>{const w=p.elapsed(),f={fromCache:!0,detailStats:h,type:this.d,resultCount:a.length,sortingTime:w};return[{type:"success",limitHit:i.limitHit||typeof g.maxResults=="number"&&a.length>g.maxResults,stats:f},I]})})}n(g,d,t,n){const r=(0,A.$qq)(g.filePattern||""),i=(h,p)=>(0,A.$pq)(h,p,r,!0,s,t),a=typeof g.maxResults=="number"?g.maxResults:Number.MAX_VALUE;return y.$Eb(d,i,a,1e4,n)}o(g,d,t){if(t&&t>0)for(let n=0;n<g.length;n+=t)d(g.slice(n,n+t));else d(g)}q(g,d,t,n){const r=k.$Hd.create(!1),i=d.indexOf(m.sep)>=0;let a;for(const w in g.resultsToSearchCache)if(d.startsWith(w)){if(i&&w.indexOf(m.sep)<0&&w!=="")continue;const f=g.resultsToSearchCache[w];a={promise:this.s(f.promise),event:f.event,resolved:f.resolved};break}if(!a)return null;const h=r.elapsed(),p=k.$Hd.create(!1),I=a.event(t);return n&&n.onCancellationRequested(()=>{I.dispose()}),a.promise.then(([w,f])=>{if(n&&n.isCancellationRequested)throw(0,l.$4)();const b=[],L=(0,A.$qq)(d).normalizedLowercase;for(const O of f)(0,C.$QI)(O,L)&&b.push(O);return[w,b,{cacheWasResolved:a.resolved,cacheLookupTime:h,cacheFilterTime:p.elapsed(),cacheEntryCount:f.length}]})}r(g,d,t,n){return new Promise((r,i)=>{let a=[];n?.onCancellationRequested(()=>g.cancel()),g.search(h=>{h&&(t?(a.push(h),t>0&&a.length>=t&&(d(a),a=[])):d(h))},h=>{d(h)},(h,p)=>{a.length&&d(a),h?i(h):r(p)})})}clearCache(g){return delete this.b[g],Promise.resolve(void 0)}s(g){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(d,t){return g.then(d,t)}catch(d){return this.then(void 0,d)}finally(d){return g.finally(d)}}}}e.$_dc=D,D.a=512;class E{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const s=new class{getItemLabel(o){return(0,m.$lc)(o.relativePath)}getItemDescription(o){return(0,m.$kc)(o.relativePath)}getItemPath(o){return o.relativePath}};function c(o){return{...o,folderQueries:o.folderQueries&&o.folderQueries.map(u),extraFileResources:o.extraFileResources&&o.extraFileResources.map(g=>$.URI.revive(g))}}function u(o){return{...o,folder:$.URI.revive(o.folder)}}}),define(Se[364],De([1,0,3,17,2,29,14,26,20,96,67,36,363,361,117,155]),function(ne,e,y,M,l,R,A,m,k,$,P,C,v,S,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bec=void 0;let s=class extends $.$4cc{constructor(u,o,g,d){super(u,g,d),this.s=R,this.t=-1,this.v=null,this.w=!1,this.x=new y.$Pc;const t=new D.$Wdc("RipgrepSearchUD",this.n);this.x.add(this.registerTextSearchProvider(M.Schemas.vscodeUserData,new S.$aec(t))),o.remote.isRemote&&o.remote.authority&&this.y()}dispose(){this.x.dispose()}$enableExtensionHostSearch(){this.y()}y(){if(this.w)return;this.w=!0;const u=new D.$Wdc("RipgrepSearchEH",this.n);this.x.add(this.registerTextSearchProvider(M.Schemas.file,new S.$aec(u))),this.x.add(this.z(M.Schemas.file,new v.$_dc("fileSearchProvider")))}z(u,o){const g=this.d++;return this.v=o,this.t=g,this.c.$registerFileSearchProvider(g,this.o(u)),(0,y.$Oc)(()=>{this.v=null,this.c.$unregisterProvider(g)})}$provideFileSearchResults(u,o,g,d){const t=(0,$.$5cc)(g);return u===this.t?this.A(u,o,t,d):super.$provideFileSearchResults(u,o,g,d)}A(u,o,g,d){const t=n=>{if((0,C.$PI)(n)&&(n=[n]),Array.isArray(n)){this.c.$handleFileMatch(u,o,n.map(r=>l.URI.file(r.path)));return}n.message&&this.n.debug("ExtHostSearch",n.message)};if(!this.v)throw new Error("No internal file search handler");return this.v.doFileSearch(g,t,d)}$clearCache(u){return this.v?.clearCache(u),super.$clearCache(u)}q(u,o){return new E.$0dc(u,o,void 0,"textSearchProvider")}};e.$bec=s,e.$bec=s=Ke([We(0,k.$0L),We(1,m.$nM),We(2,P.$Jbc),We(3,A.$6i)],s)}),define(Se[118],De([1,0,378,62,61,379,22,8,4,3,15,10,31,81,82]),function(ne,e,y,M,l,R,A,m,k,$,P,C,v,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.$Bh=e.$Ah=void 0;class E{traceSocketEvent(f,b){D.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,f,b)}constructor(f,b=""){this.f=!0,this.debugLabel=b,this.socket=f,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=L=>{if(this.traceSocketEvent("error",{code:L?.code,message:L?.message}),L){if(L.code==="EPIPE")return;(0,m.$Y)(L)}},this.socket.on("error",this.a),this.b=L=>{this.traceSocketEvent("close",{hadError:L}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(f){const b=L=>{this.traceSocketEvent("read",L),f(A.$_d.wrap(L))};return this.socket.on("data",b),{dispose:()=>this.socket.off("data",b)}}onClose(f){const b=L=>{f({type:0,hadError:L,error:void 0})};return this.socket.on("close",b),{dispose:()=>this.socket.off("close",b)}}onEnd(f){const b=()=>{f()};return this.socket.on("end",b),{dispose:()=>this.socket.off("end",b)}}write(f){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",f),this.socket.write(f.buffer,b=>{if(b){if(b.code==="EPIPE")return;(0,m.$Y)(b)}})}catch(b){if(b.code==="EPIPE")return;(0,m.$Y)(b)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((f,b)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),f();return}const L=()=>{this.socket.off("close",L),this.socket.off("end",L),this.socket.off("error",L),this.socket.off("timeout",L),this.socket.off("drain",L),this.traceSocketEvent("nodeDrainEnd"),f()};this.socket.on("close",L),this.socket.on("end",L),this.socket.on("error",L),this.socket.on("timeout",L),this.socket.on("drain",L)})}}e.$Ah=E;var s;(function(w){w[w.MinHeaderByteSize=2]="MinHeaderByteSize",w[w.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(s||(s={}));var c;(function(w){w[w.PeekHeader=1]="PeekHeader",w[w.ReadHeader=2]="ReadHeader",w[w.ReadBody=3]="ReadBody",w[w.Fin=4]="Fin"})(c||(c={}));class u extends $.$Qc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(f,b){this.socket.traceSocketEvent(f,b)}constructor(f,b,L,O){super(),this.f=this.B(new k.$Ld),this.g=this.B(new k.$Ld),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=f,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:b,inflateBytesLength:L?.byteLength||0,recordInflateBytes:O}),this.a=this.B(new o(this,b,L,O,this.f,(T,F)=>this.m(T,F))),this.B(this.a.onError(T=>{console.error(T),(0,m.$Y)(T),this.g.fire({type:0,hadError:!0,error:T})})),this.b=new D.$vh,this.B(this.socket.onData(T=>this.n(T))),this.B(this.socket.onClose(async T=>{this.a.isProcessingReadQueue()&&await k.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(T)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(f){return this.f.event(f)}onClose(f){return this.g.event(f)}onEnd(f){return this.socket.onEnd(f)}write(f){let b=0;for(;b<f.byteLength;)this.a.writeMessage(f.slice(b,Math.min(b+262144,f.byteLength))),b+=262144}m(f,b){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",f);let L=2;f.byteLength<126?L+=0:f.byteLength<2**16?L+=2:L+=8;const O=A.$_d.alloc(L);if(b?O.writeUInt8(194,0):O.writeUInt8(130,0),f.byteLength<126)O.writeUInt8(f.byteLength,1);else if(f.byteLength<2**16){O.writeUInt8(126,1);let T=1;O.writeUInt8(f.byteLength>>>8&255,++T),O.writeUInt8(f.byteLength>>>0&255,++T)}else{O.writeUInt8(127,1);let T=1;O.writeUInt8(0,++T),O.writeUInt8(0,++T),O.writeUInt8(0,++T),O.writeUInt8(0,++T),O.writeUInt8(f.byteLength>>>24&255,++T),O.writeUInt8(f.byteLength>>>16&255,++T),O.writeUInt8(f.byteLength>>>8&255,++T),O.writeUInt8(f.byteLength>>>0&255,++T)}this.socket.write(A.$_d.concat([O,f]))}end(){this.h=!0,this.socket.end()}n(f){if(f.byteLength!==0){for(this.b.acceptChunk(f);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const b=this.b.peek(this.j.readLen),L=b.readUInt8(0),O=(L&128)>>>7,T=(L&64)>>>6,F=b.readUInt8(1),U=(F&128)>>>7,N=F&127;this.j.state=2,this.j.readLen=2+(U?4:0)+(N===126?2:0)+(N===127?8:0),this.j.fin=O,this.j.firstFrameOfMessage&&(this.j.compressed=!!T),this.j.firstFrameOfMessage=!!O,this.j.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin})}else if(this.j.state===2){const b=this.b.read(this.j.readLen),L=b.readUInt8(1),O=(L&128)>>>7;let T=L&127,F=1;T===126?T=b.readUInt8(++F)*2**8+b.readUInt8(++F):T===127&&(T=b.readUInt8(++F)*0+b.readUInt8(++F)*0+b.readUInt8(++F)*0+b.readUInt8(++F)*0+b.readUInt8(++F)*2**24+b.readUInt8(++F)*2**16+b.readUInt8(++F)*2**8+b.readUInt8(++F));let U=0;O&&(U=b.readUInt8(++F)*2**24+b.readUInt8(++F)*2**16+b.readUInt8(++F)*2**8+b.readUInt8(++F)),this.j.state=3,this.j.readLen=T,this.j.mask=U,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask})}else if(this.j.state===3){const b=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",b),t(b,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",b),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.a.acceptFrame(b,this.j.compressed,!!this.j.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await k.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$Bh=u;class o extends $.$Qc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:A.$_d.alloc(0)}constructor(f,b,L,O,T,F){super(),this.n=f,this.r=T,this.s=F,this.a=this.B(new k.$Ld),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new k.$Ld),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new k.$Ld),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,b?(this.b=this.B(new g(this.n,O,L,{windowBits:15})),this.f=this.B(new d(this.n,{windowBits:15})),this.B(this.b.onError(U=>this.a.fire(U))),this.B(this.f.onError(U=>this.a.fire(U)))):(this.b=null,this.f=null)}writeMessage(f){this.g.push(f),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const f=this.g.shift();if(this.f){const b=await this.w(this.f,f);this.s(b,!0)}else this.s(f,!1)}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(f,b){return new Promise((L,O)=>{f.write(b),f.flush(T=>L(T))})}acceptFrame(f,b,L){this.h.push({data:f,isCompressed:b,isLastFrameOfMessage:L}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const f=this.h.shift();if(this.b&&f.isCompressed){const b=await this.C(this.b,f.data,f.isLastFrameOfMessage);this.r.fire(b)}else this.r.fire(f.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(f,b,L){return new Promise((O,T)=>{f.write(b),L&&f.write(A.$_d.fromByteArray([0,0,255,255])),f.flush(F=>O(F))})}}class g extends $.$Qc{get recordedInflateBytes(){return this.j?A.$_d.concat(this.f):A.$_d.alloc(0)}constructor(f,b,L,O){super(),this.h=f,this.j=b,this.a=this.B(new k.$Ld),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,R.createInflateRaw)(O),this.b.on("error",T=>{this.h.traceSocketEvent("zlibInflateError",{message:T?.message,code:T?.code}),this.a.fire(T)}),this.b.on("data",T=>{this.h.traceSocketEvent("zlibInflateData",T),this.g.push(A.$_d.wrap(T))}),L&&(this.h.traceSocketEvent("zlibInflateInitialWrite",L.buffer),this.b.write(L.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(f){this.j&&this.f.push(f.clone()),this.h.traceSocketEvent("zlibInflateWrite",f),this.b.write(f.buffer)}flush(f){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const b=A.$_d.concat(this.g);this.g.length=0,f(b)})}}class d extends $.$Qc{constructor(f,b){super(),this.g=f,this.a=this.B(new k.$Ld),this.onError=this.a.event,this.f=[],this.b=(0,R.createDeflateRaw)({windowBits:15}),this.b.on("error",L=>{this.g.traceSocketEvent("zlibDeflateError",{message:L?.message,code:L?.code}),this.a.fire(L)}),this.b.on("data",L=>{this.g.traceSocketEvent("zlibDeflateData",L),this.f.push(A.$_d.wrap(L))})}write(f){this.g.traceSocketEvent("zlibDeflateWrite",f.buffer),this.b.write(f.buffer)}flush(f){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let b=A.$_d.concat(this.f);this.f.length=0,b=b.slice(0,b.byteLength-4),f(b)})}}function t(w,f){if(f===0)return;const b=w.byteLength>>>2;for(let N=0;N<b;N++){const j=w.readUInt32BE(N*4);w.writeUInt32BE(j^f,N*4)}const L=b*4,O=w.byteLength-L,T=f>>>24&255,F=f>>>16&255,U=f>>>8&255;O>=1&&w.writeUInt8(w.readUInt8(L)^T,L),O>=2&&w.writeUInt8(w.readUInt8(L+1)^F,L+1),O>=3&&w.writeUInt8(w.readUInt8(L+2)^U,L+2)}e.$Ch=process.env.XDG_RUNTIME_DIR;const n={[2]:107,[1]:103};function r(){const w=(0,v.$bg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${w}-sock`;const f=process.platform!=="darwin"&&e.$Ch?e.$Ch:(0,l.tmpdir)(),b=(0,P.$hc)(f,`vscode-ipc-${w}.sock`);return a(b),b}e.$Dh=r;function i(w,f,b){const L=(0,y.createHash)("md5").update(w).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${L}-${b}-${f}-sock`;const O=b.substr(0,4),T=f.substr(0,6),F=L.substr(0,8);let U;return process.platform!=="darwin"&&e.$Ch&&!process.env.VSCODE_PORTABLE?U=(0,P.$hc)(e.$Ch,`vscode-${F}-${O}-${T}.sock`):U=(0,P.$hc)(w,`${O}-${T}.sock`),a(U),U}e.$Eh=i;function a(w){const f=n[C.$o];typeof f=="number"&&w.length>=f&&console.warn(`WARNING: IPC handle "${w}" is longer than ${f} chars, try a shorter --user-data-dir`)}class h extends S.$ph{static b(f){const b=k.Event.fromNodeEventEmitter(f,"connection");return k.Event.map(b,L=>({protocol:new D.$wh(new E(L,"ipc-server-connection")),onDidClientDisconnect:k.Event.once(k.Event.fromNodeEventEmitter(L,"close"))}))}constructor(f){super(h.b(f)),this.d=f}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$Fh=h;function p(w){return new Promise((f,b)=>{const L=(0,M.createServer)();L.on("error",b),L.listen(w,()=>{L.removeListener("error",b),f(new h(L))})})}e.$Gh=p;function I(w,f){return new Promise((b,L)=>{const O=(0,M.createConnection)(w,()=>{O.removeListener("error",L),b(D.$xh.fromSocket(new E(O,`ipc-client${f}`),f))});O.once("error",L)})}e.$Hh=I}),define(Se[365],De([1,0,62,61,166,118,9,3,10,49,14,136,247,248,107,86,22]),function(ne,e,y,M,l,R,A,m,k,$,P,C,v,S,D,E,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M7b=e.$L7b=e.$K7b=e.$J7b=void 0;async function c(t,n,r,i,a){let h;for(let p=3;p&&(h?.dispose(),h=await new u(t,n,r,i,a).waitForReady(),!(a&&l.$eg[a]||!l.$eg[h.tunnelLocalPort]));p--);return h}class u extends m.$Qc{constructor(n,r,i,a,h){super(),this.m=r,this.n=h,this.privacy=E.TunnelPrivacyId.Private,this.j=new Map,this.a=n,this.b=y.createServer(),this.c=new A.$Pg,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=p=>this.r(p),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=a,this.tunnelRemoteHost=i}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(r=>{r()})}async waitForReady(){const n=this.n??this.tunnelRemotePort,r=(0,E.$9u)(this.m)?"0.0.0.0":"127.0.0.1";let i=await(0,l.$fg)(n,2,1e3,r),a=null;return this.b.listen(i,this.m),await this.c.wait(),a=this.b.address(),a||(i=0,this.b.listen(i,this.m),await this.c.wait(),a=this.b.address()),this.tunnelLocalPort=a.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${a.port}`,this}async r(n){n.pause();const r=(0,E.$7u)(this.tunnelRemoteHost)||(0,E.$9u)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,i=await(0,v.$1k)(this.a,r,this.tunnelRemotePort),a=i.getSocket(),h=i.readEntireBuffer();i.dispose(),h.byteLength>0&&n.write(h.buffer),n.on("end",()=>{n.localAddress&&this.j.delete(n.localAddress),a.end()}),n.on("close",()=>a.end()),n.on("error",()=>{n.localAddress&&this.j.delete(n.localAddress),a instanceof R.$Ah?a.socket.destroy():a.end()}),a instanceof R.$Ah?this.t(n,a):this.s(n,a),n.localAddress&&this.j.set(n.localAddress,()=>{n.end(),a.end()})}s(n,r){r.onClose(()=>n.destroy()),r.onEnd(()=>n.end()),r.onData(i=>n.write(i.buffer)),n.on("data",i=>r.write(s.$_d.wrap(i))),n.resume()}t(n,r){const i=r.socket;i.on("end",()=>n.end()),i.on("close",()=>n.end()),i.on("error",()=>{n.destroy()}),i.pipe(n),n.pipe(i)}}e.$J7b=u;let o=class extends E.$_u{constructor(n,r,i,a,h){super(r,h),this.u=n,this.v=i,this.w=a}isPortPrivileged(n){return(0,E.$0u)(n,this.l,k.OS,M.release())}s(n,r,i,a,h,p,I,w){const f=this.r(r,i);if(f)return++f.refcount,f.value;if((0,E.$4u)(n))return this.t(n,r,i,h,p,I,w);{this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${r}:${i} on local port ${h}.`);const b={commit:this.w.commit,quality:this.w.quality,addressProvider:n,remoteSocketFactoryService:this.u,signService:this.v,logService:this.j,ipcLogger:null},L=c(b,a,r,i,h);return this.j.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.p(r,i,L),L}}};e.$K7b=o,e.$K7b=o=Ke([We(0,S.$Uk),We(1,P.$6i),We(2,D.$Xk),We(3,C.$lj),We(4,$.$fi)],o);let g=class extends o{constructor(n,r,i,a,h){super(n,r,i,a,h)}};e.$L7b=g,e.$L7b=g=Ke([We(0,S.$Uk),We(1,P.$6i),We(2,D.$Xk),We(3,C.$lj),We(4,$.$fi)],g);let d=class extends m.$Qc{constructor(n,r,i,a,h){super(),this.b=n,this.c=r,this.f=i,this.g=a,this.h=h,this.a=new Map}async openTunnel(n,r,i,a,h,p,I,w,f){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${i}:${a} on local port ${p}.`),!this.a.has(n)){const b=new g(this.b,this.c,this.g,this.f,this.h);this.B(b),this.a.set(n,b),b.onTunnelClosed(async()=>{(await b.tunnels).length===0&&(b.dispose(),this.a.delete(n))})}return this.a.get(n).openTunnel(r,i,a,h,p,I,w,f)}};e.$M7b=d,e.$M7b=d=Ke([We(0,S.$Uk),We(1,P.$6i),We(2,C.$lj),We(3,D.$Xk),We(4,$.$fi)],d)}),define(Se[366],De([1,0,118,108,52,33,2,14,43]),function(ne,e,y,M,l,R,A,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zM=e.$yM=void 0;class ${constructor(v,S,D){this.b=v,this.c=S,this.f=D,this.a=M.createServer((E,s)=>this.h(E,s)),this.g().catch(E=>(S.error(E),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",v=>this.c.error(v))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(v,S){const D=(s,c)=>{S.writeHead(s,{"content-type":"application/json"}),S.end(JSON.stringify(c||null),u=>u&&this.c.error(u))},E=[];v.setEncoding("utf8"),v.on("data",s=>E.push(s)),v.on("end",async()=>{try{const s=JSON.parse(E.join(""));let c;switch(s.type){case"open":c=await this.i(s);break;case"openExternal":c=await this.j(s);break;case"status":c=await this.l(s);break;case"extensionManagement":c=await this.k(s);break;default:D(404,`Unknown message type: ${s.type}`);break}D(200,c)}catch(s){const c=s instanceof Error?s.message:JSON.stringify(s);D(500,c),this.c.error("Error while processing pipe request",s)}})}async i(v){const{fileURIs:S,folderURIs:D,forceNewWindow:E,diffMode:s,mergeMode:c,addMode:u,forceReuseWindow:o,gotoLineMode:g,waitMarkerFilePath:d,remoteAuthority:t}=v,n=[];if(Array.isArray(D))for(const h of D)try{n.push({folderUri:A.URI.parse(h)})}catch{}if(Array.isArray(S))for(const h of S)try{(0,k.$ei)(h)?n.push({workspaceUri:A.URI.parse(h)}):n.push({fileUri:A.URI.parse(h)})}catch{}const r=d?A.URI.file(d):void 0,a={forceNewWindow:E,diffMode:s,mergeMode:c,addMode:u,gotoLineMode:g,forceReuseWindow:o,preferNewWindow:!o&&!r&&!u,waitMarkerFileURI:r,remoteAuthority:t};this.b.executeCommand("_remoteCLI.windowOpen",n,a)}async j(v){for(const S of v.uris){const D=A.URI.parse(S),E=D.scheme==="file"?D:S;await this.b.executeCommand("_remoteCLI.openExternal",E)}}async k(v){const S=E=>E?.map(s=>/\.vsix$/i.test(s)?A.URI.parse(s):s),D={list:v.list,install:S(v.install),uninstall:S(v.uninstall),force:v.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",D)}async l(v){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&l.existsSync(this.f)&&l.unlinkSync(this.f)}}e.$yM=$;let P=class extends ${constructor(v,S){super(v,S,(0,y.$Dh)())}};e.$zM=P,e.$zM=P=Ke([We(0,R.$tM),We(1,m.$6i)],P)}),define(Se[367],De([1,0,108,53,354,349,266,45,337,2,17,7,366,101,335,37,336]),function(ne,e,y,M,l,R,A,m,k,$,P,C,v,S,D,E,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gec=void 0;class c extends R.$Hdc{k(){const g=this,d=globalThis._VSCODE_NODE_MODULES.module,t=d._load;d._load=function(a,h,p){return a=r(a),g.a.has(a)?g.a.get(a).load(a,$.URI.file((0,S.$Zp)(h.filename)),I=>t.apply(this,[I,h,p])):t.apply(this,arguments)};const n=d._resolveLookupPaths;d._resolveLookupPaths=(i,a)=>n.call(this,r(i),a);const r=i=>{for(const a of g.b){const h=a(i);if(h){i=h;break}}return i}}}class u extends m.$hcc{constructor(){super(...arguments),this.extensionRuntime=C.ExtensionRuntime.Node}async tb(){this.h.createInstance(D.$eec);const g=this.h.invokeFunction(l.$Ddc);if(this.h.createInstance(k.$dec),this.f.remote.isRemote&&this.f.remote.authority){const n=this.h.createInstance(v.$zM);process.env.VSCODE_IPC_HOOK_CLI=n.ipcHandlePath}this.h.createInstance(s.$fec),await this.h.createInstance(c,g,{mine:this.J,all:this.L}).install(),M.mark("code/extHost/didInitAPI"),(async()=>{const n=process.env.VSCODE_IPC_HOOK_CLI,r=process.env.CODE_SERVER_SESSION_SOCKET;if(!n||!r)return;const a={workspace:this.h.invokeFunction(p=>p.get(E.$Mbc).workspace),socketPath:n},h=JSON.stringify({entry:a});await new Promise((p,I)=>{const w={path:"/add-session",socketPath:r,method:"POST",headers:{"content-type":"application/json"}},f=y.request(w,b=>{b.on("error",I),b.on("end",()=>{try{b.statusCode===200?p():I(new Error("Unexpected status code: "+b.statusCode))}catch(L){I(L)}})});f.on("error",I),f.write(h),f.end()})})().catch(n=>{this.s.error(n)});const t=await this.m.getConfigProvider();await(0,A.$cec)(this.j,t,this,this.s,this.z,this.f),M.mark("code/extHost/didInitProxyResolver")}ub(g){return g.main}async vb(g,d,t){if(d.scheme!==P.Schemas.file)throw new Error(`Cannot load URI: '${d}', must be of file-scheme`);let n=null;t.codeLoadingStart(),this.s.trace(`ExtensionService#loadCommonJSModule ${d.toString(!0)}`),this.s.flush();const r=g?.identifier.value;g&&await this.w.initializeLocalizedMessages(g);try{r&&M.mark(`code/extHost/willLoadExtensionCode/${r}`),n=ne.__$__nodeRequire(d.fsPath)}finally{r&&M.mark(`code/extHost/didLoadExtensionCode/${r}`),t.codeLoadingStop()}return n}async $setRemoteEnvironment(g){if(this.f.remote.isRemote)for(const d in g){const t=g[d];t===null?delete process.env[d]:process.env[d]=t}}}e.$gec=u}),define(Se[368],De([1,0,47,22,4,3,121,10,24,2,29,14,246,65,107,86,365,26,20,73,345]),function(ne,e,y,M,l,R,A,m,k,$,P,C,v,S,D,E,s,c,u,o,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oec=e.$nec=e.$mec=e.$lec=e.$kec=e.$jec=e.$iec=e.$hec=void 0;function d(f){const b=f.trim().split(`
`),L=[];return b.forEach(T=>{const F=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(T);F&&F.length>=3&&L.push({pid:parseInt(F[1],10),socket:parseInt(F[2],10)})}),L.reduce((T,F)=>(T[F.socket]=F,T),{})}e.$hec=d;function t(...f){const b=[].concat(...f.map(r));return[...new Map(b.filter(L=>L.st==="0A").map(L=>{const O=L.local_address.split(":");return{socket:parseInt(L.inode,10),ip:n(O[0]),port:parseInt(O[1],16)}}).map(L=>[L.ip+":"+L.port,L])).values()]}e.$iec=t;function n(f){let b="";if(f.length===8)for(let L=f.length-2;L>=0;L-=2)b+=parseInt(f.substr(L,2),16),L!==0&&(b+=".");else for(let L=0;L<f.length;L+=8){const O=f.substring(L,L+8);let T="";for(let F=8;F>=2;F-=2)T+=O.substring(F-2,F),(F===6||F===2)&&(T=parseInt(T,16).toString(16),b+=`${T}`,T="",L+F!==f.length-6&&(b+=":"))}return b}e.$jec=n;function r(f){const b=f.trim().split(`
`),L=b.shift().trim().split(/\s+/).filter(T=>T!=="rx_queue"&&T!=="tm->when");return b.map(T=>T.trim().split(/\s+/).reduce((F,U,N)=>(F[L[N]||N]=U,F),{}))}e.$kec=r;function i(f){return!!f.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||f.indexOf("out/server-main.js")!==-1||f.indexOf("_productName=VSCode")!==-1}function a(f){const b=f.trim().split(`
`),L=[];return b.forEach(O=>{const T=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(O);T&&T.length>=4&&L.push({pid:parseInt(T[1],10),ppid:parseInt(T[2]),cmd:T[3]})}),L}e.$lec=a;async function h(f,b,L){const O=L.reduce((F,U)=>(F[U.pid]=U,F),{}),T=[];return f.forEach(({socket:F,ip:U,port:N})=>{const j=b[F]?b[F].pid:void 0,z=j?O[j]?.cmd:void 0;j&&z&&!i(z)&&T.push({host:U,port:N,detail:z,pid:j})}),T}e.$mec=h;function p(f,b,L){const O=new Map,T=a(b);for(const F of f){const U=L.get(F.port);if(U){O.set(F.port,U);continue}const N=T.find(j=>j.cmd.includes(`${F.port}`));if(N){let j=N,z;do z=T.find(B=>B.ppid===j.pid),z&&(j=z);while(z);O.set(F.port,{host:F.ip,port:F.port,pid:j.pid,detail:j.cmd,ppid:j.ppid})}else O.set(F.port,{host:F.ip,port:F.port,ppid:Number.MAX_VALUE})}return O}e.$nec=p;let I=class extends o.$lsb{constructor(b,L,O,T){super(b,L,O),this.D=L,this.F=T,this.y=void 0,this.z=new Map,this.C=!1,m.$f&&L.remote.isRemote&&L.remote.authority&&(this.a.$setRemoteTunnelService(process.pid),this.H())}async $registerCandidateFinder(b){if(b&&this.C)return;this.C=b;let L;this.y&&(L=this.y,await this.a.$onFoundNewCandidates(this.y));const O=new A.$Ml;let T=0;for(;this.C;){const F=new Date().getTime(),U=(await this.I()).filter(z=>(0,E.$7u)(z.host)||(0,E.$9u)(z.host));this.s.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${U.map(z=>z.port).join(", ")}`);const N=new Date().getTime()-F;this.s.trace(`ForwardedPorts: (ExtHostTunnelService) candidate port scan took ${N} ms.`),T++>3&&O.update(N),(!L||JSON.stringify(L)!==JSON.stringify(U))&&(L=U,await this.a.$onFoundNewCandidates(L));const j=this.G(O.value);this.s.trace(`ForwardedPorts: (ExtHostTunnelService) next candidate port scan in ${j} ms.`),await new Promise(z=>setTimeout(()=>z(),j))}}G(b){return Math.max(b*20,2e3)}async H(){this.y=await this.I(),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) Initial candidates found: ${this.y.map(b=>b.port).join(", ")}`)}async I(){let b="",L="";try{b=await P.Promises.readFile("/proc/net/tcp","utf8"),L=await P.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const O=t(b,L),T=await new Promise(X=>{(0,y.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(Q,H,te)=>{X(H)})}),F=d(T),U=await P.Promises.readdir("/proc"),N=[];for(const X of U)try{const Q=Number(X),H=k.$sg($.URI.file("/proc"),X);if((await P.Promises.stat(H.fsPath)).isDirectory()&&!isNaN(Q)){const me=await P.Promises.readlink(k.$sg(H,"cwd").fsPath),le=await P.Promises.readFile(k.$sg(H,"cmdline").fsPath,"utf8");N.push({pid:Q,cwd:me,cmd:le})}}catch{}const j=[],z=O.filter(X=>{const Q=F[X.socket];return Q||j.push(X),Q}),B=h(z,F,N);let ae;if(this.s.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${j.length}`),j.length>0){const X=await new Promise(Q=>{(0,y.exec)("ps -F -A -l | grep root",(H,te,me)=>{Q(te)})});this.z=p(j,X,this.z),ae=Array.from(this.z.values()),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${ae.map(Q=>Q.port).join(", ")}`)}return B.then(X=>ae?X.concat(ae):X)}w(b){return async L=>{const O=new s.$J7b({commit:this.D.commit,quality:this.D.quality,logService:this.s,ipcLogger:null,remoteSocketFactoryService:{_serviceBrand:void 0,async connect(F,U,N,j){const z=await b.makeConnection();return w.connect(z,U,N,j)},register(){throw new Error("not implemented")}},addressProvider:{getAddress(){return Promise.resolve({connectTo:new S.$Lk(0),connectionToken:b.connectionToken})}},signService:this.F},"localhost",L.remoteAddress.host||"localhost",L.remoteAddress.port,L.localAddressPort);await O.waitForReady();const T=new l.$Ld;return{localAddress:(0,g.$wJ)(O.localAddress)??O.localAddress,remoteAddress:{port:O.tunnelRemotePort,host:O.tunnelRemoteHost},onDidDispose:T.event,dispose:()=>{O.dispose(),T.fire(),T.dispose()}}}}};e.$oec=I,e.$oec=I=Ke([We(0,u.$0L),We(1,c.$nM),We(2,C.$6i),We(3,D.$Xk)],I);class w extends v.$skb{static connect(b,L,O,T){const F=new R.$Pc,U={onClose:F.add(new l.$Ld),onData:F.add(new l.$Ld),onEnd:F.add(new l.$Ld)};F.add(b.onDidReceiveMessage(j=>U.onData.fire(M.$_d.wrap(j)))),F.add(b.onDidEnd(()=>U.onEnd.fire())),F.add(b.onDidClose(j=>U.onClose.fire({type:0,error:j,hadError:!!j})));const N=new w(b,T,U);return N.B(F),(0,v.$rkb)(N,L,O,T,U)}constructor(b,L,O){super(L,O),this.n=b}write(b){this.n.send(b.buffer)}h(){this.n.end()}async drain(){await this.n.drain?.()}}}),define(Se[369],De([1,0,104,340,352,351,364,367,368,95,45,96,94,44,73,91,339,338,14,353,55,261,103,107,139]),function(ne,e,y,M,l,R,A,m,k,$,P,C,v,S,D,E,s,c,u,o,g,d,t,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,y.$or)(P.$icc,m.$gec,0),(0,y.$or)(u.$7i,c.$qec,1),(0,y.$or)(u.$6i,new t.$Ih(d.$Gdc,[!1],!0)),(0,y.$or)(n.$Xk,r.$O7b,1),(0,y.$or)(E.$6bc,s.$pec,0),(0,y.$or)($.$Scc,R.$Tdc,0),(0,y.$or)(C.$3cc,A.$bec,0),(0,y.$or)(v.$Ncc,l.$Ldc,0),(0,y.$or)(S.$8bc,M.$Kdc,0),(0,y.$or)(D.$ksb,k.$oec,0),(0,y.$or)(g.$Qcc,o.$rec,0)}),define(Se[380],De([1,0,108,62,381,53,8,82,118,244,112,350,22,29,101,9,131,267,284,355,369]),function(ne,e,y,M,l,R,A,m,k,$,P,C,v,S,D,E,s,c,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),function(){for(let p=0;p<process.execArgv.length;p++)process.execArgv[p]==="--inspect-port=0"&&(process.execArgv.splice(p,1),p--)}();const o=l(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const h=globalThis._VSCODE_NODE_MODULES.module,p=h._load;h._load=function(I){if(I==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return p.apply(this,arguments)}})();const g=process.exit.bind(process);function d(h){process.exit=function(p){if(h)g(p);else{const I=new Error("An extension called process.exit() and this was prevented.");console.warn(I.stack)}},process.crash=function(){const p=new Error("An extension called process.crash() and this was prevented.");console.warn(p.stack)},process.env.ELECTRON_RUN_AS_NODE="1"}let t=function(h){g()};function n(){const h=(0,u.$tm)(process.env);if(h.type===3)return new Promise((p,I)=>{const w=f=>{const b=f[0],L=new m.$yh;b.on("message",O=>L.fire(v.$_d.wrap(O.data))),b.on("close",()=>{t("renderer closed the MessagePort")}),b.start(),p({onMessage:L.event,send:O=>b.postMessage(O.buffer)})};process.parentPort.on("message",f=>w(f.ports))});if(h.type===2)return new Promise((p,I)=>{let w=null;const f=setTimeout(()=>{t("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),b=108e5,L=3e5,O=new E.$4g(()=>t("renderer disconnected for too long (1)"),b),T=new E.$4g(()=>t("renderer disconnected for too long (2)"),L);process.on("message",(U,N)=>{if(U&&U.type==="VSCODE_EXTHOST_IPC_SOCKET"){N.setNoDelay(!0);const j=v.$_d.wrap(Buffer.from(U.initialDataChunk,"base64"));let z;if(U.skipWebSocketFrames)z=new k.$Ah(N,"extHost-socket");else{const B=v.$_d.wrap(Buffer.from(U.inflateBytes,"base64"));z=new k.$Bh(new k.$Ah(N,"extHost-socket"),U.permessageDeflate,B,!1)}w?(O.cancel(),T.cancel(),w.beginAcceptReconnection(z,j),w.endAcceptReconnection(),w.sendResume()):(clearTimeout(f),w=new m.$zh({socket:z,initialChunk:j}),w.sendResume(),w.onDidDispose(()=>t("renderer disconnected")),p(w),w.onSocketClose(()=>{O.schedule()}))}if(U&&U.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(T.isScheduled())return;O.isScheduled()&&T.schedule()}});const F={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(F)});{const p=h.pipeName;return new Promise((I,w)=>{const f=M.createConnection(p,()=>{f.removeListener("error",w);const b=new m.$zh({socket:new k.$Ah(f,"extHost-renderer")});b.sendResume(),I(b)});f.once("error",w),f.on("close",()=>{t("renderer closed the socket")})})}}async function r(){const h=await n();return new class{constructor(){this.a=new m.$yh,this.onMessage=this.a.event,this.b=!1,h.onMessage(p=>{(0,P.$7l)(p,2)?(this.b=!0,t("received terminate message from renderer")):this.a.fire(p)})}send(p){this.b||h.send(p)}async drain(){if(h.drain)return h.drain()}}}function i(h){return new Promise(p=>{const I=h.onMessage(w=>{I.dispose();const f=JSON.parse(w.toString()),b=f.commit,L=$.default.commit;if(b&&L&&b!==L&&g(55),f.parentPid){let O=0;setInterval(function(){try{process.kill(f.parentPid,0),O=0}catch(F){F&&F.code==="EPERM"?(O++,O>=3&&t(`parent process ${f.parentPid} does not exist anymore (3 x EPERM): ${F.message} (code: ${F.code}) (errno: ${F.errno})`)):t(`parent process ${f.parentPid} does not exist anymore: ${F.message} (code: ${F.code}) (errno: ${F.errno})`)}},1e3);let T;try{T=globalThis._VSCODE_NODE_MODULES["native-watchdog"],T.start(f.parentPid)}catch(F){(0,A.$Y)(F)}}h.send((0,P.$6l)(0)),p({protocol:h,initData:f})});h.send((0,P.$6l)(1))})}async function a(){const h=[];process.on("unhandledRejection",(O,T)=>{h.push(T),setTimeout(()=>{const F=h.indexOf(T);F>=0&&T.catch(U=>{h.splice(F,1),(0,A.$2)(U)||(console.warn(`rejected promise not handled within 1 second: ${U}`),U&&U.stack&&console.warn(`stack trace: ${U.stack}`),O&&(0,A.$Y)(O))})},1e3)}),process.on("rejectionHandled",O=>{const T=h.indexOf(O);T>=0&&h.splice(T,1)}),process.on("uncaughtException",function(O){(0,A.$X)(O)||(0,A.$Y)(O)}),R.mark("code/extHost/willConnectToRenderer");const p=await r();R.mark("code/extHost/didConnectToRenderer");const I=await i(p);R.mark("code/extHost/didWaitForInitData");const{initData:w}=I;d(!!w.environment.extensionTestsLocationURI),w.environment.useHostProxy=o.useHostProxy!==void 0?o.useHostProxy!=="false":void 0,w.environment.skipWorkspaceStorageLock=(0,s.boolean)(o.skipWorkspaceStorageLock,!1);const f=new class{constructor(){this.pid=process.pid}exit(T){g(T)}fsExists(T){return S.Promises.exists(T)}fsRealpath(T){return(0,D.$Yp)(T)}};let b=null;w.remote.authority&&o.transformURIs&&(b=(0,c.$sr)(w.remote.authority));const L=new C.$Jdc(I.protocol,w,f,b);t=O=>{L.terminate(O);const T=process.env.VSCODE_IPC_HOOK_CLI,F=process.env.CODE_SERVER_SESSION_SOCKET;if(!T||!F)return;const U=JSON.stringify({socketPath:T}),N={path:"/delete-session",socketPath:F,method:"POST",headers:{"content-type":"application/json",accept:"application/json"}},j=y.request(N);j.write(U),j.end()}}a().catch(h=>console.log(h))})}).call(this);

//# sourceMappingURL=extensionHostProcess.js.map
