"use strict";/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ae=["exports","require","vs/base/common/uri","vs/workbench/api/common/extHost.protocol","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/base/common/errors","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/async","vs/base/common/network","vs/platform/log/common/log","vs/base/common/strings","vs/base/common/types","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/path","vs/platform/extensions/common/extensions","vs/base/common/cancellation","vs/base/common/platform","vs/base/common/resources","vs/base/common/objects","vs/base/common/buffer","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/base/common/severity","vs/platform/registry/common/platform","vs/workbench/api/common/extHostCommands","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/glob","vs/base/common/uuid","vs/platform/files/common/files","vs/workbench/api/common/extHostFileSystemInfo","vs/base/common/extpath","vs/base/common/themables","vs/base/common/errorMessage","vs/platform/configuration/common/configuration","vs/editor/common/core/range","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/services/search/common/search","vs/base/common/ternarySearchTree","vs/base/common/htmlContent","vs/platform/progress/common/progress","vs/base/common/assert","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/platform/workspace/common/workspace","vs/workbench/api/common/cache","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/base/common/stopwatch","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWebview","vs/base/common/decorators","vs/base/common/lazy","vs/base/common/mime","vs/base/common/marshalling","vs/base/common/iterator","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/base/common/process","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/editor/common/languages","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/base/common/performance","vs/base/common/idGenerator","vs/base/common/codicons","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/hash","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/implicitActivationEvents","vs/workbench/common/editor","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/numbers","vs/base/common/comparers","vs/base/common/stream","vs/base/common/filters","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/uriIpc","vs/base/common/dataTransfer","vs/editor/common/core/textModelDefaults","vs/editor/common/languageSelector","vs/editor/common/languages/languageConfiguration","vs/editor/common/services/treeViewsDnd","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChat","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/views","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/api/common/extHostTheming","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/base/common/functional","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostTreeViews","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostChatAgents","vs/workbench/api/common/extHostChatProvider","vs/workbench/api/common/extHostChatSlashCommand","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/base/common/collections","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/editor/common/model/mirrorTextModel","vs/editor/common/core/position","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/base/common/arraysFind","vs/editor/common/model/textModelSearch","vs/editor/common/model","vs/workbench/api/worker/extensionHostWorker"],Re=function(ie){for(var e=[],h=0,C=ie.length;h<C;h++)e[h]=Ae[ie[h]];return e};define(Ae[65],Re([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fh=e.$eh=e.$dh=void 0;function h(R){return(u,D,d)=>{let A=null,k=null;if(typeof d.value=="function"?(A="value",k=d.value):typeof d.get=="function"&&(A="get",k=d.get),!k)throw new Error("not supported");d[A]=R(k,D)}}function C(R,u,D){let d=null,A=null;if(typeof D.value=="function"?(d="value",A=D.value,A.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof D.get=="function"&&(d="get",A=D.get),!A)throw new Error("not supported");const k=`$memoize$${u}`;D[d]=function(...a){return this.hasOwnProperty(k)||Object.defineProperty(this,k,{configurable:!1,enumerable:!1,writable:!1,value:A.apply(this,a)}),this[k]}}e.$dh=C;function I(R,u,D){return h((d,A)=>{const k=`$debounce$${A}`,a=`$debounce$result$${A}`;return function(...w){this[a]||(this[a]=D?D():void 0),clearTimeout(this[k]),u&&(this[a]=u(this[a],...w),w=[this[a]]),this[k]=setTimeout(()=>{d.apply(this,w),this[a]=D?D():void 0},R)}})}e.$eh=I;function O(R,u,D){return h((d,A)=>{const k=`$throttle$timer$${A}`,a=`$throttle$result$${A}`,w=`$throttle$lastRun$${A}`,m=`$throttle$pending$${A}`;return function(...f){if(this[a]||(this[a]=D?D():void 0),(this[w]===null||this[w]===void 0)&&(this[w]=-Number.MAX_VALUE),u&&(this[a]=u(this[a],...f)),this[m])return;const t=this[w]+R;t<=Date.now()?(this[w]=Date.now(),d.apply(this,[this[a]]),this[a]=D?D():void 0):(this[m]=!0,this[k]=setTimeout(()=>{this[m]=!1,this[w]=Date.now(),d.apply(this,[this[a]]),this[a]=D?D():void 0},t-Date.now()))}})}e.$fh=O}),define(Ae[88],Re([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dM=e.$cM=void 0;class h{constructor(I){this.a=I,this.b=0}nextId(){return this.a+ ++this.b}}e.$cM=h,e.$dM=new h("id#")}),define(Ae[115],Re([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wm=e.$Vm=e.$Um=e.$Tm=e.$Sm=e.$Rm=e.$Qm=e.$Pm=e.$Om=e.$Nm=e.$Mm=e.$Lm=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var h;(function(n){n[n.None=0]="None",n[n.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=2]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",n[n.InvalidUnicode=4]="InvalidUnicode",n[n.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",n[n.InvalidCharacter=6]="InvalidCharacter"})(h||(e.ScanError=h={}));var C;(function(n){n[n.OpenBraceToken=1]="OpenBraceToken",n[n.CloseBraceToken=2]="CloseBraceToken",n[n.OpenBracketToken=3]="OpenBracketToken",n[n.CloseBracketToken=4]="CloseBracketToken",n[n.CommaToken=5]="CommaToken",n[n.ColonToken=6]="ColonToken",n[n.NullKeyword=7]="NullKeyword",n[n.TrueKeyword=8]="TrueKeyword",n[n.FalseKeyword=9]="FalseKeyword",n[n.StringLiteral=10]="StringLiteral",n[n.NumericLiteral=11]="NumericLiteral",n[n.LineCommentTrivia=12]="LineCommentTrivia",n[n.BlockCommentTrivia=13]="BlockCommentTrivia",n[n.LineBreakTrivia=14]="LineBreakTrivia",n[n.Trivia=15]="Trivia",n[n.Unknown=16]="Unknown",n[n.EOF=17]="EOF"})(C||(e.SyntaxKind=C={}));var I;(function(n){n[n.InvalidSymbol=1]="InvalidSymbol",n[n.InvalidNumberFormat=2]="InvalidNumberFormat",n[n.PropertyNameExpected=3]="PropertyNameExpected",n[n.ValueExpected=4]="ValueExpected",n[n.ColonExpected=5]="ColonExpected",n[n.CommaExpected=6]="CommaExpected",n[n.CloseBraceExpected=7]="CloseBraceExpected",n[n.CloseBracketExpected=8]="CloseBracketExpected",n[n.EndOfFileExpected=9]="EndOfFileExpected",n[n.InvalidCommentToken=10]="InvalidCommentToken",n[n.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=12]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",n[n.InvalidUnicode=14]="InvalidUnicode",n[n.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",n[n.InvalidCharacter=16]="InvalidCharacter"})(I||(e.ParseErrorCode=I={}));var O;(function(n){n.DEFAULT={allowTrailingComma:!0}})(O||(e.ParseOptions=O={}));function R(n,r=!1){let i=0;const o=n.length;let y="",g=0,E=16,P=0;function l(W){let L=0,z=0;for(;L<W;){const K=n.charCodeAt(i);if(K>=48&&K<=57)z=z*16+K-48;else if(K>=65&&K<=70)z=z*16+K-65+10;else if(K>=97&&K<=102)z=z*16+K-97+10;else break;i++,L++}return L<W&&(z=-1),z}function $(W){i=W,y="",g=0,E=16,P=0}function b(){const W=i;if(n.charCodeAt(i)===48)i++;else for(i++;i<n.length&&d(n.charCodeAt(i));)i++;if(i<n.length&&n.charCodeAt(i)===46)if(i++,i<n.length&&d(n.charCodeAt(i)))for(i++;i<n.length&&d(n.charCodeAt(i));)i++;else return P=3,n.substring(W,i);let L=i;if(i<n.length&&(n.charCodeAt(i)===69||n.charCodeAt(i)===101))if(i++,(i<n.length&&n.charCodeAt(i)===43||n.charCodeAt(i)===45)&&i++,i<n.length&&d(n.charCodeAt(i))){for(i++;i<n.length&&d(n.charCodeAt(i));)i++;L=i}else P=3;return n.substring(W,L)}function M(){let W="",L=i;for(;;){if(i>=o){W+=n.substring(L,i),P=2;break}const z=n.charCodeAt(i);if(z===34){W+=n.substring(L,i),i++;break}if(z===92){if(W+=n.substring(L,i),i++,i>=o){P=2;break}switch(n.charCodeAt(i++)){case 34:W+='"';break;case 92:W+="\\";break;case 47:W+="/";break;case 98:W+="\b";break;case 102:W+="\f";break;case 110:W+=`
`;break;case 114:W+="\r";break;case 116:W+="	";break;case 117:{const B=l(4);B>=0?W+=String.fromCharCode(B):P=4;break}default:P=5}L=i;continue}if(z>=0&&z<=31)if(D(z)){W+=n.substring(L,i),P=2;break}else P=6;i++}return W}function U(){if(y="",P=0,g=i,i>=o)return g=o,E=17;let W=n.charCodeAt(i);if(u(W)){do i++,y+=String.fromCharCode(W),W=n.charCodeAt(i);while(u(W));return E=15}if(D(W))return i++,y+=String.fromCharCode(W),W===13&&n.charCodeAt(i)===10&&(i++,y+=`
`),E=14;switch(W){case 123:return i++,E=1;case 125:return i++,E=2;case 91:return i++,E=3;case 93:return i++,E=4;case 58:return i++,E=6;case 44:return i++,E=5;case 34:return i++,y=M(),E=10;case 47:{const L=i-1;if(n.charCodeAt(i+1)===47){for(i+=2;i<o&&!D(n.charCodeAt(i));)i++;return y=n.substring(L,i),E=12}if(n.charCodeAt(i+1)===42){i+=2;const z=o-1;let K=!1;for(;i<z;){if(n.charCodeAt(i)===42&&n.charCodeAt(i+1)===47){i+=2,K=!0;break}i++}return K||(i++,P=1),y=n.substring(L,i),E=13}return y+=String.fromCharCode(W),i++,E=16}case 45:if(y+=String.fromCharCode(W),i++,i===o||!d(n.charCodeAt(i)))return E=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return y+=b(),E=11;default:for(;i<o&&F(W);)i++,W=n.charCodeAt(i);if(g!==i){switch(y=n.substring(g,i),y){case"true":return E=8;case"false":return E=9;case"null":return E=7}return E=16}return y+=String.fromCharCode(W),i++,E=16}}function F(W){if(u(W)||D(W))return!1;switch(W){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function q(){let W;do W=U();while(W>=12&&W<=15);return W}return{setPosition:$,getPosition:()=>i,scan:r?q:U,getToken:()=>E,getTokenValue:()=>y,getTokenOffset:()=>g,getTokenLength:()=>i-g,getTokenError:()=>P}}e.$Lm=R;function u(n){return n===32||n===9||n===11||n===12||n===160||n===5760||n>=8192&&n<=8203||n===8239||n===8287||n===12288||n===65279}function D(n){return n===10||n===13||n===8232||n===8233}function d(n){return n>=48&&n<=57}var A;(function(n){n[n.nullCharacter=0]="nullCharacter",n[n.maxAsciiCharacter=127]="maxAsciiCharacter",n[n.lineFeed=10]="lineFeed",n[n.carriageReturn=13]="carriageReturn",n[n.lineSeparator=8232]="lineSeparator",n[n.paragraphSeparator=8233]="paragraphSeparator",n[n.nextLine=133]="nextLine",n[n.space=32]="space",n[n.nonBreakingSpace=160]="nonBreakingSpace",n[n.enQuad=8192]="enQuad",n[n.emQuad=8193]="emQuad",n[n.enSpace=8194]="enSpace",n[n.emSpace=8195]="emSpace",n[n.threePerEmSpace=8196]="threePerEmSpace",n[n.fourPerEmSpace=8197]="fourPerEmSpace",n[n.sixPerEmSpace=8198]="sixPerEmSpace",n[n.figureSpace=8199]="figureSpace",n[n.punctuationSpace=8200]="punctuationSpace",n[n.thinSpace=8201]="thinSpace",n[n.hairSpace=8202]="hairSpace",n[n.zeroWidthSpace=8203]="zeroWidthSpace",n[n.narrowNoBreakSpace=8239]="narrowNoBreakSpace",n[n.ideographicSpace=12288]="ideographicSpace",n[n.mathematicalSpace=8287]="mathematicalSpace",n[n.ogham=5760]="ogham",n[n._=95]="_",n[n.$=36]="$",n[n._0=48]="_0",n[n._1=49]="_1",n[n._2=50]="_2",n[n._3=51]="_3",n[n._4=52]="_4",n[n._5=53]="_5",n[n._6=54]="_6",n[n._7=55]="_7",n[n._8=56]="_8",n[n._9=57]="_9",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.ampersand=38]="ampersand",n[n.asterisk=42]="asterisk",n[n.at=64]="at",n[n.backslash=92]="backslash",n[n.bar=124]="bar",n[n.caret=94]="caret",n[n.closeBrace=125]="closeBrace",n[n.closeBracket=93]="closeBracket",n[n.closeParen=41]="closeParen",n[n.colon=58]="colon",n[n.comma=44]="comma",n[n.dot=46]="dot",n[n.doubleQuote=34]="doubleQuote",n[n.equals=61]="equals",n[n.exclamation=33]="exclamation",n[n.greaterThan=62]="greaterThan",n[n.lessThan=60]="lessThan",n[n.minus=45]="minus",n[n.openBrace=123]="openBrace",n[n.openBracket=91]="openBracket",n[n.openParen=40]="openParen",n[n.percent=37]="percent",n[n.plus=43]="plus",n[n.question=63]="question",n[n.semicolon=59]="semicolon",n[n.singleQuote=39]="singleQuote",n[n.slash=47]="slash",n[n.tilde=126]="tilde",n[n.backspace=8]="backspace",n[n.formFeed=12]="formFeed",n[n.byteOrderMark=65279]="byteOrderMark",n[n.tab=9]="tab",n[n.verticalTab=11]="verticalTab"})(A||(A={}));function k(n,r){const i=[],o=new Object;let y;const g={value:{},offset:0,length:0,type:"object",parent:void 0};let E=!1;function P(l,$,b,M){g.value=l,g.offset=$,g.length=b,g.type=M,g.colonOffset=void 0,y=g}try{v(n,{onObjectBegin:(l,$)=>{if(r<=l)throw o;y=void 0,E=r>l,i.push("")},onObjectProperty:(l,$,b)=>{if(r<$||(P(l,$,b,"property"),i[i.length-1]=l,r<=$+b))throw o},onObjectEnd:(l,$)=>{if(r<=l)throw o;y=void 0,i.pop()},onArrayBegin:(l,$)=>{if(r<=l)throw o;y=void 0,i.push(0)},onArrayEnd:(l,$)=>{if(r<=l)throw o;y=void 0,i.pop()},onLiteralValue:(l,$,b)=>{if(r<$||(P(l,$,b,p(l)),r<=$+b))throw o},onSeparator:(l,$,b)=>{if(r<=$)throw o;if(l===":"&&y&&y.type==="property")y.colonOffset=$,E=!1,y=void 0;else if(l===","){const M=i[i.length-1];typeof M=="number"?i[i.length-1]=M+1:(E=!0,i[i.length-1]=""),y=void 0}}})}catch(l){if(l!==o)throw l}return{path:i,previousNode:y,isAtPropertyKey:E,matches:l=>{let $=0;for(let b=0;$<l.length&&b<i.length;b++)if(l[$]===i[b]||l[$]==="*")$++;else if(l[$]!=="**")return!1;return $===l.length}}}e.$Mm=k;function a(n,r=[],i=O.DEFAULT){let o=null,y=[];const g=[];function E(l){Array.isArray(y)?y.push(l):o!==null&&(y[o]=l)}return v(n,{onObjectBegin:()=>{const l={};E(l),g.push(y),y=l,o=null},onObjectProperty:l=>{o=l},onObjectEnd:()=>{y=g.pop()},onArrayBegin:()=>{const l=[];E(l),g.push(y),y=l,o=null},onArrayEnd:()=>{y=g.pop()},onLiteralValue:E,onError:(l,$,b)=>{r.push({error:l,offset:$,length:b})}},i),y[0]}e.$Nm=a;function w(n,r=[],i=O.DEFAULT){let o={type:"array",offset:-1,length:-1,children:[],parent:void 0};function y(l){o.type==="property"&&(o.length=l-o.offset,o=o.parent)}function g(l){return o.children.push(l),l}v(n,{onObjectBegin:l=>{o=g({type:"object",offset:l,length:-1,parent:o,children:[]})},onObjectProperty:(l,$,b)=>{o=g({type:"property",offset:$,length:-1,parent:o,children:[]}),o.children.push({type:"string",value:l,offset:$,length:b,parent:o})},onObjectEnd:(l,$)=>{o.length=l+$-o.offset,o=o.parent,y(l+$)},onArrayBegin:(l,$)=>{o=g({type:"array",offset:l,length:-1,parent:o,children:[]})},onArrayEnd:(l,$)=>{o.length=l+$-o.offset,o=o.parent,y(l+$)},onLiteralValue:(l,$,b)=>{g({type:p(l),offset:$,length:b,parent:o,value:l}),y($+b)},onSeparator:(l,$,b)=>{o.type==="property"&&(l===":"?o.colonOffset=$:l===","&&y($))},onError:(l,$,b)=>{r.push({error:l,offset:$,length:b})}},i);const P=o.children[0];return P&&delete P.parent,P}e.$Om=w;function m(n,r){if(!n)return;let i=n;for(const o of r)if(typeof o=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let y=!1;for(const g of i.children)if(Array.isArray(g.children)&&g.children[0].value===o){i=g.children[1],y=!0;break}if(!y)return}else{const y=o;if(i.type!=="array"||y<0||!Array.isArray(i.children)||y>=i.children.length)return;i=i.children[y]}return i}e.$Pm=m;function f(n){if(!n.parent||!n.parent.children)return[];const r=f(n.parent);if(n.parent.type==="property"){const i=n.parent.children[0].value;r.push(i)}else if(n.parent.type==="array"){const i=n.parent.children.indexOf(n);i!==-1&&r.push(i)}return r}e.$Qm=f;function t(n){switch(n.type){case"array":return n.children.map(t);case"object":{const r=Object.create(null);for(const i of n.children){const o=i.children[1];o&&(r[i.children[0].value]=t(o))}return r}case"null":case"string":case"number":case"boolean":return n.value;default:return}}e.$Rm=t;function s(n,r,i=!1){return r>=n.offset&&r<n.offset+n.length||i&&r===n.offset+n.length}e.$Sm=s;function c(n,r,i=!1){if(s(n,r,i)){const o=n.children;if(Array.isArray(o))for(let y=0;y<o.length&&o[y].offset<=r;y++){const g=c(o[y],r,i);if(g)return g}return n}}e.$Tm=c;function v(n,r,i=O.DEFAULT){const o=R(n,!1);function y(De){return De?()=>De(o.getTokenOffset(),o.getTokenLength()):()=>!0}function g(De){return De?ue=>De(ue,o.getTokenOffset(),o.getTokenLength()):()=>!0}const E=y(r.onObjectBegin),P=g(r.onObjectProperty),l=y(r.onObjectEnd),$=y(r.onArrayBegin),b=y(r.onArrayEnd),M=g(r.onLiteralValue),U=g(r.onSeparator),F=y(r.onComment),q=g(r.onError),W=i&&i.disallowComments,L=i&&i.allowTrailingComma;function z(){for(;;){const De=o.scan();switch(o.getTokenError()){case 4:K(14);break;case 5:K(15);break;case 3:K(13);break;case 1:W||K(11);break;case 2:K(12);break;case 6:K(16);break}switch(De){case 12:case 13:W?K(10):F();break;case 16:K(1);break;case 15:case 14:break;default:return De}}}function K(De,ue=[],ve=[]){if(q(De),ue.length+ve.length>0){let ke=o.getToken();for(;ke!==17;){if(ue.indexOf(ke)!==-1){z();break}else if(ve.indexOf(ke)!==-1)break;ke=z()}}}function B(De){const ue=o.getTokenValue();return De?M(ue):P(ue),z(),!0}function me(){switch(o.getToken()){case 11:{let De=0;try{De=JSON.parse(o.getTokenValue()),typeof De!="number"&&(K(2),De=0)}catch{K(2)}M(De);break}case 7:M(null);break;case 8:M(!0);break;case 9:M(!1);break;default:return!1}return z(),!0}function ye(){return o.getToken()!==10?(K(3,[],[2,5]),!1):(B(!1),o.getToken()===6?(U(":"),z(),de()||K(4,[],[2,5])):K(5,[],[2,5]),!0)}function Ie(){E(),z();let De=!1;for(;o.getToken()!==2&&o.getToken()!==17;){if(o.getToken()===5){if(De||K(4,[],[]),U(","),z(),o.getToken()===2&&L)break}else De&&K(6,[],[]);ye()||K(4,[],[2,5]),De=!0}return l(),o.getToken()!==2?K(7,[2],[]):z(),!0}function _(){$(),z();let De=!1;for(;o.getToken()!==4&&o.getToken()!==17;){if(o.getToken()===5){if(De||K(4,[],[]),U(","),z(),o.getToken()===4&&L)break}else De&&K(6,[],[]);de()||K(4,[],[4,5]),De=!0}return b(),o.getToken()!==4?K(8,[4],[]):z(),!0}function de(){switch(o.getToken()){case 3:return _();case 1:return Ie();case 10:return B(!0);default:return me()}}return z(),o.getToken()===17?i.allowEmptyContent?!0:(K(4,[],[]),!1):de()?(o.getToken()!==17&&K(9,[],[]),!0):(K(4,[],[]),!1)}e.$Um=v;function S(n,r){const i=R(n),o=[];let y,g=0,E;do switch(E=i.getPosition(),y=i.scan(),y){case 12:case 13:case 17:g!==E&&o.push(n.substring(g,E)),r!==void 0&&o.push(i.getTokenValue().replace(/[^\r\n]/g,r)),g=i.getPosition();break}while(y!==17);return o.join("")}e.$Vm=S;function p(n){switch(typeof n){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(n){if(Array.isArray(n))return"array"}else return"null";return"object"}default:return"null"}}e.$Wm=p}),function(ie,e){typeof define=="function"&&define.amd?define(Ae[116],Re([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(ie=typeof globalThis<"u"?globalThis:ie||self,e(ie.marked={}))}(this,function(ie){"use strict";function e(he,fe){for(var Ee=0;Ee<fe.length;Ee++){var re=fe[Ee];re.enumerable=re.enumerable||!1,re.configurable=!0,"value"in re&&(re.writable=!0),Object.defineProperty(he,re.key,re)}}function h(he,fe,Ee){return fe&&e(he.prototype,fe),Ee&&e(he,Ee),Object.defineProperty(he,"prototype",{writable:!1}),he}function C(he,fe){if(he){if(typeof he=="string")return I(he,fe);var Ee=Object.prototype.toString.call(he).slice(8,-1);if(Ee==="Object"&&he.constructor&&(Ee=he.constructor.name),Ee==="Map"||Ee==="Set")return Array.from(he);if(Ee==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Ee))return I(he,fe)}}function I(he,fe){(fe==null||fe>he.length)&&(fe=he.length);for(var Ee=0,re=new Array(fe);Ee<fe;Ee++)re[Ee]=he[Ee];return re}function O(he,fe){var Ee=typeof Symbol<"u"&&he[Symbol.iterator]||he["@@iterator"];if(Ee)return(Ee=Ee.call(he)).next.bind(Ee);if(Array.isArray(he)||(Ee=C(he))||fe&&he&&typeof he.length=="number"){Ee&&(he=Ee);var re=0;return function(){return re>=he.length?{done:!0}:{done:!1,value:he[re++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function R(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ie.defaults=R();function u(he){ie.defaults=he}var D=/[&<>"']/,d=/[&<>"']/g,A=/[<>"']|&(?!#?\w+;)/,k=/[<>"']|&(?!#?\w+;)/g,a={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},w=function(fe){return a[fe]};function m(he,fe){if(fe){if(D.test(he))return he.replace(d,w)}else if(A.test(he))return he.replace(k,w);return he}var f=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function t(he){return he.replace(f,function(fe,Ee){return Ee=Ee.toLowerCase(),Ee==="colon"?":":Ee.charAt(0)==="#"?Ee.charAt(1)==="x"?String.fromCharCode(parseInt(Ee.substring(2),16)):String.fromCharCode(+Ee.substring(1)):""})}var s=/(^|[^\[])\^/g;function c(he,fe){he=typeof he=="string"?he:he.source,fe=fe||"";var Ee={replace:function(le,oe){return oe=oe.source||oe,oe=oe.replace(s,"$1"),he=he.replace(le,oe),Ee},getRegex:function(){return new RegExp(he,fe)}};return Ee}var v=/[^\w:]/g,S=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function p(he,fe,Ee){if(he){var re;try{re=decodeURIComponent(t(Ee)).replace(v,"").toLowerCase()}catch{return null}if(re.indexOf("javascript:")===0||re.indexOf("vbscript:")===0||re.indexOf("data:")===0)return null}fe&&!S.test(Ee)&&(Ee=y(fe,Ee));try{Ee=encodeURI(Ee).replace(/%25/g,"%")}catch{return null}return Ee}var n={},r=/^[^:]+:\/*[^/]*$/,i=/^([^:]+:)[\s\S]*$/,o=/^([^:]+:\/*[^/]*)[\s\S]*$/;function y(he,fe){n[" "+he]||(r.test(he)?n[" "+he]=he+"/":n[" "+he]=l(he,"/",!0)),he=n[" "+he];var Ee=he.indexOf(":")===-1;return fe.substring(0,2)==="//"?Ee?fe:he.replace(i,"$1")+fe:fe.charAt(0)==="/"?Ee?fe:he.replace(o,"$1")+fe:he+fe}var g={exec:function(){}};function E(he){for(var fe=1,Ee,re;fe<arguments.length;fe++){Ee=arguments[fe];for(re in Ee)Object.prototype.hasOwnProperty.call(Ee,re)&&(he[re]=Ee[re])}return he}function P(he,fe){var Ee=he.replace(/\|/g,function(oe,ae,pe){for(var Ce=!1,T=ae;--T>=0&&pe[T]==="\\";)Ce=!Ce;return Ce?"|":" |"}),re=Ee.split(/ \|/),le=0;if(re[0].trim()||re.shift(),re.length>0&&!re[re.length-1].trim()&&re.pop(),re.length>fe)re.splice(fe);else for(;re.length<fe;)re.push("");for(;le<re.length;le++)re[le]=re[le].trim().replace(/\\\|/g,"|");return re}function l(he,fe,Ee){var re=he.length;if(re===0)return"";for(var le=0;le<re;){var oe=he.charAt(re-le-1);if(oe===fe&&!Ee)le++;else if(oe!==fe&&Ee)le++;else break}return he.slice(0,re-le)}function $(he,fe){if(he.indexOf(fe[1])===-1)return-1;for(var Ee=he.length,re=0,le=0;le<Ee;le++)if(he[le]==="\\")le++;else if(he[le]===fe[0])re++;else if(he[le]===fe[1]&&(re--,re<0))return le;return-1}function b(he){he&&he.sanitize&&!he.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function M(he,fe){if(fe<1)return"";for(var Ee="";fe>1;)fe&1&&(Ee+=he),fe>>=1,he+=he;return Ee+he}function U(he,fe,Ee,re){var le=fe.href,oe=fe.title?m(fe.title):null,ae=he[1].replace(/\\([\[\]])/g,"$1");if(he[0].charAt(0)!=="!"){re.state.inLink=!0;var pe={type:"link",raw:Ee,href:le,title:oe,text:ae,tokens:re.inlineTokens(ae)};return re.state.inLink=!1,pe}return{type:"image",raw:Ee,href:le,title:oe,text:m(ae)}}function F(he,fe){var Ee=he.match(/^(\s+)(?:```)/);if(Ee===null)return fe;var re=Ee[1];return fe.split(`
`).map(function(le){var oe=le.match(/^\s+/);if(oe===null)return le;var ae=oe[0];return ae.length>=re.length?le.slice(re.length):le}).join(`
`)}var q=function(){function he(Ee){this.options=Ee||ie.defaults}var fe=he.prototype;return fe.space=function(re){var le=this.rules.block.newline.exec(re);if(le&&le[0].length>0)return{type:"space",raw:le[0]}},fe.code=function(re){var le=this.rules.block.code.exec(re);if(le){var oe=le[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:le[0],codeBlockStyle:"indented",text:this.options.pedantic?oe:l(oe,`
`)}}},fe.fences=function(re){var le=this.rules.block.fences.exec(re);if(le){var oe=le[0],ae=F(oe,le[3]||"");return{type:"code",raw:oe,lang:le[2]?le[2].trim():le[2],text:ae}}},fe.heading=function(re){var le=this.rules.block.heading.exec(re);if(le){var oe=le[2].trim();if(/#$/.test(oe)){var ae=l(oe,"#");(this.options.pedantic||!ae||/ $/.test(ae))&&(oe=ae.trim())}return{type:"heading",raw:le[0],depth:le[1].length,text:oe,tokens:this.lexer.inline(oe)}}},fe.hr=function(re){var le=this.rules.block.hr.exec(re);if(le)return{type:"hr",raw:le[0]}},fe.blockquote=function(re){var le=this.rules.block.blockquote.exec(re);if(le){var oe=le[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:le[0],tokens:this.lexer.blockTokens(oe,[]),text:oe}}},fe.list=function(re){var le=this.rules.block.list.exec(re);if(le){var oe,ae,pe,Ce,T,H,X,Y,J,te,se,Fe,je=le[1].trim(),Xe=je.length>1,He={type:"list",raw:"",ordered:Xe,start:Xe?+je.slice(0,-1):"",loose:!1,items:[]};je=Xe?"\\d{1,9}\\"+je.slice(-1):"\\"+je,this.options.pedantic&&(je=Xe?je:"[*+-]");for(var et=new RegExp("^( {0,3}"+je+")((?:[	 ][^\\n]*)?(?:\\n|$))");re&&(Fe=!1,!(!(le=et.exec(re))||this.rules.block.hr.test(re)));){if(oe=le[0],re=re.substring(oe.length),Y=le[2].split(`
`,1)[0],J=re.split(`
`,1)[0],this.options.pedantic?(Ce=2,se=Y.trimLeft()):(Ce=le[2].search(/[^ ]/),Ce=Ce>4?1:Ce,se=Y.slice(Ce),Ce+=le[1].length),H=!1,!Y&&/^ *$/.test(J)&&(oe+=J+`
`,re=re.substring(J.length+1),Fe=!0),!Fe)for(var xe=new RegExp("^ {0,"+Math.min(3,Ce-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),it=new RegExp("^ {0,"+Math.min(3,Ce-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),st=new RegExp("^ {0,"+Math.min(3,Ce-1)+"}(?:```|~~~)"),nt=new RegExp("^ {0,"+Math.min(3,Ce-1)+"}#");re&&(te=re.split(`
`,1)[0],Y=te,this.options.pedantic&&(Y=Y.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(st.test(Y)||nt.test(Y)||xe.test(Y)||it.test(re)));){if(Y.search(/[^ ]/)>=Ce||!Y.trim())se+=`
`+Y.slice(Ce);else if(!H)se+=`
`+Y;else break;!H&&!Y.trim()&&(H=!0),oe+=te+`
`,re=re.substring(te.length+1)}He.loose||(X?He.loose=!0:/\n *\n *$/.test(oe)&&(X=!0)),this.options.gfm&&(ae=/^\[[ xX]\] /.exec(se),ae&&(pe=ae[0]!=="[ ] ",se=se.replace(/^\[[ xX]\] +/,""))),He.items.push({type:"list_item",raw:oe,task:!!ae,checked:pe,loose:!1,text:se}),He.raw+=oe}He.items[He.items.length-1].raw=oe.trimRight(),He.items[He.items.length-1].text=se.trimRight(),He.raw=He.raw.trimRight();var Ue=He.items.length;for(T=0;T<Ue;T++){this.lexer.state.top=!1,He.items[T].tokens=this.lexer.blockTokens(He.items[T].text,[]);var ot=He.items[T].tokens.filter(function(Z){return Z.type==="space"}),x=ot.every(function(Z){for(var we=Z.raw.split(""),We=0,ze=O(we),Ze;!(Ze=ze()).done;){var at=Ze.value;if(at===`
`&&(We+=1),We>1)return!0}return!1});!He.loose&&ot.length&&x&&(He.loose=!0,He.items[T].loose=!0)}return He}},fe.html=function(re){var le=this.rules.block.html.exec(re);if(le){var oe={type:"html",raw:le[0],pre:!this.options.sanitizer&&(le[1]==="pre"||le[1]==="script"||le[1]==="style"),text:le[0]};if(this.options.sanitize){var ae=this.options.sanitizer?this.options.sanitizer(le[0]):m(le[0]);oe.type="paragraph",oe.text=ae,oe.tokens=this.lexer.inline(ae)}return oe}},fe.def=function(re){var le=this.rules.block.def.exec(re);if(le){le[3]&&(le[3]=le[3].substring(1,le[3].length-1));var oe=le[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:oe,raw:le[0],href:le[2],title:le[3]}}},fe.table=function(re){var le=this.rules.block.table.exec(re);if(le){var oe={type:"table",header:P(le[1]).map(function(X){return{text:X}}),align:le[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:le[3]&&le[3].trim()?le[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(oe.header.length===oe.align.length){oe.raw=le[0];var ae=oe.align.length,pe,Ce,T,H;for(pe=0;pe<ae;pe++)/^ *-+: *$/.test(oe.align[pe])?oe.align[pe]="right":/^ *:-+: *$/.test(oe.align[pe])?oe.align[pe]="center":/^ *:-+ *$/.test(oe.align[pe])?oe.align[pe]="left":oe.align[pe]=null;for(ae=oe.rows.length,pe=0;pe<ae;pe++)oe.rows[pe]=P(oe.rows[pe],oe.header.length).map(function(X){return{text:X}});for(ae=oe.header.length,Ce=0;Ce<ae;Ce++)oe.header[Ce].tokens=this.lexer.inline(oe.header[Ce].text);for(ae=oe.rows.length,Ce=0;Ce<ae;Ce++)for(H=oe.rows[Ce],T=0;T<H.length;T++)H[T].tokens=this.lexer.inline(H[T].text);return oe}}},fe.lheading=function(re){var le=this.rules.block.lheading.exec(re);if(le)return{type:"heading",raw:le[0],depth:le[2].charAt(0)==="="?1:2,text:le[1],tokens:this.lexer.inline(le[1])}},fe.paragraph=function(re){var le=this.rules.block.paragraph.exec(re);if(le){var oe=le[1].charAt(le[1].length-1)===`
`?le[1].slice(0,-1):le[1];return{type:"paragraph",raw:le[0],text:oe,tokens:this.lexer.inline(oe)}}},fe.text=function(re){var le=this.rules.block.text.exec(re);if(le)return{type:"text",raw:le[0],text:le[0],tokens:this.lexer.inline(le[0])}},fe.escape=function(re){var le=this.rules.inline.escape.exec(re);if(le)return{type:"escape",raw:le[0],text:m(le[1])}},fe.tag=function(re){var le=this.rules.inline.tag.exec(re);if(le)return!this.lexer.state.inLink&&/^<a /i.test(le[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(le[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(le[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(le[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:le[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(le[0]):m(le[0]):le[0]}},fe.link=function(re){var le=this.rules.inline.link.exec(re);if(le){var oe=le[2].trim();if(!this.options.pedantic&&/^</.test(oe)){if(!/>$/.test(oe))return;var ae=l(oe.slice(0,-1),"\\");if((oe.length-ae.length)%2===0)return}else{var pe=$(le[2],"()");if(pe>-1){var Ce=le[0].indexOf("!")===0?5:4,T=Ce+le[1].length+pe;le[2]=le[2].substring(0,pe),le[0]=le[0].substring(0,T).trim(),le[3]=""}}var H=le[2],X="";if(this.options.pedantic){var Y=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(H);Y&&(H=Y[1],X=Y[3])}else X=le[3]?le[3].slice(1,-1):"";return H=H.trim(),/^</.test(H)&&(this.options.pedantic&&!/>$/.test(oe)?H=H.slice(1):H=H.slice(1,-1)),U(le,{href:H&&H.replace(this.rules.inline._escapes,"$1"),title:X&&X.replace(this.rules.inline._escapes,"$1")},le[0],this.lexer)}},fe.reflink=function(re,le){var oe;if((oe=this.rules.inline.reflink.exec(re))||(oe=this.rules.inline.nolink.exec(re))){var ae=(oe[2]||oe[1]).replace(/\s+/g," ");if(ae=le[ae.toLowerCase()],!ae||!ae.href){var pe=oe[0].charAt(0);return{type:"text",raw:pe,text:pe}}return U(oe,ae,oe[0],this.lexer)}},fe.emStrong=function(re,le,oe){oe===void 0&&(oe="");var ae=this.rules.inline.emStrong.lDelim.exec(re);if(ae&&!(ae[3]&&oe.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var pe=ae[1]||ae[2]||"";if(!pe||pe&&(oe===""||this.rules.inline.punctuation.exec(oe))){var Ce=ae[0].length-1,T,H,X=Ce,Y=0,J=ae[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(J.lastIndex=0,le=le.slice(-1*re.length+Ce);(ae=J.exec(le))!=null;)if(T=ae[1]||ae[2]||ae[3]||ae[4]||ae[5]||ae[6],!!T){if(H=T.length,ae[3]||ae[4]){X+=H;continue}else if((ae[5]||ae[6])&&Ce%3&&!((Ce+H)%3)){Y+=H;continue}if(X-=H,!(X>0)){if(H=Math.min(H,H+X+Y),Math.min(Ce,H)%2){var te=re.slice(1,Ce+ae.index+H);return{type:"em",raw:re.slice(0,Ce+ae.index+H+1),text:te,tokens:this.lexer.inlineTokens(te)}}var se=re.slice(2,Ce+ae.index+H-1);return{type:"strong",raw:re.slice(0,Ce+ae.index+H+1),text:se,tokens:this.lexer.inlineTokens(se)}}}}}},fe.codespan=function(re){var le=this.rules.inline.code.exec(re);if(le){var oe=le[2].replace(/\n/g," "),ae=/[^ ]/.test(oe),pe=/^ /.test(oe)&&/ $/.test(oe);return ae&&pe&&(oe=oe.substring(1,oe.length-1)),oe=m(oe,!0),{type:"codespan",raw:le[0],text:oe}}},fe.br=function(re){var le=this.rules.inline.br.exec(re);if(le)return{type:"br",raw:le[0]}},fe.del=function(re){var le=this.rules.inline.del.exec(re);if(le)return{type:"del",raw:le[0],text:le[2],tokens:this.lexer.inlineTokens(le[2])}},fe.autolink=function(re,le){var oe=this.rules.inline.autolink.exec(re);if(oe){var ae,pe;return oe[2]==="@"?(ae=m(this.options.mangle?le(oe[1]):oe[1]),pe="mailto:"+ae):(ae=m(oe[1]),pe=ae),{type:"link",raw:oe[0],text:ae,href:pe,tokens:[{type:"text",raw:ae,text:ae}]}}},fe.url=function(re,le){var oe;if(oe=this.rules.inline.url.exec(re)){var ae,pe;if(oe[2]==="@")ae=m(this.options.mangle?le(oe[0]):oe[0]),pe="mailto:"+ae;else{var Ce;do Ce=oe[0],oe[0]=this.rules.inline._backpedal.exec(oe[0])[0];while(Ce!==oe[0]);ae=m(oe[0]),oe[1]==="www."?pe="http://"+ae:pe=ae}return{type:"link",raw:oe[0],text:ae,href:pe,tokens:[{type:"text",raw:ae,text:ae}]}}},fe.inlineText=function(re,le){var oe=this.rules.inline.text.exec(re);if(oe){var ae;return this.lexer.state.inRawBlock?ae=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(oe[0]):m(oe[0]):oe[0]:ae=m(this.options.smartypants?le(oe[0]):oe[0]),{type:"text",raw:oe[0],text:ae}}},he}(),W={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:g,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};W._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,W._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,W.def=c(W.def).replace("label",W._label).replace("title",W._title).getRegex(),W.bullet=/(?:[*+-]|\d{1,9}[.)])/,W.listItemStart=c(/^( *)(bull) */).replace("bull",W.bullet).getRegex(),W.list=c(W.list).replace(/bull/g,W.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+W.def.source+")").getRegex(),W._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",W._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,W.html=c(W.html,"i").replace("comment",W._comment).replace("tag",W._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),W.paragraph=c(W._paragraph).replace("hr",W.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",W._tag).getRegex(),W.blockquote=c(W.blockquote).replace("paragraph",W.paragraph).getRegex(),W.normal=E({},W),W.gfm=E({},W.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),W.gfm.table=c(W.gfm.table).replace("hr",W.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",W._tag).getRegex(),W.gfm.paragraph=c(W._paragraph).replace("hr",W.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",W.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",W._tag).getRegex(),W.pedantic=E({},W.normal,{html:c(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",W._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:g,paragraph:c(W.normal._paragraph).replace("hr",W.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",W.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var L={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:g,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:g,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};L._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",L.punctuation=c(L.punctuation).replace(/punctuation/g,L._punctuation).getRegex(),L.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,L.escapedEmSt=/\\\*|\\_/g,L._comment=c(W._comment).replace("(?:-->|$)","-->").getRegex(),L.emStrong.lDelim=c(L.emStrong.lDelim).replace(/punct/g,L._punctuation).getRegex(),L.emStrong.rDelimAst=c(L.emStrong.rDelimAst,"g").replace(/punct/g,L._punctuation).getRegex(),L.emStrong.rDelimUnd=c(L.emStrong.rDelimUnd,"g").replace(/punct/g,L._punctuation).getRegex(),L._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,L._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,L._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,L.autolink=c(L.autolink).replace("scheme",L._scheme).replace("email",L._email).getRegex(),L._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,L.tag=c(L.tag).replace("comment",L._comment).replace("attribute",L._attribute).getRegex(),L._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,L._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,L._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,L.link=c(L.link).replace("label",L._label).replace("href",L._href).replace("title",L._title).getRegex(),L.reflink=c(L.reflink).replace("label",L._label).replace("ref",W._label).getRegex(),L.nolink=c(L.nolink).replace("ref",W._label).getRegex(),L.reflinkSearch=c(L.reflinkSearch,"g").replace("reflink",L.reflink).replace("nolink",L.nolink).getRegex(),L.normal=E({},L),L.pedantic=E({},L.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:c(/^!?\[(label)\]\((.*?)\)/).replace("label",L._label).getRegex(),reflink:c(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",L._label).getRegex()}),L.gfm=E({},L.normal,{escape:c(L.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),L.gfm.url=c(L.gfm.url,"i").replace("email",L.gfm._extended_email).getRegex(),L.breaks=E({},L.gfm,{br:c(L.br).replace("{2,}","*").getRegex(),text:c(L.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function z(he){return he.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function K(he){var fe="",Ee,re,le=he.length;for(Ee=0;Ee<le;Ee++)re=he.charCodeAt(Ee),Math.random()>.5&&(re="x"+re.toString(16)),fe+="&#"+re+";";return fe}var B=function(){function he(Ee){this.tokens=[],this.tokens.links=Object.create(null),this.options=Ee||ie.defaults,this.options.tokenizer=this.options.tokenizer||new q,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var re={block:W.normal,inline:L.normal};this.options.pedantic?(re.block=W.pedantic,re.inline=L.pedantic):this.options.gfm&&(re.block=W.gfm,this.options.breaks?re.inline=L.breaks:re.inline=L.gfm),this.tokenizer.rules=re}he.lex=function(re,le){var oe=new he(le);return oe.lex(re)},he.lexInline=function(re,le){var oe=new he(le);return oe.inlineTokens(re)};var fe=he.prototype;return fe.lex=function(re){re=re.replace(/\r\n|\r/g,`
`),this.blockTokens(re,this.tokens);for(var le;le=this.inlineQueue.shift();)this.inlineTokens(le.src,le.tokens);return this.tokens},fe.blockTokens=function(re,le){var oe=this;le===void 0&&(le=[]),this.options.pedantic?re=re.replace(/\t/g,"    ").replace(/^ +$/gm,""):re=re.replace(/^( *)(\t+)/gm,function(X,Y,J){return Y+"    ".repeat(J.length)});for(var ae,pe,Ce,T;re;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(X){return(ae=X.call({lexer:oe},re,le))?(re=re.substring(ae.raw.length),le.push(ae),!0):!1}))){if(ae=this.tokenizer.space(re)){re=re.substring(ae.raw.length),ae.raw.length===1&&le.length>0?le[le.length-1].raw+=`
`:le.push(ae);continue}if(ae=this.tokenizer.code(re)){re=re.substring(ae.raw.length),pe=le[le.length-1],pe&&(pe.type==="paragraph"||pe.type==="text")?(pe.raw+=`
`+ae.raw,pe.text+=`
`+ae.text,this.inlineQueue[this.inlineQueue.length-1].src=pe.text):le.push(ae);continue}if(ae=this.tokenizer.fences(re)){re=re.substring(ae.raw.length),le.push(ae);continue}if(ae=this.tokenizer.heading(re)){re=re.substring(ae.raw.length),le.push(ae);continue}if(ae=this.tokenizer.hr(re)){re=re.substring(ae.raw.length),le.push(ae);continue}if(ae=this.tokenizer.blockquote(re)){re=re.substring(ae.raw.length),le.push(ae);continue}if(ae=this.tokenizer.list(re)){re=re.substring(ae.raw.length),le.push(ae);continue}if(ae=this.tokenizer.html(re)){re=re.substring(ae.raw.length),le.push(ae);continue}if(ae=this.tokenizer.def(re)){re=re.substring(ae.raw.length),pe=le[le.length-1],pe&&(pe.type==="paragraph"||pe.type==="text")?(pe.raw+=`
`+ae.raw,pe.text+=`
`+ae.raw,this.inlineQueue[this.inlineQueue.length-1].src=pe.text):this.tokens.links[ae.tag]||(this.tokens.links[ae.tag]={href:ae.href,title:ae.title});continue}if(ae=this.tokenizer.table(re)){re=re.substring(ae.raw.length),le.push(ae);continue}if(ae=this.tokenizer.lheading(re)){re=re.substring(ae.raw.length),le.push(ae);continue}if(Ce=re,this.options.extensions&&this.options.extensions.startBlock&&function(){var X=1/0,Y=re.slice(1),J=void 0;oe.options.extensions.startBlock.forEach(function(te){J=te.call({lexer:this},Y),typeof J=="number"&&J>=0&&(X=Math.min(X,J))}),X<1/0&&X>=0&&(Ce=re.substring(0,X+1))}(),this.state.top&&(ae=this.tokenizer.paragraph(Ce))){pe=le[le.length-1],T&&pe.type==="paragraph"?(pe.raw+=`
`+ae.raw,pe.text+=`
`+ae.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=pe.text):le.push(ae),T=Ce.length!==re.length,re=re.substring(ae.raw.length);continue}if(ae=this.tokenizer.text(re)){re=re.substring(ae.raw.length),pe=le[le.length-1],pe&&pe.type==="text"?(pe.raw+=`
`+ae.raw,pe.text+=`
`+ae.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=pe.text):le.push(ae);continue}if(re){var H="Infinite loop on byte: "+re.charCodeAt(0);if(this.options.silent){console.error(H);break}else throw new Error(H)}}return this.state.top=!0,le},fe.inline=function(re,le){return le===void 0&&(le=[]),this.inlineQueue.push({src:re,tokens:le}),le},fe.inlineTokens=function(re,le){var oe=this;le===void 0&&(le=[]);var ae,pe,Ce,T=re,H,X,Y;if(this.tokens.links){var J=Object.keys(this.tokens.links);if(J.length>0)for(;(H=this.tokenizer.rules.inline.reflinkSearch.exec(T))!=null;)J.includes(H[0].slice(H[0].lastIndexOf("[")+1,-1))&&(T=T.slice(0,H.index)+"["+M("a",H[0].length-2)+"]"+T.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(H=this.tokenizer.rules.inline.blockSkip.exec(T))!=null;)T=T.slice(0,H.index)+"["+M("a",H[0].length-2)+"]"+T.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(H=this.tokenizer.rules.inline.escapedEmSt.exec(T))!=null;)T=T.slice(0,H.index)+"++"+T.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;re;)if(X||(Y=""),X=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(se){return(ae=se.call({lexer:oe},re,le))?(re=re.substring(ae.raw.length),le.push(ae),!0):!1}))){if(ae=this.tokenizer.escape(re)){re=re.substring(ae.raw.length),le.push(ae);continue}if(ae=this.tokenizer.tag(re)){re=re.substring(ae.raw.length),pe=le[le.length-1],pe&&ae.type==="text"&&pe.type==="text"?(pe.raw+=ae.raw,pe.text+=ae.text):le.push(ae);continue}if(ae=this.tokenizer.link(re)){re=re.substring(ae.raw.length),le.push(ae);continue}if(ae=this.tokenizer.reflink(re,this.tokens.links)){re=re.substring(ae.raw.length),pe=le[le.length-1],pe&&ae.type==="text"&&pe.type==="text"?(pe.raw+=ae.raw,pe.text+=ae.text):le.push(ae);continue}if(ae=this.tokenizer.emStrong(re,T,Y)){re=re.substring(ae.raw.length),le.push(ae);continue}if(ae=this.tokenizer.codespan(re)){re=re.substring(ae.raw.length),le.push(ae);continue}if(ae=this.tokenizer.br(re)){re=re.substring(ae.raw.length),le.push(ae);continue}if(ae=this.tokenizer.del(re)){re=re.substring(ae.raw.length),le.push(ae);continue}if(ae=this.tokenizer.autolink(re,K)){re=re.substring(ae.raw.length),le.push(ae);continue}if(!this.state.inLink&&(ae=this.tokenizer.url(re,K))){re=re.substring(ae.raw.length),le.push(ae);continue}if(Ce=re,this.options.extensions&&this.options.extensions.startInline&&function(){var se=1/0,Fe=re.slice(1),je=void 0;oe.options.extensions.startInline.forEach(function(Xe){je=Xe.call({lexer:this},Fe),typeof je=="number"&&je>=0&&(se=Math.min(se,je))}),se<1/0&&se>=0&&(Ce=re.substring(0,se+1))}(),ae=this.tokenizer.inlineText(Ce,z)){re=re.substring(ae.raw.length),ae.raw.slice(-1)!=="_"&&(Y=ae.raw.slice(-1)),X=!0,pe=le[le.length-1],pe&&pe.type==="text"?(pe.raw+=ae.raw,pe.text+=ae.text):le.push(ae);continue}if(re){var te="Infinite loop on byte: "+re.charCodeAt(0);if(this.options.silent){console.error(te);break}else throw new Error(te)}}return le},h(he,null,[{key:"rules",get:function(){return{block:W,inline:L}}}]),he}(),me=function(){function he(Ee){this.options=Ee||ie.defaults}var fe=he.prototype;return fe.code=function(re,le,oe){var ae=(le||"").match(/\S*/)[0];if(this.options.highlight){var pe=this.options.highlight(re,ae);pe!=null&&pe!==re&&(oe=!0,re=pe)}return re=re.replace(/\n$/,"")+`
`,ae?'<pre><code class="'+this.options.langPrefix+m(ae,!0)+'">'+(oe?re:m(re,!0))+`</code></pre>
`:"<pre><code>"+(oe?re:m(re,!0))+`</code></pre>
`},fe.blockquote=function(re){return`<blockquote>
`+re+`</blockquote>
`},fe.html=function(re){return re},fe.heading=function(re,le,oe,ae){if(this.options.headerIds){var pe=this.options.headerPrefix+ae.slug(oe);return"<h"+le+' id="'+pe+'">'+re+"</h"+le+`>
`}return"<h"+le+">"+re+"</h"+le+`>
`},fe.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},fe.list=function(re,le,oe){var ae=le?"ol":"ul",pe=le&&oe!==1?' start="'+oe+'"':"";return"<"+ae+pe+`>
`+re+"</"+ae+`>
`},fe.listitem=function(re){return"<li>"+re+`</li>
`},fe.checkbox=function(re){return"<input "+(re?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},fe.paragraph=function(re){return"<p>"+re+`</p>
`},fe.table=function(re,le){return le&&(le="<tbody>"+le+"</tbody>"),`<table>
<thead>
`+re+`</thead>
`+le+`</table>
`},fe.tablerow=function(re){return`<tr>
`+re+`</tr>
`},fe.tablecell=function(re,le){var oe=le.header?"th":"td",ae=le.align?"<"+oe+' align="'+le.align+'">':"<"+oe+">";return ae+re+("</"+oe+`>
`)},fe.strong=function(re){return"<strong>"+re+"</strong>"},fe.em=function(re){return"<em>"+re+"</em>"},fe.codespan=function(re){return"<code>"+re+"</code>"},fe.br=function(){return this.options.xhtml?"<br/>":"<br>"},fe.del=function(re){return"<del>"+re+"</del>"},fe.link=function(re,le,oe){if(re=p(this.options.sanitize,this.options.baseUrl,re),re===null)return oe;var ae='<a href="'+m(re)+'"';return le&&(ae+=' title="'+le+'"'),ae+=">"+oe+"</a>",ae},fe.image=function(re,le,oe){if(re=p(this.options.sanitize,this.options.baseUrl,re),re===null)return oe;var ae='<img src="'+re+'" alt="'+oe+'"';return le&&(ae+=' title="'+le+'"'),ae+=this.options.xhtml?"/>":">",ae},fe.text=function(re){return re},he}(),ye=function(){function he(){}var fe=he.prototype;return fe.strong=function(re){return re},fe.em=function(re){return re},fe.codespan=function(re){return re},fe.del=function(re){return re},fe.html=function(re){return re},fe.text=function(re){return re},fe.link=function(re,le,oe){return""+oe},fe.image=function(re,le,oe){return""+oe},fe.br=function(){return""},he}(),Ie=function(){function he(){this.seen={}}var fe=he.prototype;return fe.serialize=function(re){return re.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},fe.getNextSafeSlug=function(re,le){var oe=re,ae=0;if(this.seen.hasOwnProperty(oe)){ae=this.seen[re];do ae++,oe=re+"-"+ae;while(this.seen.hasOwnProperty(oe))}return le||(this.seen[re]=ae,this.seen[oe]=0),oe},fe.slug=function(re,le){le===void 0&&(le={});var oe=this.serialize(re);return this.getNextSafeSlug(oe,le.dryrun)},he}(),_=function(){function he(Ee){this.options=Ee||ie.defaults,this.options.renderer=this.options.renderer||new me,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new ye,this.slugger=new Ie}he.parse=function(re,le){var oe=new he(le);return oe.parse(re)},he.parseInline=function(re,le){var oe=new he(le);return oe.parseInline(re)};var fe=he.prototype;return fe.parse=function(re,le){le===void 0&&(le=!0);var oe="",ae,pe,Ce,T,H,X,Y,J,te,se,Fe,je,Xe,He,et,xe,it,st,nt,Ue=re.length;for(ae=0;ae<Ue;ae++){if(se=re[ae],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[se.type]&&(nt=this.options.extensions.renderers[se.type].call({parser:this},se),nt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(se.type))){oe+=nt||"";continue}switch(se.type){case"space":continue;case"hr":{oe+=this.renderer.hr();continue}case"heading":{oe+=this.renderer.heading(this.parseInline(se.tokens),se.depth,t(this.parseInline(se.tokens,this.textRenderer)),this.slugger);continue}case"code":{oe+=this.renderer.code(se.text,se.lang,se.escaped);continue}case"table":{for(J="",Y="",T=se.header.length,pe=0;pe<T;pe++)Y+=this.renderer.tablecell(this.parseInline(se.header[pe].tokens),{header:!0,align:se.align[pe]});for(J+=this.renderer.tablerow(Y),te="",T=se.rows.length,pe=0;pe<T;pe++){for(X=se.rows[pe],Y="",H=X.length,Ce=0;Ce<H;Ce++)Y+=this.renderer.tablecell(this.parseInline(X[Ce].tokens),{header:!1,align:se.align[Ce]});te+=this.renderer.tablerow(Y)}oe+=this.renderer.table(J,te);continue}case"blockquote":{te=this.parse(se.tokens),oe+=this.renderer.blockquote(te);continue}case"list":{for(Fe=se.ordered,je=se.start,Xe=se.loose,T=se.items.length,te="",pe=0;pe<T;pe++)et=se.items[pe],xe=et.checked,it=et.task,He="",et.task&&(st=this.renderer.checkbox(xe),Xe?et.tokens.length>0&&et.tokens[0].type==="paragraph"?(et.tokens[0].text=st+" "+et.tokens[0].text,et.tokens[0].tokens&&et.tokens[0].tokens.length>0&&et.tokens[0].tokens[0].type==="text"&&(et.tokens[0].tokens[0].text=st+" "+et.tokens[0].tokens[0].text)):et.tokens.unshift({type:"text",text:st}):He+=st),He+=this.parse(et.tokens,Xe),te+=this.renderer.listitem(He,it,xe);oe+=this.renderer.list(te,Fe,je);continue}case"html":{oe+=this.renderer.html(se.text);continue}case"paragraph":{oe+=this.renderer.paragraph(this.parseInline(se.tokens));continue}case"text":{for(te=se.tokens?this.parseInline(se.tokens):se.text;ae+1<Ue&&re[ae+1].type==="text";)se=re[++ae],te+=`
`+(se.tokens?this.parseInline(se.tokens):se.text);oe+=le?this.renderer.paragraph(te):te;continue}default:{var ot='Token with "'+se.type+'" type was not found.';if(this.options.silent){console.error(ot);return}else throw new Error(ot)}}}return oe},fe.parseInline=function(re,le){le=le||this.renderer;var oe="",ae,pe,Ce,T=re.length;for(ae=0;ae<T;ae++){if(pe=re[ae],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[pe.type]&&(Ce=this.options.extensions.renderers[pe.type].call({parser:this},pe),Ce!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(pe.type))){oe+=Ce||"";continue}switch(pe.type){case"escape":{oe+=le.text(pe.text);break}case"html":{oe+=le.html(pe.text);break}case"link":{oe+=le.link(pe.href,pe.title,this.parseInline(pe.tokens,le));break}case"image":{oe+=le.image(pe.href,pe.title,pe.text);break}case"strong":{oe+=le.strong(this.parseInline(pe.tokens,le));break}case"em":{oe+=le.em(this.parseInline(pe.tokens,le));break}case"codespan":{oe+=le.codespan(pe.text);break}case"br":{oe+=le.br();break}case"del":{oe+=le.del(this.parseInline(pe.tokens,le));break}case"text":{oe+=le.text(pe.text);break}default:{var H='Token with "'+pe.type+'" type was not found.';if(this.options.silent){console.error(H);return}else throw new Error(H)}}}return oe},he}();function de(he,fe,Ee){if(typeof he>"u"||he===null)throw new Error("marked(): input parameter is undefined or null");if(typeof he!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(he)+", string expected");if(typeof fe=="function"&&(Ee=fe,fe=null),fe=E({},de.defaults,fe||{}),b(fe),Ee){var re=fe.highlight,le;try{le=B.lex(he,fe)}catch(T){return Ee(T)}var oe=function(H){var X;if(!H)try{fe.walkTokens&&de.walkTokens(le,fe.walkTokens),X=_.parse(le,fe)}catch(Y){H=Y}return fe.highlight=re,H?Ee(H):Ee(null,X)};if(!re||re.length<3||(delete fe.highlight,!le.length))return oe();var ae=0;de.walkTokens(le,function(T){T.type==="code"&&(ae++,setTimeout(function(){re(T.text,T.lang,function(H,X){if(H)return oe(H);X!=null&&X!==T.text&&(T.text=X,T.escaped=!0),ae--,ae===0&&oe()})},0))}),ae===0&&oe();return}function pe(T){if(T.message+=`
Please report this to https://github.com/markedjs/marked.`,fe.silent)return"<p>An error occurred:</p><pre>"+m(T.message+"",!0)+"</pre>";throw T}try{var Ce=B.lex(he,fe);if(fe.walkTokens){if(fe.async)return Promise.all(de.walkTokens(Ce,fe.walkTokens)).then(function(){return _.parse(Ce,fe)}).catch(pe);de.walkTokens(Ce,fe.walkTokens)}return _.parse(Ce,fe)}catch(T){pe(T)}}de.options=de.setOptions=function(he){return E(de.defaults,he),u(de.defaults),de},de.getDefaults=R,de.defaults=ie.defaults,de.use=function(){for(var he=arguments.length,fe=new Array(he),Ee=0;Ee<he;Ee++)fe[Ee]=arguments[Ee];var re=E.apply(void 0,[{}].concat(fe)),le=de.defaults.extensions||{renderers:{},childTokens:{}},oe;fe.forEach(function(ae){if(ae.extensions&&(oe=!0,ae.extensions.forEach(function(Ce){if(!Ce.name)throw new Error("extension name required");if(Ce.renderer){var T=le.renderers?le.renderers[Ce.name]:null;T?le.renderers[Ce.name]=function(){for(var H=arguments.length,X=new Array(H),Y=0;Y<H;Y++)X[Y]=arguments[Y];var J=Ce.renderer.apply(this,X);return J===!1&&(J=T.apply(this,X)),J}:le.renderers[Ce.name]=Ce.renderer}if(Ce.tokenizer){if(!Ce.level||Ce.level!=="block"&&Ce.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");le[Ce.level]?le[Ce.level].unshift(Ce.tokenizer):le[Ce.level]=[Ce.tokenizer],Ce.start&&(Ce.level==="block"?le.startBlock?le.startBlock.push(Ce.start):le.startBlock=[Ce.start]:Ce.level==="inline"&&(le.startInline?le.startInline.push(Ce.start):le.startInline=[Ce.start]))}Ce.childTokens&&(le.childTokens[Ce.name]=Ce.childTokens)})),ae.renderer&&function(){var Ce=de.defaults.renderer||new me,T=function(Y){var J=Ce[Y];Ce[Y]=function(){for(var te=arguments.length,se=new Array(te),Fe=0;Fe<te;Fe++)se[Fe]=arguments[Fe];var je=ae.renderer[Y].apply(Ce,se);return je===!1&&(je=J.apply(Ce,se)),je}};for(var H in ae.renderer)T(H);re.renderer=Ce}(),ae.tokenizer&&function(){var Ce=de.defaults.tokenizer||new q,T=function(Y){var J=Ce[Y];Ce[Y]=function(){for(var te=arguments.length,se=new Array(te),Fe=0;Fe<te;Fe++)se[Fe]=arguments[Fe];var je=ae.tokenizer[Y].apply(Ce,se);return je===!1&&(je=J.apply(Ce,se)),je}};for(var H in ae.tokenizer)T(H);re.tokenizer=Ce}(),ae.walkTokens){var pe=de.defaults.walkTokens;re.walkTokens=function(Ce){var T=[];return T.push(ae.walkTokens.call(this,Ce)),pe&&(T=T.concat(pe.call(this,Ce))),T}}oe&&(re.extensions=le),de.setOptions(re)})},de.walkTokens=function(he,fe){for(var Ee=[],re=function(){var pe=oe.value;switch(Ee=Ee.concat(fe.call(de,pe)),pe.type){case"table":{for(var Ce=O(pe.header),T;!(T=Ce()).done;){var H=T.value;Ee=Ee.concat(de.walkTokens(H.tokens,fe))}for(var X=O(pe.rows),Y;!(Y=X()).done;)for(var J=Y.value,te=O(J),se;!(se=te()).done;){var Fe=se.value;Ee=Ee.concat(de.walkTokens(Fe.tokens,fe))}break}case"list":{Ee=Ee.concat(de.walkTokens(pe.items,fe));break}default:de.defaults.extensions&&de.defaults.extensions.childTokens&&de.defaults.extensions.childTokens[pe.type]?de.defaults.extensions.childTokens[pe.type].forEach(function(je){Ee=Ee.concat(de.walkTokens(pe[je],fe))}):pe.tokens&&(Ee=Ee.concat(de.walkTokens(pe.tokens,fe)))}},le=O(he),oe;!(oe=le()).done;)re();return Ee},de.parseInline=function(he,fe){if(typeof he>"u"||he===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof he!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(he)+", string expected");fe=E({},de.defaults,fe||{}),b(fe);try{var Ee=B.lexInline(he,fe);return fe.walkTokens&&de.walkTokens(Ee,fe.walkTokens),_.parseInline(Ee,fe)}catch(re){if(re.message+=`
Please report this to https://github.com/markedjs/marked.`,fe.silent)return"<p>An error occurred:</p><pre>"+m(re.message+"",!0)+"</pre>";throw re}},de.Parser=_,de.parser=_.parse,de.Renderer=me,de.TextRenderer=ye,de.Lexer=B,de.lexer=B.lex,de.Tokenizer=q,de.Slugger=Ie,de.parse=de;var De=de.options,ue=de.setOptions,ve=de.use,ke=de.walkTokens,V=de.parseInline,Q=de,ee=_.parse,$e=B.lex;ie.Lexer=B,ie.Parser=_,ie.Renderer=me,ie.Slugger=Ie,ie.TextRenderer=ye,ie.Tokenizer=q,ie.getDefaults=R,ie.lexer=$e,ie.marked=de,ie.options=De,ie.parse=Q,ie.parseInline=V,ie.parser=ee,ie.setOptions=ue,ie.use=ve,ie.walkTokens=ke,Object.defineProperty(ie,"__esModule",{value:!0})}),define(Ae[117],Re([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nl=e.$Ml=e.$Ll=e.rot=e.$Jl=void 0;function h(u,D,d){return Math.min(Math.max(u,D),d)}e.$Jl=h;function C(u,D){return(D+u%D)%D}e.rot=C;class I{constructor(){this.a=0}getNext(){return this.a++}}e.$Ll=I;class O{constructor(){this.a=1,this.b=0}update(D){return this.b=this.b+(D-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Ml=O;class R{constructor(D){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(D),this.c.fill(0,0,D)}update(D){const d=this.c[this.d];return this.c[this.d]=D,this.d=(this.d+1)%this.c.length,this.e-=d,this.e+=D,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Nl=R}),function(){function ie(I){const O=[];typeof I=="number"&&O.push("code/timeOrigin",I);function R(D){O.push(D,Date.now())}function u(){const D=[];for(let d=0;d<O.length;d+=2)D.push({name:O[d],startTime:O[d+1]});return D}return{mark:R,getMarks:u}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ie():{mark(I){performance.mark(I)},getMarks(){let I=performance.timeOrigin;typeof I!="number"&&(I=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const O=[{name:"code/timeOrigin",startTime:Math.round(I)}];for(const R of performance.getEntriesByType("mark"))O.push({name:R.name,startTime:Math.round(I+R.startTime)});return O}};if(typeof process=="object"){const I=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ie(I)}else return console.trace("perf-util loaded in UNKNOWN environment"),ie()}function h(I){return I.MonacoPerformanceMarks||(I.MonacoPerformanceMarks=e()),I.MonacoPerformanceMarks}var C;typeof global=="object"?C=global:typeof self=="object"?C=self:C={},typeof define=="function"?define("vs/base/common/performance",[],function(){return h(C)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=h(C):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),C.perf=h(C))}(),define(Ae[118],Re([1,0,66,19]),function(ie,e,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lq=e.$kq=e.$jq=e.$iq=e.$hq=e.$gq=e.$fq=e.$eq=e.$dq=e.$cq=e.$bq=e.$aq=e.$_p=void 0;const I=new h.$T(()=>{const P=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:P,collatorIsNumeric:P.resolvedOptions().numeric}}),O=new h.$T(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),R=new h.$T(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function u(P,l,$=!1){const b=P||"",M=l||"",U=I.value.collator.compare(b,M);return I.value.collatorIsNumeric&&U===0&&b!==M?b<M?-1:1:U}e.$_p=u;function D(P,l){const $=O.value.collator;return P=P||"",l=l||"",S($,P,l)}e.$aq=D;function d(P,l){const $=O.value.collator;return P=P||"",l=l||"",i(P,l)||S($,P,l)}e.$bq=d;function A(P,l){const $=O.value.collator;return P=P||"",l=l||"",r(P,l)||S($,P,l)}e.$cq=A;function k(P,l){return P=P||"",l=l||"",P===l?0:P<l?-1:1}e.$dq=k;function a(P,l){const[$,b]=c(P),[M,U]=c(l);let F=I.value.collator.compare(b,U);if(F===0){if(I.value.collatorIsNumeric&&b!==U)return b<U?-1:1;if(F=I.value.collator.compare($,M),I.value.collatorIsNumeric&&F===0&&$!==M)return $<M?-1:1}return F}e.$eq=a;function w(P,l){P=P||"",l=l||"";const $=v(P),b=v(l),M=O.value.collator,U=R.value.collator;return S(U,$,b)||S(M,P,l)}e.$fq=w;function m(P,l){P=P||"",l=l||"";const $=v(P),b=v(l),M=O.value.collator,U=R.value.collator;return S(U,$,b)||i(P,l)||S(M,P,l)}e.$gq=m;function f(P,l){P=P||"",l=l||"";const $=v(P),b=v(l),M=O.value.collator,U=R.value.collator;return S(U,$,b)||r(P,l)||S(M,P,l)}e.$hq=f;function t(P,l){P=P||"",l=l||"";const $=v(P).toLowerCase(),b=v(l).toLowerCase();return $!==b?$<b?-1:1:P!==l?P<l?-1:1:0}e.$iq=t;const s=/^(.*?)(\.([^.]*))?$/;function c(P,l=!1){const $=P?s.exec(P):[];let b=[$&&$[1]||"",$&&$[3]||""];return l&&(!b[0]&&b[1]||b[0]&&b[0].charAt(0)===".")&&(b=[b[0]+"."+b[1],""]),b}function v(P){const l=P?s.exec(P):[];return l&&l[1]&&l[1].charAt(0)!=="."&&l[3]||""}function S(P,l,$){const b=P.compare(l,$);return b!==0?b:l.length!==$.length?l.length<$.length?-1:1:0}function p(P){const l=P.charAt(0);return l.toLocaleUpperCase()!==l}function n(P){const l=P.charAt(0);return l.toLocaleLowerCase()!==l}function r(P,l){return p(P)&&n(l)?-1:n(P)&&p(l)?1:0}function i(P,l){return n(P)&&p(l)?-1:p(P)&&n(l)?1:0}function o(P,l,$=!1){return $||(P=P&&P.toLowerCase(),l=l&&l.toLowerCase()),P===l?0:P<l?-1:1}function y(P,l,$=!1){const b=P.split(C.sep),M=l.split(C.sep),U=b.length-1,F=M.length-1;let q,W;for(let L=0;;L++){if(q=U===L,W=F===L,q&&W)return u(b[L],M[L],$);if(q)return-1;if(W)return 1;const z=o(b[L],M[L],$);if(z!==0)return z}}e.$jq=y;function g(P,l,$){const b=P.toLowerCase(),M=l.toLowerCase(),U=E(P,l,$);if(U)return U;const F=b.endsWith($),q=M.endsWith($);if(F!==q)return F?-1:1;const W=u(b,M);return W!==0?W:b.localeCompare(M)}e.$kq=g;function E(P,l,$){const b=P.toLowerCase(),M=l.toLowerCase(),U=b.startsWith($),F=M.startsWith($);if(U!==F)return U?-1:1;if(U&&F){if(b.length<M.length)return-1;if(b.length>M.length)return 1}return 0}e.$lq=E}),define(Ae[67],Re([1,0,19]),function(ie,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nr=e.$Mr=e.$Lr=e.$Kr=e.$Jr=void 0,e.$Jr=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const C={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},I={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function O(A){const k=(0,h.$mc)(A),a=C[k.toLowerCase()];return a!==void 0?a:R(A)}e.$Kr=O;function R(A){const k=(0,h.$mc)(A);return I[k.toLowerCase()]}e.$Lr=R;function u(A){for(const k in I)if(I[k]===A)return k}e.$Mr=u;const D=/^(.+)\/(.+?)(;.+)?$/;function d(A,k){const a=D.exec(A);return a?`${a[1].toLowerCase()}/${a[2].toLowerCase()}${a[3]??""}`:k?void 0:A}e.$Nr=d}),function(ie,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var h=e();for(var C in h)(typeof exports=="object"?exports:ie)[C]=h[C]}}(typeof self<"u"?self:this,function(){return function(ie){var e={};function h(C){if(e[C])return e[C].exports;var I=e[C]={i:C,l:!1,exports:{}};return ie[C].call(I.exports,I,I.exports,h),I.l=!0,I.exports}return h.m=ie,h.c=e,h.d=function(C,I,O){h.o(C,I)||Object.defineProperty(C,I,{enumerable:!0,get:O})},h.r=function(C){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(C,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(C,"__esModule",{value:!0})},h.t=function(C,I){if(1&I&&(C=h(C)),8&I||4&I&&typeof C=="object"&&C&&C.__esModule)return C;var O=Object.create(null);if(h.r(O),Object.defineProperty(O,"default",{enumerable:!0,value:C}),2&I&&typeof C!="string")for(var R in C)h.d(O,R,function(u){return C[u]}.bind(null,R));return O},h.n=function(C){var I=C&&C.__esModule?function(){return C.default}:function(){return C};return h.d(I,"a",I),I},h.o=function(C,I){return Object.prototype.hasOwnProperty.call(C,I)},h.p="",h(h.s=0)}([function(ie,e,h){(function(C){var I;e=ie.exports=ve,I=typeof C=="object"&&C.env&&C.env.NODE_DEBUG&&/\bsemver\b/i.test(C.env.NODE_DEBUG)?function(){var J=Array.prototype.slice.call(arguments,0);J.unshift("SEMVER"),console.log.apply(console,J)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var O=256,R=Number.MAX_SAFE_INTEGER||9007199254740991,u=e.re=[],D=e.src=[],d=0,A=d++;D[A]="0|[1-9]\\d*";var k=d++;D[k]="[0-9]+";var a=d++;D[a]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var w=d++;D[w]="("+D[A]+")\\.("+D[A]+")\\.("+D[A]+")";var m=d++;D[m]="("+D[k]+")\\.("+D[k]+")\\.("+D[k]+")";var f=d++;D[f]="(?:"+D[A]+"|"+D[a]+")";var t=d++;D[t]="(?:"+D[k]+"|"+D[a]+")";var s=d++;D[s]="(?:-("+D[f]+"(?:\\."+D[f]+")*))";var c=d++;D[c]="(?:-?("+D[t]+"(?:\\."+D[t]+")*))";var v=d++;D[v]="[0-9A-Za-z-]+";var S=d++;D[S]="(?:\\+("+D[v]+"(?:\\."+D[v]+")*))";var p=d++,n="v?"+D[w]+D[s]+"?"+D[S]+"?";D[p]="^"+n+"$";var r="[v=\\s]*"+D[m]+D[c]+"?"+D[S]+"?",i=d++;D[i]="^"+r+"$";var o=d++;D[o]="((?:<|>)?=?)";var y=d++;D[y]=D[k]+"|x|X|\\*";var g=d++;D[g]=D[A]+"|x|X|\\*";var E=d++;D[E]="[v=\\s]*("+D[g]+")(?:\\.("+D[g]+")(?:\\.("+D[g]+")(?:"+D[s]+")?"+D[S]+"?)?)?";var P=d++;D[P]="[v=\\s]*("+D[y]+")(?:\\.("+D[y]+")(?:\\.("+D[y]+")(?:"+D[c]+")?"+D[S]+"?)?)?";var l=d++;D[l]="^"+D[o]+"\\s*"+D[E]+"$";var $=d++;D[$]="^"+D[o]+"\\s*"+D[P]+"$";var b=d++;D[b]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var M=d++;D[M]="(?:~>?)";var U=d++;D[U]="(\\s*)"+D[M]+"\\s+",u[U]=new RegExp(D[U],"g");var F=d++;D[F]="^"+D[M]+D[E]+"$";var q=d++;D[q]="^"+D[M]+D[P]+"$";var W=d++;D[W]="(?:\\^)";var L=d++;D[L]="(\\s*)"+D[W]+"\\s+",u[L]=new RegExp(D[L],"g");var z=d++;D[z]="^"+D[W]+D[E]+"$";var K=d++;D[K]="^"+D[W]+D[P]+"$";var B=d++;D[B]="^"+D[o]+"\\s*("+r+")$|^$";var me=d++;D[me]="^"+D[o]+"\\s*("+n+")$|^$";var ye=d++;D[ye]="(\\s*)"+D[o]+"\\s*("+r+"|"+D[E]+")",u[ye]=new RegExp(D[ye],"g");var Ie=d++;D[Ie]="^\\s*("+D[E]+")\\s+-\\s+("+D[E]+")\\s*$";var _=d++;D[_]="^\\s*("+D[P]+")\\s+-\\s+("+D[P]+")\\s*$";var de=d++;D[de]="(<|>)?=?\\s*\\*";for(var De=0;De<35;De++)I(De,D[De]),u[De]||(u[De]=new RegExp(D[De]));function ue(J,te){if(J instanceof ve)return J;if(typeof J!="string"||J.length>O||!(te?u[i]:u[p]).test(J))return null;try{return new ve(J,te)}catch{return null}}function ve(J,te){if(J instanceof ve){if(J.loose===te)return J;J=J.version}else if(typeof J!="string")throw new TypeError("Invalid Version: "+J);if(J.length>O)throw new TypeError("version is longer than "+O+" characters");if(!(this instanceof ve))return new ve(J,te);I("SemVer",J,te),this.loose=te;var se=J.trim().match(te?u[i]:u[p]);if(!se)throw new TypeError("Invalid Version: "+J);if(this.raw=J,this.major=+se[1],this.minor=+se[2],this.patch=+se[3],this.major>R||this.major<0)throw new TypeError("Invalid major version");if(this.minor>R||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>R||this.patch<0)throw new TypeError("Invalid patch version");se[4]?this.prerelease=se[4].split(".").map(function(Fe){if(/^[0-9]+$/.test(Fe)){var je=+Fe;if(je>=0&&je<R)return je}return Fe}):this.prerelease=[],this.build=se[5]?se[5].split("."):[],this.format()}e.parse=ue,e.valid=function(J,te){var se=ue(J,te);return se?se.version:null},e.clean=function(J,te){var se=ue(J.trim().replace(/^[=v]+/,""),te);return se?se.version:null},e.SemVer=ve,ve.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ve.prototype.toString=function(){return this.version},ve.prototype.compare=function(J){return I("SemVer.compare",this.version,this.loose,J),J instanceof ve||(J=new ve(J,this.loose)),this.compareMain(J)||this.comparePre(J)},ve.prototype.compareMain=function(J){return J instanceof ve||(J=new ve(J,this.loose)),V(this.major,J.major)||V(this.minor,J.minor)||V(this.patch,J.patch)},ve.prototype.comparePre=function(J){if(J instanceof ve||(J=new ve(J,this.loose)),this.prerelease.length&&!J.prerelease.length)return-1;if(!this.prerelease.length&&J.prerelease.length)return 1;if(!this.prerelease.length&&!J.prerelease.length)return 0;var te=0;do{var se=this.prerelease[te],Fe=J.prerelease[te];if(I("prerelease compare",te,se,Fe),se===void 0&&Fe===void 0)return 0;if(Fe===void 0)return 1;if(se===void 0)return-1;if(se!==Fe)return V(se,Fe)}while(++te)},ve.prototype.inc=function(J,te){switch(J){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",te);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",te);break;case"prepatch":this.prerelease.length=0,this.inc("patch",te),this.inc("pre",te);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",te),this.inc("pre",te);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var se=this.prerelease.length;--se>=0;)typeof this.prerelease[se]=="number"&&(this.prerelease[se]++,se=-2);se===-1&&this.prerelease.push(0)}te&&(this.prerelease[0]===te?isNaN(this.prerelease[1])&&(this.prerelease=[te,0]):this.prerelease=[te,0]);break;default:throw new Error("invalid increment argument: "+J)}return this.format(),this.raw=this.version,this},e.inc=function(J,te,se,Fe){typeof se=="string"&&(Fe=se,se=void 0);try{return new ve(J,se).inc(te,Fe).version}catch{return null}},e.diff=function(J,te){if(he(J,te))return null;var se=ue(J),Fe=ue(te);if(se.prerelease.length||Fe.prerelease.length){for(var je in se)if((je==="major"||je==="minor"||je==="patch")&&se[je]!==Fe[je])return"pre"+je;return"prerelease"}for(var je in se)if((je==="major"||je==="minor"||je==="patch")&&se[je]!==Fe[je])return je},e.compareIdentifiers=V;var ke=/^[0-9]+$/;function V(J,te){var se=ke.test(J),Fe=ke.test(te);return se&&Fe&&(J=+J,te=+te),se&&!Fe?-1:Fe&&!se?1:J<te?-1:J>te?1:0}function Q(J,te,se){return new ve(J,se).compare(new ve(te,se))}function ee(J,te,se){return Q(J,te,se)>0}function $e(J,te,se){return Q(J,te,se)<0}function he(J,te,se){return Q(J,te,se)===0}function fe(J,te,se){return Q(J,te,se)!==0}function Ee(J,te,se){return Q(J,te,se)>=0}function re(J,te,se){return Q(J,te,se)<=0}function le(J,te,se,Fe){var je;switch(te){case"===":typeof J=="object"&&(J=J.version),typeof se=="object"&&(se=se.version),je=J===se;break;case"!==":typeof J=="object"&&(J=J.version),typeof se=="object"&&(se=se.version),je=J!==se;break;case"":case"=":case"==":je=he(J,se,Fe);break;case"!=":je=fe(J,se,Fe);break;case">":je=ee(J,se,Fe);break;case">=":je=Ee(J,se,Fe);break;case"<":je=$e(J,se,Fe);break;case"<=":je=re(J,se,Fe);break;default:throw new TypeError("Invalid operator: "+te)}return je}function oe(J,te){if(J instanceof oe){if(J.loose===te)return J;J=J.value}if(!(this instanceof oe))return new oe(J,te);I("comparator",J,te),this.loose=te,this.parse(J),this.semver===ae?this.value="":this.value=this.operator+this.semver.version,I("comp",this)}e.rcompareIdentifiers=function(J,te){return V(te,J)},e.major=function(J,te){return new ve(J,te).major},e.minor=function(J,te){return new ve(J,te).minor},e.patch=function(J,te){return new ve(J,te).patch},e.compare=Q,e.compareLoose=function(J,te){return Q(J,te,!0)},e.rcompare=function(J,te,se){return Q(te,J,se)},e.sort=function(J,te){return J.sort(function(se,Fe){return e.compare(se,Fe,te)})},e.rsort=function(J,te){return J.sort(function(se,Fe){return e.rcompare(se,Fe,te)})},e.gt=ee,e.lt=$e,e.eq=he,e.neq=fe,e.gte=Ee,e.lte=re,e.cmp=le,e.Comparator=oe;var ae={};function pe(J,te){if(J instanceof pe)return J.loose===te?J:new pe(J.raw,te);if(J instanceof oe)return new pe(J.value,te);if(!(this instanceof pe))return new pe(J,te);if(this.loose=te,this.raw=J,this.set=J.split(/\s*\|\|\s*/).map(function(se){return this.parseRange(se.trim())},this).filter(function(se){return se.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+J);this.format()}function Ce(J){return!J||J.toLowerCase()==="x"||J==="*"}function T(J,te,se,Fe,je,Xe,He,et,xe,it,st,nt,Ue){return((te=Ce(se)?"":Ce(Fe)?">="+se+".0.0":Ce(je)?">="+se+"."+Fe+".0":">="+te)+" "+(et=Ce(xe)?"":Ce(it)?"<"+(+xe+1)+".0.0":Ce(st)?"<"+xe+"."+(+it+1)+".0":nt?"<="+xe+"."+it+"."+st+"-"+nt:"<="+et)).trim()}function H(J,te){for(var se=0;se<J.length;se++)if(!J[se].test(te))return!1;if(te.prerelease.length){for(se=0;se<J.length;se++)if(I(J[se].semver),J[se].semver!==ae&&J[se].semver.prerelease.length>0){var Fe=J[se].semver;if(Fe.major===te.major&&Fe.minor===te.minor&&Fe.patch===te.patch)return!0}return!1}return!0}function X(J,te,se){try{te=new pe(te,se)}catch{return!1}return te.test(J)}function Y(J,te,se,Fe){var je,Xe,He,et,xe;switch(J=new ve(J,Fe),te=new pe(te,Fe),se){case">":je=ee,Xe=re,He=$e,et=">",xe=">=";break;case"<":je=$e,Xe=Ee,He=ee,et="<",xe="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(X(J,te,Fe))return!1;for(var it=0;it<te.set.length;++it){var st=te.set[it],nt=null,Ue=null;if(st.forEach(function(ot){ot.semver===ae&&(ot=new oe(">=0.0.0")),nt=nt||ot,Ue=Ue||ot,je(ot.semver,nt.semver,Fe)?nt=ot:He(ot.semver,Ue.semver,Fe)&&(Ue=ot)}),nt.operator===et||nt.operator===xe||(!Ue.operator||Ue.operator===et)&&Xe(J,Ue.semver)||Ue.operator===xe&&He(J,Ue.semver))return!1}return!0}oe.prototype.parse=function(J){var te=this.loose?u[B]:u[me],se=J.match(te);if(!se)throw new TypeError("Invalid comparator: "+J);this.operator=se[1],this.operator==="="&&(this.operator=""),se[2]?this.semver=new ve(se[2],this.loose):this.semver=ae},oe.prototype.toString=function(){return this.value},oe.prototype.test=function(J){return I("Comparator.test",J,this.loose),this.semver===ae||(typeof J=="string"&&(J=new ve(J,this.loose)),le(J,this.operator,this.semver,this.loose))},oe.prototype.intersects=function(J,te){if(!(J instanceof oe))throw new TypeError("a Comparator is required");var se;if(this.operator==="")return se=new pe(J.value,te),X(this.value,se,te);if(J.operator==="")return se=new pe(this.value,te),X(J.semver,se,te);var Fe=!(this.operator!==">="&&this.operator!==">"||J.operator!==">="&&J.operator!==">"),je=!(this.operator!=="<="&&this.operator!=="<"||J.operator!=="<="&&J.operator!=="<"),Xe=this.semver.version===J.semver.version,He=!(this.operator!==">="&&this.operator!=="<="||J.operator!==">="&&J.operator!=="<="),et=le(this.semver,"<",J.semver,te)&&(this.operator===">="||this.operator===">")&&(J.operator==="<="||J.operator==="<"),xe=le(this.semver,">",J.semver,te)&&(this.operator==="<="||this.operator==="<")&&(J.operator===">="||J.operator===">");return Fe||je||Xe&&He||et||xe},e.Range=pe,pe.prototype.format=function(){return this.range=this.set.map(function(J){return J.join(" ").trim()}).join("||").trim(),this.range},pe.prototype.toString=function(){return this.range},pe.prototype.parseRange=function(J){var te=this.loose;J=J.trim(),I("range",J,te);var se=te?u[_]:u[Ie];J=J.replace(se,T),I("hyphen replace",J),J=J.replace(u[ye],"$1$2$3"),I("comparator trim",J,u[ye]),J=(J=(J=J.replace(u[U],"$1~")).replace(u[L],"$1^")).split(/\s+/).join(" ");var Fe=te?u[B]:u[me],je=J.split(" ").map(function(Xe){return function(He,et){return I("comp",He),He=function(xe,it){return xe.trim().split(/\s+/).map(function(st){return function(nt,Ue){I("caret",nt,Ue);var ot=Ue?u[K]:u[z];return nt.replace(ot,function(x,Z,we,We,ze){var Ze;return I("caret",nt,x,Z,we,We,ze),Ce(Z)?Ze="":Ce(we)?Ze=">="+Z+".0.0 <"+(+Z+1)+".0.0":Ce(We)?Ze=Z==="0"?">="+Z+"."+we+".0 <"+Z+"."+(+we+1)+".0":">="+Z+"."+we+".0 <"+(+Z+1)+".0.0":ze?(I("replaceCaret pr",ze),ze.charAt(0)!=="-"&&(ze="-"+ze),Ze=Z==="0"?we==="0"?">="+Z+"."+we+"."+We+ze+" <"+Z+"."+we+"."+(+We+1):">="+Z+"."+we+"."+We+ze+" <"+Z+"."+(+we+1)+".0":">="+Z+"."+we+"."+We+ze+" <"+(+Z+1)+".0.0"):(I("no pr"),Ze=Z==="0"?we==="0"?">="+Z+"."+we+"."+We+" <"+Z+"."+we+"."+(+We+1):">="+Z+"."+we+"."+We+" <"+Z+"."+(+we+1)+".0":">="+Z+"."+we+"."+We+" <"+(+Z+1)+".0.0"),I("caret return",Ze),Ze})}(st,it)}).join(" ")}(He,et),I("caret",He),He=function(xe,it){return xe.trim().split(/\s+/).map(function(st){return function(nt,Ue){var ot=Ue?u[q]:u[F];return nt.replace(ot,function(x,Z,we,We,ze){var Ze;return I("tilde",nt,x,Z,we,We,ze),Ce(Z)?Ze="":Ce(we)?Ze=">="+Z+".0.0 <"+(+Z+1)+".0.0":Ce(We)?Ze=">="+Z+"."+we+".0 <"+Z+"."+(+we+1)+".0":ze?(I("replaceTilde pr",ze),ze.charAt(0)!=="-"&&(ze="-"+ze),Ze=">="+Z+"."+we+"."+We+ze+" <"+Z+"."+(+we+1)+".0"):Ze=">="+Z+"."+we+"."+We+" <"+Z+"."+(+we+1)+".0",I("tilde return",Ze),Ze})}(st,it)}).join(" ")}(He,et),I("tildes",He),He=function(xe,it){return I("replaceXRanges",xe,it),xe.split(/\s+/).map(function(st){return function(nt,Ue){nt=nt.trim();var ot=Ue?u[$]:u[l];return nt.replace(ot,function(x,Z,we,We,ze,Ze){I("xRange",nt,x,Z,we,We,ze,Ze);var at=Ce(we),mt=at||Ce(We),bt=mt||Ce(ze);return Z==="="&&bt&&(Z=""),at?x=Z===">"||Z==="<"?"<0.0.0":"*":Z&&bt?(mt&&(We=0),bt&&(ze=0),Z===">"?(Z=">=",mt?(we=+we+1,We=0,ze=0):bt&&(We=+We+1,ze=0)):Z==="<="&&(Z="<",mt?we=+we+1:We=+We+1),x=Z+we+"."+We+"."+ze):mt?x=">="+we+".0.0 <"+(+we+1)+".0.0":bt&&(x=">="+we+"."+We+".0 <"+we+"."+(+We+1)+".0"),I("xRange return",x),x})}(st,it)}).join(" ")}(He,et),I("xrange",He),He=function(xe,it){return I("replaceStars",xe,it),xe.trim().replace(u[de],"")}(He,et),I("stars",He),He}(Xe,te)}).join(" ").split(/\s+/);return this.loose&&(je=je.filter(function(Xe){return!!Xe.match(Fe)})),je=je.map(function(Xe){return new oe(Xe,te)})},pe.prototype.intersects=function(J,te){if(!(J instanceof pe))throw new TypeError("a Range is required");return this.set.some(function(se){return se.every(function(Fe){return J.set.some(function(je){return je.every(function(Xe){return Fe.intersects(Xe,te)})})})})},e.toComparators=function(J,te){return new pe(J,te).set.map(function(se){return se.map(function(Fe){return Fe.value}).join(" ").trim().split(" ")})},pe.prototype.test=function(J){if(!J)return!1;typeof J=="string"&&(J=new ve(J,this.loose));for(var te=0;te<this.set.length;te++)if(H(this.set[te],J))return!0;return!1},e.satisfies=X,e.maxSatisfying=function(J,te,se){var Fe=null,je=null;try{var Xe=new pe(te,se)}catch{return null}return J.forEach(function(He){Xe.test(He)&&(Fe&&je.compare(He)!==-1||(je=new ve(Fe=He,se)))}),Fe},e.minSatisfying=function(J,te,se){var Fe=null,je=null;try{var Xe=new pe(te,se)}catch{return null}return J.forEach(function(He){Xe.test(He)&&(Fe&&je.compare(He)!==1||(je=new ve(Fe=He,se)))}),Fe},e.validRange=function(J,te){try{return new pe(J,te).range||"*"}catch{return null}},e.ltr=function(J,te,se){return Y(J,te,"<",se)},e.gtr=function(J,te,se){return Y(J,te,">",se)},e.outside=Y,e.prerelease=function(J,te){var se=ue(J,te);return se&&se.prerelease.length?se.prerelease:null},e.intersects=function(J,te,se){return J=new pe(J,se),te=new pe(te,se),J.intersects(te)},e.coerce=function(J){if(J instanceof ve)return J;if(typeof J!="string")return null;var te=J.match(u[b]);return te==null?null:ue((te[1]||"0")+"."+(te[2]||"0")+"."+(te[3]||"0"))}}).call(this,h(1))},function(ie,e){var h,C,I=ie.exports={};function O(){throw new Error("setTimeout has not been defined")}function R(){throw new Error("clearTimeout has not been defined")}function u(t){if(h===setTimeout)return setTimeout(t,0);if((h===O||!h)&&setTimeout)return h=setTimeout,setTimeout(t,0);try{return h(t,0)}catch{try{return h.call(null,t,0)}catch{return h.call(this,t,0)}}}(function(){try{h=typeof setTimeout=="function"?setTimeout:O}catch{h=O}try{C=typeof clearTimeout=="function"?clearTimeout:R}catch{C=R}})();var D,d=[],A=!1,k=-1;function a(){A&&D&&(A=!1,D.length?d=D.concat(d):k=-1,d.length&&w())}function w(){if(!A){var t=u(a);A=!0;for(var s=d.length;s;){for(D=d,d=[];++k<s;)D&&D[k].run();k=-1,s=d.length}D=null,A=!1,function(c){if(C===clearTimeout)return clearTimeout(c);if((C===R||!C)&&clearTimeout)return C=clearTimeout,clearTimeout(c);try{C(c)}catch{try{return C.call(null,c)}catch{return C.call(this,c)}}}(t)}}function m(t,s){this.fun=t,this.array=s}function f(){}I.nextTick=function(t){var s=new Array(arguments.length-1);if(arguments.length>1)for(var c=1;c<arguments.length;c++)s[c-1]=arguments[c];d.push(new m(t,s)),d.length!==1||A||u(w)},m.prototype.run=function(){this.fun.apply(null,this.array)},I.title="browser",I.browser=!0,I.env={},I.argv=[],I.version="",I.versions={},I.on=f,I.addListener=f,I.once=f,I.off=f,I.removeListener=f,I.removeAllListeners=f,I.emit=f,I.prependListener=f,I.prependOnceListener=f,I.listeners=function(t){return[]},I.binding=function(t){throw new Error("process.binding is not supported")},I.cwd=function(){return"/"},I.chdir=function(t){throw new Error("process.chdir is not supported")},I.umask=function(){return 0}}])}),define(Ae[119],Re([1,0,9,6]),function(ie,e,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.$3d=e.$2d=e.$1d=e.$Zd=e.$Yd=e.$Xd=e.$Wd=void 0;function I(S){const p=S;return p?typeof p.read=="function":!1}e.$Wd=I;function O(S){const p=S;return p?[p.on,p.pause,p.resume,p.destroy].every(n=>typeof n=="function"):!1}e.$Xd=O;function R(S){const p=S;return p?O(p.stream)&&Array.isArray(p.buffer)&&typeof p.ended=="boolean":!1}e.$Yd=R;function u(S,p){return new D(S,p)}e.$Zd=u;class D{constructor(p,n){this.e=p,this.f=n,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(p){if(!this.a.destroyed){if(this.a.flowing)this.g(p);else if(this.b.data.push(p),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(n=>this.d.push(n))}}error(p){this.a.destroyed||(this.a.flowing?this.h(p):this.b.error.push(p))}end(p){this.a.destroyed||(typeof p<"u"&&this.write(p),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(p){this.c.data.slice(0).forEach(n=>n(p))}h(p){this.c.error.length===0?(0,h.$Y)(p):this.c.error.slice(0).forEach(n=>n(p))}i(){this.c.end.slice(0).forEach(p=>p())}on(p,n){if(!this.a.destroyed)switch(p){case"data":this.c.data.push(n),this.resume();break;case"end":this.c.end.push(n),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(n),this.a.flowing&&this.k();break}}removeListener(p,n){if(this.a.destroyed)return;let r;switch(p){case"data":r=this.c.data;break;case"end":r=this.c.end;break;case"error":r=this.c.error;break}if(r){const i=r.indexOf(n);i>=0&&r.splice(i,1)}}j(){if(this.b.data.length>0){const p=this.e(this.b.data);this.g(p),this.b.data.length=0;const n=[...this.d];this.d.length=0,n.forEach(r=>r())}}k(){if(this.c.error.length>0){for(const p of this.b.error)this.h(p);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function d(S,p){const n=[];let r;for(;(r=S.read())!==null;)n.push(r);return p(n)}e.$1d=d;function A(S,p,n){const r=[];let i;for(;(i=S.read())!==null&&r.length<n;)r.push(i);return i===null&&r.length>0?p(r):{read:()=>{if(r.length>0)return r.shift();if(typeof i<"u"){const o=i;return i=void 0,o}return S.read()}}}e.$2d=A;function k(S,p){return new Promise((n,r)=>{const i=[];a(S,{onData:o=>{p&&i.push(o)},onError:o=>{p?r(o):n(void 0)},onEnd:()=>{n(p?p(i):void 0)}})})}e.$3d=k;function a(S,p,n){S.on("error",r=>{n?.isCancellationRequested||p.onError(r)}),S.on("end",()=>{n?.isCancellationRequested||p.onEnd()}),S.on("data",r=>{n?.isCancellationRequested||p.onData(r)})}e.$4d=a;function w(S,p){return new Promise((n,r)=>{const i=new C.$Pc,o=[],y=P=>{if(o.push(P),o.length>p)return i.dispose(),S.pause(),n({stream:S,buffer:o,ended:!1})},g=P=>(i.dispose(),r(P)),E=()=>(i.dispose(),n({stream:S,buffer:o,ended:!0}));i.add((0,C.$Oc)(()=>S.removeListener("error",g))),S.on("error",g),i.add((0,C.$Oc)(()=>S.removeListener("end",E))),S.on("end",E),i.add((0,C.$Oc)(()=>S.removeListener("data",y))),S.on("data",y)})}e.$5d=w;function m(S,p){const n=u(p);return n.end(S),n}e.$6d=m;function f(){const S=u(()=>{throw new Error("not supported")});return S.end(),S}e.$7d=f;function t(S){let p=!1;return{read:()=>p?null:(p=!0,S)}}e.$8d=t;function s(S,p,n){const r=u(n);return a(S,{onData:i=>r.write(p.data(i)),onError:i=>r.error(p.error?p.error(i):i),onEnd:()=>r.end()}),r}e.$9d=s;function c(S,p,n){let r=!1;return{read:()=>{const i=p.read();return r?i:(r=!0,i!==null?n([S,i]):S)}}}e.$0d=c;function v(S,p,n){let r=!1;const i=u(n);return a(p,{onData:o=>r?i.write(o):(r=!0,i.write(n([S,o]))),onError:o=>i.error(o),onEnd:()=>{r||(r=!0,i.write(S)),i.end()}}),i}e.$$d=v}),define(Ae[25],Re([1,0,66,119]),function(ie,e,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=e.$be=e.$ae=e.$_d=void 0;const I=typeof Buffer<"u",O=new h.$T(()=>new Uint8Array(256));let R,u;class D{static alloc(b){return I?new D(Buffer.allocUnsafe(b)):new D(new Uint8Array(b))}static wrap(b){return I&&!Buffer.isBuffer(b)&&(b=Buffer.from(b.buffer,b.byteOffset,b.byteLength)),new D(b)}static fromString(b,M){return!(M?.dontUseNodeBuffer||!1)&&I?new D(Buffer.from(b)):(R||(R=new TextEncoder),new D(R.encode(b)))}static fromByteArray(b){const M=D.alloc(b.length);for(let U=0,F=b.length;U<F;U++)M.buffer[U]=b[U];return M}static concat(b,M){if(typeof M>"u"){M=0;for(let q=0,W=b.length;q<W;q++)M+=b[q].byteLength}const U=D.alloc(M);let F=0;for(let q=0,W=b.length;q<W;q++){const L=b[q];U.set(L,F),F+=L.byteLength}return U}constructor(b){this.buffer=b,this.byteLength=this.buffer.byteLength}clone(){const b=D.alloc(this.byteLength);return b.set(this),b}toString(){return I?this.buffer.toString():(u||(u=new TextDecoder),u.decode(this.buffer))}slice(b,M){return new D(this.buffer.subarray(b,M))}set(b,M){if(b instanceof D)this.buffer.set(b.buffer,M);else if(b instanceof Uint8Array)this.buffer.set(b,M);else if(b instanceof ArrayBuffer)this.buffer.set(new Uint8Array(b),M);else if(ArrayBuffer.isView(b))this.buffer.set(new Uint8Array(b.buffer,b.byteOffset,b.byteLength),M);else throw new Error("Unknown argument 'array'")}readUInt32BE(b){return a(this.buffer,b)}writeUInt32BE(b,M){w(this.buffer,b,M)}readUInt32LE(b){return m(this.buffer,b)}writeUInt32LE(b,M){f(this.buffer,b,M)}readUInt8(b){return t(this.buffer,b)}writeUInt8(b,M){s(this.buffer,b,M)}indexOf(b,M=0){return d(this.buffer,b instanceof D?b.buffer:b,M)}}e.$_d=D;function d($,b,M=0){const U=b.byteLength,F=$.byteLength;if(U===0)return 0;if(U===1)return $.indexOf(b[0]);if(U>F-M)return-1;const q=O.value;q.fill(b.length);for(let K=0;K<b.length;K++)q[b[K]]=b.length-K-1;let W=M+b.length-1,L=W,z=-1;for(;W<F;)if($[W]===b[L]){if(L===0){z=W;break}W--,L--}else W+=Math.max(b.length-L,q[$[W]]),L=b.length-1;return z}e.$ae=d;function A($,b){return $[b+0]<<0>>>0|$[b+1]<<8>>>0}e.$be=A;function k($,b,M){$[M+0]=b&255,b=b>>>8,$[M+1]=b&255}e.$ce=k;function a($,b){return $[b]*2**24+$[b+1]*2**16+$[b+2]*2**8+$[b+3]}e.$de=a;function w($,b,M){$[M+3]=b,b=b>>>8,$[M+2]=b,b=b>>>8,$[M+1]=b,b=b>>>8,$[M]=b}e.$ee=w;function m($,b){return $[b+0]<<0>>>0|$[b+1]<<8>>>0|$[b+2]<<16>>>0|$[b+3]<<24>>>0}e.$fe=m;function f($,b,M){$[M+0]=b&255,b=b>>>8,$[M+1]=b&255,b=b>>>8,$[M+2]=b&255,b=b>>>8,$[M+3]=b&255}e.$ge=f;function t($,b){return $[b]}e.$he=t;function s($,b,M){$[M]=b}e.$ie=s;function c($){return C.$1d($,b=>D.concat(b))}e.$je=c;function v($){return C.$8d($)}e.$ke=v;function S($){return C.$3d($,b=>D.concat(b))}e.$le=S;async function p($){return $.ended?D.concat($.buffer):D.concat([...$.buffer,await S($.stream)])}e.$me=p;function n($){return C.$6d($,b=>D.concat(b))}e.$ne=n;function r($){return C.$9d($,{data:b=>typeof b=="string"?D.fromString(b):D.wrap(b)},b=>D.concat(b))}e.$oe=r;function i($){return C.$Zd(b=>D.concat(b),$)}e.$pe=i;function o($,b){return C.$0d($,b,M=>D.concat(M))}e.$qe=o;function y($,b){return C.$$d($,b,M=>D.concat(M))}e.$re=y;function g($){let b=0,M=0,U=0;const F=new Uint8Array(Math.floor($.length/4*3)),q=L=>{switch(M){case 3:F[U++]=b|L,M=0;break;case 2:F[U++]=b|L>>>2,b=L<<6,M=3;break;case 1:F[U++]=b|L>>>4,b=L<<4,M=2;break;default:b=L<<2,M=1}};for(let L=0;L<$.length;L++){const z=$.charCodeAt(L);if(z>=65&&z<=90)q(z-65);else if(z>=97&&z<=122)q(z-97+26);else if(z>=48&&z<=57)q(z-48+52);else if(z===43||z===45)q(62);else if(z===47||z===95)q(63);else{if(z===61)break;throw new SyntaxError(`Unexpected base64 character ${$[L]}`)}}const W=U;for(;M>0;)q(0);return D.wrap(F).slice(0,W)}e.$se=g;const E="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",P="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function l({buffer:$},b=!0,M=!1){const U=M?P:E;let F="";const q=$.byteLength%3;let W=0;for(;W<$.byteLength-q;W+=3){const L=$[W+0],z=$[W+1],K=$[W+2];F+=U[L>>>2],F+=U[(L<<4|z>>>4)&63],F+=U[(z<<2|K>>>6)&63],F+=U[K&63]}if(q===1){const L=$[W+0];F+=U[L>>>2],F+=U[L<<4&63],b&&(F+="==")}else if(q===2){const L=$[W+0],z=$[W+1];F+=U[L>>>2],F+=U[(L<<4|z>>>4)&63],F+=U[z<<2&63],b&&(F+="=")}return F}e.$te=l}),define(Ae[120],Re([1,0,28,15]),function(ie,e,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.FuzzyScore=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.or=void 0;function I(...oe){return function(ae,pe){for(let Ce=0,T=oe.length;Ce<T;Ce++){const H=oe[Ce](ae,pe);if(H)return H}return null}}e.or=I,e.$yj=O.bind(void 0,!1),e.$zj=O.bind(void 0,!0);function O(oe,ae,pe){if(!pe||pe.length<ae.length)return null;let Ce;return oe?Ce=C.$1e(pe,ae):Ce=pe.indexOf(ae)===0,Ce?ae.length>0?[{start:0,end:ae.length}]:[]:null}function R(oe,ae){const pe=ae.toLowerCase().indexOf(oe.toLowerCase());return pe===-1?null:[{start:pe,end:pe+oe.length}]}e.$Aj=R;function u(oe,ae){return D(oe.toLowerCase(),ae.toLowerCase(),0,0)}e.$Bj=u;function D(oe,ae,pe,Ce){if(pe===oe.length)return[];if(Ce===ae.length)return null;if(oe[pe]===ae[Ce]){let T=null;return(T=D(oe,ae,pe+1,Ce+1))?s({start:Ce,end:Ce+1},T):null}return D(oe,ae,pe,Ce+1)}function d(oe){return 97<=oe&&oe<=122}function A(oe){return 65<=oe&&oe<=90}e.$Cj=A;function k(oe){return 48<=oe&&oe<=57}function a(oe){return oe===32||oe===9||oe===10||oe===13}const w=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(oe=>w.add(oe.charCodeAt(0)));function m(oe){return a(oe)||w.has(oe)}function f(oe,ae){return oe===ae||m(oe)&&m(ae)}function t(oe){return d(oe)||A(oe)||k(oe)}function s(oe,ae){return ae.length===0?ae=[oe]:oe.end===ae[0].start?ae[0].start=oe.start:ae.unshift(oe),ae}function c(oe,ae){for(let pe=ae;pe<oe.length;pe++){const Ce=oe.charCodeAt(pe);if(A(Ce)||k(Ce)||pe>0&&!t(oe.charCodeAt(pe-1)))return pe}return oe.length}function v(oe,ae,pe,Ce){if(pe===oe.length)return[];if(Ce===ae.length)return null;if(oe[pe]!==ae[Ce].toLowerCase())return null;{let T=null,H=Ce+1;for(T=v(oe,ae,pe+1,Ce+1);!T&&(H=c(ae,H))<ae.length;)T=v(oe,ae,pe+1,H),H++;return T===null?null:s({start:Ce,end:Ce+1},T)}}function S(oe){let ae=0,pe=0,Ce=0,T=0,H=0;for(let se=0;se<oe.length;se++)H=oe.charCodeAt(se),A(H)&&ae++,d(H)&&pe++,t(H)&&Ce++,k(H)&&T++;const X=ae/oe.length,Y=pe/oe.length,J=Ce/oe.length,te=T/oe.length;return{upperPercent:X,lowerPercent:Y,alphaPercent:J,numericPercent:te}}function p(oe){const{upperPercent:ae,lowerPercent:pe}=oe;return pe===0&&ae>.6}function n(oe){const{upperPercent:ae,lowerPercent:pe,alphaPercent:Ce,numericPercent:T}=oe;return pe>.2&&ae<.8&&Ce>.6&&T<.2}function r(oe){let ae=0,pe=0,Ce=0,T=0;for(let H=0;H<oe.length;H++)Ce=oe.charCodeAt(H),A(Ce)&&ae++,d(Ce)&&pe++,a(Ce)&&T++;return(ae===0||pe===0)&&T===0?oe.length<=30:ae<=5}function i(oe,ae){if(!ae||(ae=ae.trim(),ae.length===0)||!r(oe)||ae.length>60)return null;const pe=S(ae);if(!n(pe)){if(!p(pe))return null;ae=ae.toLowerCase()}let Ce=null,T=0;for(oe=oe.toLowerCase();T<ae.length&&(Ce=v(oe,ae,0,T))===null;)T=c(ae,T+1);return Ce}e.$Dj=i;function o(oe,ae,pe=!1){if(!ae||ae.length===0)return null;let Ce=null,T=0;for(oe=oe.toLowerCase(),ae=ae.toLowerCase();T<ae.length&&(Ce=y(oe,ae,0,T,pe))===null;)T=g(ae,T+1);return Ce}e.$Ej=o;function y(oe,ae,pe,Ce,T){if(pe===oe.length)return[];if(Ce===ae.length)return null;if(f(oe.charCodeAt(pe),ae.charCodeAt(Ce))){let H=null,X=Ce+1;if(H=y(oe,ae,pe+1,Ce+1,T),!T)for(;!H&&(X=g(ae,X))<ae.length;)H=y(oe,ae,pe+1,X,T),X++;return H?oe.charCodeAt(pe)!==ae.charCodeAt(Ce)?H:s({start:Ce,end:Ce+1},H):null}else return null}function g(oe,ae){for(let pe=ae;pe<oe.length;pe++)if(m(oe.charCodeAt(pe))||pe>0&&m(oe.charCodeAt(pe-1)))return pe;return oe.length}const E=I(e.$zj,i,R),P=I(e.$zj,i,u),l=new h.$Bc(1e4);function $(oe,ae,pe=!1){if(typeof oe!="string"||typeof ae!="string")return null;let Ce=l.get(oe);Ce||(Ce=new RegExp(C.$Je(oe),"i"),l.set(oe,Ce));const T=Ce.exec(ae);return T?[{start:T.index,end:T.index+T[0].length}]:pe?P(oe,ae):E(oe,ae)}e.$Fj=$;function b(oe,ae){const pe=ee(oe,oe.toLowerCase(),0,ae,ae.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return pe?U(pe):null}e.$Gj=b;function M(oe,ae,pe,Ce,T,H){const X=Math.min(13,oe.length);for(;pe<X;pe++){const Y=ee(oe,ae,pe,Ce,T,H,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(Y)return Y}return[0,H]}e.$Hj=M;function U(oe){if(typeof oe>"u")return[];const ae=[],pe=oe[1];for(let Ce=oe.length-1;Ce>1;Ce--){const T=oe[Ce]+pe,H=ae[ae.length-1];H&&H.end===T?H.end=T+1:ae.push({start:T,end:T+1})}return ae}e.$Ij=U;const F=128;function q(){const oe=[],ae=[];for(let pe=0;pe<=F;pe++)ae[pe]=0;for(let pe=0;pe<=F;pe++)oe.push(ae.slice(0));return oe}function W(oe){const ae=[];for(let pe=0;pe<=oe;pe++)ae[pe]=0;return ae}const L=W(2*F),z=W(2*F),K=q(),B=q(),me=q(),ye=!1;function Ie(oe,ae,pe,Ce,T){function H(Y,J,te=" "){for(;Y.length<J;)Y=te+Y;return Y}let X=` |   |${Ce.split("").map(Y=>H(Y,3)).join("|")}
`;for(let Y=0;Y<=pe;Y++)Y===0?X+=" |":X+=`${ae[Y-1]}|`,X+=oe[Y].slice(0,T+1).map(J=>H(J.toString(),3)).join("|")+`
`;return X}function _(oe,ae,pe,Ce){oe=oe.substr(ae),pe=pe.substr(Ce),console.log(Ie(B,oe,oe.length,pe,pe.length)),console.log(Ie(me,oe,oe.length,pe,pe.length)),console.log(Ie(K,oe,oe.length,pe,pe.length))}function de(oe,ae){if(ae<0||ae>=oe.length)return!1;const pe=oe.codePointAt(ae);switch(pe){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!C.$gf(pe)}}function De(oe,ae){if(ae<0||ae>=oe.length)return!1;switch(oe.charCodeAt(ae)){case 32:case 9:return!0;default:return!1}}function ue(oe,ae,pe){return ae[oe]!==pe[oe]}function ve(oe,ae,pe,Ce,T,H,X=!1){for(;ae<pe&&T<H;)oe[ae]===Ce[T]&&(X&&(L[ae]=T),ae+=1),T+=1;return ae===pe}e.$Jj=ve;var ke;(function(oe){oe[oe.Diag=1]="Diag",oe[oe.Left=2]="Left",oe[oe.LeftLeft=3]="LeftLeft"})(ke||(ke={}));var V;(function(oe){oe.Default=[-100,0];function ae(pe){return!pe||pe.length===2&&pe[0]===-100&&pe[1]===0}oe.isDefault=ae})(V||(e.FuzzyScore=V={}));class Q{constructor(ae,pe){this.firstMatchCanBeWeak=ae,this.boostFullMatch=pe}}e.$Kj=Q,Q.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function ee(oe,ae,pe,Ce,T,H,X=Q.default){const Y=oe.length>F?F:oe.length,J=Ce.length>F?F:Ce.length;if(pe>=Y||H>=J||Y-pe>J-H||!ve(ae,pe,Y,T,H,J,!0))return;$e(Y,J,pe,H,ae,T);let te=1,se=1,Fe=pe,je=H;const Xe=[!1];for(te=1,Fe=pe;Fe<Y;te++,Fe++){const st=L[Fe],nt=z[Fe],Ue=Fe+1<Y?z[Fe+1]:J;for(se=st-H+1,je=st;je<Ue;se++,je++){let ot=Number.MIN_SAFE_INTEGER,x=!1;je<=nt&&(ot=he(oe,ae,Fe,pe,Ce,T,je,J,H,K[te-1][se-1]===0,Xe));let Z=0;ot!==Number.MAX_SAFE_INTEGER&&(x=!0,Z=ot+B[te-1][se-1]);const we=je>st,We=we?B[te][se-1]+(K[te][se-1]>0?-5:0):0,ze=je>st+1&&K[te][se-1]>0,Ze=ze?B[te][se-2]+(K[te][se-2]>0?-5:0):0;if(ze&&(!we||Ze>=We)&&(!x||Ze>=Z))B[te][se]=Ze,me[te][se]=3,K[te][se]=0;else if(we&&(!x||We>=Z))B[te][se]=We,me[te][se]=2,K[te][se]=0;else if(x)B[te][se]=Z,me[te][se]=1,K[te][se]=K[te-1][se-1]+1;else throw new Error("not possible")}}if(ye&&_(oe,pe,Ce,H),!Xe[0]&&!X.firstMatchCanBeWeak)return;te--,se--;const He=[B[te][se],H];let et=0,xe=0;for(;te>=1;){let st=se;do{const nt=me[te][st];if(nt===3)st=st-2;else if(nt===2)st=st-1;else break}while(st>=1);et>1&&ae[pe+te-1]===T[H+se-1]&&!ue(st+H-1,Ce,T)&&et+1>K[te][st]&&(st=se),st===se?et++:et=1,xe||(xe=st),te--,se=st-1,He.push(se)}J===Y&&X.boostFullMatch&&(He[0]+=2);const it=xe-Y;return He[0]-=it,He}e.$Lj=ee;function $e(oe,ae,pe,Ce,T,H){let X=oe-1,Y=ae-1;for(;X>=pe&&Y>=Ce;)T[X]===H[Y]&&(z[X]=Y,X--),Y--}function he(oe,ae,pe,Ce,T,H,X,Y,J,te,se){if(ae[pe]!==H[X])return Number.MIN_SAFE_INTEGER;let Fe=1,je=!1;return X===pe-Ce?Fe=oe[pe]===T[X]?7:5:ue(X,T,H)&&(X===0||!ue(X-1,T,H))?(Fe=oe[pe]===T[X]?7:5,je=!0):de(H,X)&&(X===0||!de(H,X-1))?Fe=5:(de(H,X-1)||De(H,X-1))&&(Fe=5,je=!0),Fe>1&&pe===Ce&&(se[0]=!0),je||(je=ue(X,T,H)||de(H,X-1)||De(H,X-1)),pe===Ce?X>J&&(Fe-=je?3:5):te?Fe+=je?2:0:Fe+=je?0:1,X+1===Y&&(Fe-=je?3:5),Fe}function fe(oe,ae,pe,Ce,T,H,X){return re(oe,ae,pe,Ce,T,H,!0,X)}e.$Mj=fe;function Ee(oe,ae,pe,Ce,T,H,X){return re(oe,ae,pe,Ce,T,H,!1,X)}e.$Nj=Ee;function re(oe,ae,pe,Ce,T,H,X,Y){let J=ee(oe,ae,pe,Ce,T,H,Y);if(J&&!X)return J;if(oe.length>=3){const te=Math.min(7,oe.length-1);for(let se=pe+1;se<te;se++){const Fe=le(oe,se);if(Fe){const je=ee(Fe,Fe.toLowerCase(),pe,Ce,T,H,Y);je&&(je[0]-=3,(!J||je[0]>J[0])&&(J=je))}}}return J}function le(oe,ae){if(ae+1>=oe.length)return;const pe=oe[ae],Ce=oe[ae+1];if(pe!==Ce)return oe.slice(0,ae)+Ce+pe+oe.slice(ae+2)}}),define(Ae[29],Re([1,0,15]),function(ie,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var C;(function(I){I[I.Ignore=0]="Ignore",I[I.Info=1]="Info",I[I.Warning=2]="Warning",I[I.Error=3]="Error"})(C||(C={})),function(I){const O="error",R="warning",u="warn",D="info",d="ignore";function A(a){return a?h.$Ze(O,a)?I.Error:h.$Ze(R,a)||h.$Ze(u,a)?I.Warning:h.$Ze(D,a)?I.Info:I.Ignore:I.Ignore}I.fromValue=A;function k(a){switch(a){case I.Error:return O;case I.Warning:return R;case I.Info:return D;default:return d}}I.toString=k}(C||(C={})),e.default=C}),define(Ae[121],Re([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Id=void 0,e.$Id=Symbol("MicrotaskDelay")}),define(Ae[48],Re([1,0,18,15]),function(ie,e,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=void 0;class I{constructor(){this.b="",this.c=0}reset(w){return this.b=w,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(w){const m=w.charCodeAt(0),f=this.b.charCodeAt(this.c);return m-f}value(){return this.b[this.c]}}e.$Nh=I;class O{constructor(w=!0){this.e=w}reset(w){return this.b=w,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let w=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(w)this.c++;else break;else w=!1;return this}cmp(w){return this.e?(0,C.$Te)(w,this.b,0,w.length,this.c,this.d):(0,C.$Ve)(w,this.b,0,w.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Oh=O;class R{constructor(w=!0,m=!0){this.f=w,this.g=m}reset(w){this.d=0,this.e=0,this.b=w,this.c=w.length;for(let m=w.length-1;m>=0;m--,this.c--){const f=this.b.charCodeAt(m);if(!(f===47||this.f&&f===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let w=!0;for(;this.e<this.c;this.e++){const m=this.b.charCodeAt(this.e);if(m===47||this.f&&m===92)if(w)this.d++;else break;else w=!1}return this}cmp(w){return this.g?(0,C.$Te)(w,this.b,0,w.length,this.d,this.e):(0,C.$Ve)(w,this.b,0,w.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Ph=R;var u;(function(a){a[a.Scheme=1]="Scheme",a[a.Authority=2]="Authority",a[a.Path=3]="Path",a[a.Query=4]="Query",a[a.Fragment=5]="Fragment"})(u||(u={}));class D{constructor(w,m){this.f=w,this.g=m,this.d=[],this.e=0}reset(w){return this.c=w,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new R(!1,!this.f(w)),this.b.reset(w.path),this.b.value()&&this.d.push(3)),this.g(w)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(w){if(this.d[this.e]===1)return(0,C.$Ue)(w,this.c.scheme);if(this.d[this.e]===2)return(0,C.$Ue)(w,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(w);if(this.d[this.e]===4)return(0,C.$Se)(w,this.c.query);if(this.d[this.e]===5)return(0,C.$Se)(w,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$Qh=D;class d{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const w=this.right;return this.right=w.left,w.left=this,this.updateHeight(),w.updateHeight(),w}rotateRight(){const w=this.left;return this.left=w.right,w.right=this,this.updateHeight(),w.updateHeight(),w}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var A;(function(a){a[a.Left=-1]="Left",a[a.Mid=0]="Mid",a[a.Right=1]="Right"})(A||(A={}));class k{static forUris(w=()=>!1,m=()=>!1){return new k(new D(w,m))}static forPaths(w=!1){return new k(new R(void 0,!w))}static forStrings(){return new k(new I)}static forConfigKeys(){return new k(new O)}constructor(w){this.b=w}clear(){this.c=void 0}fill(w,m){if(m){const f=m.slice(0);(0,h.$Vb)(f);for(const t of f)this.set(t,w)}else{const f=w.slice(0);(0,h.$Vb)(f);for(const t of f)this.set(t[0],t[1])}}set(w,m){const f=this.b.reset(w);let t;this.c||(this.c=new d,this.c.segment=f.value());const s=[];for(t=this.c;;){const v=f.cmp(t.segment);if(v>0)t.left||(t.left=new d,t.left.segment=f.value()),s.push([-1,t]),t=t.left;else if(v<0)t.right||(t.right=new d,t.right.segment=f.value()),s.push([1,t]),t=t.right;else if(f.hasNext())f.next(),t.mid||(t.mid=new d,t.mid.segment=f.value()),s.push([0,t]),t=t.mid;else break}const c=t.value;t.value=m,t.key=w;for(let v=s.length-1;v>=0;v--){const S=s[v][1];S.updateHeight();const p=S.balanceFactor();if(p<-1||p>1){const n=s[v][0],r=s[v+1][0];if(n===1&&r===1)s[v][1]=S.rotateLeft();else if(n===-1&&r===-1)s[v][1]=S.rotateRight();else if(n===1&&r===-1)S.right=s[v+1][1]=s[v+1][1].rotateRight(),s[v][1]=S.rotateLeft();else if(n===-1&&r===1)S.left=s[v+1][1]=s[v+1][1].rotateLeft(),s[v][1]=S.rotateRight();else throw new Error;if(v>0)switch(s[v-1][0]){case-1:s[v-1][1].left=s[v][1];break;case 1:s[v-1][1].right=s[v][1];break;case 0:s[v-1][1].mid=s[v][1];break}else this.c=s[0][1]}}return c}get(w){return this.d(w)?.value}d(w){const m=this.b.reset(w);let f=this.c;for(;f;){const t=m.cmp(f.segment);if(t>0)f=f.left;else if(t<0)f=f.right;else if(m.hasNext())m.next(),f=f.mid;else break}return f}has(w){const m=this.d(w);return!(m?.value===void 0&&m?.mid===void 0)}delete(w){return this.e(w,!1)}deleteSuperstr(w){return this.e(w,!0)}e(w,m){const f=this.b.reset(w),t=[];let s=this.c;for(;s;){const c=f.cmp(s.segment);if(c>0)t.push([-1,s]),s=s.left;else if(c<0)t.push([1,s]),s=s.right;else if(f.hasNext())f.next(),t.push([0,s]),s=s.mid;else break}if(s){if(m?(s.left=void 0,s.mid=void 0,s.right=void 0,s.height=1):(s.key=void 0,s.value=void 0),!s.mid&&!s.value)if(s.left&&s.right){const c=this.f(s.right);if(c.key){const{key:v,value:S,segment:p}=c;this.e(c.key,!1),s.key=v,s.value=S,s.segment=p}}else{const c=s.left??s.right;if(t.length>0){const[v,S]=t[t.length-1];switch(v){case-1:S.left=c;break;case 0:S.mid=c;break;case 1:S.right=c;break}}else this.c=c}for(let c=t.length-1;c>=0;c--){const v=t[c][1];v.updateHeight();const S=v.balanceFactor();if(S>1?(v.right.balanceFactor()>=0||(v.right=v.right.rotateRight()),t[c][1]=v.rotateLeft()):S<-1&&(v.left.balanceFactor()<=0||(v.left=v.left.rotateLeft()),t[c][1]=v.rotateRight()),c>0)switch(t[c-1][0]){case-1:t[c-1][1].left=t[c][1];break;case 1:t[c-1][1].right=t[c][1];break;case 0:t[c-1][1].mid=t[c][1];break}else this.c=t[0][1]}}}f(w){for(;w.left;)w=w.left;return w}findSubstr(w){const m=this.b.reset(w);let f=this.c,t;for(;f;){const s=m.cmp(f.segment);if(s>0)f=f.left;else if(s<0)f=f.right;else if(m.hasNext())m.next(),t=f.value||t,f=f.mid;else break}return f&&f.value||t}findSuperstr(w){return this.g(w,!1)}g(w,m){const f=this.b.reset(w);let t=this.c;for(;t;){const s=f.cmp(t.segment);if(s>0)t=t.left;else if(s<0)t=t.right;else if(f.hasNext())f.next(),t=t.mid;else return t.mid?this.h(t.mid):m?t.value:void 0}}hasElementOrSubtree(w){return this.g(w,!0)!==void 0}forEach(w){for(const[m,f]of this)w(f,m)}*[Symbol.iterator](){yield*this.h(this.c)}h(w){const m=[];return this.j(w,m),m[Symbol.iterator]()}j(w,m){w&&(w.left&&this.j(w.left,m),w.value&&m.push([w.key,w.value]),w.mid&&this.j(w.mid,m),w.right&&this.j(w.right,m))}_isBalanced(){const w=m=>{if(!m)return!0;const f=m.balanceFactor();return f<-1||f>1?!1:w(m.left)&&w(m.right)};return w(this.c)}}e.$Rh=k}),define(Ae[40],Re([1,0,19,22,15,16]),function(ie,e,h,C,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.$Tf=e.$Sf=e.$Rf=e.$Qf=e.$Pf=e.$Of=void 0;function R(g){return g===47||g===92}e.$Of=R;function u(g){return g.replace(/[\\/]/g,h.$ec.sep)}e.$Pf=u;function D(g){return g.indexOf("/")===-1&&(g=u(g)),/^[a-zA-Z]:(\/|$)/.test(g)&&(g="/"+g),g}e.$Qf=D;function d(g,E=h.$ec.sep){if(!g)return"";const P=g.length,l=g.charCodeAt(0);if(R(l)){if(R(g.charCodeAt(1))&&!R(g.charCodeAt(2))){let b=3;const M=b;for(;b<P&&!R(g.charCodeAt(b));b++);if(M!==b&&!R(g.charCodeAt(b+1))){for(b+=1;b<P;b++)if(R(g.charCodeAt(b)))return g.slice(0,b+1).replace(/[\\/]/g,E)}}return E}else if(s(l)&&g.charCodeAt(1)===58)return R(g.charCodeAt(2))?g.slice(0,2)+E:g.slice(0,2);let $=g.indexOf("://");if($!==-1){for($+=3;$<P;$++)if(R(g.charCodeAt($)))return g.slice(0,$+1)}return""}e.$Rf=d;function A(g){if(!C.$d||!g||g.length<5)return!1;let E=g.charCodeAt(0);if(E!==92||(E=g.charCodeAt(1),E!==92))return!1;let P=2;const l=P;for(;P<g.length&&(E=g.charCodeAt(P),E!==92);P++);return!(l===P||(E=g.charCodeAt(P+1),isNaN(E)||E===92))}e.$Sf=A;const k=/[\\/:\*\?"<>\|]/g,a=/[\\/]/g,w=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function m(g,E=C.$d){const P=E?k:a;return!(!g||g.length===0||/^\s+$/.test(g)||(P.lastIndex=0,P.test(g))||E&&w.test(g)||g==="."||g===".."||E&&g[g.length-1]==="."||E&&g.length!==g.trim().length||g.length>255)}e.$Tf=m;function f(g,E,P){const l=g===E;return!P||l?l:!g||!E?!1:(0,I.$Ze)(g,E)}e.$Uf=f;function t(g,E,P,l=h.sep){if(g===E)return!0;if(!g||!E||E.length>g.length)return!1;if(P){if(!(0,I.$1e)(g,E))return!1;if(E.length===g.length)return!0;let b=E.length;return E.charAt(E.length-1)===l&&b--,g.charAt(b)===l}return E.charAt(E.length-1)!==l&&(E+=l),g.indexOf(E)===0}e.$Vf=t;function s(g){return g>=65&&g<=90||g>=97&&g<=122}e.$Wf=s;function c(g,E){return C.$d&&g.endsWith(":")&&(g+=h.sep),(0,h.$gc)(g)||(g=(0,h.$hc)(E,g)),g=(0,h.$fc)(g),C.$d?(g=(0,I.$Ie)(g,h.sep),g.endsWith(":")&&(g+=h.sep)):(g=(0,I.$Ie)(g,h.sep),g||(g=h.sep)),g}e.$Xf=c;function v(g){const E=(0,h.$fc)(g);return C.$d?g.length>3?!1:S(E)&&(g.length===2||E.charCodeAt(2)===92):E===h.$ec.sep}e.$Yf=v;function S(g,E=C.$d){return E?s(g.charCodeAt(0))&&g.charCodeAt(1)===58:!1}e.$Zf=S;function p(g,E=C.$d){return S(g,E)?g[0]:void 0}e.$1f=p;function n(g,E,P){return E.length>g.length?-1:g===E?0:(P&&(g=g.toLowerCase(),E=E.toLowerCase()),g.indexOf(E))}e.$2f=n;function r(g){const E=g.split(":");let P,l,$;for(const b of E){const M=Number(b);(0,O.$Af)(M)?l===void 0?l=M:$===void 0&&($=M):P=P?[P,b].join(":"):b}if(!P)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:P,line:l!==void 0?l:void 0,column:$!==void 0?$:l!==void 0?1:void 0}}e.$3f=r;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",o="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function y(g,E,P=8){let l="";for(let b=0;b<P;b++){let M;b===0&&C.$d&&!E&&(P===3||P===4)?M=o:M=i,l+=M.charAt(Math.floor(Math.random()*M.length))}let $;return E?$=`${E}-${l}`:$=l,g?(0,h.$hc)(g,$):$}e.$4f=y}),define(Ae[41],Re([1,0,89]),function(ie,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$Rj=e.ThemeColor=void 0;var C;(function(R){function u(D){return D&&typeof D=="object"&&typeof D.id=="string"}R.isThemeColor=u})(C||(e.ThemeColor=C={}));function I(R){return{id:R}}e.$Rj=I;var O;(function(R){R.iconNameSegment="[A-Za-z0-9]+",R.iconNameExpression="[A-Za-z0-9-]+",R.iconModifierExpression="~[A-Za-z]+",R.iconNameCharacter="[A-Za-z0-9~-]";const u=new RegExp(`^(${R.iconNameExpression})(${R.iconModifierExpression})?$`);function D(c){const v=u.exec(c.id);if(!v)return D(h.$Qj.error);const[,S,p]=v,n=["codicon","codicon-"+S];return p&&n.push("codicon-modifier-"+p.substring(1)),n}R.asClassNameArray=D;function d(c){return D(c).join(" ")}R.asClassName=d;function A(c){return"."+D(c).join(".")}R.asCSSSelector=A;function k(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(typeof c.color>"u"||C.isThemeColor(c.color))}R.isThemeIcon=k;const a=new RegExp(`^\\$\\((${R.iconNameExpression}(?:${R.iconModifierExpression})?)\\)$`);function w(c){const v=a.exec(c);if(!v)return;const[,S]=v;return{id:S}}R.fromString=w;function m(c){return{id:c}}R.fromId=m;function f(c,v){let S=c.id;const p=S.lastIndexOf("~");return p!==-1&&(S=S.substring(0,p)),v&&(S=`${S}~${v}`),{id:S}}R.modify=f;function t(c){const v=c.id.lastIndexOf("~");if(v!==-1)return c.id.substring(v+1)}R.getModifier=t;function s(c,v){return c.id===v.id&&c.color?.id===v.color?.id}R.isEqual=s})(O||(e.ThemeIcon=O={}))}),define(Ae[122],Re([1,0,120,15,41]),function(ie,e,h,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=void 0;const O="$(",R=new RegExp(`\\$\\(${I.ThemeIcon.iconNameExpression}(?:${I.ThemeIcon.iconModifierExpression})?\\)`,"g"),u=new RegExp(`(\\\\)?${R.source}`,"g");function D(s){return s.replace(u,(c,v)=>v?c:`\\${c}`)}e.$Sj=D;const d=new RegExp(`\\\\${R.source}`,"g");function A(s){return s.replace(d,c=>`\\${c}`)}e.$Tj=A;const k=new RegExp(`(\\s)?(\\\\)?${R.source}(\\s)?`,"g");function a(s){return s.indexOf(O)===-1?s:s.replace(k,(c,v,S,p)=>S?c:v||p||"")}e.$Uj=a;function w(s){return s?s.replace(/\$\((.*?)\)/g,(c,v)=>` ${v} `).trim():""}e.$Vj=w;const m=new RegExp(`\\$\\(${I.ThemeIcon.iconNameCharacter}+\\)`,"g");function f(s){m.lastIndex=0;let c="";const v=[];let S=0;for(;;){const p=m.lastIndex,n=m.exec(s),r=s.substring(p,n?.index);if(r.length>0){c+=r;for(let i=0;i<r.length;i++)v.push(S)}if(!n)break;S+=n[0].length}return{text:c,iconOffsets:v}}e.$Wj=f;function t(s,c,v=!1){const{text:S,iconOffsets:p}=c;if(!p||p.length===0)return(0,h.$Fj)(s,S,v);const n=(0,C.$He)(S," "),r=S.length-n.length,i=(0,h.$Fj)(s,n,v);if(i)for(const o of i){const y=p[o.start+r]+r;o.start+=y,o.end+=y}return i}e.$Xj=t}),define(Ae[68],Re([1,0,25,2]),function(ie,e,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ih=e.$hh=e.$gh=void 0;function I(D){return JSON.stringify(D,R)}e.$gh=I;function O(D){let d=JSON.parse(D);return d=u(d),d}e.$hh=O;function R(D,d){return d instanceof RegExp?{$mid:2,source:d.source,flags:d.flags}:d}function u(D,d=0){if(!D||d>200)return D;if(typeof D=="object"){switch(D.$mid){case 1:return C.URI.revive(D);case 2:return new RegExp(D.source,D.flags);case 17:return new Date(D.source)}if(D instanceof h.$_d||D instanceof Uint8Array)return D;if(Array.isArray(D))for(let A=0;A<D.length;++A)D[A]=u(D[A],d+1);else for(const A in D)Object.hasOwnProperty.call(D,A)&&(D[A]=u(D[A],d+1))}return D}e.$ih=u}),define(Ae[13],Re([1,0,9,22,2]),function(ie,e,h,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.Schemas=void 0;var O;(function(d){d.inMemory="inmemory",d.vscode="vscode",d.internal="private",d.walkThrough="walkThrough",d.walkThroughSnippet="walkThroughSnippet",d.http="http",d.https="https",d.file="file",d.mailto="mailto",d.untitled="untitled",d.data="data",d.command="command",d.vscodeRemote="vscode-remote",d.vscodeRemoteResource="vscode-remote-resource",d.vscodeManagedRemoteResource="vscode-managed-remote-resource",d.vscodeUserData="vscode-userdata",d.vscodeCustomEditor="vscode-custom-editor",d.vscodeNotebookCell="vscode-notebook-cell",d.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",d.vscodeNotebookCellOutput="vscode-notebook-cell-output",d.vscodeInteractiveInput="vscode-interactive-input",d.vscodeSettings="vscode-settings",d.vscodeWorkspaceTrust="vscode-workspace-trust",d.vscodeTerminal="vscode-terminal",d.vscodeChatSesssion="vscode-chat-editor",d.webviewPanel="webview-panel",d.vscodeWebview="vscode-webview",d.extension="extension",d.vscodeFileResource="vscode-file",d.tmp="tmp",d.vsls="vsls",d.vscodeSourceControl="vscode-scm"})(O||(e.Schemas=O={})),e.$5f="vscode-tkn",e.$6f="tkn";class R{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${O.vscodeRemoteResource}`}setPreferredWebSchema(A){this.d=A}setDelegate(A){this.e=A}setServerRootPath(A){this.f=`${A}/${O.vscodeRemoteResource}`}set(A,k,a){this.a[A]=k,this.b[A]=a}setConnectionToken(A,k){this.c[A]=k}getPreferredWebSchema(){return this.d}rewrite(A){if(this.e)try{return this.e(A)}catch(t){return h.$Y(t),A}const k=A.authority;let a=this.a[k];a&&a.indexOf(":")!==-1&&a.indexOf("[")===-1&&(a=`[${a}]`);const w=this.b[k],m=this.c[k];let f=`path=${encodeURIComponent(A.path)}`;return typeof m=="string"&&(f+=`&${e.$6f}=${encodeURIComponent(m)}`),I.URI.from({scheme:C.$j?this.d:O.vscodeRemoteResource,authority:`${a}:${w}`,path:C.$j?(window.location.pathname+"/"+this.f).replace(/\/\/+/g,"/"):this.f,query:f})}}e.$7f=new R,e.$8f="vs/../../extensions",e.$9f="vs/../../node_modules",e.$0f="vs/../../node_modules.asar",e.$$f="vs/../../node_modules.asar.unpacked";class u{asBrowserUri(A){const k=this.b(A,ie);return this.uriToBrowserUri(k)}uriToBrowserUri(A){return A.scheme===O.vscodeRemote?e.$7f.rewrite(A):A.scheme===O.file&&(C.$h||C.$k&&C.$b.origin===`${O.vscodeFileResource}://${u.a}`)?A.with({scheme:O.vscodeFileResource,authority:A.authority||u.a,query:null,fragment:null}):A}asFileUri(A){const k=this.b(A,ie);return this.uriToFileUri(k)}uriToFileUri(A){return A.scheme===O.vscodeFileResource?A.with({scheme:O.file,authority:A.authority!==u.a?A.authority:null,query:null,fragment:null}):A}b(A,k){return I.URI.isUri(A)?A:I.URI.parse(k.toUrl(A))}}u.a="vscode-app",e.$_f=new u;var D;(function(d){const A=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);d.CoopAndCoep=Object.freeze(A.get("3"));const k="vscode-coi";function a(m){let f;typeof m=="string"?f=new URL(m).searchParams:m instanceof URL?f=m.searchParams:I.URI.isUri(m)&&(f=new URL(m.toString(!0)).searchParams);const t=f?.get(k);if(t)return A.get(t)}d.getHeadersFromQuery=a;function w(m,f,t){if(!globalThis.crossOriginIsolated)return;const s=f&&t?"3":t?"2":"1";m instanceof URLSearchParams?m.set(k,s):m[k]=s}d.addSearchParam=w})(D||(e.COI=D={}))}),define(Ae[23],Re([1,0,40,13,19,22,15,2]),function(ie,e,h,C,I,O,R,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cg=e.DataUri=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=e.$hg=e.$gg=void 0;function D(w){return(0,u.$uc)(w,!0)}e.$gg=D;class d{constructor(m){this.a=m}compare(m,f,t=!1){return m===f?0:(0,R.$Se)(this.getComparisonKey(m,t),this.getComparisonKey(f,t))}isEqual(m,f,t=!1){return m===f?!0:!m||!f?!1:this.getComparisonKey(m,t)===this.getComparisonKey(f,t)}getComparisonKey(m,f=!1){return m.with({path:this.a(m)?m.path.toLowerCase():void 0,fragment:f?null:void 0}).toString()}ignorePathCasing(m){return this.a(m)}isEqualOrParent(m,f,t=!1){if(m.scheme===f.scheme){if(m.scheme===C.Schemas.file)return h.$Vf(D(m),D(f),this.a(m))&&m.query===f.query&&(t||m.fragment===f.fragment);if((0,e.$xg)(m.authority,f.authority))return h.$Vf(m.path,f.path,this.a(m),"/")&&m.query===f.query&&(t||m.fragment===f.fragment)}return!1}joinPath(m,...f){return u.URI.joinPath(m,...f)}basenameOrAuthority(m){return(0,e.$pg)(m)||m.authority}basename(m){return I.$ec.basename(m.path)}extname(m){return I.$ec.extname(m.path)}dirname(m){if(m.path.length===0)return m;let f;return m.scheme===C.Schemas.file?f=u.URI.file(I.$kc(D(m))).path:(f=I.$ec.dirname(m.path),m.authority&&f.length&&f.charCodeAt(0)!==47&&(console.error(`dirname("${m.toString})) resulted in a relative path`),f="/")),m.with({path:f})}normalizePath(m){if(!m.path.length)return m;let f;return m.scheme===C.Schemas.file?f=u.URI.file(I.$fc(D(m))).path:f=I.$ec.normalize(m.path),m.with({path:f})}relativePath(m,f){if(m.scheme!==f.scheme||!(0,e.$xg)(m.authority,f.authority))return;if(m.scheme===C.Schemas.file){const c=I.$jc(D(m),D(f));return O.$d?h.$Pf(c):c}let t=m.path||"/";const s=f.path||"/";if(this.a(m)){let c=0;for(const v=Math.min(t.length,s.length);c<v&&!(t.charCodeAt(c)!==s.charCodeAt(c)&&t.charAt(c).toLowerCase()!==s.charAt(c).toLowerCase());c++);t=s.substr(0,c)+t.substr(c)}return I.$ec.relative(t,s)}resolvePath(m,f){if(m.scheme===C.Schemas.file){const t=u.URI.file(I.$ic(D(m),f));return m.with({authority:t.authority,path:t.path})}return f=h.$Qf(f),m.with({path:I.$ec.resolve(m.path,f)})}isAbsolutePath(m){return!!m.path&&m.path[0]==="/"}isEqualAuthority(m,f){return m===f||m!==void 0&&f!==void 0&&(0,R.$Ze)(m,f)}hasTrailingPathSeparator(m,f=I.sep){if(m.scheme===C.Schemas.file){const t=D(m);return t.length>h.$Rf(t).length&&t[t.length-1]===f}else{const t=m.path;return t.length>1&&t.charCodeAt(t.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(m.fsPath)}}removeTrailingPathSeparator(m,f=I.sep){return(0,e.$yg)(m,f)?m.with({path:m.path.substr(0,m.path.length-1)}):m}addTrailingPathSeparator(m,f=I.sep){let t=!1;if(m.scheme===C.Schemas.file){const s=D(m);t=s!==void 0&&s.length===h.$Rf(s).length&&s[s.length-1]===f}else{f="/";const s=m.path;t=s.length===1&&s.charCodeAt(s.length-1)===47}return!t&&!(0,e.$yg)(m,f)?m.with({path:m.path+"/"}):m}}e.$hg=d,e.$ig=new d(()=>!1),e.$jg=new d(w=>w.scheme===C.Schemas.file?!O.$f:!0),e.$kg=new d(w=>!0),e.$lg=e.$ig.isEqual.bind(e.$ig),e.$mg=e.$ig.isEqualOrParent.bind(e.$ig),e.$ng=e.$ig.getComparisonKey.bind(e.$ig),e.$og=e.$ig.basenameOrAuthority.bind(e.$ig),e.$pg=e.$ig.basename.bind(e.$ig),e.$qg=e.$ig.extname.bind(e.$ig),e.$rg=e.$ig.dirname.bind(e.$ig),e.$sg=e.$ig.joinPath.bind(e.$ig),e.$tg=e.$ig.normalizePath.bind(e.$ig),e.$ug=e.$ig.relativePath.bind(e.$ig),e.$vg=e.$ig.resolvePath.bind(e.$ig),e.$wg=e.$ig.isAbsolutePath.bind(e.$ig),e.$xg=e.$ig.isEqualAuthority.bind(e.$ig),e.$yg=e.$ig.hasTrailingPathSeparator.bind(e.$ig),e.$zg=e.$ig.removeTrailingPathSeparator.bind(e.$ig),e.$Ag=e.$ig.addTrailingPathSeparator.bind(e.$ig);function A(w,m){const f=[];for(let t=0;t<w.length;t++){const s=m(w[t]);w.some((c,v)=>v===t?!1:(0,e.$mg)(s,m(c)))||f.push(w[t])}return f}e.$Bg=A;var k;(function(w){w.META_DATA_LABEL="label",w.META_DATA_DESCRIPTION="description",w.META_DATA_SIZE="size",w.META_DATA_MIME="mime";function m(f){const t=new Map;f.path.substring(f.path.indexOf(";")+1,f.path.lastIndexOf(";")).split(";").forEach(v=>{const[S,p]=v.split(":");S&&p&&t.set(S,p)});const c=f.path.substring(0,f.path.indexOf(";"));return c&&t.set(w.META_DATA_MIME,c),t}w.parseMetaData=m})(k||(e.DataUri=k={}));function a(w,m,f){if(m){let t=w.path;return t&&t[0]!==I.$ec.sep&&(t=I.$ec.sep+t),w.with({scheme:f,authority:m,path:t})}return w.with({scheme:f})}e.$Cg=a}),define(Ae[12],Re([1,0,21,9,5,6,23,22,121]),function(ie,e,h,C,I,O,R,u,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ch=e.$bh=e.$ah=e.Promises=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=void 0;function d(V){return!!V&&typeof V.then=="function"}e.$Dg=d;function A(V){const Q=new h.$Vd,ee=V(Q.token),$e=new Promise((he,fe)=>{const Ee=Q.token.onCancellationRequested(()=>{Ee.dispose(),Q.dispose(),fe(new C.$3)});Promise.resolve(ee).then(re=>{Ee.dispose(),Q.dispose(),he(re)},re=>{Ee.dispose(),Q.dispose(),fe(re)})});return new class{cancel(){Q.cancel()}then(he,fe){return $e.then(he,fe)}catch(he){return this.then(void 0,he)}finally(he){return $e.finally(he)}}}e.$Eg=A;function k(V,Q,ee){return new Promise(($e,he)=>{const fe=Q.onCancellationRequested(()=>{fe.dispose(),$e(ee)});V.then($e,he).finally(()=>fe.dispose())})}e.$Fg=k;function a(V,Q){return new Promise((ee,$e)=>{const he=Q.onCancellationRequested(()=>{he.dispose(),$e(new C.$3)});V.then(ee,$e).finally(()=>he.dispose())})}e.$Gg=a;async function w(V){let Q=-1;const ee=V.map(($e,he)=>$e.then(fe=>(Q=he,fe)));try{return await Promise.race(ee)}finally{V.forEach(($e,he)=>{he!==Q&&$e.cancel()})}}e.$Hg=w;function m(V,Q,ee){let $e;const he=setTimeout(()=>{$e?.(void 0),ee?.()},Q);return Promise.race([V.finally(()=>clearTimeout(he)),new Promise(fe=>$e=fe)])}e.$Ig=m;function f(V){return new Promise((Q,ee)=>{const $e=V();d($e)?$e.then(Q,ee):Q($e)})}e.$Jg=f;class t{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(Q){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=Q,!this.b){const ee=()=>{if(this.b=null,this.f)return;const $e=this.queue(this.d);return this.d=null,$e};this.b=new Promise($e=>{this.a.then(ee,ee).then($e)})}return new Promise((ee,$e)=>{this.b.then(ee,$e)})}return this.a=Q(),new Promise((ee,$e)=>{this.a.then(he=>{this.a=null,ee(he)},he=>{this.a=null,$e(he)})})}dispose(){this.f=!0}}e.$Kg=t;class s{constructor(){this.a=Promise.resolve(null)}queue(Q){return this.a=this.a.then(()=>Q(),()=>Q())}}e.$Lg=s;class c{constructor(){this.a=new Map}queue(Q,ee){const he=(this.a.get(Q)??Promise.resolve()).catch(()=>{}).then(ee).finally(()=>{this.a.get(Q)===he&&this.a.delete(Q)});return this.a.set(Q,he),he}}e.$Mg=c;const v=(V,Q)=>{let ee=!0;const $e=setTimeout(()=>{ee=!1,Q()},V);return{isTriggered:()=>ee,dispose:()=>{clearTimeout($e),ee=!1}}},S=V=>{let Q=!0;return queueMicrotask(()=>{Q&&(Q=!1,V())}),{isTriggered:()=>Q,dispose:()=>{Q=!1}}};class p{constructor(Q){this.defaultDelay=Q,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(Q,ee=this.defaultDelay){this.g=Q,this.h(),this.b||(this.b=new Promise((he,fe)=>{this.d=he,this.f=fe}).then(()=>{if(this.b=null,this.d=null,this.g){const he=this.g;return this.g=null,he()}}));const $e=()=>{this.a=null,this.d?.(null)};return this.a=ee===D.$Id?S($e):v(ee,$e),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new C.$3),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Ng=p;class n{constructor(Q){this.a=new p(Q),this.b=new t}trigger(Q,ee){return this.a.trigger(()=>this.b.queue(Q),ee)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Og=n;class r{constructor(){this.a=!1,this.b=new Promise((Q,ee)=>{this.d=Q})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Pg=r;class i extends r{constructor(Q){super(),this.f=setTimeout(()=>this.open(),Q)}open(){clearTimeout(this.f),super.open()}}e.$Qg=i;function o(V,Q){return Q?new Promise((ee,$e)=>{const he=setTimeout(()=>{fe.dispose(),ee()},V),fe=Q.onCancellationRequested(()=>{clearTimeout(he),fe.dispose(),$e(new C.$3)})}):A(ee=>o(V,ee))}e.$Rg=o;function y(V,Q=0,ee){const $e=setTimeout(()=>{V(),ee&&he.dispose()},Q),he=(0,O.$Oc)(()=>{clearTimeout($e),ee?.deleteAndLeak(he)});return ee?.add(he),he}e.$Sg=y;function g(V){const Q=[];let ee=0;const $e=V.length;function he(){return ee<$e?V[ee++]():null}function fe(Ee){Ee!=null&&Q.push(Ee);const re=he();return re?re.then(fe):Promise.resolve(Q)}return Promise.resolve(null).then(fe)}e.$Tg=g;function E(V,Q=$e=>!!$e,ee=null){let $e=0;const he=V.length,fe=()=>{if($e>=he)return Promise.resolve(ee);const Ee=V[$e++];return Promise.resolve(Ee()).then(le=>Q(le)?Promise.resolve(le):fe())};return fe()}e.$Ug=E;function P(V,Q=$e=>!!$e,ee=null){if(V.length===0)return Promise.resolve(ee);let $e=V.length;const he=()=>{$e=-1;for(const fe of V)fe.cancel?.()};return new Promise((fe,Ee)=>{for(const re of V)re.then(le=>{--$e>=0&&Q(le)?(he(),fe(le)):$e===0&&fe(ee)}).catch(le=>{--$e>=0&&(he(),Ee(le))})})}e.$Vg=P;class l{constructor(Q){this.a=0,this.d=Q,this.f=[],this.b=0,this.g=new I.$Ld}get onDrained(){return this.g.event}get size(){return this.a}queue(Q){return this.a++,new Promise((ee,$e)=>{this.f.push({factory:Q,c:ee,e:$e}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const Q=this.f.shift();this.b++;const ee=Q.factory();ee.then(Q.c,Q.e),ee.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$Wg=l;class $ extends l{constructor(){super(1)}}e.$Xg=$;class b{constructor(){this.a=new me,this.b=0}queue(Q){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,Q())):this.a.run(this.b++,Q())}}e.$Yg=b;class M{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const Q=new _;return this.b.add(Q),Q.p}g(){for(const[,Q]of this.a)if(Q.size>0)return!1;return!0}queueFor(Q,ee=R.$ig){const $e=ee.getComparisonKey(Q);let he=this.a.get($e);if(!he){he=new $;const fe=this.f++,Ee=I.Event.once(he.onDrained)(()=>{he?.dispose(),this.a.delete($e),this.h(),this.d?.deleteAndDispose(fe),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new O.$Yc),this.d.set(fe,Ee),this.a.set($e,he)}return he}h(){this.g()&&this.j()}j(){for(const Q of this.b)Q.complete();this.b.clear()}dispose(){for(const[,Q]of this.a)Q.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Zg=M;class U{constructor(Q,ee){this.a=-1,typeof Q=="function"&&typeof ee=="number"&&this.setIfNotSet(Q,ee)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(Q,ee){this.cancel(),this.a=setTimeout(()=>{this.a=-1,Q()},ee)}setIfNotSet(Q,ee){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,Q()},ee))}}e.$1g=U;class F{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(Q,ee){this.cancel(),this.a=setInterval(()=>{Q()},ee)}}e.$2g=F;class q{constructor(Q,ee){this.b=-1,this.a=Q,this.d=ee,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(Q=this.d){this.cancel(),this.b=setTimeout(this.f,Q)}get delay(){return this.d}set delay(Q){this.d=Q}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$3g=q;class W{constructor(Q,ee){ee%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ee}ms is not a multiple of 1000ms.`),this.a=Q,this.b=ee,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(Q=this.b){Q%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Q}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(Q/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$4g=W;class L extends q{constructor(Q,ee){super(Q,ee),this.j=[]}work(Q){this.j.push(Q),this.isScheduled()||this.schedule()}h(){const Q=this.j;this.j=[],this.a?.(Q)}dispose(){this.j=[],super.dispose()}}e.$5g=L;class z extends O.$Qc{constructor(Q,ee){super(),this.g=Q,this.h=ee,this.a=[],this.b=this.B(new O.$Rc),this.f=!1}get pending(){return this.a.length}work(Q){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+Q.length>this.g.maxBufferedWork)return!1}else if(this.pending+Q.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const ee of Q)this.a.push(ee);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new q(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$6g=z,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.$7g=V=>{(0,u.$v)(()=>{if(Q)return;const ee=Date.now()+15;V(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ee-Date.now())}}))});let Q=!1;return{dispose(){Q||(Q=!0)}}}:e.$7g=(V,Q)=>{const ee=requestIdleCallback(V,typeof Q=="number"?{timeout:Q}:void 0);let $e=!1;return{dispose(){$e||($e=!0,cancelIdleCallback(ee))}}}}();class K{constructor(Q){this.d=!1,this.a=()=>{try{this.f=Q()}catch(ee){this.g=ee}finally{this.d=!0}},this.b=(0,e.$7g)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.$8g=K;async function B(V,Q,ee){let $e;for(let he=0;he<ee;he++)try{return await V()}catch(fe){$e=fe,await o(Q)}throw $e}e.$9g=B;class me{isRunning(Q){return typeof Q=="number"?this.a?.taskId===Q:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(Q,ee,$e){return this.a={taskId:Q,cancel:()=>$e?.(),promise:ee},ee.then(()=>this.d(Q),()=>this.d(Q)),ee}d(Q){this.a&&Q===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const Q=this.b;this.b=void 0,Q.run().then(Q.promiseResolve,Q.promiseReject)}}queue(Q){if(this.b)this.b.run=Q;else{let ee,$e;const he=new Promise((fe,Ee)=>{ee=fe,$e=Ee});this.b={run:Q,promise:he,promiseResolve:ee,promiseReject:$e}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$0g=me;class ye{constructor(Q,ee=()=>Date.now()){this.d=Q,this.f=ee,this.a=0,this.b=0}increment(){const Q=this.f();return Q-this.a>this.d&&(this.a=Q,this.b=0),this.b++,this.b}}e.$$g=ye;var Ie;(function(V){V[V.Resolved=0]="Resolved",V[V.Rejected=1]="Rejected"})(Ie||(Ie={}));class _{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((Q,ee)=>{this.a=Q,this.b=ee})}complete(Q){return new Promise(ee=>{this.a(Q),this.d={outcome:0,value:Q},ee()})}error(Q){return new Promise(ee=>{this.b(Q),this.d={outcome:1,value:Q},ee()})}cancel(){return this.error(new C.$3)}}e.$_g=_;var de;(function(V){async function Q($e){let he;const fe=await Promise.all($e.map(Ee=>Ee.then(re=>re,re=>{he||(he=re)})));if(typeof he<"u")throw he;return fe}V.settled=Q;function ee($e){return new Promise(async(he,fe)=>{try{await $e(he,fe)}catch(Ee){fe(Ee)}})}V.withAsyncBody=ee})(de||(e.Promises=de={}));var De;(function(V){V[V.Initial=0]="Initial",V[V.DoneOK=1]="DoneOK",V[V.DoneError=2]="DoneError"})(De||(De={}));class ue{static fromArray(Q){return new ue(ee=>{ee.emitMany(Q)})}static fromPromise(Q){return new ue(async ee=>{ee.emitMany(await Q)})}static fromPromises(Q){return new ue(async ee=>{await Promise.all(Q.map(async $e=>ee.emitOne(await $e)))})}static merge(Q){return new ue(async ee=>{await Promise.all(Q.map(async $e=>{for await(const he of $e)ee.emitOne(he)}))})}constructor(Q){this.a=0,this.b=[],this.d=null,this.f=new I.$Ld,queueMicrotask(async()=>{const ee={emitOne:$e=>this.g($e),emitMany:$e=>this.h($e),reject:$e=>this.k($e)};try{await Promise.resolve(Q(ee)),this.j()}catch($e){this.k($e)}finally{ee.emitOne=void 0,ee.emitMany=void 0,ee.reject=void 0}})}[Symbol.asyncIterator](){let Q=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(Q<this.b.length)return{done:!1,value:this.b[Q++]};if(this.a===1)return{done:!0,value:void 0};await I.Event.toPromise(this.f.event)}while(!0)}}}static map(Q,ee){return new ue(async $e=>{for await(const he of Q)$e.emitOne(ee(he))})}map(Q){return ue.map(this,Q)}static filter(Q,ee){return new ue(async $e=>{for await(const he of Q)ee(he)&&$e.emitOne(he)})}filter(Q){return ue.filter(this,Q)}static coalesce(Q){return ue.filter(Q,ee=>!!ee)}coalesce(){return ue.coalesce(this)}static async toPromise(Q){const ee=[];for await(const $e of Q)ee.push($e);return ee}toPromise(){return ue.toPromise(this)}g(Q){this.a===0&&(this.b.push(Q),this.f.fire())}h(Q){this.a===0&&(this.b=this.b.concat(Q),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(Q){this.a===0&&(this.a=2,this.d=Q,this.f.fire())}}e.$ah=ue,ue.EMPTY=ue.fromArray([]);class ve extends ue{constructor(Q,ee){super(ee),this.l=Q}cancel(){this.l.cancel()}}e.$bh=ve;function ke(V){const Q=new h.$Vd,ee=V(Q.token);return new ve(Q,async $e=>{const he=Q.token.onCancellationRequested(()=>{he.dispose(),Q.dispose(),$e.reject(new C.$3)});try{for await(const fe of ee){if(Q.token.isCancellationRequested)return;$e.emitOne(fe)}he.dispose(),Q.dispose()}catch(fe){he.dispose(),Q.dispose(),$e.reject(fe)}})}e.$ch=ke}),define(Ae[36],Re([1,0,18,12,40,28,19,22,15]),function(ie,e,h,C,I,O,R,u,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=void 0;function d(){return Object.create(null)}e.$nj=d,e.$oj="**",e.$pj="/";const A="[/\\\\]",k="[^/\\\\]",a=/\//g;function w(me,ye){switch(me){case 0:return"";case 1:return`${k}*?`;default:return`(?:${A}|${k}+${A}${ye?`|${A}${k}+`:""})*?`}}function m(me,ye){if(!me)return[];const Ie=[];let _=!1,de=!1,De="";for(const ue of me){switch(ue){case ye:if(!_&&!de){Ie.push(De),De="";continue}break;case"{":_=!0;break;case"}":_=!1;break;case"[":de=!0;break;case"]":de=!1;break}De+=ue}return De&&Ie.push(De),Ie}e.$qj=m;function f(me){if(!me)return"";let ye="";const Ie=m(me,e.$pj);if(Ie.every(_=>_===e.$oj))ye=".*";else{let _=!1;Ie.forEach((de,De)=>{if(de===e.$oj){if(_)return;ye+=w(2,De===Ie.length-1)}else{let ue=!1,ve="",ke=!1,V="";for(const Q of de){if(Q!=="}"&&ue){ve+=Q;continue}if(ke&&(Q!=="]"||!V)){let ee;Q==="-"?ee=Q:(Q==="^"||Q==="!")&&!V?ee="^":Q===e.$pj?ee="":ee=(0,D.$De)(Q),V+=ee;continue}switch(Q){case"{":ue=!0;continue;case"[":ke=!0;continue;case"}":{const $e=`(?:${m(ve,",").map(he=>f(he)).join("|")})`;ye+=$e,ue=!1,ve="";break}case"]":{ye+="["+V+"]",ke=!1,V="";break}case"?":ye+=k;continue;case"*":ye+=w(1);continue;default:ye+=(0,D.$De)(Q)}}De<Ie.length-1&&(Ie[De+1]!==e.$oj||De+2<Ie.length)&&(ye+=A)}_=de===e.$oj})}return ye}const t=/^\*\*\/\*\.[\w\.-]+$/,s=/^\*\*\/([\w\.-]+)\/?$/,c=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,v=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,S=/^\*\*((\/[\w\.-]+)+)\/?$/,p=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,n=new O.$Bc(1e4),r=function(){return!1},i=function(){return null};function o(me,ye){if(!me)return i;let Ie;typeof me!="string"?Ie=me.pattern:Ie=me,Ie=Ie.trim();const _=`${Ie}_${!!ye.trimForExclusions}`;let de=n.get(_);if(de)return y(de,me);let De;return t.test(Ie)?de=E(Ie.substr(4),Ie):(De=s.exec(g(Ie,ye)))?de=P(De[1],Ie):(ye.trimForExclusions?v:c).test(Ie)?de=l(Ie,ye):(De=S.exec(g(Ie,ye)))?de=$(De[1].substr(1),Ie,!0):(De=p.exec(g(Ie,ye)))?de=$(De[1],Ie,!1):de=b(Ie),n.set(_,de),y(de,me)}function y(me,ye){if(typeof ye=="string")return me;const Ie=function(_,de){return(0,I.$Vf)(_,ye.base,!u.$f)?me((0,D.$He)(_.substr(ye.base.length),R.sep),de):null};return Ie.allBasenames=me.allBasenames,Ie.allPaths=me.allPaths,Ie.basenames=me.basenames,Ie.patterns=me.patterns,Ie}function g(me,ye){return ye.trimForExclusions&&me.endsWith("/**")?me.substr(0,me.length-2):me}function E(me,ye){return function(Ie,_){return typeof Ie=="string"&&Ie.endsWith(me)?ye:null}}function P(me,ye){const Ie=`/${me}`,_=`\\${me}`,de=function(ue,ve){return typeof ue!="string"?null:ve?ve===me?ye:null:ue===me||ue.endsWith(Ie)||ue.endsWith(_)?ye:null},De=[me];return de.basenames=De,de.patterns=[ye],de.allBasenames=De,de}function l(me,ye){const Ie=K(me.slice(1,-1).split(",").map(ve=>o(ve,ye)).filter(ve=>ve!==i),me),_=Ie.length;if(!_)return i;if(_===1)return Ie[0];const de=function(ve,ke){for(let V=0,Q=Ie.length;V<Q;V++)if(Ie[V](ve,ke))return me;return null},De=Ie.find(ve=>!!ve.allBasenames);De&&(de.allBasenames=De.allBasenames);const ue=Ie.reduce((ve,ke)=>ke.allPaths?ve.concat(ke.allPaths):ve,[]);return ue.length&&(de.allPaths=ue),de}function $(me,ye,Ie){const _=R.sep===R.$ec.sep,de=_?me:me.replace(a,R.sep),De=R.sep+de,ue=R.$ec.sep+me;let ve;return Ie?ve=function(ke,V){return typeof ke=="string"&&(ke===de||ke.endsWith(De)||!_&&(ke===me||ke.endsWith(ue)))?ye:null}:ve=function(ke,V){return typeof ke=="string"&&(ke===de||!_&&ke===me)?ye:null},ve.allPaths=[(Ie?"*/":"./")+me],ve}function b(me){try{const ye=new RegExp(`^${f(me)}$`);return function(Ie){return ye.lastIndex=0,typeof Ie=="string"&&ye.test(Ie)?me:null}}catch{return i}}function M(me,ye,Ie){return!me||typeof ye!="string"?!1:U(me)(ye,void 0,Ie)}e.$rj=M;function U(me,ye={}){if(!me)return r;if(typeof me=="string"||F(me)){const Ie=o(me,ye);if(Ie===i)return r;const _=function(de,De){return!!Ie(de,De)};return Ie.allBasenames&&(_.allBasenames=Ie.allBasenames),Ie.allPaths&&(_.allPaths=Ie.allPaths),_}return L(me,ye)}e.$sj=U;function F(me){const ye=me;return ye?typeof ye.base=="string"&&typeof ye.pattern=="string":!1}e.$tj=F;function q(me){return me.allBasenames||[]}e.$uj=q;function W(me){return me.allPaths||[]}e.$vj=W;function L(me,ye){const Ie=K(Object.getOwnPropertyNames(me).map(ve=>z(ve,me[ve],ye)).filter(ve=>ve!==i)),_=Ie.length;if(!_)return i;if(!Ie.some(ve=>!!ve.requiresSiblings)){if(_===1)return Ie[0];const ve=function(Q,ee){let $e;for(let he=0,fe=Ie.length;he<fe;he++){const Ee=Ie[he](Q,ee);if(typeof Ee=="string")return Ee;(0,C.$Dg)(Ee)&&($e||($e=[]),$e.push(Ee))}return $e?(async()=>{for(const he of $e){const fe=await he;if(typeof fe=="string")return fe}return null})():null},ke=Ie.find(Q=>!!Q.allBasenames);ke&&(ve.allBasenames=ke.allBasenames);const V=Ie.reduce((Q,ee)=>ee.allPaths?Q.concat(ee.allPaths):Q,[]);return V.length&&(ve.allPaths=V),ve}const de=function(ve,ke,V){let Q,ee;for(let $e=0,he=Ie.length;$e<he;$e++){const fe=Ie[$e];fe.requiresSiblings&&V&&(ke||(ke=(0,R.$lc)(ve)),Q||(Q=ke.substr(0,ke.length-(0,R.$mc)(ve).length)));const Ee=fe(ve,ke,Q,V);if(typeof Ee=="string")return Ee;(0,C.$Dg)(Ee)&&(ee||(ee=[]),ee.push(Ee))}return ee?(async()=>{for(const $e of ee){const he=await $e;if(typeof he=="string")return he}return null})():null},De=Ie.find(ve=>!!ve.allBasenames);De&&(de.allBasenames=De.allBasenames);const ue=Ie.reduce((ve,ke)=>ke.allPaths?ve.concat(ke.allPaths):ve,[]);return ue.length&&(de.allPaths=ue),de}function z(me,ye,Ie){if(ye===!1)return i;const _=o(me,Ie);if(_===i)return i;if(typeof ye=="boolean")return _;if(ye){const de=ye.when;if(typeof de=="string"){const De=(ue,ve,ke,V)=>{if(!V||!_(ue,ve))return null;const Q=de.replace("$(basename)",()=>ke),ee=V(Q);return(0,C.$Dg)(ee)?ee.then($e=>$e?me:null):ee?me:null};return De.requiresSiblings=!0,De}}return _}function K(me,ye){const Ie=me.filter(ve=>!!ve.basenames);if(Ie.length<2)return me;const _=Ie.reduce((ve,ke)=>{const V=ke.basenames;return V?ve.concat(V):ve},[]);let de;if(ye){de=[];for(let ve=0,ke=_.length;ve<ke;ve++)de.push(ye)}else de=Ie.reduce((ve,ke)=>{const V=ke.patterns;return V?ve.concat(V):ve},[]);const De=function(ve,ke){if(typeof ve!="string")return null;if(!ke){let Q;for(Q=ve.length;Q>0;Q--){const ee=ve.charCodeAt(Q-1);if(ee===47||ee===92)break}ke=ve.substr(Q)}const V=_.indexOf(ke);return V!==-1?de[V]:null};De.basenames=_,De.patterns=de,De.allBasenames=_;const ue=me.filter(ve=>!ve.basenames);return ue.push(De),ue}function B(me,ye){return(0,h.$sb)(me,ye,(Ie,_)=>typeof Ie=="string"&&typeof _=="string"?Ie===_:typeof Ie!="string"&&typeof _!="string"?Ie.base===_.base&&Ie.pattern===_.pattern:!1)}e.$wj=B}),define(Ae[49],Re([1,0,9,122,23,15,2]),function(ie,e,h,C,I,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6j=e.$5j=e.$4j=e.$3j=e.$2j=e.$1j=e.$Zj=e.$Yj=e.MarkdownStringTextNewlineStyle=void 0;var u;(function(t){t[t.Paragraph=0]="Paragraph",t[t.Break=1]="Break"})(u||(e.MarkdownStringTextNewlineStyle=u={}));class D{constructor(s="",c=!1){if(this.value=s,typeof this.value!="string")throw(0,h.$5)("value");typeof c=="boolean"?(this.isTrusted=c,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=c.isTrusted??void 0,this.supportThemeIcons=c.supportThemeIcons??!1,this.supportHtml=c.supportHtml??!1)}appendText(s,c=0){return this.value+=a(this.supportThemeIcons?(0,C.$Sj)(s):s).replace(/([ \t]+)/g,(v,S)=>"&nbsp;".repeat(S.length)).replace(/\>/gm,"\\>").replace(/\n/g,c===1?`\\
`:`

`),this}appendMarkdown(s){return this.value+=s,this}appendCodeblock(s,c){return this.value+="\n```",this.value+=s,this.value+=`
`,this.value+=c,this.value+="\n```\n",this}appendLink(s,c,v){return this.value+="[",this.value+=this.c(c,"]"),this.value+="](",this.value+=this.c(String(s),")"),v&&(this.value+=` "${this.c(this.c(v,'"'),")")}"`),this.value+=")",this}c(s,c){const v=new RegExp((0,O.$De)(c),"g");return s.replace(v,(S,p)=>s.charAt(p-1)!=="\\"?`\\${S}`:S)}}e.$Yj=D;function d(t){return A(t)?!t.value:Array.isArray(t)?t.every(d):!0}e.$Zj=d;function A(t){return t instanceof D?!0:t&&typeof t=="object"?typeof t.value=="string"&&(typeof t.isTrusted=="boolean"||typeof t.isTrusted=="object"||t.isTrusted===void 0)&&(typeof t.supportThemeIcons=="boolean"||t.supportThemeIcons===void 0):!1}e.$1j=A;function k(t,s){return t===s?!0:!t||!s?!1:t.value===s.value&&t.isTrusted===s.isTrusted&&t.supportThemeIcons===s.supportThemeIcons&&t.supportHtml===s.supportHtml&&(t.baseUri===s.baseUri||!!t.baseUri&&!!s.baseUri&&(0,I.$lg)(R.URI.from(t.baseUri),R.URI.from(s.baseUri)))}e.$2j=k;function a(t){return t.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$3j=a;function w(t){return t.replace(/"/g,"&quot;")}e.$4j=w;function m(t){return t&&t.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$5j=m;function f(t){const s=[],c=t.split("|").map(S=>S.trim());t=c[0];const v=c[1];if(v){const S=/height=(\d+)/.exec(v),p=/width=(\d+)/.exec(v),n=S?S[1]:"",r=p?p[1]:"",i=isFinite(parseInt(r)),o=isFinite(parseInt(n));i&&s.push(`width="${r}"`),o&&s.push(`height="${n}"`)}return{href:t,dimensions:s}}e.$6j=f}),define(Ae[90],Re([1,0,18,40,19,22,23,15]),function(ie,e,h,C,I,O,R,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sv=e.$rv=e.$qv=e.$pv=e.$ov=e.$nv=e.$mv=e.$lv=e.$kv=e.$jv=void 0;function D(o,y){const{os:g,tildify:E,relative:P}=y;if(P){const b=d(o,P,g);if(typeof b=="string")return b}let l=o.fsPath;if(g===1&&!O.$d?l=l.replace(/\//g,"\\"):g!==1&&O.$d&&(l=l.replace(/\\/g,"/")),g!==1&&E?.userHome){const b=E.userHome.fsPath;let M;o.scheme!==E.userHome.scheme&&o.path.startsWith(I.$ec.sep)?M=E.userHome.with({path:o.path}).fsPath:M=o.fsPath,l=a(M,b,g)}return(g===1?I.$dc:I.$ec).normalize(A(l,g===1))}e.$jv=D;function d(o,y,g){const E=g===1?I.$dc:I.$ec,P=g===3?R.$ig:R.$kg,l=y.getWorkspace(),$=(0,h.$Mb)(l.folders);if(!$)return;o.scheme!==$.uri.scheme&&o.path.startsWith(I.$ec.sep)&&(o=$.uri.with({path:o.path}));const b=y.getWorkspaceFolder(o);if(!b)return;let M;if(P.isEqual(b.uri,o)?M="":M=P.relativePath(b.uri,o)??"",M&&(M=E.normalize(M)),l.folders.length>1&&!y.noPrefix){const U=b.name?b.name:P.basenameOrAuthority(b.uri);M=M?`${U} \u2022 ${M}`:U}return M}function A(o,y=O.$d){return(0,C.$Zf)(o,y)?o.charAt(0).toUpperCase()+o.slice(1):o}e.$kv=A;let k=Object.create(null);function a(o,y,g=O.OS){if(g===1||!o||!y)return o;let E=k.original===y?k.normalized:void 0;E||(E=y,O.$d&&(E=(0,C.$Pf)(E)),E=`${(0,u.$Ie)(E,I.$ec.sep)}${I.$ec.sep}`,k={original:y,normalized:E});let P=o;return O.$d&&(P=(0,C.$Pf)(P)),(g===3?P.startsWith(E):(0,u.$1e)(P,E))?`~/${P.substr(E.length)}`:o}e.$lv=a;function w(o,y){return o.replace(/^~($|\/|\\)/,`${y}$1`)}e.$mv=w;const m="\u2026",f="\\\\",t="~";function s(o,y=I.sep){const g=new Array(o.length);let E=!1;for(let P=0;P<o.length;P++){const l=o[P];if(l===""){g[P]=`.${y}`;continue}if(!l){g[P]=l;continue}E=!0;let $="",b=l;b.indexOf(f)===0?($=b.substr(0,b.indexOf(f)+f.length),b=b.substr(b.indexOf(f)+f.length)):b.indexOf(y)===0?($=b.substr(0,b.indexOf(y)+y.length),b=b.substr(b.indexOf(y)+y.length)):b.indexOf(t)===0&&($=b.substr(0,b.indexOf(t)+t.length),b=b.substr(b.indexOf(t)+t.length));const M=b.split(y);for(let U=1;E&&U<=M.length;U++)for(let F=M.length-U;E&&F>=0;F--){E=!1;let q=M.slice(F,F+U).join(y);for(let W=0;!E&&W<o.length;W++)if(W!==P&&o[W]&&o[W].indexOf(q)>-1){const L=F+U===M.length,z=F>0&&o[W].indexOf(y)>-1?y+q:q,K=o[W].endsWith(z);E=!L||K}if(!E){let W="";(M[0].endsWith(":")||$!=="")&&(F===1&&(F=0,U++,q=M[0]+y+q),F>0&&(W=M[0]+y),W=$+W),F>0&&(W=W+m+y),W=W+q,F+U<M.length&&(W=W+y+m),g[P]=W}}E&&(g[P]=l)}return g}e.$nv=s;var c;(function(o){o[o.TEXT=0]="TEXT",o[o.VARIABLE=1]="VARIABLE",o[o.SEPARATOR=2]="SEPARATOR"})(c||(c={}));function v(o,y=Object.create(null)){const g=[];let E=!1,P="";for(const l of o)if(l==="$"||E&&l==="{")P&&g.push({value:P,type:c.TEXT}),P="",E=!0;else if(l==="}"&&E){const $=y[P];if(typeof $=="string")$.length&&g.push({value:$,type:c.VARIABLE});else if($){const b=g[g.length-1];(!b||b.type!==c.SEPARATOR)&&g.push({value:$.label,type:c.SEPARATOR})}P="",E=!1}else P+=l;return P&&!E&&g.push({value:P,type:c.TEXT}),g.filter((l,$)=>{if(l.type===c.SEPARATOR){const b=g[$-1],M=g[$+1];return[b,M].every(U=>U&&(U.type===c.VARIABLE||U.type===c.TEXT)&&U.value.length>0)}return!0}).map(l=>l.value).join("")}e.$ov=v;function S(o,y){return O.$e||y?o.replace(/\(&&\w\)|&&/g,"").replace(/&/g,O.$e?"&":"&&"):o.replace(/&&|&/g,g=>g==="&"?"&&":"&")}e.$pv=S;function p(o,y){return O.$e||y?o.replace(/\(&&\w\)|&&/g,""):O.$d?o.replace(/&&|&/g,g=>g==="&"?"&&":"&"):o.replace(/&&/g,"_")}e.$qv=p;function n(o){return o.replace(/&/g,"&&")}e.$rv=n;function r(o){if(o.endsWith("]")){const y=o.lastIndexOf(" [",o.length-2);if(y!==-1){const g=i(o.substring(0,y));return{name:g.name,parentPath:g.parentPath+o.substring(y)}}}return i(o)}e.$sv=r;function i(o){const y=o.indexOf("/")!==-1?I.$ec:I.$dc,g=y.basename(o),E=y.dirname(o);return g.length?{name:g,parentPath:E}:{name:E,parentPath:""}}}),define(Ae[123],Re([1,0,25,2]),function(ie,e,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hm=e.$Gm=e.$Fm=e.$Em=e.$Dm=void 0;function I(k){return k.toJSON()}class O{constructor(a){this.a=a}transformIncoming(a){const w=this.a.transformIncoming(a);return w===a?a:I(C.URI.from(w))}transformOutgoing(a){const w=this.a.transformOutgoing(a);return w===a?a:I(C.URI.from(w))}transformOutgoingURI(a){const w=this.a.transformOutgoing(a);return w===a?a:C.URI.from(w)}transformOutgoingScheme(a){return this.a.transformOutgoingScheme(a)}}e.$Dm=O,e.$Em=new class{transformIncoming(k){return k}transformOutgoing(k){return k}transformOutgoingURI(k){return k}transformOutgoingScheme(k){return k}};function R(k,a,w){if(!k||w>200)return null;if(typeof k=="object"){if(k instanceof C.URI)return a.transformOutgoing(k);for(const m in k)if(Object.hasOwnProperty.call(k,m)){const f=R(k[m],a,w+1);f!==null&&(k[m]=f)}}return null}function u(k,a){const w=R(k,a,0);return w===null?k:w}e.$Fm=u;function D(k,a,w,m){if(!k||m>200)return null;if(typeof k=="object"){if(k.$mid===1)return w?C.URI.revive(a.transformIncoming(k)):a.transformIncoming(k);if(k instanceof h.$_d)return null;for(const f in k)if(Object.hasOwnProperty.call(k,f)){const t=D(k[f],a,w,m+1);t!==null&&(k[f]=t)}}return null}function d(k,a){const w=D(k,a,!1,0);return w===null?k:w}e.$Gm=d;function A(k,a){const w=D(k,a,!0,0);return w===null?k:w}e.$Hm=A}),define(Ae[37],Re([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bg=e.$ag=void 0;const h=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function C(I){return h.test(I)}e.$ag=C,e.$bg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let I;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?I=crypto.getRandomValues.bind(crypto):I=function(u){for(let D=0;D<u.length;D++)u[D]=Math.floor(Math.random()*256);return u};const O=new Uint8Array(16),R=[];for(let u=0;u<256;u++)R.push(u.toString(16).padStart(2,"0"));return function(){I(O),O[6]=O[6]&15|64,O[8]=O[8]&63|128;let D=0,d="";return d+=R[O[D++]],d+=R[O[D++]],d+=R[O[D++]],d+=R[O[D++]],d+="-",d+=R[O[D++]],d+=R[O[D++]],d+="-",d+=R[O[D++]],d+=R[O[D++]],d+="-",d+=R[O[D++]],d+=R[O[D++]],d+="-",d+=R[O[D++]],d+=R[O[D++]],d+=R[O[D++]],d+=R[O[D++]],d+=R[O[D++]],d+=R[O[D++]],d}}()}),define(Ae[124],Re([1,0,18,69,37]),function(ie,e,h,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vs=e.$Us=e.$Ts=e.$Ss=e.$Rs=void 0;function O(k){return{asString:async()=>k,asFile:()=>{},value:typeof k=="string"?k:void 0}}e.$Rs=O;function R(k,a,w){const m={id:(0,I.$bg)(),name:k,uri:a,data:w};return{asString:async()=>"",asFile:()=>m,value:void 0}}e.$Ss=R;class u{constructor(){this.a=new Map}get size(){let a=0;for(const w of this.a)a++;return a}has(a){return this.a.has(this.b(a))}matches(a){const w=[...this.a.keys()];return C.Iterable.some(this,([m,f])=>f.asFile())&&w.push("files"),A(D(a),w)}get(a){return this.a.get(this.b(a))?.[0]}append(a,w){const m=this.a.get(a);m?m.push(w):this.a.set(this.b(a),[w])}replace(a,w){this.a.set(this.b(a),[w])}delete(a){this.a.delete(this.b(a))}*[Symbol.iterator](){for(const[a,w]of this.a)for(const m of w)yield[a,m]}b(a){return D(a)}}e.$Ts=u;function D(k){return k.toLowerCase()}function d(k,a){return A(D(k),a.map(D))}e.$Us=d;function A(k,a){if(k==="*/*")return a.length>0;if(a.includes(k))return!0;const w=k.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!w)return!1;const[m,f,t]=w;return t==="*"?a.some(s=>s.startsWith(f+"/")):!1}e.$Vs=Object.freeze({create:k=>(0,h.$Kb)(k.map(a=>a.toString())).join(`\r
`),split:k=>k.split(`\r
`),parse:k=>e.$Vs.split(k).filter(a=>!a.startsWith("#"))})}),define(Ae[125],Re([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wr=void 0,e.$Wr={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Ae[126],Re([1,0,36,19]),function(ie,e,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iE=void 0;function I(O,R,u,D,d,A){if(Array.isArray(O)){let k=0;for(const a of O){const w=I(a,R,u,D,d,A);if(w===10)return w;w>k&&(k=w)}return k}else{if(typeof O=="string")return D?O==="*"?5:O===u?10:0:0;if(O){const{language:k,pattern:a,scheme:w,hasAccessToAllModels:m,notebookType:f}=O;if(!D&&!m)return 0;f&&d&&(R=d);let t=0;if(w)if(w===R.scheme)t=10;else if(w==="*")t=5;else return 0;if(k)if(k===u)t=10;else if(k==="*")t=Math.max(t,5);else return 0;if(f)if(f===A)t=10;else if(f==="*"&&A!==void 0)t=Math.max(t,5);else return 0;if(a){let s;if(typeof a=="string"?s=a:s={...a,base:(0,C.$fc)(a.base)},s===R.fsPath||(0,h.$rj)(s,R.fsPath))t=10;else return 0}return t}else return 0}}e.$iE=I}),define(Ae[127],Re([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jt=e.$it=e.IndentAction=void 0;var h;(function(R){R[R.None=0]="None",R[R.Indent=1]="Indent",R[R.IndentOutdent=2]="IndentOutdent",R[R.Outdent=3]="Outdent"})(h||(e.IndentAction=h={}));class C{constructor(u){if(this.e=null,this.f=!1,this.open=u.open,this.close=u.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(u.notIn))for(let D=0,d=u.notIn.length;D<d;D++)switch(u.notIn[D]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(u){switch(u){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(u,D){if(u.getTokenCount()===0)return!0;const d=u.findTokenIndexAtOffset(D-2),A=u.getStandardTokenType(d);return this.isOK(A)}g(u,D){for(let d=u;d<=D;d++){const A=String.fromCharCode(d);if(!this.open.includes(A)&&!this.close.includes(A))return A}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$it=C;class I{constructor(u){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const D of u)O(this.autoClosingPairsOpenByStart,D.open.charAt(0),D),O(this.autoClosingPairsOpenByEnd,D.open.charAt(D.open.length-1),D),O(this.autoClosingPairsCloseByStart,D.close.charAt(0),D),O(this.autoClosingPairsCloseByEnd,D.close.charAt(D.close.length-1),D),D.close.length===1&&D.open.length===1&&O(this.autoClosingPairsCloseSingleChar,D.close,D)}}e.$jt=I;function O(R,u,D){R.has(u)?R.get(u).push(D):R.set(u,[D])}}),define(Ae[91],Re([1,0,25,22]),function(ie,e,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J0=e.$I0=void 0;var I;(function(k){k[k.Full=1]="Full",k[k.Delta=2]="Delta"})(I||(I={}));function O(k){for(let a=0,w=k.length;a<w;a+=4){const m=k[a+0],f=k[a+1],t=k[a+2],s=k[a+3];k[a+0]=s,k[a+1]=t,k[a+2]=f,k[a+3]=m}}function R(k){const a=new Uint8Array(k.buffer,k.byteOffset,k.length*4);return C.$x()||O(a),h.$_d.wrap(a)}function u(k){const a=k.buffer;if(C.$x()||O(a),a.byteOffset%4===0)return new Uint32Array(a.buffer,a.byteOffset,a.length/4);{const w=new Uint8Array(a.byteLength);return w.set(a),new Uint32Array(w.buffer,w.byteOffset,w.length/4)}}function D(k){const a=new Uint32Array(d(k));let w=0;if(a[w++]=k.id,k.type==="full")a[w++]=1,a[w++]=k.data.length,a.set(k.data,w),w+=k.data.length;else{a[w++]=2,a[w++]=k.deltas.length;for(const m of k.deltas)a[w++]=m.start,a[w++]=m.deleteCount,m.data?(a[w++]=m.data.length,a.set(m.data,w),w+=m.data.length):a[w++]=0}return R(a)}e.$I0=D;function d(k){let a=0;if(a+=1+1,k.type==="full")a+=1+k.data.length;else{a+=1,a+=(1+1+1)*k.deltas.length;for(const w of k.deltas)w.data&&(a+=w.data.length)}return a}function A(k){const a=u(k);let w=0;const m=a[w++];if(a[w++]===1){const c=a[w++],v=a.subarray(w,w+c);return w+=c,{id:m,type:"full",data:v}}const t=a[w++],s=[];for(let c=0;c<t;c++){const v=a[w++],S=a[w++],p=a[w++];let n;p>0&&(n=a.subarray(w,w+p),w+=p),s[c]={start:v,deleteCount:S,data:n}}return{id:m,type:"delta",deltas:s}}e.$J0=A}),define(Ae[128],Re([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$z7=e.$y7=void 0;class h{constructor(){this.a=new Map}removeDragOperationTransfer(O){if(O&&this.a.has(O)){const R=this.a.get(O);return this.a.delete(O),R}}addDragOperationTransfer(O,R){this.a.set(O,R)}}e.$y7=h;class C{constructor(O){this.identifier=O}}e.$z7=C}),define(Ae[129],Re([10,11]),function(ie,e){return ie.create("vs/base/common/actions",e)}),define(Ae[130],Re([1,0,5,6,129]),function(ie,e,h,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vi=e.$ui=e.$ti=e.$si=e.$ri=e.$qi=void 0;class O extends C.$Qc{constructor(a,w="",m="",f=!0,t){super(),this.h=this.B(new h.$Ld),this.onDidChange=this.h.event,this.w=!0,this.j=a,this.m=w,this.u=m,this.w=f,this.C=t}get id(){return this.j}get label(){return this.m}set label(a){this.D(a)}D(a){this.m!==a&&(this.m=a,this.h.fire({label:a}))}get tooltip(){return this.n||""}set tooltip(a){this.F(a)}F(a){this.n!==a&&(this.n=a,this.h.fire({tooltip:a}))}get class(){return this.u}set class(a){this.G(a)}G(a){this.u!==a&&(this.u=a,this.h.fire({class:a}))}get enabled(){return this.w}set enabled(a){this.H(a)}H(a){this.w!==a&&(this.w=a,this.h.fire({enabled:a}))}get checked(){return this.z}set checked(a){this.I(a)}I(a){this.z!==a&&(this.z=a,this.h.fire({checked:a}))}async run(a,w){this.C&&await this.C(a)}}e.$qi=O;class R extends C.$Qc{constructor(){super(...arguments),this.f=this.B(new h.$Ld),this.onWillRun=this.f.event,this.m=this.B(new h.$Ld),this.onDidRun=this.m.event}async run(a,w){if(!a.enabled)return;this.f.fire({action:a});let m;try{await this.u(a,w)}catch(f){m=f}this.m.fire({action:a,error:m})}async u(a,w){await a.run(w)}}e.$ri=R;class u{constructor(){this.id=u.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...a){let w=[];for(const m of a)m.length&&(w.length?w=[...w,new u,...m]:w=m);return w}async run(){}}e.$si=u,u.ID="vs.actions.separator";class D{get actions(){return this.a}constructor(a,w,m,f){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=a,this.label=w,this.class=f,this.a=m}async run(){}}e.$ti=D;class d extends O{constructor(){super(d.ID,I.localize(0,null),void 0,!1)}}e.$ui=d,d.ID="vs.actions.empty";function A(k){return{id:k.id,label:k.label,class:void 0,enabled:k.enabled??!0,checked:k.checked??!1,run:async(...a)=>k.run(...a),tooltip:k.label}}e.$vi=A}),define(Ae[131],Re([10,11]),function(ie,e){return ie.create("vs/base/common/date",e)}),define(Ae[132],Re([1,0,131]),function(ie,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9l=e.$8l=void 0;const C=60,I=C*60,O=I*24,R=O*7,u=O*30,D=O*365;function d(k,a,w,m){typeof k!="number"&&(k=k.getTime());const f=Math.round((new Date().getTime()-k)/1e3);if(f<-30)return(0,h.localize)(0,null,d(new Date().getTime()+f*1e3,!1));if(!m&&f<30)return(0,h.localize)(1,null);let t;return f<C?(t=f,a?t===1?w?(0,h.localize)(2,null,t):(0,h.localize)(3,null,t):w?(0,h.localize)(4,null,t):(0,h.localize)(5,null,t):t===1?w?(0,h.localize)(6,null,t):(0,h.localize)(7,null,t):w?(0,h.localize)(8,null,t):(0,h.localize)(9,null,t)):f<I?(t=Math.floor(f/C),a?t===1?w?(0,h.localize)(10,null,t):(0,h.localize)(11,null,t):w?(0,h.localize)(12,null,t):(0,h.localize)(13,null,t):t===1?w?(0,h.localize)(14,null,t):(0,h.localize)(15,null,t):w?(0,h.localize)(16,null,t):(0,h.localize)(17,null,t)):f<O?(t=Math.floor(f/I),a?t===1?w?(0,h.localize)(18,null,t):(0,h.localize)(19,null,t):w?(0,h.localize)(20,null,t):(0,h.localize)(21,null,t):t===1?w?(0,h.localize)(22,null,t):(0,h.localize)(23,null,t):w?(0,h.localize)(24,null,t):(0,h.localize)(25,null,t)):f<R?(t=Math.floor(f/O),a?t===1?(0,h.localize)(26,null,t):(0,h.localize)(27,null,t):t===1?(0,h.localize)(28,null,t):(0,h.localize)(29,null,t)):f<u?(t=Math.floor(f/R),a?t===1?w?(0,h.localize)(30,null,t):(0,h.localize)(31,null,t):w?(0,h.localize)(32,null,t):(0,h.localize)(33,null,t):t===1?w?(0,h.localize)(34,null,t):(0,h.localize)(35,null,t):w?(0,h.localize)(36,null,t):(0,h.localize)(37,null,t)):f<D?(t=Math.floor(f/u),a?t===1?w?(0,h.localize)(38,null,t):(0,h.localize)(39,null,t):w?(0,h.localize)(40,null,t):(0,h.localize)(41,null,t):t===1?w?(0,h.localize)(42,null,t):(0,h.localize)(43,null,t):w?(0,h.localize)(44,null,t):(0,h.localize)(45,null,t)):(t=Math.floor(f/D),a?t===1?w?(0,h.localize)(46,null,t):(0,h.localize)(47,null,t):w?(0,h.localize)(48,null,t):(0,h.localize)(49,null,t):t===1?w?(0,h.localize)(50,null,t):(0,h.localize)(51,null,t):w?(0,h.localize)(52,null,t):(0,h.localize)(53,null,t))}e.$8l=d;function A(k){return k.getFullYear()+"-"+String(k.getMonth()+1).padStart(2,"0")+"-"+String(k.getDate()).padStart(2,"0")+"T"+String(k.getHours()).padStart(2,"0")+":"+String(k.getMinutes()).padStart(2,"0")+":"+String(k.getSeconds()).padStart(2,"0")+"."+(k.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$9l=A}),define(Ae[133],Re([10,11]),function(ie,e){return ie.create("vs/base/common/errorMessage",e)}),define(Ae[42],Re([1,0,18,16,133]),function(ie,e,h,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yi=e.$xi=e.$wi=void 0;function O(k,a){return a&&(k.stack||k.stacktrace)?I.localize(0,null,u(k),R(k.stack)||R(k.stacktrace)):u(k)}function R(k){return Array.isArray(k)?k.join(`
`):k}function u(k){return k.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${k.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof k.code=="string"&&typeof k.errno=="number"&&typeof k.syscall=="string"?I.localize(1,null,k.message):k.message||I.localize(2,null)}function D(k=null,a=!1){if(!k)return I.localize(3,null);if(Array.isArray(k)){const w=h.$Fb(k),m=D(w[0],a);return w.length>1?I.localize(4,null,m,w.length):m}if(C.$wf(k))return k;if(k.detail){const w=k.detail;if(w.error)return O(w.error,a);if(w.exception)return O(w.exception,a)}return k.stack?O(k,a):k.message?k.message:I.localize(5,null)}e.$wi=D;function d(k){const a=k;return a instanceof Error&&Array.isArray(a.actions)}e.$xi=d;function A(k,a){let w;return typeof k=="string"?w=new Error(k):w=k,w.actions=a,w}e.$yi=A}),define(Ae[134],Re([10,11]),function(ie,e){return ie.create("vs/editor/common/config/editorOptions",e)}),define(Ae[135],Re([1,0,18,24,22,125,136,134]),function(ie,e,h,C,I,O,R,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var D;(function(x){x[x.None=0]="None",x[x.Keep=1]="Keep",x[x.Brackets=2]="Brackets",x[x.Advanced=3]="Advanced",x[x.Full=4]="Full"})(D||(e.EditorAutoIndentStrategy=D={})),e.MINIMAP_GUTTER_WIDTH=8;class d{constructor(Z){this.c=Z}hasChanged(Z){return this.c[Z]}}e.ConfigurationChangedEvent=d;class A{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=A;class k{constructor(Z,we,We,ze){this.id=Z,this.name=we,this.defaultValue=We,this.schema=ze}applyUpdate(Z,we){return w(Z,we)}compute(Z,we,We){return We}}class a{constructor(Z,we){this.newValue=Z,this.didChange=we}}e.ApplyUpdateResult=a;function w(x,Z){if(typeof x!="object"||typeof Z!="object"||!x||!Z)return new a(Z,x!==Z);if(Array.isArray(x)||Array.isArray(Z)){const We=Array.isArray(x)&&Array.isArray(Z)&&h.$sb(x,Z);return new a(Z,!We)}let we=!1;for(const We in Z)if(Z.hasOwnProperty(We)){const ze=w(x[We],Z[We]);ze.didChange&&(x[We]=ze.newValue,we=!0)}return new a(x,we)}class m{constructor(Z){this.schema=void 0,this.id=Z,this.name="_never_",this.defaultValue=void 0}applyUpdate(Z,we){return w(Z,we)}validate(Z){return this.defaultValue}}class f{constructor(Z,we,We,ze){this.id=Z,this.name=we,this.defaultValue=We,this.schema=ze}applyUpdate(Z,we){return w(Z,we)}validate(Z){return typeof Z>"u"?this.defaultValue:Z}compute(Z,we,We){return We}}function t(x,Z){return typeof x>"u"?Z:x==="false"?!1:!!x}e.boolean=t;class s extends f{constructor(Z,we,We,ze=void 0){typeof ze<"u"&&(ze.type="boolean",ze.default=We),super(Z,we,We,ze)}validate(Z){return t(Z,this.defaultValue)}}function c(x,Z,we,We){if(typeof x>"u")return Z;let ze=parseInt(x,10);return isNaN(ze)?Z:(ze=Math.max(we,ze),ze=Math.min(We,ze),ze|0)}e.clampedInt=c;class v extends f{static clampedInt(Z,we,We,ze){return c(Z,we,We,ze)}constructor(Z,we,We,ze,Ze,at=void 0){typeof at<"u"&&(at.type="integer",at.default=We,at.minimum=ze,at.maximum=Ze),super(Z,we,We,at),this.minimum=ze,this.maximum=Ze}validate(Z){return v.clampedInt(Z,this.defaultValue,this.minimum,this.maximum)}}function S(x,Z,we,We){if(typeof x>"u")return Z;const ze=p.float(x,Z);return p.clamp(ze,we,We)}e.clampedFloat=S;class p extends f{static clamp(Z,we,We){return Z<we?we:Z>We?We:Z}static float(Z,we){if(typeof Z=="number")return Z;if(typeof Z>"u")return we;const We=parseFloat(Z);return isNaN(We)?we:We}constructor(Z,we,We,ze,Ze){typeof Ze<"u"&&(Ze.type="number",Ze.default=We),super(Z,we,We,Ze),this.validationFn=ze}validate(Z){return this.validationFn(p.float(Z,this.defaultValue))}}class n extends f{static string(Z,we){return typeof Z!="string"?we:Z}constructor(Z,we,We,ze=void 0){typeof ze<"u"&&(ze.type="string",ze.default=We),super(Z,we,We,ze)}validate(Z){return n.string(Z,this.defaultValue)}}function r(x,Z,we,We){return typeof x!="string"?Z:We&&x in We?We[x]:we.indexOf(x)===-1?Z:x}e.stringSet=r;class i extends f{constructor(Z,we,We,ze,Ze=void 0){typeof Ze<"u"&&(Ze.type="string",Ze.enum=ze,Ze.default=We),super(Z,we,We,Ze),this.c=ze}validate(Z){return r(Z,this.defaultValue,this.c)}}class o extends k{constructor(Z,we,We,ze,Ze,at,mt=void 0){typeof mt<"u"&&(mt.type="string",mt.enum=Ze,mt.default=ze),super(Z,we,We,mt),this.c=Ze,this.d=at}validate(Z){return typeof Z!="string"?this.defaultValue:this.c.indexOf(Z)===-1?this.defaultValue:this.d(Z)}}function y(x){switch(x){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class g extends k{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[u.localize(0,null),u.localize(1,null),u.localize(2,null)],default:"auto",tags:["accessibility"],description:u.localize(3,null)})}validate(Z){switch(Z){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Z,we,We){return We===0?Z.accessibilitySupport:We}}class E extends k{constructor(){const Z={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",Z,{"editor.comments.insertSpace":{type:"boolean",default:Z.insertSpace,description:u.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Z.ignoreEmptyLines,description:u.localize(5,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const we=Z;return{insertSpace:t(we.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:t(we.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var P;(function(x){x[x.Hidden=0]="Hidden",x[x.Blink=1]="Blink",x[x.Smooth=2]="Smooth",x[x.Phase=3]="Phase",x[x.Expand=4]="Expand",x[x.Solid=5]="Solid"})(P||(e.TextEditorCursorBlinkingStyle=P={}));function l(x){switch(x){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var $;(function(x){x[x.Line=1]="Line",x[x.Block=2]="Block",x[x.Underline=3]="Underline",x[x.LineThin=4]="LineThin",x[x.BlockOutline=5]="BlockOutline",x[x.UnderlineThin=6]="UnderlineThin"})($||(e.TextEditorCursorStyle=$={}));function b(x){switch(x){case $.Line:return"line";case $.Block:return"block";case $.Underline:return"underline";case $.LineThin:return"line-thin";case $.BlockOutline:return"block-outline";case $.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=b;function M(x){switch(x){case"line":return $.Line;case"block":return $.Block;case"underline":return $.Underline;case"line-thin":return $.LineThin;case"block-outline":return $.BlockOutline;case"underline-thin":return $.UnderlineThin}}class U extends m{constructor(){super(140)}compute(Z,we,We){const ze=["monaco-editor"];return we.get(39)&&ze.push(we.get(39)),Z.extraEditorClassName&&ze.push(Z.extraEditorClassName),we.get(73)==="default"?ze.push("mouse-default"):we.get(73)==="copy"&&ze.push("mouse-copy"),we.get(110)&&ze.push("showUnused"),we.get(138)&&ze.push("showDeprecated"),ze.join(" ")}}class F extends s{constructor(){super(37,"emptySelectionClipboard",!0,{description:u.localize(6,null)})}compute(Z,we,We){return We&&Z.emptySelectionClipboard}}class q extends k{constructor(){const Z={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",Z,{"editor.find.cursorMoveOnType":{type:"boolean",default:Z.cursorMoveOnType,description:u.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Z.seedSearchStringFromSelection,enumDescriptions:[u.localize(8,null),u.localize(9,null),u.localize(10,null)],description:u.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Z.autoFindInSelection,enumDescriptions:[u.localize(12,null),u.localize(13,null),u.localize(14,null)],description:u.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Z.globalFindClipboard,description:u.localize(16,null),included:I.$e},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Z.addExtraSpaceOnTop,description:u.localize(17,null)},"editor.find.loop":{type:"boolean",default:Z.loop,description:u.localize(18,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const we=Z;return{cursorMoveOnType:t(we.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Z.seedSearchStringFromSelection=="boolean"?Z.seedSearchStringFromSelection?"always":"never":r(we.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Z.autoFindInSelection=="boolean"?Z.autoFindInSelection?"always":"never":r(we.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:t(we.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:t(we.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:t(we.loop,this.defaultValue.loop)}}}class W extends k{constructor(){super(51,"fontLigatures",W.OFF,{anyOf:[{type:"boolean",description:u.localize(19,null)},{type:"string",description:u.localize(20,null)}],description:u.localize(21,null),default:!1})}validate(Z){return typeof Z>"u"?this.defaultValue:typeof Z=="string"?Z==="false"?W.OFF:Z==="true"?W.ON:Z:Z?W.ON:W.OFF}}e.EditorFontLigatures=W,W.OFF='"liga" off, "calt" off',W.ON='"liga" on, "calt" on';class L extends k{constructor(){super(54,"fontVariations",L.OFF,{anyOf:[{type:"boolean",description:u.localize(22,null)},{type:"string",description:u.localize(23,null)}],description:u.localize(24,null),default:!1})}validate(Z){return typeof Z>"u"?this.defaultValue:typeof Z=="string"?Z==="false"?L.OFF:Z==="true"?L.TRANSLATE:Z:Z?L.TRANSLATE:L.OFF}compute(Z,we,We){return Z.fontInfo.fontVariationSettings}}e.EditorFontVariations=L,L.OFF="normal",L.TRANSLATE="translate";class z extends m{constructor(){super(50)}compute(Z,we,We){return Z.fontInfo}}class K extends f{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:u.localize(25,null)})}validate(Z){const we=p.float(Z,this.defaultValue);return we===0?e.EDITOR_FONT_DEFAULTS.fontSize:p.clamp(we,6,100)}compute(Z,we,We){return Z.fontInfo.fontSize}}class B extends k{constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:B.d,maximum:B.e,errorMessage:u.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:B.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:u.localize(27,null)})}validate(Z){return Z==="normal"||Z==="bold"?Z:String(v.clampedInt(Z,e.EDITOR_FONT_DEFAULTS.fontWeight,B.d,B.e))}}B.c=["normal","bold","100","200","300","400","500","600","700","800","900"],B.d=1,B.e=1e3;class me extends k{constructor(){const Z={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},we={type:"string",enum:["peek","gotoAndPeek","goto"],default:Z.multiple,enumDescriptions:[u.localize(28,null),u.localize(29,null),u.localize(30,null)]},We=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",Z,{"editor.gotoLocation.multiple":{deprecationMessage:u.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:u.localize(32,null),...we},"editor.gotoLocation.multipleTypeDefinitions":{description:u.localize(33,null),...we},"editor.gotoLocation.multipleDeclarations":{description:u.localize(34,null),...we},"editor.gotoLocation.multipleImplementations":{description:u.localize(35,null),...we},"editor.gotoLocation.multipleReferences":{description:u.localize(36,null),...we},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Z.alternativeDefinitionCommand,enum:We,description:u.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Z.alternativeTypeDefinitionCommand,enum:We,description:u.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Z.alternativeDeclarationCommand,enum:We,description:u.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Z.alternativeImplementationCommand,enum:We,description:u.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Z.alternativeReferenceCommand,enum:We,description:u.localize(41,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const we=Z;return{multiple:r(we.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:we.multipleDefinitions??r(we.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:we.multipleTypeDefinitions??r(we.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:we.multipleDeclarations??r(we.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:we.multipleImplementations??r(we.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:we.multipleReferences??r(we.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:n.string(we.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:n.string(we.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:n.string(we.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:n.string(we.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:n.string(we.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class ye extends k{constructor(){const Z={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",Z,{"editor.hover.enabled":{type:"boolean",default:Z.enabled,description:u.localize(42,null)},"editor.hover.delay":{type:"number",default:Z.delay,minimum:0,maximum:1e4,description:u.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:Z.sticky,description:u.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:Z.hidingDelay,description:u.localize(45,null)},"editor.hover.above":{type:"boolean",default:Z.above,description:u.localize(46,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const we=Z;return{enabled:t(we.enabled,this.defaultValue.enabled),delay:v.clampedInt(we.delay,this.defaultValue.delay,0,1e4),sticky:t(we.sticky,this.defaultValue.sticky),hidingDelay:v.clampedInt(we.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:t(we.above,this.defaultValue.above)}}}var Ie;(function(x){x[x.None=0]="None",x[x.Text=1]="Text",x[x.Blocks=2]="Blocks"})(Ie||(e.RenderMinimap=Ie={}));class _ extends m{constructor(){super(143)}compute(Z,we,We){return _.computeLayout(we,{memory:Z.memory,outerWidth:Z.outerWidth,outerHeight:Z.outerHeight,isDominatedByLongLines:Z.isDominatedByLongLines,lineHeight:Z.fontInfo.lineHeight,viewLineCount:Z.viewLineCount,lineNumbersDigitCount:Z.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Z.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Z.fontInfo.maxDigitWidth,pixelRatio:Z.pixelRatio,glyphMarginDecorationLaneCount:Z.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(Z){const we=Z.height/Z.lineHeight,We=Math.floor(Z.paddingTop/Z.lineHeight);let ze=Math.floor(Z.paddingBottom/Z.lineHeight);Z.scrollBeyondLastLine&&(ze=Math.max(ze,we-1));const Ze=(We+Z.viewLineCount+ze)/(Z.pixelRatio*Z.height),at=Math.floor(Z.viewLineCount/Ze);return{typicalViewportLineCount:we,extraLinesBeforeFirstLine:We,extraLinesBeyondLastLine:ze,desiredRatio:Ze,minimapLineCount:at}}static c(Z,we){const We=Z.outerWidth,ze=Z.outerHeight,Ze=Z.pixelRatio;if(!Z.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Ze*ze),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:ze};const at=we.stableMinimapLayoutInput,mt=at&&Z.outerHeight===at.outerHeight&&Z.lineHeight===at.lineHeight&&Z.typicalHalfwidthCharacterWidth===at.typicalHalfwidthCharacterWidth&&Z.pixelRatio===at.pixelRatio&&Z.scrollBeyondLastLine===at.scrollBeyondLastLine&&Z.paddingTop===at.paddingTop&&Z.paddingBottom===at.paddingBottom&&Z.minimap.enabled===at.minimap.enabled&&Z.minimap.side===at.minimap.side&&Z.minimap.size===at.minimap.size&&Z.minimap.showSlider===at.minimap.showSlider&&Z.minimap.renderCharacters===at.minimap.renderCharacters&&Z.minimap.maxColumn===at.minimap.maxColumn&&Z.minimap.scale===at.minimap.scale&&Z.verticalScrollbarWidth===at.verticalScrollbarWidth&&Z.isViewportWrapping===at.isViewportWrapping,bt=Z.lineHeight,Tt=Z.typicalHalfwidthCharacterWidth,Xt=Z.scrollBeyondLastLine,qt=Z.minimap.renderCharacters;let wt=Ze>=2?Math.round(Z.minimap.scale*2):Z.minimap.scale;const Nt=Z.minimap.maxColumn,zt=Z.minimap.size,Zt=Z.minimap.side,Ut=Z.verticalScrollbarWidth,jt=Z.viewLineCount,Kt=Z.remainingWidth,Gt=Z.isViewportWrapping,Bt=qt?2:3;let Ht=Math.floor(Ze*ze);const Jt=Ht/Ze;let ct=!1,gt=!1,It=Bt*wt,Rt=wt/Ze,Ct=1;if(zt==="fill"||zt==="fit"){const{typicalViewportLineCount:Le,extraLinesBeforeFirstLine:be,extraLinesBeyondLastLine:G,desiredRatio:Me,minimapLineCount:Be}=_.computeContainedMinimapLineCount({viewLineCount:jt,scrollBeyondLastLine:Xt,paddingTop:Z.paddingTop,paddingBottom:Z.paddingBottom,height:ze,lineHeight:bt,pixelRatio:Ze});if(jt/Be>1)ct=!0,gt=!0,wt=1,It=1,Rt=wt/Ze;else{let Ve=!1,tt=wt+1;if(zt==="fit"){const vt=Math.ceil((be+jt+G)*It);Gt&&mt&&Kt<=we.stableFitRemainingWidth?(Ve=!0,tt=we.stableFitMaxMinimapScale):Ve=vt>Ht}if(zt==="fill"||Ve){ct=!0;const vt=wt;It=Math.min(bt*Ze,Math.max(1,Math.floor(1/Me))),Gt&&mt&&Kt<=we.stableFitRemainingWidth&&(tt=we.stableFitMaxMinimapScale),wt=Math.min(tt,Math.max(1,Math.floor(It/Bt))),wt>vt&&(Ct=Math.min(2,wt/vt)),Rt=wt/Ze/Ct,Ht=Math.ceil(Math.max(Le,be+jt+G)*It),Gt?(we.stableMinimapLayoutInput=Z,we.stableFitRemainingWidth=Kt,we.stableFitMaxMinimapScale=wt):(we.stableMinimapLayoutInput=null,we.stableFitRemainingWidth=0)}}}const ft=Math.floor(Nt*Rt),kt=Math.min(ft,Math.max(0,Math.floor((Kt-Ut-2)*Rt/(Tt+Rt)))+e.MINIMAP_GUTTER_WIDTH);let Pt=Math.floor(Ze*kt);const Ft=Pt/Ze;Pt=Math.floor(Pt*Ct);const Ke=qt?1:2,Pe=Zt==="left"?0:We-kt-Ut;return{renderMinimap:Ke,minimapLeft:Pe,minimapWidth:kt,minimapHeightIsEditorHeight:ct,minimapIsSampling:gt,minimapScale:wt,minimapLineHeight:It,minimapCanvasInnerWidth:Pt,minimapCanvasInnerHeight:Ht,minimapCanvasOuterWidth:Ft,minimapCanvasOuterHeight:Jt}}static computeLayout(Z,we){const We=we.outerWidth|0,ze=we.outerHeight|0,Ze=we.lineHeight|0,at=we.lineNumbersDigitCount|0,mt=we.typicalHalfwidthCharacterWidth,bt=we.maxDigitWidth,Tt=we.pixelRatio,Xt=we.viewLineCount,qt=Z.get(135),wt=qt==="inherit"?Z.get(134):qt,Nt=wt==="inherit"?Z.get(130):wt,zt=Z.get(133),Zt=we.isDominatedByLongLines,Ut=Z.get(57),jt=Z.get(67).renderType!==0,Kt=Z.get(68),Gt=Z.get(104),Bt=Z.get(83),Ht=Z.get(72),Jt=Z.get(102),ct=Jt.verticalScrollbarSize,gt=Jt.verticalHasArrows,It=Jt.arrowSize,Rt=Jt.horizontalScrollbarSize,Ct=Z.get(43),ft=Z.get(109)!=="never";let kt=Z.get(65);Ct&&ft&&(kt+=16);let Pt=0;if(jt){const yt=Math.max(at,Kt);Pt=Math.round(yt*bt)}let Ft=0;Ut&&(Ft=Ze*we.glyphMarginDecorationLaneCount);let Ke=0,Pe=Ke+Ft,Le=Pe+Pt,be=Le+kt;const G=We-Ft-Pt-kt;let Me=!1,Be=!1,Qe=-1;wt==="inherit"&&Zt?(Me=!0,Be=!0):Nt==="on"||Nt==="bounded"?Be=!0:Nt==="wordWrapColumn"&&(Qe=zt);const Ve=_.c({outerWidth:We,outerHeight:ze,lineHeight:Ze,typicalHalfwidthCharacterWidth:mt,pixelRatio:Tt,scrollBeyondLastLine:Gt,paddingTop:Bt.top,paddingBottom:Bt.bottom,minimap:Ht,verticalScrollbarWidth:ct,viewLineCount:Xt,remainingWidth:G,isViewportWrapping:Be},we.memory||new A);Ve.renderMinimap!==0&&Ve.minimapLeft===0&&(Ke+=Ve.minimapWidth,Pe+=Ve.minimapWidth,Le+=Ve.minimapWidth,be+=Ve.minimapWidth);const tt=G-Ve.minimapWidth,vt=Math.max(1,Math.floor((tt-ct-2)/mt)),Lt=gt?It:0;return Be&&(Qe=Math.max(1,vt),Nt==="bounded"&&(Qe=Math.min(Qe,zt))),{width:We,height:ze,glyphMarginLeft:Ke,glyphMarginWidth:Ft,glyphMarginDecorationLaneCount:we.glyphMarginDecorationLaneCount,lineNumbersLeft:Pe,lineNumbersWidth:Pt,decorationsLeft:Le,decorationsWidth:kt,contentLeft:be,contentWidth:tt,minimap:Ve,viewportColumn:vt,isWordWrapMinified:Me,isViewportWrapping:Be,wrappingColumn:Qe,verticalScrollbarWidth:ct,horizontalScrollbarHeight:Rt,overviewRuler:{top:Lt,width:ct,height:ze-2*Lt,right:0}}}}e.EditorLayoutInfoComputer=_;class de extends k{constructor(){super(137,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[u.localize(47,null),u.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:u.localize(49,null)}})}validate(Z){return r(Z,"simple",["simple","advanced"])}compute(Z,we,We){return we.get(2)===2?"advanced":We}}class De extends k{constructor(){const Z={enabled:!0};super(64,"lightbulb",Z,{"editor.lightbulb.enabled":{type:"boolean",default:Z.enabled,description:u.localize(50,null)}})}validate(Z){return!Z||typeof Z!="object"?this.defaultValue:{enabled:t(Z.enabled,this.defaultValue.enabled)}}}class ue extends k{constructor(){const Z={enabled:!1,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(114,"stickyScroll",Z,{"editor.stickyScroll.enabled":{type:"boolean",default:Z.enabled,description:u.localize(51,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:Z.maxLineCount,minimum:1,maximum:10,description:u.localize(52,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:Z.defaultModel,description:u.localize(53,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:Z.scrollWithEditor,description:u.localize(54,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const we=Z;return{enabled:t(we.enabled,this.defaultValue.enabled),maxLineCount:v.clampedInt(we.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:r(we.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:t(we.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class ve extends k{constructor(){const Z={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(139,"inlayHints",Z,{"editor.inlayHints.enabled":{type:"string",default:Z.enabled,description:u.localize(55,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[u.localize(56,null),u.localize(57,null,I.$e?"Ctrl+Option":"Ctrl+Alt"),u.localize(58,null,I.$e?"Ctrl+Option":"Ctrl+Alt"),u.localize(59,null)]},"editor.inlayHints.fontSize":{type:"number",default:Z.fontSize,markdownDescription:u.localize(60,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:Z.fontFamily,markdownDescription:u.localize(61,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:Z.padding,description:u.localize(62,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const we=Z;return typeof we.enabled=="boolean"&&(we.enabled=we.enabled?"on":"off"),{enabled:r(we.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:v.clampedInt(we.fontSize,this.defaultValue.fontSize,0,100),fontFamily:n.string(we.fontFamily,this.defaultValue.fontFamily),padding:t(we.padding,this.defaultValue.padding)}}}class ke extends k{constructor(){super(65,"lineDecorationsWidth",10)}validate(Z){return typeof Z=="string"&&/^\d+(\.\d+)?ch$/.test(Z)?-parseFloat(Z.substring(0,Z.length-2)):v.clampedInt(Z,this.defaultValue,0,1e3)}compute(Z,we,We){return We<0?v.clampedInt(-We*Z.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):We}}class V extends p{constructor(){super(66,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Z=>p.clamp(Z,0,150),{markdownDescription:u.localize(63,null)})}compute(Z,we,We){return Z.fontInfo.lineHeight}}class Q extends k{constructor(){const Z={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(72,"minimap",Z,{"editor.minimap.enabled":{type:"boolean",default:Z.enabled,description:u.localize(64,null)},"editor.minimap.autohide":{type:"boolean",default:Z.autohide,description:u.localize(65,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[u.localize(66,null),u.localize(67,null),u.localize(68,null)],default:Z.size,description:u.localize(69,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Z.side,description:u.localize(70,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Z.showSlider,description:u.localize(71,null)},"editor.minimap.scale":{type:"number",default:Z.scale,minimum:1,maximum:3,enum:[1,2,3],description:u.localize(72,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Z.renderCharacters,description:u.localize(73,null)},"editor.minimap.maxColumn":{type:"number",default:Z.maxColumn,description:u.localize(74,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const we=Z;return{enabled:t(we.enabled,this.defaultValue.enabled),autohide:t(we.autohide,this.defaultValue.autohide),size:r(we.size,this.defaultValue.size,["proportional","fill","fit"]),side:r(we.side,this.defaultValue.side,["right","left"]),showSlider:r(we.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:t(we.renderCharacters,this.defaultValue.renderCharacters),scale:v.clampedInt(we.scale,1,1,3),maxColumn:v.clampedInt(we.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function ee(x){return x==="ctrlCmd"?I.$e?"metaKey":"ctrlKey":"altKey"}class $e extends k{constructor(){super(83,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:u.localize(75,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:u.localize(76,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const we=Z;return{top:v.clampedInt(we.top,0,0,1e3),bottom:v.clampedInt(we.bottom,0,0,1e3)}}}class he extends k{constructor(){const Z={enabled:!0,cycle:!0};super(85,"parameterHints",Z,{"editor.parameterHints.enabled":{type:"boolean",default:Z.enabled,description:u.localize(77,null)},"editor.parameterHints.cycle":{type:"boolean",default:Z.cycle,description:u.localize(78,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const we=Z;return{enabled:t(we.enabled,this.defaultValue.enabled),cycle:t(we.cycle,this.defaultValue.cycle)}}}class fe extends m{constructor(){super(141)}compute(Z,we,We){return Z.pixelRatio}}class Ee extends k{constructor(){const Z={other:"on",comments:"off",strings:"off"},we=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[u.localize(79,null),u.localize(80,null),u.localize(81,null)]}];super(88,"quickSuggestions",Z,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:we,default:Z.strings,description:u.localize(82,null)},comments:{anyOf:we,default:Z.comments,description:u.localize(83,null)},other:{anyOf:we,default:Z.other,description:u.localize(84,null)}},default:Z,markdownDescription:u.localize(85,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=Z}validate(Z){if(typeof Z=="boolean"){const Tt=Z?"on":"off";return{comments:Tt,strings:Tt,other:Tt}}if(!Z||typeof Z!="object")return this.defaultValue;const{other:we,comments:We,strings:ze}=Z,Ze=["on","inline","off"];let at,mt,bt;return typeof we=="boolean"?at=we?"on":"off":at=r(we,this.defaultValue.other,Ze),typeof We=="boolean"?mt=We?"on":"off":mt=r(We,this.defaultValue.comments,Ze),typeof ze=="boolean"?bt=ze?"on":"off":bt=r(ze,this.defaultValue.strings,Ze),{other:at,comments:mt,strings:bt}}}var re;(function(x){x[x.Off=0]="Off",x[x.On=1]="On",x[x.Relative=2]="Relative",x[x.Interval=3]="Interval",x[x.Custom=4]="Custom"})(re||(e.RenderLineNumbersType=re={}));class le extends k{constructor(){super(67,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[u.localize(86,null),u.localize(87,null),u.localize(88,null),u.localize(89,null)],default:"on",description:u.localize(90,null)})}validate(Z){let we=this.defaultValue.renderType,We=this.defaultValue.renderFn;return typeof Z<"u"&&(typeof Z=="function"?(we=4,We=Z):Z==="interval"?we=3:Z==="relative"?we=2:Z==="on"?we=1:we=0),{renderType:we,renderFn:We}}}function oe(x){const Z=x.get(97);return Z==="editable"?x.get(90):Z!=="on"}e.filterValidationDecorations=oe;class ae extends k{constructor(){const Z=[],we={type:"number",description:u.localize(91,null)};super(101,"rulers",Z,{type:"array",items:{anyOf:[we,{type:["object"],properties:{column:we,color:{type:"string",description:u.localize(92,null),format:"color-hex"}}}]},default:Z,description:u.localize(93,null)})}validate(Z){if(Array.isArray(Z)){const we=[];for(const We of Z)if(typeof We=="number")we.push({column:v.clampedInt(We,0,0,1e4),color:null});else if(We&&typeof We=="object"){const ze=We;we.push({column:v.clampedInt(ze.column,0,0,1e4),color:ze.color})}return we.sort((We,ze)=>We.column-ze.column),we}return this.defaultValue}}class pe extends k{constructor(){super(91,"readOnlyMessage",void 0)}validate(Z){return!Z||typeof Z!="object"?this.defaultValue:Z}}function Ce(x,Z){if(typeof x!="string")return Z;switch(x){case"hidden":return 2;case"visible":return 3;default:return 1}}class T extends k{constructor(){const Z={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(102,"scrollbar",Z,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[u.localize(94,null),u.localize(95,null),u.localize(96,null)],default:"auto",description:u.localize(97,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[u.localize(98,null),u.localize(99,null),u.localize(100,null)],default:"auto",description:u.localize(101,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Z.verticalScrollbarSize,description:u.localize(102,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Z.horizontalScrollbarSize,description:u.localize(103,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Z.scrollByPage,description:u.localize(104,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const we=Z,We=v.clampedInt(we.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),ze=v.clampedInt(we.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:v.clampedInt(we.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Ce(we.vertical,this.defaultValue.vertical),horizontal:Ce(we.horizontal,this.defaultValue.horizontal),useShadows:t(we.useShadows,this.defaultValue.useShadows),verticalHasArrows:t(we.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:t(we.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:t(we.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:t(we.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:We,horizontalSliderSize:v.clampedInt(we.horizontalSliderSize,We,0,1e3),verticalScrollbarSize:ze,verticalSliderSize:v.clampedInt(we.verticalSliderSize,ze,0,1e3),scrollByPage:t(we.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class H extends k{constructor(){const Z={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(124,"unicodeHighlight",Z,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Z.nonBasicASCII,description:u.localize(105,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:Z.invisibleCharacters,description:u.localize(106,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:Z.ambiguousCharacters,description:u.localize(107,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Z.includeComments,description:u.localize(108,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Z.includeStrings,description:u.localize(109,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:Z.allowedCharacters,description:u.localize(110,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:Z.allowedLocales,description:u.localize(111,null)}})}applyUpdate(Z,we){let We=!1;we.allowedCharacters&&Z&&(C.$2m(Z.allowedCharacters,we.allowedCharacters)||(Z={...Z,allowedCharacters:we.allowedCharacters},We=!0)),we.allowedLocales&&Z&&(C.$2m(Z.allowedLocales,we.allowedLocales)||(Z={...Z,allowedLocales:we.allowedLocales},We=!0));const ze=super.applyUpdate(Z,we);return We?new a(ze.newValue,!0):ze}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const we=Z;return{nonBasicASCII:te(we.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:t(we.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:t(we.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:te(we.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:te(we.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(Z.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(Z.allowedLocales,this.defaultValue.allowedLocales)}}c(Z,we){if(typeof Z!="object"||!Z)return we;const We={};for(const[ze,Ze]of Object.entries(Z))Ze===!0&&(We[ze]=!0);return We}}class X extends k{constructor(){const Z={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1};super(62,"inlineSuggest",Z,{"editor.inlineSuggest.enabled":{type:"boolean",default:Z.enabled,description:u.localize(112,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:Z.showToolbar,enum:["always","onHover"],enumDescriptions:[u.localize(113,null),u.localize(114,null)],description:u.localize(115,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:Z.suppressSuggestions,description:u.localize(116,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const we=Z;return{enabled:t(we.enabled,this.defaultValue.enabled),mode:r(we.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:r(we.showToolbar,this.defaultValue.showToolbar,["always","onHover"]),suppressSuggestions:t(we.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:t(we.keepOnBlur,this.defaultValue.keepOnBlur)}}}class Y extends k{constructor(){const Z={enabled:O.$Wr.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:O.$Wr.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",Z,{"editor.bracketPairColorization.enabled":{type:"boolean",default:Z.enabled,markdownDescription:u.localize(117,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:Z.independentColorPoolPerBracketType,description:u.localize(118,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const we=Z;return{enabled:t(we.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:t(we.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class J extends k{constructor(){const Z={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",Z,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[u.localize(119,null),u.localize(120,null),u.localize(121,null)],default:Z.bracketPairs,description:u.localize(122,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[u.localize(123,null),u.localize(124,null),u.localize(125,null)],default:Z.bracketPairsHorizontal,description:u.localize(126,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:Z.highlightActiveBracketPair,description:u.localize(127,null)},"editor.guides.indentation":{type:"boolean",default:Z.indentation,description:u.localize(128,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[u.localize(129,null),u.localize(130,null),u.localize(131,null)],default:Z.highlightActiveIndentation,description:u.localize(132,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const we=Z;return{bracketPairs:te(we.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:te(we.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:t(we.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:t(we.indentation,this.defaultValue.indentation),highlightActiveIndentation:te(we.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function te(x,Z,we){const We=we.indexOf(x);return We===-1?Z:we[We]}class se extends k{constructor(){const Z={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(117,"suggest",Z,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[u.localize(133,null),u.localize(134,null)],default:Z.insertMode,description:u.localize(135,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Z.filterGraceful,description:u.localize(136,null)},"editor.suggest.localityBonus":{type:"boolean",default:Z.localityBonus,description:u.localize(137,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Z.shareSuggestSelections,markdownDescription:u.localize(138,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[u.localize(139,null),u.localize(140,null),u.localize(141,null),u.localize(142,null)],default:Z.selectionMode,markdownDescription:u.localize(143,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Z.snippetsPreventQuickSuggestions,description:u.localize(144,null)},"editor.suggest.showIcons":{type:"boolean",default:Z.showIcons,description:u.localize(145,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Z.showStatusBar,description:u.localize(146,null)},"editor.suggest.preview":{type:"boolean",default:Z.preview,description:u.localize(147,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Z.showInlineDetails,description:u.localize(148,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:u.localize(149,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:u.localize(150,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:u.localize(151,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:u.localize(152,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:u.localize(153,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:u.localize(154,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:u.localize(155,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:u.localize(156,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:u.localize(157,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:u.localize(158,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:u.localize(159,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:u.localize(160,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:u.localize(161,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:u.localize(162,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:u.localize(163,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:u.localize(164,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:u.localize(165,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:u.localize(166,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:u.localize(167,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:u.localize(168,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:u.localize(169,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:u.localize(170,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:u.localize(171,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:u.localize(172,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:u.localize(173,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:u.localize(174,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:u.localize(175,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:u.localize(176,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:u.localize(177,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:u.localize(178,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:u.localize(179,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:u.localize(180,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const we=Z;return{insertMode:r(we.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:t(we.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:t(we.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:t(we.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:t(we.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:r(we.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:t(we.showIcons,this.defaultValue.showIcons),showStatusBar:t(we.showStatusBar,this.defaultValue.showStatusBar),preview:t(we.preview,this.defaultValue.preview),previewMode:r(we.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:t(we.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:t(we.showMethods,this.defaultValue.showMethods),showFunctions:t(we.showFunctions,this.defaultValue.showFunctions),showConstructors:t(we.showConstructors,this.defaultValue.showConstructors),showDeprecated:t(we.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:t(we.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:t(we.showFields,this.defaultValue.showFields),showVariables:t(we.showVariables,this.defaultValue.showVariables),showClasses:t(we.showClasses,this.defaultValue.showClasses),showStructs:t(we.showStructs,this.defaultValue.showStructs),showInterfaces:t(we.showInterfaces,this.defaultValue.showInterfaces),showModules:t(we.showModules,this.defaultValue.showModules),showProperties:t(we.showProperties,this.defaultValue.showProperties),showEvents:t(we.showEvents,this.defaultValue.showEvents),showOperators:t(we.showOperators,this.defaultValue.showOperators),showUnits:t(we.showUnits,this.defaultValue.showUnits),showValues:t(we.showValues,this.defaultValue.showValues),showConstants:t(we.showConstants,this.defaultValue.showConstants),showEnums:t(we.showEnums,this.defaultValue.showEnums),showEnumMembers:t(we.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:t(we.showKeywords,this.defaultValue.showKeywords),showWords:t(we.showWords,this.defaultValue.showWords),showColors:t(we.showColors,this.defaultValue.showColors),showFiles:t(we.showFiles,this.defaultValue.showFiles),showReferences:t(we.showReferences,this.defaultValue.showReferences),showFolders:t(we.showFolders,this.defaultValue.showFolders),showTypeParameters:t(we.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:t(we.showSnippets,this.defaultValue.showSnippets),showUsers:t(we.showUsers,this.defaultValue.showUsers),showIssues:t(we.showIssues,this.defaultValue.showIssues)}}}class Fe extends k{constructor(){super(112,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:u.localize(181,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:u.localize(182,null),default:!0,type:"boolean"}})}validate(Z){return!Z||typeof Z!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:t(Z.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:t(Z.selectSubwords,this.defaultValue.selectSubwords)}}}var je;(function(x){x[x.None=0]="None",x[x.Same=1]="Same",x[x.Indent=2]="Indent",x[x.DeepIndent=3]="DeepIndent"})(je||(e.WrappingIndent=je={}));class Xe extends k{constructor(){super(136,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[u.localize(183,null),u.localize(184,null),u.localize(185,null),u.localize(186,null)],description:u.localize(187,null),default:"same"}})}validate(Z){switch(Z){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(Z,we,We){return we.get(2)===2?0:We}}class He extends m{constructor(){super(144)}compute(Z,we,We){const ze=we.get(143);return{isDominatedByLongLines:Z.isDominatedByLongLines,isWordWrapMinified:ze.isWordWrapMinified,isViewportWrapping:ze.isViewportWrapping,wrappingColumn:ze.wrappingColumn}}}class et extends k{constructor(){const Z={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",Z,{"editor.dropIntoEditor.enabled":{type:"boolean",default:Z.enabled,markdownDescription:u.localize(188,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:u.localize(189,null),enum:["afterDrop","never"],enumDescriptions:[u.localize(190,null),u.localize(191,null)],default:"afterDrop"}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const we=Z;return{enabled:t(we.enabled,this.defaultValue.enabled),showDropSelector:r(we.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class xe extends k{constructor(){const Z={enabled:!0,showPasteSelector:"afterPaste"};super(84,"pasteAs",Z,{"editor.pasteAs.enabled":{type:"boolean",default:Z.enabled,markdownDescription:u.localize(192,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:u.localize(193,null),enum:["afterPaste","never"],enumDescriptions:[u.localize(194,null),u.localize(195,null)],default:"afterPaste"}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const we=Z;return{enabled:t(we.enabled,this.defaultValue.enabled),showPasteSelector:r(we.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const it="Consolas, 'Courier New', monospace",st="Menlo, Monaco, 'Courier New', monospace",nt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:I.$e?st:I.$f?nt:it,fontWeight:"normal",fontSize:I.$e?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Ue(x){return e.editorOptionsRegistry[x.id]=x,x}var ot;(function(x){x[x.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",x[x.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",x[x.accessibilitySupport=2]="accessibilitySupport",x[x.accessibilityPageSize=3]="accessibilityPageSize",x[x.ariaLabel=4]="ariaLabel",x[x.ariaRequired=5]="ariaRequired",x[x.autoClosingBrackets=6]="autoClosingBrackets",x[x.autoClosingComments=7]="autoClosingComments",x[x.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",x[x.autoClosingDelete=9]="autoClosingDelete",x[x.autoClosingOvertype=10]="autoClosingOvertype",x[x.autoClosingQuotes=11]="autoClosingQuotes",x[x.autoIndent=12]="autoIndent",x[x.automaticLayout=13]="automaticLayout",x[x.autoSurround=14]="autoSurround",x[x.bracketPairColorization=15]="bracketPairColorization",x[x.guides=16]="guides",x[x.codeLens=17]="codeLens",x[x.codeLensFontFamily=18]="codeLensFontFamily",x[x.codeLensFontSize=19]="codeLensFontSize",x[x.colorDecorators=20]="colorDecorators",x[x.colorDecoratorsLimit=21]="colorDecoratorsLimit",x[x.columnSelection=22]="columnSelection",x[x.comments=23]="comments",x[x.contextmenu=24]="contextmenu",x[x.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",x[x.cursorBlinking=26]="cursorBlinking",x[x.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",x[x.cursorStyle=28]="cursorStyle",x[x.cursorSurroundingLines=29]="cursorSurroundingLines",x[x.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",x[x.cursorWidth=31]="cursorWidth",x[x.disableLayerHinting=32]="disableLayerHinting",x[x.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",x[x.domReadOnly=34]="domReadOnly",x[x.dragAndDrop=35]="dragAndDrop",x[x.dropIntoEditor=36]="dropIntoEditor",x[x.emptySelectionClipboard=37]="emptySelectionClipboard",x[x.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",x[x.extraEditorClassName=39]="extraEditorClassName",x[x.fastScrollSensitivity=40]="fastScrollSensitivity",x[x.find=41]="find",x[x.fixedOverflowWidgets=42]="fixedOverflowWidgets",x[x.folding=43]="folding",x[x.foldingStrategy=44]="foldingStrategy",x[x.foldingHighlight=45]="foldingHighlight",x[x.foldingImportsByDefault=46]="foldingImportsByDefault",x[x.foldingMaximumRegions=47]="foldingMaximumRegions",x[x.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",x[x.fontFamily=49]="fontFamily",x[x.fontInfo=50]="fontInfo",x[x.fontLigatures=51]="fontLigatures",x[x.fontSize=52]="fontSize",x[x.fontWeight=53]="fontWeight",x[x.fontVariations=54]="fontVariations",x[x.formatOnPaste=55]="formatOnPaste",x[x.formatOnType=56]="formatOnType",x[x.glyphMargin=57]="glyphMargin",x[x.gotoLocation=58]="gotoLocation",x[x.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",x[x.hover=60]="hover",x[x.inDiffEditor=61]="inDiffEditor",x[x.inlineSuggest=62]="inlineSuggest",x[x.letterSpacing=63]="letterSpacing",x[x.lightbulb=64]="lightbulb",x[x.lineDecorationsWidth=65]="lineDecorationsWidth",x[x.lineHeight=66]="lineHeight",x[x.lineNumbers=67]="lineNumbers",x[x.lineNumbersMinChars=68]="lineNumbersMinChars",x[x.linkedEditing=69]="linkedEditing",x[x.links=70]="links",x[x.matchBrackets=71]="matchBrackets",x[x.minimap=72]="minimap",x[x.mouseStyle=73]="mouseStyle",x[x.mouseWheelScrollSensitivity=74]="mouseWheelScrollSensitivity",x[x.mouseWheelZoom=75]="mouseWheelZoom",x[x.multiCursorMergeOverlapping=76]="multiCursorMergeOverlapping",x[x.multiCursorModifier=77]="multiCursorModifier",x[x.multiCursorPaste=78]="multiCursorPaste",x[x.multiCursorLimit=79]="multiCursorLimit",x[x.occurrencesHighlight=80]="occurrencesHighlight",x[x.overviewRulerBorder=81]="overviewRulerBorder",x[x.overviewRulerLanes=82]="overviewRulerLanes",x[x.padding=83]="padding",x[x.pasteAs=84]="pasteAs",x[x.parameterHints=85]="parameterHints",x[x.peekWidgetDefaultFocus=86]="peekWidgetDefaultFocus",x[x.definitionLinkOpensInPeek=87]="definitionLinkOpensInPeek",x[x.quickSuggestions=88]="quickSuggestions",x[x.quickSuggestionsDelay=89]="quickSuggestionsDelay",x[x.readOnly=90]="readOnly",x[x.readOnlyMessage=91]="readOnlyMessage",x[x.renameOnType=92]="renameOnType",x[x.renderControlCharacters=93]="renderControlCharacters",x[x.renderFinalNewline=94]="renderFinalNewline",x[x.renderLineHighlight=95]="renderLineHighlight",x[x.renderLineHighlightOnlyWhenFocus=96]="renderLineHighlightOnlyWhenFocus",x[x.renderValidationDecorations=97]="renderValidationDecorations",x[x.renderWhitespace=98]="renderWhitespace",x[x.revealHorizontalRightPadding=99]="revealHorizontalRightPadding",x[x.roundedSelection=100]="roundedSelection",x[x.rulers=101]="rulers",x[x.scrollbar=102]="scrollbar",x[x.scrollBeyondLastColumn=103]="scrollBeyondLastColumn",x[x.scrollBeyondLastLine=104]="scrollBeyondLastLine",x[x.scrollPredominantAxis=105]="scrollPredominantAxis",x[x.selectionClipboard=106]="selectionClipboard",x[x.selectionHighlight=107]="selectionHighlight",x[x.selectOnLineNumbers=108]="selectOnLineNumbers",x[x.showFoldingControls=109]="showFoldingControls",x[x.showUnused=110]="showUnused",x[x.snippetSuggestions=111]="snippetSuggestions",x[x.smartSelect=112]="smartSelect",x[x.smoothScrolling=113]="smoothScrolling",x[x.stickyScroll=114]="stickyScroll",x[x.stickyTabStops=115]="stickyTabStops",x[x.stopRenderingLineAfter=116]="stopRenderingLineAfter",x[x.suggest=117]="suggest",x[x.suggestFontSize=118]="suggestFontSize",x[x.suggestLineHeight=119]="suggestLineHeight",x[x.suggestOnTriggerCharacters=120]="suggestOnTriggerCharacters",x[x.suggestSelection=121]="suggestSelection",x[x.tabCompletion=122]="tabCompletion",x[x.tabIndex=123]="tabIndex",x[x.unicodeHighlighting=124]="unicodeHighlighting",x[x.unusualLineTerminators=125]="unusualLineTerminators",x[x.useShadowDOM=126]="useShadowDOM",x[x.useTabStops=127]="useTabStops",x[x.wordBreak=128]="wordBreak",x[x.wordSeparators=129]="wordSeparators",x[x.wordWrap=130]="wordWrap",x[x.wordWrapBreakAfterCharacters=131]="wordWrapBreakAfterCharacters",x[x.wordWrapBreakBeforeCharacters=132]="wordWrapBreakBeforeCharacters",x[x.wordWrapColumn=133]="wordWrapColumn",x[x.wordWrapOverride1=134]="wordWrapOverride1",x[x.wordWrapOverride2=135]="wordWrapOverride2",x[x.wrappingIndent=136]="wrappingIndent",x[x.wrappingStrategy=137]="wrappingStrategy",x[x.showDeprecated=138]="showDeprecated",x[x.inlayHints=139]="inlayHints",x[x.editorClassName=140]="editorClassName",x[x.pixelRatio=141]="pixelRatio",x[x.tabFocusMode=142]="tabFocusMode",x[x.layoutInfo=143]="layoutInfo",x[x.wrappingInfo=144]="wrappingInfo",x[x.defaultColorDecorators=145]="defaultColorDecorators",x[x.colorDecoratorsActivatedOn=146]="colorDecoratorsActivatedOn",x[x.inlineCompletionsAccessibilityVerbose=147]="inlineCompletionsAccessibilityVerbose"})(ot||(e.EditorOption=ot={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Ue(new s(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:u.localize(196,null)})),acceptSuggestionOnEnter:Ue(new i(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",u.localize(197,null),""],markdownDescription:u.localize(198,null)})),accessibilitySupport:Ue(new g),accessibilityPageSize:Ue(new v(3,"accessibilityPageSize",10,1,1073741824,{description:u.localize(199,null),tags:["accessibility"]})),ariaLabel:Ue(new n(4,"ariaLabel",u.localize(200,null))),ariaRequired:Ue(new s(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Ue(new s(8,"screenReaderAnnounceInlineSuggestion",!0,{description:u.localize(201,null),tags:["accessibility"]})),autoClosingBrackets:Ue(new i(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",u.localize(202,null),u.localize(203,null),""],description:u.localize(204,null)})),autoClosingComments:Ue(new i(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",u.localize(205,null),u.localize(206,null),""],description:u.localize(207,null)})),autoClosingDelete:Ue(new i(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",u.localize(208,null),""],description:u.localize(209,null)})),autoClosingOvertype:Ue(new i(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",u.localize(210,null),""],description:u.localize(211,null)})),autoClosingQuotes:Ue(new i(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",u.localize(212,null),u.localize(213,null),""],description:u.localize(214,null)})),autoIndent:Ue(new o(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],y,{enumDescriptions:[u.localize(215,null),u.localize(216,null),u.localize(217,null),u.localize(218,null),u.localize(219,null)],description:u.localize(220,null)})),automaticLayout:Ue(new s(13,"automaticLayout",!1)),autoSurround:Ue(new i(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[u.localize(221,null),u.localize(222,null),u.localize(223,null),""],description:u.localize(224,null)})),bracketPairColorization:Ue(new Y),bracketPairGuides:Ue(new J),stickyTabStops:Ue(new s(115,"stickyTabStops",!1,{description:u.localize(225,null)})),codeLens:Ue(new s(17,"codeLens",!0,{description:u.localize(226,null)})),codeLensFontFamily:Ue(new n(18,"codeLensFontFamily","",{description:u.localize(227,null)})),codeLensFontSize:Ue(new v(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:u.localize(228,null)})),colorDecorators:Ue(new s(20,"colorDecorators",!0,{description:u.localize(229,null)})),colorDecoratorActivatedOn:Ue(new i(146,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[u.localize(230,null),u.localize(231,null),u.localize(232,null)],description:u.localize(233,null)})),colorDecoratorsLimit:Ue(new v(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:u.localize(234,null)})),columnSelection:Ue(new s(22,"columnSelection",!1,{description:u.localize(235,null)})),comments:Ue(new E),contextmenu:Ue(new s(24,"contextmenu",!0)),copyWithSyntaxHighlighting:Ue(new s(25,"copyWithSyntaxHighlighting",!0,{description:u.localize(236,null)})),cursorBlinking:Ue(new o(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],l,{description:u.localize(237,null)})),cursorSmoothCaretAnimation:Ue(new i(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[u.localize(238,null),u.localize(239,null),u.localize(240,null)],description:u.localize(241,null)})),cursorStyle:Ue(new o(28,"cursorStyle",$.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],M,{description:u.localize(242,null)})),cursorSurroundingLines:Ue(new v(29,"cursorSurroundingLines",0,0,1073741824,{description:u.localize(243,null)})),cursorSurroundingLinesStyle:Ue(new i(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[u.localize(244,null),u.localize(245,null)],markdownDescription:u.localize(246,null)})),cursorWidth:Ue(new v(31,"cursorWidth",0,0,1073741824,{markdownDescription:u.localize(247,null)})),disableLayerHinting:Ue(new s(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:Ue(new s(33,"disableMonospaceOptimizations",!1)),domReadOnly:Ue(new s(34,"domReadOnly",!1)),dragAndDrop:Ue(new s(35,"dragAndDrop",!0,{description:u.localize(248,null)})),emptySelectionClipboard:Ue(new F),dropIntoEditor:Ue(new et),stickyScroll:Ue(new ue),experimentalWhitespaceRendering:Ue(new i(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[u.localize(249,null),u.localize(250,null),u.localize(251,null)],description:u.localize(252,null)})),extraEditorClassName:Ue(new n(39,"extraEditorClassName","")),fastScrollSensitivity:Ue(new p(40,"fastScrollSensitivity",5,x=>x<=0?5:x,{markdownDescription:u.localize(253,null)})),find:Ue(new q),fixedOverflowWidgets:Ue(new s(42,"fixedOverflowWidgets",!1)),folding:Ue(new s(43,"folding",!0,{description:u.localize(254,null)})),foldingStrategy:Ue(new i(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[u.localize(255,null),u.localize(256,null)],description:u.localize(257,null)})),foldingHighlight:Ue(new s(45,"foldingHighlight",!0,{description:u.localize(258,null)})),foldingImportsByDefault:Ue(new s(46,"foldingImportsByDefault",!1,{description:u.localize(259,null)})),foldingMaximumRegions:Ue(new v(47,"foldingMaximumRegions",5e3,10,65e3,{description:u.localize(260,null)})),unfoldOnClickAfterEndOfLine:Ue(new s(48,"unfoldOnClickAfterEndOfLine",!1,{description:u.localize(261,null)})),fontFamily:Ue(new n(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:u.localize(262,null)})),fontInfo:Ue(new z),fontLigatures2:Ue(new W),fontSize:Ue(new K),fontWeight:Ue(new B),fontVariations:Ue(new L),formatOnPaste:Ue(new s(55,"formatOnPaste",!1,{description:u.localize(263,null)})),formatOnType:Ue(new s(56,"formatOnType",!1,{description:u.localize(264,null)})),glyphMargin:Ue(new s(57,"glyphMargin",!0,{description:u.localize(265,null)})),gotoLocation:Ue(new me),hideCursorInOverviewRuler:Ue(new s(59,"hideCursorInOverviewRuler",!1,{description:u.localize(266,null)})),hover:Ue(new ye),inDiffEditor:Ue(new s(61,"inDiffEditor",!1)),letterSpacing:Ue(new p(63,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,x=>p.clamp(x,-5,20),{description:u.localize(267,null)})),lightbulb:Ue(new De),lineDecorationsWidth:Ue(new ke),lineHeight:Ue(new V),lineNumbers:Ue(new le),lineNumbersMinChars:Ue(new v(68,"lineNumbersMinChars",5,1,300)),linkedEditing:Ue(new s(69,"linkedEditing",!1,{description:u.localize(268,null)})),links:Ue(new s(70,"links",!0,{description:u.localize(269,null)})),matchBrackets:Ue(new i(71,"matchBrackets","always",["always","near","never"],{description:u.localize(270,null)})),minimap:Ue(new Q),mouseStyle:Ue(new i(73,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Ue(new p(74,"mouseWheelScrollSensitivity",1,x=>x===0?1:x,{markdownDescription:u.localize(271,null)})),mouseWheelZoom:Ue(new s(75,"mouseWheelZoom",!1,{markdownDescription:u.localize(272,null)})),multiCursorMergeOverlapping:Ue(new s(76,"multiCursorMergeOverlapping",!0,{description:u.localize(273,null)})),multiCursorModifier:Ue(new o(77,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],ee,{markdownEnumDescriptions:[u.localize(274,null),u.localize(275,null)],markdownDescription:u.localize(276,null)})),multiCursorPaste:Ue(new i(78,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[u.localize(277,null),u.localize(278,null)],markdownDescription:u.localize(279,null)})),multiCursorLimit:Ue(new v(79,"multiCursorLimit",1e4,1,1e5,{markdownDescription:u.localize(280,null)})),occurrencesHighlight:Ue(new s(80,"occurrencesHighlight",!0,{description:u.localize(281,null)})),overviewRulerBorder:Ue(new s(81,"overviewRulerBorder",!0,{description:u.localize(282,null)})),overviewRulerLanes:Ue(new v(82,"overviewRulerLanes",3,0,3)),padding:Ue(new $e),pasteAs:Ue(new xe),parameterHints:Ue(new he),peekWidgetDefaultFocus:Ue(new i(86,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[u.localize(283,null),u.localize(284,null)],description:u.localize(285,null)})),definitionLinkOpensInPeek:Ue(new s(87,"definitionLinkOpensInPeek",!1,{description:u.localize(286,null)})),quickSuggestions:Ue(new Ee),quickSuggestionsDelay:Ue(new v(89,"quickSuggestionsDelay",10,0,1073741824,{description:u.localize(287,null)})),readOnly:Ue(new s(90,"readOnly",!1)),readOnlyMessage:Ue(new pe),renameOnType:Ue(new s(92,"renameOnType",!1,{description:u.localize(288,null),markdownDeprecationMessage:u.localize(289,null)})),renderControlCharacters:Ue(new s(93,"renderControlCharacters",!0,{description:u.localize(290,null),restricted:!0})),renderFinalNewline:Ue(new i(94,"renderFinalNewline",I.$f?"dimmed":"on",["off","on","dimmed"],{description:u.localize(291,null)})),renderLineHighlight:Ue(new i(95,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",u.localize(292,null)],description:u.localize(293,null)})),renderLineHighlightOnlyWhenFocus:Ue(new s(96,"renderLineHighlightOnlyWhenFocus",!1,{description:u.localize(294,null)})),renderValidationDecorations:Ue(new i(97,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Ue(new i(98,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",u.localize(295,null),u.localize(296,null),u.localize(297,null),""],description:u.localize(298,null)})),revealHorizontalRightPadding:Ue(new v(99,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Ue(new s(100,"roundedSelection",!0,{description:u.localize(299,null)})),rulers:Ue(new ae),scrollbar:Ue(new T),scrollBeyondLastColumn:Ue(new v(103,"scrollBeyondLastColumn",4,0,1073741824,{description:u.localize(300,null)})),scrollBeyondLastLine:Ue(new s(104,"scrollBeyondLastLine",!0,{description:u.localize(301,null)})),scrollPredominantAxis:Ue(new s(105,"scrollPredominantAxis",!0,{description:u.localize(302,null)})),selectionClipboard:Ue(new s(106,"selectionClipboard",!0,{description:u.localize(303,null),included:I.$f})),selectionHighlight:Ue(new s(107,"selectionHighlight",!0,{description:u.localize(304,null)})),selectOnLineNumbers:Ue(new s(108,"selectOnLineNumbers",!0)),showFoldingControls:Ue(new i(109,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[u.localize(305,null),u.localize(306,null),u.localize(307,null)],description:u.localize(308,null)})),showUnused:Ue(new s(110,"showUnused",!0,{description:u.localize(309,null)})),showDeprecated:Ue(new s(138,"showDeprecated",!0,{description:u.localize(310,null)})),inlayHints:Ue(new ve),snippetSuggestions:Ue(new i(111,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[u.localize(311,null),u.localize(312,null),u.localize(313,null),u.localize(314,null)],description:u.localize(315,null)})),smartSelect:Ue(new Fe),smoothScrolling:Ue(new s(113,"smoothScrolling",!1,{description:u.localize(316,null)})),stopRenderingLineAfter:Ue(new v(116,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Ue(new se),inlineSuggest:Ue(new X),inlineCompletionsAccessibilityVerbose:Ue(new s(147,"inlineCompletionsAccessibilityVerbose",!1,{description:u.localize(317,null)})),suggestFontSize:Ue(new v(118,"suggestFontSize",0,0,1e3,{markdownDescription:u.localize(318,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Ue(new v(119,"suggestLineHeight",0,0,1e3,{markdownDescription:u.localize(319,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Ue(new s(120,"suggestOnTriggerCharacters",!0,{description:u.localize(320,null)})),suggestSelection:Ue(new i(121,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[u.localize(321,null),u.localize(322,null),u.localize(323,null)],description:u.localize(324,null)})),tabCompletion:Ue(new i(122,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[u.localize(325,null),u.localize(326,null),u.localize(327,null)],description:u.localize(328,null)})),tabIndex:Ue(new v(123,"tabIndex",0,-1,1073741824)),unicodeHighlight:Ue(new H),unusualLineTerminators:Ue(new i(125,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[u.localize(329,null),u.localize(330,null),u.localize(331,null)],description:u.localize(332,null)})),useShadowDOM:Ue(new s(126,"useShadowDOM",!0)),useTabStops:Ue(new s(127,"useTabStops",!0,{description:u.localize(333,null)})),wordBreak:Ue(new i(128,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[u.localize(334,null),u.localize(335,null)],description:u.localize(336,null)})),wordSeparators:Ue(new n(129,"wordSeparators",R.$Xr,{description:u.localize(337,null)})),wordWrap:Ue(new i(130,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[u.localize(338,null),u.localize(339,null),u.localize(340,null),u.localize(341,null)],description:u.localize(342,null)})),wordWrapBreakAfterCharacters:Ue(new n(131,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Ue(new n(132,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Ue(new v(133,"wordWrapColumn",80,1,1073741824,{markdownDescription:u.localize(343,null)})),wordWrapOverride1:Ue(new i(134,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Ue(new i(135,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Ue(new U),defaultColorDecorators:Ue(new s(145,"defaultColorDecorators",!1,{markdownDescription:u.localize(344,null)})),pixelRatio:Ue(new fe),tabFocusMode:Ue(new s(142,"tabFocusMode",!1,{markdownDescription:u.localize(345,null)})),layoutInfo:Ue(new _),wrappingInfo:Ue(new He),wrappingIndent:Ue(new Xe),wrappingStrategy:Ue(new de)}}),define(Ae[137],Re([10,11]),function(ie,e){return ie.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ae[138],Re([10,11]),function(ie,e){return ie.create("vs/platform/contextkey/common/contextkey",e)}),define(Ae[139],Re([10,11]),function(ie,e){return ie.create("vs/platform/contextkey/common/scanner",e)}),define(Ae[140],Re([10,11]),function(ie,e){return ie.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Ae[141],Re([10,11]),function(ie,e){return ie.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ae[142],Re([10,11]),function(ie,e){return ie.create("vs/platform/files/common/files",e)}),define(Ae[143],Re([10,11]),function(ie,e){return ie.create("vs/platform/markers/common/markers",e)}),define(Ae[144],Re([10,11]),function(ie,e){return ie.create("vs/platform/theme/common/iconRegistry",e)}),define(Ae[145],Re([10,11]),function(ie,e){return ie.create("vs/platform/workspace/common/workspace",e)}),define(Ae[146],Re([10,11]),function(ie,e){return ie.create("vs/workbench/api/common/extHostChat",e)}),define(Ae[147],Re([10,11]),function(ie,e){return ie.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Ae[148],Re([10,11]),function(ie,e){return ie.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Ae[149],Re([10,11]),function(ie,e){return ie.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Ae[150],Re([10,11]),function(ie,e){return ie.create("vs/workbench/api/common/extHostLogService",e)}),define(Ae[151],Re([10,11]),function(ie,e){return ie.create("vs/workbench/api/common/extHostNotebook",e)}),define(Ae[152],Re([10,11]),function(ie,e){return ie.create("vs/workbench/api/common/extHostProgress",e)}),define(Ae[153],Re([10,11]),function(ie,e){return ie.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Ae[154],Re([10,11]),function(ie,e){return ie.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Ae[155],Re([10,11]),function(ie,e){return ie.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Ae[156],Re([10,11]),function(ie,e){return ie.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Ae[157],Re([10,11]),function(ie,e){return ie.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Ae[158],Re([10,11]),function(ie,e){return ie.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Ae[159],Re([10,11]),function(ie,e){return ie.create("vs/workbench/common/editor",e)}),define(Ae[160],Re([10,11]),function(ie,e){return ie.create("vs/workbench/common/views",e)}),define(Ae[161],Re([10,11]),function(ie,e){return ie.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Ae[162],Re([10,11]),function(ie,e){return ie.create("vs/workbench/contrib/debug/common/debug",e)}),define(Ae[163],Re([10,11]),function(ie,e){return ie.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Ae[164],Re([10,11]),function(ie,e){return ie.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Ae[165],Re([10,11]),function(ie,e){return ie.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ae[166],Re([10,11]),function(ie,e){return ie.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Ae[167],Re([10,11]),function(ie,e){return ie.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Ae[168],Re([1,0,9,139]),function(ie,e,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gi=e.TokenType=void 0;var I;(function(d){d[d.LParen=0]="LParen",d[d.RParen=1]="RParen",d[d.Neg=2]="Neg",d[d.Eq=3]="Eq",d[d.NotEq=4]="NotEq",d[d.Lt=5]="Lt",d[d.LtEq=6]="LtEq",d[d.Gt=7]="Gt",d[d.GtEq=8]="GtEq",d[d.RegexOp=9]="RegexOp",d[d.RegexStr=10]="RegexStr",d[d.True=11]="True",d[d.False=12]="False",d[d.In=13]="In",d[d.Not=14]="Not",d[d.And=15]="And",d[d.Or=16]="Or",d[d.Str=17]="Str",d[d.QuotedStr=18]="QuotedStr",d[d.Error=19]="Error",d[d.EOF=20]="EOF"})(I||(e.TokenType=I={}));function O(...d){switch(d.length){case 1:return(0,C.localize)(0,null,d[0]);case 2:return(0,C.localize)(1,null,d[0],d[1]);case 3:return(0,C.localize)(2,null,d[0],d[1],d[2]);default:return}}const R=(0,C.localize)(3,null),u=(0,C.localize)(4,null);class D{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(A){switch(A.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return A.isTripleEq?"===":"==";case 4:return A.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return A.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return A.lexeme;case 18:return A.lexeme;case 19:return A.lexeme;case 20:return"EOF";default:throw(0,h.$6)(`unhandled token type: ${JSON.stringify(A)}; have you forgotten to add a case?`)}}get errors(){return this.g}reset(A){return this.c=A,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const k=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:k})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const k=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:k})}else this.h(126)?this.k(9):this.l(O("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(O("&&"));break;case 124:this.h(124)?this.k(16):this.l(O("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(A){return this.r()||this.c.charCodeAt(this.e)!==A?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(A){this.f.push({type:A,offset:this.d})}l(A){const k=this.d,a=this.c.substring(this.d,this.e),w={type:19,offset:this.d,lexeme:a};this.g.push({offset:k,lexeme:a,additionalInfo:A}),this.f.push(w)}n(){this.m.lastIndex=this.d;const A=this.m.exec(this.c);if(A){this.e=this.d+A[0].length;const k=this.c.substring(this.d,this.e),a=D.b.get(k);a?this.k(a):this.f.push({type:17,lexeme:k,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(R);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let A=this.e,k=!1,a=!1;for(;;){if(A>=this.c.length){this.e=A,this.l(u);return}const m=this.c.charCodeAt(A);if(k)k=!1;else if(m===47&&!a){A++;break}else m===91?a=!0:m===92?k=!0:m===93&&(a=!1);A++}for(;A<this.c.length&&D.a.has(this.c.charCodeAt(A));)A++;this.e=A;const w=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:w,offset:this.d})}r(){return this.e>=this.c.length}}e.$Gi=D,D.a=new Set(["i","g","s","m","y","u"].map(d=>d.charCodeAt(0))),D.b=new Map([["not",14],["in",13],["false",12],["true",11]])}),define(Ae[169],Re([1,0,23,29,141,277]),function(ie,e,h,C,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=void 0;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,u=/^-(\d{4})(\d{2})(\d{2})$/;function D(s){return s=s.trim(),s==="*"||R.test(s)}e.$Do=D;function d(s){if(!D(s))return null;if(s=s.trim(),s==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const c=s.match(R);return c?{hasCaret:c[1]==="^",hasGreaterEquals:c[1]===">=",majorBase:c[2]==="x"?0:parseInt(c[2],10),majorMustEqual:c[2]!=="x",minorBase:c[4]==="x"?0:parseInt(c[4],10),minorMustEqual:c[4]!=="x",patchBase:c[6]==="x"?0:parseInt(c[6],10),patchMustEqual:c[6]!=="x",preRelease:c[8]||null}:null}e.$Eo=d;function A(s){if(!s)return null;const c=s.majorBase,v=s.majorMustEqual,S=s.minorBase;let p=s.minorMustEqual;const n=s.patchBase;let r=s.patchMustEqual;s.hasCaret&&(c===0||(p=!1),r=!1);let i=0;if(s.preRelease){const o=u.exec(s.preRelease);if(o){const[,y,g,E]=o;i=Date.UTC(Number(y),Number(g)-1,Number(E))}}return{majorBase:c,majorMustEqual:v,minorBase:S,minorMustEqual:p,patchBase:n,patchMustEqual:r,isMinimum:s.hasGreaterEquals,notBefore:i}}e.$Fo=A;function k(s,c,v){let S;typeof s=="string"?S=A(d(s)):S=s;let p;c instanceof Date?p=c.getTime():typeof c=="string"&&(p=new Date(c).getTime());let n;if(typeof v=="string"?n=A(d(v)):n=v,!S||!n)return!1;const r=S.majorBase,i=S.minorBase,o=S.patchBase;let y=n.majorBase,g=n.minorBase,E=n.patchBase;const P=n.notBefore;let l=n.majorMustEqual,$=n.minorMustEqual,b=n.patchMustEqual;return n.isMinimum?r>y?!0:r<y?!1:i>g?!0:i<g||p&&p<P?!1:o>=E:(r===1&&y===0&&(!l||!$||!b)&&(y=1,g=0,E=0,l=!0,$=!1,b=!1),r<y?!1:r>y?!l:i<g?!1:i>g?!$:o<E?!1:o>E?!b:!(p&&p<P))}e.$Go=k;function a(s,c,v,S,p){const n=[];if(typeof S.publisher<"u"&&typeof S.publisher!="string")return n.push([C.default.Error,I.localize(0,null)]),n;if(typeof S.name!="string")return n.push([C.default.Error,I.localize(1,null,"name")]),n;if(typeof S.version!="string")return n.push([C.default.Error,I.localize(2,null,"version")]),n;if(!S.engines)return n.push([C.default.Error,I.localize(3,null,"engines")]),n;if(typeof S.engines.vscode!="string")return n.push([C.default.Error,I.localize(4,null,"engines.vscode")]),n;if(typeof S.extensionDependencies<"u"&&!t(S.extensionDependencies))return n.push([C.default.Error,I.localize(5,null,"extensionDependencies")]),n;if(typeof S.activationEvents<"u"){if(!t(S.activationEvents))return n.push([C.default.Error,I.localize(6,null,"activationEvents")]),n;if(typeof S.main>"u"&&typeof S.browser>"u")return n.push([C.default.Error,I.localize(7,null,"activationEvents","main","browser")]),n}if(typeof S.extensionKind<"u"&&typeof S.main>"u"&&n.push([C.default.Warning,I.localize(8,null,"extensionKind")]),typeof S.main<"u"){if(typeof S.main!="string")return n.push([C.default.Error,I.localize(9,null,"main")]),n;{const o=(0,h.$sg)(v,S.main);(0,h.$mg)(o,v)||n.push([C.default.Warning,I.localize(10,null,o.path,v.path)])}}if(typeof S.browser<"u"){if(typeof S.browser!="string")return n.push([C.default.Error,I.localize(11,null,"browser")]),n;{const o=(0,h.$sg)(v,S.browser);(0,h.$mg)(o,v)||n.push([C.default.Warning,I.localize(12,null,o.path,v.path)])}}if(!O.valid(S.version))return n.push([C.default.Error,I.localize(13,null)]),n;const r=[];if(!w(s,c,S,p,r))for(const o of r)n.push([C.default.Error,o]);return n}e.$Ho=a;function w(s,c,v,S,p){return S||typeof v.main>"u"&&typeof v.browser>"u"?!0:f(s,c,v.engines.vscode,p)}e.$Io=w;function m(s,c,v){return s==="*"||f(c,v,s)}e.$Jo=m;function f(s,c,v,S=[]){const p=A(d(v));if(!p)return S.push(I.localize(14,null,v)),!1;if(p.majorBase===0){if(!p.majorMustEqual||!p.minorMustEqual)return S.push(I.localize(15,null,v)),!1}else if(!p.majorMustEqual)return S.push(I.localize(16,null,v)),!1;return k(s,c,p)?!0:(S.push(I.localize(17,null,s,v)),!1)}function t(s){if(!Array.isArray(s))return!1;for(let c=0,v=s.length;c<v;c++)if(typeof s[c]!="string")return!1;return!0}}),define(Ae[70],Re([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ih=void 0;class h{constructor(I,O=[],R=!1){this.ctor=I,this.staticArguments=O,this.supportsDelayedInstantiation=R}}e.$Ih=h}),define(Ae[71],Re([1,0,70]),function(ie,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pr=e.$or=e.InstantiationType=void 0;const C=[];var I;(function(u){u[u.Eager=0]="Eager",u[u.Delayed=1]="Delayed"})(I||(e.InstantiationType=I={}));function O(u,D,d){D instanceof h.$Ih||(D=new h.$Ih(D,[],!!d)),C.push([u,D])}e.$or=O;function R(){return C}e.$pr=R}),define(Ae[170],Re([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7p=e.$6p=void 0;class h{constructor(O,R){this.key=O,this.data=R,this.incoming=new Map,this.outgoing=new Map}}e.$6p=h;class C{constructor(O){this.b=O,this.a=new Map}roots(){const O=[];for(const R of this.a.values())R.outgoing.size===0&&O.push(R);return O}insertEdge(O,R){const u=this.lookupOrInsertNode(O),D=this.lookupOrInsertNode(R);u.outgoing.set(D.key,D),D.incoming.set(u.key,u)}removeNode(O){const R=this.b(O);this.a.delete(R);for(const u of this.a.values())u.outgoing.delete(R),u.incoming.delete(R)}lookupOrInsertNode(O){const R=this.b(O);let u=this.a.get(R);return u||(u=new h(R,O),this.a.set(R,u)),u}lookup(O){return this.a.get(this.b(O))}isEmpty(){return this.a.size===0}toString(){const O=[];for(const[R,u]of this.a)O.push(`${R}
	(-> incoming)[${[...u.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...u.outgoing.keys()].join(",")}]
`);return O.join(`
`)}findCycleSlow(){for(const[O,R]of this.a){const u=new Set([O]),D=this.c(R,u);if(D)return D}}c(O,R){for(const[u,D]of O.outgoing){if(R.has(u))return[...R,u].join(" -> ");R.add(u);const d=this.c(D,R);if(d)return d;R.delete(u)}}}e.$7p=C}),define(Ae[4],Re([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mh=e.$Lh=e.$Kh=e._util=void 0;var h;(function(R){R.serviceIds=new Map,R.DI_TARGET="$di$target",R.DI_DEPENDENCIES="$di$dependencies";function u(D){return D[R.DI_DEPENDENCIES]||[]}R.getServiceDependencies=u})(h||(e._util=h={})),e.$Kh=I("instantiationService");function C(R,u,D){u[h.DI_TARGET]===u?u[h.DI_DEPENDENCIES].push({id:R,index:D}):(u[h.DI_DEPENDENCIES]=[{id:R,index:D}],u[h.DI_TARGET]=u)}function I(R){if(h.serviceIds.has(R))return h.serviceIds.get(R);const u=function(D,d,A){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");C(u,D,A)};return u.toString=()=>R,h.serviceIds.set(R,u),u}e.$Lh=I;function O(R){return R}e.$Mh=O}),define(Ae[43],Re([1,0,16,2,4]),function(ie,e,h,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pi=e.$oi=e.$ni=e.$mi=e.$li=e.$ki=e.$ji=e.$ii=e.ConfigurationTarget=e.$hi=e.$gi=e.$fi=void 0,e.$fi=(0,I.$Lh)("configurationService");function O(s){return s&&typeof s=="object"&&(!s.overrideIdentifier||typeof s.overrideIdentifier=="string")&&(!s.resource||s.resource instanceof C.URI)}e.$gi=O;function R(s){return s&&typeof s=="object"&&(!s.overrideIdentifiers||Array.isArray(s.overrideIdentifiers))&&!s.overrideIdentifier&&(!s.resource||s.resource instanceof C.URI)}e.$hi=R;var u;(function(s){s[s.APPLICATION=1]="APPLICATION",s[s.USER=2]="USER",s[s.USER_LOCAL=3]="USER_LOCAL",s[s.USER_REMOTE=4]="USER_REMOTE",s[s.WORKSPACE=5]="WORKSPACE",s[s.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",s[s.DEFAULT=7]="DEFAULT",s[s.MEMORY=8]="MEMORY"})(u||(e.ConfigurationTarget=u={}));function D(s){switch(s){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$ii=D;function d(s){return s.applicationValue!==void 0||s.userValue!==void 0||s.userLocalValue!==void 0||s.userRemoteValue!==void 0||s.workspaceValue!==void 0||s.workspaceFolderValue!==void 0}e.$ji=d;function A(s,c){const v=Object.create(null);for(const S in s)k(v,S,s[S],c);return v}e.$ki=A;function k(s,c,v,S){const p=c.split("."),n=p.pop();let r=s;for(let i=0;i<p.length;i++){const o=p[i];let y=r[o];switch(typeof y){case"undefined":y=r[o]=Object.create(null);break;case"object":break;default:S(`Ignoring ${c} as ${p.slice(0,i+1).join(".")} is ${JSON.stringify(y)}`);return}r=y}if(typeof r=="object"&&r!==null)try{r[n]=v}catch{S(`Ignoring ${c} as ${p.join(".")} is ${JSON.stringify(r)}`)}else S(`Ignoring ${c} as ${p.join(".")} is ${JSON.stringify(r)}`)}e.$li=k;function a(s,c){const v=c.split(".");w(s,v)}e.$mi=a;function w(s,c){const v=c.shift();if(c.length===0){delete s[v];return}if(Object.keys(s).indexOf(v)!==-1){const S=s[v];typeof S=="object"&&!Array.isArray(S)&&(w(S,c),Object.keys(S).length===0&&delete s[v])}}function m(s,c,v){function S(r,i){let o=r;for(const y of i){if(typeof o!="object"||o===null)return;o=o[y]}return o}const p=c.split("."),n=S(s,p);return typeof n>"u"?v:n}e.$ni=m;function f(s,c,v){Object.keys(c).forEach(S=>{S!=="__proto__"&&(S in s?h.$yf(s[S])&&h.$yf(c[S])?f(s[S],c[S],v):v&&(s[S]=c[S]):s[S]=c[S])})}e.$oi=f;function t(s){return s.replace(/[\[\]]/g,"")}e.$pi=t}),define(Ae[32],Re([1,0,22,15,168,4,138,9]),function(ie,e,h,C,I,O,R,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.$Mi=e.$Li=e.$Ki=e.$Ji=e.$Ii=e.ContextKeyExprType=e.$Hi=void 0;const D=new Map;D.set("false",!1),D.set("true",!0),D.set("isMac",h.$e),D.set("isLinux",h.$f),D.set("isWindows",h.$d),D.set("isWeb",h.$j),D.set("isMacNative",h.$e&&!h.$j),D.set("isEdge",h.$B),D.set("isFirefox",h.$z),D.set("isChrome",h.$y),D.set("isSafari",h.$A);function d(ke,V){if(D.get(ke)!==void 0)throw(0,u.$5)("contextkey.setConstant(k, v) invoked with already set constant `k`");D.set(ke,V)}e.$Hi=d;const A=Object.prototype.hasOwnProperty;var k;(function(ke){ke[ke.False=0]="False",ke[ke.True=1]="True",ke[ke.Defined=2]="Defined",ke[ke.Not=3]="Not",ke[ke.Equals=4]="Equals",ke[ke.NotEquals=5]="NotEquals",ke[ke.And=6]="And",ke[ke.Regex=7]="Regex",ke[ke.NotRegex=8]="NotRegex",ke[ke.Or=9]="Or",ke[ke.In=10]="In",ke[ke.NotIn=11]="NotIn",ke[ke.Greater=12]="Greater",ke[ke.GreaterEquals=13]="GreaterEquals",ke[ke.Smaller=14]="Smaller",ke[ke.SmallerEquals=15]="SmallerEquals"})(k||(e.ContextKeyExprType=k={}));const a={regexParsingWithErrorRecovery:!0},w=(0,R.localize)(0,null),m=(0,R.localize)(1,null),f=(0,R.localize)(2,null),t=(0,R.localize)(3,null),s=(0,R.localize)(4,null),c=(0,R.localize)(5,null),v=(0,R.localize)(6,null),S=(0,R.localize)(7,null);class p{get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(V=a){this.k=V,this.d=new I.$Gi,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(V){if(V===""){this.h.push({message:w,offset:0,lexeme:"",additionalInfo:m});return}this.f=this.d.reset(V).scan(),this.g=0,this.h=[];try{const Q=this.l();if(!this.E()){const ee=this.D(),$e=ee.type===17?c:void 0;throw this.h.push({message:s,offset:ee.offset,lexeme:I.$Gi.getLexeme(ee),additionalInfo:$e}),p.c}return Q}catch(Q){if(Q!==p.c)throw Q;return}}l(){return this.m()}m(){const V=[this.o()];for(;this.y(16);){const Q=this.o();V.push(Q)}return V.length===1?V[0]:n.or(...V)}o(){const V=[this.s()];for(;this.y(15);){const Q=this.s();V.push(Q)}return V.length===1?V[0]:n.and(...V)}s(){if(this.y(2)){const V=this.D();switch(V.type){case 11:return this.z(),y.INSTANCE;case 12:return this.z(),g.INSTANCE;case 0:{this.z();const Q=this.l();return this.A(1,t),Q?.negate()}case 17:return this.z(),M.create(V.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",V)}}return this.t()}t(){const V=this.D();switch(V.type){case 11:return this.z(),n.true();case 12:return this.z(),n.false();case 0:{this.z();const Q=this.l();return this.A(1,t),Q}case 17:{const Q=V.lexeme;if(this.z(),this.y(9)){const $e=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),$e.type!==10)throw this.B("REGEX",$e);const he=$e.lexeme,fe=he.lastIndexOf("/"),Ee=fe===he.length-1?void 0:this.w(he.substring(fe+1));let re;try{re=new RegExp(he.substring(1,fe),Ee)}catch{throw this.B("REGEX",$e)}return z.create(Q,re)}switch($e.type){case 10:case 19:{const he=[$e.lexeme];this.z();let fe=this.D(),Ee=0;for(let pe=0;pe<$e.lexeme.length;pe++)$e.lexeme.charCodeAt(pe)===40?Ee++:$e.lexeme.charCodeAt(pe)===41&&Ee--;for(;!this.E()&&fe.type!==15&&fe.type!==16;){switch(fe.type){case 0:Ee++;break;case 1:Ee--;break;case 10:case 18:for(let pe=0;pe<fe.lexeme.length;pe++)fe.lexeme.charCodeAt(pe)===40?Ee++:$e.lexeme.charCodeAt(pe)===41&&Ee--}if(Ee<0)break;he.push(I.$Gi.getLexeme(fe)),this.z(),fe=this.D()}const re=he.join(""),le=re.lastIndexOf("/"),oe=le===re.length-1?void 0:this.w(re.substring(le+1));let ae;try{ae=new RegExp(re.substring(1,le),oe)}catch{throw this.B("REGEX",$e)}return n.regex(Q,ae)}case 18:{const he=$e.lexeme;this.z();let fe=null;if(!(0,C.$ze)(he)){const Ee=he.indexOf("/"),re=he.lastIndexOf("/");if(Ee!==re&&Ee>=0){const le=he.slice(Ee+1,re),oe=he[re+1]==="i"?"i":"";try{fe=new RegExp(le,oe)}catch{throw this.B("REGEX",$e)}}}if(fe===null)throw this.B("REGEX",$e);return z.create(Q,fe)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,f);const $e=this.u();return n.notIn(Q,$e)}switch(this.D().type){case 3:{this.z();const $e=this.u();if(this.x().type===18)return n.equals(Q,$e);switch($e){case"true":return n.has(Q);case"false":return n.not(Q);default:return n.equals(Q,$e)}}case 4:{this.z();const $e=this.u();if(this.x().type===18)return n.notEquals(Q,$e);switch($e){case"true":return n.not(Q);case"false":return n.has(Q);default:return n.notEquals(Q,$e)}}case 5:return this.z(),W.create(Q,this.u());case 6:return this.z(),L.create(Q,this.u());case 7:return this.z(),F.create(Q,this.u());case 8:return this.z(),q.create(Q,this.u());case 13:return this.z(),n.in(Q,this.u());default:return n.has(Q)}}case 20:throw this.h.push({message:v,offset:V.offset,lexeme:"",additionalInfo:S}),p.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const V=this.D();switch(V.type){case 17:case 18:return this.z(),V.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(V){return V.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(V){return this.C(V)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(V,Q){if(this.C(V))return this.z();throw this.B(Q,this.D())}B(V,Q,ee){const $e=(0,R.localize)(8,null,V,I.$Gi.getLexeme(Q)),he=Q.offset,fe=I.$Gi.getLexeme(Q);return this.h.push({message:$e,offset:he,lexeme:fe,additionalInfo:ee}),p.c}C(V){return this.D().type===V}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Ii=p,p.c=new Error;class n{static false(){return y.INSTANCE}static true(){return g.INSTANCE}static has(V){return E.create(V)}static equals(V,Q){return P.create(V,Q)}static notEquals(V,Q){return b.create(V,Q)}static regex(V,Q){return z.create(V,Q)}static in(V,Q){return l.create(V,Q)}static notIn(V,Q){return $.create(V,Q)}static not(V){return M.create(V)}static and(...V){return me.create(V,null,!0)}static or(...V){return ye.create(V,null,!0)}static greater(V,Q){return F.create(V,Q)}static greaterEquals(V,Q){return q.create(V,Q)}static smaller(V,Q){return W.create(V,Q)}static smallerEquals(V,Q){return L.create(V,Q)}static deserialize(V){return V==null?void 0:this.c.parse(V)}}e.$Ji=n,n.c=new p({regexParsingWithErrorRecovery:!1});function r(ke){const V=new p({regexParsingWithErrorRecovery:!1});return ke.map(Q=>(V.parse(Q),V.lexingErrors.length>0?V.lexingErrors.map(ee=>({errorMessage:ee.additionalInfo?(0,R.localize)(9,null,ee.additionalInfo):(0,R.localize)(10,null),offset:ee.offset,length:ee.lexeme.length})):V.parsingErrors.length>0?V.parsingErrors.map(ee=>({errorMessage:ee.additionalInfo?`${ee.message}. ${ee.additionalInfo}`:ee.message,offset:ee.offset,length:ee.lexeme.length})):[]))}e.$Ki=r;function i(ke,V){const Q=ke?ke.substituteConstants():void 0,ee=V?V.substituteConstants():void 0;return!Q&&!ee?!0:!Q||!ee?!1:Q.equals(ee)}e.$Li=i;function o(ke,V){return ke.cmp(V)}class y{constructor(){this.type=0}cmp(V){return this.type-V.type}equals(V){return V.type===this.type}substituteConstants(){return this}evaluate(V){return!1}serialize(){return"false"}keys(){return[]}map(V){return this}negate(){return g.INSTANCE}}e.$Mi=y,y.INSTANCE=new y;class g{constructor(){this.type=1}cmp(V){return this.type-V.type}equals(V){return V.type===this.type}substituteConstants(){return this}evaluate(V){return!0}serialize(){return"true"}keys(){return[]}map(V){return this}negate(){return y.INSTANCE}}e.$Ni=g,g.INSTANCE=new g;class E{static create(V,Q=null){const ee=D.get(V);return typeof ee=="boolean"?ee?g.INSTANCE:y.INSTANCE:new E(V,Q)}constructor(V,Q){this.key=V,this.c=Q,this.type=2}cmp(V){return V.type!==this.type?this.type-V.type:_(this.key,V.key)}equals(V){return V.type===this.type?this.key===V.key:!1}substituteConstants(){const V=D.get(this.key);return typeof V=="boolean"?V?g.INSTANCE:y.INSTANCE:this}evaluate(V){return!!V.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(V){return V.mapDefined(this.key)}negate(){return this.c||(this.c=M.create(this.key,this)),this.c}}e.$Oi=E;class P{static create(V,Q,ee=null){if(typeof Q=="boolean")return Q?E.create(V,ee):M.create(V,ee);const $e=D.get(V);return typeof $e=="boolean"?Q===($e?"true":"false")?g.INSTANCE:y.INSTANCE:new P(V,Q,ee)}constructor(V,Q,ee){this.c=V,this.d=Q,this.f=ee,this.type=4}cmp(V){return V.type!==this.type?this.type-V.type:de(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){const V=D.get(this.c);if(typeof V=="boolean"){const Q=V?"true":"false";return this.d===Q?g.INSTANCE:y.INSTANCE}return this}evaluate(V){return V.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(V){return V.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=b.create(this.c,this.d,this)),this.f}}e.$Pi=P;class l{static create(V,Q){return new l(V,Q)}constructor(V,Q){this.d=V,this.f=Q,this.type=10,this.c=null}cmp(V){return V.type!==this.type?this.type-V.type:de(this.d,this.f,V.d,V.f)}equals(V){return V.type===this.type?this.d===V.d&&this.f===V.f:!1}substituteConstants(){return this}evaluate(V){const Q=V.getValue(this.f),ee=V.getValue(this.d);return Array.isArray(Q)?Q.includes(ee):typeof ee=="string"&&typeof Q=="object"&&Q!==null?A.call(Q,ee):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(V){return V.mapIn(this.d,this.f)}negate(){return this.c||(this.c=$.create(this.d,this.f)),this.c}}e.$Qi=l;class ${static create(V,Q){return new $(V,Q)}constructor(V,Q){this.d=V,this.f=Q,this.type=11,this.c=l.create(V,Q)}cmp(V){return V.type!==this.type?this.type-V.type:this.c.cmp(V.c)}equals(V){return V.type===this.type?this.c.equals(V.c):!1}substituteConstants(){return this}evaluate(V){return!this.c.evaluate(V)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(V){return V.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Ri=$;class b{static create(V,Q,ee=null){if(typeof Q=="boolean")return Q?M.create(V,ee):E.create(V,ee);const $e=D.get(V);return typeof $e=="boolean"?Q===($e?"true":"false")?y.INSTANCE:g.INSTANCE:new b(V,Q,ee)}constructor(V,Q,ee){this.c=V,this.d=Q,this.f=ee,this.type=5}cmp(V){return V.type!==this.type?this.type-V.type:de(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){const V=D.get(this.c);if(typeof V=="boolean"){const Q=V?"true":"false";return this.d===Q?y.INSTANCE:g.INSTANCE}return this}evaluate(V){return V.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(V){return V.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=P.create(this.c,this.d,this)),this.f}}e.$Si=b;class M{static create(V,Q=null){const ee=D.get(V);return typeof ee=="boolean"?ee?y.INSTANCE:g.INSTANCE:new M(V,Q)}constructor(V,Q){this.c=V,this.d=Q,this.type=3}cmp(V){return V.type!==this.type?this.type-V.type:_(this.c,V.c)}equals(V){return V.type===this.type?this.c===V.c:!1}substituteConstants(){const V=D.get(this.c);return typeof V=="boolean"?V?y.INSTANCE:g.INSTANCE:this}evaluate(V){return!V.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(V){return V.mapNot(this.c)}negate(){return this.d||(this.d=E.create(this.c,this)),this.d}}e.$Ti=M;function U(ke,V){if(typeof ke=="string"){const Q=parseFloat(ke);isNaN(Q)||(ke=Q)}return typeof ke=="string"||typeof ke=="number"?V(ke):y.INSTANCE}class F{static create(V,Q,ee=null){return U(Q,$e=>new F(V,$e,ee))}constructor(V,Q,ee){this.c=V,this.d=Q,this.f=ee,this.type=12}cmp(V){return V.type!==this.type?this.type-V.type:de(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){return this}evaluate(V){return typeof this.d=="string"?!1:parseFloat(V.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(V){return V.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=L.create(this.c,this.d,this)),this.f}}e.$Ui=F;class q{static create(V,Q,ee=null){return U(Q,$e=>new q(V,$e,ee))}constructor(V,Q,ee){this.c=V,this.d=Q,this.f=ee,this.type=13}cmp(V){return V.type!==this.type?this.type-V.type:de(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){return this}evaluate(V){return typeof this.d=="string"?!1:parseFloat(V.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(V){return V.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=W.create(this.c,this.d,this)),this.f}}e.$Vi=q;class W{static create(V,Q,ee=null){return U(Q,$e=>new W(V,$e,ee))}constructor(V,Q,ee){this.c=V,this.d=Q,this.f=ee,this.type=14}cmp(V){return V.type!==this.type?this.type-V.type:de(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){return this}evaluate(V){return typeof this.d=="string"?!1:parseFloat(V.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(V){return V.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=q.create(this.c,this.d,this)),this.f}}e.$Wi=W;class L{static create(V,Q,ee=null){return U(Q,$e=>new L(V,$e,ee))}constructor(V,Q,ee){this.c=V,this.d=Q,this.f=ee,this.type=15}cmp(V){return V.type!==this.type?this.type-V.type:de(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){return this}evaluate(V){return typeof this.d=="string"?!1:parseFloat(V.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(V){return V.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=F.create(this.c,this.d,this)),this.f}}e.$Xi=L;class z{static create(V,Q){return new z(V,Q)}constructor(V,Q){this.d=V,this.f=Q,this.type=7,this.c=null}cmp(V){if(V.type!==this.type)return this.type-V.type;if(this.d<V.d)return-1;if(this.d>V.d)return 1;const Q=this.f?this.f.source:"",ee=V.f?V.f.source:"";return Q<ee?-1:Q>ee?1:0}equals(V){if(V.type===this.type){const Q=this.f?this.f.source:"",ee=V.f?V.f.source:"";return this.d===V.d&&Q===ee}return!1}substituteConstants(){return this}evaluate(V){const Q=V.getValue(this.d);return this.f?this.f.test(Q):!1}serialize(){const V=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${V}`}keys(){return[this.d]}map(V){return V.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=K.create(this)),this.c}}e.$Yi=z;class K{static create(V){return new K(V)}constructor(V){this.c=V,this.type=8}cmp(V){return V.type!==this.type?this.type-V.type:this.c.cmp(V.c)}equals(V){return V.type===this.type?this.c.equals(V.c):!1}substituteConstants(){return this}evaluate(V){return!this.c.evaluate(V)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(V){return new K(this.c.map(V))}negate(){return this.c}}e.$Zi=K;function B(ke){let V=null;for(let Q=0,ee=ke.length;Q<ee;Q++){const $e=ke[Q].substituteConstants();if(ke[Q]!==$e&&V===null){V=[];for(let he=0;he<Q;he++)V[he]=ke[he]}V!==null&&(V[Q]=$e)}return V===null?ke:V}class me{static create(V,Q,ee){return me.d(V,Q,ee)}constructor(V,Q){this.expr=V,this.c=Q,this.type=6}cmp(V){if(V.type!==this.type)return this.type-V.type;if(this.expr.length<V.expr.length)return-1;if(this.expr.length>V.expr.length)return 1;for(let Q=0,ee=this.expr.length;Q<ee;Q++){const $e=o(this.expr[Q],V.expr[Q]);if($e!==0)return $e}return 0}equals(V){if(V.type===this.type){if(this.expr.length!==V.expr.length)return!1;for(let Q=0,ee=this.expr.length;Q<ee;Q++)if(!this.expr[Q].equals(V.expr[Q]))return!1;return!0}return!1}substituteConstants(){const V=B(this.expr);return V===this.expr?this:me.create(V,this.c,!1)}evaluate(V){for(let Q=0,ee=this.expr.length;Q<ee;Q++)if(!this.expr[Q].evaluate(V))return!1;return!0}static d(V,Q,ee){const $e=[];let he=!1;for(const fe of V)if(fe){if(fe.type===1){he=!0;continue}if(fe.type===0)return y.INSTANCE;if(fe.type===6){$e.push(...fe.expr);continue}$e.push(fe)}if($e.length===0&&he)return g.INSTANCE;if($e.length!==0){if($e.length===1)return $e[0];$e.sort(o);for(let fe=1;fe<$e.length;fe++)$e[fe-1].equals($e[fe])&&($e.splice(fe,1),fe--);if($e.length===1)return $e[0];for(;$e.length>1;){const fe=$e[$e.length-1];if(fe.type!==9)break;$e.pop();const Ee=$e.pop(),re=$e.length===0,le=ye.create(fe.expr.map(oe=>me.create([oe,Ee],null,ee)),null,re);le&&($e.push(le),$e.sort(o))}if($e.length===1)return $e[0];if(ee){for(let fe=0;fe<$e.length;fe++)for(let Ee=fe+1;Ee<$e.length;Ee++)if($e[fe].negate().equals($e[Ee]))return y.INSTANCE;if($e.length===1)return $e[0]}return new me($e,Q)}}serialize(){return this.expr.map(V=>V.serialize()).join(" && ")}keys(){const V=[];for(const Q of this.expr)V.push(...Q.keys());return V}map(V){return new me(this.expr.map(Q=>Q.map(V)),null)}negate(){if(!this.c){const V=[];for(const Q of this.expr)V.push(Q.negate());this.c=ye.create(V,this,!0)}return this.c}}e.$1i=me;class ye{static create(V,Q,ee){return ye.d(V,Q,ee)}constructor(V,Q){this.expr=V,this.c=Q,this.type=9}cmp(V){if(V.type!==this.type)return this.type-V.type;if(this.expr.length<V.expr.length)return-1;if(this.expr.length>V.expr.length)return 1;for(let Q=0,ee=this.expr.length;Q<ee;Q++){const $e=o(this.expr[Q],V.expr[Q]);if($e!==0)return $e}return 0}equals(V){if(V.type===this.type){if(this.expr.length!==V.expr.length)return!1;for(let Q=0,ee=this.expr.length;Q<ee;Q++)if(!this.expr[Q].equals(V.expr[Q]))return!1;return!0}return!1}substituteConstants(){const V=B(this.expr);return V===this.expr?this:ye.create(V,this.c,!1)}evaluate(V){for(let Q=0,ee=this.expr.length;Q<ee;Q++)if(this.expr[Q].evaluate(V))return!0;return!1}static d(V,Q,ee){let $e=[],he=!1;if(V){for(let fe=0,Ee=V.length;fe<Ee;fe++){const re=V[fe];if(re){if(re.type===0){he=!0;continue}if(re.type===1)return g.INSTANCE;if(re.type===9){$e=$e.concat(re.expr);continue}$e.push(re)}}if($e.length===0&&he)return y.INSTANCE;$e.sort(o)}if($e.length!==0){if($e.length===1)return $e[0];for(let fe=1;fe<$e.length;fe++)$e[fe-1].equals($e[fe])&&($e.splice(fe,1),fe--);if($e.length===1)return $e[0];if(ee){for(let fe=0;fe<$e.length;fe++)for(let Ee=fe+1;Ee<$e.length;Ee++)if($e[fe].negate().equals($e[Ee]))return g.INSTANCE;if($e.length===1)return $e[0]}return new ye($e,Q)}}serialize(){return this.expr.map(V=>V.serialize()).join(" || ")}keys(){const V=[];for(const Q of this.expr)V.push(...Q.keys());return V}map(V){return new ye(this.expr.map(Q=>Q.map(V)),null)}negate(){if(!this.c){const V=[];for(const Q of this.expr)V.push(Q.negate());for(;V.length>1;){const Q=V.shift(),ee=V.shift(),$e=[];for(const he of ve(Q))for(const fe of ve(ee))$e.push(me.create([he,fe],null,!1));V.unshift(ye.create($e,null,!1))}this.c=ye.create(V,this,!0)}return this.c}}e.$2i=ye;class Ie extends E{static all(){return Ie.d.values()}constructor(V,Q,ee){super(V,null),this.f=Q,typeof ee=="object"?Ie.d.push({...ee,key:V}):ee!==!0&&Ie.d.push({key:V,description:ee,type:Q!=null?typeof Q:void 0})}bindTo(V){return V.createKey(this.key,this.f)}getValue(V){return V.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(V){return P.create(this.key,V)}notEqualsTo(V){return b.create(this.key,V)}}e.$3i=Ie,Ie.d=[],e.$4i=(0,O.$Lh)("contextKeyService");function _(ke,V){return ke<V?-1:ke>V?1:0}function de(ke,V,Q,ee){return ke<Q?-1:ke>Q?1:V<ee?-1:V>ee?1:0}function De(ke,V){if(ke.type===0||V.type===1)return!0;if(ke.type===9)return V.type===9?ue(ke.expr,V.expr):!1;if(V.type===9){for(const Q of V.expr)if(De(ke,Q))return!0;return!1}if(ke.type===6){if(V.type===6)return ue(V.expr,ke.expr);for(const Q of ke.expr)if(De(Q,V))return!0;return!1}return ke.equals(V)}e.$5i=De;function ue(ke,V){let Q=0,ee=0;for(;Q<ke.length&&ee<V.length;){const $e=ke[Q].cmp(V[ee]);if($e<0)return!1;$e===0&&Q++,ee++}return Q===ke.length}function ve(ke){return ke.type===9?ke.expr:[ke]}}),define(Ae[171],Re([1,0,4]),function(ie,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Th=e.$Sh=void 0,e.$Sh=(0,h.$Lh)("environmentService"),e.$Th=(0,h.$Mh)(e.$Sh)}),define(Ae[92],Re([1,0,140,4]),function(ie,e,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$2n=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$1n=e.$Zn=e.$Yn=e.$Xn=e.$Wn=e.$Vn=e.$Un=e.$Tn=e.$Sn=e.$Rn=e.$Qn=e.$Pn=e.$On=void 0,e.$On="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Pn=new RegExp(e.$On),e.$Qn="__web_extension",e.$Rn="skipWalkthrough",e.$Sn="extensionsSync",e.$Tn="dependecyOrPackExtensionInstall";function I(c){switch(c){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$Un=I;function O(c){switch(c){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$Vn=O;function R(c,v){switch(c){case 3:return v==="x64"?"win32-x64":v==="ia32"?"win32-ia32":v==="arm64"?"win32-arm64":"unknown";case 2:return v==="x64"?"linux-x64":v==="arm64"?"linux-arm64":v==="arm"?"linux-armhf":"unknown";case"alpine":return v==="x64"?"alpine-x64":v==="arm64"?"alpine-arm64":"unknown";case 1:return v==="x64"?"darwin-x64":v==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$Wn=R;function u(c,v){return v==="web"&&!c.includes("web")}e.$Xn=u;function D(c,v,S){return u(v,S)?!1:c==="undefined"||c==="universal"?!0:c==="unknown"?!1:c===S?!0:d(S).includes(c)}e.$Yn=D;function d(c){switch(c){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.$Zn=d;function A(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(!c.uuid||typeof c.uuid=="string")}e.$1n=A;var k;(function(c){c[c.NoneOrRelevance=0]="NoneOrRelevance",c[c.LastUpdatedDate=1]="LastUpdatedDate",c[c.Title=2]="Title",c[c.PublisherName=3]="PublisherName",c[c.InstallCount=4]="InstallCount",c[c.PublishedDate=10]="PublishedDate",c[c.AverageRating=6]="AverageRating",c[c.WeightedRating=12]="WeightedRating"})(k||(e.SortBy=k={}));var a;(function(c){c[c.Default=0]="Default",c[c.Ascending=1]="Ascending",c[c.Descending=2]="Descending"})(a||(e.SortOrder=a={}));var w;(function(c){c.Install="install",c.Uninstall="uninstall"})(w||(e.StatisticType=w={}));var m;(function(c){c[c.None=1]="None",c[c.Install=2]="Install",c[c.Update=3]="Update",c[c.Migrate=4]="Migrate"})(m||(e.InstallOperation=m={})),e.$2n=(0,C.$Lh)("extensionGalleryService");var f;(function(c){c.Unsupported="Unsupported",c.Deprecated="Deprecated",c.Malicious="Malicious",c.Incompatible="Incompatible",c.IncompatibleTargetPlatform="IncompatibleTargetPlatform",c.ReleaseVersionNotFound="ReleaseVersionNotFound",c.Invalid="Invalid",c.Download="Download",c.Extract="Extract",c.Delete="Delete",c.Rename="Rename",c.CorruptZip="CorruptZip",c.IncompleteZip="IncompleteZip",c.Signature="Signature",c.Internal="Internal"})(f||(e.ExtensionManagementErrorCode=f={}));var t;(function(c){c.UnknownError="UnknownError",c.PackageIsInvalidZip="PackageIsInvalidZip",c.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(t||(e.ExtensionSignaturetErrorCode=t={}));class s extends Error{constructor(v,S){super(v),this.code=S,this.name=S}}e.$3n=s,e.$4n=(0,C.$Lh)("extensionManagementService"),e.$5n="extensionsIdentifiers/disabled",e.$6n="extensionsIdentifiers/enabled",e.$7n=(0,C.$Lh)("IGlobalExtensionEnablementService"),e.$8n=(0,C.$Lh)("IExtensionTipsService"),e.$9n=(0,h.localize)(0,null),e.$0n={value:e.$9n,original:"Extensions"},e.$$n={value:(0,h.localize)(1,null),original:"Preferences"}}),define(Ae[38],Re([1,0,48,19,15,16,2,142,4,22,13]),function(ie,e,h,C,I,O,R,u,D,d,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ck=e.$Bk=e.$Ak=e.$zk=e.$yk=e.FileKind=e.$xk=e.$wk=e.$vk=e.$uk=e.$tk=e.$sk=e.$rk=e.FileOperationResult=e.$qk=e.$pk=e.$ok=e.$nk=e.$mk=e.FileChangeType=e.$lk=e.FileOperation=e.$kk=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.FileSystemProviderErrorCode=e.$ek=e.$dk=e.$ck=e.$bk=e.$ak=e.$_j=e.$$j=e.$0j=e.$9j=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.$8j=e.$7j=void 0,e.$7j=(0,D.$Lh)("fileService");function k(_){return _.create===!0}e.$8j=k;var a;(function(_){_[_.Unknown=0]="Unknown",_[_.File=1]="File",_[_.Directory=2]="Directory",_[_.SymbolicLink=64]="SymbolicLink"})(a||(e.FileType=a={}));var w;(function(_){_[_.Readonly=1]="Readonly",_[_.Locked=2]="Locked"})(w||(e.FilePermission=w={}));var m;(function(_){_[_.None=0]="None",_[_.FileReadWrite=2]="FileReadWrite",_[_.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",_[_.FileReadStream=16]="FileReadStream",_[_.FileFolderCopy=8]="FileFolderCopy",_[_.PathCaseSensitive=1024]="PathCaseSensitive",_[_.Readonly=2048]="Readonly",_[_.Trash=4096]="Trash",_[_.FileWriteUnlock=8192]="FileWriteUnlock",_[_.FileAtomicRead=16384]="FileAtomicRead",_[_.FileAtomicWrite=32768]="FileAtomicWrite",_[_.FileAtomicDelete=65536]="FileAtomicDelete",_[_.FileClone=131072]="FileClone"})(m||(e.FileSystemProviderCapabilities=m={}));function f(_){return!!(_.capabilities&2)}e.$9j=f;function t(_){return!!(_.capabilities&8)}e.$0j=t;function s(_){return!!(_.capabilities&131072)}e.$$j=s;function c(_){return!!(_.capabilities&4)}e.$_j=c;function v(_){return!!(_.capabilities&16)}e.$ak=v;function S(_){return f(_)?!!(_.capabilities&16384):!1}e.$bk=S;function p(_){return f(_)?!!(_.capabilities&32768):!1}e.$ck=p;function n(_){return!!(_.capabilities&65536)}e.$dk=n;function r(_){return!!(_.capabilities&2048)}e.$ek=r;var i;(function(_){_.FileExists="EntryExists",_.FileNotFound="EntryNotFound",_.FileNotADirectory="EntryNotADirectory",_.FileIsADirectory="EntryIsADirectory",_.FileExceedsStorageQuota="EntryExceedsStorageQuota",_.FileTooLarge="EntryTooLarge",_.FileWriteLocked="EntryWriteLocked",_.NoPermissions="NoPermissions",_.Unavailable="Unavailable",_.Unknown="Unknown"})(i||(e.FileSystemProviderErrorCode=i={}));class o extends Error{static create(de,De){const ue=new o(de.toString(),De);return E(ue,De),ue}constructor(de,De){super(de),this.code=De}}e.$fk=o;function y(_,de){return o.create(_,de)}e.$gk=y;function g(_){return _||y((0,u.localize)(0,null),i.Unknown)}e.$hk=g;function E(_,de){return _.name=de?`${de} (FileSystemError)`:"FileSystemError",_}e.$ik=E;function P(_){if(!_)return i.Unknown;if(_ instanceof o)return _.code;const de=/^(.+) \(FileSystemError\)$/.exec(_.name);if(!de)return i.Unknown;switch(de[1]){case i.FileExists:return i.FileExists;case i.FileIsADirectory:return i.FileIsADirectory;case i.FileNotADirectory:return i.FileNotADirectory;case i.FileNotFound:return i.FileNotFound;case i.FileTooLarge:return i.FileTooLarge;case i.FileWriteLocked:return i.FileWriteLocked;case i.NoPermissions:return i.NoPermissions;case i.Unavailable:return i.Unavailable}return i.Unknown}e.$jk=P;function l(_){if(_ instanceof q)return _.fileOperationResult;switch(P(_)){case i.FileNotFound:return 1;case i.FileIsADirectory:return 0;case i.FileNotADirectory:return 9;case i.FileWriteLocked:return 5;case i.NoPermissions:return 6;case i.FileExists:return 4;case i.FileTooLarge:return 7;default:return 10}}e.$kk=l;var $;(function(_){_[_.CREATE=0]="CREATE",_[_.DELETE=1]="DELETE",_[_.MOVE=2]="MOVE",_[_.COPY=3]="COPY",_[_.WRITE=4]="WRITE"})($||(e.FileOperation=$={}));class b{constructor(de,De,ue){this.resource=de,this.operation=De,this.target=ue}isOperation(de){return this.operation===de}}e.$lk=b;var M;(function(_){_[_.UPDATED=0]="UPDATED",_[_.ADDED=1]="ADDED",_[_.DELETED=2]="DELETED"})(M||(e.FileChangeType=M={}));class U{constructor(de,De){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const ue=new Map;for(const ve of de){const ke=ue.get(ve.type);switch(ke?ke.push([ve.resource,ve]):ue.set(ve.type,[[ve.resource,ve]]),ve.type){case 1:this.rawAdded.push(ve.resource);break;case 0:this.rawUpdated.push(ve.resource);break;case 2:this.rawDeleted.push(ve.resource);break}}for(const[ve,ke]of ue)switch(ve){case 1:this.a=h.$Rh.forUris(()=>De),this.a.fill(ke);break;case 0:this.b=h.$Rh.forUris(()=>De),this.b.fill(ke);break;case 2:this.c=h.$Rh.forUris(()=>De),this.c.fill(ke);break}}contains(de,...De){return this.d(de,{includeChildren:!1},...De)}affects(de,...De){return this.d(de,{includeChildren:!0},...De)}d(de,De,...ue){if(!de)return!1;const ve=ue.length>0;return!!((!ve||ue.includes(1))&&(this.a?.get(de)||De.includeChildren&&this.a?.findSuperstr(de))||(!ve||ue.includes(0))&&(this.b?.get(de)||De.includeChildren&&this.b?.findSuperstr(de))||(!ve||ue.includes(2))&&(this.c?.findSubstr(de)||De.includeChildren&&this.c?.findSuperstr(de)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.$mk=U;function F(_,de,De){return!_||!de||_===de||de.length>_.length?!1:(de.charAt(de.length-1)!==C.sep&&(de+=C.sep),De?(0,I.$1e)(_,de):_.indexOf(de)===0)}e.$nk=F;class q extends Error{constructor(de,De,ue){super(de),this.fileOperationResult=De,this.options=ue}}e.$ok=q;class W extends q{constructor(de,De,ue,ve){super(de,De,ve),this.fileOperationResult=De,this.size=ue}}e.$pk=W;class L extends q{constructor(de,De,ue){super(de,2,ue),this.stat=De}}e.$qk=L;var z;(function(_){_[_.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",_[_.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",_[_.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",_[_.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",_[_.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",_[_.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",_[_.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",_[_.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",_[_.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",_[_.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",_[_.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(z||(e.FileOperationResult=z={})),e.$rk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$sk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$tk="files.associations",e.$uk="files.exclude",e.$vk="files.readonlyInclude",e.$wk="files.readonlyExclude",e.$xk="files.readonlyFromPermissions";var K;(function(_){_[_.FILE=0]="FILE",_[_.FOLDER=1]="FOLDER",_[_.ROOT_FOLDER=2]="ROOT_FOLDER"})(K||(e.FileKind=K={})),e.$yk="";function B(_){if(!(typeof _.size!="number"||typeof _.mtime!="number"))return _.mtime.toString(29)+_.size.toString(31)}e.$zk=B;async function me(_,de){if(!de.hasProvider(R.URI.from({scheme:_.scheme})))return new Promise(De=>{const ue=de.onDidChangeFileSystemProviderRegistrations(ve=>{ve.scheme===_.scheme&&ve.added&&(ue.dispose(),De())})})}e.$Ak=me;class ye{static formatSize(de){return(0,O.$Af)(de)||(de=0),de<ye.KB?(0,u.localize)(1,null,de.toFixed(0)):de<ye.MB?(0,u.localize)(2,null,(de/ye.KB).toFixed(2)):de<ye.GB?(0,u.localize)(3,null,(de/ye.MB).toFixed(2)):de<ye.TB?(0,u.localize)(4,null,(de/ye.GB).toFixed(2)):(0,u.localize)(5,null,(de/ye.TB).toFixed(2))}}e.$Bk=ye,ye.KB=1024,ye.MB=ye.KB*ye.KB,ye.GB=ye.MB*ye.KB,ye.TB=ye.GB*ye.KB;function Ie(_){const de=typeof _=="string"||_?.scheme===A.Schemas.vscodeRemote;return typeof _!="string"&&_?.scheme===A.Schemas.file?1024*ye.MB:de?10*ye.MB:d.$j?50*ye.MB:1024*ye.MB}e.$Ck=Ie}),define(Ae[72],Re([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jh=void 0;class h{constructor(...I){this.a=new Map;for(const[O,R]of I)this.set(O,R)}set(I,O){const R=this.a.get(I);return this.a.set(I,O),R}has(I){return this.a.has(I)}get(I){return this.a.get(I)}}e.$Jh=h}),define(Ae[172],Re([1,0,12,9,6,70,170,4,72,173]),function(ie,e,h,C,I,O,R,u,D,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9p=e.$8p=void 0;const A=!1;class k extends Error{constructor(t){super("cyclic dependency between services"),this.message=t.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${t.toString()}`}}class a{constructor(t=new D.$Jh,s=!1,c,v=A){this.f=t,this.g=s,this.h=c,this.i=v,this.o=new Set,this.f.set(u.$Kh,this),this._globalGraph=v?c?._globalGraph??new R.$7p(S=>S):void 0}createChild(t){return new a(t,this.g,this,this.i)}invokeFunction(t,...s){const c=m.traceInvocation(this.i,t);let v=!1;try{return t({get:p=>{if(v)throw(0,C.$6)("service accessor is only valid during the invocation of its target method");const n=this.m(p,c);if(!n)throw new Error(`[invokeFunction] unknown service '${p}'`);return n}},...s)}finally{v=!0,c.stop()}}createInstance(t,...s){let c,v;return t instanceof O.$Ih?(c=m.traceCreation(this.i,t.ctor),v=this.j(t.ctor,t.staticArguments.concat(s),c)):(c=m.traceCreation(this.i,t),v=this.j(t,s,c)),c.stop(),v}j(t,s=[],c){const v=u._util.getServiceDependencies(t).sort((n,r)=>n.index-r.index),S=[];for(const n of v){const r=this.m(n.id,c);r||this.u(`[createInstance] ${t.name} depends on UNKNOWN service ${n.id}.`,!1),S.push(r)}const p=v.length>0?v[0].index:s.length;if(s.length!==p){console.trace(`[createInstance] First service dependency of ${t.name} at position ${p+1} conflicts with ${s.length} static arguments`);const n=p-s.length;n>0?s=s.concat(new Array(n)):s=s.slice(0,p)}return Reflect.construct(t,s.concat(S))}k(t,s){if(this.f.get(t)instanceof O.$Ih)this.f.set(t,s);else if(this.h)this.h.k(t,s);else throw new Error("illegalState - setting UNKNOWN service instance")}l(t){const s=this.f.get(t);return!s&&this.h?this.h.l(t):s}m(t,s){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(t));const c=this.l(t);return c instanceof O.$Ih?this.q(t,c,s.branch(t,!0)):(s.branch(t,!1),c)}q(t,s,c){if(this.o.has(t))throw new Error(`illegal state - RECURSIVELY instantiating service '${t}'`);this.o.add(t);try{return this.r(t,s,c)}finally{this.o.delete(t)}}r(t,s,c){const v=new R.$7p(n=>n.id.toString());let S=0;const p=[{id:t,desc:s,_trace:c}];for(;p.length;){const n=p.pop();if(v.lookupOrInsertNode(n),S++>1e3)throw new k(v);for(const r of u._util.getServiceDependencies(n.desc.ctor)){const i=this.l(r.id);if(i||this.u(`[createInstance] ${t} depends on ${r.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(n.id),String(r.id)),i instanceof O.$Ih){const o={id:r.id,desc:i,_trace:n._trace.branch(r.id,!0)};v.insertEdge(n,o),p.push(o)}}}for(;;){const n=v.roots();if(n.length===0){if(!v.isEmpty())throw new k(v);break}for(const{data:r}of n){if(this.l(r.id)instanceof O.$Ih){const o=this.s(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this.k(r.id,o)}v.removeNode(r)}}return this.l(t)}s(t,s,c=[],v,S){if(this.f.get(t)instanceof O.$Ih)return this.t(t,s,c,v,S);if(this.h)return this.h.s(t,s,c,v,S);throw new Error(`illegalState - creating UNKNOWN service instance ${s.name}`)}t(t,s,c=[],v,S){if(v){const p=new a(void 0,this.g,this,this.i);p.c=String(t);const n=new Map,r=new h.$8g(()=>{const i=p.j(s,c,S);for(const[o,y]of n){const g=i[o];if(typeof g=="function")for(const E of y)g.apply(i,E)}return n.clear(),i});return new Proxy(Object.create(null),{get(i,o){if(!r.isInitialized&&typeof o=="string"&&(o.startsWith("onDid")||o.startsWith("onWill"))){let E=n.get(o);return E||(E=new d.$Zc,n.set(o,E)),(l,$,b)=>{const M=E.push([l,$,b]);return(0,I.$Oc)(M)}}if(o in i)return i[o];const y=r.value;let g=y[o];return typeof g!="function"||(g=g.bind(y),i[o]=g),g},set(i,o,y){return r.value[o]=y,!0},getPrototypeOf(i){return s.prototype}})}else return this.j(s,c,S)}u(t,s){if(s&&console.warn(t),this.g)throw new Error(t)}}e.$8p=a;var w;(function(f){f[f.None=0]="None",f[f.Creation=1]="Creation",f[f.Invocation=2]="Invocation",f[f.Branch=3]="Branch"})(w||(w={}));class m{static traceInvocation(t,s){return t?new m(2,s.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):m.c}static traceCreation(t,s){return t?new m(1,s.name):m.c}constructor(t,s){this.type=t,this.name=s,this.g=Date.now(),this.h=[]}branch(t,s){const c=new m(3,t.toString());return this.h.push([t,s,c]),c}stop(){const t=Date.now()-this.g;m.f+=t;let s=!1;function c(S,p){const n=[],r=new Array(S+1).join("	");for(const[i,o,y]of p.h)if(o&&y){s=!0,n.push(`${r}CREATES -> ${i}`);const g=c(S+1,y);g&&n.push(g)}else n.push(`${r}uses -> ${i}`);return n.join(`
`)}const v=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${c(1,this)}`,`DONE, took ${t.toFixed(2)}ms (grand total ${m.f.toFixed(2)}ms)`];(t>2||s)&&m.all.add(v.join(`
`))}}e.$9p=m,m.all=new Set,m.c=new class extends m{constructor(){super(0,null)}stop(){}branch(){return this}},m.f=0}),define(Ae[14],Re([1,0,42,5,93,6,28,22,23,16,2,32,4]),function(ie,e,h,C,I,O,R,u,D,d,A,k,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=e.$$i=e.log=e.$9i=e.LogLevel=e.$8i=e.$7i=e.$6i=void 0,e.$6i=(0,a.$Lh)("logService"),e.$7i=(0,a.$Lh)("loggerService");function w(){return new Date().toISOString()}function m(l){return(0,d.$Af)(l)}e.$8i=m;var f;(function(l){l[l.Off=0]="Off",l[l.Trace=1]="Trace",l[l.Debug=2]="Debug",l[l.Info=3]="Info",l[l.Warning=4]="Warning",l[l.Error=5]="Error"})(f||(e.LogLevel=f={})),e.$9i=f.Info;function t(l,$,b){switch($){case f.Trace:l.trace(b);break;case f.Debug:l.debug(b);break;case f.Info:l.info(b);break;case f.Warning:l.warn(b);break;case f.Error:l.error(b);break;case f.Off:break;default:throw new Error(`Invalid log level ${$}`)}}e.log=t;function s(l,$=!1){let b="";for(let M=0;M<l.length;M++){let U=l[M];if(U instanceof Error&&(U=(0,h.$wi)(U,$)),typeof U=="object")try{U=JSON.stringify(U)}catch{}b+=(M>0?" ":"")+U}return b}class c extends O.$Qc{constructor(){super(...arguments),this.b=e.$9i,this.c=this.B(new C.$Ld),this.onDidChangeLogLevel=this.c.event}setLevel($){this.b!==$&&(this.b=$,this.c.fire(this.b))}getLevel(){return this.b}f($){return this.b!==f.Off&&this.b<=$}}e.$$i=c;class v extends c{constructor($){super(),this.h=$}f($){return this.h||super.f($)}trace($,...b){this.f(f.Trace)&&this.g(f.Trace,s([$,...b],!0))}debug($,...b){this.f(f.Debug)&&this.g(f.Debug,s([$,...b]))}info($,...b){this.f(f.Info)&&this.g(f.Info,s([$,...b]))}warn($,...b){this.f(f.Warning)&&this.g(f.Warning,s([$,...b]))}error($,...b){if(this.f(f.Error))if($ instanceof Error){const M=Array.prototype.slice.call(arguments);M[0]=$.stack,this.g(f.Error,s(M))}else this.g(f.Error,s([$,...b]))}flush(){}}e.$_i=v;class S extends c{constructor($=e.$9i){super(),this.setLevel($),this.g=!u.$d}trace($,...b){this.f(f.Trace)&&(this.g?console.log(`\x1B[90m[main ${w()}]\x1B[0m`,$,...b):console.log(`[main ${w()}]`,$,...b))}debug($,...b){this.f(f.Debug)&&(this.g?console.log(`\x1B[90m[main ${w()}]\x1B[0m`,$,...b):console.log(`[main ${w()}]`,$,...b))}info($,...b){this.f(f.Info)&&(this.g?console.log(`\x1B[90m[main ${w()}]\x1B[0m`,$,...b):console.log(`[main ${w()}]`,$,...b))}warn($,...b){this.f(f.Warning)&&(this.g?console.warn(`\x1B[93m[main ${w()}]\x1B[0m`,$,...b):console.warn(`[main ${w()}]`,$,...b))}error($,...b){this.f(f.Error)&&(this.g?console.error(`\x1B[91m[main ${w()}]\x1B[0m`,$,...b):console.error(`[main ${w()}]`,$,...b))}dispose(){}flush(){}}e.$aj=S;class p extends c{constructor($=e.$9i,b=!0){super(),this.g=b,this.setLevel($)}trace($,...b){this.f(f.Trace)&&(this.g?console.log("%cTRACE","color: #888",$,...b):console.log($,...b))}debug($,...b){this.f(f.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",$,...b):console.log($,...b))}info($,...b){this.f(f.Info)&&(this.g?console.log("%c INFO","color: #33f",$,...b):console.log($,...b))}warn($,...b){this.f(f.Warning)&&(this.g?console.log("%c WARN","color: #993",$,...b):console.log($,...b))}error($,...b){this.f(f.Error)&&(this.g?console.log("%c  ERR","color: #f33",$,...b):console.error($,...b))}dispose(){}flush(){}}e.$bj=p;class n extends c{constructor($,b=e.$9i){super(),this.g=$,this.setLevel(b)}trace($,...b){this.f(f.Trace)&&this.g.log(f.Trace,[this.h($),...b])}debug($,...b){this.f(f.Debug)&&this.g.log(f.Debug,[this.h($),...b])}info($,...b){this.f(f.Info)&&this.g.log(f.Info,[this.h($),...b])}warn($,...b){this.f(f.Warning)&&this.g.log(f.Warning,[this.h($),...b])}error($,...b){this.f(f.Error)&&this.g.log(f.Error,[this.h($),...b])}h($){return typeof $=="string"?$:(0,h.$wi)($,this.f(f.Trace))}dispose(){}flush(){}}e.$cj=n;class r extends c{constructor($){super(),this.g=$,$.length&&this.setLevel($[0].getLevel())}setLevel($){for(const b of this.g)b.setLevel($);super.setLevel($)}trace($,...b){for(const M of this.g)M.trace($,...b)}debug($,...b){for(const M of this.g)M.debug($,...b)}info($,...b){for(const M of this.g)M.info($,...b)}warn($,...b){for(const M of this.g)M.warn($,...b)}error($,...b){for(const M of this.g)M.error($,...b)}flush(){for(const $ of this.g)$.flush()}dispose(){for(const $ of this.g)$.dispose()}}e.$dj=r;class i extends O.$Qc{constructor($,b,M){if(super(),this.h=$,this.j=b,this.b=new R.$yc,this.c=this.B(new C.$Ld),this.onDidChangeLoggers=this.c.event,this.f=this.B(new C.$Ld),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new C.$Ld),this.onDidChangeVisibility=this.g.event,M)for(const U of M)this.b.set(U.resource,{logger:void 0,info:U})}m($){return(0,d.$wf)($)?[...this.b.values()].find(b=>b.info.id===$):this.b.get($)}getLogger($){return this.m($)?.logger}createLogger($,b){const M=this.n($),U=(0,d.$wf)($)?$:b?.id??(0,I.$zi)(M.toString()).toString(16);let F=this.b.get(M)?.logger;const q=b?.logLevel==="always"?f.Trace:b?.logLevel;F||(F=this.s(M,q??this.getLogLevel(M)??this.h,{...b,id:U}));const W={logger:F,info:{resource:M,id:U,logLevel:q,name:b?.name,hidden:b?.hidden,extensionId:b?.extensionId,when:b?.when}};return this.registerLogger(W.info),this.b.set(M,W),F}n($){return(0,d.$wf)($)?(0,D.$sg)(this.j,`${$}.log`):$}setLogLevel($,b){if(A.URI.isUri($)){const M=$,U=b,F=this.b.get(M);F&&U!==F.info.logLevel&&(F.info.logLevel=U===this.h?void 0:U,F.logger?.setLevel(U),this.b.set(F.info.resource,F),this.f.fire([M,U]))}else{this.h=$;for(const[M,U]of this.b.entries())this.b.get(M)?.info.logLevel===void 0&&U.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility($,b){const M=this.m($);M&&b!==!M.info.hidden&&(M.info.hidden=!b,this.b.set(M.info.resource,M),this.g.fire([M.info.resource,b]))}getLogLevel($){let b;return $&&(b=this.b.get($)?.info.logLevel),b??this.h}registerLogger($){const b=this.b.get($.resource);b?b.info.hidden!==$.hidden&&this.setVisibility($.resource,!$.hidden):(this.b.set($.resource,{info:$,logger:void 0}),this.c.fire({added:[$],removed:[]}))}deregisterLogger($){const b=this.b.get($);b&&(b.logger&&b.logger.dispose(),this.b.delete($),this.c.fire({added:[],removed:[b.info]}))}*getRegisteredLoggers(){for(const $ of this.b.values())yield $.info}getRegisteredLogger($){return this.b.get($)?.info}dispose(){this.b.forEach($=>$.logger?.dispose()),this.b.clear(),super.dispose()}}e.$ej=i;class o{constructor(){this.onDidChangeLogLevel=new C.$Ld().event}setLevel($){}getLevel(){return f.Info}trace($,...b){}debug($,...b){}info($,...b){}warn($,...b){}error($,...b){}critical($,...b){}dispose(){}flush(){}}e.$fj=o;class y extends o{}e.$gj=y;function g(l){if(l.verbose)return f.Trace;if(typeof l.logLevel=="string"){const $=P(l.logLevel.toLowerCase());if($!==void 0)return $}return e.$9i}e.$hj=g;function E(l){switch(l){case f.Trace:return"trace";case f.Debug:return"debug";case f.Info:return"info";case f.Warning:return"warn";case f.Error:return"error";case f.Off:return"off"}}e.$ij=E;function P(l){switch(l){case"trace":return f.Trace;case"debug":return f.Debug;case"info":return f.Info;case"warn":return f.Warning;case"error":return f.Error;case"critical":return f.Error;case"off":return f.Off}}e.$jj=P,e.$kj=new k.$3i("logLevel",E(f.Info))}),define(Ae[174],Re([1,0,6,14]),function(ie,e,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vN=void 0;class I extends h.$Qc{constructor(R,u=[]){super(),this.a=new C.$dj([R,...u]),this.B(R.onDidChangeLogLevel(D=>this.setLevel(D)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(R){this.a.setLevel(R)}getLevel(){return this.a.getLevel()}trace(R,...u){this.a.trace(R,...u)}debug(R,...u){this.a.debug(R,...u)}info(R,...u){this.a.info(R,...u)}warn(R,...u){this.a.warn(R,...u)}error(R,...u){this.a.error(R,...u)}flush(){this.a.flush()}}e.$vN=I}),define(Ae[94],Re([1,0,29,143,4]),function(ie,e,h,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5s=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var O;(function(D){D[D.Unnecessary=1]="Unnecessary",D[D.Deprecated=2]="Deprecated"})(O||(e.MarkerTag=O={}));var R;(function(D){D[D.Hint=1]="Hint",D[D.Info=2]="Info",D[D.Warning=4]="Warning",D[D.Error=8]="Error"})(R||(e.MarkerSeverity=R={})),function(D){function d(m,f){return f-m}D.compare=d;const A=Object.create(null);A[D.Error]=(0,C.localize)(0,null),A[D.Warning]=(0,C.localize)(1,null),A[D.Info]=(0,C.localize)(2,null);function k(m){return A[m]||""}D.toString=k;function a(m){switch(m){case h.default.Error:return D.Error;case h.default.Warning:return D.Warning;case h.default.Info:return D.Info;case h.default.Ignore:return D.Hint}}D.fromSeverity=a;function w(m){switch(m){case D.Error:return h.default.Error;case D.Warning:return h.default.Warning;case D.Info:return h.default.Info;case D.Hint:return h.default.Ignore}}D.toSeverity=w}(R||(e.MarkerSeverity=R={}));var u;(function(D){const d="";function A(a){return k(a,!0)}D.makeKey=A;function k(a,w){const m=[d];return a.source?m.push(a.source.replace("\xA6","\\\xA6")):m.push(d),a.code?typeof a.code=="string"?m.push(a.code.replace("\xA6","\\\xA6")):m.push(a.code.value.replace("\xA6","\\\xA6")):m.push(d),a.severity!==void 0&&a.severity!==null?m.push(R.toString(a.severity)):m.push(d),a.message&&w?m.push(a.message.replace("\xA6","\\\xA6")):m.push(d),a.startLineNumber!==void 0&&a.startLineNumber!==null?m.push(a.startLineNumber.toString()):m.push(d),a.startColumn!==void 0&&a.startColumn!==null?m.push(a.startColumn.toString()):m.push(d),a.endLineNumber!==void 0&&a.endLineNumber!==null?m.push(a.endLineNumber.toString()):m.push(d),a.endColumn!==void 0&&a.endColumn!==null?m.push(a.endColumn.toString()):m.push(d),m.push(d),m.join("\xA6")}D.makeKeyOptionalMessage=k})(u||(e.IMarkerData=u={})),e.$5s=(0,I.$Lh)("markerService")}),define(Ae[175],Re([1,0,5,29,4]),function(ie,e,h,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uu=e.$Tu=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$Su=e.Severity=void 0,e.Severity=C.default,e.$Su=(0,I.$Lh)("notificationService");var O;(function(A){A[A.DEFAULT=0]="DEFAULT",A[A.SILENT=1]="SILENT",A[A.URGENT=2]="URGENT"})(O||(e.NotificationPriority=O={}));var R;(function(A){A[A.WORKSPACE=0]="WORKSPACE",A[A.PROFILE=1]="PROFILE",A[A.APPLICATION=2]="APPLICATION"})(R||(e.NeverShowAgainScope=R={}));var u;(function(A){A[A.OFF=0]="OFF",A[A.SILENT=1]="SILENT",A[A.ERROR=2]="ERROR"})(u||(e.NotificationsFilter=u={}));class D{constructor(){this.progress=new d,this.onDidClose=h.Event.None,this.onDidChangeVisibility=h.Event.None}updateSeverity(k){}updateMessage(k){}updateActions(k){}close(){}}e.$Tu=D;class d{infinite(){}done(){}total(k){}worked(k){}}e.$Uu=d}),define(Ae[95],Re([1,0,15,2,4]),function(ie,e,h,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5T=e.$4T=e.$3T=e.$2T=e.$1T=void 0,e.$1T=(0,I.$Lh)("openerService");function O(d,A){return C.URI.isUri(d)?(0,h.$Ze)(d.scheme,A):(0,h.$1e)(d,A+":")}e.$2T=O;function R(d,...A){return A.some(k=>O(d,k))}e.$3T=R;function u(d,A){return d.with({fragment:`${A.startLineNumber},${A.startColumn}${A.endLineNumber?`-${A.endLineNumber}${A.endColumn?`,${A.endColumn}`:""}`:""}`})}e.$4T=u;function D(d){let A;const k=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(d.fragment);return k&&(A={startLineNumber:parseInt(k[1]),startColumn:k[2]?parseInt(k[2]):1,endLineNumber:k[4]?parseInt(k[4]):void 0,endColumn:k[4]?k[5]?parseInt(k[5]):1:void 0},d=d.with({fragment:""})),{selection:A,uri:d}}e.$5T=D}),define(Ae[176],Re([1,0,4]),function(ie,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mj=e.$lj=void 0,e.$lj=(0,h.$Lh)("productService"),e.$mj="vscode://schemas/vscode-product"});var Je=this&&this.__decorate||function(ie,e,h,C){var I=arguments.length,O=I<3?e:C===null?C=Object.getOwnPropertyDescriptor(e,h):C,R;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")O=Reflect.decorate(ie,e,h,C);else for(var u=ie.length-1;u>=0;u--)(R=ie[u])&&(O=(I<3?R(O):I>3?R(e,h,O):R(e,h))||O);return I>3&&O&&Object.defineProperty(e,h,O),O},qe=this&&this.__param||function(ie,e){return function(h,C){e(h,C,ie)}};define(Ae[50],Re([1,0,12,21,6,4]),function(ie,e,h,C,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1u=e.$Zu=e.$Yu=e.$Xu=e.$Wu=e.ProgressLocation=e.$Vu=void 0,e.$Vu=(0,O.$Lh)("progressService");var R;(function(A){A[A.Explorer=1]="Explorer",A[A.Scm=3]="Scm",A[A.Extensions=5]="Extensions",A[A.Window=10]="Window",A[A.Notification=15]="Notification",A[A.Dialog=20]="Dialog"})(R||(e.ProgressLocation=R={})),e.$Wu=Object.freeze({total(){},worked(){},done(){}});class u{get value(){return this.a}constructor(k,a){this.c=k,this.report=a?.async?this.e.bind(this):this.d.bind(this)}d(k){this.a=k,this.c(this.a)}e(k){Promise.resolve(this.b).finally(()=>{this.a=k;const a=this.c(this.a);this.b=Promise.resolve(a).finally(()=>this.b=void 0)})}}e.$Xu=u,u.None=Object.freeze({report(){}});let D=class extends I.$Qc{constructor(k,a){super(),this.a=new h.$_g,a.withProgress(k,w=>(this.b=w,this.c&&w.report(this.c),this.a.p)),this.B((0,I.$Oc)(()=>this.a.complete()))}report(k){this.b?this.b.report(k):this.c=k}};e.$Yu=D,e.$Yu=D=Je([qe(1,e.$Vu)],D);class d extends I.$Qc{constructor(k){super(),this.g=k,this.a=0,this.b=this.B(new I.$Pc)}start(k){this.stop();const a=++this.a,w=new C.$Vd;return this.f=setTimeout(()=>{a===this.a&&(this.c=this.g.show(!0))},k),this.b.add((0,I.$Oc)(()=>clearTimeout(this.f))),this.b.add((0,I.$Oc)(()=>w.cancel())),this.b.add((0,I.$Oc)(()=>this.c?this.c.done():void 0)),{id:a,token:w.token,stop:()=>this.h(a),isCurrent:()=>this.a===a}}stop(){this.h(this.a)}h(k){this.a===k&&this.b.clear()}}e.$Zu=d,e.$1u=(0,O.$Lh)("editorProgressService")}),define(Ae[30],Re([1,0,51,16]),function(ie,e,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0m=void 0;class I{constructor(){this.a=new Map}add(R,u){h.ok(C.$wf(R)),h.ok(C.$yf(u)),h.ok(!this.a.has(R),"There is already an extension with this id"),this.a.set(R,u)}knows(R){return this.a.has(R)}as(R){return this.a.get(R)||null}}e.$0m=new I}),define(Ae[73],Re([1,0,5,30]),function(ie,e,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$m=void 0,e.$$m={JSONContribution:"base.contributions.json"};function I(u){return u.length>0&&u.charAt(u.length-1)==="#"?u.substring(0,u.length-1):u}class O{constructor(){this.b=new h.$Ld,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(D,d){this.a[I(D)]=d,this.b.fire(D)}notifySchemaChanged(D){this.b.fire(D)}getSchemaContributions(){return{schemas:this.a}}}const R=new O;C.$0m.add(e.$$m.JSONContribution,R)}),define(Ae[96],Re([1,0,18,5,16,137,43,73,30]),function(ie,e,h,C,I,O,R,u,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rn=e.$qn=e.$pn=e.$on=e.$nn=e.$mn=e.$ln=e.$kn=e.$jn=e.$in=e.$hn=e.$gn=e.$fn=e.$en=e.$dn=e.ConfigurationScope=e.$cn=e.EditPresentationTypes=void 0;var d;(function(p){p.Multiline="multilineText",p.Singleline="singlelineText"})(d||(e.EditPresentationTypes=d={})),e.$cn={Configuration:"base.contributions.configuration"};var A;(function(p){p[p.APPLICATION=1]="APPLICATION",p[p.MACHINE=2]="MACHINE",p[p.WINDOW=3]="WINDOW",p[p.RESOURCE=4]="RESOURCE",p[p.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",p[p.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(A||(e.ConfigurationScope=A={})),e.$dn={properties:{},patternProperties:{}},e.$en={properties:{},patternProperties:{}},e.$fn={properties:{},patternProperties:{}},e.$gn={properties:{},patternProperties:{}},e.$hn={properties:{},patternProperties:{}},e.$in={properties:{},patternProperties:{}},e.$jn="vscode://schemas/settings/resourceLanguage",e.$kn="vscode://schemas/settings/configurationDefaults";const k=D.$0m.as(u.$$m.JSONContribution);class a{constructor(){this.h=new Set,this.i=new C.$Ld,this.onDidSchemaChange=this.i.event,this.j=new C.$Ld,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:O.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},k.registerSchema(e.$jn,this.g),this.v()}registerConfiguration(n,r=!0){this.registerConfigurations([n],r)}registerConfigurations(n,r=!0){const i=new Set;this.n(n,r,i),k.registerSchema(e.$jn,this.g),this.i.fire(),this.j.fire({properties:i})}deregisterConfigurations(n){const r=new Set;this.o(n,r),k.registerSchema(e.$jn,this.g),this.i.fire(),this.j.fire({properties:r})}updateConfigurations({add:n,remove:r}){const i=new Set;this.o(r,i),this.n(n,!1,i),k.registerSchema(e.$jn,this.g),this.i.fire(),this.j.fire({properties:i})}registerDefaultConfigurations(n){const r=new Set;this.k(n,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}k(n,r){const i=[];for(const{overrides:o,source:y}of n)for(const g in o)if(r.add(g),e.$mn.test(g)){const E=this.a.get(g),P=E?.valuesSources??new Map;if(y)for(const M of Object.keys(o[g]))P.set(M,y);const l={...E?.value||{},...o[g]};this.a.set(g,{source:y,value:l,valuesSources:P});const $=(0,R.$pi)(g),b={type:"object",default:l,description:O.localize(1,null,$),$ref:e.$jn,defaultDefaultValue:l,source:I.$wf(y)?void 0:y,defaultValueSource:y};i.push(...f(g)),this.d[g]=b,this.b.properties[g]=b}else{this.a.set(g,{value:o[g],source:y});const E=this.d[g];E&&(this.w(g,E),this.r(g,E))}this.m(i)}deregisterDefaultConfigurations(n){const r=new Set;this.l(n,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}l(n,r){for(const{overrides:i,source:o}of n)for(const y in i){const g=this.a.get(y),E=I.$wf(o)?o:o?.id,P=I.$wf(g?.source)?g?.source:g?.source?.id;if(E===P)if(r.add(y),this.a.delete(y),e.$mn.test(y))delete this.d[y],delete this.b.properties[y];else{const l=this.d[y];l&&(this.w(y,l),this.r(y,l))}}this.u()}deltaConfiguration(n){let r=!1;const i=new Set;n.removedDefaults&&(this.l(n.removedDefaults,i),r=!0),n.addedDefaults&&(this.k(n.addedDefaults,i),r=!0),n.removedConfigurations&&this.o(n.removedConfigurations,i),n.addedConfigurations&&this.n(n.addedConfigurations,!1,i),this.i.fire(),this.j.fire({properties:i,defaultsOverrides:r})}notifyConfigurationSchemaUpdated(...n){this.i.fire()}registerOverrideIdentifiers(n){this.m(n),this.i.fire()}m(n){for(const r of n)this.h.add(r);this.u()}n(n,r,i){n.forEach(o=>{this.p(o,r,o.extensionInfo,o.restrictedProperties,void 0,i),this.c.push(o),this.q(o)})}o(n,r){const i=o=>{if(o.properties)for(const y in o.properties){r.add(y);const g=this.d[y];g?.policy?.name&&this.e.delete(g.policy.name),delete this.d[y],this.s(y,o.properties[y])}o.allOf?.forEach(y=>i(y))};for(const o of n){i(o);const y=this.c.indexOf(o);y!==-1&&this.c.splice(y,1)}}p(n,r=!0,i,o,y=3,g){y=I.$Ff(n.scope)?y:n.scope;const E=n.properties;if(E)for(const l in E){const $=E[l];if(r&&v(l,$)){delete E[l];continue}if($.source=i,$.defaultDefaultValue=E[l].default,this.w(l,$),e.$mn.test(l)?$.scope=void 0:($.scope=I.$Ff($.scope)?y:$.scope,$.restricted=I.$Ff($.restricted)?!!o?.includes(l):$.restricted),E[l].hasOwnProperty("included")&&!E[l].included){this.f[l]=E[l],delete E[l];continue}else this.d[l]=E[l],E[l].policy?.name&&this.e.set(E[l].policy.name,l);!E[l].deprecationMessage&&E[l].markdownDeprecationMessage&&(E[l].deprecationMessage=E[l].markdownDeprecationMessage),g.add(l)}const P=n.allOf;if(P)for(const l of P)this.p(l,r,i,o,y,g)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(n){const r=i=>{const o=i.properties;if(o)for(const g in o)this.r(g,o[g]);i.allOf?.forEach(r)};r(n)}r(n,r){switch(e.$dn.properties[n]=r,r.scope){case 1:e.$en.properties[n]=r;break;case 2:e.$fn.properties[n]=r;break;case 6:e.$gn.properties[n]=r;break;case 3:e.$hn.properties[n]=r;break;case 4:e.$in.properties[n]=r;break;case 5:e.$in.properties[n]=r,this.g.properties[n]=r;break}}s(n,r){switch(delete e.$dn.properties[n],r.scope){case 1:delete e.$en.properties[n];break;case 2:delete e.$fn.properties[n];break;case 6:delete e.$gn.properties[n];break;case 3:delete e.$hn.properties[n];break;case 4:case 5:delete e.$in.properties[n],delete this.g.properties[n];break}}u(){for(const n of this.h.values()){const r=`[${n}]`,i={type:"object",description:O.localize(2,null),errorMessage:O.localize(3,null),$ref:e.$jn};this.w(r,i),e.$dn.properties[r]=i,e.$en.properties[r]=i,e.$fn.properties[r]=i,e.$gn.properties[r]=i,e.$hn.properties[r]=i,e.$in.properties[r]=i}}v(){const n={type:"object",description:O.localize(4,null),errorMessage:O.localize(5,null),$ref:e.$jn};e.$dn.patternProperties[e.$ln]=n,e.$en.patternProperties[e.$ln]=n,e.$fn.patternProperties[e.$ln]=n,e.$gn.patternProperties[e.$ln]=n,e.$hn.patternProperties[e.$ln]=n,e.$in.patternProperties[e.$ln]=n,this.i.fire()}w(n,r){const i=this.a.get(n);let o=i?.value,y=i?.source;I.$Df(o)&&(o=r.defaultDefaultValue,y=void 0),I.$Df(o)&&(o=s(r.type)),r.default=o,r.defaultValueSource=y}}const w="\\[([^\\]]+)\\]",m=new RegExp(w,"g");e.$ln=`^(${w})+$`,e.$mn=new RegExp(e.$ln);function f(p){const n=[];if(e.$mn.test(p)){let r=m.exec(p);for(;r?.length;){const i=r[1].trim();i&&n.push(i),r=m.exec(p)}}return(0,h.$Kb)(n)}e.$nn=f;function t(p){return p.reduce((n,r)=>`${n}[${r}]`,"")}e.$on=t;function s(p){switch(Array.isArray(p)?p[0]:p){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$pn=s;const c=new a;D.$0m.add(e.$cn.Configuration,c);function v(p,n){return p.trim()?e.$mn.test(p)?O.localize(7,null,p):c.getConfigurationProperties()[p]!==void 0?O.localize(8,null,p):n.policy?.name&&c.getPolicyConfigurations().get(n.policy?.name)!==void 0?O.localize(9,null,p,n.policy?.name,c.getPolicyConfigurations().get(n.policy?.name)):null:O.localize(6,null)}e.$qn=v;function S(){const p=[],n=c.getConfigurationProperties();for(const r of Object.keys(n))p.push([r,n[r].scope]);return p.push(["launch",4]),p.push(["task",4]),p}e.$rn=S}),define(Ae[177],Re([1,0,18,5,115,6,28,24,16,2,43,96,30]),function(ie,e,h,C,I,O,R,u,D,d,A,k,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xn=e.$wn=e.$vn=e.$un=e.$tn=e.$sn=void 0;function w(r){return Object.isFrozen(r)?r:u.$Ym(r)}class m{constructor(i={},o=[],y=[],g){this.b=i,this.c=o,this.d=y,this.raw=g,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const i=this.raw.map(o=>{if(o instanceof m)return o;const y=new f("");return y.parseRaw(o),y.configurationModel});this.f=i.reduce((o,y)=>y===o?y:o.merge(y),i[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(i){return i?(0,A.$ni)(this.contents,i):this.contents}inspect(i,o){const y=this.rawConfiguration.getValue(i),g=o?this.rawConfiguration.getOverrideValue(i,o):void 0,E=o?this.rawConfiguration.override(o).getValue(i):y;return{value:y,override:g,merged:E}}getOverrideValue(i,o){const y=this.i(o);return y?i?(0,A.$ni)(y,i):y:void 0}getKeysForOverrideIdentifier(i){const o=[];for(const y of this.overrides)y.identifiers.includes(i)&&o.push(...y.keys);return h.$Kb(o)}getAllOverrideIdentifiers(){const i=[];for(const o of this.overrides)i.push(...o.identifiers);return h.$Kb(i)}override(i){let o=this.a.get(i);return o||(o=this.g(i),this.a.set(i,o)),o}merge(...i){const o=u.$Xm(this.contents),y=u.$Xm(this.overrides),g=[...this.keys],E=this.raw?.length?[...this.raw]:[this];for(const P of i)if(E.push(...P.raw?.length?P.raw:[P]),!P.isEmpty()){this.h(o,P.contents);for(const l of P.overrides){const[$]=y.filter(b=>h.$sb(b.identifiers,l.identifiers));$?(this.h($.contents,l.contents),$.keys.push(...l.keys),$.keys=h.$Kb($.keys)):y.push(u.$Xm(l))}for(const l of P.keys)g.indexOf(l)===-1&&g.push(l)}return new m(o,g,y,E.every(P=>P instanceof m)?void 0:E)}g(i){const o=this.i(i);if(!o||typeof o!="object"||!Object.keys(o).length)return this;const y={};for(const g of h.$Kb([...Object.keys(this.contents),...Object.keys(o)])){let E=this.contents[g];const P=o[g];P&&(typeof E=="object"&&typeof P=="object"?(E=u.$Xm(E),this.h(E,P)):E=P),y[g]=E}return new m(y,this.keys,this.overrides)}h(i,o){for(const y of Object.keys(o)){if(y in i&&D.$yf(i[y])&&D.$yf(o[y])){this.h(i[y],o[y]);continue}i[y]=u.$Xm(o[y])}}i(i){let o=null,y=null;const g=E=>{E&&(y?this.h(y,E):y=u.$Xm(E))};for(const E of this.overrides)E.identifiers.length===1&&E.identifiers[0]===i?o=E.contents:E.identifiers.includes(i)&&g(E.contents);return g(o),y}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(i,o){this.j(i,o,!0)}setValue(i,o){this.j(i,o,!1)}removeValue(i){const o=this.keys.indexOf(i);o!==-1&&(this.keys.splice(o,1),(0,A.$mi)(this.contents,i),k.$mn.test(i)&&this.overrides.splice(this.overrides.findIndex(y=>h.$sb(y.identifiers,(0,k.$nn)(i))),1))}j(i,o,y){(0,A.$li)(this.contents,i,o,g=>console.error(g)),y=y||this.keys.indexOf(i)===-1,y&&this.keys.push(i),k.$mn.test(i)&&this.overrides.push({identifiers:(0,k.$nn)(i),keys:Object.keys(this.contents[i]),contents:(0,A.$ki)(this.contents[i],g=>console.error(g))})}}e.$sn=m;class f{constructor(i){this.f=i,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new m}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(i,o){if(!D.$Ff(i)){const y=this.g(i);this.parseRaw(y,o)}}reparse(i){this.a&&this.parseRaw(this.a,i)}parseRaw(i,o){this.a=i;const{contents:y,keys:g,overrides:E,restricted:P,hasExcludedProperties:l}=this.h(i,o);this.b=new m(y,g,E,l?[i]:void 0),this.c=P||[]}g(i){let o={},y=null,g=[];const E=[],P=[];function l(b){Array.isArray(g)?g.push(b):y!==null&&(g[y]=b)}const $={onObjectBegin:()=>{const b={};l(b),E.push(g),g=b,y=null},onObjectProperty:b=>{y=b},onObjectEnd:()=>{g=E.pop()},onArrayBegin:()=>{const b=[];l(b),E.push(g),g=b,y=null},onArrayEnd:()=>{g=E.pop()},onLiteralValue:l,onError:(b,M,U)=>{P.push({error:b,offset:M,length:U})}};if(i)try{I.$Um(i,$),o=g[0]||{}}catch(b){console.error(`Error while parsing settings file ${this.f}: ${b}`),this.d=[b]}return o}h(i,o){const y=a.$0m.as(k.$cn.Configuration).getConfigurationProperties(),g=this.i(i,y,!0,o);i=g.raw;const E=(0,A.$ki)(i,$=>console.error(`Conflict in settings file ${this.f}: ${$}`)),P=Object.keys(i),l=this.j(i,$=>console.error(`Conflict in settings file ${this.f}: ${$}`));return{contents:E,keys:P,overrides:l,restricted:g.restricted,hasExcludedProperties:g.hasExcludedProperties}}i(i,o,y,g){let E=!1;if(!g?.scopes&&!g?.skipRestricted&&!g?.exclude?.length)return{raw:i,restricted:[],hasExcludedProperties:E};const P={},l=[];for(const $ in i)if(k.$mn.test($)&&y){const b=this.i(i[$],o,!1,g);P[$]=b.raw,E=E||b.hasExcludedProperties,l.push(...b.restricted)}else{const b=o[$],M=b?typeof b.scope<"u"?b.scope:3:void 0;b?.restricted&&l.push($),!g.exclude?.includes($)&&(g.include?.includes($)||(M===void 0||g.scopes===void 0||g.scopes.includes(M))&&!(g.skipRestricted&&b?.restricted))?P[$]=i[$]:E=!0}return{raw:P,restricted:l,hasExcludedProperties:E}}j(i,o){const y=[];for(const g of Object.keys(i))if(k.$mn.test(g)){const E={};for(const P in i[g])E[P]=i[g][P];y.push({identifiers:(0,k.$nn)(g),keys:Object.keys(E),contents:(0,A.$ki)(E,o)})}return y}}e.$tn=f;class t extends O.$Qc{constructor(i,o,y,g){super(),this.c=i,this.f=o,this.g=g,this.b=this.B(new C.$Ld),this.onDidChange=this.b.event,this.a=new f(this.c.toString()),this.B(this.g.watch(y.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(C.Event.any(C.Event.filter(this.g.onDidFilesChange,E=>E.contains(this.c)),C.Event.filter(this.g.onDidRunOperation,E=>(E.isOperation(0)||E.isOperation(3)||E.isOperation(1)||E.isOperation(4))&&y.isEqual(E.resource,i)))(()=>this.b.fire()))}async loadConfiguration(){try{const i=await this.g.readFile(this.c);return this.a.parse(i.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new m}}reparse(i){return i&&(this.f=i),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$un=t;class s{constructor(i,o,y,g,E,P,l,$,b,M,U,F,q){this.a=i,this.b=o,this.c=y,this.overrideIdentifiers=g,this.d=E,this.f=P,this.g=l,this.h=$,this.i=b,this.j=M,this.k=U,this.l=F,this.m=q}get value(){return w(this.c)}n(i,o,y){const g=i.inspect(o,y);return{get value(){return w(g.value)},get override(){return w(g.override)},get merged(){return w(g.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class c{constructor(i,o,y,g,E=new m,P=new m,l=new R.$yc,$=new m,b=new R.$yc){this.c=i,this.d=o,this.f=y,this.g=g,this.h=E,this.i=P,this.j=l,this.l=$,this.m=b,this.a=null,this.b=new R.$yc,this.n=null}getValue(i,o,y){return this.q(i,o,y).getValue(i)}updateValue(i,o,y={}){let g;y.resource?(g=this.m.get(y.resource),g||(g=new m,this.m.set(y.resource,g))):g=this.l,o===void 0?g.removeValue(i):g.setValue(i,o),y.resource||(this.a=null)}inspect(i,o,y){const g=this.q(i,o,y),E=this.u(o.resource,y),P=o.resource?this.m.get(o.resource)||this.l:this.l,l=new Set;for(const $ of g.overrides)for(const b of $.identifiers)g.getOverrideValue(i,b)!==void 0&&l.add(b);return new s(i,o,g.getValue(i),l.size?[...l]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,y?this.i:void 0,E||void 0,P)}keys(i){const o=this.u(void 0,i);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:o?o.keys.slice(0):[]}}updateDefaultConfiguration(i){this.c=i,this.a=null,this.b.clear()}updatePolicyConfiguration(i){this.d=i}updateApplicationConfiguration(i){this.f=i,this.a=null,this.b.clear()}updateLocalUserConfiguration(i){this.g=i,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(i){this.h=i,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(i){this.i=i,this.a=null,this.b.clear()}updateFolderConfiguration(i,o){this.j.set(i,o),this.b.delete(i)}deleteFolderConfiguration(i){this.p.delete(i),this.b.delete(i)}compareAndUpdateDefaultConfiguration(i,o){const y=[];if(!o){const{added:g,updated:E,removed:P}=p(this.c,i);o=[...g,...E,...P]}for(const g of o)for(const E of(0,k.$nn)(g)){const P=this.c.getKeysForOverrideIdentifier(E),l=i.getKeysForOverrideIdentifier(E),$=[...l.filter(b=>P.indexOf(b)===-1),...P.filter(b=>l.indexOf(b)===-1),...P.filter(b=>!u.$2m(this.c.override(E).getValue(b),i.override(E).getValue(b)))];y.push([E,$])}return this.updateDefaultConfiguration(i),{keys:o,overrides:y}}compareAndUpdatePolicyConfiguration(i){const{added:o,updated:y,removed:g}=p(this.d,i),E=[...o,...y,...g];return E.length&&this.updatePolicyConfiguration(i),{keys:E,overrides:[]}}compareAndUpdateApplicationConfiguration(i){const{added:o,updated:y,removed:g,overrides:E}=p(this.applicationConfiguration,i),P=[...o,...y,...g];return P.length&&this.updateApplicationConfiguration(i),{keys:P,overrides:E}}compareAndUpdateLocalUserConfiguration(i){const{added:o,updated:y,removed:g,overrides:E}=p(this.localUserConfiguration,i),P=[...o,...y,...g];return P.length&&this.updateLocalUserConfiguration(i),{keys:P,overrides:E}}compareAndUpdateRemoteUserConfiguration(i){const{added:o,updated:y,removed:g,overrides:E}=p(this.remoteUserConfiguration,i),P=[...o,...y,...g];return P.length&&this.updateRemoteUserConfiguration(i),{keys:P,overrides:E}}compareAndUpdateWorkspaceConfiguration(i){const{added:o,updated:y,removed:g,overrides:E}=p(this.workspaceConfiguration,i),P=[...o,...y,...g];return P.length&&this.updateWorkspaceConfiguration(i),{keys:P,overrides:E}}compareAndUpdateFolderConfiguration(i,o){const y=this.p.get(i),{added:g,updated:E,removed:P,overrides:l}=p(y,o),$=[...g,...E,...P];return($.length||!y)&&this.updateFolderConfiguration(i,o),{keys:$,overrides:l}}compareAndDeleteFolderConfiguration(i){const o=this.p.get(i);if(!o)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:y,updated:g,removed:E,overrides:P}=p(o,void 0);return{keys:[...y,...g,...E],overrides:P}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(i,o,y){let g=this.r(o,y);return o.overrideIdentifier&&(g=g.override(o.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(i)!==void 0&&(g=g.merge(this.d)),g}r({resource:i},o){let y=this.s();if(o&&i){const g=o.getFolder(i);g&&(y=this.t(g.uri)||y);const E=this.m.get(i);E&&(y=y.merge(E))}return y}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(i){let o=this.b.get(i);if(!o){const y=this.s(),g=this.j.get(i);g?(o=y.merge(g),this.b.set(i,o)):o=y}return o}u(i,o){if(o&&i){const y=o.getFolder(i);if(y)return this.j.get(y.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((i,o)=>{const{contents:y,overrides:g,keys:E}=this.j.get(o);return i.push([o,{contents:y,overrides:g,keys:E}]),i},[])}}allKeys(){const i=new Set;return this.c.keys.forEach(o=>i.add(o)),this.userConfiguration.keys.forEach(o=>i.add(o)),this.i.keys.forEach(o=>i.add(o)),this.j.forEach(o=>o.keys.forEach(y=>i.add(y))),[...i.values()]}v(){const i=new Set;return this.c.getAllOverrideIdentifiers().forEach(o=>i.add(o)),this.userConfiguration.getAllOverrideIdentifiers().forEach(o=>i.add(o)),this.i.getAllOverrideIdentifiers().forEach(o=>i.add(o)),this.j.forEach(o=>o.getAllOverrideIdentifiers().forEach(y=>i.add(y))),[...i.values()]}w(i){const o=new Set;return this.c.getKeysForOverrideIdentifier(i).forEach(y=>o.add(y)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(y=>o.add(y)),this.i.getKeysForOverrideIdentifier(i).forEach(y=>o.add(y)),this.j.forEach(y=>y.getKeysForOverrideIdentifier(i).forEach(g=>o.add(g))),[...o.values()]}static parse(i){const o=this.x(i.defaults),y=this.x(i.policy),g=this.x(i.application),E=this.x(i.user),P=this.x(i.workspace),l=i.folders.reduce(($,b)=>($.set(d.URI.revive(b[0]),this.x(b[1])),$),new R.$yc);return new c(o,y,g,E,new m,P,l,new m,new R.$yc)}static x(i){return new m(i.contents,i.keys,i.overrides)}}e.$vn=c;function v(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const i=new Set,o=new Map;for(const g of r)g.keys.forEach(E=>i.add(E)),g.overrides.forEach(([E,P])=>{const l=(0,R.$vc)(o,E,new Set);P.forEach($=>l.add($))});const y=[];return o.forEach((g,E)=>y.push([E,[...g.values()]])),{keys:[...i.values()],overrides:y}}e.$wn=v;class S{constructor(i,o,y,g){this.change=i,this.f=o,this.g=y,this.h=g,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const E of i.keys)this.affectedKeys.add(E);for(const[,E]of i.overrides)for(const P of E)this.affectedKeys.add(P);this.d=this.a;for(const E of this.affectedKeys)this.d+=E+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=c.parse(this.f.data)),this.i}affectsConfiguration(i,o){const y=this.a+i,g=this.d.indexOf(y);if(g<0)return!1;const E=g+y.length;if(E>=this.d.length)return!1;const P=this.d.charCodeAt(E);if(P!==this.b&&P!==this.c)return!1;if(o){const l=this.previousConfiguration?this.previousConfiguration.getValue(i,o,this.f?.workspace):void 0,$=this.g.getValue(i,o,this.h);return!u.$2m(l,$)}return!0}}e.$xn=S;function p(r,i){const{added:o,removed:y,updated:g}=n(i?.rawConfiguration,r?.rawConfiguration),E=[],P=r?.getAllOverrideIdentifiers()||[],l=i?.getAllOverrideIdentifiers()||[];if(i){const $=l.filter(b=>!P.includes(b));for(const b of $)E.push([b,i.getKeysForOverrideIdentifier(b)])}if(r){const $=P.filter(b=>!l.includes(b));for(const b of $)E.push([b,r.getKeysForOverrideIdentifier(b)])}if(i&&r){for(const $ of P)if(l.includes($)){const b=n({contents:r.getOverrideValue(void 0,$)||{},keys:r.getKeysForOverrideIdentifier($)},{contents:i.getOverrideValue(void 0,$)||{},keys:i.getKeysForOverrideIdentifier($)});E.push([$,[...b.added,...b.removed,...b.updated]])}}return{added:o,removed:y,updated:g,overrides:E}}function n(r,i){const o=r?i?r.keys.filter(E=>i.keys.indexOf(E)===-1):[...r.keys]:[],y=i?r?i.keys.filter(E=>r.keys.indexOf(E)===-1):[...i.keys]:[],g=[];if(r&&i){for(const E of i.keys)if(r.keys.indexOf(E)!==-1){const P=(0,A.$ni)(i.contents,E),l=(0,A.$ni)(r.contents,E);u.$2m(P,l)||g.push(E)}}return{added:o,removed:y,updated:g}}}),define(Ae[97],Re([1,0,9,4]),function(ie,e,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ok=e.$Nk=e.RemoteAuthorityResolverErrorCode=e.$Mk=e.$Lk=e.RemoteConnectionType=e.$Kk=void 0,e.$Kk=(0,C.$Lh)("remoteAuthorityResolverService");var I;(function(A){A[A.WebSocket=0]="WebSocket",A[A.Managed=1]="Managed"})(I||(e.RemoteConnectionType=I={}));class O{constructor(k){this.id=k,this.type=1}toString(){return`Managed(${this.id})`}}e.$Lk=O;class R{constructor(k,a){this.host=k,this.port=a,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Mk=R;var u;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound",A.InvalidAuthority="InvalidAuthority"})(u||(e.RemoteAuthorityResolverErrorCode=u={}));class D extends h.$_{static isNotAvailable(k){return k instanceof D&&k._code===u.NotAvailable}static isTemporarilyNotAvailable(k){return k instanceof D&&k._code===u.TemporarilyNotAvailable}static isNoResolverFound(k){return k instanceof D&&k._code===u.NoResolverFound}static isInvalidAuthority(k){return k instanceof D&&k._code===u.InvalidAuthority}static isHandled(k){return k instanceof D&&k.isHandled}constructor(k,a=u.Unknown,w){super(k),this._message=k,this._code=a,this._detail=w,this.isHandled=a===u.NotAvailable&&w===!0,Object.setPrototypeOf(this,D.prototype)}}e.$Nk=D;function d(A){const k=A.indexOf("+");return k===-1?A:A.substring(0,k)}e.$Ok=d}),define(Ae[52],Re([1,0,13]),function(ie,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tk=e.$Sk=e.$Rk=e.$Qk=e.$Pk=void 0;function C(d){return d.scheme===h.Schemas.vscodeRemote?d.authority:void 0}e.$Pk=C;function I(d){if(!d)return;const A=d.indexOf("+");return A<0?d:d.substr(0,A)}e.$Qk=I;function O(d){return`/${d.quality??"oss"}-${d.commit??"dev"}`}e.$Rk=O;function R(d){const{host:A,port:k}=D(d);if(typeof k>"u")throw new Error("Remote authority doesn't contain a port!");return{host:A,port:k}}e.$Sk=R;function u(d,A){let{host:k,port:a}=D(d);return typeof a>"u"&&(a=A),{host:k,port:a}}e.$Tk=u;function D(d){const A=d.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(A)return{host:A[1],port:parseInt(A[2],10)};const k=d.match(/^(\[[0-9a-z:]+\])$/);if(k)return{host:k[1],port:void 0};const a=d.match(/(.*):(\d+)$/);return a?{host:a[1],port:parseInt(a[2],10)}:{host:d,port:void 0}}}),define(Ae[20],Re([1,0,15,4,52]),function(ie,e,h,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5l=e.$4l=e.$3l=e.$2l=e.$1l=e.$Zl=e.$Yl=e.$Xl=e.TargetPlatform=e.ExtensionType=e.$Wl=e.$Vl=e.$Ul=e.$Tl=e.$Sl=e.$Rl=void 0,e.$Rl="extensions.user.cache",e.$Sl="extensions.builtin.cache",e.$Tl="undefined_publisher",e.$Ul=["ui","workspace","web"];function O(f){if(typeof f=="object"&&f!==null&&f.supported!==!0)return f.description}e.$Vl=O,e.$Wl=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var R;(function(f){f[f.System=0]="System",f[f.User=1]="User"})(R||(e.ExtensionType=R={}));var u;(function(f){f.WIN32_X64="win32-x64",f.WIN32_IA32="win32-ia32",f.WIN32_ARM64="win32-arm64",f.LINUX_X64="linux-x64",f.LINUX_ARM64="linux-arm64",f.LINUX_ARMHF="linux-armhf",f.ALPINE_X64="alpine-x64",f.ALPINE_ARM64="alpine-arm64",f.DARWIN_X64="darwin-x64",f.DARWIN_ARM64="darwin-arm64",f.WEB="web",f.UNIVERSAL="universal",f.UNKNOWN="unknown",f.UNDEFINED="undefined"})(u||(e.TargetPlatform=u={}));class D{constructor(t){this.value=t,this._lower=t.toLowerCase()}static equals(t,s){if(typeof t>"u"||t===null)return typeof s>"u"||s===null;if(typeof s>"u"||s===null)return!1;if(typeof t=="string"||typeof s=="string"){const c=typeof t=="string"?t:t.value,v=typeof s=="string"?s:s.value;return h.$Ze(c,v)}return t._lower===s._lower}static toKey(t){return typeof t=="string"?t.toLowerCase():t._lower}}e.$Xl=D;class d{get size(){return this.c.size}constructor(t){if(this.c=new Set,t)for(const s of t)this.add(s)}add(t){this.c.add(D.toKey(t))}delete(t){return this.c.delete(D.toKey(t))}has(t){return this.c.has(D.toKey(t))}}e.$Yl=d;class A{constructor(){this.c=new Map}clear(){this.c.clear()}delete(t){this.c.delete(D.toKey(t))}get(t){return this.c.get(D.toKey(t))}has(t){return this.c.has(D.toKey(t))}set(t,s){this.c.set(D.toKey(t),s)}values(){return this.c.values()}forEach(t){this.c.forEach(t)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Zl=A;function k(f){return a(f)}e.$1l=k;function a(f){return f.contributes&&f.contributes.localizations?f.contributes.localizations.length>0:!1}e.$2l=a;function w(f){return f.contributes&&f.contributes.authentication?f.contributes.authentication.length>0:!1}e.$3l=w;function m(f,t){if(t){const s=`onResolveRemoteAuthority:${(0,I.$Qk)(t)}`;return!!f.activationEvents?.includes(s)}return!1}e.$4l=m,e.$5l=(0,C.$Lh)("IBuiltinExtensionsScannerService")}),define(Ae[98],Re([1,0,9,20]),function(ie,e,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ME=e.$LE=void 0;class I{constructor(){this.a=new Map,this.b=new WeakMap}register(R,u){this.a.set(R,u)}readActivationEvents(R){return this.b.has(R)||this.b.set(R,this.c(R)),this.b.get(R)}createActivationEventsMap(R){const u=Object.create(null);for(const D of R){const d=this.readActivationEvents(D);d.length>0&&(u[C.$Xl.toKey(D.identifier)]=d)}return u}c(R){if(typeof R.main>"u"&&typeof R.browser>"u")return[];const u=Array.isArray(R.activationEvents)?R.activationEvents.slice(0):[];if(!R.contributes)return u;for(const D in R.contributes){const d=this.a.get(D);if(!d)continue;const A=R.contributes[D],k=Array.isArray(A)?A:[A];try{d(k,u)}catch(a){(0,h.$Y)(a)}}return u}}e.$LE=I,e.$ME=new I}),define(Ae[178],Re([1,0,22,74,37]),function(ie,e,h,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ao=e.$_n=void 0;function O(D){if(h.$o===2&&/^penguin(\.|$)/i.test(D))return"chromebook"}function R(D,d,A,k,a,w,m,f){const t=Object.create(null);t["common.machineId"]=w,t.sessionID=(0,I.$bg)()+Date.now(),t.commitHash=k,t.version=a,t["common.platformVersion"]=(D||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),t["common.platform"]=(0,h.$c)(h.$o),t["common.nodePlatform"]=C.$bc,t["common.nodeArch"]=A,t["common.product"]=f||"desktop",m&&(t["common.msftInternal"]=m);let s=0;const c=Date.now();Object.defineProperties(t,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-c,enumerable:!0},"common.sequence":{get:()=>s++,enumerable:!0}}),h.$g&&(t["common.snap"]="true");const v=O(d);return v&&(t["common.platformDetail"]=v),t}e.$_n=R;function u(D){const d=C.env.USERDNSDOMAIN;if(!d)return!1;const A=d.toLowerCase();return D.some(k=>A===k)}e.$ao=u}),define(Ae[179],Re([1,0,4]),function(ie,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$gl=e.$fl=e.$el=e.$dl=e.$cl=e.$bl=e.$al=e.$_k=e.$$k=e.$0k=void 0,e.$0k=(0,h.$Lh)("telemetryService"),e.$$k=(0,h.$Lh)("customEndpointTelemetryService"),e.$_k="telemetry.currentSessionDate",e.$al="telemetry.firstSessionDate",e.$bl="telemetry.lastSessionDate",e.$cl="telemetry.machineId",e.$dl="telemetry",e.$el="telemetry.telemetryLevel",e.$fl="telemetry.enableCrashReporter",e.$gl="telemetry.enableTelemetry";var C;(function(O){O[O.NONE=0]="NONE",O[O.CRASH=1]="CRASH",O[O.ERROR=2]="ERROR",O[O.USAGE=3]="USAGE"})(C||(e.TelemetryLevel=C={}));var I;(function(O){O.OFF="off",O.CRASH="crash",O.ERROR="error",O.ON="all"})(I||(e.TelemetryConfiguration=I={}))}),define(Ae[53],Re([1,0,24,16,5,43,52,178,179]),function(ie,e,h,C,I,O,R,u,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qo=e.$po=e.$oo=e.$no=e.$mo=e.$lo=e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.$co=e.$bo=void 0;class d{constructor(y){this.value=y,this.isTrustedTelemetryValue=!0}}e.$bo=d;class A{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$co=A,e.$do=new A;class k{async publicLog(y,g,E){}async publicLogError(y,g,E){}}e.$eo=k,e.$fo="telemetry",e.$go="extensionTelemetryLog",e.$ho={log:()=>null,flush:()=>Promise.resolve(null)};function a(o,y){return I.Event.debounce(y.onDidChangeConfiguration,(E,P)=>{const l=E?new Set([...E.affectedKeys,...P.affectedKeys]):P.affectedKeys;return{...P,affectedKeys:l}},1e3,!0)(E=>{E.source!==7&&o.publicLog2("updateConfiguration",{configurationSource:(0,O.$ii)(E.source),configurationKeys:Array.from(E.affectedKeys)})})}e.$io=a;function w(o,y){return!y.isBuilt&&!y.disableTelemetry?!0:!(y.disableTelemetry||!o.enableTelemetry)}e.$jo=w;function m(o,y){return y.extensionTestsLocationURI?!0:!(y.isBuilt||y.disableTelemetry||o.enableTelemetry&&o.aiConfig?.ariaKey)}e.$ko=m;function f(o){const y=o.getValue(D.$el),g=o.getValue(D.$fl);if(o.getValue(D.$gl)===!1||g===!1)return 0;switch(y??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$lo=f;function t(o){const y={},g={},E={};v(o,E);for(let P in E){P=P.length>150?P.substr(P.length-149):P;const l=E[P];typeof l=="number"?g[P]=l:typeof l=="boolean"?g[P]=l?1:0:typeof l=="string"?(l.length>8192&&console.warn(`Telemetry property: ${P} has been trimmed to 8192, the original length is ${l.length}`),y[P]=l.substring(0,8191)):typeof l<"u"&&l!==null&&(y[P]=l)}return{properties:y,measurements:g}}e.$mo=t;const s=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function c(o){if(!o)return"none";const y=(0,R.$Qk)(o);return s.has(y)?y:"other"}e.$no=c;function v(o,y,g=0,E){if(o)for(const P of Object.getOwnPropertyNames(o)){const l=o[P],$=E?E+P:P;Array.isArray(l)?y[$]=(0,h.$3m)(l):l instanceof Date?y[$]=l.toISOString():(0,C.$yf)(l)?g<2?v(l,y,g+1,$+"."):y[$]=(0,h.$3m)(l):y[$]=l}}function S(o,y){const g=o.msftInternalDomains||[],E=y.getValue("telemetry.internalTesting");return(0,u.$ao)(g)||E}e.$oo=S;function p(o){return[o.appRoot,o.extensionsPath,o.userHome.fsPath,o.tmpDir.fsPath,o.userDataPath]}e.$po=p;function n(o,y){if(!o||!o.includes("/")&&!o.includes("\\"))return o;let g=o;const E=[];for(const b of y)for(;;){const M=b.exec(o);if(!M)break;E.push([M.index,b.lastIndex])}const P=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,l=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let $=0;for(g="";;){const b=l.exec(o);if(!b)break;const M=E.some(([U,F])=>b.index<F&&U<l.lastIndex);!P.test(b[0])&&!M&&(g+=o.substring($,b.index)+"<REDACTED: user-file-path>",$=l.lastIndex)}return $<o.length&&(g+=o.substr($)),g}function r(o){if(!o)return o;const y=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const g of y)if(g.regex.test(o))return`<REDACTED: ${g.label}>`;return o}function i(o,y){return(0,h.$Zm)(o,g=>{if(g instanceof d||Object.hasOwnProperty.call(g,"isTrustedTelemetryValue"))return g.value;if(typeof g=="string"){let E=g.replaceAll("%20"," ");E=n(E,y);for(const P of y)E=E.replace(P,"");return E=r(E),E}})}e.$qo=i}),define(Ae[180],Re([1,0,15,92,20,22,2,9,74,53]),function(ie,e,h,C,I,O,R,u,D,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=void 0;function A(i,o){return i.uuid&&o.uuid?i.uuid===o.uuid:i.id===o.id?!0:(0,h.$Ue)(i.id,o.id)===0}e.$ro=A;const k=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class a{static create(o){const y=o.manifest?o.manifest.version:o.version,g=o.manifest?o.targetPlatform:o.properties.targetPlatform;return new a(o.identifier,y,g)}static parse(o){const y=k.exec(o);return y&&y[1]&&y[2]?new a({id:y[1]},y[2],y[4]||void 0):null}constructor(o,y,g="undefined"){this.version=y,this.targetPlatform=g,this.id=o.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(o){return o instanceof a?A(this,o)&&this.version===o.version&&this.targetPlatform===o.targetPlatform:!1}}e.$so=a;const w=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function m(i){const o=w.exec(i);return o&&o[1]?[t(o[1]),o[2]]:[t(i),void 0]}e.$to=m;function f(i,o){return`${i}.${o}`}e.$uo=f;function t(i){return i.toLowerCase()}e.$vo=t;function s(i,o){return t(f(i??I.$Tl,o))}e.$wo=s;function c(i,o){const y=[],g=E=>{for(const P of y)if(P.some(l=>A(o(l),o(E))))return P;return null};for(const E of i){const P=g(E);P?P.push(E):y.push([E])}return y}e.$xo=c;function v(i){return{id:i.identifier.id,name:i.manifest.name,galleryId:null,publisherId:i.publisherId,publisherName:i.manifest.publisher,publisherDisplayName:i.publisherDisplayName,dependencies:i.manifest.extensionDependencies&&i.manifest.extensionDependencies.length>0}}e.$yo=v;function S(i){return{id:new d.$bo(i.identifier.id),name:new d.$bo(i.name),galleryId:i.identifier.uuid,publisherId:i.publisherId,publisherName:i.publisher,publisherDisplayName:i.publisherDisplayName,isPreReleaseVersion:i.properties.isPreReleaseVersion,dependencies:!!(i.properties.dependencies&&i.properties.dependencies.length>0),isSigned:i.isSigned,...i.telemetryData}}e.$zo=S,e.$Ao=new I.$Xl("pprice.better-merge");function p(i,o){const y=[],g=o.manifest.extensionDependencies?.slice(0)??[];for(;g.length;){const E=g.shift();if(E&&y.every(P=>!A(P.identifier,{id:E}))){const P=i.filter(l=>A(l.identifier,{id:E}));P.length===1&&(y.push(P[0]),g.push(...P[0].manifest.extensionDependencies?.slice(0)??[]))}}return y}e.$Bo=p;async function n(i,o){if(!O.$f)return!1;let y;try{y=(await i.readFile(R.URI.file("/etc/os-release"))).value.toString()}catch{try{y=(await i.readFile(R.URI.file("/usr/lib/os-release"))).value.toString()}catch(E){o.debug("Error while getting the os-release file.",(0,u.$8)(E))}}return!!y&&(y.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function r(i,o){const y=await n(i,o),g=(0,C.$Wn)(y?"alpine":O.$o,D.$cc);return o.debug("ComputeTargetPlatform:",g),g}e.$Co=r}),define(Ae[181],Re([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hr=e.$gr=e.$fr=e.$er=e.$dr=e.$cr=void 0;function h(D){return[...D.entries()]}e.$cr=h;function C(D){return D?[...D.entries()]:[]}e.$dr=C;function I(D){return new Map(D)}e.$er=I;function O(D){return new Map(D??[])}e.$fr=O;function R(D){return Array.from(D.entries()).map(d=>[d[0],h(d[1].map),C(d[1].descriptionMap)])}e.$gr=R;function u(D){return new Map(D.map(d=>[d[0],{map:I(d[1]),descriptionMap:O(d[2])}]))}e.$hr=u}),define(Ae[182],Re([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ikb=void 0;class h{constructor(I){this.b=I,this.a=new Map}dispose(){for(const I of this.a.values())I.dispose()}startBuffering(I,O,R=5){const u=O(D=>{const d=typeof D=="string"?D:D.data;let A=this.a.get(I);if(A){A.data.push(d);return}const k=setTimeout(()=>this.flushBuffer(I),R);A={data:[d],timeoutId:k,dispose:()=>{clearTimeout(k),this.flushBuffer(I),u.dispose()}},this.a.set(I,A)});return u}stopBuffering(I){this.a.get(I)?.dispose()}flushBuffer(I){const O=this.a.get(I);O&&(this.a.delete(I),this.b(I,O.data.join("")))}}e.$Ikb=h}),define(Ae[183],Re([1,0,12,89,41,5,16,2,144,73,30]),function(ie,e,h,C,I,O,R,u,D,d,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5v=e.$4v=e.$3v=e.$2v=e.$1v=e.$Zv=e.$Yv=e.$Xv=e.IconFontDefinition=e.IconContribution=e.$Wv=void 0,e.$Wv={IconContribution:"base.contributions.icons"};var k;(function(S){function p(n,r){let i=n.defaults;for(;I.ThemeIcon.isThemeIcon(i);){const o=m.getIcon(i.id);if(!o)return;i=o.defaults}return i}S.getDefinition=p})(k||(e.IconContribution=k={}));var a;(function(S){function p(r){return{weight:r.weight,style:r.style,src:r.src.map(i=>({format:i.format,location:i.location.toString()}))}}S.toJSONObject=p;function n(r){const i=o=>(0,R.$wf)(o)?o:void 0;if(r&&Array.isArray(r.src)&&r.src.every(o=>(0,R.$wf)(o.format)&&(0,R.$wf)(o.location)))return{weight:i(r.weight),style:i(r.style),src:r.src.map(o=>({format:o.format,location:u.URI.parse(o.location)}))}}S.fromJSONObject=n})(a||(e.IconFontDefinition=a={}));class w{constructor(){this.a=new O.$Ld,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,D.localize)(0,null)},fontCharacter:{type:"string",description:(0,D.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${I.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(p,n,r,i){const o=this.b[p];if(o){if(r&&!o.description){o.description=r,this.d.properties[p].markdownDescription=`${r} $(${p})`;const E=this.e.enum.indexOf(p);E!==-1&&(this.e.enumDescriptions[E]=r),this.a.fire()}return o}const y={id:p,description:r,defaults:n,deprecationMessage:i};this.b[p]=y;const g={$ref:"#/definitions/icons"};return i&&(g.deprecationMessage=i),r&&(g.markdownDescription=`${r}: $(${p})`),this.d.properties[p]=g,this.e.enum.push(p),this.e.enumDescriptions.push(r||""),this.a.fire(),{id:p}}deregisterIcon(p){delete this.b[p],delete this.d.properties[p];const n=this.e.enum.indexOf(p);n!==-1&&(this.e.enum.splice(n,1),this.e.enumDescriptions.splice(n,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(p=>this.b[p])}getIcon(p){return this.b[p]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(p,n){const r=this.f[p];return r||(this.f[p]=n,this.a.fire(),n)}deregisterIconFont(p){delete this.f[p]}getIconFont(p){return this.f[p]}toString(){const p=(o,y)=>o.id.localeCompare(y.id),n=o=>{for(;I.ThemeIcon.isThemeIcon(o.defaults);)o=this.b[o.defaults.id];return`codicon codicon-${o?o.id:""}`},r=[];r.push("| preview     | identifier                        | default codicon ID                | description"),r.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const i=Object.keys(this.b).map(o=>this.b[o]);for(const o of i.filter(y=>!!y.description).sort(p))r.push(`|<i class="${n(o)}"></i>|${o.id}|${I.ThemeIcon.isThemeIcon(o.defaults)?o.defaults.id:o.id}|${o.description||""}|`);r.push("| preview     | identifier                        "),r.push("| ----------- | --------------------------------- |");for(const o of i.filter(y=>!I.ThemeIcon.isThemeIcon(y.defaults)).sort(p))r.push(`|<i class="${n(o)}"></i>|${o.id}|`);return r.join(`
`)}}const m=new w;A.$0m.add(e.$Wv.IconContribution,m);function f(S,p,n,r){return m.registerIcon(S,p,n,r)}e.$Xv=f;function t(){return m}e.$Yv=t;function s(){const S=(0,C.$Oj)();for(const p in S){const n="\\"+S[p].toString(16);m.registerIcon(p,{fontCharacter:n})}}s(),e.$Zv="vscode://schemas/icons";const c=A.$0m.as(d.$$m.JSONContribution);c.registerSchema(e.$Zv,m.getIconSchema());const v=new h.$3g(()=>c.notifySchemaChanged(e.$Zv),200);m.onDidChange(()=>{v.isScheduled()||v.schedule()}),e.$1v=f("widget-close",C.$Qj.close,(0,D.localize)(2,null)),e.$2v=f("goto-previous-location",C.$Qj.arrowUp,(0,D.localize)(3,null)),e.$3v=f("goto-next-location",C.$Qj.arrowDown,(0,D.localize)(4,null)),e.$4v=I.ThemeIcon.modify(C.$Qj.sync,"spin"),e.$5v=I.ThemeIcon.modify(C.$Qj.loading,"spin")}),define(Ae[184],Re([1,0,5,43,4,14]),function(ie,e,h,C,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_u=e.$$u=e.$0u=e.$9u=e.$8u=e.$7u=e.$6u=e.$5u=e.ProvidedOnAutoForward=e.$4u=e.TunnelPrivacyId=e.TunnelProtocol=e.$3u=e.$2u=void 0,e.$2u=(0,I.$Lh)("tunnelService"),e.$3u=(0,I.$Lh)("sharedTunnelsService");var R;(function(t){t.Http="http",t.Https="https"})(R||(e.TunnelProtocol=R={}));var u;(function(t){t.ConstantPrivate="constantPrivate",t.Private="private",t.Public="public"})(u||(e.TunnelPrivacyId=u={}));function D(t){return!!t.forwardPort}e.$4u=D;var d;(function(t){t[t.Notify=1]="Notify",t[t.OpenBrowser=2]="OpenBrowser",t[t.OpenPreview=3]="OpenPreview",t[t.Silent=4]="Silent",t[t.Ignore=5]="Ignore",t[t.OpenBrowserOnce=6]="OpenBrowserOnce"})(d||(e.ProvidedOnAutoForward=d={}));function A(t){if(t.scheme!=="http"&&t.scheme!=="https")return;const s=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(t.authority);if(s)return{address:s[1],port:+s[2]}}e.$5u=A,e.$6u=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function k(t){return e.$6u.indexOf(t)>=0}e.$7u=k,e.$8u=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function a(t){return e.$8u.indexOf(t)>=0}e.$9u=a;function w(t,s,c,v){if(c===1)return!1;if(c===2&&a(s)){const S=/(\d+)\.(\d+)\.(\d+)/g.exec(v);if(S?.length===4&&parseInt(S[1])>=18)return!1}return t<1024}e.$0u=w;class m{constructor(s,c,v){this.remoteAddress=s,this.localAddress=c,this.b=v,this.a=new h.$Ld,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$$u=m;let f=class{constructor(s,c){this.j=s,this.k=c,this.a=new h.$Ld,this.onTunnelOpened=this.a.event,this.b=new h.$Ld,this.onTunnelClosed=this.b.event,this.c=new h.$Ld,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=[],this.i=new Set}get hasTunnelProvider(){return!!this.f}get l(){const s=this.k.getValue("remote.localPortHost");return!s||s==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(s){return this.f=s,s?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.h=[]}}):(this.g=!1,this.h=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(s){this.g=s.elevation,this.h=s.privacyOptions}get canElevate(){return this.g}get canChangePrivacy(){return this.h.length>0}get privacyOptions(){return this.h}get tunnels(){return this.m()}async m(){const s=[],c=Array.from(this.e.values());for(const v of c){const S=Array.from(v.values());for(const p of S){const n=await p.value;n&&typeof n!="string"&&s.push(n)}}return s}async dispose(){for(const s of this.e.values()){for(const{value:c}of s.values())await c.then(v=>typeof v!="string"?v?.dispose():void 0);s.clear()}this.e.clear()}setEnvironmentTunnel(s,c,v,S,p){this.p(s,c,Promise.resolve({tunnelRemoteHost:s,tunnelRemotePort:c,localAddress:v,privacy:S,protocol:p,dispose:()=>Promise.resolve()}))}async getExistingTunnel(s,c){(a(s)||k(s))&&(s=e.$6u[0]);const v=this.r(s,c);if(v)return++v.refcount,v.value}openTunnel(s,c,v,S,p,n=!1,r,i){this.j.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${c}:${v} on local port ${p}.`);const o=this.f??s;if(!o)return;if(c||(c="localhost"),S||(S=this.l),this.f&&this.i.has(v)){this.j.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const y=this.s(o,c,v,S,p,n,r,i);return y?y.then(g=>{if(g){if(typeof g=="string")return this.j.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.q(c,v),g}else{this.j.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.q(c,v);return}this.j.trace("ForwardedPorts: (TunnelService) New tunnel established.");const E=this.n(g);return(g.tunnelRemoteHost!==c||g.tunnelRemotePort!==v)&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),r&&g.privacy!==r&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(E),E}):(this.j.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),y)}n(s){return{tunnelRemotePort:s.tunnelRemotePort,tunnelRemoteHost:s.tunnelRemoteHost,tunnelLocalPort:s.tunnelLocalPort,localAddress:s.localAddress,privacy:s.privacy,protocol:s.protocol,dispose:async()=>{this.j.trace(`ForwardedPorts: (TunnelService) dispose request for ${s.tunnelRemoteHost}:${s.tunnelRemotePort} `);const c=this.e.get(s.tunnelRemoteHost);if(c){const v=c.get(s.tunnelRemotePort);v&&(v.refcount--,await this.o(s.tunnelRemoteHost,s.tunnelRemotePort,v))}}}}async o(s,c,v){if(v.refcount<=0){this.j.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${s}:${c}.`);const S=v.value.then(async p=>{p&&typeof p!="string"&&(await p.dispose(!0),this.b.fire({host:p.tunnelRemoteHost,port:p.tunnelRemotePort}))});return this.e.has(s)&&this.e.get(s).delete(c),S}}async closeTunnel(s,c){this.j.trace(`ForwardedPorts: (TunnelService) close request for ${s}:${c} `);const v=this.e.get(s);if(v&&v.has(c)){const S=v.get(c);S.refcount=0,await this.o(s,c,S)}}p(s,c,v){this.e.has(s)||this.e.set(s,new Map),this.e.get(s).set(c,{refcount:1,value:v})}async q(s,c){const v=this.e.get(s);if(v){const S=v.get(c),p=S?await S.value:void 0;(!p||typeof p=="string")&&v.delete(c),v.size===0&&this.e.delete(s)}}r(s,c){const v=[s];k(s)?(v.push(...e.$6u),v.push(...e.$8u)):a(s)&&v.push(...e.$8u);const S=v.map(p=>this.e.get(p));for(const p of S){const n=p?.get(c);if(n)return n}}canTunnel(s){return!!A(s)}t(s,c,v,S,p,n,r){this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${c}:${v} on local port ${S}.`);const i=v;this.i.add(i);const o=S===void 0?v:S,y={elevationRequired:p?this.isPortPrivileged(o):!1},g={remoteAddress:{host:c,port:v},localAddressPort:S,privacy:n,public:n?n!==u.Private:void 0,protocol:r},E=s.forwardPort(g,y);return E?(this.p(c,v,E),E.finally(()=>{this.j.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.i.delete(i)})):this.i.delete(i),E}};e.$_u=f,e.$_u=f=Je([qe(0,O.$6i),qe(1,C.$fi)],f)}),define(Ae[185],Re([1,0,4]),function(ie,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$av=void 0,e.$av=(0,h.$Lh)("editSessionIdentityService");var C;(function(I){I[I.Complete=100]="Complete",I[I.Partial=50]="Partial",I[I.None=0]="None"})(C||(e.EditSessionIdentityMatch=C={}))}),define(Ae[186],Re([1,0,13]),function(ie,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JJ=e.$IJ=e.$HJ=e.$GJ=e.$FJ=void 0;function C(D){return D.scheme!==h.Schemas.file&&D.scheme!==h.Schemas.vscodeRemote}e.$FJ=C;function I(D){if(D.folders.length)return D.folders.every(d=>C(d.uri))?D.folders[0].uri:void 0;if(D.configuration&&C(D.configuration))return D.configuration}e.$GJ=I;function O(D){return I(D)?.scheme}e.$HJ=O;function R(D){return I(D)?.authority}e.$IJ=R;function u(D){return I(D)!==void 0}e.$JJ=u}),define(Ae[54],Re([1,0,145,19,48,23,2,4,13]),function(ie,e,h,C,I,O,R,u,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ei=e.$di=e.$ci=e.$bi=e.$ai=e.$_h=e.$$h=e.$0h=e.$9h=e.$8h=e.$7h=e.$6h=e.$5h=e.$4h=e.$3h=e.WorkbenchState=e.$2h=e.$1h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=void 0,e.$Uh=(0,u.$Lh)("contextService");function d(o){const y=o;return typeof y?.id=="string"&&R.URI.isUri(y.uri)}e.$Vh=d;function A(o){return typeof o?.id=="string"&&!d(o)&&!a(o)}e.$Wh=A,e.$Xh={id:"ext-dev"},e.$Yh={id:"empty-window"};function k(o,y){if(typeof o=="string"||typeof o>"u")return typeof o=="string"?{id:(0,C.$lc)(o)}:y?e.$Xh:e.$Yh;const g=o;return g.configuration?{id:g.id,configPath:g.configuration}:g.folders.length===1?{id:g.id,uri:g.folders[0].uri}:{id:g.id}}e.$Zh=k;function a(o){const y=o;return typeof y?.id=="string"&&R.URI.isUri(y.configPath)}e.$1h=a;function w(o){const y=o;if(y?.uri)return{id:y.id,uri:R.URI.revive(y.uri)};const g=o;if(g?.configPath)return{id:g.id,configPath:R.URI.revive(g.configPath)};if(o?.id)return{id:o.id}}e.$2h=w;var m;(function(o){o[o.EMPTY=1]="EMPTY",o[o.FOLDER=2]="FOLDER",o[o.WORKSPACE=3]="WORKSPACE"})(m||(e.WorkbenchState=m={}));function f(o){const y=o;return!!(y&&typeof y=="object"&&typeof y.id=="string"&&Array.isArray(y.folders))}e.$3h=f;function t(o){const y=o;return!!(y&&typeof y=="object"&&R.URI.isUri(y.uri)&&typeof y.name=="string"&&typeof y.toResource=="function")}e.$4h=t;class s{constructor(y,g,E,P,l){this.h=y,this.j=E,this.k=P,this.l=l,this.c=I.$Rh.forUris(this.l,()=>!0),this.folders=g}update(y){this.h=y.id,this.k=y.configuration,this.j=y.transient,this.l=y.l,this.folders=y.folders}get folders(){return this.g}set folders(y){this.g=y,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(y){this.k=y}getFolder(y){return y&&this.c.findSubstr(y)||null}n(){this.c=I.$Rh.forUris(this.l,()=>!0);for(const y of this.folders)this.c.set(y.uri,y)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$5h=s;class c{constructor(y,g){this.raw=g,this.uri=y.uri,this.index=y.index,this.name=y.name}toResource(y){return(0,O.$sg)(this.uri,y)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$6h=c;function v(o){return new c({uri:o,index:0,name:(0,O.$og)(o)},{uri:o.toString()})}e.$7h=v,e.$8h="code-workspace",e.$9h=`.${e.$8h}`,e.$0h=[{name:(0,h.localize)(0,null),extensions:[e.$8h]}],e.$$h="workspace.json";function S(o,y){return O.$jg.isEqualOrParent(o,y.untitledWorkspacesHome)}e.$_h=S;function p(o){let y;return R.URI.isUri(o)?y=o:y=o.configuration,y?.scheme===D.Schemas.tmp}e.$ai=p,e.$bi="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function n(o){return o.id===e.$bi}e.$ci=n;function r(o,y){return!S(o,y)&&!p(o)}e.$di=r;function i(o){return(typeof o=="string"?(0,C.$mc)(o):(0,O.$qg)(o))===e.$9h}e.$ei=i}),define(Ae[55],Re([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wbc=void 0;class h{constructor(I){this.d=I,this.b=new Map,this.c=1}add(I){const O=this.c++;return this.b.set(O,I),this.e(),O}get(I,O){return this.b.has(I)?this.b.get(I)[O]:void 0}delete(I){this.b.delete(I),this.e()}e(){h.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$wbc=h,h.a=!1}),define(Ae[39],Re([1,0,13,23,4]),function(ie,e,h,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zbc=e.$ybc=void 0;class O{constructor(){this.a=new Set(Object.keys(h.Schemas)),this.b=new Map,this.extUri=new C.$hg(u=>{const D=this.b.get(u.scheme);return!(D===void 0||D&1024)})}$acceptProviderInfos(u,D){D===null?this.b.delete(u.scheme):this.b.set(u.scheme,D)}isFreeScheme(u){return!this.b.has(u)&&!this.a.has(u)}getCapabilities(u){return this.b.get(u)}}e.$ybc=O,e.$zbc=(0,I.$Lh)("IExtHostFileSystemInfo")}),define(Ae[27],Re([1,0,4]),function(ie,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nM=void 0,e.$nM=(0,h.$Lh)("IExtHostInitDataService")}),define(Ae[187],Re([1,0,150,14,174,27]),function(ie,e,h,C,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gdc=void 0;let R=class extends I.$vN{constructor(D,d,A){const k=A.remote.isRemote?"remoteexthost":D?"workerexthost":"exthost",a=A.remote.isRemote?(0,h.localize)(0,null):D?(0,h.localize)(1,null):(0,h.localize)(2,null);super(d.createLogger(k,{name:a}))}};e.$Gdc=R,e.$Gdc=R=Je([qe(1,C.$7i),qe(2,O.$nM)],R)}),define(Ae[188],Re([1,0,12]),function(ie,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3bc=e.$2bc=void 0;class C{constructor(R,u,D){this.h=new Map,this.a=R,this.b=u,this.c=D,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(d=>(this.f=d,this)),this.g=this.c.onDidChangeStorage(d=>{d.shared===this.b&&d.key===this.a&&(this.f=d.value)}),this.i=new h.$3g(()=>{const d=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const A of d.values())A.complete()}catch(A){for(const k of d.values())k.error(A)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,R])=>R!==void 0).map(([R])=>R)}get whenReady(){return this.d}get(R,u){let D=this.f[R];return typeof D>"u"&&(D=u),D}update(R,u){this.f[R]=u;const D=this.h.get(R);if(D!==void 0)return D.p;const d=new h.$_g;return this.h.set(R,d),this.i.isScheduled()||this.i.schedule(),d.p}dispose(){this.g.dispose()}}e.$2bc=C;class I extends C{setKeysForSync(R){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},R)}constructor(R,u){super(R.identifier.value,!0,u),this.j=R}}e.$3bc=I}),define(Ae[189],Re([1,0,5,2]),function(ie,e,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$odc=void 0;class I{constructor(R){this.c=R,this.a=new h.$Ld,this.onDidSaveNotebookDocument=this.a.event,this.b=new h.$Ld,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(R,u,D,d){const k=this.c.getNotebookDocument(C.URI.revive(R)).acceptModelChanged(u.value,D,d);this.b.fire(k)}$acceptDirtyStateChanged(R,u){this.c.getNotebookDocument(C.URI.revive(R)).acceptDirty(u)}$acceptModelSaved(R){const u=this.c.getNotebookDocument(C.URI.revive(R));this.a.fire(u.apiNotebook)}}e.$odc=I}),define(Ae[17],Re([1,0,4]),function(ie,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$L=e.$0L=void 0,e.$0L=(0,h.$Lh)("IExtHostRpcService");class C{constructor(O){this.getProxy=O.getProxy.bind(O),this.set=O.set.bind(O),this.dispose=O.dispose.bind(O),this.assertRegistered=O.assertRegistered.bind(O),this.drain=O.drain.bind(O)}}e.$$L=C});var Ye=this&&this.__classPrivateFieldSet||function(ie,e,h,C,I){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!I:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?I.call(ie,h):I?I.value=h:e.set(ie,h),h},Ne=this&&this.__classPrivateFieldGet||function(ie,e,h,C){if(h==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!C:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?C:h==="a"?C.call(ie):C?C.value:e.get(ie)};define(Ae[190],Re([1,0,20,5]),function(ie,e,h,C){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.$bcc=void 0;class O{constructor(u,D){I.set(this,void 0),this.b=new C.$Ld,this.onDidChange=this.b.event,this.a=h.$Xl.toKey(u.identifier),Ye(this,I,D,"f"),Ne(this,I,"f").onDidChangePassword(d=>{d.extensionId===this.a&&this.b.fire({key:d.key})})}get(u){return Ne(this,I,"f").get(this.a,u)}store(u,D){return Ne(this,I,"f").store(this.a,u,D)}delete(u){return Ne(this,I,"f").delete(this.a,u)}}e.$bcc=O,I=new WeakMap}),define(Ae[56],Re([1,0,4]),function(ie,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kbc=e.$Jbc=void 0,e.$Jbc=(0,h.$Lh)("IURITransformerService");class C{constructor(O){O?(this.transformIncoming=O.transformIncoming.bind(O),this.transformOutgoing=O.transformOutgoing.bind(O),this.transformOutgoingURI=O.transformOutgoingURI.bind(O),this.transformOutgoingScheme=O.transformOutgoingScheme.bind(O)):(this.transformIncoming=R=>R,this.transformOutgoing=R=>R,this.transformOutgoingURI=R=>R,this.transformOutgoingScheme=R=>R)}}e.$Kbc=C}),define(Ae[191],Re([1,0,25]),function(ie,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mcb=e.$lcb=void 0;class C{constructor(){this.buffers=[]}add(D){let d=this.buffers.indexOf(D);return d<0&&(d=this.buffers.length,this.buffers.push(D)),d}}function I(u,D){if(D.serializeBuffersForPostMessage){const d=new C,k=JSON.stringify(u,(w,m)=>{if(m instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:d.add(m)};if(ArrayBuffer.isView(m)){const f=O(m);if(f)return{$$vscode_array_buffer_reference$$:!0,index:d.add(m.buffer),view:{type:f,byteLength:m.byteLength,byteOffset:m.byteOffset}}}return m}),a=d.buffers.map(w=>{const m=new Uint8Array(w);return h.$_d.wrap(m)});return{message:k,buffers:a}}else return{message:JSON.stringify(u),buffers:[]}}e.$lcb=I;function O(u){switch(u.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function R(u,D){const d=D.map(a=>{const w=new ArrayBuffer(a.byteLength);return new Uint8Array(w).set(a.buffer),w}),A=D.length?(a,w)=>{if(w&&typeof w=="object"&&w.$$vscode_array_buffer_reference$$){const m=w,{index:f}=m,t=d[f];if(m.view)switch(m.view.type){case 1:return new Int8Array(t,m.view.byteOffset,m.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(t,m.view.byteOffset,m.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(t,m.view.byteOffset,m.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(t,m.view.byteOffset,m.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(t,m.view.byteOffset,m.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(t,m.view.byteOffset,m.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(t,m.view.byteOffset,m.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(t,m.view.byteOffset,m.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(t,m.view.byteOffset,m.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(t,m.view.byteOffset,m.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(t,m.view.byteOffset,m.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return t}return w}:void 0;return{message:JSON.parse(u,A),arrayBuffers:d}}e.$mcb=R}),define(Ae[99],Re([1,0,159,16,2,6,4,30,38,13,42,130,29]),function(ie,e,h,C,I,O,R,u,D,d,A,k,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$D=e.$0D=e.$9D=e.EditorsOrder=e.$8D=e.CloseDirection=e.$7D=e.$6D=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$5D=e.$4D=e.$3D=e.$2D=e.$1D=e.$ZD=e.$YD=e.$XD=e.EditorInputCapabilities=e.$WD=e.SaveReason=e.Verbosity=e.$VD=e.$UD=e.$TD=e.$SD=e.$RD=e.$QD=e.$PD=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$OD=e.$ND=e.$MD=e.$LD=e.$KD=void 0,e.$KD={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$LD={id:"default",displayName:(0,h.localize)(0,null),providerDisplayName:(0,h.localize)(1,null)},e.$MD="workbench.editor.sidebysideEditor",e.$ND="workbench.editors.textDiffEditor",e.$OD="workbench.editors.binaryResourceDiffEditor";var w;(function(ue){ue[ue.PROGRAMMATIC=1]="PROGRAMMATIC",ue[ue.USER=2]="USER",ue[ue.EDIT=3]="EDIT",ue[ue.NAVIGATION=4]="NAVIGATION",ue[ue.JUMP=5]="JUMP"})(w||(e.EditorPaneSelectionChangeReason=w={}));var m;(function(ue){ue[ue.IDENTICAL=1]="IDENTICAL",ue[ue.SIMILAR=2]="SIMILAR",ue[ue.DIFFERENT=3]="DIFFERENT"})(m||(e.EditorPaneSelectionCompareResult=m={}));function f(ue){const ve=ue;return!!ve&&typeof ve.getSelection=="function"&&!!ve.onDidChangeSelection}e.$PD=f;function t(ue,ve,ke){for(const V of ke.visibleEditorPanes)if(V.group.id===ve&&ue.matches(V.input))return V.getViewState()}e.$QD=t;function s(ue){if(g(ue))return!1;const ve=ue;return I.URI.isUri(ve?.resource)}e.$RD=s;function c(ue){if(g(ue))return!1;const ve=ue;return ve?.original!==void 0&&ve.modified!==void 0}e.$SD=c;function v(ue){if(g(ue)||c(ue))return!1;const ve=ue;return ve?.primary!==void 0&&ve.secondary!==void 0}e.$TD=v;function S(ue){if(g(ue))return!1;const ve=ue;return ve?ve.resource===void 0||ve.resource.scheme===d.Schemas.untitled||ve.forceUntitled===!0:!1}e.$UD=S;function p(ue){if(g(ue))return!1;const ve=ue;return I.URI.isUri(ve?.base?.resource)&&I.URI.isUri(ve?.input1?.resource)&&I.URI.isUri(ve?.input2?.resource)&&I.URI.isUri(ve?.result?.resource)}e.$VD=p;var n;(function(ue){ue[ue.SHORT=0]="SHORT",ue[ue.MEDIUM=1]="MEDIUM",ue[ue.LONG=2]="LONG"})(n||(e.Verbosity=n={}));var r;(function(ue){ue[ue.EXPLICIT=1]="EXPLICIT",ue[ue.AUTO=2]="AUTO",ue[ue.FOCUS_CHANGE=3]="FOCUS_CHANGE",ue[ue.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(r||(e.SaveReason=r={}));class i{constructor(){this.a=new Map}registerSource(ve,ke){let V=this.a.get(ve);return V||(V={source:ve,label:ke},this.a.set(ve,V)),V.source}getSourceLabel(ve){return this.a.get(ve)?.label??ve}}e.$WD=new i;var o;(function(ue){ue[ue.None=0]="None",ue[ue.Readonly=2]="Readonly",ue[ue.Untitled=4]="Untitled",ue[ue.Singleton=8]="Singleton",ue[ue.RequiresTrust=16]="RequiresTrust",ue[ue.CanSplitInGroup=32]="CanSplitInGroup",ue[ue.ForceDescription=64]="ForceDescription",ue[ue.CanDropIntoEditor=128]="CanDropIntoEditor",ue[ue.MultipleEditors=256]="MultipleEditors",ue[ue.Scratchpad=512]="Scratchpad"})(o||(e.EditorInputCapabilities=o={}));class y extends O.$Qc{}e.$XD=y;function g(ue){return ue instanceof y}e.$YD=g;function E(ue){const ve=ue;return I.URI.isUri(ve?.preferredResource)}function P(ue){const ve=ue;return g(ve?.primary)&&g(ve?.secondary)}e.$ZD=P;function l(ue){const ve=ue;return g(ve?.modified)&&g(ve?.original)}e.$1D=l;function $(ue,ve,ke,V,Q){return De(V,[(0,k.$vi)({id:"workbench.action.openLargeFile",label:(0,h.localize)(2,null),run:()=>{const ee={...ke,limits:{size:Number.MAX_VALUE}};ue.openEditor(ve,ee)}}),(0,k.$vi)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,h.localize)(3,null),run:()=>Q.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:a.default.Warning})}e.$2D=$;function b(ue){return g(ue?.editor)}e.$3D=b;function M(ue){const ve=ue;return b(ue)&&ve?.group!==void 0}e.$4D=M;function U(ue){const ve=ue;return typeof ve?.groupId=="number"&&g(ve.editor)}e.$5D=U;var F;(function(ue){ue[ue.UNKNOWN=0]="UNKNOWN",ue[ue.REPLACE=1]="REPLACE",ue[ue.MOVE=2]="MOVE",ue[ue.UNPIN=3]="UNPIN"})(F||(e.EditorCloseContext=F={}));var q;(function(ue){ue[ue.GROUP_ACTIVE=0]="GROUP_ACTIVE",ue[ue.GROUP_INDEX=1]="GROUP_INDEX",ue[ue.GROUP_LOCKED=2]="GROUP_LOCKED",ue[ue.EDITOR_OPEN=3]="EDITOR_OPEN",ue[ue.EDITOR_CLOSE=4]="EDITOR_CLOSE",ue[ue.EDITOR_MOVE=5]="EDITOR_MOVE",ue[ue.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",ue[ue.EDITOR_LABEL=7]="EDITOR_LABEL",ue[ue.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",ue[ue.EDITOR_PIN=9]="EDITOR_PIN",ue[ue.EDITOR_STICKY=10]="EDITOR_STICKY",ue[ue.EDITOR_DIRTY=11]="EDITOR_DIRTY",ue[ue.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(q||(e.GroupModelChangeKind=q={}));var W;(function(ue){ue[ue.PRIMARY=1]="PRIMARY",ue[ue.SECONDARY=2]="SECONDARY",ue[ue.BOTH=3]="BOTH",ue[ue.ANY=4]="ANY"})(W||(e.SideBySideEditor=W={}));class L{getOriginalUri(ve,ke){if(!ve)return;if(p(ve))return e.$7D.getOriginalUri(ve.result,ke);if(ke?.supportSideBySide){const{primary:Q,secondary:ee}=this.a(ve);if(Q&&ee){if(ke?.supportSideBySide===W.BOTH)return{primary:this.getOriginalUri(Q,{filterByScheme:ke.filterByScheme}),secondary:this.getOriginalUri(ee,{filterByScheme:ke.filterByScheme})};if(ke?.supportSideBySide===W.ANY)return this.getOriginalUri(Q,{filterByScheme:ke.filterByScheme})??this.getOriginalUri(ee,{filterByScheme:ke.filterByScheme});ve=ke.supportSideBySide===W.PRIMARY?Q:ee}}if(c(ve)||v(ve)||p(ve))return;const V=E(ve)?ve.preferredResource:ve.resource;return!V||!ke||!ke.filterByScheme?V:this.b(V,ke.filterByScheme)}a(ve){return P(ve)||v(ve)?{primary:ve.primary,secondary:ve.secondary}:l(ve)||c(ve)?{primary:ve.modified,secondary:ve.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(ve,ke){if(!ve)return;if(p(ve))return e.$7D.getCanonicalUri(ve.result,ke);if(ke?.supportSideBySide){const{primary:Q,secondary:ee}=this.a(ve);if(Q&&ee){if(ke?.supportSideBySide===W.BOTH)return{primary:this.getCanonicalUri(Q,{filterByScheme:ke.filterByScheme}),secondary:this.getCanonicalUri(ee,{filterByScheme:ke.filterByScheme})};if(ke?.supportSideBySide===W.ANY)return this.getCanonicalUri(Q,{filterByScheme:ke.filterByScheme})??this.getCanonicalUri(ee,{filterByScheme:ke.filterByScheme});ve=ke.supportSideBySide===W.PRIMARY?Q:ee}}if(c(ve)||v(ve)||p(ve))return;const V=ve.resource;return!V||!ke||!ke.filterByScheme?V:this.b(V,ke.filterByScheme)}b(ve,ke){if(Array.isArray(ke)){if(ke.some(V=>ve.scheme===V))return ve}else if(ke===ve.scheme)return ve}}var z;(function(ue){ue[ue.UNKNOWN=0]="UNKNOWN",ue[ue.KEYBOARD=1]="KEYBOARD",ue[ue.MOUSE=2]="MOUSE"})(z||(e.EditorCloseMethod=z={}));function K(ue,ve,ke,V){if(!ue.isSticky(ve))return!1;switch(V.preventPinnedEditorClose){case"keyboardAndMouse":return ke===z.MOUSE||ke===z.KEYBOARD;case"mouse":return ke===z.MOUSE;case"keyboard":return ke===z.KEYBOARD}return!1}e.$6D=K,e.$7D=new L;var B;(function(ue){ue[ue.LEFT=0]="LEFT",ue[ue.RIGHT=1]="RIGHT"})(B||(e.CloseDirection=B={}));class me{constructor(){this.c=new Map,this.d=new Map}start(ve){const ke=this.a=ve.get(R.$Kh);for(const[V,Q]of this.c)this.e(V,Q,ke);this.c.clear()}e(ve,ke,V){const Q=V.createInstance(ke);this.d.set(ve,Q)}registerFileEditorFactory(ve){if(this.b)throw new Error("Can only register one file editor factory.");this.b=ve}getFileEditorFactory(){return(0,C.$Hf)(this.b)}registerEditorSerializer(ve,ke){if(this.c.has(ve)||this.d.has(ve))throw new Error(`A editor serializer with type ID '${ve}' was already registered.`);return this.a?this.e(ve,ke,this.a):this.c.set(ve,ke),(0,O.$Oc)(()=>{this.c.delete(ve),this.d.delete(ve)})}getEditorSerializer(ve){return this.d.get(typeof ve=="string"?ve:ve.typeId)}}u.$0m.add(e.$KD.EditorFactory,new me);async function ye(ue,ve,ke){return!ue||!ue.length?[]:await Promise.all(ue.map(async V=>{const Q=I.URI.revive(V.fileUri);if(!Q){ke.info("Cannot resolve the path because it is not valid.",V);return}if(!await ve.canHandleResource(Q)){ke.info("Cannot resolve the path because it cannot be handled",V);return}let $e=V.exists,he=V.type;if(typeof $e!="boolean"||typeof he!="number")try{he=(await ve.stat(Q)).isDirectory?D.FileType.Directory:D.FileType.Unknown,$e=!0}catch(Ee){ke.error(Ee),$e=!1}if(!$e&&V.openOnlyIfExists){ke.info("Cannot resolve the path because it does not exist",V);return}if(he===D.FileType.Directory){ke.info("Cannot resolve the path because it is a directory",V);return}const fe={...V.options,pinned:!0};return $e?{resource:Q,options:fe}:{resource:Q,options:fe,forceUntitled:!0}}))}e.$8D=ye;var Ie;(function(ue){ue[ue.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",ue[ue.SEQUENTIAL=1]="SEQUENTIAL"})(Ie||(e.EditorsOrder=Ie={}));function _(ue){const ve=ue;if(!ve)return!1;const ke=ve;if(ke.modified)return _(ke.modified);const V=ve;return!!(V.contributionsState&&V.viewState&&Array.isArray(V.cursorState))}e.$9D=_;function de(ue){return(0,A.$xi)(ue)}e.$0D=de;function De(ue,ve,ke){const V=(0,A.$yi)(ue,ve);return V.forceMessage=ke?.forceMessage,V.forceSeverity=ke?.forceSeverity,V.allowDialog=ke?.allowDialog,V}e.$$D=De}),define(Ae[192],Re([1,0,5,160,4,6,28,30,18,24,89,183]),function(ie,e,h,C,I,O,R,u,D,d,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hE=e.$gE=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$fE=e.$eE=e.ViewContentGroups=e.$dE=e.$cE=e.ViewContainerLocation=e.Extensions=e.$bE=void 0,e.$bE=(0,k.$Xv)("default-view-icon",A.$Qj.window,(0,C.localize)(0,null));var a;(function(r){r.ViewContainersRegistry="workbench.registry.view.containers",r.ViewsRegistry="workbench.registry.view"})(a||(e.Extensions=a={}));var w;(function(r){r[r.Sidebar=0]="Sidebar",r[r.Panel=1]="Panel",r[r.AuxiliaryBar=2]="AuxiliaryBar"})(w||(e.ViewContainerLocation=w={})),e.$cE=[0,1,2];function m(r){switch(r){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.$dE=m;class f extends O.$Qc{constructor(){super(...arguments),this.c=this.B(new h.$Ld),this.onDidRegister=this.c.event,this.f=this.B(new h.$Ld),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,D.$Pb)([...this.g.values()])}registerViewContainer(i,o,y){const g=this.get(i.id);if(g)return g;const E=i;return E.openCommandActionDescriptor=y?.doNotRegisterOpenCommand?void 0:E.openCommandActionDescriptor??{id:E.id},(0,R.$vc)(this.g,o,[]).push(E),y?.isDefault&&this.h.push(E),this.c.fire({viewContainer:E,viewContainerLocation:o}),E}deregisterViewContainer(i){for(const o of this.g.keys()){const y=this.g.get(o),g=y?.indexOf(i);if(g!==-1){y?.splice(g,1),y.length===0&&this.g.delete(o),this.f.fire({viewContainer:i,viewContainerLocation:o});return}}}get(i){return this.all.filter(o=>o.id===i)[0]}getViewContainers(i){return[...this.g.get(i)||[]]}getViewContainerLocation(i){return[...this.g.keys()].filter(o=>this.getViewContainers(o).filter(y=>y?.id===i.id).length>0)[0]}getDefaultViewContainer(i){return this.h.find(o=>this.getViewContainerLocation(o)===i)}}u.$0m.add(a.ViewContainersRegistry,new f);var t;(function(r){r.Open="2_open",r.Debug="4_debug",r.SCM="5_scm",r.More="9_more"})(t||(e.ViewContentGroups=t={}));function s(r,i){const o=r.group??t.More,y=i.group??t.More;return o!==y?o.localeCompare(y):(r.order??5)-(i.order??5)}class c extends O.$Qc{constructor(){super(...arguments),this.c=this.B(new h.$Ld),this.onViewsRegistered=this.c.event,this.f=this.B(new h.$Ld),this.onViewsDeregistered=this.f.event,this.g=this.B(new h.$Ld),this.onDidChangeContainer=this.g.event,this.h=this.B(new h.$Ld),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new R.$Ec}registerViews(i,o){this.registerViews2([{views:i,viewContainer:o}])}registerViews2(i){i.forEach(({views:o,viewContainer:y})=>this.r(o,y)),this.c.fire(i)}deregisterViews(i,o){const y=this.s(i,o);y.length&&this.f.fire({views:y,viewContainer:o})}moveViews(i,o){for(const y of this.m.keys())if(y!==o){const g=this.s(i,y);g.length&&(this.r(g,o),this.g.fire({views:g,from:y,to:o}))}}getViews(i){return this.m.get(i)||[]}getView(i){for(const o of this.j){const y=(this.m.get(o)||[]).filter(g=>g.id===i)[0];if(y)return y}return null}getViewContainer(i){for(const o of this.j)if((this.m.get(o)||[]).filter(g=>g.id===i)[0])return o;return null}registerViewWelcomeContent(i,o){return this.n.add(i,o),this.h.fire(i),(0,O.$Oc)(()=>{this.n.delete(i,o),this.h.fire(i)})}registerViewWelcomeContent2(i,o){const y=new Map;for(const[g,E]of o)this.n.add(i,E),y.set(g,(0,O.$Oc)(()=>{this.n.delete(i,E),this.h.fire(i)}));return this.h.fire(i),y}getViewWelcomeContent(i){const o=[];return this.n.forEach(i,y=>o.push(y)),o.sort(s)}r(i,o){let y=this.m.get(o);y||(y=[],this.m.set(o,y),this.j.push(o));for(const g of i){if(this.getView(g.id)!==null)throw new Error((0,C.localize)(1,null,g.id));y.push(g)}}s(i,o){const y=this.m.get(o);if(!y)return[];const g=[],E=[];for(const P of y)i.includes(P)?g.push(P):E.push(P);return g.length&&(E.length?this.m.set(o,E):(this.m.delete(o),this.j.splice(this.j.indexOf(o),1))),g}}u.$0m.add(a.ViewsRegistry,new c),e.$eE=(0,I.$Lh)("viewsService"),e.$fE=(0,I.$Lh)("viewDescriptorService");var v;(function(r){r[r.Default=0]="Default",r[r.Expand=1]="Expand"})(v||(e.ViewVisibilityState=v={}));var S;(function(r){r[r.None=0]="None",r[r.Collapsed=1]="Collapsed",r[r.Expanded=2]="Expanded"})(S||(e.TreeItemCollapsibleState=S={}));class p{constructor(i,o){this.c=!1,this.d=!1,(0,d.$1m)(this,i),this.d=!!o,this.resolve=async y=>{if(o&&!this.c){const g=await o(y);g&&(this.tooltip=this.tooltip??g.tooltip,this.command=this.command??g.command)}y.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$gE=p;class n extends Error{constructor(i){super((0,C.localize)(2,null,i)),this.name="NoTreeViewError"}static is(i){return i.name==="NoTreeViewError"}}e.$hE=n}),define(Ae[193],Re([1,0,5,12,161]),function(ie,e,h,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rcb=void 0;class O{constructor(){this.f=new Map,this.k=[],this.m=new h.$Ld,this.n=new h.$Ld,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(u){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=u}onEvent(u){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=u}onRequest(u){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=u}sendResponse(u){u.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${u.command}`)):this.s("response",u)}sendRequest(u,D,d,A){const k={command:u};if(D&&Object.keys(D).length>0&&(k.arguments=D),this.s("request",k),typeof A=="number"){const a=setTimeout(()=>{clearTimeout(a);const w=this.f.get(k.seq);if(w){this.f.delete(k.seq);const m={type:"response",seq:0,request_seq:k.seq,success:!1,command:u,message:(0,I.localize)(0,null,A,u)};w(m)}},A)}return d&&this.f.set(k.seq,d),k.seq}acceptMessage(u){this.j?this.j(u):(this.k.push(u),this.k.length===1&&this.q())}o(u,D){return u.type!=="event"||D.type!=="event"}async q(){let u;for(;this.k.length;){if((!u||this.o(this.k[0],u))&&await(0,C.$Rg)(0),u=this.k.shift(),!u)return;switch(u.type){case"event":this.i?.(u);break;case"request":this.g?.(u);break;case"response":{const D=u,d=this.f.get(D.request_seq);d&&(this.f.delete(D.request_seq),d(D));break}}}}s(u,D){D.type=u,D.seq=this.d++,this.sendMessage(D)}async u(){if(this.f.size===0)return Promise.resolve();const u=new Map;this.f.forEach((D,d)=>u.set(d,D)),await(0,C.$Rg)(500),u.forEach((D,d)=>{D({type:"response",seq:0,request_seq:d,success:!1,command:"canceled",message:"canceled"}),this.f.delete(d)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.$Rcb=O}),define(Ae[194],Re([1,0,162,32,4]),function(ie,e,h,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.$YG=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.$XG=e.MemoryRangeType=e.$WG=e.State=e.$VG=e.$UG=e.$TG=e.$SG=e.$RG=e.$QG=e.$PG=e.$OG=e.$NG=e.$MG=e.$LG=e.$KG=e.$JG=e.$IG=e.$HG=e.$GG=e.$FG=e.$EG=e.$DG=e.$CG=e.$BG=e.$AG=e.$zG=e.$yG=e.$xG=e.$wG=e.$vG=e.$uG=e.$tG=e.$sG=e.$rG=e.$qG=e.$pG=e.$oG=e.$nG=e.$mG=e.$lG=e.$kG=e.$jG=e.$iG=e.$hG=e.$gG=e.$fG=e.$eG=e.$dG=e.$cG=e.$bG=e.$aG=e.$_F=e.$$F=e.$0F=e.$9F=e.$8F=e.$7F=e.$6F=e.$5F=e.$4F=e.$3F=e.$2F=e.$1F=e.$ZF=e.$YF=e.$XF=e.$WF=e.$VF=e.$UF=void 0,e.$UF="workbench.view.debug",e.$VF="workbench.debug.variablesView",e.$WF="workbench.debug.watchExpressionsView",e.$XF="workbench.debug.callStackView",e.$YF="workbench.debug.loadedScriptsView",e.$ZF="workbench.debug.breakPointsView",e.$1F="workbench.debug.disassemblyView",e.$2F="workbench.panel.repl",e.$3F="workbench.panel.repl.view",e.$4F=new C.$3i("debugType",void 0,{type:"string",description:h.localize(0,null)}),e.$5F=new C.$3i("debugConfigurationType",void 0,{type:"string",description:h.localize(1,null)}),e.$6F=new C.$3i("debugState","inactive",{type:"string",description:h.localize(2,null)}),e.$7F="debugUx",e.$8F=new C.$3i(e.$7F,"default",{type:"string",description:h.localize(3,null)}),e.$9F=new C.$3i("hasDebugged",!1,{type:"boolean",description:h.localize(4,null)}),e.$0F=new C.$3i("inDebugMode",!1,{type:"boolean",description:h.localize(5,null)}),e.$$F=new C.$3i("inDebugRepl",!1,{type:"boolean",description:h.localize(6,null)}),e.$_F=new C.$3i("breakpointWidgetVisible",!1,{type:"boolean",description:h.localize(7,null)}),e.$aG=new C.$3i("inBreakpointWidget",!1,{type:"boolean",description:h.localize(8,null)}),e.$bG=new C.$3i("breakpointsFocused",!0,{type:"boolean",description:h.localize(9,null)}),e.$cG=new C.$3i("watchExpressionsFocused",!0,{type:"boolean",description:h.localize(10,null)}),e.$dG=new C.$3i("watchExpressionsExist",!1,{type:"boolean",description:h.localize(11,null)}),e.$eG=new C.$3i("variablesFocused",!0,{type:"boolean",description:h.localize(12,null)}),e.$fG=new C.$3i("expressionSelected",!1,{type:"boolean",description:h.localize(13,null)}),e.$gG=new C.$3i("breakpointInputFocused",!1,{type:"boolean",description:h.localize(14,null)}),e.$hG=new C.$3i("callStackItemType",void 0,{type:"string",description:h.localize(15,null)}),e.$iG=new C.$3i("callStackSessionIsAttach",!1,{type:"boolean",description:h.localize(16,null)}),e.$jG=new C.$3i("callStackItemStopped",!1,{type:"boolean",description:h.localize(17,null)}),e.$kG=new C.$3i("callStackSessionHasOneThread",!1,{type:"boolean",description:h.localize(18,null)}),e.$lG=new C.$3i("watchItemType",void 0,{type:"string",description:h.localize(19,null)}),e.$mG=new C.$3i("canViewMemory",void 0,{type:"boolean",description:h.localize(20,null)}),e.$nG=new C.$3i("breakpointItemType",void 0,{type:"string",description:h.localize(21,null)}),e.$oG=new C.$3i("breakpointSupportsCondition",!1,{type:"boolean",description:h.localize(22,null)}),e.$pG=new C.$3i("loadedScriptsSupported",!1,{type:"boolean",description:h.localize(23,null)}),e.$qG=new C.$3i("loadedScriptsItemType",void 0,{type:"string",description:h.localize(24,null)}),e.$rG=new C.$3i("focusedSessionIsAttach",!1,{type:"boolean",description:h.localize(25,null)}),e.$sG=new C.$3i("stepBackSupported",!1,{type:"boolean",description:h.localize(26,null)}),e.$tG=new C.$3i("restartFrameSupported",!1,{type:"boolean",description:h.localize(27,null)}),e.$uG=new C.$3i("stackFrameSupportsRestart",!1,{type:"boolean",description:h.localize(28,null)}),e.$vG=new C.$3i("jumpToCursorSupported",!1,{type:"boolean",description:h.localize(29,null)}),e.$wG=new C.$3i("stepIntoTargetsSupported",!1,{type:"boolean",description:h.localize(30,null)}),e.$xG=new C.$3i("breakpointsExist",!1,{type:"boolean",description:h.localize(31,null)}),e.$yG=new C.$3i("debuggersAvailable",!1,{type:"boolean",description:h.localize(32,null)}),e.$zG=new C.$3i("debugExtensionAvailable",!0,{type:"boolean",description:h.localize(33,null)}),e.$AG=new C.$3i("debugProtocolVariableMenuContext",void 0,{type:"string",description:h.localize(34,null)}),e.$BG=new C.$3i("debugSetVariableSupported",!1,{type:"boolean",description:h.localize(35,null)}),e.$CG=new C.$3i("debugSetExpressionSupported",!1,{type:"boolean",description:h.localize(36,null)}),e.$DG=new C.$3i("breakWhenValueChangesSupported",!1,{type:"boolean",description:h.localize(37,null)}),e.$EG=new C.$3i("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:h.localize(38,null)}),e.$FG=new C.$3i("breakWhenValueIsReadSupported",!1,{type:"boolean",description:h.localize(39,null)}),e.$GG=new C.$3i("terminateDebuggeeSupported",!1,{type:"boolean",description:h.localize(40,null)}),e.$HG=new C.$3i("suspendDebuggeeSupported",!1,{type:"boolean",description:h.localize(41,null)}),e.$IG=new C.$3i("variableEvaluateNamePresent",!1,{type:"boolean",description:h.localize(42,null)}),e.$JG=new C.$3i("variableIsReadonly",!1,{type:"boolean",description:h.localize(43,null)}),e.$KG=new C.$3i("exceptionWidgetVisible",!1,{type:"boolean",description:h.localize(44,null)}),e.$LG=new C.$3i("multiSessionRepl",!1,{type:"boolean",description:h.localize(45,null)}),e.$MG=new C.$3i("multiSessionDebug",!1,{type:"boolean",description:h.localize(46,null)}),e.$NG=new C.$3i("disassembleRequestSupported",!1,{type:"boolean",description:h.localize(47,null)}),e.$OG=new C.$3i("disassemblyViewFocus",!1,{type:"boolean",description:h.localize(48,null)}),e.$PG=new C.$3i("languageSupportsDisassembleRequest",!1,{type:"boolean",description:h.localize(49,null)}),e.$QG=new C.$3i("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:h.localize(50,null)});const O=a=>h.localize(51,null,a);e.$RG=O,e.$SG="editor.contrib.debug",e.$TG="editor.contrib.breakpoint",e.$UG="debug",e.$VG={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:h.localize(52,null)};var R;(function(a){a[a.Inactive=0]="Inactive",a[a.Initializing=1]="Initializing",a[a.Stopped=2]="Stopped",a[a.Running=3]="Running"})(R||(e.State=R={}));function u(a){switch(a){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.$WG=u;var D;(function(a){a[a.Valid=0]="Valid",a[a.Unreadable=1]="Unreadable",a[a.Error=2]="Error"})(D||(e.MemoryRangeType=D={})),e.$XG="vscode-debug-memory";var d;(function(a){a[a.Initial=1]="Initial",a[a.Dynamic=2]="Dynamic"})(d||(e.DebugConfigurationProviderTriggerKind=d={}));var A;(function(a){a.UnverifiedBreakpoints="unverifiedBreakpoints"})(A||(e.DebuggerString=A={})),e.$YG=(0,I.$Lh)("debugService");var k;(function(a){a[a.CONDITION=0]="CONDITION",a[a.HIT_COUNT=1]="HIT_COUNT",a[a.LOG_MESSAGE=2]="LOG_MESSAGE"})(k||(e.BreakpointWidgetContext=k={}))}),define(Ae[195],Re([1,0,15,2,19,24,13,44,21,18]),function(ie,e,h,C,I,O,R,u,D,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vF=e.$uF=e.$tF=e.$sF=e.$rF=e.$qF=e.$pF=e.$oF=e.$nF=e.$mF=e.$lF=e.$kF=e.$jF=void 0;const A=/{([^}]+)}/g;function k(P,l,$){return P.replace(A,function(b,M){return l&&M.length>0&&M[0]!=="_"?b:$&&$.hasOwnProperty(M)?$[M]:b})}e.$jF=k;function a(P){const l={};for(const $ of Object.keys(P))$.startsWith("!")||(l[$]=P[$]);return l}e.$kF=a;function w(P){return P.configuration.request==="attach"&&!m(P)&&(!P.parentSession||w(P.parentSession))}e.$lF=w;function m(P){let l=P.configuration.type;if(l)return l==="vslsShare"&&(l=P.configuration.adapterProxy.configuration.type),(0,h.$Ze)(l,"extensionhost")||(0,h.$Ze)(l,"pwa-extensionhost")?P:P.parentSession?m(P.parentSession):void 0}e.$mF=m;function f(P){return P.type&&(P.label||P.program||P.runtime)}e.$nF=f;function t(P,l,$){let b,M=0;const U=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let F=null;for(;F=U.exec(P);){const q=F.index+1,W=q+F[0].length;if(q<=l&&W>=$){b=F[0],M=q;break}}if(b){const q=/\w+/g;let W=null;for(;(W=q.exec(b))&&!(W.index+1+M+W[0].length>=$););W&&(b=b.substring(0,q.lastIndex))}return b?{start:M,end:M+b.length-1}:{start:0,end:0}}e.$oF=t;async function s(P,l,$,b){if(P.evaluatableExpressionProvider.has(l)){const M=P.evaluatableExpressionProvider.ordered(l),U=(0,d.$Fb)(await Promise.all(M.map(async F=>{try{return await F.provideEvaluatableExpression(l,$,b??D.CancellationToken.None)}catch{return}})));if(U.length>0){let F=U[0].expression;const q=U[0].range;return F||(F=l.getLineContent($.lineNumber).substring(q.startColumn-1,q.endColumn-1)),{range:q,matchingExpression:F}}}else{const M=l.getLineContent($.lineNumber),{start:U,end:F}=t(M,$.column,$.column),q=M.substring(U-1,F);return{matchingExpression:q,range:new u.$ms($.lineNumber,U,$.lineNumber,U+q.length)}}return null}e.$pF=s;const c=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function v(P){return!!(P&&P.match(c))}e.$qF=v;function S(P){if(typeof P.path=="string"&&!(typeof P.sourceReference=="number"&&P.sourceReference>0)){if(v(P.path))return C.URI.parse(P.path);if((0,I.$gc)(P.path))return C.URI.file(P.path)}return P.path}function p(P){if(typeof P.path=="object"){const l=C.URI.revive(P.path);if(l)return l.scheme===R.Schemas.file?l.fsPath:l.toString()}return P.path}function n(P,l){const $=l?S:p,b=(0,O.$Xm)(P);return i(b,(M,U)=>{M&&U&&(U.path=$(U))}),b}e.$rF=n;function r(P,l){const $=l?S:p,b=(0,O.$Xm)(P);return i(b,(M,U)=>{!M&&U&&(U.path=$(U))}),b}e.$sF=r;function i(P,l){switch(P.type){case"event":{const $=P;switch($.event){case"output":l(!1,$.body.source);break;case"loadedSource":l(!1,$.body.source);break;case"breakpoint":l(!1,$.body.breakpoint.source);break;default:break}break}case"request":{const $=P;switch($.command){case"setBreakpoints":l(!0,$.arguments.source);break;case"breakpointLocations":l(!0,$.arguments.source);break;case"source":l(!0,$.arguments.source);break;case"gotoTargets":l(!0,$.arguments.source);break;case"launchVSCode":$.arguments.args.forEach(b=>l(!1,b));break;default:break}break}case"response":{const $=P;if($.success&&$.body)switch($.command){case"stackTrace":$.body.stackFrames.forEach(b=>l(!1,b.source));break;case"loadedSources":$.body.sources.forEach(b=>l(!1,b));break;case"scopes":$.body.scopes.forEach(b=>l(!1,b.source));break;case"setFunctionBreakpoints":$.body.breakpoints.forEach(b=>l(!1,b.source));break;case"setBreakpoints":$.body.breakpoints.forEach(b=>l(!1,b.source));break;case"disassemble":$.body?.instructions.forEach(M=>l(!1,M.location));break;default:break}break}}}function o(P){return P.filter(l=>!l.presentation?.hidden).sort((l,$)=>l.presentation?$.presentation?l.presentation.group?$.presentation.group?l.presentation.group!==$.presentation.group?l.presentation.group.localeCompare($.presentation.group):y(l.presentation.order,$.presentation.order):-1:$.presentation.group?1:y(l.presentation.order,$.presentation.order):-1:$.presentation?1:0)}e.$tF=o;function y(P,l){return typeof P!="number"?typeof l!="number"?0:1:typeof l!="number"?-1:P-l}async function g(P,l){const $=P.getValue("debug.saveBeforeStart",{overrideIdentifier:l.activeTextEditorLanguageId});if($!=="none"&&(await l.saveAll(),$==="allEditorsInActiveGroup")){const b=l.activeEditorPane;b&&b.input.resource?.scheme===R.Schemas.untitled&&await l.save({editor:b.input,groupId:b.group.id})}await P.reloadConfiguration()}e.$uF=g;const E=(P,l)=>!P||!l?P===l:P.name===l.name&&P.path===l.path&&P.sourceReference===l.sourceReference;e.$vF=E}),define(Ae[75],Re([1,0,25,36,69,67,13,19,22,32]),function(ie,e,h,C,I,O,R,u,D,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kI=e.$jI=e.$iI=e.$hI=e.CellStatusbarAlignment=e.$gI=e.$fI=e.$eI=e.NotebookEditorPriority=e.$dI=e.$cI=e.$bI=e.$aI=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$_H=e.$$H=e.$0H=e.$9H=e.CellKind=e.$8H=e.$7H=e.$6H=void 0,e.$6H="workbench.editor.notebook",e.$7H="workbench.editor.notebookTextDiffEditor",e.$8H="workbench.editor.interactive";var A;(function(z){z[z.Markup=1]="Markup",z[z.Code=2]="Code"})(A||(e.CellKind=A={})),e.$9H=["application/json","application/javascript","text/html","image/svg+xml",O.$Jr.latex,O.$Jr.markdown,"image/png","image/jpeg",O.$Jr.text],e.$0H=[O.$Jr.latex,O.$Jr.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",O.$Jr.text],e.$$H=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$_H="_notAvailable";var k;(function(z){z[z.Running=1]="Running",z[z.Idle=2]="Idle"})(k||(e.NotebookRunState=k={}));var a;(function(z){z[z.Unconfirmed=1]="Unconfirmed",z[z.Pending=2]="Pending",z[z.Executing=3]="Executing"})(a||(e.NotebookCellExecutionState=a={}));var w;(function(z){z[z.Unconfirmed=1]="Unconfirmed",z[z.Pending=2]="Pending",z[z.Executing=3]="Executing"})(w||(e.NotebookExecutionState=w={}));var m;(function(z){z[z.WithHardKernelDependency=0]="WithHardKernelDependency",z[z.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",z[z.Pure=2]="Pure",z[z.Never=3]="Never"})(m||(e.NotebookRendererMatch=m={}));var f;(function(z){z.Always="always",z.Never="never",z.Optional="optional"})(f||(e.RendererMessagingSpec=f={}));var t;(function(z){z[z.ModelChange=1]="ModelChange",z[z.Move=2]="Move",z[z.ChangeCellLanguage=5]="ChangeCellLanguage",z[z.Initialize=6]="Initialize",z[z.ChangeCellMetadata=7]="ChangeCellMetadata",z[z.Output=8]="Output",z[z.OutputItem=9]="OutputItem",z[z.ChangeCellContent=10]="ChangeCellContent",z[z.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",z[z.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",z[z.ChangeCellMime=13]="ChangeCellMime",z[z.Unknown=100]="Unknown"})(t||(e.NotebookCellsChangeType=t={}));var s;(function(z){z[z.Handle=0]="Handle",z[z.Index=1]="Index"})(s||(e.SelectionStateType=s={}));var c;(function(z){z[z.Replace=1]="Replace",z[z.Output=2]="Output",z[z.Metadata=3]="Metadata",z[z.CellLanguage=4]="CellLanguage",z[z.DocumentMetadata=5]="DocumentMetadata",z[z.Move=6]="Move",z[z.OutputItems=7]="OutputItems",z[z.PartialMetadata=8]="PartialMetadata",z[z.PartialInternalMetadata=9]="PartialInternalMetadata"})(c||(e.CellEditType=c={}));var v;(function(z){z.scheme=R.Schemas.vscodeNotebookCell;const K=["W","X","Y","Z","a","b","c","d","e","f"],B=new RegExp(`^[${K.join("")}]+`),me=7;function ye(ve,ke){const V=ke.toString(me),ee=`${V.length<K.length?K[V.length-1]:"z"}${V}s${(0,h.$te)(h.$_d.fromString(ve.scheme),!0,!0)}`;return ve.with({scheme:z.scheme,fragment:ee})}z.generate=ye;function Ie(ve){if(ve.scheme!==z.scheme)return;const ke=ve.fragment.indexOf("s");if(ke<0)return;const V=parseInt(ve.fragment.substring(0,ke).replace(B,""),me),Q=(0,h.$se)(ve.fragment.substring(ke+1)).toString();if(!isNaN(V))return{handle:V,notebook:ve.with({scheme:Q,fragment:null})}}z.parse=Ie;function _(ve,ke){return ve.with({scheme:R.Schemas.vscodeNotebookCellOutput,fragment:`op${ke??""},${ve.scheme!==R.Schemas.file?ve.scheme:""}`})}z.generateCellOutputUri=_;function de(ve){if(ve.scheme!==R.Schemas.vscodeNotebookCellOutput)return;const ke=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(ve.fragment);if(!ke)return;const V=ke[1]&&ke[1]!==""?ke[1]:void 0,Q=ke[2];return{outputId:V,notebook:ve.with({scheme:Q||R.Schemas.file,fragment:null})}}z.parseCellOutputUri=de;function De(ve,ke,V){return z.generate(ve,ke).with({scheme:V})}z.generateCellPropertyUri=De;function ue(ve,ke){if(ve.scheme===ke)return z.parse(ve.with({scheme:z.scheme}))}z.parseCellPropertyUri=ue})(v||(e.CellUri=v={}));const S=z=>D.$d?z.replace(/\//g,"\\"):z;class p{constructor(K=[],B=e.$9H){this.e=B,this.d=[...new Set(K)].map(me=>({pattern:me,matches:C.$sj(S(me))}))}sort(K){const B=new Map(I.Iterable.map(K,ye=>[ye,S(ye)]));let me=[];for(const{matches:ye}of this.d)for(const[Ie,_]of B)if(ye(_)){me.push(Ie),B.delete(Ie);break}return B.size&&(me=me.concat([...B.keys()].sort((ye,Ie)=>this.e.indexOf(ye)-this.e.indexOf(Ie)))),me}prioritize(K,B){const me=this.f(K);if(me===-1){this.d.unshift({pattern:K,matches:C.$sj(S(K))});return}const ye=new Set(B.map(_=>this.f(_,me)));ye.delete(-1);const Ie=Array.from(ye).sort();this.d.splice(me+1,0,...Ie.map(_=>this.d[_]));for(let _=Ie.length-1;_>=0;_--)this.d.splice(Ie[_],1)}toArray(){return this.d.map(K=>K.pattern)}f(K,B=this.d.length){const me=S(K);for(let ye=0;ye<B;ye++)if(this.d[ye].matches(me))return ye;return-1}}e.$aI=p;function n(z,K,B,me=(ye,Ie)=>ye===Ie){const ye=[];function Ie(De,ue,ve){if(ue===0&&ve.length===0)return;const ke=ye[ye.length-1];ke&&ke.start+ke.deleteCount===De?(ke.deleteCount+=ue,ke.toInsert.push(...ve)):ye.push({start:De,deleteCount:ue,toInsert:ve})}let _=0,de=0;for(;;){if(_===z.length){Ie(_,0,K.slice(de));break}if(de===K.length){Ie(_,z.length-_,[]);break}const De=z[_],ue=K[de];if(me(De,ue)){_+=1,de+=1;continue}B(ue)?(Ie(_,1,[]),_+=1):(Ie(_,0,[ue]),de+=1)}return ye}e.$bI=n,e.$cI=new d.$3i("notebookEditorCursorAtBoundary","none"),e.$dI=new d.$3i("notebookEditorCursorAtLineBoundary","none");var r;(function(z){z.default="default",z.option="option"})(r||(e.NotebookEditorPriority=r={}));function i(z){const K=z;return!!((typeof K.include=="string"||C.$tj(K.include))&&(typeof K.exclude=="string"||C.$tj(K.exclude)))}e.$eI=i;function o(z,K,B){if(Array.isArray(z.viewType)&&z.viewType.indexOf(K)>=0||z.viewType===K)return!0;if(z.filenamePattern){const me=i(z.filenamePattern)?z.filenamePattern.include:z.filenamePattern,ye=i(z.filenamePattern)?z.filenamePattern.exclude:void 0;if(C.$rj(me,(0,u.$lc)(B.fsPath).toLowerCase()))return!(ye&&C.$rj(ye,(0,u.$lc)(B.fsPath).toLowerCase()))}return!1}e.$fI=o,e.$gI={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScroll:"notebook.stickyScroll.enabled",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",formatOnSave:"notebook.formatOnSave.enabled",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell"};var y;(function(z){z[z.Left=1]="Left",z[z.Right=2]="Right"})(y||(e.CellStatusbarAlignment=y={}));class g{static create(K){return`${g.d}${K}`}static parse(K){if(K.startsWith(g.d))return K.substring(g.d.length)}}e.$hI=g,g.d="notebook/";function E(z){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(z)}e.$iI=E;const P=new TextDecoder;function l(z){const K=[];let B=!1;for(const _ of z)(K.length===0||B)&&(K.push(_),B=!0);let me=M(K);const ye=h.$_d.concat(K.map(_=>h.$_d.wrap(_))),Ie=L(ye);return me=me||Ie.byteLength!==ye.byteLength,{data:Ie,didCompression:me}}e.$jI=l,e.$kI=`${String.fromCharCode(27)}[A`;const $=e.$kI.split("").map(z=>z.charCodeAt(0)),b=10;function M(z){let K=!1;return z.forEach((B,me)=>{if(me===0||B.length<e.$kI.length)return;const ye=z[me-1],Ie=B.subarray(0,e.$kI.length);if(Ie[0]===$[0]&&Ie[1]===$[1]&&Ie[2]===$[2]){const _=ye.lastIndexOf(b);if(_===-1)return;K=!0,z[me-1]=ye.subarray(0,_),z[me]=B.subarray(e.$kI.length)}}),K}function U(z){let K=z;do z=K,K=z.replace(/[^\n]\x08/gm,"");while(K.length<z.length);return z}function F(z){for(z=z.replace(/\r+\n/gm,`
`);z.search(/\r[^$]/g)>-1;){const K=z.match(/^(.*)\r+/m)[1];let B=z.match(/\r+(.*)$/m)[1];B=B+K.slice(B.length,K.length),z=z.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,B)}return z}const q="\b".charCodeAt(0),W="\r".charCodeAt(0);function L(z){return!z.buffer.includes(q)&&!z.buffer.includes(W)?z:h.$_d.fromString(F(U(P.decode(z.buffer))))}});var Ye=this&&this.__classPrivateFieldSet||function(ie,e,h,C,I){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!I:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?I.call(ie,h):I?I.value=h:e.set(ie,h),h},Ne=this&&this.__classPrivateFieldGet||function(ie,e,h,C){if(h==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!C:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?C:h==="a"?C.call(ie):C?C.value:e.get(ie)};define(Ae[7],Re([1,0,18,9,49,28,67,15,16,2,37,20,38,97,75]),function(ie,e,h,C,I,O,R,u,D,d,A,k,a,w,m){"use strict";var f,t,s,c,v,S,p,n,r,i,o,y,g,E,P,l,$,b,M,U,F,q,W,L,z,K;Object.defineProperty(e,"__esModule",{value:!0}),e.RelatedInformationType=e.$YL=e.ChatVariableLevel=e.ChatMessageRole=e.InteractiveEditorResponseFeedbackKind=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.$XL=e.$WL=e.$VL=e.$UL=e.$TL=e.$SL=e.$RL=e.$QL=e.$PL=e.$OL=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$NL=e.$ML=e.$LL=e.$KL=e.$JL=e.$IL=e.$HL=e.$GL=e.TestRunProfileKind=e.TestResultState=e.$FL=e.$EL=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$DL=e.$CL=e.$BL=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$AL=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$zL=e.$yL=e.$xL=e.$wL=e.$vL=e.ColorThemeKind=e.$uL=e.$tL=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$sL=e.DebugConsoleMode=e.$rL=e.$qL=e.$pL=e.$oL=e.$nL=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$mL=e.$lL=e.FileChangeType=e.$kL=e.$jL=e.$iL=e.$hL=e.InlineCompletionTriggerKind=e.$gL=e.$fL=e.$eL=e.$dL=e.$cL=e.$bL=e.$aL=e.$_K=e.$$K=e.$0K=e.$9K=e.$8K=e.$7K=e.ConfigurationTarget=e.$6K=e.$5K=e.$4K=e.$3K=e.$2K=e.$1K=e.$ZK=e.$YK=e.$XK=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$WK=e.ViewBadge=e.ProgressLocation=e.$VK=e.$UK=e.TaskScope=e.ShellQuoting=e.$TK=e.$SK=e.$RK=e.TaskPanelKind=e.TaskRevealKind=e.$QK=e.TerminalLocation=e.$PK=e.$OK=e.$NK=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$MK=e.$LK=e.$KK=e.$JK=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.$IK=e.StatusBarAlignment=e.ViewColumn=e.$HK=e.$GK=e.$FK=e.$EK=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$DK=e.$CK=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$BK=e.$AK=e.$zK=e.$yK=e.$xK=e.LanguageStatusSeverity=e.$wK=e.$vK=e.$uK=e.$tK=e.$sK=e.$rK=e.CodeActionTriggerKind=e.$qK=e.$pK=e.SymbolTag=e.SymbolKind=e.$oK=e.DocumentHighlightKind=e.$nK=e.$mK=e.$lK=e.$kK=e.DiagnosticSeverity=e.DiagnosticTag=e.$jK=e.$iK=e.FileEditType=e.$hK=e.$gK=e.$fK=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$eK=e.$dK=e.$cK=e.$bK=e.$aK=e.$_J=e.$$J=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function B(j){return Object.assign(j,{apply:function(...ce){if(ce.length===0)return Reflect.construct(j,[]);{const Se=ce.length===1?[]:ce[1];return Reflect.construct(j,Se,ce[0].constructor)}},call:function(...ce){if(ce.length===0)return Reflect.construct(j,[]);{const[Se,...Ge]=ce;return Reflect.construct(j,Ge,Se.constructor)}}})}var me;(function(j){j[j.Top=0]="Top",j[j.Bottom=1]="Bottom"})(me||(e.TerminalOutputAnchor=me={}));var ye;(function(j){j[j.TerminalCommand=0]="TerminalCommand",j[j.Opener=1]="Opener",j[j.Command=3]="Command"})(ye||(e.TerminalQuickFixType=ye={}));let Ie=r=class{static from(...N){let ce=N;return new r(function(){if(ce){for(const Se of ce)Se&&typeof Se.dispose=="function"&&Se.dispose();ce=void 0}})}constructor(N){f.set(this,void 0),Ye(this,f,N,"f")}dispose(){typeof Ne(this,f,"f")=="function"&&(Ne(this,f,"f").call(this),Ye(this,f,void 0,"f"))}};e.$$J=Ie,f=new WeakMap,e.$$J=Ie=r=Je([B],Ie);let _=i=class{static Min(...N){if(N.length===0)throw new TypeError;let ce=N[0];for(let Se=1;Se<N.length;Se++){const Ge=N[Se];Ge.isBefore(ce)&&(ce=Ge)}return ce}static Max(...N){if(N.length===0)throw new TypeError;let ce=N[0];for(let Se=1;Se<N.length;Se++){const Ge=N[Se];Ge.isAfter(ce)&&(ce=Ge)}return ce}static isPosition(N){if(!N)return!1;if(N instanceof i)return!0;const{line:ce,character:Se}=N;return typeof ce=="number"&&typeof Se=="number"}static of(N){if(N instanceof i)return N;if(this.isPosition(N))return new i(N.line,N.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(N,ce){if(N<0)throw(0,C.$5)("line must be non-negative");if(ce<0)throw(0,C.$5)("character must be non-negative");this.c=N,this.e=ce}isBefore(N){return this.c<N.c?!0:N.c<this.c?!1:this.e<N.e}isBeforeOrEqual(N){return this.c<N.c?!0:N.c<this.c?!1:this.e<=N.e}isAfter(N){return!this.isBeforeOrEqual(N)}isAfterOrEqual(N){return!this.isBefore(N)}isEqual(N){return this.c===N.c&&this.e===N.e}compareTo(N){return this.c<N.c?-1:this.c>N.line?1:this.e<N.e?-1:this.e>N.e?1:0}translate(N,ce=0){if(N===null||ce===null)throw(0,C.$5)();let Se;return typeof N>"u"?Se=0:typeof N=="number"?Se=N:(Se=typeof N.lineDelta=="number"?N.lineDelta:0,ce=typeof N.characterDelta=="number"?N.characterDelta:0),Se===0&&ce===0?this:new i(this.line+Se,this.character+ce)}with(N,ce=this.character){if(N===null||ce===null)throw(0,C.$5)();let Se;return typeof N>"u"?Se=this.line:typeof N=="number"?Se=N:(Se=typeof N.line=="number"?N.line:this.line,ce=typeof N.character=="number"?N.character:this.character),Se===this.line&&ce===this.character?this:new i(Se,ce)}toJSON(){return{line:this.line,character:this.character}}};e.$_J=_,e.$_J=_=i=Je([B],_);let de=o=class{static isRange(N){return N instanceof o?!0:N?_.isPosition(N.start)&&_.isPosition(N.end):!1}static of(N){if(N instanceof o)return N;if(this.isRange(N))return new o(N.start,N.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(N,ce,Se,Ge){let _e,lt;if(typeof N=="number"&&typeof ce=="number"&&typeof Se=="number"&&typeof Ge=="number"?(_e=new _(N,ce),lt=new _(Se,Ge)):_.isPosition(N)&&_.isPosition(ce)&&(_e=_.of(N),lt=_.of(ce)),!_e||!lt)throw new Error("Invalid arguments");_e.isBefore(lt)?(this.c=_e,this.e=lt):(this.c=lt,this.e=_e)}contains(N){return o.isRange(N)?this.contains(N.start)&&this.contains(N.end):_.isPosition(N)?!(_.of(N).isBefore(this.c)||this.e.isBefore(N)):!1}isEqual(N){return this.c.isEqual(N.c)&&this.e.isEqual(N.e)}intersection(N){const ce=_.Max(N.start,this.c),Se=_.Min(N.end,this.e);if(!ce.isAfter(Se))return new o(ce,Se)}union(N){if(this.contains(N))return this;if(N.contains(this))return N;const ce=_.Min(N.start,this.c),Se=_.Max(N.end,this.end);return new o(ce,Se)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(N,ce=this.end){if(N===null||ce===null)throw(0,C.$5)();let Se;return N?_.isPosition(N)?Se=N:(Se=N.start||this.start,ce=N.end||this.end):Se=this.start,Se.isEqual(this.c)&&ce.isEqual(this.end)?this:new o(Se,ce)}toJSON(){return[this.start,this.end]}};e.$aK=de,e.$aK=de=o=Je([B],de);let De=y=class extends de{static isSelection(N){return N instanceof y?!0:N?de.isRange(N)&&_.isPosition(N.anchor)&&_.isPosition(N.active)&&typeof N.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(N,ce,Se,Ge){let _e,lt;if(typeof N=="number"&&typeof ce=="number"&&typeof Se=="number"&&typeof Ge=="number"?(_e=new _(N,ce),lt=new _(Se,Ge)):_.isPosition(N)&&_.isPosition(ce)&&(_e=_.of(N),lt=_.of(ce)),!_e||!lt)throw new Error("Invalid arguments");super(_e,lt),this.f=_e,this.g=lt}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$bK=De,e.$bK=De=y=Je([B],De);const ue=j=>{if(typeof j!="string"||j.length===0||!/^[0-9A-Za-z_\-]+$/.test(j))throw(0,C.$5)("connectionToken")};class ve{static isResolvedAuthority(N){return N&&typeof N=="object"&&typeof N.host=="string"&&typeof N.port=="number"&&(N.connectionToken===void 0||typeof N.connectionToken=="string")}constructor(N,ce,Se){if(typeof N!="string"||N.length===0)throw(0,C.$5)("host");if(typeof ce!="number"||ce===0||Math.round(ce)!==ce)throw(0,C.$5)("port");typeof Se<"u"&&ue(Se),this.host=N,this.port=Math.round(ce),this.connectionToken=Se}}e.$cK=ve;class ke{static isManagedResolvedAuthority(N){return N&&typeof N=="object"&&typeof N.makeConnection=="function"&&(N.connectionToken===void 0||typeof N.connectionToken=="string")}constructor(N,ce){this.makeConnection=N,this.connectionToken=ce,typeof ce<"u"&&ue(ce)}}e.$dK=ke;class V extends Error{static NotAvailable(N,ce){return new V(N,w.RemoteAuthorityResolverErrorCode.NotAvailable,ce)}static TemporarilyNotAvailable(N){return new V(N,w.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(N,ce=w.RemoteAuthorityResolverErrorCode.Unknown,Se){super(N),this._message=N,this._code=ce,this._detail=Se,Object.setPrototypeOf(this,V.prototype)}}e.$eK=V;var Q;(function(j){j[j.LF=1]="LF",j[j.CRLF=2]="CRLF"})(Q||(e.EndOfLine=Q={}));var ee;(function(j){j[j.Replace=1]="Replace",j[j.Append=2]="Append",j[j.Prepend=3]="Prepend"})(ee||(e.EnvironmentVariableMutatorType=ee={}));let $e=g=class{static isTextEdit(N){return N instanceof g?!0:N?de.isRange(N)&&typeof N.newText=="string":!1}static replace(N,ce){return new g(N,ce)}static insert(N,ce){return g.replace(new de(N,N),ce)}static delete(N){return g.replace(N,"")}static setEndOfLine(N){const ce=new g(new de(new _(0,0),new _(0,0)),"");return ce.newEol=N,ce}get range(){return this.c}set range(N){if(N&&!de.isRange(N))throw(0,C.$5)("range");this.c=N}get newText(){return this.e||""}set newText(N){if(N&&typeof N!="string")throw(0,C.$5)("newText");this.e=N}get newEol(){return this.f}set newEol(N){if(N&&typeof N!="number")throw(0,C.$5)("newEol");this.f=N}constructor(N,ce){this.c=N,this.e=ce}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$fK=$e,e.$fK=$e=g=Je([B],$e);let he=E=class{static isNotebookCellEdit(N){return N instanceof E?!0:N?Oe.isNotebookRange(N)&&Array.isArray(N.newCells):!1}static replaceCells(N,ce){return new E(N,ce)}static insertCells(N,ce){return new E(new Oe(N,N),ce)}static deleteCells(N){return new E(N,[])}static updateCellMetadata(N,ce){const Se=new E(new Oe(N,N),[]);return Se.newCellMetadata=ce,Se}static updateNotebookMetadata(N){const ce=new E(new Oe(0,0),[]);return ce.newNotebookMetadata=N,ce}constructor(N,ce){this.range=N,this.newCells=ce}};e.$gK=he,e.$gK=he=E=Je([B],he);class fe{static isSnippetTextEdit(N){return N instanceof fe?!0:N?de.isRange(N.range)&&le.isSnippetString(N.snippet):!1}static replace(N,ce){return new fe(N,ce)}static insert(N,ce){return fe.replace(new de(N,N),ce)}constructor(N,ce){this.range=N,this.snippet=ce}}e.$hK=fe;var Ee;(function(j){j[j.File=1]="File",j[j.Text=2]="Text",j[j.Cell=3]="Cell",j[j.CellReplace=5]="CellReplace",j[j.Snippet=6]="Snippet"})(Ee||(e.FileEditType=Ee={}));let re=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(N,ce,Se,Ge){this.c.push({_type:1,from:N,to:ce,options:Se,metadata:Ge})}createFile(N,ce,Se){this.c.push({_type:1,from:void 0,to:N,options:ce,metadata:Se})}deleteFile(N,ce,Se){this.c.push({_type:1,from:N,to:void 0,options:ce,metadata:Se})}e(N,ce,Se){this.c.push({_type:3,metadata:Se,uri:N,edit:{editType:5,metadata:ce},notebookMetadata:ce})}f(N,ce,Se,Ge){const _e=ce.start,lt=ce.end;(_e!==lt||Se.length>0)&&this.c.push({_type:5,uri:N,index:_e,count:lt-_e,cells:Se,metadata:Ge})}g(N,ce,Se,Ge){this.c.push({_type:3,metadata:Ge,uri:N,edit:{editType:3,index:ce,metadata:Se}})}replace(N,ce,Se,Ge){this.c.push({_type:2,uri:N,edit:new $e(ce,Se),metadata:Ge})}insert(N,ce,Se,Ge){this.replace(N,new de(ce,ce),Se,Ge)}delete(N,ce,Se){this.replace(N,ce,"",Se)}has(N){return this.c.some(ce=>ce._type===2&&ce.uri.toString()===N.toString())}set(N,ce){if(ce)for(const Se of ce){if(!Se)continue;let Ge,_e;Array.isArray(Se)?(Ge=Se[0],_e=Se[1]):Ge=Se,he.isNotebookCellEdit(Ge)?Ge.newCellMetadata?this.g(N,Ge.range.start,Ge.newCellMetadata,_e):Ge.newNotebookMetadata?this.e(N,Ge.newNotebookMetadata,_e):this.f(N,Ge.range,Ge.newCells,_e):fe.isSnippetTextEdit(Ge)?this.c.push({_type:6,uri:N,range:Ge.range,edit:Ge.snippet,metadata:_e}):this.c.push({_type:2,uri:N,edit:Ge,metadata:_e})}else{for(let Se=0;Se<this.c.length;Se++){const Ge=this.c[Se];switch(Ge._type){case 2:case 6:case 3:case 5:Ge.uri.toString()===N.toString()&&(this.c[Se]=void 0);break}}(0,h.$Gb)(this.c)}}get(N){const ce=[];for(const Se of this.c)Se._type===2&&Se.uri.toString()===N.toString()&&ce.push(Se.edit);return ce}entries(){const N=new O.$yc;for(const ce of this.c)if(ce._type===2){let Se=N.get(ce.uri);Se||(Se=[ce.uri,[]],N.set(ce.uri,Se)),Se[1].push(ce.edit)}return[...N.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$iK=re,e.$iK=re=Je([B],re);let le=P=class{static isSnippetString(N){return N instanceof P?!0:N?typeof N.value=="string":!1}static c(N){return N.replace(/\$|}|\\/g,"\\$&")}constructor(N){this.e=1,this.value=N||""}appendText(N){return this.value+=P.c(N),this}appendTabstop(N=this.e++){return this.value+="$",this.value+=N,this}appendPlaceholder(N,ce=this.e++){if(typeof N=="function"){const Se=new P;Se.e=this.e,N(Se),this.e=Se.e,N=Se.value}else N=P.c(N);return this.value+="${",this.value+=ce,this.value+=":",this.value+=N,this.value+="}",this}appendChoice(N,ce=this.e++){const Se=N.map(Ge=>Ge.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ce,this.value+="|",this.value+=Se,this.value+="|}",this}appendVariable(N,ce){if(typeof ce=="function"){const Se=new P;Se.e=this.e,ce(Se),this.e=Se.e,ce=Se.value}else typeof ce=="string"&&(ce=ce.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=N,ce&&(this.value+=":",this.value+=ce),this.value+="}",this}};e.$jK=le,e.$jK=le=P=Je([B],le);var oe;(function(j){j[j.Unnecessary=1]="Unnecessary",j[j.Deprecated=2]="Deprecated"})(oe||(e.DiagnosticTag=oe={}));var ae;(function(j){j[j.Hint=3]="Hint",j[j.Information=2]="Information",j[j.Warning=1]="Warning",j[j.Error=0]="Error"})(ae||(e.DiagnosticSeverity=ae={}));let pe=l=class{static isLocation(N){return N instanceof l?!0:N?de.isRange(N.range)&&d.URI.isUri(N.uri):!1}constructor(N,ce){if(this.uri=N,ce)if(de.isRange(ce))this.range=de.of(ce);else if(_.isPosition(ce))this.range=new de(ce,ce);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$kK=pe,e.$kK=pe=l=Je([B],pe);let Ce=class{static is(N){return N?typeof N.message=="string"&&N.location&&de.isRange(N.location.range)&&d.URI.isUri(N.location.uri):!1}constructor(N,ce){this.location=N,this.message=ce}static isEqual(N,ce){return N===ce?!0:!N||!ce?!1:N.message===ce.message&&N.location.range.isEqual(ce.location.range)&&N.location.uri.toString()===ce.location.uri.toString()}};e.$lK=Ce,e.$lK=Ce=Je([B],Ce);let T=class{constructor(N,ce,Se=ae.Error){if(!de.isRange(N))throw new TypeError("range must be set");if(!ce)throw new TypeError("message must be set");this.range=N,this.message=ce,this.severity=Se}toJSON(){return{severity:ae[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(N,ce){return N===ce?!0:!N||!ce?!1:N.message===ce.message&&N.severity===ce.severity&&N.code===ce.code&&N.severity===ce.severity&&N.source===ce.source&&N.range.isEqual(ce.range)&&(0,h.$sb)(N.tags,ce.tags)&&(0,h.$sb)(N.relatedInformation,ce.relatedInformation,Ce.isEqual)}};e.$mK=T,e.$mK=T=Je([B],T);let H=class{constructor(N,ce){if(!N)throw new Error("Illegal argument, contents must be defined");Array.isArray(N)?this.contents=N:this.contents=[N],this.range=ce}};e.$nK=H,e.$nK=H=Je([B],H);var X;(function(j){j[j.Text=0]="Text",j[j.Read=1]="Read",j[j.Write=2]="Write"})(X||(e.DocumentHighlightKind=X={}));let Y=class{constructor(N,ce=X.Text){this.range=N,this.kind=ce}toJSON(){return{range:this.range,kind:X[this.kind]}}};e.$oK=Y,e.$oK=Y=Je([B],Y);var J;(function(j){j[j.File=0]="File",j[j.Module=1]="Module",j[j.Namespace=2]="Namespace",j[j.Package=3]="Package",j[j.Class=4]="Class",j[j.Method=5]="Method",j[j.Property=6]="Property",j[j.Field=7]="Field",j[j.Constructor=8]="Constructor",j[j.Enum=9]="Enum",j[j.Interface=10]="Interface",j[j.Function=11]="Function",j[j.Variable=12]="Variable",j[j.Constant=13]="Constant",j[j.String=14]="String",j[j.Number=15]="Number",j[j.Boolean=16]="Boolean",j[j.Array=17]="Array",j[j.Object=18]="Object",j[j.Key=19]="Key",j[j.Null=20]="Null",j[j.EnumMember=21]="EnumMember",j[j.Struct=22]="Struct",j[j.Event=23]="Event",j[j.Operator=24]="Operator",j[j.TypeParameter=25]="TypeParameter"})(J||(e.SymbolKind=J={}));var te;(function(j){j[j.Deprecated=1]="Deprecated"})(te||(e.SymbolTag=te={}));let se=$=class{static validate(N){if(!N.name)throw new Error("name must not be falsy")}constructor(N,ce,Se,Ge,_e){this.name=N,this.kind=ce,this.containerName=_e,typeof Se=="string"&&(this.containerName=Se),Ge instanceof pe?this.location=Ge:Se instanceof de&&(this.location=new pe(Ge,Se)),$.validate(this)}toJSON(){return{name:this.name,kind:J[this.kind],location:this.location,containerName:this.containerName}}};e.$pK=se,e.$pK=se=$=Je([B],se);let Fe=b=class{static validate(N){if(!N.name)throw new Error("name must not be falsy");if(!N.range.contains(N.selectionRange))throw new Error("selectionRange must be contained in fullRange");N.children?.forEach(b.validate)}constructor(N,ce,Se,Ge,_e){this.name=N,this.detail=ce,this.kind=Se,this.range=Ge,this.selectionRange=_e,this.children=[],b.validate(this)}};e.$qK=Fe,e.$qK=Fe=b=Je([B],Fe);var je;(function(j){j[j.Invoke=1]="Invoke",j[j.Automatic=2]="Automatic"})(je||(e.CodeActionTriggerKind=je={}));let Xe=class{constructor(N,ce){this.title=N,this.kind=ce}};e.$rK=Xe,e.$rK=Xe=Je([B],Xe);let He=M=class{constructor(N){this.value=N}append(N){return new M(this.value?this.value+M.c+N:N)}intersects(N){return this.contains(N)||N.contains(this)}contains(N){return this.value===N.value||N.value.startsWith(this.value+M.c)}};e.$sK=He,He.c=".",e.$sK=He=M=Je([B],He),He.Empty=new He(""),He.QuickFix=He.Empty.append("quickfix"),He.Refactor=He.Empty.append("refactor"),He.RefactorExtract=He.Refactor.append("extract"),He.RefactorInline=He.Refactor.append("inline"),He.RefactorMove=He.Refactor.append("move"),He.RefactorRewrite=He.Refactor.append("rewrite"),He.Source=He.Empty.append("source"),He.SourceOrganizeImports=He.Source.append("organizeImports"),He.SourceFixAll=He.Source.append("fixAll"),He.Notebook=He.Empty.append("notebook");let et=class{constructor(N,ce){if(this.range=N,this.parent=ce,ce&&!ce.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$tK=et,e.$tK=et=Je([B],et);class xe{constructor(N,ce,Se,Ge,_e,lt){this.kind=N,this.name=ce,this.detail=Se,this.uri=Ge,this.range=_e,this.selectionRange=lt}}e.$uK=xe;class it{constructor(N,ce){this.fromRanges=ce,this.from=N}}e.$vK=it;class st{constructor(N,ce){this.fromRanges=ce,this.to=N}}e.$wK=st;var nt;(function(j){j[j.Information=0]="Information",j[j.Warning=1]="Warning",j[j.Error=2]="Error"})(nt||(e.LanguageStatusSeverity=nt={}));let Ue=class{constructor(N,ce){this.range=N,this.command=ce}get isResolved(){return!!this.command}};e.$xK=Ue,e.$xK=Ue=Je([B],Ue);let ot=U=class{static isMarkdownString(N){return N instanceof U?!0:N&&N.appendCodeblock&&N.appendMarkdown&&N.appendText&&N.value!==void 0}constructor(N,ce=!1){t.set(this,void 0),Ye(this,t,new I.$Yj(N,{supportThemeIcons:ce}),"f")}get value(){return Ne(this,t,"f").value}set value(N){Ne(this,t,"f").value=N}get isTrusted(){return Ne(this,t,"f").isTrusted}set isTrusted(N){Ne(this,t,"f").isTrusted=N}get supportThemeIcons(){return Ne(this,t,"f").supportThemeIcons}set supportThemeIcons(N){Ne(this,t,"f").supportThemeIcons=N}get supportHtml(){return Ne(this,t,"f").supportHtml}set supportHtml(N){Ne(this,t,"f").supportHtml=N}get baseUri(){return Ne(this,t,"f").baseUri}set baseUri(N){Ne(this,t,"f").baseUri=N}appendText(N){return Ne(this,t,"f").appendText(N),this}appendMarkdown(N){return Ne(this,t,"f").appendMarkdown(N),this}appendCodeblock(N,ce){return Ne(this,t,"f").appendCodeblock(ce??"",N),this}};e.$yK=ot,t=new WeakMap,e.$yK=ot=U=Je([B],ot);let x=class{constructor(N,ce){this.label=N,this.documentation=ce}};e.$zK=x,e.$zK=x=Je([B],x);let Z=class{constructor(N,ce){this.label=N,this.documentation=ce,this.parameters=[]}};e.$AK=Z,e.$AK=Z=Je([B],Z);let we=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$BK=we,e.$BK=we=Je([B],we);var We;(function(j){j[j.Invoke=1]="Invoke",j[j.TriggerCharacter=2]="TriggerCharacter",j[j.ContentChange=3]="ContentChange"})(We||(e.SignatureHelpTriggerKind=We={}));var ze;(function(j){j[j.Type=1]="Type",j[j.Parameter=2]="Parameter"})(ze||(e.InlayHintKind=ze={}));let Ze=class{constructor(N){this.value=N}};e.$CK=Ze,e.$CK=Ze=Je([B],Ze);let at=class{constructor(N,ce,Se){this.position=N,this.label=ce,this.kind=Se}};e.$DK=at,e.$DK=at=Je([B],at);var mt;(function(j){j[j.Invoke=0]="Invoke",j[j.TriggerCharacter=1]="TriggerCharacter",j[j.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(mt||(e.CompletionTriggerKind=mt={}));var bt;(function(j){j[j.Text=0]="Text",j[j.Method=1]="Method",j[j.Function=2]="Function",j[j.Constructor=3]="Constructor",j[j.Field=4]="Field",j[j.Variable=5]="Variable",j[j.Class=6]="Class",j[j.Interface=7]="Interface",j[j.Module=8]="Module",j[j.Property=9]="Property",j[j.Unit=10]="Unit",j[j.Value=11]="Value",j[j.Enum=12]="Enum",j[j.Keyword=13]="Keyword",j[j.Snippet=14]="Snippet",j[j.Color=15]="Color",j[j.File=16]="File",j[j.Reference=17]="Reference",j[j.Folder=18]="Folder",j[j.EnumMember=19]="EnumMember",j[j.Constant=20]="Constant",j[j.Struct=21]="Struct",j[j.Event=22]="Event",j[j.Operator=23]="Operator",j[j.TypeParameter=24]="TypeParameter",j[j.User=25]="User",j[j.Issue=26]="Issue"})(bt||(e.CompletionItemKind=bt={}));var Tt;(function(j){j[j.Deprecated=1]="Deprecated"})(Tt||(e.CompletionItemTag=Tt={}));let Xt=class{constructor(N,ce){this.label=N,this.kind=ce}toJSON(){return{label:this.label,kind:this.kind&&bt[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$EK=Xt,e.$EK=Xt=Je([B],Xt);let qt=class{constructor(N=[],ce=!1){this.items=N,this.isIncomplete=ce}};e.$FK=qt,e.$FK=qt=Je([B],qt);let wt=class{constructor(N,ce,Se){this.insertText=N,this.range=ce,this.command=Se}};e.$GK=wt,e.$GK=wt=Je([B],wt);let Nt=class{constructor(N){this.commands=void 0,this.suppressSuggestions=void 0,this.items=N}};e.$HK=Nt,e.$HK=Nt=Je([B],Nt);var zt;(function(j){j[j.Active=-1]="Active",j[j.Beside=-2]="Beside",j[j.One=1]="One",j[j.Two=2]="Two",j[j.Three=3]="Three",j[j.Four=4]="Four",j[j.Five=5]="Five",j[j.Six=6]="Six",j[j.Seven=7]="Seven",j[j.Eight=8]="Eight",j[j.Nine=9]="Nine"})(zt||(e.ViewColumn=zt={}));var Zt;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(Zt||(e.StatusBarAlignment=Zt={}));function Ut(j,N){return`${k.$Xl.toKey(j)}.${N}`}e.$IK=Ut;var jt;(function(j){j[j.Off=0]="Off",j[j.On=1]="On",j[j.Relative=2]="Relative"})(jt||(e.TextEditorLineNumbersStyle=jt={}));var Kt;(function(j){j[j.Manual=1]="Manual",j[j.AfterDelay=2]="AfterDelay",j[j.FocusOut=3]="FocusOut"})(Kt||(e.TextDocumentSaveReason=Kt={}));var Gt;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(Gt||(e.TextEditorRevealType=Gt={}));var Bt;(function(j){j[j.Keyboard=1]="Keyboard",j[j.Mouse=2]="Mouse",j[j.Command=3]="Command"})(Bt||(e.TextEditorSelectionChangeKind=Bt={}));var Ht;(function(j){j[j.Undo=1]="Undo",j[j.Redo=2]="Redo"})(Ht||(e.TextDocumentChangeReason=Ht={}));var Jt;(function(j){j[j.OpenOpen=0]="OpenOpen",j[j.ClosedClosed=1]="ClosedClosed",j[j.OpenClosed=2]="OpenClosed",j[j.ClosedOpen=3]="ClosedOpen"})(Jt||(e.DecorationRangeBehavior=Jt={})),function(j){function N(ce){switch(ce){case"keyboard":return j.Keyboard;case"mouse":return j.Mouse;case"api":return j.Command}}j.fromValue=N}(Bt||(e.TextEditorSelectionChangeKind=Bt={}));var ct;(function(j){j[j.Other=0]="Other",j[j.Comment=1]="Comment",j[j.String=2]="String",j[j.RegEx=3]="RegEx"})(ct||(e.SyntaxTokenType=ct={})),function(j){function N(ce){switch(ce){case j.Other:return"other";case j.Comment:return"comment";case j.String:return"string";case j.RegEx:return"regex"}return"other"}j.toString=N}(ct||(e.SyntaxTokenType=ct={}));let gt=class{constructor(N,ce){if(ce&&!d.URI.isUri(ce))throw(0,C.$5)("target");if(!de.isRange(N)||N.isEmpty)throw(0,C.$5)("range");this.range=N,this.target=ce}};e.$JK=gt,e.$JK=gt=Je([B],gt);let It=class{constructor(N,ce,Se,Ge){this.red=N,this.green=ce,this.blue=Se,this.alpha=Ge}};e.$KK=It,e.$KK=It=Je([B],It);let Rt=class{constructor(N,ce){if(ce&&!(ce instanceof It))throw(0,C.$5)("color");if(!de.isRange(N)||N.isEmpty)throw(0,C.$5)("range");this.range=N,this.color=ce}};e.$LK=Rt,e.$LK=Rt=Je([B],Rt);let Ct=class{constructor(N){if(!N||typeof N!="string")throw(0,C.$5)("label");this.label=N}};e.$MK=Ct,e.$MK=Ct=Je([B],Ct);var ft;(function(j){j[j.RGB=0]="RGB",j[j.HEX=1]="HEX",j[j.HSL=2]="HSL"})(ft||(e.ColorFormat=ft={}));var kt;(function(j){j[j.Error=0]="Error",j[j.Warning=1]="Warning",j[j.Information=2]="Information"})(kt||(e.SourceControlInputBoxValidationType=kt={}));var Pt;(function(j){j[j.Unknown=0]="Unknown",j[j.Shutdown=1]="Shutdown",j[j.Process=2]="Process",j[j.User=3]="User",j[j.Extension=4]="Extension"})(Pt||(e.TerminalExitReason=Pt={}));class Ft{constructor(N,ce,Se){if(this.startIndex=N,this.length=ce,this.tooltip=Se,typeof N!="number"||N<0)throw(0,C.$5)("startIndex");if(typeof ce!="number"||ce<1)throw(0,C.$5)("length");if(Se!==void 0&&typeof Se!="string")throw(0,C.$5)("tooltip")}}e.$NK=Ft;class Ke{constructor(N){this.uri=N}}e.$OK=Ke;class Pe{constructor(N){this.terminalCommand=N}}e.$PK=Pe;var Le;(function(j){j[j.Panel=1]="Panel",j[j.Editor=2]="Editor"})(Le||(e.TerminalLocation=Le={}));class be{constructor(N){if(this.options=N,typeof N!="object")throw(0,C.$5)("options")}}e.$QK=be;var G;(function(j){j[j.Always=1]="Always",j[j.Silent=2]="Silent",j[j.Never=3]="Never"})(G||(e.TaskRevealKind=G={}));var Me;(function(j){j[j.Shared=1]="Shared",j[j.Dedicated=2]="Dedicated",j[j.New=3]="New"})(Me||(e.TaskPanelKind=Me={}));let Be=F=class{static from(N){switch(N){case"clean":return F.Clean;case"build":return F.Build;case"rebuild":return F.Rebuild;case"test":return F.Test;default:return}}constructor(N,ce){if(this.label=ce,typeof N!="string"||typeof ce!="string")throw(0,C.$5)("name");this.c=N}get id(){return this.c}};e.$RK=Be,Be.Clean=new F("clean","Clean"),Be.Build=new F("build","Build"),Be.Rebuild=new F("rebuild","Rebuild"),Be.Test=new F("test","Test"),e.$RK=Be=F=Je([B],Be);function Qe(j){let N="";for(let ce=0;ce<j.length;ce++)N+=j[ce].replace(/,/g,",,")+",";return N}let Ve=class{constructor(N,ce,Se){if(typeof N!="string")throw(0,C.$5)("process");this.e=[],this.c=N,ce!==void 0&&(Array.isArray(ce)?(this.e=ce,this.f=Se):this.f=ce)}get process(){return this.c}set process(N){if(typeof N!="string")throw(0,C.$5)("process");this.c=N}get args(){return this.e}set args(N){Array.isArray(N)||(N=[]),this.e=N}get options(){return this.f}set options(N){this.f=N}computeId(){const N=[];if(N.push("process"),this.c!==void 0&&N.push(this.c),this.e&&this.e.length>0)for(const ce of this.e)N.push(ce);return Qe(N)}};e.$SK=Ve,e.$SK=Ve=Je([B],Ve);let tt=class{constructor(N,ce,Se){if(this.f=[],Array.isArray(ce)){if(!N)throw(0,C.$5)("command can't be undefined or null");if(typeof N!="string"&&typeof N.value!="string")throw(0,C.$5)("command");this.e=N,this.f=ce,this.g=Se}else{if(typeof N!="string")throw(0,C.$5)("commandLine");this.c=N,this.g=ce}}get commandLine(){return this.c}set commandLine(N){if(typeof N!="string")throw(0,C.$5)("commandLine");this.c=N}get command(){return this.e?this.e:""}set command(N){if(typeof N!="string"&&typeof N.value!="string")throw(0,C.$5)("command");this.e=N}get args(){return this.f}set args(N){this.f=N||[]}get options(){return this.g}set options(N){this.g=N}computeId(){const N=[];if(N.push("shell"),this.c!==void 0&&N.push(this.c),this.e!==void 0&&N.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const ce of this.f)N.push(typeof ce=="string"?ce:ce.value);return Qe(N)}};e.$TK=tt,e.$TK=tt=Je([B],tt);var vt;(function(j){j[j.Escape=1]="Escape",j[j.Strong=2]="Strong",j[j.Weak=3]="Weak"})(vt||(e.ShellQuoting=vt={}));var Lt;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace"})(Lt||(e.TaskScope=Lt={}));class yt{constructor(N){this.c=N}computeId(){return"customExecution"+(0,A.$bg)()}set callback(N){this.c=N}get callback(){return this.c}}e.$UK=yt;let ut=q=class{constructor(N,ce,Se,Ge,_e,lt){this.j=!1,this.k=this.definition=N;let dt;typeof ce=="string"?(this.m=this.name=ce,this.t=this.source=Se,this.execution=Ge,dt=_e,this.j=!0):ce===Lt.Global||ce===Lt.Workspace?(this.target=ce,this.m=this.name=Se,this.t=this.source=Ge,this.execution=_e,dt=lt):(this.target=ce,this.m=this.name=Se,this.t=this.source=Ge,this.execution=_e,dt=lt),typeof dt=="string"?(this.o=[dt],this.q=!0):Array.isArray(dt)?(this.o=dt,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.w=Object.create(null),this.x=Object.create(null)}get _id(){return this.h}set _id(N){this.h=N}get _deprecated(){return this.j}z(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.A())}A(){this.n instanceof Ve?this.k={type:q.e,id:this.n.computeId()}:this.n instanceof tt?this.k={type:q.f,id:this.n.computeId()}:this.n instanceof yt?this.k={type:q.c,id:this.n.computeId()}:this.k={type:q.g,id:(0,A.$bg)()}}get definition(){return this.k}set definition(N){if(N==null)throw(0,C.$5)("Kind can't be undefined or null");this.z(),this.k=N}get scope(){return this.l}set target(N){this.z(),this.l=N}get name(){return this.m}set name(N){if(typeof N!="string")throw(0,C.$5)("name");this.z(),this.m=N}get execution(){return this.n}set execution(N){N===null&&(N=void 0),this.z(),this.n=N;const ce=this.k.type;(q.g===ce||q.e===ce||q.f===ce||q.c===ce)&&this.A()}get problemMatchers(){return this.o}set problemMatchers(N){if(Array.isArray(N))this.z(),this.o=N,this.q=!0;else{this.z(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(N){N!==!0&&N!==!1&&(N=!1),this.z(),this.r=N}get source(){return this.t}set source(N){if(typeof N!="string"||N.length===0)throw(0,C.$5)("source must be a string of length > 0");this.z(),this.t=N}get group(){return this.u}set group(N){N===null&&(N=void 0),this.z(),this.u=N}get detail(){return this.y}set detail(N){N===null&&(N=void 0),this.y=N}get presentationOptions(){return this.w}set presentationOptions(N){N==null&&(N=Object.create(null)),this.z(),this.w=N}get runOptions(){return this.x}set runOptions(N){N==null&&(N=Object.create(null)),this.z(),this.x=N}};e.$VK=ut,ut.c="customExecution",ut.e="process",ut.f="shell",ut.g="$empty",e.$VK=ut=q=Je([B],ut);var pt;(function(j){j[j.SourceControl=1]="SourceControl",j[j.Window=10]="Window",j[j.Notification=15]="Notification"})(pt||(e.ProgressLocation=pt={}));var St;(function(j){function N(ce){const Se=ce;return(0,D.$Af)(Se.value)?Se.tooltip&&!(0,D.$wf)(Se.tooltip)?(console.log("INVALID view badge, invalid tooltip",Se.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Se.value),!1)}j.isViewBadge=N})(St||(e.ViewBadge=St={}));let mi=W=class{static isTreeItem(N,ce){const Se=N;if(Se.checkboxState!==void 0){const Ge=(0,D.$Af)(Se.checkboxState)?Se.checkboxState:(0,D.$yf)(Se.checkboxState)&&(0,D.$Af)(Se.checkboxState.state)?Se.checkboxState.state:void 0,_e=!(0,D.$Af)(Se.checkboxState)&&(0,D.$yf)(Se.checkboxState)?Se.checkboxState.tooltip:void 0;if(Ge===void 0||Ge!==$i.Checked&&Ge!==$i.Unchecked||_e!==void 0&&!(0,D.$wf)(_e))return console.log("INVALID tree item, invalid checkboxState",Se.checkboxState),!1}if(N instanceof W)return!0;if(Se.label!==void 0&&!(0,D.$wf)(Se.label)&&!Se.label?.label)return console.log("INVALID tree item, invalid label",Se.label),!1;if(Se.id!==void 0&&!(0,D.$wf)(Se.id))return console.log("INVALID tree item, invalid id",Se.id),!1;if(Se.iconPath!==void 0&&!(0,D.$wf)(Se.iconPath)&&!d.URI.isUri(Se.iconPath)&&(!Se.iconPath||!(0,D.$wf)(Se.iconPath.id))){const Ge=Se.iconPath;if(!Ge||!(0,D.$wf)(Ge.light)&&!d.URI.isUri(Ge.light)&&!(0,D.$wf)(Ge.dark)&&!d.URI.isUri(Ge.dark))return console.log("INVALID tree item, invalid iconPath",Se.iconPath),!1}return Se.description!==void 0&&!(0,D.$wf)(Se.description)&&typeof Se.description!="boolean"?(console.log("INVALID tree item, invalid description",Se.description),!1):Se.resourceUri!==void 0&&!d.URI.isUri(Se.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Se.resourceUri),!1):Se.tooltip!==void 0&&!(0,D.$wf)(Se.tooltip)&&!(Se.tooltip instanceof ot)?(console.log("INVALID tree item, invalid tooltip",Se.tooltip),!1):Se.command!==void 0&&!Se.command.command?(console.log("INVALID tree item, invalid command",Se.command),!1):Se.collapsibleState!==void 0&&Se.collapsibleState<Wt.None&&Se.collapsibleState>Wt.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Se.collapsibleState),!1):Se.contextValue!==void 0&&!(0,D.$wf)(Se.contextValue)?(console.log("INVALID tree item, invalid contextValue",Se.contextValue),!1):Se.accessibilityInformation!==void 0&&!Se.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Se.accessibilityInformation),!1):!0}constructor(N,ce=Wt.None){this.collapsibleState=ce,d.URI.isUri(N)?this.resourceUri=N:this.label=N}};e.$WK=mi,e.$WK=mi=W=Je([B],mi);var Wt;(function(j){j[j.None=0]="None",j[j.Collapsed=1]="Collapsed",j[j.Expanded=2]="Expanded"})(Wt||(e.TreeItemCollapsibleState=Wt={}));var $i;(function(j){j[j.Unchecked=0]="Unchecked",j[j.Checked=1]="Checked"})($i||(e.TreeItemCheckboxState=$i={}));let ii=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(N){this.value=N}};e.$XK=ii,e.$XK=ii=Je([B],ii);class ki extends ii{}e.$YK=ki;class Mt extends ki{constructor(N){super(""),s.set(this,void 0),Ye(this,s,N,"f")}asFile(){return Ne(this,s,"f")}}e.$ZK=Mt,s=new WeakMap;class hn{constructor(N,ce,Se,Ge){this.name=N,this.uri=ce,this._itemId=Se,this.c=Ge}data(){return this.c()}}e.$1K=hn;let Si=class{constructor(N){c.add(this),v.set(this,new Map);for(const[ce,Se]of N??[]){const Ge=Ne(this,v,"f").get(Ne(this,c,"m",S).call(this,ce));Ge?Ge.push(Se):Ne(this,v,"f").set(Ne(this,c,"m",S).call(this,ce),[Se])}}get(N){return Ne(this,v,"f").get(Ne(this,c,"m",S).call(this,N))?.[0]}set(N,ce){Ne(this,v,"f").set(Ne(this,c,"m",S).call(this,N),[ce])}forEach(N,ce){for(const[Se,Ge]of Ne(this,v,"f"))for(const _e of Ge)N.call(ce,_e,Se,this)}*[(v=new WeakMap,c=new WeakSet,Symbol.iterator)](){for(const[N,ce]of Ne(this,v,"f"))for(const Se of ce)yield[N,Se]}};e.$2K=Si,S=function(N){return N.toLowerCase()},e.$2K=Si=Je([B],Si);let Dt=class{constructor(N){this.insertText=N}};e.$3K=Dt,e.$3K=Dt=Je([B],Dt);let pi=class{constructor(N,ce){this.label=ce,this.insertText=N}};e.$4K=pi,e.$4K=pi=Je([B],pi);let Yt=class{constructor(N,ce){this.id=N,this.color=ce}static isThemeIcon(N){return typeof N.id!="string"?(console.log("INVALID ThemeIcon, invalid id",N.id),!1):!0}};e.$5K=Yt,e.$5K=Yt=Je([B],Yt),Yt.File=new Yt("file"),Yt.Folder=new Yt("folder");let oi=class{constructor(N){this.id=N}};e.$6K=oi,e.$6K=oi=Je([B],oi);var qi;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace",j[j.WorkspaceFolder=3]="WorkspaceFolder"})(qi||(e.ConfigurationTarget=qi={}));let Ii=class{get base(){return this.c}set base(N){this.c=N,this.e=d.URI.file(N)}get baseUri(){return this.e}set baseUri(N){this.e=N,this.c=N.fsPath}constructor(N,ce){if(typeof N!="string"&&(!N||!d.URI.isUri(N)&&!d.URI.isUri(N.uri)))throw(0,C.$5)("base");if(typeof ce!="string")throw(0,C.$5)("pattern");typeof N=="string"?this.baseUri=d.URI.file(N):d.URI.isUri(N)?this.baseUri=N:this.baseUri=N.uri,this.pattern=ce}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$7K=Ii,e.$7K=Ii=Je([B],Ii);const Ot=new WeakMap;function Ki(j,N){Ot.set(j,N)}e.$8K=Ki;let ai=class{constructor(N,ce,Se,Ge){this.enabled=typeof N=="boolean"?N:!0,typeof ce=="string"&&(this.condition=ce),typeof Se=="string"&&(this.hitCondition=Se),typeof Ge=="string"&&(this.logMessage=Ge)}get id(){return this.c||(this.c=Ot.get(this)??(0,A.$bg)()),this.c}};e.$9K=ai,e.$9K=ai=Je([B],ai);let ci=class extends ai{constructor(N,ce,Se,Ge,_e){if(super(ce,Se,Ge,_e),N===null)throw(0,C.$5)("location");this.location=N}};e.$0K=ci,e.$0K=ci=Je([B],ci);let ui=class extends ai{constructor(N,ce,Se,Ge,_e){super(ce,Se,Ge,_e),this.functionName=N}};e.$$K=ui,e.$$K=ui=Je([B],ui);let ht=class extends ai{constructor(N,ce,Se,Ge,_e,lt,dt){if(super(Ge,_e,lt,dt),!ce)throw(0,C.$5)("dataId");this.label=N,this.dataId=ce,this.canPersist=Se}};e.$_K=ht,e.$_K=ht=Je([B],ht);let Ci=class{constructor(N,ce,Se){this.command=N,this.args=ce||[],this.options=Se}};e.$aL=Ci,e.$aL=Ci=Je([B],Ci);let xt=class{constructor(N,ce){this.port=N,this.host=ce}};e.$bL=xt,e.$bL=xt=Je([B],xt);let ni=class{constructor(N){this.path=N}};e.$cL=ni,e.$cL=ni=Je([B],ni);let vi=class{constructor(N){this.implementation=N}};e.$dL=vi,e.$dL=vi=Je([B],vi);let Pi=class{constructor(N,ce,Se){this.session=N,this.threadId=ce,this.frameId=Se}};e.$eL=Pi,e.$eL=Pi=Je([B],Pi);let Ai=class{constructor(N,ce){this.session=N,this.threadId=ce}};e.$fL=Ai,e.$fL=Ai=Je([B],Ai);let Ri=class{constructor(N,ce){this.range=N,this.expression=ce}};e.$gL=Ri,e.$gL=Ri=Je([B],Ri);var Li;(function(j){j[j.Invoke=0]="Invoke",j[j.Automatic=1]="Automatic"})(Li||(e.InlineCompletionTriggerKind=Li={}));let Mi=class{constructor(N,ce){this.range=N,this.text=ce}};e.$hL=Mi,e.$hL=Mi=Je([B],Mi);let bi=class{constructor(N,ce,Se=!0){this.range=N,this.variableName=ce,this.caseSensitiveLookup=Se}};e.$iL=bi,e.$iL=bi=Je([B],bi);let ri=class{constructor(N,ce){this.range=N,this.expression=ce}};e.$jL=ri,e.$jL=ri=Je([B],ri);let Ti=class{constructor(N,ce){this.frameId=N,this.stoppedLocation=ce}};e.$kL=Ti,e.$kL=Ti=Je([B],Ti);var wi;(function(j){j[j.Changed=1]="Changed",j[j.Created=2]="Created",j[j.Deleted=3]="Deleted"})(wi||(e.FileChangeType=wi={}));let hi=L=class extends Error{static FileExists(N){return new L(N,a.FileSystemProviderErrorCode.FileExists,L.FileExists)}static FileNotFound(N){return new L(N,a.FileSystemProviderErrorCode.FileNotFound,L.FileNotFound)}static FileNotADirectory(N){return new L(N,a.FileSystemProviderErrorCode.FileNotADirectory,L.FileNotADirectory)}static FileIsADirectory(N){return new L(N,a.FileSystemProviderErrorCode.FileIsADirectory,L.FileIsADirectory)}static NoPermissions(N){return new L(N,a.FileSystemProviderErrorCode.NoPermissions,L.NoPermissions)}static Unavailable(N){return new L(N,a.FileSystemProviderErrorCode.Unavailable,L.Unavailable)}constructor(N,ce=a.FileSystemProviderErrorCode.Unknown,Se){super(d.URI.isUri(N)?N.toString(!0):N),this.code=Se?.name??"Unknown",(0,a.$ik)(this,ce),Object.setPrototypeOf(this,L.prototype),typeof Error.captureStackTrace=="function"&&typeof Se=="function"&&Error.captureStackTrace(this,Se)}};e.$lL=hi,e.$lL=hi=L=Je([B],hi);let Fi=class{constructor(N,ce,Se){this.start=N,this.end=ce,this.kind=Se}};e.$mL=Fi,e.$mL=Fi=Je([B],Fi);var Hi;(function(j){j[j.Comment=1]="Comment",j[j.Imports=2]="Imports",j[j.Region=3]="Region"})(Hi||(e.FoldingRangeKind=Hi={}));var li;(function(j){j[j.Collapsed=0]="Collapsed",j[j.Expanded=1]="Expanded"})(li||(e.CommentThreadCollapsibleState=li={}));var Ji;(function(j){j[j.Editing=0]="Editing",j[j.Preview=1]="Preview"})(Ji||(e.CommentMode=Ji={}));var Gi;(function(j){j[j.Published=0]="Published",j[j.Draft=1]="Draft"})(Gi||(e.CommentState=Gi={}));var Qi;(function(j){j[j.Unresolved=0]="Unresolved",j[j.Resolved=1]="Resolved"})(Qi||(e.CommentThreadState=Qi={}));class yi{constructor(N,ce=[]){this.tokenTypes=N,this.tokenModifiers=ce}}e.$nL=yi;function dn(j){return typeof j>"u"||(0,D.$xf)(j)}class Oi{constructor(N){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,N){this.l=!0;for(let ce=0,Se=N.tokenTypes.length;ce<Se;ce++)this.j.set(N.tokenTypes[ce],ce);for(let ce=0,Se=N.tokenModifiers.length;ce<Se;ce++)this.k.set(N.tokenModifiers[ce],ce)}}push(N,ce,Se,Ge,_e){if(typeof N=="number"&&typeof ce=="number"&&typeof Se=="number"&&typeof Ge=="number"&&(typeof _e=="number"||typeof _e>"u"))return typeof _e>"u"&&(_e=0),this.n(N,ce,Se,Ge,_e);if(de.isRange(N)&&typeof ce=="string"&&dn(Se))return this.m(N,ce,Se);throw(0,C.$5)()}m(N,ce,Se){if(!this.l)throw new Error("Legend must be provided in constructor");if(N.start.line!==N.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(ce))throw new Error("`tokenType` is not in the provided legend");const Ge=N.start.line,_e=N.start.character,lt=N.end.character-N.start.character,dt=this.j.get(ce);let Vt=0;if(Se)for(const _t of Se){if(!this.k.has(_t))throw new Error("`tokenModifier` is not in the provided legend");const ei=this.k.get(_t);Vt|=1<<ei>>>0}this.n(Ge,_e,lt,dt,Vt)}n(N,ce,Se,Ge,_e){if(this.f&&(N<this.c||N===this.c&&ce<this.e)){this.f=!1;const Vt=this.g.length/5|0;let _t=0,ei=0;for(let ti=0;ti<Vt;ti++){let si=this.g[5*ti],Wi=this.g[5*ti+1];si===0?(si=_t,Wi+=ei):si+=_t,this.g[5*ti]=si,this.g[5*ti+1]=Wi,_t=si,ei=Wi}}let lt=N,dt=ce;this.f&&this.h>0&&(lt-=this.c,lt===0&&(dt-=this.e)),this.g[this.h++]=lt,this.g[this.h++]=dt,this.g[this.h++]=Se,this.g[this.h++]=Ge,this.g[this.h++]=_e,this.c=N,this.e=ce}static o(N){const ce=[],Se=N.length/5|0;for(let dt=0;dt<Se;dt++)ce[dt]=dt;ce.sort((dt,Vt)=>{const _t=N[5*dt],ei=N[5*Vt];if(_t===ei){const ti=N[5*dt+1],si=N[5*Vt+1];return ti-si}return _t-ei});const Ge=new Uint32Array(N.length);let _e=0,lt=0;for(let dt=0;dt<Se;dt++){const Vt=5*ce[dt],_t=N[Vt+0],ei=N[Vt+1],ti=N[Vt+2],si=N[Vt+3],Wi=N[Vt+4],An=_t-_e,Wn=An===0?ei-lt:ei,Vi=5*dt;Ge[Vi+0]=An,Ge[Vi+1]=Wn,Ge[Vi+2]=ti,Ge[Vi+3]=si,Ge[Vi+4]=Wi,_e=_t,lt=ei}return Ge}build(N){return this.f?new Ni(new Uint32Array(this.g),N):new Ni(Oi.o(this.g),N)}}e.$oL=Oi;class Ni{constructor(N,ce){this.resultId=ce,this.data=N}}e.$pL=Ni;class di{constructor(N,ce,Se){this.start=N,this.deleteCount=ce,this.data=Se}}e.$qL=di;class Xi{constructor(N,ce){this.resultId=ce,this.edits=N}}e.$rL=Xi;var Zi;(function(j){j[j.Separate=0]="Separate",j[j.MergeWithParent=1]="MergeWithParent"})(Zi||(e.DebugConsoleMode=Zi={}));let Ei=class{constructor(){}};e.$sL=Ei,Ei.Back={iconPath:new Yt("arrow-left")},e.$sL=Ei=Je([B],Ei);var zi;(function(j){j[j.Separator=-1]="Separator",j[j.Default=0]="Default"})(zi||(e.QuickPickItemKind=zi={}));var Yi;(function(j){j[j.Info=1]="Info",j[j.Warning=2]="Warning",j[j.Error=3]="Error"})(Yi||(e.InputBoxValidationSeverity=Yi={}));var _i;(function(j){j[j.UI=1]="UI",j[j.Workspace=2]="Workspace"})(_i||(e.ExtensionKind=_i={}));class fn{static validate(N){if(typeof N.badge=="string"){let ce=(0,u.$0e)(N.badge,0);if(ce<N.badge.length&&(ce+=(0,u.$0e)(N.badge,ce)),N.badge.length>ce)throw new Error("The 'badge'-property must be undefined or a short character")}else if(N.badge&&!Yt.isThemeIcon(N.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!N.color&&!N.badge&&!N.tooltip)throw new Error("The decoration is empty");return!0}constructor(N,ce,Se){this.badge=N,this.tooltip=ce,this.color=Se}}e.$tL=fn;let fi=class{constructor(N){this.kind=N}};e.$uL=fi,e.$uL=fi=Je([B],fi);var Ui;(function(j){j[j.Light=1]="Light",j[j.Dark=2]="Dark",j[j.HighContrast=3]="HighContrast",j[j.HighContrastLight=4]="HighContrastLight"})(Ui||(e.ColorThemeKind=Ui={}));class Oe{static isNotebookRange(N){return N instanceof Oe?!0:N?typeof N.start=="number"&&typeof N.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(N,ce){if(N<0)throw(0,C.$5)("start must be positive");if(ce<0)throw(0,C.$5)("end must be positive");N<=ce?(this.c=N,this.e=ce):(this.c=ce,this.e=N)}with(N){let ce=this.c,Se=this.e;return N.start!==void 0&&(ce=N.start),N.end!==void 0&&(Se=N.end),ce===this.c&&Se===this.e?this:new Oe(ce,Se)}}e.$vL=Oe;class Qt{static validate(N){if(typeof N.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof N.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof N.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(N){return Array.isArray(N)&&N.every(ce=>Qt.isNotebookCellData(ce))}static isNotebookCellData(N){return!0}constructor(N,ce,Se,Ge,_e,lt,dt){this.kind=N,this.value=ce,this.languageId=Se,this.mime=Ge,this.outputs=_e??[],this.metadata=lt,this.executionSummary=dt,Qt.validate(this)}}e.$wL=Qt;class xi{constructor(N){this.cells=N}}e.$xL=xi;class $t{static isNotebookCellOutputItem(N){return N instanceof p?!0:N?typeof N.mime=="string"&&N.data instanceof Uint8Array:!1}static error(N){const ce={name:N.name,message:N.message,stack:N.stack};return p.json(ce,"application/vnd.code.notebook.error")}static stdout(N){return p.text(N,"application/vnd.code.notebook.stdout")}static stderr(N){return p.text(N,"application/vnd.code.notebook.stderr")}static bytes(N,ce="application/octet-stream"){return new p(N,ce)}static text(N,ce=R.$Jr.text){const Se=Ne(p,p,"f",n).encode(String(N));return new p(Se,ce)}static json(N,ce="text/x-json"){const Se=JSON.stringify(N,void 0,"	");return p.text(Se,ce)}constructor(N,ce){this.data=N,this.mime=ce;const Se=(0,R.$Nr)(ce,!0);if(!Se)throw new Error(`INVALID mime type: ${ce}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Se}}e.$yL=$t,p=$t,n={value:new TextEncoder};class Di{static isNotebookCellOutput(N){return N instanceof Di?!0:!N||typeof N!="object"?!1:typeof N.id=="string"&&Array.isArray(N.items)}static ensureUniqueMimeTypes(N,ce=!1){const Se=new Set,Ge=new Set;for(let _e=0;_e<N.length;_e++){const lt=N[_e],dt=(0,R.$Nr)(lt.mime);if(!Se.has(dt)||(0,m.$iI)(dt)){Se.add(dt);continue}Ge.add(_e),ce&&console.warn(`DUPLICATED mime type '${lt.mime}' will be dropped`)}return Ge.size===0?N:N.filter((_e,lt)=>!Ge.has(lt))}constructor(N,ce,Se){this.items=Di.ensureUniqueMimeTypes(N,!0),typeof ce=="string"?(this.id=ce,this.metadata=Se):(this.id=(0,A.$bg)(),this.metadata=ce??Se)}}e.$zL=Di;var en;(function(j){j[j.Markup=1]="Markup",j[j.Code=2]="Code"})(en||(e.NotebookCellKind=en={}));var ji;(function(j){j[j.Idle=1]="Idle",j[j.Pending=2]="Pending",j[j.Executing=3]="Executing"})(ji||(e.NotebookCellExecutionState=ji={}));var tn;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(tn||(e.NotebookCellStatusBarAlignment=tn={}));var gi;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(gi||(e.NotebookEditorRevealType=gi={}));class gn{constructor(N,ce){this.text=N,this.alignment=ce}}e.$AL=gn;var nn;(function(j){j[j.Default=1]="Default",j[j.Preferred=2]="Preferred"})(nn||(e.NotebookControllerAffinity=nn={}));var rn;(function(j){j[j.Default=1]="Default",j[j.Preferred=2]="Preferred",j[j.Hidden=-1]="Hidden"})(rn||(e.NotebookControllerAffinity2=rn={}));class sn{constructor(N,ce=[]){this.uri=N,this.provides=(0,h.$1b)(ce)}}e.$BL=sn;class mn{constructor(N){this.label=N}}e.$CL=mn;let Bi=class{constructor(N,ce){this.label=N,this.timestamp=ce}};e.$DL=Bi,e.$DL=Bi=Je([B],Bi);var on;(function(j){j[j.Production=1]="Production",j[j.Development=2]="Development",j[j.Test=3]="Test"})(on||(e.ExtensionMode=on={}));var an;(function(j){j[j.Node=1]="Node",j[j.Webworker=2]="Webworker"})(an||(e.ExtensionRuntime=an={}));var cn;(function(j){j[j.Other=0]="Other",j[j.Comment=1]="Comment",j[j.String=2]="String",j[j.RegEx=3]="RegEx"})(cn||(e.StandardTokenType=cn={}));class $n{constructor(N,ce){this.ranges=N,this.wordPattern=ce}}e.$EL=$n;class pn{constructor(N){this.c=N}get autoForwardAction(){return this.c}}e.$FL=pn;var un;(function(j){j[j.Queued=1]="Queued",j[j.Running=2]="Running",j[j.Passed=3]="Passed",j[j.Failed=4]="Failed",j[j.Skipped=5]="Skipped",j[j.Errored=6]="Errored"})(un||(e.TestResultState=un={}));var ln;(function(j){j[j.Run=1]="Run",j[j.Debug=2]="Debug",j[j.Coverage=3]="Coverage"})(ln||(e.TestRunProfileKind=ln={}));let ne=class{constructor(N=void 0,ce=void 0,Se=void 0,Ge=!1){this.include=N,this.exclude=ce,this.profile=Se,this.continuous=Ge}};e.$GL=ne,e.$GL=ne=Je([B],ne);let ge=z=class{static diff(N,ce,Se){const Ge=new z(N);return Ge.expectedOutput=ce,Ge.actualOutput=Se,Ge}constructor(N){this.message=N}};e.$HL=ge,e.$HL=ge=z=Je([B],ge);let Te=class{constructor(N){this.id=N}};e.$IL=Te,e.$IL=Te=Je([B],Te);let rt=class{constructor(N,ce){this.covered=N,this.total=ce}};e.$JL=rt,e.$JL=rt=Je([B],rt);let Et=K=class{static fromDetails(N,ce){const Se=new rt(0,0),Ge=new rt(0,0),_e=new rt(0,0);for(const dt of ce)if("branches"in dt){Se.total+=1,Se.covered+=dt.executionCount>0?1:0;for(const Vt of dt.branches)Ge.total+=1,Ge.covered+=Vt.executionCount>0?1:0}else _e.total+=1,_e.covered+=dt.executionCount>0?1:0;const lt=new K(N,Se,Ge.total>0?Ge:void 0,_e.total>0?_e:void 0);return lt.detailedCoverage=ce,lt}constructor(N,ce,Se,Ge){this.uri=N,this.statementCoverage=ce,this.branchCoverage=Se,this.functionCoverage=Ge}};e.$KL=Et,e.$KL=Et=K=Je([B],Et);let At=class{constructor(N,ce,Se=[]){this.executionCount=N,this.location=ce,this.branches=Se}};e.$LL=At,e.$LL=At=Je([B],At);let vn=class{constructor(N,ce){this.executionCount=N,this.location=ce}};e.$ML=vn,e.$ML=vn=Je([B],vn);let bn=class{constructor(N,ce){this.executionCount=N,this.location=ce}};e.$NL=bn,e.$NL=bn=Je([B],bn);var wn;(function(j){j[j.None=0]="None",j[j.Option=1]="Option",j[j.Default=2]="Default",j[j.Preferred=3]="Preferred"})(wn||(e.ExternalUriOpenerPriority=wn={}));var yn;(function(j){j[j.Untrusted=0]="Untrusted",j[j.Trusted=1]="Trusted",j[j.Unspecified=2]="Unspecified"})(yn||(e.WorkspaceTrustState=yn={}));var En;(function(j){j[j.Notify=1]="Notify",j[j.OpenBrowser=2]="OpenBrowser",j[j.OpenPreview=3]="OpenPreview",j[j.Silent=4]="Silent",j[j.Ignore=5]="Ignore",j[j.OpenBrowserOnce=6]="OpenBrowserOnce"})(En||(e.PortAutoForwardAction=En={}));class Rn{constructor(N,ce,Se,Ge,_e,lt){this.kind=N,this.name=ce,this.detail=Se,this.uri=Ge,this.range=_e,this.selectionRange=lt}}e.$OL=Rn;class Ln{constructor(N){this.uri=N}}e.$PL=Ln;class Mn{constructor(N,ce){this.original=N,this.modified=ce}}e.$QL=Mn;class Tn{constructor(N,ce,Se,Ge){this.base=N,this.input1=ce,this.input2=Se,this.result=Ge}}e.$RL=Tn;class Fn{constructor(N,ce){this.uri=N,this.viewType=ce}}e.$SL=Fn;class On{constructor(N){this.viewType=N}}e.$TL=On;class Nn{constructor(N,ce){this.uri=N,this.notebookType=ce}}e.$UL=Nn;class zn{constructor(N,ce,Se){this.original=N,this.modified=ce,this.notebookType=Se}}e.$VL=zn;class Un{constructor(){}}e.$WL=Un;class jn{constructor(N,ce){this.uri=N,this.inputBoxUri=ce}}e.$XL=jn;var Dn;(function(j){j[j.Up=1]="Up",j[j.Down=2]="Down"})(Dn||(e.InteractiveSessionVoteDirection=Dn={}));var kn;(function(j){j[j.Action=1]="Action",j[j.Toolbar=2]="Toolbar"})(kn||(e.InteractiveSessionCopyKind=kn={}));var Sn;(function(j){j[j.Unhelpful=0]="Unhelpful",j[j.Helpful=1]="Helpful",j[j.Undone=2]="Undone",j[j.Accepted=3]="Accepted"})(Sn||(e.InteractiveEditorResponseFeedbackKind=Sn={}));var In;(function(j){j[j.System=0]="System",j[j.User=1]="User",j[j.Assistant=2]="Assistant",j[j.Function=3]="Function"})(In||(e.ChatMessageRole=In={}));var Cn;(function(j){j[j.Short=1]="Short",j[j.Medium=2]="Medium",j[j.Full=3]="Full"})(Cn||(e.ChatVariableLevel=Cn={}));class Bn{constructor(N,ce){this.role=N,this.content=ce}}e.$YL=Bn;var Pn;(function(j){j[j.SymbolInformation=1]="SymbolInformation",j[j.CommandInformation=2]="CommandInformation",j[j.SearchInformation=3]="SearchInformation",j[j.SettingInformation=4]="SettingInformation"})(Pn||(e.RelatedInformationType=Pn={}))}),define(Ae[100],Re([1,0,51,13,15,278,136,7,18]),function(ie,e,h,C,I,O,R,u,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bM=e.$aM=e.$_L=void 0;const d=new Map;function A(m,f){f?d.set(m,f):d.delete(m)}e.$_L=A;function k(m){return d.get(m)}class a extends O.$Ou{constructor(f,t,s,c,v,S,p,n){super(t,s,c,v),this.c=f,this.m=S,this.q=p,this.notebook=n,this.b=!1}dispose(){(0,h.ok)(!this.b),this.b=!0,this.q=!1}equalLines(f){return(0,D.$sb)(this.f,f)}get document(){if(!this.a){const f=this;this.a={get uri(){return f.d},get fileName(){return f.d.fsPath},get isUntitled(){return f.d.scheme===C.Schemas.untitled},get languageId(){return f.m},get version(){return f.h},get isClosed(){return f.b},get isDirty(){return f.q},save(){return f.r()},getText(t){return t?f.s(t):f.getText()},get eol(){return f.g===`
`?u.EndOfLine.LF:u.EndOfLine.CRLF},get lineCount(){return f.f.length},lineAt(t){return f.t(t)},offsetAt(t){return f.u(t)},positionAt(t){return f.v(t)},validateRange(t){return f.w(t)},validatePosition(t){return f.x(t)},getWordRangeAtPosition(t,s){return f.y(t,s)}}}return Object.freeze(this.a)}_acceptLanguageId(f){(0,h.ok)(!this.b),this.m=f}_acceptIsDirty(f){(0,h.ok)(!this.b),this.q=f}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(f){const t=this.w(f);if(t.isEmpty)return"";if(t.isSingleLine)return this.f[t.start.line].substring(t.start.character,t.end.character);const s=this.g,c=t.start.line,v=t.end.line,S=[];S.push(this.f[c].substring(t.start.character));for(let p=c+1;p<v;p++)S.push(this.f[p]);return S.push(this.f[v].substring(0,t.end.character)),S.join(s)}t(f){let t;if(f instanceof u.$_J?t=f.line:typeof f=="number"&&(t=f),typeof t!="number"||t<0||t>=this.f.length||Math.floor(t)!==t)throw new Error("Illegal value for `line`");return new w(t,this.f[t],t===this.f.length-1)}u(f){return f=this.x(f),this.l(),this.j.getPrefixSum(f.line-1)+f.character}v(f){f=Math.floor(f),f=Math.max(0,f),this.l();const t=this.j.getIndexOf(f),s=this.f[t.index].length;return new u.$_J(t.index,Math.min(t.remainder,s))}w(f){if(!(f instanceof u.$aK))throw new Error("Invalid argument");const t=this.x(f.start),s=this.x(f.end);return t===f.start&&s===f.end?f:new u.$aK(t.line,t.character,s.line,s.character)}x(f){if(!(f instanceof u.$_J))throw new Error("Invalid argument");if(this.f.length===0)return f.with(0,0);let{line:t,character:s}=f,c=!1;if(t<0)t=0,s=0,c=!0;else if(t>=this.f.length)t=this.f.length-1,s=this.f[t].length,c=!0;else{const v=this.f[t].length;s<0?(s=0,c=!0):s>v&&(s=v,c=!0)}return c?new u.$_J(t,s):f}y(f,t){const s=this.x(f);if(!t)t=k(this.m);else if((0,I.$Me)(t))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${t.source}' because it matches the empty string.`);const c=(0,R.$2r)(s.character+1,(0,R.$Zr)(t),this.f[s.line],0);if(c)return new u.$aK(s.line,c.startColumn-1,s.line,c.endColumn-1)}}e.$aM=a;class w{constructor(f,t,s){this.a=f,this.b=t,this.c=s}get lineNumber(){return this.a}get text(){return this.b}get range(){return new u.$aK(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new u.$aK(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$bM=w}),define(Ae[196],Re([1,0,7,17,5]),function(ie,e,h,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0cc=void 0;let O=class{constructor(u){this.a=new h.$uL(h.ColorThemeKind.Dark),this.b=new I.$Ld}get activeColorTheme(){return this.a}$onColorThemeChange(u){let D;switch(u){case"light":D=h.ColorThemeKind.Light;break;case"hcDark":D=h.ColorThemeKind.HighContrast;break;case"hcLight":D=h.ColorThemeKind.HighContrastLight;break;default:D=h.ColorThemeKind.Dark}this.a=new h.$uL(D),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$0cc=O,e.$0cc=O=Je([qe(0,C.$0L)],O)}),define(Ae[197],Re([1,0,4]),function(ie,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mI=e.CellExecutionUpdateType=void 0;var C;(function(I){I[I.Output=1]="Output",I[I.OutputItems=2]="OutputItems",I[I.ExecutionState=3]="ExecutionState"})(C||(e.CellExecutionUpdateType=C={})),e.$mI=(0,h.$Lh)("INotebookExecutionService")}),define(Ae[45],Re([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2I=e.TestPosition=e.TestIdPathParts=void 0;var h;(function(O){O.Delimiter="\0"})(h||(e.TestIdPathParts=h={}));var C;(function(O){O[O.IsSame=0]="IsSame",O[O.Disconnected=1]="Disconnected",O[O.IsChild=2]="IsChild",O[O.IsParent=3]="IsParent"})(C||(e.TestPosition=C={}));class I{static fromExtHostTestItem(R,u,D=R.parent){if(R._isRoot)return new I([u]);const d=[R.id];for(let A=D;A&&A.id!==u;A=A.parent)d.push(A.id);return d.push(u),new I(d.reverse())}static isRoot(R){return!R.includes("\0")}static root(R){const u=R.indexOf("\0");return u===-1?R:R.slice(0,u)}static fromString(R){return new I(R.split("\0"))}static join(R,u){return new I([...R.path,u])}static joinToString(R,u){return R.toString()+"\0"+u}static parentId(R){const u=R.lastIndexOf("\0");return u===-1?void 0:R.slice(0,u)}static localId(R){const u=R.lastIndexOf("\0");return u===-1?R:R.slice(u+1)}static isChild(R,u){return u.startsWith(R)&&u[R.length]==="\0"}static compare(R,u){return R===u?0:I.isChild(R,u)?2:I.isChild(u,R)?3:1}constructor(R,u=R.length){if(this.path=R,this.d=u,R.length===0||u<1)throw new Error("cannot create test with empty path")}get rootId(){return new I(this.path,1)}get parentId(){return this.d>1?new I(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let R=1;R<=this.d;R++)yield new I(this.path,R)}*idsToRoot(){for(let R=this.d;R>0;R--)yield new I(this.path,R)}compare(R){if(typeof R=="string")return I.compare(this.toString(),R);for(let u=0;u<R.d&&u<this.d;u++)if(R.path[u]!==this.path[u])return 1;return R.d>this.d?2:R.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let R=1;R<this.d;R++)this.c+="\0",this.c+=this.path[R]}return this.c}}e.$2I=I}),define(Ae[57],Re([1,0,2,44,45]),function(ie,e,h,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9I=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.$8I=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$7I=e.$6I=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$5I=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$4I=e.$3I=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var O;(function(P){P[P.Unset=0]="Unset",P[P.Queued=1]="Queued",P[P.Running=2]="Running",P[P.Passed=3]="Passed",P[P.Failed=4]="Failed",P[P.Skipped=5]="Skipped",P[P.Errored=6]="Errored"})(O||(e.TestResultState=O={}));var R;(function(P){P[P.Run=1]="Run",P[P.Debug=2]="Debug",P[P.Coverage=3]="Coverage"})(R||(e.ExtTestRunProfileKind=R={}));var u;(function(P){P[P.Run=2]="Run",P[P.Debug=4]="Debug",P[P.Coverage=8]="Coverage",P[P.HasNonDefaultProfile=16]="HasNonDefaultProfile",P[P.HasConfigurable=32]="HasConfigurable",P[P.SupportsContinuousRun=64]="SupportsContinuousRun"})(u||(e.TestRunProfileBitset=u={})),e.$3I=[2,4,8,16,32,64];const D=P=>"runId"in P;e.$4I=D;var d;(function(P){P.serialize=l=>({range:l.range.toJSON(),uri:l.uri.toJSON()}),P.deserialize=l=>({range:C.$ms.lift(l.range),uri:h.URI.revive(l.uri)})})(d||(e.IRichLocation=d={}));var A;(function(P){P[P.Error=0]="Error",P[P.Output=1]="Output"})(A||(e.TestMessageType=A={}));var k;(function(P){P.serialize=l=>({message:l.message,type:0,expected:l.expected,actual:l.actual,contextValue:l.contextValue,location:l.location&&d.serialize(l.location)}),P.deserialize=l=>({message:l.message,type:0,expected:l.expected,actual:l.actual,contextValue:l.contextValue,location:l.location&&d.deserialize(l.location)})})(k||(e.ITestErrorMessage=k={}));const a=(P,l)=>`${l?"s":"e"}${P}`;e.$5I=a;var w;(function(P){P.serialize=l=>({message:l.message,type:1,offset:l.offset,length:l.length,location:l.location&&d.serialize(l.location)}),P.deserialize=l=>({message:l.message,type:1,offset:l.offset,length:l.length,location:l.location&&d.deserialize(l.location)})})(w||(e.ITestOutputMessage=w={}));var m;(function(P){P.serialize=l=>l.type===0?k.serialize(l):w.serialize(l),P.deserialize=l=>l.type===0?k.deserialize(l):w.deserialize(l)})(m||(e.ITestMessage=m={}));var f;(function(P){P.serializeWithoutMessages=l=>({state:l.state,duration:l.duration,messages:[]}),P.serialize=l=>({state:l.state,duration:l.duration,messages:l.messages.map(m.serialize)}),P.deserialize=l=>({state:l.state,duration:l.duration,messages:l.messages.map(m.deserialize)})})(f||(e.ITestTaskState=f={}));const t="\0",s=(P,l)=>P+t+l;e.$6I=s;const c=P=>{const l=P.indexOf(t);return{ctrlId:P.slice(0,l),tagId:P.slice(l+1)}};e.$7I=c;var v;(function(P){P.serialize=l=>({extId:l.extId,label:l.label,tags:l.tags,busy:l.busy,children:void 0,uri:l.uri?.toJSON(),range:l.range?.toJSON()||null,description:l.description,error:l.error,sortText:l.sortText}),P.deserialize=l=>({extId:l.extId,label:l.label,tags:l.tags,busy:l.busy,children:void 0,uri:l.uri?h.URI.revive(l.uri):void 0,range:l.range?C.$ms.lift(l.range):null,description:l.description,error:l.error,sortText:l.sortText})})(v||(e.ITestItem=v={}));var S;(function(P){P[P.NotExpandable=0]="NotExpandable",P[P.Expandable=1]="Expandable",P[P.BusyExpanding=2]="BusyExpanding",P[P.Expanded=3]="Expanded"})(S||(e.TestItemExpandState=S={}));var p;(function(P){P.serialize=l=>({expand:l.expand,item:v.serialize(l.item)}),P.deserialize=l=>({controllerId:I.$2I.root(l.item.extId),expand:l.expand,item:v.deserialize(l.item)})})(p||(e.InternalTestItem=p={}));var n;(function(P){P.serialize=l=>{let $;return l.item&&($={},l.item.label!==void 0&&($.label=l.item.label),l.item.tags!==void 0&&($.tags=l.item.tags),l.item.busy!==void 0&&($.busy=l.item.busy),l.item.uri!==void 0&&($.uri=l.item.uri?.toJSON()),l.item.range!==void 0&&($.range=l.item.range?.toJSON()),l.item.description!==void 0&&($.description=l.item.description),l.item.error!==void 0&&($.error=l.item.error),l.item.sortText!==void 0&&($.sortText=l.item.sortText)),{extId:l.extId,expand:l.expand,item:$}},P.deserialize=l=>{let $;return l.item&&($={},l.item.label!==void 0&&($.label=l.item.label),l.item.tags!==void 0&&($.tags=l.item.tags),l.item.busy!==void 0&&($.busy=l.item.busy),l.item.range!==void 0&&($.range=l.item.range?C.$ms.lift(l.item.range):null),l.item.description!==void 0&&($.description=l.item.description),l.item.error!==void 0&&($.error=l.item.error),l.item.sortText!==void 0&&($.sortText=l.item.sortText)),{extId:l.extId,expand:l.expand,item:$}}})(n||(e.ITestItemUpdate=n={}));const r=(P,l)=>{l.expand!==void 0&&(P.expand=l.expand),l.item!==void 0&&(P.item=P.item?Object.assign(P.item,l.item):l.item)};e.$8I=r;var i;(function(P){P.serializeWithoutMessages=l=>({...p.serialize(l),ownComputedState:l.ownComputedState,computedState:l.computedState,tasks:l.tasks.map(f.serializeWithoutMessages)}),P.serialize=l=>({...p.serialize(l),ownComputedState:l.ownComputedState,computedState:l.computedState,tasks:l.tasks.map(f.serialize)}),P.deserialize=l=>({...p.deserialize(l),ownComputedState:l.ownComputedState,computedState:l.computedState,tasks:l.tasks.map(f.deserialize),retired:!0})})(i||(e.TestResultItem=i={}));var o;(function(P){P[P.Function=0]="Function",P[P.Statement=1]="Statement"})(o||(e.DetailType=o={}));var y;(function(P){P[P.Add=0]="Add",P[P.Update=1]="Update",P[P.DocumentSynced=2]="DocumentSynced",P[P.Remove=3]="Remove",P[P.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",P[P.Retire=5]="Retire",P[P.AddTag=6]="AddTag",P[P.RemoveTag=7]="RemoveTag"})(y||(e.TestDiffOpType=y={}));var g;(function(P){P.deserialize=l=>l.op===0?{op:l.op,item:p.deserialize(l.item)}:l.op===1?{op:l.op,item:n.deserialize(l.item)}:l.op===2?{op:l.op,uri:h.URI.revive(l.uri),docv:l.docv}:l,P.serialize=l=>l.op===0?{op:l.op,item:p.serialize(l.item)}:l.op===1?{op:l.op,item:n.serialize(l.item)}:l})(g||(e.TestsDiffOp=g={}));class E{constructor(){this.d=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.d}apply(l){const $=this.p();for(const b of l)switch(b.op){case 0:this.k(p.deserialize(b.item),$);break;case 1:this.l(n.deserialize(b.item),$);break;case 3:this.m(b.itemId,$);break;case 5:this.o(b.itemId);break;case 4:this.updatePendingRoots(b.amount);break;case 6:this.d.set(b.tag.id,b.tag);break;case 7:this.d.delete(b.id);break}$.complete?.()}k(l,$){const b=I.$2I.parentId(l.item.extId)?.toString();let M;if(!b)M=this.q(l),this.g.add(M),this.f.set(l.item.extId,M);else if(this.f.has(b)){const U=this.f.get(b);U.children.add(l.item.extId),M=this.q(l,U),this.f.set(l.item.extId,M)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(l)}`);return}return $.add?.(M),l.expand===2&&this.h++,M}l(l,$){const b=this.f.get(l.extId);if(b)return l.expand!==void 0&&(b.expand===2&&this.h--,l.expand===2&&this.h++),(0,e.$8I)(b,l),$.update?.(b),b}m(l,$){const b=this.f.get(l);if(!b)return;const M=I.$2I.parentId(b.item.extId)?.toString();M?this.f.get(M).children.delete(b.item.extId):this.g.delete(b);const U=[[l]];for(;U.length;)for(const F of U.pop()){const q=this.f.get(F);q&&(U.push(q.children),this.f.delete(F),$.remove?.(q,q!==b),q.expand===2&&this.h--)}}o(l){}updatePendingRoots(l){this.j+=l}p(){return{}}}e.$9I=E}),define(Ae[76],Re([1,0,12,5,6,51,57,45]),function(ie,e,h,C,I,O,R,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4L=e.$3L=e.$2L=e.$1L=e.$ZL=e.TestItemEventOp=void 0;var D;(function(c){c[c.Upsert=0]="Upsert",c[c.SetTags=1]="SetTags",c[c.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",c[c.RemoveChild=3]="RemoveChild",c[c.SetProp=4]="SetProp",c[c.Bulk=5]="Bulk",c[c.DocumentSynced=6]="DocumentSynced"})(D||(e.TestItemEventOp=D={}));const d=(c,v)=>c===v,k=Object.entries({range:(c,v)=>c===v?!0:!c||!v?!1:c.equalsRange(v),busy:d,label:d,description:d,error:d,sortText:d,tags:(c,v)=>!(c.length!==v.length||c.some(S=>!v.includes(S)))}),a=(c,v)=>{let S;for(const[p,n]of k)n(c[p],v[p])||(S?S[p]=v[p]:S={[p]:v[p]});return S};class w extends I.$Qc{get root(){return this.s.root}constructor(v){super(),this.s=v,this.f=this.B(new h.$3g(()=>this.flushDiff(),200)),this.g=this.B(new C.$Ld),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.y(this.root,void 0)}set resolveHandler(v){this.h=v;for(const S of this.tree.values())this.I(S)}get resolveHandler(){return this.h}collectDiff(){const v=this.m;return this.m=[],v}pushDiff(v){switch(v.op){case 2:{for(const S of this.m)if(S.op===2&&S.uri===v.uri){S.docv=v.docv;return}break}case 1:{const S=this.m[this.m.length-1];if(S){if(S.op===1&&S.item.extId===v.item.extId){(0,R.$8I)(S.item,v.item);return}if(S.op===0&&S.item.item.extId===v.item.extId){(0,R.$8I)(S.item,v.item);return}}break}}this.m.push(v),this.f.isScheduled()||this.f.schedule()}expand(v,S){const p=this.tree.get(v);if(p){if((p.expandLevels===void 0||S>p.expandLevels)&&(p.expandLevels=S),p.expand===1){const n=this.L(p);return n.isOpen()?this.J(p,S-1):n.wait().then(()=>this.J(p,S-1))}else if(p.expand===3)return p.resolveBarrier?.isOpen()===!1?p.resolveBarrier.wait().then(()=>this.J(p,S-1)):this.J(p,S-1)}}dispose(){for(const v of this.tree.values())this.s.getApiFor(v.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}u(v,S){switch(S.op){case 3:this.N(u.$2I.joinToString(v.fullId,S.id));break;case 0:this.y(S.item,v);break;case 5:for(const p of S.ops)this.u(v,p);break;case 1:this.z(S.new,S.old,v.fullId.toString());break;case 2:this.I(v);break;case 4:this.pushDiff({op:1,item:{extId:v.fullId.toString(),item:S.update}});break;case 6:this.w(v.actual.uri);break;default:(0,O.$2c)(S)}}w(v){v&&this.pushDiff({op:2,uri:v,docv:this.s.getDocumentVersion(v)})}y(v,S){const p=u.$2I.fromExtHostTestItem(v,this.root.id,S?.actual),n=this.s.getApiFor(v);n.parent&&n.parent!==S?.actual&&this.s.getChildren(n.parent).delete(v.id);let r=this.tree.get(p.toString());if(!r){r={fullId:p,actual:v,expandLevels:S?.expandLevels?S.expandLevels-1:void 0,expand:0},v.tags.forEach(this.C,this),this.tree.set(r.fullId.toString(),r),this.F(v,S),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:r.expand,item:this.s.toITestItem(v)}}),this.H(v,r,S);return}if(r.actual===v){this.G(v,r,S);return}if(r.actual.uri?.toString()!==v.uri?.toString())return this.N(p.toString()),this.y(v,S);const i=this.s.getChildren(r.actual),o=r.actual,y=a(this.s.toITestItem(o),this.s.toITestItem(v));this.s.getApiFor(o).listener=void 0,r.actual=v,r.expand=0,y&&(y.hasOwnProperty("tags")&&(this.z(v.tags,o.tags,p.toString()),delete y.tags),this.u(r,{op:4,update:y})),this.H(v,r,S);for(const[g,E]of i)this.s.getChildren(v).get(E.id)||this.N(u.$2I.joinToString(p,E.id));this.w(r.actual.uri)}z(v,S,p){const n=new Set(S.map(r=>r.id));for(const r of v)n.delete(r.id)||this.C(r);this.pushDiff({op:1,item:{extId:p,item:{tags:v.map(r=>(0,R.$6I)(this.s.controllerId,r.id))}}}),n.forEach(this.D,this)}C(v){const S=this.j.get(v.id);S?S.refCount++:(this.j.set(v.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,R.$6I)(this.s.controllerId,v.id)}}))}D(v){const S=this.j.get(v);S&&!--S.refCount&&(this.j.delete(v),this.pushDiff({op:7,id:(0,R.$6I)(this.s.controllerId,v)}))}F(v,S){this.s.getApiFor(v).parent=S&&S.actual!==this.root?S.actual:void 0}G(v,S,p){this.F(v,p);const n=this.s.getApiFor(v);n.parent=p?.actual,n.listener=r=>this.u(S,r),this.I(S)}H(v,S,p){this.G(v,S,p);for(const[n,r]of this.s.getChildren(v))this.y(r,S)}I(v){let S;this.h?v.resolveBarrier?S=v.resolveBarrier.isOpen()?3:2:S=v.actual.canResolveChildren?1:0:S=0,S!==v.expand&&(v.expand=S,this.pushDiff({op:1,item:{extId:v.fullId.toString(),expand:S}}),S===1&&v.expandLevels!==void 0&&this.L(v))}J(v,S){if(S<0)return;const p=[];for(const[n,r]of this.s.getChildren(v.actual)){const i=this.expand(u.$2I.joinToString(v.fullId,r.id),S);(0,h.$Dg)(i)&&p.push(i)}if(p.length)return Promise.all(p).then(()=>{})}L(v){if(v.resolveBarrier)return v.resolveBarrier;if(!this.h){const r=new h.$Pg;return r.open(),r}v.expand=2,this.M(v);const S=v.resolveBarrier=new h.$Pg,p=r=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,r)};let n;try{n=this.h(v.actual===this.root?void 0:v.actual)}catch(r){p(r)}return(0,h.$Dg)(n)?n.catch(p).then(()=>{S.open(),this.I(v)}):(S.open(),this.I(v)),v.resolveBarrier}M(v){this.pushDiff({op:1,item:{extId:v.fullId.toString(),expand:v.expand}})}N(v){const S=this.tree.get(v);if(!S)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:v});const p=[S];for(;p.length;){const n=p.pop();if(n){this.s.getApiFor(n.actual).listener=void 0;for(const r of n.actual.tags)this.D(r.id);this.tree.delete(n.fullId.toString());for(const[r,i]of this.s.getChildren(n.actual))p.push(this.tree.get(u.$2I.joinToString(n.fullId,i.id)))}}}flushDiff(){const v=this.collectDiff();v.length&&this.g.fire(v)}}e.$ZL=w;class m extends Error{constructor(v){super(`Attempted to insert a duplicate test item ID ${v}`)}}e.$1L=m;class f extends Error{constructor(v){super(`TestItem with ID "${v}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$2L=f;class t extends Error{constructor(v,S,p){super(`TestItem with ID "${v}" is from controller "${S}" and cannot be added as a child of an item from controller "${p}".`)}}e.$3L=t;const s=(c,v,S)=>{let p=new Map;return{get size(){return p.size},forEach(n,r){for(const i of p.values())n.call(r,i,this)},[Symbol.iterator](){return p.entries()},replace(n){const r=new Map,i=new Set(p.keys()),o={op:5,ops:[]};for(const y of n){if(!(y instanceof S))throw new f(y.id);const g=v(y).controllerId;if(g!==c.controllerId)throw new t(y.id,g,c.controllerId);if(r.has(y.id))throw new m(y.id);r.set(y.id,y),i.delete(y.id),o.ops.push({op:0,item:y})}for(const y of i.keys())o.ops.push({op:3,id:y});c.listener?.(o),p=r},add(n){if(!(n instanceof S))throw new f(n.id);p.set(n.id,n),c.listener?.({op:0,item:n})},delete(n){p.delete(n)&&c.listener?.({op:3,id:n})},get(n){return p.get(n)},toJSON(){return Array.from(p.values())}}};e.$4L=s}),define(Ae[101],Re([1,0,76]),function(ie,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6L=e.$5L=void 0;const C=new WeakMap,I=(R,u)=>{const D={controllerId:u};return C.set(R,D),D};e.$5L=I;const O=R=>{const u=C.get(R);if(!u)throw new h.$2L(R?.id||"<unknown>");return u};e.$6L=O}),define(Ae[77],Re([1,0,13,2]),function(ie,e,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zob=e.$Yob=e.$Xob=e.$Wob=e.$Vob=void 0,e.$Vob="vscode-cdn.net",e.$Wob=`vscode-resource.${e.$Vob}`,e.$Xob=`'self' https://*.${e.$Vob}`;function I(u,D){return u.scheme===h.Schemas.http||u.scheme===h.Schemas.https?u:(D&&D.authority&&D.isRemote&&u.scheme===h.Schemas.file&&(u=C.URI.from({scheme:h.Schemas.vscodeRemote,authority:D.authority,path:u.path})),C.URI.from({scheme:h.Schemas.https,authority:`${u.scheme}+${O(u.authority)}.${e.$Wob}`,path:u.path,fragment:u.fragment,query:u.query}))}e.$Yob=I;function O(u){return u.replace(/./g,D=>{const d=D.charCodeAt(0);return d>=97&&d<=122||d>=65&&d<=90||d>=48&&d<=57?D:"-"+d.toString(16).padStart(4,"0")})}function R(u){return u.replace(/-([0-9a-f]{4})/g,(D,d)=>String.fromCharCode(parseInt(d,16)))}e.$Zob=R}),define(Ae[198],Re([1,0,5,6,77]),function(ie,e,h,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hcc=void 0;class O{constructor(u,D,d){this.d=u,this.e=D,this.f=d,this.a=0,this.b=new C.$Pc,this.c=new Map,this.b.add(D.onDidChangeVisibleTextEditors(()=>{const A=D.getVisibleTextEditors();for(const k of this.c.values())A.indexOf(k.editor)<0&&k.inset.dispose()}))}dispose(){this.c.forEach(u=>u.inset.dispose()),this.b.dispose()}createWebviewEditorInset(u,D,d,A,k){let a;for(const v of this.e.getVisibleTextEditors(!0))if(v.value===u){a=v;break}if(!a)throw new Error("not a visible editor");const w=this,m=this.a++,f=new h.$Ld,t=new h.$Ld,s=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(v){return(0,I.$Yob)(v,w.f)}get cspSource(){return I.$Xob}set options(v){this.b=v,w.d.$setOptions(m,v)}get options(){return this.b}set html(v){this.a=v,w.d.$setHtml(m,v)}get html(){return this.a}get onDidReceiveMessage(){return f.event}postMessage(v){return w.d.$postMessage(m,v)}},c=new class{constructor(){this.editor=u,this.line=D,this.height=d,this.webview=s,this.onDidDispose=t.event}dispose(){w.c.has(m)&&(w.c.delete(m),w.d.$disposeEditorInset(m),t.fire(),t.dispose(),f.dispose())}};return this.d.$createEditorInset(m,a.id,a.value.document.uri,D+1,d,A||{},k.identifier,k.extensionLocation),this.c.set(m,{editor:u,inset:c,onDidReceiveMessage:f}),c}$onDidDispose(u){const D=this.c.get(u);D&&D.inset.dispose()}$onDidReceiveMessage(u,D){this.c.get(u)?.onDidReceiveMessage.fire(D)}}e.$Hcc=O}),define(Ae[199],Re([1,0,4]),function(ie,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WM=e.VariableKind=e.$VM=void 0,e.$VM=(0,h.$Lh)("configurationResolverService");var C;(function(O){O.Unknown="unknown",O.Env="env",O.Config="config",O.Command="command",O.Input="input",O.ExtensionInstallFolder="extensionInstallFolder",O.WorkspaceFolder="workspaceFolder",O.Cwd="cwd",O.WorkspaceFolderBasename="workspaceFolderBasename",O.UserHome="userHome",O.LineNumber="lineNumber",O.SelectedText="selectedText",O.File="file",O.FileWorkspaceFolder="fileWorkspaceFolder",O.RelativeFile="relativeFile",O.RelativeFileDirname="relativeFileDirname",O.FileDirname="fileDirname",O.FileExtname="fileExtname",O.FileBasename="fileBasename",O.FileBasenameNoExtension="fileBasenameNoExtension",O.FileDirnameBasename="fileDirnameBasename",O.ExecPath="execPath",O.ExecInstallFolder="execInstallFolder",O.PathSeparator="pathSeparator"})(C||(e.VariableKind=C={}));class I extends Error{constructor(R,u){super(u),this.variable=R}}e.$WM=I}),define(Ae[200],Re([1,0,19,74,16,24,22,90,165,199,15]),function(ie,e,h,C,I,O,R,u,D,d,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$M=void 0;class k{constructor(w,m,f,t){this.h=new Map,this.a=w,this.b=m,this.g=f,t&&(this.c=t.then(s=>this.i(s)))}i(w){if(R.$d){const m=Object.create(null);return Object.keys(w).forEach(f=>{m[f.toLowerCase()]=w[f]}),m}return w}resolveWithEnvironment(w,m,f){return this.l({env:this.i(w),userHome:void 0},m?m.uri:void 0,f)}async resolveAsync(w,m){const f={env:await this.c,userHome:await this.g};return this.l(f,w?w.uri:void 0,m)}async j(w,m,f,t){const s=O.$Xm(m);R.$d&&s.windows?Object.keys(s.windows).forEach(v=>s[v]=s.windows[v]):R.$e&&s.osx?Object.keys(s.osx).forEach(v=>s[v]=s.osx[v]):R.$f&&s.linux&&Object.keys(s.linux).forEach(v=>s[v]=s.linux[v]),delete s.windows,delete s.osx,delete s.linux;const c={env:await this.c,userHome:await this.g};return this.l(c,w?w.uri:void 0,s,f,t)}async resolveAnyAsync(w,m,f){return this.j(w,m,f)}async resolveAnyMap(w,m,f){const t=new Map;return{newConfig:await this.j(w,m,f,t),resolvedVariables:t}}resolveWithInteractionReplace(w,m,f,t){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(w,m,f,t){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(w,m){if(this.h.has(w))throw new Error("Variable "+w+" is contributed twice.");this.h.set(w,m)}async l(w,m,f,t,s){if(I.$wf(f))return this.m(w,m,f,t,s);if(Array.isArray(f))return Promise.all(f.map(c=>this.l(w,m,c,t,s)));if(I.$yf(f)){const c=Object.create(null),v=await Promise.all(Object.keys(f).map(async S=>[await this.m(w,m,S,t,s),await this.l(w,m,f[S],t,s)]));for(const[S,p]of v)c[S]=p;return c}return f}m(w,m,f,t,s){return(0,A.$Re)(f,k.VARIABLE_REGEXP,async(c,v)=>{if(v.includes(k.VARIABLE_LHS))return c;let S=await this.o(w,c,v,m,t);return s?.set(v,S),S!==c&&I.$wf(S)&&S.match(k.VARIABLE_REGEXP)&&(S=await this.m(w,m,S,t,s)),S})}n(w){return this.b?this.b.getUriLabel(w,{noPrefix:!0}):w.fsPath}async o(w,m,f,t,s){let c;const v=f.split(":");v.length>1&&(f=v[0],c=v[1]);const S=r=>{const i=this.a.getFilePath();if(i)return(0,u.$kv)(i);throw new d.$WM(r,(0,D.localize)(0,null,m))},p=r=>{const i=S(r);if(this.a.getWorkspaceFolderPathForFile){const o=this.a.getWorkspaceFolderPathForFile();if(o)return(0,u.$kv)(o)}throw new d.$WM(r,(0,D.localize)(1,null,m,h.$lc(i)))},n=r=>{if(c){const i=this.a.getFolderUri(c);if(i)return i;throw new d.$WM(r,(0,D.localize)(2,null,m,c))}if(t)return t;throw this.a.getWorkspaceFolderCount()>1?new d.$WM(r,(0,D.localize)(3,null,m)):new d.$WM(r,(0,D.localize)(4,null,m))};switch(f){case"env":if(c){if(w.env){const r=w.env[R.$d?c.toLowerCase():c];if(I.$wf(r))return r}return""}throw new d.$WM(d.VariableKind.Env,(0,D.localize)(5,null,m));case"config":if(c){const r=this.a.getConfigurationValue(t,c);if(I.$Ff(r))throw new d.$WM(d.VariableKind.Config,(0,D.localize)(6,null,m,c));if(I.$yf(r))throw new d.$WM(d.VariableKind.Config,(0,D.localize)(7,null,m,c));return r}throw new d.$WM(d.VariableKind.Config,(0,D.localize)(8,null,m));case"command":return this.p(d.VariableKind.Command,m,c,s,"command");case"input":return this.p(d.VariableKind.Input,m,c,s,"input");case"extensionInstallFolder":if(c){const r=await this.a.getExtension(c);if(!r)throw new d.$WM(d.VariableKind.ExtensionInstallFolder,(0,D.localize)(9,null,m,c));return this.n(r.extensionLocation)}throw new d.$WM(d.VariableKind.ExtensionInstallFolder,(0,D.localize)(10,null,m));default:switch(f){case"workspaceRoot":case"workspaceFolder":return(0,u.$kv)(this.n(n(d.VariableKind.WorkspaceFolder)));case"cwd":return t||c?(0,u.$kv)(this.n(n(d.VariableKind.Cwd))):C.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,u.$kv)(h.$lc(this.n(n(d.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(w.userHome)return w.userHome;throw new d.$WM(d.VariableKind.UserHome,(0,D.localize)(11,null,m))}case"lineNumber":{const r=this.a.getLineNumber();if(r)return r;throw new d.$WM(d.VariableKind.LineNumber,(0,D.localize)(12,null,m))}case"selectedText":{const r=this.a.getSelectedText();if(r)return r;throw new d.$WM(d.VariableKind.SelectedText,(0,D.localize)(13,null,m))}case"file":return S(d.VariableKind.File);case"fileWorkspaceFolder":return p(d.VariableKind.FileWorkspaceFolder);case"relativeFile":return t||c?h.$jc(this.n(n(d.VariableKind.RelativeFile)),S(d.VariableKind.RelativeFile)):S(d.VariableKind.RelativeFile);case"relativeFileDirname":{const r=h.$kc(S(d.VariableKind.RelativeFileDirname));if(t||c){const i=h.$jc(this.n(n(d.VariableKind.RelativeFileDirname)),r);return i.length===0?".":i}return r}case"fileDirname":return h.$kc(S(d.VariableKind.FileDirname));case"fileExtname":return h.$mc(S(d.VariableKind.FileExtname));case"fileBasename":return h.$lc(S(d.VariableKind.FileBasename));case"fileBasenameNoExtension":{const r=h.$lc(S(d.VariableKind.FileBasenameNoExtension));return r.slice(0,r.length-h.$mc(r).length)}case"fileDirnameBasename":return h.$lc(h.$kc(S(d.VariableKind.FileDirnameBasename)));case"execPath":{const r=this.a.getExecPath();return r||m}case"execInstallFolder":{const r=this.a.getAppRoot();return r||m}case"pathSeparator":return h.sep;default:try{const r=c?`${f}:${c}`:f;return this.p(d.VariableKind.Unknown,m,r,s,void 0)}catch{return m}}}}p(w,m,f,t,s){if(f&&t){const c=s===void 0?t[f]:t[s+":"+f];if(typeof c=="string")return c;throw new d.$WM(w,(0,D.localize)(14,null,m))}return m}}e.$$M=k,k.VARIABLE_LHS="${",k.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(Ae[102],Re([1,0,4,99]),function(ie,e,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_B=e.$$B=e.OpenEditorContext=e.GroupsOrder=e.$0B=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$9B=void 0,e.$9B=(0,h.$Lh)("editorGroupsService");var I;(function(m){m[m.UP=0]="UP",m[m.DOWN=1]="DOWN",m[m.LEFT=2]="LEFT",m[m.RIGHT=3]="RIGHT"})(I||(e.GroupDirection=I={}));var O;(function(m){m[m.HORIZONTAL=0]="HORIZONTAL",m[m.VERTICAL=1]="VERTICAL"})(O||(e.GroupOrientation=O={}));var R;(function(m){m[m.FIRST=0]="FIRST",m[m.LAST=1]="LAST",m[m.NEXT=2]="NEXT",m[m.PREVIOUS=3]="PREVIOUS"})(R||(e.GroupLocation=R={}));var u;(function(m){m[m.MAXIMIZE=0]="MAXIMIZE",m[m.EVEN=1]="EVEN",m[m.TOGGLE=2]="TOGGLE"})(u||(e.GroupsArrangement=u={}));var D;(function(m){m[m.COPY_EDITORS=0]="COPY_EDITORS",m[m.MOVE_EDITORS=1]="MOVE_EDITORS"})(D||(e.MergeGroupMode=D={}));function d(m){const f=m;return(0,C.$YD)(f?.editor)&&(0,C.$YD)(f?.replacement)}e.$0B=d;var A;(function(m){m[m.CREATION_TIME=0]="CREATION_TIME",m[m.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",m[m.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(A||(e.GroupsOrder=A={}));var k;(function(m){m[m.NEW_EDITOR=1]="NEW_EDITOR",m[m.MOVE_EDITOR=2]="MOVE_EDITOR",m[m.COPY_EDITOR=3]="COPY_EDITOR"})(k||(e.OpenEditorContext=k={}));function a(m){const f=m;return!!f&&typeof f.id=="number"&&Array.isArray(f.editors)}e.$$B=a;function w(m){return m.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.$_B=w}),define(Ae[201],Re([1,0,4,102]),function(ie,e,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dC=e.$cC=e.$bC=e.$aC=void 0,e.$aC=(0,h.$Lh)("editorService"),e.$bC=-1,e.$cC=-2;function I(O){const R=O;return typeof O=="number"||(0,C.$$B)(R)}e.$dC=I}),define(Ae[8],Re([1,0,18,25,124,202,49,28,116,68,67,24,16,2,44,78,94,101,99,75,45,57,201,7]),function(ie,e,h,C,I,O,R,u,D,d,A,k,a,w,m,f,t,s,c,v,S,p,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalQuickFix=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.ChatMessageRole=e.ChatMessage=e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.$9L=e.$8L=e.MarkdownString=e.$7L=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var i;(function(Pe){function Le(G){const{selectionStartLineNumber:Me,selectionStartColumn:Be,positionLineNumber:Qe,positionColumn:Ve}=G,tt=new r.$_J(Me-1,Be-1),vt=new r.$_J(Qe-1,Ve-1);return new r.$bK(tt,vt)}Pe.to=Le;function be(G){const{anchor:Me,active:Be}=G;return{selectionStartLineNumber:Me.line+1,selectionStartColumn:Me.character+1,positionLineNumber:Be.line+1,positionColumn:Be.character+1}}Pe.from=be})(i||(e.Selection=i={}));var o;(function(Pe){function Le(G){if(!G)return;const{start:Me,end:Be}=G;return{startLineNumber:Me.line+1,startColumn:Me.character+1,endLineNumber:Be.line+1,endColumn:Be.character+1}}Pe.from=Le;function be(G){if(!G)return;const{startLineNumber:Me,startColumn:Be,endLineNumber:Qe,endColumn:Ve}=G;return new r.$aK(Me-1,Be-1,Qe-1,Ve-1)}Pe.to=be})(o||(e.Range=o={}));var y;(function(Pe){function Le(be){switch(be){case 1:return r.StandardTokenType.Comment;case 0:return r.StandardTokenType.Other;case 3:return r.StandardTokenType.RegEx;case 2:return r.StandardTokenType.String}}Pe.to=Le})(y||(e.TokenType=y={}));var g;(function(Pe){function Le(G){return new r.$_J(G.lineNumber-1,G.column-1)}Pe.to=Le;function be(G){return{lineNumber:G.line+1,column:G.character+1}}Pe.from=be})(g||(e.Position=g={}));var E;(function(Pe){function Le(Me,Be,Qe){return(0,h.$Fb)((0,h.$1b)(Me).map(Ve=>be(Ve,Be,Qe)))}Pe.from=Le;function be(Me,Be,Qe){if(typeof Me=="string")return{$serialized:!0,language:Me,isBuiltin:Qe?.isBuiltin};if(Me)return{$serialized:!0,language:Me.language,scheme:G(Me.scheme,Be),pattern:ot.from(Me.pattern)??void 0,exclusive:Me.exclusive,notebookType:Me.notebookType,isBuiltin:Qe?.isBuiltin}}function G(Me,Be){return Be&&typeof Me=="string"?Be.transformOutgoingScheme(Me):Me}})(E||(e.DocumentSelector=E={}));var P;(function(Pe){function Le(G){switch(G){case r.DiagnosticTag.Unnecessary:return 1;case r.DiagnosticTag.Deprecated:return 2}}Pe.from=Le;function be(G){switch(G){case 1:return r.DiagnosticTag.Unnecessary;case 2:return r.DiagnosticTag.Deprecated;default:return}}Pe.to=be})(P||(e.DiagnosticTag=P={}));var l;(function(Pe){function Le(G){let Me;return G.code&&((0,a.$wf)(G.code)||(0,a.$Af)(G.code)?Me=String(G.code):Me={value:String(G.code.value),target:G.code.target}),{...o.from(G.range),message:G.message,source:G.source,code:Me,severity:b.from(G.severity),relatedInformation:G.relatedInformation&&G.relatedInformation.map($.from),tags:Array.isArray(G.tags)?(0,h.$Fb)(G.tags.map(P.from)):void 0}}Pe.from=Le;function be(G){const Me=new r.$mK(o.to(G),G.message,b.to(G.severity));return Me.source=G.source,Me.code=(0,a.$wf)(G.code)?G.code:G.code?.value,Me.relatedInformation=G.relatedInformation&&G.relatedInformation.map($.to),Me.tags=G.tags&&(0,h.$Fb)(G.tags.map(P.to)),Me}Pe.to=be})(l||(e.Diagnostic=l={}));var $;(function(Pe){function Le(G){return{...o.from(G.location.range),message:G.message,resource:G.location.uri}}Pe.from=Le;function be(G){return new r.$lK(new r.$kK(G.resource,o.to(G)),G.message)}Pe.to=be})($||(e.DiagnosticRelatedInformation=$={}));var b;(function(Pe){function Le(G){switch(G){case r.DiagnosticSeverity.Error:return t.MarkerSeverity.Error;case r.DiagnosticSeverity.Warning:return t.MarkerSeverity.Warning;case r.DiagnosticSeverity.Information:return t.MarkerSeverity.Info;case r.DiagnosticSeverity.Hint:return t.MarkerSeverity.Hint}return t.MarkerSeverity.Error}Pe.from=Le;function be(G){switch(G){case t.MarkerSeverity.Info:return r.DiagnosticSeverity.Information;case t.MarkerSeverity.Warning:return r.DiagnosticSeverity.Warning;case t.MarkerSeverity.Error:return r.DiagnosticSeverity.Error;case t.MarkerSeverity.Hint:return r.DiagnosticSeverity.Hint;default:return r.DiagnosticSeverity.Error}}Pe.to=be})(b||(e.DiagnosticSeverity=b={}));var M;(function(Pe){function Le(G){return typeof G=="number"&&G>=r.ViewColumn.One?G-1:G===r.ViewColumn.Beside?n.$cC:n.$bC}Pe.from=Le;function be(G){if(typeof G=="number"&&G>=0)return G+1;throw new Error("invalid 'EditorGroupColumn'")}Pe.to=be})(M||(e.ViewColumn=M={}));function U(Pe){return typeof Pe.range<"u"}function F(Pe){return Pe.length===0?!0:!!U(Pe[0])}e.$7L=F;var q;(function(Pe){function Le(Ve){return Ve.map(Pe.from)}Pe.fromMany=Le;function be(Ve){return Ve&&typeof Ve=="object"&&typeof Ve.language=="string"&&typeof Ve.value=="string"}function G(Ve){let tt;if(be(Ve)){const{language:ut,value:pt}=Ve;tt={value:"```"+ut+`
`+pt+"\n```\n"}}else r.$yK.isMarkdownString(Ve)?tt={value:Ve.value,isTrusted:Ve.isTrusted,supportThemeIcons:Ve.supportThemeIcons,supportHtml:Ve.supportHtml,baseUri:Ve.baseUri}:typeof Ve=="string"?tt={value:Ve}:tt={value:""};const vt=Object.create(null);tt.uris=vt;const Lt=ut=>{try{let pt=w.URI.parse(ut,!0);pt=pt.with({query:Me(pt.query,vt)}),vt[ut]=pt}catch{}return""},yt=new D.marked.Renderer;return yt.link=Lt,yt.image=ut=>typeof ut=="string"?Lt(R.$6j(ut).href):"",(0,D.marked)(tt.value,{renderer:yt}),tt}Pe.from=G;function Me(Ve,tt){if(!Ve)return Ve;let vt;try{vt=(0,d.$hh)(Ve)}catch{}if(!vt)return Ve;let Lt=!1;return vt=(0,k.$Zm)(vt,yt=>{if(w.URI.isUri(yt)){const ut=`__uri_${Math.random().toString(16).slice(2,8)}`;return tt[ut]=yt,Lt=!0,ut}else return}),Lt?JSON.stringify(vt):Ve}function Be(Ve){const tt=new r.$yK(Ve.value,Ve.supportThemeIcons);return tt.isTrusted=Ve.isTrusted,tt.supportHtml=Ve.supportHtml,tt.baseUri=Ve.baseUri?w.URI.from(Ve.baseUri):void 0,tt}Pe.to=Be;function Qe(Ve){if(Ve)return typeof Ve=="string"?Ve:Pe.from(Ve)}Pe.fromStrict=Qe})(q||(e.MarkdownString=q={}));function W(Pe){return F(Pe)?Pe.map(Le=>({range:o.from(Le.range),hoverMessage:Array.isArray(Le.hoverMessage)?q.fromMany(Le.hoverMessage):Le.hoverMessage?q.from(Le.hoverMessage):void 0,renderOptions:Le.renderOptions})):Pe.map(Le=>({range:o.from(Le)}))}e.$8L=W;function L(Pe){return typeof Pe>"u"?Pe:typeof Pe=="string"?w.URI.file(Pe):Pe}e.$9L=L;var z;(function(Pe){function Le(be){return typeof be>"u"?be:{contentText:be.contentText,contentIconPath:be.contentIconPath?L(be.contentIconPath):void 0,border:be.border,borderColor:be.borderColor,fontStyle:be.fontStyle,fontWeight:be.fontWeight,textDecoration:be.textDecoration,color:be.color,backgroundColor:be.backgroundColor,margin:be.margin,width:be.width,height:be.height}}Pe.from=Le})(z||(e.ThemableDecorationAttachmentRenderOptions=z={}));var K;(function(Pe){function Le(be){return typeof be>"u"?be:{backgroundColor:be.backgroundColor,outline:be.outline,outlineColor:be.outlineColor,outlineStyle:be.outlineStyle,outlineWidth:be.outlineWidth,border:be.border,borderColor:be.borderColor,borderRadius:be.borderRadius,borderSpacing:be.borderSpacing,borderStyle:be.borderStyle,borderWidth:be.borderWidth,fontStyle:be.fontStyle,fontWeight:be.fontWeight,textDecoration:be.textDecoration,cursor:be.cursor,color:be.color,opacity:be.opacity,letterSpacing:be.letterSpacing,gutterIconPath:be.gutterIconPath?L(be.gutterIconPath):void 0,gutterIconSize:be.gutterIconSize,overviewRulerColor:be.overviewRulerColor,before:be.before?z.from(be.before):void 0,after:be.after?z.from(be.after):void 0}}Pe.from=Le})(K||(e.ThemableDecorationRenderOptions=K={}));var B;(function(Pe){function Le(be){if(typeof be>"u")return be;switch(be){case r.DecorationRangeBehavior.OpenOpen:return 0;case r.DecorationRangeBehavior.ClosedClosed:return 1;case r.DecorationRangeBehavior.OpenClosed:return 2;case r.DecorationRangeBehavior.ClosedOpen:return 3}}Pe.from=Le})(B||(e.DecorationRangeBehavior=B={}));var me;(function(Pe){function Le(be){return{isWholeLine:be.isWholeLine,rangeBehavior:be.rangeBehavior?B.from(be.rangeBehavior):void 0,overviewRulerLane:be.overviewRulerLane,light:be.light?K.from(be.light):void 0,dark:be.dark?K.from(be.dark):void 0,backgroundColor:be.backgroundColor,outline:be.outline,outlineColor:be.outlineColor,outlineStyle:be.outlineStyle,outlineWidth:be.outlineWidth,border:be.border,borderColor:be.borderColor,borderRadius:be.borderRadius,borderSpacing:be.borderSpacing,borderStyle:be.borderStyle,borderWidth:be.borderWidth,fontStyle:be.fontStyle,fontWeight:be.fontWeight,textDecoration:be.textDecoration,cursor:be.cursor,color:be.color,opacity:be.opacity,letterSpacing:be.letterSpacing,gutterIconPath:be.gutterIconPath?L(be.gutterIconPath):void 0,gutterIconSize:be.gutterIconSize,overviewRulerColor:be.overviewRulerColor,before:be.before?z.from(be.before):void 0,after:be.after?z.from(be.after):void 0}}Pe.from=Le})(me||(e.DecorationRenderOptions=me={}));var ye;(function(Pe){function Le(G){return{text:G.newText,eol:G.newEol&&xe.from(G.newEol),range:o.from(G.range)}}Pe.from=Le;function be(G){const Me=new r.$fK(o.to(G.range),G.text);return Me.newEol=typeof G.eol>"u"?void 0:xe.to(G.eol),Me}Pe.to=be})(ye||(e.TextEdit=ye={}));var Ie;(function(Pe){function Le(G,Me){const Be={edits:[]};if(G instanceof r.$iK){const Qe=new u.$zc;for(const Ve of G._allEntries())Ve._type===1&&w.URI.isUri(Ve.to)&&Ve.from===void 0&&Qe.add(Ve.to);for(const Ve of G._allEntries())if(Ve._type===1){let tt;Ve.options?.contents&&(ArrayBuffer.isView(Ve.options.contents)?tt={type:"base64",value:(0,C.$te)(C.$_d.wrap(Ve.options.contents))}:tt={type:"dataTransferItem",id:Ve.options.contents._itemId}),Be.edits.push({oldResource:Ve.from,newResource:Ve.to,options:{...Ve.options,contents:tt},metadata:Ve.metadata})}else Ve._type===2?Be.edits.push({resource:Ve.uri,textEdit:ye.from(Ve.edit),versionId:Qe.has(Ve.uri)?void 0:Me?.getTextDocumentVersion(Ve.uri),metadata:Ve.metadata}):Ve._type===6?Be.edits.push({resource:Ve.uri,textEdit:{range:o.from(Ve.range),text:Ve.edit.value,insertAsSnippet:!0},versionId:Qe.has(Ve.uri)?void 0:Me?.getTextDocumentVersion(Ve.uri),metadata:Ve.metadata}):Ve._type===3?Be.edits.push({metadata:Ve.metadata,resource:Ve.uri,cellEdit:Ve.edit,notebookMetadata:Ve.notebookMetadata,notebookVersionId:Me?.getNotebookDocumentVersion(Ve.uri)}):Ve._type===5&&Be.edits.push({metadata:Ve.metadata,resource:Ve.uri,notebookVersionId:Me?.getNotebookDocumentVersion(Ve.uri),cellEdit:{editType:1,index:Ve.index,count:Ve.count,cells:Ve.cells.map(mt.from)}})}return Be}Pe.from=Le;function be(G){const Me=new r.$iK,Be=new u.$yc;for(const Qe of G.edits)if(Qe.textEdit){const Ve=Qe,tt=w.URI.revive(Ve.resource),vt=o.to(Ve.textEdit.range),Lt=Ve.textEdit.text,yt=Ve.textEdit.insertAsSnippet;let ut;yt?ut=r.$hK.replace(vt,new r.$jK(Lt)):ut=r.$fK.replace(vt,Lt);const pt=Be.get(tt);pt?pt.push(ut):Be.set(tt,[ut])}else Me.renameFile(w.URI.revive(Qe.oldResource),w.URI.revive(Qe.newResource),Qe.options);for(const[Qe,Ve]of Be)Me.set(Qe,Ve);return Me}Pe.to=be})(Ie||(e.WorkspaceEdit=Ie={}));var _;(function(Pe){const Le=Object.create(null);Le[r.SymbolKind.File]=0,Le[r.SymbolKind.Module]=1,Le[r.SymbolKind.Namespace]=2,Le[r.SymbolKind.Package]=3,Le[r.SymbolKind.Class]=4,Le[r.SymbolKind.Method]=5,Le[r.SymbolKind.Property]=6,Le[r.SymbolKind.Field]=7,Le[r.SymbolKind.Constructor]=8,Le[r.SymbolKind.Enum]=9,Le[r.SymbolKind.Interface]=10,Le[r.SymbolKind.Function]=11,Le[r.SymbolKind.Variable]=12,Le[r.SymbolKind.Constant]=13,Le[r.SymbolKind.String]=14,Le[r.SymbolKind.Number]=15,Le[r.SymbolKind.Boolean]=16,Le[r.SymbolKind.Array]=17,Le[r.SymbolKind.Object]=18,Le[r.SymbolKind.Key]=19,Le[r.SymbolKind.Null]=20,Le[r.SymbolKind.EnumMember]=21,Le[r.SymbolKind.Struct]=22,Le[r.SymbolKind.Event]=23,Le[r.SymbolKind.Operator]=24,Le[r.SymbolKind.TypeParameter]=25;function be(Me){return typeof Le[Me]=="number"?Le[Me]:6}Pe.from=be;function G(Me){for(const Be in Le)if(Le[Be]===Me)return Number(Be);return r.SymbolKind.Property}Pe.to=G})(_||(e.SymbolKind=_={}));var de;(function(Pe){function Le(G){switch(G){case r.SymbolTag.Deprecated:return 1}}Pe.from=Le;function be(G){switch(G){case 1:return r.SymbolTag.Deprecated}}Pe.to=be})(de||(e.SymbolTag=de={}));var De;(function(Pe){function Le(G){return{name:G.name,kind:_.from(G.kind),tags:G.tags&&G.tags.map(de.from),containerName:G.containerName,location:Q.from(G.location)}}Pe.from=Le;function be(G){const Me=new r.$pK(G.name,_.to(G.kind),G.containerName,Q.to(G.location));return Me.tags=G.tags&&G.tags.map(de.to),Me}Pe.to=be})(De||(e.WorkspaceSymbol=De={}));var ue;(function(Pe){function Le(G){const Me={name:G.name||"!!MISSING: name!!",detail:G.detail,range:o.from(G.range),selectionRange:o.from(G.selectionRange),kind:_.from(G.kind),tags:G.tags?.map(de.from)??[]};return G.children&&(Me.children=G.children.map(Le)),Me}Pe.from=Le;function be(G){const Me=new r.$qK(G.name,G.detail,_.to(G.kind),o.to(G.range),o.to(G.selectionRange));return(0,h.$Jb)(G.tags)&&(Me.tags=G.tags.map(de.to)),G.children&&(Me.children=G.children.map(be)),Me}Pe.to=be})(ue||(e.DocumentSymbol=ue={}));var ve;(function(Pe){function Le(G){const Me=new r.$uK(_.to(G.kind),G.name,G.detail||"",w.URI.revive(G.uri),o.to(G.range),o.to(G.selectionRange));return Me._sessionId=G._sessionId,Me._itemId=G._itemId,Me}Pe.to=Le;function be(G,Me,Be){if(Me=Me??G._sessionId,Be=Be??G._itemId,Me===void 0||Be===void 0)throw new Error("invalid item");return{_sessionId:Me,_itemId:Be,name:G.name,detail:G.detail,kind:_.from(G.kind),uri:G.uri,range:o.from(G.range),selectionRange:o.from(G.selectionRange),tags:G.tags?.map(de.from)}}Pe.from=be})(ve||(e.CallHierarchyItem=ve={}));var ke;(function(Pe){function Le(be){return new r.$vK(ve.to(be.from),be.fromRanges.map(G=>o.to(G)))}Pe.to=Le})(ke||(e.CallHierarchyIncomingCall=ke={}));var V;(function(Pe){function Le(be){return new r.$wK(ve.to(be.to),be.fromRanges.map(G=>o.to(G)))}Pe.to=Le})(V||(e.CallHierarchyOutgoingCall=V={}));var Q;(function(Pe){function Le(G){return{range:G.range&&o.from(G.range),uri:G.uri}}Pe.from=Le;function be(G){return new r.$kK(w.URI.revive(G.uri),o.to(G.range))}Pe.to=be})(Q||(e.location=Q={}));var ee;(function(Pe){function Le(G){const Me=G,Be=G;return{originSelectionRange:Me.originSelectionRange?o.from(Me.originSelectionRange):void 0,uri:Me.targetUri?Me.targetUri:Be.uri,range:o.from(Me.targetRange?Me.targetRange:Be.range),targetSelectionRange:Me.targetSelectionRange?o.from(Me.targetSelectionRange):void 0}}Pe.from=Le;function be(G){return{targetUri:w.URI.revive(G.uri),targetRange:o.to(G.range),targetSelectionRange:G.targetSelectionRange?o.to(G.targetSelectionRange):void 0,originSelectionRange:G.originSelectionRange?o.to(G.originSelectionRange):void 0}}Pe.to=be})(ee||(e.DefinitionLink=ee={}));var $e;(function(Pe){function Le(G){return{range:o.from(G.range),contents:q.fromMany(G.contents)}}Pe.from=Le;function be(G){return new r.$nK(G.contents.map(q.to),o.to(G.range))}Pe.to=be})($e||(e.Hover=$e={}));var he;(function(Pe){function Le(G){return{range:o.from(G.range),expression:G.expression}}Pe.from=Le;function be(G){return new r.$gL(o.to(G.range),G.expression)}Pe.to=be})(he||(e.EvaluatableExpression=he={}));var fe;(function(Pe){function Le(G){if(G instanceof r.$hL)return{type:"text",range:o.from(G.range),text:G.text};if(G instanceof r.$iL)return{type:"variable",range:o.from(G.range),variableName:G.variableName,caseSensitiveLookup:G.caseSensitiveLookup};if(G instanceof r.$jL)return{type:"expression",range:o.from(G.range),expression:G.expression};throw new Error("Unknown 'InlineValue' type")}Pe.from=Le;function be(G){switch(G.type){case"text":return{range:o.to(G.range),text:G.text};case"variable":return{range:o.to(G.range),variableName:G.variableName,caseSensitiveLookup:G.caseSensitiveLookup};case"expression":return{range:o.to(G.range),expression:G.expression}}}Pe.to=be})(fe||(e.InlineValue=fe={}));var Ee;(function(Pe){function Le(G){return{frameId:G.frameId,stoppedLocation:o.from(G.stoppedLocation)}}Pe.from=Le;function be(G){return new r.$kL(G.frameId,o.to(G.stoppedLocation))}Pe.to=be})(Ee||(e.InlineValueContext=Ee={}));var re;(function(Pe){function Le(G){return{range:o.from(G.range),kind:G.kind}}Pe.from=Le;function be(G){return new r.$oK(o.to(G.range),G.kind)}Pe.to=be})(re||(e.DocumentHighlight=re={}));var le;(function(Pe){function Le(be){switch(be){case 1:return r.CompletionTriggerKind.TriggerCharacter;case 2:return r.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return r.CompletionTriggerKind.Invoke}}Pe.to=Le})(le||(e.CompletionTriggerKind=le={}));var oe;(function(Pe){function Le(be){return{triggerKind:le.to(be.triggerKind),triggerCharacter:be.triggerCharacter}}Pe.to=Le})(oe||(e.CompletionContext=oe={}));var ae;(function(Pe){function Le(G){switch(G){case r.CompletionItemTag.Deprecated:return 1}}Pe.from=Le;function be(G){switch(G){case 1:return r.CompletionItemTag.Deprecated}}Pe.to=be})(ae||(e.CompletionItemTag=ae={}));var pe;(function(Pe){const Le=new Map([[r.CompletionItemKind.Method,0],[r.CompletionItemKind.Function,1],[r.CompletionItemKind.Constructor,2],[r.CompletionItemKind.Field,3],[r.CompletionItemKind.Variable,4],[r.CompletionItemKind.Class,5],[r.CompletionItemKind.Interface,7],[r.CompletionItemKind.Struct,6],[r.CompletionItemKind.Module,8],[r.CompletionItemKind.Property,9],[r.CompletionItemKind.Unit,12],[r.CompletionItemKind.Value,13],[r.CompletionItemKind.Constant,14],[r.CompletionItemKind.Enum,15],[r.CompletionItemKind.EnumMember,16],[r.CompletionItemKind.Keyword,17],[r.CompletionItemKind.Snippet,27],[r.CompletionItemKind.Text,18],[r.CompletionItemKind.Color,19],[r.CompletionItemKind.File,20],[r.CompletionItemKind.Reference,21],[r.CompletionItemKind.Folder,23],[r.CompletionItemKind.Event,10],[r.CompletionItemKind.Operator,11],[r.CompletionItemKind.TypeParameter,24],[r.CompletionItemKind.Issue,26],[r.CompletionItemKind.User,25]]);function be(Be){return Le.get(Be)??9}Pe.from=be;const G=new Map([[0,r.CompletionItemKind.Method],[1,r.CompletionItemKind.Function],[2,r.CompletionItemKind.Constructor],[3,r.CompletionItemKind.Field],[4,r.CompletionItemKind.Variable],[5,r.CompletionItemKind.Class],[7,r.CompletionItemKind.Interface],[6,r.CompletionItemKind.Struct],[8,r.CompletionItemKind.Module],[9,r.CompletionItemKind.Property],[12,r.CompletionItemKind.Unit],[13,r.CompletionItemKind.Value],[14,r.CompletionItemKind.Constant],[15,r.CompletionItemKind.Enum],[16,r.CompletionItemKind.EnumMember],[17,r.CompletionItemKind.Keyword],[27,r.CompletionItemKind.Snippet],[18,r.CompletionItemKind.Text],[19,r.CompletionItemKind.Color],[20,r.CompletionItemKind.File],[21,r.CompletionItemKind.Reference],[23,r.CompletionItemKind.Folder],[10,r.CompletionItemKind.Event],[11,r.CompletionItemKind.Operator],[24,r.CompletionItemKind.TypeParameter],[25,r.CompletionItemKind.User],[26,r.CompletionItemKind.Issue]]);function Me(Be){return G.get(Be)??r.CompletionItemKind.Property}Pe.to=Me})(pe||(e.CompletionItemKind=pe={}));var Ce;(function(Pe){function Le(be,G){const Me=new r.$EK(be.label);return Me.insertText=be.insertText,Me.kind=pe.to(be.kind),Me.tags=be.tags?.map(ae.to),Me.detail=be.detail,Me.documentation=R.$1j(be.documentation)?q.to(be.documentation):be.documentation,Me.sortText=be.sortText,Me.filterText=be.filterText,Me.preselect=be.preselect,Me.commitCharacters=be.commitCharacters,m.$ms.isIRange(be.range)?Me.range=o.to(be.range):typeof be.range=="object"&&(Me.range={inserting:o.to(be.range.insert),replacing:o.to(be.range.replace)}),Me.keepWhitespace=typeof be.insertTextRules>"u"?!1:!!(be.insertTextRules&1),typeof be.insertTextRules<"u"&&be.insertTextRules&4?Me.insertText=new r.$jK(be.insertText):(Me.insertText=be.insertText,Me.textEdit=Me.range instanceof r.$aK?new r.$fK(Me.range,Me.insertText):void 0),be.additionalTextEdits&&be.additionalTextEdits.length>0&&(Me.additionalTextEdits=be.additionalTextEdits.map(Be=>ye.to(Be))),Me.command=G&&be.command?G.fromInternal(be.command):void 0,Me}Pe.to=Le})(Ce||(e.CompletionItem=Ce={}));var T;(function(Pe){function Le(G){if(typeof G.label!="string"&&!Array.isArray(G.label))throw new TypeError("Invalid label");return{label:G.label,documentation:q.fromStrict(G.documentation)}}Pe.from=Le;function be(G){return{label:G.label,documentation:R.$1j(G.documentation)?q.to(G.documentation):G.documentation}}Pe.to=be})(T||(e.ParameterInformation=T={}));var H;(function(Pe){function Le(G){return{label:G.label,documentation:q.fromStrict(G.documentation),parameters:Array.isArray(G.parameters)?G.parameters.map(T.from):[],activeParameter:G.activeParameter}}Pe.from=Le;function be(G){return{label:G.label,documentation:R.$1j(G.documentation)?q.to(G.documentation):G.documentation,parameters:Array.isArray(G.parameters)?G.parameters.map(T.to):[],activeParameter:G.activeParameter}}Pe.to=be})(H||(e.SignatureInformation=H={}));var X;(function(Pe){function Le(G){return{activeSignature:G.activeSignature,activeParameter:G.activeParameter,signatures:Array.isArray(G.signatures)?G.signatures.map(H.from):[]}}Pe.from=Le;function be(G){return{activeSignature:G.activeSignature,activeParameter:G.activeParameter,signatures:Array.isArray(G.signatures)?G.signatures.map(H.to):[]}}Pe.to=be})(X||(e.SignatureHelp=X={}));var Y;(function(Pe){function Le(be,G){const Me=new r.$DK(g.to(G.position),typeof G.label=="string"?G.label:G.label.map(J.to.bind(void 0,be)),G.kind&&te.to(G.kind));return Me.textEdits=G.textEdits&&G.textEdits.map(ye.to),Me.tooltip=R.$1j(G.tooltip)?q.to(G.tooltip):G.tooltip,Me.paddingLeft=G.paddingLeft,Me.paddingRight=G.paddingRight,Me}Pe.to=Le})(Y||(e.InlayHint=Y={}));var J;(function(Pe){function Le(be,G){const Me=new r.$CK(G.label);return Me.tooltip=R.$1j(G.tooltip)?q.to(G.tooltip):G.tooltip,f.Command.is(G.command)&&(Me.command=be.fromInternal(G.command)),G.location&&(Me.location=Q.to(G.location)),Me}Pe.to=Le})(J||(e.InlayHintLabelPart=J={}));var te;(function(Pe){function Le(G){return G}Pe.from=Le;function be(G){return G}Pe.to=be})(te||(e.InlayHintKind=te={}));var se;(function(Pe){function Le(G){return{range:o.from(G.range),url:G.target,tooltip:G.tooltip}}Pe.from=Le;function be(G){let Me;if(G.url)try{Me=typeof G.url=="string"?w.URI.parse(G.url,!0):w.URI.revive(G.url)}catch{}return new r.$JK(o.to(G.range),Me)}Pe.to=be})(se||(e.DocumentLink=se={}));var Fe;(function(Pe){function Le(G){const Me=new r.$MK(G.label);return G.textEdit&&(Me.textEdit=ye.to(G.textEdit)),G.additionalTextEdits&&(Me.additionalTextEdits=G.additionalTextEdits.map(Be=>ye.to(Be))),Me}Pe.to=Le;function be(G){return{label:G.label,textEdit:G.textEdit?ye.from(G.textEdit):void 0,additionalTextEdits:G.additionalTextEdits?G.additionalTextEdits.map(Me=>ye.from(Me)):void 0}}Pe.from=be})(Fe||(e.ColorPresentation=Fe={}));var je;(function(Pe){function Le(G){return new r.$KK(G[0],G[1],G[2],G[3])}Pe.to=Le;function be(G){return[G.red,G.green,G.blue,G.alpha]}Pe.from=be})(je||(e.Color=je={}));var Xe;(function(Pe){function Le(G){return{range:o.from(G.range)}}Pe.from=Le;function be(G){return new r.$tK(o.to(G.range))}Pe.to=be})(Xe||(e.SelectionRange=Xe={}));var He;(function(Pe){function Le(be){switch(be){case 2:return r.TextDocumentSaveReason.AfterDelay;case 1:return r.TextDocumentSaveReason.Manual;case 3:case 4:return r.TextDocumentSaveReason.FocusOut}}Pe.to=Le})(He||(e.TextDocumentSaveReason=He={}));var et;(function(Pe){function Le(G){switch(G){case r.TextEditorLineNumbersStyle.Off:return 0;case r.TextEditorLineNumbersStyle.Relative:return 2;case r.TextEditorLineNumbersStyle.On:default:return 1}}Pe.from=Le;function be(G){switch(G){case 0:return r.TextEditorLineNumbersStyle.Off;case 2:return r.TextEditorLineNumbersStyle.Relative;case 1:default:return r.TextEditorLineNumbersStyle.On}}Pe.to=be})(et||(e.TextEditorLineNumbersStyle=et={}));var xe;(function(Pe){function Le(G){if(G===r.EndOfLine.CRLF)return 1;if(G===r.EndOfLine.LF)return 0}Pe.from=Le;function be(G){if(G===1)return r.EndOfLine.CRLF;if(G===0)return r.EndOfLine.LF}Pe.to=be})(xe||(e.EndOfLine=xe={}));var it;(function(Pe){function Le(be){if(typeof be=="object")return be.viewId;switch(be){case r.ProgressLocation.SourceControl:return 3;case r.ProgressLocation.Window:return 10;case r.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Pe.from=Le})(it||(e.ProgressLocation=it={}));var st;(function(Pe){function Le(G){const Me={start:G.start+1,end:G.end+1};return G.kind&&(Me.kind=nt.from(G.kind)),Me}Pe.from=Le;function be(G){const Me={start:G.start-1,end:G.end-1};return G.kind&&(Me.kind=nt.to(G.kind)),Me}Pe.to=be})(st||(e.FoldingRange=st={}));var nt;(function(Pe){function Le(G){if(G)switch(G){case r.FoldingRangeKind.Comment:return f.$bt.Comment;case r.FoldingRangeKind.Imports:return f.$bt.Imports;case r.FoldingRangeKind.Region:return f.$bt.Region}}Pe.from=Le;function be(G){if(G)switch(G.value){case f.$bt.Comment.value:return r.FoldingRangeKind.Comment;case f.$bt.Imports.value:return r.FoldingRangeKind.Imports;case f.$bt.Region.value:return r.FoldingRangeKind.Region}}Pe.to=be})(nt||(e.FoldingRangeKind=nt={}));var Ue;(function(Pe){function Le(be){if(be)return{pinned:typeof be.preview=="boolean"?!be.preview:void 0,inactive:be.background,preserveFocus:be.preserveFocus,selection:typeof be.selection=="object"?o.from(be.selection):void 0,override:typeof be.override=="boolean"?c.$LD.id:void 0}}Pe.from=Le})(Ue||(e.TextEditorOpenOptions=Ue={}));var ot;(function(Pe){function Le(Be){return Be instanceof r.$7K?Be.toJSON():typeof Be=="string"?Be:be(Be)||G(Be)?new r.$7K(Be.baseUri??Be.base,Be.pattern).toJSON():Be}Pe.from=Le;function be(Be){const Qe=Be;return Qe?w.URI.isUri(Qe.baseUri)&&typeof Qe.pattern=="string":!1}function G(Be){const Qe=Be;return Qe?typeof Qe.base=="string"&&typeof Qe.pattern=="string":!1}function Me(Be){return typeof Be=="string"?Be:new r.$7K(w.URI.revive(Be.baseUri),Be.pattern)}Pe.to=Me})(ot||(e.GlobPattern=ot={}));var x;(function(Pe){function Le(be){if(be){if(Array.isArray(be))return be.map(Le);if(typeof be=="string")return be;{const G=be;return{language:G.language,scheme:G.scheme,pattern:ot.from(G.pattern),exclusive:G.exclusive,notebookType:G.notebookType}}}else return}Pe.from=Le})(x||(e.LanguageSelector=x={}));var Z;(function(Pe){function Le(G){return!!G&&typeof G=="object"&&"documents"in G&&Array.isArray(G.documents)&&G.documents.every(Me=>Array.isArray(Me)&&Me.every(Be=>Be&&typeof Be=="object"&&"uri"in Be&&w.URI.isUri(Be.uri)&&"version"in Be&&typeof Be.version=="number"&&"ranges"in Be&&Array.isArray(Be.ranges)&&Be.ranges.every(Qe=>Qe instanceof r.$aK)))}Pe.is=Le;function be(G){return{documents:G.documents.map(Me=>Me.map(Be=>({uri:w.URI.from(Be.uri),version:Be.version,ranges:Be.ranges.map(Qe=>o.from(Qe))})))}}Pe.from=be})(Z||(e.MappedEditsContext=Z={}));var we;(function(Pe){function Le(G){return{start:G.start,end:G.end}}Pe.from=Le;function be(G){return new r.$vL(G.start,G.end)}Pe.to=be})(we||(e.NotebookRange=we={}));var We;(function(Pe){function Le(G){return{timing:typeof G.runStartTime=="number"&&typeof G.runEndTime=="number"?{startTime:G.runStartTime,endTime:G.runEndTime}:void 0,executionOrder:G.executionOrder,success:G.lastRunSuccess}}Pe.to=Le;function be(G){return{lastRunSuccess:G.success,runStartTime:G.timing?.startTime,runEndTime:G.timing?.endTime,executionOrder:G.executionOrder}}Pe.from=be})(We||(e.NotebookCellExecutionSummary=We={}));var ze;(function(Pe){function Le(be){if(be===v.NotebookCellExecutionState.Unconfirmed)return r.NotebookCellExecutionState.Pending;if(be===v.NotebookCellExecutionState.Pending)return;if(be===v.NotebookCellExecutionState.Executing)return r.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${be}`)}Pe.to=Le})(ze||(e.NotebookCellExecutionState=ze={}));var Ze;(function(Pe){function Le(G){switch(G){case r.NotebookCellKind.Markup:return v.CellKind.Markup;case r.NotebookCellKind.Code:default:return v.CellKind.Code}}Pe.from=Le;function be(G){switch(G){case v.CellKind.Markup:return r.NotebookCellKind.Markup;case v.CellKind.Code:default:return r.NotebookCellKind.Code}}Pe.to=be})(Ze||(e.NotebookCellKind=Ze={}));var at;(function(Pe){function Le(G){const Me={metadata:G.metadata??Object.create(null),cells:[]};for(const Be of G.cells)r.$wL.validate(Be),Me.cells.push(mt.from(Be));return Me}Pe.from=Le;function be(G){const Me=new r.$xL(G.cells.map(mt.to));return(0,a.$Jf)(G.metadata)||(Me.metadata=G.metadata),Me}Pe.to=be})(at||(e.NotebookData=at={}));var mt;(function(Pe){function Le(G){return{cellKind:Ze.from(G.kind),language:G.languageId,mime:G.mime,source:G.value,metadata:G.metadata,internalMetadata:We.from(G.executionSummary??{}),outputs:G.outputs?G.outputs.map(Tt.from):[]}}Pe.from=Le;function be(G){return new r.$wL(Ze.to(G.cellKind),G.source,G.language,G.mime,G.outputs?G.outputs.map(Tt.to):void 0,G.metadata,G.internalMetadata?We.to(G.internalMetadata):void 0)}Pe.to=be})(mt||(e.NotebookCellData=mt={}));var bt;(function(Pe){function Le(G){return{mime:G.mime,valueBytes:C.$_d.wrap(G.data)}}Pe.from=Le;function be(G){return new r.$yL(G.valueBytes.buffer,G.mime)}Pe.to=be})(bt||(e.NotebookCellOutputItem=bt={}));var Tt;(function(Pe){function Le(G){return{outputId:G.id,items:G.items.map(bt.from),metadata:G.metadata}}Pe.from=Le;function be(G){const Me=G.items.map(bt.to);return new r.$zL(Me,G.outputId,G.metadata)}Pe.to=be})(Tt||(e.NotebookCellOutput=Tt={}));var Xt;(function(Pe){function Le(Me){return G(Me)?{include:ot.from(Me.include)??void 0,exclude:ot.from(Me.exclude)??void 0}:ot.from(Me)??void 0}Pe.from=Le;function be(Me){return G(Me)?{include:ot.to(Me.include),exclude:ot.to(Me.exclude)}:ot.to(Me)}Pe.to=be;function G(Me){const Be=Me;return Be?!(0,a.$Ff)(Be.include)&&!(0,a.$Ff)(Be.exclude):!1}})(Xt||(e.NotebookExclusiveDocumentPattern=Xt={}));var qt;(function(Pe){function Le(be,G,Me){const Be=typeof be.command=="string"?{title:"",command:be.command}:be.command;return{alignment:be.alignment===r.NotebookCellStatusBarAlignment.Left?1:2,command:G.toInternal(Be,Me),text:be.text,tooltip:be.tooltip,accessibilityInformation:be.accessibilityInformation,priority:be.priority}}Pe.from=Le})(qt||(e.NotebookStatusBarItem=qt={}));var wt;(function(Pe){function Le(be,G,Me){const Be=typeof be.command=="string"?{title:"",command:be.command}:be.command;return{command:G.toInternal(Be,Me),label:be.label,description:be.description,detail:be.detail,documentation:be.documentation}}Pe.from=Le})(wt||(e.NotebookKernelSourceAction=wt={}));var Nt;(function(Pe){function Le(be){return{transientOutputs:be?.transientOutputs??!1,transientCellMetadata:be?.transientCellMetadata??{},transientDocumentMetadata:be?.transientDocumentMetadata??{},cellContentMetadata:be?.cellContentMetadata??{}}}Pe.from=Le})(Nt||(e.NotebookDocumentContentOptions=Nt={}));var zt;(function(Pe){function Le(G){return{uri:G.uri,provides:G.provides}}Pe.from=Le;function be(G){return new r.$BL(w.URI.revive(G.uri),G.provides)}Pe.to=be})(zt||(e.NotebookRendererScript=zt={}));var Zt;(function(Pe){function Le(G){return{message:q.fromStrict(G.message)||"",type:0,expected:G.expectedOutput,actual:G.actualOutput,contextValue:G.contextValue,location:G.location&&{range:o.from(G.location.range),uri:G.location.uri}}}Pe.from=Le;function be(G){const Me=new r.$HL(typeof G.message=="string"?G.message:q.to(G.message));return Me.actualOutput=G.actual,Me.expectedOutput=G.expected,Me.contextValue=G.contextValue,Me.location=G.location?Q.to(G.location):void 0,Me}Pe.to=be})(Zt||(e.TestMessage=Zt={}));var Ut;(function(Pe){Pe.namespace=p.$6I,Pe.denamespace=p.$7I})(Ut||(e.TestTag=Ut={}));var jt;(function(Pe){function Le(G){const Me=(0,s.$6L)(G).controllerId;return{extId:S.$2I.fromExtHostTestItem(G,Me).toString(),label:G.label,uri:w.URI.revive(G.uri),busy:G.busy,tags:G.tags.map(Be=>Ut.namespace(Me,Be.id)),range:m.$ms.lift(o.from(G.range)),description:G.description||null,sortText:G.sortText||null,error:G.error&&q.fromStrict(G.error)||null}}Pe.from=Le;function be(G){return{parent:void 0,error:void 0,id:S.$2I.fromString(G.extId).localId,label:G.label,uri:w.URI.revive(G.uri),tags:(G.tags||[]).map(Me=>{const{tagId:Be}=Ut.denamespace(Me);return new r.$IL(Be)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:o.to(G.range||void 0),canResolveChildren:!1,busy:G.busy,description:G.description||void 0,sortText:G.sortText||void 0}}Pe.toPlain=be})(jt||(e.TestItem=jt={})),function(Pe){function Le(G){return{id:G.id}}Pe.from=Le;function be(G){return new r.$IL(G.id)}Pe.to=be}(Ut||(e.TestTag=Ut={}));var Kt;(function(Pe){const Le=(G,Me)=>{const Be=[];for(const[Ve,tt]of Me)S.$2I.compare(tt.item.extId,Ve)===2&&(Me.delete(Ve),Be.push(tt));const Qe={...jt.toPlain(G.item),parent:void 0,taskStates:G.tasks.map(Ve=>({state:Ve.state,duration:Ve.duration,messages:Ve.messages.filter(tt=>tt.type===0).map(Zt.to)})),children:Be.map(Ve=>Le(Ve,Me))};for(const Ve of Qe.children)Ve.parent=Qe;return Qe};function be(G){const Me=[],Be=new Map;for(const Qe of G.items){Be.set(Qe.item.extId,Qe);const Ve=S.$2I.root(Qe.item.extId);G.request.targets.some(tt=>tt.controllerId===Ve&&tt.testIds.includes(Qe.item.extId))&&Me.push(Qe)}return{completedAt:G.completedAt,results:Me.map(Qe=>Le(Qe,Be))}}Pe.to=be})(Kt||(e.TestResults=Kt={}));var Gt;(function(Pe){function Le(Be){return{covered:Be.covered,total:Be.covered}}function be(Be){return"line"in Be?g.from(Be):o.from(Be)}function G(Be){return"branches"in Be?{count:Be.executionCount,location:be(Be.location),type:1,branches:Be.branches.length?Be.branches.map(Qe=>({count:Qe.executionCount,location:Qe.location&&be(Qe.location)})):void 0}:{type:0,count:Be.executionCount,location:be(Be.location)}}Pe.fromDetailed=G;function Me(Be){return{uri:Be.uri,statement:Le(Be.statementCoverage),branch:Be.branchCoverage&&Le(Be.branchCoverage),function:Be.functionCoverage&&Le(Be.functionCoverage),details:Be.detailedCoverage?.map(G)}}Pe.fromFile=Me})(Gt||(e.TestCoverage=Gt={}));var Bt;(function(Pe){function Le(be){switch(be){case 1:return r.CodeActionTriggerKind.Invoke;case 2:return r.CodeActionTriggerKind.Automatic}}Pe.to=Le})(Bt||(e.CodeActionTriggerKind=Bt={}));var Ht;(function(Pe){function Le(G){const Me=new r.$OL(_.to(G.kind),G.name,G.detail||"",w.URI.revive(G.uri),o.to(G.range),o.to(G.selectionRange));return Me._sessionId=G._sessionId,Me._itemId=G._itemId,Me}Pe.to=Le;function be(G,Me,Be){if(Me=Me??G._sessionId,Be=Be??G._itemId,Me===void 0||Be===void 0)throw new Error("invalid item");return{_sessionId:Me,_itemId:Be,kind:_.from(G.kind),name:G.name,detail:G.detail??"",uri:G.uri,range:o.from(G.range),selectionRange:o.from(G.selectionRange),tags:G.tags?.map(de.from)}}Pe.from=be})(Ht||(e.TypeHierarchyItem=Ht={}));var Jt;(function(Pe){function Le(be){if(be)return{value:be.value,tooltip:be.tooltip}}Pe.from=Le})(Jt||(e.ViewBadge=Jt={}));var ct;(function(Pe){function Le(Be,Qe,Ve){const tt=Qe.fileData;return tt?new r.$ZK(new r.$1K(tt.name,w.URI.revive(tt.uri),tt.id,(0,O.$bb)(()=>Ve(tt.id)))):Be===A.$Jr.uriList&&Qe.uriListData?new r.$YK(Me(Qe.uriListData)):new r.$YK(Qe.asString)}Pe.to=Le;async function be(Be,Qe){const Ve=await Qe.asString();if(Be===A.$Jr.uriList)return{asString:Ve,fileData:void 0,uriListData:G(Ve)};const tt=Qe.asFile();return{asString:Ve,fileData:tt?{name:tt.name,uri:tt.uri,id:tt._itemId??tt.id}:void 0}}Pe.from=be;function G(Be){return I.$Vs.split(Be).map(Qe=>{if(Qe.startsWith("#"))return Qe;try{return w.URI.parse(Qe)}catch{}return Qe})}function Me(Be){return I.$Vs.create(Be.map(Qe=>typeof Qe=="string"?Qe:w.URI.revive(Qe)))}})(ct||(e.DataTransferItem=ct={}));var gt;(function(Pe){function Le(G,Me){const Be=G.items.map(([Qe,Ve])=>[Qe,ct.to(Qe,Ve,Me)]);return new r.$2K(Be)}Pe.toDataTransfer=Le;async function be(G){const Me={items:[]},Be=[];for(const[Qe,Ve]of G)Be.push((async()=>{Me.items.push([Qe,await ct.from(Qe,Ve)])})());return await Promise.all(Be),Me}Pe.from=be})(gt||(e.DataTransfer=gt={}));var It;(function(Pe){function Le(G){return{message:G.message,metadata:G.metadata,title:G.title,tooltip:G.tooltip}}Pe.to=Le;function be(G){return{kind:"reply",message:G.message,metadata:G.metadata,title:G.title,tooltip:G.tooltip}}Pe.from=be})(It||(e.ChatReplyFollowup=It={}));var Rt;(function(Pe){function Le(be){return typeof be=="string"?{title:be,message:be,kind:"reply"}:"commandId"in be?{kind:"command",title:be.title??"",commandId:be.commandId??"",when:be.when??"",args:be.args}:It.from(be)}Pe.from=Le})(Rt||(e.ChatFollowup=Rt={}));var Ct;(function(Pe){function Le(G){const Me=new r.$YL(ft.to(G.role),G.content);return Me.name=G.name,Me}Pe.to=Le;function be(G){return{role:ft.from(G.role),content:G.content,name:G.name}}Pe.from=be})(Ct||(e.ChatMessage=Ct={}));var ft;(function(Pe){function Le(G){switch(G){case 0:return r.ChatMessageRole.System;case 1:return r.ChatMessageRole.User;case 2:return r.ChatMessageRole.Assistant;case 3:return r.ChatMessageRole.Function}}Pe.to=Le;function be(G){switch(G){case r.ChatMessageRole.System:return 0;case r.ChatMessageRole.Assistant:return 2;case r.ChatMessageRole.Function:return 3;case r.ChatMessageRole.User:default:return 1}}Pe.from=be})(ft||(e.ChatMessageRole=ft={}));var kt;(function(Pe){function Le(G){return{level:Pt.to(G.level),value:G.value,description:G.description}}Pe.to=Le;function be(G){return{level:Pt.from(G.level),value:G.value,description:G.description}}Pe.from=be})(kt||(e.ChatVariable=kt={}));var Pt;(function(Pe){function Le(G){switch(G){case"short":return r.ChatVariableLevel.Short;case"medium":return r.ChatVariableLevel.Medium;case"full":default:return r.ChatVariableLevel.Full}}Pe.to=Le;function be(G){switch(G){case r.ChatVariableLevel.Short:return"short";case r.ChatVariableLevel.Medium:return"medium";case r.ChatVariableLevel.Full:default:return"full"}}Pe.from=be})(Pt||(e.ChatVariableLevel=Pt={}));var Ft;(function(Pe){function Le(be){switch(be){case 1:return r.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return r.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return r.InteractiveEditorResponseFeedbackKind.Undone;case 3:return r.InteractiveEditorResponseFeedbackKind.Accepted}}Pe.to=Le})(Ft||(e.InteractiveEditorResponseFeedbackKind=Ft={}));var Ke;(function(Pe){function Le(be,G,Me){return"terminalCommand"in be?{terminalCommand:be.terminalCommand}:"uri"in be?{uri:be.uri}:G.toInternal(be,Me)}Pe.from=Le})(Ke||(e.TerminalQuickFix=Ke={}))}),define(Ae[203],Re([1,0,2,9,7,8,173]),function(ie,e,h,C,I,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sbc=void 0;class u{constructor(d,A,k,a={timeout:1500,errors:3}){this.c=d,this.d=A,this.f=k,this.g=a,this.a=new R.$Zc,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(d){return(A,k,a)=>{const m={dispose:this.a.push([A,k,d])};return Array.isArray(a)&&a.push(m),m}}async $participateInSave(d,A){const k=h.URI.revive(d);let a=!1;const w=setTimeout(()=>a=!0,this.g.timeout),m=[];try{for(const f of[...this.a]){if(a)break;const t=this.d.getDocument(k),s=await this.h(f,{document:t,reason:O.TextDocumentSaveReason.to(A)});m.push(s)}}finally{clearTimeout(w)}return m}h([d,A,k],a){const w=this.b.get(d);return typeof w=="number"&&w>this.g.errors?Promise.resolve(!1):this.i(k,d,A,a).then(()=>!0,m=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' threw ERROR`),this.c.error(m),!(m instanceof Error)||m.message!=="concurrent_edits"){const f=this.b.get(d);this.b.set(d,f?f+1:1),typeof f=="number"&&f>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(d,A,k,a){const w=[],m=Date.now(),{document:f,reason:t}=a,{version:s}=f,c=Object.freeze({document:f,reason:t,waitUntil(v){if(Object.isFrozen(w))throw(0,C.$6)("waitUntil can not be called async");w.push(Promise.resolve(v))}});try{A.apply(k,[c])}catch(v){return Promise.reject(v)}return Object.freeze(w),new Promise((v,S)=>{const p=setTimeout(()=>S(new Error("timeout")),this.g.timeout);return Promise.all(w).then(n=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${d.identifier.value}' finished after ${Date.now()-m}ms`),clearTimeout(p),v(n)}).catch(n=>{clearTimeout(p),S(n)})}).then(v=>{const S={edits:[]};for(const p of v)if(Array.isArray(p)&&p.every(n=>n instanceof I.$fK))for(const{newText:n,newEol:r,range:i}of p)S.edits.push({resource:f.uri,versionId:void 0,textEdit:{range:i&&O.Range.from(i),text:n,eol:r&&O.EndOfLine.from(r)}});if(S.edits.length!==0)return s===f.version?this.f.$tryApplyWorkspaceEdit(S):Promise.reject(new Error("concurrent_edits"))})}}e.$Sbc=u}),define(Ae[204],Re([1,0,13,2,8,7,75]),function(ie,e,h,C,I,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7cc=e.$6cc=void 0;class u{constructor(k,a,w,m){this.start=k,this.deletedCount=a,this.deletedItems=w,this.items=m}asApiEvent(){return{range:new O.$vL(this.start,this.start+this.deletedCount),addedCells:this.items.map(k=>k.apiCell),removedCells:this.deletedItems}}}class D{static asModelAddData(k,a){return{EOL:a.eol,lines:a.source,languageId:a.language,uri:a.uri,isDirty:!1,versionId:1,notebook:k}}constructor(k,a,w){this.notebook=k,this.h=a,this.j=w,this.handle=w.handle,this.uri=C.URI.revive(w.uri),this.cellKind=w.cellKind,this.a=w.outputs.map(I.NotebookCellOutput.to),this.e=w.internalMetadata??{},this.b=Object.freeze(w.metadata??{}),this.d=Object.freeze(I.NotebookCellExecutionSummary.to(w.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const k=this,a=this.h.getDocument(this.uri);if(!a)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const w={get index(){return k.notebook.getCellIndex(k)},notebook:k.notebook.apiNotebook,kind:I.NotebookCellKind.to(this.j.cellKind),document:a.document,get mime(){return k.g},set mime(m){k.g=m},get outputs(){return k.a.slice(0)},get metadata(){return k.b},get executionSummary(){return k.d}};this.f=Object.freeze(w)}return this.f}setOutputs(k){this.a=k.map(I.NotebookCellOutput.to)}setOutputItems(k,a,w){const m=w.map(I.NotebookCellOutputItem.to),f=this.a.find(t=>t.id===k);if(f&&(a||(f.items.length=0),f.items.push(...m),f.items.length>1&&f.items.every(t=>R.$iI(t.mime)))){const t=new Map,s=[];f.items.forEach(c=>{let v;t.has(c.mime)?v=t.get(c.mime):(v=[],t.set(c.mime,v),s.push(c.mime)),v.push(c.data)}),f.items.length=0,s.forEach(c=>{const v=R.$jI(t.get(c));f.items.push({mime:c,data:v.data.buffer})})}}setMetadata(k){this.b=Object.freeze(k)}setInternalMetadata(k){this.e=k,this.d=Object.freeze(I.NotebookCellExecutionSummary.to(k))}setMime(k){}}e.$6cc=D;class d{constructor(k,a,w,m,f){this.k=k,this.l=a,this.m=w,this.uri=m,this.handle=d.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=f.viewType,this.f=Object.freeze(f.metadata??Object.create(null)),this.r([[0,0,f.cells]],!0,void 0),this.g=f.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const k=this,a={get uri(){return k.uri},get version(){return k.g},get notebookType(){return k.d},get isDirty(){return k.h},get isUntitled(){return k.uri.scheme===h.Schemas.untitled},get isClosed(){return k.j},get metadata(){return k.f},get cellCount(){return k.b.length},cellAt(w){return w=k.n(w),k.b[w].apiCell},getCells(w){return(w?k.p(w):k.b).map(f=>f.apiCell)},save(){return k.q()}};this.e=Object.freeze(a)}return this.e}acceptDocumentPropertiesChanged(k){k.metadata&&(this.f=Object.freeze({...this.f,...k.metadata}))}acceptDirty(k){this.h=k}acceptModelChanged(k,a,w){this.g=k.versionId,this.h=a,this.acceptDocumentPropertiesChanged({metadata:w});const m={notebook:this.apiNotebook,metadata:w,cellChanges:[],contentChanges:[]},f=[];for(const s of k.rawEvents)s.kind===R.NotebookCellsChangeType.ModelChange?this.r(s.changes,!1,m.contentChanges):s.kind===R.NotebookCellsChangeType.Move?this.s(s.index,s.length,s.newIdx,m.contentChanges):s.kind===R.NotebookCellsChangeType.Output?(this.t(s.index,s.outputs),f.push({cell:this.b[s.index].apiCell,outputs:this.b[s.index].apiCell.outputs})):s.kind===R.NotebookCellsChangeType.OutputItem?(this.u(s.index,s.outputId,s.append,s.outputItems),f.push({cell:this.b[s.index].apiCell,outputs:this.b[s.index].apiCell.outputs})):s.kind===R.NotebookCellsChangeType.ChangeCellLanguage?(this.v(s.index,s.language),f.push({cell:this.b[s.index].apiCell,document:this.b[s.index].apiCell.document})):s.kind===R.NotebookCellsChangeType.ChangeCellContent?f.push({cell:this.b[s.index].apiCell,document:this.b[s.index].apiCell.document}):s.kind===R.NotebookCellsChangeType.ChangeCellMime?this.w(s.index,s.mime):s.kind===R.NotebookCellsChangeType.ChangeCellMetadata?(this.x(s.index,s.metadata),f.push({cell:this.b[s.index].apiCell,metadata:this.b[s.index].apiCell.metadata})):s.kind===R.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(s.index,s.internalMetadata),f.push({cell:this.b[s.index].apiCell,executionSummary:this.b[s.index].apiCell.executionSummary}));const t=new Map;for(let s=0;s<f.length;s++){const c=f[s],v=t.get(c.cell);if(v===void 0){const S=m.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...c});t.set(c.cell,S-1)}else m.cellChanges[v]={...m.cellChanges[v],...c}}return Object.freeze(m),Object.freeze(m.cellChanges),Object.freeze(m.contentChanges),m}n(k){return k=k|0,k<0?0:k>=this.b.length?this.b.length-1:k}o(k){let a=k.start|0,w=k.end|0;return a<0&&(a=0),w>this.b.length&&(w=this.b.length),k.with({start:a,end:w})}p(k){k=this.o(k);const a=[];for(let w=k.start;w<k.end;w++)a.push(this.b[w]);return a}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(k,a,w){if(this.j)return;const m=[],f=[],t=[];if(k.reverse().forEach(s=>{const v=s[2].map(n=>{const r=new D(this,this.l,n);return a||f.push(D.asModelAddData(this.apiNotebook,n)),r}),S=new u(s[0],s[1],[],v),p=this.b.splice(s[0],s[1],...v);for(const n of p)t.push(n.uri),S.deletedItems.push(n.apiCell);m.push(S)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:f,removedDocuments:t}),w)for(const s of m)w.push(s.asApiEvent())}s(k,a,w,m){const f=this.b.splice(k,a);this.b.splice(w,0,...f);const t=[new u(k,a,f.map(s=>s.apiCell),[]),new u(w,0,[],f)];for(const s of t)m.push(s.asApiEvent())}t(k,a){this.b[k].setOutputs(a)}u(k,a,w,m){this.b[k].setOutputItems(a,w,m)}v(k,a){const w=this.b[k];w.apiCell.document.languageId!==a&&this.m.$acceptModelLanguageChanged(w.uri,a)}w(k,a){const w=this.b[k];w.apiCell.mime=a}x(k,a){this.b[k].setMetadata(a)}y(k,a){this.b[k].setInternalMetadata(a)}getCellFromApiCell(k){return this.b.find(a=>a.apiCell===k)}getCellFromIndex(k){return this.b[k]}getCell(k){return this.b.find(a=>a.handle===k)}getCellIndex(k){return this.b.indexOf(k)}}e.$7cc=d,d.a=0}),define(Ae[205],Re([1,0,5,2,8,7]),function(ie,e,h,C,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$udc=void 0;class R{constructor(D,d,A,k={timeout:1500,errors:3}){this.b=D,this.c=d,this.d=A,this.f=k,this.a=new h.$Nd}dispose(){}getOnWillSaveNotebookDocumentEvent(D){return(d,A,k)=>{const a=function(m){d.call(A,m)};return a.extension=D,this.a.event(a,void 0,k)}}async $participateInSave(D,d,A){const k=C.URI.revive(D),a=this.c.getNotebookDocument(k);if(!a)throw new Error("Unable to resolve notebook document");const w=[];if(await this.a.fireAsync({notebook:a.apiNotebook,reason:I.TextDocumentSaveReason.to(d)},A,async(f,t)=>{const s=Date.now(),c=await await Promise.resolve(f);Date.now()-s>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",t.extension.identifier),!A.isCancellationRequested&&c&&(c instanceof O.$iK?w.push(c):this.b.warn("onWillSaveNotebookDocument-listener from extension",t.extension.identifier,"ignored due to invalid data"))}),A.isCancellationRequested)return!1;if(w.length===0)return!0;const m={edits:[]};for(const f of w){const{edits:t}=I.WorkspaceEdit.from(f);m.edits=m.edits.concat(t)}return this.d.$tryApplyWorkspaceEdit(m)}}e.$udc=R}),define(Ae[103],Re([1,0,9,8,7]),function(ie,e,h,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8cc=void 0;class O{constructor(u,D,d,A,k,a){this.id=u,this.f=D,this.notebookData=d,this.a=[],this.b=[],this.d=!1,this.a=k,this.b=A,this.c=a}get apiEditor(){if(!this.e){const u=this;this.e={get notebook(){return u.notebookData.apiNotebook},get selection(){return u.a[0]},set selection(D){this.selections=[D]},get selections(){return u.a},set selections(D){if(!Array.isArray(D)||!D.every(I.$vL.isNotebookRange))throw(0,h.$5)("selections");u.a=D,u.g(D)},get visibleRanges(){return u.b},revealRange(D,d){u.f.$tryRevealRange(u.id,C.NotebookRange.from(D),d??I.NotebookEditorRevealType.Default)},get viewColumn(){return u.c}},O.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(u){this.d=u}_acceptVisibleRanges(u){this.b=u}_acceptSelections(u){this.a=u}g(u){this.f.$trySetSelections(this.id,u.map(C.NotebookRange.from))}_acceptViewColumn(u){this.c=u}}e.$8cc=O,O.apiEditorsToExtHost=new WeakMap}),define(Ae[206],Re([1,0,9,5,14,8]),function(ie,e,h,C,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ndc=void 0;let R=class{constructor(D,d){this.c=D,this.d=d,this.a=new C.$Ld({onListenerError:h.$Z}),this.b=new C.$Ld({onListenerError:h.$Z}),this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(D,d){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",D,d);const A=this.d.getEditorById(D);d.visibleRanges&&A._acceptVisibleRanges(d.visibleRanges.ranges.map(O.NotebookRange.to)),d.selections&&A._acceptSelections(d.selections.selections.map(O.NotebookRange.to)),d.visibleRanges&&this.b.fire({notebookEditor:A.apiEditor,visibleRanges:A.apiEditor.visibleRanges}),d.selections&&this.a.fire(Object.freeze({notebookEditor:A.apiEditor,selections:A.apiEditor.selections}))}$acceptEditorViewColumns(D){for(const d in D)this.d.getEditorById(d)._acceptViewColumn(O.ViewColumn.to(D[d]))}};e.$ndc=R,e.$ndc=R=Je([qe(0,I.$6i)],R)}),define(Ae[207],Re([1,0,8,50,152,21,65,9]),function(ie,e,h,C,I,O,R,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rcc=void 0;class D{constructor(a){this.b=0,this.c=new Map,this.a=a}async withProgress(a,w,m){const f=this.b++,{title:t,location:s,cancellable:c}=w,v={label:(0,I.localize)(0,null,a.displayName||a.name),id:a.identifier.value};return this.a.$startProgress(f,{location:h.ProgressLocation.from(s),title:t,source:v,cancellable:c},a.isUnderDevelopment?void 0:a.identifier.value).catch(u.$Z),this.d(f,m,!!c)}d(a,w,m){let f;m&&(f=new O.$Vd,this.c.set(a,f));const t=c=>{this.a.$progressEnd(c),this.c.delete(c),f?.dispose()};let s;try{s=w(new A(this.a,a),m&&f?f.token:O.CancellationToken.None)}catch(c){throw t(a),c}return s.then(c=>t(a),c=>t(a)),s}$acceptProgressCanceled(a){const w=this.c.get(a);w&&(w.cancel(),this.c.delete(a))}}e.$rcc=D;function d(k,a){return k.message=a.message,typeof a.increment=="number"&&(typeof k.increment=="number"?k.increment+=a.increment:k.increment=a.increment),k}class A extends C.$Xu{constructor(a,w){super(m=>this.throttledReport(m)),this.f=a,this.g=w}throttledReport(a){this.f.$progressReport(this.g,a)}}Je([(0,R.$fh)(100,(k,a)=>d(k,a),()=>Object.create(null))],A.prototype,"throttledReport",null)}),define(Ae[104],Re([1,0,44,101,45,76,57,8,2]),function(ie,e,h,C,I,O,R,u,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mM=e.$lM=e.$kM=e.$jM=void 0;const d=(v,S,p,n)=>{let r=S;return{enumerable:!0,configurable:!1,get(){return r},set(i){if(!p(r,i)){const o=r;r=i,v.listener?.(n(i,o))}}}},A=(v,S)=>v===S,k={range:(v,S)=>v===S?!0:!v||!S?!1:v.isEqual(S),label:A,description:A,sortText:A,busy:A,error:A,canResolveChildren:A,tags:(v,S)=>!(v.length!==S.length||v.some(p=>!S.find(n=>p.id===n.id)))},a=v=>S=>({op:4,update:v(S)}),w=(v,S)=>({range:(()=>{let p;const n=a(r=>({range:h.$ms.lift(u.Range.from(r))}));return{enumerable:!0,configurable:!1,get(){return p},set(r){v.listener?.({op:6}),k.range(p,r)||(p=r,v.listener?.(n(r)))}}})(),label:d(v,S,k.label,a(p=>({label:p}))),description:d(v,void 0,k.description,a(p=>({description:p}))),sortText:d(v,void 0,k.sortText,a(p=>({sortText:p}))),canResolveChildren:d(v,!1,k.canResolveChildren,p=>({op:2,state:p})),busy:d(v,!1,k.busy,a(p=>({busy:p}))),error:d(v,void 0,k.error,a(p=>({error:u.MarkdownString.fromStrict(p)||null}))),tags:d(v,[],k.tags,(p,n)=>({op:1,new:p.map(u.TestTag.from),old:n.map(u.TestTag.from)}))}),m=v=>{const S=I.$2I.fromString(v.extId),p=new t(S.controllerId,S.localId,v.label,D.URI.revive(v.uri)||void 0);return p.range=u.Range.to(v.range||void 0),p.description=v.description||void 0,p.sortText=v.sortText||void 0,p.tags=v.tags.map(n=>u.TestTag.to({id:(0,R.$7I)(n).tagId})),p},f=v=>{let S;for(const p of v.tests){const n=m(p.item);(0,C.$6L)(n).parent=S,S=n}return S};e.$jM=f;class t{constructor(S,p,n,r){if(p.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(p)} symbol`);const i=(0,C.$5L)(this,S);Object.defineProperties(this,{id:{value:p,enumerable:!0,writable:!1},uri:{value:r,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return i.parent instanceof s?void 0:i.parent}},children:{value:(0,O.$4L)(i,C.$6L,t),enumerable:!0,writable:!1},...w(i,n)})}}e.$kM=t;class s extends t{constructor(S,p){super(S,S,p,void 0),this._isRoot=!0}}e.$lM=s;class c extends O.$ZL{constructor(S,p,n){super({controllerId:S,getDocumentVersion:r=>r&&n.getDocument(r)?.version,getApiFor:C.$6L,getChildren:r=>r.children,root:new s(S,p),toITestItem:u.TestItem.from})}}e.$mM=c}),define(Ae[105],Re([1,0,51,9,88,8,7]),function(ie,e,h,C,I,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gM=e.$fM=e.$eM=void 0;class u{constructor(a,w,m){const f=u.c.nextId();a.$registerTextEditorDecorationType(w.identifier,f,O.DecorationRenderOptions.from(m)),this.value=Object.freeze({key:f,dispose(){a.$removeTextEditorDecorationType(f)}})}}e.$eM=u,u.c=new I.$cM("TextEditorDecorationType");class D{constructor(a,w){this.g=[],this.h=void 0,this.j=!1,this.c=a,this.d=a.version,this.e=w.undoStopBefore,this.f=w.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(a,w){this.k();let m=null;if(a instanceof R.$_J)m=new R.$aK(a,a);else if(a instanceof R.$aK)m=a;else throw new Error("Unrecognized location");this.l(m,w,!1)}insert(a,w){this.k(),this.l(new R.$aK(a,a),w,!0)}delete(a){this.k();let w=null;if(a instanceof R.$aK)w=a;else throw new Error("Unrecognized location");this.l(w,null,!0)}l(a,w,m){const f=this.c.validateRange(a);this.g.push({range:f,text:w,forceMoveMarkers:m})}setEndOfLine(a){if(this.k(),a!==R.EndOfLine.LF&&a!==R.EndOfLine.CRLF)throw(0,C.$5)("endOfLine");this.h=a}}class d{constructor(a,w,m,f){this.c=a,this.d=w,this._accept(m),this.e=f;const t=this;this.value={get tabSize(){return t.f},set tabSize(s){t.m(s)},get indentSize(){return t.g},set indentSize(s){t.o(s)},get insertSpaces(){return t.h},set insertSpaces(s){t.q(s)},get cursorStyle(){return t.j},set cursorStyle(s){t.s(s)},get lineNumbers(){return t.k},set lineNumbers(s){t.t(s)}}}_accept(a){this.f=a.tabSize,this.g=a.indentSize,this.h=a.insertSpaces,this.j=a.cursorStyle,this.k=O.TextEditorLineNumbersStyle.to(a.lineNumbers)}l(a){if(a==="auto")return"auto";if(typeof a=="number"){const w=Math.floor(a);return w>0?w:null}if(typeof a=="string"){const w=parseInt(a,10);return isNaN(w)?null:w>0?w:null}return null}m(a){const w=this.l(a);if(w!==null){if(typeof w=="number"){if(this.f===w)return;this.f=w}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:w}))}}n(a){if(a==="tabSize")return"tabSize";if(typeof a=="number"){const w=Math.floor(a);return w>0?w:null}if(typeof a=="string"){const w=parseInt(a,10);return isNaN(w)?null:w>0?w:null}return null}o(a){const w=this.n(a);if(w!==null){if(typeof w=="number"){if(this.g===w)return;this.g=w}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:w}))}}p(a){return a==="auto"?"auto":a==="false"?!1:!!a}q(a){const w=this.p(a);if(typeof w=="boolean"){if(this.h===w)return;this.h=w}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:w}))}s(a){this.j!==a&&(this.j=a,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:a})))}t(a){this.k!==a&&(this.k=a,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:O.TextEditorLineNumbersStyle.from(a)})))}assign(a){const w={};let m=!1;if(typeof a.tabSize<"u"){const f=this.l(a.tabSize);f==="auto"?(m=!0,w.tabSize=f):typeof f=="number"&&this.f!==f&&(this.f=f,m=!0,w.tabSize=f)}if(typeof a.indentSize<"u"){const f=this.n(a.indentSize);f==="tabSize"?(m=!0,w.indentSize=f):typeof f=="number"&&this.g!==f&&(this.g=f,m=!0,w.indentSize=f)}if(typeof a.insertSpaces<"u"){const f=this.p(a.insertSpaces);f==="auto"?(m=!0,w.insertSpaces=f):this.h!==f&&(this.h=f,m=!0,w.insertSpaces=f)}typeof a.cursorStyle<"u"&&this.j!==a.cursorStyle&&(this.j=a.cursorStyle,m=!0,w.cursorStyle=a.cursorStyle),typeof a.lineNumbers<"u"&&this.k!==a.lineNumbers&&(this.k=a.lineNumbers,m=!0,w.lineNumbers=O.TextEditorLineNumbersStyle.from(a.lineNumbers)),m&&this.u("setOptions",this.c.$trySetOptions(this.d,w))}u(a,w){w.catch(m=>{this.e.warn(`ExtHostTextEditorOptions '${a}' failed:'`),this.e.warn(m)})}}e.$fM=d;class A{constructor(a,w,m,f,t,s,c,v){this.id=a,this.j=w,this.k=m,this.g=!1,this.h=new Set,this.c=t,this.d=new d(this.j,this.id,s,m),this.e=c,this.f=v;const S=this;this.value=Object.freeze({get document(){return f.value},set document(p){throw new C.$7("document")},get selection(){return S.c&&S.c[0]},set selection(p){if(!(p instanceof R.$bK))throw(0,C.$5)("selection");S.c=[p],S.l()},get selections(){return S.c},set selections(p){if(!Array.isArray(p)||p.some(n=>!(n instanceof R.$bK)))throw(0,C.$5)("selections");S.c=p,S.l()},get visibleRanges(){return S.e},set visibleRanges(p){throw new C.$7("visibleRanges")},get options(){return S.d.value},set options(p){S.g||S.d.assign(p)},get viewColumn(){return S.f},set viewColumn(p){throw new C.$7("viewColumn")},edit(p,n={undoStopBefore:!0,undoStopAfter:!0}){if(S.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const r=new D(f.value,n);return p(r),S.m(r)},insertSnippet(p,n,r={undoStopBefore:!0,undoStopAfter:!0}){if(S.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let i;if(!n||Array.isArray(n)&&n.length===0)i=S.c.map(o=>O.Range.from(o));else if(n instanceof R.$_J){const{lineNumber:o,column:y}=O.Position.from(n);i=[{startLineNumber:o,startColumn:y,endLineNumber:o,endColumn:y}]}else if(n instanceof R.$aK)i=[O.Range.from(n)];else{i=[];for(const o of n)if(o instanceof R.$aK)i.push(O.Range.from(o));else{const{lineNumber:y,column:g}=O.Position.from(o);i.push({startLineNumber:y,startColumn:g,endLineNumber:y,endColumn:g})}}return w.$tryInsertSnippet(a,f.value.version,p.value,i,r)},setDecorations(p,n){const r=n.length===0;r&&!S.h.has(p.key)||(r?S.h.delete(p.key):S.h.add(p.key),S.n(()=>{if(O.$7L(n))return w.$trySetDecorations(a,p.key,O.$8L(n));{const i=new Array(4*n.length);for(let o=0,y=n.length;o<y;o++){const g=n[o];i[4*o]=g.start.line+1,i[4*o+1]=g.start.character+1,i[4*o+2]=g.end.line+1,i[4*o+3]=g.end.character+1}return w.$trySetDecorationsFast(a,p.key,i)}}))},revealRange(p,n){S.n(()=>w.$tryRevealRange(a,O.Range.from(p),n||R.TextEditorRevealType.Default))},show(p){w.$tryShowEditor(a,O.ViewColumn.from(p))},hide(){w.$tryHideEditor(a)}})}dispose(){(0,h.ok)(!this.g),this.g=!0}_acceptOptions(a){(0,h.ok)(!this.g),this.d._accept(a)}_acceptVisibleRanges(a){(0,h.ok)(!this.g),this.e=a}_acceptViewColumn(a){(0,h.ok)(!this.g),this.f=a}_acceptSelections(a){(0,h.ok)(!this.g),this.c=a}async l(){const a=this.c.map(O.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,a)),this.value}m(a){const w=a.finalize();if(w.edits.length===0&&!w.setEndOfLine)return Promise.resolve(!0);const m=w.edits.map(t=>t.range);m.sort((t,s)=>t.end.line===s.end.line?t.end.character===s.end.character?t.start.line===s.start.line?t.start.character-s.start.character:t.start.line-s.start.line:t.end.character-s.end.character:t.end.line-s.end.line);for(let t=0,s=m.length-1;t<s;t++){const c=m[t].end;if(m[t+1].start.isBefore(c))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const f=w.edits.map(t=>({range:O.Range.from(t.range),text:t.text,forceMoveMarkers:t.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,w.documentVersionId,f,{setEndOfLine:typeof w.setEndOfLine=="number"?O.EndOfLine.from(w.setEndOfLine):void 0,undoStopBefore:w.undoStopBefore,undoStopAfter:w.undoStopAfter})}n(a){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):a().then(()=>this,w=>(w instanceof Error&&w.name==="DISPOSED"||this.k.warn(w),null))}}e.$gM=A}),define(Ae[208],Re([1,0,4,171]),function(ie,e,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tJ=void 0,e.$tJ=(0,h.$Mh)(C.$Sh)}),define(Ae[106],Re([1,0,20,5,19,6]),function(ie,e,h,C,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$93b=e.$83b=e.$73b=e.$63b=e.$53b=e.$43b=void 0;class R{constructor(s,c){this.versionId=s,this.removedDueToLooping=c}}e.$43b=R;class u{static isHostExtension(s,c,v){if(c.getExtensionDescription(s))return!1;const S=v.getExtensionDescription(s);return S?!!((S.main||S.browser)&&S.api==="none"):!1}constructor(s,c){this.j=s,this.c=new C.$Ld,this.onDidChange=this.c.event,this.d=0,this.e=c,this.k()}k(){this.e.sort(m),this.f=new h.$Zl,this.g=[],this.h=new Map;for(const s of this.e){if(this.f.has(s.identifier)){console.error("Extension `"+s.identifier.value+"` is already registered");continue}this.f.set(s.identifier,s),this.g.push(s);const c=this.j.readActivationEvents(s);if(Array.isArray(c))for(let v of c)v==="onUri"&&(v=`onUri:${h.$Xl.toKey(s.identifier)}`),this.h.has(v)||this.h.set(v,[]),this.h.get(v).push(s)}}set(s){return this.e=s,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(s,c){this.e=f(this.e,c),this.e=this.e.concat(s);const v=u.l(this.e);return this.e=f(this.e,v.map(S=>S.identifier)),this.k(),this.d++,this.c.fire(void 0),new R(this.d,v)}static l(s){const c=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(r){this.d.has(r)||(this.d.add(r),this.e.push(r))}addArc(r,i){this.addNode(r),this.addNode(i),this.c.has(r)?this.c.get(r).push(i):this.c.set(r,[i])}getArcs(r){return this.c.has(r)?this.c.get(r):[]}hasOnlyGoodArcs(r,i){const o=c.getArcs(r);for(let y=0;y<o.length;y++)if(!i.has(o[y]))return!1;return!0}getNodes(){return this.e}},v=new h.$Zl;for(const r of s)if(v.set(r.identifier,r),r.extensionDependencies)for(const i of r.extensionDependencies)c.addArc(h.$Xl.toKey(r.identifier),h.$Xl.toKey(i));const S=new Set;c.getNodes().filter(r=>c.getArcs(r).length===0).forEach(r=>S.add(r));const p=c.getNodes().filter(r=>!S.has(r));let n;do{n=!1;for(let r=0;r<p.length;r++){const i=p[r];c.hasOnlyGoodArcs(i,S)&&(p.splice(r,1),r--,S.add(i),n=!0)}}while(n);return p.map(r=>v.get(r))}containsActivationEvent(s){return this.h.has(s)}containsExtension(s){return this.f.has(s)}getExtensionDescriptionsForActivationEvent(s){const c=this.h.get(s);return c?c.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new D(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(s){const c=this.f.get(s);return c||void 0}getExtensionDescriptionByUUID(s){for(const c of this.g)if(c.uuid===s)return c}getExtensionDescriptionByIdOrUUID(s,c){return this.getExtensionDescription(s)??(c?this.getExtensionDescriptionByUUID(c):void 0)}}e.$53b=u;class D{constructor(s,c){this.versionId=s,this.extensions=c}}e.$63b=D,e.$73b={readActivationEvents:t=>t.activationEvents};class d{constructor(s){this.d=new a,this.c=new u(s,[])}async acquireLock(s){const c=await this.d.acquire(s);return new A(this,c)}deltaExtensions(s,c,v){if(!s.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(c,v)}containsActivationEvent(s){return this.c.containsActivationEvent(s)}containsExtension(s){return this.c.containsExtension(s)}getExtensionDescriptionsForActivationEvent(s){return this.c.getExtensionDescriptionsForActivationEvent(s)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(s){return this.c.getExtensionDescription(s)}getExtensionDescriptionByUUID(s){return this.c.getExtensionDescriptionByUUID(s)}getExtensionDescriptionByIdOrUUID(s,c){return this.c.getExtensionDescriptionByIdOrUUID(s,c)}}e.$83b=d;class A extends O.$Qc{constructor(s,c){super(),this.f=s,this.c=!1,this.B(c)}isAcquiredFor(s){return!this.c&&this.f===s}}e.$93b=A;class k{constructor(s){this.name=s,this.promise=new Promise((c,v)=>{this.c=c})}resolve(s){this.c(s)}}class a{constructor(){this.c=[],this.d=!1}async acquire(s){const c=new k(s);return this.c.push(c),this.e(),c.promise}e(){if(this.d||this.c.length===0)return;const s=this.c.shift();this.d=!0;let c=!0;const v=setTimeout(()=>{c&&console.warn(`The customer named ${s.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),S=()=>{c&&(clearTimeout(v),c=!1,this.d=!1,this.e())};s.resolve((0,O.$Oc)(S))}}var w;(function(t){t[t.Builtin=0]="Builtin",t[t.User=1]="User",t[t.Dev=2]="Dev"})(w||(w={}));function m(t,s){const c=t.isBuiltin?0:t.isUnderDevelopment?2:1,v=s.isBuiltin?0:s.isUnderDevelopment?2:1;if(c!==v)return c-v;const S=I.$ec.basename(t.extensionLocation.path),p=I.$ec.basename(s.extensionLocation.path);return S<p?-1:S>p?1:0}function f(t,s){const c=new h.$Yl(s);return t.filter(v=>!c.has(v.identifier))}}),define(Ae[79],Re([1,0,25]),function(ie,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.$7l=e.$6l=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var C;(function(d){d[d.Desktop=1]="Desktop",d[d.Web=2]="Web"})(C||(e.UIKind=C={}));var I;(function(d){d[d.VersionMismatch=55]="VersionMismatch",d[d.UnexpectedError=81]="UnexpectedError"})(I||(e.ExtensionHostExitCode=I={}));var O;(function(d){d[d.Initialized=0]="Initialized",d[d.Ready=1]="Ready",d[d.Terminate=2]="Terminate"})(O||(e.MessageType=O={}));function R(d){const A=h.$_d.alloc(1);switch(d){case 0:A.writeUInt8(1,0);break;case 1:A.writeUInt8(2,0);break;case 2:A.writeUInt8(3,0);break}return A}e.$6l=R;function u(d,A){if(d.byteLength!==1)return!1;switch(d.readUInt8(0)){case 1:return A===0;case 2:return A===1;case 3:return A===2;default:return!1}}e.$7l=u;var D;(function(d){d.Start="START_NATIVE_LOG",d.End="END_NATIVE_LOG"})(D||(e.NativeLogMarkers=D={}))}),define(Ae[58],Re([1,0,4,5,14,27,79,52,53,24,2,6,154]),function(ie,e,h,C,I,O,R,u,D,d,A,k,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rM=e.$qM=e.$pM=e.$oM=void 0;let w=class extends k.$Qc{constructor(s,c){super(),this.s=s,this.t=c,this.a=this.B(new C.$Ld),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new C.$Ld),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=A.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=c.createLogger(this.m,{id:D.$go,name:(0,a.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(c.onDidChangeLogLevel(v=>{(0,I.$8i)(v)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===I.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(s,c,v){const S=this.getTelemetryDetails(),p=new m(c,v,s,this.n,this.j,this.getBuiltInCommonProperties(s),{isUsageEnabled:S.isUsageEnabled,isErrorsEnabled:S.isErrorsEnabled}),n=this.r.get(s.identifier.value)??[];return this.r.set(s.identifier.value,[...n,p]),p.apiTelemetryLogger}$initializeTelemetryLevel(s,c,v){this.f=s,this.g=c,this.c=v??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(s){const c=Object.create(null);switch(c["common.extname"]=`${s.publisher}.${s.name}`,c["common.extversion"]=s.version,c["common.vscodemachineid"]=this.s.telemetryInfo.machineId,c["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,c["common.vscodeversion"]=this.s.version,c["common.isnewappinstall"]=f(this.s.telemetryInfo.firstSessionDate),c["common.product"]=this.s.environment.appHost,this.s.uiKind){case R.UIKind.Web:c["common.uikind"]="web";break;case R.UIKind.Desktop:c["common.uikind"]="desktop";break;default:c["common.uikind"]="unknown"}return c["common.remotename"]=(0,u.$Qk)((0,D.$no)(this.s.remote.authority)),c}$onDidChangeTelemetryLevel(s){this.h=this.getTelemetryConfiguration(),this.f=s;const c=this.getTelemetryDetails();this.r.forEach((v,S)=>{const p=v.filter(n=>!n.isDisposed);p.length===0?this.r.delete(S):this.r.set(S,p)}),this.r.forEach(v=>{for(const S of v)S.updateTelemetryEnablements(c.isUsageEnabled,c.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(s,c){const S=this.r.get(s.value)?.filter(n=>!n.isDisposed);if(!S)return this.r.delete(s.value),!1;let p=!1;for(const n of S)n.ignoreUnhandledExtHostErrors||(n.logError(c),p=!0);return p}};e.$oM=w,e.$oM=w=Je([qe(0,O.$nM),qe(1,I.$7i)],w);class m{static validateSender(s){if(typeof s!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof s.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof s.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof s.flush<"u"&&typeof s.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(s,c,v,S,p,n,r){this.g=v,this.h=S,this.i=p,this.j=n,this.a=new C.$Ld,this.ignoreUnhandledExtHostErrors=c?.ignoreUnhandledErrors??!1,this.b=c?.ignoreBuiltInCommonProperties??!1,this.c=c?.additionalCommonProperties,this.f=s,this.d={isUsageEnabled:r.isUsageEnabled,isErrorsEnabled:r.isErrorsEnabled}}updateTelemetryEnablements(s,c){this.e&&(this.d={isUsageEnabled:s,isErrorsEnabled:c},this.a.fire(this.e))}mixInCommonPropsAndCleanData(s){let c="properties"in s?s.properties??{}:s;return c=(0,D.$qo)(c,[]),this.c&&(c=(0,d.$1m)(c,this.c)),this.b||(c=(0,d.$1m)(c,this.j)),"properties"in s?s.properties=c:s=c,s}k(s,c){this.f&&(this.g.publisher==="vscode"?s=this.g.name+"/"+s:s=this.g.identifier.value+"/"+s,c=this.mixInCommonPropsAndCleanData(c||{}),this.i||this.f?.sendEventData(s,c),this.h.trace(s,c))}logUsage(s,c){this.d.isUsageEnabled&&this.k(s,c)}logError(s,c){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof s=="string")this.k(s,c);else{const v={name:s.name,message:s.message,stack:s.stack,cause:s.cause},S=(0,D.$qo)(v,[]),p=new Error(S.message,{cause:S.cause});p.stack=S.stack,p.name=S.name,c=this.mixInCommonPropsAndCleanData(c||{}),this.i||this.f.sendErrorData(p,c),this.h.trace("exception",c)}}get apiTelemetryLogger(){if(!this.e){const s=this,c={logUsage:s.logUsage.bind(s),get isUsageEnabled(){return s.d.isUsageEnabled},get isErrorsEnabled(){return s.d.isErrorsEnabled},logError:s.logError.bind(s),dispose:s.dispose.bind(s),onDidChangeEnableStates:s.a.event.bind(s)};this.e=Object.freeze(c)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let s=this.f;this.f=void 0,Promise.resolve(s.flush()).then(s=void 0),this.e=void 0}else this.f=void 0}}e.$pM=m;function f(t){const s=Date.now()-new Date(t).getTime();return isNaN(s)?!1:s<1e3*60*60*24}e.$qM=f,e.$rM=(0,h.$Lh)("IExtHostTelemetry")}),define(Ae[26],Re([1,0,5,2,180,98,20,4]),function(ie,e,h,C,I,O,R,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aF=e.$_E=e.$$E=e.ActivationKind=e.$0E=e.$9E=e.$8E=e.$7E=e.$6E=e.ExtensionHostStartup=e.$5E=e.$4E=e.$3E=e.$2E=void 0,e.$2E=Object.freeze({identifier:new R.$Xl("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:C.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$3E="extensions.webWorker",e.$4E=(0,u.$Lh)("extensionService");class D{constructor(p){this.dependency=p}}e.$5E=D;var d;(function(S){S[S.EagerAutoStart=1]="EagerAutoStart",S[S.EagerManualStart=2]="EagerManualStart",S[S.Lazy=3]="Lazy"})(d||(e.ExtensionHostStartup=d={}));class A{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(p,n,r){this.c=p,this.d=n.slice(0),this.e=r.slice(0)}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:O.$ME.createActivationEventsMap(this.d)}}set(p,n,r){if(this.c>p)throw new Error(`ExtensionHostExtensions: invalid versionId ${p} (current: ${this.c})`);const i=[],o=[],y=[],g=[],E=k(this.d),P=k(n),l=(F,q)=>F.extensionLocation.toString()===q.extensionLocation.toString()||F.isBuiltin===q.isBuiltin||F.isUserBuiltin===q.isUserBuiltin||F.isUnderDevelopment===q.isUnderDevelopment;for(const F of this.d){const q=P.get(F.identifier);if(!q){i.push(F.identifier),E.delete(F.identifier);continue}if(!l(F,q)){i.push(F.identifier),E.delete(F.identifier);continue}}for(const F of n){const q=E.get(F.identifier);if(!q){o.push(F);continue}if(!l(q,F)){i.push(q.identifier),E.delete(q.identifier);continue}}const $=new R.$Yl(this.e),b=new R.$Yl(r);for(const F of this.e)b.has(F)||y.push(F);for(const F of r)$.has(F)||g.push(F);const M=O.$ME.createActivationEventsMap(o),U={versionId:p,toRemove:i,toAdd:o,addActivationEvents:M,myToRemove:y,myToAdd:g};return this.delta(U),U}delta(p){if(this.c>=p.versionId)return null;const{toRemove:n,toAdd:r,myToRemove:i,myToAdd:o}=p,y=new R.$Yl(n),g=new R.$Yl(i);for(let E=0;E<this.d.length;E++)y.has(this.d[E].identifier)&&(this.d.splice(E,1),E--);for(let E=0;E<this.e.length;E++)g.has(this.e[E])&&(this.e.splice(E,1),E--);for(const E of r)this.d.push(E);for(const E of o)this.e.push(E);return p}containsExtension(p){for(const n of this.e)if(R.$Xl.equals(n,p))return!0;return!1}}e.$6E=A;function k(S){const p=new R.$Zl;for(const n of S)p.set(n.identifier,n);return p}function a(S,p){return!0}e.$7E=a;function w(S,p){if(!a(S,p))throw new Error(`Extension '${S.identifier.value}' CANNOT use API proposal: ${p}.
Its package.json#enabledApiProposals-property declares: ${S.enabledApiProposals?.join(", ")??"[]"} but NOT ${p}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${S.identifier.value}`)}e.$8E=w;class m{constructor(p,n,r,i){this.codeLoadingTime=p,this.activateCallTime=n,this.activateResolvedTime=r,this.activationReason=i}}e.$9E=m;class f{constructor(p,n){this.description=p,this.value=n}}e.$0E=f;var t;(function(S){S[S.Normal=0]="Normal",S[S.Immediate=1]="Immediate"})(t||(e.ActivationKind=t={}));function s(S){return{type:S.isBuiltin?0:1,isBuiltin:S.isBuiltin||S.isUserBuiltin,identifier:{id:(0,I.$wo)(S.publisher,S.name),uuid:S.uuid},manifest:S,location:S.extensionLocation,targetPlatform:S.targetPlatform,validations:[],isValid:!0}}e.$$E=s;function c(S,p){return{identifier:new R.$Xl((0,I.$uo)(S.manifest.publisher,S.manifest.name)),isBuiltin:S.type===0,isUserBuiltin:S.type===1&&S.isBuiltin,isUnderDevelopment:!!p,extensionLocation:S.location,...S.manifest,uuid:S.identifier.uuid,targetPlatform:S.targetPlatform}}e.$_E=c;class v{constructor(){this.onDidRegisterExtensions=h.Event.None,this.onDidChangeExtensionsStatus=h.Event.None,this.onDidChangeExtensions=h.Event.None,this.onWillActivateByEvent=h.Event.None,this.onDidChangeResponsiveChange=h.Event.None,this.onWillStop=h.Event.None,this.extensions=[]}activateByEvent(p){return Promise.resolve(void 0)}activationEventIsDone(p){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(p){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(p,n){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(p){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$aF=v}),define(Ae[209],Re([1,0,9,106,20,26,14,12]),function(ie,e,h,C,I,O,R,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ybc=e.$Xbc=e.$Wbc=e.$Vbc=e.$Ubc=e.$Tbc=void 0;class D{constructor(s,c,v,S){this.startup=s,this.codeLoadingTime=c,this.activateCallTime=v,this.activateResolvedTime=S}}e.$Tbc=D,D.NONE=new D(!1,-1,-1,-1);class d{constructor(s){this.a=s,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(s,c){return s===-1||c===-1?-1:c-s}build(){return new D(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$Ubc=d;class A{constructor(s,c,v,S,p,n){this.activationFailed=s,this.activationFailedError=c,this.activationTimes=v,this.module=S,this.exports=p,this.subscriptions=n}}e.$Vbc=A;class k extends A{constructor(s){super(!1,null,s,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Wbc=k;class a extends A{constructor(){super(!1,null,D.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Xbc=a;class w extends A{constructor(s){super(!0,s,D.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let m=class{constructor(s,c,v,S){this.g=S,this.a=s,this.b=c,this.c=v,this.d=new I.$Zl,this.f=Object.create(null)}dispose(){for(const[s,c]of this.d)c.dispose()}async waitForActivatingExtensions(){const s=[];for(const[c,v]of this.d)s.push(v.wait());await Promise.all(s)}isActivated(s){const c=this.d.get(s);return!!(c&&c.value)}getActivatedExtension(s){const c=this.d.get(s);if(!c||!c.value)throw new Error(`Extension '${s.value}' is not known or not activated`);return c.value}async activateByEvent(s,c){if(this.f[s])return;const v=this.a.getExtensionDescriptionsForActivationEvent(s);await this.h(v.map(S=>({id:S.identifier,reason:{startup:c,extensionId:S.identifier,activationEvent:s}}))),this.f[s]=!0}activateById(s,c){const v=this.a.getExtensionDescription(s);if(!v)throw new Error(`Extension '${s}' is not known`);return this.h([{id:v.identifier,reason:c}])}async h(s){const c=s.filter(v=>!this.isActivated(v.id)).map(v=>this.j(v));await Promise.all(c.map(v=>v.wait()))}j(s){if(this.d.has(s.id))return this.d.get(s.id);if(this.l(s.id))return this.k(s,null,[],null);const c=this.a.getExtensionDescription(s.id);if(!c){const p=new Error(`Cannot activate unknown extension '${s.id.value}'`),n=this.k(s,null,[],new w(p));return this.c.onExtensionActivationError(s.id,p,new O.$5E(s.id.value)),n}const v=[],S=typeof c.extensionDependencies>"u"?[]:c.extensionDependencies;for(const p of S){if(this.m(p))continue;const n=this.d.get(p);if(n){v.push(n);continue}if(this.l(p)){v.push(this.j({id:this.b.getExtensionDescription(p).identifier,reason:s.reason}));continue}const r=this.a.getExtensionDescription(p);if(r){if(!r.main&&!r.browser)continue;v.push(this.j({id:r.identifier,reason:s.reason}));continue}const i=c.displayName||c.identifier.value,o=new Error(`Cannot activate the '${i}' extension because it depends on unknown extension '${p}'`),y=this.k(s,c.displayName,[],new w(o));return this.c.onExtensionActivationError(c.identifier,o,new O.$5E(p)),y}return this.k(s,c.displayName,v,null)}k(s,c,v,S){const p=new f(s.id,c,s.reason,v,S,this.c,this.g);return this.d.set(s.id,p),p}l(s){return C.$53b.isHostExtension(s,this.a,this.b)}m(s){const c=this.b.getExtensionDescription(s);return c?!c.main&&!c.browser:!1}};e.$Ybc=m,e.$Ybc=m=Je([qe(3,R.$6i)],m);let f=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(s,c,v,S,p,n,r){this.c=s,this.d=c,this.f=v,this.g=S,this.h=p,this.j=n,this.k=r,this.a=new u.$Pg,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let s=0;s<this.g.length;s++){const c=this.g[s];if(c.value&&!c.value.activationFailed){this.g.splice(s,1),s--;continue}if(c.value&&c.value.activationFailed){const v=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${c.friendlyName}' failed to activate`);v.detail=c.value.activationFailedError,this.h=new w(v),this.j.onExtensionActivationError(this.c,v,null);return}}this.g.length>0&&await Promise.race(this.g.map(s=>s.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(s){const c=new Error;if(s&&s.name&&(c.name=s.name),s&&s.message?c.message=`Activating extension '${this.c.value}' failed: ${s.message}.`:c.message=`Activating extension '${this.c.value}' failed: ${s}.`,s&&s.stack&&(c.stack=s.stack),this.h=new w(c),this.b&&h.$2(s))return;this.j.onExtensionActivationError(this.c,c,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(s)}}};f=Je([qe(6,R.$6i)],f)}),define(Ae[210],Re([1,0,156,23,2,5,6,192,12,7,16,18,8,49,21,128,26]),function(ie,e,h,C,I,O,R,u,D,d,A,k,a,w,m,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ycc=void 0;function s(S,p){if((0,A.$wf)(S))return{label:S};if(S&&typeof S=="object"&&typeof S.label=="string"){let n;return Array.isArray(S.highlights)&&(n=S.highlights.filter(r=>r.length===2&&typeof r[0]=="number"&&typeof r[1]=="number"),n=n.length?n:void 0),{label:S.label,highlights:n}}}class c extends R.$Qc{constructor(p,n,r){super(),this.f=p,this.g=n,this.h=r,this.a=new Map,this.b=new f.$y7;function i(o){return o&&o.$treeViewId&&(o.$treeItemHandle||o.$selectedTreeItems||o.$focusedTreeItem)}n.registerArgumentProcessor({processArgument:o=>i(o)?this.r(o):Array.isArray(o)&&o.length>0?o.map(y=>i(y)?this.r(y):y):o})}registerTreeDataProvider(p,n,r){const i=this.createTreeView(p,{treeDataProvider:n},r);return{dispose:()=>i.dispose()}}createTreeView(p,n,r){if(!n||!n.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const i=n.dragAndDropController?.dropMimeTypes??[],o=n.dragAndDropController?.dragMimeTypes??[],y=!!n.dragAndDropController?.handleDrag,g=!!n.dragAndDropController?.handleDrop,E=this.m(p,n,r),P={showCollapseAll:!!n.showCollapseAll,canSelectMany:!!n.canSelectMany,dropMimeTypes:i,dragMimeTypes:o,hasHandleDrag:y,hasHandleDrop:g,manuallyManageCheckboxes:!!n.manageCheckboxStateManually},l=this.f.$registerTreeViewDataProvider(p,P),$={get onDidCollapseElement(){return E.onDidCollapseElement},get onDidExpandElement(){return E.onDidExpandElement},get selection(){return E.selectedElements},get onDidChangeSelection(){return E.onDidChangeSelection},get activeItem(){return(0,t.$8E)(r,"treeViewActiveItem"),E.focusedElement},get onDidChangeActiveItem(){return(0,t.$8E)(r,"treeViewActiveItem"),E.onDidChangeActiveItem},get visible(){return E.visible},get onDidChangeVisibility(){return E.onDidChangeVisibility},get onDidChangeCheckboxState(){return E.onDidChangeCheckboxState},get message(){return E.message},set message(b){(0,w.$1j)(b)&&(0,t.$8E)(r,"treeViewMarkdownMessage"),E.message=b},get title(){return E.title},set title(b){E.title=b},get description(){return E.description},set description(b){E.description=b},get badge(){return E.badge},set badge(b){b!==void 0&&d.ViewBadge.isViewBadge(b)?E.badge={value:Math.floor(Math.abs(b.value)),tooltip:b.tooltip}:b===void 0&&(E.badge=void 0)},reveal:(b,M)=>E.reveal(b,M),dispose:async()=>{await l,this.a.delete(p),E.dispose()}};return this.B($),$}$getChildren(p,n){const r=this.a.get(p);return r?r.getChildren(n):Promise.reject(new u.$hE(p))}async $handleDrop(p,n,r,i,o,y,g,E){const P=this.a.get(p);if(!P)return Promise.reject(new u.$hE(p));const l=a.DataTransfer.toDataTransfer(r,async $=>(await this.f.$resolveDropFileData(p,n,$)).buffer);return g===p&&E&&await this.j(l,P,E,o,y),P.onDrop(l,i,o)}async j(p,n,r,i,o){const y=this.b.removeDragOperationTransfer(o);if(y)(await y)?.forEach((g,E)=>{g&&p.set(E,g)});else if(o&&n.handleDrag){const g=n.handleDrag(r,p,i);this.b.addDragOperationTransfer(o,g),await g}return p}async $handleDrag(p,n,r,i){const o=this.a.get(p);if(!o)return Promise.reject(new u.$hE(p));const y=await this.j(new d.$2K,o,n,i,r);if(!(!y||i.isCancellationRequested))return a.DataTransfer.from(y)}async $hasResolve(p){const n=this.a.get(p);if(!n)throw new u.$hE(p);return n.hasResolve}$resolve(p,n,r){const i=this.a.get(p);if(!i)throw new u.$hE(p);return i.resolveTreeItem(n,r)}$setExpanded(p,n,r){const i=this.a.get(p);if(!i)throw new u.$hE(p);i.setExpanded(n,r)}$setSelectionAndFocus(p,n,r){const i=this.a.get(p);if(!i)throw new u.$hE(p);i.setSelectionAndFocus(n,r)}$setVisible(p,n){const r=this.a.get(p);if(!r){if(!n)return;throw new u.$hE(p)}r.setVisible(n)}$changeCheckboxState(p,n){const r=this.a.get(p);if(!r)throw new u.$hE(p);r.setCheckboxState(n)}m(p,n,r){const i=this.B(new v(p,n,this.f,this.g.converter,this.h,r));return this.a.set(p,i),i}r(p){const n=this.a.get(p.$treeViewId);return n&&"$treeItemHandle"in p?n.getExtensionElement(p.$treeItemHandle):n&&"$focusedTreeItem"in p&&p.$focusedTreeItem?n.focusedElement:null}}e.$ycc=c;class v extends R.$Qc{get visible(){return this.r}get selectedElements(){return this.s.map(p=>this.getExtensionElement(p)).filter(p=>!(0,A.$Ff)(p))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(p,n,r,i,o,y){if(super(),this.I=p,this.J=r,this.L=i,this.M=o,this.N=y,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new O.$Ld),this.onDidExpandElement=this.u.event,this.w=this.B(new O.$Ld),this.onDidCollapseElement=this.w.event,this.y=this.B(new O.$Ld),this.onDidChangeSelection=this.y.event,this.z=this.B(new O.$Ld),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new O.$Ld),this.onDidChangeVisibility=this.C.event,this.D=this.B(new O.$Ld),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new O.$Ld),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new m.$Vd,y.contributes&&y.contributes.views)for(const l in y.contributes.views)for(const $ of y.contributes.views[l])$.id===p&&(this.P=$.name);this.f=n.treeDataProvider,this.g=n.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(l=>this.F.fire({message:!1,element:l})));let g,E;const P=O.Event.debounce(this.F.event,(l,$)=>(l||(l={message:!1,elements:[]}),$.element!==!1&&(g||(g=new Promise(b=>E=b),this.G=this.G.then(()=>g)),Array.isArray($.element)?l.elements.push(...$.element):l.elements.push($.element)),$.message&&(l.message=!0),l),200,!0);this.B(P(({message:l,elements:$})=>{$.length&&(this.H=this.H.then(()=>{const b=E;return g=null,this.$($).then(()=>b())})),l&&this.J.$setMessage(this.I,a.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(p){const n=p?this.getExtensionElement(p):void 0;if(p&&!n)return this.M.error(`No tree item with id '${p}' found.`),Promise.resolve([]);let r=this.X(p);return r||(r=await this.Y(n)),r?r.map(i=>i.item):void 0}getExtensionElement(p){return this.j.get(p)}reveal(p,n){n=n||{select:!0,focus:!1};const r=(0,A.$Ff)(n.select)?!0:n.select,i=(0,A.$Ff)(n.focus)?!1:n.focus,o=(0,A.$Ff)(n.expand)?!1:n.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):p?this.G.then(()=>this.S(p)).then(y=>this.W(p,y[y.length-1]).then(g=>this.J.$reveal(this.I,{item:g.item,parentChain:y.map(E=>E.item)},{select:r,focus:i,expand:o})),y=>this.M.error(y)):this.J.$reveal(this.I,void 0,{select:r,focus:i,expand:o})}get message(){return this.O}set message(p){this.O=p,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(p){this.P=p,this.J.$setTitle(this.I,p,this.Q)}get description(){return this.Q}set description(p){this.Q=p,this.J.$setTitle(this.I,this.P,p)}get badge(){return this.R}set badge(p){this.R?.value===p?.value&&this.R?.tooltip===p?.tooltip||(this.R=a.ViewBadge.from(p),this.J.$setBadge(this.I,p))}setExpanded(p,n){const r=this.getExtensionElement(p);r&&(n?this.u.fire(Object.freeze({element:r})):this.w.fire(Object.freeze({element:r})))}setSelectionAndFocus(p,n){const r=!(0,k.$sb)(this.s,p);this.s=p;const i=this.t!==n;this.t=n,r&&this.y.fire(Object.freeze({selection:this.selectedElements})),i&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(p){p!==this.r&&(this.r=p,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(p){const n=(await Promise.all(p.map(async r=>{const i=this.getExtensionElement(r.treeItemHandle);return i?{extensionItem:i,treeItem:await this.f.getTreeItem(i),newState:r.newState?d.TreeItemCheckboxState.Checked:d.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(r=>r!==void 0);n.forEach(r=>{r.treeItem.checkboxState=r.newState?d.TreeItemCheckboxState.Checked:d.TreeItemCheckboxState.Unchecked}),this.D.fire({items:n.map(r=>[r.extensionItem,r.newState])})}async handleDrag(p,n,r){const i=[];for(const o of p){const y=this.getExtensionElement(o);y&&i.push(y)}if(!(!this.g?.handleDrag||i.length===0))return await this.g.handleDrag(i,n,r),n}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(p,n,r){const i=n?this.getExtensionElement(n):void 0;if(!(!i&&n||!this.g?.handleDrop))return(0,D.$Jg)(()=>this.g?.handleDrop?this.g.handleDrop(i,p,r):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(p,n){if(!this.f.resolveTreeItem)return;const r=this.j.get(p);if(r){const i=this.m.get(r);if(i){const o=await this.f.resolveTreeItem(i.extensionItem,r,n)??i.extensionItem;return this.hb(o),i.item.tooltip=this.eb(o.tooltip),i.item.command=this.fb(i.disposableStore,o.command),i.item}}}S(p){return this.U(p).then(n=>n?this.S(n).then(r=>this.W(n,r[r.length-1]).then(i=>(r.push(i),r))):Promise.resolve([]))}U(p){const n=this.m.get(p);return n?Promise.resolve(n.parent?this.j.get(n.parent.item.handle):void 0):(0,D.$Jg)(()=>this.f.getParent(p))}W(p,n){const r=this.m.get(p);return r?Promise.resolve(r):(0,D.$Jg)(()=>this.f.getTreeItem(p)).then(i=>this.kb(p,i,n,!0)).then(i=>this.getChildren(n?n.item.handle:void 0).then(()=>{const o=this.getExtensionElement(i);if(o){const y=this.m.get(o);if(y)return Promise.resolve(y)}throw new Error(`Cannot resolve tree item for element ${i} from extension ${this.N.identifier.value}`)}))}X(p){if(p){let n;if(typeof p=="string"){const r=this.getExtensionElement(p);n=r?this.m.get(r):void 0}else n=p;return n&&n.children||void 0}return this.h}async Y(p){this.rb(p);const n=new m.$Vd(this.Z.token);try{const r=p?this.m.get(p):void 0,i=await this.f.getChildren(p);if(n.token.isCancellationRequested)return;const o=await Promise.all((0,k.$Fb)(i||[]).map(async y=>{const g=await this.f.getTreeItem(y);return g&&!n.token.isCancellationRequested?this.db(y,g,r):null}));return n.token.isCancellationRequested?void 0:(0,k.$Fb)(o)}finally{n.dispose()}}$(p){if(p.some(r=>!r))return this.Z.dispose(!0),this.Z=new m.$Vd,this.tb(),this.J.$refresh(this.I);{const r=this.ab(p);if(r.length)return this.bb(r)}return Promise.resolve(void 0)}ab(p){const n=new Set,r=p.map(o=>this.m.get(o));for(const o of r)if(o&&!n.has(o.item.handle)){let y=o;for(;y&&y.parent&&r.findIndex(g=>y&&y.parent&&g&&g.item.handle===y.parent.item.handle)===-1;){const g=this.j.get(y.parent.item.handle);y=g?this.m.get(g):void 0}y&&!y.parent&&n.add(o.item.handle)}const i=[];return n.forEach(o=>{const y=this.j.get(o);if(y){const g=this.m.get(y);g&&(!g.parent||!n.has(g.parent.item.handle))&&i.push(o)}}),i}bb(p){const n={};return Promise.all(p.map(r=>this.cb(r).then(i=>{i&&(n[r]=i.item)}))).then(()=>Object.keys(n).length?this.J.$refresh(this.I,n):void 0)}cb(p){const n=this.getExtensionElement(p);if(n){const r=this.m.get(n);if(r)return this.rb(n),(0,D.$Jg)(()=>this.f.getTreeItem(n)).then(i=>{if(i){const o=this.ib(n,i,r.parent);return this.pb(n,o,r,r.parent),r.dispose(),o}return null})}return Promise.resolve(null)}db(p,n,r){const i=this.ib(p,n,r);if(n.id&&this.j.has(i.item.handle))throw new Error((0,h.localize)(0,null,n.id));return this.ob(p,i),this.qb(i,r),i}eb(p){return d.$yK.isMarkdownString(p)?a.MarkdownString.from(p):p}fb(p,n){return n?{...this.L.toInternal(n,p),originalId:n.command}:void 0}gb(p){if(p.checkboxState===void 0)return;let n,r,i;return typeof p.checkboxState=="number"?n=p.checkboxState:(n=p.checkboxState.state,r=p.checkboxState.tooltip,i=p.checkboxState.accessibilityInformation),{isChecked:n===d.TreeItemCheckboxState.Checked,tooltip:r,accessibilityInformation:i}}hb(p){if(!d.$WK.isTreeItem(p,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(p,n,r){this.hb(n);const i=this.B(new R.$Pc),o=this.kb(p,n,r),y=this.lb(n);return{item:{handle:o,parentHandle:r?r.item.handle:void 0,label:s(n.label,this.N),description:n.description,resourceUri:n.resourceUri,tooltip:this.eb(n.tooltip),command:this.fb(i,n.command),contextValue:n.contextValue,icon:y,iconDark:this.mb(n)||y,themeIcon:this.jb(n),collapsibleState:(0,A.$Ff)(n.collapsibleState)?d.TreeItemCollapsibleState.None:n.collapsibleState,accessibilityInformation:n.accessibilityInformation,checkbox:this.gb(n)},extensionItem:n,parent:r,children:void 0,disposableStore:i,dispose(){i.dispose()}}}jb(p){return p.iconPath instanceof d.$5K?p.iconPath:void 0}kb(p,{id:n,label:r,resourceUri:i},o,y){if(n)return`${v.b}/${n}`;const g=s(r,this.N),E=o?o.item.handle:v.a;let P=g?g.label:i?(0,C.$pg)(i):"";P=P.indexOf("/")!==-1?P.replace("/","//"):P;const l=this.m.has(p)?this.m.get(p).item.handle:void 0,$=this.X(o)||[];let b,M=0;do{if(b=`${E}/${M}:${P}`,y||!this.j.has(b)||l===b)break;M++}while(M<=$.length);return b}lb(p){if(p.iconPath&&!(p.iconPath instanceof d.$5K))return typeof p.iconPath=="string"||I.URI.isUri(p.iconPath)?this.nb(p.iconPath):this.nb(p.iconPath.light)}mb(p){if(p.iconPath&&!(p.iconPath instanceof d.$5K)&&p.iconPath.dark)return this.nb(p.iconPath.dark)}nb(p){return I.URI.isUri(p)?p:I.URI.file(p)}ob(p,n){this.j.set(n.item.handle,p),this.m.set(p,n)}pb(p,n,r,i){this.j.delete(n.item.handle),this.m.delete(p),n.item.handle!==r.item.handle&&this.j.delete(r.item.handle),this.ob(p,n);const o=this.X(i)||[],y=o.filter(g=>g.item.handle===r.item.handle)[0];y&&o.splice(o.indexOf(y),1,n)}qb(p,n){n?(n.children||(n.children=[]),n.children.push(p)):(this.h||(this.h=[]),this.h.push(p))}rb(p){if(p){const n=this.m.get(p);if(n){if(n.children)for(const r of n.children){const i=this.j.get(r.item.handle);i&&this.sb(i)}n.children=void 0}}else this.tb()}sb(p){const n=this.m.get(p);if(n){if(n.children)for(const r of n.children){const i=this.j.get(r.item.handle);i&&this.sb(i)}this.m.delete(p),this.j.delete(n.item.handle),n.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(p=>p.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}v.a="0",v.b="1"}),define(Ae[211],Re([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chat:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chat.d.ts",chatAgents:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatRequestAccess:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatRequestAccess.d.ts",chatSlashCommands:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatSlashCommands.d.ts",chatVariables:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariables.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveUserActions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveUserActions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",readonlyMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.readonlyMessage.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",saveEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.saveEditor.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testMessageContextValue:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testMessageContextValue.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Ae[212],Re([1,0,166,9,29,92,73,30,20,211,176,98]),function(ie,e,h,C,I,O,R,u,D,d,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1E=e.$ZE=e.$YE=e.$XE=e.$WE=e.$VE=void 0;const a=u.$0m.as(R.$$m.JSONContribution);class w{constructor(p,n,r){this.a=p,this.b=n,this.c=r}d(p,n){this.a({type:p,message:n,extensionId:this.b.identifier,extensionPointId:this.c})}error(p){this.d(I.default.Error,p)}warn(p){this.d(I.default.Warning,p)}info(p){this.d(I.default.Info,p)}}e.$VE=w;class m{static a(p){const n=new D.$Yl;for(let r=0,i=p.length;r<i;r++)n.add(p[r].description.identifier);return n}static compute(p,n){if(!p||!p.length)return new m(n,[]);if(!n||!n.length)return new m([],p);const r=this.a(p),i=this.a(n),o=n.filter(g=>!r.has(g.description.identifier)),y=p.filter(g=>!i.has(g.description.identifier));return new m(o,y)}constructor(p,n){this.added=p,this.removed=n}}e.$WE=m;class f{constructor(p,n){this.name=p,this.defaultExtensionKind=n,this.a=null,this.b=null,this.c=null}setHandler(p){if(this.a!==null)throw new Error("Handler already set!");this.a=p,this.d()}acceptUsers(p){this.c=m.compute(this.b,p),this.b=p,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(p){(0,C.$Y)(p)}}}e.$XE=f;const t={type:"string",enum:["ui","workspace"],enumDescriptions:[h.localize(0,null),h.localize(1,null)]},s="vscode://schemas/vscode-extensions";e.$YE={properties:{engines:{type:"object",description:h.localize(2,null),properties:{vscode:{type:"string",description:h.localize(3,null),default:"^1.22.0"}}},publisher:{description:h.localize(4,null),type:"string"},displayName:{description:h.localize(5,null),type:"string"},categories:{description:h.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:D.$Wl},{type:"string",const:"Languages",deprecationMessage:h.localize(7,null)}]}},galleryBanner:{type:"object",description:h.localize(8,null),properties:{color:{description:h.localize(9,null),type:"string"},theme:{description:h.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:h.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:h.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:h.localize(13,null)},enabledApiProposals:{markdownDescription:h.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(d.allApiProposals),markdownEnumDescriptions:Object.values(d.allApiProposals)}},api:{markdownDescription:h.localize(15,null),type:"string",enum:["none"],enumDescriptions:[h.localize(16,null)]},activationEvents:{description:h.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:h.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:h.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:h.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:h.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:h.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:h.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:h.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:h.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:h.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:h.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:h.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:h.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:h.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:h.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:h.localize(32,null)},{label:"onUri",body:"onUri",description:h.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:h.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:h.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:h.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:h.localize(37,null)},{label:"onRenderer",description:h.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:h.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:h.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:h.localize(41,null)},{label:"*",description:h.localize(42,null),body:"*"}]}},badges:{type:"array",description:h.localize(43,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:h.localize(44,null)},href:{type:"string",description:h.localize(45,null)},description:{type:"string",description:h.localize(46,null)}}}},markdown:{type:"string",description:h.localize(47,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:h.localize(48,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:h.localize(49,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:O.$On}},extensionPack:{description:h.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:O.$On}},extensionKind:{description:h.localize(51,null),type:"array",items:t,default:["workspace"],defaultSnippets:[{body:["ui"],description:h.localize(52,null)},{body:["workspace"],description:h.localize(53,null)},{body:["ui","workspace"],description:h.localize(54,null)},{body:["workspace","ui"],description:h.localize(55,null)},{body:[],description:h.localize(56,null)}]},capabilities:{description:h.localize(57,null),type:"object",properties:{virtualWorkspaces:{description:h.localize(58,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:h.localize(59,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[h.localize(60,null),h.localize(61,null),h.localize(62,null)]},description:{type:"string",markdownDescription:h.localize(63,null)}}},untrustedWorkspaces:{description:h.localize(64,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:h.localize(65,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[h.localize(66,null),h.localize(67,null),h.localize(68,null)]},restrictedConfigurations:{description:h.localize(69,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:h.localize(70,null)}}}}},sponsor:{description:h.localize(71,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:h.localize(72,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:h.localize(73,null),type:"string"},"vscode:uninstall":{description:h.localize(74,null),type:"string"}}},icon:{type:"string",description:h.localize(75,null)},l10n:{type:"string",description:h.localize(76,null)},pricing:{type:"string",markdownDescription:h.localize(77,null),enum:["Free","Trial"],default:"Free"}}};class c{constructor(){this.a=new Map}registerExtensionPoint(p){if(this.a.has(p.extensionPoint))throw new Error("Duplicate extension point: "+p.extensionPoint);const n=new f(p.extensionPoint,p.defaultExtensionKind);return this.a.set(p.extensionPoint,n),p.activationEventsGenerator&&k.$ME.register(p.extensionPoint,p.activationEventsGenerator),e.$YE.properties.contributes.properties[p.extensionPoint]=p.jsonSchema,a.registerSchema(s,e.$YE),n}getExtensionPoints(){return Array.from(this.a.values())}}e.$ZE=c;const v={ExtensionsRegistry:"ExtensionsRegistry"};u.$0m.add(v.ExtensionsRegistry,new c),e.$1E=u.$0m.as(v.ExtensionsRegistry),a.registerSchema(s,e.$YE),a.registerSchema(A.$mj,{properties:{extensionEnabledApiProposals:{description:h.localize(78,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(d.allApiProposals),markdownEnumDescriptions:Object.values(d.allApiProposals)}}]}}}})}),define(Ae[213],Re([1,0,163,16,24,212,32,5]),function(ie,e,h,C,I,O,R,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JF=void 0;const D={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:h.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:h.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:h.localize(2,null),default:""}}};var d;(function(a){function w(m,f,t){if(!m)return;const s=C.$wf(m.type)?m.type:void 0;if(!s||s.length===0){t.error(h.localize(3,null));return}const c=[];if(Array.isArray(m.required))for(const v of m.required)C.$wf(v)&&c.push(v);return{extensionId:f.value,taskType:s,required:c,properties:m.properties?I.$Xm(m.properties):{},when:m.when?R.$Ji.deserialize(m.when):void 0}}a.from=w})(d||(d={}));const A=O.$1E.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(a,w)=>{for(const m of a)m.type&&w.push(`onTaskType:${m.type}`)},jsonSchema:{description:h.localize(4,null),type:"array",items:D}});class k{constructor(){this.d=new u.$Ld,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((w,m)=>{A.setHandler((f,t)=>{this.c=void 0;try{for(const s of t.removed){const c=s.value;for(const v of c)this.a&&v.type&&this.a[v.type]&&delete this.a[v.type]}for(const s of t.added){const c=s.value;for(const v of c){const S=d.from(v,s.description.identifier,s.collector);S&&(this.a[S.taskType]=S)}}(t.removed.length>0||t.added.length>0)&&this.d.fire()}catch{}w(void 0)})})}onReady(){return this.b}get(w){return this.a[w]}all(){return Object.keys(this.a).map(w=>this.a[w])}getJsonSchema(){if(this.c===void 0){const w=[];for(const m of this.all()){const f={type:"object",additionalProperties:!1};m.required.length>0&&(f.required=m.required.slice(0)),m.properties!==void 0?f.properties=I.$Xm(m.properties):f.properties=Object.create(null),f.properties.type={type:"string",enum:[m.taskType]},w.push(f)}this.c={oneOf:w}}return this.c}}e.$JF=new k}),define(Ae[214],Re([1,0,164,16,23,24,32,213]),function(ie,e,h,C,I,O,R,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$TF=e.JsonSchemaVersion=e.ExecutionEngine=e.$SF=e.$RF=e.$QF=e.$PF=e.$OF=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$NF=e.ShellQuoting=e.$MF=e.$LF=e.$KF=void 0,e.$KF="settings",e.$LF=new R.$3i("taskRunning",!1,h.localize(0,null)),e.$MF={value:h.localize(1,null),original:"Tasks"};var D;(function(L){L[L.Escape=1]="Escape",L[L.Strong=2]="Strong",L[L.Weak=3]="Weak"})(D||(e.ShellQuoting=D={})),e.$NF="$customized",function(L){function z(K){if(!K)return L.Strong;switch(K.toLowerCase()){case"escape":return L.Escape;case"strong":return L.Strong;case"weak":return L.Weak;default:return L.Strong}}L.from=z}(D||(e.ShellQuoting=D={}));var d;(function(L){L.defaults={cwd:"${workspaceFolder}"}})(d||(e.CommandOptions=d={}));var A;(function(L){L[L.Always=1]="Always",L[L.Silent=2]="Silent",L[L.Never=3]="Never"})(A||(e.RevealKind=A={})),function(L){function z(K){switch(K.toLowerCase()){case"always":return L.Always;case"silent":return L.Silent;case"never":return L.Never;default:return L.Always}}L.fromString=z}(A||(e.RevealKind=A={}));var k;(function(L){L[L.Never=1]="Never",L[L.OnProblem=2]="OnProblem",L[L.Always=3]="Always"})(k||(e.RevealProblemKind=k={})),function(L){function z(K){switch(K.toLowerCase()){case"always":return L.Always;case"never":return L.Never;case"onproblem":return L.OnProblem;default:return L.OnProblem}}L.fromString=z}(k||(e.RevealProblemKind=k={}));var a;(function(L){L[L.Shared=1]="Shared",L[L.Dedicated=2]="Dedicated",L[L.New=3]="New"})(a||(e.PanelKind=a={})),function(L){function z(K){switch(K.toLowerCase()){case"shared":return L.Shared;case"dedicated":return L.Dedicated;case"new":return L.New;default:return L.Shared}}L.fromString=z}(a||(e.PanelKind=a={}));var w;(function(L){L.defaults={echo:!0,reveal:A.Always,revealProblems:k.Never,focus:!1,panel:a.Shared,showReuseMessage:!0,clear:!1}})(w||(e.PresentationOptions=w={}));var m;(function(L){L[L.Shell=1]="Shell",L[L.Process=2]="Process",L[L.CustomExecution=3]="CustomExecution"})(m||(e.RuntimeType=m={})),function(L){function z(B){switch(B.toLowerCase()){case"shell":return L.Shell;case"process":return L.Process;case"customExecution":return L.CustomExecution;default:return L.Process}}L.fromString=z;function K(B){switch(B){case L.Shell:return"shell";case L.Process:return"process";case L.CustomExecution:return"customExecution";default:return"process"}}L.toString=K}(m||(e.RuntimeType=m={}));var f;(function(L){function z(K){return C.$wf(K)?K:K.value}L.value=z})(f||(e.CommandString=f={}));var t;(function(L){L.Clean={_id:"clean",isDefault:!1},L.Build={_id:"build",isDefault:!1},L.Rebuild={_id:"rebuild",isDefault:!1},L.Test={_id:"test",isDefault:!1};function z(B){return B===L.Clean._id||B===L.Build._id||B===L.Rebuild._id||B===L.Test._id}L.is=z;function K(B){if(B!==void 0)return C.$wf(B)?z(B)?{_id:B,isDefault:!1}:void 0:B}L.from=K})(t||(e.TaskGroup=t={}));var s;(function(L){L[L.Global=1]="Global",L[L.Workspace=2]="Workspace",L[L.Folder=3]="Folder"})(s||(e.TaskScope=s={}));var c;(function(L){L.Workspace="workspace",L.Extension="extension",L.InMemory="inMemory",L.WorkspaceFile="workspaceFile",L.User="user";function z(K){switch(K){case L.User:return 2;case L.WorkspaceFile:return 5;default:return 6}}L.toConfigurationTarget=z})(c||(e.TaskSourceKind=c={}));var v;(function(L){L.parallel="parallel",L.sequence="sequence"})(v||(e.DependsOrder=v={}));var S;(function(L){L[L.default=1]="default",L[L.folderOpen=2]="folderOpen"})(S||(e.RunOnOptions=S={}));var p;(function(L){L.defaults={reevaluateOnRerun:!0,runOn:S.default,instanceLimit:1}})(p||(e.RunOptions=p={}));class n{constructor(z,K,B,me,ye,Ie){this._label="",this._id=z,K&&(this._label=K),B&&(this.type=B),this.runOptions=me,this.configurationProperties=ye,this._source=Ie}getDefinition(z){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const z={folder:this.d(),id:this._id};return JSON.stringify(z)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(z,K=!1){if(z===void 0)return!1;if(C.$wf(z))return z===this._label||z===this.configurationProperties.identifier||K&&z===this._id;const B=this.getDefinition(!0);return B!==void 0&&B._key===z._key}getQualifiedLabel(){const z=this.getWorkspaceFolder();return z?`${this._label} (${z.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(z){this.c===void 0&&(this.c=[]),z&&(this.c=this.c.concat(z))}get taskLoadMessages(){return this.c}}e.$OF=n;class r extends n{constructor(z,K,B,me,ye,Ie,_,de){super(z,B,void 0,_,de,K),this.command={},this._source=K,this.hasDefinedMatchers=Ie,ye&&(this.command=ye)}clone(){return new r(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(z=!1){if(z&&this._source.customizes!==void 0)return this._source.customizes;{let K;switch(this.command?this.command.runtime:void 0){case m.Shell:K="shell";break;case m.Process:K="process";break;case m.CustomExecution:K="customExecution";break;case void 0:K="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:K,_key:this._id,id:this._id}}}static is(z){return z instanceof r}getMapKey(){const z=this._source.config.workspaceFolder;return z?`${z.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===c.User?e.$KF:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const z=this.d();if(!z)return;let K=this.configurationProperties.identifier;this._source.kind!==c.Workspace&&(K+=this._source.kind);const B={type:e.$NF,folder:z,id:K};return JSON.stringify(B)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?I.$pg(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(z){return new r(z._id,z._source,z._label,z.type,z.command,z.hasDefinedMatchers,z.runOptions,z.configurationProperties)}}e.$PF=r;class i extends n{constructor(z,K,B,me,ye,Ie,_){super(z,B,me,Ie,_,K),this._source=K,this.configures=ye}static is(z){return z instanceof i}f(z){return z}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?I.$pg(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===c.User?e.$KF:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const z=this.d();if(!z)return;let K=this.configurationProperties.identifier;this._source.kind!==c.Workspace&&(K+=this._source.kind);const B={type:e.$NF,folder:z,id:K};return JSON.stringify(B)}}e.$QF=i;class o extends n{constructor(z,K,B,me,ye,Ie,_,de,De){super(z,B,me,de,De,K),this.defines=ye,this.hasDefinedMatchers=_,this.command=Ie,this.icon=De.icon,this.hide=De.hide}clone(){return new o(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(z){return z instanceof o}getMapKey(){const z=this._source.workspaceFolder;return z?`${this._source.scope.toString()}|${z.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const z={type:"contributed",scope:this._source.scope,id:this._id};return z.folder=this.d(),JSON.stringify(z)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(z){return new o(z._id,z._source,z._label,z.type,z.defines,z.command,z.hasDefinedMatchers,z.runOptions,z.configurationProperties)}}e.$RF=o;class y extends n{constructor(z,K,B,me,ye,Ie){super(z,B,me,ye,Ie,K),this._source=K}clone(){return new y(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(z){return z instanceof y}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(z){return new y(z._id,z._source,z._label,z.type,z.runOptions,z.configurationProperties)}}e.$SF=y;var g;(function(L){L[L.Process=1]="Process",L[L.Terminal=2]="Terminal"})(g||(e.ExecutionEngine=g={})),function(L){L._default=L.Terminal}(g||(e.ExecutionEngine=g={}));var E;(function(L){L[L.V0_1_0=1]="V0_1_0",L[L.V2_0_0=2]="V2_0_0"})(E||(e.JsonSchemaVersion=E={}));class P{constructor(z){this.c=new Map;for(let K=0;K<z.length;K++)this.c.set(z[K].uri.toString(),K)}compare(z,K){const B=z.getWorkspaceFolder(),me=K.getWorkspaceFolder();if(B&&me){let ye=this.c.get(B.uri.toString());ye=ye===void 0?0:ye+1;let Ie=this.c.get(me.uri.toString());return Ie=Ie===void 0?0:Ie+1,ye===Ie?z._label.localeCompare(K._label):ye-Ie}else return!B&&me?-1:B&&!me?1:0}}e.$TF=P;var l;(function(L){L.DependsOnStarted="dependsOnStarted",L.AcquiredInput="acquiredInput",L.Start="start",L.ProcessStarted="processStarted",L.Active="active",L.Inactive="inactive",L.Changed="changed",L.Terminated="terminated",L.ProcessEnded="processEnded",L.End="end"})(l||(e.TaskEventKind=l={}));var $;(function(L){L.SingleRun="singleRun",L.Background="background"})($||(e.TaskRunType=$={}));var b;(function(L){L[L.System=0]="System",L[L.User=1]="User",L[L.FolderOpen=2]="FolderOpen",L[L.ConfigurationChange=3]="ConfigurationChange",L[L.Reconnect=4]="Reconnect"})(b||(e.TaskRunSource=b={}));var M;(function(L){function z(de){return{taskId:de._id,taskName:de.configurationProperties.name,runType:de.configurationProperties.isBackground?"background":"singleRun",group:de.configurationProperties.group,__task:de}}function K(de,De,ue){return{...z(de),kind:"start",terminalId:De,resolvedVariables:ue}}L.start=K;function B(de,De,ue){return{...z(de),kind:"processStarted",terminalId:De,processId:ue}}L.processStarted=B;function me(de,De,ue){return{...z(de),kind:"processEnded",terminalId:De,exitCode:ue}}L.processEnded=me;function ye(de,De,ue){return{...z(de),kind:"terminated",exitReason:ue,terminalId:De}}L.terminated=ye;function Ie(de,De,ue){return{...z(De),kind:de,terminalId:ue}}L.general=Ie;function _(){return{kind:"changed"}}L.changed=_})(M||(e.TaskEvent=M={}));var U;(function(L){function z(B){const me=Object.keys(B).sort();let ye="";for(const Ie of me){let _=B[Ie];_ instanceof Object?_=z(_):typeof _=="string"&&(_=_.replace(/,/g,",,")),ye+=Ie+","+_+","}return ye}function K(B){const ye={_key:z(B),type:B.taskType};return Object.assign(ye,B),ye}L.create=K})(U||(e.KeyedTaskIdentifier=U={}));var F;(function(L){L.AutoDetect="task.autoDetect",L.SaveBeforeRun="task.saveBeforeRun",L.ShowDecorations="task.showDecorations",L.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",L.SlowProviderWarning="task.slowProviderWarning",L.QuickOpenHistory="task.quickOpen.history",L.QuickOpenDetail="task.quickOpen.detail",L.QuickOpenSkip="task.quickOpen.skip",L.QuickOpenShowAll="task.quickOpen.showAll",L.AllowAutomaticTasks="task.allowAutomaticTasks",L.Reconnection="task.reconnection"})(F||(e.TaskSettingId=F={}));var q;(function(L){L.Tasks="tasks",L.SuppressTaskName="tasks.suppressTaskName",L.Windows="tasks.windows",L.Osx="tasks.osx",L.Linux="tasks.linux",L.ShowOutput="tasks.showOutput",L.IsShellCommand="tasks.isShellCommand",L.ServiceTestSetting="tasks.service.testSetting"})(q||(e.TasksSchemaProperties=q={}));var W;(function(L){function z(K,B){const me=u.$JF.get(K.type);if(me===void 0){const de=O.$Xm(K);return delete de._key,U.create(de)}const ye=Object.create(null);ye.type=me.taskType;const Ie=new Set;me.required.forEach(de=>Ie.add(de));const _=me.properties;for(const de of Object.keys(_)){const De=K[de];if(De!=null)ye[de]=De;else if(Ie.has(de)){const ue=_[de];if(ue.default!==void 0)ye[de]=O.$Xm(ue.default);else switch(ue.type){case"boolean":ye[de]=!1;break;case"number":case"integer":ye[de]=0;break;case"string":ye[de]="";break;default:B.error(h.localize(2,null,JSON.stringify(K,void 0,0),de));return}}}return U.create(ye)}L.createTaskIdentifier=z})(W||(e.TaskDefinition=W={}))}),define(Ae[215],Re([1,0,9]),function(ie,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$3b=e.$03b=void 0;class C{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((R,u)=>{this.b=R,this.d=u,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(R){this.f||this.h||(this.f=!0,this.g=R,this.a&&this.b(R))}resolveErr(R){this.f||this.h||(this.h=!0,this.i=R,this.a?this.d(R):(0,h.$Y)(R))}then(R,u){return this.j().then(R,u)}catch(R){return this.j().then(void 0,R)}finally(R){return this.j().finally(R)}}e.$03b=C;class I extends C{constructor(){super(),this.h=!0,this.i=new h.$3}}e.$$3b=I}),define(Ae[46],Re([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iv=e.$hv=e.$gv=e.$fv=void 0;class h{constructor(D){this._proxyIdentifierBrand=void 0,this.sid=D,this.nid=++h.count}}e.$fv=h,h.count=0;const C=[];function I(u){const D=new h(u);return C[D.nid]=D,D}e.$gv=I;function O(u){return C[u].sid}e.$hv=O;class R{constructor(D){this.value=D}}e.$iv=R}),define(Ae[3],Re([1,0,46]),function(ie,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0J=e.$9J=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$8J=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var C;(function(f){f[f.Default=0]="Default",f[f.InCenter=1]="InCenter",f[f.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",f[f.AtTop=3]="AtTop"})(C||(e.TextEditorRevealType=C={}));var I;(function(f){f[f.UnknownInput=0]="UnknownInput",f[f.TextInput=1]="TextInput",f[f.TextDiffInput=2]="TextDiffInput",f[f.TextMergeInput=3]="TextMergeInput",f[f.NotebookInput=4]="NotebookInput",f[f.NotebookDiffInput=5]="NotebookDiffInput",f[f.CustomEditorInput=6]="CustomEditorInput",f[f.WebviewEditorInput=7]="WebviewEditorInput",f[f.TerminalEditorInput=8]="TerminalEditorInput",f[f.InteractiveEditorInput=9]="InteractiveEditorInput"})(I||(e.TabInputKind=I={}));var O;(function(f){f[f.TAB_OPEN=0]="TAB_OPEN",f[f.TAB_CLOSE=1]="TAB_CLOSE",f[f.TAB_UPDATE=2]="TAB_UPDATE",f[f.TAB_MOVE=3]="TAB_MOVE"})(O||(e.TabModelOperationKind=O={}));var R;(function(f){f[f.Editable=0]="Editable",f[f.SupportsHotExit=1]="SupportsHotExit"})(R||(e.WebviewEditorCapabilities=R={}));var u;(function(f){f[f.Int8Array=1]="Int8Array",f[f.Uint8Array=2]="Uint8Array",f[f.Uint8ClampedArray=3]="Uint8ClampedArray",f[f.Int16Array=4]="Int16Array",f[f.Uint16Array=5]="Uint16Array",f[f.Int32Array=6]="Int32Array",f[f.Uint32Array=7]="Uint32Array",f[f.Float32Array=8]="Float32Array",f[f.Float64Array=9]="Float64Array",f[f.BigInt64Array=10]="BigInt64Array",f[f.BigUint64Array=11]="BigUint64Array"})(u||(e.WebviewMessageArrayBufferViewType=u={}));var D;(function(f){f[f.Text=1]="Text",f[f.Error=2]="Error",f[f.Rich=3]="Rich"})(D||(e.CellOutputKind=D={}));var d;(function(f){f[f.Default=0]="Default",f[f.InCenter=1]="InCenter",f[f.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",f[f.AtTop=3]="AtTop"})(d||(e.NotebookEditorRevealType=d={}));var A;(function(f){f[f.None=0]="None",f[f.Process=1]="Process",f[f.Output=2]="Output"})(A||(e.CandidatePortSource=A={}));class k{static mixin(t){return t._id=k.a++,t}}e.$8J=k,k.a=0;var a;(function(f){f.label="a",f.kind="b",f.detail="c",f.documentation="d",f.sortText="e",f.filterText="f",f.preselect="g",f.insertText="h",f.insertTextRules="i",f.range="j",f.commitCharacters="k",f.additionalTextEdits="l",f.kindModifier="m",f.commandIdent="n",f.commandId="o",f.commandArguments="p"})(a||(e.ISuggestDataDtoField=a={}));var w;(function(f){f.defaultRanges="a",f.completions="b",f.isIncomplete="c",f.duration="d"})(w||(e.ISuggestResultDtoField=w={}));var m;(function(f){f[f.Workspace=0]="Workspace",f[f.TextDocument=1]="TextDocument"})(m||(e.ExtHostTestingResource=m={})),e.$9J={MainThreadAuthentication:(0,h.$gv)("MainThreadAuthentication"),MainThreadBulkEdits:(0,h.$gv)("MainThreadBulkEdits"),MainThreadChatProvider:(0,h.$gv)("MainThreadChatProvider"),MainThreadChatSlashCommands:(0,h.$gv)("MainThreadChatSlashCommands"),MainThreadChatAgents:(0,h.$gv)("MainThreadChatAgents"),MainThreadChatVariables:(0,h.$gv)("MainThreadChatVariables"),MainThreadClipboard:(0,h.$gv)("MainThreadClipboard"),MainThreadCommands:(0,h.$gv)("MainThreadCommands"),MainThreadComments:(0,h.$gv)("MainThreadComments"),MainThreadConfiguration:(0,h.$gv)("MainThreadConfiguration"),MainThreadConsole:(0,h.$gv)("MainThreadConsole"),MainThreadDebugService:(0,h.$gv)("MainThreadDebugService"),MainThreadDecorations:(0,h.$gv)("MainThreadDecorations"),MainThreadDiagnostics:(0,h.$gv)("MainThreadDiagnostics"),MainThreadDialogs:(0,h.$gv)("MainThreadDiaglogs"),MainThreadDocuments:(0,h.$gv)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,h.$gv)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,h.$gv)("MainThreadTextEditors"),MainThreadEditorInsets:(0,h.$gv)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,h.$gv)("MainThreadEditorTabs"),MainThreadErrors:(0,h.$gv)("MainThreadErrors"),MainThreadTreeViews:(0,h.$gv)("MainThreadTreeViews"),MainThreadDownloadService:(0,h.$gv)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,h.$gv)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,h.$gv)("MainThreadLanguages"),MainThreadLogger:(0,h.$gv)("MainThreadLogger"),MainThreadMessageService:(0,h.$gv)("MainThreadMessageService"),MainThreadOutputService:(0,h.$gv)("MainThreadOutputService"),MainThreadProgress:(0,h.$gv)("MainThreadProgress"),MainThreadQuickDiff:(0,h.$gv)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,h.$gv)("MainThreadQuickOpen"),MainThreadStatusBar:(0,h.$gv)("MainThreadStatusBar"),MainThreadSecretState:(0,h.$gv)("MainThreadSecretState"),MainThreadStorage:(0,h.$gv)("MainThreadStorage"),MainThreadTelemetry:(0,h.$gv)("MainThreadTelemetry"),MainThreadTerminalService:(0,h.$gv)("MainThreadTerminalService"),MainThreadWebviews:(0,h.$gv)("MainThreadWebviews"),MainThreadWebviewPanels:(0,h.$gv)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,h.$gv)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,h.$gv)("MainThreadCustomEditors"),MainThreadUrls:(0,h.$gv)("MainThreadUrls"),MainThreadUriOpeners:(0,h.$gv)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,h.$gv)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,h.$gv)("MainThreadWorkspace"),MainThreadFileSystem:(0,h.$gv)("MainThreadFileSystem"),MainThreadExtensionService:(0,h.$gv)("MainThreadExtensionService"),MainThreadSCM:(0,h.$gv)("MainThreadSCM"),MainThreadSearch:(0,h.$gv)("MainThreadSearch"),MainThreadShare:(0,h.$gv)("MainThreadShare"),MainThreadTask:(0,h.$gv)("MainThreadTask"),MainThreadWindow:(0,h.$gv)("MainThreadWindow"),MainThreadLabelService:(0,h.$gv)("MainThreadLabelService"),MainThreadNotebook:(0,h.$gv)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,h.$gv)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,h.$gv)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,h.$gv)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,h.$gv)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,h.$gv)("MainThreadInteractive"),MainThreadChat:(0,h.$gv)("MainThreadChat"),MainThreadInlineChat:(0,h.$gv)("MainThreadInlineChatShape"),MainThreadTheming:(0,h.$gv)("MainThreadTheming"),MainThreadTunnelService:(0,h.$gv)("MainThreadTunnelService"),MainThreadManagedSockets:(0,h.$gv)("MainThreadManagedSockets"),MainThreadTimeline:(0,h.$gv)("MainThreadTimeline"),MainThreadTesting:(0,h.$gv)("MainThreadTesting"),MainThreadLocalization:(0,h.$gv)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,h.$gv)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,h.$gv)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,h.$gv)("MainThreadIssueReporter")},e.$0J={ExtHostCommands:(0,h.$gv)("ExtHostCommands"),ExtHostConfiguration:(0,h.$gv)("ExtHostConfiguration"),ExtHostDiagnostics:(0,h.$gv)("ExtHostDiagnostics"),ExtHostDebugService:(0,h.$gv)("ExtHostDebugService"),ExtHostDecorations:(0,h.$gv)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,h.$gv)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,h.$gv)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,h.$gv)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,h.$gv)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,h.$gv)("ExtHostEditors"),ExtHostTreeViews:(0,h.$gv)("ExtHostTreeViews"),ExtHostFileSystem:(0,h.$gv)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,h.$gv)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,h.$gv)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,h.$gv)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,h.$gv)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,h.$gv)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,h.$gv)("ExtHostQuickDiff"),ExtHostStatusBar:(0,h.$gv)("ExtHostStatusBar"),ExtHostShare:(0,h.$gv)("ExtHostShare"),ExtHostExtensionService:(0,h.$gv)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,h.$gv)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,h.$gv)("ExtHostTerminalService"),ExtHostSCM:(0,h.$gv)("ExtHostSCM"),ExtHostSearch:(0,h.$gv)("ExtHostSearch"),ExtHostTask:(0,h.$gv)("ExtHostTask"),ExtHostWorkspace:(0,h.$gv)("ExtHostWorkspace"),ExtHostWindow:(0,h.$gv)("ExtHostWindow"),ExtHostWebviews:(0,h.$gv)("ExtHostWebviews"),ExtHostWebviewPanels:(0,h.$gv)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,h.$gv)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,h.$gv)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,h.$gv)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,h.$gv)("ExtHostEditorTabs"),ExtHostProgress:(0,h.$gv)("ExtHostProgress"),ExtHostComments:(0,h.$gv)("ExtHostComments"),ExtHostSecretState:(0,h.$gv)("ExtHostSecretState"),ExtHostStorage:(0,h.$gv)("ExtHostStorage"),ExtHostUrls:(0,h.$gv)("ExtHostUrls"),ExtHostUriOpeners:(0,h.$gv)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,h.$gv)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,h.$gv)("ExtHostOutputService"),ExtHosLabelService:(0,h.$gv)("ExtHostLabelService"),ExtHostNotebook:(0,h.$gv)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,h.$gv)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,h.$gv)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,h.$gv)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,h.$gv)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,h.$gv)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,h.$gv)("ExtHostInteractive"),ExtHostInlineChat:(0,h.$gv)("ExtHostInlineChatShape"),ExtHostChat:(0,h.$gv)("ExtHostChat"),ExtHostChatSlashCommands:(0,h.$gv)("ExtHostChatSlashCommands"),ExtHostChatAgents:(0,h.$gv)("ExtHostChatAgents"),ExtHostChatVariables:(0,h.$gv)("ExtHostChatVariables"),ExtHostChatProvider:(0,h.$gv)("ExtHostChatProvider"),ExtHostAiRelatedInformation:(0,h.$gv)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,h.$gv)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,h.$gv)("ExtHostTheming"),ExtHostTunnelService:(0,h.$gv)("ExtHostTunnelService"),ExtHostManagedSockets:(0,h.$gv)("ExtHostManagedSockets"),ExtHostAuthentication:(0,h.$gv)("ExtHostAuthentication"),ExtHostTimeline:(0,h.$gv)("ExtHostTimeline"),ExtHostTesting:(0,h.$gv)("ExtHostTesting"),ExtHostTelemetry:(0,h.$gv)("ExtHostTelemetry"),ExtHostLocalization:(0,h.$gv)("ExtHostLocalization"),ExtHostIssueReporter:(0,h.$gv)("ExtHostIssueReporter")}}),define(Ae[216],Re([1,0,3,7]),function(ie,e,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Adc=void 0;class I{constructor(R){this.a=new Map,this.b=0,this.c=R.getProxy(h.$9J.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(R,u,D){if(this.a.size===0)throw new Error("No related information providers registered");const d=this.a.get(R);if(!d)throw new Error("related information provider not found");return await d.provideRelatedInformation(u,D)??[]}getRelatedInformation(R,u,D){return this.c.$getAiRelatedInformation(u,D)}registerRelatedInformationProvider(R,u,D){const d=this.b;return this.b++,this.a.set(d,D),this.c.$registerAiRelatedInformationProvider(d,u),new C.$$J(()=>{this.c.$unregisterAiRelatedInformationProvider(d),this.a.delete(d)})}}e.$Adc=I}),define(Ae[80],Re([1,0,4,14,3,17]),function(ie,e,h,C,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ebc=e.$Dbc=e.$Cbc=void 0,e.$Cbc=(0,h.$Lh)("IExtHostApiDeprecationService");let R=class{constructor(D,d){this.c=d,this.a=new Set,this.b=D.getProxy(I.$9J.MainThreadTelemetry)}report(D,d,A){const k=this.d(D,d);this.a.has(k)||(this.a.add(k),d.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${D}' is deprecated. ${A}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:d.identifier.value,apiId:D}))}d(D,d){return`${D}-${d.identifier.value}`}};e.$Dbc=R,e.$Dbc=R=Je([qe(0,O.$0L),qe(1,C.$6i)],R),e.$Ebc=Object.freeze(new class{report(u,D,d){}})}),define(Ae[217],Re([1,0,5,3,7,20]),function(ie,e,h,C,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$cc=void 0;class R{constructor(d){this.b=new Map,this.c=[],this.d=new h.$Ld,this.onDidChangeSessions=this.d.event,this.f=new u,this.g=new u,this.a=d.getProxy(C.$9J.MainThreadAuthentication)}$setProviders(d){return this.c=d,Promise.resolve()}async getSession(d,A,k,a={}){const w=O.$Xl.toKey(d.identifier),m=[...k].sort().join(" ");return await this.f.getOrCreate(`${w} ${A} ${m}`,async()=>{await this.a.$ensureProvider(A);const f=d.displayName||d.name;return this.a.$getSession(A,k,w,f,a)})}async getSessions(d,A,k){const a=O.$Xl.toKey(d.identifier),w=[...k].sort().join(" ");return await this.g.getOrCreate(`${a} ${w}`,async()=>{await this.a.$ensureProvider(A);const m=d.displayName||d.name;return this.a.$getSessions(A,k,a,m)})}async removeSession(d,A){const k=this.b.get(d);return k?k.provider.removeSession(A):this.a.$removeSession(d,A)}registerAuthenticationProvider(d,A,k,a){if(this.b.get(d))throw new Error(`An authentication provider with id '${d}' is already registered.`);this.b.set(d,{label:A,provider:k,options:a??{supportsMultipleAccounts:!1}}),this.c.find(m=>m.id===d)||this.c.push({id:d,label:A});const w=k.onDidChangeSessions(m=>{this.a.$sendDidChangeSessions(d,{added:m.added??[],changed:m.changed??[],removed:m.removed??[]})});return this.a.$registerAuthenticationProvider(d,A,a?.supportsMultipleAccounts??!1),new I.$$J(()=>{w.dispose(),this.b.delete(d);const m=this.c.findIndex(f=>f.id===d);m>-1&&this.c.splice(m),this.a.$unregisterAuthenticationProvider(d)})}$createSession(d,A,k){const a=this.b.get(d);if(a)return Promise.resolve(a.provider.createSession(A,k));throw new Error(`Unable to find authentication provider with handle: ${d}`)}$removeSession(d,A){const k=this.b.get(d);if(k)return Promise.resolve(k.provider.removeSession(A));throw new Error(`Unable to find authentication provider with handle: ${d}`)}$getSessions(d,A){const k=this.b.get(d);if(k)return Promise.resolve(k.provider.getSessions(A));throw new Error(`Unable to find authentication provider with handle: ${d}`)}$onDidChangeAuthenticationSessions(d,A){return this.d.fire({provider:{id:d,label:A}}),Promise.resolve()}}e.$$cc=R;class u{constructor(){this.a=new Map}getOrCreate(d,A){const k=this.a.get(d);if(k)return k;const a=A().finally(()=>this.a.delete(d));return this.a.set(d,a),a}}}),define(Ae[218],Re([1,0,3,17,8]),function(ie,e,h,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$edc=void 0;let O=class{constructor(u,D){this.a=u.getProxy(h.$9J.MainThreadBulkEdits),this.b={getTextDocumentVersion:d=>D.getDocument(d)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(u,D,d){const A=I.WorkspaceEdit.from(u,this.b);return this.a.$tryApplyWorkspaceEdit(A,void 0,d?.isRefactoring??!1)}};e.$edc=O,e.$edc=O=Je([qe(0,C.$0L)],O)}),define(Ae[219],Re([1,0,12,5,69,6,59,146,3,8]),function(ie,e,h,C,I,O,R,u,D,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sdc=void 0;class A{constructor(w,m){this.extension=w,this.provider=m,this.handle=A.a++}}A.a=0;class k{constructor(w,m){this.i=m,this.b=new Map,this.e=new Map,this.g=new C.$Ld,this.onDidPerformUserAction=this.g.event,this.h=w.getProxy(D.$9J.MainThreadChat)}registerChatProvider(w,m,f){const t=new A(w,f);return this.b.set(t.handle,t),this.h.$registerChatProvider(t.handle,m),(0,O.$Oc)(()=>{this.h.$unregisterChatProvider(t.handle),this.b.delete(t.handle)})}transferChatSession(w,m){const f=I.Iterable.find(this.e.keys(),t=>this.e.get(t)===w)??0;typeof f=="number"&&this.h.$transferChatSession(f,m)}addChatRequest(w){this.h.$addRequest(w)}sendInteractiveRequestToProvider(w,m){this.h.$sendRequestToProvider(w,m)}async $prepareChat(w,m,f){const t=this.b.get(w);if(!t)return;const s=await t.provider.prepareSession(m,f);if(!s)return;const c=k.a++;return this.e.set(c,s),{id:c,requesterUsername:s.requester?.name,requesterAvatarIconUri:s.requester?.icon,responderUsername:s.responder?.name,responderAvatarIconUri:s.responder?.icon,inputPlaceholder:s.inputPlaceholder}}async $resolveRequest(w,m,f,t){const s=this.b.get(w);if(!s)return;const c=this.e.get(m);if(!c||!s.provider.resolveRequest)return;const v=await s.provider.resolveRequest(c,f,t);if(v)return{message:typeof v.message=="string"?v.message:d.ChatReplyFollowup.from(v.message)}}async $provideWelcomeMessage(w,m){const f=this.b.get(w);if(!f||!f.provider.provideWelcomeMessage)return;const t=await f.provider.provideWelcomeMessage(m);if(t)return t.map(s=>typeof s=="string"?s:s.map(c=>d.ChatReplyFollowup.from(c)))}async $provideFollowups(w,m,f){const t=this.b.get(w);if(!t)return;const s=this.e.get(m);return!s||!t.provider.provideFollowups?void 0:(await t.provider.provideFollowups(s,f))?.map(v=>d.ChatFollowup.from(v))}$removeRequest(w,m,f){const t=this.b.get(w);if(!t)return;const s=this.e.get(m);s&&t.provider.removeRequest&&t.provider.removeRequest(s,f)}async $provideReply(w,m,f,t){const s=this.b.get(w);if(!s)return;const c=this.e.get(m);if(!c)return;const v={session:c,message:typeof f.message=="string"?f.message:d.ChatReplyFollowup.to(f.message),variables:{}};if(f.variables)for(const o of Object.keys(f.variables))v.variables[o]=f.variables[o].map(d.ChatVariable.to);const S=R.$Hd.create(!1);let p;const n={report:o=>{if(!t.isCancellationRequested)if(typeof p>"u"&&(p=S.elapsed()),"responseId"in o)this.h.$acceptResponseProgress(w,m,{requestId:o.responseId});else if("placeholder"in o&&"resolvedContent"in o){const y=Promise.all([this.h.$acceptResponseProgress(w,m,{placeholder:o.placeholder}),o.resolvedContent]);(0,h.$Fg)(y,t).then(g=>{if(!g)return;const[E,P]=g;this.h.$acceptResponseProgress(w,m,P,E??void 0)})}else"content"in o?this.h.$acceptResponseProgress(w,m,{content:typeof o.content=="string"?o.content:d.MarkdownString.from(o.content)}):"documents"in o?this.h.$acceptResponseProgress(w,m,{documents:o.documents.map(y=>({uri:y.uri,version:y.version,ranges:y.ranges.map(g=>d.Range.from(g))}))}):this.h.$acceptResponseProgress(w,m,o)}};let r;try{r=await s.provider.provideResponseWithProgress(v,n,t),r||(r={errorDetails:{message:(0,u.localize)(0,null)}})}catch(o){r={errorDetails:{message:(0,u.localize)(1,null,o.message),responseIsIncomplete:!0}},this.i.error(o)}try{if(c.saveState&&this.e.has(m)){const o=c.saveState();this.h.$acceptChatState(m,o)}}catch(o){this.i.warn(o)}const i={firstProgress:p??0,totalElapsed:S.elapsed()};return{errorDetails:r.errorDetails,timings:i}}async $provideSlashCommands(w,m,f){const t=this.b.get(w);if(!t)return;const s=this.e.get(m);return!s||!t.provider.provideSlashCommands?void 0:(await t.provider.provideSlashCommands(s,f))?.map(v=>({...v,kind:d.CompletionItemKind.from(v.kind)}))}$releaseSession(w){this.e.delete(w)}async $onDidPerformUserAction(w){this.g.fire(w)}}e.$sdc=k,k.a=0}),define(Ae[220],Re([1,0,12,6,50,3,8,7]),function(ie,e,h,C,I,O,R,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cdc=void 0;class D{constructor(k,a,w){this.d=a,this.e=w,this.b=new Map,this.c=k.getProxy(O.$9J.MainThreadChatAgents)}registerAgent(k,a,w,m){const f=D.a++;return this.b.set(f,{extension:k,agent:w}),this.c.$registerAgent(f,a,m),(0,C.$Oc)(()=>{this.c.$unregisterAgent(f),this.b.delete(f)})}async $invokeAgent(k,a,w,m,f){const t=this.b.get(k);if(!t){this.e.warn(`[CHAT](${k}) CANNOT invoke agent because the agent is not registered`);return}let s=!1;function c(){if(s)throw new Error("Only valid while executing the command")}const v=new h.$_g;f.onCancellationRequested(()=>v.complete()),setTimeout(()=>v.complete(),3*1e3),this.d.allowListExtensionWhile(t.extension,v.p);const S=t.agent({role:u.ChatMessageRole.User,content:w},{history:m.history.map(R.ChatMessage.to)},new I.$Xu(p=>{c(),this.c.$handleProgressChunk(a,{content:d(p.message)?p.message:p.message.value})}),f);try{return await(0,h.$Fg)(Promise.resolve(S).then(p=>{if(p&&"followUp"in p)return{followUp:p?.followUp?.map(r=>R.ChatFollowup.from(r))}}),f)}finally{s=!0,v.complete()}}}e.$Cdc=D,D.a=0;function d(A){return!!A&&typeof A=="object"&&"treeData"in A}}),define(Ae[221],Re([1,0,6,3,8,50,20]),function(ie,e,h,C,I,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xdc=void 0;class u{constructor(d,A){this.d=A,this.c=new Map,this.e=new Map,this.f=new R.$Zl,this.b=d.getProxy(C.$9J.MainThreadChatProvider)}registerProvider(d,A,k,a){const w=u.a++;return this.c.set(w,{extension:d,provider:k}),this.b.$registerProvider(w,A,{extension:d,displayName:a.name??d.value}),(0,h.$Oc)(()=>{this.b.$unregisterProvider(w),this.c.delete(w)})}async $provideChatResponse(d,A,k,a,w){const m=this.c.get(d);if(!m)return;const f=new O.$Xu(async t=>{if(w.isCancellationRequested){this.d.warn(`[CHAT](${m.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}await this.b.$handleProgressChunk(A,{index:t.index,part:t.part})},{async:!0});return m.provider.provideChatResponse(k.map(I.ChatMessage.to),a,f,w)}allowListExtensionWhile(d,A){this.f.set(d,A),A.finally(()=>this.f.delete(d))}async requestChatResponseProvider(d,A){if(!this.f.has(d))throw new Error("Extension is NOT allowed to make chat requests");const k=this;return{get isRevoked(){return!k.f.has(d)},async makeRequest(a,w,m,f){if(!k.f.has(d))throw new Error("Access to chat has been revoked");const t=Math.random()*1e6|0;k.e.set(t,m);try{await k.b.$fetchResponse(d,A,t,a.map(I.ChatMessage.from),w,f)}finally{k.e.delete(t)}}}}async $handleResponseFragment(d,A){this.e.get(d)?.report(A)}}e.$xdc=u,u.a=1}),define(Ae[222],Re([1,0,6,3,7,8,50,12]),function(ie,e,h,C,I,O,R,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ydc=void 0;class D{constructor(k,a,w){this.d=a,this.e=w,this.b=new Map,this.c=k.getProxy(C.$9J.MainThreadChatSlashCommands)}registerCommand(k,a,w,m){const f=D.a++;return this.b.set(f,{extension:k,command:w}),this.c.$registerCommand(f,a,m.description),(0,h.$Oc)(()=>{this.c.$unregisterCommand(f),this.b.delete(f)})}async $executeCommand(k,a,w,m,f){const t=this.b.get(k);if(!t){this.e.warn(`[CHAT](${k}) CANNOT execute command because the command is not registered`);return}let s=!1;function c(){if(s)throw new Error("Only valid while executing the command")}const v=new u.$_g;f.onCancellationRequested(()=>v.complete()),setTimeout(()=>v.complete(),10*1e3),this.d.allowListExtensionWhile(t.extension,v.p);const S=t.command({role:I.ChatMessageRole.User,content:w},{history:m.history.map(O.ChatMessage.to)},new R.$Xu(p=>{c(),this.c.$handleProgressChunk(a,{content:d(p.message)?p.message:p.message.value})}),f);try{return await(0,u.$Fg)(Promise.resolve(S).then(p=>{if(p&&"followUp"in p)return{followUp:p?.followUp?.map(r=>O.ChatFollowup.from(r))}}),f)}finally{s=!0,v.complete()}}}e.$ydc=D,D.a=0;function d(A){return!!A&&typeof A=="object"&&"treeData"in A}}),define(Ae[223],Re([1,0,6,3,9,8]),function(ie,e,h,C,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zdc=void 0;class R{constructor(D){this.b=new Map,this.c=D.getProxy(C.$9J.MainThreadChatVariables)}async $resolveVariable(D,d,A){const k=this.b.get(D);if(k)try{const a=await k.resolver.resolve(k.data.name,{message:d},A);if(a)return a.map(O.ChatVariable.from)}catch(a){(0,I.$Z)(a)}}registerVariableResolver(D,d,A,k){const a=R.a++;return this.b.set(a,{extension:D.identifier,data:{name:d,description:A},resolver:k}),this.c.$registerVariable(a,{name:d,description:A}),(0,h.$Oc)(()=>{this.b.delete(a),this.c.$unregisterVariable(a)})}}e.$zdc=R,R.a=0}),define(Ae[224],Re([1,0,3]),function(ie,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hbc=void 0;class C{constructor(O){const R=O.getProxy(h.$9J.MainThreadClipboard);this.value=Object.freeze({readText(){return R.$readText()},writeText(u){return R.$writeText(u)}})}}e.$Hbc=C});var Ye=this&&this.__classPrivateFieldSet||function(ie,e,h,C,I){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!I:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?I.call(ie,h):I?I.value=h:e.set(ie,h),h},Ne=this&&this.__classPrivateFieldGet||function(ie,e,h,C){if(h==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!C:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?C:h==="a"?C.call(ie):C?C.value:e.get(ie)};define(Ae[31],Re([1,0,16,7,8,24,3,18,14,68,44,279,2,6,4,17,104,25,46,42,59,53,58]),function(ie,e,h,C,I,O,R,u,D,d,A,k,a,w,m,f,t,s,c,v,S,p,n){"use strict";var r,i,o;Object.defineProperty(e,"__esModule",{value:!0}),e.$xM=e.$wM=e.$vM=e.$uM=e.$tM=e.$sM=void 0;let y=class{constructor(b,M,U){r.set(this,void 0),this.b=new Map,this.c=new Map,i.set(this,void 0),o.set(this,void 0),Ye(this,r,b.getProxy(R.$9J.MainThreadCommands),"f"),this.d=M,Ye(this,o,U,"f"),Ye(this,i,b.getProxy(R.$9J.MainThreadTelemetry),"f"),this.converter=new g(this,F=>{const q=this.c.get(F);return q?.result===P.Void?q:void 0},M),this.f=[{processArgument(F){return(0,d.$ih)(F)}},{processArgument(F){return(0,O.$Zm)(F,function(q){if(A.$ms.isIRange(q))return I.Range.to(q);if(k.$ls.isIPosition(q))return I.Position.to(q);if(A.$ms.isIRange(q.range)&&a.URI.isUri(q.uri))return I.location.to(q);if(q instanceof s.$_d)return q.buffer.buffer;if(!Array.isArray(q))return q})}}]}registerArgumentProcessor(b){this.f.push(b)}registerApiCommand(b){const M=this.registerCommand(!1,b.id,async(...U)=>{const F=b.args.map((W,L)=>{if(!W.validate(U[L]))throw new Error(`Invalid argument '${W.name}' when running '${b.id}', received: ${typeof U[L]=="object"?JSON.stringify(U[L],null,"	"):U[L]} `);return W.convert(U[L])}),q=await this.executeCommand(b.internalId,...F);return b.result.convert(q,U,this.converter)},void 0,{description:b.description,args:b.args,returns:b.result.description});return this.c.set(b.id,b),new C.$$J(()=>{M.dispose(),this.c.delete(b.id)})}registerCommand(b,M,U,F,q,W){if(this.d.trace("ExtHostCommands#registerCommand",M),!M.trim().length)throw new Error("invalid id");if(this.b.has(M))throw new Error(`command '${M}' already exists`);return this.b.set(M,{callback:U,thisArg:F,description:q,extension:W}),b&&Ne(this,r,"f").$registerCommand(M),new C.$$J(()=>{this.b.delete(M)&&b&&Ne(this,r,"f").$unregisterCommand(M)})}executeCommand(b,...M){return this.d.trace("ExtHostCommands#executeCommand",b),this.g(b,M,!0)}async g(b,M,U){if(this.b.has(b))return Ne(this,r,"f").$fireCommandActivationEvent(b),this.h(b,M,!1);{let F=!1;const q=(0,O.$Zm)(M,function(W){if(W instanceof C.$_J)return I.Position.from(W);if(W instanceof C.$aK)return I.Range.from(W);if(W instanceof C.$kK)return I.location.from(W);if(C.$vL.isNotebookRange(W))return I.NotebookRange.from(W);if(W instanceof ArrayBuffer)return F=!0,s.$_d.wrap(new Uint8Array(W));if(W instanceof Uint8Array)return F=!0,s.$_d.wrap(W);if(W instanceof s.$_d)return F=!0,W;if(!Array.isArray(W))return W});try{const W=await Ne(this,r,"f").$executeCommand(b,F?new c.$iv(q):q,U);return(0,d.$ih)(W)}catch(W){if(W instanceof Error&&W.message==="$executeCommand:retry")return this.g(b,M,!1);throw W}}}async h(b,M,U){const F=this.b.get(b);if(!F)throw new Error("Unknown command");const{callback:q,thisArg:W,description:L}=F;if(L)for(let K=0;K<L.args.length;K++)try{(0,h.$Nf)(M[K],L.args[K].constraint)}catch{throw new Error(`Running the contributed command: '${b}' failed.Illegal argument '${L.args[K].name}' - ${L.args[K].description} `)}const z=S.$Hd.create();try{return await q.apply(W,M)}catch(K){if(b===this.converter.delegatingCommandId){const B=this.converter.getActualCommand(...M);B&&(b=B.command)}if(this.d.error(K,b,F.extension?.identifier),!U)throw K;if(F.extension?.identifier){const B=Ne(this,o,"f").onExtensionError(F.extension.identifier,K);this.d.trace("forwarded error to extension?",B,F.extension?.identifier)}throw new class extends Error{constructor(){super((0,v.$wi)(K)),this.id=b,this.source=F.extension?.displayName??F.extension?.name}}}finally{this.j(F,b,z.elapsed())}}j(b,M,U){b.extension&&Ne(this,i,"f").$publicLog2("Extension:ActionExecuted",{extensionId:b.extension.identifier.value,id:new p.$bo(M),duration:U})}$executeContributedCommand(b,...M){this.d.trace("ExtHostCommands#$executeContributedCommand",b);const U=this.b.get(b);return U?(M=M.map(F=>this.f.reduce((q,W)=>W.processArgument(q,U.extension?.identifier),F)),this.h(b,M,!0)):Promise.reject(new Error(`Contributed command '${b}' does not exist.`))}getCommands(b=!1){return this.d.trace("ExtHostCommands#getCommands",b),Ne(this,r,"f").$getCommands().then(M=>(b&&(M=M.filter(U=>U[0]!=="_")),M))}$getContributedCommandHandlerDescriptions(){const b=Object.create(null);for(const[M,U]of this.b){const{description:F}=U;F&&(b[M]=F)}return Promise.resolve(b)}};e.$sM=y,r=new WeakMap,i=new WeakMap,o=new WeakMap,e.$sM=y=Je([qe(0,f.$0L),qe(1,D.$6i),qe(2,n.$rM)],y),e.$tM=(0,m.$Lh)("IExtHostCommands");class g{constructor(b,M,U){this.d=b,this.f=M,this.g=U,this.delegatingCommandId=`__vsc${Date.now().toString(36)} `,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(b,M){if(!b)return;const U={$ident:void 0,id:b.command,title:b.title,tooltip:b.tooltip};if(!b.command)return U;const F=this.f(b.command);if(F)U.id=F.internalId,U.arguments=F.args.map((q,W)=>q.convert(b.arguments&&b.arguments[W]));else if((0,u.$Jb)(b.arguments)){const q=`${b.command} /${++this.c}`;this.b.set(q,b),M.add((0,w.$Oc)(()=>{this.b.delete(q),this.g.trace("CommandsConverter#DISPOSE",q)})),U.$ident=q,U.id=this.delegatingCommandId,U.arguments=[q],this.g.trace("CommandsConverter#CREATE",b.command,q)}return U}fromInternal(b){return typeof b.$ident=="string"?this.b.get(b.$ident):{command:b.id,title:b.title,arguments:b.arguments}}getActualCommand(...b){return this.b.get(b[0])}h(...b){const M=this.getActualCommand(...b);return this.g.trace("CommandsConverter#EXECUTE",b[0],M?M.command:"MISSING"),M?this.d.executeCommand(M.command,...M.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${b[0]}`)}}e.$uM=g;class E{static Arr(b){return new E(`${b.name}_array`,`Array of ${b.name}, ${b.description}`,M=>Array.isArray(M)&&M.every(U=>b.validate(U)),M=>M.map(U=>b.convert(U)))}constructor(b,M,U,F){this.name=b,this.description=M,this.validate=U,this.convert=F}optional(){return new E(this.name,`(optional) ${this.description}`,b=>b==null||this.validate(b),b=>b===void 0?void 0:b===null?null:this.convert(b))}with(b,M){return new E(b??this.name,M??this.description,this.validate,this.convert)}}e.$vM=E,E.Uri=new E("uri","Uri of a text document",$=>a.URI.isUri($),$=>$),E.Position=new E("position","A position in a text document",$=>C.$_J.isPosition($),I.Position.from),E.Range=new E("range","A range in a text document",$=>C.$aK.isRange($),I.Range.from),E.Selection=new E("selection","A selection in a text document",$=>C.$bK.isSelection($),I.Selection.from),E.Number=new E("number","",$=>typeof $=="number",$=>$),E.String=new E("string","",$=>typeof $=="string",$=>$),E.StringArray=E.Arr(E.String),E.CallHierarchyItem=new E("item","A call hierarchy item",$=>$ instanceof C.$uK,I.CallHierarchyItem.from),E.TypeHierarchyItem=new E("item","A type hierarchy item",$=>$ instanceof C.$OL,I.TypeHierarchyItem.from),E.TestItem=new E("testItem","A VS Code TestItem",$=>$ instanceof t.$kM,I.TestItem.from);class P{constructor(b,M){this.description=b,this.convert=M}}e.$wM=P,P.Void=new P("no result",$=>$);class l{constructor(b,M,U,F,q){this.id=b,this.internalId=M,this.description=U,this.args=F,this.result=q}}e.$xM=l}),define(Ae[225],Re([1,0,18,13,2,78,91,32,95,31,8,7]),function(ie,e,h,C,I,O,R,u,D,d,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gbc=void 0;const a=[new d.$xM("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[d.$vM.Uri,d.$vM.Position],new d.$wM("A promise that resolves to an array of DocumentHighlight-instances.",m(A.DocumentHighlight.to))),new d.$xM("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[d.$vM.Uri],new d.$wM("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(t,s)=>{if((0,h.$Ib)(t))return;class c extends k.$pK{static to(S){const p=new c(S.name,A.SymbolKind.to(S.kind),S.containerName||"",new k.$kK(s[0],A.Range.to(S.range)));return p.detail=S.detail,p.range=p.location.range,p.selectionRange=A.Range.to(S.selectionRange),p.children=S.children?S.children.map(c.to):[],p}}return t.map(c.to)})),new d.$xM("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[d.$vM.Uri,new d.$vM("options","Formatting options",t=>!0,t=>t)],new d.$wM("A promise that resolves to an array of TextEdits.",m(A.TextEdit.to))),new d.$xM("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[d.$vM.Uri,d.$vM.Range,new d.$vM("options","Formatting options",t=>!0,t=>t)],new d.$wM("A promise that resolves to an array of TextEdits.",m(A.TextEdit.to))),new d.$xM("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[d.$vM.Uri,d.$vM.Position,new d.$vM("ch","Trigger character",t=>typeof t=="string",t=>t),new d.$vM("options","Formatting options",t=>!0,t=>t)],new d.$wM("A promise that resolves to an array of TextEdits.",m(A.TextEdit.to))),new d.$xM("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[d.$vM.Uri,d.$vM.Position],new d.$wM("A promise that resolves to an array of Location or LocationLink instances.",f)),new d.$xM("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[d.$vM.Uri,d.$vM.Position],new d.$wM("A promise that resolves to an array of Location or LocationLink instances.",f)),new d.$xM("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[d.$vM.Uri,d.$vM.Position],new d.$wM("A promise that resolves to an array of Location or LocationLink instances.",f)),new d.$xM("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[d.$vM.Uri,d.$vM.Position],new d.$wM("A promise that resolves to an array of Location or LocationLink instances.",f)),new d.$xM("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[d.$vM.Uri,d.$vM.Position],new d.$wM("A promise that resolves to an array of Location-instances.",m(A.location.to))),new d.$xM("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[d.$vM.Uri,d.$vM.Position],new d.$wM("A promise that resolves to an array of Hover-instances.",m(A.Hover.to))),new d.$xM("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[d.$vM.Uri,new d.$vM("position","A position in a text document",t=>Array.isArray(t)&&t.every(s=>k.$_J.isPosition(s)),t=>t.map(A.Position.from))],new d.$wM("A promise that resolves to an array of ranges.",t=>t.map(s=>{let c;for(const v of s.reverse())c=new k.$tK(A.Range.to(v),c);return c}))),new d.$xM("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[d.$vM.String.with("query","Search string")],new d.$wM("A promise that resolves to an array of SymbolInformation-instances.",t=>t.map(A.WorkspaceSymbol.to))),new d.$xM("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[d.$vM.Uri,d.$vM.Position],new d.$wM("A promise that resolves to an array of CallHierarchyItem-instances",t=>t.map(A.CallHierarchyItem.to))),new d.$xM("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[d.$vM.CallHierarchyItem],new d.$wM("A promise that resolves to an array of CallHierarchyIncomingCall-instances",t=>t.map(A.CallHierarchyIncomingCall.to))),new d.$xM("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[d.$vM.CallHierarchyItem],new d.$wM("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",t=>t.map(A.CallHierarchyOutgoingCall.to))),new d.$xM("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[d.$vM.Uri,d.$vM.Position],new d.$wM("A promise that resolves to a range and placeholder text.",t=>{if(t)return{range:A.Range.to(t.range),placeholder:t.text}})),new d.$xM("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[d.$vM.Uri,d.$vM.Position,d.$vM.String.with("newName","The new symbol name")],new d.$wM("A promise that resolves to a WorkspaceEdit.",t=>{if(t){if(t.rejectReason)throw new Error(t.rejectReason);return A.WorkspaceEdit.to(t)}})),new d.$xM("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[d.$vM.Uri,d.$vM.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new d.$wM("A promise that resolves to an array of DocumentLink-instances.",t=>t.map(A.DocumentLink.to))),new d.$xM("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[d.$vM.Uri],new d.$wM("A promise that resolves to SemanticTokensLegend.",t=>{if(t)return new k.$nL(t.tokenTypes,t.tokenModifiers)})),new d.$xM("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[d.$vM.Uri],new d.$wM("A promise that resolves to SemanticTokens.",t=>{if(!t)return;const s=(0,R.$J0)(t);if(s.type==="full")return new k.$pL(s.data,void 0)})),new d.$xM("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[d.$vM.Uri,d.$vM.Range.optional()],new d.$wM("A promise that resolves to SemanticTokensLegend.",t=>{if(t)return new k.$nL(t.tokenTypes,t.tokenModifiers)})),new d.$xM("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[d.$vM.Uri,d.$vM.Range],new d.$wM("A promise that resolves to SemanticTokens.",t=>{if(!t)return;const s=(0,R.$J0)(t);if(s.type==="full")return new k.$pL(s.data,void 0)})),new d.$xM("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[d.$vM.Uri,d.$vM.Position,d.$vM.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),d.$vM.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new d.$wM("A promise that resolves to a CompletionList-instance.",(t,s,c)=>{if(!t)return new k.$FK([]);const v=t.suggestions.map(S=>A.CompletionItem.to(S,c));return new k.$FK(v,t.incomplete)})),new d.$xM("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[d.$vM.Uri,d.$vM.Position,d.$vM.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new d.$wM("A promise that resolves to SignatureHelp.",t=>{if(t)return A.SignatureHelp.to(t)})),new d.$xM("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[d.$vM.Uri,d.$vM.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new d.$wM("A promise that resolves to an array of CodeLens-instances.",(t,s,c)=>m(v=>new k.$xK(A.Range.to(v.range),v.command&&c.fromInternal(v.command)))(t))),new d.$xM("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[d.$vM.Uri,new d.$vM("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",t=>k.$aK.isRange(t),t=>k.$bK.isSelection(t)?A.Selection.from(t):A.Range.from(t)),d.$vM.String.with("kind","Code action kind to return code actions for").optional(),d.$vM.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new d.$wM("A promise that resolves to an array of Command-instances.",(t,s,c)=>m(v=>{if(v._isSynthetic){if(!v.command)throw new Error("Synthetic code actions must have a command");return c.fromInternal(v.command)}else{const S=new k.$rK(v.title,v.kind?new k.$sK(v.kind):void 0);return v.edit&&(S.edit=A.WorkspaceEdit.to(v.edit)),v.command&&(S.command=c.fromInternal(v.command)),S.isPreferred=v.isPreferred,S}})(t))),new d.$xM("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[d.$vM.Uri],new d.$wM("A promise that resolves to an array of ColorInformation objects.",t=>t?t.map(s=>new k.$LK(A.Range.to(s.range),A.Color.to(s.color))):[])),new d.$xM("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new d.$vM("color","The color to show and insert",t=>t instanceof k.$KK,A.Color.from),new d.$vM("context","Context object with uri and range",t=>!0,t=>({uri:t.uri,range:A.Range.from(t.range)}))],new d.$wM("A promise that resolves to an array of ColorPresentation objects.",t=>t?t.map(A.ColorPresentation.to):[])),new d.$xM("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[d.$vM.Uri,d.$vM.Range],new d.$wM("A promise that resolves to an array of Inlay objects",(t,s,c)=>t.map(A.InlayHint.to.bind(void 0,c)))),new d.$xM("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[d.$vM.Uri],new d.$wM("A promise that resolves to an array of FoldingRange objects",(t,s)=>{if(t)return t.map(A.FoldingRange.to)})),new d.$xM("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new d.$wM("A promise that resolves to an array of NotebookContentProvider static info objects.",m(t=>({viewType:t.viewType,displayName:t.displayName,options:{transientOutputs:t.options.transientOutputs,transientCellMetadata:t.options.transientCellMetadata,transientDocumentMetadata:t.options.transientDocumentMetadata},filenamePattern:t.filenamePattern.map(s=>A.NotebookExclusiveDocumentPattern.to(s))})))),new d.$xM("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[d.$vM.Uri,d.$vM.Range,new d.$vM("context","An InlineValueContext",t=>t&&typeof t.frameId=="number"&&t.stoppedLocation instanceof k.$aK,t=>A.InlineValueContext.from(t))],new d.$wM("A promise that resolves to an array of InlineValue objects",t=>t.map(A.InlineValue.to))),new d.$xM("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new d.$vM("uriOrString","Uri-instance or string (only http/https)",t=>I.URI.isUri(t)||typeof t=="string"&&(0,D.$3T)(t,C.Schemas.http,C.Schemas.https),t=>t),new d.$vM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="number"||typeof t=="object",t=>t&&(typeof t=="number"?[A.ViewColumn.from(t),void 0]:[A.ViewColumn.from(t.viewColumn),A.TextEditorOpenOptions.from(t)])).optional(),d.$vM.String.with("label","").optional()],d.$wM.Void),new d.$xM("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[d.$vM.Uri.with("resource","Resource to open"),d.$vM.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new d.$vM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="number"||typeof t=="object",t=>t&&(typeof t=="number"?[A.ViewColumn.from(t),void 0]:[A.ViewColumn.from(t.viewColumn),A.TextEditorOpenOptions.from(t)])).optional()],d.$wM.Void),new d.$xM("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[d.$vM.Uri.with("left","Left-hand side resource of the diff editor"),d.$vM.Uri.with("right","Right-hand side resource of the diff editor"),d.$vM.String.with("title","Human readable title for the diff editor").optional(),new d.$vM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="object",t=>t&&[A.ViewColumn.from(t.viewColumn),A.TextEditorOpenOptions.from(t)]).optional()],d.$wM.Void),new d.$xM("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[d.$vM.Uri,d.$vM.Position],new d.$wM("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(A.TypeHierarchyItem.to))),new d.$xM("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[d.$vM.TypeHierarchyItem],new d.$wM("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(A.TypeHierarchyItem.to))),new d.$xM("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[d.$vM.TypeHierarchyItem],new d.$wM("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(A.TypeHierarchyItem.to))),new d.$xM("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[d.$vM.TestItem],d.$wM.Void),new d.$xM("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[d.$vM.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],d.$wM.Void),new d.$xM("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[d.$vM.String.with("name","The context key name"),new d.$vM("value","The context key value",()=>!0,t=>t)],d.$wM.Void),new d.$xM("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[d.$vM.Uri,d.$vM.StringArray,new d.$vM("MappedEditsContext","Mapped Edits Context",t=>A.MappedEditsContext.is(t),t=>A.MappedEditsContext.from(t))],new d.$wM("A promise that resolves to a workspace edit or null",t=>t?A.WorkspaceEdit.to(t):null))];class w{static register(s){a.forEach(s.registerApiCommand,s),this.a(s)}static a(s){s.registerCommand(!1,"_validateWhenClauses",u.$Ki)}}e.$Gbc=w;function m(t){return s=>{if(Array.isArray(s))return s.map(t)}}function f(t){if(!Array.isArray(t))return;const s=[];for(const c of t)O.$0s(c)?s.push(A.DefinitionLink.to(c)):s.push(A.location.to(c));return s}}),define(Ae[226],Re([1,0,12,65,5,6,2,78,20,8,7,3,26]),function(ie,e,h,C,I,O,R,u,D,d,A,k,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ibc=void 0;function w(m,f,t){const s=m.getProxy(k.$9J.MainThreadComments);class c{constructor(){this.b=new Map,this.c=new D.$Zl,f.registerArgumentProcessor({processArgument:g=>{if(g&&g.$mid===6){const E=this.b.get(g.handle);return E?E.value:g}else if(g&&g.$mid===7){const E=this.b.get(g.commentControlHandle);if(!E)return g;const P=E.getCommentThread(g.commentThreadHandle);return P?P.value:g}else if(g&&(g.$mid===9||g.$mid===8)){const E=this.b.get(g.thread.commentControlHandle);if(!E)return g;const P=E.getCommentThread(g.thread.commentThreadHandle);return P?g.$mid===8?P.value:{thread:P.value,text:g.text}:g}else if(g&&g.$mid===10){const E=this.b.get(g.thread.commentControlHandle);if(!E)return g;const P=E.getCommentThread(g.thread.commentThreadHandle);if(!P)return g;const l=g.commentUniqueId,$=P.getCommentByUniqueId(l);return $||g}else if(g&&g.$mid===11){const E=this.b.get(g.thread.commentControlHandle);if(!E)return g;const P=E.getCommentThread(g.thread.commentThreadHandle);if(!P)return g;const l=g.text,$=g.commentUniqueId,b=P.getCommentByUniqueId($);return b?(typeof b.body=="string"?b.body=l:b.body=new A.$yK(l),b):g}return g}})}createCommentController(g,E,P){const l=c.a++,$=new S(g,l,E,P);this.b.set($.handle,$);const b=this.c.get(g.identifier)||[];return b.push($),this.c.set(g.identifier,b),$.value}$createCommentThreadTemplate(g,E,P){const l=this.b.get(g);l&&l.$createCommentThreadTemplate(E,P)}async $updateCommentThreadTemplate(g,E,P){const l=this.b.get(g);l&&l.$updateCommentThreadTemplate(E,P)}$deleteCommentThread(g,E){this.b.get(g)?.$deleteCommentThread(E)}$provideCommentingRanges(g,E,P){const l=this.b.get(g);if(!l||!l.commentingRangeProvider)return Promise.resolve(void 0);const $=t.getDocument(R.URI.revive(E));return(0,h.$Jg)(async()=>{const b=await l.commentingRangeProvider.provideCommentingRanges($,P);let M;return Array.isArray(b)?M={ranges:b,fileComments:!1}:b?M={ranges:b.ranges||[],fileComments:b.fileComments||!1}:M=b??void 0,M}).then(b=>{let M;return b&&(M={ranges:b.ranges.map(U=>d.Range.from(U)),fileComments:b.fileComments}),M})}$toggleReaction(g,E,P,l,$){const b=this.b.get(g);return!b||!b.reactionHandler?Promise.resolve(void 0):(0,h.$Jg)(()=>{const M=b.getCommentThread(E);if(M){const U=M.getCommentByUniqueId(l.uniqueIdInThread);if(b!==void 0&&U&&b.reactionHandler)return b.reactionHandler(U,r($))}return Promise.resolve(void 0)})}}c.a=0;class v{set threadId(g){this.n=g}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(g){(g===void 0!=(this.p===void 0)||!g||!this.p||!g.isEqual(this.p))&&(this.p=g,this.b.range=g,this.c.fire())}get range(){return this.p}set canReply(g){this.d!==g&&(this.d=g,this.b.canReply=g,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(g){this.e=g,this.b.label=g,this.c.fire()}get contextValue(){return this.f}set contextValue(g){this.f=g,this.b.contextValue=g,this.c.fire()}get comments(){return this.q}set comments(g){this.q=g,this.b.comments=g,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(g){this.g=g,this.b.collapsibleState=g,this.c.fire()}get state(){return this.h}set state(g){this.h=g,this.b.state=g,this.c.fire()}get isDisposed(){return this.j}constructor(g,E,P,l,$,b,M,U){this.m=E,this.n=P,this.o=l,this.p=$,this.q=b,this.extensionDescription=M,this.r=U,this.handle=v.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new I.$Ld,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new O.$Rc,this.l.value=new O.$Pc,this.n===void 0&&(this.n=`${g}.${this.handle}`),s.$createCommentThread(E,this.handle,this.n,this.o,d.Range.from(this.p),M.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=b,this.i.push({dispose:()=>{s.$deleteCommentThread(E,this.handle)}});const F=this;this.value={get uri(){return F.uri},get range(){return F.range},set range(q){F.range=q},get comments(){return F.comments},set comments(q){F.comments=q},get collapsibleState(){return F.collapsibleState},set collapsibleState(q){F.collapsibleState=q},get canReply(){return F.canReply},set canReply(q){F.canReply=q},get contextValue(){return F.contextValue},set contextValue(q){F.contextValue=q},get label(){return F.label},set label(q){F.label=q},get state(){return F.state},set state(q){F.state=q},dispose:()=>{F.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new O.$Pc);const g=P=>Object.prototype.hasOwnProperty.call(this.b,P),E={};g("range")&&(E.range=d.Range.from(this.p)),g("label")&&(E.label=this.label),g("contextValue")&&(E.contextValue=this.contextValue??null),g("comments")&&(E.comments=this.q.map(P=>p(this,P,this.k,this.extensionDescription))),g("collapsibleState")&&(E.collapseState=i(this.g)),g("canReply")&&(E.canReply=this.canReply),g("state")&&(E.state=o(this.h)),g("isTemplate")&&(E.isTemplate=this.r),this.b={},s.$updateCommentThread(this.m,this.handle,this.n,this.o,E)}getCommentByUniqueId(g){for(const E of this.k){const P=E[0],l=E[1];if(g===l)return P}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(g=>g.dispose())}}v.a=0,Je([(0,C.$eh)(100)],v.prototype,"eventuallyUpdateCommentThread",null);class S{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(g){this.b=g,s.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(g){this.c=g,s.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!g})}get options(){return this.d}set options(g){this.d=g,s.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(g,E,P,l){this.f=g,this.g=E,this.h=P,this.i=l,this.a=new Map,s.$registerCommentController(this.handle,P,l,this.f.identifier.value);const $=this;this.value=Object.freeze({id:$.id,label:$.label,get options(){return $.options},set options(b){$.options=b},get commentingRangeProvider(){return $.commentingRangeProvider},set commentingRangeProvider(b){$.commentingRangeProvider=b},get reactionHandler(){return $.reactionHandler},set reactionHandler(b){$.reactionHandler=b},createCommentThread(b,M,U){return $.createCommentThread(b,M,U).value},dispose:()=>{$.dispose()}}),this.e=[],this.e.push({dispose:()=>{s.$unregisterCommentController(this.handle)}})}createCommentThread(g,E,P){E===void 0&&(0,a.$8E)(this.f,"fileComments");const l=new v(this.id,this.handle,void 0,g,E,P,this.f,!1);return this.a.set(l.handle,l),l}$createCommentThreadTemplate(g,E){const P=new v(this.id,this.handle,void 0,R.URI.revive(g),d.Range.to(E),[],this.f,!0);return P.collapsibleState=u.CommentThreadCollapsibleState.Expanded,this.a.set(P.handle,P),P}$updateCommentThreadTemplate(g,E){const P=this.a.get(g);P&&(P.range=d.Range.to(E))}$deleteCommentThread(g){this.a.get(g)?.dispose(),this.a.delete(g)}getCommentThread(g){return this.a.get(g)}dispose(){this.a.forEach(g=>{g.dispose()}),this.e.forEach(g=>g.dispose())}}function p(y,g,E,P){let l=E.get(g);return l||(l=++y.commentHandle,E.set(g,l)),g.state!==void 0&&(0,a.$8E)(P,"commentsDraftState"),{mode:g.mode,contextValue:g.contextValue,uniqueIdInThread:l,body:typeof g.body=="string"?g.body:d.MarkdownString.from(g.body),userName:g.author.name,userIconPath:g.author.iconPath,label:g.label,commentReactions:g.reactions?g.reactions.map($=>n($)):void 0,state:g.state,timestamp:g.timestamp?.toJSON()}}function n(y){return{label:y.label,iconPath:y.iconPath?d.$9L(y.iconPath):void 0,count:y.count,hasReacted:y.authorHasReacted}}function r(y){return{label:y.label||"",count:y.count||0,iconPath:y.iconPath?R.URI.revive(y.iconPath):"",authorHasReacted:y.hasReacted||!1}}function i(y){if(y!==void 0)switch(y){case A.CommentThreadCollapsibleState.Expanded:return u.CommentThreadCollapsibleState.Expanded;case A.CommentThreadCollapsibleState.Collapsed:return u.CommentThreadCollapsibleState.Collapsed}return u.CommentThreadCollapsibleState.Collapsed}function o(y){if(y!==void 0)switch(y){case A.CommentThreadState.Unresolved:return u.CommentThreadState.Unresolved;case A.CommentThreadState.Resolved:return u.CommentThreadState.Resolved}return u.CommentThreadState.Unresolved}return new c}e.$Ibc=w}),define(Ae[227],Re([1,0,24,3,27,17]),function(ie,e,h,C,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fdc=void 0;let R=class{constructor(A,k){this.a=A.getProxy(C.$9J.MainThreadConsole),this.b=k.consoleForward.includeStack,this.c=k.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(A,k){const a=this,w=console[A];Object.defineProperty(console,A,{set:()=>{},get:()=>function(){a.e(A,k,w,arguments)}})}e(A,k,a,w){this.a.$logExtensionHostMessage({type:"__$console",severity:k,arguments:D(w,this.b)}),this.c&&this.f(A,a,w)}};e.$Fdc=R,e.$Fdc=R=Je([qe(0,O.$0L),qe(1,I.$nM)],R);const u=1e5;function D(d,A){const k=[];if(d.length)for(let a=0;a<d.length;a++){let w=d[a];if(typeof w>"u")w="undefined";else if(w instanceof Error){const m=w;m.stack?w=m.stack:w=m.toString()}k.push(w)}if(A){const a=new Error().stack;a&&k.push({__$stack:a.split(`
`).slice(3).join(`
`)})}try{const a=(0,h.$3m)(k);return a.length>u?"Output omitted for a large object that exceeds the limits":a}catch(a){return`Output omitted for an object that cannot be inspected ('${a.toString()}')`}}}),define(Ae[107],Re([1,0,2,3,7,4,17,14,18,15,19,26]),function(ie,e,h,C,I,O,R,u,D,d,A,k){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.$Kcc=e.$Jcc=void 0;let w=a=class{constructor(f,t){this.h=t,this.f=new Map,this.g=f.getProxy(C.$9J.MainThreadDecorations)}registerFileDecorationProvider(f,t){const s=a.c++;this.f.set(s,{provider:f,extensionDescription:t}),this.g.$registerDecorationProvider(s,t.identifier.value);const c=f.onDidChangeFileDecorations&&f.onDidChangeFileDecorations(v=>{if(!v){this.g.$onDidChange(s,null);return}const S=(0,D.$1b)(v);if(S.length<=a.d){this.g.$onDidChange(s,S);return}this.h.warn("[Decorations] CAPPING events from decorations provider",t.identifier.value,S.length);const p=S.map(i=>({uri:i,rank:(0,d.$Ee)(i.path,"/")})),n=(0,D.$xb)(p,(i,o)=>i.rank-o.rank||(0,d.$Se)(i.uri.path,o.uri.path)),r=[];e:for(const i of n){let o;for(const y of i){const g=(0,A.$kc)(y.uri.path);if(o!==g&&(o=g,r.push(y.uri)>=a.d))break e}}this.g.$onDidChange(s,r)});return new I.$$J(()=>{c?.dispose(),this.g.$unregisterDecorationProvider(s),this.f.delete(s)})}async $provideDecorations(f,t,s){if(!this.f.has(f))return Object.create(null);const c=Object.create(null),{provider:v,extensionDescription:S}=this.f.get(f);return await Promise.all(t.map(async p=>{try{const{uri:n,id:r}=p,i=await Promise.resolve(v.provideFileDecoration(h.URI.revive(n),s));if(!i)return;try{I.$tL.validate(i),i.badge&&typeof i.badge!="string"&&(0,k.$8E)(S,"codiconDecoration"),c[r]=[i.propagate,i.tooltip,i.badge,i.color]}catch(o){this.h.warn(`INVALID decoration from extension '${S.identifier.value}': ${o}`)}}catch(n){this.h.error(n)}})),c}};e.$Jcc=w,w.c=0,w.d=250,e.$Jcc=w=a=Je([qe(0,R.$0L),qe(1,u.$6i)],w),e.$Kcc=(0,O.$Lh)("IExtHostDecorations")});var Ye=this&&this.__classPrivateFieldSet||function(ie,e,h,C,I){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!I:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?I.call(ie,h):I?I.value=h:e.set(ie,h),h},Ne=this&&this.__classPrivateFieldGet||function(ie,e,h,C){if(h==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!C:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?C:h==="a"?C.call(ie):C?C.value:e.get(ie)};define(Ae[228],Re([1,0,147,94,2,3,7,8,5,14,28,39]),function(ie,e,h,C,I,O,R,u,D,d,A,k){"use strict";var a,w,m,f;Object.defineProperty(e,"__esModule",{value:!0}),e.$Bbc=e.$Abc=void 0;class t{constructor(v,S,p,n,r,i,o,y){this.d=v,this.e=S,this.f=p,this.g=n,this.h=r,a.set(this,void 0),w.set(this,void 0),m.set(this,void 0),this.c=!1,this.f=Math.max(n,p),Ye(this,m,new A.$yc(g=>i.getComparisonKey(g)),"f"),Ye(this,a,o,"f"),Ye(this,w,y,"f")}dispose(){this.c||(Ne(this,w,"f").fire([...Ne(this,m,"f").keys()]),Ne(this,a,"f")?.$clear(this.e),Ne(this,m,"f").clear(),this.c=!0)}get name(){return this.j(),this.d}set(v,S){if(!v){this.clear();return}this.j();let p=[];if(I.URI.isUri(v)){if(!S){this.delete(v);return}Ne(this,m,"f").set(v,S.slice()),p=[v]}else if(Array.isArray(v)){p=[];let i;v=[...v].sort(t.k);for(const o of v){const[y,g]=o;if((!i||y.toString()!==i.toString())&&(i&&Ne(this,m,"f").get(i).length===0&&Ne(this,m,"f").delete(i),i=y,p.push(y),Ne(this,m,"f").set(y,[])),g)Ne(this,m,"f").get(y)?.push(...g);else{const E=Ne(this,m,"f").get(y);E&&(E.length=0)}}}if(Ne(this,w,"f").fire(p),!Ne(this,a,"f"))return;const n=[];let r=0;for(const i of p){let o=[];const y=Ne(this,m,"f").get(i);if(y)if(y.length>this.g){o=[];const g=[R.DiagnosticSeverity.Error,R.DiagnosticSeverity.Warning,R.DiagnosticSeverity.Information,R.DiagnosticSeverity.Hint];e:for(let E=0;E<4;E++)for(const P of y)if(P.severity===g[E]&&o.push({...u.Diagnostic.from(P),modelVersionId:this.h(i)})===this.g)break e;o.push({severity:C.MarkerSeverity.Info,message:(0,h.localize)(0,null,y.length-this.g),startLineNumber:o[o.length-1].startLineNumber,startColumn:o[o.length-1].startColumn,endLineNumber:o[o.length-1].endLineNumber,endColumn:o[o.length-1].endColumn})}else o=y.map(g=>({...u.Diagnostic.from(g),modelVersionId:this.h(i)}));if(n.push([i,o]),r+=o.length,r>this.f)break}Ne(this,a,"f").$changeMany(this.e,n)}delete(v){this.j(),Ne(this,w,"f").fire([v]),Ne(this,m,"f").delete(v),Ne(this,a,"f")?.$changeMany(this.e,[[v,void 0]])}clear(){this.j(),Ne(this,w,"f").fire([...Ne(this,m,"f").keys()]),Ne(this,m,"f").clear(),Ne(this,a,"f")?.$clear(this.e)}forEach(v,S){this.j();for(const[p,n]of this)v.call(S,p,n,this)}*[(a=new WeakMap,w=new WeakMap,m=new WeakMap,Symbol.iterator)](){this.j();for(const v of Ne(this,m,"f").keys())yield[v,this.get(v)]}get(v){this.j();const S=Ne(this,m,"f").get(v);return Array.isArray(S)?Object.freeze(S.slice(0)):[]}has(v){return this.j(),Array.isArray(Ne(this,m,"f").get(v))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(v,S){return v[0].toString()<S[0].toString()?-1:v[0].toString()>S[0].toString()?1:0}}e.$Abc=t;let s=f=class{static _mapper(v){const S=new A.$yc;for(const p of v)S.set(p,p);return{uris:Object.freeze(Array.from(S.values()))}}constructor(v,S,p,n){this.j=S,this.k=p,this.l=n,this.g=new Map,this.h=new D.$Pd({merge:r=>r.flat(),delay:50}),this.onDidChangeDiagnostics=D.Event.map(this.h.event,f._mapper),this.f=v.getProxy(O.$9J.MainThreadDiagnostics)}createDiagnosticCollection(v,S){const{g:p,f:n,h:r,j:i,k:o,l:y}=this,g=new class{$changeMany(l,$){n.$changeMany(l,$),i.trace("[DiagnosticCollection] change many (extension, owner, uris)",v.value,l,$.length===0?"CLEARING":$)}$clear(l){n.$clear(l),i.trace("[DiagnosticCollection] remove all (extension, owner)",v.value,l)}dispose(){n.dispose()}};let E;if(!S)S="_generated_diagnostic_collection_name_#"+f.c++,E=S;else if(!p.has(S))E=S;else{this.j.warn(`DiagnosticCollection with name '${S}' does already exist.`);do E=S+f.c++;while(p.has(E))}return new class extends t{constructor(){super(S,E,f.e,f.d,l=>y.getDocument(l)?.version,o.extUri,g,r),p.set(E,this)}dispose(){super.dispose(),p.delete(E)}}}getDiagnostics(v){if(v)return this.m(v);{const S=new Map,p=[];for(const n of this.g.values())n.forEach((r,i)=>{let o=S.get(r.toString());typeof o>"u"&&(o=p.length,S.set(r.toString(),o),p.push([r,[]])),p[o][1]=p[o][1].concat(...i)});return p}}m(v){let S=[];for(const p of this.g.values())p.has(v)&&(S=S.concat(p.get(v)));return S}$acceptMarkersChange(v){if(!this.n){const S="_generated_mirror",p=new t(S,S,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,n=>{},this.k.extUri,void 0,this.h);this.g.set(S,p),this.n=p}for(const[S,p]of v)this.n.set(I.URI.revive(S),p.map(u.Diagnostic.to))}};e.$Bbc=s,s.c=0,s.d=1e3,s.e=1.1*f.d,e.$Bbc=s=f=Je([qe(1,d.$6i),qe(2,k.$zbc)],s)}),define(Ae[229],Re([1,0,2,3,26]),function(ie,e,h,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qbc=void 0;class O{constructor(u){this.a=u.getProxy(C.$9J.MainThreadDialogs)}showOpenDialog(u,D){return D?.allowUIResources&&(0,I.$8E)(u,"showLocal"),this.a.$showOpenDialog(D).then(d=>d?d.map(A=>h.URI.revive(A)):void 0)}showSaveDialog(u){return this.a.$showSaveDialog(u).then(D=>D?h.URI.revive(D):void 0)}}e.$Qbc=O}),define(Ae[230],Re([1,0,9,2,7,3,13,21,15]),function(ie,e,h,C,I,O,R,u,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rbc=void 0;class d{constructor(k,a,w){this.d=a,this.e=w,this.b=new Map,this.c=k.getProxy(O.$9J.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(k,a){if(Object.keys(R.Schemas).indexOf(k)>=0)throw new Error(`scheme '${k}' already registered`);const w=d.a++;this.b.set(w,a),this.c.$registerTextContentProvider(w,k);let m;return typeof a.onDidChange=="function"&&(m=a.onDidChange(f=>{if(f.scheme!==k){this.e.warn(`Provider for scheme '${k}' is firing event for schema '${f.scheme}' which will be IGNORED`);return}this.d.getDocument(f)&&this.$provideTextDocumentContent(w,f).then(t=>{if(!t&&typeof t!="string")return;const s=this.d.getDocument(f);if(!s)return;const c=(0,D.$Ne)(t);if(!s.equalLines(c))return this.c.$onVirtualDocumentChange(f,t)},h.$Y)})),new I.$$J(()=>{this.b.delete(w)&&this.c.$unregisterTextContentProvider(w),m&&(m.dispose(),m=void 0)})}$provideTextDocumentContent(k,a){const w=this.b.get(k);return w?Promise.resolve(w.provideTextDocumentContent(C.URI.revive(a),u.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${a.scheme}`))}}e.$Rbc=d,d.a=0}),define(Ae[231],Re([1,0,5,6,2,3,100,8,16,24,7,9]),function(ie,e,h,C,I,O,R,u,D,d,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xbc=void 0;class a{constructor(m,f){this.a=new h.$Ld({onListenerError:k.$Z}),this.b=new h.$Ld({onListenerError:k.$Z}),this.c=new h.$Ld({onListenerError:k.$Z}),this.d=new h.$Ld({onListenerError:k.$Z}),this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new C.$Pc,this.h=new Map,this.f=m.getProxy(O.$9J.MainThreadDocuments),this.g=f,this.g.onDidRemoveDocuments(t=>{for(const s of t)this.b.fire(s.document)},void 0,this.e),this.g.onDidAddDocuments(t=>{for(const s of t)this.a.fire(s.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(m){if(!m)return;const f=this.g.getDocument(m);if(f)return f}getDocument(m){const f=this.getDocumentData(m);if(!f?.document)throw new Error(`Unable to retrieve document from URI '${m}'`);return f.document}ensureDocumentData(m){const f=this.g.getDocument(m);if(f)return Promise.resolve(f);let t=this.h.get(m.toString());return t||(t=this.f.$tryOpenDocument(m).then(s=>{this.h.delete(m.toString());const c=I.URI.revive(s);return(0,D.$Hf)(this.g.getDocument(c))},s=>(this.h.delete(m.toString()),Promise.reject(s))),this.h.set(m.toString(),t)),t}createDocumentData(m){return this.f.$tryCreateDocument(m).then(f=>I.URI.revive(f))}$acceptModelLanguageChanged(m,f){const t=I.URI.revive(m),s=this.g.getDocument(t);if(!s)throw new Error("unknown document");this.b.fire(s.document),s._acceptLanguageId(f),this.a.fire(s.document)}$acceptModelSaved(m){const f=I.URI.revive(m),t=this.g.getDocument(f);if(!t)throw new Error("unknown document");this.$acceptDirtyStateChanged(m,!1),this.d.fire(t.document)}$acceptDirtyStateChanged(m,f){const t=I.URI.revive(m),s=this.g.getDocument(t);if(!s)throw new Error("unknown document");s._acceptIsDirty(f),this.c.fire({document:s.document,contentChanges:[],reason:void 0})}$acceptModelChanged(m,f,t){const s=I.URI.revive(m),c=this.g.getDocument(s);if(!c)throw new Error("unknown document");c._acceptIsDirty(t),c.onEvents(f);let v;f.isUndoing?v=A.TextDocumentChangeReason.Undo:f.isRedoing&&(v=A.TextDocumentChangeReason.Redo),this.c.fire((0,d.$Ym)({document:c.document,contentChanges:f.changes.map(S=>({range:u.Range.to(S.range),rangeOffset:S.rangeOffset,rangeLength:S.rangeLength,text:S.text})),reason:v}))}setWordDefinitionFor(m,f){(0,R.$_L)(m,f)}}e.$xbc=a}),define(Ae[60],Re([1,0,51,5,6,2,4,3,100,17,105,8,14,28,13,69,66]),function(ie,e,h,C,I,O,R,u,D,d,A,k,a,w,m,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iM=e.$hM=void 0;class s{constructor(S){this.value=S,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let c=class{constructor(S,p){this.h=S,this.i=p,this.a=null,this.b=new Map,this.c=new w.$yc,this.d=new C.$Ld,this.e=new C.$Ld,this.f=new C.$Ld,this.g=new C.$Ld,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(S){this.acceptDocumentsAndEditorsDelta(S)}acceptDocumentsAndEditorsDelta(S){const p=[],n=[],r=[];if(S.removedDocuments)for(const i of S.removedDocuments){const o=O.URI.revive(i),y=this.c.get(o);y?.unref()&&(this.c.delete(o),p.push(y.value))}if(S.addedDocuments)for(const i of S.addedDocuments){const o=O.URI.revive(i.uri);let y=this.c.get(o);if(y&&o.scheme!==m.Schemas.vscodeNotebookCell&&o.scheme!==m.Schemas.vscodeInteractiveInput)throw new Error(`document '${o} already exists!'`);y||(y=new s(new D.$aM(this.h.getProxy(u.$9J.MainThreadDocuments),o,i.lines,i.EOL,i.versionId,i.languageId,i.isDirty,i.notebook)),this.c.set(o,y),n.push(y.value)),y.ref()}if(S.removedEditors)for(const i of S.removedEditors){const o=this.b.get(i);this.b.delete(i),o&&r.push(o)}if(S.addedEditors)for(const i of S.addedEditors){const o=O.URI.revive(i.documentUri);h.ok(this.c.has(o),`document '${o}' does not exist`),h.ok(!this.b.has(i.id),`editor '${i.id}' already exists!`);const y=this.c.get(o).value,g=new A.$gM(i.id,this.h.getProxy(u.$9J.MainThreadTextEditors),this.i,new t.$T(()=>y.document),i.selections.map(k.Selection.to),i.options,i.visibleRanges.map(E=>k.Range.to(E)),typeof i.editorPosition=="number"?k.ViewColumn.to(i.editorPosition):void 0);this.b.set(i.id,g)}S.newActiveEditor!==void 0&&(h.ok(S.newActiveEditor===null||this.b.has(S.newActiveEditor),`active editor '${S.newActiveEditor}' does not exist`),this.a=S.newActiveEditor),(0,I.$Lc)(p),(0,I.$Lc)(r),S.removedDocuments&&this.e.fire(p),S.addedDocuments&&this.d.fire(n),(S.removedEditors||S.addedEditors)&&this.f.fire(this.allEditors().map(i=>i.value)),S.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(S){return this.c.get(S)?.value}allDocuments(){return f.Iterable.map(this.c.values(),S=>S.value)}getEditor(S){return this.b.get(S)}activeEditor(S){if(!this.a)return;const p=this.b.get(this.a);return S?p:p?.value}allEditors(){return[...this.b.values()]}};e.$hM=c,e.$hM=c=Je([qe(0,d.$0L),qe(1,a.$6i)],c),e.$iM=(0,R.$Lh)("IExtHostDocumentsAndEditors")}),define(Ae[61],Re([1,0,8,3,2,5,4,7,17,16,232]),function(ie,e,h,C,I,O,R,u,D,d,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pcc=e.$Occ=void 0,e.$Occ=(0,R.$Lh)("IExtHostEditorTabs");class k{constructor(t,s,c){this.e=c,this.d=s,this.acceptDtoUpdate(t)}get apiObject(){if(!this.a){const t=this,s={get isActive(){return t.b.id===t.e()},get label(){return t.b.label},get input(){return t.c},get isDirty(){return t.b.isDirty},get isPinned(){return t.b.isPinned},get isPreview(){return t.b.isPreview},get group(){return t.d.apiObject}};this.a=Object.freeze(s)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(t){this.b=t,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new u.$PL(I.URI.revive(this.b.input.uri));case 2:return new u.$QL(I.URI.revive(this.b.input.original),I.URI.revive(this.b.input.modified));case 3:return new u.$RL(I.URI.revive(this.b.input.base),I.URI.revive(this.b.input.input1),I.URI.revive(this.b.input.input2),I.URI.revive(this.b.input.result));case 6:return new u.$SL(I.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new u.$TL(this.b.input.viewType);case 4:return new u.$UL(I.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new u.$VL(I.URI.revive(this.b.input.original),I.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new u.$WL;case 9:return new u.$XL(I.URI.revive(this.b.input.uri),I.URI.revive(this.b.input.inputBoxUri));default:return}}}class a{constructor(t,s){this.c=[],this.d="",this.b=t,this.e=s;for(const c of t.tabs)c.isActive&&(this.d=c.id),this.c.push(new k(c,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const t=this,s={get isActive(){return t.b.groupId===t.e()},get viewColumn(){return h.ViewColumn.to(t.b.viewColumn)},get activeTab(){return t.c.find(c=>c.tabId===t.d)?.apiObject},get tabs(){return Object.freeze(t.c.map(c=>c.apiObject))}};this.a=Object.freeze(s)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(t){this.b=t}acceptTabOperation(t){if(t.kind===0){const c=new k(t.tabDto,this,()=>this.activeTabId());return this.c.splice(t.index,0,c),t.tabDto.isActive&&(this.d=c.tabId),c}else if(t.kind===1){const c=this.c.splice(t.index,1)[0];if(!c)throw new Error(`Tab close updated received for index ${t.index} which does not exist`);return c.tabId===this.d&&(this.d=""),c}else if(t.kind===3){if(t.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const c=this.c.splice(t.oldIndex,1)[0];if(!c)throw new Error(`Tab move updated received for index ${t.oldIndex} which does not exist`);return this.c.splice(t.index,0,c),c}const s=this.c.find(c=>c.tabId===t.tabDto.id);if(!s)throw new Error("INVALID tab");return t.tabDto.isActive?this.d=t.tabDto.id:this.d===t.tabDto.id&&!t.tabDto.isActive&&(this.d=""),s.acceptDtoUpdate(t.tabDto),s}activeTabId(){return this.d}}let w=class{constructor(t){this.b=new O.$Ld,this.c=new O.$Ld,this.e=[],this.a=t.getProxy(C.$9J.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const t=this,s={onDidChangeTabGroups:t.c.event,onDidChangeTabs:t.b.event,get all(){return Object.freeze(t.e.map(c=>c.apiObject))},get activeTabGroup(){const c=t.d;return(0,d.$Hf)(t.e.find(S=>S.groupId===c)?.apiObject)},close:async(c,v)=>{const S=Array.isArray(c)?c:[c];return S.length?m(S[0])?this.j(S,v):this.i(S,v):!0}};this.f=Object.freeze(s)}return this.f}$acceptEditorTabModel(t){const s=new Set(this.e.map(i=>i.groupId)),c=new Set(t.map(i=>i.groupId)),v=(0,A.$E)(s,c),S=this.e.filter(i=>v.removed.includes(i.groupId)).map(i=>i.apiObject),p=[],n=[];this.e=t.map(i=>{const o=new a(i,()=>this.d);return v.added.includes(o.groupId)?p.push(o.apiObject):n.push(o.apiObject),o});const r=(0,d.$Hf)(t.find(i=>i.isActive===!0)?.groupId);r!==void 0&&this.d!==r&&(this.d=r),this.c.fire(Object.freeze({opened:p,closed:S,changed:n}))}$acceptTabGroupUpdate(t){const s=this.e.find(c=>c.groupId===t.groupId);if(!s)throw new Error("Update Group IPC call received before group creation.");s.acceptGroupDtoUpdate(t),t.isActive&&(this.d=t.groupId),this.c.fire(Object.freeze({changed:[s.apiObject],opened:[],closed:[]}))}$acceptTabOperation(t){const s=this.e.find(v=>v.groupId===t.groupId);if(!s)throw new Error("Update Tabs IPC call received before group creation.");const c=s.acceptTabOperation(t);switch(t.kind){case 0:this.b.fire(Object.freeze({opened:[c.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[c.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[c.apiObject]}));return}}g(t){for(const s of this.e)for(const c of s.tabs)if(c.apiObject===t)return c}h(t){return this.e.find(s=>s.apiObject===t)}async i(t,s){const c=[];for(const v of t){const S=this.g(v);if(!S)throw new Error("Tab close: Invalid tab not found!");c.push(S.tabId)}return this.a.$closeTab(c,s)}async j(t,s){const c=[];for(const v of t){const S=this.h(v);if(!S)throw new Error("Group close: Invalid group not found!");c.push(S.groupId)}return this.a.$closeGroup(c,s)}};e.$Pcc=w,e.$Pcc=w=Je([qe(0,D.$0L)],w);function m(f){return f.tabs!==void 0}}),define(Ae[233],Re([1,0,3,7]),function(ie,e,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bdc=void 0;class I{constructor(R){this.a=new Map,this.b=0,this.c=R.getProxy(h.$9J.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(R,u,D){if(this.a.size===0)throw new Error("No embedding vector providers registered");const d=this.a.get(R);if(!d)throw new Error("Embedding vector provider not found");const A=await d.provideEmbeddingVector(u,D);if(!A)throw new Error("Embedding vector provider returned undefined");return A}registerEmbeddingVectorProvider(R,u,D){const d=this.b;return this.b++,this.a.set(d,D),this.c.$registerAiEmbeddingVectorProvider(u,d),new C.$$J(()=>{this.c.$unregisterAiEmbeddingVectorProvider(d),this.a.delete(d)})}}e.$Bdc=I}),define(Ae[234],Re([1,0,2,3,6,7,8,280,15,25,26,49]),function(ie,e,h,C,I,O,R,u,D,d,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lcc=void 0;class a{constructor(){this.a=[]}add(f){this.b=void 0,this.a.push(f)}delete(f){const t=this.a.indexOf(f);t>=0&&(this.a.splice(t,1),this.b=void 0)}c(){if(!this.b){const f=this.a.sort(),t=[];let s,c,v=14,S=14;for(const p of f){let n=s?(0,D.$2e)(s,p):0;for(n===0?c=1:c=S;n<p.length;n++)n+1===p.length?(v=S,S=9):S+=1,t.push([c,p.toUpperCase().charCodeAt(n),S]),t.push([c,p.toLowerCase().charCodeAt(n),S]),c=S;s=p,S=v}t.push([9,58,10]),t.push([10,47,12]),this.b=new u.$LY(t)}}provideDocumentLinks(f){this.c();const t=[],s=u.$MY.computeLinks({getLineContent(c){return f.lineAt(c-1).text},getLineCount(){return f.lineCount}},this.b);for(const c of s){const v=R.DocumentLink.to(c);v.target&&t.push(v)}return t}}class w{constructor(f,t){this.i=t,this.b=new a,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=f.getProxy(C.$9J.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(f,t,s,c={}){if(w.j(s),this.d.has(t))throw new Error(`a provider for the scheme '${t}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(f,"*",this.b));const v=this.h++;this.b.add(t),this.d.add(t),this.c.set(v,s);let S=2;c.isCaseSensitive&&(S+=1024),c.isReadonly&&(S+=2048),typeof s.copy=="function"&&(S+=8),typeof s.open=="function"&&typeof s.close=="function"&&typeof s.read=="function"&&typeof s.write=="function"&&((0,A.$8E)(f,"fsChunks"),S+=4);let p;c.isReadonly&&(0,k.$1j)(c.isReadonly)&&((0,A.$8E)(f,"readonlyMessage"),p={value:c.isReadonly.value,isTrusted:c.isReadonly.isTrusted,supportThemeIcons:c.isReadonly.supportThemeIcons,supportHtml:c.isReadonly.supportHtml,baseUri:c.isReadonly.baseUri,uris:c.isReadonly.uris}),this.a.$registerFileSystemProvider(v,t,S,p).catch(r=>{console.error(`FAILED to register filesystem provider of ${f.identifier.value}-extension for the scheme ${t}`),console.error(r)});const n=s.onDidChangeFile(r=>{const i=[];for(const o of r){const{uri:y,type:g}=o;if(y.scheme!==t)continue;let E;switch(g){case O.FileChangeType.Changed:E=0;break;case O.FileChangeType.Created:E=1;break;case O.FileChangeType.Deleted:E=2;break;default:throw new Error("Unknown FileChangeType")}i.push({resource:y,type:E})}this.a.$onFileSystemChange(v,i)});return(0,I.$Oc)(()=>{n.dispose(),this.b.delete(t),this.d.delete(t),this.c.delete(v),this.a.$unregisterProvider(v)})}static j(f){if(!f)throw new Error("MISSING provider");if(typeof f.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof f.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof f.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof f.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof f.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof f.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof f.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof f.rename!="function")throw new Error("Provider does NOT implement rename")}static k(f){const{type:t,ctime:s,mtime:c,size:v,permissions:S}=f;return{type:t,ctime:s,mtime:c,size:v,permissions:S}}$stat(f,t){return Promise.resolve(this.l(f).stat(h.URI.revive(t))).then(s=>w.k(s))}$readdir(f,t){return Promise.resolve(this.l(f).readDirectory(h.URI.revive(t)))}$readFile(f,t){return Promise.resolve(this.l(f).readFile(h.URI.revive(t))).then(s=>d.$_d.wrap(s))}$writeFile(f,t,s,c){return Promise.resolve(this.l(f).writeFile(h.URI.revive(t),s.buffer,c))}$delete(f,t,s){return Promise.resolve(this.l(f).delete(h.URI.revive(t),s))}$rename(f,t,s,c){return Promise.resolve(this.l(f).rename(h.URI.revive(t),h.URI.revive(s),c))}$copy(f,t,s,c){const v=this.l(f);if(!v.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(v.copy(h.URI.revive(t),h.URI.revive(s),c))}$mkdir(f,t){return Promise.resolve(this.l(f).createDirectory(h.URI.revive(t)))}$watch(f,t,s,c){const v=this.l(f).watch(h.URI.revive(s),c);this.f.set(t,v)}$unwatch(f,t){const s=this.f.get(t);s&&(s.dispose(),this.f.delete(t))}$open(f,t,s){const c=this.l(f);if(!c.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(c.open(h.URI.revive(t),s))}$close(f,t){const s=this.l(f);if(!s.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(s.close(t))}$read(f,t,s,c){const v=this.l(f);if(!v.read)throw new Error('FileSystemProvider does not implement "read"');const S=d.$_d.alloc(c);return Promise.resolve(v.read(t,s,S.buffer,0,c)).then(p=>S.slice(0,p))}$write(f,t,s,c){const v=this.l(f);if(!v.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(v.write(t,s,c.buffer,0,c.byteLength))}l(f){const t=this.c.get(f);if(!t){const s=new Error;throw s.name="ENOPRO",s.message="no provider",s}return t}}e.$lcc=w}),define(Ae[62],Re([1,0,3,38,7,25,4,17,39,6,12,23,13]),function(ie,e,h,C,I,O,R,u,D,d,A,k,a){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.$5bc=e.$4bc=void 0;let m=w=class{constructor(t,s){this.b=new Map,this.c=new A.$Zg,this.a=t.getProxy(h.$9J.MainThreadFileSystem);const c=this;this.value=Object.freeze({async stat(v){try{let S;const p=c.b.get(v.scheme);return p?(await c.a.$ensureActivation(v.scheme),S=await p.impl.stat(v)):S=await c.a.$stat(v),{type:S.type,ctime:S.ctime,mtime:S.mtime,size:S.size,permissions:S.permissions===C.FilePermission.Readonly?1:void 0}}catch(S){w.e(S)}},async readDirectory(v){try{const S=c.b.get(v.scheme);return S?(await c.a.$ensureActivation(v.scheme),(await S.impl.readDirectory(v)).slice()):await c.a.$readdir(v)}catch(S){return w.e(S)}},async createDirectory(v){try{const S=c.b.get(v.scheme);return S&&!S.isReadonly?(await c.a.$ensureActivation(v.scheme),await c.d(S.impl,S.extUri,v)):await c.a.$mkdir(v)}catch(S){return w.e(S)}},async readFile(v){try{const S=c.b.get(v.scheme);return S?(await c.a.$ensureActivation(v.scheme),(await S.impl.readFile(v)).slice()):(await c.a.$readFile(v)).buffer}catch(S){return w.e(S)}},async writeFile(v,S){try{const p=c.b.get(v.scheme);return p&&!p.isReadonly?(await c.a.$ensureActivation(v.scheme),await c.d(p.impl,p.extUri,p.extUri.dirname(v)),await c.c.queueFor(v).queue(()=>Promise.resolve(p.impl.writeFile(v,S,{create:!0,overwrite:!0})))):await c.a.$writeFile(v,O.$_d.wrap(S))}catch(p){return w.e(p)}},async delete(v,S){try{const p=c.b.get(v.scheme);return p&&!p.isReadonly?(await c.a.$ensureActivation(v.scheme),await p.impl.delete(v,{recursive:!1,...S})):await c.a.$delete(v,{recursive:!1,useTrash:!1,atomic:!1,...S})}catch(p){return w.e(p)}},async rename(v,S,p){try{return await c.a.$rename(v,S,{overwrite:!1,...p})}catch(n){return w.e(n)}},async copy(v,S,p){try{return await c.a.$copy(v,S,{overwrite:!1,...p})}catch(n){return w.e(n)}},isWritableFileSystem(v){const S=s.getCapabilities(v);if(typeof S=="number")return!(S&2048)}})}async d(t,s,c){const v=[];for(;!s.isEqual(c,s.dirname(c));)try{if(!((await t.stat(c)).type&C.FileType.Directory))throw I.$lL.FileExists(`Unable to create folder '${c.scheme===a.Schemas.file?c.fsPath:c.toString(!0)}' that already exists but is not a directory`);break}catch(S){if(C.$jk(S)!==C.FileSystemProviderErrorCode.FileNotFound)throw S;v.push(s.basename(c)),c=s.dirname(c)}for(let S=v.length-1;S>=0;S--){c=s.joinPath(c,v[S]);try{await t.createDirectory(c)}catch(p){if(C.$jk(p)!==C.FileSystemProviderErrorCode.FileExists)throw p}}}static e(t){if(t instanceof I.$lL)throw t;if(t instanceof C.$fk)switch(t.code){case C.FileSystemProviderErrorCode.FileExists:throw I.$lL.FileExists(t.message);case C.FileSystemProviderErrorCode.FileNotFound:throw I.$lL.FileNotFound(t.message);case C.FileSystemProviderErrorCode.FileNotADirectory:throw I.$lL.FileNotADirectory(t.message);case C.FileSystemProviderErrorCode.FileIsADirectory:throw I.$lL.FileIsADirectory(t.message);case C.FileSystemProviderErrorCode.NoPermissions:throw I.$lL.NoPermissions(t.message);case C.FileSystemProviderErrorCode.Unavailable:throw I.$lL.Unavailable(t.message);default:throw new I.$lL(t.message,t.name)}if(!(t instanceof Error))throw new I.$lL(String(t));if(t.name==="ENOPRO"||t.message.includes("ENOPRO"))throw I.$lL.Unavailable(t.message);switch(t.name){case C.FileSystemProviderErrorCode.FileExists:throw I.$lL.FileExists(t.message);case C.FileSystemProviderErrorCode.FileNotFound:throw I.$lL.FileNotFound(t.message);case C.FileSystemProviderErrorCode.FileNotADirectory:throw I.$lL.FileNotADirectory(t.message);case C.FileSystemProviderErrorCode.FileIsADirectory:throw I.$lL.FileIsADirectory(t.message);case C.FileSystemProviderErrorCode.NoPermissions:throw I.$lL.NoPermissions(t.message);case C.FileSystemProviderErrorCode.Unavailable:throw I.$lL.Unavailable(t.message);default:throw new I.$lL(t.message,t.name)}}addFileSystemProvider(t,s,c){return this.b.set(t,{impl:s,extUri:c?.isCaseSensitive?k.$ig:k.$kg,isReadonly:!!c?.isReadonly}),(0,d.$Oc)(()=>this.b.delete(t))}getFileSystemProviderExtUri(t){return this.b.get(t)?.extUri??k.$ig}};e.$4bc=m,e.$4bc=m=w=Je([qe(0,u.$0L),qe(1,D.$zbc)],m),e.$5bc=(0,R.$Lh)("IExtHostConsumerFileSystem")}),define(Ae[235],Re([1,0,5,36,2,3,8,7]),function(ie,e,h,C,I,O,R,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mcc=void 0;class D{get ignoreCreateEvents(){return!!(this.g&1)}get ignoreChangeEvents(){return!!(this.g&2)}get ignoreDeleteEvents(){return!!(this.g&4)}constructor(k,a,w,m,f,t,s,c){this.a=new h.$Ld,this.b=new h.$Ld,this.c=new h.$Ld;const v=this.h(k,w,f);this.g=0,t&&(this.g+=1),s&&(this.g+=2),c&&(this.g+=4);const S=(0,C.$sj)(f),p=typeof f=="string",n=m(r=>{if(!t)for(const i of r.created){const o=I.URI.revive(i);S(o.fsPath)&&(!p||a.getWorkspaceFolder(o))&&this.a.fire(o)}if(!s)for(const i of r.changed){const o=I.URI.revive(i);S(o.fsPath)&&(!p||a.getWorkspaceFolder(o))&&this.b.fire(o)}if(!c)for(const i of r.deleted){const o=I.URI.revive(i);S(o.fsPath)&&(!p||a.getWorkspaceFolder(o))&&this.c.fire(o)}});this.d=u.$$J.from(v,this.a,this.b,this.c,n)}h(k,a,w){const m=u.$$J.from();if(typeof w=="string")return m;const f=k.getProxy(O.$9J.MainThreadFileSystem);let t=!1;(w.pattern.includes(C.$oj)||w.pattern.includes(C.$pj))&&(t=!0);const s=Math.random();return f.$watch(a.identifier.value,s,w.baseUri,{recursive:t,excludes:[]}),u.$$J.from({dispose:()=>f.$unwatch(s)})}dispose(){this.d.dispose()}get onDidCreate(){return this.a.event}get onDidChange(){return this.b.event}get onDidDelete(){return this.c.event}}class d{constructor(k,a,w){this.j=k,this.k=a,this.l=w,this.a=new h.$Ld,this.b=new h.$Ld,this.c=new h.$Ld,this.d=new h.$Ld,this.g=new h.$Nd,this.h=new h.$Nd,this.i=new h.$Nd,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(k,a,w,m,f,t){return new D(this.j,k,a,this.a.event,R.GlobPattern.from(w),m,f,t)}$onFileEvent(k){this.a.fire(k)}$onDidRunFileOperation(k,a){switch(k){case 2:this.b.fire(Object.freeze({files:a.map(w=>({oldUri:I.URI.revive(w.source),newUri:I.URI.revive(w.target)}))}));break;case 1:this.d.fire(Object.freeze({files:a.map(w=>I.URI.revive(w.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:a.map(w=>I.URI.revive(w.target))}));break;default:}}getOnWillRenameFileEvent(k){return this.m(k,this.g)}getOnWillCreateFileEvent(k){return this.m(k,this.h)}getOnWillDeleteFileEvent(k){return this.m(k,this.i)}m(k,a){return(w,m,f)=>{const t=function(c){w.call(m,c)};return t.extension=k,a.event(t,void 0,f)}}async $onWillRunFileOperation(k,a,w,m){switch(k){case 2:return await this.n(this.g,{files:a.map(f=>({oldUri:I.URI.revive(f.source),newUri:I.URI.revive(f.target)}))},w,m);case 1:return await this.n(this.i,{files:a.map(f=>I.URI.revive(f.target))},w,m);case 0:case 3:return await this.n(this.h,{files:a.map(f=>I.URI.revive(f.target))},w,m)}}async n(k,a,w,m){const f=new Set,t=[];if(await k.fireAsync(a,m,async(c,v)=>{const S=Date.now(),p=await Promise.resolve(c);p instanceof u.$iK&&(t.push([v.extension,p]),f.add(v.extension.displayName??v.extension.identifier.value)),Date.now()-S>w&&this.k.warn("SLOW file-participant",v.extension.identifier)}),m.isCancellationRequested||t.length===0)return;const s={edits:[]};for(const[,c]of t){const{edits:v}=R.WorkspaceEdit.from(c,{getTextDocumentVersion:S=>this.l.getDocument(S)?.version,getNotebookDocumentVersion:()=>{}});s.edits=s.edits.concat(v)}return{edit:s,extensionNames:Array.from(f)}}}e.$mcc=d}),define(Ae[236],Re([1,0,6,2,3,8,7,31]),function(ie,e,h,C,I,O,R,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tdc=void 0;class D{constructor(a,w){this.extension=a,this.provider=w,this.handle=D.a++}}D.a=0;class d{constructor(a){this.session=a,this.responses=[]}}class A{constructor(a,w,m,f){this.f=m,this.g=f,this.b=new Map,this.d=new Map,this.e=a.getProxy(I.$9J.MainThreadInlineChat),w.registerApiCommand(new u.$xM("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new u.$vM("Run arguments","",t=>!0,t=>{if(t)return{initialRange:t.initialRange?O.Range.from(t.initialRange):void 0,initialSelection:t.initialSelection?O.Selection.from(t.initialSelection):void 0,message:t.message,autoSend:t.autoSend,position:t.position?O.Position.from(t.position):void 0}})],u.$wM.Void))}registerProvider(a,w,m){const f=new D(a,w);return this.b.set(f.handle,f),this.e.$registerInteractiveEditorProvider(f.handle,m.label,a.identifier.value,typeof w.handleInteractiveEditorResponseFeedback=="function"),(0,h.$Oc)(()=>{this.e.$unregisterInteractiveEditorProvider(f.handle),this.b.delete(f.handle)})}async $prepareSession(a,w,m,f){const t=this.b.get(a);if(!t){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const s=this.f.getDocument(C.URI.revive(w)),c=O.Selection.to(m),v=await t.provider.prepareInteractiveEditorSession({document:s,selection:c},f);if(!v)return;if(v.wholeRange&&!v.wholeRange.contains(c))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const S=A.a++;return this.d.set(S,new d(v)),{id:S,placeholder:v.placeholder,slashCommands:v.slashCommands?.map(p=>({command:p.command,detail:p.detail,refer:p.refer,executeImmediately:p.executeImmediately})),wholeRange:O.Range.from(v.wholeRange),message:v.message}}async $provideResponse(a,w,m,f){const t=this.b.get(a);if(!t)return;const s=this.d.get(w.id);if(!s)return;const c={prompt:m.prompt,selection:O.Selection.to(m.selection),wholeRange:O.Range.to(m.wholeRange),attempt:m.attempt,live:m.live};let v=!1;const S={report:r=>{if(!m.live)throw new Error("Progress reporting is only supported for live sessions");v||f.isCancellationRequested||!r.message&&!r.edits||this.e.$handleProgressChunk(m.requestId,{message:r.message,edits:r.edits?.map(O.TextEdit.from)})}},p=t.provider.provideInteractiveEditorResponse(s.session,c,S,f);Promise.resolve(p).finally(()=>v=!0);const n=await p;if(n){const r=s.responses.push(n)-1,i={wholeRange:O.Range.from(n.wholeRange),placeholder:n.placeholder};if(A.h(n))return{...i,id:r,type:"message",message:O.MarkdownString.from(n.contents)};const{edits:o}=n;if(o instanceof R.$iK)return{...i,id:r,type:"bulkEdit",edits:O.WorkspaceEdit.from(o)};if(Array.isArray(o))return{...i,id:r,type:"editorEdit",edits:o.map(O.TextEdit.from)}}}$handleFeedback(a,w,m,f){const t=this.b.get(a),s=this.d.get(w),c=s?.responses[m];if(t&&c){const v=O.InteractiveEditorResponseFeedbackKind.to(f);t.provider.handleInteractiveEditorResponseFeedback?.(s.session,c,v)}}$releaseSession(a,w){}static h(a){return typeof a=="object"&&typeof a.contents=="object"}}e.$tdc=A,A.a=0}),define(Ae[237],Re([1,0,2,31]),function(ie,e,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pdc=void 0;class I{constructor(R,u,D,d,A){this.a=u,this.b=D,this.c=d;const k=new C.$xM("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new C.$vM("showOptions","Show Options",a=>!0,a=>a),new C.$vM("resource","Interactive resource Uri",a=>!0,a=>a),new C.$vM("controllerId","Notebook controller Id",a=>!0,a=>a),new C.$vM("title","Interactive editor title",a=>!0,a=>a)],new C.$wM("Notebook and input URI",a=>{if(A.debug("[ExtHostInteractive] open iw with notebook editor id",a.notebookEditorId),a.notebookEditorId!==void 0){const w=this.a.getEditorById(a.notebookEditorId);return A.debug("[ExtHostInteractive] notebook editor found",w.id),{notebookUri:h.URI.revive(a.notebookUri),inputUri:h.URI.revive(a.inputUri),notebookEditor:w.apiEditor}}return A.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",a.notebookUri,a.inputUri),{notebookUri:h.URI.revive(a.notebookUri),inputUri:h.URI.revive(a.inputUri)}}));this.c.registerApiCommand(k)}$willAddInteractiveDocument(R,u,D,d){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:u,lines:[""],languageId:D,uri:R,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(h.URI.revive(d))?.apiNotebook}]})}$willRemoveInteractiveDocument(R,u){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[R]})}}e.$pdc=I}),define(Ae[238],Re([1,0,3,7]),function(ie,e,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vdc=void 0;class I{constructor(R){this.a=new Map,this.b=R.getProxy(h.$9J.MainThreadIssueReporter)}async $getIssueReporterUri(R,u){if(this.a.size===0)throw new Error("No issue request handlers registered");const D=this.a.get(R);if(!D)throw new Error("Issue request handler not found");const d=await D.handleIssueUrlRequest();if(!d)throw new Error("Issue request handler returned no result");return d}registerIssueUriRequestHandler(R,u){const D=R.identifier.value;return this.a.set(D,u),this.b.$registerIssueUriRequestHandler(D),new C.$$J(()=>{this.b.$unregisterIssueUriRequestHandler(D),this.a.delete(D)})}}e.$vdc=I}),define(Ae[239],Re([1,0,6,3]),function(ie,e,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Icc=void 0;class I{constructor(R){this.b=0,this.a=R.getProxy(C.$9J.MainThreadLabelService)}$registerResourceLabelFormatter(R){const u=this.b++;return this.a.$registerResourceLabelFormatter(u,R),(0,h.$Oc)(()=>{this.a.$unregisterResourceLabelFormatter(u)})}}e.$Icc=I}),define(Ae[240],Re([1,0,2,24,8,7,78,3,15,44,18,16,281,21,20,6,91,88,55,59,9,12,26,149]),function(ie,e,h,C,I,O,R,u,D,d,A,k,a,w,m,f,t,s,c,v,S,p,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fbc=void 0;class i{constructor(T,H){this.d=T,this.e=H}async provideDocumentSymbols(T,H){const X=this.d.getDocument(T),Y=await this.e.provideDocumentSymbols(X,H);if(!(0,A.$Ib)(Y))return Y[0]instanceof O.$qK?Y.map(I.DocumentSymbol.from):i.f(Y)}static f(T){T=T.slice(0).sort((Y,J)=>{let te=Y.location.range.start.compareTo(J.location.range.start);return te===0&&(te=J.location.range.end.compareTo(Y.location.range.end)),te});const H=[],X=[];for(const Y of T){const J={name:Y.name||"!!MISSING: name!!",kind:I.SymbolKind.from(Y.kind),tags:Y.tags?.map(I.SymbolTag.from)||[],detail:"",containerName:Y.containerName,range:I.Range.from(Y.location.range),selectionRange:I.Range.from(Y.location.range),children:[]};for(;;){if(X.length===0){X.push(J),H.push(J);break}const te=X[X.length-1];if(d.$ms.containsRange(te.range,J.range)&&!d.$ms.equalsRange(te.range,J.range)){te.children?.push(J),X.push(J);break}X.pop()}}return H}}class o{constructor(T,H,X){this.g=T,this.h=H,this.j=X,this.e=new c.$wbc("CodeLens"),this.f=new Map}async provideCodeLenses(T,H){const X=this.g.getDocument(T),Y=await this.j.provideCodeLenses(X,H);if(!Y||H.isCancellationRequested)return;const J=this.e.add(Y),te=new f.$Pc;this.f.set(J,te);const se={cacheId:J,lenses:[]};for(let Fe=0;Fe<Y.length;Fe++)se.lenses.push({cacheId:[J,Fe],range:I.Range.from(Y[Fe].range),command:this.h.toInternal(Y[Fe].command,te)});return se}async resolveCodeLens(T,H){const X=T.cacheId&&this.e.get(...T.cacheId);if(!X)return;let Y;if(typeof this.j.resolveCodeLens!="function"||X.isResolved?Y=X:Y=await this.j.resolveCodeLens(X,H),Y||(Y=X),H.isCancellationRequested)return;const J=T.cacheId&&this.f.get(T.cacheId[0]);if(J)return T.command=this.h.toInternal(Y.command??o.d,J),T}releaseCodeLenses(T){this.f.get(T)?.dispose(),this.f.delete(T),this.e.delete(T)}}o.d={command:"missing",title:"!!MISSING: command!!"};function y(Ce){return Array.isArray(Ce)?Ce.map(I.DefinitionLink.from):Ce?[I.DefinitionLink.from(Ce)]:[]}class g{constructor(T,H){this.d=T,this.e=H}async provideDefinition(T,H,X){const Y=this.d.getDocument(T),J=I.Position.to(H),te=await this.e.provideDefinition(Y,J,X);return y(te)}}class E{constructor(T,H){this.d=T,this.e=H}async provideDeclaration(T,H,X){const Y=this.d.getDocument(T),J=I.Position.to(H),te=await this.e.provideDeclaration(Y,J,X);return y(te)}}class P{constructor(T,H){this.d=T,this.e=H}async provideImplementation(T,H,X){const Y=this.d.getDocument(T),J=I.Position.to(H),te=await this.e.provideImplementation(Y,J,X);return y(te)}}class l{constructor(T,H){this.d=T,this.e=H}async provideTypeDefinition(T,H,X){const Y=this.d.getDocument(T),J=I.Position.to(H),te=await this.e.provideTypeDefinition(Y,J,X);return y(te)}}class ${constructor(T,H){this.d=T,this.e=H}async provideHover(T,H,X){const Y=this.d.getDocument(T),J=I.Position.to(H),te=await this.e.provideHover(Y,J,X);if(!(!te||(0,A.$Ib)(te.contents)))return te.range||(te.range=Y.getWordRangeAtPosition(J)),te.range||(te.range=new O.$aK(J,J)),I.Hover.from(te)}}class b{constructor(T,H){this.d=T,this.e=H}async provideEvaluatableExpression(T,H,X){const Y=this.d.getDocument(T),J=I.Position.to(H),te=await this.e.provideEvaluatableExpression(Y,J,X);if(te)return I.EvaluatableExpression.from(te)}}class M{constructor(T,H){this.d=T,this.e=H}async provideInlineValues(T,H,X,Y){const J=this.d.getDocument(T),te=await this.e.provideInlineValues(J,I.Range.to(H),I.InlineValueContext.to(X),Y);if(Array.isArray(te))return te.map(se=>I.InlineValue.from(se))}}class U{constructor(T,H){this.d=T,this.e=H}async provideDocumentHighlights(T,H,X){const Y=this.d.getDocument(T),J=I.Position.to(H),te=await this.e.provideDocumentHighlights(Y,J,X);if(Array.isArray(te))return te.map(I.DocumentHighlight.from)}}class F{constructor(T,H){this.d=T,this.e=H}async provideLinkedEditingRanges(T,H,X){const Y=this.d.getDocument(T),J=I.Position.to(H),te=await this.e.provideLinkedEditingRanges(Y,J,X);if(te&&Array.isArray(te.ranges))return{ranges:(0,A.$Fb)(te.ranges.map(I.Range.from)),wordPattern:te.wordPattern}}}class q{constructor(T,H){this.d=T,this.e=H}async provideReferences(T,H,X,Y){const J=this.d.getDocument(T),te=I.Position.to(H),se=await this.e.provideReferences(J,te,X,Y);if(Array.isArray(se))return se.map(I.location.from)}}class W{constructor(T,H,X,Y,J,te,se){this.g=T,this.h=H,this.j=X,this.k=Y,this.l=J,this.m=te,this.n=se,this.e=new c.$wbc("CodeAction"),this.f=new Map}async provideCodeActions(T,H,X,Y){const J=this.g.getDocument(T),te=a.$os.isISelection(H)?I.Selection.to(H):I.Range.to(H),se=[];for(const xe of this.j.getDiagnostics(T))if(te.intersection(xe.range)&&se.push(xe)>W.d)break;const Fe={diagnostics:se,only:X.only?new O.$sK(X.only):void 0,triggerKind:I.CodeActionTriggerKind.to(X.trigger)},je=await this.k.provideCodeActions(J,te,Fe,Y);if(!(0,A.$Jb)(je)||Y.isCancellationRequested)return;const Xe=this.e.add(je),He=new f.$Pc;this.f.set(Xe,He);const et=[];for(let xe=0;xe<je.length;xe++){const it=je[xe];it&&(W.o(it)?(this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),et.push({_isSynthetic:!0,title:it.title,command:this.h.toInternal(it,He)})):(Fe.only&&(it.kind?Fe.only.contains(it.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Fe.only.value} 'requested but returned code action is of kind '${it.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Fe.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),et.push({cacheId:[Xe,xe],title:it.title,command:it.command&&this.h.toInternal(it.command,He),diagnostics:it.diagnostics&&it.diagnostics.map(I.Diagnostic.from),edit:it.edit&&I.WorkspaceEdit.from(it.edit,void 0),kind:it.kind&&it.kind.value,isPreferred:it.isPreferred,disabled:it.disabled?.reason})))}return{cacheId:Xe,actions:et}}async resolveCodeAction(T,H){const[X,Y]=T,J=this.e.get(X,Y);if(!J||W.o(J))return{};if(!this.k.resolveCodeAction)return{};const te=await this.k.resolveCodeAction(J,H)??J;let se;te.edit&&(se=I.WorkspaceEdit.from(te.edit,void 0));let Fe;if(te.command){const je=this.f.get(X);je&&(Fe=this.h.toInternal(te.command,je))}return{edit:se,command:Fe}}releaseCodeActions(T){this.f.get(T)?.dispose(),this.f.delete(T),this.e.delete(T)}static o(T){return typeof T.command=="string"&&typeof T.title=="string"}}W.d=1e3;class L{static toInternalProviderId(T,H){return T+"."+H}constructor(T,H,X,Y,J){this.d=T,this.e=H,this.f=X,this.g=Y,this.h=J}async prepareDocumentPaste(T,H,X,Y){if(!this.f.prepareDocumentPaste)return;const J=this.e.getDocument(T),te=H.map(je=>I.Range.to(je)),se=I.DataTransfer.toDataTransfer(X,()=>{throw new S.$9});if(await this.f.prepareDocumentPaste(J,te,se,Y),Y.isCancellationRequested)return;const Fe=Array.from(se).filter(([,je])=>!(je instanceof O.$YK));return I.DataTransfer.from(Fe)}async providePasteEdits(T,H,X,Y,J){if(!this.f.provideDocumentPasteEdits)return;const te=this.e.getDocument(H),se=X.map(Xe=>I.Range.to(Xe)),Fe=I.DataTransfer.toDataTransfer(Y,async Xe=>(await this.d.$resolvePasteFileData(this.g,T,Xe)).buffer),je=await this.f.provideDocumentPasteEdits(te,se,Fe,J);if(je)return{label:je.label??(0,r.localize)(0,null,this.h.displayName||this.h.name),detail:this.h.displayName||this.h.name,yieldTo:je.yieldTo?.map(Xe=>"mimeType"in Xe?Xe:{providerId:L.toInternalProviderId(Xe.extensionId,Xe.providerId)}),insertText:typeof je.insertText=="string"?je.insertText:{snippet:je.insertText.value},additionalEdit:je.additionalEdit?I.WorkspaceEdit.from(je.additionalEdit,void 0):void 0}}}class z{constructor(T,H){this.d=T,this.e=H}async provideDocumentFormattingEdits(T,H,X){const Y=this.d.getDocument(T),J=await this.e.provideDocumentFormattingEdits(Y,H,X);if(Array.isArray(J))return J.map(I.TextEdit.from)}}class K{constructor(T,H){this.d=T,this.e=H}async provideDocumentRangeFormattingEdits(T,H,X,Y){const J=this.d.getDocument(T),te=I.Range.to(H),se=await this.e.provideDocumentRangeFormattingEdits(J,te,X,Y);if(Array.isArray(se))return se.map(I.TextEdit.from)}async provideDocumentRangesFormattingEdits(T,H,X,Y){(0,k.$Gf)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const J=this.d.getDocument(T),te=H.map(I.Range.to),se=await this.e.provideDocumentRangesFormattingEdits(J,te,X,Y);if(Array.isArray(se))return se.map(I.TextEdit.from)}}class B{constructor(T,H){this.d=T,this.e=H,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(T,H,X,Y,J){const te=this.d.getDocument(T),se=I.Position.to(H),Fe=await this.e.provideOnTypeFormattingEdits(te,se,X,Y,J);if(Array.isArray(Fe))return Fe.map(I.TextEdit.from)}}class me{constructor(T,H){this.e=T,this.f=H,this.d=new c.$wbc("WorkspaceSymbols")}async provideWorkspaceSymbols(T,H){const X=await this.e.provideWorkspaceSymbols(T,H);if(!(0,A.$Jb)(X))return{symbols:[]};const Y=this.d.add(X),J={cacheId:Y,symbols:[]};for(let te=0;te<X.length;te++){const se=X[te];if(!se||!se.name){this.f.warn("INVALID SymbolInformation",se);continue}J.symbols.push({...I.WorkspaceSymbol.from(se),cacheId:[Y,te]})}return J}async resolveWorkspaceSymbol(T,H){if(typeof this.e.resolveWorkspaceSymbol!="function"||!T.cacheId)return T;const X=this.d.get(...T.cacheId);if(X){const Y=await this.e.resolveWorkspaceSymbol(X,H);return Y&&(0,C.$1m)(T,I.WorkspaceSymbol.from(Y),!0)}}releaseWorkspaceSymbols(T){this.d.delete(T)}}class ye{static supportsResolving(T){return typeof T.prepareRename=="function"}constructor(T,H,X){this.d=T,this.e=H,this.f=X}async provideRenameEdits(T,H,X,Y){const J=this.d.getDocument(T),te=I.Position.to(H);try{const se=await this.e.provideRenameEdits(J,te,X,Y);return se?I.WorkspaceEdit.from(se):void 0}catch(se){const Fe=ye.g(se);return Fe?{rejectReason:Fe,edits:void 0}:Promise.reject(se)}}async resolveRenameLocation(T,H,X){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const Y=this.d.getDocument(T),J=I.Position.to(H);try{const te=await this.e.prepareRename(Y,J,X);let se,Fe;if(O.$aK.isRange(te)?(se=te,Fe=Y.getText(te)):(0,k.$yf)(te)&&(se=te.range,Fe=te.placeholder),!se||!Fe)return;if(se.start.line>J.line||se.end.line<J.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:I.Range.from(se),text:Fe}}catch(te){const se=ye.g(te);return se?{rejectReason:se,range:void 0,text:void 0}:Promise.reject(te)}}static g(T){return typeof T=="string"?T:T instanceof Error&&typeof T.message=="string"?T.message:void 0}}class Ie{constructor(T,H){this.resultId=T,this.tokens=H}}class _{constructor(T,H){this.f=T,this.g=H,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(T,H,X){const Y=this.f.getDocument(T),J=H!==0?this.d.get(H):null;let te=typeof J?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(Y,J.resultId,X):await this.g.provideDocumentSemanticTokens(Y,X);return J&&this.d.delete(H),te?(te=_.h(te),this.o(_.n(J,te),te)):null}async releaseDocumentSemanticColoring(T){this.d.delete(T)}static h(T){return _.j(T)?_.k(T)?T:new O.$pL(new Uint32Array(T.data),T.resultId):_.l(T)?_.m(T)?T:new O.$rL(T.edits.map(H=>new O.$qL(H.start,H.deleteCount,H.data?new Uint32Array(H.data):H.data)),T.resultId):T}static j(T){return T&&!!T.data}static k(T){return T.data instanceof Uint32Array}static l(T){return T&&Array.isArray(T.edits)}static m(T){for(const H of T.edits)if(!(H.data instanceof Uint32Array))return!1;return!0}static n(T,H){if(!_.j(H)||!T||!T.tokens)return H;const X=T.tokens,Y=X.length,J=H.data,te=J.length;let se=0;const Fe=Math.min(Y,te);for(;se<Fe&&X[se]===J[se];)se++;if(se===Y&&se===te)return new O.$rL([],H.resultId);let je=0;const Xe=Fe-se;for(;je<Xe&&X[Y-je-1]===J[te-je-1];)je++;return new O.$rL([{start:se,deleteCount:Y-se-je,data:J.subarray(se,te-je)}],H.resultId)}o(T,H){if(_.j(T)){const X=this.e++;return this.d.set(X,new Ie(T.resultId,T.data)),(0,t.$I0)({id:X,type:"full",data:T.data})}if(_.l(T)){const X=this.e++;return _.j(H)?this.d.set(X,new Ie(H.resultId,H.data)):this.d.set(X,new Ie(T.resultId)),(0,t.$I0)({id:X,type:"delta",deltas:(T.edits||[]).map(Y=>({start:Y.start,deleteCount:Y.deleteCount,data:Y.data}))})}return null}}class de{constructor(T,H){this.d=T,this.e=H}async provideDocumentRangeSemanticTokens(T,H,X){const Y=this.d.getDocument(T),J=await this.e.provideDocumentRangeSemanticTokens(Y,I.Range.to(H),X);return J?this.f(J):null}f(T){return(0,t.$I0)({id:0,type:"full",data:T.data})}}class De{static supportsResolving(T){return typeof T.resolveCompletionItem=="function"}constructor(T,H,X,Y,J){this.f=T,this.g=H,this.h=X,this.j=Y,this.k=J,this.d=new c.$wbc("CompletionItem"),this.e=new Map}async provideCompletionItems(T,H,X,Y){const J=this.f.getDocument(T),te=I.Position.to(H),se=J.getWordRangeAtPosition(te)||new O.$aK(te,te),Fe=se.with({end:te}),je=new v.$Hd,Xe=await this.h.provideCompletionItems(J,te,Y,I.CompletionContext.to(X));if(!Xe||Y.isCancellationRequested)return;const He=Array.isArray(Xe)?new O.$FK(Xe):Xe,et=De.supportsResolving(this.h)?this.d.add(He.items):this.d.add([]),xe=new f.$Pc;this.e.set(et,xe);const it=[],st={x:et,b:it,a:{replace:I.Range.from(se),insert:I.Range.from(Fe)},c:He.isIncomplete||void 0,d:je.elapsed()};for(let nt=0;nt<He.items.length;nt++){const Ue=He.items[nt],ot=this.l(Ue,[et,nt],Fe,se);it.push(ot)}return st}async resolveCompletionItem(T,H){if(typeof this.h.resolveCompletionItem!="function")return;const X=this.d.get(...T);if(!X)return;const Y=this.l(X,T),J=await this.h.resolveCompletionItem(X,H);if(!J)return;const te=this.l(J,T);return(Y.h!==te.h||Y.i!==te.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(Y.n!==te.n||Y.o!==te.o||!(0,C.$2m)(Y.p,te.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...Y,d:te.d,c:te.c,l:te.l,h:te.h,i:te.i,n:te.n,o:te.o,p:te.p}}releaseCompletionItems(T){this.e.get(T)?.dispose(),this.e.delete(T),this.d.delete(T)}l(T,H,X,Y){const J=this.e.get(H[0]);if(!J)throw Error("DisposableStore is missing...");const te=this.g.toInternal(T.command,J),se={x:H,a:T.label,b:T.kind!==void 0?I.CompletionItemKind.from(T.kind):void 0,m:T.tags&&T.tags.map(I.CompletionItemTag.from),c:T.detail,d:typeof T.documentation>"u"?void 0:I.MarkdownString.fromStrict(T.documentation),e:T.sortText!==T.label?T.sortText:void 0,f:T.filterText!==T.label?T.filterText:void 0,g:T.preselect||void 0,i:T.keepWhitespace?1:0,k:T.commitCharacters?.join(""),l:T.additionalTextEdits&&T.additionalTextEdits.map(I.TextEdit.from),n:te?.$ident,o:te?.id,p:te?.$ident?void 0:te?.arguments};T.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),se.h=T.textEdit.newText):typeof T.insertText=="string"?se.h=T.insertText:T.insertText instanceof O.$jK&&(se.h=T.insertText.value,se.i|=4);let Fe;return T.textEdit?Fe=T.textEdit.range:T.range&&(Fe=T.range),O.$aK.isRange(Fe)?se.j=I.Range.from(Fe):Fe&&(!X?.isEqual(Fe.inserting)||!Y?.isEqual(Fe.replacing))&&(se.j={insert:I.Range.from(Fe.inserting),replace:I.Range.from(Fe.replacing)}),se}}class ue{async provideInlineCompletions(T,H,X,Y){}disposeCompletions(T){}handleDidShowCompletionItem(T,H,X){}handlePartialAccept(T,H,X){}}class ve extends ue{constructor(T,H,X,Y){super(),this.f=T,this.g=H,this.h=X,this.j=Y,this.d=new ke,this.e=(0,n.$7E)(this.f,"inlineCompletionsAdditions"),this.k={[R.InlineCompletionTriggerKind.Automatic]:O.InlineCompletionTriggerKind.Automatic,[R.InlineCompletionTriggerKind.Explicit]:O.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,n.$7E)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(T,H,X,Y){const J=this.g.getDocument(T),te=I.Position.to(H),se=await this.h.provideInlineCompletionItems(J,te,{selectedCompletionInfo:X.selectedSuggestionInfo?{range:I.Range.to(X.selectedSuggestionInfo.range),text:X.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[X.triggerKind]},Y);if(!se||Y.isCancellationRequested)return;const Fe=Array.isArray(se)?se:se.items,je=this.e?Array.isArray(se)?[]:se.commands||[]:[],Xe=this.e&&!Array.isArray(se)?se.enableForwardStability:void 0;let He;return{pid:this.d.createReferenceId({dispose(){He?.dispose()},items:Fe}),items:Fe.map((xe,it)=>{let st;xe.command&&(He||(He=new f.$Pc),st=this.j.toInternal(xe.command,He));const nt=xe.insertText;return{insertText:typeof nt=="string"?nt:{snippet:nt.value},filterText:xe.filterText,range:xe.range?I.Range.from(xe.range):void 0,command:st,idx:it,completeBracketPairs:this.e?xe.completeBracketPairs:!1}}),commands:je.map(xe=>(He||(He=new f.$Pc),this.j.toInternal(xe,He))),suppressSuggestions:!1,enableForwardStability:Xe}}disposeCompletions(T){this.d.disposeReferenceId(T)?.dispose()}handleDidShowCompletionItem(T,H,X){const Y=this.d.get(T)?.items[H];Y&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(Y,X)}handlePartialAccept(T,H,X){const Y=this.d.get(T)?.items[H];Y&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(Y,X)}}class ke{constructor(){this.d=new Map,this.e=1}createReferenceId(T){const H=this.e++;return this.d.set(H,T),H}disposeReferenceId(T){const H=this.d.get(T);return this.d.delete(T),H}get(T){return this.d.get(T)}}class V{constructor(T,H){this.e=T,this.f=H,this.d=new c.$wbc("SignatureHelp")}async provideSignatureHelp(T,H,X,Y){const J=this.e.getDocument(T),te=I.Position.to(H),se=this.g(X),Fe=await this.f.provideSignatureHelp(J,te,Y,se);if(Fe){const je=this.d.add([Fe]);return{...I.SignatureHelp.from(Fe),id:je}}}g(T){let H;if(T.activeSignatureHelp){const X=I.SignatureHelp.to(T.activeSignatureHelp),Y=this.d.get(T.activeSignatureHelp.id,0);Y?(H=Y,H.activeSignature=X.activeSignature,H.activeParameter=X.activeParameter):H=X}return{...T,activeSignatureHelp:H}}releaseSignatureHelp(T){this.d.delete(T)}}class Q{constructor(T,H,X,Y,J){this.f=T,this.g=H,this.h=X,this.j=Y,this.k=J,this.d=new c.$wbc("InlayHints"),this.e=new Map}async provideInlayHints(T,H,X){const Y=this.f.getDocument(T),J=I.Range.to(H),te=await this.h.provideInlayHints(Y,J,X);if(!Array.isArray(te)||te.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for ${H}`);return}if(X.isCancellationRequested)return;const se=this.d.add(te);this.e.set(se,new f.$Pc);const Fe={hints:[],cacheId:se};for(let je=0;je<te.length;je++)this.l(te[je],J)&&Fe.hints.push(this.m(te[je],[se,je]));return this.j.trace(`[InlayHints] ${Fe.hints.length} inlay hints from '${this.k.identifier.value}' for ${H}`),Fe}async resolveInlayHint(T,H){if(typeof this.h.resolveInlayHint!="function")return;const X=this.d.get(...T);if(!X)return;const Y=await this.h.resolveInlayHint(X,H);if(Y&&this.l(Y))return this.m(Y,T)}releaseHints(T){this.e.get(T)?.dispose(),this.e.delete(T),this.d.delete(T)}l(T,H){return T.label.length===0||Array.isArray(T.label)&&T.label.every(X=>X.value.length===0)?(console.log("INVALID inlay hint, empty label",T),!1):!(H&&!H.contains(T.position))}m(T,H){const X=this.e.get(H[0]);if(!X)throw Error("DisposableStore is missing...");const Y={label:"",cacheId:H,tooltip:I.MarkdownString.fromStrict(T.tooltip),position:I.Position.from(T.position),textEdits:T.textEdits&&T.textEdits.map(I.TextEdit.from),kind:T.kind&&I.InlayHintKind.from(T.kind),paddingLeft:T.paddingLeft,paddingRight:T.paddingRight};return typeof T.label=="string"?Y.label=T.label:Y.label=T.label.map(J=>{const te={label:J.value};return te.tooltip=I.MarkdownString.fromStrict(J.tooltip),O.$kK.isLocation(J.location)&&(te.location=I.location.from(J.location)),J.command&&(te.command=this.g.toInternal(J.command,X)),te}),Y}}class ee{constructor(T,H){this.e=T,this.f=H,this.d=new c.$wbc("DocumentLink")}async provideLinks(T,H){const X=this.e.getDocument(T),Y=await this.f.provideDocumentLinks(X,H);if(!(!Array.isArray(Y)||Y.length===0)&&!H.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:Y.filter(ee.g).map(I.DocumentLink.from)};{const J=this.d.add(Y),te={links:[],cacheId:J};for(let se=0;se<Y.length;se++){if(!ee.g(Y[se]))continue;const Fe=I.DocumentLink.from(Y[se]);Fe.cacheId=[J,se],te.links.push(Fe)}return te}}}static g(T){return T.target&&T.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(T,H){if(typeof this.f.resolveDocumentLink!="function")return;const X=this.d.get(...T);if(!X)return;const Y=await this.f.resolveDocumentLink(X,H);if(!(!Y||!ee.g(Y)))return I.DocumentLink.from(Y)}releaseLinks(T){this.d.delete(T)}}class $e{constructor(T,H){this.d=T,this.e=H}async provideColors(T,H){const X=this.d.getDocument(T),Y=await this.e.provideDocumentColors(X,H);return Array.isArray(Y)?Y.map(te=>({color:I.Color.from(te.color),range:I.Range.from(te.range)})):[]}async provideColorPresentations(T,H,X){const Y=this.d.getDocument(T),J=I.Range.to(H.range),te=I.Color.to(H.color),se=await this.e.provideColorPresentations(te,{document:Y,range:J},X);if(Array.isArray(se))return se.map(I.ColorPresentation.from)}}class he{constructor(T,H){this.d=T,this.e=H}async provideFoldingRanges(T,H,X){const Y=this.d.getDocument(T),J=await this.e.provideFoldingRanges(Y,H,X);if(Array.isArray(J))return J.map(I.FoldingRange.from)}}class fe{constructor(T,H,X){this.d=T,this.e=H,this.f=X}async provideSelectionRanges(T,H,X){const Y=this.d.getDocument(T),J=H.map(I.Position.to),te=await this.e.provideSelectionRanges(Y,J,X);if(!(0,A.$Jb)(te))return[];if(te.length!==J.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const se=[];for(let Fe=0;Fe<J.length;Fe++){const je=[];se.push(je);let Xe=J[Fe],He=te[Fe];for(;;){if(!He.range.contains(Xe))throw new Error("INVALID selection range, must contain the previous range");if(je.push(I.SelectionRange.from(He)),!He.parent)break;Xe=He.range,He=He.parent}}return se}}class Ee{constructor(T,H){this.f=T,this.g=H,this.d=new s.$cM(""),this.e=new Map}async prepareSession(T,H,X){const Y=this.f.getDocument(T),J=I.Position.to(H),te=await this.g.prepareCallHierarchy(Y,J,X);if(!te)return;const se=this.d.nextId();return this.e.set(se,new Map),Array.isArray(te)?te.map(Fe=>this.h(se,Fe)):[this.h(se,te)]}async provideCallsTo(T,H,X){const Y=this.j(T,H);if(!Y)throw new Error("missing call hierarchy item");const J=await this.g.provideCallHierarchyIncomingCalls(Y,X);if(J)return J.map(te=>({from:this.h(T,te.from),fromRanges:te.fromRanges.map(se=>I.Range.from(se))}))}async provideCallsFrom(T,H,X){const Y=this.j(T,H);if(!Y)throw new Error("missing call hierarchy item");const J=await this.g.provideCallHierarchyOutgoingCalls(Y,X);if(J)return J.map(te=>({to:this.h(T,te.to),fromRanges:te.fromRanges.map(se=>I.Range.from(se))}))}releaseSession(T){this.e.delete(T)}h(T,H){const X=this.e.get(T),Y=I.CallHierarchyItem.from(H,T,X.size.toString(36));return X.set(Y._itemId,H),Y}j(T,H){return this.e.get(T)?.get(H)}}class re{constructor(T,H){this.f=T,this.g=H,this.d=new s.$cM(""),this.e=new Map}async prepareSession(T,H,X){const Y=this.f.getDocument(T),J=I.Position.to(H),te=await this.g.prepareTypeHierarchy(Y,J,X);if(!te)return;const se=this.d.nextId();return this.e.set(se,new Map),Array.isArray(te)?te.map(Fe=>this.h(se,Fe)):[this.h(se,te)]}async provideSupertypes(T,H,X){const Y=this.j(T,H);if(!Y)throw new Error("missing type hierarchy item");const J=await this.g.provideTypeHierarchySupertypes(Y,X);if(J)return J.map(te=>this.h(T,te))}async provideSubtypes(T,H,X){const Y=this.j(T,H);if(!Y)throw new Error("missing type hierarchy item");const J=await this.g.provideTypeHierarchySubtypes(Y,X);if(J)return J.map(te=>this.h(T,te))}releaseSession(T){this.e.delete(T)}h(T,H){const X=this.e.get(T),Y=I.TypeHierarchyItem.from(H,T,X.size.toString(36));return X.set(Y._itemId,H),Y}j(T,H){return this.e.get(T)?.get(H)}}class le{static toInternalProviderId(T,H){return T+"."+H}constructor(T,H,X,Y,J){this.d=T,this.e=H,this.f=X,this.g=Y,this.h=J}async provideDocumentOnDropEdits(T,H,X,Y,J){const te=this.e.getDocument(H),se=I.Position.to(X),Fe=I.DataTransfer.toDataTransfer(Y,async Xe=>(await this.d.$resolveDocumentOnDropFileData(this.g,T,Xe)).buffer),je=await this.f.provideDocumentDropEdits(te,se,Fe,J);if(je)return{label:je.label??(0,r.localize)(1,null,this.h.displayName||this.h.name),yieldTo:je.yieldTo?.map(Xe=>"mimeType"in Xe?Xe:{providerId:le.toInternalProviderId(Xe.extensionId,Xe.providerId)}),insertText:typeof je.insertText=="string"?je.insertText:{snippet:je.insertText.value},additionalEdit:je.additionalEdit?I.WorkspaceEdit.from(je.additionalEdit,void 0):void 0}}}class oe{constructor(T,H){this.d=T,this.e=H}async provideMappedEdits(T,H,X,Y){const J=h.URI.revive(T),te=this.d.getDocument(J),se=X.documents.map(Xe=>Xe.map(He=>({uri:h.URI.revive(He.uri),version:He.version,ranges:He.ranges.map(et=>I.Range.to(et))}))),Fe={documents:se,selections:se[0]?.[0]?.ranges??[]},je=await this.e.provideMappedEdits(te,H,Fe,Y);return je?I.WorkspaceEdit.from(je):null}}class ae{constructor(T,H){this.adapter=T,this.extension=H}}class pe{constructor(T,H,X,Y,J,te,se,Fe){this.g=H,this.h=X,this.j=Y,this.k=J,this.l=te,this.m=se,this.n=Fe,this.f=new Map,this.e=T.getProxy(u.$9J.MainThreadLanguageFeatures)}o(T,H){return I.DocumentSelector.from(T,this.g,H)}p(T){return new O.$$J(()=>{this.f.delete(T),this.e.$unregister(T)})}q(){return pe.d++}async s(T,H,X,Y,J,te=!1){const se=this.f.get(T);if(!se||!(se.adapter instanceof H))return Y;const Fe=Date.now();te||this.l.trace(`[${se.extension.identifier.value}] INVOKE provider '${X.toString().replace(/[\r\n]/g,"")}'`);const je=X(se.adapter,se.extension);return Promise.resolve(je).catch(Xe=>{(0,S.$2)(Xe)||(this.l.error(`[${se.extension.identifier.value}] provider FAILED`),this.l.error(Xe),this.n.onExtensionError(se.extension.identifier,Xe))}).finally(()=>{te||this.l.trace(`[${se.extension.identifier.value}] provider DONE after ${Date.now()-Fe}ms`)}),w.CancellationToken.isCancellationToken(J)?(0,p.$Gg)(je,J):je}t(T,H){const X=this.q();return this.f.set(X,new ae(T,H)),X}static u(T){return T.displayName||T.name}registerDocumentSymbolProvider(T,H,X,Y){const J=this.t(new i(this.h,X),T),te=Y&&Y.label||pe.u(T);return this.e.$registerDocumentSymbolProvider(J,this.o(H,T),te),this.p(J)}$provideDocumentSymbols(T,H,X){return this.s(T,i,Y=>Y.provideDocumentSymbols(h.URI.revive(H),X),void 0,X)}registerCodeLensProvider(T,H,X){const Y=this.q(),J=typeof X.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(Y,new ae(new o(this.h,this.j.converter,X),T)),this.e.$registerCodeLensSupport(Y,this.o(H,T),J);let te=this.p(Y);if(J!==void 0){const se=X.onDidChangeCodeLenses(Fe=>this.e.$emitCodeLensEvent(J));te=O.$$J.from(te,se)}return te}$provideCodeLenses(T,H,X){return this.s(T,o,Y=>Y.provideCodeLenses(h.URI.revive(H),X),void 0,X)}$resolveCodeLens(T,H,X){return this.s(T,o,Y=>Y.resolveCodeLens(H,X),void 0,void 0)}$releaseCodeLenses(T,H){this.s(T,o,X=>Promise.resolve(X.releaseCodeLenses(H)),void 0,void 0)}registerDefinitionProvider(T,H,X){const Y=this.t(new g(this.h,X),T);return this.e.$registerDefinitionSupport(Y,this.o(H,T)),this.p(Y)}$provideDefinition(T,H,X,Y){return this.s(T,g,J=>J.provideDefinition(h.URI.revive(H),X,Y),[],Y)}registerDeclarationProvider(T,H,X){const Y=this.t(new E(this.h,X),T);return this.e.$registerDeclarationSupport(Y,this.o(H,T)),this.p(Y)}$provideDeclaration(T,H,X,Y){return this.s(T,E,J=>J.provideDeclaration(h.URI.revive(H),X,Y),[],Y)}registerImplementationProvider(T,H,X){const Y=this.t(new P(this.h,X),T);return this.e.$registerImplementationSupport(Y,this.o(H,T)),this.p(Y)}$provideImplementation(T,H,X,Y){return this.s(T,P,J=>J.provideImplementation(h.URI.revive(H),X,Y),[],Y)}registerTypeDefinitionProvider(T,H,X){const Y=this.t(new l(this.h,X),T);return this.e.$registerTypeDefinitionSupport(Y,this.o(H,T)),this.p(Y)}$provideTypeDefinition(T,H,X,Y){return this.s(T,l,J=>J.provideTypeDefinition(h.URI.revive(H),X,Y),[],Y)}registerHoverProvider(T,H,X,Y){const J=this.t(new $(this.h,X),T);return this.e.$registerHoverProvider(J,this.o(H,T)),this.p(J)}$provideHover(T,H,X,Y){return this.s(T,$,J=>J.provideHover(h.URI.revive(H),X,Y),void 0,Y)}registerEvaluatableExpressionProvider(T,H,X,Y){const J=this.t(new b(this.h,X),T);return this.e.$registerEvaluatableExpressionProvider(J,this.o(H,T)),this.p(J)}$provideEvaluatableExpression(T,H,X,Y){return this.s(T,b,J=>J.provideEvaluatableExpression(h.URI.revive(H),X,Y),void 0,Y)}registerInlineValuesProvider(T,H,X,Y){const J=typeof X.onDidChangeInlineValues=="function"?this.q():void 0,te=this.t(new M(this.h,X),T);this.e.$registerInlineValuesProvider(te,this.o(H,T),J);let se=this.p(te);if(J!==void 0){const Fe=X.onDidChangeInlineValues(je=>this.e.$emitInlineValuesEvent(J));se=O.$$J.from(se,Fe)}return se}$provideInlineValues(T,H,X,Y,J){return this.s(T,M,te=>te.provideInlineValues(h.URI.revive(H),X,Y,J),void 0,J)}registerDocumentHighlightProvider(T,H,X){const Y=this.t(new U(this.h,X),T);return this.e.$registerDocumentHighlightProvider(Y,this.o(H,T)),this.p(Y)}$provideDocumentHighlights(T,H,X,Y){return this.s(T,U,J=>J.provideDocumentHighlights(h.URI.revive(H),X,Y),void 0,Y)}registerLinkedEditingRangeProvider(T,H,X){const Y=this.t(new F(this.h,X),T);return this.e.$registerLinkedEditingRangeProvider(Y,this.o(H,T)),this.p(Y)}$provideLinkedEditingRanges(T,H,X,Y){return this.s(T,F,async J=>{const te=await J.provideLinkedEditingRanges(h.URI.revive(H),X,Y);if(te)return{ranges:te.ranges,wordPattern:te.wordPattern?pe.w(te.wordPattern):void 0}},void 0,Y)}registerReferenceProvider(T,H,X){const Y=this.t(new q(this.h,X),T);return this.e.$registerReferenceSupport(Y,this.o(H,T)),this.p(Y)}$provideReferences(T,H,X,Y,J){return this.s(T,q,te=>te.provideReferences(h.URI.revive(H),X,Y,J),void 0,J)}registerCodeActionProvider(T,H,X,Y){const J=new f.$Pc,te=this.t(new W(this.h,this.j.converter,this.k,X,this.l,T,this.m),T);return this.e.$registerQuickFixSupport(te,this.o(H,T),{providedKinds:Y?.providedCodeActionKinds?.map(se=>se.value),documentation:Y?.documentation?.map(se=>({kind:se.kind.value,command:this.j.converter.toInternal(se.command,J)}))},pe.u(T),!!X.resolveCodeAction),J.add(this.p(te)),J}$provideCodeActions(T,H,X,Y,J){return this.s(T,W,te=>te.provideCodeActions(h.URI.revive(H),X,Y,J),void 0,J)}$resolveCodeAction(T,H,X){return this.s(T,W,Y=>Y.resolveCodeAction(H,X),{},void 0)}$releaseCodeActions(T,H){this.s(T,W,X=>Promise.resolve(X.releaseCodeActions(H)),void 0,void 0)}registerDocumentFormattingEditProvider(T,H,X){const Y=this.t(new z(this.h,X),T);return this.e.$registerDocumentFormattingSupport(Y,this.o(H,T),T.identifier,T.displayName||T.name),this.p(Y)}$provideDocumentFormattingEdits(T,H,X,Y){return this.s(T,z,J=>J.provideDocumentFormattingEdits(h.URI.revive(H),X,Y),void 0,Y)}registerDocumentRangeFormattingEditProvider(T,H,X){const Y=typeof X.provideDocumentRangesFormattingEdits=="function",J=this.t(new K(this.h,X),T);return this.e.$registerRangeFormattingSupport(J,this.o(H,T),T.identifier,T.displayName||T.name,Y),this.p(J)}$provideDocumentRangeFormattingEdits(T,H,X,Y,J){return this.s(T,K,te=>te.provideDocumentRangeFormattingEdits(h.URI.revive(H),X,Y,J),void 0,J)}$provideDocumentRangesFormattingEdits(T,H,X,Y,J){return this.s(T,K,te=>te.provideDocumentRangesFormattingEdits(h.URI.revive(H),X,Y,J),void 0,J)}registerOnTypeFormattingEditProvider(T,H,X,Y){const J=this.t(new B(this.h,X),T);return this.e.$registerOnTypeFormattingSupport(J,this.o(H,T),Y,T.identifier),this.p(J)}$provideOnTypeFormattingEdits(T,H,X,Y,J,te){return this.s(T,B,se=>se.provideOnTypeFormattingEdits(h.URI.revive(H),X,Y,J,te),void 0,te)}registerWorkspaceSymbolProvider(T,H){const X=this.t(new me(H,this.l),T);return this.e.$registerNavigateTypeSupport(X,typeof H.resolveWorkspaceSymbol=="function"),this.p(X)}$provideWorkspaceSymbols(T,H,X){return this.s(T,me,Y=>Y.provideWorkspaceSymbols(H,X),{symbols:[]},X)}$resolveWorkspaceSymbol(T,H,X){return this.s(T,me,Y=>Y.resolveWorkspaceSymbol(H,X),void 0,void 0)}$releaseWorkspaceSymbols(T,H){this.s(T,me,X=>X.releaseWorkspaceSymbols(H),void 0,void 0)}registerRenameProvider(T,H,X){const Y=this.t(new ye(this.h,X,this.l),T);return this.e.$registerRenameSupport(Y,this.o(H,T),ye.supportsResolving(X)),this.p(Y)}$provideRenameEdits(T,H,X,Y,J){return this.s(T,ye,te=>te.provideRenameEdits(h.URI.revive(H),X,Y,J),void 0,J)}$resolveRenameLocation(T,H,X,Y){return this.s(T,ye,J=>J.resolveRenameLocation(h.URI.revive(H),X,Y),void 0,Y)}registerDocumentSemanticTokensProvider(T,H,X,Y){const J=this.t(new _(this.h,X),T),te=typeof X.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(J,this.o(H,T),Y,te);let se=this.p(J);if(te){const Fe=X.onDidChangeSemanticTokens(je=>this.e.$emitDocumentSemanticTokensEvent(te));se=O.$$J.from(se,Fe)}return se}$provideDocumentSemanticTokens(T,H,X,Y){return this.s(T,_,J=>J.provideDocumentSemanticTokens(h.URI.revive(H),X,Y),null,Y)}$releaseDocumentSemanticTokens(T,H){this.s(T,_,X=>X.releaseDocumentSemanticColoring(H),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(T,H,X,Y){const J=this.t(new de(this.h,X),T);return this.e.$registerDocumentRangeSemanticTokensProvider(J,this.o(H,T),Y),this.p(J)}$provideDocumentRangeSemanticTokens(T,H,X,Y){return this.s(T,de,J=>J.provideDocumentRangeSemanticTokens(h.URI.revive(H),X,Y),null,Y)}registerCompletionItemProvider(T,H,X,Y){const J=this.t(new De(this.h,this.j.converter,X,this.m,T),T);return this.e.$registerCompletionsProvider(J,this.o(H,T),Y,De.supportsResolving(X),T.identifier),this.p(J)}$provideCompletionItems(T,H,X,Y,J){return this.s(T,De,te=>te.provideCompletionItems(h.URI.revive(H),X,Y,J),void 0,J)}$resolveCompletionItem(T,H,X){return this.s(T,De,Y=>Y.resolveCompletionItem(H,X),void 0,X)}$releaseCompletionItems(T,H){this.s(T,De,X=>X.releaseCompletionItems(H),void 0,void 0)}registerInlineCompletionsProvider(T,H,X,Y){const J=new ve(T,this.h,X,this.j.converter),te=this.t(J,T);return this.e.$registerInlineCompletionsSupport(te,this.o(H,T),J.supportsHandleEvents,m.$Xl.toKey(T.identifier.value),Y?.yieldTo?.map(se=>m.$Xl.toKey(se))||[]),this.p(te)}$provideInlineCompletions(T,H,X,Y,J){return this.s(T,ue,te=>te.provideInlineCompletions(h.URI.revive(H),X,Y,J),void 0,J)}$handleInlineCompletionDidShow(T,H,X,Y){this.s(T,ue,async J=>{J.handleDidShowCompletionItem(H,X,Y)},void 0,void 0)}$handleInlineCompletionPartialAccept(T,H,X,Y){this.s(T,ue,async J=>{J.handlePartialAccept(H,X,Y)},void 0,void 0)}$freeInlineCompletionsList(T,H){this.s(T,ue,async X=>{X.disposeCompletions(H)},void 0,void 0)}registerSignatureHelpProvider(T,H,X,Y){const J=Array.isArray(Y)?{triggerCharacters:Y,retriggerCharacters:[]}:Y,te=this.t(new V(this.h,X),T);return this.e.$registerSignatureHelpProvider(te,this.o(H,T),J),this.p(te)}$provideSignatureHelp(T,H,X,Y,J){return this.s(T,V,te=>te.provideSignatureHelp(h.URI.revive(H),X,Y,J),void 0,J)}$releaseSignatureHelp(T,H){this.s(T,V,X=>X.releaseSignatureHelp(H),void 0,void 0)}registerInlayHintsProvider(T,H,X){const Y=typeof X.onDidChangeInlayHints=="function"?this.q():void 0,J=this.t(new Q(this.h,this.j.converter,X,this.l,T),T);this.e.$registerInlayHintsProvider(J,this.o(H,T),typeof X.resolveInlayHint=="function",Y,pe.u(T));let te=this.p(J);if(Y!==void 0){const se=X.onDidChangeInlayHints(Fe=>this.e.$emitInlayHintsEvent(Y));te=O.$$J.from(te,se)}return te}$provideInlayHints(T,H,X,Y){return this.s(T,Q,J=>J.provideInlayHints(h.URI.revive(H),X,Y),void 0,Y)}$resolveInlayHint(T,H,X){return this.s(T,Q,Y=>Y.resolveInlayHint(H,X),void 0,X)}$releaseInlayHints(T,H){this.s(T,Q,X=>X.releaseHints(H),void 0,void 0)}registerDocumentLinkProvider(T,H,X){const Y=this.t(new ee(this.h,X),T);return this.e.$registerDocumentLinkProvider(Y,this.o(H,T),typeof X.resolveDocumentLink=="function"),this.p(Y)}$provideDocumentLinks(T,H,X){return this.s(T,ee,Y=>Y.provideLinks(h.URI.revive(H),X),void 0,X,H.scheme==="output")}$resolveDocumentLink(T,H,X){return this.s(T,ee,Y=>Y.resolveLink(H,X),void 0,void 0,!0)}$releaseDocumentLinks(T,H){this.s(T,ee,X=>X.releaseLinks(H),void 0,void 0,!0)}registerColorProvider(T,H,X){const Y=this.t(new $e(this.h,X),T);return this.e.$registerDocumentColorProvider(Y,this.o(H,T)),this.p(Y)}$provideDocumentColors(T,H,X){return this.s(T,$e,Y=>Y.provideColors(h.URI.revive(H),X),[],X)}$provideColorPresentations(T,H,X,Y){return this.s(T,$e,J=>J.provideColorPresentations(h.URI.revive(H),X,Y),void 0,Y)}registerFoldingRangeProvider(T,H,X){const Y=this.q(),J=typeof X.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(Y,new ae(new he(this.h,X),T)),this.e.$registerFoldingRangeProvider(Y,this.o(H,T),T.identifier,J);let te=this.p(Y);if(J!==void 0){const se=X.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(J));te=O.$$J.from(te,se)}return te}$provideFoldingRanges(T,H,X,Y){return this.s(T,he,J=>J.provideFoldingRanges(h.URI.revive(H),X,Y),void 0,Y)}registerSelectionRangeProvider(T,H,X){const Y=this.t(new fe(this.h,X,this.l),T);return this.e.$registerSelectionRangeProvider(Y,this.o(H,T)),this.p(Y)}$provideSelectionRanges(T,H,X,Y){return this.s(T,fe,J=>J.provideSelectionRanges(h.URI.revive(H),X,Y),[],Y)}registerCallHierarchyProvider(T,H,X){const Y=this.t(new Ee(this.h,X),T);return this.e.$registerCallHierarchyProvider(Y,this.o(H,T)),this.p(Y)}$prepareCallHierarchy(T,H,X,Y){return this.s(T,Ee,J=>Promise.resolve(J.prepareSession(h.URI.revive(H),X,Y)),void 0,Y)}$provideCallHierarchyIncomingCalls(T,H,X,Y){return this.s(T,Ee,J=>J.provideCallsTo(H,X,Y),void 0,Y)}$provideCallHierarchyOutgoingCalls(T,H,X,Y){return this.s(T,Ee,J=>J.provideCallsFrom(H,X,Y),void 0,Y)}$releaseCallHierarchy(T,H){this.s(T,Ee,X=>Promise.resolve(X.releaseSession(H)),void 0,void 0)}registerTypeHierarchyProvider(T,H,X){const Y=this.t(new re(this.h,X),T);return this.e.$registerTypeHierarchyProvider(Y,this.o(H,T)),this.p(Y)}$prepareTypeHierarchy(T,H,X,Y){return this.s(T,re,J=>Promise.resolve(J.prepareSession(h.URI.revive(H),X,Y)),void 0,Y)}$provideTypeHierarchySupertypes(T,H,X,Y){return this.s(T,re,J=>J.provideSupertypes(H,X,Y),void 0,Y)}$provideTypeHierarchySubtypes(T,H,X,Y){return this.s(T,re,J=>J.provideSubtypes(H,X,Y),void 0,Y)}$releaseTypeHierarchy(T,H){this.s(T,re,X=>Promise.resolve(X.releaseSession(H)),void 0,void 0)}registerDocumentOnDropEditProvider(T,H,X,Y){const J=this.q();this.f.set(J,new ae(new le(this.e,this.h,X,J,T),T));const te=(0,n.$7E)(T,"dropMetadata")&&Y?le.toInternalProviderId(T.identifier.value,Y.id):void 0;return this.e.$registerDocumentOnDropEditProvider(J,this.o(H,T),te,(0,n.$7E)(T,"dropMetadata")?Y:void 0),this.p(J)}$provideDocumentOnDropEdits(T,H,X,Y,J,te){return this.s(T,le,se=>Promise.resolve(se.provideDocumentOnDropEdits(H,h.URI.revive(X),Y,J,te)),void 0,void 0)}registerMappedEditsProvider(T,H,X){const Y=this.t(new oe(this.h,X),T);return this.e.$registerMappedEditsProvider(Y,this.o(H,T)),this.p(Y)}$provideMappedEdits(T,H,X,Y,J){return this.s(T,oe,te=>Promise.resolve(te.provideMappedEdits(H,X,Y,J)),null,J)}registerDocumentPasteEditProvider(T,H,X,Y){const J=this.q();this.f.set(J,new ae(new L(this.e,this.h,X,J,T),T));const te=L.toInternalProviderId(T.identifier.value,Y.id);return this.e.$registerPasteEditProvider(J,this.o(H,T),te,{supportsCopy:!!X.prepareDocumentPaste,supportsPaste:!!X.provideDocumentPasteEdits,copyMimeTypes:Y.copyMimeTypes,pasteMimeTypes:Y.pasteMimeTypes}),this.p(J)}$prepareDocumentPaste(T,H,X,Y,J){return this.s(T,L,te=>te.prepareDocumentPaste(h.URI.revive(H),X,Y,J),void 0,J)}$providePasteEdits(T,H,X,Y,J,te){return this.s(T,L,se=>se.providePasteEdits(H,h.URI.revive(X),Y,J,te),void 0,te)}static w(T){return{pattern:T.source,flags:T.flags}}static y(T){return{decreaseIndentPattern:pe.w(T.decreaseIndentPattern),increaseIndentPattern:pe.w(T.increaseIndentPattern),indentNextLinePattern:T.indentNextLinePattern?pe.w(T.indentNextLinePattern):void 0,unIndentedLinePattern:T.unIndentedLinePattern?pe.w(T.unIndentedLinePattern):void 0}}static z(T){return{beforeText:pe.w(T.beforeText),afterText:T.afterText?pe.w(T.afterText):void 0,previousLineText:T.previousLineText?pe.w(T.previousLineText):void 0,action:T.action}}static B(T){return T.map(pe.z)}static C(T){return{open:T.open,close:T.close,notIn:T.notIn?T.notIn.map(H=>O.SyntaxTokenType.toString(H)):void 0}}static D(T){return T.map(pe.C)}setLanguageConfiguration(T,H,X){const{wordPattern:Y}=X;if(Y&&(0,D.$Me)(Y))throw new Error(`Invalid language configuration: wordPattern '${Y}' is not allowed to match the empty string.`);Y?this.h.setWordDefinitionFor(H,Y):this.h.setWordDefinitionFor(H,void 0),X.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",T,"Do not use."),X.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",T,"Do not use.");const J=this.q(),te={comments:X.comments,brackets:X.brackets,wordPattern:X.wordPattern?pe.w(X.wordPattern):void 0,indentationRules:X.indentationRules?pe.y(X.indentationRules):void 0,onEnterRules:X.onEnterRules?pe.B(X.onEnterRules):void 0,__electricCharacterSupport:X.__electricCharacterSupport,__characterPairSupport:X.__characterPairSupport,autoClosingPairs:X.autoClosingPairs?pe.D(X.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(J,H,te),this.p(J)}$setWordDefinitions(T){for(const H of T)this.h.setWordDefinitionFor(H.languageId,new RegExp(H.regexSource,H.regexFlags))}}e.$Fbc=pe,pe.d=0}),define(Ae[241],Re([1,0,3,8,7,29,12,6]),function(ie,e,h,C,I,O,R,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ncc=void 0;class D{constructor(A,k,a,w){this.c=k,this.d=a,this.e=w,this.b=[],this.f=0,this.g=new Set,this.a=A.getProxy(h.$9J.MainThreadLanguages)}$acceptLanguageIds(A){this.b=A}async getLanguages(){return this.b.slice(0)}async changeLanguage(A,k){await this.a.$changeLanguage(A,k);const a=this.c.getDocumentData(A);if(!a)throw new Error(`document '${A.toString()}' NOT found`);return a.document}async tokenAtPosition(A,k){const a=A.version,w=C.Position.from(k),m=await this.a.$tokensAtPosition(A.uri,w),f={type:I.StandardTokenType.Other,range:A.getWordRangeAtPosition(k)??new I.$aK(k.line,k.character,k.line,k.character)};if(!m)return f;const t={range:C.Range.to(m.range),type:C.TokenType.to(m.type)};return!t.range.contains(k)||a!==A.version?f:t}createLanguageStatusItem(A,k,a){const w=this.f++,m=this.a,f=this.g,t=`${A.identifier.value}/${k}`;if(f.has(t))throw new Error(`LanguageStatusItem with id '${k}' ALREADY exists`);f.add(t);const s={selector:a,id:k,name:A.displayName??A.name,severity:I.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let c;const v=new u.$Pc,S=()=>{if(c?.dispose(),!f.has(t)){console.warn(`LanguageStatusItem (${k}) from ${A.identifier.value} has been disposed and CANNOT be updated anymore`);return}c=(0,R.$Sg)(()=>{v.clear(),this.a.$setLanguageStatus(w,{id:t,name:s.name??A.displayName??A.name,source:A.displayName??A.name,selector:C.DocumentSelector.from(s.selector,this.e),label:s.text,detail:s.detail??"",severity:s.severity===I.LanguageStatusSeverity.Error?O.default.Error:s.severity===I.LanguageStatusSeverity.Warning?O.default.Warning:O.default.Info,command:s.command&&this.d.toInternal(s.command,v),accessibilityInfo:s.accessibilityInformation,busy:s.busy})},0)},p={dispose(){v.dispose(),c?.dispose(),m.$removeLanguageStatus(w),f.delete(t)},get id(){return s.id},get name(){return s.name},set name(n){s.name=n,S()},get selector(){return s.selector},set selector(n){s.selector=n,S()},get text(){return s.text},set text(n){s.text=n,S()},get detail(){return s.detail},set detail(n){s.detail=n,S()},get severity(){return s.severity},set severity(n){s.severity=n,S()},get accessibilityInformation(){return s.accessibilityInformation},set accessibilityInformation(n){s.accessibilityInformation=n,S()},get command(){return s.command},set command(n){s.command=n,S()},get busy(){return s.busy},set busy(n){s.busy=n,S()}};return S(),p}}e.$ncc=D}),define(Ae[81],Re([1,0,22,15,2,4,14,3,27,17]),function(ie,e,h,C,I,O,R,u,D,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dcc=e.$ccc=void 0;let A=class{constructor(a,w,m){this.f=m,this.d=new Map,this.a=w.getProxy(u.$9J.MainThreadLocalization),this.b=a.environment.appLanguage,this.c=this.b===h.$a}getMessage(a,w){const{message:m,args:f,comment:t}=w;if(this.c)return(0,C.$Be)(m,f??{});let s=m;t&&t.length>0&&(s+=`/${Array.isArray(t)?t.join(""):t}`);const c=this.d.get(a)?.contents[s];return c||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${s}`),(0,C.$Be)(c??m,f??{})}getBundle(a){return this.d.get(a)?.contents}getBundleUri(a){return this.d.get(a)?.uri}async initializeLocalizedMessages(a){if(this.c||!a.l10n&&!a.isBuiltin||this.d.has(a.identifier.value))return;let w;const m=await this.g(a);if(!m){this.f.error(`No bundle location found for extension ${a.identifier.value}`);return}try{const f=await this.a.$fetchBundleContents(m),t=JSON.parse(f);w=a.isBuiltin?t.contents?.bundle:t}catch(f){this.f.error(`Failed to load translations for ${a.identifier.value} from ${m}: ${f.message}`);return}w&&this.d.set(a.identifier.value,{contents:w,uri:m})}async g(a){if(a.isBuiltin){const w=await this.a.$fetchBuiltInBundleUri(a.identifier.value,this.b);return I.URI.revive(w)}return a.l10n?I.URI.joinPath(a.extensionLocation,a.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$ccc=A,e.$ccc=A=Je([qe(0,D.$nM),qe(1,d.$0L),qe(2,R.$6i)],A),e.$dcc=(0,O.$Lh)("IExtHostLocalizationService")}),define(Ae[242],Re([1,0,14,3,27,17,2,68]),function(ie,e,h,C,I,O,R,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Edc=void 0;let D=class extends h.$ej{constructor(k,a){super(a.logLevel,a.logsLocation,a.loggers.map(w=>(0,u.$ih)(w))),this.r=k.getProxy(C.$9J.MainThreadLogger)}$setLogLevel(k,a){a?this.setLogLevel(R.URI.revive(a),k):this.setLogLevel(k)}setVisibility(k,a){super.setVisibility(k,a),this.r.$setVisibility(k,a)}s(k,a,w){return new d(this.r,k,a,w)}};e.$Edc=D,e.$Edc=D=Je([qe(0,O.$0L),qe(1,I.$nM)],D);class d extends h.$_i{constructor(k,a,w,m){super(m?.logLevel==="always"),this.r=k,this.s=a,this.m=!1,this.n=[],this.setLevel(w),this.r.$createLogger(a,m).then(()=>{this.u(this.n),this.m=!0})}g(k,a){const w=[[k,a]];this.m?this.u(w):this.n.push(...w)}u(k){this.r.$log(this.s,k)}flush(){this.r.$flush(this.s)}}}),define(Ae[82],Re([1,0,3,4,6,17,25]),function(ie,e,h,C,I,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fcc=e.$ecc=void 0,e.$ecc=(0,C.$Lh)("IExtHostManagedSockets");let u=class{constructor(k){this.b=0,this.c=null,this.d=new Map,this.a=k.getProxy(h.$9J.MainThreadManagedSockets)}setFactory(k,a){for(const w of this.d.values())w.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new D(k,a),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(k){if(!this.c||this.c.socketFactoryId!==k)throw new Error(`No socket factory with id ${k}`);const a=++this.b,w=await this.c.makeConnection(),m=new I.$Pc;return this.d.set(a,new d(a,w,m)),m.add((0,I.$Oc)(()=>this.d.delete(a))),m.add(w.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(a),m.dispose()})),m.add(w.onDidClose(f=>{this.a.$onDidManagedSocketClose(a,f?.stack??f?.message),m.dispose()})),m.add(w.onDidReceiveMessage(f=>this.a.$onDidManagedSocketHaveData(a,R.$_d.wrap(f)))),a}$remoteSocketWrite(k,a){this.d.get(k)?.actual.send(a.buffer)}$remoteSocketEnd(k){const a=this.d.get(k);a&&(a.actual.end(),a.dispose())}async $remoteSocketDrain(k){await this.d.get(k)?.actual.drain?.()}};e.$fcc=u,e.$fcc=u=Je([qe(0,O.$0L)],u);class D{constructor(k,a){this.socketFactoryId=k,this.makeConnection=a}}class d extends I.$Qc{constructor(k,a,w){super(),this.socketId=k,this.actual=a,this.B(w)}}}),define(Ae[243],Re([1,0,3,14,26]),function(ie,e,h,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$occ=void 0;function O(u){return u&&u.title}let R=class{constructor(D,d){this.b=d,this.a=D.getProxy(h.$9J.MainThreadMessageService)}showMessage(D,d,A,k,a){const w={source:{identifier:D.identifier,label:D.displayName||D.name}};let m;typeof k=="string"||O(k)?m=[k,...a]:(w.modal=k?.modal,w.useCustom=k?.useCustom,w.detail=k?.detail,m=a),w.useCustom&&(0,I.$8E)(D,"resolvers");const f=[];for(let t=0;t<m.length;t++){const s=m[t];if(typeof s=="string")f.push({title:s,handle:t,isCloseAffordance:!1});else if(typeof s=="object"){const{title:c,isCloseAffordance:v}=s;f.push({title:c,isCloseAffordance:!!v,handle:t})}else this.b.warn("Invalid message item:",s)}return this.a.$showMessage(d,A,w,f).then(t=>{if(typeof t=="number")return m[t]})}};e.$occ=R,e.$occ=R=Je([qe(1,C.$6i)],R)}),define(Ae[244],Re([1,0,151,25,5,6,28,15,16,2,38,55,3,31,8,7,46,204,103,9,24,13]),function(ie,e,h,C,I,O,R,u,D,d,A,k,a,w,m,f,t,s,c,v,S,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9cc=void 0;class n{get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(i=>i.apiEditor)}constructor(i,o,y,g,E){this.q=y,this.r=g,this.s=E,this.f=new Map,this.g=new R.$yc,this.h=new Map,this.j=new I.$Ld({onListenerError:v.$Z}),this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new I.$Ld({onListenerError:v.$Z}),this.onDidOpenNotebookDocument=this.m.event,this.n=new I.$Ld({onListenerError:v.$Z}),this.onDidCloseNotebookDocument=this.n.event,this.o=new I.$Ld({onListenerError:v.$Z}),this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new k.$wbc("NotebookCellStatusBarCache"),this.u=0,this.w=new Map,this.b=i.getProxy(a.$9J.MainThreadNotebook),this.c=i.getProxy(a.$9J.MainThreadNotebookDocuments),this.d=i.getProxy(a.$9J.MainThreadNotebookEditors),this.i=o.converter,o.registerArgumentProcessor({processArgument:P=>{if(P&&P.$mid===13){const l=P.notebookEditor?.notebookUri,$=P.cell.handle,M=this.g.get(l)?.getCell($);if(M)return M.apiCell}if(P&&P.$mid===14){const l=P.uri,$=this.g.get(l);if($)return $.apiNotebook}return P}}),n.A(o)}getEditorById(i){const o=this.h.get(i);if(!o)throw new Error(`unknown text editor: ${i}. known editors: ${[...this.h.keys()]} `);return o}getIdByEditor(i){for(const[o,y]of this.h)if(y.apiEditor===i)return o}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(i,o){const y=this.g.get(i);if(!y&&!o)throw new Error(`NO notebook document for '${i}'`);return y}static t(i,o){if(!o)return;const y=o.filenamePattern.map(g=>m.NotebookExclusiveDocumentPattern.from(g)).filter(g=>g!==void 0);if(o.filenamePattern&&!y){console.warn(`Notebook content provider view options file name pattern is invalid ${o.filenamePattern}`);return}return{extension:i.identifier,providerDisplayName:i.displayName||i.name,displayName:o.displayName,filenamePattern:y,exclusive:o.exclusive||!1}}registerNotebookCellStatusBarItemProvider(i,o,y){const g=n.a++,E=typeof y.onDidChangeCellStatusBarItems=="function"?n.a++:void 0;this.f.set(g,y),this.b.$registerNotebookCellStatusBarItemProvider(g,E,o);let P;return E!==void 0&&(P=y.onDidChangeCellStatusBarItems(l=>this.b.$emitCellStatusBarEvent(E))),new f.$$J(()=>{this.f.delete(g),this.b.$unregisterNotebookCellStatusBarItemProvider(g,E),P?.dispose()})}async createNotebookDocument(i){const o=await this.c.$tryCreateNotebook({viewType:i.viewType,content:i.content&&m.NotebookData.from(i.content)});return d.URI.revive(o)}async openNotebookDocument(i){const o=this.g.get(i);if(o)return o.apiNotebook;const y=await this.c.$tryOpenNotebook(i),g=this.g.get(d.URI.revive(y));return(0,D.$Hf)(g?.apiNotebook)}async showNotebookDocument(i,o){d.URI.isUri(i)&&(i=await this.openNotebookDocument(i));let y;typeof o=="object"?y={position:m.ViewColumn.from(o.viewColumn),preserveFocus:o.preserveFocus,selections:o.selections&&o.selections.map(m.NotebookRange.from),pinned:typeof o.preview=="boolean"?!o.preview:void 0}:y={preserveFocus:!1};const g=await this.d.$tryShowNotebookDocument(i.uri,i.notebookType,y),E=g&&this.h.get(g)?.apiEditor;if(E)return E;throw g?new Error(`Could NOT open editor for "${i.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${i.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(i,o,y,g){const E=this.f.get(i),P=d.URI.revive(o),l=this.g.get(P);if(!l||!E)return;const $=l.getCellFromIndex(y);if(!$)return;const b=await E.provideCellStatusBarItems($.apiCell,g);if(!b)return;const M=new O.$Pc,U=this.p.add([M]),q=(Array.isArray(b)?b:[b]).map(W=>m.NotebookStatusBarItem.from(W,this.i,M));return{cacheId:U,items:q}}$releaseNotebookCellStatusBarItems(i){this.p.delete(i)}registerNotebookSerializer(i,o,y,g,E){if((0,u.$ze)(o))throw new Error("viewType cannot be empty or just whitespace");const P=this.u++;return this.w.set(P,{viewType:o,serializer:y,options:g}),this.b.$registerNotebookSerializer(P,{id:i.identifier,location:i.extensionLocation},o,m.NotebookDocumentContentOptions.from(g),n.t(i,E)),(0,O.$Oc)(()=>{this.b.$unregisterNotebookSerializer(P)})}async $dataToNotebook(i,o,y){const g=this.w.get(i);if(!g)throw new Error("NO serializer found");const E=await g.serializer.deserializeNotebook(o.buffer,y);return new t.$iv(m.NotebookData.from(E))}async $notebookToData(i,o,y){const g=this.w.get(i);if(!g)throw new Error("NO serializer found");const E=await g.serializer.serializeNotebook(m.NotebookData.to(o.value),y);return C.$_d.wrap(E)}async $saveNotebook(i,o,y,g,E){const P=d.URI.revive(o),l=this.w.get(i);if(!l)throw new Error("NO serializer found");const $=this.g.get(P);if(!$)throw new Error("Document NOT found");if($.versionId!==y)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(P.scheme))throw new A.$ok((0,h.localize)(0,null,this.y(P)),6);await this.x(P,g);const b={metadata:(0,S.$6m)($.apiNotebook.metadata,W=>!(l.options?.transientDocumentMetadata??{})[W]),cells:[]};for(const W of $.apiNotebook.getCells()){const L=new f.$wL(W.kind,W.document.getText(),W.document.languageId,W.mime,l.options?.transientOutputs?[]:[...W.outputs],W.metadata,W.executionSummary);L.metadata=(0,S.$6m)(W.metadata,z=>!(l.options?.transientCellMetadata??{})[z]),b.cells.push(L)}const M=await l.serializer.serializeNotebook(b,E);await this.s.value.writeFile(P,M);const U=this.s.getFileSystemProviderExtUri(P.scheme),F=await this.s.value.stat(P);return{name:U.basename(P),isFile:(F.type&A.FileType.File)!==0,isDirectory:(F.type&A.FileType.Directory)!==0,isSymbolicLink:(F.type&A.FileType.SymbolicLink)!==0,mtime:F.mtime,ctime:F.ctime,size:F.size,readonly:!!((F.permissions??0)&A.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(P.scheme),locked:!!((F.permissions??0)&A.FilePermission.Locked),etag:A.$zk({mtime:F.mtime,size:F.size}),children:void 0}}async x(i,o){const y=await this.s.value.stat(i);if(typeof o?.mtime=="number"&&typeof o.etag=="string"&&o.etag!==A.$yk&&typeof y.mtime=="number"&&typeof y.size=="number"&&o.mtime<y.mtime&&o.etag!==A.$zk({mtime:o.mtime,size:y.size}))throw new A.$ok((0,h.localize)(1,null),3,o)}y(i){return i.scheme===p.Schemas.file?i.fsPath:i.toString()}z(i,o,y){if(this.h.has(o))throw new Error(`editor with id ALREADY EXSIST: ${o}`);const g=new c.$8cc(o,this.d,i,y.visibleRanges.map(m.NotebookRange.to),y.selections.map(m.NotebookRange.to),typeof y.viewColumn=="number"?m.ViewColumn.to(y.viewColumn):void 0);this.h.set(o,g)}$acceptDocumentAndEditorsDelta(i){if(i.value.removedDocuments)for(const y of i.value.removedDocuments){const g=d.URI.revive(y),E=this.g.get(g);E&&(E.dispose(),this.g.delete(g),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:E.apiNotebook.getCells().map(P=>P.document.uri)}),this.n.fire(E.apiNotebook));for(const P of this.h.values())P.notebookData.uri.toString()===g.toString()&&this.h.delete(P.id)}if(i.value.addedDocuments){const y=[];for(const g of i.value.addedDocuments){const E=d.URI.revive(g.uri);if(this.g.has(E))throw new Error(`adding EXISTING notebook ${E} `);const P=new s.$7cc(this.c,this.q,this.r,E,g);y.push(...g.cells.map(l=>s.$6cc.asModelAddData(P.apiNotebook,l))),this.g.get(E)?.dispose(),this.g.set(E,P),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:y}),this.m.fire(P.apiNotebook)}}if(i.value.addedEditors)for(const y of i.value.addedEditors){if(this.h.has(y.id))return;const g=d.URI.revive(y.documentUri),E=this.g.get(g);E&&this.z(E,y.id,y)}const o=[];if(i.value.removedEditors)for(const y of i.value.removedEditors){const g=this.h.get(y);g&&(this.h.delete(y),this.k?.id===g.id&&(this.k=void 0),o.push(g))}if(i.value.visibleEditors){this.l=i.value.visibleEditors.map(g=>this.h.get(g)).filter(g=>!!g);const y=new Set;this.l.forEach(g=>y.add(g.id));for(const g of this.h.values()){const E=y.has(g.id);g._acceptVisibility(E)}this.l=[...this.h.values()].map(g=>g).filter(g=>g.visible),this.o.fire(this.visibleNotebookEditors)}i.value.newActiveEditor===null?this.k=void 0:i.value.newActiveEditor&&(this.h.get(i.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${i.value.newActiveEditor}`),this.k=this.h.get(i.value.newActiveEditor)),i.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static A(i){const o=w.$vM.String.with("notebookType","A notebook type"),y=new w.$xM("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[o,new w.$vM("data","Bytes to convert to data",E=>E instanceof Uint8Array,E=>C.$_d.wrap(E))],new w.$wM("Notebook Data",E=>m.NotebookData.to(E.value))),g=new w.$xM("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[o,new w.$vM("NotebookData","Notebook data to convert to bytes",E=>!0,E=>new t.$iv(m.NotebookData.from(E)))],new w.$wM("Bytes",E=>E.buffer));i.registerApiCommand(y),i.registerApiCommand(g)}}e.$9cc=n,n.a=0}),define(Ae[245],Re([1,0,18,12,21,5,6,28,2,20,14,55,3,31,8,7,77,197,26,46]),function(ie,e,h,C,I,O,R,u,D,d,A,k,a,w,m,f,t,s,c,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ldc=e.$kdc=void 0;let S=class{constructor(E,P,l,$,b){this.m=P,this.n=l,this.o=$,this.q=b,this.b=new u.$yc,this.c=new u.$yc,this.e=new Map,this.f=0,this.g=new Map,this.h=0,this.i=new k.$wbc("NotebookKernelSourceActionProviderCache"),this.j=new Map,this.k=0,this.l=new O.$Ld,this.onDidChangeNotebookCellExecutionState=this.l.event,this.a=E.getProxy(a.$9J.MainThreadNotebookKernels);const M=new w.$xM("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new w.$vM("options","Select kernel options",U=>!0,U=>{if(U&&"notebookEditor"in U&&"id"in U){const F=this.n.getIdByEditor(U.notebookEditor);return{id:U.id,extension:U.extension,notebookEditorId:F}}else if(U&&"notebookEditor"in U){const F=this.n.getIdByEditor(U.notebookEditor);if(F===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${U.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:F}}return U})],w.$wM.Void);this.o.registerApiCommand(M)}createNotebookController(E,P,l,$,b,M){for(const De of this.j.values())if(De.controller.id===P&&d.$Xl.equals(E.identifier,De.extensionId))throw new Error(`notebook controller with id '${P}' ALREADY exist`);const U=this.k++,F=this;this.q.trace(`NotebookController[${U}], CREATED by ${E.identifier.value}, ${P}`);const q=()=>console.warn(`NO execute handler from notebook controller '${K.id}' of extension: '${E.identifier}'`);let W=!1;const L=new O.$Ld,z=new O.$Ld,K={id:y(E.identifier,P),notebookType:l,extensionId:E.identifier,extensionLocation:E.extensionLocation,label:$||E.identifier.value,preloads:M?M.map(m.NotebookRendererScript.from):[]};let B=b??q,me;this.a.$addKernel(U,K).catch(De=>{console.log(De),W=!0});let ye=0;const Ie=()=>{if(W)return;const De=++ye;Promise.resolve().then(()=>{De===ye&&this.a.$updateKernel(U,K)})},_=new u.$yc,de={get id(){return P},get notebookType(){return K.notebookType},onDidChangeSelectedNotebooks:L.event,get label(){return K.label},set label(De){K.label=De??E.displayName??E.name,Ie()},get detail(){return K.detail??""},set detail(De){K.detail=De,Ie()},get description(){return K.description??""},set description(De){K.description=De,Ie()},get supportedLanguages(){return K.supportedLanguages},set supportedLanguages(De){K.supportedLanguages=De,Ie()},get supportsExecutionOrder(){return K.supportsExecutionOrder??!1},set supportsExecutionOrder(De){K.supportsExecutionOrder=De,Ie()},get rendererScripts(){return K.preloads?K.preloads.map(m.NotebookRendererScript.to):[]},get executeHandler(){return B},set executeHandler(De){B=De??q},get interruptHandler(){return me},set interruptHandler(De){me=De,K.supportsInterrupt=!!De,Ie()},createNotebookCellExecution(De){if(W)throw new Error("notebook controller is DISPOSED");if(!_.has(De.notebook.uri))throw F.q.trace(`NotebookController[${U}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(_.keys()).map(ue=>ue.toString())),new Error(`notebook controller is NOT associated to notebook: ${De.notebook.uri.toString()}`);return F._createNotebookCellExecution(De,y(E.identifier,this.id))},createNotebookExecution(De){if((0,c.$8E)(E,"notebookExecution"),W)throw new Error("notebook controller is DISPOSED");if(!_.has(De.uri))throw F.q.trace(`NotebookController[${U}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(_.keys()).map(ue=>ue.toString())),new Error(`notebook controller is NOT associated to notebook: ${De.uri.toString()}`);return F._createNotebookExecution(De,y(E.identifier,this.id))},dispose:()=>{W||(this.q.trace(`NotebookController[${U}], DISPOSED`),W=!0,this.j.delete(U),L.dispose(),z.dispose(),this.a.$removeKernel(U))},updateNotebookAffinity(De,ue){ue===f.NotebookControllerAffinity2.Hidden&&(0,c.$8E)(E,"notebookControllerAffinityHidden"),F.a.$updateNotebookPriority(U,De.uri,ue)},onDidReceiveMessage:z.event,postMessage(De,ue){return(0,c.$8E)(E,"notebookMessaging"),F.a.$postMessage(U,ue&&F.n.getIdByEditor(ue),De)},asWebviewUri(De){return(0,c.$8E)(E,"notebookMessaging"),(0,t.$Yob)(De,F.m.remote)}};return this.j.set(U,{extensionId:E.identifier,controller:de,onDidReceiveMessage:z,onDidChangeSelection:L,associatedNotebooks:_}),de}getIdByController(E){for(const[P,l]of this.j)if(l.controller===E)return y(l.extensionId,E.id);return null}createNotebookControllerDetectionTask(E,P){const l=this.f++,$=this;this.q.trace(`NotebookControllerDetectionTask[${l}], CREATED by ${E.identifier.value}`),this.a.$addKernelDetectionTask(l,P);const b={dispose:()=>{this.e.delete(l),$.a.$removeKernelDetectionTask(l)}};return this.e.set(l,b),b}registerKernelSourceActionProvider(E,P,l){const $=this.h++,b=typeof l.onDidChangeNotebookKernelSourceActions=="function"?$:void 0,M=this;this.g.set($,l),this.q.trace(`NotebookKernelSourceActionProvider[${$}], CREATED by ${E.identifier.value}`),this.a.$addKernelSourceActionProvider($,$,P);let U;return b!==void 0&&(U=l.onDidChangeNotebookKernelSourceActions(F=>this.a.$emitNotebookKernelSourceActionsChangeEvent(b))),{dispose:()=>{this.g.delete($),M.a.$removeKernelSourceActionProvider($,$),U?.dispose()}}}async $provideKernelSourceActions(E,P){const l=this.g.get(E);if(l){const $=new R.$Pc;return this.i.add([$]),(await l.provideNotebookKernelSourceActions(P)??[]).map(M=>m.NotebookKernelSourceAction.from(M,this.o.converter,$))}return[]}$acceptNotebookAssociation(E,P,l){const $=this.j.get(E);if($){const b=this.n.getNotebookDocument(D.URI.revive(P));l?$.associatedNotebooks.set(b.uri,!0):$.associatedNotebooks.delete(b.uri),this.q.trace(`NotebookController[${E}] ASSOCIATE notebook`,b.uri.toString(),l),$.onDidChangeSelection.fire({selected:l,notebook:b.apiNotebook})}}async $executeCells(E,P,l){const $=this.j.get(E);if(!$)return;const b=this.n.getNotebookDocument(D.URI.revive(P)),M=[];for(const U of l){const F=b.getCell(U);F&&M.push(F.apiCell)}try{this.q.trace(`NotebookController[${E}] EXECUTE cells`,b.uri.toString(),M.length),await $.controller.executeHandler.call($.controller,M,b.apiNotebook,$.controller)}catch(U){this.q.error(`NotebookController[${E}] execute cells FAILED`,U),console.error(U)}}async $cancelCells(E,P,l){const $=this.j.get(E);if(!$)return;const b=this.n.getNotebookDocument(D.URI.revive(P));if($.controller.interruptHandler)await $.controller.interruptHandler.call($.controller,b.apiNotebook);else for(const M of l){const U=b.getCell(M);U&&this.b.get(U.uri)?.cancel()}if($.controller.interruptHandler){const M=this.c.get(b.uri);l.length&&Array.isArray(M)&&M.length&&M.forEach(U=>U.dispose())}}$acceptKernelMessageFromRenderer(E,P,l){const $=this.j.get(E);if(!$)return;const b=this.n.getEditorById(P);$.onDidReceiveMessage.fire(Object.freeze({editor:b.apiEditor,message:l}))}$cellExecutionChanged(E,P,l){const b=this.n.getNotebookDocument(D.URI.revive(E)).getCell(P);if(b){const M=l?m.NotebookCellExecutionState.to(l):f.NotebookCellExecutionState.Idle;M!==void 0&&this.l.fire({cell:b.apiCell,state:M})}}_createNotebookCellExecution(E,P){if(E.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const $=this.n.getNotebookDocument(E.notebook.uri).getCellFromApiCell(E);if(!$)throw new Error("invalid cell");if(this.b.has($.uri))throw new Error(`duplicate execution for ${$.uri}`);const b=new n(P,$,this.a);this.b.set($.uri,b);const M=b.onDidChangeState(()=>{b.state===p.Resolved&&(b.dispose(),M.dispose(),this.b.delete($.uri))});return b.asApiObject()}_createNotebookExecution(E,P){const l=this.n.getNotebookDocument(E.uri),$=E.getCells().find(U=>{const F=l.getCellFromApiCell(U);return F&&this.b.has(F.uri)});if($)throw new Error(`duplicate cell execution for ${$.document.uri}`);if(this.c.has(l.uri))throw new Error(`duplicate notebook execution for ${l.uri}`);const b=new i(P,l,this.a),M=b.onDidChangeState(()=>{b.state===r.Resolved&&(b.dispose(),M.dispose(),this.c.delete(l.uri))});return this.c.set(l.uri,[b,M]),b.asApiObject()}};e.$kdc=S,e.$kdc=S=Je([qe(4,A.$6i)],S);var p;(function(g){g[g.Init=0]="Init",g[g.Started=1]="Started",g[g.Resolved=2]="Resolved"})(p||(p={}));class n extends R.$Qc{get state(){return this.f}constructor(E,P,l){super(),this.m=P,this.n=l,this.b=n.a++,this.c=new O.$Ld,this.onDidChangeState=this.c.event,this.f=p.Init,this.g=this.B(new I.$Vd),this.h=new o(10,$=>this.s($)),this.j=P.internalMetadata.executionOrder,this.n.$createExecution(this.b,E,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(E){await this.h.addItem(E)}async s(E){const P=Array.isArray(E)?E:[E];return this.n.$updateExecution(this.b,new v.$iv(P))}t(){if(this.f===p.Init)throw new Error("Must call start before modifying cell output");if(this.f===p.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(E){let P=this.m;if(E&&(P=this.m.notebook.getCellFromApiCell(E)),!P)throw new Error("INVALID cell");return P.handle}y(E){return E.map(P=>{const l=f.$zL.ensureUniqueMimeTypes(P.items,!0);return l===P.items?m.NotebookCellOutput.from(P):m.NotebookCellOutput.from({items:l,id:P.id,metadata:P.metadata})})}async z(E,P,l){const $=this.w(P),b=this.y((0,h.$1b)(E));return this.r({editType:s.CellExecutionUpdateType.Output,cellHandle:$,append:l,outputs:b})}async C(E,P,l){return E=f.$zL.ensureUniqueMimeTypes((0,h.$1b)(E),!0),this.r({editType:s.CellExecutionUpdateType.OutputItems,items:E.map(m.NotebookCellOutputItem.from),outputId:P.id,append:l})}asApiObject(){const E=this;return Object.freeze({get token(){return E.g.token},get cell(){return E.m.apiCell},get executionOrder(){return E.j},set executionOrder(l){E.j=l,E.s([{editType:s.CellExecutionUpdateType.ExecutionState,executionOrder:E.j}])},start(l){if(E.f===p.Resolved||E.f===p.Started)throw new Error("Cannot call start again");E.f=p.Started,E.c.fire(),E.s({editType:s.CellExecutionUpdateType.ExecutionState,runStartTime:l})},end(l,$){if(E.f===p.Resolved)throw new Error("Cannot call resolve twice");E.f=p.Resolved,E.c.fire(),E.h.flush(),E.n.$completeExecution(E.b,new v.$iv({runEndTime:$,lastRunSuccess:l}))},clearOutput(l){return E.t(),E.z([],l,!1)},appendOutput(l,$){return E.t(),E.z(l,$,!0)},replaceOutput(l,$){return E.t(),E.z(l,$,!1)},appendOutputItems(l,$){return E.t(),E.C(l,$,!0)},replaceOutputItems(l,$){return E.t(),E.C(l,$,!1)}})}}n.a=0;var r;(function(g){g[g.Init=0]="Init",g[g.Started=1]="Started",g[g.Resolved=2]="Resolved"})(r||(r={}));class i extends R.$Qc{get state(){return this.f}constructor(E,P,l){super(),this.h=P,this.j=l,this.b=i.a++,this.c=new O.$Ld,this.onDidChangeState=this.c.event,this.f=r.Init,this.g=this.B(new I.$Vd),this.j.$createNotebookExecution(this.b,E,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===r.Resolved||this.f===r.Started)throw new Error("Cannot call start again");this.f=r.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===r.Resolved)throw new Error("Cannot call resolve twice");this.f=r.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}i.a=0;class o{constructor(E,P){this.e=E,this.f=P,this.a=[],this.b=Date.now()}addItem(E){return this.a.push(E),this.c||(this.c=new C.$_g,this.b=Date.now(),(0,C.$Rg)(this.e).then(()=>this.flush())),Date.now()-this.b>this.e?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const E=this.c;this.c=void 0;const P=this.a;return this.a=[],this.f(P).finally(()=>E.complete())}}function y(g,E){return`${g.value}/${E}`}e.$ldc=y}),define(Ae[246],Re([1,0,5,3,103]),function(ie,e,h,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mdc=void 0;class O{constructor(u,D){this.c=D,this.a=new Map,this.b=u.getProxy(C.$9J.MainThreadNotebookRenderers)}$postRendererMessage(u,D,d){const A=this.c.getEditorById(u);this.a.get(D)?.fire({editor:A.apiEditor,message:d})}createRendererMessaging(u,D){if(!u.contributes?.notebookRenderer?.some(A=>A.id===D))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${D})`);return{onDidReceiveMessage:(A,k,a)=>this.d(D).event(A,k,a),postMessage:(A,k)=>{I.$8cc.apiEditorsToExtHost.has(A)&&([A,k]=[k,A]);const a=k&&I.$8cc.apiEditorsToExtHost.get(k);return this.b.$postMessage(a?.id,D,A)}}}d(u){let D=this.a.get(u);return D||(D=new h.$Ld({onDidRemoveLastListener:()=>{D?.dispose(),this.a.delete(u)}}),this.a.set(u,D),D)}}e.$mdc=O}),define(Ae[247],Re([1,0,6,16,2,26,3]),function(ie,e,h,C,I,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qdc=void 0;class u{constructor(d){this.b=new Map,this.a=d.getProxy(R.$9J.MainThreadProfileContentHandlers)}registrProfileContentHandler(d,A,k){if((0,O.$8E)(d,"profileContentHandlers"),this.b.has(A))throw new Error(`Handler with id '${A}' already registered`);return this.b.set(A,k),this.a.$registerProfileContentHandler(A,k.name,k.description,d.identifier.value),(0,h.$Oc)(()=>{this.b.delete(A),this.a.$unregisterProfileContentHandler(A)})}async $saveProfile(d,A,k,a){const w=this.b.get(d);if(!w)throw new Error(`Unknown handler with id: ${d}`);return w.saveProfile(A,k,a)}async $readProfile(d,A,k){const a=this.b.get(d);if(!a)throw new Error(`Unknown handler with id: ${d}`);return a.readProfile((0,C.$wf)(A)?A:I.URI.revive(A),k)}}e.$qdc=u}),define(Ae[248],Re([1,0,2,3,12,8]),function(ie,e,h,C,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rdc=void 0;class R{constructor(D,d){this.d=d,this.c=new Map,this.b=D.getProxy(C.$9J.MainThreadQuickDiff)}$provideOriginalResource(D,d,A){const k=h.URI.revive(d),a=this.c.get(D);return a?(0,I.$Jg)(()=>a.provideOriginalResource(k,A)).then(w=>w||null):Promise.resolve(null)}registerQuickDiffProvider(D,d,A,k){const a=R.a++;return this.c.set(a,d),this.b.$registerQuickDiffProvider(a,O.DocumentSelector.from(D,this.d),A,k),{dispose:()=>{this.b.$unregisterQuickDiffProvider(a),this.c.delete(a)}}}}e.$rdc=R,R.a=0}),define(Ae[249],Re([1,0,21,5,6,3,2,7,9,18,29,41,26,8]),function(ie,e,h,C,I,O,R,u,D,d,A,k,a,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$scc=void 0;function m(f,t,s){const c=f.getProxy(O.$9J.MainThreadQuickOpen);class v{constructor(E,P){this.e=new Map,this.f=0,this.a=E,this.b=P}showQuickPick(E,P,l,$=h.CancellationToken.None){this.c=void 0;const b=Promise.resolve(P),M=++this.f,U=c.$show(M,{title:l?.title,placeHolder:l?.placeHolder,matchOnDescription:l?.matchOnDescription,matchOnDetail:l?.matchOnDetail,ignoreFocusLost:l?.ignoreFocusOut,canPickMany:l?.canPickMany},$),F={},q=U.then(()=>F);return Promise.race([q,b]).then(W=>{if(W===F)return;const L=(0,a.$7E)(E,"quickPickItemTooltip");return b.then(z=>{const K=[];for(let B=0;B<z.length;B++){const me=z[B];if(typeof me=="string")K.push({label:me,handle:B});else if(me.kind===u.QuickPickItemKind.Separator)K.push({type:"separator",label:me.label});else{me.tooltip&&!L&&console.warn(`Extension '${E.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${E.identifier.value}`);const ye=me.iconPath?i(me.iconPath):void 0;K.push({label:me.label,iconPath:ye?.iconPath,iconClass:ye?.iconClass,description:me.description,detail:me.detail,picked:me.picked,alwaysShow:me.alwaysShow,tooltip:L?w.MarkdownString.fromStrict(me.tooltip):void 0,handle:B})}}return l&&typeof l.onDidSelectItem=="function"&&(this.c=B=>{l.onDidSelectItem(z[B])}),c.$setItems(M,K),U.then(B=>{if(typeof B=="number")return z[B];if(Array.isArray(B))return B.map(me=>z[me])})})}).then(void 0,W=>{if(!(0,D.$2)(W))return c.$setError(M,W),Promise.reject(W)})}$onItemSelected(E){this.c?.(E)}showInput(E,P=h.CancellationToken.None){return this.d=E?.validateInput,c.$input(E,typeof this.d=="function",P).then(void 0,l=>{if(!(0,D.$2)(l))return Promise.reject(l)})}async $validateInput(E){if(!this.d)return;const P=await this.d(E);if(!P||typeof P=="string")return P;let l;switch(P.severity){case u.InputBoxValidationSeverity.Info:l=A.default.Info;break;case u.InputBoxValidationSeverity.Warning:l=A.default.Warning;break;case u.InputBoxValidationSeverity.Error:l=A.default.Error;break;default:l=P.message?A.default.Error:A.default.Ignore;break}return{content:P.message,severity:l}}async showWorkspaceFolderPick(E,P=h.CancellationToken.None){const l=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[E]);if(!l)return;const $=await this.a.getWorkspaceFolders2();if($)return $.find(b=>b.uri.toString()===l.uri.toString())}createQuickPick(E){const P=new o(E,()=>this.e.delete(P._id));return this.e.set(P._id,P),P}createInputBox(E){const P=new y(E,()=>this.e.delete(P._id));return this.e.set(P._id,P),P}$onDidChangeValue(E,P){this.e.get(E)?._fireDidChangeValue(P)}$onDidAccept(E){this.e.get(E)?._fireDidAccept()}$onDidChangeActive(E,P){const l=this.e.get(E);l instanceof o&&l._fireDidChangeActive(P)}$onDidChangeSelection(E,P){const l=this.e.get(E);l instanceof o&&l._fireDidChangeSelection(P)}$onDidTriggerButton(E,P){this.e.get(E)?._fireDidTriggerButton(P)}$onDidTriggerItemButton(E,P,l){const $=this.e.get(E);$ instanceof o&&$._fireDidTriggerItemButton(P,l)}$onDidHide(E){this.e.get(E)?._fireDidHide()}}class S{constructor(E,P){this.x=E,this.y=P,this._id=o.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new C.$Ld,this.q=new C.$Ld,this.r=new C.$Ld,this.s=new C.$Ld,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(E){this.b=E,this.z({title:E})}get step(){return this.c}set step(E){this.c=E,this.z({step:E})}get totalSteps(){return this.d}set totalSteps(E){this.d=E,this.z({totalSteps:E})}get enabled(){return this.g}set enabled(E){this.g=E,this.z({enabled:E})}get busy(){return this.j}set busy(E){this.j=E,this.z({busy:E})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(E){this.k=E,this.z({ignoreFocusOut:E})}get value(){return this.l}set value(E){this.l=E,this.z({value:E})}get placeholder(){return this.m}set placeholder(E){this.m=E,this.z({placeholder:E})}get buttons(){return this.n}set buttons(E){this.n=E.slice(),this.o.clear(),E.forEach((P,l)=>{const $=P===u.$sL.Back?-1:l;this.o.set($,P)}),this.z({buttons:E.map((P,l)=>({...i(P.iconPath),tooltip:P.tooltip,handle:P===u.$sL.Back?-1:l}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(E){this.l=E,this.q.fire(E)}_fireDidTriggerButton(E){const P=this.o.get(E);P&&this.r.fire(P)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,I.$Lc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),c.$dispose(this._id))}z(E){if(!this.v){for(const P of Object.keys(E)){const l=E[P];this.u[P]=l===void 0?null:l}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){c.$createOrUpdate(this.u),this.u={id:this._id}}}S.a=1;function p(g){if(g instanceof u.$5K)return{id:g.id};const E=r(g),P=n(g);return{dark:typeof E=="string"?R.URI.file(E):E,light:typeof P=="string"?R.URI.file(P):P}}function n(g){return typeof g=="object"&&"light"in g?g.light:g}function r(g){return typeof g=="object"&&"dark"in g?g.dark:g}function i(g){const E=p(g);let P,l;return"id"in E?l=k.ThemeIcon.asClassName(E):P=E,{iconPath:P,iconClass:l}}class o extends S{constructor(E,P){super(E.identifier,P),this.O=E,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new C.$Ld,this.L=[],this.M=new C.$Ld,this.N=new C.$Ld,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(E){this.B=E.slice(),this.C.clear(),this.D.clear(),E.forEach(($,b)=>{this.C.set(b,$),this.D.set($,b)});const P=(0,a.$7E)(this.O,"quickPickItemTooltip"),l=[];for(let $=0;$<E.length;$++){const b=E[$];if(b.kind===u.QuickPickItemKind.Separator)l.push({type:"separator",label:b.label});else{b.tooltip&&!P&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const M=b.iconPath?i(b.iconPath):void 0;l.push({handle:$,label:b.label,iconPath:M?.iconPath,iconClass:M?.iconClass,description:b.description,detail:b.detail,picked:b.picked,alwaysShow:b.alwaysShow,tooltip:P?w.MarkdownString.fromStrict(b.tooltip):void 0,buttons:b.buttons?.map((U,F)=>({...i(U.iconPath),tooltip:U.tooltip,handle:F}))})}}this.z({items:l})}get canSelectMany(){return this.E}set canSelectMany(E){this.E=E,this.z({canSelectMany:E})}get matchOnDescription(){return this.F}set matchOnDescription(E){this.F=E,this.z({matchOnDescription:E})}get matchOnDetail(){return this.G}set matchOnDetail(E){this.G=E,this.z({matchOnDetail:E})}get sortByLabel(){return this.H}set sortByLabel(E){this.H=E,this.z({sortByLabel:E})}get keepScrollPosition(){return this.I}set keepScrollPosition(E){this.I=E,this.z({keepScrollPosition:E})}get activeItems(){return this.J}set activeItems(E){this.J=E.filter(P=>this.D.has(P)),this.z({activeItems:this.J.map(P=>this.D.get(P))})}get selectedItems(){return this.L}set selectedItems(E){this.L=E.filter(P=>this.D.has(P)),this.z({selectedItems:this.L.map(P=>this.D.get(P))})}_fireDidChangeActive(E){const P=(0,d.$Fb)(E.map(l=>this.C.get(l)));this.J=P,this.K.fire(P)}_fireDidChangeSelection(E){const P=(0,d.$Fb)(E.map(l=>this.C.get(l)));this.L=P,this.M.fire(P)}_fireDidTriggerItemButton(E,P){const l=this.C.get(E);if(!l||!l.buttons||!l.buttons.length)return;const $=l.buttons[P];$&&this.N.fire({button:$,item:l})}}class y extends S{constructor(E,P){super(E.identifier,P),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(E){this.B=E,this.z({password:E})}get prompt(){return this.C}set prompt(E){this.C=E,this.z({prompt:E})}get valueSelection(){return this.D}set valueSelection(E){this.D=E,this.z({valueSelection:E})}get validationMessage(){return this.E}set validationMessage(E){this.E=E,E?typeof E=="string"?this.z({validationMessage:E,severity:A.default.Error}):this.z({validationMessage:E.message,severity:E.severity??A.default.Error}):this.z({validationMessage:void 0,severity:A.default.Ignore})}}return new v(t,s)}e.$scc=m});var Ne=this&&this.__classPrivateFieldGet||function(ie,e,h,C){if(h==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!C:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?C:h==="a"?C.call(ie):C?C.value:e.get(ie)},Ye=this&&this.__classPrivateFieldSet||function(ie,e,h,C,I){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!I:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?I.call(ie,h):I?I.value=h:e.set(ie,h),h};define(Ae[250],Re([1,0,2,5,65,6,12,3,18,118,14,20,41,8,26,13]),function(ie,e,h,C,I,O,R,u,D,d,A,k,a,w,m,f){"use strict";var t,s,c,v;Object.defineProperty(e,"__esModule",{value:!0}),e.$ucc=e.$tcc=void 0;function S(U){if(U)return typeof U.iconPath=="string"?h.URI.file(U.iconPath):h.URI.isUri(U.iconPath)||a.ThemeIcon.isThemeIcon(U.iconPath)?U.iconPath:void 0}function p(U){if(U.icon){if(h.URI.isUri(U.icon))return U.icon;if(a.ThemeIcon.isThemeIcon(U.icon))return U.icon;{const F=U.icon;return{light:F.light,dark:F.dark}}}else return}function n(U,F){if(!U.iconPath&&!F.iconPath)return 0;if(U.iconPath){if(!F.iconPath)return 1}else return-1;const q=typeof U.iconPath=="string"?U.iconPath:h.URI.isUri(U.iconPath)?U.iconPath.fsPath:U.iconPath.id,W=typeof F.iconPath=="string"?F.iconPath:h.URI.isUri(F.iconPath)?F.iconPath.fsPath:F.iconPath.id;return(0,d.$jq)(q,W)}function r(U,F){let q=0;if(U.strikeThrough!==F.strikeThrough)return U.strikeThrough?1:-1;if(U.faded!==F.faded)return U.faded?1:-1;if(U.tooltip!==F.tooltip)return(U.tooltip||"").localeCompare(F.tooltip||"");if(q=n(U,F),q!==0)return q;if(U.light&&F.light)q=n(U.light,F.light);else{if(U.light)return 1;if(F.light)return-1}if(q!==0)return q;if(U.dark&&F.dark)q=n(U.dark,F.dark);else{if(U.dark)return 1;if(F.dark)return-1}return q}function i(U,F){if(U.command!==F.command)return U.command<F.command?-1:1;if(U.title!==F.title)return U.title<F.title?-1:1;if(U.tooltip!==F.tooltip){if(U.tooltip!==void 0&&F.tooltip!==void 0)return U.tooltip<F.tooltip?-1:1;if(U.tooltip!==void 0)return 1;if(F.tooltip!==void 0)return-1}if(U.arguments===F.arguments)return 0;if(U.arguments)if(F.arguments){if(U.arguments.length!==F.arguments.length)return U.arguments.length-F.arguments.length}else return 1;else return-1;for(let q=0;q<U.arguments.length;q++){const W=U.arguments[q],L=F.arguments[q];if(W!==L)return W<L?-1:1}return 0}function o(U,F){let q=(0,d.$jq)(U.resourceUri.fsPath,F.resourceUri.fsPath,!0);if(q!==0)return q;if(U.command&&F.command)q=i(U.command,F.command);else{if(U.command)return 1;if(F.command)return-1}if(q!==0)return q;if(U.decorations&&F.decorations)q=r(U.decorations,F.decorations);else{if(U.decorations)return 1;if(F.decorations)return-1}return q}function y(U,F){for(let q=0;q<U.length;q++)if(U[q]!==F[q])return!1;return!0}function g(U,F){return U.command===F.command&&U.title===F.title&&U.tooltip===F.tooltip&&(U.arguments&&F.arguments?y(U.arguments,F.arguments):U.arguments===F.arguments)}function E(U,F){return(0,D.$sb)(U,F,g)}function P(U,F){return U===F?!0:!U||!F?!1:U.id===F.id&&U.label===F.label&&U.upstream?.id===F.upstream?.id&&U.upstream?.label===F.upstream?.label}class l{get value(){return this.d}set value(F){F=F??"",Ne(this,t,"f").$setInputBoxValue(this.l,F),this.n(F)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(F){Ne(this,t,"f").$setInputBoxPlaceholder(this.l,F),this.f=F}get validateInput(){return(0,m.$8E)(this.k,"scmValidation"),this.g}set validateInput(F){if((0,m.$8E)(this.k,"scmValidation"),F&&typeof F!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=F,Ne(this,t,"f").$setValidationProviderIsEnabled(this.l,!!F)}get enabled(){return this.h}set enabled(F){F=!!F,this.h!==F&&(this.h=F,Ne(this,t,"f").$setInputBoxEnablement(this.l,F))}get visible(){return this.j}set visible(F){F=!!F,this.j!==F&&(this.j=F,Ne(this,t,"f").$setInputBoxVisibility(this.l,F))}get document(){return(0,m.$8E)(this.k,"scmTextDocument"),Ne(this,s,"f").getDocument(this.m)}constructor(F,q,W,L,z){this.k=F,this.l=L,this.m=z,t.set(this,void 0),s.set(this,void 0),this.d="",this.e=new C.$Ld,this.f="",this.h=!0,this.j=!0,Ye(this,s,q,"f"),Ye(this,t,W,"f")}showValidationMessage(F,q){(0,m.$8E)(this.k,"scmValidation"),Ne(this,t,"f").$showValidationMessage(this.l,F,q)}$onInputBoxValueChange(F){this.n(F)}n(F){this.d=F,this.e.fire(F)}}e.$tcc=l,t=new WeakMap,s=new WeakMap;class ${get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(F){this.v=F,this.q.$updateGroupLabel(this.t,this.handle,F)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(F){this.p=F,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(F){this.f=[...F],this.k.fire()}constructor(F,q,W,L,z){this.q=F,this.s=q,this.t=W,this.u=L,this.v=z,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new C.$Ld,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new C.$Ld,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=$.d++}getResourceState(F){return this.g.get(F)}$executeResourceCommand(F,q){const W=this.h.get(F);return W?(0,R.$Jg)(()=>this.s.executeCommand(W.command,...W.arguments||[],q)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const F=[...this.f].sort(o),W=(0,D.$Bb)(this.o,F,o).map(K=>{const B=K.toInsert.map(me=>{const ye=this.e++;this.g.set(ye,me);const Ie=me.resourceUri;let _;if(me.command)if(me.command.command==="vscode.open"||me.command.command==="vscode.diff"){const he=new O.$Pc;_=this.s.converter.toInternal(me.command,he),this.j.set(ye,he)}else this.h.set(ye,me.command);const de=S(me.decorations),De=me.decorations&&S(me.decorations.light)||de,ue=me.decorations&&S(me.decorations.dark)||de,ve=[De,ue],ke=me.decorations&&me.decorations.tooltip||"",V=me.decorations&&!!me.decorations.strikeThrough,Q=me.decorations&&!!me.decorations.faded,ee=me.contextValue||"";return{rawResource:[ye,Ie,ve,ke,V,Q,ee,_],handle:ye}});return{start:K.start,deleteCount:K.deleteCount,toInsert:B}}),L=W.map(({start:K,deleteCount:B,toInsert:me})=>[K,B,me.map(ye=>ye.rawResource)]),z=W.reverse();for(const{start:K,deleteCount:B,toInsert:me}of z){const ye=me.map(_=>_.handle),Ie=this.n.splice(K,B,...ye);for(const _ of Ie)this.g.delete(_),this.h.delete(_),this.j.get(_)?.dispose(),this.j.delete(_)}return this.o=F,L}dispose(){this.l=!0,this.m.fire()}}$.d=0;class b{get id(){return this.A}get label(){return this.B}get rootUri(){return this.C}get inputBox(){return this.f}get count(){return this.g}set count(F){this.g!==F&&(this.g=F,Ne(this,c,"f").$updateSourceControl(this.x,{count:F}))}get quickDiffProvider(){return this.h}set quickDiffProvider(F){this.h=F;let q;(0,m.$7E)(this.y,"quickDiffProvider")&&(q=F?.label),Ne(this,c,"f").$updateSourceControl(this.x,{hasQuickDiffProvider:!!F,quickDiffLabel:q})}get historyProvider(){return(0,m.$8E)(this.y,"scmHistoryProvider"),this.j}set historyProvider(F){(0,m.$8E)(this.y,"scmHistoryProvider"),this.j=F,this.k.value=new O.$Pc,Ne(this,c,"f").$updateSourceControl(this.x,{hasHistoryProvider:!!F}),F&&(this.k.value.add(F.onDidChangeCurrentHistoryItemGroup(()=>{P(this.l,F?.currentHistoryItemGroup)||(this.l=F?.currentHistoryItemGroup,Ne(this,c,"f").$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.x,this.l))})),this.k.value.add(F.onDidChangeActionButton(()=>{(0,m.$8E)(this.y,"scmActionButton"),this.m.value=new O.$Pc;const q=F.actionButton!==void 0?{command:this.z.converter.toInternal(F.actionButton.command,this.m.value),description:F.actionButton.description,enabled:F.actionButton.enabled}:void 0;Ne(this,c,"f").$onDidChangeHistoryProviderActionButton(this.x,q??null)})))}get commitTemplate(){return this.n}set commitTemplate(F){F!==this.n&&(this.n=F,Ne(this,c,"f").$updateSourceControl(this.x,{commitTemplate:F}))}get acceptInputCommand(){return this.p}set acceptInputCommand(F){this.o.value=new O.$Pc,this.p=F;const q=this.z.converter.toInternal(F,this.o.value);Ne(this,c,"f").$updateSourceControl(this.x,{acceptInputCommand:q})}get actionButton(){return(0,m.$8E)(this.y,"scmActionButton"),this.s}set actionButton(F){(0,m.$8E)(this.y,"scmActionButton"),this.q.value=new O.$Pc,this.s=F;const q=F!==void 0?{command:this.z.converter.toInternal(F.command,this.q.value),secondaryCommands:F.secondaryCommands?.map(W=>W.map(L=>this.z.converter.toInternal(L,this.q.value))),description:F.description,enabled:F.enabled}:void 0;Ne(this,c,"f").$updateSourceControl(this.x,{actionButton:q??null})}get statusBarCommands(){return this.u}set statusBarCommands(F){if(this.u&&F&&E(this.u,F))return;this.t.value=new O.$Pc,this.u=F;const q=(F||[]).map(W=>this.z.converter.toInternal(W,this.t.value));Ne(this,c,"f").$updateSourceControl(this.x,{statusBarCommands:q})}get selected(){return this.v}constructor(F,q,W,L,z,K,B){this.y=F,this.z=L,this.A=z,this.B=K,this.C=B,c.set(this,void 0),this.e=new Map,this.g=void 0,this.h=void 0,this.k=new O.$Rc,this.m=new O.$Rc,this.n=void 0,this.o=new O.$Rc,this.p=void 0,this.q=new O.$Rc,this.t=new O.$Rc,this.u=void 0,this.v=!1,this.w=new C.$Ld,this.onDidChangeSelection=this.w.event,this.x=b.d++,this.D=new Map,this.E=new Set,Ye(this,c,W,"f");const me=h.URI.from({scheme:f.Schemas.vscodeSourceControl,path:`${z}/scm${this.x}/input`,query:B?`rootUri=${encodeURIComponent(B.toString())}`:void 0});this.f=new l(F,q,Ne(this,c,"f"),this.x,me),Ne(this,c,"f").$registerSourceControl(this.x,z,K,B,me)}createResourceGroup(F,q){const W=new $(Ne(this,c,"f"),this.z,this.x,F,q),L=C.Event.once(W.onDidDispose)(()=>this.D.delete(W));return this.D.set(W,L),this.eventuallyAddResourceGroups(),W}eventuallyAddResourceGroups(){const F=[],q=[];for(const[W,L]of this.D){L.dispose();const z=W.onDidUpdateResourceStates(()=>{this.E.add(W),this.eventuallyUpdateResourceStates()});C.Event.once(W.onDidDispose)(()=>{this.E.delete(W),z.dispose(),this.e.delete(W.handle),Ne(this,c,"f").$unregisterGroup(this.x,W.handle)}),F.push([W.handle,W.id,W.label,W.features]);const K=W._takeResourceStateSnapshot();K.length>0&&q.push([W.handle,K]),this.e.set(W.handle,W)}Ne(this,c,"f").$registerGroups(this.x,F,q),this.D.clear()}eventuallyUpdateResourceStates(){const F=[];this.E.forEach(q=>{const W=q._takeResourceStateSnapshot();W.length!==0&&F.push([q.handle,W])}),F.length>0&&Ne(this,c,"f").$spliceResourceStates(this.x,F),this.E.clear()}getResourceGroup(F){return this.e.get(F)}setSelectionState(F){this.v=F,this.w.fire(F)}dispose(){this.o.dispose(),this.q.dispose(),this.t.dispose(),this.e.forEach(F=>F.dispose()),Ne(this,c,"f").$unregisterSourceControl(this.x)}}c=new WeakMap,b.d=0,Je([(0,I.$eh)(100)],b.prototype,"eventuallyAddResourceGroups",null),Je([(0,I.$eh)(100)],b.prototype,"eventuallyUpdateResourceStates",null);let M=v=class{get onDidChangeActiveProvider(){return this.j.event}constructor(F,q,W,L){this.l=q,this.m=W,this.n=L,this.g=new Map,this.h=new k.$Zl,this.j=new C.$Ld,this.e=F.getProxy(u.$9J.MainThreadSCM),this.f=F.getProxy(u.$9J.MainThreadTelemetry),q.registerArgumentProcessor({processArgument:z=>{if(z&&z.$mid===3){const K=this.g.get(z.sourceControlHandle);if(!K)return z;const B=K.getResourceGroup(z.groupHandle);return B?B.getResourceState(z.handle):z}else if(z&&z.$mid===4){const K=this.g.get(z.sourceControlHandle);return K?K.getResourceGroup(z.groupHandle):z}else if(z&&z.$mid===5){const K=this.g.get(z.handle);return K||z}return z}})}createSourceControl(F,q,W,L){this.n.trace("ExtHostSCM#createSourceControl",F.identifier.value,q,W,L),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:F.identifier.value});const z=v.d++,K=new b(F,this.m,this.e,this.l,q,W,L);this.g.set(z,K);const B=this.h.get(F.identifier)||[];return B.push(K),this.h.set(F.identifier,B),K}getLastInputBox(F){this.n.trace("ExtHostSCM#getLastInputBox",F.identifier.value);const q=this.h.get(F.identifier),W=q&&q[q.length-1];return W&&W.inputBox}$provideOriginalResource(F,q,W){const L=h.URI.revive(q);this.n.trace("ExtHostSCM#$provideOriginalResource",F,L.toString());const z=this.g.get(F);return!z||!z.quickDiffProvider||!z.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,R.$Jg)(()=>z.quickDiffProvider.provideOriginalResource(L,W)).then(K=>K||null)}$onInputBoxValueChange(F,q){this.n.trace("ExtHostSCM#$onInputBoxValueChange",F);const W=this.g.get(F);return W&&W.inputBox.$onInputBoxValueChange(q),Promise.resolve(void 0)}$executeResourceCommand(F,q,W,L){this.n.trace("ExtHostSCM#$executeResourceCommand",F,q,W);const z=this.g.get(F);if(!z)return Promise.resolve(void 0);const K=z.getResourceGroup(q);return K?K.$executeResourceCommand(W,L):Promise.resolve(void 0)}$validateInput(F,q,W){this.n.trace("ExtHostSCM#$validateInput",F);const L=this.g.get(F);return!L||!L.inputBox.validateInput?Promise.resolve(void 0):(0,R.$Jg)(()=>L.inputBox.validateInput(q,W)).then(z=>{if(!z)return Promise.resolve(void 0);const K=w.MarkdownString.fromStrict(z.message);return K?Promise.resolve([K,z.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(F){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",F),F!==void 0&&this.g.get(F)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=F,Promise.resolve(void 0)}async $resolveHistoryItemGroupBase(F,q,W){return await this.g.get(F)?.historyProvider?.resolveHistoryItemGroupBase(q,W)??void 0}async $resolveHistoryItemGroupCommonAncestor(F,q,W,L){return await this.g.get(F)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(q,W,L)??void 0}async $provideHistoryItems(F,q,W,L){return(await this.g.get(F)?.historyProvider?.provideHistoryItems(q,W,L))?.map(B=>({id:B.id,parentIds:B.parentIds,label:B.label,description:B.description,icon:p(B),timestamp:B.timestamp}))??void 0}async $provideHistoryItemChanges(F,q,W){return await this.g.get(F)?.historyProvider?.provideHistoryItemChanges(q,W)??void 0}};e.$ucc=M,M.d=0,e.$ucc=M=v=Je([qe(3,A.$6i)],M)}),define(Ae[83],Re([1,0,3,5,4]),function(ie,e,h,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$acc=e.$_bc=void 0;class O{constructor(u){this.b=new C.$Ld,this.onDidChangePassword=this.b.event,this.a=u.getProxy(h.$9J.MainThreadSecretState)}async $onDidChangePassword(u){this.b.fire(u)}get(u,D){return this.a.$getPassword(u,D)}store(u,D,d){return this.a.$setPassword(u,D,d)}delete(u,D){return this.a.$deletePassword(u,D)}}e.$_bc=O,e.$acc=(0,I.$Lh)("IExtHostSecretState")}),define(Ae[251],Re([1,0,3,8,2]),function(ie,e,h,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wdc=void 0;class O{constructor(u,D){this.d=D,this.c=new Map,this.b=u.getProxy(h.$9J.MainThreadShare)}async $provideShare(u,D,d){return await this.c.get(u)?.provideShare({selection:C.Range.to(D.selection),resourceUri:I.URI.revive(D.resourceUri)},d)??void 0}registerShareProvider(u,D){const d=O.a++;return this.c.set(d,D),this.b.$registerShareProvider(d,C.DocumentSelector.from(u,this.d),D.id,D.label,D.priority),{dispose:()=>{this.b.$unregisterShareProvider(d),this.c.delete(d)}}}}e.$wdc=O,O.a=0});var Ye=this&&this.__classPrivateFieldSet||function(ie,e,h,C,I){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!I:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?I.call(ie,h):I?I.value=h:e.set(ie,h),h},Ne=this&&this.__classPrivateFieldGet||function(ie,e,h,C){if(h==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!C:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?C:h==="a"?C.call(ie):C?C.value:e.get(ie)};define(Ae[252],Re([1,0,7,3,153,6,8,16]),function(ie,e,h,C,I,O,R,u){"use strict";var D,d;Object.defineProperty(e,"__esModule",{value:!0}),e.$wcc=e.$vcc=void 0;class A{constructor(m,f,t,s,c,v=h.StatusBarAlignment.Left,S){if(D.set(this,void 0),d.set(this,void 0),this.i=!1,this.k="",this.q=new O.$Pc,Ye(this,D,m,"f"),Ye(this,d,f,"f"),c&&s){this.c=(0,h.$IK)(s.identifier,c);const p=t.get(this.c);p&&(v=p.alignLeft?h.StatusBarAlignment.Left:h.StatusBarAlignment.Right,S=p.priority,this.j=!0,this.name=p.name,this.text=p.text,this.tooltip=p.tooltip,this.command=p.command,this.accessibilityInformation=p.accessibilityInformation)}else this.c=String(A.a++);this.e=s,this.f=c,this.g=v,this.h=this.u(S)}u(m){if((0,u.$Af)(m))return m===Number.POSITIVE_INFINITY?Number.MAX_VALUE:m===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:m}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(m){this.k=m,this.v()}set name(m){this.m=m,this.v()}set tooltip(m){this.l=m,this.v()}set color(m){this.n=m,this.v()}set backgroundColor(m){m&&!A.b.has(m.id)&&(m=void 0),this.o=m,this.v()}set command(m){this.r?.fromApi!==m&&(this.p&&this.q.add(this.p),this.p=new O.$Pc,typeof m=="string"?this.r={fromApi:m,internal:Ne(this,d,"f").toInternal({title:"",command:m},this.p)}:m?this.r={fromApi:m,internal:Ne(this,d,"f").toInternal(m,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(m){this.t=m,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,Ne(this,D,"f").$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let m;this.e?this.f?m=`${this.e.identifier.value}.${this.f}`:m=this.e.identifier.value:m=this.f;let f;this.m?f=this.m:f=(0,I.localize)(0,null,this.e.displayName||this.e.name);let t=this.n;this.o&&(t=A.b.get(this.o.id));const s=R.MarkdownString.fromStrict(this.l);Ne(this,D,"f").$setEntry(this.c,m,this.e?.identifier.value,f,this.k,s,this.r?.internal,t,this.o,this.g===h.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$vcc=A,D=new WeakMap,d=new WeakMap,A.a=0,A.b=new Map([["statusBarItem.errorBackground",new h.$6K("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new h.$6K("statusBarItem.warningForeground")]]);class k{constructor(m){this.b=[],this.a=m.createStatusBarEntry(void 0,"status.extensionMessage",h.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,I.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(m){const f={message:m};return this.b.unshift(f),this.c(),new h.$$J(()=>{const t=this.b.indexOf(f);t>=0&&(this.b.splice(t,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class a{constructor(m,f){this.e=new Map,this.a=m.getProxy(C.$9J.MainThreadStatusBar),this.b=f,this.c=new k(this)}$acceptStaticEntries(m){for(const f of m)this.e.set(f.entryId,f)}createStatusBarEntry(m,f,t,s){return new A(this.a,this.b,this.e,m,f,t,s)}setStatusBarMessage(m,f){const t=this.c.setMessage(m);let s;return typeof f=="number"?s=setTimeout(()=>t.dispose(),f):typeof f<"u"&&f.then(()=>t.dispose(),()=>t.dispose()),new h.$$J(()=>{t.dispose(),clearTimeout(s)})}}e.$wcc=a}),define(Ae[84],Re([1,0,3,5,4]),function(ie,e,h,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1bc=e.$Zbc=void 0;class O{constructor(u,D){this.c=D,this.b=new C.$Ld,this.onDidChangeStorage=this.b.event,this.a=u.getProxy(h.$9J.MainThreadStorage)}registerExtensionStorageKeysToSync(u,D){this.a.$registerExtensionStorageKeysToSync(u,D)}async initializeExtensionStorage(u,D,d){const A=await this.a.$initializeExtensionStorage(u,D);let k;return A&&(k=this.d(u,D,A)),k||d}setValue(u,D,d){return this.a.$setValue(u,D,d)}$acceptValue(u,D,d){const A=this.d(u,D,d);A&&this.b.fire({shared:u,key:D,value:A})}d(u,D,d){try{return JSON.parse(d)}catch(A){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${D}, global: ${u}): ${A}`)}}}e.$Zbc=O,e.$1bc=(0,I.$Lh)("IExtHostStorage")}),define(Ae[85],Re([1,0,4,27,14,62,2]),function(ie,e,h,C,I,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7bc=e.$6bc=void 0,e.$6bc=(0,h.$Lh)("IExtensionStoragePaths");let u=class{constructor(d,A,k){this.d=A,this.f=k,this.a=d.workspace??void 0,this.b=d.environment,this.whenReady=this.h().then(a=>this.c=a)}async g(d){return R.URI.joinPath(this.b.workspaceStorageHome,d)}async h(){if(!this.a)return Promise.resolve(void 0);const d=this.a.id,A=await this.g(d);try{return await this.f.value.stat(A),this.d.trace("[ExtHostStorage] storage dir already exists",A),A}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",A),await this.f.value.createDirectory(A),await this.f.value.writeFile(R.URI.joinPath(A,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:R.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),A}catch(k){this.d.error("[ExtHostStorage]",k);return}}workspaceValue(d){if(this.c)return R.URI.joinPath(this.c,d.identifier.value)}globalValue(d){return R.URI.joinPath(this.b.globalStorageHome,d.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$7bc=u,e.$7bc=u=Je([qe(0,C.$nM),qe(1,I.$6i),qe(2,O.$5bc)],u)}),define(Ae[63],Re([1,0,5,3,4,2,17,6,7,155,9,181,21,37,182,41,12,8,31]),function(ie,e,h,C,I,O,R,u,D,d,A,k,a,w,m,f,t,s,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$bc=e.$0bc=e.$9bc=e.$8bc=void 0,e.$8bc=(0,I.$Lh)("IExtHostTerminalService");class v{constructor(l,$,b,M){this.l=l,this._id=$,this.m=b,this.n=M,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.m=Object.freeze(this.m),this.b=new Promise(F=>this.f=F);const U=this;this.value={get name(){return U.n||""},get processId(){return U.b},get creationOptions(){return U.m},get exitStatus(){return U.h},get state(){return U.j},get selection(){return U.k},sendText(F,q=!0){U.q(),U.l.$sendText(U._id,F,q)},show(F){U.q(),U.l.$show(U._id,F)},hide(){U.q(),U.l.$hide(U._id)},dispose(){U.a||(U.a=!0,U.l.$dispose(U._id))},get dimensions(){if(!(U.d===void 0||U.g===void 0))return{columns:U.d,rows:U.g}}}}async create(l,$){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.l.$createTerminal(this._id,{name:l.name,shellPath:l.shellPath??void 0,shellArgs:l.shellArgs??void 0,cwd:l.cwd??void 0,env:l.env??void 0,icon:y(l.iconPath)??void 0,color:f.ThemeColor.isThemeColor(l.color)?l.color.id:void 0,initialText:l.message??void 0,strictEnv:l.strictEnv??void 0,hideFromUser:l.hideFromUser??void 0,isFeatureTerminal:$?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:$?.useShellEnvironment??void 0,location:$?.location||this.o(l.location,$?.resolvedExtHostIdentifier),isTransient:l.isTransient??void 0})}async createExtensionTerminal(l,$,b,M){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.l.$createTerminal(this._id,{name:this.n,isExtensionCustomPtyTerminal:!0,icon:b,color:f.ThemeColor.isThemeColor(M)?M.id:void 0,location:this.o(l,$),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}o(l,$){return typeof l=="object"?"parentTerminal"in l&&l.parentTerminal&&$?{parentTerminal:$}:"viewColumn"in l?{viewColumn:s.ViewColumn.from(l.viewColumn),preserveFocus:l.preserveFocus}:void 0:l}q(){if(this.a)throw new Error("Terminal has already been disposed")}set name(l){this.n=l}setExitStatus(l,$){this.h=Object.freeze({code:l,reason:$})}setDimensions(l,$){return l===this.d&&$===this.g||l===0||$===0?!1:(this.d=l,this.g=$,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}setSelection(l){this.k=l}_setProcessId(l){this.f?(this.f(l),this.f=void 0):this.b.then($=>{$!==l&&(this.b=Promise.resolve(l))})}}e.$9bc=v;class S{get onProcessReady(){return this.b.event}constructor(l){this.g=l,this.id=0,this.shouldPersist=!1,this.a=new h.$Ld,this.onProcessData=this.a.event,this.b=new h.$Ld,this.d=new h.$Ld,this.onDidChangeProperty=this.d.event,this.f=new h.$Ld,this.onProcessExit=this.f.event}refreshProperty(l){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${l}`)}updateProperty(l,$){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${l}, value: ${$}`)}async start(){}shutdown(){this.g.close()}input(l){this.g.handleInput?.(l)}resize(l,$){this.g.setDimensions?.({columns:l,rows:$})}clearBuffer(){}async processBinary(l){}acknowledgeDataEvent(l){}async setUnicodeVersion(l){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(l){this.g.onDidWrite($=>this.a.fire($)),this.g.onDidClose?.(($=void 0)=>{this.f.fire($===void 0?void 0:$)}),this.g.onDidOverrideDimensions?.($=>{$&&this.d.fire({type:"overrideDimensions",value:{cols:$.columns,rows:$.rows}})}),this.g.onDidChangeName?.($=>{this.d.fire({type:"title",value:$})}),this.g.open(l||void 0),l&&this.g.setDimensions?.(l),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let p=1,n=class extends u.$Qc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(l=>l.value)}constructor(l,$,b){super(),this.Q=$,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new u.$Rc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new h.$Ld,this.onDidCloseTerminal=this.H.event,this.I=new h.$Ld,this.onDidOpenTerminal=this.I.event,this.J=new h.$Ld,this.onDidChangeActiveTerminal=this.J.event,this.L=new h.$Ld,this.onDidChangeTerminalDimensions=this.L.event,this.M=new h.$Ld,this.onDidChangeTerminalState=this.M.event,this.N=new h.$Ld,this.onDidChangeShell=this.N.event,this.O=new h.$Ld({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new h.$Ld({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=b.getProxy(C.$9J.MainThreadTerminalService),this.y=new m.$Ikb(this.a.$sendProcessData),this.a.$registerProcessSupport(l),this.Q.registerArgumentProcessor({processArgument:M=>{const U=F=>{const q=F;return this.W(q.instanceId)?.value};switch(M?.$mid){case 15:return U(M);default:{if(Array.isArray(M))for(let F=0;F<M.length&&M[F].$mid===15;F++)M[F]=U(M[F]);return M}}}}),this.B({dispose:()=>{for(const[M,U]of this.g)U.shutdown(!0)}})}getDefaultShell(l){return(l?this.u:this.s)?.path||""}getDefaultShellArgs(l){return(l?this.u:this.s)?.args||[]}createExtensionTerminal(l,$){const b=new v(this.a,(0,w.$bg)(),l,l.name),M=new S(l.pty);return b.createExtensionTerminal(l.location,this.R(l,$).resolvedExtHostIdentifier,y(l.iconPath),g(l.color)).then(U=>{const F=this.S(U,M);this.h[U]=F}),this.f.push(b),b.value}R(l,$){if($=$||{},l.location&&typeof l.location=="object"&&"parentTerminal"in l.location){const b=l.location.parentTerminal;if(b){const M=this.f.find(U=>U.value===b);M&&($.resolvedExtHostIdentifier=M._id)}}else l.location&&typeof l.location!="object"?$.location=l.location:$.location&&typeof $.location=="object"&&"splitActiveTerminal"in $.location&&($.location={splitActiveTerminal:!0});return $}attachPtyToTerminal(l,$){if(!this.W(l))throw new Error(`Cannot resolve terminal with id ${l} for virtual process`);const M=new S($),U=this.S(l,M);this.h[l]=U}async $acceptActiveTerminalChanged(l){const $=this.b;if(l===null){this.b=void 0,$!==this.b&&this.J.fire(this.b);return}const b=this.W(l);b&&(this.b=b,$!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(l,$){const b=this.W(l);b&&this.O.fire({terminal:b.value,data:$})}async $acceptTerminalDimensions(l,$,b){const M=this.W(l);M&&M.setDimensions($,b)&&this.L.fire({terminal:M.value,dimensions:M.value.dimensions})}async $acceptDidExecuteCommand(l,$){const b=this.W(l);b&&this.P.fire({terminal:b.value,...$})}async $acceptTerminalMaximumDimensions(l,$,b){this.g.get(l)?.resize($,b)}async $acceptTerminalTitleChange(l,$){const b=this.W(l);b&&(b.name=$)}async $acceptTerminalClosed(l,$,b){const M=this.Y(this.f,l);if(M!==null){const U=this.f.splice(M,1)[0];U.setExitStatus($,b),this.H.fire(U.value)}}$acceptTerminalOpened(l,$,b,M){if($){const q=this.Y(this.f,$);if(q!==null){this.f[q]._id=l,this.I.fire(this.terminals[q]),this.f[q].isOpen=!0;return}}const U={name:M.name,shellPath:M.executable,shellArgs:M.args,cwd:typeof M.cwd=="string"?M.cwd:O.URI.revive(M.cwd),env:M.env,hideFromUser:M.hideFromUser},F=new v(this.a,l,U,b);this.f.push(F),this.I.fire(F.value),F.isOpen=!0}async $acceptTerminalProcessId(l,$){this.W(l)?._setProcessId($)}async $startExtensionTerminal(l,$){const b=this.W(l);if(!b)return{message:(0,d.localize)(0,null,l)};b.isOpen||await new Promise(U=>{const F=this.onDidOpenTerminal(async q=>{q===b.value&&(F.dispose(),U())})});const M=this.g.get(l);M?M.startSendingEvents($):this.j[l]={initialDimensions:$}}S(l,$){const b=new u.$Pc;b.add($.onProcessReady(U=>this.a.$sendProcessReady(l,U.pid,U.cwd,U.windowsPty))),b.add($.onDidChangeProperty(U=>this.a.$sendProcessProperty(l,U))),this.y.startBuffering(l,$.onProcessData),b.add($.onProcessExit(U=>this.U(l,U))),this.g.set(l,$);const M=this.j[l];return M&&$ instanceof S&&($.startSendingEvents(M.initialDimensions),delete this.j[l]),b}$acceptProcessAckDataEvent(l,$){this.g.get(l)?.acknowledgeDataEvent($)}$acceptProcessInput(l,$){this.g.get(l)?.input($)}$acceptTerminalInteraction(l){const $=this.W(l);$?.setInteractedWith()&&this.M.fire($.value)}$acceptTerminalSelection(l,$){this.W(l)?.setSelection($)}$acceptProcessResize(l,$,b){try{this.g.get(l)?.resize($,b)}catch(M){if(M.code!=="EPIPE"&&M.code!=="ERR_IPC_CHANNEL_CLOSED")throw M}}$acceptProcessShutdown(l,$){this.g.get(l)?.shutdown($)}$acceptProcessRequestInitialCwd(l){this.g.get(l)?.getInitialCwd().then($=>this.a.$sendProcessProperty(l,{type:"initialCwd",value:$}))}$acceptProcessRequestCwd(l){this.g.get(l)?.getCwd().then($=>this.a.$sendProcessProperty(l,{type:"cwd",value:$}))}$acceptProcessRequestLatency(l){return Promise.resolve(l)}registerLinkProvider(l){return this.z.add(l),this.z.size===1&&this.a.$startLinkProvider(),new D.$$J(()=>{this.z.delete(l),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(l,$,b){if(this.C.has($))throw new Error(`Terminal profile provider "${$}" already registered`);return this.C.set($,b),this.a.$registerProfileProvider($,l.identifier.value),new D.$$J(()=>{this.C.delete($),this.a.$unregisterProfileProvider($)})}registerTerminalQuickFixProvider(l,$,b){if(this.D.has(l))throw new Error(`Terminal quick fix provider "${l}" is already registered`);return this.D.set(l,b),this.a.$registerQuickFixProvider(l,$),new D.$$J(()=>{this.D.delete(l),this.a.$unregisterQuickFixProvider(l)})}async $provideTerminalQuickFixes(l,$){const b=new a.$Vd().token;if(b.isCancellationRequested)return;const M=this.D.get(l);if(!M)return;const U=await M.provideTerminalQuickFixes($,b);if(U===null||Array.isArray(U)&&U.length===0)return;const F=new u.$Pc;if(this.w.value=F,!Array.isArray(U))return U?s.TerminalQuickFix.from(U,this.Q.converter,F):void 0;const q=[];for(const W of U){const L=s.TerminalQuickFix.from(W,this.Q.converter,F);L&&q.push(L)}return q}async $createContributedProfileTerminal(l,$){const b=new a.$Vd().token;let M=await this.C.get(l)?.provideTerminalProfile(b);if(!b.isCancellationRequested){if(M&&!("options"in M)&&(M={options:M}),!M||!("options"in M))throw new Error(`No terminal profile options provided for id "${l}"`);if("pty"in M.options){this.createExtensionTerminal(M.options,$);return}this.createTerminalFromOptions(M.options,$)}}async $provideLinks(l,$){const b=this.W(l);if(!b)return[];this.F.delete(l),this.G.get(l)?.dispose(!0);const U=new a.$Vd;this.G.set(l,U);const F=[],q={terminal:b.value,line:$},W=[];for(const K of this.z)W.push(t.Promises.withAsyncBody(async B=>{U.token.onCancellationRequested(()=>B({provider:K,links:[]}));const me=await K.provideTerminalLinks(q,U.token)||[];U.token.isCancellationRequested||B({provider:K,links:me})}));const L=await Promise.all(W);if(U.token.isCancellationRequested)return[];const z=new Map;for(const K of L)K&&K.links.length>0&&F.push(...K.links.map(B=>{const me={id:p++,startIndex:B.startIndex,length:B.length,label:B.tooltip};return z.set(me.id,{provider:K.provider,link:B}),me}));return this.F.set(l,z),F}$activateLink(l,$){const b=this.F.get(l)?.get($);b&&b.provider.handleTerminalLink(b.link)}U(l,$){this.y.stopBuffering(l),this.g.delete(l),delete this.j[l];const b=this.h[l];b&&(b.dispose(),delete this.h[l]),this.a.$sendProcessExit(l,$)}W(l){return this.X(this.f,l)}X(l,$){const b=this.Y(l,$);return b!==null?l[b]:null}Y(l,$){const b=l.findIndex(M=>M._id===$);return b===-1?null:b}getEnvironmentVariableCollection(l){let $=this.n.get(l.identifier.value);return $||($=new r,this.$(l.identifier.value,$)),$.getScopedEnvironmentVariableCollection(void 0)}Z(l,$){const b=(0,k.$cr)($.map),M=(0,k.$dr)($.descriptionMap);this.a.$setEnvironmentVariableCollection(l,$.persistent,b.length===0?void 0:b,M)}$initEnvironmentVariableCollections(l){l.forEach($=>{const b=$[0],M=new r($[1]);this.$(b,M)})}$acceptDefaultProfile(l,$){const b=this.s;this.s=l,this.u=$,b?.path!==l.path&&this.N.fire(l.path)}$(l,$){this.n.set(l,$),$.onDidChangeCollection(()=>{this.Z(l,$)})}};e.$0bc=n,e.$0bc=n=Je([qe(1,c.$tM),qe(2,R.$0L)],n);class r{get persistent(){return this.b}set persistent(l){this.b=l,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(l){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new h.$Ld,this.map=new Map(l)}getScopedEnvironmentVariableCollection(l){const $=this.h(l);let b=this.a.get($);return b||(b=new i(this,l),this.a.set($,b),b.onDidChangeCollection(()=>this.d.fire())),b}replace(l,$,b,M){this.f(l,{value:$,type:D.EnvironmentVariableMutatorType.Replace,options:b??{applyAtProcessCreation:!0},scope:M})}append(l,$,b,M){this.f(l,{value:$,type:D.EnvironmentVariableMutatorType.Append,options:b??{applyAtProcessCreation:!0},scope:M})}prepend(l,$,b,M){this.f(l,{value:$,type:D.EnvironmentVariableMutatorType.Prepend,options:b??{applyAtProcessCreation:!0},scope:M})}f(l,$){if($.options&&$.options.applyAtProcessCreation===!1&&!$.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const b=this.g(l,$.scope),M=this.map.get(b),U=$.options?{applyAtProcessCreation:$.options.applyAtProcessCreation??!1,applyAtShellIntegration:$.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!M||M.value!==$.value||M.type!==$.type||M.options?.applyAtProcessCreation!==U.applyAtProcessCreation||M.options?.applyAtShellIntegration!==U.applyAtShellIntegration||M.scope?.workspaceFolder?.index!==$.scope?.workspaceFolder?.index){const F=this.g(l,$.scope),q={variable:l,...$,options:U};this.map.set(F,q),this.d.fire()}}get(l,$){const b=this.g(l,$),M=this.map.get(b);return M?E(M):void 0}g(l,$){const b=this.h($);return b.length?`${l}:::${b}`:l}h(l){return this.j(l?.workspaceFolder)??""}j(l){return l?l.uri.toString():void 0}getVariableMap(l){const $=new Map;for(const[b,M]of this.map)this.h(M.scope)===this.h(l)&&$.set(M.variable,E(M));return $}delete(l,$){const b=this.g(l,$);this.map.delete(b),this.d.fire()}clear(l){if(l?.workspaceFolder){for(const[$,b]of this.map)b.scope?.workspaceFolder?.index===l.workspaceFolder.index&&this.map.delete($);this.k(l)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(l,$){const b=this.h($),M=this.descriptionMap.get(b);if(!M||M.description!==l){let U;typeof l=="string"?U=l:U=l?.value.split(`

`)[0];const F={description:U,scope:$};this.descriptionMap.set(b,F),this.d.fire()}}getDescription(l){const $=this.h(l);return this.descriptionMap.get($)?.description}k(l){const $=this.h(l);this.descriptionMap.delete($)}}class i{get persistent(){return this.b.persistent}set persistent(l){this.b.persistent=l}get onDidChangeCollection(){return this.a&&this.a.event}constructor(l,$){this.b=l,this.d=$,this.a=new h.$Ld}getScoped(l){return this.b.getScopedEnvironmentVariableCollection(l)}replace(l,$,b){this.b.replace(l,$,b,this.d)}append(l,$,b){this.b.append(l,$,b,this.d)}prepend(l,$,b){this.b.prepend(l,$,b,this.d)}get(l){return this.b.get(l,this.d)}forEach(l,$){this.b.getVariableMap(this.d).forEach((b,M)=>l.call($,M,b,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(l){this.b.delete(l,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(l){this.b.setDescription(l,this.d)}get description(){return this.b.getDescription(this.d)}}let o=class extends n{constructor(l,$){super(!1,l,$)}createTerminal(l,$,b){throw new A.$0}createTerminalFromOptions(l,$){throw new A.$0}};e.$$bc=o,e.$$bc=o=Je([qe(0,c.$tM),qe(1,R.$0L)],o);function y(P){if(!(!P||typeof P=="string"))return"id"in P?{id:P.id,color:P.color}:P}function g(P){return f.ThemeColor.isThemeColor(P)?P:void 0}function E(P){const l={...P};return delete l.scope,l.options=l.options??void 0,delete l.variable,l}});var Ne=this&&this.__classPrivateFieldGet||function(ie,e,h,C){if(h==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!C:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?C:h==="a"?C.call(ie):C?C.value:e.get(ie)},Ye=this&&this.__classPrivateFieldSet||function(ie,e,h,C,I){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!I:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?I.call(ie,h):I?I.value=h:e.set(ie,h),h};define(Ae[253],Re([1,0,282,12,25,21,5,202,93,6,24,16,37,3,17,104,8,7,45,76,57,26]),function(ie,e,h,C,I,O,R,u,D,d,A,k,a,w,m,f,t,s,c,v,S,p){"use strict";var n,r;Object.defineProperty(e,"__esModule",{value:!0}),e.$idc=e.$hdc=e.$gdc=e.$fdc=void 0;let i=class{constructor(L,z,K){this.k=K,this.d=new R.$Ld,this.f=new Map,this.onResultsChanged=this.d.event,this.results=[],this.g=L.getProxy(w.$9J.MainThreadTesting),this.j=new U(this.g),this.h=new E(this.g),z.registerArgumentProcessor({processArgument:B=>{switch(B?.$mid){case 16:{const me=B,ye=me.tests[me.tests.length-1].item.extId;return this.f.get(c.$2I.root(ye))?.collection.tree.get(ye)?.actual??(0,f.$jM)(B)}case 18:{const{extId:me,message:ye}=B;return{test:this.f.get(c.$2I.root(me))?.collection.tree.get(me)?.actual,message:t.TestMessage.to(ye)}}default:return B}}}),z.registerCommand(!1,"testing.getExplorerSelection",async()=>{const B=await z.executeCommand("_testing.getExplorerSelection"),me=ye=>{const Ie=this.f.get(c.$2I.root(ye));if(Ie)return c.$2I.isRoot(ye)?Ie.controller:Ie.collection.tree.get(ye)?.actual};return{include:B?.include.map(me).filter(k.$Ef)||[],exclude:B?.exclude.map(me).filter(k.$Ef)||[]}})}createTestController(L,z,K,B){if(this.f.has(z))throw new Error(`Attempt to insert a duplicate controller with ID "${z}"`);const me=new d.$Pc,ye=me.add(new f.$mM(z,K,this.k));ye.root.label=K;const Ie=new Map,_=this.g,de={items:ye.root.children,get label(){return K},set label(ue){K=ue,ye.root.label=ue,_.$updateController(z,{label:K})},get refreshHandler(){return B},set refreshHandler(ue){B=ue,_.$updateController(z,{canRefresh:!!ue})},get id(){return z},createRunProfile:(ue,ve,ke,V,Q,ee)=>{let $e=(0,D.$zi)(ue);for(;Ie.has($e);)$e++;return new F(this.g,Ie,z,$e,ue,ve,ke,V,Q,ee)},createTestItem(ue,ve,ke){return new f.$kM(z,ue,ve,ke)},createTestRun:(ue,ve,ke=!0)=>this.h.createTestRun(L,z,ye,ue,ve,ke),invalidateTestResults:ue=>{if(ue===void 0)this.g.$markTestRetired(void 0);else{const ve=ue instanceof Array?ue:[ue];this.g.$markTestRetired(ve.map(ke=>c.$2I.fromExtHostTestItem(ke,z).toString()))}},set resolveHandler(ue){ye.resolveHandler=ue},get resolveHandler(){return ye.resolveHandler},dispose:()=>{me.dispose()}};_.$registerTestController(z,K,!!B),me.add((0,d.$Oc)(()=>_.$unregisterTestController(z)));const De={controller:de,collection:ye,profiles:Ie,extension:L};return this.f.set(z,De),me.add((0,d.$Oc)(()=>this.f.delete(z))),me.add(ye.onDidGenerateDiff(ue=>_.$publishDiff(z,ue.map(S.TestsDiffOp.serialize)))),de}createTestObserver(){return this.j.checkout()}async runTests(L,z=O.CancellationToken.None){const K=P(L);if(!K)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const B=this.f.get(K.controllerId);if(!B)throw new Error("Controller not found");await this.g.$runTests({isUiTriggered:!1,targets:[{testIds:L.include?.map(me=>c.$2I.fromExtHostTestItem(me,B.collection.root.id).toString())??[B.collection.root.id],profileGroup:q[K.kind],profileId:K.profileId,controllerId:K.controllerId}],exclude:L.exclude?.map(me=>me.id)},z)}$syncTests(){for(const{collection:L}of this.f.values())L.flushDiff();return Promise.resolve()}$provideFileCoverage(L,z,K){return(0,h.$pb)(this.h.trackers,me=>me.id===L?me.getCoverage(z):void 0)?.provideFileCoverage(K)??Promise.resolve([])}$resolveFileCoverage(L,z,K,B){return(0,h.$pb)(this.h.trackers,ye=>ye.id===L?ye.getCoverage(z):void 0)?.resolveFileCoverage(K,B)??Promise.resolve([])}$configureRunProfile(L,z){this.f.get(L)?.profiles.get(z)?.configureHandler?.()}async $refreshTests(L,z){await this.f.get(L)?.controller.refreshHandler?.(z)}$publishTestResults(L){this.results=Object.freeze(L.map(z=>(0,A.$Ym)(t.TestResults.to(z))).concat(this.results).sort((z,K)=>K.completedAt-z.completedAt).slice(0,32)),this.d.fire()}async $expandTest(L,z){const K=this.f.get(c.$2I.fromString(L).controllerId)?.collection;K&&(await K.expand(L,z<0?1/0:z),K.flushDiff())}$acceptDiff(L){this.j.applyDiff(L.map(S.TestsDiffOp.deserialize))}async $runControllerTests(L,z){return Promise.all(L.map(K=>this.l(K,!1,z)))}async $startContinuousRun(L,z){const K=new O.$Vd(z),B=await Promise.all(L.map(me=>this.l(me,!0,K.token)));return!z.isCancellationRequested&&!B.some(me=>me.error)&&await new Promise(me=>z.onCancellationRequested(me)),K.dispose(!0),B}async l(L,z,K){const B=this.f.get(L.controllerId);if(!B)return{};const{collection:me,profiles:ye,extension:Ie}=B,_=ye.get(L.profileId);if(!_)return{};const de=L.testIds.map(ke=>me.tree.get(ke)).filter(k.$Ef),De=L.excludeExtIds.map(ke=>B.collection.tree.get(ke)).filter(k.$Ef).filter(ke=>de.some(V=>V.fullId.compare(ke.fullId)===2));if(!de.length)return{};const ue=new s.$GL(de.some(ke=>ke.actual instanceof f.$lM)?void 0:de.map(ke=>ke.actual),De.map(ke=>ke.actual),_,z),ve=(0,S.$4I)(L)&&this.h.prepareForMainThreadTestRun(ue,l.fromInternal(L,B.collection),Ie,K);try{return await _.runHandler(ue,K),{}}catch(ke){return{error:String(ke)}}finally{ve&&(ve.hasRunningTasks&&!K.isCancellationRequested&&await R.Event.toPromise(ve.onEnd),ve.dispose())}}$cancelExtensionTestRun(L){L===void 0?this.h.cancelAllRuns():this.h.cancelRunById(L)}};e.$fdc=i,e.$fdc=i=Je([qe(0,m.$0L)],i);const o=1e4;var y;(function(W){W[W.Running=0]="Running",W[W.Cancelling=1]="Cancelling",W[W.Ended=2]="Ended"})(y||(y={}));class g extends d.$Qc{get hasRunningTasks(){return this.g.size>0}get id(){return this.s.id}constructor(L,z,K,B){super(),this.s=L,this.u=z,this.w=K,this.f=0,this.g=new Map,this.h=new Set,this.m=this.B(new R.$Ld),this.onEnd=this.m.event,this.j=this.B(new O.$Vd(B));const me=this.B(new C.$3g(()=>this.y(),o));this.B(this.j.token.onCancellationRequested(()=>me.schedule()))}cancel(){this.f===0?(this.j.cancel(),this.f=1):this.f===1&&this.y()}getCoverage(L){return this.g.get(L)?.coverage}createRun(L){const z=this.s.id,K=this.s.controllerId,B=(0,a.$bg)(),me=new $(this.u,z,B),ye=De=>(ue,...ve)=>{if(_){console.warn(`Setting the state of test "${ue.id}" is a no-op after the run ends.`);return}this.s.isIncluded(ue)&&(this.C(ue),De(ue,...ve))},Ie=(De,ue)=>{const ve=ue instanceof Array?ue.map(t.TestMessage.from):[t.TestMessage.from(ue)];if(ve.some(ke=>ke.contextValue!==void 0)&&(0,p.$8E)(this.w,"testMessageContextValue"),De.uri&&De.range){const ke={range:t.Range.from(De.range),uri:De.uri};for(const V of ve)V.location=V.location||ke}this.u.$appendTestMessagesInRun(z,B,c.$2I.fromExtHostTestItem(De,K).toString(),ve)};let _=!1;const de={isPersisted:this.s.isPersisted,token:this.j.token,name:L,get coverageProvider(){return me.coverageProvider},set coverageProvider(De){me.coverageProvider=De},enqueued:ye(De=>{this.u.$updateTestStateInRun(z,B,c.$2I.fromExtHostTestItem(De,K).toString(),1)}),skipped:ye(De=>{this.u.$updateTestStateInRun(z,B,c.$2I.fromExtHostTestItem(De,K).toString(),5)}),started:ye(De=>{this.u.$updateTestStateInRun(z,B,c.$2I.fromExtHostTestItem(De,K).toString(),2)}),errored:ye((De,ue,ve)=>{Ie(De,ue),this.u.$updateTestStateInRun(z,B,c.$2I.fromExtHostTestItem(De,K).toString(),6,ve)}),failed:ye((De,ue,ve)=>{Ie(De,ue),this.u.$updateTestStateInRun(z,B,c.$2I.fromExtHostTestItem(De,K).toString(),4,ve)}),passed:ye((De,ue)=>{this.u.$updateTestStateInRun(z,B,c.$2I.fromExtHostTestItem(De,this.s.controllerId).toString(),3,ue)}),appendOutput:(De,ue,ve)=>{_||(ve&&(this.s.isIncluded(ve)?this.C(ve):ve=void 0),this.u.$appendOutputToRun(z,B,I.$_d.fromString(De),ue&&t.location.from(ue),ve&&c.$2I.fromExtHostTestItem(ve,K).toString()))},end:()=>{_||(_=!0,this.u.$finishedTestRunTask(z,B),this.g.delete(B),this.g.size||this.z())}};return this.g.set(B,{run:de,coverage:me}),this.u.$startedTestRunTask(z,{id:B,name:L,running:!0}),de}y(){for(const{run:L}of this.g.values())L.end()}z(){this.f!==2&&(this.f=2,this.m.fire())}C(L){if(!(L instanceof f.$kM))throw new v.$2L(L.id);if(this.h.has(c.$2I.fromExtHostTestItem(L,this.s.controllerId).toString()))return;const z=[],K=this.s.colllection.root;for(;;){const B=t.TestItem.from(L);if(z.unshift(B),this.h.has(B.extId)||(this.h.add(B.extId),L===K))break;L=L.parent||K}this.u.$addTestsToRun(this.s.controllerId,this.s.id,z)}dispose(){this.z(),super.dispose()}}class E{get trackers(){return this.d.values()}constructor(L){this.f=L,this.d=new Map}prepareForMainThreadTestRun(L,z,K,B){return this.g(L,z,K,B)}cancelRunById(L){for(const z of this.d.values())if(z.id===L){z.cancel();return}}cancelAllRuns(){for(const L of this.d.values())L.cancel()}createTestRun(L,z,K,B,me,ye){const Ie=this.d.get(B);if(Ie)return Ie.createRun(me);const _=l.fromPublic(z,K,B,ye),de=P(B);this.f.$startedExtensionTestRun({controllerId:z,continuous:!!B.continuous,profile:de&&{group:q[de.kind],id:de.profileId},exclude:B.exclude?.map(ue=>c.$2I.fromExtHostTestItem(ue,K.root.id).toString())??[],id:_.id,include:B.include?.map(ue=>c.$2I.fromExtHostTestItem(ue,K.root.id).toString())??[K.root.id],persist:ye});const De=this.g(B,_,L);return R.Event.once(De.onEnd)(()=>{this.f.$finishedExtensionTestRun(_.id),De.dispose()}),De.createRun(me)}g(L,z,K,B){const me=new g(z,this.f,K,B);return this.d.set(L,me),R.Event.once(me.onEnd)(()=>this.d.delete(L)),me}}e.$gdc=E;const P=W=>{if(W.profile){if(!(W.profile instanceof F))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return W.profile}};class l{static fromPublic(L,z,K,B){return new l(L,(0,a.$bg)(),K.include?.map(me=>c.$2I.fromExtHostTestItem(me,L).toString())??[L],K.exclude?.map(me=>c.$2I.fromExtHostTestItem(me,L).toString())??[],B,z)}static fromInternal(L,z){return new l(L.controllerId,L.runId,L.testIds,L.excludeExtIds,!0,z)}constructor(L,z,K,B,me,ye){this.controllerId=L,this.id=z,this.isPersisted=me,this.colllection=ye,this.d=K.map(Ie=>Ie+"\0"),this.f=B.map(Ie=>Ie+"\0")}isIncluded(L){const z=c.$2I.fromExtHostTestItem(L,this.controllerId).toString()+"\0";for(const K of this.f)if(z===K||z.startsWith(K))return!1;for(const K of this.d)if(z===K||z.startsWith(K))return!0;return!1}}e.$hdc=l;class ${set coverageProvider(L){if(this.d)throw new Error("The TestCoverageProvider cannot be replaced after being provided");L&&(this.d=L,this.g.$signalCoverageAvailable(this.h,this.j))}get coverageProvider(){return this.d}constructor(L,z,K){this.g=L,this.h=z,this.j=K}async provideFileCoverage(L){if(!this.d)return[];this.f||(this.f=(async()=>this.d.provideFileCoverage(L))());try{return(await this.f)?.map(t.TestCoverage.fromFile)??[]}catch(z){throw this.f=void 0,z}}async resolveFileCoverage(L,z){const K=await this.f;let B=K?.[L];return!this.d||!K||!B?[]:(B.detailedCoverage||(B=K[L]=await this.d.resolveFileCoverage?.(B,z)??B),B.detailedCoverage?.map(t.TestCoverage.fromDetailed)??[])}}class b{get isEmpty(){return this.d.size===0&&this.g.size===0&&this.f.size===0}constructor(L){this.j=L,this.d=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(L){this.d.add(L)}update(L){Object.assign(L.revived,t.TestItem.toPlain(L.item)),this.d.has(L)||this.f.add(L)}remove(L){if(this.d.has(L)){this.d.delete(L);return}this.f.delete(L);const z=c.$2I.parentId(L.item.extId);if(z&&this.h.has(z.toString())){this.h.add(L.item.extId);return}this.g.add(L)}getChangeEvent(){const{d:L,f:z,g:K}=this;return{get added(){return[...L].map(B=>B.revived)},get updated(){return[...z].map(B=>B.revived)},get removed(){return[...K].map(B=>B.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class M extends S.$9I{constructor(){super(...arguments),this.s=new R.$Ld,this.onDidChangeTests=this.s.event}get rootTests(){return this.g}getMirroredTestDataById(L){return this.f.get(L)}getMirroredTestDataByReference(L){return this.f.get(L.id)}q(L,z){return{...L,revived:t.TestItem.toPlain(L.item),depth:z?z.depth+1:0,children:new Set}}p(){return new b(this.s)}}class U{constructor(L){this.f=L}checkout(){this.d||(this.d=this.g());const L=this.d;return L.observers++,{onDidChangeTest:L.tests.onDidChangeTests,get tests(){return[...L.tests.rootTests].map(z=>z.revived)},dispose:(0,u.$bb)(()=>{--L.observers===0&&(this.f.$unsubscribeFromDiffs(),this.d=void 0)})}}getMirroredTestDataByReference(L){return this.d?.tests.getMirroredTestDataByReference(L)}applyDiff(L){this.d?.tests.apply(L)}g(){const L=new M;return this.f.$subscribeToDiffs(),{observers:0,tests:L}}}class F{get label(){return this.f}set label(L){L!==this.f&&(this.f=L,Ne(this,n,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:L}))}get supportsContinuousRun(){return this.h}set supportsContinuousRun(L){L!==this.h&&(this.h=L,Ne(this,n,"f").$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:L}))}get isDefault(){return this.g}set isDefault(L){L!==this.g&&(this.g=L,Ne(this,n,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:L}))}get tag(){return this._tag}set tag(L){L?.id!==this._tag?.id&&(this._tag=L,Ne(this,n,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:L?t.TestTag.namespace(this.controllerId,L.id):null}))}get configureHandler(){return this.d}set configureHandler(L){L!==this.d&&(this.d=L,Ne(this,n,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!L}))}constructor(L,z,K,B,me,ye,Ie,_=!1,de=void 0,De=!1){this.controllerId=K,this.profileId=B,this.f=me,this.kind=ye,this.runHandler=Ie,this.g=_,this._tag=de,this.h=De,n.set(this,void 0),r.set(this,void 0),Ye(this,n,L,"f"),Ye(this,r,z,"f"),z.set(B,this);const ue=q[ye];if(typeof ue!="number")throw new Error(`Unknown TestRunProfile.group ${ye}`);Ne(this,n,"f").$publishTestRunProfile({profileId:B,controllerId:K,tag:de?t.TestTag.namespace(this.controllerId,de.id):null,label:me,group:ue,isDefault:_,hasConfigurationHandler:!1,supportsContinuousRun:De})}dispose(){Ne(this,r,"f")?.delete(this.profileId)&&(Ye(this,r,void 0,"f"),Ne(this,n,"f").$removeTestProfile(this.controllerId,this.profileId))}}e.$idc=F,n=new WeakMap,r=new WeakMap;const q={[s.TestRunProfileKind.Coverage]:8,[s.TestRunProfileKind.Debug]:4,[s.TestRunProfileKind.Run]:2}}),define(Ae[254],Re([1,0,18,9,5,3,105,8,7]),function(ie,e,h,C,I,O,R,u,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xcc=void 0;class d{constructor(k,a){this.i=a,this.a=new I.$Ld({onListenerError:C.$Z}),this.b=new I.$Ld({onListenerError:C.$Z}),this.c=new I.$Ld({onListenerError:C.$Z}),this.d=new I.$Ld({onListenerError:C.$Z}),this.f=new I.$Ld({onListenerError:C.$Z}),this.g=new I.$Ld({onListenerError:C.$Z}),this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=k.getProxy(O.$9J.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(w=>this.g.fire(w)),this.i.onDidChangeActiveTextEditor(w=>this.f.fire(w))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(k){const a=this.i.allEditors();return k?a:a.map(w=>w.value)}async showTextDocument(k,a,w){let m;typeof a=="number"?m={position:u.ViewColumn.from(a),preserveFocus:w}:typeof a=="object"?m={position:u.ViewColumn.from(a.viewColumn),preserveFocus:a.preserveFocus,selection:typeof a.selection=="object"?u.Range.from(a.selection):void 0,pinned:typeof a.preview=="boolean"?!a.preview:void 0}:m={preserveFocus:!1};const f=await this.h.$tryShowTextDocument(k.uri,m),t=f&&this.i.getEditor(f);if(t)return t.value;throw f?new Error(`Could NOT open editor for "${k.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${k.uri.toString()}".`)}createTextEditorDecorationType(k,a){return new R.$eM(this.h,k,a).value}$acceptEditorPropertiesChanged(k,a){const w=this.i.getEditor(k);if(!w)throw new Error("unknown text editor");if(a.options&&w._acceptOptions(a.options),a.selections){const m=a.selections.selections.map(u.Selection.to);w._acceptSelections(m)}if(a.visibleRanges){const m=h.$Fb(a.visibleRanges.map(u.Range.to));w._acceptVisibleRanges(m)}if(a.options&&this.b.fire({textEditor:w.value,options:{...a.options,lineNumbers:u.TextEditorLineNumbersStyle.to(a.options.lineNumbers)}}),a.selections){const m=D.TextEditorSelectionChangeKind.fromValue(a.selections.source),f=a.selections.selections.map(u.Selection.to);this.a.fire({textEditor:w.value,selections:f,kind:m})}if(a.visibleRanges){const m=h.$Fb(a.visibleRanges.map(u.Range.to));this.c.fire({textEditor:w.value,visibleRanges:m})}}$acceptEditorPositionData(k){for(const a in k){const w=this.i.getEditor(a);if(!w)throw new Error("Unknown text editor");const m=u.ViewColumn.to(k[a]);w.value.viewColumn!==m&&(w._acceptViewColumn(m),this.d.fire({textEditor:w.value,viewColumn:m}))}}getDiffInformation(k){return Promise.resolve(this.h.$getDiffInformation(k))}}e.$xcc=d}),define(Ae[255],Re([1,0,2,4,3,6,7,8,20,16]),function(ie,e,h,C,I,O,R,u,D,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$adc=e.$_cc=void 0,e.$_cc=(0,C.$Lh)("IExtHostTimeline");class A{constructor(w,m){this.b=new Map,this.c=new Map,this.a=w.getProxy(I.$9J.MainThreadTimeline),m.registerArgumentProcessor({processArgument:(f,t)=>{if(f&&f.$mid===12)if(this.b.get(f.source)&&D.$Xl.equals(t,this.b.get(f.source)?.extension)){const s=f.uri===void 0?void 0:h.URI.revive(f.uri);return this.c.get(f.source)?.get(k(s))?.get(f.handle)}else return;return f}})}async $getTimeline(w,m,f,t){return this.b.get(w)?.provider.provideTimeline(h.URI.revive(m),f,t)}registerTimelineProvider(w,m,f,t){const s=new O.$Pc,c=this.d(m.id,t,s).bind(this);let v;m.onDidChange&&(v=m.onDidChange(p=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...p,id:m.id}),this));const S=this.c;return this.f({...m,scheme:w,onDidChange:void 0,async provideTimeline(p,n,r){n?.resetCache&&(s.clear(),S.get(m.id)?.clear());const i=await m.provideTimeline(p,n,r);if(i==null)return;const o=c(p,n);return{...i,source:m.id,items:i.items.map(o)}},dispose(){for(const p of S.values())p.get(m.id)?.clear();v?.dispose(),s.dispose()}},f)}d(w,m,f){return(t,s)=>{let c;if(s?.cacheResults){let v=this.c.get(w);v===void 0&&(v=new Map,this.c.set(w,v));const S=k(t);c=v.get(S),c===void 0&&(c=new Map,v.set(S,c))}return v=>{const{iconPath:S,...p}=v,n=`${w}|${v.id??v.timestamp}`;c?.set(n,v);let r,i,o;v.iconPath&&(S instanceof R.$5K?o={id:S.id,color:S.color}:h.URI.isUri(S)?(r=S,i=S):{light:r,dark:i}=S);let y;return R.$yK.isMarkdownString(p.tooltip)?y=u.MarkdownString.from(p.tooltip):(0,d.$wf)(p.tooltip)?y=p.tooltip:R.$yK.isMarkdownString(p.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),y=u.MarkdownString.from(p.detail)):(0,d.$wf)(p.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),y=p.detail),{...p,id:p.id??void 0,handle:n,source:w,command:v.command?m.toInternal(v.command,f):void 0,icon:r,iconDark:i,themeIcon:o,tooltip:y,accessibilityInformation:v.accessibilityInformation}}}}f(w,m){if(this.b.get(w.id))throw new Error(`Timeline Provider ${w.id} already exists.`);return this.a.$registerTimelineProvider({id:w.id,label:w.label,scheme:w.scheme}),this.b.set(w.id,{provider:w,extension:m}),(0,O.$Oc)(()=>{for(const t of this.c.values())t.get(w.id)?.clear();this.b.delete(w.id),this.a.$unregisterTimelineProvider(w.id),w.dispose()})}}e.$adc=A;function k(a){return a?.toString()}}),define(Ae[86],Re([1,0,21,5,6,157,4,14,184,3,27,17,7]),function(ie,e,h,C,I,O,R,u,D,d,A,k,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lsb=e.$ksb=e.TunnelDtoConverter=void 0;class w extends D.$$u{}var m;(function(t){function s(v){return{remoteAddress:v.remoteAddress,localAddress:v.localAddress,public:!!v.public,privacy:v.privacy??(v.public?D.TunnelPrivacyId.Public:D.TunnelPrivacyId.Private),protocol:v.protocol}}t.fromApiTunnel=s;function c(v){return{remoteAddress:{host:v.tunnelRemoteHost,port:v.tunnelRemotePort},localAddress:v.localAddress,public:v.privacy!==D.TunnelPrivacyId.ConstantPrivate&&v.privacy!==D.TunnelPrivacyId.ConstantPrivate,privacy:v.privacy,protocol:v.protocol}}t.fromServiceTunnel=c})(m||(e.TunnelDtoConverter=m={})),e.$ksb=(0,R.$Lh)("IExtHostTunnelService");let f=class extends I.$Qc{constructor(s,c,v){super(),this.s=v,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new C.$Ld,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=s.getProxy(d.$9J.MainThreadTunnelService)}async openTunnel(s,c){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${s.identifier.value} called openTunnel API for ${c.remoteAddress.host}:${c.remoteAddress.port}.`);const v=await this.a.$openTunnel(c,s.displayName);if(v){const S=new w(v.remoteAddress,v.localAddress,()=>this.a.$closeTunnel(v.remoteAddress));return this.B(S),S}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(s,c){const v=this.u();return this.r.set(v,{selector:s,provider:c}),this.a.$registerPortsAttributesProvider(s,v),new a.$$J(()=>{this.r.delete(v),this.a.$unregisterPortsAttributesProvider(v)})}async $providePortAttributes(s,c,v,S,p){const n=[];for(const i of s){const o=this.r.get(i);if(!o)return[];n.push(...await Promise.all(c.map(async y=>{let g;try{g=await o.provider.providePortAttributes({port:y,pid:v,commandLine:S},p)}catch{g=await o.provider.providePortAttributes(y,v,S,p)}return{providedAttributes:g,port:y}})))}const r=n.filter(i=>!!i.providedAttributes);return r.length>0?r.map(i=>({autoForwardAction:i.providedAttributes.autoForwardAction,port:i.port})):[]}async $registerCandidateFinder(s){}registerTunnelProvider(s,c){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(S,p)=>await s.provideTunnel(S,p,new h.$Vd().token)??void 0;const v=c.tunnelFeatures?{elevation:!!c.tunnelFeatures?.elevation,privacyOptions:c.tunnelFeatures?.privacyOptions}:void 0;return this.a.$setTunnelProvider(v),Promise.resolve((0,I.$Oc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(s,c){if(s){s.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(s.candidatePortSource),s.showCandidatePort&&(this.f=s.showCandidatePort,this.a.$setCandidateFilter());const v=s.tunnelFactory??(c?this.w(c):void 0);if(v){this.b=v;let S=s.tunnelFeatures?.privacyOptions??[];s.tunnelFeatures?.public&&S.length===0&&(S=[{id:"private",label:O.localize(0,null),themeIcon:"lock"},{id:"public",label:O.localize(1,null),themeIcon:"eye"}]);const p=s.tunnelFeatures?{elevation:!!s.tunnelFeatures?.elevation,public:!!s.tunnelFeatures?.public,privacyOptions:S}:void 0;this.a.$setTunnelProvider(p)}}else this.b=void 0;return(0,I.$Oc)(()=>{this.b=void 0})}w(s){}async $closeTunnel(s,c){if(this.g.has(s.host)){const v=this.g.get(s.host);v.has(s.port)&&(c&&v.get(s.port).disposeListener.dispose(),await v.get(s.port).tunnel.dispose(),v.delete(s.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(s,c){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const v=this.b(s,c);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),v!==void 0){const S=await v;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),S===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(s.remoteAddress.host)||this.g.set(s.remoteAddress.host,new Map);const p=this.B(S.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(S.remoteAddress))));return this.g.get(s.remoteAddress.host).set(s.remoteAddress.port,{tunnel:S,disposeListener:p}),m.fromApiTunnel(S)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(v){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),v instanceof Error)return v.message}}async $applyCandidateFilter(s){const c=await Promise.all(s.map(S=>this.f(S.host,S.port,S.detail??""))),v=s.filter((S,p)=>c[p]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${s.map(S=>S.port).join(", ")} to ${v.map(S=>S.port).join(", ")}`),v}};e.$lsb=f,e.$lsb=f=Je([qe(0,k.$0L),qe(1,A.$nM),qe(2,u.$6i)],f)}),define(Ae[256],Re([1,0,6,13,2,3]),function(ie,e,h,C,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jdc=void 0;class R{constructor(D){this.c=new Map,this.b=D.getProxy(O.$9J.MainThreadUriOpeners)}registerExternalUriOpener(D,d,A,k){if(this.c.has(d))throw new Error(`Opener with id '${d}' already registered`);const a=k.schemes.find(w=>!R.a.has(w));if(a)throw new Error(`Scheme '${a}' is not supported. Only http and https are currently supported.`);return this.c.set(d,A),this.b.$registerUriOpener(d,k.schemes,D,k.label),(0,h.$Oc)(()=>{this.c.delete(d),this.b.$unregisterUriOpener(d)})}async $canOpenUri(D,d,A){const k=this.c.get(D);if(!k)throw new Error(`Unknown opener with id: ${D}`);const a=I.URI.revive(d);return k.canOpenExternalUri(a,A)}async $openUri(D,d,A){const k=this.c.get(D);if(!k)throw new Error(`Unknown opener id: '${D}'`);return k.openExternalUri(I.URI.revive(d.resolvedUri),{sourceUri:I.URI.revive(d.sourceUri)},A)}}e.$jdc=R,R.a=new Set([C.Schemas.http,C.Schemas.https])}),define(Ae[257],Re([1,0,3,2,6,9,20]),function(ie,e,h,C,I,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zcc=void 0;class u{constructor(d){this.c=new R.$Yl,this.d=new Map,this.b=d.getProxy(h.$9J.MainThreadUrls)}registerUriHandler(d,A){const k=d.identifier;if(this.c.has(k))throw new Error(`Protocol handler already registered for extension ${k}`);const a=u.a++;return this.c.add(k),this.d.set(a,A),this.b.$registerUriHandler(a,k,d.displayName||d.name),(0,I.$Oc)(()=>{this.c.delete(k),this.d.delete(a),this.b.$unregisterUriHandler(a)})}$handleExternalUri(d,A){const k=this.d.get(d);if(!k)return Promise.resolve(void 0);try{k.handleUri(C.URI.revive(A))}catch(a){(0,O.$Y)(a)}return Promise.resolve(void 0)}async createAppUri(d){return C.URI.revive(await this.b.$createAppUri(d))}}e.$zcc=u,u.a=0});var Ye=this&&this.__classPrivateFieldSet||function(ie,e,h,C,I){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!I:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?I.call(ie,h):I?I.value=h:e.set(ie,h),h},Ne=this&&this.__classPrivateFieldGet||function(ie,e,h,C){if(h==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!C:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?C:h==="a"?C.call(ie):C?C.value:e.get(ie)};define(Ae[64],Re([1,0,5,6,13,24,2,169,191,77,3]),function(ie,e,h,C,I,O,R,u,D,d,A){"use strict";var k,a,w,m,f,t,s,c,v,S,p,n,r;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ecc=e.$Dcc=e.$Ccc=e.$Bcc=e.$Acc=void 0;class i{constructor(M,U,F,q,W,L,z){k.set(this,void 0),a.set(this,void 0),w.set(this,void 0),m.set(this,void 0),f.set(this,void 0),t.set(this,void 0),s.set(this,""),c.set(this,void 0),v.set(this,!1),S.set(this,!1),p.set(this,void 0),n.set(this,void 0),this._onMessageEmitter=new h.$Ld,this.onDidReceiveMessage=this._onMessageEmitter.event,r.set(this,new h.$Ld),this._onDidDispose=Ne(this,r,"f").event,Ye(this,k,M,"f"),Ye(this,a,U,"f"),Ye(this,c,F,"f"),Ye(this,m,q,"f"),Ye(this,f,W,"f"),Ye(this,t,L,"f"),Ye(this,p,o(L),"f"),Ye(this,n,y(L),"f"),Ye(this,w,z,"f")}dispose(){Ye(this,v,!0,"f"),Ne(this,r,"f").fire(),Ne(this,r,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(M){return Ye(this,S,!0,"f"),(0,d.$Yob)(M,Ne(this,m,"f"))}get cspSource(){const M=Ne(this,t,"f").extensionLocation;if(M.scheme===I.Schemas.https||M.scheme===I.Schemas.http){let U=M.toString();return U.endsWith("/")||(U+="/"),U+" "+d.$Xob}return d.$Xob}get html(){return this.a(),Ne(this,s,"f")}set html(M){this.a(),Ne(this,s,"f")!==M&&(Ye(this,s,M,"f"),Ne(this,n,"f")&&!Ne(this,S,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(M)&&(Ye(this,S,!0,"f"),Ne(this,w,"f").report("Webview vscode-resource: uris",Ne(this,t,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Ne(this,a,"f").$setHtml(Ne(this,k,"f"),this.b(M)))}get options(){return this.a(),Ne(this,c,"f")}set options(M){this.a(),O.$2m(Ne(this,c,"f"),M)||Ne(this,a,"f").$setOptions(Ne(this,k,"f"),P(Ne(this,t,"f"),Ne(this,f,"f"),M)),Ye(this,c,M,"f")}async postMessage(M){if(Ne(this,v,"f"))return!1;const U=(0,D.$lcb)(M,{serializeBuffersForPostMessage:Ne(this,p,"f")});return Ne(this,a,"f").$postMessage(Ne(this,k,"f"),U.message,...U.buffers)}a(){if(Ne(this,v,"f"))throw new Error("Webview is disposed")}b(M){if(!Ne(this,n,"f"))return M;const U=Ne(this,t,"f").extensionLocation?.scheme===I.Schemas.vscodeRemote,F=Ne(this,t,"f").extensionLocation.scheme===I.Schemas.vscodeRemote?Ne(this,t,"f").extensionLocation.authority:void 0;return M.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(q,W,L,z,K,B)=>{const me=R.URI.from({scheme:z||"file",path:decodeURIComponent(K)}),ye=(0,d.$Yob)(me,{isRemote:U,authority:F}).toString();return`${W}${ye}${B}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(q,W,L,z,K,B)=>{const me=R.URI.from({scheme:z||"file",path:decodeURIComponent(K)}),ye=(0,d.$Yob)(me,{isRemote:U,authority:F}).toString();return`${W}${ye}${B}`})}}e.$Acc=i,k=new WeakMap,a=new WeakMap,w=new WeakMap,m=new WeakMap,f=new WeakMap,t=new WeakMap,s=new WeakMap,c=new WeakMap,v=new WeakMap,S=new WeakMap,p=new WeakMap,n=new WeakMap,r=new WeakMap;function o(b){try{const M=(0,u.$Fo)((0,u.$Eo)(b.engines.vscode));return!!M&&M.majorBase>=1&&M.minorBase>=57}catch{return!1}}e.$Bcc=o;function y(b){try{const M=(0,u.$Fo)((0,u.$Eo)(b.engines.vscode));return M?M.majorBase<1||M.majorBase===1&&M.minorBase<60:!1}catch{return!1}}class g extends C.$Qc{constructor(M,U,F,q,W){super(),this.c=U,this.f=F,this.g=q,this.h=W,this.b=new Map,this.a=M.getProxy(A.$9J.MainThreadWebviews)}dispose(){super.dispose();for(const M of this.b.values())M.dispose();this.b.clear()}$onMessage(M,U,F){const q=this.j(M);if(q){const{message:W}=(0,D.$mcb)(U,F.value);q._onMessageEmitter.fire(W)}}$onMissingCsp(M,U){this.g.warn(`${U} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(M,U,F){const q=new i(M,this.a,l(U),this.c,this.f,F,this.h);this.b.set(M,q);const W=q._onDidDispose(()=>{W.dispose(),this.deleteWebview(M)});return q}deleteWebview(M){this.b.delete(M)}j(M){return this.b.get(M)}}e.$Ccc=g;function E(b){return{id:b.identifier,location:b.extensionLocation}}e.$Dcc=E;function P(b,M,U){return{enableCommandUris:U.enableCommandUris,enableScripts:U.enableScripts,enableForms:U.enableForms,portMapping:U.portMapping,localResourceRoots:U.localResourceRoots||$(b,M)}}e.$Ecc=P;function l(b){return{enableCommandUris:b.enableCommandUris,enableScripts:b.enableScripts,enableForms:b.enableForms,portMapping:b.portMapping,localResourceRoots:b.localResourceRoots?.map(M=>R.URI.from(M))}}function $(b,M){return[...(M?.getWorkspaceFolders()||[]).map(U=>U.uri),b.extensionLocation]}}),define(Ae[258],Re([1,0,21,93,6,13,23,2,8,64,55,3,7]),function(ie,e,h,C,I,O,R,u,D,d,A,k,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ddc=void 0;class w{constructor(r,i){this.document=r,this.b=i,this.a=1,this.c=new A.$wbc("custom documents")}addEdit(r){return this.c.add([r])}async undo(r,i){await this.f(r).undo(),i||this.disposeBackup()}async redo(r,i){await this.f(r).redo(),i||this.disposeBackup()}disposeEdits(r){for(const i of r)this.c.delete(i)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const r=p(this.document.uri)+this.a++;return(0,R.$sg)(this.b,r)}updateBackup(r){this.d?.delete(),this.d=r}disposeBackup(){this.d?.delete(),this.d=void 0}f(r){const i=this.c.get(r,0);if(!i)throw new Error("No edit found");return i}}class m{constructor(){this.a=new Map}get(r,i){return this.a.get(this.b(r,i))}add(r,i,o){const y=this.b(r,i.uri);if(this.a.has(y))throw new Error(`Document already exists for viewType:${r} resource:${i.uri}`);const g=new w(i,o);return this.a.set(y,g),g}delete(r,i){const o=this.b(r,i.uri);this.a.delete(o)}b(r,i){return`${r}@@@${i}`}}var f;(function(n){n[n.Text=0]="Text",n[n.Custom=1]="Custom"})(f||(f={}));class t{constructor(){this.a=new Map}addTextProvider(r,i,o){return this.b(0,r,i,o)}addCustomProvider(r,i,o){return this.b(1,r,i,o)}get(r){return this.a.get(r)}b(r,i,o,y){if(this.a.has(i))throw new Error(`Provider for viewType:${i} already registered`);return this.a.set(i,{type:r,extension:o,provider:y}),new a.$$J(()=>this.a.delete(i))}}class s{constructor(r,i,o,y,g){this.d=i,this.f=o,this.g=y,this.h=g,this.b=new t,this.c=new m,this.a=r.getProxy(k.$9J.MainThreadCustomEditors)}registerCustomEditorProvider(r,i,o,y){const g=new I.$Pc;return v(o)?(g.add(this.b.addTextProvider(i,r,o)),this.a.$registerTextEditorProvider((0,d.$Dcc)(r),i,y.webviewOptions||{},{supportsMove:!!o.moveCustomTextEditor},(0,d.$Bcc)(r))):(g.add(this.b.addCustomProvider(i,r,o)),c(o)&&g.add(o.onDidChangeCustomDocument(E=>{const P=this.i(i,E.document.uri);if(S(E)){const l=P.addEdit(E);this.a.$onDidEdit(E.document.uri,i,l,E.label)}else this.a.$onContentChange(E.document.uri,i)})),this.a.$registerCustomEditorProvider((0,d.$Dcc)(r),i,y.webviewOptions||{},!!y.supportsMultipleEditorsPerDocument,(0,d.$Bcc)(r))),a.$$J.from(g,new a.$$J(()=>{this.a.$unregisterEditorProvider(i)}))}async $createCustomDocument(r,i,o,y,g){const E=this.b.get(i);if(!E)throw new Error(`No provider found for '${i}'`);if(E.type!==1)throw new Error(`Invalid provide type for '${i}'`);const P=u.URI.revive(r),l=await E.provider.openCustomDocument(P,{backupId:o,untitledDocumentData:y?.buffer},g);let $;return c(E.provider)&&this.f&&($=this.f.workspaceValue(E.extension)??this.f.globalValue(E.extension)),this.c.add(i,l,$),{editable:c(E.provider)}}async $disposeCustomDocument(r,i){const o=this.b.get(i);if(!o)throw new Error(`No provider found for '${i}'`);if(o.type!==1)throw new Error(`Invalid provider type for '${i}'`);const y=u.URI.revive(r),{document:g}=this.i(i,y);this.c.delete(i,g),g.dispose()}async $resolveCustomEditor(r,i,o,y,g,E){const P=this.b.get(o);if(!P)throw new Error(`No provider found for '${o}'`);const l=D.ViewColumn.to(g),$=this.g.createNewWebview(i,y.contentOptions,P.extension),b=this.h.createNewWebviewPanel(i,o,y.title,l,y.options,$,y.active),M=u.URI.revive(r);switch(P.type){case 1:{const{document:U}=this.i(o,M);return P.provider.resolveCustomEditor(U,b,E)}case 0:{const U=this.d.getDocument(M);return P.provider.resolveCustomTextEditor(U,b,E)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(r,i,o){this.i(i,r).disposeEdits(o)}async $onMoveCustomEditor(r,i,o){const y=this.b.get(o);if(!y)throw new Error(`No provider found for '${o}'`);if(!y.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${o}'`);const g=this.h.getWebviewPanel(r);if(!g)throw new Error("No webview found");const E=u.URI.revive(i),P=this.d.getDocument(E);await y.provider.moveCustomTextEditor(P,g,h.CancellationToken.None)}async $undo(r,i,o,y){return this.i(i,r).undo(o,y)}async $redo(r,i,o,y){return this.i(i,r).redo(o,y)}async $revert(r,i,o){const y=this.i(i,r);await this.j(i).revertCustomDocument(y.document,o),y.disposeBackup()}async $onSave(r,i,o){const y=this.i(i,r);await this.j(i).saveCustomDocument(y.document,o),y.disposeBackup()}async $onSaveAs(r,i,o,y){const g=this.i(i,r);return this.j(i).saveCustomDocumentAs(g.document,u.URI.revive(o),y)}async $backup(r,i,o){const y=this.i(i,r),E=await this.j(i).backupCustomDocument(y.document,{destination:y.getNewBackupUri()},o);return y.updateBackup(E),E.id}i(r,i){const o=this.c.get(r,u.URI.revive(i));if(!o)throw new Error("No custom document found");return o}j(r){const o=this.b.get(r)?.provider;if(!o||!c(o))throw new Error("Custom document is not editable");return o}}e.$ddc=s;function c(n){return!!n.onDidChangeCustomDocument}function v(n){return typeof n.resolveCustomTextEditor=="function"}function S(n){return typeof n.undo=="function"&&typeof n.redo=="function"}function p(n){const r=n.scheme===O.Schemas.file||n.scheme===O.Schemas.untitled?n.fsPath:n.toString();return(0,C.$zi)(r)+""}});var Ye=this&&this.__classPrivateFieldSet||function(ie,e,h,C,I){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!I:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?I.call(ie,h):I?I.value=h:e.set(ie,h),h},Ne=this&&this.__classPrivateFieldGet||function(ie,e,h,C){if(h==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!C:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?C:h==="a"?C.call(ie):C?C.value:e.get(ie)};define(Ae[259],Re([1,0,5,6,2,37,8,64,3,7]),function(ie,e,h,C,I,O,R,u,D,d){"use strict";var A,k,a,w,m,f,t,s,c,v,S,p,n;Object.defineProperty(e,"__esModule",{value:!0}),e.$cdc=void 0;class r extends C.$Qc{constructor(g,E,P,l){super(),A.set(this,void 0),k.set(this,void 0),a.set(this,void 0),w.set(this,void 0),m.set(this,void 0),f.set(this,void 0),t.set(this,void 0),s.set(this,void 0),c.set(this,!0),v.set(this,void 0),S.set(this,!1),p.set(this,this.B(new h.$Ld)),this.onDidDispose=Ne(this,p,"f").event,n.set(this,this.B(new h.$Ld)),this.onDidChangeViewState=Ne(this,n,"f").event,Ye(this,A,g,"f"),Ye(this,k,E,"f"),Ye(this,w,P,"f"),Ye(this,a,l.viewType,"f"),Ye(this,m,l.panelOptions,"f"),Ye(this,s,l.viewColumn,"f"),Ye(this,f,l.title,"f"),Ye(this,v,l.active,"f")}dispose(){Ne(this,S,"f")||(Ye(this,S,!0,"f"),Ne(this,p,"f").fire(),Ne(this,k,"f").$disposeWebview(Ne(this,A,"f")),Ne(this,w,"f").dispose(),super.dispose())}get webview(){return this.c(),Ne(this,w,"f")}get viewType(){return this.c(),Ne(this,a,"f")}get title(){return this.c(),Ne(this,f,"f")}set title(g){this.c(),Ne(this,f,"f")!==g&&(Ye(this,f,g,"f"),Ne(this,k,"f").$setTitle(Ne(this,A,"f"),g))}get iconPath(){return this.c(),Ne(this,t,"f")}set iconPath(g){this.c(),Ne(this,t,"f")!==g&&(Ye(this,t,g,"f"),Ne(this,k,"f").$setIconPath(Ne(this,A,"f"),I.URI.isUri(g)?{light:g,dark:g}:g))}get options(){return Ne(this,m,"f")}get viewColumn(){if(this.c(),!(typeof Ne(this,s,"f")=="number"&&Ne(this,s,"f")<0))return Ne(this,s,"f")}get active(){return this.c(),Ne(this,v,"f")}get visible(){return this.c(),Ne(this,c,"f")}_updateViewState(g){Ne(this,S,"f")||(this.active!==g.active||this.visible!==g.visible||this.viewColumn!==g.viewColumn)&&(Ye(this,v,g.active,"f"),Ye(this,c,g.visible,"f"),Ye(this,s,g.viewColumn,"f"),Ne(this,n,"f").fire({webviewPanel:this}))}reveal(g,E){this.c(),Ne(this,k,"f").$reveal(Ne(this,A,"f"),{viewColumn:typeof g>"u"?void 0:R.ViewColumn.from(g),preserveFocus:!!E})}c(){if(Ne(this,S,"f"))throw new Error("Webview is disposed")}}A=new WeakMap,k=new WeakMap,a=new WeakMap,w=new WeakMap,m=new WeakMap,f=new WeakMap,t=new WeakMap,s=new WeakMap,c=new WeakMap,v=new WeakMap,S=new WeakMap,p=new WeakMap,n=new WeakMap;class i extends C.$Qc{static c(){return(0,O.$bg)()}constructor(g,E,P){super(),this.j=E,this.m=P,this.g=new Map,this.h=new Map,this.f=g.getProxy(D.$9J.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(g=>g.dispose()),this.g.clear()}createWebviewPanel(g,E,P,l,$={}){const b=typeof l=="object"?l.viewColumn:l,M={viewColumn:R.ViewColumn.from(b),preserveFocus:typeof l=="object"&&!!l.preserveFocus},U=(0,u.$Bcc)(g),F=i.c();this.f.$createWebviewPanel((0,u.$Dcc)(g),F,E,{title:P,panelOptions:o($),webviewOptions:(0,u.$Ecc)(g,this.m,$),serializeBuffersForPostMessage:U},M);const q=this.j.createNewWebview(F,$,g);return this.createNewWebviewPanel(F,E,P,b,$,q,!0)}$onDidChangeWebviewPanelViewStates(g){const E=Object.keys(g);E.sort((P,l)=>{const $=g[P],b=g[l];return $.active?1:b.active?-1:+$.visible-+b.visible});for(const P of E){const l=this.getWebviewPanel(P);if(!l)continue;const $=g[P];l._updateViewState({active:$.active,visible:$.visible,viewColumn:R.ViewColumn.to($.position)})}}async $onDidDisposeWebviewPanel(g){this.getWebviewPanel(g)?.dispose(),this.g.delete(g),this.j.deleteWebview(g)}registerWebviewPanelSerializer(g,E,P){if(this.h.has(E))throw new Error(`Serializer for '${E}' already registered`);return this.h.set(E,{serializer:P,extension:g}),this.f.$registerSerializer(E,{serializeBuffersForPostMessage:(0,u.$Bcc)(g)}),new d.$$J(()=>{this.h.delete(E),this.f.$unregisterSerializer(E)})}async $deserializeWebviewPanel(g,E,P,l){const $=this.h.get(E);if(!$)throw new Error(`No serializer found for '${E}'`);const{serializer:b,extension:M}=$,U=this.j.createNewWebview(g,P.webviewOptions,M),F=this.createNewWebviewPanel(g,E,P.title,l,P.panelOptions,U,P.active);await b.deserializeWebviewPanel(F,P.state)}createNewWebviewPanel(g,E,P,l,$,b,M){const U=new r(g,this.f,b,{viewType:E,title:P,viewColumn:l,panelOptions:$,active:M});return this.g.set(g,U),U}getWebviewPanel(g){return this.g.get(g)}}e.$cdc=i;function o(y){return{enableFindWidget:y.enableFindWidget,retainContextWhenHidden:y.retainContextWhenHidden}}});var Ye=this&&this.__classPrivateFieldSet||function(ie,e,h,C,I){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!I:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?I.call(ie,h):I?I.value=h:e.set(ie,h),h},Ne=this&&this.__classPrivateFieldGet||function(ie,e,h,C){if(h==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!C:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?C:h==="a"?C.call(ie):C?C.value:e.get(ie)};define(Ae[260],Re([1,0,5,6,64,8,3,7]),function(ie,e,h,C,I,O,R,u){"use strict";var D,d,A,k,a,w,m,f,t,s,c;Object.defineProperty(e,"__esModule",{value:!0}),e.$bdc=void 0;class v extends C.$Qc{constructor(n,r,i,o,y,g){super(),D.set(this,void 0),d.set(this,void 0),A.set(this,void 0),k.set(this,void 0),a.set(this,!1),w.set(this,void 0),m.set(this,void 0),f.set(this,void 0),t.set(this,void 0),s.set(this,this.B(new h.$Ld)),this.onDidChangeVisibility=Ne(this,s,"f").event,c.set(this,this.B(new h.$Ld)),this.onDidDispose=Ne(this,c,"f").event,Ye(this,A,i,"f"),Ye(this,m,o,"f"),Ye(this,D,n,"f"),Ye(this,d,r,"f"),Ye(this,k,y,"f"),Ye(this,w,g,"f")}dispose(){Ne(this,a,"f")||(Ye(this,a,!0,"f"),Ne(this,c,"f").fire(),Ne(this,k,"f").dispose(),super.dispose())}get title(){return this.a(),Ne(this,m,"f")}set title(n){this.a(),Ne(this,m,"f")!==n&&(Ye(this,m,n,"f"),Ne(this,d,"f").$setWebviewViewTitle(Ne(this,D,"f"),n))}get description(){return this.a(),Ne(this,f,"f")}set description(n){this.a(),Ne(this,f,"f")!==n&&(Ye(this,f,n,"f"),Ne(this,d,"f").$setWebviewViewDescription(Ne(this,D,"f"),n))}get visible(){return Ne(this,w,"f")}get webview(){return Ne(this,k,"f")}get viewType(){return Ne(this,A,"f")}_setVisible(n){n===Ne(this,w,"f")||Ne(this,a,"f")||(Ye(this,w,n,"f"),Ne(this,s,"f").fire())}get badge(){return this.a(),Ne(this,t,"f")}set badge(n){this.a(),!(n?.value===Ne(this,t,"f")?.value&&n?.tooltip===Ne(this,t,"f")?.tooltip)&&(Ye(this,t,O.ViewBadge.from(n),"f"),Ne(this,d,"f").$setWebviewViewBadge(Ne(this,D,"f"),n))}show(n){this.a(),Ne(this,d,"f").$show(Ne(this,D,"f"),!!n)}a(){if(Ne(this,a,"f"))throw new Error("Webview is disposed")}}D=new WeakMap,d=new WeakMap,A=new WeakMap,k=new WeakMap,a=new WeakMap,w=new WeakMap,m=new WeakMap,f=new WeakMap,t=new WeakMap,s=new WeakMap,c=new WeakMap;class S{constructor(n,r){this.d=r,this.b=new Map,this.c=new Map,this.a=n.getProxy(R.$9J.MainThreadWebviewViews)}registerWebviewViewProvider(n,r,i,o){if(this.b.has(r))throw new Error(`View provider for '${r}' already registered`);return this.b.set(r,{provider:i,extension:n}),this.a.$registerWebviewViewProvider((0,I.$Dcc)(n),r,{retainContextWhenHidden:o?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,I.$Bcc)(n)}),new u.$$J(()=>{this.b.delete(r),this.a.$unregisterWebviewViewProvider(r)})}async $resolveWebviewView(n,r,i,o,y){const g=this.b.get(r);if(!g)throw new Error(`No view provider found for '${r}'`);const{provider:E,extension:P}=g,l=this.d.createNewWebview(n,{},P),$=new v(n,this.a,r,i,l,!0);this.c.set(n,$),await E.resolveWebviewView($,{state:o},y)}async $onDidChangeWebviewViewVisibility(n,r){this.e(n)._setVisible(r)}async $disposeWebviewView(n){const r=this.e(n);this.c.delete(n),r.dispose(),this.d.deleteWebview(n)}e(n){const r=this.c.get(n);if(!r)throw new Error("No webview found");return r}}e.$bdc=S}),define(Ae[108],Re([1,0,5,3,2,13,15,4,17,26]),function(ie,e,h,C,I,O,R,u,D,d){"use strict";var A;Object.defineProperty(e,"__esModule",{value:!0}),e.$Gcc=e.$Fcc=void 0;let k=A=class{getState(w){const m=this.d;return{get focused(){return m.focused},get active(){return(0,d.$8E)(w,"windowActivity"),m.active}}}constructor(w){this.c=new h.$Ld,this.onDidChangeWindowState=this.c.event,this.d=A.a,this.b=w.getProxy(C.$9J.MainThreadWindow),this.b.$getInitialState().then(({isFocused:m,isActive:f})=>{this.onDidChangeWindowProperty("focused",m),this.onDidChangeWindowProperty("active",f)})}$onDidChangeWindowFocus(w){this.onDidChangeWindowProperty("focused",w)}$onDidChangeWindowActive(w){this.onDidChangeWindowProperty("active",w)}onDidChangeWindowProperty(w,m){m!==this.d[w]&&(this.d={...this.d,[w]:m},this.c.fire(this.d))}openUri(w,m){let f;if(typeof w=="string"){f=w;try{w=I.URI.parse(w)}catch{return Promise.reject(`Invalid uri - '${w}'`)}}return(0,R.$ze)(w.scheme)?Promise.reject("Invalid scheme - cannot be empty"):w.scheme===O.Schemas.command?Promise.reject(`Invalid scheme '${w.scheme}'`):this.b.$openUri(w,f,m)}async asExternalUri(w,m){if((0,R.$ze)(w.scheme))return Promise.reject("Invalid scheme - cannot be empty");const f=await this.b.$asExternalUri(w,m);return I.URI.from(f)}};e.$Fcc=k,k.a={focused:!0,active:!0},e.$Fcc=k=A=Je([qe(0,D.$0L)],k),e.$Gcc=(0,u.$Lh)("IExtHostWindow")}),define(Ae[261],Re([1,0,227,27,17]),function(ie,e,h,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mfc=void 0;let O=class extends h.$Fdc{constructor(u,D){super(u,D)}f(u,D,d){D.apply(console,d)}};e.$Mfc=O,e.$Mfc=O=Je([qe(0,I.$0L),qe(1,C.$nM)],O)}),define(Ae[262],Re([1,0,12,25,21,9,5,6,123,215,46]),function(ie,e,h,C,I,O,R,u,D,d,A){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.$b4b=e.ResponsiveState=e.RequestInitiator=e.$a4b=e.$_3b=void 0;function a(b,M){try{return JSON.stringify(b,M)}catch{return"null"}}const w="$$ref$$",m={[w]:-1};class f{constructor(M,U){this.jsonString=M,this.referencedBuffers=U}}function t(b,M=null,U=!1){const F=[];return{jsonString:(U?a:JSON.stringify)(b,(W,L)=>{if(typeof L>"u")return m;if(typeof L=="object"){if(L instanceof C.$_d){const z=F.push(L)-1;return{[w]:z}}if(M)return M(W,L)}return L}),referencedBuffers:F}}e.$_3b=t;function s(b,M,U){return JSON.parse(b,(F,q)=>{if(q){const W=q[w];if(typeof W=="number")return M[W];if(U&&q.$mid===1)return U.transformIncoming(q)}return q})}e.$a4b=s;function c(b,M){return JSON.stringify(b,M)}function v(b){return b?(M,U)=>U&&U.$mid===1?b.transformOutgoing(U):U:null}var S;(function(b){b[b.LocalSide=0]="LocalSide",b[b.OtherSide=1]="OtherSide"})(S||(e.RequestInitiator=S={}));var p;(function(b){b[b.Responsive=0]="Responsive",b[b.Unresponsive=1]="Unresponsive"})(p||(e.ResponsiveState=p={}));const n=()=>{},r=Symbol.for("rpcProtocol"),i=Symbol.for("rpcProxy");class o extends u.$Qc{constructor(M,U=null,F=null){super(),this[k]=!0,this.b=this.B(new R.$Ld),this.onDidChangeResponsiveState=this.b.event,this.c=M,this.f=U,this.g=F,this.h=v(this.g),this.j=!1,this.m=[],this.s=[];for(let q=0,W=A.$fv.count;q<W;q++)this.m[q]=null,this.s[q]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new h.$3g(()=>this.H(),1e3)),this.c.onMessage(q=>this.L(q))}dispose(){this.j=!0,Object.keys(this.w).forEach(M=>{const U=this.w[M];delete this.w[M],U.resolveErr(O.$4())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(M){this.z===0&&(this.C=Date.now()+o.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(M){this.C=Date.now()+o.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(M){this.y!==M&&(this.y=M,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(M){return this.g?(0,D.$Gm)(M,this.g):M}getProxy(M){const{nid:U,sid:F}=M;return this.s[U]||(this.s[U]=this.J(U,F)),this.s[U]}J(M,U){const F={get:(q,W)=>(typeof W=="string"&&!q[W]&&W.charCodeAt(0)===36&&(q[W]=(...L)=>this.U(M,W,L)),W===i?U:q[W])};return new Proxy(Object.create(null),F)}set(M,U){return this.m[M.nid]=U,U}assertRegistered(M){for(let U=0,F=M.length;U<F;U++){const q=M[U];if(!this.m[q.nid])throw new Error(`Missing proxy instance ${q.sid}`)}}L(M){if(this.j)return;const U=M.byteLength,F=g.read(M,0),q=F.readUInt8(),W=F.readUInt32();switch(q){case 1:case 2:{let{rpcId:L,method:z,args:K}=P.deserializeRequestJSONArgs(F);this.g&&(K=(0,D.$Gm)(K,this.g)),this.M(U,W,L,z,K,q===2);break}case 3:case 4:{let{rpcId:L,method:z,args:K}=P.deserializeRequestMixedArgs(F);this.g&&(K=(0,D.$Gm)(K,this.g)),this.M(U,W,L,z,K,q===4);break}case 5:{this.f?.logIncoming(U,W,0,"ack"),this.G(W);break}case 6:{this.N(U,W);break}case 7:{this.O(U,W,void 0);break}case 9:{let L=P.deserializeReplyOKJSON(F);this.g&&(L=(0,D.$Gm)(L,this.g)),this.O(U,W,L);break}case 10:{const L=P.deserializeReplyOKJSONWithBuffers(F,this.g);this.O(U,W,L);break}case 8:{const L=P.deserializeReplyOKVSBuffer(F);this.O(U,W,L);break}case 11:{let L=P.deserializeReplyErrError(F);this.g&&(L=(0,D.$Gm)(L,this.g)),this.P(U,W,L);break}case 12:{this.P(U,W,void 0);break}default:console.error("received unexpected message"),console.error(M)}}M(M,U,F,q,W,L){this.f?.logIncoming(M,U,1,`receiveRequest ${(0,A.$hv)(F)}.${q}(`,W);const z=String(U);let K,B;if(L){const ye=new I.$Vd;W.push(ye.token),K=this.Q(F,q,W),B=()=>ye.cancel()}else K=this.Q(F,q,W),B=n;this.u[z]=B;const me=P.serializeAcknowledged(U);this.f?.logOutgoing(me.byteLength,U,1,"ack"),this.c.send(me),K.then(ye=>{delete this.u[z];const Ie=P.serializeReplyOK(U,ye,this.h);this.f?.logOutgoing(Ie.byteLength,U,1,"reply:",ye),this.c.send(Ie)},ye=>{delete this.u[z];const Ie=P.serializeReplyErr(U,ye);this.f?.logOutgoing(Ie.byteLength,U,1,"replyErr:",ye),this.c.send(Ie)})}N(M,U){this.f?.logIncoming(M,U,1,"receiveCancel");const F=String(U);this.u[F]?.()}O(M,U,F){this.f?.logIncoming(M,U,0,"receiveReply:",F);const q=String(U);if(!this.w.hasOwnProperty(q))return;const W=this.w[q];delete this.w[q],W.resolveOk(F)}P(M,U,F){this.f?.logIncoming(M,U,0,"receiveReplyErr:",F);const q=String(U);if(!this.w.hasOwnProperty(q))return;const W=this.w[q];delete this.w[q];let L;F&&(F.$isError?(L=new Error,L.name=F.name,L.message=F.message,L.stack=F.stack):L=F),W.resolveErr(L)}Q(M,U,F){try{return Promise.resolve(this.S(M,U,F))}catch(q){return Promise.reject(q)}}S(M,U,F){const q=this.m[M];if(!q)throw new Error("Unknown actor "+(0,A.$hv)(M));const W=q[U];if(typeof W!="function")throw new Error("Unknown method "+U+" on actor "+(0,A.$hv)(M));return W.apply(q,F)}U(M,U,F){if(this.j)return new d.$$3b;let q=null;if(F.length>0&&I.CancellationToken.isCancellationToken(F[F.length-1])&&(q=F.pop()),q&&q.isCancellationRequested)return Promise.reject(O.$4());const W=P.serializeRequestArguments(F,this.h),L=++this.t,z=String(L),K=new d.$03b,B=new u.$Pc;q&&B.add(q.onCancellationRequested(()=>{const ye=P.serializeCancel(L);this.f?.logOutgoing(ye.byteLength,L,0,"cancel"),this.c.send(P.serializeCancel(L))})),this.w[z]=new y(K,B),this.F(L);const me=P.serializeRequest(L,M,U,W,!!q);return this.f?.logOutgoing(me.byteLength,L,0,`request: ${(0,A.$hv)(M)}.${U}(`,F),this.c.send(me),K}}e.$b4b=o,k=r,o.a=3*1e3;class y{constructor(M,U){this.a=M,this.b=U}resolveOk(M){this.a.resolveOk(M),this.b.dispose()}resolveErr(M){this.a.resolveErr(M),this.b.dispose()}}class g{static alloc(M,U,F){const q=new g(C.$_d.alloc(F+1+4),0);return q.writeUInt8(M),q.writeUInt32(U),q}static read(M,U){return new g(M,U)}get buffer(){return this.a}constructor(M,U){this.a=M,this.b=U}static sizeUInt8(){return 1}writeUInt8(M){this.a.writeUInt8(M,this.b),this.b+=1}readUInt8(){const M=this.a.readUInt8(this.b);return this.b+=1,M}writeUInt32(M){this.a.writeUInt32BE(M,this.b),this.b+=4}readUInt32(){const M=this.a.readUInt32BE(this.b);return this.b+=4,M}static sizeShortString(M){return 1+M.byteLength}writeShortString(M){this.a.writeUInt8(M.byteLength,this.b),this.b+=1,this.a.set(M,this.b),this.b+=M.byteLength}readShortString(){const M=this.a.readUInt8(this.b);this.b+=1;const F=this.a.slice(this.b,this.b+M).toString();return this.b+=M,F}static sizeLongString(M){return 4+M.byteLength}writeLongString(M){this.a.writeUInt32BE(M.byteLength,this.b),this.b+=4,this.a.set(M,this.b),this.b+=M.byteLength}readLongString(){const M=this.a.readUInt32BE(this.b);this.b+=4;const F=this.a.slice(this.b,this.b+M).toString();return this.b+=M,F}writeBuffer(M){this.a.writeUInt32BE(M.byteLength,this.b),this.b+=4,this.a.set(M,this.b),this.b+=M.byteLength}static sizeVSBuffer(M){return 4+M.byteLength}writeVSBuffer(M){this.a.writeUInt32BE(M.byteLength,this.b),this.b+=4,this.a.set(M,this.b),this.b+=M.byteLength}readVSBuffer(){const M=this.a.readUInt32BE(this.b);this.b+=4;const U=this.a.slice(this.b,this.b+M);return this.b+=M,U}static sizeMixedArray(M){let U=0;U+=1;for(let F=0,q=M.length;F<q;F++){const W=M[F];switch(U+=1,W.type){case 1:U+=this.sizeLongString(W.value);break;case 2:U+=this.sizeVSBuffer(W.value);break;case 3:U+=this.sizeUInt32,U+=this.sizeLongString(W.value);for(let L=0;L<W.buffers.length;++L)U+=this.sizeVSBuffer(W.buffers[L]);break;case 4:break}}return U}writeMixedArray(M){this.a.writeUInt8(M.length,this.b),this.b+=1;for(let U=0,F=M.length;U<F;U++){const q=M[U];switch(q.type){case 1:this.writeUInt8(1),this.writeLongString(q.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(q.value);break;case 3:this.writeUInt8(3),this.writeUInt32(q.buffers.length),this.writeLongString(q.value);for(let W=0;W<q.buffers.length;++W)this.writeBuffer(q.buffers[W]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const M=this.a.readUInt8(this.b);this.b+=1;const U=new Array(M);for(let F=0;F<M;F++)switch(this.readUInt8()){case 1:U[F]=this.readLongString();break;case 2:U[F]=this.readVSBuffer();break;case 3:{const W=this.readUInt32(),L=this.readLongString(),z=[];for(let K=0;K<W;++K)z.push(this.readVSBuffer());U[F]=new A.$iv(s(L,z,null));break}case 4:U[F]=void 0;break}return U}}g.sizeUInt32=4;var E;(function(b){b[b.Simple=0]="Simple",b[b.Mixed=1]="Mixed"})(E||(E={}));class P{static a(M){for(let U=0,F=M.length;U<F;U++)if(M[U]instanceof C.$_d||M[U]instanceof A.$iv||typeof M[U]>"u")return!0;return!1}static serializeRequestArguments(M,U){if(this.a(M)){const F=[];for(let q=0,W=M.length;q<W;q++){const L=M[q];if(L instanceof C.$_d)F[q]={type:2,value:L};else if(typeof L>"u")F[q]={type:4};else if(L instanceof A.$iv){const{jsonString:z,referencedBuffers:K}=t(L.value,U);F[q]={type:3,value:C.$_d.fromString(z),buffers:K}}else F[q]={type:1,value:C.$_d.fromString(c(L,U))}}return{type:1,args:F}}return{type:0,args:c(M,U)}}static serializeRequest(M,U,F,q,W){switch(q.type){case 0:return this.b(M,U,F,q.args,W);case 1:return this.c(M,U,F,q.args,W)}}static b(M,U,F,q,W){const L=C.$_d.fromString(F),z=C.$_d.fromString(q);let K=0;K+=g.sizeUInt8(),K+=g.sizeShortString(L),K+=g.sizeLongString(z);const B=g.alloc(W?2:1,M,K);return B.writeUInt8(U),B.writeShortString(L),B.writeLongString(z),B.buffer}static deserializeRequestJSONArgs(M){const U=M.readUInt8(),F=M.readShortString(),q=M.readLongString();return{rpcId:U,method:F,args:JSON.parse(q)}}static c(M,U,F,q,W){const L=C.$_d.fromString(F);let z=0;z+=g.sizeUInt8(),z+=g.sizeShortString(L),z+=g.sizeMixedArray(q);const K=g.alloc(W?4:3,M,z);return K.writeUInt8(U),K.writeShortString(L),K.writeMixedArray(q),K.buffer}static deserializeRequestMixedArgs(M){const U=M.readUInt8(),F=M.readShortString(),q=M.readMixedArray(),W=new Array(q.length);for(let L=0,z=q.length;L<z;L++){const K=q[L];typeof K=="string"?W[L]=JSON.parse(K):W[L]=K}return{rpcId:U,method:F,args:W}}static serializeAcknowledged(M){return g.alloc(5,M,0).buffer}static serializeCancel(M){return g.alloc(6,M,0).buffer}static serializeReplyOK(M,U,F){if(typeof U>"u")return this.d(M);if(U instanceof C.$_d)return this.e(M,U);if(U instanceof A.$iv){const{jsonString:q,referencedBuffers:W}=t(U.value,F,!0);return this.g(M,q,W)}else return this.f(M,a(U,F))}static d(M){return g.alloc(7,M,0).buffer}static e(M,U){let F=0;F+=g.sizeVSBuffer(U);const q=g.alloc(8,M,F);return q.writeVSBuffer(U),q.buffer}static deserializeReplyOKVSBuffer(M){return M.readVSBuffer()}static f(M,U){const F=C.$_d.fromString(U);let q=0;q+=g.sizeLongString(F);const W=g.alloc(9,M,q);return W.writeLongString(F),W.buffer}static g(M,U,F){const q=C.$_d.fromString(U);let W=0;W+=g.sizeUInt32,W+=g.sizeLongString(q);for(const z of F)W+=g.sizeVSBuffer(z);const L=g.alloc(10,M,W);L.writeUInt32(F.length),L.writeLongString(q);for(const z of F)L.writeBuffer(z);return L.buffer}static deserializeReplyOKJSON(M){const U=M.readLongString();return JSON.parse(U)}static deserializeReplyOKJSONWithBuffers(M,U){const F=M.readUInt32(),q=M.readLongString(),W=[];for(let L=0;L<F;++L)W.push(M.readVSBuffer());return new A.$iv(s(q,W,U))}static serializeReplyErr(M,U){const F=U?a(O.$1(U),null):void 0;if(typeof F!="string")return this.h(M);const q=C.$_d.fromString(F);let W=0;W+=g.sizeLongString(q);const L=g.alloc(11,M,W);return L.writeLongString(q),L.buffer}static deserializeReplyErrError(M){const U=M.readLongString();return JSON.parse(U)}static h(M){return g.alloc(12,M,0).buffer}}var l;(function(b){b[b.RequestJSONArgs=1]="RequestJSONArgs",b[b.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",b[b.RequestMixedArgs=3]="RequestMixedArgs",b[b.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",b[b.Acknowledged=5]="Acknowledged",b[b.Cancel=6]="Cancel",b[b.ReplyOKEmpty=7]="ReplyOKEmpty",b[b.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",b[b.ReplyOKJSON=9]="ReplyOKJSON",b[b.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",b[b.ReplyErrError=11]="ReplyErrError",b[b.ReplyErrEmpty=12]="ReplyErrEmpty"})(l||(l={}));var $;(function(b){b[b.String=1]="String",b[b.VSBuffer=2]="VSBuffer",b[b.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",b[b.Undefined=4]="Undefined"})($||($={}))}),define(Ae[263],Re([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ofc=void 0;const h=function(O){const R=u=>{globalThis.removeEventListener("message",R);const D=u.data;Object.defineProperties(globalThis,{postMessage:{value(d,A){D.postMessage(d,A)}},onmessage:{get(){return D.onmessage},set(d){D.onmessage=d}}}),D.addEventListener("message",d=>{globalThis.dispatchEvent(new MessageEvent("message",{data:d.data,ports:d.ports?[...d.ports]:void 0}))}),D.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(O)};globalThis.addEventListener("message",R)}.toString();class C extends EventTarget{constructor(O,R,u){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const D=`((${h})('${R}'))`,d=new Blob([D],{type:"application/javascript"}),A=URL.createObjectURL(d),k=new MessageChannel,a=A,w={type:"_newWorker",id:a,port:k.port2,url:A,options:u};O(w,[k.port2]),this.postMessage=k.port1.postMessage.bind(k.port1),this.terminate=()=>{O({type:"_terminateWorker",id:a}),URL.revokeObjectURL(A),k.port1.close(),k.port2.close()},Object.defineProperties(this,{onmessage:{get(){return k.port1.onmessage},set(m){k.port1.onmessage=m}},onmessageerror:{get(){return k.port1.onmessageerror},set(m){k.port1.onmessageerror=m}}}),k.port1.addEventListener("messageerror",m=>{const f=new MessageEvent("messageerror",{data:m.data});this.dispatchEvent(f)}),k.port1.addEventListener("message",m=>{const f=new MessageEvent("message",{data:m.data});this.dispatchEvent(f)}),k.port1.start()}}e.$Ofc=C}),define(Ae[264],Re([1,0,5,30,32,4]),function(ie,e,h,C,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sJ=e.$rJ=e.OutputChannelUpdateMode=e.$qJ=e.$pJ=e.$oJ=e.$nJ=e.$mJ=e.$lJ=e.$kJ=e.$jJ=e.$iJ=e.$hJ=void 0,e.$hJ="text/x-code-output",e.$iJ="output",e.$jJ="Log",e.$kJ="text/x-code-log-output",e.$lJ="log",e.$mJ="workbench.panel.output",e.$nJ=new I.$3i("inOutput",!1),e.$oJ=new I.$3i("activeLogOutput",!1),e.$pJ=new I.$3i("outputView.scrollLock",!1),e.$qJ=(0,O.$Lh)("outputService");var R;(function(D){D[D.Append=1]="Append",D[D.Replace=2]="Replace",D[D.Clear=3]="Clear"})(R||(e.OutputChannelUpdateMode=R={})),e.$rJ={OutputChannels:"workbench.contributions.outputChannels"};class u{constructor(){this.a=new Map,this.b=new h.$Ld,this.onDidRegisterChannel=this.b.event,this.c=new h.$Ld,this.onDidRemoveChannel=this.c.event}registerChannel(d){this.a.has(d.id)||(this.a.set(d.id,d),this.b.fire(d.id))}getChannels(){const d=[];return this.a.forEach(A=>d.push(A)),d}getChannel(d){return this.a.get(d)}removeChannel(d){this.a.delete(d),this.c.fire(d)}}C.$0m.add(e.$rJ.OutputChannels,new u),e.$sJ=new I.$3i("activeOutputChannel","")}),define(Ae[109],Re([1,0,3,4,17,20,14,264,62,27,39,132,25,16,38,5,6]),function(ie,e,h,C,I,O,R,u,D,d,A,k,a,w,m,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qcc=e.$pcc=void 0;class s extends R.$_i{get disposed(){return this.n}constructor(p,n,r,i,o){super(),this.id=p,this.name=n,this.r=r,this.s=i,this.extension=o,this.m=0,this.n=!1,this.visible=!1,this.setLevel(r.getLevel()),this.B(r.onDidChangeLogLevel(y=>this.setLevel(y)))}get logLevel(){return this.getLevel()}appendLine(p){this.append(p+`
`)}append(p){this.info(p)}clear(){const p=this.m;this.r.flush(),this.s.$update(this.id,u.OutputChannelUpdateMode.Clear,p)}replace(p){const n=this.m;this.info(p),this.s.$update(this.id,u.OutputChannelUpdateMode.Replace,n),this.visible&&this.r.flush()}show(p,n){this.r.flush(),this.s.$reveal(this.id,!!(typeof p=="boolean"?p:n))}hide(){this.s.$close(this.id)}g(p,n){this.m+=a.$_d.fromString(n).byteLength,(0,R.log)(this.r,p,n),this.visible&&(this.r.flush(),this.s.$update(this.id,u.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class c extends s{appendLine(p){this.append(p)}}let v=class{constructor(p,n,r,i,o,y){this.i=n,this.j=r,this.k=i,this.l=o,this.m=y,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=p.getProxy(h.$9J.MainThreadOutputService),this.b=this.k.extUri.joinPath(n.logsLocation,`output_logging_${(0,k.$9l)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(p){this.h=p;for(const[n,r]of this.g)r.visible=n===this.h}createOutputChannel(p,n,r){if(p=p.trim(),!p)throw new Error("illegal argument `name`. must not be falsy");const i=typeof n=="object"&&n.log,o=(0,w.$wf)(n)?n:void 0;if((0,w.$wf)(o)&&!o.trim())throw new Error("illegal argument `languageId`. must not be empty");let y;const g=this.i.environment.extensionLogLevel?.find(([P])=>O.$Xl.equals(r.identifier,P))?.[1];g&&(y=(0,R.$jj)(g));const E=i?this.o(p,y,r):this.n(p,o,r);return E.then(P=>{this.g.set(P.id,P),P.visible=P.id===this.h}),i?this.r(p,y??this.m.getLevel(),E):this.q(p,E)}async n(p,n,r){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const i=await this.c,o=this.k.extUri.joinPath(i,`${this.f++}-${p.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),y=this.l.createLogger(o,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),g=await this.a.$register(p,o,n,r.identifier.value);return new s(g,p,y,this.a,r)}async o(p,n,r){const i=await this.p(r),o=p.replace(/[\\/:\*\?"<>\|]/g,""),y=this.k.extUri.joinPath(i,`${o}.log`),g=`${r.identifier.value}.${o}`,E=this.l.createLogger(y,{id:g,name:p,logLevel:n,extensionId:r.identifier.value});return new c(g,p,E,this.a,r)}p(p){let n=this.d.get(p.identifier.value);if(!n){const r=this.k.extUri.joinPath(this.i.logsLocation,p.identifier.value);this.d.set(p.identifier.value,n=(async()=>{try{await this.j.value.createDirectory(r)}catch(i){if((0,m.$jk)(i)!==m.FileSystemProviderErrorCode.FileExists)throw i}return r})())}return n}q(p,n){let r=!1;const i=()=>{if(r)throw new Error("Channel has been closed")};return{get name(){return p},append(o){i(),n.then(y=>y.append(o))},appendLine(o){i(),n.then(y=>y.appendLine(o))},clear(){i(),n.then(o=>o.clear())},replace(o){i(),n.then(y=>y.replace(o))},show(o,y){i(),n.then(g=>g.show(o,y))},hide(){i(),n.then(o=>o.hide())},dispose(){r=!0,n.then(o=>o.dispose())}}}r(p,n,r){const i=new t.$Pc,o=()=>{if(i.isDisposed)throw new Error("Channel has been closed")},y=i.add(new f.$Ld);function g(E){n=E,y.fire(E)}return r.then(E=>{i.add(E),E.logLevel!==n&&g(E.logLevel),i.add(E.onDidChangeLogLevel(P=>g(P)))}),{...this.q(p,r),get logLevel(){return n},onDidChangeLogLevel:y.event,trace(E,...P){o(),r.then(l=>l.trace(E,...P))},debug(E,...P){o(),r.then(l=>l.debug(E,...P))},info(E,...P){o(),r.then(l=>l.info(E,...P))},warn(E,...P){o(),r.then(l=>l.warn(E,...P))},error(E,...P){o(),r.then(l=>l.error(E,...P))},dispose(){i.dispose()}}}};e.$pcc=v,e.$pcc=v=Je([qe(0,I.$0L),qe(1,d.$nM),qe(2,D.$5bc),qe(3,A.$zbc),qe(4,R.$7i),qe(5,R.$6i)],v),e.$qcc=(0,C.$Lh)("IExtHostOutputService")}),define(Ae[265],Re([1,0,4,12]),function(ie,e,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mm=e.$lm=void 0,e.$lm=(0,h.$Lh)("remoteAgentService"),e.$mm=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(I){let O=1/0;for(let u=0;u<this.maxSampleCount;u++){const D=await I.getRoundTripTime();if(D===void 0)return;O=Math.min(O,D/2),await(0,C.$Rg)(this.sampleDelay)}this.average.push(O),this.average.length>this.maxAverageCount&&this.average.shift();let R;return this.initial.length<this.maxInitialCount?this.initial.push(O):R=this.initial.reduce((u,D)=>u+D,0)/this.initial.length,this.lastMeasurement={initial:R,current:O,average:this.average.reduce((u,D)=>u+D,0)/this.average.length,high:(()=>typeof R>"u"?!1:O>this.highLatencyMaxThreshold||O>this.highLatencyMinThreshold&&O>R*this.highLatencyMultiple)()},this.lastMeasurement}}}),define(Ae[266],Re([1,0,40,13,19,22,23,2,4,186,54,208,265]),function(ie,e,h,C,I,O,R,u,D,d,A,k,a){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.$LJ=e.$KJ=void 0,e.$KJ=(0,D.$Lh)("pathService");let m=w=class{constructor(t,s,c,v){this.d=t,this.e=s,this.f=c,this.g=v,this.a=(async()=>(await this.e.getEnvironment())?.os||O.OS)(),this.b=(async()=>{const S=await this.e.getEnvironment();return this.c=S?.userHome??t})()}hasValidBasename(t,s,c){return typeof s=="string"||typeof s>"u"?this.a.then(v=>this.h(t,v,s)):this.h(t,s,c)}h(t,s,c){return t.scheme===C.Schemas.file||t.scheme===C.Schemas.vscodeRemote?(0,h.$Tf)(c??(0,R.$pg)(t),s===1):!0}get defaultUriScheme(){return w.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(t,s){if(t.remoteAuthority)return C.Schemas.vscodeRemote;const c=(0,d.$HJ)(s.getWorkspace());if(c)return c;const v=s.getWorkspace().folders[0];if(v)return v.uri.scheme;const S=s.getWorkspace().configuration;return S?S.scheme:C.Schemas.file}userHome(t){return t?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(t=>t===1?I.$dc:I.$ec)}async fileURI(t){let s="";if(await this.a===1&&(t=t.replace(/\\/g,"/")),t[0]==="/"&&t[1]==="/"){const v=t.indexOf("/",2);v===-1?(s=t.substring(2),t="/"):(s=t.substring(2,v),t=t.substring(v)||"/")}return u.URI.from({scheme:C.Schemas.file,authority:s,path:t,query:"",fragment:""})}};e.$LJ=m,e.$LJ=m=w=Je([qe(1,a.$lm),qe(2,k.$tJ),qe(3,A.$Uh)],m)}),define(Ae[110],Re([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$uI=e.$tI=void 0;class h{constructor(R,u){this.line=R,this.character=u}isBefore(R){return!1}isBeforeOrEqual(R){return!1}isAfter(R){return!1}isAfterOrEqual(R){return!1}isEqual(R){return!1}compareTo(R){return 0}translate(R,u){return new h(0,0)}with(R){return new h(0,0)}}e.$tI=h;class C{constructor(R,u,D,d){this.isEmpty=!1,this.isSingleLine=!1,this.start=new h(R,u),this.end=new h(D,d)}contains(R){return!1}isEqual(R){return!1}intersection(R){}union(R){return new C(0,0,0,0)}with(R){return new C(0,0,0,0)}}e.$uI=C;var I;(function(O){O[O.Information=1]="Information",O[O.Warning=2]="Warning"})(I||(e.TextSearchCompleteMessageType=I={}))}),define(Ae[47],Re([1,0,18,36,24,40,15,4,19,9,110,12]),function(ie,e,h,C,I,O,R,u,D,d,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VI=e.$UI=e.$TI=e.$SI=e.$RI=e.$QI=e.$PI=e.$OI=e.$NI=e.$MI=e.$LI=e.$KI=e.SearchErrorCode=e.$JI=e.$II=e.SearchSortOrder=e.ViewMode=e.$HI=e.$GI=e.$FI=e.$EI=e.SearchCompletionExitCode=e.$DI=e.$CI=e.$BI=e.QueryType=e.SearchProviderType=e.$AI=e.$zI=e.$yI=e.$xI=e.$wI=e.$vI=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return A.TextSearchCompleteMessageType}}),e.$vI="workbench.view.search",e.$wI="workbench.panel.search",e.$xI="workbench.view.search",e.$yI="search-result",e.$zI="search.exclude";const a="\u27EA ",w=" characters skipped \u27EB",m=(a.length+w.length+5)*2;e.$AI=(0,u.$Lh)("searchService");var f;(function(_){_[_.file=0]="file",_[_.text=1]="text"})(f||(e.SearchProviderType=f={}));var t;(function(_){_[_.File=1]="File",_[_.Text=2]="Text"})(t||(e.QueryType=t={}));function s(_){return!!_.preview}e.$BI=s;function c(_){return!!_.resource}e.$CI=c;function v(_){return!!_.message}e.$DI=v;var S;(function(_){_[_.Normal=0]="Normal",_[_.NewSearchStarted=1]="NewSearchStarted"})(S||(e.SearchCompletionExitCode=S={}));class p{constructor(de){this.resource=de,this.results=[]}}e.$EI=p;class n{constructor(de,De,ue,ve){this.ranges=De,this.webviewIndex=ve;const ke=Array.isArray(De)?De:[De];if(ue&&ue.matchLines===1&&r(ke)){de=(0,R.$pf)(de,ue.matchLines);let V="",Q=0,ee=0;const $e=Math.floor(ue.charsPerLine/5),he=[];for(const fe of ke){const Ee=Math.max(fe.startColumn-$e,0),re=fe.startColumn+ue.charsPerLine;if(Ee>ee+$e+m){const le=a+(Ee-ee)+w;V+=le+de.slice(Ee,re),Q+=Ee-(ee+le.length)}else V+=de.slice(ee,re);he.push(new o(0,fe.startColumn-Q,fe.endColumn-Q)),ee=re}this.preview={text:V,matches:Array.isArray(this.ranges)?he:he[0]}}else{const V=Array.isArray(De)?De[0].startLineNumber:De.startLineNumber;this.preview={text:de,matches:(0,h.$Zb)(De,Q=>new i(Q.startLineNumber-V,Q.startColumn,Q.endLineNumber-V,Q.endColumn))}}}}e.$FI=n;function r(_){const de=_[0].startLineNumber;for(const De of _)if(De.startLineNumber!==de||De.endLineNumber!==de)return!1;return!0}class i{constructor(de,De,ue,ve){this.startLineNumber=de,this.startColumn=De,this.endLineNumber=ue,this.endColumn=ve}}e.$GI=i;class o extends i{constructor(de,De,ue){super(de,De,de,ue)}}e.$HI=o;var y;(function(_){_.List="list",_.Tree="tree"})(y||(e.ViewMode=y={}));var g;(function(_){_.Default="default",_.FileNames="fileNames",_.Type="type",_.Modified="modified",_.CountDescending="countDescending",_.CountAscending="countAscending"})(g||(e.SearchSortOrder=g={}));function E(_,de=!0){const De=_&&_.files&&_.files.exclude,ue=de&&_&&_.search&&_.search.exclude;if(!De&&!ue)return;if(!De||!ue)return De||ue;let ve=Object.create(null);return ve=I.$1m(ve,I.$Xm(De)),ve=I.$1m(ve,I.$Xm(ue),!0),ve}e.$II=E;function P(_,de){return _.excludePattern&&C.$rj(_.excludePattern,de)?!1:_.includePattern||_.usingSearchPaths?_.includePattern&&C.$rj(_.includePattern,de)?!0:_.usingSearchPaths?!!_.folderQueries&&_.folderQueries.some(De=>{const ue=De.folder.fsPath;if(O.$Vf(de,ue)){const ve=D.$jc(ue,de);return!De.includePattern||!!C.$rj(De.includePattern,ve)}else return!1}):!1:!0}e.$JI=P;var l;(function(_){_[_.unknownEncoding=1]="unknownEncoding",_[_.regexParseError=2]="regexParseError",_[_.globParseError=3]="globParseError",_[_.invalidLiteral=4]="invalidLiteral",_[_.rgProcessError=5]="rgProcessError",_[_.other=6]="other",_[_.canceled=7]="canceled"})(l||(e.SearchErrorCode=l={}));class $ extends Error{constructor(de,De){super(de),this.code=De}}e.$KI=$;function b(_){const de=_.message;if((0,d.$2)(_))return new $(de,l.canceled);try{const De=JSON.parse(de);return new $(De.message,De.code)}catch{return new $(de,l.other)}}e.$LI=b;function M(_){const de={message:_.message,code:_.code};return new Error(JSON.stringify(de))}e.$MI=M;function U(_){return _.type==="error"?!0:_.type==="success"}e.$NI=U;function F(_){return _.type==="success"}e.$OI=F;function q(_){return!!_.path}e.$PI=q;function W(_,de){const De=_.searchPath?_.searchPath:_.relativePath;return(0,R.$mf)(De,de)}e.$QI=W;class L{constructor(de){this.path=de,this.results=[]}addMatch(de){this.results.push(de)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$RI=L;function z(_,de){const De={..._||{},...de||{}};return Object.keys(De).filter(ue=>{const ve=De[ue];return typeof ve=="boolean"&&ve})}e.$SI=z;class K{constructor(de,De){this.c=null,this.a={...de.excludePattern||{},...De.excludePattern||{}},this.b=C.$sj(this.a);let ue=de.includePattern;De.includePattern&&(ue?ue={...ue,...De.includePattern}:ue=De.includePattern),ue&&(this.c=C.$sj(ue))}matchesExcludesSync(de,De,ue){return!!(this.b&&this.b(de,De,ue))}includedInQuerySync(de,De,ue){return!(this.b&&this.b(de,De,ue)||this.c&&!this.c(de,De,ue))}includedInQuery(de,De,ue){const ve=this.b(de,De,ue),ke=()=>this.c?!!this.c(de,De,ue):!0;return(0,k.$Dg)(ve)?ve.then(V=>V?!1:ke()):ke()}hasSiblingExcludeClauses(){return B(this.a)}}e.$TI=K;function B(_){for(const de in _)if(typeof _[de]!="boolean")return!0;return!1}function me(_){if(!_)return;let de;return De=>(de||(de=(_()||Promise.resolve([])).then(ue=>ue?Ie(ue):{})),de.then(ue=>!!ue[De]))}e.$UI=me;function ye(_){if(!_)return;let de;return De=>{if(!de){const ue=_();de=ue?Ie(ue):{}}return!!de[De]}}e.$VI=ye;function Ie(_){const de={};for(const De of _)de[De]=!0;return de}}),define(Ae[33],Re([1,0,18,12,21,5,6,48,13,117,23,15,2,158,4,14,175,54,39,27,17,8,7,56,47,3]),function(ie,e,h,C,I,O,R,u,D,d,A,k,a,w,m,f,t,s,c,v,S,p,n,r,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mbc=e.$Lbc=void 0;function y(U,F,q){return new A.$hg(W=>l(W,q)).isEqual(U,F)}function g(U,F,q){return y(U.uri,F.uri,q)?0:(0,k.$Se)(U.uri.toString(),F.uri.toString())}function E(U,F,q){return U.index!==F.index?U.index<F.index?-1:1:y(U.uri,F.uri,q)?(0,k.$Se)(U.name,F.name):(0,k.$Se)(U.uri.toString(),F.uri.toString())}function P(U,F,q,W){const L=U.slice(0).sort((K,B)=>q(K,B,W)),z=F.slice(0).sort((K,B)=>q(K,B,W));return(0,h.$Cb)(L,z,(K,B)=>q(K,B,W))}function l(U,F){const q=F.getCapabilities(U.scheme);return!(q&&q&1024)}class $ extends s.$5h{static toExtHostWorkspace(F,q,W,L){if(!F)return{workspace:null,added:[],removed:[]};const{id:z,name:K,folders:B,configuration:me,transient:ye,isUntitled:Ie}=F,_=[],de=q;q?B.forEach((ke,V)=>{const Q=a.URI.revive(ke.uri),ee=$.o(W||q,Q,L);ee?(ee.name=ke.name,ee.index=ke.index,_.push(ee)):_.push({uri:Q,name:ke.name,index:V})}):_.push(...B.map(({uri:ke,name:V,index:Q})=>({uri:a.URI.revive(ke),name:V,index:Q}))),_.sort((ke,V)=>ke.index<V.index?-1:1);const De=new $(z,K,_,!!ye,me?a.URI.revive(me):null,!!Ie,ke=>l(ke,L)),{added:ue,removed:ve}=P(de?de.workspaceFolders:[],De.workspaceFolders,g,L);return{workspace:De,added:ue,removed:ve}}static o(F,q,W){for(let L=0;L<F.folders.length;L++){const z=F.workspaceFolders[L];if(y(z.uri,q,W))return z}}constructor(F,q,W,L,z,K,B){super(F,W.map(me=>new s.$6h(me)),L,z,B),this.t=q,this.u=K,this.q=[],this.s=u.$Rh.forUris(B),W.forEach(me=>{this.q.push(me),this.s.set(me.uri,me)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(F,q){return q&&this.s.get(F)&&(F=(0,A.$rg)(F)),this.s.findSubstr(F)}resolveWorkspaceFolder(F){return this.s.get(F)}}let b=class{constructor(F,q,W,L,z){this.c=new O.$Ld,this.onDidChangeWorkspace=this.c.event,this.g=new O.$Ld,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.z=0,this.A=new O.$Nd,this.B=new Map,this.h=L,this.s=W,this.t=z,this.j=new d.$Ll,this.k=new C.$Pg,this.o=F.getProxy(o.$9J.MainThreadWorkspace),this.q=F.getProxy(o.$9J.MainThreadMessageService);const K=q.workspace;this.l=K?new $(K.id,K.name,[],!!K.transient,K.configuration?a.URI.revive(K.configuration):null,!!K.isUntitled,B=>l(B,W)):void 0}$initializeWorkspace(F,q){this.v=q,this.$acceptWorkspaceData(F),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?a.URI.from({scheme:D.Schemas.untitled,path:(0,A.$pg)((0,A.$rg)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(F,q,W,...L){const z=[];if(Array.isArray(L)&&L.forEach(Ie=>{a.URI.isUri(Ie.uri)&&!z.some(_=>y(_.uri,Ie.uri,this.s))&&z.push({uri:Ie.uri,name:Ie.name||(0,A.$og)(Ie.uri)})}),this.n||[q,W].some(Ie=>typeof Ie!="number"||Ie<0)||W===0&&z.length===0)return!1;const K=this.x?this.x.workspaceFolders:[];if(q+W>K.length)return!1;const B=K.slice(0);B.splice(q,W,...z.map(Ie=>({uri:Ie.uri,name:Ie.name||(0,A.$og)(Ie.uri),index:void 0})));for(let Ie=0;Ie<B.length;Ie++){const _=B[Ie];if(B.some((de,De)=>De!==Ie&&y(_.uri,de.uri,this.s)))return!1}B.forEach((Ie,_)=>Ie.index=_);const{added:me,removed:ye}=P(K,B,E,this.s);if(me.length===0&&ye.length===0)return!1;if(this.o){const Ie=F.displayName||F.name;this.o.$updateWorkspaceFolders(Ie,q,W,z).then(void 0,_=>{this.n=void 0;const de={source:{identifier:F.identifier,label:F.displayName||F.name}};this.q.$showMessage(t.Severity.Error,(0,w.localize)(0,null,Ie,_.toString()),de,[])})}return this.y(B),!0}getWorkspaceFolder(F,q){if(this.x)return this.x.getWorkspaceFolder(F,q)}async getWorkspaceFolder2(F,q){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(F,q)}async resolveWorkspaceFolder(F){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(F)}getPath(){if(!this.x)return;const{folders:F}=this.x;if(F.length!==0)return F[0].uri.fsPath}getRelativePath(F,q){let W,L="";if(typeof F=="string"?(W=a.URI.file(F),L=F):typeof F<"u"&&(W=F,L=F.fsPath),!W)return L;const z=this.getWorkspaceFolder(W,!0);if(!z)return L;typeof q>"u"&&this.x&&(q=this.x.folders.length>1);let K=(0,A.$ug)(z.uri,W);return q&&z.name&&(K=`${z.name}/${K}`),K}y(F){this.x&&(this.n=$.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:F,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(F){const{workspace:q,added:W,removed:L}=$.toExtHostWorkspace(F,this.l,this.n,this.s);this.l=q||void 0,this.n=void 0,this.c.fire(Object.freeze({added:W,removed:L}))}findFiles(F,q,W,L,z=I.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${L.value}, entryPoint: findFiles`);let K;if(q===null?K=!1:q&&(typeof q=="string"?K=q:K=q.pattern),z&&z.isCancellationRequested)return Promise.resolve([]);const{includePattern:B,folder:me}=M(p.GlobPattern.from(F));return this.o.$startFileSearch(B??null,me??null,K??null,W??null,z).then(ye=>Array.isArray(ye)?ye.map(Ie=>a.URI.revive(Ie)):[])}async findTextInFiles(F,q,W,L,z=I.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${L.value}, entryPoint: findTextInFiles`);const K=this.j.getNext(),B=typeof q.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:q.previewOptions,{includePattern:me,folder:ye}=M(p.GlobPattern.from(q.include)),Ie=typeof q.exclude=="string"?q.exclude:q.exclude?q.exclude.pattern:void 0,_={ignoreSymlinks:typeof q.followSymlinks=="boolean"?!q.followSymlinks:void 0,disregardIgnoreFiles:typeof q.useIgnoreFiles=="boolean"?!q.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof q.useGlobalIgnoreFiles=="boolean"?!q.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof q.useParentIgnoreFiles=="boolean"?!q.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof q.useDefaultExcludes=="boolean"?!q.useDefaultExcludes:!0,fileEncoding:q.encoding,maxResults:q.maxResults,previewOptions:B,afterContext:q.afterContext,beforeContext:q.beforeContext,includePattern:me,excludePattern:Ie},de=!1;if(this.u[K]=De=>{if(de)return;const ue=a.URI.revive(De.resource);De.results.forEach(ve=>{(0,i.$BI)(ve)?W({uri:ue,preview:{text:ve.preview.text,matches:(0,h.$Zb)(ve.preview.matches,ke=>new n.$aK(ke.startLineNumber,ke.startColumn,ke.endLineNumber,ke.endColumn))},ranges:(0,h.$Zb)(ve.ranges,ke=>new n.$aK(ke.startLineNumber,ke.startColumn,ke.endLineNumber,ke.endColumn))}):W({uri:ue,text:ve.text,lineNumber:ve.lineNumber})})},z.isCancellationRequested)return{};try{const De=await this.o.$startTextSearch(F,ye??null,_,K,z);return delete this.u[K],De||{}}catch(De){throw delete this.u[K],De}}$handleTextSearchResult(F,q){this.u[q]?.(F)}async save(F){const q=await this.o.$save(F,{saveAs:!1});return a.URI.revive(q)}async saveAs(F){const q=await this.o.$save(F,{saveAs:!0});return a.URI.revive(q)}saveAll(F){return this.o.$saveAll(F)}resolveProxy(F){return this.o.$resolveProxy(F)}get trusted(){return this.v}requestWorkspaceTrust(F){return this.o.$requestWorkspaceTrust(F)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(F,q){if(this.w.has(F))throw new Error(`A provider has already been registered for scheme ${F}`);this.w.set(F,q);const W=this.t.transformOutgoingScheme(F),L=this.z++;return this.o.$registerEditSessionIdentityProvider(L,W),(0,R.$Oc)(()=>{this.w.delete(F),this.o.$unregisterEditSessionIdentityProvider(L)})}async $getEditSessionIdentifier(F,q){this.h.info("Getting edit session identifier for workspaceFolder",F);const W=await this.resolveWorkspaceFolder(a.URI.revive(F));if(!W){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",W);const L=this.w.get(W.uri.scheme);if(this.h.info(`Provider for scheme ${W.uri.scheme} is defined: `,!!L),!L)return;const z=await L.provideEditSessionIdentity(W,q);if(this.h.info("Provider returned edit session identifier: ",z),!!z)return z}async $provideEditSessionIdentityMatch(F,q,W,L){this.h.info("Getting edit session identifier for workspaceFolder",F);const z=await this.resolveWorkspaceFolder(a.URI.revive(F));if(!z){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",z);const K=this.w.get(z.uri.scheme);if(this.h.info(`Provider for scheme ${z.uri.scheme} is defined: `,!!K),!K)return;const B=await K.provideEditSessionIdentityMatch?.(q,W,L);if(this.h.info("Provider returned edit session identifier match result: ",B),!!B)return B}getOnWillCreateEditSessionIdentityEvent(F){return(q,W,L)=>{const z=function(B){q.call(W,B)};return z.extension=F,this.A.event(z,void 0,L)}}async $onWillCreateEditSessionIdentity(F,q,W){const L=await this.resolveWorkspaceFolder(a.URI.revive(F));if(L===void 0)throw new Error("Unable to resolve workspace folder");await this.A.fireAsync({workspaceFolder:L},q,async(z,K)=>{const B=Date.now();await Promise.resolve(z),Date.now()-B>W&&this.h.warn("SLOW edit session create-participant",K.extension.identifier)}),q.isCancellationRequested}registerCanonicalUriProvider(F,q){if(this.B.has(F))throw new Error(`A provider has already been registered for scheme ${F}`);this.B.set(F,q);const W=this.t.transformOutgoingScheme(F),L=this.z++;return this.o.$registerCanonicalUriProvider(L,W),(0,R.$Oc)(()=>{this.B.delete(F),this.o.$unregisterCanonicalUriProvider(L)})}async provideCanonicalUri(F,q,W){const L=this.B.get(F.scheme);if(!L)return;const z=await L.provideCanonicalUri?.(a.URI.revive(F),q,W);if(z)return z}async $provideCanonicalUri(F,q,W){return this.provideCanonicalUri(a.URI.revive(F),{targetScheme:q},W)}};e.$Lbc=b,e.$Lbc=b=Je([qe(0,S.$0L),qe(1,v.$nM),qe(2,c.$zbc),qe(3,f.$6i),qe(4,r.$Jbc)],b),e.$Mbc=(0,m.$Lh)("IExtHostWorkspace");function M(U){let F,q;return U&&(typeof U=="string"?F=U:(F=U.pattern,q=a.URI.revive(U.baseUri))),{includePattern:F,folder:q}}}),define(Ae[34],Re([1,0,24,5,33,3,7,177,96,16,12,4,17,14,2]),function(ie,e,h,C,I,O,R,u,D,d,A,k,a,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pbc=e.$Obc=e.$Nbc=void 0;function f(r,i){if(i){const o=i.split(".");let y=r;for(let g=0;y&&g<o.length;g++)y=y[o[g]];return y}}function t(r){return r instanceof m.URI}function s(r){return r&&r.uri instanceof m.URI&&r.languageId&&typeof r.languageId=="string"}function c(r){return r&&!r.uri&&r.languageId&&typeof r.languageId=="string"}function v(r){return r&&r.uri instanceof m.URI&&(!r.name||typeof r.name=="string")&&(!r.index||typeof r.index=="number")}function S(r){if(t(r))return{resource:r};if(s(r))return{resource:r.uri,overrideIdentifier:r.languageId};if(c(r))return{overrideIdentifier:r.languageId};if(v(r))return{resource:r.uri};if(r===null)return{resource:null}}let p=class{constructor(i,o,y){this.a=i.getProxy(O.$9J.MainThreadConfiguration),this.c=o,this.b=y,this.d=new A.$Pg,this.e=null}getConfigProvider(){return this.d.wait().then(i=>this.e)}$initializeConfiguration(i){this.e=new n(this.a,this.c,i,this.b),this.d.open()}$acceptConfigurationChanged(i,o){this.getConfigProvider().then(y=>y.$acceptConfigurationChanged(i,o))}};e.$Nbc=p,e.$Nbc=p=Je([qe(0,a.$0L),qe(1,I.$Mbc),qe(2,w.$6i)],p);class n{constructor(i,o,y,g){this.a=new C.$Ld,this.b=i,this.f=g,this.c=o,this.e=u.$vn.parse(y),this.d=this.k(y.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(i,o){const y={data:this.e.toData(),workspace:this.c.workspace};this.e=u.$vn.parse(i),this.d=this.k(i.configurationScopes),this.a.fire(this.j(o,y))}getConfiguration(i,o,y){const g=S(o)||{},E=this.g(i?f(this.e.getValue(void 0,g,this.c.workspace),i):this.e.getValue(void 0,g,this.c.workspace));i&&this.h(i,g,y?.identifier);function P($){if($==null)return null;if(typeof $=="boolean")return $?2:5;switch($){case R.ConfigurationTarget.Global:return 2;case R.ConfigurationTarget.Workspace:return 5;case R.ConfigurationTarget.WorkspaceFolder:return 6}}const l={has($){return typeof f(E,$)<"u"},get:($,b)=>{this.h(i?`${i}.${$}`:$,g,y?.identifier);let M=f(E,$);if(typeof M>"u")M=b;else{let U;const F=(q,W)=>{if((0,d.$yf)(q)){let L;const z=()=>{U=U||(0,h.$Xm)(E),L=L||f(U,W)};return new Proxy(q,{get:(K,B)=>{if(typeof B=="string"&&B.toLowerCase()==="tojson")return z(),()=>L;if(U)return L=L||f(U,W),L[B];const me=K[B];return typeof B=="string"?F(me,`${W}.${B}`):me},set:(K,B,me)=>(z(),L&&(L[B]=me),!0),deleteProperty:(K,B)=>(z(),L&&delete L[B],!0),defineProperty:(K,B,me)=>(z(),L&&Object.defineProperty(L,B,me),!0)})}return Array.isArray(q)?(0,h.$Xm)(q):q};M=F(M,$)}return M},update:($,b,M,U)=>{$=i?`${i}.${$}`:$;const F=P(M);return b!==void 0?this.b.$updateConfigurationOption(F,$,b,g,U):this.b.$removeConfigurationOption(F,$,g,U)},inspect:$=>{$=i?`${i}.${$}`:$;const b=this.e.inspect($,g,this.c.workspace);if(b)return{key:$,defaultValue:(0,h.$Xm)(b.policy?.value??b.default?.value),globalValue:(0,h.$Xm)(b.user?.value??b.application?.value),workspaceValue:(0,h.$Xm)(b.workspace?.value),workspaceFolderValue:(0,h.$Xm)(b.workspaceFolder?.value),defaultLanguageValue:(0,h.$Xm)(b.default?.override),globalLanguageValue:(0,h.$Xm)(b.user?.override??b.application?.override),workspaceLanguageValue:(0,h.$Xm)(b.workspace?.override),workspaceFolderLanguageValue:(0,h.$Xm)(b.workspaceFolder?.override),languageIds:(0,h.$Xm)(b.overrideIdentifiers)}}};return typeof E=="object"&&(0,h.$1m)(l,E,!1),Object.freeze(l)}g(i){const o=y=>(0,d.$yf)(y)?new Proxy(y,{get:(g,E)=>o(g[E]),set:(g,E,P)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(E)}' of object`)},deleteProperty:(g,E)=>{throw new Error(`TypeError: Cannot delete read only property '${String(E)}' of object`)},defineProperty:(g,E)=>{throw new Error(`TypeError: Cannot define property '${String(E)}' for a readonly object`)},setPrototypeOf:g=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):y;return o(i)}h(i,o,y){const g=D.$mn.test(i)?4:this.d.get(i),E=y?`[${y.value}] `:"";if(g===4){typeof o?.resource>"u"&&this.f.warn(`${E}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${i}', provide the URI of a resource or 'null' for any resource.`);return}if(g===3){o?.resource&&this.f.warn(`${E}Accessing a window scoped configuration for a resource is not expected. To associate '${i}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(i,o){const y=new u.$xn(i,o,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(g,E)=>y.affectsConfiguration(g,S(E))})}k(i){return i.reduce((o,y)=>(o.set(y[0],y[1]),o),new Map)}}e.$Obc=n,e.$Pbc=(0,k.$Lh)("IExtHostConfiguration")});var Ye=this&&this.__classPrivateFieldSet||function(ie,e,h,C,I){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!I:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?I.call(ie,h):I?I.value=h:e.set(ie,h),h},Ne=this&&this.__classPrivateFieldGet||function(ie,e,h,C){if(h==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!C:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?C:h==="a"?C.call(ie):C?C.value:e.get(ie)};define(Ae[111],Re([1,0,2,12,5,3,7,33,60,34,21,63,17,27,4,13,22,14,80,214,9]),function(ie,e,h,C,I,O,R,u,D,d,A,k,a,w,m,f,t,s,c,v,S){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ncc=e.$Mcc=e.$Lcc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var n;(function(q){function W(z){if(z!=null)return z}q.from=W;function L(z){if(z!=null)return z}q.to=L})(n||(n={}));var r;(function(q){function W(z){if(z!=null)return z}q.from=W;function L(z){if(z!=null)return z}q.to=L})(r||(r={}));var i;(function(q){function W(z){if(z!=null)return z}q.from=W;function L(z){if(z!=null)return z}q.to=L})(i||(i={}));var o;(function(q){function W(K){if(K){const B=K;return B&&!!B.process}else return!1}q.is=W;function L(K){if(K==null)return;const B={process:K.process,args:K.args};return K.options&&(B.options=i.from(K.options)),B}q.from=L;function z(K){if(K!=null)return new R.$SK(K.process,K.args,K.options)}q.to=z})(o||(o={}));var y;(function(q){function W(z){if(z!=null)return z}q.from=W;function L(z){if(z!=null)return z}q.to=L})(y||(y={}));var g;(function(q){function W(K){if(K){const B=K;return B&&(!!B.commandLine||!!B.command)}else return!1}q.is=W;function L(K){if(K==null)return;const B={};return K.commandLine!==void 0?B.commandLine=K.commandLine:(B.command=K.command,B.args=K.args),K.options&&(B.options=y.from(K.options)),B}q.from=L;function z(K){if(!(K==null||K.command===void 0&&K.commandLine===void 0))return K.commandLine?new R.$TK(K.commandLine,K.options):new R.$TK(K.command,K.args?K.args:[],K.options)}q.to=z})(g||(g={}));var E;(function(q){function W(K){if(K){const B=K;return B&&B.customExecution==="customExecution"}else return!1}q.is=W;function L(K){return{customExecution:"customExecution"}}q.from=L;function z(K,B){return B.get(K)}q.to=z})(E||(e.CustomExecutionDTO=E={}));var P;(function(q){function W(L,z){let K;return L.scope!==void 0&&typeof L.scope!="number"?K=L.scope.uri:L.scope!==void 0&&typeof L.scope=="number"&&(L.scope===R.TaskScope.Workspace&&z&&z.workspaceFile?K=z.workspaceFile:K=v.$KF),{id:L._id,workspaceFolder:K}}q.from=W})(P||(e.TaskHandleDTO=P={}));var l;(function(q){function W(L){if(L!=null)return{_id:L.id,isDefault:L.isDefault}}q.from=W})(l||(l={}));var $;(function(q){function W(K,B){if(K==null)return[];const me=[];for(const ye of K){const Ie=L(ye,B);Ie&&me.push(Ie)}return me}q.fromMany=W;function L(K,B){if(K==null)return;let me;K.execution instanceof R.$SK?me=o.from(K.execution):K.execution instanceof R.$TK?me=g.from(K.execution):K.execution&&K.execution instanceof R.$UK&&(me=E.from(K.execution));const ye=n.from(K.definition);let Ie;return K.scope?typeof K.scope=="number"?Ie=K.scope:Ie=K.scope.uri:Ie=R.TaskScope.Workspace,!ye||!Ie?void 0:{_id:K._id,definition:ye,name:K.name,source:{extensionId:B.identifier.value,label:K.source,scope:Ie},execution:me,isBackground:K.isBackground,group:l.from(K.group),presentationOptions:r.from(K.presentationOptions),problemMatchers:K.problemMatchers,hasDefinedMatchers:K.hasDefinedMatchers,runOptions:K.runOptions?K.runOptions:{reevaluateOnRerun:!0},detail:K.detail}}q.from=L;async function z(K,B,me){if(K==null)return;let ye;o.is(K.execution)?ye=o.to(K.execution):g.is(K.execution)?ye=g.to(K.execution):E.is(K.execution)&&(ye=E.to(K._id,me));const Ie=n.to(K.definition);let _;if(K.source&&(K.source.scope!==void 0?typeof K.source.scope=="number"?_=K.source.scope:_=await B.resolveWorkspaceFolder(h.URI.revive(K.source.scope)):_=R.TaskScope.Workspace),!Ie||!_)return;const de=new R.$VK(Ie,_,K.name,K.source.label,ye,K.problemMatchers);return K.isBackground!==void 0&&(de.isBackground=K.isBackground),K.group!==void 0&&(de.group=R.$RK.from(K.group._id),de.group&&K.group.isDefault&&(de.group=new R.$RK(de.group.id,de.group.label),K.group.isDefault===!0&&(de.group.isDefault=K.group.isDefault))),K.presentationOptions&&(de.presentationOptions=r.to(K.presentationOptions)),K._id&&(de._id=K._id),K.detail&&(de.detail=K.detail),de}q.to=z})($||(e.TaskDTO=$={}));var b;(function(q){function W(z){return z}q.from=W;function L(z){if(z)return Object.assign(Object.create(null),z)}q.to=L})(b||(b={}));class M{constructor(W,L,z){this._id=L,this.a=z,p.set(this,void 0),Ye(this,p,W,"f")}get task(){return this.a}terminate(){Ne(this,p,"f").terminateTask(this)}fireDidStartProcess(W){}fireDidEndProcess(W){}}p=new WeakMap;let U=class{constructor(W,L,z,K,B,me,ye,Ie){this.q=new I.$Ld,this.r=new I.$Ld,this.s=new I.$Ld,this.t=new I.$Ld,this.a=W.getProxy(O.$9J.MainThreadTask),this.b=z,this.c=K,this.d=B,this.e=me,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=ye,this.g=Ie,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(W,L,z){if(!z)return new R.$$J(()=>{});const K=this.w();return this.j.set(K,{type:L,provider:z,extension:W}),this.a.$registerTaskProvider(K,L),new R.$$J(()=>{this.j.delete(K),this.a.$unregisterTaskProvider(K)})}registerTaskSystem(W,L){this.a.$registerTaskSystem(W,L)}fetchTasks(W){return this.a.$fetchTasks(b.from(W)).then(async L=>{const z=[];for(const K of L){const B=await $.to(K,this.b,this.m);B&&z.push(B)}return z})}get taskExecutions(){const W=[];return this.k.forEach(L=>W.push(L)),W}terminateTask(W){if(!(W instanceof M))throw new Error("No valid task execution provided");return this.a.$terminateTask(W._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(W,L,z){const K=this.m.get(W.id);K&&(this.o.set(W.id,K),this.e.attachPtyToTerminal(L,await K.callback(z))),this.p=W.id,this.q.fire({execution:await this.y(W)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(W){const L=await this.y(W);this.l.delete(W.id),this.k.delete(W.id),this.A(W),this.r.fire({execution:L})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(W){const L=await this.y(W.id);this.s.fire({execution:L,processId:W.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess(W){const L=await this.y(W.id);this.t.fire({execution:L,exitCode:W.exitCode})}$provideTasks(W,L){const z=this.j.get(W);if(!z)return Promise.reject(new Error("no handler found"));const K=[],B=(0,C.$Jg)(()=>z.provider.provideTasks(A.CancellationToken.None)).then(me=>this.u(L,K,z,me));return new Promise(me=>{B.then(ye=>{Promise.all(K).then(()=>{me(ye)})})})}async $resolveTask(W,L){const z=this.j.get(W);if(!z)return Promise.reject(new Error("no handler found"));if(L.definition.type!==z.type)throw new Error(`Unexpected: Task of type [${L.definition.type}] cannot be resolved by provider of type [${z.type}].`);const K=await $.to(L,this.b,this.m);if(!K)throw new Error("Unexpected: Task cannot be resolved.");const B=await z.provider.resolveTask(K,A.CancellationToken.None);if(!B)return;this.z(B,z);const me=$.from(B,z.extension);if(!me)throw new Error("Unexpected: Task cannot be resolved.");if(B.definition!==K.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return E.is(me.execution)&&await this.x(me,B,!0),await this.v(me)}w(){return this.h++}async x(W,L,z){const K=await this.a.$createTaskId(W);!z&&!this.m.has(K)&&(this.n.add(K),this.o.set(K,L.execution)),this.m.set(K,L.execution)}async y(W,L){if(typeof W=="string"){const B=this.l.get(W);if(!B)throw new S.$_("Unexpected: The specified task is missing an execution");return B}const z=this.l.get(W.id);if(z)return z;const K=new Promise((B,me)=>{function ye(Ie,_,de){de?B(new M(Ie,_.id,de)):me("Unexpected: Task does not exist.")}L?ye(this,W,L):$.to(W.task,this.b,this.m).then(Ie=>ye(this,W,Ie))});return this.l.set(W.id,K),K.then(B=>(this.k.set(W.id,B),B),B=>Promise.reject(B))}z(W,L){W._deprecated&&this.g.report("Task.constructor",L.extension,"Use the Task constructor that takes a `scope` instead.")}A(W){this.o.get(W.id)&&this.o.delete(W.id),this.n.has(W.id)&&this.p!==W.id&&(this.m.delete(W.id),this.n.delete(W.id));const z=this.n.values();let K=z.next();for(;!K.done;)!this.o.has(K.value)&&this.p!==K.value&&(this.m.delete(K.value),this.n.delete(K.value)),K=z.next()}};e.$Lcc=U,e.$Lcc=U=Je([qe(0,a.$0L),qe(1,w.$nM),qe(2,u.$Mbc),qe(3,D.$iM),qe(4,d.$Pbc),qe(5,k.$8bc),qe(6,s.$6i),qe(7,c.$Cbc)],U);let F=class extends U{constructor(W,L,z,K,B,me,ye,Ie){super(W,L,z,K,B,me,ye,Ie),this.registerTaskSystem(f.Schemas.vscodeRemote,{scheme:f.Schemas.vscodeRemote,authority:"",platform:t.$c(0)})}async executeTask(W,L){if(!L.execution)throw new Error("Tasks to execute must include an execution");const z=$.from(L,W);if(z===void 0)throw new Error("Task is not valid");if(E.is(z.execution))await this.x(z,L,!1);else throw new S.$0;const K=await this.y(await this.a.$getTaskExecution(z),L);return this.a.$executeTask(z).catch(B=>{throw new Error(B)}),K}u(W,L,z,K){const B=[];if(K)for(const me of K){this.z(me,z),(!me.definition||!W[me.definition.type])&&this.f.warn(`The task [${me.source}, ${me.name}] uses an undefined task type. The task will be ignored in the future.`);const ye=$.from(me,z.extension);ye&&E.is(ye.execution)?(B.push(ye),L.push(this.x(ye,me,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:B,extension:z.extension}}async v(W){if(E.is(W.execution))return W;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(W,L){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(W,L,z){}};e.$Mcc=F,e.$Mcc=F=Je([qe(0,a.$0L),qe(1,w.$nM),qe(2,u.$Mbc),qe(3,D.$iM),qe(4,d.$Pbc),qe(5,k.$8bc),qe(6,s.$6i),qe(7,c.$Cbc)],F),e.$Ncc=(0,m.$Lh)("IExtHostTask")}),define(Ae[267],Re([1,0,19,21,42,36,23,59,47]),function(ie,e,h,C,I,O,R,u,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xcc=void 0;class d{constructor(a,w,m){this.k=a,this.l=w,this.o=m,this.e=!1,this.f=0,this.g=!1,this.a=a.filePattern,this.b=a.includePattern&&O.$sj(a.includePattern),this.c=a.maxResults||void 0,this.d=a.exists,this.h=new Set,this.j=a.excludePattern&&O.$sj(a.excludePattern)}cancel(){this.g=!0,this.h.forEach(a=>a.cancel()),this.h=new Set}search(a){const w=this.k.folderQueries||[];return new Promise((m,f)=>{const t=s=>{this.f++,a(s)};if(this.g)return m({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(s=>{const c=s.toString(),v=h.$lc(c);this.j&&this.j(c,v)||this.v(t,{base:s,basename:v})}),Promise.all(w.map(s=>this.p(s,t))).then(s=>{m({limitHit:this.e,stats:s[0]||void 0})},s=>{f(new Error((0,I.$wi)(s)))})})}async p(a,w){const m=new C.$Vd,f=this.q(a),t=this.r(),s=new D.$TI(this.k,a),c=!s.hasSiblingExcludeClauses();let v;try{this.h.add(m),v=u.$Hd.create();const S=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},f,m.token),p=v.elapsed(),n=u.$Hd.create();return this.g&&!this.e||(S&&S.forEach(r=>{const i=h.$ec.relative(a.folder.path,r.path);if(c){const o=h.$lc(r.path);this.v(w,{base:a.folder,relativePath:i,basename:o});return}this.s(t,a.folder,i,w)}),this.g&&!this.e)?null:(this.u(t,s,w),{providerTime:p,postProcessTime:n.elapsed()})}finally{m.dispose(),this.h.delete(m)}}q(a){const w=(0,D.$SI)(this.k.includePattern,a.includePattern),m=(0,D.$SI)(this.k.excludePattern,a.excludePattern);return{folder:a.folder,excludes:m,includes:w,useIgnoreFiles:!a.disregardIgnoreFiles,useGlobalIgnoreFiles:!a.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!a.disregardParentIgnoreFiles,followSymlinks:!a.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const a={rootEntries:[],pathToEntries:Object.create(null)};return a.pathToEntries["."]=a.rootEntries,a}s({pathToEntries:a},w,m,f){if(m===this.a){const s=h.$lc(this.a);this.v(f,{base:w,relativePath:this.a,basename:s})}function t(s){const c=h.$lc(s),v=h.$kc(s);let S=a[v];S||(S=a[v]=[],t(v)),S.push({base:w,relativePath:s,basename:c})}t(m)}u({rootEntries:a,pathToEntries:w},m,f){const t=this,s=this.a;function c(v){const S=(0,D.$VI)(()=>v.map(p=>p.basename));for(let p=0,n=v.length;p<n;p++){const r=v[p],{relativePath:i,basename:o}=r;if(m.matchesExcludesSync(i,o,s!==o?S:void 0))continue;const y=w[i];if(y)c(y);else{if(i===s)continue;t.v(f,r)}if(t.e)break}}c(a)}v(a,w){(!this.b||w.relativePath&&this.b(w.relativePath,w.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||a(w))}}class A{constructor(){this.b=new Map}fileSearch(a,w,m,f){const t=this.c(a.cacheKey),s=new d(a,w,t&&t.token);let c=0;const v=S=>{c+=S.length,m(S.map(p=>this.d(p)))};return this.e(s,A.a,v,f).then(S=>({limitHit:S.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:c,detailStats:S.stats}}))}clearCache(a){this.c(a)?.cancel()}c(a){if(a)return this.b.has(a)||this.b.set(a,new C.$Vd),this.b.get(a)}d(a){return a.relativePath?{resource:R.$sg(a.base,a.relativePath)}:{resource:a.base}}e(a,w,m,f){const t=f.onCancellationRequested(()=>{a.cancel()}),s=v=>{v&&(c.push(v),w>0&&c.length>=w&&(m(c),c=[]))};let c=[];return a.search(s).then(v=>(c.length&&m(c),t.dispose(),v),v=>(c.length&&m(c),t.dispose(),Promise.reject(v)))}}e.$Xcc=A,A.a=512}),define(Ae[268],Re([1,0,18,232,36,90,28,13,19,23,15,16,2,283,167,43,14,54,102,266,47]),function(ie,e,h,C,I,O,R,u,D,d,A,k,a,w,m,f,t,s,c,v,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NJ=e.$MJ=void 0;let p=class{constructor($,b,M,U,F){this.a=$,this.b=b,this.c=M,this.d=U,this.e=F}text($,b,M={}){$=this.f($,M);const U=this.a.getValue(),F=b&&b.some(W=>!this.a.getValue({resource:W}).search.useRipgrep);return{...this.h(b?.map(s.$7h),M),type:2,contentPattern:$,previewOptions:M.previewOptions,maxFileSize:M.maxFileSize,usePCRE2:U.search.usePCRE2||F||!1,beforeContext:M.beforeContext,afterContext:M.afterContext,userDisabledExcludesAndIgnoreFiles:M.disregardExcludeSettings&&M.disregardIgnoreFiles}}f($,b){const M=this.a.getValue();$.isRegExp&&($.pattern=$.pattern.replace(/\r?\n/g,"\\n"));const U={...$,wordSeparators:M.editor.wordSeparators};return this.j($,b)&&(U.isCaseSensitive=!0),this.k($)&&(U.isMultiline=!0),b.notebookSearchConfig?.includeMarkupInput&&(U.notebookInfo||(U.notebookInfo={}),U.notebookInfo.isInNotebookMarkdownInput=b.notebookSearchConfig.includeMarkupInput),b.notebookSearchConfig?.includeMarkupPreview&&(U.notebookInfo||(U.notebookInfo={}),U.notebookInfo.isInNotebookMarkdownPreview=b.notebookSearchConfig.includeMarkupPreview),b.notebookSearchConfig?.includeCodeInput&&(U.notebookInfo||(U.notebookInfo={}),U.notebookInfo.isInNotebookCellInput=b.notebookSearchConfig.includeCodeInput),b.notebookSearchConfig?.includeOutput&&(U.notebookInfo||(U.notebookInfo={}),U.notebookInfo.isInNotebookCellOutput=b.notebookSearchConfig.includeOutput),U}file($,b={}){return{...this.h($,b),type:1,filePattern:b.filePattern?b.filePattern.trim():b.filePattern,exists:b.exists,sortByScore:b.sortByScore,cacheKey:b.cacheKey}}g($,b){return $?($=Array.isArray($)?$.map(y):y($),b?this.parseSearchPaths($):{pattern:r(...Array.isArray($)?$:[$])}):{}}h($=[],b={}){const M=this.g(b.includePattern,b.expandPatterns),U=this.g(b.excludePattern,b.expandPatterns),F=$.length>1,q=(M.searchPaths&&M.searchPaths.length?M.searchPaths.map(z=>this.q(z,b,U)):$.map(z=>this.r(z,b,U,F))).filter(z=>!!z),W={_reason:b._reason,folderQueries:q,usingSearchPaths:!!(M.searchPaths&&M.searchPaths.length),extraFileResources:b.extraFileResources,excludePattern:U.pattern,includePattern:M.pattern,onlyOpenEditors:b.onlyOpenEditors,maxResults:b.maxResults};if(b.onlyOpenEditors){const z=h.$Fb(h.$Pb(this.c.groups.map(me=>me.editors.map(ye=>ye.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(z));const K=z.filter(me=>(0,S.$JI)(W,me.fsPath)),B=this.i(K);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(B)),{...W,...B}}const L=b.extraFileResources&&b.extraFileResources.filter(z=>(0,S.$JI)(W,z.fsPath));return W.extraFileResources=L&&L.length?L:void 0,W}i($){const b=[],M=new R.$yc,U={};let F=!1;return $.forEach(q=>{if(q.scheme===u.Schemas.walkThrough)return;if((0,d.$wg)(q)){const L=this.b.getWorkspaceFolder(q)?.uri??q.with({path:D.$kc(q.fsPath)});let z=M.get(L);z||(F=!0,z={folder:L,includePattern:{}},b.push(z),M.set(L,z));const K=D.$jc(L.fsPath,q.fsPath);(0,k.$Hf)(z.includePattern)[K.replace(/\\/g,"/")]=!0}else q.fsPath&&(F=!0,U[q.fsPath]=!0)}),{folderQueries:b,includePattern:U,usingSearchPaths:!0,excludePattern:F?void 0:{"**/*":!0}}}j($,b){if(b.isSmartCase){if($.isRegExp){if(A.$nf($.pattern,!0))return!0}else if(A.$nf($.pattern))return!0}return!!$.isCaseSensitive}k($){return $.isMultiline||$.isRegExp&&(0,w.$mB)($.pattern)||$.pattern.indexOf(`
`)>=0?!0:!!$.isMultiline}parseSearchPaths($){const b=B=>D.$gc(B)||/^\.\.?([\/\\]|$)/.test(B),U=(Array.isArray($)?$:i($)).map(B=>{const me=this.e.resolvedUserHome;return me?(0,O.$mv)(B,me.scheme===u.Schemas.file?me.fsPath:me.path):B}),F=C.$D(U,B=>b(B)?"searchPaths":"exprSegments"),q=(F.exprSegments||[]).map(B=>A.$Ie(B,"/")).map(B=>A.$Ie(B,"\\")).map(B=>(B[0]==="."&&(B="*"+B),o(B))),W={},L=this.m(F.searchPaths||[]);L&&L.length&&(W.searchPaths=L);const z=h.$Pb(q),K=r(...z);return K&&(W.pattern=K),W}l($,b){return b.disregardExcludeSettings?void 0:(0,S.$II)($,!b.disregardSearchExcludeSettings)}m($){if(!$||!$.length)return[];const b=$.flatMap(U=>{let{pathPortion:F,globPortion:q}=n(U);return q&&(q=g(q)),this.n(F).flatMap(L=>this.o(L,q))}),M=new Map;return b.forEach(U=>{const F=U.searchPath.toString(),q=M.get(F);q?U.pattern&&(q.pattern=q.pattern||{},q.pattern[U.pattern]=!0):M.set(F,{searchPath:U.searchPath,pattern:U.pattern?r(U.pattern):void 0})}),Array.from(M.values())}n($){if(D.$gc($)){const b=this.b.getWorkspace().folders;return b[0]&&b[0].uri.scheme!==u.Schemas.file?[{searchPath:b[0].uri.with({path:$})}]:[{searchPath:a.URI.file(D.$fc($))}]}if(this.b.getWorkbenchState()===2){const b=this.b.getWorkspace().folders[0].uri;if($=y($),$.startsWith("../")||$===".."){const U=D.$ec.resolve(b.path,$);return[{searchPath:b.with({path:U})}]}const M=g($);return[{searchPath:b,pattern:M}]}else{if($==="./"||$===".\\")return[];{const b=$.replace(/^\.[\/\\]/,""),U=this.b.getWorkspace().folders.map(F=>{const q=b.match(new RegExp(`^${A.$De(F.name)}(?:/(.*)|$)`));return q?{match:q,folder:F}:null}).filter(k.$Ef);if(U.length)return U.map(F=>{const q=F.match[1];return{searchPath:F.folder.uri,pattern:q&&g(q)}});{const F=$.match(/\.[\/\\](.+)[\/\\]?/),q=F?F[1]:$,W=m.localize(0,null,q);throw new Error(W)}}}}o($,b){const M=$.pattern&&b?`${$.pattern}/${b}`:$.pattern||b,U=[{searchPath:$.searchPath,pattern:M}];return M&&!M.endsWith("**")&&U.push({searchPath:$.searchPath,pattern:M+"/**"}),U}q($,b,M){const U=this.r((0,s.$7h)($.searchPath),b,M,!1);return U?{...U,includePattern:$.pattern}:null}r($,b,M,U){let F;const q=a.URI.isUri($)?$:$.uri;if(M.searchPaths){const B=M.searchPaths.filter(me=>(0,d.$lg)(me.searchPath,q))[0];if(B&&!B.pattern)return null;B&&(F=B.pattern)}const W=this.a.getValue({resource:q}),z={...this.l(W,b)||{},...F||{}},K=a.URI.isUri($)?(0,d.$pg)($):$.name;return{folder:q,folderName:U?K:void 0,excludePattern:Object.keys(z).length>0?z:void 0,fileEncoding:W.files&&W.files.encoding,disregardIgnoreFiles:typeof b.disregardIgnoreFiles=="boolean"?b.disregardIgnoreFiles:!W.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof b.disregardGlobalIgnoreFiles=="boolean"?b.disregardGlobalIgnoreFiles:!W.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof b.disregardParentIgnoreFiles=="boolean"?b.disregardParentIgnoreFiles:!W.search.useParentIgnoreFiles,ignoreSymlinks:typeof b.ignoreSymlinks=="boolean"?b.ignoreSymlinks:!W.search.followSymlinks}}};e.$MJ=p,e.$MJ=p=Je([qe(0,f.$fi),qe(1,s.$Uh),qe(2,c.$9B),qe(3,t.$6i),qe(4,v.$KJ)],p);function n(l){const $=l.match(/[\*\{\}\(\)\[\]\?]/);if($){const b=$.index,M=l.substr(0,b).match(/[/|\\][^/\\]*$/);if(M){let U=l.substr(0,M.index);return U.match(/[/\\]/)||(U+="/"),{pathPortion:U,globPortion:l.substr((M.index||0)+1)}}}return{pathPortion:l}}function r(...l){return l.length?l.reduce(($,b)=>($[b]=!0,$),Object.create(null)):void 0}function i(l){return I.$qj(l,",").map($=>$.trim()).filter($=>!!$.length)}function o(l){return[`**/${l}/**`,`**/${l}`].map(b=>b.replace(/\*\*\/\*\*/g,"**"))}function y(l){return l.replace(/\\/g,"/")}function g(l){return y(l).replace(/^\.\//,"").replace(/\/+$/g,"")}function E(l){return l.replace(/([?*[\]])/g,"[$1]")}function P(l,$){l=h.$Kb(l,U=>U.toString());const b=[],M=$.getWorkspace();return l&&l.forEach(U=>{let F;if($.getWorkbenchState()===2)F=(0,d.$ug)(M.folders[0].uri,U),F&&F!=="."&&(F="./"+F);else{const q=$.getWorkspaceFolder(U);if(q){const W=q.name;if(M.folders.filter(z=>z.name===W).length===1){const z=(0,d.$ug)(q.uri,U);z===""?F=`./${q.name}`:F=`./${q.name}/${z}`}else F=U.fsPath}}F&&b.push(E(F))}),b}e.$NJ=P}),define(Ae[269],Re([1,0,23,2,21,9,4,268,47,54]),function(ie,e,h,C,I,O,R,u,D,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$plb=e.$olb=void 0;const A=7e3;function k(f,t){const s=t.activationEvents;if(!s)return Promise.resolve(void 0);const c=[],v=[];for(const o of s)if(/^workspaceContains:/.test(o)){const y=o.substr(18);y.indexOf("*")>=0||y.indexOf("?")>=0||f.forceUsingSearch?v.push(y):c.push(y)}if(c.length===0&&v.length===0)return Promise.resolve(void 0);let S;const p=new Promise((o,y)=>{S=o}),n=o=>S({activationEvent:o}),r=Promise.all(c.map(o=>a(f,o,n))).then(()=>{}),i=w(f,t.identifier,v,n);return Promise.all([r,i]).then(()=>{S(void 0)}),p}e.$olb=k;async function a(f,t,s){for(const c of f.folders)if(await f.exists(h.$sg(C.URI.revive(c),t))){s(`workspaceContains:${t}`);return}}async function w(f,t,s,c){if(s.length===0)return Promise.resolve(void 0);const v=new I.$Vd,S=f.checkExists(f.folders,s,v.token),p=setTimeout(async()=>{v.cancel(),f.logService.info(`Not activating extension '${t.value}': Timed out while searching for 'workspaceContains' pattern ${s.join(",")}`)},A);let n=!1;try{n=await S}catch(r){O.$2(r)||O.$Y(r)}v.dispose(),clearTimeout(p),n&&c(`workspaceContains:${s.join(",")}`)}function m(f,t,s,c){const v=f.get(R.$Kh),S=f.get(D.$AI),n=v.createInstance(u.$MJ).file(t.map(r=>(0,d.$7h)(C.URI.revive(r))),{_reason:"checkExists",includePattern:s,exists:!0});return S.fileSearch(n,c).then(r=>!!r.limitHit,r=>O.$2(r)?!1:Promise.reject(r))}e.$plb=m});var Ye=this&&this.__classPrivateFieldSet||function(ie,e,h,C,I){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!I:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?I.call(ie,h):I?I.value=h:e.set(ie,h),h},Ne=this&&this.__classPrivateFieldGet||function(ie,e,h,C){if(h==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!C:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?C:h==="a"?C.call(ie):C?C.value:e.get(ie)};define(Ae[35],Re([1,0,148,19,87,23,12,6,48,2,14,3,34,209,84,33,26,106,9,20,25,188,7,97,4,27,85,17,72,86,63,5,269,83,190,13,81,59,22,82]),function(ie,e,h,C,I,O,R,u,D,d,A,k,a,w,m,f,t,s,c,v,S,p,n,r,i,o,y,g,E,P,l,$,b,M,U,F,q,W,L,z){"use strict";var K,B,me,ye;Object.defineProperty(e,"__esModule",{value:!0}),e.$kcc=e.$jcc=e.$icc=e.$hcc=e.$gcc=void 0,e.$gcc=(0,i.$Lh)("IHostUtils");let Ie=ye=class extends u.$Qc{constructor(ee,$e,he,fe,Ee,re,le,oe,ae,pe,Ce,T){super(),this.X=T,this.a=this.B(new $.$Ld),this.onDidChangeRemoteConnectionData=this.a.event,this.U=!1,this.c=$e,this.g=he,this.f=le,this.j=fe,this.m=Ee,this.s=re,this.t=ae,this.u=pe,this.w=Ce,this.y=this.g.getProxy(k.$9J.MainThreadWorkspace),this.z=this.g.getProxy(k.$9J.MainThreadTelemetry),this.C=this.g.getProxy(k.$9J.MainThreadExtensionService),this.D=new R.$Pg,this.F=new R.$Pg,this.G=new R.$Pg,this.H=new R.$Pg,this.I=new V(this.f.extensions.activationEvents),this.L=new s.$53b(this.I,this.f.extensions.allExtensions);const H=new v.$Yl(this.f.extensions.myExtensions);this.J=new s.$53b(this.I,ve(this.L,H)),L.$n&&(this.s.info(`Creating extension host with the following global extensions: ${De(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${De(this.J)}`)),this.M=new m.$Zbc(this.g,this.s),this.N=new M.$_bc(this.g),this.O=oe,this.h=ee.createChild(new E.$Jh([m.$1bc,this.M],[M.$acc,this.N])),this.P=this.B(new w.$Ybc(this.J,this.L,{onExtensionActivationError:(X,Y,J)=>{this.C.$onExtensionActivationError(X,c.$1(Y),J)},actualActivateExtension:async(X,Y)=>{if(s.$53b.isHostExtension(X,this.J,this.L))return await this.C.$activateExtension(X,Y),new w.$Xbc;const J=this.J.getExtensionDescription(X);return this.db(J,Y)}},this.s)),this.Q=null,this.R=Object.create(null),this.S=!1,this.W=this.f.remote.connectionData}getRemoteConnectionData(){return this.W}async initialize(){try{await this.tb(),this.D.open(),await this.j.waitForInitializeCall(),I.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.rb()}catch(ee){c.$Y(ee)}}async Y(){this.O.onWillDeactivateAll();let ee=[];try{ee=this.J.getAllExtensionDescriptions().map(Ee=>Ee.identifier).filter(Ee=>this.isActivated(Ee)).map(Ee=>this.cb(Ee))}catch{}await Promise.all(ee)}terminate(ee,$e=0){if(this.U)return;this.U=!0,this.s.info(`Extension host terminating: ${ee}`),this.s.flush(),this.u.dispose(),this.P.dispose(),c.setUnexpectedErrorHandler(fe=>{this.s.error(fe)}),this.g.dispose();const he=this.Y();Promise.race([(0,R.$Rg)(5e3),he]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${$e}`):this.s.info(`Extension host exiting with code ${$e}`),this.s.flush(),this.s.dispose(),this.c.exit($e)})}isActivated(ee){return this.G.isOpen()?this.P.isActivated(ee):!1}async getExtension(ee){const $e=await this.C.$getExtension(ee);return $e&&{...$e,identifier:new v.$Xl($e.identifier.value),extensionLocation:d.URI.revive($e.extensionLocation)}}Z(ee,$e){return this.P.activateByEvent(ee,$e)}$(ee,$e){return this.P.activateById(ee,$e)}activateByIdWithErrors(ee,$e){return this.$(ee,$e).then(()=>{const he=this.P.getActivatedExtension(ee);if(he.activationFailed)return Promise.reject(he.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(ee=>this.J)}getExtensionExports(ee){if(this.G.isOpen())return this.P.getActivatedExtension(ee).exports;try{return this.P.getActivatedExtension(ee).exports}catch{return null}}async ab(ee){if(ee.scheme===F.Schemas.file&&this.c.fsRealpath){const $e=await this.c.fsRealpath(ee.fsPath);return d.URI.file($e)}return ee}async getExtensionPathIndex(){return this.Q||(this.Q=this.bb(this.J.getAllExtensionDescriptions()).then(ee=>new ke(ee))),this.Q}async bb(ee){const $e=D.$Rh.forUris(he=>O.$jg.ignorePathCasing(he));return await Promise.all(ee.map(async he=>{if(this.ub(he)){const fe=await this.ab(he.extensionLocation);$e.set(fe,he)}})),$e}cb(ee){let $e=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(ee))return $e;const he=this.P.getActivatedExtension(ee);if(!he)return $e;try{typeof he.module.deactivate=="function"&&($e=Promise.resolve(he.module.deactivate()).then(void 0,fe=>(this.s.error(fe),Promise.resolve(void 0))))}catch(fe){this.s.error(`An error occurred when deactivating the extension '${ee.value}':`),this.s.error(fe)}try{(0,u.$Lc)(he.subscriptions)}catch(fe){this.s.error(`An error occurred when deactivating the subscriptions for extension '${ee.value}':`),this.s.error(fe)}return $e}async db(ee,$e){return this.f.remote.isRemote?this.C.$onWillActivateExtension(ee.identifier):await this.C.$onWillActivateExtension(ee.identifier),this.fb(ee,$e).then(he=>{const fe=he.activationTimes;return this.C.$onDidActivateExtension(ee.identifier,fe.codeLoadingTime,fe.activateCallTime,fe.activateResolvedTime,$e),this.eb(ee,$e,"success",fe),he},he=>{throw this.eb(ee,$e,"failure"),he})}eb(ee,$e,he,fe){const Ee=de(ee,$e);this.z.$publicLog2("extensionActivationTimes",{...Ee,...fe||{},outcome:he})}fb(ee,$e){const he=de(ee,$e);this.z.$publicLog2("activatePlugin",he);const fe=this.ub(ee);if(!fe)return Promise.resolve(new w.$Wbc(w.$Tbc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${ee.identifier.value}, startup: ${$e.startup}, activationEvent: '${$e.activationEvent}'${ee.identifier.value!==$e.extensionId.value?`, root cause: ${$e.extensionId.value}`:""}`),this.s.flush();const Ee=new w.$Ubc($e.startup);return Promise.all([this.vb(ee,(0,O.$sg)(ee.extensionLocation,fe),Ee),this.gb(ee)]).then(re=>(I.mark(`code/extHost/willActivateExtension/${ee.identifier.value}`),ye.hb(this.s,ee.identifier,re[0],re[1],Ee))).then(re=>(I.mark(`code/extHost/didActivateExtension/${ee.identifier.value}`),re))}gb(ee){const $e=new p.$3bc(ee,this.M),he=new p.$2bc(ee.identifier.value,!1,this.M),fe=new U.$bcc(ee,this.N),Ee=ee.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?n.ExtensionMode.Test:n.ExtensionMode.Development:n.ExtensionMode.Production,re=this.f.remote.isRemote?n.ExtensionKind.Workspace:n.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${ee.identifier.value}`),Promise.all([$e.whenReady,he.whenReady,this.O.whenReady]).then(()=>{const le=this;let oe,ae;const pe=(0,t.$7E)(ee,"ipc")?this.f.messagePorts?.get(v.$Xl.toKey(ee.identifier)):void 0;return Object.freeze({globalState:$e,workspaceState:he,secrets:fe,subscriptions:[],get extensionUri(){return ee.extensionLocation},get extensionPath(){return ee.extensionLocation.fsPath},asAbsolutePath(Ce){return C.$hc(ee.extensionLocation.fsPath,Ce)},get storagePath(){return le.O.workspaceValue(ee)?.fsPath},get globalStoragePath(){return le.O.globalValue(ee).fsPath},get logPath(){return C.$hc(le.f.logsLocation.fsPath,ee.identifier.value)},get logUri(){return d.URI.joinPath(le.f.logsLocation,ee.identifier.value)},get storageUri(){return le.O.workspaceValue(ee)},get globalStorageUri(){return le.O.globalValue(ee)},get extensionMode(){return Ee},get extension(){return oe===void 0&&(oe=new ue(le,ee.identifier,ee,re,!1)),oe},get extensionRuntime(){return(0,t.$8E)(ee,"extensionRuntime"),le.extensionRuntime},get environmentVariableCollection(){return le.u.getEnvironmentVariableCollection(ee)},get messagePassingProtocol(){if(!ae){if(!pe)return;const Ce=$.Event.buffer($.Event.fromDOMEventEmitter(pe,"message",T=>T.data));pe.start(),ae={onDidReceiveMessage:Ce,postMessage:pe.postMessage.bind(pe)}}return ae}})})}static hb(ee,$e,he,fe,Ee){return he=he||{activate:void 0,deactivate:void 0},this.ib(ee,$e,he,fe,Ee).then(re=>new w.$Vbc(!1,null,Ee.build(),he,re,fe.subscriptions))}static ib(ee,$e,he,fe,Ee){if(typeof he.activate=="function")try{Ee.activateCallStart(),ee.trace(`ExtensionService#_callActivateOptional ${$e.value}`);const re=typeof global=="object"?global:self,le=he.activate.apply(re,[fe]);return Ee.activateCallStop(),Ee.activateResolveStart(),Promise.resolve(le).then(oe=>(Ee.activateResolveStop(),oe))}catch(re){return Promise.reject(re)}else return Promise.resolve(he)}jb(ee,$e){this.$(ee.identifier,{startup:!1,extensionId:ee.identifier,activationEvent:$e}).then(void 0,he=>{this.s.error(he)})}kb(ee,$e=0){const fe=Date.now();(0,L.$v)(()=>{for(let Ee=$e;Ee<ee.length;Ee+=1){const re=ee[Ee];for(const le of re.activationEvents??[])if(le==="onStartupFinished")if(Date.now()-fe>50){this.kb(ee,Ee);break}else this.jb(re,le)}})}lb(){this.C.$setPerformanceMarks(I.getMarks()),this.m.getConfigProvider().then(ee=>{const $e=ee.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),he=this.J.getAllExtensionDescriptions();if($e)this.kb(he);else for(const fe of he)if(fe.activationEvents)for(const Ee of fe.activationEvents)Ee==="onStartupFinished"&&this.jb(fe,Ee)})}mb(){const ee=this.Z("*",!0).then(void 0,re=>{this.s.error(re)});this.B(this.j.onDidChangeWorkspace(re=>this.nb(re.added)));const $e=this.j.workspace?this.j.workspace.folders:[],he=this.nb($e),fe=this.pb(),Ee=Promise.all([fe,ee,he]).then(()=>{});return Promise.race([Ee,(0,R.$Rg)(1e4)]).then(()=>{this.lb()}),Ee}nb(ee){return ee.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map($e=>this.ob(ee,$e))).then(()=>{})}async ob(ee,$e){if(this.isActivated($e.identifier))return;const he=!this.f.remote.isRemote&&!!this.f.remote.authority,fe={logService:this.s,folders:ee.map(re=>re.uri),forceUsingSearch:he||!this.c.fsExists,exists:re=>this.c.fsExists(re.fsPath),checkExists:(re,le,oe)=>this.y.$checkExists(re,le,oe)},Ee=await(0,b.$olb)(fe,$e);if(Ee)return this.$($e.identifier,{startup:!0,extensionId:$e.identifier,activationEvent:Ee.activationEvent}).then(void 0,re=>this.s.error(re))}async pb(){if(this.f.remote.authority)return this.Z(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.qb()}catch(ee){throw console.error(ee),ee}}async qb(){const{extensionDevelopmentLocationURI:ee,extensionTestsLocationURI:$e}=this.f.environment;if(!ee||!$e)throw new Error(h.localize(0,null));const he=await this.vb(null,$e,new w.$Ubc(!1));if(!he||typeof he.run!="function")throw new Error(h.localize(1,null,$e.toString()));return new Promise((fe,Ee)=>{const re=(ae,pe)=>{ae?(L.$n&&this.s.error("Test runner called back with error",ae),Ee(ae)):(L.$n&&(pe?this.s.info(`Test runner called back with ${pe} failures.`):this.s.info("Test runner called back with successful outcome.")),fe(typeof pe=="number"&&pe>0?1:0))},le=(0,O.$gg)($e),oe=he.run(le,re);oe&&oe.then&&oe.then(()=>{L.$n&&this.s.info("Test runner finished successfully."),fe(0)}).catch(ae=>{L.$n&&this.s.error("Test runner finished with error",ae),Ee(ae instanceof Error&&ae.stack?ae.stack:String(ae))})})}rb(){if(this.S)throw new Error("Extension host is already started!");return this.S=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,R.$Rg)(1e3)])).then(()=>this.mb()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(ee,$e){return this.R[ee]=$e,(0,u.$Oc)(()=>{delete this.R[ee]})}async getRemoteExecServer(ee){const{resolver:$e}=await this.sb(ee);return $e?.resolveExecServer?.(ee,{resolveAttempt:0})}async sb(ee){const $e=ee.indexOf("+");if($e===-1)throw new n.$eK("Not an authority that can be resolved!",r.RemoteAuthorityResolverErrorCode.InvalidAuthority);const he=ee.substr(0,$e);return await this.D.wait(),await this.Z(`onResolveRemoteAuthority:${he}`,!1),{authorityPrefix:he,resolver:this.R[he]}}async $resolveAuthority(ee,$e){const he=W.$Hd.create(!1),fe=()=>`[resolveAuthority(${(0,r.$Ok)(ee)},${$e})][${he.elapsed()}ms] `,Ee=se=>this.s.info(`${fe()}${se}`),re=se=>this.s.warn(`${fe()}${se}`),le=(se,Fe=void 0)=>this.s.error(`${fe()}${se}`,Fe),oe=se=>{if(se instanceof n.$eK)return{type:"error",error:{code:se._code,message:se._message,detail:se._detail}};throw se},ae=async se=>{Ee(`activating resolver for ${se}...`);const{resolver:Fe,authorityPrefix:je}=await this.sb(se);if(!Fe)throw le(`no resolver for ${je}`),new n.$eK(`No remote extension installed to resolve ${je}.`,r.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:Fe,authorityPrefix:je,remoteAuthority:se}},pe=ee.split(/@|%40/g).reverse();Ee(`activating remote resolvers ${pe.join(" -> ")}`);let Ce;try{Ce=await Promise.all(pe.map(ae)).catch(async se=>{if(!(se instanceof n.$eK)||se._code!==r.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw se;return re(`resolving nested authorities failed: ${se.message}`),[await ae(ee)]})}catch(se){return oe(se)}const T=new R.$2g;T.cancelAndSet(()=>Ee("waiting..."),1e3);let H,X;for(const[se,{authorityPrefix:Fe,resolver:je,remoteAuthority:Xe}]of Ce.entries())try{if(se===Ce.length-1)Ee("invoking final resolve()..."),I.mark(`code/extHost/willResolveAuthority/${Fe}`),H=await je.resolve(Xe,{resolveAttempt:$e,execServer:X}),I.mark(`code/extHost/didResolveAuthorityOK/${Fe}`),Ee("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(je,n.$dK.isManagedResolvedAuthority(H)?H:void 0));else{if(Ee(`invoking resolveExecServer() for ${Xe}`),I.mark(`code/extHost/willResolveExecServer/${Fe}`),X=await je.resolveExecServer?.(Xe,{resolveAttempt:$e,execServer:X}),!X)throw new n.$eK(`Exec server was not available for ${Xe}`,r.RemoteAuthorityResolverErrorCode.NoResolverFound);I.mark(`code/extHost/didResolveExecServerOK/${Fe}`)}}catch(He){return I.mark(`code/extHost/didResolveAuthorityError/${Fe}`),le("returned an error",He),T.dispose(),oe(He)}T.dispose();const Y={environmentTunnels:H.environmentTunnels,features:H.tunnelFeatures},J={extensionHostEnv:H.extensionHostEnv,isTrusted:H.isTrusted,authenticationSession:H.authenticationSessionForInitializingExtensions?{id:H.authenticationSessionForInitializingExtensions.id,providerId:H.authenticationSessionForInitializingExtensions.providerId}:void 0};Ee(`returned ${n.$dK.isManagedResolvedAuthority(H)?"managed authority":`${H.host}:${H.port}`}`);let te;if(n.$dK.isManagedResolvedAuthority(H)){const se=$e;this.X.setFactory(se,H.makeConnection),te={authority:ee,connectTo:new r.$Lk(se),connectionToken:H.connectionToken}}else te={authority:ee,connectTo:new r.$Mk(H.host,H.port),connectionToken:H.connectionToken};return{type:"ok",value:{authority:te,options:J,tunnelInformation:Y}}}async $getCanonicalURI(ee,$e){this.s.info(`$getCanonicalURI invoked for authority (${(0,r.$Ok)(ee)})`);const{resolver:he}=await this.sb(ee);if(!he)return null;const fe=d.URI.revive($e);if(typeof he.getCanonicalURI>"u")return fe;const Ee=await(0,R.$Jg)(()=>he.getCanonicalURI(fe));return Ee||fe}$startExtensionHost(ee){ee.toAdd.forEach(fe=>fe.extensionLocation=d.URI.revive(fe.extensionLocation));const{globalRegistry:$e,myExtensions:he}=_(this.I,this.L,this.J,ee);return this.L.set($e.getAllExtensionDescriptions()),this.J.set(he),L.$n&&(this.s.info(`$startExtensionHost: global extensions: ${De(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${De(this.J)}`)),this.rb()}$activateByEvent(ee,$e){return $e===1?this.D.wait().then(he=>this.Z(ee,!1)):this.G.wait().then(he=>this.Z(ee,!1))}async $activate(ee,$e){return await this.G.wait(),this.J.getExtensionDescription(ee)?(await this.$(ee,$e),!0):!1}async $deltaExtensions(ee){ee.toAdd.forEach(re=>re.extensionLocation=d.URI.revive(re.extensionLocation));const{globalRegistry:$e,myExtensions:he}=_(this.I,this.L,this.J,ee),fe=await this.bb(he);return(await this.getExtensionPathIndex()).setSearchTree(fe),this.L.set($e.getAllExtensionDescriptions()),this.J.set(he),L.$n&&(this.s.info(`$deltaExtensions: global extensions: ${De(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${De(this.J)}`)),Promise.resolve(void 0)}async $test_latency(ee){return ee}async $test_up(ee){return ee.byteLength}async $test_down(ee){const $e=S.$_d.alloc(ee),he=Math.random()%256;for(let fe=0;fe<ee;fe++)$e.writeUInt8(he,fe);return $e}async $updateRemoteConnectionData(ee){this.W=ee,this.a.fire()}};e.$hcc=Ie,e.$hcc=Ie=ye=Je([qe(0,i.$Kh),qe(1,e.$gcc),qe(2,g.$0L),qe(3,f.$Mbc),qe(4,a.$Pbc),qe(5,A.$6i),qe(6,o.$nM),qe(7,y.$6bc),qe(8,P.$ksb),qe(9,l.$8bc),qe(10,q.$dcc),qe(11,z.$ecc)],Ie);function _(Q,ee,$e,he){Q.addActivationEvents(he.addActivationEvents);const fe=new s.$53b(Q,ee.getAllExtensionDescriptions());fe.deltaExtensions(he.toAdd,he.toRemove);const Ee=new v.$Yl($e.getAllExtensionDescriptions().map(le=>le.identifier));for(const le of he.myToRemove)Ee.delete(le);for(const le of he.myToAdd)Ee.add(le);const re=ve(fe,Ee);return{globalRegistry:fe,myExtensions:re}}function de(Q,ee){return{id:Q.identifier.value,name:Q.name,extensionVersion:Q.version,publisherDisplayName:Q.publisher,activationEvents:Q.activationEvents?Q.activationEvents.join(","):null,isBuiltin:Q.isBuiltin,reason:ee.activationEvent,reasonId:ee.extensionId.value}}function De(Q){return Q.getAllExtensionDescriptions().map(ee=>ee.identifier.value).join(",")}e.$icc=(0,i.$Lh)("IExtHostExtensionService");class ue{constructor(ee,$e,he,fe,Ee){K.set(this,void 0),B.set(this,void 0),me.set(this,void 0),Ye(this,K,ee,"f"),Ye(this,B,$e,"f"),Ye(this,me,he.identifier,"f"),this.id=he.identifier.value,this.extensionUri=he.extensionLocation,this.extensionPath=C.$fc((0,O.$gg)(he.extensionLocation)),this.packageJSON=he,this.extensionKind=fe,this.isFromDifferentExtensionHost=Ee}get isActive(){return Ne(this,K,"f").isActivated(Ne(this,me,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return Ne(this,K,"f").getExtensionExports(Ne(this,me,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await Ne(this,K,"f").activateByIdWithErrors(Ne(this,me,"f"),{startup:!1,extensionId:Ne(this,B,"f"),activationEvent:"api"}),this.exports}}e.$jcc=ue,K=new WeakMap,B=new WeakMap,me=new WeakMap;function ve(Q,ee){return Q.getAllExtensionDescriptions().filter($e=>ee.has($e.identifier))}class ke{constructor(ee){this.a=ee}setSearchTree(ee){this.a=ee}findSubstr(ee){return this.a.findSubstr(ee)}forEach(ee){return this.a.forEach(ee)}}e.$kcc=ke;class V{constructor(ee){this.a=new v.$Zl,this.addActivationEvents(ee)}readActivationEvents(ee){return this.a.get(ee.identifier)}addActivationEvents(ee){for(const $e of Object.keys(ee))this.a.set($e,ee[$e])}}}),define(Ae[270],Re([1,0,87,2,3,34,26,20,17,27,4,35,14,15]),function(ie,e,h,C,I,O,R,u,D,d,A,k,a,w){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hdc=void 0;let f=class{constructor(S,p,n,r,i,o,y){this.c=S,this.d=p,this.f=n,this.g=r,this.h=i,this.i=o,this.j=y,this.a=new Map,this.b=[]}async install(){this.k(),h.mark("code/extHost/willWaitForConfig");const S=await this.g.getConfigProvider();h.mark("code/extHost/didWaitForConfig");const p=await this.h.getExtensionPathIndex();this.register(new s(this.c,p,this.d,S,this.j)),this.register(this.f.createInstance(t)),this.i.remote.isRemote&&this.register(this.f.createInstance(c,p,this.i.environment.appUriScheme))}register(S){if("nodeModuleName"in S)if(Array.isArray(S.nodeModuleName))for(const p of S.nodeModuleName)this.a.set(p,S);else this.a.set(S.nodeModuleName,S);typeof S.alternativeModuleName=="function"&&this.b.push(p=>S.alternativeModuleName(p))}};e.$Hdc=f,e.$Hdc=f=Je([qe(2,A.$Kh),qe(3,O.$Pbc),qe(4,k.$icc),qe(5,d.$nM),qe(6,a.$6i)],f);let t=m=class{constructor(S){if(S.environment.appRoot&&m.a.size){const p=(0,w.$De)(this.c(S.environment.appRoot.fsPath)),n="[a-z0-9_.-]",r=`@${n}+\\/${n}+|${n}+`,i="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${p}/${i}\\/)(${r})(.*)$`,"i")}}alternativeModuleName(S){if(!this.b)return;const p=this.b.exec(this.c(S));if(!p)return;const[,n,r,i]=p,o=m.a.get(r);if(o!==void 0)return console.warn(`${r} as been renamed to ${o}, please update your imports`),n+o+i}c(S){return S.replace(/\\/g,"/")}};t.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),t=m=Je([qe(0,d.$nM)],t);class s{constructor(S,p,n,r,i){this.c=S,this.d=p,this.e=n,this.f=r,this.g=i,this.nodeModuleName="vscode",this.a=new u.$Zl}load(S,p){const n=this.d.findSubstr(p);if(n){let r=this.a.get(n.identifier);return r||(r=this.c(n,this.e,this.f),this.a.set(n.identifier,r)),r}if(!this.b){let r="";this.d.forEach((i,o)=>r+=`	${o} -> ${i.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${p}. These are the extension path mappings: 
${r}`),this.b=this.c(R.$2E,this.e,this.f)}return this.b}}let c=class{constructor(S,p,n){this.e=S,this.f=p,this.nodeModuleName=["open","opn"],this.d=n.getProxy(I.$9J.MainThreadTelemetry);const r=n.getProxy(I.$9J.MainThreadWindow);this.c=(i,o)=>{const y=C.URI.parse(i);return o?this.g(i,o):y.scheme==="http"||y.scheme==="https"?r.$openUri(y,i,{allowTunneling:!0}):y.scheme==="mailto"||y.scheme===this.f?r.$openUri(y,i,{}):this.g(i,o)}}load(S,p,n){const r=this.e.findSubstr(p);return r&&(this.a=r.identifier.value,this.h()),this.b=n(S),this.c}g(S,p){return this.i(),this.b(S,p)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};c=Je([qe(2,D.$0L)],c)}),define(Ae[112],Re([1,0,66,6,19,74,4,60,61,35,7,33,200,34]),function(ie,e,h,C,I,O,R,u,D,d,A,k,a,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rcc=e.$Qcc=void 0,e.$Qcc=(0,R.$Lh)("IExtHostVariableResolverProvider");class m extends a.$$M{constructor(s,c,v,S,p,n,r){function i(){if(v){const o=v.activeEditor();if(o)return o.document.uri;const y=S.tabGroups.all.find(g=>g.isActive)?.activeTab;if(y!==void 0){if(y.input instanceof A.$QL||y.input instanceof A.$VL)return y.input.modified;if(y.input instanceof A.$PL||y.input instanceof A.$UL||y.input instanceof A.$SL)return y.input.uri}}}super({getFolderUri:o=>{const y=n.folders.filter(g=>g.name===o);if(y&&y.length>0)return y[0].uri},getWorkspaceFolderCount:()=>n.folders.length,getConfigurationValue:(o,y)=>p.getConfiguration(void 0,o).get(y),getAppRoot:()=>O.cwd(),getExecPath:()=>O.env.VSCODE_EXEC_PATH,getFilePath:()=>{const o=i();if(o)return I.$fc(o.fsPath)},getWorkspaceFolderPathForFile:()=>{if(c){const o=i();if(o){const y=c.getWorkspaceFolder(o);if(y)return I.$fc(y.uri.fsPath)}}},getSelectedText:()=>{if(v){const o=v.activeEditor();if(o&&!o.selection.isEmpty)return o.document.getText(o.selection)}},getLineNumber:()=>{if(v){const o=v.activeEditor();if(o)return String(o.selection.end.line+1)}},getExtension:o=>s.getExtension(o)},void 0,r?Promise.resolve(r):void 0,Promise.resolve(O.env))}}let f=class extends C.$Qc{constructor(s,c,v,S,p){super(),this.b=s,this.c=c,this.g=v,this.h=S,this.j=p,this.a=new h.$T(async()=>{const n=await this.h.getConfigProvider(),i={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async o=>{i.folders=await this.c.getWorkspaceFolders2()||[]})),new m(this.b,this.c,this.g,this.j,n,i,this.m())})}getResolver(){return this.a.value}m(){}};e.$Rcc=f,e.$Rcc=f=Je([qe(0,d.$icc),qe(1,k.$Mbc),qe(2,u.$iM),qe(3,w.$Pbc),qe(4,D.$Occ)],f)}),define(Ae[113],Re([1,0,12,5,2,4,3,61,35,17,7,33,193,195,34,112]),function(ie,e,h,C,I,O,R,u,D,d,A,k,a,w,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wcc=e.$Vcc=e.$Ucc=e.$Tcc=e.$Scc=void 0,e.$Scc=(0,O.$Lh)("IExtHostDebugService");let t=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(r,i,o,y,g,E){this.E=i,this.F=o,this.G=y,this.H=g,this.I=E,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.B=new Map,this.C=new Map,this.m=new C.$Ld,this.n=new C.$Ld,this.o=new C.$Ld,this.u=new C.$Ld,this.k=r.getProxy(R.$9J.MainThreadDebugService),this.y=new C.$Ld,this.A=new C.$Ld,this.v=new c(this.k),this.w=new Map,this.F.getExtensionRegistry().then(P=>{P.onDidChange(l=>{this.J(P)}),this.J(P)})}asDebugSourceUri(r,i){const o=r;if(typeof o.sourceReference=="number"&&o.sourceReference>0){let y=`debug:${encodeURIComponent(o.path||"")}`,g="?";return i&&(y+=`${g}session=${encodeURIComponent(i.id)}`,g="&"),y+=`${g}ref=${o.sourceReference}`,I.URI.parse(y)}else{if(o.path)return I.URI.file(o.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}J(r){const i=[];for(const o of r.getAllExtensionDescriptions())if(o.contributes){const y=o.contributes.debuggers;if(y&&y.length>0)for(const g of y)(0,w.$nF)(g)&&i.push(g.type)}this.k.$registerDebugTypes(i)}get stackFrameFocus(){return this.z}get onDidChangeStackFrameFocus(){return this.A.event}get onDidChangeBreakpoints(){return this.y.event}get breakpoints(){const r=[];return this.w.forEach(i=>r.push(i)),r}addBreakpoints(r){const i=r.filter(g=>{const E=g.id;return this.w.has(E)?!1:(this.w.set(E,g),!0)});this.U(i,[],[]);const o=[],y=new Map;for(const g of i)if(g instanceof A.$0K){let E=y.get(g.location.uri.toString());E||(E={type:"sourceMulti",uri:g.location.uri,lines:[]},y.set(g.location.uri.toString(),E),o.push(E)),E.lines.push({id:g.id,enabled:g.enabled,condition:g.condition,hitCondition:g.hitCondition,logMessage:g.logMessage,line:g.location.range.start.line,character:g.location.range.start.character})}else g instanceof A.$$K&&o.push({type:"function",id:g.id,enabled:g.enabled,hitCondition:g.hitCondition,logMessage:g.logMessage,condition:g.condition,functionName:g.functionName});return this.k.$registerBreakpoints(o)}removeBreakpoints(r){const i=r.filter(E=>this.w.delete(E.id));this.U([],i,[]);const o=i.filter(E=>E instanceof A.$0K).map(E=>E.id),y=i.filter(E=>E instanceof A.$$K).map(E=>E.id),g=i.filter(E=>E instanceof A.$_K).map(E=>E.id);return this.k.$unregisterBreakpoints(o,y,g)}startDebugging(r,i,o){return this.k.$startDebugging(r?r.uri:void 0,i,{parentSessionID:o.parentSession?o.parentSession.id:void 0,lifecycleManagedByParent:o.lifecycleManagedByParent,repl:o.consoleMode===A.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:o.noDebug,compact:o.compact,suppressSaveBeforeStart:o.suppressSaveBeforeStart,suppressDebugStatusbar:o.suppressDebugStatusbar??o.debugUI?.simple,suppressDebugToolbar:o.suppressDebugToolbar??o.debugUI?.simple,suppressDebugView:o.suppressDebugView??o.debugUI?.simple})}stopDebugging(r){return this.k.$stopDebugging(r?r.id:void 0)}registerDebugConfigurationProvider(r,i,o){if(!i)return new A.$$J(()=>{});const y=this.d++;return this.f.push({type:r,handle:y,provider:i}),this.k.$registerDebugConfigurationProvider(r,o,!!i.provideDebugConfigurations,!!i.resolveDebugConfiguration,!!i.resolveDebugConfigurationWithSubstitutedVariables,y),new A.$$J(()=>{this.f=this.f.filter(g=>g.provider!==i),this.k.$unregisterDebugConfigurationProvider(y)})}registerDebugAdapterDescriptorFactory(r,i,o){if(!o)return new A.$$J(()=>{});if(!this.Q(r,i))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${i}' debugger.`);if(this.N(i))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const y=this.g++;return this.h.push({type:i,handle:y,factory:o}),this.k.$registerDebugAdapterDescriptorFactory(i,y),new A.$$J(()=>{this.h=this.h.filter(g=>g.factory!==o),this.k.$unregisterDebugAdapterDescriptorFactory(y)})}registerDebugAdapterTrackerFactory(r,i){if(!i)return new A.$$J(()=>{});const o=this.i++;return this.j.push({type:r,handle:o,factory:i}),new A.$$J(()=>{this.j=this.j.filter(y=>y.factory!==i)})}async $runInTerminal(r,i){return Promise.resolve(void 0)}async $substituteVariables(r,i){let o;const y=await this.W(r);return y&&(o={uri:y.uri,name:y.name,index:y.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.I.getResolver()).resolveAnyAsync(o,i)}K(r,i){if(r.type==="implementation")return new S(r.implementation)}L(){}async $startDASession(r,i){const o=this,y=await this.V(i);return this.S(this.N(y.type),y).then(g=>{if(!g)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${y.type}' (extension might have failed to activate)`);const E=this.M(g),P=this.K(E,y);if(!P)throw new Error(`Couldn't create a debug adapter for type '${y.type}'.`);const l=P;return this.B.set(r,l),this.R(y).then($=>($&&this.C.set(r,$),l.onMessage(async b=>{if(b.type==="request"&&b.command==="handshake"){const M=b,U={type:"response",seq:0,command:M.command,request_seq:M.seq,success:!0};this.D||(this.D=this.L());try{if(this.D){const F=await this.D.sign(M.arguments.value);U.body={signature:F},l.sendResponse(U)}else throw new Error("no signer")}catch(F){U.success=!1,U.message=F.message,l.sendResponse(U)}}else $&&$.onDidSendMessage&&$.onDidSendMessage(b),b=(0,w.$sF)(b,!0),o.k.$acceptDAMessage(r,b)}),l.onError(b=>{$&&$.onError&&$.onError(b),this.k.$acceptDAError(r,b.name,b.message,b.stack)}),l.onExit(b=>{$&&$.onExit&&$.onExit(b??void 0,void 0),this.k.$acceptDAExit(r,b??void 0,void 0)}),$&&$.onWillStartSession&&$.onWillStartSession(),l.startSession()))})}$sendDAMessage(r,i){i=(0,w.$rF)(i,!1);const o=this.C.get(r);o&&o.onWillReceiveMessage&&o.onWillReceiveMessage(i),this.B.get(r)?.sendMessage(i)}$stopDASession(r){const i=this.C.get(r);this.C.delete(r),i&&i.onWillStopSession&&i.onWillStopSession();const o=this.B.get(r);return this.B.delete(r),o?o.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(r){const i=[],o=[],y=[];if(r.added)for(const g of r.added){const E=g.id;if(E&&!this.w.has(E)){let P;if(g.type==="function")P=new A.$$K(g.functionName,g.enabled,g.condition,g.hitCondition,g.logMessage);else if(g.type==="data")P=new A.$_K(g.label,g.dataId,g.canPersist,g.enabled,g.hitCondition,g.condition,g.logMessage);else{const l=I.URI.revive(g.uri);P=new A.$0K(new A.$kK(l,new A.$_J(g.line,g.character)),g.enabled,g.condition,g.hitCondition,g.logMessage)}(0,A.$8K)(P,E),this.w.set(E,P),i.push(P)}}if(r.removed)for(const g of r.removed){const E=this.w.get(g);E&&(this.w.delete(g),o.push(E))}if(r.changed){for(const g of r.changed)if(g.id){const E=this.w.get(g.id);if(E){if(E instanceof A.$$K&&g.type==="function"){const P=E;P.enabled=g.enabled,P.condition=g.condition,P.hitCondition=g.hitCondition,P.logMessage=g.logMessage,P.functionName=g.functionName}else if(E instanceof A.$0K&&g.type==="source"){const P=E;P.enabled=g.enabled,P.condition=g.condition,P.hitCondition=g.hitCondition,P.logMessage=g.logMessage,P.location=new A.$kK(I.URI.revive(g.uri),new A.$_J(g.line,g.character))}y.push(E)}}}this.U(i,o,y)}async $acceptStackFrameFocus(r){let i;const o=r.sessionId?await this.V(r.sessionId):void 0;if(!o)throw new Error("no DebugSession found for debug focus context");r.kind==="thread"?i=new A.$fL(o,r.threadId):i=new A.$eL(o,r.threadId,r.frameId),this.z=i,this.A.fire(this.z)}$provideDebugConfigurations(r,i,o){return(0,h.$Jg)(async()=>{const y=this.P(r);if(!y)throw new Error("no DebugConfigurationProvider found");if(!y.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const g=await this.W(i);return y.provideDebugConfigurations(g,o)}).then(y=>{if(!y)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return y})}$resolveDebugConfiguration(r,i,o,y){return(0,h.$Jg)(async()=>{const g=this.P(r);if(!g)throw new Error("no DebugConfigurationProvider found");if(!g.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const E=await this.W(i);return g.resolveDebugConfiguration(E,o,y)})}$resolveDebugConfigurationWithSubstitutedVariables(r,i,o,y){return(0,h.$Jg)(async()=>{const g=this.P(r);if(!g)throw new Error("no DebugConfigurationProvider found");if(!g.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const E=await this.W(i);return g.resolveDebugConfigurationWithSubstitutedVariables(E,o,y)})}async $provideDebugAdapter(r,i){const o=this.O(r);if(!o)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const y=await this.V(i);return this.S(o,y).then(g=>{if(!g)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${y.type}'`);return this.M(g)})}async $acceptDebugSessionStarted(r){const i=await this.V(r);this.m.fire(i)}async $acceptDebugSessionTerminated(r){const i=await this.V(r);i&&(this.n.fire(i),this.l.delete(i.id))}async $acceptDebugSessionActiveChanged(r){this.q=r?await this.V(r):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(r,i){(await this.V(r))?._acceptNameChanged(i)}async $acceptDebugSessionCustomEvent(r,i){const y={session:await this.V(r),event:i.event,body:i.body};this.u.fire(y)}M(r){if(r instanceof A.$aL)return{type:"executable",command:r.command,args:r.args,options:r.options};if(r instanceof A.$bL)return{type:"server",port:r.port,host:r.host};if(r instanceof A.$cL)return{type:"pipeServer",path:r.path};if(r instanceof A.$dL)return{type:"implementation",implementation:r.implementation};throw new Error("convertToDto unexpected type")}N(r){const i=this.h.filter(o=>o.type===r);if(i.length>0)return i[0].factory}O(r){const i=this.h.filter(o=>o.handle===r);if(i.length>0)return i[0].factory}P(r){const i=this.f.filter(o=>o.handle===r);if(i.length>0)return i[0].provider}Q(r,i){if(r.contributes){const o=r.contributes.debuggers;if(o&&o.length>0){for(const y of o)if(y.label&&y.type&&y.type===i)return!0}}return!1}R(r){const o=r.configuration.type,y=this.j.filter(g=>g.type===o||g.type==="*").map(g=>(0,h.$Jg)(()=>g.factory.createDebugAdapterTracker(r)).then(E=>E,E=>null));return Promise.race([Promise.all(y).then(g=>{const E=g.filter(P=>!!P);if(E.length>0)return new v(E)}),new Promise(g=>setTimeout(()=>g(void 0),1e3))]).catch(g=>{})}async S(r,i){const o=i.configuration.debugServer;if(typeof o=="number")return Promise.resolve(new A.$bL(o));if(r){const g=await this.F.getExtensionRegistry();return(0,h.$Jg)(()=>r.createDebugAdapterDescriptor(i,this.T(i,g))).then(E=>{if(E)return E})}const y=await this.F.getExtensionRegistry();return Promise.resolve(this.T(i,y))}T(r,i){}U(r,i,o){(r.length>0||i.length>0||o.length>0)&&this.y.fire(Object.freeze({added:r,removed:i,changed:o}))}async V(r){if(r)if(typeof r=="string"){const i=this.l.get(r);if(i)return i}else{let i=this.l.get(r.id);if(!i){const o=await this.W(r.folderUri),y=r.parent?this.l.get(r.parent):void 0;i=new s(this.k,r.id,r.type,r.name,o,r.configuration,y),this.l.set(i.id,i),this.k.$sessionCached(i.id)}return i}throw new Error("cannot find session")}W(r){if(r){const i=I.URI.revive(r);return this.E.resolveWorkspaceFolder(i)}return Promise.resolve(void 0)}};e.$Tcc=t,e.$Tcc=t=Je([qe(0,d.$0L),qe(1,k.$Mbc),qe(2,D.$icc),qe(3,m.$Pbc),qe(4,u.$Occ),qe(5,f.$Qcc)],t);class s{constructor(r,i,o,y,g,E,P){this.d=r,this.f=i,this.g=o,this.h=y,this.i=g,this.j=E,this.k=P}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(r){this.h=r,this.d.$setDebugSessionName(this.f,r)}get parentSession(){return this.k}_acceptNameChanged(r){this.h=r}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(r,i){return this.d.$customDebugAdapterRequest(this.f,r,i)}getDebugProtocolBreakpoint(r){return this.d.$getDebugProtocolBreakpoint(this.f,r.id)}}e.$Ucc=s;class c{constructor(r){this.value=Object.freeze({append(i){r.$appendDebugConsole(i)},appendLine(i){this.append(i+`
`)}})}}e.$Vcc=c;class v{constructor(r){this.d=r}onWillStartSession(){this.d.forEach(r=>r.onWillStartSession?r.onWillStartSession():void 0)}onWillReceiveMessage(r){this.d.forEach(i=>i.onWillReceiveMessage?i.onWillReceiveMessage(r):void 0)}onDidSendMessage(r){this.d.forEach(i=>i.onDidSendMessage?i.onDidSendMessage(r):void 0)}onWillStopSession(){this.d.forEach(r=>r.onWillStopSession?r.onWillStopSession():void 0)}onError(r){this.d.forEach(i=>i.onError?i.onError(r):void 0)}onExit(r,i){this.d.forEach(o=>o.onExit?o.onExit(r,i):void 0)}}class S extends a.$Rcb{constructor(r){super(),this.h=r,r.onDidSendMessage(i=>{this.acceptMessage(i)})}startSession(){return Promise.resolve(void 0)}sendMessage(r){this.h.handleMessage(r)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let p=class extends t{constructor(r,i,o,y,g,E){super(r,i,o,y,g,E)}};e.$Wcc=p,e.$Wcc=p=Je([qe(0,d.$0L),qe(1,k.$Mbc),qe(2,D.$icc),qe(3,m.$Pbc),qe(4,u.$Occ),qe(5,f.$Qcc)],p)}),define(Ae[271],Re([1,0,9,87,2,3,262,14,71,72,27,172,17,56,35,58]),function(ie,e,h,C,I,O,R,u,D,d,A,k,a,w,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jdc=e.$Idc=void 0;class t{static async installEarlyHandler(v){Error.stackTraceLimit=100;const S=v.get(u.$6i),n=v.get(a.$0L).getProxy(O.$9J.MainThreadErrors);h.setUnexpectedErrorHandler(r=>{S.error(r);const i=h.$1(r);n.$onUnexpectedError(i)})}static async installFullHandler(v){const S=v.get(u.$6i),p=v.get(a.$0L),n=v.get(m.$icc),r=v.get(f.$rM),i=p.getProxy(O.$9J.MainThreadExtensionService),o=p.getProxy(O.$9J.MainThreadErrors),y=await n.getExtensionPathIndex(),g=new WeakMap;function E($,b){if(g.has($))return g.get($).stack;let M="",U,F;for(const W of b)M+=`
	at ${W.toString()}`,F=W.getFileName(),!U&&F&&(U=y.findSubstr(I.URI.file(F)));const q=`${$.name||"Error"}: ${$.message||""}${M}`;return g.set($,{extensionIdentifier:U?.identifier,stack:q}),q}const P=Symbol("prepareStackTrace wrapped");let l=E;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return l},set($){if($===E||!$||$[P]){l=$||E;return}l=function(b,M){return E(b,M),$.call(Error,b,M)},Object.assign(l,{[P]:!0})}}),h.setUnexpectedErrorHandler($=>{S.error($);const b=h.$1($),M=g.get($);if(!M?.extensionIdentifier){o.$onUnexpectedError(b);return}i.$onExtensionRuntimeError(M.extensionIdentifier,b);const U=r.onExtensionError(M.extensionIdentifier,$);S.trace("forwarded error to extension?",U,M)})}}e.$Idc=t;class s{constructor(v,S,p,n,r){this.a=p,this.b=new R.$b4b(v,null,n),S=s.e(S,this.b);const i=new d.$Jh(...(0,D.$pr)());i.set(A.$nM,{_serviceBrand:void 0,...S,messagePorts:r}),i.set(a.$0L,new a.$$L(this.b)),i.set(w.$Jbc,new w.$Kbc(n)),i.set(m.$gcc,p);const o=new k.$8p(i,!0);o.invokeFunction(t.installEarlyHandler),this.d=o.invokeFunction(y=>y.get(u.$6i)),C.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",S),this.c=o.invokeFunction(y=>y.get(m.$icc)),this.c.initialize(),o.invokeFunction(t.installFullHandler)}async asBrowserUri(v){const S=this.b.getProxy(O.$9J.MainThreadExtensionService);return I.URI.revive(await S.$asBrowserUri(v))}terminate(v){this.c.terminate(v)}static e(v,S){v.extensions.allExtensions.forEach(n=>{n.extensionLocation=I.URI.revive(S.transformIncomingURIs(n.extensionLocation))}),v.environment.appRoot=I.URI.revive(S.transformIncomingURIs(v.environment.appRoot));const p=v.environment.extensionDevelopmentLocationURI;return p&&(v.environment.extensionDevelopmentLocationURI=p.map(n=>I.URI.revive(S.transformIncomingURIs(n)))),v.environment.extensionTestsLocationURI=I.URI.revive(S.transformIncomingURIs(v.environment.extensionTestsLocationURI)),v.environment.globalStorageHome=I.URI.revive(S.transformIncomingURIs(v.environment.globalStorageHome)),v.environment.workspaceStorageHome=I.URI.revive(S.transformIncomingURIs(v.environment.workspaceStorageHome)),v.environment.extensionTelemetryLogResource=I.URI.revive(S.transformIncomingURIs(v.environment.extensionTelemetryLogResource)),v.nlsBaseUrl=I.URI.revive(S.transformIncomingURIs(v.nlsBaseUrl)),v.logsLocation=I.URI.revive(S.transformIncomingURIs(v.logsLocation)),v.workspace=S.transformIncomingURIs(v.workspace),v}}e.$Jdc=s}),define(Ae[272],Re([1,0,18,12,21,42,13,19,23,2,47]),function(ie,e,h,C,I,O,R,u,D,d,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2cc=e.$1cc=e.$Zcc=e.$Ycc=void 0;class k{constructor(c,v,S,p){this.d=c,this.e=v,this.f=S,this.g=p,this.a=null,this.b=!1,this.c=0}search(c,v){const S=this.d.folderQueries||[],p=new I.$Vd(v);return new Promise((n,r)=>{this.a=new w(c);let i=!1;const o=(y,g)=>{if(!i&&!this.b){const E=this.h(y);f(y)&&typeof this.d.maxResults=="number"&&this.c+E>this.d.maxResults&&(this.b=!0,i=!0,p.cancel(),y=this.j(y,this.d.maxResults-this.c));const P=this.h(y);this.c+=P,(P>0||!f(y))&&this.a.add(y,g)}};Promise.all(S.map((y,g)=>this.k(y,E=>o(E,g),p.token))).then(y=>{p.dispose(),this.a.flush();const g=y.some(E=>!!E&&!!E.limitHit);n({limitHit:this.b||g,messages:(0,h.$Pb)(y.map(E=>E?.message?Array.isArray(E.message)?E.message:[E.message]:[])),stats:{type:this.g}})},y=>{p.dispose();const g=(0,O.$wi)(y);r(new Error(g))})})}h(c){return f(c)?Array.isArray(c.ranges)?c.ranges.length:1:0}j(c,v){const S=Array.isArray(c.ranges)?c.ranges:[c.ranges],p=Array.isArray(c.preview.matches)?c.preview.matches:[c.preview.matches];return{ranges:S.slice(0,v),preview:{matches:p.slice(0,v),text:c.preview.text},uri:c.uri}}async k(c,v,S){const p=new A.$TI(this.d,c),n=[],r={report:y=>{if(!this.l(y))return;const g=c.folder.scheme===R.Schemas.file?(0,A.$UI)(()=>this.f.readdir(D.$rg(y.uri))):void 0,E=D.$ug(c.folder,y.uri);if(E){const P=p.includedInQuery(E,u.$lc(E),g);(0,C.$Dg)(P)?n.push(P.then(l=>{l&&v(y)})):P&&v(y)}}},i=this.n(c),o=await this.e.provideTextSearchResults(a(this.d.contentPattern),i,r,S);return n.length&&await Promise.all(n),o}l(c){if(f(c)){if(Array.isArray(c.ranges)){if(!Array.isArray(c.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(c.preview.matches.length!==c.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(c.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(c){const v=(0,A.$SI)(this.d.includePattern,c.includePattern),S=(0,A.$SI)(this.d.excludePattern,c.excludePattern),p={folder:d.URI.from(c.folder),excludes:S,includes:v,useIgnoreFiles:!c.disregardIgnoreFiles,useGlobalIgnoreFiles:!c.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!c.disregardParentIgnoreFiles,followSymlinks:!c.ignoreSymlinks,encoding:c.fileEncoding&&this.f.toCanonicalName(c.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return p.usePCRE2=this.d.usePCRE2,p}}e.$Ycc=k;function a(s){return{isCaseSensitive:s.isCaseSensitive||!1,isRegExp:s.isRegExp||!1,isWordMatch:s.isWordMatch||!1,isMultiline:s.isMultiline||!1,pattern:s.pattern}}class w{constructor(c){this.e=c,this.b=-1,this.d=null,this.a=new t(512,v=>this.g(v))}add(c,v){this.d&&(this.b!==v||!D.$lg(this.c,c.uri))&&(this.f(),this.d=null),this.d||(this.b=v,this.d={resource:c.uri,results:[]}),this.d.results.push(m(c))}f(){const c=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,c)}flush(){this.f(),this.a.flush()}g(c){this.e(c)}}e.$Zcc=w;function m(s){return f(s)?{preview:{matches:(0,h.$Zb)(s.preview.matches,c=>({startLineNumber:c.start.line,startColumn:c.start.character,endLineNumber:c.end.line,endColumn:c.end.character})),text:s.preview.text},ranges:(0,h.$Zb)(s.ranges,c=>({startLineNumber:c.start.line,startColumn:c.start.character,endLineNumber:c.end.line,endColumn:c.end.character}))}:{text:s.text,lineNumber:s.lineNumber}}function f(s){return!!s.preview}e.$1cc=f;class t{constructor(c,v){this.g=c,this.h=v,this.c=0,this.d=[],this.e=0}addItem(c,v){c&&this.j(c,v)}addItems(c,v){c&&this.k(c,v)}j(c,v){this.d.push(c),this.e+=v,this.l()}k(c,v){this.d=this.d.concat(c),this.e+=v,this.l()}l(){this.c<t.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},t.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$2cc=t,t.a=4e3,t.b=50}),define(Ae[114],Re([1,0,6,3,4,267,17,56,14,2,272]),function(ie,e,h,C,I,O,R,u,D,d,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5cc=e.$4cc=e.$3cc=void 0,e.$3cc=(0,I.$Lh)("IExtHostSearch");let k=class{constructor(f,t,s){this.k=f,this.l=t,this.n=s,this.c=this.k.getProxy(C.$9J.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new O.$Xcc}o(f){return this.l.transformOutgoingScheme(f)}registerTextSearchProvider(f,t){if(this.g.has(f))throw new Error(`a text search provider for the scheme '${f}' is already registered`);this.g.add(f);const s=this.d++;return this.e.set(s,t),this.c.$registerTextSearchProvider(s,this.o(f)),(0,h.$Oc)(()=>{this.g.delete(f),this.e.delete(s),this.c.$unregisterProvider(s)})}registerFileSearchProvider(f,t){if(this.i.has(f))throw new Error(`a file search provider for the scheme '${f}' is already registered`);this.i.add(f);const s=this.d++;return this.h.set(s,t),this.c.$registerFileSearchProvider(s,this.o(f)),(0,h.$Oc)(()=>{this.i.delete(f),this.h.delete(s),this.c.$unregisterProvider(s)})}$provideFileSearchResults(f,t,s,c){const v=a(s),S=this.h.get(f);if(S)return this.j.fileSearch(v,S,p=>{this.c.$handleFileMatch(f,t,p.map(n=>n.resource))},c);throw new Error("unknown provider: "+f)}$clearCache(f){return this.j.clearCache(f),Promise.resolve(void 0)}$provideTextSearchResults(f,t,s,c){const v=this.e.get(f);if(!v||!v.provideTextSearchResults)throw new Error(`Unknown provider ${f}`);const S=a(s);return this.q(S,v).search(n=>this.c.$handleTextMatch(f,t,n),c)}$enableExtensionHostSearch(){}q(f,t){return new A.$Ycc(f,t,{readdir:s=>Promise.resolve([]),toCanonicalName:s=>s},"textSearchProvider")}};e.$4cc=k,e.$4cc=k=Je([qe(0,R.$0L),qe(1,u.$Jbc),qe(2,D.$6i)],k);function a(m){return{...m,folderQueries:m.folderQueries&&m.folderQueries.map(w),extraFileResources:m.extraFileResources&&m.extraFileResources.map(f=>d.URI.revive(f))}}e.$5cc=a;function w(m){return{...m,folder:d.URI.revive(m.folder)}}}),define(Ae[273],Re([1,0,21,9,5,29,2,135,284,127,126,38,3,79,225,224,31,226,34,228,229,230,203,231,60,35,234,235,240,241,243,109,207,249,250,252,84,63,254,210,8,7,53,257,64,108,33,20,198,239,52,107,111,113,114,14,56,17,27,244,196,86,80,217,255,85,62,260,258,259,218,39,253,256,83,61,58,245,110,246,13,95,206,189,237,6,26,194,81,185,247,248,219,236,205,238,82,251,221,222,223,216,233,220]),function(ie,e,h,C,I,O,R,u,D,d,A,k,a,w,m,f,t,s,c,v,S,p,n,r,i,o,y,g,E,P,l,$,b,M,U,F,q,W,L,z,K,B,me,ye,Ie,_,de,De,ue,ve,ke,V,Q,ee,$e,he,fe,Ee,re,le,oe,ae,pe,Ce,T,H,X,Y,J,te,se,Fe,je,Xe,He,et,xe,it,st,nt,Ue,ot,x,Z,we,We,ze,Ze,at,mt,bt,Tt,Xt,qt,wt,Nt,zt,Zt,Ut,jt,Kt,Gt,Bt,Ht){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ddc=void 0;function Jt(ct){const gt=ct.get(re.$nM),It=ct.get(Fe.$zbc),Rt=ct.get(X.$5bc),Ct=ct.get(o.$icc),ft=ct.get(de.$Mbc),kt=ct.get(xe.$rM),Pt=ct.get(c.$Pbc),Ft=ct.get(fe.$Jbc),Ke=ct.get(Ee.$0L),Pe=ct.get(q.$1bc),Le=ct.get(H.$6bc),be=ct.get(he.$7i),G=ct.get(he.$6i),Me=ct.get(ae.$ksb),Be=ct.get(pe.$Cbc),Qe=ct.get(_.$Gcc),Ve=ct.get(He.$acc),tt=ct.get(et.$Occ),vt=ct.get(zt.$ecc);Ke.set(a.$0J.ExtHostFileSystemInfo,It),Ke.set(a.$0J.ExtHostLogLevelServiceShape,be),Ke.set(a.$0J.ExtHostWorkspace,ft),Ke.set(a.$0J.ExtHostConfiguration,Pt),Ke.set(a.$0J.ExtHostExtensionService,Ct),Ke.set(a.$0J.ExtHostStorage,Pe),Ke.set(a.$0J.ExtHostTunnelService,Me),Ke.set(a.$0J.ExtHostWindow,Qe),Ke.set(a.$0J.ExtHostSecretState,Ve),Ke.set(a.$0J.ExtHostTelemetry,kt),Ke.set(a.$0J.ExtHostEditorTabs,tt),Ke.set(a.$0J.ExtHostManagedSockets,vt);const Lt=Ke.set(a.$0J.ExtHostDecorations,ct.get(V.$Kcc)),yt=Ke.set(a.$0J.ExtHostDocumentsAndEditors,ct.get(i.$iM)),ut=Ke.set(a.$0J.ExtHostCommands,ct.get(t.$tM)),pt=Ke.set(a.$0J.ExtHostTerminalService,ct.get(W.$8bc)),St=Ke.set(a.$0J.ExtHostDebugService,ct.get(ee.$Scc)),mi=Ke.set(a.$0J.ExtHostSearch,ct.get($e.$3cc)),Wt=Ke.set(a.$0J.ExtHostTask,ct.get(Q.$Ncc)),$i=Ke.set(a.$0J.ExtHostOutputService,ct.get($.$qcc)),ii=Ke.set(a.$0J.ExtHostLocalization,ct.get(at.$dcc)),ki=Ke.set(a.$0J.ExtHostUrls,new ye.$zcc(Ke)),Mt=Ke.set(a.$0J.ExtHostDocuments,new r.$xbc(Ke,yt)),hn=Ke.set(a.$0J.ExtHostDocumentContentProviders,new p.$Rbc(Ke,yt,G)),Si=Ke.set(a.$0J.ExtHostDocumentSaveParticipant,new n.$Sbc(G,Mt,Ke.getProxy(a.$9J.MainThreadBulkEdits))),Dt=Ke.set(a.$0J.ExtHostNotebook,new le.$9cc(Ke,ut,yt,Mt,Rt)),pi=Ke.set(a.$0J.ExtHostNotebookDocuments,new Z.$odc(Dt)),Yt=Ke.set(a.$0J.ExtHostNotebookEditors,new x.$ndc(G,Dt)),oi=Ke.set(a.$0J.ExtHostNotebookKernels,new it.$kdc(Ke,gt,Dt,ut,G)),qi=Ke.set(a.$0J.ExtHostNotebookRenderers,new nt.$mdc(Ke,Dt)),Ii=Ke.set(a.$0J.ExtHostNotebookDocumentSaveParticipant,new wt.$udc(G,Dt,Ke.getProxy(a.$9J.MainThreadBulkEdits))),Ot=Ke.set(a.$0J.ExtHostEditors,new L.$xcc(Ke,yt)),Ki=Ke.set(a.$0J.ExtHostTreeViews,new z.$ycc(Ke.getProxy(a.$9J.MainThreadTreeViews),ut,G)),ai=Ke.set(a.$0J.ExtHostEditorInsets,new ue.$Hcc(Ke.getProxy(a.$9J.MainThreadEditorInsets),Ot,gt.remote)),ci=Ke.set(a.$0J.ExtHostDiagnostics,new v.$Bbc(Ke,G,It,yt)),ui=Ke.set(a.$0J.ExtHostLanguages,new P.$ncc(Ke,Mt,ut.converter,Ft)),ht=Ke.set(a.$0J.ExtHostLanguageFeatures,new E.$Fbc(Ke,Ft,Mt,ut,ci,G,Be,kt)),Ci=Ke.set(a.$0J.ExtHostFileSystem,new y.$lcc(Ke,ht)),xt=Ke.set(a.$0J.ExtHostFileSystemEventService,new g.$mcc(Ke,G,yt)),ni=Ke.set(a.$0J.ExtHostQuickOpen,(0,M.$scc)(Ke,ft,ut)),vi=Ke.set(a.$0J.ExtHostSCM,new U.$ucc(Ke,ut,Mt,G)),Pi=Ke.set(a.$0J.ExtHostQuickDiff,new Tt.$rdc(Ke,Ft)),Ai=Ke.set(a.$0J.ExtHostShare,new Zt.$wdc(Ke,Ft)),Ri=Ke.set(a.$0J.ExtHostComments,(0,s.$Ibc)(Ke,ut,Mt)),Li=Ke.set(a.$0J.ExtHostProgress,new b.$rcc(Ke.getProxy(a.$9J.MainThreadProgress))),Mi=Ke.set(a.$0J.ExtHosLabelService,new ve.$Icc(Ke)),bi=Ke.set(a.$0J.ExtHostTheming,new oe.$0cc(Ke)),ri=Ke.set(a.$0J.ExtHostAuthentication,new Ce.$$cc(Ke)),Ti=Ke.set(a.$0J.ExtHostTimeline,new T.$adc(Ke,ut)),wi=Ke.set(a.$0J.ExtHostWebviews,new Ie.$Ccc(Ke,gt.remote,ft,G,Be)),hi=Ke.set(a.$0J.ExtHostWebviewPanels,new te.$cdc(Ke,wi,ft)),Fi=Ke.set(a.$0J.ExtHostCustomEditors,new J.$ddc(Ke,Mt,Le,wi,hi)),Hi=Ke.set(a.$0J.ExtHostWebviewViews,new Y.$bdc(Ke,wi)),li=Ke.set(a.$0J.ExtHostTesting,new je.$fdc(Ke,ut,yt)),Ji=Ke.set(a.$0J.ExtHostUriOpeners,new Xe.$jdc(Ke)),Gi=Ke.set(a.$0J.ExtHostProfileContentHandlers,new bt.$qdc(Ke));Ke.set(a.$0J.ExtHostInteractive,new we.$pdc(Ke,Dt,yt,ut,G));const Qi=Ke.set(a.$0J.ExtHostInlineChat,new qt.$tdc(Ke,ut,Mt,G)),yi=Ke.set(a.$0J.ExtHostChatProvider,new Ut.$xdc(Ke,G)),dn=Ke.set(a.$0J.ExtHostChatSlashCommands,new jt.$ydc(Ke,yi,G)),Oi=Ke.set(a.$0J.ExtHostChatAgents,new Ht.$Cdc(Ke,yi,G)),Ni=Ke.set(a.$0J.ExtHostChatVariables,new Kt.$zdc(Ke)),di=Ke.set(a.$0J.ExtHostChat,new Xt.$sdc(Ke,G)),Xi=Ke.set(a.$0J.ExtHostAiRelatedInformation,new Gt.$Adc(Ke)),Zi=Ke.set(a.$0J.ExtHostAiEmbeddingVector,new Bt.$Bdc(Ke)),Ei=Ke.set(a.$0J.ExtHostIssueReporter,new Nt.$vdc(Ke)),zi=Ke.set(a.$0J.ExtHostStatusBar,new F.$wcc(Ke,ut.converter)),Yi=Object.values(a.$0J);Ke.assertRegistered(Yi);const _i=new se.$edc(Ke,yt),fn=new f.$Hbc(Ke),fi=new l.$occ(Ke,G),Ui=new S.$Qbc(Ke);return m.$Gbc.register(ut),function(Oe,Qt,xi){const $t=function(){let ne=!Oe.isUnderDevelopment;function ge(){ne||(G.info(`Extension '${Oe.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ne=!0)}return function Te(rt){if(Array.isArray(rt))rt.forEach(Te);else if(typeof rt=="string")ge();else{const Et=rt;typeof Et.scheme>"u"&&ge(),typeof Et.exclusive=="boolean"&&(0,ze.$8E)(Oe,"documentFiltersExclusive")}return rt}}(),Di={getSession(ne,ge,Te){return ri.getSession(Oe,ne,ge,Te)},getSessions(ne,ge){return(0,ze.$8E)(Oe,"authGetSessions"),ri.getSessions(Oe,ne,ge)},async hasSession(ne,ge){return(0,ze.$8E)(Oe,"authSession"),!!await ri.getSession(Oe,ne,ge,{silent:!0})},get onDidChangeSessions(){return ri.onDidChangeSessions},registerAuthenticationProvider(ne,ge,Te,rt){return ri.registerAuthenticationProvider(ne,ge,Te,rt)}},en={registerCommand(ne,ge,Te){return ut.registerCommand(!0,ne,ge,Te,void 0,Oe)},registerTextEditorCommand(ne,ge,Te){return ut.registerCommand(!0,ne,(...rt)=>{const Et=Ot.getActiveTextEditor();if(!Et){G.warn("Cannot execute "+ne+" because there is no active text editor.");return}return Et.edit(At=>{ge.apply(Te,[Et,At,...rt])}).then(At=>{At||G.warn("Edits from command "+ne+" were not applied.")},At=>{G.warn("An error occurred while running command "+ne,At)})},void 0,void 0,Oe)},registerDiffInformationCommand:(ne,ge,Te)=>((0,ze.$8E)(Oe,"diffCommand"),ut.registerCommand(!0,ne,async(...rt)=>{const Et=yt.activeEditor(!0);if(!Et){G.warn("Cannot execute "+ne+" because there is no active text editor.");return}const At=await Ot.getDiffInformation(Et.id);ge.apply(Te,[At,...rt])},void 0,void 0,Oe)),executeCommand(ne,...ge){return ut.executeCommand(ne,...ge)},getCommands(ne=!1){return ut.getCommands(ne)}},ji={get machineId(){return gt.telemetryInfo.machineId},get sessionId(){return gt.telemetryInfo.sessionId},get language(){return gt.environment.appLanguage},get appName(){return gt.environment.appName},get appRoot(){return gt.environment.appRoot?.fsPath??""},get appHost(){return gt.environment.appHost},get uriScheme(){return gt.environment.appUriScheme},get clipboard(){return fn.value},get shell(){return pt.getDefaultShell(!1)},get onDidChangeShell(){return pt.onDidChangeShell},get isTelemetryEnabled(){return kt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return kt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,ze.$8E)(Oe,"telemetry"),kt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,ze.$8E)(Oe,"telemetry"),kt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,xe.$qM)(gt.telemetryInfo.firstSessionDate)},createTelemetryLogger(ne,ge){return xe.$pM.validateSender(ne),kt.instantiateLogger(Oe,ne,ge)},openExternal(ne,ge){return Qe.openUri(ne,{allowTunneling:!!gt.remote.authority,allowContributedOpeners:ge?.allowContributedOpeners})},async asExternalUri(ne){if(ne.scheme===gt.environment.appUriScheme)return ki.createAppUri(ne);try{return await Qe.asExternalUri(ne,{allowTunneling:!!gt.remote.authority})}catch(ge){if((0,ot.$2T)(ne,Ue.Schemas.http)||(0,ot.$2T)(ne,Ue.Schemas.https))return ne;throw ge}},get remoteName(){return(0,ke.$Qk)(gt.remote.authority)},get remoteAuthority(){return(0,ze.$8E)(Oe,"resolvers"),gt.remote.authority},get uiKind(){return gt.uiKind},get logLevel(){return G.getLevel()},get onDidChangeLogLevel(){return G.onDidChangeLogLevel},registerIssueUriRequestHandler(ne){return(0,ze.$8E)(Oe,"handleIssueUri"),Ei.registerIssueUriRequestHandler(Oe,ne)},get appQuality(){return(0,ze.$8E)(Oe,"resolvers"),gt.quality},get appCommit(){return(0,ze.$8E)(Oe,"resolvers"),gt.commit}};gt.environment.extensionTestsLocationURI||Object.freeze(ji);const tn={createTestController(ne,ge,Te){return li.createTestController(Oe,ne,ge,Te)},createTestObserver(){return(0,ze.$8E)(Oe,"testObserver"),li.createTestObserver()},runTests(ne){return(0,ze.$8E)(Oe,"testObserver"),li.runTests(ne)},get onDidChangeTestResults(){return(0,ze.$8E)(Oe,"testObserver"),li.onResultsChanged},get testResults(){return(0,ze.$8E)(Oe,"testObserver"),li.results}},gi=gt.remote.isRemote?B.ExtensionKind.Workspace:B.ExtensionKind.UI,gn={getExtension(ne,ge){(0,ze.$7E)(Oe,"extensionsAny")||(ge=!1);const Te=Qt.mine.getExtensionDescription(ne);if(Te)return new o.$jcc(Ct,Oe.identifier,Te,gi,!1);if(ge){const rt=Qt.all.getExtensionDescription(ne);if(rt)return new o.$jcc(Ct,Oe.identifier,rt,gi,!0)}},get all(){const ne=[];for(const ge of Qt.mine.getAllExtensionDescriptions())ne.push(new o.$jcc(Ct,Oe.identifier,ge,gi,!1));return ne},get allAcrossExtensionHosts(){(0,ze.$8E)(Oe,"extensionsAny");const ne=new De.$Yl(Qt.mine.getAllExtensionDescriptions().map(Te=>Te.identifier)),ge=[];for(const Te of Qt.all.getAllExtensionDescriptions()){const rt=!ne.has(Te.identifier);ge.push(new o.$jcc(Ct,Oe.identifier,Te,gi,rt))}return ge},get onDidChange(){return(0,ze.$7E)(Oe,"extensionsAny")?I.Event.any(Qt.mine.onDidChange,Qt.all.onDidChange):Qt.mine.onDidChange}},nn={createDiagnosticCollection(ne){return ci.createDiagnosticCollection(Oe.identifier,ne)},get onDidChangeDiagnostics(){return ci.onDidChangeDiagnostics},getDiagnostics:ne=>ci.getDiagnostics(ne),getLanguages(){return ui.getLanguages()},setTextDocumentLanguage(ne,ge){return ui.changeLanguage(ne.uri,ge)},match(ne,ge){const Te=Mt.getDocumentData(ge.uri)?.notebook;return(0,A.$iE)(K.LanguageSelector.from(ne),ge.uri,ge.languageId,!0,Te?.uri,Te?.notebookType)},registerCodeActionsProvider(ne,ge,Te){return ht.registerCodeActionProvider(Oe,$t(ne),ge,Te)},registerDocumentPasteEditProvider(ne,ge,Te){return(0,ze.$8E)(Oe,"documentPaste"),ht.registerDocumentPasteEditProvider(Oe,$t(ne),ge,Te)},registerCodeLensProvider(ne,ge){return ht.registerCodeLensProvider(Oe,$t(ne),ge)},registerDefinitionProvider(ne,ge){return ht.registerDefinitionProvider(Oe,$t(ne),ge)},registerDeclarationProvider(ne,ge){return ht.registerDeclarationProvider(Oe,$t(ne),ge)},registerImplementationProvider(ne,ge){return ht.registerImplementationProvider(Oe,$t(ne),ge)},registerTypeDefinitionProvider(ne,ge){return ht.registerTypeDefinitionProvider(Oe,$t(ne),ge)},registerHoverProvider(ne,ge){return ht.registerHoverProvider(Oe,$t(ne),ge,Oe.identifier)},registerEvaluatableExpressionProvider(ne,ge){return ht.registerEvaluatableExpressionProvider(Oe,$t(ne),ge,Oe.identifier)},registerInlineValuesProvider(ne,ge){return ht.registerInlineValuesProvider(Oe,$t(ne),ge,Oe.identifier)},registerDocumentHighlightProvider(ne,ge){return ht.registerDocumentHighlightProvider(Oe,$t(ne),ge)},registerLinkedEditingRangeProvider(ne,ge){return ht.registerLinkedEditingRangeProvider(Oe,$t(ne),ge)},registerReferenceProvider(ne,ge){return ht.registerReferenceProvider(Oe,$t(ne),ge)},registerRenameProvider(ne,ge){return ht.registerRenameProvider(Oe,$t(ne),ge)},registerDocumentSymbolProvider(ne,ge,Te){return ht.registerDocumentSymbolProvider(Oe,$t(ne),ge,Te)},registerWorkspaceSymbolProvider(ne){return ht.registerWorkspaceSymbolProvider(Oe,ne)},registerDocumentFormattingEditProvider(ne,ge){return ht.registerDocumentFormattingEditProvider(Oe,$t(ne),ge)},registerDocumentRangeFormattingEditProvider(ne,ge){return ht.registerDocumentRangeFormattingEditProvider(Oe,$t(ne),ge)},registerOnTypeFormattingEditProvider(ne,ge,Te,...rt){return ht.registerOnTypeFormattingEditProvider(Oe,$t(ne),ge,[Te].concat(rt))},registerDocumentSemanticTokensProvider(ne,ge,Te){return ht.registerDocumentSemanticTokensProvider(Oe,$t(ne),ge,Te)},registerDocumentRangeSemanticTokensProvider(ne,ge,Te){return ht.registerDocumentRangeSemanticTokensProvider(Oe,$t(ne),ge,Te)},registerSignatureHelpProvider(ne,ge,Te,...rt){return typeof Te=="object"?ht.registerSignatureHelpProvider(Oe,$t(ne),ge,Te):ht.registerSignatureHelpProvider(Oe,$t(ne),ge,typeof Te>"u"?[]:[Te,...rt])},registerCompletionItemProvider(ne,ge,...Te){return ht.registerCompletionItemProvider(Oe,$t(ne),ge,Te)},registerInlineCompletionItemProvider(ne,ge,Te){return ge.handleDidShowCompletionItem&&(0,ze.$8E)(Oe,"inlineCompletionsAdditions"),ge.handleDidPartiallyAcceptCompletionItem&&(0,ze.$8E)(Oe,"inlineCompletionsAdditions"),Te&&(0,ze.$8E)(Oe,"inlineCompletionsAdditions"),ht.registerInlineCompletionsProvider(Oe,$t(ne),ge,Te)},registerDocumentLinkProvider(ne,ge){return ht.registerDocumentLinkProvider(Oe,$t(ne),ge)},registerColorProvider(ne,ge){return ht.registerColorProvider(Oe,$t(ne),ge)},registerFoldingRangeProvider(ne,ge){return ht.registerFoldingRangeProvider(Oe,$t(ne),ge)},registerSelectionRangeProvider(ne,ge){return ht.registerSelectionRangeProvider(Oe,ne,ge)},registerCallHierarchyProvider(ne,ge){return ht.registerCallHierarchyProvider(Oe,ne,ge)},registerTypeHierarchyProvider(ne,ge){return ht.registerTypeHierarchyProvider(Oe,ne,ge)},setLanguageConfiguration:(ne,ge)=>ht.setLanguageConfiguration(Oe,ne,ge),getTokenInformationAtPosition(ne,ge){return(0,ze.$8E)(Oe,"tokenInformation"),ui.tokenAtPosition(ne,ge)},registerInlayHintsProvider(ne,ge){return ht.registerInlayHintsProvider(Oe,ne,ge)},createLanguageStatusItem(ne,ge){return ui.createLanguageStatusItem(Oe,ne,ge)},registerDocumentDropEditProvider(ne,ge,Te){return ht.registerDocumentOnDropEditProvider(Oe,ne,ge,(0,ze.$7E)(Oe,"dropMetadata")?Te:void 0)}},rn={get activeTextEditor(){return Ot.getActiveTextEditor()},get visibleTextEditors(){return Ot.getVisibleTextEditors()},get activeTerminal(){return pt.activeTerminal},get terminals(){return pt.terminals},async showTextDocument(ne,ge,Te){const rt=await(R.URI.isUri(ne)?Promise.resolve(sn.openTextDocument(ne)):Promise.resolve(ne));return Ot.showTextDocument(rt,ge,Te)},createTextEditorDecorationType(ne){return Ot.createTextEditorDecorationType(Oe,ne)},onDidChangeActiveTextEditor(ne,ge,Te){return Ot.onDidChangeActiveTextEditor(ne,ge,Te)},onDidChangeVisibleTextEditors(ne,ge,Te){return Ot.onDidChangeVisibleTextEditors(ne,ge,Te)},onDidChangeTextEditorSelection(ne,ge,Te){return Ot.onDidChangeTextEditorSelection(ne,ge,Te)},onDidChangeTextEditorOptions(ne,ge,Te){return Ot.onDidChangeTextEditorOptions(ne,ge,Te)},onDidChangeTextEditorVisibleRanges(ne,ge,Te){return Ot.onDidChangeTextEditorVisibleRanges(ne,ge,Te)},onDidChangeTextEditorViewColumn(ne,ge,Te){return Ot.onDidChangeTextEditorViewColumn(ne,ge,Te)},onDidCloseTerminal(ne,ge,Te){return pt.onDidCloseTerminal(ne,ge,Te)},onDidOpenTerminal(ne,ge,Te){return pt.onDidOpenTerminal(ne,ge,Te)},onDidChangeActiveTerminal(ne,ge,Te){return pt.onDidChangeActiveTerminal(ne,ge,Te)},onDidChangeTerminalDimensions(ne,ge,Te){return(0,ze.$8E)(Oe,"terminalDimensions"),pt.onDidChangeTerminalDimensions(ne,ge,Te)},onDidChangeTerminalState(ne,ge,Te){return pt.onDidChangeTerminalState(ne,ge,Te)},onDidWriteTerminalData(ne,ge,Te){return(0,ze.$8E)(Oe,"terminalDataWriteEvent"),pt.onDidWriteTerminalData(ne,ge,Te)},onDidExecuteTerminalCommand(ne,ge,Te){return(0,ze.$8E)(Oe,"terminalExecuteCommandEvent"),pt.onDidExecuteTerminalCommand(ne,ge,Te)},get state(){return Qe.getState(Oe)},onDidChangeWindowState(ne,ge,Te){return Qe.onDidChangeWindowState(ne,ge,Te)},showInformationMessage(ne,...ge){return fi.showMessage(Oe,O.default.Info,ne,ge[0],ge.slice(1))},showWarningMessage(ne,...ge){return fi.showMessage(Oe,O.default.Warning,ne,ge[0],ge.slice(1))},showErrorMessage(ne,...ge){return fi.showMessage(Oe,O.default.Error,ne,ge[0],ge.slice(1))},showQuickPick(ne,ge,Te){return ni.showQuickPick(Oe,ne,ge,Te)},showWorkspaceFolderPick(ne){return ni.showWorkspaceFolderPick(ne)},showInputBox(ne,ge){return ni.showInput(ne,ge)},showOpenDialog(ne){return Ui.showOpenDialog(Oe,ne)},showSaveDialog(ne){return Ui.showSaveDialog(ne)},createStatusBarItem(ne,ge,Te){let rt,Et,At;return typeof ne=="string"?(rt=ne,Et=ge,At=Te):(Et=ne,At=ge),zi.createStatusBarEntry(Oe,rt,Et,At)},setStatusBarMessage(ne,ge){return zi.setStatusBarMessage(ne,ge)},withScmProgress(ne){return Be.report("window.withScmProgress",Oe,"Use 'withProgress' instead."),Li.withProgress(Oe,{location:B.ProgressLocation.SourceControl},(ge,Te)=>ne({report(rt){}}))},withProgress(ne,ge){return Li.withProgress(Oe,ne,ge)},createOutputChannel(ne,ge){return $i.createOutputChannel(ne,ge,Oe)},createWebviewPanel(ne,ge,Te,rt){return hi.createWebviewPanel(Oe,ne,ge,Te,rt)},createWebviewTextEditorInset(ne,ge,Te,rt){return(0,ze.$8E)(Oe,"editorInsets"),ai.createWebviewEditorInset(ne,ge,Te,rt,Oe)},createTerminal(ne,ge,Te){return typeof ne=="object"?"pty"in ne?pt.createExtensionTerminal(ne):pt.createTerminalFromOptions(ne):pt.createTerminal(ne,ge,Te)},registerTerminalLinkProvider(ne){return pt.registerLinkProvider(ne)},registerTerminalProfileProvider(ne,ge){return pt.registerProfileProvider(Oe,ne,ge)},registerTerminalQuickFixProvider(ne,ge){return(0,ze.$8E)(Oe,"terminalQuickFixProvider"),pt.registerTerminalQuickFixProvider(ne,Oe.identifier.value,ge)},registerTreeDataProvider(ne,ge){return Ki.registerTreeDataProvider(ne,ge,Oe)},createTreeView(ne,ge){return Ki.createTreeView(ne,ge,Oe)},registerWebviewPanelSerializer:(ne,ge)=>hi.registerWebviewPanelSerializer(Oe,ne,ge),registerCustomEditorProvider:(ne,ge,Te={})=>Fi.registerCustomEditorProvider(Oe,ne,ge,Te),registerFileDecorationProvider(ne){return Lt.registerFileDecorationProvider(ne,Oe)},registerUriHandler(ne){return ki.registerUriHandler(Oe,ne)},createQuickPick(){return ni.createQuickPick(Oe)},createInputBox(){return ni.createInputBox(Oe)},get activeColorTheme(){return bi.activeColorTheme},onDidChangeActiveColorTheme(ne,ge,Te){return bi.onDidChangeActiveColorTheme(ne,ge,Te)},registerWebviewViewProvider(ne,ge,Te){return Hi.registerWebviewViewProvider(Oe,ne,ge,Te?.webviewOptions)},get activeNotebookEditor(){return Dt.activeNotebookEditor},onDidChangeActiveNotebookEditor(ne,ge,Te){return Dt.onDidChangeActiveNotebookEditor(ne,ge,Te)},get visibleNotebookEditors(){return Dt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return Dt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(ne,ge,Te){return Yt.onDidChangeNotebookEditorSelection(ne,ge,Te)},onDidChangeNotebookEditorVisibleRanges(ne,ge,Te){return Yt.onDidChangeNotebookEditorVisibleRanges(ne,ge,Te)},showNotebookDocument(ne,ge){return Dt.showNotebookDocument(ne,ge)},registerExternalUriOpener(ne,ge,Te){return(0,ze.$8E)(Oe,"externalUriOpener"),Ji.registerExternalUriOpener(Oe.identifier,ne,ge,Te)},registerProfileContentHandler(ne,ge){return(0,ze.$8E)(Oe,"profileContentHandlers"),Gi.registrProfileContentHandler(Oe,ne,ge)},registerQuickDiffProvider(ne,ge,Te,rt){return(0,ze.$8E)(Oe,"quickDiffProvider"),Pi.registerQuickDiffProvider($t(ne),ge,Te,rt)},get tabGroups(){return tt.tabGroups},registerShareProvider(ne,ge){return(0,ze.$8E)(Oe,"shareProvider"),Ai.registerShareProvider($t(ne),ge)}},sn={get rootPath(){return Be.report("workspace.rootPath",Oe,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ft.getPath()},set rootPath(ne){throw new C.$7("rootPath")},getWorkspaceFolder(ne){return ft.getWorkspaceFolder(ne)},get workspaceFolders(){return ft.getWorkspaceFolders()},get name(){return ft.name},set name(ne){throw new C.$7("name")},get workspaceFile(){return ft.workspaceFile},set workspaceFile(ne){throw new C.$7("workspaceFile")},updateWorkspaceFolders:(ne,ge,...Te)=>ft.updateWorkspaceFolders(Oe,ne,ge||0,...Te),onDidChangeWorkspaceFolders:function(ne,ge,Te){return ft.onDidChangeWorkspace(ne,ge,Te)},asRelativePath:(ne,ge)=>ft.getRelativePath(ne,ge),findFiles:(ne,ge,Te,rt)=>ft.findFiles(ne,ge,Te,Oe.identifier,rt),findTextInFiles:(ne,ge,Te,rt)=>{(0,ze.$8E)(Oe,"findTextInFiles");let Et,At;return typeof ge=="object"?(Et=ge,At=Te):(Et={},At=ge,rt=Te),ft.findTextInFiles(ne,Et||{},At,Oe.identifier,rt)},save:ne=>((0,ze.$8E)(Oe,"saveEditor"),ft.save(ne)),saveAs:ne=>((0,ze.$8E)(Oe,"saveEditor"),ft.saveAs(ne)),saveAll:ne=>ft.saveAll(ne),applyEdit(ne,ge){return _i.applyWorkspaceEdit(ne,Oe,ge)},createFileSystemWatcher:(ne,ge,Te,rt)=>xt.createFileSystemWatcher(ft,Oe,ne,ge,Te,rt),get textDocuments(){return Mt.getAllDocumentData().map(ne=>ne.document)},set textDocuments(ne){throw new C.$7("textDocuments")},openTextDocument(ne){let ge;const Te=ne;if(typeof ne=="string")ge=Promise.resolve(R.URI.file(ne));else if(R.URI.isUri(ne))ge=Promise.resolve(ne);else if(!Te||typeof Te=="object")ge=Mt.createDocumentData(Te);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ge.then(rt=>Mt.ensureDocumentData(rt).then(Et=>Et.document))},onDidOpenTextDocument:(ne,ge,Te)=>Mt.onDidAddDocument(ne,ge,Te),onDidCloseTextDocument:(ne,ge,Te)=>Mt.onDidRemoveDocument(ne,ge,Te),onDidChangeTextDocument:(ne,ge,Te)=>Mt.onDidChangeDocument(ne,ge,Te),onDidSaveTextDocument:(ne,ge,Te)=>Mt.onDidSaveDocument(ne,ge,Te),onWillSaveTextDocument:(ne,ge,Te)=>Si.getOnWillSaveTextDocumentEvent(Oe)(ne,ge,Te),get notebookDocuments(){return Dt.notebookDocuments.map(ne=>ne.apiNotebook)},async openNotebookDocument(ne,ge){let Te;if(R.URI.isUri(ne))Te=ne,await Dt.openNotebookDocument(ne);else if(typeof ne=="string")Te=R.URI.revive(await Dt.createNotebookDocument({viewType:ne,content:ge}));else throw new Error("Invalid arguments");return Dt.getNotebookDocument(Te).apiNotebook},onDidSaveNotebookDocument(ne,ge,Te){return pi.onDidSaveNotebookDocument(ne,ge,Te)},onDidChangeNotebookDocument(ne,ge,Te){return pi.onDidChangeNotebookDocument(ne,ge,Te)},onWillSaveNotebookDocument(ne,ge,Te){return Ii.getOnWillSaveNotebookDocumentEvent(Oe)(ne,ge,Te)},get onDidOpenNotebookDocument(){return Dt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return Dt.onDidCloseNotebookDocument},registerNotebookSerializer(ne,ge,Te,rt){return Dt.registerNotebookSerializer(Oe,ne,ge,Te,(0,ze.$7E)(Oe,"notebookLiveShare")?rt:void 0)},onDidChangeConfiguration:(ne,ge,Te)=>xi.onDidChangeConfiguration(ne,ge,Te),getConfiguration(ne,ge){return ge=arguments.length===1?void 0:ge,xi.getConfiguration(ne,ge,Oe)},registerTextDocumentContentProvider(ne,ge){return hn.registerTextDocumentContentProvider(ne,ge)},registerTaskProvider:(ne,ge)=>(Be.report("window.registerTaskProvider",Oe,"Use the corresponding function on the 'tasks' namespace instead"),Wt.registerTaskProvider(Oe,ne,ge)),registerFileSystemProvider(ne,ge,Te){return(0,We.$Nc)(Ci.registerFileSystemProvider(Oe,ne,ge,Te),Rt.addFileSystemProvider(ne,ge,Te))},get fs(){return Rt.value},registerFileSearchProvider:(ne,ge)=>((0,ze.$8E)(Oe,"fileSearchProvider"),mi.registerFileSearchProvider(ne,ge)),registerTextSearchProvider:(ne,ge)=>((0,ze.$8E)(Oe,"textSearchProvider"),mi.registerTextSearchProvider(ne,ge)),registerRemoteAuthorityResolver:(ne,ge)=>((0,ze.$8E)(Oe,"resolvers"),Ct.registerRemoteAuthorityResolver(ne,ge)),registerResourceLabelFormatter:ne=>((0,ze.$8E)(Oe,"resolvers"),Mi.$registerResourceLabelFormatter(ne)),getRemoteExecServer:ne=>((0,ze.$8E)(Oe,"resolvers"),Ct.getRemoteExecServer(ne)),onDidCreateFiles:(ne,ge,Te)=>xt.onDidCreateFile(ne,ge,Te),onDidDeleteFiles:(ne,ge,Te)=>xt.onDidDeleteFile(ne,ge,Te),onDidRenameFiles:(ne,ge,Te)=>xt.onDidRenameFile(ne,ge,Te),onWillCreateFiles:(ne,ge,Te)=>xt.getOnWillCreateFileEvent(Oe)(ne,ge,Te),onWillDeleteFiles:(ne,ge,Te)=>xt.getOnWillDeleteFileEvent(Oe)(ne,ge,Te),onWillRenameFiles:(ne,ge,Te)=>xt.getOnWillRenameFileEvent(Oe)(ne,ge,Te),openTunnel:ne=>((0,ze.$8E)(Oe,"tunnels"),Me.openTunnel(Oe,ne).then(ge=>{if(!ge)throw new Error("cannot open tunnel");return ge})),get tunnels(){return(0,ze.$8E)(Oe,"tunnels"),Me.getTunnels()},onDidChangeTunnels:(ne,ge,Te)=>((0,ze.$8E)(Oe,"tunnels"),Me.onDidChangeTunnels(ne,ge,Te)),registerPortAttributesProvider:(ne,ge)=>((0,ze.$8E)(Oe,"portsAttributes"),Me.registerPortsAttributesProvider(ne,ge)),registerTunnelProvider:(ne,ge)=>((0,ze.$8E)(Oe,"tunnelFactory"),Me.registerTunnelProvider(ne,ge)),registerTimelineProvider:(ne,ge)=>((0,ze.$8E)(Oe,"timeline"),Ti.registerTimelineProvider(ne,ge,Oe.identifier,ut.converter)),get isTrusted(){return ft.trusted},requestWorkspaceTrust:ne=>((0,ze.$8E)(Oe,"workspaceTrust"),ft.requestWorkspaceTrust(ne)),onDidGrantWorkspaceTrust:(ne,ge,Te)=>ft.onDidGrantWorkspaceTrust(ne,ge,Te),registerEditSessionIdentityProvider:(ne,ge)=>((0,ze.$8E)(Oe,"editSessionIdentityProvider"),ft.registerEditSessionIdentityProvider(ne,ge)),onWillCreateEditSessionIdentity:(ne,ge,Te)=>((0,ze.$8E)(Oe,"editSessionIdentityProvider"),ft.getOnWillCreateEditSessionIdentityEvent(Oe)(ne,ge,Te)),registerCanonicalUriProvider:(ne,ge)=>((0,ze.$8E)(Oe,"canonicalUriProvider"),ft.registerCanonicalUriProvider(ne,ge)),getCanonicalUri:(ne,ge,Te)=>((0,ze.$8E)(Oe,"canonicalUriProvider"),ft.provideCanonicalUri(ne,ge,Te))},mn={get inputBox(){return Be.report("scm.inputBox",Oe,"Use 'SourceControl.inputBox' instead"),vi.getLastInputBox(Oe)},createSourceControl(ne,ge,Te){return vi.createSourceControl(Oe,ne,ge,Te)}},Bi={createCommentController(ne,ge){return Ri.createCommentController(Oe,ne,ge)}},on={get activeDebugSession(){return St.activeDebugSession},get activeDebugConsole(){return St.activeDebugConsole},get breakpoints(){return St.breakpoints},get stackFrameFocus(){return St.stackFrameFocus},onDidStartDebugSession(ne,ge,Te){return St.onDidStartDebugSession(ne,ge,Te)},onDidTerminateDebugSession(ne,ge,Te){return St.onDidTerminateDebugSession(ne,ge,Te)},onDidChangeActiveDebugSession(ne,ge,Te){return St.onDidChangeActiveDebugSession(ne,ge,Te)},onDidReceiveDebugSessionCustomEvent(ne,ge,Te){return St.onDidReceiveDebugSessionCustomEvent(ne,ge,Te)},onDidChangeBreakpoints(ne,ge,Te){return St.onDidChangeBreakpoints(ne,ge,Te)},onDidChangeStackFrameFocus(ne,ge,Te){return(0,ze.$8E)(Oe,"debugFocus"),St.onDidChangeStackFrameFocus(ne,ge,Te)},registerDebugConfigurationProvider(ne,ge,Te){return St.registerDebugConfigurationProvider(ne,ge,Te||Ze.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ne,ge){return St.registerDebugAdapterDescriptorFactory(Oe,ne,ge)},registerDebugAdapterTrackerFactory(ne,ge){return St.registerDebugAdapterTrackerFactory(ne,ge)},startDebugging(ne,ge,Te){return!Te||typeof Te=="object"&&"configuration"in Te?St.startDebugging(ne,ge,{parentSession:Te}):St.startDebugging(ne,ge,Te||{})},stopDebugging(ne){return St.stopDebugging(ne)},addBreakpoints(ne){return St.addBreakpoints(ne)},removeBreakpoints(ne){return St.removeBreakpoints(ne)},asDebugSourceUri(ne,ge){return St.asDebugSourceUri(ne,ge)}},an={registerTaskProvider:(ne,ge)=>Wt.registerTaskProvider(Oe,ne,ge),fetchTasks:ne=>Wt.fetchTasks(ne),executeTask:ne=>Wt.executeTask(Oe,ne),get taskExecutions(){return Wt.taskExecutions},onDidStartTask:(ne,ge,Te)=>Wt.onDidStartTask(ne,ge,Te),onDidEndTask:(ne,ge,Te)=>Wt.onDidEndTask(ne,ge,Te),onDidStartTaskProcess:(ne,ge,Te)=>Wt.onDidStartTaskProcess(ne,ge,Te),onDidEndTaskProcess:(ne,ge,Te)=>Wt.onDidEndTaskProcess(ne,ge,Te)},cn={createNotebookController(ne,ge,Te,rt,Et){return oi.createNotebookController(Oe,ne,ge,Te,rt,(0,ze.$7E)(Oe,"notebookMessaging")?Et:void 0)},registerNotebookCellStatusBarItemProvider:(ne,ge)=>Dt.registerNotebookCellStatusBarItemProvider(Oe,ne,ge),createRendererMessaging(ne){return qi.createRendererMessaging(Oe,ne)},createNotebookControllerDetectionTask(ne){return(0,ze.$8E)(Oe,"notebookKernelSource"),oi.createNotebookControllerDetectionTask(Oe,ne)},registerKernelSourceActionProvider(ne,ge){return(0,ze.$8E)(Oe,"notebookKernelSource"),oi.registerKernelSourceActionProvider(Oe,ne,ge)},onDidChangeNotebookCellExecutionState(ne,ge,Te){return(0,ze.$8E)(Oe,"notebookCellExecutionState"),oi.onDidChangeNotebookCellExecutionState(ne,ge,Te)}},$n={t(...ne){if(typeof ne[0]=="string"){const ge=ne.shift(),Te=!ne||typeof ne[0]!="object"?ne:ne[0];return ii.getMessage(Oe.identifier.value,{message:ge,args:Te})}return ii.getMessage(Oe.identifier.value,ne[0])},get bundle(){return ii.getBundle(Oe.identifier.value)},get uri(){return ii.getBundleUri(Oe.identifier.value)}},pn={_version:1,registerInteractiveEditorSessionProvider(ne,ge){return(0,ze.$8E)(Oe,"interactive"),Qi.registerProvider(Oe,ne,ge={label:ge?.label??Oe.displayName??Oe.name})},registerInteractiveSessionProvider(ne,ge){return(0,ze.$8E)(Oe,"interactive"),di.registerChatProvider(Oe,ne,ge)},addInteractiveRequest(ne){return(0,ze.$8E)(Oe,"interactive"),di.addChatRequest(ne)},sendInteractiveRequestToProvider(ne,ge){return(0,ze.$8E)(Oe,"interactive"),di.sendInteractiveRequestToProvider(ne,ge)},get onDidPerformUserAction(){return(0,ze.$8E)(Oe,"interactiveUserActions"),di.onDidPerformUserAction},transferChatSession(ne,ge){return(0,ze.$8E)(Oe,"interactive"),di.transferChatSession(ne,ge)}},un={getRelatedInformation(ne,ge){return(0,ze.$8E)(Oe,"aiRelatedInformation"),Xi.getRelatedInformation(Oe,ne,ge)},registerRelatedInformationProvider(ne,ge){return(0,ze.$8E)(Oe,"aiRelatedInformation"),Xi.registerRelatedInformationProvider(Oe,ne,ge)},registerEmbeddingVectorProvider(ne,ge){return(0,ze.$8E)(Oe,"aiRelatedInformation"),Zi.registerEmbeddingVectorProvider(Oe,ne,ge)}},ln={registerChatResponseProvider(ne,ge,Te){return(0,ze.$8E)(Oe,"chatProvider"),yi.registerProvider(Oe.identifier,ne,ge,Te)},registerSlashCommand(ne,ge,Te){return(0,ze.$8E)(Oe,"chatSlashCommands"),dn.registerCommand(Oe.identifier,ne,ge,Te??{description:""})},requestChatAccess(ne){return(0,ze.$8E)(Oe,"chatRequestAccess"),yi.requestChatResponseProvider(Oe.identifier,ne)},registerVariable(ne,ge,Te){return(0,ze.$8E)(Oe,"chatVariables"),Ni.registerVariableResolver(Oe,ne,ge,Te)},registerMappedEditsProvider(ne,ge){return(0,ze.$8E)(Oe,"mappedEditsProvider"),ht.registerMappedEditsProvider(Oe,ne,ge)},registerAgent(ne,ge,Te){return(0,ze.$8E)(Oe,"chatAgents"),Oi.registerAgent(Oe.identifier,ne,ge,Te)}};return{version:gt.version,ai:un,authentication:Di,commands:en,comments:Bi,chat:ln,debug:on,env:ji,extensions:gn,interactive:pn,l10n:$n,languages:nn,notebooks:cn,scm:mn,tasks:an,tests:tn,window:rn,workspace:sn,Breakpoint:B.$9K,TerminalOutputAnchor:B.TerminalOutputAnchor,ChatMessage:B.$YL,ChatMessageRole:B.ChatMessageRole,ChatVariableLevel:B.ChatVariableLevel,CallHierarchyIncomingCall:B.$vK,CallHierarchyItem:B.$uK,CallHierarchyOutgoingCall:B.$wK,CancellationError:C.$3,CancellationTokenSource:h.$Vd,CandidatePortSource:a.CandidatePortSource,CodeAction:B.$rK,CodeActionKind:B.$sK,CodeActionTriggerKind:B.CodeActionTriggerKind,CodeLens:B.$xK,Color:B.$KK,ColorInformation:B.$LK,ColorPresentation:B.$MK,ColorThemeKind:B.ColorThemeKind,CommentMode:B.CommentMode,CommentState:B.CommentState,CommentThreadCollapsibleState:B.CommentThreadCollapsibleState,CommentThreadState:B.CommentThreadState,CompletionItem:B.$EK,CompletionItemKind:B.CompletionItemKind,CompletionItemTag:B.CompletionItemTag,CompletionList:B.$FK,CompletionTriggerKind:B.CompletionTriggerKind,ConfigurationTarget:B.ConfigurationTarget,CustomExecution:B.$UK,DebugAdapterExecutable:B.$aL,DebugAdapterInlineImplementation:B.$dL,DebugAdapterNamedPipeServer:B.$cL,DebugAdapterServer:B.$bL,DebugConfigurationProviderTriggerKind:Ze.DebugConfigurationProviderTriggerKind,DebugConsoleMode:B.DebugConsoleMode,DecorationRangeBehavior:B.DecorationRangeBehavior,Diagnostic:B.$mK,DiagnosticRelatedInformation:B.$lK,DiagnosticSeverity:B.DiagnosticSeverity,DiagnosticTag:B.DiagnosticTag,Disposable:B.$$J,DocumentHighlight:B.$oK,DocumentHighlightKind:B.DocumentHighlightKind,DocumentLink:B.$JK,DocumentSymbol:B.$qK,EndOfLine:B.EndOfLine,EnvironmentVariableMutatorType:B.EnvironmentVariableMutatorType,EvaluatableExpression:B.$gL,InlineValueText:B.$hL,InlineValueVariableLookup:B.$iL,InlineValueEvaluatableExpression:B.$jL,InlineCompletionTriggerKind:B.InlineCompletionTriggerKind,EventEmitter:I.$Ld,ExtensionKind:B.ExtensionKind,ExtensionMode:B.ExtensionMode,ExternalUriOpenerPriority:B.ExternalUriOpenerPriority,FileChangeType:B.FileChangeType,FileDecoration:B.$tL,FileDecoration2:B.$tL,FileSystemError:B.$lL,FileType:k.FileType,FilePermission:k.FilePermission,FoldingRange:B.$mL,FoldingRangeKind:B.FoldingRangeKind,FunctionBreakpoint:B.$$K,InlineCompletionItem:B.$GK,InlineCompletionList:B.$HK,Hover:B.$nK,IndentAction:d.IndentAction,Location:B.$kK,MarkdownString:B.$yK,OverviewRulerLane:D.OverviewRulerLane,ParameterInformation:B.$zK,PortAutoForwardAction:B.PortAutoForwardAction,Position:B.$_J,ProcessExecution:B.$SK,ProgressLocation:B.ProgressLocation,QuickInputButtons:B.$sL,Range:B.$aK,RelativePattern:B.$7K,Selection:B.$bK,SelectionRange:B.$tK,SemanticTokens:B.$pL,SemanticTokensBuilder:B.$oL,SemanticTokensEdit:B.$qL,SemanticTokensEdits:B.$rL,SemanticTokensLegend:B.$nL,ShellExecution:B.$TK,ShellQuoting:B.ShellQuoting,SignatureHelp:B.$BK,SignatureHelpTriggerKind:B.SignatureHelpTriggerKind,SignatureInformation:B.$AK,SnippetString:B.$jK,SourceBreakpoint:B.$0K,StandardTokenType:B.StandardTokenType,StatusBarAlignment:B.StatusBarAlignment,SymbolInformation:B.$pK,SymbolKind:B.SymbolKind,SymbolTag:B.SymbolTag,Task:B.$VK,TaskGroup:B.$RK,TaskPanelKind:B.TaskPanelKind,TaskRevealKind:B.TaskRevealKind,TaskScope:B.TaskScope,TerminalLink:B.$NK,TerminalQuickFixExecuteTerminalCommand:B.$PK,TerminalQuickFixOpener:B.$OK,TerminalLocation:B.TerminalLocation,TerminalProfile:B.$QK,TerminalExitReason:B.TerminalExitReason,TextDocumentSaveReason:B.TextDocumentSaveReason,TextEdit:B.$fK,SnippetTextEdit:B.$hK,TextEditorCursorStyle:u.TextEditorCursorStyle,TextEditorLineNumbersStyle:B.TextEditorLineNumbersStyle,TextEditorRevealType:B.TextEditorRevealType,TextEditorSelectionChangeKind:B.TextEditorSelectionChangeKind,SyntaxTokenType:B.SyntaxTokenType,TextDocumentChangeReason:B.TextDocumentChangeReason,ThemeColor:B.$6K,ThemeIcon:B.$5K,TreeItem:B.$WK,TreeItemCheckboxState:B.TreeItemCheckboxState,TreeItemCollapsibleState:B.TreeItemCollapsibleState,TypeHierarchyItem:B.$OL,UIKind:w.UIKind,Uri:R.URI,ViewColumn:B.ViewColumn,WorkspaceEdit:B.$iK,DocumentDropEdit:B.$3K,DocumentPasteEdit:B.$4K,InlayHint:B.$DK,InlayHintLabelPart:B.$CK,InlayHintKind:B.InlayHintKind,RemoteAuthorityResolverError:B.$eK,ResolvedAuthority:B.$cK,ManagedResolvedAuthority:B.$dK,SourceControlInputBoxValidationType:B.SourceControlInputBoxValidationType,ExtensionRuntime:B.ExtensionRuntime,TimelineItem:B.$DL,NotebookRange:B.$vL,NotebookCellKind:B.NotebookCellKind,NotebookCellExecutionState:B.NotebookCellExecutionState,NotebookCellData:B.$wL,NotebookData:B.$xL,NotebookRendererScript:B.$BL,NotebookCellStatusBarAlignment:B.NotebookCellStatusBarAlignment,NotebookEditorRevealType:B.NotebookEditorRevealType,NotebookCellOutput:B.$zL,NotebookCellOutputItem:B.$yL,NotebookCellStatusBarItem:B.$AL,NotebookControllerAffinity:B.NotebookControllerAffinity,NotebookControllerAffinity2:B.NotebookControllerAffinity2,NotebookEdit:B.$gK,NotebookKernelSourceAction:B.$CL,PortAttributes:B.$FL,LinkedEditingRanges:B.$EL,TestResultState:B.TestResultState,TestRunRequest:B.$GL,TestMessage:B.$HL,TestMessage2:B.$HL,TestTag:B.$IL,TestRunProfileKind:B.TestRunProfileKind,TextSearchCompleteMessageType:st.TextSearchCompleteMessageType,DataTransfer:B.$2K,DataTransferItem:B.$XK,CoveredCount:B.$JL,FileCoverage:B.$KL,StatementCoverage:B.$LL,BranchCoverage:B.$ML,FunctionCoverage:B.$NL,WorkspaceTrustState:B.WorkspaceTrustState,LanguageStatusSeverity:B.LanguageStatusSeverity,QuickPickItemKind:B.QuickPickItemKind,InputBoxValidationSeverity:B.InputBoxValidationSeverity,TabInputText:B.$PL,TabInputTextDiff:B.$QL,TabInputTextMerge:B.$RL,TabInputCustom:B.$SL,TabInputNotebook:B.$UL,TabInputNotebookDiff:B.$VL,TabInputWebview:B.$TL,TabInputTerminal:B.$WL,TabInputInteractiveWindow:B.$XL,TelemetryTrustedValue:me.$bo,LogLevel:he.LogLevel,EditSessionIdentityMatch:mt.EditSessionIdentityMatch,InteractiveSessionVoteDirection:B.InteractiveSessionVoteDirection,InteractiveSessionCopyKind:B.InteractiveSessionCopyKind,InteractiveEditorResponseFeedbackKind:B.InteractiveEditorResponseFeedbackKind,StackFrameFocus:B.$eL,ThreadFocus:B.$fL,RelatedInformationType:B.RelatedInformationType}}}e.$Ddc=Jt}),define(Ae[274],Re([1,0,71,109,33,107,34,31,60,63,111,113,114,84,86,80,108,62,39,83,58,61,242,14,112,81,82]),function(ie,e,h,C,I,O,R,u,D,d,A,k,a,w,m,f,t,s,c,v,S,p,n,r,i,o,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,h.$or)(o.$dcc,o.$ccc,1),(0,h.$or)(r.$7i,n.$Edc,1),(0,h.$or)(f.$Cbc,f.$Dbc,1),(0,h.$or)(u.$tM,u.$sM,0),(0,h.$or)(R.$Pbc,R.$Nbc,0),(0,h.$or)(s.$5bc,s.$4bc,0),(0,h.$or)(k.$Scc,k.$Wcc,0),(0,h.$or)(O.$Kcc,O.$Jcc,0),(0,h.$or)(D.$iM,D.$hM,0),(0,h.$or)(y.$ecc,y.$fcc,0),(0,h.$or)(c.$zbc,c.$ybc,0),(0,h.$or)(C.$qcc,C.$pcc,1),(0,h.$or)(a.$3cc,a.$4cc,0),(0,h.$or)(w.$1bc,w.$Zbc,0),(0,h.$or)(A.$Ncc,A.$Mcc,0),(0,h.$or)(d.$8bc,d.$$bc,0),(0,h.$or)(m.$ksb,m.$lsb,0),(0,h.$or)(t.$Gcc,t.$Fcc,0),(0,h.$or)(I.$Mbc,I.$Lbc,0),(0,h.$or)(v.$acc,v.$_bc,0),(0,h.$or)(S.$rM,S.$oM,0),(0,h.$or)(p.$Occ,p.$Pcc,0),(0,h.$or)(i.$Qcc,i.$Rcc,0)}),define(Ae[275],Re([1,0,273,35,2,270,7,12,261]),function(ie,e,h,C,I,O,R,u,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nfc=void 0;class d extends O.$Hdc{k(){}getModule(w,m){for(const f of this.b){const t=f(w);if(t){w=t;break}}if(this.a.has(w))return this.a.get(w).load(w,m,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class A extends C.$hcc{constructor(){super(...arguments),this.extensionRuntime=R.ExtensionRuntime.Webworker}async tb(){this.h.createInstance(D.$Mfc);const w=this.h.invokeFunction(h.$Ddc);this.r=this.h.createInstance(d,w,{mine:this.J,all:this.L}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.zb()}ub(w){return w.browser}async vb(w,m,f){m=m.with({path:k(m.path,".js")});const t=w?.identifier.value;t&&performance.mark(`code/extHost/willFetchExtensionCode/${t}`);const s=I.URI.revive(await this.C.$asBrowserUri(m)),c=await fetch(s.toString(!0));if(t&&performance.mark(`code/extHost/didFetchExtensionCode/${t}`),c.status!==200)throw new Error(c.statusText);const v=await c.text(),S=`${m.toString(!0)}#vscode-extension`,p=`${v}
//# sourceURL=${S}`;let n;try{n=new Function("module","exports","require",p)}catch(y){throw console.error(t?`Loading code for extension ${t} failed: ${y.message}`:`Loading code failed: ${y.message}`),console.error(`${m.toString(!0)}${typeof y.line=="number"?` line ${y.line}`:""}${typeof y.column=="number"?` column ${y.column}`:""}`),console.error(y),y}w&&await this.w.initializeLocalizedMessages(w);const r={},i={exports:r},o=y=>{const g=this.r.getModule(y,m);if(g===void 0)throw new Error(`Cannot load module '${y}'`);return g};try{return f.codeLoadingStart(),t&&performance.mark(`code/extHost/willLoadExtensionCode/${t}`),n(i,r,o),i.exports!==r?i.exports:r}finally{t&&performance.mark(`code/extHost/didLoadExtensionCode/${t}`),f.codeLoadingStop()}}async $setRemoteEnvironment(w){}async zb(w=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const m=Date.now()+w;for(;Date.now()<m&&!("__jsDebugIsReady"in globalThis);)await(0,u.$Rg)(10)}}e.$Nfc=A;function k(a,w){return a.endsWith(w)?a:a+w}}),define(Ae[276],Re([1,0,70,71,14,35,187,85,275]),function(ie,e,h,C,I,O,R,u,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,C.$or)(I.$6i,new h.$Ih(R.$Gdc,[!0],!0)),(0,C.$or)(O.$icc,D.$Nfc,0),(0,C.$or)(u.$6bc,u.$7bc,0)}),define(Ae[285],Re([1,0,25,5,79,271,263,19,87,13,2,274,276]),function(ie,e,h,C,I,O,R,u,D,d,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const k=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const a=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function w(n){return/^(file|vscode-remote):/i.test(n)}const m=fetch.bind(self);function f(n){self.fetch=async function(r,i){return r instanceof Request||w(String(r))&&(r=(await n(A.URI.parse(String(r)))).toString(!0)),m(r,i)},self.XMLHttpRequest=class extends XMLHttpRequest{open(r,i,o,y,g){(async()=>(w(i.toString())&&(i=(await n(A.URI.parse(i.toString()))).toString(!0)),super.open(r,i,o??!0,y,g)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const n=self.Worker;Worker=function(r,i){if(/^file:/i.test(r.toString()))r=d.$_f.uriToBrowserUri(A.URI.parse(r.toString())).toString(!0);else if(/^vscode-remote:/i.test(r.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const y=`(${function(l){function $(U){return typeof U=="string"||U instanceof URL?String(U).replace(/^file:\/\//i,"vscode-file://vscode-app"):U}const b=fetch.bind(self);self.fetch=function(U,F){return U instanceof Request?b(U,F):b($(U),F)},self.XMLHttpRequest=class extends XMLHttpRequest{open(U,F,q,W,L){return super.open(U,$(F),q??!0,W,L)}};const M=importScripts.bind(self);self.importScripts=(...U)=>{M(...U.map($))},M(l)}.toString()}('${r}'))`;i=i||{},i.name=i.name||u.$lc(r.toString());const g=new Blob([y],{type:"application/javascript"}),E=URL.createObjectURL(g);return new n(E,i)}}else self.Worker=class extends R.$Ofc{constructor(n,r){super(a,n,{name:u.$lc(n.toString()),...r})}};const t=new class{constructor(){this.pid=void 0}exit(n){k()}};class s{constructor(){const r=new MessageChannel,i=new C.$Ld;let o=!1;a(r.port2,[r.port2]),r.port1.onmessage=y=>{const{data:g}=y;if(!(g instanceof ArrayBuffer)){console.warn("UNKNOWN data received",g);return}const E=h.$_d.wrap(new Uint8Array(g,0,g.byteLength));if((0,I.$7l)(E,2)){o=!0,v("received terminate message from renderer");return}i.fire(E)},this.protocol={onMessage:i.event,send:y=>{if(!o){const g=y.buffer.buffer.slice(y.buffer.byteOffset,y.buffer.byteOffset+y.buffer.byteLength);r.port1.postMessage(g,[g])}}}}}function c(n){return new Promise(r=>{const i=n.onMessage(o=>{i.dispose();const y=JSON.parse(o.toString());n.send((0,I.$6l)(0)),r({protocol:n,initData:y})});n.send((0,I.$6l)(1))})}let v=n=>k();function S(n){return!!n&&typeof n=="object"&&n.type==="vscode.init"&&n.data instanceof Map}function p(){D.mark("code/extHost/willConnectToRenderer");const n=new s;return{onmessage(r){S(r)&&c(n.protocol).then(i=>{D.mark("code/extHost/didWaitForInitData");const o=new O.$Jdc(i.protocol,i.initData,t,null,r.data);f(y=>o.asBrowserUri(y)),v=y=>o.terminate(y)})}}}e.create=p})}).call(this);

//# sourceMappingURL=extensionHostWorker.js.map
